/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(B){for(var t=[],k=0,P=B.length;k<P;k++)t[k]=ie[B[k]];return t};const Ve=this,ze=typeof global=="object"?global:{};var he;(function(B){B.global=Ve;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=t})(he||(he={}));var he;(function(B){class t{constructor(c,w,d){this.type=c,this.detail=w,this.timestamp=d}}B.LoaderEvent=t;class k{constructor(c){this._events=[new t(1,"",c)]}record(c,w){this._events.push(new t(c,w,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=k;class P{record(c,w){}getEvents(){return[]}}P.INSTANCE=new P,B.NullLoaderEventRecorder=P})(he||(he={}));var he;(function(B){class t{static fileUriToFilePath(P,r){if(r=decodeURI(r).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(P,r){return P.length>=r.length&&P.substr(0,r.length)===r}static endsWith(P,r){return P.length>=r.length&&P.substr(P.length-r.length)===r}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,r){if(P){let c;for(c in P)P.hasOwnProperty(c)&&r(c,P[c])}}static isEmpty(P){let r=!0;return t.forEachProperty(P,()=>{r=!1}),r}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let r=Array.isArray(P)?[]:{};return t.forEachProperty(P,(c,w)=>{w&&typeof w=="object"?r[c]=t.recursiveClone(w):r[c]=w}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,B.Utilities=t})(he||(he={}));var he;(function(B){function t(r){if(r instanceof Error)return r;const c=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(c.stack=r.stack),c}B.ensureError=t;class k{static validateConfigurationOptions(c){function w(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=w),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(B.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",c.onError(d),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,w=null){let d=B.Utilities.recursiveClone(w||{});return B.Utilities.forEachProperty(c,(l,s)=>{l==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(s):l==="paths"&&typeof d.paths<"u"?B.Utilities.forEachProperty(s,(g,N)=>d.paths[g]=N):l==="config"&&typeof d.config<"u"?B.Utilities.forEachProperty(s,(g,N)=>d.config[g]=N):d[l]=B.Utilities.recursiveClone(s)}),k.validateConfigurationOptions(d)}}B.ConfigurationOptionsUtil=k;class P{constructor(c,w){if(this._env=c,this.options=k.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,l=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(c,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:c,to:w}):this.sortedPathsRules.push({from:c,to:[w]})}),this.sortedPathsRules.sort((c,w)=>w.from.length-c.from.length)}cloneAndMerge(c){return new P(this._env,k.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let w;for(let d=0,l=this.sortedPathsRules.length;d<l;d++)if(w=this.sortedPathsRules[d],B.Utilities.startsWith(c,w.from)){let s=[];for(let g=0,N=w.to.length;g<N;g++)s.push(w.to[g]+c.substr(w.from.length));return s}return[c]}_addUrlArgsToUrl(c){return B.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let w=0,d=c.length;w<d;w++)c[w]=this._addUrlArgsToUrl(c[w]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let w=c,d;if(!B.Utilities.endsWith(w,".js")&&!B.Utilities.isAbsolutePath(w)){d=this._applyPaths(w);for(let l=0,s=d.length;l<s;l++)this.isBuild()&&d[l]==="empty:"||(B.Utilities.isAbsolutePath(d[l])||(d[l]=this.options.baseUrl+d[l]),!B.Utilities.endsWith(d[l],".js")&&!B.Utilities.containsQueryString(d[l])&&(d[l]=d[l]+".js"))}else!B.Utilities.endsWith(w,".js")&&!B.Utilities.containsQueryString(w)&&(w=w+".js"),d=[w];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(c){let w=c;return B.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],B.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}B.Configuration=P})(he||(he={}));var he;(function(B){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,g,N,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new k:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new k;let b={callback:N,errorback:m};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(b);return}this._callbackMap[g]=[b],this._scriptLoader.load(s,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(s){let g=this._callbackMap[s];delete this._callbackMap[s];for(let N=0;N<g.length;N++)g[N].callback()}triggerErrorback(s,g){let N=this._callbackMap[s];delete this._callbackMap[s];for(let m=0;m<N.length;m++)N[m].errorback(g)}}class k{attachListeners(s,g,N){let m=()=>{s.removeEventListener("load",b),s.removeEventListener("error",e)},b=v=>{m(),g()},e=v=>{m(),N(v)};s.addEventListener("load",b),s.addEventListener("error",e)}load(s,g,N,m){if(/^node\|/.test(g)){let b=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),b.nodeRequire||B.global.nodeRequire),v=g.split("|"),A=null;try{A=e(v[1])}catch(E){m(E);return}s.enqueueDefineAnonymousModule([],()=>A),N()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,N,m);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),b.setAttribute("src",g);const{cspNonce:v}=s.getConfig().getOptionsLiteral();v&&b.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild(b)}}}function P(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(s)),this._cachedCanUseEval}load(s,g,N,m){if(/^node\|/.test(g)){const b=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),b.nodeRequire||B.global.nodeRequire),v=g.split("|");let A=null;try{A=e(v[1])}catch(E){m(E);return}s.enqueueDefineAnonymousModule([],function(){return A}),N()}else{const{trustedTypesPolicy:b}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(g).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${g}`,(b?self.eval(b.createScript("",v)):new Function(v)).call(self),N()}).then(void 0,m);return}try{b&&(g=b.createScriptURL(g)),importScripts(g),N()}catch(v){m(v)}}}}class c{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,g){const{nodeCachedData:N}=g.getConfig().getOptionsLiteral();if(!N||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,b=s("module");function e(v){const A=v.constructor;let E=function(o){try{return v.require(o)}finally{}};return E.resolve=function(o,f){return A._resolveFilename(o,v,!1,f)},E.resolve.paths=function(o){return A._resolveLookupPaths(o,v)},E.main=process.mainModule,E.extensions=A._extensions,E.cache=A._cache,E}b.prototype._compile=function(v,A){const E=b.wrap(v.replace(/^#!.*/,"")),h=g.getRecorder(),o=m._getCachedDataPath(N,A),f={filename:A};let a;try{const R=m._fs.readFileSync(o);a=R.slice(0,16),f.cachedData=R.slice(16),h.record(60,o)}catch{h.record(61,o)}const i=new m._vm.Script(E,f),u=i.runInThisContext(f),p=m._path.dirname(A),_=e(this),L=[this.exports,_,this,A,p,process,ze,Buffer],M=u.apply(this.exports,L);return m._handleCachedData(i,E,o,!f.cachedData,g),m._verifyCachedData(i,E,o,a,g),M}}load(s,g,N,m){const b=s.getConfig().getOptionsLiteral(),e=w(s.getRecorder(),b.nodeRequire||B.global.nodeRequire),v=b.nodeInstrumenter||function(E){return E};this._init(e),this._initNodeRequire(e,s);let A=s.getRecorder();if(/^node\|/.test(g)){let E=g.split("|"),h=null;try{h=e(E[1])}catch(o){m(o);return}s.enqueueDefineAnonymousModule([],()=>h),N()}else{g=B.Utilities.fileUriToFilePath(this._env.isWindows,g);const E=this._path.normalize(g),h=this._getElectronRendererScriptPathOrUri(E),o=!!b.nodeCachedData,f=o?this._getCachedDataPath(b.nodeCachedData,g):void 0;this._readSourceAndCachedData(E,f,A,(a,i,u,p)=>{if(a){m(a);return}let _;i.charCodeAt(0)===c._BOM?_=c._PREFIX+i.substring(1)+c._SUFFIX:_=c._PREFIX+i+c._SUFFIX,_=v(_,E);const L={filename:h,cachedData:u},M=this._createAndEvalScript(s,_,L,N,m);this._handleCachedData(M,_,f,o&&!u,s),this._verifyCachedData(M,_,f,p,s)})}}_createAndEvalScript(s,g,N,m,b){const e=s.getRecorder();e.record(31,N.filename);const v=new this._vm.Script(g,N),A=v.runInThisContext(N),E=s.getGlobalAMDDefineFunc();let h=!1;const o=function(){return h=!0,E.apply(null,arguments)};return o.amd=E.amd,A.call(B.global,s.getGlobalAMDRequireFunc(),o,N.filename,this._path.dirname(N.filename)),e.record(32,N.filename),h?m():b(new Error(`Didn't receive define call in ${N.filename}!`)),v}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let g=s.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,g){const N=this._crypto.createHash("md5").update(g,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(g).replace(/\.js$/,"");return this._path.join(s.path,`${m}-${N}.code`)}_handleCachedData(s,g,N,m,b){s.cachedDataRejected?this._fs.unlink(N,e=>{b.getRecorder().record(62,N),this._createAndWriteCachedData(s,g,N,b),e&&b.getConfig().onError(e)}):m&&this._createAndWriteCachedData(s,g,N,b)}_createAndWriteCachedData(s,g,N,m){let b=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,v=0,A;const E=()=>{setTimeout(()=>{A||(A=this._crypto.createHash("md5").update(g,"utf8").digest());const h=s.createCachedData();if(!(h.length===0||h.length===e||v>=5)){if(h.length<e){E();return}e=h.length,this._fs.writeFile(N,Buffer.concat([A,h]),o=>{o&&m.getConfig().onError(o),m.getRecorder().record(63,N),E()})}},b*Math.pow(4,v++))};E()}_readSourceAndCachedData(s,g,N,m){if(!g)this._fs.readFile(s,{encoding:"utf8"},m);else{let b,e,v,A=2;const E=h=>{h?m(h):--A===0&&m(void 0,b,e,v)};this._fs.readFile(s,{encoding:"utf8"},(h,o)=>{b=o,E(h)}),this._fs.readFile(g,(h,o)=>{!h&&o&&o.length>0?(v=o.slice(0,16),e=o.slice(16),N.record(60,g)):N.record(61,g),E()})}}_verifyCachedData(s,g,N,m,b){m&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();m.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${N}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(N,v=>{v&&b.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function w(l,s){if(s.__$__isRecorded)return s;const g=function(m){l.record(33,m);try{return s(m)}finally{l.record(34,m)}};return g.__$__isRecorded=!0,g}B.ensureRecordedNodeRequire=w;function d(l){return new t(l)}B.createScriptLoader=d})(he||(he={}));var he;(function(B){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,g;for(g=/\/\.\//;g.test(s);)s=s.replace(g,"/");for(s=s.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(s);)s=s.replace(g,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return B.Utilities.isAbsolutePath(s)||(B.Utilities.startsWith(s,"./")||B.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),B.ModuleIdResolver=t;class k{constructor(l,s,g,N,m,b){this.id=l,this.strId=s,this.dependencies=g,this._callback=N,this._errorback=m,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(B.global,s),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,s,g,N){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(g,N):{returnedValue:g.apply(B.global,N),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,g,N){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let b=k._invokeFactory(s,this.strId,this._callback,g);m=b.producedError,l.record(22,this.strId),!m&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(m){let b=B.ensureError(m);b.phase="factory",b.moduleId=this.strId,b.neededBy=N(this.id),this.error=b,s.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}B.Module=k;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),B.RegularDependency=r;class c{constructor(l,s,g){this.id=l,this.pluginId=s,this.pluginParam=g}}B.PluginDependency=c;class w{constructor(l,s,g,N,m=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=m,this._defineFunc=g,this._requireFunc=N,this._moduleIdProvider=new P,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let g=b=>b.replace(/\\/g,"/"),N=g(l),m=s.split(/\n/);for(let b=0;b<m.length;b++){let e=m[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let v=e[1],A=e[2],E=e[3],h=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr(h),v=g(v),v===N){let o={line:parseInt(A,10),col:parseInt(E,10)};return o.line===1&&(o.col-=53),o}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let g=0,N=this._modules2.length;g<N;g++){let m=this._modules2[g];if(!m)continue;let b=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,v=this._buildInfoDependencies[m.id];l[s++]={id:m.strId,path:b,defineLocation:b&&e?w._findRelevantLocationInStack(b,e):null,dependencies:v,shim:null,exports:m.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:s}}defineModule(l,s,g,N,m,b=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let v=new k(e,l,this._normalizeDependencies(s,b),g,N,b);this._modules2[e]=v,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(v.dependencies||[]).map(A=>this._moduleIdProvider.getStrModuleId(A.id))),this._resolve(v)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let g=l.indexOf("!");if(g>=0){let N=s.resolveModule(l.substr(0,g)),m=s.resolveModule(l.substr(g+1)),b=this._moduleIdProvider.getModuleId(N+"!"+m),e=this._moduleIdProvider.getModuleId(N);return new c(b,e,m)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let g=[],N=0;for(let m=0,b=l.length;m<b;m++)g[N++]=this._normalizeDependency(l[m],s);return g}_relativeRequire(l,s,g,N){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(B.Utilities.generateAnonymousModule(),s,g,N,null,l)}synchronousRequire(l,s=new t(l)){let g=this._normalizeDependency(l,s),N=this._modules2[g.id];if(!N)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!N.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(N.error)throw N.error;return N.exports}configure(l,s){let g=this._config.shouldRecordStats();s?this._config=new B.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let g=this._moduleIdProvider.getStrModuleId(l),N=(this._inverseDependencies2[l]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const m=B.ensureError(s);return m.phase="loading",m.moduleId=g,m.neededBy=N,m}_onLoadError(l,s){const g=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new k(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let N=[];for(let e=0,v=this._moduleIdProvider.getMaxModuleId();e<v;e++)N[e]=!1;let m=!1,b=[];for(b.push(l),N[l]=!0;b.length>0;){let e=b.shift(),v=this._modules2[e];v&&(m=v.onDependencyError(g)||m);let A=this._inverseDependencies2[e];if(A)for(let E=0,h=A.length;E<h;E++){let o=A[E];N[o]||(b.push(o),N[o]=!0)}}m||this._config.onError(g)}_hasDependencyPath(l,s){let g=this._modules2[l];if(!g)return!1;let N=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)N[b]=!1;let m=[];for(m.push(g),N[l]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let v=0,A=e.length;v<A;v++){let E=e[v];if(E.id===s)return!0;let h=this._modules2[E.id];h&&!N[E.id]&&(N[E.id]=!0,m.push(h))}}return!1}_findCyclePath(l,s,g){if(l===s||g===50)return[l];let N=this._modules2[l];if(!N)return null;let m=N.dependencies;if(m)for(let b=0,e=m.length;b<e;b++){let v=this._findCyclePath(m[b].id,s,g+1);if(v!==null)return v.push(l),v}return null}_createRequire(l){let s=(g,N,m)=>this._relativeRequire(l,g,N,m);return s.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(g,N=!1)=>{this.configure(g,N)},s.__$__nodeRequire=B.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(s),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||N.test(s))&&g.push("node|"+s);let m=-1,b=e=>{if(m++,m>=g.length)this._onLoadError(l,e);else{let v=g[m],A=this.getRecorder();if(this._config.isBuild()&&v==="empty:"){this._buildInfoPath[l]=v,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}A.record(10,v),this._scriptLoader.load(this,v,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=v),A.record(11,v),this._onLoad(l)},E=>{A.record(12,v),b(E)})}};b(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let g=N=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],N,null,null)};g.error=N=>{this._config.onError(this._createLoadError(s.id,N))},l.load(s.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let g=0,N=s.length;g<N;g++){let m=s[g];if(m===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(m===r.MODULE){l.unresolvedDependenciesCount--;continue}if(m===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let b=this._modules2[m.id];if(b&&b.isComplete()){if(b.error){l.onDependencyError(b.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,l.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(v=>this._moduleIdProvider.getStrModuleId(v)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(l.id),m instanceof c){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let v=this._inversePluginDependencies2.get(m.pluginId);v||(v=[],this._inversePluginDependencies2.set(m.pluginId,v)),v.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,N=[];if(g)for(let v=0,A=g.length;v<A;v++){let E=g[v];if(E===r.EXPORTS){N[v]=l.exports;continue}if(E===r.MODULE){N[v]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(E===r.REQUIRE){N[v]=this._createRequire(l.moduleIdResolver);continue}let h=this._modules2[E.id];if(h){N[v]=h.exports;continue}N[v]=null}const m=v=>(this._inverseDependencies2[v]||[]).map(A=>this._moduleIdProvider.getStrModuleId(A));l.complete(s,this._config,N,m);let b=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,b)for(let v=0,A=b.length;v<A;v++){let E=b[v],h=this._modules2[E];h.unresolvedDependenciesCount--,h.unresolvedDependenciesCount===0&&this._onModuleComplete(h)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let v=0,A=e.length;v<A;v++)this._loadPluginDependency(l.exports,e[v])}}}B.ModuleManager=w})(he||(he={}));var te,he;(function(B){const t=new B.Environment;let k=null;const P=function(d,l,s){typeof d!="string"&&(s=l,l=d,d=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),d?k.defineModule(d,l,s,null,null):k.enqueueDefineAnonymousModule(l,s)};P.amd={jQuery:!0};const r=function(d,l=!1){k.configure(d,l)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return k.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){k.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=r,c.getConfig=function(){return k.getConfig().getOptionsLiteral()},c.reset=function(){k=k.reset()},c.getBuildInfo=function(){return k.getBuildInfo()},c.getStats=function(){return k.getLoaderEvents()},c.define=P;function w(){if(typeof B.global.require<"u"||typeof require<"u"){const d=B.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const l=B.ensureRecordedNodeRequire(k.getRecorder(),d);B.global.nodeRequire=l,c.nodeRequire=l,c.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(B.global.define=P),B.global.require=c)}B.init=w,(typeof B.global.define!="function"||!B.global.define.amd)&&(k=new B.ModuleManager(t,B.createScriptLoader(t),P,c,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&c.config(B.global.require),te=function(){return P.apply(null,arguments)},te.amd=P.amd,typeof doNotInitLoader>"u"&&w())})(he||(he={})),te(ie[69],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function k(d,l,s,g){if(g=g||{},(g["vs/css"]||{}).disabled){s({});return}const m=l.toUrl(d+".css");P(d,m,()=>{s({})},b=>{typeof s.error=="function"&&s.error("Could not find "+m+".")})}t.load=k;function P(d,l,s,g){if(r(d,l)){s();return}c(d,l,s,g)}function r(d,l){const s=document.getElementsByTagName("link");for(let g=0,N=s.length;g<N;g++){const m=s[g].getAttribute("data-name"),b=s[g].getAttribute("href");if(m===d||b===l)return!0}return!1}function c(d,l,s,g){const N=document.createElement("link");N.setAttribute("rel","stylesheet"),N.setAttribute("type","text/css"),N.setAttribute("data-name",d),w(d,N,s,g),N.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(N)}function w(d,l,s,g){const N=()=>{l.removeEventListener("load",m),l.removeEventListener("error",b)},m=e=>{N(),s()},b=e=>{N(),g(e)};l.addEventListener("load",m),l.addEventListener("error",b)}}),te("vs/nls",["require","exports"],function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let k=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function r(e,v){let A;return v.length===0?A=e:A=e.replace(/\{(\d+)\}/g,(E,h)=>{const o=h[0],f=v[o];let a=E;return typeof f=="string"?a=f:(typeof f=="number"||typeof f=="boolean"||f===void 0||f===null)&&(a=String(f)),a}),k&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function c(e,v){let A=e[v];return A||(A=e["*"],A)?A:null}function w(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function d(e,v,A){const E=w(e)+w(v)+"vscode/"+w(A),h=await fetch(E);if(h.ok)return await h.json();throw new Error(`${h.status} - ${h.statusText}`)}function l(e){return function(v,A){const E=Array.prototype.slice.call(arguments,2);return r(e[v],E)}}function s(e,v,...A){return r(v,A)}t.localize=s;function g(e){}t.getConfiguredDefaultLocale=g;function N(e){k=e}t.setPseudoTranslation=N;function m(e,v){return{localize:l(v[e]),getConfiguredDefaultLocale:v.getConfiguredDefaultLocale??(A=>{})}}t.create=m;function b(e,v,A,E){const h=E["vs/nls"]??{};if(!e||e.length===0)return A({localize:s,getConfiguredDefaultLocale:()=>h.availableLanguages?.["*"]});const o=h.availableLanguages?c(h.availableLanguages,e):null,f=o===null||o===P;let a=".nls";f||(a=a+"."+o);const i=u=>{Array.isArray(u)?u.localize=l(u):u.localize=l(u[e]),u.getConfiguredDefaultLocale=()=>h.availableLanguages?.["*"],A(u)};typeof h.loadBundle=="function"?h.loadBundle(e,o,(u,p)=>{u?v([e+".nls"],i):i(p)}):h.translationServiceUrl&&!f?(async()=>{try{const u=await d(h.translationServiceUrl,o,e);return i(u)}catch(u){if(!o.includes("-"))return console.error(u),v([e+".nls"],i);try{const p=o.split("-")[0],_=await d(h.translationServiceUrl,p,e);return h.availableLanguages??={},h.availableLanguages["*"]=p,i(_)}catch(p){return console.error(p),v([e+".nls"],i)}}})():v([e+a],i,u=>{if(a===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${o}. Falling back to the default language:`,u),v([e+".nls"],i)})}t.load=b}),function(){const B=globalThis.MonacoEnvironment,t=B&&B.baseUrl?B.baseUrl:"../../../";function k(g,N){if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(g,N)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(g,N)}catch(m){console.warn(m);return}}const P=k("amdLoader",{createScriptURL:g=>g,createScript:(g,...N)=>{const m=N.slice(0,-1).join(","),b=N.pop().toString();return`(function anonymous(${m}) { ${b}
})`}});function r(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((g,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const m=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,N);return}P?importScripts(P.createScriptURL(m)):importScripts(m),g()})}function w(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function d(g){c().then(()=>{w(),require([g],function(N){setTimeout(function(){const m=N.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>m.onmessage(b.data,b.ports);s.length>0;){const b=s.shift();m.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let l=!0;const s=[];globalThis.onmessage=g=>{if(!l){s.push(g);return}l=!1,d(g.data)}}(),te(ie[9],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFindFirst=t.findMaxIdxBy=t.findFirstMinBy=t.findLastMaxBy=t.findFirstMaxBy=t.MonotonousArray=t.findFirstIdxMonotonous=t.findFirstIdxMonotonousOrArrLen=t.findFirstMonotonous=t.findLastIdxMonotonous=t.findLastMonotonous=t.findLastIdx=t.findLast=void 0;function k(v,A,E){const h=P(v,A);if(h!==-1)return v[h]}t.findLast=k;function P(v,A,E=v.length-1){for(let h=E;h>=0;h--){const o=v[h];if(A(o))return h}return-1}t.findLastIdx=P;function r(v,A){const E=c(v,A);return E===-1?void 0:v[E]}t.findLastMonotonous=r;function c(v,A,E=0,h=v.length){let o=E,f=h;for(;o<f;){const a=Math.floor((o+f)/2);A(v[a])?o=a+1:f=a}return o-1}t.findLastIdxMonotonous=c;function w(v,A){const E=d(v,A);return E===v.length?void 0:v[E]}t.findFirstMonotonous=w;function d(v,A,E=0,h=v.length){let o=E,f=h;for(;o<f;){const a=Math.floor((o+f)/2);A(v[a])?f=a:o=a+1}return o}t.findFirstIdxMonotonousOrArrLen=d;function l(v,A,E=0,h=v.length){const o=d(v,A,E,h);return o===v.length?-1:o}t.findFirstIdxMonotonous=l;class s{static{this.assertInvariants=!1}constructor(A){this._array=A,this._findLastMonotonousLastIdx=0}findLastMonotonous(A){if(s.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!A(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=A}const E=c(this._array,A,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=E+1,E===-1?void 0:this._array[E]}}t.MonotonousArray=s;function g(v,A){if(v.length===0)return;let E=v[0];for(let h=1;h<v.length;h++){const o=v[h];A(o,E)>0&&(E=o)}return E}t.findFirstMaxBy=g;function N(v,A){if(v.length===0)return;let E=v[0];for(let h=1;h<v.length;h++){const o=v[h];A(o,E)>=0&&(E=o)}return E}t.findLastMaxBy=N;function m(v,A){return g(v,(E,h)=>-A(E,h))}t.findFirstMinBy=m;function b(v,A){if(v.length===0)return-1;let E=0;for(let h=1;h<v.length;h++){const o=v[h];A(o,v[E])>0&&(E=h)}return E}t.findMaxIdxBy=b;function e(v,A){for(const E of v){const h=A(E);if(h!==void 0)return h}}t.mapFindFirst=e}),te(ie[34],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.intersection=t.diffMaps=t.diffSets=t.groupBy=void 0;function k(w,d){const l=Object.create(null);for(const s of w){const g=d(s);let N=l[g];N||(N=l[g]=[]),N.push(s)}return l}t.groupBy=k;function P(w,d){const l=[],s=[];for(const g of w)d.has(g)||l.push(g);for(const g of d)w.has(g)||s.push(g);return{removed:l,added:s}}t.diffSets=P;function r(w,d){const l=[],s=[];for(const[g,N]of w)d.has(g)||l.push(N);for(const[g,N]of d)w.has(g)||s.push(N);return{removed:l,added:s}}t.diffMaps=r;function c(w,d){const l=new Set;for(const s of d)w.has(s)&&l.add(s);return l}t.intersection=c}),te(ie[35],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function k(d,l){const s=Math.pow(10,l);return Math.round(d*s)/s}class P{constructor(l,s,g,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=k(Math.max(Math.min(1,N),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.RGBA=P;class r{constructor(l,s,g,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.l=k(Math.max(Math.min(1,g),0),3),this.a=k(Math.max(Math.min(1,N),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,N=l.b/255,m=l.a,b=Math.max(s,g,N),e=Math.min(s,g,N);let v=0,A=0;const E=(e+b)/2,h=b-e;if(h>0){switch(A=Math.min(E<=.5?h/(2*E):h/(2-2*E),1),b){case s:v=(g-N)/h+(g<N?6:0);break;case g:v=(N-s)/h+2;break;case N:v=(s-g)/h+4;break}v*=60,v=Math.round(v)}return new r(v,A,E,m)}static _hue2rgb(l,s,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(s-l)*6*g:g<1/2?s:g<2/3?l+(s-l)*(2/3-g)*6:l}static toRGBA(l){const s=l.h/360,{s:g,l:N,a:m}=l;let b,e,v;if(g===0)b=e=v=N;else{const A=N<.5?N*(1+g):N+g-N*g,E=2*N-A;b=r._hue2rgb(E,A,s+1/3),e=r._hue2rgb(E,A,s),v=r._hue2rgb(E,A,s-1/3)}return new P(Math.round(b*255),Math.round(e*255),Math.round(v*255),m)}}t.HSLA=r;class c{constructor(l,s,g,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.v=k(Math.max(Math.min(1,g),0),3),this.a=k(Math.max(Math.min(1,N),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,N=l.b/255,m=Math.max(s,g,N),b=Math.min(s,g,N),e=m-b,v=m===0?0:e/m;let A;return e===0?A=0:m===s?A=((g-N)/e%6+6)%6:m===g?A=(N-s)/e+2:A=(s-g)/e+4,new c(Math.round(A*60),v,m,l.a)}static toRGBA(l){const{h:s,s:g,v:N,a:m}=l,b=N*g,e=b*(1-Math.abs(s/60%2-1)),v=N-b;let[A,E,h]=[0,0,0];return s<60?(A=b,E=e):s<120?(A=e,E=b):s<180?(E=b,h=e):s<240?(E=e,h=b):s<300?(A=e,h=b):s<=360&&(A=b,h=e),A=Math.round((A+v)*255),E=Math.round((E+v)*255),h=Math.round((h+v)*255),new P(A,E,h,m)}}t.HSVA=c;class w{static fromHex(l){return w.Format.CSS.parseHex(l)||w.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:c.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof P)this.rgba=l;else if(l instanceof r)this._hsla=l,this.rgba=r.toRGBA(l);else if(l instanceof c)this._hsva=l,this.rgba=c.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&P.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&c.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=w._relativeLuminanceForComponent(this.rgba.r),s=w._relativeLuminanceForComponent(this.rgba.g),g=w._relativeLuminanceForComponent(this.rgba.b),N=.2126*l+.7152*s+.0722*g;return k(N,4)}static _relativeLuminanceForComponent(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g?(s+.05)/(g+.05):(g+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g}isDarkerThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s<g}lighten(l){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g,b:N,a:m}=this.rgba;return new w(new P(s,g,N,m*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,g=this.rgba.a,N=s.a,m=g+N*(1-g);if(m<1e-6)return w.transparent;const b=this.rgba.r*g/m+s.r*N*(1-g)/m,e=this.rgba.g*g/m+s.g*N*(1-g)/m,v=this.rgba.b*g/m+s.b*N*(1-g)/m;return new w(new P(b,e,v,m))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g,b:N,a:m}=this.rgba;return new w(new P(l.rgba.r-m*(l.rgba.r-s),l.rgba.g-m*(l.rgba.g-g),l.rgba.b-m*(l.rgba.b-N),1))}flatten(...l){const s=l.reduceRight((g,N)=>w._flatten(N,g));return w._flatten(this,s)}static _flatten(l,s){const g=1-l.rgba.a;return new w(new P(g*s.rgba.r+l.rgba.a*l.rgba.r,g*s.rgba.g+l.rgba.a*l.rgba.g,g*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(l,s,g){if(l.isLighterThan(s))return l;g=g||.5;const N=l.getRelativeLuminance(),m=s.getRelativeLuminance();return g=g*(m-N)/m,l.lighten(g)}static getDarkerColor(l,s,g){if(l.isDarkerThan(s))return l;g=g||.5;const N=l.getRelativeLuminance(),m=s.getRelativeLuminance();return g=g*(N-m)/N,l.darken(g)}static{this.white=new w(new P(255,255,255,1))}static{this.black=new w(new P(0,0,0,1))}static{this.red=new w(new P(255,0,0,1))}static{this.blue=new w(new P(0,0,255,1))}static{this.green=new w(new P(0,255,0,1))}static{this.cyan=new w(new P(0,255,255,1))}static{this.lightgrey=new w(new P(211,211,211,1))}static{this.transparent=new w(new P(0,0,0,0))}}t.Color=w,function(d){let l;(function(s){let g;(function(N){function m(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:d.Format.CSS.formatRGBA(i)}N.formatRGB=m;function b(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}N.formatRGBA=b;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(i)}N.formatHSL=e;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}N.formatHSLA=v;function A(i){const u=i.toString(16);return u.length!==2?"0"+u:u}function E(i){return`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}`}N.formatHex=E;function h(i,u=!1){return u&&i.rgba.a===1?d.Format.CSS.formatHex(i):`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}${A(Math.round(i.rgba.a*255))}`}N.formatHexA=h;function o(i){return i.isOpaque()?d.Format.CSS.formatHex(i):d.Format.CSS.formatRGBA(i)}N.format=o;function f(i){const u=i.length;if(u===0||i.charCodeAt(0)!==35)return null;if(u===7){const p=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),_=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),L=16*a(i.charCodeAt(5))+a(i.charCodeAt(6));return new d(new P(p,_,L,1))}if(u===9){const p=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),_=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),L=16*a(i.charCodeAt(5))+a(i.charCodeAt(6)),M=16*a(i.charCodeAt(7))+a(i.charCodeAt(8));return new d(new P(p,_,L,M/255))}if(u===4){const p=a(i.charCodeAt(1)),_=a(i.charCodeAt(2)),L=a(i.charCodeAt(3));return new d(new P(16*p+p,16*_+_,16*L+L))}if(u===5){const p=a(i.charCodeAt(1)),_=a(i.charCodeAt(2)),L=a(i.charCodeAt(3)),M=a(i.charCodeAt(4));return new d(new P(16*p+p,16*_+_,16*L+L,(16*M+M)/255))}return null}N.parseHex=f;function a(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=s.CSS||(s.CSS={}))})(l=d.Format||(d.Format={}))}(w||(t.Color=w={}))}),te(ie[36],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class k{constructor(r,c,w,d){this.originalStart=r,this.originalLength=c,this.modifiedStart=w,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=k}),te(ie[3],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.ReadonlyError=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?o.isErrorNoTelemetry(i)?new o(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(u=>{u(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}t.ErrorHandler=k,t.errorHandler=new k;function P(a){t.errorHandler.setUnexpectedErrorHandler(a)}t.setUnexpectedErrorHandler=P;function r(a){if(!a||typeof a!="object")return!1;const i=a;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=r;function c(a){s(a)||t.errorHandler.onUnexpectedError(a)}t.onUnexpectedError=c;function w(a){s(a)||t.errorHandler.onUnexpectedExternalError(a)}t.onUnexpectedExternalError=w;function d(a){if(a instanceof Error){const{name:i,message:u}=a,p=a.stacktrace||a.stack;return{$isError:!0,name:i,message:u,stack:p,noTelemetry:o.isErrorNoTelemetry(a)}}return a}t.transformErrorForSerialization=d;const l="Canceled";function s(a){return a instanceof g?!0:a instanceof Error&&a.name===l&&a.message===l}t.isCancellationError=s;class g extends Error{constructor(){super(l),this.name=this.message}}t.CancellationError=g;function N(){const a=new Error(l);return a.name=a.message,a}t.canceled=N;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}t.illegalArgument=m;function b(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}t.illegalState=b;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}t.getErrorMessage=v;class A extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.NotImplementedError=A;class E extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.NotSupportedError=E;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=h;class o extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof o)return i;const u=new o;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.ErrorNoTelemetry=o;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}t.BugIndicatingError=f}),te(ie[6],re([0,1,3,9]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.reverseOrder=t.booleanComparator=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.forEachWithNeighbors=t.forEachAdjacent=t.groupAdjacentBy=t.groupBy=t.quickSelect=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function r(x,V=0){return x[x.length-(1+V)]}t.tail=r;function c(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}t.tail2=c;function w(x,V,W=(X,ee)=>X===ee){if(x===V)return!0;if(!x||!V||x.length!==V.length)return!1;for(let X=0,ee=x.length;X<ee;X++)if(!W(x[X],V[X]))return!1;return!0}t.equals=w;function d(x,V){const W=x.length-1;V<W&&(x[V]=x[W]),x.pop()}t.removeFastWithoutKeepingOrder=d;function l(x,V,W){return s(x.length,X=>W(x[X],V))}t.binarySearch=l;function s(x,V){let W=0,X=x-1;for(;W<=X;){const ee=(W+X)/2|0,Q=V(ee);if(Q<0)W=ee+1;else if(Q>0)X=ee-1;else return ee}return-(W+1)}t.binarySearch2=s;function g(x,V,W){if(x=x|0,x>=V.length)throw new TypeError("invalid index");const X=V[Math.floor(V.length*Math.random())],ee=[],Q=[],G=[];for(const Z of V){const K=W(Z,X);K<0?ee.push(Z):K>0?Q.push(Z):G.push(Z)}return x<ee.length?g(x,ee,W):x<ee.length+G.length?G[0]:g(x-(ee.length+G.length),Q,W)}t.quickSelect=g;function N(x,V){const W=[];let X;for(const ee of x.slice(0).sort(V))!X||V(X[0],ee)!==0?(X=[ee],W.push(X)):X.push(ee);return W}t.groupBy=N;function*m(x,V){let W,X;for(const ee of x)X!==void 0&&V(X,ee)?W.push(ee):(W&&(yield W),W=[ee]),X=ee;W&&(yield W)}t.groupAdjacentBy=m;function b(x,V){for(let W=0;W<=x.length;W++)V(W===0?void 0:x[W-1],W===x.length?void 0:x[W])}t.forEachAdjacent=b;function e(x,V){for(let W=0;W<x.length;W++)V(W===0?void 0:x[W-1],x[W],W+1===x.length?void 0:x[W+1])}t.forEachWithNeighbors=e;function v(x,V,W){const X=[];function ee(Z,K,se){if(K===0&&se.length===0)return;const le=X[X.length-1];le&&le.start+le.deleteCount===Z?(le.deleteCount+=K,le.toInsert.push(...se)):X.push({start:Z,deleteCount:K,toInsert:se})}let Q=0,G=0;for(;;){if(Q===x.length){ee(Q,0,V.slice(G));break}if(G===V.length){ee(Q,x.length-Q,[]);break}const Z=x[Q],K=V[G],se=W(Z,K);se===0?(Q+=1,G+=1):se<0?(ee(Q,1,[]),Q+=1):se>0&&(ee(Q,0,[K]),G+=1)}return X}t.sortedDiff=v;function A(x,V,W){const X=v(x,V,W),ee=[],Q=[];for(const G of X)ee.push(...x.slice(G.start,G.start+G.deleteCount)),Q.push(...G.toInsert);return{removed:ee,added:Q}}t.delta=A;function E(x,V,W){if(W===0)return[];const X=x.slice(0,W).sort(V);return o(x,V,X,W,x.length),X}t.top=E;function h(x,V,W,X,ee){return W===0?Promise.resolve([]):new Promise((Q,G)=>{(async()=>{const Z=x.length,K=x.slice(0,W).sort(V);for(let se=W,le=Math.min(W+X,Z);se<Z;se=le,le=Math.min(le+X,Z)){if(se>W&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new k.CancellationError;o(x,V,K,se,le)}return K})().then(Q,G)})}t.topAsync=h;function o(x,V,W,X,ee){for(const Q=W.length;X<ee;X++){const G=x[X];if(V(G,W[Q-1])<0){W.pop();const Z=(0,P.findFirstIdxMonotonousOrArrLen)(W,K=>V(G,K)<0);W.splice(Z,0,G)}}}function f(x){return x.filter(V=>!!V)}t.coalesce=f;function a(x){let V=0;for(let W=0;W<x.length;W++)x[W]&&(x[V]=x[W],V+=1);x.length=V}t.coalesceInPlace=a;function i(x,V,W){x.splice(W,0,x.splice(V,1)[0])}t.move=i;function u(x){return!Array.isArray(x)||x.length===0}t.isFalsyOrEmpty=u;function p(x){return Array.isArray(x)&&x.length>0}t.isNonEmptyArray=p;function _(x,V=W=>W){const W=new Set;return x.filter(X=>{const ee=V(X);return W.has(ee)?!1:(W.add(ee),!0)})}t.distinct=_;function L(x){const V=new Set;return W=>{const X=x(W);return V.has(X)?!1:(V.add(X),!0)}}t.uniqueFilter=L;function M(x,V){return x.length>0?x[0]:V}t.firstOrDefault=M;function R(x,V){return x.length>0?x[x.length-1]:V}t.lastOrDefault=R;function D(x,V,W=(X,ee)=>X===ee){let X=0;for(let ee=0,Q=Math.min(x.length,V.length);ee<Q&&W(x[ee],V[ee]);ee++)X++;return X}t.commonPrefixLength=D;function F(x){return[].concat(...x)}t.flatten=F;function y(x,V){let W=typeof V=="number"?x:0;typeof V=="number"?W=x:(W=0,V=x);const X=[];if(W<=V)for(let ee=W;ee<V;ee++)X.push(ee);else for(let ee=W;ee>V;ee--)X.push(ee);return X}t.range=y;function S(x,V,W){return x.reduce((X,ee)=>(X[V(ee)]=W?W(ee):ee,X),Object.create(null))}t.index=S;function C(x,V){return x.push(V),()=>O(x,V)}t.insert=C;function O(x,V){const W=x.indexOf(V);if(W>-1)return x.splice(W,1),V}t.remove=O;function z(x,V,W){const X=x.slice(0,V),ee=x.slice(V);return X.concat(W,ee)}t.arrayInsert=z;function T(x,V){let W;if(typeof V=="number"){let X=V;W=()=>{const ee=Math.sin(X++)*179426549;return ee-Math.floor(ee)}}else W=Math.random;for(let X=x.length-1;X>0;X-=1){const ee=Math.floor(W()*(X+1)),Q=x[X];x[X]=x[ee],x[ee]=Q}}t.shuffle=T;function q(x,V){const W=x.indexOf(V);W>-1&&(x.splice(W,1),x.unshift(V))}t.pushToStart=q;function j(x,V){const W=x.indexOf(V);W>-1&&(x.splice(W,1),x.push(V))}t.pushToEnd=j;function H(x,V){for(const W of V)x.push(W)}t.pushMany=H;function Y(x,V){return Array.isArray(x)?x.map(V):V(x)}t.mapArrayOrNot=Y;function n(x){return Array.isArray(x)?x:[x]}t.asArray=n;function ne(x){return x[Math.floor(Math.random()*x.length)]}t.getRandomElement=ne;function oe(x,V,W){const X=pe(x,V),ee=x.length,Q=W.length;x.length=ee+Q;for(let G=ee-1;G>=X;G--)x[G+Q]=x[G];for(let G=0;G<Q;G++)x[G+X]=W[G]}t.insertInto=oe;function ge(x,V,W,X){const ee=pe(x,V);let Q=x.splice(ee,W);return Q===void 0&&(Q=[]),oe(x,ee,X),Q}t.splice=ge;function pe(x,V){return V<0?Math.max(V+x.length,0):Math.min(V,x.length)}var Le;(function(x){function V(Q){return Q<0}x.isLessThan=V;function W(Q){return Q<=0}x.isLessThanOrEqual=W;function X(Q){return Q>0}x.isGreaterThan=X;function ee(Q){return Q===0}x.isNeitherLessOrGreaterThan=ee,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(Le||(t.CompareResult=Le={}));function _e(x,V){return(W,X)=>V(x(W),x(X))}t.compareBy=_e;function we(...x){return(V,W)=>{for(const X of x){const ee=X(V,W);if(!Le.isNeitherLessOrGreaterThan(ee))return ee}return Le.neitherLessOrGreaterThan}}t.tieBreakComparators=we;const ke=(x,V)=>x-V;t.numberComparator=ke;const Te=(x,V)=>(0,t.numberComparator)(x?1:0,V?1:0);t.booleanComparator=Te;function Ie(x){return(V,W)=>-x(V,W)}t.reverseOrder=Ie;class Ce{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let W=this.firstIdx;for(;W<this.items.length&&V(this.items[W]);)W++;const X=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,X}takeFromEndWhile(V){let W=this.lastIdx;for(;W>=0&&V(this.items[W]);)W--;const X=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,X}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}removeLast(){const V=this.items[this.lastIdx];return this.lastIdx--,V}takeCount(V){const W=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,W}}t.ArrayQueue=Ce;class Me{static{this.empty=new Me(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(W=>(V(W),!0))}toArray(){const V=[];return this.iterate(W=>(V.push(W),!0)),V}filter(V){return new Me(W=>this.iterate(X=>V(X)?W(X):!0))}map(V){return new Me(W=>this.iterate(X=>W(V(X))))}some(V){let W=!1;return this.iterate(X=>(W=V(X),!W)),W}findFirst(V){let W;return this.iterate(X=>V(X)?(W=X,!1):!0),W}findLast(V){let W;return this.iterate(X=>(V(X)&&(W=X),!0)),W}findLastMaxBy(V){let W,X=!0;return this.iterate(ee=>((X||Le.isGreaterThan(V(ee,W)))&&(X=!1,W=ee),!0)),W}}t.CallbackIterable=Me}),te(ie[13],re([0,1,3]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function P(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=P;function r(l,s="Unreachable"){throw new Error(s)}t.assertNever=r;function c(l){if(!l)throw new k.BugIndicatingError("Assertion Failed")}t.assert=c;function w(l){if(!l()){debugger;l(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}t.assertFn=w;function d(l,s){let g=0;for(;g<l.length-1;){const N=l[g],m=l[g+1];if(!s(N,m))return!1;g++}return!0}t.checkAdjacentItems=d}),te(ie[19],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=void 0;function k(P){const r=this;let c=!1,w;return function(){return c||(c=!0,w=P.apply(r,arguments)),w}}t.createSingleCallFunction=k}),te(ie[20],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(P){function r(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}P.is=r;const c=Object.freeze([]);function w(){return c}P.empty=w;function*d(a){yield a}P.single=d;function l(a){return r(a)?a:d(a)}P.wrap=l;function s(a){return a||c}P.from=s;function*g(a){for(let i=a.length-1;i>=0;i--)yield a[i]}P.reverse=g;function N(a){return!a||a[Symbol.iterator]().next().done===!0}P.isEmpty=N;function m(a){return a[Symbol.iterator]().next().value}P.first=m;function b(a,i){for(const u of a)if(i(u))return!0;return!1}P.some=b;function e(a,i){for(const u of a)if(i(u))return u}P.find=e;function*v(a,i){for(const u of a)i(u)&&(yield u)}P.filter=v;function*A(a,i){let u=0;for(const p of a)yield i(p,u++)}P.map=A;function*E(...a){for(const i of a)for(const u of i)yield u}P.concat=E;function h(a,i,u){let p=u;for(const _ of a)p=i(p,_);return p}P.reduce=h;function*o(a,i,u=a.length){for(i<0&&(i+=a.length),u<0?u+=a.length:u>a.length&&(u=a.length);i<u;i++)yield a[i]}P.slice=o;function f(a,i=Number.POSITIVE_INFINITY){const u=[];if(i===0)return[u,a];const p=a[Symbol.iterator]();for(let _=0;_<i;_++){const L=p.next();if(L.done)return[u,P.empty()];u.push(L.value)}return[u,{[Symbol.iterator](){return p}}]}P.consume=f})(k||(t.Iterable=k={}))}),te(ie[37],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,A){this._keyCodeToStr[v]=A,this._strToKeyCode[A.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const c=new r,w=new r,d=new r;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],s=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",v=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],A=[],E=[];for(const h of v){const[o,f,a,i,u,p,_,L,M]=h;if(E[f]||(E[f]=!0,l[f]=a,s[a]=f,g[a.toLowerCase()]=f,o&&(t.IMMUTABLE_CODE_TO_KEY_CODE[f]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[i]=f))),!A[i]){if(A[i]=!0,!u)throw new Error(`String representation missing for key code ${i} around scan code ${a}`);c.define(i,u),w.define(i,L||u),d.define(i,M||L||u)}p&&(t.EVENT_KEY_CODE_MAP[p]=i),_&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[_]=i)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function v(a){return c.keyCodeToStr(a)}e.toString=v;function A(a){return c.strToKeyCode(a)}e.fromString=A;function E(a){return w.keyCodeToStr(a)}e.toUserSettingsUS=E;function h(a){return d.keyCodeToStr(a)}e.toUserSettingsGeneral=h;function o(a){return w.strToKeyCode(a)||d.strToKeyCode(a)}e.fromUserSettings=o;function f(a){if(a>=98&&a<=113)return null;switch(a){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(a)}e.toElectronAccelerator=f})(N||(t.KeyCodeUtils=N={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(t.KeyMod=m={}));function b(e,v){const A=(v&65535)<<16>>>0;return(e|A)>>>0}t.KeyChord=b}),te(ie[38],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class k{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=k}),te(ie[21],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class k{static{this.Undefined=new k(void 0)}constructor(c){this.element=c,this.next=k.Undefined,this.prev=k.Undefined}}class P{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let c=this._first;for(;c!==k.Undefined;){const w=c.next;c.prev=k.Undefined,c.next=k.Undefined,c=w}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,w){const d=new k(c);if(this._first===k.Undefined)this._first=d,this._last=d;else if(w){const s=this._last;this._last=d,d.prev=s,s.next=d}else{const s=this._first;this._first=d,d.next=s,s.prev=d}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(d))}}shift(){if(this._first!==k.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==k.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==k.Undefined&&c.next!==k.Undefined){const w=c.prev;w.next=c.next,c.next.prev=w}else c.prev===k.Undefined&&c.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):c.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):c.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==k.Undefined;)yield c.element,c=c.next}}t.LinkedList=P}),te(ie[22],re([0,1]),function(B,t){"use strict";var k,P,r;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function c(h,o,f){let a=h.get(o);return a===void 0&&(a=f,h.set(o,a)),a}t.getOrSet=c;function w(h){const o=[];return h.forEach((f,a)=>{o.push(`${a} => ${f}`)}),`Map(${h.size}) {${o.join(", ")}}`}t.mapToString=w;function d(h){const o=[];return h.forEach(f=>{o.push(f)}),`Set(${h.size}) {${o.join(", ")}}`}t.setToString=d;class l{constructor(o,f){this.uri=o,this.value=f}}function s(h){return Array.isArray(h)}class g{static{this.defaultToKey=o=>o.toString()}constructor(o,f){if(this[k]="ResourceMap",o instanceof g)this.map=new Map(o.map),this.toKey=f??g.defaultToKey;else if(s(o)){this.map=new Map,this.toKey=f??g.defaultToKey;for(const[a,i]of o)this.set(a,i)}else this.map=new Map,this.toKey=o??g.defaultToKey}set(o,f){return this.map.set(this.toKey(o),new l(o,f)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,f){typeof f<"u"&&(o=o.bind(f));for(const[a,i]of this.map)o(i.value,i.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}t.ResourceMap=g;class N{constructor(o,f){this[P]="ResourceSet",!o||typeof o=="function"?this._map=new g(o):(this._map=new g(f),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,f){this._map.forEach((a,i)=>o.call(f,i,i,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=N;var m;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(m||(t.Touch=m={}));class b{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,f=0){const a=this._map.get(o);if(a)return f!==0&&this.touch(a,f),a.value}set(o,f,a=0){let i=this._map.get(o);if(i)i.value=f,a!==0&&this.touch(i,a);else{switch(i={key:o,value:f,next:void 0,previous:void 0},a){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(o,i),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const f=this._map.get(o);if(f)return this._map.delete(o),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,f){const a=this._state;let i=this._head;for(;i;){if(f?o.bind(f)(i.value,i.key,this):o(i.value,i.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const o=this,f=this._state;let a=this._head;const i={[Symbol.iterator](){return i},next(){if(o._state!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.key,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return i}values(){const o=this,f=this._state;let a=this._head;const i={[Symbol.iterator](){return i},next(){if(o._state!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.value,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return i}entries(){const o=this,f=this._state;let a=this._head;const i={[Symbol.iterator](){return i},next(){if(o._state!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:[a.key,a.value],done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let f=this._head,a=this.size;for(;f&&a>o;)this._map.delete(f.key),f=f.next,a--;this._head=f,this._size=a,f&&(f.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const f=o.next,a=o.previous;if(!f||!a)throw new Error("Invalid list");f.previous=a,a.next=f}o.next=void 0,o.previous=void 0,this._state++}touch(o,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(o===this._head)return;const a=o.next,i=o.previous;o===this._tail?(i.next=void 0,this._tail=i):(a.previous=i,i.next=a),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(f===2){if(o===this._tail)return;const a=o.next,i=o.previous;o===this._head?(a.previous=void 0,this._head=a):(a.previous=i,i.next=a),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((f,a)=>{o.push([a,f])}),o}fromJSON(o){this.clear();for(const[f,a]of o)this.set(f,a)}}t.LinkedMap=b;class e extends b{constructor(o,f=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,f=2){return super.get(o,f)}peek(o){return super.get(o,0)}set(o,f){return super.set(o,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=e;class v{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let f=this.map.get(o)||0;return f===0?!1:(f--,f===0?this.map.delete(o):this.map.set(o,f),!0)}has(o){return this.map.has(o)}}t.CounterSet=v;class A{constructor(o){if(this._m1=new Map,this._m2=new Map,o)for(const[f,a]of o)this.set(f,a)}clear(){this._m1.clear(),this._m2.clear()}set(o,f){this._m1.set(o,f),this._m2.set(f,o)}get(o){return this._m1.get(o)}getKey(o){return this._m2.get(o)}delete(o){const f=this._m1.get(o);return f===void 0?!1:(this._m1.delete(o),this._m2.delete(f),!0)}forEach(o,f){this._m1.forEach((a,i)=>{o.call(f,a,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=A;class E{constructor(){this.map=new Map}add(o,f){let a=this.map.get(o);a||(a=new Set,this.map.set(o,a)),a.add(f)}delete(o,f){const a=this.map.get(o);a&&(a.delete(f),a.size===0&&this.map.delete(o))}forEach(o,f){const a=this.map.get(o);a&&a.forEach(f)}get(o){const f=this.map.get(o);return f||new Set}}t.SetMap=E}),te(ie[10],re([0,1,6,34,22,19,20]),function(B,t,k,P,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.markAsDisposed=t.trackDisposable=t.setDisposableTracker=t.DisposableTracker=void 0;const d=!1;let l=null;class s{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(S){let C=this.livingDisposables.get(S);return C||(C={parent:null,source:null,isSingleton:!1,value:S,idx:s.idx++},this.livingDisposables.set(S,C)),C}trackDisposable(S){const C=this.getDisposableData(S);C.source||(C.source=new Error().stack)}setParent(S,C){const O=this.getDisposableData(S);O.parent=C}markAsDisposed(S){this.livingDisposables.delete(S)}markAsSingleton(S){this.getDisposableData(S).isSingleton=!0}getRootParent(S,C){const O=C.get(S);if(O)return O;const z=S.parent?this.getRootParent(this.getDisposableData(S.parent),C):S;return C.set(S,z),z}getTrackedDisposables(){const S=new Map;return[...this.livingDisposables.entries()].filter(([,O])=>O.source!==null&&!this.getRootParent(O,S).isSingleton).map(([O])=>O).flat()}computeLeakingDisposables(S=10,C){let O;if(C)O=C;else{const H=new Map,Y=[...this.livingDisposables.values()].filter(ne=>ne.source!==null&&!this.getRootParent(ne,H).isSingleton);if(Y.length===0)return;const n=new Set(Y.map(ne=>ne.value));if(O=Y.filter(ne=>!(ne.parent&&n.has(ne.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function z(H){function Y(ne,oe){for(;ne.length>0&&oe.some(ge=>typeof ge=="string"?ge===ne[0]:ne[0].match(ge));)ne.shift()}const n=H.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return Y(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const T=new r.SetMap;for(const H of O){const Y=z(H);for(let n=0;n<=Y.length;n++)T.add(Y.slice(0,n).join(`
`),H)}O.sort((0,k.compareBy)(H=>H.idx,k.numberComparator));let q="",j=0;for(const H of O.slice(0,S)){j++;const Y=z(H),n=[];for(let ne=0;ne<Y.length;ne++){let oe=Y[ne];oe=`(shared with ${T.get(Y.slice(0,ne+1).join(`
`)).size}/${O.length} leaks) at ${oe}`;const pe=T.get(Y.slice(0,ne).join(`
`)),Le=(0,P.groupBy)([...pe].map(_e=>z(_e)[ne]),_e=>_e);delete Le[Y[ne]];for(const[_e,we]of Object.entries(Le))n.unshift(`    - stacktraces of ${we.length} other leaks continue with ${_e}`);n.unshift(oe)}q+=`


==================== Leaking disposable ${j}/${O.length}: ${H.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return O.length>S&&(q+=`


... and ${O.length-S} more leaking disposables

`),{leaks:O,details:q}}}t.DisposableTracker=s;function g(y){l=y}if(t.setDisposableTracker=g,d){const y="__is_disposable_tracked__";g(new class{trackDisposable(S){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[y]||console.log(C)},3e3)}setParent(S,C){if(S&&S!==i.None)try{S[y]=!0}catch{}}markAsDisposed(S){if(S&&S!==i.None)try{S[y]=!0}catch{}}markAsSingleton(S){}})}function N(y){return l?.trackDisposable(y),y}t.trackDisposable=N;function m(y){l?.markAsDisposed(y)}t.markAsDisposed=m;function b(y,S){l?.setParent(y,S)}function e(y,S){if(l)for(const C of y)l.setParent(C,S)}function v(y){return l?.markAsSingleton(y),y}t.markAsSingleton=v;function A(y){return typeof y.dispose=="function"&&y.dispose.length===0}t.isDisposable=A;function E(y){if(w.Iterable.is(y)){const S=[];for(const C of y)if(C)try{C.dispose()}catch(O){S.push(O)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}t.dispose=E;function h(y){for(const S of y)A(S)&&S.dispose();return[]}t.disposeIfDisposable=h;function o(...y){const S=f(()=>E(y));return e(y,S),S}t.combinedDisposable=o;function f(y){const S=N({dispose:(0,c.createSingleCallFunction)(()=>{m(S),y()})});return S}t.toDisposable=f;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,N(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{E(this._toDispose)}finally{this._toDispose.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return b(S,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(S),S.dispose()}}deleteAndLeak(S){S&&this._toDispose.has(S)&&(this._toDispose.delete(S),b(S,null))}}t.DisposableStore=a;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,N(this),b(this._store,this)}dispose(){m(this),this._store.dispose()}_register(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(S)}}t.Disposable=i;class u{constructor(){this._isDisposed=!1,N(this)}get value(){return this._isDisposed?void 0:this._value}set value(S){this._isDisposed||S===this._value||(this._value?.dispose(),S&&b(S,this),this._value=S)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const S=this._value;return this._value=void 0,S&&b(S,null),S}}t.MutableDisposable=u;class p{constructor(S){this._disposable=S,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=p;class _{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(S){let C=S;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,m(this))},this}}t.SafeDisposable=_;class L{constructor(){this.references=new Map}acquire(S,...C){let O=this.references.get(S);O||(O={counter:0,object:this.createReferencedObject(S,...C)},this.references.set(S,O));const{object:z}=O,T=(0,c.createSingleCallFunction)(()=>{--O.counter===0&&(this.destroyReferencedObject(S,O.object),this.references.delete(S))});return O.counter++,{object:z,dispose:T}}}t.ReferenceCollection=L;class M{constructor(S){this.referenceCollection=S}async acquire(S,...C){const O=this.referenceCollection.acquire(S,...C);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(z){throw O.dispose(),z}}}t.AsyncReferenceCollection=M;class R{constructor(S){this.object=S}dispose(){}}t.ImmortalReference=R;function D(y){const S=new a;try{y(S)}finally{S.dispose()}}t.disposeOnReturn=D;class F{constructor(){this._store=new Map,this._isDisposed=!1,N(this)}dispose(){m(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{E(this._store.values())}finally{this._store.clear()}}has(S){return this._store.has(S)}get size(){return this._store.size}get(S){return this._store.get(S)}set(S,C,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(S)?.dispose(),this._store.set(S,C)}deleteAndDispose(S){this._store.get(S)?.dispose(),this._store.delete(S)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=F}),te(ie[23],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(c){return new P(c)}constructor(c){this._now=k&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=P}),te(ie[11],re([0,1,3,19,10,21,23]),function(B,t,k,P,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const d=!1,l=!1;var s;(function(F){F.None=()=>r.Disposable.None;function y(Q){if(l){const{onDidAddListener:G}=Q,Z=e.create();let K=0;Q.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),G?.()}}}function S(Q,G){return ne(Q,()=>{},0,void 0,!0,void 0,G)}F.defer=S;function C(Q){return(G,Z=null,K)=>{let se=!1,le;return le=Q(ce=>{if(!se)return le?le.dispose():se=!0,G.call(Z,ce)},null,K),se&&le.dispose(),le}}F.once=C;function O(Q,G,Z){return Y((K,se=null,le)=>Q(ce=>K.call(se,G(ce)),null,le),Z)}F.map=O;function z(Q,G,Z){return Y((K,se=null,le)=>Q(ce=>{G(ce),K.call(se,ce)},null,le),Z)}F.forEach=z;function T(Q,G,Z){return Y((K,se=null,le)=>Q(ce=>G(ce)&&K.call(se,ce),null,le),Z)}F.filter=T;function q(Q){return Q}F.signal=q;function j(...Q){return(G,Z=null,K)=>{const se=(0,r.combinedDisposable)(...Q.map(le=>le(ce=>G.call(Z,ce))));return n(se,K)}}F.any=j;function H(Q,G,Z,K){let se=Z;return O(Q,le=>(se=G(se,le),se),K)}F.reduce=H;function Y(Q,G){let Z;const K={onWillAddFirstListener(){Z=Q(se.fire,se)},onDidRemoveLastListener(){Z?.dispose()}};G||y(K);const se=new o(K);return G?.add(se),se.event}function n(Q,G){return G instanceof Array?G.push(Q):G&&G.add(Q),Q}function ne(Q,G,Z=100,K=!1,se=!1,le,ce){let me,fe,Re,ve=0,Se;const xe={leakWarningThreshold:le,onWillAddFirstListener(){me=Q(qe=>{ve++,fe=G(fe,qe),K&&!Re&&(Fe.fire(fe),fe=void 0),Se=()=>{const Ue=fe;fe=void 0,Re=void 0,(!K||ve>1)&&Fe.fire(Ue),ve=0},typeof Z=="number"?(clearTimeout(Re),Re=setTimeout(Se,Z)):Re===void 0&&(Re=0,queueMicrotask(Se))})},onWillRemoveListener(){se&&ve>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,me.dispose()}};ce||y(xe);const Fe=new o(xe);return ce?.add(Fe),Fe.event}F.debounce=ne;function oe(Q,G=0,Z){return F.debounce(Q,(K,se)=>K?(K.push(se),K):[se],G,void 0,!0,void 0,Z)}F.accumulate=oe;function ge(Q,G=(K,se)=>K===se,Z){let K=!0,se;return T(Q,le=>{const ce=K||!G(le,se);return K=!1,se=le,ce},Z)}F.latch=ge;function pe(Q,G,Z){return[F.filter(Q,G,Z),F.filter(Q,K=>!G(K),Z)]}F.split=pe;function Le(Q,G=!1,Z=[],K){let se=Z.slice(),le=Q(fe=>{se?se.push(fe):me.fire(fe)});K&&K.add(le);const ce=()=>{se?.forEach(fe=>me.fire(fe)),se=null},me=new o({onWillAddFirstListener(){le||(le=Q(fe=>me.fire(fe)),K&&K.add(le))},onDidAddFirstListener(){se&&(G?setTimeout(ce):ce())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(me),me.event}F.buffer=Le;function _e(Q,G){return(K,se,le)=>{const ce=G(new ke);return Q(function(me){const fe=ce.evaluate(me);fe!==we&&K.call(se,fe)},void 0,le)}}F.chain=_e;const we=Symbol("HaltChainable");class ke{constructor(){this.steps=[]}map(G){return this.steps.push(G),this}forEach(G){return this.steps.push(Z=>(G(Z),Z)),this}filter(G){return this.steps.push(Z=>G(Z)?Z:we),this}reduce(G,Z){let K=Z;return this.steps.push(se=>(K=G(K,se),K)),this}latch(G=(Z,K)=>Z===K){let Z=!0,K;return this.steps.push(se=>{const le=Z||!G(se,K);return Z=!1,K=se,le?se:we}),this}evaluate(G){for(const Z of this.steps)if(G=Z(G),G===we)break;return G}}function Te(Q,G,Z=K=>K){const K=(...me)=>ce.fire(Z(...me)),se=()=>Q.on(G,K),le=()=>Q.removeListener(G,K),ce=new o({onWillAddFirstListener:se,onDidRemoveLastListener:le});return ce.event}F.fromNodeEventEmitter=Te;function Ie(Q,G,Z=K=>K){const K=(...me)=>ce.fire(Z(...me)),se=()=>Q.addEventListener(G,K),le=()=>Q.removeEventListener(G,K),ce=new o({onWillAddFirstListener:se,onDidRemoveLastListener:le});return ce.event}F.fromDOMEventEmitter=Ie;function Ce(Q){return new Promise(G=>C(Q)(G))}F.toPromise=Ce;function Me(Q){const G=new o;return Q.then(Z=>{G.fire(Z)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}F.fromPromise=Me;function x(Q,G){return G(void 0),Q(Z=>G(Z))}F.runAndSubscribe=x;function V(Q,G){let Z=null;function K(le){Z?.dispose(),Z=new r.DisposableStore,G(le,Z)}K(void 0);const se=Q(le=>K(le));return(0,r.toDisposable)(()=>{se.dispose(),Z?.dispose()})}F.runAndSubscribeWithStore=V;class W{constructor(G,Z){this._observable=G,this._counter=0,this._hasChanged=!1;const K={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Z||y(K),this.emitter=new o(K),Z&&Z.add(this.emitter)}beginUpdate(G){this._counter++}handlePossibleChange(G){}handleChange(G,Z){this._hasChanged=!0}endUpdate(G){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function X(Q,G){return new W(Q,G).emitter.event}F.fromObservable=X;function ee(Q){return G=>{let Z=0,K=!1;const se={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(Q.reportChanges(),K&&(K=!1,G()))},handlePossibleChange(){},handleChange(){K=!0}};return Q.addObserver(se),Q.reportChanges(),{dispose(){Q.removeObserver(se)}}}}F.fromObservableLight=ee})(s||(t.Event=s={}));class g{static{this.all=new Set}static{this._idPool=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${g._idPool++}`,g.all.add(this)}start(y){this._stopWatch=new w.StopWatch,this.listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=g;let N=-1;function m(F){const y=N;return N=F,{dispose(){N=y}}}t.setGlobalLeakWarningThreshold=m;class b{constructor(y,S=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=S,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(y,S){const C=this.threshold;if(C<=0||S<C)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(y.value)||0;if(this._stacks.set(y.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let z,T=0;for(const[q,j]of this._stacks)(!z||T<j)&&(z=q,T=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${T}):`),console.warn(z)}return()=>{const z=this._stacks.get(y.value)||0;this._stacks.set(y.value,z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class A{constructor(y){this.value=y,this.id=v++}}const E=2,h=(F,y)=>{if(F instanceof A)y(F);else for(let S=0;S<F.length;S++){const C=F[S];C&&y(C)}};class o{constructor(y){this._size=0,this._options=y,this._leakageMon=N>0||this._options?.leakWarningThreshold?new b(this._options?.leakWarningThreshold??N):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(d){const y=this._listeners;queueMicrotask(()=>{h(y,S=>S.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(y,S,C)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;S&&(y=y.bind(S));const O=new A(y);let z,T;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=e.create(),z=this._leakageMon.check(O.stack,this._size+1)),d&&(O.stack=T??e.create()),this._listeners?this._listeners instanceof A?(this._deliveryQueue??=new a,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,r.toDisposable)(()=>{z?.(),this._removeListener(O)});return C instanceof r.DisposableStore?C.add(q):Array.isArray(C)&&C.push(q),q},this._event}_removeListener(y){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const S=this._listeners,C=S.indexOf(y);if(C===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,S[C]=void 0;const O=this._deliveryQueue.current===this;if(this._size*E<=S.length){let z=0;for(let T=0;T<S.length;T++)S[T]?S[z++]=S[T]:O&&(this._deliveryQueue.end--,z<this._deliveryQueue.i&&this._deliveryQueue.i--);S.length=z}}_deliver(y,S){if(!y)return;const C=this._options?.onListenerError||k.onUnexpectedError;if(!C){y.value(S);return}try{y.value(S)}catch(O){C(O)}}_deliverQueue(y){const S=y.current._listeners;for(;y.i<y.end;)this._deliver(S[y.i++],y.value);y.reset()}fire(y){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof A)this._deliver(this._listeners,y);else{const S=this._deliveryQueue;S.enqueue(this,y,this._listeners.length),this._deliverQueue(S)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=o;const f=()=>new a;t.createEventDeliveryQueue=f;class a{constructor(){this.i=-1,this.end=0}enqueue(y,S,C){this.i=0,this.end=C,this.current=y,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends o{async fireAsync(y,S,C){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new c.LinkedList),h(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,y]));this._asyncDeliveryQueue.size>0&&!S.isCancellationRequested;){const[O,z]=this._asyncDeliveryQueue.shift(),T=[],q={...z,token:S,waitUntil:j=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");C&&(j=C(j,O)),T.push(j)}};try{O(q)}catch(j){(0,k.onUnexpectedError)(j);continue}Object.freeze(T),await Promise.allSettled(T).then(j=>{for(const H of j)H.status==="rejected"&&(0,k.onUnexpectedError)(H.reason)})}}}t.AsyncEmitter=i;class u extends o{get isPaused(){return this._isPaused!==0}constructor(y){super(y),this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._size&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}t.PauseableEmitter=u;class p extends u{constructor(y){super(y),this._delay=y.delay??100}fire(y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(y)}}t.DebounceEmitter=p;class _ extends o{constructor(y){super(y),this._queuedEvents=[],this._mergeFn=y?.merge}fire(y){this.hasListeners()&&(this._queuedEvents.push(y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(S=>super.fire(S)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=_;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const S={event:y,listener:null};this.events.push(S),this.hasListeners&&this.hook(S);const C=()=>{this.hasListeners&&this.unhook(S);const O=this.events.indexOf(S);this.events.splice(O,1)};return(0,r.toDisposable)((0,P.createSingleCallFunction)(C))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(S=>this.emitter.fire(S))}unhook(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=L;class M{constructor(y,S,C,O){this._store=new r.DisposableStore;const z=this._store.add(new L),T=this._store.add(new r.DisposableMap);function q(j){T.set(j,z.add(O(j)))}for(const j of y)q(j);this._store.add(S(j=>{q(j)})),this._store.add(C(j=>{T.deleteAndDispose(j)})),this.event=z.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=M;class R{constructor(){this.buffers=[]}wrapEvent(y){return(S,C,O)=>y(z=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>S.call(C,z)):S.call(C,z)},void 0,O)}bufferEvents(y){const S=[];this.buffers.push(S);const C=y();return this.buffers.pop(),S.forEach(O=>O()),C}}t.EventBufferer=R;class D{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=r.Disposable.None,this.emitter=new o({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=D}),te(ie[24],re([0,1,11]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const P=Object.freeze(function(d,l){const s=setTimeout(d.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(d){function l(s){return s===d.None||s===d.Cancelled||s instanceof c?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}d.isCancellationToken=l,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(r||(t.CancellationToken=r={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=r.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=r.None}}t.CancellationTokenSource=w}),te(ie[39],re([0,1,24]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class P{constructor(d){this.task=d,this.result=null}get(){if(this.result)return this.result;const d=new k.CancellationTokenSource,l=this.task(d.token);return this.result={promise:l,dispose:()=>{this.result=null,d.cancel(),d.dispose()}},this.result}}t.Cache=P;class r{constructor(d){this.fn=d,this.lastCache=void 0,this.lastArgKey=void 0}get(d){const l=JSON.stringify(d);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(d)),this.lastCache}}t.LRUCachedFunction=r;class c{get cachedValues(){return this._map}constructor(d){this.fn=d,this._map=new Map}get(d){if(this._map.has(d))return this._map.get(d);const l=this.fn(d);return this._map.set(d,l),l}}t.CachedFunction=c}),te(ie[7],re([0,1,39,38]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function r(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.isFalsyOrWhitespace=r;const c=/{(\d+)}/g;function w(I,...U){return U.length===0?I:I.replace(c,function($,J){const ae=parseInt(J,10);return isNaN(ae)||ae<0||ae>=U.length?$:U[ae]})}t.format=w;const d=/{([^}]+)}/g;function l(I,U){return I.replace(d,($,J)=>U[J]??$)}t.format2=l;function s(I){return I.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}t.escape=s;function g(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=g;function N(I,U){let $=0;const J=U.charCodeAt(0);for(let ae=I.length-1;ae>=0;ae--)I.charCodeAt(ae)===J&&$++;return $}t.count=N;function m(I,U,$="\u2026"){return I.length<=U?I:`${I.substr(0,U)}${$}`}t.truncate=m;function b(I,U=" "){const $=e(I,U);return v($,U)}t.trim=b;function e(I,U){if(!I||!U)return I;const $=U.length;if($===0||I.length===0)return I;let J=0;for(;I.indexOf(U,J)===J;)J=J+$;return I.substring(J)}t.ltrim=e;function v(I,U){if(!I||!U)return I;const $=U.length,J=I.length;if($===0||J===0)return I;let ae=J,ue=-1;for(;ue=I.lastIndexOf(U,ae-1),!(ue===-1||ue+$!==ae);){if(ue===0)return"";ae=ue}return I.substring(0,ae)}t.rtrim=v;function A(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=A;function E(I){return I.replace(/\*/g,"")}t.stripWildcards=E;function h(I,U,$={}){if(!I)throw new Error("Cannot create regex from empty string");U||(I=g(I)),$.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let J="";return $.global&&(J+="g"),$.matchCase||(J+="i"),$.multiline&&(J+="m"),$.unicode&&(J+="u"),new RegExp(I,J)}t.createRegExp=h;function o(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.regExpLeadsToEndlessLoop=o;function f(I){return I.split(/\r\n|\r|\n/)}t.splitLines=f;function a(I){for(let U=0,$=I.length;U<$;U++){const J=I.charCodeAt(U);if(J!==32&&J!==9)return U}return-1}t.firstNonWhitespaceIndex=a;function i(I,U=0,$=I.length){for(let J=U;J<$;J++){const ae=I.charCodeAt(J);if(ae!==32&&ae!==9)return I.substring(U,J)}return I.substring(U,$)}t.getLeadingWhitespace=i;function u(I,U=I.length-1){for(let $=U;$>=0;$--){const J=I.charCodeAt($);if(J!==32&&J!==9)return $}return-1}t.lastNonWhitespaceIndex=u;function p(I,U,$){const J=[];let ae=0;for(const ue of I.matchAll(U)){if(J.push(I.slice(ae,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");ae=ue.index+ue[0].length,J.push($(ue[0],...ue.slice(1),ue.index,I,ue.groups))}return J.push(I.slice(ae)),Promise.all(J).then(ue=>ue.join(""))}t.replaceAsync=p;function _(I,U){return I<U?-1:I>U?1:0}t.compare=_;function L(I,U,$=0,J=I.length,ae=0,ue=U.length){for(;$<J&&ae<ue;$++,ae++){const Ee=I.charCodeAt($),Ne=U.charCodeAt(ae);if(Ee<Ne)return-1;if(Ee>Ne)return 1}const de=J-$,ye=ue-ae;return de<ye?-1:de>ye?1:0}t.compareSubstring=L;function M(I,U){return R(I,U,0,I.length,0,U.length)}t.compareIgnoreCase=M;function R(I,U,$=0,J=I.length,ae=0,ue=U.length){for(;$<J&&ae<ue;$++,ae++){let Ee=I.charCodeAt($),Ne=U.charCodeAt(ae);if(Ee===Ne)continue;if(Ee>=128||Ne>=128)return L(I.toLowerCase(),U.toLowerCase(),$,J,ae,ue);F(Ee)&&(Ee-=32),F(Ne)&&(Ne-=32);const be=Ee-Ne;if(be!==0)return be}const de=J-$,ye=ue-ae;return de<ye?-1:de>ye?1:0}t.compareSubstringIgnoreCase=R;function D(I){return I>=48&&I<=57}t.isAsciiDigit=D;function F(I){return I>=97&&I<=122}t.isLowerAsciiLetter=F;function y(I){return I>=65&&I<=90}t.isUpperAsciiLetter=y;function S(I,U){return I.length===U.length&&R(I,U)===0}t.equalsIgnoreCase=S;function C(I,U){const $=U.length;return U.length>I.length?!1:R(I,U,0,$)===0}t.startsWithIgnoreCase=C;function O(I,U){const $=Math.min(I.length,U.length);let J;for(J=0;J<$;J++)if(I.charCodeAt(J)!==U.charCodeAt(J))return J;return $}t.commonPrefixLength=O;function z(I,U){const $=Math.min(I.length,U.length);let J;const ae=I.length-1,ue=U.length-1;for(J=0;J<$;J++)if(I.charCodeAt(ae-J)!==U.charCodeAt(ue-J))return J;return $}t.commonSuffixLength=z;function T(I){return 55296<=I&&I<=56319}t.isHighSurrogate=T;function q(I){return 56320<=I&&I<=57343}t.isLowSurrogate=q;function j(I,U){return(I-55296<<10)+(U-56320)+65536}t.computeCodePoint=j;function H(I,U,$){const J=I.charCodeAt($);if(T(J)&&$+1<U){const ae=I.charCodeAt($+1);if(q(ae))return j(J,ae)}return J}t.getNextCodePoint=H;function Y(I,U){const $=I.charCodeAt(U-1);if(q($)&&U>1){const J=I.charCodeAt(U-2);if(T(J))return j(J,$)}return $}class n{get offset(){return this._offset}constructor(U,$=0){this._str=U,this._len=U.length,this._offset=$}setOffset(U){this._offset=U}prevCodePoint(){const U=Y(this._str,this._offset);return this._offset-=U>=65536?2:1,U}nextCodePoint(){const U=H(this._str,this._len,this._offset);return this._offset+=U>=65536?2:1,U}eol(){return this._offset>=this._len}}t.CodePointIterator=n;class ne{get offset(){return this._iterator.offset}constructor(U,$=0){this._iterator=new n(U,$)}nextGraphemeLength(){const U=ve.getInstance(),$=this._iterator,J=$.offset;let ae=U.getGraphemeBreakType($.nextCodePoint());for(;!$.eol();){const ue=$.offset,de=U.getGraphemeBreakType($.nextCodePoint());if(fe(ae,de)){$.setOffset(ue);break}ae=de}return $.offset-J}prevGraphemeLength(){const U=ve.getInstance(),$=this._iterator,J=$.offset;let ae=U.getGraphemeBreakType($.prevCodePoint());for(;$.offset>0;){const ue=$.offset,de=U.getGraphemeBreakType($.prevCodePoint());if(fe(de,ae)){$.setOffset(ue);break}ae=de}return J-$.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ne;function oe(I,U){return new ne(I,U).nextGraphemeLength()}t.nextCharLength=oe;function ge(I,U){return new ne(I,U).prevGraphemeLength()}t.prevCharLength=ge;function pe(I,U){U>0&&q(I.charCodeAt(U))&&U--;const $=U+oe(I,U);return[$-ge(I,$),$]}t.getCharContainingOffset=pe;function Le(I){const U=new ne(I);let $=0;for(;!U.eol();)$++,U.nextGraphemeLength();return $}t.charCount=Le;let _e;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(I){return _e||(_e=we()),_e.test(I)}t.containsRTL=ke;const Te=/^[\t\n\r\x20-\x7E]*$/;function Ie(I){return Te.test(I)}t.isBasicASCII=Ie,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ce(I){return t.UNUSUAL_LINE_TERMINATORS.test(I)}t.containsUnusualLineTerminators=Ce;function Me(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.isFullWidthCharacter=Me;function x(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.isEmojiImprecise=x;function V(I,U){if(I.length<U)return I;const $=/\b/g;let J=0;for(;$.test(I)&&!(I.length-$.lastIndex<U);)J=$.lastIndex,$.lastIndex+=1;return I.substring(J).replace(/^\s/,"")}t.lcut=V;const W=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,X=/\x1b\].*?\x07/g;function ee(I){return I&&(I=I.replace(W,"").replace(X,"")),I}t.removeAnsiEscapeCodes=ee,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Q;function G(I){return Q(I)?I.substr(1):I}t.stripUTF8BOM=G;function Z(I,U){if(!I||!U||I.length<U.length)return!1;const $=U.length,J=I.toLowerCase();let ae=0,ue=-1;for(;ae<$;){const de=J.indexOf(U[ae],ue+1);if(de<0)return!1;ue=de,ae++}return!0}t.fuzzyContains=Z;function K(I,U=!1){return I?(U&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.containsUppercaseCharacter=K;function se(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.uppercaseFirstLetter=se;function le(I,U=1){if(U===0)return"";let $=-1;do $=I.indexOf(`
`,$+1),U--;while(U>0&&$>=0);return $===-1?I:(I[$-1]==="\r"&&$--,I.substr(0,$))}t.getNLines=le;function ce(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.singleLetterHash=ce;function me(I){return ve.getInstance().getGraphemeBreakType(I)}t.getGraphemeBreakType=me;function fe(I,U){return I===0?U!==5&&U!==7:I===2&&U===3?!1:I===4||I===2||I===3||U===4||U===2||U===3?!0:!(I===8&&(U===8||U===9||U===11||U===12)||(I===11||I===9)&&(U===9||U===10)||(I===12||I===10)&&U===10||U===5||U===13||U===7||I===1||I===13&&U===14||I===6&&U===6)}var Re;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(t.GraphemeBreakType=Re={}));class ve{static{this._INSTANCE=null}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}constructor(){this._data=Se()}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const $=this._data,J=$.length/3;let ae=1;for(;ae<=J;)if(U<$[3*ae])ae=2*ae;else if(U>$[3*ae+1])ae=2*ae+1;else return $[3*ae+2];return 0}}function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(I,U){if(I===0)return 0;const $=Fe(I,U);if($!==void 0)return $;const J=new n(U,I);return J.prevCodePoint(),J.offset}t.getLeftDeleteOffset=xe;function Fe(I,U){const $=new n(U,I);let J=$.prevCodePoint();for(;qe(J)||J===65039||J===8419;){if($.offset===0)return;J=$.prevCodePoint()}if(!x(J))return;let ae=$.offset;return ae>0&&$.prevCodePoint()===8205&&(ae=$.offset),ae}function qe(I){return 127995<=I&&I<=127999}var Ue;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.noBreakWhitespace="\xA0";class Pe{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new k.LRUCachedFunction(U=>{function $(be){const De=new Map;for(let Ae=0;Ae<be.length;Ae+=2)De.set(be[Ae],be[Ae+1]);return De}function J(be,De){const Ae=new Map(be);for(const[Be,We]of De)Ae.set(Be,We);return Ae}function ae(be,De){if(!be)return De;const Ae=new Map;for(const[Be,We]of be)De.has(Be)&&Ae.set(Be,We);return Ae}const ue=this.ambiguousCharacterData.value;let de=U.filter(be=>!be.startsWith("_")&&be in ue);de.length===0&&(de=["_default"]);let ye;for(const be of de){const De=$(ue[be]);ye=ae(ye,De)}const Ee=$(ue._common),Ne=J(Ee,ye);return new Pe(Ne)})}static getInstance(U){return Pe.cache.get(Array.from(U))}static{this._locales=new P.Lazy(()=>Object.keys(Pe.ambiguousCharacterData.value).filter(U=>!U.startsWith("_")))}static getLocales(){return Pe._locales.value}constructor(U){this.confusableDictionary=U}isAmbiguous(U){return this.confusableDictionary.has(U)}getPrimaryConfusable(U){return this.confusableDictionary.get(U)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Pe;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(U){return Oe.getData().has(U)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe}),te(ie[40],re([0,1,7]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function P(E){return r(E,0)}t.hash=P;function r(E,h){switch(typeof E){case"object":return E===null?c(349,h):Array.isArray(E)?l(E,h):s(E,h);case"string":return d(E,h);case"boolean":return w(E,h);case"number":return c(E,h);case"undefined":return c(937,h);default:return c(617,h)}}t.doHash=r;function c(E,h){return(h<<5)-h+E|0}t.numberHash=c;function w(E,h){return c(E?433:863,h)}function d(E,h){h=c(149417,h);for(let o=0,f=E.length;o<f;o++)h=c(E.charCodeAt(o),h);return h}t.stringHash=d;function l(E,h){return h=c(104579,h),E.reduce((o,f)=>r(f,o),h)}function s(E,h){return h=c(181387,h),Object.keys(E).sort().reduce((o,f)=>(o=d(f,o),r(E[f],o)),h)}class g{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=r(h,this._value),this._value}}t.Hasher=g;var N;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function m(E,h,o=32){const f=o-h,a=~((1<<f)-1);return(E<<h|(a&E)>>>f)>>>0}function b(E,h=0,o=E.byteLength,f=0){for(let a=0;a<o;a++)E[h+a]=f}function e(E,h,o="0"){for(;E.length<h;)E=o+E;return E}function v(E,h=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(o=>o.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),h/4)}t.toHexString=v;class A{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const o=h.length;if(o===0)return;const f=this._buff;let a=this._buffLen,i=this._leftoverHighSurrogate,u,p;for(i!==0?(u=i,p=-1,i=0):(u=h.charCodeAt(0),p=0);;){let _=u;if(k.isHighSurrogate(u))if(p+1<o){const L=h.charCodeAt(p+1);k.isLowSurrogate(L)?(p++,_=k.computeCodePoint(u,L)):_=65533}else{i=u;break}else k.isLowSurrogate(u)&&(_=65533);if(a=this._push(f,a,_),p++,p<o)u=h.charCodeAt(p);else break}this._buffLen=a,this._leftoverHighSurrogate=i}_push(h,o,f){return f<128?h[o++]=f:f<2048?(h[o++]=192|(f&1984)>>>6,h[o++]=128|(f&63)>>>0):f<65536?(h[o++]=224|(f&61440)>>>12,h[o++]=128|(f&4032)>>>6,h[o++]=128|(f&63)>>>0):(h[o++]=240|(f&1835008)>>>18,h[o++]=128|(f&258048)>>>12,h[o++]=128|(f&4032)>>>6,h[o++]=128|(f&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=A._bigBlock32,o=this._buffDV;for(let R=0;R<64;R+=4)h.setUint32(R,o.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)h.setUint32(R,m(h.getUint32(R-12,!1)^h.getUint32(R-32,!1)^h.getUint32(R-56,!1)^h.getUint32(R-64,!1),1),!1);let f=this._h0,a=this._h1,i=this._h2,u=this._h3,p=this._h4,_,L,M;for(let R=0;R<80;R++)R<20?(_=a&i|~a&u,L=1518500249):R<40?(_=a^i^u,L=1859775393):R<60?(_=a&i|a&u|i&u,L=2400959708):(_=a^i^u,L=3395469782),M=m(f,5)+_+p+L+h.getUint32(R*4,!1)&4294967295,p=u,u=i,i=m(a,30),a=f,f=M;this._h0=this._h0+f&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+p&4294967295}}t.StringSHA1=A}),te(ie[25],re([0,1,36,40]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class r{constructor(m){this.source=m}getElements(){const m=this.source,b=new Int32Array(m.length);for(let e=0,v=m.length;e<v;e++)b[e]=m.charCodeAt(e);return b}}t.StringDiffSequence=r;function c(N,m,b){return new g(new r(N),new r(m)).ComputeDiff(b).changes}t.stringDiff=c;class w{static Assert(m,b){if(!m)throw new Error(b)}}class d{static Copy(m,b,e,v,A){for(let E=0;E<A;E++)e[v+E]=m[b+E]}static Copy2(m,b,e,v,A){for(let E=0;E<A;E++)e[v+E]=m[b+E]}}var l;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new k.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(m,b){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++}AddModifiedElement(m,b){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class g{constructor(m,b,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=m,this._modifiedSequence=b;const[v,A,E]=g._getElements(m),[h,o,f]=g._getElements(b);this._hasStrings=E&&f,this._originalStringElements=v,this._originalElementsOrHash=A,this._modifiedStringElements=h,this._modifiedElementsOrHash=o,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const b=m.getElements();if(g._isStringArray(b)){const e=new Int32Array(b.length);for(let v=0,A=b.length;v<A;v++)e[v]=(0,P.stringHash)(b[v],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}ElementsAreEqual(m,b){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[b]:!0}ElementsAreStrictEqual(m,b){if(!this.ElementsAreEqual(m,b))return!1;const e=g._getStrictElement(this._originalSequence,m),v=g._getStrictElement(this._modifiedSequence,b);return e===v}static _getStrictElement(m,b){return typeof m.getStrictElement=="function"?m.getStrictElement(b):null}OriginalElementsAreEqual(m,b){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[b]:!0}ModifiedElementsAreEqual(m,b){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[b]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,b,e,v,A){const E=[!1];let h=this.ComputeDiffRecursive(m,b,e,v,E);return A&&(h=this.PrettifyChanges(h)),{quitEarly:E[0],changes:h}}ComputeDiffRecursive(m,b,e,v,A){for(A[0]=!1;m<=b&&e<=v&&this.ElementsAreEqual(m,e);)m++,e++;for(;b>=m&&v>=e&&this.ElementsAreEqual(b,v);)b--,v--;if(m>b||e>v){let i;return e<=v?(w.Assert(m===b+1,"originalStart should only be one more than originalEnd"),i=[new k.DiffChange(m,0,e,v-e+1)]):m<=b?(w.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),i=[new k.DiffChange(m,b-m+1,e,0)]):(w.Assert(m===b+1,"originalStart should only be one more than originalEnd"),w.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const E=[0],h=[0],o=this.ComputeRecursionPoint(m,b,e,v,E,h,A),f=E[0],a=h[0];if(o!==null)return o;if(!A[0]){const i=this.ComputeDiffRecursive(m,f,e,a,A);let u=[];return A[0]?u=[new k.DiffChange(f+1,b-(f+1)+1,a+1,v-(a+1)+1)]:u=this.ComputeDiffRecursive(f+1,b,a+1,v,A),this.ConcatenateChanges(i,u)}return[new k.DiffChange(m,b-m+1,e,v-e+1)]}WALKTRACE(m,b,e,v,A,E,h,o,f,a,i,u,p,_,L,M,R,D){let F=null,y=null,S=new s,C=b,O=e,z=p[0]-M[0]-v,T=-1073741824,q=this.m_forwardHistory.length-1;do{const j=z+m;j===C||j<O&&f[j-1]<f[j+1]?(i=f[j+1],_=i-z-v,i<T&&S.MarkNextChange(),T=i,S.AddModifiedElement(i+1,_),z=j+1-m):(i=f[j-1]+1,_=i-z-v,i<T&&S.MarkNextChange(),T=i-1,S.AddOriginalElement(i,_+1),z=j-1-m),q>=0&&(f=this.m_forwardHistory[q],m=f[0],C=1,O=f.length-1)}while(--q>=-1);if(F=S.getReverseChanges(),D[0]){let j=p[0]+1,H=M[0]+1;if(F!==null&&F.length>0){const Y=F[F.length-1];j=Math.max(j,Y.getOriginalEnd()),H=Math.max(H,Y.getModifiedEnd())}y=[new k.DiffChange(j,u-j+1,H,L-H+1)]}else{S=new s,C=E,O=h,z=p[0]-M[0]-o,T=1073741824,q=R?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const j=z+A;j===C||j<O&&a[j-1]>=a[j+1]?(i=a[j+1]-1,_=i-z-o,i>T&&S.MarkNextChange(),T=i+1,S.AddOriginalElement(i+1,_+1),z=j+1-A):(i=a[j-1],_=i-z-o,i>T&&S.MarkNextChange(),T=i,S.AddModifiedElement(i+1,_+1),z=j-1-A),q>=0&&(a=this.m_reverseHistory[q],A=a[0],C=1,O=a.length-1)}while(--q>=-1);y=S.getChanges()}return this.ConcatenateChanges(F,y)}ComputeRecursionPoint(m,b,e,v,A,E,h){let o=0,f=0,a=0,i=0,u=0,p=0;m--,e--,A[0]=0,E[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const _=b-m+(v-e),L=_+1,M=new Int32Array(L),R=new Int32Array(L),D=v-e,F=b-m,y=m-e,S=b-v,O=(F-D)%2===0;M[D]=m,R[F]=b,h[0]=!1;for(let z=1;z<=_/2+1;z++){let T=0,q=0;a=this.ClipDiagonalBound(D-z,z,D,L),i=this.ClipDiagonalBound(D+z,z,D,L);for(let H=a;H<=i;H+=2){H===a||H<i&&M[H-1]<M[H+1]?o=M[H+1]:o=M[H-1]+1,f=o-(H-D)-y;const Y=o;for(;o<b&&f<v&&this.ElementsAreEqual(o+1,f+1);)o++,f++;if(M[H]=o,o+f>T+q&&(T=o,q=f),!O&&Math.abs(H-F)<=z-1&&o>=R[H])return A[0]=o,E[0]=f,Y<=R[H]&&1447>0&&z<=1447+1?this.WALKTRACE(D,a,i,y,F,u,p,S,M,R,o,b,A,f,v,E,O,h):null}const j=(T-m+(q-e)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(T,j))return h[0]=!0,A[0]=T,E[0]=q,j>0&&1447>0&&z<=1447+1?this.WALKTRACE(D,a,i,y,F,u,p,S,M,R,o,b,A,f,v,E,O,h):(m++,e++,[new k.DiffChange(m,b-m+1,e,v-e+1)]);u=this.ClipDiagonalBound(F-z,z,F,L),p=this.ClipDiagonalBound(F+z,z,F,L);for(let H=u;H<=p;H+=2){H===u||H<p&&R[H-1]>=R[H+1]?o=R[H+1]-1:o=R[H-1],f=o-(H-F)-S;const Y=o;for(;o>m&&f>e&&this.ElementsAreEqual(o,f);)o--,f--;if(R[H]=o,O&&Math.abs(H-D)<=z&&o<=M[H])return A[0]=o,E[0]=f,Y>=M[H]&&1447>0&&z<=1447+1?this.WALKTRACE(D,a,i,y,F,u,p,S,M,R,o,b,A,f,v,E,O,h):null}if(z<=1447){let H=new Int32Array(i-a+2);H[0]=D-a+1,d.Copy2(M,a,H,1,i-a+1),this.m_forwardHistory.push(H),H=new Int32Array(p-u+2),H[0]=F-u+1,d.Copy2(R,u,H,1,p-u+1),this.m_reverseHistory.push(H)}}return this.WALKTRACE(D,a,i,y,F,u,p,S,M,R,o,b,A,f,v,E,O,h)}PrettifyChanges(m){for(let b=0;b<m.length;b++){const e=m[b],v=b<m.length-1?m[b+1].originalStart:this._originalElementsOrHash.length,A=b<m.length-1?m[b+1].modifiedStart:this._modifiedElementsOrHash.length,E=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<v&&e.modifiedStart+e.modifiedLength<A&&(!E||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const f=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!f)break;e.originalStart++,e.modifiedStart++}const o=[null];if(b<m.length-1&&this.ChangesOverlap(m[b],m[b+1],o)){m[b]=o[0],m.splice(b+1,1),b--;continue}}for(let b=m.length-1;b>=0;b--){const e=m[b];let v=0,A=0;if(b>0){const i=m[b-1];v=i.originalStart+i.originalLength,A=i.modifiedStart+i.modifiedLength}const E=e.originalLength>0,h=e.modifiedLength>0;let o=0,f=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const u=e.originalStart-i,p=e.modifiedStart-i;if(u<v||p<A||E&&!this.OriginalElementsAreEqual(u,u+e.originalLength)||h&&!this.ModifiedElementsAreEqual(p,p+e.modifiedLength))break;const L=(u===v&&p===A?5:0)+this._boundaryScore(u,e.originalLength,p,e.modifiedLength);L>f&&(f=L,o=i)}e.originalStart-=o,e.modifiedStart-=o;const a=[null];if(b>0&&this.ChangesOverlap(m[b-1],m[b],a)){m[b-1]=a[0],m.splice(b,1),b++;continue}}if(this._hasStrings)for(let b=1,e=m.length;b<e;b++){const v=m[b-1],A=m[b],E=A.originalStart-v.originalStart-v.originalLength,h=v.originalStart,o=A.originalStart+A.originalLength,f=o-h,a=v.modifiedStart,i=A.modifiedStart+A.modifiedLength,u=i-a;if(E<5&&f<20&&u<20){const p=this._findBetterContiguousSequence(h,f,a,u,E);if(p){const[_,L]=p;(_!==v.originalStart+v.originalLength||L!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=_-v.originalStart,v.modifiedLength=L-v.modifiedStart,A.originalStart=_+E,A.modifiedStart=L+E,A.originalLength=o-A.originalStart,A.modifiedLength=i-A.modifiedStart)}}}return m}_findBetterContiguousSequence(m,b,e,v,A){if(b<A||v<A)return null;const E=m+b-A+1,h=e+v-A+1;let o=0,f=0,a=0;for(let i=m;i<E;i++)for(let u=e;u<h;u++){const p=this._contiguousSequenceScore(i,u,A);p>0&&p>o&&(o=p,f=i,a=u)}return o>0?[f,a]:null}_contiguousSequenceScore(m,b,e){let v=0;for(let A=0;A<e;A++){if(!this.ElementsAreEqual(m+A,b+A))return 0;v+=this._originalStringElements[m+A].length}return v}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,b){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(b>0){const e=m+b;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,b){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(b>0){const e=m+b;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(m,b,e,v){const A=this._OriginalRegionIsBoundary(m,b)?1:0,E=this._ModifiedRegionIsBoundary(e,v)?1:0;return A+E}ConcatenateChanges(m,b){const e=[];if(m.length===0||b.length===0)return b.length>0?b:m;if(this.ChangesOverlap(m[m.length-1],b[0],e)){const v=new Array(m.length+b.length-1);return d.Copy(m,0,v,0,m.length-1),v[m.length-1]=e[0],d.Copy(b,1,v,m.length,b.length-1),v}else{const v=new Array(m.length+b.length);return d.Copy(m,0,v,0,m.length),d.Copy(b,0,v,m.length,b.length),v}}ChangesOverlap(m,b,e){if(w.Assert(m.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),w.Assert(m.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=b.originalStart||m.modifiedStart+m.modifiedLength>=b.modifiedStart){const v=m.originalStart;let A=m.originalLength;const E=m.modifiedStart;let h=m.modifiedLength;return m.originalStart+m.originalLength>=b.originalStart&&(A=b.originalStart+b.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=b.modifiedStart&&(h=b.modifiedStart+b.modifiedLength-m.modifiedStart),e[0]=new k.DiffChange(v,A,E,h),!0}else return e[0]=null,!1}ClipDiagonalBound(m,b,e,v){if(m>=0&&m<v)return m;const A=e,E=v-e-1,h=b%2===0;if(m<0){const o=A%2===0;return h===o?0:1}else{const o=E%2===0;return h===o?v-1:v-2}}}t.LcsDiff=g}),te(ie[26],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function k(a){return typeof a=="string"}t.isString=k;function P(a){return Array.isArray(a)&&a.every(i=>k(i))}t.isStringArray=P;function r(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}t.isObject=r;function c(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}t.isTypedArray=c;function w(a){return typeof a=="number"&&!isNaN(a)}t.isNumber=w;function d(a){return!!a&&typeof a[Symbol.iterator]=="function"}t.isIterable=d;function l(a){return a===!0||a===!1}t.isBoolean=l;function s(a){return typeof a>"u"}t.isUndefined=s;function g(a){return!N(a)}t.isDefined=g;function N(a){return s(a)||a===null}t.isUndefinedOrNull=N;function m(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.assertType=m;function b(a){if(N(a))throw new Error("Assertion Failed: argument is undefined or null");return a}t.assertIsDefined=b;function e(...a){const i=[];for(let u=0;u<a.length;u++){const p=a[u];if(N(p))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);i.push(p)}return i}t.assertAllDefined=e;const v=Object.prototype.hasOwnProperty;function A(a){if(!r(a))return!1;for(const i in a)if(v.call(a,i))return!1;return!0}t.isEmptyObject=A;function E(a){return typeof a=="function"}t.isFunction=E;function h(...a){return a.length>0&&a.every(E)}t.areFunctions=h;function o(a,i){const u=Math.min(a.length,i.length);for(let p=0;p<u;p++)f(a[p],i[p])}t.validateConstraints=o;function f(a,i){if(k(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(E(i)){try{if(a instanceof i)return}catch{}if(!N(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=f}),te(ie[41],re([0,1,26]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const P=Object.create(null);function r(d,l){if((0,k.isString)(l)){const s=P[l];if(s===void 0)throw new Error(`${d} references an unknown codicon: ${l}`);l=s}return P[d]=l,{id:d}}function c(){return P}t.getCodiconFontCharacters=c;function w(){return Object.values(t.Codicon)}t.getAllCodicons=w,t.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ie[14],re([0,1,26]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const h=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([o,f])=>{h[o]=f&&typeof f=="object"?P(f):f}),h}t.deepClone=P;function r(E){if(!E||typeof E!="object")return E;const h=[E];for(;h.length>0;){const o=h.shift();Object.freeze(o);for(const f in o)if(c.call(o,f)){const a=o[f];typeof a=="object"&&!Object.isFrozen(a)&&!(0,k.isTypedArray)(a)&&h.push(a)}}return E}t.deepFreeze=r;const c=Object.prototype.hasOwnProperty;function w(E,h){return d(E,h,new Set)}t.cloneAndChange=w;function d(E,h,o){if((0,k.isUndefinedOrNull)(E))return E;const f=h(E);if(typeof f<"u")return f;if(Array.isArray(E)){const a=[];for(const i of E)a.push(d(i,h,o));return a}if((0,k.isObject)(E)){if(o.has(E))throw new Error("Cannot clone recursive data-structure");o.add(E);const a={};for(const i in E)c.call(E,i)&&(a[i]=d(E[i],h,o));return o.delete(E),a}return E}function l(E,h,o=!0){return(0,k.isObject)(E)?((0,k.isObject)(h)&&Object.keys(h).forEach(f=>{f in E?o&&((0,k.isObject)(E[f])&&(0,k.isObject)(h[f])?l(E[f],h[f],o):E[f]=h[f]):E[f]=h[f]}),E):h}t.mixin=l;function s(E,h){if(E===h)return!0;if(E==null||h===null||h===void 0||typeof E!=typeof h||typeof E!="object"||Array.isArray(E)!==Array.isArray(h))return!1;let o,f;if(Array.isArray(E)){if(E.length!==h.length)return!1;for(o=0;o<E.length;o++)if(!s(E[o],h[o]))return!1}else{const a=[];for(f in E)a.push(f);a.sort();const i=[];for(f in h)i.push(f);if(i.sort(),!s(a,i))return!1;for(o=0;o<a.length;o++)if(!s(E[a[o]],h[a[o]]))return!1}return!0}t.equals=s;function g(E){const h=new Set;return JSON.stringify(E,(o,f)=>{if((0,k.isObject)(f)||Array.isArray(f)){if(h.has(f))return"[Circular]";h.add(f)}return f})}t.safeStringify=g;function N(E,h){const o=Object.create(null);return!E||!h||Object.keys(h).forEach(a=>{const i=E[a],u=h[a];s(i,u)||(o[a]=u)}),o}t.distinct=N;function m(E,h){const o=h.toLowerCase(),f=Object.keys(E).find(a=>a.toLowerCase()===o);return f?E[f]:E[h]}t.getCaseInsensitive=m;function b(E,h){const o=Object.create(null);for(const[f,a]of Object.entries(E))h(f,a)&&(o[f]=a);return o}t.filter=b;function e(E){let h=[];for(;Object.prototype!==E;)h=h.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return h}t.getAllPropertyNames=e;function v(E){const h=[];for(const o of e(E))typeof E[o]=="function"&&h.push(o);return h}t.getAllMethodNames=v;function A(E,h){const o=a=>function(){const i=Array.prototype.slice.call(arguments,0);return h(a,i)},f={};for(const a of E)f[a]=o(a);return f}t.createProxyObject=A}),te(ie[27],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var k;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(t.Constants=k={}));function P(c){return c<0?0:c>255?255:c|0}t.toUint8=P;function r(c){return c<0?0:c>4294967295?4294967295:c|0}t.toUint32=r}),te(ie[28],re([0,1,27]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class P{constructor(d){const l=(0,k.toUint8)(d);this._defaultValue=l,this._asciiMap=P._createAsciiMap(l),this._map=new Map}static _createAsciiMap(d){const l=new Uint8Array(256);return l.fill(d),l}set(d,l){const s=(0,k.toUint8)(l);d>=0&&d<256?this._asciiMap[d]=s:this._map.set(d,s)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=P;var r;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(r||(r={}));class c{constructor(){this._actual=new P(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}clear(){return this._actual.clear()}}t.CharacterSet=c}),te(ie[4],re([0,1,3]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class P{static addRange(w,d){let l=0;for(;l<d.length&&d[l].endExclusive<w.start;)l++;let s=l;for(;s<d.length&&d[s].start<=w.endExclusive;)s++;if(l===s)d.splice(l,0,w);else{const g=Math.min(w.start,d[l].start),N=Math.max(w.endExclusive,d[s-1].endExclusive);d.splice(l,s-l,new P(g,N))}}static tryCreate(w,d){if(!(w>d))return new P(w,d)}static ofLength(w){return new P(0,w)}constructor(w,d){if(this.start=w,this.endExclusive=d,w>d)throw new k.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new P(this.start+w,this.endExclusive+w)}deltaStart(w){return new P(this.start+w,this.endExclusive)}deltaEnd(w){return new P(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new P(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const d=Math.max(this.start,w.start),l=Math.min(this.endExclusive,w.endExclusive);if(d<=l)return new P(d,l)}intersectsOrTouches(w){const d=Math.max(this.start,w.start),l=Math.min(this.endExclusive,w.endExclusive);return d<=l}slice(w){return w.slice(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new k.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new k.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const d=[];for(let l=this.start;l<this.endExclusive;l++)d.push(w(l));return d}forEach(w){for(let d=this.start;d<this.endExclusive;d++)w(d)}}t.OffsetRange=P;class r{constructor(){this._sortedRanges=[]}addRange(w){let d=0;for(;d<this._sortedRanges.length&&this._sortedRanges[d].endExclusive<w.start;)d++;let l=d;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=w.endExclusive;)l++;if(d===l)this._sortedRanges.splice(d,0,w);else{const s=Math.min(w.start,this._sortedRanges[d].start),g=Math.max(w.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(d,l-d,new P(s,g))}}toString(){return this._sortedRanges.map(w=>w.toString()).join(", ")}intersectsStrict(w){let d=0;for(;d<this._sortedRanges.length&&this._sortedRanges[d].endExclusive<=w.start;)d++;return d<this._sortedRanges.length&&this._sortedRanges[d].start<w.endExclusive}intersectWithRange(w){const d=new r;for(const l of this._sortedRanges){const s=l.intersect(w);s&&d.addRange(s)}return d}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this._sortedRanges.reduce((w,d)=>w+d.length,0)}}t.OffsetRangeSet=r}),te(ie[5],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class k{constructor(r,c){this.lineNumber=r,this.column=c}with(r=this.lineNumber,c=this.column){return r===this.lineNumber&&c===this.column?this:new k(r,c)}delta(r=0,c=0){return this.with(this.lineNumber+r,this.column+c)}equals(r){return k.equals(this,r)}static equals(r,c){return!r&&!c?!0:!!r&&!!c&&r.lineNumber===c.lineNumber&&r.column===c.column}isBefore(r){return k.isBefore(this,r)}static isBefore(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<c.column}isBeforeOrEqual(r){return k.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<=c.column}static compare(r,c){const w=r.lineNumber|0,d=c.lineNumber|0;if(w===d){const l=r.column|0,s=c.column|0;return l-s}return w-d}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new k(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.Position=k}),te(ie[2],re([0,1,5]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class P{constructor(c,w,d,l){c>d||c===d&&w>l?(this.startLineNumber=d,this.startColumn=l,this.endLineNumber=c,this.endColumn=w):(this.startLineNumber=c,this.startColumn=w,this.endLineNumber=d,this.endColumn=l)}isEmpty(){return P.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return P.containsPosition(this,c)}static containsPosition(c,w){return!(w.lineNumber<c.startLineNumber||w.lineNumber>c.endLineNumber||w.lineNumber===c.startLineNumber&&w.column<c.startColumn||w.lineNumber===c.endLineNumber&&w.column>c.endColumn)}static strictContainsPosition(c,w){return!(w.lineNumber<c.startLineNumber||w.lineNumber>c.endLineNumber||w.lineNumber===c.startLineNumber&&w.column<=c.startColumn||w.lineNumber===c.endLineNumber&&w.column>=c.endColumn)}containsRange(c){return P.containsRange(this,c)}static containsRange(c,w){return!(w.startLineNumber<c.startLineNumber||w.endLineNumber<c.startLineNumber||w.startLineNumber>c.endLineNumber||w.endLineNumber>c.endLineNumber||w.startLineNumber===c.startLineNumber&&w.startColumn<c.startColumn||w.endLineNumber===c.endLineNumber&&w.endColumn>c.endColumn)}strictContainsRange(c){return P.strictContainsRange(this,c)}static strictContainsRange(c,w){return!(w.startLineNumber<c.startLineNumber||w.endLineNumber<c.startLineNumber||w.startLineNumber>c.endLineNumber||w.endLineNumber>c.endLineNumber||w.startLineNumber===c.startLineNumber&&w.startColumn<=c.startColumn||w.endLineNumber===c.endLineNumber&&w.endColumn>=c.endColumn)}plusRange(c){return P.plusRange(this,c)}static plusRange(c,w){let d,l,s,g;return w.startLineNumber<c.startLineNumber?(d=w.startLineNumber,l=w.startColumn):w.startLineNumber===c.startLineNumber?(d=w.startLineNumber,l=Math.min(w.startColumn,c.startColumn)):(d=c.startLineNumber,l=c.startColumn),w.endLineNumber>c.endLineNumber?(s=w.endLineNumber,g=w.endColumn):w.endLineNumber===c.endLineNumber?(s=w.endLineNumber,g=Math.max(w.endColumn,c.endColumn)):(s=c.endLineNumber,g=c.endColumn),new P(d,l,s,g)}intersectRanges(c){return P.intersectRanges(this,c)}static intersectRanges(c,w){let d=c.startLineNumber,l=c.startColumn,s=c.endLineNumber,g=c.endColumn;const N=w.startLineNumber,m=w.startColumn,b=w.endLineNumber,e=w.endColumn;return d<N?(d=N,l=m):d===N&&(l=Math.max(l,m)),s>b?(s=b,g=e):s===b&&(g=Math.min(g,e)),d>s||d===s&&l>g?null:new P(d,l,s,g)}equalsRange(c){return P.equalsRange(this,c)}static equalsRange(c,w){return!c&&!w?!0:!!c&&!!w&&c.startLineNumber===w.startLineNumber&&c.startColumn===w.startColumn&&c.endLineNumber===w.endLineNumber&&c.endColumn===w.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(c){return new k.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(c){return new k.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,w){return new P(this.startLineNumber,this.startColumn,c,w)}setStartPosition(c,w){return new P(c,w,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(c){return new P(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(c){return new P(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new P(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,w=c){return new P(c.lineNumber,c.column,w.lineNumber,w.column)}static lift(c){return c?new P(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,w){return!(c.endLineNumber<w.startLineNumber||c.endLineNumber===w.startLineNumber&&c.endColumn<w.startColumn||w.endLineNumber<c.startLineNumber||w.endLineNumber===c.startLineNumber&&w.endColumn<c.startColumn)}static areIntersecting(c,w){return!(c.endLineNumber<w.startLineNumber||c.endLineNumber===w.startLineNumber&&c.endColumn<=w.startColumn||w.endLineNumber<c.startLineNumber||w.endLineNumber===c.startLineNumber&&w.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,w){if(c&&w){const s=c.startLineNumber|0,g=w.startLineNumber|0;if(s===g){const N=c.startColumn|0,m=w.startColumn|0;if(N===m){const b=c.endLineNumber|0,e=w.endLineNumber|0;if(b===e){const v=c.endColumn|0,A=w.endColumn|0;return v-A}return b-e}return N-m}return s-g}return(c?1:0)-(w?1:0)}static compareRangesUsingEnds(c,w){return c.endLineNumber===w.endLineNumber?c.endColumn===w.endColumn?c.startLineNumber===w.startLineNumber?c.startColumn-w.startColumn:c.startLineNumber-w.startLineNumber:c.endColumn-w.endColumn:c.endLineNumber-w.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.Range=P}),te(ie[42],re([0,1,2]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class P{static insert(c,w){return{range:new k.Range(c.lineNumber,c.column,c.lineNumber,c.column),text:w,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,w){return{range:c,text:w}}static replaceMove(c,w){return{range:c,text:w,forceMoveMarkers:!0}}}t.EditOperation=P}),te(ie[12],re([0,1,3,4,2,9]),function(B,t,k,P,r,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class w{static fromRange(s){return new w(s.startLineNumber,s.endLineNumber)}static subtract(s,g){return g?s.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<s.endLineNumberExclusive?[new w(s.startLineNumber,g.startLineNumber),new w(g.endLineNumberExclusive,s.endLineNumberExclusive)]:g.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<s.endLineNumberExclusive?[new w(Math.max(g.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new w(s.startLineNumber,Math.min(g.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let g=new d(s[0].slice());for(let N=1;N<s.length;N++)g=g.getUnion(new d(s[N].slice()));return g.ranges}static ofLength(s,g){return new w(s,s+g)}static deserialize(s){return new w(s[0],s[1])}constructor(s,g){if(s>g)throw new k.BugIndicatingError(`startLineNumber ${s} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=s,this.endLineNumberExclusive=g}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new w(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new w(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new w(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const g=Math.max(this.startLineNumber,s.startLineNumber),N=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(g<=N)return new w(g,N)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const g=[];for(let N=this.startLineNumber;N<this.endLineNumberExclusive;N++)g.push(s(N));return g}forEach(s){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)s(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new P.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=w;class d{constructor(s=[]){this._normalizedRanges=s}get ranges(){return this._normalizedRanges}addRange(s){if(s.length===0)return;const g=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,m=>m.endLineNumberExclusive>=s.startLineNumber),N=(0,c.findLastIdxMonotonous)(this._normalizedRanges,m=>m.startLineNumber<=s.endLineNumberExclusive)+1;if(g===N)this._normalizedRanges.splice(g,0,s);else if(g===N-1){const m=this._normalizedRanges[g];this._normalizedRanges[g]=m.join(s)}else{const m=this._normalizedRanges[g].join(this._normalizedRanges[N-1]).join(s);this._normalizedRanges.splice(g,N-g,m)}}contains(s){const g=(0,c.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<=s);return!!g&&g.endLineNumberExclusive>s}intersects(s){const g=(0,c.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<s.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this._normalizedRanges.length===0)return s;if(s._normalizedRanges.length===0)return this;const g=[];let N=0,m=0,b=null;for(;N<this._normalizedRanges.length||m<s._normalizedRanges.length;){let e=null;if(N<this._normalizedRanges.length&&m<s._normalizedRanges.length){const v=this._normalizedRanges[N],A=s._normalizedRanges[m];v.startLineNumber<A.startLineNumber?(e=v,N++):(e=A,m++)}else N<this._normalizedRanges.length?(e=this._normalizedRanges[N],N++):(e=s._normalizedRanges[m],m++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new w(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(b),b=e)}return b!==null&&g.push(b),new d(g)}subtractFrom(s){const g=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=s.startLineNumber),N=(0,c.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(g===N)return new d([s]);const m=[];let b=s.startLineNumber;for(let e=g;e<N;e++){const v=this._normalizedRanges[e];v.startLineNumber>b&&m.push(new w(b,v.startLineNumber)),b=v.endLineNumberExclusive}return b<s.endLineNumberExclusive&&m.push(new w(b,s.endLineNumberExclusive)),new d(m)}toString(){return this._normalizedRanges.map(s=>s.toString()).join(", ")}getIntersection(s){const g=[];let N=0,m=0;for(;N<this._normalizedRanges.length&&m<s._normalizedRanges.length;){const b=this._normalizedRanges[N],e=s._normalizedRanges[m],v=b.intersect(e);v&&!v.isEmpty&&g.push(v),b.endLineNumberExclusive<e.endLineNumberExclusive?N++:m++}return new d(g)}getWithDelta(s){return new d(this._normalizedRanges.map(g=>g.delta(s)))}}t.LineRangeSet=d}),te(ie[43],re([0,1,5,2]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var r;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class c extends P.Range{constructor(d,l,s,g){super(d,l,s,g),this.selectionStartLineNumber=d,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return c.selectionsEqual(this,d)}static selectionsEqual(d,l){return d.selectionStartLineNumber===l.selectionStartLineNumber&&d.selectionStartColumn===l.selectionStartColumn&&d.positionLineNumber===l.positionLineNumber&&d.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,l){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,d,l):new c(d,l,this.startLineNumber,this.startColumn)}getPosition(){return new k.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,l){return this.getDirection()===0?new c(d,l,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,d,l)}static fromPositions(d,l=d){return new c(d.lineNumber,d.column,l.lineNumber,l.column)}static fromRange(d,l){return l===0?new c(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new c(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new c(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,l){if(d&&!l||!d&&l)return!1;if(!d&&!l)return!0;if(d.length!==l.length)return!1;for(let s=0,g=d.length;s<g;s++)if(!this.selectionsEqual(d[s],l[s]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,l,s,g,N){return N===0?new c(d,l,s,g):new c(s,g,d,l)}}t.Selection=c}),te(ie[44],re([0,1,28]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var P;(function(w){w[w.Regular=0]="Regular",w[w.Whitespace=1]="Whitespace",w[w.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class r extends k.CharacterClassifier{constructor(d){super(0);for(let l=0,s=d.length;l<s;l++)this.set(d.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=r;function c(w){const d={};return l=>(d.hasOwnProperty(l)||(d[l]=w(l)),d[l])}t.getMapForWordSeparators=c(w=>new r(w))}),te(ie[29],re([0,1,20,10,21]),function(B,t,k,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(N=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.USUAL_WORD_SEPARATORS)N.indexOf(b)>=0||(m+="\\"+b);return m+="\\s]+)",new RegExp(m,"g")}t.DEFAULT_WORD_REGEXP=c();function w(N){let m=t.DEFAULT_WORD_REGEXP;if(N&&N instanceof RegExp)if(N.global)m=N;else{let b="g";N.ignoreCase&&(b+="i"),N.multiline&&(b+="m"),N.unicode&&(b+="u"),m=new RegExp(N.source,b)}return m.lastIndex=0,m}t.ensureValidWordDefinition=w;const d=new r.LinkedList;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(N){const m=d.unshift(N);return(0,P.toDisposable)(m)}t.setDefaultGetWordAtTextConfig=l;function s(N,m,b,e,v){if(v||(v=k.Iterable.first(d)),b.length>v.maxLen){let f=N-v.maxLen/2;return f<0?f=0:e+=f,b=b.substring(f,N+v.maxLen/2),s(N,m,b,e,v)}const A=Date.now(),E=N-1-e;let h=-1,o=null;for(let f=1;!(Date.now()-A>=v.timeBudget);f++){const a=E-v.windowSize*f;m.lastIndex=Math.max(0,a);const i=g(m,b,E,h);if(!i&&o||(o=i,a<=0))break;h=a}if(o){const f={word:o[0],startColumn:e+1+o.index,endColumn:e+1+o.index+o[0].length};return m.lastIndex=0,f}return null}t.getWordAtText=s;function g(N,m,b,e){let v;for(;v=N.exec(m);){const A=v.index||0;if(A<=b&&N.lastIndex>=b)return v;if(e>0&&A>e)return null}return null}}),te(ie[8],re([0,1,6,3,4]),function(B,t,k,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class c{static trivial(N,m){return new c([new w(r.OffsetRange.ofLength(N.length),r.OffsetRange.ofLength(m.length))],!1)}static trivialTimedOut(N,m){return new c([new w(r.OffsetRange.ofLength(N.length),r.OffsetRange.ofLength(m.length))],!0)}constructor(N,m){this.diffs=N,this.hitTimeout=m}}t.DiffAlgorithmResult=c;class w{static invert(N,m){const b=[];return(0,k.forEachAdjacent)(N,(e,v)=>{b.push(w.fromOffsetPairs(e?e.getEndExclusives():d.zero,v?v.getStarts():new d(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),b}static fromOffsetPairs(N,m){return new w(new r.OffsetRange(N.offset1,m.offset1),new r.OffsetRange(N.offset2,m.offset2))}constructor(N,m){this.seq1Range=N,this.seq2Range=m}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(N){return new w(this.seq1Range.join(N.seq1Range),this.seq2Range.join(N.seq2Range))}delta(N){return N===0?this:new w(this.seq1Range.delta(N),this.seq2Range.delta(N))}deltaStart(N){return N===0?this:new w(this.seq1Range.deltaStart(N),this.seq2Range.deltaStart(N))}deltaEnd(N){return N===0?this:new w(this.seq1Range.deltaEnd(N),this.seq2Range.deltaEnd(N))}intersectsOrTouches(N){return this.seq1Range.intersectsOrTouches(N.seq1Range)||this.seq2Range.intersectsOrTouches(N.seq2Range)}intersect(N){const m=this.seq1Range.intersect(N.seq1Range),b=this.seq2Range.intersect(N.seq2Range);if(!(!m||!b))return new w(m,b)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=w;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(N,m){this.offset1=N,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.OffsetPair=d;class l{static{this.instance=new l}isValid(){return!0}}t.InfiniteTimeout=l;class s{constructor(N){if(this.timeout=N,this.startTime=Date.now(),this.valid=!0,N<=0)throw new P.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=s}),te(ie[30],re([0,1,4,8]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class r{compute(s,g,N=P.InfiniteTimeout.instance){if(s.length===0||g.length===0)return P.DiffAlgorithmResult.trivial(s,g);const m=s,b=g;function e(u,p){for(;u<m.length&&p<b.length&&m.getElement(u)===b.getElement(p);)u++,p++;return u}let v=0;const A=new w;A.set(0,e(0,0));const E=new d;E.set(0,A.get(0)===0?null:new c(null,0,0,A.get(0)));let h=0;e:for(;;){if(v++,!N.isValid())return P.DiffAlgorithmResult.trivialTimedOut(m,b);const u=-Math.min(v,b.length+v%2),p=Math.min(v,m.length+v%2);for(h=u;h<=p;h+=2){let _=0;const L=h===p?-1:A.get(h+1),M=h===u?-1:A.get(h-1)+1;_++;const R=Math.min(Math.max(L,M),m.length),D=R-h;if(_++,R>m.length||D>b.length)continue;const F=e(R,D);A.set(h,F);const y=R===L?E.get(h+1):E.get(h-1);if(E.set(h,F!==R?new c(y,R,D,F-R):y),A.get(h)===m.length&&A.get(h)-h===b.length)break e}}let o=E.get(h);const f=[];let a=m.length,i=b.length;for(;;){const u=o?o.x+o.length:0,p=o?o.y+o.length:0;if((u!==a||p!==i)&&f.push(new P.SequenceDiff(new k.OffsetRange(u,a),new k.OffsetRange(p,i))),!o)break;a=o.x,i=o.y,o=o.prev}return f.reverse(),new P.DiffAlgorithmResult(f,!1)}}t.MyersDiffAlgorithm=r;class c{constructor(s,g,N,m){this.prev=s,this.x=g,this.y=N,this.length=m}}class w{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,g){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const N=this.negativeArr;this.negativeArr=new Int32Array(N.length*2),this.negativeArr.set(N)}this.negativeArr[s]=g}else{if(s>=this.positiveArr.length){const N=this.positiveArr;this.positiveArr=new Int32Array(N.length*2),this.positiveArr.set(N)}this.positiveArr[s]=g}}}class d{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,g){s<0?(s=-s-1,this.negativeArr[s]=g):this.positiveArr[s]=g}}}),te(ie[45],re([0,1,6,4,8]),function(B,t,k,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeVeryShortMatchingTextBetweenLongDiffs=t.removeVeryShortMatchingLinesBetweenDiffs=t.extendDiffsToEntireWordIfAppropriate=t.removeShortMatches=t.optimizeSequenceDiffs=void 0;function c(e,v,A){let E=A;return E=w(e,v,E),E=d(e,v,E),E}t.optimizeSequenceDiffs=c;function w(e,v,A){if(A.length===0)return A;const E=[];E.push(A[0]);for(let o=1;o<A.length;o++){const f=E[E.length-1];let a=A[o];if(a.seq1Range.isEmpty||a.seq2Range.isEmpty){const i=a.seq1Range.start-f.seq1Range.endExclusive;let u;for(u=1;u<=i&&!(e.getElement(a.seq1Range.start-u)!==e.getElement(a.seq1Range.endExclusive-u)||v.getElement(a.seq2Range.start-u)!==v.getElement(a.seq2Range.endExclusive-u));u++);if(u--,u===i){E[E.length-1]=new r.SequenceDiff(new P.OffsetRange(f.seq1Range.start,a.seq1Range.endExclusive-i),new P.OffsetRange(f.seq2Range.start,a.seq2Range.endExclusive-i));continue}a=a.delta(-u)}E.push(a)}const h=[];for(let o=0;o<E.length-1;o++){const f=E[o+1];let a=E[o];if(a.seq1Range.isEmpty||a.seq2Range.isEmpty){const i=f.seq1Range.start-a.seq1Range.endExclusive;let u;for(u=0;u<i&&!(!e.isStronglyEqual(a.seq1Range.start+u,a.seq1Range.endExclusive+u)||!v.isStronglyEqual(a.seq2Range.start+u,a.seq2Range.endExclusive+u));u++);if(u===i){E[o+1]=new r.SequenceDiff(new P.OffsetRange(a.seq1Range.start+i,f.seq1Range.endExclusive),new P.OffsetRange(a.seq2Range.start+i,f.seq2Range.endExclusive));continue}u>0&&(a=a.delta(u))}h.push(a)}return E.length>0&&h.push(E[E.length-1]),h}function d(e,v,A){if(!e.getBoundaryScore||!v.getBoundaryScore)return A;for(let E=0;E<A.length;E++){const h=E>0?A[E-1]:void 0,o=A[E],f=E+1<A.length?A[E+1]:void 0,a=new P.OffsetRange(h?h.seq1Range.start+1:0,f?f.seq1Range.endExclusive-1:e.length),i=new P.OffsetRange(h?h.seq2Range.start+1:0,f?f.seq2Range.endExclusive-1:v.length);o.seq1Range.isEmpty?A[E]=l(o,e,v,a,i):o.seq2Range.isEmpty&&(A[E]=l(o.swap(),v,e,i,a).swap())}return A}function l(e,v,A,E,h){let f=1;for(;e.seq1Range.start-f>=E.start&&e.seq2Range.start-f>=h.start&&A.isStronglyEqual(e.seq2Range.start-f,e.seq2Range.endExclusive-f)&&f<100;)f++;f--;let a=0;for(;e.seq1Range.start+a<E.endExclusive&&e.seq2Range.endExclusive+a<h.endExclusive&&A.isStronglyEqual(e.seq2Range.start+a,e.seq2Range.endExclusive+a)&&a<100;)a++;if(f===0&&a===0)return e;let i=0,u=-1;for(let p=-f;p<=a;p++){const _=e.seq2Range.start+p,L=e.seq2Range.endExclusive+p,M=e.seq1Range.start+p,R=v.getBoundaryScore(M)+A.getBoundaryScore(_)+A.getBoundaryScore(L);R>u&&(u=R,i=p)}return e.delta(i)}function s(e,v,A){const E=[];for(const h of A){const o=E[E.length-1];if(!o){E.push(h);continue}h.seq1Range.start-o.seq1Range.endExclusive<=2||h.seq2Range.start-o.seq2Range.endExclusive<=2?E[E.length-1]=new r.SequenceDiff(o.seq1Range.join(h.seq1Range),o.seq2Range.join(h.seq2Range)):E.push(h)}return E}t.removeShortMatches=s;function g(e,v,A){const E=[];let h;function o(){if(!h)return;const a=h.s1Range.length-h.deleted,i=h.s2Range.length-h.added;Math.max(h.deleted,h.added)+(h.count-1)>a&&E.push(new r.SequenceDiff(h.s1Range,h.s2Range)),h=void 0}for(const a of A){let i=function(M,R){if(!h||!h.s1Range.containsRange(M)||!h.s2Range.containsRange(R))if(h&&!(h.s1Range.endExclusive<M.start&&h.s2Range.endExclusive<R.start)){const y=P.OffsetRange.tryCreate(h.s1Range.endExclusive,M.start),S=P.OffsetRange.tryCreate(h.s2Range.endExclusive,R.start);h.deleted+=y?.length??0,h.added+=S?.length??0,h.s1Range=h.s1Range.join(M),h.s2Range=h.s2Range.join(R)}else o(),h={added:0,deleted:0,count:0,s1Range:M,s2Range:R};const D=M.intersect(a.seq1Range),F=R.intersect(a.seq2Range);h.count++,h.deleted+=D?.length??0,h.added+=F?.length??0};const u=e.findWordContaining(a.seq1Range.start-1),p=v.findWordContaining(a.seq2Range.start-1),_=e.findWordContaining(a.seq1Range.endExclusive),L=v.findWordContaining(a.seq2Range.endExclusive);u&&_&&p&&L&&u.equals(_)&&p.equals(L)?i(u,p):(u&&p&&i(u,p),_&&L&&i(_,L))}return o(),N(A,E)}t.extendDiffsToEntireWordIfAppropriate=g;function N(e,v){const A=[];for(;e.length>0||v.length>0;){const E=e[0],h=v[0];let o;E&&(!h||E.seq1Range.start<h.seq1Range.start)?o=e.shift():o=v.shift(),A.length>0&&A[A.length-1].seq1Range.endExclusive>=o.seq1Range.start?A[A.length-1]=A[A.length-1].join(o):A.push(o)}return A}function m(e,v,A){let E=A;if(E.length===0)return E;let h=0,o;do{o=!1;const f=[E[0]];for(let a=1;a<E.length;a++){let p=function(L,M){const R=new P.OffsetRange(u.seq1Range.endExclusive,i.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(L.seq1Range.length+L.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=E[a],u=f[f.length-1];p(u,i)?(o=!0,f[f.length-1]=f[f.length-1].join(i)):f.push(i)}E=f}while(h++<10&&o);return E}t.removeVeryShortMatchingLinesBetweenDiffs=m;function b(e,v,A){let E=A;if(E.length===0)return E;let h=0,o;do{o=!1;const a=[E[0]];for(let i=1;i<E.length;i++){let _=function(M,R){const D=new P.OffsetRange(p.seq1Range.endExclusive,u.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const y=e.getText(D).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(M.seq1Range),C=M.seq1Range.length,O=v.countLinesIn(M.seq2Range),z=M.seq2Range.length,T=e.countLinesIn(R.seq1Range),q=R.seq1Range.length,j=v.countLinesIn(R.seq2Range),H=R.seq2Range.length,Y=2*40+50;function n(ne){return Math.min(ne,Y)}return Math.pow(Math.pow(n(S*40+C),1.5)+Math.pow(n(O*40+z),1.5),1.5)+Math.pow(Math.pow(n(T*40+q),1.5)+Math.pow(n(j*40+H),1.5),1.5)>(Y**1.5)**1.5*1.3};const u=E[i],p=a[a.length-1];_(p,u)?(o=!0,a[a.length-1]=a[a.length-1].join(u)):a.push(u)}E=a}while(h++<10&&o);const f=[];return(0,k.forEachWithNeighbors)(E,(a,i,u)=>{let p=i;function _(y){return y.length>0&&y.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const L=e.extendToFullLines(i.seq1Range),M=e.getText(new P.OffsetRange(L.start,i.seq1Range.start));_(M)&&(p=p.deltaStart(-M.length));const R=e.getText(new P.OffsetRange(i.seq1Range.endExclusive,L.endExclusive));_(R)&&(p=p.deltaEnd(R.length));const D=r.SequenceDiff.fromOffsetPairs(a?a.getEndExclusives():r.OffsetPair.zero,u?u.getStarts():r.OffsetPair.max),F=p.intersect(D);f.push(F)}),f}t.removeVeryShortMatchingTextBetweenLongDiffs=b}),te(ie[46],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class k{constructor(c,w){this.trimmedHash=c,this.lines=w}getElement(c){return this.trimmedHash[c]}get length(){return this.trimmedHash.length}getBoundaryScore(c){const w=c===0?0:P(this.lines[c-1]),d=c===this.lines.length?0:P(this.lines[c]);return 1e3-(w+d)}getText(c){return this.lines.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,w){return this.lines[c]===this.lines[w]}}t.LineSequence=k;function P(r){let c=0;for(;c<r.length&&(r.charCodeAt(c)===32||r.charCodeAt(c)===9);)c++;return c}}),te(ie[15],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.isSpace=t.Array2D=void 0;class k{constructor(w,d){this.width=w,this.height=d,this.array=[],this.array=new Array(w*d)}get(w,d){return this.array[w+d*this.width]}set(w,d,l){this.array[w+d*this.width]=l}}t.Array2D=k;function P(c){return c===32||c===9}t.isSpace=P;class r{static{this.chrKeys=new Map}static getKey(w){let d=this.chrKeys.get(w);return d===void 0&&(d=this.chrKeys.size,this.chrKeys.set(w,d)),d}constructor(w,d,l){this.range=w,this.lines=d,this.source=l,this.histogram=[];let s=0;for(let g=w.startLineNumber-1;g<w.endLineNumberExclusive-1;g++){const N=d[g];for(let b=0;b<N.length;b++){s++;const e=N[b],v=r.getKey(e);this.histogram[v]=(this.histogram[v]||0)+1}s++;const m=r.getKey(`
`);this.histogram[m]=(this.histogram[m]||0)+1}this.totalCount=s}computeSimilarity(w){let d=0;const l=Math.max(this.histogram.length,w.histogram.length);for(let s=0;s<l;s++)d+=Math.abs((this.histogram[s]??0)-(w.histogram[s]??0));return 1-d/(this.totalCount+w.totalCount)}}t.LineRangeFragment=r}),te(ie[47],re([0,1,4,8,15]),function(B,t,k,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class c{compute(d,l,s=P.InfiniteTimeout.instance,g){if(d.length===0||l.length===0)return P.DiffAlgorithmResult.trivial(d,l);const N=new r.Array2D(d.length,l.length),m=new r.Array2D(d.length,l.length),b=new r.Array2D(d.length,l.length);for(let f=0;f<d.length;f++)for(let a=0;a<l.length;a++){if(!s.isValid())return P.DiffAlgorithmResult.trivialTimedOut(d,l);const i=f===0?0:N.get(f-1,a),u=a===0?0:N.get(f,a-1);let p;d.getElement(f)===l.getElement(a)?(f===0||a===0?p=0:p=N.get(f-1,a-1),f>0&&a>0&&m.get(f-1,a-1)===3&&(p+=b.get(f-1,a-1)),p+=g?g(f,a):1):p=-1;const _=Math.max(i,u,p);if(_===p){const L=f>0&&a>0?b.get(f-1,a-1):0;b.set(f,a,L+1),m.set(f,a,3)}else _===i?(b.set(f,a,0),m.set(f,a,1)):_===u&&(b.set(f,a,0),m.set(f,a,2));N.set(f,a,_)}const e=[];let v=d.length,A=l.length;function E(f,a){(f+1!==v||a+1!==A)&&e.push(new P.SequenceDiff(new k.OffsetRange(f+1,v),new k.OffsetRange(a+1,A))),v=f,A=a}let h=d.length-1,o=l.length-1;for(;h>=0&&o>=0;)m.get(h,o)===3?(E(h,o),h--,o--):m.get(h,o)===1?h--:o--;return E(-1,-1),e.reverse(),new P.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=c}),te(ie[31],re([0,1,9,4,5,2,15]),function(B,t,k,P,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class d{constructor(e,v,A){this.lines=e,this.considerWhitespaceChanges=A,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let E=!1;v.start>0&&v.endExclusive>=e.length&&(v=new P.OffsetRange(v.start-1,v.endExclusive),E=!0),this.lineRange=v,this.firstCharOffsetByLine[0]=0;for(let h=this.lineRange.start;h<this.lineRange.endExclusive;h++){let o=e[h],f=0;if(E)f=o.length,o="",E=!1;else if(!A){const a=o.trimStart();f=o.length-a.length,o=a.trimEnd()}this.additionalOffsetByLine.push(f);for(let a=0;a<o.length;a++)this.elements.push(o.charCodeAt(a));h<e.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[h-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new P.OffsetRange(0,this.length))}getText(e){return this.elements.slice(e.start,e.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(e){return this.elements[e]}get length(){return this.elements.length}getBoundaryScore(e){const v=m(e>0?this.elements[e-1]:-1),A=m(e<this.elements.length?this.elements[e]:-1);if(v===6&&A===7)return 0;let E=0;return v!==A&&(E+=10,v===0&&A===1&&(E+=1)),E+=N(v),E+=N(A),E}translateOffset(e){if(this.lineRange.isEmpty)return new r.Position(this.lineRange.start+1,1);const v=(0,k.findLastIdxMonotonous)(this.firstCharOffsetByLine,A=>A<=e);return new r.Position(this.lineRange.start+v+1,e-this.firstCharOffsetByLine[v]+this.additionalOffsetByLine[v]+1)}translateRange(e){return c.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.elements.length||!l(this.elements[e]))return;let v=e;for(;v>0&&l(this.elements[v-1]);)v--;let A=e;for(;A<this.elements.length&&l(this.elements[A]);)A++;return new P.OffsetRange(v,A)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,v){return this.elements[e]===this.elements[v]}extendToFullLines(e){const v=(0,k.findLastMonotonous)(this.firstCharOffsetByLine,E=>E<=e.start)??0,A=(0,k.findFirstMonotonous)(this.firstCharOffsetByLine,E=>e.endExclusive<=E)??this.elements.length;return new P.OffsetRange(v,A)}}t.LinesSliceCharSequence=d;function l(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var s;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Space=5]="Space",b[b.LineBreakCR=6]="LineBreakCR",b[b.LineBreakLF=7]="LineBreakLF"})(s||(s={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function N(b){return g[b]}function m(b){return b===10?7:b===13?6:(0,w.isSpace)(b)?5:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:4}}),te(ie[32],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class k{constructor(c,w,d){this.changes=c,this.moves=w,this.hitTimeout=d}}t.LinesDiff=k;class P{constructor(c,w){this.lineRangeMapping=c,this.changes=w}flip(){return new P(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.MovedText=P}),te(ie[16],re([0,1,12]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class P{static inverse(d,l,s){const g=[];let N=1,m=1;for(const e of d){const v=new r(new k.LineRange(N,e.original.startLineNumber),new k.LineRange(m,e.modified.startLineNumber),void 0);v.modified.isEmpty||g.push(v),N=e.original.endLineNumberExclusive,m=e.modified.endLineNumberExclusive}const b=new r(new k.LineRange(N,l+1),new k.LineRange(m,s+1),void 0);return b.modified.isEmpty||g.push(b),g}constructor(d,l){this.original=d,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new P(this.modified,this.original)}join(d){return new P(this.original.join(d.original),this.modified.join(d.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.LineRangeMapping=P;class r extends P{constructor(d,l,s){super(d,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(d=>d.flip()))}}t.DetailedLineRangeMapping=r;class c{constructor(d,l){this.originalRange=d,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}t.RangeMapping=c}),te(ie[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(B,t,k,P,r,c,w,d,l,s,g,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=void 0;function m(h,o,f,a,i,u){let{moves:p,excludedChanges:_}=b(h,o,f,u);if(!u.isValid())return[];const L=h.filter(R=>!_.has(R)),M=e(L,a,i,o,f,u);return(0,r.pushMany)(p,M),p=A(p),p=p.filter(R=>R.original.toOffsetRange().slice(o).map(F=>F.trim()).join(`
`).length>=10),p=E(h,p),p}t.computeMovedLines=m;function b(h,o,f,a){const i=[],u=h.filter(L=>L.modified.isEmpty&&L.original.length>=3).map(L=>new g.LineRangeFragment(L.original,o,L)),p=new Set(h.filter(L=>L.original.isEmpty&&L.modified.length>=3).map(L=>new g.LineRangeFragment(L.modified,f,L))),_=new Set;for(const L of u){let M=-1,R;for(const D of p){const F=L.computeSimilarity(D);F>M&&(M=F,R=D)}if(M>.9&&R&&(p.delete(R),i.push(new P.LineRangeMapping(L.range,R.range)),_.add(L.source),_.add(R.source)),!a.isValid())return{moves:i,excludedChanges:_}}return{moves:i,excludedChanges:_}}function e(h,o,f,a,i,u){const p=[],_=new w.SetMap;for(const F of h)for(let y=F.original.startLineNumber;y<F.original.endLineNumberExclusive-2;y++){const S=`${o[y-1]}:${o[y+1-1]}:${o[y+2-1]}`;_.add(S,{range:new d.LineRange(y,y+3)})}const L=[];h.sort((0,r.compareBy)(F=>F.modified.startLineNumber,r.numberComparator));for(const F of h){let y=[];for(let S=F.modified.startLineNumber;S<F.modified.endLineNumberExclusive-2;S++){const C=`${f[S-1]}:${f[S+1-1]}:${f[S+2-1]}`,O=new d.LineRange(S,S+3),z=[];_.forEach(C,({range:T})=>{for(const j of y)if(j.originalLineRange.endLineNumberExclusive+1===T.endLineNumberExclusive&&j.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){j.originalLineRange=new d.LineRange(j.originalLineRange.startLineNumber,T.endLineNumberExclusive),j.modifiedLineRange=new d.LineRange(j.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),z.push(j);return}const q={modifiedLineRange:O,originalLineRange:T};L.push(q),z.push(q)}),y=z}if(!u.isValid())return[]}L.sort((0,r.reverseOrder)((0,r.compareBy)(F=>F.modifiedLineRange.length,r.numberComparator)));const M=new d.LineRangeSet,R=new d.LineRangeSet;for(const F of L){const y=F.modifiedLineRange.startLineNumber-F.originalLineRange.startLineNumber,S=M.subtractFrom(F.modifiedLineRange),C=R.subtractFrom(F.originalLineRange).getWithDelta(y),O=S.getIntersection(C);for(const z of O.ranges){if(z.length<3)continue;const T=z,q=z.delta(-y);p.push(new P.LineRangeMapping(q,T)),M.addRange(T),R.addRange(q)}}p.sort((0,r.compareBy)(F=>F.original.startLineNumber,r.numberComparator));const D=new c.MonotonousArray(h);for(let F=0;F<p.length;F++){const y=p[F],S=D.findLastMonotonous(Y=>Y.original.startLineNumber<=y.original.startLineNumber),C=(0,c.findLastMonotonous)(h,Y=>Y.modified.startLineNumber<=y.modified.startLineNumber),O=Math.max(y.original.startLineNumber-S.original.startLineNumber,y.modified.startLineNumber-C.modified.startLineNumber),z=D.findLastMonotonous(Y=>Y.original.startLineNumber<y.original.endLineNumberExclusive),T=(0,c.findLastMonotonous)(h,Y=>Y.modified.startLineNumber<y.modified.endLineNumberExclusive),q=Math.max(z.original.endLineNumberExclusive-y.original.endLineNumberExclusive,T.modified.endLineNumberExclusive-y.modified.endLineNumberExclusive);let j;for(j=0;j<O;j++){const Y=y.original.startLineNumber-j-1,n=y.modified.startLineNumber-j-1;if(Y>a.length||n>i.length||M.contains(n)||R.contains(Y)||!v(a[Y-1],i[n-1],u))break}j>0&&(R.addRange(new d.LineRange(y.original.startLineNumber-j,y.original.startLineNumber)),M.addRange(new d.LineRange(y.modified.startLineNumber-j,y.modified.startLineNumber)));let H;for(H=0;H<q;H++){const Y=y.original.endLineNumberExclusive+H,n=y.modified.endLineNumberExclusive+H;if(Y>a.length||n>i.length||M.contains(n)||R.contains(Y)||!v(a[Y-1],i[n-1],u))break}H>0&&(R.addRange(new d.LineRange(y.original.endLineNumberExclusive,y.original.endLineNumberExclusive+H)),M.addRange(new d.LineRange(y.modified.endLineNumberExclusive,y.modified.endLineNumberExclusive+H))),(j>0||H>0)&&(p[F]=new P.LineRangeMapping(new d.LineRange(y.original.startLineNumber-j,y.original.endLineNumberExclusive+H),new d.LineRange(y.modified.startLineNumber-j,y.modified.endLineNumberExclusive+H)))}return p}function v(h,o,f){if(h.trim()===o.trim())return!0;if(h.length>300&&o.length>300)return!1;const i=new N.MyersDiffAlgorithm().compute(new s.LinesSliceCharSequence([h],new l.OffsetRange(0,1),!1),new s.LinesSliceCharSequence([o],new l.OffsetRange(0,1),!1),f);let u=0;const p=k.SequenceDiff.invert(i.diffs,h.length);for(const R of p)R.seq1Range.forEach(D=>{(0,g.isSpace)(h.charCodeAt(D))||u++});function _(R){let D=0;for(let F=0;F<h.length;F++)(0,g.isSpace)(R.charCodeAt(F))||D++;return D}const L=_(h.length>o.length?h:o);return u/L>.6&&L>10}function A(h){if(h.length===0)return h;h.sort((0,r.compareBy)(f=>f.original.startLineNumber,r.numberComparator));const o=[h[0]];for(let f=1;f<h.length;f++){const a=o[o.length-1],i=h[f],u=i.original.startLineNumber-a.original.endLineNumberExclusive,p=i.modified.startLineNumber-a.modified.endLineNumberExclusive;if(u>=0&&p>=0&&u+p<=2){o[o.length-1]=a.join(i);continue}o.push(i)}return o}function E(h,o){const f=new c.MonotonousArray(h);return o=o.filter(a=>{const i=f.findLastMonotonous(_=>_.original.endLineNumberExclusive<a.original.endLineNumberExclusive)||new P.LineRangeMapping(new d.LineRange(1,1),new d.LineRange(1,1)),u=(0,c.findLastMonotonous)(h,_=>_.modified.endLineNumberExclusive<a.modified.endLineNumberExclusive);return i!==u}),o}}),te(ie[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(B,t,k,P,r,c,w,d,l,s,g,N,m,b,e,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.DefaultLinesDiffComputer=void 0;class A{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new s.MyersDiffAlgorithm}computeDiff(f,a,i){if(f.length<=1&&(0,k.equals)(f,a,(Y,n)=>Y===n))return new m.LinesDiff([],[],!1);if(f.length===1&&f[0].length===0||a.length===1&&a[0].length===0)return new m.LinesDiff([new b.DetailedLineRangeMapping(new r.LineRange(1,f.length+1),new r.LineRange(1,a.length+1),[new b.RangeMapping(new w.Range(1,1,f.length,f[0].length+1),new w.Range(1,1,a.length,a[0].length+1))])],[],!1);const u=i.maxComputationTimeMs===0?d.InfiniteTimeout.instance:new d.DateTimeout(i.maxComputationTimeMs),p=!i.ignoreTrimWhitespace,_=new Map;function L(Y){let n=_.get(Y);return n===void 0&&(n=_.size,_.set(Y,n)),n}const M=f.map(Y=>L(Y.trim())),R=a.map(Y=>L(Y.trim())),D=new v.LineSequence(M,f),F=new v.LineSequence(R,a),y=(()=>D.length+F.length<1700?this.dynamicProgrammingDiffing.compute(D,F,u,(Y,n)=>f[Y]===a[n]?a[n].length===0?.1:1+Math.log(1+a[n].length):.99):this.myersDiffingAlgorithm.compute(D,F))();let S=y.diffs,C=y.hitTimeout;S=(0,N.optimizeSequenceDiffs)(D,F,S),S=(0,N.removeVeryShortMatchingLinesBetweenDiffs)(D,F,S);const O=[],z=Y=>{if(p)for(let n=0;n<Y;n++){const ne=T+n,oe=q+n;if(f[ne]!==a[oe]){const ge=this.refineDiff(f,a,new d.SequenceDiff(new c.OffsetRange(ne,ne+1),new c.OffsetRange(oe,oe+1)),u,p);for(const pe of ge.mappings)O.push(pe);ge.hitTimeout&&(C=!0)}}};let T=0,q=0;for(const Y of S){(0,P.assertFn)(()=>Y.seq1Range.start-T===Y.seq2Range.start-q);const n=Y.seq1Range.start-T;z(n),T=Y.seq1Range.endExclusive,q=Y.seq2Range.endExclusive;const ne=this.refineDiff(f,a,Y,u,p);ne.hitTimeout&&(C=!0);for(const oe of ne.mappings)O.push(oe)}z(f.length-T);const j=E(O,f,a);let H=[];return i.computeMoves&&(H=this.computeMoves(j,f,a,M,R,u,p)),(0,P.assertFn)(()=>{function Y(ne,oe){if(ne.lineNumber<1||ne.lineNumber>oe.length)return!1;const ge=oe[ne.lineNumber-1];return!(ne.column<1||ne.column>ge.length+1)}function n(ne,oe){return!(ne.startLineNumber<1||ne.startLineNumber>oe.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>oe.length+1)}for(const ne of j){if(!ne.innerChanges)return!1;for(const oe of ne.innerChanges)if(!(Y(oe.modifiedRange.getStartPosition(),a)&&Y(oe.modifiedRange.getEndPosition(),a)&&Y(oe.originalRange.getStartPosition(),f)&&Y(oe.originalRange.getEndPosition(),f)))return!1;if(!n(ne.modified,a)||!n(ne.original,f))return!1}return!0}),new m.LinesDiff(j,H,C)}computeMoves(f,a,i,u,p,_,L){return(0,g.computeMovedLines)(f,a,i,u,p,_).map(D=>{const F=this.refineDiff(a,i,new d.SequenceDiff(D.original.toOffsetRange(),D.modified.toOffsetRange()),_,L),y=E(F.mappings,a,i,!0);return new m.MovedText(D,y)})}refineDiff(f,a,i,u,p){const _=new e.LinesSliceCharSequence(f,i.seq1Range,p),L=new e.LinesSliceCharSequence(a,i.seq2Range,p),M=_.length+L.length<500?this.dynamicProgrammingDiffing.compute(_,L,u):this.myersDiffingAlgorithm.compute(_,L,u);let R=M.diffs;return R=(0,N.optimizeSequenceDiffs)(_,L,R),R=(0,N.extendDiffsToEntireWordIfAppropriate)(_,L,R),R=(0,N.removeShortMatches)(_,L,R),R=(0,N.removeVeryShortMatchingTextBetweenLongDiffs)(_,L,R),{mappings:R.map(F=>new b.RangeMapping(_.translateRange(F.seq1Range),L.translateRange(F.seq2Range))),hitTimeout:M.hitTimeout}}}t.DefaultLinesDiffComputer=A;function E(o,f,a,i=!1){const u=[];for(const p of(0,k.groupAdjacentBy)(o.map(_=>h(_,f,a)),(_,L)=>_.original.overlapOrTouch(L.original)||_.modified.overlapOrTouch(L.modified))){const _=p[0],L=p[p.length-1];u.push(new b.DetailedLineRangeMapping(_.original.join(L.original),_.modified.join(L.modified),p.map(M=>M.innerChanges[0])))}return(0,P.assertFn)(()=>!i&&u.length>0&&u[0].original.startLineNumber!==u[0].modified.startLineNumber?!1:(0,P.checkAdjacentItems)(u,(p,_)=>_.original.startLineNumber-p.original.endLineNumberExclusive===_.modified.startLineNumber-p.modified.endLineNumberExclusive&&p.original.endLineNumberExclusive<_.original.startLineNumber&&p.modified.endLineNumberExclusive<_.modified.startLineNumber)),u}t.lineRangeMappingFromRangeMappings=E;function h(o,f,a){let i=0,u=0;o.modifiedRange.endColumn===1&&o.originalRange.endColumn===1&&o.originalRange.startLineNumber+i<=o.originalRange.endLineNumber&&o.modifiedRange.startLineNumber+i<=o.modifiedRange.endLineNumber&&(u=-1),o.modifiedRange.startColumn-1>=a[o.modifiedRange.startLineNumber-1].length&&o.originalRange.startColumn-1>=f[o.originalRange.startLineNumber-1].length&&o.originalRange.startLineNumber<=o.originalRange.endLineNumber+u&&o.modifiedRange.startLineNumber<=o.modifiedRange.endLineNumber+u&&(i=1);const p=new r.LineRange(o.originalRange.startLineNumber+i,o.originalRange.endLineNumber+1+u),_=new r.LineRange(o.modifiedRange.startLineNumber+i,o.modifiedRange.endLineNumber+1+u);return new b.DetailedLineRangeMapping(p,_,[o])}t.getLineRangeMapping=h}),te(ie[33],re([0,1,25,32,16,7,2,13,12]),function(B,t,k,P,r,c,w,d,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const s=3;class g{computeDiff(i,u,p){const L=new E(i,u,{maxComputationTime:p.maxComputationTimeMs,shouldIgnoreTrimWhitespace:p.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let R=null;for(const D of L.changes){let F;D.originalEndLineNumber===0?F=new l.LineRange(D.originalStartLineNumber+1,D.originalStartLineNumber+1):F=new l.LineRange(D.originalStartLineNumber,D.originalEndLineNumber+1);let y;D.modifiedEndLineNumber===0?y=new l.LineRange(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):y=new l.LineRange(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let S=new r.DetailedLineRangeMapping(F,y,D.charChanges?.map(C=>new r.RangeMapping(new w.Range(C.originalStartLineNumber,C.originalStartColumn,C.originalEndLineNumber,C.originalEndColumn),new w.Range(C.modifiedStartLineNumber,C.modifiedStartColumn,C.modifiedEndLineNumber,C.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===S.modified.startLineNumber||R.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.DetailedLineRangeMapping(R.original.join(S.original),R.modified.join(S.modified),R.innerChanges&&S.innerChanges?R.innerChanges.concat(S.innerChanges):void 0),M.pop()),M.push(S),R=S}return(0,d.assertFn)(()=>(0,d.checkAdjacentItems)(M,(D,F)=>F.original.startLineNumber-D.original.endLineNumberExclusive===F.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<F.original.startLineNumber&&D.modified.endLineNumberExclusive<F.modified.startLineNumber)),new P.LinesDiff(M,[],L.quitEarly)}}t.LegacyLinesDiffComputer=g;function N(a,i,u,p){return new k.LcsDiff(a,i,u).ComputeDiff(p)}class m{constructor(i){const u=[],p=[];for(let _=0,L=i.length;_<L;_++)u[_]=h(i[_],1),p[_]=o(i[_],1);this.lines=i,this._startColumns=u,this._endColumns=p}getElements(){const i=[];for(let u=0,p=this.lines.length;u<p;u++)i[u]=this.lines[u].substring(this._startColumns[u]-1,this._endColumns[u]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,u,p){const _=[],L=[],M=[];let R=0;for(let D=u;D<=p;D++){const F=this.lines[D],y=i?this._startColumns[D]:1,S=i?this._endColumns[D]:F.length+1;for(let C=y;C<S;C++)_[R]=F.charCodeAt(C-1),L[R]=D+1,M[R]=C,R++;!i&&D<p&&(_[R]=10,L[R]=D+1,M[R]=F.length+1,R++)}return new b(_,L,M)}}class b{constructor(i,u,p){this._charCodes=i,this._lineNumbers=u,this._columns=p}toString(){return"["+this._charCodes.map((i,u)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[u]},${this._columns[u]})`).join(", ")+"]"}_assertIndex(i,u){if(i<0||i>=u.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class e{constructor(i,u,p,_,L,M,R,D){this.originalStartLineNumber=i,this.originalStartColumn=u,this.originalEndLineNumber=p,this.originalEndColumn=_,this.modifiedStartLineNumber=L,this.modifiedStartColumn=M,this.modifiedEndLineNumber=R,this.modifiedEndColumn=D}static createFromDiffChange(i,u,p){const _=u.getStartLineNumber(i.originalStart),L=u.getStartColumn(i.originalStart),M=u.getEndLineNumber(i.originalStart+i.originalLength-1),R=u.getEndColumn(i.originalStart+i.originalLength-1),D=p.getStartLineNumber(i.modifiedStart),F=p.getStartColumn(i.modifiedStart),y=p.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=p.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(_,L,M,R,D,F,y,S)}}function v(a){if(a.length<=1)return a;const i=[a[0]];let u=i[0];for(let p=1,_=a.length;p<_;p++){const L=a[p],M=L.originalStart-(u.originalStart+u.originalLength),R=L.modifiedStart-(u.modifiedStart+u.modifiedLength);Math.min(M,R)<s?(u.originalLength=L.originalStart+L.originalLength-u.originalStart,u.modifiedLength=L.modifiedStart+L.modifiedLength-u.modifiedStart):(i.push(L),u=L)}return i}class A{constructor(i,u,p,_,L){this.originalStartLineNumber=i,this.originalEndLineNumber=u,this.modifiedStartLineNumber=p,this.modifiedEndLineNumber=_,this.charChanges=L}static createFromDiffResult(i,u,p,_,L,M,R){let D,F,y,S,C;if(u.originalLength===0?(D=p.getStartLineNumber(u.originalStart)-1,F=0):(D=p.getStartLineNumber(u.originalStart),F=p.getEndLineNumber(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(y=_.getStartLineNumber(u.modifiedStart)-1,S=0):(y=_.getStartLineNumber(u.modifiedStart),S=_.getEndLineNumber(u.modifiedStart+u.modifiedLength-1)),M&&u.originalLength>0&&u.originalLength<20&&u.modifiedLength>0&&u.modifiedLength<20&&L()){const O=p.createCharSequence(i,u.originalStart,u.originalStart+u.originalLength-1),z=_.createCharSequence(i,u.modifiedStart,u.modifiedStart+u.modifiedLength-1);if(O.getElements().length>0&&z.getElements().length>0){let T=N(O,z,L,!0).changes;R&&(T=v(T)),C=[];for(let q=0,j=T.length;q<j;q++)C.push(e.createFromDiffChange(T[q],O,z))}}return new A(D,F,y,S,C)}}class E{constructor(i,u,p){this.shouldComputeCharChanges=p.shouldComputeCharChanges,this.shouldPostProcessCharChanges=p.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=p.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=p.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=u,this.original=new m(i),this.modified=new m(u),this.continueLineDiff=f(p.maxComputationTime),this.continueCharDiff=f(p.maxComputationTime===0?0:Math.min(p.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=N(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),u=i.changes,p=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let D=0,F=u.length;D<F;D++)R.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,u[D],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:p,changes:R}}const _=[];let L=0,M=0;for(let R=-1,D=u.length;R<D;R++){const F=R+1<D?u[R+1]:null,y=F?F.originalStart:this.originalLines.length,S=F?F.modifiedStart:this.modifiedLines.length;for(;L<y&&M<S;){const C=this.originalLines[L],O=this.modifiedLines[M];if(C!==O){{let z=h(C,1),T=h(O,1);for(;z>1&&T>1;){const q=C.charCodeAt(z-2),j=O.charCodeAt(T-2);if(q!==j)break;z--,T--}(z>1||T>1)&&this._pushTrimWhitespaceCharChange(_,L+1,1,z,M+1,1,T)}{let z=o(C,1),T=o(O,1);const q=C.length+1,j=O.length+1;for(;z<q&&T<j;){const H=C.charCodeAt(z-1),Y=C.charCodeAt(T-1);if(H!==Y)break;z++,T++}(z<q||T<j)&&this._pushTrimWhitespaceCharChange(_,L+1,z,q,M+1,T,j)}}L++,M++}F&&(_.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,F,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),L+=F.originalLength,M+=F.modifiedLength)}return{quitEarly:p,changes:_}}_pushTrimWhitespaceCharChange(i,u,p,_,L,M,R){if(this._mergeTrimWhitespaceCharChange(i,u,p,_,L,M,R))return;let D;this.shouldComputeCharChanges&&(D=[new e(u,p,u,_,L,M,L,R)]),i.push(new A(u,u,L,L,D))}_mergeTrimWhitespaceCharChange(i,u,p,_,L,M,R){const D=i.length;if(D===0)return!1;const F=i[D-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===u&&F.modifiedEndLineNumber===L?(this.shouldComputeCharChanges&&F.charChanges&&F.charChanges.push(new e(u,p,u,_,L,M,L,R)),!0):F.originalEndLineNumber+1===u&&F.modifiedEndLineNumber+1===L?(F.originalEndLineNumber=u,F.modifiedEndLineNumber=L,this.shouldComputeCharChanges&&F.charChanges&&F.charChanges.push(new e(u,p,u,_,L,M,L,R)),!0):!1}}t.DiffComputer=E;function h(a,i){const u=c.firstNonWhitespaceIndex(a);return u===-1?i:u+1}function o(a,i){const u=c.lastNonWhitespaceIndex(a);return u===-1?i:u+2}function f(a){if(a===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<a}}),te(ie[50],re([0,1,33,49]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new k.LegacyLinesDiffComputer,getDefault:()=>new P.DefaultLinesDiffComputer}}),te(ie[51],re([0,1,35]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function P(m){const b=[];for(const e of m){const v=Number(e);(v||v===0&&e.replace(/\s/g,"")!=="")&&b.push(v)}return b}function r(m,b,e,v){return{red:m/255,blue:e/255,green:b/255,alpha:v}}function c(m,b){const e=b.index,v=b[0].length;if(!e)return;const A=m.positionAt(e);return{startLineNumber:A.lineNumber,startColumn:A.column,endLineNumber:A.lineNumber,endColumn:A.column+v}}function w(m,b){if(!m)return;const e=k.Color.Format.CSS.parseHex(b);if(e)return{range:m,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(m,b,e){if(!m||b.length!==1)return;const A=b[0].values(),E=P(A);return{range:m,color:r(E[0],E[1],E[2],e?E[3]:1)}}function l(m,b,e){if(!m||b.length!==1)return;const A=b[0].values(),E=P(A),h=new k.Color(new k.HSLA(E[0],E[1]/100,E[2]/100,e?E[3]:1));return{range:m,color:r(h.rgba.r,h.rgba.g,h.rgba.b,h.rgba.a)}}function s(m,b){return typeof m=="string"?[...m.matchAll(b)]:m.findMatches(b)}function g(m){const b=[],v=s(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(v.length>0)for(const A of v){const E=A.filter(a=>a!==void 0),h=E[1],o=E[2];if(!o)continue;let f;if(h==="rgb"){const a=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;f=d(c(m,A),s(o,a),!1)}else if(h==="rgba"){const a=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=d(c(m,A),s(o,a),!0)}else if(h==="hsl"){const a=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;f=l(c(m,A),s(o,a),!1)}else if(h==="hsla"){const a=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=l(c(m,A),s(o,a),!0)}else h==="#"&&(f=w(c(m,A),h+o));f&&b.push(f)}return b}function N(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:g(m)}t.computeDefaultDocumentColors=N}),te(ie[52],re([0,1,28]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var P;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class r{constructor(e,v,A){const E=new Uint8Array(e*v);for(let h=0,o=e*v;h<o;h++)E[h]=A;this._data=E,this.rows=e,this.cols=v}get(e,v){return this._data[e*this.cols+v]}set(e,v,A){this._data[e*this.cols+v]=A}}class c{constructor(e){let v=0,A=0;for(let h=0,o=e.length;h<o;h++){const[f,a,i]=e[h];a>v&&(v=a),f>A&&(A=f),i>A&&(A=i)}v++,A++;const E=new r(A,v,0);for(let h=0,o=e.length;h<o;h++){const[f,a,i]=e[h];E.set(f,a,i)}this._states=E,this._maxCharCode=v}nextState(e,v){return v<0||v>=this._maxCharCode?0:this._states.get(e,v)}}t.StateMachine=c;let w=null;function d(){return w===null&&(w=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var l;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function g(){if(s===null){s=new k.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<b.length;v++)s.set(b.charCodeAt(v),1);const e=".,;:";for(let v=0;v<e.length;v++)s.set(e.charCodeAt(v),2)}return s}class N{static _createLink(e,v,A,E,h){let o=h-1;do{const f=v.charCodeAt(o);if(e.get(f)!==2)break;o--}while(o>E);if(E>0){const f=v.charCodeAt(E-1),a=v.charCodeAt(o);(f===40&&a===41||f===91&&a===93||f===123&&a===125)&&o--}return{range:{startLineNumber:A,startColumn:E+1,endLineNumber:A,endColumn:o+2},url:v.substring(E,o+1)}}static computeLinks(e,v=d()){const A=g(),E=[];for(let h=1,o=e.getLineCount();h<=o;h++){const f=e.getLineContent(h),a=f.length;let i=0,u=0,p=0,_=1,L=!1,M=!1,R=!1,D=!1;for(;i<a;){let F=!1;const y=f.charCodeAt(i);if(_===13){let S;switch(y){case 40:L=!0,S=0;break;case 41:S=L?0:1;break;case 91:R=!0,M=!0,S=0;break;case 93:R=!1,S=M?0:1;break;case 123:D=!0,S=0;break;case 125:S=D?0:1;break;case 39:case 34:case 96:p===y?S=1:p===39||p===34||p===96?S=0:S=1;break;case 42:S=p===42?1:0;break;case 124:S=p===124?1:0;break;case 32:S=R?0:1;break;default:S=A.get(y)}S===1&&(E.push(N._createLink(A,f,h,u,i)),F=!0)}else if(_===12){let S;y===91?(M=!0,S=0):S=A.get(y),S===1?F=!0:_=13}else _=v.nextState(_,y),_===0&&(F=!0);F&&(_=1,L=!1,M=!1,D=!1,u=i+1,p=y),i++}_===13&&E.push(N._createLink(A,f,h,u,a))}return E}}t.LinkComputer=N;function m(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:N.computeLinks(b)}t.computeLinks=m}),te(ie[53],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class k{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new k}navigateValueSet(r,c,w,d,l){if(r&&c){const s=this.doNavigateValueSet(c,l);if(s)return{range:r,value:s}}if(w&&d){const s=this.doNavigateValueSet(d,l);if(s)return{range:w,value:s}}return null}doNavigateValueSet(r,c){const w=this.numberReplace(r,c);return w!==null?w:this.textReplace(r,c)}numberReplace(r,c){const w=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let d=Number(r);const l=parseFloat(r);return!isNaN(d)&&!isNaN(l)&&d===l?d===0&&!c?null:(d=Math.floor(d*w),d+=c?w:-w,String(d/w)):null}textReplace(r,c){return this.valueSetsReplace(this._defaultValueSet,r,c)}valueSetsReplace(r,c,w){let d=null;for(let l=0,s=r.length;d===null&&l<s;l++)d=this.valueSetReplace(r[l],c,w);return d}valueSetReplace(r,c,w){let d=r.indexOf(c);return d>=0?(d+=w?1:-1,d<0?d=r.length-1:d%=r.length,r[d]):null}}t.BasicInplaceReplace=k}),te(ie[54],re([0,1,14]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var P;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var r;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var c;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var w;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var d;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(d||(t.EndOfLinePreference=d={}));var l;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class g{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,a.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this._indentSizeIsTabSize===a._indentSizeIsTabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,k.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}t.TextModelResolvedOptions=g;class N{constructor(a,i){this._findMatchBrand=void 0,this.range=a,this.matches=i}}t.FindMatch=N;var m;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function b(f){return f&&typeof f.read=="function"}t.isITextSnapshot=b;var e;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var v;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(t.ModelConstants=v={}));class A{constructor(a,i,u,p,_,L){this.identifier=a,this.range=i,this.text=u,this.forceMoveMarkers=p,this.isAutoWhitespaceEdit=_,this._isTracked=L}}t.ValidAnnotatedEditOperation=A;class E{constructor(a,i,u){this.regex=a,this.wordSeparators=i,this.simpleSearch=u}}t.SearchData=E;class h{constructor(a,i,u){this.reverseEdits=a,this.changes=i,this.trimAutoWhitespaceLineNumbers=u}}t.ApplyEditsResult=h;function o(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}t.shouldSynchronizeModel=o}),te(ie[55],re([0,1,6,27]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class r{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(l,s){l=(0,P.toUint32)(l);const g=this.values,N=this.prefixSum,m=s.length;return m===0?!1:(this.values=new Uint32Array(g.length+m),this.values.set(g.subarray(0,l),0),this.values.set(g.subarray(l),l+m),this.values.set(s,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,s){return l=(0,P.toUint32)(l),s=(0,P.toUint32)(s),this.values[l]===s?!1:(this.values[l]=s,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,s){l=(0,P.toUint32)(l),s=(0,P.toUint32)(s);const g=this.values,N=this.prefixSum;if(l>=g.length)return!1;const m=g.length-l;return s>=m&&(s=m),s===0?!1:(this.values=new Uint32Array(g.length-s),this.values.set(g.subarray(0,l),0),this.values.set(g.subarray(l+s),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,P.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),l>=this.values.length&&(l=this.values.length-1);for(let g=s;g<=l;g++)this.prefixSum[g]=this.prefixSum[g-1]+this.values[g];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,g=this.values.length-1,N=0,m=0,b=0;for(;s<=g;)if(N=s+(g-s)/2|0,m=this.prefixSum[N],b=m-this.values[N],l<b)g=N-1;else if(l>=m)s=N+1;else break;return new w(N,l-b)}}t.PrefixSumComputer=r;class c{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const s=this._indexBySum[l],g=s>0?this._prefixSum[s-1]:0;return new w(s,l-g)}removeValues(l,s){this._values.splice(l,s),this._invalidate(l)}insertValues(l,s){this._values=(0,k.arrayInsert)(this._values,l,s),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,s=this._values.length;l<s;l++){const g=this._values[l],N=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=N+g;for(let m=0;m<g;m++)this._indexBySum[N+m]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,s){this._values[l]!==s&&(this._values[l]=s,this._invalidate(l))}}t.ConstantTimePrefixSumComputer=c;class w{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.PrefixSumIndexOfResult=w}),te(ie[56],re([0,1,7,5,55]),function(B,t,k,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class c{constructor(d,l,s,g){this._uri=d,this._lines=l,this._eol=s,this._versionId=g,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const l=d.changes;for(const s of l)this._acceptDeleteRange(s.range),this._acceptInsertText(new P.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,l=this._lines.length,s=new Uint32Array(l);for(let g=0;g<l;g++)s[g]=this._lines[g].length+d;this._lineStarts=new r.PrefixSumComputer(s)}}_setLineText(d,l){this._lines[d]=l,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,l){if(l.length===0)return;const s=(0,k.splitLines)(l);if(s.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+s[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}s[s.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+s[0]);const g=new Uint32Array(s.length-1);for(let N=1;N<s.length;N++)this._lines.splice(d.lineNumber+N-1,0,s[N]),g[N-1]=s[N].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,g)}}t.MirrorTextModel=c}),te(ie[57],re([0,1,7,44,5,2,54]),function(B,t,k,P,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const d=999;class l{constructor(h,o,f,a){this.searchString=h,this.isRegex=o,this.matchCase=f,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=s(this.searchString):h=this.searchString.indexOf(`
`)>=0;let o=null;try{o=k.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!o)return null;let f=!this.isRegex&&!h;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new w.SearchData(o,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}t.SearchParams=l;function s(E){if(!E||E.length===0)return!1;for(let h=0,o=E.length;h<o;h++){const f=E.charCodeAt(h);if(f===10)return!0;if(f===92){if(h++,h>=o)break;const a=E.charCodeAt(h);if(a===110||a===114||a===87)return!0}}return!1}t.isMultilineRegexSource=s;function g(E,h,o){if(!o)return new w.FindMatch(E,null);const f=[];for(let a=0,i=h.length;a<i;a++)f[a]=h[a];return new w.FindMatch(E,f)}t.createFindMatch=g;class N{constructor(h){const o=[];let f=0;for(let a=0,i=h.length;a<i;a++)h.charCodeAt(a)===10&&(o[f++]=a);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(h){const o=this._lineFeedsOffsets;let f=0,a=o.length-1;if(a===-1||h<=o[0])return 0;for(;f<a;){const i=f+((a-f)/2>>0);o[i]>=h?a=i-1:o[i+1]>=h?(f=i,a=i):f=i+1}return f+1}}class m{static findMatches(h,o,f,a,i){const u=o.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(h,f,new A(u.wordSeparators,u.regex),a,i):this._doFindMatchesLineByLine(h,f,u,a,i):[]}static _getMultilineMatchRange(h,o,f,a,i,u){let p,_=0;a?(_=a.findLineFeedCountBeforeOffset(i),p=o+i+_):p=o+i;let L;if(a){const F=a.findLineFeedCountBeforeOffset(i+u.length)-_;L=p+u.length+F}else L=p+u.length;const M=h.getPositionAt(p),R=h.getPositionAt(L);return new c.Range(M.lineNumber,M.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(h,o,f,a,i){const u=h.getOffsetAt(o.getStartPosition()),p=h.getValueInRange(o,1),_=h.getEOL()===`\r
`?new N(p):null,L=[];let M=0,R;for(f.reset(0);R=f.next(p);)if(L[M++]=g(this._getMultilineMatchRange(h,u,p,_,R.index,R[0]),R,a),M>=i)return L;return L}static _doFindMatchesLineByLine(h,o,f,a,i){const u=[];let p=0;if(o.startLineNumber===o.endLineNumber){const L=h.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return p=this._findMatchesInLine(f,L,o.startLineNumber,o.startColumn-1,p,u,a,i),u}const _=h.getLineContent(o.startLineNumber).substring(o.startColumn-1);p=this._findMatchesInLine(f,_,o.startLineNumber,o.startColumn-1,p,u,a,i);for(let L=o.startLineNumber+1;L<o.endLineNumber&&p<i;L++)p=this._findMatchesInLine(f,h.getLineContent(L),L,0,p,u,a,i);if(p<i){const L=h.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);p=this._findMatchesInLine(f,L,o.endLineNumber,0,p,u,a,i)}return u}static _findMatchesInLine(h,o,f,a,i,u,p,_){const L=h.wordSeparators;if(!p&&h.simpleSearch){const D=h.simpleSearch,F=D.length,y=o.length;let S=-F;for(;(S=o.indexOf(D,S+F))!==-1;)if((!L||v(L,o,y,S,F))&&(u[i++]=new w.FindMatch(new c.Range(f,S+1+a,f,S+1+F+a),null),i>=_))return i;return i}const M=new A(h.wordSeparators,h.regex);let R;M.reset(0);do if(R=M.next(o),R&&(u[i++]=g(new c.Range(f,R.index+1+a,f,R.index+1+R[0].length+a),R,p),i>=_))return i;while(R);return i}static findNextMatch(h,o,f,a){const i=o.parseSearchRequest();if(!i)return null;const u=new A(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(h,f,u,a):this._doFindNextMatchLineByLine(h,f,u,a)}static _doFindNextMatchMultiline(h,o,f,a){const i=new r.Position(o.lineNumber,1),u=h.getOffsetAt(i),p=h.getLineCount(),_=h.getValueInRange(new c.Range(i.lineNumber,i.column,p,h.getLineMaxColumn(p)),1),L=h.getEOL()===`\r
`?new N(_):null;f.reset(o.column-1);const M=f.next(_);return M?g(this._getMultilineMatchRange(h,u,_,L,M.index,M[0]),M,a):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(h,new r.Position(1,1),f,a):null}static _doFindNextMatchLineByLine(h,o,f,a){const i=h.getLineCount(),u=o.lineNumber,p=h.getLineContent(u),_=this._findFirstMatchInLine(f,p,u,o.column,a);if(_)return _;for(let L=1;L<=i;L++){const M=(u+L-1)%i,R=h.getLineContent(M+1),D=this._findFirstMatchInLine(f,R,M+1,1,a);if(D)return D}return null}static _findFirstMatchInLine(h,o,f,a,i){h.reset(a-1);const u=h.next(o);return u?g(new c.Range(f,u.index+1,f,u.index+1+u[0].length),u,i):null}static findPreviousMatch(h,o,f,a){const i=o.parseSearchRequest();if(!i)return null;const u=new A(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(h,f,u,a):this._doFindPreviousMatchLineByLine(h,f,u,a)}static _doFindPreviousMatchMultiline(h,o,f,a){const i=this._doFindMatchesMultiline(h,new c.Range(1,1,o.lineNumber,o.column),f,a,10*d);if(i.length>0)return i[i.length-1];const u=h.getLineCount();return o.lineNumber!==u||o.column!==h.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(h,new r.Position(u,h.getLineMaxColumn(u)),f,a):null}static _doFindPreviousMatchLineByLine(h,o,f,a){const i=h.getLineCount(),u=o.lineNumber,p=h.getLineContent(u).substring(0,o.column-1),_=this._findLastMatchInLine(f,p,u,a);if(_)return _;for(let L=1;L<=i;L++){const M=(i+u-L-1)%i,R=h.getLineContent(M+1),D=this._findLastMatchInLine(f,R,M+1,a);if(D)return D}return null}static _findLastMatchInLine(h,o,f,a){let i=null,u;for(h.reset(0);u=h.next(o);)i=g(new c.Range(f,u.index+1,f,u.index+1+u[0].length),u,a);return i}}t.TextModelSearch=m;function b(E,h,o,f,a){if(f===0)return!0;const i=h.charCodeAt(f-1);if(E.get(i)!==0||i===13||i===10)return!0;if(a>0){const u=h.charCodeAt(f);if(E.get(u)!==0)return!0}return!1}function e(E,h,o,f,a){if(f+a===o)return!0;const i=h.charCodeAt(f+a);if(E.get(i)!==0||i===13||i===10)return!0;if(a>0){const u=h.charCodeAt(f+a-1);if(E.get(u)!==0)return!0}return!1}function v(E,h,o,f,a){return b(E,h,o,f,a)&&e(E,h,o,f,a)}t.isValidMatch=v;class A{constructor(h,o){this._wordSeparators=h,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const o=h.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(f=this._searchRegex.exec(h),!f))return null;const a=f.index,i=f[0].length;if(a===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){k.getNextCodePoint(h,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=i,!this._wordSeparators||v(this._wordSeparators,h,o,a,i))return f}while(f);return null}}t.Searcher=A}),te(ie[58],re([0,1,2,57,7,13,29]),function(B,t,k,P,r,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class d{static computeUnicodeHighlights(e,v,A){const E=A?A.startLineNumber:1,h=A?A.endLineNumber:e.getLineCount(),o=new g(v),f=o.getCandidateCodePoints();let a;f==="allNonBasicAscii"?a=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):a=new RegExp(`${l(Array.from(f))}`,"g");const i=new P.Searcher(null,a),u=[];let p=!1,_,L=0,M=0,R=0;e:for(let D=E,F=h;D<=F;D++){const y=e.getLineContent(D),S=y.length;i.reset(0);do if(_=i.next(y),_){let C=_.index,O=_.index+_[0].length;if(C>0){const j=y.charCodeAt(C-1);r.isHighSurrogate(j)&&C--}if(O+1<S){const j=y.charCodeAt(O-1);r.isHighSurrogate(j)&&O++}const z=y.substring(C,O);let T=(0,w.getWordAtText)(C+1,w.DEFAULT_WORD_REGEXP,y,0);T&&T.endColumn<=C+1&&(T=null);const q=o.shouldHighlightNonBasicASCII(z,T?T.word:null);if(q!==0){q===3?L++:q===2?M++:q===1?R++:(0,c.assertNever)(q);const j=1e3;if(u.length>=j){p=!0;break e}u.push(new k.Range(D,C+1,D,O+1))}}while(_)}return{ranges:u,hasMore:p,ambiguousCharacterCount:L,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,v){const A=new g(v);switch(A.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const h=e.codePointAt(0),o=A.ambiguousCharacters.getPrimaryConfusable(h),f=r.AmbiguousCharacters.getLocales().filter(a=>!r.AmbiguousCharacters.getInstance(new Set([...v.allowedLocales,a])).isAmbiguous(h));return{kind:0,confusableWith:String.fromCodePoint(o),notAmbiguousInLocales:f}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=d;function l(b,e){return`[${r.escapeRegExpCharacters(b.map(A=>String.fromCodePoint(A)).join(""))}]`}var s;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class g{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const v of r.InvisibleCharacters.codePoints)N(String.fromCodePoint(v))||e.add(v);if(this.options.ambiguousCharacters)for(const v of this.ambiguousCharacters.getConfusableCodePoints())e.add(v);for(const v of this.allowedCodePoints)e.delete(v);return e}shouldHighlightNonBasicASCII(e,v){const A=e.codePointAt(0);if(this.allowedCodePoints.has(A))return 0;if(this.options.nonBasicASCII)return 1;let E=!1,h=!1;if(v)for(const o of v){const f=o.codePointAt(0),a=r.isBasicASCII(o);E=E||a,!a&&!this.ambiguousCharacters.isAmbiguous(f)&&!r.InvisibleCharacters.isInvisibleCharacter(f)&&(h=!0)}return!E&&h?0:this.options.invisibleCharacters&&!N(e)&&r.InvisibleCharacters.isInvisibleCharacter(A)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(A)?3:0}}function N(b){return b===" "||b===`
`||b==="	"}var m;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(m||(m={}))}),te(ie[59],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var k;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(k||(t.AccessibilitySupport=k={}));var P;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var c;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var w;(function(n){n[n.Deprecated=1]="Deprecated"})(w||(t.CompletionItemTag=w={}));var d;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var N;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(N||(t.DocumentHighlightKind=N={}));var m;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(m||(t.EditorAutoIndentStrategy=m={}));var b;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var v;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(v||(t.EndOfLineSequence=v={}));var A;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(A||(t.GlyphMarginLane=A={}));var E;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(E||(t.IndentAction=E={}));var h;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(h||(t.InjectedTextCursorStops=h={}));var o;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(o||(t.InlayHintKind=o={}));var f;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(f||(t.InlineCompletionTriggerKind=f={}));var a;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(a||(t.KeyCode=a={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var u;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(u||(t.MarkerTag=u={}));var p;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(p||(t.MinimapPosition=p={}));var _;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(_||(t.MouseTargetType=_={}));var L;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(L||(t.OverlayWidgetPositionPreference=L={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var R;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(R||(t.PositionAffinity=R={}));var D;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(D||(t.RenderLineNumbersType=D={}));var F;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(F||(t.RenderMinimap=F={}));var y;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(y||(t.ScrollType=y={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var C;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(C||(t.SelectionDirection=C={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var z;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(z||(t.SymbolKind=z={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var q;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(q||(t.TextEditorCursorBlinkingStyle=q={}));var j;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(j||(t.TextEditorCursorStyle=j={}));var H;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(H||(t.TrackedRangeStickiness=H={}));var Y;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(Y||(t.WrappingIndent=Y={}))}),te(ie[60],re([0,1,11,10]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class r{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(d){this._onDidChange.fire({changedLanguages:d,changedColorMap:!1})}register(d,l){return this._tokenizationSupports.set(d,l),this.handleChange([d]),(0,P.toDisposable)(()=>{this._tokenizationSupports.get(d)===l&&(this._tokenizationSupports.delete(d),this.handleChange([d]))})}get(d){return this._tokenizationSupports.get(d)||null}registerFactory(d,l){this._factories.get(d)?.dispose();const s=new c(this,d,l);return this._factories.set(d,s),(0,P.toDisposable)(()=>{const g=this._factories.get(d);!g||g!==s||(this._factories.delete(d),g.dispose())})}async getOrCreate(d){const l=this.get(d);if(l)return l;const s=this._factories.get(d);return!s||s.isResolved?null:(await s.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const s=this._factories.get(d);return!!(!s||s.isResolved)}setColorMap(d){this._colorMap=d,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=r;class c extends P.Disposable{get isResolved(){return this._isResolved}constructor(d,l,s){super(),this._registry=d,this._languageId=l,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const d=await this._factory.tokenizationSupport;this._isResolved=!0,d&&!this._isDisposed&&this._register(this._registry.register(this._languageId,d))}}}),te(ie[61],re([62,63]),function(B,t){return B.create("vs/base/common/platform",t)}),te(ie[17],re([0,1,61]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let P=!1,r=!1,c=!1,w=!1,d=!1,l=!1,s=!1,g=!1,N=!1,m=!1,b,e=t.LANGUAGE_DEFAULT,v=t.LANGUAGE_DEFAULT,A,E;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?h=t.globals.vscode.process:typeof process<"u"&&(h=process);const o=typeof h?.versions?.electron=="string",f=o&&h?.type==="renderer";if(typeof navigator=="object"&&!f)E=navigator.userAgent,P=E.indexOf("Windows")>=0,r=E.indexOf("Macintosh")>=0,g=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=E.indexOf("Linux")>=0,m=E?.indexOf("Mobi")>=0,l=!0,b=k.getConfiguredDefaultLocale(k.localize(0,null))||t.LANGUAGE_DEFAULT,e=b,v=navigator.language;else if(typeof h=="object"){P=h.platform==="win32",r=h.platform==="darwin",c=h.platform==="linux",w=c&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,s=o,N=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const D=h.env.VSCODE_NLS_CONFIG;if(D)try{const F=JSON.parse(D),y=F.availableLanguages["*"];b=F.locale,v=F.osLocale,e=y||t.LANGUAGE_DEFAULT,A=F._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var a;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(a||(t.Platform=a={}));function i(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=i;let u=0;r?u=1:P?u=3:c&&(u=2),t.isWindows=P,t.isMacintosh=r,t.isLinux=c,t.isLinuxSnap=w,t.isNative=d,t.isElectron=s,t.isWeb=l,t.isWebWorker=l&&typeof t.globals.importScripts=="function",t.isIOS=g,t.isMobile=m,t.isCI=N,t.platform=u,t.userAgent=E,t.language=e;var p;(function(D){function F(){return t.language}D.value=F;function y(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}D.isDefaultVariant=y;function S(){return t.language==="en"}D.isDefault=S})(p||(t.Language=p={})),t.locale=b,t.platformLocale=v,t.translationsConfigFile=A,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const D=[];t.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let S=0,C=D.length;S<C;S++){const O=D[S];if(O.id===y.data.vscodeScheduleAsyncWork){D.splice(S,1),O.callback();return}}});let F=0;return y=>{const S=++F;D.push({id:S,callback:y}),t.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return D=>setTimeout(D)})();var _;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(_||(t.OperatingSystem=_={})),t.OS=r||g?2:P?1:3;let L=!0,M=!1;function R(){if(!M){M=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,L=new Uint16Array(D.buffer)[0]===(2<<8)+1}return L}t.isLittleEndian=R,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),te(ie[64],re([0,1,17]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let P;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const r=k.globals.vscode.process;P={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.platform=P.platform,t.arch=P.arch}),te(ie[65],re([0,1,64]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const P=65,r=97,c=90,w=122,d=46,l=47,s=92,g=58,N=63;class m extends Error{constructor(u,p,_){let L;typeof p=="string"&&p.indexOf("not ")===0?(L="must not be",p=p.replace(/^not /,"")):L="must be";const M=u.indexOf(".")!==-1?"property":"argument";let R=`The "${u}" ${M} ${L} of type ${p}`;R+=`. Received type ${typeof _}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,u){if(i===null||typeof i!="object")throw new m(u,"Object",i)}function e(i,u){if(typeof i!="string")throw new m(u,"string",i)}const v=k.platform==="win32";function A(i){return i===l||i===s}function E(i){return i===l}function h(i){return i>=P&&i<=c||i>=r&&i<=w}function o(i,u,p,_){let L="",M=0,R=-1,D=0,F=0;for(let y=0;y<=i.length;++y){if(y<i.length)F=i.charCodeAt(y);else{if(_(F))break;F=l}if(_(F)){if(!(R===y-1||D===1))if(D===2){if(L.length<2||M!==2||L.charCodeAt(L.length-1)!==d||L.charCodeAt(L.length-2)!==d){if(L.length>2){const S=L.lastIndexOf(p);S===-1?(L="",M=0):(L=L.slice(0,S),M=L.length-1-L.lastIndexOf(p)),R=y,D=0;continue}else if(L.length!==0){L="",M=0,R=y,D=0;continue}}u&&(L+=L.length>0?`${p}..`:"..",M=2)}else L.length>0?L+=`${p}${i.slice(R+1,y)}`:L=i.slice(R+1,y),M=y-R-1;R=y,D=0}else F===d&&D!==-1?++D:D=-1}return L}function f(i,u){b(u,"pathObject");const p=u.dir||u.root,_=u.base||`${u.name||""}${u.ext||""}`;return p?p===u.root?`${p}${_}`:`${p}${i}${_}`:_}t.win32={resolve(...i){let u="",p="",_=!1;for(let L=i.length-1;L>=-1;L--){let M;if(L>=0){if(M=i[L],e(M,"path"),M.length===0)continue}else u.length===0?M=k.cwd():(M=k.env[`=${u}`]||k.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==u.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${u}\\`));const R=M.length;let D=0,F="",y=!1;const S=M.charCodeAt(0);if(R===1)A(S)&&(D=1,y=!0);else if(A(S))if(y=!0,A(M.charCodeAt(1))){let C=2,O=C;for(;C<R&&!A(M.charCodeAt(C));)C++;if(C<R&&C!==O){const z=M.slice(O,C);for(O=C;C<R&&A(M.charCodeAt(C));)C++;if(C<R&&C!==O){for(O=C;C<R&&!A(M.charCodeAt(C));)C++;(C===R||C!==O)&&(F=`\\\\${z}\\${M.slice(O,C)}`,D=C)}}}else D=1;else h(S)&&M.charCodeAt(1)===g&&(F=M.slice(0,2),D=2,R>2&&A(M.charCodeAt(2))&&(y=!0,D=3));if(F.length>0)if(u.length>0){if(F.toLowerCase()!==u.toLowerCase())continue}else u=F;if(_){if(u.length>0)break}else if(p=`${M.slice(D)}\\${p}`,_=y,y&&u.length>0)break}return p=o(p,!_,"\\",A),_?`${u}\\${p}`:`${u}${p}`||"."},normalize(i){e(i,"path");const u=i.length;if(u===0)return".";let p=0,_,L=!1;const M=i.charCodeAt(0);if(u===1)return E(M)?"\\":i;if(A(M))if(L=!0,A(i.charCodeAt(1))){let D=2,F=D;for(;D<u&&!A(i.charCodeAt(D));)D++;if(D<u&&D!==F){const y=i.slice(F,D);for(F=D;D<u&&A(i.charCodeAt(D));)D++;if(D<u&&D!==F){for(F=D;D<u&&!A(i.charCodeAt(D));)D++;if(D===u)return`\\\\${y}\\${i.slice(F)}\\`;D!==F&&(_=`\\\\${y}\\${i.slice(F,D)}`,p=D)}}}else p=1;else h(M)&&i.charCodeAt(1)===g&&(_=i.slice(0,2),p=2,u>2&&A(i.charCodeAt(2))&&(L=!0,p=3));let R=p<u?o(i.slice(p),!L,"\\",A):"";return R.length===0&&!L&&(R="."),R.length>0&&A(i.charCodeAt(u-1))&&(R+="\\"),_===void 0?L?`\\${R}`:R:L?`${_}\\${R}`:`${_}${R}`},isAbsolute(i){e(i,"path");const u=i.length;if(u===0)return!1;const p=i.charCodeAt(0);return A(p)||u>2&&h(p)&&i.charCodeAt(1)===g&&A(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let u,p;for(let M=0;M<i.length;++M){const R=i[M];e(R,"path"),R.length>0&&(u===void 0?u=p=R:u+=`\\${R}`)}if(u===void 0)return".";let _=!0,L=0;if(typeof p=="string"&&A(p.charCodeAt(0))){++L;const M=p.length;M>1&&A(p.charCodeAt(1))&&(++L,M>2&&(A(p.charCodeAt(2))?++L:_=!1))}if(_){for(;L<u.length&&A(u.charCodeAt(L));)L++;L>=2&&(u=`\\${u.slice(L)}`)}return t.win32.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u)return"";const p=t.win32.resolve(i),_=t.win32.resolve(u);if(p===_||(i=p.toLowerCase(),u=_.toLowerCase(),i===u))return"";let L=0;for(;L<i.length&&i.charCodeAt(L)===s;)L++;let M=i.length;for(;M-1>L&&i.charCodeAt(M-1)===s;)M--;const R=M-L;let D=0;for(;D<u.length&&u.charCodeAt(D)===s;)D++;let F=u.length;for(;F-1>D&&u.charCodeAt(F-1)===s;)F--;const y=F-D,S=R<y?R:y;let C=-1,O=0;for(;O<S;O++){const T=i.charCodeAt(L+O);if(T!==u.charCodeAt(D+O))break;T===s&&(C=O)}if(O!==S){if(C===-1)return _}else{if(y>S){if(u.charCodeAt(D+O)===s)return _.slice(D+O+1);if(O===2)return _.slice(D+O)}R>S&&(i.charCodeAt(L+O)===s?C=O:O===2&&(C=3)),C===-1&&(C=0)}let z="";for(O=L+C+1;O<=M;++O)(O===M||i.charCodeAt(O)===s)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${_.slice(D,F)}`:(_.charCodeAt(D)===s&&++D,_.slice(D,F))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const u=t.win32.resolve(i);if(u.length<=2)return i;if(u.charCodeAt(0)===s){if(u.charCodeAt(1)===s){const p=u.charCodeAt(2);if(p!==N&&p!==d)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(h(u.charCodeAt(0))&&u.charCodeAt(1)===g&&u.charCodeAt(2)===s)return`\\\\?\\${u}`;return i},dirname(i){e(i,"path");const u=i.length;if(u===0)return".";let p=-1,_=0;const L=i.charCodeAt(0);if(u===1)return A(L)?i:".";if(A(L)){if(p=_=1,A(i.charCodeAt(1))){let D=2,F=D;for(;D<u&&!A(i.charCodeAt(D));)D++;if(D<u&&D!==F){for(F=D;D<u&&A(i.charCodeAt(D));)D++;if(D<u&&D!==F){for(F=D;D<u&&!A(i.charCodeAt(D));)D++;if(D===u)return i;D!==F&&(p=_=D+1)}}}}else h(L)&&i.charCodeAt(1)===g&&(p=u>2&&A(i.charCodeAt(2))?3:2,_=p);let M=-1,R=!0;for(let D=u-1;D>=_;--D)if(A(i.charCodeAt(D))){if(!R){M=D;break}}else R=!1;if(M===-1){if(p===-1)return".";M=p}return i.slice(0,M)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let p=0,_=-1,L=!0,M;if(i.length>=2&&h(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(p=2),u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let R=u.length-1,D=-1;for(M=i.length-1;M>=p;--M){const F=i.charCodeAt(M);if(A(F)){if(!L){p=M+1;break}}else D===-1&&(L=!1,D=M+1),R>=0&&(F===u.charCodeAt(R)?--R===-1&&(_=M):(R=-1,_=D))}return p===_?_=D:_===-1&&(_=i.length),i.slice(p,_)}for(M=i.length-1;M>=p;--M)if(A(i.charCodeAt(M))){if(!L){p=M+1;break}}else _===-1&&(L=!1,_=M+1);return _===-1?"":i.slice(p,_)},extname(i){e(i,"path");let u=0,p=-1,_=0,L=-1,M=!0,R=0;i.length>=2&&i.charCodeAt(1)===g&&h(i.charCodeAt(0))&&(u=_=2);for(let D=i.length-1;D>=u;--D){const F=i.charCodeAt(D);if(A(F)){if(!M){_=D+1;break}continue}L===-1&&(M=!1,L=D+1),F===d?p===-1?p=D:R!==1&&(R=1):p!==-1&&(R=-1)}return p===-1||L===-1||R===0||R===1&&p===L-1&&p===_+1?"":i.slice(p,L)},format:f.bind(null,"\\"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const p=i.length;let _=0,L=i.charCodeAt(0);if(p===1)return A(L)?(u.root=u.dir=i,u):(u.base=u.name=i,u);if(A(L)){if(_=1,A(i.charCodeAt(1))){let C=2,O=C;for(;C<p&&!A(i.charCodeAt(C));)C++;if(C<p&&C!==O){for(O=C;C<p&&A(i.charCodeAt(C));)C++;if(C<p&&C!==O){for(O=C;C<p&&!A(i.charCodeAt(C));)C++;C===p?_=C:C!==O&&(_=C+1)}}}}else if(h(L)&&i.charCodeAt(1)===g){if(p<=2)return u.root=u.dir=i,u;if(_=2,A(i.charCodeAt(2))){if(p===3)return u.root=u.dir=i,u;_=3}}_>0&&(u.root=i.slice(0,_));let M=-1,R=_,D=-1,F=!0,y=i.length-1,S=0;for(;y>=_;--y){if(L=i.charCodeAt(y),A(L)){if(!F){R=y+1;break}continue}D===-1&&(F=!1,D=y+1),L===d?M===-1?M=y:S!==1&&(S=1):M!==-1&&(S=-1)}return D!==-1&&(M===-1||S===0||S===1&&M===D-1&&M===R+1?u.base=u.name=i.slice(R,D):(u.name=i.slice(R,M),u.base=i.slice(R,D),u.ext=i.slice(M,D))),R>0&&R!==_?u.dir=i.slice(0,R-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const i=/\\/g;return()=>{const u=k.cwd().replace(i,"/");return u.slice(u.indexOf("/"))}}return()=>k.cwd()})();t.posix={resolve(...i){let u="",p=!1;for(let _=i.length-1;_>=-1&&!p;_--){const L=_>=0?i[_]:a();e(L,"path"),L.length!==0&&(u=`${L}/${u}`,p=L.charCodeAt(0)===l)}return u=o(u,!p,"/",E),p?`/${u}`:u.length>0?u:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===l,p=i.charCodeAt(i.length-1)===l;return i=o(i,!u,"/",E),i.length===0?u?"/":p?"./":".":(p&&(i+="/"),u?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let u;for(let p=0;p<i.length;++p){const _=i[p];e(_,"path"),_.length>0&&(u===void 0?u=_:u+=`/${_}`)}return u===void 0?".":t.posix.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u||(i=t.posix.resolve(i),u=t.posix.resolve(u),i===u))return"";const p=1,_=i.length,L=_-p,M=1,R=u.length-M,D=L<R?L:R;let F=-1,y=0;for(;y<D;y++){const C=i.charCodeAt(p+y);if(C!==u.charCodeAt(M+y))break;C===l&&(F=y)}if(y===D)if(R>D){if(u.charCodeAt(M+y)===l)return u.slice(M+y+1);if(y===0)return u.slice(M+y)}else L>D&&(i.charCodeAt(p+y)===l?F=y:y===0&&(F=0));let S="";for(y=p+F+1;y<=_;++y)(y===_||i.charCodeAt(y)===l)&&(S+=S.length===0?"..":"/..");return`${S}${u.slice(M+F)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===l;let p=-1,_=!0;for(let L=i.length-1;L>=1;--L)if(i.charCodeAt(L)===l){if(!_){p=L;break}}else _=!1;return p===-1?u?"/":".":u&&p===1?"//":i.slice(0,p)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let p=0,_=-1,L=!0,M;if(u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let R=u.length-1,D=-1;for(M=i.length-1;M>=0;--M){const F=i.charCodeAt(M);if(F===l){if(!L){p=M+1;break}}else D===-1&&(L=!1,D=M+1),R>=0&&(F===u.charCodeAt(R)?--R===-1&&(_=M):(R=-1,_=D))}return p===_?_=D:_===-1&&(_=i.length),i.slice(p,_)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===l){if(!L){p=M+1;break}}else _===-1&&(L=!1,_=M+1);return _===-1?"":i.slice(p,_)},extname(i){e(i,"path");let u=-1,p=0,_=-1,L=!0,M=0;for(let R=i.length-1;R>=0;--R){const D=i.charCodeAt(R);if(D===l){if(!L){p=R+1;break}continue}_===-1&&(L=!1,_=R+1),D===d?u===-1?u=R:M!==1&&(M=1):u!==-1&&(M=-1)}return u===-1||_===-1||M===0||M===1&&u===_-1&&u===p+1?"":i.slice(u,_)},format:f.bind(null,"/"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const p=i.charCodeAt(0)===l;let _;p?(u.root="/",_=1):_=0;let L=-1,M=0,R=-1,D=!0,F=i.length-1,y=0;for(;F>=_;--F){const S=i.charCodeAt(F);if(S===l){if(!D){M=F+1;break}continue}R===-1&&(D=!1,R=F+1),S===d?L===-1?L=F:y!==1&&(y=1):L!==-1&&(y=-1)}if(R!==-1){const S=M===0&&p?1:M;L===-1||y===0||y===1&&L===R-1&&L===M+1?u.base=u.name=i.slice(S,R):(u.name=i.slice(S,L),u.base=i.slice(S,R),u.ext=i.slice(L,R))}return M>0?u.dir=i.slice(0,M-1):p&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v?t.win32.normalize:t.posix.normalize,t.isAbsolute=v?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v?t.win32.join:t.posix.join,t.resolve=v?t.win32.resolve:t.posix.resolve,t.relative=v?t.win32.relative:t.posix.relative,t.dirname=v?t.win32.dirname:t.posix.dirname,t.basename=v?t.win32.basename:t.posix.basename,t.extname=v?t.win32.extname:t.posix.extname,t.format=v?t.win32.format:t.posix.format,t.parse=v?t.win32.parse:t.posix.parse,t.toNamespacedPath=v?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v?t.win32.sep:t.posix.sep,t.delimiter=v?t.win32.delimiter:t.posix.delimiter}),te(ie[18],re([0,1,65,17]),function(B,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,c=/^\//,w=/^\/\//;function d(_,L){if(!_.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!r.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!c.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(_,L){return!_&&!L?"file":_}function s(_,L){switch(_){case"https":case"http":case"file":L?L[0]!==N&&(L=N+L):L=N;break}return L}const g="",N="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(L){return L instanceof b?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,M,R,D,F,y=!1){typeof L=="object"?(this.scheme=L.scheme||g,this.authority=L.authority||g,this.path=L.path||g,this.query=L.query||g,this.fragment=L.fragment||g):(this.scheme=l(L,y),this.authority=M||g,this.path=s(this.scheme,R||g),this.query=D||g,this.fragment=F||g,d(this,y))}get fsPath(){return f(this,!1)}with(L){if(!L)return this;let{scheme:M,authority:R,path:D,query:F,fragment:y}=L;return M===void 0?M=this.scheme:M===null&&(M=g),R===void 0?R=this.authority:R===null&&(R=g),D===void 0?D=this.path:D===null&&(D=g),F===void 0?F=this.query:F===null&&(F=g),y===void 0?y=this.fragment:y===null&&(y=g),M===this.scheme&&R===this.authority&&D===this.path&&F===this.query&&y===this.fragment?this:new A(M,R,D,F,y)}static parse(L,M=!1){const R=m.exec(L);return R?new A(R[2]||g,p(R[4]||g),p(R[5]||g),p(R[7]||g),p(R[9]||g),M):new A(g,g,g,g,g)}static file(L){let M=g;if(P.isWindows&&(L=L.replace(/\\/g,N)),L[0]===N&&L[1]===N){const R=L.indexOf(N,2);R===-1?(M=L.substring(2),L=N):(M=L.substring(2,R),L=L.substring(R)||N)}return new A("file",M,L,g,g)}static from(L,M){return new A(L.scheme,L.authority,L.path,L.query,L.fragment,M)}static joinPath(L,...M){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return P.isWindows&&L.scheme==="file"?R=b.file(k.win32.join(f(L,!0),...M)).path:R=k.posix.join(L.path,...M),L.with({path:R})}toString(L=!1){return a(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof b)return L;{const M=new A(L);return M._formatted=L.external??null,M._fsPath=L._sep===v?L.fsPath??null:null,M}}else return L}}t.URI=b;function e(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}t.isUriComponents=e;const v=P.isWindows?1:void 0;class A extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(L=!1){return L?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=v),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(_,L,M){let R,D=-1;for(let F=0;F<_.length;F++){const y=_.charCodeAt(F);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||L&&y===47||M&&y===91||M&&y===93||M&&y===58)D!==-1&&(R+=encodeURIComponent(_.substring(D,F)),D=-1),R!==void 0&&(R+=_.charAt(F));else{R===void 0&&(R=_.substr(0,F));const S=E[y];S!==void 0?(D!==-1&&(R+=encodeURIComponent(_.substring(D,F)),D=-1),R+=S):D===-1&&(D=F)}}return D!==-1&&(R+=encodeURIComponent(_.substring(D))),R!==void 0?R:_}function o(_){let L;for(let M=0;M<_.length;M++){const R=_.charCodeAt(M);R===35||R===63?(L===void 0&&(L=_.substr(0,M)),L+=E[R]):L!==void 0&&(L+=_[M])}return L!==void 0?L:_}function f(_,L){let M;return _.authority&&_.path.length>1&&_.scheme==="file"?M=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===47&&(_.path.charCodeAt(1)>=65&&_.path.charCodeAt(1)<=90||_.path.charCodeAt(1)>=97&&_.path.charCodeAt(1)<=122)&&_.path.charCodeAt(2)===58?L?M=_.path.substr(1):M=_.path[1].toLowerCase()+_.path.substr(2):M=_.path,P.isWindows&&(M=M.replace(/\//g,"\\")),M}t.uriToFsPath=f;function a(_,L){const M=L?o:h;let R="",{scheme:D,authority:F,path:y,query:S,fragment:C}=_;if(D&&(R+=D,R+=":"),(F||D==="file")&&(R+=N,R+=N),F){let O=F.indexOf("@");if(O!==-1){const z=F.substr(0,O);F=F.substr(O+1),O=z.lastIndexOf(":"),O===-1?R+=M(z,!1,!1):(R+=M(z.substr(0,O),!1,!1),R+=":",R+=M(z.substr(O+1),!1,!0)),R+="@"}F=F.toLowerCase(),O=F.lastIndexOf(":"),O===-1?R+=M(F,!1,!0):(R+=M(F.substr(0,O),!1,!0),R+=F.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}R+=M(y,!0,!1)}return S&&(R+="?",R+=M(S,!1,!1)),C&&(R+="#",R+=L?C:h(C,!1,!1)),R}function i(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+i(_.substr(3)):_}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function p(_){return _.match(u)?_.replace(u,L=>i(L)):_}}),te(ie[70],re([0,1,3,11,10,14,17,7]),function(B,t,k,P,r,c,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function g(p){w.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(p.message))}t.logOnceWebWorkerWarning=g;var N;(function(p){p[p.Request=0]="Request",p[p.Reply=1]="Reply",p[p.SubscribeEvent=2]="SubscribeEvent",p[p.Event=3]="Event",p[p.UnsubscribeEvent=4]="UnsubscribeEvent"})(N||(N={}));class m{constructor(_,L,M,R){this.vsWorker=_,this.req=L,this.method=M,this.args=R,this.type=0}}class b{constructor(_,L,M,R){this.vsWorker=_,this.seq=L,this.res=M,this.err=R,this.type=1}}class e{constructor(_,L,M,R){this.vsWorker=_,this.req=L,this.eventName=M,this.arg=R,this.type=2}}class v{constructor(_,L,M){this.vsWorker=_,this.req=L,this.event=M,this.type=3}}class A{constructor(_,L){this.vsWorker=_,this.req=L,this.type=4}}class E{constructor(_){this._workerId=-1,this._handler=_,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(_){this._workerId=_}sendMessage(_,L){const M=String(++this._lastSentReq);return new Promise((R,D)=>{this._pendingReplies[M]={resolve:R,reject:D},this._send(new m(this._workerId,M,_,L))})}listen(_,L){let M=null;const R=new P.Emitter({onWillAddFirstListener:()=>{M=String(++this._lastSentReq),this._pendingEmitters.set(M,R),this._send(new e(this._workerId,M,_,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(M),this._send(new A(this._workerId,M)),M=null}});return R.event}handleMessage(_){!_||!_.vsWorker||this._workerId!==-1&&_.vsWorker!==this._workerId||this._handleMessage(_)}_handleMessage(_){switch(_.type){case 1:return this._handleReplyMessage(_);case 0:return this._handleRequestMessage(_);case 2:return this._handleSubscribeEventMessage(_);case 3:return this._handleEventMessage(_);case 4:return this._handleUnsubscribeEventMessage(_)}}_handleReplyMessage(_){if(!this._pendingReplies[_.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[_.seq];if(delete this._pendingReplies[_.seq],_.err){let M=_.err;_.err.$isError&&(M=new Error,M.name=_.err.name,M.message=_.err.message,M.stack=_.err.stack),L.reject(M);return}L.resolve(_.res)}_handleRequestMessage(_){const L=_.req;this._handler.handleMessage(_.method,_.args).then(R=>{this._send(new b(this._workerId,L,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,k.transformErrorForSerialization)(R.detail)),this._send(new b(this._workerId,L,void 0,(0,k.transformErrorForSerialization)(R)))})}_handleSubscribeEventMessage(_){const L=_.req,M=this._handler.handleEvent(_.eventName,_.arg)(R=>{this._send(new v(this._workerId,L,R))});this._pendingEvents.set(L,M)}_handleEventMessage(_){if(!this._pendingEmitters.has(_.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(_.req).fire(_.event)}_handleUnsubscribeEventMessage(_){if(!this._pendingEvents.has(_.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(_.req).dispose(),this._pendingEvents.delete(_.req)}_send(_){const L=[];if(_.type===0)for(let M=0;M<_.args.length;M++)_.args[M]instanceof ArrayBuffer&&L.push(_.args[M]);else _.type===1&&_.res instanceof ArrayBuffer&&L.push(_.res);this._handler.sendMessage(_,L)}}class h extends r.Disposable{constructor(_,L,M){super();let R=null;this._worker=this._register(_.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{R?.(O)})),this._protocol=new E({sendMessage:(O,z)=>{this._worker.postMessage(O,z)},handleMessage:(O,z)=>{if(typeof M[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(M[O].apply(M,z))}catch(T){return Promise.reject(T)}},handleEvent:(O,z)=>{if(f(O)){const T=M[O].call(M,z);if(typeof T!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return T}if(o(O)){const T=M[O];if(typeof T!="function")throw new Error(`Missing event ${O} on main thread host.`);return T}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let D=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?D=F.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const y=(0,c.getAllMethodNames)(M);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(D)),L,y]);const S=(O,z)=>this._request(O,z),C=(O,z)=>this._protocol.listen(O,z);this._lazyProxy=new Promise((O,z)=>{R=z,this._onModuleLoaded.then(T=>{O(a(T,S,C))},T=>{z(T),this._onError("Worker failed to load "+L,T)})})}getProxyObject(){return this._lazyProxy}_request(_,L){return new Promise((M,R)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(_,L).then(M,R)},R)})}_onError(_,L){console.error(_),console.info(L)}}t.SimpleWorkerClient=h;function o(p){return p[0]==="o"&&p[1]==="n"&&d.isUpperAsciiLetter(p.charCodeAt(2))}function f(p){return/^onDynamic/.test(p)&&d.isUpperAsciiLetter(p.charCodeAt(9))}function a(p,_,L){const M=F=>function(){const y=Array.prototype.slice.call(arguments,0);return _(F,y)},R=F=>function(y){return L(F,y)},D={};for(const F of p){if(f(F)){D[F]=R(F);continue}if(o(F)){D[F]=L(F,void 0);continue}D[F]=M(F)}return D}class i{constructor(_,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new E({sendMessage:(M,R)=>{_(M,R)},handleMessage:(M,R)=>this._handleMessage(M,R),handleEvent:(M,R)=>this._handleEvent(M,R)})}onmessage(_){this._protocol.handleMessage(_)}_handleMessage(_,L){if(_===l)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[_]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+_));try{return Promise.resolve(this._requestHandler[_].apply(this._requestHandler,L))}catch(M){return Promise.reject(M)}}_handleEvent(_,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(f(_)){const M=this._requestHandler[_].call(this._requestHandler,L);if(typeof M!="function")throw new Error(`Missing dynamic event ${_} on request handler.`);return M}if(o(_)){const M=this._requestHandler[_];if(typeof M!="function")throw new Error(`Missing event ${_} on request handler.`);return M}throw new Error(`Malformed event name ${_}`)}initialize(_,L,M,R){this._protocol.setWorkerId(_);const y=a(R,(S,C)=>this._protocol.sendMessage(S,C),(S,C)=>this._protocol.listen(S,C));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(y),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((S,C)=>{(globalThis.require||B)([M],z=>{if(this._requestHandler=z.create(y),!this._requestHandler){C(new Error("No RequestHandler!"));return}S((0,c.getAllMethodNames)(this._requestHandler))},C)}))}}t.SimpleWorkerServer=i;function u(p){return new i(p,null)}t.create=u}),te(ie[66],re([62,63]),function(B,t){return B.create("vs/editor/common/languages",t)}),te(ie[67],re([0,1,41,18,42,2,60,66]),function(B,t,k,P,r,c,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.getAriaLabelForSymbol=t.symbolKindNames=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class l{constructor(q,j,H){this.offset=q,this.type=j,this.language=H,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=l;class s{constructor(q,j){this.tokens=q,this.endState=j,this._tokenizationResultBrand=void 0}}t.TokenizationResult=s;class g{constructor(q,j){this.tokens=q,this.endState=j,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=g;var N;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(N||(t.CompletionItemKind=N={}));var m;(function(T){const q=new Map;q.set(0,k.Codicon.symbolMethod),q.set(1,k.Codicon.symbolFunction),q.set(2,k.Codicon.symbolConstructor),q.set(3,k.Codicon.symbolField),q.set(4,k.Codicon.symbolVariable),q.set(5,k.Codicon.symbolClass),q.set(6,k.Codicon.symbolStruct),q.set(7,k.Codicon.symbolInterface),q.set(8,k.Codicon.symbolModule),q.set(9,k.Codicon.symbolProperty),q.set(10,k.Codicon.symbolEvent),q.set(11,k.Codicon.symbolOperator),q.set(12,k.Codicon.symbolUnit),q.set(13,k.Codicon.symbolValue),q.set(15,k.Codicon.symbolEnum),q.set(14,k.Codicon.symbolConstant),q.set(15,k.Codicon.symbolEnum),q.set(16,k.Codicon.symbolEnumMember),q.set(17,k.Codicon.symbolKeyword),q.set(27,k.Codicon.symbolSnippet),q.set(18,k.Codicon.symbolText),q.set(19,k.Codicon.symbolColor),q.set(20,k.Codicon.symbolFile),q.set(21,k.Codicon.symbolReference),q.set(22,k.Codicon.symbolCustomColor),q.set(23,k.Codicon.symbolFolder),q.set(24,k.Codicon.symbolTypeParameter),q.set(25,k.Codicon.account),q.set(26,k.Codicon.issues);function j(n){let ne=q.get(n);return ne||(console.info("No codicon found for CompletionItemKind "+n),ne=k.Codicon.symbolProperty),ne}T.toIcon=j;const H=new Map;H.set("method",0),H.set("function",1),H.set("constructor",2),H.set("field",3),H.set("variable",4),H.set("class",5),H.set("struct",6),H.set("interface",7),H.set("module",8),H.set("property",9),H.set("event",10),H.set("operator",11),H.set("unit",12),H.set("value",13),H.set("constant",14),H.set("enum",15),H.set("enum-member",16),H.set("enumMember",16),H.set("keyword",17),H.set("snippet",27),H.set("text",18),H.set("color",19),H.set("file",20),H.set("reference",21),H.set("customcolor",22),H.set("folder",23),H.set("type-parameter",24),H.set("typeParameter",24),H.set("account",25),H.set("issue",26);function Y(n,ne){let oe=H.get(n);return typeof oe>"u"&&!ne&&(oe=9),oe}T.fromString=Y})(m||(t.CompletionItemKinds=m={}));var b;(function(T){T[T.Deprecated=1]="Deprecated"})(b||(t.CompletionItemTag=b={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var v;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(t.CompletionTriggerKind=v={}));var A;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(A||(t.InlineCompletionTriggerKind=A={}));class E{constructor(q,j,H,Y){this.range=q,this.text=j,this.completionKind=H,this.isSnippetText=Y}equals(q){return c.Range.lift(this.range).equalsRange(q.range)&&this.text===q.text&&this.completionKind===q.completionKind&&this.isSnippetText===q.isSnippetText}}t.SelectedSuggestionInfo=E;var h;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(h||(t.CodeActionTriggerType=h={}));var o;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(o||(t.SignatureHelpTriggerKind=o={}));var f;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(f||(t.DocumentHighlightKind=f={}));function a(T){return T&&P.URI.isUri(T.uri)&&c.Range.isIRange(T.range)&&(c.Range.isIRange(T.originSelectionRange)||c.Range.isIRange(T.targetSelectionRange))}t.isLocationLink=a;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.symbolKindNames={[17]:(0,d.localize)(0,null),[16]:(0,d.localize)(1,null),[4]:(0,d.localize)(2,null),[13]:(0,d.localize)(3,null),[8]:(0,d.localize)(4,null),[9]:(0,d.localize)(5,null),[21]:(0,d.localize)(6,null),[23]:(0,d.localize)(7,null),[7]:(0,d.localize)(8,null),[0]:(0,d.localize)(9,null),[11]:(0,d.localize)(10,null),[10]:(0,d.localize)(11,null),[19]:(0,d.localize)(12,null),[5]:(0,d.localize)(13,null),[1]:(0,d.localize)(14,null),[2]:(0,d.localize)(15,null),[20]:(0,d.localize)(16,null),[15]:(0,d.localize)(17,null),[18]:(0,d.localize)(18,null),[24]:(0,d.localize)(19,null),[3]:(0,d.localize)(20,null),[6]:(0,d.localize)(21,null),[14]:(0,d.localize)(22,null),[22]:(0,d.localize)(23,null),[25]:(0,d.localize)(24,null),[12]:(0,d.localize)(25,null)};function u(T,q){return(0,d.localize)(26,null,T,t.symbolKindNames[q])}t.getAriaLabelForSymbol=u;var p;(function(T){T[T.Deprecated=1]="Deprecated"})(p||(t.SymbolTag=p={}));var _;(function(T){const q=new Map;q.set(0,k.Codicon.symbolFile),q.set(1,k.Codicon.symbolModule),q.set(2,k.Codicon.symbolNamespace),q.set(3,k.Codicon.symbolPackage),q.set(4,k.Codicon.symbolClass),q.set(5,k.Codicon.symbolMethod),q.set(6,k.Codicon.symbolProperty),q.set(7,k.Codicon.symbolField),q.set(8,k.Codicon.symbolConstructor),q.set(9,k.Codicon.symbolEnum),q.set(10,k.Codicon.symbolInterface),q.set(11,k.Codicon.symbolFunction),q.set(12,k.Codicon.symbolVariable),q.set(13,k.Codicon.symbolConstant),q.set(14,k.Codicon.symbolString),q.set(15,k.Codicon.symbolNumber),q.set(16,k.Codicon.symbolBoolean),q.set(17,k.Codicon.symbolArray),q.set(18,k.Codicon.symbolObject),q.set(19,k.Codicon.symbolKey),q.set(20,k.Codicon.symbolNull),q.set(21,k.Codicon.symbolEnumMember),q.set(22,k.Codicon.symbolStruct),q.set(23,k.Codicon.symbolEvent),q.set(24,k.Codicon.symbolOperator),q.set(25,k.Codicon.symbolTypeParameter);function j(H){let Y=q.get(H);return Y||(console.info("No codicon found for SymbolKind "+H),Y=k.Codicon.symbolProperty),Y}T.toIcon=j})(_||(t.SymbolKinds=_={}));class L{static asEditOperation(q){return r.EditOperation.replace(c.Range.lift(q.range),q.text)}}t.TextEdit=L;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(q){switch(q){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(q)}constructor(q){this.value=q}}t.FoldingRangeKind=M;var R;(function(T){function q(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}T.is=q})(R||(t.Command=R={}));var D;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var F;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(F||(t.CommentThreadState=F={}));var y;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(y||(t.CommentMode=y={}));var S;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(S||(t.CommentState=S={}));var C;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(C||(t.InlayHintKind=C={}));class O{constructor(q){this.createSupport=q,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(q=>{q&&q.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=O,t.TokenizationRegistry=new w.TokenizationRegistry;var z;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(z||(t.ExternalUriOpenerPriority=z={}))}),te(ie[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(B,t,k,P,r,c,w,d,l,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class N{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,v){return(0,r.KeyChord)(e,v)}}t.KeyMod=N;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:k.CancellationTokenSource,Emitter:P.Emitter,KeyCode:g.KeyCode,KeyMod:N,Position:w.Position,Range:d.Range,Selection:l.Selection,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:c.URI,Token:s.Token}}t.createMonacoBaseAPI=m}),te(ie[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(B,t,k,P,r,c,w,d,l,s,g,N,m,b,e,v,A,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class h extends w.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(i){const u=[];for(let p=0;p<this._lines.length;p++){const _=this._lines[p],L=this.offsetAt(new r.Position(p+1,1)),M=_.matchAll(i);for(const R of M)(R.index||R.index===0)&&(R.index=R.index+L),u.push(R)}return u}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,u){const p=(0,d.getWordAtText)(i.column,(0,d.ensureValidWordDefinition)(u),this._lines[i.lineNumber-1],0);return p?new c.Range(i.lineNumber,p.startColumn,i.lineNumber,p.endColumn):null}getWordUntilPosition(i,u){const p=this.getWordAtPosition(i,u);return p?{word:this._lines[i.lineNumber-1].substring(p.startColumn-1,i.column-1),startColumn:p.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const u=this._lines,p=this._wordenize.bind(this);let _=0,L="",M=0,R=[];return{*[Symbol.iterator](){for(;;)if(M<R.length){const D=L.substring(R[M].start,R[M].end);M+=1,yield D}else if(_<u.length)L=u[_],R=p(L,i),M=0,_+=1;else break}}}getLineWords(i,u){const p=this._lines[i-1],_=this._wordenize(p,u),L=[];for(const M of _)L.push({word:p.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return L}_wordenize(i,u){const p=[];let _;for(u.lastIndex=0;(_=u.exec(i))&&_[0].length!==0;)p.push({start:_.index,end:_.index+_[0].length});return p}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const u=this._eol,p=i.startLineNumber-1,_=i.endLineNumber-1,L=[];L.push(this._lines[p].substring(i.startColumn-1));for(let M=p+1;M<_;M++)L.push(this._lines[M]);return L.push(this._lines[_].substring(0,i.endColumn-1)),L.join(u)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(i),p=this._lines[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,p)}}_validateRange(i){const u=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),p=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return u.lineNumber!==i.startLineNumber||u.column!==i.startColumn||p.lineNumber!==i.endLineNumber||p.column!==i.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:p.lineNumber,endColumn:p.column}:i}_validatePosition(i){if(!r.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:u,column:p}=i,_=!1;if(u<1)u=1,p=1,_=!0;else if(u>this._lines.length)u=this._lines.length,p=this._lines[u-1].length+1,_=!0;else{const L=this._lines[u-1].length+1;p<1?(p=1,_=!0):p>L&&(p=L,_=!0)}return _?{lineNumber:u,column:p}:i}}class o{constructor(i,u){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=u,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(u=>i.push(this._models[u])),i}acceptNewModel(i){this._models[i.url]=new h(P.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,u){if(!this._models[i])return;this._models[i].onEvents(u)}acceptRemovedModel(i){this._models[i]&&delete this._models[i]}async computeUnicodeHighlights(i,u,p){const _=this._getModel(i);return _?m.UnicodeTextModelHighlighter.computeUnicodeHighlights(_,u,p):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,u,p,_){const L=this._getModel(i),M=this._getModel(u);return!L||!M?null:o.computeDiff(L,M,p,_)}static computeDiff(i,u,p,_){const L=_==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),M=i.getLinesContent(),R=u.getLinesContent(),D=L.computeDiff(M,R,p),F=D.changes.length>0?!1:this._modelsAreIdentical(i,u);function y(S){return S.map(C=>[C.original.startLineNumber,C.original.endLineNumberExclusive,C.modified.startLineNumber,C.modified.endLineNumberExclusive,C.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}return{identical:F,quitEarly:D.hitTimeout,changes:y(D.changes),moves:D.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,y(S.changes)])}}static _modelsAreIdentical(i,u){const p=i.getLineCount(),_=u.getLineCount();if(p!==_)return!1;for(let L=1;L<=p;L++){const M=i.getLineContent(L),R=u.getLineContent(L);if(M!==R)return!1}return!0}async computeDirtyDiff(i,u,p){const _=this._getModel(i),L=this._getModel(u);if(!_||!L)return null;const M=_.getLinesContent(),R=L.getLinesContent();return new b.DiffComputer(M,R,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:p,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(i,u,p){const _=this._getModel(i);if(!_)return u;const L=[];let M;u=u.slice(0).sort((D,F)=>{if(D.range&&F.range)return c.Range.compareRangesUsingStarts(D.range,F.range);const y=D.range?0:1,S=F.range?0:1;return y-S});let R=0;for(let D=1;D<u.length;D++)c.Range.getEndPosition(u[R].range).equals(c.Range.getStartPosition(u[D].range))?(u[R].range=c.Range.fromPositions(c.Range.getStartPosition(u[R].range),c.Range.getEndPosition(u[D].range)),u[R].text+=u[D].text):(R++,u[R]=u[D]);u.length=R+1;for(let{range:D,text:F,eol:y}of u){if(typeof y=="number"&&(M=y),c.Range.isEmpty(D)&&!F)continue;const S=_.getValueInRange(D);if(F=F.replace(/\r\n|\n|\r/g,_.eol),S===F)continue;if(Math.max(F.length,S.length)>o._diffLimit){L.push({range:D,text:F});continue}const C=(0,k.stringDiff)(S,F,p),O=_.offsetAt(c.Range.lift(D).getStartPosition());for(const z of C){const T=_.positionAt(O+z.originalStart),q=_.positionAt(O+z.originalStart+z.originalLength),j={text:F.substr(z.modifiedStart,z.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:q.lineNumber,endColumn:q.column}};_.getValueInRange(j.range)!==j.text&&L.push(j)}}return typeof M=="number"&&L.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}computeHumanReadableDiff(i,u,p){const _=this._getModel(i);if(!_)return u;const L=[];let M;u=u.slice(0).sort((R,D)=>{if(R.range&&D.range)return c.Range.compareRangesUsingStarts(R.range,D.range);const F=R.range?0:1,y=D.range?0:1;return F-y});for(let{range:R,text:D,eol:F}of u){let T=function(j,H){return new r.Position(j.lineNumber+H.lineNumber-1,H.lineNumber===1?j.column+H.column-1:H.column)},q=function(j,H){const Y=[];for(let n=H.startLineNumber;n<=H.endLineNumber;n++){const ne=j[n-1];n===H.startLineNumber&&n===H.endLineNumber?Y.push(ne.substring(H.startColumn-1,H.endColumn-1)):n===H.startLineNumber?Y.push(ne.substring(H.startColumn-1)):n===H.endLineNumber?Y.push(ne.substring(0,H.endColumn-1)):Y.push(ne)}return Y};if(typeof F=="number"&&(M=F),c.Range.isEmpty(R)&&!D)continue;const y=_.getValueInRange(R);if(D=D.replace(/\r\n|\n|\r/g,_.eol),y===D)continue;if(Math.max(D.length,y.length)>o._diffLimit){L.push({range:R,text:D});continue}const S=y.split(/\r\n|\n|\r/),C=D.split(/\r\n|\n|\r/),O=e.linesDiffComputers.getDefault().computeDiff(S,C,p),z=c.Range.lift(R).getStartPosition();for(const j of O.changes)if(j.innerChanges)for(const H of j.innerChanges)L.push({range:c.Range.fromPositions(T(z,H.originalRange.getStartPosition()),T(z,H.originalRange.getEndPosition())),text:q(C,H.modifiedRange).join(_.eol)});else throw new A.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&L.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(i){const u=this._getModel(i);return u?(0,l.computeLinks)(u):null}async computeDefaultDocumentColors(i){const u=this._getModel(i);return u?(0,E.computeDefaultDocumentColors)(u):null}static{this._suggestionsLimit=1e4}async textualSuggest(i,u,p,_){const L=new N.StopWatch,M=new RegExp(p,_),R=new Set;e:for(const D of i){const F=this._getModel(D);if(F){for(const y of F.words(M))if(!(y===u||!isNaN(Number(y)))&&(R.add(y),R.size>o._suggestionsLimit))break e}}return{words:Array.from(R),duration:L.elapsed()}}async computeWordRanges(i,u,p,_){const L=this._getModel(i);if(!L)return Object.create(null);const M=new RegExp(p,_),R=Object.create(null);for(let D=u.startLineNumber;D<u.endLineNumber;D++){const F=L.getLineWords(D,M);for(const y of F){if(!isNaN(Number(y.word)))continue;let S=R[y.word];S||(S=[],R[y.word]=S),S.push({startLineNumber:D,startColumn:y.startColumn,endLineNumber:D,endColumn:y.endColumn})}}return R}async navigateValueSet(i,u,p,_,L){const M=this._getModel(i);if(!M)return null;const R=new RegExp(_,L);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const D=M.getValueInRange(u),F=M.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},R);if(!F)return null;const y=M.getValueInRange(F);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(u,D,F,y,p)}loadForeignModule(i,u,p){const _=(R,D)=>this._host.fhr(R,D),M={host:(0,v.createProxyObject)(p,_),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(M,u),Promise.resolve((0,v.getAllMethodNames)(this._foreignModule))):new Promise((R,D)=>{B([i],F=>{this._foreignModule=F.create(M,u),R((0,v.getAllMethodNames)(this._foreignModule))},D)})}fmr(i,u){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,u))}catch(p){return Promise.reject(p)}}}t.EditorSimpleWorker=o;function f(a){return new o(a,null)}t.create=f,typeof importScripts=="function"&&(globalThis.monaco=(0,g.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/base/worker/workerMain.js.map
