/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/lazy","vs/base/common/normalization","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],te=function(K){for(var e=[],I=0,L=K.length;I<L;I++)e[I]=ee[K[I]];return e};define(ee[132],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function I(w,g,m){const h=L(w,g);if(h!==-1)return w[h]}e.findLast=I;function L(w,g,m=w.length-1){for(let h=m;h>=0;h--){const c=w[h];if(g(c))return h}return-1}e.findLastIdx=L;function r(w,g){const m=_(w,g);return m===-1?void 0:w[m]}e.findLastMonotonous=r;function _(w,g,m=0,h=w.length){let c=m,P=h;for(;c<P;){const u=Math.floor((c+P)/2);g(w[u])?c=u+1:P=u}return c-1}e.findLastIdxMonotonous=_;function M(w,g){const m=C(w,g);return m===w.length?void 0:w[m]}e.findFirstMonotonous=M;function C(w,g,m=0,h=w.length){let c=m,P=h;for(;c<P;){const u=Math.floor((c+P)/2);g(w[u])?P=u:c=u+1}return c}e.findFirstIdxMonotonousOrArrLen=C;function d(w,g,m=0,h=w.length){const c=C(w,g,m,h);return c===w.length?-1:c}e.findFirstIdxMonotonous=d;class a{static{this.assertInvariants=!1}constructor(g){this._array=g,this._findLastMonotonousLastIdx=0}findLastMonotonous(g){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!g(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=g}const m=_(this._array,g,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=m+1,m===-1?void 0:this._array[m]}}e.MonotonousArray=a;function p(w,g){if(w.length===0)return;let m=w[0];for(let h=1;h<w.length;h++){const c=w[h];g(c,m)>0&&(m=c)}return m}e.findFirstMaxBy=p;function v(w,g){if(w.length===0)return;let m=w[0];for(let h=1;h<w.length;h++){const c=w[h];g(c,m)>=0&&(m=c)}return m}e.findLastMaxBy=v;function S(w,g){return p(w,(m,h)=>-g(m,h))}e.findFirstMinBy=S;function f(w,g){if(w.length===0)return-1;let m=0;for(let h=1;h<w.length;h++){const c=w[h];g(c,w[m])>0&&(m=h)}return m}e.findMaxIdxBy=f;function y(w,g){for(const m of w){const h=g(m);if(h!==void 0)return h}}e.mapFindFirst=y}),define(ee[133],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function I(M,C){const d=Object.create(null);for(const a of M){const p=C(a);let v=d[p];v||(v=d[p]=[]),v.push(a)}return d}e.groupBy=I;function L(M,C){const d=[],a=[];for(const p of M)C.has(p)||d.push(p);for(const p of C)M.has(p)||a.push(p);return{removed:d,added:a}}e.diffSets=L;function r(M,C){const d=[],a=[];for(const[p,v]of M)C.has(p)||d.push(v);for(const[p,v]of C)M.has(p)||a.push(v);return{removed:d,added:a}}e.diffMaps=r;function _(M,C){const d=new Set;for(const a of C)M.has(a)&&d.add(a);return d}e.intersection=_}),define(ee[134],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(C,d){const a=Math.pow(10,d);return Math.round(C*a)/a}class L{constructor(d,a,p,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=I(Math.max(Math.min(1,v),0),3)}static equals(d,a){return d.r===a.r&&d.g===a.g&&d.b===a.b&&d.a===a.a}}e.RGBA=L;class r{constructor(d,a,p,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=I(Math.max(Math.min(1,a),0),3),this.l=I(Math.max(Math.min(1,p),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(d,a){return d.h===a.h&&d.s===a.s&&d.l===a.l&&d.a===a.a}static fromRGBA(d){const a=d.r/255,p=d.g/255,v=d.b/255,S=d.a,f=Math.max(a,p,v),y=Math.min(a,p,v);let w=0,g=0;const m=(y+f)/2,h=f-y;if(h>0){switch(g=Math.min(m<=.5?h/(2*m):h/(2-2*m),1),f){case a:w=(p-v)/h+(p<v?6:0);break;case p:w=(v-a)/h+2;break;case v:w=(a-p)/h+4;break}w*=60,w=Math.round(w)}return new r(w,g,m,S)}static _hue2rgb(d,a,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?d+(a-d)*6*p:p<1/2?a:p<2/3?d+(a-d)*(2/3-p)*6:d}static toRGBA(d){const a=d.h/360,{s:p,l:v,a:S}=d;let f,y,w;if(p===0)f=y=w=v;else{const g=v<.5?v*(1+p):v+p-v*p,m=2*v-g;f=r._hue2rgb(m,g,a+1/3),y=r._hue2rgb(m,g,a),w=r._hue2rgb(m,g,a-1/3)}return new L(Math.round(f*255),Math.round(y*255),Math.round(w*255),S)}}e.HSLA=r;class _{constructor(d,a,p,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=I(Math.max(Math.min(1,a),0),3),this.v=I(Math.max(Math.min(1,p),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(d,a){return d.h===a.h&&d.s===a.s&&d.v===a.v&&d.a===a.a}static fromRGBA(d){const a=d.r/255,p=d.g/255,v=d.b/255,S=Math.max(a,p,v),f=Math.min(a,p,v),y=S-f,w=S===0?0:y/S;let g;return y===0?g=0:S===a?g=((p-v)/y%6+6)%6:S===p?g=(v-a)/y+2:g=(a-p)/y+4,new _(Math.round(g*60),w,S,d.a)}static toRGBA(d){const{h:a,s:p,v,a:S}=d,f=v*p,y=f*(1-Math.abs(a/60%2-1)),w=v-f;let[g,m,h]=[0,0,0];return a<60?(g=f,m=y):a<120?(g=y,m=f):a<180?(m=f,h=y):a<240?(m=y,h=f):a<300?(g=y,h=f):a<=360&&(g=f,h=y),g=Math.round((g+w)*255),m=Math.round((m+w)*255),h=Math.round((h+w)*255),new L(g,m,h,S)}}e.HSVA=_;class M{static fromHex(d){return M.Format.CSS.parseHex(d)||M.red}static equals(d,a){return!d&&!a?!0:!d||!a?!1:d.equals(a)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:_.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof L)this.rgba=d;else if(d instanceof r)this._hsla=d,this.rgba=r.toRGBA(d);else if(d instanceof _)this._hsva=d,this.rgba=_.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&L.equals(this.rgba,d.rgba)&&r.equals(this.hsla,d.hsla)&&_.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=M._relativeLuminanceForComponent(this.rgba.r),a=M._relativeLuminanceForComponent(this.rgba.g),p=M._relativeLuminanceForComponent(this.rgba.b),v=.2126*d+.7152*a+.0722*p;return I(v,4)}static _relativeLuminanceForComponent(d){const a=d/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(d){const a=this.getRelativeLuminance(),p=d.getRelativeLuminance();return a>p?(a+.05)/(p+.05):(p+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const a=this.getRelativeLuminance(),p=d.getRelativeLuminance();return a>p}isDarkerThan(d){const a=this.getRelativeLuminance(),p=d.getRelativeLuminance();return a<p}lighten(d){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:a,g:p,b:v,a:S}=this.rgba;return new M(new L(a,p,v,S*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const a=d.rgba,p=this.rgba.a,v=a.a,S=p+v*(1-p);if(S<1e-6)return M.transparent;const f=this.rgba.r*p/S+a.r*v*(1-p)/S,y=this.rgba.g*p/S+a.g*v*(1-p)/S,w=this.rgba.b*p/S+a.b*v*(1-p)/S;return new M(new L(f,y,w,S))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:a,g:p,b:v,a:S}=this.rgba;return new M(new L(d.rgba.r-S*(d.rgba.r-a),d.rgba.g-S*(d.rgba.g-p),d.rgba.b-S*(d.rgba.b-v),1))}flatten(...d){const a=d.reduceRight((p,v)=>M._flatten(v,p));return M._flatten(this,a)}static _flatten(d,a){const p=1-d.rgba.a;return new M(new L(p*a.rgba.r+d.rgba.a*d.rgba.r,p*a.rgba.g+d.rgba.a*d.rgba.g,p*a.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(d,a,p){if(d.isLighterThan(a))return d;p=p||.5;const v=d.getRelativeLuminance(),S=a.getRelativeLuminance();return p=p*(S-v)/S,d.lighten(p)}static getDarkerColor(d,a,p){if(d.isDarkerThan(a))return d;p=p||.5;const v=d.getRelativeLuminance(),S=a.getRelativeLuminance();return p=p*(v-S)/v,d.darken(p)}static{this.white=new M(new L(255,255,255,1))}static{this.black=new M(new L(0,0,0,1))}static{this.red=new M(new L(255,0,0,1))}static{this.blue=new M(new L(0,0,255,1))}static{this.green=new M(new L(0,255,0,1))}static{this.cyan=new M(new L(0,255,255,1))}static{this.lightgrey=new M(new L(211,211,211,1))}static{this.transparent=new M(new L(0,0,0,0))}}e.Color=M,function(C){let d;(function(a){let p;(function(v){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:C.Format.CSS.formatRGBA(t)}v.formatRGB=S;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=f;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(t)}v.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function g(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function m(t){return`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}`}v.formatHex=m;function h(t,l=!1){return l&&t.rgba.a===1?C.Format.CSS.formatHex(t):`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}${g(Math.round(t.rgba.a*255))}`}v.formatHexA=h;function c(t){return t.isOpaque()?C.Format.CSS.formatHex(t):C.Format.CSS.formatRGBA(t)}v.format=c;function P(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const s=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new C(new L(s,i,n,1))}if(l===9){const s=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),o=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new C(new L(s,i,n,o/255))}if(l===4){const s=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new C(new L(16*s+s,16*i+i,16*n+n))}if(l===5){const s=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),o=u(t.charCodeAt(4));return new C(new L(16*s+s,16*i+i,16*n+n,(16*o+o)/255))}return null}v.parseHex=P;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=a.CSS||(a.CSS={}))})(d=C.Format||(C.Format={}))}(M||(e.Color=M={}))}),define(ee[54],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(M){return(C,d,a)=>{let p=null,v=null;if(typeof a.value=="function"?(p="value",v=a.value):typeof a.get=="function"&&(p="get",v=a.get),!v)throw new Error("not supported");a[p]=M(v,d)}}function L(M,C,d){let a=null,p=null;if(typeof d.value=="function"?(a="value",p=d.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(a="get",p=d.get),!p)throw new Error("not supported");const v=`$memoize$${C}`;d[a]=function(...S){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,S)}),this[v]}}e.memoize=L;function r(M,C,d){return I((a,p)=>{const v=`$debounce$${p}`,S=`$debounce$result$${p}`;return function(...f){this[S]||(this[S]=d?d():void 0),clearTimeout(this[v]),C&&(this[S]=C(this[S],...f),f=[this[S]]),this[v]=setTimeout(()=>{a.apply(this,f),this[S]=d?d():void 0},M)}})}e.debounce=r;function _(M,C,d){return I((a,p)=>{const v=`$throttle$timer$${p}`,S=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,y=`$throttle$pending$${p}`;return function(...w){if(this[S]||(this[S]=d?d():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[S]=C(this[S],...w)),this[y])return;const g=this[f]+M;g<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[S]]),this[S]=d?d():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),a.apply(this,[this[S]]),this[S]=d?d():void 0},g-Date.now()))}})}e.throttle=_}),define(ee[14],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(l=>{l(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=I,e.errorHandler=new I;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function r(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function _(u){a(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=_;function M(u){a(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function C(u){if(u instanceof Error){const{name:t,message:l}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:s,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=C;const d="Canceled";function a(u){return u instanceof p?!0:u instanceof Error&&u.name===d&&u.message===d}e.isCancellationError=a;class p extends Error{constructor(){super(d),this.name=this.message}}e.CancellationError=p;function v(){const u=new Error(d);return u.name=u.message,u}e.canceled=v;function S(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=S;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=f;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=y;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=g;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=m;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=h;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const l=new c;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class P extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype)}}e.BugIndicatingError=P}),define(ee[23],te([0,1,14,132]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(B,z=0){return B[B.length-(1+z)]}e.tail=r;function _(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=_;function M(B,z,j=(ae,fe)=>ae===fe){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let ae=0,fe=B.length;ae<fe;ae++)if(!j(B[ae],z[ae]))return!1;return!0}e.equals=M;function C(B,z){const j=B.length-1;z<j&&(B[z]=B[j]),B.pop()}e.removeFastWithoutKeepingOrder=C;function d(B,z,j){return a(B.length,ae=>j(B[ae],z))}e.binarySearch=d;function a(B,z){let j=0,ae=B-1;for(;j<=ae;){const fe=(j+ae)/2|0,ue=z(fe);if(ue<0)j=fe+1;else if(ue>0)ae=fe-1;else return fe}return-(j+1)}e.binarySearch2=a;function p(B,z,j){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const ae=z[Math.floor(z.length*Math.random())],fe=[],ue=[],de=[];for(const be of z){const we=j(be,ae);we<0?fe.push(be):we>0?ue.push(be):de.push(be)}return B<fe.length?p(B,fe,j):B<fe.length+de.length?de[0]:p(B-(fe.length+de.length),ue,j)}e.quickSelect=p;function v(B,z){const j=[];let ae;for(const fe of B.slice(0).sort(z))!ae||z(ae[0],fe)!==0?(ae=[fe],j.push(ae)):ae.push(fe);return j}e.groupBy=v;function*S(B,z){let j,ae;for(const fe of B)ae!==void 0&&z(ae,fe)?j.push(fe):(j&&(yield j),j=[fe]),ae=fe;j&&(yield j)}e.groupAdjacentBy=S;function f(B,z){for(let j=0;j<=B.length;j++)z(j===0?void 0:B[j-1],j===B.length?void 0:B[j])}e.forEachAdjacent=f;function y(B,z){for(let j=0;j<B.length;j++)z(j===0?void 0:B[j-1],B[j],j+1===B.length?void 0:B[j+1])}e.forEachWithNeighbors=y;function w(B,z,j){const ae=[];function fe(be,we,ye){if(we===0&&ye.length===0)return;const ke=ae[ae.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=we,ke.toInsert.push(...ye)):ae.push({start:be,deleteCount:we,toInsert:ye})}let ue=0,de=0;for(;;){if(ue===B.length){fe(ue,0,z.slice(de));break}if(de===z.length){fe(ue,B.length-ue,[]);break}const be=B[ue],we=z[de],ye=j(be,we);ye===0?(ue+=1,de+=1):ye<0?(fe(ue,1,[]),ue+=1):ye>0&&(fe(ue,0,[we]),de+=1)}return ae}e.sortedDiff=w;function g(B,z,j){const ae=w(B,z,j),fe=[],ue=[];for(const de of ae)fe.push(...B.slice(de.start,de.start+de.deleteCount)),ue.push(...de.toInsert);return{removed:fe,added:ue}}e.delta=g;function m(B,z,j){if(j===0)return[];const ae=B.slice(0,j).sort(z);return c(B,z,ae,j,B.length),ae}e.top=m;function h(B,z,j,ae,fe){return j===0?Promise.resolve([]):new Promise((ue,de)=>{(async()=>{const be=B.length,we=B.slice(0,j).sort(z);for(let ye=j,ke=Math.min(j+ae,be);ye<be;ye=ke,ke=Math.min(ke+ae,be)){if(ye>j&&await new Promise(Ne=>setTimeout(Ne)),fe&&fe.isCancellationRequested)throw new I.CancellationError;c(B,z,we,ye,ke)}return we})().then(ue,de)})}e.topAsync=h;function c(B,z,j,ae,fe){for(const ue=j.length;ae<fe;ae++){const de=B[ae];if(z(de,j[ue-1])<0){j.pop();const be=(0,L.findFirstIdxMonotonousOrArrLen)(j,we=>z(de,we)<0);j.splice(be,0,de)}}}function P(B){return B.filter(z=>!!z)}e.coalesce=P;function u(B){let z=0;for(let j=0;j<B.length;j++)B[j]&&(B[z]=B[j],z+=1);B.length=z}e.coalesceInPlace=u;function t(B,z,j){B.splice(j,0,B.splice(z,1)[0])}e.move=t;function l(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=l;function s(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=s;function i(B,z=j=>j){const j=new Set;return B.filter(ae=>{const fe=z(ae);return j.has(fe)?!1:(j.add(fe),!0)})}e.distinct=i;function n(B){const z=new Set;return j=>{const ae=B(j);return z.has(ae)?!1:(z.add(ae),!0)}}e.uniqueFilter=n;function o(B,z){return B.length>0?B[0]:z}e.firstOrDefault=o;function b(B,z){return B.length>0?B[B.length-1]:z}e.lastOrDefault=b;function D(B,z,j=(ae,fe)=>ae===fe){let ae=0;for(let fe=0,ue=Math.min(B.length,z.length);fe<ue&&j(B[fe],z[fe]);fe++)ae++;return ae}e.commonPrefixLength=D;function R(B){return[].concat(...B)}e.flatten=R;function E(B,z){let j=typeof z=="number"?B:0;typeof z=="number"?j=B:(j=0,z=B);const ae=[];if(j<=z)for(let fe=j;fe<z;fe++)ae.push(fe);else for(let fe=j;fe>z;fe--)ae.push(fe);return ae}e.range=E;function k(B,z,j){return B.reduce((ae,fe)=>(ae[z(fe)]=j?j(fe):fe,ae),Object.create(null))}e.index=k;function O(B,z){return B.push(z),()=>F(B,z)}e.insert=O;function F(B,z){const j=B.indexOf(z);if(j>-1)return B.splice(j,1),z}e.remove=F;function q(B,z,j){const ae=B.slice(0,z),fe=B.slice(z);return ae.concat(j,fe)}e.arrayInsert=q;function ne(B,z){let j;if(typeof z=="number"){let ae=z;j=()=>{const fe=Math.sin(ae++)*179426549;return fe-Math.floor(fe)}}else j=Math.random;for(let ae=B.length-1;ae>0;ae-=1){const fe=Math.floor(j()*(ae+1)),ue=B[ae];B[ae]=B[fe],B[fe]=ue}}e.shuffle=ne;function J(B,z){const j=B.indexOf(z);j>-1&&(B.splice(j,1),B.unshift(z))}e.pushToStart=J;function ce(B,z){const j=B.indexOf(z);j>-1&&(B.splice(j,1),B.push(z))}e.pushToEnd=ce;function re(B,z){for(const j of z)B.push(j)}e.pushMany=re;function se(B,z){return Array.isArray(B)?B.map(z):z(B)}e.mapArrayOrNot=se;function G(B){return Array.isArray(B)?B:[B]}e.asArray=G;function V(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=V;function x(B,z,j){const ae=U(B,z),fe=B.length,ue=j.length;B.length=fe+ue;for(let de=fe-1;de>=ae;de--)B[de+ue]=B[de];for(let de=0;de<ue;de++)B[de+ae]=j[de]}e.insertInto=x;function W(B,z,j,ae){const fe=U(B,z);let ue=B.splice(fe,j);return ue===void 0&&(ue=[]),x(B,fe,ae),ue}e.splice=W;function U(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var H;(function(B){function z(ue){return ue<0}B.isLessThan=z;function j(ue){return ue<=0}B.isLessThanOrEqual=j;function ae(ue){return ue>0}B.isGreaterThan=ae;function fe(ue){return ue===0}B.isNeitherLessOrGreaterThan=fe,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function Q(B,z){return(j,ae)=>z(B(j),B(ae))}e.compareBy=Q;function ie(...B){return(z,j)=>{for(const ae of B){const fe=ae(z,j);if(!H.isNeitherLessOrGreaterThan(fe))return fe}return H.neitherLessOrGreaterThan}}e.tieBreakComparators=ie;const oe=(B,z)=>B-z;e.numberComparator=oe;const N=(B,z)=>(0,e.numberComparator)(B?1:0,z?1:0);e.booleanComparator=N;function A(B){return(z,j)=>-B(z,j)}e.reverseOrder=A;class T{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let j=this.firstIdx;for(;j<this.items.length&&z(this.items[j]);)j++;const ae=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,ae}takeFromEndWhile(z){let j=this.lastIdx;for(;j>=0&&z(this.items[j]);)j--;const ae=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const j=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,j}}e.ArrayQueue=T;class ${static{this.empty=new $(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(j=>(z(j),!0))}toArray(){const z=[];return this.iterate(j=>(z.push(j),!0)),z}filter(z){return new $(j=>this.iterate(ae=>z(ae)?j(ae):!0))}map(z){return new $(j=>this.iterate(ae=>j(z(ae))))}some(z){let j=!1;return this.iterate(ae=>(j=z(ae),!j)),j}findFirst(z){let j;return this.iterate(ae=>z(ae)?(j=ae,!1):!0),j}findLast(z){let j;return this.iterate(ae=>(z(ae)&&(j=ae),!0)),j}findLastMaxBy(z){let j,ae=!0;return this.iterate(fe=>((ae||H.isGreaterThan(z(fe,j)))&&(ae=!1,j=fe),!0)),j}}e.CallbackIterable=$}),define(ee[135],te([0,1,14]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(d,a){if(!d)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=L;function r(d,a="Unreachable"){throw new Error(a)}e.assertNever=r;function _(d){if(!d)throw new I.BugIndicatingError("Assertion Failed")}e.assert=_;function M(d){if(!d()){debugger;d(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function C(d,a){let p=0;for(;p<d.length-1;){const v=d[p],S=d[p+1];if(!a(v,S))return!1;p++}return!0}e.checkAdjacentItems=C}),define(ee[82],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function I(L){const r=this;let _=!1,M;return function(){return _||(_=!0,M=L.apply(r,arguments)),M}}e.createSingleCallFunction=I}),define(ee[67],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=r;const _=Object.freeze([]);function M(){return _}L.empty=M;function*C(u){yield u}L.single=C;function d(u){return r(u)?u:C(u)}L.wrap=d;function a(u){return u||_}L.from=a;function*p(u){for(let t=u.length-1;t>=0;t--)yield u[t]}L.reverse=p;function v(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=v;function S(u){return u[Symbol.iterator]().next().value}L.first=S;function f(u,t){for(const l of u)if(t(l))return!0;return!1}L.some=f;function y(u,t){for(const l of u)if(t(l))return l}L.find=y;function*w(u,t){for(const l of u)t(l)&&(yield l)}L.filter=w;function*g(u,t){let l=0;for(const s of u)yield t(s,l++)}L.map=g;function*m(...u){for(const t of u)for(const l of t)yield l}L.concat=m;function h(u,t,l){let s=l;for(const i of u)s=t(s,i);return s}L.reduce=h;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}L.slice=c;function P(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const s=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=s.next();if(n.done)return[l,L.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return s}}]}L.consume=P})(I||(e.Iterable=I={}))}),define(ee[44],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_||(e.ParseOptions=_={}));function M(t,l=!1){let s=0;const i=t.length;let n="",o=0,b=16,D=0;function R(J){let ce=0,re=0;for(;ce<J;){const se=t.charCodeAt(s);if(se>=48&&se<=57)re=re*16+se-48;else if(se>=65&&se<=70)re=re*16+se-65+10;else if(se>=97&&se<=102)re=re*16+se-97+10;else break;s++,ce++}return ce<J&&(re=-1),re}function E(J){s=J,n="",o=0,b=16,D=0}function k(){const J=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&a(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&a(t.charCodeAt(s)))for(s++;s<t.length&&a(t.charCodeAt(s));)s++;else return D=3,t.substring(J,s);let ce=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&a(t.charCodeAt(s))){for(s++;s<t.length&&a(t.charCodeAt(s));)s++;ce=s}else D=3;return t.substring(J,ce)}function O(){let J="",ce=s;for(;;){if(s>=i){J+=t.substring(ce,s),D=2;break}const re=t.charCodeAt(s);if(re===34){J+=t.substring(ce,s),s++;break}if(re===92){if(J+=t.substring(ce,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const G=R(4);G>=0?J+=String.fromCharCode(G):D=4;break}default:D=5}ce=s;continue}if(re>=0&&re<=31)if(d(re)){J+=t.substring(ce,s),D=2;break}else D=6;s++}return J}function F(){if(n="",D=0,o=s,s>=i)return o=i,b=17;let J=t.charCodeAt(s);if(C(J)){do s++,n+=String.fromCharCode(J),J=t.charCodeAt(s);while(C(J));return b=15}if(d(J))return s++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),b=14;switch(J){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,n=O(),b=10;case 47:{const ce=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!d(t.charCodeAt(s));)s++;return n=t.substring(ce,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const re=i-1;let se=!1;for(;s<re;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,se=!0;break}s++}return se||(s++,D=1),n=t.substring(ce,s),b=13}return n+=String.fromCharCode(J),s++,b=16}case 45:if(n+=String.fromCharCode(J),s++,s===i||!a(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=k(),b=11;default:for(;s<i&&q(J);)s++,J=t.charCodeAt(s);if(o!==s){switch(n=t.substring(o,s),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(J),s++,b=16}}function q(J){if(C(J)||d(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let J;do J=F();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>s,scan:l?ne:F,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>D}}e.createScanner=M;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function a(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function v(t,l){const s=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function D(R,E,k,O){o.value=R,o.offset=E,o.length=k,o.type=O,o.colonOffset=void 0,n=o}try{c(t,{onObjectBegin:(R,E)=>{if(l<=R)throw i;n=void 0,b=l>R,s.push("")},onObjectProperty:(R,E,k)=>{if(l<E||(D(R,E,k,"property"),s[s.length-1]=R,l<=E+k))throw i},onObjectEnd:(R,E)=>{if(l<=R)throw i;n=void 0,s.pop()},onArrayBegin:(R,E)=>{if(l<=R)throw i;n=void 0,s.push(0)},onArrayEnd:(R,E)=>{if(l<=R)throw i;n=void 0,s.pop()},onLiteralValue:(R,E,k)=>{if(l<E||(D(R,E,k,u(R)),l<=E+k))throw i},onSeparator:(R,E,k)=>{if(l<=E)throw i;if(R===":"&&n&&n.type==="property")n.colonOffset=E,b=!1,n=void 0;else if(R===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(b=!0,s[s.length-1]=""),n=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:n,isAtPropertyKey:b,matches:R=>{let E=0;for(let k=0;E<R.length&&k<s.length;k++)if(R[E]===s[k]||R[E]==="*")E++;else if(R[E]!=="**")return!1;return E===R.length}}}e.getLocation=v;function S(t,l=[],s=_.DEFAULT){let i=null,n=[];const o=[];function b(R){Array.isArray(n)?n.push(R):i!==null&&(n[i]=R)}return c(t,{onObjectBegin:()=>{const R={};b(R),o.push(n),n=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const R=[];b(R),o.push(n),n=R,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:b,onError:(R,E,k)=>{l.push({error:R,offset:E,length:k})}},s),n[0]}e.parse=S;function f(t,l=[],s=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function o(R){return i.children.push(R),R}c(t,{onObjectBegin:R=>{i=o({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,E,k)=>{i=o({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:E,length:k,parent:i})},onObjectEnd:(R,E)=>{i.length=R+E-i.offset,i=i.parent,n(R+E)},onArrayBegin:(R,E)=>{i=o({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,E)=>{i.length=R+E-i.offset,i=i.parent,n(R+E)},onLiteralValue:(R,E,k)=>{o({type:u(R),offset:E,length:k,parent:i,value:R}),n(E+k)},onSeparator:(R,E,k)=>{i.type==="property"&&(R===":"?i.colonOffset=E:R===","&&n(E))},onError:(R,E,k)=>{l.push({error:R,offset:E,length:k})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=f;function y(t,l){if(!t)return;let s=t;for(const i of l)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=y;function w(t){if(!t.parent||!t.parent.children)return[];const l=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;l.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&l.push(s)}return l}e.getNodePath=w;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const l=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(l[s.children[0].value]=g(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function m(t,l,s=!1){return l>=t.offset&&l<t.offset+t.length||s&&l===t.offset+t.length}e.contains=m;function h(t,l,s=!1){if(m(t,l,s)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const o=h(i[n],l,s);if(o)return o}return t}}e.findNodeAtOffset=h;function c(t,l,s=_.DEFAULT){const i=M(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?ie=>Q(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=n(l.onObjectBegin),D=o(l.onObjectProperty),R=n(l.onObjectEnd),E=n(l.onArrayBegin),k=n(l.onArrayEnd),O=o(l.onLiteralValue),F=o(l.onSeparator),q=n(l.onComment),ne=o(l.onError),J=s&&s.disallowComments,ce=s&&s.allowTrailingComma;function re(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:J||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(Q){case 12:case 13:J?se(10):q();break;case 16:se(1);break;case 15:case 14:break;default:return Q}}}function se(Q,ie=[],oe=[]){if(ne(Q),ie.length+oe.length>0){let N=i.getToken();for(;N!==17;){if(ie.indexOf(N)!==-1){re();break}else if(oe.indexOf(N)!==-1)break;N=re()}}}function G(Q){const ie=i.getTokenValue();return Q?O(ie):D(ie),re(),!0}function V(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(se(2),Q=0)}catch{se(2)}O(Q);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return re(),!0}function x(){return i.getToken()!==10?(se(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(F(":"),re(),H()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function W(){b(),re();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||se(4,[],[]),F(","),re(),i.getToken()===2&&ce)break}else Q&&se(6,[],[]);x()||se(4,[],[2,5]),Q=!0}return R(),i.getToken()!==2?se(7,[2],[]):re(),!0}function U(){E(),re();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||se(4,[],[]),F(","),re(),i.getToken()===4&&ce)break}else Q&&se(6,[],[]);H()||se(4,[],[4,5]),Q=!0}return k(),i.getToken()!==4?se(8,[4],[]):re(),!0}function H(){switch(i.getToken()){case 3:return U();case 1:return W();case 10:return G(!0);default:return V()}}return re(),i.getToken()===17?s.allowEmptyContent?!0:(se(4,[],[]),!1):H()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=c;function P(t,l){const s=M(t),i=[];let n,o=0,b;do switch(b=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:o!==b&&i.push(t.substring(o,b)),l!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,l)),o=s.getPosition();break}while(n!==17);return i.join("")}e.stripComments=P;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ee[136],te([0,1,44]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(a,p,v){let S,f,y,w,g;if(p){for(w=p.offset,g=w+p.length,y=w;y>0&&!d(a,y-1);)y--;let b=g;for(;b<a.length&&!d(a,b);)b++;f=a.substring(y,b),S=M(f,v)}else f=a,S=0,y=0,w=0,g=a.length;const m=C(v,a);let h=!1,c=0,P;v.insertSpaces?P=_(" ",v.tabSize||4):P="	";const u=(0,I.createScanner)(f,!1);let t=!1;function l(){return m+_(P,S+c)}function s(){let b=u.scan();for(h=!1;b===15||b===14;)h=h||b===14,b=u.scan();return t=b===16||u.getTokenError()!==0,b}const i=[];function n(b,D,R){!t&&D<g&&R>w&&a.substring(D,R)!==b&&i.push({offset:D,length:R-D,content:b})}let o=s();if(o!==17){const b=u.getTokenOffset()+y,D=_(P,S);n(D,y,b)}for(;o!==17;){let b=u.getTokenOffset()+u.getTokenLength()+y,D=s(),R="";for(;!h&&(D===12||D===13);){const k=u.getTokenOffset()+y;n(" ",b,k),b=u.getTokenOffset()+u.getTokenLength()+y,R=D===12?l():"",D=s()}if(D===2)o!==1&&(c--,R=l());else if(D===4)o!==3&&(c--,R=l());else{switch(o){case 3:case 1:c++,R=l();break;case 5:case 12:R=l();break;case 13:h?R=l():R=" ";break;case 6:R=" ";break;case 10:if(D===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?R=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}h&&(D===12||D===13)&&(R=l())}const E=u.getTokenOffset()+y;n(R,b,E),o=D}return i}e.format=L;function r(a,p){const v=JSON.stringify(a,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?v.replace(/\r\n|\r|\n/g,p.eol):v}e.toFormattedString=r;function _(a,p){let v="";for(let S=0;S<p;S++)v+=a;return v}function M(a,p){let v=0,S=0;const f=p.tabSize||4;for(;v<a.length;){const y=a.charAt(v);if(y===" ")S++;else if(y==="	")S+=f;else break;v++}return Math.floor(S/f)}function C(a,p){for(let v=0;v<p.length;v++){const S=p.charAt(v);if(S==="\r")return v+1<p.length&&p.charAt(v+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return a&&a.eol||`
`}e.getEOL=C;function d(a,p){return`\r
`.indexOf(a.charAt(p))!==-1}e.isEOL=d}),define(ee[137],te([0,1,44,136]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(a,p,v){return _(a,p,void 0,v)}e.removeProperty=r;function _(a,p,v,S,f){const y=p.slice(),w=[],g=(0,I.parseTree)(a,w);let m,h;for(;y.length>0&&(h=y.pop(),m=(0,I.findNodeAtLocation)(g,y),m===void 0&&v!==void 0);)typeof h=="string"?v={[h]:v}:v=[v];if(m)if(m.type==="object"&&typeof h=="string"&&Array.isArray(m.children)){const c=(0,I.findNodeAtLocation)(m,[h]);if(c!==void 0)if(v===void 0){if(!c.parent)throw new Error("Malformed AST");const P=m.children.indexOf(c.parent);let u,t=c.parent.offset+c.parent.length;if(P>0){const l=m.children[P-1];u=l.offset+l.length}else u=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return M(a,{offset:u,length:t-u,content:""},S)}else return M(a,{offset:c.offset,length:c.length,content:JSON.stringify(v)},S);else{if(v===void 0)return[];const P=`${JSON.stringify(h)}: ${JSON.stringify(v)}`,u=f?f(m.children.map(l=>l.children[0].value)):m.children.length;let t;if(u>0){const l=m.children[u-1];t={offset:l.offset+l.length,length:0,content:","+P}}else m.children.length===0?t={offset:m.offset+1,length:0,content:P}:t={offset:m.offset+1,length:0,content:P+","};return M(a,t,S)}}else if(m.type==="array"&&typeof h=="number"&&Array.isArray(m.children))if(v!==void 0){const c=`${JSON.stringify(v)}`;let P;if(m.children.length===0||h===0)P={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const u=h===-1||h>m.children.length?m.children.length:h,t=m.children[u-1];P={offset:t.offset+t.length,length:0,content:","+c}}return M(a,P,S)}else{const c=h,P=m.children[c];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const t=m.children[c-1],l=t.offset+t.length,s=m.offset+m.length;u={offset:l,length:s-2-l,content:""}}else u={offset:P.offset,length:m.children[c+1].offset-P.offset,content:""};return M(a,u,S)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${m.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return M(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(v)},S)}}e.setProperty=_;function M(a,p,v){let S=C(a,p),f=p.offset,y=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;f>0&&!(0,L.isEOL)(S,f-1);)f--;for(;y<S.length&&!(0,L.isEOL)(S,y);)y++}const w=(0,L.format)(S,{offset:f,length:y-f},v);for(let m=w.length-1;m>=0;m--){const h=w[m];S=C(S,h),f=Math.min(f,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const g=a.length-(S.length-y)-f;return[{offset:f,length:g,content:S.substring(f,y)}]}e.withFormatting=M;function C(a,p){return a.substring(0,p.offset)+p.content+a.substring(p.offset+p.length)}e.applyEdit=C;function d(a,p){const v=p.slice(0).sort((f,y)=>{const w=f.offset-y.offset;return w===0?f.length-y.length:w});let S=a.length;for(let f=v.length-1;f>=0;f--){const y=v[f];if(y.offset+y.length<=S)a=C(a,y);else throw new Error("Overlapping edit");S=y.offset}return a}e.applyEdits=d}),define(ee[83],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(ee[101],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{static{this.Undefined=new I(void 0)}constructor(_){this.element=_,this.next=I.Undefined,this.prev=I.Undefined}}class L{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let _=this._first;for(;_!==I.Undefined;){const M=_.next;_.prev=I.Undefined,_.next=I.Undefined,_=M}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,M){const C=new I(_);if(this._first===I.Undefined)this._first=C,this._last=C;else if(M){const a=this._last;this._last=C,C.prev=a,a.next=C}else{const a=this._first;this._first=C,C.next=a,a.prev=C}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(C))}}shift(){if(this._first!==I.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==I.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==I.Undefined&&_.next!==I.Undefined){const M=_.prev;M.next=_.next,_.next.prev=M}else _.prev===I.Undefined&&_.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):_.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):_.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==I.Undefined;)yield _.element,_=_.next}}e.LinkedList=L}),define(ee[31],te([0,1]),function(K,e){"use strict";var I,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function _(h,c,P){let u=h.get(c);return u===void 0&&(u=P,h.set(c,u)),u}e.getOrSet=_;function M(h){const c=[];return h.forEach((P,u)=>{c.push(`${u} => ${P}`)}),`Map(${h.size}) {${c.join(", ")}}`}e.mapToString=M;function C(h){const c=[];return h.forEach(P=>{c.push(P)}),`Set(${h.size}) {${c.join(", ")}}`}e.setToString=C;class d{constructor(c,P){this.uri=c,this.value=P}}function a(h){return Array.isArray(h)}class p{static{this.defaultToKey=c=>c.toString()}constructor(c,P){if(this[I]="ResourceMap",c instanceof p)this.map=new Map(c.map),this.toKey=P??p.defaultToKey;else if(a(c)){this.map=new Map,this.toKey=P??p.defaultToKey;for(const[u,t]of c)this.set(u,t)}else this.map=new Map,this.toKey=c??p.defaultToKey}set(c,P){return this.map.set(this.toKey(c),new d(c,P)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,P){typeof P<"u"&&(c=c.bind(P));for(const[u,t]of this.map)c(t.value,t.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=p;class v{constructor(c,P){this[L]="ResourceSet",!c||typeof c=="function"?this._map=new p(c):(this._map=new p(P),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,P){this._map.forEach((u,t)=>c.call(P,t,t,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=v;var S;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(S||(e.Touch=S={}));class f{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,P=0){const u=this._map.get(c);if(u)return P!==0&&this.touch(u,P),u.value}set(c,P,u=0){let t=this._map.get(c);if(t)t.value=P,u!==0&&this.touch(t,u);else{switch(t={key:c,value:P,next:void 0,previous:void 0},u){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(c,t),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const P=this._map.get(c);if(P)return this._map.delete(c),this.removeItem(P),this._size--,P.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,P){const u=this._state;let t=this._head;for(;t;){if(P?c.bind(P)(t.value,t.key,this):c(t.value,t.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,P=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==P)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.key,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}values(){const c=this,P=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==P)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.value,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}entries(){const c=this,P=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==P)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:[u.key,u.value],done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let P=this._head,u=this.size;for(;P&&u>c;)this._map.delete(P.key),P=P.next,u--;this._head=P,this._size=u,P&&(P.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const P=c.next,u=c.previous;if(!P||!u)throw new Error("Invalid list");P.previous=u,u.next=P}c.next=void 0,c.previous=void 0,this._state++}touch(c,P){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(P!==1&&P!==2)){if(P===1){if(c===this._head)return;const u=c.next,t=c.previous;c===this._tail?(t.next=void 0,this._tail=t):(u.previous=t,t.next=u),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(P===2){if(c===this._tail)return;const u=c.next,t=c.previous;c===this._head?(u.previous=void 0,this._head=u):(u.previous=t,t.next=u),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((P,u)=>{c.push([u,P])}),c}fromJSON(c){this.clear();for(const[P,u]of c)this.set(P,u)}}e.LinkedMap=f;class y extends f{constructor(c,P=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,P),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,P=2){return super.get(c,P)}peek(c){return super.get(c,0)}set(c,P){return super.set(c,P,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class w{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let P=this.map.get(c)||0;return P===0?!1:(P--,P===0?this.map.delete(c):this.map.set(c,P),!0)}has(c){return this.map.has(c)}}e.CounterSet=w;class g{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[P,u]of c)this.set(P,u)}clear(){this._m1.clear(),this._m2.clear()}set(c,P){this._m1.set(c,P),this._m2.set(P,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const P=this._m1.get(c);return P===void 0?!1:(this._m1.delete(c),this._m2.delete(P),!0)}forEach(c,P){this._m1.forEach((u,t)=>{c.call(P,u,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=g;class m{constructor(){this.map=new Map}add(c,P){let u=this.map.get(c);u||(u=new Set,this.map.set(c,u)),u.add(P)}delete(c,P){const u=this.map.get(c);u&&(u.delete(P),u.size===0&&this.map.delete(c))}forEach(c,P){const u=this.map.get(c);u&&u.forEach(P)}get(c){const P=this.map.get(c);return P||new Set}}e.SetMap=m}),define(ee[2],te([0,1,23,133,31,82,67]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const C=!1;let d=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(k){let O=this.livingDisposables.get(k);return O||(O={parent:null,source:null,isSingleton:!1,value:k,idx:a.idx++},this.livingDisposables.set(k,O)),O}trackDisposable(k){const O=this.getDisposableData(k);O.source||(O.source=new Error().stack)}setParent(k,O){const F=this.getDisposableData(k);F.parent=O}markAsDisposed(k){this.livingDisposables.delete(k)}markAsSingleton(k){this.getDisposableData(k).isSingleton=!0}getRootParent(k,O){const F=O.get(k);if(F)return F;const q=k.parent?this.getRootParent(this.getDisposableData(k.parent),O):k;return O.set(k,q),q}getTrackedDisposables(){const k=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,k).isSingleton).map(([F])=>F).flat()}computeLeakingDisposables(k=10,O){let F;if(O)F=O;else{const re=new Map,se=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,re).isSingleton);if(se.length===0)return;const G=new Set(se.map(V=>V.value));if(F=se.filter(V=>!(V.parent&&G.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function q(re){function se(V,x){for(;V.length>0&&x.some(W=>typeof W=="string"?W===V[0]:V[0].match(W));)V.shift()}const G=re.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return se(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const ne=new r.SetMap;for(const re of F){const se=q(re);for(let G=0;G<=se.length;G++)ne.add(se.slice(0,G).join(`
`),re)}F.sort((0,I.compareBy)(re=>re.idx,I.numberComparator));let J="",ce=0;for(const re of F.slice(0,k)){ce++;const se=q(re),G=[];for(let V=0;V<se.length;V++){let x=se[V];x=`(shared with ${ne.get(se.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${x}`;const U=ne.get(se.slice(0,V).join(`
`)),H=(0,L.groupBy)([...U].map(Q=>q(Q)[V]),Q=>Q);delete H[se[V]];for(const[Q,ie]of Object.entries(H))G.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${Q}`);G.unshift(x)}J+=`


==================== Leaking disposable ${ce}/${F.length}: ${re.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return F.length>k&&(J+=`


... and ${F.length-k} more leaking disposables

`),{leaks:F,details:J}}}e.DisposableTracker=a;function p(E){d=E}if(e.setDisposableTracker=p,C){const E="__is_disposable_tracked__";p(new class{trackDisposable(k){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[E]||console.log(O)},3e3)}setParent(k,O){if(k&&k!==t.None)try{k[E]=!0}catch{}}markAsDisposed(k){if(k&&k!==t.None)try{k[E]=!0}catch{}}markAsSingleton(k){}})}function v(E){return d?.trackDisposable(E),E}e.trackDisposable=v;function S(E){d?.markAsDisposed(E)}e.markAsDisposed=S;function f(E,k){d?.setParent(E,k)}function y(E,k){if(d)for(const O of E)d.setParent(O,k)}function w(E){return d?.markAsSingleton(E),E}e.markAsSingleton=w;function g(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.isDisposable=g;function m(E){if(M.Iterable.is(E)){const k=[];for(const O of E)if(O)try{O.dispose()}catch(F){k.push(F)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.dispose=m;function h(E){for(const k of E)g(k)&&k.dispose();return[]}e.disposeIfDisposable=h;function c(...E){const k=P(()=>m(E));return y(E,k),k}e.combinedDisposable=c;function P(E){const k=v({dispose:(0,_.createSingleCallFunction)(()=>{S(k),E()})});return k}e.toDisposable=P;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return f(k,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(k),k.dispose()}}deleteAndLeak(k){k&&this._toDispose.has(k)&&(this._toDispose.delete(k),f(k,null))}}e.DisposableStore=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new u,v(this),f(this._store,this)}dispose(){S(this),this._store.dispose()}_register(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(k)}}e.Disposable=t;class l{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(k){this._isDisposed||k===this._value||(this._value?.dispose(),k&&f(k,this),this._value=k)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const k=this._value;return this._value=void 0,k&&f(k,null),k}}e.MutableDisposable=l;class s{constructor(k){this._disposable=k,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(k){let O=k;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,S(this))},this}}e.SafeDisposable=i;class n{constructor(){this.references=new Map}acquire(k,...O){let F=this.references.get(k);F||(F={counter:0,object:this.createReferencedObject(k,...O)},this.references.set(k,F));const{object:q}=F,ne=(0,_.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(k,F.object),this.references.delete(k))});return F.counter++,{object:q,dispose:ne}}}e.ReferenceCollection=n;class o{constructor(k){this.referenceCollection=k}async acquire(k,...O){const F=this.referenceCollection.acquire(k,...O);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(q){throw F.dispose(),q}}}e.AsyncReferenceCollection=o;class b{constructor(k){this.object=k}dispose(){}}e.ImmortalReference=b;function D(E){const k=new u;try{E(k)}finally{k.dispose()}}e.disposeOnReturn=D;class R{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(k){return this._store.has(k)}get size(){return this._store.size}get(k){return this._store.get(k)}set(k,O,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(k)?.dispose(),this._store.set(k,O)}deleteAndDispose(k){this._store.get(k)?.dispose(),this._store.delete(k)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=R}),define(ee[84],te([0,1,31]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new I.LRUCache(1e4);function r(a){return d(a,"NFC",L)}e.normalizeNFC=r;const _=new I.LRUCache(1e4);function M(a){return d(a,"NFD",_)}e.normalizeNFD=M;const C=/[^\u0000-\u0080]/;function d(a,p,v){if(!a)return a;const S=v.get(a);if(S)return S;let f;return C.test(a)?f=a.normalize(p):f=a,v.set(a,f),f}e.removeAccents=function(){const a=/[\u0300-\u036f]/g;return function(p){return M(p).replace(a,"")}}()}),define(ee[138],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(C,d,a){return Math.min(Math.max(C,d),a)}e.clamp=I;function L(C,d){return(d+C%d)%d}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class _{constructor(){this._n=1,this._val=0}update(d){return this._val=this._val+(d-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=_;class M{constructor(d){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(d),this._values.fill(0,0,d)}update(d){const a=this._values[this._index];return this._values[this._index]=d,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=d,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function K(r){const _=[];typeof r=="number"&&_.push("code/timeOrigin",r);function M(d){_.push(d,Date.now())}function C(){const d=[];for(let a=0;a<_.length;a+=2)d.push({name:_[a],startTime:_[a+1]});return d}return{mark:M,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const M of performance.getEntriesByType("mark"))_.push({name:M.name,startTime:Math.round(r+M.startTime)});return _}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function I(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:K)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function I(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return K[L].call(r.exports,r,r.exports,I),r.l=!0,r.exports}return I.m=K,I.c=e,I.d=function(L,r,_){I.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:_})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,r){if(1&r&&(L=I(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var _=Object.create(null);if(I.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var M in L)I.d(_,M,function(C){return L[C]}.bind(null,M));return _},I.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(r,"a",r),r},I.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},I.p="",I(I.s=0)}([function(K,e,I){(function(L){var r;e=K.exports=oe,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],d=e.src=[],a=0,p=a++;d[p]="0|[1-9]\\d*";var v=a++;d[v]="[0-9]+";var S=a++;d[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;d[f]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var y=a++;d[y]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var w=a++;d[w]="(?:"+d[p]+"|"+d[S]+")";var g=a++;d[g]="(?:"+d[v]+"|"+d[S]+")";var m=a++;d[m]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var h=a++;d[h]="(?:-?("+d[g]+"(?:\\."+d[g]+")*))";var c=a++;d[c]="[0-9A-Za-z-]+";var P=a++;d[P]="(?:\\+("+d[c]+"(?:\\."+d[c]+")*))";var u=a++,t="v?"+d[f]+d[m]+"?"+d[P]+"?";d[u]="^"+t+"$";var l="[v=\\s]*"+d[y]+d[h]+"?"+d[P]+"?",s=a++;d[s]="^"+l+"$";var i=a++;d[i]="((?:<|>)?=?)";var n=a++;d[n]=d[v]+"|x|X|\\*";var o=a++;d[o]=d[p]+"|x|X|\\*";var b=a++;d[b]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[m]+")?"+d[P]+"?)?)?";var D=a++;d[D]="[v=\\s]*("+d[n]+")(?:\\.("+d[n]+")(?:\\.("+d[n]+")(?:"+d[h]+")?"+d[P]+"?)?)?";var R=a++;d[R]="^"+d[i]+"\\s*"+d[b]+"$";var E=a++;d[E]="^"+d[i]+"\\s*"+d[D]+"$";var k=a++;d[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=a++;d[O]="(?:~>?)";var F=a++;d[F]="(\\s*)"+d[O]+"\\s+",C[F]=new RegExp(d[F],"g");var q=a++;d[q]="^"+d[O]+d[b]+"$";var ne=a++;d[ne]="^"+d[O]+d[D]+"$";var J=a++;d[J]="(?:\\^)";var ce=a++;d[ce]="(\\s*)"+d[J]+"\\s+",C[ce]=new RegExp(d[ce],"g");var re=a++;d[re]="^"+d[J]+d[b]+"$";var se=a++;d[se]="^"+d[J]+d[D]+"$";var G=a++;d[G]="^"+d[i]+"\\s*("+l+")$|^$";var V=a++;d[V]="^"+d[i]+"\\s*("+t+")$|^$";var x=a++;d[x]="(\\s*)"+d[i]+"\\s*("+l+"|"+d[b]+")",C[x]=new RegExp(d[x],"g");var W=a++;d[W]="^\\s*("+d[b]+")\\s+-\\s+("+d[b]+")\\s*$";var U=a++;d[U]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var H=a++;d[H]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)r(Q,d[Q]),C[Q]||(C[Q]=new RegExp(d[Q]));function ie(Y,le){if(Y instanceof oe)return Y;if(typeof Y!="string"||Y.length>_||!(le?C[s]:C[u]).test(Y))return null;try{return new oe(Y,le)}catch{return null}}function oe(Y,le){if(Y instanceof oe){if(Y.loose===le)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof oe))return new oe(Y,le);r("SemVer",Y,le),this.loose=le;var ge=Y.trim().match(le?C[s]:C[u]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(De){if(/^[0-9]+$/.test(De)){var Le=+De;if(Le>=0&&Le<M)return Le}return De}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ie,e.valid=function(Y,le){var ge=ie(Y,le);return ge?ge.version:null},e.clean=function(Y,le){var ge=ie(Y.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(Y){return r("SemVer.compare",this.version,this.loose,Y),Y instanceof oe||(Y=new oe(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},oe.prototype.compareMain=function(Y){return Y instanceof oe||(Y=new oe(Y,this.loose)),A(this.major,Y.major)||A(this.minor,Y.minor)||A(this.patch,Y.patch)},oe.prototype.comparePre=function(Y){if(Y instanceof oe||(Y=new oe(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],De=Y.prerelease[le];if(r("prerelease compare",le,ge,De),ge===void 0&&De===void 0)return 0;if(De===void 0)return 1;if(ge===void 0)return-1;if(ge!==De)return A(ge,De)}while(++le)},oe.prototype.inc=function(Y,le){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,le,ge,De){typeof ge=="string"&&(De=ge,ge=void 0);try{return new oe(Y,ge).inc(le,De).version}catch{return null}},e.diff=function(Y,le){if(z(Y,le))return null;var ge=ie(Y),De=ie(le);if(ge.prerelease.length||De.prerelease.length){for(var Le in ge)if((Le==="major"||Le==="minor"||Le==="patch")&&ge[Le]!==De[Le])return"pre"+Le;return"prerelease"}for(var Le in ge)if((Le==="major"||Le==="minor"||Le==="patch")&&ge[Le]!==De[Le])return Le},e.compareIdentifiers=A;var N=/^[0-9]+$/;function A(Y,le){var ge=N.test(Y),De=N.test(le);return ge&&De&&(Y=+Y,le=+le),ge&&!De?-1:De&&!ge?1:Y<le?-1:Y>le?1:0}function T(Y,le,ge){return new oe(Y,ge).compare(new oe(le,ge))}function $(Y,le,ge){return T(Y,le,ge)>0}function B(Y,le,ge){return T(Y,le,ge)<0}function z(Y,le,ge){return T(Y,le,ge)===0}function j(Y,le,ge){return T(Y,le,ge)!==0}function ae(Y,le,ge){return T(Y,le,ge)>=0}function fe(Y,le,ge){return T(Y,le,ge)<=0}function ue(Y,le,ge,De){var Le;switch(le){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Le=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Le=Y!==ge;break;case"":case"=":case"==":Le=z(Y,ge,De);break;case"!=":Le=j(Y,ge,De);break;case">":Le=$(Y,ge,De);break;case">=":Le=ae(Y,ge,De);break;case"<":Le=B(Y,ge,De);break;case"<=":Le=fe(Y,ge,De);break;default:throw new TypeError("Invalid operator: "+le)}return Le}function de(Y,le){if(Y instanceof de){if(Y.loose===le)return Y;Y=Y.value}if(!(this instanceof de))return new de(Y,le);r("comparator",Y,le),this.loose=le,this.parse(Y),this.semver===be?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(Y,le){return A(le,Y)},e.major=function(Y,le){return new oe(Y,le).major},e.minor=function(Y,le){return new oe(Y,le).minor},e.patch=function(Y,le){return new oe(Y,le).patch},e.compare=T,e.compareLoose=function(Y,le){return T(Y,le,!0)},e.rcompare=function(Y,le,ge){return T(le,Y,ge)},e.sort=function(Y,le){return Y.sort(function(ge,De){return e.compare(ge,De,le)})},e.rsort=function(Y,le){return Y.sort(function(ge,De){return e.rcompare(ge,De,le)})},e.gt=$,e.lt=B,e.eq=z,e.neq=j,e.gte=ae,e.lte=fe,e.cmp=ue,e.Comparator=de;var be={};function we(Y,le){if(Y instanceof we)return Y.loose===le?Y:new we(Y.raw,le);if(Y instanceof de)return new we(Y.value,le);if(!(this instanceof we))return new we(Y,le);if(this.loose=le,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function ye(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function ke(Y,le,ge,De,Le,Fe,Ae,ze,Be,X,he,me,Ee){return((le=ye(ge)?"":ye(De)?">="+ge+".0.0":ye(Le)?">="+ge+"."+De+".0":">="+le)+" "+(ze=ye(Be)?"":ye(X)?"<"+(+Be+1)+".0.0":ye(he)?"<"+Be+"."+(+X+1)+".0":me?"<="+Be+"."+X+"."+he+"-"+me:"<="+ze)).trim()}function Ne(Y,le){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Y.length;ge++)if(r(Y[ge].semver),Y[ge].semver!==be&&Y[ge].semver.prerelease.length>0){var De=Y[ge].semver;if(De.major===le.major&&De.minor===le.minor&&De.patch===le.patch)return!0}return!1}return!0}function pe(Y,le,ge){try{le=new we(le,ge)}catch{return!1}return le.test(Y)}function ve(Y,le,ge,De){var Le,Fe,Ae,ze,Be;switch(Y=new oe(Y,De),le=new we(le,De),ge){case">":Le=$,Fe=fe,Ae=B,ze=">",Be=">=";break;case"<":Le=B,Fe=ae,Ae=$,ze="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Y,le,De))return!1;for(var X=0;X<le.set.length;++X){var he=le.set[X],me=null,Ee=null;if(he.forEach(function(Me){Me.semver===be&&(Me=new de(">=0.0.0")),me=me||Me,Ee=Ee||Me,Le(Me.semver,me.semver,De)?me=Me:Ae(Me.semver,Ee.semver,De)&&(Ee=Me)}),me.operator===ze||me.operator===Be||(!Ee.operator||Ee.operator===ze)&&Fe(Y,Ee.semver)||Ee.operator===Be&&Ae(Y,Ee.semver))return!1}return!0}de.prototype.parse=function(Y){var le=this.loose?C[G]:C[V],ge=Y.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=be},de.prototype.toString=function(){return this.value},de.prototype.test=function(Y){return r("Comparator.test",Y,this.loose),this.semver===be||(typeof Y=="string"&&(Y=new oe(Y,this.loose)),ue(Y,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Y,le){if(!(Y instanceof de))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new we(Y.value,le),pe(this.value,ge,le);if(Y.operator==="")return ge=new we(this.value,le),pe(Y.semver,ge,le);var De=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Le=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Fe=this.semver.version===Y.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),ze=ue(this.semver,"<",Y.semver,le)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Be=ue(this.semver,">",Y.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return De||Le||Fe&&Ae||ze||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Y){var le=this.loose;Y=Y.trim(),r("range",Y,le);var ge=le?C[U]:C[W];Y=Y.replace(ge,ke),r("hyphen replace",Y),Y=Y.replace(C[x],"$1$2$3"),r("comparator trim",Y,C[x]),Y=(Y=(Y=Y.replace(C[F],"$1~")).replace(C[ce],"$1^")).split(/\s+/).join(" ");var De=le?C[G]:C[V],Le=Y.split(" ").map(function(Fe){return function(Ae,ze){return r("comp",Ae),Ae=function(Be,X){return Be.trim().split(/\s+/).map(function(he){return function(me,Ee){r("caret",me,Ee);var Me=Ee?C[se]:C[re];return me.replace(Me,function(We,Oe,Te,$e,qe){var xe;return r("caret",me,We,Oe,Te,$e,qe),ye(Oe)?xe="":ye(Te)?xe=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":ye($e)?xe=Oe==="0"?">="+Oe+"."+Te+".0 <"+Oe+"."+(+Te+1)+".0":">="+Oe+"."+Te+".0 <"+(+Oe+1)+".0.0":qe?(r("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),xe=Oe==="0"?Te==="0"?">="+Oe+"."+Te+"."+$e+qe+" <"+Oe+"."+Te+"."+(+$e+1):">="+Oe+"."+Te+"."+$e+qe+" <"+Oe+"."+(+Te+1)+".0":">="+Oe+"."+Te+"."+$e+qe+" <"+(+Oe+1)+".0.0"):(r("no pr"),xe=Oe==="0"?Te==="0"?">="+Oe+"."+Te+"."+$e+" <"+Oe+"."+Te+"."+(+$e+1):">="+Oe+"."+Te+"."+$e+" <"+Oe+"."+(+Te+1)+".0":">="+Oe+"."+Te+"."+$e+" <"+(+Oe+1)+".0.0"),r("caret return",xe),xe})}(he,X)}).join(" ")}(Ae,ze),r("caret",Ae),Ae=function(Be,X){return Be.trim().split(/\s+/).map(function(he){return function(me,Ee){var Me=Ee?C[ne]:C[q];return me.replace(Me,function(We,Oe,Te,$e,qe){var xe;return r("tilde",me,We,Oe,Te,$e,qe),ye(Oe)?xe="":ye(Te)?xe=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":ye($e)?xe=">="+Oe+"."+Te+".0 <"+Oe+"."+(+Te+1)+".0":qe?(r("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),xe=">="+Oe+"."+Te+"."+$e+qe+" <"+Oe+"."+(+Te+1)+".0"):xe=">="+Oe+"."+Te+"."+$e+" <"+Oe+"."+(+Te+1)+".0",r("tilde return",xe),xe})}(he,X)}).join(" ")}(Ae,ze),r("tildes",Ae),Ae=function(Be,X){return r("replaceXRanges",Be,X),Be.split(/\s+/).map(function(he){return function(me,Ee){me=me.trim();var Me=Ee?C[E]:C[R];return me.replace(Me,function(We,Oe,Te,$e,qe,xe){r("xRange",me,We,Oe,Te,$e,qe,xe);var Je=ye(Te),Ye=Je||ye($e),tt=Ye||ye(qe);return Oe==="="&&tt&&(Oe=""),Je?We=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&tt?(Ye&&($e=0),tt&&(qe=0),Oe===">"?(Oe=">=",Ye?(Te=+Te+1,$e=0,qe=0):tt&&($e=+$e+1,qe=0)):Oe==="<="&&(Oe="<",Ye?Te=+Te+1:$e=+$e+1),We=Oe+Te+"."+$e+"."+qe):Ye?We=">="+Te+".0.0 <"+(+Te+1)+".0.0":tt&&(We=">="+Te+"."+$e+".0 <"+Te+"."+(+$e+1)+".0"),r("xRange return",We),We})}(he,X)}).join(" ")}(Ae,ze),r("xrange",Ae),Ae=function(Be,X){return r("replaceStars",Be,X),Be.trim().replace(C[H],"")}(Ae,ze),r("stars",Ae),Ae}(Fe,le)}).join(" ").split(/\s+/);return this.loose&&(Le=Le.filter(function(Fe){return!!Fe.match(De)})),Le=Le.map(function(Fe){return new de(Fe,le)})},we.prototype.intersects=function(Y,le){if(!(Y instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(De){return Y.set.some(function(Le){return Le.every(function(Fe){return De.intersects(Fe,le)})})})})},e.toComparators=function(Y,le){return new we(Y,le).set.map(function(ge){return ge.map(function(De){return De.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new oe(Y,this.loose));for(var le=0;le<this.set.length;le++)if(Ne(this.set[le],Y))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Y,le,ge){var De=null,Le=null;try{var Fe=new we(le,ge)}catch{return null}return Y.forEach(function(Ae){Fe.test(Ae)&&(De&&Le.compare(Ae)!==-1||(Le=new oe(De=Ae,ge)))}),De},e.minSatisfying=function(Y,le,ge){var De=null,Le=null;try{var Fe=new we(le,ge)}catch{return null}return Y.forEach(function(Ae){Fe.test(Ae)&&(De&&Le.compare(Ae)!==1||(Le=new oe(De=Ae,ge)))}),De},e.validRange=function(Y,le){try{return new we(Y,le).range||"*"}catch{return null}},e.ltr=function(Y,le,ge){return ve(Y,le,"<",ge)},e.gtr=function(Y,le,ge){return ve(Y,le,">",ge)},e.outside=ve,e.prerelease=function(Y,le){var ge=ie(Y,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,le,ge){return Y=new we(Y,ge),le=new we(le,ge),Y.intersects(le)},e.coerce=function(Y){if(Y instanceof oe)return Y;if(typeof Y!="string")return null;var le=Y.match(C[k]);return le==null?null:ie((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,I(1))},function(K,e){var I,L,r=K.exports={};function _(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function C(g){if(I===setTimeout)return setTimeout(g,0);if((I===_||!I)&&setTimeout)return I=setTimeout,setTimeout(g,0);try{return I(g,0)}catch{try{return I.call(null,g,0)}catch{return I.call(this,g,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:_}catch{I=_}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var d,a=[],p=!1,v=-1;function S(){p&&d&&(p=!1,d.length?a=d.concat(a):v=-1,a.length&&f())}function f(){if(!p){var g=C(S);p=!0;for(var m=a.length;m;){for(d=a,a=[];++v<m;)d&&d[v].run();v=-1,m=a.length}d=null,p=!1,function(h){if(L===clearTimeout)return clearTimeout(h);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(h);try{L(h)}catch{try{return L.call(null,h)}catch{return L.call(this,h)}}}(g)}}function y(g,m){this.fun=g,this.array=m}function w(){}r.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)m[h-1]=arguments[h];a.push(new y(g,m)),a.length!==1||p||C(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=w,r.addListener=w,r.once=w,r.off=w,r.removeListener=w,r.removeAllListeners=w,r.emit=w,r.prependListener=w,r.prependOnceListener=w,r.listeners=function(g){return[]},r.binding=function(g){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(g){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(ee[139],te([0,1]),function(K,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(C,d,a){this.level=C,this.key=d,this.value=a,this.forward=[]}}const r=void 0;class _{constructor(C,d=2**16){this.comparator=C,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(d)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r)}has(C){return!!_._search(this,C,this.comparator)}get(C){return _._search(this,C,this.comparator)?.value}set(C,d){return _._insert(this,C,d,this.comparator)&&(this._size+=1),this}delete(C){const d=_._delete(this,C,this.comparator);return d&&(this._size-=1),d}forEach(C,d){let a=this._header.forward[0];for(;a;)C.call(d,a.value,a.key,this),a=a.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",d=this._header.forward[0];for(;d;)C+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return C}static _search(C,d,a){let p=C._header;for(let v=C._level-1;v>=0;v--)for(;p.forward[v]&&a(p.forward[v].key,d)<0;)p=p.forward[v];if(p=p.forward[0],p&&a(p.key,d)===0)return p}static _insert(C,d,a,p){const v=[];let S=C._header;for(let f=C._level-1;f>=0;f--){for(;S.forward[f]&&p(S.forward[f].key,d)<0;)S=S.forward[f];v[f]=S}if(S=S.forward[0],S&&p(S.key,d)===0)return S.value=a,!1;{const f=_._randomLevel(C);if(f>C._level){for(let y=C._level;y<f;y++)v[y]=C._header;C._level=f}S=new L(f,d,a);for(let y=0;y<f;y++)S.forward[y]=v[y].forward[y],v[y].forward[y]=S;return!0}}static _randomLevel(C,d=.5){let a=1;for(;Math.random()<d&&a<C._maxLevel;)a+=1;return a}static _delete(C,d,a){const p=[];let v=C._header;for(let S=C._level-1;S>=0;S--){for(;v.forward[S]&&a(v.forward[S].key,d)<0;)v=v.forward[S];p[S]=v}if(v=v.forward[0],!v||a(v.key,d)!==0)return!1;for(let S=0;S<C._level&&p[S].forward[S]===v;S++)p[S].forward[S]=v.forward[S];for(;C._level>0&&C._header.forward[C._level-1]===r;)C._level-=1;return!0}}e.SkipList=_}),define(ee[68],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(_){return new L(_)}constructor(_){this._now=I&&_===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(ee[3],te([0,1,14,82,2,101,68]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const C=!1,d=!1;var a;(function(R){R.None=()=>r.Disposable.None;function E(ue){if(d){const{onDidAddListener:de}=ue,be=y.create();let we=0;ue.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),de?.()}}}function k(ue,de){return V(ue,()=>{},0,void 0,!0,void 0,de)}R.defer=k;function O(ue){return(de,be=null,we)=>{let ye=!1,ke;return ke=ue(Ne=>{if(!ye)return ke?ke.dispose():ye=!0,de.call(be,Ne)},null,we),ye&&ke.dispose(),ke}}R.once=O;function F(ue,de,be){return se((we,ye=null,ke)=>ue(Ne=>we.call(ye,de(Ne)),null,ke),be)}R.map=F;function q(ue,de,be){return se((we,ye=null,ke)=>ue(Ne=>{de(Ne),we.call(ye,Ne)},null,ke),be)}R.forEach=q;function ne(ue,de,be){return se((we,ye=null,ke)=>ue(Ne=>de(Ne)&&we.call(ye,Ne),null,ke),be)}R.filter=ne;function J(ue){return ue}R.signal=J;function ce(...ue){return(de,be=null,we)=>{const ye=(0,r.combinedDisposable)(...ue.map(ke=>ke(Ne=>de.call(be,Ne))));return G(ye,we)}}R.any=ce;function re(ue,de,be,we){let ye=be;return F(ue,ke=>(ye=de(ye,ke),ye),we)}R.reduce=re;function se(ue,de){let be;const we={onWillAddFirstListener(){be=ue(ye.fire,ye)},onDidRemoveLastListener(){be?.dispose()}};de||E(we);const ye=new c(we);return de?.add(ye),ye.event}function G(ue,de){return de instanceof Array?de.push(ue):de&&de.add(ue),ue}function V(ue,de,be=100,we=!1,ye=!1,ke,Ne){let pe,ve,Y,le=0,ge;const De={leakWarningThreshold:ke,onWillAddFirstListener(){pe=ue(Fe=>{le++,ve=de(ve,Fe),we&&!Y&&(Le.fire(ve),ve=void 0),ge=()=>{const Ae=ve;ve=void 0,Y=void 0,(!we||le>1)&&Le.fire(Ae),le=0},typeof be=="number"?(clearTimeout(Y),Y=setTimeout(ge,be)):Y===void 0&&(Y=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,pe.dispose()}};Ne||E(De);const Le=new c(De);return Ne?.add(Le),Le.event}R.debounce=V;function x(ue,de=0,be){return R.debounce(ue,(we,ye)=>we?(we.push(ye),we):[ye],de,void 0,!0,void 0,be)}R.accumulate=x;function W(ue,de=(we,ye)=>we===ye,be){let we=!0,ye;return ne(ue,ke=>{const Ne=we||!de(ke,ye);return we=!1,ye=ke,Ne},be)}R.latch=W;function U(ue,de,be){return[R.filter(ue,de,be),R.filter(ue,we=>!de(we),be)]}R.split=U;function H(ue,de=!1,be=[],we){let ye=be.slice(),ke=ue(ve=>{ye?ye.push(ve):pe.fire(ve)});we&&we.add(ke);const Ne=()=>{ye?.forEach(ve=>pe.fire(ve)),ye=null},pe=new c({onWillAddFirstListener(){ke||(ke=ue(ve=>pe.fire(ve)),we&&we.add(ke))},onDidAddFirstListener(){ye&&(de?setTimeout(Ne):Ne())},onDidRemoveLastListener(){ke&&ke.dispose(),ke=null}});return we&&we.add(pe),pe.event}R.buffer=H;function Q(ue,de){return(we,ye,ke)=>{const Ne=de(new oe);return ue(function(pe){const ve=Ne.evaluate(pe);ve!==ie&&we.call(ye,ve)},void 0,ke)}}R.chain=Q;const ie=Symbol("HaltChainable");class oe{constructor(){this.steps=[]}map(de){return this.steps.push(de),this}forEach(de){return this.steps.push(be=>(de(be),be)),this}filter(de){return this.steps.push(be=>de(be)?be:ie),this}reduce(de,be){let we=be;return this.steps.push(ye=>(we=de(we,ye),we)),this}latch(de=(be,we)=>be===we){let be=!0,we;return this.steps.push(ye=>{const ke=be||!de(ye,we);return be=!1,we=ye,ke?ye:ie}),this}evaluate(de){for(const be of this.steps)if(de=be(de),de===ie)break;return de}}function N(ue,de,be=we=>we){const we=(...pe)=>Ne.fire(be(...pe)),ye=()=>ue.on(de,we),ke=()=>ue.removeListener(de,we),Ne=new c({onWillAddFirstListener:ye,onDidRemoveLastListener:ke});return Ne.event}R.fromNodeEventEmitter=N;function A(ue,de,be=we=>we){const we=(...pe)=>Ne.fire(be(...pe)),ye=()=>ue.addEventListener(de,we),ke=()=>ue.removeEventListener(de,we),Ne=new c({onWillAddFirstListener:ye,onDidRemoveLastListener:ke});return Ne.event}R.fromDOMEventEmitter=A;function T(ue){return new Promise(de=>O(ue)(de))}R.toPromise=T;function $(ue){const de=new c;return ue.then(be=>{de.fire(be)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}R.fromPromise=$;function B(ue,de){return de(void 0),ue(be=>de(be))}R.runAndSubscribe=B;function z(ue,de){let be=null;function we(ke){be?.dispose(),be=new r.DisposableStore,de(ke,be)}we(void 0);const ye=ue(ke=>we(ke));return(0,r.toDisposable)(()=>{ye.dispose(),be?.dispose()})}R.runAndSubscribeWithStore=z;class j{constructor(de,be){this._observable=de,this._counter=0,this._hasChanged=!1;const we={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};be||E(we),this.emitter=new c(we),be&&be.add(this.emitter)}beginUpdate(de){this._counter++}handlePossibleChange(de){}handleChange(de,be){this._hasChanged=!0}endUpdate(de){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ae(ue,de){return new j(ue,de).emitter.event}R.fromObservable=ae;function fe(ue){return de=>{let be=0,we=!1;const ye={beginUpdate(){be++},endUpdate(){be--,be===0&&(ue.reportChanges(),we&&(we=!1,de()))},handlePossibleChange(){},handleChange(){we=!0}};return ue.addObserver(ye),ue.reportChanges(),{dispose(){ue.removeObserver(ye)}}}}R.fromObservableLight=fe})(a||(e.Event=a={}));class p{static{this.all=new Set}static{this._idPool=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${p._idPool++}`,p.all.add(this)}start(E){this._stopWatch=new M.StopWatch,this.listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=p;let v=-1;function S(R){const E=v;return v=R,{dispose(){v=E}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(E,k=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=k,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(E,k){const O=this.threshold;if(O<=0||k<O)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(E.value)||0;if(this._stacks.set(E.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=O*.5;let q,ne=0;for(const[J,ce]of this._stacks)(!q||ne<ce)&&(q=J,ne=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${ne}):`),console.warn(q)}return()=>{const q=this._stacks.get(E.value)||0;this._stacks.set(E.value,q-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class g{constructor(E){this.value=E,this.id=w++}}const m=2,h=(R,E)=>{if(R instanceof g)E(R);else for(let k=0;k<R.length;k++){const O=R[k];O&&E(O)}};class c{constructor(E){this._size=0,this._options=E,this._leakageMon=v>0||this._options?.leakWarningThreshold?new f(this._options?.leakWarningThreshold??v):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(C){const E=this._listeners;queueMicrotask(()=>{h(E,k=>k.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(E,k,O)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;k&&(E=E.bind(k));const F=new g(E);let q,ne;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(F.stack=y.create(),q=this._leakageMon.check(F.stack,this._size+1)),C&&(F.stack=ne??y.create()),this._listeners?this._listeners instanceof g?(this._deliveryQueue??=new u,this._listeners=[this._listeners,F]):this._listeners.push(F):(this._options?.onWillAddFirstListener?.(this),this._listeners=F,this._options?.onDidAddFirstListener?.(this)),this._size++;const J=(0,r.toDisposable)(()=>{q?.(),this._removeListener(F)});return O instanceof r.DisposableStore?O.add(J):Array.isArray(O)&&O.push(J),J},this._event}_removeListener(E){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const k=this._listeners,O=k.indexOf(E);if(O===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,k[O]=void 0;const F=this._deliveryQueue.current===this;if(this._size*m<=k.length){let q=0;for(let ne=0;ne<k.length;ne++)k[ne]?k[q++]=k[ne]:F&&(this._deliveryQueue.end--,q<this._deliveryQueue.i&&this._deliveryQueue.i--);k.length=q}}_deliver(E,k){if(!E)return;const O=this._options?.onListenerError||I.onUnexpectedError;if(!O){E.value(k);return}try{E.value(k)}catch(F){O(F)}}_deliverQueue(E){const k=E.current._listeners;for(;E.i<E.end;)this._deliver(k[E.i++],E.value);E.reset()}fire(E){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof g)this._deliver(this._listeners,E);else{const k=this._deliveryQueue;k.enqueue(this,E,this._listeners.length),this._deliverQueue(k)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=c;const P=()=>new u;e.createEventDeliveryQueue=P;class u{constructor(){this.i=-1,this.end=0}enqueue(E,k,O){this.i=0,this.end=O,this.current=E,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(E,k,O){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList),h(this._listeners,F=>this._asyncDeliveryQueue.push([F.value,E]));this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[F,q]=this._asyncDeliveryQueue.shift(),ne=[],J={...q,token:k,waitUntil:ce=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");O&&(ce=O(ce,F)),ne.push(ce)}};try{F(J)}catch(ce){(0,I.onUnexpectedError)(ce);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ce=>{for(const re of ce)re.status==="rejected"&&(0,I.onUnexpectedError)(re.reason)})}}}e.AsyncEmitter=t;class l extends c{get isPaused(){return this._isPaused!==0}constructor(E){super(E),this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=E?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._size&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=l;class s extends l{constructor(E){super(E),this._delay=E.delay??100}fire(E){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(E)}}e.DebounceEmitter=s;class i extends c{constructor(E){super(E),this._queuedEvents=[],this._mergeFn=E?.merge}fire(E){this.hasListeners()&&(this._queuedEvents.push(E),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(k=>super.fire(k)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const k={event:E,listener:null};this.events.push(k),this.hasListeners&&this.hook(k);const O=()=>{this.hasListeners&&this.unhook(k);const F=this.events.indexOf(k);this.events.splice(F,1)};return(0,r.toDisposable)((0,L.createSingleCallFunction)(O))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(k=>this.emitter.fire(k))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class o{constructor(E,k,O,F){this._store=new r.DisposableStore;const q=this._store.add(new n),ne=this._store.add(new r.DisposableMap);function J(ce){ne.set(ce,q.add(F(ce)))}for(const ce of E)J(ce);this._store.add(k(ce=>{J(ce)})),this._store.add(O(ce=>{ne.deleteAndDispose(ce)})),this.event=q.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=o;class b{constructor(){this.buffers=[]}wrapEvent(E){return(k,O,F)=>E(q=>{const ne=this.buffers[this.buffers.length-1];ne?ne.push(()=>k.call(O,q)):k.call(O,q)},void 0,F)}bufferEvents(E){const k=[];this.buffers.push(k);const O=E();return this.buffers.pop(),k.forEach(F=>F()),O}}e.EventBufferer=b;class D{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=r.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(ee[22],te([0,1,3]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,d){const a=setTimeout(C.bind(d),0);return{dispose(){clearTimeout(a)}}});var r;(function(C){function d(a){return a===C.None||a===C.Cancelled||a instanceof _?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}C.isCancellationToken=d,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=r.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=M}),define(ee[140],te([0,1,22]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new I.CancellationTokenSource,d=this.task(C.token);return this.result={promise:d,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=L;class r{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const d=JSON.stringify(C);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=r;class _{get cachedValues(){return this._map}constructor(C){this.fn=C,this._map=new Map}get(C){if(this._map.has(C))return this._map.get(C);const d=this.fn(C);return this._map.set(C,d),d}}e.CachedFunction=_}),define(ee[61],te([0,1,14,2]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(P){const u=P;return u?typeof u.read=="function":!1}e.isReadable=r;function _(P){const u=P;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=_;function M(P){const u=P;return u?_(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=M;function C(P,u){return new d(P,u)}e.newWriteableStream=C;class d{constructor(u,t){this.reducer=u,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(t=>t(u))}emitError(u){this.listeners.error.length===0?(0,I.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(t=>t(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,t){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(u,t){if(this.state.destroyed)return;let l;switch(u){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const s=l.indexOf(t);s>=0&&l.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(P,u){const t=[];let l;for(;(l=P.read())!==null;)t.push(l);return u(t)}e.consumeReadable=a;function p(P,u,t){const l=[];let s;for(;(s=P.read())!==null&&l.length<t;)l.push(s);return s===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return P.read()}}}e.peekReadable=p;function v(P,u){return new Promise((t,l)=>{const s=[];S(P,{onData:i=>{u&&s.push(i)},onError:i=>{u?l(i):t(void 0)},onEnd:()=>{t(u?u(s):void 0)}})})}e.consumeStream=v;function S(P,u,t){P.on("error",l=>{t?.isCancellationRequested||u.onError(l)}),P.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),P.on("data",l=>{t?.isCancellationRequested||u.onData(l)})}e.listenStream=S;function f(P,u){return new Promise((t,l)=>{const s=new L.DisposableStore,i=[],n=D=>{if(i.push(D),i.length>u)return s.dispose(),P.pause(),t({stream:P,buffer:i,ended:!1})},o=D=>(s.dispose(),l(D)),b=()=>(s.dispose(),t({stream:P,buffer:i,ended:!0}));s.add((0,L.toDisposable)(()=>P.removeListener("error",o))),P.on("error",o),s.add((0,L.toDisposable)(()=>P.removeListener("end",b))),P.on("end",b),s.add((0,L.toDisposable)(()=>P.removeListener("data",n))),P.on("data",n)})}e.peekStream=f;function y(P,u){const t=C(u);return t.end(P),t}e.toStream=y;function w(){const P=C(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=w;function g(P){let u=!1;return{read:()=>u?null:(u=!0,P)}}e.toReadable=g;function m(P,u,t){const l=C(t);return S(P,{onData:s=>l.write(u.data(s)),onError:s=>l.error(u.error?u.error(s):s),onEnd:()=>l.end()}),l}e.transform=m;function h(P,u,t){let l=!1;return{read:()=>{const s=u.read();return l?s:(l=!0,s!==null?t([P,s]):P)}}}e.prefixedReadable=h;function c(P,u,t){let l=!1;const s=C(t);return S(u,{onData:i=>l?s.write(i):(l=!0,s.write(t([P,i]))),onError:i=>s.error(i),onEnd:()=>{l||(l=!0,s.write(P)),s.end()}}),s}e.prefixedStream=c}),define(ee[17],te([0,1,83,61]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const r=typeof Buffer<"u",_=new I.Lazy(()=>new Uint8Array(256));let M,C;class d{static alloc(k){return r?new d(Buffer.allocUnsafe(k)):new d(new Uint8Array(k))}static wrap(k){return r&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new d(k)}static fromString(k,O){return!(O?.dontUseNodeBuffer||!1)&&r?new d(Buffer.from(k)):(M||(M=new TextEncoder),new d(M.encode(k)))}static fromByteArray(k){const O=d.alloc(k.length);for(let F=0,q=k.length;F<q;F++)O.buffer[F]=k[F];return O}static concat(k,O){if(typeof O>"u"){O=0;for(let ne=0,J=k.length;ne<J;ne++)O+=k[ne].byteLength}const F=d.alloc(O);let q=0;for(let ne=0,J=k.length;ne<J;ne++){const ce=k[ne];F.set(ce,q),q+=ce.byteLength}return F}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=d.alloc(this.byteLength);return k.set(this),k}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(k,O){return new d(this.buffer.subarray(k,O))}set(k,O){if(k instanceof d)this.buffer.set(k.buffer,O);else if(k instanceof Uint8Array)this.buffer.set(k,O);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),O);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return S(this.buffer,k)}writeUInt32BE(k,O){f(this.buffer,k,O)}readUInt32LE(k){return y(this.buffer,k)}writeUInt32LE(k,O){w(this.buffer,k,O)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,O){m(this.buffer,k,O)}indexOf(k,O=0){return a(this.buffer,k instanceof d?k.buffer:k,O)}}e.VSBuffer=d;function a(E,k,O=0){const F=k.byteLength,q=E.byteLength;if(F===0)return 0;if(F===1)return E.indexOf(k[0]);if(F>q-O)return-1;const ne=_.value;ne.fill(k.length);for(let se=0;se<k.length;se++)ne[k[se]]=k.length-se-1;let J=O+k.length-1,ce=J,re=-1;for(;J<q;)if(E[J]===k[ce]){if(ce===0){re=J;break}J--,ce--}else J+=Math.max(k.length-ce,ne[E[J]]),ce=k.length-1;return re}e.binaryIndexOf=a;function p(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}e.readUInt16LE=p;function v(E,k,O){E[O+0]=k&255,k=k>>>8,E[O+1]=k&255}e.writeUInt16LE=v;function S(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}e.readUInt32BE=S;function f(E,k,O){E[O+3]=k,k=k>>>8,E[O+2]=k,k=k>>>8,E[O+1]=k,k=k>>>8,E[O]=k}e.writeUInt32BE=f;function y(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}e.readUInt32LE=y;function w(E,k,O){E[O+0]=k&255,k=k>>>8,E[O+1]=k&255,k=k>>>8,E[O+2]=k&255,k=k>>>8,E[O+3]=k&255}e.writeUInt32LE=w;function g(E,k){return E[k]}e.readUInt8=g;function m(E,k,O){E[O]=k}e.writeUInt8=m;function h(E){return L.consumeReadable(E,k=>d.concat(k))}e.readableToBuffer=h;function c(E){return L.toReadable(E)}e.bufferToReadable=c;function P(E){return L.consumeStream(E,k=>d.concat(k))}e.streamToBuffer=P;async function u(E){return E.ended?d.concat(E.buffer):d.concat([...E.buffer,await P(E.stream)])}e.bufferedStreamToBuffer=u;function t(E){return L.toStream(E,k=>d.concat(k))}e.bufferToStream=t;function l(E){return L.transform(E,{data:k=>typeof k=="string"?d.fromString(k):d.wrap(k)},k=>d.concat(k))}e.streamToBufferReadableStream=l;function s(E){return L.newWriteableStream(k=>d.concat(k),E)}e.newWriteableBufferStream=s;function i(E,k){return L.prefixedReadable(E,k,O=>d.concat(O))}e.prefixedBufferReadable=i;function n(E,k){return L.prefixedStream(E,k,O=>d.concat(O))}e.prefixedBufferStream=n;function o(E){let k=0,O=0,F=0;const q=new Uint8Array(Math.floor(E.length/4*3)),ne=ce=>{switch(O){case 3:q[F++]=k|ce,O=0;break;case 2:q[F++]=k|ce>>>2,k=ce<<6,O=3;break;case 1:q[F++]=k|ce>>>4,k=ce<<4,O=2;break;default:k=ce<<2,O=1}};for(let ce=0;ce<E.length;ce++){const re=E.charCodeAt(ce);if(re>=65&&re<=90)ne(re-65);else if(re>=97&&re<=122)ne(re-97+26);else if(re>=48&&re<=57)ne(re-48+52);else if(re===43||re===45)ne(62);else if(re===47||re===95)ne(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ce]}`)}}const J=F;for(;O>0;)ne(0);return d.wrap(q).slice(0,J)}e.decodeBase64=o;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:E},k=!0,O=!1){const F=O?D:b;let q="";const ne=E.byteLength%3;let J=0;for(;J<E.byteLength-ne;J+=3){const ce=E[J+0],re=E[J+1],se=E[J+2];q+=F[ce>>>2],q+=F[(ce<<4|re>>>4)&63],q+=F[(re<<2|se>>>6)&63],q+=F[se&63]}if(ne===1){const ce=E[J+0];q+=F[ce>>>2],q+=F[ce<<4&63],k&&(q+="==")}else if(ne===2){const ce=E[J+0],re=E[J+1];q+=F[ce>>>2],q+=F[(ce<<4|re>>>4)&63],q+=F[re<<2&63],k&&(q+="=")}return q}e.encodeBase64=R}),define(ee[26],te([0,1,140,83]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=r;const _=/{(\d+)}/g;function M(X,...he){return he.length===0?X:X.replace(_,function(me,Ee){const Me=parseInt(Ee,10);return isNaN(Me)||Me<0||Me>=he.length?me:he[Me]})}e.format=M;const C=/{([^}]+)}/g;function d(X,he){return X.replace(C,(me,Ee)=>he[Ee]??me)}e.format2=d;function a(X){return X.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=a;function p(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function v(X,he){let me=0;const Ee=he.charCodeAt(0);for(let Me=X.length-1;Me>=0;Me--)X.charCodeAt(Me)===Ee&&me++;return me}e.count=v;function S(X,he,me="\u2026"){return X.length<=he?X:`${X.substr(0,he)}${me}`}e.truncate=S;function f(X,he=" "){const me=y(X,he);return w(me,he)}e.trim=f;function y(X,he){if(!X||!he)return X;const me=he.length;if(me===0||X.length===0)return X;let Ee=0;for(;X.indexOf(he,Ee)===Ee;)Ee=Ee+me;return X.substring(Ee)}e.ltrim=y;function w(X,he){if(!X||!he)return X;const me=he.length,Ee=X.length;if(me===0||Ee===0)return X;let Me=Ee,We=-1;for(;We=X.lastIndexOf(he,Me-1),!(We===-1||We+me!==Me);){if(We===0)return"";Me=We}return X.substring(0,Me)}e.rtrim=w;function g(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(X){return X.replace(/\*/g,"")}e.stripWildcards=m;function h(X,he,me={}){if(!X)throw new Error("Cannot create regex from empty string");he||(X=p(X)),me.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let Ee="";return me.global&&(Ee+="g"),me.matchCase||(Ee+="i"),me.multiline&&(Ee+="m"),me.unicode&&(Ee+="u"),new RegExp(X,Ee)}e.createRegExp=h;function c(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function P(X){return X.split(/\r\n|\r|\n/)}e.splitLines=P;function u(X){for(let he=0,me=X.length;he<me;he++){const Ee=X.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}e.firstNonWhitespaceIndex=u;function t(X,he=0,me=X.length){for(let Ee=he;Ee<me;Ee++){const Me=X.charCodeAt(Ee);if(Me!==32&&Me!==9)return X.substring(he,Ee)}return X.substring(he,me)}e.getLeadingWhitespace=t;function l(X,he=X.length-1){for(let me=he;me>=0;me--){const Ee=X.charCodeAt(me);if(Ee!==32&&Ee!==9)return me}return-1}e.lastNonWhitespaceIndex=l;function s(X,he,me){const Ee=[];let Me=0;for(const We of X.matchAll(he)){if(Ee.push(X.slice(Me,We.index)),We.index===void 0)throw new Error("match.index should be defined");Me=We.index+We[0].length,Ee.push(me(We[0],...We.slice(1),We.index,X,We.groups))}return Ee.push(X.slice(Me)),Promise.all(Ee).then(We=>We.join(""))}e.replaceAsync=s;function i(X,he){return X<he?-1:X>he?1:0}e.compare=i;function n(X,he,me=0,Ee=X.length,Me=0,We=he.length){for(;me<Ee&&Me<We;me++,Me++){const $e=X.charCodeAt(me),qe=he.charCodeAt(Me);if($e<qe)return-1;if($e>qe)return 1}const Oe=Ee-me,Te=We-Me;return Oe<Te?-1:Oe>Te?1:0}e.compareSubstring=n;function o(X,he){return b(X,he,0,X.length,0,he.length)}e.compareIgnoreCase=o;function b(X,he,me=0,Ee=X.length,Me=0,We=he.length){for(;me<Ee&&Me<We;me++,Me++){let $e=X.charCodeAt(me),qe=he.charCodeAt(Me);if($e===qe)continue;if($e>=128||qe>=128)return n(X.toLowerCase(),he.toLowerCase(),me,Ee,Me,We);R($e)&&($e-=32),R(qe)&&(qe-=32);const xe=$e-qe;if(xe!==0)return xe}const Oe=Ee-me,Te=We-Me;return Oe<Te?-1:Oe>Te?1:0}e.compareSubstringIgnoreCase=b;function D(X){return X>=48&&X<=57}e.isAsciiDigit=D;function R(X){return X>=97&&X<=122}e.isLowerAsciiLetter=R;function E(X){return X>=65&&X<=90}e.isUpperAsciiLetter=E;function k(X,he){return X.length===he.length&&b(X,he)===0}e.equalsIgnoreCase=k;function O(X,he){const me=he.length;return he.length>X.length?!1:b(X,he,0,me)===0}e.startsWithIgnoreCase=O;function F(X,he){const me=Math.min(X.length,he.length);let Ee;for(Ee=0;Ee<me;Ee++)if(X.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return me}e.commonPrefixLength=F;function q(X,he){const me=Math.min(X.length,he.length);let Ee;const Me=X.length-1,We=he.length-1;for(Ee=0;Ee<me;Ee++)if(X.charCodeAt(Me-Ee)!==he.charCodeAt(We-Ee))return Ee;return me}e.commonSuffixLength=q;function ne(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ne;function J(X){return 56320<=X&&X<=57343}e.isLowSurrogate=J;function ce(X,he){return(X-55296<<10)+(he-56320)+65536}e.computeCodePoint=ce;function re(X,he,me){const Ee=X.charCodeAt(me);if(ne(Ee)&&me+1<he){const Me=X.charCodeAt(me+1);if(J(Me))return ce(Ee,Me)}return Ee}e.getNextCodePoint=re;function se(X,he){const me=X.charCodeAt(he-1);if(J(me)&&he>1){const Ee=X.charCodeAt(he-2);if(ne(Ee))return ce(Ee,me)}return me}class G{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=se(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=re(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class V{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new G(he,me)}nextGraphemeLength(){const he=le.getInstance(),me=this._iterator,Ee=me.offset;let Me=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const We=me.offset,Oe=he.getGraphemeBreakType(me.nextCodePoint());if(ve(Me,Oe)){me.setOffset(We);break}Me=Oe}return me.offset-Ee}prevGraphemeLength(){const he=le.getInstance(),me=this._iterator,Ee=me.offset;let Me=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const We=me.offset,Oe=he.getGraphemeBreakType(me.prevCodePoint());if(ve(Oe,Me)){me.setOffset(We);break}Me=Oe}return Ee-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function x(X,he){return new V(X,he).nextGraphemeLength()}e.nextCharLength=x;function W(X,he){return new V(X,he).prevGraphemeLength()}e.prevCharLength=W;function U(X,he){he>0&&J(X.charCodeAt(he))&&he--;const me=he+x(X,he);return[me-W(X,me),me]}e.getCharContainingOffset=U;function H(X){const he=new V(X);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=H;let Q;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(X){return Q||(Q=ie()),Q.test(X)}e.containsRTL=oe;const N=/^[\t\n\r\x20-\x7E]*$/;function A(X){return N.test(X)}e.isBasicASCII=A,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=T;function $(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=$;function B(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=B;function z(X,he){if(X.length<he)return X;const me=/\b/g;let Ee=0;for(;me.test(X)&&!(X.length-me.lastIndex<he);)Ee=me.lastIndex,me.lastIndex+=1;return X.substring(Ee).replace(/^\s/,"")}e.lcut=z;const j=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function fe(X){return X&&(X=X.replace(j,"").replace(ae,"")),X}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(X){return ue(X)?X.substr(1):X}e.stripUTF8BOM=de;function be(X,he){if(!X||!he||X.length<he.length)return!1;const me=he.length,Ee=X.toLowerCase();let Me=0,We=-1;for(;Me<me;){const Oe=Ee.indexOf(he[Me],We+1);if(Oe<0)return!1;We=Oe,Me++}return!0}e.fuzzyContains=be;function we(X,he=!1){return X?(he&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=we;function ye(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=ye;function ke(X,he=1){if(he===0)return"";let me=-1;do me=X.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?X:(X[me-1]==="\r"&&me--,X.substr(0,me))}e.getNLines=ke;function Ne(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Ne;function pe(X){return le.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=pe;function ve(X,he){return X===0?he!==5&&he!==7:X===2&&he===3?!1:X===4||X===2||X===3||he===4||he===2||he===3?!0:!(X===8&&(he===8||he===9||he===11||he===12)||(X===11||X===9)&&(he===9||he===10)||(X===12||X===10)&&he===10||he===5||he===13||he===7||X===1||X===13&&he===14||X===6&&he===6)}var Y;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class le{static{this._INSTANCE=null}static getInstance(){return le._INSTANCE||(le._INSTANCE=new le),le._INSTANCE}constructor(){this._data=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,Ee=me.length/3;let Me=1;for(;Me<=Ee;)if(he<me[3*Me])Me=2*Me;else if(he>me[3*Me+1])Me=2*Me+1;else return me[3*Me+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(X,he){if(X===0)return 0;const me=Le(X,he);if(me!==void 0)return me;const Ee=new G(he,X);return Ee.prevCodePoint(),Ee.offset}e.getLeftDeleteOffset=De;function Le(X,he){const me=new G(he,X);let Ee=me.prevCodePoint();for(;Fe(Ee)||Ee===65039||Ee===8419;){if(me.offset===0)return;Ee=me.prevCodePoint()}if(!B(Ee))return;let Me=me.offset;return Me>0&&me.prevCodePoint()===8205&&(Me=me.offset),Me}function Fe(X){return 127995<=X&&X<=127999}var Ae;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new I.LRUCachedFunction(he=>{function me(xe){const Je=new Map;for(let Ye=0;Ye<xe.length;Ye+=2)Je.set(xe[Ye],xe[Ye+1]);return Je}function Ee(xe,Je){const Ye=new Map(xe);for(const[tt,nt]of Je)Ye.set(tt,nt);return Ye}function Me(xe,Je){if(!xe)return Je;const Ye=new Map;for(const[tt,nt]of xe)Je.has(tt)&&Ye.set(tt,nt);return Ye}const We=this.ambiguousCharacterData.value;let Oe=he.filter(xe=>!xe.startsWith("_")&&xe in We);Oe.length===0&&(Oe=["_default"]);let Te;for(const xe of Oe){const Je=me(We[xe]);Te=Me(Te,Je)}const $e=me(We._common),qe=Ee($e,Te);return new ze(qe)})}static getInstance(he){return ze.cache.get(Array.from(he))}static{this._locales=new L.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze;class Be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Be.getRawData())),this._data}static isInvisibleCharacter(he){return Be.getData().has(he)}static get codePoints(){return Be.getData()}}e.InvisibleCharacters=Be}),define(ee[55],te([0,1,26]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(m){return r(m,0)}e.hash=L;function r(m,h){switch(typeof m){case"object":return m===null?_(349,h):Array.isArray(m)?d(m,h):a(m,h);case"string":return C(m,h);case"boolean":return M(m,h);case"number":return _(m,h);case"undefined":return _(937,h);default:return _(617,h)}}e.doHash=r;function _(m,h){return(h<<5)-h+m|0}e.numberHash=_;function M(m,h){return _(m?433:863,h)}function C(m,h){h=_(149417,h);for(let c=0,P=m.length;c<P;c++)h=_(m.charCodeAt(c),h);return h}e.stringHash=C;function d(m,h){return h=_(104579,h),m.reduce((c,P)=>r(P,c),h)}function a(m,h){return h=_(181387,h),Object.keys(m).sort().reduce((c,P)=>(c=C(P,c),r(m[P],c)),h)}class p{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=r(h,this._value),this._value}}e.Hasher=p;var v;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function S(m,h,c=32){const P=c-h,u=~((1<<P)-1);return(m<<h|(u&m)>>>P)>>>0}function f(m,h=0,c=m.byteLength,P=0){for(let u=0;u<c;u++)m[h+u]=P}function y(m,h,c="0"){for(;m.length<h;)m=c+m;return m}function w(m,h=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(c=>c.toString(16).padStart(2,"0")).join(""):y((m>>>0).toString(16),h/4)}e.toHexString=w;class g{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const c=h.length;if(c===0)return;const P=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,l,s;for(t!==0?(l=t,s=-1,t=0):(l=h.charCodeAt(0),s=0);;){let i=l;if(I.isHighSurrogate(l))if(s+1<c){const n=h.charCodeAt(s+1);I.isLowSurrogate(n)?(s++,i=I.computeCodePoint(l,n)):i=65533}else{t=l;break}else I.isLowSurrogate(l)&&(i=65533);if(u=this._push(P,u,i),s++,s<c)l=h.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(h,c,P){return P<128?h[c++]=P:P<2048?(h[c++]=192|(P&1984)>>>6,h[c++]=128|(P&63)>>>0):P<65536?(h[c++]=224|(P&61440)>>>12,h[c++]=128|(P&4032)>>>6,h[c++]=128|(P&63)>>>0):(h[c++]=240|(P&1835008)>>>18,h[c++]=128|(P&258048)>>>12,h[c++]=128|(P&4032)>>>6,h[c++]=128|(P&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=g._bigBlock32,c=this._buffDV;for(let b=0;b<64;b+=4)h.setUint32(b,c.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)h.setUint32(b,S(h.getUint32(b-12,!1)^h.getUint32(b-32,!1)^h.getUint32(b-56,!1)^h.getUint32(b-64,!1),1),!1);let P=this._h0,u=this._h1,t=this._h2,l=this._h3,s=this._h4,i,n,o;for(let b=0;b<80;b++)b<20?(i=u&t|~u&l,n=1518500249):b<40?(i=u^t^l,n=1859775393):b<60?(i=u&t|u&l|t&l,n=2400959708):(i=u^t^l,n=3395469782),o=S(P,5)+i+s+n+h.getUint32(b*4,!1)&4294967295,s=l,l=t,t=S(u,30),u=P,P=o;this._h0=this._h0+P&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=g}),define(ee[69],te([0,1,26]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const _="error",M="warning",C="warn",d="info",a="ignore";function p(S){return S?I.equalsIgnoreCase(_,S)?r.Error:I.equalsIgnoreCase(M,S)||I.equalsIgnoreCase(C,S)?r.Warning:I.equalsIgnoreCase(d,S)?r.Info:r.Ignore:r.Ignore}r.fromValue=p;function v(S){switch(S){case r.Error:return _;case r.Warning:return M;case r.Info:return d;default:return a}}r.toString=v}(L||(L={})),e.default=L}),define(ee[141],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[56],te([0,1,23,26]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const y=f.charCodeAt(0),w=this._value.charCodeAt(this._pos);return y-w}value(){return this._value[this._pos]}}e.StringIterator=r;class _{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,L.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class M{constructor(f=!0,y=!0){this._splitOnBackslash=f,this._caseSensitive=y}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let y=f.length-1;y>=0;y--,this._valueLen--){const w=this._value.charCodeAt(y);if(!(w===47||this._splitOnBackslash&&w===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,L.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var C;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(C||(C={}));class d{constructor(f,y){this._ignorePathCasing=f,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===4)return(0,L.compare)(f,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(p||(p={}));class v{static forUris(f=()=>!1,y=()=>!1){return new v(new d(f,y))}static forPaths(f=!1){return new v(new M(void 0,!f))}static forStrings(){return new v(new r)}static forConfigKeys(){return new v(new _)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,y){if(y){const w=y.slice(0);(0,I.shuffle)(w);for(const g of w)this.set(g,f)}else{const w=f.slice(0);(0,I.shuffle)(w);for(const g of w)this.set(g[0],g[1])}}set(f,y){const w=this._iter.reset(f);let g;this._root||(this._root=new a,this._root.segment=w.value());const m=[];for(g=this._root;;){const c=w.cmp(g.segment);if(c>0)g.left||(g.left=new a,g.left.segment=w.value()),m.push([-1,g]),g=g.left;else if(c<0)g.right||(g.right=new a,g.right.segment=w.value()),m.push([1,g]),g=g.right;else if(w.hasNext())w.next(),g.mid||(g.mid=new a,g.mid.segment=w.value()),m.push([0,g]),g=g.mid;else break}const h=g.value;g.value=y,g.key=f;for(let c=m.length-1;c>=0;c--){const P=m[c][1];P.updateHeight();const u=P.balanceFactor();if(u<-1||u>1){const t=m[c][0],l=m[c+1][0];if(t===1&&l===1)m[c][1]=P.rotateLeft();else if(t===-1&&l===-1)m[c][1]=P.rotateRight();else if(t===1&&l===-1)P.right=m[c+1][1]=m[c+1][1].rotateRight(),m[c][1]=P.rotateLeft();else if(t===-1&&l===1)P.left=m[c+1][1]=m[c+1][1].rotateLeft(),m[c][1]=P.rotateRight();else throw new Error;if(c>0)switch(m[c-1][0]){case-1:m[c-1][1].left=m[c][1];break;case 1:m[c-1][1].right=m[c][1];break;case 0:m[c-1][1].mid=m[c][1];break}else this._root=m[0][1]}}return h}get(f){return this._getNode(f)?.value}_getNode(f){const y=this._iter.reset(f);let w=this._root;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(f){const y=this._getNode(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,y){const w=this._iter.reset(f),g=[];let m=this._root;for(;m;){const h=w.cmp(m.segment);if(h>0)g.push([-1,m]),m=m.left;else if(h<0)g.push([1,m]),m=m.right;else if(w.hasNext())w.next(),g.push([0,m]),m=m.mid;else break}if(m){if(y?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const h=this._min(m.right);if(h.key){const{key:c,value:P,segment:u}=h;this._delete(h.key,!1),m.key=c,m.value=P,m.segment=u}}else{const h=m.left??m.right;if(g.length>0){const[c,P]=g[g.length-1];switch(c){case-1:P.left=h;break;case 0:P.mid=h;break;case 1:P.right=h;break}}else this._root=h}for(let h=g.length-1;h>=0;h--){const c=g[h][1];c.updateHeight();const P=c.balanceFactor();if(P>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),g[h][1]=c.rotateLeft()):P<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),g[h][1]=c.rotateRight()),h>0)switch(g[h-1][0]){case-1:g[h-1][1].left=g[h][1];break;case 1:g[h-1][1].right=g[h][1];break;case 0:g[h-1][1].mid=g[h][1];break}else this._root=g[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this._iter.reset(f);let w=this._root,g;for(;w;){const m=y.cmp(w.segment);if(m>0)w=w.left;else if(m<0)w=w.right;else if(y.hasNext())y.next(),g=w.value||g,w=w.mid;else break}return w&&w.value||g}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,y){const w=this._iter.reset(f);let g=this._root;for(;g;){const m=w.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(w.hasNext())w.next(),g=g.mid;else return g.mid?this._entries(g.mid):y?g.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[y,w]of this)f(w,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const y=[];return this._dfsEntries(f,y),y[Symbol.iterator]()}_dfsEntries(f,y){f&&(f.left&&this._dfsEntries(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,y),f.right&&this._dfsEntries(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:f(y.left)&&f(y.right)};return f(this._root)}}e.TernarySearchTree=v}),define(ee[12],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(u){return typeof u=="string"}e.isString=I;function L(u){return Array.isArray(u)&&u.every(t=>I(t))}e.isStringArray=L;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=r;function _(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.isTypedArray=_;function M(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=M;function C(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=C;function d(u){return u===!0||u===!1}e.isBoolean=d;function a(u){return typeof u>"u"}e.isUndefined=a;function p(u){return!v(u)}e.isDefined=p;function v(u){return a(u)||u===null}e.isUndefinedOrNull=v;function S(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function f(u){if(v(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=f;function y(...u){const t=[];for(let l=0;l<u.length;l++){const s=u[l];if(v(s))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(s)}return t}e.assertAllDefined=y;const w=Object.prototype.hasOwnProperty;function g(u){if(!r(u))return!1;for(const t in u)if(w.call(u,t))return!1;return!0}e.isEmptyObject=g;function m(u){return typeof u=="function"}e.isFunction=m;function h(...u){return u.length>0&&u.every(m)}e.areFunctions=h;function c(u,t){const l=Math.min(u.length,t.length);for(let s=0;s<l;s++)P(u[s],t[s])}e.validateConstraints=c;function P(u,t){if(I(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(u instanceof t)return}catch{}if(!v(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=P}),define(ee[70],te([0,1,12]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(C,d){if((0,I.isString)(d)){const a=L[d];if(a===void 0)throw new Error(`${C} references an unknown codicon: ${d}`);d=a}return L[C]=d,{id:C}}function _(){return L}e.getCodiconFontCharacters=_;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,12]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const h=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([c,P])=>{h[c]=P&&typeof P=="object"?L(P):P}),h}e.deepClone=L;function r(m){if(!m||typeof m!="object")return m;const h=[m];for(;h.length>0;){const c=h.shift();Object.freeze(c);for(const P in c)if(_.call(c,P)){const u=c[P];typeof u=="object"&&!Object.isFrozen(u)&&!(0,I.isTypedArray)(u)&&h.push(u)}}return m}e.deepFreeze=r;const _=Object.prototype.hasOwnProperty;function M(m,h){return C(m,h,new Set)}e.cloneAndChange=M;function C(m,h,c){if((0,I.isUndefinedOrNull)(m))return m;const P=h(m);if(typeof P<"u")return P;if(Array.isArray(m)){const u=[];for(const t of m)u.push(C(t,h,c));return u}if((0,I.isObject)(m)){if(c.has(m))throw new Error("Cannot clone recursive data-structure");c.add(m);const u={};for(const t in m)_.call(m,t)&&(u[t]=C(m[t],h,c));return c.delete(m),u}return m}function d(m,h,c=!0){return(0,I.isObject)(m)?((0,I.isObject)(h)&&Object.keys(h).forEach(P=>{P in m?c&&((0,I.isObject)(m[P])&&(0,I.isObject)(h[P])?d(m[P],h[P],c):m[P]=h[P]):m[P]=h[P]}),m):h}e.mixin=d;function a(m,h){if(m===h)return!0;if(m==null||h===null||h===void 0||typeof m!=typeof h||typeof m!="object"||Array.isArray(m)!==Array.isArray(h))return!1;let c,P;if(Array.isArray(m)){if(m.length!==h.length)return!1;for(c=0;c<m.length;c++)if(!a(m[c],h[c]))return!1}else{const u=[];for(P in m)u.push(P);u.sort();const t=[];for(P in h)t.push(P);if(t.sort(),!a(u,t))return!1;for(c=0;c<u.length;c++)if(!a(m[u[c]],h[u[c]]))return!1}return!0}e.equals=a;function p(m){const h=new Set;return JSON.stringify(m,(c,P)=>{if((0,I.isObject)(P)||Array.isArray(P)){if(h.has(P))return"[Circular]";h.add(P)}return P})}e.safeStringify=p;function v(m,h){const c=Object.create(null);return!m||!h||Object.keys(h).forEach(u=>{const t=m[u],l=h[u];a(t,l)||(c[u]=l)}),c}e.distinct=v;function S(m,h){const c=h.toLowerCase(),P=Object.keys(m).find(u=>u.toLowerCase()===c);return P?m[P]:m[h]}e.getCaseInsensitive=S;function f(m,h){const c=Object.create(null);for(const[P,u]of Object.entries(m))h(P,u)&&(c[P]=u);return c}e.filter=f;function y(m){let h=[];for(;Object.prototype!==m;)h=h.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return h}e.getAllPropertyNames=y;function w(m){const h=[];for(const c of y(m))typeof m[c]=="function"&&h.push(c);return h}e.getAllMethodNames=w;function g(m,h){const c=u=>function(){const t=Array.prototype.slice.call(arguments,0);return h(u,t)},P={};for(const u of m)P[u]=c(u);return P}e.createProxyObject=g}),define(ee[102],te([0,1,70]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(M){function C(d){return d&&typeof d=="object"&&typeof d.id=="string"}M.isThemeColor=C})(L||(e.ThemeColor=L={}));function r(M){return{id:M}}e.themeColorFromId=r;var _;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function d(h){const c=C.exec(h.id);if(!c)return d(I.Codicon.error);const[,P,u]=c,t=["codicon","codicon-"+P];return u&&t.push("codicon-modifier-"+u.substring(1)),t}M.asClassNameArray=d;function a(h){return d(h).join(" ")}M.asClassName=a;function p(h){return"."+d(h).join(".")}M.asCSSSelector=p;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||L.isThemeColor(h.color))}M.isThemeIcon=v;const S=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function f(h){const c=S.exec(h);if(!c)return;const[,P]=c;return{id:P}}M.fromString=f;function y(h){return{id:h}}M.fromId=y;function w(h,c){let P=h.id;const u=P.lastIndexOf("~");return u!==-1&&(P=P.substring(0,u)),c&&(P=`${P}~${c}`),{id:P}}M.modify=w;function g(h){const c=h.id.lastIndexOf("~");if(c!==-1)return h.id.substring(c+1)}M.getModifier=g;function m(h,c){return h.id===c.id&&h.color?.id===c.color?.id}M.isEqual=m})(_||(e.ThemeIcon=_={}))}),define(ee[32],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return I.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(C){for(let d=0;d<C.length;d++)C[d]=Math.floor(Math.random()*256);return C};const _=new Uint8Array(16),M=[];for(let C=0;C<256;C++)M.push(C.toString(16).padStart(2,"0"));return function(){r(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let d=0,a="";return a+=M[_[d++]],a+=M[_[d++]],a+=M[_[d++]],a+=M[_[d++]],a+="-",a+=M[_[d++]],a+=M[_[d++]],a+="-",a+=M[_[d++]],a+=M[_[d++]],a+="-",a+=M[_[d++]],a+=M[_[d++]],a+="-",a+=M[_[d++]],a+=M[_[d++]],a+=M[_[d++]],a+=M[_[d++]],a+=M[_[d++]],a+=M[_[d++]],a}}()}),define(ee[142],te([0,1,85,45,82]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function _(M,C){if(await new Promise((p,v)=>{const S=L.createReadStream(M),f=I.createHash("sha1");S.pipe(f);const y=(0,r.createSingleCallFunction)((w,g)=>{S.removeAllListeners(),f.removeAllListeners(),w?v(w):p(g)});S.once("error",y),S.once("end",y),f.once("error",y),f.once("data",w=>y(void 0,w.toString("hex")))})!==C)throw new Error("Hash mismatch")}e.checksum=_}),define(ee[143],te([0,1,27]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(M){const C=M.replace(/\-/g,":").toLowerCase();return!L.has(C)}function _(){const M=(0,I.networkInterfaces)();for(const C in M){const d=M[C];if(d){for(const{mac:a}of d)if(r(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ee[86],te([0,1,27,56,32,143]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(a){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(a)}value(){if(this._value===void 0){let a=0,p=0;const v=(0,I.networkInterfaces)();for(const S in v){const f=v[S];if(f)for(const{mac:y,internal:w}of f)w||(p+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(a+=1))}this._value=p>0?a/p:0}return this._value}};let M;async function C(a){return M||(M=(async()=>await d(a)||r.generateUuid())()),M}e.getMachineId=C;async function d(a){try{const p=await new Promise((S,f)=>{K(["crypto"],S,f)}),v=(0,_.getMac)();return p.createHash("sha256").update(v,"utf8").digest("hex")}catch(p){a(p);return}}}),define(ee[103],te([0,1,87]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(C,d,a,p=1){let v=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!v)return v=!0,S(0)},a);r(C,d,p,y=>{if(!v)return v=!0,clearTimeout(f),S(y)})})}e.findFreePort=L;function r(C,d,a,p){if(d===0)return p(0);const v=new I.Socket;v.once("connect",()=>(M(v),r(C+a,d-1,a,p))),v.once("data",()=>{}),v.once("error",S=>(M(v),S.code!=="ECONNREFUSED"?r(C+a,d-1,a,p):p(C))),v.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(C,d,a,p="127.0.0.1"){let v=!1,S,f=1;const y=I.createServer({pauseOnConnect:!0});function w(g,m){v||(v=!0,y.removeAllListeners(),y.close(),S&&clearTimeout(S),m(g))}return new Promise(g=>{S=setTimeout(()=>{w(0,g)},a),y.on("listening",()=>{w(C,g)}),y.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&f<d?(C++,f++,y.listen(C,p)):w(0,g)}),y.on("close",()=>{w(0,g)}),y.listen(C,p)})}e.findFreePortFaster=_;function M(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(d){console.error(d)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function I(d){const a=new Set;if(Array.isArray(d))for(const p of d)typeof p=="string"&&a.add(p);return Array.from(a)}function L(){const d=e();return d?Array.from(d):[]}function r(d){if(process.platform!=="win32")return;const a=e();if(a)if(typeof d=="string")a.add(d.toLowerCase());else for(const p of I(d))r(p)}function _(d){if(typeof d!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const v of a){if(d.indexOf(v)!==0)continue;const f=d.indexOf("\\",v.length);if(f===-1)continue;const y=d.substring(v.length,f);if(y){p=y;break}}return p}function M(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function C(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:_,disableUNCAccessRestrictions:M,isUNCAccessRestrictionsDisabled:C}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ee[144],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[145],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(r,_){this.sender=r,this.onMessage=_}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[38],te([0,1,15,14]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class r{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,C){const d=(a,...p)=>{this.validateEvent(M,a)&&C(a,...p)};return this.mapListenerToWrapper.set(C,d),I.ipcMain.on(M,d),this}once(M,C){return I.ipcMain.once(M,(d,...a)=>{this.validateEvent(M,d)&&C(d,...a)}),this}handle(M,C){return I.ipcMain.handle(M,(d,...a)=>this.validateEvent(M,d)?C(d,...a):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return I.ipcMain.removeHandler(M),this}removeListener(M,C){const d=this.mapListenerToWrapper.get(C);return d&&(I.ipcMain.removeListener(M,d),this.mapListenerToWrapper.delete(C)),this}validateEvent(M,C){if(!M||!M.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const d=C.senderFrame,a=d.url;if(!a||a==="about:blank")return!0;let p="unknown";try{p=new URL(a).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${a}'.`),!1}return p!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${p}'.`),!1):d.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new r}),define(ee[146],te([0,1,15,38,144]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function _(){L.validatedIpcMain.on(r.CONTEXT_MENU_CHANNEL,(C,d,a,p,v)=>{const S=M(C,p,a);S.popup({window:I.BrowserWindow.fromWebContents(C.sender)??void 0,x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{S&&C.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=_;function M(C,d,a){const p=new I.Menu;return a.forEach(v=>{let S;v.type==="separator"?S=new I.MenuItem({type:v.type}):Array.isArray(v.submenu)?S=new I.MenuItem({submenu:M(C,d,v.submenu),label:v.label}):S=new I.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(f,y,w)=>C.sender.send(d,v.id,w)}),p.append(S)}),p}}),define(ee[147],te([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(ee[148],te([0,1,147]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,_=r*24,M=_*7,C=_*30,d=_*365;function a(v,S,f,y){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,I.localize)(0,null,a(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,I.localize)(1,null);let g;return w<L?(g=w,S?g===1?f?(0,I.localize)(2,null,g):(0,I.localize)(3,null,g):f?(0,I.localize)(4,null,g):(0,I.localize)(5,null,g):g===1?f?(0,I.localize)(6,null,g):(0,I.localize)(7,null,g):f?(0,I.localize)(8,null,g):(0,I.localize)(9,null,g)):w<r?(g=Math.floor(w/L),S?g===1?f?(0,I.localize)(10,null,g):(0,I.localize)(11,null,g):f?(0,I.localize)(12,null,g):(0,I.localize)(13,null,g):g===1?f?(0,I.localize)(14,null,g):(0,I.localize)(15,null,g):f?(0,I.localize)(16,null,g):(0,I.localize)(17,null,g)):w<_?(g=Math.floor(w/r),S?g===1?f?(0,I.localize)(18,null,g):(0,I.localize)(19,null,g):f?(0,I.localize)(20,null,g):(0,I.localize)(21,null,g):g===1?f?(0,I.localize)(22,null,g):(0,I.localize)(23,null,g):f?(0,I.localize)(24,null,g):(0,I.localize)(25,null,g)):w<M?(g=Math.floor(w/_),S?g===1?(0,I.localize)(26,null,g):(0,I.localize)(27,null,g):g===1?(0,I.localize)(28,null,g):(0,I.localize)(29,null,g)):w<C?(g=Math.floor(w/M),S?g===1?f?(0,I.localize)(30,null,g):(0,I.localize)(31,null,g):f?(0,I.localize)(32,null,g):(0,I.localize)(33,null,g):g===1?f?(0,I.localize)(34,null,g):(0,I.localize)(35,null,g):f?(0,I.localize)(36,null,g):(0,I.localize)(37,null,g)):w<d?(g=Math.floor(w/C),S?g===1?f?(0,I.localize)(38,null,g):(0,I.localize)(39,null,g):f?(0,I.localize)(40,null,g):(0,I.localize)(41,null,g):g===1?f?(0,I.localize)(42,null,g):(0,I.localize)(43,null,g):f?(0,I.localize)(44,null,g):(0,I.localize)(45,null,g)):(g=Math.floor(w/d),S?g===1?f?(0,I.localize)(46,null,g):(0,I.localize)(47,null,g):f?(0,I.localize)(48,null,g):(0,I.localize)(49,null,g):g===1?f?(0,I.localize)(50,null,g):(0,I.localize)(51,null,g):f?(0,I.localize)(52,null,g):(0,I.localize)(53,null,g))}e.fromNow=a;function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(ee[149],te([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ee[49],te([0,1,23,12,149]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function _(v,S){return S&&(v.stack||v.stacktrace)?r.localize(0,null,C(v),M(v.stack)||M(v.stacktrace)):C(v)}function M(v){return Array.isArray(v)?v.join(`
`):v}function C(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?r.localize(1,null,v.message):v.message||r.localize(2,null)}function d(v=null,S=!1){if(!v)return r.localize(3,null);if(Array.isArray(v)){const f=I.coalesce(v),y=d(f[0],S);return f.length>1?r.localize(4,null,y,f.length):y}if(L.isString(v))return v;if(v.detail){const f=v.detail;if(f.error)return _(f.error,S);if(f.exception)return _(f.exception,S)}return v.stack?_(v,S):v.message?v.message:r.localize(5,null)}e.toErrorMessage=d;function a(v){const S=v;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=a;function p(v,S){let f;return typeof v=="string"?f=new Error(v):f=v,f.actions=S,f}e.createErrorWithActions=p}),define(ee[150],te([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(ee[151],te([0,1,150]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[152],te([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,152]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,_=!1,M=!1,C=!1,d=!1,a=!1,p=!1,v=!1,S=!1,f,y=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,g,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const c=typeof h?.versions?.electron=="string",P=c&&h?.type==="renderer";if(typeof navigator=="object"&&!P)m=navigator.userAgent,L=m.indexOf("Windows")>=0,r=m.indexOf("Macintosh")>=0,p=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=m.indexOf("Linux")>=0,S=m?.indexOf("Mobi")>=0,d=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,y=f,w=navigator.language;else if(typeof h=="object"){L=h.platform==="win32",r=h.platform==="darwin",_=h.platform==="linux",M=_&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,a=c,v=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const D=h.env.VSCODE_NLS_CONFIG;if(D)try{const R=JSON.parse(D),E=R.availableLanguages["*"];f=R.locale,w=R.osLocale,y=E||e.LANGUAGE_DEFAULT,g=R._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var u;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let l=0;r?l=1:L?l=3:_&&(l=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=_,e.isLinuxSnap=M,e.isNative=C,e.isElectron=a,e.isWeb=d,e.isWebWorker=d&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=S,e.isCI=v,e.platform=l,e.userAgent=m,e.language=y;var s;(function(D){function R(){return e.language}D.value=R;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=E;function k(){return e.language==="en"}D.isDefault=k})(s||(e.Language=s={})),e.locale=f,e.platformLocale=w,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let k=0,O=D.length;k<O;k++){const F=D[k];if(F.id===E.data.vscodeScheduleAsyncWork){D.splice(k,1),F.callback();return}}});let R=0;return E=>{const k=++R;D.push({id:k,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return D=>setTimeout(D)})();var i;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||p?2:L?1:3;let n=!0,o=!1;function b(){if(!o){o=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,n=new Uint16Array(D.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=b,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[35],te([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const r=I.globals.vscode.process;L={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,35]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,_=90,M=122,C=46,d=47,a=92,p=58,v=63;class S extends Error{constructor(l,s,i){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let b=`The "${l}" ${o} ${n} of type ${s}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,l){if(t===null||typeof t!="object")throw new S(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new S(l,"string",t)}const w=I.platform==="win32";function g(t){return t===d||t===a}function m(t){return t===d}function h(t){return t>=L&&t<=_||t>=r&&t<=M}function c(t,l,s,i){let n="",o=0,b=-1,D=0,R=0;for(let E=0;E<=t.length;++E){if(E<t.length)R=t.charCodeAt(E);else{if(i(R))break;R=d}if(i(R)){if(!(b===E-1||D===1))if(D===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const k=n.lastIndexOf(s);k===-1?(n="",o=0):(n=n.slice(0,k),o=n.length-1-n.lastIndexOf(s)),b=E,D=0;continue}else if(n.length!==0){n="",o=0,b=E,D=0;continue}}l&&(n+=n.length>0?`${s}..`:"..",o=2)}else n.length>0?n+=`${s}${t.slice(b+1,E)}`:n=t.slice(b+1,E),o=E-b-1;b=E,D=0}else R===C&&D!==-1?++D:D=-1}return n}function P(t,l){f(l,"pathObject");const s=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let l="",s="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else l.length===0?o=I.cwd():(o=I.env[`=${l}`]||I.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===a)&&(o=`${l}\\`));const b=o.length;let D=0,R="",E=!1;const k=o.charCodeAt(0);if(b===1)g(k)&&(D=1,E=!0);else if(g(k))if(E=!0,g(o.charCodeAt(1))){let O=2,F=O;for(;O<b&&!g(o.charCodeAt(O));)O++;if(O<b&&O!==F){const q=o.slice(F,O);for(F=O;O<b&&g(o.charCodeAt(O));)O++;if(O<b&&O!==F){for(F=O;O<b&&!g(o.charCodeAt(O));)O++;(O===b||O!==F)&&(R=`\\\\${q}\\${o.slice(F,O)}`,D=O)}}}else D=1;else h(k)&&o.charCodeAt(1)===p&&(R=o.slice(0,2),D=2,b>2&&g(o.charCodeAt(2))&&(E=!0,D=3));if(R.length>0)if(l.length>0){if(R.toLowerCase()!==l.toLowerCase())continue}else l=R;if(i){if(l.length>0)break}else if(s=`${o.slice(D)}\\${s}`,i=E,E&&l.length>0)break}return s=c(s,!i,"\\",g),i?`${l}\\${s}`:`${l}${s}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let s=0,i,n=!1;const o=t.charCodeAt(0);if(l===1)return m(o)?"\\":t;if(g(o))if(n=!0,g(t.charCodeAt(1))){let D=2,R=D;for(;D<l&&!g(t.charCodeAt(D));)D++;if(D<l&&D!==R){const E=t.slice(R,D);for(R=D;D<l&&g(t.charCodeAt(D));)D++;if(D<l&&D!==R){for(R=D;D<l&&!g(t.charCodeAt(D));)D++;if(D===l)return`\\\\${E}\\${t.slice(R)}\\`;D!==R&&(i=`\\\\${E}\\${t.slice(R,D)}`,s=D)}}}else s=1;else h(o)&&t.charCodeAt(1)===p&&(i=t.slice(0,2),s=2,l>2&&g(t.charCodeAt(2))&&(n=!0,s=3));let b=s<l?c(t.slice(s),!n,"\\",g):"";return b.length===0&&!n&&(b="."),b.length>0&&g(t.charCodeAt(l-1))&&(b+="\\"),i===void 0?n?`\\${b}`:b:n?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const s=t.charCodeAt(0);return g(s)||l>2&&h(s)&&t.charCodeAt(1)===p&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,s;for(let o=0;o<t.length;++o){const b=t[o];y(b,"path"),b.length>0&&(l===void 0?l=s=b:l+=`\\${b}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof s=="string"&&g(s.charCodeAt(0))){++n;const o=s.length;o>1&&g(s.charCodeAt(1))&&(++n,o>2&&(g(s.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&g(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const s=e.win32.resolve(t),i=e.win32.resolve(l);if(s===i||(t=s.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===a;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===a;)o--;const b=o-n;let D=0;for(;D<l.length&&l.charCodeAt(D)===a;)D++;let R=l.length;for(;R-1>D&&l.charCodeAt(R-1)===a;)R--;const E=R-D,k=b<E?b:E;let O=-1,F=0;for(;F<k;F++){const ne=t.charCodeAt(n+F);if(ne!==l.charCodeAt(D+F))break;ne===a&&(O=F)}if(F!==k){if(O===-1)return i}else{if(E>k){if(l.charCodeAt(D+F)===a)return i.slice(D+F+1);if(F===2)return i.slice(D+F)}b>k&&(t.charCodeAt(n+F)===a?O=F:F===2&&(O=3)),O===-1&&(O=0)}let q="";for(F=n+O+1;F<=o;++F)(F===o||t.charCodeAt(F)===a)&&(q+=q.length===0?"..":"\\..");return D+=O,q.length>0?`${q}${i.slice(D,R)}`:(i.charCodeAt(D)===a&&++D,i.slice(D,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const s=l.charCodeAt(2);if(s!==v&&s!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(h(l.charCodeAt(0))&&l.charCodeAt(1)===p&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let s=-1,i=0;const n=t.charCodeAt(0);if(l===1)return g(n)?t:".";if(g(n)){if(s=i=1,g(t.charCodeAt(1))){let D=2,R=D;for(;D<l&&!g(t.charCodeAt(D));)D++;if(D<l&&D!==R){for(R=D;D<l&&g(t.charCodeAt(D));)D++;if(D<l&&D!==R){for(R=D;D<l&&!g(t.charCodeAt(D));)D++;if(D===l)return t;D!==R&&(s=i=D+1)}}}}else h(n)&&t.charCodeAt(1)===p&&(s=l>2&&g(t.charCodeAt(2))?3:2,i=s);let o=-1,b=!0;for(let D=l-1;D>=i;--D)if(g(t.charCodeAt(D))){if(!b){o=D;break}}else b=!1;if(o===-1){if(s===-1)return".";o=s}return t.slice(0,o)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let s=0,i=-1,n=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(s=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let b=l.length-1,D=-1;for(o=t.length-1;o>=s;--o){const R=t.charCodeAt(o);if(g(R)){if(!n){s=o+1;break}}else D===-1&&(n=!1,D=o+1),b>=0&&(R===l.charCodeAt(b)?--b===-1&&(i=o):(b=-1,i=D))}return s===i?i=D:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=s;--o)if(g(t.charCodeAt(o))){if(!n){s=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let l=0,s=-1,i=0,n=-1,o=!0,b=0;t.length>=2&&t.charCodeAt(1)===p&&h(t.charCodeAt(0))&&(l=i=2);for(let D=t.length-1;D>=l;--D){const R=t.charCodeAt(D);if(g(R)){if(!o){i=D+1;break}continue}n===-1&&(o=!1,n=D+1),R===C?s===-1?s=D:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||n===-1||b===0||b===1&&s===n-1&&s===i+1?"":t.slice(s,n)},format:P.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.length;let i=0,n=t.charCodeAt(0);if(s===1)return g(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(g(n)){if(i=1,g(t.charCodeAt(1))){let O=2,F=O;for(;O<s&&!g(t.charCodeAt(O));)O++;if(O<s&&O!==F){for(F=O;O<s&&g(t.charCodeAt(O));)O++;if(O<s&&O!==F){for(F=O;O<s&&!g(t.charCodeAt(O));)O++;O===s?i=O:O!==F&&(i=O+1)}}}}else if(h(n)&&t.charCodeAt(1)===p){if(s<=2)return l.root=l.dir=t,l;if(i=2,g(t.charCodeAt(2))){if(s===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let o=-1,b=i,D=-1,R=!0,E=t.length-1,k=0;for(;E>=i;--E){if(n=t.charCodeAt(E),g(n)){if(!R){b=E+1;break}continue}D===-1&&(R=!1,D=E+1),n===C?o===-1?o=E:k!==1&&(k=1):o!==-1&&(k=-1)}return D!==-1&&(o===-1||k===0||k===1&&o===D-1&&o===b+1?l.base=l.name=t.slice(b,D):(l.name=t.slice(b,o),l.base=t.slice(b,D),l.ext=t.slice(o,D))),b>0&&b!==i?l.dir=t.slice(0,b-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const t=/\\/g;return()=>{const l=I.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let l="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const n=i>=0?t[i]:u();y(n,"path"),n.length!==0&&(l=`${n}/${l}`,s=n.charCodeAt(0)===d)}return l=c(l,!s,"/",m),s?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===d,s=t.charCodeAt(t.length-1)===d;return t=c(t,!l,"/",m),t.length===0?l?"/":s?"./":".":(s&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===d},join(...t){if(t.length===0)return".";let l;for(let s=0;s<t.length;++s){const i=t[s];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const s=1,i=t.length,n=i-s,o=1,b=l.length-o,D=n<b?n:b;let R=-1,E=0;for(;E<D;E++){const O=t.charCodeAt(s+E);if(O!==l.charCodeAt(o+E))break;O===d&&(R=E)}if(E===D)if(b>D){if(l.charCodeAt(o+E)===d)return l.slice(o+E+1);if(E===0)return l.slice(o+E)}else n>D&&(t.charCodeAt(s+E)===d?R=E:E===0&&(R=0));let k="";for(E=s+R+1;E<=i;++E)(E===i||t.charCodeAt(E)===d)&&(k+=k.length===0?"..":"/..");return`${k}${l.slice(o+R)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===d;let s=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===d){if(!i){s=n;break}}else i=!1;return s===-1?l?"/":".":l&&s===1?"//":t.slice(0,s)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let s=0,i=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let b=l.length-1,D=-1;for(o=t.length-1;o>=0;--o){const R=t.charCodeAt(o);if(R===d){if(!n){s=o+1;break}}else D===-1&&(n=!1,D=o+1),b>=0&&(R===l.charCodeAt(b)?--b===-1&&(i=o):(b=-1,i=D))}return s===i?i=D:i===-1&&(i=t.length),t.slice(s,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===d){if(!n){s=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(s,i)},extname(t){y(t,"path");let l=-1,s=0,i=-1,n=!0,o=0;for(let b=t.length-1;b>=0;--b){const D=t.charCodeAt(b);if(D===d){if(!n){s=b+1;break}continue}i===-1&&(n=!1,i=b+1),D===C?l===-1?l=b:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||i===-1||o===0||o===1&&l===i-1&&l===s+1?"":t.slice(l,i)},format:P.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.charCodeAt(0)===d;let i;s?(l.root="/",i=1):i=0;let n=-1,o=0,b=-1,D=!0,R=t.length-1,E=0;for(;R>=i;--R){const k=t.charCodeAt(R);if(k===d){if(!D){o=R+1;break}continue}b===-1&&(D=!1,b=R+1),k===C?n===-1?n=R:E!==1&&(E=1):n!==-1&&(E=-1)}if(b!==-1){const k=o===0&&s?1:o;n===-1||E===0||E===1&&n===b-1&&n===o+1?l.base=l.name=t.slice(k,b):(l.name=t.slice(k,n),l.base=t.slice(k,b),l.ext=t.slice(n,b))}return o>0?l.dir=t.slice(0,o-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ee[33],te([0,1,9,4,26,12]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function C(o){return o.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=C;function d(o){return o.indexOf("/")===-1&&(o=C(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=d;function a(o,b=I.posix.sep){if(!o)return"";const D=o.length,R=o.charCodeAt(0);if(M(R)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let k=3;const O=k;for(;k<D&&!M(o.charCodeAt(k));k++);if(O!==k&&!M(o.charCodeAt(k+1))){for(k+=1;k<D;k++)if(M(o.charCodeAt(k)))return o.slice(0,k+1).replace(/[\\/]/g,b)}}return b}else if(m(R)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+b:o.slice(0,2);let E=o.indexOf("://");if(E!==-1){for(E+=3;E<D;E++)if(M(o.charCodeAt(E)))return o.slice(0,E+1)}return""}e.getRoot=a;function p(o){if(!L.isWindows||!o||o.length<5)return!1;let b=o.charCodeAt(0);if(b!==92||(b=o.charCodeAt(1),b!==92))return!1;let D=2;const R=D;for(;D<o.length&&(b=o.charCodeAt(D),b!==92);D++);return!(R===D||(b=o.charCodeAt(D+1),isNaN(b)||b===92))}e.isUNC=p;const v=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,b=L.isWindows){const D=b?v:S;return!(!o||o.length===0||/^\s+$/.test(o)||(D.lastIndex=0,D.test(o))||b&&f.test(o)||o==="."||o===".."||b&&o[o.length-1]==="."||b&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=y;function w(o,b,D){const R=o===b;return!D||R?R:!o||!b?!1:(0,r.equalsIgnoreCase)(o,b)}e.isEqual=w;function g(o,b,D,R=I.sep){if(o===b)return!0;if(!o||!b||b.length>o.length)return!1;if(D){if(!(0,r.startsWithIgnoreCase)(o,b))return!1;if(b.length===o.length)return!0;let k=b.length;return b.charAt(b.length-1)===R&&k--,o.charAt(k)===R}return b.charAt(b.length-1)!==R&&(b+=R),o.indexOf(b)===0}e.isEqualOrParent=g;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function h(o,b){return L.isWindows&&o.endsWith(":")&&(o+=I.sep),(0,I.isAbsolute)(o)||(o=(0,I.join)(b,o)),o=(0,I.normalize)(o),L.isWindows?(o=(0,r.rtrim)(o,I.sep),o.endsWith(":")&&(o+=I.sep)):(o=(0,r.rtrim)(o,I.sep),o||(o=I.sep)),o}e.sanitizeFilePath=h;function c(o){const b=(0,I.normalize)(o);return L.isWindows?o.length>3?!1:P(b)&&(o.length===2||b.charCodeAt(2)===92):b===I.posix.sep}e.isRootOrDriveLetter=c;function P(o,b=L.isWindows){return b?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function u(o,b=L.isWindows){return P(o,b)?o[0]:void 0}e.getDriveLetter=u;function t(o,b,D){return b.length>o.length?-1:o===b?0:(D&&(o=o.toLowerCase(),b=b.toLowerCase()),o.indexOf(b))}e.indexOfPath=t;function l(o){const b=o.split(":");let D,R,E;for(const k of b){const O=Number(k);(0,_.isNumber)(O)?R===void 0?R=O:E===void 0&&(E=O):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:R!==void 0?R:void 0,column:E!==void 0?E:R!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,b,D=8){let R="";for(let k=0;k<D;k++){let O;k===0&&L.isWindows&&!b&&(D===3||D===4)?O=i:O=s,R+=O.charAt(Math.floor(Math.random()*O.length))}let E;return b?E=`${b}-${R}`:E=R,o?(0,I.join)(o,E):E}e.randomPath=n}),define(ee[71],te([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function _(C,...d){const a=d.reduce((S,f)=>(S[f]=!0,S),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(S=>!a[S]).forEach(S=>{for(let f=0;f<p.length;f++)if(S.search(p[f])!==-1){delete C[S];break}})}e.sanitizeProcessEnvironment=_;function M(C){C&&(delete C.DEBUG,I.isMacintosh&&delete C.DYLD_LIBRARY_PATH,I.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[7],te([0,1,9,4]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,_=/^\//,M=/^\/\//;function C(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,n){return!i&&!n?"file":i}function a(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const p="",v="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,b,D,R,E=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=d(n,E),this.authority=o||p,this.path=a(this.scheme,b||p),this.query=D||p,this.fragment=R||p,C(this,E))}get fsPath(){return P(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:b,path:D,query:R,fragment:E}=n;return o===void 0?o=this.scheme:o===null&&(o=p),b===void 0?b=this.authority:b===null&&(b=p),D===void 0?D=this.path:D===null&&(D=p),R===void 0?R=this.query:R===null&&(R=p),E===void 0?E=this.fragment:E===null&&(E=p),o===this.scheme&&b===this.authority&&D===this.path&&R===this.query&&E===this.fragment?this:new g(o,b,D,R,E)}static parse(n,o=!1){const b=S.exec(n);return b?new g(b[2]||p,s(b[4]||p),s(b[5]||p),s(b[7]||p),s(b[9]||p),o):new g(p,p,p,p,p)}static file(n){let o=p;if(L.isWindows&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const b=n.indexOf(v,2);b===-1?(o=n.substring(2),n=v):(o=n.substring(2,b),n=n.substring(b)||v)}return new g("file",o,n,p,p)}static from(n,o){return new g(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return L.isWindows&&n.scheme==="file"?b=f.file(I.win32.join(P(n,!0),...o)).path:b=I.posix.join(n.path,...o),n.with({path:b})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new g(n);return o._formatted=n.external??null,o._fsPath=n._sep===w?n.fsPath??null:null,o}}else return n}}e.URI=f;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=y;const w=L.isWindows?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=P(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let b,D=-1;for(let R=0;R<i.length;R++){const E=i.charCodeAt(R);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||o&&E===91||o&&E===93||o&&E===58)D!==-1&&(b+=encodeURIComponent(i.substring(D,R)),D=-1),b!==void 0&&(b+=i.charAt(R));else{b===void 0&&(b=i.substr(0,R));const k=m[E];k!==void 0?(D!==-1&&(b+=encodeURIComponent(i.substring(D,R)),D=-1),b+=k):D===-1&&(D=R)}}return D!==-1&&(b+=encodeURIComponent(i.substring(D))),b!==void 0?b:i}function c(i){let n;for(let o=0;o<i.length;o++){const b=i.charCodeAt(o);b===35||b===63?(n===void 0&&(n=i.substr(0,o)),n+=m[b]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function P(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=P;function u(i,n){const o=n?c:h;let b="",{scheme:D,authority:R,path:E,query:k,fragment:O}=i;if(D&&(b+=D,b+=":"),(R||D==="file")&&(b+=v,b+=v),R){let F=R.indexOf("@");if(F!==-1){const q=R.substr(0,F);R=R.substr(F+1),F=q.lastIndexOf(":"),F===-1?b+=o(q,!1,!1):(b+=o(q.substr(0,F),!1,!1),b+=":",b+=o(q.substr(F+1),!1,!0)),b+="@"}R=R.toLowerCase(),F=R.lastIndexOf(":"),F===-1?b+=o(R,!1,!0):(b+=o(R.substr(0,F),!1,!0),b+=R.substr(F))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const F=E.charCodeAt(1);F>=65&&F<=90&&(E=`/${String.fromCharCode(F+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const F=E.charCodeAt(0);F>=65&&F<=90&&(E=`${String.fromCharCode(F+32)}:${E.substr(2)}`)}b+=o(E,!0,!1)}return k&&(b+="?",b+=o(k,!1,!1)),O&&(b+="#",b+=n?O:h(O,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(ee[153],te([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(a){const p=a;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=L;function r(a){const p=[];let v;try{const S=JSON.parse(a.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),v=f.__$stack),p.push(...S)}catch{p.push("Unable to log remote console arguments",a.arguments)}return{args:p,stack:v}}e.parse=r;function _(a){if(typeof a!="string")return _(r(a).stack);const p=a;if(p){const v=M(p),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(S&&S.length===4)return{uri:I.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=_;function M(a){if(!a)return a;const p=a.indexOf(`
`);return p===-1?a:a.substring(0,p)}function C(a,p){const{args:v,stack:S}=r(a),f=typeof v[0]=="string"&&v.length===1;let y=M(S);y&&(y=`(${y.trim()})`);let w=[];if(typeof v[0]=="string"?y&&f?w=[`%c[${p}] %c${v[0]} %c${y}`,d("blue"),d(""),d("grey")]:w=[`%c[${p}] %c${v[0]}`,d("blue"),d(""),...v.slice(1)]:w=[`%c[${p}]%`,d("blue"),...v],y&&!f&&w.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,w)}e.log=C;function d(a){return`color: ${a}`}}),define(ee[72],te([0,1,17,7]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function r(d){return JSON.stringify(d,M)}e.stringify=r;function _(d){let a=JSON.parse(d);return a=C(a),a}e.parse=_;function M(d,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function C(d,a=0){if(!d||a>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return L.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof I.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let p=0;p<d.length;++p)d[p]=C(d[p],a+1);else for(const p in d)Object.hasOwnProperty.call(d,p)&&(d[p]=C(d[p],a+1))}return d}e.revive=C}),define(ee[13],te([0,1,14,4,7]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(_||(e.Schemas=_={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${_.vscodeRemoteResource}`}set(p,v,S){this._hosts[p]=v,this._ports[p]=S}setConnectionToken(p,v){this._connectionTokens[p]=v}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)try{return this._delegate(p)}catch(g){return I.onUnexpectedError(g),p}const v=p.authority;let S=this._hosts[v];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const f=this._ports[v],y=this._connectionTokens[v];let w=`path=${encodeURIComponent(p.path)}`;return typeof y=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),r.URI.from({scheme:L.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${S}:${f}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p){const v=this.toUri(p,K);return this.uriToBrowserUri(v)}uriToBrowserUri(p){return p.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===_.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${_.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?p.with({scheme:_.vscodeFileResource,authority:p.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(p){const v=this.toUri(p,K);return this.uriToFileUri(v)}uriToFileUri(p){return p.scheme===_.vscodeFileResource?p.with({scheme:_.file,authority:p.authority!==C.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(p,v){return r.URI.isUri(p)?p:r.URI.parse(v.toUrl(p))}}e.FileAccess=new C;var d;(function(a){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(p.get("3"));const v="vscode-coi";function S(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:r.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const g=w?.get(v);if(g)return p.get(g)}a.getHeadersFromQuery=S;function f(y,w,g){if(!globalThis.crossOriginIsolated)return;const m=w&&g?"3":g?"2":"1";y instanceof URLSearchParams?y.set(v,m):y[v]=m}a.addSearchParam=f})(d||(e.COI=d={}))}),define(ee[19],te([0,1,33,13,9,4,26,7]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=d;class a{constructor(y){this._ignorePathCasing=y}compare(y,w,g=!1){return y===w?0:(0,M.compare)(this.getComparisonKey(y,g),this.getComparisonKey(w,g))}isEqual(y,w,g=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,g)===this.getComparisonKey(w,g)}getComparisonKey(y,w=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,w,g=!1){if(y.scheme===w.scheme){if(y.scheme===L.Schemas.file)return I.isEqualOrParent(d(y),d(w),this._ignorePathCasing(y))&&y.query===w.query&&(g||y.fragment===w.fragment);if((0,e.isEqualAuthority)(y.authority,w.authority))return I.isEqualOrParent(y.path,w.path,this._ignorePathCasing(y),"/")&&y.query===w.query&&(g||y.fragment===w.fragment)}return!1}joinPath(y,...w){return C.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return r.posix.basename(y.path)}extname(y){return r.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===L.Schemas.file?w=C.URI.file(r.dirname(d(y))).path:(w=r.posix.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===L.Schemas.file?w=C.URI.file(r.normalize(d(y))).path:w=r.posix.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.isEqualAuthority)(y.authority,w.authority))return;if(y.scheme===L.Schemas.file){const h=r.relative(d(y),d(w));return _.isWindows?I.toSlashes(h):h}let g=y.path||"/";const m=w.path||"/";if(this._ignorePathCasing(y)){let h=0;for(const c=Math.min(g.length,m.length);h<c&&!(g.charCodeAt(h)!==m.charCodeAt(h)&&g.charAt(h).toLowerCase()!==m.charAt(h).toLowerCase());h++);g=m.substr(0,h)+g.substr(h)}return r.posix.relative(g,m)}resolvePath(y,w){if(y.scheme===L.Schemas.file){const g=C.URI.file(r.resolve(d(y),w));return y.with({authority:g.authority,path:g.path})}return w=I.toPosixPath(w),y.with({path:r.posix.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,M.equalsIgnoreCase)(y,w)}hasTrailingPathSeparator(y,w=r.sep){if(y.scheme===L.Schemas.file){const g=d(y);return g.length>I.getRoot(g).length&&g[g.length-1]===w}else{const g=y.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=r.sep){return(0,e.hasTrailingPathSeparator)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=r.sep){let g=!1;if(y.scheme===L.Schemas.file){const m=d(y);g=m!==void 0&&m.length===I.getRoot(m).length&&m[m.length-1]===w}else{w="/";const m=y.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(y,w)?y.with({path:y.path+"/"}):y}}e.ExtUri=a,e.extUri=new a(()=>!1),e.extUriBiasedIgnorePathCase=new a(f=>f.scheme===L.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new a(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(f,y){const w=[];for(let g=0;g<f.length;g++){const m=y(f[g]);f.some((h,c)=>c===g?!1:(0,e.isEqualOrParent)(m,y(h)))||w.push(f[g])}return w}e.distinctParents=p;var v;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(w){const g=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[P,u]=c.split(":");P&&u&&g.set(P,u)});const h=w.path.substring(0,w.path.indexOf(";"));return h&&g.set(f.META_DATA_MIME,h),g}f.parseMetaData=y})(v||(e.DataUri=v={}));function S(f,y,w){if(y){let g=f.path;return g&&g[0]!==r.posix.sep&&(g=r.posix.sep+g),f.with({scheme:w,authority:y,path:g})}return f.with({scheme:w})}e.toLocalResource=S}),define(ee[8],te([0,1,22,14,3,2,19,4,141]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function a(A){return!!A&&typeof A.then=="function"}e.isThenable=a;function p(A){const T=new I.CancellationTokenSource,$=A(T.token),B=new Promise((z,j)=>{const ae=T.token.onCancellationRequested(()=>{ae.dispose(),T.dispose(),j(new L.CancellationError)});Promise.resolve($).then(fe=>{ae.dispose(),T.dispose(),z(fe)},fe=>{ae.dispose(),T.dispose(),j(fe)})});return new class{cancel(){T.cancel()}then(z,j){return B.then(z,j)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}e.createCancelablePromise=p;function v(A,T,$){return new Promise((B,z)=>{const j=T.onCancellationRequested(()=>{j.dispose(),B($)});A.then(B,z).finally(()=>j.dispose())})}e.raceCancellation=v;function S(A,T){return new Promise(($,B)=>{const z=T.onCancellationRequested(()=>{z.dispose(),B(new L.CancellationError)});A.then($,B).finally(()=>z.dispose())})}e.raceCancellationError=S;async function f(A){let T=-1;const $=A.map((B,z)=>B.then(j=>(T=z,j)));try{return await Promise.race($)}finally{A.forEach((B,z)=>{z!==T&&B.cancel()})}}e.raceCancellablePromises=f;function y(A,T,$){let B;const z=setTimeout(()=>{B?.(void 0),$?.()},T);return Promise.race([A.finally(()=>clearTimeout(z)),new Promise(j=>B=j)])}e.raceTimeout=y;function w(A){return new Promise((T,$)=>{const B=A();a(B)?B.then(T,$):T(B)})}e.asPromise=w;class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const $=()=>{if(this.queuedPromise=null,this.isDisposed)return;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then($,$).then(B)})}return new Promise(($,B)=>{this.queuedPromise.then($,B)})}return this.activePromise=T(),new Promise(($,B)=>{this.activePromise.then(z=>{this.activePromise=null,$(z)},z=>{this.activePromise=null,B(z)})})}dispose(){this.isDisposed=!0}}e.Throttler=g;class m{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=m;class h{constructor(){this.promiseMap=new Map}queue(T,$){const z=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(T)===z&&this.promiseMap.delete(T)});return this.promiseMap.set(T,z),z}}e.SequencerByKey=h;const c=(A,T)=>{let $=!0;const B=setTimeout(()=>{$=!1,T()},A);return{isTriggered:()=>$,dispose:()=>{clearTimeout(B),$=!1}}},P=A=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,A())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class u{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,$=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,j)=>{this.doResolve=z,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=$===d.MicrotaskDelay?P(B):c($,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class t{constructor(T){this.delayer=new u(T),this.throttler=new g}trigger(T,$){return this.delayer.trigger(()=>this.throttler.queue(T),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class l{constructor(){this._isOpen=!1,this._promise=new Promise((T,$)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class s extends l{constructor(T){super(),this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(A,T){return T?new Promise(($,B)=>{const z=setTimeout(()=>{j.dispose(),$()},A),j=T.onCancellationRequested(()=>{clearTimeout(z),j.dispose(),B(new L.CancellationError)})}):p($=>i(A,$))}e.timeout=i;function n(A,T=0,$){const B=setTimeout(()=>{A(),$&&z.dispose()},T),z=(0,_.toDisposable)(()=>{clearTimeout(B),$?.deleteAndLeak(z)});return $?.add(z),z}e.disposableTimeout=n;function o(A){const T=[];let $=0;const B=A.length;function z(){return $<B?A[$++]():null}function j(ae){ae!=null&&T.push(ae);const fe=z();return fe?fe.then(j):Promise.resolve(T)}return Promise.resolve(null).then(j)}e.sequence=o;function b(A,T=B=>!!B,$=null){let B=0;const z=A.length,j=()=>{if(B>=z)return Promise.resolve($);const ae=A[B++];return Promise.resolve(ae()).then(ue=>T(ue)?Promise.resolve(ue):j())};return j()}e.first=b;function D(A,T=B=>!!B,$=null){if(A.length===0)return Promise.resolve($);let B=A.length;const z=()=>{B=-1;for(const j of A)j.cancel?.()};return new Promise((j,ae)=>{for(const fe of A)fe.then(ue=>{--B>=0&&T(ue)?(z(),j(ue)):B===0&&j($)}).catch(ue=>{--B>=0&&(z(),ae(ue))})})}e.firstParallel=D;class R{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(T){return this._size++,new Promise(($,B)=>{this.outstandingPromises.push({factory:T,c:$,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const $=T.factory();$.then(T.c,T.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=R;class E extends R{constructor(){super(1)}}e.Queue=E;class k{constructor(){this.sequentializer=new V,this.tasks=0}queue(T){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,T())):this.sequentializer.run(this.tasks++,T())}}e.LimitedQueue=k;class O{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const T=new U;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueFor(T,$=M.extUri){const B=$.getComparisonKey(T);let z=this.queues.get(B);if(!z){z=new E;const j=this.drainListenerCount++,ae=r.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(B),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(j),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new _.DisposableMap),this.drainListeners.set(j,ae),this.queues.set(B,z)}return z}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=O;class F{constructor(T,$){this._token=-1,typeof T=="function"&&typeof $=="number"&&this.setIfNotSet(T,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},$)}setIfNotSet(T,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},$))}}e.TimeoutTimer=F;class q{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,$){this.cancel(),this._token=setInterval(()=>{T()},$)}}e.IntervalTimer=q;class ne{constructor(T,$){this.timeoutToken=-1,this.runner=T,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ne;class J{constructor(T,$){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=J;class ce extends ne{constructor(T,$){super(T,$),this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner?.(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ce;class re extends _.Disposable{constructor(T,$){super(),this.options=T,this.handler=$,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const $ of T)this.pendingWork.push($);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ne(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=A=>{(0,C.setTimeout0)(()=>{if(T)return;const $=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(A,T)=>{const $=requestIdleCallback(A,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback($))}}}}();class se{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function G(A,T,$){let B;for(let z=0;z<$;z++)try{return await A()}catch(j){B=j,await i(T)}throw B}e.retry=G;class V{isRunning(T){return typeof T=="number"?this._running?.taskId===T:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(T,$,B){return this._running={taskId:T,cancel:()=>B?.(),promise:$},$.then(()=>this.doneRunning(T),()=>this.doneRunning(T)),$}doneRunning(T){this._running&&T===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const T=this._queued;this._queued=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this._queued)this._queued.run=T;else{let $,B;const z=new Promise((j,ae)=>{$=j,B=ae});this._queued={run:T,promise:z,promiseResolve:$,promiseReject:B}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=V;class x{constructor(T,$=()=>Date.now()){this.interval=T,this.nowFn=$,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=x;var W;(function(A){A[A.Resolved=0]="Resolved",A[A.Rejected=1]="Rejected"})(W||(W={}));class U{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((T,$)=>{this.completeCallback=T,this.errorCallback=$})}complete(T){return new Promise($=>{this.completeCallback(T),this.outcome={outcome:0,value:T},$()})}error(T){return new Promise($=>{this.errorCallback(T),this.outcome={outcome:1,value:T},$()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=U;var H;(function(A){async function T(B){let z;const j=await Promise.all(B.map(ae=>ae.then(fe=>fe,fe=>{z||(z=fe)})));if(typeof z<"u")throw z;return j}A.settled=T;function $(B){return new Promise(async(z,j)=>{try{await B(z,j)}catch(ae){j(ae)}})}A.withAsyncBody=$})(H||(e.Promises=H={}));var Q;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(Q||(Q={}));class ie{static fromArray(T){return new ie($=>{$.emitMany(T)})}static fromPromise(T){return new ie(async $=>{$.emitMany(await T)})}static fromPromises(T){return new ie(async $=>{await Promise.all(T.map(async B=>$.emitOne(await B)))})}static merge(T){return new ie(async $=>{await Promise.all(T.map(async B=>{for await(const z of B)$.emitOne(z)}))})}static{this.EMPTY=ie.fromArray([])}constructor(T){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const $={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(T($)),this.resolve()}catch(B){this.reject(B)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(T,$){return new ie(async B=>{for await(const z of T)B.emitOne($(z))})}map(T){return ie.map(this,T)}static filter(T,$){return new ie(async B=>{for await(const z of T)$(z)&&B.emitOne(z)})}filter(T){return ie.filter(this,T)}static coalesce(T){return ie.filter(T,$=>!!$)}coalesce(){return ie.coalesce(this)}static async toPromise(T){const $=[];for await(const B of T)$.push(B);return $}toPromise(){return ie.toPromise(this)}emitOne(T){this._state===0&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===0&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(T){this._state===0&&(this._state=2,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=ie;class oe extends ie{constructor(T,$){super($),this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function N(A){const T=new I.CancellationTokenSource,$=A(T.token);return new oe(T,async B=>{const z=T.token.onCancellationRequested(()=>{z.dispose(),T.dispose(),B.reject(new L.CancellationError)});try{for await(const j of $){if(T.token.isCancellationRequested)return;B.emitOne(j)}z.dispose(),T.dispose()}catch(j){z.dispose(),T.dispose(),B.reject(j)}})}e.createCancelableAsyncIterable=N}),define(ee[104],te([0,1,23,8,33,31,9,4,26]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function a(){return Object.create(null)}e.getEmptyExpression=a,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",v="[^/\\\\]",S=/\//g;function f(V,x){switch(V){case 0:return"";case 1:return`${v}*?`;default:return`(?:${p}|${v}+${p}${x?`|${p}${v}+`:""})*?`}}function y(V,x){if(!V)return[];const W=[];let U=!1,H=!1,Q="";for(const ie of V){switch(ie){case x:if(!U&&!H){W.push(Q),Q="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":H=!0;break;case"]":H=!1;break}Q+=ie}return Q&&W.push(Q),W}e.splitGlobAware=y;function w(V){if(!V)return"";let x="";const W=y(V,e.GLOB_SPLIT);if(W.every(U=>U===e.GLOBSTAR))x=".*";else{let U=!1;W.forEach((H,Q)=>{if(H===e.GLOBSTAR){if(U)return;x+=f(2,Q===W.length-1)}else{let ie=!1,oe="",N=!1,A="";for(const T of H){if(T!=="}"&&ie){oe+=T;continue}if(N&&(T!=="]"||!A)){let $;T==="-"?$=T:(T==="^"||T==="!")&&!A?$="^":T===e.GLOB_SPLIT?$="":$=(0,d.escapeRegExpCharacters)(T),A+=$;continue}switch(T){case"{":ie=!0;continue;case"[":N=!0;continue;case"}":{const B=`(?:${y(oe,",").map(z=>w(z)).join("|")})`;x+=B,ie=!1,oe="";break}case"]":{x+="["+A+"]",N=!1,A="";break}case"?":x+=v;continue;case"*":x+=f(1);continue;default:x+=(0,d.escapeRegExpCharacters)(T)}}Q<W.length-1&&(W[Q+1]!==e.GLOBSTAR||Q+2<W.length)&&(x+=p)}U=H===e.GLOBSTAR})}return x}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),l=function(){return!1},s=function(){return null};function i(V,x){if(!V)return s;let W;typeof V!="string"?W=V.pattern:W=V,W=W.trim();const U=`${W}_${!!x.trimForExclusions}`;let H=t.get(U);if(H)return n(H,V);let Q;return g.test(W)?H=b(W.substr(4),W):(Q=m.exec(o(W,x)))?H=D(Q[1],W):(x.trimForExclusions?c:h).test(W)?H=R(W,x):(Q=P.exec(o(W,x)))?H=E(Q[1].substr(1),W,!0):(Q=u.exec(o(W,x)))?H=E(Q[1],W,!1):H=k(W),t.set(U,H),n(H,V)}function n(V,x){if(typeof x=="string")return V;const W=function(U,H){return(0,r.isEqualOrParent)(U,x.base,!C.isLinux)?V((0,d.ltrim)(U.substr(x.base.length),M.sep),H):null};return W.allBasenames=V.allBasenames,W.allPaths=V.allPaths,W.basenames=V.basenames,W.patterns=V.patterns,W}function o(V,x){return x.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function b(V,x){return function(W,U){return typeof W=="string"&&W.endsWith(V)?x:null}}function D(V,x){const W=`/${V}`,U=`\\${V}`,H=function(ie,oe){return typeof ie!="string"?null:oe?oe===V?x:null:ie===V||ie.endsWith(W)||ie.endsWith(U)?x:null},Q=[V];return H.basenames=Q,H.patterns=[x],H.allBasenames=Q,H}function R(V,x){const W=se(V.slice(1,-1).split(",").map(oe=>i(oe,x)).filter(oe=>oe!==s),V),U=W.length;if(!U)return s;if(U===1)return W[0];const H=function(oe,N){for(let A=0,T=W.length;A<T;A++)if(W[A](oe,N))return V;return null},Q=W.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const ie=W.reduce((oe,N)=>N.allPaths?oe.concat(N.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function E(V,x,W){const U=M.sep===M.posix.sep,H=U?V:V.replace(S,M.sep),Q=M.sep+H,ie=M.posix.sep+V;let oe;return W?oe=function(N,A){return typeof N=="string"&&(N===H||N.endsWith(Q)||!U&&(N===V||N.endsWith(ie)))?x:null}:oe=function(N,A){return typeof N=="string"&&(N===H||!U&&N===V)?x:null},oe.allPaths=[(W?"*/":"./")+V],oe}function k(V){try{const x=new RegExp(`^${w(V)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?V:null}}catch{return s}}function O(V,x,W){return!V||typeof x!="string"?!1:F(V)(x,void 0,W)}e.match=O;function F(V,x={}){if(!V)return l;if(typeof V=="string"||q(V)){const W=i(V,x);if(W===s)return l;const U=function(H,Q){return!!W(H,Q)};return W.allBasenames&&(U.allBasenames=W.allBasenames),W.allPaths&&(U.allPaths=W.allPaths),U}return ce(V,x)}e.parse=F;function q(V){const x=V;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=q;function ne(V){return V.allBasenames||[]}e.getBasenameTerms=ne;function J(V){return V.allPaths||[]}e.getPathTerms=J;function ce(V,x){const W=se(Object.getOwnPropertyNames(V).map(oe=>re(oe,V[oe],x)).filter(oe=>oe!==s)),U=W.length;if(!U)return s;if(!W.some(oe=>!!oe.requiresSiblings)){if(U===1)return W[0];const oe=function(T,$){let B;for(let z=0,j=W.length;z<j;z++){const ae=W[z](T,$);if(typeof ae=="string")return ae;(0,L.isThenable)(ae)&&(B||(B=[]),B.push(ae))}return B?(async()=>{for(const z of B){const j=await z;if(typeof j=="string")return j}return null})():null},N=W.find(T=>!!T.allBasenames);N&&(oe.allBasenames=N.allBasenames);const A=W.reduce((T,$)=>$.allPaths?T.concat($.allPaths):T,[]);return A.length&&(oe.allPaths=A),oe}const H=function(oe,N,A){let T,$;for(let B=0,z=W.length;B<z;B++){const j=W[B];j.requiresSiblings&&A&&(N||(N=(0,M.basename)(oe)),T||(T=N.substr(0,N.length-(0,M.extname)(oe).length)));const ae=j(oe,N,T,A);if(typeof ae=="string")return ae;(0,L.isThenable)(ae)&&($||($=[]),$.push(ae))}return $?(async()=>{for(const B of $){const z=await B;if(typeof z=="string")return z}return null})():null},Q=W.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const ie=W.reduce((oe,N)=>N.allPaths?oe.concat(N.allPaths):oe,[]);return ie.length&&(H.allPaths=ie),H}function re(V,x,W){if(x===!1)return s;const U=i(V,W);if(U===s)return s;if(typeof x=="boolean")return U;if(x){const H=x.when;if(typeof H=="string"){const Q=(ie,oe,N,A)=>{if(!A||!U(ie,oe))return null;const T=H.replace("$(basename)",()=>N),$=A(T);return(0,L.isThenable)($)?$.then(B=>B?V:null):$?V:null};return Q.requiresSiblings=!0,Q}}return U}function se(V,x){const W=V.filter(oe=>!!oe.basenames);if(W.length<2)return V;const U=W.reduce((oe,N)=>{const A=N.basenames;return A?oe.concat(A):oe},[]);let H;if(x){H=[];for(let oe=0,N=U.length;oe<N;oe++)H.push(x)}else H=W.reduce((oe,N)=>{const A=N.patterns;return A?oe.concat(A):oe},[]);const Q=function(oe,N){if(typeof oe!="string")return null;if(!N){let T;for(T=oe.length;T>0;T--){const $=oe.charCodeAt(T-1);if($===47||$===92)break}N=oe.substr(T)}const A=U.indexOf(N);return A!==-1?H[A]:null};Q.basenames=U,Q.patterns=H,Q.allBasenames=U;const ie=V.filter(oe=>!oe.basenames);return ie.push(Q),ie}function G(V,x){return(0,I.equals)(V,x,(W,U)=>typeof W=="string"&&typeof U=="string"?W===U:typeof W!="string"&&typeof U!="string"?W.base===U.base&&W.pattern===U.pattern:!1)}e.patternsEquals=G}),define(ee[46],te([0,1,23,33,9,4,19,26]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function d(i,n){const{os:o,tildify:b,relative:D}=n;if(D){const k=a(i,D,o);if(typeof k=="string")return k}let R=i.fsPath;if(o===1&&!_.isWindows?R=R.replace(/\//g,"\\"):o!==1&&_.isWindows&&(R=R.replace(/\\/g,"/")),o!==1&&b?.userHome){const k=b.userHome.fsPath;let O;i.scheme!==b.userHome.scheme&&i.path.startsWith(r.posix.sep)?O=b.userHome.with({path:i.path}).fsPath:O=i.fsPath,R=S(O,k,o)}return(o===1?r.win32:r.posix).normalize(p(R,o===1))}e.getPathLabel=d;function a(i,n,o){const b=o===1?r.win32:r.posix,D=o===3?M.extUri:M.extUriIgnorePathCase,R=n.getWorkspace(),E=(0,I.firstOrDefault)(R.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=E.uri.with({path:i.path}));const k=n.getWorkspaceFolder(i);if(!k)return;let O;if(D.isEqual(k.uri,i)?O="":O=D.relativePath(k.uri,i)??"",O&&(O=b.normalize(O)),R.folders.length>1&&!n.noPrefix){const F=k.name?k.name:D.basenameOrAuthority(k.uri);O=O?`${F} \u2022 ${O}`:F}return O}function p(i,n=_.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=p;let v=Object.create(null);function S(i,n,o=_.OS){if(o===1||!i||!n)return i;let b=v.original===n?v.normalized:void 0;b||(b=n,_.isWindows&&(b=(0,L.toSlashes)(b)),b=`${(0,C.rtrim)(b,r.posix.sep)}${r.posix.sep}`,v={original:n,normalized:b});let D=i;return _.isWindows&&(D=(0,L.toSlashes)(D)),(o===3?D.startsWith(b):(0,C.startsWithIgnoreCase)(D,b))?`~/${D.substr(b.length)}`:i}e.tildify=S;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=f;const y="\u2026",w="\\\\",g="~";function m(i,n=r.sep){const o=new Array(i.length);let b=!1;for(let D=0;D<i.length;D++){const R=i[D];if(R===""){o[D]=`.${n}`;continue}if(!R){o[D]=R;continue}b=!0;let E="",k=R;k.indexOf(w)===0?(E=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(n)===0?(E=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(g)===0&&(E=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const O=k.split(n);for(let F=1;b&&F<=O.length;F++)for(let q=O.length-F;b&&q>=0;q--){b=!1;let ne=O.slice(q,q+F).join(n);for(let J=0;!b&&J<i.length;J++)if(J!==D&&i[J]&&i[J].indexOf(ne)>-1){const ce=q+F===O.length,re=q>0&&i[J].indexOf(n)>-1?n+ne:ne,se=i[J].endsWith(re);b=!ce||se}if(!b){let J="";(O[0].endsWith(":")||E!=="")&&(q===1&&(q=0,F++,ne=O[0]+n+ne),q>0&&(J=O[0]+n),J=E+J),q>0&&(J=J+y+n),J=J+ne,q+F<O.length&&(J=J+n+y),o[D]=J}}b&&(o[D]=R)}return o}e.shorten=m;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function c(i,n=Object.create(null)){const o=[];let b=!1,D="";for(const R of i)if(R==="$"||b&&R==="{")D&&o.push({value:D,type:h.TEXT}),D="",b=!0;else if(R==="}"&&b){const E=n[D];if(typeof E=="string")E.length&&o.push({value:E,type:h.VARIABLE});else if(E){const k=o[o.length-1];(!k||k.type!==h.SEPARATOR)&&o.push({value:E.label,type:h.SEPARATOR})}D="",b=!1}else D+=R;return D&&!b&&o.push({value:D,type:h.TEXT}),o.filter((R,E)=>{if(R.type===h.SEPARATOR){const k=o[E-1],O=o[E+1];return[k,O].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=c;function P(i,n){return _.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function u(i,n){return _.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):_.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=u;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=s(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return s(i)}e.splitRecentLabel=l;function s(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,o=n.basename(i),b=n.dirname(i);return o.length?{name:o,parentPath:b}:{name:b,parentPath:""}}}),define(ee[154],te([0,1,17,7]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(v){return v.toJSON()}class _{constructor(S){this._uriTransformer=S}transformIncoming(S){const f=this._uriTransformer.transformIncoming(S);return f===S?S:r(L.URI.from(f))}transformOutgoing(S){const f=this._uriTransformer.transformOutgoing(S);return f===S?S:r(L.URI.from(f))}transformOutgoingURI(S){const f=this._uriTransformer.transformOutgoing(S);return f===S?S:L.URI.from(f)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function M(v,S,f){if(!v||f>200)return null;if(typeof v=="object"){if(v instanceof L.URI)return S.transformOutgoing(v);for(const y in v)if(Object.hasOwnProperty.call(v,y)){const w=M(v[y],S,f+1);w!==null&&(v[y]=w)}}return null}function C(v,S){const f=M(v,S,0);return f===null?v:f}e.transformOutgoingURIs=C;function d(v,S,f,y){if(!v||y>200)return null;if(typeof v=="object"){if(v.$mid===1)return f?L.URI.revive(S.transformIncoming(v)):S.transformIncoming(v);if(v instanceof I.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const g=d(v[w],S,f,y+1);g!==null&&(v[w]=g)}}return null}function a(v,S){const f=d(v,S,!1,0);return f===null?v:f}e.transformIncomingURIs=a;function p(v,S){const f=d(v,S,!0,0);return f===null?v:f}e.transformAndReviveIncomingURIs=p}),define(ee[21],te([0,1,45,27,155,8,33,84,9,4,19,7]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function f(re,se=S.UNLINK,G){if((0,M.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return se===S.UNLINK?w(re):y(re,G)}async function y(re,se=(0,M.randomPath)((0,L.tmpdir)())){try{try{await I.promises.rename(re,se)}catch(G){return G.code==="ENOENT"?void 0:w(re)}w(se).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function w(re){return(0,r.promisify)(I.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function g(re){if((0,M.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function m(re,se){return P(await(se?h(re):(0,r.promisify)(I.readdir)(re)))}async function h(re){try{return await(0,r.promisify)(I.readdir)(re,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const se=[],G=await m(re);for(const V of G){let x=!1,W=!1,U=!1;try{const H=await e.Promises.lstat((0,d.join)(re,V));x=H.isFile(),W=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}se.push({name:V,isFile:()=>x,isDirectory:()=>W,isSymbolicLink:()=>U})}return se}function c(re){return P(I.readdirSync(re))}e.readdirSync=c;function P(re){return re.map(se=>typeof se=="string"?a.isMacintosh?(0,C.normalizeNFC)(se):se:(se.name=a.isMacintosh?(0,C.normalizeNFC)(se.name):se.name,se))}async function u(re){const se=await m(re),G=[];for(const V of se)await l.existsDirectory((0,d.join)(re,V))&&G.push(V);return G}function t(re,se=1e3){return new Promise(G=>{let V=!1;const x=setInterval(()=>{V||(V=!0,I.access(re,W=>{V=!1,W&&(clearInterval(x),G(void 0))}))},se)})}e.whenDeleted=t;var l;(function(re){async function se(x){let W;try{if(W=await e.Promises.lstat(x),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(a.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw H}throw U}}re.stat=se;async function G(x){try{const{stat:W,symbolicLink:U}=await re.stat(x);return W.isFile()&&U?.dangling!==!0}catch{}return!1}re.existsFile=G;async function V(x){try{const{stat:W,symbolicLink:U}=await re.stat(x);return W.isDirectory()&&U?.dangling!==!0}catch{}return!1}re.existsDirectory=V})(l||(e.SymlinkSupport=l={}));const s=new _.ResourceQueue;function i(re,se,G){return s.queueFor(v.URI.file(re),p.extUriBiasedIgnorePathCase).queue(()=>{const V=R(G);return new Promise((x,W)=>b(re,se,V,U=>U?W(U):x()))})}let n=!0;function o(re){n=re}e.configureFlushOnWrite=o;function b(re,se,G,V){if(!n)return I.writeFile(re,se,{mode:G.mode,flag:G.flag},V);I.open(re,G.flag,G.mode,(x,W)=>{if(x)return V(x);I.writeFile(W,se,U=>{if(U)return I.close(W,()=>V(U));I.fdatasync(W,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),I.close(W,Q=>V(Q))))})})}function D(re,se,G){const V=R(G);if(!n)return I.writeFileSync(re,se,{mode:V.mode,flag:V.flag});const x=I.openSync(re,V.flag,V.mode);try{I.writeFileSync(x,se);try{I.fdatasyncSync(x)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o(!1)}}finally{I.closeSync(x)}}e.writeFileSync=D;function R(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,se,G=6e4){if(re!==se)try{a.isWindows&&typeof G=="number"?await k(re,se,Date.now(),G):await(0,r.promisify)(I.rename)(re,se)}catch(V){if(re.toLowerCase()!==se.toLowerCase()&&V.code==="EXDEV"||re.endsWith("."))await O(re,se,{preserveSymlinks:!1}),await f(re,S.MOVE);else throw V}}async function k(re,se,G,V,x=0){try{return await(0,r.promisify)(I.rename)(re,se)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-G>=V)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${W}`),W;if(x===0){let U=!1;try{const{stat:H}=await l.stat(se);H.isFile()||(U=!0)}catch{}if(U)throw W}return await(0,_.timeout)(Math.min(100,x*10)),k(re,se,G,V,x+1)}}async function O(re,se,G){return q(re,se,{root:{source:re,target:se},options:G,handledSourcePaths:new Set})}const F=511;async function q(re,se,G){if(G.handledSourcePaths.has(re))return;G.handledSourcePaths.add(re);const{stat:V,symbolicLink:x}=await l.stat(re);if(x){if(G.options.preserveSymlinks)try{return await ce(re,se,G)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(x.dangling)return}return V.isDirectory()?ne(re,se,V.mode&F,G):J(re,se,V.mode&F)}async function ne(re,se,G,V){await e.Promises.mkdir(se,{recursive:!0,mode:G});const x=await m(re);for(const W of x)await q((0,d.join)(re,W),(0,d.join)(se,W),V)}async function J(re,se,G){await e.Promises.copyFile(re,se),await e.Promises.chmod(se,G)}async function ce(re,se,G){let V=await e.Promises.readlink(re);(0,M.isEqualOrParent)(V,G.root.source,!a.isLinux)&&(V=(0,d.join)(G.root.target,V.substr(G.root.source.length+1))),await e.Promises.symlink(V,se)}e.Promises=new class{get access(){return(0,r.promisify)(I.access)}get stat(){return(0,r.promisify)(I.stat)}get lstat(){return(0,r.promisify)(I.lstat)}get utimes(){return(0,r.promisify)(I.utimes)}get read(){return(re,se,G,V,x)=>new Promise((W,U)=>{I.read(re,se,G,V,x,(H,Q,ie)=>H?U(H):W({bytesRead:Q,buffer:ie}))})}get readFile(){return(0,r.promisify)(I.readFile)}get write(){return(re,se,G,V,x)=>new Promise((W,U)=>{I.write(re,se,G,V,x,(H,Q,ie)=>H?U(H):W({bytesWritten:Q,buffer:ie}))})}get appendFile(){return(0,r.promisify)(I.appendFile)}get fdatasync(){return(0,r.promisify)(I.fdatasync)}get truncate(){return(0,r.promisify)(I.truncate)}get copyFile(){return(0,r.promisify)(I.copyFile)}get open(){return(0,r.promisify)(I.open)}get close(){return(0,r.promisify)(I.close)}get symlink(){return(0,r.promisify)(I.symlink)}get readlink(){return(0,r.promisify)(I.readlink)}get chmod(){return(0,r.promisify)(I.chmod)}get mkdir(){return(0,r.promisify)(I.mkdir)}get unlink(){return(0,r.promisify)(I.unlink)}get rmdir(){return(0,r.promisify)(I.rmdir)}get realpath(){return(0,r.promisify)(I.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return f}get rename(){return E}get copy(){return O}}}),define(ee[105],te([0,1,45,9,4,26,21]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(S){if(r.isLinux)return S;const f=(0,L.dirname)(S);if(S===f)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const g=(0,M.readdirSync)(f).filter(m=>m.toLowerCase()===y);if(g.length===1){const m=C(f);if(m)return(0,L.join)(m,g[0])}else if(g.length>1){const m=g.indexOf(y);if(m>=0){const h=C(f);if(h)return(0,L.join)(h,g[m])}}}catch{}return null}e.realcaseSync=C;async function d(S){if(r.isLinux)return S;const f=(0,L.dirname)(S);if(S===f)return S;const y=((0,L.basename)(S)||S).toLowerCase();try{const g=(await M.Promises.readdir(f)).filter(m=>m.toLowerCase()===y);if(g.length===1){const m=await d(f);if(m)return(0,L.join)(m,g[0])}else if(g.length>1){const m=g.indexOf(y);if(m>=0){const h=await d(f);if(h)return(0,L.join)(h,g[m])}}}catch{}return null}e.realcase=d;async function a(S){try{return await M.Promises.realpath(S)}catch{const y=v(S);return await M.Promises.access(y,I.constants.R_OK),y}}e.realpath=a;function p(S){try{return I.realpathSync(S)}catch{const y=v(S);return I.accessSync(y,I.constants.R_OK),y}}e.realpathSync=p;function v(S){return(0,_.rtrim)((0,L.normalize)(S),L.sep)}}),define(ee[106],te([0,1,27,9,21]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,M=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var d;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(d||(d={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class v{constructor(u,t,l){this.exePath=u,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:P=!1}={}){return P?a===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:P=!1,findPreview:u=!1}={}){const t=S({useAlternateBitness:P});if(!t)return null;const l=L.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(l))return null;let s=-1,i=null;for(const b of await r.Promises.readdir(l)){let D=-1;if(u){const E=b.indexOf("-");if(E<0)continue;const k=b.substring(0,E);if(!_.test(k)||b.substring(E+1)!=="preview")continue;D=parseInt(k,10)}else{if(!_.test(b))continue;D=parseInt(b,10)}if(D<=s)continue;const R=L.join(l,b,"pwsh.exe");await r.SymlinkSupport.existsFile(R)&&(i=R,s=D)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=u?" Preview":"";return new v(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=P?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(u))if(t.test(s)){const i=L.join(u,s,"pwsh.exe");return new v(i,l)}return null}function w(){const P=L.join(I.homedir(),".dotnet","tools","pwsh.exe");return new v(P,".NET Core PowerShell Global Tool")}function g(){const P=L.join(process.env.windir,a===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(P,"Windows PowerShell",!0)}async function*m(){let P=await f();P&&(yield P),P=await f({useAlternateBitness:!0}),P&&(yield P),P=await y(),P&&(yield P),P=w(),P&&(yield P),P=await f({findPreview:!0}),P&&(yield P),P=await y({findPreview:!0}),P&&(yield P),P=await f({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=g(),P&&(yield P)}async function*h(){for await(const P of m())await P.exists()&&(yield P)}e.enumeratePowerShellInstallations=h;async function c(){for await(const P of h())return P;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ee[88],te([0,1,9,4,35,71,12,21]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return _.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return _.TerminateResponseCode}});function d(v=r.env){return v.comspec||"cmd.exe"}e.getWindowsShell=d;function a(v){let S=[],f=!1;const y=function(w){if(f){S.push(w);return}(!v.send(w,m=>{if(m&&console.error(m),f=!1,S.length>0){const h=S.slice(0);S=[],h.forEach(c=>y(c))}})||L.isWindows)&&(f=!0)};return{send:y}}e.createQueuedSender=a;var p;(function(v){async function S(f,y,w){if(I.isAbsolute(f))return f;if(y===void 0&&(y=r.cwd()),I.dirname(f)!=="."||(w===void 0&&M.isString(r.env.PATH)&&(w=r.env.PATH.split(I.delimiter)),w===void 0||w.length===0))return I.join(y,f);async function m(h){if(await C.Promises.exists(h)){let c;try{c=await C.Promises.stat(h)}catch(P){P.message.startsWith("EACCES")&&(c=await C.Promises.lstat(h))}return c?!c.isDirectory():!1}return!1}for(const h of w){let c;if(I.isAbsolute(h)?c=I.join(h,f):c=I.join(y,h,f),await m(c))return c;let P=c+".com";if(await m(P)||(P=c+".exe",await m(P)))return P}return I.join(y,f)}v.findExecutable=S})(p||(e.win32=p={}))}),define(ee[107],te([0,1,47,13]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(M){return new Promise((C,d)=>{let a;const p=new Map;function v(f,y,w,g,m){const h=p.get(y);if(f===M||h){const c={name:S(w),cmd:w,pid:f,ppid:y,load:g,mem:m};p.set(f,c),f===M&&(a=c),h&&(h.children||(h.children=[]),h.children.push(c),h.children.length>1&&(h.children=h.children.sort((P,u)=>P.pid-u.pid)))}}function S(f){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,g=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if(m.exec(f))return"winpty-agent";if(h.exec(f))return"conpty-agent";let P=c.exec(f);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const u=/[a-zA-Z-]+\.js/g;let t="";do P=u.exec(f),P&&(t+=P+" ");while(P);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{K(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(M,w=>{if(!w){d(new Error(`Root process ${M} not found`));return}y.getProcessCpuUsage(w,g=>{const m=new Map;g.forEach(h=>{const c=f(h.commandLine||"");m.set(h.pid,{name:S(c),cmd:c,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),a=m.get(M),a?(m.forEach(h=>{const c=m.get(h.ppid);c&&(c.children||(c.children=[]),c.children.push(h))}),m.forEach(h=>{h.children&&(h.children=h.children.sort((c,P)=>c.pid-P.pid))}),C(a)):d(new Error(`Root process ${M} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[a];const w=[];for(;y.length;){const m=y.shift();m&&(w.push(m.pid),m.children&&(y=y.concat(m.children)))}let g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+w.join(" "),(0,I.exec)(g,{},(m,h,c)=>{if(m||c)d(m||new Error(c.toString()));else{const P=h.toString().split(`
`);for(let u=0;u<w.length;u++){const t=p.get(w[u]);t.load=parseFloat(P[u])}if(!a){d(new Error(`Root process ${M} not found`));return}C(a)}})};(0,I.exec)("which ps",{},(y,w,g)=>{if(y||g)if(process.platform!=="linux")d(y||new Error(g.toString()));else{const m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(m,{},(h,c,P)=>{h||P?d(h||new Error(P.toString())):(_(c,v),f())})}else{const m=w.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${m} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,P,u)=>{c||u&&!u.includes("screen size is bogus")?d(c||new Error(u.toString())):(_(P,v),process.platform==="linux"?f():a?C(a):d(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=r;function _(M,C){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=M.toString().split(`
`);for(const p of a){const v=d.exec(p.trim());v&&v.length===6&&C(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ee[108],te([0,1,27,4,106,88]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(v,S){return v===1?L.isWindows?p():_.getWindowsShell(S):d(v,S)}e.getSystemShell=M;let C=null;function d(v,S){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!C){let f;if(L.isWindows)f="/bin/bash";else{if(f=S.SHELL,!f)try{f=(0,I.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}C=f}return C}let a=null;async function p(){return a||(a=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),a}});var Pe=this&&this.__decorate||function(K,e,I,L){var r=arguments.length,_=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(K,e,I,L);else for(var C=K.length-1;C>=0;C--)(M=K[C])&&(_=(r<3?M(_):r>3?M(e,I,_):M(e,I))||_);return r>3&&_&&Object.defineProperty(e,I,_),_};define(ee[42],te([0,1,23,8,17,22,54,14,3,2,72,26,12]),function(K,e,I,L,r,_,M,C,d,a,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(f||(f={}));function y(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(w||(w={}));function g(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));function h(x){let W=0;for(let U=0;;U+=7){const H=x.read(1);if(W|=(H.buffer[0]&127)<<U,!(H.buffer[0]&128))return W}}const c=s(0);function P(x,W){if(W===0){x.write(c);return}let U=0;for(let Q=W;Q!==0;Q=Q>>>7)U++;const H=r.VSBuffer.alloc(U);for(let Q=0;W!==0;Q++)H.buffer[Q]=W&127,W=W>>>7,W>0&&(H.buffer[Q]|=128);x.write(H)}class u{constructor(W){this.buffer=W,this.pos=0}read(W){const U=this.buffer.slice(this.pos,this.pos+W);return this.pos+=U.byteLength,U}}e.BufferReader=u;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=t;var l;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(l||(l={}));function s(x){const W=r.VSBuffer.alloc(1);return W.writeUInt8(x,0),W}const i={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object),Uint:s(l.Int)},n=typeof Buffer<"u";function o(x,W){if(typeof W>"u")x.write(i.Undefined);else if(typeof W=="string"){const U=r.VSBuffer.fromString(W);x.write(i.String),P(x,U.byteLength),x.write(U)}else if(n&&Buffer.isBuffer(W)){const U=r.VSBuffer.wrap(W);x.write(i.Buffer),P(x,U.byteLength),x.write(U)}else if(W instanceof r.VSBuffer)x.write(i.VSBuffer),P(x,W.byteLength),x.write(W);else if(Array.isArray(W)){x.write(i.Array),P(x,W.length);for(const U of W)o(x,U)}else if(typeof W=="number"&&(W|0)===W)x.write(i.Uint),P(x,W);else{const U=r.VSBuffer.fromString(JSON.stringify(W));x.write(i.Object),P(x,U.byteLength),x.write(U)}}e.serialize=o;function b(x){switch(x.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return x.read(h(x)).toString();case l.Buffer:return x.read(h(x)).buffer;case l.VSBuffer:return x.read(h(x));case l.Array:{const U=h(x),H=[];for(let Q=0;Q<U;Q++)H.push(b(x));return H}case l.Object:return JSON.parse(x.read(h(x)).toString());case l.Int:return h(x)}}e.deserialize=b;class D{constructor(W,U,H=null,Q=1e3){this.protocol=W,this.ctx=U,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(W,U){this.channels.set(W,U),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const U=this.send([W.type]);this.logger?.logOutgoing(U,0,1,g(W.type));return}case 201:case 202:case 204:case 203:{const U=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(U,W.id,1,g(W.type),W.data);return}}}send(W,U=void 0){const H=new t;return o(H,W),o(H,U),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const U=new u(W),H=b(U),Q=b(U),ie=H[0];switch(ie){case 100:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:ie,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:ie,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}`),this.disposeActiveRequest({type:ie,id:H[1]});case 103:return this.logger?.logIncoming(W.byteLength,H[1],1,`${y(ie)}`),this.disposeActiveRequest({type:ie,id:H[1]})}}onPromise(W){const U=this.channels.get(W.channelName);if(!U){this.collectPendingRequest(W);return}const H=new _.CancellationTokenSource;let Q;try{Q=U.call(this.ctx,W.name,W.arg,H.token)}catch(N){Q=Promise.reject(N)}const ie=W.id;Q.then(N=>{this.sendResponse({id:ie,data:N,type:201})},N=>{N instanceof Error?this.sendResponse({id:ie,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:ie,data:N,type:203})}).finally(()=>{oe.dispose(),this.activeRequests.delete(W.id)});const oe=(0,a.toDisposable)(()=>H.cancel());this.activeRequests.set(W.id,oe)}onEventListen(W){const U=this.channels.get(W.channelName);if(!U){this.collectPendingRequest(W);return}const H=W.id,ie=U.listen(this.ctx,W.name,W.arg)(oe=>this.sendResponse({id:H,data:oe,type:204}));this.activeRequests.set(W.id,ie)}disposeActiveRequest(W){const U=this.activeRequests.get(W.id);U&&(U.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let U=this.pendingRequests.get(W.channelName);U||(U=[],this.pendingRequests.set(W.channelName,U));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:W,timeoutTimer:H})}flushPendingRequests(W){const U=this.pendingRequests.get(W);if(U){for(const H of U)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var R;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class E{constructor(W,U=null){this.protocol=W,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=U}getChannel(W){const U=this;return{call(H,Q,ie){return U.isDisposed?Promise.reject(new C.CancellationError):U.requestPromise(W,H,Q,ie)},listen(H,Q){return U.isDisposed?d.Event.None:U.requestEvent(W,H,Q)}}}requestPromise(W,U,H,Q=_.CancellationToken.None){const ie=this.lastRequestId++,N={id:ie,type:100,channelName:W,name:U,arg:H};if(Q.isCancellationRequested)return Promise.reject(new C.CancellationError);let A;return new Promise(($,B)=>{if(Q.isCancellationRequested)return B(new C.CancellationError);const z=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(ie),$(de.data);break;case 202:{this.handlers.delete(ie);const be=new Error(de.data.message);be.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,be.name=de.data.name,B(be);break}case 203:this.handlers.delete(ie),B(de.data);break}};this.handlers.set(ie,ue),this.sendRequest(N)};let j=null;this.state===m.Idle?z():(j=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),j.then(()=>{j=null,z()}));const ae=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ie,type:101}),B(new C.CancellationError)},fe=Q.onCancellationRequested(ae);A=(0,a.combinedDisposable)((0,a.toDisposable)(ae),fe),this.activeRequests.add(A)}).finally(()=>{A.dispose(),this.activeRequests.delete(A)})}requestEvent(W,U,H){const Q=this.lastRequestId++,oe={id:Q,type:102,channelName:W,name:U,arg:H};let N=null;const A=new d.Emitter({onWillAddFirstListener:()=>{N=(0,L.createCancelablePromise)($=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(A),this.sendRequest(oe)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(A),this.sendRequest({id:Q,type:103}))}}),T=$=>A.fire($.data);return this.handlers.set(Q,T),A.event}sendRequest(W){switch(W.type){case 100:case 102:{const U=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(U,W.id,0,`${y(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const U=this.send([W.type,W.id]);this.logger?.logOutgoing(U,W.id,0,y(W.type));return}}}send(W,U=void 0){const H=new t;return o(H,W),o(H,U),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const U=new u(W),H=b(U),Q=b(U),ie=H[0];switch(ie){case 200:return this.logger?.logIncoming(W.byteLength,0,0,g(ie)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,H[1],0,g(ie),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(W){if(W.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=E,Pe([M.memoize],E.prototype,"onDidInitializePromise",null);class k{get connections(){const W=[];return this._connections.forEach(U=>W.push(U)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(W(({protocol:U,onDidClientDisconnect:H})=>{const Q=d.Event.once(U.onMessage);this.disposables.add(Q(ie=>{const oe=new u(ie),N=b(oe),A=new D(U,N),T=new E(U);this.channels.forEach((B,z)=>A.registerChannel(z,B));const $={channelServer:A,channelClient:T,ctx:N};this._connections.add($),this._onDidAddConnection.fire($),this.disposables.add(H(()=>{A.dispose(),T.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)}))}))}))}getChannel(W,U){const H=this;return{call(Q,ie,oe){let N;if((0,S.isFunction)(U)){const T=(0,I.getRandomElement)(H.connections.filter(U));N=T?Promise.resolve(T):d.Event.toPromise(d.Event.filter(H.onDidAddConnection,U))}else N=U.routeCall(H,Q,ie);const A=N.then(T=>T.channelClient.getChannel(W));return F(A).call(Q,ie,oe)},listen(Q,ie){if((0,S.isFunction)(U))return H.getMulticastEvent(W,U,Q,ie);const oe=U.routeEvent(H,Q,ie).then(N=>N.channelClient.getChannel(W));return F(oe).listen(Q,ie)}}}getMulticastEvent(W,U,H,Q){const ie=this;let oe;const N=new d.Emitter({onWillAddFirstListener:()=>{oe=new a.DisposableStore;const A=new d.EventMultiplexer,T=new Map,$=z=>{const ae=z.channelClient.getChannel(W).listen(H,Q),fe=A.add(ae);T.set(z,fe)},B=z=>{const j=T.get(z);j&&(j.dispose(),T.delete(z))};ie.connections.filter(U).forEach($),d.Event.filter(ie.onDidAddConnection,U)($,void 0,oe),ie.onDidRemoveConnection(B,void 0,oe),A.event(N.fire,N,oe),oe.add(A)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return N.event}registerChannel(W,U){this.channels.set(W,U);for(const H of this._connections)H.channelServer.registerChannel(W,U)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class O{constructor(W,U,H=null){const Q=new t;o(Q,U),W.send(Q.buffer),this.channelClient=new E(W,H),this.channelServer=new D(W,U,H)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,U){this.channelServer.registerChannel(W,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(x){return{call(W,U,H){return x.then(Q=>Q.call(W,U,H))},listen(W,U){const H=new d.Relay;return x.then(Q=>H.input=Q.listen(W,U)),H.event}}}e.getDelayedChannel=F;function q(x){let W=!1;return{call(U,H,Q){return W?x.call(U,H,Q):(0,L.timeout)(0).then(()=>W=!0).then(()=>x.call(U,H,Q))},listen(U,H){if(W)return x.listen(U,H);const Q=new d.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>Q.input=x.listen(U,H)),Q.event}}}e.getNextTickChannel=q;class ne{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const U of W.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await d.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=ne;var J;(function(x){function W(ie,oe,N){const A=ie,T=N&&N.disableMarshalling,$=new Map;for(const B in A)H(B)&&$.set(B,d.Event.buffer(A[B],!0,void 0,oe));return new class{listen(B,z,j){const ae=$.get(z);if(ae)return ae;if(Q(z)){const fe=A[z];if(typeof fe=="function")return fe.call(A,j)}throw new C.ErrorNoTelemetry(`Event not found: ${z}`)}call(B,z,j){const ae=A[z];if(typeof ae=="function"){if(!T&&Array.isArray(j))for(let ue=0;ue<j.length;ue++)j[ue]=(0,p.revive)(j[ue]);let fe=ae.apply(A,j);return fe instanceof Promise||(fe=Promise.resolve(fe)),fe}throw new C.ErrorNoTelemetry(`Method not found: ${z}`)}}}x.fromService=W;function U(ie,oe){const N=oe&&oe.disableMarshalling;return new Proxy({},{get(A,T){if(typeof T=="string")return oe?.properties?.has(T)?oe.properties.get(T):Q(T)?function($){return ie.listen(T,$)}:H(T)?ie.listen(T):async function(...$){let B;oe&&!(0,S.isUndefinedOrNull)(oe.context)?B=[oe.context,...$]:B=$;const z=await ie.call(T,B);return N?z:(0,p.revive)(z)};throw new C.ErrorNoTelemetry(`Property not found: ${String(T)}`)}})}x.toService=U;function H(ie){return ie[0]==="o"&&ie[1]==="n"&&v.isUpperAsciiLetter(ie.charCodeAt(2))}function Q(ie){return/^onDynamic/.test(ie)&&v.isUpperAsciiLetter(ie.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const W=x.toString();if(W!=="[object Object]")return W}return x}function se(x){return Array.isArray(x)?x.map(re):re(x)}function G(x,W,U,H,Q,ie,oe){oe=se(oe);const N=ce[Q],A=N[H%N.length];let T=[`%c[${x}]%c[${String(W).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ie)?(T=T.concat(oe),T.push(")")):T.push(oe),console.log.apply(console,T)}class V{constructor(W,U){this._outgoingPrefix=W,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,U,H,Q,ie){this._totalOutgoing+=W,G(this._outgoingPrefix,this._totalOutgoing,W,U,H,Q,ie)}logIncoming(W,U,H,Q,ie){this._totalIncoming+=W,G(this._incomingPrefix,this._totalIncoming,W,U,H,Q,ie)}}e.IPCLogger=V}),define(ee[156],te([0,1,17,3,42]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(d){this.port=d,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",a=>I.VSBuffer.wrap(a.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class M extends r.IPCClient{constructor(d,a){const p=new _(d);super(p,a),this.protocol=p}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=M}),define(ee[109],te([0,1,17,3,2,42]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function b(R,E){if(!n.has(R)){const k=String(++o);n.set(R,k)}return n.get(R)}function D(R,E,k,O){if(!i.enableDiagnostics)return;const F=b(R,E);if(O instanceof I.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const q=I.VSBuffer.alloc(O.byteLength);q.set(O),i.records.push({timestamp:Date.now(),id:F,label:E,type:k,buff:q})}else i.records.push({timestamp:Date.now(),id:F,label:E,type:k,data:O})}i.traceSocketEvent=D})(C||(e.SocketDiagnostics=C={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let a=null;function p(){return a||(a=I.VSBuffer.alloc(0)),a}class v{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return p();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}const b=I.VSBuffer.alloc(n);let D=0,R=0;for(;n>0;){const E=this._chunks[R];if(E.byteLength>n){const k=E.slice(0,n);b.set(k,D),D+=n,o&&(this._chunks[R]=E.slice(n),this._totalLength-=n),n-=n}else b.set(E,D),D+=E.byteLength,o?(this._chunks.shift(),this._totalLength-=E.byteLength):R++,n-=E.byteLength}return b}}e.ChunkStream=v;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,o,b,D){this.type=n,this.id=o,this.ack=b,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends r.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new v,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const b=this._state.messageType,D=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new w(b,D,R,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=I.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(o,n.data)}_bufferAdd(n,o){const b=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,b}_bufferTake(){const n=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class h extends r.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new w(1,0,0,n))}}e.Protocol=h;class c extends _.IPCClient{static fromSocket(n,o){return new c(new h(n),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,o,b=null){super(n,o,b),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=c;class P{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=P;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let n=0,o=this._first;for(;o;)o=o.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let o=0,b=this._first;for(;b;)n[o++]=b.data,b=b.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new u(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class l{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<l._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=l._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),o=(1+l._HISTORY_LENGTH)*1e3;let b=0;for(let D=0;D<l._HISTORY_LENGTH;D++)n-this.lastRuns[D]<=o&&b++;return 1-b/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new P,this.onControlMessage=this._onControlMessage.event,this._onMessage=new P,this.onMessage=this._onMessage.event,this._onDidDispose=new P,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new P,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new P,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??l.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new r.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new w(5,0,0,p());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new w(7,0,0,p());this._socketWriter.write(n)}sendResume(){const n=new w(8,0,0,p());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new r.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(b=>this._receiveMessage(b))),this._socketDisposables.add(this._socket.onClose(b=>this._onSocketClose.fire(b))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new w(3,0,this._incomingAckId,p());this._socketWriter.write(n);const o=this._outgoingUnackMsg.toArray();for(let b=0,D=o.length;b<D;b++)this._socketWriter.write(o[b]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new w(6,0,0,p())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let b=0,D=o.length;b<D;b++)this._socketWriter.write(o[b]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const b=new w(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(b),this._isReconnecting||(this._socketWriter.write(b),this._recvAckCheck())}sendControl(n){const o=new w(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime,b=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&b>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:b});return}const R=Math.max(2e4-o,2e4-b,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new w(3,0,this._incomingAckId,p());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new w(9,0,this._incomingAckId,p());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(ee[157],te([0,1,38,17,3,2,42,145]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(p,v){const S=r.Event.fromNodeEventEmitter(I.validatedIpcMain,v,(y,w)=>({event:y,message:w})),f=r.Event.filter(S,({event:y})=>y.sender.id===p);return r.Event.map(f,({message:y})=>y&&L.VSBuffer.wrap(y))}class a extends M.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const v=r.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:S})=>S);return r.Event.map(v,S=>{const f=S.id;a.Clients.get(f)?.dispose();const w=new r.Emitter;a.Clients.set(f,(0,_.toDisposable)(()=>w.fire()));const g=d(f,"vscode:message"),m=r.Event.any(r.Event.signal(d(f,"vscode:disconnect")),w.event);return{protocol:new C.Protocol(S,g),onDidClientDisconnect:m}})}constructor(){super(a.getOnDidClientConnect())}}e.Server=a}),define(ee[110],te([0,1,38,3,32,156]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends _.Client{constructor(a,p){super({addEventListener:(v,S)=>a.addListener(v,S),removeEventListener:(v,S)=>a.removeListener(v,S),postMessage:v=>a.postMessage(v),start:()=>a.start(),close:()=>a.close()},p)}}e.Client=M;async function C(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,r.generateUuid)();d.webContents.send("vscode:createMessageChannel",a);const p=L.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(S,f)=>({nonce:f,port:S.ports[0]})),{port:v}=await L.Event.toPromise(L.Event.once(L.Event.filter(p,S=>S.nonce===a)));return v}e.connect=C}),define(ee[158],te([0,1,47,8,17,22,153,14,3,2,37,88,71,42]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends f.ChannelServer{constructor(m){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",h=>r.VSBuffer.wrap(Buffer.from(h,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=y;class w{constructor(m,h){this.modulePath=m,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new L.Delayer(c),this.child=null,this._client=null}getChannel(m){const h=this;return{call(c,P,u){return h.requestPromise(m,c,P,u)},listen(c,P){return h.requestEvent(m,c,P)}}}requestPromise(m,h,c,P=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(m),t=(0,L.createCancelablePromise)(i=>u.call(h,c,i)),l=P.onCancellationRequested(()=>t.cancel()),s=(0,a.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{l.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(m,h,c){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let P;const u=new d.Emitter({onWillAddFirstListener:()=>{P=this.getCachedChannel(m).listen(h,c)(u.fire,u),this.activeRequests.add(P)},onDidRemoveLastListener:()=>{this.activeRequests.delete(P),P.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(h.env),this.child=(0,I.fork)(this.modulePath,m,h);const c=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,M.isRemoteConsoleLog)(n)){(0,M.log)(n,`IPC Library: ${this.options.serverName}`);return}c.fire(r.VSBuffer.wrap(Buffer.from(n,"base64")))});const u=this.options.useQueue?(0,v.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&u.send(n.buffer.toString("base64")),l=c.event,s={send:t,onMessage:l};this._client=new f.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(b=>(0,a.dispose)(b)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(m){let h=this.channels.get(m);return h||(h=this.client.getChannel(m),this.channels.set(m,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(ee[111],te([0,1,8,3,2,72,12]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function d(S){const f=S;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=d;var a;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(a||(e.StorageState=a={}));class p extends r.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(f,y=Object.create(null)){super(),this.database=f,this.options=y,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){this._onDidChangeStorage.pause();try{f.changed?.forEach((y,w)=>this.acceptExternal(w,y)),f.deleted?.forEach(y=>this.acceptExternal(y,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(f,y){if(this.state===a.Closed)return;let w=!1;(0,M.isUndefinedOrNull)(y)?w=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),w=!0),w&&this._onDidChangeStorage.fire({key:f,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const w=this.cache.get(f);return(0,M.isUndefinedOrNull)(w)?y:w}getBoolean(f,y){const w=this.get(f);return(0,M.isUndefinedOrNull)(w)?y:w==="true"}getNumber(f,y){const w=this.get(f);return(0,M.isUndefinedOrNull)(w)?y:parseInt(w,10)}getObject(f,y){const w=this.get(f);return(0,M.isUndefinedOrNull)(w)?y:(0,_.parse)(w)}async set(f,y,w=!1){if(this.state===a.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(f,w);const g=(0,M.isObject)(y)||Array.isArray(y)?(0,_.stringify)(y):String(y);if(this.cache.get(f)!==g)return this.cache.set(f,g),this.pendingInserts.set(f,g),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire({key:f,external:w}),this.doFlush()}async delete(f,y=!1){if(!(this.state===a.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire({key:f,external:y}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(this.hasPending)return this.doFlush(f)}async doFlush(f){return this.options.hint===C.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}isInMemory(){return this.options.hint===C.STORAGE_IN_MEMORY}}e.Storage=p;class v{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert?.forEach((y,w)=>this.items.set(w,y)),f.delete?.forEach(y=>this.items.delete(y))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=v}),define(ee[159],te([0,1,8,3,31,9,21]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class C{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(p,v=Object.create(null)){this.path=p,this.options=v,this.name=(0,_.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const p=await this.whenConnected,v=new Map;return(await this.all(p,"SELECT * FROM ItemTable")).forEach(f=>v.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${v.size} rows`),v}async updateItems(p){const v=await this.whenConnected;return this.doUpdateItems(v,p)}doUpdateItems(p,v){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${v.insert?(0,r.mapToString)(v.insert):"0"}), delete(${v.delete?(0,r.setToString)(v.delete):"0"})`),this.transaction(p,()=>{const S=v.insert,f=v.delete;if(S&&S.size>0){const y=[];y.push([]);let w=0;S.forEach((g,m)=>{let h=y[w];h.length>C.MAX_HOST_PARAMETERS&&(w++,h=[],y.push(h)),h.push(m,g)}),y.forEach(g=>{this.prepare(p,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,m=>m.run(g),()=>{const m=[];let h=0;return S.forEach((c,P)=>{m.push(P),h+=c.length}),`Keys: ${m.join(", ")} Length: ${h}`})})}if(f&&f.size){const y=[];y.push([]);let w=0;f.forEach(g=>{let m=y[w];m.length>C.MAX_HOST_PARAMETERS&&(w++,m=[],y.push(m)),m.push(g)}),y.forEach(g=>{this.prepare(p,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,m=>m.run(g),()=>{const m=[];return f.forEach(h=>{m.push(h)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const p=await this.whenConnected;return this.exec(p,"VACUUM")}async close(p){this.logger.trace(`[storage ${this.name}] close()`);const v=await this.whenConnected;return this.doClose(v,p)}doClose(p,v){return new Promise((S,f)=>{p.db.close(y=>(y&&this.handleSQLiteError(p,`[storage ${this.name}] close(): ${y}`),this.path===C.IN_MEMORY_PATH?S():!p.isErroneous&&!p.isInMemory?this.backup().then(S,w=>(this.logger.error(`[storage ${this.name}] backup(): ${w}`),S())):typeof v=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(w=>{const g=()=>this.doClose(w,void 0);return this.doUpdateItems(w,{insert:v()}).then(()=>g(),m=>(g(),Promise.reject(m)))})).then(S,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const p=this.toBackupPath(this.path);return M.Promises.copy(this.path,p,{preserveSymlinks:!1})}toBackupPath(p){return`${p}.backup`}async checkIntegrity(p){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${p})`);const v=await this.whenConnected,S=await this.get(v,p?"PRAGMA integrity_check":"PRAGMA quick_check"),f=p?S.integrity_check:S.quick_check;return v.isErroneous?`${f} (last error: ${v.lastError})`:v.isInMemory?`${f} (in-memory!)`:f}async connect(p,v=!0){this.logger.trace(`[storage ${this.name}] open(${p}, retryOnBusy: ${v})`);try{return await this.doConnect(p)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&v)return await(0,I.timeout)(C.BUSY_OPEN_TIMEOUT),this.connect(p,!1);try{await M.Promises.unlink(p);try{await M.Promises.rename(this.toBackupPath(p),p,!1)}catch{}return await this.doConnect(p)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(C.IN_MEMORY_PATH)}}}handleSQLiteError(p,v){p.isErroneous=!0,p.lastError=v,this.logger.error(v)}doConnect(p){return new Promise((v,S)=>{new Promise((f,y)=>{K(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(p,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>S(w)):S(w):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(y),g=>y.db.close(()=>S(g)))),isInMemory:p===C.IN_MEMORY_PATH};y.db.on("error",w=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${w}`)),this.logger.isTracing&&y.db.on("trace",w=>this.logger.trace(`[storage ${this.name}] Trace (event): ${w}`))},S)})}exec(p,v){return new Promise((S,f)=>{p.db.exec(v,y=>y?(this.handleSQLiteError(p,`[storage ${this.name}] exec(): ${y}`),f(y)):S())})}get(p,v){return new Promise((S,f)=>{p.db.get(v,(y,w)=>y?(this.handleSQLiteError(p,`[storage ${this.name}] get(): ${y}`),f(y)):S(w))})}all(p,v){return new Promise((S,f)=>{p.db.all(v,(y,w)=>y?(this.handleSQLiteError(p,`[storage ${this.name}] all(): ${y}`),f(y)):S(w))})}transaction(p,v){return new Promise((S,f)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),v(),p.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(p,`[storage ${this.name}] transaction(): ${y}`),f(y)):S())})})}prepare(p,v,S,f){const y=p.db.prepare(v),w=g=>{this.handleSQLiteError(p,`[storage ${this.name}] prepare(): ${g} (${v}). Details: ${f()}`)};y.on("error",w),S(y),y.finalize(g=>{g&&w(g),y.removeListener("error",w)})}}e.SQLiteStorageDatabase=C;class d{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=p.logTrace),p&&typeof p.logError=="function"&&(this.logError=p.logError)}get isTracing(){return!!this.logTrace}trace(p){this.logTrace?.(p)}error(p){this.logError?.(p)}}}),define(ee[160],te([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(ee[161],te([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[162],te([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[163],te([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(ee[164],te([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[165],te([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[166],te([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(ee[167],te([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(ee[168],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[169],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[170],te([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[171],te([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[172],te([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[173],te([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ee[174],te([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ee[175],te([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ee[176],te([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[177],te([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[178],te([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[179],te([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[180],te([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[181],te([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ee[182],te([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(ee[183],te([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[184],te([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[185],te([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ee[186],te([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[187],te([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[188],te([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[189],te([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[190],te([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(ee[191],te([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[192],te([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[193],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[194],te([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(M){let C=[];try{Array.isArray(M.workspaces)&&(C=M.workspaces.map(d=>({workspace:{id:d.id,configPath:I.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return C}e.deserializeWorkspaceInfos=r;function _(M){let C=[];try{Array.isArray(M.folders)&&(C=M.folders.map(d=>({folderUri:I.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return C}e.deserializeFolderInfos=_}),define(ee[195],te([0,1,14,163]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(r||(e.TokenType=r={}));function _(...a){switch(a.length){case 1:return(0,L.localize)(0,null,a[0]);case 2:return(0,L.localize)(1,null,a[0],a[1]);case 3:return(0,L.localize)(2,null,a[0],a[1],a[2]);default:return}}const M=(0,L.localize)(3,null),C=(0,L.localize)(4,null);class d{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(p){return this._input=p,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const v=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:v})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const v=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:v})}else this._match(126)?this._addToken(9):this._error(_("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(_("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(_("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(p){return this._isAtEnd()||this._input.charCodeAt(this._current)!==p?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(p){this._tokens.push({type:p,offset:this._start})}_error(p){const v=this._start,S=this._input.substring(this._start,this._current),f={type:19,offset:this._start,lexeme:S};this._errors.push({offset:v,lexeme:S,additionalInfo:p}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const p=this.stringRe.exec(this._input);if(p){this._current=this._start+p[0].length;const v=this._input.substring(this._start,this._current),S=d._keywords.get(v);S?this._addToken(S):this._tokens.push({type:17,lexeme:v,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let p=this._current,v=!1,S=!1;for(;;){if(p>=this._input.length){this._current=p,this._error(C);return}const y=this._input.charCodeAt(p);if(v)v=!1;else if(y===47&&!S){p++;break}else y===91?S=!0:y===92?v=!0:y===93&&(S=!1);p++}for(;p<this._input.length&&d._regexFlags.has(this._input.charCodeAt(p));)p++;this._current=p;const f=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=d}),define(ee[196],te([0,1,3,2]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(C,d,a){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(C,d,a){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r;class _ extends L.Disposable{constructor(C){super(),this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,d,a){this.channel.call("attach",[C,d,a])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,d){this.channel.call("terminate",[C,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,d){return this.channel.call("openExtensionDevelopmentHostWindow",[C,d])}}e.ExtensionHostDebugChannelClient=_}),define(ee[197],te([0,1,148,54,13,9,35,19,7]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,_.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",f)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(d.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=M.env.VSCODE_PORTABLE;return f?d.URI.file((0,_.join)(f,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,_.resolve)(f):(0,_.normalize)((0,_.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?d.URI.file((0,_.resolve)(f)):d.URI.file((0,_.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,_.resolve)(f);const y=M.env.VSCODE_EXTENSIONS;if(y)return y;const w=M.env.VSCODE_PORTABLE;return w?(0,_.join)(w,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?d.URI.parse(y):d.URI.file((0,_.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,_.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=M.env.VSCODE_PORTABLE;return f?d.URI.file((0,_.join)(f,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,y,w){this._args=f,this.paths=y,this.productService=w,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,Pe([L.memoize],a.prototype,"appRoot",null),Pe([L.memoize],a.prototype,"userHome",null),Pe([L.memoize],a.prototype,"userDataPath",null),Pe([L.memoize],a.prototype,"appSettingsHome",null),Pe([L.memoize],a.prototype,"tmpDir",null),Pe([L.memoize],a.prototype,"cacheHome",null),Pe([L.memoize],a.prototype,"stateResource",null),Pe([L.memoize],a.prototype,"userRoamingDataHome",null),Pe([L.memoize],a.prototype,"userDataSyncHome",null),Pe([L.memoize],a.prototype,"sync",null),Pe([L.memoize],a.prototype,"machineSettingsResource",null),Pe([L.memoize],a.prototype,"workspaceStorageHome",null),Pe([L.memoize],a.prototype,"localHistoryHome",null),Pe([L.memoize],a.prototype,"keyboardLayoutResource",null),Pe([L.memoize],a.prototype,"argvResource",null),Pe([L.memoize],a.prototype,"isExtensionDevelopment",null),Pe([L.memoize],a.prototype,"untitledWorkspacesHome",null),Pe([L.memoize],a.prototype,"builtinExtensionsPath",null),Pe([L.memoize],a.prototype,"extensionsPath",null),Pe([L.memoize],a.prototype,"extensionDevelopmentLocationURI",null),Pe([L.memoize],a.prototype,"extensionDevelopmentKind",null),Pe([L.memoize],a.prototype,"extensionTestsLocationURI",null),Pe([L.memoize],a.prototype,"debugExtensionHost",null),Pe([L.memoize],a.prototype,"logLevel",null),Pe([L.memoize],a.prototype,"extensionLogLevel",null),Pe([L.memoize],a.prototype,"serviceMachineIdResource",null),Pe([L.memoize],a.prototype,"disableTelemetry",null),Pe([L.memoize],a.prototype,"disableWorkspaceTrust",null),Pe([L.memoize],a.prototype,"useInMemorySecretStorage",null),Pe([L.memoize],a.prototype,"policyFile",null);function p(S,f){return v(S["inspect-extensions"],S["inspect-brk-extensions"],5870,f,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=p;function v(S,f,y,w,g,m){const c=Number(f||S)||(w?null:y),P=c?!!f:!1;let u;if(m)try{u=JSON.parse(m)}catch{}return{port:c,break:P,debugId:g,env:u}}e.parseDebugParams=v}),define(ee[112],te([0,1,306,4,166]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const _={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(w,g,m=M){const h=w.find(o=>o.length>0&&o[0]!=="-"),c={},P=["_"],u=[],t={};let l;for(const o in g){const b=g[o];b.type==="subcommand"?o===h&&(l=b):(b.alias&&(c[o]=b.alias),b.type==="string"||b.type==="string[]"?(P.push(o),b.deprecates&&P.push(...b.deprecates)):b.type==="boolean"&&(u.push(o),b.deprecates&&u.push(...b.deprecates)),b.global&&(t[o]=b))}if(l&&h){const o=t;for(const E in l.options)o[E]=l.options[E];const b=w.filter(E=>E!==h),D=m.getSubcommandReporter?m.getSubcommandReporter(h):void 0,R=C(b,o,D);return{[h]:R,_:[]}}const s=I(w,{string:P,boolean:u,alias:c}),i={},n=s;i._=s._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in g){const b=g[o];if(b.type==="subcommand")continue;b.alias&&delete n[b.alias];let D=n[o];if(b.deprecates)for(const R of b.deprecates)n.hasOwnProperty(R)&&(D||(D=n[R],D&&m.onDeprecatedOption(R,b.deprecationMessage||(0,r.localize)(37,null,o))),delete n[R]);if(typeof D<"u"){if(b.type==="string[]"){if(Array.isArray(D)||(D=[D]),!b.allowEmptyValue){const R=D.filter(E=>E.length>0);R.length!==D.length&&(m.onEmptyValue(o),D=R.length>0?R:void 0)}}else b.type==="string"&&(Array.isArray(D)?(D=D.pop(),m.onMultipleValues(o,D)):!D&&!b.allowEmptyValue&&(m.onEmptyValue(o),D=void 0));i[o]=D,b.deprecationMessage&&m.onDeprecatedOption(o,b.deprecationMessage)}delete n[o]}for(const o in n)m.onUnknownOption(o);return i}e.parseArgs=C;function d(w,g){let m="";return g.args&&(Array.isArray(g.args)?m=` <${g.args.join("> <")}>`:m=` <${g.args}>`),g.alias?`-${g.alias} --${w}${m}`:`--${w}${m}`}function a(w,g){const m=[];for(const h in w){const c=w[h],P=d(h,c);m.push([P,c.description])}return p(m,g)}e.formatOptions=a;function p(w,g){const h=w.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if(g-h<25)return w.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=g-h-1,P=[];for(const u of w){const t=u[0],l=S(u[1],c),s=v(h-t.length-2);P.push("  "+t+s+l[0]);for(let i=1;i<l.length;i++)P.push(v(h)+l[i])}return P}function v(w){return" ".repeat(w)}function S(w,g){const m=[];for(;w.length;){const h=w.length<g?w.length:w.lastIndexOf(" ",g),c=w.slice(0,h).trim();w=w.slice(h),m.push(c)}return m}function f(w,g,m,h,c){const P=process.stdout.isTTY&&process.stdout.columns||80,u=c?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",t=[`${w} ${m}`];t.push(""),t.push(`${(0,r.localize)(39,null)}: ${g} [${(0,r.localize)(40,null)}]${u}`),t.push(""),c?.noPipe!==!0&&(L.isWindows?t.push((0,r.localize)(41,null,g)):t.push((0,r.localize)(42,null,g)),t.push(""));const l={},s=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&s.push({command:i,description:n.description});else if(n.description&&n.cat){let o=l[n.cat];o||(l[n.cat]=o={}),o[i]=n}}for(const i in l){const n=i,o=l[n];o&&(t.push(_[n]),t.push(...a(o,P)),t.push(""))}return s.length&&(t.push((0,r.localize)(43,null)),t.push(...p(s.map(i=>[i.command,i.description]),P)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function y(w,g){return`${w||(0,r.localize)(44,null)}
${g||(0,r.localize)(45,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ee[198],te([0,1,87,196,112]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class _ extends L.ExtensionHostDebugBroadcastChannel{constructor(C){super(),this.windowsMainService=C}call(C,d,a){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(a[0],a[1]):super.call(C,d,a)}async openExtensionDevelopmentHostWindow(C,d){const a=(0,r.parseArgs)(C,r.OPTIONS);a.debugRenderer=d;const p=a.extensionDevelopmentPath;if(!p)return{success:!1};const[v]=await this.windowsMainService.openExtensionDevelopmentHostWindow(p,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!d)return{success:!0};const S=v.win;if(!S)return{success:!0};const f=S.webContents.debugger;let y=f.isAttached()?1/0:0;const w=(0,I.createServer)(g=>{y++===0&&f.attach();let m=!1;const h=u=>{m||g.write(JSON.stringify(u)+"\0")},c=(u,t,l,s)=>h({method:t,params:l,sessionId:s});S.on("close",()=>{f.removeListener("message",c),g.end(),m=!0}),f.addListener("message",c);let P=Buffer.alloc(0);g.on("data",u=>{P=Buffer.concat([P,u]);for(let t=P.indexOf(0);t!==-1;t=P.indexOf(0)){let l;try{const s=P.slice(0,t).toString("utf8");P=P.slice(t+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(l.method,l.params,l.sessionId).then(s=>h({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>h({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),g.on("error",u=>{console.error("error on cdp pipe:",u)}),g.on("close",()=>{m=!0,--y===0&&f.detach()})});return await new Promise(g=>w.listen(0,g)),S.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=_}),define(ee[62],te([0,1,307,167,112]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function _(v,S){const f=(c,P)=>{console.warn((0,L.localize)(0,null,c,P))},y=c=>{console.warn((0,L.localize)(1,null,c))},w=(c,P)=>{console.warn((0,L.localize)(2,null,c,P))},g=c=>({onUnknownOption:P=>{r.NATIVE_CLI_COMMANDS.includes(c)||console.warn((0,L.localize)(3,null,P,c))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:r.NATIVE_CLI_COMMANDS.includes(c)?g:void 0}),m={onUnknownOption:c=>{console.warn((0,L.localize)(4,null,c))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:g},h=(0,r.parseArgs)(v,r.OPTIONS,S?m:void 0);return h.goto&&h._.forEach(c=>I(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,L.localize)(5,null))),h}function M(v){const S=v.findIndex(f=>!/^-/.test(f));if(S>-1)return[...v.slice(0,S),...v.slice(S+1)]}function C(v){let[,...S]=v;process.env.VSCODE_DEV&&(S=M(S)||[]);const f=!p(process.env);return _(S,f)}e.parseMainProcessArgv=C;function d(v){let[,,...S]=v;return process.env.VSCODE_DEV&&(S=M(S)||[]),_(S,!0)}e.parseCLIProcessArgv=d;function a(v,...S){const f=v.indexOf("--");return f===-1?v.push(...S):v.splice(f,0,...S),v}e.addArg=a;function p(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=p}),function(){"use strict";function K(e,I,L){function r(M,C){const d=_(M,C),a=[d];return e.isAbsolute(d)||a.unshift(L),e.resolve(...a)}function _(M,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,C);const p=M["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(I.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,C)}return{getUserDataPath:r}}if(typeof define=="function")define(ee[199],te([113,27,35]),function(e,I,L){return K(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=K(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[89],te([0,1,27,197,199]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class _ extends L.AbstractNativeEnvironmentService{constructor(a,p){super(a,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,r.getUserDataPath)(a,p.nameShort)},p)}}e.NativeEnvironmentService=_;function M(d,a){return(0,L.parseDebugParams)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,a,d.extensionEnvironment)}e.parsePtyHostDebugPort=M;function C(d,a){return(0,L.parseDebugParams)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,a,d.extensionEnvironment)}e.parseSharedProcessDebugPort=C}),define(ee[200],te([0,1,45,27,33]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function _(M){const C=(0,r.randomPath)((0,L.tmpdir)());try{return(0,I.writeFileSync)(C,""),M&&console.log(`Marker file for --wait created: ${C}`),C}catch(d){M&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFileSync=_}),define(ee[201],te([0,1,12,169]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(M,C,d,a){try{_(M,C,d,a)}catch(p){M.error(p?.message??p)}return C}e.localizeManifest=r;function _(M,C,d,a){const p=(v,S,f)=>{const y=v[S];if((0,I.isString)(y)){const w=y,g=w.length;if(g>1&&w[0]==="%"&&w[g-1]==="%"){const m=w.substr(1,g-2);let h=d[m];h===void 0&&a&&(h=a[m]);const c=typeof h=="string"?h:h?.message,P=a?.[m],u=typeof P=="string"?P:P?.message;if(!c){u||M.warn(`[${C.name}]: ${(0,L.localize)(0,null,m)}`);return}if(f&&(S==="title"||S==="category")&&u&&u!==c){const t={value:c,original:u};v[S]=t}else v[S]=c}}else if((0,I.isObject)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?p(y,w,!0):p(y,w,f));else if(Array.isArray(y))for(let w=0;w<y.length;w++)p(y,w,f)};for(const v in C)C.hasOwnProperty(v)&&p(C,v)}}),define(ee[202],te([0,1,19,69,171,203]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function d(m){return m=m.trim(),m==="*"||M.test(m)}e.isValidVersionStr=d;function a(m){if(!d(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=m.match(M);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=a;function p(m){if(!m)return null;const h=m.majorBase,c=m.majorMustEqual,P=m.minorBase;let u=m.minorMustEqual;const t=m.patchBase;let l=m.patchMustEqual;m.hasCaret&&(h===0||(u=!1),l=!1);let s=0;if(m.preRelease){const i=C.exec(m.preRelease);if(i){const[,n,o,b]=i;s=Date.UTC(Number(n),Number(o)-1,Number(b))}}return{majorBase:h,majorMustEqual:c,minorBase:P,minorMustEqual:u,patchBase:t,patchMustEqual:l,isMinimum:m.hasGreaterEquals,notBefore:s}}e.normalizeVersion=p;function v(m,h,c){let P;typeof m=="string"?P=p(a(m)):P=m;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let t;if(typeof c=="string"?t=p(a(c)):t=c,!P||!t)return!1;const l=P.majorBase,s=P.minorBase,i=P.patchBase;let n=t.majorBase,o=t.minorBase,b=t.patchBase;const D=t.notBefore;let R=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:s>o?!0:s<o||u&&u<D?!1:i>=b:(l===1&&n===0&&(!R||!E||!k)&&(n=1,o=0,b=0,R=!0,E=!1,k=!1),l<n?!1:l>n?!R:s<o?!1:s>o?!E:i<b?!1:i>b?!k:!(u&&u<D))}e.isValidVersion=v;function S(m,h,c,P,u){const t=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return t.push([L.default.Error,r.localize(0,null)]),t;if(typeof P.name!="string")return t.push([L.default.Error,r.localize(1,null,"name")]),t;if(typeof P.version!="string")return t.push([L.default.Error,r.localize(2,null,"version")]),t;if(!P.engines)return t.push([L.default.Error,r.localize(3,null,"engines")]),t;if(typeof P.engines.vscode!="string")return t.push([L.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof P.extensionDependencies<"u"&&!g(P.extensionDependencies))return t.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof P.activationEvents<"u"){if(!g(P.activationEvents))return t.push([L.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof P.main>"u"&&typeof P.browser>"u")return t.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&t.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return t.push([L.default.Error,r.localize(9,null,"main")]),t;{const i=(0,I.joinPath)(c,P.main);(0,I.isEqualOrParent)(i,c)||t.push([L.default.Warning,r.localize(10,null,i.path,c.path)])}}if(typeof P.browser<"u"){if(typeof P.browser!="string")return t.push([L.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,I.joinPath)(c,P.browser);(0,I.isEqualOrParent)(i,c)||t.push([L.default.Warning,r.localize(12,null,i.path,c.path)])}}if(!_.valid(P.version))return t.push([L.default.Error,r.localize(13,null)]),t;const l=[];if(!f(m,h,P,u,l))for(const i of l)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=S;function f(m,h,c,P,u){return P||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(m,h,c.engines.vscode,u)}e.isValidExtensionVersion=f;function y(m,h,c){return m==="*"||w(h,c,m)}e.isEngineValid=y;function w(m,h,c,P=[]){const u=p(a(c));if(!u)return P.push(r.localize(14,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return P.push(r.localize(15,null,c)),!1}else if(!u.majorMustEqual)return P.push(r.localize(16,null,c)),!1;return v(m,h,u)?!0:(P.push(r.localize(17,null,m,c)),!1)}function g(m){if(!Array.isArray(m))return!1;for(let h=0,c=m.length;h<c;h++)if(typeof m[h]!="string")return!1;return!0}}),define(ee[204],te([0,1,17,32]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(_,M,C){let d=C&&C.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const p=(await M.readFile(_.serviceMachineIdResource)).value.toString();d=(0,L.isUUID)(p)?p:null}catch{d=null}if(!d){d=(0,L.generateUuid)();try{await M.writeFile(_.serviceMachineIdResource,I.VSBuffer.fromString(d))}catch{}}return C?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=r}),define(ee[73],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(r,_=[],M=!1){this.ctor=r,this.staticArguments=_,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=I}),define(ee[205],te([0,1,73]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function _(C,d,a){d instanceof I.SyncDescriptor||(d=new I.SyncDescriptor(d,[],!!a)),L.push([C,d])}e.registerSingleton=_;function M(){return L}e.getSingletonServiceDescriptors=M}),define(ee[206],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(_,M){this.key=_,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(const M of this._nodes.values())M.outgoing.size===0&&_.push(M);return _}insertEdge(_,M){const C=this.lookupOrInsertNode(_),d=this.lookupOrInsertNode(M);C.outgoing.set(d.key,d),d.incoming.set(C.key,C)}removeNode(_){const M=this._hashFn(_);this._nodes.delete(M);for(const C of this._nodes.values())C.outgoing.delete(M),C.incoming.delete(M)}lookupOrInsertNode(_){const M=this._hashFn(_);let C=this._nodes.get(M);return C||(C=new I(M,_),this._nodes.set(M,C)),C}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){const _=[];for(const[M,C]of this._nodes)_.push(`${M}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return _.join(`
`)}findCycleSlow(){for(const[_,M]of this._nodes){const C=new Set([_]),d=this._findCycle(M,C);if(d)return d}}_findCycle(_,M){for(const[C,d]of _.outgoing){if(M.has(C))return[...M,C].join(" -> ");M.add(C);const a=this._findCycle(d,M);if(a)return a;M.delete(C)}}}e.Graph=L}),define(ee[6],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function C(d){return d[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=C})(I||(e._util=I={})),e.IInstantiationService=r("instantiationService");function L(M,C,d){C[I.DI_TARGET]===C?C[I.DI_DEPENDENCIES].push({id:M,index:d}):(C[I.DI_DEPENDENCIES]=[{id:M,index:d}],C[I.DI_TARGET]=C)}function r(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const C=function(d,a,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(C,d,p)};return C.toString=()=>M,I.serviceIds.set(M,C),C}e.createDecorator=r;function _(M){return M}e.refineServiceDecorator=_}),define(ee[63],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,6]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function _(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationOverrides=_;function M(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=M;var C;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function d(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function a(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}e.isConfigured=a;function p(m,h){const c=Object.create(null);for(const P in m)v(c,P,m[P],h);return c}e.toValuesTree=p;function v(m,h,c,P){const u=h.split("."),t=u.pop();let l=m;for(let s=0;s<u.length;s++){const i=u[s];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:P(`Ignoring ${h} as ${u.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=c}catch{P(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}else P(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=v;function S(m,h){const c=h.split(".");f(m,c)}e.removeFromValueTree=S;function f(m,h){const c=h.shift();if(h.length===0){delete m[c];return}if(Object.keys(m).indexOf(c)!==-1){const P=m[c];typeof P=="object"&&!Array.isArray(P)&&(f(P,h),Object.keys(P).length===0&&delete m[c])}}function y(m,h,c){function P(l,s){let i=l;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=h.split("."),t=P(m,u);return typeof t>"u"?c:t}e.getConfigurationValue=y;function w(m,h,c){Object.keys(h).forEach(P=>{P!=="__proto__"&&(P in m?I.isObject(m[P])&&I.isObject(h[P])?w(m[P],h[P],c):c&&(m[P]=h[P]):m[P]=h[P])})}e.merge=w;function g(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(ee[114],te([0,1,4,26,195,6,162,14]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",I.isMacintosh),d.set("isLinux",I.isLinux),d.set("isWindows",I.isWindows),d.set("isWeb",I.isWeb),d.set("isMacNative",I.isMacintosh&&!I.isWeb),d.set("isEdge",I.isEdge),d.set("isFirefox",I.isFirefox),d.set("isChrome",I.isChrome),d.set("isSafari",I.isSafari);function a(N,A){if(d.get(N)!==void 0)throw(0,C.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(N,A)}e.setConstant=a;const p=Object.prototype.hasOwnProperty;var v;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const S={regexParsingWithErrorRecovery:!0},f=(0,M.localize)(0,null),y=(0,M.localize)(1,null),w=(0,M.localize)(2,null),g=(0,M.localize)(3,null),m=(0,M.localize)(4,null),h=(0,M.localize)(5,null),c=(0,M.localize)(6,null),P=(0,M.localize)(7,null);class u{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(A=S){this._config=A,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(A){if(A===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(A).scan(),this._current=0,this._parsingErrors=[];try{const T=this._expr();if(!this._isAtEnd()){const $=this._peek(),B=$.type===17?h:void 0;throw this._parsingErrors.push({message:m,offset:$.offset,lexeme:r.Scanner.getLexeme($),additionalInfo:B}),u._parseError}return T}catch(T){if(T!==u._parseError)throw T;return}}_expr(){return this._or()}_or(){const A=[this._and()];for(;this._matchOne(16);){const T=this._and();A.push(T)}return A.length===1?A[0]:t.or(...A)}_and(){const A=[this._term()];for(;this._matchOne(15);){const T=this._term();A.push(T)}return A.length===1?A[0]:t.and(...A)}_term(){if(this._matchOne(2)){const A=this._peek();switch(A.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const T=this._expr();return this._consume(1,g),T?.negate()}case 17:return this._advance(),O.create(A.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",A)}}return this._primary()}_primary(){const A=this._peek();switch(A.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const T=this._expr();return this._consume(1,g),T}case 17:{const T=A.lexeme;if(this._advance(),this._matchOne(9)){const B=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),B.type!==10)throw this._errExpectedButGot("REGEX",B);const z=B.lexeme,j=z.lastIndexOf("/"),ae=j===z.length-1?void 0:this._removeFlagsGY(z.substring(j+1));let fe;try{fe=new RegExp(z.substring(1,j),ae)}catch{throw this._errExpectedButGot("REGEX",B)}return re.create(T,fe)}switch(B.type){case 10:case 19:{const z=[B.lexeme];this._advance();let j=this._peek(),ae=0;for(let we=0;we<B.lexeme.length;we++)B.lexeme.charCodeAt(we)===40?ae++:B.lexeme.charCodeAt(we)===41&&ae--;for(;!this._isAtEnd()&&j.type!==15&&j.type!==16;){switch(j.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let we=0;we<j.lexeme.length;we++)j.lexeme.charCodeAt(we)===40?ae++:B.lexeme.charCodeAt(we)===41&&ae--}if(ae<0)break;z.push(r.Scanner.getLexeme(j)),this._advance(),j=this._peek()}const fe=z.join(""),ue=fe.lastIndexOf("/"),de=ue===fe.length-1?void 0:this._removeFlagsGY(fe.substring(ue+1));let be;try{be=new RegExp(fe.substring(1,ue),de)}catch{throw this._errExpectedButGot("REGEX",B)}return t.regex(T,be)}case 18:{const z=B.lexeme;this._advance();let j=null;if(!(0,L.isFalsyOrWhitespace)(z)){const ae=z.indexOf("/"),fe=z.lastIndexOf("/");if(ae!==fe&&ae>=0){const ue=z.slice(ae+1,fe),de=z[fe+1]==="i"?"i":"";try{j=new RegExp(ue,de)}catch{throw this._errExpectedButGot("REGEX",B)}}}if(j===null)throw this._errExpectedButGot("REGEX",B);return re.create(T,j)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,w);const B=this._value();return t.notIn(T,B)}switch(this._peek().type){case 3:{this._advance();const B=this._value();if(this._previous().type===18)return t.equals(T,B);switch(B){case"true":return t.has(T);case"false":return t.not(T);default:return t.equals(T,B)}}case 4:{this._advance();const B=this._value();if(this._previous().type===18)return t.notEquals(T,B);switch(B){case"true":return t.not(T);case"false":return t.has(T);default:return t.notEquals(T,B)}}case 5:return this._advance(),J.create(T,this._value());case 6:return this._advance(),ce.create(T,this._value());case 7:return this._advance(),q.create(T,this._value());case 8:return this._advance(),ne.create(T,this._value());case 13:return this._advance(),t.in(T,this._value());default:return t.has(T)}}case 20:throw this._parsingErrors.push({message:c,offset:A.offset,lexeme:"",additionalInfo:P}),u._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const A=this._peek();switch(A.type){case 17:case 18:return this._advance(),A.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(A){return A.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(A){return this._check(A)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(A,T){if(this._check(A))return this._advance();throw this._errExpectedButGot(T,this._peek())}_errExpectedButGot(A,T,$){const B=(0,M.localize)(8,null,A,r.Scanner.getLexeme(T)),z=T.offset,j=r.Scanner.getLexeme(T);return this._parsingErrors.push({message:B,offset:z,lexeme:j,additionalInfo:$}),u._parseError}_check(A){return this._peek().type===A}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=u;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(A){return b.create(A)}static equals(A,T){return D.create(A,T)}static notEquals(A,T){return k.create(A,T)}static regex(A,T){return re.create(A,T)}static in(A,T){return R.create(A,T)}static notIn(A,T){return E.create(A,T)}static not(A){return O.create(A)}static and(...A){return V.create(A,null,!0)}static or(...A){return x.create(A,null,!0)}static greater(A,T){return q.create(A,T)}static greaterEquals(A,T){return ne.create(A,T)}static smaller(A,T){return J.create(A,T)}static smallerEquals(A,T){return ce.create(A,T)}static{this._parser=new u({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this._parser.parse(A)}}e.ContextKeyExpr=t;function l(N){const A=new u({regexParsingWithErrorRecovery:!1});return N.map(T=>(A.parse(T),A.lexingErrors.length>0?A.lexingErrors.map($=>({errorMessage:$.additionalInfo?(0,M.localize)(9,null,$.additionalInfo):(0,M.localize)(10,null),offset:$.offset,length:$.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map($=>({errorMessage:$.additionalInfo?`${$.message}. ${$.additionalInfo}`:$.message,offset:$.offset,length:$.lexeme.length})):[]))}e.validateWhenClauses=l;function s(N,A){const T=N?N.substituteConstants():void 0,$=A?A.substituteConstants():void 0;return!T&&!$?!0:!T||!$?!1:T.equals($)}e.expressionsAreEqualWithConstantSubstitution=s;function i(N,A){return N.cmp(A)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=o;class b{static create(A,T=null){const $=d.get(A);return typeof $=="boolean"?$?o.INSTANCE:n.INSTANCE:new b(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:U(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=d.get(this.key);return typeof A=="boolean"?A?o.INSTANCE:n.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class D{static create(A,T,$=null){if(typeof T=="boolean")return T?b.create(A,$):O.create(A,$);const B=d.get(A);return typeof B=="boolean"?T===(B?"true":"false")?o.INSTANCE:n.INSTANCE:new D(A,T,$)}constructor(A,T,$){this.key=A,this.value=T,this.negated=$,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=d.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?o.INSTANCE:n.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class R{static create(A,T){return new R(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.valueKey),$=A.getValue(this.key);return Array.isArray(T)?T.includes($):typeof $=="string"&&typeof T=="object"&&T!==null?p.call(T,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class E{static create(A,T){return new E(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=11,this._negated=R.create(A,T)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class k{static create(A,T,$=null){if(typeof T=="boolean")return T?O.create(A,$):b.create(A,$);const B=d.get(A);return typeof B=="boolean"?T===(B?"true":"false")?n.INSTANCE:o.INSTANCE:new k(A,T,$)}constructor(A,T,$){this.key=A,this.value=T,this.negated=$,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=d.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?n.INSTANCE:o.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class O{static create(A,T=null){const $=d.get(A);return typeof $=="boolean"?$?n.INSTANCE:o.INSTANCE:new O(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:U(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=d.get(this.key);return typeof A=="boolean"?A?n.INSTANCE:o.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function F(N,A){if(typeof N=="string"){const T=parseFloat(N);isNaN(T)||(N=T)}return typeof N=="string"||typeof N=="number"?A(N):n.INSTANCE}class q{static create(A,T,$=null){return F(T,B=>new q(A,B,$))}constructor(A,T,$){this.key=A,this.value=T,this.negated=$,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class ne{static create(A,T,$=null){return F(T,B=>new ne(A,B,$))}constructor(A,T,$){this.key=A,this.value=T,this.negated=$,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=ne;class J{static create(A,T,$=null){return F(T,B=>new J(A,B,$))}constructor(A,T,$){this.key=A,this.value=T,this.negated=$,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=J;class ce{static create(A,T,$=null){return F(T,B=>new ce(A,B,$))}constructor(A,T,$){this.key=A,this.value=T,this.negated=$,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ce;class re{static create(A,T){return new re(A,T)}constructor(A,T){this.key=A,this.regexp=T,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const T=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return T<$?-1:T>$?1:0}equals(A){if(A.type===this.type){const T=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return this.key===A.key&&T===$}return!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=re;class se{static create(A){return new se(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(A){return new se(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function G(N){let A=null;for(let T=0,$=N.length;T<$;T++){const B=N[T].substituteConstants();if(N[T]!==B&&A===null){A=[];for(let z=0;z<T;z++)A[z]=N[z]}A!==null&&(A[T]=B)}return A===null?N:A}class V{static create(A,T,$){return V._normalizeArr(A,T,$)}constructor(A,T){this.expr=A,this.negated=T,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,$=this.expr.length;T<$;T++){const B=i(this.expr[T],A.expr[T]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,$=this.expr.length;T<$;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=G(this.expr);return A===this.expr?this:V.create(A,this.negated,!1)}evaluate(A){for(let T=0,$=this.expr.length;T<$;T++)if(!this.expr[T].evaluate(A))return!1;return!0}static _normalizeArr(A,T,$){const B=[];let z=!1;for(const j of A)if(j){if(j.type===1){z=!0;continue}if(j.type===0)return n.INSTANCE;if(j.type===6){B.push(...j.expr);continue}B.push(j)}if(B.length===0&&z)return o.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let j=1;j<B.length;j++)B[j-1].equals(B[j])&&(B.splice(j,1),j--);if(B.length===1)return B[0];for(;B.length>1;){const j=B[B.length-1];if(j.type!==9)break;B.pop();const ae=B.pop(),fe=B.length===0,ue=x.create(j.expr.map(de=>V.create([de,ae],null,$)),null,fe);ue&&(B.push(ue),B.sort(i))}if(B.length===1)return B[0];if($){for(let j=0;j<B.length;j++)for(let ae=j+1;ae<B.length;ae++)if(B[j].negate().equals(B[ae]))return n.INSTANCE;if(B.length===1)return B[0]}return new V(B,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new V(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class x{static create(A,T,$){return x._normalizeArr(A,T,$)}constructor(A,T){this.expr=A,this.negated=T,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,$=this.expr.length;T<$;T++){const B=i(this.expr[T],A.expr[T]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,$=this.expr.length;T<$;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=G(this.expr);return A===this.expr?this:x.create(A,this.negated,!1)}evaluate(A){for(let T=0,$=this.expr.length;T<$;T++)if(this.expr[T].evaluate(A))return!0;return!1}static _normalizeArr(A,T,$){let B=[],z=!1;if(A){for(let j=0,ae=A.length;j<ae;j++){const fe=A[j];if(fe){if(fe.type===0){z=!0;continue}if(fe.type===1)return o.INSTANCE;if(fe.type===9){B=B.concat(fe.expr);continue}B.push(fe)}}if(B.length===0&&z)return n.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let j=1;j<B.length;j++)B[j-1].equals(B[j])&&(B.splice(j,1),j--);if(B.length===1)return B[0];if($){for(let j=0;j<B.length;j++)for(let ae=j+1;ae<B.length;ae++)if(B[j].negate().equals(B[ae]))return o.INSTANCE;if(B.length===1)return B[0]}return new x(B,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new x(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());for(;A.length>1;){const T=A.shift(),$=A.shift(),B=[];for(const z of oe(T))for(const j of oe($))B.push(V.create([z,j],null,!1));A.unshift(x.create(B,null,!1))}this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class W extends b{static{this._info=[]}static all(){return W._info.values()}constructor(A,T,$){super(A,null),this._defaultValue=T,typeof $=="object"?W._info.push({...$,key:A}):$!==!0&&W._info.push({key:A,description:$,type:T!=null?typeof T:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return D.create(this.key,A)}notEqualsTo(A){return k.create(this.key,A)}}e.RawContextKey=W,e.IContextKeyService=(0,_.createDecorator)("contextKeyService");function U(N,A){return N<A?-1:N>A?1:0}function H(N,A,T,$){return N<T?-1:N>T?1:A<$?-1:A>$?1:0}function Q(N,A){if(N.type===0||A.type===1)return!0;if(N.type===9)return A.type===9?ie(N.expr,A.expr):!1;if(A.type===9){for(const T of A.expr)if(Q(N,T))return!0;return!1}if(N.type===6){if(A.type===6)return ie(A.expr,N.expr);for(const T of N.expr)if(Q(T,A))return!0;return!1}return N.equals(A)}e.implies=Q;function ie(N,A){let T=0,$=0;for(;T<N.length&&$<A.length;){const B=N[T].cmp(A[$]);if(B<0)return!1;B===0&&T++,$++}return T===N.length}function oe(N){return N.type===9?N.expr:[N]}}),define(ee[90],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function L(_){return!!_.hostName&&!!_.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(M,C){return{}}async getSystemInfo(M,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,C){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=r}),define(ee[91],te([0,1,19,69,164,6,46,4,37]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,_.createDecorator)("dialogService");var a;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(a||(a={}));class p{getConfirmationButtons(g){return this.getButtons(g,a.Confirmation)}getPromptButtons(g){return this.getButtons(g,a.Prompt)}getInputButtons(g){return this.getButtons(g,a.Input)}getButtons(g,m){const h=[];switch(m){case a.Confirmation:{const c=g;c.primaryButton?h.push(c.primaryButton):h.push((0,r.localize)(0,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,r.localize)(1,null));break}case a.Prompt:{const c=g;Array.isArray(c.buttons)&&c.buttons.length>0&&h.push(...c.buttons.map(P=>P.label)),c.cancelButton&&(c.cancelButton===!0?h.push((0,r.localize)(2,null)):typeof c.cancelButton=="string"?h.push(c.cancelButton):c.cancelButton.label?h.push(c.cancelButton.label):h.push((0,r.localize)(3,null))),h.length===0&&h.push((0,r.localize)(4,null));break}case a.Input:{const c=g;c.primaryButton?h.push(c.primaryButton):h.push((0,r.localize)(5,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,r.localize)(6,null));break}}return h}getDialogType(g){if(typeof g=="string")return g;if(typeof g=="number")return g===L.default.Info?"info":g===L.default.Error?"error":g===L.default.Warning?"warning":"none"}async getPromptResult(g,m,h){const c=[...g.buttons??[]];return g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&c.push(g.cancelButton),{result:await c[m]?.run({checkboxChecked:h}),checkboxChecked:h}}}e.AbstractDialogHandler=p,e.IFileDialogService=(0,_.createDecorator)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const S=10;function f(w){const g=[];return g.push(...w.slice(0,S).map(m=>typeof m=="string"?m:(0,I.basename)(m))),w.length>S&&(w.length-S===1?g.push((0,r.localize)(7,null)):g.push((0,r.localize)(8,null,w.length-S))),g.push(""),g.join(`
`)}e.getFileNamesMessage=f;function y(w,g){const m=(0,d.deepClone)(w);let h=(m.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),c=(w.buttons||[]).map((t,l)=>l),P=0,u=m.cancelId??h.length-1;if(h.length>1){const t=typeof u=="number"?h[u]:void 0;if(C.isLinux||C.isMacintosh){if(typeof t=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,t);const l=c[u];c.splice(u,1),c.splice(1,0,l),u=1}C.isLinux&&h.length>1&&(h=h.reverse(),c=c.reverse(),P=h.length-1,typeof t=="string"&&(u=P-1))}else if(C.isWindows&&typeof t=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(t);const l=c[u];c.splice(u,1),c.push(l),u=h.length-1}}return m.buttons=h,m.defaultId=P,m.cancelId=u,m.noLink=!0,m.title=m.title||g.nameLong,{options:m,buttonIndeces:c}}e.massageMessageBoxOptions=y}),define(ee[115],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,I.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService");var L;(function(C){C.kwallet="kwallet",C.kwallet5="kwallet5",C.gnome="gnome",C.gnomeKeyring="gnome-keyring",C.gnomeLibsecret="gnome-libsecret",C.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var r;(function(C){C.unknown="unknown",C.basicText="basic_text",C.gnomeAny="gnome_any",C.gnomeLibsecret="gnome_libsecret",C.gnomeKeyring="gnome_keyring",C.kwallet="kwallet",C.kwallet5="kwallet5",C.kwallet6="kwallet6",C.dplib="dpapi",C.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function _(C){return C==="kwallet"||C==="kwallet5"||C==="kwallet6"}e.isKwallet=_;function M(C){return C==="gnome_any"||C==="gnome_libsecret"||C==="gnome_keyring"}e.isGnome=M}),define(ee[36],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[116],te([0,1,168,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function r(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function _(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function M(h,c){switch(h){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function C(h,c){return c==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function d(h,c,P){return C(c,P)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===P?!0:a(P).includes(h)}e.isTargetPlatformCompatible=d;function a(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=a;function p(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=p;var v;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var f;(function(h){h.Install="install",h.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var w;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var g;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class m extends Error{constructor(c,P){super(c),this.code=P,this.name=P}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ee[207],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[208],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ee[209],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[210],te([0,1,47,13,9,4,71,21,88,172,208]),function(K,e,I,L,r,_,M,C,d,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=a.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends S{static{this.CMD="cmd.exe"}openTerminal(P,u){return this.spawnTerminal(I,P,d.getWindowsShell(),u)}spawnTerminal(P,u,t,l){const s=u.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=r.basename(s,".exe").toLowerCase();if(i==="cmder")return P.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),i==="wt"&&n.push("-d ."),new Promise((o,b)=>{const D=g(process),R=P.spawn(t,n,{cwd:l,env:D});R.on("error",b),R.on("exit",()=>o())})}runInTerminal(P,u,t,l,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,o)=>{const b=`"${u} - ${v}"`,D=`""${t.join('" "')}" & pause"`,R=Object.assign({},g(process),l);Object.keys(R).filter(q=>R[q]===null).forEach(q=>delete R[q]);const E={cwd:u,env:R,windowsVerbatimArguments:!0};let k,O;r.basename(i,".exe")==="wt"?(k=i,O=["-d",".",f.CMD,"/c",D]):(k=f.CMD,O=["/c","start",b,"/wait",i,"/c",D]),I.spawn(k,O,E).on("error",q=>{o(m(q))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const P=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${P?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f;class y extends S{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(P,u){return this.spawnTerminal(I,P,u)}runInTerminal(P,u,t,l,s){const i=s.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{if(i===p.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const b=i===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`).fsPath,"-t",P||v,"-w",u];for(const O of t)R.push("-a"),R.push(O);if(l){const O=Object.assign({},g(process),l);for(const F in O){const q=O[F];q===null?(R.push("-u"),R.push(F)):(R.push("-e"),R.push(`${F}=${q}`))}}let E="";const k=I.spawn(y.OSASCRIPT,R);k.on("error",O=>{o(m(O))}),k.stderr.on("data",O=>{E+=O.toString()}),k.on("exit",O=>{if(O===0)n(void 0);else if(E){const F=E.split(`
`,1);o(new Error(F[0]))}else o(new Error(a.localize(1,null,b,O)))})}else o(new Error(a.localize(2,null,i)))})}spawnTerminal(P,u,t){const l=u.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const n=["-a",l];t&&n.push(t);const o=g(process),b=P.spawn("/usr/bin/open",n,{cwd:t,env:o});b.on("error",i),b.on("exit",()=>s())})}}e.MacExternalTerminalService=y;class w extends S{static{this.WAIT_MESSAGE=a.localize(3,null)}openTerminal(P,u){return this.spawnTerminal(I,P,u)}runInTerminal(P,u,t,l,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const b=[];i.then(D=>{D.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const R=`${h(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;b.push(`''${R}''`);const E=Object.assign({},g(process),l);Object.keys(E).filter(q=>E[q]===null).forEach(q=>delete E[q]);const k={cwd:u,env:E};let O="";const F=I.spawn(D,b,k);F.on("error",q=>{o(m(q))}),F.stderr.on("data",q=>{O+=q.toString()}),F.on("exit",q=>{if(q===0)n(void 0);else if(O){const ne=O.split(`
`,1);o(new Error(ne[0]))}else o(new Error(a.localize(4,null,D,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const P=await C.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{P?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(P,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{l.then(n=>{const o=g(process),b=P.spawn(n,[],{cwd:t,env:o});b.on("error",i),b.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=w;function g(c){const P={...c.env};return(0,M.sanitizeProcessEnvironment)(P),P}function m(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(a.localize(5,null,c.path)):c}function h(c){let P="";for(const u of c)u.indexOf(" ")>=0?P+='"'+u+'"':P+=u,P+=" ";return P}}),define(ee[16],te([0,1,56,9,26,12,7,174,6,4,13]),function(K,e,I,L,r,_,M,C,d,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function v(U){return U.create===!0}e.isFileOpenForWriteOptions=v;var S;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var f;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function w(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=w;function g(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=g;function m(U){return!!(U.capabilities&131072)}e.hasFileCloneCapability=m;function h(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function c(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=c;function P(U){return w(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=P;function u(U){return w(U)?!!(U.capabilities&32768):!1}e.hasFileAtomicWriteCapability=u;function t(U){return!!(U.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function l(U){return!!(U.capabilities&2048)}e.hasReadonlyCapability=l;var s;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create(H,Q){const ie=new i(H.toString(),Q);return b(ie,Q),ie}constructor(H,Q){super(H),this.code=Q}}e.FileSystemProviderError=i;function n(U,H){return i.create(U,H)}e.createFileSystemProviderError=n;function o(U){return U||n((0,C.localize)(0,null),s.Unknown)}e.ensureFileSystemProviderError=o;function b(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=b;function D(U){if(!U)return s.Unknown;if(U instanceof i)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return s.Unknown;switch(H[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.toFileSystemProviderErrorCode=D;function R(U){if(U instanceof ne)return U.fileOperationResult;switch(D(U)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=R;var E;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class k{constructor(H,Q,ie){this.resource=H,this.operation=Q,this.target=ie}isOperation(H){return this.operation===H}}e.FileOperationEvent=k;var O;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class F{constructor(H,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const oe of H){const N=ie.get(oe.type);switch(N?N.push([oe.resource,oe]):ie.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,N]of ie)switch(oe){case 1:this.added=I.TernarySearchTree.forUris(()=>Q),this.added.fill(N);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>Q),this.updated.fill(N);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>Q),this.deleted.fill(N);break}}contains(H,...Q){return this.doContains(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.doContains(H,{includeChildren:!0},...Q)}doContains(H,Q,...ie){if(!H)return!1;const oe=ie.length>0;return!!((!oe||ie.includes(1))&&(this.added?.get(H)||Q.includeChildren&&this.added?.findSuperstr(H))||(!oe||ie.includes(0))&&(this.updated?.get(H)||Q.includeChildren&&this.updated?.findSuperstr(H))||(!oe||ie.includes(2))&&(this.deleted?.findSubstr(H)||Q.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=F;function q(U,H,Q){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),Q?(0,r.startsWithIgnoreCase)(U,H):U.indexOf(H)===0)}e.isParent=q;class ne extends Error{constructor(H,Q,ie){super(H),this.fileOperationResult=Q,this.options=ie}}e.FileOperationError=ne;class J extends ne{constructor(H,Q,ie,oe){super(H,Q,oe),this.fileOperationResult=Q,this.size=ie}}e.TooLargeFileOperationError=J;class ce extends ne{constructor(H,Q,ie){super(H,2,ie),this.stat=Q}}e.NotModifiedSinceFileOperationError=ce;var re;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var se;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(se||(e.FileKind=se={})),e.ETAG_DISABLED="";function G(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=G;async function V(U,H){if(!H.hasProvider(M.URI.from({scheme:U.scheme})))return new Promise(Q=>{const ie=H.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===U.scheme&&oe.added&&(ie.dispose(),Q())})})}e.whenProviderRegistered=V;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(H){return(0,_.isNumber)(H)||(H=0),H<x.KB?(0,C.localize)(1,null,H.toFixed(0)):H<x.MB?(0,C.localize)(2,null,(H/x.KB).toFixed(2)):H<x.GB?(0,C.localize)(3,null,(H/x.MB).toFixed(2)):H<x.TB?(0,C.localize)(4,null,(H/x.GB).toFixed(2)):(0,C.localize)(5,null,(H/x.TB).toFixed(2))}}e.ByteSize=x;function W(U){const H=typeof U=="string"||U?.scheme===p.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===p.Schemas.file?1024*x.MB:H?10*x.MB:a.isWeb?50*x.MB:1024*x.MB}e.getLargeFileConfirmationLimit=W}),define(ee[211],te([0,1,17,49,14,3,2,61,7,32,16]),function(K,e,I,L,r,_,M,C,d,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends M.Disposable{constructor(f,y){super(),this.channel=f,this.extraCapabilities=y,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,a.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,y){const{buffer:w}=await this.channel.call("readFile",[f,y]);return w}readFileStream(f,y,w){const g=(0,C.newWriteableStream)(h=>I.VSBuffer.concat(h.map(c=>I.VSBuffer.wrap(c))).buffer),m=new M.DisposableStore;return m.add(this.channel.listen("readFileStream",[f,y])(h=>{if(h instanceof I.VSBuffer)g.write(h.buffer);else{if(h==="end")g.end();else{let c;if(h instanceof Error)c=h;else{const P=h;c=(0,p.createFileSystemProviderError)(P.message??(0,L.toErrorMessage)(P),P.code??p.FileSystemProviderErrorCode.Unknown)}g.error(c),g.end()}m.dispose()}})),m.add(w.onCancellationRequested(()=>{g.error((0,r.canceled)()),g.end(),m.dispose()})),g}writeFile(f,y,w){return this.channel.call("writeFile",[f,I.VSBuffer.wrap(y),w])}open(f,y){return this.channel.call("open",[f,y])}close(f){return this.channel.call("close",[f])}async read(f,y,w,g,m){const[h,c]=await this.channel.call("read",[f,y,m]);return w.set(h.buffer.slice(0,c),g),c}write(f,y,w,g,m){return this.channel.call("write",[f,y,I.VSBuffer.wrap(w),g,m])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,y){return this.channel.call("delete",[f,y])}rename(f,y,w){return this.channel.call("rename",[f,y,w])}copy(f,y,w){return this.channel.call("copy",[f,y,w])}cloneFile(f,y){return this.channel.call("cloneFile",[f,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const y=f;this._onDidChange.fire(y.map(w=>({resource:d.URI.revive(w.resource),type:w.type})))}else{const y=f;this._onDidWatchError.fire(y)}}))}watch(f,y){const w=(0,a.generateUuid)();return this.channel.call("watch",[this.sessionId,w,f,y]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,w]))}}e.DiskFileSystemProviderClient=v}),define(ee[117],te([0,1,17,14,175,16]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(p,v,S,f,y,w){let g;try{await C(p,v,S,f,y,w)}catch(m){g=m}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&S.error(g),S.end()}}e.readFileIntoStream=M;async function C(p,v,S,f,y,w){d(w);const g=await p.open(v,{create:!1});try{d(w);let m=0,h=0,c=y&&typeof y.length=="number"?y.length:void 0,P=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,t=0;do h=await p.read(g,u,P.buffer,t,P.byteLength-t),u+=h,t+=h,m+=h,typeof c=="number"&&(c-=h),t===P.byteLength&&(await S.write(f(P)),P=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),t=0);while(h>0&&(typeof c!="number"||c>0)&&d(w)&&a(m,y));if(t>0){let l=t;typeof c=="number"&&(l=Math.min(t,c)),S.write(f(P.slice(0,l)))}}catch(m){throw(0,_.ensureFileSystemProviderError)(m)}finally{await p.close(g)}}function d(p){if(p.isCancellationRequested)throw(0,L.canceled)();return!0}function a(p,v){if(typeof v?.limits?.size=="number"&&p>v.limits.size)throw(0,_.createFileSystemProviderError)((0,r.localize)(0,null),_.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[74],te([0,1,104,2,9,4,7,16]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function d(m){return m.recursive===!0}e.isRecursiveWatchRequest=d;class a extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(h,c,P,u){super(),this.onFileChanges=h,this.onLogMessage=c,this.verboseLogging=P,this.options=u,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new L.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),h.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),h.add(this.watcher.onDidError(c=>this.onError(c)))}onError(h){this.options.restartOnError?this.restartCounter<a.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}trace(h){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=a;class p extends a{constructor(h,c,P){super(h,c,P,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class v extends a{constructor(h,c,P){super(h,c,P,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function S(m){return m.map(h=>({type:h.type,resource:M.URI.file(h.path)}))}e.toFileChanges=S;function f(m){const h=new g;for(const c of m)h.processEvent(c);return h.coalesce()}e.coalesceEvents=f;function y(m,h){return typeof h=="string"&&!h.startsWith(I.GLOBSTAR)&&!(0,r.isAbsolute)(h)?{base:m,pattern:h}:h}e.normalizeWatcherPattern=y;function w(m,h){const c=[];for(const P of h)c.push((0,I.parse)(y(m,P)));return c}e.parseWatcherPatterns=w;class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return _.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const c=this.mapPathToChange.get(this.toKey(h));let P=!1;if(c){const u=c.type,t=h.type;c.path!==h.path&&(h.type===2||h.type===1)?P=!0:u===1&&t===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(c)):u===2&&t===1?c.type=0:u===1&&t===0||(c.type=t)}else P=!0;P&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],c=[];return Array.from(this.coalesced).filter(P=>P.type!==2?(h.push(P),!1):!0).sort((P,u)=>P.path.length-u.path.length).filter(P=>c.some(u=>(0,C.isParent)(P.path,u,!_.isLinux))?!1:(c.push(P.path),!0)).concat(h)}}}),define(ee[212],te([0,1,45,8,22,33,2,84,9,4,105,21,74]),function(K,e,I,L,r,_,M,C,d,a,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends M.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(g,m,h,c){super(),this.request=g,this.onDidFilesChange=m,this.onLogMessage=h,this.verboseLogging=c,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},P=>this.onDidFilesChange(P))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(P=>this.handleFileChanges(P),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await v.Promises.stat(g);this._register(await this.doWatch(g,m.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let m=g.path;try{m=await v.Promises.realpath(g.path),g.path===m&&(m=await(0,p.realcase)(g.path)??g.path),g.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${m})`)}catch{}return m}async doWatch(g,m){if(a.isMacintosh&&(0,_.isEqualOrParent)(g,"/Volumes/",!0))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const h=new r.CancellationTokenSource(this.cts.token),c=new M.DisposableStore;try{const P=(0,d.basename)(g),u=(0,I.watch)(g);c.add((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${g}'`);const t=new Set;if(m)try{for(const s of await v.Promises.readdir(g))t.add(s)}catch(s){this.error(s)}const l=new Map;c.add((0,M.toDisposable)(()=>{for(const[,s]of l)s.dispose();l.clear()})),u.on("error",(s,i)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),u.on("change",(s,i)=>{if(h.token.isCancellationRequested)return;this.trace(`[raw] ["${s}"] ${i}`);let n="";if(i&&(n=i.toString(),a.isMacintosh&&(n=(0,C.normalizeNFC)(n))),!(!n||s!=="change"&&s!=="rename"))if(m)if(s==="rename"){l.get(n)?.dispose();const o=setTimeout(async()=>{if(l.delete(n),n===P&&!await v.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.existsChildStrictCase((0,d.join)(g,n));if(h.token.isCancellationRequested)return;let D;b?t.has(n)?D=0:(D=1,t.add(n)):(t.delete(n),D=2),this.onFileChange({path:(0,d.join)(this.request.path,n),type:D})},f.FILE_DELETE_HANDLER_DELAY);l.set(n,(0,M.toDisposable)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.onFileChange({path:(0,d.join)(this.request.path,n),type:o})}else if(s==="rename"||n!==P){const o=setTimeout(async()=>{const b=await v.Promises.exists(g);h.token.isCancellationRequested||(b?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(g,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,M.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(P){await v.Promises.exists(g)&&!h.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${P.toString()})`)}return(0,M.toDisposable)(()=>{h.dispose(!0),c.dispose()})}onFileChange(g,m=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!m&&this.excludes.some(h=>h(g.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${g.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(h=>h(g.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${g.path}`):this.fileChangesAggregator.work(g))}handleFileChanges(g){const m=(0,S.coalesceEvents)(g);if(m.length>0){if(this.verboseLogging)for(const c of m)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesEmitter.work(m)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(g){if(a.isLinux)return v.Promises.exists(g);try{const m=(0,d.basename)(g);return(await v.Promises.readdir((0,d.dirname)(g))).some(c=>c===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f;async function y(w,g,m,h,c=512){const P=await v.Promises.open(w,"r"),u=Buffer.allocUnsafe(c),t=new r.CancellationTokenSource(h);let l,s=!1;const i={path:w,excludes:[],recursive:!1},n=new f(i,o=>{(async()=>{for(const{type:b}of o)if(b===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:D}=await v.Promises.read(P,u,0,c,null);if(!D||t.token.isCancellationRequested)break;g(u.slice(0,D))}}catch(D){l=new Error(D),t.dispose(!0)}finally{s=!1}}})()});return await n.ready,m(),new Promise((o,b)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await v.Promises.close(P)}catch(D){l=new Error(D)}l?b(l):o()})})}e.watchFileContents=y}),define(ee[213],te([0,1,3,104,2,4,212]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(a){const p=this.normalizeRequests(a),v=p.filter(f=>{const y=this.watchers.get(f.path);return y?!(0,L.patternsEquals)(y.request.excludes,f.excludes)||!(0,L.patternsEquals)(y.request.includes,f.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:f})=>!p.find(y=>y.path===f.path&&(0,L.patternsEquals)(y.excludes,f.excludes)&&(0,L.patternsEquals)(y.includes,f.includes))).map(({request:f})=>f.path);v.length&&this.trace(`Request to start watching: ${v.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.stopWatching(f);for(const f of v)this.startWatching(f)}startWatching(a){const p=new M.NodeJSFileWatcherLibrary(a,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),v={request:a,instance:p};this.watchers.set(a.path,v)}async stop(){for(const[a]of this.watchers)this.stopWatching(a);this.watchers.clear()}stopWatching(a){const p=this.watchers.get(a);p&&(this.watchers.delete(a),p.instance.dispose())}normalizeRequests(a){const p=new Map;for(const v of a){const S=_.isLinux?v.path:v.path.toLowerCase();p.set(S,v)}return Array.from(p.values())}async setVerboseLogging(a){this.verboseLogging=a;for(const[,p]of this.watchers)p.instance.setVerboseLogging(a)}trace(a){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(a)})}toMessage(a,p){return p?`[File Watcher (node.js)] ${a} (path: ${p.request.path})`:`[File Watcher (node.js)] ${a}`}}e.NodeJSWatcher=C}),define(ee[214],te([0,1,74,213]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends I.AbstractNonRecursiveWatcherClient{constructor(M,C,d){super(M,C,d),this.init()}createWatcher(M){return M.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=r}),define(ee[215],te([0,1,13,42,158,74]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends _.AbstractUniversalWatcherClient{constructor(d,a,p){super(d,a,p),this.init()}createWatcher(d){const a=d.add(new r.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(a.onDidProcessExit(({code:p,signal:v})=>this.onError(`terminated by itself with code ${p}, signal: ${v}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[92],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...r){this._entries=new Map;for(const[_,M]of r)this.set(_,M)}set(r,_){const M=this._entries.get(r);return this._entries.set(r,_),M}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=I}),define(ee[216],te([0,1,8,14,2,73,206,6,92,101]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class v extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class S{constructor(g=new d.ServiceCollection,m=!1,h,c=p){this._services=g,this._strict=m,this._parent=h,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(C.IInstantiationService,this),this._globalGraph=c?h?._globalGraph??new M.Graph(P=>P):void 0}createChild(g){return new S(g,this._strict,this,this._enableTracing)}invokeFunction(g,...m){const h=y.traceInvocation(this._enableTracing,g);let c=!1;try{return g({get:u=>{if(c)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(u,h);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...m)}finally{c=!0,h.stop()}}createInstance(g,...m){let h,c;return g instanceof _.SyncDescriptor?(h=y.traceCreation(this._enableTracing,g.ctor),c=this._createInstance(g.ctor,g.staticArguments.concat(m),h)):(h=y.traceCreation(this._enableTracing,g),c=this._createInstance(g,m,h)),h.stop(),c}_createInstance(g,m=[],h){const c=C._util.getServiceDependencies(g).sort((t,l)=>t.index-l.index),P=[];for(const t of c){const l=this._getOrCreateServiceInstance(t.id,h);l||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),P.push(l)}const u=c.length>0?c[0].index:m.length;if(m.length!==u){console.trace(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${m.length} static arguments`);const t=u-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,u)}return Reflect.construct(g,m.concat(P))}_setServiceInstance(g,m){if(this._services.get(g)instanceof _.SyncDescriptor)this._services.set(g,m);else if(this._parent)this._parent._setServiceInstance(g,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const m=this._services.get(g);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):m}_getOrCreateServiceInstance(g,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const h=this._getServiceInstanceOrDescriptor(g);return h instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,h,m.branch(g,!0)):(m.branch(g,!1),h)}_safeCreateAndCacheServiceInstance(g,m,h){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,m,h)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,m,h){const c=new M.Graph(t=>t.id.toString());let P=0;const u=[{id:g,desc:m,_trace:h}];for(;u.length;){const t=u.pop();if(c.lookupOrInsertNode(t),P++>1e3)throw new v(c);for(const l of C._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(l.id);if(s||this._throwIfStrict(`[createInstance] ${g} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),s instanceof _.SyncDescriptor){const i={id:l.id,desc:s,_trace:t._trace.branch(l.id,!0)};c.insertEdge(t,i),u.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new v(c);break}for(const{data:l}of t){if(this._getServiceInstanceOrDescriptor(l.id)instanceof _.SyncDescriptor){const i=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,i)}c.removeNode(l)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,m,h=[],c,P){if(this._services.get(g)instanceof _.SyncDescriptor)return this._createServiceInstance(g,m,h,c,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,m,h,c,P);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(g,m,h=[],c,P){if(c){const u=new S(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(g);const t=new Map,l=new I.IdleValue(()=>{const s=u._createInstance(m,h,P);for(const[i,n]of t){const o=s[i];if(typeof o=="function")for(const b of n)o.apply(s,b)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new a.LinkedList,t.set(i,b)),(R,E,k)=>{const O=b.push([R,E,k]);return(0,r.toDisposable)(O)}}if(i in s)return s[i];const n=l.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),s[i]=o),o},set(s,i,n){return l.value[i]=n,!0},getPrototypeOf(s){return m.prototype}})}else return this._createInstance(m,h,P)}_throwIfStrict(g,m){if(m&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=S;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,m){return g?new y(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(g,m){return g?new y(1,m.name):y._None}static{this._totals=0}constructor(g,m){this.type=g,this.name=m,this._start=Date.now(),this._dep=[]}branch(g,m){const h=new y(3,g.toString());return this._dep.push([g,m,h]),h}stop(){const g=Date.now()-this._start;y._totals+=g;let m=!1;function h(P,u){const t=[],l=new Array(P+1).join("	");for(const[s,i,n]of u._dep)if(i&&n){m=!0,t.push(`${l}CREATES -> ${s}`);const o=h(P+1,n);o&&t.push(o)}else t.push(`${l}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(g>2||m)&&y.all.add(c.join(`
`))}}e.Trace=y}),define(ee[217],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,I.createDecorator)("issueService")}),define(ee[5],te([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(K,e,I,L,r,_,M,C,d,a,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function f(){return new Date().toISOString()}function y(R){return(0,a.isNumber)(R)}e.isLogLevel=y;var w;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function g(R,E,k){switch(E){case w.Trace:R.trace(k);break;case w.Debug:R.debug(k);break;case w.Info:R.info(k);break;case w.Warning:R.warn(k);break;case w.Error:R.error(k);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=g;function m(R,E=!1){let k="";for(let O=0;O<R.length;O++){let F=R[O];if(F instanceof Error&&(F=(0,I.toErrorMessage)(F,E)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(O>0?" ":"")+F}return k}class h extends _.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==w.Off&&this.level<=E}}e.AbstractLogger=h;class c extends h{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...k){this.checkLogLevel(w.Trace)&&this.log(w.Trace,m([E,...k],!0))}debug(E,...k){this.checkLogLevel(w.Debug)&&this.log(w.Debug,m([E,...k]))}info(E,...k){this.checkLogLevel(w.Info)&&this.log(w.Info,m([E,...k]))}warn(E,...k){this.checkLogLevel(w.Warning)&&this.log(w.Warning,m([E,...k]))}error(E,...k){if(this.checkLogLevel(w.Error))if(E instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=E.stack,this.log(w.Error,m(O))}else this.log(w.Error,m([E,...k]))}flush(){}}e.AbstractMessageLogger=c;class P extends h{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!C.isWindows}trace(E,...k){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,E,...k):console.log(`[main ${f()}]`,E,...k))}debug(E,...k){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,E,...k):console.log(`[main ${f()}]`,E,...k))}info(E,...k){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,E,...k):console.log(`[main ${f()}]`,E,...k))}warn(E,...k){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,E,...k):console.warn(`[main ${f()}]`,E,...k))}error(E,...k){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,E,...k):console.error(`[main ${f()}]`,E,...k))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class u extends h{constructor(E=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(E)}trace(E,...k){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...k):console.log(E,...k))}debug(E,...k){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...k):console.log(E,...k))}info(E,...k){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...k):console.log(E,...k))}warn(E,...k){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...k):console.log(E,...k))}error(E,...k){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...k):console.error(E,...k))}dispose(){}flush(){}}e.ConsoleLogger=u;class t extends h{constructor(E,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(k)}trace(E,...k){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(E),...k])}debug(E,...k){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(E),...k])}info(E,...k){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(E),...k])}warn(E,...k){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(E),...k])}error(E,...k){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(E),...k])}extractMessage(E){return typeof E=="string"?E:(0,I.toErrorMessage)(E,this.checkLogLevel(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class l extends h{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const k of this.loggers)k.setLevel(E);super.setLevel(E)}trace(E,...k){for(const O of this.loggers)O.trace(E,...k)}debug(E,...k){for(const O of this.loggers)O.debug(E,...k)}info(E,...k){for(const O of this.loggers)O.info(E,...k)}warn(E,...k){for(const O of this.loggers)O.warn(E,...k)}error(E,...k){for(const O of this.loggers)O.error(E,...k)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose()}}e.MultiplexLogger=l;class s extends _.Disposable{constructor(E,k,O){if(super(),this.logLevel=E,this.logsHome=k,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const F of O)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(E){return(0,a.isString)(E)?[...this._loggers.values()].find(k=>k.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,k){const O=this.toResource(E),F=(0,a.isString)(E)?E:k?.id??(0,r.hash)(O.toString()).toString(16);let q=this._loggers.get(O)?.logger;const ne=k?.logLevel==="always"?w.Trace:k?.logLevel;q||(q=this.doCreateLogger(O,ne??this.getLogLevel(O)??this.logLevel,{...k,id:F}));const J={logger:q,info:{resource:O,id:F,logLevel:ne,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(J.info),this._loggers.set(O,J),q}toResource(E){return(0,a.isString)(E)?(0,d.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,k){if(p.URI.isUri(E)){const O=E,F=k,q=this._loggers.get(O);q&&F!==q.info.logLevel&&(q.info.logLevel=F===this.logLevel?void 0:F,q.logger?.setLevel(F),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([O,F]))}else{this.logLevel=E;for(const[O,F]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,k){const O=this.getLoggerEntry(E);O&&k!==!O.info.hidden&&(O.info.hidden=!k,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,k]))}getLogLevel(E){let k;return E&&(k=this._loggers.get(E)?.info.logLevel),k??this.logLevel}registerLogger(E){const k=this._loggers.get(E.resource);k?k.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const k=this._loggers.get(E);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(E){}getLevel(){return w.Info}trace(E,...k){}debug(E,...k){}info(E,...k){}warn(E,...k){}error(E,...k){}critical(E,...k){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function o(R){if(R.verbose)return w.Trace;if(typeof R.logLevel=="string"){const E=D(R.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function b(R){switch(R){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=b;function D(R){switch(R){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new v.RawContextKey("logLevel",b(w.Info))});var Z=this&&this.__param||function(K,e){return function(I,L){e(I,L,K)}};define(ee[218],te([0,1,15,4,5]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const _=I.safeStorage;let M=class{constructor(d){this.logService=d,I.app.commandLine.getSwitchValue("password-store")==="basic"&&_.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(_.encryptString(d));return this.logService.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.logService.error(a),a}}async decrypt(d){let a;try{if(a=JSON.parse(d),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const p=Buffer.from(a.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const v=_.decryptString(p);return this.logService.trace("[EncryptionMainService] Decrypted value."),v}catch(p){throw this.logService.error(p),p}}isEncryptionAvailable(){return Promise.resolve(_.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(_.getSelectedStorageBackend)try{const d=_.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.logService.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!_.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");_.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=M,e.EncryptionMainService=M=Pe([Z(0,r.ILogService)],M)}),define(ee[219],te([0,1,23,8,14,3,2,9,74,5]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends M.Disposable{constructor(S,f){super(),this.logService=S,this.options=f,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,f):this.watchNonRecursive(S,f)}watchUniversal(S,f){const y={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,I.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,d.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,f){const y={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,I.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,d.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,C.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(ee[220],te([0,1,23,8,17,22,3,55,67,2,56,13,64,19,61,173,16,117,5,14]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class extends a.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(t,l){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const s=new a.DisposableStore;return this.provider.set(t,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:l}),s.add(l.onDidChangeFile(i=>this._onDidFilesChange.fire(new g.FileChangesEvent(i,!this.isPathCaseSensitive(l))))),typeof l.onDidWatchError=="function"&&s.add(l.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:t}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:l}),this.provider.delete(t),(0,a.dispose)(s)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(s){l.push(s)}}),!this.provider.has(t)&&await L.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,l){const s=this.provider.get(t.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return d.Iterable.map(this.provider,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async withProvider(t){if(!(0,f.isAbsolutePath)(t))throw new g.FileOperationError((0,w.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const l=this.provider.get(t.scheme);if(!l){const s=new c.ErrorNoTelemetry;throw s.message=(0,w.localize)(1,null,t.toString()),s}return l}async withReadProvider(t){const l=await this.withProvider(t);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)||(0,g.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const l=await this.withProvider(t);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.doResolveFile(t,l)}catch(s){throw(0,g.toFileSystemProviderErrorCode)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,w.localize)(2,null,this.resourceForError(t)),1):(0,g.ensureFileSystemProviderError)(s)}}async doResolveFile(t,l){const s=await this.withProvider(t),i=this.isPathCaseSensitive(s),n=l?.resolveTo,o=l?.resolveSingleChildDescendants,b=l?.resolveMetadata,D=await s.stat(t);let R;return this.toFileStat(s,t,D,void 0,!!b,(E,k)=>(R||(R=p.TernarySearchTree.forUris(()=>!i),R.set(t,!0),n&&R.fill(!0,n)),R.get(E.resource)||R.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?k===1:!1))}async toFileStat(t,l,s,i,n,o){const{providerExtUri:b}=this.getExtUri(t),D={resource:l,name:b.basename(l),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&o(D,i)){try{const R=await t.readdir(l),E=await L.Promises.settled(R.map(async([k,O])=>{try{const F=b.joinPath(l,k),q=n?await t.stat(F):{type:O};return await this.toFileStat(t,F,q,R.length,n,o)}catch(F){return this.logService.trace(F),null}}));D.children=(0,I.coalesce)(E)}catch(R){this.logService.trace(R),D.children=[]}return D}return D}async resolveAll(t){return L.Promises.settled(t.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.withProvider(t),s=await l.stat(t);return this.toFileStat(l,t,s,void 0,!0,()=>!1)}async exists(t){const l=await this.withProvider(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.doValidateCreateFile(t,l)}catch(s){return s}return!0}async doValidateCreateFile(t,l){if(!l?.overwrite&&await this.exists(t))throw new g.FileOperationError((0,w.localize)(3,null,this.resourceForError(t)),3,l)}async createFile(t,l=r.VSBuffer.fromString(""),s){await this.doValidateCreateFile(t,s);const i=await this.writeFile(t,l);return this._onDidRunOperation.fire(new g.FileOperationEvent(t,0,i)),i}async writeFile(t,l,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:n}=this.getExtUri(i);let o=s;if((0,g.hasFileAtomicWriteCapability)(i)&&!o?.atomic){const b=i.enforceAtomicWriteFile?.(t);b&&(o={...s,atomic:b})}try{await this.validateWriteFile(i,t,o)||await this.mkdirp(i,n.dirname(t));let D;if((0,g.hasReadWriteCapability)(i)&&!(l instanceof r.VSBuffer))if((0,y.isReadableStream)(l)){const R=await(0,y.peekStream)(l,3);R.ended?D=r.VSBuffer.concat(R.buffer):D=R}else D=(0,y.peekReadable)(l,R=>r.VSBuffer.concat(R),3);else D=l;!(0,g.hasOpenReadWriteCloseCapability)(i)||(0,g.hasReadWriteCapability)(i)&&D instanceof r.VSBuffer||(0,g.hasReadWriteCapability)(i)&&(0,g.hasFileAtomicWriteCapability)(i)&&o?.atomic?await this.doWriteUnbuffered(i,t,o,D):await this.doWriteBuffered(i,t,o,D instanceof r.VSBuffer?(0,r.bufferToReadable)(D):D),this._onDidRunOperation.fire(new g.FileOperationEvent(t,4))}catch(b){throw new g.FileOperationError((0,w.localize)(4,null,this.resourceForError(t),(0,g.ensureFileSystemProviderError)(b).toString()),(0,g.toFileOperationResult)(b),o)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,l,s){const i=!!s?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(l)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.resourceForError(l)));if(!(t.capabilities&2))throw new Error((0,w.localize)(7,null,this.resourceForError(l)));if(i)throw new Error((0,w.localize)(8,null,this.resourceForError(l)))}let o;try{o=await t.stat(l)}catch{return}if(o.type&g.FileType.Directory)throw new g.FileOperationError((0,w.localize)(9,null,this.resourceForError(l)),0,s);if(this.throwIfFileIsReadonly(l,o),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&s.mtime<o.mtime&&s.etag!==(0,g.etag)({mtime:s.mtime,size:o.size}))throw new g.FileOperationError((0,w.localize)(10,null),3,s);return o}async readFile(t,l,s){const i=await this.withReadProvider(t);return l?.atomic?this.doReadFileAtomic(i,t,l,s):this.doReadFile(i,t,l,s)}async doReadFileAtomic(t,l,s,i){return new Promise((n,o)=>{this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{try{const b=await this.doReadFile(t,l,s,i);n(b)}catch(b){o(b)}})})}async doReadFile(t,l,s,i){const n=await this.doReadFileStream(t,l,{...s,preferUnbuffered:!0},i);return{...n,value:await(0,r.streamToBuffer)(n.value)}}async readFileStream(t,l,s){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,l,s)}async doReadFileStream(t,l,s,i){const n=new _.CancellationTokenSource(i);let o=s;(0,g.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(l)&&(o={...s,atomic:!0});const b=this.validateReadFile(l,o).then(R=>R,R=>{throw n.dispose(!0),R});let D;try{return typeof o?.etag=="string"&&o.etag!==g.ETAG_DISABLED&&await b,o?.atomic&&(0,g.hasFileAtomicReadCapability)(t)||!((0,g.hasOpenReadWriteCloseCapability)(t)||(0,g.hasFileReadStreamCapability)(t))||(0,g.hasReadWriteCapability)(t)&&o?.preferUnbuffered?D=this.readFileUnbuffered(t,l,o):(0,g.hasFileReadStreamCapability)(t)?D=this.readFileStreamed(t,l,n.token,o):D=this.readFileBuffered(t,l,n.token,o),D.on("end",()=>n.dispose()),D.on("error",()=>n.dispose()),{...await b,value:D}}catch(R){throw D&&await(0,y.consumeStream)(D),this.restoreReadError(R,l,o)}}restoreReadError(t,l,s){const i=(0,w.localize)(11,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(t).toString());return t instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(i,t.stat,s):t instanceof g.TooLargeFileOperationError?new g.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new g.FileOperationError(i,(0,g.toFileOperationResult)(t),s)}readFileStreamed(t,l,s,i=Object.create(null)){const n=t.readFileStream(l,i,s);return(0,y.transform)(n,{data:o=>o instanceof r.VSBuffer?o:r.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,l,i)},o=>r.VSBuffer.concat(o))}readFileBuffered(t,l,s,i=Object.create(null)){const n=(0,r.newWriteableBufferStream)();return(0,m.readFileIntoStream)(t,l,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,l,i)},s),n}readFileUnbuffered(t,l,s){const i=(0,y.newWriteableStream)(n=>r.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,g.hasFileAtomicReadCapability)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(l,n.byteLength,s),i.end(r.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(t,l){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new g.FileOperationError((0,w.localize)(12,null,this.resourceForError(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==g.ETAG_DISABLED&&l.etag===s.etag)throw new g.NotModifiedSinceFileOperationError((0,w.localize)(13,null),s,l);return this.validateReadFileLimits(t,s.size,l),s}validateReadFileLimits(t,l,s){if(typeof s?.limits?.size=="number"&&l>s.limits.size)throw new g.TooLargeFileOperationError((0,w.localize)(14,null,this.resourceForError(t)),7,l,s)}async canMove(t,l,s){return this.doCanMoveCopy(t,l,"move",s)}async canCopy(t,l,s){return this.doCanMoveCopy(t,l,"copy",s)}async doCanMoveCopy(t,l,s,i){if(t.toString()!==l.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,t,o,l,s,i)}catch(n){return n}return!0}async move(t,l,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(i,t,n,l,"move",!!s),b=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(t,o==="move"?2:3,b)),b}async copy(t,l,s){const i=await this.withReadProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(i,t,n,l,"copy",!!s),b=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(t,o==="copy"?3:2,b)),b}async doMoveCopy(t,l,s,i,n,o){if(l.toString()===i.toString())return n;const{exists:b,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,l,s,i,n,o);if(b&&!D&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),n==="copy"){if(t===s&&(0,g.hasFileFolderCopyCapability)(t))await t.copy(l,i,{overwrite:o});else{const R=await this.resolve(l);R.isDirectory?await this.doCopyFolder(t,R,s,i):await this.doCopyFile(t,l,s,i)}return n}else return t===s?(await t.rename(l,i,{overwrite:o}),n):(await this.doMoveCopy(t,l,s,i,"copy",o),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(t,l,s,i){if((0,g.hasOpenReadWriteCloseCapability)(t)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(t,l,s,i);if((0,g.hasOpenReadWriteCloseCapability)(t)&&(0,g.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(t,l,s,i);if((0,g.hasReadWriteCapability)(t)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(t,l,s,i);if((0,g.hasReadWriteCapability)(t)&&(0,g.hasReadWriteCapability)(s))return this.doPipeUnbuffered(t,l,s,i)}async doCopyFolder(t,l,s,i){await s.mkdir(i),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async n=>{const o=this.getExtUri(s).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(t,await this.resolve(n.resource),s,o):this.doCopyFile(t,n.resource,s,o)}))}async doValidateMoveCopy(t,l,s,i,n,o){let b=!1;if(t===s){const{providerExtUri:R,isPathCaseSensitive:E}=this.getExtUri(t);if(E||(b=R.isEqual(l,i)),b&&n==="copy")throw new Error((0,w.localize)(15,null,this.resourceForError(l),this.resourceForError(i)));if(!b&&R.isEqualOrParent(i,l))throw new Error((0,w.localize)(16,null,this.resourceForError(l),this.resourceForError(i)))}const D=await this.exists(i);if(D&&!b){if(!o)throw new g.FileOperationError((0,w.localize)(17,null,this.resourceForError(l),this.resourceForError(i)),4);if(t===s){const{providerExtUri:R}=this.getExtUri(t);if(R.isEqualOrParent(l,i))throw new Error((0,w.localize)(18,null,this.resourceForError(l),this.resourceForError(i)))}}return{exists:D,isSameResourceWithDifferentPathCase:b}}getExtUri(t){const l=this.isPathCaseSensitive(t);return{providerExtUri:l?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(l,t);const s=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(t,0,s)),s}async mkdirp(t,l){const s=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&g.FileType.Directory))throw new Error((0,w.localize)(19,null,this.resourceForError(l)));break}catch(n){if((0,g.toFileSystemProviderErrorCode)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(i.basename(l)),l=i.dirname(l)}for(let n=s.length-1;n>=0;n--){l=i.joinPath(l,s[n]);try{await t.mkdir(l)}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,l){try{await this.doValidateDelete(t,l)}catch(s){return s}return!0}async doValidateDelete(t,l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),i=!!l?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,w.localize)(20,null,this.resourceForError(t)));const n=l?.atomic;if(n&&!(s.capabilities&65536))throw new Error((0,w.localize)(21,null,this.resourceForError(t)));if(i&&n)throw new Error((0,w.localize)(22,null,this.resourceForError(t)));let o;try{o=await s.stat(t)}catch{}if(o)this.throwIfFileIsReadonly(t,o);else throw new g.FileOperationError((0,w.localize)(23,null,this.resourceForError(t)),1);if(!!!l?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,w.localize)(24,null,this.resourceForError(t)))}return s}async del(t,l){const s=await this.doValidateDelete(t,l);let i=l;if((0,g.hasFileAtomicDeleteCapability)(s)&&!i?.atomic){const D=s.enforceAtomicDelete?.(t);D&&(i={...l,atomic:D})}const n=!!i?.useTrash,o=!!i?.recursive,b=i?.atomic??!1;await s.delete(t,{recursive:o,useTrash:n,atomic:b}),this._onDidRunOperation.fire(new g.FileOperationEvent(t,1))}async cloneFile(t,l){const s=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(t,l))return;if(s===i&&(0,g.hasFileCloneCapability)(s))return s.cloneFile(t,l);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(l));const n=this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri);return s===i&&(0,g.hasFileFolderCopyCapability)(s)?n.queue(()=>s.copy(t,l,{overwrite:!0})):n.queue(()=>this.doCopyFile(s,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const s=new a.DisposableStore;let i=!1,n=()=>{i=!0};return s.add((0,a.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(t,l);i?(0,a.dispose)(o):n=()=>(0,a.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(t,l){const s=await this.withProvider(t),i=(0,C.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(t),l]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:s.watch(t,l)},this.activeWatchers.set(i,n)),n.count+=1,(0,a.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,a.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,a.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,l,s,i){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,n,i):await this.doWriteReadableBufferedQueued(t,n,i)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await t.close(n)}})}async doWriteStreamBufferedQueued(t,l,s){let i=0,n;if((0,y.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=r.VSBuffer.concat(s.buffer);await this.doWriteBuffer(t,l,o,o.byteLength,i,0),i+=o.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((o,b)=>{(0,y.listenStream)(n,{onData:async D=>{n.pause();try{await this.doWriteBuffer(t,l,D,D.byteLength,i,0)}catch(R){return b(R)}i+=D.byteLength,setTimeout(()=>n.resume())},onError:D=>b(D),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(t,l,s){let i=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(t,l,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(t,l,s,i,n,o){let b=0;for(;b<i;){const D=await t.write(l,n+b,s.buffer,o+b,i-b);b+=D}}async doWriteUnbuffered(t,l,s,i){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,l,s,i))}async doWriteUnbufferedQueued(t,l,s,i){let n;i instanceof r.VSBuffer?n=i:(0,y.isReadableStream)(i)?n=await(0,r.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?n=await(0,r.bufferedStreamToBuffer)(i):n=(0,r.readableToBuffer)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(t,l,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,l,s,i))}async doPipeBufferedQueued(t,l,s,i){let n,o;try{n=await t.open(l,{create:!1}),o=await s.open(i,{create:!0,unlock:!1});const b=r.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,R=0,E=0;do E=await t.read(n,D,b.buffer,R,b.byteLength-R),await this.doWriteBuffer(s,o,b,E,D,R),D+=E,R+=E,R===b.byteLength&&(R=0);while(E>0)}catch(b){throw(0,g.ensureFileSystemProviderError)(b)}finally{await L.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(t,l,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,l,s,i))}async doPipeUnbufferedQueued(t,l,s,i){return s.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,l,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,l,s,i))}async doPipeUnbufferedToBufferedQueued(t,l,s,i){const n=await s.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(l);await this.doWriteBuffer(s,n,r.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(t,l,s,i){const n=await(0,r.streamToBuffer)(this.readFileBuffered(t,l,_.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,n)}throwIfFileSystemIsReadonly(t,l){if(t.capabilities&2048)throw new g.FileOperationError((0,w.localize)(25,null,this.resourceForError(l)),6);return t}throwIfFileIsReadonly(t,l){if((l.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,w.localize)(26,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=P,e.FileService=P=Pe([Z(0,h.ILogService)],P)}),define(ee[93],te([0,1,45,308,8,31,17,3,33,2,9,4,19,61,21,177,16,117,219,49,215,214]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(l){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(l)}`)}})();class t extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new _.ResourceMap(n=>S.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,v.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await y.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let b;o.isSymbolicLink()?b=(await this.stat((0,S.joinPath)(s,o.name))).type:b=this.toType(o),n.push([o.name,b])}catch(b){this.logService.trace(b)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let n;return i?.dangling?n=g.FileType.Unknown:s.isFile()?n=g.FileType.File:s.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new r.Barrier;return this.resourceLocks.set(s,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(s,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const o=this.toFilePath(s);return await y.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{n?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,n){const o=(0,f.newWriteableStream)(b=>M.VSBuffer.concat(b.map(D=>M.VSBuffer.wrap(D))).buffer);return(0,m.readFileIntoStream)(this,s,o,b=>b.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(s,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,S.joinPath)((0,S.dirname)(s),`${(0,S.basename)(s)}${n.atomic.postfix}`),i,n):this.doWriteFile(s,i,n)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:n}=await y.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,i,n,o){const b=new a.DisposableStore;try{b.add(await this.createResourceLock(s)),b.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,o,!0);try{await this.rename(i,s,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{b.dispose()}}async doWriteFile(s,i,n,o){let b;try{const D=this.toFilePath(s);if(!n.create||!n.overwrite){if(await y.Promises.exists(D)){if(!n.overwrite)throw(0,g.createFileSystemProviderError)((0,w.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.createFileSystemProviderError)((0,w.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(s,{create:!0,unlock:n.unlock},o),await this.write(b,0,i,0,i.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof b=="number"&&await this.close(b)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,n){const o=this.toFilePath(s);let b;(0,g.isFileOpenForWriteOptions)(i)&&!n&&(b=await this.createResourceLock(s));let D;try{if((0,g.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:E}=await y.SymlinkSupport.stat(o);E.mode&128||await y.Promises.chmod(o,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}let R;if((0,g.isFileOpenForWriteOptions)(i)){if(v.isWindows)try{await y.Promises.truncate(o,0),R="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}R||(R="w")}else R="r";D=await y.Promises.open(o,R)}catch(R){throw b?.dispose(),(0,g.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,R):this.toFileSystemProviderError(R)}if(this.mapHandleToPos.set(D,0),(0,g.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(D,s),b){const R=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${o})`),this.mapHandleToLock.set(D,b),R&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${o})`),R.dispose())}return D}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await y.Promises.fdatasync(s)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await y.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,n,o,b){const D=this.normalizePos(s,i);let R=null;try{R=(await y.Promises.read(s,n,o,b,D)).bytesRead}catch(E){throw this.toFileSystemProviderError(E)}finally{this.updatePos(s,D,R)}return R}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,n){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,o+n):this.mapHandleToPos.delete(s)))}async write(s,i,n,o,b){return(0,r.retry)(()=>this.doWrite(s,i,n,o,b),100,3)}async doWrite(s,i,n,o,b){const D=this.normalizePos(s,i);let R=null;try{R=(await y.Promises.write(s,n,o,b,D)).bytesWritten}catch(E){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),E)}finally{this.updatePos(s,D,R)}return R}async mkdir(s){try{await y.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const n=this.toFilePath(s);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,p.join)((0,p.dirname)(n),`${(0,p.basename)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let b=!1;try{const{stat:D,symbolicLink:R}=await y.SymlinkSupport.stat(n);b=D.isDirectory()&&!R}catch{}if(b)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,i,n){const o=this.toFilePath(s),b=this.toFilePath(i);if(o!==b)try{await this.validateMoveCopy(s,i,"move",n.overwrite),await y.Promises.rename(o,b)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,p.basename)(o),(0,p.basename)((0,p.dirname)(b)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(s,i,n){const o=this.toFilePath(s),b=this.toFilePath(i);if(o!==b)try{await this.validateMoveCopy(s,i,"copy",n.overwrite),await y.Promises.copy(o,b,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,p.basename)(o),(0,p.basename)((0,p.dirname)(b)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(s,i,n,o){const b=this.toFilePath(s),D=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,d.isEqual)(b,D,!0)),R){if(n==="copy")throw(0,g.createFileSystemProviderError)((0,w.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const k=await this.statIgnoreError(s);if(!k)throw(0,g.createFileSystemProviderError)((0,w.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(i);if(O){if(!o)throw(0,g.createFileSystemProviderError)((0,w.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&O.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,n){const o=this.toFilePath(s),b=this.toFilePath(i),D=!!(this.capabilities&1024);if((0,d.isEqual)(o,b,!D))return;const R=new a.DisposableStore;try{R.add(await this.createResourceLock(s)),R.add(await this.createResourceLock(i)),n&&await y.Promises.mkdir((0,p.dirname)(b),{recursive:!0}),await y.Promises.copyFile(o,b)}catch(E){if(E.code==="ENOENT"&&!n)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(E)}finally{R.dispose()}}createUniversalWatcher(s,i,n){return new P.UniversalWatcherClient(o=>s(o),o=>i(o),n)}createNonRecursiveWatcher(s,i,n){return new u.NodeJSWatcherClient(o=>s(o),o=>i(o),n)}toFileSystemProviderError(s){if(s instanceof g.FileSystemProviderError)return s;let i=s,n;switch(s.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(s,i){let n=this.toFileSystemProviderError(i);if(s&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(n=(0,g.createFileSystemProviderError)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=t}),define(ee[221],te([0,1,3,93,2,17,61,22]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends r.Disposable{constructor(v,S){super(),this.provider=v,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(v,S,f){const y=this.getUriTransformer(v);switch(S){case"stat":return this.stat(y,f[0]);case"readdir":return this.readdir(y,f[0]);case"open":return this.open(y,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(y,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(y,f[0],f[1],f[2]);case"rename":return this.rename(y,f[0],f[1],f[2]);case"copy":return this.copy(y,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(y,f[0],f[1]);case"mkdir":return this.mkdir(y,f[0]);case"delete":return this.delete(y,f[0],f[1]);case"watch":return this.watch(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${S} not found`)}listen(v,S,f){const y=this.getUriTransformer(v);switch(S){case"fileChange":return this.onFileChange(y,f[0]);case"readFileStream":return this.onReadFileStream(y,f[0],f[1])}throw new Error(`Unknown event ${S}`)}stat(v,S){const f=this.transformIncoming(v,S,!0);return this.provider.stat(f)}readdir(v,S){const f=this.transformIncoming(v,S);return this.provider.readdir(f)}async readFile(v,S,f){const y=this.transformIncoming(v,S,!0),w=await this.provider.readFile(y,f);return _.VSBuffer.wrap(w)}onReadFileStream(v,S,f){const y=this.transformIncoming(v,S,!0),w=new C.CancellationTokenSource,g=new I.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),m=this.provider.readFileStream(y,f,w.token);return(0,M.listenStream)(m,{onData:h=>g.fire(_.VSBuffer.wrap(h)),onError:h=>g.fire(h),onEnd:()=>{g.fire("end"),g.dispose(),w.dispose()}}),g.event}writeFile(v,S,f,y){const w=this.transformIncoming(v,S);return this.provider.writeFile(w,f.buffer,y)}open(v,S,f){const y=this.transformIncoming(v,S,!0);return this.provider.open(y,f)}close(v){return this.provider.close(v)}async read(v,S,f){const y=_.VSBuffer.alloc(f),w=0,g=await this.provider.read(v,S,y.buffer,w,f);return[y,g]}write(v,S,f,y,w){return this.provider.write(v,S,f.buffer,y,w)}mkdir(v,S){const f=this.transformIncoming(v,S);return this.provider.mkdir(f)}delete(v,S,f){const y=this.transformIncoming(v,S);return this.provider.delete(y,f)}rename(v,S,f,y){const w=this.transformIncoming(v,S),g=this.transformIncoming(v,f);return this.provider.rename(w,g,y)}copy(v,S,f,y){const w=this.transformIncoming(v,S),g=this.transformIncoming(v,f);return this.provider.copy(w,g,y)}cloneFile(v,S,f){const y=this.transformIncoming(v,S),w=this.transformIncoming(v,f);return this.provider.cloneFile(y,w)}onFileChange(v,S){const f=new I.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(v,f))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return f.event}async watch(v,S,f,y,w){const g=this.sessionToWatcher.get(S);if(g){const m=this.transformIncoming(v,y),h=g.watch(f,m,w);this.watchRequests.set(S+f,h)}}async unwatch(v,S){const f=v+S,y=this.watchRequests.get(f);y&&((0,r.dispose)(y),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,v]of this.watchRequests)v.dispose();this.watchRequests.clear();for(const[,v]of this.sessionToWatcher)v.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class a extends r.Disposable{constructor(v,S,f,y){super(),this.uriTransformer=v,this.logService=f,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(v){const S=this._register(new I.Emitter);this._register(S.event(f=>{v.fire(f.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>S.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>v.fire(f)))}getRecursiveWatcherOptions(v){}getExtraExcludes(v){}watch(v,S,f){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.watcherRequests.set(v,this.fileWatcher.watch(S,f)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(v)),this.watcherRequests.delete(v)})}dispose(){for(const[,v]of this.watcherRequests)v.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=a}),define(ee[222],te([0,1,15,176,4,7,16,9,221,154]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends d.AbstractDiskFileSystemProviderChannel{constructor(f,y,w){super(f,y),this.environmentService=w}getUriTransformer(f){return a.DefaultURITransformer}transformIncoming(f,y){return _.URI.revive(y)}async delete(f,y,w){if(!w.useTrash)return super.delete(f,y,w);const g=this.transformIncoming(f,y),m=(0,C.normalize)(g.fsPath);try{await I.shell.trashItem(m)}catch{throw(0,M.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,C.basename)(m)):(0,L.localize)(1,null,(0,C.basename)(m)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,y){return new v(f,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=p;class v extends d.AbstractSessionFileWatcher{watch(f,y,w){if(w.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(ee[223],te([0,1,5]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends I.AbstractMessageLogger{constructor(_=I.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(_),this._register(this.onDidChangeLogLevel(M=>{this._logger?.setLevel(M)}))}set logger(_){this._logger=_;for(const{level:M,message:C}of this.buffer)(0,I.log)(_,M,C);this.buffer=[]}log(_,M){this._logger?(0,I.log)(this._logger,_,M):this.getLevel()<=_&&this.buffer.push({level:_,message:M})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(ee[224],te([0,1,7,3,5,2]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends r.AbstractLoggerService{constructor(v,S,f,y,w){super(S,f,y),this.windowId=v,this.channel=w,this._register(w.listen("onDidChangeLogLevel",v)(g=>{(0,r.isLogLevel)(g)?super.setLogLevel(g):super.setLogLevel(I.URI.revive(g[0]),g[1])})),this._register(w.listen("onDidChangeVisibility",v)(([g,m])=>super.setVisibility(I.URI.revive(g),m))),this._register(w.listen("onDidChangeLoggers",v)(({added:g,removed:m})=>{for(const h of g)super.registerLogger({...h,resource:I.URI.revive(h.resource)});for(const h of m)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(v,S)=>{this.channel.call("consoleLog",[v,S])}})}registerLogger(v){super.registerLogger(v),this.channel.call("registerLogger",[v,this.windowId])}deregisterLogger(v){super.deregisterLogger(v),this.channel.call("deregisterLogger",[v,this.windowId])}setLogLevel(v,S){super.setLogLevel(v,S),this.channel.call("setLogLevel",[v,S])}setVisibility(v,S){super.setVisibility(v,S),this.channel.call("setVisibility",[this.toResource(v),S])}doCreateLogger(v,S,f){return new C(this.channel,v,S,f,this.windowId)}static setLogLevel(v,S,f){return v.call("setLogLevel",[S,f])}}e.LoggerChannelClient=M;class C extends r.AbstractMessageLogger{constructor(v,S,f,y,w){super(y?.logLevel==="always"),this.channel=v,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[S,y,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,S){const f=[[v,S]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(v){this.channel.call("log",[this.file,v])}}class d{constructor(v,S){this.loggerService=v,this.getUriTransformer=S}listen(v,S){const f=this.getUriTransformer(v);switch(S){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.transformLogger(w,f)),removed:[...y.removed].map(w=>this.transformLogger(w,f))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,y=>(0,r.isLogLevel)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${S}`)}async call(v,S,f){const y=this.getUriTransformer(v);switch(S){case"setLogLevel":return(0,r.isLogLevel)(f[0])?this.loggerService.setLogLevel(f[0]):this.loggerService.setLogLevel(I.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(w=>this.transformLogger(w,y)))}throw new Error(`Call not found: ${S}`)}transformLogger(v,S){return{...v,resource:S.transformOutgoingURI(v.resource)}}}e.LoggerChannel=d;class a extends _.Disposable{constructor(v,S){super(),S.call("setLogLevel",[v.getLogLevel()]),this._register(v.onDidChangeLogLevel(f=>S.call("setLogLevel",[f]))),S.call("getRegisteredLoggers").then(f=>{for(const y of f)v.registerLogger({...y,resource:I.URI.revive(y.resource)})}),this._register(S.listen("onDidChangeVisibility")(([f,y])=>v.setVisibility(I.URI.revive(f),y))),this._register(S.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const w of f)v.registerLogger({...w,resource:I.URI.revive(w.resource)});for(const w of y)v.deregisterLogger(w.resource)}))}}e.RemoteLoggerChannelClient=a}),define(ee[225],te([0,1,2,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends I.Disposable{constructor(M,C=[]){super(),this.logger=new L.MultiplexLogger([M,...C]),this._register(M.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...C){this.logger.trace(M,...C)}debug(M,...C){this.logger.debug(M,...C)}info(M,...C){this.logger.info(M,...C)}warn(M,...C){this.logger.warn(M,...C)}error(M,...C){this.logger.error(M,...C)}flush(){this.logger.flush()}}e.LogService=r}),define(ee[226],te([0,1,31,7,5]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class _{constructor(C){this.loggerService=C,this.loggers=new I.ResourceMap}listen(C,d,a){switch(d){case"onDidChangeLoggers":return a?this.loggerService.getOnDidChangeLoggersEvent(a):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.loggerService.getOnDidChangeLogLevelEvent(a):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.loggerService.getOnDidChangeVisibilityEvent(a):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(C,d,a){switch(d){case"createLogger":this.createLogger(L.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.log(L.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1]);case"setLogLevel":return(0,r.isLogLevel)(a[0])?this.loggerService.setLogLevel(a[0]):this.loggerService.setLogLevel(L.URI.revive(a[0]),a[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(a[0]),a[1]);case"registerLogger":return this.loggerService.registerLogger({...a[0],resource:L.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(a[0]))}throw new Error(`Call not found: ${d}`)}createLogger(C,d,a){this.loggers.set(C,this.loggerService.createLogger(C,d,a))}consoleLog(C,d){let a=console.log;switch(C){case r.LogLevel.Error:a=console.error;break;case r.LogLevel.Warning:a=console.warn;break;case r.LogLevel.Info:a=console.info;break}a.call(console,...d)}log(C,d){const a=this.loggers.get(C);if(!a)throw new Error("Create the logger before logging");for(const[p,v]of d)(0,r.log)(a,p,v)}}e.LoggerChannel=_}),define(ee[227],te([0,1,16,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(r||(r={}));async function _(a,p,v,S,f){try{const y=await new Promise((g,m)=>{K(["@vscode/spdlog"],g,m)});y.setFlushOn(r.Trace);const w=await y.createAsyncRotatingLogger(a,p,v,S);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function M(a,p,v){switch(p){case L.LogLevel.Trace:a.trace(v);break;case L.LogLevel.Debug:a.debug(v);break;case L.LogLevel.Info:a.info(v);break;case L.LogLevel.Warning:a.warn(v);break;case L.LogLevel.Error:a.error(v);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function C(a,p){switch(p){case L.LogLevel.Trace:a.setLevel(r.Trace);break;case L.LogLevel.Debug:a.setLevel(r.Debug);break;case L.LogLevel.Info:a.setLevel(r.Info);break;case L.LogLevel.Warning:a.setLevel(r.Warning);break;case L.LogLevel.Error:a.setLevel(r.Error);break;case L.LogLevel.Off:a.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class d extends L.AbstractMessageLogger{constructor(p,v,S,f,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(p,v,S,f),this._register(this.onDidChangeLogLevel(w=>{this._logger&&C(this._logger,w)}))}async _createSpdLogLogger(p,v,S,f){const y=S?6:1,w=30/y*I.ByteSize.MB,g=await _(p,v,w,y,f);if(g){this._logger=g,C(this._logger,this.getLevel());for(const{level:m,message:h}of this.buffer)M(this._logger,m,h);this.buffer=[]}}log(p,v){this._logger?M(this._logger,p,v):this.getLevel()<=p&&this.buffer.push({level:p,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=d}),define(ee[228],te([0,1,32,5,227]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class _ extends L.AbstractLoggerService{doCreateLogger(C,d,a){return new r.SpdLogLogger((0,I.generateUuid)(),C.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,d)}}e.LoggerService=_}),define(ee[65],te([0,1,31,3,6,5,228]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(_.ILoggerService);class C extends M.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new I.ResourceMap}createLogger(a,p,v){v!==void 0&&this.loggerResourcesByWindow.set(this.toResource(a),v);try{return super.createLogger(a,p)}catch(S){throw this.loggerResourcesByWindow.delete(this.toResource(a)),S}}registerLogger(a,p){p!==void 0&&this.loggerResourcesByWindow.set(a.resource,p),super.registerLogger(a)}deregisterLogger(a){this.loggerResourcesByWindow.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const p=[];for(const v of super.getRegisteredLoggers())a===this.loggerResourcesByWindow.get(v.resource)&&p.push(v);return p}getOnDidChangeLogLevelEvent(a){return L.Event.filter(this.onDidChangeLogLevel,p=>(0,_.isLogLevel)(p)||this.isInterestedLoggerResource(p[0],a))}getOnDidChangeVisibilityEvent(a){return L.Event.filter(this.onDidChangeVisibility,([p])=>this.isInterestedLoggerResource(p,a))}getOnDidChangeLoggersEvent(a){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(S=>this.isInterestedLoggerResource(S.resource,a)),removed:[...p.removed].filter(S=>this.isInterestedLoggerResource(S.resource,a))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(a){for(const[p,v]of this.loggerResourcesByWindow)v===a&&this.deregisterLogger(p)}isInterestedLoggerResource(a,p){const v=this.loggerResourcesByWindow.get(a);return v===void 0||v===p}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=C}),define(ee[229],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function L(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function _(M){return!I(M)&&!L(M)&&!r(M)}e.isMenubarMenuItemAction=_}),define(ee[39],te([0,1,3,67,2,6]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,_.createDecorator)("policy");class M extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const p=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},p!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),L.Iterable.reduce(this.policies.entries(),(v,[S,f])=>({...v,[S]:f}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[p,v])=>({...a,[p]:{definition:v,value:this.policies.get(p)}}),{})}}e.AbstractPolicyService=M;class C{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(ee[230],te([0,1,8,3,67,12,16,5,39]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(v,S){const f=[];for(const y of new Set(r.Iterable.concat(v.keys(),S.keys())))v.get(y)!==S.get(y)&&f.push(y);return f}let p=class extends d.AbstractPolicyService{constructor(S,f,y){super(),this.file=S,this.fileService=f,this.logService=y,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const w=L.Event.filter(f.onDidFilesChange,g=>g.affects(S));this._register(f.watch(S)),this._register(w(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const f=await this.fileService.readFile(this.file),y=JSON.parse(f.value.toString());if(!(0,_.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.policyDefinitions[w]&&S.set(w,y[w])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return S}async refresh(){const S=await this.read(),f=a(this.policies,S);this.policies=S,f.length>0&&this._onDidChange.fire(f)}};e.FilePolicyService=p,e.FilePolicyService=p=Pe([Z(1,M.IFileService),Z(2,C.ILogService)],p)}),define(ee[231],te([0,1,3,2,39]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class _{constructor(d){this.service=d,this.disposables=new L.DisposableStore}listen(d,a){switch(a){case"onDidChange":return I.Event.map(this.service.onDidChange,p=>p.reduce((v,S)=>({...v,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${a}`)}call(d,a,p){switch(a){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${a}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=_;class M extends r.AbstractPolicyService{constructor(d,a){super(),this.channel=a;for(const p in d){const{definition:v,value:S}=d[p];this.policyDefinitions[p]=v,S!==void 0&&this.policies.set(p,S)}this.channel.listen("onDidChange")(p=>{for(const v in p){const S=p[v];S===null?this.policies.delete(v):this.policies.set(v,S)}this._onDidChange.fire(Object.keys(p))})}async _updatePolicyDefinitions(d){const a=await this.channel.call("updatePolicyDefinitions",d);for(const p in a)this.policies.set(p,a[p])}}e.PolicyChannelClient=M}),define(ee[232],te([0,1,39,8,309,2,5]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let C=class extends I.AbstractPolicyService{constructor(a,p){super(),this.logService=a,this.productName=p,this.throttler=new L.Throttler,this.watcher=this._register(new _.MutableDisposable)}async _updatePolicyDefinitions(a){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.throttler.queue(()=>new Promise((p,v)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,a,S=>{this._onDidPolicyChange(S),p()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),v(S)}}))}_onDidPolicyChange(a){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const p in a){const v=a[p];v===void 0?this.policies.delete(p):this.policies.set(p,v)}this._onDidChange.fire(Object.keys(a))}};e.NativePolicyService=C,e.NativePolicyService=C=Pe([Z(0,M.ILogService)],C)}),define(ee[75],te([0,1,4,35]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const _=I.globals.vscode.context.configuration();if(_)r=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){r=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:_,searchUrl:M,itemUrl:C,controlUrl:d}=r.extensionsGallery||{};Object.assign(r,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||_,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||C,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||d}});try{const a=(...v)=>v.reduce((S,f)=>(Object.keys(f).forEach(y=>{Array.isArray(S[y])&&Array.isArray(f[y])?S[y]=f[y]:typeof S[y]=="object"&&typeof f[y]=="object"?S[y]=a(S[y],f[y]):S[y]=f[y]}),S),{}),p=globalThis._VSCODE_USER_PRODUCT_JSON||{};r=a(r,p)}catch{}if(L.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const a=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:a.version,release:a.release})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ee[24],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[233],te([0,1,8,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(M,C,d){this._window=M,this._sessionId=C,this._logService=d}async inspect(M){await this._connect();const C=this._window.webContents.debugger;await C.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,I.timeout)(M);const d=await C.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),d.profile}async _connect(){const M=this._window.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async _disconnect(){const M=this._window.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};e.WindowProfiler=r,e.WindowProfiler=r=Pe([Z(2,L.ILogService)],r)}),define(ee[76],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[43],te([0,1,135,12]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(M,C){I.ok(L.isString(M)),I.ok(L.isObject(C)),I.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,C)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new r}),define(ee[234],te([0,1,3,43]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class _{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,a){this.schemasById[r(d)]=a,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new _;L.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[57],te([0,1,23,3,12,161,18,234,43]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=d.Registry.as(C.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const s=new Set;this.doRegisterConfigurations(t,l,s),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const l=new Set;this.doDeregisterConfigurations(t,l),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:t,remove:l}){const s=new Set;this.doDeregisterConfigurations(l,s),this.doRegisterConfigurations(t,!1,s),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const l=new Set;this.doRegisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,l){const s=[];for(const{overrides:i,source:n}of t)for(const o in i)if(l.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const b=this.configurationDefaultsOverrides.get(o),D=b?.valuesSources??new Map;if(n)for(const O of Object.keys(i[o]))D.set(O,n);const R={...b?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:R,valuesSources:D});const E=(0,M.getLanguageTagSettingPlainKey)(o),k={type:"object",default:R,description:_.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:r.isString(n)?void 0:n,defaultValueSource:n};s.push(...w(o)),this.configurationProperties[o]=k,this.defaultLanguageConfigurationOverridesNode.properties[o]=k}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:n});const b=this.configurationProperties[o];b&&(this.updatePropertyDefaultValue(o,b),this.updateSchema(o,b))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const l=new Set;this.doDeregisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,l){for(const{overrides:s,source:i}of t)for(const n in s){const o=this.configurationDefaultsOverrides.get(n),b=r.isString(i)?i:i?.id,D=r.isString(o?.source)?o?.source:o?.source?.id;if(b===D)if(l.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const R=this.configurationProperties[n];R&&(this.updatePropertyDefaultValue(n,R),this.updateSchema(n,R))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let l=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),l=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),l=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const l of t)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,l,s){t.forEach(i=>{this.validateAndRegisterProperties(i,l,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,l){const s=i=>{if(i.properties)for(const n in i.properties){l.add(n);const o=this.configurationProperties[n];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>s(n))};for(const i of t){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,l=!0,s,i,n=3,o){n=r.isUndefinedOrNull(t.scope)?n:t.scope;const b=t.properties;if(b)for(const R in b){const E=b[R];if(l&&c(R,E)){delete b[R];continue}if(E.source=s,E.defaultDefaultValue=b[R].default,this.updatePropertyDefaultValue(R,E),e.OVERRIDE_PROPERTY_REGEX.test(R)?E.scope=void 0:(E.scope=r.isUndefinedOrNull(E.scope)?n:E.scope,E.restricted=r.isUndefinedOrNull(E.restricted)?!!i?.includes(R):E.restricted),b[R].hasOwnProperty("included")&&!b[R].included){this.excludedConfigurationProperties[R]=b[R],delete b[R];continue}else this.configurationProperties[R]=b[R],b[R].policy?.name&&this.policyConfigurations.set(b[R].policy.name,R);!b[R].deprecationMessage&&b[R].markdownDeprecationMessage&&(b[R].deprecationMessage=b[R].markdownDeprecationMessage),o.add(R)}const D=t.allOf;if(D)for(const R of D)this.validateAndRegisterProperties(R,l,s,i,n,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const l=s=>{const i=s.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);s.allOf?.forEach(l)};l(t)}updateSchema(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.resourceLanguageSettingsSchema.properties[t]=l;break}}removeFromSchema(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const l=`[${t}]`,s={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,s),e.allSettings.properties[l]=s,e.applicationSettings.properties[l]=s,e.machineSettings.properties[l]=s,e.machineOverridableSettings.properties[l]=s,e.windowSettings.properties[l]=s,e.resourceSettings.properties[l]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,l){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,n=s?.source;r.isUndefined(i)&&(i=l.defaultDefaultValue,n=void 0),r.isUndefined(i)&&(i=m(l.type)),l.default=i,l.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(u){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let l=y.exec(u);for(;l?.length;){const s=l[1].trim();s&&t.push(s),l=y.exec(u)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=w;function g(u){return u.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=g;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const h=new S;d.Registry.add(e.Extensions.Configuration,h);function c(u,t){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?_.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?_.localize(8,null,u):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?_.localize(9,null,u,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:_.localize(6,null)}e.validateProperty=c;function P(){const u=[],t=h.getConfigurationProperties();for(const l of Object.keys(t))u.push([l,t[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=P}),define(ee[118],te([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(K,e,I,L,r,_,M,C,d,a,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(l){return Object.isFrozen(l)?l:C.deepFreeze(l)}class y{constructor(s={},i=[],n=[],o){this._contents=s,this._keys=i,this._overrides=n,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof y)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=s.reduce((i,n)=>n===i?n:i.merge(n),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,p.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const n=this.rawConfiguration.getValue(s),o=i?this.rawConfiguration.getOverrideValue(s,i):void 0,b=i?this.rawConfiguration.override(i).getValue(s):n;return{value:n,override:o,merged:b}}getOverrideValue(s,i){const n=this.getContentsForOverrideIdentifer(i);return n?s?(0,p.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return I.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=C.deepClone(this.contents),n=C.deepClone(this.overrides),o=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of s)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(i,D.contents);for(const R of D.overrides){const[E]=n.filter(k=>I.equals(k.identifiers,R.identifiers));E?(this.mergeContents(E.contents,R.contents),E.keys.push(...R.keys),E.keys=I.distinct(E.keys)):n.push(C.deepClone(R))}for(const R of D.keys)o.indexOf(R)===-1&&o.push(R)}return new y(i,o,n,b.every(D=>D instanceof y)?void 0:b)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[o];const D=i[o];D&&(typeof b=="object"&&typeof D=="object"?(b=C.deepClone(b),this.mergeContents(b,D)):b=D),n[o]=b}return new y(n,this.keys,this.overrides)}mergeContents(s,i){for(const n of Object.keys(i)){if(n in s&&d.isObject(s[n])&&d.isObject(i[n])){this.mergeContents(s[n],i[n]);continue}s[n]=C.deepClone(i[n])}}getContentsForOverrideIdentifer(s){let i=null,n=null;const o=b=>{b&&(n?this.mergeContents(n,b):n=C.deepClone(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===s?i=b.contents:b.identifiers.includes(s)&&o(b.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,p.removeFromValueTree)(this.contents,s),v.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>I.equals(n.identifiers,(0,v.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,n){(0,p.addToValueTree)(this.contents,s,i,o=>console.error(o)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),v.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,p.toValuesTree)(this.contents[s],o=>console.error(o))})}}e.ConfigurationModel=y;class w{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!d.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:n,keys:o,overrides:b,restricted:D,hasExcludedProperties:R}=this.doParseRaw(s,i);this._configurationModel=new y(n,o,b,R?[s]:void 0),this._restrictedConfigurations=D||[]}doParseContent(s){let i={},n=null,o=[];const b=[],D=[];function R(k){Array.isArray(o)?o.push(k):n!==null&&(o[n]=k)}const E={onObjectBegin:()=>{const k={};R(k),b.push(o),o=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{o=b.pop()},onArrayBegin:()=>{const k=[];R(k),b.push(o),o=k,n=null},onArrayEnd:()=>{o=b.pop()},onLiteralValue:R,onError:(k,O,F)=>{D.push({error:k,offset:O,length:F})}};if(s)try{r.visit(s,E),i=o[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(s,i){const n=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.filter(s,n,!0,i);s=o.raw;const b=(0,p.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),D=Object.keys(s),R=this.toOverrides(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:b,keys:D,overrides:R,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(s,i,n,o){let b=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:b};const D={},R=[];for(const E in s)if(v.OVERRIDE_PROPERTY_REGEX.test(E)&&n){const k=this.filter(s[E],i,!1,o);D[E]=k.raw,b=b||k.hasExcludedProperties,R.push(...k.restricted)}else{const k=i[E],O=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&R.push(E),!o.exclude?.includes(E)&&(o.include?.includes(E)||(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&!(o.skipRestricted&&k?.restricted))?D[E]=s[E]:b=!0}return{raw:D,restricted:R,hasExcludedProperties:b}}toOverrides(s,i){const n=[];for(const o of Object.keys(s))if(v.OVERRIDE_PROPERTY_REGEX.test(o)){const b={};for(const D in s[o])b[D]=s[o][D];n.push({identifiers:(0,v.overrideIdentifiersFromKey)(o),keys:Object.keys(b),contents:(0,p.toValuesTree)(b,i)})}return n}}e.ConfigurationModelParser=w;class g extends _.Disposable{constructor(s,i,n,o){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=o,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,b=>b.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&n.isEqual(b.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class m{constructor(s,i,n,o,b,D,R,E,k,O,F,q,ne){this.key=s,this.overrides=i,this._value=n,this.overrideIdentifiers=o,this.defaultConfiguration=b,this.policyConfiguration=D,this.applicationConfiguration=R,this.userConfiguration=E,this.localUserConfiguration=k,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=q,this.memoryConfigurationModel=ne}get value(){return f(this._value)}inspect(s,i,n){const o=s.inspect(i,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(s,i,n,o,b=new y,D=new y,R=new M.ResourceMap,E=new y,k=new M.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=b,this._workspaceConfiguration=D,this._folderConfigurations=R,this._memoryConfiguration=E,this._memoryConfigurationByResource=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,n){return this.getConsolidatedConfigurationModel(s,i,n).getValue(s)}updateValue(s,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new y,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(s):o.setValue(s,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,n){const o=this.getConsolidatedConfigurationModel(s,i,n),b=this.getFolderConfigurationModelForResource(i.resource,n),D=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const E of o.overrides)for(const k of E.identifiers)o.getOverrideValue(s,k)!==void 0&&R.add(k);return new m(s,i,o.getValue(s),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,b||void 0,D)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:o,updated:b,removed:D}=u(this._defaultConfiguration,s);i=[...o,...b,...D]}for(const o of i)for(const b of(0,v.overrideIdentifiersFromKey)(o)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(b),R=s.getKeysForOverrideIdentifier(b),E=[...R.filter(k=>D.indexOf(k)===-1),...D.filter(k=>R.indexOf(k)===-1),...D.filter(k=>!C.equals(this._defaultConfiguration.override(b).getValue(k),s.override(b).getValue(k)))];n.push([b,E])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:n,removed:o}=u(this._policyConfiguration,s),b=[...i,...n,...o];return b.length&&this.updatePolicyConfiguration(s),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.applicationConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.localUserConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.remoteUserConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:o,overrides:b}=u(this.workspaceConfiguration,s),D=[...i,...n,...o];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(s,i){const n=this.folderConfigurations.get(s),{added:o,updated:b,removed:D,overrides:R}=u(n,i),E=[...o,...b,...D];return(E.length||!n)&&this.updateFolderConfiguration(s,i),{keys:E,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:o,removed:b,overrides:D}=u(i,void 0);return{keys:[...n,...o,...b],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:s},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const o=i.getFolder(s);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const b=this._memoryConfigurationByResource.get(s);b&&(n=n.merge(b))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(s);o?(i=n.merge(o),this._foldersConsolidatedConfigurations.set(s,i)):i=n}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:n,overrides:o,keys:b}=this._folderConfigurations.get(i);return s.push([i,{contents:n,overrides:o,keys:b}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),o=this.parseConfigurationModel(s.application),b=this.parseConfigurationModel(s.user),D=this.parseConfigurationModel(s.workspace),R=s.folders.reduce((E,k)=>(E.set(a.URI.revive(k[0]),this.parseConfigurationModel(k[1])),E),new M.ResourceMap);return new h(i,n,o,b,new y,D,R,new y,new M.ResourceMap)}static parseConfigurationModel(s){return new y(s.contents,s.keys,s.overrides)}}e.Configuration=h;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,i=new Map;for(const o of l)o.keys.forEach(b=>s.add(b)),o.overrides.forEach(([b,D])=>{const R=(0,M.getOrSet)(i,b,new Set);D.forEach(E=>R.add(E))});const n=[];return i.forEach((o,b)=>n.push([b,[...o.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=c;class P{constructor(s,i,n,o){this.change=s,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const b of s.keys)this.affectedKeys.add(b);for(const[,b]of s.overrides)for(const D of b)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const b of this.affectedKeys)this._affectsConfigStr+=b+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const n=this._marker+s,o=this._affectsConfigStr.indexOf(n);if(o<0)return!1;const b=o+n.length;if(b>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(b);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(i){const R=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!C.equals(R,E)}return!0}}e.ConfigurationChangeEvent=P;function u(l,s){const{added:i,removed:n,updated:o}=t(s?.rawConfiguration,l?.rawConfiguration),b=[],D=l?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const E=R.filter(k=>!D.includes(k));for(const k of E)b.push([k,s.getKeysForOverrideIdentifier(k)])}if(l){const E=D.filter(k=>!R.includes(k));for(const k of E)b.push([k,l.getKeysForOverrideIdentifier(k)])}if(s&&l){for(const E of D)if(R.includes(E)){const k=t({contents:l.getOverrideValue(void 0,E)||{},keys:l.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});b.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:i,removed:n,updated:o,overrides:b}}function t(l,s){const i=l?s?l.keys.filter(b=>s.keys.indexOf(b)===-1):[...l.keys]:[],n=s?l?s.keys.filter(b=>l.keys.indexOf(b)===-1):[...s.keys]:[],o=[];if(l&&s){for(const b of s.keys)if(l.keys.indexOf(b)!==-1){const D=(0,p.getConfigurationValue)(s.contents,b),R=(0,p.getConfigurationValue)(l.contents,b);C.equals(D,R)||o.push(b)}}return{added:i,removed:n,updated:o}}}),define(ee[235],te([0,1,23,3,2,37,12,118,57,5,39,43]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(v.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:m})=>this.onDidUpdateConfiguration(Array.from(g),m))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(g,m){this.updateConfigurationModel(g,v.Registry.as(d.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new C.ConfigurationModel;const g=v.Registry.as(d.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(g),g)}updateConfigurationModel(g,m){const h=this.getConfigurationDefaultOverrides();for(const c of g){const P=h[c],u=m[c];P!==void 0?this._configurationModel.addValue(c,P):u?this._configurationModel.addValue(c,u.default):this._configurationModel.removeValue(c)}}}e.DefaultConfiguration=S;class f{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new C.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let y=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(g,m,h){super(),this.defaultConfiguration=g,this.policyService=m,this.logService=h,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.updatePolicyDefinitions(g),!0))),this._configurationModel}async updatePolicyDefinitions(g){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",g);const m={},h=[],c=v.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const P of g){const u=c[P];if(!u){h.push(P);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.logService.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(P),m[u.policy.name]={type:u.type}}}return(0,M.isEmptyObject)(m)||await this.policyService.updatePolicyDefinitions(m),h}onDidChangePolicies(g){this.logService.trace("PolicyConfiguration#onDidChangePolicies",g);const m=v.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),h=(0,I.coalesce)(g.map(c=>m.get(c)));this.update(h,!0)}update(g,m){this.logService.trace("PolicyConfiguration#update",g);const h=v.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),c=[],P=this._configurationModel.isEmpty();for(const u of g){const t=h[u]?.policy?.name;if(t){const l=this.policyService.getPolicyValue(t);(P?l!==void 0:!(0,_.equals)(this._configurationModel.getValue(u),l))&&c.push([u,l])}else this._configurationModel.getValue(u)!==void 0&&c.push([u,void 0])}if(c.length){this.logService.trace("PolicyConfiguration#changed",c);const u=this._configurationModel;this._configurationModel=new C.ConfigurationModel;for(const t of u.keys)this._configurationModel.setValue(t,u.getValue(t));for(const[t,l]of c)l===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,l);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=y,e.PolicyConfiguration=y=Pe([Z(1,p.IPolicyService),Z(2,a.ILogService)],y)}),define(ee[236],te([0,1,8,3,2,19,18,118,235,39]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends r.Disposable{constructor(S,f,y,w){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new d.DefaultConfiguration),this.policyConfiguration=y instanceof a.NullPolicyService?new d.NullPolicyConfiguration:this._register(new d.PolicyConfiguration(this.defaultConfiguration,y,w)),this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,{},_.extUriBiasedIgnorePathCase,f)),this.configuration=new C.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:g,properties:m})=>this.onDidDefaultConfigurationChange(g,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(g=>this.onDidPolicyConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,f,y]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new C.Configuration(S,f,new C.ConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(S,f){const y=typeof S=="string"?S:void 0,w=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(y,w,void 0)}updateValue(S,f,y,w){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const f=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(y,f,2)}onDidDefaultConfigurationChange(S,f){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(S,f);this.trigger(w,y,7)}onDidPolicyConfigurationChange(S){const f=this.configuration.toData(),y=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(y,f,7)}trigger(S,f,y){const w=new C.ConfigurationChangeEvent(S,{data:f},this.configuration);w.source=y,w.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(ee[237],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class I{async routeCall(r,_,M){if(_!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${_}`);const C=M[0];if(C?.authority){const d=r.connections.find(a=>a.ctx===C.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(r,_){throw new Error(`Event not found: ${_}`)}}e.NodeRemoteResourceRouter=I}),define(ee[238],te([0,1,14,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class _{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=_;class M{constructor(v,S){this.host=v,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=M;var C;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class d extends I.ErrorNoTelemetry{static isNotAvailable(v){return v instanceof d&&v._code===C.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof d&&v._code===C.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof d&&v._code===C.NoResolverFound}static isInvalidAuthority(v){return v instanceof d&&v._code===C.InvalidAuthority}static isHandled(v){return v instanceof d&&v.isHandled}constructor(v,S=C.Unknown,f){super(v),this._message=v,this._code=S,this._detail=f,this.isHandled=S===C.NotAvailable&&f===!0,Object.setPrototypeOf(this,d.prototype)}}e.RemoteAuthorityResolverError=d;function a(p){const v=p.indexOf("+");return v===-1?p:p.substring(0,v)}e.getRemoteAuthorityPrefix=a}),define(ee[58],te([0,1,13]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(a){return a.scheme===I.Schemas.vscodeRemote?a.authority:void 0}e.getRemoteAuthority=L;function r(a){if(!a)return;const p=a.indexOf("+");return p<0?a:a.substr(0,p)}e.getRemoteName=r;function _(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.getRemoteServerRootPath=_;function M(a){const{host:p,port:v}=d(a);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:v}}e.parseAuthorityWithPort=M;function C(a,p){let{host:v,port:S}=d(a);return typeof S>"u"&&(S=p),{host:v,port:S}}e.parseAuthorityWithOptionalPort=C;function d(a){const p=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const v=a.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const S=a.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:a,port:void 0}}}),define(ee[119],te([0,1,26,6,58]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(M||(e.ExtensionType=M={}));var C;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.LINUX_PPC64LE="linux-ppc64le",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class d{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,m){if(typeof g>"u"||g===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof g=="string"||typeof m=="string"){const h=typeof g=="string"?g:g.value,c=typeof m=="string"?m:m.value;return I.equalsIgnoreCase(h,c)}return g._lower===m._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=d;class a{get size(){return this._set.size}constructor(g){if(this._set=new Set,g)for(const m of g)this.add(m)}add(g){this._set.add(d.toKey(g))}delete(g){return this._set.delete(d.toKey(g))}has(g){return this._set.has(d.toKey(g))}}e.ExtensionIdentifierSet=a;class p{constructor(){this._map=new Map}clear(){this._map.clear()}delete(g){this._map.delete(d.toKey(g))}get(g){return this._map.get(d.toKey(g))}has(g){return this._map.has(d.toKey(g))}set(g,m){this._map.set(d.toKey(g),m)}values(){return this._map.values()}forEach(g){this._map.forEach(g)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=p;function v(w){return S(w)}e.isApplicationScopedExtension=v;function S(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function y(w,g){if(g){const m=`onResolveRemoteAuthority:${(0,r.getRemoteName)(g)}`;return!!w.activationEvents?.includes(m)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[239],te([0,1,8,17,22,14,3,2,64,68,32,109,238,58]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var w;(function(N){N[N.Management=1]="Management",N[N.ExtensionHost=2]="ExtensionHost",N[N.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function g(N){switch(N){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(N){const A=new r.CancellationTokenSource;return setTimeout(()=>A.cancel(),N),A.token}function h(N,A){if(N.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const T=new r.CancellationTokenSource;return N.onCancellationRequested(()=>T.cancel()),A.onCancellationRequested(()=>T.cancel()),T.token}class c{get didTimeout(){return this._state==="timedout"}constructor(A){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((T,$)=>{this._resolvePromise=T,this._rejectPromise=$}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function P(N,A){const T=new c(A);return T.registerDisposable(N.onControlMessage($=>{const B=JSON.parse($.toString()),z=W(B);z?T.reject(z):T.resolve(B)})),T.promise}function u(N,A,T,$,B,z,j,ae){const fe=new c(ae),ue=a.StopWatch.create(!1);return N.info(`Creating a socket (${j})...`),d.mark(`code/willCreateSocket/${z}`),A.connect(T,$,B,j).then(de=>{fe.didTimeout?(d.mark(`code/didCreateSocketError/${z}`),N.info(`Creating a socket (${j}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(d.mark(`code/didCreateSocketOK/${z}`),N.info(`Creating a socket (${j}) was successful after ${ue.elapsed()} ms.`),fe.resolve(de))},de=>{d.mark(`code/didCreateSocketError/${z}`),N.info(`Creating a socket (${j}) returned an error after ${ue.elapsed()} ms.`),N.error(de),fe.reject(de)}),fe.promise}function t(N,A){const T=new c(A);return N.then($=>{T.didTimeout||T.resolve($)},$=>{T.didTimeout||T.reject($)}),T.promise}async function l(N,A,T,$){const B=ie(N,A);N.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let z;try{z=await u(N.logService,N.remoteSocketFactoryService,N.connectTo,(0,f.getRemoteServerRootPath)(N),`reconnectionToken=${N.reconnectionToken}&reconnection=${N.reconnectionProtocol?"true":"false"}`,g(A),`renderer-${g(A)}-${N.reconnectionToken}`,$)}catch(de){throw N.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),N.logService.error(de),de}N.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let j,ae;N.reconnectionProtocol?(N.reconnectionProtocol.beginAcceptReconnection(z,null),j=N.reconnectionProtocol,ae=!1):(j=new v.PersistentProtocol({socket:z}),ae=!0),N.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const fe=await t(N.signService.createNewMessage((0,p.generateUuid)()),$),ue={type:"auth",auth:N.connectionToken||"00000000000000000000",data:fe.data};j.sendControl(L.VSBuffer.fromString(JSON.stringify(ue)));try{const de=await P(j,h($,m(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(N.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(N.signService.validate(fe,de.signedData),$)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const we=await t(N.signService.sign(de.data),$),ye={type:"connectionType",commit:N.commit,signedData:we,desiredConnectionType:A};return T&&(ye.args=T),N.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),j.sendControl(L.VSBuffer.fromString(JSON.stringify(ye))),{protocol:j,ownsProtocol:ae}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(N.logService.error(`${B} the handshake timed out. Error:`),N.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(N.logService.error(`${B} received error control message when negotiating connection. Error:`),N.logService.error(de)),ae&&x(j),de}}async function s(N,A,T,$){const B=Date.now(),z=ie(N,A),{protocol:j,ownsProtocol:ae}=await l(N,A,T,$),fe=new c($);return fe.registerDisposable(j.onControlMessage(ue=>{const de=JSON.parse(ue.toString()),be=W(de);be?(N.logService.error(`${z} received error control message when negotiating connection. Error:`),N.logService.error(be),ae&&x(j),fe.reject(be)):(N.reconnectionProtocol?.endAcceptReconnection(),N.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(B)}!`),fe.resolve({protocol:j,firstMessage:de}))})),fe.promise}async function i(N,A){const{protocol:T}=await s(N,1,void 0,A);return{protocol:T}}async function n(N,A,T){const{protocol:$,firstMessage:B}=await s(N,2,A,T),z=B&&B.debugPort;return{protocol:$,debugPort:z}}async function o(N,A,T){const $=Date.now(),B=ie(N,3),{protocol:z}=await l(N,3,A,T);return N.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${oe($)}!`),z}async function b(N,A,T){const{connectTo:$,connectionToken:B}=await N.addressProvider.getAddress();return{commit:N.commit,quality:N.quality,connectTo:$,connectionToken:B,reconnectionToken:A,reconnectionProtocol:T,remoteSocketFactoryService:N.remoteSocketFactoryService,signService:N.signService,logService:N.logService}}async function D(N,A,T){return E(N,async $=>{const{protocol:B}=await i($,r.CancellationToken.None);return new G(N,A,T,$.reconnectionToken,B)})}e.connectRemoteAgentManagement=D;async function R(N,A){return E(N,async T=>{const{protocol:$,debugPort:B}=await n(T,A,r.CancellationToken.None);return new V(N,A,T.reconnectionToken,$,B)})}e.connectRemoteAgentExtensionHost=R;async function E(N,A){for(let $=1;;$++)try{const B=(0,p.generateUuid)(),z=await b(N,B,null);return await A(z)}catch(B){if($<5)N.logService.error(`[remote-connection][attempt ${$}] An error occurred in initial connection! Will retry... Error:`),N.logService.error(B);else throw N.logService.error(`[remote-connection][attempt ${$}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),N.logService.error(B),se.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(B)),B}}async function k(N,A,T){const $=await b(N,(0,p.generateUuid)(),null);return await o($,{host:A,port:T},r.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function O(N){return(0,I.createCancelablePromise)(A=>new Promise((T,$)=>{const B=setTimeout(T,N*1e3);A.onCancellationRequested(()=>{clearTimeout(B),T()})}))}var F;(function(N){N[N.ConnectionLost=0]="ConnectionLost",N[N.ReconnectionWait=1]="ReconnectionWait",N[N.ReconnectionRunning=2]="ReconnectionRunning",N[N.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",N[N.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class q{constructor(A,T){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=q;class ne{constructor(A,T,$,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.durationSeconds=$,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ne;class J{constructor(A,T,$){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=$,this.type=2}}e.ReconnectionRunningEvent=J;class ce{constructor(A,T,$){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=$,this.type=4}}e.ConnectionGainEvent=ce;class re{constructor(A,T,$,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=$,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class se extends C.Disposable{static triggerPermanentFailure(A,T,$){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=T,this._permanentFailureHandled=$,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor(A,T,$,B,z){super(),this._connectionType=A,this._options=T,this.reconnectionToken=$,this.protocol=B,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ce(this.reconnectionToken,0,0)),this._register(B.onSocketClose(j=>{const ae=Q(this._connectionType,this.reconnectionToken,!0);j?j.type===0?(this._options.logService.info(`${ae} received socket close event (hadError: ${j.hadError}).`),j.error&&this._options.logService.error(j.error)):(this._options.logService.info(`${ae} received socket close event (wasClean: ${j.wasClean}, code: ${j.code}, reason: ${j.reason}).`),j.event&&this._options.logService.error(j.event)):this._options.logService.info(`${ae} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(j=>{const ae=Q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${j.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${j.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${j.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,C.toDisposable)(()=>{const j=se._instances.indexOf(this);j>=0&&se._instances.splice(j,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const A=Q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let $=-1;do{$++;const B=$<T.length?T[$]:T[T.length-1];try{if(B>0){const j=O(B);this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,j)),this._options.logService.info(`${A} waiting for ${B} seconds before reconnecting...`);try{await j}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1)),this._options.logService.info(`${A} resolving connection...`);const z=await b(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${z.connectTo}...`),await this._reconnect(z,m(y)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if($>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,_.isCancellationError)(z)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,S.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(A,T,$){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(A,T,$):this._gotoPermanentFailure(A,T,$)}_gotoPermanentFailure(A,T,$){this._onDidStateChange.fire(new re(this.reconnectionToken,A,T,$)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se;class G extends se{constructor(A,T,$,B,z){super(1,A,B,z,!0),this.client=this._register(new v.Client(z,{remoteAuthority:T,clientId:$},A.ipcLogger))}async _reconnect(A,T){await i(A,T)}}e.ManagementPersistentConnection=G;class V extends se{constructor(A,T,$,B,z){super(2,A,$,B,!1),this._startArguments=T,this.debugPort=z}async _reconnect(A,T){await n(A,this._startArguments,T)}}e.ExtensionHostPersistentConnection=V;function x(N){try{N.acceptDisconnect();const A=N.getSocket();N.dispose(),A.dispose()}catch(A){(0,_.onUnexpectedError)(A)}}function W(N){if(N&&N.type==="error"){const A=new Error(`Connection error: ${N.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function U(N,A){for(;N.length<A;)N+=" ";return N}function H(N,A){return`[remote-connection][${U(g(N),13)}][${A.substr(0,5)}\u2026]`}function Q(N,A,T){return`${H(N,A)}[${T?"reconnect":"initial"}]`}function ie(N,A){return`${Q(A,N.reconnectionToken,!!N.reconnectionProtocol)}[${N.connectTo}]`}function oe(N){return`${Date.now()-N} ms`}}),define(ee[240],te([0,1,2,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(M,C){return this.factories[M]??=[],this.factories[M].push(C),(0,I.toDisposable)(()=>{const d=this.factories[M]?.indexOf(C);typeof d=="number"&&d>=0&&this.factories[M]?.splice(d,1)})}getSocketFactory(M){return(this.factories[M.type]||[]).find(d=>d.supports(M))}connect(M,C,d,a){const p=this.getSocketFactory(M);if(!p)throw new Error(`No socket factory found for ${M}`);return p.connect(M,C,d,a)}}e.RemoteSocketFactoryService=r}),define(ee[241],te([0,1,27,47,21,113]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function C(f=!1){return(M===void 0||f)&&(M=d()),M}e.hasWSLFeatureInstalled=C;async function d(){const f=a();if(f===void 0)return!1;if(f>=22e3){const y=v();if(y)return new Promise(w=>{L.execFile(y,["--status"],g=>w(!g))})}else{const y=S();if(y)try{if((await r.Promises.stat(y)).isFile())return!0}catch{}}return!1}function a(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(f)return parseInt(f[3])}function p(f){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return _.join(y,w?"Sysnative":"System32",f)}}function v(){return p("wsl.exe")}function S(){return p("lxss\\LxssManager.dll")}}),define(ee[50],te([0,1,17,14,2,181,57,6,5,43]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");class p{constructor(u){this.original=u}toJSON(){if(!this.headers){const u=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.original[t];this.headers=u}return this.headers}}class v extends r.Disposable{constructor(u){super(),this.counter=0,this.logger=u.createLogger("network",{name:(0,_.localize)(0,null),when:d.CONTEXT_LOG_LEVEL.isEqualTo((0,d.LogLevelToString)(d.LogLevel.Trace)).serialize()})}async logAndRequest(u,t,l){const s=`${u} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new p(t.headers??{}));try{const i=await l();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=v;function S(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=S;function f(P){return P.res.statusCode===204}e.hasNoContent=f;async function y(P){return f(P)?null:(await(0,I.streamToBuffer)(P.stream)).toString()}e.asText=y;async function w(P){if(!S(P))throw new Error("Server returned "+P.res.statusCode);return y(P)}e.asTextOrError=w;async function g(P){if(!S(P))throw new Error("Server returned "+P.res.statusCode);if(f(P))return null;const t=(await(0,I.streamToBuffer)(P.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.asJson=g;function m(P){c(P)}e.updateProxyConfigurationsScope=m;let h;function c(P){const u=a.Registry.as(M.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,_.localize)(1,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,_.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(6,null),(0,_.localize)(7,null),(0,_.localize)(8,null),(0,_.localize)(9,null)],default:"override",description:(0,_.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,_.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:t?[t]:[]})}c(1)}),define(ee[242],te([0,1,17,22]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(C){this.service=C}listen(C,d){throw new Error("Invalid listen")}call(C,d,a,p=L.CancellationToken.None){switch(d){case"request":return this.service.request(a[0],p).then(async({res:v,stream:S})=>{const f=await(0,I.streamToBuffer)(S);return[{statusCode:v.statusCode,headers:v.headers},f]});case"resolveProxy":return this.service.resolveProxy(a[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class _{constructor(C){this.channel=C}async request(C,d){const[a,p]=await this.channel.call("request",[C],d);return{res:a,stream:(0,I.bufferToStream)(p)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}}e.RequestChannelClient=_}),define(ee[243],te([0,1,244,12]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(M,C){return M.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:M.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function _(M,C,d={}){const a=(0,I.parse)(M),p=d.proxyUrl||r(a,C);if(!p)return null;const v=(0,I.parse)(p);if(!/^https?:$/.test(v.protocol||""))return null;const S={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,L.isBoolean)(d.strictSSL)?d.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,y)=>{K(["http-proxy-agent"],f,y)}))(S):new(await new Promise((f,y)=>{K(["https-proxy-agent"],f,y)}))(S)}e.getProxyAgent=_}),define(ee[245],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ee[94],te([0,1,47,9,182,22,49,14,4,32,108,62,8,138]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function w(m,h,c,P){return c["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(P)&&!c["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(P)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=S.Promises.withAsyncBody(async(u,t)=>{const l=new _.CancellationTokenSource;let s=1e4;const i=m.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,f.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{u(await g(h,l.token))}catch(o){!(0,C.isCancellationError)(o)&&!l.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,M.toErrorMessage)(o)))):u({})}finally{clearTimeout(n),l.dispose()}})),y)}e.getResolvedShellEnv=w;async function g(m,h){const c=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",c);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",P);const u=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",l);const s=await(0,p.getSystemShell)(d.OS,l);return m.trace("getUnixShellEnvironment#shell",s),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new C.CancellationError);const o=(0,L.basename)(s);let b,D;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(b=`& '${process.execPath}' ${R} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,D=["-Login","-Command"]):o==="nu"?(b=`^'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,D=["-i","-l","-c"]):(b=`'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"||o==="csh"?D=["-ic"]:D=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),b);const E=(0,I.spawn)(s,[...D,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});h.onCancellationRequested(()=>(E.kill(),n(new C.CancellationError))),E.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(F)),n(F)});const k=[];E.stdout.on("data",F=>k.push(F));const O=[];E.stderr.on("data",F=>O.push(F)),E.on("close",(F,q)=>{const ne=Buffer.concat(k).toString("utf8");m.trace("getUnixShellEnvironment#raw",ne);const J=Buffer.concat(O).toString("utf8");if(J.trim()&&m.trace("getUnixShellEnvironment#stderr",J),F||q)return n(new Error((0,r.localize)(2,null,F,q)));const ce=t.exec(ne),re=ce?ce[1]:"{}";try{const se=JSON.parse(re);c?se.ELECTRON_RUN_AS_NODE=c:delete se.ELECTRON_RUN_AS_NODE,P?se.ELECTRON_NO_ATTACH_CONSOLE=P:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){m.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(se)),n(se)}})})}}),define(ee[246],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class I{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(r){try{const _=await this.getValidator();if(_){const M=String(I._nextId++);return this.validators.set(M,_),{id:M,data:_.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,_){if(!r.id)return!0;const M=this.validators.get(r.id);if(!M)return!1;this.validators.delete(r.id);try{return M.validate(_)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=I}),define(ee[95],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[247],te([0,1,246]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends I.AbstractSignService{getValidator(){return this.vsda().then(_=>new _.validator)}signValue(_){return this.vsda().then(M=>new M.signer().sign(_))}vsda(){return new Promise((_,M)=>K(["vsda"],_,M))}}e.SignService=L}),define(ee[34],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[120],te([0,1,8,17,2,12,36,16,5]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class p extends r.Disposable{constructor(y,w,g,m){super(),this.storagePath=y,this.logService=g,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=w===0?void 0:this._register(new I.ThrottledDelayer(100))}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,w){const g=this.storage[y];return(0,_.isUndefinedOrNull)(g)?w:g}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:g,data:m}of y)this.storage[g]!==m&&((0,_.isUndefinedOrNull)(m)?(0,_.isUndefined)(this.storage[g])||(this.storage[g]=void 0,w=!0):(this.storage[g]=m,w=!0));w&&this.save()}removeItem(y){(0,_.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=y}catch(w){this.logService.error(w)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=p;let v=class extends r.Disposable{constructor(y,w,g,m){super(),this.fileStorage=this._register(new p(w.stateResource,y,g,m))}async init(){await this.fileStorage.init()}getItem(y,w){return this.fileStorage.getItem(y,w)}};e.StateReadonlyService=v,e.StateReadonlyService=v=Pe([Z(1,M.IEnvironmentService),Z(2,d.ILogService),Z(3,C.IFileService)],v);class S extends v{setItem(y,w){this.fileStorage.setItem(y,w)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}}e.StateService=S}),define(ee[121],te([0,1,4,35,32]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(d){if(I.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function M(d,a,p,v,S,f,y,w){const g=Object.create(null);g["common.machineId"]=f,g.sessionID=(0,r.generateUuid)()+Date.now(),g.commitHash=v,g.version=S,g["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,I.PlatformToString)(I.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=p,g["common.product"]=w||"desktop",y&&(g["common.msftInternal"]=y);let m=0;const h=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),I.isLinuxSnap&&(g["common.snap"]="true");const c=_(a);return c&&(g["common.platformDetail"]=c),g}e.resolveCommonProperties=M;function C(d){const a=L.env.USERDNSDOMAIN;if(!a)return!1;const p=a.toLowerCase();return d.some(v=>p===v)}e.verifyMicrosoftInternalDomain=C}),define(ee[25],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(ee[248],te([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function m(t,l){const s=`${t}::${l.join(":")}`,i=g.get(s);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,b=new Map,D=2e4;function R(k,O,F,q){const ne=O.substring(k.length+1);return L.Promises.withAsyncBody(async J=>{let ce;try{ce=await p.Promises.readdir(O,{withFileTypes:!0})}catch{J();return}if(q.count>=D){q.count+=ce.length,q.maxReached=!0,J();return}let re=ce.length;if(re===0){J();return}let se=ce;q.count+ce.length>D&&(q.maxReached=!0,re=D-q.count,se=ce.slice(0,re)),q.count+=ce.length;for(const G of se)if(G.isDirectory()){if(F.includes(G.name)||await R(k,(0,M.join)(O,G.name),F,q),--re===0){J();return}}else{const V=G.name.lastIndexOf(".");if(V>=0){const x=G.name.substring(V+1);x&&o.set(x,(o.get(x)??0)+1)}for(const x of n)x.relativePathPattern?.test(ne)!==!1&&x.filePattern.test(G.name)&&b.set(x.tag,(b.get(x.tag)??0)+1);if(--re===0){J();return}}})}const E=L.Promises.withAsyncBody(async k=>{const O={count:0,maxReached:!1};await R(t,t,l,O);const F=await P(t);k({configFiles:h(b),fileTypes:h(o),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return g.set(s,E),E}e.collectWorkspaceStats=m;function h(t){return Array.from(t.entries(),([l,s])=>({name:l,count:s})).sort((l,s)=>s.count-l.count)}function c(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.virtualMachineHint.value()*100)}%`},l=I.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.getMachineInfo=c;async function P(t){try{const l=new Map,s=(0,M.join)(t,".vscode","launch.json"),i=await p.Promises.readFile(s),n=[],o=(0,r.parse)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.getNodeType)(o)==="object"&&o.configurations)for(const b of o.configurations){const D=b.type;D&&(l.has(D)?l.set(D,l.get(D)+1):l.set(D,1))}return h(l)}catch{return[]}}e.collectLaunchConfigs=P;let u=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(I.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||s.push(`Load (avg):       ${I.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(a.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,v.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[n,o]=i,b=this.formatProcessList(l,n);return s.forEach(D=>{if((0,S.isRemoteDiagnosticError)(D))b+=`
${D.errorMessage}`,o+=`
${D.errorMessage}`;else if(b+=`

Remote: ${D.hostName}`,D.processes&&(b+=`
${this.formatProcessList(l,D.processes)}`),D.workspaceMetadata){o+=`
|  Remote: ${D.hostName}`;for(const R of Object.keys(D.workspaceMetadata)){const E=D.workspaceMetadata[R];let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${R}): ${k}`,o+=this.formatWorkspaceStats(E)}}}),{processInfo:b,workspaceInfo:o}})}async getSystemInfo(l,s){const{memory:i,vmHint:n,os:o,cpus:b}=c(),D={os:o,memory:i,cpus:b,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return C.isWindows||(D.load=`${I.loadavg().map(R=>Math.round(R)).join(", ")}`),C.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(l,s){const i=[];return(0,v.listProcesses)(l.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,n)),l.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),s.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(l,o.processes)),o.workspaceMetadata)for(const b of Object.keys(o.workspaceMetadata)){const D=o.workspaceMetadata[b];let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${b}): ${R}`),i.push(this.formatWorkspaceStats(D))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const s=[];let n=0;const o=(E,k)=>{const O=` ${E}(${k})`;n+O.length>60?(s.push(b),b="|                 ",n=b.length):n+=O.length,b+=O};let b="|      File types:";const D=10,R=l.fileTypes.length>D?D:l.fileTypes.length;for(let E=0;E<R;E++){const k=l.fileTypes[E];o(k.name,k.count)}if(s.push(b),l.configFiles.length>=0&&(b="|      Conf files:",n=0,l.configFiles.forEach(E=>{o(E.name,E.count)}),s.push(b)),l.launchConfigFiles.length>0){let E="|      Launch Configs:";l.launchConfigFiles.forEach(k=>{const O=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;E+=O}),s.push(E)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const b=d.URI.revive(o);if(b.scheme===_.Schemas.file){const D=b.fsPath;i.push(m(D,["node_modules",".git"]).then(R=>{let E=`${R.fileCount} files`;R.maxFilesReached&&(E=`more than ${E}`),s.push(`|    Folder (${(0,M.basename)(D)}): ${E}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${R.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(l,s){const i=new Map;l.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),l.pidToNames.forEach(({pid:o,name:b})=>i.set(o,b));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,i,n,s,0),n.join(`
`)}formatProcessItem(l,s,i,n,o){const b=o===0;let D;b?D=n.pid===l?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?D=s.get(n.pid):D=`${"  ".repeat(o)} ${n.name}`;const R=process.platform==="win32"?n.mem:I.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(R/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(E=>this.formatProcessItem(l,s,i,E,o+1))}async getWorkspaceFileExtensions(l){const s=new Set;for(const{uri:i}of l.folders){const n=d.URI.revive(i);if(n.scheme!==_.Schemas.file)continue;const o=n.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(D=>s.add(D.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const i=d.URI.revive(s);if(i.scheme!==_.Schemas.file)continue;const n=i.fsPath;try{const o=await m(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),o.fileTypes.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:b.name,count:b.count})}),o.launchConfigFiles.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:b.name,count:b.count})}),o.configFiles.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.DiagnosticsService=u,e.DiagnosticsService=u=Pe([Z(0,w.ITelemetryService),Z(1,y.IProductService)],u)}),define(ee[249],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(_){this.appenders=_}listen(_,M){throw new Error(`Event not found: ${M}`)}call(_,M,{eventName:C,data:d}){return this.appenders.forEach(a=>a.log(C,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class L{constructor(_){this.channel=_}log(_,M){return this.channel.call("log",{eventName:_,data:M}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[51],te([0,1,37,12,3,18,58,121,25]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=a;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class v{async publicLog(n,o,b){}async publicLogError(n,o,b){}}e.NullEndpointTelemetryService=v,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,n){return r.Event.debounce(n.onDidChangeConfiguration,(b,D)=>{const R=b?new Set([...b.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:R}},1e3,!0)(b=>{b.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,_.ConfigurationTargetToString)(b.source),configurationKeys:Array.from(b.affectedKeys)})})}e.configurationTelemetry=S;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=f;function y(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=y;function w(i){const n=i.getValue(d.TELEMETRY_SETTING_ID),o=i.getValue(d.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(d.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function g(i){const n={},o={},b={};c(i,b);for(let D in b){D=D.length>150?D.substr(D.length-149):D;const R=b[D];typeof R=="number"?o[D]=R:typeof R=="boolean"?o[D]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${R.length}`),n[D]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(n[D]=R)}return{properties:n,measurements:o}}e.validateTelemetryData=g;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,M.getRemoteName)(i);return m.has(n)?n:"other"}e.cleanRemoteAuthority=h;function c(i,n,o=0,b){if(i)for(const D of Object.getOwnPropertyNames(i)){const R=i[D],E=b?b+D:D;Array.isArray(R)?n[E]=(0,I.safeStringify)(R):R instanceof Date?n[E]=R.toISOString():(0,L.isObject)(R)?o<2?c(R,n,o+1,E+"."):n[E]=(0,I.safeStringify)(R):n[E]=R}}function P(i,n){const o=i.msftInternalDomains||[],b=n.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(o)||b}e.isInternalTelemetry=P;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const b=[];for(const k of n)for(;;){const O=k.exec(i);if(!O)break;b.push([O.index,k.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(o="";;){const k=R.exec(i);if(!k)break;const O=b.some(([F,q])=>k.index<q&&F<R.lastIndex);!D.test(k[0])&&!O&&(o+=i.substring(E,k.index)+"<REDACTED: user-file-path>",E=R.lastIndex)}return E<i.length&&(o+=i.substr(E)),o}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function s(i,n){return(0,I.cloneAndChange)(i,o=>{if(o instanceof a||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let b=o.replaceAll("%20"," ");b=t(b,n);for(const D of n)b=b.replace(D,"");return b=l(b),b}})}e.cleanData=s}),define(ee[122],te([0,1,26,116,119,4,7,14,35,51]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,I.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=p;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new S(i.identifier,n,o)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new S({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof S?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=S;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const i=f.exec(s);return i&&i[1]?[g(i[1]),i[2]]:[g(s),void 0]}e.getIdAndVersion=y;function w(s,i){return`${s}.${i}`}e.getExtensionId=w;function g(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=g;function m(s,i){return g(w(s??r.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=m;function h(s,i){const n=[],o=b=>{for(const D of n)if(D.some(R=>p(i(R),i(b))))return D;return null};for(const b of s){const D=o(b);D?D.push(b):n.push([b])}return n}e.groupByExtension=h;function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=c;function P(s){return{id:new a.TelemetryTrustedValue(s.identifier.id),name:new a.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function u(s,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const b=o.shift();if(b&&n.every(D=>!p(D.identifier,{id:b}))){const D=s.filter(R=>p(R.identifier,{id:b}));D.length===1&&(n.push(D[0]),o.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=u;async function t(s,i){if(!_.isLinux)return!1;let n;try{n=(await s.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(b))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(s,i){const n=await t(s,i),o=(0,L.getTargetPlatform)(n?"alpine":_.platform,d.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=l}),define(ee[250],te([0,1,204,51]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(_,M,C,d,a,p,v){const S={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_} (${M.nameShort})`};if((0,L.supportsTelemetry)(M,C)&&(0,L.getTelemetryLevel)(d)===3){const f=await(0,I.getServiceMachineId)(C,a,p);S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=v.machineId||f}return S}e.resolveMarketplaceHeaders=r}),define(ee[251],te([0,1,2,37,4,26,183,18,57,75,24,43,25,51]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,h,c){this._configurationService=h,this._productService=c,this._experimentProperties={},this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(P),"gi")),P.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(P.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(P=>{(P.affectsConfiguration(S.TELEMETRY_SETTING_ID)||P.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||P.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(m,h){this._experimentProperties[m]=h}_updateTelemetryLevel(){let m=(0,f.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const c=h.usage?3:h.error?2:0;m=Math.min(m,c)}this._telemetryLevel=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(m,h,c){this._telemetryLevel<h||(c=(0,L.mixin)(c,this._experimentProperties),c=(0,f.cleanData)(c,this._cleanupPatterns),c=(0,L.mixin)(c,this._commonProperties),this._appenders.forEach(P=>P.log(m,c)))}publicLog(m,h){this._log(m,3,h)}publicLog2(m,h){this.publicLog(m,h)}publicLogError(m,h){this._sendErrorTelemetry&&this._log(m,2,h)}publicLogError2(m,h){this.publicLogError(m,h)}};e.TelemetryService=y,e.TelemetryService=y=Pe([Z(1,C.IConfigurationService),Z(2,p.IProductService)],y);function w(){const g=(0,M.localize)(0,null,a.default.nameLong),m=a.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=r.isWeb?"":(0,M.localize)(3,null),c=(0,M.localize)(4,null),P=(0,M.localize)(5,null),u=(0,M.localize)(6,null),t=(0,M.localize)(7,null),l=`
|       | ${c} | ${P} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,M.localize)(8,null);return`
${g} ${m} ${h}

&nbsp;

${t}
${l}

&nbsp;

${s}
`}v.Registry.as(d.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:w(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(d.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,M.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,M.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[252],te([0,1,4,86,25]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function _(M,C){let d=M.getItem(r.machineIdKey);return(typeof d!="string"||I.isMacintosh&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,L.getMachineId)(C.error.bind(C))),d}e.resolveMachineId=_}),define(ee[253],te([0,1,25,252]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(_,M){const C=await(0,L.resolveMachineId)(_,M);return _.setItem(I.machineIdKey,C),C}e.resolveMachineId=r}),define(ee[123],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var I;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(I||(e.EnvironmentVariableMutatorType=I={}))}),define(ee[254],te([0,1,4,123]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class _{constructor(p){this.collections=p,this.map=new Map,this.descriptionMap=new Map,p.forEach((v,S)=>{this.populateDescriptionMap(v,S);const f=v.map.entries();let y=f.next();for(;!y.done;){const w=y.value[1],g=y.value[0];let m=this.map.get(g);if(m||(m=[],this.map.set(g,m)),m.length>0&&m[0].type===L.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const h={extensionIdentifier:S,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};h.scope||delete h.scope,m.unshift(h),y=f.next()}})}async applyToProcessEnvironment(p,v,S){let f;I.isWindows&&(f={},Object.keys(p).forEach(y=>f[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap(v)){const g=I.isWindows&&f[y.toLowerCase()]||y;for(const m of w){const h=S?await S(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case L.EnvironmentVariableMutatorType.Append:p[g]=(p[g]||"")+h;break;case L.EnvironmentVariableMutatorType.Prepend:p[g]=h+(p[g]||"");break;case L.EnvironmentVariableMutatorType.Replace:p[g]=h;break}if(m.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${r.get(m.type)}`;p[c]=(p[c]?p[c]+":":"")+y+"="+this._encodeColons(h)}}}}_encodeColons(p){return p.replaceAll(":","\\x3a")}diff(p,v){const S=new Map,f=new Map,y=new Map;if(p.getVariableMap(v).forEach((w,g)=>{const m=this.getVariableMap(v).get(g),h=C(w,m);h&&S.set(g,h)}),this.getVariableMap(v).forEach((w,g)=>{const m=p.getVariableMap(v).get(g),h=C(w,m);h&&y.set(g,h)}),this.getVariableMap(v).forEach((w,g)=>{const m=p.getVariableMap(v).get(g),h=d(w,m);h&&f.set(g,h)}),!(S.size===0&&f.size===0&&y.size===0))return{added:S,changed:f,removed:y}}getVariableMap(p){const v=new Map;for(const S of this.map.values()){const f=S.filter(y=>M(y,p));f.length>0&&v.set(f[0].variable,f)}return v}getDescriptionMap(p){const v=new Map;for(const S of this.descriptionMap.values()){const f=S.filter(y=>M(y,p,!0));for(const y of f)v.set(y.extensionIdentifier,y.description)}return v}populateDescriptionMap(p,v){if(!p.descriptionMap)return;const S=p.descriptionMap.entries();let f=S.next();for(;!f.done;){const y=f.value[1],w=f.value[0];let g=this.descriptionMap.get(w);g||(g=[],this.descriptionMap.set(w,g));const m={extensionIdentifier:v,scope:y.scope,description:y.description};m.scope||delete m.scope,g.push(m),f=S.next()}}}e.MergedEnvironmentVariableCollection=_;function M(a,p,v=!1){return a.scope?!!(a.scope.workspaceFolder&&p?.workspaceFolder&&a.scope.workspaceFolder.index===p.workspaceFolder.index):v?p===a.scope:!0}function C(a,p){if(!p)return a;const v=new Set;p.forEach(f=>v.add(f.extensionIdentifier));const S=[];return a.forEach(f=>{v.has(f.extensionIdentifier)||S.push(f)}),S.length===0?void 0:S}function d(a,p){if(!p)return;const v=new Map;p.forEach(f=>v.set(f.extensionIdentifier,f));const S=[];return a.forEach(f=>{const y=v.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&S.push(y)}),S.length===0?void 0:S}}),define(ee[255],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(d){return[...d.entries()]}e.serializeEnvironmentVariableCollection=I;function L(d){return d?[...d.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(d){return new Map(d)}e.deserializeEnvironmentVariableCollection=r;function _(d){return new Map(d??[])}e.deserializeEnvironmentDescriptionMap=_;function M(d){return Array.from(d.entries()).map(a=>[a[0],I(a[1].map),L(a[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function C(d){return new Map(d.map(a=>[a[0],{map:r(a[1]),descriptionMap:_(a[2])}]))}e.deserializeEnvironmentVariableCollections=C}),define(ee[256],te([0,1,8,22,3,2,5]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends _.Disposable{constructor(a,p){super(),this._logService=p,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=a===void 0?15e3:a,this._register((0,_.toDisposable)(()=>{for(const v of this._pendingRequestDisposables.values())(0,_.dispose)(v)}))}createRequest(a){return new Promise((p,v)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,p),this._onCreateRequest.fire({requestId:S,...a});const f=new L.CancellationTokenSource;(0,I.timeout)(this._timeout,f.token).then(()=>v(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,_.toDisposable)(()=>f.cancel())])})}acceptReply(a,p){const v=this._pendingRequests.get(a);v?(this._pendingRequests.delete(a),(0,_.dispose)(this._pendingRequestDisposables.get(a)||[]),this._pendingRequestDisposables.delete(a),v(p)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.RequestStore=C,e.RequestStore=C=Pe([Z(1,M.ILogService)],C)}),define(ee[124],te([0,1,6,114,43]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var _;(function(u){u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(_||(e.TerminalSettingPrefix=_={}));var M;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var C;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(C||(e.PosixShellType=C={}));var d;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var a;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var p;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var v;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.IPtyService=(0,I.createDecorator)("ptyService");var S;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S||(e.HeartbeatConstants=S={}));var f;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var g;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var m;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class P{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const l=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this._backends.set(l,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}r.Registry.add(e.TerminalExtensions.Backend,new P),e.ILocalPtyService=(0,I.createDecorator)("localPtyService"),e.ITerminalLogService=(0,I.createDecorator)("terminalLogService")}),define(ee[257],te([0,1,70,7,185,102]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function M(S,f){const y=[{name:null,description:(0,r.localize)(0,null)}];return y.push(...S.map(w=>({name:w.profileName,description:C(w)}))),f&&y.push(...f.map(w=>({name:w.title,description:d(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.createProfileSchemaEnums=M;function C(S){let f=`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:I.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?f+=`
- args: "${S.args}"`:f+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(f+=`
- overrideName: ${S.overrideName}`),S.color&&(f+=`
- color: ${S.color}`),S.env&&(f+=`
- env: ${JSON.stringify(S.env)}`),f}function d(S){return`$(${_.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:I.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function a(S,f){if(!S&&!f)return!0;if(typeof S=="string"&&typeof f=="string")return S===f;if(Array.isArray(S)&&Array.isArray(f)){if(S.length!==f.length)return!1;for(let y=0;y<S.length;y++)if(S[y]!==f[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=a;function p(S,f){if(!S&&!f)return!0;if(!S||!f)return!1;if(_.ThemeIcon.isThemeIcon(S)&&_.ThemeIcon.isThemeIcon(f))return S.id===f.id&&S.color===f.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof f=="object"&&"light"in f&&"dark"in f){const y=S,w=f;if((L.URI.isUri(y.light)||v(y.light))&&(L.URI.isUri(y.dark)||v(y.dark))&&(L.URI.isUri(w.light)||v(w.light))&&(L.URI.isUri(w.dark)||v(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(L.URI.isUri(S)&&L.URI.isUri(f)||v(S)||v(f)){const y=S,w=f;return y.path===w.path&&y.scheme===w.scheme}return!1}e.terminalIconsEqual=p;function v(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=v}),define(ee[258],te([0,1,70,4,184,57,43,257]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,I.getAllCodicons)(),g=>g.id),markdownEnumDescriptions:Array.from((0,I.getAllCodicons)(),g=>`$(${g.id})`)};const d={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},p={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function v(g){const m=g===2?"linux":g===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(g),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const S={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...d}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...d}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...d}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){M.Registry.as(_.Extensions.Configuration).registerConfiguration(S),w()}e.registerTerminalPlatformConfiguration=f;let y;function w(g,m){const h=M.Registry.as(_.Extensions.Configuration);let c;g&&(c=(0,C.createProfileSchemaEnums)(g?.profiles,m));const P=y;y={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?c?.values:void 0,markdownEnumDescriptions:g?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?c?.values:void 0,markdownEnumDescriptions:g?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?c?.values:void 0,markdownEnumDescriptions:g?.os===1?c?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:P?[P]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(ee[259],te([0,1,27,13,37,9,4,35,26,12,21,123,255,254]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.getWindowsBuildNumber=y;async function w(i,n,o,b=C.env,D=p.Promises.exists){if(_.isAbsolute(i))return await D(i)?i:void 0;if(n===void 0&&(n=C.cwd()),_.dirname(i)!=="."){const O=_.join(n,i);return await D(O)?O:void 0}const E=(0,r.getCaseInsensitive)(b,"PATH");if(o===void 0&&(0,a.isString)(E)&&(o=E.split(_.delimiter)),o===void 0||o.length===0){const O=_.join(n,i);return await D(O)?O:void 0}for(const O of o){let F;if(_.isAbsolute(O)?F=_.join(O,i):F=_.join(n,O,i),await D(F))return F;if(M.isWindows){let q=F+".com";if(await D(q)||(q=F+".exe",await D(q)))return q}}const k=_.join(n,i);return await D(k)?k:void 0}e.findExecutable=w;function g(i,n,o,b,D){const R=M.isWindows&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||R)return;const E=i.args,k=C.platform==="win32"?_.basename(i.executable).toLowerCase():_.basename(i.executable),O=_.dirname(L.FileAccess.asFileUri("").fsPath);let F;const q={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(q.VSCODE_NONCE=n.shellIntegration.nonce),M.isWindows){if(k==="pwsh.exe"||k==="powershell.exe")return!E||l(E)?F=c.get(h.WindowsPwsh):t(E)&&(F=c.get(h.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,d.format)(F[F.length-1],O,""),{newArgs:F,envMixin:q}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(k){case"bash":return!E||E.length===0?F=c.get(h.Bash):s(E)&&(q.VSCODE_SHELL_LOGIN="1",m(n,q),F=c.get(h.Bash)),F?(F=[...F],F[F.length-1]=(0,d.format)(F[F.length-1],O),{newArgs:F,envMixin:q}):void 0;case"fish":{const ne=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=_.join(O,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${ne}:${J}`,m(n,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!E||l(E)?F=c.get(h.Pwsh):t(E)&&(F=c.get(h.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,d.format)(F[F.length-1],O,""),{newArgs:F,envMixin:q}):void 0;case"zsh":{if(!E||E.length===0?F=c.get(h.Zsh):s(E)?(F=c.get(h.ZshLogin),m(n,q)):(E===c.get(h.Zsh)||E===c.get(h.ZshLogin))&&(F=E),!F)return;F=[...F],F[F.length-1]=(0,d.format)(F[F.length-1],O);let ne;try{ne=I.userInfo().username}catch{ne="unknown"}const J=_.join(I.tmpdir(),`${ne}-${D.applicationName}-zsh`);q.ZDOTDIR=J;const ce=o?.ZDOTDIR??I.homedir()??"~";q.USER_ZDOTDIR=ce;const re=[];return re.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:_.join(J,".zshrc")}),re.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:_.join(J,".zprofile")}),re.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:_.join(J,".zshenv")}),re.push({source:_.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:_.join(J,".zlogin")}),{newArgs:F,envMixin:q,filesToCopy:re}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=g;function m(i,n){if(M.isMacintosh&&i.environmentVariableCollections){const o=(0,S.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),D=new f.MergedEnvironmentVariableCollection(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),R=[];if(D)for(const E of D)E.type===v.EnvironmentVariableMutatorType.Prepend&&R.push(E.value);R.length>0&&(n.VSCODE_PATH_PREFIX=R.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const c=new Map;c.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(h.Zsh,["-i"]),c.set(h.ZshLogin,["-il"]),c.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?P.includes(i.toLowerCase()):i.length===1&&P.includes(i[0].toLowerCase())||i.length===2&&(P.includes(i[0].toLowerCase())||P.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function s(i){return i==="string"&&P.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&P.includes(i[0].toLowerCase())}}),define(ee[260],te([0,1,47,70,9,4,12,21,106,259,113]),function(K,e,I,L,r,_,M,C,d,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let v,S=!0;function f(n,o,b,D,R=process.env,E,k,O,F){return E=E||{existsFile:C.SymlinkSupport.existsFile,readFile:C.Promises.readFile},_.isWindows?y(b,E,R,k,D.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:D.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:D.getValue("terminal.integrated.defaultProfile.windows"),F,O):l(E,k,b,n&&typeof n=="object"?{...n}:D.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:D.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,O,R)}e.detectAvailableProfiles=f;async function y(n,o,b,D,R,E,k,O,F){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let J=!1;(0,a.getWindowsBuildNumber)()>=16299&&(J=!0),await h(O);const ce=new Map;if(n){ce.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const se=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",se],requiresPath:process.env.CMDER_ROOT?se:{path:se,isUnsafe:!0},isAutoDetected:!0})}s(E,ce);const re=await w(ce.entries(),k,o,b,D,F);if(n&&R)try{const se=await u(`${ne}\\${J?"wsl":"bash"}.exe`,k);for(const G of se)(!E||!(G.profileName in E))&&re.push(G)}catch{S&&(D?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return re}async function w(n,o,b,D=process.env,R,E){const k=[];for(const[O,F]of n)k.push(g(O,F,o,b,D,R,E));return(await Promise.all(k)).filter(O=>!!O)}async function g(n,o,b,D,R=process.env,E,k){if(o===null)return;let O,F,q;if("source"in o&&!("path"in o)){const re=v?.get(o.source);if(!re)return;O=re.paths,F=o.args||re.args,o.icon?q=m(o.icon):re.icon&&(q=re.icon)}else O=Array.isArray(o.path)?o.path:[o.path],F=_.isWindows||Array.isArray(o.args)?o.args:void 0,q=m(o.icon);let ne;if(k){const re=O.map(G=>typeof G=="string"?G:G.path),se=await k(re);ne=new Array(O.length);for(let G=0;G<O.length;G++)typeof O[G]=="string"?ne[G]=se[G]:ne[G]={path:se[G],isUnsafe:!0}}else ne=O.slice();let J;if(o.requiresPath){let re;if((0,M.isString)(o.requiresPath)?re=o.requiresPath:(re=o.requiresPath.path,o.requiresPath.isUnsafe&&(J=re)),!await D.existsFile(re))return}const ce=await i(n,b,ne,D,R,F,o.env,o.overrideName,o.isAutoDetected,J);if(!ce){E?.debug("Terminal profile not validated",n,O);return}return ce.isAutoDetected=o.isAutoDetected,ce.icon=q,ce.color=o.color,ce}function m(n){return typeof n=="string"?{id:n}:n}async function h(n){if(v&&!n)return;const[o,b]=await Promise.all([c(),n||P()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:b,icon:L.Codicon.terminalPowershell})}async function c(){const n=new Set,o=await(0,a.findExecutable)("git.exe");if(o){const R=(0,p.dirname)(o);n.add((0,p.resolve)(R,"../.."))}function b(R,E){E&&R.add(E)}b(n,process.env.ProgramW6432),b(n,process.env.ProgramFiles),b(n,process.env["ProgramFiles(X86)"]),b(n,`${process.env.LocalAppData}\\Program`);const D=[];for(const R of n)D.push(`${R}\\Git\\bin\\bash.exe`,`${R}\\Git\\usr\\bin\\bash.exe`,`${R}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function P(){const n=[];for await(const o of(0,d.enumeratePowerShellInstallations)())n.push(o.exePath);return n}async function u(n,o){const b=[],D=await new Promise((k,O)=>{I.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,q)=>{if(F)return O("Problem occurred when getting wsl distros");k(q)})});if(!D)return[];const R=new RegExp(/[\r?\n]/),E=D.split(R).filter(k=>k.trim().length>0&&k!=="");for(const k of E){if(k===""||k.startsWith("docker-desktop"))continue;const O=`${k} (WSL)`,F={profileName:O,path:n,args:["-d",`${k}`],isDefault:O===o,icon:t(k),isAutoDetected:!1};b.push(F)}return b}function t(n){return n.includes("Ubuntu")?L.Codicon.terminalUbuntu:n.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function l(n,o,b,D,R,E,k,O){const F=new Map;if(b){const q=(await n.readFile("/etc/shells")).toString(),ne=(E||q.split(`
`)).map(ce=>{const re=ce.indexOf("#");return re===-1?ce:ce.substring(0,re)}).filter(ce=>ce.trim().length>0),J=new Map;for(const ce of ne){let re=(0,r.basename)(ce),se=J.get(re)||0;se++,se>1&&(re=`${re} (${se})`),J.set(re,se),F.set(re,{path:ce,isAutoDetected:!0})}}return s(D,F),await w(F.entries(),R,n,O,o,k)}function s(n,o){if(n)for(const[b,D]of Object.entries(n))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?o.delete(b):(D.icon=D.icon||o.get(b)?.icon,o.set(b,D))}async function i(n,o,b,D,R,E,k,O,F,q){if(b.length===0)return Promise.resolve(void 0);const ne=b.shift();if(ne==="")return i(n,o,b,D,R,E,k,O,F);const J=typeof ne!="string"&&ne.isUnsafe,ce=typeof ne=="string"?ne:ne.path,re={profileName:n,path:ce,args:E,env:k,overrideName:O,isAutoDetected:F,isDefault:n===o,isUnsafePath:J,requiresUnsafePath:q};if((0,r.basename)(ce)===ce){const G=R.PATH?R.PATH.split(r.delimiter):void 0,V=await(0,a.findExecutable)(ce,void 0,G,void 0,D.existsFile);return V?(re.path=V,re.isFromPath=!0,re):i(n,o,b,D,R,E)}return await D.existsFile((0,r.normalize)(ce))?re:i(n,o,b,D,R,E,k,O,F)}}),define(ee[261],te([0,1,3,2,4,42,18,5,224,94,256,124,258,260,108,68]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let m=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(c,P,u,t){super(),this._ptyHostStarter=c,this._configurationService=P,this._logService=u,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new I.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new I.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new I.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new I.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new I.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new I.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new I.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new I.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new I.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new I.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new I.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new I.Emitter),this.onProcessExit=this._onProcessExit.event,(0,S.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&I.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,a.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(c){return this._logService.error("ptyHost was unable to resolve shell environment",c),{}}}_startPtyHost(){const c=this._ptyHostStarter.start(),P=c.client;this._logService.getLevel()===C.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),_.ProxyChannel.toService(P.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(c.onDidProcessExit(l=>{this._onPtyHostExit.fire(l.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=_.ProxyChannel.toService(P.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(l=>this._onProcessData.fire(l))),this._register(t.onProcessReady(l=>this._onProcessReady.fire(l))),this._register(t.onProcessExit(l=>this._onProcessExit.fire(l))),this._register(t.onDidChangeProperty(l=>this._onDidChangeProperty.fire(l))),this._register(t.onProcessReplay(l=>this._onProcessReplay.fire(l))),this._register(t.onProcessOrphanQuestion(l=>this._onProcessOrphanQuestion.fire(l))),this._register(t.onDidRequestDetach(l=>this._onDidRequestDetach.fire(l))),this._register(new d.RemoteLoggerChannelClient(this._loggerService,P.getChannel(v.TerminalIpcChannels.Logger))),this.__connection=c,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[c,t]}async createProcess(c,P,u,t,l,s,i,n,o,b,D){const R=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(c,P,u,t,l,s,i,n,o,b,D);return clearTimeout(R),E}updateTitle(c,P,u){return this._proxy.updateTitle(c,P,u)}updateIcon(c,P,u,t){return this._proxy.updateIcon(c,P,u,t)}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c,P){return this._proxy.detachFromProcess(c,P)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,P){return this._proxy.shutdown(c,P)}input(c,P){return this._proxy.input(c,P)}processBinary(c,P){return this._proxy.processBinary(c,P)}resize(c,P,u){return this._proxy.resize(c,P,u)}clearBuffer(c){return this._proxy.clearBuffer(c)}acknowledgeDataEvent(c,P){return this._proxy.acknowledgeDataEvent(c,P)}setUnicodeVersion(c,P){return this._proxy.setUnicodeVersion(c,P)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}async getLatency(){const c=new w.StopWatch,P=await this._proxy.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...P]}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}installAutoReply(c,P){return this._proxy.installAutoReply(c,P)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(c){return this._proxy.uninstallAutoReply(c)}getDefaultSystemShell(c){return this._optionalProxy?.getDefaultSystemShell(c)??(0,y.getSystemShell)(c??r.OS,process.env)}async getProfiles(c,P,u,t=!1){const l=await this._resolveShellEnv();return(0,f.detectAvailableProfiles)(P,u,t,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,c))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(c,P){return this._proxy.getWslPath(c,P)}getRevivedPtyNewId(c,P){return this._proxy.getRevivedPtyNewId(c,P)}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this._optionalProxy?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,P){return this._proxy.requestDetachInstance(c,P)}async acceptDetachInstanceReply(c,P){return this._proxy.acceptDetachInstanceReply(c,P)}async freePortKillProcess(c){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(c)}async serializeTerminalState(c){return this._proxy.serializeTerminalState(c)}async reviveTerminalProcesses(c,P,u){return this._proxy.reviveTerminalProcesses(c,P,u)}async refreshProperty(c,P){return this._proxy.refreshProperty(c,P)}async updateProperty(c,P,u){return this._proxy.updateProperty(c,P,u)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(c){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),c?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(c,P){return this._resolveVariablesRequestStore.createRequest({workspaceId:c,originalText:P})}async acceptPtyHostResolvedVariables(c,P){this._resolveVariablesRequestStore.acceptReply(c,P)}};e.PtyHostService=m,e.PtyHostService=m=Pe([Z(1,M.IConfigurationService),Z(2,C.ILogService),Z(3,C.ILoggerService)],m)}),define(ee[77],te([0,1,15,3,2,4,18,6,34]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const a="#FFFFFF",p="#1E1E1E",v="#000000",S="#FFFFFF",f="theme",y="themeBackground",w="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let g=class extends r.Disposable{constructor(h,c){super(),this.stateService=h,this.configurationService=c,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,I.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(_.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(_.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(_.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return h.dark?v:S;let c=this.stateService.getItem(y,null);if(!c)switch(this.stateService.getItem(f,"vs-dark").split(" ")[0]){case"vs":c=a;break;case"hc-black":c=v;break;case"hc-light":c=S;break;default:c=p}return _.isMacintosh&&c.toUpperCase()===p&&(c="#171717"),c}saveWindowSplash(h,c){this.stateService.setItems([{key:f,data:c.baseTheme},{key:y,data:c.colorInfo.background},{key:w,data:c}]),typeof h=="number"&&this.updateBackgroundColor(h,c)}updateBackgroundColor(h,c){for(const P of I.BrowserWindow.getAllWindows())if(P.id===h){P.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(w)}};e.ThemeMainService=g,e.ThemeMainService=g=Pe([Z(0,d.IStateService),Z(1,M.IConfigurationService)],g)}),define(ee[125],te([0,1,3,18,6,5]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var M;(function(g){g.Http="http",g.Https="https"})(M||(e.TunnelProtocol=M={}));var C;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(C||(e.TunnelPrivacyId=C={}));function d(g){return!!g.forwardPort}e.isTunnelProvider=d;var a;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function p(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=S;function f(g,m,h,c){if(h===1)return!1;if(h===2&&S(m)){const P=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(P?.length===4&&parseInt(P[1])>=18)return!1}return g<1024}e.isPortPrivileged=f;class y{constructor(m,h,c){this.remoteAddress=m,this.localAddress=h,this._dispose=c,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let w=class{constructor(m,h){this.logService=m,this.configurationService=h,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],h=Array.from(this._tunnels.values());for(const c of h){const P=Array.from(c.values());for(const u of P){const t=await u.value;t&&typeof t!="string"&&m.push(t)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:h}of m.values())await h.then(c=>typeof c!="string"?c?.dispose():void 0);m.clear()}this._tunnels.clear()}setEnvironmentTunnel(m,h,c,P,u){this.addTunnelToMap(m,h,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:h,localAddress:c,privacy:P,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,h){(S(m)||v(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(m,h);if(c)return++c.refcount,c.value}openTunnel(m,h,c,P,u,t=!1,l,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${c} on local port ${u}.`);const i=this._tunnelProvider??m;if(!i)return;if(h||(h="localhost"),P||(P=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(i,h,c,P,u,t,l,s);return n?n.then(o=>{if(o){if(typeof o=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(h,c),o}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(h,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.makeTunnel(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&o.privacy!==l&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(b),b}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const h=this._tunnels.get(m.tunnelRemoteHost);if(h){const c=h.get(m.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,c))}}}}async tryDisposeTunnel(m,h,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${h}.`);const P=c.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(h),P}}async closeTunnel(m,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${h} `);const c=this._tunnels.get(m);if(c&&c.has(h)){const P=c.get(h);P.refcount=0,await this.tryDisposeTunnel(m,h,P)}}addTunnelToMap(m,h,c){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(h,{refcount:1,value:c})}async removeEmptyOrErrorTunnelFromMap(m,h){const c=this._tunnels.get(m);if(c){const P=c.get(h),u=P?await P.value:void 0;(!u||typeof u=="string")&&c.delete(h),c.size===0&&this._tunnels.delete(m)}}getTunnelFromMap(m,h){const c=[m];v(m)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):S(m)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const P=c.map(u=>this._tunnels.get(u));for(const u of P){const t=u?.get(h);if(t)return t}}canTunnel(m){return!!p(m)}createWithProvider(m,h,c,P,u,t,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${c} on local port ${P}.`);const s=c;this._factoryInProgress.add(s);const i=P===void 0?c:P,n={elevationRequired:u?this.isPortPrivileged(i):!1},o={remoteAddress:{host:h,port:c},localAddressPort:P,privacy:t,public:t?t!==C.Private:void 0,protocol:l},b=m.forwardPort(o,n);return b?(this.addTunnelToMap(h,c,b),b.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),b}};e.AbstractTunnelService=w,e.AbstractTunnelService=w=Pe([Z(0,_.ILogService),Z(1,L.IConfigurationService)],w)}),define(ee[48],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.Disabled="disabled",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L||(e.StateType=L={}));var r;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap",M[M.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={}));var _;(function(M){M[M.NotBuilt=0]="NotBuilt",M[M.DisabledByEnvironment=1]="DisabledByEnvironment",M[M.ManuallyDisabled=2]="ManuallyDisabled",M[M.MissingConfiguration=3]="MissingConfiguration",M[M.InvalidConfiguration=4]="InvalidConfiguration",M[M.RunningAsAdmin=5]="RunningAsAdmin"})(_||(e.DisablementReason=_={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:M=>({type:"disabled",reason:M}),Idle:(M,C)=>({type:"idle",updateType:M,error:C}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[262],te([0,1,4,186,57,43]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[263],te([0,1,3,48]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(C){this.service=C}listen(C,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(C,d,a){switch(d){case"checkForUpdates":return this.service.checkForUpdates(a);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(a)}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=r;class _{get state(){return this._state}set state(C){this._state=C,this._onStateChange.fire(C)}constructor(C){this.channel=C,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(C){return this.channel.call("checkForUpdates",C)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(C){return this.channel.call("_applySpecificUpdate",C)}}e.UpdateChannelClient=_}),define(ee[40],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[264],te([0,1,40,205,16,19,139,3,2]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(S){this.uri=S,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let p=class{constructor(S){this._fileService=S,this._dispooables=new d.DisposableStore,this._limit=2**16;const f=new Map,y=w=>{let g=f.get(w.scheme);return g===void 0&&(g=S.hasProvider(w)&&!this._fileService.hasCapability(w,1024),f.set(w.scheme,g)),g};this._dispooables.add(C.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new _.ExtUri(y),this._canonicalUris=new M.SkipList((w,g)=>this.extUri.compare(w,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,_.normalizePath)(S));const f=this._canonicalUris.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new a(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let y=0;y<f;y++)this._canonicalUris.set(S[y][0],S[y][1].touch())}};e.UriIdentityService=p,e.UriIdentityService=p=Pe([Z(0,r.IFileService)],p),(0,L.registerSingleton)(I.IUriIdentityService,p,1)}),define(ee[126],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[265],te([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(C){this.handler=C}listen(C,d){throw new Error(`Event not found: ${d}`)}call(C,d,a){switch(d){case"handleURL":return this.handler.handleURL(I.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=L;class r{constructor(C){this.channel=C}handleURL(C,d){return this.channel.call("handleURL",[C.toJSON(),d])}}e.URLHandlerChannelClient=r;class _{constructor(C,d){this.next=C,this.logService=d}async routeCall(C,d,a,p){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(a)&&a.length>0){const v=I.URI.revive(a[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const S=/\bwindowId=(\d+)/.exec(v.query);if(S){const f=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,v.toString(!0));const y=new RegExp(`window:${f}`),w=C.connections.find(g=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",g.ctx),y.test(g.ctx)));if(w)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(C,d,a,p)}routeEvent(C,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=_}),define(ee[266],te([0,1,8,2,7,24]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(a,p){const v=[...this.handlers.values()];return(0,I.first)(v.map(S=>()=>S.handleURL(a,p)),void 0,!1).then(S=>S||!1)}registerHandler(a){return this.handlers.add(a),(0,L.toDisposable)(()=>this.handlers.delete(a))}}e.AbstractURLService=M;let C=class extends M{constructor(a){super(),this.productService=a}create(a){let{authority:p,path:v,query:S,fragment:f}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&v&&v.indexOf("/")!==0&&(v=`/${v}`),r.URI.from({scheme:this.productService.urlProtocol,authority:p,path:v,query:S,fragment:f})}};e.NativeURLService=C,e.NativeURLService=C=Pe([Z(0,_.IProductService)],C)}),define(ee[267],te([0,1,15,8,3,2,4,7]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class d extends _.Disposable{constructor(p,v,S,f,y,w){if(super(),this.urlService=v,this.logService=w,this.uris=[],this.retryCount=0,p&&(w.trace("ElectronURLListener initialUrisToHandle:",p.map(h=>h.originalUrl)),this.uris=p),M.isWindows){const h=f.isBuilt?[]:[`"${f.appRoot}"`];h.push("--open-url","--"),I.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const g=r.Event.map(r.Event.fromNodeEventEmitter(I.app,"open-url",(h,c)=>({event:h,url:c})),({event:h,url:c})=>(h.preventDefault(),c));this._register(g(h=>{const c=this.uriFromRawUrl(h);c&&this.urlService.open(c,{originalUrl:h})})),S.getWindows().filter(h=>h.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(r.Event.once(S.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(p){try{return C.URI.parse(p)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const v of this.uris)await this.urlService.open(v.uri,{originalUrl:v.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),p.push(v));p.length!==0&&(this.uris=p,(0,L.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=d}),define(ee[268],te([0,1,3,2,16,56,31]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends L.Disposable{constructor(a,p,v,S,f,y){super(),this.fileSystemScheme=a,this.fileSystemProvider=p,this.userDataScheme=v,this.userDataProfilesService=S,this.uriIdentityService=f,this.logService=y,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new M.ResourceSet(w=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(w))),this.updateAtomicReadWritesResources(),this._register(S.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(w=>this.handleFileChanges(w)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,p){return this.fileSystemProvider.open(this.toFileSystemResource(a),p)}close(a){return this.fileSystemProvider.close(a)}read(a,p,v,S,f){return this.fileSystemProvider.read(a,p,v,S,f)}write(a,p,v,S,f){return this.fileSystemProvider.write(a,p,v,S,f)}watch(a,p){this.watchResources.set(a,a);const v=this.fileSystemProvider.watch(this.toFileSystemResource(a),p);return(0,L.toDisposable)(()=>{this.watchResources.delete(a),v.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,p,v){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(p),v)}readFile(a,p){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),p)}readFileStream(a,p,v){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),p,v)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,p,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),p,v)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,p){return this.fileSystemProvider.delete(this.toFileSystemResource(a),p)}copy(a,p,v){if((0,r.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(p),v);throw new Error("copy not supported")}cloneFile(a,p){if((0,r.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(p));throw new Error("clone not supported")}handleFileChanges(a){const p=[];for(const v of a){if(v.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(v.resource);this.watchResources.findSubstr(S)&&p.push({resource:S,type:v.type})}p.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(p))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(ee[269],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[270],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[271],te([0,1,15,2,13,7]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.handleWebviewRequest.bind(this);I.protocol.registerFileProtocol(r.Schemas.vscodeWebview,d)}handleWebviewRequest(d,a){try{const p=_.URI.parse(d.url),v=M.validWebviewFilePaths.get(p.path);if(typeof v=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${v}`,f=r.FileAccess.asFileUri(S);return a({path:f.fsPath,headers:{...r.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.WebviewProtocolProvider=M}),define(ee[78],te([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(p){return!!p.workspaceUri}e.isWorkspaceToOpen=L;function r(p){return!!p.folderUri}e.isFolderToOpen=r;function _(p){return!!p.fileUri}e.isFileToOpen=_;function M(p){const v=C(p),S=p.getValue("window.menuBarVisibility");return S==="default"||v==="native"&&S==="compact"||I.isMacintosh&&I.isNative?"classic":S}e.getMenuBarVisibility=M;function C(p){if(I.isWeb)return"custom";const v=p.getValue("window");if(v){if(I.isMacintosh&&v.nativeTabs===!0||I.isMacintosh&&v.nativeFullScreen===!1)return"native";const y=v.titleBarStyle;if(y==="native"||y==="custom")return y}return I.isLinux?"native":"custom"}e.getTitleBarStyle=C;function d(p){return!(!I.isWindows||I.isWeb||C(p)==="native")}e.useWindowControlsOverlay=d;function a(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=a}),define(ee[127],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(C){C[C.INITIAL=1]="INITIAL",C[C.LOAD=2]="LOAD",C[C.RELOAD=3]="RELOAD"})(I||(e.LoadReason=I={}));var L;(function(C){C[C.CLOSE=1]="CLOSE",C[C.QUIT=2]="QUIT",C[C.RELOAD=3]="RELOAD",C[C.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(C=1){return{width:1024,height:768,mode:C}};e.defaultWindowState=r;var _;(function(C){C[C.Maximized=0]="Maximized",C[C.Normal=1]="Normal",C[C.Minimized=2]="Minimized",C[C.Fullscreen=3]="Fullscreen"})(_||(e.WindowMode=_={}));var M;(function(C){C[C.UNRESPONSIVE=1]="UNRESPONSIVE",C[C.PROCESS_GONE=2]="PROCESS_GONE",C[C.LOAD=3]="LOAD"})(M||(e.WindowError=M={}))}),define(ee[30],te([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var L;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(L||(e.OpenContext=L={}))}),define(ee[272],te([0,1,15,23,4,7,21,18,62,6,5,126,30]),function(K,e,I,L,r,_,M,C,d,a,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,a.createDecorator)(e.ID);let f=class{constructor(w,g,m,h){this.logService=w,this.windowsMainService=g,this.urlService=m,this.configurationService=h}async start(w,g){this.logService.trace("Received data from other instance: ",w,g),r.isMacintosh&&I.app.focus({steal:!0});const m=this.parseOpenUrl(w);if(m.length){let h=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const c=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));c&&(h=c.ready())}h.then(()=>{for(const{uri:c,originalUrl:P}of m)this.urlService.open(c,{originalUrl:P})})}else return this.startOpenWindow(w,g)}parseOpenUrl(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,L.coalesce)(w._urls.map(g=>{try{return{uri:_.URI.parse(g),originalUrl:g}}catch{return null}})):[]}async startOpenWindow(w,g){const m=(0,d.isLaunchedFromCli)(g)?0:4;let h=[];const c=w.wait&&w.waitMarkerFilePath?_.URI.file(w.waitMarkerFilePath):void 0,P=w.remote||void 0,u={context:m,cli:w,userEnv:g,waitMarkerFileURI:c,remoteAuthority:P,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,u);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)h=await this.windowsMainService.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,u),h=[l]):h=await this.windowsMainService.open({...u,forceEmpty:!0})}}else h=await this.windowsMainService.open({...u,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(c&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,M.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=f,e.LaunchMainService=f=Pe([Z(0,p.ILogService),Z(1,S.IWindowsMainService),Z(2,v.IURLService),Z(3,C.IConfigurationService)],f)}),define(ee[273],te([0,1,15,3,2,271,30]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let C=class extends r.Disposable{constructor(a){super(),this.windowsMainService=a,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new _.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(a,p){let v;if(typeof a.windowId=="number"){const{windowId:S}=a,f=this.windowsMainService.getWindowById(S);if(!f?.win)throw new Error(`Invalid windowId: ${S}`);v=f.win.webContents}else{const{webContentsId:S}=a;if(v=I.webContents.fromId(S),!v)throw new Error(`Invalid webContentsId: ${S}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(p)}async findInFrame(a,p,v,S){const y=this.getFrameByName(a,p);if(typeof y.findInFrame=="function"){y.findInFrame(v,{findNext:S.findNext,forward:S.forward});const w=(g,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(a,p,v){const f=this.getFrameByName(a,p);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}getFrameByName(a,p){const v=this.windowsMainService.getWindowById(a.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${a}`);const S=v.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===p);if(!S)throw new Error(`Unknown frame: ${p}`);return S}};e.WebviewMainService=C,e.WebviewMainService=C=Pe([Z(0,M.IWindowsMainService)],C)}),define(ee[274],te([0,1,8,3,2]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends r.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:d,getActiveWindowId:a}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(C,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,I.createCancelablePromise)(()=>a()),(async()=>{try{const v=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:v}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ee[29],te([0,1,190,9,56,19,7,6,13]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=a;function p(i){return typeof i?.id=="string"&&!a(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=v;function S(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=w;function g(i){const n=i;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=g;class m{constructor(n,o,b,D,R){this._id=n,this._transient=b,this._configuration=D,this._ignorePathCasing=R,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,_.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function c(i){return new h({uri:i,index:0,name:(0,_.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=c,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(i,n){return _.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function u(i){let n;return M.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=u,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function l(i,n){return!P(i,n)&&!u(i)}e.isSavedWorkspace=l;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,_.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ee[59],te([0,1,15,8,55,46,2,84,4,21,165,91,6,5,24,29]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let g=class{constructor(h,c){this.logService=h,this.productService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,c){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},c)}pickFolder(h,c){return this.doPick({...h,pickFolders:!0,title:(0,p.localize)(1,null)},c)}pickFile(h,c){return this.doPick({...h,pickFiles:!0,title:(0,p.localize)(2,null)},c)}pickWorkspace(h,c){const P=(0,p.localize)(3,null),u=(0,_.mnemonicButtonLabel)((0,p.localize)(4,null)),t=w.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:P,filters:t,buttonLabel:u},c)}async doPick(h,c){const P={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(P.properties=void 0,h.pickFiles&&h.pickFolders&&(P.properties=["multiSelections","openDirectory","openFile","createDirectory"])),P.properties||(P.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&P.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(P,(c||I.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(h){if(h){let c=this.windowDialogQueues.get(h.id);return c||(c=new L.Queue,this.windowDialogQueues.set(h.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(h,c){return this.getWindowDialogQueue(c).queue(async()=>{const{options:P,buttonIndeces:u}=(0,v.massageMessageBoxOptions)(h,this.productService);let t;return c?t=await I.dialog.showMessageBox(c,P):t=await I.dialog.showMessageBox(P),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,c){const P=this.acquireFileDialogLock(h,c);if(!P)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(c).queue(async()=>{let u;return c?u=await I.dialog.showSaveDialog(c,h):u=await I.dialog.showSaveDialog(h),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,M.dispose)(P)}}normalizePath(h){return h&&d.isMacintosh&&(h=(0,C.normalizeNFC)(h)),h}normalizePaths(h){return h.map(c=>this.normalizePath(c))}async showOpenDialog(h,c){h.defaultPath&&(await a.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const P=this.acquireFileDialogLock(h,c);if(!P)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(c).queue(async()=>{let u;return c?u=await I.dialog.showOpenDialog(c,h):u=await I.dialog.showOpenDialog(h),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,M.dispose)(P)}}acquireFileDialogLock(h,c){if(!c)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",h);let P=this.windowFileDialogLocks.get(c.id);P||(P=new Set,this.windowFileDialogLocks.set(c.id,P));const u=(0,r.hash)(h);if(!P.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",h),P.add(u),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",h),P?.delete(u),P?.size===0&&this.windowFileDialogLocks.delete(c.id)})}};e.DialogMainService=g,e.DialogMainService=g=Pe([Z(0,f.ILogService),Z(1,y.IProductService)],g)}),define(ee[275],te([0,1,3,2,72,29]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(d,a){super(),this.logService=d,this.storageMainService=a,this.onDidChangeApplicationStorageEmitter=this._register(new I.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(a.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(d,a){this._register(I.Event.debounce(d.onDidChangeStorage,(p,v)=>(p?p.push(v):p=[v],p),M.STORAGE_CHANGE_DEBOUNCE_TIME)(p=>{p.length&&a.fire(this.serializeStorageChangeEvents(p,d))}))}serializeStorageChangeEvents(d,a){const p=new Map,v=new Set;return d.forEach(S=>{const f=a.get(S.key);typeof f=="string"?p.set(S.key,f):v.add(S.key)}),{changed:Array.from(p.entries()),deleted:Array.from(v.values())}}listen(d,a,p){switch(a){case"onDidChangeStorage":{const v=p.profile?(0,r.revive)(p.profile):void 0;if(!v)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(v.id);return S||(S=this._register(new I.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(v),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(v.id,S)),S.event}}throw new Error(`Event not found: ${a}`)}async call(d,a,p){const v=p.profile?(0,r.revive)(p.profile):void 0,S=(0,_.reviveIdentifier)(p.workspace),f=await this.withStorageInitialized(v,S);switch(a){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=p;if(y.insert)for(const[w,g]of y.insert)f.set(w,g);y.delete?.forEach(w=>f.delete(w));break}case"optimize":return f.optimize();case"isUsed":{const y=p.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${a}`)}}async withStorageInitialized(d,a){let p;a?p=this.storageMainService.workspaceStorage(a):d?p=this.storageMainService.profileStorage(d):p=this.storageMainService.applicationStorage;try{await p.init()}catch(v){this.logService.error(`StorageIPC#init: Unable to init ${a?"workspace":d?"profile":"application"} storage due to ${v}`)}return p}}e.StorageDatabaseChannel=M}),define(ee[41],te([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,26,12]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function P(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&M.URI.isUri(n.location)&&M.URI.isUri(n.globalStorageHome)&&M.URI.isUri(n.settingsResource)&&M.URI.isUri(n.keybindingsResource)&&M.URI.isUri(n.tasksResource)&&M.URI.isUri(n.snippetsHome)&&M.URI.isUri(n.extensionsResource))}e.isUserDataProfile=P,e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:M.URI.revive(i.location).with({scheme:n}),globalStorageHome:M.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:M.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:M.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:M.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:M.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:M.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:M.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=u;function t(i,n,o,b,D,R){return{id:i,name:n,location:o,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:R&&D?.useDefaultFlags?.globalState?R.globalStorageHome:(0,_.joinPath)(o,"globalStorage"),settingsResource:R&&D?.useDefaultFlags?.settings?R.settingsResource:(0,_.joinPath)(o,"settings.json"),keybindingsResource:R&&D?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,_.joinPath)(o,"keybindings.json"),tasksResource:R&&D?.useDefaultFlags?.tasks?R.tasksResource:(0,_.joinPath)(o,"tasks.json"),snippetsHome:R&&D?.useDefaultFlags?.snippets?R.snippetsHome:(0,_.joinPath)(o,"snippets"),extensionsResource:R&&D?.useDefaultFlags?.extensions?R.extensionsResource:(0,_.joinPath)(o,"extensions.json"),cacheHome:(0,_.joinPath)(b,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let l=class extends r.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,b,D){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=b,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,_.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,_.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),o=[n];if(this.enabled)try{for(const R of this.getStoredProfiles()){if(!R.name||!(0,h.isString)(R.name)||!R.location){this.logService.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(t((0,_.basename)(R.location),R.name,R.location,this.profilesCacheHome,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.logService.error(R)}const b=new f.ResourceMap,D=new Map;if(o.length)try{const R=this.getStoredProfileAssociations();if(R.workspaces)for(const[E,k]of Object.entries(R.workspaces)){const O=M.URI.parse(E),F=o.find(q=>q.id===k);F&&b.set(O,F)}if(R.emptyWindows)for(const[E,k]of Object.entries(R.emptyWindows)){const O=o.find(F=>F.id===k);O&&D.set(E,O)}}catch(R){this.logService.error(R)}this._profilesObject={profiles:o,workspaces:b,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,C.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",b=new RegExp(`${(0,m.escapeRegExpCharacters)(o)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const k=b.exec(E.name),O=k?parseInt(k[1]):0;D=O>D?O:D}const R=`${o} ${D+1}`;return this.createProfile((0,I.hash)((0,g.generateUuid)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,o,b){return this.createProfile((0,I.hash)((0,g.generateUuid)()).toString(16),n,o,b)}async createProfile(n,o,b,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const R=await this.doCreateProfile(n,o,b);return D&&await this.setProfileForWorkspace(D,R),R}async doCreateProfile(n,o,b){if(!(0,h.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(o);return D||(D=(async()=>{try{const R=this.profiles.find(O=>O.name===o||O.id===n);if(R)return R;const E=t(n,o,(0,_.joinPath)(this.profilesHome,n),this.profilesCacheHome,b,this.defaultProfile);await this.fileService.createFolder(E.location);const k=[];return this._onWillCreateProfile.fire({profile:E,join(O){k.push(O)}}),await w.Promises.settled(k),this.updateProfiles([E],[],[]),E}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,D)),D}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(D=>D.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);return b=t(b.id,o.name??b.name,b.location,this.profilesCacheHome,{shortName:o.shortName??b.shortName,icon:o.icon===null?void 0:o.icon??b.icon,transient:o.transient??b.isTransient,useDefaultFlags:o.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[b]),b}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(D=>D.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const b=[];this._onWillRemoveProfile.fire({profile:o,join(D){b.push(D)}});try{await Promise.allSettled(b)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(D){(0,a.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(D=>D.id===o.id);if(!b)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,b)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(b=>!this.uriIdentityService.extUri.isEqual(b.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return M.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,S.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,S.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,b){const D=[...this.profiles,...n],R=[];this.transientProfilesObject.profiles=[];for(let E of D)E.isDefault||o.some(k=>E.id===k.id)||(E=b.find(k=>E.id===k.id)??E,E.isTransient?this.transientProfilesObject.profiles.push(E):R.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.saveStoredProfiles(R),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,b)}triggerProfilesChanges(n,o,b){this._onDidChangeProfiles.fire({added:n,removed:o,updated:b,all:this.profiles})}updateWorkspaceAssociation(n,o,b){b=o?.isTransient?!0:b,b||this.updateWorkspaceAssociation(n,void 0,!0);const D=this.getWorkspace(n),R=b?this.transientProfilesObject:this.profilesObject;M.URI.isUri(D)?(R.workspaces.delete(D),o&&R.workspaces.set(D,o)):(R.emptyWindows.delete(D),o&&R.emptyWindows.set(D,o)),b||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[b,D]of this.profilesObject.workspaces.entries())n[b.toString()]=D.id;const o={};for(const[b,D]of this.profilesObject.emptyWindows.entries())o[b.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},b=this.createDefaultProfile();if(n.workspaces)for(const[R,E]of Object.entries(n.workspaces)){const k=M.URI.parse(E);o[R]=this.uriIdentityService.extUri.isEqual(k,b.location)?b.id:this.uriIdentityService.extUri.basename(k)}const D={};if(n.emptyWindows)for(const[R,E]of Object.entries(n.emptyWindows)){const k=M.URI.parse(E);D[R]=this.uriIdentityService.extUri.isEqual(k,b.location)?b.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:o,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=l,e.UserDataProfilesService=l=Pe([Z(0,d.IEnvironmentService),Z(1,a.IFileService),Z(2,y.IUriIdentityService),Z(3,v.ILogService)],l);class s extends l{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(ee[79],te([0,1,8,17,2,3,31,7,116,122,16,6,5,41,40,12,14,25]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class c extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=c,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let P=class extends r.Disposable{constructor(s,i,n,o,b,D){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=o,this.telemetryService=b,this.logService=D,this._onAddExtensions=this._register(new _.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new _.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new _.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new _.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new M.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i){const n=[],o=[];try{return await this.withProfileExtensions(i,b=>{const D=[];for(const R of b)s.some(([E])=>(0,a.areSameExtensions)(E.identifier,R.identifier)&&E.manifest.version!==R.version)?n.push(R):D.push(R);for(const[R,E]of s){const k=D.findIndex(F=>(0,a.areSameExtensions)(F.identifier,R.identifier)&&F.version===R.manifest.version),O={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:E};k===-1?(o.push(O),D.push(O)):D.splice(k,1,O)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),D}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),o}catch(b){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:b,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:b,profileLocation:i}),b}}async updateMetadata(s,i){const n=[];return await this.withProfileExtensions(i,o=>{const b=[];for(const D of o){const R=s.find(([E])=>(0,a.areSameExtensions)(E.identifier,D.identifier)&&E.manifest.version===D.version);R&&(D.metadata={...D.metadata,...R[1]},n.push(D)),b.push(D)}return b}),n}async removeExtensionFromProfile(s,i){const n=[];try{await this.withProfileExtensions(i,o=>{const b=[];for(const D of o)(0,a.areSameExtensions)(D.identifier,s.identifier)?n.push(D):b.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),b}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:o,profileLocation:i}),o}}async withProfileExtensions(s,i,n){return this.getResourceAccessQueue(s).queue(async()=>{let o=[],b;try{const D=await this.fileService.readFile(s);b=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,p.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(b=await this.migrateFromOldDefaultProfileExtensionsLocation()),!b&&n?.bailOutWhenFileNotFound)throw new c((0,g.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.reportAndThrowInvalidConentError(s);let D=!1;for(const R of b){u(R)||this.reportAndThrowInvalidConentError(s);let E;if((0,w.isString)(R.relativeLocation)&&R.relativeLocation)E=this.resolveExtensionLocation(R.relativeLocation);else if((0,w.isString)(R.location))E=this.resolveExtensionLocation(R.location),D=!0,R.relativeLocation=R.location,R.location=E.toJSON();else{E=C.URI.revive(R.location);const k=this.toRelativePath(E);k&&(D=!0,R.relativeLocation=k)}o.push({identifier:R.identifier,location:E,version:R.version,metadata:R.metadata})}D&&await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(b)))}if(i){o=i(o);const D=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.toRelativePath(R.location),metadata:R.metadata}));await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(D)))}return o})}reportAndThrowInvalidConentError(s){const i=new c(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(b){if((0,p.toFileOperationResult)(b)===1)return;throw b}this.logService.info("Migrating extensions from old default profile location",s.toString());let o;try{const b=JSON.parse(n);Array.isArray(b)&&b.every(D=>u(D))?o=b:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.logService.error(b)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(b){if((0,p.toFileOperationResult)(b)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw b}try{await this.fileService.del(s)}catch(b){(0,p.toFileOperationResult)(b)!==1&&this.logService.error(b)}try{await this.fileService.del(i)}catch(b){(0,p.toFileOperationResult)(b)!==1&&this.logService.error(b)}return o})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new I.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=P,e.AbstractExtensionsProfileScannerService=P=Pe([Z(1,p.IFileService),Z(2,f.IUserDataProfilesService),Z(3,y.IUriIdentityService),Z(4,m.ITelemetryService),Z(5,S.ILogService)],P);function u(l){return(0,w.isObject)(l)&&(0,d.isIExtensionIdentifier)(l.identifier)&&(t(l.location)||(0,w.isString)(l.location)&&l.location)&&((0,w.isUndefined)(l.relativeLocation)||(0,w.isString)(l.relativeLocation))&&l.version&&(0,w.isString)(l.version)}function t(l){return l?(0,w.isString)(l.path)&&(0,w.isString)(l.scheme):!1}}),define(ee[128],te([0,1,23,8,37,17,14,44,151,2,13,9,4,19,203,69,12,7,170,36,122,119,202,16,6,5,24,3,72,79,41,40,201]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n,o,b,D,R,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(se){function G(V,x){if(V===x)return!0;const W=Object.keys(V),U=new Set;for(const H of Object.keys(x))U.add(H);if(W.length!==U.size)return!1;for(const H of W){if(V[H]!==x[H])return!1;U.delete(H)}return U.size===0}se.equals=G})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let F=class extends a.Disposable{constructor(G,V,x,W,U,H,Q,ie,oe,N,A,T){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=V,this.extensionsControlLocation=x,this.currentProfile=W,this.userDataProfilesService=U,this.extensionsProfileScannerService=H,this.fileService=Q,this.logService=ie,this.environmentService=oe,this.productService=N,this.uriIdentityService=A,this.instantiationService=T,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,P.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,V,x){const[W,U]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(V)]),H=x?await this.scanExtensionsUnderDevelopment(G,[...W,...U]):[];return this.dedupExtensions(W,U,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const V=[];V.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),V.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[x,W]=await Promise.all(V);return this.applyScanOptions([...x,...W],0,G,!1)}async scanUserExtensions(G){const V=G.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",V);const x=this.uriIdentityService.extUri.isEqual(G.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(V,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,x),U=G.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let H;try{H=await U.scanExtensions(W)}catch(Q){if(Q instanceof D.ExtensionsProfileScanningError&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),H=await U.scanExtensions(W);else throw Q}return H=await this.applyScanOptions(H,1,G,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(G,V){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===p.Schemas.file).map(async W=>{const U=await this.createExtensionScannerInput(W,!1,1,!0,G.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(Q=>(Q.type=V.find(ie=>(0,P.areSameExtensions)(ie.identifier,Q.identifier))?.type??Q.type,this.extensionsScanner.validate(Q,U)))}))).flat();return this.applyScanOptions(x,"development",G,!0)}return[]}async scanExistingExtension(G,V,x){const W=await this.createExtensionScannerInput(G,!1,V,!0,x.language,!0,void 0),U=await this.extensionsScanner.scanExtension(W);return!U||!x.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(G,V,x){const W=await this.createExtensionScannerInput(G,!1,V,!0,x.language,!0,void 0),U=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(U,V,x,!0)}async scanMetadata(G){const V=(0,f.joinPath)(G,"package.json"),x=(await this.fileService.readFile(V)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(G,V){const x=(0,f.joinPath)(G,"package.json"),W=(await this.fileService.readFile(x)).value.toString(),U=JSON.parse(W);V.isMachineScoped=V.isMachineScoped||void 0,V.isBuiltin=V.isBuiltin||void 0,U.__metadata={...U.__metadata,...V},await this.fileService.writeFile((0,f.joinPath)(G,"package.json"),_.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof D.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw G}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.extensionsProfileScannerService.addExtensionsToProfile(G.map(V=>[V,V.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify([])))}catch(V){(0,l.toFileOperationResult)(V)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(V))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.logService.error(G)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(G,V,x,W){return x.includeAllVersions||(G=this.dedupExtensions(V===0?G:void 0,V===1?G:void 0,V==="development"?G:void 0,await this.getTargetPlatform(),W)),x.includeInvalid||(G=G.filter(U=>U.isValid)),G.sort((U,H)=>{const Q=v.basename(U.location.fsPath),ie=v.basename(H.location.fsPath);return Q<ie?-1:Q>ie?1:0})}dedupExtensions(G,V,x,W,U){const H=(ie,oe,N)=>{if(ie.isValid&&!oe.isValid)return!1;if(ie.isValid===oe.isValid){if(U&&y.gt(ie.manifest.version,oe.manifest.version))return this.logService.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(y.eq(ie.manifest.version,oe.manifest.version)){if(ie.type===0)return this.logService.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===W)return this.logService.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`):this.logService.debug(`Overwriting user extension ${ie.location.path} with ${oe.location.path}.`),!0},Q=new u.ExtensionIdentifierMap;return G?.forEach(ie=>{const oe=Q.get(ie.identifier.id);(!oe||H(oe,ie,!1))&&Q.set(ie.identifier.id,ie)}),V?.forEach(ie=>{const oe=Q.get(ie.identifier.id);if(!oe&&G&&ie.type===0){this.logService.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!oe||H(oe,ie,!1))&&Q.set(ie.identifier.id,ie)}),x?.forEach(ie=>{const oe=Q.get(ie.identifier.id);(!oe||H(oe,ie,!0))&&Q.set(ie.identifier.id,ie),Q.set(ie.identifier.id,ie)}),[...Q.values()]}async scanDefaultSystemExtensions(G,V){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0),U=await(G&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(G,V){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=V?await this.getBuiltInExtensionControl():{},U=[],H=m.URI.file(v.normalize(v.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of x){const oe=W[ie.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":U.push((0,f.joinPath)(H,ie.name));break;default:U.push(m.URI.file(oe));break}}const Q=await Promise.all(U.map(async ie=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ie,!1,0,!0,G,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Q.length),(0,I.coalesce)(Q)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,V,x,W,U,H,Q){const ie=await this.getTranslations(U??S.language),oe=await this.getMtime(G),N=V&&!this.uriIdentityService.extUri.isEqual(G,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,A=N?await this.getMtime(N):void 0;return new q(G,oe,N,A,V,Q,x,W,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,U,ie)}async getMtime(G){try{const V=await this.fileService.stat(G);if(typeof V.mtime=="number")return V.mtime}catch{}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=Pe([Z(4,R.IUserDataProfilesService),Z(5,D.IExtensionsProfileScannerService),Z(6,l.IFileService),Z(7,i.ILogService),Z(8,c.IEnvironmentService),Z(9,n.IProductService),Z(10,E.IUriIdentityService),Z(11,s.IInstantiationService)],F);class q{constructor(G,V,x,W,U,H,Q,ie,oe,N,A,T,$,B,z){this.location=G,this.mtime=V,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=W,this.profile=U,this.profileScanOptions=H,this.type=Q,this.excludeObsolete=ie,this.validate=oe,this.productVersion=N,this.productDate=A,this.productCommit=T,this.devMode=$,this.language=B,this.translations=z}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,V){return(0,f.isEqual)(G.location,V.location)&&G.mtime===V.mtime&&(0,f.isEqual)(G.applicationExtensionslocation,V.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&G.profile===V.profile&&r.equals(G.profileScanOptions,V.profileScanOptions)&&G.type===V.type&&G.excludeObsolete===V.excludeObsolete&&G.validate===V.validate&&G.productVersion===V.productVersion&&G.productDate===V.productDate&&G.productCommit===V.productCommit&&G.devMode===V.devMode&&G.language===V.language&&O.equals(G.translations,V.translations)}}e.ExtensionScannerInput=q;let ne=class extends a.Disposable{constructor(G,V,x,W,U){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=V,this.uriIdentityService=x,this.fileService=W,this.logService=U}async scanExtensions(G){const V=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let x={};if(G.excludeObsolete&&G.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(W)}catch{}return(0,g.isEmptyObject)(x)?V:V.filter(W=>!x[P.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(G){const V=await this.fileService.resolve(G.location);if(!V.children?.length)return[];const x=await Promise.all(V.children.map(async W=>{if(!W.isDirectory||G.type===1&&(0,f.basename)(W.resource).indexOf(".")===0)return null;const U=new q(W.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(U)}));return(0,I.coalesce)(x).sort((W,U)=>W.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(G){let V=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){V=V.filter(W=>!W.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,G);V.push(...x)}return V}async scanExtensionsFromProfileResource(G,V,x){const W=await this.extensionsProfileScannerService.scanProfileExtensions(G,x.profileScanOptions);if(!W.length)return[];const U=await Promise.all(W.map(async H=>{if(V(H)){const Q=new q(H.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(Q,H.metadata)}return null}));return(0,I.coalesce)(U)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,f.joinPath)(G.location,"package.json"))){const V=await this.scanExtension(G);return V?[V]:[]}else return await this.scanExtensions(G)}catch(V){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,M.getErrorMessage)(V)),[]}}async scanExtension(G,V){try{let x=await this.scanExtensionManifest(G.location);if(x){x.publisher||(x.publisher=u.UNDEFINED_PUBLISHER),V=V??x.__metadata,delete x.__metadata;const W=(0,P.getGalleryExtensionId)(x.publisher,x.name),U=V?.id?{id:W,uuid:V.id}:{id:W},H=V?.isSystem?0:G.type,Q=H===0||!!V?.isBuiltin;x=await this.translateManifest(G.location,x,q.createNlsConfiguration(G));const ie={type:H,identifier:U,manifest:x,location:G.location,isBuiltin:Q,targetPlatform:V?.targetPlatform??"undefined",metadata:V,isValid:!0,validations:[]};return G.validate?this.validate(ie,G):ie}}catch(x){G.type!==0&&this.logService.error(x)}return null}validate(G,V){let x=!0;const W=(0,t.validateExtensionManifest)(V.productVersion,V.productDate,V.location,G.manifest,G.isBuiltin);for(const[U,H]of W)U===w.default.Error&&(x=!1,this.logService.error(this.formatMessage(V.location,H)));return G.isValid=x,G.validations=W,G}async scanExtensionManifest(G){const V=(0,f.joinPath)(G,"package.json");let x;try{x=(await this.fileService.readFile(V)).value.toString()}catch(U){return(0,l.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(G,(0,h.localize)(0,null,V.path,U.message))),null}let W;try{W=JSON.parse(x)}catch{const H=[];(0,C.parse)(x,H);for(const Q of H)this.logService.error(this.formatMessage(G,(0,h.localize)(1,null,V.path,Q.offset,Q.length,(0,d.getParseErrorMessage)(Q.error))));return null}return(0,C.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(G,(0,h.localize)(2,null,V.path))),null):W}async translateManifest(G,V,x){const W=await this.getLocalizedMessages(G,V,x);if(W)try{const U=[],H=await this.resolveOriginalMessageBundle(W.default,U);if(U.length>0)return U.forEach(ie=>{this.logService.error(this.formatMessage(G,(0,h.localize)(3,null,W.default?.path,(0,d.getParseErrorMessage)(ie.error))))}),V;if((0,C.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(G,(0,h.localize)(4,null,W.default?.path))),V;const Q=W.values||Object.create(null);return(0,k.localizeManifest)(this.logService,V,Q,H)}catch{}return V}async getLocalizedMessages(G,V,x){const W=(0,f.joinPath)(G,"package.nls.json"),U=(oe,N)=>{N.forEach(A=>{this.logService.error(this.formatMessage(G,(0,h.localize)(5,null,oe?.path,(0,d.getParseErrorMessage)(A.error))))})},H=oe=>{this.logService.error(this.formatMessage(G,(0,h.localize)(6,null,oe?.path)))},Q=`${V.publisher}.${V.name}`,ie=x.translations[Q];if(ie)try{const oe=m.URI.file(ie),N=(await this.fileService.readFile(oe)).value.toString(),A=[],T=(0,C.parse)(N,A);return A.length>0?(U(oe,A),{values:void 0,default:W}):(0,C.getNodeType)(T)!=="object"?(H(oe),{values:void 0,default:W}):{values:T.contents?T.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let N;try{N=await this.findMessageBundles(G,x)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const A=(await this.fileService.readFile(N.localized)).value.toString(),T=[],$=(0,C.parse)(A,T);return T.length>0?(U(N.localized,T),{values:void 0,default:N.original}):(0,C.getNodeType)($)!=="object"?(H(N.localized),{values:void 0,default:N.original}):{values:$,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(G,V){if(G)try{const x=(await this.fileService.readFile(G)).value.toString();return(0,C.parse)(x,V)}catch{}}findMessageBundles(G,V){return new Promise((x,W)=>{const U=H=>{const Q=(0,f.joinPath)(G,`package.nls.${H}.json`);this.fileService.exists(Q).then(ie=>{ie&&x({localized:Q,original:(0,f.joinPath)(G,"package.nls.json")});const oe=H.lastIndexOf("-");oe===-1?x({localized:(0,f.joinPath)(G,"package.nls.json"),original:null}):(H=H.substring(0,oe),U(H))})};if(V.devMode||V.pseudo||!V.language)return x({localized:(0,f.joinPath)(G,"package.nls.json"),original:null});U(V.language)})}formatMessage(G,V){return`[${G.path}]: ${V}`}};ne=Pe([Z(1,D.IExtensionsProfileScannerService),Z(2,E.IUriIdentityService),Z(3,l.IFileService),Z(4,i.ILogService)],ne);let J=class extends ne{constructor(G,V,x,W,U,H,Q){super(V,W,U,H,Q),this.currentProfile=G,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const V=this.getCacheFile(G),x=await this.readExtensionCache(V);if(this.input=G,x&&x.input&&q.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",G.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(U=>(U.location=m.URI.revive(U.location),U));const W=await super.scanExtensions(G);return await this.writeExtensionCache(V,{input:G,result:W}),W}async readExtensionCache(G){try{const V=await this.fileService.readFile(G),x=JSON.parse(V.value.toString());return{result:x.result,input:(0,b.revive)(x.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",G.path,(0,M.getErrorMessage)(V))}return null}async writeExtensionCache(G,V){try{await this.fileService.writeFile(G,_.VSBuffer.fromString(JSON.stringify(V)))}catch(x){this.logService.debug("Error while writing the extension cache file:",G.path,(0,M.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const G=this.getCacheFile(this.input),V=await this.readExtensionCache(G);if(!V)return;const x=V.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(W,x))try{this.logService.info("Invalidating Cache",x,W),await this.fileService.del(G),this._onDidChangeCache.fire()}catch(U){this.logService.error(U)}}getCacheFile(G){const V=this.getProfile(G);return this.uriIdentityService.extUri.joinPath(V.cacheHome,G.type===0?u.BUILTIN_MANIFEST_CACHE_FILE:u.USER_MANIFEST_CACHE_FILE)}getProfile(G){return G.type===0?this.userDataProfilesService.defaultProfile:G.profile?this.uriIdentityService.extUri.isEqual(G.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(V=>this.uriIdentityService.extUri.isEqual(G.location,V.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};J=Pe([Z(2,R.IUserDataProfilesService),Z(3,D.IExtensionsProfileScannerService),Z(4,E.IUriIdentityService),Z(5,l.IFileService),Z(6,i.ILogService)],J);function ce(se,G){const V=(0,P.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:V,identifier:new u.ExtensionIdentifier(V),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:G,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=ce;class re extends F{constructor(G,V,x,W,U,H,Q,ie,oe,N,A,T){super(G,V,(0,f.joinPath)(x,".vscode-oss-dev","extensions","control.json"),W,U,H,Q,ie,oe,N,A,T),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const $=await this.fileService.readFile(m.URI.file(S.translationsConfigFile));return JSON.parse($.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=re}),define(ee[276],te([0,1,5,41,40,25,79,16,36,7]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=class extends M.AbstractExtensionsProfileScannerService{constructor(S,f,y,w,g,m){super(a.URI.file(S.extensionsPath),f,y,w,g,m)}};e.ExtensionsProfileScannerService=p,e.ExtensionsProfileScannerService=p=Pe([Z(0,d.INativeEnvironmentService),Z(1,C.IFileService),Z(2,L.IUserDataProfilesService),Z(3,r.IUriIdentityService),Z(4,_.ITelemetryService),Z(5,I.ILogService)],p)}),define(ee[277],te([0,1,7,36,79,128,16,6,5,24,40,41]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends _.NativeExtensionsScannerService{constructor(y,w,g,m,h,c,P,u){super(I.URI.file(h.builtinExtensionsPath),I.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,w,g,m,h,c,P,u)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=Pe([Z(0,v.IUserDataProfilesService),Z(1,r.IExtensionsProfileScannerService),Z(2,M.IFileService),Z(3,d.ILogService),Z(4,L.INativeEnvironmentService),Z(5,a.IProductService),Z(6,p.IUriIdentityService),Z(7,C.IInstantiationService)],S)}),define(ee[278],te([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends L.Disposable{constructor(g,m,h){super(),this.environmentService=g,this.logService=h,this.validRoots=C.TernarySearchTree.forPaths(!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(g.appRoot),this.addValidFileRoot(g.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:r.Schemas.file}).fsPath),this.addValidFileRoot(g.workspaceStorageHome.with({scheme:r.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:g}=I.session;g.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(m,h)=>this.handleResourceRequest(m,h)),g.protocol.interceptFileProtocol(r.Schemas.file,(m,h)=>this.handleFileRequest(m,h)),this._register((0,L.toDisposable)(()=>{g.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(g){const m=(0,_.normalize)(g);return this.validRoots.get(m)?L.Disposable.None:(this.validRoots.set(m,!0),(0,L.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(g,m){const h=d.URI.parse(g.url);return this.logService.error(`Refused to load resource ${h.fsPath} from ${r.Schemas.file}: protocol (original URL: ${g.url})`),m({error:-3})}handleResourceRequest(g,m){const h=this.requestToNormalizedFilePath(g);let c;return this.environmentService.crossOriginIsolated&&((0,_.basename)(h)==="workbench.html"||(0,_.basename)(h)==="workbench-dev.html"?c=r.COI.CoopAndCoep:c=r.COI.getHeadersFromQuery(g.url)),this.validRoots.findSubstr(h)?m({path:h,headers:c}):this.validExtensions.has((0,_.extname)(h).toLowerCase())?m({path:h}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),m({error:-3}))}requestToNormalizedFilePath(g){const m=d.URI.parse(g.url),h=r.FileAccess.uriToFileUri(m);return(0,_.normalize)(h.fsPath)}createIPCObjectUrl(){let g;const m=d.URI.from({scheme:"vscode",path:(0,a.generateUuid)()}),h=m.toString(),c=async()=>g;return p.validatedIpcMain.handle(h,c),this.logService.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:m,update:P=>g=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${h}.`),p.validatedIpcMain.removeHandler(h)}}}};e.ProtocolMainService=y,e.ProtocolMainService=y=Pe([Z(0,v.INativeEnvironmentService),Z(1,f.IUserDataProfilesService),Z(2,S.ILogService)],y)}),define(ee[96],te([0,1,8,3,2,64,12,111,6,41]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var p;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var v;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var S;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function f(h){const c=h.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=f;class y extends r.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(c={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(c,P,u){return L.Event.filter(this._onDidChangeValue.event,t=>t.scope===c&&(P===void 0||t.key===P),u)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,P){const{key:u,external:t}=P;if(u===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:u,target:this.getKeyTargets(c)[u],external:t})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,P,u){return this.getStorage(P)?.get(c,u)}getBoolean(c,P,u){return this.getStorage(P)?.getBoolean(c,u)}getNumber(c,P,u){return this.getStorage(P)?.getNumber(c,u)}getObject(c,P,u){return this.getStorage(P)?.getObject(c,u)}storeAll(c,P){this.withPausedEmitters(()=>{for(const u of c)this.store(u.key,u.value,u.scope,u.target,P)})}store(c,P,u,t,l=!1){if((0,M.isUndefinedOrNull)(P)){this.remove(c,u,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,u,t),this.getStorage(u)?.set(c,P,l)})}remove(c,P,u=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(c,P,void 0),this.getStorage(P)?.delete(c,u)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,P){const u=[],t=this.getKeyTargets(c);for(const l of Object.keys(t))t[l]===P&&u.push(l);return u}updateKeyTarget(c,P,u,t=!1){const l=this.getKeyTargets(P);typeof u=="number"?l[c]!==u&&(l[c]=u,this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(l),t)):typeof l[c]=="number"&&(delete l[c],this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(l),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const P=this.getStorage(c);return P?f(P):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=p.NONE){this._onWillSaveState.fire({reason:c});const P=this.getStorage(-1),u=this.getStorage(0),t=this.getStorage(1);switch(c){case p.NONE:await I.Promises.settled([P?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await I.Promises.settled([P?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,P=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return m(c,P,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(c){return await this.flush(),this.getStorage(c)?.optimize()}async switch(c,P){return this.emitWillSaveState(p.NONE),(0,a.isUserDataProfile)(c)?this.switchToProfile(c,P):this.switchToWorkspace(c,P)}canSwitchProfile(c,P){return!(c.id===P.id||w(P)&&w(c))}switchData(c,P,u){this.withPausedEmitters(()=>{const t=new Set;for(const[l,s]of c)t.add(l),P.get(l)!==s&&this.emitDidChangeValue(u,{key:l,external:!0});for(const[l]of P.items)t.has(l)||this.emitDidChangeValue(u,{key:l,external:!0})})}}e.AbstractStorageService=y;function w(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=w;class g extends y{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(c){return!1}}e.InMemoryStorageService=g;async function m(h,c,P,u,t,l){const s=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,n=new Map;h.forEach((O,F)=>{i.set(F,O),n.set(F,s(O))});const o=new Map,b=new Map;c.forEach((O,F)=>{o.set(F,O),b.set(F,s(O))});const D=new Map,R=new Map;P.forEach((O,F)=>{D.set(F,O),R.set(F,s(O))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(i.forEach((O,F)=>{E.push({key:F,value:O})}),console.table(E),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const O=[];o.forEach((F,q)=>{O.push({key:q,value:F})}),console.table(O),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${l})`);const k=[];D.forEach((O,F)=>{k.push({key:F,value:O})}),console.table(k),console.groupEnd(),console.log(R)}e.logStorage=m}),define(ee[279],te([0,1,23,8,3,2,9,68,7,21,111,159,5,96,25,29,13]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class m extends _.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,i){super(),this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=p.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===p.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(s);const i=s.getBoolean(f.IS_NEW_KEY);i===void 0?s.set(f.IS_NEW_KEY,!0):i&&s.set(f.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=p.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new C.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const i=(0,I.top)(Array.from(this._storage.items.entries()).map(([o,b])=>({key:o,length:b.length})),(o,b)=>b.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(d.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=p.StorageState.Closed,await this._storage.close()}}class h extends m{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,h.STORAGE_NAME)}constructor(s,i,n,o){super(n,o),this.profile=s,this.options=i}async doCreate(){return new p.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class c extends h{constructor(s,i,n,o){super(s,i,n,o)}}e.ProfileStorageMain=c;class P extends h{constructor(s,i,n,o){super(i.defaultProfile,s,n,o)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(y.firstSessionDateStorageKey,void 0)===void 0&&s.set(y.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(y.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();s.set(y.lastSessionDateStorageKey,typeof n>"u"?null:n),s.set(y.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=P;class u extends m{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}constructor(s,i,n,o,b){super(n,b),this.workspace=s,this.options=i,this.environmentService=o}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new p.Storage(new v.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.workspace.id),i=(0,M.join)(s,u.WORKSPACE_STORAGE_NAME);return await a.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await a.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,M.join)(s,u.WORKSPACE_META_NAME);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u;class t extends m{get path(){}async doCreate(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(ee[280],te([0,1,3,2,96]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class _ extends L.Disposable{constructor(C,d,a){super(),this.storageMainService=C,this.userDataProfilesService=d,this.logService=a;const p=this._register(new L.MutableDisposable);this._onDidChange=this._register(new I.Emitter({onWillAddFirstListener:()=>p.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>p.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const C=new L.DisposableStore;return C.add(I.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(d,a)=>(d?d.push(a.key):d=[a.key],d),100)(d=>this.onDidChangeApplicationStorage(d))),C.add(I.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(d,a)=>{d||(d=new Map);let p=d.get(a.profile.id);return p||d.set(a.profile.id,p={profile:a.profile,keys:[],storage:a.storage}),p.keys.push(a.key),d},100)(d=>this.onDidChangeProfileStorage(d))),C}onDidChangeApplicationStorage(C){const d=C.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],a=[];if(C=C.filter(p=>p!==r.TARGET_KEY),C.length){const p=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);a.push({profile:this.userDataProfilesService.defaultProfile,changes:C.map(v=>({key:v,scope:0,target:p[v]}))})}this.triggerEvents(d,a)}onDidChangeProfileStorage(C){const d=[],a=new Map;for(const[p,v]of C.entries()){v.keys.includes(r.TARGET_KEY)&&d.push(v.profile);const S=v.keys.filter(f=>f!==r.TARGET_KEY);if(S.length){const f=(0,r.loadKeyTargets)(v.storage.storage);a.set(p,{profile:v.profile,changes:S.map(y=>({key:y,scope:0,target:f[y]}))})}}this.triggerEvents(d,[...a.values()])}triggerEvents(C,d){(C.length||d.length)&&this._onDidChange.fire({valueChanges:d,targetChanges:C})}listen(C,d,a){switch(d){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${d}`)}async call(C,d){throw new Error(`Call not found: ${d}`)}}e.ProfileStorageChangesListenerChannel=_}),define(ee[281],te([0,1,7,36,16,5,34,40,41,12,120]),function(K,e,I,L,r,_,M,C,d,a,p){"use strict";var v,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let f=class extends d.UserDataProfilesService{static{v=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(m,h,c,P,u){super(c,P,h,u),this.stateReadonlyService=m,this.nativeEnvironmentService=c}getStoredProfiles(){return this.stateReadonlyService.getItem(v.PROFILES_KEY,[]).map(h=>({...h,location:(0,a.isString)(h.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,h.location):I.URI.revive(h.location)}))}getStoredProfileAssociations(){const m=this.stateReadonlyService.getItem(v.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(v.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?m:this.migrateStoredProfileAssociations(m)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(I.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=f,e.UserDataProfilesReadonlyService=f=v=Pe([Z(0,M.IStateReadService),Z(1,C.IUriIdentityService),Z(2,L.INativeEnvironmentService),Z(3,r.IFileService),Z(4,_.ILogService)],f);let y=S=class extends f{constructor(m,h,c,P,u){super(m,h,c,P,u),this.stateService=m}saveStoredProfiles(m){m.length?this.stateService.setItem(S.PROFILES_KEY,m.map(h=>({...h,location:this.uriIdentityService.extUri.basename(h.location)}))):this.stateService.removeItem(S.PROFILES_KEY)}getStoredProfiles(){const m=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(m),this.stateService.setItem("userDataProfilesMigration",!0)),m}saveStoredProfileAssociations(m){m.emptyWindows||m.workspaces?this.stateService.setItem(S.PROFILE_ASSOCIATIONS_KEY,m):this.stateService.removeItem(S.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",h=this.stateService.getItem(m,void 0);if(h){this.stateService.removeItem(m);const P=h.reduce((u,{workspace:t,profile:l})=>(u[I.URI.revive(t).toString()]=I.URI.revive(l).toString(),u),{});this.stateService.setItem(S.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}const c=super.getStoredProfileAssociations();return this.stateService.getItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(c),this.stateService.setItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),c}};e.UserDataProfilesService=y,e.UserDataProfilesService=y=S=Pe([Z(0,M.IStateService),Z(1,C.IUriIdentityService),Z(2,L.INativeEnvironmentService),Z(3,r.IFileService),Z(4,_.ILogService)],y);let w=class extends y{constructor(m,h,c,P){super(new p.StateService(0,h,P,c),m,h,c,P)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=w,e.ServerUserDataProfilesService=w=Pe([Z(0,C.IUriIdentityService),Z(1,L.INativeEnvironmentService),Z(2,r.IFileService),Z(3,_.ILogService)],w)}),define(ee[52],te([0,1,36,16,6,5,40,41,281,34]),function(K,e,I,L,r,_,M,C,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(C.IUserDataProfilesService);let p=class extends d.UserDataProfilesService{constructor(S,f,y,w,g){super(S,f,y,w,g)}getAssociatedEmptyWindows(){const S=[];for(const f of this.profilesObject.emptyWindows.keys())S.push({id:f});return S}};e.UserDataProfilesMainService=p,e.UserDataProfilesMainService=p=Pe([Z(0,a.IStateService),Z(1,M.IUriIdentityService),Z(2,I.INativeEnvironmentService),Z(3,L.IFileService),Z(4,_.ILogService)],p)}),define(ee[129],te([0,1,19,7,29]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function _(d,a,p){for(const S of d){const f=S.openedWorkspace;if((0,r.isWorkspaceIdentifier)(f)){const y=await p(f);if(y){if(y.folders.some(w=>I.extUriBiasedIgnorePathCase.isEqualOrParent(a,w.uri)))return S}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(a,f.configPath))return S}}const v=d.filter(S=>(0,r.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(a,S.openedWorkspace.uri));if(v.length)return v.sort((S,f)=>-(S.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=_;function M(d,a){for(const p of d)if((0,r.isWorkspaceIdentifier)(p.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,a)||(0,r.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,a))return p}e.findWindowOnWorkspaceOrFolder=M;function C(d,a){const p=v=>a.some(S=>I.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(v)));for(const v of d)if(v.config?.extensionDevelopmentPath?.some(S=>p(S)))return v}e.findWindowOnExtensionDevelopmentPath=C}),define(ee[97],te([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function y(R){return R.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function w(R){return R.hasOwnProperty("folderUri")}e.isRecentFolder=w;function g(R){return R.hasOwnProperty("fileUri")}e.isRecentFile=g;function m(R){return h(R)||c(R)}e.isStoredWorkspaceFolder=m;function h(R){const E=R;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function c(R){const E=R;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function P(R,E,k,O,F){if(R.scheme!==O.scheme)return{name:k,uri:R.toString(!0)};let q=E?void 0:F.relativePath(O,R);if(q!==void 0)q.length===0?q=".":d.isWindows&&(q=u(q));else if(R.scheme===M.Schemas.file)q=R.fsPath,d.isWindows&&(q=u(q));else if(F.isEqualAuthority(R.authority,O.authority))q=R.path;else return{name:k,uri:R.toString(!0)};return{name:k,path:q}}e.getStoredWorkspaceFolder=P;function u(R){return R=(0,_.normalizeDriveLetter)(R),(0,I.isUNC)(R)||(R=(0,I.toSlashes)(R)),R}function t(R,E,k){const O=[],F=new Set,q=k.dirname(E);for(const ne of R){let J;if(h(ne))ne.path&&(J=k.resolvePath(q,ne.path));else if(c(ne))try{J=p.URI.parse(ne.uri),J.path[0]!==C.posix.sep&&(J=J.with({path:C.posix.sep+J.path}))}catch(ce){console.warn(ce)}if(J){const ce=k.getComparisonKey(J);if(!F.has(ce)){F.add(ce);const re=ne.name||k.basenameOrAuthority(J);O.push(new f.WorkspaceFolder({uri:J,name:re,index:O.length},ne))}}}return O}e.toWorkspaceFolders=t;function l(R,E,k,O,F){const q=s(E,R),ne=F.dirname(E),J=F.dirname(O),ce=[];for(const V of q.folders){const x=h(V)?F.resolvePath(ne,V.path):p.URI.parse(V.uri);let W;k?W=!1:W=!h(V)||(0,C.isAbsolute)(V.path),ce.push(P(x,W,V.name,J,F))}const re={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},se=r.setProperty(R,["folders"],ce,re);let G=r.applyEdits(R,se);return(0,a.isEqualAuthority)(q.remoteAuthority,(0,S.getRemoteAuthority)(O))&&(G=r.applyEdits(G,r.removeProperty(G,["remoteAuthority"],re))),G}e.rewriteWorkspaceFileForNewLocation=l;function s(R,E){const k=L.parse(E);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(O=>m(O));else throw new Error(`${R} looks like an invalid workspace file.`);return k}function i(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function n(R){return typeof R.folderUri=="string"}function o(R){return typeof R.fileUri=="string"}function b(R,E){const k={workspaces:[],files:[]};if(R){const O=function(q,ne){for(let J=0;J<q.length;J++)try{ne(q[J],J)}catch(ce){E.warn(`Error restoring recent entry ${JSON.stringify(q[J])}: ${ce.toString()}. Skip entry.`)}},F=R;Array.isArray(F.entries)&&O(F.entries,q=>{const ne=q.label,J=q.remoteAuthority;i(q)?k.workspaces.push({label:ne,remoteAuthority:J,workspace:{id:q.workspace.id,configPath:p.URI.parse(q.workspace.configPath)}}):n(q)?k.workspaces.push({label:ne,remoteAuthority:J,folderUri:p.URI.parse(q.folderUri)}):o(q)&&k.files.push({label:ne,remoteAuthority:J,fileUri:p.URI.parse(q.fileUri)})})}return k}e.restoreRecentlyOpened=b;function D(R){const E={entries:[]};for(const k of R.workspaces)w(k)?E.entries.push({folderUri:k.folderUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority}):E.entries.push({workspace:{id:k.workspace.id,configPath:k.workspace.configPath.toString()},label:k.label,remoteAuthority:k.remoteAuthority});for(const k of R.files)E.entries.push({fileUri:k.fileUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority});return E}e.toStoreData=D}),define(ee[98],te([0,1,85,13,4,19]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(a){function p(){let v=a.scheme===L.Schemas.file?(0,_.originalFSPath)(a):a.toString();return r.isLinux||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:p(),configPath:a}}e.getWorkspaceIdentifier=M;function C(a,p){function v(){if(a.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(a.toString()).digest("hex");if(!p)return;let f;return r.isLinux?f=p.ino:r.isMacintosh?f=p.birthtime.getTime():r.isWindows&&(typeof p.birthtimeMs=="number"?f=Math.floor(p.birthtimeMs):f=p.birthtime.getTime()),(0,I.createHash)("md5").update(a.fsPath).update(f?String(f):"").digest("hex")}const S=v();if(typeof S=="string")return{id:S,uri:a}}e.getSingleFolderWorkspaceIdentifier=C;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=d}),define(ee[99],te([0,1,85,87,27,282,17,14,3,2,9,4,32,42,109]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(E,k){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,k)}constructor(E,k=""){this._canWrite=!0,this.debugLabel=k,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,C.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(E){const k=O=>{this.traceSocketEvent("read",O),E(M.VSBuffer.wrap(O))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(E){const k=O=>{E({type:0,hadError:O,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(E){const k=()=>{E()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(E){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,C.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,C.onUnexpectedError)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=w;var g;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var m;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(m||(m={}));class h extends a.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(E,k){this.socket.traceSocketEvent(E,k)}constructor(E,k,O,F){super(),this._onData=this._register(new d.Emitter),this._onClose=this._register(new d.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new c(this,k,O,F,this._onData,(q,ne)=>this._write(q,ne))),this._register(this._flowManager.onError(q=>{console.error(q),(0,C.onUnexpectedError)(q),this._onClose.fire({type:0,hadError:!0,error:q})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(async q=>{this._flowManager.isProcessingReadQueue()&&await d.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(q)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let k=0;for(;k<E.byteLength;)this._flowManager.writeMessage(E.slice(k,Math.min(k+262144,E.byteLength))),k+=262144}_write(E,k){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let O=2;E.byteLength<126?O+=0:E.byteLength<2**16?O+=2:O+=8;const F=M.VSBuffer.alloc(O);if(k?F.writeUInt8(194,0):F.writeUInt8(130,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let q=1;F.writeUInt8(E.byteLength>>>8&255,++q),F.writeUInt8(E.byteLength>>>0&255,++q)}else{F.writeUInt8(127,1);let q=1;F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(E.byteLength>>>24&255,++q),F.writeUInt8(E.byteLength>>>16&255,++q),F.writeUInt8(E.byteLength>>>8&255,++q),F.writeUInt8(E.byteLength>>>0&255,++q)}this.socket.write(M.VSBuffer.concat([F,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),O=k.readUInt8(0),F=(O&128)>>>7,q=(O&64)>>>6,ne=k.readUInt8(1),J=(ne&128)>>>7,ce=ne&127;this._state.state=2,this._state.readLen=2+(J?4:0)+(ce===126?2:0)+(ce===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!q),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),O=k.readUInt8(1),F=(O&128)>>>7;let q=O&127,ne=1;q===126?q=k.readUInt8(++ne)*2**8+k.readUInt8(++ne):q===127&&(q=k.readUInt8(++ne)*0+k.readUInt8(++ne)*0+k.readUInt8(++ne)*0+k.readUInt8(++ne)*0+k.readUInt8(++ne)*2**24+k.readUInt8(++ne)*2**16+k.readUInt8(++ne)*2**8+k.readUInt8(++ne));let J=0;F&&(J=k.readUInt8(++ne)*2**24+k.readUInt8(++ne)*2**16+k.readUInt8(++ne)*2**8+k.readUInt8(++ne)),this._state.state=3,this._state.readLen=q,this._state.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(k,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await d.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class c extends a.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(E,k,O,F,q,ne){super(),this._tracer=E,this._onData=q,this._writeFn=ne,this._onError=this._register(new d.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new d.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new d.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,k?(this._zlibInflateStream=this._register(new P(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(J=>this._onError.fire(J))),this._register(this._zlibDeflateStream.onError(J=>this._onError.fire(J)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(E){this._writeQueue.push(E),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const E=this._writeQueue.shift();if(this._zlibDeflateStream){const k=await this._deflateMessage(this._zlibDeflateStream,E);this._writeFn(k,!0)}else this._writeFn(E,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(E,k){return new Promise((O,F)=>{E.write(k),E.flush(q=>O(q))})}acceptFrame(E,k,O){this._readQueue.push({data:E,isCompressed:k,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const E=this._readQueue.shift();if(this._zlibInflateStream&&E.isCompressed){const k=await this._inflateFrame(this._zlibInflateStream,E.data,E.isLastFrameOfMessage);this._onData.fire(k)}else this._onData.fire(E.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(E,k,O){return new Promise((F,q)=>{E.write(k),O&&E.write(M.VSBuffer.fromByteArray([0,0,255,255])),E.flush(ne=>F(ne))})}}class P extends a.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}constructor(E,k,O,F){super(),this._tracer=E,this._recordInflateBytes=k,this._onError=this._register(new d.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,_.createInflateRaw)(F),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent("zlibInflateData",q),this._pendingInflateData.push(M.VSBuffer.wrap(q))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(E){this._recordInflateBytes&&this._recordedInflateBytes.push(E.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",E),this._zlibInflate.write(E.buffer)}flush(E){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const k=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,E(k)})}}class u extends a.Disposable{constructor(E,k){super(),this._tracer=E,this._onError=this._register(new d.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,_.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(M.VSBuffer.wrap(O))})}write(E){this._tracer.traceSocketEvent("zlibDeflateWrite",E.buffer),this._zlibDeflate.write(E.buffer)}flush(E){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let k=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.byteLength-4),E(k)})}}function t(R,E){if(E===0)return;const k=R.byteLength>>>2;for(let ce=0;ce<k;ce++){const re=R.readUInt32BE(ce*4);R.writeUInt32BE(re^E,ce*4)}const O=k*4,F=R.byteLength-O,q=E>>>24&255,ne=E>>>16&255,J=E>>>8&255;F>=1&&R.writeUInt8(R.readUInt8(O)^q,O),F>=2&&R.writeUInt8(R.readUInt8(O+1)^ne,O+1),F>=3&&R.writeUInt8(R.readUInt8(O+2)^J,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const R=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const E=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),k=(0,p.join)(E,`vscode-ipc-${R}.sock`);return n(k),k}e.createRandomIPCHandle=s;function i(R,E,k){const O=(0,I.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${k}-${E}-sock`;const F=k.substr(0,4),q=E.substr(0,6),ne=O.substr(0,8);let J;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?J=(0,p.join)(e.XDG_RUNTIME_DIR,`vscode-${ne}-${F}-${q}.sock`):J=(0,p.join)(R,`${F}-${q}.sock`),n(J),J}e.createStaticIPCHandle=i;function n(R){const E=l[v.platform];typeof E=="number"&&R.length>=E&&console.warn(`WARNING: IPC handle "${R}" is longer than ${E} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{static toClientConnectionEvent(E){const k=d.Event.fromNodeEventEmitter(E,"connection");return d.Event.map(k,O=>({protocol:new y.Protocol(new w(O,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(O,"close"))}))}constructor(E){super(o.toClientConnectionEvent(E)),this.server=E}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function b(R){return new Promise((E,k)=>{const O=(0,L.createServer)();O.on("error",k),O.listen(R,()=>{O.removeListener("error",k),E(new o(O))})})}e.serve=b;function D(R,E){return new Promise((k,O)=>{const F=(0,L.createConnection)(R,()=>{F.removeListener("error",O),k(y.Client.fromSocket(new w(F,`ipc-client${E}`),E))});F.once("error",O)})}e.connect=D}),define(ee[28],te([0,1,54,9,4,99,36,89,6]),function(K,e,I,L,r,_,M,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,d.refineServiceDecorator)(M.IEnvironmentService);class a extends C.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,_.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.isLinux){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const S=v.slice(0,-17);if(this._snapEnv[S])continue;process.env[S]&&(this._snapEnv[S]=process.env[S]),process.env[v]?process.env[S]=process.env[v]:delete process.env[S]}}}restoreSnapExportedVariables(){if(r.isLinux)for(const v in this._snapEnv)process.env[v]=this._snapEnv[v],delete this._snapEnv[v]}}e.EnvironmentMainService=a,Pe([I.memoize],a.prototype,"cachedLanguagesPath",null),Pe([I.memoize],a.prototype,"backupHome",null),Pe([I.memoize],a.prototype,"mainIPCHandle",null),Pe([I.memoize],a.prototype,"mainLockfile",null),Pe([I.memoize],a.prototype,"disableUpdates",null),Pe([I.memoize],a.prototype,"crossOriginIsolated",null),Pe([I.memoize],a.prototype,"codeCachePath",null),Pe([I.memoize],a.prototype,"useCodeCache",null)}),define(ee[283],te([0,1,85,33,13,9,4,19,21,194,18,28,34,16,5,193,29,98]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let c=class{static{h=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(u,t,l,s){this.environmentMainService=u,this.configurationService=t,this.logService=l,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=C.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,L.isEqual)(i,n,!M.isLinux)}}async initialize(){const u=this.stateService.getItem(h.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWindows),this.workspaces=await this.validateWorkspaces((0,a.deserializeWorkspaceInfos)(u)),this.folders=await this.validateFolders((0,a.deserializeFolderInfos)(u)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==f.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(u,t){this.workspaces.some(s=>u.workspace.id===s.workspace.id)||(this.workspaces.push(u),this.storeWorkspacesMetadata());const l=(0,_.join)(this.backupHome,u.workspace.id);return t?this.moveBackupFolder(l,t).then(()=>l):l}async moveBackupFolder(u,t){if(await d.Promises.exists(u)&&await this.convertToEmptyWindowBackup(u),await d.Promises.exists(t))try{await d.Promises.rename(t,u,!1)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(u){return this.folders.some(t=>this.backupUriComparer.isEqual(u.folderUri,t.folderUri))||(this.folders.push(u),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,this.getFolderHash(u))}registerEmptyWindowBackup(u){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u.backupFolder))||(this.emptyWindows.push(u),this.storeWorkspacesMetadata()),(0,_.join)(this.backupHome,u.backupFolder)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const t=new Set,l=[];for(const s of u){const i=s.workspace;if(!(0,g.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,_.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await d.Promises.exists(i.configPath.fsPath)?l.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const s of u){const i=s.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!l.has(n)){l.add(n);const o=(0,_.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(o)?i.scheme!==r.Schemas.file||await d.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return t}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const s of u){const i=s.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,_.join)(this.backupHome,i);await this.doHasBackups(n)?t.push(s):await this.deleteStaleBackup(n)}}return t}async deleteStaleBackup(u){try{await d.Promises.rm(u,d.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let u=(0,m.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u.id));)u=(0,m.createEmptyWorkspaceIdentifier)();return{backupFolder:u.id}}async convertToEmptyWindowBackup(u){const t=this.prepareNewEmptyWindowBackup(),l=(0,_.join)(this.backupHome,t.backupFolder);try{await d.Promises.rename(u,l,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.workspaces)await this.hasBackups(t)&&u.push(t);for(const t of this.folders)await this.hasBackups(t)&&u.push(t);return u}hasBackups(u){let t;return(0,a.isEmptyWindowBackupInfo)(u)?t=(0,_.join)(this.backupHome,u.backupFolder):(0,w.isFolderBackupInfo)(u)?t=(0,_.join)(this.backupHome,this.getFolderHash(u)):t=(0,_.join)(this.backupHome,u.workspace.id),this.doHasBackups(t)}async doHasBackups(u){try{const t=await d.Promises.readdir(u);for(const l of t)try{if((await d.Promises.readdir((0,_.join)(u,l))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const u={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:l})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return l&&(s.remoteAuthority=l),s}),folders:this.folders.map(({folderUri:t,remoteAuthority:l})=>{const s={folderUri:t.toString()};return l&&(s.remoteAuthority=l),s}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:l})=>{const s={backupFolder:t};return l&&(s.remoteAuthority=l),s})};this.stateService.setItem(h.backupWorkspacesMetadataStorageKey,u)}getFolderHash(u){const t=u.folderUri;let l;return t.scheme===r.Schemas.file?l=M.isLinux?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,I.createHash)("md5").update(l).digest("hex")}};e.BackupMainService=c,e.BackupMainService=c=h=Pe([Z(0,v.IEnvironmentMainService),Z(1,p.IConfigurationService),Z(2,y.ILogService),Z(3,S.IStateService)],c)}),define(ee[20],te([0,1,15,38,8,3,2,4,35,12,6,5,34,28]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var w;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var g;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(g||(e.LifecycleMainPhase=g={}));let m=class extends M.Disposable{static{y=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(c,P,u){super(),this.logService=c,this.stateService=P,this.environmentMainService=u,this._onBeforeShutdown=this._register(new _.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new _.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new _.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(y.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(y.QUIT_AND_RESTART_KEY)}registerListeners(){const c=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),C.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};I.app.addListener("before-quit",c);const P=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!C.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",P),I.app.once("will-quit",u=>{this.trace("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),I.app.removeListener("before-quit",c),I.app.removeListener("window-all-closed",P),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}fireOnWillShutdown(c){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const P=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const u=[];return this._onWillShutdown.fire({reason:c,join(t,l){P.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(l.finally(()=>{P.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(u)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===c)return;this.trace(`lifecycle (main): phase changed (value: ${c})`),this._phase=c;const P=this.phaseWhen.get(this._phase);P&&(P.open(),this.phaseWhen.delete(this._phase))}async when(c){if(c<=this._phase)return;let P=this.phaseWhen.get(c);P||(P=new r.Barrier,this.phaseWhen.set(c,P)),await P.wait()}registerWindow(c){const P=new M.DisposableStore;this.windowCounter++,P.add(c.onWillLoad(t=>this._onWillLoadWindow.fire({window:c,workspace:t.workspace,reason:t.reason})));const u=(0,a.assertIsDefined)(c.win);u.on("close",t=>{const l=c.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.trace(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(s=>{if(s){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(c),c.close()})}),u.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.windowCounter--,P.dispose(),this.windowCounter===0&&(!C.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(c,P){await this.unload(c,3)||c.reload(P)}unload(c,P){const u=this.mapWindowIdToPendingUnload.get(c.id);if(u)return u;const t=this.doUnload(c,P).finally(()=>{this.mapWindowIdToPendingUnload.delete(c.id)});return this.mapWindowIdToPendingUnload.set(c.id,t),t}async doUnload(c,P){if(!c.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${c.id}`);const u=this._quitRequested?2:P,t=await this.onBeforeUnloadWindowInRenderer(c,u);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(c,u),!1)}handleWindowUnloadVeto(c){return c?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(c){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(c),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(c,P){return new Promise(u=>{const t=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${t}`,s=`vscode:cancel${t}`;L.validatedIpcMain.once(l,()=>{u(!1)}),L.validatedIpcMain.once(s,()=>{u(!0)}),c.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:s,reason:P})})}onWillUnloadWindowInRenderer(c,P){return new Promise(u=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(l,()=>u()),c.send("vscode:onWillUnload",{replyChannel:l,reason:P})})}quit(c){return this.doQuit(c).then(P=>{if(!P&&c)try{if(C.isWindows){const u=(0,d.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.logService.error(u)}return P})}doQuit(c){return this.trace(`Lifecycle#quit() - begin (willRestart: ${c})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(c&&this.stateService.setItem(y.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(P=>{this.pendingQuitPromiseResolve=P,this.trace("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.pendingQuitPromise)}trace(c){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(c):this.logService.trace(c)}setRelaunchHandler(c){this.relaunchHandler=c}async relaunch(c){this.trace("Lifecycle#relaunch()");const P=process.argv.slice(1);if(c?.addArgs&&P.push(...c.addArgs),c?.removeArgs)for(const l of c.removeArgs){const s=P.indexOf(l);s>=0&&P.splice(s,1)}const u=()=>{this.relaunchHandler?.handleRelaunch(c)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:P}))};I.app.once("quit",u),await this.quit(!0)&&I.app.removeListener("quit",u)}async kill(c){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const P of I.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let u;P.webContents&&!P.webContents.isDestroyed()?u=new Promise(t=>P.once("closed",t)):u=Promise.resolve(),P.destroy(),await u}})()]),I.app.exit(c)}};e.LifecycleMainService=m,e.LifecycleMainService=m=y=Pe([Z(0,v.ILogService),Z(1,S.IStateService),Z(2,f.IEnvironmentMainService)],m)}),define(ee[284],te([0,1,4,3,2,6,20]),function(K,e,I,L,r,_,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,_.createDecorator)("keyboardLayoutMainService");let C=class extends r.Disposable{constructor(p){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((v,S)=>{K(["native-keymap"],v,S)});this._keyboardLayoutData=d(p),I.isCI||p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=d(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=C,e.KeyboardLayoutMainService=C=Pe([Z(0,M.ILifecycleMainService)],C);function d(a){const p=a.getKeyMap(),v=a.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:v}}}),define(ee[285],te([0,1,244,8,17,14,12,18,36,94,5,50,243,282]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=class extends v.AbstractRequestService{constructor(h,c,P,u){super(u),this.configurationService=h,this.environmentService=c,this.logService=P,this.configure(),this._register(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const h=this.configurationService.getValue("http");this.proxyUrl=h?.proxy,this.strictSSL=!!h?.proxyStrictSSL,this.authorization=h?.proxyAuthorization}async request(h,c){const{proxyUrl:P,strictSSL:u}=this;let t;try{t=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,_.getErrorMessage)(i)))}const l={...process.env,...t},s=h.agent?h.agent:await(0,S.getProxyAgent)(h.url||"",l,{proxyUrl:P,strictSSL:u});return h.agent=s,h.strictSSL=u,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(h.isChromiumNetwork?"electron":"node",h,()=>g(h,c))}async resolveProxy(h){}};e.RequestService=y,e.RequestService=y=Pe([Z(0,C.IConfigurationService),Z(1,d.INativeEnvironmentService),Z(2,p.ILogService),Z(3,p.ILoggerService)],y);async function w(m){return((0,I.parse)(m.url).protocol==="https:"?await new Promise((P,u)=>{K(["https"],P,u)}):await new Promise((P,u)=>{K(["http"],P,u)})).request}async function g(m,h){return L.Promises.withAsyncBody(async(c,P)=>{const u=(0,I.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await w(m),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,M.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password);const s=t(l,i=>{const n=(0,M.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)g({...m,url:i.headers.location,followRedirects:n-1},h).then(c,P);else{let o=i;!m.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,f.createGunzip)())),c({res:i,stream:(0,r.streamToBufferReadableStream)(o)})}});s.on("error",P),m.timeout&&s.setTimeout(m.timeout),m.isChromiumNetwork&&s.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&s.write(m.data),s.end(),h.onCancellationRequested(()=>{s.abort(),P(new _.CancellationError)})})}e.nodeRequest=g}),define(ee[286],te([0,1,15,285]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(M){return I.net.request}class _ extends L.RequestService{request(C,d){return super.request({...C||{},getRawRequest:r,isChromiumNetwork:!0},d)}}e.RequestMainService=_}),define(ee[80],te([0,1,7,3,2,36,16,6,20,5,96,279,41,52,40,13]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let g=class extends r.Disposable{constructor(c,P,u,t,l,s){super(),this.logService=c,this.environmentService=P,this.userDataProfilesService=u,this.lifecycleMainService=t,this.fileService=l,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new L.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(c=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.mapProfileToStorage)c.join("profileStorage",P.close());for(const[,P]of this.mapWorkspaceToStorage)c.join("workspaceStorage",P.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(c=>{c.join((async()=>{await this.fileService.exists(c.profile.globalStorageHome)||await this.fileService.createFolder(c.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(c=>{const P=this.mapProfileToStorage.get(c.profile.id);P&&c.join(P.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const c=new v.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(L.Event.once(c.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,p.isProfileUsingDefaultStorage)(c))return this.applicationStorage;let P=this.mapProfileToStorage.get(c.id);if(!P){this.logService.trace(`StorageMainService: creating profile storage (${c.name})`),P=this._register(this.createProfileStorage(c)),this.mapProfileToStorage.set(c.id,P);const u=this._register(P.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:P,profile:c})));this._register(L.Event.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${c.name})`),this.mapProfileToStorage.delete(c.id),u.dispose()}))}return P}createProfileStorage(c){return this.shutdownReason===2?new v.InMemoryStorageMain(this.logService,this.fileService):new v.ProfileStorageMain(c,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(c){let P=this.mapWorkspaceToStorage.get(c.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${c.id})`),P=this._register(this.createWorkspaceStorage(c)),this.mapWorkspaceToStorage.set(c.id,P),this._register(L.Event.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${c.id})`),this.mapWorkspaceToStorage.delete(c.id)}))),P}createWorkspaceStorage(c){return this.shutdownReason===2?new v.InMemoryStorageMain(this.logService,this.fileService):new v.WorkspaceStorageMain(c,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(c){const P=I.URI.file(c);for(const u of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(u.path&&this.uriIdentityService.extUri.isEqualOrParent(I.URI.file(u.path),P))return!0;return!1}};e.StorageMainService=g,e.StorageMainService=g=Pe([Z(0,a.ILogService),Z(1,_.IEnvironmentService),Z(2,f.IUserDataProfilesMainService),Z(3,d.ILifecycleMainService),Z(4,M.IFileService),Z(5,y.IUriIdentityService)],g),e.IApplicationStorageMainService=(0,C.createDecorator)("applicationStorageMainService");let m=class extends p.AbstractStorageService{constructor(c,P){super(),this.userDataProfilesService=c,this.storageMainService=P,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(c){if(c===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(c){if(c===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=m,e.ApplicationStorageMainService=m=Pe([Z(0,S.IUserDataProfilesService),Z(1,e.IStorageMainService)],m)}),define(ee[287],te([0,1,15,22,3,55,2,32,115,5,80,30]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let f=class extends M.Disposable{constructor(w,g,m,h){super(),this.logService=w,this.windowsMainService=g,this.encryptionMainService=m,this.applicationStorageMainService=h,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=r.Event.fromNodeEventEmitter(I.app,"login",(g,m,h,c,P)=>({event:g,webContents:m,req:h,authInfo:c,callback:P}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:g,req:m,callback:h}){if(!g.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let c;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(g);try{c=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(c?.username,c?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.doResolveProxyCredentials(w);if(g)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const g=String((0,_.hash)({scheme:w.scheme,host:w.host,port:w.port}));let m,h;try{const t=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+g,-1);if(t){const l=JSON.parse(await this.encryptionMainService.decrypt(t));m=l.username,h=l.password}}catch(t){this.logService.error(t)}if(this.state!==S.StoredCredentialsUsed&&typeof m=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:m,password:h};const c=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!c){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const P={authInfo:w,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,C.generateUuid)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,P),this.state=S.LoginDialogShown;const u=await new Promise(t=>{const l=async(s,i,n)=>{if(i===P.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",l),n){const o={username:n.username,password:n.password};try{if(n.remember){const b=await this.encryptionMainService.encrypt(JSON.stringify(o));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+g,b,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+g,-1)}catch(b){this.logService.error(b)}t({username:o.username,password:o.password})}else t(void 0)};c.win?.webContents.on("ipc-message",l)});return this.sessionCredentials=u,u}};e.ProxyAuthHandler=f,e.ProxyAuthHandler=f=Pe([Z(0,a.ILogService),Z(1,v.IWindowsMainService),Z(2,d.IEncryptionMainService),Z(3,p.IApplicationStorageMainService)],f)}),define(ee[288],te([0,1,87,27,103,99,8,2,4,18,5,24,239,240,95,125,17]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function m(t,l,s,i,n){let o;for(let b=3;b&&(o?.dispose(),o=await new h(t,l,s,i,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));b--);return o}class h extends C.Disposable{constructor(l,s,i,n,o){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=o,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=I.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=b=>this._onConnection(b),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const l=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,w.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,r.findFreePortFaster)(l,2,1e3,s),n=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(l){l.pause();const s=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,S.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n instanceof _.NodeSocket?n.socket.destroy():n.end()}),n instanceof _.NodeSocket?this._mirrorNodeSocket(l,n):this._mirrorGenericSocket(l,n),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),n.end()})}_mirrorGenericSocket(l,s){s.onClose(()=>l.destroy()),s.onEnd(()=>l.end()),s.onData(i=>l.write(i.buffer)),l.on("data",i=>s.write(g.VSBuffer.wrap(i))),l.resume()}_mirrorNodeSocket(l,s){const i=s.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.NodeRemoteTunnel=h;let c=class extends w.AbstractTunnelService{constructor(l,s,i,n,o){super(s,o),this.remoteSocketFactoryService=l,this.signService=i,this.productService=n}isPortPrivileged(l){return(0,w.isPortPrivileged)(l,this.defaultTunnelHost,d.OS,L.release())}retainOrCreateTunnel(l,s,i,n,o,b,D,R){const E=this.getTunnelFromMap(s,i);if(E)return++E.refcount,E.value;if((0,w.isTunnelProvider)(l))return this.createWithProvider(l,s,i,o,b,D,R);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${o}.`);const k={commit:this.productService.commit,quality:this.productService.quality,addressProvider:l,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},O=m(k,n,s,i,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,O),O}}};e.BaseTunnelService=c,e.BaseTunnelService=c=Pe([Z(0,f.IRemoteSocketFactoryService),Z(1,p.ILogService),Z(2,y.ISignService),Z(3,v.IProductService),Z(4,a.IConfigurationService)],c);let P=class extends c{constructor(l,s,i,n,o){super(l,s,i,n,o)}};e.TunnelService=P,e.TunnelService=P=Pe([Z(0,f.IRemoteSocketFactoryService),Z(1,p.ILogService),Z(2,y.ISignService),Z(3,v.IProductService),Z(4,a.IConfigurationService)],P);let u=class extends C.Disposable{constructor(l,s,i,n,o){super(),this.remoteSocketFactoryService=l,this.logService=s,this.productService=i,this.signService=n,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(l,s,i,n,o,b,D,R,E){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${b}.`),!this._tunnelServices.has(l)){const k=new P(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(k),this._tunnelServices.set(l,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(s,i,n,o,b,D,R,E)}};e.SharedTunnelsService=u,e.SharedTunnelsService=u=Pe([Z(0,f.IRemoteSocketFactoryService),Z(1,p.ILogService),Z(2,v.IProductService),Z(3,y.ISignService),Z(4,a.IConfigurationService)],u)}),define(ee[100],te([0,1,8,22,3,18,28,20,5,24,50,48]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(y,w,g){return`${g.updateUrl}/api/update/${y}/${w}/${g.commit}`}e.createUpdateURL=S;let f=class{get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}constructor(w,g,m,h,c,P){this.lifecycleMainService=w,this.configurationService=g,this.environmentMainService=m,this.requestService=h,this.logService=c,this.productService=P,this._state=v.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,w.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(v.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(v.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(v.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.configurationService.getValue("update.mode"),g=this.getProductQuality(w);if(!g){this.setState(v.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(g),!this.url){this.setState(v.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(v.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,I.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(g){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(g);return}}async _applySpecificUpdate(w){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=f,e.AbstractUpdateService=f=Pe([Z(0,C.ILifecycleMainService),Z(1,_.IConfigurationService),Z(2,M.IEnvironmentMainService),Z(3,p.IRequestService),Z(4,d.ILogService),Z(5,a.IProductService)],f)}),define(ee[289],te([0,1,15,54,3,2,18,28,20,5,24,50,25,48,100]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends y.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"error",(m,h)=>h)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(m,h,c)=>({url:h,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(m,h,c,P)=>({releaseNotes:h,version:c,productVersion:c,date:P}))}constructor(m,h,c,P,u,t,l){super(m,h,P,u,t,l),this.telemetryService=c,this.disposables=new _.DisposableStore,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.logService.error("UpdateService error:",m);const h=this.state.type==="checking for updates"&&this.state.explicit?m:void 0;this.setState(f.State.Idle(1,h))}buildUpdateFeedUrl(m){let h;this.productService.darwinUniversalAssetId?h=this.productService.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,y.createUpdateURL)(h,m,this.productService);try{I.autoUpdater.setFeedURL({url:c})}catch(P){this.logService.error("Failed to set update feed URL",P);return}return c}doCheckForUpdates(m){this.setState(f.State.CheckingForUpdates(m)),I.autoUpdater.checkForUpdates()}onUpdateAvailable(m){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(m))}onUpdateDownloaded(m){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(f.State.Ready(m)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=w,Pe([L.memoize],w.prototype,"onRawError",null),Pe([L.memoize],w.prototype,"onRawUpdateNotAvailable",null),Pe([L.memoize],w.prototype,"onRawUpdateAvailable",null),Pe([L.memoize],w.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=w=Pe([Z(0,d.ILifecycleMainService),Z(1,M.IConfigurationService),Z(2,S.ITelemetryService),Z(3,C.IEnvironmentMainService),Z(4,v.IRequestService),Z(5,a.ILogService),Z(6,p.IProductService)],w)}),define(ee[290],te([0,1,47,45,8,3,9,28,20,5,25,48]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}constructor(w,g,m){if(this.lifecycleMainService=w,this.logService=m,this._state=v.State.Uninitialized,this._onStateChange=new _.Emitter,this.onStateChange=this._onStateChange.event,g.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(v.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,h=>this.logService.error(h))}scheduleCheckForUpdates(w=60*60*1e3){return(0,r.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(w){}};S=Pe([Z(0,d.ILifecycleMainService),Z(1,C.IEnvironmentMainService),Z(2,a.ILogService)],S);let f=class extends S{constructor(w,g,m,h,c,P){super(m,h,c),this.snap=w,this.snapRevision=g,this.telemetryService=P;const u=(0,L.watch)(M.dirname(this.snap)),t=_.Event.fromNodeEventEmitter(u,"change",(n,o)=>o),l=_.Event.filter(t,n=>n==="current"),i=_.Event.debounce(l,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{i.dispose(),u.close()})}doCheckForUpdates(){this.setState(v.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(v.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(v.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(v.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((m,h)=>(0,L.realpath)(`${M.dirname(this.snap)}/current`,(c,P)=>c?h(c):m(P))),g=M.basename(w);return this.snapRevision!==g}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=f,e.SnapUpdateService=f=Pe([Z(2,d.ILifecycleMainService),Z(3,C.IEnvironmentMainService),Z(4,a.ILogService),Z(5,p.ITelemetryService)],f)}),define(ee[291],te([0,1,2,20,52,29,8,30]),function(K,e,I,L,r,_,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let d=class extends I.Disposable{constructor(p,v,S){super(),this.userDataProfilesService=v,this.windowsMainService=S,this._register(p.onWillLoadWindow(f=>{f.reason===2&&this.unsetProfileForWorkspace(f.window)})),this._register(p.onBeforeCloseWindow(f=>this.unsetProfileForWorkspace(f))),this._register(new M.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(p){const v=this.getWorkspace(p),S=this.userDataProfilesService.getProfileForWorkspace(v);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(v,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(p){return p.openedWorkspace??(0,_.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const p=this.userDataProfilesService.getAssociatedEmptyWindows();if(p.length===0)return;const v=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of p)v.some(f=>f.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};e.UserDataProfilesHandler=d,e.UserDataProfilesHandler=d=Pe([Z(0,L.ILifecycleMainService),Z(1,r.IUserDataProfilesMainService),Z(2,C.IWindowsMainService)],d)}),define(ee[60],te([0,1,15,2,3,5,310,8,13,30,69,25,20,71,37,4,130]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function h(u){return typeof u.responseWindowId=="number"}let c=class extends L.Disposable{static{m=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(m.all.values())}constructor(t,l,s){super(),this.logService=t,this.telemetryService=l,this.lifecycleMainService=s,this.id=String(++m.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(t,l){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,l){case p.default.Error:this.logService.error(s);break;case p.default.Warning:this.logService.warn(s);break;case p.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(t){const l=this.doStart(t);return l&&t.payload&&this.postMessage(t.payload),l}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const l=`${this.configuration.type}-${this.id}`,s=d.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],n=this.configuration.execArgv??[],o=this.configuration.allowLoadingUnsignedLibraries,b=this.configuration.forceAllocationsToV8Sandbox,D="pipe",R=this.createEnv(t);return this.log("creating new...",p.default.Info),this.process=I.utilityProcess.fork(s,i,{serviceName:l,env:R,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:b,stdio:D}),this.registerListeners(this.process,this.configuration,l),!0}createEnv(t){const l=t.env?{...t.env}:{...(0,y.deepClone)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.isWindows&&((0,g.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,g.getUNCHostAllowlist)().join("\\")),(0,f.removeDangerousEnvVariables)(l);for(const s of Object.keys(l))l[s]=String(l[s]);return l}registerListeners(t,l,s){if(t.stdout){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:i.write(n))))}this._register(r.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(r.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&m.all.set(t.pid,{pid:t.pid,name:h(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.log("successfully created",p.default.Info)})),this._register(r.Event.fromNodeEventEmitter(t,"exit")(i=>{this.log(`received exit event with code ${i}`,p.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(I.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,l){const s=this._register(this._onMessage.event(i=>{i===t&&(s.dispose(),l())}))}postMessage(t,l){this.process&&this.process.postMessage(t,l)}connect(t){const{port1:l,port2:s}=new I.MessageChannelMain;return this.postMessage(t,[s]),l}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",p.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",p.default.Info),this.process.kill()?(this.log("successfully killed the process",p.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",p.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&m.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",p.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,C.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,p.default.Info),this.kill()))}};e.UtilityProcess=c,e.UtilityProcess=c=m=Pe([Z(0,_.ILogService),Z(1,v.ITelemetryService),Z(2,S.ILifecycleMainService)],c);let P=class extends c{constructor(t,l,s,i){super(t,s,i),this.windowsMainService=l}start(t){const l=this.windowsMainService.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,l){l.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=P,e.WindowUtilityProcess=P=Pe([Z(0,_.ILogService),Z(1,a.IWindowsMainService),Z(2,v.ITelemetryService),Z(3,S.ILifecycleMainService)],P)}),define(ee[292],te([0,1,14,5,20,8,60,30,25]),function(K,e,I,L,r,_,M,C,d){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let p=class{static{a=this}static{this._lastId=0}constructor(S,f,y,w){this._logService=S,this._lifecycleMainService=f,this._windowsMainService=y,this._telemetryService=w,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(g=>{this._shutdown=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(S){const f=this._extHosts.get(S);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(S){return this._getExtHost(S).onStdout}onDynamicStderr(S){return this._getExtHost(S).onStderr}onDynamicMessage(S){return this._getExtHost(S).onMessage}onDynamicExit(S){return this._getExtHost(S).onExit}async createExtensionHost(){if(this._shutdown)throw(0,I.canceled)();const S=String(++a._lastId),f=new M.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(S,f),f.onExit(({pid:y,code:w,signal:g})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${g}.`),setTimeout(()=>{f.dispose(),this._extHosts.delete(S)})}),{id:S}}async start(S,f){if(this._shutdown)throw(0,I.canceled)();this._getExtHost(S).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:S})}async enableInspectPort(S){if(this._shutdown)throw(0,I.canceled)();const f=this._extHosts.get(S);return f?f.enableInspectPort():!1}async kill(S){if(this._shutdown)throw(0,I.canceled)();const f=this._extHosts.get(S);f&&f.kill()}async _killAllNow(){for(const[,S]of this._extHosts)S.kill()}async _waitForAllExit(S){const f=[];for(const[,y]of this._extHosts)f.push(y.waitForExit(S));return _.Promises.settled(f).then(()=>{})}};e.ExtensionHostStarter=p,e.ExtensionHostStarter=p=a=Pe([Z(0,L.ILogService),Z(1,r.ILifecycleMainService),Z(2,C.IWindowsMainService),Z(3,d.ITelemetryService)],p)}),define(ee[293],te([0,1,38,8,2,28,20,5,41,39,65,60,51,89,12,245,24]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends r.Disposable{constructor(c,P,u,t,l,s,i,n){super(),this.machineId=c,this.environmentMainService=P,this.userDataProfilesService=u,this.lifecycleMainService=t,this.logService=l,this.loggerMainService=s,this.policyService=i,this.productService=n,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){I.validatedIpcMain.on(w.SharedProcessChannelConnection.request,(c,P)=>this.onWindowConnection(c,P,w.SharedProcessChannelConnection.response)),I.validatedIpcMain.on(w.SharedProcessRawConnection.request,(c,P)=>this.onWindowConnection(c,P,w.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,P,u){this.logService.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const t=await this.connect(u);if(c.sender.isDestroyed())return t.close();c.sender.postMessage(u,P,[t])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(w.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const c=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(w.SharedProcessLifecycle.initDone,()=>c.complete()):I.validatedIpcMain.once(w.SharedProcessLifecycle.initDone,()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const c=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(w.SharedProcessLifecycle.ipcReady,()=>c.complete()):I.validatedIpcMain.once(w.SharedProcessLifecycle.ipcReady,()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new v.UtilityProcess(this.logService,S.NullTelemetryService,this.lifecycleMainService));const c=(0,f.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let P;c.port&&(P=["--nolazy"],c.break?P.push(`--inspect-brk=${c.port}`):P.push(`--inspect=${c.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:P,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.productService.quality!=="stable"})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(c){return await this.whenIpcReady,(0,y.assertIsDefined)(this.utilityProcess).connect(c)}};e.SharedProcess=m,e.SharedProcess=m=Pe([Z(1,_.IEnvironmentMainService),Z(2,d.IUserDataProfilesService),Z(3,M.ILifecycleMainService),Z(4,C.ILogService),Z(5,p.ILoggerMainService),Z(6,a.IPolicyService),Z(7,g.IProductService)],m)}),define(ee[294],te([0,1,28,89,20,5,51,60,110,38,2,3,37,18,13]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let w=class extends p.Disposable{constructor(m,h,c,P,u){super(),this._reconnectConstants=m,this._configurationService=h,this._environmentMainService=c,this._lifecycleMainService=P,this._logService=u,this.utilityProcess=void 0,this._onRequestConnection=new v.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new v.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),a.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,l)=>this._onWindowConnection(t,l)),this._register((0,p.toDisposable)(()=>{a.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new C.UtilityProcess(this._logService,M.NullTelemetryService,this._lifecycleMainService);const m=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),h=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const c=this.utilityProcess.connect(),P=new d.Client(c,"ptyHost"),u=new p.DisposableStore;return u.add(P),u.add((0,p.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:P,store:u,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const m={...(0,S.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},h=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(m.VSCODE_LATENCY=String(h));const c=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(m.VSCODE_STARTUP_DELAY=String(c)),this._environmentMainService.restoreSnapExportedVariables(),m}_onWindowConnection(m,h){this._onRequestConnection.fire();const c=this.utilityProcess.connect();if(m.sender.isDestroyed()){c.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[c])}};e.ElectronPtyHostStarter=w,e.ElectronPtyHostStarter=w=Pe([Z(1,f.IConfigurationService),Z(2,I.IEnvironmentMainService),Z(3,r.ILifecycleMainService),Z(4,_.ILogService)],w)}),define(ee[295],te([0,1,2,6,5,30,60,25,55,3,8,20]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let S=class extends I.Disposable{constructor(w,g,m,h){super(),this.logService=w,this.windowsMainService=g,this.telemetryService=m,this.lifecycleMainService=h,this.workers=new Map}async createWorker(w){const g=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${g})`);const m=this.hash(w);this.workers.has(m)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${g})`),this.disposeWorker(w));const h=new f(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,w);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(m,h);const c=new p.DeferredPromise;return a.Event.once(h.onDidTerminate)(P=>{P.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.workers.delete(m),c.complete({reason:P})}),c.p}hash(w){return(0,d.hash)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const g=this.hash(w),m=this.workers.get(g);m&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),m.kill(),this.workers.delete(g))}};e.UtilityProcessWorkerMainService=S,e.UtilityProcessWorkerMainService=S=Pe([Z(0,r.ILogService),Z(1,_.IWindowsMainService),Z(2,C.ITelemetryService),Z(3,v.ILifecycleMainService)],S);let f=class extends I.Disposable{constructor(w,g,m,h,c){super(),this.logService=w,this.windowsMainService=g,this.telemetryService=m,this.lifecycleMainService=h,this.configuration=c,this._onDidTerminate=this._register(new a.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new M.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(w=>this._onDidTerminate.fire({code:w.code,signal:w.signal}))),this._register(this.utilityProcess.onCrash(w=>this._onDidTerminate.fire({code:w.code,signal:"ECRASH"})))}spawn(){const g=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:g,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};f=Pe([Z(0,r.ILogService),Z(1,_.IWindowsMainService),Z(2,C.ITelemetryService),Z(3,v.ILifecycleMainService)],f)}),define(ee[296],te([0,1,15,2,4,19,7,18,20,5,34,30,127,29]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class extends L.Disposable{static{y=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(u,t,l,s,i){super(),this.windowsMainService=u,this.stateService=t,this.lifecycleMainService=l,this.logService=s,this.configurationService=i,this._state=g(this.stateService.getItem(y.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){I.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const l=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?r.isMacintosh&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const s=h(t);this.stateService.setItem(y.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{const s=(0,f.isWorkspaceIdentifier)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&l.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(s||i)&&(l.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(u){return{windowId:u.id,workspace:(0,f.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),s||(t.mode=1)}return t}doGetNewWindowState(u){const t=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=u.workspace;if((0,f.isWorkspaceIdentifier)(b)){const R=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===b.id).map(E=>E.uiState);if(R.length)return R[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(b)){const R=this.state.openedWindows.filter(E=>E.folderUri&&_.extUriBiasedIgnorePathCase.isEqual(E.folderUri,b.uri)).map(E=>E.uiState);if(R.length)return R[0]}else if(u.backupPath){const R=this.state.openedWindows.filter(E=>E.backupPath===u.backupPath).map(E=>E.uiState);if(R.length)return R[0]}const D=this.lastClosedState||this.state.lastActiveWindow;if(!t&&D)return D.uiState}let l;const s=I.screen.getAllDisplays();if(s.length===1)l=s[0];else{if(r.isMacintosh){const b=I.screen.getCursorScreenPoint();l=I.screen.getDisplayNearestPoint(b)}!l&&t&&(l=I.screen.getDisplayMatching(t.getBounds())),l||(l=I.screen.getPrimaryDisplay()||s[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i=b,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};e.WindowsStateHandler=w,e.WindowsStateHandler=w=y=Pe([Z(0,v.IWindowsMainService),Z(1,p.IStateService),Z(2,d.ILifecycleMainService),Z(3,a.ILogService),Z(4,C.IConfigurationService)],w);function g(P){const u={openedWindows:[]},t=P||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(l=>m(l))),u}e.restoreWindowsState=g;function m(P){const u={uiState:P.uiState};return P.backupPath&&(u.backupPath=P.backupPath),P.remoteAuthority&&(u.remoteAuthority=P.remoteAuthority),P.folder&&(u.folderUri=M.URI.parse(P.folder)),P.workspaceIdentifier&&(u.workspace={id:P.workspaceIdentifier.id,configPath:M.URI.parse(P.workspaceIdentifier.configURIPath)}),u}function h(P){return{lastActiveWindow:P.lastActiveWindow&&c(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&c(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(u=>c(u))}}e.getWindowsStateStoreData=h;function c(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(ee[53],te([0,1,15,3,44,2,13,9,19,21,192,63,59,28,6,5,52,129,29,97,98]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,y.createDecorator)("workspacesManagementMainService");let u=class extends _.Disposable{constructor(l,s,i,n,o){super(),this.environmentMainService=l,this.logService=s,this.userDataProfilesMainService=i,this.backupMainService=n,this.dialogMainService=o,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const l=(await a.Promises.readdir(this.untitledWorkspacesHome.with({scheme:M.Schemas.file}).fsPath)).map(s=>(0,d.joinPath)(this.untitledWorkspacesHome,s,h.UNTITLED_WORKSPACE_NAME));for(const s of l){const i=(0,P.getWorkspaceIdentifier)(s),n=await this.resolveLocalWorkspace(s);n?this.untitledWorkspaces.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,s=>a.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(l,s){if(this.isWorkspacePath(l)&&l.scheme===M.Schemas.file)try{const i=s(l.fsPath);return i instanceof Promise?i.then(n=>this.doResolveWorkspace(l,n),n=>{}):this.doResolveWorkspace(l,i)}catch{return}}isWorkspacePath(l){return(0,h.isUntitledWorkspace)(l,this.environmentMainService)||(0,h.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,s){try{const i=this.doParseStoredWorkspace(l,s),n=(0,P.getWorkspaceIdentifier)(l);return{id:n.id,configPath:n.configPath,folders:(0,c.toWorkspaceFolders)(i.folders,n.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(l,s){const i=(0,r.parse)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,c.isStoredWorkspaceFolder)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,s){const{workspace:i,storedWorkspace:n}=this.newUntitledWorkspace(l,s),o=i.configPath.fsPath;return await a.Promises.mkdir((0,C.dirname)(o),{recursive:!0}),await a.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:s}),i}newUntitledWorkspace(l=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,d.joinPath)(this.untitledWorkspacesHome,i),o=(0,d.joinPath)(n,h.UNTITLED_WORKSPACE_NAME),b=[];for(const D of l)b.push((0,c.getStoredWorkspaceFolder)(D.uri,!0,D.name,n,d.extUriBiasedIgnorePathCase));return{workspace:(0,P.getWorkspaceIdentifier)(o),storedWorkspace:{folders:b,remoteAuthority:s}}}async getWorkspaceIdentifier(l){return(0,P.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,h.isUntitledWorkspace)(l.configPath,this.environmentMainService)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.doDeleteUntitledWorkspace(l),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(l),this._onDidDeleteUntitledWorkspace.fire(l))}async doDeleteUntitledWorkspace(l){const s=(0,d.originalFSPath)(l.configPath);try{await a.Promises.rm((0,C.dirname)(s));const i=(0,C.join)(this.environmentMainService.workspaceStorageHome.with({scheme:M.Schemas.file}).fsPath,l.id);await a.Promises.exists(i)&&await a.Promises.writeFile((0,C.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(n=>n.workspace.id!==l.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(l,s,i){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,s,i))return;const o=await this.doEnterWorkspace(l,(0,P.getWorkspaceIdentifier)(i));if(o)return this._onDidEnterWorkspace.fire({window:l,workspace:o.workspace}),o}async isValidTargetWorkspacePath(l,s,i){return i?(0,h.isWorkspaceIdentifier)(l.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,i)?!1:(0,m.findWindowOnWorkspaceOrFolder)(s,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,d.basename)(i)),detail:(0,p.localize)(2,null)},I.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(l,s){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:l.remoteAuthority})),(0,h.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=s,l.config.backupPath=i,{workspace:s,backupPath:i}}};e.WorkspacesManagementMainService=u,e.WorkspacesManagementMainService=u=Pe([Z(0,f.IEnvironmentMainService),Z(1,w.ILogService),Z(2,g.IUserDataProfilesMainService),Z(3,v.IBackupMainService),Z(4,S.IDialogMainService)],u)}),define(ee[131],te([0,1,15,38,22,6,30,29,53,12,5,60]),function(K,e,I,L,r,_,M,C,d,a,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,_.createDecorator)(e.ID);let S=class{constructor(y,w,g){this.windowsMainService=y,this.workspacesManagementMainService=w,this.logService=g}async getRemoteDiagnostics(y){const w=this.windowsMainService.getWindows();return(await Promise.all(w.map(async m=>{const h=m.remoteAuthority;if(!h)return;const c=`vscode:getDiagnosticInfoResponse${m.id}`,P={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.getFolderURIs(m):void 0};return new Promise(u=>{m.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:c,args:P}),L.validatedIpcMain.once(c,(t,l)=>{l||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(l)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const y=[];for(const g of I.BrowserWindow.getAllWindows()){const m=this.windowsMainService.getWindowById(g.id);m?y.push(await this.codeWindowToInfo(m)):y.push(this.browserWindowToInfo(g))}const w=[];for(const{pid:g,name:m}of v.UtilityProcess.getAll())w.push({pid:g,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async codeWindowToInfo(y){const w=await this.getFolderURIs(y),g=(0,a.assertIsDefined)(y.win);return this.browserWindowToInfo(g,w,y.remoteAuthority)}browserWindowToInfo(y,w=[],g){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:g}}async getFolderURIs(y){const w=[],g=y.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(g))w.push(g.uri);else if((0,C.isWorkspaceIdentifier)(g)){const m=await this.workspacesManagementMainService.resolveLocalWorkspace(g.configPath);m&&m.folders.forEach(c=>{w.push(c.uri)})}return w}};e.DiagnosticsMainService=S,e.DiagnosticsMainService=S=Pe([Z(0,M.IWindowsMainService),Z(1,d.IWorkspacesManagementMainService),Z(2,p.ILogService)],S)}),define(ee[66],te([0,1,47,15,27,155,54,3,2,13,9,4,7,105,86,21,103,180,59,28,6,20,5,24,77,30,29,53,17,241,233]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n,o,b,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,P.createDecorator)("nativeHostMainService");let E=class extends d.Disposable{constructor(O,F,q,ne,J,ce,re,se){super(),this.windowsMainService=O,this.dialogMainService=F,this.lifecycleMainService=q,this.environmentMainService=ne,this.logService=J,this.productService=ce,this.themeMainService=re,this.workspacesManagementMainService=se,this.onDidOpenWindow=C.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=C.Event.filter(C.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:G,x:V,y:x})=>({windowId:G.id,x:V,y:x})),({windowId:G})=>!!this.windowsMainService.getWindowById(G)),this.onDidMaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=C.Event.any(C.Event.map(C.Event.filter(C.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(G,V)=>V.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=C.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new C.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=C.Event.debounce(C.Event.any(C.Event.filter(C.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(G,V,x)=>x),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),C.Event.fromNodeEventEmitter(L.screen,"display-added"),C.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace??(0,n.toWorkspaceIdentifier)(F.backupPath,F.isExtensionDevelopmentHost),title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const F=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(O,F,q){return Array.isArray(F)?this.doOpenWindow(O,F,q):this.doOpenEmptyWindow(O,F)}async doOpenWindow(O,F,q=Object.create(null)){F.length>0&&await this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async doOpenEmptyWindow(O,F){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},F)}async toggleFullScreen(O){this.windowById(O)?.toggleFullScreen()}async handleTitleDoubleClick(O){this.windowById(O)?.handleTitleDoubleClick()}async isMaximized(O){const F=this.windowById(O);return F?.win?F.win.isMaximized():!1}async maximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.maximize()}async unmaximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.unmaximize()}async minimizeWindow(O){const F=this.windowById(O);F?.win&&F.win.minimize()}async updateWindowControls(O,F){const q=this.windowById(O);q&&q.updateWindowControls(F)}async focusWindow(O,F){F&&typeof F.windowId=="number"&&(O=F.windowId),this.windowById(O)?.focus({force:F?.force??!1})}async setMinimumSize(O,F,q){const ne=this.windowById(O);if(ne?.win){const[J,ce]=ne.win.getSize(),[re,se]=ne.win.getMinimumSize(),[G,V]=[F??re,q??se],[x,W]=[Math.max(J,G),Math.max(ce,V)];(re!==G||se!==V)&&ne.win.setMinimumSize(G,V),(J!==x||ce!==W)&&ne.win.setSize(x,W)}}async saveWindowSplash(O,F){this.themeMainService.saveWindowSplash(O,F)}async installShellCommand(O){const{source:F,target:q}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await w.SymlinkSupport.stat(F);if(ne&&!ne.dangling){const J=await(0,f.realpath)(F);if(q===J)return}await w.Promises.unlink(F)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await w.Promises.symlink(q,F)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:J}=await this.showMessageBox(O,{type:"info",message:(0,m.localize)(0,null,this.productService.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(J===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${F}'\\" with administrator privileges"`;await(0,_.promisify)(I.exec)(ce)}catch{throw new Error((0,m.localize)(3,null,F))}}}async uninstallShellCommand(O){const{source:F}=await this.getShellCommandLink();try{await w.Promises.unlink(F)}catch(q){switch(q.code){case"EACCES":{const{response:ne}=await this.showMessageBox(O,{type:"info",message:(0,m.localize)(4,null,this.productService.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(ne===0)try{const J=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,_.promisify)(I.exec)(J)}catch{throw new Error((0,m.localize)(7,null,F))}break}case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const O=(0,p.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(O))throw new Error((0,m.localize)(8,null,O));return{source:F,target:O}}async showMessageBox(O,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(O))}async showSaveDialog(O,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(O))}async showOpenDialog(O,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(O))}toBrowserWindow(O){const F=this.windowById(O);if(F?.win)return F.win}async pickFileFolderAndOpen(O,F){const q=await this.dialogMainService.pickFileFolder(F);q&&await this.doOpenPicked(await Promise.all(q.map(async ne=>await w.SymlinkSupport.existsDirectory(ne)?{folderUri:S.URI.file(ne)}:{fileUri:S.URI.file(ne)})),F,O)}async pickFolderAndOpen(O,F){const q=await this.dialogMainService.pickFolder(F);q&&await this.doOpenPicked(q.map(ne=>({folderUri:S.URI.file(ne)})),F,O)}async pickFileAndOpen(O,F){const q=await this.dialogMainService.pickFile(F);q&&await this.doOpenPicked(q.map(ne=>({fileUri:S.URI.file(ne)})),F,O)}async pickWorkspaceAndOpen(O,F){const q=await this.dialogMainService.pickWorkspace(F);q&&await this.doOpenPicked(q.map(ne=>({workspaceUri:S.URI.file(ne)})),F,O)}async doOpenPicked(O,F,q){await this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:F.forceNewWindow})}async showItemInFolder(O,F){L.shell.showItemInFolder(F)}async setRepresentedFilename(O,F){this.windowById(O)?.setRepresentedFilename(F)}async setDocumentEdited(O,F){this.windowById(O)?.setDocumentEdited(F)}async openExternal(O,F){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(F),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(O,F){return L.shell.trashItem(F)}async isAdmin(){let O;return v.isWindows?O=(await new Promise((F,q)=>{K(["native-is-elevated"],F,q)}))():O=process.getuid?.()===0,O}async writeElevated(O,F,q,ne){const J=await new Promise((ce,re)=>{K(["@vscode/sudo-prompt"],ce,re)});return new Promise((ce,re)=>{const se=[`"${this.cliPath}"`];ne?.unlock&&se.push("--file-chmod"),se.push("--file-write",`"${F.fsPath}"`,`"${q.fsPath}"`);const G={name:this.productService.nameLong.replace("-",""),icns:v.isMacintosh&&this.environmentMainService.isBuilt?(0,p.join)((0,p.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};J.exec(se.join(" "),G,(V,x,W)=>{x&&this.logService.trace(`[sudo-prompt] received stdout: ${x}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),V?re(V):ce(void 0)})})}async isRunningUnderARM64Translation(){return v.isLinux||v.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return v.isWindows?this.environmentMainService.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,p.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):v.isLinux?this.environmentMainService.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,p.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,p.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,p.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(O,F,q){process.kill(F,q)}async readClipboardText(O,F){return L.clipboard.readText(F)}async writeClipboardText(O,F,q){return L.clipboard.writeText(F,q)}async readClipboardFindText(O){return L.clipboard.readFindText()}async writeClipboardFindText(O,F){return L.clipboard.writeFindText(F)}async writeClipboardBuffer(O,F,q,ne){return L.clipboard.writeBuffer(F,Buffer.from(q.buffer),ne)}async readClipboardBuffer(O,F){return b.VSBuffer.wrap(L.clipboard.readBuffer(F))}async hasClipboard(O,F,q){return L.clipboard.has(F,q)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,F){this.windowById(O)?.updateTouchBar(F)}async notifyReady(O){this.windowById(O)?.setReady()}async relaunch(O,F){return this.lifecycleMainService.relaunch(F)}async reload(O,F){const q=this.windowById(O);if(q){if((0,n.isWorkspaceIdentifier)(q.openedWorkspace)){const ne=q.openedWorkspace.configPath;if(ne.scheme===a.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,F){const q=this.windowById(F);if(q?.win)return q.win.close()}async quit(O){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(O,F){await this.lifecycleMainService.kill(F)}async resolveProxy(O,F){return this.windowById(O)?.win?.webContents?.session?.resolveProxy(F)}findFreePort(O,F,q,ne,J=1){return(0,g.findFreePort)(F,q,ne,J)}async openDevTools(O,F){const q=this.windowById(O);q?.win&&q.win.webContents.openDevTools(F)}async toggleDevTools(O){const F=this.windowById(O);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(O,F){const q=this.windowById(O);q?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&q.win.webContents.sendInputEvent(F)}async profileRenderer(O,F,q){const ne=this.windowById(O);if(!ne||!ne.win)throw new Error;return await new R.WindowProfiler(ne.win,F,this.logService).inspect(q)}async windowsGetStringRegKey(O,F,q,ne){if(!v.isWindows)return;const J=await new Promise((ce,re)=>{K(["@vscode/windows-registry"],ce,re)});try{return J.GetStringRegKey(F,q,ne)}catch{return}}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};e.NativeHostMainService=E,Pe([M.memoize],E.prototype,"cliPath",null),e.NativeHostMainService=E=Pe([Z(0,i.IWindowsMainService),Z(1,h.IDialogMainService),Z(2,u.ILifecycleMainService),Z(3,c.IEnvironmentMainService),Z(4,t.ILogService),Z(5,l.IProductService),Z(6,s.IThemeMainService),Z(7,o.IWorkspacesManagementMainService)],E)}),define(ee[297],te([0,1,15,38,27,2,13,4,107,178,90,131,59,28,5,66,75,24,76,78,33,34,60,22,7,30,8]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const b="issue.processExplorerWindowState";let D=class{static{o=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(k,O,F,q,ne,J,ce,re,se,G,V){this.userEnv=k,this.environmentMainService=O,this.logService=F,this.diagnosticsService=q,this.diagnosticsMainService=ne,this.dialogMainService=J,this.nativeHostMainService=ce,this.protocolMainService=re,this.productService=se,this.stateService=G,this.windowsMainService=V,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){L.validatedIpcMain.on("vscode:listProcesses",async k=>{const O=[];try{O.push({name:(0,a.localize)(0,null),rootProcess:await(0,d.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,p.isRemoteDiagnosticError)(q)?O.push({name:q.hostName,rootProcess:q}):q.processes&&O.push({name:q.hostName,rootProcess:q.processes})})}catch(F){this.logService.error(`Listing processes failed: ${F}`)}this.safeSend(k,"vscode:listProcessesResponse",O)}),L.validatedIpcMain.on("vscode:workbenchCommand",(k,O)=>{const{id:F,from:q,args:ne}=O;let J;switch(q){case"processExplorer":J=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${q}`)}J?.webContents.send("vscode:runAction",{id:F,from:q,args:ne})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",k=>{this.processExplorerWindow?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async k=>{const O=await this.diagnosticsMainService.getMainDiagnostics(),F=[];for(const q of O.windows)F.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:ne}of t.UtilityProcess.getAll())F.push([q,ne]);this.safeSend(k,"vscode:pidToNameResponse",F)})}async openReporter(k){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=I.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const O=new _.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),q=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(q,F,{backgroundColor:k.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:k.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:k,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:g.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,O.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,O.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(k){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=I.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const O=new _.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),q=this.stateService.getItem(b,void 0),ne=R(q)?q:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(ne,F,{backgroundColor:k.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:k.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:k,product:g.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,O.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,O.dispose())});const J=()=>{if(!this.processExplorerWindow)return;const ce=this.processExplorerWindow.getSize(),re=this.processExplorerWindow.getPosition();if(!ce||!re)return;const se={width:ce[0],height:ce[1],x:re[0],y:re[1]};this.stateService.setItem(b,se)};this.processExplorerWindow.on("moved",J),this.processExplorerWindow.on("resized",J)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const k=await I.contentTracing.stopRecording(`${(0,P.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,k),buttons:[(0,a.localize)(5,null)]},I.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,k)}async getSystemStatus(){const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(k,O)}async $getSystemInfo(){const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(k,O)}async $getPerformanceInfo(){try{const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(k,O)}catch(k){throw this.logService.warn("issueService#getPerformanceInfo ",k.message),k}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(k){this.logService.error(k)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:k}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.issueReporterWindow);k===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:k}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.issueReporterWindow);return k===0}return!1}async $getIssueReporterUri(k){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const O=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!O)throw new Error("Window not found");const F=`vscode:triggerIssueUriRequestHandlerResponse${O.id}`;return n.Promises.withAsyncBody(async(q,ne)=>{const J=new l.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:F,extensionId:k}),L.validatedIpcMain.once(F,(ce,re)=>{q(s.URI.parse(re))});try{await(0,n.timeout)(5e3),J.cancel(),ne(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(F)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(k){k.isMinimized()&&k.restore(),k.focus()}safeSend(k,O,...F){k.sender.isDestroyed()||k.sender.send(O,...F)}createBrowserWindow(k,O,F,q){const ne=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:k.width,height:k.height,minWidth:300,minHeight:200,x:k.x,y:k.y,title:F.title,backgroundColor:F.backgroundColor||o.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return ne.setMenuBarVisibility(!1),ne}getWindowPosition(k,O,F){let q;const ne=I.screen.getAllDisplays();if(ne.length===1)q=ne[0];else{if(C.isMacintosh){const re=I.screen.getCursorScreenPoint();q=I.screen.getDisplayNearestPoint(re)}!q&&k&&(q=I.screen.getDisplayMatching(k.getBounds())),q||(q=I.screen.getPrimaryDisplay()||ne[0])}const J=q.bounds,ce={width:O,height:F,x:J.x+J.width/2-O/2,y:J.y+J.height/2-F/2};return J.width>0&&J.height>0&&(ce.x<J.x&&(ce.x=J.x),ce.y<J.y&&(ce.y=J.y),ce.x>J.x+J.width&&(ce.x=J.x),ce.y>J.y+J.height&&(ce.y=J.y),ce.width>J.width&&(ce.width=J.width),ce.height>J.height&&(ce.height=J.height)),ce}};e.IssueMainService=D,e.IssueMainService=D=o=Pe([Z(1,f.IEnvironmentMainService),Z(2,y.ILogService),Z(3,p.IDiagnosticsService),Z(4,v.IDiagnosticsMainService),Z(5,S.IDialogMainService),Z(6,w.INativeHostMainService),Z(7,h.IProtocolMainService),Z(8,m.IProductService),Z(9,u.IStateService),Z(10,i.IWindowsMainService)],D);function R(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ee[298],te([0,1,22,18,28,20,5,66,24,50,25,48,100]),function(K,e,I,L,r,_,M,C,d,a,p,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends S.AbstractUpdateService{constructor(w,g,m,h,c,P,u,t){super(w,g,h,c,P,t),this.telemetryService=m,this.nativeHostMainService=u}buildUpdateFeedUrl(w){return(0,S.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){this.url&&(this.setState(v.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},I.CancellationToken.None).then(a.asJson).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(v.State.Idle(1))):this.setState(v.State.AvailableForDownload(g))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const m=w?g.message||g:void 0;this.setState(v.State.Idle(1,m))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(v.State.Idle(1))}};e.LinuxUpdateService=f,e.LinuxUpdateService=f=Pe([Z(0,_.ILifecycleMainService),Z(1,L.IConfigurationService),Z(2,p.ITelemetryService),Z(3,r.IEnvironmentMainService),Z(4,a.IRequestService),Z(5,M.ILogService),Z(6,C.INativeHostMainService),Z(7,d.IProductService)],f)}),define(ee[299],te([0,1,47,45,27,8,22,54,9,7,142,21,18,28,16,20,5,66,24,50,25,48,100]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(o,b=1e3){for(;!o();)await(0,_.timeout)(b)}let s;function i(){return typeof s>"u"&&(L.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?s=0:d.basename(d.normalize(d.join(process.execPath,"..","..")))==="Program Files"?s=3:s=1),s}let n=class extends t.AbstractUpdateService{get cachePath(){const b=d.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return v.Promises.mkdir(b,{recursive:!0}).then(()=>b)}constructor(b,D,R,E,k,O,F,q,ne){super(b,D,E,k,O,ne),this.telemetryService=R,this.fileService=F,this.nativeHostMainService=q,b.setRelaunchHandler(this)}handleRelaunch(b){return b?.addArgs||b?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(u.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(b){let D="win32";switch(process.arch!=="ia32"&&(D+=`-${process.arch}`),i()){case 1:D+="-archive";break;case 3:D+="-msi";break;default:this.productService.target==="user"&&(D+="-user")}return(0,t.createUpdateURL)(D,b,this.productService)}doCheckForUpdates(b){this.url&&(this.setState(u.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},M.CancellationToken.None).then(c.asJson).then(D=>{const R=i();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(u.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(E=>v.Promises.exists(E).then(k=>{if(k)return Promise.resolve(E);const O=D.url,F=D.hash,q=`${E}.tmp`;return this.requestService.request({url:O},M.CancellationToken.None).then(ne=>this.fileService.writeFile(a.URI.file(q),ne.stream)).then(F?()=>(0,p.checksum)(q,D.hash):()=>{}).then(()=>v.Promises.rename(q,E,!1)).then(()=>E)})).then(E=>{const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:E},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(D)):this.setState(u.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const R=b?D.message||D:void 0;this.setState(u.State.Idle(i(),R))}))}async doDownloadUpdate(b){b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(u.State.Idle(i()))}async getUpdatePackagePath(b){const D=await this.cachePath;return d.join(D,`CodeSetup-${this.productService.quality}-${b}.exe`)}async cleanup(b=null){const D=b?O=>!new RegExp(`${this.productService.quality}-${b}\\.exe$`).test(O):()=>!0,R=await this.cachePath,k=(await v.Promises.readdir(R)).filter(D).map(async O=>{try{await v.Promises.unlink(d.join(R,O))}catch{}});await Promise.all(k)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const b=this.state.update;this.setState(u.State.Updating(b));const D=await this.cachePath;this.availableUpdate.updateFilePath=d.join(D,`CodeSetup-${this.productService.quality}-${b.version}.flag`),await v.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(i()))});const E=`${this.productService.win32MutexName}-ready`,k=await new Promise((O,F)=>{K(["@vscode/windows-mutex"],O,F)});l(()=>k.isActive(E)).then(()=>this.setState(u.State.Ready(b)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):i()==3?(0,I.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(b){if(this.state.type!=="idle")return;const D=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown"};this.setState(u.State.Downloading(R)),this.availableUpdate={packagePath:b},D?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(R)):this.setState(u.State.Ready(R))}};e.Win32UpdateService=n,Pe([C.memoize],n.prototype,"cachePath",null),e.Win32UpdateService=n=Pe([Z(0,w.ILifecycleMainService),Z(1,S.IConfigurationService),Z(2,P.ITelemetryService),Z(3,f.IEnvironmentMainService),Z(4,c.IRequestService),Z(5,g.ILogService),Z(6,y.IFileService),Z(7,m.INativeHostMainService),Z(8,h.IProductService)],n)}),define(ee[300],te([0,1,15,8,22,49,3,2,13,9,64,4,7,188,63,18,59,28,62,16,20,5,24,76,250,80,25,102,77,78,30,29,53,127,134,39,34,52,65,23]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n,o,b,D,R,E,k,O,F,q,ne,J,ce,re){"use strict";var se;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(G||(G={}));let V=class extends C.Disposable{static{se=this}static{this.windowControlHeightStateStorageKey="windowControlHeight"}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,E.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,U,H,Q,ie,oe,N,A,T,$,B,z,j,ae,fe,ue,de,be,we,ye){super(),this.logService=U,this.loggerMainService=H,this.environmentMainService=Q,this.policyService=ie,this.userDataProfilesService=oe,this.fileService=N,this.applicationStorageMainService=A,this.storageMainService=T,this.configurationService=$,this.themeMainService=B,this.workspacesManagementMainService=z,this.backupMainService=j,this.telemetryService=ae,this.dialogMainService=fe,this.lifecycleMainService=ue,this.productService=de,this.protocolMainService=be,this.windowsMainService=we,this.stateService=ye,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Ne]=this.restoreWindowState(W.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const pe=this.windowState.mode===0||this.windowState.mode===3,ve=this.configurationService.getValue("window"),Y={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!pe,title:this.productService.nameLong,webPreferences:{preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(ve?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};v.isLinux?Y.icon=(0,a.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):v.isWindows&&!this.environmentMainService.isBuilt&&(Y.icon=(0,a.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.useNativeFullScreen()&&(Y.fullscreenable=!1),v.isMacintosh&&(Y.acceptFirstMouse=!0,ve?.clickThroughInactive===!1&&(Y.acceptFirstMouse=!1));const le=v.isMacintosh&&ve?.nativeTabs===!0;le&&(Y.tabbingIdentifier=this.productService.nameShort);const ge=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ge&&(Y.titleBarStyle="hidden",v.isMacintosh||(Y.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService))){const De=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Le=F.Color.fromHex(De).isDarker()?"#FFFFFF":"#000000";Y.titleBarOverlay={height:29,color:De,symbolColor:Le},this.hasWindowControlOverlay=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this._win=new I.BrowserWindow(Y),(0,p.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,v.isMacintosh&&ge&&this._win.setSheetOffset(22),ge&&(v.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService)||v.isMacintosh)){const De=this.stateService.getItem(se.windowControlHeightStateStorageKey);De&&this.updateWindowControls({height:De})}v.isWindows&&ge&&this._win.hookWindowMessage(278,()=>{const[Le,Fe]=this._win.getPosition(),Ae=I.screen.getCursorScreenPoint(),ze=Ae.x-Le,Be=Ae.y-Fe;return(()=>!(ze>30&&Be>=0&&Be<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:ze,y:Be})),0}),(v.isMacintosh||v.isWindows)&&Ne&&(!le||I.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(De=>typeof De=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),pe&&((0,p.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(W){v.isMacintosh?this._win.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return v.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){v.isMacintosh&&this._win.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return v.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(W){v.isMacintosh&&W?.force&&I.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function U(){H.dispose(),Q.dispose(),W()}const H=this.onDidClose(()=>U()),Q=this.onWillLoad(()=>U())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,H)=>this.onWindowError(2,{...H})),this._win.webContents.on("did-fail-load",(U,H,Q)=>this.onWindowError(3,{reason:Q,exitCode:H})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this._config&&(this._config.maximized=!0),I.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this._config&&(this._config.maximized=!1),I.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(U=>this.onConfigurationUpdated(U))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(U,H)=>{const Q=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,Q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,U){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:U?.reason,code:U?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this._config?.workspace?(0,f.localize)(5,null):void 0},this._win);if(H!==2){const ie=H===0;await this.destroyWindow(ie,Q)}}else if(W===2){let H;U?H=(0,f.localize)(7,null,U.reason,U.exitCode??"<unknown>"):H=(0,f.localize)(6,null);const{response:Q,checkboxChecked:ie}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:H,detail:this._config?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this._config?.workspace?(0,f.localize)(13,null):void 0},this._win),oe=Q===0;await this.destroyWindow(oe,ie)}break}}async destroyWindow(W,U){const H=this._config?.workspace;if(U&&H)try{const Q=this.storageMainService.workspaceStorage(H);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.logService.error(Q)}if(this._onDidDestroy.fire(),this._win?.destroy(),W&&this._config){let Q,ie;(0,E.isSingleFolderWorkspaceIdentifier)(H)?Q={folderUri:H.uri}:(0,E.isWorkspaceIdentifier)(H)?Q={workspaceUri:H.configPath}:ie=!0,(0,re.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:ie,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const U=this.getMenuBarVisibility();U!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=U,this.setMenuBarVisibility(U))}if(!W||W.affectsConfiguration("http.proxy")){let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=H;const Q=U||"",ie=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${Q}', bypassing '${ie}'`),this._win.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:ie,pacScript:""})}}}addTabbedWindow(W){v.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,U=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!U.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,U),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(d.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:U.isReload?3:H?2:1})}updateConfiguration(W,U){const H=(this._config??this.pendingLoadConfig)?.userEnv;if(H){const Q=(0,h.isLaunchedFromCli)(H)&&!(0,h.isLaunchedFromCli)(W.userEnv),ie=this.isExtensionDevelopmentHost;(Q||ie)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(W["disable-extensions"]=U.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),W.perfMarks=(0,p.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const U=Object.assign({},this._config);U.workspace=await this.validateWorkspaceBeforeReload(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&W&&(U.verbose=W.verbose,U.debugId=W.debugId,U.extensionEnvironment=W.extensionEnvironment,U["inspect-extensions"]=W["inspect-extensions"],U["inspect-brk-extensions"]=W["inspect-brk-extensions"],U["extensions-dir"]=W["extensions-dir"]),U.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.policyService.serialize(),U.continueOn=this.environmentMainService.continueOn,U.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},U.logLevel=this.loggerMainService.getLogLevel(),U.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,E.isWorkspaceIdentifier)(W.workspace)){const U=W.workspace.configPath;if(U.scheme===d.Schemas.file&&!await this.fileService.exists(U))return}else if((0,E.isSingleFolderWorkspaceIdentifier)(W.workspace)){const U=W.workspace.uri;if(U.scheme===d.Schemas.file&&!await this.fileService.exists(U))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,O.defaultWindowState)();if(this.isFullScreen){let H;try{H=I.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,O.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||Q.width,height:this.windowState.height||Q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let U;if(!v.isMacintosh&&this._win.isMaximized()?U=0:U=1,U===0?W.mode=0:W.mode=1,U===1||U===0){let H;U===1?H=this.getBounds():H=this._win.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W}updateWindowControls(W){if(W.height&&this.stateService.setItem(se.windowControlHeightStateStorageKey,W.height),v.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(v.isMacintosh&&W.height!==void 0){const U=(W.height-15)/2;U?this._win.setWindowButtonPosition({x:U,y:U}):this._win.setWindowButtonPosition(null)}}restoreWindowState(W){(0,p.mark)("code/willRestoreCodeWindowState");let U=!1;if(W)try{const H=I.screen.getAllDisplays();U=H.length>1,W=this.validateWindowState(W,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[W||(0,O.defaultWindowState)(),U]}validateWindowState(W,U){if(this.logService.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const ie=this.getWorkingArea(U[0]);if(ie){let oe=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!ie||(W.x<ie.x&&(W.x=ie.x),W.y<ie.y&&(W.y=ie.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",ie),oe(),W.width>ie.width&&(W.width=ie.width),W.height>ie.height&&(W.height=ie.height),W.x>ie.x+ie.width-128&&(W.x=ie.x+ie.width-W.width),W.y>ie.y+ie.height-128&&(W.y=ie.y+ie.height-W.height),oe()}return W}if(W.display&&W.mode===3){const ie=U.find(oe=>oe.id===W.display);if(ie&&typeof ie.bounds?.x=="number"&&typeof ie.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,O.defaultWindowState)(3);return oe.x=ie.bounds.x,oe.y=ie.bounds.y,oe}}let H,Q;try{H=I.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),Q=this.getWorkingArea(H)}catch{}if(H&&Q&&W.x+W.width>Q.x&&W.y+W.height>Q.y&&W.x<Q.x+Q.width&&W.y<Q.y+Q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",Q),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,U]=this._win.getPosition(),[H,Q]=this._win.getSize();return{x:W,y:U,width:H,height:Q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){this.useNativeFullScreen()?this.setNativeFullScreen(W):this.setSimpleFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(W){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W)}doSetNativeFullScreen(W){v.isMacintosh&&(this.transientIsNativeFullScreen=W,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(W)}setSimpleFullScreen(W){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(W),this._win.webContents.focus()}useNativeFullScreen(){const W=this.configurationService.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let W=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,U=!0){v.isMacintosh||(W==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,f.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const U=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!U),this._win.autoHideMenuBar=U;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(W,U,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{U.isCancellationRequested||this.send(W,...H)})}send(W,...U){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...U)}catch(H){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,_.toErrorMessage)(H)}`)}}}updateTouchBar(W){v.isMacintosh&&this.touchBarGroups.forEach((U,H)=>{const Q=W[H];U.segments=this.createTouchBarGroupSegments(Q)})}createTouchBar(){if(v.isMacintosh){for(let W=0;W<10;W++){const U=this.createTouchBarGroup();this.touchBarGroups.push(U)}this._win.setTouchBar(new I.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const U=this.createTouchBarGroupSegments(W),H=new I.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:H.segments[Q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(W=[]){return W.map(H=>{let Q;H.icon&&!o.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===d.Schemas.file&&(Q=I.nativeImage.createFromPath(S.URI.revive(H.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let ie;return typeof H.title=="string"?ie=H.title:ie=H.title.value,{id:H.id,label:Q?void 0:ie,icon:Q}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};e.CodeWindow=V,e.CodeWindow=V=se=Pe([Z(1,u.ILogService),Z(2,ce.ILoggerMainService),Z(3,m.IEnvironmentMainService),Z(4,q.IPolicyService),Z(5,J.IUserDataProfilesMainService),Z(6,c.IFileService),Z(7,i.IApplicationStorageMainService),Z(8,i.IStorageMainService),Z(9,w.IConfigurationService),Z(10,b.IThemeMainService),Z(11,k.IWorkspacesManagementMainService),Z(12,y.IBackupMainService),Z(13,n.ITelemetryService),Z(14,g.IDialogMainService),Z(15,P.ILifecycleMainService),Z(16,t.IProductService),Z(17,l.IProtocolMainService),Z(18,R.IWindowsMainService),Z(19,ne.IStateService)],V)}),define(ee[81],te([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,80,97,29,53,31]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let l=class extends C.Disposable{static{t=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(i,n,o,b){super(),this.logService=i,this.workspacesManagementMainService=n,this.lifecycleMainService=o,this.applicationStorageMainService=b,this._onDidChangeRecentlyOpened=this._register(new _.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const D of i)if((0,h.isRecentWorkspace)(D))!this.workspacesManagementMainService.isUntitledWorkspace(D.workspace)&&!this.containsWorkspace(n,D.workspace)&&n.push(D);else if((0,h.isRecentFolder)(D))this.containsFolder(n,D.folderUri)||n.push(D);else{const R=this.containsFile(o,D.fileUri),E=D.fileUri.scheme===d.Schemas.file&&t.COMMON_FILES_FILTER.indexOf((0,p.basename)(D.fileUri))>=0;!R&&!E&&(o.push(D),a.isWindows&&D.fileUri.scheme===d.Schemas.file&&I.app.addRecentDocument(D.fileUri.fsPath))}const b=await this.mergeEntriesFromStorage({workspaces:n,files:o});n=b.workspaces,o=b.files,n.length>t.MAX_TOTAL_RECENT_ENTRIES&&(n.length=t.MAX_TOTAL_RECENT_ENTRIES),o.length>t.MAX_TOTAL_RECENT_ENTRIES&&(o.length=t.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:o}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const n=R=>{const E=this.location(R);for(const k of i)if(p.extUriBiasedIgnorePathCase.isEqual(k,E))return!1;return!0},o=await this.getRecentlyOpened(),b=o.workspaces.filter(n),D=o.files.filter(n);(b.length!==o.workspaces.length||D.length!==o.files.length)&&(await this.saveRecentlyOpened({files:D,workspaces:b}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const n=new u.ResourceMap(D=>p.extUriBiasedIgnorePathCase.getComparisonKey(D));if(i?.workspaces)for(const D of i.workspaces)n.set(this.location(D),D);const o=new u.ResourceMap(D=>p.extUriBiasedIgnorePathCase.getComparisonKey(D));if(i?.files)for(const D of i.files)o.set(this.location(D),D);const b=await this.getRecentlyOpenedFromStorage();for(const D of b.workspaces){const R=n.get(this.location(D));R?R.label=R.label??D.label:n.set(this.location(D),D)}for(const D of b.files){const R=o.get(this.location(D));R?R.label=R.label??D.label:o.set(this.location(D),D)}return{workspaces:[...n.values()],files:[...o.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const n=this.applicationStorageMainService.get(t.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,h.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(t.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,h.toStoreData)(i)),-1,1)}location(i){return(0,h.isRecentFolder)(i)?i.folderUri:(0,h.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,n){return!!i.find(o=>(0,h.isRecentWorkspace)(o)&&o.workspace.id===n.id)}containsFolder(i,n){return!!i.find(o=>(0,h.isRecentFolder)(o)&&p.extUriBiasedIgnorePathCase.isEqual(o.folderUri,n))}containsFile(i,n){return!!i.find(o=>p.extUriBiasedIgnorePathCase.isEqual(o.fileUri,n))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){a.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!a.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const D of I.app.getJumpListSettings().removedItems){const R=D.args;if(R){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);E&&n.push(v.URI.parse(E[2]))}}await this.removeRecentlyOpened(n);let o=!1;const b=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,t.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(D=>{const R=(0,h.isRecentWorkspace)(D)?D.workspace:D.folderUri,{title:E,description:k}=this.getWindowsJumpListLabel(R,D.label);let O;return v.URI.isUri(R)?O=`--folder-uri "${R.toString()}"`:(o=!0,O=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:k.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));b.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:b})}i.push({type:"recent"});try{const n=I.app.setJumpList(i);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(i,n){if(n)return{title:(0,M.splitRecentLabel)(n).name,description:n};if(v.URI.isUri(i))return{title:(0,p.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,p.basename)(i.configPath);return o.endsWith(c.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,o),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,M.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!a.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let D=0;D<i.workspaces.length&&o<t.MAX_MACOS_DOCK_RECENT_WORKSPACES;D++){const R=this.location(i.workspaces[D]);if(R.scheme===d.Schemas.file){const E=(0,p.originalFSPath)(R);await S.Promises.exists(E)&&(n.push(E),o++)}}const b=[];for(let D=0;D<i.files.length&&o<t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;D++){const R=this.location(i.files[D]);if(R.scheme===d.Schemas.file){const E=(0,p.originalFSPath)(R);if(t.COMMON_FILES_FILTER.includes((0,p.basename)(R))||n.includes(E))continue;await S.Promises.exists(E)&&(b.push(E),o++)}}b.reverse().forEach(D=>I.app.addRecentDocument(D)),n.reverse().forEach(D=>I.app.addRecentDocument(D))}};e.WorkspacesHistoryMainService=l,e.WorkspacesHistoryMainService=l=t=Pe([Z(0,g.ILogService),Z(1,P.IWorkspacesManagementMainService),Z(2,w.ILifecycleMainService),Z(3,m.IApplicationStorageMainService)],l)}),define(ee[301],te([0,1,15,8,22,46,4,7,179,18,28,20,5,229,66,24,34,25,48,78,30,81]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const l="menu";let s=class{static{t=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(o,b,D,R,E,k,O,F,q,ne,J){this.updateService=o,this.configurationService=b,this.windowsMainService=D,this.environmentMainService=R,this.telemetryService=E,this.workspacesHistoryMainService=k,this.stateService=O,this.lifecycleMainService=F,this.logService=q,this.nativeHostMainService=ne,this.productService=J,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateService.getItem(t.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(k,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(k,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(k,O,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:l}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(k,O,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:l}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(k,O,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:l}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.youTubeUrl;o&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(o,"openYouTubeUrl"));const b=this.productService.requestFeatureUrl;b&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(b,"openUserVoiceUrl"));const D=this.productService.reportIssueUrl;D&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(D,"openReportIssues"));const R=this.productService.licenseUrl;R&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const k=R.indexOf("?")>0?"&":"?";this.openUrl(`${R}${k}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(R,"openLicenseUrl")});const E=this.productService.privacyStatementUrl;E&&R&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(E,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,b){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateService.setItem(t.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){M.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){M.isMacintosh&&(this.noActiveWindow=!I.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=I.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){I.Menu.setApplicationMenu(M.isMacintosh?new I.Menu:null);return}const b=new I.Menu;let D;if(M.isMacintosh){const E=new I.Menu;D=new I.MenuItem({label:this.productService.nameShort,submenu:E}),this.setMacApplicationMenu(E),b.append(D)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const E=new I.Menu;E.append(new I.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),I.app.dock.setMenu(E)}if(this.shouldDrawMenu("File")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:E});this.setMenuById(E,"File"),b.append(k)}if(this.shouldDrawMenu("Edit")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:E});this.setMenuById(E,"Edit"),b.append(k)}if(this.shouldDrawMenu("Selection")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:E});this.setMenuById(E,"Selection"),b.append(k)}if(this.shouldDrawMenu("View")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:E});this.setMenuById(E,"View"),b.append(k)}if(this.shouldDrawMenu("Go")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:E});this.setMenuById(E,"Go"),b.append(k)}if(this.shouldDrawMenu("Run")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:E});this.setMenuById(E,"Run"),b.append(k)}if(this.shouldDrawMenu("Terminal")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:E});this.setMenuById(E,"Terminal"),b.append(k)}let R;if(this.shouldDrawMenu("Window")){const E=new I.Menu;R=new I.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:E,role:"window"}),this.setMacWindowMenu(E)}if(R&&b.append(R),this.shouldDrawMenu("Help")){const E=new I.Menu,k=new I.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:E,role:"help"});this.setMenuById(E,"Help"),b.append(k)}b.items&&b.items.length>0?I.Menu.setApplicationMenu(b):I.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const b=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),D=this.getUpdateMenuItems();let R;if(this.shouldDrawMenu("Preferences")){const ce=new I.Menu;this.setMenuById(ce,"Preferences"),R=new I.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:ce})}const E=new I.Menu,k=new I.MenuItem({label:d.localize(12,null),role:"services",submenu:E}),O=new I.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new I.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new I.MenuItem({label:d.localize(15,null),role:"unhide"}),ne=new I.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:async(ce,re,se)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||I.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.confirmBeforeQuit(se)&&this.nativeHostMainService.quit(void 0)}})),J=[b];J.push(...D),R&&J.push(i(),R),J.push(i(),k,i(),O,F,q,i(),ne),J.forEach(ce=>o.append(ce))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const b=this.configurationService.getValue("window.confirmBeforeClose");if(b==="always"||b==="keyboardOnly"&&this.isKeyboardEvent(o)){const{response:D}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return D===0}return!0}shouldDrawMenu(o){if(!M.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,b){b.forEach(D=>{if((0,f.isMenubarMenuItemSeparator)(D))o.append(i());else if((0,f.isMenubarMenuItemSubmenu)(D)){const R=new I.Menu,E=new I.MenuItem({label:this.mnemonicLabel(D.label),submenu:R});this.setMenu(R,D.submenu.items),o.append(E)}else(0,f.isMenubarMenuItemRecentAction)(D)?o.append(this.createOpenRecentMenuItem(D)):(0,f.isMenubarMenuItemAction)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[D.id]?o.append(new I.MenuItem(this.likeAction(D.id,{label:this.mnemonicLabel(D.label),click:this.fallbackMenuHandlers[D.id]}))):o.append(this.createMenuItem(D.label,D.id,!1,D.checked)):o.append(this.createMenuItem(D.label,D.id,D.enabled!==!1,!!D.checked)):o.append(this.createMenuItem(D.label,D.id,D.enabled!==!1,!!D.checked)))})}setMenuById(o,b){this.menubarMenus&&this.menubarMenus[b]&&this.setMenu(o,this.menubarMenus[b].items)}insertCheckForUpdatesItems(o){const b=this.getUpdateMenuItems();b.length&&(b.forEach(D=>o.append(D)),o.append(i()))}createOpenRecentMenuItem(o){const b=C.URI.revive(o.uri),D=o.id,R=D==="openRecentFile"?{fileUri:b}:D==="openRecentWorkspace"?{workspaceUri:b}:{folderUri:b};return new I.MenuItem(this.likeAction(D,{label:o.label,click:async(E,k,O)=>{const F=this.isOptionClick(O);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[R],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([b])}},!1))}isOptionClick(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,b,D){const R={label:this.mnemonicLabel(o),role:D,enabled:!0};return new I.MenuItem(this.withKeybinding(b,R))}setMacWindowMenu(o){const b=new I.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),D=new I.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),R=new I.MenuItem({label:d.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),E=this.createMenuItem(d.localize(23,null),"workbench.action.switchWindow"),k=[];this.currentEnableNativeTabs&&(k.push(i()),k.push(this.createMenuItem(d.localize(24,null),"workbench.action.newWindowTab")),k.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),k.push(this.createRoleMenuItem(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),k.push(this.createRoleMenuItem(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),k.push(this.createRoleMenuItem(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[b,D,i(),E,...k,i(),R].forEach(O=>o.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new I.MenuItem({label:this.mnemonicLabel(d.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.mnemonicLabel(d.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.mnemonicLabel(d.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new I.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.mnemonicLabel(d.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(o,b,D,R){const E=this.mnemonicLabel(o),k=typeof b=="function"?b:(J,ce,re)=>{const se=J?J.userSettingsLabel:null;let G=b;Array.isArray(b)&&(G=this.isOptionClick(re)?b[1]:b[0]),se&&re.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:se}):this.runActionInRenderer({type:"commandId",commandId:G})},O=typeof D=="boolean"?D:this.windowsMainService.getWindowCount()>0,F=typeof R=="boolean"?R:!1,q={label:E,click:k,enabled:O};F&&(q.type="checkbox",q.checked=F);let ne;return typeof b=="string"?ne=b:Array.isArray(b)&&(ne=b[0]),M.isMacintosh&&(ne==="editor.action.clipboardCutAction"?q.role="cut":ne==="editor.action.clipboardCopyAction"?q.role="copy":ne==="editor.action.clipboardPasteAction"&&(q.role="paste"),ne==="undo"?q.click=this.makeContextAwareClickHandler(k,{inDevTools:J=>J.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?q.click=this.makeContextAwareClickHandler(k,{inDevTools:J=>J.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(q.click=this.makeContextAwareClickHandler(k,{inDevTools:J=>J.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.withKeybinding(ne,q))}makeContextAwareClickHandler(o,b){return(D,R,E)=>{const k=I.BrowserWindow.getFocusedWindow();if(!k)return b.inNoWindow();if(k.webContents.isDevToolsFocused()&&k.webContents.devToolsWebContents)return b.inDevTools(k.webContents.devToolsWebContents);o(D,R||k,E)}}runActionInRenderer(o){let b=I.BrowserWindow.getFocusedWindow();if(!b){const R=this.windowsMainService.getLastActiveWindow();R?.isMinimized()&&(b=R.win)}const D=b?this.windowsMainService.getWindowById(b.id):void 0;if(D){if(this.logService.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.environmentMainService.isBuilt&&!D.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const R={id:o.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",r.CancellationToken.None,R)}else{const R={userSettingsLabel:o.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,R)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,b){const D=typeof o=="string"?this.keybindings[o]:void 0;if(D?.label){if(D.isNative!==!1)b.accelerator=D.label,b.userSettingsLabel=D.userSettingsLabel;else if(typeof b.label=="string"){const R=b.label.indexOf("[");R>=0?b.label=`${b.label.substr(0,R)} [${D.label}]`:b.label=`${b.label} [${D.label}]`}}else b.accelerator=void 0;return b}likeAction(o,b,D=!b.accelerator){D&&(b=this.withKeybinding(o,b));const R=b.click;return b.click=(E,k,O)=>{this.reportMenuActionTelemetry(o),R?.(E,k,O)},b}openUrl(o,b){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(b)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:l})}mnemonicLabel(o){return(0,_.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};e.Menubar=s,e.Menubar=s=t=Pe([Z(0,h.IUpdateService),Z(1,a.IConfigurationService),Z(2,P.IWindowsMainService),Z(3,p.IEnvironmentMainService),Z(4,m.ITelemetryService),Z(5,u.IWorkspacesHistoryMainService),Z(6,g.IStateService),Z(7,v.ILifecycleMainService),Z(8,S.ILogService),Z(9,y.INativeHostMainService),Z(10,w.IProductService)],s);function i(){return new I.MenuItem({type:"separator"})}}),define(ee[302],te([0,1,6,20,5,301]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let M=class{constructor(d,a,p){this.instantiationService=d,this.lifecycleMainService=a,this.logService=p,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(_.Menubar)}async updateMenubar(d,a){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(a,d)}};e.MenubarMainService=M,e.MenubarMainService=M=Pe([Z(0,I.IInstantiationService),Z(1,L.ILifecycleMainService),Z(2,r.ILogService)],M)}),define(ee[303],te([0,1,15,21,130,27,23,22,3,33,46,2,13,9,64,4,35,19,12,7,189,63,18,59,28,16,6,20,5,75,76,58,34,78,300,129,296,29,98,81,53,77,39,52,65]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n,o,b,D,R,E,k,O,F,q,ne,J,ce,re,se,G,V,x,W){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(oe){return(0,J.isWorkspaceIdentifier)(oe?.workspace)}function Q(oe){return(0,J.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let ie=class extends v.Disposable{static{U=this}static{this.WINDOWS=[]}constructor(N,A,T,$,B,z,j,ae,fe,ue,de,be,we,ye,ke,Ne,pe,ve){super(),this.machineId=N,this.initialUserEnv=A,this.logService=T,this.loggerService=$,this.stateService=B,this.policyService=z,this.environmentMainService=j,this.userDataProfilesMainService=ae,this.lifecycleMainService=fe,this.backupMainService=ue,this.configurationService=de,this.workspacesHistoryMainService=be,this.workspacesManagementMainService=we,this.instantiationService=ye,this.dialogMainService=ke,this.fileService=Ne,this.protocolMainService=pe,this.themeMainService=ve,this._onDidOpenWindow=this._register(new d.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new d.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new d.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new d.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new d.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ne.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(N=>this._onDidSignalReadyWindow.fire(N.window))),this._register(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const A=new v.DisposableStore;if(A.add(d.Event.any(N.onDidClose,N.onDidDestroy)(()=>A.dispose())),N.config.extensionDevelopmentPath)for(const T of N.config.extensionDevelopmentPath)A.add(this.protocolMainService.addValidFileRoot(T));N.config.extensionTestsPath&&A.add(this.protocolMainService.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,A){const T=this.environmentMainService.args,$=A?.remoteAuthority||void 0,B=!0,z=A?.forceReuseWindow,j=!z;return this.open({...N,cli:T,forceEmpty:B,forceNewWindow:j,forceReuseWindow:z,remoteAuthority:$})}openExistingWindow(N,A){N.focus(),this.handleWaitMarkerFile(A,[N])}async open(N){this.logService.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const A=[],T=[],$=[],B=[],z=[];let j,ae=0;const fe=await this.getPathsToOpen(N);this.logService.trace("windowsManager#open pathsToOpen",fe);for(const ye of fe)Q(ye)?N.addMode?A.push(ye):T.push(ye):H(ye)?$.push(ye):ye.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),j.filesToOpenOrCreate.push(ye)):ye.backupPath?z.push({backupFolder:(0,f.basename)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):ae++;N.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),N.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&N.waitMarkerFileURI&&(j.filesToWait={paths:(0,M.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(B.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),$.push(...B),z.push(...this.backupMainService.getEmptyWindowBackups())):z.length=0;const{windows:ue,filesOpenedInWindow:de}=await this.doOpen(N,$,T,z,ae,j,A);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${$.length}, foldersToOpen: ${T.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ae})`),ue.length>1)if(de)de.focus();else{const ye=this.windowsStateHandler.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let ke=!0,Ne=!0;if(ye){const pe=ue.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),ke=!1,Ne=!1)}if(ke)for(let pe=ue.length-1;pe>=0;pe--){const ve=ue[pe];if(!(ve.openedWorkspace&&B.some(Y=>ve.openedWorkspace&&Y.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&z.some(Y=>ve.backupPath&&Y.backupFolder===(0,f.basename)(ve.backupPath)))){ve.focus(),Ne=!1;break}}Ne&&ue[ue.length-1].focus()}const be=j&&j.filesToDiff.length>0,we=j&&j.filesToMerge.length>0;if(!ue.some(ye=>ye.isExtensionDevelopmentHost)&&!be&&!we&&!N.noRecentEntry){const ye=[];for(const ke of fe)H(ke)&&!ke.transient?ye.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):Q(ke)?ye.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&ye.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ye)}return this.handleWaitMarkerFile(N,ue),ue}handleWaitMarkerFile(N,A){const T=N.waitMarkerFileURI;N.context===0&&T&&A.length===1&&A[0]&&(async()=>{await A[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}async doOpen(N,A,T,$,B,z,j){const ae=[];let fe;function ue(pe,ve){ae.push(pe),ve&&(fe=pe,z=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:be}=this.shouldOpenNewWindow(N);if(!N.initialStartup&&j.length>0){const pe=j[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(pe);ve&&ue(this.doAddFoldersToExistingWindow(ve,j.map(Y=>Y.workspace.uri)))}const we=T.length+A.length+$.length;if(z&&we===0){const pe=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],ve=this.getWindows().filter(le=>z&&(0,m.isEqualAuthority)(le.remoteAuthority,z.remoteAuthority));let Y;pe?.fileUri&&!be&&((N.context===4||N.context===0||N.context===1)&&(Y=await(0,q.findWindowOnFile)(ve,pe.fileUri,async le=>le.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(le.configPath):void 0)),Y||(Y=this.doGetLastActiveWindow(ve))),Y?(0,J.isWorkspaceIdentifier)(Y.openedWorkspace)?A.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(Y.openedWorkspace)?T.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(N,Y,z),!0):ue(await this.openInBrowserWindow({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const ye=(0,M.distinct)(A,pe=>pe.workspace.id);if(ye.length>0){const pe=(0,M.coalesce)(ye.map(ve=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(pe.length>0){const ve=pe[0],Y=(0,m.isEqualAuthority)(z?.remoteAuthority,ve.remoteAuthority)?z:void 0;ue(this.doOpenFilesInExistingWindow(N,ve,Y),!!Y),de=!0}for(const ve of ye){if(pe.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===ve.workspace.id))continue;const Y=ve.remoteAuthority,le=(0,m.isEqualAuthority)(z?.remoteAuthority,Y)?z:void 0;ue(await this.doOpenFolderOrWorkspace(N,ve,de,le),!!le),de=!0}}const ke=(0,M.distinct)(T,pe=>m.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(ke.length>0){const pe=(0,M.coalesce)(ke.map(ve=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(pe.length>0){const ve=pe[0],Y=(0,m.isEqualAuthority)(z?.remoteAuthority,ve.remoteAuthority)?z:void 0;ue(this.doOpenFilesInExistingWindow(N,ve,Y),!!Y),de=!0}for(const ve of ke){if(pe.some(ge=>(0,J.isSingleFolderWorkspaceIdentifier)(ge.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(ge.openedWorkspace.uri,ve.workspace.uri)))continue;const Y=ve.remoteAuthority,le=(0,m.isEqualAuthority)(z?.remoteAuthority,Y)?z:void 0;ue(await this.doOpenFolderOrWorkspace(N,ve,de,le),!!le),de=!0}}const Ne=(0,M.distinct)($,pe=>pe.backupFolder);if(Ne.length>0)for(const pe of Ne){const ve=pe.remoteAuthority,Y=(0,m.isEqualAuthority)(z?.remoteAuthority,ve)?z:void 0;ue(await this.doOpenEmpty(N,!0,ve,Y,pe),!!Y),de=!0}if(ae.length===0||z){z&&!B&&B++;const pe=z?z.remoteAuthority:N.remoteAuthority;for(let ve=0;ve<B;ve++)ue(await this.doOpenEmpty(N,de,pe,z),!!z),de=!0}return{windows:(0,M.distinct)(ae),filesOpenedInWindow:fe}}doOpenFilesInExistingWindow(N,A,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),A.focus();const $={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToMerge:T?.filesToMerge,filesToWait:T?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return A.sendWhenReady("vscode:openFiles",C.CancellationToken.None,$),A}doAddFoldersToExistingWindow(N,A){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:A}),N.focus();const T={foldersToAdd:A};return N.sendWhenReady("vscode:addFolders",C.CancellationToken.None,T),N}doOpenEmpty(N,A,T,$,B){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!B,remoteAuthority:T,filesToOpen:$,forceNewWindow:A});let z;return!A&&typeof N.contextWindowId=="number"&&(z=this.getWindowById(N.contextWindowId)),this.openInBrowserWindow({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:T,forceNewWindow:A,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:$,windowToUse:z,emptyWindowBackupInfo:B,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}doOpenFolderOrWorkspace(N,A,T,$,B){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:A,filesToOpen:$}),!T&&!B&&typeof N.contextWindowId=="number"&&(B=this.getWindowById(N.contextWindowId)),this.openInBrowserWindow({workspace:A.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:A.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:$,windowToUse:B,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async getPathsToOpen(N){let A,T=!1,$=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(A=await this.doExtractPathsFromAPI(N),T=!0):N.forceEmpty?A=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(A=await this.doExtractPathsFromCLI(N.cli),A.length===0&&A.push(Object.create(null)),T=!0):(A=await this.doGetPathsFromLastSession(),A.length===0&&A.push(Object.create(null)),$=!0),!N.addMode&&T){const B=A.filter(z=>Q(z));if(B.length>1){const z=B[0].remoteAuthority;if(B.every(j=>(0,m.isEqualAuthority)(j.remoteAuthority,z))){const j=await this.workspacesManagementMainService.createUntitledWorkspace(B.map(ae=>({uri:ae.workspace.uri})));A.push({workspace:j,remoteAuthority:z}),A=A.filter(ae=>!Q(ae))}}}if(N.initialStartup&&!$&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const B=await this.doGetPathsFromLastSession();A.unshift(...B.filter(z=>H(z)||Q(z)||z.backupPath))}return A}async doExtractPathsFromAPI(N){const A={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},T=await Promise.all((0,M.coalesce)(N.urisToOpen||[]).map(async $=>{const B=await this.resolveOpenable($,A);if(B)return B.label=$.label,B;const z=this.resourceFromOpenable($);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,P.localize)(0,null)],message:z.scheme===S.Schemas.file?(0,P.localize)(1,null):(0,P.localize)(2,null),detail:z.scheme===S.Schemas.file?(0,P.localize)(3,null,(0,p.getPathLabel)(z,{os:w.OS,tildify:this.environmentMainService})):(0,P.localize)(4,null,z.toString(!0))},I.BrowserWindow.getFocusedWindow()??void 0)}));return(0,M.coalesce)(T)}async doExtractPathsFromCLI(N){const A=[],T={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},$=N["folder-uri"];if($){const j=await Promise.all($.map(ae=>{const fe=this.cliArgToUri(ae);if(fe)return this.resolveOpenable({folderUri:fe},T)}));A.push(...(0,M.coalesce)(j))}const B=N["file-uri"];if(B){const j=await Promise.all(B.map(ae=>{const fe=this.cliArgToUri(ae);if(fe)return this.resolveOpenable((0,J.hasWorkspaceFileExtension)(ae)?{workspaceUri:fe}:{fileUri:fe},T)}));A.push(...(0,M.coalesce)(j))}const z=await Promise.all(N._.map(j=>T.remoteAuthority?this.doResolveRemotePath(j,T):this.doResolveFilePath(j,T)));return A.push(...(0,M.coalesce)(z)),A}cliArgToUri(N){try{const A=c.URI.parse(N);if(!A.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${N}`);return}return A.path?A:A.with({path:"/"})}catch(A){this.logService.error(`Invalid URI input string: ${N}, ${A.message}`)}}async doGetPathsFromLastSession(){const N=this.getRestoreWindowsSetting();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const A=[];N!=="one"&&A.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&A.push(this.windowsStateHandler.state.lastActiveWindow);const T=await Promise.all(A.map(async $=>{if($.workspace){const B=await this.resolveOpenable({workspaceUri:$.workspace.configPath},{remoteAuthority:$.remoteAuthority,rejectTransientWorkspaces:!0});if(H(B))return B}else if($.folderUri){const B=await this.resolveOpenable({folderUri:$.folderUri},{remoteAuthority:$.remoteAuthority});if(Q(B))return B}else if(N!=="folders"&&$.backupPath)return{backupPath:$.backupPath,remoteAuthority:$.remoteAuthority}}));return(0,M.coalesce)(T)}}}getRestoreWindowsSetting(){let N;return this.lifecycleMainService.wasRestarted?N="all":(N=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async resolveOpenable(N,A=Object.create(null)){const T=this.resourceFromOpenable(N);return T.scheme===S.Schemas.file?((0,O.isFileToOpen)(N)&&(A={...A,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,A)):this.doResolveRemoteOpenable(N,A)}doResolveRemoteOpenable(N,A){let T=this.resourceFromOpenable(N);const $=(0,E.getRemoteAuthority)(T)||A.remoteAuthority;if(T=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(T)),(0,O.isFileToOpen)(N)){if(A.gotoLineMode){const{path:B,line:z,column:j}=(0,a.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:B}),options:{selection:z?{startLineNumber:z,startColumn:j||1}:void 0},remoteAuthority:$}}return{fileUri:T,remoteAuthority:$}}else if((0,O.isWorkspaceToOpen)(N))return{workspace:(0,ce.getWorkspaceIdentifier)(T),remoteAuthority:$};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:$}}resourceFromOpenable(N){return(0,O.isWorkspaceToOpen)(N)?N.workspaceUri:(0,O.isFolderToOpen)(N)?N.folderUri:N.fileUri}async doResolveFilePath(N,A,T){let $,B;A.gotoLineMode&&({path:N,line:$,column:B}=(0,a.parseLineAndColumnAware)(N)),N=(0,a.sanitizeFilePath)((0,f.normalize)(N),(0,g.cwd)());try{const z=await L.Promises.stat(N);if(z.isFile()){if(!A.forceOpenWorkspaceAsFile){const j=await this.workspacesManagementMainService.resolveLocalWorkspace(c.URI.file(N));if(j)return j.transient&&A.rejectTransientWorkspaces?void 0:{workspace:{id:j.id,configPath:j.configPath},type:i.FileType.File,exists:!0,remoteAuthority:j.remoteAuthority,transient:j.transient}}return{fileUri:c.URI.file(N),type:i.FileType.File,exists:!0,options:{selection:$?{startLineNumber:$,startColumn:B||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(c.URI.file(N),z),type:i.FileType.Directory,exists:!0};if(!w.isWindows&&N==="/dev/null")return{fileUri:c.URI.file(N),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!T)return this.onUNCHostNotAllowed(N,A);const j=c.URI.file(N);if(this.workspacesHistoryMainService.removeRecentlyOpened([j]),A.ignoreFileNotFound)return{fileUri:j,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(N,A){const T=c.URI.file(N),{response:$,checkboxChecked:B}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],message:(0,P.localize)(8,null,T.authority),detail:(0,P.localize)(9,null,(0,p.getPathLabel)(T,{os:w.OS,tildify:this.environmentMainService})),checkboxLabel:(0,P.localize)(10,null,T.authority),cancelId:1});if($===0)return(0,r.addUNCHostToAllowlist)(T.authority),B&&this._register(d.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",C.CancellationToken.None,T.authority)})),this.doResolveFilePath(N,A,!0);if($===2)return I.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(N,A)}doResolveRemotePath(N,A){const T=N.charCodeAt(0),$=A.remoteAuthority;let B,z;A.gotoLineMode&&({path:N,line:B,column:z}=(0,a.parseLineAndColumnAware)(N)),T!==47&&((0,a.isWindowsDriveLetter)(T)&&N.charCodeAt(N.charCodeAt(1))===58&&(N=(0,a.toSlashes)(N)),N=`/${N}`);const j=c.URI.from({scheme:S.Schemas.vscodeRemote,authority:$,path:N});if(N.charCodeAt(N.length-1)!==47){if((0,J.hasWorkspaceFileExtension)(N))return A.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:B?{startLineNumber:B,startColumn:z||1}:void 0},remoteAuthority:A.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(j),remoteAuthority:$};if(A.gotoLineMode||f.posix.basename(N).indexOf(".")!==-1)return{fileUri:j,options:{selection:B?{startLineNumber:B,startColumn:z||1}:void 0},remoteAuthority:$}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:$}}shouldOpenNewWindow(N){const A=this.configurationService.getValue("window"),T=A?.openFoldersInNewWindow||"default",$=A?.openFilesInNewWindow||"off";let B=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(T==="on"||T==="off")&&(B=T==="on");let z=!1;return N.forceNewWindow||N.forceReuseWindow?z=!!N.forceNewWindow&&!N.forceReuseWindow:(w.isMacintosh?N.context===1&&(z=!0):N.context!==3&&N.context!==2&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!N.cli.extensionDevelopmentPath&&($==="on"||$==="off")&&(z=$==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(N,A){const T=(0,q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),N);if(T)return this.lifecycleMainService.reload(T,A.cli),T.focus(),[T];let $=A.cli["folder-uri"]||[],B=A.cli["file-uri"]||[],z=A.cli._;if(!z.length&&!$.length&&!B.length&&!A.cli.extensionTestsPath){const fe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ue=fe?.workspace??fe?.folderUri;ue&&(c.URI.isUri(ue)?ue.scheme===S.Schemas.file?z=[ue.fsPath]:$=[ue.toString()]:ue.configPath.scheme===S.Schemas.file?z=[(0,m.originalFSPath)(ue.configPath)]:B=[ue.configPath.toString()])}let j=A.remoteAuthority;for(const fe of N)if(fe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=c.URI.parse(fe),de=(0,E.getRemoteAuthority)(ue);de&&(j?(0,m.isEqualAuthority)(de,j)||this.logService.error("more than one extension development path authority"):j=de)}z=z.filter(fe=>{const ue=c.URI.file(fe);return(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,m.isEqualAuthority)((0,E.getRemoteAuthority)(ue),j)}),$=$.filter(fe=>{const ue=this.cliArgToUri(fe);return ue&&(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,m.isEqualAuthority)((0,E.getRemoteAuthority)(ue),j):!1}),B=B.filter(fe=>{const ue=this.cliArgToUri(fe);return ue&&(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,m.isEqualAuthority)((0,E.getRemoteAuthority)(ue),j):!1}),A.cli._=z,A.cli["folder-uri"]=$,A.cli["file-uri"]=B;const ae={context:A.context,cli:A.cli,forceNewWindow:!0,forceEmpty:!z.length&&!$.length&&!B.length,userEnv:A.userEnv,noRecentEntry:!0,waitMarkerFileURI:A.waitMarkerFileURI,remoteAuthority:j,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile};return this.open(ae)}async openInBrowserWindow(N){const A=this.configurationService.getValue("window"),T=this.getLastActiveWindow(),$=T?.profile??this.userDataProfilesMainService.defaultProfile;let B;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(B=N.windowToUse||T,B&&B.focus());const z={...this.environmentMainService.args,...N.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:$},homeDir:this.environmentMainService.userHome.with({scheme:S.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:S.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.initialUserEnv,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:S.Schemas.file}).fsPath,product:D.default,isInitialStartup:N.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,_.release)(),hostname:(0,_.hostname)(),arch:(0,_.arch)()},zoomLevel:typeof A?.zoomLevel=="number"?A.zoomLevel:void 0,autoDetectHighContrast:A?.autoDetectHighContrast??!0,autoDetectColorScheme:A?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(B){const j=B.config;!z.extensionDevelopmentPath&&j?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=j.extensionDevelopmentPath,z.extensionDevelopmentKind=j.extensionDevelopmentKind,z["enable-proposed-api"]=j["enable-proposed-api"],z.verbose=j.verbose,z["inspect-extensions"]=j["inspect-extensions"],z["inspect-brk-extensions"]=j["inspect-brk-extensions"],z.debugId=j.debugId,z.extensionEnvironment=j.extensionEnvironment,z["extensions-dir"]=j["extensions-dir"],z["disable-extensions"]=j["disable-extensions"]),z.loggers={global:z.loggers.global,window:j?.loggers.window??z.loggers.window}}else{const j=this.windowsStateHandler.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const ae=B=this.instantiationService.createInstance(F.CodeWindow,{state:j,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ae),U.WINDOWS.push(ae),this._onDidOpenWindow.fire(ae),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),d.Event.once(ae.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ae)),d.Event.once(ae.onDidClose)(()=>this.onWindowClosed(ae)),d.Event.once(ae.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ae)),ae.onDidTriggerSystemContextMenu(({x:ue,y:de})=>this._onDidTriggerSystemContextMenu.fire({window:ae,x:ue,y:de}));const fe=(0,h.assertIsDefined)(ae.win?.webContents);fe.removeAllListeners("devtools-reload-page"),fe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ae)),this.lifecycleMainService.registerWindow(ae)}return z.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then(async j=>{j||await this.doOpenInBrowserWindow(B,z,N,$)}):await this.doOpenInBrowserWindow(B,z,N,$),B}async doOpenInBrowserWindow(N,A,T,$){if(A.extensionDevelopmentPath||((0,J.isWorkspaceIdentifier)(A.workspace)?A.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:A.workspace,remoteAuthority:A.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(A.workspace)?A.backupPath=this.backupMainService.registerFolderBackup({folderUri:A.workspace.uri,remoteAuthority:A.remoteAuthority}):A.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:T.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:A.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const B=A.workspace??(0,J.toWorkspaceIdentifier)(A.backupPath,!1),z=this.resolveProfileForBrowserWindow(T,B,$),j=z instanceof Promise?await z:z;A.profiles.profile=j,A.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(B,j)}N.load(A)}resolveProfileForBrowserWindow(N,A,T){return N.forceProfile?this.userDataProfilesMainService.profiles.find($=>$.name===N.forceProfile)??this.userDataProfilesMainService.createNamedProfile(N.forceProfile):N.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(A)??T}onWindowClosed(N){const A=U.WINDOWS.indexOf(N);U.WINDOWS.splice(A,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const N=I.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(N){return this.doGetLastActiveWindow(this.getWindows().filter(A=>(0,m.isEqualAuthority)(A.remoteAuthority,N)))}doGetLastActiveWindow(N){const A=Math.max.apply(Math,N.map(T=>T.lastFocusTime));return N.find(T=>T.lastFocusTime===A)}sendToFocused(N,...A){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,C.CancellationToken.None,...A)}sendToAll(N,A,T){for(const $ of this.getWindows())T&&T.indexOf($.id)>=0||$.sendWhenReady(N,C.CancellationToken.None,A)}getWindows(){return U.WINDOWS}getWindowCount(){return U.WINDOWS.length}getWindowById(N){const A=this.getWindows().filter(T=>T.id===N);return(0,M.firstOrDefault)(A)}getWindowByWebContents(N){const A=I.BrowserWindow.fromWebContents(N);if(A)return this.getWindowById(A.id)}};e.WindowsMainService=ie,e.WindowsMainService=ie=U=Pe([Z(2,b.ILogService),Z(3,W.ILoggerMainService),Z(4,k.IStateService),Z(5,V.IPolicyService),Z(6,s.IEnvironmentMainService),Z(7,x.IUserDataProfilesMainService),Z(8,o.ILifecycleMainService),Z(9,u.IBackupMainService),Z(10,t.IConfigurationService),Z(11,re.IWorkspacesHistoryMainService),Z(12,se.IWorkspacesManagementMainService),Z(13,n.IInstantiationService),Z(14,l.IDialogMainService),Z(15,i.IFileService),Z(16,R.IProtocolMainService),Z(17,G.IThemeMainService)],ie)}),define(ee[304],te([0,1,63,30,81,53]),function(K,e,I,L,r,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(d,a,p,v){this.workspacesManagementMainService=d,this.windowsMainService=a,this.workspacesHistoryMainService=p,this.backupMainService=v,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,a){const p=this.windowsMainService.getWindowById(d);if(p)return this.workspacesManagementMainService.enterWorkspace(p,this.windowsMainService.getWindows(),a)}createUntitledWorkspace(d,a,p){return this.workspacesManagementMainService.createUntitledWorkspace(a,p)}deleteUntitledWorkspace(d,a){return this.workspacesManagementMainService.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(d,a){return this.workspacesManagementMainService.getWorkspaceIdentifier(a)}getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(d,a){return this.workspacesHistoryMainService.addRecentlyOpened(a)}removeRecentlyOpened(d,a){return this.workspacesHistoryMainService.removeRecentlyOpened(a)}clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=M,e.WorkspacesMainService=M=Pe([Z(0,_.IWorkspacesManagementMainService),Z(1,L.IWindowsMainService),Z(2,r.IWorkspacesHistoryMainService),Z(3,I.IBackupMainService)],M)}),define(ee[305],te([0,1,15,130,38,27,17,49,14,33,3,44,46,2,13,9,4,12,7,32,146,42,157,110,287,160,63,283,18,198,90,131,59,115,218,28,62,94,207,292,209,210,211,16,222,93,73,6,92,217,297,284,272,20,5,302,66,24,58,293,95,34,275,80,121,25,249,251,51,48,263,289,298,290,299,126,265,266,267,270,273,30,303,274,29,97,81,304,53,39,231,52,242,50,79,128,277,291,280,8,253,276,226,65,91,295,269,23,124,294,261,237,83]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n,o,b,D,R,E,k,O,F,q,ne,J,ce,re,se,G,V,x,W,U,H,Q,ie,oe,N,A,T,$,B,z,j,ae,fe,ue,de,be,we,ye,ke,Ne,pe,ve,Y,le,ge,De,Le,Fe,Ae,ze,Be,X,he,me,Ee,Me,We,Oe,Te,$e,qe,xe,Je,Ye,tt,nt,gt,mt,pt,vt,wt,St,yt,st,bt,Et,Pt,It,Ct,ot,kt,ut,at,Dt,Mt,ct,Rt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let lt=class extends f.Disposable{constructor(Ce,Ie,Se,_e,Re,Ue,Ge,Xe,Qe,je,He,Ve){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=Ie,this.mainInstantiationService=Se,this.logService=_e,this.loggerService=Re,this.environmentMainService=Ue,this.lifecycleMainService=Ge,this.configurationService=Xe,this.stateService=Qe,this.fileService=je,this.productService=He,this.userDataProfilesMainService=Ve,this.configureSession(),this.registerListeners()}configureSession(){const Ce=je=>je?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(this.productService.quality==="stable"?[]:["media"]),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((je,He,Ve,Ke)=>Ce(Ke.requestingUrl)?Ve(Se.has(He)):Ke.isMainFrame&&Ke.securityOrigin==="vscode-file://vscode-app/"?Ve(Ie.has(He)):Ve(!1)),I.session.defaultSession.setPermissionCheckHandler((je,He,Ve,Ke)=>Ce(Ke.requestingUrl)?Se.has(He):Ke.isMainFrame&&Ke.securityOrigin==="vscode-file://vscode-app/"?Ie.has(He):!1);const _e=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Re=je=>{for(let He=je;He;He=He.parent)if(He.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ue=je=>je.resourceType==="xhr"||Re(je.frame),Ge=je=>{const He=je.frame;if(!He||!this.windowsMainService)return!1;const Ve=I.BrowserWindow.getAllWindows();for(const Ke of Ve)if(He.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Xe=(je,He)=>{if(je.path!=="/index.html")return!0;const Ve=He.frame;if(!Ve||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&Ve.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((je,He)=>{const Ve=h.URI.parse(je.url);return Ve.scheme===y.Schemas.vscodeWebview&&!Xe(Ve,je)?(this.logService.error("Blocked vscode-webview request",je.url),He({cancel:!0})):Ve.scheme===y.Schemas.vscodeFileResource&&!Ge(je)?(this.logService.error("Blocked vscode-file request",je.url),He({cancel:!0})):Ve.path.endsWith(".svg")&&!_e.has(Ve.scheme)?He({cancel:!Ue(je)}):He({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((je,He)=>{const Ve=je.responseHeaders,Ke=Ve["content-type"]||Ve["Content-Type"];if(Ke&&Array.isArray(Ke)){const it=h.URI.parse(je.url);if(it.path.endsWith(".svg")&&_e.has(it.scheme))return Ve["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:Ve});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ke.some(Ze=>Ze.toLowerCase().includes("image/svg")))return He({cancel:!Ue(je)})}return He({cancel:!1})});const Qe=I.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Qe.setCodeCachePath((0,w.join)(this.environmentMainService.codeCachePath,"chrome")),g.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,d.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>{(0,d.isSigPipeError)(Se)||(0,d.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,d.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,P.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Se,_e)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",_e)}),I.app.on("activate",async(Se,_e)=>{this.logService.trace("app#activate"),_e||await this.windowsMainService?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Se,_e)=>{_e.on("will-navigate",Re=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),_e.setWindowOpenHandler(({url:Re})=>(this.nativeHostMainService?.openExternal(void 0,Re),{action:"deny"}))});let Ce=[],Ie;I.app.on("open-file",(Se,_e)=>{this.logService.trace("app#open-file: ",_e),Se.preventDefault(),Ce.push((0,Te.hasWorkspaceFileExtension)(_e)?{workspaceUri:h.URI.file(_e)}:{fileUri:h.URI.file(_e)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Ie=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",Se=>{const _e=this.windowsMainService?.getWindowByWebContents(Se.sender);let Re,Ue;return _e?.config?(Re=_e.config,Ue={...process.env,..._e.config.userEnv}):(Re=this.environmentMainService.args,Ue=process.env),this.resolveShellEnvironment(Re,Ue,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(Se,_e,Re)=>{const Ue=this.validateNlsPath([_e]);if(!Ue||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ue,M.VSBuffer.fromString(Re))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(Se,..._e)=>{const Re=this.validateNlsPath(_e);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Re)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(Ce){let Ie;for(const Se of Ce)typeof Se=="string"&&(typeof Ie!="string"?Ie=Se:Ie=(0,w.join)(Ie,Se));if(!(typeof Ie!="string"||!(0,w.isAbsolute)(Ie)||!(0,a.isEqualOrParent)(Ie,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return h.URI.file(Ie)}onUnexpectedError(Ce){if(Ce){const Ie={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;g.isWindows&&Ce&&I.app.setAppUserModelId(Ce);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Qe){this.logService.error(Qe)}const Ie=new t.Server;this.lifecycleMainService.onWillShutdown(Qe=>{Qe.reason===2&&Ie.dispose()}),this.logService.trace("Resolving machine identifier...");const Se=await(0,bt.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcessReady:_e,sharedProcessClient:Re}=this.setupSharedProcess(Se),Ue=await this.initServices(Se,_e);this._register(Ue.createInstance(s.ProxyAuthHandler)),this._register(Ue.createInstance(St.UserDataProfilesHandler)),Ue.invokeFunction(Qe=>this.initChannels(Qe,Ie,Re));const Ge=Ue.invokeFunction(Qe=>this.setupProtocolUrlHandlers(Qe,Ie));this.setupManagedRemoteResourceUrlHandler(Ie),this.lifecycleMainService.phase=2,await Ue.invokeFunction(Qe=>this.openFirstWindow(Qe,Ge)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new st.RunOnceScheduler(()=>{this._register((0,st.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ce,Ie){const Se=this.windowsMainService=Ce.get(Me.IWindowsMainService),_e=Ce.get(ze.IURLService),Re=this.nativeHostMainService=Ce.get(j.INativeHostMainService),Ue=this;_e.registerHandler({async handleURL(Ve,Ke){return Ue.handleProtocolUrl(Se,_e,Ve,Ke)}});const Ge=this._register(new Oe.ActiveWindowManager({onDidOpenWindow:Re.onDidOpenWindow,onDidFocusWindow:Re.onDidFocusWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Xe=new u.StaticRouter(Ve=>Ge.getActiveClientId().then(Ke=>Ve===Ke)),Qe=new Be.URLHandlerRouter(Xe,this.logService),je=Ie.getChannel("urlHandler",Qe);_e.registerHandler(new Be.URLHandlerChannelClient(je));const He=this.resolveInitialProtocolUrls();return this._register(new he.ElectronURLListener(He?.urls,_e,Se,this.environmentMainService,this.productService,this.logService)),He}setupManagedRemoteResourceUrlHandler(Ce){const Ie=()=>({statusCode:404,data:"Not found"}),Se=new Rt.Lazy(()=>Ce.getChannel(ct.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new ct.NodeRemoteResourceRouter));I.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(_e,Re)=>{const Ue=h.URI.parse(_e.url);if(!Ue.authority.startsWith("window:"))return Re(Ie());Se.value.call(ct.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Ue]).then(Ge=>Re({...Ge,data:Buffer.from(Ge.body,"base64")}),Ge=>{this.logService.warn("error dispatching remote resource call",Ge),Re({statusCode:500,data:String(Ge)})})})}resolveInitialProtocolUrls(){const Ce=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ce.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Ce.length+Ie.length===0)return;const Se=[];return{urls:[...Ce,...Ie].map(Re=>{try{return{uri:h.URI.parse(Re),originalUrl:Re}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Re);return}}).filter(Re=>{if(!Re)return!1;if(this.shouldBlockURI(Re.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Re.uri.toString(!0)),!1;const Ue=this.getWindowOpenableFromProtocolUrl(Re.uri);return Ue?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Re.uri.toString(!0),Ue),Se.push(Ue),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Re.uri.toString(!0)),!0)}),openables:Se}}shouldBlockURI(Ce){if(Ce.authority===y.Schemas.file&&g.isWindows){const{options:Ie,buttonIndeces:Se}=(0,Ct.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,S.getPathLabel)(Ce,{os:g.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(Se[I.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ce){if(Ce.path){if(Ce.authority===y.Schemas.file){const Ie=h.URI.file(Ce.fsPath);return(0,Te.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Ce.authority===y.Schemas.vscodeRemote){const Ie=Ce.path.indexOf(w.posix.sep,1);if(Ie!==-1){const Se=Ce.path.substring(1,Ie),_e=Ce.path.substring(Ie);let Re=Ce.query;const Ue=new URLSearchParams(Ce.query);Ue.get("windowId")==="_blank"&&(Ue.delete("windowId"),Re=Ue.toString());const Ge=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Se,path:_e,query:Re,fragment:Ce.fragment});return(0,Te.hasWorkspaceFileExtension)(_e)?{workspaceUri:Ge}:/:[\d]+$/.test(_e)?{fileUri:Ge}:{folderUri:Ge}}}}}async handleProtocolUrl(Ce,Ie,Se,_e){if(this.logService.trace("app#handleProtocolUrl():",Se.toString(!0),_e),Se.scheme===this.productService.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:h.URI.parse(Se.query).path,query:""})),this.shouldBlockURI(Se))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let Re=!1;const Ue=new URLSearchParams(Se.query);Ue.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ue.delete("windowId"),Se=Se.with({query:Ue.toString()}),Re=!0):g.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Re=!0);const Ge=Ue.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ue.delete("continueOn"),Se=Se.with({query:Ue.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(Se);return Xe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,Se.toString(!0)),(0,ut.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:Re,gotoLineMode:!0}))?.focus(),!0):Re?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,ut.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(Se)}))?.ready(),Ie.open(Se,_e)):(this.logService.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),_e),!1)}setupSharedProcess(Ce){const Ie=this._register(this.mainInstantiationService.createInstance(ue.SharedProcess,Ce)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Re=await Ie.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(Re,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),Se))(),sharedProcessClient:Se}}async initServices(Ce,Ie){const Se=new ie.ServiceCollection;switch(process.platform){case"win32":Se.set(le.IUpdateService,new H.SyncDescriptor(Ae.Win32UpdateService));break;case"linux":g.isLinuxSnap?Se.set(le.IUpdateService,new H.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(le.IUpdateService,new H.SyncDescriptor(Le.LinuxUpdateService));break;case"darwin":Se.set(le.IUpdateService,new H.SyncDescriptor(De.DarwinUpdateService));break}Se.set(Me.IWindowsMainService,new H.SyncDescriptor(We.WindowsMainService,[Ce,this.userEnv],!1));const _e=new k.DialogMainService(this.logService,this.productService);Se.set(k.IDialogMainService,_e),Se.set(T.ILaunchMainService,new H.SyncDescriptor(T.LaunchMainService,void 0,!1)),Se.set(E.IDiagnosticsMainService,new H.SyncDescriptor(E.DiagnosticsMainService,void 0,!1)),Se.set(R.IDiagnosticsService,u.ProxyChannel.toService((0,u.getDelayedChannel)(Ie.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(oe.IIssueMainService,new H.SyncDescriptor(N.IssueMainService,[this.userEnv])),Se.set(O.IEncryptionMainService,new H.SyncDescriptor(F.EncryptionMainService)),Se.set(A.IKeyboardLayoutMainService,new H.SyncDescriptor(A.KeyboardLayoutMainService)),Se.set(j.INativeHostMainService,new H.SyncDescriptor(j.NativeHostMainService,void 0,!1)),Se.set(me.IWebviewManagerService,new H.SyncDescriptor(Ee.WebviewMainService)),Se.set(z.IMenubarMainService,new H.SyncDescriptor(z.MenubarMainService)),Se.set(ce.IExtensionHostStarter,new H.SyncDescriptor(re.ExtensionHostStarter)),Se.set(ye.IStorageMainService,new H.SyncDescriptor(ye.StorageMainService)),Se.set(ye.IApplicationStorageMainService,new H.SyncDescriptor(ye.ApplicationStorageMainService));const Re=new Dt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ue=new Mt.PtyHostService(Re,this.configurationService,this.logService,this.loggerService);Se.set(at.ILocalPtyService,Ue),g.isWindows?Se.set(se.IExternalTerminalMainService,new H.SyncDescriptor(G.WindowsExternalTerminalService)):g.isMacintosh?Se.set(se.IExternalTerminalMainService,new H.SyncDescriptor(G.MacExternalTerminalService)):g.isLinux&&Se.set(se.IExternalTerminalMainService,new H.SyncDescriptor(G.LinuxExternalTerminalService));const Ge=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Se.set(n.IBackupMainService,Ge);const Xe=new Je.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ge,_e);if(Se.set(Je.IWorkspacesManagementMainService,Xe),Se.set($e.IWorkspacesService,new H.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Se.set(qe.IWorkspacesHistoryMainService,new H.SyncDescriptor(qe.WorkspacesHistoryMainService,void 0,!1)),Se.set(ze.IURLService,new H.SyncDescriptor(X.NativeURLService,void 0,!1)),(0,Y.supportsTelemetry)(this.productService,this.environmentMainService)){const Qe=(0,Y.isInternalTelemetry)(this.productService,this.configurationService),je=(0,u.getDelayedChannel)(Ie.then(Ze=>Ze.getChannel("telemetryAppender"))),He=new pe.TelemetryAppenderClient(je),Ve=(0,ke.resolveCommonProperties)((0,_.release)(),(0,_.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Qe),Ke=(0,Y.getPiiPathsFromEnvironment)(this.environmentMainService),it={appenders:[He],commonProperties:Ve,piiPaths:Ke,sendErrorTelemetry:!0};Se.set(Ne.ITelemetryService,new H.SyncDescriptor(ve.TelemetryService,[it],!1))}else Se.set(Ne.ITelemetryService,Y.NullTelemetryService);return Se.set(pt.IExtensionsProfileScannerService,new H.SyncDescriptor(Et.ExtensionsProfileScannerService,void 0,!0)),Se.set(vt.IExtensionsScannerService,new H.SyncDescriptor(wt.ExtensionsScannerService,void 0,!0)),Se.set(ot.IUtilityProcessWorkerMainService,new H.SyncDescriptor(ot.UtilityProcessWorkerMainService,void 0,!0)),await st.Promises.settled([Ge.initialize(),Xe.initialize()]),this.mainInstantiationService.createChild(Se)}initChannels(Ce,Ie,Se){const _e=this._register(new f.DisposableStore),Re=u.ProxyChannel.fromService(Ce.get(T.ILaunchMainService),_e,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Re);const Ue=u.ProxyChannel.fromService(Ce.get(E.IDiagnosticsMainService),_e,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Ue);const Ge=new tt.PolicyChannel(Ce.get(Ye.IPolicyService));Ie.registerChannel("policy",Ge),Se.then(et=>et.registerChannel("policy",Ge));const Xe=this.fileService.getProvider(y.Schemas.file);(0,m.assertType)(Xe instanceof U.DiskFileSystemProvider);const Qe=new W.DiskFileSystemProviderChannel(Xe,this.logService,this.environmentMainService);Ie.registerChannel(V.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),Se.then(et=>et.registerChannel(V.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const je=u.ProxyChannel.fromService(Ce.get(nt.IUserDataProfilesMainService),_e);Ie.registerChannel("userDataProfiles",je),Se.then(et=>et.registerChannel("userDataProfiles",je));const He=new gt.RequestChannel(Ce.get(mt.IRequestService));Se.then(et=>et.registerChannel("request",He));const Ve=new ge.UpdateChannel(Ce.get(le.IUpdateService));Ie.registerChannel("update",Ve);const Ke=u.ProxyChannel.fromService(Ce.get(oe.IIssueMainService),_e);Ie.registerChannel("issue",Ke);const it=u.ProxyChannel.fromService(Ce.get(O.IEncryptionMainService),_e);Ie.registerChannel("encryption",it);const Ze=u.ProxyChannel.fromService(Ce.get(de.ISignService),_e);Ie.registerChannel("sign",Ze);const rt=u.ProxyChannel.fromService(Ce.get(A.IKeyboardLayoutMainService),_e);Ie.registerChannel("keyboardLayout",rt),this.nativeHostMainService=Ce.get(j.INativeHostMainService);const ht=u.ProxyChannel.fromService(this.nativeHostMainService,_e);Ie.registerChannel("nativeHost",ht),Se.then(et=>et.registerChannel("nativeHost",ht));const Lt=u.ProxyChannel.fromService(Ce.get($e.IWorkspacesService),_e);Ie.registerChannel("workspaces",Lt);const At=u.ProxyChannel.fromService(Ce.get(z.IMenubarMainService),_e);Ie.registerChannel("menubar",At);const _t=u.ProxyChannel.fromService(Ce.get(ze.IURLService),_e);Ie.registerChannel("url",_t);const Ot=u.ProxyChannel.fromService(Ce.get(me.IWebviewManagerService),_e);Ie.registerChannel("webview",Ot);const dt=this._register(new we.StorageDatabaseChannel(this.logService,Ce.get(ye.IStorageMainService)));Ie.registerChannel("storage",dt),Se.then(et=>et.registerChannel("storage",dt));const Tt=this._register(new yt.ProfileStorageChangesListenerChannel(Ce.get(ye.IStorageMainService),Ce.get(nt.IUserDataProfilesMainService),this.logService));Se.then(et=>et.registerChannel("profileStorageListener",Tt));const Wt=u.ProxyChannel.fromService(Ce.get(at.ILocalPtyService),_e);Ie.registerChannel(at.TerminalIpcChannels.LocalPty,Wt);const Ft=u.ProxyChannel.fromService(Ce.get(se.IExternalTerminalMainService),_e);Ie.registerChannel("externalTerminal",Ft);const ft=new Pt.LoggerChannel(Ce.get(It.ILoggerMainService));Ie.registerChannel("logger",ft),Se.then(et=>et.registerChannel("logger",ft));const Ut=new D.ElectronExtensionHostDebugBroadcastChannel(Ce.get(Me.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Ut);const Nt=u.ProxyChannel.fromService(Ce.get(ce.IExtensionHostStarter),_e);Ie.registerChannel(ce.ipcExtensionHostStarterChannelName,Nt);const Bt=u.ProxyChannel.fromService(Ce.get(ot.IUtilityProcessWorkerMainService),_e);Ie.registerChannel(kt.ipcUtilityProcessWorkerChannelName,Bt)}async openFirstWindow(Ce,Ie){const Se=this.windowsMainService=Ce.get(Me.IWindowsMainService),_e=(0,ne.isLaunchedFromCli)(process.env)?0:4,Re=this.environmentMainService.args;if(Ie){if(Ie.openables.length>0)return Se.open({context:_e,cli:Re,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const Ze of Ie.urls){const rt=new URLSearchParams(Ze.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),Ze.originalUrl=Ze.uri.toString(!0),Ze.uri=Ze.uri.with({query:rt.toString()}),Se.open({context:_e,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ue=global.macOpenFiles,Ge=Re._.length,Xe=!!Re["folder-uri"],Qe=!!Re["file-uri"],je=Re["skip-add-to-recently-opened"]===!0,He=Re.wait&&Re.waitMarkerFilePath?h.URI.file(Re.waitMarkerFilePath):void 0,Ve=Re.remote||void 0,Ke=Re.profile,it=Re["profile-temp"];if(!Ge&&!Xe&&!Qe){if(Re["new-window"]||Ke||it)return Se.open({context:_e,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:je,waitMarkerFileURI:He,initialStartup:!0,remoteAuthority:Ve,forceProfile:Ke,forceTempProfile:it});if(Ue.length)return Se.open({context:1,cli:Re,urisToOpen:Ue.map(Ze=>(0,Te.hasWorkspaceFileExtension)(Ze)?{workspaceUri:h.URI.file(Ze)}:{fileUri:h.URI.file(Ze)}),noRecentEntry:je,waitMarkerFileURI:He,initialStartup:!0})}return Se.open({context:_e,cli:Re,forceNewWindow:Re["new-window"]||!Ge&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:je,waitMarkerFileURI:He,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Ve,forceProfile:Ke,forceTempProfile:it})}afterWindowOpen(){this.installMutex(),I.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ce,Ie)=>{Ie({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),g.isMacintosh&&I.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ce=this.productService.win32MutexName;if(g.isWindows&&Ce)try{const Ie=await new Promise((_e,Re)=>{K(["@vscode/windows-mutex"],_e,Re)}),Se=new Ie.Mutex(Ce);p.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Se.release())}catch(Ie){this.logService.error(Ie)}}async resolveShellEnvironment(Ce,Ie,Se){try{return await(0,J.getResolvedShellEnv)(this.configurationService,this.logService,Ce,Ie)}catch(_e){const Re=(0,C.toErrorMessage)(_e);Se?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Re):this.logService.error(Re)}return{}}async updateCrashReporterEnablement(){try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Se=JSON.parse((0,v.stripComments)(Ie)),Re=(0,Y.getTelemetryLevel)(this.configurationService)>=1;if(Se["enable-crash-reporter"]===void 0){const Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],Ge=Ie.substring(0,Ie.length-2).concat(`,
`,Ue.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ge))}else{const Ue=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Ue!==Ie&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ue))}}catch(Ce){this.logService.error(Ce)}}};e.CodeApplication=lt,e.CodeApplication=lt=Pe([Z(2,Q.IInstantiationService),Z(3,B.ILogService),Z(4,B.ILoggerService),Z(5,q.IEnvironmentMainService),Z(6,$.ILifecycleMainService),Z(7,b.IConfigurationService),Z(8,be.IStateService),Z(9,x.IFileService),Z(10,ae.IProductService),Z(11,nt.IUserDataProfilesMainService)],lt)}),define(ee[311],te([0,1,15,45,7,23,8,49,14,33,3,46,13,9,64,4,35,26,21,42,99,305,10,18,236,248,28,62,200,16,220,93,73,216,92,20,223,5,75,24,76,278,125,288,50,286,95,247,34,51,77,52,39,232,230,2,40,264,65,225,91,120,268,262]),function(K,e,I,L,r,_,M,C,d,a,p,v,S,f,y,w,g,m,h,c,P,u,t,l,s,i,n,o,b,D,R,E,k,O,F,q,ne,J,ce,re,se,G,V,x,W,U,H,Q,ie,oe,N,A,T,$,B,z,j,ae,fe,ue,de,be,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.startup()}catch(pe){console.error(pe.message),I.app.exit(1)}}async startup(){(0,d.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[pe,ve,Y,le,ge,De,Le,Fe]=this.createServices();try{try{await this.initServices(Y,Fe,le,ge,Le)}catch(Ae){throw this.handleStartupDataDirError(Y,Le,Ae),Ae}await pe.invokeFunction(async Ae=>{const ze=Ae.get(J.ILogService),Be=Ae.get(q.ILifecycleMainService),X=Ae.get(D.IFileService),he=Ae.get(J.ILoggerService),me=await this.claimInstance(ze,Y,Be,pe,Le,!0);return h.Promises.writeFile(Y.mainLockfile,String(process.pid)).catch(Ee=>{ze.warn(`app#startup(): Error writing main lockfile: ${Ee.stack}`)}),De.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),p.Event.once(Be.onWillShutdown)(Ee=>{X.dispose(),le.dispose(),Ee.join("instanceLockfile",h.Promises.unlink(Y.mainLockfile).catch(()=>{}))}),pe.createInstance(u.CodeApplication,me,ve).startup()})}catch(Ae){pe.invokeFunction(this.quit,Ae)}}createServices(){const pe=new F.ServiceCollection,ve=new z.DisposableStore;process.once("exit",()=>ve.dispose());const Y={_serviceBrand:void 0,...ce.default};pe.set(re.IProductService,Y);const le=new n.EnvironmentMainService(this.resolveArgs(),Y),ge=this.patchEnvironment(le);pe.set(n.IEnvironmentMainService,le);const De=new fe.LoggerMainService((0,J.getLogLevel)(le),le.logsHome);pe.set(fe.ILoggerMainService,De);const Le=new ne.BufferLogger(De.getLogLevel()),Fe=ve.add(new ue.LogService(Le,[new J.ConsoleMainLogger(De.getLogLevel())]));pe.set(J.ILogService,Fe);const Ae=new R.FileService(Fe);pe.set(D.IFileService,Ae);const ze=new E.DiskFileSystemProvider(Fe);Ae.registerProvider(S.Schemas.file,ze);const Be=new ae.UriIdentityService(Ae);pe.set(j.IUriIdentityService,Be);const X=new be.StateService(1,le,Fe,Ae);pe.set(ie.IStateReadService,X),pe.set(ie.IStateService,X);const he=new A.UserDataProfilesMainService(X,Be,le,Ae,Fe);pe.set(A.IUserDataProfilesMainService,he),Ae.registerProvider(S.Schemas.vscodeUserData,new we.FileUserDataProvider(S.Schemas.file,ze,S.Schemas.vscodeUserData,he,Be,Fe));const me=w.isWindows&&Y.win32RegValueName?ve.add(new $.NativePolicyService(Fe,Y.win32RegValueName)):le.policyFile?ve.add(new B.FilePolicyService(le.policyFile,Ae,Fe)):new T.NullPolicyService;pe.set(T.IPolicyService,me);const Ee=new s.ConfigurationService(he.defaultProfile.settingsResource,Ae,me,Fe);return pe.set(l.IConfigurationService,Ee),pe.set(q.ILifecycleMainService,new k.SyncDescriptor(q.LifecycleMainService,void 0,!1)),pe.set(W.IRequestService,new k.SyncDescriptor(U.RequestMainService,void 0,!0)),pe.set(N.IThemeMainService,new k.SyncDescriptor(N.ThemeMainService)),pe.set(H.ISignService,new k.SyncDescriptor(Q.SignService,void 0,!1)),pe.set(V.ITunnelService,new k.SyncDescriptor(x.TunnelService)),pe.set(se.IProtocolMainService,new G.ProtocolMainService(le,he,Fe)),[new O.InstantiationService(pe,!0),ge,le,Ee,X,Le,Y,he]}patchEnvironment(pe){const ve={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Y=>{const le=process.env[Y];typeof le=="string"&&(ve[Y]=le)}),Object.assign(process.env,ve),ve}async initServices(pe,ve,Y,le,ge){await M.Promises.settled([Promise.all([pe.extensionsPath,pe.codeCachePath,pe.logsHome.with({scheme:S.Schemas.file}).fsPath,ve.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath,pe.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath,pe.localHistoryHome.with({scheme:S.Schemas.file}).fsPath,pe.backupHome].map(De=>De?h.Promises.mkdir(De,{recursive:!0}):void 0)),le.init(),Y.initialize()]),ve.init()}async claimInstance(pe,ve,Y,le,ge,De){let Le;try{(0,y.mark)("code/willStartMainServer"),Le=await(0,P.serve)(ve.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),p.Event.once(Y.onWillShutdown)(()=>Le.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ve,ge,Fe),Fe;let Ae;try{Ae=await(0,P.connect)(ve.mainIPCHandle,"main")}catch(he){if(!De||w.isWindows||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),he;try{(0,L.unlinkSync)(ve.mainIPCHandle)}catch(me){throw pe.warn("Could not delete obsolete instance handle",me),me}return this.claimInstance(pe,ve,Y,le,ge,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw pe.error(he),Ae.dispose(),new Error(he)}let ze;!ve.args.wait&&!ve.args.status&&(ze=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Be=c.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),X=c.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return le.invokeFunction(async()=>{const he=new i.DiagnosticsService(oe.NullTelemetryService,ge),me=await X.getMainDiagnostics(),Ee=await X.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Me=await he.getDiagnostics(me,Ee);throw console.log(Me),new d.ExpectedError});throw w.isWindows&&await this.windowsAllowSetForegroundWindow(Be,pe),pe.trace("Sending env to running instance..."),await Be.start(ve.args,process.env),Ae.dispose(),ze&&clearTimeout(ze),new d.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Le}handleStartupDataDirError(pe,ve,Y){if(Y.code==="EACCES"||Y.code==="EPERM"){const le=(0,_.coalesce)([pe.userDataPath,pe.extensionsPath,P.XDG_RUNTIME_DIR]).map(ge=>(0,v.getPathLabel)(r.URI.file(ge),{os:w.OS,tildify:pe}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,C.toErrorMessage)(Y),le.join(`
`)),ve)}}showStartupWarningDialog(pe,ve,Y){I.dialog.showMessageBoxSync((0,de.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:pe,detail:ve},Y).options)}async windowsAllowSetForegroundWindow(pe,ve){if(w.isWindows){const Y=await pe.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Y);try{(await new Promise((le,ge)=>{K(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Y)}catch(le){ve.error(le)}}}quit(pe,ve){const Y=pe.get(J.ILogService),le=pe.get(q.ILifecycleMainService);let ge=0;ve&&(ve.isExpected?ve.message&&Y.trace(ve.message):(ge=1,ve.stack?Y.error(ve.stack):Y.error(`Startup error: ${ve.toString()}`))),le.kill(ge)}resolveArgs(){const pe=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const ve=(0,b.createWaitMarkerFileSync)(pe.verbose);ve&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ve),pe.waitMarkerFilePath=ve)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const ve=this.doValidatePaths(pe._,pe.goto);pe._=ve}return pe}doValidatePaths(pe,ve){const Y=(0,g.cwd)(),le=pe.map(Le=>{let Fe=String(Le),Ae;ve&&(Ae=(0,a.parseLineAndColumnAware)(Fe),Fe=Ae.path),Fe&&(Fe=this.preparePath(Y,Fe));const ze=(0,a.sanitizeFilePath)(Fe,Y),Be=(0,f.basename)(ze);return Be&&!(0,a.isValidBasename)(Be)?null:ve&&Ae?(Ae.path=ze,this.toPath(Ae)):ze}),ge=w.isWindows||w.isMacintosh,De=(0,_.distinct)(le,Le=>Le&&ge?Le.toLowerCase():Le||"");return(0,_.coalesce)(De)}preparePath(pe,ve){return w.isWindows&&(ve=(0,m.rtrim)(ve,'"')),ve=(0,m.trim)((0,m.trim)(ve," "),"	"),w.isWindows&&(ve=(0,f.resolve)(pe,ve),ve=(0,m.rtrim)(ve,".")),ve}toPath(pe){const ve=[pe.path];return typeof pe.line=="number"&&ve.push(String(pe.line)),typeof pe.column=="number"&&ve.push(String(pe.column)),ve.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/code/electron-main/main.js.map
