/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],se=function(G){for(var e=[],N=0,O=G.length;N<O;N++)e[N]=ne[G[N]];return e};define(ne[70],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class N{static get(){const k=new Map,A=new Map,T=new Map,E=new Map;function u(d,I){d.has(I.detail)||d.set(I.detail,-I.timestamp)}function l(d,I){const S=d.get(I.detail);S&&(S>=0||d.set(I.detail,S+I.timestamp))}let w=[];typeof G=="function"&&typeof G.getStats=="function"&&(w=G.getStats().slice(0).sort((d,I)=>d.timestamp-I.timestamp));for(const d of w)switch(d.type){case 10:u(k,d);break;case 11:case 12:l(k,d);break;case 21:u(A,d);break;case 22:l(A,d);break;case 33:u(T,d);break;case 34:l(T,d);break;case 31:u(E,d);break;case 32:l(E,d);break}let R=0;T.forEach(d=>R+=d);function m(d){const I=[];return d.forEach((S,p)=>I.push([p,S])),I}return{amdLoad:m(k),amdInvoke:m(A),nodeRequire:m(T),nodeEval:m(E),nodeRequireTotal:R}}static toMarkdownTable(k,A){let T="";const E=[];return k.forEach((u,l)=>{E[l]=u.length}),A.forEach(u=>{u.forEach((l,w)=>{typeof l>"u"&&(l=u[w]="-");const R=l.toString().length;E[w]=Math.max(R,E[w])})}),k.forEach((u,l)=>{T+=`| ${u+" ".repeat(E[l]-u.toString().length)} `}),T+=`|
`,k.forEach((u,l)=>{T+=`| ${"-".repeat(E[l])} `}),T+=`|
`,A.forEach(u=>{u.forEach((l,w)=>{typeof l<"u"&&(T+=`| ${l+" ".repeat(E[w]-l.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=N}),define(ne[52],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(T){return(E,u,l)=>{let w=null,R=null;if(typeof l.value=="function"?(w="value",R=l.value):typeof l.get=="function"&&(w="get",R=l.get),!R)throw new Error("not supported");l[w]=T(R,u)}}function O(T,E,u){let l=null,w=null;if(typeof u.value=="function"?(l="value",w=u.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",w=u.get),!w)throw new Error("not supported");const R=`$memoize$${E}`;u[l]=function(...m){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,m)}),this[R]}}e.memoize=O;function k(T,E,u){return N((l,w)=>{const R=`$debounce$${w}`,m=`$debounce$result$${w}`;return function(...d){this[m]||(this[m]=u?u():void 0),clearTimeout(this[R]),E&&(this[m]=E(this[m],...d),d=[this[m]]),this[R]=setTimeout(()=>{l.apply(this,d),this[m]=u?u():void 0},T)}})}e.debounce=k;function A(T,E,u){return N((l,w)=>{const R=`$throttle$timer$${w}`,m=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,I=`$throttle$pending$${w}`;return function(...S){if(this[m]||(this[m]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),E&&(this[m]=E(this[m],...S)),this[I])return;const p=this[d]+T;p<=Date.now()?(this[d]=Date.now(),l.apply(this,[this[m]]),this[m]=u?u():void 0):(this[I]=!0,this[R]=setTimeout(()=>{this[I]=!1,this[d]=Date.now(),l.apply(this,[this[m]]),this[m]=u?u():void 0},p-Date.now()))}})}e.throttle=A}),define(ne[71],se([0,1,9]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function k(u,l="Unreachable"){throw new Error(l)}e.assertNever=k;function A(u){if(!u)throw new N.BugIndicatingError("Assertion Failed")}e.assert=A;function T(u){if(!u()){debugger;u(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function E(u,l){let w=0;for(;w<u.length-1;){const R=u[w],m=u[w+1];if(!l(R,m))return!1;w++}return!0}e.checkAdjacentItems=E}),define(ne[53],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(t,a=!1){let i=0;const n=t.length;let r="",s=0,c=16,D=0;function y(te){let ae=0,ce=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)ce=ce*16+ie-48;else if(ie>=65&&ie<=70)ce=ce*16+ie-65+10;else if(ie>=97&&ie<=102)ce=ce*16+ie-97+10;else break;i++,ae++}return ae<te&&(ce=-1),ce}function P(te){i=te,r="",s=0,c=16,D=0}function L(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return D=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ae=i}else D=3;return t.substring(te,ae)}function $(){let te="",ae=i;for(;;){if(i>=n){te+=t.substring(ae,i),D=2;break}const ce=t.charCodeAt(i);if(ce===34){te+=t.substring(ae,i),i++;break}if(ce===92){if(te+=t.substring(ae,i),i++,i>=n){D=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const W=y(4);W>=0?te+=String.fromCharCode(W):D=4;break}default:D=5}ae=i;continue}if(ce>=0&&ce<=31)if(u(ce)){te+=t.substring(ae,i),D=2;break}else D=6;i++}return te}function Q(){if(r="",D=0,s=i,i>=n)return s=n,c=17;let te=t.charCodeAt(i);if(E(te)){do i++,r+=String.fromCharCode(te),te=t.charCodeAt(i);while(E(te));return c=15}if(u(te))return i++,r+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),c=14;switch(te){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,r=$(),c=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(t.charCodeAt(i));)i++;return r=t.substring(ae,i),c=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=n-1;let ie=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,D=1),r=t.substring(ae,i),c=13}return r+=String.fromCharCode(te),i++,c=16}case 45:if(r+=String.fromCharCode(te),i++,i===n||!l(t.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),c=11;default:for(;i<n&&Z(te);)i++,te=t.charCodeAt(i);if(s!==i){switch(r=t.substring(s,i),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(te),i++,c=16}}function Z(te){if(E(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=Q();while(te>=12&&te<=15);return te}return{setPosition:P,getPosition:()=>i,scan:a?ue:Q,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>D}}e.createScanner=T;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function R(t,a){const i=[],n=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function D(y,P,L,$){s.value=y,s.offset=P,s.length=L,s.type=$,s.colonOffset=void 0,r=s}try{C(t,{onObjectBegin:(y,P)=>{if(a<=y)throw n;r=void 0,c=a>y,i.push("")},onObjectProperty:(y,P,L)=>{if(a<P||(D(y,P,L,"property"),i[i.length-1]=y,a<=P+L))throw n},onObjectEnd:(y,P)=>{if(a<=y)throw n;r=void 0,i.pop()},onArrayBegin:(y,P)=>{if(a<=y)throw n;r=void 0,i.push(0)},onArrayEnd:(y,P)=>{if(a<=y)throw n;r=void 0,i.pop()},onLiteralValue:(y,P,L)=>{if(a<P||(D(y,P,L,b(y)),a<=P+L))throw n},onSeparator:(y,P,L)=>{if(a<=P)throw n;if(y===":"&&r&&r.type==="property")r.colonOffset=P,c=!1,r=void 0;else if(y===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(c=!0,i[i.length-1]=""),r=void 0}}})}catch(y){if(y!==n)throw y}return{path:i,previousNode:r,isAtPropertyKey:c,matches:y=>{let P=0;for(let L=0;P<y.length&&L<i.length;L++)if(y[P]===i[L]||y[P]==="*")P++;else if(y[P]!=="**")return!1;return P===y.length}}}e.getLocation=R;function m(t,a=[],i=A.DEFAULT){let n=null,r=[];const s=[];function c(y){Array.isArray(r)?r.push(y):n!==null&&(r[n]=y)}return C(t,{onObjectBegin:()=>{const y={};c(y),s.push(r),r=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const y=[];c(y),s.push(r),r=y,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:c,onError:(y,P,L)=>{a.push({error:y,offset:P,length:L})}},i),r[0]}e.parse=m;function d(t,a=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function s(y){return n.children.push(y),y}C(t,{onObjectBegin:y=>{n=s({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,P,L)=>{n=s({type:"property",offset:P,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:P,length:L,parent:n})},onObjectEnd:(y,P)=>{n.length=y+P-n.offset,n=n.parent,r(y+P)},onArrayBegin:(y,P)=>{n=s({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,P)=>{n.length=y+P-n.offset,n=n.parent,r(y+P)},onLiteralValue:(y,P,L)=>{s({type:b(y),offset:P,length:L,parent:n,value:y}),r(P+L)},onSeparator:(y,P,L)=>{n.type==="property"&&(y===":"?n.colonOffset=P:y===","&&r(P))},onError:(y,P,L)=>{a.push({error:y,offset:P,length:L})}},i);const D=n.children[0];return D&&delete D.parent,D}e.parseTree=d;function I(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=I;function S(t){if(!t.parent||!t.parent.children)return[];const a=S(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=S;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=p(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function f(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=f;function h(t,a,i=!1){if(f(t,a,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const s=h(n[r],a,i);if(s)return s}return t}}e.findNodeAtOffset=h;function C(t,a,i=A.DEFAULT){const n=T(t,!1);function r(X){return X?()=>X(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(X){return X?J=>X(J,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=r(a.onObjectBegin),D=s(a.onObjectProperty),y=r(a.onObjectEnd),P=r(a.onArrayBegin),L=r(a.onArrayEnd),$=s(a.onLiteralValue),Q=s(a.onSeparator),Z=r(a.onComment),ue=s(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ce(){for(;;){const X=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(X){case 12:case 13:te?ie(10):Z();break;case 16:ie(1);break;case 15:case 14:break;default:return X}}}function ie(X,J=[],_=[]){if(ue(X),J.length+_.length>0){let x=n.getToken();for(;x!==17;){if(J.indexOf(x)!==-1){ce();break}else if(_.indexOf(x)!==-1)break;x=ce()}}}function W(X){const J=n.getTokenValue();return X?$(J):D(J),ce(),!0}function B(){switch(n.getToken()){case 11:{let X=0;try{X=JSON.parse(n.getTokenValue()),typeof X!="number"&&(ie(2),X=0)}catch{ie(2)}$(X);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return ce(),!0}function V(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(W(!1),n.getToken()===6?(Q(":"),ce(),K()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function M(){c(),ce();let X=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(X||ie(4,[],[]),Q(","),ce(),n.getToken()===2&&ae)break}else X&&ie(6,[],[]);V()||ie(4,[],[2,5]),X=!0}return y(),n.getToken()!==2?ie(7,[2],[]):ce(),!0}function z(){P(),ce();let X=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(X||ie(4,[],[]),Q(","),ce(),n.getToken()===4&&ae)break}else X&&ie(6,[],[]);K()||ie(4,[],[4,5]),X=!0}return L(),n.getToken()!==4?ie(8,[4],[]):ce(),!0}function K(){switch(n.getToken()){case 3:return z();case 1:return M();case 10:return W(!0);default:return B()}}return ce(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):K()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=C;function v(t,a){const i=T(t),n=[];let r,s=0,c;do switch(c=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:s!==c&&n.push(t.substring(s,c)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),s=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=v;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(ne[72],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(E,u,l){return Math.min(Math.max(E,u),l)}e.clamp=N;function O(E,u){return(u+E%u)%u}e.rot=O;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const l=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function G(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function T(u){A.push(u,Date.now())}function E(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:T,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(k+T.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function N(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=N(O))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var O in N)(typeof exports=="object"?exports:G)[O]=N[O]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function N(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return G[O].call(k.exports,k,k.exports,N),k.l=!0,k.exports}return N.m=G,N.c=e,N.d=function(O,k,A){N.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:A})},N.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},N.t=function(O,k){if(1&k&&(O=N(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(N.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var T in O)N.d(A,T,function(E){return O[E]}.bind(null,T));return A},N.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return N.d(k,"a",k),k},N.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},N.p="",N(N.s=0)}([function(G,e,N){(function(O){var k;e=G.exports=_,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],l=0,w=l++;u[w]="0|[1-9]\\d*";var R=l++;u[R]="[0-9]+";var m=l++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=l++;u[d]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var I=l++;u[I]="("+u[R]+")\\.("+u[R]+")\\.("+u[R]+")";var S=l++;u[S]="(?:"+u[w]+"|"+u[m]+")";var p=l++;u[p]="(?:"+u[R]+"|"+u[m]+")";var f=l++;u[f]="(?:-("+u[S]+"(?:\\."+u[S]+")*))";var h=l++;u[h]="(?:-?("+u[p]+"(?:\\."+u[p]+")*))";var C=l++;u[C]="[0-9A-Za-z-]+";var v=l++;u[v]="(?:\\+("+u[C]+"(?:\\."+u[C]+")*))";var b=l++,t="v?"+u[d]+u[f]+"?"+u[v]+"?";u[b]="^"+t+"$";var a="[v=\\s]*"+u[I]+u[h]+"?"+u[v]+"?",i=l++;u[i]="^"+a+"$";var n=l++;u[n]="((?:<|>)?=?)";var r=l++;u[r]=u[R]+"|x|X|\\*";var s=l++;u[s]=u[w]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[f]+")?"+u[v]+"?)?)?";var D=l++;u[D]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[v]+"?)?)?";var y=l++;u[y]="^"+u[n]+"\\s*"+u[c]+"$";var P=l++;u[P]="^"+u[n]+"\\s*"+u[D]+"$";var L=l++;u[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=l++;u[$]="(?:~>?)";var Q=l++;u[Q]="(\\s*)"+u[$]+"\\s+",E[Q]=new RegExp(u[Q],"g");var Z=l++;u[Z]="^"+u[$]+u[c]+"$";var ue=l++;u[ue]="^"+u[$]+u[D]+"$";var te=l++;u[te]="(?:\\^)";var ae=l++;u[ae]="(\\s*)"+u[te]+"\\s+",E[ae]=new RegExp(u[ae],"g");var ce=l++;u[ce]="^"+u[te]+u[c]+"$";var ie=l++;u[ie]="^"+u[te]+u[D]+"$";var W=l++;u[W]="^"+u[n]+"\\s*("+a+")$|^$";var B=l++;u[B]="^"+u[n]+"\\s*("+t+")$|^$";var V=l++;u[V]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[c]+")",E[V]=new RegExp(u[V],"g");var M=l++;u[M]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var z=l++;u[z]="^\\s*("+u[D]+")\\s+-\\s+("+u[D]+")\\s*$";var K=l++;u[K]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)k(X,u[X]),E[X]||(E[X]=new RegExp(u[X]));function J(j,Y){if(j instanceof _)return j;if(typeof j!="string"||j.length>A||!(Y?E[i]:E[b]).test(j))return null;try{return new _(j,Y)}catch{return null}}function _(j,Y){if(j instanceof _){if(j.loose===Y)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof _))return new _(j,Y);k("SemVer",j,Y),this.loose=Y;var ee=j.trim().match(Y?E[i]:E[b]);if(!ee)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ye=+pe;if(ye>=0&&ye<T)return ye}return pe}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=J,e.valid=function(j,Y){var ee=J(j,Y);return ee?ee.version:null},e.clean=function(j,Y){var ee=J(j.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(j){return k("SemVer.compare",this.version,this.loose,j),j instanceof _||(j=new _(j,this.loose)),this.compareMain(j)||this.comparePre(j)},_.prototype.compareMain=function(j){return j instanceof _||(j=new _(j,this.loose)),o(this.major,j.major)||o(this.minor,j.minor)||o(this.patch,j.patch)},_.prototype.comparePre=function(j){if(j instanceof _||(j=new _(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],pe=j.prerelease[Y];if(k("prerelease compare",Y,ee,pe),ee===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(ee===void 0)return-1;if(ee!==pe)return o(ee,pe)}while(++Y)},_.prototype.inc=function(j,Y){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Y,ee,pe){typeof ee=="string"&&(pe=ee,ee=void 0);try{return new _(j,ee).inc(Y,pe).version}catch{return null}},e.diff=function(j,Y){if(H(j,Y))return null;var ee=J(j),pe=J(Y);if(ee.prerelease.length||pe.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==pe[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==pe[ye])return ye},e.compareIdentifiers=o;var x=/^[0-9]+$/;function o(j,Y){var ee=x.test(j),pe=x.test(Y);return ee&&pe&&(j=+j,Y=+Y),ee&&!pe?-1:pe&&!ee?1:j<Y?-1:j>Y?1:0}function g(j,Y,ee){return new _(j,ee).compare(new _(Y,ee))}function F(j,Y,ee){return g(j,Y,ee)>0}function U(j,Y,ee){return g(j,Y,ee)<0}function H(j,Y,ee){return g(j,Y,ee)===0}function q(j,Y,ee){return g(j,Y,ee)!==0}function le(j,Y,ee){return g(j,Y,ee)>=0}function oe(j,Y,ee){return g(j,Y,ee)<=0}function me(j,Y,ee,pe){var ye;switch(Y){case"===":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),ye=j===ee;break;case"!==":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),ye=j!==ee;break;case"":case"=":case"==":ye=H(j,ee,pe);break;case"!=":ye=q(j,ee,pe);break;case">":ye=F(j,ee,pe);break;case">=":ye=le(j,ee,pe);break;case"<":ye=U(j,ee,pe);break;case"<=":ye=oe(j,ee,pe);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(j,Y){if(j instanceof de){if(j.loose===Y)return j;j=j.value}if(!(this instanceof de))return new de(j,Y);k("comparator",j,Y),this.loose=Y,this.parse(j),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(j,Y){return o(Y,j)},e.major=function(j,Y){return new _(j,Y).major},e.minor=function(j,Y){return new _(j,Y).minor},e.patch=function(j,Y){return new _(j,Y).patch},e.compare=g,e.compareLoose=function(j,Y){return g(j,Y,!0)},e.rcompare=function(j,Y,ee){return g(Y,j,ee)},e.sort=function(j,Y){return j.sort(function(ee,pe){return e.compare(ee,pe,Y)})},e.rsort=function(j,Y){return j.sort(function(ee,pe){return e.rcompare(ee,pe,Y)})},e.gt=F,e.lt=U,e.eq=H,e.neq=q,e.gte=le,e.lte=oe,e.cmp=me,e.Comparator=de;var ge={};function he(j,Y){if(j instanceof he)return j.loose===Y?j:new he(j.raw,Y);if(j instanceof de)return new he(j.value,Y);if(!(this instanceof he))return new he(j,Y);if(this.loose=Y,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function fe(j){return!j||j.toLowerCase()==="x"||j==="*"}function Se(j,Y,ee,pe,ye,Le,Ie,Ne,Ce,Ae,_e,Re,Te){return((Y=fe(ee)?"":fe(pe)?">="+ee+".0.0":fe(ye)?">="+ee+"."+pe+".0":">="+Y)+" "+(Ne=fe(Ce)?"":fe(Ae)?"<"+(+Ce+1)+".0.0":fe(_e)?"<"+Ce+"."+(+Ae+1)+".0":Re?"<="+Ce+"."+Ae+"."+_e+"-"+Re:"<="+Ne)).trim()}function we(j,Y){for(var ee=0;ee<j.length;ee++)if(!j[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<j.length;ee++)if(k(j[ee].semver),j[ee].semver!==ge&&j[ee].semver.prerelease.length>0){var pe=j[ee].semver;if(pe.major===Y.major&&pe.minor===Y.minor&&pe.patch===Y.patch)return!0}return!1}return!0}function be(j,Y,ee){try{Y=new he(Y,ee)}catch{return!1}return Y.test(j)}function Fe(j,Y,ee,pe){var ye,Le,Ie,Ne,Ce;switch(j=new _(j,pe),Y=new he(Y,pe),ee){case">":ye=F,Le=oe,Ie=U,Ne=">",Ce=">=";break;case"<":ye=U,Le=le,Ie=F,Ne="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(j,Y,pe))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var _e=Y.set[Ae],Re=null,Te=null;if(_e.forEach(function(Oe){Oe.semver===ge&&(Oe=new de(">=0.0.0")),Re=Re||Oe,Te=Te||Oe,ye(Oe.semver,Re.semver,pe)?Re=Oe:Ie(Oe.semver,Te.semver,pe)&&(Te=Oe)}),Re.operator===Ne||Re.operator===Ce||(!Te.operator||Te.operator===Ne)&&Le(j,Te.semver)||Te.operator===Ce&&Ie(j,Te.semver))return!1}return!0}de.prototype.parse=function(j){var Y=this.loose?E[W]:E[B],ee=j.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+j);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new _(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(j){return k("Comparator.test",j,this.loose),this.semver===ge||(typeof j=="string"&&(j=new _(j,this.loose)),me(j,this.operator,this.semver,this.loose))},de.prototype.intersects=function(j,Y){if(!(j instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he(j.value,Y),be(this.value,ee,Y);if(j.operator==="")return ee=new he(this.value,Y),be(j.semver,ee,Y);var pe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Le=this.semver.version===j.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ne=me(this.semver,"<",j.semver,Y)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),Ce=me(this.semver,">",j.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return pe||ye||Le&&Ie||Ne||Ce},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(j){var Y=this.loose;j=j.trim(),k("range",j,Y);var ee=Y?E[z]:E[M];j=j.replace(ee,Se),k("hyphen replace",j),j=j.replace(E[V],"$1$2$3"),k("comparator trim",j,E[V]),j=(j=(j=j.replace(E[Q],"$1~")).replace(E[ae],"$1^")).split(/\s+/).join(" ");var pe=Y?E[W]:E[B],ye=j.split(" ").map(function(Le){return function(Ie,Ne){return k("comp",Ie),Ie=function(Ce,Ae){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Te){k("caret",Re,Te);var Oe=Te?E[ie]:E[ce];return Re.replace(Oe,function(Me,Ee,Pe,De,ke){var xe;return k("caret",Re,Me,Ee,Pe,De,ke),fe(Ee)?xe="":fe(Pe)?xe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?xe=Ee==="0"?">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+".0 <"+(+Ee+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),xe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+ke+" <"+(+Ee+1)+".0.0"):(k("no pr"),xe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+" <"+(+Ee+1)+".0.0"),k("caret return",xe),xe})}(_e,Ae)}).join(" ")}(Ie,Ne),k("caret",Ie),Ie=function(Ce,Ae){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Te){var Oe=Te?E[ue]:E[Z];return Re.replace(Oe,function(Me,Ee,Pe,De,ke){var xe;return k("tilde",Re,Me,Ee,Pe,De,ke),fe(Ee)?xe="":fe(Pe)?xe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?xe=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),xe=">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0"):xe=">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0",k("tilde return",xe),xe})}(_e,Ae)}).join(" ")}(Ie,Ne),k("tildes",Ie),Ie=function(Ce,Ae){return k("replaceXRanges",Ce,Ae),Ce.split(/\s+/).map(function(_e){return function(Re,Te){Re=Re.trim();var Oe=Te?E[P]:E[y];return Re.replace(Oe,function(Me,Ee,Pe,De,ke,xe){k("xRange",Re,Me,Ee,Pe,De,ke,xe);var We=fe(Pe),Ue=We||fe(De),Ve=Ue||fe(ke);return Ee==="="&&Ve&&(Ee=""),We?Me=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Ue&&(De=0),Ve&&(ke=0),Ee===">"?(Ee=">=",Ue?(Pe=+Pe+1,De=0,ke=0):Ve&&(De=+De+1,ke=0)):Ee==="<="&&(Ee="<",Ue?Pe=+Pe+1:De=+De+1),Me=Ee+Pe+"."+De+"."+ke):Ue?Me=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Me=">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0"),k("xRange return",Me),Me})}(_e,Ae)}).join(" ")}(Ie,Ne),k("xrange",Ie),Ie=function(Ce,Ae){return k("replaceStars",Ce,Ae),Ce.trim().replace(E[K],"")}(Ie,Ne),k("stars",Ie),Ie}(Le,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Le){return!!Le.match(pe)})),ye=ye.map(function(Le){return new de(Le,Y)})},he.prototype.intersects=function(j,Y){if(!(j instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(pe){return j.set.some(function(ye){return ye.every(function(Le){return pe.intersects(Le,Y)})})})})},e.toComparators=function(j,Y){return new he(j,Y).set.map(function(ee){return ee.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},he.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new _(j,this.loose));for(var Y=0;Y<this.set.length;Y++)if(we(this.set[Y],j))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(j,Y,ee){var pe=null,ye=null;try{var Le=new he(Y,ee)}catch{return null}return j.forEach(function(Ie){Le.test(Ie)&&(pe&&ye.compare(Ie)!==-1||(ye=new _(pe=Ie,ee)))}),pe},e.minSatisfying=function(j,Y,ee){var pe=null,ye=null;try{var Le=new he(Y,ee)}catch{return null}return j.forEach(function(Ie){Le.test(Ie)&&(pe&&ye.compare(Ie)!==1||(ye=new _(pe=Ie,ee)))}),pe},e.validRange=function(j,Y){try{return new he(j,Y).range||"*"}catch{return null}},e.ltr=function(j,Y,ee){return Fe(j,Y,"<",ee)},e.gtr=function(j,Y,ee){return Fe(j,Y,">",ee)},e.outside=Fe,e.prerelease=function(j,Y){var ee=J(j,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(j,Y,ee){return j=new he(j,ee),Y=new he(Y,ee),j.intersects(Y)},e.coerce=function(j){if(j instanceof _)return j;if(typeof j!="string")return null;var Y=j.match(E[L]);return Y==null?null:J((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,N(1))},function(G,e){var N,O,k=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function E(p){if(N===setTimeout)return setTimeout(p,0);if((N===A||!N)&&setTimeout)return N=setTimeout,setTimeout(p,0);try{return N(p,0)}catch{try{return N.call(null,p,0)}catch{return N.call(this,p,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:A}catch{N=A}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var u,l=[],w=!1,R=-1;function m(){w&&u&&(w=!1,u.length?l=u.concat(l):R=-1,l.length&&d())}function d(){if(!w){var p=E(m);w=!0;for(var f=l.length;f;){for(u=l,l=[];++R<f;)u&&u[R].run();R=-1,f=l.length}u=null,w=!1,function(h){if(O===clearTimeout)return clearTimeout(h);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(h);try{O(h)}catch{try{return O.call(null,h)}catch{return O.call(this,h)}}}(p)}}function I(p,f){this.fun=p,this.array=f}function S(){}k.nextTick=function(p){var f=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)f[h-1]=arguments[h];l.push(new I(p,f)),l.length!==1||w||E(d)},I.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(p){return[]},k.binding=function(p){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(p){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[73],se([0,1]),function(G,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(E,u,l){this.level=E,this.key=u,this.value=l,this.forward=[]}}const k=void 0;class A{constructor(E,u=2**16){this.comparator=E,this[N]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new O(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,k,k)}has(E){return!!A._search(this,E,this.comparator)}get(E){return A._search(this,E,this.comparator)?.value}set(E,u){return A._insert(this,E,u,this.comparator)&&(this._size+=1),this}delete(E){const u=A._delete(this,E,this.comparator);return u&&(this._size-=1),u}forEach(E,u){let l=this._header.forward[0];for(;l;)E.call(u,l.value,l.key,this),l=l.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this._header.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static _search(E,u,l){let w=E._header;for(let R=E._level-1;R>=0;R--)for(;w.forward[R]&&l(w.forward[R].key,u)<0;)w=w.forward[R];if(w=w.forward[0],w&&l(w.key,u)===0)return w}static _insert(E,u,l,w){const R=[];let m=E._header;for(let d=E._level-1;d>=0;d--){for(;m.forward[d]&&w(m.forward[d].key,u)<0;)m=m.forward[d];R[d]=m}if(m=m.forward[0],m&&w(m.key,u)===0)return m.value=l,!1;{const d=A._randomLevel(E);if(d>E._level){for(let I=E._level;I<d;I++)R[I]=E._header;E._level=d}m=new O(d,u,l);for(let I=0;I<d;I++)m.forward[I]=R[I].forward[I],R[I].forward[I]=m;return!0}}static _randomLevel(E,u=.5){let l=1;for(;Math.random()<u&&l<E._maxLevel;)l+=1;return l}static _delete(E,u,l){const w=[];let R=E._header;for(let m=E._level-1;m>=0;m--){for(;R.forward[m]&&l(R.forward[m].key,u)<0;)R=R.forward[m];w[m]=R}if(R=R.forward[0],!R||l(R.key,u)!==0)return!1;for(let m=0;m<E._level&&w[m].forward[m]===R;m++)w[m].forward[m]=R.forward[m];for(;E._level>0&&E._header.forward[E._level-1]===k;)E._level-=1;return!0}}e.SkipList=A}),define(ne[45],se([0,1,9,2]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(v){const b=v;return b?typeof b.read=="function":!1}e.isReadable=k;function A(v){const b=v;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function T(v){const b=v;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=T;function E(v,b){return new u(v,b)}e.newWriteableStream=E;class u{constructor(b,t){this.reducer=b,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(t=>t(b))}emitError(b){this.listeners.error.length===0?(0,N.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(t=>t(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,t){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(b,t){if(this.state.destroyed)return;let a;switch(b){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(v,b){const t=[];let a;for(;(a=v.read())!==null;)t.push(a);return b(t)}e.consumeReadable=l;function w(v,b,t){const a=[];let i;for(;(i=v.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return v.read()}}}e.peekReadable=w;function R(v,b){return new Promise((t,a)=>{const i=[];m(v,{onData:n=>{b&&i.push(n)},onError:n=>{b?a(n):t(void 0)},onEnd:()=>{t(b?b(i):void 0)}})})}e.consumeStream=R;function m(v,b,t){v.on("error",a=>{t?.isCancellationRequested||b.onError(a)}),v.on("end",()=>{t?.isCancellationRequested||b.onEnd()}),v.on("data",a=>{t?.isCancellationRequested||b.onData(a)})}e.listenStream=m;function d(v,b){return new Promise((t,a)=>{const i=new O.DisposableStore,n=[],r=D=>{if(n.push(D),n.length>b)return i.dispose(),v.pause(),t({stream:v,buffer:n,ended:!1})},s=D=>(i.dispose(),a(D)),c=()=>(i.dispose(),t({stream:v,buffer:n,ended:!0}));i.add((0,O.toDisposable)(()=>v.removeListener("error",s))),v.on("error",s),i.add((0,O.toDisposable)(()=>v.removeListener("end",c))),v.on("end",c),i.add((0,O.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=d;function I(v,b){const t=E(b);return t.end(v),t}e.toStream=I;function S(){const v=E(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=S;function p(v){let b=!1;return{read:()=>b?null:(b=!0,v)}}e.toReadable=p;function f(v,b,t){const a=E(t);return m(v,{onData:i=>a.write(b.data(i)),onError:i=>a.error(b.error?b.error(i):i),onEnd:()=>a.end()}),a}e.transform=f;function h(v,b,t){let a=!1;return{read:()=>{const i=b.read();return a?i:(a=!0,i!==null?t([v,i]):v)}}}e.prefixedReadable=h;function C(v,b,t){let a=!1;const i=E(t);return m(b,{onData:n=>a?i.write(n):(a=!0,i.write(t([v,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(v)),i.end()}}),i}e.prefixedStream=C}),define(ne[14],se([0,1,164,45]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",A=new N.Lazy(()=>new Uint8Array(256));let T,E;class u{static alloc(L){return k?new u(Buffer.allocUnsafe(L)):new u(new Uint8Array(L))}static wrap(L){return k&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new u(L)}static fromString(L,$){return!($?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(L)):(T||(T=new TextEncoder),new u(T.encode(L)))}static fromByteArray(L){const $=u.alloc(L.length);for(let Q=0,Z=L.length;Q<Z;Q++)$.buffer[Q]=L[Q];return $}static concat(L,$){if(typeof $>"u"){$=0;for(let ue=0,te=L.length;ue<te;ue++)$+=L[ue].byteLength}const Q=u.alloc($);let Z=0;for(let ue=0,te=L.length;ue<te;ue++){const ae=L[ue];Q.set(ae,Z),Z+=ae.byteLength}return Q}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=u.alloc(this.byteLength);return L.set(this),L}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(L,$){return new u(this.buffer.subarray(L,$))}set(L,$){if(L instanceof u)this.buffer.set(L.buffer,$);else if(L instanceof Uint8Array)this.buffer.set(L,$);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),$);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),$);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return m(this.buffer,L)}writeUInt32BE(L,$){d(this.buffer,L,$)}readUInt32LE(L){return I(this.buffer,L)}writeUInt32LE(L,$){S(this.buffer,L,$)}readUInt8(L){return p(this.buffer,L)}writeUInt8(L,$){f(this.buffer,L,$)}indexOf(L,$=0){return l(this.buffer,L instanceof u?L.buffer:L,$)}}e.VSBuffer=u;function l(P,L,$=0){const Q=L.byteLength,Z=P.byteLength;if(Q===0)return 0;if(Q===1)return P.indexOf(L[0]);if(Q>Z-$)return-1;const ue=A.value;ue.fill(L.length);for(let ie=0;ie<L.length;ie++)ue[L[ie]]=L.length-ie-1;let te=$+L.length-1,ae=te,ce=-1;for(;te<Z;)if(P[te]===L[ae]){if(ae===0){ce=te;break}te--,ae--}else te+=Math.max(L.length-ae,ue[P[te]]),ae=L.length-1;return ce}e.binaryIndexOf=l;function w(P,L){return P[L+0]<<0>>>0|P[L+1]<<8>>>0}e.readUInt16LE=w;function R(P,L,$){P[$+0]=L&255,L=L>>>8,P[$+1]=L&255}e.writeUInt16LE=R;function m(P,L){return P[L]*2**24+P[L+1]*2**16+P[L+2]*2**8+P[L+3]}e.readUInt32BE=m;function d(P,L,$){P[$+3]=L,L=L>>>8,P[$+2]=L,L=L>>>8,P[$+1]=L,L=L>>>8,P[$]=L}e.writeUInt32BE=d;function I(P,L){return P[L+0]<<0>>>0|P[L+1]<<8>>>0|P[L+2]<<16>>>0|P[L+3]<<24>>>0}e.readUInt32LE=I;function S(P,L,$){P[$+0]=L&255,L=L>>>8,P[$+1]=L&255,L=L>>>8,P[$+2]=L&255,L=L>>>8,P[$+3]=L&255}e.writeUInt32LE=S;function p(P,L){return P[L]}e.readUInt8=p;function f(P,L,$){P[$]=L}e.writeUInt8=f;function h(P){return O.consumeReadable(P,L=>u.concat(L))}e.readableToBuffer=h;function C(P){return O.toReadable(P)}e.bufferToReadable=C;function v(P){return O.consumeStream(P,L=>u.concat(L))}e.streamToBuffer=v;async function b(P){return P.ended?u.concat(P.buffer):u.concat([...P.buffer,await v(P.stream)])}e.bufferedStreamToBuffer=b;function t(P){return O.toStream(P,L=>u.concat(L))}e.bufferToStream=t;function a(P){return O.transform(P,{data:L=>typeof L=="string"?u.fromString(L):u.wrap(L)},L=>u.concat(L))}e.streamToBufferReadableStream=a;function i(P){return O.newWriteableStream(L=>u.concat(L),P)}e.newWriteableBufferStream=i;function n(P,L){return O.prefixedReadable(P,L,$=>u.concat($))}e.prefixedBufferReadable=n;function r(P,L){return O.prefixedStream(P,L,$=>u.concat($))}e.prefixedBufferStream=r;function s(P){let L=0,$=0,Q=0;const Z=new Uint8Array(Math.floor(P.length/4*3)),ue=ae=>{switch($){case 3:Z[Q++]=L|ae,$=0;break;case 2:Z[Q++]=L|ae>>>2,L=ae<<6,$=3;break;case 1:Z[Q++]=L|ae>>>4,L=ae<<4,$=2;break;default:L=ae<<2,$=1}};for(let ae=0;ae<P.length;ae++){const ce=P.charCodeAt(ae);if(ce>=65&&ce<=90)ue(ce-65);else if(ce>=97&&ce<=122)ue(ce-97+26);else if(ce>=48&&ce<=57)ue(ce-48+52);else if(ce===43||ce===45)ue(62);else if(ce===47||ce===95)ue(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${P[ae]}`)}}const te=Q;for(;$>0;)ue(0);return u.wrap(Z).slice(0,te)}e.decodeBase64=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:P},L=!0,$=!1){const Q=$?D:c;let Z="";const ue=P.byteLength%3;let te=0;for(;te<P.byteLength-ue;te+=3){const ae=P[te+0],ce=P[te+1],ie=P[te+2];Z+=Q[ae>>>2],Z+=Q[(ae<<4|ce>>>4)&63],Z+=Q[(ce<<2|ie>>>6)&63],Z+=Q[ie&63]}if(ue===1){const ae=P[te+0];Z+=Q[ae>>>2],Z+=Q[ae<<4&63],L&&(Z+="==")}else if(ue===2){const ae=P[te+0],ce=P[te+1];Z+=Q[ae>>>2],Z+=Q[(ae<<4|ce>>>4)&63],Z+=Q[ce<<2&63],L&&(Z+="=")}return Z}e.encodeBase64=y}),define(ne[41],se([0,1,29]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(f){return k(f,0)}e.hash=O;function k(f,h){switch(typeof f){case"object":return f===null?A(349,h):Array.isArray(f)?u(f,h):l(f,h);case"string":return E(f,h);case"boolean":return T(f,h);case"number":return A(f,h);case"undefined":return A(937,h);default:return A(617,h)}}e.doHash=k;function A(f,h){return(h<<5)-h+f|0}e.numberHash=A;function T(f,h){return A(f?433:863,h)}function E(f,h){h=A(149417,h);for(let C=0,v=f.length;C<v;C++)h=A(f.charCodeAt(C),h);return h}e.stringHash=E;function u(f,h){return h=A(104579,h),f.reduce((C,v)=>k(v,C),h)}function l(f,h){return h=A(181387,h),Object.keys(f).sort().reduce((C,v)=>(C=E(v,C),k(f[v],C)),h)}class w{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=k(h,this._value),this._value}}e.Hasher=w;var R;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function m(f,h,C=32){const v=C-h,b=~((1<<v)-1);return(f<<h|(b&f)>>>v)>>>0}function d(f,h=0,C=f.byteLength,v=0){for(let b=0;b<C;b++)f[h+b]=v}function I(f,h,C="0"){for(;f.length<h;)f=C+f;return f}function S(f,h=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(C=>C.toString(16).padStart(2,"0")).join(""):I((f>>>0).toString(16),h/4)}e.toHexString=S;class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const C=h.length;if(C===0)return;const v=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,a,i;for(t!==0?(a=t,i=-1,t=0):(a=h.charCodeAt(0),i=0);;){let n=a;if(N.isHighSurrogate(a))if(i+1<C){const r=h.charCodeAt(i+1);N.isLowSurrogate(r)?(i++,n=N.computeCodePoint(a,r)):n=65533}else{t=a;break}else N.isLowSurrogate(a)&&(n=65533);if(b=this._push(v,b,n),i++,i<C)a=h.charCodeAt(i);else break}this._buffLen=b,this._leftoverHighSurrogate=t}_push(h,C,v){return v<128?h[C++]=v:v<2048?(h[C++]=192|(v&1984)>>>6,h[C++]=128|(v&63)>>>0):v<65536?(h[C++]=224|(v&61440)>>>12,h[C++]=128|(v&4032)>>>6,h[C++]=128|(v&63)>>>0):(h[C++]=240|(v&1835008)>>>18,h[C++]=128|(v&258048)>>>12,h[C++]=128|(v&4032)>>>6,h[C++]=128|(v&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=p._bigBlock32,C=this._buffDV;for(let c=0;c<64;c+=4)h.setUint32(c,C.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,m(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let v=this._h0,b=this._h1,t=this._h2,a=this._h3,i=this._h4,n,r,s;for(let c=0;c<80;c++)c<20?(n=b&t|~b&a,r=1518500249):c<40?(n=b^t^a,r=1859775393):c<60?(n=b&t|b&a|t&a,r=2400959708):(n=b^t^a,r=3395469782),s=m(v,5)+n+i+r+h.getUint32(c*4,!1)&4294967295,i=a,a=t,t=m(b,30),b=v,v=s;this._h0=this._h0+v&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=p}),define(ne[54],se([0,1,29]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const A="error",T="warning",E="warn",u="info",l="ignore";function w(m){return m?N.equalsIgnoreCase(A,m)?k.Error:N.equalsIgnoreCase(T,m)||N.equalsIgnoreCase(E,m)?k.Warning:N.equalsIgnoreCase(u,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=w;function R(m){switch(m){case k.Error:return A;case k.Warning:return T;case k.Info:return u;default:return l}}k.toString=R}(O||(O={})),e.default=O}),define(ne[30],se([0,1,3]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const h=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([C,v])=>{h[C]=v&&typeof v=="object"?O(v):v}),h}e.deepClone=O;function k(f){if(!f||typeof f!="object")return f;const h=[f];for(;h.length>0;){const C=h.shift();Object.freeze(C);for(const v in C)if(A.call(C,v)){const b=C[v];typeof b=="object"&&!Object.isFrozen(b)&&!(0,N.isTypedArray)(b)&&h.push(b)}}return f}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function T(f,h){return E(f,h,new Set)}e.cloneAndChange=T;function E(f,h,C){if((0,N.isUndefinedOrNull)(f))return f;const v=h(f);if(typeof v<"u")return v;if(Array.isArray(f)){const b=[];for(const t of f)b.push(E(t,h,C));return b}if((0,N.isObject)(f)){if(C.has(f))throw new Error("Cannot clone recursive data-structure");C.add(f);const b={};for(const t in f)A.call(f,t)&&(b[t]=E(f[t],h,C));return C.delete(f),b}return f}function u(f,h,C=!0){return(0,N.isObject)(f)?((0,N.isObject)(h)&&Object.keys(h).forEach(v=>{v in f?C&&((0,N.isObject)(f[v])&&(0,N.isObject)(h[v])?u(f[v],h[v],C):f[v]=h[v]):f[v]=h[v]}),f):h}e.mixin=u;function l(f,h){if(f===h)return!0;if(f==null||h===null||h===void 0||typeof f!=typeof h||typeof f!="object"||Array.isArray(f)!==Array.isArray(h))return!1;let C,v;if(Array.isArray(f)){if(f.length!==h.length)return!1;for(C=0;C<f.length;C++)if(!l(f[C],h[C]))return!1}else{const b=[];for(v in f)b.push(v);b.sort();const t=[];for(v in h)t.push(v);if(t.sort(),!l(b,t))return!1;for(C=0;C<b.length;C++)if(!l(f[b[C]],h[b[C]]))return!1}return!0}e.equals=l;function w(f){const h=new Set;return JSON.stringify(f,(C,v)=>{if((0,N.isObject)(v)||Array.isArray(v)){if(h.has(v))return"[Circular]";h.add(v)}return v})}e.safeStringify=w;function R(f,h){const C=Object.create(null);return!f||!h||Object.keys(h).forEach(b=>{const t=f[b],a=h[b];l(t,a)||(C[b]=a)}),C}e.distinct=R;function m(f,h){const C=h.toLowerCase(),v=Object.keys(f).find(b=>b.toLowerCase()===C);return v?f[v]:f[h]}e.getCaseInsensitive=m;function d(f,h){const C=Object.create(null);for(const[v,b]of Object.entries(f))h(v,b)&&(C[v]=b);return C}e.filter=d;function I(f){let h=[];for(;Object.prototype!==f;)h=h.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return h}e.getAllPropertyNames=I;function S(f){const h=[];for(const C of I(f))typeof f[C]=="function"&&h.push(C);return h}e.getAllMethodNames=S;function p(f,h){const C=b=>function(){const t=Array.prototype.slice.call(arguments,0);return h(b,t)},v={};for(const b of f)v[b]=C(b);return v}e.createProxyObject=p}),define(ne[28],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return N.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),T=[];for(let E=0;E<256;E++)T.push(E.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l}}()}),define(ne[74],se([0,1,33]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const E=T.replace(/\-/g,":").toLowerCase();return!O.has(E)}function A(){const T=(0,N.networkInterfaces)();for(const E in T){const u=T[E];if(u){for(const{mac:l}of u)if(k(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[75],se([0,1,33,46,28,74]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(l){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(l)}value(){if(this._value===void 0){let l=0,w=0;const R=(0,N.networkInterfaces)();for(const m in R){const d=R[m];if(d)for(const{mac:I,internal:S}of d)S||(w+=1,this._isVirtualMachineMacAddress(I.toUpperCase())&&(l+=1))}this._value=w>0?l/w:0}return this._value}};let T;async function E(l){return T||(T=(async()=>await u(l)||k.generateUuid())()),T}e.getMachineId=E;async function u(l){try{const w=await new Promise((m,d)=>{G(["crypto"],m,d)}),R=(0,A.getMac)();return w.createHash("sha256").update(R,"utf8").digest("hex")}catch(w){l(w);return}}}),define(ne[76],se([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ne[77],se([0,1,76]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,A=k*24,T=A*7,E=A*30,u=A*365;function l(R,m,d,I){typeof R!="number"&&(R=R.getTime());const S=Math.round((new Date().getTime()-R)/1e3);if(S<-30)return(0,N.localize)(0,null,l(new Date().getTime()+S*1e3,!1));if(!I&&S<30)return(0,N.localize)(1,null);let p;return S<O?(p=S,m?p===1?d?(0,N.localize)(2,null,p):(0,N.localize)(3,null,p):d?(0,N.localize)(4,null,p):(0,N.localize)(5,null,p):p===1?d?(0,N.localize)(6,null,p):(0,N.localize)(7,null,p):d?(0,N.localize)(8,null,p):(0,N.localize)(9,null,p)):S<k?(p=Math.floor(S/O),m?p===1?d?(0,N.localize)(10,null,p):(0,N.localize)(11,null,p):d?(0,N.localize)(12,null,p):(0,N.localize)(13,null,p):p===1?d?(0,N.localize)(14,null,p):(0,N.localize)(15,null,p):d?(0,N.localize)(16,null,p):(0,N.localize)(17,null,p)):S<A?(p=Math.floor(S/k),m?p===1?d?(0,N.localize)(18,null,p):(0,N.localize)(19,null,p):d?(0,N.localize)(20,null,p):(0,N.localize)(21,null,p):p===1?d?(0,N.localize)(22,null,p):(0,N.localize)(23,null,p):d?(0,N.localize)(24,null,p):(0,N.localize)(25,null,p)):S<T?(p=Math.floor(S/A),m?p===1?(0,N.localize)(26,null,p):(0,N.localize)(27,null,p):p===1?(0,N.localize)(28,null,p):(0,N.localize)(29,null,p)):S<E?(p=Math.floor(S/T),m?p===1?d?(0,N.localize)(30,null,p):(0,N.localize)(31,null,p):d?(0,N.localize)(32,null,p):(0,N.localize)(33,null,p):p===1?d?(0,N.localize)(34,null,p):(0,N.localize)(35,null,p):d?(0,N.localize)(36,null,p):(0,N.localize)(37,null,p)):S<u?(p=Math.floor(S/E),m?p===1?d?(0,N.localize)(38,null,p):(0,N.localize)(39,null,p):d?(0,N.localize)(40,null,p):(0,N.localize)(41,null,p):p===1?d?(0,N.localize)(42,null,p):(0,N.localize)(43,null,p):d?(0,N.localize)(44,null,p):(0,N.localize)(45,null,p)):(p=Math.floor(S/u),m?p===1?d?(0,N.localize)(46,null,p):(0,N.localize)(47,null,p):d?(0,N.localize)(48,null,p):(0,N.localize)(49,null,p):p===1?d?(0,N.localize)(50,null,p):(0,N.localize)(51,null,p):d?(0,N.localize)(52,null,p):(0,N.localize)(53,null,p))}e.fromNow=l;function w(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(ne[78],se([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ne[34],se([0,1,19,3,78]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(R,m){return m&&(R.stack||R.stacktrace)?k.localize(0,null,E(R),T(R.stack)||T(R.stacktrace)):E(R)}function T(R){return Array.isArray(R)?R.join(`
`):R}function E(R){return R.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${R.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?k.localize(1,null,R.message):R.message||k.localize(2,null)}function u(R=null,m=!1){if(!R)return k.localize(3,null);if(Array.isArray(R)){const d=N.coalesce(R),I=u(d[0],m);return d.length>1?k.localize(4,null,I,d.length):I}if(O.isString(R))return R;if(R.detail){const d=R.detail;if(d.error)return A(d.error,m);if(d.exception)return A(d.exception,m)}return R.stack?A(R,m):R.message?R.message:k.localize(5,null)}e.toErrorMessage=u;function l(R){const m=R;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=l;function w(R,m){let d;return typeof R=="string"?d=new Error(R):d=R,d.actions=m,d}e.createErrorWithActions=w}),define(ne[79],se([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],se([0,1,79]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ne[55],se([0,1,13]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(E,...u){const l=u.reduce((m,d)=>(m[d]=!0,m),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(m=>!l[m]).forEach(m=>{for(let d=0;d<w.length;d++)if(m.search(w[d])!==-1){delete E[m];break}})}e.sanitizeProcessEnvironment=A;function T(E){E&&(delete E.DEBUG,N.isMacintosh&&delete E.DYLD_LIBRARY_PATH,N.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[81],se([0,1,11]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(l){const w=l;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=O;function k(l){const w=[];let R;try{const m=JSON.parse(l.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),R=d.__$stack),w.push(...m)}catch{w.push("Unable to log remote console arguments",l.arguments)}return{args:w,stack:R}}e.parse=k;function A(l){if(typeof l!="string")return A(k(l).stack);const w=l;if(w){const R=T(w),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(m&&m.length===4)return{uri:N.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=A;function T(l){if(!l)return l;const w=l.indexOf(`
`);return w===-1?l:l.substring(0,w)}function E(l,w){const{args:R,stack:m}=k(l),d=typeof R[0]=="string"&&R.length===1;let I=T(m);I&&(I=`(${I.trim()})`);let S=[];if(typeof R[0]=="string"?I&&d?S=[`%c[${w}] %c${R[0]} %c${I}`,u("blue"),u(""),u("grey")]:S=[`%c[${w}] %c${R[0]}`,u("blue"),u(""),...R.slice(1)]:S=[`%c[${w}]%`,u("blue"),...R],I&&!d&&S.push(I),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,S)}e.log=E;function u(l){return`color: ${l}`}}),define(ne[47],se([0,1,14,11]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(u){return JSON.stringify(u,T)}e.stringify=k;function A(u){let l=JSON.parse(u);return l=E(l),l}e.parse=A;function T(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function E(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return O.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof N.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let w=0;w<u.length;++w)u[w]=E(u[w],l+1);else for(const w in u)Object.hasOwnProperty.call(u,w)&&(u[w]=E(u[w],l+1))}return u}e.revive=E}),define(ne[82],se([0,1,70,15,13,11]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(m,d,I){this.id=m,this.dependencies=d,this.callback=I}}class E{static{this.INSTANCE=new E}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(m,d,I)=>{typeof m!="string"&&(I=d,d=m,m=null),(typeof d!="object"||!Array.isArray(d))&&(I=d,d=null),this._defineCalls.push(new T(m,d,I))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this._initialize();const d=await(this._isWebWorker?this._workerLoadScript(m):this._isRenderer?this._rendererLoadScript(m):this._nodeJSLoadScript(m));if(!d)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}_rendererLoadScript(m){return new Promise((d,I)=>{const S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript");const p=()=>{S.removeEventListener("load",f),S.removeEventListener("error",h)},f=C=>{p(),d(this._defineCalls.pop())},h=C=>{p(),I(C)};S.addEventListener("load",f),S.addEventListener("error",h),this._amdPolicy&&(m=this._amdPolicy.createScriptURL(m)),S.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(S)})}_workerLoadScript(m){return new Promise((d,I)=>{try{this._amdPolicy&&(m=this._amdPolicy.createScriptURL(m)),importScripts(m),d(this._defineCalls.pop())}catch(S){I(S)}})}async _nodeJSLoadScript(m){try{const d=globalThis._VSCODE_NODE_MODULES.fs,I=globalThis._VSCODE_NODE_MODULES.vm,S=globalThis._VSCODE_NODE_MODULES.module,p=A.URI.parse(m).fsPath,f=d.readFileSync(p).toString(),h=S.wrap(f.replace(/^#!.*/,""));return new I.Script(h).runInThisContext().apply(),this._defineCalls.pop()}catch(d){throw d}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function w(R,m,d){if(N.isESM){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[R]&&(R=l[R]);const I=`${R}/${m}`;if(u.has(I))return u.get(I);let S;if(/^\w[\w\d+.-]*:\/\//.test(I))S=I;else{const C=`${d&&!k.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${I}`;S=O.FileAccess.asBrowserUri(C).toString(!0)}const p=E.INSTANCE.load(S);return u.set(I,p),p}else return await new Promise((I,S)=>{G([R],I,S)})}e.importAMDNodeModule=w}),define(ne[83],se([0,1,33,16,24]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class R{constructor(b,t,a){this.exePath=b,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:v=!1}={}){return v?l===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:v=!1,findPreview:b=!1}={}){const t=m({useAlternateBitness:v});if(!t)return null;const a=O.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const c of await k.Promises.readdir(a)){let D=-1;if(b){const P=c.indexOf("-");if(P<0)continue;const L=c.substring(0,P);if(!A.test(L)||c.substring(P+1)!=="preview")continue;D=parseInt(L,10)}else{if(!A.test(c))continue;D=parseInt(c,10)}if(D<=i)continue;const y=O.join(a,c,"pwsh.exe");await k.SymlinkSupport.existsFile(y)&&(n=y,i=D)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",s=b?" Preview":"";return new R(n,`PowerShell${s}${r}`,!0)}async function I({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const b=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(b))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=v?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(b))if(t.test(i)){const n=O.join(b,i,"pwsh.exe");return new R(n,a)}return null}function S(){const v=O.join(N.homedir(),".dotnet","tools","pwsh.exe");return new R(v,".NET Core PowerShell Global Tool")}function p(){const v=O.join(process.env.windir,l===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(v,"Windows PowerShell",!0)}async function*f(){let v=await d();v&&(yield v),v=await d({useAlternateBitness:!0}),v&&(yield v),v=await I(),v&&(yield v),v=S(),v&&(yield v),v=await d({findPreview:!0}),v&&(yield v),v=await I({findPreview:!0}),v&&(yield v),v=await d({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=p(),v&&(yield v)}async function*h(){for await(const v of f())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=h;async function C(){for await(const v of h())return v;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ne[56],se([0,1,16,13,35,55,3,24]),function(G,e,N,O,k,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(R=k.env){return R.comspec||"cmd.exe"}e.getWindowsShell=u;function l(R){let m=[],d=!1;const I=function(S){if(d){m.push(S);return}(!R.send(S,f=>{if(f&&console.error(f),d=!1,m.length>0){const h=m.slice(0);m=[],h.forEach(C=>I(C))}})||O.isWindows)&&(d=!0)};return{send:I}}e.createQueuedSender=l;var w;(function(R){async function m(d,I,S){if(N.isAbsolute(d))return d;if(I===void 0&&(I=k.cwd()),N.dirname(d)!=="."||(S===void 0&&T.isString(k.env.PATH)&&(S=k.env.PATH.split(N.delimiter)),S===void 0||S.length===0))return N.join(I,d);async function f(h){if(await E.Promises.exists(h)){let C;try{C=await E.Promises.stat(h)}catch(v){v.message.startsWith("EACCES")&&(C=await E.Promises.lstat(h))}return C?!C.isDirectory():!1}return!1}for(const h of S){let C;if(N.isAbsolute(h)?C=N.join(h,d):C=N.join(I,h,d),await f(C))return C;let v=C+".com";if(await f(v)||(v=C+".exe",await f(v)))return v}return N.join(I,d)}R.findExecutable=m})(w||(e.win32=w={}))}),define(ne[84],se([0,1,33,13,83,56]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(R,m){return R===1?O.isWindows?w():A.getWindowsShell(m):u(R,m)}e.getSystemShell=T;let E=null;function u(R,m){if(O.isLinux&&R===2||O.isMacintosh&&R===3)return"/bin/bash";if(!E){let d;if(O.isWindows)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,N.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}E=d}return E}let l=null;async function w(){return l||(l=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(G,e,N,O){var k=arguments.length,A=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,N):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,N,O);else for(var E=G.length-1;E>=0;E--)(T=G[E])&&(A=(k<3?T(A):k>3?T(e,N,A):T(e,N))||A);return k>3&&A&&Object.defineProperty(e,N,A),A};define(ne[57],se([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(G,e,N,O,k,A,T,E,u,l,w,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(d||(d={}));function I(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(S||(S={}));function p(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function h(V){let M=0;for(let z=0;;z+=7){const K=V.read(1);if(M|=(K.buffer[0]&127)<<z,!(K.buffer[0]&128))return M}}const C=i(0);function v(V,M){if(M===0){V.write(C);return}let z=0;for(let X=M;X!==0;X=X>>>7)z++;const K=k.VSBuffer.alloc(z);for(let X=0;M!==0;X++)K.buffer[X]=M&127,M=M>>>7,M>0&&(K.buffer[X]|=128);V.write(K)}class b{constructor(M){this.buffer=M,this.pos=0}read(M){const z=this.buffer.slice(this.pos,this.pos+M);return this.pos+=z.byteLength,z}}e.BufferReader=b;class t{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=t;var a;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(a||(a={}));function i(V){const M=k.VSBuffer.alloc(1);return M.writeUInt8(V,0),M}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},r=typeof Buffer<"u";function s(V,M){if(typeof M>"u")V.write(n.Undefined);else if(typeof M=="string"){const z=k.VSBuffer.fromString(M);V.write(n.String),v(V,z.byteLength),V.write(z)}else if(r&&Buffer.isBuffer(M)){const z=k.VSBuffer.wrap(M);V.write(n.Buffer),v(V,z.byteLength),V.write(z)}else if(M instanceof k.VSBuffer)V.write(n.VSBuffer),v(V,M.byteLength),V.write(M);else if(Array.isArray(M)){V.write(n.Array),v(V,M.length);for(const z of M)s(V,z)}else if(typeof M=="number"&&(M|0)===M)V.write(n.Uint),v(V,M);else{const z=k.VSBuffer.fromString(JSON.stringify(M));V.write(n.Object),v(V,z.byteLength),V.write(z)}}e.serialize=s;function c(V){switch(V.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return V.read(h(V)).toString();case a.Buffer:return V.read(h(V)).buffer;case a.VSBuffer:return V.read(h(V));case a.Array:{const z=h(V),K=[];for(let X=0;X<z;X++)K.push(c(V));return K}case a.Object:return JSON.parse(V.read(h(V)).toString());case a.Int:return h(V)}}e.deserialize=c;class D{constructor(M,z,K=null,X=1e3){this.protocol=M,this.ctx=z,this.logger=K,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(M,z){this.channels.set(M,z),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const z=this.send([M.type]);this.logger?.logOutgoing(z,0,1,p(M.type));return}case 201:case 202:case 204:case 203:{const z=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(z,M.id,1,p(M.type),M.data);return}}}send(M,z=void 0){const K=new t;return s(K,M),s(K,z),this.sendBuffer(K.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const z=new b(M),K=c(z),X=c(z),J=K[0];switch(J){case 100:return this.logger?.logIncoming(M.byteLength,K[1],1,`${I(J)}: ${K[2]}.${K[3]}`,X),this.onPromise({type:J,id:K[1],channelName:K[2],name:K[3],arg:X});case 102:return this.logger?.logIncoming(M.byteLength,K[1],1,`${I(J)}: ${K[2]}.${K[3]}`,X),this.onEventListen({type:J,id:K[1],channelName:K[2],name:K[3],arg:X});case 101:return this.logger?.logIncoming(M.byteLength,K[1],1,`${I(J)}`),this.disposeActiveRequest({type:J,id:K[1]});case 103:return this.logger?.logIncoming(M.byteLength,K[1],1,`${I(J)}`),this.disposeActiveRequest({type:J,id:K[1]})}}onPromise(M){const z=this.channels.get(M.channelName);if(!z){this.collectPendingRequest(M);return}const K=new A.CancellationTokenSource;let X;try{X=z.call(this.ctx,M.name,M.arg,K.token)}catch(x){X=Promise.reject(x)}const J=M.id;X.then(x=>{this.sendResponse({id:J,data:x,type:201})},x=>{x instanceof Error?this.sendResponse({id:J,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.sendResponse({id:J,data:x,type:203})}).finally(()=>{_.dispose(),this.activeRequests.delete(M.id)});const _=(0,l.toDisposable)(()=>K.cancel());this.activeRequests.set(M.id,_)}onEventListen(M){const z=this.channels.get(M.channelName);if(!z){this.collectPendingRequest(M);return}const K=M.id,J=z.listen(this.ctx,M.name,M.arg)(_=>this.sendResponse({id:K,data:_,type:204}));this.activeRequests.set(M.id,J)}disposeActiveRequest(M){const z=this.activeRequests.get(M.id);z&&(z.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let z=this.pendingRequests.get(M.channelName);z||(z=[],this.pendingRequests.set(M.channelName,z));const K=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:M,timeoutTimer:K})}flushPendingRequests(M){const z=this.pendingRequests.get(M);if(z){for(const K of z)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var y;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class P{constructor(M,z=null){this.protocol=M,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=z}getChannel(M){const z=this;return{call(K,X,J){return z.isDisposed?Promise.reject(new E.CancellationError):z.requestPromise(M,K,X,J)},listen(K,X){return z.isDisposed?u.Event.None:z.requestEvent(M,K,X)}}}requestPromise(M,z,K,X=A.CancellationToken.None){const J=this.lastRequestId++,x={id:J,type:100,channelName:M,name:z,arg:K};if(X.isCancellationRequested)return Promise.reject(new E.CancellationError);let o;return new Promise((F,U)=>{if(X.isCancellationRequested)return U(new E.CancellationError);const H=()=>{const me=de=>{switch(de.type){case 201:this.handlers.delete(J),F(de.data);break;case 202:{this.handlers.delete(J);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.handlers.delete(J),U(de.data);break}};this.handlers.set(J,me),this.sendRequest(x)};let q=null;this.state===f.Idle?H():(q=(0,O.createCancelablePromise)(me=>this.whenInitialized()),q.then(()=>{q=null,H()}));const le=()=>{q?(q.cancel(),q=null):this.sendRequest({id:J,type:101}),U(new E.CancellationError)},oe=X.onCancellationRequested(le);o=(0,l.combinedDisposable)((0,l.toDisposable)(le),oe),this.activeRequests.add(o)}).finally(()=>{o.dispose(),this.activeRequests.delete(o)})}requestEvent(M,z,K){const X=this.lastRequestId++,_={id:X,type:102,channelName:M,name:z,arg:K};let x=null;const o=new u.Emitter({onWillAddFirstListener:()=>{x=(0,O.createCancelablePromise)(F=>this.whenInitialized()),x.then(()=>{x=null,this.activeRequests.add(o),this.sendRequest(_)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.activeRequests.delete(o),this.sendRequest({id:X,type:103}))}}),g=F=>o.fire(F.data);return this.handlers.set(X,g),o.event}sendRequest(M){switch(M.type){case 100:case 102:{const z=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing(z,M.id,0,`${I(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const z=this.send([M.type,M.id]);this.logger?.logOutgoing(z,M.id,0,I(M.type));return}}}send(M,z=void 0){const K=new t;return s(K,M),s(K,z),this.sendBuffer(K.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const z=new b(M),K=c(z),X=c(z),J=K[0];switch(J){case 200:return this.logger?.logIncoming(M.byteLength,0,0,p(J)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,K[1],0,p(J),X),this.onResponse({type:K[0],id:K[1],data:X})}}onResponse(M){if(M.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=P,ve([T.memoize],P.prototype,"onDidInitializePromise",null);class L{get connections(){const M=[];return this._connections.forEach(z=>M.push(z)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(M(({protocol:z,onDidClientDisconnect:K})=>{const X=u.Event.once(z.onMessage);this.disposables.add(X(J=>{const _=new b(J),x=c(_),o=new D(z,x),g=new P(z);this.channels.forEach((U,H)=>o.registerChannel(H,U));const F={channelServer:o,channelClient:g,ctx:x};this._connections.add(F),this._onDidAddConnection.fire(F),this.disposables.add(K(()=>{o.dispose(),g.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)}))}))}))}getChannel(M,z){const K=this;return{call(X,J,_){let x;if((0,m.isFunction)(z)){const g=(0,N.getRandomElement)(K.connections.filter(z));x=g?Promise.resolve(g):u.Event.toPromise(u.Event.filter(K.onDidAddConnection,z))}else x=z.routeCall(K,X,J);const o=x.then(g=>g.channelClient.getChannel(M));return Q(o).call(X,J,_)},listen(X,J){if((0,m.isFunction)(z))return K.getMulticastEvent(M,z,X,J);const _=z.routeEvent(K,X,J).then(x=>x.channelClient.getChannel(M));return Q(_).listen(X,J)}}}getMulticastEvent(M,z,K,X){const J=this;let _;const x=new u.Emitter({onWillAddFirstListener:()=>{_=new l.DisposableStore;const o=new u.EventMultiplexer,g=new Map,F=H=>{const le=H.channelClient.getChannel(M).listen(K,X),oe=o.add(le);g.set(H,oe)},U=H=>{const q=g.get(H);q&&(q.dispose(),g.delete(H))};J.connections.filter(z).forEach(F),u.Event.filter(J.onDidAddConnection,z)(F,void 0,_),J.onDidRemoveConnection(U,void 0,_),o.event(x.fire,x,_),_.add(o)},onDidRemoveLastListener:()=>{_?.dispose(),_=void 0}});return x.event}registerChannel(M,z){this.channels.set(M,z);for(const K of this._connections)K.channelServer.registerChannel(M,z)}dispose(){this.disposables.dispose();for(const M of this._connections)M.channelClient.dispose(),M.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class ${constructor(M,z,K=null){const X=new t;s(X,z),M.send(X.buffer),this.channelClient=new P(M,K),this.channelServer=new D(M,z,K)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,z){this.channelServer.registerChannel(M,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function Q(V){return{call(M,z,K){return V.then(X=>X.call(M,z,K))},listen(M,z){const K=new u.Relay;return V.then(X=>K.input=X.listen(M,z)),K.event}}}e.getDelayedChannel=Q;function Z(V){let M=!1;return{call(z,K,X){return M?V.call(z,K,X):(0,O.timeout)(0).then(()=>M=!0).then(()=>V.call(z,K,X))},listen(z,K){if(M)return V.listen(z,K);const X=new u.Relay;return(0,O.timeout)(0).then(()=>M=!0).then(()=>X.input=V.listen(z,K)),X.event}}}e.getNextTickChannel=Z;class ue{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const z of M.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await u.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ue;var te;(function(V){function M(J,_,x){const o=J,g=x&&x.disableMarshalling,F=new Map;for(const U in o)K(U)&&F.set(U,u.Event.buffer(o[U],!0,void 0,_));return new class{listen(U,H,q){const le=F.get(H);if(le)return le;if(X(H)){const oe=o[H];if(typeof oe=="function")return oe.call(o,q)}throw new E.ErrorNoTelemetry(`Event not found: ${H}`)}call(U,H,q){const le=o[H];if(typeof le=="function"){if(!g&&Array.isArray(q))for(let me=0;me<q.length;me++)q[me]=(0,w.revive)(q[me]);let oe=le.apply(o,q);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new E.ErrorNoTelemetry(`Method not found: ${H}`)}}}V.fromService=M;function z(J,_){const x=_&&_.disableMarshalling;return new Proxy({},{get(o,g){if(typeof g=="string")return _?.properties?.has(g)?_.properties.get(g):X(g)?function(F){return J.listen(g,F)}:K(g)?J.listen(g):async function(...F){let U;_&&!(0,m.isUndefinedOrNull)(_.context)?U=[_.context,...F]:U=F;const H=await J.call(g,U);return x?H:(0,w.revive)(H)};throw new E.ErrorNoTelemetry(`Property not found: ${String(g)}`)}})}V.toService=z;function K(J){return J[0]==="o"&&J[1]==="n"&&R.isUpperAsciiLetter(J.charCodeAt(2))}function X(J){return/^onDynamic/.test(J)&&R.isUpperAsciiLetter(J.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const M=V.toString();if(M!=="[object Object]")return M}return V}function ie(V){return Array.isArray(V)?V.map(ce):ce(V)}function W(V,M,z,K,X,J,_){_=ie(_);const x=ae[X],o=x[K%x.length];let g=[`%c[${V}]%c[${String(M).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(J)?(g=g.concat(_),g.push(")")):g.push(_),console.log.apply(console,g)}class B{constructor(M,z){this._outgoingPrefix=M,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,z,K,X,J){this._totalOutgoing+=M,W(this._outgoingPrefix,this._totalOutgoing,M,z,K,X,J)}logIncoming(M,z,K,X,J){this._totalIncoming+=M,W(this._incomingPrefix,this._totalIncoming,M,z,K,X,J)}}e.IPCLogger=B}),define(ne[85],se([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class I extends d.ChannelServer{constructor(f){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",h=>k.VSBuffer.wrap(Buffer.from(h,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=I;class S{constructor(f,h){this.modulePath=f,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new O.Delayer(C),this.child=null,this._client=null}getChannel(f){const h=this;return{call(C,v,b){return h.requestPromise(f,C,v,b)},listen(C,v){return h.requestEvent(f,C,v)}}}requestPromise(f,h,C,v=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const b=this.getCachedChannel(f),t=(0,O.createCancelablePromise)(n=>b.call(h,C,n)),a=v.onCancellationRequested(()=>t.cancel()),i=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{a.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,h,C){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let v;const b=new u.Emitter({onWillAddFirstListener:()=>{v=this.getCachedChannel(f).listen(h,C)(b.fire,b),this.activeRequests.add(v)},onDidRemoveLastListener:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return b.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(h.env),this.child=(0,N.fork)(this.modulePath,f,h);const C=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}C.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const b=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&b.send(r.buffer.toString("base64")),a=C.event,i={send:t,onMessage:a};this._client=new d.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(c=>(0,l.dispose)(c)),this.activeRequests.clear(),r!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+s),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:s})})}return this._client}getCachedChannel(f){let h=this.channels.get(f);return h||(h=this.client.getChannel(f),this.channels.set(f,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[86],se([0,1,8,4,2,47,3]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=u;var l;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(l||(e.StorageState=l={}));class w extends k.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(d,I=Object.create(null)){super(),this.database=d,this.options=I,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new N.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){this._onDidChangeStorage.pause();try{d.changed?.forEach((I,S)=>this.acceptExternal(S,I)),d.deleted?.forEach(I=>this.acceptExternal(I,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(d,I){if(this.state===l.Closed)return;let S=!1;(0,T.isUndefinedOrNull)(I)?S=this.cache.delete(d):this.cache.get(d)!==I&&(this.cache.set(d,I),S=!0),S&&this._onDidChangeStorage.fire({key:d,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,I){const S=this.cache.get(d);return(0,T.isUndefinedOrNull)(S)?I:S}getBoolean(d,I){const S=this.get(d);return(0,T.isUndefinedOrNull)(S)?I:S==="true"}getNumber(d,I){const S=this.get(d);return(0,T.isUndefinedOrNull)(S)?I:parseInt(S,10)}getObject(d,I){const S=this.get(d);return(0,T.isUndefinedOrNull)(S)?I:(0,A.parse)(S)}async set(d,I,S=!1){if(this.state===l.Closed)return;if((0,T.isUndefinedOrNull)(I))return this.delete(d,S);const p=(0,T.isObject)(I)||Array.isArray(I)?(0,A.stringify)(I):String(I);if(this.cache.get(d)!==p)return this.cache.set(d,p),this.pendingInserts.set(d,p),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire({key:d,external:S}),this.doFlush()}async delete(d,I=!1){if(!(this.state===l.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire({key:d,external:I}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(this.hasPending)return this.doFlush(d)}async doFlush(d){return this.options.hint===E.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}isInMemory(){return this.options.hint===E.STORAGE_IN_MEMORY}}e.Storage=w;class R{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((I,S)=>this.items.set(S,I)),d.delete?.forEach(I=>this.items.delete(I))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=R}),define(ne[87],se([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ne[88],se([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],se([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],se([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],se([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],se([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],se([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ne[100],se([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ne[101],se([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],se([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],se([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ne[104],se([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],se([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],se([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],se([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],se([0,1,9,90]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const T=(0,O.localize)(3,null),E=(0,O.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,N.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(w){return this._input=w,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const R=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:R})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const R=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:R})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(w){return this._isAtEnd()||this._input.charCodeAt(this._current)!==w?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(w){this._tokens.push({type:w,offset:this._start})}_error(w){const R=this._start,m=this._input.substring(this._start,this._current),d={type:19,offset:this._start,lexeme:m};this._errors.push({offset:R,lexeme:m,additionalInfo:w}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const w=this.stringRe.exec(this._input);if(w){this._current=this._start+w[0].length;const R=this._input.substring(this._start,this._current),m=u._keywords.get(R);m?this._addToken(m):this._tokens.push({type:17,lexeme:R,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let w=this._current,R=!1,m=!1;for(;;){if(w>=this._input.length){this._current=w,this._error(E);return}const I=this._input.charCodeAt(w);if(R)R=!1;else if(I===47&&!m){w++;break}else I===91?m=!0:I===92?R=!0:I===93&&(m=!1);w++}for(;w<this._input.length&&u._regexFlags.has(this._input.charCodeAt(w));)w++;this._current=w;const d=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(ne[109],se([0,1,77,52,15,16,35,17,11]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=T.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.join)(d,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.resolve)(d)):u.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const I=T.env.VSCODE_EXTENSIONS;if(I)return I;const S=T.env.VSCODE_PORTABLE;return S?(0,A.join)(S,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(I=>/^[^:/?#]+?:\/\//.test(I)?u.URI.parse(I):u.URI.file((0,A.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const I of this.args.log||[]){const S=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(I);S&&S[1]&&S[2]&&d.push([S[1],S[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=T.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.join)(d,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,I,S){this._args=d,this.paths=I,this.productService=S,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([O.memoize],l.prototype,"appRoot",null),ve([O.memoize],l.prototype,"userHome",null),ve([O.memoize],l.prototype,"userDataPath",null),ve([O.memoize],l.prototype,"appSettingsHome",null),ve([O.memoize],l.prototype,"tmpDir",null),ve([O.memoize],l.prototype,"cacheHome",null),ve([O.memoize],l.prototype,"stateResource",null),ve([O.memoize],l.prototype,"userRoamingDataHome",null),ve([O.memoize],l.prototype,"userDataSyncHome",null),ve([O.memoize],l.prototype,"sync",null),ve([O.memoize],l.prototype,"machineSettingsResource",null),ve([O.memoize],l.prototype,"workspaceStorageHome",null),ve([O.memoize],l.prototype,"localHistoryHome",null),ve([O.memoize],l.prototype,"keyboardLayoutResource",null),ve([O.memoize],l.prototype,"argvResource",null),ve([O.memoize],l.prototype,"isExtensionDevelopment",null),ve([O.memoize],l.prototype,"untitledWorkspacesHome",null),ve([O.memoize],l.prototype,"builtinExtensionsPath",null),ve([O.memoize],l.prototype,"extensionsPath",null),ve([O.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([O.memoize],l.prototype,"extensionDevelopmentKind",null),ve([O.memoize],l.prototype,"extensionTestsLocationURI",null),ve([O.memoize],l.prototype,"debugExtensionHost",null),ve([O.memoize],l.prototype,"logLevel",null),ve([O.memoize],l.prototype,"extensionLogLevel",null),ve([O.memoize],l.prototype,"serviceMachineIdResource",null),ve([O.memoize],l.prototype,"disableTelemetry",null),ve([O.memoize],l.prototype,"disableWorkspaceTrust",null),ve([O.memoize],l.prototype,"useInMemorySecretStorage",null),ve([O.memoize],l.prototype,"policyFile",null);function w(m,d){return R(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=w;function R(m,d,I,S,p,f){const C=Number(d||m)||(S?null:I),v=C?!!d:!1;let b;if(f)try{b=JSON.parse(f)}catch{}return{port:C,break:v,debugId:p,env:b}}e.parseDebugParams=R}),function(){"use strict";function G(e,N,O){function k(T,E){const u=A(T,E),l=[u];return e.isAbsolute(u)||l.unshift(O),e.resolve(...l)}function A(T,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,E);const w=T["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(R,"AppData","Roaming")}break;case"darwin":l=e.join(N.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,E)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[110],se([165,33,35]),function(e,N,O){return G(e,N,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=G(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],se([0,1,33,109,110]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(l,w){super(l,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,k.getUserDataPath)(l,w.nameShort)},w)}}e.NativeEnvironmentService=A;function T(u,l){return(0,O.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.parsePtyHostDebugPort=T;function E(u,l){return(0,O.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.parseSharedProcessDebugPort=E}),define(ne[112],se([0,1,3,94]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(T,E,u,l){try{A(T,E,u,l)}catch(w){T.error(w?.message??w)}return E}e.localizeManifest=k;function A(T,E,u,l){const w=(R,m,d)=>{const I=R[m];if((0,N.isString)(I)){const S=I,p=S.length;if(p>1&&S[0]==="%"&&S[p-1]==="%"){const f=S.substr(1,p-2);let h=u[f];h===void 0&&l&&(h=l[f]);const C=typeof h=="string"?h:h?.message,v=l?.[f],b=typeof v=="string"?v:v?.message;if(!C){b||T.warn(`[${E.name}]: ${(0,O.localize)(0,null,f)}`);return}if(d&&(m==="title"||m==="category")&&b&&b!==C){const t={value:C,original:b};R[m]=t}else R[m]=C}}else if((0,N.isObject)(I))for(const S in I)I.hasOwnProperty(S)&&(S==="commands"?w(I,S,!0):w(I,S,d));else if(Array.isArray(I))for(let S=0;S<I.length;S++)w(I,S,d)};for(const R in E)E.hasOwnProperty(R)&&w(E,R)}}),define(ne[48],se([0,1,17,54,98,42]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=u;function l(f){if(!u(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=f.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=l;function w(f){if(!f)return null;const h=f.majorBase,C=f.majorMustEqual,v=f.minorBase;let b=f.minorMustEqual;const t=f.patchBase;let a=f.patchMustEqual;f.hasCaret&&(h===0||(b=!1),a=!1);let i=0;if(f.preRelease){const n=E.exec(f.preRelease);if(n){const[,r,s,c]=n;i=Date.UTC(Number(r),Number(s)-1,Number(c))}}return{majorBase:h,majorMustEqual:C,minorBase:v,minorMustEqual:b,patchBase:t,patchMustEqual:a,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=w;function R(f,h,C){let v;typeof f=="string"?v=w(l(f)):v=f;let b;h instanceof Date?b=h.getTime():typeof h=="string"&&(b=new Date(h).getTime());let t;if(typeof C=="string"?t=w(l(C)):t=C,!v||!t)return!1;const a=v.majorBase,i=v.minorBase,n=v.patchBase;let r=t.majorBase,s=t.minorBase,c=t.patchBase;const D=t.notBefore;let y=t.majorMustEqual,P=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:i>s?!0:i<s||b&&b<D?!1:n>=c:(a===1&&r===0&&(!y||!P||!L)&&(r=1,s=0,c=0,y=!0,P=!1,L=!1),a<r?!1:a>r?!y:i<s?!1:i>s?!P:n<c?!1:n>c?!L:!(b&&b<D))}e.isValidVersion=R;function m(f,h,C,v,b){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([O.default.Error,k.localize(0,null)]),t;if(typeof v.name!="string")return t.push([O.default.Error,k.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([O.default.Error,k.localize(2,null,"version")]),t;if(!v.engines)return t.push([O.default.Error,k.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([O.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!p(v.extensionDependencies))return t.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!p(v.activationEvents))return t.push([O.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([O.default.Error,k.localize(9,null,"main")]),t;{const n=(0,N.joinPath)(C,v.main);(0,N.isEqualOrParent)(n,C)||t.push([O.default.Warning,k.localize(10,null,n.path,C.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([O.default.Error,k.localize(11,null,"browser")]),t;{const n=(0,N.joinPath)(C,v.browser);(0,N.isEqualOrParent)(n,C)||t.push([O.default.Warning,k.localize(12,null,n.path,C.path)])}}if(!A.valid(v.version))return t.push([O.default.Error,k.localize(13,null)]),t;const a=[];if(!d(f,h,v,b,a))for(const n of a)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=m;function d(f,h,C,v,b){return v||typeof C.main>"u"&&typeof C.browser>"u"?!0:S(f,h,C.engines.vscode,b)}e.isValidExtensionVersion=d;function I(f,h,C){return f==="*"||S(h,C,f)}e.isEngineValid=I;function S(f,h,C,v=[]){const b=w(l(C));if(!b)return v.push(k.localize(14,null,C)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return v.push(k.localize(15,null,C)),!1}else if(!b.majorMustEqual)return v.push(k.localize(16,null,C)),!1;return R(f,h,b)?!0:(v.push(k.localize(17,null,f,C)),!1)}function p(f){if(!Array.isArray(f))return!1;for(let h=0,C=f.length;h<C;h++)if(typeof f[h]!="string")return!1;return!0}}),define(ne[113],se([0,1,14,28]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,T,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const w=(await T.readFile(A.serviceMachineIdResource)).value.toString();u=(0,O.isUUID)(w)?w:null}catch{u=null}if(!u){u=(0,O.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,N.VSBuffer.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(ne[49],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(k,A=[],T=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=N}),define(ne[114],se([0,1,49]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(E,u,l){u instanceof N.SyncDescriptor||(u=new N.SyncDescriptor(u,[],!!l)),O.push([E,u])}e.registerSingleton=A;function T(){return O}e.getSingletonServiceDescriptors=T}),define(ne[115],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const E=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(T);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const E of this._nodes.values())E.outgoing.delete(T),E.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let E=this._nodes.get(T);return E||(E=new N(T,A),this._nodes.set(T,E)),E}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,E]of this._nodes)A.push(`${T}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const E=new Set([A]),u=this._findCycle(T,E);if(u)return u}}_findCycle(A,T){for(const[E,u]of A.outgoing){if(T.has(E))return[...T,E].join(" -> ");T.add(E);const l=this._findCycle(u,T);if(l)return l;T.delete(E)}}}e.Graph=O}),define(ne[25],se([0,1,3,11,10]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof O.URI)}e.isConfigurationOverrides=A;function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var E;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.isConfigured=l;function w(f,h){const C=Object.create(null);for(const v in f)R(C,v,f[v],h);return C}e.toValuesTree=w;function R(f,h,C,v){const b=h.split("."),t=b.pop();let a=f;for(let i=0;i<b.length;i++){const n=b[i];let r=a[n];switch(typeof r){case"undefined":r=a[n]=Object.create(null);break;case"object":break;default:v(`Ignoring ${h} as ${b.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}a=r}if(typeof a=="object"&&a!==null)try{a[t]=C}catch{v(`Ignoring ${h} as ${b.join(".")} is ${JSON.stringify(a)}`)}else v(`Ignoring ${h} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=R;function m(f,h){const C=h.split(".");d(f,C)}e.removeFromValueTree=m;function d(f,h){const C=h.shift();if(h.length===0){delete f[C];return}if(Object.keys(f).indexOf(C)!==-1){const v=f[C];typeof v=="object"&&!Array.isArray(v)&&(d(v,h),Object.keys(v).length===0&&delete f[C])}}function I(f,h,C){function v(a,i){let n=a;for(const r of i){if(typeof n!="object"||n===null)return;n=n[r]}return n}const b=h.split("."),t=v(f,b);return typeof t>"u"?C:t}e.getConfigurationValue=I;function S(f,h,C){Object.keys(h).forEach(v=>{v!=="__proto__"&&(v in f?N.isObject(f[v])&&N.isObject(h[v])?S(f[v],h[v],C):C&&(f[v]=h[v]):f[v]=h[v])})}e.merge=S;function p(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ne[116],se([0,1,13,29,108,10,89,9]),function(G,e,N,O,k,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",N.isMacintosh),u.set("isLinux",N.isLinux),u.set("isWindows",N.isWindows),u.set("isWeb",N.isWeb),u.set("isMacNative",N.isMacintosh&&!N.isWeb),u.set("isEdge",N.isEdge),u.set("isFirefox",N.isFirefox),u.set("isChrome",N.isChrome),u.set("isSafari",N.isSafari);function l(x,o){if(u.get(x)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(x,o)}e.setConstant=l;const w=Object.prototype.hasOwnProperty;var R;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(R||(e.ContextKeyExprType=R={}));const m={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),I=(0,T.localize)(1,null),S=(0,T.localize)(2,null),p=(0,T.localize)(3,null),f=(0,T.localize)(4,null),h=(0,T.localize)(5,null),C=(0,T.localize)(6,null),v=(0,T.localize)(7,null);class b{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(o=m){this._config=o,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(o){if(o===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:I});return}this._tokens=this._scanner.reset(o).scan(),this._current=0,this._parsingErrors=[];try{const g=this._expr();if(!this._isAtEnd()){const F=this._peek(),U=F.type===17?h:void 0;throw this._parsingErrors.push({message:f,offset:F.offset,lexeme:k.Scanner.getLexeme(F),additionalInfo:U}),b._parseError}return g}catch(g){if(g!==b._parseError)throw g;return}}_expr(){return this._or()}_or(){const o=[this._and()];for(;this._matchOne(16);){const g=this._and();o.push(g)}return o.length===1?o[0]:t.or(...o)}_and(){const o=[this._term()];for(;this._matchOne(15);){const g=this._term();o.push(g)}return o.length===1?o[0]:t.and(...o)}_term(){if(this._matchOne(2)){const o=this._peek();switch(o.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),s.INSTANCE;case 0:{this._advance();const g=this._expr();return this._consume(1,p),g?.negate()}case 17:return this._advance(),$.create(o.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",o)}}return this._primary()}_primary(){const o=this._peek();switch(o.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const g=this._expr();return this._consume(1,p),g}case 17:{const g=o.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const H=U.lexeme,q=H.lastIndexOf("/"),le=q===H.length-1?void 0:this._removeFlagsGY(H.substring(q+1));let oe;try{oe=new RegExp(H.substring(1,q),le)}catch{throw this._errExpectedButGot("REGEX",U)}return ce.create(g,oe)}switch(U.type){case 10:case 19:{const H=[U.lexeme];this._advance();let q=this._peek(),le=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?le++:U.lexeme.charCodeAt(he)===41&&le--;for(;!this._isAtEnd()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let he=0;he<q.lexeme.length;he++)q.lexeme.charCodeAt(he)===40?le++:U.lexeme.charCodeAt(he)===41&&le--}if(le<0)break;H.push(k.Scanner.getLexeme(q)),this._advance(),q=this._peek()}const oe=H.join(""),me=oe.lastIndexOf("/"),de=me===oe.length-1?void 0:this._removeFlagsGY(oe.substring(me+1));let ge;try{ge=new RegExp(oe.substring(1,me),de)}catch{throw this._errExpectedButGot("REGEX",U)}return t.regex(g,ge)}case 18:{const H=U.lexeme;this._advance();let q=null;if(!(0,O.isFalsyOrWhitespace)(H)){const le=H.indexOf("/"),oe=H.lastIndexOf("/");if(le!==oe&&le>=0){const me=H.slice(le+1,oe),de=H[oe+1]==="i"?"i":"";try{q=new RegExp(me,de)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(q===null)throw this._errExpectedButGot("REGEX",U);return ce.create(g,q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,S);const U=this._value();return t.notIn(g,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return t.equals(g,U);switch(U){case"true":return t.has(g);case"false":return t.not(g);default:return t.equals(g,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return t.notEquals(g,U);switch(U){case"true":return t.not(g);case"false":return t.has(g);default:return t.notEquals(g,U)}}case 5:return this._advance(),te.create(g,this._value());case 6:return this._advance(),ae.create(g,this._value());case 7:return this._advance(),Z.create(g,this._value());case 8:return this._advance(),ue.create(g,this._value());case 13:return this._advance(),t.in(g,this._value());default:return t.has(g)}}case 20:throw this._parsingErrors.push({message:C,offset:o.offset,lexeme:"",additionalInfo:v}),b._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const o=this._peek();switch(o.type){case 17:case 18:return this._advance(),o.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(o){return o.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(o){return this._check(o)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(o,g){if(this._check(o))return this._advance();throw this._errExpectedButGot(g,this._peek())}_errExpectedButGot(o,g,F){const U=(0,T.localize)(8,null,o,k.Scanner.getLexeme(g)),H=g.offset,q=k.Scanner.getLexeme(g);return this._parsingErrors.push({message:U,offset:H,lexeme:q,additionalInfo:F}),b._parseError}_check(o){return this._peek().type===o}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=b;class t{static false(){return r.INSTANCE}static true(){return s.INSTANCE}static has(o){return c.create(o)}static equals(o,g){return D.create(o,g)}static notEquals(o,g){return L.create(o,g)}static regex(o,g){return ce.create(o,g)}static in(o,g){return y.create(o,g)}static notIn(o,g){return P.create(o,g)}static not(o){return $.create(o)}static and(...o){return B.create(o,null,!0)}static or(...o){return V.create(o,null,!0)}static greater(o,g){return Z.create(o,g)}static greaterEquals(o,g){return ue.create(o,g)}static smaller(o,g){return te.create(o,g)}static smallerEquals(o,g){return ae.create(o,g)}static{this._parser=new b({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this._parser.parse(o)}}e.ContextKeyExpr=t;function a(x){const o=new b({regexParsingWithErrorRecovery:!1});return x.map(g=>(o.parse(g),o.lexingErrors.length>0?o.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,T.localize)(9,null,F.additionalInfo):(0,T.localize)(10,null),offset:F.offset,length:F.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.validateWhenClauses=a;function i(x,o){const g=x?x.substituteConstants():void 0,F=o?o.substituteConstants():void 0;return!g&&!F?!0:!g||!F?!1:g.equals(F)}e.expressionsAreEqualWithConstantSubstitution=i;function n(x,o){return x.cmp(o)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return s.INSTANCE}}e.ContextKeyFalseExpr=r;class s{static{this.INSTANCE=new s}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=s;class c{static create(o,g=null){const F=u.get(o);return typeof F=="boolean"?F?s.INSTANCE:r.INSTANCE:new c(o,g)}constructor(o,g){this.key=o,this.negated=g,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:z(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?s.INSTANCE:r.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.negated||(this.negated=$.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class D{static create(o,g,F=null){if(typeof g=="boolean")return g?c.create(o,F):$.create(o,F);const U=u.get(o);return typeof U=="boolean"?g===(U?"true":"false")?s.INSTANCE:r.INSTANCE:new D(o,g,F)}constructor(o,g,F){this.key=o,this.value=g,this.negated=F,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}substituteConstants(){const o=u.get(this.key);if(typeof o=="boolean"){const g=o?"true":"false";return this.value===g?s.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class y{static create(o,g){return new y(o,g)}constructor(o,g){this.key=o,this.valueKey=g,this.type=10,this.negated=null}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}substituteConstants(){return this}evaluate(o){const g=o.getValue(this.valueKey),F=o.getValue(this.key);return Array.isArray(g)?g.includes(F):typeof F=="string"&&typeof g=="object"&&g!==null?w.call(g,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=y;class P{static create(o,g){return new P(o,g)}constructor(o,g){this.key=o,this.valueKey=g,this.type=11,this._negated=y.create(o,g)}cmp(o){return o.type!==this.type?this.type-o.type:this._negated.cmp(o._negated)}equals(o){return o.type===this.type?this._negated.equals(o._negated):!1}substituteConstants(){return this}evaluate(o){return!this._negated.evaluate(o)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(o){return o.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class L{static create(o,g,F=null){if(typeof g=="boolean")return g?$.create(o,F):c.create(o,F);const U=u.get(o);return typeof U=="boolean"?g===(U?"true":"false")?r.INSTANCE:s.INSTANCE:new L(o,g,F)}constructor(o,g,F){this.key=o,this.value=g,this.negated=F,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}substituteConstants(){const o=u.get(this.key);if(typeof o=="boolean"){const g=o?"true":"false";return this.value===g?r.INSTANCE:s.INSTANCE}return this}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class ${static create(o,g=null){const F=u.get(o);return typeof F=="boolean"?F?r.INSTANCE:s.INSTANCE:new $(o,g)}constructor(o,g){this.key=o,this.negated=g,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:z(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:s.INSTANCE:this}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=$;function Q(x,o){if(typeof x=="string"){const g=parseFloat(x);isNaN(g)||(x=g)}return typeof x=="string"||typeof x=="number"?o(x):r.INSTANCE}class Z{static create(o,g,F=null){return Q(g,U=>new Z(o,U,F))}constructor(o,g,F){this.key=o,this.value=g,this.negated=F,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}substituteConstants(){return this}evaluate(o){return typeof this.value=="string"?!1:parseFloat(o.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Z;class ue{static create(o,g,F=null){return Q(g,U=>new ue(o,U,F))}constructor(o,g,F){this.key=o,this.value=g,this.negated=F,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}substituteConstants(){return this}evaluate(o){return typeof this.value=="string"?!1:parseFloat(o.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=te.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=ue;class te{static create(o,g,F=null){return Q(g,U=>new te(o,U,F))}constructor(o,g,F){this.key=o,this.value=g,this.negated=F,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}substituteConstants(){return this}evaluate(o){return typeof this.value=="string"?!1:parseFloat(o.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=te;class ae{static create(o,g,F=null){return Q(g,U=>new ae(o,U,F))}constructor(o,g,F){this.key=o,this.value=g,this.negated=F,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:K(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}substituteConstants(){return this}evaluate(o){return typeof this.value=="string"?!1:parseFloat(o.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ae;class ce{static create(o,g){return new ce(o,g)}constructor(o,g){this.key=o,this.regexp=g,this.type=7,this.negated=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const g=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return g<F?-1:g>F?1:0}equals(o){if(o.type===this.type){const g=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return this.key===o.key&&g===F}return!1}substituteConstants(){return this}evaluate(o){const g=o.getValue(this.key);return this.regexp?this.regexp.test(g):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ie.create(this)),this.negated}}e.ContextKeyRegexExpr=ce;class ie{static create(o){return new ie(o)}constructor(o){this._actual=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}substituteConstants(){return this}evaluate(o){return!this._actual.evaluate(o)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(o){return new ie(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ie;function W(x){let o=null;for(let g=0,F=x.length;g<F;g++){const U=x[g].substituteConstants();if(x[g]!==U&&o===null){o=[];for(let H=0;H<g;H++)o[H]=x[H]}o!==null&&(o[g]=U)}return o===null?x:o}class B{static create(o,g,F){return B._normalizeArr(o,g,F)}constructor(o,g){this.expr=o,this.negated=g,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let g=0,F=this.expr.length;g<F;g++){const U=n(this.expr[g],o.expr[g]);if(U!==0)return U}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let g=0,F=this.expr.length;g<F;g++)if(!this.expr[g].equals(o.expr[g]))return!1;return!0}return!1}substituteConstants(){const o=W(this.expr);return o===this.expr?this:B.create(o,this.negated,!1)}evaluate(o){for(let g=0,F=this.expr.length;g<F;g++)if(!this.expr[g].evaluate(o))return!1;return!0}static _normalizeArr(o,g,F){const U=[];let H=!1;for(const q of o)if(q){if(q.type===1){H=!0;continue}if(q.type===0)return r.INSTANCE;if(q.type===6){U.push(...q.expr);continue}U.push(q)}if(U.length===0&&H)return s.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let q=1;q<U.length;q++)U[q-1].equals(U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0];for(;U.length>1;){const q=U[U.length-1];if(q.type!==9)break;U.pop();const le=U.pop(),oe=U.length===0,me=V.create(q.expr.map(de=>B.create([de,le],null,F)),null,oe);me&&(U.push(me),U.sort(n))}if(U.length===1)return U[0];if(F){for(let q=0;q<U.length;q++)for(let le=q+1;le<U.length;le++)if(U[q].negate().equals(U[le]))return r.INSTANCE;if(U.length===1)return U[0]}return new B(U,g)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const g of this.expr)o.push(...g.keys());return o}map(o){return new B(this.expr.map(g=>g.map(o)),null)}negate(){if(!this.negated){const o=[];for(const g of this.expr)o.push(g.negate());this.negated=V.create(o,this,!0)}return this.negated}}e.ContextKeyAndExpr=B;class V{static create(o,g,F){return V._normalizeArr(o,g,F)}constructor(o,g){this.expr=o,this.negated=g,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let g=0,F=this.expr.length;g<F;g++){const U=n(this.expr[g],o.expr[g]);if(U!==0)return U}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let g=0,F=this.expr.length;g<F;g++)if(!this.expr[g].equals(o.expr[g]))return!1;return!0}return!1}substituteConstants(){const o=W(this.expr);return o===this.expr?this:V.create(o,this.negated,!1)}evaluate(o){for(let g=0,F=this.expr.length;g<F;g++)if(this.expr[g].evaluate(o))return!0;return!1}static _normalizeArr(o,g,F){let U=[],H=!1;if(o){for(let q=0,le=o.length;q<le;q++){const oe=o[q];if(oe){if(oe.type===0){H=!0;continue}if(oe.type===1)return s.INSTANCE;if(oe.type===9){U=U.concat(oe.expr);continue}U.push(oe)}}if(U.length===0&&H)return r.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let q=1;q<U.length;q++)U[q-1].equals(U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0];if(F){for(let q=0;q<U.length;q++)for(let le=q+1;le<U.length;le++)if(U[q].negate().equals(U[le]))return s.INSTANCE;if(U.length===1)return U[0]}return new V(U,g)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const g of this.expr)o.push(...g.keys());return o}map(o){return new V(this.expr.map(g=>g.map(o)),null)}negate(){if(!this.negated){const o=[];for(const g of this.expr)o.push(g.negate());for(;o.length>1;){const g=o.shift(),F=o.shift(),U=[];for(const H of _(g))for(const q of _(F))U.push(B.create([H,q],null,!1));o.unshift(V.create(U,null,!1))}this.negated=V.create(o,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class M extends c{static{this._info=[]}static all(){return M._info.values()}constructor(o,g,F){super(o,null),this._defaultValue=g,typeof F=="object"?M._info.push({...F,key:o}):F!==!0&&M._info.push({key:o,description:F,type:g!=null?typeof g:void 0})}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return D.create(this.key,o)}notEqualsTo(o){return L.create(this.key,o)}}e.RawContextKey=M,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function z(x,o){return x<o?-1:x>o?1:0}function K(x,o,g,F){return x<g?-1:x>g?1:o<F?-1:o>F?1:0}function X(x,o){if(x.type===0||o.type===1)return!0;if(x.type===9)return o.type===9?J(x.expr,o.expr):!1;if(o.type===9){for(const g of o.expr)if(X(x,g))return!0;return!1}if(x.type===6){if(o.type===6)return J(o.expr,x.expr);for(const g of x.expr)if(X(g,o))return!0;return!1}return x.equals(o)}e.implies=X;function J(x,o){let g=0,F=0;for(;g<x.length&&F<o.length;){const U=x[g].cmp(o[F]);if(U<0)return!1;U===0&&g++,F++}return g===x.length}function _(x){return x.type===9?x.expr:[x]}}),define(ne[59],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(ne[18],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[21],se([0,1,92,10]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(h,C){switch(h){case 3:return C==="x64"?"win32-x64":C==="ia32"?"win32-ia32":C==="arm64"?"win32-arm64":"unknown";case 2:return C==="x64"?"linux-x64":C==="arm64"?"linux-arm64":C==="arm"?"linux-armhf":C==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return C==="x64"?"alpine-x64":C==="arm64"?"alpine-arm64":"unknown";case 1:return C==="x64"?"darwin-x64":C==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function E(h,C){return C==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function u(h,C,v){return E(C,v)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===v?!0:l(v).includes(h)}e.isTargetPlatformCompatible=u;function l(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=w;var R;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var m;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var I;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(I||(e.InstallOperation=I={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var S;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var p;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class f extends Error{constructor(C,v){super(C),this.code=v,this.name=v}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,N.localize)(1,null),original:"Preferences"}}),define(ne[60],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,N.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,T)=>G(["node-vsce-sign"],async E=>A(E),T))),this.moduleLoadingPromise}async verify(A,T,E){let u;try{u=await this.vsceSign()}catch{return!1}return u.verify(A,T,E)}}e.ExtensionSignatureVerificationService=O}),define(ne[61],se([0,1,14,9,100,12]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(w,R,m,d,I,S){let p;try{await E(w,R,m,d,I,S)}catch(f){p=f}finally{p&&I.errorTransformer&&(p=I.errorTransformer(p)),typeof p<"u"&&m.error(p),m.end()}}e.readFileIntoStream=T;async function E(w,R,m,d,I,S){u(S);const p=await w.open(R,{create:!1});try{u(S);let f=0,h=0,C=I&&typeof I.length=="number"?I.length:void 0,v=N.VSBuffer.alloc(Math.min(I.bufferSize,typeof C=="number"?C:I.bufferSize)),b=I&&typeof I.position=="number"?I.position:0,t=0;do h=await w.read(p,b,v.buffer,t,v.byteLength-t),b+=h,t+=h,f+=h,typeof C=="number"&&(C-=h),t===v.byteLength&&(await m.write(d(v)),v=N.VSBuffer.alloc(Math.min(I.bufferSize,typeof C=="number"?C:I.bufferSize)),t=0);while(h>0&&(typeof C!="number"||C>0)&&u(S)&&l(f,I));if(t>0){let a=t;typeof C=="number"&&(a=Math.min(t,C)),m.write(d(v.slice(0,a)))}}catch(f){throw(0,A.ensureFileSystemProviderError)(f)}finally{await w.close(p)}}function u(w){if(w.isCancellationRequested)throw(0,O.canceled)();return!0}function l(w,R){if(typeof R?.limits?.size=="number"&&w>R.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],se([0,1,4,166,2,13,167]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new N.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=N.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const w=this.normalizeRequests(l),R=w.filter(d=>{const I=this.watchers.get(d.path);return I?!(0,O.patternsEquals)(I.request.excludes,d.excludes)||!(0,O.patternsEquals)(I.request.includes,d.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:d})=>!w.find(I=>I.path===d.path&&(0,O.patternsEquals)(I.excludes,d.excludes)&&(0,O.patternsEquals)(I.includes,d.includes))).map(({request:d})=>d.path);R.length&&this.trace(`Request to start watching: ${R.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.stopWatching(d);for(const d of R)this.startWatching(d)}startWatching(l){const w=new T.NodeJSFileWatcherLibrary(l,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),R={request:l,instance:w};this.watchers.set(l.path,R)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const w=this.watchers.get(l);w&&(this.watchers.delete(l),w.instance.dispose())}normalizeRequests(l){const w=new Map;for(const R of l){const m=A.isLinux?R.path:R.path.toLowerCase();w.set(m,R)}return Array.from(w.values())}async setVerboseLogging(l){this.verboseLogging=l;for(const[,w]of this.watchers)w.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,w){return w?`[File Watcher (node.js)] ${l} (path: ${w.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=E}),define(ne[118],se([0,1,62,117]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends N.AbstractNonRecursiveWatcherClient{constructor(T,E,u){super(T,E,u),this.init()}createWatcher(T){return T.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=k}),define(ne[119],se([0,1,15,57,85,62]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(u,l,w){super(u,l,w),this.init()}createWatcher(u){const l=u.add(new k.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:w,signal:R})=>this.onError(`terminated by itself with code ${w}, signal: ${R}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[63],se([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...k){this._entries=new Map;for(const[A,T]of k)this.set(A,T)}set(k,A){const T=this._entries.get(k);return this._entries.set(k,A),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=N}),define(ne[120],se([0,1,8,9,2,49,115,10,63,168]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class R extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class m{constructor(p=new u.ServiceCollection,f=!1,h,C=w){this._services=p,this._strict=f,this._parent=h,this._enableTracing=C,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=C?h?._globalGraph??new T.Graph(v=>v):void 0}createChild(p){return new m(p,this._strict,this,this._enableTracing)}invokeFunction(p,...f){const h=I.traceInvocation(this._enableTracing,p);let C=!1;try{return p({get:b=>{if(C)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(b,h);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...f)}finally{C=!0,h.stop()}}createInstance(p,...f){let h,C;return p instanceof A.SyncDescriptor?(h=I.traceCreation(this._enableTracing,p.ctor),C=this._createInstance(p.ctor,p.staticArguments.concat(f),h)):(h=I.traceCreation(this._enableTracing,p),C=this._createInstance(p,f,h)),h.stop(),C}_createInstance(p,f=[],h){const C=E._util.getServiceDependencies(p).sort((t,a)=>t.index-a.index),v=[];for(const t of C){const a=this._getOrCreateServiceInstance(t.id,h);a||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(a)}const b=C.length>0?C[0].index:f.length;if(f.length!==b){console.trace(`[createInstance] First service dependency of ${p.name} at position ${b+1} conflicts with ${f.length} static arguments`);const t=b-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,b)}return Reflect.construct(p,f.concat(v))}_setServiceInstance(p,f){if(this._services.get(p)instanceof A.SyncDescriptor)this._services.set(p,f);else if(this._parent)this._parent._setServiceInstance(p,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const f=this._services.get(p);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):f}_getOrCreateServiceInstance(p,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const h=this._getServiceInstanceOrDescriptor(p);return h instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,h,f.branch(p,!0)):(f.branch(p,!1),h)}_safeCreateAndCacheServiceInstance(p,f,h){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,f,h)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,f,h){const C=new T.Graph(t=>t.id.toString());let v=0;const b=[{id:p,desc:f,_trace:h}];for(;b.length;){const t=b.pop();if(C.lookupOrInsertNode(t),v++>1e3)throw new R(C);for(const a of E._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${p} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};C.insertEdge(t,n),b.push(n)}}}for(;;){const t=C.roots();if(t.length===0){if(!C.isEmpty())throw new R(C);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,n)}C.removeNode(a)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,f,h=[],C,v){if(this._services.get(p)instanceof A.SyncDescriptor)return this._createServiceInstance(p,f,h,C,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,f,h,C,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(p,f,h=[],C,v){if(C){const b=new m(void 0,this._strict,this,this._enableTracing);b._globalGraphImplicitDependency=String(p);const t=new Map,a=new N.IdleValue(()=>{const i=b._createInstance(f,h,v);for(const[n,r]of t){const s=i[n];if(typeof s=="function")for(const c of r)s.apply(i,c)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let c=t.get(n);return c||(c=new l.LinkedList,t.set(n,c)),(y,P,L)=>{const $=c.push([y,P,L]);return(0,k.toDisposable)($)}}if(n in i)return i[n];const r=a.value;let s=r[n];return typeof s!="function"||(s=s.bind(r),i[n]=s),s},set(i,n,r){return a.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this._createInstance(f,h,v)}_throwIfStrict(p,f){if(f&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=m;var d;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(d||(d={}));class I{static{this.all=new Set}static{this._None=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,f){return p?new I(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I._None}static traceCreation(p,f){return p?new I(1,f.name):I._None}static{this._totals=0}constructor(p,f){this.type=p,this.name=f,this._start=Date.now(),this._dep=[]}branch(p,f){const h=new I(3,p.toString());return this._dep.push([p,f,h]),h}stop(){const p=Date.now()-this._start;I._totals+=p;let f=!1;function h(v,b){const t=[],a=new Array(v+1).join("	");for(const[i,n,r]of b._dep)if(n&&r){f=!0,t.push(`${a}CREATES -> ${i}`);const s=h(v+1,r);s&&t.push(s)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const C=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(p>2||f)&&I.all.add(C.join(`
`))}}e.Trace=I});var re=this&&this.__param||function(G,e){return function(N,O){e(N,O,G)}};define(ne[64],se([0,1,20,2,13,102,21,10]),function(G,e,N,O,k,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function u(w){return w.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=u,e.ILanguagePackService=(0,E.createDecorator)("languagePackService");let l=class extends O.Disposable{constructor(R){super(),this.extensionGalleryService=R}async getAvailableLanguages(){const R=new N.CancellationTokenSource;setTimeout(()=>R.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const I=m.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(p=>p.startsWith("lp-"))).map(S=>{const p=S.properties.localizedLanguages?.[0],f=u(S);return{...this.createQuickPickItem(f,p,S),extensionId:S.identifier.id,galleryExtension:S}});return I.push(this.createQuickPickItem("en","English")),I}createQuickPickItem(R,m,d){const I=m??R;let S;if(I!==R&&(S=`(${R})`),R.toLowerCase()===k.language.toLowerCase()&&(S??="",S+=(0,A.localize)(0,null)),d?.installCount){S??="";const p=d.installCount;let f;p>1e6?f=`${Math.floor(p/1e5)/10}M`:p>1e3?f=`${Math.floor(p/1e3)}K`:f=String(p),S+=` $(cloud-download) ${f}`}return{id:R,label:I,description:S}}};e.LanguagePackBaseService=l,e.LanguagePackBaseService=l=ve([re(0,T.IExtensionGalleryService)],l)}),define(ne[6],se([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(G,e,N,O,k,A,T,E,u,l,w,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function d(){return new Date().toISOString()}function I(y){return(0,l.isNumber)(y)}e.isLogLevel=I;var S;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(S||(e.LogLevel=S={})),e.DEFAULT_LOG_LEVEL=S.Info;function p(y,P,L){switch(P){case S.Trace:y.trace(L);break;case S.Debug:y.debug(L);break;case S.Info:y.info(L);break;case S.Warning:y.warn(L);break;case S.Error:y.error(L);break;case S.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=p;function f(y,P=!1){let L="";for(let $=0;$<y.length;$++){let Q=y[$];if(Q instanceof Error&&(Q=(0,N.toErrorMessage)(Q,P)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}L+=($>0?" ":"")+Q}return L}class h extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==S.Off&&this.level<=P}}e.AbstractLogger=h;class C extends h{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...L){this.checkLogLevel(S.Trace)&&this.log(S.Trace,f([P,...L],!0))}debug(P,...L){this.checkLogLevel(S.Debug)&&this.log(S.Debug,f([P,...L]))}info(P,...L){this.checkLogLevel(S.Info)&&this.log(S.Info,f([P,...L]))}warn(P,...L){this.checkLogLevel(S.Warning)&&this.log(S.Warning,f([P,...L]))}error(P,...L){if(this.checkLogLevel(S.Error))if(P instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=P.stack,this.log(S.Error,f($))}else this.log(S.Error,f([P,...L]))}flush(){}}e.AbstractMessageLogger=C;class v extends h{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!E.isWindows}trace(P,...L){this.checkLogLevel(S.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,P,...L):console.log(`[main ${d()}]`,P,...L))}debug(P,...L){this.checkLogLevel(S.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,P,...L):console.log(`[main ${d()}]`,P,...L))}info(P,...L){this.checkLogLevel(S.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,P,...L):console.log(`[main ${d()}]`,P,...L))}warn(P,...L){this.checkLogLevel(S.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,P,...L):console.warn(`[main ${d()}]`,P,...L))}error(P,...L){this.checkLogLevel(S.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,P,...L):console.error(`[main ${d()}]`,P,...L))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class b extends h{constructor(P=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(P)}trace(P,...L){this.checkLogLevel(S.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...L):console.log(P,...L))}debug(P,...L){this.checkLogLevel(S.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...L):console.log(P,...L))}info(P,...L){this.checkLogLevel(S.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...L):console.log(P,...L))}warn(P,...L){this.checkLogLevel(S.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...L):console.log(P,...L))}error(P,...L){this.checkLogLevel(S.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...L):console.error(P,...L))}dispose(){}flush(){}}e.ConsoleLogger=b;class t extends h{constructor(P,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(L)}trace(P,...L){this.checkLogLevel(S.Trace)&&this.adapter.log(S.Trace,[this.extractMessage(P),...L])}debug(P,...L){this.checkLogLevel(S.Debug)&&this.adapter.log(S.Debug,[this.extractMessage(P),...L])}info(P,...L){this.checkLogLevel(S.Info)&&this.adapter.log(S.Info,[this.extractMessage(P),...L])}warn(P,...L){this.checkLogLevel(S.Warning)&&this.adapter.log(S.Warning,[this.extractMessage(P),...L])}error(P,...L){this.checkLogLevel(S.Error)&&this.adapter.log(S.Error,[this.extractMessage(P),...L])}extractMessage(P){return typeof P=="string"?P:(0,N.toErrorMessage)(P,this.checkLogLevel(S.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends h{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const L of this.loggers)L.setLevel(P);super.setLevel(P)}trace(P,...L){for(const $ of this.loggers)$.trace(P,...L)}debug(P,...L){for(const $ of this.loggers)$.debug(P,...L)}info(P,...L){for(const $ of this.loggers)$.info(P,...L)}warn(P,...L){for(const $ of this.loggers)$.warn(P,...L)}error(P,...L){for(const $ of this.loggers)$.error(P,...L)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose()}}e.MultiplexLogger=a;class i extends A.Disposable{constructor(P,L,$){if(super(),this.logLevel=P,this.logsHome=L,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,$)for(const Q of $)this._loggers.set(Q.resource,{logger:void 0,info:Q})}getLoggerEntry(P){return(0,l.isString)(P)?[...this._loggers.values()].find(L=>L.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,L){const $=this.toResource(P),Q=(0,l.isString)(P)?P:L?.id??(0,k.hash)($.toString()).toString(16);let Z=this._loggers.get($)?.logger;const ue=L?.logLevel==="always"?S.Trace:L?.logLevel;Z||(Z=this.doCreateLogger($,ue??this.getLogLevel($)??this.logLevel,{...L,id:Q}));const te={logger:Z,info:{resource:$,id:Q,logLevel:ue,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(te.info),this._loggers.set($,te),Z}toResource(P){return(0,l.isString)(P)?(0,u.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,L){if(w.URI.isUri(P)){const $=P,Q=L,Z=this._loggers.get($);Z&&Q!==Z.info.logLevel&&(Z.info.logLevel=Q===this.logLevel?void 0:Q,Z.logger?.setLevel(Q),this._loggers.set(Z.info.resource,Z),this._onDidChangeLogLevel.fire([$,Q]))}else{this.logLevel=P;for(const[$,Q]of this._loggers.entries())this._loggers.get($)?.info.logLevel===void 0&&Q.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,L){const $=this.getLoggerEntry(P);$&&L!==!$.info.hidden&&($.info.hidden=!L,this._loggers.set($.info.resource,$),this._onDidChangeVisibility.fire([$.info.resource,L]))}getLogLevel(P){let L;return P&&(L=this._loggers.get(P)?.info.logLevel),L??this.logLevel}registerLogger(P){const L=this._loggers.get(P.resource);L?L.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const L=this._loggers.get(P);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(P){}getLevel(){return S.Info}trace(P,...L){}debug(P,...L){}info(P,...L){}warn(P,...L){}error(P,...L){}critical(P,...L){}dispose(){}flush(){}}e.NullLogger=n;class r extends n{}e.NullLogService=r;function s(y){if(y.verbose)return S.Trace;if(typeof y.logLevel=="string"){const P=D(y.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function c(y){switch(y){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=c;function D(y){switch(y){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new R.RawContextKey("logLevel",c(S.Info))}),define(ne[121],se([0,1,19,8,9,4,2,16,62,6]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends T.Disposable{constructor(m,d){super(),this.logService=m,this.options=d,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(m,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,d):this.watchNonRecursive(m,d)}watchUniversal(m,d){const I={path:this.toFilePath(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive},S=(0,N.insert)(this.universalPathsToWatch,I);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,u.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&m.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,d){const I={path:this.toFilePath(m),excludes:d.excludes,includes:d.includes,recursive:!1},S=(0,N.insert)(this.nonRecursivePathsToWatch,I);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,u.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,E.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(ne[122],se([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends l.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(t,a){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new l.DisposableStore;return this.provider.set(t,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this._onDidFilesChange.fire(new p.FileChangesEvent(n,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:t}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:a}),this.provider.delete(t),(0,l.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){a.push(i)}}),!this.provider.has(t)&&await O.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,a){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.provider,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async withProvider(t){if(!(0,d.isAbsolutePath)(t))throw new p.FileOperationError((0,S.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const a=this.provider.get(t.scheme);if(!a){const i=new C.ErrorNoTelemetry;throw i.message=(0,S.localize)(1,null,t.toString()),i}return a}async withReadProvider(t){const a=await this.withProvider(t);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a)||(0,p.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const a=await this.withProvider(t);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.doResolveFile(t,a)}catch(i){throw(0,p.toFileSystemProviderErrorCode)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,S.localize)(2,null,this.resourceForError(t)),1):(0,p.ensureFileSystemProviderError)(i)}}async doResolveFile(t,a){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),r=a?.resolveTo,s=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,D=await i.stat(t);let y;return this.toFileStat(i,t,D,void 0,!!c,(P,L)=>(y||(y=w.TernarySearchTree.forUris(()=>!n),y.set(t,!0),r&&y.fill(!0,r)),y.get(P.resource)||y.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&s?L===1:!1))}async toFileStat(t,a,i,n,r,s){const{providerExtUri:c}=this.getExtUri(t),D={resource:a,name:c.basename(a),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&s(D,n)){try{const y=await t.readdir(a),P=await O.Promises.settled(y.map(async([L,$])=>{try{const Q=c.joinPath(a,L),Z=r?await t.stat(Q):{type:$};return await this.toFileStat(t,Q,Z,y.length,r,s)}catch(Q){return this.logService.trace(Q),null}}));D.children=(0,N.coalesce)(P)}catch(y){this.logService.trace(y),D.children=[]}return D}return D}async resolveAll(t){return O.Promises.settled(t.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.withProvider(t),i=await a.stat(t);return this.toFileStat(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.withProvider(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.doValidateCreateFile(t,a)}catch(i){return i}return!0}async doValidateCreateFile(t,a){if(!a?.overwrite&&await this.exists(t))throw new p.FileOperationError((0,S.localize)(3,null,this.resourceForError(t)),3,a)}async createFile(t,a=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,a);return this._onDidRunOperation.fire(new p.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:r}=this.getExtUri(n);let s=i;if((0,p.hasFileAtomicWriteCapability)(n)&&!s?.atomic){const c=n.enforceAtomicWriteFile?.(t);c&&(s={...i,atomic:c})}try{await this.validateWriteFile(n,t,s)||await this.mkdirp(n,r.dirname(t));let D;if((0,p.hasReadWriteCapability)(n)&&!(a instanceof k.VSBuffer))if((0,I.isReadableStream)(a)){const y=await(0,I.peekStream)(a,3);y.ended?D=k.VSBuffer.concat(y.buffer):D=y}else D=(0,I.peekReadable)(a,y=>k.VSBuffer.concat(y),3);else D=a;!(0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n)&&D instanceof k.VSBuffer||(0,p.hasReadWriteCapability)(n)&&(0,p.hasFileAtomicWriteCapability)(n)&&s?.atomic?await this.doWriteUnbuffered(n,t,s,D):await this.doWriteBuffered(n,t,s,D instanceof k.VSBuffer?(0,k.bufferToReadable)(D):D),this._onDidRunOperation.fire(new p.FileOperationEvent(t,4))}catch(c){throw new p.FileOperationError((0,S.localize)(4,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(c).toString()),(0,p.toFileOperationResult)(c),s)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,S.localize)(6,null,this.resourceForError(a)));if(!(t.capabilities&2))throw new Error((0,S.localize)(7,null,this.resourceForError(a)));if(n)throw new Error((0,S.localize)(8,null,this.resourceForError(a)))}let s;try{s=await t.stat(a)}catch{return}if(s.type&p.FileType.Directory)throw new p.FileOperationError((0,S.localize)(9,null,this.resourceForError(a)),0,i);if(this.throwIfFileIsReadonly(a,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,p.etag)({mtime:i.mtime,size:s.size}))throw new p.FileOperationError((0,S.localize)(10,null),3,i);return s}async readFile(t,a,i){const n=await this.withReadProvider(t);return a?.atomic?this.doReadFileAtomic(n,t,a,i):this.doReadFile(n,t,a,i)}async doReadFileAtomic(t,a,i,n){return new Promise((r,s)=>{this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(t,a,i,n);r(c)}catch(c){s(c)}})})}async doReadFile(t,a,i,n){const r=await this.doReadFileStream(t,a,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(t,a,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,a,i)}async doReadFileStream(t,a,i,n){const r=new A.CancellationTokenSource(n);let s=i;(0,p.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(a)&&(s={...i,atomic:!0});const c=this.validateReadFile(a,s).then(y=>y,y=>{throw r.dispose(!0),y});let D;try{return typeof s?.etag=="string"&&s.etag!==p.ETAG_DISABLED&&await c,s?.atomic&&(0,p.hasFileAtomicReadCapability)(t)||!((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasFileReadStreamCapability)(t))||(0,p.hasReadWriteCapability)(t)&&s?.preferUnbuffered?D=this.readFileUnbuffered(t,a,s):(0,p.hasFileReadStreamCapability)(t)?D=this.readFileStreamed(t,a,r.token,s):D=this.readFileBuffered(t,a,r.token,s),D.on("end",()=>r.dispose()),D.on("error",()=>r.dispose()),{...await c,value:D}}catch(y){throw D&&await(0,I.consumeStream)(D),this.restoreReadError(y,a,s)}}restoreReadError(t,a,i){const n=(0,S.localize)(11,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(t).toString());return t instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new p.FileOperationError(n,(0,p.toFileOperationResult)(t),i)}readFileStreamed(t,a,i,n=Object.create(null)){const r=t.readFileStream(a,n,i);return(0,I.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>this.restoreReadError(s,a,n)},s=>k.VSBuffer.concat(s))}readFileBuffered(t,a,i,n=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,a,r,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>this.restoreReadError(s,a,n)},i),r}readFileUnbuffered(t,a,i){const n=(0,I.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,p.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(a,r.byteLength,i),n.end(k.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new p.FileOperationError((0,S.localize)(12,null,this.resourceForError(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==p.ETAG_DISABLED&&a.etag===i.etag)throw new p.NotModifiedSinceFileOperationError((0,S.localize)(13,null),i,a);return this.validateReadFileLimits(t,i.size,a),i}validateReadFileLimits(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new p.TooLargeFileOperationError((0,S.localize)(14,null,this.resourceForError(t)),7,a,i)}async canMove(t,a,i){return this.doCanMoveCopy(t,a,"move",i)}async canCopy(t,a,i){return this.doCanMoveCopy(t,a,"copy",i)}async doCanMoveCopy(t,a,i,n){if(t.toString()!==a.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(r,t,s,a,i,n)}catch(r){return r}return!0}async move(t,a,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(n,t,r,a,"move",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,s==="move"?2:3,c)),c}async copy(t,a,i){const n=await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(n,t,r,a,"copy",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,s==="copy"?3:2,c)),c}async doMoveCopy(t,a,i,n,r,s){if(a.toString()===n.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(t,a,i,n,r,s);if(c&&!D&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,p.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:s});else{const y=await this.resolve(a);y.isDirectory?await this.doCopyFolder(t,y,i,n):await this.doCopyFile(t,a,i,n)}return r}else return t===i?(await t.rename(a,n,{overwrite:s}),r):(await this.doMoveCopy(t,a,i,n,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(t,a,i,n){if((0,p.hasOpenReadWriteCloseCapability)(t)&&(0,p.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,a,i,n);if((0,p.hasOpenReadWriteCloseCapability)(t)&&(0,p.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,a,i,n);if((0,p.hasReadWriteCapability)(t)&&(0,p.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,a,i,n);if((0,p.hasReadWriteCapability)(t)&&(0,p.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,a,i,n)}async doCopyFolder(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await O.Promises.settled(a.children.map(async r=>{const s=this.getExtUri(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(t,await this.resolve(r.resource),i,s):this.doCopyFile(t,r.resource,i,s)}))}async doValidateMoveCopy(t,a,i,n,r,s){let c=!1;if(t===i){const{providerExtUri:y,isPathCaseSensitive:P}=this.getExtUri(t);if(P||(c=y.isEqual(a,n)),c&&r==="copy")throw new Error((0,S.localize)(15,null,this.resourceForError(a),this.resourceForError(n)));if(!c&&y.isEqualOrParent(n,a))throw new Error((0,S.localize)(16,null,this.resourceForError(a),this.resourceForError(n)))}const D=await this.exists(n);if(D&&!c){if(!s)throw new p.FileOperationError((0,S.localize)(17,null,this.resourceForError(a),this.resourceForError(n)),4);if(t===i){const{providerExtUri:y}=this.getExtUri(t);if(y.isEqualOrParent(a,n))throw new Error((0,S.localize)(18,null,this.resourceForError(a),this.resourceForError(n)))}}return{exists:D,isSameResourceWithDifferentPathCase:c}}getExtUri(t){const a=this.isPathCaseSensitive(t);return{providerExtUri:a?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(t,0,i)),i}async mkdirp(t,a){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&p.FileType.Directory))throw new Error((0,S.localize)(19,null,this.resourceForError(a)));break}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(a)),a=n.dirname(a)}for(let r=i.length-1;r>=0;r--){a=n.joinPath(a,i[r]);try{await t.mkdir(a)}catch(s){if((0,p.toFileSystemProviderErrorCode)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(t,a){try{await this.doValidateDelete(t,a)}catch(i){return i}return!0}async doValidateDelete(t,a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,S.localize)(20,null,this.resourceForError(t)));const r=a?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,S.localize)(21,null,this.resourceForError(t)));if(n&&r)throw new Error((0,S.localize)(22,null,this.resourceForError(t)));let s;try{s=await i.stat(t)}catch{}if(s)this.throwIfFileIsReadonly(t,s);else throw new p.FileOperationError((0,S.localize)(23,null,this.resourceForError(t)),1);if(!!!a?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,S.localize)(24,null,this.resourceForError(t)))}return i}async del(t,a){const i=await this.doValidateDelete(t,a);let n=a;if((0,p.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const D=i.enforceAtomicDelete?.(t);D&&(n={...a,atomic:D})}const r=!!n?.useTrash,s=!!n?.recursive,c=n?.atomic??!1;await i.delete(t,{recursive:s,useTrash:r,atomic:c}),this._onDidRunOperation.fire(new p.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,p.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(a));const r=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===n&&(0,p.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,a,{overwrite:!0})):r.queue(()=>this.doCopyFile(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,l.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(t,a);n?(0,l.dispose)(s):r=()=>(0,l.dispose)(s)}catch(s){this.logService.error(s)}})(),i}async doWatch(t,a){const i=await this.withProvider(t),n=(0,E.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),a]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:i.watch(t,a)},this.activeWatchers.set(n,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,l.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,a,i,n){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,I.isReadableStream)(n)||(0,I.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,r,n):await this.doWriteReadableBufferedQueued(t,r,n)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await t.close(r)}})}async doWriteStreamBufferedQueued(t,a,i){let n=0,r;if((0,I.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,a,s,s.byteLength,n,0),n+=s.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((s,c)=>{(0,I.listenStream)(r,{onData:async D=>{r.pause();try{await this.doWriteBuffer(t,a,D,D.byteLength,n,0)}catch(y){return c(y)}n+=D.byteLength,setTimeout(()=>r.resume())},onError:D=>c(D),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(t,a,i){let n=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(t,a,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(t,a,i,n,r,s){let c=0;for(;c<n;){const D=await t.write(a,r+c,i.buffer,s+c,n-c);c+=D}}async doWriteUnbuffered(t,a,i,n){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,a,i,n))}async doWriteUnbufferedQueued(t,a,i,n){let r;n instanceof k.VSBuffer?r=n:(0,I.isReadableStream)(n)?r=await(0,k.streamToBuffer)(n):(0,I.isReadableBufferedStream)(n)?r=await(0,k.bufferedStreamToBuffer)(n):r=(0,k.readableToBuffer)(n),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(t,a,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,a,i,n))}async doPipeBufferedQueued(t,a,i,n){let r,s;try{r=await t.open(a,{create:!1}),s=await i.open(n,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,y=0,P=0;do P=await t.read(r,D,c.buffer,y,c.byteLength-y),await this.doWriteBuffer(i,s,c,P,D,y),D+=P,y+=P,y===c.byteLength&&(y=0);while(P>0)}catch(c){throw(0,p.ensureFileSystemProviderError)(c)}finally{await O.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(t,a,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,a,i,n))}async doPipeUnbufferedQueued(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,a,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,a,i,n))}async doPipeUnbufferedToBufferedQueued(t,a,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const s=await t.readFile(a);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(t,a,i,n){const r=await(0,k.streamToBuffer)(this.readFileBuffered(t,a,A.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,r)}throwIfFileSystemIsReadonly(t,a){if(t.capabilities&2048)throw new p.FileOperationError((0,S.localize)(25,null,this.resourceForError(a)),6);return t}throwIfFileIsReadonly(t,a){if((a.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,S.localize)(26,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===R.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=v,e.FileService=v=ve([re(0,h.ILogService)],v)}),define(ne[124],se([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(N)}catch(a){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(a)}`)}})();class t extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(i,n){super(i,n),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new A.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await I.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const n=await I.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,m.joinPath)(i,s.name))).type:c=this.toType(s),r.push([s.name,c])}catch(c){this.logService.trace(c)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=p.FileType.Unknown:i.isFile()?r=p.FileType.File:i.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,n&&(r|=p.FileType.SymbolicLink),r}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const s=new k.Barrier;return this.resourceLocks.set(i,s),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===s&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),s.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const s=this.toFilePath(i);return await I.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{r?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,r){const s=(0,d.newWriteableStream)(c=>T.VSBuffer.concat(c.map(D=>T.VSBuffer.wrap(D))).buffer);return(0,f.readFileIntoStream)(this,i,s,c=>c.buffer,{...n,bufferSize:256*1024},r),s}async writeFile(i,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(i)?this.doWriteFileAtomic(i,(0,m.joinPath)((0,m.dirname)(i),`${(0,m.basename)(i)}${r.atomic.postfix}`),n,r):this.doWriteFile(i,n,r)}async canWriteFileAtomic(i){try{const n=this.toFilePath(i),{symbolicLink:r}=await I.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async doWriteFileAtomic(i,n,r,s){const c=new l.DisposableStore;try{c.add(await this.createResourceLock(i)),c.add(await this.createResourceLock(n)),await this.doWriteFile(n,r,s,!0);try{await this.rename(n,i,{overwrite:!0})}catch(D){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{c.dispose()}}async doWriteFile(i,n,r,s){let c;try{const D=this.toFilePath(i);if(!r.create||!r.overwrite){if(await I.Promises.exists(D)){if(!r.overwrite)throw(0,p.createFileSystemProviderError)((0,S.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.createFileSystemProviderError)((0,S.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:r.unlock},s),await this.write(c,0,n,0,n.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(i,D)}finally{typeof c=="number"&&await this.close(c)}}static{this.canFlush=!0}static configureFlushOnWrite(i){t.canFlush=i}async open(i,n,r){const s=this.toFilePath(i);let c;(0,p.isFileOpenForWriteOptions)(n)&&!r&&(c=await this.createResourceLock(i));let D;try{if((0,p.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:P}=await I.SymlinkSupport.stat(s);P.mode&128||await I.Promises.chmod(s,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let y;if((0,p.isFileOpenForWriteOptions)(n)){if(R.isWindows)try{await I.Promises.truncate(s,0),y="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}y||(y="w")}else y="r";D=await I.Promises.open(s,y)}catch(y){throw c?.dispose(),(0,p.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(D,0),(0,p.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(D,i),c){const y=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${s})`),this.mapHandleToLock.set(D,c),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${s})`),y.dispose())}return D}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await I.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await I.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,s,c){const D=this.normalizePos(i,n);let y=null;try{y=(await I.Promises.read(i,r,s,c,D)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(i,D,y)}return y}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,s+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,s,c){return(0,k.retry)(()=>this.doWrite(i,n,r,s,c),100,3)}async doWrite(i,n,r,s,c){const D=this.normalizePos(i,n);let y=null;try{y=(await I.Promises.write(i,r,s,c,D)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),P)}finally{this.updatePos(i,D,y)}return y}async mkdir(i){try{await I.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);if(n.recursive){let s;n?.atomic!==!1&&n.atomic.postfix&&(s=(0,w.join)((0,w.dirname)(r),`${(0,w.basename)(r)}${n.atomic.postfix}`)),await I.Promises.rm(r,I.RimRafMode.MOVE,s)}else try{await I.Promises.unlink(r)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let c=!1;try{const{stat:D,symbolicLink:y}=await I.SymlinkSupport.stat(r);c=D.isDirectory()&&!y}catch{}if(c)await I.Promises.rmdir(r);else throw s}else throw s}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const s=this.toFilePath(i),c=this.toFilePath(n);if(s!==c)try{await this.validateMoveCopy(i,n,"move",r.overwrite),await I.Promises.rename(s,c)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,S.localize)(2,null,(0,w.basename)(s),(0,w.basename)((0,w.dirname)(c)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(i,n,r){const s=this.toFilePath(i),c=this.toFilePath(n);if(s!==c)try{await this.validateMoveCopy(i,n,"copy",r.overwrite),await I.Promises.copy(s,c,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,S.localize)(3,null,(0,w.basename)(s),(0,w.basename)((0,w.dirname)(c)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(i,n,r,s){const c=this.toFilePath(i),D=this.toFilePath(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.isEqual)(c,D,!0)),y){if(r==="copy")throw(0,p.createFileSystemProviderError)((0,S.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const L=await this.statIgnoreError(i);if(!L)throw(0,p.createFileSystemProviderError)((0,S.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const $=await this.statIgnoreError(n);if($){if(!s)throw(0,p.createFileSystemProviderError)((0,S.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);L.type&p.FileType.File&&$.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,r){const s=this.toFilePath(i),c=this.toFilePath(n),D=!!(this.capabilities&1024);if((0,u.isEqual)(s,c,!D))return;const y=new l.DisposableStore;try{y.add(await this.createResourceLock(i)),y.add(await this.createResourceLock(n)),r&&await I.Promises.mkdir((0,w.dirname)(c),{recursive:!0}),await I.Promises.copyFile(s,c)}catch(P){if(P.code==="ENOENT"&&!r)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(P)}finally{y.dispose()}}createUniversalWatcher(i,n,r){return new v.UniversalWatcherClient(s=>i(s),s=>n(s),r)}createNonRecursiveWatcher(i,n,r){return new b.NodeJSWatcherClient(s=>i(s),s=>n(s),r)}toFileSystemProviderError(i){if(i instanceof p.FileSystemProviderError)return i;let n=i,r;switch(i.code){case"ENOENT":r=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=p.FileSystemProviderErrorCode.Unknown;break;default:r=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await I.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(r=(0,p.createFileSystemProviderError)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return r}}e.DiskFileSystemProvider=t}),define(ne[126],se([0,1,2,6]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends N.Disposable{constructor(T,E=[]){super(),this.logger=new O.MultiplexLogger([T,...E]),this._register(T.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...E){this.logger.trace(T,...E)}debug(T,...E){this.logger.debug(T,...E)}info(T,...E){this.logger.info(T,...E)}warn(T,...E){this.logger.warn(T,...E)}error(T,...E){this.logger.error(T,...E)}flush(){this.logger.flush()}}e.LogService=k}),define(ne[127],se([0,1,12,6]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function A(l,w,R,m,d){try{const I=await new Promise((p,f)=>{G(["@vscode/spdlog"],p,f)});I.setFlushOn(k.Trace);const S=await I.createAsyncRotatingLogger(l,w,R,m);return d?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(I){console.error(I)}return null}function T(l,w,R){switch(w){case O.LogLevel.Trace:l.trace(R);break;case O.LogLevel.Debug:l.debug(R);break;case O.LogLevel.Info:l.info(R);break;case O.LogLevel.Warning:l.warn(R);break;case O.LogLevel.Error:l.error(R);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function E(l,w){switch(w){case O.LogLevel.Trace:l.setLevel(k.Trace);break;case O.LogLevel.Debug:l.setLevel(k.Debug);break;case O.LogLevel.Info:l.setLevel(k.Info);break;case O.LogLevel.Warning:l.setLevel(k.Warning);break;case O.LogLevel.Error:l.setLevel(k.Error);break;case O.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class u extends O.AbstractMessageLogger{constructor(w,R,m,d,I){super(),this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(w,R,m,d),this._register(this.onDidChangeLogLevel(S=>{this._logger&&E(this._logger,S)}))}async _createSpdLogLogger(w,R,m,d){const I=m?6:1,S=30/I*N.ByteSize.MB,p=await A(w,R,S,I,d);if(p){this._logger=p,E(this._logger,this.getLevel());for(const{level:f,message:h}of this.buffer)T(this._logger,f,h);this.buffer=[]}}log(w,R){this._logger?T(this._logger,w,R):this.getLevel()<=w&&this.buffer.push({level:w,message:R})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(ne[128],se([0,1,28,6,127]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends O.AbstractLoggerService{doCreateLogger(E,u,l){return new k.SpdLogLogger((0,N.generateUuid)(),E.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.LoggerService=A}),define(ne[38],se([0,1,4,65,2,10]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const w=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},w!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),O.Iterable.reduce(this.policies.entries(),(R,[m,d])=>({...R,[m]:d}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[w,R])=>({...l,[w]:{definition:R,value:this.policies.get(w)}}),{})}}e.AbstractPolicyService=T;class E{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(ne[129],se([0,1,8,4,65,3,12,6,38]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(R,m){const d=[];for(const I of new Set(k.Iterable.concat(R.keys(),m.keys())))R.get(I)!==m.get(I)&&d.push(I);return d}let w=class extends u.AbstractPolicyService{constructor(m,d,I){super(),this.file=m,this.fileService=d,this.logService=I,this.throttledDelayer=this._register(new N.ThrottledDelayer(500));const S=O.Event.filter(d.onDidFilesChange,p=>p.affects(m));this._register(d.watch(m)),this._register(S(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const m=new Map;try{const d=await this.fileService.readFile(this.file),I=JSON.parse(d.value.toString());if(!(0,A.isObject)(I))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(I))this.policyDefinitions[S]&&m.set(S,I[S])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return m}async refresh(){const m=await this.read(),d=l(this.policies,m);this.policies=m,d.length>0&&this._onDidChange.fire(d)}};e.FilePolicyService=w,e.FilePolicyService=w=ve([re(1,T.IFileService),re(2,E.ILogService)],w)}),define(ne[130],se([0,1,38,8,171,2,6]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let E=class extends N.AbstractPolicyService{constructor(l,w){super(),this.logService=l,this.productName=w,this.throttler=new O.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(l){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.throttler.queue(()=>new Promise((w,R)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,m=>{this._onDidPolicyChange(m),w()})}catch(m){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),R(m)}}))}_onDidPolicyChange(l){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const w in l){const R=l[w];R===void 0?this.policies.delete(w):this.policies.set(w,R)}this._onDidChange.fire(Object.keys(l))}};e.NativePolicyService=E,e.NativePolicyService=E=ve([re(0,T.ILogService)],E)}),define(ne[32],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,71,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,E){N.ok(O.isString(T)),N.ok(O.isObject(E)),N.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,E)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ne[131],se([0,1,4,36]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class A{constructor(){this._onDidChangeSchema=new N.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,l){this.schemasById[k(u)]=l,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;O.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],se([0,1,19,4,3,88,25,131,36]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=u.Registry.as(E.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.doRegisterConfigurations(t,a,i),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.doDeregisterConfigurations(a,i),this.doRegisterConfigurations(t,!1,i),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const i=[];for(const{overrides:n,source:r}of t)for(const s in n)if(a.add(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const c=this.configurationDefaultsOverrides.get(s),D=c?.valuesSources??new Map;if(r)for(const $ of Object.keys(n[s]))D.set($,r);const y={...c?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:r,value:y,valuesSources:D});const P=(0,T.getLanguageTagSettingPlainKey)(s),L={type:"object",default:y,description:A.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:k.isString(r)?void 0:r,defaultValueSource:r};i.push(...S(s)),this.configurationProperties[s]=L,this.defaultLanguageConfigurationOverridesNode.properties[s]=L}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:r});const c=this.configurationProperties[s];c&&(this.updatePropertyDefaultValue(s,c),this.updateSchema(s,c))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:i,source:n}of t)for(const r in i){const s=this.configurationDefaultsOverrides.get(r),c=k.isString(n)?n:n?.id,D=k.isString(s?.source)?s?.source:s?.source?.id;if(c===D)if(a.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const y=this.configurationProperties[r];y&&(this.updatePropertyDefaultValue(r,y),this.updateSchema(r,y))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,i){t.forEach(n=>{this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,a){const i=n=>{if(n.properties)for(const r in n.properties){a.add(r);const s=this.configurationProperties[r];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,a=!0,i,n,r=3,s){r=k.isUndefinedOrNull(t.scope)?r:t.scope;const c=t.properties;if(c)for(const y in c){const P=c[y];if(a&&C(y,P)){delete c[y];continue}if(P.source=i,P.defaultDefaultValue=c[y].default,this.updatePropertyDefaultValue(y,P),e.OVERRIDE_PROPERTY_REGEX.test(y)?P.scope=void 0:(P.scope=k.isUndefinedOrNull(P.scope)?r:P.scope,P.restricted=k.isUndefinedOrNull(P.restricted)?!!n?.includes(y):P.restricted),c[y].hasOwnProperty("included")&&!c[y].included){this.excludedConfigurationProperties[y]=c[y],delete c[y];continue}else this.configurationProperties[y]=c[y],c[y].policy?.name&&this.policyConfigurations.set(c[y].policy.name,y);!c[y].deprecationMessage&&c[y].markdownDeprecationMessage&&(c[y].deprecationMessage=c[y].markdownDeprecationMessage),s.add(y)}const D=t.allOf;if(D)for(const y of D)this.validateAndRegisterProperties(y,a,i,n,r,s)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=i=>{const n=i.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);i.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,r=i?.source;k.isUndefined(n)&&(n=a.defaultDefaultValue,r=void 0),k.isUndefined(n)&&(n=f(a.type)),a.default=n,a.defaultValueSource=r}}const d="\\[([^\\]]+)\\]",I=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let a=I.exec(b);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=I.exec(b)}}return(0,N.distinct)(t)}e.overrideIdentifiersFromKey=S;function p(b){return b.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=p;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const h=new m;u.Registry.add(e.Extensions.Configuration,h);function C(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):h.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,b,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=C;function v(){const b=[],t=h.getConfigurationProperties();for(const a of Object.keys(t))b.push([a,t[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=v}),define(ne[66],se([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,N,O,k,A,T,E,u,l,w,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(a){return Object.isFrozen(a)?a:E.deepFreeze(a)}class I{constructor(i={},n=[],r=[],s){this._contents=i,this._keys=n,this._overrides=r,this.raw=s,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof I)return n;const r=new S("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,w.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),s=n?this.rawConfiguration.getOverrideValue(i,n):void 0,c=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:s,merged:c}}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,w.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return N.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return N.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=E.deepClone(this.contents),r=E.deepClone(this.overrides),s=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const D of i)if(c.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(n,D.contents);for(const y of D.overrides){const[P]=r.filter(L=>N.equals(L.identifiers,y.identifiers));P?(this.mergeContents(P.contents,y.contents),P.keys.push(...y.keys),P.keys=N.distinct(P.keys)):r.push(E.deepClone(y))}for(const y of D.keys)s.indexOf(y)===-1&&s.push(y)}return new I(n,s,r,c.every(D=>D instanceof I)?void 0:c)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const s of N.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[s];const D=n[s];D&&(typeof c=="object"&&typeof D=="object"?(c=E.deepClone(c),this.mergeContents(c,D)):c=D),r[s]=c}return new I(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&u.isObject(i[r])&&u.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=E.deepClone(n[r])}}getContentsForOverrideIdentifer(i){let n=null,r=null;const s=c=>{c&&(r?this.mergeContents(r,c):r=E.deepClone(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===i?n=c.contents:c.identifiers.includes(i)&&s(c.contents);return s(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,w.removeFromValueTree)(this.contents,i),R.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>N.equals(r.identifiers,(0,R.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,r){(0,w.addToValueTree)(this.contents,i,n,s=>console.error(s)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),R.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,R.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,w.toValuesTree)(this.contents[i],s=>console.error(s))})}}e.ConfigurationModel=I;class S{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!u.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:s,overrides:c,restricted:D,hasExcludedProperties:y}=this.doParseRaw(i,n);this._configurationModel=new I(r,s,c,y?[i]:void 0),this._restrictedConfigurations=D||[]}doParseContent(i){let n={},r=null,s=[];const c=[],D=[];function y(L){Array.isArray(s)?s.push(L):r!==null&&(s[r]=L)}const P={onObjectBegin:()=>{const L={};y(L),c.push(s),s=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const L=[];y(L),c.push(s),s=L,r=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:y,onError:(L,$,Q)=>{D.push({error:L,offset:$,length:Q})}};if(i)try{k.visit(i,P),n=s[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return n}doParseRaw(i,n){const r=m.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,n);i=s.raw;const c=(0,w.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),D=Object.keys(i),y=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:c,keys:D,overrides:y,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(i,n,r,s){let c=!1;if(!s?.scopes&&!s?.skipRestricted&&!s?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:c};const D={},y=[];for(const P in i)if(R.OVERRIDE_PROPERTY_REGEX.test(P)&&r){const L=this.filter(i[P],n,!1,s);D[P]=L.raw,c=c||L.hasExcludedProperties,y.push(...L.restricted)}else{const L=n[P],$=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&y.push(P),!s.exclude?.includes(P)&&(s.include?.includes(P)||($===void 0||s.scopes===void 0||s.scopes.includes($))&&!(s.skipRestricted&&L?.restricted))?D[P]=i[P]:c=!0}return{raw:D,restricted:y,hasExcludedProperties:c}}toOverrides(i,n){const r=[];for(const s of Object.keys(i))if(R.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const D in i[s])c[D]=i[s][D];r.push({identifiers:(0,R.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,w.toValuesTree)(c,n)})}return r}}e.ConfigurationModelParser=S;class p extends A.Disposable{constructor(i,n,r,s){super(),this.userSettingsResource=i,this.parseOptions=n,this.fileService=s,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(i){return i&&(this.parseOptions=i),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class f{constructor(i,n,r,s,c,D,y,P,L,$,Q,Z,ue){this.key=i,this.overrides=n,this._value=r,this.overrideIdentifiers=s,this.defaultConfiguration=c,this.policyConfiguration=D,this.applicationConfiguration=y,this.userConfiguration=P,this.localUserConfiguration=L,this.remoteUserConfiguration=$,this.workspaceConfiguration=Q,this.folderConfigurationModel=Z,this.memoryConfigurationModel=ue}get value(){return d(this._value)}inspect(i,n,r){const s=i.inspect(n,r);return{get value(){return d(s.value)},get override(){return d(s.override)},get merged(){return d(s.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(i,n,r,s,c=new I,D=new I,y=new T.ResourceMap,P=new I,L=new T.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=c,this._workspaceConfiguration=D,this._folderConfigurations=y,this._memoryConfiguration=P,this._memoryConfigurationByResource=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidatedConfigurationModel(i,n,r).getValue(i)}updateValue(i,n,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new I,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(i):s.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const s=this.getConsolidatedConfigurationModel(i,n,r),c=this.getFolderConfigurationModelForResource(n.resource,r),D=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,y=new Set;for(const P of s.overrides)for(const L of P.identifiers)s.getOverrideValue(i,L)!==void 0&&y.add(L);return new f(i,n,s.getValue(i),y.size?[...y]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,c||void 0,D)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:s,updated:c,removed:D}=b(this._defaultConfiguration,i);n=[...s,...c,...D]}for(const s of n)for(const c of(0,R.overrideIdentifiersFromKey)(s)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(c),y=i.getKeysForOverrideIdentifier(c),P=[...y.filter(L=>D.indexOf(L)===-1),...D.filter(L=>y.indexOf(L)===-1),...D.filter(L=>!E.equals(this._defaultConfiguration.override(c).getValue(L),i.override(c).getValue(L)))];r.push([c,P])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:s}=b(this._policyConfiguration,i),c=[...n,...r,...s];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:s,overrides:c}=b(this.applicationConfiguration,i),D=[...n,...r,...s];return D.length&&this.updateApplicationConfiguration(i),{keys:D,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:s,overrides:c}=b(this.localUserConfiguration,i),D=[...n,...r,...s];return D.length&&this.updateLocalUserConfiguration(i),{keys:D,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:s,overrides:c}=b(this.remoteUserConfiguration,i),D=[...n,...r,...s];return D.length&&this.updateRemoteUserConfiguration(i),{keys:D,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:s,overrides:c}=b(this.workspaceConfiguration,i),D=[...n,...r,...s];return D.length&&this.updateWorkspaceConfiguration(i),{keys:D,overrides:c}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:s,updated:c,removed:D,overrides:y}=b(r,n),P=[...s,...c,...D];return(P.length||!r)&&this.updateFolderConfiguration(i,n),{keys:P,overrides:y}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:c,overrides:D}=b(n,void 0);return{keys:[...r,...s,...c],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,r){let s=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(s=s.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const s=n.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const c=this._memoryConfigurationByResource.get(i);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(n=r.merge(s),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:s,keys:c}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:s,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),s=this.parseConfigurationModel(i.application),c=this.parseConfigurationModel(i.user),D=this.parseConfigurationModel(i.workspace),y=i.folders.reduce((P,L)=>(P.set(l.URI.revive(L[0]),this.parseConfigurationModel(L[1])),P),new T.ResourceMap);return new h(n,r,s,c,new I,D,y,new I,new T.ResourceMap)}static parseConfigurationModel(i){return new I(i.contents,i.keys,i.overrides)}}e.Configuration=h;function C(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const s of a)s.keys.forEach(c=>i.add(c)),s.overrides.forEach(([c,D])=>{const y=(0,T.getOrSet)(n,c,new Set);D.forEach(P=>y.add(P))});const r=[];return n.forEach((s,c)=>r.push([c,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=C;class v{constructor(i,n,r,s){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=s,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const D of c)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){const r=this._marker+i,s=this._affectsConfigStr.indexOf(r);if(s<0)return!1;const c=s+r.length;if(c>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(c);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,P=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!E.equals(y,P)}return!0}}e.ConfigurationChangeEvent=v;function b(a,i){const{added:n,removed:r,updated:s}=t(i?.rawConfiguration,a?.rawConfiguration),c=[],D=a?.getAllOverrideIdentifiers()||[],y=i?.getAllOverrideIdentifiers()||[];if(i){const P=y.filter(L=>!D.includes(L));for(const L of P)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(a){const P=D.filter(L=>!y.includes(L));for(const L of P)c.push([L,a.getKeysForOverrideIdentifier(L)])}if(i&&a){for(const P of D)if(y.includes(P)){const L=t({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});c.push([P,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:r,updated:s,overrides:c}}function t(a,i){const n=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],r=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],s=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const D=(0,w.getConfigurationValue)(i.contents,c),y=(0,w.getConfigurationValue)(a.contents,c);E.equals(D,y)||s.push(c)}}return{added:n,removed:r,updated:s}}}),define(ne[132],se([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,N,O,k,A,T,E,u,l,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(R.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(p),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,f){this.updateConfigurationModel(p,R.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new E.ConfigurationModel;const p=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,f){const h=this.getConfigurationDefaultOverrides();for(const C of p){const v=h[C],b=f[C];v!==void 0?this._configurationModel.addValue(C,v):b?this._configurationModel.addValue(C,b.default):this._configurationModel.removeValue(C)}}}e.DefaultConfiguration=m;class d{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let I=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(p,f,h){super(),this.defaultConfiguration=p,this.policyService=f,this.logService=h,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const f={},h=[],C=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const v of p){const b=C[v];if(!b){h.push(v);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.logService.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}h.push(v),f[b.policy.name]={type:b.type}}}return(0,T.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),h}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const f=R.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),h=(0,N.coalesce)(p.map(C=>f.get(C)));this.update(h,!0)}update(p,f){this.logService.trace("PolicyConfiguration#update",p);const h=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),C=[],v=this._configurationModel.isEmpty();for(const b of p){const t=h[b]?.policy?.name;if(t){const a=this.policyService.getPolicyValue(t);(v?a!==void 0:!(0,A.equals)(this._configurationModel.getValue(b),a))&&C.push([b,a])}else this._configurationModel.getValue(b)!==void 0&&C.push([b,void 0])}if(C.length){this.logService.trace("PolicyConfiguration#changed",C);const b=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of b.keys)this._configurationModel.setValue(t,b.getValue(t));for(const[t,a]of C)a===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,a);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=I,e.PolicyConfiguration=I=ve([re(1,w.IPolicyService),re(2,l.ILogService)],I)}),define(ne[133],se([0,1,8,4,2,17,25,66,132,38]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class w extends k.Disposable{constructor(m,d,I,S){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=I instanceof l.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,I,S)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,d)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:p,properties:f})=>this.onDidDefaultConfigurationChange(p,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(p=>this.onDidPolicyConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,d,I]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(m,d,new E.ConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(m,d){const I=typeof m=="string"?m:void 0,S=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(I,S,void 0)}updateValue(m,d,I,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const d=this.configuration.toData(),I=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(I,d,2)}onDidDefaultConfigurationChange(m,d){const I=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(m,d);this.trigger(S,I,7)}onDidPolicyConfigurationChange(m){const d=this.configuration.toData(),I=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(I,d,7)}trigger(m,d,I){const S=new E.ConfigurationChangeEvent(m,{data:d},this.configuration);S.source=I,S.sourceConfig=this.getTargetConfiguration(I),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=w}),define(ne[67],se([0,1,15]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(l){return l.scheme===N.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=O;function k(l){if(!l)return;const w=l.indexOf("+");return w<0?l:l.substr(0,w)}e.getRemoteName=k;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(l){const{host:w,port:R}=u(l);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:R}}e.parseAuthorityWithPort=T;function E(l,w){let{host:R,port:m}=u(l);return typeof m>"u"&&(m=w),{host:R,port:m}}e.parseAuthorityWithOptionalPort=E;function u(l){const w=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const R=l.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const m=l.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:l,port:void 0}}}),define(ne[37],se([0,1,29,10,67]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(T||(e.ExtensionType=T={}));var E;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.LINUX_PPC64LE="linux-ppc64le",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,f){if(typeof p>"u"||p===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){const h=typeof p=="string"?p:p.value,C=typeof f=="string"?f:f.value;return N.equalsIgnoreCase(h,C)}return p._lower===f._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=u;class l{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const f of p)this.add(f)}add(p){this._set.add(u.toKey(p))}delete(p){return this._set.delete(u.toKey(p))}has(p){return this._set.has(u.toKey(p))}}e.ExtensionIdentifierSet=l;class w{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(u.toKey(p))}get(p){return this._map.get(u.toKey(p))}has(p){return this._map.has(u.toKey(p))}set(p,f){this._map.set(u.toKey(p),f)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=w;function R(S){return m(S)}e.isApplicationScopedExtension=R;function m(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function d(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function I(S,p){if(p){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return!!S.activationEvents?.includes(f)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[134],se([0,1,2,37,12]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends N.Disposable{constructor(E,u,l,w,R){super(),this.userDataProfilesService=E,this.fileService=u,this.uriIdentityService=l,this.logService=R,this._register(w.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(w.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(E){for(const u of E)u.local&&this.invalidate(u.profileLocation)}onDidUnInstallExtension(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const u of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(u.extensionsResource,E)&&await this.deleteUserCacheFile(u);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(E){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(E.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(u){(0,k.toFileOperationResult)(u)!==1&&this.logService.error(u)}}}e.ExtensionsManifestCache=A}),define(ne[44],se([0,1,14,9,2,103,43,10,6,36]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,E.createDecorator)("requestService");class w{constructor(b){this.original=b}toJSON(){if(!this.headers){const b=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.original[t];this.headers=b}return this.headers}}class R extends k.Disposable{constructor(b){super(),this.counter=0,this.logger=b.createLogger("network",{name:(0,A.localize)(0,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(b,t,a){const i=`${b} #${++this.counter}: ${t.url}`;this.logger.trace(`${i} - begin`,t.type,new w(t.headers??{}));try{const n=await a();return this.logger.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${i} - error`,t.type,(0,O.getErrorMessage)(n)),n}}}e.AbstractRequestService=R;function m(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=m;function d(v){return v.res.statusCode===204}e.hasNoContent=d;async function I(v){return d(v)?null:(await(0,N.streamToBuffer)(v.stream)).toString()}e.asText=I;async function S(v){if(!m(v))throw new Error("Server returned "+v.res.statusCode);return I(v)}e.asTextOrError=S;async function p(v){if(!m(v))throw new Error("Server returned "+v.res.statusCode);if(d(v))return null;const t=(await(0,N.streamToBuffer)(v.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=p;function f(v){C(v)}e.updateProxyConfigurationsScope=f;let h;function C(v){const b=l.Registry.as(T.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},b.updateConfigurations({add:[h],remove:t?[t]:[]})}C(1)}),define(ne[135],se([0,1,20,15,12,44]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(u,l){this.requestService=u,this.fileService=l}async download(u,l,w=N.CancellationToken.None){if(u.scheme===O.Schemas.file||u.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(u,l);return}const R={type:"GET",url:u.toString(!0)},m=await this.requestService.request(R,w);if(m.res.statusCode===200)await this.fileService.writeFile(l,m.stream);else{const d=await(0,A.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.DownloadService=T,e.DownloadService=T=ve([re(0,A.IRequestService),re(1,k.IFileService)],T)}),define(ne[136],se([0,1,137,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(T,E){return T.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:T.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function A(T,E,u={}){const l=(0,N.parse)(T),w=u.proxyUrl||k(l,E);if(!w)return null;const R=(0,N.parse)(w);if(!/^https?:$/.test(R.protocol||""))return null;const m={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,O.isBoolean)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((d,I)=>{G(["http-proxy-agent"],d,I)}))(m):new(await new Promise((d,I)=>{G(["https-proxy-agent"],d,I)}))(m)}e.getProxyAgent=A}),define(ne[138],se([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let I;async function S(f,h,C,v){return C["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(v)&&!C["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(v)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=m.Promises.withAsyncBody(async(b,t)=>{const a=new A.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,k.localize)(0,null)))},i);try{b(await p(h,a.token))}catch(s){!(0,E.isCancellationError)(s)&&!a.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(s)))):b({})}finally{clearTimeout(r),a.dispose()}})),I)}e.getResolvedShellEnv=S;async function p(f,h){const C=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",C);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const b=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(b+"({.*})"+b),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",a);const i=await(0,w.getSystemShell)(u.OS,a);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(h.isCancellationRequested)return r(new E.CancellationError);const s=(0,O.basename)(i);let c,D;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' ${y} -p '''${b}'' + JSON.stringify(process.env) + ''${b}'''`,D=["-Login","-Command"]):s==="nu"?(c=`^'${process.execPath}' ${y} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,D=["-i","-l","-c"]):(c=`'${process.execPath}' ${y} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,s==="tcsh"||s==="csh"?D=["-ic"]:D=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),c);const P=(0,N.spawn)(i,[...D,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});h.onCancellationRequested(()=>(P.kill(),r(new E.CancellationError))),P.on("error",Q=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Q)),r(Q)});const L=[];P.stdout.on("data",Q=>L.push(Q));const $=[];P.stderr.on("data",Q=>$.push(Q)),P.on("close",(Q,Z)=>{const ue=Buffer.concat(L).toString("utf8");f.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat($).toString("utf8");if(te.trim()&&f.trace("getUnixShellEnvironment#stderr",te),Q||Z)return r(new Error((0,k.localize)(2,null,Q,Z)));const ae=t.exec(ue),ce=ae?ae[1]:"{}";try{const ie=JSON.parse(ce);C?ie.ELECTRON_RUN_AS_NODE=C:delete ie.ELECTRON_RUN_AS_NODE,v?ie.ELECTRON_NO_ATTACH_CONSOLE=v:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){f.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(ie)),r(ie)}})})}}),define(ne[139],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,N.createDecorator)("stateReadService"),e.IStateService=(0,N.createDecorator)("stateService")}),define(ne[68],se([0,1,8,14,2,3,18,12,6]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class w extends k.Disposable{constructor(I,S,p,f){super(),this.storagePath=I,this.logService=p,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=S===0?void 0:this._register(new N.ThrottledDelayer(100))}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,S){const p=this.storage[I];return(0,A.isUndefinedOrNull)(p)?S:p}setItem(I,S){this.setItems([{key:I,data:S}])}setItems(I){let S=!1;for(const{key:p,data:f}of I)this.storage[p]!==f&&((0,A.isUndefinedOrNull)(f)?(0,A.isUndefined)(this.storage[p])||(this.storage[p]=void 0,S=!0):(this.storage[p]=f,S=!0));S&&this.save()}removeItem(I){(0,A.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(I),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=I}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=w;let R=class extends k.Disposable{constructor(I,S,p,f){super(),this.fileStorage=this._register(new w(S.stateResource,I,p,f))}async init(){await this.fileStorage.init()}getItem(I,S){return this.fileStorage.getItem(I,S)}};e.StateReadonlyService=R,e.StateReadonlyService=R=ve([re(1,T.IEnvironmentService),re(2,u.ILogService),re(3,E.IFileService)],R);class m extends R{setItem(I,S){this.fileStorage.setItem(I,S)}setItems(I){this.fileStorage.setItems(I)}removeItem(I){this.fileStorage.removeItem(I)}close(){return this.fileStorage.close()}}e.StateService=m}),define(ne[69],se([0,1,13,35,28]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(u){if(N.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function T(u,l,w,R,m,d,I,S){const p=Object.create(null);p["common.machineId"]=d,p.sessionID=(0,k.generateUuid)()+Date.now(),p.commitHash=R,p.version=m,p["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,N.PlatformToString)(N.platform),p["common.nodePlatform"]=O.platform,p["common.nodeArch"]=w,p["common.product"]=S||"desktop",I&&(p["common.msftInternal"]=I);let f=0;const h=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),N.isLinuxSnap&&(p["common.snap"]="true");const C=A(l);return C&&(p["common.platformDetail"]=C),p}e.resolveCommonProperties=T;function E(u){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const w=l.toLowerCase();return u.some(R=>w===R)}e.verifyMicrosoftInternalDomain=E}),define(ne[26],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[39],se([0,1,30,3,4,25,67,69,26]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class R{async publicLog(r,s,c){}async publicLogError(r,s,c){}}e.NullEndpointTelemetryService=R,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(n,r){return k.Event.debounce(r.onDidChangeConfiguration,(c,D)=>{const y=c?new Set([...c.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:y}},1e3,!0)(c=>{c.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=m;function d(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}e.supportsTelemetry=d;function I(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=I;function S(n){const r=n.getValue(u.TELEMETRY_SETTING_ID),s=n.getValue(u.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(u.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function p(n){const r={},s={},c={};C(n,c);for(let D in c){D=D.length>150?D.substr(D.length-149):D;const y=c[D];typeof y=="number"?s[D]=y:typeof y=="boolean"?s[D]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${y.length}`),r[D]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(r[D]=y)}return{properties:r,measurements:s}}e.validateTelemetryData=p;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(n){if(!n)return"none";const r=(0,T.getRemoteName)(n);return f.has(r)?r:"other"}e.cleanRemoteAuthority=h;function C(n,r,s=0,c){if(n)for(const D of Object.getOwnPropertyNames(n)){const y=n[D],P=c?c+D:D;Array.isArray(y)?r[P]=(0,N.safeStringify)(y):y instanceof Date?r[P]=y.toISOString():(0,O.isObject)(y)?s<2?C(y,r,s+1,P+"."):r[P]=(0,N.safeStringify)(y):r[P]=y}}function v(n,r){const s=n.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,E.verifyMicrosoftInternalDomain)(s)||c}e.isInternalTelemetry=v;function b(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=b;function t(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let s=n;const c=[];for(const L of r)for(;;){const $=L.exec(n);if(!$)break;c.push([$.index,L.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(s="";;){const L=y.exec(n);if(!L)break;const $=c.some(([Q,Z])=>L.index<Z&&Q<y.lastIndex);!D.test(L[0])&&!$&&(s+=n.substring(P,L.index)+"<REDACTED: user-file-path>",P=y.lastIndex)}return P<n.length&&(s+=n.substr(P)),s}function a(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(n))return`<REDACTED: ${s.label}>`;return n}function i(n,r){return(0,N.cloneAndChange)(n,s=>{if(s instanceof l||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let c=s.replaceAll("%20"," ");c=t(c,r);for(const D of r)c=c.replace(D,"");return c=a(c),c}})}e.cleanData=i}),define(ne[27],se([0,1,29,21,37,13,11,9,35,39]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,N.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=w;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,r,s)}static parse(n){const r=R.exec(n);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?w(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(i){const n=d.exec(i);return n&&n[1]?[p(n[1]),n[2]]:[p(i),void 0]}e.getIdAndVersion=I;function S(i,n){return`${i}.${n}`}e.getExtensionId=S;function p(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=p;function f(i,n){return p(S(i??k.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=f;function h(i,n){const r=[],s=c=>{for(const D of r)if(D.some(y=>w(n(y),n(c))))return D;return null};for(const c of i){const D=s(c);D?D.push(c):r.push([c])}return r}e.groupByExtension=h;function C(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function v(i){return{id:new l.TelemetryTrustedValue(i.identifier.id),name:new l.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function b(i,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&r.every(D=>!w(D.identifier,{id:c}))){const D=i.filter(y=>w(y.identifier,{id:c}));D.length===1&&(r.push(D[0]),s.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=b;async function t(i,n){if(!A.isLinux)return!1;let r;try{r=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const r=await t(i,n),s=(0,O.getTargetPlatform)(r?"alpine":A.platform,u.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=a}),define(ne[140],se([0,1,20,9,15,17,42,11,93,21,27,37]),function(G,e,N,O,k,A,T,E,u,l,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=p=>(0,u.localize)(0,null,p),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function I(p,f){return f?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let S=class{constructor(f,h,C){this.logger=f,this.extensionManagementService=h,this.extensionGalleryService=C}get location(){}async listExtensions(f,h,C){let v=await this.extensionManagementService.getInstalled(1,C);const b=R.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(h&&h!==""){if(b.indexOf(h.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.logger.info("Possible Categories: "),b.forEach(a=>{this.logger.info(a)});return}this.location&&this.logger.info((0,u.localize)(2,null,this.location)),v=v.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of v)t!==a.identifier.id&&(t=a.identifier.id,this.logger.info(I(a.manifest,f)))}async installExtensions(f,h,C,v){const b=[];try{const t=[];f.length&&this.logger.info(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const a=[];let i=[];const n=(s,c,D)=>{i.push({id:s,version:c!=="prerelease"?c:void 0,installOptions:{...C,isBuiltin:D,installPreReleaseVersion:c==="prerelease"||C.installPreReleaseVersion}})};for(const s of f)if(s instanceof E.URI)a.push({vsix:s,installOptions:C});else{const[c,D]=(0,w.getIdAndVersion)(s);n(c,D,!1)}for(const s of h)if(s instanceof E.URI)a.push({vsix:s,installOptions:{...C,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,D]=(0,w.getIdAndVersion)(s);n(c,D,!0)}const r=await this.extensionManagementService.getInstalled(1,C.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:s,installOptions:c})=>{try{const D=await this.installVSIX(s,c,v,r);D&&t.push(D)}catch(D){this.logger.error(D),b.push(s.toString())}})),i.length&&(i=i.filter(({id:s,version:c})=>{const D=r.find(y=>(0,w.areSameExtensions)(y.identifier,{id:s}));if(D){if(!v&&(!c||c==="prerelease"&&D.preRelease))return this.logger.info((0,u.localize)(5,null,s,D.manifest.version,s)),!1;if(c&&D.manifest.version===c)return this.logger.info((0,u.localize)(6,null,`${s}@${c}`)),!1}return!0}),i.length)){const s=await this.getGalleryExtensions(i);await Promise.all(i.map(async c=>{const D=s.get(c.id.toLowerCase());if(D)try{const y=await this.installFromGallery(c,D,r);y&&t.push(y)}catch(y){this.logger.error(y.message||y.stack||y),b.push(c.id)}else this.logger.error(`${m(c.version?`${c.id}@${c.version}`:c.id)}
${d}`),b.push(c.id)}))}}catch(t){throw this.logger.error((0,u.localize)(7,null,(0,O.getErrorMessage)(t))),t}if(b.length)throw new Error((0,u.localize)(8,null,b.join(", ")))}async installVSIX(f,h,C,v){const b=await this.extensionManagementService.getManifest(f);if(!b)throw new Error("Invalid vsix");if(await this.validateVSIX(b,C,h.profileLocation,v))try{return await this.extensionManagementService.install(f,h),this.logger.info((0,u.localize)(9,null,(0,A.basename)(f))),b}catch(a){if((0,O.isCancellationError)(a))return this.logger.info((0,u.localize)(10,null,(0,A.basename)(f))),null;throw a}return null}async getGalleryExtensions(f){const h=new Map,C=f.some(t=>t.installOptions.installPreReleaseVersion),v=await this.extensionManagementService.getTargetPlatform(),b=[];for(const t of f)l.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&b.push({...t,preRelease:C});if(b.length){const t=await this.extensionGalleryService.getExtensions(b,{targetPlatform:v},N.CancellationToken.None);for(const a of t)h.set(a.identifier.id.toLowerCase(),a)}return h}async installFromGallery({id:f,version:h,installOptions:C},v,b){const t=await this.extensionGalleryService.getManifest(v,N.CancellationToken.None);if(t&&!this.validateExtensionKind(t))return null;const a=b.find(i=>(0,w.areSameExtensions)(i.identifier,v.identifier));if(a){if(v.version===a.manifest.version)return this.logger.info((0,u.localize)(11,null,h?`${f}@${h}`:f)),null;this.logger.info((0,u.localize)(12,null,f,v.version))}try{C.isBuiltin?this.logger.info(h?(0,u.localize)(13,null,f,h):(0,u.localize)(14,null,f)):this.logger.info(h?(0,u.localize)(15,null,f,h):(0,u.localize)(16,null,f));const i=await this.extensionManagementService.installFromGallery(v,{...C,installGivenVersion:!!h});return this.logger.info((0,u.localize)(17,null,f,i.manifest.version)),t}catch(i){if((0,O.isCancellationError)(i))return this.logger.info((0,u.localize)(18,null,f)),null;throw i}}validateExtensionKind(f){return!0}async validateVSIX(f,h,C,v){if(!h){const b={id:(0,w.getGalleryExtensionId)(f.publisher,f.name)},t=v.find(a=>(0,w.areSameExtensions)(b,a.identifier)&&(0,T.gt)(a.manifest.version,f.version));if(t)return this.logger.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.validateExtensionKind(f)}async uninstallExtensions(f,h,C){const v=async t=>{if(t instanceof E.URI){const a=await this.extensionManagementService.getManifest(t);return I(a)}return t},b=[];for(const t of f){const a=await v(t),n=(await this.extensionManagementService.getInstalled(void 0,C)).filter(r=>(0,w.areSameExtensions)(r.identifier,{id:a}));if(!n.length)throw new Error(`${this.notInstalled(a)}
${d}`);if(n.some(r=>r.type===0)){this.logger.info((0,u.localize)(20,null,a));return}if(!h&&n.some(r=>r.isBuiltin)){this.logger.info((0,u.localize)(21,null,a));return}this.logger.info((0,u.localize)(22,null,a));for(const r of n)await this.extensionManagementService.uninstall(r,{profileLocation:C}),b.push(r);this.location?this.logger.info((0,u.localize)(23,null,a,this.location)):this.logger.info((0,u.localize)(24,null,a))}}async locateExtension(f){const h=await this.extensionManagementService.getInstalled();f.forEach(C=>{h.forEach(v=>{if(v.identifier.id===C&&v.location.scheme===k.Schemas.file){this.logger.info(v.location.fsPath);return}})})}notInstalled(f){return this.location?(0,u.localize)(25,null,f,this.location):(0,u.localize)(26,null,f)}};e.ExtensionManagementCLI=S,e.ExtensionManagementCLI=S=ve([re(1,l.IExtensionManagementService),re(2,l.IExtensionGalleryService)],S)}),define(ne[141],se([0,1,4,2,31,27,37]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class E extends O.Disposable{constructor(l,w,R,m,d,I,S){super(),this.extensionManagementService=l,this.extensionsScannerService=w,this.userDataProfilesService=R,this.extensionsProfileScannerService=m,this.uriIdentityService=d,this.fileService=I,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,p=>S.error(p))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l){try{l.length&&await Promise.all(l.map(w=>(this.extensionsProfileWatchDisposables.set(w.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(w.extensionsResource)),this.fileService.watch(w.extensionsResource))),this.populateExtensionsFromProfile(w.extensionsResource))))}catch(w){throw this.logService.error(w),w}}async onAddExtensions(l){for(const w of l.extensions)this.addExtensionWithKey(this.getKey(w.identifier,w.version),l.profileLocation)}async onDidAddExtensions(l){for(const w of l.extensions){const R=this.getKey(w.identifier,w.version);l.error?this.removeExtensionWithKey(R,l.profileLocation):this.addExtensionWithKey(R,l.profileLocation)}}async onRemoveExtensions(l){for(const w of l.extensions)this.removeExtensionWithKey(this.getKey(w.identifier,w.version),l.profileLocation)}async onDidRemoveExtensions(l){const w=[],R=[];for(const m of l.extensions){const d=this.getKey(m.identifier,m.version);l.error?this.addExtensionWithKey(d,l.profileLocation):(this.removeExtensionWithKey(d,l.profileLocation),this.allExtensions.has(d)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),R.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(I=>{I?w.push(I):this.logService.info("Extension not found at the location",m.location.toString())},I=>this.logService.error(I)))))}try{await Promise.all(R),w.length&&await this.uninstallExtensionsNotInProfiles(w)}catch(m){this.logService.error(m)}}onDidFilesChange(l){for(const w of this.userDataProfilesService.profiles)l.contains(w.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(w.extensionsResource)}async onDidExtensionsProfileChange(l){const w=[],R=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(l),d=new Set,I=new Set;for(const[S,p]of this.allExtensions)p.has(l)&&I.add(S);for(const S of m){const p=this.getKey(S.identifier,S.version);d.add(p),I.has(p)||(w.push(S.identifier),this.addExtensionWithKey(p,l))}for(const S of I)if(!d.has(S)){const p=this.fromKey(S);p&&(R.push(p.identifier),this.removeExtensionWithKey(S,l))}(w.length||R.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w.length?{extensions:w,profileLocation:l}:void 0,removed:R.length?{extensions:R,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const w=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const R of w)this.addExtensionWithKey(this.getKey(R.identifier,R.version),l)}async uninstallExtensionsNotInProfiles(l){l||(l=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(R=>!this.allExtensions.has(this.getKey(R.identifier,R.manifest.version)))),l.length&&await this.extensionManagementService.markAsUninstalled(...l)}addExtensionWithKey(l,w){let R=this.allExtensions.get(l);R||this.allExtensions.set(l,R=new k.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),R.add(w)}removeExtensionWithKey(l,w){const R=this.allExtensions.get(l);R&&R.delete(w),R?.size||this.allExtensions.delete(l)}getKey(l,w){return`${T.ExtensionIdentifier.toKey(l.id)}@${w}`}fromKey(l){const[w,R]=(0,A.getIdAndVersion)(l);return R?{identifier:{id:w},version:R}:void 0}}e.ExtensionsWatcher=E}),define(ne[142],se([0,1,113,39]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(A,T,E,u,l,w,R){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,E)&&(0,O.getTelemetryLevel)(u)===3){const d=await(0,N.getServiceMachineId)(E,l,w);m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=R.machineId||d}return m}e.resolveMarketplaceHeaders=k}),define(ne[143],se([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let S=class extends d.LanguagePackBaseService{constructor(C,v,b,t){super(b),this.extensionManagementService=C,this.logService=t,this.cache=this._register(new p(v,t)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getBuiltInExtensionTranslationsUri(C,v){const t=(await this.cache.getLanguagePacks())[v];if(!t){this.logService.warn(`No language pack found for ${v}`);return}const a=t.translations[C];return a?I.URI.file(a):void 0}async getInstalledLanguages(){const C=await this.cache.getLanguagePacks(),v=Object.keys(C).map(b=>{const t=C[b];return{...this.createQuickPickItem(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return v.push(this.createQuickPickItem("en","English")),v.sort((b,t)=>b.label.localeCompare(t.label)),v}async postInstallExtension(C){C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",C.identifier.id),await this.update())}async postUninstallExtension(C){const v=await this.cache.getLanguagePacks();Object.keys(v).some(b=>v[b]&&v[b].extensions.some(t=>(0,R.areSameExtensions)(t.extensionIdentifier,C.identifier)))&&(this.logService.info("Removing language packs from the extension",C.identifier.id),await this.update())}async update(){const[C,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),b=await this.cache.update(v);return!(0,O.equals)(Object.keys(C),Object.keys(b))}};e.NativeLanguagePackService=S,e.NativeLanguagePackService=S=ve([re(0,w.IExtensionManagementService),re(1,l.INativeEnvironmentService),re(2,w.IExtensionGalleryService),re(3,m.ILogService)],S);let p=class extends A.Disposable{constructor(C,v){super(),this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(C.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(C){return this.withLanguagePacks(v=>{Object.keys(v).forEach(b=>delete v[b]),this.createLanguagePacksFromExtensions(v,...C)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(C,...v){for(const b of v)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(C,b);Object.keys(C).forEach(b=>this.updateHash(C[b]))}createLanguagePacksFromExtension(C,v){const b=v.identifier,t=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const a of t)if(v.location.scheme===T.Schemas.file&&f(a)){let i=C[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},C[a.languageId]=i);const n=i.extensions.filter(r=>(0,R.areSameExtensions)(r.extensionIdentifier,b))[0];n?n.version=v.manifest.version:i.extensions.push({extensionIdentifier:b,version:v.manifest.version});for(const r of a.translations)i.translations[r.id]=(0,E.join)(v.location.fsPath,r.path)}}updateHash(C){if(C){const v=(0,N.createHash)("md5");for(const b of C.extensions)v.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);C.hash=v.digest("hex")}}withLanguagePacks(C=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(v=C(b),b)).then(b=>{for(const a of Object.keys(b))b[a]||delete b[a];this.languagePacks=b,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),u.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>v,b=>this.logService.error(b))})}};p=ve([re(0,l.INativeEnvironmentService),re(1,m.ILogService)],p);function f(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const C of h.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ne[144],se([0,1,82,9,30,39]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",E="https://0.0.0.0/ping";async function u(w,R,m){const d=await(0,N.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),I=await(0,N.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),S=new d.AppInsightsCore,p=new I.PostChannel,f={instrumentationKey:w,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(m){f.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:m};f.extensionConfig[p.identifier]=h}return S.initialize(f,[]),S.addTelemetryInitializer(h=>{R&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),S}class l{constructor(R,m,d,I,S){this._isInternalTelemetry=R,this._eventPrefix=m,this._defaultData=d,this._xhrOverride=S,this.endPointUrl=T,this.endPointHealthUrl=E,this._defaultData||(this._defaultData={}),typeof I=="function"?this._aiCoreOrKey=I():this._aiCoreOrKey=I,this._asyncAiCore=null}_withAIClient(R){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){R(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(m=>{R(m)},m=>{(0,O.onUnexpectedError)(m),console.error(m)})}}log(R,m){if(!this._aiCoreOrKey)return;m=(0,k.mixin)(m,this._defaultData),m=(0,A.validateTelemetryData)(m);const d=this._eventPrefix+"/"+R;try{this._withAIClient(I=>{I.pluginVersionString=m?.properties.version??"Unknown",I.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(R=>{this._withAIClient(m=>{m.unload(!0,()=>{this._aiCoreOrKey=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=l}),define(ne[145],se([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,h,C){this._configurationService=h,this._productService=C,this._experimentProperties={},this._disposables=new N.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(v=>{(v.affectsConfiguration(m.TELEMETRY_SETTING_ID)||v.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,h){this._experimentProperties[f]=h}_updateTelemetryLevel(){let f=(0,d.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const C=h.usage?3:h.error?2:0;f=Math.min(f,C)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(f,h,C){this._telemetryLevel<h||(C=(0,O.mixin)(C,this._experimentProperties),C=(0,d.cleanData)(C,this._cleanupPatterns),C=(0,O.mixin)(C,this._commonProperties),this._appenders.forEach(v=>v.log(f,C)))}publicLog(f,h){this._log(f,3,h)}publicLog2(f,h){this.publicLog(f,h)}publicLogError(f,h){this._sendErrorTelemetry&&this._log(f,2,h)}publicLogError2(f,h){this.publicLogError(f,h)}};e.TelemetryService=I,e.TelemetryService=I=ve([re(1,E.IConfigurationService),re(2,w.IProductService)],I);function S(){const p=(0,T.localize)(0,null,l.default.nameLong),f=l.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=k.isWeb?"":(0,T.localize)(3,null),C=(0,T.localize)(4,null),v=(0,T.localize)(5,null),b=(0,T.localize)(6,null),t=(0,T.localize)(7,null),a=`
|       | ${C} | ${v} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,T.localize)(8,null);return`
${p} ${f} ${h}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}R.Registry.as(u.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:S(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),R.Registry.as(u.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,T.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,T.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],se([0,1,14,20,174,144]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function T(w,R){const m=await R.request(w,O.CancellationToken.None),d=(await(0,N.streamToBuffer)(m.stream)).toString(),I=m.res.statusCode??200;return{headers:m.res.headers,statusCode:I,responseData:d}}async function E(w){const R={method:w.type,headers:w.headers};return new Promise((d,I)=>{const S=k.request(w.url??"",R,p=>{p.on("data",function(f){d({headers:p.headers,statusCode:p.statusCode??200,responseData:f.toString()})}),p.on("error",function(f){I(f)})});S.write(w.data,p=>{p&&I(p)}),S.end()})}async function u(w,R,m){const d=typeof R.data=="string"?R.data:new TextDecoder().decode(R.data),I={type:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data).toString()},url:R.urlString,data:d};try{const S=w?await T(I,w):await E(I);m(S.statusCode,S.headers,S.responseData)}catch{m(0,{})}}class l extends A.AbstractOneDataSystemAppender{constructor(R,m,d,I,S){const p={sendPOST:(f,h)=>{u(R,f,h)}};super(m,d,I,S,p)}}e.OneDataSystemAppender=l}),define(ne[148],se([0,1,16,24]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(A,T){const E=Object.create(null),u=(w,R)=>{const m=JSON.parse(w);E[R]=m};if(T){const w=[],R=await O.Promises.readdir(T);for(const d of R)try{(await O.Promises.stat((0,N.join)(T,d))).isDirectory()&&w.push(d)}catch{}const m=[];for(const d of w)(await O.Promises.readdir((0,N.join)(T,d))).filter(S=>S==="telemetry.json").length===1&&m.push(d);for(const d of m){const I=(await O.Promises.readFile((0,N.join)(T,d,"telemetry.json"))).toString();u(I,d)}}let l=(await O.Promises.readFile((0,N.join)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await O.Promises.readFile((0,N.join)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(E,null,4)}e.buildTelemetryMessage=k}),define(ne[149],se([0,1,13,75,26]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(T,E){let u=T.getItem(k.machineIdKey);return(typeof u!="string"||N.isMacintosh&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,O.getMachineId)(E.error.bind(E))),u}e.resolveMachineId=A}),define(ne[22],se([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(ne[150],se([0,1,22,114,12,17,73,4,2]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(m){this.uri=m,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let w=class{constructor(m){this._fileService=m,this._dispooables=new u.DisposableStore,this._limit=2**16;const d=new Map,I=S=>{let p=d.get(S.scheme);return p===void 0&&(p=m.hasProvider(S)&&!this._fileService.hasCapability(S,1024),d.set(S.scheme,p)),p};this._dispooables.add(E.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(S=>{d.delete(S.scheme)})),this.extUri=new A.ExtUri(I),this._canonicalUris=new T.SkipList((S,p)=>this.extUri.compare(S,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,A.normalizePath)(m));const d=this._canonicalUris.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new l(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((I,S)=>I[1].time<S[1].time?1:I[1].time>S[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let I=0;I<d;I++)this._canonicalUris.set(m[I][0],m[I][1].touch())}};e.UriIdentityService=w,e.UriIdentityService=w=ve([re(0,k.IFileService)],w),(0,O.registerSingleton)(N.IUriIdentityService,w,1)}),define(ne[151],se([0,1,4,2,12,46,31]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends O.Disposable{constructor(l,w,R,m,d,I){super(),this.fileSystemScheme=l,this.fileSystemProvider=w,this.userDataScheme=R,this.userDataProfilesService=m,this.uriIdentityService=d,this.logService=I,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new T.ResourceSet(S=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(S))),this.updateAtomicReadWritesResources(),this._register(m.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(S=>this.handleFileChanges(S)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,w){return this.fileSystemProvider.open(this.toFileSystemResource(l),w)}close(l){return this.fileSystemProvider.close(l)}read(l,w,R,m,d){return this.fileSystemProvider.read(l,w,R,m,d)}write(l,w,R,m,d){return this.fileSystemProvider.write(l,w,R,m,d)}watch(l,w){this.watchResources.set(l,l);const R=this.fileSystemProvider.watch(this.toFileSystemResource(l),w);return(0,O.toDisposable)(()=>{this.watchResources.delete(l),R.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,w,R){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(w),R)}readFile(l,w){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),w)}readFileStream(l,w,R){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),w,R)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,w,R){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),w,R)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,w){return this.fileSystemProvider.delete(this.toFileSystemResource(l),w)}copy(l,w,R){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(w),R);throw new Error("copy not supported")}cloneFile(l,w){if((0,k.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(w));throw new Error("clone not supported")}handleFileChanges(l){const w=[];for(const R of l){if(R.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(R.resource);this.watchResources.findSubstr(m)&&w.push({resource:m,type:R.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[152],se([0,1,107,16,46,17,11,10,15]),function(G,e,N,O,k,A,T,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function l(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=l;function w(n){return typeof n?.id=="string"&&!l(n)&&!m(n)}e.isEmptyWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function R(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=n;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=R;function m(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=m;function d(n){const r=n;if(r?.uri)return{id:r.id,uri:T.URI.revive(r.uri)};const s=n;if(s?.configPath)return{id:s.id,configPath:T.URI.revive(s.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=d;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I||(e.WorkbenchState=I={}));function S(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=S;function p(n){const r=n;return!!(r&&typeof r=="object"&&T.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=p;class f{constructor(r,s,c,D,y){this._id=r,this._transient=c,this._configuration=D,this._ignorePathCasing=y,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class h{constructor(r,s){this.raw=s,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function C(n){return new h({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(n,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function b(n){let r;return T.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=b,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(n,r){return!v(n,r)&&!b(n)}e.isSavedWorkspace=a;function i(n){return(typeof n=="string"?(0,O.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[23],se([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var C;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(C||(e.ProfileResourceType=C={}));function v(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&T.URI.isUri(r.location)&&T.URI.isUri(r.globalStorageHome)&&T.URI.isUri(r.settingsResource)&&T.URI.isUri(r.keybindingsResource)&&T.URI.isUri(r.tasksResource)&&T.URI.isUri(r.snippetsHome)&&T.URI.isUri(r.extensionsResource))}e.isUserDataProfile=v,e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function b(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:T.URI.revive(n.location).with({scheme:r}),globalStorageHome:T.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:T.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:T.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:T.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:T.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:T.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:T.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=b;function t(n,r,s,c,D,y){return{id:n,name:r,location:s,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:y&&D?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.joinPath)(s,"globalStorage"),settingsResource:y&&D?.useDefaultFlags?.settings?y.settingsResource:(0,A.joinPath)(s,"settings.json"),keybindingsResource:y&&D?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.joinPath)(s,"keybindings.json"),tasksResource:y&&D?.useDefaultFlags?.tasks?y.tasksResource:(0,A.joinPath)(s,"tasks.json"),snippetsHome:y&&D?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.joinPath)(s,"snippets"),extensionsResource:y&&D?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.joinPath)(s,"extensions.json"),cacheHome:(0,A.joinPath)(c,n),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let a=class extends k.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,s,c,D){super(),this.environmentService=r,this.fileService=s,this.uriIdentityService=c,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),s=[r];if(this.enabled)try{for(const y of this.getStoredProfiles()){if(!y.name||!(0,h.isString)(y.name)||!y.location){this.logService.warn("Skipping the invalid stored profile",y.location||y.name);continue}s.push(t((0,A.basename)(y.location),y.name,y.location,this.profilesCacheHome,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},r))}}catch(y){this.logService.error(y)}const c=new d.ResourceMap,D=new Map;if(s.length)try{const y=this.getStoredProfileAssociations();if(y.workspaces)for(const[P,L]of Object.entries(y.workspaces)){const $=T.URI.parse(P),Q=s.find(Z=>Z.id===L);Q&&c.set($,Q)}if(y.emptyWindows)for(const[P,L]of Object.entries(y.emptyWindows)){const $=s.find(Q=>Q.id===L);$&&D.set(P,$)}}catch(y){this.logService.error(y)}this._profilesObject={profiles:s,workspaces:c,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const r=t("__default__profile__",(0,E.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const s="Temp",c=new RegExp(`${(0,f.escapeRegExpCharacters)(s)}\\s(\\d+)`);let D=0;for(const P of this.profiles){const L=c.exec(P.name),$=L?parseInt(L[1]):0;D=$>D?$:D}const y=`${s} ${D+1}`;return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),y,{transient:!0},r)}async createNamedProfile(r,s,c){return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),r,s,c)}async createProfile(r,s,c,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=await this.doCreateProfile(r,s,c);return D&&await this.setProfileForWorkspace(D,y),y}async doCreateProfile(r,s,c){if(!(0,h.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(s);return D||(D=(async()=>{try{const y=this.profiles.find($=>$.name===s||$.id===r);if(y)return y;const P=t(r,s,(0,A.joinPath)(this.profilesHome,r),this.profilesCacheHome,c,this.defaultProfile);await this.fileService.createFolder(P.location);const L=[];return this._onWillCreateProfile.fire({profile:P,join($){L.push($)}}),await S.Promises.settled(L),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,D)),D}async updateProfile(r,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(D=>D.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=t(c.id,s.name??c.name,c.location,this.profilesCacheHome,{shortName:s.shortName??c.shortName,icon:s.icon===null?void 0:s.icon??c.icon,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(D=>D.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:s,join(D){c.push(D)}});try{await Promise.allSettled(c)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])s.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{await this.fileService.del(s.cacheHome,{recursive:!0})}catch(D){(0,l.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(r,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(D=>D.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}getProfileForWorkspace(r){const s=this.getWorkspace(r);return T.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindows.get(s)??this.profilesObject.emptyWindows.get(s)}getWorkspace(r){return(0,m.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,m.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location)))}updateProfiles(r,s,c){const D=[...this.profiles,...r],y=[];this.transientProfilesObject.profiles=[];for(let P of D)P.isDefault||s.some(L=>P.id===L.id)||(P=c.find(L=>P.id===L.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):y.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(y),this._profilesObject=void 0,this.triggerProfilesChanges(r,s,c)}triggerProfilesChanges(r,s,c){this._onDidChangeProfiles.fire({added:r,removed:s,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,s,c){c=s?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const D=this.getWorkspace(r),y=c?this.transientProfilesObject:this.profilesObject;T.URI.isUri(D)?(y.workspaces.delete(D),s&&y.workspaces.set(D,s)):(y.emptyWindows.delete(D),s&&y.emptyWindows.set(D,s)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,D]of this.profilesObject.workspaces.entries())r[c.toString()]=D.id;const s={};for(const[c,D]of this.profilesObject.emptyWindows.entries())s[c.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:s}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const s={},c=this.createDefaultProfile();if(r.workspaces)for(const[y,P]of Object.entries(r.workspaces)){const L=T.URI.parse(P);s[y]=this.uriIdentityService.extUri.isEqual(L,c.location)?c.id:this.uriIdentityService.extUri.basename(L)}const D={};if(r.emptyWindows)for(const[y,P]of Object.entries(r.emptyWindows)){const L=T.URI.parse(P);D[y]=this.uriIdentityService.extUri.isEqual(L,c.location)?c.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:s,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=a,e.UserDataProfilesService=a=ve([re(0,u.IEnvironmentService),re(1,l.IFileService),re(2,I.IUriIdentityService),re(3,R.ILogService)],a);class i extends a{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=i}),define(ne[153],se([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends E.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(r,s,c,D,y,P){super(),this.galleryService=r,this.telemetryService=s,this.uriIdentityService=c,this.logService=D,this.productService=y,this.userDataProfilesService=P,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const s=await this.getTargetPlatform();return r.allTargetPlatforms.some(c=>(0,m.isTargetPlatformCompatible)(c,r.allTargetPlatforms,s))}async installFromGallery(r,s={}){try{const D=(await this.installGalleryExtensions([{extension:r,options:s}])).find(({identifier:y})=>(0,d.areSameExtensions)(y,r.identifier));if(D?.local)return D?.local;throw D?.error?D.error:t(new Error(`Unknown error while installing extension ${r.identifier.id}`))}catch(c){throw t(c)}}async installGalleryExtensions(r){if(!this.galleryService.isEnabled())throw new m.ExtensionManagementError(R.localize(0,null),m.ExtensionManagementErrorCode.Internal);const s=[],c=[];await Promise.allSettled(r.map(async({extension:D,options:y})=>{try{const P=await this.checkAndGetCompatibleVersion(D,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);c.push({...P,options:y})}catch(P){s.push({identifier:D.identifier,operation:2,source:D,error:P})}})),c.length&&s.push(...await this.installExtensions(c));for(const D of s)D.error&&(this.logService.error("Failed to install extension.",D.identifier.id),this.logService.error(D.error),D.source&&!w.URI.isUri(D.source)&&a(this.telemetryService,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(D.source),error:D.error}));return s}async uninstall(r,s={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtension(r,s)}async toggleAppliationScope(r,s){if((0,I.isApplicationScopedExtension)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let c=await this.updateMetadata(r,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)||(c=await this.copyExtension(r,this.userDataProfilesService.defaultProfile.extensionsResource,s));for(const D of this.userDataProfilesService.profiles){const y=(await this.getInstalled(1,D.extensionsResource)).find(P=>(0,d.areSameExtensions)(P.identifier,r.identifier));y?this._onDidUpdateExtensionMetadata.fire(y):this._onDidUninstallExtension.fire({identifier:r.identifier,profileLocation:D.extensionsResource})}return c}else{const c=this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(r,s,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtensions(r){const s=[];return await Promise.allSettled(r.map(async c=>{try{const D=await this.installExtension(c);s.push(...D)}catch(D){s.push({identifier:{id:(0,d.getGalleryExtensionId)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:D})}})),this._onDidInstallExtensions.fire(s),s}async installExtension({manifest:r,extension:s,options:c}){const D=c.isApplicationScoped||c.isBuiltin||(0,I.isApplicationScopedExtension)(r),y={...c,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(s)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:D,profileLocation:D?this.userDataProfilesService.defaultProfile.extensionsResource:c.profileLocation??this.getCurrentExtensionsManifestLocation()},P=te=>`${d.ExtensionKey.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!w.URI.isUri(s)){const te=this.installingExtensions.get(P(s));if(te)return this.logService.info("Extensions is already requested to install",s.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const L=[],$=[],Q=[],Z=this.createInstallExtensionTask(r,s,y);w.URI.isUri(s)||this.installingExtensions.set(P(s),{task:Z,waitingTasks:[]}),this._onInstallExtension.fire({identifier:Z.identifier,source:s,profileLocation:y.profileLocation}),this.logService.info("Installing extension:",Z.identifier.id),L.push({task:Z,manifest:r});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",Z.identifier.id);else try{const ae=await this.getAllDepsAndPackExtensions(Z.identifier,r,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),ce=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[m.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:W,manifest:B}of(0,N.distinct)(ae,({gallery:V})=>V.identifier.id)){ue=ue||!!B.extensionDependencies?.some(z=>(0,d.areSameExtensions)({id:z},Z.identifier));const V=P(W),M=this.installingExtensions.get(V);if(M){if(this.canWaitForTask(Z,M.task)){const z=M.task.identifier;this.logService.info("Waiting for already requested installing extension",z.id,Z.identifier.id),M.waitingTasks.push(Z),$.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,K=>K.some(X=>(0,d.areSameExtensions)(X.identifier,z)))).then(K=>{if(this.logService.info("Finished waiting for already requested installing extension",z.id,Z.identifier.id),!K.find(J=>(0,d.areSameExtensions)(J.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!ce.some(({identifier:z})=>(0,d.areSameExtensions)(z,W.identifier))){const z=this.createInstallExtensionTask(B,W,ie);this.installingExtensions.set(V,{task:z,waitingTasks:[Z]}),this._onInstallExtension.fire({identifier:z.identifier,source:W,profileLocation:y.profileLocation}),this.logService.info("Installing extension:",z.identifier.id,Z.identifier.id),L.push({task:z,manifest:B})}}}catch(ae){if(w.URI.isUri(Z.source))(0,N.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Z.identifier.id,ae.message),(0,N.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Z.identifier.id,ae.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",Z.identifier.id),ae}const te=L.reduce((ae,{task:ce,manifest:ie})=>(ae.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:ie}),ae),new Map);for(;te.size;){let ae;const ce=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(W=>te.has(W.toLowerCase())));ce.length?ae=te.size===1?ce:ce.filter(({task:ie})=>!(ie===Z&&!ue)):(this.logService.info("Found extensions with circular dependencies",ce.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.joinAllSettled(ae.map(async({task:ie})=>{const W=new Date().getTime();try{const B=await ie.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(B,ie.source,y,k.CancellationToken.None))),!w.URI.isUri(ie.source)){const V=ie.operation===3,M=V?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-W,durationSinceUpdate:M}),u.isWeb&&ie.operation!==3)try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}Q.push({local:B,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw w.URI.isUri(ie.source)||a(this.telemetryService,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-W,error:B}),this.logService.error("Error while installing the extension:",ie.identifier.id),B}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return $.length&&await this.joinAllSettled($),Q.forEach(({identifier:ae})=>this.logService.info("Extension installed successfully:",ae.id)),Q}catch(te){if(L.forEach(({task:ae})=>ae.cancel()),Q.length)try{const ae=await Promise.allSettled(Q.map(({local:ce})=>this.createUninstallExtensionTask(ce,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let ce=0;ce<ae.length;ce++){const ie=ae[ce],{identifier:W}=Q[ce];ie.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",W.id):this.logService.warn("Rollback: Error while uninstalling extension",W.id,(0,A.getErrorMessage)(ie.reason))}}catch(ae){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(ae),Q.map(({identifier:ce})=>ce.id))}return L.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of L)te.source&&!w.URI.isUri(te.source)&&this.installingExtensions.delete(P(te.source))}}canWaitForTask(r,s){for(const[,{task:c,waitingTasks:D}]of this.installingExtensions.entries())if(c===r&&(D.includes(s)||D.some(y=>this.canWaitForTask(y,s)))||c===s&&D[0]&&!this.canWaitForTask(r,D[0]))return!1;return!0}async joinAllSettled(r){const s=[],c=[],D=await Promise.allSettled(r);for(const y of D)y.status==="fulfilled"?s.push(y.value):c.push(y.reason);if(c.length)throw b(c);return s}async getAllDepsAndPackExtensions(r,s,c,D,y){if(!this.galleryService.isEnabled())return[];const P=await this.getInstalled(void 0,y),L=[],$=[],Q=async(Z,ue)=>{L.push(Z);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const ce=c?P.find(ie=>(0,d.areSameExtensions)(ie.identifier,Z)):void 0;for(const ie of ue.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(W=>(0,d.areSameExtensions)({id:W},{id:ie}))||ae.every(W=>!(0,d.areSameExtensions)({id:W},{id:ie}))&&ae.push(ie)}if(ae.length){const ce=ae.filter(ie=>L.every(W=>!(0,d.areSameExtensions)(W,{id:ie})));if(ce.length){const ie=await this.galleryService.getExtensions(ce.map(W=>({id:W,preRelease:D})),k.CancellationToken.None);for(const W of ie){if(L.find(M=>(0,d.areSameExtensions)(M,W.identifier)))continue;const B=te.some(M=>(0,d.areSameExtensions)({id:M},W.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(W,!1,D)}catch(M){if(B)throw M;this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.getErrorMessage)(M));continue}$.push({gallery:V.extension,manifest:V.manifest}),await Q(V.extension.identifier,V.manifest)}}}};return await Q(r,s),$}async checkAndGetCompatibleVersion(r,s,c){let D;const y=await this.getExtensionsControlManifest();if(y.malicious.some($=>(0,d.areSameExtensions)(r.identifier,$)))throw new m.ExtensionManagementError(R.localize(1,null,r.identifier.id),m.ExtensionManagementErrorCode.Malicious);const P=y.deprecated[r.identifier.id.toLowerCase()];if(P?.extension?.autoMigrate){if(this.logService.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${P.extension.id}' extension instead.`),D=(await this.galleryService.getExtensions([{id:P.extension.id,preRelease:P.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0],!D)throw new m.ExtensionManagementError(R.localize(2,null,r.identifier.id,P.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const $=await this.getTargetPlatform();throw new m.ExtensionManagementError(R.localize(3,null,r.identifier.id,this.productService.nameLong,(0,m.TargetPlatformToString)($)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(D=await this.getCompatibleVersion(r,s,c),!D)throw!c&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],k.CancellationToken.None))[0]?new m.ExtensionManagementError(R.localize(4,null,r.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(R.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",D.identifier.id);const L=await this.galleryService.getManifest(D,k.CancellationToken.None);if(L===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${D.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(L.version!==D.version)throw new m.ExtensionManagementError(`Cannot install '${D.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:L}}async getCompatibleVersion(r,s,c){const D=await this.getTargetPlatform();let y=null;return!s&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==c&&(y=(await this.galleryService.getExtensions([{...r.identifier,preRelease:c}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(r,c,D)&&(y=r),y||(s?y=(await this.galleryService.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(r,c,D)),y}async uninstallExtension(r,s){const c={...s,profileLocation:r.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation??this.getCurrentExtensionsManifestLocation()},D=Z=>`${Z.id.toLowerCase()}${c.versionOnly?`-${r.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,y=this.uninstallingExtensions.get(D(r.identifier));if(y)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),y.waitUntilTaskIsFinished();const P=Z=>{const ue=this.createUninstallExtensionTask(Z,c);return this.uninstallingExtensions.set(D(ue.extension.identifier),ue),c.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,c.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this._onUninstallExtension.fire({identifier:Z.identifier,profileLocation:c.profileLocation,applicationScoped:Z.isApplicationScoped}),ue},L=(Z,ue)=>{ue?c.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,c.profileLocation.toString(),ue.message):this.logService.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,ue.message):c.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,c.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),a(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(Z),error:ue}),this._onDidUninstallExtension.fire({identifier:Z.identifier,error:ue?.code,profileLocation:c.profileLocation,applicationScoped:Z.isApplicationScoped})},$=[],Q=[];try{$.push(P(r));const Z=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${r.identifier.id}@${r.manifest.version}`);else{const ue=this.getAllPackExtensionsToUninstall(r,Z);for(const te of ue)this.uninstallingExtensions.has(D(te.identifier))?this.logService.info("Extensions is already requested to uninstall",te.identifier.id):$.push(P(te))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${r.identifier.id}@${r.manifest.version}`):this.checkForDependents($.map(ue=>ue.extension),Z,r),await this.joinAllSettled($.map(async ue=>{try{if(await ue.run(),await this.joinAllSettled(this.participants.map(te=>te.postUninstall(ue.extension,c,k.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.galleryService.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}L(ue.extension)}catch(te){const ae=te instanceof m.ExtensionManagementError?te:new m.ExtensionManagementError((0,A.getErrorMessage)(te),m.ExtensionManagementErrorCode.Internal);throw L(ue.extension,ae),ae}finally{Q.push(ue)}}))}catch(Z){const ue=Z instanceof m.ExtensionManagementError?Z:new m.ExtensionManagementError((0,A.getErrorMessage)(Z),m.ExtensionManagementErrorCode.Internal);for(const te of $){try{te.cancel()}catch{}Q.includes(te)||L(te.extension,ue)}throw ue}finally{for(const Z of $)this.uninstallingExtensions.delete(D(Z.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}checkForDependents(r,s,c){for(const D of r){const y=this.getDependents(D,s);if(y.length){const P=y.filter(L=>!r.some($=>(0,d.areSameExtensions)($.identifier,L.identifier)));if(P.length)throw new Error(this.getDependentsErrorMessage(D,P,c))}}}getDependentsErrorMessage(r,s,c){return c===r?s.length===1?R.localize(6,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?R.localize(7,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):R.localize(8,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?R.localize(9,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?R.localize(10,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):R.localize(11,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(r,s,c=[]){if(c.indexOf(r)!==-1)return[];c.push(r);const D=r.manifest.extensionPack?r.manifest.extensionPack:[];if(D.length){const y=s.filter(L=>!L.isBuiltin&&D.some($=>(0,d.areSameExtensions)({id:$},L.identifier))),P=[];for(const L of y)P.push(...this.getAllPackExtensionsToUninstall(L,s,c));return[...y,...P]}return[]}getDependents(r,s){return s.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(D=>(0,d.areSameExtensions)({id:D},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=v,e.AbstractExtensionManagementService=v=ve([re(0,m.IExtensionGalleryService),re(1,f.ITelemetryService),re(2,h.IUriIdentityService),re(3,S.ILogService),re(4,p.IProductService),re(5,C.IUserDataProfilesService)],v);function b(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=b;function t(n){if(n instanceof m.ExtensionManagementError)return n;const r=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}e.toExtensionManagementError=t;function a(n,r,{extensionData:s,verificationStatus:c,duration:D,error:y,durationSinceUpdate:P}){let L,$;(0,l.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(L=m.ExtensionManagementErrorCode.Signature,$=c),c="Unverified")),y&&(y instanceof m.ExtensionManagementError?(L=y.code,y.code===m.ExtensionManagementErrorCode.Signature&&($=y.message)):L=m.ExtensionManagementErrorCode.Internal),n.publicLog(r,{...s,verificationStatus:c,success:!y,duration:D,errorcode:L,errorcodeDetail:$,durationSinceUpdate:P})}class i{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>new Promise((s,c)=>{const D=r.onCancellationRequested(()=>{D.dispose(),c(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[40],se([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class C extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=C,e.IExtensionsProfileScannerService=(0,R.createDecorator)("IExtensionsProfileScannerService");let v=class extends k.Disposable{constructor(i,n,r,s,c,D){super(),this.extensionsLocation=i,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=s,this.telemetryService=c,this.logService=D,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(i,n){return this.withProfileExtensions(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],s=[];try{return await this.withProfileExtensions(n,c=>{const D=[];for(const y of c)i.some(([P])=>(0,l.areSameExtensions)(P.identifier,y.identifier)&&P.manifest.version!==y.version)?r.push(y):D.push(y);for(const[y,P]of i){const L=D.findIndex(Q=>(0,l.areSameExtensions)(Q.identifier,y.identifier)&&Q.version===y.manifest.version),$={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:P};L===-1?(s.push($),D.push($)):D.splice(L,1,$)}return s.length&&this._onAddExtensions.fire({extensions:s,profileLocation:n}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),D}),s.length&&this._onDidAddExtensions.fire({extensions:s,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n}),s}catch(c){throw s.length&&this._onDidAddExtensions.fire({extensions:s,error:c,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:c,profileLocation:n}),c}}async updateMetadata(i,n){const r=[];return await this.withProfileExtensions(n,s=>{const c=[];for(const D of s){const y=i.find(([P])=>(0,l.areSameExtensions)(P.identifier,D.identifier)&&P.manifest.version===D.version);y&&(D.metadata={...D.metadata,...y[1]},r.push(D)),c.push(D)}return c}),r}async removeExtensionFromProfile(i,n){const r=[];try{await this.withProfileExtensions(n,s=>{const c=[];for(const D of s)(0,l.areSameExtensions)(D.identifier,i.identifier)?r.push(D):c.push(D);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),c}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(s){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:s,profileLocation:n}),s}}async withProfileExtensions(i,n,r){return this.getResourceAccessQueue(i).queue(async()=>{let s=[],c;try{const D=await this.fileService.readFile(i);c=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,w.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&r?.bailOutWhenFileNotFound)throw new C((0,p.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(i);let D=!1;for(const y of c){b(y)||this.reportAndThrowInvalidConentError(i);let P;if((0,S.isString)(y.relativeLocation)&&y.relativeLocation)P=this.resolveExtensionLocation(y.relativeLocation);else if((0,S.isString)(y.location))P=this.resolveExtensionLocation(y.location),D=!0,y.relativeLocation=y.location,y.location=P.toJSON();else{P=E.URI.revive(y.location);const L=this.toRelativePath(P);L&&(D=!0,y.relativeLocation=L)}s.push({identifier:y.identifier,location:P,version:y.version,metadata:y.metadata})}D&&await this.fileService.writeFile(i,O.VSBuffer.fromString(JSON.stringify(c)))}if(n){s=n(s);const D=s.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.toRelativePath(y.location),metadata:y.metadata}));await this.fileService.writeFile(i,O.VSBuffer.fromString(JSON.stringify(D)))}return s})}reportAndThrowInvalidConentError(i){const n=new C(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(i)).value.toString()}catch(c){if((0,w.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",i.toString());let s;try{const c=JSON.parse(r);Array.isArray(c)&&c.every(D=>b(D))?s=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(s)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,w.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(i)}catch(c){(0,w.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(n)}catch(c){(0,w.toFileOperationResult)(c)!==1&&this.logService.error(c)}return s})()),this._migrationPromise}getResourceAccessQueue(i){let n=this.resourcesAccessQueueMap.get(i);return n||(n=new N.Queue,this.resourcesAccessQueueMap.set(i,n)),n}};e.AbstractExtensionsProfileScannerService=v,e.AbstractExtensionsProfileScannerService=v=ve([re(1,w.IFileService),re(2,d.IUserDataProfilesService),re(3,I.IUriIdentityService),re(4,f.ITelemetryService),re(5,m.ILogService)],v);function b(a){return(0,S.isObject)(a)&&(0,u.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,S.isString)(a.location)&&a.location)&&((0,S.isUndefined)(a.relativeLocation)||(0,S.isString)(a.relativeLocation))&&a.version&&(0,S.isString)(a.version)}function t(a){return a?(0,S.isString)(a.path)&&(0,S.isString)(a.scheme):!1}}),define(ne[50],se([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C,v,b,t,a,i,n,r,s,c,D,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(ie){function W(B,V){if(B===V)return!0;const M=Object.keys(B),z=new Set;for(const K of Object.keys(V))z.add(K);if(M.length!==z.size)return!1;for(const K of M){if(B[K]!==V[K])return!1;z.delete(K)}return z.size===0}ie.equals=W})($||(e.Translations=$={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let Q=class extends l.Disposable{constructor(W,B,V,M,z,K,X,J,_,x,o,g){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=B,this.extensionsControlLocation=V,this.currentProfile=M,this.userDataProfilesService=z,this.extensionsProfileScannerService=K,this.fileService=X,this.logService=J,this.environmentService=_,this.productService=x,this.uriIdentityService=o,this.instantiationService=g,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ue,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,v.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,B,V){const[M,z]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(B)]),K=V?await this.scanExtensionsUnderDevelopment(W,[...M,...z]):[];return this.dedupExtensions(M,z,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const B=[];B.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),B.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[V,M]=await Promise.all(B);return this.applyScanOptions([...V,...M],0,W,!1)}async scanUserExtensions(W){const B=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",B);const V=this.uriIdentityService.extUri.isEqual(W.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput(B,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V),z=W.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let K;try{K=await z.scanExtensions(M)}catch(X){if(X instanceof D.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),K=await z.scanExtensions(M);else throw X}return K=await this.applyScanOptions(K,1,W,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(W,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===w.Schemas.file).map(async M=>{const z=await this.createExtensionScannerInput(M,!1,1,!0,W.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(X=>(X.type=B.find(J=>(0,v.areSameExtensions)(J.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,z)))}))).flat();return this.applyScanOptions(V,"development",W,!0)}return[]}async scanExistingExtension(W,B,V){const M=await this.createExtensionScannerInput(W,!1,B,!0,V.language,!0,void 0),z=await this.extensionsScanner.scanExtension(M);return!z||!V.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(W,B,V){const M=await this.createExtensionScannerInput(W,!1,B,!0,V.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions(z,B,V,!0)}async scanMetadata(W){const B=(0,d.joinPath)(W,"package.json"),V=(await this.fileService.readFile(B)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,B){const V=(0,d.joinPath)(W,"package.json"),M=(await this.fileService.readFile(V)).value.toString(),z=JSON.parse(M);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,z.__metadata={...z.__metadata,...B},await this.fileService.writeFile((0,d.joinPath)(W,"package.json"),A.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof D.ExtensionsProfileScanningError&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw W}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.extensionsProfileScannerService.addExtensionsToProfile(W.map(B=>[B,B.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,a.toFileOperationResult)(B)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(B))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.logService.error(W)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(W,B,V,M){return V.includeAllVersions||(W=this.dedupExtensions(B===0?W:void 0,B===1?W:void 0,B==="development"?W:void 0,await this.getTargetPlatform(),M)),V.includeInvalid||(W=W.filter(z=>z.isValid)),W.sort((z,K)=>{const X=R.basename(z.location.fsPath),J=R.basename(K.location.fsPath);return X<J?-1:X>J?1:0})}dedupExtensions(W,B,V,M,z){const K=(J,_,x)=>{if(J.isValid&&!_.isValid)return!1;if(J.isValid===_.isValid){if(z&&I.gt(J.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(I.eq(J.manifest.version,_.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===M)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return x?this.logService.warn(`Overwriting user extension ${J.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${_.location.path}.`),!0},X=new b.ExtensionIdentifierMap;return W?.forEach(J=>{const _=X.get(J.identifier.id);(!_||K(_,J,!1))&&X.set(J.identifier.id,J)}),B?.forEach(J=>{const _=X.get(J.identifier.id);if(!_&&W&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!_||K(_,J,!1))&&X.set(J.identifier.id,J)}),V?.forEach(J=>{const _=X.get(J.identifier.id);(!_||K(_,J,!0))&&X.set(J.identifier.id,J),X.set(J.identifier.id,J)}),[...X.values()]}async scanDefaultSystemExtensions(W,B){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),z=await(W&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(W,B){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=B?await this.getBuiltInExtensionControl():{},z=[],K=f.URI.file(R.normalize(R.join(w.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of V){const _=M[J.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":z.push((0,d.joinPath)(K,J.name));break;default:z.push(f.URI.file(_));break}}const X=await Promise.all(z.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,W,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,N.coalesce)(X)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,B,V,M,z,K,X){const J=await this.getTranslations(z??m.language),_=await this.getMtime(W),x=B&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,o=x?await this.getMtime(x):void 0;return new Z(W,_,x,o,B,X,V,M,K,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,J)}async getMtime(W){try{const B=await this.fileService.stat(W);if(typeof B.mtime=="number")return B.mtime}catch{}}};e.AbstractExtensionsScannerService=Q,e.AbstractExtensionsScannerService=Q=ve([re(4,y.IUserDataProfilesService),re(5,D.IExtensionsProfileScannerService),re(6,a.IFileService),re(7,n.ILogService),re(8,C.IEnvironmentService),re(9,r.IProductService),re(10,P.IUriIdentityService),re(11,i.IInstantiationService)],Q);class Z{constructor(W,B,V,M,z,K,X,J,_,x,o,g,F,U,H){this.location=W,this.mtime=B,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=M,this.profile=z,this.profileScanOptions=K,this.type=X,this.excludeObsolete=J,this.validate=_,this.productVersion=x,this.productDate=o,this.productCommit=g,this.devMode=F,this.language=U,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,B){return(0,d.isEqual)(W.location,B.location)&&W.mtime===B.mtime&&(0,d.isEqual)(W.applicationExtensionslocation,B.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&W.profile===B.profile&&k.equals(W.profileScanOptions,B.profileScanOptions)&&W.type===B.type&&W.excludeObsolete===B.excludeObsolete&&W.validate===B.validate&&W.productVersion===B.productVersion&&W.productDate===B.productDate&&W.productCommit===B.productCommit&&W.devMode===B.devMode&&W.language===B.language&&$.equals(W.translations,B.translations)}}e.ExtensionScannerInput=Z;let ue=class extends l.Disposable{constructor(W,B,V,M,z){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=B,this.uriIdentityService=V,this.fileService=M,this.logService=z}async scanExtensions(W){const B=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let V={};if(W.excludeObsolete&&W.type===1)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(M)}catch{}return(0,p.isEmptyObject)(V)?B:B.filter(M=>!V[v.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(W){const B=await this.fileService.resolve(W.location);if(!B.children?.length)return[];const V=await Promise.all(B.children.map(async M=>{if(!M.isDirectory||W.type===1&&(0,d.basename)(M.resource).indexOf(".")===0)return null;const z=new Z(M.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(z)}));return(0,N.coalesce)(V).sort((M,z)=>M.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(W){let B=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){B=B.filter(M=>!M.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,W);B.push(...V)}return B}async scanExtensionsFromProfileResource(W,B,V){const M=await this.extensionsProfileScannerService.scanProfileExtensions(W,V.profileScanOptions);if(!M.length)return[];const z=await Promise.all(M.map(async K=>{if(B(K)){const X=new Z(K.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X,K.metadata)}return null}));return(0,N.coalesce)(z)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,d.joinPath)(W.location,"package.json"))){const B=await this.scanExtension(W);return B?[B]:[]}else return await this.scanExtensions(W)}catch(B){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,T.getErrorMessage)(B)),[]}}async scanExtension(W,B){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=b.UNDEFINED_PUBLISHER),B=B??V.__metadata,delete V.__metadata;const M=(0,v.getGalleryExtensionId)(V.publisher,V.name),z=B?.id?{id:M,uuid:B.id}:{id:M},K=B?.isSystem?0:W.type,X=K===0||!!B?.isBuiltin;V=await this.translateManifest(W.location,V,Z.createNlsConfiguration(W));const J={type:K,identifier:z,manifest:V,location:W.location,isBuiltin:X,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return W.validate?this.validate(J,W):J}}catch(V){W.type!==0&&this.logService.error(V)}return null}validate(W,B){let V=!0;const M=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,W.manifest,W.isBuiltin);for(const[z,K]of M)z===S.default.Error&&(V=!1,this.logService.error(this.formatMessage(B.location,K)));return W.isValid=V,W.validations=M,W}async scanExtensionManifest(W){const B=(0,d.joinPath)(W,"package.json");let V;try{V=(await this.fileService.readFile(B)).value.toString()}catch(z){return(0,a.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(W,(0,h.localize)(0,null,B.path,z.message))),null}let M;try{M=JSON.parse(V)}catch{const K=[];(0,E.parse)(V,K);for(const X of K)this.logService.error(this.formatMessage(W,(0,h.localize)(1,null,B.path,X.offset,X.length,(0,u.getParseErrorMessage)(X.error))));return null}return(0,E.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(W,(0,h.localize)(2,null,B.path))),null):M}async translateManifest(W,B,V){const M=await this.getLocalizedMessages(W,B,V);if(M)try{const z=[],K=await this.resolveOriginalMessageBundle(M.default,z);if(z.length>0)return z.forEach(J=>{this.logService.error(this.formatMessage(W,(0,h.localize)(3,null,M.default?.path,(0,u.getParseErrorMessage)(J.error))))}),B;if((0,E.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(W,(0,h.localize)(4,null,M.default?.path))),B;const X=M.values||Object.create(null);return(0,L.localizeManifest)(this.logService,B,X,K)}catch{}return B}async getLocalizedMessages(W,B,V){const M=(0,d.joinPath)(W,"package.nls.json"),z=(_,x)=>{x.forEach(o=>{this.logService.error(this.formatMessage(W,(0,h.localize)(5,null,_?.path,(0,u.getParseErrorMessage)(o.error))))})},K=_=>{this.logService.error(this.formatMessage(W,(0,h.localize)(6,null,_?.path)))},X=`${B.publisher}.${B.name}`,J=V.translations[X];if(J)try{const _=f.URI.file(J),x=(await this.fileService.readFile(_)).value.toString(),o=[],g=(0,E.parse)(x,o);return o.length>0?(z(_,o),{values:void 0,default:M}):(0,E.getNodeType)(g)!=="object"?(K(_),{values:void 0,default:M}):{values:g.contents?g.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let x;try{x=await this.findMessageBundles(W,V)}catch{return}if(!x.localized)return{values:void 0,default:x.original};try{const o=(await this.fileService.readFile(x.localized)).value.toString(),g=[],F=(0,E.parse)(o,g);return g.length>0?(z(x.localized,g),{values:void 0,default:x.original}):(0,E.getNodeType)(F)!=="object"?(K(x.localized),{values:void 0,default:x.original}):{values:F,default:x.original}}catch{return{values:void 0,default:x.original}}}}async resolveOriginalMessageBundle(W,B){if(W)try{const V=(await this.fileService.readFile(W)).value.toString();return(0,E.parse)(V,B)}catch{}}findMessageBundles(W,B){return new Promise((V,M)=>{const z=K=>{const X=(0,d.joinPath)(W,`package.nls.${K}.json`);this.fileService.exists(X).then(J=>{J&&V({localized:X,original:(0,d.joinPath)(W,"package.nls.json")});const _=K.lastIndexOf("-");_===-1?V({localized:(0,d.joinPath)(W,"package.nls.json"),original:null}):(K=K.substring(0,_),z(K))})};if(B.devMode||B.pseudo||!B.language)return V({localized:(0,d.joinPath)(W,"package.nls.json"),original:null});z(B.language)})}formatMessage(W,B){return`[${W.path}]: ${B}`}};ue=ve([re(1,D.IExtensionsProfileScannerService),re(2,P.IUriIdentityService),re(3,a.IFileService),re(4,n.ILogService)],ue);let te=class extends ue{constructor(W,B,V,M,z,K,X){super(B,M,z,K,X),this.currentProfile=W,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const B=this.getCacheFile(W),V=await this.readExtensionCache(B);if(this.input=W,V&&V.input&&Z.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",W.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(z=>(z.location=f.URI.revive(z.location),z));const M=await super.scanExtensions(W);return await this.writeExtensionCache(B,{input:W,result:M}),M}async readExtensionCache(W){try{const B=await this.fileService.readFile(W),V=JSON.parse(B.value.toString());return{result:V.result,input:(0,c.revive)(V.input)}}catch(B){this.logService.debug("Error while reading the extension cache file:",W.path,(0,T.getErrorMessage)(B))}return null}async writeExtensionCache(W,B){try{await this.fileService.writeFile(W,A.VSBuffer.fromString(JSON.stringify(B)))}catch(V){this.logService.debug("Error while writing the extension cache file:",W.path,(0,T.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const W=this.getCacheFile(this.input),B=await this.readExtensionCache(W);if(!B)return;const V=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(M,V))try{this.logService.info("Invalidating Cache",V,M),await this.fileService.del(W),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}getCacheFile(W){const B=this.getProfile(W);return this.uriIdentityService.extUri.joinPath(B.cacheHome,W.type===0?b.BUILTIN_MANIFEST_CACHE_FILE:b.USER_MANIFEST_CACHE_FILE)}getProfile(W){return W.type===0?this.userDataProfilesService.defaultProfile:W.profile?this.uriIdentityService.extUri.isEqual(W.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(B=>this.uriIdentityService.extUri.isEqual(W.location,B.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};te=ve([re(2,y.IUserDataProfilesService),re(3,D.IExtensionsProfileScannerService),re(4,P.IUriIdentityService),re(5,a.IFileService),re(6,n.ILogService)],te);function ae(ie,W){const B=(0,v.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:B,identifier:new b.ExtensionIdentifier(B),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:W,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=ae;class ce extends Q{constructor(W,B,V,M,z,K,X,J,_,x,o,g){super(W,B,(0,d.joinPath)(V,".vscode-oss-dev","extensions","control.json"),M,z,K,X,J,_,x,o,g),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const F=await this.fileService.readFile(f.URI.file(m.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(ne[154],se([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,N,O,k,A,T,E,u,l,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(I,S){super(),this.userDataProfilesService=I,this.logService=S,this.processesLimiter=new O.Limiter(5)}async postUninstall(I){const S=this.parseScript(I,"uninstall");S&&(this.logService.info(I.identifier.id,I.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(S.script,"uninstall",S.args,!0,I),this.logService.info("Finished running post uninstall script",I.identifier.id,I.manifest.version)}catch(p){this.logService.error("Failed to run post uninstall script",I.identifier.id,I.manifest.version),this.logService.error(p)}}));try{await l.Promises.rm(this.getExtensionStoragePath(I))}catch(p){this.logService.error("Error while removing extension storage path",I.identifier.id),this.logService.error(p)}}parseScript(I,S){const p=`vscode:${S}`;if(I.location.scheme===E.Schemas.file&&I.manifest&&I.manifest.scripts&&typeof I.manifest.scripts[p]=="string"){const f=I.manifest.scripts[p].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(I.identifier.id,I.manifest.version,`${p} should be a node script`),null):{script:(0,u.join)(I.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(I,S,p,f,h){return new Promise((C,v)=>{const b=this.start(I,S,p,h);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?v(i):C(void 0)};b.on("error",i=>{a((0,k.toErrorMessage)(i)||"Unknown")}),b.on("exit",(i,n)=>{a(i?`post-${S} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,b.kill(),v("timed out")},5e3))})}start(I,S,p,f){const h={silent:!0,execArgv:void 0},C=(0,N.fork)(I,[`--type=extension-post-${S}`,...p],h);C.stdout.setEncoding("utf8"),C.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(C.stdout,"data"),b=A.Event.fromNodeEventEmitter(C.stderr,"data");v(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${S}`,i)),b(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${S}`,i));const t=A.Event.any(A.Event.map(v,i=>({data:`%c${i}`,format:[""]})),A.Event.map(b,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),C}getExtensionStoragePath(I){return(0,u.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,I.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m,e.ExtensionsLifecycle=m=ve([re(0,R.IUserDataProfilesService),re(1,w.ILogService)],m)}),define(ne[155],se([0,1,6,23,22,26,40,12,18,11]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let w=class extends T.AbstractExtensionsProfileScannerService{constructor(m,d,I,S,p,f){super(l.URI.file(m.extensionsPath),d,I,S,p,f)}};e.ExtensionsProfileScannerService=w,e.ExtensionsProfileScannerService=w=ve([re(0,u.INativeEnvironmentService),re(1,E.IFileService),re(2,O.IUserDataProfilesService),re(3,k.IUriIdentityService),re(4,A.ITelemetryService),re(5,N.ILogService)],w)}),define(ne[156],se([0,1,11,18,40,50,12,10,6,32,22,23]),function(G,e,N,O,k,A,T,E,u,l,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends A.NativeExtensionsScannerService{constructor(I,S,p,f,h,C,v,b){super(N.URI.file(h.builtinExtensionsPath),N.URI.file(h.extensionsPath),h.userHome,I.defaultProfile,I,S,p,f,h,C,v,b)}};e.ExtensionsScannerService=m,e.ExtensionsScannerService=m=ve([re(0,R.IUserDataProfilesService),re(1,k.IExtensionsProfileScannerService),re(2,T.IFileService),re(3,u.ILogService),re(4,O.INativeEnvironmentService),re(5,l.IProductService),re(6,w.IUriIdentityService),re(7,E.IInstantiationService)],m)}),define(ne[157],se([0,1,8,4,2,123,3,86,10,23]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var w;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var R;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(R||(e.StorageScope=R={}));var m;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(h){const C=h.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}e.loadKeyTargets=d;class I extends k.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(C={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super(),this.options=C,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new N.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(C,v,b){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===C&&(v===void 0||t.key===v),b)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,N.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,v){const{key:b,external:t}=v;if(b===e.TARGET_KEY){switch(C){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:C})}else this._onDidChangeValue.fire({scope:C,key:b,target:this.getKeyTargets(C)[b],external:t})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,v,b){return this.getStorage(v)?.get(C,b)}getBoolean(C,v,b){return this.getStorage(v)?.getBoolean(C,b)}getNumber(C,v,b){return this.getStorage(v)?.getNumber(C,b)}getObject(C,v,b){return this.getStorage(v)?.getObject(C,b)}storeAll(C,v){this.withPausedEmitters(()=>{for(const b of C)this.store(b.key,b.value,b.scope,b.target,v)})}store(C,v,b,t,a=!1){if((0,T.isUndefinedOrNull)(v)){this.remove(C,b,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(C,b,t),this.getStorage(b)?.set(C,v,a)})}remove(C,v,b=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(C,v,void 0),this.getStorage(v)?.delete(C,b)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,v){const b=[],t=this.getKeyTargets(C);for(const a of Object.keys(t))t[a]===v&&b.push(a);return b}updateKeyTarget(C,v,b,t=!1){const a=this.getKeyTargets(v);typeof b=="number"?a[C]!==b&&(a[C]=b,this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(a),t)):typeof a[C]=="number"&&(delete a[C],this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(a),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(C){switch(C){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(C){const v=this.getStorage(C);return v?d(v):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=w.NONE){this._onWillSaveState.fire({reason:C});const v=this.getStorage(-1),b=this.getStorage(0),t=this.getStorage(1);switch(C){case w.NONE:await N.Promises.settled([v?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await N.Promises.settled([v?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.getStorage(-1)?.items??new Map,v=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return f(C,v,b,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(C){return await this.flush(),this.getStorage(C)?.optimize()}async switch(C,v){return this.emitWillSaveState(w.NONE),(0,l.isUserDataProfile)(C)?this.switchToProfile(C,v):this.switchToWorkspace(C,v)}canSwitchProfile(C,v){return!(C.id===v.id||S(v)&&S(C))}switchData(C,v,b){this.withPausedEmitters(()=>{const t=new Set;for(const[a,i]of C)t.add(a),v.get(a)!==i&&this.emitDidChangeValue(b,{key:a,external:!0});for(const[a]of v.items)t.has(a)||this.emitDidChangeValue(b,{key:a,external:!0})})}}e.AbstractStorageService=I;function S(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=S;class p extends I{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(1,C))),this._register(this.profileStorage.onDidChangeStorage(C=>this.emitDidChangeValue(0,C))),this._register(this.applicationStorage.onDidChangeStorage(C=>this.emitDidChangeValue(-1,C)))}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(C){return!1}}e.InMemoryStorageService=p;async function f(h,C,v,b,t,a){const i=$=>{try{return JSON.parse($)}catch{return $}},n=new Map,r=new Map;h.forEach(($,Q)=>{n.set(Q,$),r.set(Q,i($))});const s=new Map,c=new Map;C.forEach(($,Q)=>{s.set(Q,$),c.set(Q,i($))});const D=new Map,y=new Map;v.forEach(($,Q)=>{D.set(Q,$),y.set(Q,i($))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const P=[];if(n.forEach(($,Q)=>{P.push({key:Q,value:$})}),console.table(P),console.groupEnd(),console.log(r),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const $=[];s.forEach((Q,Z)=>{$.push({key:Z,value:Q})}),console.table($),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${a})`);const L=[];D.forEach(($,Q)=>{L.push({key:Q,value:$})}),console.table(L),console.groupEnd(),console.log(y)}e.logStorage=f}),define(ne[158],se([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,R.getTargetPlatform)(A.platform,T.arch),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...o){return String(o.reduce((g,F)=>g|F,0))}var r;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class P{constructor(g=y){this.state=g}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(g,F=this.state.pageSize){return new P({...this.state,pageNumber:g,pageSize:F})}withFilter(g,...F){const U=[...this.state.criteria,...F.length?F.map(H=>({filterType:g,value:H})):[{filterType:g}]];return new P({...this.state,criteria:U})}withSortBy(g){return new P({...this.state,sortBy:g})}withSortOrder(g){return new P({...this.state,sortOrder:g})}withFlags(...g){return new P({...this.state,flags:g.reduce((F,U)=>F|U,0)})}withAssetTypes(...g){return new P({...this.state,assetTypes:g})}withSource(g){return new P({...this.state,source:g})}get raw(){const{criteria:g,pageNumber:F,pageSize:U,sortBy:H,sortOrder:q,flags:le,assetTypes:oe}=this.state;return{filters:[{criteria:g,pageNumber:F,pageSize:U,sortBy:H,sortOrder:q}],assetTypes:oe,flags:le}}get searchText(){const g=this.state.criteria.filter(F=>F.filterType===r.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(g=>String(g.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function L(o,g){const F=(o||[]).filter(U=>U.statisticName===g)[0];return F?F.value:0}function $(o){const g="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(U=>U.assetType.indexOf(g)===0).reduce((U,H)=>{const q=ue(o,H.assetType);return q&&U.push([H.assetType.substring(g.length),q]),U},[])}function Q(o){if(o.properties){const g=o.properties.filter(H=>H.key===s.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=g.filter(H=>F.test(H.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return ue(o,s.Repository)}function Z(o){return{uri:`${o.fallbackAssetUri}/${s.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${s.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,g){return o.files.filter(U=>U.assetType===g)[0]?{uri:`${o.assetUri}/${g}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${g}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,g){const F=o.properties?o.properties.filter(H=>H.key===g):[],U=F.length>0&&F[0].value;return U?U.split(",").map(H=>(0,m.adoptToGalleryExtensionId)(H)):[]}function ae(o){const g=o.properties?o.properties.filter(F=>F.key===c.Engine):[];return g.length>0&&g[0].value||""}function ce(o){const g=o.properties?o.properties.filter(F=>F.key===c.PreRelease):[];return g.length>0&&g[0].value==="true"}function ie(o){const g=o.properties?o.properties.filter(U=>U.key===c.LocalizedLanguages):[],F=g.length>0&&g[0].value||"";return F?F.split(","):[]}function W(o){return o.properties?.find(g=>g.key===c.SponsorLink)?.value}function B(o){return o.indexOf("preview")!==-1}function V(o){return o.targetPlatform?(0,R.toTargetPlatform)(o.targetPlatform):"undefined"}function M(o){const g=(0,N.distinct)(o.versions.map(V)),F=!!o.tags?.includes(R.WEB_EXTENSION_TAG),U=g.indexOf("web");return F?U===-1&&g.push("web"):U!==-1&&g.splice(U,1),g}function z(o,g){const F=(0,R.getFallbackTargetPlarforms)(g);for(let U=0;U<o.length;U++){const H=o[U];if(H.version===o[U-1]?.version){let q=U;const le=V(H);if(le===g)for(;q>0&&o[q-1].version===H.version;)q--;else if(F.includes(le))for(;q>0&&o[q-1].version===H.version&&V(o[q-1])!==g;)q--;q!==U&&(o.splice(U,1),o.splice(q,0,H))}}return o}e.sortExtensionVersions=z;function K(o,g,F){o.telemetryData={index:g,querySource:F,queryActivityId:o.queryContext?.[a]}}function X(o,g,F,U){const H=o.versions[0],q={manifest:ue(g,s.Manifest),readme:ue(g,s.Details),changelog:ue(g,s.Changelog),license:ue(g,s.License),repository:Q(g),download:Z(g),icon:ue(g,s.Icon),signature:ue(g,s.Signature),coreTranslations:$(g)};return{identifier:{id:(0,m.getGalleryExtensionId)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:g.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(H),description:o.shortDescription||"",installCount:L(o.statistics,"install"),rating:L(o.statistics,"averagerating"),ratingCount:L(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:F,assets:q,properties:{dependencies:te(g,c.Dependency),extensionPack:te(g,c.ExtensionPack),engine:ae(g),localizedLanguages:ie(g),targetPlatform:V(g),isPreReleaseVersion:ce(g)},hasPreReleaseVersion:ce(H),hasReleaseVersion:!0,preview:B(o.flags),isSigned:!!q.signature,queryContext:U}}let J=class{constructor(g,F,U,H,q,le,oe,me){this.requestService=F,this.logService=U,this.environmentService=H,this.telemetryService=q,this.fileService=le,this.productService=oe,this.configurationService=me;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?de.servicePPEUrl:de?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:de?.searchUrl,this.extensionsControlUrl=de?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(oe.version,oe,this.environmentService,this.configurationService,this.fileService,g,this.telemetryService)}api(g=""){return`${this.extensionsGalleryUrl}${g}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(g,F,U){const H=O.CancellationToken.isCancellationToken(F)?{}:F,q=O.CancellationToken.isCancellationToken(F)?F:U,le=[],oe=[],me=[],de=[];let ge=!0;for(const Se of g){Se.uuid?oe.push(Se.uuid):le.push(Se.id);const we=!!(Se.version||Se.preRelease);me.push({id:Se.id,uuid:Se.uuid,includePreRelease:we}),Se.version&&de.push({id:Se.id,uuid:Se.uuid,version:Se.version}),ge=ge&&!!Se.hasPreRelease&&!we}if(!oe.length&&!le.length)return[];let he=new P().withPage(1,g.length);oe.length&&(he=he.withFilter(r.ExtensionId,...oe)),le.length&&(he=he.withFilter(r.ExtensionName,...le)),(H.queryAllVersions||ge)&&(he=he.withFlags(he.flags,i.IncludeVersions)),H.source&&(he=he.withSource(H.source));const{extensions:fe}=await this.queryGalleryExtensions(he,{targetPlatform:H.targetPlatform??t,includePreRelease:me,versions:de,compatible:!!H.compatible},q);return H.source&&fe.forEach((Se,we)=>K(Se,we,H.source)),fe}async getCompatibleExtension(g,F,U){if((0,R.isNotWebExtensionInWebTargetPlatform)(g.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(g,F,U))return g;const H=new P().withFlags(i.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,g.identifier.uuid),{extensions:q}=await this.queryGalleryExtensions(H,{targetPlatform:U,compatible:!0,includePreRelease:F},O.CancellationToken.None);return q[0]||null}async isExtensionCompatible(g,F,U){if(!(0,R.isTargetPlatformCompatible)(g.properties.targetPlatform,g.allTargetPlatforms,U)||!F&&g.properties.isPreReleaseVersion)return!1;let H=g.properties.engine;if(!H){const q=await this.getManifest(g,O.CancellationToken.None);if(!q)throw new Error("Manifest was not found");H=q.engines.vscode}return(0,d.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(g,F,U,H,q){if(!(0,R.isTargetPlatformCompatible)(V(g),H,q)||F!=="any"&&ce(g)!==(F==="prerelease"))return!1;if(U)try{const le=await this.getEngine(g);if(!(0,d.isEngineValid)(le,this.productService.version,this.productService.date))return!1}catch(le){return this.logService.error(`Error while getting the engine for the version ${g.version}.`,(0,k.getErrorMessage)(le)),!1}return!0}async query(g,F){let U=g.text||"";const H=g.pageSize??50;let q=new P().withPage(1,H);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(q=q.withFilter(r.Category,fe||he),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(q=q.withFilter(r.Tag,fe||he),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(r.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),q=q.withFilter(r.SearchText,U)),q=q.withSortBy(0)):g.ids?q=q.withFilter(r.ExtensionId,...g.ids):g.names?q=q.withFilter(r.ExtensionName,...g.names):q=q.withSortBy(4),typeof g.sortBy=="number"&&(q=q.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(q=q.withSortOrder(g.sortOrder)),g.source&&(q=q.withSource(g.source));const le=async(ge,he)=>{const{extensions:fe,total:Se}=await this.queryGalleryExtensions(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!g.includePreRelease},he);return fe.forEach((we,be)=>K(we,(ge.pageNumber-1)*ge.pageSize+be,g.source)),{extensions:fe,total:Se}},{extensions:oe,total:me}=await le(q,F),de=async(ge,he)=>{if(he.isCancellationRequested)throw new k.CancellationError;const{extensions:fe}=await le(q.withPage(ge+1),he);return fe};return{firstPage:oe,total:me,pageSize:q.pageSize,getPage:de}}async queryGalleryExtensions(g,F,U){const H=g.flags;g.flags&i.IncludeLatestVersionOnly&&g.flags&i.IncludeVersions&&(g=g.withFlags(g.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(g.flags&i.IncludeLatestVersionOnly)&&!(g.flags&i.IncludeVersions)&&(g=g.withFlags(g.flags,i.IncludeLatestVersionOnly)),F.versions?.length&&(g=g.withFlags(g.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),g=g.withFlags(g.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:q,total:le,context:oe}=await this.queryRawGalleryExtensions(g,U);if(!(g.flags&i.IncludeLatestVersionOnly)){const he=[];for(const fe of q){const Se=await this.toGalleryExtensionWithCriteria(fe,F,oe);Se&&he.push(Se)}return{extensions:he,total:le}}const de=[],ge=new Map;for(let he=0;he<q.length;he++){const fe=q[he],Se={id:(0,m.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),uuid:fe.extensionId},we=(0,E.isBoolean)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,m.areSameExtensions)(Fe,Se))?.includePreRelease;if(F.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(M(fe),F.targetPlatform))continue;const be=await this.toGalleryExtensionWithCriteria(fe,F,oe);!be||be.properties.isPreReleaseVersion&&(!we||!be.hasReleaseVersion)||!be.properties.isPreReleaseVersion&&be.properties.targetPlatform!==F.targetPlatform&&be.hasPreReleaseVersion?ge.set(fe.extensionId,he):de.push([he,be])}if(ge.size){const he=new b.StopWatch,fe=new P().withFlags(H&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(r.ExtensionId,...ge.keys()),{extensions:Se}=await this.queryGalleryExtensions(fe,F,U);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:he.elapsed(),count:ge.size});for(const we of Se){const be=ge.get(we.identifier.uuid);de.push([be,we])}}return{extensions:de.sort((he,fe)=>he[0]-fe[0]).map(([,he])=>he),total:le}}async toGalleryExtensionWithCriteria(g,F,U){const H={id:(0,m.getGalleryExtensionId)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},q=F.versions?.find(de=>(0,m.areSameExtensions)(de,H))?.version,le=(0,E.isBoolean)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,m.areSameExtensions)(de,H))?.includePreRelease,oe=M(g),me=z(g.versions,F.targetPlatform);if(F.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(oe,F.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(q&&ge.version!==q)){if(await this.isValidVersion(ge,le?"any":"release",F.compatible,oe,F.targetPlatform))return X(g,ge,oe,U);if(q&&ge.version===q)return null}}return q||F.compatible?null:X(g,g.versions[0],oe)}async queryRawGalleryExtensions(g,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,i.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(i.Unpublished));const U=await this.commonHeadersPromise,H=JSON.stringify(g.raw),q={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},le=new b.StopWatch;let oe,me,de=0;try{if(oe=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&g.criteria.some(he=>he.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:q},F),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,f.asJson)(oe);if(ge){const he=ge.results[0],fe=he.extensions,Se=he.resultMetadata&&he.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return de=Se&&Se.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(H.length),duration:le.elapsed(),success:!!oe&&(0,f.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,k.isCancellationError)(me)?"canceled":(0,k.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,F,U,H){if(!this.isEnabled())return;const q=A.isWeb?this.api(`/itemName/${g}.${F}/version/${U}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${g}/extensions/${F}/${U}/stats?statType=${H}`),le=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:le};try{await this.requestService.request({type:"POST",url:q,headers:me},O.CancellationToken.None)}catch{}}async download(g,F,U){this.logService.trace("ExtensionGalleryService#download",g.identifier.id);const H=(0,m.getGalleryExtensionTelemetryData)(g),q=new Date().getTime(),le=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:he}),oe=U===2?"install":U===3?"update":"",me=oe?{uri:`${g.assets.download.uri}${u.URI.parse(g.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${g.assets.download.fallbackUri}${u.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:g.assets.download,de=g.queryContext?.[a]?{[a]:g.queryContext[a]}:void 0,ge=await this.getAsset(me,de?{headers:de}:void 0);await this.fileService.writeFile(F,ge.stream),le(new Date().getTime()-q)}async downloadSignatureArchive(g,F){if(!g.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const U=await this.getAsset(g.assets.signature);await this.fileService.writeFile(F,U.stream)}async getReadme(g,F){if(g.assets.readme){const U=await this.getAsset(g.assets.readme,{},F);return await(0,f.asTextOrError)(U)||""}return""}async getManifest(g,F){if(g.assets.manifest){const U=await this.getAsset(g.assets.manifest,{},F),H=await(0,f.asTextOrError)(U);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(g,F){const U=ue(g,s.Manifest);if(!U)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},q=await this.getAsset(U,{headers:H});return await(0,f.asJson)(q)}async getCoreTranslation(g,F){const U=g.assets.coreTranslations.filter(H=>H[0]===F.toUpperCase())[0];if(U){const H=await this.getAsset(U[1]),q=await(0,f.asTextOrError)(H);return q?JSON.parse(q):null}return null}async getChangelog(g,F){if(g.assets.changelog){const U=await this.getAsset(g.assets.changelog,{},F);return await(0,f.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(g,F,U){let H=new P().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?H=H.withFilter(r.ExtensionId,g.identifier.uuid):H=H.withFilter(r.ExtensionName,g.identifier.id);const{galleryExtensions:q}=await this.queryRawGalleryExtensions(H,O.CancellationToken.None);if(!q.length)return[];const le=M(q[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)(le,U))return[];const oe=[];await Promise.all(q[0].versions.map(async ge=>{try{await this.isValidVersion(ge,F?"any":"release",!0,le,U)&&oe.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of z(oe,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async getAsset(g,F={},U=O.CancellationToken.None){const H=await this.commonHeadersPromise,q={type:"GET"},le={...H,...F.headers||{}};F={...F,...q,headers:le};const oe=g.uri,me=g.fallbackUri,de={...F,url:oe};try{const ge=await this.requestService.request(de,U);if(ge.res.statusCode===200)return ge;const he=await(0,f.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${he}`)}catch(ge){if((0,k.isCancellationError)(ge))throw ge;const he=(0,k.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:he});const fe={...F,url:me};return this.requestService.request(fe,U)}}async getEngine(g){let F=ae(g);if(!F){const U=await this.getManifestFromRawExtensionVersion(g,O.CancellationToken.None);if(!U)throw new Error("Manifest was not found");F=U.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const g=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,f.asJson)(g),U=[],H={},q=[];if(F){for(const le of F.malicious)U.push({id:le});if(F.migrateToPreRelease)for(const[le,oe]of Object.entries(F.migrateToPreRelease))(!oe.engine||(0,d.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(H[le.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[le,oe]of Object.entries(F.deprecated))oe&&(H[le.toLowerCase()]=(0,E.isBoolean)(oe)?{}:oe);if(F.search)for(const le of F.search)q.push(le)}return{malicious:U,deprecated:H,search:q}}};J=ve([re(1,f.IRequestService),re(2,S.ILogService),re(3,w.IEnvironmentService),re(4,v.ITelemetryService),re(5,I.IFileService),re(6,p.IProductService),re(7,l.IConfigurationService)],J);let _=class extends J{constructor(g,F,U,H,q,le,oe,me){super(g,F,U,H,q,le,oe,me)}};e.ExtensionGalleryService=_,e.ExtensionGalleryService=_=ve([re(0,C.IStorageService),re(1,f.IRequestService),re(2,S.ILogService),re(3,w.IEnvironmentService),re(4,v.ITelemetryService),re(5,I.IFileService),re(6,p.IProductService),re(7,l.IConfigurationService)],_);let x=class extends J{constructor(g,F,U,H,q,le,oe){super(void 0,g,F,U,H,q,le,oe)}};e.ExtensionGalleryServiceWithNoStorageService=x,e.ExtensionGalleryServiceWithNoStorageService=x=ve([re(0,f.IRequestService),re(1,S.ILogService),re(2,w.IEnvironmentService),re(3,v.ITelemetryService),re(4,I.IFileService),re(5,p.IProductService),re(6,l.IConfigurationService)],x)}),define(ne[159],se([0,1,11,18,12,6,139,22,23,3,68]),function(G,e,N,O,k,A,T,E,u,l,w){"use strict";var R,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let d=class extends u.UserDataProfilesService{static{R=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(f,h,C,v,b){super(C,v,h,b),this.stateReadonlyService=f,this.nativeEnvironmentService=C}getStoredProfiles(){return this.stateReadonlyService.getItem(R.PROFILES_KEY,[]).map(h=>({...h,location:(0,l.isString)(h.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,h.location):N.URI.revive(h.location)}))}getStoredProfileAssociations(){const f=this.stateReadonlyService.getItem(R.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(R.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?f:this.migrateStoredProfileAssociations(f)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(N.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=d,e.UserDataProfilesReadonlyService=d=R=ve([re(0,T.IStateReadService),re(1,E.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,A.ILogService)],d);let I=m=class extends d{constructor(f,h,C,v,b){super(f,h,C,v,b),this.stateService=f}saveStoredProfiles(f){f.length?this.stateService.setItem(m.PROFILES_KEY,f.map(h=>({...h,location:this.uriIdentityService.extUri.basename(h.location)}))):this.stateService.removeItem(m.PROFILES_KEY)}getStoredProfiles(){const f=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(f),this.stateService.setItem("userDataProfilesMigration",!0)),f}saveStoredProfileAssociations(f){f.emptyWindows||f.workspaces?this.stateService.setItem(m.PROFILE_ASSOCIATIONS_KEY,f):this.stateService.removeItem(m.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",h=this.stateService.getItem(f,void 0);if(h){this.stateService.removeItem(f);const v=h.reduce((b,{workspace:t,profile:a})=>(b[N.URI.revive(t).toString()]=N.URI.revive(a).toString(),b),{});this.stateService.setItem(m.PROFILE_ASSOCIATIONS_KEY,{workspaces:v})}const C=super.getStoredProfileAssociations();return this.stateService.getItem(m.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(C),this.stateService.setItem(m.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),C}};e.UserDataProfilesService=I,e.UserDataProfilesService=I=m=ve([re(0,T.IStateService),re(1,E.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,A.ILogService)],I);let S=class extends I{constructor(f,h,C,v){super(new w.StateService(0,h,v,C),f,h,C,v)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=S,e.ServerUserDataProfilesService=S=ve([re(0,E.IUriIdentityService),re(1,O.INativeEnvironmentService),re(2,k.IFileService),re(3,A.ILogService)],S)}),define(ne[51],se([0,1,125,8,16,3,24,87,176,177]),function(G,e,N,O,k,A,T,E,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const w=new RegExp(e.CorruptZipMessage);class R extends Error{constructor(a,i){let n=i.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=i}}e.ExtractError=R;function m(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,n)=>i+n,a&61440)}function d(t){if(t instanceof R)return t;let a;return w.test(t.message)&&(a="CorruptZip"),new R(a,t)}function I(t,a,i,n,r,s){const c=k.dirname(a),D=k.join(n,c);if(!D.startsWith(n))return Promise.reject(new Error(E.localize(0,null,a)));const y=k.join(n,a);let P;return s.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(T.Promises.mkdir(D,{recursive:!0})).then(()=>new Promise((L,$)=>{if(!s.isCancellationRequested)try{P=(0,N.createWriteStream)(y,{mode:i}),P.once("close",()=>L()),P.once("error",$),t.once("error",$),t.pipe(P)}catch(Q){$(Q)}}))}function S(t,a,i,n){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;const c=n.onCancellationRequested(()=>{r.cancel(),t.close()});return new Promise((D,y)=>{const P=new O.Sequencer,L=$=>{$.isCancellationRequested||(s++,t.readEntry())};t.once("error",y),t.once("close",()=>r.then(()=>{n.isCancellationRequested||t.entryCount===s?D():y(new R("Incomplete",new Error(E.localize(1,null,s,t.entryCount))))},y)),t.readEntry(),t.on("entry",$=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test($.fileName)){L(n);return}const Q=$.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(Q)){const te=k.join(a,Q);r=(0,O.createCancelablePromise)(ae=>T.Promises.mkdir(te,{recursive:!0}).then(()=>L(ae)).then(void 0,y));return}const Z=f(t,$),ue=m($);r=(0,O.createCancelablePromise)(te=>P.queue(()=>Z.then(ae=>I(ae,Q,ue,a,i,te).then(()=>L(te)))).then(null,y))})}).finally(()=>c.dispose())}function p(t,a=!1){return new Promise((i,n)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(r,s)=>{r?n(d(r)):i((0,A.assertIsDefined)(s))})})}function f(t,a){return new Promise((i,n)=>{t.openReadStream(a,(r,s)=>{r?n(d(r)):i((0,A.assertIsDefined)(s))})})}function h(t,a){return new Promise((i,n)=>{const r=new l.ZipFile;a.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const s=(0,N.createWriteStream)(t);r.outputStream.pipe(s),r.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(t))})}e.zip=h;function C(t,a,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=p(t,!0);return i.overwrite&&(s=s.then(c=>T.Promises.rm(a).then(()=>c))),s.then(c=>S(c,a,{sourcePathRegex:r},n))}e.extract=C;function v(t,a){return p(t).then(i=>new Promise((n,r)=>{i.on("entry",s=>{s.fileName===a&&f(i,s).then(c=>n(c),c=>r(c))}),i.once("close",()=>r(new Error(E.localize(2,null,a))))}))}function b(t,a){return v(t,a).then(i=>new Promise((n,r)=>{const s=[];i.once("error",r),i.on("data",c=>s.push(c)),i.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=b}),define(ne[160],se([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class extends k.Disposable{static{C=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(t,a,i,n,r,s){super(),this.fileService=a,this.extensionGalleryService=i,this.configurationService=n,this.extensionSignatureVerificationService=r,this.logService=s,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,a,i){await this.cleanUpPromise;const n=(0,T.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,n,s=>this.extensionGalleryService.download(t,s,a))}catch(s){throw new I.ExtensionManagementError(s.message,I.ExtensionManagementErrorCode.Download)}let r=!1;if(i&&this.shouldVerifySignature(t)){const s=await this.downloadSignatureArchive(t);try{r=await this.extensionSignatureVerificationService.verify(n.fsPath,s.fsPath,this.logService.getLevel()===h.LogLevel.Trace)}catch(c){const D=c;if(r=D.code,D.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${D.output}`),r===I.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===I.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new I.ExtensionManagementError(R.CorruptZipMessage,I.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(s)}catch(c){this.logService.error(c)}}}return r===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${t.identifier.id}`),{location:n,verificationStatus:r}}shouldVerifySignature(t){if(!t.isSigned)return!1;const a=this.configurationService.getValue("extensions.verifySignature");return(0,u.isBoolean)(a)?a:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const a=(0,T.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${C.SignatureArchiveExtension}`);return await this.downloadFile(t,a,i=>this.extensionGalleryService.downloadSignatureArchive(t,i)),a}async downloadFile(t,a,i){if(await this.fileService.exists(a))return;if(a.scheme!==A.Schemas.file){await i(a);return}const n=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,l.generateUuid)()}`);await this.fileService.exists(n)||await i(n);try{await w.Promises.rename(n.fsPath,a.fsPath,2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],n=[];for(const c of t.children)if(c.name.endsWith(C.SignatureArchiveExtension))n.push(c.resource);else{const D=S.ExtensionKey.parse(c.name);D&&i.push([D,c])}const r=(0,S.groupByExtension)(i,([c])=>c),s=[];for(const c of r)c.sort((D,y)=>E.rcompare(D[0].version,y[0].version)),a.push(...c.slice(1).map(D=>D[1].resource)),s.push(c[0][1]);s.sort((c,D)=>c.mtime-D.mtime),a.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(c=>c.resource)),a.push(...n),await N.Promises.settled(a.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?S.ExtensionKey.create(t).toString().toLowerCase():(0,l.generateUuid)()}};e.ExtensionsDownloader=v,e.ExtensionsDownloader=v=C=ve([re(0,d.INativeEnvironmentService),re(1,f.IFileService),re(2,I.IExtensionGalleryService),re(3,m.IConfigurationService),re(4,p.IExtensionSignatureVerificationService),re(5,h.ILogService)],v)}),define(ne[161],se([0,1,51,97]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,N.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(ne[162],se([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C,v,b,t,a,i,n,r,s,c,D,y,P,L,$,Q,Z,ue,te,ae,ce,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,Z.refineServiceDecorator)(i.IExtensionManagementService);const W=".vsctmp";let B=class extends a.AbstractExtensionManagementService{constructor(_,x,o,g,F,U,H,q,le,oe,me,de){super(_,x,me,o,oe,de),this.extensionsScannerService=F,this.extensionsProfileScannerService=U,this.downloadService=H,this.fileService=le,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new w.ResourceSet;const ge=this._register(q.createInstance(D.ExtensionsLifecycle));this.extensionsScanner=this._register(q.createInstance(V,fe=>ge.postUninstall(fe))),this.manifestCache=this._register(new P.ExtensionsManifestCache(de,le,me,this,this.logService)),this.extensionsDownloader=this._register(q.createInstance(c.ExtensionsDownloader));const he=this._register(new L.ExtensionsWatcher(this,this.extensionsScannerService,de,U,me,le,o));this._register(he.onDidChangeExtensionsByAnotherSource(fe=>this.onDidChangeExtensionsFromAnotherSource(fe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const x=await this.collectFiles(_),o=await(0,C.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,x);return p.URI.file(o)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const{location:x,cleanup:o}=await this.downloadVsix(_),g=m.resolve(x.fsPath);try{return await(0,y.getManifest)(g)}finally{await o()}}getInstalled(_,x=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(_??null,x)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(_){return this.extensionsScanner.scanUserExtensionAtLocation(_)}async install(_,x={}){this.logService.trace("ExtensionManagementService#install",_.toString());const{location:o,cleanup:g}=await this.downloadVsix(_);try{const F=await(0,y.getManifest)(m.resolve(o.fsPath)),U=(0,n.getGalleryExtensionId)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,$.isEngineValid)(F.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,U,this.productService.version));const q=(await this.installExtensions([{manifest:F,extension:o,options:x}])).find(({identifier:le})=>(0,n.areSameExtensions)(le,{id:U}));if(q?.local)return q.local;throw q?.error?q.error:(0,a.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await g()}}async installFromLocation(_,x){this.logService.trace("ExtensionManagementService#installFromLocation",_.toString());const o=await this.extensionsScanner.scanUserExtensionAtLocation(_);if(!o)throw new Error(`Cannot find a valid extension from the location ${_.toString()}`);return await this.addExtensionsToProfile([[o,void 0]],x),this.logService.info("Successfully installed extension",o.identifier.id,x.toString()),o}async installExtensionsFromProfile(_,x,o){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",_,x.toString(),o.toString());const g=(await this.extensionsScanner.scanExtensions(1,x)).filter(F=>_.some(U=>(0,n.areSameExtensions)(U,F.identifier)));if(g.length){const F=await Promise.all(g.map(U=>this.extensionsScanner.scanMetadata(U,x)));await this.addExtensionsToProfile(g.map((U,H)=>[U,F[H]]),o),this.logService.info("Successfully installed extensions",g.map(U=>U.identifier.id),o.toString())}return g}async updateMetadata(_,x,o=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0),x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,x.pinned=x.pinned||void 0,_=await this.extensionsScanner.updateMetadata(_,x,o),this.manifestCache.invalidate(o),this._onDidUpdateExtensionMetadata.fire(_),_}async reinstallFromGallery(_){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",_.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(1,null));const x=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{..._.identifier,preRelease:_.preRelease}],{targetPlatform:x,compatible:!0},k.CancellationToken.None);if(!o)throw new Error(v.localize(2,null));await this.extensionsScanner.setUninstalled(_);try{await this.extensionsScanner.removeUninstalledExtension(_)}catch(g){throw new Error(v.localize(3,null,(0,A.toErrorMessage)(g)))}return this.installFromGallery(o)}copyExtension(_,x,o,g){return this.extensionsScanner.copyExtension(_,x,o,g)}copyExtensions(_,x){return this.extensionsScanner.copyExtensions(_,x)}markAsUninstalled(..._){return this.extensionsScanner.setUninstalled(..._)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(_){this.logService.error(_)}}async download(_,x,o){const{location:g}=await this.extensionsDownloader.download(_,x,!o);return g}async downloadVsix(_){if(_.scheme===R.Schemas.file)return{location:_,async cleanup(){}};this.logService.trace("Downloading extension from",_.toString());const x=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)());return await this.downloadService.download(_,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(g){this.logService.error(g)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(_,x,o){if(p.URI.isUri(x))return new K(_,x,o,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const g=n.ExtensionKey.create(x).toString();let F=this.installGalleryExtensionsTasks.get(g);return F||(this.installGalleryExtensionsTasks.set(g,F=new z(_,x,o,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),F.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(g))),F}createUninstallExtensionTask(_,x){return new X(_,x.profileLocation,this.extensionsProfileScannerService)}async collectFiles(_){const x=async g=>{let F=await h.Promises.readdir(g);F=F.map(q=>m.join(g,q));const U=await Promise.all(F.map(q=>h.Promises.stat(q)));let H=Promise.resolve([]);return U.forEach((q,le)=>{const oe=F[le];q.isFile()&&(H=H.then(me=>[...me,oe])),q.isDirectory()&&(H=H.then(me=>x(oe).then(de=>[...me,...de])))}),H};return(await x(_.location.fsPath)).map(g=>({path:`extension/${m.relative(_.location.fsPath,g)}`,localPath:g}))}async onDidChangeExtensionsFromAnotherSource({added:_,removed:x}){if(x){const o=_&&this.uriIdentityService.extUri.isEqual(x.profileLocation,_.profileLocation)?x.extensions.filter(g=>_.extensions.every(F=>!(0,n.areSameExtensions)(F,g))):x.extensions;for(const g of o)this.logService.info("Extensions removed from another source",g.id,x.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:g,profileLocation:x.profileLocation})}if(_){const g=(await this.extensionsScanner.scanExtensions(1,_.profileLocation)).filter(F=>_.extensions.some(U=>(0,n.areSameExtensions)(U,F.identifier)));this._onDidInstallExtensions.fire(g.map(F=>(this.logService.info("Extensions added from another source",F.identifier.id,_.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:_.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(x=>this.knownDirectories.add(x)));const _=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const x of _.children??[])x.isDirectory&&this.knownDirectories.add(x.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(x=>this.onDidFilesChange(x)))}async onDidFilesChange(_){if(!_.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const x=[];for(const o of _.rawAdded){if(this.knownDirectories.has(o)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(o),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(o,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(o).startsWith(".")||!(await this.fileService.stat(o)).isDirectory)continue;const g=await this.extensionsScanner.scanUserExtensionAtLocation(o);g&&g.installedTimestamp===void 0&&(this.knownDirectories.add(o),x.push(g))}x.length&&(await this.addExtensionsToProfile(x.map(o=>[o,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",x.map(o=>o.identifier.id)))}async addExtensionsToProfile(_,x){const o=_.map(g=>g[0]);await this.setInstalled(o),await this.extensionsProfileScannerService.addExtensionsToProfile(_,x),this._onDidInstallExtensions.fire(o.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:x})))}async setInstalled(_){const x=await this.extensionsScanner.getUninstalledExtensions();for(const o of _){const g=n.ExtensionKey.create(o);x[g.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",g.id),await this.extensionsScanner.setInstalled(g),this.logService.info("Removed the extension from uninstalled list:",g.id))}}};e.ExtensionManagementService=B,e.ExtensionManagementService=B=ve([re(0,i.IExtensionGalleryService),re(1,ae.ITelemetryService),re(2,ue.ILogService),re(3,t.INativeEnvironmentService),re(4,s.IExtensionsScannerService),re(5,r.IExtensionsProfileScannerService),re(6,b.IDownloadService),re(7,Z.IInstantiationService),re(8,Q.IFileService),re(9,te.IProductService),re(10,ce.IUriIdentityService),re(11,ie.IUserDataProfilesService)],B);let V=class extends l.Disposable{constructor(_,x,o,g,F,U){super(),this.beforeRemovingExtension=_,this.fileService=x,this.extensionsScannerService=o,this.extensionsProfileScannerService=g,this.uriIdentityService=F,this.logService=U,this._onExtract=this._register(new E.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new N.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(_,x){const o={includeInvalid:!0,profileLocation:x};let g=[];return _===null||_===0?g.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},o,!1)):_===1&&g.push(...await this.extensionsScannerService.scanUserExtensions(o)),g=_!==null?g.filter(F=>F.type===_):g,Promise.all(g.map(F=>this.toLocalExtension(F)))}async scanAllUserExtensions(_){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!_,includeInvalid:!0});return Promise.all(x.map(o=>this.toLocalExtension(o)))}async scanUserExtensionAtLocation(_){try{const x=await this.extensionsScannerService.scanExistingExtension(_,1,{includeInvalid:!0});if(x)return await this.toLocalExtension(x)}catch(x){this.logService.error(x)}return null}async extractUserExtension(_,x,o,g,F){const U=_.toString(),H=p.URI.file(m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`)),q=p.URI.file(m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let le=await this.fileService.exists(q);if(le&&g){try{await this.deleteExtensionFromLocation(_.id,q,"removeExisting")}catch{throw new i.ExtensionManagementError(v.localize(4,null,q.fsPath,_.id),i.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.logService.trace(`Started extracting the extension from ${x} to ${q.fsPath}`),await(0,C.extract)(x,H.fsPath,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${q}:`,_.id)}catch(oe){let me=i.ExtensionManagementErrorCode.Extract;throw oe instanceof C.ExtractError&&(oe.type==="CorruptZip"?me=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(me=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(oe.message,me)}await this.extensionsScannerService.updateMetadata(H,o);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${q.fsPath}`),await this.rename(H.fsPath,q.fsPath),this.logService.info("Renamed to",q.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",_.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(oe)}. Deleted from extracted location`,H),oe}this._onExtract.fire(q)}catch(oe){try{await this.fileService.del(H,{recursive:!0})}catch{}throw oe}return this.scanLocalExtension(q,1)}async scanMetadata(_,x){return x?(await this.getScannedExtension(_,x))?.metadata:this.extensionsScannerService.scanMetadata(_.location)}async getScannedExtension(_,x){return(await this.extensionsProfileScannerService.scanProfileExtensions(x)).find(g=>(0,n.areSameExtensions)(g.identifier,_.identifier))}async updateMetadata(_,x,o){return o?await this.extensionsProfileScannerService.updateMetadata([[_,x]],o):await this.extensionsScannerService.updateMetadata(_.location,x),this.scanLocalExtension(_.location,_.type,o)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(..._){const x=_.map(o=>n.ExtensionKey.create(o));await this.withUninstalledExtensions(o=>x.forEach(g=>{o[g.toString()]=!0,this.logService.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(_){await this.withUninstalledExtensions(x=>delete x[_.toString()])}async removeExtension(_,x){if(this.uriIdentityService.extUri.isEqualOrParent(_.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(_.identifier.id,_.location,x)}async removeUninstalledExtension(_){await this.removeExtension(_,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[n.ExtensionKey.create(_).toString()])}async copyExtension(_,x,o,g){const F=await this.getScannedExtension(_,x),U=await this.getScannedExtension(_,o);return g={...F?.metadata,...g},U?await this.extensionsProfileScannerService.updateMetadata([[_,{...U.metadata,...g}]],o):await this.extensionsProfileScannerService.addExtensionsToProfile([[_,g]],o),this.scanLocalExtension(_.location,_.type,o)}async copyExtensions(_,x){const o=await this.scanExtensions(1,_),g=await Promise.all(o.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,_)]));await this.extensionsProfileScannerService.addExtensionsToProfile(g,x)}async deleteExtensionFromLocation(_,x,o){this.logService.trace(`Deleting ${o} extension from disk`,_,x.fsPath);const g=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(x),`${this.uriIdentityService.extUri.basename(x)}.${(0,u.hash)((0,f.generateUuid)()).toString(16)}${W}`);await this.rename(x.fsPath,g.fsPath),await this.fileService.del(g,{recursive:!0}),this.logService.info(`Deleted ${o} extension from disk`,_,x.fsPath)}async withUninstalledExtensions(_){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(g){if((0,Q.toFileOperationResult)(g)!==1)throw g}let o={};if(x)try{o=JSON.parse(x)}catch{}return _&&(_(o),Object.keys(o).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(o))):await this.fileService.del(this.uninstalledResource)),o})}async rename(_,x){try{await h.Promises.rename(_,x,2*60*1e3)}catch(o){throw new i.ExtensionManagementError(o.message||v.localize(5,null,_,x),o.code||i.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(_,x,o){if(o){const F=(await this.extensionsScannerService.scanUserExtensions({profileLocation:o})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,_));if(F)return this.toLocalExtension(F)}else{const g=await this.extensionsScannerService.scanExistingExtension(_,x,{includeInvalid:!0});if(g)return this.toLocalExtension(g)}throw new Error(v.localize(6,null,_.path))}async toLocalExtension(_){const x=await this.fileService.resolve(_.location);let o,g;return x.children&&(o=x.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,g=x.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:_.identifier,type:_.type,isBuiltin:_.isBuiltin||!!_.metadata?.isBuiltin,location:_.location,manifest:_.manifest,targetPlatform:_.targetPlatform,validations:_.validations,isValid:_.isValid,readmeUrl:o,changelogUrl:g,publisherDisplayName:_.metadata?.publisherDisplayName||null,publisherId:_.metadata?.publisherId||null,isApplicationScoped:!!_.metadata?.isApplicationScoped,isMachineScoped:!!_.metadata?.isMachineScoped,isPreReleaseVersion:!!_.metadata?.isPreReleaseVersion,preRelease:!!_.metadata?.preRelease,installedTimestamp:_.metadata?.installedTimestamp,updated:!!_.metadata?.updated,pinned:!!_.metadata?.pinned}}async removeUninstalledExtensions(){const _=await this.getUninstalledExtensions();if(Object.keys(_).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(_));const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const F of x)_[n.ExtensionKey.create(F).toString()]||o.add(F.identifier.id.toLowerCase());try{const F=(0,n.groupByExtension)(x,U=>U.identifier);await N.Promises.settled(F.map(async U=>{const H=U.sort((q,le)=>I.rcompare(q.manifest.version,le.manifest.version))[0];o.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(F){this.logService.error(F)}const g=x.filter(F=>F.metadata&&_[n.ExtensionKey.create(F).toString()]);await Promise.allSettled(g.map(F=>this.removeUninstalledExtension(F)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let _;try{_=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(x){(0,Q.toFileOperationResult)(x)!==1&&this.logService.error(x);return}if(_?.children)try{await Promise.allSettled(_.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(W))){this.logService.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.fileService.del(x.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(o){(0,Q.toFileOperationResult)(o)!==1&&this.logService.error(o)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=ve([re(1,Q.IFileService),re(2,s.IExtensionsScannerService),re(3,r.IExtensionsProfileScannerService),re(4,ce.IUriIdentityService),re(5,ue.ILogService)],V);class M extends a.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,S.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(_,x,o,g,F,U,H,q,le){super(),this.identifier=_,this.source=x,this.options=o,this.extensionsScanner=g,this.uriIdentityService=F,this.userDataProfilesService=U,this.extensionsScannerService=H,this.extensionsProfileScannerService=q,this.logService=le,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(_){const[x,o]=await this.install(_);return this._profileLocation=x.isBuiltin||x.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[x,o]],this._profileLocation),x}async extractExtension({zipPath:_,key:x,metadata:o},g,F){let U=await this.unsetIfUninstalled(x);return U||(this.logService.trace("Extracting extension...",x.id),U=await this.extensionsScanner.extractUserExtension(x,_,o,g,F),this.logService.info("Extracting extension completed.",x.id)),U}async unsetIfUninstalled(_){return await this.isUninstalled(_)?(this.logService.trace("Removing the extension from uninstalled list:",_.id),await this.extensionsScanner.setInstalled(_),this.logService.info("Removed the extension from uninstalled list:",_.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(g=>n.ExtensionKey.create(g).equals(_))):void 0}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.toString()]}}class z extends M{constructor(_,x,o,g,F,U,H,q,le,oe){super(x.identifier,x,o,F,U,H,q,le,oe),this.gallery=x,this.extensionsDownloader=g}async install(_){const o=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.gallery.identifier));o&&(this._operation=3);const g={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,S.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(o,g),g];const{location:F,verificationStatus:U}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=U,this.validateManifest(F.fsPath),[await this.extractExtension({zipPath:F.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:g},!1,_),g]}catch(H){try{await this.extensionsDownloader.delete(F)}catch(q){this.logService.warn("Error while deleting the downloaded file",F.toString(),(0,T.getErrorMessage)(q))}throw H}}async validateManifest(_){try{await(0,y.getManifest)(_)}catch(x){throw new i.ExtensionManagementError((0,a.joinErrors)(x).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=z;class K extends M{constructor(_,x,o,g,F,U,H,q,le,oe){super({id:(0,n.getGalleryExtensionId)(_.publisher,_.name)},x,o,F,U,H,q,le,oe),this.manifest=_,this.location=x,this.galleryService=g}async doRun(_){const x=await super.doRun(_);return this.updateMetadata(x,_),x}async install(_){const x=new n.ExtensionKey(this.identifier,this.manifest.version),g=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this._operation=3,x.equals(new n.ExtensionKey(g.identifier,g.manifest.version)))try{await this.extensionsScanner.removeExtension(g,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(g.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(g);else{const H=await this.unsetIfUninstalled(x);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(v.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:m.resolve(this.location.fsPath),key:x,metadata:F},!0,_),F]}async updateMetadata(_,x){try{let[o]=await this.galleryService.getExtensions([{id:_.identifier.id,version:_.manifest.version}],x);if(o||([o]=await this.galleryService.getExtensions([{id:_.identifier.id}],x)),o){const g={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(_,g,this.options.profileLocation)}}catch{}}}class X extends a.AbstractExtensionTask{constructor(_,x,o){super(),this.extension=_,this.profileLocation=x,this.extensionsProfileScannerService=o}async doRun(_){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ne[163],se([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let I=class extends R.AbstractRequestService{constructor(h,C,v,b){super(b),this.configurationService=h,this.environmentService=C,this.logService=v,this.configure(),this._register(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const h=this.configurationService.getValue("http");this.proxyUrl=h?.proxy,this.strictSSL=!!h?.proxyStrictSSL,this.authorization=h?.proxyAuthorization}async request(h,C){const{proxyUrl:v,strictSSL:b}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(n)))}const a={...process.env,...t},i=h.agent?h.agent:await(0,m.getProxyAgent)(h.url||"",a,{proxyUrl:v,strictSSL:b});return h.agent=i,h.strictSSL=b,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(h.isChromiumNetwork?"electron":"node",h,()=>p(h,C))}async resolveProxy(h){}};e.RequestService=I,e.RequestService=I=ve([re(0,E.IConfigurationService),re(1,u.INativeEnvironmentService),re(2,w.ILogService),re(3,w.ILoggerService)],I);async function S(f){return((0,N.parse)(f.url).protocol==="https:"?await new Promise((v,b)=>{G(["https"],v,b)}):await new Promise((v,b)=>{G(["http"],v,b)})).request}async function p(f,h){return O.Promises.withAsyncBody(async(C,v)=>{const b=(0,N.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await S(f),a={hostname:b.hostname,port:b.port?parseInt(b.port):b.protocol==="https:"?443:80,protocol:b.protocol,path:b.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,T.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(a.auth=f.user+":"+f.password);const i=t(a,n=>{const r=(0,T.isNumber)(f.followRedirects)?f.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)p({...f,url:n.headers.location,followRedirects:r-1},h).then(C,v);else{let s=n;!f.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,d.createGunzip)())),C({res:n,stream:(0,k.streamToBufferReadableStream)(s)})}});i.on("error",v),f.timeout&&i.setTimeout(f.timeout),f.isChromiumNetwork&&i.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&i.write(f.data),i.end(),h.onCancellationRequested(()=>{i.abort(),v(new A.CancellationError)})})}e.nodeRequest=p}),define(ne[179],se([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(G,e,N,O,k,A,T,E,u,l,w,R,m,d,I,S,p,f,h,C,v,b,t,a,i,n,r,s,c,D,y,P,L,$,Q,Z,ue,te,ae,ce,ie,W,B,V,M,z,K,X,J,_,x,o,g,F,U,H,q,le,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends T.Disposable{constructor(fe){super(),this.argv=fe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[fe,Se]=await this.initServices();return fe.invokeFunction(async we=>{const be=we.get(Z.ILogService),Fe=we.get(s.IFileService),j=we.get(f.INativeEnvironmentService),Y=we.get(g.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(j,Fe,Y,fe),await Promise.all(Se.map(ee=>{(0,O.raceTimeout)(ee.flush(),1e3)}))})}async initServices(){const fe=new L.ServiceCollection,Se={_serviceBrand:void 0,...ce.default};fe.set(ie.IProductService,Se);const we=new h.NativeEnvironmentService(this.argv,Se);fe.set(f.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.with({scheme:E.Schemas.file}).fsPath,we.extensionsPath].map(Oe=>Oe?m.Promises.mkdir(Oe,{recursive:!0}):void 0));const be=new le.LoggerService((0,Z.getLogLevel)(we),we.logsHome);fe.set(Z.ILoggerService,be);const Fe=this._register(be.createLogger("cli",{name:(0,oe.localize)(0,null)})),j=[];be.getLogLevel()===Z.LogLevel.Trace&&j.push(new Z.ConsoleLogger(be.getLogLevel()));const Y=this._register(new q.LogService(Fe,j));fe.set(Z.ILogService,Y);const ee=this._register(new c.FileService(Y));fe.set(s.IFileService,ee);const pe=this._register(new D.DiskFileSystemProvider(Y));ee.registerProvider(E.Schemas.file,pe);const ye=new o.UriIdentityService(ee);fe.set(x.IUriIdentityService,ye);const Le=new V.StateReadonlyService(1,we,Y,ee),Ie=new F.UserDataProfilesReadonlyService(Le,ye,we,ee,Y);fe.set(g.IUserDataProfilesService,Ie),ee.registerProvider(E.Schemas.vscodeUserData,new me.FileUserDataProvider(E.Schemas.file,pe,E.Schemas.vscodeUserData,Ie,ye,Y));const Ne=l.isWindows&&Se.win32RegValueName?this._register(new ae.NativePolicyService(Y,Se.win32RegValueName)):we.policyFile?this._register(new ue.FilePolicyService(we.policyFile,ee,Y)):new te.NullPolicyService;fe.set(te.IPolicyService,Ne);const Ce=this._register(new I.ConfigurationService(Ie.defaultProfile.settingsResource,ee,Ne,Y));fe.set(d.IConfigurationService,Ce),await Promise.all([Le.init(),Ce.initialize()]);let Ae;try{Ae=await(0,U.resolveMachineId)(Le,Y)}catch(Oe){Oe.code!=="ENOENT"&&Y.error(Oe)}Ie.init(),fe.set(x.IUriIdentityService,new o.UriIdentityService(ee));const _e=new B.RequestService(Ce,we,Y,be);fe.set(W.IRequestService,_e),fe.set(S.IDownloadService,new y.SyncDescriptor(p.DownloadService,void 0,!0)),fe.set(a.IExtensionsProfileScannerService,new y.SyncDescriptor(H.ExtensionsProfileScannerService,void 0,!0)),fe.set(i.IExtensionsScannerService,new y.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),fe.set(b.IExtensionSignatureVerificationService,new y.SyncDescriptor(b.ExtensionSignatureVerificationService,void 0,!0)),fe.set(n.INativeServerExtensionManagementService,new y.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),fe.set(v.IExtensionGalleryService,new y.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),fe.set($.ILanguagePackService,new y.SyncDescriptor(Q.NativeLanguagePackService,void 0,!1));const Re=[],Te=(0,X.isInternalTelemetry)(Se,Ce);if((0,X.supportsTelemetry)(Se,we)){Se.aiConfig&&Se.aiConfig.ariaKey&&Re.push(new J.OneDataSystemAppender(_e,Te,"monacoworkbench",null,Se.aiConfig.ariaKey));const Oe={appenders:Re,sendErrorTelemetry:!1,commonProperties:(0,M.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,Se.commit,Se.version,Ae,Te),piiPaths:(0,X.getPiiPathsFromEnvironment)(we)};fe.set(z.ITelemetryService,new y.SyncDescriptor(K.TelemetryService,[Oe],!1))}else fe.set(z.ITelemetryService,X.NullTelemetryService);return[new P.InstantiationService(fe),Re]}registerErrorHandler(fe){(0,A.setUnexpectedErrorHandler)(Se=>{const we=(0,k.toErrorMessage)(Se,!0);we&&fe.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",Se=>{(0,A.isSigPipeError)(Se)||(0,A.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,A.onUnexpectedError)(Se))}async doRun(fe,Se,we,be){let Fe;if(fe.args.profile&&(Fe=we.profiles.find(Y=>Y.name===fe.args.profile),!Fe))throw new Error(`Profile '${fe.args.profile}' not found.`);const j=(Fe??we.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return be.createInstance(t.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,j);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Y={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:j};return be.createInstance(t.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),Y,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(t.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,j);if(this.argv["locate-extension"])return be.createInstance(t.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,_.buildTelemetryMessage)(fe.appRoot,fe.extensionsPath))}}asExtensionIdOrVSIX(fe){return fe.map(Se=>/\.vsix$/i.test(Se)?R.URI.file((0,u.isAbsolute)(Se)?Se:(0,u.join)((0,w.cwd)(),Se)):Se)}}async function ge(he){const fe=new de(he);try{await fe.run()}finally{fe.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/code/node/cliProcessMain.js.map
