/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],k=0,O=te.length;k<O;k++)e[k]=oe[te[k]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class k{static get(){const A=new Map,U=new Map,_=new Map,L=new Map;function I(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function f(c,g){const y=c.get(g.detail);y&&(y>=0||c.set(g.detail,y+g.timestamp))}let D=[];typeof te=="function"&&typeof te.getStats=="function"&&(D=te.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of D)switch(c.type){case 10:I(A,c);break;case 11:case 12:f(A,c);break;case 21:I(U,c);break;case 22:f(U,c);break;case 33:I(_,c);break;case 34:f(_,c);break;case 31:I(L,c);break;case 32:f(L,c);break}let C=0;_.forEach(c=>C+=c);function S(c){const g=[];return c.forEach((y,m)=>g.push([m,y])),g}return{amdLoad:S(A),amdInvoke:S(U),nodeRequire:S(_),nodeEval:S(L),nodeRequireTotal:C}}static toMarkdownTable(A,U){let _="";const L=[];return A.forEach((I,f)=>{L[f]=I.length}),U.forEach(I=>{I.forEach((f,D)=>{typeof f>"u"&&(f=I[D]="-");const C=f.toString().length;L[D]=Math.max(C,L[D])})}),A.forEach((I,f)=>{_+=`| ${I+" ".repeat(L[f]-I.toString().length)} `}),_+=`|
`,A.forEach((I,f)=>{_+=`| ${"-".repeat(L[f])} `}),_+=`|
`,U.forEach(I=>{I.forEach((f,D)=>{typeof f<"u"&&(_+=`| ${f+" ".repeat(L[D]-f.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=k}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function k(y,m,h){const l=O(y,m);if(l!==-1)return y[l]}e.findLast=k;function O(y,m,h=y.length-1){for(let l=h;l>=0;l--){const u=y[l];if(m(u))return l}return-1}e.findLastIdx=O;function A(y,m){const h=U(y,m);return h===-1?void 0:y[h]}e.findLastMonotonous=A;function U(y,m,h=0,l=y.length){let u=h,p=l;for(;u<p;){const b=Math.floor((u+p)/2);m(y[b])?u=b+1:p=b}return u-1}e.findLastIdxMonotonous=U;function _(y,m){const h=L(y,m);return h===y.length?void 0:y[h]}e.findFirstMonotonous=_;function L(y,m,h=0,l=y.length){let u=h,p=l;for(;u<p;){const b=Math.floor((u+p)/2);m(y[b])?p=b:u=b+1}return u}e.findFirstIdxMonotonousOrArrLen=L;function I(y,m,h=0,l=y.length){const u=L(y,m,h,l);return u===y.length?-1:u}e.findFirstIdxMonotonous=I;class f{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(f.assertInvariants){if(this._prevFindLastPredicate){for(const l of this._array)if(this._prevFindLastPredicate(l)&&!m(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const h=U(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=h+1,h===-1?void 0:this._array[h]}}e.MonotonousArray=f;function D(y,m){if(y.length===0)return;let h=y[0];for(let l=1;l<y.length;l++){const u=y[l];m(u,h)>0&&(h=u)}return h}e.findFirstMaxBy=D;function C(y,m){if(y.length===0)return;let h=y[0];for(let l=1;l<y.length;l++){const u=y[l];m(u,h)>=0&&(h=u)}return h}e.findLastMaxBy=C;function S(y,m){return D(y,(h,l)=>-m(h,l))}e.findFirstMinBy=S;function c(y,m){if(y.length===0)return-1;let h=0;for(let l=1;l<y.length;l++){const u=y[l];m(u,y[h])>0&&(h=l)}return h}e.findMaxIdxBy=c;function g(y,m){for(const h of y){const l=m(h);if(l!==void 0)return l}}e.mapFindFirst=g}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function k(_,L){const I=Object.create(null);for(const f of _){const D=L(f);let C=I[D];C||(C=I[D]=[]),C.push(f)}return I}e.groupBy=k;function O(_,L){const I=[],f=[];for(const D of _)L.has(D)||I.push(D);for(const D of L)_.has(D)||f.push(D);return{removed:I,added:f}}e.diffSets=O;function A(_,L){const I=[],f=[];for(const[D,C]of _)L.has(D)||I.push(C);for(const[D,C]of L)_.has(D)||f.push(C);return{removed:I,added:f}}e.diffMaps=A;function U(_,L){const I=new Set;for(const f of L)_.has(f)&&I.add(f);return I}e.intersection=U}),define(oe[83],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(_){return(L,I,f)=>{let D=null,C=null;if(typeof f.value=="function"?(D="value",C=f.value):typeof f.get=="function"&&(D="get",C=f.get),!C)throw new Error("not supported");f[D]=_(C,I)}}function O(_,L,I){let f=null,D=null;if(typeof I.value=="function"?(f="value",D=I.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(f="get",D=I.get),!D)throw new Error("not supported");const C=`$memoize$${L}`;I[f]=function(...S){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,S)}),this[C]}}e.memoize=O;function A(_,L,I){return k((f,D)=>{const C=`$debounce$${D}`,S=`$debounce$result$${D}`;return function(...c){this[S]||(this[S]=I?I():void 0),clearTimeout(this[C]),L&&(this[S]=L(this[S],...c),c=[this[S]]),this[C]=setTimeout(()=>{f.apply(this,c),this[S]=I?I():void 0},_)}})}e.debounce=A;function U(_,L,I){return k((f,D)=>{const C=`$throttle$timer$${D}`,S=`$throttle$result$${D}`,c=`$throttle$lastRun$${D}`,g=`$throttle$pending$${D}`;return function(...y){if(this[S]||(this[S]=I?I():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),L&&(this[S]=L(this[S],...y)),this[g])return;const m=this[c]+_;m<=Date.now()?(this[c]=Date.now(),f.apply(this,[this[S]]),this[S]=I?I():void 0):(this[g]=!0,this[C]=setTimeout(()=>{this[g]=!1,this[c]=Date.now(),f.apply(this,[this[S]]),this[S]=I?I():void 0},m-Date.now()))}})}e.throttle=U}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?u.isErrorNoTelemetry(t)?new u(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(a=>{a(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=k,e.errorHandler=new k;function O(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=O;function A(b){if(!b||typeof b!="object")return!1;const t=b;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=A;function U(b){f(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=U;function _(b){f(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=_;function L(b){if(b instanceof Error){const{name:t,message:a}=b,n=b.stacktrace||b.stack;return{$isError:!0,name:t,message:a,stack:n,noTelemetry:u.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=L;const I="Canceled";function f(b){return b instanceof D?!0:b instanceof Error&&b.name===I&&b.message===I}e.isCancellationError=f;class D extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=D;function C(){const b=new Error(I);return b.name=b.message,b}e.canceled=C;function S(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=S;function c(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=c;class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=g;function y(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=y;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=m;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=h;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=l;class u extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof u)return t;const a=new u;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class p extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.BugIndicatingError=p}),define(oe[18],ae([0,1,8,125]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(F,H=0){return F[F.length-(1+H)]}e.tail=A;function U(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=U;function _(F,H,Y=(se,le)=>se===le){if(F===H)return!0;if(!F||!H||F.length!==H.length)return!1;for(let se=0,le=F.length;se<le;se++)if(!Y(F[se],H[se]))return!1;return!0}e.equals=_;function L(F,H){const Y=F.length-1;H<Y&&(F[H]=F[Y]),F.pop()}e.removeFastWithoutKeepingOrder=L;function I(F,H,Y){return f(F.length,se=>Y(F[se],H))}e.binarySearch=I;function f(F,H){let Y=0,se=F-1;for(;Y<=se;){const le=(Y+se)/2|0,he=H(le);if(he<0)Y=le+1;else if(he>0)se=le-1;else return le}return-(Y+1)}e.binarySearch2=f;function D(F,H,Y){if(F=F|0,F>=H.length)throw new TypeError("invalid index");const se=H[Math.floor(H.length*Math.random())],le=[],he=[],ue=[];for(const me of H){const fe=Y(me,se);fe<0?le.push(me):fe>0?he.push(me):ue.push(me)}return F<le.length?D(F,le,Y):F<le.length+ue.length?ue[0]:D(F-(le.length+ue.length),he,Y)}e.quickSelect=D;function C(F,H){const Y=[];let se;for(const le of F.slice(0).sort(H))!se||H(se[0],le)!==0?(se=[le],Y.push(se)):se.push(le);return Y}e.groupBy=C;function*S(F,H){let Y,se;for(const le of F)se!==void 0&&H(se,le)?Y.push(le):(Y&&(yield Y),Y=[le]),se=le;Y&&(yield Y)}e.groupAdjacentBy=S;function c(F,H){for(let Y=0;Y<=F.length;Y++)H(Y===0?void 0:F[Y-1],Y===F.length?void 0:F[Y])}e.forEachAdjacent=c;function g(F,H){for(let Y=0;Y<F.length;Y++)H(Y===0?void 0:F[Y-1],F[Y],Y+1===F.length?void 0:F[Y+1])}e.forEachWithNeighbors=g;function y(F,H,Y){const se=[];function le(me,fe,pe){if(fe===0&&pe.length===0)return;const Ce=se[se.length-1];Ce&&Ce.start+Ce.deleteCount===me?(Ce.deleteCount+=fe,Ce.toInsert.push(...pe)):se.push({start:me,deleteCount:fe,toInsert:pe})}let he=0,ue=0;for(;;){if(he===F.length){le(he,0,H.slice(ue));break}if(ue===H.length){le(he,F.length-he,[]);break}const me=F[he],fe=H[ue],pe=Y(me,fe);pe===0?(he+=1,ue+=1):pe<0?(le(he,1,[]),he+=1):pe>0&&(le(he,0,[fe]),ue+=1)}return se}e.sortedDiff=y;function m(F,H,Y){const se=y(F,H,Y),le=[],he=[];for(const ue of se)le.push(...F.slice(ue.start,ue.start+ue.deleteCount)),he.push(...ue.toInsert);return{removed:le,added:he}}e.delta=m;function h(F,H,Y){if(Y===0)return[];const se=F.slice(0,Y).sort(H);return u(F,H,se,Y,F.length),se}e.top=h;function l(F,H,Y,se,le){return Y===0?Promise.resolve([]):new Promise((he,ue)=>{(async()=>{const me=F.length,fe=F.slice(0,Y).sort(H);for(let pe=Y,Ce=Math.min(Y+se,me);pe<me;pe=Ce,Ce=Math.min(Ce+se,me)){if(pe>Y&&await new Promise(Le=>setTimeout(Le)),le&&le.isCancellationRequested)throw new k.CancellationError;u(F,H,fe,pe,Ce)}return fe})().then(he,ue)})}e.topAsync=l;function u(F,H,Y,se,le){for(const he=Y.length;se<le;se++){const ue=F[se];if(H(ue,Y[he-1])<0){Y.pop();const me=(0,O.findFirstIdxMonotonousOrArrLen)(Y,fe=>H(ue,fe)<0);Y.splice(me,0,ue)}}}function p(F){return F.filter(H=>!!H)}e.coalesce=p;function b(F){let H=0;for(let Y=0;Y<F.length;Y++)F[Y]&&(F[H]=F[Y],H+=1);F.length=H}e.coalesceInPlace=b;function t(F,H,Y){F.splice(Y,0,F.splice(H,1)[0])}e.move=t;function a(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=a;function n(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=n;function s(F,H=Y=>Y){const Y=new Set;return F.filter(se=>{const le=H(se);return Y.has(le)?!1:(Y.add(le),!0)})}e.distinct=s;function i(F){const H=new Set;return Y=>{const se=F(Y);return H.has(se)?!1:(H.add(se),!0)}}e.uniqueFilter=i;function r(F,H){return F.length>0?F[0]:H}e.firstOrDefault=r;function o(F,H){return F.length>0?F[F.length-1]:H}e.lastOrDefault=o;function w(F,H,Y=(se,le)=>se===le){let se=0;for(let le=0,he=Math.min(F.length,H.length);le<he&&Y(F[le],H[le]);le++)se++;return se}e.commonPrefixLength=w;function E(F){return[].concat(...F)}e.flatten=E;function d(F,H){let Y=typeof H=="number"?F:0;typeof H=="number"?Y=F:(Y=0,H=F);const se=[];if(Y<=H)for(let le=Y;le<H;le++)se.push(le);else for(let le=Y;le>H;le--)se.push(le);return se}e.range=d;function v(F,H,Y){return F.reduce((se,le)=>(se[H(le)]=Y?Y(le):le,se),Object.create(null))}e.index=v;function T(F,H){return F.push(H),()=>N(F,H)}e.insert=T;function N(F,H){const Y=F.indexOf(H);if(Y>-1)return F.splice(Y,1),H}e.remove=N;function M(F,H,Y){const se=F.slice(0,H),le=F.slice(H);return se.concat(Y,le)}e.arrayInsert=M;function $(F,H){let Y;if(typeof H=="number"){let se=H;Y=()=>{const le=Math.sin(se++)*179426549;return le-Math.floor(le)}}else Y=Math.random;for(let se=F.length-1;se>0;se-=1){const le=Math.floor(Y()*(se+1)),he=F[se];F[se]=F[le],F[le]=he}}e.shuffle=$;function j(F,H){const Y=F.indexOf(H);Y>-1&&(F.splice(Y,1),F.unshift(H))}e.pushToStart=j;function Z(F,H){const Y=F.indexOf(H);Y>-1&&(F.splice(Y,1),F.push(H))}e.pushToEnd=Z;function G(F,H){for(const Y of H)F.push(Y)}e.pushMany=G;function Q(F,H){return Array.isArray(F)?F.map(H):H(F)}e.mapArrayOrNot=Q;function B(F){return Array.isArray(F)?F:[F]}e.asArray=B;function K(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=K;function V(F,H,Y){const se=x(F,H),le=F.length,he=Y.length;F.length=le+he;for(let ue=le-1;ue>=se;ue--)F[ue+he]=F[ue];for(let ue=0;ue<he;ue++)F[ue+se]=Y[ue]}e.insertInto=V;function z(F,H,Y,se){const le=x(F,H);let he=F.splice(le,Y);return he===void 0&&(he=[]),V(F,le,se),he}e.splice=z;function x(F,H){return H<0?Math.max(H+F.length,0):Math.min(H,F.length)}var ee;(function(F){function H(he){return he<0}F.isLessThan=H;function Y(he){return he<=0}F.isLessThanOrEqual=Y;function se(he){return he>0}F.isGreaterThan=se;function le(he){return he===0}F.isNeitherLessOrGreaterThan=le,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(F,H){return(Y,se)=>H(F(Y),F(se))}e.compareBy=ne;function re(...F){return(H,Y)=>{for(const se of F){const le=se(H,Y);if(!ee.isNeitherLessOrGreaterThan(le))return le}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const J=(F,H)=>F-H;e.numberComparator=J;const q=(F,H)=>(0,e.numberComparator)(F?1:0,H?1:0);e.booleanComparator=q;function P(F){return(H,Y)=>-F(H,Y)}e.reverseOrder=P;class R{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let Y=this.firstIdx;for(;Y<this.items.length&&H(this.items[Y]);)Y++;const se=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,se}takeFromEndWhile(H){let Y=this.lastIdx;for(;Y>=0&&H(this.items[Y]);)Y--;const se=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,se}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}removeLast(){const H=this.items[this.lastIdx];return this.lastIdx--,H}takeCount(H){const Y=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,Y}}e.ArrayQueue=R;class W{static{this.empty=new W(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(Y=>(H(Y),!0))}toArray(){const H=[];return this.iterate(Y=>(H.push(Y),!0)),H}filter(H){return new W(Y=>this.iterate(se=>H(se)?Y(se):!0))}map(H){return new W(Y=>this.iterate(se=>Y(H(se))))}some(H){let Y=!1;return this.iterate(se=>(Y=H(se),!Y)),Y}findFirst(H){let Y;return this.iterate(se=>H(se)?(Y=se,!1):!0),Y}findLast(H){let Y;return this.iterate(se=>(H(se)&&(Y=se),!0)),Y}findLastMaxBy(H){let Y,se=!0;return this.iterate(le=>((se||ee.isGreaterThan(H(le,Y)))&&(se=!1,Y=le),!0)),Y}}e.CallbackIterable=W}),define(oe[127],ae([0,1,8]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(I,f){if(!I)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}e.ok=O;function A(I,f="Unreachable"){throw new Error(f)}e.assertNever=A;function U(I){if(!I)throw new k.BugIndicatingError("Assertion Failed")}e.assert=U;function _(I){if(!I()){debugger;I(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function L(I,f){let D=0;for(;D<I.length-1;){const C=I[D],S=I[D+1];if(!f(C,S))return!1;D++}return!0}e.checkAdjacentItems=L}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function k(O){const A=this;let U=!1,_;return function(){return U||(U=!0,_=O.apply(A,arguments)),_}}e.createSingleCallFunction=k}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(O){function A(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}O.is=A;const U=Object.freeze([]);function _(){return U}O.empty=_;function*L(b){yield b}O.single=L;function I(b){return A(b)?b:L(b)}O.wrap=I;function f(b){return b||U}O.from=f;function*D(b){for(let t=b.length-1;t>=0;t--)yield b[t]}O.reverse=D;function C(b){return!b||b[Symbol.iterator]().next().done===!0}O.isEmpty=C;function S(b){return b[Symbol.iterator]().next().value}O.first=S;function c(b,t){for(const a of b)if(t(a))return!0;return!1}O.some=c;function g(b,t){for(const a of b)if(t(a))return a}O.find=g;function*y(b,t){for(const a of b)t(a)&&(yield a)}O.filter=y;function*m(b,t){let a=0;for(const n of b)yield t(n,a++)}O.map=m;function*h(...b){for(const t of b)for(const a of t)yield a}O.concat=h;function l(b,t,a){let n=a;for(const s of b)n=t(n,s);return n}O.reduce=l;function*u(b,t,a=b.length){for(t<0&&(t+=b.length),a<0?a+=b.length:a>b.length&&(a=b.length);t<a;t++)yield b[t]}O.slice=u;function p(b,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,b];const n=b[Symbol.iterator]();for(let s=0;s<t;s++){const i=n.next();if(i.done)return[a,O.empty()];a.push(i.value)}return[a,{[Symbol.iterator](){return n}}]}O.consume=p})(k||(e.Iterable=k={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var U;(function(t){t.DEFAULT={allowTrailingComma:!0}})(U||(e.ParseOptions=U={}));function _(t,a=!1){let n=0;const s=t.length;let i="",r=0,o=16,w=0;function E(j){let Z=0,G=0;for(;Z<j;){const Q=t.charCodeAt(n);if(Q>=48&&Q<=57)G=G*16+Q-48;else if(Q>=65&&Q<=70)G=G*16+Q-65+10;else if(Q>=97&&Q<=102)G=G*16+Q-97+10;else break;n++,Z++}return Z<j&&(G=-1),G}function d(j){n=j,i="",r=0,o=16,w=0}function v(){const j=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&f(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&f(t.charCodeAt(n)))for(n++;n<t.length&&f(t.charCodeAt(n));)n++;else return w=3,t.substring(j,n);let Z=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&f(t.charCodeAt(n))){for(n++;n<t.length&&f(t.charCodeAt(n));)n++;Z=n}else w=3;return t.substring(j,Z)}function T(){let j="",Z=n;for(;;){if(n>=s){j+=t.substring(Z,n),w=2;break}const G=t.charCodeAt(n);if(G===34){j+=t.substring(Z,n),n++;break}if(G===92){if(j+=t.substring(Z,n),n++,n>=s){w=2;break}switch(t.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const B=E(4);B>=0?j+=String.fromCharCode(B):w=4;break}default:w=5}Z=n;continue}if(G>=0&&G<=31)if(I(G)){j+=t.substring(Z,n),w=2;break}else w=6;n++}return j}function N(){if(i="",w=0,r=n,n>=s)return r=s,o=17;let j=t.charCodeAt(n);if(L(j)){do n++,i+=String.fromCharCode(j),j=t.charCodeAt(n);while(L(j));return o=15}if(I(j))return n++,i+=String.fromCharCode(j),j===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),o=14;switch(j){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,i=T(),o=10;case 47:{const Z=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!I(t.charCodeAt(n));)n++;return i=t.substring(Z,n),o=12}if(t.charCodeAt(n+1)===42){n+=2;const G=s-1;let Q=!1;for(;n<G;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,w=1),i=t.substring(Z,n),o=13}return i+=String.fromCharCode(j),n++,o=16}case 45:if(i+=String.fromCharCode(j),n++,n===s||!f(t.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=v(),o=11;default:for(;n<s&&M(j);)n++,j=t.charCodeAt(n);if(r!==n){switch(i=t.substring(r,n),i){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return i+=String.fromCharCode(j),n++,o=16}}function M(j){if(L(j)||I(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:d,getPosition:()=>n,scan:a?$:N,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>w}}e.createScanner=_;function L(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function I(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function C(t,a){const n=[],s=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function w(E,d,v,T){r.value=E,r.offset=d,r.length=v,r.type=T,r.colonOffset=void 0,i=r}try{u(t,{onObjectBegin:(E,d)=>{if(a<=E)throw s;i=void 0,o=a>E,n.push("")},onObjectProperty:(E,d,v)=>{if(a<d||(w(E,d,v,"property"),n[n.length-1]=E,a<=d+v))throw s},onObjectEnd:(E,d)=>{if(a<=E)throw s;i=void 0,n.pop()},onArrayBegin:(E,d)=>{if(a<=E)throw s;i=void 0,n.push(0)},onArrayEnd:(E,d)=>{if(a<=E)throw s;i=void 0,n.pop()},onLiteralValue:(E,d,v)=>{if(a<d||(w(E,d,v,b(E)),a<=d+v))throw s},onSeparator:(E,d,v)=>{if(a<=d)throw s;if(E===":"&&i&&i.type==="property")i.colonOffset=d,o=!1,i=void 0;else if(E===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(o=!0,n[n.length-1]=""),i=void 0}}})}catch(E){if(E!==s)throw E}return{path:n,previousNode:i,isAtPropertyKey:o,matches:E=>{let d=0;for(let v=0;d<E.length&&v<n.length;v++)if(E[d]===n[v]||E[d]==="*")d++;else if(E[d]!=="**")return!1;return d===E.length}}}e.getLocation=C;function S(t,a=[],n=U.DEFAULT){let s=null,i=[];const r=[];function o(E){Array.isArray(i)?i.push(E):s!==null&&(i[s]=E)}return u(t,{onObjectBegin:()=>{const E={};o(E),r.push(i),i=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const E=[];o(E),r.push(i),i=E,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:o,onError:(E,d,v)=>{a.push({error:E,offset:d,length:v})}},n),i[0]}e.parse=S;function c(t,a=[],n=U.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function r(E){return s.children.push(E),E}u(t,{onObjectBegin:E=>{s=r({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,d,v)=>{s=r({type:"property",offset:d,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:d,length:v,parent:s})},onObjectEnd:(E,d)=>{s.length=E+d-s.offset,s=s.parent,i(E+d)},onArrayBegin:(E,d)=>{s=r({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,d)=>{s.length=E+d-s.offset,s=s.parent,i(E+d)},onLiteralValue:(E,d,v)=>{r({type:b(E),offset:d,length:v,parent:s,value:E}),i(d+v)},onSeparator:(E,d,v)=>{s.type==="property"&&(E===":"?s.colonOffset=d:E===","&&i(d))},onError:(E,d,v)=>{a.push({error:E,offset:d,length:v})}},n);const w=s.children[0];return w&&delete w.parent,w}e.parseTree=c;function g(t,a){if(!t)return;let n=t;for(const s of a)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.findNodeAtLocation=g;function y(t){if(!t.parent||!t.parent.children)return[];const a=y(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;a.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&a.push(n)}return a}e.getNodePath=y;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const a=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(a[n.children[0].value]=m(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=m;function h(t,a,n=!1){return a>=t.offset&&a<t.offset+t.length||n&&a===t.offset+t.length}e.contains=h;function l(t,a,n=!1){if(h(t,a,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=a;i++){const r=l(s[i],a,n);if(r)return r}return t}}e.findNodeAtOffset=l;function u(t,a,n=U.DEFAULT){const s=_(t,!1);function i(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ne){return ne?re=>ne(re,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=i(a.onObjectBegin),w=r(a.onObjectProperty),E=i(a.onObjectEnd),d=i(a.onArrayBegin),v=i(a.onArrayEnd),T=r(a.onLiteralValue),N=r(a.onSeparator),M=i(a.onComment),$=r(a.onError),j=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function G(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:j||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(ne){case 12:case 13:j?Q(10):M();break;case 16:Q(1);break;case 15:case 14:break;default:return ne}}}function Q(ne,re=[],J=[]){if($(ne),re.length+J.length>0){let q=s.getToken();for(;q!==17;){if(re.indexOf(q)!==-1){G();break}else if(J.indexOf(q)!==-1)break;q=G()}}}function B(ne){const re=s.getTokenValue();return ne?T(re):w(re),G(),!0}function K(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(Q(2),ne=0)}catch{Q(2)}T(ne);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return G(),!0}function V(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(N(":"),G(),ee()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function z(){o(),G();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Q(4,[],[]),N(","),G(),s.getToken()===2&&Z)break}else ne&&Q(6,[],[]);V()||Q(4,[],[2,5]),ne=!0}return E(),s.getToken()!==2?Q(7,[2],[]):G(),!0}function x(){d(),G();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Q(4,[],[]),N(","),G(),s.getToken()===4&&Z)break}else ne&&Q(6,[],[]);ee()||Q(4,[],[4,5]),ne=!0}return v(),s.getToken()!==4?Q(8,[4],[]):G(),!0}function ee(){switch(s.getToken()){case 3:return x();case 1:return z();case 10:return B(!0);default:return K()}}return G(),s.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):ee()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=u;function p(t,a){const n=_(t),s=[];let i,r=0,o;do switch(o=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:r!==o&&s.push(t.substring(r,o)),a!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(i!==17);return s.join("")}e.stripComments=p;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(oe[41],ae([0,1,35]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(f,D,C){let S,c,g,y,m;if(D){for(y=D.offset,m=y+D.length,g=y;g>0&&!I(f,g-1);)g--;let o=m;for(;o<f.length&&!I(f,o);)o++;c=f.substring(g,o),S=_(c,C)}else c=f,S=0,g=0,y=0,m=f.length;const h=L(C,f);let l=!1,u=0,p;C.insertSpaces?p=U(" ",C.tabSize||4):p="	";const b=(0,k.createScanner)(c,!1);let t=!1;function a(){return h+U(p,S+u)}function n(){let o=b.scan();for(l=!1;o===15||o===14;)l=l||o===14,o=b.scan();return t=o===16||b.getTokenError()!==0,o}const s=[];function i(o,w,E){!t&&w<m&&E>y&&f.substring(w,E)!==o&&s.push({offset:w,length:E-w,content:o})}let r=n();if(r!==17){const o=b.getTokenOffset()+g,w=U(p,S);i(w,g,o)}for(;r!==17;){let o=b.getTokenOffset()+b.getTokenLength()+g,w=n(),E="";for(;!l&&(w===12||w===13);){const v=b.getTokenOffset()+g;i(" ",o,v),o=b.getTokenOffset()+b.getTokenLength()+g,E=w===12?a():"",w=n()}if(w===2)r!==1&&(u--,E=a());else if(w===4)r!==3&&(u--,E=a());else{switch(r){case 3:case 1:u++,E=a();break;case 5:case 12:E=a();break;case 13:l?E=a():E=" ";break;case 6:E=" ";break;case 10:if(w===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?E=" ":w!==5&&w!==17&&(t=!0);break;case 16:t=!0;break}l&&(w===12||w===13)&&(E=a())}const d=b.getTokenOffset()+g;i(E,o,d),r=w}return s}e.format=O;function A(f,D){const C=JSON.stringify(f,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?C.replace(/\r\n|\r|\n/g,D.eol):C}e.toFormattedString=A;function U(f,D){let C="";for(let S=0;S<D;S++)C+=f;return C}function _(f,D){let C=0,S=0;const c=D.tabSize||4;for(;C<f.length;){const g=f.charAt(C);if(g===" ")S++;else if(g==="	")S+=c;else break;C++}return Math.floor(S/c)}function L(f,D){for(let C=0;C<D.length;C++){const S=D.charAt(C);if(S==="\r")return C+1<D.length&&D.charAt(C+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=L;function I(f,D){return`\r
`.indexOf(f.charAt(D))!==-1}e.isEOL=I}),define(oe[85],ae([0,1,35,41]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(f,D,C){return U(f,D,void 0,C)}e.removeProperty=A;function U(f,D,C,S,c){const g=D.slice(),y=[],m=(0,k.parseTree)(f,y);let h,l;for(;g.length>0&&(l=g.pop(),h=(0,k.findNodeAtLocation)(m,g),h===void 0&&C!==void 0);)typeof l=="string"?C={[l]:C}:C=[C];if(h)if(h.type==="object"&&typeof l=="string"&&Array.isArray(h.children)){const u=(0,k.findNodeAtLocation)(h,[l]);if(u!==void 0)if(C===void 0){if(!u.parent)throw new Error("Malformed AST");const p=h.children.indexOf(u.parent);let b,t=u.parent.offset+u.parent.length;if(p>0){const a=h.children[p-1];b=a.offset+a.length}else b=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return _(f,{offset:b,length:t-b,content:""},S)}else return _(f,{offset:u.offset,length:u.length,content:JSON.stringify(C)},S);else{if(C===void 0)return[];const p=`${JSON.stringify(l)}: ${JSON.stringify(C)}`,b=c?c(h.children.map(a=>a.children[0].value)):h.children.length;let t;if(b>0){const a=h.children[b-1];t={offset:a.offset+a.length,length:0,content:","+p}}else h.children.length===0?t={offset:h.offset+1,length:0,content:p}:t={offset:h.offset+1,length:0,content:p+","};return _(f,t,S)}}else if(h.type==="array"&&typeof l=="number"&&Array.isArray(h.children))if(C!==void 0){const u=`${JSON.stringify(C)}`;let p;if(h.children.length===0||l===0)p={offset:h.offset+1,length:0,content:h.children.length===0?u:u+","};else{const b=l===-1||l>h.children.length?h.children.length:l,t=h.children[b-1];p={offset:t.offset+t.length,length:0,content:","+u}}return _(f,p,S)}else{const u=l,p=h.children[u];let b;if(h.children.length===1)b={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===u){const t=h.children[u-1],a=t.offset+t.length,n=h.offset+h.length;b={offset:a,length:n-2-a,content:""}}else b={offset:p.offset,length:h.children[u+1].offset-p.offset,content:""};return _(f,b,S)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${h.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return _(f,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(C)},S)}}e.setProperty=U;function _(f,D,C){let S=L(f,D),c=D.offset,g=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;c>0&&!(0,O.isEOL)(S,c-1);)c--;for(;g<S.length&&!(0,O.isEOL)(S,g);)g++}const y=(0,O.format)(S,{offset:c,length:g-c},C);for(let h=y.length-1;h>=0;h--){const l=y[h];S=L(S,l),c=Math.min(c,l.offset),g=Math.max(g,l.offset+l.length),g+=l.content.length-l.length}const m=f.length-(S.length-g)-c;return[{offset:c,length:m,content:S.substring(c,g)}]}e.withFormatting=_;function L(f,D){return f.substring(0,D.offset)+D.content+f.substring(D.offset+D.length)}e.applyEdit=L;function I(f,D){const C=D.slice(0).sort((c,g)=>{const y=c.offset-g.offset;return y===0?c.length-g.length:y});let S=f.length;for(let c=C.length-1;c>=0;c--){const g=C[c];if(g.offset+g.length<=S)f=L(f,g);else throw new Error("Overlapping edit");S=g.offset}return f}e.applyEdits=I}),define(oe[86],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(A){this.executor=A,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=k}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{static{this.Undefined=new k(void 0)}constructor(U){this.element=U,this.next=k.Undefined,this.prev=k.Undefined}}class O{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let U=this._first;for(;U!==k.Undefined;){const _=U.next;U.prev=k.Undefined,U.next=k.Undefined,U=_}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(U){return this._insert(U,!1)}push(U){return this._insert(U,!0)}_insert(U,_){const L=new k(U);if(this._first===k.Undefined)this._first=L,this._last=L;else if(_){const f=this._last;this._last=L,L.prev=f,f.next=L}else{const f=this._first;this._first=L,L.next=f,f.prev=L}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(L))}}shift(){if(this._first!==k.Undefined){const U=this._first.element;return this._remove(this._first),U}}pop(){if(this._last!==k.Undefined){const U=this._last.element;return this._remove(this._last),U}}_remove(U){if(U.prev!==k.Undefined&&U.next!==k.Undefined){const _=U.prev;_.next=U.next,U.next.prev=_}else U.prev===k.Undefined&&U.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):U.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):U.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let U=this._first;for(;U!==k.Undefined;)yield U.element,U=U.next}}e.LinkedList=O}),define(oe[34],ae([0,1]),function(te,e){"use strict";var k,O,A;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function U(l,u,p){let b=l.get(u);return b===void 0&&(b=p,l.set(u,b)),b}e.getOrSet=U;function _(l){const u=[];return l.forEach((p,b)=>{u.push(`${b} => ${p}`)}),`Map(${l.size}) {${u.join(", ")}}`}e.mapToString=_;function L(l){const u=[];return l.forEach(p=>{u.push(p)}),`Set(${l.size}) {${u.join(", ")}}`}e.setToString=L;class I{constructor(u,p){this.uri=u,this.value=p}}function f(l){return Array.isArray(l)}class D{static{this.defaultToKey=u=>u.toString()}constructor(u,p){if(this[k]="ResourceMap",u instanceof D)this.map=new Map(u.map),this.toKey=p??D.defaultToKey;else if(f(u)){this.map=new Map,this.toKey=p??D.defaultToKey;for(const[b,t]of u)this.set(b,t)}else this.map=new Map,this.toKey=u??D.defaultToKey}set(u,p){return this.map.set(this.toKey(u),new I(u,p)),this}get(u){return this.map.get(this.toKey(u))?.value}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,p){typeof p<"u"&&(u=u.bind(p));for(const[b,t]of this.map)u(t.value,t.uri,this)}*values(){for(const u of this.map.values())yield u.value}*keys(){for(const u of this.map.values())yield u.uri}*entries(){for(const u of this.map.values())yield[u.uri,u.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.map)yield[u.uri,u.value]}}e.ResourceMap=D;class C{constructor(u,p){this[O]="ResourceSet",!u||typeof u=="function"?this._map=new D(u):(this._map=new D(p),u.forEach(this.add,this))}get size(){return this._map.size}add(u){return this._map.set(u,u),this}clear(){this._map.clear()}delete(u){return this._map.delete(u)}forEach(u,p){this._map.forEach((b,t)=>u.call(p,t,t,this))}has(u){return this._map.has(u)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var S;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(S||(e.Touch=S={}));class c{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(u){return this._map.has(u)}get(u,p=0){const b=this._map.get(u);if(b)return p!==0&&this.touch(b,p),b.value}set(u,p,b=0){let t=this._map.get(u);if(t)t.value=p,b!==0&&this.touch(t,b);else{switch(t={key:u,value:p,next:void 0,previous:void 0},b){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(u,t),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const p=this._map.get(u);if(p)return this._map.delete(u),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}forEach(u,p){const b=this._state;let t=this._head;for(;t;){if(p?u.bind(p)(t.value,t.key,this):u(t.value,t.key,this),this._state!==b)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,p=this._state;let b=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==p)throw new Error("LinkedMap got modified during iteration.");if(b){const a={value:b.key,done:!1};return b=b.next,a}else return{value:void 0,done:!0}}};return t}values(){const u=this,p=this._state;let b=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==p)throw new Error("LinkedMap got modified during iteration.");if(b){const a={value:b.value,done:!1};return b=b.next,a}else return{value:void 0,done:!0}}};return t}entries(){const u=this,p=this._state;let b=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==p)throw new Error("LinkedMap got modified during iteration.");if(b){const a={value:[b.key,b.value],done:!1};return b=b.next,a}else return{value:void 0,done:!0}}};return t}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(u>=this.size)return;if(u===0){this.clear();return}let p=this._head,b=this.size;for(;p&&b>u;)this._map.delete(p.key),p=p.next,b--;this._head=p,this._size=b,p&&(p.previous=void 0),this._state++}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const p=u.next,b=u.previous;if(!p||!b)throw new Error("Invalid list");p.previous=b,b.next=p}u.next=void 0,u.previous=void 0,this._state++}touch(u,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(u===this._head)return;const b=u.next,t=u.previous;u===this._tail?(t.next=void 0,this._tail=t):(b.previous=t,t.next=b),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(p===2){if(u===this._tail)return;const b=u.next,t=u.previous;u===this._head?(b.previous=void 0,this._head=b):(b.previous=t,t.next=b),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((p,b)=>{u.push([b,p])}),u}fromJSON(u){this.clear();for(const[p,b]of u)this.set(p,b)}}e.LinkedMap=c;class g extends c{constructor(u,p=1){super(),this._limit=u,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,p=2){return super.get(u,p)}peek(u){return super.get(u,0)}set(u,p){return super.set(u,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class y{constructor(){this.map=new Map}add(u){return this.map.set(u,(this.map.get(u)||0)+1),this}delete(u){let p=this.map.get(u)||0;return p===0?!1:(p--,p===0?this.map.delete(u):this.map.set(u,p),!0)}has(u){return this.map.has(u)}}e.CounterSet=y;class m{constructor(u){if(this._m1=new Map,this._m2=new Map,u)for(const[p,b]of u)this.set(p,b)}clear(){this._m1.clear(),this._m2.clear()}set(u,p){this._m1.set(u,p),this._m2.set(p,u)}get(u){return this._m1.get(u)}getKey(u){return this._m2.get(u)}delete(u){const p=this._m1.get(u);return p===void 0?!1:(this._m1.delete(u),this._m2.delete(p),!0)}forEach(u,p){this._m1.forEach((b,t)=>{u.call(p,b,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class h{constructor(){this.map=new Map}add(u,p){let b=this.map.get(u);b||(b=new Set,this.map.set(u,b)),b.add(p)}delete(u,p){const b=this.map.get(u);b&&(b.delete(p),b.size===0&&this.map.delete(u))}forEach(u,p){const b=this.map.get(u);b&&b.forEach(p)}get(u){const p=this.map.get(u);return p||new Set}}e.SetMap=h}),define(oe[2],ae([0,1,18,126,34,84,59]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const L=!1;let I=null;class f{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(v){let T=this.livingDisposables.get(v);return T||(T={parent:null,source:null,isSingleton:!1,value:v,idx:f.idx++},this.livingDisposables.set(v,T)),T}trackDisposable(v){const T=this.getDisposableData(v);T.source||(T.source=new Error().stack)}setParent(v,T){const N=this.getDisposableData(v);N.parent=T}markAsDisposed(v){this.livingDisposables.delete(v)}markAsSingleton(v){this.getDisposableData(v).isSingleton=!0}getRootParent(v,T){const N=T.get(v);if(N)return N;const M=v.parent?this.getRootParent(this.getDisposableData(v.parent),T):v;return T.set(v,M),M}getTrackedDisposables(){const v=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,v).isSingleton).map(([N])=>N).flat()}computeLeakingDisposables(v=10,T){let N;if(T)N=T;else{const G=new Map,Q=[...this.livingDisposables.values()].filter(K=>K.source!==null&&!this.getRootParent(K,G).isSingleton);if(Q.length===0)return;const B=new Set(Q.map(K=>K.value));if(N=Q.filter(K=>!(K.parent&&B.has(K.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function M(G){function Q(K,V){for(;K.length>0&&V.some(z=>typeof z=="string"?z===K[0]:K[0].match(z));)K.shift()}const B=G.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return Q(B,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),B.reverse()}const $=new A.SetMap;for(const G of N){const Q=M(G);for(let B=0;B<=Q.length;B++)$.add(Q.slice(0,B).join(`
`),G)}N.sort((0,k.compareBy)(G=>G.idx,k.numberComparator));let j="",Z=0;for(const G of N.slice(0,v)){Z++;const Q=M(G),B=[];for(let K=0;K<Q.length;K++){let V=Q[K];V=`(shared with ${$.get(Q.slice(0,K+1).join(`
`)).size}/${N.length} leaks) at ${V}`;const x=$.get(Q.slice(0,K).join(`
`)),ee=(0,O.groupBy)([...x].map(ne=>M(ne)[K]),ne=>ne);delete ee[Q[K]];for(const[ne,re]of Object.entries(ee))B.unshift(`    - stacktraces of ${re.length} other leaks continue with ${ne}`);B.unshift(V)}j+=`


==================== Leaking disposable ${Z}/${N.length}: ${G.value.constructor.name} ====================
${B.join(`
`)}
============================================================

`}return N.length>v&&(j+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:j}}}e.DisposableTracker=f;function D(d){I=d}if(e.setDisposableTracker=D,L){const d="__is_disposable_tracked__";D(new class{trackDisposable(v){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[d]||console.log(T)},3e3)}setParent(v,T){if(v&&v!==t.None)try{v[d]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[d]=!0}catch{}}markAsSingleton(v){}})}function C(d){return I?.trackDisposable(d),d}e.trackDisposable=C;function S(d){I?.markAsDisposed(d)}e.markAsDisposed=S;function c(d,v){I?.setParent(d,v)}function g(d,v){if(I)for(const T of d)I.setParent(T,v)}function y(d){return I?.markAsSingleton(d),d}e.markAsSingleton=y;function m(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=m;function h(d){if(_.Iterable.is(d)){const v=[];for(const T of d)if(T)try{T.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=h;function l(d){for(const v of d)m(v)&&v.dispose();return[]}e.disposeIfDisposable=l;function u(...d){const v=p(()=>h(d));return g(d,v),v}e.combinedDisposable=u;function p(d){const v=C({dispose:(0,U.createSingleCallFunction)(()=>{S(v),d()})});return v}e.toDisposable=p;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return c(v,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(v),v.dispose()}}deleteAndLeak(v){v&&this._toDispose.has(v)&&(this._toDispose.delete(v),c(v,null))}}e.DisposableStore=b;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new b,C(this),c(this._store,this)}dispose(){S(this),this._store.dispose()}_register(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(v)}}e.Disposable=t;class a{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(v){this._isDisposed||v===this._value||(this._value?.dispose(),v&&c(v,this),this._value=v)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const v=this._value;return this._value=void 0,v&&c(v,null),v}}e.MutableDisposable=a;class n{constructor(v){this._disposable=v,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=n;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(v){let T=v;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,S(this))},this}}e.SafeDisposable=s;class i{constructor(){this.references=new Map}acquire(v,...T){let N=this.references.get(v);N||(N={counter:0,object:this.createReferencedObject(v,...T)},this.references.set(v,N));const{object:M}=N,$=(0,U.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(v,N.object),this.references.delete(v))});return N.counter++,{object:M,dispose:$}}}e.ReferenceCollection=i;class r{constructor(v){this.referenceCollection=v}async acquire(v,...T){const N=this.referenceCollection.acquire(v,...T);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(M){throw N.dispose(),M}}}e.AsyncReferenceCollection=r;class o{constructor(v){this.object=v}dispose(){}}e.ImmortalReference=o;function w(d){const v=new b;try{d(v)}finally{v.dispose()}}e.disposeOnReturn=w;class E{constructor(){this._store=new Map,this._isDisposed=!1,C(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(v){return this._store.has(v)}get size(){return this._store.size}get(v){return this._store.get(v)}set(v,T,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(v)?.dispose(),this._store.set(v,T)}deleteAndDispose(v){this._store.get(v)?.dispose(),this._store.delete(v)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=E}),define(oe[88],ae([0,1,34]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new k.LRUCache(1e4);function A(f){return I(f,"NFC",O)}e.normalizeNFC=A;const U=new k.LRUCache(1e4);function _(f){return I(f,"NFD",U)}e.normalizeNFD=_;const L=/[^\u0000-\u0080]/;function I(f,D,C){if(!f)return f;const S=C.get(f);if(S)return S;let c;return L.test(f)?c=f.normalize(D):c=f,C.set(f,c),c}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(D){return _(D).replace(f,"")}}()}),function(){function te(A){const U=[];typeof A=="number"&&U.push("code/timeOrigin",A);function _(I){U.push(I,Date.now())}function L(){const I=[];for(let f=0;f<U.length;f+=2)I.push({name:U[f],startTime:U[f+1]});return I}return{mark:_,getMarks:L}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const U=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const _ of performance.getEntriesByType("mark"))U.push({name:_.name,startTime:Math.round(A+_.startTime)});return U}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function k(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=k(O))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var O in k)(typeof exports=="object"?exports:te)[O]=k[O]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function k(O){if(e[O])return e[O].exports;var A=e[O]={i:O,l:!1,exports:{}};return te[O].call(A.exports,A,A.exports,k),A.l=!0,A.exports}return k.m=te,k.c=e,k.d=function(O,A,U){k.o(O,A)||Object.defineProperty(O,A,{enumerable:!0,get:U})},k.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},k.t=function(O,A){if(1&A&&(O=k(O)),8&A||4&A&&typeof O=="object"&&O&&O.__esModule)return O;var U=Object.create(null);if(k.r(U),Object.defineProperty(U,"default",{enumerable:!0,value:O}),2&A&&typeof O!="string")for(var _ in O)k.d(U,_,function(L){return O[L]}.bind(null,_));return U},k.n=function(O){var A=O&&O.__esModule?function(){return O.default}:function(){return O};return k.d(A,"a",A),A},k.o=function(O,A){return Object.prototype.hasOwnProperty.call(O,A)},k.p="",k(k.s=0)}([function(te,e,k){(function(O){var A;e=te.exports=J,A=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var U=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],I=e.src=[],f=0,D=f++;I[D]="0|[1-9]\\d*";var C=f++;I[C]="[0-9]+";var S=f++;I[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=f++;I[c]="("+I[D]+")\\.("+I[D]+")\\.("+I[D]+")";var g=f++;I[g]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var y=f++;I[y]="(?:"+I[D]+"|"+I[S]+")";var m=f++;I[m]="(?:"+I[C]+"|"+I[S]+")";var h=f++;I[h]="(?:-("+I[y]+"(?:\\."+I[y]+")*))";var l=f++;I[l]="(?:-?("+I[m]+"(?:\\."+I[m]+")*))";var u=f++;I[u]="[0-9A-Za-z-]+";var p=f++;I[p]="(?:\\+("+I[u]+"(?:\\."+I[u]+")*))";var b=f++,t="v?"+I[c]+I[h]+"?"+I[p]+"?";I[b]="^"+t+"$";var a="[v=\\s]*"+I[g]+I[l]+"?"+I[p]+"?",n=f++;I[n]="^"+a+"$";var s=f++;I[s]="((?:<|>)?=?)";var i=f++;I[i]=I[C]+"|x|X|\\*";var r=f++;I[r]=I[D]+"|x|X|\\*";var o=f++;I[o]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[h]+")?"+I[p]+"?)?)?";var w=f++;I[w]="[v=\\s]*("+I[i]+")(?:\\.("+I[i]+")(?:\\.("+I[i]+")(?:"+I[l]+")?"+I[p]+"?)?)?";var E=f++;I[E]="^"+I[s]+"\\s*"+I[o]+"$";var d=f++;I[d]="^"+I[s]+"\\s*"+I[w]+"$";var v=f++;I[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=f++;I[T]="(?:~>?)";var N=f++;I[N]="(\\s*)"+I[T]+"\\s+",L[N]=new RegExp(I[N],"g");var M=f++;I[M]="^"+I[T]+I[o]+"$";var $=f++;I[$]="^"+I[T]+I[w]+"$";var j=f++;I[j]="(?:\\^)";var Z=f++;I[Z]="(\\s*)"+I[j]+"\\s+",L[Z]=new RegExp(I[Z],"g");var G=f++;I[G]="^"+I[j]+I[o]+"$";var Q=f++;I[Q]="^"+I[j]+I[w]+"$";var B=f++;I[B]="^"+I[s]+"\\s*("+a+")$|^$";var K=f++;I[K]="^"+I[s]+"\\s*("+t+")$|^$";var V=f++;I[V]="(\\s*)"+I[s]+"\\s*("+a+"|"+I[o]+")",L[V]=new RegExp(I[V],"g");var z=f++;I[z]="^\\s*("+I[o]+")\\s+-\\s+("+I[o]+")\\s*$";var x=f++;I[x]="^\\s*("+I[w]+")\\s+-\\s+("+I[w]+")\\s*$";var ee=f++;I[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)A(ne,I[ne]),L[ne]||(L[ne]=new RegExp(I[ne]));function re(ce,ge){if(ce instanceof J)return ce;if(typeof ce!="string"||ce.length>U||!(ge?L[n]:L[b]).test(ce))return null;try{return new J(ce,ge)}catch{return null}}function J(ce,ge){if(ce instanceof J){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>U)throw new TypeError("version is longer than "+U+" characters");if(!(this instanceof J))return new J(ce,ge);A("SemVer",ce,ge),this.loose=ge;var ve=ce.trim().match(ge?L[n]:L[b]);if(!ve)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var De=+Pe;if(De>=0&&De<_)return De}return Pe}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=re,e.valid=function(ce,ge){var ve=re(ce,ge);return ve?ve.version:null},e.clean=function(ce,ge){var ve=re(ce.trim().replace(/^[=v]+/,""),ge);return ve?ve.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(ce){return A("SemVer.compare",this.version,this.loose,ce),ce instanceof J||(ce=new J(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},J.prototype.compareMain=function(ce){return ce instanceof J||(ce=new J(ce,this.loose)),P(this.major,ce.major)||P(this.minor,ce.minor)||P(this.patch,ce.patch)},J.prototype.comparePre=function(ce){if(ce instanceof J||(ce=new J(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var ve=this.prerelease[ge],Pe=ce.prerelease[ge];if(A("prerelease compare",ge,ve,Pe),ve===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ve===void 0)return-1;if(ve!==Pe)return P(ve,Pe)}while(++ge)},J.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,ve,Pe){typeof ve=="string"&&(Pe=ve,ve=void 0);try{return new J(ce,ve).inc(ge,Pe).version}catch{return null}},e.diff=function(ce,ge){if(H(ce,ge))return null;var ve=re(ce),Pe=re(ge);if(ve.prerelease.length||Pe.prerelease.length){for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Pe[De])return"pre"+De;return"prerelease"}for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Pe[De])return De},e.compareIdentifiers=P;var q=/^[0-9]+$/;function P(ce,ge){var ve=q.test(ce),Pe=q.test(ge);return ve&&Pe&&(ce=+ce,ge=+ge),ve&&!Pe?-1:Pe&&!ve?1:ce<ge?-1:ce>ge?1:0}function R(ce,ge,ve){return new J(ce,ve).compare(new J(ge,ve))}function W(ce,ge,ve){return R(ce,ge,ve)>0}function F(ce,ge,ve){return R(ce,ge,ve)<0}function H(ce,ge,ve){return R(ce,ge,ve)===0}function Y(ce,ge,ve){return R(ce,ge,ve)!==0}function se(ce,ge,ve){return R(ce,ge,ve)>=0}function le(ce,ge,ve){return R(ce,ge,ve)<=0}function he(ce,ge,ve,Pe){var De;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof ve=="object"&&(ve=ve.version),De=ce===ve;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ve=="object"&&(ve=ve.version),De=ce!==ve;break;case"":case"=":case"==":De=H(ce,ve,Pe);break;case"!=":De=Y(ce,ve,Pe);break;case">":De=W(ce,ve,Pe);break;case">=":De=se(ce,ve,Pe);break;case"<":De=F(ce,ve,Pe);break;case"<=":De=le(ce,ve,Pe);break;default:throw new TypeError("Invalid operator: "+ge)}return De}function ue(ce,ge){if(ce instanceof ue){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof ue))return new ue(ce,ge);A("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===me?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ce,ge){return P(ge,ce)},e.major=function(ce,ge){return new J(ce,ge).major},e.minor=function(ce,ge){return new J(ce,ge).minor},e.patch=function(ce,ge){return new J(ce,ge).patch},e.compare=R,e.compareLoose=function(ce,ge){return R(ce,ge,!0)},e.rcompare=function(ce,ge,ve){return R(ge,ce,ve)},e.sort=function(ce,ge){return ce.sort(function(ve,Pe){return e.compare(ve,Pe,ge)})},e.rsort=function(ce,ge){return ce.sort(function(ve,Pe){return e.rcompare(ve,Pe,ge)})},e.gt=W,e.lt=F,e.eq=H,e.neq=Y,e.gte=se,e.lte=le,e.cmp=he,e.Comparator=ue;var me={};function fe(ce,ge){if(ce instanceof fe)return ce.loose===ge?ce:new fe(ce.raw,ge);if(ce instanceof ue)return new fe(ce.value,ge);if(!(this instanceof fe))return new fe(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function pe(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ce(ce,ge,ve,Pe,De,$e,Te,We,Fe,ie,de,Se,Ee){return((ge=pe(ve)?"":pe(Pe)?">="+ve+".0.0":pe(De)?">="+ve+"."+Pe+".0":">="+ge)+" "+(We=pe(Fe)?"":pe(ie)?"<"+(+Fe+1)+".0.0":pe(de)?"<"+Fe+"."+(+ie+1)+".0":Se?"<="+Fe+"."+ie+"."+de+"-"+Se:"<="+We)).trim()}function Le(ce,ge){for(var ve=0;ve<ce.length;ve++)if(!ce[ve].test(ge))return!1;if(ge.prerelease.length){for(ve=0;ve<ce.length;ve++)if(A(ce[ve].semver),ce[ve].semver!==me&&ce[ve].semver.prerelease.length>0){var Pe=ce[ve].semver;if(Pe.major===ge.major&&Pe.minor===ge.minor&&Pe.patch===ge.patch)return!0}return!1}return!0}function Oe(ce,ge,ve){try{ge=new fe(ge,ve)}catch{return!1}return ge.test(ce)}function Me(ce,ge,ve,Pe){var De,$e,Te,We,Fe;switch(ce=new J(ce,Pe),ge=new fe(ge,Pe),ve){case">":De=W,$e=le,Te=F,We=">",Fe=">=";break;case"<":De=F,$e=se,Te=W,We="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ce,ge,Pe))return!1;for(var ie=0;ie<ge.set.length;++ie){var de=ge.set[ie],Se=null,Ee=null;if(de.forEach(function(be){be.semver===me&&(be=new ue(">=0.0.0")),Se=Se||be,Ee=Ee||be,De(be.semver,Se.semver,Pe)?Se=be:Te(be.semver,Ee.semver,Pe)&&(Ee=be)}),Se.operator===We||Se.operator===Fe||(!Ee.operator||Ee.operator===We)&&$e(ce,Ee.semver)||Ee.operator===Fe&&Te(ce,Ee.semver))return!1}return!0}ue.prototype.parse=function(ce){var ge=this.loose?L[B]:L[K],ve=ce.match(ge);if(!ve)throw new TypeError("Invalid comparator: "+ce);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new J(ve[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(ce){return A("Comparator.test",ce,this.loose),this.semver===me||(typeof ce=="string"&&(ce=new J(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(ce,ge){if(!(ce instanceof ue))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new fe(ce.value,ge),Oe(this.value,ve,ge);if(ce.operator==="")return ve=new fe(this.value,ge),Oe(ce.semver,ve,ge);var Pe=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),$e=this.semver.version===ce.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),We=he(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Fe=he(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Pe||De||$e&&Te||We||Fe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),A("range",ce,ge);var ve=ge?L[x]:L[z];ce=ce.replace(ve,Ce),A("hyphen replace",ce),ce=ce.replace(L[V],"$1$2$3"),A("comparator trim",ce,L[V]),ce=(ce=(ce=ce.replace(L[N],"$1~")).replace(L[Z],"$1^")).split(/\s+/).join(" ");var Pe=ge?L[B]:L[K],De=ce.split(" ").map(function($e){return function(Te,We){return A("comp",Te),Te=function(Fe,ie){return Fe.trim().split(/\s+/).map(function(de){return function(Se,Ee){A("caret",Se,Ee);var be=Ee?L[Q]:L[G];return Se.replace(be,function(Re,Ie,ke,_e,Ue){var Ne;return A("caret",Se,Re,Ie,ke,_e,Ue),pe(Ie)?Ne="":pe(ke)?Ne=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(_e)?Ne=Ie==="0"?">="+Ie+"."+ke+".0 <"+Ie+"."+(+ke+1)+".0":">="+Ie+"."+ke+".0 <"+(+Ie+1)+".0.0":Ue?(A("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ne=Ie==="0"?ke==="0"?">="+Ie+"."+ke+"."+_e+Ue+" <"+Ie+"."+ke+"."+(+_e+1):">="+Ie+"."+ke+"."+_e+Ue+" <"+Ie+"."+(+ke+1)+".0":">="+Ie+"."+ke+"."+_e+Ue+" <"+(+Ie+1)+".0.0"):(A("no pr"),Ne=Ie==="0"?ke==="0"?">="+Ie+"."+ke+"."+_e+" <"+Ie+"."+ke+"."+(+_e+1):">="+Ie+"."+ke+"."+_e+" <"+Ie+"."+(+ke+1)+".0":">="+Ie+"."+ke+"."+_e+" <"+(+Ie+1)+".0.0"),A("caret return",Ne),Ne})}(de,ie)}).join(" ")}(Te,We),A("caret",Te),Te=function(Fe,ie){return Fe.trim().split(/\s+/).map(function(de){return function(Se,Ee){var be=Ee?L[$]:L[M];return Se.replace(be,function(Re,Ie,ke,_e,Ue){var Ne;return A("tilde",Se,Re,Ie,ke,_e,Ue),pe(Ie)?Ne="":pe(ke)?Ne=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":pe(_e)?Ne=">="+Ie+"."+ke+".0 <"+Ie+"."+(+ke+1)+".0":Ue?(A("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ne=">="+Ie+"."+ke+"."+_e+Ue+" <"+Ie+"."+(+ke+1)+".0"):Ne=">="+Ie+"."+ke+"."+_e+" <"+Ie+"."+(+ke+1)+".0",A("tilde return",Ne),Ne})}(de,ie)}).join(" ")}(Te,We),A("tildes",Te),Te=function(Fe,ie){return A("replaceXRanges",Fe,ie),Fe.split(/\s+/).map(function(de){return function(Se,Ee){Se=Se.trim();var be=Ee?L[d]:L[E];return Se.replace(be,function(Re,Ie,ke,_e,Ue,Ne){A("xRange",Se,Re,Ie,ke,_e,Ue,Ne);var qe=pe(ke),je=qe||pe(_e),xe=je||pe(Ue);return Ie==="="&&xe&&(Ie=""),qe?Re=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&xe?(je&&(_e=0),xe&&(Ue=0),Ie===">"?(Ie=">=",je?(ke=+ke+1,_e=0,Ue=0):xe&&(_e=+_e+1,Ue=0)):Ie==="<="&&(Ie="<",je?ke=+ke+1:_e=+_e+1),Re=Ie+ke+"."+_e+"."+Ue):je?Re=">="+ke+".0.0 <"+(+ke+1)+".0.0":xe&&(Re=">="+ke+"."+_e+".0 <"+ke+"."+(+_e+1)+".0"),A("xRange return",Re),Re})}(de,ie)}).join(" ")}(Te,We),A("xrange",Te),Te=function(Fe,ie){return A("replaceStars",Fe,ie),Fe.trim().replace(L[ee],"")}(Te,We),A("stars",Te),Te}($e,ge)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function($e){return!!$e.match(Pe)})),De=De.map(function($e){return new ue($e,ge)})},fe.prototype.intersects=function(ce,ge){if(!(ce instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Pe){return ce.set.some(function(De){return De.every(function($e){return Pe.intersects($e,ge)})})})})},e.toComparators=function(ce,ge){return new fe(ce,ge).set.map(function(ve){return ve.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new J(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Le(this.set[ge],ce))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ce,ge,ve){var Pe=null,De=null;try{var $e=new fe(ge,ve)}catch{return null}return ce.forEach(function(Te){$e.test(Te)&&(Pe&&De.compare(Te)!==-1||(De=new J(Pe=Te,ve)))}),Pe},e.minSatisfying=function(ce,ge,ve){var Pe=null,De=null;try{var $e=new fe(ge,ve)}catch{return null}return ce.forEach(function(Te){$e.test(Te)&&(Pe&&De.compare(Te)!==1||(De=new J(Pe=Te,ve)))}),Pe},e.validRange=function(ce,ge){try{return new fe(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,ve){return Me(ce,ge,"<",ve)},e.gtr=function(ce,ge,ve){return Me(ce,ge,">",ve)},e.outside=Me,e.prerelease=function(ce,ge){var ve=re(ce,ge);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(ce,ge,ve){return ce=new fe(ce,ve),ge=new fe(ge,ve),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof J)return ce;if(typeof ce!="string")return null;var ge=ce.match(L[v]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,k(1))},function(te,e){var k,O,A=te.exports={};function U(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function L(m){if(k===setTimeout)return setTimeout(m,0);if((k===U||!k)&&setTimeout)return k=setTimeout,setTimeout(m,0);try{return k(m,0)}catch{try{return k.call(null,m,0)}catch{return k.call(this,m,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:U}catch{k=U}try{O=typeof clearTimeout=="function"?clearTimeout:_}catch{O=_}})();var I,f=[],D=!1,C=-1;function S(){D&&I&&(D=!1,I.length?f=I.concat(f):C=-1,f.length&&c())}function c(){if(!D){var m=L(S);D=!0;for(var h=f.length;h;){for(I=f,f=[];++C<h;)I&&I[C].run();C=-1,h=f.length}I=null,D=!1,function(l){if(O===clearTimeout)return clearTimeout(l);if((O===_||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(l);try{O(l)}catch{try{return O.call(null,l)}catch{return O.call(this,l)}}}(m)}}function g(m,h){this.fun=m,this.array=h}function y(){}A.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)h[l-1]=arguments[l];f.push(new g(m,h)),f.length!==1||D||L(c)},g.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=y,A.addListener=y,A.once=y,A.off=y,A.removeListener=y,A.removeAllListeners=y,A.emit=y,A.prependListener=y,A.prependOnceListener=y,A.listeners=function(m){return[]},A.binding=function(m){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(m){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(L,I,f){this.level=L,this.key=I,this.value=f,this.forward=[]}}const A=void 0;class U{constructor(L,I=2**16){this.comparator=L,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new O(this._maxLevel,A,A)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,A,A)}has(L){return!!U._search(this,L,this.comparator)}get(L){return U._search(this,L,this.comparator)?.value}set(L,I){return U._insert(this,L,I,this.comparator)&&(this._size+=1),this}delete(L){const I=U._delete(this,L,this.comparator);return I&&(this._size-=1),I}forEach(L,I){let f=this._header.forward[0];for(;f;)L.call(I,f.value,f.key,this),f=f.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let L=this._header.forward[0];for(;L;)yield[L.key,L.value],L=L.forward[0]}*keys(){let L=this._header.forward[0];for(;L;)yield L.key,L=L.forward[0]}*values(){let L=this._header.forward[0];for(;L;)yield L.value,L=L.forward[0]}toString(){let L="[SkipList]:",I=this._header.forward[0];for(;I;)L+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return L}static _search(L,I,f){let D=L._header;for(let C=L._level-1;C>=0;C--)for(;D.forward[C]&&f(D.forward[C].key,I)<0;)D=D.forward[C];if(D=D.forward[0],D&&f(D.key,I)===0)return D}static _insert(L,I,f,D){const C=[];let S=L._header;for(let c=L._level-1;c>=0;c--){for(;S.forward[c]&&D(S.forward[c].key,I)<0;)S=S.forward[c];C[c]=S}if(S=S.forward[0],S&&D(S.key,I)===0)return S.value=f,!1;{const c=U._randomLevel(L);if(c>L._level){for(let g=L._level;g<c;g++)C[g]=L._header;L._level=c}S=new O(c,I,f);for(let g=0;g<c;g++)S.forward[g]=C[g].forward[g],C[g].forward[g]=S;return!0}}static _randomLevel(L,I=.5){let f=1;for(;Math.random()<I&&f<L._maxLevel;)f+=1;return f}static _delete(L,I,f){const D=[];let C=L._header;for(let S=L._level-1;S>=0;S--){for(;C.forward[S]&&f(C.forward[S].key,I)<0;)C=C.forward[S];D[S]=C}if(C=C.forward[0],!C||f(C.key,I)!==0)return!1;for(let S=0;S<L._level&&D[S].forward[S]===C;S++)D[S].forward[S]=C.forward[S];for(;L._level>0&&L._header.forward[L._level-1]===A;)L._level-=1;return!0}}e.SkipList=U}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(U){return new O(U)}constructor(U){this._now=k&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(oe[3],ae([0,1,8,84,2,87,60]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const L=!1,I=!1;var f;(function(E){E.None=()=>A.Disposable.None;function d(he){if(I){const{onDidAddListener:ue}=he,me=g.create();let fe=0;he.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),ue?.()}}}function v(he,ue){return K(he,()=>{},0,void 0,!0,void 0,ue)}E.defer=v;function T(he){return(ue,me=null,fe)=>{let pe=!1,Ce;return Ce=he(Le=>{if(!pe)return Ce?Ce.dispose():pe=!0,ue.call(me,Le)},null,fe),pe&&Ce.dispose(),Ce}}E.once=T;function N(he,ue,me){return Q((fe,pe=null,Ce)=>he(Le=>fe.call(pe,ue(Le)),null,Ce),me)}E.map=N;function M(he,ue,me){return Q((fe,pe=null,Ce)=>he(Le=>{ue(Le),fe.call(pe,Le)},null,Ce),me)}E.forEach=M;function $(he,ue,me){return Q((fe,pe=null,Ce)=>he(Le=>ue(Le)&&fe.call(pe,Le),null,Ce),me)}E.filter=$;function j(he){return he}E.signal=j;function Z(...he){return(ue,me=null,fe)=>{const pe=(0,A.combinedDisposable)(...he.map(Ce=>Ce(Le=>ue.call(me,Le))));return B(pe,fe)}}E.any=Z;function G(he,ue,me,fe){let pe=me;return N(he,Ce=>(pe=ue(pe,Ce),pe),fe)}E.reduce=G;function Q(he,ue){let me;const fe={onWillAddFirstListener(){me=he(pe.fire,pe)},onDidRemoveLastListener(){me?.dispose()}};ue||d(fe);const pe=new u(fe);return ue?.add(pe),pe.event}function B(he,ue){return ue instanceof Array?ue.push(he):ue&&ue.add(he),he}function K(he,ue,me=100,fe=!1,pe=!1,Ce,Le){let Oe,Me,ce,ge=0,ve;const Pe={leakWarningThreshold:Ce,onWillAddFirstListener(){Oe=he($e=>{ge++,Me=ue(Me,$e),fe&&!ce&&(De.fire(Me),Me=void 0),ve=()=>{const Te=Me;Me=void 0,ce=void 0,(!fe||ge>1)&&De.fire(Te),ge=0},typeof me=="number"?(clearTimeout(ce),ce=setTimeout(ve,me)):ce===void 0&&(ce=0,queueMicrotask(ve))})},onWillRemoveListener(){pe&&ge>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,Oe.dispose()}};Le||d(Pe);const De=new u(Pe);return Le?.add(De),De.event}E.debounce=K;function V(he,ue=0,me){return E.debounce(he,(fe,pe)=>fe?(fe.push(pe),fe):[pe],ue,void 0,!0,void 0,me)}E.accumulate=V;function z(he,ue=(fe,pe)=>fe===pe,me){let fe=!0,pe;return $(he,Ce=>{const Le=fe||!ue(Ce,pe);return fe=!1,pe=Ce,Le},me)}E.latch=z;function x(he,ue,me){return[E.filter(he,ue,me),E.filter(he,fe=>!ue(fe),me)]}E.split=x;function ee(he,ue=!1,me=[],fe){let pe=me.slice(),Ce=he(Me=>{pe?pe.push(Me):Oe.fire(Me)});fe&&fe.add(Ce);const Le=()=>{pe?.forEach(Me=>Oe.fire(Me)),pe=null},Oe=new u({onWillAddFirstListener(){Ce||(Ce=he(Me=>Oe.fire(Me)),fe&&fe.add(Ce))},onDidAddFirstListener(){pe&&(ue?setTimeout(Le):Le())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return fe&&fe.add(Oe),Oe.event}E.buffer=ee;function ne(he,ue){return(fe,pe,Ce)=>{const Le=ue(new J);return he(function(Oe){const Me=Le.evaluate(Oe);Me!==re&&fe.call(pe,Me)},void 0,Ce)}}E.chain=ne;const re=Symbol("HaltChainable");class J{constructor(){this.steps=[]}map(ue){return this.steps.push(ue),this}forEach(ue){return this.steps.push(me=>(ue(me),me)),this}filter(ue){return this.steps.push(me=>ue(me)?me:re),this}reduce(ue,me){let fe=me;return this.steps.push(pe=>(fe=ue(fe,pe),fe)),this}latch(ue=(me,fe)=>me===fe){let me=!0,fe;return this.steps.push(pe=>{const Ce=me||!ue(pe,fe);return me=!1,fe=pe,Ce?pe:re}),this}evaluate(ue){for(const me of this.steps)if(ue=me(ue),ue===re)break;return ue}}function q(he,ue,me=fe=>fe){const fe=(...Oe)=>Le.fire(me(...Oe)),pe=()=>he.on(ue,fe),Ce=()=>he.removeListener(ue,fe),Le=new u({onWillAddFirstListener:pe,onDidRemoveLastListener:Ce});return Le.event}E.fromNodeEventEmitter=q;function P(he,ue,me=fe=>fe){const fe=(...Oe)=>Le.fire(me(...Oe)),pe=()=>he.addEventListener(ue,fe),Ce=()=>he.removeEventListener(ue,fe),Le=new u({onWillAddFirstListener:pe,onDidRemoveLastListener:Ce});return Le.event}E.fromDOMEventEmitter=P;function R(he){return new Promise(ue=>T(he)(ue))}E.toPromise=R;function W(he){const ue=new u;return he.then(me=>{ue.fire(me)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}E.fromPromise=W;function F(he,ue){return ue(void 0),he(me=>ue(me))}E.runAndSubscribe=F;function H(he,ue){let me=null;function fe(Ce){me?.dispose(),me=new A.DisposableStore,ue(Ce,me)}fe(void 0);const pe=he(Ce=>fe(Ce));return(0,A.toDisposable)(()=>{pe.dispose(),me?.dispose()})}E.runAndSubscribeWithStore=H;class Y{constructor(ue,me){this._observable=ue,this._counter=0,this._hasChanged=!1;const fe={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};me||d(fe),this.emitter=new u(fe),me&&me.add(this.emitter)}beginUpdate(ue){this._counter++}handlePossibleChange(ue){}handleChange(ue,me){this._hasChanged=!0}endUpdate(ue){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function se(he,ue){return new Y(he,ue).emitter.event}E.fromObservable=se;function le(he){return ue=>{let me=0,fe=!1;const pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(he.reportChanges(),fe&&(fe=!1,ue()))},handlePossibleChange(){},handleChange(){fe=!0}};return he.addObserver(pe),he.reportChanges(),{dispose(){he.removeObserver(pe)}}}}E.fromObservableLight=le})(f||(e.Event=f={}));class D{static{this.all=new Set}static{this._idPool=0}constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${D._idPool++}`,D.all.add(this)}start(d){this._stopWatch=new _.StopWatch,this.listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=D;let C=-1;function S(E){const d=C;return C=E,{dispose(){C=d}}}e.setGlobalLeakWarningThreshold=S;class c{constructor(d,v=Math.random().toString(18).slice(2,5)){this.threshold=d,this.name=v,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(d,v){const T=this.threshold;if(T<=0||v<T)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(d.value)||0;if(this._stacks.set(d.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let M,$=0;for(const[j,Z]of this._stacks)(!M||$<Z)&&(M=j,$=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${$}):`),console.warn(M)}return()=>{const M=this._stacks.get(d.value)||0;this._stacks.set(d.value,M-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class m{constructor(d){this.value=d,this.id=y++}}const h=2,l=(E,d)=>{if(E instanceof m)d(E);else for(let v=0;v<E.length;v++){const T=E[v];T&&d(T)}};class u{constructor(d){this._size=0,this._options=d,this._leakageMon=C>0||this._options?.leakWarningThreshold?new c(this._options?.leakWarningThreshold??C):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(L){const d=this._listeners;queueMicrotask(()=>{l(d,v=>v.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(d,v,T)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;v&&(d=d.bind(v));const N=new m(d);let M,$;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=g.create(),M=this._leakageMon.check(N.stack,this._size+1)),L&&(N.stack=$??g.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new b,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const j=(0,A.toDisposable)(()=>{M?.(),this._removeListener(N)});return T instanceof A.DisposableStore?T.add(j):Array.isArray(T)&&T.push(j),j},this._event}_removeListener(d){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const v=this._listeners,T=v.indexOf(d);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,v[T]=void 0;const N=this._deliveryQueue.current===this;if(this._size*h<=v.length){let M=0;for(let $=0;$<v.length;$++)v[$]?v[M++]=v[$]:N&&(this._deliveryQueue.end--,M<this._deliveryQueue.i&&this._deliveryQueue.i--);v.length=M}}_deliver(d,v){if(!d)return;const T=this._options?.onListenerError||k.onUnexpectedError;if(!T){d.value(v);return}try{d.value(v)}catch(N){T(N)}}_deliverQueue(d){const v=d.current._listeners;for(;d.i<d.end;)this._deliver(v[d.i++],d.value);d.reset()}fire(d){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,d);else{const v=this._deliveryQueue;v.enqueue(this,d,this._listeners.length),this._deliverQueue(v)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=u;const p=()=>new b;e.createEventDeliveryQueue=p;class b{constructor(){this.i=-1,this.end=0}enqueue(d,v,T){this.i=0,this.end=T,this.current=d,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends u{async fireAsync(d,v,T){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList),l(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,d]));this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[N,M]=this._asyncDeliveryQueue.shift(),$=[],j={...M,token:v,waitUntil:Z=>{if(Object.isFrozen($))throw new Error("waitUntil can NOT be called asynchronous");T&&(Z=T(Z,N)),$.push(Z)}};try{N(j)}catch(Z){(0,k.onUnexpectedError)(Z);continue}Object.freeze($),await Promise.allSettled($).then(Z=>{for(const G of Z)G.status==="rejected"&&(0,k.onUnexpectedError)(G.reason)})}}}e.AsyncEmitter=t;class a extends u{get isPaused(){return this._isPaused!==0}constructor(d){super(d),this._isPaused=0,this._eventQueue=new U.LinkedList,this._mergeFn=d?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._size&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=a;class n extends a{constructor(d){super(d),this._delay=d.delay??100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=n;class s extends u{constructor(d){super(d),this._queuedEvents=[],this._mergeFn=d?.merge}fire(d){this.hasListeners()&&(this._queuedEvents.push(d),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(v=>super.fire(v)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const v={event:d,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const T=()=>{this.hasListeners&&this.unhook(v);const N=this.events.indexOf(v);this.events.splice(N,1)};return(0,A.toDisposable)((0,O.createSingleCallFunction)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(v=>this.emitter.fire(v))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class r{constructor(d,v,T,N){this._store=new A.DisposableStore;const M=this._store.add(new i),$=this._store.add(new A.DisposableMap);function j(Z){$.set(Z,M.add(N(Z)))}for(const Z of d)j(Z);this._store.add(v(Z=>{j(Z)})),this._store.add(T(Z=>{$.deleteAndDispose(Z)})),this.event=M.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(d){return(v,T,N)=>d(M=>{const $=this.buffers[this.buffers.length-1];$?$.push(()=>v.call(T,M)):v.call(T,M)},void 0,N)}bufferEvents(d){const v=[];this.buffers.push(v);const T=d();return this.buffers.pop(),v.forEach(N=>N()),T}}e.EventBufferer=o;class w{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=A.Disposable.None,this.emitter=new u({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(oe[26],ae([0,1,3]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(L,I){const f=setTimeout(L.bind(I),0);return{dispose(){clearTimeout(f)}}});var A;(function(L){function I(f){return f===L.None||f===L.Cancelled||f instanceof U?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}L.isCancellationToken=I,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(A||(e.CancellationToken=A={}));class U{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new U),this._token}cancel(){this._token?this._token instanceof U&&this._token.cancel():this._token=A.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof U&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=_}),define(oe[129],ae([0,1,26]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(L){this.task=L,this.result=null}get(){if(this.result)return this.result;const L=new k.CancellationTokenSource,I=this.task(L.token);return this.result={promise:I,dispose:()=>{this.result=null,L.cancel(),L.dispose()}},this.result}}e.Cache=O;class A{constructor(L){this.fn=L,this.lastCache=void 0,this.lastArgKey=void 0}get(L){const I=JSON.stringify(L);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(L)),this.lastCache}}e.LRUCachedFunction=A;class U{get cachedValues(){return this._map}constructor(L){this.fn=L,this._map=new Map}get(L){if(this._map.has(L))return this._map.get(L);const I=this.fn(L);return this._map.set(L,I),I}}e.CachedFunction=U}),define(oe[46],ae([0,1,8,2]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function A(p){const b=p;return b?typeof b.read=="function":!1}e.isReadable=A;function U(p){const b=p;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=U;function _(p){const b=p;return b?U(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=_;function L(p,b){return new I(p,b)}e.newWriteableStream=L;class I{constructor(b,t){this.reducer=b,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(t=>t(b))}emitError(b){this.listeners.error.length===0?(0,k.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(t=>t(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,t){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(b,t){if(this.state.destroyed)return;let a;switch(b){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const n=a.indexOf(t);n>=0&&a.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(p,b){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return b(t)}e.consumeReadable=f;function D(p,b,t){const a=[];let n;for(;(n=p.read())!==null&&a.length<t;)a.push(n);return n===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return p.read()}}}e.peekReadable=D;function C(p,b){return new Promise((t,a)=>{const n=[];S(p,{onData:s=>{b&&n.push(s)},onError:s=>{b?a(s):t(void 0)},onEnd:()=>{t(b?b(n):void 0)}})})}e.consumeStream=C;function S(p,b,t){p.on("error",a=>{t?.isCancellationRequested||b.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||b.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||b.onData(a)})}e.listenStream=S;function c(p,b){return new Promise((t,a)=>{const n=new O.DisposableStore,s=[],i=w=>{if(s.push(w),s.length>b)return n.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=w=>(n.dispose(),a(w)),o=()=>(n.dispose(),t({stream:p,buffer:s,ended:!0}));n.add((0,O.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,O.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),n.add((0,O.toDisposable)(()=>p.removeListener("data",i))),p.on("data",i)})}e.peekStream=c;function g(p,b){const t=L(b);return t.end(p),t}e.toStream=g;function y(){const p=L(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=y;function m(p){let b=!1;return{read:()=>b?null:(b=!0,p)}}e.toReadable=m;function h(p,b,t){const a=L(t);return S(p,{onData:n=>a.write(b.data(n)),onError:n=>a.error(b.error?b.error(n):n),onEnd:()=>a.end()}),a}e.transform=h;function l(p,b,t){let a=!1;return{read:()=>{const n=b.read();return a?n:(a=!0,n!==null?t([p,n]):p)}}}e.prefixedReadable=l;function u(p,b,t){let a=!1;const n=L(t);return S(b,{onData:s=>a?n.write(s):(a=!0,n.write(t([p,s]))),onError:s=>n.error(s),onEnd:()=>{a||(a=!0,n.write(p)),n.end()}}),n}e.prefixedStream=u}),define(oe[15],ae([0,1,86,46]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const A=typeof Buffer<"u",U=new k.Lazy(()=>new Uint8Array(256));let _,L;class I{static alloc(v){return A?new I(Buffer.allocUnsafe(v)):new I(new Uint8Array(v))}static wrap(v){return A&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new I(v)}static fromString(v,T){return!(T?.dontUseNodeBuffer||!1)&&A?new I(Buffer.from(v)):(_||(_=new TextEncoder),new I(_.encode(v)))}static fromByteArray(v){const T=I.alloc(v.length);for(let N=0,M=v.length;N<M;N++)T.buffer[N]=v[N];return T}static concat(v,T){if(typeof T>"u"){T=0;for(let $=0,j=v.length;$<j;$++)T+=v[$].byteLength}const N=I.alloc(T);let M=0;for(let $=0,j=v.length;$<j;$++){const Z=v[$];N.set(Z,M),M+=Z.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=I.alloc(this.byteLength);return v.set(this),v}toString(){return A?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(v,T){return new I(this.buffer.subarray(v,T))}set(v,T){if(v instanceof I)this.buffer.set(v.buffer,T);else if(v instanceof Uint8Array)this.buffer.set(v,T);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),T);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return S(this.buffer,v)}writeUInt32BE(v,T){c(this.buffer,v,T)}readUInt32LE(v){return g(this.buffer,v)}writeUInt32LE(v,T){y(this.buffer,v,T)}readUInt8(v){return m(this.buffer,v)}writeUInt8(v,T){h(this.buffer,v,T)}indexOf(v,T=0){return f(this.buffer,v instanceof I?v.buffer:v,T)}}e.VSBuffer=I;function f(d,v,T=0){const N=v.byteLength,M=d.byteLength;if(N===0)return 0;if(N===1)return d.indexOf(v[0]);if(N>M-T)return-1;const $=U.value;$.fill(v.length);for(let Q=0;Q<v.length;Q++)$[v[Q]]=v.length-Q-1;let j=T+v.length-1,Z=j,G=-1;for(;j<M;)if(d[j]===v[Z]){if(Z===0){G=j;break}j--,Z--}else j+=Math.max(v.length-Z,$[d[j]]),Z=v.length-1;return G}e.binaryIndexOf=f;function D(d,v){return d[v+0]<<0>>>0|d[v+1]<<8>>>0}e.readUInt16LE=D;function C(d,v,T){d[T+0]=v&255,v=v>>>8,d[T+1]=v&255}e.writeUInt16LE=C;function S(d,v){return d[v]*2**24+d[v+1]*2**16+d[v+2]*2**8+d[v+3]}e.readUInt32BE=S;function c(d,v,T){d[T+3]=v,v=v>>>8,d[T+2]=v,v=v>>>8,d[T+1]=v,v=v>>>8,d[T]=v}e.writeUInt32BE=c;function g(d,v){return d[v+0]<<0>>>0|d[v+1]<<8>>>0|d[v+2]<<16>>>0|d[v+3]<<24>>>0}e.readUInt32LE=g;function y(d,v,T){d[T+0]=v&255,v=v>>>8,d[T+1]=v&255,v=v>>>8,d[T+2]=v&255,v=v>>>8,d[T+3]=v&255}e.writeUInt32LE=y;function m(d,v){return d[v]}e.readUInt8=m;function h(d,v,T){d[T]=v}e.writeUInt8=h;function l(d){return O.consumeReadable(d,v=>I.concat(v))}e.readableToBuffer=l;function u(d){return O.toReadable(d)}e.bufferToReadable=u;function p(d){return O.consumeStream(d,v=>I.concat(v))}e.streamToBuffer=p;async function b(d){return d.ended?I.concat(d.buffer):I.concat([...d.buffer,await p(d.stream)])}e.bufferedStreamToBuffer=b;function t(d){return O.toStream(d,v=>I.concat(v))}e.bufferToStream=t;function a(d){return O.transform(d,{data:v=>typeof v=="string"?I.fromString(v):I.wrap(v)},v=>I.concat(v))}e.streamToBufferReadableStream=a;function n(d){return O.newWriteableStream(v=>I.concat(v),d)}e.newWriteableBufferStream=n;function s(d,v){return O.prefixedReadable(d,v,T=>I.concat(T))}e.prefixedBufferReadable=s;function i(d,v){return O.prefixedStream(d,v,T=>I.concat(T))}e.prefixedBufferStream=i;function r(d){let v=0,T=0,N=0;const M=new Uint8Array(Math.floor(d.length/4*3)),$=Z=>{switch(T){case 3:M[N++]=v|Z,T=0;break;case 2:M[N++]=v|Z>>>2,v=Z<<6,T=3;break;case 1:M[N++]=v|Z>>>4,v=Z<<4,T=2;break;default:v=Z<<2,T=1}};for(let Z=0;Z<d.length;Z++){const G=d.charCodeAt(Z);if(G>=65&&G<=90)$(G-65);else if(G>=97&&G<=122)$(G-97+26);else if(G>=48&&G<=57)$(G-48+52);else if(G===43||G===45)$(62);else if(G===47||G===95)$(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${d[Z]}`)}}const j=N;for(;T>0;)$(0);return I.wrap(M).slice(0,j)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:d},v=!0,T=!1){const N=T?w:o;let M="";const $=d.byteLength%3;let j=0;for(;j<d.byteLength-$;j+=3){const Z=d[j+0],G=d[j+1],Q=d[j+2];M+=N[Z>>>2],M+=N[(Z<<4|G>>>4)&63],M+=N[(G<<2|Q>>>6)&63],M+=N[Q&63]}if($===1){const Z=d[j+0];M+=N[Z>>>2],M+=N[Z<<4&63],v&&(M+="==")}else if($===2){const Z=d[j+0],G=d[j+1];M+=N[Z>>>2],M+=N[(Z<<4|G>>>4)&63],M+=N[G<<2&63],v&&(M+="=")}return M}e.encodeBase64=E}),define(oe[27],ae([0,1,129,86]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=A;const U=/{(\d+)}/g;function _(ie,...de){return de.length===0?ie:ie.replace(U,function(Se,Ee){const be=parseInt(Ee,10);return isNaN(be)||be<0||be>=de.length?Se:de[be]})}e.format=_;const L=/{([^}]+)}/g;function I(ie,de){return ie.replace(L,(Se,Ee)=>de[Ee]??Se)}e.format2=I;function f(ie){return ie.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=f;function D(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function C(ie,de){let Se=0;const Ee=de.charCodeAt(0);for(let be=ie.length-1;be>=0;be--)ie.charCodeAt(be)===Ee&&Se++;return Se}e.count=C;function S(ie,de,Se="\u2026"){return ie.length<=de?ie:`${ie.substr(0,de)}${Se}`}e.truncate=S;function c(ie,de=" "){const Se=g(ie,de);return y(Se,de)}e.trim=c;function g(ie,de){if(!ie||!de)return ie;const Se=de.length;if(Se===0||ie.length===0)return ie;let Ee=0;for(;ie.indexOf(de,Ee)===Ee;)Ee=Ee+Se;return ie.substring(Ee)}e.ltrim=g;function y(ie,de){if(!ie||!de)return ie;const Se=de.length,Ee=ie.length;if(Se===0||Ee===0)return ie;let be=Ee,Re=-1;for(;Re=ie.lastIndexOf(de,be-1),!(Re===-1||Re+Se!==be);){if(Re===0)return"";be=Re}return ie.substring(0,be)}e.rtrim=y;function m(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function h(ie){return ie.replace(/\*/g,"")}e.stripWildcards=h;function l(ie,de,Se={}){if(!ie)throw new Error("Cannot create regex from empty string");de||(ie=D(ie)),Se.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Ee="";return Se.global&&(Ee+="g"),Se.matchCase||(Ee+="i"),Se.multiline&&(Ee+="m"),Se.unicode&&(Ee+="u"),new RegExp(ie,Ee)}e.createRegExp=l;function u(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function p(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=p;function b(ie){for(let de=0,Se=ie.length;de<Se;de++){const Ee=ie.charCodeAt(de);if(Ee!==32&&Ee!==9)return de}return-1}e.firstNonWhitespaceIndex=b;function t(ie,de=0,Se=ie.length){for(let Ee=de;Ee<Se;Ee++){const be=ie.charCodeAt(Ee);if(be!==32&&be!==9)return ie.substring(de,Ee)}return ie.substring(de,Se)}e.getLeadingWhitespace=t;function a(ie,de=ie.length-1){for(let Se=de;Se>=0;Se--){const Ee=ie.charCodeAt(Se);if(Ee!==32&&Ee!==9)return Se}return-1}e.lastNonWhitespaceIndex=a;function n(ie,de,Se){const Ee=[];let be=0;for(const Re of ie.matchAll(de)){if(Ee.push(ie.slice(be,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");be=Re.index+Re[0].length,Ee.push(Se(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return Ee.push(ie.slice(be)),Promise.all(Ee).then(Re=>Re.join(""))}e.replaceAsync=n;function s(ie,de){return ie<de?-1:ie>de?1:0}e.compare=s;function i(ie,de,Se=0,Ee=ie.length,be=0,Re=de.length){for(;Se<Ee&&be<Re;Se++,be++){const _e=ie.charCodeAt(Se),Ue=de.charCodeAt(be);if(_e<Ue)return-1;if(_e>Ue)return 1}const Ie=Ee-Se,ke=Re-be;return Ie<ke?-1:Ie>ke?1:0}e.compareSubstring=i;function r(ie,de){return o(ie,de,0,ie.length,0,de.length)}e.compareIgnoreCase=r;function o(ie,de,Se=0,Ee=ie.length,be=0,Re=de.length){for(;Se<Ee&&be<Re;Se++,be++){let _e=ie.charCodeAt(Se),Ue=de.charCodeAt(be);if(_e===Ue)continue;if(_e>=128||Ue>=128)return i(ie.toLowerCase(),de.toLowerCase(),Se,Ee,be,Re);E(_e)&&(_e-=32),E(Ue)&&(Ue-=32);const Ne=_e-Ue;if(Ne!==0)return Ne}const Ie=Ee-Se,ke=Re-be;return Ie<ke?-1:Ie>ke?1:0}e.compareSubstringIgnoreCase=o;function w(ie){return ie>=48&&ie<=57}e.isAsciiDigit=w;function E(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=E;function d(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=d;function v(ie,de){return ie.length===de.length&&o(ie,de)===0}e.equalsIgnoreCase=v;function T(ie,de){const Se=de.length;return de.length>ie.length?!1:o(ie,de,0,Se)===0}e.startsWithIgnoreCase=T;function N(ie,de){const Se=Math.min(ie.length,de.length);let Ee;for(Ee=0;Ee<Se;Ee++)if(ie.charCodeAt(Ee)!==de.charCodeAt(Ee))return Ee;return Se}e.commonPrefixLength=N;function M(ie,de){const Se=Math.min(ie.length,de.length);let Ee;const be=ie.length-1,Re=de.length-1;for(Ee=0;Ee<Se;Ee++)if(ie.charCodeAt(be-Ee)!==de.charCodeAt(Re-Ee))return Ee;return Se}e.commonSuffixLength=M;function $(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=$;function j(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=j;function Z(ie,de){return(ie-55296<<10)+(de-56320)+65536}e.computeCodePoint=Z;function G(ie,de,Se){const Ee=ie.charCodeAt(Se);if($(Ee)&&Se+1<de){const be=ie.charCodeAt(Se+1);if(j(be))return Z(Ee,be)}return Ee}e.getNextCodePoint=G;function Q(ie,de){const Se=ie.charCodeAt(de-1);if(j(Se)&&de>1){const Ee=ie.charCodeAt(de-2);if($(Ee))return Z(Ee,Se)}return Se}class B{get offset(){return this._offset}constructor(de,Se=0){this._str=de,this._len=de.length,this._offset=Se}setOffset(de){this._offset=de}prevCodePoint(){const de=Q(this._str,this._offset);return this._offset-=de>=65536?2:1,de}nextCodePoint(){const de=G(this._str,this._len,this._offset);return this._offset+=de>=65536?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class K{get offset(){return this._iterator.offset}constructor(de,Se=0){this._iterator=new B(de,Se)}nextGraphemeLength(){const de=ge.getInstance(),Se=this._iterator,Ee=Se.offset;let be=de.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Re=Se.offset,Ie=de.getGraphemeBreakType(Se.nextCodePoint());if(Me(be,Ie)){Se.setOffset(Re);break}be=Ie}return Se.offset-Ee}prevGraphemeLength(){const de=ge.getInstance(),Se=this._iterator,Ee=Se.offset;let be=de.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Re=Se.offset,Ie=de.getGraphemeBreakType(Se.prevCodePoint());if(Me(Ie,be)){Se.setOffset(Re);break}be=Ie}return Ee-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function V(ie,de){return new K(ie,de).nextGraphemeLength()}e.nextCharLength=V;function z(ie,de){return new K(ie,de).prevGraphemeLength()}e.prevCharLength=z;function x(ie,de){de>0&&j(ie.charCodeAt(de))&&de--;const Se=de+V(ie,de);return[Se-z(ie,Se),Se]}e.getCharContainingOffset=x;function ee(ie){const de=new K(ie);let Se=0;for(;!de.eol();)Se++,de.nextGraphemeLength();return Se}e.charCount=ee;let ne;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function J(ie){return ne||(ne=re()),ne.test(ie)}e.containsRTL=J;const q=/^[\t\n\r\x20-\x7E]*$/;function P(ie){return q.test(ie)}e.isBasicASCII=P,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function R(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=R;function W(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=W;function F(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=F;function H(ie,de){if(ie.length<de)return ie;const Se=/\b/g;let Ee=0;for(;Se.test(ie)&&!(ie.length-Se.lastIndex<de);)Ee=Se.lastIndex,Se.lastIndex+=1;return ie.substring(Ee).replace(/^\s/,"")}e.lcut=H;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(Y,"").replace(se,"")),ie}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function ue(ie){return he(ie)?ie.substr(1):ie}e.stripUTF8BOM=ue;function me(ie,de){if(!ie||!de||ie.length<de.length)return!1;const Se=de.length,Ee=ie.toLowerCase();let be=0,Re=-1;for(;be<Se;){const Ie=Ee.indexOf(de[be],Re+1);if(Ie<0)return!1;Re=Ie,be++}return!0}e.fuzzyContains=me;function fe(ie,de=!1){return ie?(de&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=fe;function pe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=pe;function Ce(ie,de=1){if(de===0)return"";let Se=-1;do Se=ie.indexOf(`
`,Se+1),de--;while(de>0&&Se>=0);return Se===-1?ie:(ie[Se-1]==="\r"&&Se--,ie.substr(0,Se))}e.getNLines=Ce;function Le(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=Le;function Oe(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=Oe;function Me(ie,de){return ie===0?de!==5&&de!==7:ie===2&&de===3?!1:ie===4||ie===2||ie===3||de===4||de===2||de===3?!0:!(ie===8&&(de===8||de===9||de===11||de===12)||(ie===11||ie===9)&&(de===9||de===10)||(ie===12||ie===10)&&de===10||de===5||de===13||de===7||ie===1||ie===13&&de===14||ie===6&&de===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this._INSTANCE=null}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}constructor(){this._data=ve()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const Se=this._data,Ee=Se.length/3;let be=1;for(;be<=Ee;)if(de<Se[3*be])be=2*be;else if(de>Se[3*be+1])be=2*be+1;else return Se[3*be+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(ie,de){if(ie===0)return 0;const Se=De(ie,de);if(Se!==void 0)return Se;const Ee=new B(de,ie);return Ee.prevCodePoint(),Ee.offset}e.getLeftDeleteOffset=Pe;function De(ie,de){const Se=new B(de,ie);let Ee=Se.prevCodePoint();for(;$e(Ee)||Ee===65039||Ee===8419;){if(Se.offset===0)return;Ee=Se.prevCodePoint()}if(!F(Ee))return;let be=Se.offset;return be>0&&Se.prevCodePoint()===8205&&(be=Se.offset),be}function $e(ie){return 127995<=ie&&ie<=127999}var Te;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class We{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new k.LRUCachedFunction(de=>{function Se(Ne){const qe=new Map;for(let je=0;je<Ne.length;je+=2)qe.set(Ne[je],Ne[je+1]);return qe}function Ee(Ne,qe){const je=new Map(Ne);for(const[xe,Ze]of qe)je.set(xe,Ze);return je}function be(Ne,qe){if(!Ne)return qe;const je=new Map;for(const[xe,Ze]of Ne)qe.has(xe)&&je.set(xe,Ze);return je}const Re=this.ambiguousCharacterData.value;let Ie=de.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ie.length===0&&(Ie=["_default"]);let ke;for(const Ne of Ie){const qe=Se(Re[Ne]);ke=be(ke,qe)}const _e=Se(Re._common),Ue=Ee(_e,ke);return new We(Ue)})}static getInstance(de){return We.cache.get(Array.from(de))}static{this._locales=new O.Lazy(()=>Object.keys(We.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return We._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=We;class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(de){return Fe.getData().has(de)}static get codePoints(){return Fe.getData()}}e.InvisibleCharacters=Fe}),define(oe[51],ae([0,1,27]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(h){return A(h,0)}e.hash=O;function A(h,l){switch(typeof h){case"object":return h===null?U(349,l):Array.isArray(h)?I(h,l):f(h,l);case"string":return L(h,l);case"boolean":return _(h,l);case"number":return U(h,l);case"undefined":return U(937,l);default:return U(617,l)}}e.doHash=A;function U(h,l){return(l<<5)-l+h|0}e.numberHash=U;function _(h,l){return U(h?433:863,l)}function L(h,l){l=U(149417,l);for(let u=0,p=h.length;u<p;u++)l=U(h.charCodeAt(u),l);return l}e.stringHash=L;function I(h,l){return l=U(104579,l),h.reduce((u,p)=>A(p,u),l)}function f(h,l){return l=U(181387,l),Object.keys(h).sort().reduce((u,p)=>(u=L(p,u),A(h[p],u)),l)}class D{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=A(l,this._value),this._value}}e.Hasher=D;var C;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function S(h,l,u=32){const p=u-l,b=~((1<<p)-1);return(h<<l|(b&h)>>>p)>>>0}function c(h,l=0,u=h.byteLength,p=0){for(let b=0;b<u;b++)h[l+b]=p}function g(h,l,u="0"){for(;h.length<l;)h=u+h;return h}function y(h,l=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),l/4)}e.toHexString=y;class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const u=l.length;if(u===0)return;const p=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,a,n;for(t!==0?(a=t,n=-1,t=0):(a=l.charCodeAt(0),n=0);;){let s=a;if(k.isHighSurrogate(a))if(n+1<u){const i=l.charCodeAt(n+1);k.isLowSurrogate(i)?(n++,s=k.computeCodePoint(a,i)):s=65533}else{t=a;break}else k.isLowSurrogate(a)&&(s=65533);if(b=this._push(p,b,s),n++,n<u)a=l.charCodeAt(n);else break}this._buffLen=b,this._leftoverHighSurrogate=t}_push(l,u,p){return p<128?l[u++]=p:p<2048?(l[u++]=192|(p&1984)>>>6,l[u++]=128|(p&63)>>>0):p<65536?(l[u++]=224|(p&61440)>>>12,l[u++]=128|(p&4032)>>>6,l[u++]=128|(p&63)>>>0):(l[u++]=240|(p&1835008)>>>18,l[u++]=128|(p&258048)>>>12,l[u++]=128|(p&4032)>>>6,l[u++]=128|(p&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=m._bigBlock32,u=this._buffDV;for(let o=0;o<64;o+=4)l.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)l.setUint32(o,S(l.getUint32(o-12,!1)^l.getUint32(o-32,!1)^l.getUint32(o-56,!1)^l.getUint32(o-64,!1),1),!1);let p=this._h0,b=this._h1,t=this._h2,a=this._h3,n=this._h4,s,i,r;for(let o=0;o<80;o++)o<20?(s=b&t|~b&a,i=1518500249):o<40?(s=b^t^a,i=1859775393):o<60?(s=b&t|b&a|t&a,i=2400959708):(s=b^t^a,i=3395469782),r=S(p,5)+s+n+i+l.getUint32(o*4,!1)&4294967295,n=a,a=t,t=S(b,30),b=p,p=r;this._h0=this._h0+p&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=m}),define(oe[89],ae([0,1,27]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(O||(O={})),function(A){const U="error",_="warning",L="warn",I="info",f="ignore";function D(S){return S?k.equalsIgnoreCase(U,S)?A.Error:k.equalsIgnoreCase(_,S)||k.equalsIgnoreCase(L,S)?A.Warning:k.equalsIgnoreCase(I,S)?A.Info:A.Ignore:A.Ignore}A.fromValue=D;function C(S){switch(S){case A.Error:return U;case A.Warning:return _;case A.Info:return I;default:return f}}A.toString=C}(O||(O={})),e.default=O}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const g=c.charCodeAt(0),y=this._value.charCodeAt(this._pos);return g-y}value(){return this._value[this._pos]}}e.StringIterator=A;class U{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,O.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=U;class _{constructor(c=!0,g=!0){this._splitOnBackslash=c,this._caseSensitive=g}reset(c){this._from=0,this._to=0,this._value=c,this._valueLen=c.length;for(let g=c.length-1;g>=0;g--,this._valueLen--){const y=this._value.charCodeAt(g);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let c=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,O.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var L;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(L||(L={}));class I{constructor(c,g){this._ignorePathCasing=c,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(c)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===4)return(0,O.compare)(c,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(D||(D={}));class C{static forUris(c=()=>!1,g=()=>!1){return new C(new I(c,g))}static forPaths(c=!1){return new C(new _(void 0,!c))}static forStrings(){return new C(new A)}static forConfigKeys(){return new C(new U)}constructor(c){this._iter=c}clear(){this._root=void 0}fill(c,g){if(g){const y=g.slice(0);(0,k.shuffle)(y);for(const m of y)this.set(m,c)}else{const y=c.slice(0);(0,k.shuffle)(y);for(const m of y)this.set(m[0],m[1])}}set(c,g){const y=this._iter.reset(c);let m;this._root||(this._root=new f,this._root.segment=y.value());const h=[];for(m=this._root;;){const u=y.cmp(m.segment);if(u>0)m.left||(m.left=new f,m.left.segment=y.value()),h.push([-1,m]),m=m.left;else if(u<0)m.right||(m.right=new f,m.right.segment=y.value()),h.push([1,m]),m=m.right;else if(y.hasNext())y.next(),m.mid||(m.mid=new f,m.mid.segment=y.value()),h.push([0,m]),m=m.mid;else break}const l=m.value;m.value=g,m.key=c;for(let u=h.length-1;u>=0;u--){const p=h[u][1];p.updateHeight();const b=p.balanceFactor();if(b<-1||b>1){const t=h[u][0],a=h[u+1][0];if(t===1&&a===1)h[u][1]=p.rotateLeft();else if(t===-1&&a===-1)h[u][1]=p.rotateRight();else if(t===1&&a===-1)p.right=h[u+1][1]=h[u+1][1].rotateRight(),h[u][1]=p.rotateLeft();else if(t===-1&&a===1)p.left=h[u+1][1]=h[u+1][1].rotateLeft(),h[u][1]=p.rotateRight();else throw new Error;if(u>0)switch(h[u-1][0]){case-1:h[u-1][1].left=h[u][1];break;case 1:h[u-1][1].right=h[u][1];break;case 0:h[u-1][1].mid=h[u][1];break}else this._root=h[0][1]}}return l}get(c){return this._getNode(c)?.value}_getNode(c){const g=this._iter.reset(c);let y=this._root;for(;y;){const m=g.cmp(y.segment);if(m>0)y=y.left;else if(m<0)y=y.right;else if(g.hasNext())g.next(),y=y.mid;else break}return y}has(c){const g=this._getNode(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,g){const y=this._iter.reset(c),m=[];let h=this._root;for(;h;){const l=y.cmp(h.segment);if(l>0)m.push([-1,h]),h=h.left;else if(l<0)m.push([1,h]),h=h.right;else if(y.hasNext())y.next(),m.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const l=this._min(h.right);if(l.key){const{key:u,value:p,segment:b}=l;this._delete(l.key,!1),h.key=u,h.value=p,h.segment=b}}else{const l=h.left??h.right;if(m.length>0){const[u,p]=m[m.length-1];switch(u){case-1:p.left=l;break;case 0:p.mid=l;break;case 1:p.right=l;break}}else this._root=l}for(let l=m.length-1;l>=0;l--){const u=m[l][1];u.updateHeight();const p=u.balanceFactor();if(p>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),m[l][1]=u.rotateLeft()):p<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),m[l][1]=u.rotateRight()),l>0)switch(m[l-1][0]){case-1:m[l-1][1].left=m[l][1];break;case 1:m[l-1][1].right=m[l][1];break;case 0:m[l-1][1].mid=m[l][1];break}else this._root=m[0][1]}}}_min(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this._iter.reset(c);let y=this._root,m;for(;y;){const h=g.cmp(y.segment);if(h>0)y=y.left;else if(h<0)y=y.right;else if(g.hasNext())g.next(),m=y.value||m,y=y.mid;else break}return y&&y.value||m}findSuperstr(c){return this._findSuperstrOrElement(c,!1)}_findSuperstrOrElement(c,g){const y=this._iter.reset(c);let m=this._root;for(;m;){const h=y.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(y.hasNext())y.next(),m=m.mid;else return m.mid?this._entries(m.mid):g?m.value:void 0}}hasElementOrSubtree(c){return this._findSuperstrOrElement(c,!0)!==void 0}forEach(c){for(const[g,y]of this)c(y,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(c){const g=[];return this._dfsEntries(c,g),g[Symbol.iterator]()}_dfsEntries(c,g){c&&(c.left&&this._dfsEntries(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this._dfsEntries(c.mid,g),c.right&&this._dfsEntries(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const y=g.balanceFactor();return y<-1||y>1?!1:c(g.left)&&c(g.right)};return c(this._root)}}e.TernarySearchTree=C}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(b){return typeof b=="string"}e.isString=k;function O(b){return Array.isArray(b)&&b.every(t=>k(t))}e.isStringArray=O;function A(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=A;function U(b){const t=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof t}e.isTypedArray=U;function _(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=_;function L(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=L;function I(b){return b===!0||b===!1}e.isBoolean=I;function f(b){return typeof b>"u"}e.isUndefined=f;function D(b){return!C(b)}e.isDefined=D;function C(b){return f(b)||b===null}e.isUndefinedOrNull=C;function S(b,t){if(!b)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function c(b){if(C(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=c;function g(...b){const t=[];for(let a=0;a<b.length;a++){const n=b[a];if(C(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(n)}return t}e.assertAllDefined=g;const y=Object.prototype.hasOwnProperty;function m(b){if(!A(b))return!1;for(const t in b)if(y.call(b,t))return!1;return!0}e.isEmptyObject=m;function h(b){return typeof b=="function"}e.isFunction=h;function l(...b){return b.length>0&&b.every(h)}e.areFunctions=l;function u(b,t){const a=Math.min(b.length,t.length);for(let n=0;n<a;n++)p(b[n],t[n])}e.validateConstraints=u;function p(b,t){if(k(t)){if(typeof b!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(b instanceof t)return}catch{}if(!C(b)&&b.constructor===t||t.length===1&&t.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p}),define(oe[30],ae([0,1,12]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const l=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([u,p])=>{l[u]=p&&typeof p=="object"?O(p):p}),l}e.deepClone=O;function A(h){if(!h||typeof h!="object")return h;const l=[h];for(;l.length>0;){const u=l.shift();Object.freeze(u);for(const p in u)if(U.call(u,p)){const b=u[p];typeof b=="object"&&!Object.isFrozen(b)&&!(0,k.isTypedArray)(b)&&l.push(b)}}return h}e.deepFreeze=A;const U=Object.prototype.hasOwnProperty;function _(h,l){return L(h,l,new Set)}e.cloneAndChange=_;function L(h,l,u){if((0,k.isUndefinedOrNull)(h))return h;const p=l(h);if(typeof p<"u")return p;if(Array.isArray(h)){const b=[];for(const t of h)b.push(L(t,l,u));return b}if((0,k.isObject)(h)){if(u.has(h))throw new Error("Cannot clone recursive data-structure");u.add(h);const b={};for(const t in h)U.call(h,t)&&(b[t]=L(h[t],l,u));return u.delete(h),b}return h}function I(h,l,u=!0){return(0,k.isObject)(h)?((0,k.isObject)(l)&&Object.keys(l).forEach(p=>{p in h?u&&((0,k.isObject)(h[p])&&(0,k.isObject)(l[p])?I(h[p],l[p],u):h[p]=l[p]):h[p]=l[p]}),h):l}e.mixin=I;function f(h,l){if(h===l)return!0;if(h==null||l===null||l===void 0||typeof h!=typeof l||typeof h!="object"||Array.isArray(h)!==Array.isArray(l))return!1;let u,p;if(Array.isArray(h)){if(h.length!==l.length)return!1;for(u=0;u<h.length;u++)if(!f(h[u],l[u]))return!1}else{const b=[];for(p in h)b.push(p);b.sort();const t=[];for(p in l)t.push(p);if(t.sort(),!f(b,t))return!1;for(u=0;u<b.length;u++)if(!f(h[b[u]],l[b[u]]))return!1}return!0}e.equals=f;function D(h){const l=new Set;return JSON.stringify(h,(u,p)=>{if((0,k.isObject)(p)||Array.isArray(p)){if(l.has(p))return"[Circular]";l.add(p)}return p})}e.safeStringify=D;function C(h,l){const u=Object.create(null);return!h||!l||Object.keys(l).forEach(b=>{const t=h[b],a=l[b];f(t,a)||(u[b]=a)}),u}e.distinct=C;function S(h,l){const u=l.toLowerCase(),p=Object.keys(h).find(b=>b.toLowerCase()===u);return p?h[p]:h[l]}e.getCaseInsensitive=S;function c(h,l){const u=Object.create(null);for(const[p,b]of Object.entries(h))l(p,b)&&(u[p]=b);return u}e.filter=c;function g(h){let l=[];for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=g;function y(h){const l=[];for(const u of g(h))typeof h[u]=="function"&&l.push(u);return l}e.getAllMethodNames=y;function m(h,l){const u=b=>function(){const t=Array.prototype.slice.call(arguments,0);return l(b,t)},p={};for(const b of h)p[b]=u(b);return p}e.createProxyObject=m}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(A){return k.test(A)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(L){for(let I=0;I<L.length;I++)L[I]=Math.floor(Math.random()*256);return L};const U=new Uint8Array(16),_=[];for(let L=0;L<256;L++)_.push(L.toString(16).padStart(2,"0"));return function(){A(U),U[6]=U[6]&15|64,U[8]=U[8]&63|128;let I=0,f="";return f+=_[U[I++]],f+=_[U[I++]],f+=_[U[I++]],f+=_[U[I++]],f+="-",f+=_[U[I++]],f+=_[U[I++]],f+="-",f+=_[U[I++]],f+=_[U[I++]],f+="-",f+=_[U[I++]],f+=_[U[I++]],f+="-",f+=_[U[I++]],f+=_[U[I++]],f+=_[U[I++]],f+=_[U[I++]],f+=_[U[I++]],f+=_[U[I++]],f}}()}),define(oe[131],ae([0,1,36]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(_){const L=_.replace(/\-/g,":").toLowerCase();return!O.has(L)}function U(){const _=(0,k.networkInterfaces)();for(const L in _){const I=_[L];if(I){for(const{mac:f}of I)if(A(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=U}),define(oe[132],ae([0,1,36,47,32,131]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(f){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(f)}value(){if(this._value===void 0){let f=0,D=0;const C=(0,k.networkInterfaces)();for(const S in C){const c=C[S];if(c)for(const{mac:g,internal:y}of c)y||(D+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(f+=1))}this._value=D>0?f/D:0}return this._value}};let _;async function L(f){return _||(_=(async()=>await I(f)||A.generateUuid())()),_}e.getMachineId=L;async function I(f){try{const D=await new Promise((S,c)=>{te(["crypto"],S,c)}),C=(0,U.getMac)();return D.createHash("sha256").update(C,"utf8").digest("hex")}catch(D){f(D);return}}}),define(oe[133],ae([0,1,268,15]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class A extends k.Transform{constructor(_){if(super(),typeof _=="number")this.splitter=_,this.spitterLen=1;else{const L=Buffer.isBuffer(_)?_:Buffer.from(_);this.splitter=L.length===1?L[0]:L,this.spitterLen=L.length}}_transform(_,L,I){this.buffer?this.buffer=Buffer.concat([this.buffer,_]):this.buffer=_;let f=0;for(;f<this.buffer.length;){const D=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,f):(0,O.binaryIndexOf)(this.buffer,this.splitter,f);if(D===-1)break;this.push(this.buffer.slice(f,D+this.spitterLen)),f=D+this.spitterLen}this.buffer=f===this.buffer.length?void 0:this.buffer.slice(f),I()}_flush(_){this.buffer&&this.push(this.buffer),_()}}e.StreamSplitter=A}),define(oe[134],ae([0,1,61]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(L,I,f,D=1){let C=!1;return new Promise(S=>{const c=setTimeout(()=>{if(!C)return C=!0,S(0)},f);A(L,I,D,g=>{if(!C)return C=!0,clearTimeout(c),S(g)})})}e.findFreePort=O;function A(L,I,f,D){if(I===0)return D(0);const C=new k.Socket;C.once("connect",()=>(_(C),A(L+f,I-1,f,D))),C.once("data",()=>{}),C.once("error",S=>(_(C),S.code!=="ECONNREFUSED"?A(L+f,I-1,f,D):D(L))),C.connect(L,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function U(L,I,f,D="127.0.0.1"){let C=!1,S,c=1;const g=k.createServer({pauseOnConnect:!0});function y(m,h){C||(C=!0,g.removeAllListeners(),g.close(),S&&clearTimeout(S),h(m))}return new Promise(m=>{S=setTimeout(()=>{y(0,m)},f),g.on("listening",()=>{y(L,m)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&c<I?(L++,c++,g.listen(L,D)):y(0,m)}),g.on("close",()=>{y(0,m)}),g.listen(L,D)})}e.findFreePortFaster=U;function _(L){try{L.removeAllListeners("connect"),L.removeAllListeners("error"),L.end(),L.destroy(),L.unref()}catch(I){console.error(I)}}}),define(oe[135],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(O){return!!O.parentPort}e.isUtilityProcess=k}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,136]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,A=O*60,U=A*24,_=U*7,L=U*30,I=U*365;function f(C,S,c,g){typeof C!="number"&&(C=C.getTime());const y=Math.round((new Date().getTime()-C)/1e3);if(y<-30)return(0,k.localize)(0,null,f(new Date().getTime()+y*1e3,!1));if(!g&&y<30)return(0,k.localize)(1,null);let m;return y<O?(m=y,S?m===1?c?(0,k.localize)(2,null,m):(0,k.localize)(3,null,m):c?(0,k.localize)(4,null,m):(0,k.localize)(5,null,m):m===1?c?(0,k.localize)(6,null,m):(0,k.localize)(7,null,m):c?(0,k.localize)(8,null,m):(0,k.localize)(9,null,m)):y<A?(m=Math.floor(y/O),S?m===1?c?(0,k.localize)(10,null,m):(0,k.localize)(11,null,m):c?(0,k.localize)(12,null,m):(0,k.localize)(13,null,m):m===1?c?(0,k.localize)(14,null,m):(0,k.localize)(15,null,m):c?(0,k.localize)(16,null,m):(0,k.localize)(17,null,m)):y<U?(m=Math.floor(y/A),S?m===1?c?(0,k.localize)(18,null,m):(0,k.localize)(19,null,m):c?(0,k.localize)(20,null,m):(0,k.localize)(21,null,m):m===1?c?(0,k.localize)(22,null,m):(0,k.localize)(23,null,m):c?(0,k.localize)(24,null,m):(0,k.localize)(25,null,m)):y<_?(m=Math.floor(y/U),S?m===1?(0,k.localize)(26,null,m):(0,k.localize)(27,null,m):m===1?(0,k.localize)(28,null,m):(0,k.localize)(29,null,m)):y<L?(m=Math.floor(y/_),S?m===1?c?(0,k.localize)(30,null,m):(0,k.localize)(31,null,m):c?(0,k.localize)(32,null,m):(0,k.localize)(33,null,m):m===1?c?(0,k.localize)(34,null,m):(0,k.localize)(35,null,m):c?(0,k.localize)(36,null,m):(0,k.localize)(37,null,m)):y<I?(m=Math.floor(y/L),S?m===1?c?(0,k.localize)(38,null,m):(0,k.localize)(39,null,m):c?(0,k.localize)(40,null,m):(0,k.localize)(41,null,m):m===1?c?(0,k.localize)(42,null,m):(0,k.localize)(43,null,m):c?(0,k.localize)(44,null,m):(0,k.localize)(45,null,m)):(m=Math.floor(y/I),S?m===1?c?(0,k.localize)(46,null,m):(0,k.localize)(47,null,m):c?(0,k.localize)(48,null,m):(0,k.localize)(49,null,m):m===1?c?(0,k.localize)(50,null,m):(0,k.localize)(51,null,m):c?(0,k.localize)(52,null,m):(0,k.localize)(53,null,m))}e.fromNow=f;function D(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(oe[137],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,137]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function U(C,S){return S&&(C.stack||C.stacktrace)?A.localize(0,null,L(C),_(C.stack)||_(C.stacktrace)):L(C)}function _(C){return Array.isArray(C)?C.join(`
`):C}function L(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?A.localize(1,null,C.message):C.message||A.localize(2,null)}function I(C=null,S=!1){if(!C)return A.localize(3,null);if(Array.isArray(C)){const c=k.coalesce(C),g=I(c[0],S);return c.length>1?A.localize(4,null,g,c.length):g}if(O.isString(C))return C;if(C.detail){const c=C.detail;if(c.error)return U(c.error,S);if(c.exception)return U(c.exception,S)}return C.stack?U(C,S):C.message?C.message:A.localize(5,null)}e.toErrorMessage=I;function f(C){const S=C;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=f;function D(C,S){let c;return typeof C=="string"?c=new Error(C):c=C,c.actions=S,c}e.createErrorWithActions=D}),define(oe[138],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(A){switch(A){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(oe[140],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[6],ae([0,1,140]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,A=!1,U=!1,_=!1,L=!1,I=!1,f=!1,D=!1,C=!1,S=!1,c,g=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,m,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const u=typeof l?.versions?.electron=="string",p=u&&l?.type==="renderer";if(typeof navigator=="object"&&!p)h=navigator.userAgent,O=h.indexOf("Windows")>=0,A=h.indexOf("Macintosh")>=0,D=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=h.indexOf("Linux")>=0,S=h?.indexOf("Mobi")>=0,I=!0,c=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,g=c,y=navigator.language;else if(typeof l=="object"){O=l.platform==="win32",A=l.platform==="darwin",U=l.platform==="linux",_=U&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,f=u,C=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const w=l.env.VSCODE_NLS_CONFIG;if(w)try{const E=JSON.parse(w),d=E.availableLanguages["*"];c=E.locale,y=E.osLocale,g=d||e.LANGUAGE_DEFAULT,m=E._translationsConfigFile}catch{}L=!0}else console.error("Unable to resolve platform.");var b;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(b||(e.Platform=b={}));function t(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let a=0;A?a=1:O?a=3:U&&(a=2),e.isWindows=O,e.isMacintosh=A,e.isLinux=U,e.isLinuxSnap=_,e.isNative=L,e.isElectron=f,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=D,e.isMobile=S,e.isCI=C,e.platform=a,e.userAgent=h,e.language=g;var n;(function(w){function E(){return e.language}w.value=E;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}w.isDefaultVariant=d;function v(){return e.language==="en"}w.isDefault=v})(n||(e.Language=n={})),e.locale=c,e.platformLocale=y,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const w=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let v=0,T=w.length;v<T;v++){const N=w[v];if(N.id===d.data.vscodeScheduleAsyncWork){w.splice(v,1),N.callback();return}}});let E=0;return d=>{const v=++E;w.push({id:v,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:v},"*")}}return w=>setTimeout(w)})();var s;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=A||D?2:O?1:3;let i=!0,r=!1;function o(){if(!r){r=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,i=new Uint16Array(w.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[37],ae([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const A=k.globals.vscode.process;O={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(oe[16],ae([0,1,37]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,A=97,U=90,_=122,L=46,I=47,f=92,D=58,C=63;class S extends Error{constructor(a,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${i} of type ${n}`;o+=`. Received type ${typeof s}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function c(t,a){if(t===null||typeof t!="object")throw new S(a,"Object",t)}function g(t,a){if(typeof t!="string")throw new S(a,"string",t)}const y=k.platform==="win32";function m(t){return t===I||t===f}function h(t){return t===I}function l(t){return t>=O&&t<=U||t>=A&&t<=_}function u(t,a,n,s){let i="",r=0,o=-1,w=0,E=0;for(let d=0;d<=t.length;++d){if(d<t.length)E=t.charCodeAt(d);else{if(s(E))break;E=I}if(s(E)){if(!(o===d-1||w===1))if(w===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==L||i.charCodeAt(i.length-2)!==L){if(i.length>2){const v=i.lastIndexOf(n);v===-1?(i="",r=0):(i=i.slice(0,v),r=i.length-1-i.lastIndexOf(n)),o=d,w=0;continue}else if(i.length!==0){i="",r=0,o=d,w=0;continue}}a&&(i+=i.length>0?`${n}..`:"..",r=2)}else i.length>0?i+=`${n}${t.slice(o+1,d)}`:i=t.slice(o+1,d),r=d-o-1;o=d,w=0}else E===L&&w!==-1?++w:w=-1}return i}function p(t,a){c(a,"pathObject");const n=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${s}`:`${n}${t}${s}`:s}e.win32={resolve(...t){let a="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],g(r,"path"),r.length===0)continue}else a.length===0?r=k.cwd():(r=k.env[`=${a}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===f)&&(r=`${a}\\`));const o=r.length;let w=0,E="",d=!1;const v=r.charCodeAt(0);if(o===1)m(v)&&(w=1,d=!0);else if(m(v))if(d=!0,m(r.charCodeAt(1))){let T=2,N=T;for(;T<o&&!m(r.charCodeAt(T));)T++;if(T<o&&T!==N){const M=r.slice(N,T);for(N=T;T<o&&m(r.charCodeAt(T));)T++;if(T<o&&T!==N){for(N=T;T<o&&!m(r.charCodeAt(T));)T++;(T===o||T!==N)&&(E=`\\\\${M}\\${r.slice(N,T)}`,w=T)}}}else w=1;else l(v)&&r.charCodeAt(1)===D&&(E=r.slice(0,2),w=2,o>2&&m(r.charCodeAt(2))&&(d=!0,w=3));if(E.length>0)if(a.length>0){if(E.toLowerCase()!==a.toLowerCase())continue}else a=E;if(s){if(a.length>0)break}else if(n=`${r.slice(w)}\\${n}`,s=d,d&&a.length>0)break}return n=u(n,!s,"\\",m),s?`${a}\\${n}`:`${a}${n}`||"."},normalize(t){g(t,"path");const a=t.length;if(a===0)return".";let n=0,s,i=!1;const r=t.charCodeAt(0);if(a===1)return h(r)?"\\":t;if(m(r))if(i=!0,m(t.charCodeAt(1))){let w=2,E=w;for(;w<a&&!m(t.charCodeAt(w));)w++;if(w<a&&w!==E){const d=t.slice(E,w);for(E=w;w<a&&m(t.charCodeAt(w));)w++;if(w<a&&w!==E){for(E=w;w<a&&!m(t.charCodeAt(w));)w++;if(w===a)return`\\\\${d}\\${t.slice(E)}\\`;w!==E&&(s=`\\\\${d}\\${t.slice(E,w)}`,n=w)}}}else n=1;else l(r)&&t.charCodeAt(1)===D&&(s=t.slice(0,2),n=2,a>2&&m(t.charCodeAt(2))&&(i=!0,n=3));let o=n<a?u(t.slice(n),!i,"\\",m):"";return o.length===0&&!i&&(o="."),o.length>0&&m(t.charCodeAt(a-1))&&(o+="\\"),s===void 0?i?`\\${o}`:o:i?`${s}\\${o}`:`${s}${o}`},isAbsolute(t){g(t,"path");const a=t.length;if(a===0)return!1;const n=t.charCodeAt(0);return m(n)||a>2&&l(n)&&t.charCodeAt(1)===D&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,n;for(let r=0;r<t.length;++r){const o=t[r];g(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&m(n.charCodeAt(0))){++i;const r=n.length;r>1&&m(n.charCodeAt(1))&&(++i,r>2&&(m(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<a.length&&m(a.charCodeAt(i));)i++;i>=2&&(a=`\\${a.slice(i)}`)}return e.win32.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a)return"";const n=e.win32.resolve(t),s=e.win32.resolve(a);if(n===s||(t=n.toLowerCase(),a=s.toLowerCase(),t===a))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===f;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===f;)r--;const o=r-i;let w=0;for(;w<a.length&&a.charCodeAt(w)===f;)w++;let E=a.length;for(;E-1>w&&a.charCodeAt(E-1)===f;)E--;const d=E-w,v=o<d?o:d;let T=-1,N=0;for(;N<v;N++){const $=t.charCodeAt(i+N);if($!==a.charCodeAt(w+N))break;$===f&&(T=N)}if(N!==v){if(T===-1)return s}else{if(d>v){if(a.charCodeAt(w+N)===f)return s.slice(w+N+1);if(N===2)return s.slice(w+N)}o>v&&(t.charCodeAt(i+N)===f?T=N:N===2&&(T=3)),T===-1&&(T=0)}let M="";for(N=i+T+1;N<=r;++N)(N===r||t.charCodeAt(N)===f)&&(M+=M.length===0?"..":"\\..");return w+=T,M.length>0?`${M}${s.slice(w,E)}`:(s.charCodeAt(w)===f&&++w,s.slice(w,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const n=a.charCodeAt(2);if(n!==C&&n!==L)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===D&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return t},dirname(t){g(t,"path");const a=t.length;if(a===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(a===1)return m(i)?t:".";if(m(i)){if(n=s=1,m(t.charCodeAt(1))){let w=2,E=w;for(;w<a&&!m(t.charCodeAt(w));)w++;if(w<a&&w!==E){for(E=w;w<a&&m(t.charCodeAt(w));)w++;if(w<a&&w!==E){for(E=w;w<a&&!m(t.charCodeAt(w));)w++;if(w===a)return t;w!==E&&(n=s=w+1)}}}}else l(i)&&t.charCodeAt(1)===D&&(n=a>2&&m(t.charCodeAt(2))?3:2,s=n);let r=-1,o=!0;for(let w=a-1;w>=s;--w)if(m(t.charCodeAt(w))){if(!o){r=w;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return t.slice(0,r)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let n=0,s=-1,i=!0,r;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===D&&(n=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let o=a.length-1,w=-1;for(r=t.length-1;r>=n;--r){const E=t.charCodeAt(r);if(m(E)){if(!i){n=r+1;break}}else w===-1&&(i=!1,w=r+1),o>=0&&(E===a.charCodeAt(o)?--o===-1&&(s=r):(o=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=n;--r)if(m(t.charCodeAt(r))){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){g(t,"path");let a=0,n=-1,s=0,i=-1,r=!0,o=0;t.length>=2&&t.charCodeAt(1)===D&&l(t.charCodeAt(0))&&(a=s=2);for(let w=t.length-1;w>=a;--w){const E=t.charCodeAt(w);if(m(E)){if(!r){s=w+1;break}continue}i===-1&&(r=!1,i=w+1),E===L?n===-1?n=w:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||i===-1||o===0||o===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:p.bind(null,"\\"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return m(i)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(m(i)){if(s=1,m(t.charCodeAt(1))){let T=2,N=T;for(;T<n&&!m(t.charCodeAt(T));)T++;if(T<n&&T!==N){for(N=T;T<n&&m(t.charCodeAt(T));)T++;if(T<n&&T!==N){for(N=T;T<n&&!m(t.charCodeAt(T));)T++;T===n?s=T:T!==N&&(s=T+1)}}}}else if(l(i)&&t.charCodeAt(1)===D){if(n<=2)return a.root=a.dir=t,a;if(s=2,m(t.charCodeAt(2))){if(n===3)return a.root=a.dir=t,a;s=3}}s>0&&(a.root=t.slice(0,s));let r=-1,o=s,w=-1,E=!0,d=t.length-1,v=0;for(;d>=s;--d){if(i=t.charCodeAt(d),m(i)){if(!E){o=d+1;break}continue}w===-1&&(E=!1,w=d+1),i===L?r===-1?r=d:v!==1&&(v=1):r!==-1&&(v=-1)}return w!==-1&&(r===-1||v===0||v===1&&r===w-1&&r===o+1?a.base=a.name=t.slice(o,w):(a.name=t.slice(o,r),a.base=t.slice(o,w),a.ext=t.slice(r,w))),o>0&&o!==s?a.dir=t.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(y){const t=/\\/g;return()=>{const a=k.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...t){let a="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:b();g(i,"path"),i.length!==0&&(a=`${i}/${a}`,n=i.charCodeAt(0)===I)}return a=u(a,!n,"/",h),n?`/${a}`:a.length>0?a:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===I,n=t.charCodeAt(t.length-1)===I;return t=u(t,!a,"/",h),t.length===0?a?"/":n?"./":".":(n&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===I},join(...t){if(t.length===0)return".";let a;for(let n=0;n<t.length;++n){const s=t[n];g(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const n=1,s=t.length,i=s-n,r=1,o=a.length-r,w=i<o?i:o;let E=-1,d=0;for(;d<w;d++){const T=t.charCodeAt(n+d);if(T!==a.charCodeAt(r+d))break;T===I&&(E=d)}if(d===w)if(o>w){if(a.charCodeAt(r+d)===I)return a.slice(r+d+1);if(d===0)return a.slice(r+d)}else i>w&&(t.charCodeAt(n+d)===I?E=d:d===0&&(E=0));let v="";for(d=n+E+1;d<=s;++d)(d===s||t.charCodeAt(d)===I)&&(v+=v.length===0?"..":"/..");return`${v}${a.slice(r+E)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===I;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===I){if(!s){n=i;break}}else s=!1;return n===-1?a?"/":".":a&&n===1?"//":t.slice(0,n)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let n=0,s=-1,i=!0,r;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let o=a.length-1,w=-1;for(r=t.length-1;r>=0;--r){const E=t.charCodeAt(r);if(E===I){if(!i){n=r+1;break}}else w===-1&&(i=!1,w=r+1),o>=0&&(E===a.charCodeAt(o)?--o===-1&&(s=r):(o=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===I){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){g(t,"path");let a=-1,n=0,s=-1,i=!0,r=0;for(let o=t.length-1;o>=0;--o){const w=t.charCodeAt(o);if(w===I){if(!i){n=o+1;break}continue}s===-1&&(i=!1,s=o+1),w===L?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===n+1?"":t.slice(a,s)},format:p.bind(null,"/"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const n=t.charCodeAt(0)===I;let s;n?(a.root="/",s=1):s=0;let i=-1,r=0,o=-1,w=!0,E=t.length-1,d=0;for(;E>=s;--E){const v=t.charCodeAt(E);if(v===I){if(!w){r=E+1;break}continue}o===-1&&(w=!1,o=E+1),v===L?i===-1?i=E:d!==1&&(d=1):i!==-1&&(d=-1)}if(o!==-1){const v=r===0&&n?1:r;i===-1||d===0||d===1&&i===o-1&&i===r+1?a.base=a.name=t.slice(v,o):(a.name=t.slice(v,i),a.base=t.slice(v,o),a.ext=t.slice(i,o))}return r>0?a.dir=t.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(oe[48],ae([0,1,16,6,27,12]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function L(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=L;function I(r){return r.indexOf("/")===-1&&(r=L(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function f(r,o=k.posix.sep){if(!r)return"";const w=r.length,E=r.charCodeAt(0);if(_(E)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let v=3;const T=v;for(;v<w&&!_(r.charCodeAt(v));v++);if(T!==v&&!_(r.charCodeAt(v+1))){for(v+=1;v<w;v++)if(_(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,o)}}return o}else if(h(E)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<w;d++)if(_(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=f;function D(r){if(!O.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let w=2;const E=w;for(;w<r.length&&(o=r.charCodeAt(w),o!==92);w++);return!(E===w||(o=r.charCodeAt(w+1),isNaN(o)||o===92))}e.isUNC=D;const C=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=O.isWindows){const w=o?C:S;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||o&&c.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function y(r,o,w){const E=r===o;return!w||E?E:!r||!o?!1:(0,A.equalsIgnoreCase)(r,o)}e.isEqual=y;function m(r,o,w,E=k.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(w){if(!(0,A.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let v=o.length;return o.charAt(o.length-1)===E&&v--,r.charAt(v)===E}return o.charAt(o.length-1)!==E&&(o+=E),r.indexOf(o)===0}e.isEqualOrParent=m;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function l(r,o){return O.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(o,r)),r=(0,k.normalize)(r),O.isWindows?(r=(0,A.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,A.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=l;function u(r){const o=(0,k.normalize)(r);return O.isWindows?r.length>3?!1:p(o)&&(r.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=u;function p(r,o=O.isWindows){return o?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function b(r,o=O.isWindows){return p(r,o)?r[0]:void 0}e.getDriveLetter=b;function t(r,o,w){return o.length>r.length?-1:r===o?0:(w&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=t;function a(r){const o=r.split(":");let w,E,d;for(const v of o){const T=Number(v);(0,U.isNumber)(T)?E===void 0?E=T:d===void 0&&(d=T):w=w?[w,v].join(":"):v}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:E!==void 0?E:void 0,column:d!==void 0?d:E!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,o,w=8){let E="";for(let v=0;v<w;v++){let T;v===0&&O.isWindows&&!o&&(w===3||w===4)?T=s:T=n,E+=T.charAt(Math.floor(Math.random()*T.length))}let d;return o?d=`${o}-${E}`:d=E,r?(0,k.join)(r,d):d}e.randomPath=i}),define(oe[141],ae([0,1,16]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(D){const C=(0,k.extname)(D),S=O[C.toLowerCase()];return S!==void 0?S:_(D)}e.getMediaOrTextMime=U;function _(D){const C=(0,k.extname)(D);return A[C.toLowerCase()]}e.getMediaMime=_;function L(D){for(const C in A)if(A[C]===D)return C}e.getExtensionForMimeType=L;const I=/^(.+)\/(.+?)(;.+)?$/;function f(D,C){const S=I.exec(D);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:C?void 0:D}e.normalizeMimeType=f}),define(oe[90],ae([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(O||(e.Source=O={}));var A;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function U(L,...I){const f=I.reduce((S,c)=>(S[c]=!0,S),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(S=>!f[S]).forEach(S=>{for(let c=0;c<D.length;c++)if(S.search(D[c])!==-1){delete L[S];break}})}e.sanitizeProcessEnvironment=U;function _(L){L&&(delete L.DEBUG,k.isMacintosh&&delete L.DYLD_LIBRARY_PATH,k.isLinux&&delete L.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(oe[10],ae([0,1,16,6]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,U=/^\//,_=/^\/\//;function L(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!U.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(s,i){return!s&&!i?"file":s}function f(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const D="",C="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(i){return i instanceof c?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,o,w,E,d=!1){typeof i=="object"?(this.scheme=i.scheme||D,this.authority=i.authority||D,this.path=i.path||D,this.query=i.query||D,this.fragment=i.fragment||D):(this.scheme=I(i,d),this.authority=r||D,this.path=f(this.scheme,o||D),this.query=w||D,this.fragment=E||D,L(this,d))}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:o,path:w,query:E,fragment:d}=i;return r===void 0?r=this.scheme:r===null&&(r=D),o===void 0?o=this.authority:o===null&&(o=D),w===void 0?w=this.path:w===null&&(w=D),E===void 0?E=this.query:E===null&&(E=D),d===void 0?d=this.fragment:d===null&&(d=D),r===this.scheme&&o===this.authority&&w===this.path&&E===this.query&&d===this.fragment?this:new m(r,o,w,E,d)}static parse(i,r=!1){const o=S.exec(i);return o?new m(o[2]||D,n(o[4]||D),n(o[5]||D),n(o[7]||D),n(o[9]||D),r):new m(D,D,D,D,D)}static file(i){let r=D;if(O.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const o=i.indexOf(C,2);o===-1?(r=i.substring(2),i=C):(r=i.substring(2,o),i=i.substring(o)||C)}return new m("file",r,i,D,D)}static from(i,r){return new m(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return O.isWindows&&i.scheme==="file"?o=c.file(k.win32.join(p(i,!0),...r)).path:o=k.posix.join(i.path,...r),i.with({path:o})}toString(i=!1){return b(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof c)return i;{const r=new m(i);return r._formatted=i.external??null,r._fsPath=i._sep===y?i.fsPath??null:null,r}}else return i}}e.URI=c;function g(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.isUriComponents=g;const y=O.isWindows?1:void 0;class m extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=y),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(s,i,r){let o,w=-1;for(let E=0;E<s.length;E++){const d=s.charCodeAt(E);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47||r&&d===91||r&&d===93||r&&d===58)w!==-1&&(o+=encodeURIComponent(s.substring(w,E)),w=-1),o!==void 0&&(o+=s.charAt(E));else{o===void 0&&(o=s.substr(0,E));const v=h[d];v!==void 0?(w!==-1&&(o+=encodeURIComponent(s.substring(w,E)),w=-1),o+=v):w===-1&&(w=E)}}return w!==-1&&(o+=encodeURIComponent(s.substring(w))),o!==void 0?o:s}function u(s){let i;for(let r=0;r<s.length;r++){const o=s.charCodeAt(r);o===35||o===63?(i===void 0&&(i=s.substr(0,r)),i+=h[o]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function p(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function b(s,i){const r=i?u:l;let o="",{scheme:w,authority:E,path:d,query:v,fragment:T}=s;if(w&&(o+=w,o+=":"),(E||w==="file")&&(o+=C,o+=C),E){let N=E.indexOf("@");if(N!==-1){const M=E.substr(0,N);E=E.substr(N+1),N=M.lastIndexOf(":"),N===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,N),!1,!1),o+=":",o+=r(M.substr(N+1),!1,!0)),o+="@"}E=E.toLowerCase(),N=E.lastIndexOf(":"),N===-1?o+=r(E,!1,!0):(o+=r(E.substr(0,N),!1,!0),o+=E.substr(N))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const N=d.charCodeAt(1);N>=65&&N<=90&&(d=`/${String.fromCharCode(N+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const N=d.charCodeAt(0);N>=65&&N<=90&&(d=`${String.fromCharCode(N+32)}:${d.substr(2)}`)}o+=r(d,!0,!1)}return v&&(o+="?",o+=r(v,!1,!1)),T&&(o+="#",o+=i?T:l(T,!1,!1)),o}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(a)?s.replace(a,i=>t(i)):s}}),define(oe[142],ae([0,1,10]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(f){const D=f;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=O;function A(f){const D=[];let C;try{const S=JSON.parse(f.arguments),c=S[S.length-1];c&&c.__$stack&&(S.pop(),C=c.__$stack),D.push(...S)}catch{D.push("Unable to log remote console arguments",f.arguments)}return{args:D,stack:C}}e.parse=A;function U(f){if(typeof f!="string")return U(A(f).stack);const D=f;if(D){const C=_(D),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(S&&S.length===4)return{uri:k.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=U;function _(f){if(!f)return f;const D=f.indexOf(`
`);return D===-1?f:f.substring(0,D)}function L(f,D){const{args:C,stack:S}=A(f),c=typeof C[0]=="string"&&C.length===1;let g=_(S);g&&(g=`(${g.trim()})`);let y=[];if(typeof C[0]=="string"?g&&c?y=[`%c[${D}] %c${C[0]} %c${g}`,I("blue"),I(""),I("grey")]:y=[`%c[${D}] %c${C[0]}`,I("blue"),I(""),...C.slice(1)]:y=[`%c[${D}]%`,I("blue"),...C],g&&!c&&y.push(g),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,y)}e.log=L;function I(f){return`color: ${f}`}}),define(oe[63],ae([0,1,15,10]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(I){return JSON.stringify(I,_)}e.stringify=A;function U(I){let f=JSON.parse(I);return f=L(f),f}e.parse=U;function _(I,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function L(I,f=0){if(!I||f>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return O.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 17:return new Date(I.source)}if(I instanceof k.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let D=0;D<I.length;++D)I[D]=L(I[D],f+1);else for(const D in I)Object.hasOwnProperty.call(I,D)&&(I[D]=L(I[D],f+1))}return I}e.revive=L}),define(oe[23],ae([0,1,8,6,10]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var U;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(U||(e.Schemas=U={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}setServerRootPath(D){this._remoteResourcesPath=`${D}/${U.vscodeRemoteResource}`}set(D,C,S){this._hosts[D]=C,this._ports[D]=S}setConnectionToken(D,C){this._connectionTokens[D]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)try{return this._delegate(D)}catch(m){return k.onUnexpectedError(m),D}const C=D.authority;let S=this._hosts[C];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const c=this._ports[C],g=this._connectionTokens[C];let y=`path=${encodeURIComponent(D.path)}`;return typeof g=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),A.URI.from({scheme:O.isWeb?this._preferredWebSchema:U.vscodeRemoteResource,authority:`${S}:${c}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new _,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class L{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D){const C=this.toUri(D,te);return this.uriToBrowserUri(C)}uriToBrowserUri(D){return D.scheme===U.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===U.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${U.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?D.with({scheme:U.vscodeFileResource,authority:D.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(D){const C=this.toUri(D,te);return this.uriToFileUri(C)}uriToFileUri(D){return D.scheme===U.vscodeFileResource?D.with({scheme:U.file,authority:D.authority!==L.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(D,C){return A.URI.isUri(D)?D:A.URI.parse(C.toUrl(D))}}e.FileAccess=new L;var I;(function(f){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(D.get("3"));const C="vscode-coi";function S(g){let y;typeof g=="string"?y=new URL(g).searchParams:g instanceof URL?y=g.searchParams:A.URI.isUri(g)&&(y=new URL(g.toString(!0)).searchParams);const m=y?.get(C);if(m)return D.get(m)}f.getHeadersFromQuery=S;function c(g,y,m){if(!globalThis.crossOriginIsolated)return;const h=y&&m?"3":m?"2":"1";g instanceof URLSearchParams?g.set(C,h):g[C]=h}f.addSearchParam=c})(I||(e.COI=I={}))}),define(oe[143],ae([0,1,124,23,6,10]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class _{constructor(S,c,g){this.id=S,this.dependencies=c,this.callback=g}}class L{static{this.INSTANCE=new L}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(S,c,g)=>{typeof S!="string"&&(g=c,c=S,S=null),(typeof c!="object"||!Array.isArray(c))&&(g=c,c=null),this._defineCalls.push(new _(S,c,g))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){if(S.startsWith(window.location.origin)||S.startsWith("vscode-file://vscode-app"))return S;throw new Error(`[trusted_script_src] Invalid script url: ${S}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){return S}})))}async load(S){this._initialize();const c=await(this._isWebWorker?this._workerLoadScript(S):this._isRenderer?this._rendererLoadScript(S):this._nodeJSLoadScript(S));if(!c)throw new Error(`Did not receive a define call from script ${S}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${S}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}_rendererLoadScript(S){return new Promise((c,g)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const m=()=>{y.removeEventListener("load",h),y.removeEventListener("error",l)},h=u=>{m(),c(this._defineCalls.pop())},l=u=>{m(),g(u)};y.addEventListener("load",h),y.addEventListener("error",l),this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),y.setAttribute("src",S),document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(S){return new Promise((c,g)=>{try{this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),importScripts(S),c(this._defineCalls.pop())}catch(y){g(y)}})}async _nodeJSLoadScript(S){try{const c=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,m=U.URI.parse(S).fsPath,h=c.readFileSync(m).toString(),l=y.wrap(h.replace(/^#!.*/,""));return new g.Script(l).runInThisContext().apply(),this._defineCalls.pop()}catch(c){throw c}}}const I=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function D(C,S,c){if(k.isESM){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[C]&&(C=f[C]);const g=`${C}/${S}`;if(I.has(g))return I.get(g);let y;if(/^\w[\w\d+.-]*:\/\//.test(g))y=g;else{const u=`${c&&!A.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${g}`;y=O.FileAccess.asBrowserUri(u).toString(!0)}const m=L.INSTANCE.load(y);return I.set(g,m),m}else return await new Promise((g,y)=>{te([C],g,y)})}e.importAMDNodeModule=D}),define(oe[21],ae([0,1,48,23,16,6,27,10]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(c){return(0,L.uriToFsPath)(c,!0)}e.originalFSPath=I;class f{constructor(g){this._ignorePathCasing=g}compare(g,y,m=!1){return g===y?0:(0,_.compare)(this.getComparisonKey(g,m),this.getComparisonKey(y,m))}isEqual(g,y,m=!1){return g===y?!0:!g||!y?!1:this.getComparisonKey(g,m)===this.getComparisonKey(y,m)}getComparisonKey(g,y=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,y,m=!1){if(g.scheme===y.scheme){if(g.scheme===O.Schemas.file)return k.isEqualOrParent(I(g),I(y),this._ignorePathCasing(g))&&g.query===y.query&&(m||g.fragment===y.fragment);if((0,e.isEqualAuthority)(g.authority,y.authority))return k.isEqualOrParent(g.path,y.path,this._ignorePathCasing(g),"/")&&g.query===y.query&&(m||g.fragment===y.fragment)}return!1}joinPath(g,...y){return L.URI.joinPath(g,...y)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return A.posix.basename(g.path)}extname(g){return A.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let y;return g.scheme===O.Schemas.file?y=L.URI.file(A.dirname(I(g))).path:(y=A.posix.dirname(g.path),g.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),y="/")),g.with({path:y})}normalizePath(g){if(!g.path.length)return g;let y;return g.scheme===O.Schemas.file?y=L.URI.file(A.normalize(I(g))).path:y=A.posix.normalize(g.path),g.with({path:y})}relativePath(g,y){if(g.scheme!==y.scheme||!(0,e.isEqualAuthority)(g.authority,y.authority))return;if(g.scheme===O.Schemas.file){const l=A.relative(I(g),I(y));return U.isWindows?k.toSlashes(l):l}let m=g.path||"/";const h=y.path||"/";if(this._ignorePathCasing(g)){let l=0;for(const u=Math.min(m.length,h.length);l<u&&!(m.charCodeAt(l)!==h.charCodeAt(l)&&m.charAt(l).toLowerCase()!==h.charAt(l).toLowerCase());l++);m=h.substr(0,l)+m.substr(l)}return A.posix.relative(m,h)}resolvePath(g,y){if(g.scheme===O.Schemas.file){const m=L.URI.file(A.resolve(I(g),y));return g.with({authority:m.authority,path:m.path})}return y=k.toPosixPath(y),g.with({path:A.posix.resolve(g.path,y)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,y){return g===y||g!==void 0&&y!==void 0&&(0,_.equalsIgnoreCase)(g,y)}hasTrailingPathSeparator(g,y=A.sep){if(g.scheme===O.Schemas.file){const m=I(g);return m.length>k.getRoot(m).length&&m[m.length-1]===y}else{const m=g.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,y=A.sep){return(0,e.hasTrailingPathSeparator)(g,y)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,y=A.sep){let m=!1;if(g.scheme===O.Schemas.file){const h=I(g);m=h!==void 0&&h.length===k.getRoot(h).length&&h[h.length-1]===y}else{y="/";const h=g.path;m=h.length===1&&h.charCodeAt(h.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(g,y)?g.with({path:g.path+"/"}):g}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(c=>c.scheme===O.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new f(c=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(c,g){const y=[];for(let m=0;m<c.length;m++){const h=g(c[m]);c.some((l,u)=>u===m?!1:(0,e.isEqualOrParent)(h,g(l)))||y.push(c[m])}return y}e.distinctParents=D;var C;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(y){const m=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(u=>{const[p,b]=u.split(":");p&&b&&m.set(p,b)});const l=y.path.substring(0,y.path.indexOf(";"));return l&&m.set(c.META_DATA_MIME,l),m}c.parseMetaData=g})(C||(e.DataUri=C={}));function S(c,g,y){if(g){let m=c.path;return m&&m[0]!==A.posix.sep&&(m=A.posix.sep+m),c.with({scheme:y,authority:g,path:m})}return c.with({scheme:y})}e.toLocalResource=S}),define(oe[5],ae([0,1,26,8,3,2,21,6,130]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(P){return!!P&&typeof P.then=="function"}e.isThenable=f;function D(P){const R=new k.CancellationTokenSource,W=P(R.token),F=new Promise((H,Y)=>{const se=R.token.onCancellationRequested(()=>{se.dispose(),R.dispose(),Y(new O.CancellationError)});Promise.resolve(W).then(le=>{se.dispose(),R.dispose(),H(le)},le=>{se.dispose(),R.dispose(),Y(le)})});return new class{cancel(){R.cancel()}then(H,Y){return F.then(H,Y)}catch(H){return this.then(void 0,H)}finally(H){return F.finally(H)}}}e.createCancelablePromise=D;function C(P,R,W){return new Promise((F,H)=>{const Y=R.onCancellationRequested(()=>{Y.dispose(),F(W)});P.then(F,H).finally(()=>Y.dispose())})}e.raceCancellation=C;function S(P,R){return new Promise((W,F)=>{const H=R.onCancellationRequested(()=>{H.dispose(),F(new O.CancellationError)});P.then(W,F).finally(()=>H.dispose())})}e.raceCancellationError=S;async function c(P){let R=-1;const W=P.map((F,H)=>F.then(Y=>(R=H,Y)));try{return await Promise.race(W)}finally{P.forEach((F,H)=>{H!==R&&F.cancel()})}}e.raceCancellablePromises=c;function g(P,R,W){let F;const H=setTimeout(()=>{F?.(void 0),W?.()},R);return Promise.race([P.finally(()=>clearTimeout(H)),new Promise(Y=>F=Y)])}e.raceTimeout=g;function y(P){return new Promise((R,W)=>{const F=P();f(F)?F.then(R,W):R(F)})}e.asPromise=y;class m{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const W=()=>{if(this.queuedPromise=null,this.isDisposed)return;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(W,W).then(F)})}return new Promise((W,F)=>{this.queuedPromise.then(W,F)})}return this.activePromise=R(),new Promise((W,F)=>{this.activePromise.then(H=>{this.activePromise=null,W(H)},H=>{this.activePromise=null,F(H)})})}dispose(){this.isDisposed=!0}}e.Throttler=m;class h{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=h;class l{constructor(){this.promiseMap=new Map}queue(R,W){const H=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(R)===H&&this.promiseMap.delete(R)});return this.promiseMap.set(R,H),H}}e.SequencerByKey=l;const u=(P,R)=>{let W=!0;const F=setTimeout(()=>{W=!1,R()},P);return{isTriggered:()=>W,dispose:()=>{clearTimeout(F),W=!1}}},p=P=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,P())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class b{constructor(R){this.defaultDelay=R,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,W=this.defaultDelay){this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,Y)=>{this.doResolve=H,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const F=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===I.MicrotaskDelay?p(F):u(W,F),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=b;class t{constructor(R){this.delayer=new b(R),this.throttler=new m}trigger(R,W){return this.delayer.trigger(()=>this.throttler.queue(R),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this._isOpen=!1,this._promise=new Promise((R,W)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class n extends a{constructor(R){super(),this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function s(P,R){return R?new Promise((W,F)=>{const H=setTimeout(()=>{Y.dispose(),W()},P),Y=R.onCancellationRequested(()=>{clearTimeout(H),Y.dispose(),F(new O.CancellationError)})}):D(W=>s(P,W))}e.timeout=s;function i(P,R=0,W){const F=setTimeout(()=>{P(),W&&H.dispose()},R),H=(0,U.toDisposable)(()=>{clearTimeout(F),W?.deleteAndLeak(H)});return W?.add(H),H}e.disposableTimeout=i;function r(P){const R=[];let W=0;const F=P.length;function H(){return W<F?P[W++]():null}function Y(se){se!=null&&R.push(se);const le=H();return le?le.then(Y):Promise.resolve(R)}return Promise.resolve(null).then(Y)}e.sequence=r;function o(P,R=F=>!!F,W=null){let F=0;const H=P.length,Y=()=>{if(F>=H)return Promise.resolve(W);const se=P[F++];return Promise.resolve(se()).then(he=>R(he)?Promise.resolve(he):Y())};return Y()}e.first=o;function w(P,R=F=>!!F,W=null){if(P.length===0)return Promise.resolve(W);let F=P.length;const H=()=>{F=-1;for(const Y of P)Y.cancel?.()};return new Promise((Y,se)=>{for(const le of P)le.then(he=>{--F>=0&&R(he)?(H(),Y(he)):F===0&&Y(W)}).catch(he=>{--F>=0&&(H(),se(he))})})}e.firstParallel=w;class E{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new A.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(R){return this._size++,new Promise((W,F)=>{this.outstandingPromises.push({factory:R,c:W,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const W=R.factory();W.then(R.c,R.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=E;class d extends E{constructor(){super(1)}}e.Queue=d;class v{constructor(){this.sequentializer=new K,this.tasks=0}queue(R){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,R())):this.sequentializer.run(this.tasks++,R())}}e.LimitedQueue=v;class T{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const R=new x;return this.drainers.add(R),R.p}isDrained(){for(const[,R]of this.queues)if(R.size>0)return!1;return!0}queueFor(R,W=_.extUri){const F=W.getComparisonKey(R);let H=this.queues.get(F);if(!H){H=new d;const Y=this.drainListenerCount++,se=A.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(F),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Y),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new U.DisposableMap),this.drainListeners.set(Y,se),this.queues.set(F,H)}return H}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const R of this.drainers)R.complete();this.drainers.clear()}dispose(){for(const[,R]of this.queues)R.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=T;class N{constructor(R,W){this._token=-1,typeof R=="function"&&typeof W=="number"&&this.setIfNotSet(R,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},W)}setIfNotSet(R,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},W))}}e.TimeoutTimer=N;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,W){this.cancel(),this._token=setInterval(()=>{R()},W)}}e.IntervalTimer=M;class ${constructor(R,W){this.timeoutToken=-1,this.runner=R,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class j{constructor(R,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=R,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(R=this.timeout){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(R/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=j;class Z extends ${constructor(R,W){super(R,W),this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner?.(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Z;class G extends U.Disposable{constructor(R,W){super(),this.options=R,this.handler=W,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.options.maxBufferedWork)return!1}else if(this.pending+R.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const W of R)this.pendingWork.push(W);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=P=>{(0,L.setTimeout0)(()=>{if(R)return;const W=Date.now()+15;P(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(P,R)=>{const W=requestIdleCallback(P,typeof R=="number"?{timeout:R}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(W))}}}}();class Q{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Q;async function B(P,R,W){let F;for(let H=0;H<W;H++)try{return await P()}catch(Y){F=Y,await s(R)}throw F}e.retry=B;class K{isRunning(R){return typeof R=="number"?this._running?.taskId===R:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(R,W,F){return this._running={taskId:R,cancel:()=>F?.(),promise:W},W.then(()=>this.doneRunning(R),()=>this.doneRunning(R)),W}doneRunning(R){this._running&&R===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const R=this._queued;this._queued=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this._queued)this._queued.run=R;else{let W,F;const H=new Promise((Y,se)=>{W=Y,F=se});this._queued={run:R,promise:H,promiseResolve:W,promiseReject:F}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=K;class V{constructor(R,W=()=>Date.now()){this.interval=R,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const R=this.nowFn();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=V;var z;(function(P){P[P.Resolved=0]="Resolved",P[P.Rejected=1]="Rejected"})(z||(z={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((R,W)=>{this.completeCallback=R,this.errorCallback=W})}complete(R){return new Promise(W=>{this.completeCallback(R),this.outcome={outcome:0,value:R},W()})}error(R){return new Promise(W=>{this.errorCallback(R),this.outcome={outcome:1,value:R},W()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=x;var ee;(function(P){async function R(F){let H;const Y=await Promise.all(F.map(se=>se.then(le=>le,le=>{H||(H=le)})));if(typeof H<"u")throw H;return Y}P.settled=R;function W(F){return new Promise(async(H,Y)=>{try{await F(H,Y)}catch(se){Y(se)}})}P.withAsyncBody=W})(ee||(e.Promises=ee={}));var ne;(function(P){P[P.Initial=0]="Initial",P[P.DoneOK=1]="DoneOK",P[P.DoneError=2]="DoneError"})(ne||(ne={}));class re{static fromArray(R){return new re(W=>{W.emitMany(R)})}static fromPromise(R){return new re(async W=>{W.emitMany(await R)})}static fromPromises(R){return new re(async W=>{await Promise.all(R.map(async F=>W.emitOne(await F)))})}static merge(R){return new re(async W=>{await Promise.all(R.map(async F=>{for await(const H of F)W.emitOne(H)}))})}static{this.EMPTY=re.fromArray([])}constructor(R){this._state=0,this._results=[],this._error=null,this._onStateChanged=new A.Emitter,queueMicrotask(async()=>{const W={emitOne:F=>this.emitOne(F),emitMany:F=>this.emitMany(F),reject:F=>this.reject(F)};try{await Promise.resolve(R(W)),this.resolve()}catch(F){this.reject(F)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(R<this._results.length)return{done:!1,value:this._results[R++]};if(this._state===1)return{done:!0,value:void 0};await A.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(R,W){return new re(async F=>{for await(const H of R)F.emitOne(W(H))})}map(R){return re.map(this,R)}static filter(R,W){return new re(async F=>{for await(const H of R)W(H)&&F.emitOne(H)})}filter(R){return re.filter(this,R)}static coalesce(R){return re.filter(R,W=>!!W)}coalesce(){return re.coalesce(this)}static async toPromise(R){const W=[];for await(const F of R)W.push(F);return W}toPromise(){return re.toPromise(this)}emitOne(R){this._state===0&&(this._results.push(R),this._onStateChanged.fire())}emitMany(R){this._state===0&&(this._results=this._results.concat(R),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(R){this._state===0&&(this._state=2,this._error=R,this._onStateChanged.fire())}}e.AsyncIterableObject=re;class J extends re{constructor(R,W){super(W),this._source=R}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function q(P){const R=new k.CancellationTokenSource,W=P(R.token);return new J(R,async F=>{const H=R.token.onCancellationRequested(()=>{H.dispose(),R.dispose(),F.reject(new O.CancellationError)});try{for await(const Y of W){if(R.token.isCancellationRequested)return;F.emitOne(Y)}H.dispose(),R.dispose()}catch(Y){H.dispose(),R.dispose(),F.reject(Y)}})}e.createCancelableAsyncIterable=q}),define(oe[91],ae([0,1,18,5,48,34,16,6,27]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function f(){return Object.create(null)}e.getEmptyExpression=f,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",C="[^/\\\\]",S=/\//g;function c(K,V){switch(K){case 0:return"";case 1:return`${C}*?`;default:return`(?:${D}|${C}+${D}${V?`|${D}${C}+`:""})*?`}}function g(K,V){if(!K)return[];const z=[];let x=!1,ee=!1,ne="";for(const re of K){switch(re){case V:if(!x&&!ee){z.push(ne),ne="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=re}return ne&&z.push(ne),z}e.splitGlobAware=g;function y(K){if(!K)return"";let V="";const z=g(K,e.GLOB_SPLIT);if(z.every(x=>x===e.GLOBSTAR))V=".*";else{let x=!1;z.forEach((ee,ne)=>{if(ee===e.GLOBSTAR){if(x)return;V+=c(2,ne===z.length-1)}else{let re=!1,J="",q=!1,P="";for(const R of ee){if(R!=="}"&&re){J+=R;continue}if(q&&(R!=="]"||!P)){let W;R==="-"?W=R:(R==="^"||R==="!")&&!P?W="^":R===e.GLOB_SPLIT?W="":W=(0,I.escapeRegExpCharacters)(R),P+=W;continue}switch(R){case"{":re=!0;continue;case"[":q=!0;continue;case"}":{const F=`(?:${g(J,",").map(H=>y(H)).join("|")})`;V+=F,re=!1,J="";break}case"]":{V+="["+P+"]",q=!1,P="";break}case"?":V+=C;continue;case"*":V+=c(1);continue;default:V+=(0,I.escapeRegExpCharacters)(R)}}ne<z.length-1&&(z[ne+1]!==e.GLOBSTAR||ne+2<z.length)&&(V+=D)}x=ee===e.GLOBSTAR})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new U.LRUCache(1e4),a=function(){return!1},n=function(){return null};function s(K,V){if(!K)return n;let z;typeof K!="string"?z=K.pattern:z=K,z=z.trim();const x=`${z}_${!!V.trimForExclusions}`;let ee=t.get(x);if(ee)return i(ee,K);let ne;return m.test(z)?ee=o(z.substr(4),z):(ne=h.exec(r(z,V)))?ee=w(ne[1],z):(V.trimForExclusions?u:l).test(z)?ee=E(z,V):(ne=p.exec(r(z,V)))?ee=d(ne[1].substr(1),z,!0):(ne=b.exec(r(z,V)))?ee=d(ne[1],z,!1):ee=v(z),t.set(x,ee),i(ee,K)}function i(K,V){if(typeof V=="string")return K;const z=function(x,ee){return(0,A.isEqualOrParent)(x,V.base,!L.isLinux)?K((0,I.ltrim)(x.substr(V.base.length),_.sep),ee):null};return z.allBasenames=K.allBasenames,z.allPaths=K.allPaths,z.basenames=K.basenames,z.patterns=K.patterns,z}function r(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,V){return function(z,x){return typeof z=="string"&&z.endsWith(K)?V:null}}function w(K,V){const z=`/${K}`,x=`\\${K}`,ee=function(re,J){return typeof re!="string"?null:J?J===K?V:null:re===K||re.endsWith(z)||re.endsWith(x)?V:null},ne=[K];return ee.basenames=ne,ee.patterns=[V],ee.allBasenames=ne,ee}function E(K,V){const z=Q(K.slice(1,-1).split(",").map(J=>s(J,V)).filter(J=>J!==n),K),x=z.length;if(!x)return n;if(x===1)return z[0];const ee=function(J,q){for(let P=0,R=z.length;P<R;P++)if(z[P](J,q))return K;return null},ne=z.find(J=>!!J.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=z.reduce((J,q)=>q.allPaths?J.concat(q.allPaths):J,[]);return re.length&&(ee.allPaths=re),ee}function d(K,V,z){const x=_.sep===_.posix.sep,ee=x?K:K.replace(S,_.sep),ne=_.sep+ee,re=_.posix.sep+K;let J;return z?J=function(q,P){return typeof q=="string"&&(q===ee||q.endsWith(ne)||!x&&(q===K||q.endsWith(re)))?V:null}:J=function(q,P){return typeof q=="string"&&(q===ee||!x&&q===K)?V:null},J.allPaths=[(z?"*/":"./")+K],J}function v(K){try{const V=new RegExp(`^${y(K)}$`);return function(z){return V.lastIndex=0,typeof z=="string"&&V.test(z)?K:null}}catch{return n}}function T(K,V,z){return!K||typeof V!="string"?!1:N(K)(V,void 0,z)}e.match=T;function N(K,V={}){if(!K)return a;if(typeof K=="string"||M(K)){const z=s(K,V);if(z===n)return a;const x=function(ee,ne){return!!z(ee,ne)};return z.allBasenames&&(x.allBasenames=z.allBasenames),z.allPaths&&(x.allPaths=z.allPaths),x}return Z(K,V)}e.parse=N;function M(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=M;function $(K){return K.allBasenames||[]}e.getBasenameTerms=$;function j(K){return K.allPaths||[]}e.getPathTerms=j;function Z(K,V){const z=Q(Object.getOwnPropertyNames(K).map(J=>G(J,K[J],V)).filter(J=>J!==n)),x=z.length;if(!x)return n;if(!z.some(J=>!!J.requiresSiblings)){if(x===1)return z[0];const J=function(R,W){let F;for(let H=0,Y=z.length;H<Y;H++){const se=z[H](R,W);if(typeof se=="string")return se;(0,O.isThenable)(se)&&(F||(F=[]),F.push(se))}return F?(async()=>{for(const H of F){const Y=await H;if(typeof Y=="string")return Y}return null})():null},q=z.find(R=>!!R.allBasenames);q&&(J.allBasenames=q.allBasenames);const P=z.reduce((R,W)=>W.allPaths?R.concat(W.allPaths):R,[]);return P.length&&(J.allPaths=P),J}const ee=function(J,q,P){let R,W;for(let F=0,H=z.length;F<H;F++){const Y=z[F];Y.requiresSiblings&&P&&(q||(q=(0,_.basename)(J)),R||(R=q.substr(0,q.length-(0,_.extname)(J).length)));const se=Y(J,q,R,P);if(typeof se=="string")return se;(0,O.isThenable)(se)&&(W||(W=[]),W.push(se))}return W?(async()=>{for(const F of W){const H=await F;if(typeof H=="string")return H}return null})():null},ne=z.find(J=>!!J.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=z.reduce((J,q)=>q.allPaths?J.concat(q.allPaths):J,[]);return re.length&&(ee.allPaths=re),ee}function G(K,V,z){if(V===!1)return n;const x=s(K,z);if(x===n)return n;if(typeof V=="boolean")return x;if(V){const ee=V.when;if(typeof ee=="string"){const ne=(re,J,q,P)=>{if(!P||!x(re,J))return null;const R=ee.replace("$(basename)",()=>q),W=P(R);return(0,O.isThenable)(W)?W.then(F=>F?K:null):W?K:null};return ne.requiresSiblings=!0,ne}}return x}function Q(K,V){const z=K.filter(J=>!!J.basenames);if(z.length<2)return K;const x=z.reduce((J,q)=>{const P=q.basenames;return P?J.concat(P):J},[]);let ee;if(V){ee=[];for(let J=0,q=x.length;J<q;J++)ee.push(V)}else ee=z.reduce((J,q)=>{const P=q.patterns;return P?J.concat(P):J},[]);const ne=function(J,q){if(typeof J!="string")return null;if(!q){let R;for(R=J.length;R>0;R--){const W=J.charCodeAt(R-1);if(W===47||W===92)break}q=J.substr(R)}const P=x.indexOf(q);return P!==-1?ee[P]:null};ne.basenames=x,ne.patterns=ee,ne.allBasenames=x;const re=K.filter(J=>!J.basenames);return re.push(ne),re}function B(K,V){return(0,k.equals)(K,V,(z,x)=>typeof z=="string"&&typeof x=="string"?z===x:typeof z!="string"&&typeof x!="string"?z.base===x.base&&z.pattern===x.pattern:!1)}e.patternsEquals=B}),define(oe[92],ae([0,1,15,10]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(C){return C.toJSON()}class U{constructor(S){this._uriTransformer=S}transformIncoming(S){const c=this._uriTransformer.transformIncoming(S);return c===S?S:A(O.URI.from(c))}transformOutgoing(S){const c=this._uriTransformer.transformOutgoing(S);return c===S?S:A(O.URI.from(c))}transformOutgoingURI(S){const c=this._uriTransformer.transformOutgoing(S);return c===S?S:O.URI.from(c)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=U,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function _(C,S,c){if(!C||c>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return S.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const y=_(C[g],S,c+1);y!==null&&(C[g]=y)}}return null}function L(C,S){const c=_(C,S,0);return c===null?C:c}e.transformOutgoingURIs=L;function I(C,S,c,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return c?O.URI.revive(S.transformIncoming(C)):S.transformIncoming(C);if(C instanceof k.VSBuffer)return null;for(const y in C)if(Object.hasOwnProperty.call(C,y)){const m=I(C[y],S,c,g+1);m!==null&&(C[y]=m)}}return null}function f(C,S){const c=I(C,S,!1,0);return c===null?C:c}e.transformIncomingURIs=f;function D(C,S){const c=I(C,S,!0,0);return c===null?C:c}e.transformAndReviveIncomingURIs=D}),define(oe[31],ae([0,1,52,36,269,5,48,88,16,6,21,10]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function c(G,Q=S.UNLINK,B){if((0,_.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");return Q===S.UNLINK?y(G):g(G,B)}async function g(G,Q=(0,_.randomPath)((0,O.tmpdir)())){try{try{await k.promises.rename(G,Q)}catch(B){return B.code==="ENOENT"?void 0:y(G)}y(Q).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function y(G){return(0,A.promisify)(k.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function m(G){if((0,_.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function h(G,Q){return p(await(Q?l(G):(0,A.promisify)(k.readdir)(G)))}async function l(G){try{return await(0,A.promisify)(k.readdir)(G,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Q=[],B=await h(G);for(const K of B){let V=!1,z=!1,x=!1;try{const ee=await e.Promises.lstat((0,I.join)(G,K));V=ee.isFile(),z=ee.isDirectory(),x=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Q.push({name:K,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>x})}return Q}function u(G){return p(k.readdirSync(G))}e.readdirSync=u;function p(G){return G.map(Q=>typeof Q=="string"?f.isMacintosh?(0,L.normalizeNFC)(Q):Q:(Q.name=f.isMacintosh?(0,L.normalizeNFC)(Q.name):Q.name,Q))}async function b(G){const Q=await h(G),B=[];for(const K of Q)await a.existsDirectory((0,I.join)(G,K))&&B.push(K);return B}function t(G,Q=1e3){return new Promise(B=>{let K=!1;const V=setInterval(()=>{K||(K=!0,k.access(G,z=>{K=!1,z&&(clearInterval(V),B(void 0))}))},Q)})}e.whenDeleted=t;var a;(function(G){async function Q(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(f.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ee}throw x}}G.stat=Q;async function B(V){try{const{stat:z,symbolicLink:x}=await G.stat(V);return z.isFile()&&x?.dangling!==!0}catch{}return!1}G.existsFile=B;async function K(V){try{const{stat:z,symbolicLink:x}=await G.stat(V);return z.isDirectory()&&x?.dangling!==!0}catch{}return!1}G.existsDirectory=K})(a||(e.SymlinkSupport=a={}));const n=new U.ResourceQueue;function s(G,Q,B){return n.queueFor(C.URI.file(G),D.extUriBiasedIgnorePathCase).queue(()=>{const K=E(B);return new Promise((V,z)=>o(G,Q,K,x=>x?z(x):V()))})}let i=!0;function r(G){i=G}e.configureFlushOnWrite=r;function o(G,Q,B,K){if(!i)return k.writeFile(G,Q,{mode:B.mode,flag:B.flag},K);k.open(G,B.flag,B.mode,(V,z)=>{if(V)return K(V);k.writeFile(z,Q,x=>{if(x)return k.close(z,()=>K(x));k.fdatasync(z,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),k.close(z,ne=>K(ne))))})})}function w(G,Q,B){const K=E(B);if(!i)return k.writeFileSync(G,Q,{mode:K.mode,flag:K.flag});const V=k.openSync(G,K.flag,K.mode);try{k.writeFileSync(V,Q);try{k.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r(!1)}}finally{k.closeSync(V)}}e.writeFileSync=w;function E(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function d(G,Q,B=6e4){if(G!==Q)try{f.isWindows&&typeof B=="number"?await v(G,Q,Date.now(),B):await(0,A.promisify)(k.rename)(G,Q)}catch(K){if(G.toLowerCase()!==Q.toLowerCase()&&K.code==="EXDEV"||G.endsWith("."))await T(G,Q,{preserveSymlinks:!1}),await c(G,S.MOVE);else throw K}}async function v(G,Q,B,K,V=0){try{return await(0,A.promisify)(k.rename)(G,Q)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-B>=K)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let x=!1;try{const{stat:ee}=await a.stat(Q);ee.isFile()||(x=!0)}catch{}if(x)throw z}return await(0,U.timeout)(Math.min(100,V*10)),v(G,Q,B,K,V+1)}}async function T(G,Q,B){return M(G,Q,{root:{source:G,target:Q},options:B,handledSourcePaths:new Set})}const N=511;async function M(G,Q,B){if(B.handledSourcePaths.has(G))return;B.handledSourcePaths.add(G);const{stat:K,symbolicLink:V}=await a.stat(G);if(V){if(B.options.preserveSymlinks)try{return await Z(G,Q,B)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(V.dangling)return}return K.isDirectory()?$(G,Q,K.mode&N,B):j(G,Q,K.mode&N)}async function $(G,Q,B,K){await e.Promises.mkdir(Q,{recursive:!0,mode:B});const V=await h(G);for(const z of V)await M((0,I.join)(G,z),(0,I.join)(Q,z),K)}async function j(G,Q,B){await e.Promises.copyFile(G,Q),await e.Promises.chmod(Q,B)}async function Z(G,Q,B){let K=await e.Promises.readlink(G);(0,_.isEqualOrParent)(K,B.root.source,!f.isLinux)&&(K=(0,I.join)(B.root.target,K.substr(B.root.source.length+1))),await e.Promises.symlink(K,Q)}e.Promises=new class{get access(){return(0,A.promisify)(k.access)}get stat(){return(0,A.promisify)(k.stat)}get lstat(){return(0,A.promisify)(k.lstat)}get utimes(){return(0,A.promisify)(k.utimes)}get read(){return(G,Q,B,K,V)=>new Promise((z,x)=>{k.read(G,Q,B,K,V,(ee,ne,re)=>ee?x(ee):z({bytesRead:ne,buffer:re}))})}get readFile(){return(0,A.promisify)(k.readFile)}get write(){return(G,Q,B,K,V)=>new Promise((z,x)=>{k.write(G,Q,B,K,V,(ee,ne,re)=>ee?x(ee):z({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,A.promisify)(k.appendFile)}get fdatasync(){return(0,A.promisify)(k.fdatasync)}get truncate(){return(0,A.promisify)(k.truncate)}get copyFile(){return(0,A.promisify)(k.copyFile)}get open(){return(0,A.promisify)(k.open)}get close(){return(0,A.promisify)(k.close)}get symlink(){return(0,A.promisify)(k.symlink)}get readlink(){return(0,A.promisify)(k.readlink)}get chmod(){return(0,A.promisify)(k.chmod)}get mkdir(){return(0,A.promisify)(k.mkdir)}get unlink(){return(0,A.promisify)(k.unlink)}get rmdir(){return(0,A.promisify)(k.rmdir)}get realpath(){return(0,A.promisify)(k.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return b}get writeFile(){return s}get rm(){return c}get rename(){return d}get copy(){return T}}}),define(oe[144],ae([0,1,52,16,6,27,31]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function L(S){if(A.isLinux)return S;const c=(0,O.dirname)(S);if(S===c)return S;const g=((0,O.basename)(S)||S).toLowerCase();try{const m=(0,_.readdirSync)(c).filter(h=>h.toLowerCase()===g);if(m.length===1){const h=L(c);if(h)return(0,O.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(g);if(h>=0){const l=L(c);if(l)return(0,O.join)(l,m[h])}}}catch{}return null}e.realcaseSync=L;async function I(S){if(A.isLinux)return S;const c=(0,O.dirname)(S);if(S===c)return S;const g=((0,O.basename)(S)||S).toLowerCase();try{const m=(await _.Promises.readdir(c)).filter(h=>h.toLowerCase()===g);if(m.length===1){const h=await I(c);if(h)return(0,O.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(g);if(h>=0){const l=await I(c);if(l)return(0,O.join)(l,m[h])}}}catch{}return null}e.realcase=I;async function f(S){try{return await _.Promises.realpath(S)}catch{const g=C(S);return await _.Promises.access(g,k.constants.R_OK),g}}e.realpath=f;function D(S){try{return k.realpathSync(S)}catch{const g=C(S);return k.accessSync(g,k.constants.R_OK),g}}e.realpathSync=D;function C(S){return(0,U.rtrim)((0,O.normalize)(S),O.sep)}}),define(oe[145],ae([0,1,16,6,37,90,12,31]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return U.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return U.TerminateResponseCode}});function I(C=A.env){return C.comspec||"cmd.exe"}e.getWindowsShell=I;function f(C){let S=[],c=!1;const g=function(y){if(c){S.push(y);return}(!C.send(y,h=>{if(h&&console.error(h),c=!1,S.length>0){const l=S.slice(0);S=[],l.forEach(u=>g(u))}})||O.isWindows)&&(c=!0)};return{send:g}}e.createQueuedSender=f;var D;(function(C){async function S(c,g,y){if(k.isAbsolute(c))return c;if(g===void 0&&(g=A.cwd()),k.dirname(c)!=="."||(y===void 0&&_.isString(A.env.PATH)&&(y=A.env.PATH.split(k.delimiter)),y===void 0||y.length===0))return k.join(g,c);async function h(l){if(await L.Promises.exists(l)){let u;try{u=await L.Promises.stat(l)}catch(p){p.message.startsWith("EACCES")&&(u=await L.Promises.lstat(l))}return u?!u.isDirectory():!1}return!1}for(const l of y){let u;if(k.isAbsolute(l)?u=k.join(l,c):u=k.join(g,l,c),await h(u))return u;let p=u+".com";if(await h(p)||(p=u+".exe",await h(p)))return p}return k.join(g,c)}C.findExecutable=S})(D||(e.win32=D={}))}),define(oe[146],ae([0,1,64,23]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(_){return new Promise((L,I)=>{let f;const D=new Map;function C(c,g,y,m,h){const l=D.get(g);if(c===_||l){const u={name:S(y),cmd:y,pid:c,ppid:g,load:m,mem:h};D.set(c,u),c===_&&(f=u),l&&(l.children||(l.children=[]),l.children.push(u),l.children.length>1&&(l.children=l.children.sort((p,b)=>p.pid-b.pid)))}}function S(c){const g=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,m=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(m.exec(c))return"electron-crash-reporter";if(h.exec(c))return"winpty-agent";if(l.exec(c))return"conpty-agent";let p=u.exec(c);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?g.exec(c)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const b=/[a-zA-Z-]+\.js/g;let t="";do p=b.exec(c),p&&(t+=p+" ");while(p);return t&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${t})`:y.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,y)=>{te(["@vscode/windows-process-tree"],g,y)}).then(g=>{g.getProcessList(_,y=>{if(!y){I(new Error(`Root process ${_} not found`));return}g.getProcessCpuUsage(y,m=>{const h=new Map;m.forEach(l=>{const u=c(l.commandLine||"");h.set(l.pid,{name:S(u),cmd:u,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),f=h.get(_),f?(h.forEach(l=>{const u=h.get(l.ppid);u&&(u.children||(u.children=[]),u.children.push(l))}),h.forEach(l=>{l.children&&(l.children=l.children.sort((u,p)=>u.pid-p.pid))}),L(f)):I(new Error(`Root process ${_} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let c=function(){let g=[f];const y=[];for(;g.length;){const h=g.shift();h&&(y.push(h.pid),h.children&&(g=g.concat(h.children)))}let m=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+y.join(" "),(0,k.exec)(m,{},(h,l,u)=>{if(h||u)I(h||new Error(u.toString()));else{const p=l.toString().split(`
`);for(let b=0;b<y.length;b++){const t=D.get(y[b]);t.load=parseFloat(p[b])}if(!f){I(new Error(`Root process ${_} not found`));return}L(f)}})};(0,k.exec)("which ps",{},(g,y,m)=>{if(g||m)if(process.platform!=="linux")I(g||new Error(m.toString()));else{const h=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(h,{},(l,u,p)=>{l||p?I(l||new Error(p.toString())):(U(u,C),c())})}else{const h=y.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${h} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,p,b)=>{u||b&&!b.includes("screen size is bogus")?I(u||new Error(b.toString())):(U(p,C),process.platform==="linux"?c():f?L(f):I(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=A;function U(_,L){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=_.toString().split(`
`);for(const D of f){const C=I.exec(D.trim());C&&C.length===6&&L(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var ye=this&&this.__decorate||function(te,e,k,O){var A=arguments.length,U=A<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,k):O,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(te,e,k,O);else for(var L=te.length-1;L>=0;L--)(_=te[L])&&(U=(A<3?_(U):A>3?_(e,k,U):_(e,k))||U);return A>3&&U&&Object.defineProperty(e,k,U),U};define(oe[42],ae([0,1,18,5,15,26,83,8,3,2,63,27,12]),function(te,e,k,O,A,U,_,L,I,f,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var c;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(c||(c={}));function g(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(y||(y={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));function l(V){let z=0;for(let x=0;;x+=7){const ee=V.read(1);if(z|=(ee.buffer[0]&127)<<x,!(ee.buffer[0]&128))return z}}const u=n(0);function p(V,z){if(z===0){V.write(u);return}let x=0;for(let ne=z;ne!==0;ne=ne>>>7)x++;const ee=A.VSBuffer.alloc(x);for(let ne=0;z!==0;ne++)ee.buffer[ne]=z&127,z=z>>>7,z>0&&(ee.buffer[ne]|=128);V.write(ee)}class b{constructor(z){this.buffer=z,this.pos=0}read(z){const x=this.buffer.slice(this.pos,this.pos+z);return this.pos+=x.byteLength,x}}e.BufferReader=b;class t{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}e.BufferWriter=t;var a;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(a||(a={}));function n(V){const z=A.VSBuffer.alloc(1);return z.writeUInt8(V,0),z}const s={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},i=typeof Buffer<"u";function r(V,z){if(typeof z>"u")V.write(s.Undefined);else if(typeof z=="string"){const x=A.VSBuffer.fromString(z);V.write(s.String),p(V,x.byteLength),V.write(x)}else if(i&&Buffer.isBuffer(z)){const x=A.VSBuffer.wrap(z);V.write(s.Buffer),p(V,x.byteLength),V.write(x)}else if(z instanceof A.VSBuffer)V.write(s.VSBuffer),p(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(s.Array),p(V,z.length);for(const x of z)r(V,x)}else if(typeof z=="number"&&(z|0)===z)V.write(s.Uint),p(V,z);else{const x=A.VSBuffer.fromString(JSON.stringify(z));V.write(s.Object),p(V,x.byteLength),V.write(x)}}e.serialize=r;function o(V){switch(V.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return V.read(l(V)).toString();case a.Buffer:return V.read(l(V)).buffer;case a.VSBuffer:return V.read(l(V));case a.Array:{const x=l(V),ee=[];for(let ne=0;ne<x;ne++)ee.push(o(V));return ee}case a.Object:return JSON.parse(V.read(l(V)).toString());case a.Int:return l(V)}}e.deserialize=o;class w{constructor(z,x,ee=null,ne=1e3){this.protocol=z,this.ctx=x,this.logger=ee,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(z,x){this.channels.set(z,x),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const x=this.send([z.type]);this.logger?.logOutgoing(x,0,1,m(z.type));return}case 201:case 202:case 204:case 203:{const x=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(x,z.id,1,m(z.type),z.data);return}}}send(z,x=void 0){const ee=new t;return r(ee,z),r(ee,x),this.sendBuffer(ee.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const x=new b(z),ee=o(x),ne=o(x),re=ee[0];switch(re){case 100:return this.logger?.logIncoming(z.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.onPromise({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.logger?.logIncoming(z.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.onEventListen({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.logger?.logIncoming(z.byteLength,ee[1],1,`${g(re)}`),this.disposeActiveRequest({type:re,id:ee[1]});case 103:return this.logger?.logIncoming(z.byteLength,ee[1],1,`${g(re)}`),this.disposeActiveRequest({type:re,id:ee[1]})}}onPromise(z){const x=this.channels.get(z.channelName);if(!x){this.collectPendingRequest(z);return}const ee=new U.CancellationTokenSource;let ne;try{ne=x.call(this.ctx,z.name,z.arg,ee.token)}catch(q){ne=Promise.reject(q)}const re=z.id;ne.then(q=>{this.sendResponse({id:re,data:q,type:201})},q=>{q instanceof Error?this.sendResponse({id:re,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:re,data:q,type:203})}).finally(()=>{J.dispose(),this.activeRequests.delete(z.id)});const J=(0,f.toDisposable)(()=>ee.cancel());this.activeRequests.set(z.id,J)}onEventListen(z){const x=this.channels.get(z.channelName);if(!x){this.collectPendingRequest(z);return}const ee=z.id,re=x.listen(this.ctx,z.name,z.arg)(J=>this.sendResponse({id:ee,data:J,type:204}));this.activeRequests.set(z.id,re)}disposeActiveRequest(z){const x=this.activeRequests.get(z.id);x&&(x.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let x=this.pendingRequests.get(z.channelName);x||(x=[],this.pendingRequests.set(z.channelName,x));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:z,timeoutTimer:ee})}flushPendingRequests(z){const x=this.pendingRequests.get(z);if(x){for(const ee of x)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var E;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class d{constructor(z,x=null){this.protocol=z,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=x}getChannel(z){const x=this;return{call(ee,ne,re){return x.isDisposed?Promise.reject(new L.CancellationError):x.requestPromise(z,ee,ne,re)},listen(ee,ne){return x.isDisposed?I.Event.None:x.requestEvent(z,ee,ne)}}}requestPromise(z,x,ee,ne=U.CancellationToken.None){const re=this.lastRequestId++,q={id:re,type:100,channelName:z,name:x,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new L.CancellationError);let P;return new Promise((W,F)=>{if(ne.isCancellationRequested)return F(new L.CancellationError);const H=()=>{const he=ue=>{switch(ue.type){case 201:this.handlers.delete(re),W(ue.data);break;case 202:{this.handlers.delete(re);const me=new Error(ue.data.message);me.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,me.name=ue.data.name,F(me);break}case 203:this.handlers.delete(re),F(ue.data);break}};this.handlers.set(re,he),this.sendRequest(q)};let Y=null;this.state===h.Idle?H():(Y=(0,O.createCancelablePromise)(he=>this.whenInitialized()),Y.then(()=>{Y=null,H()}));const se=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:re,type:101}),F(new L.CancellationError)},le=ne.onCancellationRequested(se);P=(0,f.combinedDisposable)((0,f.toDisposable)(se),le),this.activeRequests.add(P)}).finally(()=>{P.dispose(),this.activeRequests.delete(P)})}requestEvent(z,x,ee){const ne=this.lastRequestId++,J={id:ne,type:102,channelName:z,name:x,arg:ee};let q=null;const P=new I.Emitter({onWillAddFirstListener:()=>{q=(0,O.createCancelablePromise)(W=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(P),this.sendRequest(J)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(P),this.sendRequest({id:ne,type:103}))}}),R=W=>P.fire(W.data);return this.handlers.set(ne,R),P.event}sendRequest(z){switch(z.type){case 100:case 102:{const x=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(x,z.id,0,`${g(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const x=this.send([z.type,z.id]);this.logger?.logOutgoing(x,z.id,0,g(z.type));return}}}send(z,x=void 0){const ee=new t;return r(ee,z),r(ee,x),this.sendBuffer(ee.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const x=new b(z),ee=o(x),ne=o(x),re=ee[0];switch(re){case 200:return this.logger?.logIncoming(z.byteLength,0,0,m(re)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(z.byteLength,ee[1],0,m(re),ne),this.onResponse({type:ee[0],id:ee[1],data:ne})}}onResponse(z){if(z.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=d,ye([_.memoize],d.prototype,"onDidInitializePromise",null);class v{get connections(){const z=[];return this._connections.forEach(x=>z.push(x)),z}constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new f.DisposableStore,this.disposables.add(z(({protocol:x,onDidClientDisconnect:ee})=>{const ne=I.Event.once(x.onMessage);this.disposables.add(ne(re=>{const J=new b(re),q=o(J),P=new w(x,q),R=new d(x);this.channels.forEach((F,H)=>P.registerChannel(H,F));const W={channelServer:P,channelClient:R,ctx:q};this._connections.add(W),this._onDidAddConnection.fire(W),this.disposables.add(ee(()=>{P.dispose(),R.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)}))}))}))}getChannel(z,x){const ee=this;return{call(ne,re,J){let q;if((0,S.isFunction)(x)){const R=(0,k.getRandomElement)(ee.connections.filter(x));q=R?Promise.resolve(R):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,x))}else q=x.routeCall(ee,ne,re);const P=q.then(R=>R.channelClient.getChannel(z));return N(P).call(ne,re,J)},listen(ne,re){if((0,S.isFunction)(x))return ee.getMulticastEvent(z,x,ne,re);const J=x.routeEvent(ee,ne,re).then(q=>q.channelClient.getChannel(z));return N(J).listen(ne,re)}}}getMulticastEvent(z,x,ee,ne){const re=this;let J;const q=new I.Emitter({onWillAddFirstListener:()=>{J=new f.DisposableStore;const P=new I.EventMultiplexer,R=new Map,W=H=>{const se=H.channelClient.getChannel(z).listen(ee,ne),le=P.add(se);R.set(H,le)},F=H=>{const Y=R.get(H);Y&&(Y.dispose(),R.delete(H))};re.connections.filter(x).forEach(W),I.Event.filter(re.onDidAddConnection,x)(W,void 0,J),re.onDidRemoveConnection(F,void 0,J),P.event(q.fire,q,J),J.add(P)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return q.event}registerChannel(z,x){this.channels.set(z,x);for(const ee of this._connections)ee.channelServer.registerChannel(z,x)}dispose(){this.disposables.dispose();for(const z of this._connections)z.channelClient.dispose(),z.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class T{constructor(z,x,ee=null){const ne=new t;r(ne,x),z.send(ne.buffer),this.channelClient=new d(z,ee),this.channelServer=new w(z,x,ee)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,x){this.channelServer.registerChannel(z,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function N(V){return{call(z,x,ee){return V.then(ne=>ne.call(z,x,ee))},listen(z,x){const ee=new I.Relay;return V.then(ne=>ee.input=ne.listen(z,x)),ee.event}}}e.getDelayedChannel=N;function M(V){let z=!1;return{call(x,ee,ne){return z?V.call(x,ee,ne):(0,O.timeout)(0).then(()=>z=!0).then(()=>V.call(x,ee,ne))},listen(x,ee){if(z)return V.listen(x,ee);const ne=new I.Relay;return(0,O.timeout)(0).then(()=>z=!0).then(()=>ne.input=V.listen(x,ee)),ne.event}}}e.getNextTickChannel=M;class ${constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const x of z.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await I.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=$;var j;(function(V){function z(re,J,q){const P=re,R=q&&q.disableMarshalling,W=new Map;for(const F in P)ee(F)&&W.set(F,I.Event.buffer(P[F],!0,void 0,J));return new class{listen(F,H,Y){const se=W.get(H);if(se)return se;if(ne(H)){const le=P[H];if(typeof le=="function")return le.call(P,Y)}throw new L.ErrorNoTelemetry(`Event not found: ${H}`)}call(F,H,Y){const se=P[H];if(typeof se=="function"){if(!R&&Array.isArray(Y))for(let he=0;he<Y.length;he++)Y[he]=(0,D.revive)(Y[he]);let le=se.apply(P,Y);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new L.ErrorNoTelemetry(`Method not found: ${H}`)}}}V.fromService=z;function x(re,J){const q=J&&J.disableMarshalling;return new Proxy({},{get(P,R){if(typeof R=="string")return J?.properties?.has(R)?J.properties.get(R):ne(R)?function(W){return re.listen(R,W)}:ee(R)?re.listen(R):async function(...W){let F;J&&!(0,S.isUndefinedOrNull)(J.context)?F=[J.context,...W]:F=W;const H=await re.call(R,F);return q?H:(0,D.revive)(H)};throw new L.ErrorNoTelemetry(`Property not found: ${String(R)}`)}})}V.toService=x;function ee(re){return re[0]==="o"&&re[1]==="n"&&C.isUpperAsciiLetter(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&C.isUpperAsciiLetter(re.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function Q(V){return Array.isArray(V)?V.map(G):G(V)}function B(V,z,x,ee,ne,re,J){J=Q(J);const q=Z[ne],P=q[ee%q.length];let R=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(re)?(R=R.concat(J),R.push(")")):R.push(J),console.log.apply(console,R)}class K{constructor(z,x){this._outgoingPrefix=z,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,x,ee,ne,re){this._totalOutgoing+=z,B(this._outgoingPrefix,this._totalOutgoing,z,x,ee,ne,re)}logIncoming(z,x,ee,ne,re){this._totalIncoming+=z,B(this._incomingPrefix,this._totalIncoming,z,x,ee,ne,re)}}e.IPCLogger=K}),define(oe[65],ae([0,1,15,3,2,42]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(_||(e.SocketDiagnosticsEventType=_={}));var L;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let r=0;function o(E,d){if(!i.has(E)){const v=String(++r);i.set(E,v)}return i.get(E)}function w(E,d,v,T){if(!s.enableDiagnostics)return;const N=o(E,d);if(T instanceof k.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const M=k.VSBuffer.alloc(T.byteLength);M.set(T),s.records.push({timestamp:Date.now(),id:N,label:d,type:v,buff:M})}else s.records.push({timestamp:Date.now(),id:N,label:d,type:v,data:T})}s.traceSocketEvent=w})(L||(e.SocketDiagnostics=L={}));var I;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I||(e.SocketCloseEventType=I={}));let f=null;function D(){return f||(f=k.VSBuffer.alloc(0)),f}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,r){if(i===0)return D();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const d=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=i),d}if(this._chunks[0].byteLength>i){const d=this._chunks[0].slice(0,i);return r&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),d}const o=k.VSBuffer.alloc(i);let w=0,E=0;for(;i>0;){const d=this._chunks[E];if(d.byteLength>i){const v=d.slice(0,i);o.set(v,w),w+=i,r&&(this._chunks[E]=d.slice(i),this._totalLength-=i),i-=i}else o.set(d,w),w+=d.byteLength,r?(this._chunks.shift(),this._totalLength-=d.byteLength):E++,i-=d.byteLength}return o}}e.ChunkStream=C;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function c(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class y{constructor(i,r,o,w){this.type=i,this.id=r,this.ack=o,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends A.Disposable{constructor(i){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:c(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,w=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new y(o,w,E,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=k.VSBuffer.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:c(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(r,i.data)}_bufferAdd(i,r){const o=this._totalLength===0;return this._data.push(i,r),this._totalLength+=i.byteLength+r.byteLength,o}_bufferTake(){const i=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,r){this._bufferAdd(i,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class l extends A.Disposable{constructor(i){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new y(1,0,0,i))}}e.Protocol=l;class u extends U.IPCClient{static fromSocket(i,r){return new u(new l(i),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(i,r,o=null){super(i,r,o),this.protocol=i}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=u;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class b{constructor(i){this.data=i,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let i=0,r=this._first;for(;r;)r=r.next,i++;return i}peek(){return this._first?this._first.data:null}toArray(){const i=[];let r=0,o=this._first;for(;o;)i[r++]=o.data,o=o.next;return i}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const r=new b(i);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class a{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}constructor(){this.lastRuns=[];const i=Date.now();for(let r=0;r<a._HISTORY_LENGTH;r++)this.lastRuns[r]=i-1e3*r;setInterval(()=>{for(let r=a._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const i=Date.now(),r=(1+a._HISTORY_LENGTH)*1e3;let o=0;for(let w=0;w<a._HISTORY_LENGTH;w++)i-this.lastRuns[w]<=r&&o++;return 1-o/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(i){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=i.loadEstimator??a.getInstance(),this._shouldSendKeepAlive=i.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=i.socket,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),i.initialChunk&&this._socketReader.acceptChunk(i.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new y(5,0,0,D());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new y(7,0,0,D());this._socketWriter.write(i)}sendResume(){const i=new y(8,0,0,D());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new y(3,0,this._incomingAckId,D());this._socketWriter.write(i);const r=this._outgoingUnackMsg.toArray();for(let o=0,w=r.length;o<w;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new y(6,0,0,D())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let o=0,w=r.length;o<w;o++)this._socketWriter.write(r[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new y(1,r,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const r=new y(2,0,0,i);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),r=Date.now()-i.writtenTime,o=Date.now()-this._socketReader.lastReadTime,w=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&o>=2e4&&w>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const E=Math.max(2e4-r,2e4-o,2e4-w,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new y(3,0,this._incomingAckId,D());this._socketWriter.write(i)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const i=new y(9,0,this._incomingAckId,D());this._socketWriter.write(i)}}e.PersistentProtocol=n}),define(oe[93],ae([0,1,64,5,15,26,142,8,3,2,30,145,90,42]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends c.ChannelServer{constructor(h){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",l=>A.VSBuffer.wrap(Buffer.from(l,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=g;class y{constructor(h,l){this.modulePath=h,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new O.Delayer(u),this.child=null,this._client=null}getChannel(h){const l=this;return{call(u,p,b){return l.requestPromise(h,u,p,b)},listen(u,p){return l.requestEvent(h,u,p)}}}requestPromise(h,l,u,p=U.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const b=this.getCachedChannel(h),t=(0,O.createCancelablePromise)(s=>b.call(l,u,s)),a=p.onCancellationRequested(()=>t.cancel()),n=(0,f.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(h,l,u){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let p;const b=new I.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(h).listen(l,u)(b.fire,b),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return b.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(l.env={...l.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(l.env),this.child=(0,k.fork)(this.modulePath,h,l);const u=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,_.isRemoteConsoleLog)(i)){(0,_.log)(i,`IPC Library: ${this.options.serverName}`);return}u.fire(A.VSBuffer.wrap(Buffer.from(i,"base64")))});const b=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,t=i=>this.child&&this.child.connected&&b.send(i.buffer.toString("base64")),a=u.event,n={send:t,onMessage:a};this._client=new c.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(o=>(0,f.dispose)(o)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(h){let l=this.channels.get(h);return l||(l=this.client.getChannel(h),this.channels.set(h,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(oe[147],ae([0,1,135,15,42,3,12,18]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(S){this.port=S,this.onMessage=U.Event.fromNodeEventEmitter(this.port,"message",c=>O.VSBuffer.wrap(c.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}class f extends A.IPCServer{static getOnDidClientConnect(S){(0,_.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const c=new U.Emitter;return process.parentPort.on("message",g=>{if(S?.handledClientConnection(g))return;const y=(0,L.firstOrDefault)(g.ports);y&&c.fire(y)}),U.Event.map(c.event,g=>({protocol:new I(g),onDidClientDisconnect:U.Event.fromNodeEventEmitter(g,"close")}))}constructor(S){super(f.getOnDidClientConnect(S))}}e.Server=f;function D(C,S,c){const g=y=>{y.data===S&&(C.removeListener("message",g),c())};C.on("message",g)}e.once=D}),define(oe[66],ae([0,1,5,3,2,63,12]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L||(e.StorageHint=L={}));function I(S){const c=S;return c?.changed instanceof Map||c?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var f;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(f||(e.StorageState=f={}));class D extends A.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(c,g=Object.create(null)){super(),this.database=c,this.options=g,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=this._register(new k.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){this._onDidChangeStorage.pause();try{c.changed?.forEach((g,y)=>this.acceptExternal(y,g)),c.deleted?.forEach(g=>this.acceptExternal(g,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(c,g){if(this.state===f.Closed)return;let y=!1;(0,_.isUndefinedOrNull)(g)?y=this.cache.delete(c):this.cache.get(c)!==g&&(this.cache.set(c,g),y=!0),y&&this._onDidChangeStorage.fire({key:c,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,g){const y=this.cache.get(c);return(0,_.isUndefinedOrNull)(y)?g:y}getBoolean(c,g){const y=this.get(c);return(0,_.isUndefinedOrNull)(y)?g:y==="true"}getNumber(c,g){const y=this.get(c);return(0,_.isUndefinedOrNull)(y)?g:parseInt(y,10)}getObject(c,g){const y=this.get(c);return(0,_.isUndefinedOrNull)(y)?g:(0,U.parse)(y)}async set(c,g,y=!1){if(this.state===f.Closed)return;if((0,_.isUndefinedOrNull)(g))return this.delete(c,y);const m=(0,_.isObject)(g)||Array.isArray(g)?(0,U.stringify)(g):String(g);if(this.cache.get(c)!==m)return this.cache.set(c,m),this.pendingInserts.set(c,m),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire({key:c,external:y}),this.doFlush()}async delete(c,g=!1){if(!(this.state===f.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire({key:c,external:g}),this.doFlush()}async optimize(){if(this.state!==f.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(this.hasPending)return this.doFlush(c)}async doFlush(c){return this.options.hint===L.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}isInMemory(){return this.options.hint===L.STORAGE_IN_MEMORY}}e.Storage=D;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert?.forEach((g,y)=>this.items.set(y,g)),c.delete?.forEach(g=>this.items.delete(g))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(A||(e.TokenType=A={}));function U(...f){switch(f.length){case 1:return(0,O.localize)(0,null,f[0]);case 2:return(0,O.localize)(1,null,f[0],f[1]);case 3:return(0,O.localize)(2,null,f[0],f[1],f[2]);default:return}}const _=(0,O.localize)(3,null),L=(0,O.localize)(4,null);class I{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const C=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:C})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const C=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:C})}else this._match(126)?this._addToken(9):this._error(U("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(U("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(U("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(D){const C=this._start,S=this._input.substring(this._start,this._current),c={type:19,offset:this._start,lexeme:S};this._errors.push({offset:C,lexeme:S,additionalInfo:D}),this._tokens.push(c)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const C=this._input.substring(this._start,this._current),S=I._keywords.get(C);S?this._addToken(S):this._tokens.push({type:17,lexeme:C,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,C=!1,S=!1;for(;;){if(D>=this._input.length){this._current=D,this._error(L);return}const g=this._input.charCodeAt(D);if(C)C=!1;else if(g===47&&!S){D++;break}else g===91?S=!0:g===92?C=!0:g===93&&(S=!1);D++}for(;D<this._input.length&&I._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const c=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:c,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=I}),define(oe[180],ae([0,1,62,83,23,16,37,21,10]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class f{get appRoot(){return(0,U.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,U.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,L.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,L.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,U.join)(this.userDataPath,"logs",c)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(I.URI.file((0,U.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,L.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,L.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=_.env.VSCODE_PORTABLE;return c?I.URI.file((0,U.join)(c,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,U.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,U.resolve)(c):(0,U.normalize)((0,U.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?I.URI.file((0,U.resolve)(c)):I.URI.file((0,U.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,U.resolve)(c);const g=_.env.VSCODE_EXTENSIONS;if(g)return g;const y=_.env.VSCODE_PORTABLE;return y?(0,U.join)(y,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(g=>/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,U.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?I.URI.parse(c):I.URI.file((0,U.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(c))}get extensionLogLevel(){const c=[];for(const g of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);y&&y[1]&&y[2]&&c.push([y[1],y[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,L.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=_.env.VSCODE_PORTABLE;return c?I.URI.file((0,U.join)(c,"policy.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this._args}constructor(c,g,y){this._args=c,this.paths=g,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=f,ye([O.memoize],f.prototype,"appRoot",null),ye([O.memoize],f.prototype,"userHome",null),ye([O.memoize],f.prototype,"userDataPath",null),ye([O.memoize],f.prototype,"appSettingsHome",null),ye([O.memoize],f.prototype,"tmpDir",null),ye([O.memoize],f.prototype,"cacheHome",null),ye([O.memoize],f.prototype,"stateResource",null),ye([O.memoize],f.prototype,"userRoamingDataHome",null),ye([O.memoize],f.prototype,"userDataSyncHome",null),ye([O.memoize],f.prototype,"sync",null),ye([O.memoize],f.prototype,"machineSettingsResource",null),ye([O.memoize],f.prototype,"workspaceStorageHome",null),ye([O.memoize],f.prototype,"localHistoryHome",null),ye([O.memoize],f.prototype,"keyboardLayoutResource",null),ye([O.memoize],f.prototype,"argvResource",null),ye([O.memoize],f.prototype,"isExtensionDevelopment",null),ye([O.memoize],f.prototype,"untitledWorkspacesHome",null),ye([O.memoize],f.prototype,"builtinExtensionsPath",null),ye([O.memoize],f.prototype,"extensionsPath",null),ye([O.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ye([O.memoize],f.prototype,"extensionDevelopmentKind",null),ye([O.memoize],f.prototype,"extensionTestsLocationURI",null),ye([O.memoize],f.prototype,"debugExtensionHost",null),ye([O.memoize],f.prototype,"logLevel",null),ye([O.memoize],f.prototype,"extensionLogLevel",null),ye([O.memoize],f.prototype,"serviceMachineIdResource",null),ye([O.memoize],f.prototype,"disableTelemetry",null),ye([O.memoize],f.prototype,"disableWorkspaceTrust",null),ye([O.memoize],f.prototype,"useInMemorySecretStorage",null),ye([O.memoize],f.prototype,"policyFile",null);function D(S,c){return C(S["inspect-extensions"],S["inspect-brk-extensions"],5870,c,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=D;function C(S,c,g,y,m,h){const u=Number(c||S)||(y?null:g),p=u?!!c:!1;let b;if(h)try{b=JSON.parse(h)}catch{}return{port:u,break:p,debugId:m,env:b}}e.parseDebugParams=C}),function(){"use strict";function te(e,k,O){function A(_,L){const I=U(_,L),f=[I];return e.isAbsolute(I)||f.unshift(O),e.resolve(...f)}function U(_,L){process.env.VSCODE_DEV&&(L="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,L);const D=_["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(C,"AppData","Roaming")}break;case"darwin":f=e.join(k.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,L)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,k,O){return te(e,k,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=te(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class U extends O.AbstractNativeEnvironmentService{constructor(f,D){super(f,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,A.getUserDataPath)(f,D.nameShort)},D)}}e.NativeEnvironmentService=U;function _(I,f){return(0,O.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,f,I.extensionEnvironment)}e.parsePtyHostDebugPort=_;function L(I,f){return(0,O.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,f,I.extensionEnvironment)}e.parseSharedProcessDebugPort=L}),define(oe[183],ae([0,1,12,154]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function A(_,L,I,f){try{U(_,L,I,f)}catch(D){_.error(D?.message??D)}return L}e.localizeManifest=A;function U(_,L,I,f){const D=(C,S,c)=>{const g=C[S];if((0,k.isString)(g)){const y=g,m=y.length;if(m>1&&y[0]==="%"&&y[m-1]==="%"){const h=y.substr(1,m-2);let l=I[h];l===void 0&&f&&(l=f[h]);const u=typeof l=="string"?l:l?.message,p=f?.[h],b=typeof p=="string"?p:p?.message;if(!u){b||_.warn(`[${L.name}]: ${(0,O.localize)(0,null,h)}`);return}if(c&&(S==="title"||S==="category")&&b&&b!==u){const t={value:u,original:b};C[S]=t}else C[S]=u}}else if((0,k.isObject)(g))for(const y in g)g.hasOwnProperty(y)&&(y==="commands"?D(g,y,!0):D(g,y,c));else if(Array.isArray(g))for(let y=0;y<g.length;y++)D(g,y,c)};for(const C in L)L.hasOwnProperty(C)&&D(L,C)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(U){this.channel=U}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(U){return this.channel.call("promptImportantExtensionsInstallNotification",[U])}promptWorkspaceRecommendations(U){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class O{constructor(U){this.service=U}listen(U,_){throw new Error(`Event not found: ${_}`)}call(U,_,L){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(L[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(oe[67],ae([0,1,21,89,158,53]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function I(h){return h=h.trim(),h==="*"||_.test(h)}e.isValidVersionStr=I;function f(h){if(!I(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=h.match(_);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.parseVersion=f;function D(h){if(!h)return null;const l=h.majorBase,u=h.majorMustEqual,p=h.minorBase;let b=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(l===0||(b=!1),a=!1);let n=0;if(h.preRelease){const s=L.exec(h.preRelease);if(s){const[,i,r,o]=s;n=Date.UTC(Number(i),Number(r)-1,Number(o))}}return{majorBase:l,majorMustEqual:u,minorBase:p,minorMustEqual:b,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:n}}e.normalizeVersion=D;function C(h,l,u){let p;typeof h=="string"?p=D(f(h)):p=h;let b;l instanceof Date?b=l.getTime():typeof l=="string"&&(b=new Date(l).getTime());let t;if(typeof u=="string"?t=D(f(u)):t=u,!p||!t)return!1;const a=p.majorBase,n=p.minorBase,s=p.patchBase;let i=t.majorBase,r=t.minorBase,o=t.patchBase;const w=t.notBefore;let E=t.majorMustEqual,d=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?a>i?!0:a<i?!1:n>r?!0:n<r||b&&b<w?!1:s>=o:(a===1&&i===0&&(!E||!d||!v)&&(i=1,r=0,o=0,E=!0,d=!1,v=!1),a<i?!1:a>i?!E:n<r?!1:n>r?!d:s<o?!1:s>o?!v:!(b&&b<w))}e.isValidVersion=C;function S(h,l,u,p,b){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([O.default.Error,A.localize(0,null)]),t;if(typeof p.name!="string")return t.push([O.default.Error,A.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([O.default.Error,A.localize(2,null,"version")]),t;if(!p.engines)return t.push([O.default.Error,A.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([O.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return t.push([O.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return t.push([O.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([O.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([O.default.Warning,A.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([O.default.Error,A.localize(9,null,"main")]),t;{const s=(0,k.joinPath)(u,p.main);(0,k.isEqualOrParent)(s,u)||t.push([O.default.Warning,A.localize(10,null,s.path,u.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([O.default.Error,A.localize(11,null,"browser")]),t;{const s=(0,k.joinPath)(u,p.browser);(0,k.isEqualOrParent)(s,u)||t.push([O.default.Warning,A.localize(12,null,s.path,u.path)])}}if(!U.valid(p.version))return t.push([O.default.Error,A.localize(13,null)]),t;const a=[];if(!c(h,l,p,b,a))for(const s of a)t.push([O.default.Error,s]);return t}e.validateExtensionManifest=S;function c(h,l,u,p,b){return p||typeof u.main>"u"&&typeof u.browser>"u"?!0:y(h,l,u.engines.vscode,b)}e.isValidExtensionVersion=c;function g(h,l,u){return h==="*"||y(l,u,h)}e.isEngineValid=g;function y(h,l,u,p=[]){const b=D(f(u));if(!b)return p.push(A.localize(14,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return p.push(A.localize(15,null,u)),!1}else if(!b.majorMustEqual)return p.push(A.localize(16,null,u)),!1;return C(h,l,b)?!0:(p.push(A.localize(17,null,h,u)),!1)}function m(h){if(!Array.isArray(h))return!1;for(let l=0,u=h.length;l<u;l++)if(typeof h[l]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(U,_,L){let I=L&&L.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const D=(await _.readFile(U.serviceMachineIdResource)).value.toString();I=(0,O.isUUID)(D)?D:null}catch{I=null}if(!I){I=(0,O.generateUuid)();try{await _.writeFile(U.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return L?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=A}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(A,U=[],_=!1){this.ctor=A,this.staticArguments=U,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=k}),define(oe[185],ae([0,1,68]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var A;(function(L){L[L.Eager=0]="Eager",L[L.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function U(L,I,f){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],!!f)),O.push([L,I])}e.registerSingleton=U;function _(){return O}e.getSingletonServiceDescriptors=_}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(U,_){this.key=U,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class O{constructor(U){this._hashFn=U,this._nodes=new Map}roots(){const U=[];for(const _ of this._nodes.values())_.outgoing.size===0&&U.push(_);return U}insertEdge(U,_){const L=this.lookupOrInsertNode(U),I=this.lookupOrInsertNode(_);L.outgoing.set(I.key,I),I.incoming.set(L.key,L)}removeNode(U){const _=this._hashFn(U);this._nodes.delete(_);for(const L of this._nodes.values())L.outgoing.delete(_),L.incoming.delete(_)}lookupOrInsertNode(U){const _=this._hashFn(U);let L=this._nodes.get(_);return L||(L=new k(_,U),this._nodes.set(_,L)),L}lookup(U){return this._nodes.get(this._hashFn(U))}isEmpty(){return this._nodes.size===0}toString(){const U=[];for(const[_,L]of this._nodes)U.push(`${_}
	(-> incoming)[${[...L.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...L.outgoing.keys()].join(",")}]
`);return U.join(`
`)}findCycleSlow(){for(const[U,_]of this._nodes){const L=new Set([U]),I=this._findCycle(_,L);if(I)return I}}_findCycle(U,_){for(const[L,I]of U.outgoing){if(_.has(L))return[..._,L].join(" -> ");_.add(L);const f=this._findCycle(I,_);if(f)return f;_.delete(L)}}}e.Graph=O}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function L(I){return I[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=L})(k||(e._util=k={})),e.IInstantiationService=A("instantiationService");function O(_,L,I){L[k.DI_TARGET]===L?L[k.DI_DEPENDENCIES].push({id:_,index:I}):(L[k.DI_DEPENDENCIES]=[{id:_,index:I}],L[k.DI_TARGET]=L)}function A(_){if(k.serviceIds.has(_))return k.serviceIds.get(_);const L=function(I,f,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(L,I,D)};return L.toString=()=>_,k.serviceIds.set(_,L),L}e.createDecorator=A;function U(_){return _}e.refineServiceDecorator=U}),define(oe[187],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[19],ae([0,1,12,10,4]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function U(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationOverrides=U;function _(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=_;var L;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(L||(e.ConfigurationTarget=L={}));function I(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function f(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.isConfigured=f;function D(h,l){const u=Object.create(null);for(const p in h)C(u,p,h[p],l);return u}e.toValuesTree=D;function C(h,l,u,p){const b=l.split("."),t=b.pop();let a=h;for(let n=0;n<b.length;n++){const s=b[n];let i=a[s];switch(typeof i){case"undefined":i=a[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${l} as ${b.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[t]=u}catch{p(`Ignoring ${l} as ${b.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${l} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=C;function S(h,l){const u=l.split(".");c(h,u)}e.removeFromValueTree=S;function c(h,l){const u=l.shift();if(l.length===0){delete h[u];return}if(Object.keys(h).indexOf(u)!==-1){const p=h[u];typeof p=="object"&&!Array.isArray(p)&&(c(p,l),Object.keys(p).length===0&&delete h[u])}}function g(h,l,u){function p(a,n){let s=a;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const b=l.split("."),t=p(h,b);return typeof t>"u"?u:t}e.getConfigurationValue=g;function y(h,l,u){Object.keys(l).forEach(p=>{p!=="__proto__"&&(p in h?k.isObject(h[p])&&k.isObject(l[p])?y(h[p],l[p],u):u&&(h[p]=l[p]):h[p]=l[p])})}e.merge=y;function m(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(oe[94],ae([0,1,6,27,179,4,150,8]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",k.isMacintosh),I.set("isLinux",k.isLinux),I.set("isWindows",k.isWindows),I.set("isWeb",k.isWeb),I.set("isMacNative",k.isMacintosh&&!k.isWeb),I.set("isEdge",k.isEdge),I.set("isFirefox",k.isFirefox),I.set("isChrome",k.isChrome),I.set("isSafari",k.isSafari);function f(q,P){if(I.get(q)!==void 0)throw(0,L.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(q,P)}e.setConstant=f;const D=Object.prototype.hasOwnProperty;var C;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const S={regexParsingWithErrorRecovery:!0},c=(0,_.localize)(0,null),g=(0,_.localize)(1,null),y=(0,_.localize)(2,null),m=(0,_.localize)(3,null),h=(0,_.localize)(4,null),l=(0,_.localize)(5,null),u=(0,_.localize)(6,null),p=(0,_.localize)(7,null);class b{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=S){this._config=P,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const R=this._expr();if(!this._isAtEnd()){const W=this._peek(),F=W.type===17?l:void 0;throw this._parsingErrors.push({message:h,offset:W.offset,lexeme:A.Scanner.getLexeme(W),additionalInfo:F}),b._parseError}return R}catch(R){if(R!==b._parseError)throw R;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(16);){const R=this._and();P.push(R)}return P.length===1?P[0]:t.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(15);){const R=this._term();P.push(R)}return P.length===1?P[0]:t.and(...P)}_term(){if(this._matchOne(2)){const P=this._peek();switch(P.type){case 11:return this._advance(),i.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const R=this._expr();return this._consume(1,m),R?.negate()}case 17:return this._advance(),T.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const R=this._expr();return this._consume(1,m),R}case 17:{const R=P.lexeme;if(this._advance(),this._matchOne(9)){const F=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),F.type!==10)throw this._errExpectedButGot("REGEX",F);const H=F.lexeme,Y=H.lastIndexOf("/"),se=Y===H.length-1?void 0:this._removeFlagsGY(H.substring(Y+1));let le;try{le=new RegExp(H.substring(1,Y),se)}catch{throw this._errExpectedButGot("REGEX",F)}return G.create(R,le)}switch(F.type){case 10:case 19:{const H=[F.lexeme];this._advance();let Y=this._peek(),se=0;for(let fe=0;fe<F.lexeme.length;fe++)F.lexeme.charCodeAt(fe)===40?se++:F.lexeme.charCodeAt(fe)===41&&se--;for(;!this._isAtEnd()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let fe=0;fe<Y.lexeme.length;fe++)Y.lexeme.charCodeAt(fe)===40?se++:F.lexeme.charCodeAt(fe)===41&&se--}if(se<0)break;H.push(A.Scanner.getLexeme(Y)),this._advance(),Y=this._peek()}const le=H.join(""),he=le.lastIndexOf("/"),ue=he===le.length-1?void 0:this._removeFlagsGY(le.substring(he+1));let me;try{me=new RegExp(le.substring(1,he),ue)}catch{throw this._errExpectedButGot("REGEX",F)}return t.regex(R,me)}case 18:{const H=F.lexeme;this._advance();let Y=null;if(!(0,O.isFalsyOrWhitespace)(H)){const se=H.indexOf("/"),le=H.lastIndexOf("/");if(se!==le&&se>=0){const he=H.slice(se+1,le),ue=H[le+1]==="i"?"i":"";try{Y=new RegExp(he,ue)}catch{throw this._errExpectedButGot("REGEX",F)}}}if(Y===null)throw this._errExpectedButGot("REGEX",F);return G.create(R,Y)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const F=this._value();return t.notIn(R,F)}switch(this._peek().type){case 3:{this._advance();const F=this._value();if(this._previous().type===18)return t.equals(R,F);switch(F){case"true":return t.has(R);case"false":return t.not(R);default:return t.equals(R,F)}}case 4:{this._advance();const F=this._value();if(this._previous().type===18)return t.notEquals(R,F);switch(F){case"true":return t.not(R);case"false":return t.has(R);default:return t.notEquals(R,F)}}case 5:return this._advance(),j.create(R,this._value());case 6:return this._advance(),Z.create(R,this._value());case 7:return this._advance(),M.create(R,this._value());case 8:return this._advance(),$.create(R,this._value());case 13:return this._advance(),t.in(R,this._value());default:return t.has(R)}}case 20:throw this._parsingErrors.push({message:u,offset:P.offset,lexeme:"",additionalInfo:p}),b._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case 17:case 18:return this._advance(),P.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,R){if(this._check(P))return this._advance();throw this._errExpectedButGot(R,this._peek())}_errExpectedButGot(P,R,W){const F=(0,_.localize)(8,null,P,A.Scanner.getLexeme(R)),H=R.offset,Y=A.Scanner.getLexeme(R);return this._parsingErrors.push({message:F,offset:H,lexeme:Y,additionalInfo:W}),b._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=b;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(P){return o.create(P)}static equals(P,R){return w.create(P,R)}static notEquals(P,R){return v.create(P,R)}static regex(P,R){return G.create(P,R)}static in(P,R){return E.create(P,R)}static notIn(P,R){return d.create(P,R)}static not(P){return T.create(P)}static and(...P){return K.create(P,null,!0)}static or(...P){return V.create(P,null,!0)}static greater(P,R){return M.create(P,R)}static greaterEquals(P,R){return $.create(P,R)}static smaller(P,R){return j.create(P,R)}static smallerEquals(P,R){return Z.create(P,R)}static{this._parser=new b({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}e.ContextKeyExpr=t;function a(q){const P=new b({regexParsingWithErrorRecovery:!1});return q.map(R=>(P.parse(R),P.lexingErrors.length>0?P.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,_.localize)(9,null,W.additionalInfo):(0,_.localize)(10,null),offset:W.offset,length:W.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.validateWhenClauses=a;function n(q,P){const R=q?q.substituteConstants():void 0,W=P?P.substituteConstants():void 0;return!R&&!W?!0:!R||!W?!1:R.equals(W)}e.expressionsAreEqualWithConstantSubstitution=n;function s(q,P){return q.cmp(P)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=r;class o{static create(P,R=null){const W=I.get(P);return typeof W=="boolean"?W?r.INSTANCE:i.INSTANCE:new o(P,R)}constructor(P,R){this.key=P,this.negated=R,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:x(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=I.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:i.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class w{static create(P,R,W=null){if(typeof R=="boolean")return R?o.create(P,W):T.create(P,W);const F=I.get(P);return typeof F=="boolean"?R===(F?"true":"false")?r.INSTANCE:i.INSTANCE:new w(P,R,W)}constructor(P,R,W){this.key=P,this.value=R,this.negated=W,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=I.get(this.key);if(typeof P=="boolean"){const R=P?"true":"false";return this.value===R?r.INSTANCE:i.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class E{static create(P,R){return new E(P,R)}constructor(P,R){this.key=P,this.valueKey=R,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const R=P.getValue(this.valueKey),W=P.getValue(this.key);return Array.isArray(R)?R.includes(W):typeof W=="string"&&typeof R=="object"&&R!==null?D.call(R,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class d{static create(P,R){return new d(P,R)}constructor(P,R){this.key=P,this.valueKey=R,this.type=11,this._negated=E.create(P,R)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class v{static create(P,R,W=null){if(typeof R=="boolean")return R?T.create(P,W):o.create(P,W);const F=I.get(P);return typeof F=="boolean"?R===(F?"true":"false")?i.INSTANCE:r.INSTANCE:new v(P,R,W)}constructor(P,R,W){this.key=P,this.value=R,this.negated=W,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=I.get(this.key);if(typeof P=="boolean"){const R=P?"true":"false";return this.value===R?i.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class T{static create(P,R=null){const W=I.get(P);return typeof W=="boolean"?W?i.INSTANCE:r.INSTANCE:new T(P,R)}constructor(P,R){this.key=P,this.negated=R,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:x(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=I.get(this.key);return typeof P=="boolean"?P?i.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function N(q,P){if(typeof q=="string"){const R=parseFloat(q);isNaN(R)||(q=R)}return typeof q=="string"||typeof q=="number"?P(q):i.INSTANCE}class M{static create(P,R,W=null){return N(R,F=>new M(P,F,W))}constructor(P,R,W){this.key=P,this.value=R,this.negated=W,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class ${static create(P,R,W=null){return N(R,F=>new $(P,F,W))}constructor(P,R,W){this.key=P,this.value=R,this.negated=W,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class j{static create(P,R,W=null){return N(R,F=>new j(P,F,W))}constructor(P,R,W){this.key=P,this.value=R,this.negated=W,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=j;class Z{static create(P,R,W=null){return N(R,F=>new Z(P,F,W))}constructor(P,R,W){this.key=P,this.value=R,this.negated=W,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=Z;class G{static create(P,R){return new G(P,R)}constructor(P,R){this.key=P,this.regexp=R,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const R=this.regexp?this.regexp.source:"",W=P.regexp?P.regexp.source:"";return R<W?-1:R>W?1:0}equals(P){if(P.type===this.type){const R=this.regexp?this.regexp.source:"",W=P.regexp?P.regexp.source:"";return this.key===P.key&&R===W}return!1}substituteConstants(){return this}evaluate(P){const R=P.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Q.create(this)),this.negated}}e.ContextKeyRegexExpr=G;class Q{static create(P){return new Q(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(P){return new Q(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Q;function B(q){let P=null;for(let R=0,W=q.length;R<W;R++){const F=q[R].substituteConstants();if(q[R]!==F&&P===null){P=[];for(let H=0;H<R;H++)P[H]=q[H]}P!==null&&(P[R]=F)}return P===null?q:P}class K{static create(P,R,W){return K._normalizeArr(P,R,W)}constructor(P,R){this.expr=P,this.negated=R,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let R=0,W=this.expr.length;R<W;R++){const F=s(this.expr[R],P.expr[R]);if(F!==0)return F}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let R=0,W=this.expr.length;R<W;R++)if(!this.expr[R].equals(P.expr[R]))return!1;return!0}return!1}substituteConstants(){const P=B(this.expr);return P===this.expr?this:K.create(P,this.negated,!1)}evaluate(P){for(let R=0,W=this.expr.length;R<W;R++)if(!this.expr[R].evaluate(P))return!1;return!0}static _normalizeArr(P,R,W){const F=[];let H=!1;for(const Y of P)if(Y){if(Y.type===1){H=!0;continue}if(Y.type===0)return i.INSTANCE;if(Y.type===6){F.push(...Y.expr);continue}F.push(Y)}if(F.length===0&&H)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(s);for(let Y=1;Y<F.length;Y++)F[Y-1].equals(F[Y])&&(F.splice(Y,1),Y--);if(F.length===1)return F[0];for(;F.length>1;){const Y=F[F.length-1];if(Y.type!==9)break;F.pop();const se=F.pop(),le=F.length===0,he=V.create(Y.expr.map(ue=>K.create([ue,se],null,W)),null,le);he&&(F.push(he),F.sort(s))}if(F.length===1)return F[0];if(W){for(let Y=0;Y<F.length;Y++)for(let se=Y+1;se<F.length;se++)if(F[Y].negate().equals(F[se]))return i.INSTANCE;if(F.length===1)return F[0]}return new K(F,R)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const R of this.expr)P.push(...R.keys());return P}map(P){return new K(this.expr.map(R=>R.map(P)),null)}negate(){if(!this.negated){const P=[];for(const R of this.expr)P.push(R.negate());this.negated=V.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=K;class V{static create(P,R,W){return V._normalizeArr(P,R,W)}constructor(P,R){this.expr=P,this.negated=R,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let R=0,W=this.expr.length;R<W;R++){const F=s(this.expr[R],P.expr[R]);if(F!==0)return F}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let R=0,W=this.expr.length;R<W;R++)if(!this.expr[R].equals(P.expr[R]))return!1;return!0}return!1}substituteConstants(){const P=B(this.expr);return P===this.expr?this:V.create(P,this.negated,!1)}evaluate(P){for(let R=0,W=this.expr.length;R<W;R++)if(this.expr[R].evaluate(P))return!0;return!1}static _normalizeArr(P,R,W){let F=[],H=!1;if(P){for(let Y=0,se=P.length;Y<se;Y++){const le=P[Y];if(le){if(le.type===0){H=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){F=F.concat(le.expr);continue}F.push(le)}}if(F.length===0&&H)return i.INSTANCE;F.sort(s)}if(F.length!==0){if(F.length===1)return F[0];for(let Y=1;Y<F.length;Y++)F[Y-1].equals(F[Y])&&(F.splice(Y,1),Y--);if(F.length===1)return F[0];if(W){for(let Y=0;Y<F.length;Y++)for(let se=Y+1;se<F.length;se++)if(F[Y].negate().equals(F[se]))return r.INSTANCE;if(F.length===1)return F[0]}return new V(F,R)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const R of this.expr)P.push(...R.keys());return P}map(P){return new V(this.expr.map(R=>R.map(P)),null)}negate(){if(!this.negated){const P=[];for(const R of this.expr)P.push(R.negate());for(;P.length>1;){const R=P.shift(),W=P.shift(),F=[];for(const H of J(R))for(const Y of J(W))F.push(K.create([H,Y],null,!1));P.unshift(V.create(F,null,!1))}this.negated=V.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class z extends o{static{this._info=[]}static all(){return z._info.values()}constructor(P,R,W){super(P,null),this._defaultValue=R,typeof W=="object"?z._info.push({...W,key:P}):W!==!0&&z._info.push({key:P,description:W,type:R!=null?typeof R:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return w.create(this.key,P)}notEqualsTo(P){return v.create(this.key,P)}}e.RawContextKey=z,e.IContextKeyService=(0,U.createDecorator)("contextKeyService");function x(q,P){return q<P?-1:q>P?1:0}function ee(q,P,R,W){return q<R?-1:q>R?1:P<W?-1:P>W?1:0}function ne(q,P){if(q.type===0||P.type===1)return!0;if(q.type===9)return P.type===9?re(q.expr,P.expr):!1;if(P.type===9){for(const R of P.expr)if(ne(q,R))return!0;return!1}if(q.type===6){if(P.type===6)return re(P.expr,q.expr);for(const R of q.expr)if(ne(R,P))return!0;return!1}return q.equals(P)}e.implies=ne;function re(q,P){let R=0,W=0;for(;R<q.length&&W<P.length;){const F=q[R].cmp(P[W]);if(F<0)return!1;F===0&&R++,W++}return R===q.length}function J(q){return q.type===9?q.expr:[q]}}),define(oe[95],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function O(U){return!!U.hostName&&!!U.errorMessage}e.isRemoteDiagnosticError=O;class A{async getPerformanceInfo(_,L){return{}}async getSystemInfo(_,L){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,L){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=A}),define(oe[96],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,153,4]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function A(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function U(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=U;function _(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":u==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function L(l,u){return u==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=L;function I(l,u,p){return L(u,p)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===p?!0:f(p).includes(l)}e.isTargetPlatformCompatible=I;function f(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=f;function D(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=D;var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var c;(function(l){l.Install="install",l.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var m;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class h extends Error{constructor(u,p){super(u),this.code=p,this.name=p}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,k.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,10,92,29]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(m,h){return m?U.URI.revive(h?h.transformIncoming(m):m):void 0}function f(m,h){return h?h.transformOutgoingURI(m):m}function D(m,h){h=h||_.DefaultURITransformer;const l=m.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...m,manifest:void 0},h),manifest:l}}function C(m,h){return m?.profileLocation?(0,_.transformAndReviveIncomingURIs)(m,h??_.DefaultURITransformer):m}function S(m,h){return h?(0,A.cloneAndChange)(m,l=>l instanceof U.URI?h.transformOutgoingURI(l):void 0):m}class c{constructor(h,l){this.service=h,this.getUriTransformer=l,this.onInstallExtension=k.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,l){const u=this.getUriTransformer(h);switch(l){case"onInstallExtension":return k.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?f(p.profileLocation,u):p.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,p=>p.map(b=>({...b,local:b.local?S(b.local,u):b.local,profileLocation:b.profileLocation?f(b.profileLocation,u):b.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?f(p.profileLocation,u):p.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?f(p.profileLocation,u):p.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,p=>S(p,u))}throw new Error("Invalid listen")}async call(h,l,u){const p=this.getUriTransformer(h);switch(l){case"zip":{const b=D(u[0],p),t=await this.service.zip(b);return f(t,p)}case"unzip":return this.service.unzip(I(u[0],p));case"install":return this.service.install(I(u[0],p),C(u[1],p));case"installFromLocation":return this.service.installFromLocation(I(u[0],p),I(u[1],p));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(u[0],I(u[1],p),I(u[2],p));case"getManifest":return this.service.getManifest(I(u[0],p));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],C(u[1],p));case"installGalleryExtensions":{const b=u[0];return this.service.installGalleryExtensions(b.map(({extension:t,options:a})=>({extension:t,options:C(a,p)??{}})))}case"uninstall":return this.service.uninstall(D(u[0],p),C(u[1],p));case"reinstallFromGallery":return this.service.reinstallFromGallery(D(u[0],p));case"getInstalled":return(await this.service.getInstalled(u[0],I(u[1],p))).map(t=>S(t,p));case"toggleAppliationScope":{const b=await this.service.toggleAppliationScope(D(u[0],p),I(u[1],p));return S(b,p)}case"copyExtensions":return this.service.copyExtensions(I(u[0],p),I(u[1],p));case"updateMetadata":{const b=await this.service.updateMetadata(D(u[0],p),u[1],I(u[2],p));return S(b,p)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(u[0],u[1],u[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=c;class g extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(h){super(),this.channel=h,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(l=>this.fireEvent(this._onInstallExtension,{...l,source:this.isUriComponents(l.source)?U.URI.revive(l.source):l.source,profileLocation:U.URI.revive(l.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(l=>this.fireEvent(this._onDidInstallExtensions,l.map(u=>({...u,local:u.local?D(u.local,null):u.local,source:this.isUriComponents(u.source)?U.URI.revive(u.source):u.source,profileLocation:U.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(l=>this.fireEvent(this._onUninstallExtension,{...l,profileLocation:U.URI.revive(l.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(l=>this.fireEvent(this._onDidUninstallExtension,{...l,profileLocation:U.URI.revive(l.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(l=>this._onDidUpdateExtensionMetadata.fire(D(l,null))))}fireEvent(h,l){h.fire(l)}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const l=await this.getTargetPlatform();return h.allTargetPlatforms.some(u=>(0,L.isTargetPlatformCompatible)(u,h.allTargetPlatforms,l))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(l=>U.URI.revive(l)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,l){return Promise.resolve(this.channel.call("install",[h,l])).then(u=>D(u,null))}installFromLocation(h,l){return Promise.resolve(this.channel.call("installFromLocation",[h,l])).then(u=>D(u,null))}async installExtensionsFromProfile(h,l,u){return(await this.channel.call("installExtensionsFromProfile",[h,l,u])).map(b=>D(b,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,l){return Promise.resolve(this.channel.call("installFromGallery",[h,l])).then(u=>D(u,null))}async installGalleryExtensions(h){return(await this.channel.call("installGalleryExtensions",[h])).map(u=>({...u,local:u.local?D(u.local,null):u.local,source:this.isUriComponents(u.source)?U.URI.revive(u.source):u.source,profileLocation:U.URI.revive(u.profileLocation)}))}uninstall(h,l){return Promise.resolve(this.channel.call("uninstall",[h,l]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h])).then(l=>D(l,null))}getInstalled(h=null,l){return Promise.resolve(this.channel.call("getInstalled",[h,l])).then(u=>u.map(p=>D(p,null)))}updateMetadata(h,l,u){return Promise.resolve(this.channel.call("updateMetadata",[h,l,u])).then(p=>D(p,null))}toggleAppliationScope(h,l){return this.channel.call("toggleAppliationScope",[h,l]).then(u=>D(u,null))}copyExtensions(h,l){return this.channel.call("copyExtensions",[h,l])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(h,l,u){const p=await this.channel.call("download",[h,l,u]);return U.URI.revive(p)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class y{constructor(h){this.service=h}listen(h,l){throw new Error("Invalid listen")}call(h,l,u){switch(l){case"getConfigBasedTips":return this.service.getConfigBasedTips(U.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(oe[97],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((U,_)=>te(["node-vsce-sign"],async L=>U(L),_))),this.moduleLoadingPromise}async verify(U,_,L){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(U,_,L)}}e.ExtensionSignatureVerificationService=O}),define(oe[98],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(O||(e.RecommendationSource=O={}));function A(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var U;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(U||(e.RecommendationsNotificationResult=U={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,160,4,6,23]),function(te,e,k,O,A,U,_,L,I,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function C(x){return x.create===!0}e.isFileOpenForWriteOptions=C;var S;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var c;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function y(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=y;function m(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=m;function h(x){return!!(x.capabilities&131072)}e.hasFileCloneCapability=h;function l(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function u(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=u;function p(x){return y(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;function b(x){return y(x)?!!(x.capabilities&32768):!1}e.hasFileAtomicWriteCapability=b;function t(x){return!!(x.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function a(x){return!!(x.capabilities&2048)}e.hasReadonlyCapability=a;var n;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ee,ne){const re=new s(ee.toString(),ne);return o(re,ne),re}constructor(ee,ne){super(ee),this.code=ne}}e.FileSystemProviderError=s;function i(x,ee){return s.create(x,ee)}e.createFileSystemProviderError=i;function r(x){return x||i((0,L.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=r;function o(x,ee){return x.name=ee?`${ee} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=o;function w(x){if(!x)return n.Unknown;if(x instanceof s)return x.code;const ee=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=w;function E(x){if(x instanceof $)return x.fileOperationResult;switch(w(x)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=E;var d;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class v{constructor(ee,ne,re){this.resource=ee,this.operation=ne,this.target=re}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=v;var T;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class N{constructor(ee,ne){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const J of ee){const q=re.get(J.type);switch(q?q.push([J.resource,J]):re.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,q]of re)switch(J){case 1:this.added=k.TernarySearchTree.forUris(()=>ne),this.added.fill(q);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>ne),this.updated.fill(q);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>ne),this.deleted.fill(q);break}}contains(ee,...ne){return this.doContains(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.doContains(ee,{includeChildren:!0},...ne)}doContains(ee,ne,...re){if(!ee)return!1;const J=re.length>0;return!!((!J||re.includes(1))&&(this.added?.get(ee)||ne.includeChildren&&this.added?.findSuperstr(ee))||(!J||re.includes(0))&&(this.updated?.get(ee)||ne.includeChildren&&this.updated?.findSuperstr(ee))||(!J||re.includes(2))&&(this.deleted?.findSubstr(ee)||ne.includeChildren&&this.deleted?.findSuperstr(ee)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=N;function M(x,ee,ne){return!x||!ee||x===ee||ee.length>x.length?!1:(ee.charAt(ee.length-1)!==O.sep&&(ee+=O.sep),ne?(0,A.startsWithIgnoreCase)(x,ee):x.indexOf(ee)===0)}e.isParent=M;class $ extends Error{constructor(ee,ne,re){super(ee),this.fileOperationResult=ne,this.options=re}}e.FileOperationError=$;class j extends ${constructor(ee,ne,re,J){super(ee,ne,J),this.fileOperationResult=ne,this.size=re}}e.TooLargeFileOperationError=j;class Z extends ${constructor(ee,ne,re){super(ee,2,re),this.stat=ne}}e.NotModifiedSinceFileOperationError=Z;var G;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Q;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.ETAG_DISABLED="";function B(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=B;async function K(x,ee){if(!ee.hasProvider(_.URI.from({scheme:x.scheme})))return new Promise(ne=>{const re=ee.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===x.scheme&&J.added&&(re.dispose(),ne())})})}e.whenProviderRegistered=K;class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(ee){return(0,U.isNumber)(ee)||(ee=0),ee<V.KB?(0,L.localize)(1,null,ee.toFixed(0)):ee<V.MB?(0,L.localize)(2,null,(ee/V.KB).toFixed(2)):ee<V.GB?(0,L.localize)(3,null,(ee/V.MB).toFixed(2)):ee<V.TB?(0,L.localize)(4,null,(ee/V.GB).toFixed(2)):(0,L.localize)(5,null,(ee/V.TB).toFixed(2))}}e.ByteSize=V;function z(x){const ee=typeof x=="string"||x?.scheme===D.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===D.Schemas.file?1024*V.MB:ee?10*V.MB:f.isWeb?50*V.MB:1024*V.MB}e.getLargeFileConfirmationLimit=z});var X=this&&this.__param||function(te,e){return function(k,O){e(k,O,te)}};define(oe[189],ae([0,1,69,46,11]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let U=class{constructor(L){this.fileService=L}async checksum(L){const I=(await this.fileService.readFileStream(L)).value;return new Promise((f,D)=>{const C=(0,k.createHash)("md5");(0,O.listenStream)(I,{onData:S=>C.update(S.buffer),onError:S=>D(S),onEnd:()=>f(C.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=U,e.ChecksumService=U=ye([X(0,A.IFileService)],U)}),define(oe[190],ae([0,1,15,38,8,3,2,46,10,32,11]),function(te,e,k,O,A,U,_,L,I,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends _.Disposable{constructor(c,g){super(),this.channel=c,this.extraCapabilities=g,this.onDidChangeCapabilities=U.Event.None,this._onDidChange=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new U.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,f.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(c){return this.channel.call("stat",[c])}readdir(c){return this.channel.call("readdir",[c])}async readFile(c,g){const{buffer:y}=await this.channel.call("readFile",[c,g]);return y}readFileStream(c,g,y){const m=(0,L.newWriteableStream)(l=>k.VSBuffer.concat(l.map(u=>k.VSBuffer.wrap(u))).buffer),h=new _.DisposableStore;return h.add(this.channel.listen("readFileStream",[c,g])(l=>{if(l instanceof k.VSBuffer)m.write(l.buffer);else{if(l==="end")m.end();else{let u;if(l instanceof Error)u=l;else{const p=l;u=(0,D.createFileSystemProviderError)(p.message??(0,O.toErrorMessage)(p),p.code??D.FileSystemProviderErrorCode.Unknown)}m.error(u),m.end()}h.dispose()}})),h.add(y.onCancellationRequested(()=>{m.error((0,A.canceled)()),m.end(),h.dispose()})),m}writeFile(c,g,y){return this.channel.call("writeFile",[c,k.VSBuffer.wrap(g),y])}open(c,g){return this.channel.call("open",[c,g])}close(c){return this.channel.call("close",[c])}async read(c,g,y,m,h){const[l,u]=await this.channel.call("read",[c,g,h]);return y.set(l.buffer.slice(0,u),m),u}write(c,g,y,m,h){return this.channel.call("write",[c,g,k.VSBuffer.wrap(y),m,h])}mkdir(c){return this.channel.call("mkdir",[c])}delete(c,g){return this.channel.call("delete",[c,g])}rename(c,g,y){return this.channel.call("rename",[c,g,y])}copy(c,g,y){return this.channel.call("copy",[c,g,y])}cloneFile(c,g){return this.channel.call("cloneFile",[c,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(c=>{if(Array.isArray(c)){const g=c;this._onDidChange.fire(g.map(y=>({resource:I.URI.revive(y.resource),type:y.type})))}else{const g=c;this._onDidWatchError.fire(g)}}))}watch(c,g){const y=(0,f.generateUuid)();return this.channel.call("watch",[this.sessionId,y,c,g]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=C}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(D,C,S,c,g,y){let m;try{await L(D,C,S,c,g,y)}catch(h){m=h}finally{m&&g.errorTransformer&&(m=g.errorTransformer(m)),typeof m<"u"&&S.error(m),S.end()}}e.readFileIntoStream=_;async function L(D,C,S,c,g,y){I(y);const m=await D.open(C,{create:!1});try{I(y);let h=0,l=0,u=g&&typeof g.length=="number"?g.length:void 0,p=k.VSBuffer.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),b=g&&typeof g.position=="number"?g.position:0,t=0;do l=await D.read(m,b,p.buffer,t,p.byteLength-t),b+=l,t+=l,h+=l,typeof u=="number"&&(u-=l),t===p.byteLength&&(await S.write(c(p)),p=k.VSBuffer.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),t=0);while(l>0&&(typeof u!="number"||u>0)&&I(y)&&f(h,g));if(t>0){let a=t;typeof u=="number"&&(a=Math.min(t,u)),S.write(c(p.slice(0,a)))}}catch(h){throw(0,U.ensureFileSystemProviderError)(h)}finally{await D.close(m)}}function I(D){if(D.isCancellationRequested)throw(0,O.canceled)();return!0}function f(D,C){if(typeof C?.limits?.size=="number"&&D>C.limits.size)throw(0,U.createFileSystemProviderError)((0,A.localize)(0,null),U.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,91,2,16,6,10,11]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(h){return h.recursive===!0}e.isRecursiveWatchRequest=I;class f extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(l,u,p,b){super(),this.onFileChanges=l,this.onLogMessage=u,this.verboseLogging=p,this.options=b,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new O.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),l.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),l.add(this.watcher.onDidError(u=>this.onError(u)))}onError(l){this.options.restartOnError?this.restartCounter<f.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${l}`):this.error(l)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}trace(l){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=f;class D extends f{constructor(l,u,p){super(l,u,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class C extends f{constructor(l,u,p){super(l,u,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function S(h){return h.map(l=>({type:l.type,resource:_.URI.file(l.path)}))}e.toFileChanges=S;function c(h){const l=new m;for(const u of h)l.processEvent(u);return l.coalesce()}e.coalesceEvents=c;function g(h,l){return typeof l=="string"&&!l.startsWith(k.GLOBSTAR)&&!(0,A.isAbsolute)(l)?{base:h,pattern:l}:l}e.normalizeWatcherPattern=g;function y(h,l){const u=[];for(const p of l)u.push((0,k.parse)(g(h,p)));return u}e.parseWatcherPatterns=y;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return U.isLinux?l.path:l.path.toLowerCase()}processEvent(l){const u=this.mapPathToChange.get(this.toKey(l));let p=!1;if(u){const b=u.type,t=l.type;u.path!==l.path&&(l.type===2||l.type===1)?p=!0:b===1&&t===2?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(u)):b===2&&t===1?u.type=0:b===1&&t===0||(u.type=t)}else p=!0;p&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],u=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(l.push(p),!1):!0).sort((p,b)=>p.path.length-b.path.length).filter(p=>u.some(b=>(0,L.isParent)(p.path,b,!U.isLinux))?!1:(u.push(p.path),!0)).concat(l)}}}),define(oe[191],ae([0,1,52,5,26,48,2,88,16,6,144,31,54]),function(te,e,k,O,A,U,_,L,I,f,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class c extends _.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(m,h,l,u){super(),this.request=m,this.onDidFilesChange=h,this.onLogMessage=l,this.verboseLogging=u,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.onDidFilesChange(p))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(p=>this.handleFileChanges(p),c.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new A.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await C.Promises.stat(m);this._register(await this.doWatch(m,h.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let h=m.path;try{h=await C.Promises.realpath(m.path),m.path===h&&(h=await(0,D.realcase)(m.path)??m.path),m.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${h})`)}catch{}return h}async doWatch(m,h){if(f.isMacintosh&&(0,U.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const l=new A.CancellationTokenSource(this.cts.token),u=new _.DisposableStore;try{const p=(0,I.basename)(m),b=(0,k.watch)(m);u.add((0,_.toDisposable)(()=>{b.removeAllListeners(),b.close()})),this.trace(`Started watching: '${m}'`);const t=new Set;if(h)try{for(const n of await C.Promises.readdir(m))t.add(n)}catch(n){this.error(n)}const a=new Map;u.add((0,_.toDisposable)(()=>{for(const[,n]of a)n.dispose();a.clear()})),b.on("error",(n,s)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),b.on("change",(n,s)=>{if(l.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${s}`);let i="";if(s&&(i=s.toString(),f.isMacintosh&&(i=(0,L.normalizeNFC)(i))),!(!i||n!=="change"&&n!=="rename"))if(h)if(n==="rename"){a.get(i)?.dispose();const r=setTimeout(async()=>{if(a.delete(i),i===p&&!await C.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,I.join)(m,i));if(l.token.isCancellationRequested)return;let w;o?t.has(i)?w=0:(w=1,t.add(i)):(t.delete(i),w=2),this.onFileChange({path:(0,I.join)(this.request.path,i),type:w})},c.FILE_DELETE_HANDLER_DELAY);a.set(i,(0,_.toDisposable)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.onFileChange({path:(0,I.join)(this.request.path,i),type:r})}else if(n==="rename"||i!==p){const r=setTimeout(async()=>{const o=await C.Promises.exists(m);l.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(m,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},c.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,_.toDisposable)(()=>clearTimeout(r)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(p){await C.Promises.exists(m)&&!l.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${p.toString()})`)}return(0,_.toDisposable)(()=>{l.dispose(!0),u.dispose()})}onFileChange(m,h=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!h&&this.excludes.some(l=>l(m.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${m.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(m.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${m.path}`):this.fileChangesAggregator.work(m))}handleFileChanges(m){const h=(0,S.coalesceEvents)(m);if(h.length>0){if(this.verboseLogging)for(const u of h)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesEmitter.work(h)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(m){if(f.isLinux)return C.Promises.exists(m);try{const h=(0,I.basename)(m);return(await C.Promises.readdir((0,I.dirname)(m))).some(u=>u===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=c;async function g(y,m,h,l,u=512){const p=await C.Promises.open(y,"r"),b=Buffer.allocUnsafe(u),t=new A.CancellationTokenSource(l);let a,n=!1;const s={path:y,excludes:[],recursive:!1},i=new c(s,r=>{(async()=>{for(const{type:o}of r)if(o===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:w}=await C.Promises.read(p,b,0,u,null);if(!w||t.token.isCancellationRequested)break;m(b.slice(0,w))}}catch(w){a=new Error(w),t.dispose(!0)}finally{n=!1}}})()});return await i.ready,h(),new Promise((r,o)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await C.Promises.close(p)}catch(w){a=new Error(w)}a?o(a):r()})})}e.watchFileContents=g}),define(oe[192],ae([0,1,3,91,2,6,191]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class L extends A.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(f){const D=this.normalizeRequests(f),C=D.filter(c=>{const g=this.watchers.get(c.path);return g?!(0,O.patternsEquals)(g.request.excludes,c.excludes)||!(0,O.patternsEquals)(g.request.includes,c.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:c})=>!D.find(g=>g.path===c.path&&(0,O.patternsEquals)(g.excludes,c.excludes)&&(0,O.patternsEquals)(g.includes,c.includes))).map(({request:c})=>c.path);C.length&&this.trace(`Request to start watching: ${C.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const c of S)this.stopWatching(c);for(const c of C)this.startWatching(c)}startWatching(f){const D=new _.NodeJSFileWatcherLibrary(f,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),C={request:f,instance:D};this.watchers.set(f.path,C)}async stop(){for(const[f]of this.watchers)this.stopWatching(f);this.watchers.clear()}stopWatching(f){const D=this.watchers.get(f);D&&(this.watchers.delete(f),D.instance.dispose())}normalizeRequests(f){const D=new Map;for(const C of f){const S=U.isLinux?C.path:C.path.toLowerCase();D.set(S,C)}return Array.from(D.values())}async setVerboseLogging(f){this.verboseLogging=f;for(const[,D]of this.watchers)D.instance.setVerboseLogging(f)}trace(f){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(f)})}toMessage(f,D){return D?`[File Watcher (node.js)] ${f} (path: ${D.request.path})`:`[File Watcher (node.js)] ${f}`}}e.NodeJSWatcher=L}),define(oe[193],ae([0,1,54,192]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends k.AbstractNonRecursiveWatcherClient{constructor(_,L,I){super(_,L,I),this.init()}createWatcher(_){return _.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=A}),define(oe[194],ae([0,1,23,42,93,54]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends U.AbstractUniversalWatcherClient{constructor(I,f,D){super(I,f,D),this.init()}createWatcher(I){const f=I.add(new A.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(f.onDidProcessExit(({code:D,signal:C})=>this.onError(`terminated by itself with code ${D}, signal: ${C}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(f.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(oe[70],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...A){this._entries=new Map;for(const[U,_]of A)this.set(U,_)}set(A,U){const _=this._entries.get(A);return this._entries.set(A,U),_}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=k}),define(oe[195],ae([0,1,5,8,2,68,186,4,70,87]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class S{constructor(m=new I.ServiceCollection,h=!1,l,u=D){this._services=m,this._strict=h,this._parent=l,this._enableTracing=u,this._activeInstantiations=new Set,this._services.set(L.IInstantiationService,this),this._globalGraph=u?l?._globalGraph??new _.Graph(p=>p):void 0}createChild(m){return new S(m,this._strict,this,this._enableTracing)}invokeFunction(m,...h){const l=g.traceInvocation(this._enableTracing,m);let u=!1;try{return m({get:b=>{if(u)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(b,l);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...h)}finally{u=!0,l.stop()}}createInstance(m,...h){let l,u;return m instanceof U.SyncDescriptor?(l=g.traceCreation(this._enableTracing,m.ctor),u=this._createInstance(m.ctor,m.staticArguments.concat(h),l)):(l=g.traceCreation(this._enableTracing,m),u=this._createInstance(m,h,l)),l.stop(),u}_createInstance(m,h=[],l){const u=L._util.getServiceDependencies(m).sort((t,a)=>t.index-a.index),p=[];for(const t of u){const a=this._getOrCreateServiceInstance(t.id,l);a||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const b=u.length>0?u[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${m.name} at position ${b+1} conflicts with ${h.length} static arguments`);const t=b-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,b)}return Reflect.construct(m,h.concat(p))}_setServiceInstance(m,h){if(this._services.get(m)instanceof U.SyncDescriptor)this._services.set(m,h);else if(this._parent)this._parent._setServiceInstance(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const h=this._services.get(m);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):h}_getOrCreateServiceInstance(m,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const l=this._getServiceInstanceOrDescriptor(m);return l instanceof U.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,l,h.branch(m,!0)):(h.branch(m,!1),l)}_safeCreateAndCacheServiceInstance(m,h,l){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,h,l)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,h,l){const u=new _.Graph(t=>t.id.toString());let p=0;const b=[{id:m,desc:h,_trace:l}];for(;b.length;){const t=b.pop();if(u.lookupOrInsertNode(t),p++>1e3)throw new C(u);for(const a of L._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(a.id);if(n||this._throwIfStrict(`[createInstance] ${m} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),n instanceof U.SyncDescriptor){const s={id:a.id,desc:n,_trace:t._trace.branch(a.id,!0)};u.insertEdge(t,s),b.push(s)}}}for(;;){const t=u.roots();if(t.length===0){if(!u.isEmpty())throw new C(u);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof U.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}u.removeNode(a)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,h,l=[],u,p){if(this._services.get(m)instanceof U.SyncDescriptor)return this._createServiceInstance(m,h,l,u,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,h,l,u,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(m,h,l=[],u,p){if(u){const b=new S(void 0,this._strict,this,this._enableTracing);b._globalGraphImplicitDependency=String(m);const t=new Map,a=new k.IdleValue(()=>{const n=b._createInstance(h,l,p);for(const[s,i]of t){const r=n[s];if(typeof r=="function")for(const o of i)r.apply(n,o)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let o=t.get(s);return o||(o=new f.LinkedList,t.set(s,o)),(E,d,v)=>{const T=o.push([E,d,v]);return(0,A.toDisposable)(T)}}if(s in n)return n[s];const i=a.value;let r=i[s];return typeof r!="function"||(r=r.bind(i),n[s]=r),r},set(n,s,i){return a.value[s]=i,!0},getPrototypeOf(n){return h.prototype}})}else return this._createInstance(h,l,p)}_throwIfStrict(m,h){if(h&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=S;var c;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(c||(c={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,h){return m?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(m,h){return m?new g(1,h.name):g._None}static{this._totals=0}constructor(m,h){this.type=m,this.name=h,this._start=Date.now(),this._dep=[]}branch(m,h){const l=new g(3,m.toString());return this._dep.push([m,h,l]),l}stop(){const m=Date.now()-this._start;g._totals+=m;let h=!1;function l(p,b){const t=[],a=new Array(p+1).join("	");for(const[n,s,i]of b._dep)if(s&&i){h=!0,t.push(`${a}CREATES -> ${n}`);const r=l(p+1,i);r&&t.push(r)}else t.push(`${a}uses -> ${n}`);return t.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(m>2||h)&&g.all.add(u.join(`
`))}}e.Trace=g}),define(oe[71],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,k.createDecorator)("mainProcessService");class O{constructor(U,_){this.server=U,this.router=_}getChannel(U){return this.server.getChannel(U,this.router)}registerChannel(U,_){this.server.registerChannel(U,_)}}e.MainProcessService=O}),define(oe[72],ae([0,1,26,2,6,163,29,4]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(D){return D.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,L.createDecorator)("languagePackService");let f=class extends O.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new k.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let S;try{S=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const g=S.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(m=>m.startsWith("lp-"))).map(y=>{const m=y.properties.localizedLanguages?.[0],h=I(y);return{...this.createQuickPickItem(h,m,y),extensionId:y.identifier.id,galleryExtension:y}});return g.push(this.createQuickPickItem("en","English")),g}createQuickPickItem(C,S,c){const g=S??C;let y;if(g!==C&&(y=`(${C})`),C.toLowerCase()===A.language.toLowerCase()&&(y??="",y+=(0,U.localize)(0,null)),c?.installCount){y??="";const m=c.installCount;let h;m>1e6?h=`${Math.floor(m/1e5)/10}M`:m>1e3?h=`${Math.floor(m/1e3)}K`:h=String(m),y+=` $(cloud-download) ${h}`}return{id:C,label:g,description:y}}};e.LanguagePackBaseService=f,e.LanguagePackBaseService=f=ye([X(0,_.IExtensionGalleryService)],f)}),define(oe[196],ae([0,1,2,72]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends k.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=A,e.LocalizationsUpdater=A=ye([X(0,O.ILanguagePackService)],A)}),define(oe[7],ae([0,1,38,3,51,2,34,6,21,12,10,94,4]),function(te,e,k,O,A,U,_,L,I,f,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function c(){return new Date().toISOString()}function g(E){return(0,f.isNumber)(E)}e.isLogLevel=g;var y;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function m(E,d,v){switch(d){case y.Trace:E.trace(v);break;case y.Debug:E.debug(v);break;case y.Info:E.info(v);break;case y.Warning:E.warn(v);break;case y.Error:E.error(v);break;case y.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=m;function h(E,d=!1){let v="";for(let T=0;T<E.length;T++){let N=E[T];if(N instanceof Error&&(N=(0,k.toErrorMessage)(N,d)),typeof N=="object")try{N=JSON.stringify(N)}catch{}v+=(T>0?" ":"")+N}return v}class l extends U.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(d){this.level!==d&&(this.level=d,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(d){return this.level!==y.Off&&this.level<=d}}e.AbstractLogger=l;class u extends l{constructor(d){super(),this.logAlways=d}checkLogLevel(d){return this.logAlways||super.checkLogLevel(d)}trace(d,...v){this.checkLogLevel(y.Trace)&&this.log(y.Trace,h([d,...v],!0))}debug(d,...v){this.checkLogLevel(y.Debug)&&this.log(y.Debug,h([d,...v]))}info(d,...v){this.checkLogLevel(y.Info)&&this.log(y.Info,h([d,...v]))}warn(d,...v){this.checkLogLevel(y.Warning)&&this.log(y.Warning,h([d,...v]))}error(d,...v){if(this.checkLogLevel(y.Error))if(d instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=d.stack,this.log(y.Error,h(T))}else this.log(y.Error,h([d,...v]))}flush(){}}e.AbstractMessageLogger=u;class p extends l{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.useColors=!L.isWindows}trace(d,...v){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...v):console.log(`[main ${c()}]`,d,...v))}debug(d,...v){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...v):console.log(`[main ${c()}]`,d,...v))}info(d,...v){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...v):console.log(`[main ${c()}]`,d,...v))}warn(d,...v){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,d,...v):console.warn(`[main ${c()}]`,d,...v))}error(d,...v){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,d,...v):console.error(`[main ${c()}]`,d,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class b extends l{constructor(d=e.DEFAULT_LOG_LEVEL,v=!0){super(),this.useColors=v,this.setLevel(d)}trace(d,...v){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",d,...v):console.log(d,...v))}debug(d,...v){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",d,...v):console.log(d,...v))}info(d,...v){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",d,...v):console.log(d,...v))}warn(d,...v){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",d,...v):console.log(d,...v))}error(d,...v){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",d,...v):console.error(d,...v))}dispose(){}flush(){}}e.ConsoleLogger=b;class t extends l{constructor(d,v=e.DEFAULT_LOG_LEVEL){super(),this.adapter=d,this.setLevel(v)}trace(d,...v){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(d),...v])}debug(d,...v){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(d),...v])}info(d,...v){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(d),...v])}warn(d,...v){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(d),...v])}error(d,...v){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(d),...v])}extractMessage(d){return typeof d=="string"?d:(0,k.toErrorMessage)(d,this.checkLogLevel(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends l{constructor(d){super(),this.loggers=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const v of this.loggers)v.setLevel(d);super.setLevel(d)}trace(d,...v){for(const T of this.loggers)T.trace(d,...v)}debug(d,...v){for(const T of this.loggers)T.debug(d,...v)}info(d,...v){for(const T of this.loggers)T.info(d,...v)}warn(d,...v){for(const T of this.loggers)T.warn(d,...v)}error(d,...v){for(const T of this.loggers)T.error(d,...v)}flush(){for(const d of this.loggers)d.flush()}dispose(){for(const d of this.loggers)d.dispose()}}e.MultiplexLogger=a;class n extends U.Disposable{constructor(d,v,T){if(super(),this.logLevel=d,this.logsHome=v,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const N of T)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(d){return(0,f.isString)(d)?[...this._loggers.values()].find(v=>v.info.id===d):this._loggers.get(d)}getLogger(d){return this.getLoggerEntry(d)?.logger}createLogger(d,v){const T=this.toResource(d),N=(0,f.isString)(d)?d:v?.id??(0,A.hash)(T.toString()).toString(16);let M=this._loggers.get(T)?.logger;const $=v?.logLevel==="always"?y.Trace:v?.logLevel;M||(M=this.doCreateLogger(T,$??this.getLogLevel(T)??this.logLevel,{...v,id:N}));const j={logger:M,info:{resource:T,id:N,logLevel:$,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(j.info),this._loggers.set(T,j),M}toResource(d){return(0,f.isString)(d)?(0,I.joinPath)(this.logsHome,`${d}.log`):d}setLogLevel(d,v){if(D.URI.isUri(d)){const T=d,N=v,M=this._loggers.get(T);M&&N!==M.info.logLevel&&(M.info.logLevel=N===this.logLevel?void 0:N,M.logger?.setLevel(N),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([T,N]))}else{this.logLevel=d;for(const[T,N]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(d,v){const T=this.getLoggerEntry(d);T&&v!==!T.info.hidden&&(T.info.hidden=!v,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,v]))}getLogLevel(d){let v;return d&&(v=this._loggers.get(d)?.info.logLevel),v??this.logLevel}registerLogger(d){const v=this._loggers.get(d.resource);v?v.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this._loggers.set(d.resource,{info:d,logger:void 0}),this._onDidChangeLoggers.fire({added:[d],removed:[]}))}deregisterLogger(d){const v=this._loggers.get(d);v&&(v.logger&&v.logger.dispose(),this._loggers.delete(d),this._onDidChangeLoggers.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const d of this._loggers.values())yield d.info}getRegisteredLogger(d){return this._loggers.get(d)?.info}dispose(){this._loggers.forEach(d=>d.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class s{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(d){}getLevel(){return y.Info}trace(d,...v){}debug(d,...v){}info(d,...v){}warn(d,...v){}error(d,...v){}critical(d,...v){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;function r(E){if(E.verbose)return y.Trace;if(typeof E.logLevel=="string"){const d=w(E.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function o(E){switch(E){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=o;function w(E){switch(E){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=w,e.CONTEXT_LOG_LEVEL=new C.RawContextKey("logLevel",o(y.Info))}),define(oe[197],ae([0,1,5,8,2,23,16,21,31,14,7]),function(te,e,k,O,A,U,_,L,I,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends A.Disposable{constructor(c,g){super(),this.environmentService=c,this.logService=g,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,L.basename)(this.environmentService.logsHome),g=(0,L.dirname)(this.environmentService.logsHome.with({scheme:U.Schemas.file})).fsPath,h=(await I.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),l=h.slice(0,Math.max(0,h.length-9));l.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${l.join(", ")}'`),await Promise.all(l.map(u=>I.Promises.rm((0,_.join)(g,u)))))}catch(c){(0,O.onUnexpectedError)(c)}}};e.LogsDataCleaner=C,e.LogsDataCleaner=C=ye([X(0,f.IEnvironmentService),X(1,D.ILogService)],C)}),define(oe[198],ae([0,1,18,5,8,3,2,16,54,7]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends _.Disposable{constructor(S,c){super(),this.logService=S,this.options=c,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new U.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(S,c){return c.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,c):this.watchNonRecursive(S,c)}watchUniversal(S,c){const g={path:this.toFilePath(S),excludes:c.excludes,includes:c.includes,recursive:c.recursive},y=(0,k.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,A.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(c=>this._onDidChangeFile.fire((0,I.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const c of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(c)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const c of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(c)&&S.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,c){const g={path:this.toFilePath(S),excludes:c.excludes,includes:c.includes,recursive:!1},y=(0,k.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,A.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,I.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,L.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(oe[199],ae([0,1,18,5,15,26,3,51,59,2,47,23,100,21,46,159,11,99,7,8]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends f.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(t,a){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const n=new f.DisposableStore;return this.provider.set(t,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:a}),n.add(a.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:t}))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:a}),this.provider.delete(t),(0,f.dispose)(n)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(n){a.push(n)}}),!this.provider.has(t)&&await O.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,a){const n=this.provider.get(t.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return I.Iterable.map(this.provider,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async withProvider(t){if(!(0,c.isAbsolutePath)(t))throw new m.FileOperationError((0,y.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const a=this.provider.get(t.scheme);if(!a){const n=new u.ErrorNoTelemetry;throw n.message=(0,y.localize)(1,null,t.toString()),n}return a}async withReadProvider(t){const a=await this.withProvider(t);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a)||(0,m.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const a=await this.withProvider(t);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.doResolveFile(t,a)}catch(n){throw(0,m.toFileSystemProviderErrorCode)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,y.localize)(2,null,this.resourceForError(t)),1):(0,m.ensureFileSystemProviderError)(n)}}async doResolveFile(t,a){const n=await this.withProvider(t),s=this.isPathCaseSensitive(n),i=a?.resolveTo,r=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,w=await n.stat(t);let E;return this.toFileStat(n,t,w,void 0,!!o,(d,v)=>(E||(E=D.TernarySearchTree.forUris(()=>!s),E.set(t,!0),i&&E.fill(!0,i)),E.get(d.resource)||E.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?v===1:!1))}async toFileStat(t,a,n,s,i,r){const{providerExtUri:o}=this.getExtUri(t),w={resource:a,name:o.basename(a),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(w.isDirectory&&r(w,s)){try{const E=await t.readdir(a),d=await O.Promises.settled(E.map(async([v,T])=>{try{const N=o.joinPath(a,v),M=i?await t.stat(N):{type:T};return await this.toFileStat(t,N,M,E.length,i,r)}catch(N){return this.logService.trace(N),null}}));w.children=(0,k.coalesce)(d)}catch(E){this.logService.trace(E),w.children=[]}return w}return w}async resolveAll(t){return O.Promises.settled(t.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.withProvider(t),n=await a.stat(t);return this.toFileStat(a,t,n,void 0,!0,()=>!1)}async exists(t){const a=await this.withProvider(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.doValidateCreateFile(t,a)}catch(n){return n}return!0}async doValidateCreateFile(t,a){if(!a?.overwrite&&await this.exists(t))throw new m.FileOperationError((0,y.localize)(3,null,this.resourceForError(t)),3,a)}async createFile(t,a=A.VSBuffer.fromString(""),n){await this.doValidateCreateFile(t,n);const s=await this.writeFile(t,a);return this._onDidRunOperation.fire(new m.FileOperationEvent(t,0,s)),s}async writeFile(t,a,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:i}=this.getExtUri(s);let r=n;if((0,m.hasFileAtomicWriteCapability)(s)&&!r?.atomic){const o=s.enforceAtomicWriteFile?.(t);o&&(r={...n,atomic:o})}try{await this.validateWriteFile(s,t,r)||await this.mkdirp(s,i.dirname(t));let w;if((0,m.hasReadWriteCapability)(s)&&!(a instanceof A.VSBuffer))if((0,g.isReadableStream)(a)){const E=await(0,g.peekStream)(a,3);E.ended?w=A.VSBuffer.concat(E.buffer):w=E}else w=(0,g.peekReadable)(a,E=>A.VSBuffer.concat(E),3);else w=a;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&w instanceof A.VSBuffer||(0,m.hasReadWriteCapability)(s)&&(0,m.hasFileAtomicWriteCapability)(s)&&r?.atomic?await this.doWriteUnbuffered(s,t,r,w):await this.doWriteBuffered(s,t,r,w instanceof A.VSBuffer?(0,A.bufferToReadable)(w):w),this._onDidRunOperation.fire(new m.FileOperationEvent(t,4))}catch(o){throw new m.FileOperationError((0,y.localize)(4,null,this.resourceForError(t),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,a,n){const s=!!n?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(a)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(a)));if(!(t.capabilities&2))throw new Error((0,y.localize)(7,null,this.resourceForError(a)));if(s)throw new Error((0,y.localize)(8,null,this.resourceForError(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&m.FileType.Directory)throw new m.FileOperationError((0,y.localize)(9,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,m.etag)({mtime:n.mtime,size:r.size}))throw new m.FileOperationError((0,y.localize)(10,null),3,n);return r}async readFile(t,a,n){const s=await this.withReadProvider(t);return a?.atomic?this.doReadFileAtomic(s,t,a,n):this.doReadFile(s,t,a,n)}async doReadFileAtomic(t,a,n,s){return new Promise((i,r)=>{this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(t,a,n,s);i(o)}catch(o){r(o)}})})}async doReadFile(t,a,n,s){const i=await this.doReadFileStream(t,a,{...n,preferUnbuffered:!0},s);return{...i,value:await(0,A.streamToBuffer)(i.value)}}async readFileStream(t,a,n){const s=await this.withReadProvider(t);return this.doReadFileStream(s,t,a,n)}async doReadFileStream(t,a,n,s){const i=new U.CancellationTokenSource(s);let r=n;(0,m.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...n,atomic:!0});const o=this.validateReadFile(a,r).then(E=>E,E=>{throw i.dispose(!0),E});let w;try{return typeof r?.etag=="string"&&r.etag!==m.ETAG_DISABLED&&await o,r?.atomic&&(0,m.hasFileAtomicReadCapability)(t)||!((0,m.hasOpenReadWriteCloseCapability)(t)||(0,m.hasFileReadStreamCapability)(t))||(0,m.hasReadWriteCapability)(t)&&r?.preferUnbuffered?w=this.readFileUnbuffered(t,a,r):(0,m.hasFileReadStreamCapability)(t)?w=this.readFileStreamed(t,a,i.token,r):w=this.readFileBuffered(t,a,i.token,r),w.on("end",()=>i.dispose()),w.on("error",()=>i.dispose()),{...await o,value:w}}catch(E){throw w&&await(0,g.consumeStream)(w),this.restoreReadError(E,a,r)}}restoreReadError(t,a,n){const s=(0,y.localize)(11,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(t).toString());return t instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(s,t.stat,n):t instanceof m.TooLargeFileOperationError?new m.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new m.FileOperationError(s,(0,m.toFileOperationResult)(t),n)}readFileStreamed(t,a,n,s=Object.create(null)){const i=t.readFileStream(a,s,n);return(0,g.transform)(i,{data:r=>r instanceof A.VSBuffer?r:A.VSBuffer.wrap(r),error:r=>this.restoreReadError(r,a,s)},r=>A.VSBuffer.concat(r))}readFileBuffered(t,a,n,s=Object.create(null)){const i=(0,A.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,a,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>this.restoreReadError(r,a,s)},n),i}readFileUnbuffered(t,a,n){const s=(0,g.newWriteableStream)(i=>A.VSBuffer.concat(i));return(async()=>{try{let i;n?.atomic&&(0,m.hasFileAtomicReadCapability)(t)?i=await t.readFile(a,{atomic:!0}):i=await t.readFile(a),typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.validateReadFileLimits(a,i.byteLength,n),s.end(A.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(t,a){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new m.FileOperationError((0,y.localize)(12,null,this.resourceForError(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==m.ETAG_DISABLED&&a.etag===n.etag)throw new m.NotModifiedSinceFileOperationError((0,y.localize)(13,null),n,a);return this.validateReadFileLimits(t,n.size,a),n}validateReadFileLimits(t,a,n){if(typeof n?.limits?.size=="number"&&a>n.limits.size)throw new m.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(t)),7,a,n)}async canMove(t,a,n){return this.doCanMoveCopy(t,a,"move",n)}async canCopy(t,a,n){return this.doCanMoveCopy(t,a,"copy",n)}async doCanMoveCopy(t,a,n,s){if(t.toString()!==a.toString())try{const i=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,t,r,a,n,s)}catch(i){return i}return!0}async move(t,a,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,t,i,a,"move",!!n),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(t,r==="move"?2:3,o)),o}async copy(t,a,n){const s=await this.withReadProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,t,i,a,"copy",!!n),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(t,r==="copy"?3:2,o)),o}async doMoveCopy(t,a,n,s,i,r){if(a.toString()===s.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(t,a,n,s,i,r);if(o&&!w&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),i==="copy"){if(t===n&&(0,m.hasFileFolderCopyCapability)(t))await t.copy(a,s,{overwrite:r});else{const E=await this.resolve(a);E.isDirectory?await this.doCopyFolder(t,E,n,s):await this.doCopyFile(t,a,n,s)}return i}else return t===n?(await t.rename(a,s,{overwrite:r}),i):(await this.doMoveCopy(t,a,n,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(t,a,n,s){if((0,m.hasOpenReadWriteCloseCapability)(t)&&(0,m.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(t,a,n,s);if((0,m.hasOpenReadWriteCloseCapability)(t)&&(0,m.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(t,a,n,s);if((0,m.hasReadWriteCapability)(t)&&(0,m.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(t,a,n,s);if((0,m.hasReadWriteCapability)(t)&&(0,m.hasReadWriteCapability)(n))return this.doPipeUnbuffered(t,a,n,s)}async doCopyFolder(t,a,n,s){await n.mkdir(s),Array.isArray(a.children)&&await O.Promises.settled(a.children.map(async i=>{const r=this.getExtUri(n).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(t,await this.resolve(i.resource),n,r):this.doCopyFile(t,i.resource,n,r)}))}async doValidateMoveCopy(t,a,n,s,i,r){let o=!1;if(t===n){const{providerExtUri:E,isPathCaseSensitive:d}=this.getExtUri(t);if(d||(o=E.isEqual(a,s)),o&&i==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(a),this.resourceForError(s)));if(!o&&E.isEqualOrParent(s,a))throw new Error((0,y.localize)(16,null,this.resourceForError(a),this.resourceForError(s)))}const w=await this.exists(s);if(w&&!o){if(!r)throw new m.FileOperationError((0,y.localize)(17,null,this.resourceForError(a),this.resourceForError(s)),4);if(t===n){const{providerExtUri:E}=this.getExtUri(t);if(E.isEqualOrParent(a,s))throw new Error((0,y.localize)(18,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:w,isSameResourceWithDifferentPathCase:o}}getExtUri(t){const a=this.isPathCaseSensitive(t);return{providerExtUri:a?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(a,t);const n=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(t,0,n)),n}async mkdirp(t,a){const n=[],{providerExtUri:s}=this.getExtUri(t);for(;!s.isEqual(a,s.dirname(a));)try{if(!((await t.stat(a)).type&m.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(a)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(s.basename(a)),a=s.dirname(a)}for(let i=n.length-1;i>=0;i--){a=s.joinPath(a,n[i]);try{await t.mkdir(a)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.doValidateDelete(t,a)}catch(n){return n}return!0}async doValidateDelete(t,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),s=!!a?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,y.localize)(20,null,this.resourceForError(t)));const i=a?.atomic;if(i&&!(n.capabilities&65536))throw new Error((0,y.localize)(21,null,this.resourceForError(t)));if(s&&i)throw new Error((0,y.localize)(22,null,this.resourceForError(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.throwIfFileIsReadonly(t,r);else throw new m.FileOperationError((0,y.localize)(23,null,this.resourceForError(t)),1);if(!!!a?.recursive){const w=await this.resolve(t);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(t)))}return n}async del(t,a){const n=await this.doValidateDelete(t,a);let s=a;if((0,m.hasFileAtomicDeleteCapability)(n)&&!s?.atomic){const w=n.enforceAtomicDelete?.(t);w&&(s={...a,atomic:w})}const i=!!s?.useTrash,r=!!s?.recursive,o=s?.atomic??!1;await n.delete(t,{recursive:r,useTrash:i,atomic:o}),this._onDidRunOperation.fire(new m.FileOperationEvent(t,1))}async cloneFile(t,a){const n=await this.withProvider(t),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(n===s&&this.getExtUri(n).providerExtUri.isEqual(t,a))return;if(n===s&&(0,m.hasFileCloneCapability)(n))return n.cloneFile(t,a);await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(a));const i=this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri);return n===s&&(0,m.hasFileFolderCopyCapability)(n)?i.queue(()=>n.copy(t,a,{overwrite:!0})):i.queue(()=>this.doCopyFile(n,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const n=new f.DisposableStore;let s=!1,i=()=>{s=!0};return n.add((0,f.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(t,a);s?(0,f.dispose)(r):i=()=>(0,f.dispose)(r)}catch(r){this.logService.error(r)}})(),n}async doWatch(t,a){const n=await this.withProvider(t),s=(0,L.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(t),a]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:n.watch(t,a)},this.activeWatchers.set(s,i)),i.count+=1,(0,f.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,f.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,f.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,a,n,s){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{const i=await t.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,g.isReadableStream)(s)||(0,g.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(t,i,s):await this.doWriteReadableBufferedQueued(t,i,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await t.close(i)}})}async doWriteStreamBufferedQueued(t,a,n){let s=0,i;if((0,g.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=A.VSBuffer.concat(n.buffer);await this.doWriteBuffer(t,a,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((r,o)=>{(0,g.listenStream)(i,{onData:async w=>{i.pause();try{await this.doWriteBuffer(t,a,w,w.byteLength,s,0)}catch(E){return o(E)}s+=w.byteLength,setTimeout(()=>i.resume())},onError:w=>o(w),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(t,a,n){let s=0,i;for(;(i=n.read())!==null;)await this.doWriteBuffer(t,a,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(t,a,n,s,i,r){let o=0;for(;o<s;){const w=await t.write(a,i+o,n.buffer,r+o,s-o);o+=w}}async doWriteUnbuffered(t,a,n,s){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,a,n,s))}async doWriteUnbufferedQueued(t,a,n,s){let i;s instanceof A.VSBuffer?i=s:(0,g.isReadableStream)(s)?i=await(0,A.streamToBuffer)(s):(0,g.isReadableBufferedStream)(s)?i=await(0,A.bufferedStreamToBuffer)(s):i=(0,A.readableToBuffer)(s),await t.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(t,a,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,a,n,s))}async doPipeBufferedQueued(t,a,n,s){let i,r;try{i=await t.open(a,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const o=A.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,E=0,d=0;do d=await t.read(i,w,o.buffer,E,o.byteLength-E),await this.doWriteBuffer(n,r,o,d,w,E),w+=d,E+=d,E===o.byteLength&&(E=0);while(d>0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await O.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(t,a,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,a,n,s))}async doPipeUnbufferedQueued(t,a,n,s){return n.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,a,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,a,n,s))}async doPipeUnbufferedToBufferedQueued(t,a,n,s){const i=await n.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.doWriteBuffer(n,i,A.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await n.close(i)}}async doPipeBufferedToUnbuffered(t,a,n,s){const i=await(0,A.streamToBuffer)(this.readFileBuffered(t,a,U.CancellationToken.None));await this.doWriteUnbuffered(n,s,void 0,i)}throwIfFileSystemIsReadonly(t,a){if(t.capabilities&2048)throw new m.FileOperationError((0,y.localize)(25,null,this.resourceForError(a)),6);return t}throwIfFileIsReadonly(t,a){if((a.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,y.localize)(26,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===C.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=p,e.FileService=p=ye([X(0,l.ILogService)],p)}),define(oe[200],ae([0,1,52,271,5,34,15,3,48,2,16,6,21,46,31,162,11,99,198,38,194,193]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(k)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(a)}`)}})();class t extends l.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=L.Event.None,this.resourceLocks=new U.ResourceMap(i=>S.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:i}=await g.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:m.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await g.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,S.joinPath)(n,r.name))).type:o=this.toType(r),i.push([r.name,o])}catch(o){this.logService.trace(o)}})),i}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let i;return s?.dangling?i=m.FileType.Unknown:n.isFile()?i=m.FileType.File:n.isDirectory()?i=m.FileType.Directory:i=m.FileType.Unknown,s&&(i|=m.FileType.SymbolicLink),i}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const r=new A.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),i=await this.createResourceLock(n));const r=this.toFilePath(n);return await g.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{i?.dispose()}}traceLock(n){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,i){const r=(0,c.newWriteableStream)(o=>_.VSBuffer.concat(o.map(w=>_.VSBuffer.wrap(w))).buffer);return(0,h.readFileIntoStream)(this,n,r,o=>o.buffer,{...s,bufferSize:256*1024},i),r}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,S.joinPath)((0,S.dirname)(n),`${(0,S.basename)(n)}${i.atomic.postfix}`),s,i):this.doWriteFile(n,s,i)}async canWriteFileAtomic(n){try{const s=this.toFilePath(n),{symbolicLink:i}=await g.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async doWriteFileAtomic(n,s,i,r){const o=new f.DisposableStore;try{o.add(await this.createResourceLock(n)),o.add(await this.createResourceLock(s)),await this.doWriteFile(s,i,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(w){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{o.dispose()}}async doWriteFile(n,s,i,r){let o;try{const w=this.toFilePath(n);if(!i.create||!i.overwrite){if(await g.Promises.exists(w)){if(!i.overwrite)throw(0,m.createFileSystemProviderError)((0,y.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,m.createFileSystemProviderError)((0,y.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:i.unlock},r),await this.write(o,0,s,0,s.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(n,w)}finally{typeof o=="number"&&await this.close(o)}}static{this.canFlush=!0}static configureFlushOnWrite(n){t.canFlush=n}async open(n,s,i){const r=this.toFilePath(n);let o;(0,m.isFileOpenForWriteOptions)(s)&&!i&&(o=await this.createResourceLock(n));let w;try{if((0,m.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:d}=await g.SymlinkSupport.stat(r);d.mode&128||await g.Promises.chmod(r,d.mode|128)}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}let E;if((0,m.isFileOpenForWriteOptions)(s)){if(C.isWindows)try{await g.Promises.truncate(r,0),E="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}E||(E="w")}else E="r";w=await g.Promises.open(r,E)}catch(E){throw o?.dispose(),(0,m.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,E):this.toFileSystemProviderError(E)}if(this.mapHandleToPos.set(w,0),(0,m.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(w,n),o){const E=this.mapHandleToLock.get(w);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${r})`),this.mapHandleToLock.set(w,o),E&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${r})`),E.dispose())}return w}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&t.canFlush)try{await g.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.logService.error(i)}return await g.Promises.close(n)}catch(i){throw this.toFileSystemProviderError(i)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,r,o){const w=this.normalizePos(n,s);let E=null;try{E=(await g.Promises.read(n,i,r,o,w)).bytesRead}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(n,w,E)}return E}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,i){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof s=="number"||(typeof i=="number"?this.mapHandleToPos.set(n,r+i):this.mapHandleToPos.delete(n)))}async write(n,s,i,r,o){return(0,A.retry)(()=>this.doWrite(n,s,i,r,o),100,3)}async doWrite(n,s,i,r,o){const w=this.normalizePos(n,s);let E=null;try{E=(await g.Promises.write(n,i,r,o,w)).bytesWritten}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),d)}finally{this.updatePos(n,w,E)}return E}async mkdir(n){try{await g.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const i=this.toFilePath(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,D.join)((0,D.dirname)(i),`${(0,D.basename)(i)}${s.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:w,symbolicLink:E}=await g.SymlinkSupport.stat(i);o=w.isDirectory()&&!E}catch{}if(o)await g.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(n,s,i){const r=this.toFilePath(n),o=this.toFilePath(s);if(r!==o)try{await this.validateMoveCopy(n,s,"move",i.overwrite),await g.Promises.rename(r,o)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,y.localize)(2,null,(0,D.basename)(r),(0,D.basename)((0,D.dirname)(o)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(n,s,i){const r=this.toFilePath(n),o=this.toFilePath(s);if(r!==o)try{await this.validateMoveCopy(n,s,"copy",i.overwrite),await g.Promises.copy(r,o,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,y.localize)(3,null,(0,D.basename)(r),(0,D.basename)((0,D.dirname)(o)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(n,s,i,r){const o=this.toFilePath(n),w=this.toFilePath(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,I.isEqual)(o,w,!0)),E){if(i==="copy")throw(0,m.createFileSystemProviderError)((0,y.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const v=await this.statIgnoreError(n);if(!v)throw(0,m.createFileSystemProviderError)((0,y.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(s);if(T){if(!r)throw(0,m.createFileSystemProviderError)((0,y.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);v.type&m.FileType.File&&T.type&m.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,i){const r=this.toFilePath(n),o=this.toFilePath(s),w=!!(this.capabilities&1024);if((0,I.isEqual)(r,o,!w))return;const E=new f.DisposableStore;try{E.add(await this.createResourceLock(n)),E.add(await this.createResourceLock(s)),i&&await g.Promises.mkdir((0,D.dirname)(o),{recursive:!0}),await g.Promises.copyFile(r,o)}catch(d){if(d.code==="ENOENT"&&!i)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(d)}finally{E.dispose()}}createUniversalWatcher(n,s,i){return new p.UniversalWatcherClient(r=>n(r),r=>s(r),i)}createNonRecursiveWatcher(n,s,i){return new b.NodeJSWatcherClient(r=>n(r),r=>s(r),i)}toFileSystemProviderError(n){if(n instanceof m.FileSystemProviderError)return n;let s=n,i;switch(n.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=m.FileSystemProviderErrorCode.Unknown;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(n,s){let i=this.toFileSystemProviderError(s);if(n&&i.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(i=(0,m.createFileSystemProviderError)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return i}}e.DiskFileSystemProvider=t}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let _=class extends O.Disposable{constructor(I){super(),this.logService=I,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_,e.SharedProcessLifecycleService=_=ye([X(0,U.ILogService)],_)}),define(oe[201],ae([0,1,10,3,7,2]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends A.AbstractLoggerService{constructor(C,S,c,g,y){super(S,c,g),this.windowId=C,this.channel=y,this._register(y.listen("onDidChangeLogLevel",C)(m=>{(0,A.isLogLevel)(m)?super.setLogLevel(m):super.setLogLevel(k.URI.revive(m[0]),m[1])})),this._register(y.listen("onDidChangeVisibility",C)(([m,h])=>super.setVisibility(k.URI.revive(m),h))),this._register(y.listen("onDidChangeLoggers",C)(({added:m,removed:h})=>{for(const l of m)super.registerLogger({...l,resource:k.URI.revive(l.resource)});for(const l of h)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(C,S)=>{this.channel.call("consoleLog",[C,S])}})}registerLogger(C){super.registerLogger(C),this.channel.call("registerLogger",[C,this.windowId])}deregisterLogger(C){super.deregisterLogger(C),this.channel.call("deregisterLogger",[C,this.windowId])}setLogLevel(C,S){super.setLogLevel(C,S),this.channel.call("setLogLevel",[C,S])}setVisibility(C,S){super.setVisibility(C,S),this.channel.call("setVisibility",[this.toResource(C),S])}doCreateLogger(C,S,c){return new L(this.channel,C,S,c,this.windowId)}static setLogLevel(C,S,c){return C.call("setLogLevel",[S,c])}}e.LoggerChannelClient=_;class L extends A.AbstractMessageLogger{constructor(C,S,c,g,y){super(g?.logLevel==="always"),this.channel=C,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[S,g,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,S){const c=[[C,S]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(C){this.channel.call("log",[this.file,C])}}class I{constructor(C,S){this.loggerService=C,this.getUriTransformer=S}listen(C,S){const c=this.getUriTransformer(C);switch(S){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,g=>({added:[...g.added].map(y=>this.transformLogger(y,c)),removed:[...g.removed].map(y=>this.transformLogger(y,c))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,g=>[c.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,g=>(0,A.isLogLevel)(g)?g:[c.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${S}`)}async call(C,S,c){const g=this.getUriTransformer(C);switch(S){case"setLogLevel":return(0,A.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(k.URI.revive(g.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,g)))}throw new Error(`Call not found: ${S}`)}transformLogger(C,S){return{...C,resource:S.transformOutgoingURI(C.resource)}}}e.LoggerChannel=I;class f extends U.Disposable{constructor(C,S){super(),S.call("setLogLevel",[C.getLogLevel()]),this._register(C.onDidChangeLogLevel(c=>S.call("setLogLevel",[c]))),S.call("getRegisteredLoggers").then(c=>{for(const g of c)C.registerLogger({...g,resource:k.URI.revive(g.resource)})}),this._register(S.listen("onDidChangeVisibility")(([c,g])=>C.setVisibility(k.URI.revive(c),g))),this._register(S.listen("onDidChangeLoggers")(({added:c,removed:g})=>{for(const y of c)C.registerLogger({...y,resource:k.URI.revive(y.resource)});for(const y of g)C.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=f}),define(oe[202],ae([0,1,2,7]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends k.Disposable{constructor(_,L=[]){super(),this.logger=new O.MultiplexLogger([_,...L]),this._register(_.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...L){this.logger.trace(_,...L)}debug(_,...L){this.logger.debug(_,...L)}info(_,...L){this.logger.info(_,...L)}warn(_,...L){this.logger.warn(_,...L)}error(_,...L){this.logger.error(_,...L)}flush(){this.logger.flush()}}e.LogService=A}),define(oe[55],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,U.createDecorator)("policy");class _ extends A.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(f){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...f,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(f),O.Iterable.reduce(this.policies.entries(),(C,[S,c])=>({...C,[S]:c}),{})}getPolicyValue(f){return this.policies.get(f)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(f,[D,C])=>({...f,[D]:{definition:C,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=_;class L{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=L}),define(oe[203],ae([0,1,3,2,56]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class U{constructor(I){this.service=I,this.disposables=new O.DisposableStore}listen(I,f){switch(f){case"onDidChange":return k.Event.map(this.service.onDidChange,D=>D.reduce((C,S)=>({...C,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${f}`)}call(I,f,D){switch(f){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(D)}throw new Error(`Call not found: ${f}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=U;class _ extends A.AbstractPolicyService{constructor(I,f){super(),this.channel=f;for(const D in I){const{definition:C,value:S}=I[D];this.policyDefinitions[D]=C,S!==void 0&&this.policies.set(D,S)}this.channel.listen("onDidChange")(D=>{for(const C in D){const S=D[C];S===null?this.policies.delete(C):this.policies.set(C,S)}this._onDidChange.fire(Object.keys(D))})}async _updatePolicyDefinitions(I){const f=await this.channel.call("updatePolicyDefinitions",I);for(const D in f)this.policies.set(D,f[D])}}e.PolicyChannelClient=_}),define(oe[102],ae([0,1,6,37]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const U=k.globals.vscode.context.configuration();if(U)A=U.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){A=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:U,searchUrl:_,itemUrl:L,controlUrl:I}=A.extensionsGallery||{};Object.assign(A,{extensionsGallery:{serviceUrl:O.env.VSCODE_GALLERY_SERVICE_URL||U,searchUrl:O.env.VSCODE_GALLERY_SEARCH_URL||_,itemUrl:O.env.VSCODE_GALLERY_ITEM_URL||L,controlUrl:O.env.VSCODE_GALLERY_CONTROL_URL||I}});try{const f=(...C)=>C.reduce((S,c)=>(Object.keys(c).forEach(g=>{Array.isArray(S[g])&&Array.isArray(c[g])?S[g]=c[g]:typeof S[g]=="object"&&typeof c[g]=="object"?S[g]=f(S[g],c[g]):S[g]=c[g]}),S),{}),D=globalThis._VSCODE_USER_PRODUCT_JSON||{};A=f(A,D)}catch{}if(O.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const f=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:f.version,release:f.release})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[24],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,5,8,2,16,31,7,24]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let f=class extends A.Disposable{constructor(C,S,c){super(),this.productService=S,this.logService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},3e4)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),c=(0,U.dirname)(C),g=(0,U.basename)(C),y=await _.Promises.readdir(c);await Promise.all(y.map(async m=>{if(m===g)return;const h=(0,U.join)(c,m),l=await _.Promises.stat(h);if(l.isDirectory()&&S-l.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${m}.`),_.Promises.rm(h)}))}catch(S){(0,O.onUnexpectedError)(S)}}};e.CodeCacheCleaner=f,e.CodeCacheCleaner=f=ye([X(1,I.IProductService),X(2,L.ILogService)],f)}),define(oe[205],ae([0,1,5,8,2,16,31,14,7,24]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends A.Disposable{constructor(S,c,g){super(),this.environmentService=S,this.logService=c,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),c=JSON.parse(await _.Promises.readFile((0,U.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const l of Object.keys(c)){const u=c[l];S[`${u.hash}.${l}`]=!0}const g=(0,U.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(g))return;const m=await _.Promises.readdir(g);for(const l of m){if(S[l]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${l}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${l}`),await _.Promises.rm((0,U.join)(g,l))}const h=Date.now();for(const l of Object.keys(S)){const u=(0,U.join)(g,l),p=await _.Promises.readdir(u);for(const b of p){if(b==="tcf.json")continue;const t=(0,U.join)(u,b),a=await _.Promises.stat(t);a.isDirectory()&&h-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,U.join)(l,b)}`),await _.Promises.rm(t))}}}catch(S){(0,O.onUnexpectedError)(S)}}};e.LanguagePackCachedDataCleaner=D,e.LanguagePackCachedDataCleaner=D=ye([X(0,L.INativeEnvironmentService),X(1,I.ILogService),X(2,f.IProductService)],D)}),define(oe[206],ae([0,1,16,4]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var A;(function(U){function _(I){return!!(I.samples&&I.timeDeltas)}U.isValidProfile=_;function L(I,f="noAbsolutePaths"){for(const D of I.nodes)D.callFrame&&D.callFrame.url&&((0,k.isAbsolute)(D.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(D.callFrame.url))&&(D.callFrame.url=(0,k.join)(f,(0,k.basename)(D.callFrame.url)));return I}U.rewriteAbsolutePaths=L})(A||(e.Utils=A={}))}),define(oe[207],ae([0,1,32]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(U){const L=await(await new Promise((f,D)=>{te(["v8-inspect-profiler"],f,D)})).startProfiling({port:U.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this._sessions.set(I,L),I}async stopProfiling(U){const _=this._sessions.get(U);if(!_)throw new Error(`UNKNOWN session '${U}'`);const L=await _.stop();return this._sessions.delete(U),L.profile}}e.InspectProfilingService=O}),define(oe[40],ae([0,1,127,12]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(_,L){k.ok(O.isString(_)),k.ok(O.isObject(L)),k.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,L)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new A}),define(oe[103],ae([0,1,3,40]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class U{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,f){this.schemasById[A(I)]=f,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new U;O.Registry.add(e.Extensions.JSONContribution,_)}),define(oe[49],ae([0,1,18,3,12,149,19,103,40]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=I.Registry.as(L.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:U.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const n=new Set;this.doRegisterConfigurations(t,a,n),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const n=new Set;this.doDeregisterConfigurations(a,n),this.doRegisterConfigurations(t,!1,n),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const n=[];for(const{overrides:s,source:i}of t)for(const r in s)if(a.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const o=this.configurationDefaultsOverrides.get(r),w=o?.valuesSources??new Map;if(i)for(const T of Object.keys(s[r]))w.set(T,i);const E={...o?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:E,valuesSources:w});const d=(0,_.getLanguageTagSettingPlainKey)(r),v={type:"object",default:E,description:U.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:A.isString(i)?void 0:i,defaultValueSource:i};n.push(...y(r)),this.configurationProperties[r]=v,this.defaultLanguageConfigurationOverridesNode.properties[r]=v}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:n,source:s}of t)for(const i in n){const r=this.configurationDefaultsOverrides.get(i),o=A.isString(s)?s:s?.id,w=A.isString(r?.source)?r?.source:r?.source?.id;if(o===w)if(a.add(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const E=this.configurationProperties[i];E&&(this.updatePropertyDefaultValue(i,E),this.updateSchema(i,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const n=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,n),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,n),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,n),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,n){t.forEach(s=>{this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(t,a){const n=s=>{if(s.properties)for(const i in s.properties){a.add(i);const r=this.configurationProperties[i];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}}validateAndRegisterProperties(t,a=!0,n,s,i=3,r){i=A.isUndefinedOrNull(t.scope)?i:t.scope;const o=t.properties;if(o)for(const E in o){const d=o[E];if(a&&u(E,d)){delete o[E];continue}if(d.source=n,d.defaultDefaultValue=o[E].default,this.updatePropertyDefaultValue(E,d),e.OVERRIDE_PROPERTY_REGEX.test(E)?d.scope=void 0:(d.scope=A.isUndefinedOrNull(d.scope)?i:d.scope,d.restricted=A.isUndefinedOrNull(d.restricted)?!!s?.includes(E):d.restricted),o[E].hasOwnProperty("included")&&!o[E].included){this.excludedConfigurationProperties[E]=o[E],delete o[E];continue}else this.configurationProperties[E]=o[E],o[E].policy?.name&&this.policyConfigurations.set(o[E].policy.name,E);!o[E].deprecationMessage&&o[E].markdownDeprecationMessage&&(o[E].deprecationMessage=o[E].markdownDeprecationMessage),r.add(E)}const w=t.allOf;if(w)for(const E of w)this.validateAndRegisterProperties(E,a,n,s,i,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=n=>{const s=n.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);n.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,n={type:"object",description:U.localize(2,null),errorMessage:U.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}}registerOverridePropertyPatternKey(){const t={type:"object",description:U.localize(4,null),errorMessage:U.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const n=this.configurationDefaultsOverrides.get(t);let s=n?.value,i=n?.source;A.isUndefined(s)&&(s=a.defaultDefaultValue,i=void 0),A.isUndefined(s)&&(s=h(a.type)),a.default=s,a.defaultValueSource=i}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let a=g.exec(b);for(;a?.length;){const n=a[1].trim();n&&t.push(n),a=g.exec(b)}}return(0,k.distinct)(t)}e.overrideIdentifiersFromKey=y;function m(b){return b.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=m;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const l=new S;I.Registry.add(e.Extensions.Configuration,l);function u(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?U.localize(7,null,b):l.getConfigurationProperties()[b]!==void 0?U.localize(8,null,b):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?U.localize(9,null,b,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:U.localize(6,null)}e.validateProperty=u;function p(){const b=[],t=l.getConfigurationProperties();for(const a of Object.keys(t))b.push([a,t[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=p}),define(oe[73],ae([0,1,18,3,35,2,34,30,12,10,19,49,40]),function(te,e,k,O,A,U,_,L,I,f,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function c(a){return Object.isFrozen(a)?a:L.deepFreeze(a)}class g{constructor(n={},s=[],i=[],r){this._contents=n,this._keys=s,this._overrides=i,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof g)return s;const i=new y("");return i.parseRaw(s),i.configurationModel});this._rawConfiguration=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const i=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,o=s?this.rawConfiguration.override(s).getValue(n):i;return{value:i,override:r,merged:o}}getOverrideValue(n,s){const i=this.getContentsForOverrideIdentifer(s);return i?n?(0,D.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return k.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return k.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=L.deepClone(this.contents),i=L.deepClone(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const w of n)if(o.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(s,w.contents);for(const E of w.overrides){const[d]=i.filter(v=>k.equals(v.identifiers,E.identifiers));d?(this.mergeContents(d.contents,E.contents),d.keys.push(...E.keys),d.keys=k.distinct(d.keys)):i.push(L.deepClone(E))}for(const E of w.keys)r.indexOf(E)===-1&&r.push(E)}return new g(s,r,i,o.every(w=>w instanceof g)?void 0:o)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const r of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[r];const w=s[r];w&&(typeof o=="object"&&typeof w=="object"?(o=L.deepClone(o),this.mergeContents(o,w)):o=w),i[r]=o}return new g(i,this.keys,this.overrides)}mergeContents(n,s){for(const i of Object.keys(s)){if(i in n&&I.isObject(n[i])&&I.isObject(s[i])){this.mergeContents(n[i],s[i]);continue}n[i]=L.deepClone(s[i])}}getContentsForOverrideIdentifer(n){let s=null,i=null;const r=o=>{o&&(i?this.mergeContents(i,o):i=L.deepClone(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?s=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,D.removeFromValueTree)(this.contents,n),C.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>k.equals(i.identifiers,(0,C.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,i){(0,D.addToValueTree)(this.contents,n,s,r=>console.error(r)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),C.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,C.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,D.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=g;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!I.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:i,keys:r,overrides:o,restricted:w,hasExcludedProperties:E}=this.doParseRaw(n,s);this._configurationModel=new g(i,r,o,E?[n]:void 0),this._restrictedConfigurations=w||[]}doParseContent(n){let s={},i=null,r=[];const o=[],w=[];function E(v){Array.isArray(r)?r.push(v):i!==null&&(r[i]=v)}const d={onObjectBegin:()=>{const v={};E(v),o.push(r),r=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const v=[];E(v),o.push(r),r=v,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:E,onError:(v,T,N)=>{w.push({error:v,offset:T,length:N})}};if(n)try{A.visit(n,d),s=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return s}doParseRaw(n,s){const i=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,i,!0,s);n=r.raw;const o=(0,D.toValuesTree)(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),w=Object.keys(n),E=this.toOverrides(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:w,overrides:E,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,s,i,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const w={},E=[];for(const d in n)if(C.OVERRIDE_PROPERTY_REGEX.test(d)&&i){const v=this.filter(n[d],s,!1,r);w[d]=v.raw,o=o||v.hasExcludedProperties,E.push(...v.restricted)}else{const v=s[d],T=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&E.push(d),!r.exclude?.includes(d)&&(r.include?.includes(d)||(T===void 0||r.scopes===void 0||r.scopes.includes(T))&&!(r.skipRestricted&&v?.restricted))?w[d]=n[d]:o=!0}return{raw:w,restricted:E,hasExcludedProperties:o}}toOverrides(n,s){const i=[];for(const r of Object.keys(n))if(C.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const w in n[r])o[w]=n[r][w];i.push({identifiers:(0,C.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,D.toValuesTree)(o,s)})}return i}}e.ConfigurationModelParser=y;class m extends U.Disposable{constructor(n,s,i,r){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=r,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class h{constructor(n,s,i,r,o,w,E,d,v,T,N,M,$){this.key=n,this.overrides=s,this._value=i,this.overrideIdentifiers=r,this.defaultConfiguration=o,this.policyConfiguration=w,this.applicationConfiguration=E,this.userConfiguration=d,this.localUserConfiguration=v,this.remoteUserConfiguration=T,this.workspaceConfiguration=N,this.folderConfigurationModel=M,this.memoryConfigurationModel=$}get value(){return c(this._value)}inspect(n,s,i){const r=n.inspect(s,i);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(n,s,i,r,o=new g,w=new g,E=new _.ResourceMap,d=new g,v=new _.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=w,this._folderConfigurations=E,this._memoryConfiguration=d,this._memoryConfigurationByResource=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,s,i){return this.getConsolidatedConfigurationModel(n,s,i).getValue(n)}updateValue(n,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new g,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(n):r.setValue(n,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,i){const r=this.getConsolidatedConfigurationModel(n,s,i),o=this.getFolderConfigurationModelForResource(s.resource,i),w=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const d of r.overrides)for(const v of d.identifiers)r.getOverrideValue(n,v)!==void 0&&E.add(v);return new h(n,s,r.getValue(n),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,o||void 0,w)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:r,updated:o,removed:w}=b(this._defaultConfiguration,n);s=[...r,...o,...w]}for(const r of s)for(const o of(0,C.overrideIdentifiersFromKey)(r)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(o),E=n.getKeysForOverrideIdentifier(o),d=[...E.filter(v=>w.indexOf(v)===-1),...w.filter(v=>E.indexOf(v)===-1),...w.filter(v=>!L.equals(this._defaultConfiguration.override(o).getValue(v),n.override(o).getValue(v)))];i.push([o,d])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:r}=b(this._policyConfiguration,n),o=[...s,...i,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:r,overrides:o}=b(this.applicationConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateApplicationConfiguration(n),{keys:w,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:o}=b(this.localUserConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateLocalUserConfiguration(n),{keys:w,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:o}=b(this.remoteUserConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateRemoteUserConfiguration(n),{keys:w,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:r,overrides:o}=b(this.workspaceConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateWorkspaceConfiguration(n),{keys:w,overrides:o}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:r,updated:o,removed:w,overrides:E}=b(i,s),d=[...r,...o,...w];return(d.length||!i)&&this.updateFolderConfiguration(n,s),{keys:d,overrides:E}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:o,overrides:w}=b(s,void 0);return{keys:[...i,...r,...o],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const r=s.getFolder(n);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const o=this._memoryConfigurationByResource.get(n);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(s=i.merge(r),this._foldersConsolidatedConfigurations.set(n,s)):s=i}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:i,overrides:r,keys:o}=this._folderConfigurations.get(s);return n.push([s,{contents:i,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),o=this.parseConfigurationModel(n.user),w=this.parseConfigurationModel(n.workspace),E=n.folders.reduce((d,v)=>(d.set(f.URI.revive(v[0]),this.parseConfigurationModel(v[1])),d),new _.ResourceMap);return new l(s,i,r,o,new g,w,E,new g,new _.ResourceMap)}static parseConfigurationModel(n){return new g(n.contents,n.keys,n.overrides)}}e.Configuration=l;function u(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,s=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,w])=>{const E=(0,_.getOrSet)(s,o,new Set);w.forEach(d=>E.add(d))});const i=[];return s.forEach((r,o)=>i.push([o,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=u;class p{constructor(n,s,i,r){this.change=n,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const w of o)this.affectedKeys.add(w);this._affectsConfigStr=this._marker;for(const o of this.affectedKeys)this._affectsConfigStr+=o+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const i=this._marker+n,r=this._affectsConfigStr.indexOf(i);if(r<0)return!1;const o=r+i.length;if(o>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(o);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(s){const E=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!L.equals(E,d)}return!0}}e.ConfigurationChangeEvent=p;function b(a,n){const{added:s,removed:i,updated:r}=t(n?.rawConfiguration,a?.rawConfiguration),o=[],w=a?.getAllOverrideIdentifiers()||[],E=n?.getAllOverrideIdentifiers()||[];if(n){const d=E.filter(v=>!w.includes(v));for(const v of d)o.push([v,n.getKeysForOverrideIdentifier(v)])}if(a){const d=w.filter(v=>!E.includes(v));for(const v of d)o.push([v,a.getKeysForOverrideIdentifier(v)])}if(n&&a){for(const d of w)if(E.includes(d)){const v=t({contents:a.getOverrideValue(void 0,d)||{},keys:a.getKeysForOverrideIdentifier(d)},{contents:n.getOverrideValue(void 0,d)||{},keys:n.getKeysForOverrideIdentifier(d)});o.push([d,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:i,updated:r,overrides:o}}function t(a,n){const s=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],i=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const w=(0,D.getConfigurationValue)(n.contents,o),E=(0,D.getConfigurationValue)(a.contents,o);L.equals(w,E)||r.push(o)}}return{added:s,removed:i,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,73,49,7,56,40]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends A.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new L.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(C.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:h})=>this.onDidUpdateConfiguration(Array.from(m),h))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(m,h){this.updateConfigurationModel(m,C.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new L.ConfigurationModel;const m=C.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(m),m)}updateConfigurationModel(m,h){const l=this.getConfigurationDefaultOverrides();for(const u of m){const p=l[u],b=h[u];p!==void 0?this._configurationModel.addValue(u,p):b?this._configurationModel.addValue(u,b.default):this._configurationModel.removeValue(u)}}}e.DefaultConfiguration=S;class c{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new L.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=c;let g=class extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(m,h,l){super(),this.defaultConfiguration=m,this.policyService=h,this.logService=l,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new L.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.updatePolicyDefinitions(m),!0))),this._configurationModel}async updatePolicyDefinitions(m){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",m);const h={},l=[],u=C.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const p of m){const b=u[p];if(!b){l.push(p);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.logService.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}l.push(p),h[b.policy.name]={type:b.type}}}return(0,_.isEmptyObject)(h)||await this.policyService.updatePolicyDefinitions(h),l}onDidChangePolicies(m){this.logService.trace("PolicyConfiguration#onDidChangePolicies",m);const h=C.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),l=(0,k.coalesce)(m.map(u=>h.get(u)));this.update(l,!0)}update(m,h){this.logService.trace("PolicyConfiguration#update",m);const l=C.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=[],p=this._configurationModel.isEmpty();for(const b of m){const t=l[b]?.policy?.name;if(t){const a=this.policyService.getPolicyValue(t);(p?a!==void 0:!(0,U.equals)(this._configurationModel.getValue(b),a))&&u.push([b,a])}else this._configurationModel.getValue(b)!==void 0&&u.push([b,void 0])}if(u.length){this.logService.trace("PolicyConfiguration#changed",u);const b=this._configurationModel;this._configurationModel=new L.ConfigurationModel;for(const t of b.keys)this._configurationModel.setValue(t,b.getValue(t));for(const[t,a]of u)a===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,a);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=g,e.PolicyConfiguration=g=ye([X(1,D.IPolicyService),X(2,f.ILogService)],g)}),define(oe[209],ae([0,1,5,3,2,21,19,73,208,56]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends A.Disposable{constructor(S,c,g,y){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=g instanceof f.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,g,y)),this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,{},U.extUriBiasedIgnorePathCase,c)),this.configuration=new L.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new L.ConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:m,properties:h})=>this.onDidDefaultConfigurationChange(m,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(m=>this.onDidPolicyConfigurationChange(m))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,c,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new L.Configuration(S,c,new L.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(S,c){const g=typeof S=="string"?S:void 0,y=(0,_.isConfigurationOverrides)(S)?S:(0,_.isConfigurationOverrides)(c)?c:{};return this.configuration.getValue(g,y,void 0)}updateValue(S,c,g,y){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const c=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(g,c,2)}onDidDefaultConfigurationChange(S,c){const g=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(S,c);this.trigger(y,g,7)}onDidPolicyConfigurationChange(S){const c=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(g,c,7)}trigger(S,c,g){const y=new L.ConfigurationChangeEvent(S,{data:c},this.configuration);y.source=g,y.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(oe[210],ae([0,1,15,3,2,65]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const _=(f,D,C)=>{const S=new Uint8Array(16);for(let y=0;y<16;y++)S[y]=Math.round(Math.random()*256);const c=(0,k.encodeBase64)(k.VSBuffer.wrap(S));return[`GET ws://localhost${f}?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=_,e.socketRawEndHeaderSequence=k.VSBuffer.fromString(`\r
\r
`);async function L(f,D,C,S,c){f.write(k.VSBuffer.fromString((0,e.makeRawSocketHeaders)(D,C,S)));const g=new A.DisposableStore;try{return await new Promise((y,m)=>{let h;g.add(f.onData(l=>{h?h=k.VSBuffer.concat([h,l],h.byteLength+l.byteLength):h=l;const u=h.indexOf(e.socketRawEndHeaderSequence);if(u===-1)return;y(f),f.pauseData();const p=h.slice(u+e.socketRawEndHeaderSequence.byteLength);p.byteLength&&c.onData.fire(p)})),g.add(f.onClose(l=>m(l??new Error("socket closed")))),g.add(f.onEnd(()=>m(new Error("socket ended"))))})}catch(y){throw f.dispose(),y}finally{g.dispose()}}e.connectManagedSocket=L;class I extends A.Disposable{constructor(D,C){super(),this.debugLabel=D,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...S)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...S)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(C.onData),this._register(C.onData.event(S=>this.pausableDataEmitter.fire(S))),this.onClose=this._register(C.onClose).event,this.onEnd=this._register(C.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(D,C){U.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,D,C)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=I}),define(oe[211],ae([0,1,8,4]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var A;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class U{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=U;class _{constructor(C,S){this.host=C,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=_;var L;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(L||(e.RemoteAuthorityResolverErrorCode=L={}));class I extends k.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof I&&C._code===L.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===L.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===L.NoResolverFound}static isInvalidAuthority(C){return C instanceof I&&C._code===L.InvalidAuthority}static isHandled(C){return C instanceof I&&C.isHandled}constructor(C,S=L.Unknown,c){super(C),this._message=C,this._code=S,this._detail=c,this.isHandled=S===L.NotAvailable&&c===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function f(D){const C=D.indexOf("+");return C===-1?D:D.substring(0,C)}e.getRemoteAuthorityPrefix=f}),define(oe[74],ae([0,1,23]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(f){return f.scheme===k.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=O;function A(f){if(!f)return;const D=f.indexOf("+");return D<0?f:f.substr(0,D)}e.getRemoteName=A;function U(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.getRemoteServerRootPath=U;function _(f){const{host:D,port:C}=I(f);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:C}}e.parseAuthorityWithPort=_;function L(f,D){let{host:C,port:S}=I(f);return typeof S>"u"&&(S=D),{host:C,port:S}}e.parseAuthorityWithOptionalPort=L;function I(f){const D=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const C=f.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const S=f.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:f,port:void 0}}}),define(oe[44],ae([0,1,27,4,74]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function U(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=U,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(_||(e.ExtensionType=_={}));var L;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(L||(e.TargetPlatform=L={}));class I{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,h){if(typeof m>"u"||m===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof m=="string"||typeof h=="string"){const l=typeof m=="string"?m:m.value,u=typeof h=="string"?h:h.value;return k.equalsIgnoreCase(l,u)}return m._lower===h._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=I;class f{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const h of m)this.add(h)}add(m){this._set.add(I.toKey(m))}delete(m){return this._set.delete(I.toKey(m))}has(m){return this._set.has(I.toKey(m))}}e.ExtensionIdentifierSet=f;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(I.toKey(m))}get(m){return this._map.get(I.toKey(m))}has(m){return this._map.has(I.toKey(m))}set(m,h){this._map.set(I.toKey(m),h)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function C(y){return S(y)}e.isApplicationScopedExtension=C;function S(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function c(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=c;function g(y,m){if(m){const h=`onResolveRemoteAuthority:${(0,A.getRemoteName)(m)}`;return!!y.activationEvents?.includes(h)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends k.Disposable{constructor(L,I,f,D,C){super(),this.userDataProfilesService=L,this.fileService=I,this.uriIdentityService=f,this.logService=C,this._register(D.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(D.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtensions(L){for(const I of L)I.local&&this.invalidate(I.profileLocation)}onDidUnInstallExtension(L){L.error||this.invalidate(L.profileLocation)}async invalidate(L){if(L)for(const I of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(I.extensionsResource,L)&&await this.deleteUserCacheFile(I);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(L){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(L.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(I){(0,A.toFileOperationResult)(I)!==1&&this.logService.error(I)}}}e.ExtensionsManifestCache=U}),define(oe[213],ae([0,1,5,15,26,8,3,2,100,60,32,65,211,74]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function m(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const P=new A.CancellationTokenSource;return setTimeout(()=>P.cancel(),q),P.token}function l(q,P){if(q.isCancellationRequested||P.isCancellationRequested)return A.CancellationToken.Cancelled;const R=new A.CancellationTokenSource;return q.onCancellationRequested(()=>R.cancel()),P.onCancellationRequested(()=>R.cancel()),R.token}class u{get didTimeout(){return this._state==="timedout"}constructor(P){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((R,W)=>{this._resolvePromise=R,this._rejectPromise=W}),P.isCancellationRequested?this._timeout():this._disposables.add(P.onCancellationRequested(()=>this._timeout()))}registerDisposable(P){this._state==="pending"?this._disposables.add(P):P.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(P))}reject(P){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(P))}}function p(q,P){const R=new u(P);return R.registerDisposable(q.onControlMessage(W=>{const F=JSON.parse(W.toString()),H=z(F);H?R.reject(H):R.resolve(F)})),R.promise}function b(q,P,R,W,F,H,Y,se){const le=new u(se),he=f.StopWatch.create(!1);return q.info(`Creating a socket (${Y})...`),I.mark(`code/willCreateSocket/${H}`),P.connect(R,W,F,Y).then(ue=>{le.didTimeout?(I.mark(`code/didCreateSocketError/${H}`),q.info(`Creating a socket (${Y}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(I.mark(`code/didCreateSocketOK/${H}`),q.info(`Creating a socket (${Y}) was successful after ${he.elapsed()} ms.`),le.resolve(ue))},ue=>{I.mark(`code/didCreateSocketError/${H}`),q.info(`Creating a socket (${Y}) returned an error after ${he.elapsed()} ms.`),q.error(ue),le.reject(ue)}),le.promise}function t(q,P){const R=new u(P);return q.then(W=>{R.didTimeout||R.resolve(W)},W=>{R.didTimeout||R.reject(W)}),R.promise}async function a(q,P,R,W){const F=re(q,P);q.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let H;try{H=await b(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,c.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,m(P),`renderer-${m(P)}-${q.reconnectionToken}`,W)}catch(ue){throw q.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ue),ue}q.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let Y,se;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(H,null),Y=q.reconnectionProtocol,se=!1):(Y=new C.PersistentProtocol({socket:H}),se=!0),q.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const le=await t(q.signService.createNewMessage((0,D.generateUuid)()),W),he={type:"auth",auth:q.connectionToken||"00000000000000000000",data:le.data};Y.sendControl(O.VSBuffer.fromString(JSON.stringify(he)));try{const ue=await p(Y,l(W,h(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(q.logService.trace(`${F} 4/6. received SignRequest control message.`),!await t(q.signService.validate(le,ue.signedData),W)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await t(q.signService.sign(ue.data),W),pe={type:"connectionType",commit:q.commit,signedData:fe,desiredConnectionType:P};return R&&(pe.args=R),q.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(O.VSBuffer.fromString(JSON.stringify(pe))),{protocol:Y,ownsProtocol:se}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(q.logService.error(`${F} the handshake timed out. Error:`),q.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${F} received error control message when negotiating connection. Error:`),q.logService.error(ue)),se&&V(Y),ue}}async function n(q,P,R,W){const F=Date.now(),H=re(q,P),{protocol:Y,ownsProtocol:se}=await a(q,P,R,W),le=new u(W);return le.registerDisposable(Y.onControlMessage(he=>{const ue=JSON.parse(he.toString()),me=z(ue);me?(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error(me),se&&V(Y),le.reject(me)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${J(F)}!`),le.resolve({protocol:Y,firstMessage:ue}))})),le.promise}async function s(q,P){const{protocol:R}=await n(q,1,void 0,P);return{protocol:R}}async function i(q,P,R){const{protocol:W,firstMessage:F}=await n(q,2,P,R),H=F&&F.debugPort;return{protocol:W,debugPort:H}}async function r(q,P,R){const W=Date.now(),F=re(q,3),{protocol:H}=await a(q,3,P,R);return q.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${J(W)}!`),H}async function o(q,P,R){const{connectTo:W,connectionToken:F}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:W,connectionToken:F,reconnectionToken:P,reconnectionProtocol:R,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function w(q,P,R){return d(q,async W=>{const{protocol:F}=await s(W,A.CancellationToken.None);return new B(q,P,R,W.reconnectionToken,F)})}e.connectRemoteAgentManagement=w;async function E(q,P){return d(q,async R=>{const{protocol:W,debugPort:F}=await i(R,P,A.CancellationToken.None);return new K(q,P,R.reconnectionToken,W,F)})}e.connectRemoteAgentExtensionHost=E;async function d(q,P){for(let W=1;;W++)try{const F=(0,D.generateUuid)(),H=await o(q,F,null);return await P(H)}catch(F){if(W<5)q.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(F);else throw q.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(F),Q.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(F)),F}}async function v(q,P,R){const W=await o(q,(0,D.generateUuid)(),null);return await r(W,{host:P,port:R},A.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function T(q){return(0,k.createCancelablePromise)(P=>new Promise((R,W)=>{const F=setTimeout(R,q*1e3);P.onCancellationRequested(()=>{clearTimeout(F),R()})}))}var N;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class M{constructor(P,R){this.reconnectionToken=P,this.millisSinceLastIncomingData=R,this.type=0}}e.ConnectionLostEvent=M;class ${constructor(P,R,W,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=R,this.durationSeconds=W,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class j{constructor(P,R,W){this.reconnectionToken=P,this.millisSinceLastIncomingData=R,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=j;class Z{constructor(P,R,W){this.reconnectionToken=P,this.millisSinceLastIncomingData=R,this.attempt=W,this.type=4}}e.ConnectionGainEvent=Z;class G{constructor(P,R,W,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=R,this.attempt=W,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=G;class Q extends L.Disposable{static triggerPermanentFailure(P,R,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=P,this._permanentFailureAttempt=R,this._permanentFailureHandled=W,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(P=>P._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(P=>P._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||Q._permanentFailure}constructor(P,R,W,F,H){super(),this._connectionType=P,this._options=R,this.reconnectionToken=W,this.protocol=F,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new Z(this.reconnectionToken,0,0)),this._register(F.onSocketClose(Y=>{const se=ne(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(Y=>{const se=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),Q._instances.push(this),this._register((0,L.toDisposable)(()=>{const Y=Q._instances.indexOf(this);Y>=0&&Q._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Q._permanentFailureMillisSinceLastIncomingData,Q._permanentFailureAttempt,Q._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const P=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const F=W<R.length?R[W]:R[R.length-1];try{if(F>0){const Y=T(F);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,Y)),this._options.logService.info(`${P} waiting for ${F} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${P} resolving connection...`);const H=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${P} connecting to ${H.connectTo}...`),await this._reconnect(H,h(g)),this._options.logService.info(`${P} reconnected!`),this._onDidStateChange.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,U.isCancellationError)(H)){this._options.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,S.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(P,R,W){this._reconnectionFailureIsFatal?Q.triggerPermanentFailure(P,R,W):this._gotoPermanentFailure(P,R,W)}_gotoPermanentFailure(P,R,W){this._onDidStateChange.fire(new G(this.reconnectionToken,P,R,W)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Q;class B extends Q{constructor(P,R,W,F,H){super(1,P,F,H,!0),this.client=this._register(new C.Client(H,{remoteAuthority:R,clientId:W},P.ipcLogger))}async _reconnect(P,R){await s(P,R)}}e.ManagementPersistentConnection=B;class K extends Q{constructor(P,R,W,F,H){super(2,P,W,F,!1),this._startArguments=R,this.debugPort=H}async _reconnect(P,R){await i(P,this._startArguments,R)}}e.ExtensionHostPersistentConnection=K;function V(q){try{q.acceptDisconnect();const P=q.getSocket();q.dispose(),P.dispose()}catch(P){(0,U.onUnexpectedError)(P)}}function z(q){if(q&&q.type==="error"){const P=new Error(`Connection error: ${q.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function x(q,P){for(;q.length<P;)q+=" ";return q}function ee(q,P){return`[remote-connection][${x(m(q),13)}][${P.substr(0,5)}\u2026]`}function ne(q,P,R){return`${ee(q,P)}[${R?"reconnect":"initial"}]`}function re(q,P){return`${ne(P,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function J(q){return`${Date.now()-q} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.factories={}}register(_,L){return this.factories[_]??=[],this.factories[_].push(L),(0,k.toDisposable)(()=>{const I=this.factories[_]?.indexOf(L);typeof I=="number"&&I>=0&&this.factories[_]?.splice(I,1)})}getSocketFactory(_){return(this.factories[_.type]||[]).find(I=>I.supports(_))}connect(_,L,I,f){const D=this.getSocketFactory(_);if(!D)throw new Error(`No socket factory found for ${_}`);return D.connect(_,L,I,f)}}e.RemoteSocketFactoryService=A}),define(oe[214],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var A;(function(U){U.disconnected=_=>({type:"disconnected",onTokenFailed:_}),U.connected=(_,L)=>({type:"connected",info:_,serviceInstallFailed:L}),U.connecting=_=>({type:"connecting",progress:_}),U.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,49,4,7,40]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");class D{constructor(b){this.original=b}toJSON(){if(!this.headers){const b=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.original[t];this.headers=b}return this.headers}}class C extends A.Disposable{constructor(b){super(),this.counter=0,this.logger=b.createLogger("network",{name:(0,U.localize)(0,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async logAndRequest(b,t,a){const n=`${b} #${++this.counter}: ${t.url}`;this.logger.trace(`${n} - begin`,t.type,new D(t.headers??{}));try{const s=await a();return this.logger.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${n} - error`,t.type,(0,O.getErrorMessage)(s)),s}}}e.AbstractRequestService=C;function S(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=S;function c(p){return p.res.statusCode===204}e.hasNoContent=c;async function g(p){return c(p)?null:(await(0,k.streamToBuffer)(p.stream)).toString()}e.asText=g;async function y(p){if(!S(p))throw new Error("Server returned "+p.res.statusCode);return g(p)}e.asTextOrError=y;async function m(p){if(!S(p))throw new Error("Server returned "+p.res.statusCode);if(c(p))return null;const t=(await(0,k.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=m;function h(p){u(p)}e.updateProxyConfigurationsScope=h;let l;function u(p){const b=f.Registry.as(_.Extensions.Configuration),t=l;l={id:"http",order:15,title:(0,U.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,U.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,U.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,U.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,U.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,U.localize)(6,null),(0,U.localize)(7,null),(0,U.localize)(8,null),(0,U.localize)(9,null)],default:"override",description:(0,U.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,U.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,U.localize)(12,null),restricted:!0}}},b.updateConfigurations({add:[l],remove:t?[t]:[]})}u(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(I,f){this.requestService=I,this.fileService=f}async download(I,f,D=k.CancellationToken.None){if(I.scheme===O.Schemas.file||I.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(I,f);return}const C={type:"GET",url:I.toString(!0)},S=await this.requestService.request(C,D);if(S.res.statusCode===200)await this.fileService.writeFile(f,S.stream);else{const c=await(0,U.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${c}`)}}};e.DownloadService=_,e.DownloadService=_=ye([X(0,U.IRequestService),X(1,A.IFileService)],_)}),define(oe[216],ae([0,1,15,26]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(L){this.service=L}listen(L,I){throw new Error("Invalid listen")}call(L,I,f,D=O.CancellationToken.None){switch(I){case"request":return this.service.request(f[0],D).then(async({res:C,stream:S})=>{const c=await(0,k.streamToBuffer)(S);return[{statusCode:C.statusCode,headers:C.headers},c]});case"resolveProxy":return this.service.resolveProxy(f[0])}throw new Error("Invalid call")}}e.RequestChannel=A;class U{constructor(L){this.channel=L}async request(L,I){const[f,D]=await this.channel.call("request",[L],I);return{res:f,stream:(0,k.bufferToStream)(D)}}async resolveProxy(L){return this.channel.call("resolveProxy",[L])}}e.RequestChannelClient=U}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class k{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(A){try{const U=await this.getValidator();if(U){const _=String(k._nextId++);return this.validators.set(_,U),{id:_,data:U.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,U){if(!A.id)return!0;const _=this.validators.get(A.id);if(!_)return!1;this.validators.delete(A.id);try{return _.validate(U)==="ok"}catch{return!1}finally{_.dispose?.()}}async sign(A){try{return await this.signValue(A)}catch{}return A}}e.AbstractSignService=k}),define(oe[106],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[219],ae([0,1,218]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends k.AbstractSignService{getValidator(){return this.vsda().then(U=>new U.validator)}signValue(U){return this.vsda().then(_=>new _.signer().sign(U))}vsda(){return new Promise((U,_)=>te(["vsda"],U,_))}}e.SignService=O}),define(oe[75],ae([0,1,3,2]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends O.Disposable{constructor(C,S,c){super(),this.channel=C,this.profile=S,this.workspace=c}async getItems(){const C={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",C);return new Map(S)}updateItems(C){const S={profile:this.profile,workspace:this.workspace};return C.insert&&(S.insert=Array.from(C.insert.entries())),C.delete&&(S.delete=Array.from(C.delete.values())),this.channel.call("updateItems",S)}optimize(){const C={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",C)}}class U extends A{constructor(C,S){super(C,S,void 0),this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(C=>this.onDidChangeStorage(C)))}onDidChangeStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class _ extends U{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class L extends U{constructor(C,S){super(C,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=L;class I extends A{constructor(C,S){super(C,void 0,S),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class f{constructor(C){this.channel=C}isUsed(C){const S={payload:C,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=f}),define(oe[107],ae([0,1,6,37,32]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function U(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function _(I,f,D,C,S,c,g,y){const m=Object.create(null);m["common.machineId"]=c,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=C,m.version=S,m["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,k.PlatformToString)(k.platform),m["common.nodePlatform"]=O.platform,m["common.nodeArch"]=D,m["common.product"]=y||"desktop",g&&(m["common.msftInternal"]=g);let h=0;const l=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),k.isLinuxSnap&&(m["common.snap"]="true");const u=U(f);return u&&(m["common.platformDetail"]=u),m}e.resolveCommonProperties=_;function L(I){const f=O.env.USERDNSDOMAIN;if(!f)return!1;const D=f.toLowerCase();return I.some(C=>D===C)}e.verifyMicrosoftInternalDomain=L}),define(oe[22],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(U){U[U.NONE=0]="NONE",U[U.CRASH=1]="CRASH",U[U.ERROR=2]="ERROR",U[U.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var A;(function(U){U.OFF="off",U.CRASH="crash",U.ERROR="error",U.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[220],ae([0,1,36,5,35,23,16,6,10,132,31,146,95,11,24,22]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function h(t,a){const n=`${t}::${a.join(":")}`,s=m.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,w=2e4;function E(v,T,N,M){const $=T.substring(v.length+1);return O.Promises.withAsyncBody(async j=>{let Z;try{Z=await D.Promises.readdir(T,{withFileTypes:!0})}catch{j();return}if(M.count>=w){M.count+=Z.length,M.maxReached=!0,j();return}let G=Z.length;if(G===0){j();return}let Q=Z;M.count+Z.length>w&&(M.maxReached=!0,G=w-M.count,Q=Z.slice(0,G)),M.count+=Z.length;for(const B of Q)if(B.isDirectory()){if(N.includes(B.name)||await E(v,(0,_.join)(T,B.name),N,M),--G===0){j();return}}else{const K=B.name.lastIndexOf(".");if(K>=0){const V=B.name.substring(K+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of i)V.relativePathPattern?.test($)!==!1&&V.filePattern.test(B.name)&&o.set(V.tag,(o.get(V.tag)??0)+1);if(--G===0){j();return}}})}const d=O.Promises.withAsyncBody(async v=>{const T={count:0,maxReached:!1};await E(t,t,a,T);const N=await p(t);v({configFiles:l(o),fileTypes:l(r),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:N})});return m.set(n,d),d}e.collectWorkspaceStats=h;function l(t){return Array.from(t.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function u(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.virtualMachineHint.value()*100)}%`},a=k.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=u;async function p(t){try{const a=new Map,n=(0,_.join)(t,".vscode","launch.json"),s=await D.Promises.readFile(n),i=[],r=(0,A.parse)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,A.getNodeType)(r)==="object"&&r.configurations)for(const o of r.configurations){const w=o.type;w&&(a.has(w)?a.set(w,a.get(w)+1):a.set(w,1))}return l(a)}catch{return[]}}e.collectLaunchConfigs=p;let b=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),L.isWindows||n.push(`Load (avg):       ${k.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(f.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,C.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async s=>{let[i,r]=s,o=this.formatProcessList(a,i);return n.forEach(w=>{if((0,S.isRemoteDiagnosticError)(w))o+=`
${w.errorMessage}`,r+=`
${w.errorMessage}`;else if(o+=`

Remote: ${w.hostName}`,w.processes&&(o+=`
${this.formatProcessList(a,w.processes)}`),w.workspaceMetadata){r+=`
|  Remote: ${w.hostName}`;for(const E of Object.keys(w.workspaceMetadata)){const d=w.workspaceMetadata[E];let v=`${d.fileCount} files`;d.maxFilesReached&&(v=`more than ${v}`),r+=`|    Folder (${E}): ${v}`,r+=this.formatWorkspaceStats(d)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:s,vmHint:i,os:r,cpus:o}=u(),w={os:r,memory:s,cpus:o,vmHint:i,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return L.isWindows||(w.load=`${k.loadavg().map(E=>Math.round(E)).join(", ")}`),L.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(a,n){const s=[];return(0,C.listProcesses)(a.mainPID).then(async i=>(s.push(""),s.push(this.formatEnvironment(a)),s.push(""),s.push(this.formatProcessList(a,i)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(a))),n.forEach(r=>{if((0,S.isRemoteDiagnosticError)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.formatMachineInfo(r.machineInfo)),r.processes&&s.push(this.formatProcessList(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const w=r.workspaceMetadata[o];let E=`${w.fileCount} files`;w.maxFilesReached&&(E=`more than ${E}`),s.push(`Folder (${o}): ${E}`),s.push(this.formatWorkspaceStats(w))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(a){const n=[];let i=0;const r=(d,v)=>{const T=` ${d}(${v})`;i+T.length>60?(n.push(o),o="|                 ",i=o.length):i+=T.length,o+=T};let o="|      File types:";const w=10,E=a.fileTypes.length>w?w:a.fileTypes.length;for(let d=0;d<E;d++){const v=a.fileTypes[d];r(v.name,v.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",i=0,a.configFiles.forEach(d=>{r(d.name,d.count)}),n.push(o)),a.launchConfigFiles.length>0){let d="|      Launch Configs:";a.launchConfigFiles.forEach(v=>{const T=v.count>1?` ${v.name}(${v.count})`:` ${v.name}`;d+=T}),n.push(d)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(s=>s.length));return Object.keys(a).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${a[s]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],s=[];return a.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const o=I.URI.revive(r);if(o.scheme===U.Schemas.file){const w=o.fsPath;s.push(h(w,["node_modules",".git"]).then(E=>{let d=`${E.fileCount} files`;E.maxFilesReached&&(d=`more than ${d}`),n.push(`|    Folder (${(0,_.basename)(w)}): ${d}`),n.push(this.formatWorkspaceStats(E))}).catch(E=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${E.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(a,n){const s=new Map;a.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>s.set(r,o));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,s,i,n,0),i.join(`
`)}formatProcessItem(a,n,s,i,r){const o=r===0;let w;o?w=i.pid===a?`${this.productService.applicationName} main`:"remote agent":n.has(i.pid)?w=n.get(i.pid):w=`${"  ".repeat(r)} ${i.name}`;const E=process.platform==="win32"?i.mem:k.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(E/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(i.children)&&i.children.forEach(d=>this.formatProcessItem(a,n,s,d,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:s}of a.folders){const i=I.URI.revive(s);if(i.scheme!==U.Schemas.file)continue;const r=i.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const s=I.URI.revive(n);if(s.scheme!==U.Schemas.file)continue;const i=s.fsPath;try{const r=await h(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.DiagnosticsService=b,e.DiagnosticsService=b=ye([X(0,y.ITelemetryService),X(1,g.IProductService)],b)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(U){this.appenders=U}listen(U,_){throw new Error(`Event not found: ${_}`)}call(U,_,{eventName:L,data:I}){return this.appenders.forEach(f=>f.log(L,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class O{constructor(U){this.channel=U}log(U,_){return this.channel.call("log",{eventName:U,data:_}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(oe[45],ae([0,1,30,12,3,19,74,107,22]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class f{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=f;class D{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class C{async publicLog(i,r,o){}async publicLogError(i,r,o){}}e.NullEndpointTelemetryService=C,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(s,i){return A.Event.debounce(i.onDidChangeConfiguration,(o,w)=>{const E=o?new Set([...o.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:E}},1e3,!0)(o=>{o.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,U.ConfigurationTargetToString)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.configurationTelemetry=S;function c(s,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!s.enableTelemetry)}e.supportsTelemetry=c;function g(s,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=g;function y(s){const i=s.getValue(I.TELEMETRY_SETTING_ID),r=s.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function m(s){const i={},r={},o={};u(s,o);for(let w in o){w=w.length>150?w.substr(w.length-149):w;const E=o[w];typeof E=="number"?r[w]=E:typeof E=="boolean"?r[w]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${E.length}`),i[w]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(i[w]=E)}return{properties:i,measurements:r}}e.validateTelemetryData=m;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(s){if(!s)return"none";const i=(0,_.getRemoteName)(s);return h.has(i)?i:"other"}e.cleanRemoteAuthority=l;function u(s,i,r=0,o){if(s)for(const w of Object.getOwnPropertyNames(s)){const E=s[w],d=o?o+w:w;Array.isArray(E)?i[d]=(0,k.safeStringify)(E):E instanceof Date?i[d]=E.toISOString():(0,O.isObject)(E)?r<2?u(E,i,r+1,d+"."):i[d]=(0,k.safeStringify)(E):i[d]=E}}function p(s,i){const r=s.msftInternalDomains||[],o=i.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(r)||o}e.isInternalTelemetry=p;function b(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=b;function t(s,i){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const o=[];for(const v of i)for(;;){const T=v.exec(s);if(!T)break;o.push([T.index,v.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(r="";;){const v=E.exec(s);if(!v)break;const T=o.some(([N,M])=>v.index<M&&N<E.lastIndex);!w.test(v[0])&&!T&&(r+=s.substring(d,v.index)+"<REDACTED: user-file-path>",d=E.lastIndex)}return d<s.length&&(r+=s.substr(d)),r}function a(s){if(!s)return s;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,i){return(0,k.cloneAndChange)(s,r=>{if(r instanceof f||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=t(o,i);for(const w of i)o=o.replace(w,"");return o=a(o),o}})}e.cleanData=n}),define(oe[33],ae([0,1,27,29,44,6,10,8,37,45]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,k.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=D;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new S(s.identifier,i,r)}static parse(s){const i=C.exec(s);return i&&i[1]&&i[2]?new S({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof S?D(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=S;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const s=c.exec(n);return s&&s[1]?[m(s[1]),s[2]]:[m(n),void 0]}e.getIdAndVersion=g;function y(n,s){return`${n}.${s}`}e.getExtensionId=y;function m(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=m;function h(n,s){return m(y(n??A.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=h;function l(n,s){const i=[],r=o=>{for(const w of i)if(w.some(E=>D(s(E),s(o))))return w;return null};for(const o of n){const w=r(o);w?w.push(o):i.push([o])}return i}e.groupByExtension=l;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=u;function p(n){return{id:new f.TelemetryTrustedValue(n.identifier.id),name:new f.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function b(n,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&i.every(w=>!D(w.identifier,{id:o}))){const w=n.filter(E=>D(E.identifier,{id:o}));w.length===1&&(i.push(w[0]),r.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=b;async function t(n,s){if(!U.isLinux)return!1;let i;try{i=(await n.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){s.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(o))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,s){const i=await t(n,s),r=(0,O.getTargetPlatform)(i?"alpine":U.platform,I.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=a}),define(oe[221],ae([0,1,18,2,21,10,11,24,5,3,16,6,37,33]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let g=class extends O.Disposable{constructor(u,p){super(),this.fileService=u,this.productService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,b])=>this.allConfigBasedTips.set(b.configPath,b))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const p=[];for(const[b,t]of this.allConfigBasedTips)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const a=(await this.fileService.readFile((0,A.joinPath)(u,b))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(a))&&p.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return p}};e.ExtensionTipsService=g,e.ExtensionTipsService=g=ye([X(0,_.IFileService),X(1,L.IProductService)],g);const y="extensionTips/promptedExecutableTips",m="extensionTips/lastPromptedMediumImpExeTime";class h extends g{constructor(u,p,b,t,a,n,s,i){super(s,i),this.userHome=u,this.windowEvents=p,this.telemetryService=b,this.extensionManagementService=t,this.storageService=a,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,o])=>{const w=[],E=[],d=[];Object.entries(o.recommendations).forEach(([v,T])=>{T.important?o.important?w.push({extensionId:v,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):E.push({extensionId:v,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):d.push({extensionId:v,extensionName:T.name,isExtensionPack:!!T.isExtensionPack})}),w.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:w}),E.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:E}),d.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:d})}),(0,I.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),p=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...p]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),p=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),b=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,b),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(p,b)}groupImportantTipsByExe(u,p){const b=new Map;u.forEach(i=>b.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:a}=this.groupByInstalled([...b.keys()],p);for(const i of t){const r=b.get(i);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of a){const r=b.get(i);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),s=new Map;for(const i of a){const r=b.get(i);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=s.get(r.exeName);o||(o=[],s.set(r.exeName,o)),o.push(r)}}return s}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,p]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(b=>{switch(b){case"reacted":this.addToRecommendedExecutables(p[0].exeName,p);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":{const t=f.Event.once(f.Event.latch(f.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(t(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const t=this._register(new O.MutableDisposable);t.value=(0,I.disposableTimeout)(()=>{t.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),p=Date.now()-u,b=7*24*60*60*1e3;if(p<b){const n=this._register(new O.MutableDisposable);n.value=(0,I.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},b-p);return}const[t,a]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(t),this.addToRecommendedExecutables(a[0].exeName,a);const s=this._register(new O.MutableDisposable);s.value=(0,I.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},b);break}case"ignored":this.mediumImportanceTipsByExe.delete(t),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(s(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new O.MutableDisposable);s.value=(0,I.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(u){const p=await this.extensionManagementService.getInstalled(1),b=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(a=>p.every(n=>!(0,c.areSameExtensions)(n.identifier,{id:a})))).map(({extensionId:t})=>t.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:b,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(m,-1);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(m,u,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(y,-1,"{}"))}addToRecommendedExecutables(u,p){const b=this.getPromptedExecutableTips();b[u]=p.map(({extensionId:t})=>t.toLowerCase()),this.storageService.store(y,JSON.stringify(b),-1,0)}groupByInstalled(u,p){const b=[],t=[],a=p.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return u.forEach(n=>{a.has(n.toLowerCase())?b.push(n):t.push(n)}),{installed:b,uninstalled:t}}async getValidExecutableBasedExtensionTips(u){const p=[],b=new Map;for(const t of u.keys()){const a=u.get(t);if(!a||!(0,k.isNonEmptyArray)(a.recommendations))continue;const n=[];C.isWindows?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>S.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>S.env.ProgramFiles).replace("%APPDATA%",()=>S.env.APPDATA).replace("%WINDIR%",()=>S.env.WINDIR)):(n.push((0,D.join)("/usr/local/bin",t)),n.push((0,D.join)("/usr/bin",t)),n.push((0,D.join)(this.userHome.fsPath,t)));for(const s of n){let i=b.get(s);if(i===void 0&&(i=await this.fileService.exists(U.URI.file(s)),b.set(s,i)),i)for(const{extensionId:r,extensionName:o,isExtensionPack:w,whenNotInstalled:E}of a.recommendations)p.push({extensionId:r,extensionName:o,isExtensionPack:w,exeName:t,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:E})}}return p}}e.AbstractNativeExtensionTipsService=h}),define(oe[222],ae([0,1,26,33]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function A(U,_,L,I,f){try{const D=await U.getExtensionsControlManifest();if(!D.deprecated)return;const C=await U.getInstalled(1);for(const[S,c]of Object.entries(D.deprecated)){if(!c?.extension)continue;const{id:g,autoMigrate:y,preRelease:m}=c.extension;if(!y)continue;const h=C.find(u=>(0,O.areSameExtensions)(u.identifier,{id:S}));if(!h)continue;const l=(await _.getExtensions([{id:g,preRelease:m}],{targetPlatform:await U.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!l){f.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{f.info(`Migrating '${h.identifier.id}' extension to '${g}' extension...`);const u=!I.getDisabledExtensions().some(b=>(0,O.areSameExtensions)(b,h.identifier));await U.uninstall(h),f.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let p=C.find(b=>(0,O.areSameExtensions)(b.identifier,{id:g}));(!p||!p.isPreReleaseVersion&&u)&&(p=await U.installFromGallery(l,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${p.identifier.id}'`),u||(await I.disableExtension(p.identifier),f.info(`Disabled the pre-release extension '${p.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),y.storage&&(L.addToMigrationList((0,O.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,O.getExtensionId)(p.manifest.publisher,p.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${h.identifier.id}' extension to '${g}' extension.`)}catch(u){f.error(u)}}}catch(D){f.error(D)}}e.migrateUnsupportedExtensions=A}),define(oe[223],ae([0,1,3,2,34,33,44]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class L extends O.Disposable{constructor(f,D,C,S,c,g,y){super(),this.extensionManagementService=f,this.extensionsScannerService=D,this.userDataProfilesService=C,this.extensionsProfileScannerService=S,this.uriIdentityService=c,this.fileService=g,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,m=>y.error(m))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(f=>this.onDidChangeProfiles(f.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(f=>this.onAddExtensions(f))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(f=>this.onDidAddExtensions(f))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(f=>this.onRemoveExtensions(f))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(f=>this.onDidRemoveExtensions(f))),this._register(this.fileService.onDidFilesChange(f=>this.onDidFilesChange(f)))}async onDidChangeProfiles(f){try{f.length&&await Promise.all(f.map(D=>(this.extensionsProfileWatchDisposables.set(D.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(D.extensionsResource)),this.fileService.watch(D.extensionsResource))),this.populateExtensionsFromProfile(D.extensionsResource))))}catch(D){throw this.logService.error(D),D}}async onAddExtensions(f){for(const D of f.extensions)this.addExtensionWithKey(this.getKey(D.identifier,D.version),f.profileLocation)}async onDidAddExtensions(f){for(const D of f.extensions){const C=this.getKey(D.identifier,D.version);f.error?this.removeExtensionWithKey(C,f.profileLocation):this.addExtensionWithKey(C,f.profileLocation)}}async onRemoveExtensions(f){for(const D of f.extensions)this.removeExtensionWithKey(this.getKey(D.identifier,D.version),f.profileLocation)}async onDidRemoveExtensions(f){const D=[],C=[];for(const S of f.extensions){const c=this.getKey(S.identifier,S.version);f.error?this.addExtensionWithKey(c,f.profileLocation):(this.removeExtensionWithKey(c,f.profileLocation),this.allExtensions.has(c)||(this.logService.debug("Extension is removed from all profiles",S.identifier.id,S.version),C.push(this.extensionManagementService.scanInstalledExtensionAtLocation(S.location).then(g=>{g?D.push(g):this.logService.info("Extension not found at the location",S.location.toString())},g=>this.logService.error(g)))))}try{await Promise.all(C),D.length&&await this.uninstallExtensionsNotInProfiles(D)}catch(S){this.logService.error(S)}}onDidFilesChange(f){for(const D of this.userDataProfilesService.profiles)f.contains(D.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(D.extensionsResource)}async onDidExtensionsProfileChange(f){const D=[],C=[],S=await this.extensionsProfileScannerService.scanProfileExtensions(f),c=new Set,g=new Set;for(const[y,m]of this.allExtensions)m.has(f)&&g.add(y);for(const y of S){const m=this.getKey(y.identifier,y.version);c.add(m),g.has(m)||(D.push(y.identifier),this.addExtensionWithKey(m,f))}for(const y of g)if(!c.has(y)){const m=this.fromKey(y);m&&(C.push(m.identifier),this.removeExtensionWithKey(y,f))}(D.length||C.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D.length?{extensions:D,profileLocation:f}:void 0,removed:C.length?{extensions:C,profileLocation:f}:void 0})}async populateExtensionsFromProfile(f){const D=await this.extensionsProfileScannerService.scanProfileExtensions(f);for(const C of D)this.addExtensionWithKey(this.getKey(C.identifier,C.version),f)}async uninstallExtensionsNotInProfiles(f){f||(f=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(C=>!this.allExtensions.has(this.getKey(C.identifier,C.manifest.version)))),f.length&&await this.extensionManagementService.markAsUninstalled(...f)}addExtensionWithKey(f,D){let C=this.allExtensions.get(f);C||this.allExtensions.set(f,C=new A.ResourceSet(S=>this.uriIdentityService.extUri.getComparisonKey(S))),C.add(D)}removeExtensionWithKey(f,D){const C=this.allExtensions.get(f);C&&C.delete(D),C?.size||this.allExtensions.delete(f)}getKey(f,D){return`${_.ExtensionIdentifier.toKey(f.id)}@${D}`}fromKey(f){const[D,C]=(0,U.getIdAndVersion)(f);return C?{identifier:{id:D},version:C}:void 0}}e.ExtensionsWatcher=L}),define(oe[224],ae([0,1,43,45]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function A(U,_,L,I,f,D,C){const S={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${_.nameShort})`};if((0,O.supportsTelemetry)(_,L)&&(0,O.getTelemetryLevel)(I)===3){const c=await(0,k.getServiceMachineId)(L,f,D);S["X-Market-User-Id"]=c,S["VSCode-SessionId"]=C.machineId||c}return S}e.resolveMarketplaceHeaders=A}),define(oe[225],ae([0,1,69,18,5,2,23,16,31,14,29,33,7,72,10]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends c.LanguagePackBaseService{constructor(u,p,b,t){super(b),this.extensionManagementService=u,this.logService=t,this.cache=this._register(new m(p,t)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getBuiltInExtensionTranslationsUri(u,p){const t=(await this.cache.getLanguagePacks())[p];if(!t){this.logService.warn(`No language pack found for ${p}`);return}const a=t.translations[u];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),p=Object.keys(u).map(b=>{const t=u[b];return{...this.createQuickPickItem(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((b,t)=>b.label.localeCompare(t.label)),p}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const p=await this.cache.getLanguagePacks();Object.keys(p).some(b=>p[b]&&p[b].extensions.some(t=>(0,C.areSameExtensions)(t.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),b=await this.cache.update(p);return!(0,O.equals)(Object.keys(u),Object.keys(b))}};e.NativeLanguagePackService=y,e.NativeLanguagePackService=y=ye([X(0,D.IExtensionManagementService),X(1,f.INativeEnvironmentService),X(2,D.IExtensionGalleryService),X(3,S.ILogService)],y);let m=class extends U.Disposable{constructor(u,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new A.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(p=>{Object.keys(p).forEach(b=>delete p[b]),this.createLanguagePacksFromExtensions(p,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...p){for(const b of p)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,b);Object.keys(u).forEach(b=>this.updateHash(u[b]))}createLanguagePacksFromExtension(u,p){const b=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===_.Schemas.file&&h(a)){let n=u[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},u[a.languageId]=n);const s=n.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,b))[0];s?s.version=p.manifest.version:n.extensions.push({extensionIdentifier:b,version:p.manifest.version});for(const i of a.translations)n.translations[i.id]=(0,L.join)(p.location.fsPath,i.path)}}updateHash(u){if(u){const p=(0,k.createHash)("md5");for(const b of u.extensions)p.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);u.hash=p.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(p=u(b),b)).then(b=>{for(const a of Object.keys(b))b[a]||delete b[a];this.languagePacks=b,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),I.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>p,b=>this.logService.error(b))})}};m=ye([X(0,f.INativeEnvironmentService),X(1,S.ILogService)],m);function h(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,143,8,30,45]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const _="https://0.0.0.0/OneCollector/1.0",L="https://0.0.0.0/ping";async function I(D,C,S){const c=await(0,k.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,k.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new c.AppInsightsCore,m=new g.PostChannel,h={instrumentationKey:D,endpointUrl:_,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(S){h.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:S};h.extensionConfig[m.identifier]=l}return y.initialize(h,[]),y.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),y}class f{constructor(C,S,c,g,y){this._isInternalTelemetry=C,this._eventPrefix=S,this._defaultData=c,this._xhrOverride=y,this.endPointUrl=_,this.endPointHealthUrl=L,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(C){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){C(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=I(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(S=>{C(S)},S=>{(0,O.onUnexpectedError)(S),console.error(S)})}}log(C,S){if(!this._aiCoreOrKey)return;S=(0,A.mixin)(S,this._defaultData),S=(0,U.validateTelemetryData)(S);const c=this._eventPrefix+"/"+C;try{this._withAIClient(g=>{g.pluginVersionString=S?.properties.version??"Unknown",g.track({name:c,baseData:{name:c,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(C=>{this._withAIClient(S=>{S.unload(!0,()=>{this._aiCoreOrKey=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends k.Disposable{constructor(D,C,S,c,g=""){super(),this.prefix=g;const y=C.getLogger(L.telemetryLogId);if(y)this.logger=this._register(y);else{const h=(0,L.isLoggingOnly)(c,S)?" (Not Sent)":"",l=()=>(0,L.supportsTelemetry)(c,S)&&D.getLevel()===U.LogLevel.Trace;this.logger=this._register(C.createLogger(L.telemetryLogId,{name:(0,O.localize)(0,null,h),hidden:!l()})),this._register(D.onDidChangeLogLevel(()=>C.setVisibility(L.telemetryLogId,l()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(D,C){this.logger.trace(`${this.prefix}telemetry/${D}`,(0,L.validateTelemetryData)(C))}};e.TelemetryLogAppender=I,e.TelemetryLogAppender=I=ye([X(0,U.ILogService),X(1,U.ILoggerService),X(2,A.IEnvironmentService),X(3,_.IProductService)],I)}),define(oe[110],ae([0,1,2,30,6,27,168,19,49,102,24,40,22,45]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,l,u){this._configurationService=l,this._productService=u,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,U.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,U.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(S.TELEMETRY_SETTING_ID)||p.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(h,l){this._experimentProperties[h]=l}_updateTelemetryLevel(){let h=(0,c.getTelemetryLevel)(this._configurationService);const l=this._productService.enabledTelemetryLevels;if(l){this._sendErrorTelemetry=this.sendErrorTelemetry?l.error:!1;const u=l.usage?3:l.error?2:0;h=Math.min(h,u)}this._telemetryLevel=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(h,l,u){this._telemetryLevel<l||(u=(0,O.mixin)(u,this._experimentProperties),u=(0,c.cleanData)(u,this._cleanupPatterns),u=(0,O.mixin)(u,this._commonProperties),this._appenders.forEach(p=>p.log(h,u)))}publicLog(h,l){this._log(h,3,l)}publicLog2(h,l){this.publicLog(h,l)}publicLogError(h,l){this._sendErrorTelemetry&&this._log(h,2,l)}publicLogError2(h,l){this.publicLogError(h,l)}};e.TelemetryService=g,e.TelemetryService=g=ye([X(1,L.IConfigurationService),X(2,D.IProductService)],g);function y(){const m=(0,_.localize)(0,null,f.default.nameLong),h=f.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=A.isWeb?"":(0,_.localize)(3,null),u=(0,_.localize)(4,null),p=(0,_.localize)(5,null),b=(0,_.localize)(6,null),t=(0,_.localize)(7,null),a=`
|       | ${u} | ${p} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,_.localize)(8,null);return`
${m} ${h} ${l}

&nbsp;

${t}
${a}

&nbsp;

${n}
`}C.Registry.as(I.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(I.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,_.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,_.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function _(D,C){const S=await C.request(D,O.CancellationToken.None),c=(await(0,k.streamToBuffer)(S.stream)).toString(),g=S.res.statusCode??200;return{headers:S.res.headers,statusCode:g,responseData:c}}async function L(D){const C={method:D.type,headers:D.headers};return new Promise((c,g)=>{const y=A.request(D.url??"",C,m=>{m.on("data",function(h){c({headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()})}),m.on("error",function(h){g(h)})});y.write(D.data,m=>{m&&g(m)}),y.end()})}async function I(D,C,S){const c=typeof C.data=="string"?C.data:new TextDecoder().decode(C.data),g={type:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data).toString()},url:C.urlString,data:c};try{const y=D?await _(g,D):await L(g);S(y.statusCode,y.headers,y.responseData)}catch{S(0,{})}}class f extends U.AbstractOneDataSystemAppender{constructor(C,S,c,g,y){const m={sendPOST:(h,l)=>{I(C,h,l)}};super(S,c,g,y,m)}}e.OneDataSystemAppender=f}),define(oe[228],ae([0,1,23,93,19,14,7,24,22,108,109,110]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(g,y,m,h,l,u){this.configurationService=g,this.telemetryService=y,this.logService=m,this.loggerService=h,this.environmentService=l,this.productService=u,this.customTelemetryServices=new Map}getCustomTelemetryService(g){if(!this.customTelemetryServices.has(g.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.telemetryService.machineId,y["common.vscodesessionid"]=this.telemetryService.sessionId;const m=[g.id,JSON.stringify(y),g.aiKey],l=new O.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new f.TelemetryAppenderClient(l),new D.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${g.id}] `)];this.customTelemetryServices.set(g.id,new C.TelemetryService({appenders:u,sendErrorTelemetry:g.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(g.id)}publicLog(g,y,m){this.getCustomTelemetryService(g).publicLog(y,m)}publicLogError(g,y,m){this.getCustomTelemetryService(g).publicLogError(y,m)}};e.CustomEndpointTelemetryService=S,e.CustomEndpointTelemetryService=S=ye([X(0,A.IConfigurationService),X(1,I.ITelemetryService),X(2,_.ILogService),X(3,_.ILoggerService),X(4,U.IEnvironmentService),X(5,L.IProductService)],S)}),define(oe[76],ae([0,1,3,19,4,7]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var _;(function(m){m.Http="http",m.Https="https"})(_||(e.TunnelProtocol=_={}));var L;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(L||(e.TunnelPrivacyId=L={}));function I(m){return!!m.forwardPort}e.isTunnelProvider=I;var f;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function D(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=S;function c(m,h,l,u){if(l===1)return!1;if(l===2&&S(h)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(p?.length===4&&parseInt(p[1])>=18)return!1}return m<1024}e.isPortPrivileged=c;class g{constructor(h,l,u){this.remoteAddress=h,this.localAddress=l,this._dispose=u,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let y=class{constructor(h,l){this.logService=h,this.configurationService=l,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const h=this.configurationService.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],l=Array.from(this._tunnels.values());for(const u of l){const p=Array.from(u.values());for(const b of p){const t=await b.value;t&&typeof t!="string"&&h.push(t)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:l}of h.values())await l.then(u=>typeof u!="string"?u?.dispose():void 0);h.clear()}this._tunnels.clear()}setEnvironmentTunnel(h,l,u,p,b){this.addTunnelToMap(h,l,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:l,localAddress:u,privacy:p,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,l){(S(h)||C(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(h,l);if(u)return++u.refcount,u.value}openTunnel(h,l,u,p,b,t=!1,a,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${u} on local port ${b}.`);const s=this._tunnelProvider??h;if(!s)return;if(l||(l="localhost"),p||(p=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(s,l,u,p,b,t,a,n);return i?i.then(r=>{if(r){if(typeof r=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(l,u),r}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(l,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(r);return(r.tunnelRemoteHost!==l||r.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const l=this._tunnels.get(h.tunnelRemoteHost);if(l){const u=l.get(h.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,u))}}}}async tryDisposeTunnel(h,l,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${l}.`);const p=u.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(l),p}}async closeTunnel(h,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${l} `);const u=this._tunnels.get(h);if(u&&u.has(l)){const p=u.get(l);p.refcount=0,await this.tryDisposeTunnel(h,l,p)}}addTunnelToMap(h,l,u){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(l,{refcount:1,value:u})}async removeEmptyOrErrorTunnelFromMap(h,l){const u=this._tunnels.get(h);if(u){const p=u.get(l),b=p?await p.value:void 0;(!b||typeof b=="string")&&u.delete(l),u.size===0&&this._tunnels.delete(h)}}getTunnelFromMap(h,l){const u=[h];C(h)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):S(h)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const p=u.map(b=>this._tunnels.get(b));for(const b of p){const t=b?.get(l);if(t)return t}}canTunnel(h){return!!D(h)}createWithProvider(h,l,u,p,b,t,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${u} on local port ${p}.`);const n=u;this._factoryInProgress.add(n);const s=p===void 0?u:p,i={elevationRequired:b?this.isPortPrivileged(s):!1},r={remoteAddress:{host:l,port:u},localAddressPort:p,privacy:t,public:t?t!==L.Private:void 0,protocol:a},o=h.forwardPort(r,i);return o?(this.addTunnelToMap(l,u,o),o.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),o}};e.AbstractTunnelService=y,e.AbstractTunnelService=y=ye([X(0,U.ILogService),X(1,O.IConfigurationService)],y)}),define(oe[229],ae([0,1,7,76,2,8,5]),function(te,e,k,O,A,U,_){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends A.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(C){this._address=C,this._addressPromise&&(this._addressPromise.complete(C),this._addressPromise=null)}setTunnel(C){this._register(C)}}let f=class extends A.Disposable{static{L=this}static{this._lastId=0}constructor(C,S){super(),this._tunnelService=C,this._logService=S,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++L._lastId)}}async startTunnel(C,S,c,g,y,m,h){const l=new I,u=await Promise.resolve(this._tunnelService.openTunnel(C,l,c,g,y,m,h));if(!u||typeof u=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${g} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(S))throw this._disposedTunnels.delete(S),l.dispose(),await u.dispose(),(0,U.canceled)();return l.setTunnel(u),this._tunnels.set(S,l),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${u.localAddress} (local) to ${c}:${g} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(C,S){const c=this._tunnels.get(C);c&&c.setAddress(S)}async destroyTunnel(C){const S=this._tunnels.get(C);if(S){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this._tunnels.delete(C),await S.dispose();return}this._disposedTunnels.add(C)}};e.SharedProcessTunnelService=f,e.SharedProcessTunnelService=f=L=ye([X(0,O.ISharedTunnelsService),X(1,k.ILogService)],f)}),define(oe[28],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,21,128,3,2]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class f{static{this._clock=0}constructor(S){this.uri=S,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let D=class{constructor(S){this._fileService=S,this._dispooables=new I.DisposableStore,this._limit=2**16;const c=new Map,g=y=>{let m=c.get(y.scheme);return m===void 0&&(m=S.hasProvider(y)&&!this._fileService.hasCapability(y,1024),c.set(y.scheme,m)),m};this._dispooables.add(L.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(y=>{c.delete(y.scheme)})),this.extUri=new U.ExtUri(g),this._canonicalUris=new _.SkipList((y,m)=>this.extUri.compare(y,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,U.normalizePath)(S));const c=this._canonicalUris.get(S);return c?c.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new f(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((g,y)=>g[1].time<y[1].time?1:g[1].time>y[1].time?-1:0);f._clock=0,this._canonicalUris.clear();const c=this._limit*.5;for(let g=0;g<c;g++)this._canonicalUris.set(S[g][0],S[g][1].touch())}};e.UriIdentityService=D,e.UriIdentityService=D=ye([X(0,A.IFileService)],D),(0,O.registerSingleton)(k.IUriIdentityService,D,1)}),define(oe[231],ae([0,1,3,2,11,47,34]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class L extends O.Disposable{constructor(f,D,C,S,c,g){super(),this.fileSystemScheme=f,this.fileSystemProvider=D,this.userDataScheme=C,this.userDataProfilesService=S,this.uriIdentityService=c,this.logService=g,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=U.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new _.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(S.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const f of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(f.settingsResource),this.atomicReadWriteResources.add(f.keybindingsResource),this.atomicReadWriteResources.add(f.tasksResource),this.atomicReadWriteResources.add(f.extensionsResource)}open(f,D){return this.fileSystemProvider.open(this.toFileSystemResource(f),D)}close(f){return this.fileSystemProvider.close(f)}read(f,D,C,S,c){return this.fileSystemProvider.read(f,D,C,S,c)}write(f,D,C,S,c){return this.fileSystemProvider.write(f,D,C,S,c)}watch(f,D){this.watchResources.set(f,f);const C=this.fileSystemProvider.watch(this.toFileSystemResource(f),D);return(0,O.toDisposable)(()=>{this.watchResources.delete(f),C.dispose()})}stat(f){return this.fileSystemProvider.stat(this.toFileSystemResource(f))}mkdir(f){return this.fileSystemProvider.mkdir(this.toFileSystemResource(f))}rename(f,D,C){return this.fileSystemProvider.rename(this.toFileSystemResource(f),this.toFileSystemResource(D),C)}readFile(f,D){return this.fileSystemProvider.readFile(this.toFileSystemResource(f),D)}readFileStream(f,D,C){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(f),D,C)}readdir(f){return this.fileSystemProvider.readdir(this.toFileSystemResource(f))}enforceAtomicReadFile(f){return this.atomicReadWriteResources.has(f)}writeFile(f,D,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(f),D,C)}enforceAtomicWriteFile(f){return this.atomicReadWriteResources.has(f)?{postfix:".vsctmp"}:!1}delete(f,D){return this.fileSystemProvider.delete(this.toFileSystemResource(f),D)}copy(f,D,C){if((0,A.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(f),this.toFileSystemResource(D),C);throw new Error("copy not supported")}cloneFile(f,D){if((0,A.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(f),this.toFileSystemResource(D));throw new Error("clone not supported")}handleFileChanges(f){const D=[];for(const C of f){if(C.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(C.resource);this.watchResources.findSubstr(S)&&D.push({resource:S,type:C.type})}D.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(D))}toFileSystemResource(f){return f.with({scheme:this.fileSystemScheme})}toUserDataResource(f){return f.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=L}),define(oe[77],ae([0,1,85]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(_,L,I,f){const D=(0,k.setProperty)(_,L,I,f)[0];return D&&(_=_.substring(0,D.offset)+D.content+_.substring(D.offset+D.length)),_}e.edit=O;function A(_,L,I){let f=I;for(;f>=0;){if(_.charAt(f)===L.charAt(L.length-1)&&L.length===1)return f+1;if(f--,L.length===2&&f>=0&&_.charAt(f)===L.charAt(0))return f+2}return 0}e.getLineStartOffset=A;function U(_,L,I){let f=I;for(;f>=0;)if(_.charAt(f)===L.charAt(L.length-1)&&L.length===1||(f++,L.length===2&&f>=0&&_.charAt(f)===L.charAt(1)))return f;return _.length-1}e.getLineEndOffset=U}),define(oe[232],ae([0,1,30,53,12]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function U(c,g,y,m,h,l){const u=[],p=[],b=[];if(!g){const j=c.filter(({identifier:Z})=>h.every(G=>G.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:u,removed:p,updated:b},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}c=c.map(C),g=g.map(C),y=y?y.map(C):null;const t=new Map,a=j=>{j.uuid&&t.set(j.id.toLowerCase(),j.uuid)};c.forEach(({identifier:j})=>a(j)),g.forEach(({identifier:j})=>a(j)),y?.forEach(({identifier:j})=>a(j)),m?.forEach(({identifier:j})=>a(j)),l?.forEach(j=>a(j));const n=j=>{const Z=j.identifier.uuid||t.get(j.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${j.identifier.id.toLowerCase()}`},s=(j,Z)=>(j.set(n(Z),Z),j),i=c.reduce(s,new Map),r=g.reduce(s,new Map),o=g.reduce((j,Z)=>s(j,(0,k.deepClone)(Z)),new Map),w=y?y.reduce(s,new Map):null,E=m.reduce(s,new Map),d=h.reduce((j,Z)=>{const G=t.get(Z.toLowerCase());return j.add(G?`uuid:${G}`:`id:${Z.toLowerCase()}`)},new Set),v=l?l.reduce((j,{id:Z,uuid:G})=>(G=G??t.get(Z.toLowerCase()),j.add(G?`uuid:${G}`:`id:${Z.toLowerCase()}`)),new Set):null,T=_(i,r,d,!1);if(T.added.size>0||T.removed.size>0||T.updated.size>0){const j=_(w,i,d,!1),Z=_(w,r,d,!0),G=(Q,B,K,V)=>{let z,x,ee;return B.installed?(z=V.pinned,ee=V.preRelease,z&&(x=V.version)):(z=K.pinned,ee=K.preRelease,z&&(x=K.version)),z===void 0&&(z=B.pinned,z&&(x=B.version)),ee===void 0&&(ee=B.preRelease),{...V,installed:B.installed||K.installed,pinned:z,preRelease:ee,version:x??(K.version&&(!B.installed||O.gt(K.version,B.version))?K.version:B.version),state:I(B,K,w?.get(Q))}};for(const Q of Z.removed.values()){const B=i.get(Q);if(!B)continue;const K=(0,A.assertIsDefined)(w?.get(Q)),V=v&&!v.has(Q)&&K.installed;B.installed&&V?p.push(B.identifier):o.set(Q,B)}for(const Q of Z.added.values()){const B=(0,A.assertIsDefined)(r.get(Q)),K=i.get(Q);if(K){if(T.updated.has(Q)){const V=G(Q,K,B,B);L(K,B,!1,!1)||b.push(S(V,Q)),o.set(Q,V)}}else B.installed&&u.push(S(B,Q))}for(const Q of Z.updated.values()){const B=(0,A.assertIsDefined)(r.get(Q)),K=(0,A.assertIsDefined)(w?.get(Q)),V=i.get(Q);if(V)if(v&&!v.has(Q)&&K.installed&&V.installed&&!B.installed)p.push(V.identifier);else{const x=G(Q,V,B,B);b.push(S(x,Q)),o.set(Q,x)}else B.installed&&u.push(S(B,Q))}for(const Q of j.added.values())Z.added.has(Q)||o.set(Q,(0,A.assertIsDefined)(i.get(Q)));for(const Q of j.updated.values()){if(Z.removed.has(Q)||Z.updated.has(Q))continue;const B=(0,A.assertIsDefined)(i.get(Q)),K=(0,A.assertIsDefined)(r.get(Q));o.set(Q,G(Q,B,K,B))}for(const Q of j.removed.values())Z.updated.has(Q)||Z.removed.has(Q)||E.has(Q)||(0,A.assertIsDefined)(r.get(Q)).installed&&v&&(v.has(Q)||!(0,A.assertIsDefined)(w?.get(Q)).installed||o.delete(Q))}const N=[],M=_(r,o,new Set,!0),$=M.added.size>0||M.updated.size>0||M.removed.size>0;return $&&o.forEach((j,Z)=>N.push(S(j,Z))),{local:{added:u,removed:p,updated:b},remote:$?{added:[...M.added].map(j=>o.get(j)),updated:[...M.updated].map(j=>o.get(j)),removed:[...M.removed].map(j=>r.get(j)),all:N}:null}}e.merge=U;function _(c,g,y,m){const h=c?[...c.keys()].filter(t=>!y.has(t)):[],l=[...g.keys()].filter(t=>!y.has(t)),u=l.filter(t=>!h.includes(t)).reduce((t,a)=>(t.add(a),t),new Set),p=h.filter(t=>!l.includes(t)).reduce((t,a)=>(t.add(a),t),new Set),b=new Set;for(const t of h){if(p.has(t))continue;const a=c.get(t),n=g.get(t);(!n||!L(a,n,m,!0))&&b.add(t)}return{added:u,removed:p,updated:b}}function L(c,g,y,m){return!(c.disabled!==g.disabled||!!c.isApplicationScoped!=!!g.isApplicationScoped||m&&c.installed!==g.installed||c.installed&&g.installed&&(c.preRelease!==g.preRelease||c.pinned!==g.pinned||g.pinned&&c.version!==g.version)||!D(c.state,g.state)||y&&c.version!==g.version)}function I(c,g,y){const m=c.state,h=g.state,l=y?.state;if(!g.version||m&&O.gt(c.version,g.version))return m;if(h&&O.gt(g.version,c.version)||!m)return h;if(!h)return m;const u=(0,k.deepClone)(m),p=l?f(l,h):{added:Object.keys(h).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set},b=l?f(l,m):{added:Object.keys(m).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set};for(const t of[...p.added.values(),...p.updated.values()])u[t]=h[t];for(const t of p.removed.values())b.updated.has(t)||delete u[t];return u}function f(c,g){const y=Object.keys(c),m=Object.keys(g),h=m.filter(p=>!y.includes(p)).reduce((p,b)=>(p.add(b),p),new Set),l=y.filter(p=>!m.includes(p)).reduce((p,b)=>(p.add(b),p),new Set),u=new Set;for(const p of y){if(l.has(p))continue;const b=c[p],t=g[p];(0,k.equals)(b,t)||u.add(p)}return{added:h,removed:l,updated:u}}function D(c={},g={}){const{added:y,removed:m,updated:h}=f(c,g);return y.size===0&&m.size===0&&h.size===0}function C(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function S(c,g){const y={...c,identifier:{id:c.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete y.disabled,c.installed||delete y.installed,c.state||delete y.state,c.isApplicationScoped||delete y.isApplicationScoped,y}}),define(oe[111],ae([0,1,18,19,4]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let U=class{constructor(L){this.configurationService=L}hasToNeverSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(L.toLowerCase())}hasToAlwaysSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(`-${L.toLowerCase()}`)}updateIgnoredExtensions(L,I){let f=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return f=f.filter(D=>D!==L&&D!==`-${L}`),I&&f.push(L.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(L,I){let f=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return f=f.filter(D=>D!==L&&D!==`-${L}`),I&&f.push(`-${L.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(L){const I=L.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),f=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),D=[],C=[];if(Array.isArray(f))for(const S of f)S.startsWith("-")?C.push(S.substring(1)):D.push(S);return(0,k.distinct)([...I,...D].filter(S=>!C.includes(S)))}getConfiguredIgnoredExtensions(){let L=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return L!==void 0||(L=this.configurationService.inspect("sync.ignoredExtensions").userValue,L!==void 0)?L:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};e.IgnoredExtensionsManagementService=U,e.IgnoredExtensionsManagementService=U=ye([X(0,O.IConfigurationService)],U)}),define(oe[233],ae([0,1,18,35,30,94,77]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(p){return(0,O.parse)(p)||[]}async function I(p,b,t,a,n){const s=L(p),i=L(b),r=t?L(t):null,o=[...s,...i,...r||[]].map(G=>G.key),w=await n.resolveUserBindings(o),E=D(s,i,r,w);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const d=S(s),v=S(i),T=r?S(r):null,N=g(d,v,w),M=T?g(T,d,w):{added:[...d.keys()].reduce((G,Q)=>(G.add(Q),G),new Set),removed:new Set,updated:new Set},$=T?g(T,v,w):{added:[...v.keys()].reduce((G,Q)=>(G.add(Q),G),new Set),removed:new Set,updated:new Set},j=f(N,M,$);let Z=p;for(const G of j.removed.values())j.conflicts.has(G)||(Z=l(Z,G,a));for(const G of j.added.values()){if(j.conflicts.has(G))continue;const Q=v.get(G);if(Q.some(B=>B.command!==`-${G}`&&E.conflicts.has(w[B.key]))){j.conflicts.add(G);continue}Z=h(Z,Q,a)}for(const G of j.updated.values()){if(j.conflicts.has(G))continue;const Q=v.get(G);if(Q.some(B=>B.command!==`-${G}`&&E.conflicts.has(w[B.key]))){j.conflicts.add(G);continue}Z=u(Z,G,Q,a)}return{mergeContent:Z,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=I;function f(p,b,t){const a=new Set,n=new Set,s=new Set,i=new Set;for(const r of b.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(b.updated.has(r)?i.add(r):n.add(r));for(const r of b.added.values())i.has(r)||t.added.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(b.added.has(r)?p.updated.has(r)&&i.add(r):a.add(r));for(const r of b.updated.values())i.has(r)||t.updated.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(b.updated.has(r)?p.updated.has(r)&&i.add(r):s.add(r));return{added:a,removed:n,updated:s,conflicts:i}}function D(p,b,t,a){const n=new Set,s=C(p,a),i=C(b,a),r=t?C(t,a):null,o=c(s,i);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,s):{added:[...s.keys()].reduce((M,$)=>(M.add($),M),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const E=r?c(r,i):{added:[...i.keys()].reduce((M,$)=>(M.add($),M),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:d,removed:v,updated:T,conflicts:N}=f(o,w,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:v,updated:T,conflicts:N}}function C(p,b){const t=new Map;for(const a of p){const n=b[a.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(a)}return t}function S(p){const b=new Map;for(const t of p){const a=t.command[0]==="-"?t.command.substring(1):t.command;let n=b.get(a);n||(n=[],b.set(a,n)),n.push(t)}return b}function c(p,b){const t=[...p.keys()],a=[...b.keys()],n=a.filter(r=>!t.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=t.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=new Set;for(const r of t){if(s.has(r))continue;const o=p.get(r).map(E=>({...E,key:r})),w=b.get(r).map(E=>({...E,key:r}));(0,k.equals)(o,w,(E,d)=>m(E,d))||i.add(r)}return{added:n,removed:s,updated:i}}function g(p,b,t){const a=[...p.keys()],n=[...b.keys()],s=n.filter(o=>!a.includes(o)).reduce((o,w)=>(o.add(w),o),new Set),i=a.filter(o=>!n.includes(o)).reduce((o,w)=>(o.add(w),o),new Set),r=new Set;for(const o of a){if(i.has(o))continue;const w=p.get(o).map(d=>({...d,key:t[d.key]})),E=b.get(o).map(d=>({...d,key:t[d.key]}));y(w,E)||r.add(o)}return{added:s,removed:i,updated:r}}function y(p,b){return!(!(0,k.equals)(p.filter(({command:t})=>t[0]!=="-"),b.filter(({command:t})=>t[0]!=="-"),(t,a)=>m(t,a))||!(0,k.equals)(p.filter(({command:t})=>t[0]==="-"),b.filter(({command:t})=>t[0]==="-"),(t,a)=>m(t,a)))}function m(p,b){if(p.command!==b.command||p.key!==b.key)return!1;const t=U.ContextKeyExpr.deserialize(p.when),a=U.ContextKeyExpr.deserialize(b.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!A.equals(p.args,b.args))}function h(p,b,t){for(const a of b)p=_.edit(p,[-1],a,t);return p}function l(p,b,t){const a=L(p);for(let n=a.length-1;n>=0;n--)(a[n].command===b||a[n].command===`-${b}`)&&(p=_.edit(p,[n],void 0,t));return p}function u(p,b,t,a){const n=L(p),s=n.findIndex(i=>i.command===b||i.command===`-${b}`);for(let i=n.length-1;i>=0;i--)(n[i].command===b||n[i].command===`-${b}`)&&(p=_.edit(p,[i],void 0,a));for(let i=t.length-1;i>=0;i--)p=_.edit(p,[s],t[i],a);return p}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(U,_,L){const I={},f={},D=new Set;if(!_)return{local:{added:I,updated:f,removed:[...D.values()]},remote:{added:U,updated:{},removed:[]},conflicts:[]};const C=O(U,_);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:I,updated:f,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=O(L,U),c=O(L,_),g={},y={},m=new Set,h=new Set;for(const l of S.removed.values())c.updated.has(l)?I[l]=_[l]:m.add(l);for(const l of c.removed.values())h.has(l)||(S.updated.has(l)?h.add(l):D.add(l));for(const l of S.updated.values())h.has(l)||(c.updated.has(l)?C.updated.has(l)&&h.add(l):y[l]=U[l]);for(const l of c.updated.values())h.has(l)||(S.updated.has(l)?C.updated.has(l)&&h.add(l):U[l]!==void 0&&(f[l]=_[l]));for(const l of S.added.values())h.has(l)||(c.added.has(l)?C.updated.has(l)&&h.add(l):g[l]=U[l]);for(const l of c.added.values())h.has(l)||(S.added.has(l)?C.updated.has(l)&&h.add(l):I[l]=_[l]);return{local:{added:I,removed:[...D.values()],updated:f},remote:{added:g,removed:[...m.values()],updated:y},conflicts:[...h.values()]}}e.merge=k;function O(U,_){const L=U?Object.keys(U):[],I=_?Object.keys(_):[],f=I.filter(S=>!L.includes(S)).reduce((S,c)=>(S.add(c),S),new Set),D=L.filter(S=>!I.includes(S)).reduce((S,c)=>(S.add(c),S),new Set),C=new Set;for(const S of L){if(D.has(S))continue;const c=U[S],g=_[S];c!==g&&C.add(S)}return{added:f,removed:D,updated:C}}function A(U,_){const{added:L,removed:I,updated:f}=O(U,_);return L.size===0&&I.size===0&&f.size===0}e.areSame=A}),define(oe[235],ae([0,1,30]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(U,_,L,I){const f={added:[],removed:[],updated:[]};let D={added:[],removed:[],updated:[]};if(!_){const S=U.filter(({id:c})=>!I.includes(c));return S.length?D.added=S:D=null,{local:f,remote:D}}const C=A(U,_,I);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const S=A(L,U,I),c=A(L,_,I);for(const g of c.removed){const y=U.find(m=>m.id===g);y&&f.removed.push(y)}for(const g of c.added){const y=_.find(m=>m.id===g);S.added.includes(g)?C.updated.includes(g)&&f.updated.push(y):f.added.push(y)}for(const g of c.updated)f.updated.push(_.find(y=>y.id===g));for(const g of S.added)c.added.includes(g)||D.added.push(U.find(y=>y.id===g));for(const g of S.updated)c.removed.includes(g)||c.updated.includes(g)||D.updated.push(U.find(y=>y.id===g));for(const g of S.removed){const y=_.find(m=>m.id===g);y&&D.removed.push(y)}}return D.added.length===0&&D.removed.length===0&&D.updated.length===0&&(D=null),{local:f,remote:D}}e.merge=O;function A(U,_,L){U=U?U.filter(({id:c})=>!L.includes(c)):[],_=_.filter(({id:c})=>!L.includes(c));const I=U.map(({id:c})=>c),f=_.map(({id:c})=>c),D=f.filter(c=>!I.includes(c)),C=I.filter(c=>!f.includes(c)),S=[];for(const{id:c,name:g,shortName:y,icon:m,useDefaultFlags:h}of U){if(C.includes(c))continue;const l=_.find(u=>u.id===c);(!l||l.name!==g||l.shortName!==y||l.icon!==m||!(0,k.equals)(l.useDefaultFlags,h))&&S.push(c)}return{added:D,removed:C,updated:S}}}),define(oe[25],ae([0,1,18,12,174,49,29,4,103,40]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function D(){const i=f.Registry.as(U.Extensions.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=D;function C(){const i=f.Registry.as(U.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(E=>!!i[E].ignoreSync),o=Object.keys(i).filter(E=>i[E].scope===2||i[E].scope===6),w=D();return(0,k.distinct)([...r,...o,...w])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const i="vscode://schemas/ignoredSettings",r=f.Registry.as(U.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=f.Registry.as(I.Extensions.JSONContribution),w=()=>{const E=D(),d=C(),v=Object.keys(U.allSettings.properties).filter(M=>!d.includes(M)),T=d.filter(M=>!E.includes(M)),N={items:{type:"string",enum:[...v,...T.map(M=>`-${M}`)]}};o.registerSchema(i,N)};return r.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=S;function c(i){return i&&(0,O.isObject)(i)&&(0,O.isString)(i.id)&&Array.isArray(i.scopes)}e.isAuthenticationProvider=c;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(i,...r){return i?[i,...r]:r}e.getPathSegments=y;function m(i,r,o,w){return w.joinPath(o.userDataSyncHome,...y(i,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=m,e.IUserDataSyncStoreManagementService=(0,L.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,L.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,L.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(i){const r={};return r[e.HEADER_EXECUTION_ID]=i,r}e.createSyncHeaders=h;var l;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(l||(e.UserDataSyncErrorCode=l={}));class u extends Error{constructor(r,o,w,E){super(r),this.code=o,this.resource=w,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class p extends u{constructor(r,o,w,E,d){super(r,w,void 0,d),this.url=o,this.serverCode=E}}e.UserDataSyncStoreError=p;class b extends u{constructor(r,o){super(r,o)}}e.UserDataAutoSyncError=b,function(i){function r(o){if(o instanceof i)return o;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(w&&w[1]){const E=w[2]==="unknown"?void 0:w[2],d=w[3]==="unknown"?void 0:w[3];return new i(o.message,w[1],E,d)}return new i(o.message,"Unknown")}i.toUserDataSyncError=r}(u||(e.UserDataSyncError=u={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var a;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,L.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,L.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,L.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,L.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,L.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,L.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(_,L,I,f,D){if(!L)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const C=U(_,L);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=I?U(I,L):{added:Object.keys(L).reduce((l,u)=>(l.add(u),l),new Set),removed:new Set,updated:new Set},c=I?U(I,_):{added:Object.keys(_).reduce((l,u)=>(l.add(u),l),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},y=k.deepClone(L),m=!I;for(const l of c.added.values())l!==O.SYNC_SERVICE_URL_TYPE&&m&&S.added.has(l)||(y[l]=_[l]);for(const l of c.updated.values())y[l]=_[l];for(const l of c.removed.values())f.unregistered.includes(l)||delete y[l];for(const l of S.added.values()){const u=L[l];if(f.machine.includes(l)){D.info(`GlobalState: Skipped adding ${l} in local storage because it is declared as machine scoped.`);continue}if(I&&c.added.has(l))continue;const p=_[l];p&&p.value===u.value||l===O.SYNC_SERVICE_URL_TYPE&&m&&c.added.has(l)||(p?g.updated[l]=u:g.added[l]=u)}for(const l of S.updated.values()){const u=L[l];if(f.machine.includes(l)){D.info(`GlobalState: Skipped updating ${l} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(l)||c.removed.has(l))continue;const p=_[l];p&&p.value===u.value||(g.updated[l]=u)}for(const l of S.removed.values()){if(f.machine.includes(l)){D.trace(`GlobalState: Skipped removing ${l} in local storage because it is declared as machine scoped.`);continue}c.updated.has(l)||c.removed.has(l)||g.removed.push(l)}const h=U(L,y);return{local:g,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:y}}}e.merge=A;function U(_,L){const I=Object.keys(_),f=Object.keys(L),D=f.filter(c=>!I.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),C=I.filter(c=>!f.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),S=new Set;for(const c of I){if(C.has(c))continue;const g=_[c],y=L[c];k.equals(g,y)||S.add(c)}return{added:D,removed:C,updated:S}}}),define(oe[237],ae([0,1,18,35,85,41,30,77,25]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function f(o,w,E){let d=[];E?d=C(E):d=D(w);const v=[],T=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(d))for(const N of d)N.startsWith("-")?T.push(N.substring(1)):v.push(N);return(0,k.distinct)([...o,...v].filter(N=>!T.includes(N)))}e.getIgnoredSettings=f;function D(o){let w=o.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=o.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:o.getValue("settingsSync.ignoredSettings")||[]}function C(o){const w=(0,O.parse)(o);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function S(o,w){const E=(0,O.parse)(o)||{};let d="{}";for(const v of Object.keys(E)){const T=(0,A.setProperty)(d,[v],E[v],w);d=(0,A.applyEdits)(d,T)}return d}e.removeComments=S;function c(o,w,E,d){if(E.length){const v=r(w),T=(0,O.parse)(w)||{},N=(0,O.parse)(o);if(!N)return o;const M=[];for(const $ of E){const j=T[$],Z=N[$];j===void 0?o=L.edit(o,[$],void 0,d):Z!==void 0?o=L.edit(o,[$],j,d):M.push(t($,v))}M.sort(($,j)=>$.startOffset-j.startOffset),M.forEach($=>o=l($.setting.key,w,o,d))}return o}e.updateIgnoredSettings=c;function g(o,w,E,d,v,T){const N=c(o,w,d,T),M=E!==N,$=E!==w;if(!M&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!$)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if($&&!M)return{conflictsSettings:[],localContent:c(w,o,d,T),remoteContent:null,hasConflicts:!1};if(E===null&&m(o)){const R=y(o,w,d)?null:c(w,o,d,T);return{conflictsSettings:[],localContent:R,remoteContent:null,hasConflicts:!1}}let j=o,Z=w;const G=(0,O.parse)(o),Q=(0,O.parse)(w),B=E?(0,O.parse)(E):null,K=d.reduce((R,W)=>(R.add(W),R),new Set),V=h(G,Q,K),z=h(B,G,K),x=h(B,Q,K),ee=new Map,ne=new Set,re=R=>{ne.add(R);const W=v.filter(({key:F})=>F===R)[0];W?(j=L.edit(j,[R],W.value,T),Z=L.edit(Z,[R],W.value,T)):ee.set(R,{key:R,localValue:G[R],remoteValue:Q[R]})};for(const R of z.removed.values())x.updated.has(R)?re(R):Z=L.edit(Z,[R],void 0,T);for(const R of x.removed.values())ne.has(R)||(z.updated.has(R)?re(R):j=L.edit(j,[R],void 0,T));for(const R of z.updated.values())ne.has(R)||(x.updated.has(R)?V.updated.has(R)&&re(R):Z=L.edit(Z,[R],G[R],T));for(const R of x.updated.values())ne.has(R)||(z.updated.has(R)?V.updated.has(R)&&re(R):j=L.edit(j,[R],Q[R],T));for(const R of z.added.values())ne.has(R)||(x.added.has(R)?V.updated.has(R)&&re(R):Z=l(R,j,Z,T));for(const R of x.added.values())ne.has(R)||(z.added.has(R)?V.updated.has(R)&&re(R):j=l(R,Z,j,T));const J=ee.size>0||!y(j,Z,d),q=J||!y(j,o,[]),P=J||!y(Z,w,[]);return{localContent:q?j:null,remoteContent:P?Z:null,conflictsSettings:[...ee.values()],hasConflicts:J}}e.merge=g;function y(o,w,E){if(o===w)return!0;const d=(0,O.parse)(o),v=(0,O.parse)(w),T=E.reduce(($,j)=>($.add(j),$),new Set),N=r(o).filter($=>!($.setting&&T.has($.setting.key))),M=r(w).filter($=>!($.setting&&T.has($.setting.key)));if(N.length!==M.length)return!1;for(let $=0;$<N.length;$++){const j=N[$],Z=M[$];if(j.setting&&Z.setting){if(j.setting.key!==Z.setting.key||!_.equals(d[j.setting.key],v[j.setting.key]))return!1}else if(!j.setting&&!Z.setting){if(j.value!==Z.value)return!1}else return!1}return!0}function m(o){return o?r(o).length===0:!0}e.isEmpty=m;function h(o,w,E){const d=o?Object.keys(o).filter($=>!E.has($)):[],v=Object.keys(w).filter($=>!E.has($)),T=v.filter($=>!d.includes($)).reduce(($,j)=>($.add(j),$),new Set),N=d.filter($=>!v.includes($)).reduce(($,j)=>($.add(j),$),new Set),M=new Set;if(o)for(const $ of d){if(N.has($))continue;const j=o[$],Z=w[$];_.equals(j,Z)||M.add($)}return{added:T,removed:N,updated:M}}function l(o,w,E,d){const v=(0,O.parse)(w),T=r(w),N=r(E),M=u(o,T,N);return p(E,o,v[o],M,N,d)}e.addSetting=l;function u(o,w,E){const d=w.findIndex(T=>T.setting?.key===o),v=w[d-1];if(v){if(v.setting){const N=t(v.setting.key,E);if(N)return{index:E.indexOf(N),insertAfter:!0}}else{const N=a(d,w);if(N){const M=t(N.setting.key,E);if(M){const $=n(E.indexOf(M),E),j=s(w,N,w[d]);if($){const Z=s(E,M,$),G=i(j,Z);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.indexOf($),insertAfter:!1}}else{const Z=s(E,M,E[E.length-1]),G=i(j,Z);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const T=w[d+1];if(T)if(T.setting){const N=t(T.setting.key,E);if(N)return{index:E.indexOf(N),insertAfter:!1}}else{const N=n(d,w);if(N){const M=t(N.setting.key,E);if(M){const $=a(E.indexOf(M),E),j=s(w,w[d],N);if($){const Z=s(E,$,M),G=i(j.reverse(),Z.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:E.indexOf($),insertAfter:!0}}else{const Z=s(E,E[0],M),G=i(j.reverse(),Z.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function p(o,w,E,d,v,T){let N;return d.index===-1?N=(0,A.setProperty)(o,[w],E,T):N=b(o,w,E,d,v,T).map(M=>(0,A.withFormatting)(o,M,T)[0]),(0,A.applyEdits)(o,N)}function b(o,w,E,d,v,T){const N=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,M=(0,U.getEOL)(T,o),$=v[d.index];if(d.insertAfter){const j=[];if($.setting)j.push({offset:$.endOffset,length:0,content:","+N});else{const Z=n(d.index,v),G=a(d.index,v),Q=G?.setting?.commaOffset;G&&Q===void 0&&j.push({offset:G.endOffset,length:0,content:","});const B=Q!==void 0&&Q>$.endOffset;j.push({offset:B?Q+1:$.endOffset,length:0,content:Z?M+N+",":M+N})}return j}else{if($.setting)return[{offset:$.startOffset,length:0,content:N+","}];const j=(v[d.index-1]&&!v[d.index-1].setting?M:"")+N+(n(d.index,v)?",":"")+M;return[{offset:$.startOffset,length:0,content:j}]}}function t(o,w){return w.filter(E=>E.setting?.key===o)[0]}function a(o,w){for(let E=o-1;E>=0;E--)if(w[E].setting)return w[E]}function n(o,w){for(let E=o+1;E<w.length;E++)if(w[E].setting)return w[E]}function s(o,w,E){const d=o.indexOf(w),v=o.indexOf(E);return o.filter((T,N)=>d<N&&N<v)}function i(o,w){if(o.length&&w.length){let E=0;for(;E<w.length&&E<o.length;E++)if(o[E].value!==w[E].value)return w[E-1];return w[E-1]}}function r(o){const w=[];let E=-1,d,v;const T={onObjectBegin:N=>{E++},onObjectProperty:(N,M,$)=>{E===0&&(d=M,v=N)},onObjectEnd:(N,M)=>{E--,E===0&&w.push({startOffset:d,endOffset:N+M,value:o.substring(d,N+M),setting:{key:v,commaOffset:void 0}})},onArrayBegin:(N,M)=>{E++},onArrayEnd:(N,M)=>{E--,E===0&&w.push({startOffset:d,endOffset:N+M,value:o.substring(d,N+M),setting:{key:v,commaOffset:void 0}})},onLiteralValue:(N,M,$)=>{E===0&&w.push({startOffset:d,endOffset:M+$,value:o.substring(d,M+$),setting:{key:v,commaOffset:void 0}})},onSeparator:(N,M,$)=>{if(E===0&&N===","){let j=w.length-1;for(;j>=0&&!w[j].setting;j--);const Z=w[j];Z&&w.splice(j,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:M}})}},onComment:(N,M)=>{E===0&&w.push({startOffset:N,endOffset:N+M,value:o.substring(N,N+M)})}};return(0,O.visit)(o,T),w}}),define(oe[78],ae([0,1,3,2,4,25]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let _=class extends O.Disposable{get account(){return this._account}constructor(I,f){super(),this.userDataSyncStoreService=I,this.logService=f,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(D=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,D),this.updateAccount(void 0),D==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};e.UserDataSyncAccountService=_,e.UserDataSyncAccountService=_=ye([X(0,U.IUserDataSyncStoreService),X(1,U.IUserDataSyncLogService)],_)}),define(oe[238],ae([0,1,2,10]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(S){this.service=S}listen(S,c){switch(c){case"onError":return this.service.onError}throw new Error(`Event not found: ${c}`)}call(S,c,g){switch(c){case"triggerSync":return this.service.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(g[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class U{constructor(S){this.service=S}listen(S,c){throw new Error(`Event not found: ${c}`)}call(S,c,g){switch(c){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(O.URI.revive(g[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=U;class _{constructor(S){this.channel=S}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(S){return this.channel.call("resolveUserKeybindings",[S])}async resolveFormattingOptions(S){return this.channel.call("resolveFormattingOptions",[S])}}e.UserDataSyncUtilServiceClient=_;class L{constructor(S){this.service=S}listen(S,c){switch(c){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${c}`)}async call(S,c,g){switch(c){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(g[0],g[1]);case"setEnablements":return this.service.setEnablements(g)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=L;class I{constructor(S){this.service=S}listen(S,c){switch(c){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(S,c,g){switch(c){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class f{constructor(S){this.service=S}listen(S,c){switch(c){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(S,c,g){switch(c){case"switch":return this.service.switch(g[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=f;class D extends k.Disposable{constructor(S){super(),this.channel=S,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(S){return this.channel.call("switch",[S])}async getPreviousUserDataSyncStore(){const S=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(S)}revive(S){return{url:O.URI.revive(S.url),type:S.type,defaultUrl:O.URI.revive(S.defaultUrl),insidersUrl:O.URI.revive(S.insidersUrl),stableUrl:O.URI.revive(S.stableUrl),canSwitch:S.canSwitch,authenticationProviders:S.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(oe[239],ae([0,1,21,175,14,7,25]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends U.AbstractLogger{constructor(f,D){super(),this.logger=this._register(f.createLogger((0,k.joinPath)(D.logsHome,`${_.USER_DATA_SYNC_LOG_ID}.log`),{id:_.USER_DATA_SYNC_LOG_ID,name:(0,O.localize)(0,null)}))}trace(f,...D){this.logger.trace(f,...D)}debug(f,...D){this.logger.debug(f,...D)}info(f,...D){this.logger.info(f,...D)}warn(f,...D){this.logger.warn(f,...D)}error(f,...D){this.logger.error(f,...D)}flush(){this.logger.flush()}};e.UserDataSyncLogService=L,e.UserDataSyncLogService=L=ye([X(0,U.ILoggerService),X(1,A.IEnvironmentService)],L)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VoiceRecognitionService=e.IVoiceRecognitionService=void 0,e.IVoiceRecognitionService=(0,O.createDecorator)("voiceRecognitionService");let U=class{constructor(L,I){this.logService=L,this.productService=I}async transcribe(L,I){const f=process.env.VSCODE_VOICE_MODULE_PATH;if(!f||this.productService.quality==="stable")throw this.logService.error(`[voice] transcribe(${L.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const D=Date.now();try{const C=te.__$__nodeRequire(f),S=new AbortController;I.onCancellationRequested(()=>S.abort());const c=await C.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:L},{language:"en",signal:S.signal});return this.logService.info(`[voice] transcribe(${L.length}): Text "${c}", took ${Date.now()-D}ms)`),c}catch(C){throw this.logService.error(`[voice] transcribe(${L.length}): Failed width "${C}", took ${Date.now()-D}ms)`),C}}};e.VoiceRecognitionService=U,e.VoiceRecognitionService=U=ye([X(0,k.ILogService),X(1,A.IProductService)],U)}),define(oe[240],ae([0,1,2,112,7,26,5]),function(te,e,k,O,A,U,_){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.VoiceTranscriptionManager=void 0;let I=class extends k.Disposable{static{L=this}static{this.USE_SLIDING_WINDOW=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(c,g,y){super(),this.onDidWindowConnectRaw=c,this.voiceRecognitionService=g,this.logService=y,this.registerListeners()}registerListeners(){this._register(this.onDidWindowConnectRaw(c=>{this.logService.info(`[voice] transcriber: new connection (sliding window: ${L.USE_SLIDING_WINDOW})`),L.USE_SLIDING_WINDOW?this._register(new D(c,this.voiceRecognitionService,this.logService)):this._register(new C(c,this.voiceRecognitionService,this.logService))}))}};e.VoiceTranscriptionManager=I,e.VoiceTranscriptionManager=I=L=ye([X(1,O.IVoiceRecognitionService),X(2,A.ILogService)],I);class f extends k.Disposable{static{this.MAX_DATA_LENGTH=30*16e3*16*1/8}constructor(c,g,y){super(),this.port=c,this.voiceRecognitionService=g,this.logService=y,this.registerListeners()}registerListeners(){const c=new U.CancellationTokenSource;this._register((0,k.toDisposable)(()=>c.dispose(!0)));const g=m=>{m.data instanceof Float32Array&&this.handleRequest(m.data,c.token)};this.port.on("message",g),this._register((0,k.toDisposable)(()=>this.port.off("message",g))),this.port.start();let y=!1;this.port.on("close",()=>{this.logService.info("[voice] transcriber: closed connection"),y=!0,this.dispose()}),this._register((0,k.toDisposable)(()=>{y||this.port.close()}))}joinFloat32Arrays(c){const g=new Float32Array(c.reduce((m,h)=>m+h.length,0));let y=0;for(const m of c)g.set(m,y),y+=m.length;return g}}class D extends f{constructor(){super(...arguments),this.transcriptionQueue=this._register(new _.Queue),this.transcribedResults=[],this.data=new Float32Array(0)}async handleRequest(c,g){if(c.length>0)this.logService.info("[voice] transcriber: voice detected, storing in buffer"),this.data=this.data?this.joinFloat32Arrays([this.data,c]):c;else{this.logService.info("[voice] transcriber: silence detected, transcribing window...");const y=this.data.slice(0);this.data=new Float32Array(0),this.transcriptionQueue.queue(()=>this.transcribe(y,g))}}async transcribe(c,g){if(!g.isCancellationRequested){if(c.length>f.MAX_DATA_LENGTH){this.logService.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(c.length!==0){const y=await this.voiceRecognitionService.transcribe(c,g);y&&this.transcribedResults.push(y)}g.isCancellationRequested||this.port.postMessage(this.transcribedResults.join(" "))}}dispose(){super.dispose(),this.data=new Float32Array(0)}}class C extends f{constructor(){super(...arguments),this.transcriptionQueue=new _.LimitedQueue,this.data=void 0,this.transcribedDataLength=0,this.transcribedResult=""}async handleRequest(c,g){const y=this.data?this.joinFloat32Arrays([this.data,c]):c;if(y.length>f.MAX_DATA_LENGTH){this.logService.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.data=y,this.transcriptionQueue.queue(()=>this.transcribe(g))}async transcribe(c){if(c.isCancellationRequested)return;const g=this.data?.slice(0);if(!g)return;let y;g.length===this.transcribedDataLength?(this.logService.info("[voice] transcriber: silence detected, reusing previous transcription result"),y=this.transcribedResult):(this.logService.info("[voice] transcriber: voice detected, transcribing everything..."),y=await this.voiceRecognitionService.transcribe(g,c)),this.transcribedResult=y,this.transcribedDataLength=g.length,!c.isCancellationRequested&&this.port.postMessage(y)}dispose(){super.dispose(),this.data=void 0}}}),define(oe[241],ae([0,1,5,3,2]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class U extends A.Disposable{constructor({onDidOpenWindow:L,onDidFocusWindow:I,getActiveWindowId:f}){super(),this.disposables=this._register(new A.DisposableStore),O.Event.latch(O.Event.any(L,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>f()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(L){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=L}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=U}),define(oe[113],ae([0,1,178,16,47,21,10,4,23]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");function f(s){const i=s;return typeof i?.id=="string"&&_.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=f;function D(s){return typeof s?.id=="string"&&!f(s)&&!S(s)}e.isEmptyWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,O.basename)(s)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=C;function S(s){const i=s;return typeof i?.id=="string"&&_.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=S;function c(s){const i=s;if(i?.uri)return{id:i.id,uri:_.URI.revive(i.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=c;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function y(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=y;function m(s){const i=s;return!!(i&&typeof i=="object"&&_.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=m;class h{constructor(i,r,o,w,E){this._id=i,this._transient=o,this._configuration=w,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,U.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function u(s){return new l({uri:s,index:0,name:(0,U.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=u,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(s,i){return U.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function b(s){let i;return _.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=b,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(s,i){return!p(s,i)&&!b(s)}e.isSavedWorkspace=a;function n(s){return(typeof s=="string"?(0,O.extname)(s):(0,U.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[17],ae([0,1,51,3,2,21,10,169,14,11,4,7,113,34,28,5,32,27,12]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var u;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&_.URI.isUri(i.location)&&_.URI.isUri(i.globalStorageHome)&&_.URI.isUri(i.settingsResource)&&_.URI.isUri(i.keybindingsResource)&&_.URI.isUri(i.tasksResource)&&_.URI.isUri(i.snippetsHome)&&_.URI.isUri(i.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function b(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:_.URI.revive(s.location).with({scheme:i}),globalStorageHome:_.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:_.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:_.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:_.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:_.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:_.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:_.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=b;function t(s,i,r,o,w,E){return{id:s,name:i,location:r,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:E&&w?.useDefaultFlags?.globalState?E.globalStorageHome:(0,U.joinPath)(r,"globalStorage"),settingsResource:E&&w?.useDefaultFlags?.settings?E.settingsResource:(0,U.joinPath)(r,"settings.json"),keybindingsResource:E&&w?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,U.joinPath)(r,"keybindings.json"),tasksResource:E&&w?.useDefaultFlags?.tasks?E.tasksResource:(0,U.joinPath)(r,"tasks.json"),snippetsHome:E&&w?.useDefaultFlags?.snippets?E.snippetsHome:(0,U.joinPath)(r,"snippets"),extensionsResource:E&&w?.useDefaultFlags?.extensions?E.extensionsResource:(0,U.joinPath)(r,"extensions.json"),cacheHome:(0,U.joinPath)(o,s),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.toUserDataProfile=t;let a=class extends A.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,o,w){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=o,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new c.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,U.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,U.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.createDefaultProfile(),r=[i];if(this.enabled)try{for(const E of this.getStoredProfiles()){if(!E.name||!(0,l.isString)(E.name)||!E.location){this.logService.warn("Skipping the invalid stored profile",E.location||E.name);continue}r.push(t((0,U.basename)(E.location),E.name,E.location,this.profilesCacheHome,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},i))}}catch(E){this.logService.error(E)}const o=new c.ResourceMap,w=new Map;if(r.length)try{const E=this.getStoredProfileAssociations();if(E.workspaces)for(const[d,v]of Object.entries(E.workspaces)){const T=_.URI.parse(d),N=r.find(M=>M.id===v);N&&o.set(T,N)}if(E.emptyWindows)for(const[d,v]of Object.entries(E.emptyWindows)){const T=r.find(N=>N.id===v);T&&w.set(d,T)}}catch(E){this.logService.error(E)}this._profilesObject={profiles:r,workspaces:o,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const i=t("__default__profile__",(0,L.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...i,extensionsResource:this.getDefaultProfileExtensionsLocation()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,h.escapeRegExpCharacters)(r)}\\s(\\d+)`);let w=0;for(const d of this.profiles){const v=o.exec(d.name),T=v?parseInt(v[1]):0;w=T>w?T:w}const E=`${r} ${w+1}`;return this.createProfile((0,k.hash)((0,m.generateUuid)()).toString(16),E,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,k.hash)((0,m.generateUuid)()).toString(16),i,r,o)}async createProfile(i,r,o,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const E=await this.doCreateProfile(i,r,o);return w&&await this.setProfileForWorkspace(w,E),E}async doCreateProfile(i,r,o){if(!(0,l.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(r);return w||(w=(async()=>{try{const E=this.profiles.find(T=>T.name===r||T.id===i);if(E)return E;const d=t(i,r,(0,U.joinPath)(this.profilesHome,i),this.profilesCacheHome,o,this.defaultProfile);await this.fileService.createFolder(d.location);const v=[];return this._onWillCreateProfile.fire({profile:d,join(T){v.push(T)}}),await y.Promises.settled(v),this.updateProfiles([d],[],[]),d}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,w)),w}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(w=>w.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=t(o.id,r.name??o.name,o.location,this.profilesCacheHome,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[o]),o}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(w=>w.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(w){o.push(w)}});try{await Promise.allSettled(o)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(w){(0,f.toFileOperationResult)(w)!==1&&this.logService.error(w)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(w=>w.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,o)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,S.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,S.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,o){const w=[...this.profiles,...i],E=[];this.transientProfilesObject.profiles=[];for(let d of w)d.isDefault||r.some(v=>d.id===v.id)||(d=o.find(v=>d.id===v.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):E.push({location:d.location,name:d.name,shortName:d.shortName,icon:d.icon,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(E),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,o)}triggerProfilesChanges(i,r,o){this._onDidChangeProfiles.fire({added:i,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(i,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(i,void 0,!0);const w=this.getWorkspace(i),E=o?this.transientProfilesObject:this.profilesObject;_.URI.isUri(w)?(E.workspaces.delete(w),r&&E.workspaces.set(w,r)):(E.emptyWindows.delete(w),r&&E.emptyWindows.set(w,r)),o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[o,w]of this.profilesObject.workspaces.entries())i[o.toString()]=w.id;const r={};for(const[o,w]of this.profilesObject.emptyWindows.entries())r[o.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},o=this.createDefaultProfile();if(i.workspaces)for(const[E,d]of Object.entries(i.workspaces)){const v=_.URI.parse(d);r[E]=this.uriIdentityService.extUri.isEqual(v,o.location)?o.id:this.uriIdentityService.extUri.basename(v)}const w={};if(i.emptyWindows)for(const[E,d]of Object.entries(i.emptyWindows)){const v=_.URI.parse(d);w[E]=this.uriIdentityService.extUri.isEqual(v,o.location)?o.id:this.uriIdentityService.extUri.basename(v)}return{workspaces:r,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=a,e.UserDataProfilesService=a=ye([X(0,I.IEnvironmentService),X(1,f.IFileService),X(2,g.IUriIdentityService),X(3,C.ILogService)],a);class n extends a{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=n}),define(oe[242],ae([0,1,5,2,17]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let U=class extends O.Disposable{constructor(L){super(),this._register(new k.RunOnceScheduler(()=>{L.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=U,e.UserDataProfilesCleaner=U=ye([X(0,A.IUserDataProfilesService)],U)}),define(oe[243],ae([0,1,18,5,26,8,3,2,6,12,10,152,29,33,44,7,24,22,28,17]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let p=class extends L.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(i,r,o,w,E,d){super(),this.galleryService=i,this.telemetryService=r,this.uriIdentityService=o,this.logService=w,this.productService=E,this.userDataProfilesService=d,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this._onDidUpdateExtensionMetadata=this._register(new _.Emitter),this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(({task:v})=>v.cancel()),this.uninstallingExtensions.forEach(v=>v.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,S.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const w=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:E})=>(0,c.areSameExtensions)(E,i.identifier));if(w?.local)return w?.local;throw w?.error?w.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(o){throw t(o)}}async installGalleryExtensions(i){if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(C.localize(0,null),S.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(i.map(async({extension:w,options:E})=>{try{const d=await this.checkAndGetCompatibleVersion(w,!!E?.installGivenVersion,!!E?.installPreReleaseVersion);o.push({...d,options:E})}catch(d){r.push({identifier:w.identifier,operation:2,source:w,error:d})}})),o.length&&r.push(...await this.installExtensions(o));for(const w of r)w.error&&(this.logService.error("Failed to install extension.",w.identifier.id),this.logService.error(w.error),w.source&&!D.URI.isUri(w.source)&&a(this.telemetryService,"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(w.source),error:w.error}));return r}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}async toggleAppliationScope(i,r){if((0,g.isApplicationScopedExtension)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(o=await this.copyExtension(i,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const w of this.userDataProfilesService.profiles){const E=(await this.getInstalled(1,w.extensionsResource)).find(d=>(0,c.areSameExtensions)(d.identifier,i.identifier));E?this._onDidUpdateExtensionMetadata.fire(E):this._onDidUninstallExtension.fire({identifier:i.identifier,profileLocation:w.extensionsResource})}return o}else{const o=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(i,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtensions(i){const r=[];return await Promise.allSettled(i.map(async o=>{try{const w=await this.installExtension(o);r.push(...w)}catch(w){r.push({identifier:{id:(0,c.getGalleryExtensionId)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:w})}})),this._onDidInstallExtensions.fire(r),r}async installExtension({manifest:i,extension:r,options:o}){const w=o.isApplicationScoped||o.isBuiltin||(0,g.isApplicationScopedExtension)(i),E={...o,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},d=j=>`${c.ExtensionKey.create(j).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!D.URI.isUri(r)){const j=this.installingExtensions.get(d(r));if(j)return this.logService.info("Extensions is already requested to install",r.identifier.id),await j.task.waitUntilTaskIsFinished(),[]}const v=[],T=[],N=[],M=this.createInstallExtensionTask(i,r,E);D.URI.isUri(r)||this.installingExtensions.set(d(r),{task:M,waitingTasks:[]}),this._onInstallExtension.fire({identifier:M.identifier,source:r,profileLocation:E.profileLocation}),this.logService.info("Installing extension:",M.identifier.id),v.push({task:M,manifest:i});let $=!1;try{if(E.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const Z=await this.getAllDepsAndPackExtensions(M.identifier,i,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),G=await this.getInstalled(void 0,E.profileLocation),Q={...E,donotIncludePackAndDependencies:!0,context:{...E.context,[S.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:B,manifest:K}of(0,k.distinct)(Z,({gallery:V})=>V.identifier.id)){$=$||!!K.extensionDependencies?.some(x=>(0,c.areSameExtensions)({id:x},M.identifier));const V=d(B),z=this.installingExtensions.get(V);if(z){if(this.canWaitForTask(M,z.task)){const x=z.task.identifier;this.logService.info("Waiting for already requested installing extension",x.id,M.identifier.id),z.waitingTasks.push(M),T.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,c.areSameExtensions)(ne.identifier,x)))).then(ee=>{if(this.logService.info("Finished waiting for already requested installing extension",x.id,M.identifier.id),!ee.find(re=>(0,c.areSameExtensions)(re.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!G.some(({identifier:x})=>(0,c.areSameExtensions)(x,B.identifier))){const x=this.createInstallExtensionTask(K,B,Q);this.installingExtensions.set(V,{task:x,waitingTasks:[M]}),this._onInstallExtension.fire({identifier:x.identifier,source:B,profileLocation:E.profileLocation}),this.logService.info("Installing extension:",x.identifier.id,M.identifier.id),v.push({task:x,manifest:K})}}}catch(Z){if(D.URI.isUri(M.source))(0,k.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,Z.message),(0,k.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,Z.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),Z}const j=v.reduce((Z,{task:G,manifest:Q})=>(Z.set(G.identifier.id.toLowerCase(),{task:G,manifest:Q}),Z),new Map);for(;j.size;){let Z;const G=[...j.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(B=>j.has(B.toLowerCase())));G.length?Z=j.size===1?G:G.filter(({task:Q})=>!(Q===M&&!$)):(this.logService.info("Found extensions with circular dependencies",G.map(({task:Q})=>Q.identifier.id)),Z=[...j.values()]),await this.joinAllSettled(Z.map(async({task:Q})=>{const B=new Date().getTime();try{const K=await Q.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(K,Q.source,E,A.CancellationToken.None))),!D.URI.isUri(Q.source)){const V=Q.operation===3,z=V?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(a(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:z}),I.isWeb&&Q.operation!==3)try{await this.galleryService.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,"install")}catch{}}N.push({local:K,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:K.isApplicationScoped})}catch(K){throw D.URI.isUri(Q.source)||a(this.telemetryService,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-B,error:K}),this.logService.error("Error while installing the extension:",Q.identifier.id),K}finally{j.delete(Q.identifier.id.toLowerCase())}}))}return T.length&&await this.joinAllSettled(T),N.forEach(({identifier:Z})=>this.logService.info("Extension installed successfully:",Z.id)),N}catch(j){if(v.forEach(({task:Z})=>Z.cancel()),N.length)try{const Z=await Promise.allSettled(N.map(({local:G})=>this.createUninstallExtensionTask(G,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let G=0;G<Z.length;G++){const Q=Z[G],{identifier:B}=N[G];Q.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",B.id):this.logService.warn("Rollback: Error while uninstalling extension",B.id,(0,U.getErrorMessage)(Q.reason))}}catch(Z){this.logService.warn("Error while rolling back extensions",(0,U.getErrorMessage)(Z),N.map(({identifier:G})=>G.id))}return v.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:E.context,profileLocation:E.profileLocation,error:j}))}finally{for(const{task:j}of v)j.source&&!D.URI.isUri(j.source)&&this.installingExtensions.delete(d(j.source))}}canWaitForTask(i,r){for(const[,{task:o,waitingTasks:w}]of this.installingExtensions.entries())if(o===i&&(w.includes(r)||w.some(E=>this.canWaitForTask(E,r)))||o===r&&w[0]&&!this.canWaitForTask(i,w[0]))return!1;return!0}async joinAllSettled(i){const r=[],o=[],w=await Promise.allSettled(i);for(const E of w)E.status==="fulfilled"?r.push(E.value):o.push(E.reason);if(o.length)throw b(o);return r}async getAllDepsAndPackExtensions(i,r,o,w,E){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,E),v=[],T=[],N=async(M,$)=>{v.push(M);const j=$.extensionDependencies||[],Z=[...j];if($.extensionPack){const G=o?d.find(Q=>(0,c.areSameExtensions)(Q.identifier,M)):void 0;for(const Q of $.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(B=>(0,c.areSameExtensions)({id:B},{id:Q}))||Z.every(B=>!(0,c.areSameExtensions)({id:B},{id:Q}))&&Z.push(Q)}if(Z.length){const G=Z.filter(Q=>v.every(B=>!(0,c.areSameExtensions)(B,{id:Q})));if(G.length){const Q=await this.galleryService.getExtensions(G.map(B=>({id:B,preRelease:w})),A.CancellationToken.None);for(const B of Q){if(v.find(z=>(0,c.areSameExtensions)(z,B.identifier)))continue;const K=j.some(z=>(0,c.areSameExtensions)({id:z},B.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(B,!1,w)}catch(z){if(K)throw z;this.logService.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,U.getErrorMessage)(z));continue}T.push({gallery:V.extension,manifest:V.manifest}),await N(V.extension.identifier,V.manifest)}}}};return await N(i,r),T}async checkAndGetCompatibleVersion(i,r,o){let w;const E=await this.getExtensionsControlManifest();if(E.malicious.some(T=>(0,c.areSameExtensions)(i.identifier,T)))throw new S.ExtensionManagementError(C.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);const d=E.deprecated[i.identifier.id.toLowerCase()];if(d?.extension?.autoMigrate){if(this.logService.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${d.extension.id}' extension instead.`),w=(await this.galleryService.getExtensions([{id:d.extension.id,preRelease:d.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!w)throw new S.ExtensionManagementError(C.localize(2,null,i.identifier.id,d.extension.id),S.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const T=await this.getTargetPlatform();throw new S.ExtensionManagementError(C.localize(3,null,i.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(T)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.getCompatibleVersion(i,r,o),!w)throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],A.CancellationToken.None))[0]?new S.ExtensionManagementError(C.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(C.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",w.identifier.id);const v=await this.galleryService.getManifest(w,A.CancellationToken.None);if(v===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${w.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(v.version!==w.version)throw new S.ExtensionManagementError(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:v}}async getCompatibleVersion(i,r,o){const w=await this.getTargetPlatform();let E=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(E=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:w,compatible:!0},A.CancellationToken.None))[0]||null),!E&&await this.galleryService.isExtensionCompatible(i,o,w)&&(E=i),E||(r?E=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:w,compatible:!0},A.CancellationToken.None))[0]||null:E=await this.galleryService.getCompatibleExtension(i,o,w)),E}async uninstallExtension(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},w=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,E=this.uninstallingExtensions.get(w(i.identifier));if(E)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),E.waitUntilTaskIsFinished();const d=M=>{const $=this.createUninstallExtensionTask(M,o);return this.uninstallingExtensions.set(w($.extension.identifier),$),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),$},v=(M,$)=>{$?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),$.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,$.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),a(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,c.getLocalExtensionTelemetryData)(M),error:$}),this._onDidUninstallExtension.fire({identifier:M.identifier,error:$?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},T=[],N=[];try{T.push(d(i));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const $=this.getAllPackExtensionsToUninstall(i,M);for(const j of $)this.uninstallingExtensions.has(w(j.identifier))?this.logService.info("Extensions is already requested to uninstall",j.identifier.id):T.push(d(j))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(T.map($=>$.extension),M,i),await this.joinAllSettled(T.map(async $=>{try{if(await $.run(),await this.joinAllSettled(this.participants.map(j=>j.postUninstall($.extension,o,A.CancellationToken.None))),$.extension.identifier.uuid)try{await this.galleryService.reportStatistic($.extension.manifest.publisher,$.extension.manifest.name,$.extension.manifest.version,"uninstall")}catch{}v($.extension)}catch(j){const Z=j instanceof S.ExtensionManagementError?j:new S.ExtensionManagementError((0,U.getErrorMessage)(j),S.ExtensionManagementErrorCode.Internal);throw v($.extension,Z),Z}finally{N.push($)}}))}catch(M){const $=M instanceof S.ExtensionManagementError?M:new S.ExtensionManagementError((0,U.getErrorMessage)(M),S.ExtensionManagementErrorCode.Internal);for(const j of T){try{j.cancel()}catch{}N.includes(j)||v(j.extension,$)}throw $}finally{for(const M of T)this.uninstallingExtensions.delete(w(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(i,r,o){for(const w of i){const E=this.getDependents(w,r);if(E.length){const d=E.filter(v=>!i.some(T=>(0,c.areSameExtensions)(T.identifier,v.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(w,d,o))}}}getDependentsErrorMessage(i,r,o){return o===i?r.length===1?C.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const w=i.manifest.extensionPack?i.manifest.extensionPack:[];if(w.length){const E=r.filter(v=>!v.isBuiltin&&w.some(T=>(0,c.areSameExtensions)({id:T},v.identifier))),d=[];for(const v of E)d.push(...this.getAllPackExtensionsToUninstall(v,r,o));return[...E,...d]}return[]}getDependents(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(w=>(0,c.areSameExtensions)({id:w},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=p,e.AbstractExtensionManagementService=p=ye([X(0,S.IExtensionGalleryService),X(1,h.ITelemetryService),X(2,l.IUriIdentityService),X(3,y.ILogService),X(4,m.IProductService),X(5,u.IUserDataProfilesService)],p);function b(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=b;function t(s){if(s instanceof S.ExtensionManagementError)return s;const i=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}e.toExtensionManagementError=t;function a(s,i,{extensionData:r,verificationStatus:o,duration:w,error:E,durationSinceUpdate:d}){let v,T;(0,f.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(v=S.ExtensionManagementErrorCode.Signature,T=o),o="Unverified")),E&&(E instanceof S.ExtensionManagementError?(v=E.code,E.code===S.ExtensionManagementErrorCode.Signature&&(T=E.message)):v=S.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...r,verificationStatus:o,success:!E,duration:w,errorcode:v,errorcodeDetail:T,durationSinceUpdate:d})}class n{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>new Promise((r,o)=>{const w=i.onCancellationRequested(()=>{w.dispose(),o(new U.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(oe[50],ae([0,1,5,15,2,3,34,10,29,33,11,4,7,17,28,12,8,22]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class u extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=u,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let p=class extends A.Disposable{constructor(n,s,i,r,o,w){super(),this.extensionsLocation=n,this.fileService=s,this.userDataProfilesService=i,this.uriIdentityService=r,this.telemetryService=o,this.logService=w,this._onAddExtensions=this._register(new U.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new U.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new U.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new U.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(n,s){return this.withProfileExtensions(n,void 0,s)}async addExtensionsToProfile(n,s){const i=[],r=[];try{return await this.withProfileExtensions(s,o=>{const w=[];for(const E of o)n.some(([d])=>(0,f.areSameExtensions)(d.identifier,E.identifier)&&d.manifest.version!==E.version)?i.push(E):w.push(E);for(const[E,d]of n){const v=w.findIndex(N=>(0,f.areSameExtensions)(N.identifier,E.identifier)&&N.version===E.manifest.version),T={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:d};v===-1?(r.push(T),w.push(T)):w.splice(v,1,T)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:s}),i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:s}),w}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:s}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:s}),r}catch(o){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:o,profileLocation:s}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:o,profileLocation:s}),o}}async updateMetadata(n,s){const i=[];return await this.withProfileExtensions(s,r=>{const o=[];for(const w of r){const E=n.find(([d])=>(0,f.areSameExtensions)(d.identifier,w.identifier)&&d.manifest.version===w.version);E&&(w.metadata={...w.metadata,...E[1]},i.push(w)),o.push(w)}return o}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.withProfileExtensions(s,r=>{const o=[];for(const w of r)(0,f.areSameExtensions)(w.identifier,n.identifier)?i.push(w):o.push(w);return i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:s}),o}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:s})}catch(r){throw i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:r,profileLocation:s}),r}}async withProfileExtensions(n,s,i){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],o;try{const w=await this.fileService.readFile(n);o=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,D.toFileOperationResult)(w)!==1)throw w;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(o=await this.migrateFromOldDefaultProfileExtensionsLocation()),!o&&i?.bailOutWhenFileNotFound)throw new u((0,m.getErrorMessage)(w),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.reportAndThrowInvalidConentError(n);let w=!1;for(const E of o){b(E)||this.reportAndThrowInvalidConentError(n);let d;if((0,y.isString)(E.relativeLocation)&&E.relativeLocation)d=this.resolveExtensionLocation(E.relativeLocation);else if((0,y.isString)(E.location))d=this.resolveExtensionLocation(E.location),w=!0,E.relativeLocation=E.location,E.location=d.toJSON();else{d=L.URI.revive(E.location);const v=this.toRelativePath(d);v&&(w=!0,E.relativeLocation=v)}r.push({identifier:E.identifier,location:d,version:E.version,metadata:E.metadata})}w&&await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(o)))}if(s){r=s(r);const w=r.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.toRelativePath(E.location),metadata:E.metadata}));await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(w)))}return r})}reportAndThrowInvalidConentError(n){const s=new u(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let i;try{i=(await this.fileService.readFile(n)).value.toString()}catch(o){if((0,D.toFileOperationResult)(o)===1)return;throw o}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(i);Array.isArray(o)&&o.every(w=>b(w))?r=o:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.logService.error(o)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(o){if((0,D.toFileOperationResult)(o)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw o}try{await this.fileService.del(n)}catch(o){(0,D.toFileOperationResult)(o)!==1&&this.logService.error(o)}try{await this.fileService.del(s)}catch(o){(0,D.toFileOperationResult)(o)!==1&&this.logService.error(o)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let s=this.resourcesAccessQueueMap.get(n);return s||(s=new k.Queue,this.resourcesAccessQueueMap.set(n,s)),s}};e.AbstractExtensionsProfileScannerService=p,e.AbstractExtensionsProfileScannerService=p=ye([X(1,D.IFileService),X(2,c.IUserDataProfilesService),X(3,g.IUriIdentityService),X(4,h.ITelemetryService),X(5,S.ILogService)],p);function b(a){return(0,y.isObject)(a)&&(0,I.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,y.isString)(a.location)&&a.location)&&((0,y.isUndefined)(a.relativeLocation)||(0,y.isString)(a.relativeLocation))&&a.version&&(0,y.isString)(a.version)}function t(a){return a?(0,y.isString)(a.path)&&(0,y.isString)(a.scheme):!1}}),define(oe[79],ae([0,1,18,5,30,15,8,35,139,2,23,16,6,21,53,89,12,10,155,14,33,44,67,11,4,7,24,3,63,50,17,28,183]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t,a,n,s,i,r,o,w,E,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(Q){function B(K,V){if(K===V)return!0;const z=Object.keys(K),x=new Set;for(const ee of Object.keys(V))x.add(ee);if(z.length!==x.size)return!1;for(const ee of z){if(K[ee]!==V[ee])return!1;x.delete(ee)}return x.size===0}Q.equals=B})(T||(e.Translations=T={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let N=class extends f.Disposable{constructor(B,K,V,z,x,ee,ne,re,J,q,P,R){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=K,this.extensionsControlLocation=V,this.currentProfile=z,this.userDataProfilesService=x,this.extensionsProfileScannerService=ee,this.fileService=ne,this.logService=re,this.environmentService=J,this.productService=q,this.uriIdentityService=P,this.instantiationService=R,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,c.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance($,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,K,V){const[z,x]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(K)]),ee=V?await this.scanExtensionsUnderDevelopment(B,[...z,...x]):[];return this.dedupExtensions(z,x,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const K=[];K.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),K.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[V,z]=await Promise.all(K);return this.applyScanOptions([...V,...z],0,B,!1)}async scanUserExtensions(B){const K=B.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",K);const V=this.uriIdentityService.extUri.isEqual(B.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.createExtensionScannerInput(K,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,V),x=B.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ee;try{ee=await x.scanExtensions(z)}catch(ne){if(ne instanceof w.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ee=await x.scanExtensions(z);else throw ne}return ee=await this.applyScanOptions(ee,1,B,!0),this.logService.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(B,K){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===D.Schemas.file).map(async z=>{const x=await this.createExtensionScannerInput(z,!1,1,!0,B.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(x)).map(ne=>(ne.type=K.find(re=>(0,p.areSameExtensions)(re.identifier,ne.identifier))?.type??ne.type,this.extensionsScanner.validate(ne,x)))}))).flat();return this.applyScanOptions(V,"development",B,!0)}return[]}async scanExistingExtension(B,K,V){const z=await this.createExtensionScannerInput(B,!1,K,!0,V.language,!0,void 0),x=await this.extensionsScanner.scanExtension(z);return!x||!V.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(B,K,V){const z=await this.createExtensionScannerInput(B,!1,K,!0,V.language,!0,void 0),x=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(x,K,V,!0)}async scanMetadata(B){const K=(0,c.joinPath)(B,"package.json"),V=(await this.fileService.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(B,K){const V=(0,c.joinPath)(B,"package.json"),z=(await this.fileService.readFile(V)).value.toString(),x=JSON.parse(z);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,x.__metadata={...x.__metadata,...K},await this.fileService.writeFile((0,c.joinPath)(B,"package.json"),U.VSBuffer.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof w.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw B}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(K=>[K,K.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify([])))}catch(K){(0,a.toFileOperationResult)(K)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(K))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.logService.error(B)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(B,K,V,z){return V.includeAllVersions||(B=this.dedupExtensions(K===0?B:void 0,K===1?B:void 0,K==="development"?B:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(B=B.filter(x=>x.isValid)),B.sort((x,ee)=>{const ne=C.basename(x.location.fsPath),re=C.basename(ee.location.fsPath);return ne<re?-1:ne>re?1:0})}dedupExtensions(B,K,V,z,x){const ee=(re,J,q)=>{if(re.isValid&&!J.isValid)return!1;if(re.isValid===J.isValid){if(x&&g.gt(re.manifest.version,J.manifest.version))return this.logService.debug(`Skipping extension ${J.location.path} with lower version ${J.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,J.manifest.version)){if(re.type===0)return this.logService.debug(`Skipping extension ${J.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===z)return this.logService.debug(`Skipping extension ${J.location.path} from different target platform ${J.targetPlatform}`),!1}}return q?this.logService.warn(`Overwriting user extension ${re.location.path} with ${J.location.path}.`):this.logService.debug(`Overwriting user extension ${re.location.path} with ${J.location.path}.`),!0},ne=new b.ExtensionIdentifierMap;return B?.forEach(re=>{const J=ne.get(re.identifier.id);(!J||ee(J,re,!1))&&ne.set(re.identifier.id,re)}),K?.forEach(re=>{const J=ne.get(re.identifier.id);if(!J&&B&&re.type===0){this.logService.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!J||ee(J,re,!1))&&ne.set(re.identifier.id,re)}),V?.forEach(re=>{const J=ne.get(re.identifier.id);(!J||ee(J,re,!0))&&ne.set(re.identifier.id,re),ne.set(re.identifier.id,re)}),[...ne.values()]}async scanDefaultSystemExtensions(B,K){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),x=await(B&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",x.length),x}async scanDevSystemExtensions(B,K){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=K?await this.getBuiltInExtensionControl():{},x=[],ee=h.URI.file(C.normalize(C.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of V){const J=z[re.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":x.push((0,c.joinPath)(ee,re.name));break;default:x.push(h.URI.file(J));break}}const ne=await Promise.all(x.map(async re=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(re,!1,0,!0,B,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ne.length),(0,k.coalesce)(ne)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,K,V,z,x,ee,ne){const re=await this.getTranslations(x??S.language),J=await this.getMtime(B),q=K&&!this.uriIdentityService.extUri.isEqual(B,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=q?await this.getMtime(q):void 0;return new M(B,J,q,P,K,ne,V,z,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,x,re)}async getMtime(B){try{const K=await this.fileService.stat(B);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.AbstractExtensionsScannerService=N,e.AbstractExtensionsScannerService=N=ye([X(4,E.IUserDataProfilesService),X(5,w.IExtensionsProfileScannerService),X(6,a.IFileService),X(7,s.ILogService),X(8,u.IEnvironmentService),X(9,i.IProductService),X(10,d.IUriIdentityService),X(11,n.IInstantiationService)],N);class M{constructor(B,K,V,z,x,ee,ne,re,J,q,P,R,W,F,H){this.location=B,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=x,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=re,this.validate=J,this.productVersion=q,this.productDate=P,this.productCommit=R,this.devMode=W,this.language=F,this.translations=H}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,K){return(0,c.isEqual)(B.location,K.location)&&B.mtime===K.mtime&&(0,c.isEqual)(B.applicationExtensionslocation,K.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&B.profile===K.profile&&A.equals(B.profileScanOptions,K.profileScanOptions)&&B.type===K.type&&B.excludeObsolete===K.excludeObsolete&&B.validate===K.validate&&B.productVersion===K.productVersion&&B.productDate===K.productDate&&B.productCommit===K.productCommit&&B.devMode===K.devMode&&B.language===K.language&&T.equals(B.translations,K.translations)}}e.ExtensionScannerInput=M;let $=class extends f.Disposable{constructor(B,K,V,z,x){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=K,this.uriIdentityService=V,this.fileService=z,this.logService=x}async scanExtensions(B){const K=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let V={};if(B.excludeObsolete&&B.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(z)}catch{}return(0,m.isEmptyObject)(V)?K:K.filter(z=>!V[p.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(B){const K=await this.fileService.resolve(B.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async z=>{if(!z.isDirectory||B.type===1&&(0,c.basename)(z.resource).indexOf(".")===0)return null;const x=new M(z.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(x)}));return(0,k.coalesce)(V).sort((z,x)=>z.location.path<x.location.path?-1:1)}async scanExtensionsFromProfile(B){let K=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){K=K.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,B);K.push(...V)}return K}async scanExtensionsFromProfileResource(B,K,V){const z=await this.extensionsProfileScannerService.scanProfileExtensions(B,V.profileScanOptions);if(!z.length)return[];const x=await Promise.all(z.map(async ee=>{if(K(ee)){const ne=new M(ee.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,k.coalesce)(x)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,c.joinPath)(B.location,"package.json"))){const K=await this.scanExtension(B);return K?[K]:[]}else return await this.scanExtensions(B)}catch(K){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,_.getErrorMessage)(K)),[]}}async scanExtension(B,K){try{let V=await this.scanExtensionManifest(B.location);if(V){V.publisher||(V.publisher=b.UNDEFINED_PUBLISHER),K=K??V.__metadata,delete V.__metadata;const z=(0,p.getGalleryExtensionId)(V.publisher,V.name),x=K?.id?{id:z,uuid:K.id}:{id:z},ee=K?.isSystem?0:B.type,ne=ee===0||!!K?.isBuiltin;V=await this.translateManifest(B.location,V,M.createNlsConfiguration(B));const re={type:ee,identifier:x,manifest:V,location:B.location,isBuiltin:ne,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return B.validate?this.validate(re,B):re}}catch(V){B.type!==0&&this.logService.error(V)}return null}validate(B,K){let V=!0;const z=(0,t.validateExtensionManifest)(K.productVersion,K.productDate,K.location,B.manifest,B.isBuiltin);for(const[x,ee]of z)x===y.default.Error&&(V=!1,this.logService.error(this.formatMessage(K.location,ee)));return B.isValid=V,B.validations=z,B}async scanExtensionManifest(B){const K=(0,c.joinPath)(B,"package.json");let V;try{V=(await this.fileService.readFile(K)).value.toString()}catch(x){return(0,a.toFileOperationResult)(x)!==1&&this.logService.error(this.formatMessage(B,(0,l.localize)(0,null,K.path,x.message))),null}let z;try{z=JSON.parse(V)}catch{const ee=[];(0,L.parse)(V,ee);for(const ne of ee)this.logService.error(this.formatMessage(B,(0,l.localize)(1,null,K.path,ne.offset,ne.length,(0,I.getParseErrorMessage)(ne.error))));return null}return(0,L.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(B,(0,l.localize)(2,null,K.path))),null):z}async translateManifest(B,K,V){const z=await this.getLocalizedMessages(B,K,V);if(z)try{const x=[],ee=await this.resolveOriginalMessageBundle(z.default,x);if(x.length>0)return x.forEach(re=>{this.logService.error(this.formatMessage(B,(0,l.localize)(3,null,z.default?.path,(0,I.getParseErrorMessage)(re.error))))}),K;if((0,L.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(B,(0,l.localize)(4,null,z.default?.path))),K;const ne=z.values||Object.create(null);return(0,v.localizeManifest)(this.logService,K,ne,ee)}catch{}return K}async getLocalizedMessages(B,K,V){const z=(0,c.joinPath)(B,"package.nls.json"),x=(J,q)=>{q.forEach(P=>{this.logService.error(this.formatMessage(B,(0,l.localize)(5,null,J?.path,(0,I.getParseErrorMessage)(P.error))))})},ee=J=>{this.logService.error(this.formatMessage(B,(0,l.localize)(6,null,J?.path)))},ne=`${K.publisher}.${K.name}`,re=V.translations[ne];if(re)try{const J=h.URI.file(re),q=(await this.fileService.readFile(J)).value.toString(),P=[],R=(0,L.parse)(q,P);return P.length>0?(x(J,P),{values:void 0,default:z}):(0,L.getNodeType)(R)!=="object"?(ee(J),{values:void 0,default:z}):{values:R.contents?R.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let q;try{q=await this.findMessageBundles(B,V)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const P=(await this.fileService.readFile(q.localized)).value.toString(),R=[],W=(0,L.parse)(P,R);return R.length>0?(x(q.localized,R),{values:void 0,default:q.original}):(0,L.getNodeType)(W)!=="object"?(ee(q.localized),{values:void 0,default:q.original}):{values:W,default:q.original}}catch{return{values:void 0,default:q.original}}}}async resolveOriginalMessageBundle(B,K){if(B)try{const V=(await this.fileService.readFile(B)).value.toString();return(0,L.parse)(V,K)}catch{}}findMessageBundles(B,K){return new Promise((V,z)=>{const x=ee=>{const ne=(0,c.joinPath)(B,`package.nls.${ee}.json`);this.fileService.exists(ne).then(re=>{re&&V({localized:ne,original:(0,c.joinPath)(B,"package.nls.json")});const J=ee.lastIndexOf("-");J===-1?V({localized:(0,c.joinPath)(B,"package.nls.json"),original:null}):(ee=ee.substring(0,J),x(ee))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,c.joinPath)(B,"package.nls.json"),original:null});x(K.language)})}formatMessage(B,K){return`[${B.path}]: ${K}`}};$=ye([X(1,w.IExtensionsProfileScannerService),X(2,d.IUriIdentityService),X(3,a.IFileService),X(4,s.ILogService)],$);let j=class extends ${constructor(B,K,V,z,x,ee,ne){super(K,z,x,ee,ne),this.currentProfile=B,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const K=this.getCacheFile(B),V=await this.readExtensionCache(K);if(this.input=B,V&&V.input&&M.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",B.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(x=>(x.location=h.URI.revive(x.location),x));const z=await super.scanExtensions(B);return await this.writeExtensionCache(K,{input:B,result:z}),z}async readExtensionCache(B){try{const K=await this.fileService.readFile(B),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,o.revive)(V.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",B.path,(0,_.getErrorMessage)(K))}return null}async writeExtensionCache(B,K){try{await this.fileService.writeFile(B,U.VSBuffer.fromString(JSON.stringify(K)))}catch(V){this.logService.debug("Error while writing the extension cache file:",B.path,(0,_.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const B=this.getCacheFile(this.input),K=await this.readExtensionCache(B);if(!K)return;const V=K.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!A.equals(z,V))try{this.logService.info("Invalidating Cache",V,z),await this.fileService.del(B),this._onDidChangeCache.fire()}catch(x){this.logService.error(x)}}getCacheFile(B){const K=this.getProfile(B);return this.uriIdentityService.extUri.joinPath(K.cacheHome,B.type===0?b.BUILTIN_MANIFEST_CACHE_FILE:b.USER_MANIFEST_CACHE_FILE)}getProfile(B){return B.type===0?this.userDataProfilesService.defaultProfile:B.profile?this.uriIdentityService.extUri.isEqual(B.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(K=>this.uriIdentityService.extUri.isEqual(B.location,K.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};j=ye([X(2,E.IUserDataProfilesService),X(3,w.IExtensionsProfileScannerService),X(4,d.IUriIdentityService),X(5,a.IFileService),X(6,s.ILogService)],j);function Z(Q,B){const K=(0,p.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:K,identifier:new b.ExtensionIdentifier(K),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:B,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=Z;class G extends N{constructor(B,K,V,z,x,ee,ne,re,J,q,P,R){super(B,K,(0,c.joinPath)(V,".vscode-oss-dev","extensions","control.json"),z,x,ee,ne,re,J,q,P,R),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const W=await this.fileService.readFile(h.URI.file(S.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}e.NativeExtensionsScannerService=G}),define(oe[244],ae([0,1,64,5,38,3,2,23,16,31,7,17]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends _.Disposable{constructor(g,y){super(),this.userDataProfilesService=g,this.logService=y,this.processesLimiter=new O.Limiter(5)}async postUninstall(g){const y=this.parseScript(g,"uninstall");y&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,g),this.logService.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(m){this.logService.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.logService.error(m)}}));try{await f.Promises.rm(this.getExtensionStoragePath(g))}catch(m){this.logService.error("Error while removing extension storage path",g.identifier.id),this.logService.error(m)}}parseScript(g,y){const m=`vscode:${y}`;if(g.location.scheme===L.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[m]=="string"){const h=g.manifest.scripts[m].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${m} should be a node script`),null):{script:(0,I.join)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(g,y,m,h,l){return new Promise((u,p)=>{const b=this.start(g,y,m,l);let t;const a=n=>{t&&(clearTimeout(t),t=null),n?p(n):u(void 0)};b.on("error",n=>{a((0,A.toErrorMessage)(n)||"Unknown")}),b.on("exit",(n,s)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),h&&(t=setTimeout(()=>{t=null,b.kill(),p("timed out")},5e3))})}start(g,y,m,h){const l={silent:!0,execArgv:void 0},u=(0,k.fork)(g,[`--type=extension-post-${y}`,...m],l);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const p=U.Event.fromNodeEventEmitter(u.stdout,"data"),b=U.Event.fromNodeEventEmitter(u.stderr,"data");p(n=>this.logService.info(h.identifier.id,h.manifest.version,`post-${y}`,n)),b(n=>this.logService.error(h.identifier.id,h.manifest.version,`post-${y}`,n));const t=U.Event.any(U.Event.map(p,n=>({data:`%c${n}`,format:[""]})),U.Event.map(b,n=>({data:`%c${n}`,format:["color: red"]})));return U.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}getExtensionStoragePath(g){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=S,e.ExtensionsLifecycle=S=ye([X(0,C.IUserDataProfilesService),X(1,D.ILogService)],S)}),define(oe[245],ae([0,1,7,17,28,22,50,11,14,10]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=class extends _.AbstractExtensionsProfileScannerService{constructor(S,c,g,y,m,h){super(f.URI.file(S.extensionsPath),c,g,y,m,h)}};e.ExtensionsProfileScannerService=D,e.ExtensionsProfileScannerService=D=ye([X(0,I.INativeEnvironmentService),X(1,L.IFileService),X(2,O.IUserDataProfilesService),X(3,A.IUriIdentityService),X(4,U.ITelemetryService),X(5,k.ILogService)],D)}),define(oe[246],ae([0,1,10,14,50,79,11,4,7,24,28,17]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends U.NativeExtensionsScannerService{constructor(g,y,m,h,l,u,p,b){super(k.URI.file(l.builtinExtensionsPath),k.URI.file(l.extensionsPath),l.userHome,g.defaultProfile,g,y,m,h,l,u,p,b)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=ye([X(0,C.IUserDataProfilesService),X(1,A.IExtensionsProfileScannerService),X(2,_.IFileService),X(3,I.ILogService),X(4,O.INativeEnvironmentService),X(5,f.IProductService),X(6,D.IUriIdentityService),X(7,L.IInstantiationService)],S)}),define(oe[20],ae([0,1,5,3,2,100,12,66,4,17]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var D;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var C;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var S;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function c(l){const u=l.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=c;class g extends A.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(u={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=u,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(u,p,b){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===u&&(p===void 0||t.key===p),b)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,U.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,U.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,p){const{key:b,external:t}=p;if(b===e.TARGET_KEY){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:b,target:this.getKeyTargets(u)[b],external:t})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,p,b){return this.getStorage(p)?.get(u,b)}getBoolean(u,p,b){return this.getStorage(p)?.getBoolean(u,b)}getNumber(u,p,b){return this.getStorage(p)?.getNumber(u,b)}getObject(u,p,b){return this.getStorage(p)?.getObject(u,b)}storeAll(u,p){this.withPausedEmitters(()=>{for(const b of u)this.store(b.key,b.value,b.scope,b.target,p)})}store(u,p,b,t,a=!1){if((0,_.isUndefinedOrNull)(p)){this.remove(u,b,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,b,t),this.getStorage(b)?.set(u,p,a)})}remove(u,p,b=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(u,p,void 0),this.getStorage(p)?.delete(u,b)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,p){const b=[],t=this.getKeyTargets(u);for(const a of Object.keys(t))t[a]===p&&b.push(a);return b}updateKeyTarget(u,p,b,t=!1){const a=this.getKeyTargets(p);typeof b=="number"?a[u]!==b&&(a[u]=b,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(a),t)):typeof a[u]=="number"&&(delete a[u],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(a),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const p=this.getStorage(u);return p?c(p):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=D.NONE){this._onWillSaveState.fire({reason:u});const p=this.getStorage(-1),b=this.getStorage(0),t=this.getStorage(1);switch(u){case D.NONE:await k.Promises.settled([p?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await k.Promises.settled([p?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(u,p,b,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(u){return await this.flush(),this.getStorage(u)?.optimize()}async switch(u,p){return this.emitWillSaveState(D.NONE),(0,f.isUserDataProfile)(u)?this.switchToProfile(u,p):this.switchToWorkspace(u,p)}canSwitchProfile(u,p){return!(u.id===p.id||y(p)&&y(u))}switchData(u,p,b){this.withPausedEmitters(()=>{const t=new Set;for(const[a,n]of u)t.add(a),p.get(a)!==n&&this.emitDidChangeValue(b,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.emitDidChangeValue(b,{key:a,external:!0})})}}e.AbstractStorageService=g;function y(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=y;class m extends g{constructor(){super(),this.applicationStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(u){return!1}}e.InMemoryStorageService=m;async function h(l,u,p,b,t,a){const n=T=>{try{return JSON.parse(T)}catch{return T}},s=new Map,i=new Map;l.forEach((T,N)=>{s.set(N,T),i.set(N,n(T))});const r=new Map,o=new Map;u.forEach((T,N)=>{r.set(N,T),o.set(N,n(T))});const w=new Map,E=new Map;p.forEach((T,N)=>{w.set(N,T),E.set(N,n(T))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const d=[];if(s.forEach((T,N)=>{d.push({key:N,value:T})}),console.table(d),console.groupEnd(),console.log(i),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];r.forEach((N,M)=>{T.push({key:M,value:N})}),console.table(T),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const v=[];w.forEach((T,N)=>{v.push({key:N,value:T})}),console.table(v),console.groupEnd(),console.log(E)}e.logStorage=h}),define(oe[114],ae([0,1,3,2,12,29,33,20]),function(te,e,k,O,A,U,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends O.Disposable{constructor(C,S){super(),this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new f(C)),this._register(this.storageManger.onDidChange(c=>this._onDidChangeEnablement.fire({extensions:c,source:"storage"}))),this._register(S.onDidInstallExtensions(c=>c.forEach(({local:g,operation:y})=>{g&&y===4&&this._removeFromDisabledExtensions(g.identifier)})))}async enableExtension(C,S){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:S}),!0):!1}async disableExtension(C,S){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(U.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){const S=this.getDisabledExtensions();return S.every(c=>!(0,_.areSameExtensions)(c,C))?(S.push(C),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(C){const S=this.getDisabledExtensions();for(let c=0;c<S.length;c++){const g=S[c];if((0,_.areSameExtensions)(g,C))return S.splice(c,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(C){this._setExtensions(U.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,S){this.storageManger.set(C,S,0)}};e.GlobalExtensionEnablementService=I,e.GlobalExtensionEnablementService=I=ye([X(0,L.IStorageService),X(1,U.IExtensionManagementService)],I);class f extends O.Disposable{constructor(C){super(),this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(0,void 0,this._register(new O.DisposableStore))(S=>this.onDidStorageChange(S)))}get(C,S){let c;return S===0?((0,A.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,S)),c=this.storage[C]):c=this._get(C,S),JSON.parse(c)}set(C,S,c){const g=JSON.stringify(S.map(({id:m,uuid:h})=>({id:m,uuid:h})));this._get(C,c)!==g&&(c===0&&(S.length?this.storage[C]=g:delete this.storage[C]),this._set(C,S.length?g:void 0,c))}onDidStorageChange(C){if(!(0,A.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const c=this.get(C.key,C.scope);delete this.storage[C.key];const g=this.get(C.key,C.scope),y=c.filter(h=>!g.some(l=>(0,_.areSameExtensions)(h,l))),m=g.filter(h=>!c.some(l=>(0,_.areSameExtensions)(l,h)));(y.length||m.length)&&this._onDidChange.fire([...y,...m])}}_get(C,S){return this.storageService.get(C,S,"[]")}_set(C,S,c){S?this.storageService.store(C,S,c,1):this.storageService.remove(C,c)}}e.StorageManager=f}),define(oe[247],ae([0,1,18,26,8,6,37,12,10,19,14,29,33,67,11,7,24,57,224,20,22,60]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=U.isWeb?"web":(0,C.getTargetPlatform)(U.platform,_.arch),a="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...P){return String(P.reduce((R,W)=>R|W,0))}var i;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class d{constructor(R=E){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(R,W=this.state.pageSize){return new d({...this.state,pageNumber:R,pageSize:W})}withFilter(R,...W){const F=[...this.state.criteria,...W.length?W.map(H=>({filterType:R,value:H})):[{filterType:R}]];return new d({...this.state,criteria:F})}withSortBy(R){return new d({...this.state,sortBy:R})}withSortOrder(R){return new d({...this.state,sortOrder:R})}withFlags(...R){return new d({...this.state,flags:R.reduce((W,F)=>W|F,0)})}withAssetTypes(...R){return new d({...this.state,assetTypes:R})}withSource(R){return new d({...this.state,source:R})}get raw(){const{criteria:R,pageNumber:W,pageSize:F,sortBy:H,sortOrder:Y,flags:se,assetTypes:le}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:F,sortBy:H,sortOrder:Y}],assetTypes:le,flags:se}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function v(P,R){const W=(P||[]).filter(F=>F.statisticName===R)[0];return W?W.value:0}function T(P){const R="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(F=>F.assetType.indexOf(R)===0).reduce((F,H)=>{const Y=$(P,H.assetType);return Y&&F.push([H.assetType.substring(R.length),Y]),F},[])}function N(P){if(P.properties){const R=P.properties.filter(H=>H.key===r.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=R.filter(H=>W.test(H.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return $(P,r.Repository)}function M(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function $(P,R){return P.files.filter(F=>F.assetType===R)[0]?{uri:`${P.assetUri}/${R}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${R}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function j(P,R){const W=P.properties?P.properties.filter(H=>H.key===R):[],F=W.length>0&&W[0].value;return F?F.split(",").map(H=>(0,S.adoptToGalleryExtensionId)(H)):[]}function Z(P){const R=P.properties?P.properties.filter(W=>W.key===o.Engine):[];return R.length>0&&R[0].value||""}function G(P){const R=P.properties?P.properties.filter(W=>W.key===o.PreRelease):[];return R.length>0&&R[0].value==="true"}function Q(P){const R=P.properties?P.properties.filter(F=>F.key===o.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function B(P){return P.properties?.find(R=>R.key===o.SponsorLink)?.value}function K(P){return P.indexOf("preview")!==-1}function V(P){return P.targetPlatform?(0,C.toTargetPlatform)(P.targetPlatform):"undefined"}function z(P){const R=(0,k.distinct)(P.versions.map(V)),W=!!P.tags?.includes(C.WEB_EXTENSION_TAG),F=R.indexOf("web");return W?F===-1&&R.push("web"):F!==-1&&R.splice(F,1),R}function x(P,R){const W=(0,C.getFallbackTargetPlarforms)(R);for(let F=0;F<P.length;F++){const H=P[F];if(H.version===P[F-1]?.version){let Y=F;const se=V(H);if(se===R)for(;Y>0&&P[Y-1].version===H.version;)Y--;else if(W.includes(se))for(;Y>0&&P[Y-1].version===H.version&&V(P[Y-1])!==R;)Y--;Y!==F&&(P.splice(F,1),P.splice(Y,0,H))}}return P}e.sortExtensionVersions=x;function ee(P,R,W){P.telemetryData={index:R,querySource:W,queryActivityId:P.queryContext?.[a]}}function ne(P,R,W,F){const H=P.versions[0],Y={manifest:$(R,r.Manifest),readme:$(R,r.Details),changelog:$(R,r.Changelog),license:$(R,r.License),repository:N(R),download:M(R),icon:$(R,r.Icon),signature:$(R,r.Signature),coreTranslations:T(R)};return{identifier:{id:(0,S.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:R.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(H),description:P.shortDescription||"",installCount:v(P.statistics,"install"),rating:v(P.statistics,"averagerating"),ratingCount:v(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:W,assets:Y,properties:{dependencies:j(R,o.Dependency),extensionPack:j(R,o.ExtensionPack),engine:Z(R),localizedLanguages:Q(R),targetPlatform:V(R),isPreReleaseVersion:G(R)},hasPreReleaseVersion:G(H),hasReleaseVersion:!0,preview:K(P.flags),isSigned:!!Y.signature,queryContext:F}}let re=class{constructor(R,W,F,H,Y,se,le,he){this.requestService=W,this.logService=F,this.environmentService=H,this.telemetryService=Y,this.fileService=se,this.productService=le,this.configurationService=he;const ue=le.extensionsGallery,me=ue?.servicePPEUrl&&he.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=me?ue.servicePPEUrl:ue?.serviceUrl,this.extensionsGallerySearchUrl=me?void 0:ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,l.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,R,this.telemetryService)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W,F){const H=O.CancellationToken.isCancellationToken(W)?{}:W,Y=O.CancellationToken.isCancellationToken(W)?W:F,se=[],le=[],he=[],ue=[];let me=!0;for(const Ce of R){Ce.uuid?le.push(Ce.uuid):se.push(Ce.id);const Le=!!(Ce.version||Ce.preRelease);he.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Le}),Ce.version&&ue.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),me=me&&!!Ce.hasPreRelease&&!Le}if(!le.length&&!se.length)return[];let fe=new d().withPage(1,R.length);le.length&&(fe=fe.withFilter(i.ExtensionId,...le)),se.length&&(fe=fe.withFilter(i.ExtensionName,...se)),(H.queryAllVersions||me)&&(fe=fe.withFlags(fe.flags,n.IncludeVersions)),H.source&&(fe=fe.withSource(H.source));const{extensions:pe}=await this.queryGalleryExtensions(fe,{targetPlatform:H.targetPlatform??t,includePreRelease:he,versions:ue,compatible:!!H.compatible},Y);return H.source&&pe.forEach((Ce,Le)=>ee(Ce,Le,H.source)),pe}async getCompatibleExtension(R,W,F){if((0,C.isNotWebExtensionInWebTargetPlatform)(R.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(R,W,F))return R;const H=new d().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,R.identifier.uuid),{extensions:Y}=await this.queryGalleryExtensions(H,{targetPlatform:F,compatible:!0,includePreRelease:W},O.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(R,W,F){if(!(0,C.isTargetPlatformCompatible)(R.properties.targetPlatform,R.allTargetPlatforms,F)||!W&&R.properties.isPreReleaseVersion)return!1;let H=R.properties.engine;if(!H){const Y=await this.getManifest(R,O.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");H=Y.engines.vscode}return(0,c.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(R,W,F,H,Y){if(!(0,C.isTargetPlatformCompatible)(V(R),H,Y)||W!=="any"&&G(R)!==(W==="prerelease"))return!1;if(F)try{const se=await this.getEngine(R);if(!(0,c.isEngineValid)(se,this.productService.version,this.productService.date))return!1}catch(se){return this.logService.error(`Error while getting the engine for the version ${R.version}.`,(0,A.getErrorMessage)(se)),!1}return!0}async query(R,W){let F=R.text||"";const H=R.pageSize??50;let Y=new d().withPage(1,H);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,pe)=>(Y=Y.withFilter(i.Category,pe||fe),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,pe)=>(Y=Y.withFilter(i.Tag,pe||fe),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),Y=Y.withFilter(i.SearchText,F)),Y=Y.withSortBy(0)):R.ids?Y=Y.withFilter(i.ExtensionId,...R.ids):R.names?Y=Y.withFilter(i.ExtensionName,...R.names):Y=Y.withSortBy(4),typeof R.sortBy=="number"&&(Y=Y.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(Y=Y.withSortOrder(R.sortOrder)),R.source&&(Y=Y.withSource(R.source));const se=async(me,fe)=>{const{extensions:pe,total:Ce}=await this.queryGalleryExtensions(me,{targetPlatform:t,compatible:!1,includePreRelease:!!R.includePreRelease},fe);return pe.forEach((Le,Oe)=>ee(Le,(me.pageNumber-1)*me.pageSize+Oe,R.source)),{extensions:pe,total:Ce}},{extensions:le,total:he}=await se(Y,W),ue=async(me,fe)=>{if(fe.isCancellationRequested)throw new A.CancellationError;const{extensions:pe}=await se(Y.withPage(me+1),fe);return pe};return{firstPage:le,total:he,pageSize:Y.pageSize,getPage:ue}}async queryGalleryExtensions(R,W,F){const H=R.flags;R.flags&n.IncludeLatestVersionOnly&&R.flags&n.IncludeVersions&&(R=R.withFlags(R.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(R.flags&n.IncludeLatestVersionOnly)&&!(R.flags&n.IncludeVersions)&&(R=R.withFlags(R.flags,n.IncludeLatestVersionOnly)),W.versions?.length&&(R=R.withFlags(R.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),R=R.withFlags(R.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Y,total:se,context:le}=await this.queryRawGalleryExtensions(R,F);if(!(R.flags&n.IncludeLatestVersionOnly)){const fe=[];for(const pe of Y){const Ce=await this.toGalleryExtensionWithCriteria(pe,W,le);Ce&&fe.push(Ce)}return{extensions:fe,total:se}}const ue=[],me=new Map;for(let fe=0;fe<Y.length;fe++){const pe=Y[fe],Ce={id:(0,S.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Le=(0,L.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Me=>(0,S.areSameExtensions)(Me,Ce))?.includePreRelease;if(W.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(z(pe),W.targetPlatform))continue;const Oe=await this.toGalleryExtensionWithCriteria(pe,W,le);!Oe||Oe.properties.isPreReleaseVersion&&(!Le||!Oe.hasReleaseVersion)||!Oe.properties.isPreReleaseVersion&&Oe.properties.targetPlatform!==W.targetPlatform&&Oe.hasPreReleaseVersion?me.set(pe.extensionId,fe):ue.push([fe,Oe])}if(me.size){const fe=new b.StopWatch,pe=new d().withFlags(H&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,me.size).withFilter(i.ExtensionId,...me.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,W,F);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:me.size});for(const Le of Ce){const Oe=me.get(Le.identifier.uuid);ue.push([Oe,Le])}}return{extensions:ue.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:se}}async toGalleryExtensionWithCriteria(R,W,F){const H={id:(0,S.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},Y=W.versions?.find(ue=>(0,S.areSameExtensions)(ue,H))?.version,se=(0,L.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(ue=>(0,S.areSameExtensions)(ue,H))?.includePreRelease,le=z(R),he=x(R.versions,W.targetPlatform);if(W.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(le,W.targetPlatform))return null;for(let ue=0;ue<he.length;ue++){const me=he[ue];if(!(Y&&me.version!==Y)){if(await this.isValidVersion(me,se?"any":"release",W.compatible,le,W.targetPlatform))return ne(R,me,le,F);if(Y&&me.version===Y)return null}}return Y||W.compatible?null:ne(R,R.versions[0],le)}async queryRawGalleryExtensions(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const F=await this.commonHeadersPromise,H=JSON.stringify(R.raw),Y={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},se=new b.StopWatch;let le,he,ue=0;try{if(le=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&R.criteria.some(fe=>fe.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:Y},W),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ue};const me=await(0,h.asJson)(le);if(me){const fe=me.results[0],pe=fe.extensions,Ce=fe.resultMetadata&&fe.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return ue=Ce&&Ce.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:ue,context:{[a]:le.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(me){throw he=me,me}finally{this.telemetryService.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(H.length),duration:se.elapsed(),success:!!le&&(0,h.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:he?(0,A.isCancellationError)(he)?"canceled":(0,A.getErrorMessage)(he).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(R,W,F,H){if(!this.isEnabled())return;const Y=U.isWeb?this.api(`/itemName/${R}.${W}/version/${F}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${R}/extensions/${W}/${F}/stats?statType=${H}`),se=U.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Y,headers:he},O.CancellationToken.None)}catch{}}async download(R,W,F){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const H=(0,S.getGalleryExtensionTelemetryData)(R),Y=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:fe}),le=F===2?"install":F===3?"update":"",he=le?{uri:`${R.assets.download.uri}${I.URI.parse(R.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${R.assets.download.fallbackUri}${I.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:R.assets.download,ue=R.queryContext?.[a]?{[a]:R.queryContext[a]}:void 0,me=await this.getAsset(he,ue?{headers:ue}:void 0);await this.fileService.writeFile(W,me.stream),se(new Date().getTime()-Y)}async downloadSignatureArchive(R,W){if(!R.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const F=await this.getAsset(R.assets.signature);await this.fileService.writeFile(W,F.stream)}async getReadme(R,W){if(R.assets.readme){const F=await this.getAsset(R.assets.readme,{},W);return await(0,h.asTextOrError)(F)||""}return""}async getManifest(R,W){if(R.assets.manifest){const F=await this.getAsset(R.assets.manifest,{},W),H=await(0,h.asTextOrError)(F);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(R,W){const F=$(R,r.Manifest);if(!F)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},Y=await this.getAsset(F,{headers:H});return await(0,h.asJson)(Y)}async getCoreTranslation(R,W){const F=R.assets.coreTranslations.filter(H=>H[0]===W.toUpperCase())[0];if(F){const H=await this.getAsset(F[1]),Y=await(0,h.asTextOrError)(H);return Y?JSON.parse(Y):null}return null}async getChangelog(R,W){if(R.assets.changelog){const F=await this.getAsset(R.assets.changelog,{},W);return await(0,h.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(R,W,F){let H=new d().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?H=H.withFilter(i.ExtensionId,R.identifier.uuid):H=H.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:Y}=await this.queryRawGalleryExtensions(H,O.CancellationToken.None);if(!Y.length)return[];const se=z(Y[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(se,F))return[];const le=[];await Promise.all(Y[0].versions.map(async me=>{try{await this.isValidVersion(me,W?"any":"release",!0,se,F)&&le.push(me)}catch{}}));const he=[],ue=new Set;for(const me of x(le,F))ue.has(me.version)||(ue.add(me.version),he.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:G(me)}));return he}async getAsset(R,W={},F=O.CancellationToken.None){const H=await this.commonHeadersPromise,Y={type:"GET"},se={...H,...W.headers||{}};W={...W,...Y,headers:se};const le=R.uri,he=R.fallbackUri,ue={...W,url:le};try{const me=await this.requestService.request(ue,F);if(me.res.statusCode===200)return me;const fe=await(0,h.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${fe}`)}catch(me){if((0,A.isCancellationError)(me))throw me;const fe=(0,A.getErrorMessage)(me);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:fe});const pe={...W,url:he};return this.requestService.request(pe,F)}}async getEngine(R){let W=Z(R);if(!W){const F=await this.getManifestFromRawExtensionVersion(R,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");W=F.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,h.asJson)(R),F=[],H={},Y=[];if(W){for(const se of W.malicious)F.push({id:se});if(W.migrateToPreRelease)for(const[se,le]of Object.entries(W.migrateToPreRelease))(!le.engine||(0,c.isEngineValid)(le.engine,this.productService.version,this.productService.date))&&(H[se.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[se,le]of Object.entries(W.deprecated))le&&(H[se.toLowerCase()]=(0,L.isBoolean)(le)?{}:le);if(W.search)for(const se of W.search)Y.push(se)}return{malicious:F,deprecated:H,search:Y}}};re=ye([X(1,h.IRequestService),X(2,y.ILogService),X(3,D.IEnvironmentService),X(4,p.ITelemetryService),X(5,g.IFileService),X(6,m.IProductService),X(7,f.IConfigurationService)],re);let J=class extends re{constructor(R,W,F,H,Y,se,le,he){super(R,W,F,H,Y,se,le,he)}};e.ExtensionGalleryService=J,e.ExtensionGalleryService=J=ye([X(0,u.IStorageService),X(1,h.IRequestService),X(2,y.ILogService),X(3,D.IEnvironmentService),X(4,p.ITelemetryService),X(5,g.IFileService),X(6,m.IProductService),X(7,f.IConfigurationService)],J);let q=class extends re{constructor(R,W,F,H,Y,se,le){super(void 0,R,W,F,H,Y,se,le)}};e.ExtensionGalleryServiceWithNoStorageService=q,e.ExtensionGalleryServiceWithNoStorageService=q=ye([X(0,h.IRequestService),X(1,y.ILogService),X(2,D.IEnvironmentService),X(3,p.ITelemetryService),X(4,g.IFileService),X(5,m.IProductService),X(6,f.IConfigurationService)],q)}),define(oe[80],ae([0,1,4,3,2,20,33,24,18,7,12]),function(te,e,k,O,A,U,_,L,I,f,D){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends A.Disposable{static{C=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(y){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const m=S.exec(y);if(m&&m[1])return{id:m[1],version:m[2]}}static async removeOutdatedExtensionVersions(y,m){const h=await y.getInstalled(),l=[];for(const[u,p]of C.readAllExtensionsWithKeysForSync(m)){const b=h.find(t=>(0,_.areSameExtensions)(t.identifier,{id:u}))?.manifest.version;for(const t of p)b!==t&&l.push(C.toKey({id:u,version:t}))}for(const u of l)m.remove(u,0)}static readAllExtensionsWithKeysForSync(y){const m=new Map,h=y.keys(0,1);for(const l of h){const u=C.fromKey(l);if(u){let p=m.get(u.id.toLowerCase());p||m.set(u.id.toLowerCase(),p=[]),p.push(u.version)}}return m}constructor(y,m,h){super(),this.storageService=y,this.productService=m,this.logService=h,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=C.readAllExtensionsWithKeysForSync(y),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new A.DisposableStore))(l=>this.onDidChangeStorageValue(l)))}onDidChangeStorageValue(y){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const m=C.fromKey(y.key);if(m){if(this.storageService.get(y.key,0)===void 0)this.extensionsWithKeysForSync.delete(m.id.toLowerCase());else{let h=this.extensionsWithKeysForSync.get(m.id.toLowerCase());h||this.extensionsWithKeysForSync.set(m.id.toLowerCase(),h=[]),h.push(m.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(y){if((0,D.isString)(y))return y;const m=y.manifest?y.manifest.publisher:y.publisher,h=y.manifest?y.manifest.name:y.name;return(0,_.getExtensionId)(m,h)}getExtensionState(y,m){const h=this.getExtensionId(y),l=this.getExtensionStateRaw(y,m);if(l)try{return JSON.parse(l)}catch(u){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${m}): ${u}`)}}getExtensionStateRaw(y,m){const h=this.getExtensionId(y),l=this.storageService.get(h,m?0:1);return l&&l?.length>C.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${m}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(y,m,h){const l=this.getExtensionId(y);m===void 0?this.storageService.remove(l,h?0:1):this.storageService.store(l,JSON.stringify(m),h?0:1,1)}setKeysForSync(y,m){this.storageService.store(C.toKey(y),JSON.stringify(m),0,1)}getKeysForSync(y){const m=this.productService.extensionSyncedKeys?.[y.id.toLowerCase()],h=this.storageService.get(C.toKey(y),0),l=h?JSON.parse(h):void 0;return l&&m?(0,I.distinct)([...l,...m]):l||m}addToMigrationList(y,m){if(y!==m){const h=this.migrationList.filter(l=>!l.includes(y)&&!l.includes(m));h.push([y,m]),this.migrationList=h}}getSourceExtensionToMigrate(y){const m=this.migrationList.find(([,h])=>y===h);return m?m[0]:void 0}get migrationList(){const y=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const m=JSON.parse(y);if(Array.isArray(m))return m}catch{}return[]}set migrationList(y){y.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=c,e.ExtensionStorageService=c=C=ye([X(0,U.IStorageService),X(1,L.IProductService),X(2,f.ILogService)],c)}),define(oe[248],ae([0,1,29,11,24,14,98,55,20,22,221]),function(te,e,k,O,A,U,_,L,I,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends D.AbstractNativeExtensionTipsService{constructor(c,g,y,m,h,l,u,p){super(c.userHome,h,g,y,m,l,u,p)}};e.ExtensionTipsService=C,e.ExtensionTipsService=C=ye([X(0,U.INativeEnvironmentService),X(1,f.ITelemetryService),X(2,k.IExtensionManagementService),X(3,I.IStorageService),X(4,L.INativeHostService),X(5,_.IExtensionRecommendationNotificationService),X(6,O.IFileService),X(7,A.IProductService)],C)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,64,24,6,5,101,19,165,36,20,12,133,21]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const b=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP],t="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends _.Disposable{constructor(o,w,E,d,v,T,N){super(),this.telemetryService=o,this.productService=w,this.environmentService=E,this.configurationService=T,this.storageService=N,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new O.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=k.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(M,$)=>{$?this._logger.error(M):this._logger.info(M)},this._logger=this._register(d.createLogger((0,p.joinPath)(E.logsHome,`${k.LOG_ID}.log`),{id:k.LOG_ID,name:k.LOGGER_NAME})),this._startTunnelProcessDelayer=new S.Delayer(100),this._register(this._logger.onDidChangeLogLevel(M=>this._logger.info("Log level changed to "+(0,L.LogLevelToString)(M)))),this._register(v.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(T.onDidChangeConfiguration(M=>{b.some($=>M.affectsConfiguration($))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=k.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(o){this._tunnelStatus=o,this._onDidChangeTunnelStatusEmitter.fire(o)}setMode(o){i(this._mode,o)||(this._mode=o,this._storeMode(o),this._onDidChangeModeEmitter.fire(this._mode),o.active?(this._logger.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this._logger.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(o){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(o);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(w){this._logger.error(w)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let o;C.isMacintosh?o=this.environmentService.appRoot:o=(0,I.dirname)((0,I.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,I.join)(o,"bin",`${this.productService.tunnelApplicationName}${C.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(o){if(i(this._mode,o)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(o);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(w){this._logger.error(w)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._mode.active)return;const o=this._mode.asService;this.setMode(k.INACTIVE_TUNNEL_MODE);try{o&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(w){this._logger.error(w)}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(w){this._logger.error(w)}this.setTunnelStatus(k.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let o="",w=!1;const E=($,j)=>{j?this._logger.error($):o+=$,!this.environmentService.isBuilt&&$.startsWith("   Compiling")&&this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(0,null)))},d=this.runCodeTunnelCommand("status",["status"],E);this._tunnelProcess=d;try{if(await d,this._tunnelProcess!==d)return;const $=JSON.parse(o.trim().split(`
`).find(j=>j.startsWith("{")));if(w=$.service_installed,this._logger.info($.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!$.tunnel&&!this._mode.active){this.setTunnelStatus(k.TunnelStates.disconnected());return}}catch($){this._logger.error($),this.setTunnelStatus(k.TunnelStates.disconnected());return}finally{this._tunnelProcess===d&&(this._tunnelProcess=void 0)}const v=this._mode.active?this._mode.session:void 0;if(v&&v.token){const $=v.token;this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(1,null,v.accountLabel,v.providerId)));const j=(G,Q)=>{G=G.replaceAll($,"*".repeat(4)),E(G,Q)},Z=this.runCodeTunnelCommand("login",["user","login","--provider",v.providerId,"--access-token",$,"--log",(0,L.LogLevelToString)(this._logger.getLevel())],j);this._tunnelProcess=Z;try{if(await Z,this._tunnelProcess!==Z)return}catch(G){this._logger.error(G),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(v),this.setTunnelStatus(k.TunnelStates.disconnected(v));return}}const T=this._getTunnelName();T?this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(2,null,T))):this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,L.LogLevelToString)(this._logger.getLevel())];T?N.push("--name",T):N.push("--random-name");let M=!1;return this._mode.active&&this._mode.asService&&!w&&(M=await this.installTunnelService(N)===!1),this.serverOrAttachTunnel(v,N,M)}async installTunnelService(o){let w;try{w=await this.runCodeTunnelCommand("serviceInstall",["service","install",...o])}catch(E){this._logger.error(E),w=1}if(w!==0){const E=(0,y.localize)(4,null);return this._logger.warn(E),this.setTunnelStatus(k.TunnelStates.connecting(E)),!1}return!0}async serverOrAttachTunnel(o,w,E){w.push("--parent-process-id",String(process.pid)),this._preventSleep()&&w.push("--no-sleep");let d=!1;const v=this.runCodeTunnelCommand("tunnel",w,(T,N)=>{N?this._logger.error(T):this._logger.info(T),T.includes("Connected to an existing tunnel process")&&(d=!0);const M=T.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const $={link:M[1],domain:M[2],tunnelName:M[4],isAttached:d};this.setTunnelStatus(k.TunnelStates.connected($,E))}else T.match(/error refreshing token/)&&(v.cancel(),this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(k.TunnelStates.disconnected(o)))});this._tunnelProcess=v,v.finally(()=>{v===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=k.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(k.TunnelStates.disconnected()))})}runCodeTunnelCommand(o,w,E=this.defaultOnOutput){return(0,S.createCancelablePromise)(d=>new Promise((v,T)=>{d.isCancellationRequested&&v(-1);let N;const M=["ignore","pipe","pipe"];if(d.onCancellationRequested(()=>{N&&(this._logger.info(`${o} terminating(${N.pid})`),N.kill())}),!this.environmentService.isBuilt)E(`Building tunnel CLI from sources and run
`,!1),E(`${o} Spawning: cargo run -- tunnel ${w.join(" ")}
`,!1),N=(0,f.spawn)("cargo",["run","--","tunnel",...w],{cwd:(0,I.join)(this.environmentService.appRoot,"cli"),stdio:M});else{E(`Running tunnel CLI
`,!1);const $=this.getTunnelCommandLocation();E(`${o} Spawning: ${$} tunnel ${w.join(" ")}
`,!1),N=(0,f.spawn)($,["tunnel",...w],{cwd:(0,m.homedir)(),stdio:M})}N.stdout.pipe(new u.StreamSplitter(`
`)).on("data",$=>{if(N){const j=$.toString();E(j,!1)}}),N.stderr.pipe(new u.StreamSplitter(`
`)).on("data",$=>{if(N){const j=$.toString();E(j,!0)}}),N.on("exit",$=>{N&&(E(`${o} exit(${N.pid}): + ${$} `,!1),N=void 0,v($||0))}),N.on("error",$=>{N&&(E(`${o} error(${N.pid}): + ${$} `,!0),N=void 0,T())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let o=this.configurationService.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,m.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}_restoreMode(){try{const o=this.storageService.get(t,-1),w=this.storageService.getBoolean(a,-1,!1);if(o){const E=JSON.parse(o);if(E&&(0,l.isString)(E.accountLabel)&&(0,l.isString)(E.sessionId)&&(0,l.isString)(E.providerId))return{active:!0,session:E,asService:w};this._logger.error("Problems restoring session from storage, invalid format",E)}}catch(o){this._logger.error("Problems restoring session from storage",o)}return k.INACTIVE_TUNNEL_MODE}_storeMode(o){if(o.active){const w={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.storageService.store(t,JSON.stringify(w),-1,1),this.storageService.store(a,o.asService,-1,1)}else this.storageService.remove(t,-1),this.storageService.remove(a,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=ye([X(0,A.ITelemetryService),X(1,D.IProductService),X(2,U.INativeEnvironmentService),X(3,L.ILoggerService),X(4,c.ISharedProcessLifecycleService),X(5,g.IConfigurationService),X(6,h.IStorageService)],n);function s(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const i=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&s(r.session,o.session):!0}),define(oe[250],ae([0,1,5,2,23,21,66,20,75,17]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class D extends L.AbstractStorageService{constructor(S,c,g,y){super(),this.initialWorkspace=S,this.initialProfiles=c,this.remoteService=g,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const S=this._register(new I.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),c=this._register(new _.Storage(S));return this._register(c.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g))),c}createProfileStorage(S){this.profileStorageDisposables.clear(),this.profileStorageProfile=S;let c;if((0,L.isProfileUsingDefaultStorage)(S))c=this.applicationStorage;else{const g=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),S));c=this.profileStorageDisposables.add(new _.Storage(g))}return this.profileStorageDisposables.add(c.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),c}createWorkspaceStorage(S){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=S?.id;let c;if(S){const g=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),S));c=this.workspaceStorageDisposables.add(new _.Storage(g)),this.workspaceStorageDisposables.add(c.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return c}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(S){switch(S){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(S){switch(S){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,U.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(S){if(!this.canSwitchProfile(this.profileStorageProfile,S))return;const c=this.profileStorage,g=c.items;c!==this.applicationStorage&&await c.close(),this.profileStorage=this.createProfileStorage(S),await this.profileStorage.init(),this.switchData(g,this.profileStorage,0)}async switchToWorkspace(S,c){const g=this.workspaceStorage,y=g?.items??new Map;await g?.close(),this.workspaceStorage=this.createWorkspaceStorage(S),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1)}hasScope(S){return(0,f.isUserDataProfile)(S)?this.profileStorageProfile.id===S.id:this.workspaceStorageId===S.id}}e.RemoteStorageService=D}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(f,D){this.service=f,this.getUriTransformer=D}listen(f,D){const C=this.getUriTransformer(f);switch(D){case"onDidChangeProfiles":return k.Event.map(this.service.onDidChangeProfiles,S=>({all:S.all.map(c=>(0,U.transformOutgoingURIs)({...c},C)),added:S.added.map(c=>(0,U.transformOutgoingURIs)({...c},C)),removed:S.removed.map(c=>(0,U.transformOutgoingURIs)({...c},C)),updated:S.updated.map(c=>(0,U.transformOutgoingURIs)({...c},C))}))}throw new Error(`Invalid listen ${D}`)}async call(f,D,C){const S=this.getUriTransformer(f);switch(D){case"createProfile":{const c=await this.service.createProfile(C[0],C[1],C[2]);return(0,U.transformOutgoingURIs)({...c},S)}case"updateProfile":{let c=(0,A.reviveProfile)((0,U.transformIncomingURIs)(C[0],S),this.service.profilesHome.scheme);return c=await this.service.updateProfile(c,C[1]),(0,U.transformOutgoingURIs)({...c},S)}case"removeProfile":{const c=(0,A.reviveProfile)((0,U.transformIncomingURIs)(C[0],S),this.service.profilesHome.scheme);return this.service.removeProfile(c)}}throw new Error(`Invalid call ${D}`)}}e.RemoteUserDataProfilesServiceChannel=_;class L extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(f,D,C){super(),this.profilesHome=D,this.channel=C,this._profiles=[],this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=f.map(S=>(0,A.reviveProfile)(S,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(S=>{const c=S.added.map(m=>(0,A.reviveProfile)(m,this.profilesHome.scheme)),g=S.removed.map(m=>(0,A.reviveProfile)(m,this.profilesHome.scheme)),y=S.updated.map(m=>(0,A.reviveProfile)(m,this.profilesHome.scheme));this._profiles=S.all.map(m=>(0,A.reviveProfile)(m,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:c,removed:g,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(f){this.enabled=f}isEnabled(){return this.enabled}async createNamedProfile(f,D,C){const S=await this.channel.call("createNamedProfile",[f,D,C]);return(0,A.reviveProfile)(S,this.profilesHome.scheme)}async createProfile(f,D,C,S){const c=await this.channel.call("createProfile",[f,D,C,S]);return(0,A.reviveProfile)(c,this.profilesHome.scheme)}async createTransientProfile(f){const D=await this.channel.call("createTransientProfile",[f]);return(0,A.reviveProfile)(D,this.profilesHome.scheme)}async setProfileForWorkspace(f,D){await this.channel.call("setProfileForWorkspace",[f,D])}removeProfile(f){return this.channel.call("removeProfile",[f])}async updateProfile(f,D){const C=await this.channel.call("updateProfile",[f,D]);return(0,A.reviveProfile)(C,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=L}),define(oe[58],ae([0,1,2,66,4,20,3,75,17]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let f=class extends k.Disposable{constructor(c){super(),this.storageService=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async g=>this.getItems(g))}async updateStorageData(c,g,y){return this.withProfileScopedStorageService(c,async m=>this.writeItems(m,g,y))}async withProfileScopedStorageService(c,g){if(this.storageService.hasScope(c))return g(this.storageService);const y=await this.createStorageDatabase(c),m=new C(y);try{await m.initialize();const h=await g(m);return await m.flush(),h}finally{m.dispose(),await this.closeAndDispose(y)}}getItems(c){const g=new Map,y=m=>{for(const h of c.keys(0,m))g.set(h,{value:c.get(h,0),target:m})};return y(0),y(1),g}writeItems(c,g,y){c.storeAll(Array.from(g.entries()).map(([m,h])=>({key:m,value:h,scope:0,target:y})),!0)}async closeAndDispose(c){try{await c.close()}finally{(0,k.isDisposable)(c)&&c.dispose()}}};e.AbstractUserDataProfileStorageService=f,e.AbstractUserDataProfileStorageService=f=ye([X(0,U.IStorageService)],f);class D extends f{constructor(c,g,y,m){super(y),this.remoteService=c;const h=c.getChannel("profileStorageListener"),l=this._register(new k.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{l.value=h.listen("onDidChange")(u=>{m.trace("profile storage changes",u),this._onDidChange.fire({targetChanges:u.targetChanges.map(p=>(0,I.reviveProfile)(p,g.profilesHome.scheme)),valueChanges:u.valueChanges.map(p=>({...p,profile:(0,I.reviveProfile)(p.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>l.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(c){const g=this.remoteService.getChannel("storage");return(0,U.isProfileUsingDefaultStorage)(c)?new L.ApplicationStorageDatabaseClient(g):new L.ProfileStorageDatabaseClient(g,c)}}e.RemoteUserDataProfileStorageService=D;class C extends U.AbstractStorageService{constructor(c){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(c))}doInitialize(){return this.profileStorage.init()}getStorage(c){return c===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,20,7,17,71,58]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let L=class extends _.RemoteUserDataProfileStorageService{constructor(f,D,C,S){super(f,D,C,S)}};e.NativeUserDataProfileStorageService=L,e.NativeUserDataProfileStorageService=L=ye([X(0,U.IMainProcessService),X(1,A.IUserDataProfilesService),X(2,k.IStorageService),X(3,O.ILogService)],L)}),define(oe[39],ae([0,1,18,5,15,26,3,35,2,27,12,170,19,14,11,7,43,20,22,28,25,17]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function t(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||a(w.syncData)))}e.isRemoteUserData=t;function a(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.isSyncData=a;function n(w,E){return`${(0,f.uppercaseFirstLetter)(w)}${E.isDefault?"":` (${E.name})`}`}e.getSyncResourceLogLabel=n;let s=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(E,d,v,T,N,M,$,j,Z,G,Q,B){super(),this.syncResource=E,this.collection=d,this.fileService=v,this.environmentService=T,this.storageService=N,this.userDataSyncStoreService=M,this.userDataSyncLocalStoreService=$,this.userDataSyncEnablementService=j,this.telemetryService=Z,this.logService=G,this.configurationService=Q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new O.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(E.syncResource,E.profile),this.extUri=B.extUri,this.syncFolder=this.extUri.joinPath(T.userDataSyncHome,...(0,p.getPathSegments)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,p.PREVIEW_DIR_NAME),this.lastSyncResource=(0,p.getLastSyncResourceUri)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,T,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(T,v,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const E=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(E.remoteUserData,E.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.hasRemoteChanged(E):!0)&&this._onDidChangeLocal.fire()}}setStatus(E){this._status!==E&&(this._status=E,this._onDidChangStatus.fire(E))}async sync(E,d={}){await this._sync(E,!0,this.getUserDataSyncConfiguration(),d)}async preview(E,d,v={}){return this._sync(E,!1,d,v)}async apply(E,d={}){try{this.syncHeaders={...d};const v=await this.doApply(E);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(E,d,v,T){try{if(this.syncHeaders={...T},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const M=await this.getLastSyncUserData(),$=await this.getLatestRemoteUserData(E,M);return N=await this.performSync($,M,d,v),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(E){const d=this.parseSyncData(E);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const v=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,v),N=await this.isRemoteDataFromCurrentMachine(T),M=await this.generateSyncPreview({ref:T.ref,syncData:d},v,N,this.getUserDataSyncConfiguration(),U.CancellationToken.None),$=[];for(const j of M){const Z=await this.getAcceptResult(j,j.remoteResource,void 0,U.CancellationToken.None),{remoteChange:G}=await this.getAcceptResult(j,j.previewResource,j.remoteContent,U.CancellationToken.None);$.push([j,{...Z,remoteChange:G!==0?G:2}])}await this.applyResult(T,v,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(E){const d=await this.currentMachineIdPromise;return!!E.syncData?.machineId&&E.syncData.machineId===d}async getLatestRemoteUserData(E,d){if(d){const v=E?E[this.resource]:void 0;if(d.ref===v||v===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(E,d,v,T){if(E.syncData&&E.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new p.UserDataSyncError((0,C.localize)(0,null,this.resource,this.version,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(E,d,v,T)}catch(N){if(N instanceof p.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(E,d,v,T);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(E,d,v,T)}throw N}}async doSync(E,d,v,T){try{const N=await this.isRemoteDataFromCurrentMachine(E),M=!N&&d===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,$=v&&!M;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(Z=>this.doGenerateSyncResourcePreview(E,d,N,$,T,Z)));let j=await this.syncPreviewPromise;if(v&&M){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of j.resourcePreviews)j=await this.accept(Z.remoteResource)||j}return this.updateConflicts(j.resourcePreviews),j.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(E){return await this.updateSyncResourcePreview(E,async d=>{const v=await this.getMergeResult(d,U.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(v?.content||""));const T=v&&!v.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,U.CancellationToken.None):void 0;return d.acceptResult=T,d.mergeState=v.hasConflicts?"conflict":T?"accepted":"preview",d.localChange=T?T.localChange:v.localChange,d.remoteChange=T?T.remoteChange:v.remoteChange,d}),this.syncPreviewPromise}async accept(E,d){return await this.updateSyncResourcePreview(E,async v=>{const T=await this.getAcceptResult(v,E,d,U.CancellationToken.None);return v.acceptResult=T,v.mergeState="accepted",v.localChange=T.localChange,v.remoteChange=T.remoteChange,v}),this.syncPreviewPromise}async discard(E){return await this.updateSyncResourcePreview(E,async d=>{const v=await this.getMergeResult(d,U.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(v.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=v.localChange,d.remoteChange=v.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(E,d){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const T=v.resourcePreviews.findIndex(({localResource:N,remoteResource:M,previewResource:$})=>this.extUri.isEqual(N,E)||this.extUri.isEqual(M,E)||this.extUri.isEqual($,E));T!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async N=>{const M=[...v.resourcePreviews];return M[T]=await d(M[T]),{...v,resourcePreviews:M}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(E){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(v=>[v,v.acceptResult]),E),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(E){const d=E.filter(({mergeState:v})=>v==="conflict");(0,k.equals)(this._conflicts,d,(v,T)=>this.extUri.isEqual(v.previewResource,T.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async resolvePreviewContent(E){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const v of d.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,E))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,E))return v.remoteContent;if(this.extUri.isEqual(v.localResource,E))return v.localContent;if(this.extUri.isEqual(v.baseResource,E))return v.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(E){(0,g.toFileOperationResult)(E)!==1&&this.logService.error(E)}}async doGenerateSyncResourcePreview(E,d,v,T,N,M){const $=await this.generateSyncPreview(E,d,v,N,M),j=[];for(const Z of $){const G=Z.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)j.push({...Z,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=T?await this.getMergeResult(Z,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(Z.previewResource,A.VSBuffer.fromString(Q?.content||""));const B=Q&&!Q.hasConflicts?await this.getAcceptResult(Z,Z.previewResource,void 0,M):void 0;j.push({...Z,acceptResult:B,mergeState:Q?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:Q?Q.localChange:Z.localChange,remoteChange:B?B.remoteChange:Q?Q.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:d,resourcePreviews:j,isLastSyncFromCurrentMachine:v}}async getLastSyncUserData(){let E=this.getStoredLastSyncUserDataStateContent();if(E||(E=await this.migrateLastSyncUserData()),!E)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const d=JSON.parse(E),v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!d.version&&!!v&&d.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;let T,N=1;for(;T===void 0&&N++<6;)try{const M=await this.readLastSyncStoredRemoteUserData();M&&(M.ref===d.ref?T=M.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof g.FileOperationError&&M.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(M instanceof p.UserDataSyncError)throw M;this.logService.error(M,N)}}if(T===void 0)try{const M=await this.userDataSyncStoreService.resolveResourceContent(this.resource,d.ref,this.collection,this.syncHeaders);T=M===null?null:this.parseSyncData(M),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:T})}catch(M){if(M instanceof p.UserDataSyncError&&M.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw M}return T===void 0?null:{...d,syncData:T}}async updateLastSyncUserData(E,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),T={ref:E.ref,version:v,...d};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(T),-1,1),await this.writeLastSyncStoredRemoteUserData(E)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const E=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const d=E?JSON.parse(E):void 0;if(t(d))return d}catch(d){this.logService.error(d)}}async writeLastSyncStoredRemoteUserData(E){await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(E)))}async migrateLastSyncUserData(){try{const E=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(E.value.toString());await this.fileService.del(this.lastSyncResource),d.ref&&d.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...d,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:d.content===null?null:JSON.parse(d.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,d)}catch(E){E instanceof g.FileOperationError&&E.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(E)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(E){const{ref:d,content:v}=await this.getUserData(E);let T=null;return v!==null&&(T=this.parseSyncData(v)),{ref:d,syncData:T}}parseSyncData(E){try{const d=JSON.parse(E);if(a(d))return d}catch(d){this.logService.error(d)}throw new p.UserDataSyncError((0,C.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(E){const d=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,d,this.collection,this.syncHeaders)}async updateRemoteUserData(E,d){const v=await this.currentMachineIdPromise,T={version:this.version,machineId:v,content:E};try{return d=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(T),d,this.collection,this.syncHeaders),{ref:d,syncData:T}}catch(N){throw N instanceof p.UserDataSyncError&&N.code==="TooLarge"&&(N=new p.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(E){const d={version:this.version,content:E};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(d),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=s,e.AbstractSynchroniser=s=ye([X(2,g.IFileService),X(3,c.IEnvironmentService),X(4,h.IStorageService),X(5,p.IUserDataSyncStoreService),X(6,p.IUserDataSyncLocalStoreService),X(7,p.IUserDataSyncEnablementService),X(8,l.ITelemetryService),X(9,p.IUserDataSyncLogService),X(10,S.IConfigurationService),X(11,u.IUriIdentityService)],s);let i=class extends s{constructor(E,d,v,T,N,M,$,j,Z,G,Q,B,K){super(d,v,T,N,M,$,j,Z,G,Q,B,K),this.file=E,this._register(this.fileService.watch(this.extUri.dirname(E))),this._register(this.fileService.onDidFilesChange(V=>this.onFileChanges(V)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(E,d,v){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(E),v?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(E),{overwrite:v})}catch(T){throw T instanceof g.FileOperationError&&T.fileOperationResult===1||T instanceof g.FileOperationError&&T.fileOperationResult===3?new p.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(E){if(!(E instanceof g.FileOperationError&&E.fileOperationResult===1))throw E}}onFileChanges(E){E.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=i,e.AbstractFileSynchroniser=i=ye([X(3,g.IFileService),X(4,c.IEnvironmentService),X(5,h.IStorageService),X(6,p.IUserDataSyncStoreService),X(7,p.IUserDataSyncLocalStoreService),X(8,p.IUserDataSyncEnablementService),X(9,l.ITelemetryService),X(10,p.IUserDataSyncLogService),X(11,S.IConfigurationService),X(12,u.IUriIdentityService)],i);let r=class extends i{constructor(E,d,v,T,N,M,$,j,Z,G,Q,B,K,V){super(E,d,v,T,N,M,$,j,Z,G,Q,K,V),this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(E,d){const v=[],T=(0,L.parse)(E,v,{allowEmptyContent:!0,allowTrailingComma:!0});return v.length>0||!(0,D.isUndefined)(T)&&d!==Array.isArray(T)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=ye([X(3,g.IFileService),X(4,c.IEnvironmentService),X(5,h.IStorageService),X(6,p.IUserDataSyncStoreService),X(7,p.IUserDataSyncLocalStoreService),X(8,p.IUserDataSyncEnablementService),X(9,l.ITelemetryService),X(10,p.IUserDataSyncLogService),X(11,p.IUserDataSyncUtilService),X(12,S.IConfigurationService),X(13,u.IUriIdentityService)],r);let o=class{constructor(E,d,v,T,N,M,$){this.resource=E,this.userDataProfilesService=d,this.environmentService=v,this.logService=T,this.fileService=N,this.storageService=M,this.extUri=$.extUri,this.lastSyncResource=(0,p.getLastSyncResourceUri)(void 0,this.resource,v,this.extUri)}async initialize({ref:E,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(d);if(v)try{await this.doInitialize({ref:E,syncData:v})}catch(T){this.logService.error(T)}}parseSyncData(E){try{const d=JSON.parse(E);if(a(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(E,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const v={ref:E.ref,version:void 0,...d};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(v),-1,1),await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(E)))}};e.AbstractInitializer=o,e.AbstractInitializer=o=ye([X(1,b.IUserDataProfilesService),X(2,c.IEnvironmentService),X(3,y.ILogService),X(4,g.IFileService),X(5,h.IStorageService),X(6,u.IUriIdentityService)],o)}),define(oe[115],ae([0,1,5,26,8,3,41,2,27,19,14,114,29,33,80,44,11,4,70,7,20,22,28,17,39,232,111,25,58]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t,a,n,s,i,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function w(M,$){const j=JSON.parse(M.content);if(M.version===1||M.version===2){const Z=(await $.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of j)M.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),M.version===2&&Z.every(Q=>!(0,c.areSameExtensions)(Q.identifier,G.identifier))&&(G.installed=!0)}return j}function E(M){return JSON.parse(M.content)}e.parseExtensions=E;function d(M,$){return M.sort((j,Z)=>!j.identifier.uuid&&Z.identifier.uuid?-1:j.identifier.uuid&&!Z.identifier.uuid?1:(0,I.compare)(j.identifier.id,Z.identifier.id)),$?(0,_.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=d;let v=class extends n.AbstractSynchroniser{constructor($,j,Z,G,Q,B,K,V,z,x,ee,ne,re,J,q,P,R){super({syncResource:"extensions",profile:$},j,G,Z,Q,B,K,ne,re,x,ee,q),this.extensionManagementService=V,this.ignoredExtensionsManagementService=z,this.instantiationService=R,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(T),this._register(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:F})=>!!F)),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),U.Event.filter(P.onDidChange,W=>W.valueChanges.some(({profile:F,changes:H})=>this.syncResource.profile.id===F.id&&H.some(Y=>Y.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),J.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview($,j){const Z=$.syncData?await w($.syncData,this.extensionManagementService):null,G=j?.skippedExtensions??[],Q=j?.builtinExtensions??null,B=j?.syncData?await w(j.syncData,this.extensionManagementService):null,{localExtensions:K,ignoredExtensions:V}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);Z?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:x}=(0,s.merge)(K,Z,B,G,V,Q),ee={local:z,remote:x,content:this.getPreviewContent(K,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:x!==null?2:0},ne=this.stringify(K,!1);return[{skippedExtensions:G,builtinExtensions:Q,baseResource:this.baseResource,baseContent:B?this.stringify(B,!1):ne,localResource:this.localResource,localContent:ne,localExtensions:K,remoteResource:this.remoteResource,remoteExtensions:Z,remoteContent:Z?this.stringify(Z,!1):null,previewResource:this.previewResource,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged($){const j=$.syncData?await w($.syncData,this.extensionManagementService):null,{localExtensions:Z,ignoredExtensions:G}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,s.merge)(Z,j,j,$.skippedExtensions||[],G,$.builtinExtensions||[]);return Q!==null}getPreviewContent($,j,Z,G){const Q=[...j,...Z],B=new Set,K=V=>{B.add(V.id.toLowerCase()),V.uuid&&B.add(V.uuid)};Q.forEach(({identifier:V})=>K(V)),G.forEach(K);for(const V of $)B.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&B.has(V.identifier.uuid)||Q.push(V);return this.stringify(Q,!1)}async getMergeResult($,j){return{...$.previewResult,hasConflicts:!1}}async getAcceptResult($,j,Z,G){if(this.extUri.isEqual(j,this.localResource))return this.acceptLocal($);if(this.extUri.isEqual(j,this.remoteResource))return this.acceptRemote($);if(this.extUri.isEqual(j,this.previewResource))return $.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async acceptLocal($){const j=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.ignoredExtensionsManagementService.getIgnoredExtensions(j),G=(0,s.merge)($.localExtensions,null,null,$.skippedExtensions,Z,$.builtinExtensions),{local:Q,remote:B}=G;return{content:$.localContent,local:Q,remote:B,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:B!==null?2:0}}async acceptRemote($){const j=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.ignoredExtensionsManagementService.getIgnoredExtensions(j),G=$.remoteContent?JSON.parse($.remoteContent):null;if(G!==null){const Q=(0,s.merge)($.localExtensions,G,$.localExtensions,[],Z,$.builtinExtensions),{local:B,remote:K}=Q;return{content:$.remoteContent,local:B,remote:K,localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:$.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult($,j,Z,G){let{skippedExtensions:Q,builtinExtensions:B,localExtensions:K}=Z[0][0];const{local:V,remote:z,localChange:x,remoteChange:ee}=Z[0][1];if(x===0&&ee===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),x!==0&&(await this.backupLocal(JSON.stringify(K)),Q=await this.localExtensionsProvider.updateLocalExtensions(V.added,V.removed,V.updated,Q,this.syncResource.profile)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ne=JSON.stringify(z.all);$=await this.updateRemoteUserData(ne,G?null:$.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(re=>re.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(re=>re.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(re=>re.identifier.id))}.`:""}`)}j?.ref!==$.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),B=this.computeBuiltinExtensions(K,B),await this.updateLastSyncUserData($,{skippedExtensions:Q,builtinExtensions:B}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ne=>ne.identifier.id))}.`:""}`))}computeBuiltinExtensions($,j){const Z=new Set,G=[];for(const Q of $)Z.add(Q.identifier.id.toLowerCase()),Q.installed||G.push(Q.identifier);if(j)for(const Q of j)Z.has(Q.id.toLowerCase())||G.push(Q);return G}async resolveContent($){if(this.extUri.isEqual(this.remoteResource,$)||this.extUri.isEqual(this.baseResource,$)||this.extUri.isEqual(this.localResource,$)||this.extUri.isEqual(this.acceptedResource,$)){const j=await this.resolvePreviewContent($);return j&&this.stringify(JSON.parse(j),!0)}return null}stringify($,j){return d($,j)}async hasLocalData(){try{const{localExtensions:$}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if($.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=v,e.ExtensionsSynchroniser=v=ye([X(2,D.IEnvironmentService),X(3,m.IFileService),X(4,p.IStorageService),X(5,r.IUserDataSyncStoreService),X(6,r.IUserDataSyncLocalStoreService),X(7,S.IExtensionManagementService),X(8,i.IIgnoredExtensionsManagementService),X(9,r.IUserDataSyncLogService),X(10,f.IConfigurationService),X(11,r.IUserDataSyncEnablementService),X(12,b.ITelemetryService),X(13,g.IExtensionStorageService),X(14,t.IUriIdentityService),X(15,o.IUserDataProfileStorageService),X(16,h.IInstantiationService)],v);let T=class{constructor($,j,Z,G,Q,B){this.extensionManagementService=$,this.userDataProfileStorageService=j,this.extensionGalleryService=Z,this.ignoredExtensionsManagementService=G,this.instantiationService=Q,this.logService=B}async getLocalExtensions($){const j=await this.extensionManagementService.getInstalled(void 0,$.extensionsResource),Z=this.ignoredExtensionsManagementService.getIgnoredExtensions(j);return{localExtensions:await this.withProfileScopedServices($,async(Q,B)=>{const K=Q.getDisabledExtensions();return j.map(V=>{const{identifier:z,isBuiltin:x,manifest:ee,preRelease:ne,pinned:re,isApplicationScoped:J}=V,q={identifier:z,preRelease:ne,version:ee.version,pinned:!!re};J&&!(0,y.isApplicationScopedExtension)(ee)&&(q.isApplicationScoped=J),K.some(P=>(0,c.areSameExtensions)(P,z))&&(q.disabled=!0),x||(q.installed=!0);try{const P=B.getKeysForSync({id:z.id,version:ee.version});if(P){const R=B.getExtensionState(V,!0)||{};q.state=Object.keys(R).reduce((W,F)=>(P.includes(F)&&(W[F]=R[F]),W),{})}}catch(P){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",$)}: Error while parsing extension state`,(0,A.getErrorMessage)(P))}return q})}),ignoredExtensions:Z}}async updateLocalExtensions($,j,Z,G,Q){const B=(0,n.getSyncResourceLogLabel)("extensions",Q),K=[],V=new Map,z=[],x=[],ee=await this.extensionManagementService.getInstalled(void 0,Q.extensionsResource);if(($.length||Z.length)&&await this.withProfileScopedServices(Q,async(J,q)=>{await k.Promises.settled([...$,...Z].map(async P=>{const R=ee.find(H=>(0,c.areSameExtensions)(H.identifier,P.identifier));if(R&&R.isBuiltin){P.state&&R.manifest.version===P.version&&this.updateExtensionState(P.state,R,R.manifest.version,q),J.getDisabledExtensions().some(Y=>(0,c.areSameExtensions)(Y,P.identifier))!==!!P.disabled&&(P.disabled?(this.logService.trace(`${B}: Disabling extension...`,P.identifier.id),await J.disableExtension(P.identifier),this.logService.info(`${B}: Disabled extension`,P.identifier.id)):(this.logService.trace(`${B}: Enabling extension...`,P.identifier.id),await J.enableExtension(P.identifier),this.logService.info(`${B}: Enabled extension`,P.identifier.id))),z.push(P.identifier);return}const W=P.pinned?P.version:void 0,F=(await this.extensionGalleryService.getExtensions([{...P.identifier,version:W,preRelease:W?void 0:P.preRelease}],O.CancellationToken.None))[0];if(P.state&&(R?R.manifest.version===P.version:F)&&this.updateExtensionState(P.state,R||F,R?.manifest.version,q),F)try{J.getDisabledExtensions().some(Y=>(0,c.areSameExtensions)(Y,P.identifier))!==!!P.disabled&&(P.disabled?(this.logService.trace(`${B}: Disabling extension...`,P.identifier.id,F.version),await J.disableExtension(F.identifier),this.logService.info(`${B}: Disabled extension`,P.identifier.id,F.version)):(this.logService.trace(`${B}: Enabling extension...`,P.identifier.id,F.version),await J.enableExtension(F.identifier),this.logService.info(`${B}: Enabled extension`,P.identifier.id,F.version))),(!R||R.preRelease!==P.preRelease||R.pinned!==P.pinned||W&&R.manifest.version!==W)&&(await this.extensionManagementService.canInstall(F)?(K.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[S.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[S.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),V.set(F.identifier.id.toLowerCase(),P)):(this.logService.info(`${B}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),x.push(P)))}catch(H){x.push(P),this.logService.error(H),this.logService.info(`${B}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else x.push(P),this.logService.info(`${B}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),j.length){const J=ee.filter(({identifier:q,isBuiltin:P})=>!P&&j.some(R=>(0,c.areSameExtensions)(q,R)));await k.Promises.settled(J.map(async q=>{this.logService.trace(`${B}: Uninstalling local extension...`,q.identifier.id),await this.extensionManagementService.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.logService.info(`${B}: Uninstalled local extension.`,q.identifier.id),z.push(q.identifier)}))}const ne=await this.extensionManagementService.installGalleryExtensions(K);for(const{identifier:J,local:q,error:P,source:R}of ne){const W=R;if(q)this.logService.info(`${B}: Installed extension.`,J.id,W.version),z.push(J);else{const F=V.get(J.id.toLowerCase());F&&(x.push(F),this.logService.info(`${B}: Skipped synchronizing extension`,W.displayName||W.identifier.id)),P instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.logService.info(`${B}: Skipped synchronizing extension because the compatible extension is not found.`,W.displayName||W.identifier.id):P&&this.logService.error(P)}}const re=[];for(const J of G)z.some(q=>(0,c.areSameExtensions)(q,J.identifier))||re.push(J);for(const J of x)re.some(q=>(0,c.areSameExtensions)(q.identifier,J.identifier))||re.push(J);return re}updateExtensionState($,j,Z,G){const Q=G.getExtensionState(j,!0)||{},B=Z?G.getKeysForSync({id:j.identifier.id,version:Z}):void 0;B?B.forEach(K=>{Q[K]=$[K]}):Object.keys($).forEach(K=>Q[K]=$[K]),G.setExtensionState(j,Q,!0)}async withProfileScopedServices($,j){return this.userDataProfileStorageService.withProfileScopedStorageService($,async Z=>{const G=new L.DisposableStore,Q=this.instantiationService.createChild(new l.ServiceCollection([p.IStorageService,Z])),B=G.add(Q.createInstance(C.GlobalExtensionEnablementService)),K=G.add(Q.createInstance(g.ExtensionStorageService));try{return await j(B,K)}finally{G.dispose()}})}};e.LocalExtensionsProvider=T,e.LocalExtensionsProvider=T=ye([X(0,S.IExtensionManagementService),X(1,o.IUserDataProfileStorageService),X(2,S.IExtensionGalleryService),X(3,i.IIgnoredExtensionsManagementService),X(4,h.IInstantiationService),X(5,r.IUserDataSyncLogService)],T);let N=class extends n.AbstractInitializer{constructor($,j,Z,G,Q,B,K,V){super("extensions",G,Q,B,Z,K,V),this.extensionManagementService=$,this.ignoredExtensionsManagementService=j}async parseExtensions($){return $.syncData?await w($.syncData,this.extensionManagementService):null}generatePreview($,j){const Z=[],G=[],Q=[];for(const B of $){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(B.identifier.id))continue;const K=j.find(V=>(0,c.areSameExtensions)(V.identifier,B.identifier));K?(Z.push(K),B.disabled&&Q.push(B.identifier)):B.installed&&(G.push({...B.identifier,preRelease:!!B.preRelease}),B.disabled&&Q.push(B.identifier))}return{installedExtensions:Z,newExtensions:G,disabledExtensions:Q,remoteExtensions:$}}};e.AbstractExtensionsInitializer=N,e.AbstractExtensionsInitializer=N=ye([X(0,S.IExtensionManagementService),X(1,i.IIgnoredExtensionsManagementService),X(2,m.IFileService),X(3,a.IUserDataProfilesService),X(4,D.IEnvironmentService),X(5,u.ILogService),X(6,p.IStorageService),X(7,t.IUriIdentityService)],N)}),define(oe[116],ae([0,1,15,8,3,35,41,6,32,19,14,11,7,43,20,22,28,39,77,236,25,17,58,4]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",s=["locale"];function i(v,T){const N=v.storage?Object.keys(v.storage).sort():[],M={};return N.forEach($=>M[$]=v.storage[$]),v.storage=M,T?(0,_.toFormattedString)(v,{}):JSON.stringify(v)}e.stringify=i;const r=1;let o=class extends h.AbstractSynchroniser{constructor(T,N,M,$,j,Z,G,Q,B,K,V,z,x,ee){super({syncResource:"globalState",profile:T},N,$,Q,z,j,Z,B,K,G,V,x),this.userDataProfileStorageService=M,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ee.createInstance(w),this._register($.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter($.onDidFilesChange,ne=>ne.contains(this.environmentService.argvResource)),A.Event.filter(M.onDidChange,ne=>!!(ne.targetChanges.some(re=>this.syncResource.profile.id===re.id)||ne.valueChanges.some(({profile:re,changes:J})=>this.syncResource.profile.id===re.id&&J.some(q=>q.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(T,N,M){const $=T.syncData?JSON.parse(T.syncData.content):null;N=N===null&&M?T:N;const j=N&&N.syncData?JSON.parse(N.syncData.content):null,Z=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);$?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.getStorageKeys(j),{local:Q,remote:B}=(0,u.merge)(Z.storage,$?$.storage:null,j?j.storage:null,G,this.logService),K={content:null,local:Q,remote:B,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:B.all!==null?2:0},V=i(Z,!1);return[{baseResource:this.baseResource,baseContent:j?i(j,!1):V,localResource:this.localResource,localContent:V,localUserData:Z,remoteResource:this.remoteResource,remoteContent:$?i($,!1):null,previewResource:this.previewResource,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.acceptedResource,storageKeys:G}]}async hasRemoteChanged(T){const N=T.syncData?JSON.parse(T.syncData.content):null;if(N===null)return!0;const M=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),$=await this.getStorageKeys(N),{remote:j}=(0,u.merge)(M.storage,N.storage,N.storage,$,this.logService);return j.all!==null}async getMergeResult(T,N){return{...T.previewResult,hasConflicts:!1}}async getAcceptResult(T,N,M,$){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(T);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(T);if(this.extUri.isEqual(N,this.previewResource))return T.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(T.localUserData.storage),removed:[],updated:[],all:T.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(T){if(T.remoteContent!==null){const N=JSON.parse(T.remoteContent),{local:M,remote:$}=(0,u.merge)(T.localUserData.storage,N.storage,null,T.storageKeys,this.logService);return{content:T.remoteContent,local:M,remote:$,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(T,N,M,$){const{localUserData:j}=M[0][0],{local:Z,remote:G,localChange:Q,remoteChange:B}=M[0][1];if(Q===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(j)),await this.localGlobalStateProvider.writeLocalGlobalState(Z,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const K=JSON.stringify({storage:G.all});T=await this.updateRemoteUserData(K,$?null:T.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}N?.ref!==T.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(T),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(T){if(this.extUri.isEqual(this.remoteResource,T)||this.extUri.isEqual(this.baseResource,T)||this.extUri.isEqual(this.localResource,T)||this.extUri.isEqual(this.acceptedResource,T)){const N=await this.resolvePreviewContent(T);return N&&i(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:T}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(T).length>1||T[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(T){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),M=[],$=[];for(const[G,Q]of N)Q.target===0?M.push(G):Q.target===1&&$.push(G);const j=[...M,...$],Z=T?.storage?Object.keys(T.storage).filter(G=>!G.startsWith(n)&&!j.includes(G)&&N.get(G)!==void 0):[];if(!L.isWeb){const G=[...p.ALL_SYNC_RESOURCES.map(Q=>(0,p.getEnablementKey)(Q)),p.SYNC_SERVICE_URL_TYPE];Z.push(...G),$.push(...G)}return{user:M,machine:$,unregistered:Z}}};e.GlobalStateSynchroniser=o,e.GlobalStateSynchroniser=o=ye([X(2,t.IUserDataProfileStorageService),X(3,C.IFileService),X(4,p.IUserDataSyncStoreService),X(5,p.IUserDataSyncLocalStoreService),X(6,p.IUserDataSyncLogService),X(7,D.IEnvironmentService),X(8,p.IUserDataSyncEnablementService),X(9,y.ITelemetryService),X(10,f.IConfigurationService),X(11,g.IStorageService),X(12,m.IUriIdentityService),X(13,a.IInstantiationService)],o);let w=class{constructor(T,N,M,$){this.fileService=T,this.environmentService=N,this.userDataProfileStorageService=M,this.logService=$}async getLocalGlobalState(T){const N={};if(T.isDefault){const $=await this.getLocalArgvContent(),j=(0,U.parse)($);for(const Z of s)j[Z]!==void 0&&(N[`${n}${Z}`]={version:1,value:j[Z]})}const M=await this.userDataProfileStorageService.readStorageData(T);for(const[$,j]of M)j.value&&j.target===0&&(N[$]={version:1,value:j.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const T=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),T.value.toString()}catch(T){this.logService.debug((0,O.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:N,updated:M},$){const j=(0,h.getSyncResourceLogLabel)("globalState",$),Z={},G=new Map,Q=await this.userDataProfileStorageService.readStorageData($),B=(K,V)=>{for(const z of K){if(z.startsWith(n)){Z[z.substring(n.length)]=V?V[z].value:void 0;continue}if(V){const x=V[z];x.value!==Q.get(z)?.value&&G.set(z,x.value)}else Q.get(z)!==void 0&&G.set(z,void 0)}};if(B(Object.keys(T),T),B(Object.keys(M),M),B(N),Object.keys(Z).length){this.logService.trace(`${j}: Updating locale...`);const K=await this.getLocalArgvContent();let V=K;for(const z of Object.keys(Z))V=(0,l.edit)(V,[z],Z[z],{});K!==V&&(this.logService.trace(`${j}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(V)),this.logService.info(`${j}: Updated locale.`)),this.logService.info(`${j}: Updated locale`)}G.size&&(this.logService.trace(`${j}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData($,G,0),this.logService.info(`${j}: Updated global state`,[...G.keys()]))}};e.LocalGlobalStateProvider=w,e.LocalGlobalStateProvider=w=ye([X(0,C.IFileService),X(1,D.IEnvironmentService),X(2,t.IUserDataProfileStorageService),X(3,p.IUserDataSyncLogService)],w);let E=class extends h.AbstractInitializer{constructor(T,N,M,$,j,Z){super("globalState",M,$,j,N,T,Z)}async doInitialize(T){const N=T.syncData?JSON.parse(T.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},$={};for(const j of Object.keys(N.storage))j.startsWith(n)?M[j.substring(n.length)]=N.storage[j].value:this.storageService.get(j,0)===void 0&&($[j]=N.storage[j].value);if(Object.keys(M).length){let j="{}";try{j=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const Z of Object.keys(M))j=(0,l.edit)(j,[Z],M[Z],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(j))}if(Object.keys($).length){const j=[];for(const Z of Object.keys($))j.push({key:Z,value:$[Z],scope:0,target:0});this.storageService.storeAll(j,!0)}}};e.GlobalStateInitializer=E,e.GlobalStateInitializer=E=ye([X(0,g.IStorageService),X(1,C.IFileService),X(2,b.IUserDataProfilesService),X(3,D.IEnvironmentService),X(4,p.IUserDataSyncLogService),X(5,m.IUriIdentityService)],E);let d=class{constructor(T,N,M,$,j){this.userDataSyncStoreClient=T,this.storageService=N,this.environmentService=M,this.fileService=$,this.logService=j}getSyncStoreType(T){return this.parseGlobalState(T)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const N=(0,p.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(T,N)}catch(M){if(M instanceof p.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(T,N)}throw M}}async doSync(T,N){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),$=this.parseGlobalState(M)||{storage:{}};$.storage[p.SYNC_SERVICE_URL_TYPE]={value:T,version:r};const j=await(0,c.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),Z={version:r,machineId:j,content:i($,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(Z),M.ref,void 0,N)}parseGlobalState({content:T}){if(!T)return null;const N=JSON.parse(T);if((0,h.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=d,e.UserDataSyncStoreTypeSynchronizer=d=ye([X(1,g.IStorageService),X(2,D.IEnvironmentService),X(3,C.IFileService),X(4,S.ILogService)],d)}),define(oe[117],ae([0,1,18,15,3,35,6,12,171,19,14,11,20,22,28,17,39,233,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(t,a,n){try{const s=JSON.parse(t);if(!a)return(0,L.isUndefined)(s.all)?null:s.all;switch(_.OS){case 2:return(0,L.isUndefined)(s.mac)?null:s.mac;case 3:return(0,L.isUndefined)(s.linux)?null:s.linux;case 1:return(0,L.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.getKeybindingsContentFromSyncContent=u;let p=class extends m.AbstractJsonFileSynchroniser{constructor(a,n,s,i,r,o,w,E,d,v,T,N,M){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,E,d,v,s,i,w,N,r,T,o,M),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.filter(o.onDidChangeConfiguration,$=>$.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,n,s,i){const r=a.syncData?u(a.syncData.content,i.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?a:n;const o=n?this.getKeybindingsContentFromLastSyncUserData(n):null,w=await this.getLocalFileContent(),E=await this.getFormattingOptions();let d=null,v=!1,T=!1,N=!1;if(r){let j=w?w.value.toString():"[]";if(j=j||"[]",this.hasErrors(j,!0))throw new l.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==j||o!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const Z=await(0,h.merge)(j,r,o,E,this.userDataSyncUtilService);Z.hasChanges&&(d=Z.mergeContent,N=Z.hasConflicts,v=N||Z.mergeContent!==j,T=N||Z.mergeContent!==r)}}else w&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=w.value.toString(),T=!0);const M={content:N?o:d,localChange:v?w?2:1:0,remoteChange:T?2:0,hasConflicts:N},$=w?w.value.toString():null;return[{fileContent:w,baseResource:this.baseResource,baseContent:o,localResource:this.localResource,localContent:$,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const n=this.getKeybindingsContentFromLastSyncUserData(a);if(n===null)return!0;const s=await this.getLocalFileContent(),i=s?s.value.toString():"",r=await this.getFormattingOptions(),o=await(0,h.merge)(i||"[]",n,n,r,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==n}async getMergeResult(a,n){return a.previewResult}async getAcceptResult(a,n,s,i){if(this.extUri.isEqual(n,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(a,n,s,i){const{fileContent:r}=s[0][0];let{content:o,localChange:w,remoteChange:E}=s[0][1];if(w===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new l.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(o||"[]",r,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),E!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(o||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,i?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const n=(0,U.parse)(a.value.toString());if((0,k.isNonEmptyArray)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.baseResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a)?this.resolvePreviewContent(a):null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:u(a.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(a,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,_.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(l.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=p,e.KeybindingsSynchroniser=p=ye([X(2,l.IUserDataSyncStoreService),X(3,l.IUserDataSyncLocalStoreService),X(4,l.IUserDataSyncLogService),X(5,f.IConfigurationService),X(6,l.IUserDataSyncEnablementService),X(7,C.IFileService),X(8,D.IEnvironmentService),X(9,S.IStorageService),X(10,l.IUserDataSyncUtilService),X(11,c.ITelemetryService),X(12,g.IUriIdentityService)],p);let b=class extends m.AbstractInitializer{constructor(a,n,s,i,r,o){super("keybindings",n,s,i,a,r,o)}async doInitialize(a){const n=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(n)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,U.parse)(a.value.toString());return!(0,k.isNonEmptyArray)(n)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return u(a,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=b,e.KeybindingsInitializer=b=ye([X(0,C.IFileService),X(1,y.IUserDataProfilesService),X(2,D.IEnvironmentService),X(3,l.IUserDataSyncLogService),X(4,S.IStorageService),X(5,g.IUriIdentityService)],b)}),define(oe[118],ae([0,1,15,3,172,19,73,14,29,11,20,22,28,17,39,237,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(b){return b&&b.settings&&typeof b.settings=="string"&&Object.keys(b).length===1}function l(b){const t=JSON.parse(b);return h(t)?t:{settings:b}}e.parseSettingsSyncContent=l;let u=class extends g.AbstractJsonFileSynchroniser{constructor(t,a,n,s,i,r,o,w,E,d,v,T,N,M){super(t.settingsResource,{syncResource:"settings",profile:t},a,n,s,i,r,o,v,T,w,E,d,M),this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const a=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(t,a),s=this.getSettingsSyncContent(n),i=new _.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,a,n){const s=await this.getLocalFileContent(),i=await this.getFormattingOptions(),r=this.getSettingsSyncContent(t);a=a===null&&n?t:a;const o=a?this.getSettingsSyncContent(a):null,w=await this.getIgnoredSettings();let E=null,d=!1,v=!1,T=!1;if(r){let j=s?s.value.toString().trim():"{}";j=j||"{}",this.validateContent(j),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Z=(0,y.merge)(j,r.settings,o?o.settings:null,w,[],i);E=Z.localContent||Z.remoteContent,d=Z.localContent!==null,v=Z.remoteContent!==null,T=Z.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=s.value.toString().trim()||"{}",this.validateContent(E),v=!0);const N=s?s.value.toString():null,M=o?.settings??null,$={content:T?M:E,localChange:d?2:0,remoteChange:v?2:0,hasConflicts:T};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:N,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const a=this.getSettingsSyncContent(t);if(a===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",i=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,y.merge)(s||"{}",a.settings,a.settings,i,[],r).remoteContent!==null}async getMergeResult(t,a){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,y.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,a,n,s){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:t.fileContent?(0,y.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:t.remoteContent!==null?(0,y.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,y.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(t,a,n,s){const{fileContent:i}=n[0][0];let{content:r,localChange:o,remoteChange:w}=n[0][1];if(o===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),i&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(i.value.toString()))),await this.updateLocalFileContent(r,i,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const E=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),v=await this.getIgnoredSettings(r);r=(0,y.updateIgnoredSettings)(r,d?d.settings:"{}",v,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t)return!(0,y.isEmpty)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t)||this.extUri.isEqual(this.baseResource,t)?this.resolvePreviewContent(t):null}async resolvePreviewContent(t){let a=await super.resolvePreviewContent(t);if(a){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();a=(0,y.updateIgnoredSettings)(a,"{}",s,n)}return a}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return l(t)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const a=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(a,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new m.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=u,e.SettingsSynchroniser=u=ye([X(2,f.IFileService),X(3,L.IEnvironmentService),X(4,D.IStorageService),X(5,m.IUserDataSyncStoreService),X(6,m.IUserDataSyncLocalStoreService),X(7,m.IUserDataSyncLogService),X(8,m.IUserDataSyncUtilService),X(9,U.IConfigurationService),X(10,m.IUserDataSyncEnablementService),X(11,C.ITelemetryService),X(12,I.IExtensionManagementService),X(13,S.IUriIdentityService)],u);let p=class extends g.AbstractInitializer{constructor(t,a,n,s,i,r){super("settings",a,n,s,t,i,r)}async doInitialize(t){const a=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return l(t)}catch(a){this.logService.error(a)}return null}};e.SettingsInitializer=p,e.SettingsInitializer=p=ye([X(0,f.IFileService),X(1,c.IUserDataProfilesService),X(2,L.IEnvironmentService),X(3,m.IUserDataSyncLogService),X(4,D.IStorageService),X(5,S.IUriIdentityService)],p)}),define(oe[119],ae([0,1,15,3,30,19,14,11,20,22,28,17,39,234,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(l){return JSON.parse(l.content)}e.parseSnippets=y;let m=class extends S.AbstractSynchroniser{constructor(u,p,b,t,a,n,s,i,r,o,w,E){super({syncResource:"snippets",profile:u},p,t,b,a,n,s,o,w,i,r,E),this.version=1,this.snippetsFolder=u.snippetsHome,this._register(this.fileService.watch(b.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,d=>d.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(u,p,b){const t=await this.getSnippetsFileContents(),a=this.toSnippetsContents(t),n=u.syncData?this.parseSnippets(u.syncData):null;p=p===null&&b?u:p;const s=p&&p.syncData?this.parseSnippets(p.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,c.merge)(a,n,s);return this.getResourcePreviews(i,t,n||{},s||{})}async hasRemoteChanged(u){const p=u.syncData?this.parseSnippets(u.syncData):null;if(p===null)return!0;const b=await this.getSnippetsFileContents(),t=this.toSnippetsContents(b),a=(0,c.merge)(t,p,p);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async getMergeResult(u,p){return u.previewResult}async getAcceptResult(u,p,b,t){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return b===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:b,localChange:b===null?u.fileContent!==null?3:0:2,remoteChange:b===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(u,p,b,t){const a=b.map(([n,s])=>({...n,acceptResult:s}));a.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(a),await this.updateLocalSnippets(a,t)),a.some(({remoteChange:n})=>n!==0)&&(u=await this.updateRemoteSnippets(a,u,t)),p?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.fileService.del(n)}catch{}}getResourcePreviews(u,p,b,t){const a=new Map;for(const n of Object.keys(u.local.added)){const s={content:u.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u.local.updated)){const s={content:u.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=p[n]?p[n].value.toString():null;a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of u.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=p[n]?p[n].value.toString():null;a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u.remote.added)){const s={content:u.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=p[n]?p[n].value.toString():null;a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u.remote.updated)){const s={content:u.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=p[n]?p[n].value.toString():null;a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of u.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of u.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:p[n]?2:1,remoteChange:b[n]?2:1},i=p[n]?p[n].value.toString():null;a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(p))if(!a.has(n)){const s={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=p[n]?p[n].value.toString():null;a.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[n]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...a.values()]}async resolveContent(u){return this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(u):null}async hasLocalData(){try{const u=await this.getSnippetsFileContents();if(Object.keys(u).length)return!0}catch{}return!1}async updateLocalBackup(u){const p={};for(const b of u)b.fileContent&&(p[this.extUri.basename(b.localResource)]=b.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(u,p){for(const{fileContent:b,acceptResult:t,localResource:a,remoteResource:n,localChange:s}of u)if(s!==0){const i=n?this.extUri.basename(n):this.extUri.basename(a),r=this.extUri.joinPath(this.snippetsFolder,i);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,k.VSBuffer.fromString(t.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,k.VSBuffer.fromString(t.content),p?void 0:b),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(u,p,b){const t=p.syncData?this.parseSnippets(p.syncData):{},a=(0,A.deepClone)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:r}of u)if(r!==0){const o=s?this.extUri.basename(s):this.extUri.basename(i);r===3?delete a[o]:a[o]=n.content}return(0,c.areSame)(t,a)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(a),b?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(u){return y(u)}toSnippetsContents(u){const p={};for(const b of Object.keys(u))p[b]=u[b].value.toString();return p}async getSnippetsFileContents(){const u={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(b){if(b instanceof L.FileOperationError&&b.fileOperationResult===1)return u;throw b}for(const b of p.children||[]){const t=b.resource,a=this.extUri.extname(t);if(a===".json"||a===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,t),s=await this.fileService.readFile(t);u[n]=s}}return u}};e.SnippetsSynchroniser=m,e.SnippetsSynchroniser=m=ye([X(2,_.IEnvironmentService),X(3,L.IFileService),X(4,I.IStorageService),X(5,g.IUserDataSyncStoreService),X(6,g.IUserDataSyncLocalStoreService),X(7,g.IUserDataSyncLogService),X(8,U.IConfigurationService),X(9,g.IUserDataSyncEnablementService),X(10,f.ITelemetryService),X(11,D.IUriIdentityService)],m);let h=class extends S.AbstractInitializer{constructor(u,p,b,t,a,n){super("snippets",p,b,t,u,a,n)}async doInitialize(u){const p=u.syncData?JSON.parse(u.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(p)){const a=p[t];if(a){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,t);await this.fileService.createFile(n,k.VSBuffer.fromString(a)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(u)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.SnippetsInitializer=h,e.SnippetsInitializer=h=ye([X(0,L.IFileService),X(1,C.IUserDataProfilesService),X(2,_.IEnvironmentService),X(3,g.IUserDataSyncLogService),X(4,I.IStorageService),X(5,D.IUriIdentityService)],h)}),define(oe[120],ae([0,1,15,19,14,11,20,22,28,17,39,25]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(m,h){try{return JSON.parse(m).tasks??null}catch(l){return h.error(l),null}}e.getTasksContentFromSyncContent=S;let c=class extends D.AbstractFileSynchroniser{constructor(h,l,u,p,b,t,a,n,s,i,r,o){super(h.tasksResource,{syncResource:"tasks",profile:h},l,n,s,i,u,p,a,r,b,t,o),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,l,u,p){const b=h.syncData?S(h.syncData.content,this.logService):null;l=l===null&&u?h:l;const t=l?.syncData?S(l.syncData.content,this.logService):null,a=await this.getLocalFileContent();let n=null,s=!1,i=!1,r=!1;if(h.syncData){const E=a?a.value.toString():null;if(!t||t!==E||t!==b){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const d=y(E,b,t);n=d.content,r=d.hasConflicts,s=d.hasLocalChanged,i=d.hasRemoteChanged}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),i=!0);const o={content:r?t:n,localChange:s?a?2:1:0,remoteChange:i?2:0,hasConflicts:r},w=a?a.value.toString():null;return[{fileContent:a,baseResource:this.baseResource,baseContent:t,localResource:this.localResource,localContent:w,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:b,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const l=h?.syncData?S(h.syncData.content,this.logService):null;if(l===null)return!0;const u=await this.getLocalFileContent(),p=u?u.value.toString():null,b=y(p,l,l);return b.hasLocalChanged||b.hasRemoteChanged}async getMergeResult(h,l){return h.previewResult}async getAcceptResult(h,l,u,p){if(this.extUri.isEqual(l,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(l,this.remoteResource))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(l,this.previewResource))return u===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(h,l,u,p){const{fileContent:b}=u[0][0],{content:t,localChange:a,remoteChange:n}=u[0][1];if(a===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),b&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(b.value.toString()))),t?await this.updateLocalFileContent(t,b,p):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(t));h=await this.updateRemoteUserData(s,p?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}l?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(h){return this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)?this.resolvePreviewContent(h):null}toTasksSyncContent(h){return h?{tasks:h}:{}}};e.TasksSynchroniser=c,e.TasksSynchroniser=c=ye([X(2,C.IUserDataSyncStoreService),X(3,C.IUserDataSyncLocalStoreService),X(4,C.IUserDataSyncLogService),X(5,O.IConfigurationService),X(6,C.IUserDataSyncEnablementService),X(7,U.IFileService),X(8,A.IEnvironmentService),X(9,_.IStorageService),X(10,L.ITelemetryService),X(11,I.IUriIdentityService)],c);let g=class extends D.AbstractInitializer{constructor(h,l,u,p,b,t){super("tasks",l,u,p,h,b,t),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const l=h.syncData?S(h.syncData.content,this.logService):null;if(!l){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(l)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=g,e.TasksInitializer=g=ye([X(0,U.IFileService),X(1,f.IUserDataProfilesService),X(2,A.IEnvironmentService),X(3,C.IUserDataSyncLogService),X(4,_.IStorageService),X(5,I.IUriIdentityService)],g);function y(m,h,l){if(m===null&&h===null&&l===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(m===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=l!==m,p=l!==h;return!u&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!p?{content:m,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!u?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:m,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,19,14,11,20,22,28,17,39,235,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let c=class extends D.AbstractSynchroniser{constructor(h,l,u,p,b,t,a,n,s,i,r,o,w){super({syncResource:"profiles",profile:h},l,p,b,t,a,n,r,o,s,i,w),this.userDataProfilesService=u,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(u.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?y(h.syncData):null}async getRemoteSyncedProfiles(h){const l=await this.getLastSyncUserData(),u=await this.getLatestRemoteUserData(h,l);return u?.syncData?y(u.syncData):null}async generateSyncPreview(h,l,u){if(!this.userDataProfilesService.isEnabled())throw new S.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const p=h.syncData?y(h.syncData):null,b=l?.syncData?y(l.syncData):null,t=this.getLocalUserDataProfiles(),{local:a,remote:n}=(0,C.merge)(t,p,b,[]),s={local:a,remote:n,content:b?this.stringifyRemoteProfiles(b):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},i=g(t,!1);return[{baseResource:this.baseResource,baseContent:b?this.stringifyRemoteProfiles(b):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:p?this.stringifyRemoteProfiles(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const l=h?.syncData?y(h.syncData):null,u=this.getLocalUserDataProfiles(),{remote:p}=(0,C.merge)(u,l,l,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async getMergeResult(h,l){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,l,u,p){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(l,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(h){const l=this.getLocalUserDataProfiles(),u=(0,C.merge)(l,null,null,[]),{local:p,remote:b}=u;return{content:h.localContent,local:p,remote:b,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:b!==null?2:0}}async acceptRemote(h){const l=h.remoteContent?JSON.parse(h.remoteContent):null,u=[],p=[];for(const b of this.getLocalUserDataProfiles()){const t=l?.find(a=>a.id===b.id);t&&(u.push({id:b.id,name:b.name,collection:t.collection}),p.push(b))}if(l!==null){const b=(0,C.merge)(p,l,u,[]),{local:t,remote:a}=b;return{content:h.remoteContent,local:t,remote:a,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,l,u,p){const{local:b,remote:t,localChange:a,remoteChange:n}=u[0][1];a===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const s=u[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new S.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.backupLocal(g(this.getLocalUserDataProfiles(),!1));const i=[];for(const r of b.added)i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of b.removed)i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of b.updated){const o=this.userDataProfilesService.profiles.find(w=>w.id===r.id);o?i.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const i=[],r=s.length+(t?.added.length??0)<=20;if(r)for(const o of t?.added||[]){const w=await this.userDataSyncStoreService.createCollection(this.syncHeaders);i.push(w),s.push({id:o.id,name:o.name,collection:w,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const o of t?.removed||[])s.splice(s.findIndex(({id:w})=>o.id===w),1);for(const o of t?.updated||[]){const w=s.find(({id:E})=>o.id===E);w&&s.splice(s.indexOf(w),1,{...w,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{h=await this.updateRemoteProfiles(s,p?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(o=>o.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(o=>o.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(o=>o.name))}.`:""}`)}catch(o){if(i.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of i)await this.userDataSyncStoreService.deleteCollection(w,this.syncHeaders)}throw o}for(const o of t?.removed||[])await this.userDataSyncStoreService.deleteCollection(o.collection,this.syncHeaders)}l?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,l){return this.updateRemoteUserData(this.stringifyRemoteProfiles(h),l)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const l=await this.resolvePreviewContent(h);return l&&(0,k.toFormattedString)(JSON.parse(l),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(h=>!h.isDefault&&!h.isTransient)}stringifyRemoteProfiles(h){return JSON.stringify([...h].sort((l,u)=>l.name.localeCompare(u.name)))}};e.UserDataProfilesManifestSynchroniser=c,e.UserDataProfilesManifestSynchroniser=c=ye([X(2,f.IUserDataProfilesService),X(3,U.IFileService),X(4,A.IEnvironmentService),X(5,_.IStorageService),X(6,S.IUserDataSyncStoreService),X(7,S.IUserDataSyncLocalStoreService),X(8,S.IUserDataSyncLogService),X(9,O.IConfigurationService),X(10,S.IUserDataSyncEnablementService),X(11,L.ITelemetryService),X(12,I.IUriIdentityService)],c);function g(m,h){const l=[...m].sort((u,p)=>u.name.localeCompare(p.name)).map(u=>({id:u.id,name:u.name}));return h?(0,k.toFormattedString)(l,{}):JSON.stringify(l)}e.stringifyLocalProfiles=g;function y(m){return JSON.parse(m.content)}e.parseUserDataProfilesManifest=y}),define(oe[253],ae([0,1,3,2,6,14,20,22,25]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const f="sync.enable";let D=class extends O.Disposable{constructor(S,c,g,y){super(),this.storageService=S,this.telemetryService=c,this.environmentService=g,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(-1,void 0,this._register(new O.DisposableStore))(m=>this.onDidStorageChange(m)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(f,{enabled:S}),this.storageService.store(f,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,I.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,c){if(this.isResourceEnabled(S)!==c){const g=(0,I.getEnablementKey)(S);this.storeResourceEnablement(g,c)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,c){this.storageService.store(S,c,-1,A.isWeb?0:1)}onDidStorageChange(S){if(f===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const c=I.ALL_SYNC_RESOURCES.filter(g=>(0,I.getEnablementKey)(g)===S.key)[0];if(c){this._onDidChangeResourceEnablement.fire([c,this.isResourceEnabled(c)]);return}}};e.UserDataSyncEnablementService=D,e.UserDataSyncEnablementService=D=ye([X(0,_.IStorageService),X(1,L.ITelemetryService),X(2,U.IEnvironmentService),X(3,I.IUserDataSyncStoreManagementService)],D)}),define(oe[254],ae([0,1,5,15,62,2,21,19,14,11,17,25]),function(te,e,k,O,A,U,_,L,I,f,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let S=class extends U.Disposable{constructor(g,y,m,h,l){super(),this.environmentService=g,this.fileService=y,this.configurationService=m,this.logService=h,this.userDataProfilesService=l,this.cleanUp()}async cleanUp(){for(const y of this.userDataProfilesService.profiles)for(const m of C.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(m,y.isDefault?void 0:y.id))}catch(h){this.logService.error(h)}let g;try{g=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(y){(0,f.toFileOperationResult)(y)!==1&&this.logService.error(y);return}if(g.children){for(const y of g.children)if(y.isDirectory&&!this.userDataProfilesService.profiles.some(m=>m.id===y.name))try{this.logService.info("Deleting non existing profile from backup",y.resource.path),await this.fileService.del(y.resource,{recursive:!0})}catch(m){this.logService.error(m)}}}async getAllResourceRefs(g,y,m){const h=this.getResourceBackupHome(g,y,m);try{const l=await this.fileService.resolve(h);if(l.children)return l.children.filter(p=>p.isFile&&!p.name.startsWith("lastSync")).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)}))}catch(l){if((0,f.toFileOperationResult)(l)!==1)throw l}return[]}async resolveResourceContent(g,y,m,h){const l=this.getResourceBackupHome(g,m,h),u=(0,_.joinPath)(l,y);try{return(await this.fileService.readFile(u)).value.toString()}catch(p){return this.logService.error(p),null}}async writeResource(g,y,m,h,l){const u=this.getResourceBackupHome(g,h,l),p=(0,_.joinPath)(u,`${(0,A.toLocalISOString)(m).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,O.VSBuffer.fromString(y))}catch(b){this.logService.error(b)}}getResourceBackupHome(g,y,m=this.environmentService.userDataSyncHome){return(0,_.joinPath)(m,...y?[y,g]:[g])}async cleanUpBackup(g){try{try{if(!await this.fileService.exists(g))return}catch{return}const y=await this.fileService.resolve(g);if(y.children){const m=y.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let l=m.filter(p=>Date.now()-this.getCreationTime(p)>h);const u=m.length-l.length;u<10&&(l=l.slice(10-u)),await k.Promises.settled(l.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=S,e.UserDataSyncLocalStoreService=S=ye([X(0,I.IEnvironmentService),X(1,f.IFileService),X(2,L.IConfigurationService),X(3,C.IUserDataSyncLogService),X(4,D.IUserDataProfilesService)],S)}),define(oe[81],ae([0,1,3,2,6,27,176,14,11,4,24,43,20,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,f.createDecorator)("IUserDataSyncMachinesService");const y="sync.currentMachineName",m="Safari",h="Chrome",l="Edge",u="Firefox",p="Android";function b(n){switch(n){case m:case h:case l:case u:case p:case(0,A.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function t(){return A.isSafari?m:A.isChrome?h:A.isEdge?l:A.isFirefox?u:A.isAndroid?p:(0,A.PlatformToString)(A.isWeb?0:A.platform)}let a=class extends O.Disposable{static{g=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(s,i,r,o,w,E){super(),this.storageService=r,this.userDataSyncStoreService=o,this.logService=w,this.productService=E,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(s,i,r)}async getMachines(s){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(s)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(s){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(s);r.machines.some(({id:o})=>o===i)||(r.machines.push({id:i,name:this.computeCurrentMachineName(r.machines),platform:t()}),await this.writeMachinesData(r))}async removeCurrentMachine(s){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(s),o=r.machines.filter(({id:w})=>w!==i);o.length!==r.machines.length&&(r.machines=o,await this.writeMachinesData(r))}async renameMachine(s,i,r){const o=await this.readMachinesData(r),w=o.machines.find(({id:E})=>E===s);if(w){w.name=i,await this.writeMachinesData(o);const E=await this.currentMachineIdPromise;s===E&&this.storageService.store(y,i,-1,1)}}async setEnablements(s){const i=await this.readMachinesData();for(const[r,o]of s){const w=i.machines.find(E=>E.id===r);w&&(w.disabled=o?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(s){const i=this.storageService.get(y,-1);if(i)return i;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${t()} (${this.productService.nameShort})`,o=new RegExp(`${(0,U.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let w=0;for(const E of s){const d=o.exec(E.name),v=d?parseInt(d[1]):0;w=v>w?v:w}return`${r} #${w+1}`}async readMachinesData(s){this.userData=await this.readUserData(s);const i=this.parse(this.userData);if(i.version!==g.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(s){const i=JSON.stringify(s),r=await this.userDataSyncStoreService.writeResource(g.RESOURCE,i,this.userData?.ref||null);this.userData={ref:r,content:i},this._onDidChange.fire()}async readUserData(s){if(this.userData){const i=s&&s.latest?s.latest[g.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(g.RESOURCE,this.userData)}parse(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.logService.error(i)}return{version:g.VERSION,machines:[]}}};e.UserDataSyncMachinesService=a,e.UserDataSyncMachinesService=a=g=ye([X(0,L.IEnvironmentService),X(1,I.IFileService),X(2,S.IStorageService),X(3,c.IUserDataSyncStoreService),X(4,c.IUserDataSyncLogService),X(5,D.IProductService)],a)}),define(oe[255],ae([0,1,5,62,38,8,3,2,6,21,10,173,24,20,22,25,78,81]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const l="sync.disableMachineEventually",u="sync.sessionId",p="sync.storeUrl",b="sync.productQuality";let t=class extends L.Disposable{get syncUrl(){const s=this.storageService.get(p,-1);return s?D.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(p,s.toString(),-1,1):this.storageService.remove(p,-1)}get productQuality(){return this.storageService.get(b,-1)}set productQuality(s){s?this.storageService.store(b,s,-1,1):this.storageService.remove(b,-1)}constructor(s,i,r,o,w,E,d,v,T,N){super(),this.userDataSyncStoreManagementService=i,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=o,this.userDataSyncService=w,this.logService=E,this.userDataSyncAccountService=d,this.telemetryService=v,this.userDataSyncMachinesService=T,this.storageService=N,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(i.onDidChangeUserDataSyncStore(()=>{(0,f.isEqual)(this.syncUrl,i.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(d.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(w.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:i}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(i&&this.logService.info(i),this.autoSync.clear()):i&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(i))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,i,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(u,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(this.logService.error(o),i)this.updateEnablement(!1);else throw o}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const i=y.UserDataSyncError.toUserDataSyncError(s);i instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:i.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?I.isWeb&&i.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(i),this.successiveFailures++),this._onError.fire(i)}async disableMachineEventually(){this.storageService.store(l,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(l,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(l,-1)}async triggerSync(s,i,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(i&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const o=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:o}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=t,e.UserDataAutoSyncService=t=ye([X(0,S.IProductService),X(1,y.IUserDataSyncStoreManagementService),X(2,y.IUserDataSyncStoreService),X(3,y.IUserDataSyncEnablementService),X(4,y.IUserDataSyncService),X(5,y.IUserDataSyncLogService),X(6,m.IUserDataSyncAccountService),X(7,g.ITelemetryService),X(8,h.IUserDataSyncMachinesService),X(9,c.IStorageService)],t);class a extends L.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(s,i,r,o,w,E,d,v,T){super(),this.lastSyncUrl=s,this.interval=i,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=o,this.userDataSyncService=w,this.userDataSyncMachinesService=E,this.logService=d,this.telemetryService=v,this.storageService=T,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,L.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>{this.sync(a.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(s,i){const r=(0,k.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(w){if((0,U.isCancellationError)(w))return}return this.doSync(s,i,o)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,f.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),i=this.userDataSyncStoreManagementService.userDataSyncStore;return!!i&&!!s&&(!(0,f.isEqual)(i.defaultUrl,s.defaultUrl)||!(0,f.isEqual)(i.insidersUrl,s.insidersUrl)||!(0,f.isEqual)(i.stableUrl,s.stableUrl))}async doSync(s,i,r){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let o;try{await this.createAndRunSyncTask(i,r)}catch(w){if(this.logService.error(w),o=w,y.UserDataSyncError.toUserDataSyncError(w).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(i,r),o=void 0}catch(E){this.logService.error(E),o=E}}this._onDidFinishSync.fire(o)}async createAndRunSyncTask(s,i){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),i.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const r=this.storageService.get(u,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const o=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(i.isCancellationRequested)return;const w=o.find(d=>d.isCurrent);if(w?.disabled)throw new y.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");const E=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-E}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(d){throw new y.UserDataAutoSyncError((0,A.toErrorMessage)(d),d instanceof y.UserDataSyncError?d.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(u,this.manifest.session,-1,1),!i.isCancellationRequested&&(w||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(s){return super._register(s)}}}),define(oe[256],ae([0,1,10,177,14,11,43,20,28,25,17,39,119,118,117,19,120,115,116,4,121,41,27]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{a=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(i,r,o,w,E,d,v,T,N,M){this.userDataSyncStoreService=i,this.userDataSyncLocalStoreService=r,this.logService=o,this.environmentService=E,this.storageService=d,this.fileService=v,this.userDataProfilesService=T,this.configurationService=N,this.instantiationService=M,this.extUri=w.extUri}async getRemoteSyncedProfiles(){const i=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(i.content){const r=this.parseSyncData(i.content,"profiles");return(0,p.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(i){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,i);if(r.length){const o=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",r[0].ref,void 0,i);if(o){const w=this.parseSyncData(o,"profiles");return(0,p.parseUserDataProfilesManifest)(w)}}return[]}async getLocalSyncedMachines(i){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,i);if(r.length){const o=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,i);if(o)return JSON.parse(o).machines.map(E=>({...E,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,r){return(await this.userDataSyncStoreService.getAllResourceRefs(i,r?.collection)).map(({created:w,ref:E})=>({created:w,uri:this.toUri({remote:!0,syncResource:i,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:E,node:void 0})}))}async getLocalSyncResourceHandles(i,r,o){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(i,r?.collection,o)).map(({created:E,ref:d})=>({created:E,uri:this.toUri({remote:!1,syncResource:i,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:d,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:i}){const r=this.resolveUri(i),o=r?this.userDataProfilesService.profiles.find(w=>w.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:i}){const r=this.resolveUri(i);if(!r)return[];const o=this.userDataProfilesService.profiles.find(w=>w.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(i,o);case"keybindings":return this.getKeybindingsAssociatedResources(i,o);case"tasks":return this.getTasksAssociatedResources(i,o);case"snippets":return this.getSnippetsAssociatedResources(i,o);case"globalState":return this.getGlobalStateAssociatedResources(i,o);case"extensions":return this.getExtensionsAssociatedResources(i,o);case"profiles":return this.getProfilesAssociatedResources(i,o);case"workspaceState":return[]}}async getMachineId({uri:i}){const r=this.resolveUri(i);if(r){if(r.remote){if(r.ref){const{content:o}=await this.getUserData(r.syncResource,r.ref,r.collection);if(o)return this.parseSyncData(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.parseSyncData(o,r.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(i){const r=this.resolveUri(i);if(!r||r.node===a.NOT_EXISTING_RESOURCE)return null;if(r.ref){const o=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.resolveNodeContent(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(i,r,o,w,E){if(i){const{content:d}=await this.getUserData(r,w,o);return d}return this.userDataSyncLocalStoreService.resolveResourceContent(r,w,o,E)}resolveNodeContent(i,r,o){const w=this.parseSyncData(r,i);switch(i){case"settings":return this.resolveSettingsNodeContent(w,o);case"keybindings":return this.resolveKeybindingsNodeContent(w,o);case"tasks":return this.resolveTasksNodeContent(w,o);case"snippets":return this.resolveSnippetsNodeContent(w,o);case"globalState":return this.resolveGlobalStateNodeContent(w,o);case"extensions":return this.resolveExtensionsNodeContent(w,o);case"profiles":return this.resolveProfileNodeContent(w,o);case"workspaceState":return null}}async resolveLatestContent(i,r){const o=this.userDataProfilesService.profiles.find(w=>w.id===r);if(!o)return null;switch(i){case"globalState":return this.resolveLatestGlobalStateContent(o);case"extensions":return this.resolveLatestExtensionsContent(o);case"profiles":return this.resolveLatestProfilesContent(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(i,r){const o=this.extUri.joinPath(i,"settings.json"),w=r?r.settingsResource:this.extUri.joinPath(i,a.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:w}]}resolveSettingsNodeContent(i,r){switch(r){case"settings.json":return(0,c.parseSettingsSyncContent)(i.content).settings}return null}getKeybindingsAssociatedResources(i,r){const o=this.extUri.joinPath(i,"keybindings.json"),w=r?r.keybindingsResource:this.extUri.joinPath(i,a.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:w}]}resolveKeybindingsNodeContent(i,r){switch(r){case"keybindings.json":return(0,g.getKeybindingsContentFromSyncContent)(i.content,!!this.configurationService.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(i,r){const o=this.extUri.joinPath(i,"tasks.json"),w=r?r.tasksResource:this.extUri.joinPath(i,a.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:w}]}resolveTasksNodeContent(i,r){switch(r){case"tasks.json":return(0,m.getTasksContentFromSyncContent)(i.content,this.logService)}return null}async getSnippetsAssociatedResources(i,r){const o=await this.resolveContent(i);if(o){const w=this.parseSyncData(o,"snippets");if(w){const E=(0,S.parseSnippets)(w),d=[];for(const v of Object.keys(E)){const T=this.extUri.joinPath(i,v),N=r?this.extUri.joinPath(r.snippetsHome,v):this.extUri.joinPath(i,a.NOT_EXISTING_RESOURCE);d.push({resource:T,comparableResource:N})}return d}}return[]}resolveSnippetsNodeContent(i,r){return(0,S.parseSnippets)(i)[r]||null}getExtensionsAssociatedResources(i,r){const o=this.extUri.joinPath(i,"extensions.json"),w=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(i,a.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:w}]}resolveExtensionsNodeContent(i,r){switch(r){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(i),!0)}return null}async resolveLatestExtensionsContent(i){const{localExtensions:r}=await this.instantiationService.createInstance(h.LocalExtensionsProvider).getLocalExtensions(i);return(0,h.stringify)(r,!0)}getGlobalStateAssociatedResources(i,r){const o=this.extUri.joinPath(i,"globalState.json"),w=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(i,a.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:w}]}resolveGlobalStateNodeContent(i,r){switch(r){case"globalState.json":return(0,l.stringify)(JSON.parse(i.content),!0)}return null}async resolveLatestGlobalStateContent(i){const r=await this.instantiationService.createInstance(l.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,l.stringify)(r,!0)}getProfilesAssociatedResources(i,r){const o=this.extUri.joinPath(i,"profiles.json"),w=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:w}]}resolveProfileNodeContent(i,r){switch(r){case"profiles.json":return(0,b.toFormattedString)(JSON.parse(i.content),{})}return null}async resolveLatestProfilesContent(i){return(0,p.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(i){const r=i.remote?a.REMOTE_BACKUP_AUTHORITY:a.LOCAL_BACKUP_AUTHORITY,o=[];return i.location&&(o.push(`scheme:${i.location.scheme}`),o.push(`authority:${i.location.authority}`),o.push((0,t.trim)(i.location.path,"/"))),o.push(`syncResource:${i.syncResource}`),o.push(`profile:${i.profile}`),i.collection&&o.push(`collection:${i.collection}`),i.ref&&o.push(`ref:${i.ref}`),i.node&&o.push(i.node),this.extUri.joinPath(k.URI.from({scheme:f.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...o)}resolveUri(i){if(i.scheme!==f.USER_DATA_SYNC_SCHEME)return;const r=[];for(;i.path!=="/";)r.unshift(this.extUri.basename(i)),i=this.extUri.dirname(i);if(r.length<2)return;const o=i.authority===a.REMOTE_BACKUP_AUTHORITY;let w,E;const d=[];let v,T,N,M,$;for(;r.length;){const j=r.shift();j.startsWith("scheme:")?w=j.substring(7):j.startsWith("authority:")?E=j.substring(10):j.startsWith("syncResource:")?v=j.substring(13):j.startsWith("profile:")?T=j.substring(8):j.startsWith("collection:")?N=j.substring(11):j.startsWith("ref:")?M=j.substring(4):v?$=j:d.push(j)}return{remote:o,syncResource:v,profile:T,collection:N,ref:M,node:$,location:w&&E!==void 0?this.extUri.joinPath(k.URI.from({scheme:w,authority:E,query:i.query,fragment:i.fragment,path:"/"}),...d):void 0}}parseSyncData(i,r){try{const o=JSON.parse(i);if((0,C.isSyncData)(o))return o}catch(o){this.logService.error(o)}throw new f.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(i,r,o){const w=await this.userDataSyncStoreService.resolveResourceContent(i,r,o);return{ref:r,content:w}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=a=ye([X(0,f.IUserDataSyncStoreService),X(1,f.IUserDataSyncLocalStoreService),X(2,f.IUserDataSyncLogService),X(3,I.IUriIdentityService),X(4,A.IEnvironmentService),X(5,L.IStorageService),X(6,U.IFileService),X(7,D.IUserDataProfilesService),X(8,y.IConfigurationService),X(9,u.IInstantiationService)],n)}),define(oe[257],ae([0,1,18,5,26,38,3,2,21,12,32,19,29,11,4,20,22,17,115,116,117,118,119,120,121,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t,a,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let r=class extends L.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(v,T,N,M,$,j,Z,G,Q,B,K){super(),this.fileService=v,this.userDataSyncStoreService=T,this.userDataSyncStoreManagementService=N,this.instantiationService=M,this.logService=$,this.telemetryService=j,this.storageService=Z,this.userDataSyncEnablementService=G,this.userDataProfilesService=Q,this.userDataSyncResourceProviderService=B,this.userDataSyncLocalStoreService=K,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=N.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(i,-1,void 0),this._register((0,L.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(v,T){this.checkEnablement(),this.logService.info("Sync started.");const N=new Date().getTime(),M=(0,D.generateUuid)();try{const G=(0,s.createSyncHeaders)(M);T&&(G["Cache-Control"]="no-cache"),v=await this.userDataSyncStoreService.manifest(v,G)}catch(G){const Q=s.UserDataSyncError.toUserDataSyncError(G);throw E(Q,M,this.userDataSyncStoreManagementService,this.telemetryService),Q}const $=!1,j=this;let Z;return{manifest:v,async run(){if($)throw new Error("Can run a task only once");Z=(0,O.createCancelablePromise)(G=>j.sync(v,!1,M,G)),await Z.finally(()=>Z=void 0),j.logService.info(`Sync done. Took ${new Date().getTime()-N}ms`),j.updateLastSyncTime()},stop(){return Z?.cancel(),j.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const v=new Date().getTime(),T=(0,D.generateUuid)(),N=(0,s.createSyncHeaders)(T);let M;try{M=await this.userDataSyncStoreService.manifest(null,N)}catch(Z){const G=s.UserDataSyncError.toUserDataSyncError(Z);throw E(G,T,this.userDataSyncStoreManagementService,this.telemetryService),G}await this.resetLocal();const $=this,j=new A.CancellationTokenSource;return{id:T,async merge(){return $.sync(M,!0,T,j.token)},async apply(){try{try{await $.applyManualSync(M,T,j.token)}catch(Z){if(s.UserDataSyncError.toUserDataSyncError(Z).code==="MethodNotFound")$.logService.info("Client is making invalid requests. Cleaning up data..."),await $.cleanUpRemoteData(),$.logService.info("Applying manual sync again..."),await $.applyManualSync(M,T,j.token);else throw Z}}catch(Z){throw $.logService.error(Z),Z}$.logService.info(`Sync done. Took ${new Date().getTime()-v}ms`),$.updateLastSyncTime()},async stop(){j.cancel(),await $.stop(),await $.resetLocal()}}}async sync(v,T,N,M){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const $=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile($,v,T,N,M));const j=$.enabled.find(Z=>Z.resource==="profiles");if(j){const Z=await j.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.syncRemoteProfiles(Z,v,T,N,M)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(v,T,N,M,$){for(const j of v){if($.isCancellationRequested)return;const Z=this.userDataProfilesService.profiles.find(Q=>Q.id===j.id);if(!Z){this.logService.error(`Profile with id:${j.id} and name: ${j.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",j.name);const G=this.getOrCreateActiveProfileSynchronizer(Z,j);this._syncErrors.push(...await this.syncProfile(G,T,N,M,$))}for(const[j,Z]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(G=>G.id===Z[0].profile.id)||(Z[1].dispose(),this.activeProfileSynchronizers.delete(j))}async applyManualSync(v,T,N){const M=this.getActiveProfileSynchronizers();for(const Q of M){if(N.isCancellationRequested)return;await Q.apply(T,N)}const $=M.find(Q=>Q.profile.isDefault);if(!$)return;const j=$.enabled.find(Q=>Q.resource==="profiles");if(!j)return;const G=(await j.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(Q=>M.every(B=>B.profile.id!==Q.id));G.length&&await this.syncRemoteProfiles(G,v,!1,T,N)}async syncProfile(v,T,N,M,$){return(await v.sync(T,N,M,$)).map(([Z,G])=>({profile:v.profile,syncResource:Z,error:G}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(v=>v.stop()))}async resolveContent(v){const T=await this.userDataSyncResourceProviderService.resolveContent(v);if(T)return T;for(const N of this.getActiveProfileSynchronizers())for(const M of N.enabled){const $=await M.resolveContent(v);if($)return $}return null}async replace(v){this.checkEnablement();const T=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(v);if(!T)return;const N=await this.resolveContent(v.uri);N&&await this.performAction(T.profile,async M=>{if(T.syncResource===M.resource)return await M.replace(N),!0})}async accept(v,T,N,M){this.checkEnablement(),await this.performAction(v.profile,async $=>{if(v.syncResource===$.resource)return await $.accept(T,N),M&&await $.apply((0,f.isBoolean)(M)?!1:M.force,(0,s.createSyncHeaders)((0,D.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async T=>{if(T.resource!=="globalState"&&await T.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async T=>{if(await T.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(v){this.logService.error(v)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(i,-1);for(const[v]of this.activeProfileSynchronizers.values())try{await v.resetLocal()}catch(T){this.logService.error(T)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const v=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),T=v.map(j=>j.collection),N=await this.userDataSyncStoreService.getAllCollections(),M=N.filter(j=>!T.includes(j));M.length&&(this.logService.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(j=>this.userDataSyncStoreService.deleteCollection(j))),this.logService.info("Deleted redundant collections on server"));const $=v.filter(j=>N.includes(j.collection));if($.length!==v.length){const j=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await j.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await j.updateRemoteProfiles($,null),this.logService.info("Updated remote profiles on server")}finally{j.dispose()}}}async saveRemoteActivityData(v){this.checkEnablement();const T=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(v,T)}async extractActivityData(v,T){const N=(await this.fileService.readFile(v)).value.toString(),M=JSON.parse(N);if(M.resources)for(const $ in M.resources)for(const j of M.resources[$])await this.userDataSyncLocalStoreService.writeResource($,j.content,new Date(j.created*1e3),void 0,T);if(M.collections)for(const $ in M.collections)for(const j in M.collections[$].resources)for(const Z of M.collections[$].resources?.[j]??[])await this.userDataSyncLocalStoreService.writeResource(j,Z.content,new Date(Z.created*1e3),$,T)}async performAction(v,T){const N=new L.DisposableStore;try{const M=this.activeProfileSynchronizers.get(v.id);if(M){const Q=await this.performActionWithProfileSynchronizer(M[0],T,N);return(0,f.isUndefined)(Q)?null:Q}if(v.isDefault){const Q=N.add(this.instantiationService.createInstance(o,v,void 0)),B=await this.performActionWithProfileSynchronizer(Q,T,N);return(0,f.isUndefined)(B)?null:B}if(this.userDataProfilesService.isEnabled())return null;const $=N.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,v,void 0)),j=await this.userDataSyncStoreService.manifest(null),G=(await $.getRemoteSyncedProfiles(j?.latest??null)||[]).find(Q=>Q.id===v.id);if(G){const Q=N.add(this.instantiationService.createInstance(o,v,G.collection)),B=await this.performActionWithProfileSynchronizer(Q,T,N);return(0,f.isUndefined)(B)?null:B}return null}finally{N.dispose()}}async performActionWithProfileSynchronizer(v,T,N){const M=[...v.enabled,...v.disabled.reduce(($,j)=>(j!=="workspaceState"&&$.push(N.add(v.createSynchronizer(j))),$),[])];for(const $ of M){const j=await T($);if(!(0,f.isUndefined)(j))return j}}setStatus(v){const T=this._status;this._status!==v&&(this._status=v,this._onDidChangeStatus.fire(v),T==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const v=this.getActiveProfileSynchronizers().map(T=>T.conflicts).flat();(0,k.equals)(this._conflicts,v,(T,N)=>T.profile.id===N.profile.id&&T.syncResource===N.syncResource&&(0,k.equals)(T.conflicts,N.conflicts,(M,$)=>(0,I.isEqual)(M.previewResource,$.previewResource)))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(v,T){let N=this.activeProfileSynchronizers.get(v.id);if(N&&N[0].collection!==T?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.activeProfileSynchronizers.delete(v.id)),!N){const M=new L.DisposableStore,$=M.add(this.instantiationService.createInstance(o,v,T?.collection));M.add($.onDidChangeStatus(j=>this.setStatus(j))),M.add($.onDidChangeConflicts(j=>this.updateConflicts())),M.add($.onDidChangeLocal(j=>this._onDidChangeLocal.fire(j))),this.activeProfileSynchronizers.set(v.id,N=[$,M])}return N[0]}getActiveProfileSynchronizers(){const v=[];for(const[T]of this.activeProfileSynchronizers.values())v.push(T);return v}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,v])=>v.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=ye([X(0,c.IFileService),X(1,s.IUserDataSyncStoreService),X(2,s.IUserDataSyncStoreManagementService),X(3,g.IInstantiationService),X(4,s.IUserDataSyncLogService),X(5,m.ITelemetryService),X(6,y.IStorageService),X(7,s.IUserDataSyncEnablementService),X(8,h.IUserDataProfilesService),X(9,s.IUserDataSyncResourceProviderService),X(10,s.IUserDataSyncLocalStoreService)],r);let o=class extends L.Disposable{get enabled(){return this._enabled.sort((v,T)=>v[1]-T[1]).map(([v])=>v)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(v=>!this.userDataSyncEnablementService.isResourceEnabled(v))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(v,T,N,M,$,j,Z,G,Q,B){super(),this.profile=v,this.collection=T,this.userDataSyncEnablementService=N,this.instantiationService=M,this.extensionGalleryService=$,this.userDataSyncStoreManagementService=j,this.telemetryService=Z,this.logService=G,this.userDataProfilesService=Q,this.configurationService=B,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(N.onDidChangeResourceEnablement(([K,V])=>this.onDidChangeResourceEnablement(K,V))),this._register((0,L.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,K])=>K.dispose())));for(const K of s.ALL_SYNC_RESOURCES)N.isResourceEnabled(K)&&this.registerSynchronizer(K)}onDidChangeResourceEnablement(v,T){T?this.registerSynchronizer(v):this.deRegisterSynchronizer(v)}registerSynchronizer(v){if(this._enabled.some(([$])=>$.resource===v))return;if(v==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(v==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||v==="workspaceState")return;if(v!=="profiles"&&this.profile.useDefaultFlags?.[v]){this.logService.debug(`Skipping syncing ${v} in ${this.profile.name} because it is already synced by default profile`);return}const T=new L.DisposableStore,N=T.add(this.createSynchronizer(v));T.add(N.onDidChangeStatus(()=>this.updateStatus())),T.add(N.onDidChangeConflicts(()=>this.updateConflicts())),T.add(N.onDidChangeLocal(()=>this._onDidChangeLocal.fire(v)));const M=this.getOrder(v);this._enabled.push([N,M,T])}deRegisterSynchronizer(v){const T=this._enabled.findIndex(([N])=>N.resource===v);if(T!==-1){const[[N,,M]]=this._enabled.splice(T,1);M.dispose(),this.updateStatus(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,$=>this.logService.error($))}}createSynchronizer(v){switch(v){case"settings":return this.instantiationService.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(t.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(a.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(v,T,N,M){if(M.isCancellationRequested)return[];const $=this.enabled;if(!$.length)return[];try{const j=[],Z=(0,s.createSyncHeaders)(N),G=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,Q=T?await this.getUserDataSyncConfiguration(G):{};for(const B of $){if(M.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(B.resource))return[];try{if(T){const K=await B.preview(G,Q,Z);if(K)for(const V of K.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await B.merge(V.previewResource)}else await B.sync(G,Z)}catch(K){const V=s.UserDataSyncError.toUserDataSyncError(K);if(E(V,N,this.userDataSyncStoreManagementService,this.telemetryService),w(K))throw V;this.logService.error(K),this.logService.error(`${B.resource}: ${(0,U.toErrorMessage)(K)}`),j.push([B.resource,V])}}return j}finally{this.updateStatus()}}async apply(v,T){const N=(0,s.createSyncHeaders)(v);for(const M of this.enabled){if(T.isCancellationRequested)return;try{await M.apply(!1,N)}catch($){const j=s.UserDataSyncError.toUserDataSyncError($);if(E(j,v,this.userDataSyncStoreManagementService,this.telemetryService),w($))throw j;this.logService.error($),this.logService.error(`${M.resource}: ${(0,U.toErrorMessage)($)}`)}}}async stop(){for(const v of this.enabled)try{v.status!=="idle"&&await v.stop()}catch(T){this.logService.error(T)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(T){this.logService.error(`${v.resource}: ${(0,U.toErrorMessage)(T)}`),this.logService.error(T)}}async getUserDataSyncConfiguration(v){if(!this.profile.isDefault)return{};const T=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(M=>M instanceof b.SettingsSynchroniser);if(N){const M=await N.getRemoteUserDataSyncConfiguration(v);return{...T,...M}}return T}setStatus(v){this._status!==v&&(this._status=v,this._onDidChangeStatus.fire(v))}updateStatus(){return this.updateConflicts(),this.enabled.some(v=>v.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(v=>v.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const v=this.enabled.filter(T=>T.status==="hasConflicts").filter(T=>T.conflicts.conflicts.length>0).map(T=>T.conflicts);(0,k.equals)(this._conflicts,v,(T,N)=>T.syncResource===N.syncResource&&(0,k.equals)(T.conflicts,N.conflicts,(M,$)=>(0,I.isEqual)(M.previewResource,$.previewResource)))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}getOrder(v){switch(v){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([X(2,s.IUserDataSyncEnablementService),X(3,g.IInstantiationService),X(4,S.IExtensionGalleryService),X(5,s.IUserDataSyncStoreManagementService),X(6,m.ITelemetryService),X(7,s.IUserDataSyncLogService),X(8,h.IUserDataProfilesService),X(9,C.IConfigurationService)],o);function w(d){if(d instanceof s.UserDataSyncError)switch(d.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function E(d,v,T,N){N.publicLog2("sync/error",{code:d.code,serverCode:d instanceof s.UserDataSyncStoreError?String(d.serverCode):void 0,url:d instanceof s.UserDataSyncStoreError?d.url:void 0,resource:d.resource,executionId:v,service:T.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,10,17,25]),function(te,e,k,O,A,U,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function L(S,c){return{...S,profile:(0,U.reviveProfile)(S.profile,c.profilesHome.scheme)}}function I(S){return{created:S.created,uri:A.URI.revive(S.uri)}}class f{constructor(c,g,y){this.service=c,this.userDataProfilesService=g,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(c,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(c,g,y){try{return await this._call(c,g,y)}catch(m){throw this.logService.error(m),m}}async _call(c,g,y){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(A.URI.revive(y[0]));case"accept":return this.service.accept(L(y[0],this.userDataProfilesService),A.URI.revive(y[1]),y[2],y[3]);case"replace":return this.service.replace(I(y[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(A.URI.revive(y[0]));case"extractActivityData":return this.service.extractActivityData(A.URI.revive(y[0]),A.URI.revive(y[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const m=g.substring(11),h=y[0],l=this.getManualSyncTask(h);switch(y=y.slice(1),m){case"merge":return l.merge();case"apply":return l.apply().then(()=>this.manualSyncTasks.delete(this.createKey(l.id)));case"stop":return l.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(l.id)))}}throw new Error("Invalid call")}getManualSyncTask(c){const g=this.manualSyncTasks.get(this.createKey(c));if(!g)throw new Error(`Manual sync taks not found: ${c}`);return g}async createManualSyncTask(){const c=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(c.id),c),c.id}createKey(c){return`manualSyncTask-${c}`}}e.UserDataSyncChannel=f;let D=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(c,g){super(),this.userDataProfilesService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,m,h){return c.call(y,m,h).then(null,l=>{throw _.UserDataSyncError.toUserDataSyncError(l)})},listen(y,m){return c.listen(y,m)}},this.channel.call("_getInitialData").then(([y,m,h])=>{this.updateStatus(y),this.updateConflicts(m),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(l=>this.updateStatus(l))),this._register(this.channel.listen("onDidChangeLastSyncTime")(l=>this.updateLastSyncTime(l)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(m=>({...m,error:_.UserDataSyncError.toUserDataSyncError(m.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.channel.call("createManualSyncTask"),g=this;return new C(c,{async call(m,h,l){return g.channel.call(`manualSync/${m}`,[c,...Array.isArray(h)?h:[h]],l)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(c,g,y,m){return this.channel.call("accept",[c,g,y,m])}resolveContent(c){return this.channel.call("resolveContent",[c])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(c){return this.channel.call("replace",[c])}saveRemoteActivityData(c){return this.channel.call("getRemoteActivityData",[c])}extractActivityData(c,g){return this.channel.call("extractActivityData",[c,g])}async updateStatus(c){this._status=c,this._onDidChangeStatus.fire(c)}async updateConflicts(c){this._conflicts=c.map(g=>({syncResource:g.syncResource,profile:(0,U.reviveProfile)(g.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:g.conflicts.map(y=>({...y,baseResource:A.URI.revive(y.baseResource),localResource:A.URI.revive(y.localResource),remoteResource:A.URI.revive(y.remoteResource),previewResource:A.URI.revive(y.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(c){this._lastSyncTime!==c&&(this._lastSyncTime=c,this._onDidChangeLastSyncTime.fire(c))}};e.UserDataSyncChannelClient=D,e.UserDataSyncChannelClient=D=ye([X(1,U.IUserDataProfilesService)],D);class C extends O.Disposable{constructor(c,g){super(),this.id=c,this.channel=g}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(oe[259],ae([0,1,5,26,8,3,2,141,6,21,12,10,32,19,14,11,24,57,43,20,25]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const b="configurationSync.store",t="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,r=1e3*60*5;let o=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(N){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,M,$){super(),this.productService=N,this.configurationService=M,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new U.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const j=this._register(new _.DisposableStore);this._register(U.Event.filter($.onDidChangeValue(-1,p.SYNC_SERVICE_URL_TYPE,j),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,j)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[b]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(N){if(N&&(N=I.isWeb&&N.web?{...N,...N.web}:N,(0,D.isString)(N.url)&&(0,D.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(M=>Array.isArray(N.authenticationProviders[M].scopes)))){const M=N,$=!!M.canSwitch,j=M.url===M.insidersUrl?"insiders":"stable",Z=($?this.userDataSyncStoreType:void 0)||j,G=Z==="insiders"?M.insidersUrl:Z==="stable"?M.stableUrl:M.url;return{url:C.URI.parse(G),type:Z,defaultType:j,defaultUrl:C.URI.parse(M.url),stableUrl:C.URI.parse(M.stableUrl),insidersUrl:C.URI.parse(M.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Q,B)=>(Q.push({id:B,scopes:M.authenticationProviders[B].scopes}),Q),[])}}}};e.AbstractUserDataSyncStoreManagementService=o,e.AbstractUserDataSyncStoreManagementService=o=ye([X(0,m.IProductService),X(1,c.IConfigurationService),X(2,u.IStorageService)],o);let w=class extends o{constructor(N,M,$){super(N,M,$);const j=this.storageService.get(t,-1);j&&(this.previousConfigurationSyncStore=JSON.parse(j));const Z=this.productService[b];Z?this.storageService.store(t,JSON.stringify(Z),-1,1):this.storageService.remove(t,-1)}async switch(N){N!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=N,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=w,e.UserDataSyncStoreManagementService=w=ye([X(0,m.IProductService),X(1,c.IConfigurationService),X(2,u.IStorageService)],w);let E=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(N,M,$,j,Z,G,Q){super(),this.requestService=$,this.logService=j,this.storageService=Q,this._onTokenFailed=this._register(new U.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new U.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new U.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(N),this.commonHeadersPromise=(0,l.getServiceMachineId)(Z,G,Q).then(B=>{const K={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(K["X-Client-Commit"]=M.commit),K}),this.session=new v(i,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(N,M){this.authToken={token:N,type:M}}updateUserDataSyncStoreUrl(N){this.userDataSyncStoreUrl=N?(0,f.joinPath)(N,"v1"):void 0}initDonotMakeRequestsUntil(){const N=this.storageService.getNumber(a,-1);N&&Date.now()<N&&this.setDonotMakeRequestsUntil(new Date(N))}setDonotMakeRequestsUntil(N){this._donotMakeRequestsUntil?.getTime()!==N?.getTime()&&(this._donotMakeRequestsUntil=N,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(a,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(M=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(a,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,f.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]="application/json";const $=await this.request(M,{type:"GET",headers:N},[],O.CancellationToken.None);return(await(0,h.asJson)($))?.map(({id:j})=>j)||[]}async createCollection(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,f.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]=L.Mimes.text;const $=await this.request(M,{type:"POST",headers:N},[],O.CancellationToken.None),j=await(0,h.asTextOrError)($);if(!j)throw new p.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);return j}async deleteCollection(N,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=N?(0,f.joinPath)(this.userDataSyncStoreUrl,"collection",N).toString():(0,f.joinPath)(this.userDataSyncStoreUrl,"collection").toString();M={...M},await this.request($,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async getAllResourceRefs(N,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,M,N),j={},Z=await this.request($.toString(),{type:"GET",headers:j},[],O.CancellationToken.None);return(await(0,h.asJson)(Z)||[]).map(({url:Q,created:B})=>({ref:(0,f.relativePath)($,$.with({path:Q})),created:B*1e3}))}async resolveResourceContent(N,M,$,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Z=(0,f.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,N),M).toString();j={...j},j["Cache-Control"]="no-cache";const G=await this.request(Z,{type:"GET",headers:j},[],O.CancellationToken.None);return await(0,h.asTextOrError)(G)}async deleteResource(N,M,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=M!==null?(0,f.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,N),M).toString():this.getResourceUrl(this.userDataSyncStoreUrl,$,N).toString(),Z={};await this.request(j,{type:"DELETE",headers:Z},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,f.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":L.Mimes.text};await this.request(N,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async readResource(N,M,$,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Z=(0,f.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,$,N),"latest").toString();j={...j},j["Cache-Control"]="no-cache",M&&(j["If-None-Match"]=M.ref);const G=await this.request(Z,{type:"GET",headers:j},[304],O.CancellationToken.None);let Q=null;if(G.res.statusCode===304&&(Q=M),Q===null){const B=G.res.headers.etag;if(!B)throw new p.UserDataSyncStoreError("Server did not return the ref",Z,"NoRef",G.res.statusCode,G.res.headers[p.HEADER_OPERATION_ID]);const K=await(0,h.asTextOrError)(G);if(!K&&G.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",Z,"EmptyResponse",G.res.statusCode,G.res.headers[p.HEADER_OPERATION_ID]);Q={ref:B,content:K}}return Q}async writeResource(N,M,$,j,Z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const G=this.getResourceUrl(this.userDataSyncStoreUrl,j,N).toString();Z={...Z},Z["Content-Type"]=L.Mimes.text,$&&(Z["If-Match"]=$);const Q=await this.request(G,{type:"POST",data:M,headers:Z},[],O.CancellationToken.None),B=Q.res.headers.etag;if(!B)throw new p.UserDataSyncStoreError("Server did not return the ref",G,"NoRef",Q.res.statusCode,Q.res.headers[p.HEADER_OPERATION_ID]);return B}async manifest(N,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,f.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",N&&(M["If-None-Match"]=N.ref);const j=await this.request($,{type:"GET",headers:M},[304],O.CancellationToken.None);let Z=null;if(j.res.statusCode===304&&(Z=N),!Z){const Q=j.res.headers.etag;if(!Q)throw new p.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",j.res.statusCode,j.res.headers[p.HEADER_OPERATION_ID]);const B=await(0,h.asTextOrError)(j);if(!B&&j.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",$,"EmptyResponse",j.res.statusCode,j.res.headers[p.HEADER_OPERATION_ID]);B&&(Z={...JSON.parse(B),ref:Q})}const G=this.storageService.get(n,-1);return G&&Z&&G!==Z.session&&this.clearSession(),Z===null&&G&&this.clearSession(),Z&&this.storageService.store(n,Z.session,-1,1),Z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,f.joinPath)(this.userDataSyncStoreUrl,"download").toString(),M={},$=await this.request(N,{type:"GET",headers:M},[],O.CancellationToken.None);if(!(0,h.isSuccess)($))throw new p.UserDataSyncStoreError("Server returned "+$.res.statusCode,N,"EmptyResponse",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);if((0,h.hasNoContent)($))throw new p.UserDataSyncStoreError("Empty response",N,"EmptyResponse",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);return $.stream}getResourceUrl(N,M,$){return M?(0,f.joinPath)(N,"collection",M,"resource",$):(0,f.joinPath)(N,"resource",$)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(s,-1)}async request(N,M,$,j){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const Z=await this.commonHeadersPromise;M.headers={...M.headers||{},...Z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:N,type:M.type,headers:{...M.headers,authorization:void 0}});let G;try{G=await this.session.request(N,M,j)}catch(z){if(!(z instanceof p.UserDataSyncStoreError)){let x="RequestFailed";const ee=(0,A.getErrorMessage)(z).toLowerCase();ee.includes("xhr timeout")?x="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?x="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":ee.includes("headers must be an object")?x="RequestHeadersNotObject":(0,A.isCancellationError)(z)&&(x="RequestCanceled"),z=new p.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,x,void 0,void 0)}throw this.logService.info("Request failed",N),z}const Q=G.res.headers[p.HEADER_OPERATION_ID],B={url:N,status:G.res.statusCode,"execution-id":M.headers[p.HEADER_EXECUTION_ID],"operation-id":Q},K=(0,h.isSuccess)(G)||G.res.statusCode&&$.includes(G.res.statusCode);let V="";if(K?this.logService.trace("Request succeeded",B):(V=await(0,h.asText)(G)||"",this.logService.info("Request failed",B,V)),G.res.statusCode===401||G.res.statusCode===403){if(this.authToken=void 0,G.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",G.res.statusCode,Q);if(G.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",G.res.statusCode,Q)}if(this._onTokenSucceed.fire(),G.res.statusCode===404)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",G.res.statusCode,Q);if(G.res.statusCode===405)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested endpoint is not found (405). ${V}`,N,"MethodNotFound",G.res.statusCode,Q);if(G.res.statusCode===409)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",G.res.statusCode,Q);if(G.res.statusCode===410)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",G.res.statusCode,Q);if(G.res.statusCode===412)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",G.res.statusCode,Q);if(G.res.statusCode===413)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",G.res.statusCode,Q);if(G.res.statusCode===426)throw new p.UserDataSyncStoreError(`${M.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",G.res.statusCode,Q);if(G.res.statusCode===429){const z=G.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",G.res.statusCode,Q)):new p.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",G.res.statusCode,Q)}if(!K)throw new p.UserDataSyncStoreError("Server returned "+G.res.statusCode,N,"Unknown",G.res.statusCode,Q);return G}addSessionHeaders(N){let M=this.storageService.get(s,-1);M===void 0&&(M=(0,S.generateUuid)(),this.storageService.store(s,M,-1,1)),N["X-Machine-Session-Id"]=M;const $=this.storageService.get(n,-1);$!==void 0&&(N["X-User-Session-Id"]=$)}};e.UserDataSyncStoreClient=E,e.UserDataSyncStoreClient=E=ye([X(1,m.IProductService),X(2,h.IRequestService),X(3,p.IUserDataSyncLogService),X(4,g.IEnvironmentService),X(5,y.IFileService),X(6,u.IStorageService)],E);let d=class extends E{constructor(N,M,$,j,Z,G,Q){super(N.userDataSyncStore?.url,M,$,j,Z,G,Q),this._register(N.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(N.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=d,e.UserDataSyncStoreService=d=ye([X(0,p.IUserDataSyncStoreManagementService),X(1,m.IProductService),X(2,h.IRequestService),X(3,p.IUserDataSyncLogService),X(4,g.IEnvironmentService),X(5,y.IFileService),X(6,u.IStorageService)],d);class v{constructor(N,M,$,j){this.limit=N,this.interval=M,this.requestService=$,this.logService=j,this.requests=[],this.startTime=void 0}request(N,M,$){if(this.isExpired()&&this.reset(),M.url=N,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(N),this.requestService.request(M,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=v}),define(oe[260],ae([0,1,3,55,24,20,22,255,25,78,81]),function(te,e,k,O,A,U,_,L,I,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends L.UserDataAutoSyncService{constructor(c,g,y,m,h,l,u,p,b,t,a){super(c,g,y,m,h,u,p,b,t,a),this._register(k.Event.debounce(k.Event.any(k.Event.map(l.onDidFocusWindow,()=>"windowFocus"),k.Event.map(l.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=C,e.UserDataAutoSyncService=C=ye([X(0,A.IProductService),X(1,I.IUserDataSyncStoreManagementService),X(2,I.IUserDataSyncStoreService),X(3,I.IUserDataSyncEnablementService),X(4,I.IUserDataSyncService),X(5,O.INativeHostService),X(6,I.IUserDataSyncLogService),X(7,f.IUserDataSyncAccountService),X(8,_.ITelemetryService),X(9,D.IUserDataSyncMachinesService),X(10,U.IStorageService)],C)}),define(oe[261],ae([0,1,69,23,6,21]),function(te,e,k,O,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(f){function D(){let C=f.scheme===O.Schemas.file?(0,U.originalFSPath)(f):f.toString();return A.isLinux||(C=C.toLowerCase()),(0,k.createHash)("md5").update(C).digest("hex")}return{id:D(),configPath:f}}e.getWorkspaceIdentifier=_;function L(f,D){function C(){if(f.scheme!==O.Schemas.file)return(0,k.createHash)("md5").update(f.toString()).digest("hex");if(!D)return;let c;return A.isLinux?c=D.ino:A.isMacintosh?c=D.birthtime.getTime():A.isWindows&&(typeof D.birthtimeMs=="number"?c=Math.floor(D.birthtimeMs):c=D.birthtime.getTime()),(0,k.createHash)("md5").update(f.fsPath).update(c?String(c):"").digest("hex")}const S=C();if(typeof S=="string")return{id:S,uri:f}}e.getSingleFolderWorkspaceIdentifier=L;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[262],ae([0,1,5,8,2,16,31,14,7,75,113,261,55,71,23]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let y=class extends A.Disposable{constructor(h,l,u,p){super(),this.environmentService=h,this.logService=l,this.nativeHostService=u,this.mainProcessService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.environmentService.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,l=await _.Promises.readdir(h),u=new f.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(l.map(async p=>{const b=(0,U.join)(h,p);p.length===C.NON_EMPTY_WORKSPACE_ID_LENGTH||p===D.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===p)||await u.isUsed(b)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await _.Promises.rm(b))}))}catch(h){(0,O.onUnexpectedError)(h)}}};e.UnusedWorkspaceStorageDataCleaner=y,e.UnusedWorkspaceStorageDataCleaner=y=ye([X(0,L.INativeEnvironmentService),X(1,I.ILogService),X(2,S.INativeHostService),X(3,c.IMainProcessService)],y)}),define(oe[82],ae([0,1,52,5,16,12,31,148,273,274]),function(te,e,k,O,A,U,_,L,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const D=new RegExp(e.CorruptZipMessage);class C extends Error{constructor(a,n){let s=n.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=n}}e.ExtractError=C;function S(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,s)=>n+s,a&61440)}function c(t){if(t instanceof C)return t;let a;return D.test(t.message)&&(a="CorruptZip"),new C(a,t)}function g(t,a,n,s,i,r){const o=A.dirname(a),w=A.join(s,o);if(!w.startsWith(s))return Promise.reject(new Error(L.localize(0,null,a)));const E=A.join(s,a);let d;return r.onCancellationRequested(()=>{d?.destroy()}),Promise.resolve(_.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((v,T)=>{if(!r.isCancellationRequested)try{d=(0,k.createWriteStream)(E,{mode:n}),d.once("close",()=>v()),d.once("error",T),t.once("error",T),t.pipe(d)}catch(N){T(N)}}))}function y(t,a,n,s){let i=(0,O.createCancelablePromise)(()=>Promise.resolve()),r=0;const o=s.onCancellationRequested(()=>{i.cancel(),t.close()});return new Promise((w,E)=>{const d=new O.Sequencer,v=T=>{T.isCancellationRequested||(r++,t.readEntry())};t.once("error",E),t.once("close",()=>i.then(()=>{s.isCancellationRequested||t.entryCount===r?w():E(new C("Incomplete",new Error(L.localize(1,null,r,t.entryCount))))},E)),t.readEntry(),t.on("entry",T=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(T.fileName)){v(s);return}const N=T.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(N)){const j=A.join(a,N);i=(0,O.createCancelablePromise)(Z=>_.Promises.mkdir(j,{recursive:!0}).then(()=>v(Z)).then(void 0,E));return}const M=h(t,T),$=S(T);i=(0,O.createCancelablePromise)(j=>d.queue(()=>M.then(Z=>g(Z,N,$,a,n,j).then(()=>v(j)))).then(null,E))})}).finally(()=>o.dispose())}function m(t,a=!1){return new Promise((n,s)=>{(0,I.open)(t,a?{lazyEntries:!0}:void 0,(i,r)=>{i?s(c(i)):n((0,U.assertIsDefined)(r))})})}function h(t,a){return new Promise((n,s)=>{t.openReadStream(a,(i,r)=>{i?s(c(i)):n((0,U.assertIsDefined)(r))})})}function l(t,a){return new Promise((n,s)=>{const i=new f.ZipFile;a.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const r=(0,k.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(t))})}e.zip=l;function u(t,a,n={},s){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=m(t,!0);return n.overwrite&&(r=r.then(o=>_.Promises.rm(a).then(()=>o))),r.then(o=>y(o,a,{sourcePathRegex:i},s))}e.extract=u;function p(t,a){return m(t).then(n=>new Promise((s,i)=>{n.on("entry",r=>{r.fileName===a&&h(n,r).then(o=>s(o),o=>i(o))}),n.once("close",()=>i(new Error(L.localize(2,null,a))))}))}function b(t,a){return p(t,a).then(n=>new Promise((s,i)=>{const r=[];n.once("error",i),n.on("data",o=>r.push(o)),n.on("end",()=>s(Buffer.concat(r)))}))}e.buffer=b}),define(oe[263],ae([0,1,5,8,2,23,21,53,12,32,31,82,19,14,29,33,97,11,7]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class extends A.Disposable{static{u=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(t,a,n,s,i,r){super(),this.fileService=a,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=i,this.logService=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,a,n){await this.cleanUpPromise;const s=(0,_.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,s,r=>this.extensionGalleryService.download(t,r,a))}catch(r){throw new g.ExtensionManagementError(r.message,g.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.shouldVerifySignature(t)){const r=await this.downloadSignatureArchive(t);try{i=await this.extensionSignatureVerificationService.verify(s.fsPath,r.fsPath,this.logService.getLevel()===l.LogLevel.Trace)}catch(o){const w=o;if(i=w.code,w.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${w.output}`),i===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.ExtensionManagementError(C.CorruptZipMessage,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.logService.error(o)}}}return i===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:s,verificationStatus:i}}shouldVerifySignature(t){if(!t.isSigned)return!1;const a=this.configurationService.getValue("extensions.verifySignature");return(0,I.isBoolean)(a)?a:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const a=(0,_.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${u.SignatureArchiveExtension}`);return await this.downloadFile(t,a,n=>this.extensionGalleryService.downloadSignatureArchive(t,n)),a}async downloadFile(t,a,n){if(await this.fileService.exists(a))return;if(a.scheme!==U.Schemas.file){await n(a);return}const s=(0,_.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(s)||await n(s);try{await D.Promises.rename(s.fsPath,a.fsPath,2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],n=[],s=[];for(const o of t.children)if(o.name.endsWith(u.SignatureArchiveExtension))s.push(o.resource);else{const w=y.ExtensionKey.parse(o.name);w&&n.push([w,o])}const i=(0,y.groupByExtension)(n,([o])=>o),r=[];for(const o of i)o.sort((w,E)=>L.rcompare(w[0].version,E[0].version)),a.push(...o.slice(1).map(w=>w[1].resource)),r.push(o[0][1]);r.sort((o,w)=>o.mtime-w.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),a.push(...s),await k.Promises.settled(a.map(o=>(this.logService.trace("Deleting from cache",o.path),this.fileService.del(o))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?y.ExtensionKey.create(t).toString().toLowerCase():(0,f.generateUuid)()}};e.ExtensionsDownloader=p,e.ExtensionsDownloader=p=u=ye([X(0,c.INativeEnvironmentService),X(1,h.IFileService),X(2,g.IExtensionGalleryService),X(3,S.IConfigurationService),X(4,m.IExtensionSignatureVerificationService),X(5,l.ILogService)],p)}),define(oe[264],ae([0,1,82,157]),function(te,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(U){return(0,k.buffer)(U,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=A}),define(oe[122],ae([0,1,5,15,26,38,8,3,51,2,34,23,16,21,53,12,10,32,31,82,156,96,14,243,29,33,50,79,263,244,264,212,223,67,11,4,7,24,22,28,17]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t,a,n,s,i,r,o,w,E,d,v,T,N,M,$,j,Z,G,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(n.IExtensionManagementService);const B=".vsctmp";let K=class extends a.AbstractExtensionManagementService{constructor(J,q,P,R,W,F,H,Y,se,le,he,ue){super(J,q,he,P,le,ue),this.extensionsScannerService=W,this.extensionsProfileScannerService=F,this.downloadService=H,this.fileService=se,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new D.ResourceSet;const me=this._register(Y.createInstance(w.ExtensionsLifecycle));this.extensionsScanner=this._register(Y.createInstance(V,pe=>me.postUninstall(pe))),this.manifestCache=this._register(new d.ExtensionsManifestCache(ue,se,he,this,this.logService)),this.extensionsDownloader=this._register(Y.createInstance(o.ExtensionsDownloader));const fe=this._register(new v.ExtensionsWatcher(this,this.extensionsScannerService,ue,F,he,se,P));this._register(fe.onDidChangeExtensionsByAnotherSource(pe=>this.onDidChangeExtensionsFromAnotherSource(pe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(J){this.logService.trace("ExtensionManagementService#zip",J.identifier.id);const q=await this.collectFiles(J),P=await(0,u.zip)((0,c.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,q);return m.URI.file(P)}async unzip(J){return this.logService.trace("ExtensionManagementService#unzip",J.toString()),(await this.install(J)).identifier}async getManifest(J){const{location:q,cleanup:P}=await this.downloadVsix(J),R=S.resolve(q.fsPath);try{return await(0,E.getManifest)(R)}finally{await P()}}getInstalled(J,q=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(J??null,q)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(J){return this.extensionsScanner.scanUserExtensionAtLocation(J)}async install(J,q={}){this.logService.trace("ExtensionManagementService#install",J.toString());const{location:P,cleanup:R}=await this.downloadVsix(J);try{const W=await(0,E.getManifest)(S.resolve(P.fsPath)),F=(0,s.getGalleryExtensionId)(W.publisher,W.name);if(W.engines&&W.engines.vscode&&!(0,T.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,F,this.productService.version));const Y=(await this.installExtensions([{manifest:W,extension:P,options:q}])).find(({identifier:se})=>(0,s.areSameExtensions)(se,{id:F}));if(Y?.local)return Y.local;throw Y?.error?Y.error:(0,a.toExtensionManagementError)(new Error(`Unknown error while installing extension ${F}`))}finally{await R()}}async installFromLocation(J,q){this.logService.trace("ExtensionManagementService#installFromLocation",J.toString());const P=await this.extensionsScanner.scanUserExtensionAtLocation(J);if(!P)throw new Error(`Cannot find a valid extension from the location ${J.toString()}`);return await this.addExtensionsToProfile([[P,void 0]],q),this.logService.info("Successfully installed extension",P.identifier.id,q.toString()),P}async installExtensionsFromProfile(J,q,P){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",J,q.toString(),P.toString());const R=(await this.extensionsScanner.scanExtensions(1,q)).filter(W=>J.some(F=>(0,s.areSameExtensions)(F,W.identifier)));if(R.length){const W=await Promise.all(R.map(F=>this.extensionsScanner.scanMetadata(F,q)));await this.addExtensionsToProfile(R.map((F,H)=>[F,W[H]]),P),this.logService.info("Successfully installed extensions",R.map(F=>F.identifier.id),P.toString())}return R}async updateMetadata(J,q,P=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",J.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.pinned=q.pinned||void 0,J=await this.extensionsScanner.updateMetadata(J,q,P),this.manifestCache.invalidate(P),this._onDidUpdateExtensionMetadata.fire(J),J}async reinstallFromGallery(J){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",J.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const q=await this.getTargetPlatform(),[P]=await this.galleryService.getExtensions([{...J.identifier,preRelease:J.preRelease}],{targetPlatform:q,compatible:!0},A.CancellationToken.None);if(!P)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(J);try{await this.extensionsScanner.removeUninstalledExtension(J)}catch(R){throw new Error(p.localize(3,null,(0,U.toErrorMessage)(R)))}return this.installFromGallery(P)}copyExtension(J,q,P,R){return this.extensionsScanner.copyExtension(J,q,P,R)}copyExtensions(J,q){return this.extensionsScanner.copyExtensions(J,q)}markAsUninstalled(...J){return this.extensionsScanner.setUninstalled(...J)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(J){this.logService.error(J)}}async download(J,q,P){const{location:R}=await this.extensionsDownloader.download(J,q,!P);return R}async downloadVsix(J){if(J.scheme===C.Schemas.file)return{location:J,async cleanup(){}};this.logService.trace("Downloading extension from",J.toString());const q=(0,c.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(J,q),this.logService.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.fileService.del(q)}catch(R){this.logService.error(R)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(J,q,P){if(m.URI.isUri(q))return new ee(J,q,P,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const R=s.ExtensionKey.create(q).toString();let W=this.installGalleryExtensionsTasks.get(R);return W||(this.installGalleryExtensionsTasks.set(R,W=new x(J,q,P,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),W.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(R))),W}createUninstallExtensionTask(J,q){return new ne(J,q.profileLocation,this.extensionsProfileScannerService)}async collectFiles(J){const q=async R=>{let W=await l.Promises.readdir(R);W=W.map(Y=>S.join(R,Y));const F=await Promise.all(W.map(Y=>l.Promises.stat(Y)));let H=Promise.resolve([]);return F.forEach((Y,se)=>{const le=W[se];Y.isFile()&&(H=H.then(he=>[...he,le])),Y.isDirectory()&&(H=H.then(he=>q(le).then(ue=>[...he,...ue])))}),H};return(await q(J.location.fsPath)).map(R=>({path:`extension/${S.relative(J.location.fsPath,R)}`,localPath:R}))}async onDidChangeExtensionsFromAnotherSource({added:J,removed:q}){if(q){const P=J&&this.uriIdentityService.extUri.isEqual(q.profileLocation,J.profileLocation)?q.extensions.filter(R=>J.extensions.every(W=>!(0,s.areSameExtensions)(W,R))):q.extensions;for(const R of P)this.logService.info("Extensions removed from another source",R.id,q.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:R,profileLocation:q.profileLocation})}if(J){const R=(await this.extensionsScanner.scanExtensions(1,J.profileLocation)).filter(W=>J.extensions.some(F=>(0,s.areSameExtensions)(F,W.identifier)));this._onDidInstallExtensions.fire(R.map(W=>(this.logService.info("Extensions added from another source",W.identifier.id,J.profileLocation.toString()),{identifier:W.identifier,local:W,profileLocation:J.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(q=>this.knownDirectories.add(q)));const J=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const q of J.children??[])q.isDirectory&&this.knownDirectories.add(q.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(q=>this.onDidFilesChange(q)))}async onDidFilesChange(J){if(!J.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const q=[];for(const P of J.rawAdded){if(this.knownDirectories.has(P)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(P),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(P,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(P).startsWith(".")||!(await this.fileService.stat(P)).isDirectory)continue;const R=await this.extensionsScanner.scanUserExtensionAtLocation(P);R&&R.installedTimestamp===void 0&&(this.knownDirectories.add(P),q.push(R))}q.length&&(await this.addExtensionsToProfile(q.map(P=>[P,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",q.map(P=>P.identifier.id)))}async addExtensionsToProfile(J,q){const P=J.map(R=>R[0]);await this.setInstalled(P),await this.extensionsProfileScannerService.addExtensionsToProfile(J,q),this._onDidInstallExtensions.fire(P.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:q})))}async setInstalled(J){const q=await this.extensionsScanner.getUninstalledExtensions();for(const P of J){const R=s.ExtensionKey.create(P);q[R.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",R.id),await this.extensionsScanner.setInstalled(R),this.logService.info("Removed the extension from uninstalled list:",R.id))}}};e.ExtensionManagementService=K,e.ExtensionManagementService=K=ye([X(0,n.IExtensionGalleryService),X(1,Z.ITelemetryService),X(2,$.ILogService),X(3,t.INativeEnvironmentService),X(4,r.IExtensionsScannerService),X(5,i.IExtensionsProfileScannerService),X(6,b.IDownloadService),X(7,M.IInstantiationService),X(8,N.IFileService),X(9,j.IProductService),X(10,G.IUriIdentityService),X(11,Q.IUserDataProfilesService)],K);let V=class extends f.Disposable{constructor(J,q,P,R,W,F){super(),this.beforeRemovingExtension=J,this.fileService=q,this.extensionsScannerService=P,this.extensionsProfileScannerService=R,this.uriIdentityService=W,this.logService=F,this._onExtract=this._register(new L.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,c.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(J,q){const P={includeInvalid:!0,profileLocation:q};let R=[];return J===null||J===0?R.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},P,!1)):J===1&&R.push(...await this.extensionsScannerService.scanUserExtensions(P)),R=J!==null?R.filter(W=>W.type===J):R,Promise.all(R.map(W=>this.toLocalExtension(W)))}async scanAllUserExtensions(J){const q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!J,includeInvalid:!0});return Promise.all(q.map(P=>this.toLocalExtension(P)))}async scanUserExtensionAtLocation(J){try{const q=await this.extensionsScannerService.scanExistingExtension(J,1,{includeInvalid:!0});if(q)return await this.toLocalExtension(q)}catch(q){this.logService.error(q)}return null}async extractUserExtension(J,q,P,R,W){const F=J.toString(),H=m.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`)),Y=m.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,F));let se=await this.fileService.exists(Y);if(se&&R){try{await this.deleteExtensionFromLocation(J.id,Y,"removeExisting")}catch{throw new n.ExtensionManagementError(p.localize(4,null,Y.fsPath,J.id),n.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.logService.trace(`Started extracting the extension from ${q} to ${Y.fsPath}`),await(0,u.extract)(q,H.fsPath,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${Y}:`,J.id)}catch(le){let he=n.ExtensionManagementErrorCode.Extract;throw le instanceof u.ExtractError&&(le.type==="CorruptZip"?he=n.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(he=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(le.message,he)}await this.extensionsScannerService.updateMetadata(H,P);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${Y.fsPath}`),await this.rename(H.fsPath,Y.fsPath),this.logService.info("Renamed to",Y.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",J.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(le)}. Deleted from extracted location`,H),le}this._onExtract.fire(Y)}catch(le){try{await this.fileService.del(H,{recursive:!0})}catch{}throw le}return this.scanLocalExtension(Y,1)}async scanMetadata(J,q){return q?(await this.getScannedExtension(J,q))?.metadata:this.extensionsScannerService.scanMetadata(J.location)}async getScannedExtension(J,q){return(await this.extensionsProfileScannerService.scanProfileExtensions(q)).find(R=>(0,s.areSameExtensions)(R.identifier,J.identifier))}async updateMetadata(J,q,P){return P?await this.extensionsProfileScannerService.updateMetadata([[J,q]],P):await this.extensionsScannerService.updateMetadata(J.location,q),this.scanLocalExtension(J.location,J.type,P)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...J){const q=J.map(P=>s.ExtensionKey.create(P));await this.withUninstalledExtensions(P=>q.forEach(R=>{P[R.toString()]=!0,this.logService.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(J){await this.withUninstalledExtensions(q=>delete q[J.toString()])}async removeExtension(J,q){if(this.uriIdentityService.extUri.isEqualOrParent(J.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(J.identifier.id,J.location,q)}async removeUninstalledExtension(J){await this.removeExtension(J,"uninstalled"),await this.withUninstalledExtensions(q=>delete q[s.ExtensionKey.create(J).toString()])}async copyExtension(J,q,P,R){const W=await this.getScannedExtension(J,q),F=await this.getScannedExtension(J,P);return R={...W?.metadata,...R},F?await this.extensionsProfileScannerService.updateMetadata([[J,{...F.metadata,...R}]],P):await this.extensionsProfileScannerService.addExtensionsToProfile([[J,R]],P),this.scanLocalExtension(J.location,J.type,P)}async copyExtensions(J,q){const P=await this.scanExtensions(1,J),R=await Promise.all(P.filter(W=>!W.isApplicationScoped).map(async W=>[W,await this.scanMetadata(W,J)]));await this.extensionsProfileScannerService.addExtensionsToProfile(R,q)}async deleteExtensionFromLocation(J,q,P){this.logService.trace(`Deleting ${P} extension from disk`,J,q.fsPath);const R=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(q),`${this.uriIdentityService.extUri.basename(q)}.${(0,I.hash)((0,h.generateUuid)()).toString(16)}${B}`);await this.rename(q.fsPath,R.fsPath),await this.fileService.del(R,{recursive:!0}),this.logService.info(`Deleted ${P} extension from disk`,J,q.fsPath)}async withUninstalledExtensions(J){return this.uninstalledFileLimiter.queue(async()=>{let q;try{q=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(R){if((0,N.toFileOperationResult)(R)!==1)throw R}let P={};if(q)try{P=JSON.parse(q)}catch{}return J&&(J(P),Object.keys(P).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(P))):await this.fileService.del(this.uninstalledResource)),P})}async rename(J,q){try{await l.Promises.rename(J,q,2*60*1e3)}catch(P){throw new n.ExtensionManagementError(P.message||p.localize(5,null,J,q),P.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(J,q,P){if(P){const W=(await this.extensionsScannerService.scanUserExtensions({profileLocation:P})).find(F=>this.uriIdentityService.extUri.isEqual(F.location,J));if(W)return this.toLocalExtension(W)}else{const R=await this.extensionsScannerService.scanExistingExtension(J,q,{includeInvalid:!0});if(R)return this.toLocalExtension(R)}throw new Error(p.localize(6,null,J.path))}async toLocalExtension(J){const q=await this.fileService.resolve(J.location);let P,R;return q.children&&(P=q.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,R=q.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource),{identifier:J.identifier,type:J.type,isBuiltin:J.isBuiltin||!!J.metadata?.isBuiltin,location:J.location,manifest:J.manifest,targetPlatform:J.targetPlatform,validations:J.validations,isValid:J.isValid,readmeUrl:P,changelogUrl:R,publisherDisplayName:J.metadata?.publisherDisplayName||null,publisherId:J.metadata?.publisherId||null,isApplicationScoped:!!J.metadata?.isApplicationScoped,isMachineScoped:!!J.metadata?.isMachineScoped,isPreReleaseVersion:!!J.metadata?.isPreReleaseVersion,preRelease:!!J.metadata?.preRelease,installedTimestamp:J.metadata?.installedTimestamp,updated:!!J.metadata?.updated,pinned:!!J.metadata?.pinned}}async removeUninstalledExtensions(){const J=await this.getUninstalledExtensions();if(Object.keys(J).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(J));const q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const W of q)J[s.ExtensionKey.create(W).toString()]||P.add(W.identifier.id.toLowerCase());try{const W=(0,s.groupByExtension)(q,F=>F.identifier);await k.Promises.settled(W.map(async F=>{const H=F.sort((Y,se)=>g.rcompare(Y.manifest.version,se.manifest.version))[0];P.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(W){this.logService.error(W)}const R=q.filter(W=>W.metadata&&J[s.ExtensionKey.create(W).toString()]);await Promise.allSettled(R.map(W=>this.removeUninstalledExtension(W)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let J;try{J=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(q){(0,N.toFileOperationResult)(q)!==1&&this.logService.error(q);return}if(J?.children)try{await Promise.allSettled(J.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(B))){this.logService.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.fileService.del(q.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(P){(0,N.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=ye([X(1,N.IFileService),X(2,r.IExtensionsScannerService),X(3,i.IExtensionsProfileScannerService),X(4,G.IUriIdentityService),X(5,$.ILogService)],V);class z extends a.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(J,q,P,R,W,F,H,Y,se){super(),this.identifier=J,this.source=q,this.options=P,this.extensionsScanner=R,this.uriIdentityService=W,this.userDataProfilesService=F,this.extensionsScannerService=H,this.extensionsProfileScannerService=Y,this.logService=se,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(J){const[q,P]=await this.install(J);return this._profileLocation=q.isBuiltin||q.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[q,P]],this._profileLocation),q}async extractExtension({zipPath:J,key:q,metadata:P},R,W){let F=await this.unsetIfUninstalled(q);return F||(this.logService.trace("Extracting extension...",q.id),F=await this.extensionsScanner.extractUserExtension(q,J,P,R,W),this.logService.info("Extracting extension completed.",q.id)),F}async unsetIfUninstalled(J){return await this.isUninstalled(J)?(this.logService.trace("Removing the extension from uninstalled list:",J.id),await this.extensionsScanner.setInstalled(J),this.logService.info("Removed the extension from uninstalled list:",J.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(R=>s.ExtensionKey.create(R).equals(J))):void 0}async isUninstalled(J){return!!(await this.extensionsScanner.getUninstalledExtensions())[J.toString()]}}class x extends z{constructor(J,q,P,R,W,F,H,Y,se,le){super(q.identifier,q,P,W,F,H,Y,se,le),this.gallery=q,this.extensionsDownloader=R}async install(J){const P=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,s.areSameExtensions)(H.identifier,this.gallery.identifier));P&&(this._operation=3);const R={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,y.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(P,R),R];const{location:W,verificationStatus:F}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=F,this.validateManifest(W.fsPath),[await this.extractExtension({zipPath:W.fsPath,key:s.ExtensionKey.create(this.gallery),metadata:R},!1,J),R]}catch(H){try{await this.extensionsDownloader.delete(W)}catch(Y){this.logService.warn("Error while deleting the downloaded file",W.toString(),(0,_.getErrorMessage)(Y))}throw H}}async validateManifest(J){try{await(0,E.getManifest)(J)}catch(q){throw new n.ExtensionManagementError((0,a.joinErrors)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=x;class ee extends z{constructor(J,q,P,R,W,F,H,Y,se,le){super({id:(0,s.getGalleryExtensionId)(J.publisher,J.name)},q,P,W,F,H,Y,se,le),this.manifest=J,this.location=q,this.galleryService=R}async doRun(J){const q=await super.doRun(J);return this.updateMetadata(q,J),q}async install(J){const q=new s.ExtensionKey(this.identifier,this.manifest.version),R=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,s.areSameExtensions)(this.identifier,H.identifier)),W={isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(R)if(this._operation=3,q.equals(new s.ExtensionKey(R.identifier,R.manifest.version)))try{await this.extensionsScanner.removeExtension(R,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&g.gt(R.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(R);else{const H=await this.unsetIfUninstalled(q);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:S.resolve(this.location.fsPath),key:q,metadata:W},!0,J),W]}async updateMetadata(J,q){try{let[P]=await this.galleryService.getExtensions([{id:J.identifier.id,version:J.manifest.version}],q);if(P||([P]=await this.galleryService.getExtensions([{id:J.identifier.id}],q)),P){const R={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(J,R,this.options.profileLocation)}}catch{}}}class ne extends a.AbstractExtensionTask{constructor(J,q,P){super(),this.extension=J,this.profileLocation=q,this.extensionsProfileScannerService=P}async doRun(J){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[265],ae([0,1,2,29,80,222,122,7,20]),function(te,e,k,O,A,U,_,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let f=class extends k.Disposable{constructor(C,S,c,g,y,m){super(),C.cleanUp(),(0,U.migrateUnsupportedExtensions)(C,S,c,g,m),A.ExtensionStorageService.removeOutdatedExtensionVersions(C,y)}};e.ExtensionsContributions=f,e.ExtensionsContributions=f=ye([X(0,_.INativeServerExtensionManagementService),X(1,O.IExtensionGalleryService),X(2,A.IExtensionStorageService),X(3,O.IGlobalExtensionEnablementService),X(4,I.IStorageService),X(5,L.ILogService)],f)}),define(oe[123],ae([0,1,69,61,36,275,15,8,3,2,16,6,32,42,65]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{traceSocketEvent(d,v){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,v)}constructor(d,v=""){this._canWrite=!0,this.debugLabel=v,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,L.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(d){const v=T=>{this.traceSocketEvent("read",T),d(_.VSBuffer.wrap(T))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(d){const v=T=>{d({type:0,hadError:T,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(d){const v=()=>{d()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(d){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,L.onUnexpectedError)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,L.onUnexpectedError)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=y;var m;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var h;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(h||(h={}));class l extends f.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,v){this.socket.traceSocketEvent(d,v)}constructor(d,v,T,N){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:T?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new u(this,v,T,N,this._onData,(M,$)=>this._write(M,$))),this._register(this._flowManager.onError(M=>{console.error(M),(0,L.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new g.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(async M=>{this._flowManager.isProcessingReadQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(M)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){let v=0;for(;v<d.byteLength;)this._flowManager.writeMessage(d.slice(v,Math.min(v+262144,d.byteLength))),v+=262144}_write(d,v){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let T=2;d.byteLength<126?T+=0:d.byteLength<2**16?T+=2:T+=8;const N=_.VSBuffer.alloc(T);if(v?N.writeUInt8(194,0):N.writeUInt8(130,0),d.byteLength<126)N.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){N.writeUInt8(126,1);let M=1;N.writeUInt8(d.byteLength>>>8&255,++M),N.writeUInt8(d.byteLength>>>0&255,++M)}else{N.writeUInt8(127,1);let M=1;N.writeUInt8(0,++M),N.writeUInt8(0,++M),N.writeUInt8(0,++M),N.writeUInt8(0,++M),N.writeUInt8(d.byteLength>>>24&255,++M),N.writeUInt8(d.byteLength>>>16&255,++M),N.writeUInt8(d.byteLength>>>8&255,++M),N.writeUInt8(d.byteLength>>>0&255,++M)}this.socket.write(_.VSBuffer.concat([N,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const v=this._incomingData.peek(this._state.readLen),T=v.readUInt8(0),N=(T&128)>>>7,M=(T&64)>>>6,$=v.readUInt8(1),j=($&128)>>>7,Z=$&127;this._state.state=2,this._state.readLen=2+(j?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!M),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const v=this._incomingData.read(this._state.readLen),T=v.readUInt8(1),N=(T&128)>>>7;let M=T&127,$=1;M===126?M=v.readUInt8(++$)*2**8+v.readUInt8(++$):M===127&&(M=v.readUInt8(++$)*0+v.readUInt8(++$)*0+v.readUInt8(++$)*0+v.readUInt8(++$)*0+v.readUInt8(++$)*2**24+v.readUInt8(++$)*2**16+v.readUInt8(++$)*2**8+v.readUInt8(++$));let j=0;N&&(j=v.readUInt8(++$)*2**24+v.readUInt8(++$)*2**16+v.readUInt8(++$)*2**8+v.readUInt8(++$)),this._state.state=3,this._state.readLen=M,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const v=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(v,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=l;class u extends f.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(d,v,T,N,M,$){super(),this._tracer=d,this._onData=M,this._writeFn=$,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new I.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,v?(this._zlibInflateStream=this._register(new p(this._tracer,N,T,{windowBits:15})),this._zlibDeflateStream=this._register(new b(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(d){this._writeQueue.push(d),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const d=this._writeQueue.shift();if(this._zlibDeflateStream){const v=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(v,!0)}else this._writeFn(d,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,v){return new Promise((T,N)=>{d.write(v),d.flush(M=>T(M))})}acceptFrame(d,v,T){this._readQueue.push({data:d,isCompressed:v,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const v=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(v)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(d,v,T){return new Promise((N,M)=>{d.write(v),T&&d.write(_.VSBuffer.fromByteArray([0,0,255,255])),d.flush($=>N($))})}}class p extends f.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(d,v,T,N){super(),this._tracer=d,this._recordInflateBytes=v,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,U.createInflateRaw)(N),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(_.VSBuffer.wrap(M))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const v=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(v)})}}class b extends f.Disposable{constructor(d,v){super(),this._tracer=d,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,U.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(_.VSBuffer.wrap(T))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let v=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,v=v.slice(0,v.byteLength-4),d(v)})}}function t(E,d){if(d===0)return;const v=E.byteLength>>>2;for(let Z=0;Z<v;Z++){const G=E.readUInt32BE(Z*4);E.writeUInt32BE(G^d,Z*4)}const T=v*4,N=E.byteLength-T,M=d>>>24&255,$=d>>>16&255,j=d>>>8&255;N>=1&&E.writeUInt8(E.readUInt8(T)^M,T),N>=2&&E.writeUInt8(E.readUInt8(T+1)^$,T+1),N>=3&&E.writeUInt8(E.readUInt8(T+2)^j,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const E=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const d=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),v=(0,D.join)(d,`vscode-ipc-${E}.sock`);return i(v),v}e.createRandomIPCHandle=n;function s(E,d,v){const T=(0,k.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${v}-${d}-sock`;const N=v.substr(0,4),M=d.substr(0,6),$=T.substr(0,8);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${$}-${N}-${M}.sock`):j=(0,D.join)(E,`${N}-${M}.sock`),i(j),j}e.createStaticIPCHandle=s;function i(E){const d=a[C.platform];typeof d=="number"&&E.length>=d&&console.warn(`WARNING: IPC handle "${E}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{static toClientConnectionEvent(d){const v=I.Event.fromNodeEventEmitter(d,"connection");return I.Event.map(v,T=>({protocol:new g.Protocol(new y(T,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(T,"close"))}))}constructor(d){super(r.toClientConnectionEvent(d)),this.server=d}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function o(E){return new Promise((d,v)=>{const T=(0,O.createServer)();T.on("error",v),T.listen(E,()=>{T.removeListener("error",v),d(new r(T))})})}e.serve=o;function w(E,d){return new Promise((v,T)=>{const N=(0,O.createConnection)(E,()=>{N.removeListener("error",T),v(g.Client.fromSocket(new y(N,`ipc-client${d}`),d))});N.once("error",T)})}e.connect=w}),define(oe[266],ae([0,1,61,123,210]),function(te,e,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(U){return!0}connect({host:U,port:_},L,I,f){return new Promise((D,C)=>{const S=k.createConnection({host:U,port:_},()=>{S.removeListener("error",C),S.write((0,A.makeRawSocketHeaders)(L,I,f));const c=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",c),D(new O.NodeSocket(S,f)))};S.on("data",c)});S.setNoDelay(!0),S.once("error",C)})}}}),define(oe[267],ae([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,15]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function h(t,a,n,s,i){let r;for(let o=3;o&&(r?.dispose(),r=await new l(t,a,n,s,i).waitForReady(),!(i&&A.BROWSER_RESTRICTED_PORTS[i]||!A.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));o--);return r}class l extends L.Disposable{constructor(a,n,s,i,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=k.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const a=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,A.findFreePortFaster)(a,2,1e3,n),i=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(a){a.pause();const n=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,S.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i instanceof U.NodeSocket?i.socket.destroy():i.end()}),i instanceof U.NodeSocket?this._mirrorNodeSocket(a,i):this._mirrorGenericSocket(a,i),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),i.end()})}_mirrorGenericSocket(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(s=>a.write(s.buffer)),a.on("data",s=>n.write(m.VSBuffer.wrap(s))),a.resume()}_mirrorNodeSocket(a,n){const s=n.socket;s.on("end",()=>a.end()),s.on("close",()=>a.end()),s.on("error",()=>{a.destroy()}),s.pipe(a),a.pipe(s)}}e.NodeRemoteTunnel=l;let u=class extends y.AbstractTunnelService{constructor(a,n,s,i,r){super(n,r),this.remoteSocketFactoryService=a,this.signService=s,this.productService=i}isPortPrivileged(a){return(0,y.isPortPrivileged)(a,this.defaultTunnelHost,I.OS,O.release())}retainOrCreateTunnel(a,n,s,i,r,o,w,E){const d=this.getTunnelFromMap(n,s);if(d)return++d.refcount,d.value;if((0,y.isTunnelProvider)(a))return this.createWithProvider(a,n,s,r,o,w,E);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const v={commit:this.productService.commit,quality:this.productService.quality,addressProvider:a,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},T=h(v,i,n,s,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,T),T}}};e.BaseTunnelService=u,e.BaseTunnelService=u=ye([X(0,c.IRemoteSocketFactoryService),X(1,D.ILogService),X(2,g.ISignService),X(3,C.IProductService),X(4,f.IConfigurationService)],u);let p=class extends u{constructor(a,n,s,i,r){super(a,n,s,i,r)}};e.TunnelService=p,e.TunnelService=p=ye([X(0,c.IRemoteSocketFactoryService),X(1,D.ILogService),X(2,g.ISignService),X(3,C.IProductService),X(4,f.IConfigurationService)],p);let b=class extends L.Disposable{constructor(a,n,s,i,r){super(),this.remoteSocketFactoryService=a,this.logService=n,this.productService=s,this.signService=i,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(a,n,s,i,r,o,w,E,d){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${o}.`),!this._tunnelServices.has(a)){const v=new p(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(v),this._tunnelServices.set(a,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(n,s,i,r,o,w,E,d)}};e.SharedTunnelsService=b,e.SharedTunnelsService=b=ye([X(0,c.IRemoteSocketFactoryService),X(1,D.ILogService),X(2,C.IProductService),X(3,g.ISignService),X(4,f.IConfigurationService)],b)}),define(oe[276],ae([0,1,36,38,8,2,23,10,18,3,42,147,204,205,196,197,262,187,189,19,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,22,108,109,110,45,228,80,111,25,78,254,238,239,81,253,257,258,259,58,252,241,106,219,76,267,214,229,28,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,9,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,k,O,A,U,_,L,I,f,D,C,S,c,g,y,m,h,l,u,p,b,t,a,n,s,i,r,o,w,E,d,v,T,N,M,$,j,Z,G,Q,B,K,V,z,x,ee,ne,re,J,q,P,R,W,F,H,Y,se,le,he,ue,me,fe,pe,Ce,Le,Oe,Me,ce,ge,ve,Pe,De,$e,Te,We,Fe,ie,de,Se,Ee,be,Re,Ie,ke,_e,Ue,Ne,qe,je,xe,Ze,ht,wt,Ct,bt,Pt,dt,It,Dt,Rt,Lt,kt,_t,Tt,ft,At,gt,Ut,Ot,mt,Nt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends U.Disposable{constructor(we){super(),this.configuration=we,this.server=this._register(new C.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new f.Emitter),this.registerListeners()}registerListeners(){let we=!1;const Ae=()=>{we||(we=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,C.once)(process.parentPort,it.SharedProcessLifecycle.exit,Ae)}async init(){const we=await this.initServices();(0,se.registerConfiguration)(),we.invokeFunction(Ae=>{const Ge=Ae.get(K.ILogService),ze=Ae.get(J.ITelemetryService),Ke=Ae.get(_e.IUserDataProfilesService);Ge.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ae),this.registerErrorHandler(Ge),this.reportProfilesInfo(ze,Ke),this._register(Ke.onDidChangeProfiles(()=>this.reportProfilesInfo(ze,Ke)))}),this._register((0,U.combinedDisposable)(we.createInstance(S.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(c.LanguagePackCachedDataCleaner),we.createInstance(m.UnusedWorkspaceStorageDataCleaner),we.createInstance(y.LogsDataCleaner),we.createInstance(g.LocalizationsUpdater),we.createInstance(Ct.ExtensionsContributions),we.createInstance(Ze.UserDataProfilesCleaner),we.createInstance(Nt.VoiceTranscriptionManager,this.onDidWindowConnectRaw.event)))}async initServices(){const we=new G.ServiceCollection,Ae={_serviceBrand:void 0,...z.default};we.set(x.IProductService,Ae);const Ge=new D.StaticRouter(Ve=>Ve==="main"),ze=new ft.MainProcessService(this.server,Ge);we.set(ft.IMainProcessService,ze);const Ke=this.configuration.policiesData?new Ne.PolicyChannelClient(this.configuration.policiesData,ze.getChannel("policy")):new qe.NullPolicyService;we.set(qe.IPolicyService,Ke);const Be=new Ot.NativeEnvironmentService(this.configuration.args,Ae);we.set(s.INativeEnvironmentService,Be);const Xe=new V.LoggerChannelClient(void 0,this.configuration.logLevel,Be.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:L.URI.revive(Ve.resource)})),ze.getChannel("logger"));we.set(K.ILoggerService,Xe);const st=this._register(Xe.createLogger("sharedprocess",{name:(0,bt.localize)(0,null)})),ct=this._register(new K.ConsoleLogger(st.getLevel())),He=this._register(new Pt.LogService(st,[ct]));we.set(K.ILogService,He),this.lifecycleService=this._register(new dt.SharedProcessLifecycleService(He)),we.set(dt.ISharedProcessLifecycleService,this.lifecycleService);const Ye=this._register(new N.FileService(He));we.set(T.IFileService,Ye);const lt=this._register(new M.DiskFileSystemProvider(He));Ye.registerProvider(_.Schemas.file,lt);const rt=new ie.UriIdentityService(Ye);we.set(Fe.IUriIdentityService,rt);const Je=this._register(new je.UserDataProfilesService(this.configuration.profiles.all,L.URI.revive(this.configuration.profiles.home).with({scheme:Be.userRoamingDataHome.scheme}),ze.getChannel("userDataProfiles")));we.set(_e.IUserDataProfilesService,Je);const ut=this._register(new Se.FileUserDataProvider(_.Schemas.file,this._register(new Ee.DiskFileSystemProviderClient(ze.getChannel(Ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:de.isLinux})),_.Schemas.vscodeUserData,Je,rt,He));Ye.registerProvider(_.Schemas.vscodeUserData,ut);const Qe=this._register(new p.ConfigurationService(Je.defaultProfile.settingsResource,Ye,Ke,He));we.set(u.IConfigurationService,Qe);const et=new At.RemoteStorageService(void 0,{defaultProfile:Je.defaultProfile,currentProfile:Je.defaultProfile},ze,Be);we.set(ne.IStorageService,et),this._register((0,U.toDisposable)(()=>et.flush())),await Promise.all([Qe.initialize(),et.initialize()]);const vt=new Rt.RequestChannelClient(ze.getChannel("request"));we.set(ee.IRequestService,vt),we.set(h.IChecksumService,new $.SyncDescriptor(l.ChecksumService,void 0,!1)),we.set(Re.IV8InspectProfilingService,new $.SyncDescriptor(be.InspectProfilingService,void 0,!1));const pt=D.ProxyChannel.toService(ze.getChannel("nativeHost"));we.set(kt.INativeHostService,pt),we.set(a.IDownloadService,new $.SyncDescriptor(n.DownloadService,void 0,!0));const Mt=this._register(new ge.ActiveWindowManager(pt)),$t=new D.StaticRouter(Ve=>Mt.getActiveClientId().then(at=>Ve===at));we.set(v.IExtensionRecommendationNotificationService,new Lt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",$t)));let ot;const tt=[],yt=(0,W.isInternalTelemetry)(Ae,Qe);if((0,W.supportsTelemetry)(Ae,Be)){const Ve=new P.TelemetryLogAppender(He,Xe,Be,Ae);if(tt.push(Ve),!(0,W.isLoggingOnly)(Ae,Be)&&Ae.aiConfig?.ariaKey){const at=new xe.OneDataSystemAppender(vt,yt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this._register((0,U.toDisposable)(()=>at.flush())),tt.push(at)}ot=new R.TelemetryService({appenders:tt,commonProperties:(0,re.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,Ae.commit,Ae.version,this.configuration.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,W.getPiiPathsFromEnvironment)(Be)},Qe,Ae)}else{ot=W.NullTelemetryService;const Ve=W.NullAppender;tt.push(Ve)}this.server.registerChannel("telemetryAppender",new q.TelemetryAppenderChannel(tt)),we.set(J.ITelemetryService,ot);const Wt=new F.CustomEndpointTelemetryService(Qe,ot,He,Xe,Be,Ae);we.set(J.ICustomEndpointTelemetryService,Wt),we.set(Ue.IExtensionsProfileScannerService,new $.SyncDescriptor(Dt.ExtensionsProfileScannerService,void 0,!0)),we.set(Ie.IExtensionsScannerService,new $.SyncDescriptor(ke.ExtensionsScannerService,void 0,!0)),we.set(w.IExtensionSignatureVerificationService,new $.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),we.set(d.INativeServerExtensionManagementService,new $.SyncDescriptor(d.ExtensionManagementService,void 0,!0)),we.set(o.IExtensionGalleryService,new $.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),we.set(o.IExtensionTipsService,new $.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),we.set(Q.ILanguagePackService,new $.SyncDescriptor(B.NativeLanguagePackService,void 0,!1)),we.set(b.IDiagnosticsService,new $.SyncDescriptor(t.DiagnosticsService,void 0,!1)),we.set(le.IUserDataSyncAccountService,new $.SyncDescriptor(le.UserDataSyncAccountService,void 0,!0)),we.set(se.IUserDataSyncLogService,new $.SyncDescriptor(me.UserDataSyncLogService,void 0,!0)),we.set(se.IUserDataSyncUtilService,new ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),we.set(o.IGlobalExtensionEnablementService,new $.SyncDescriptor(i.GlobalExtensionEnablementService,void 0,!1)),we.set(Y.IIgnoredExtensionsManagementService,new $.SyncDescriptor(Y.IgnoredExtensionsManagementService,void 0,!0)),we.set(H.IExtensionStorageService,new $.SyncDescriptor(H.ExtensionStorageService)),we.set(se.IUserDataSyncStoreManagementService,new $.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),we.set(se.IUserDataSyncStoreService,new $.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),we.set(fe.IUserDataSyncMachinesService,new $.SyncDescriptor(fe.UserDataSyncMachinesService,void 0,!0)),we.set(se.IUserDataSyncLocalStoreService,new $.SyncDescriptor(he.UserDataSyncLocalStoreService,void 0,!1)),we.set(se.IUserDataSyncEnablementService,new $.SyncDescriptor(pe.UserDataSyncEnablementService,void 0,!0)),we.set(se.IUserDataSyncService,new $.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),we.set(Me.IUserDataProfileStorageService,new $.SyncDescriptor(ce.NativeUserDataProfileStorageService,void 0,!0)),we.set(se.IUserDataSyncResourceProviderService,new $.SyncDescriptor(wt.UserDataSyncResourceProviderService,void 0,!0)),we.set(ve.ISignService,new $.SyncDescriptor(Pe.SignService,void 0,!1));const Et=new gt.RemoteSocketFactoryService;return we.set(gt.IRemoteSocketFactoryService,Et),Et.register(0,Ut.nodeSocketFactory),we.set(De.ISharedTunnelsService,new $.SyncDescriptor($e.SharedTunnelsService)),we.set(Te.ISharedProcessTunnelService,new $.SyncDescriptor(We.SharedProcessTunnelService)),we.set(ht.IRemoteTunnelService,new $.SyncDescriptor(It.RemoteTunnelService)),we.set(mt.IVoiceRecognitionService,new $.SyncDescriptor(mt.VoiceRecognitionService)),new Z.InstantiationService(we)}initChannels(we){const Ae=this._register(new U.DisposableStore),Ge=new E.ExtensionManagementChannel(we.get(o.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ge);const ze=D.ProxyChannel.fromService(we.get(Q.ILanguagePackService),Ae);this.server.registerChannel("languagePacks",ze);const Ke=D.ProxyChannel.fromService(we.get(b.IDiagnosticsService),Ae);this.server.registerChannel("diagnostics",Ke);const Be=new E.ExtensionTipsChannel(we.get(o.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Be);const Xe=D.ProxyChannel.fromService(we.get(h.IChecksumService),Ae);this.server.registerChannel("checksum",Xe);const st=D.ProxyChannel.fromService(we.get(Re.IV8InspectProfilingService),Ae);this.server.registerChannel("v8InspectProfiling",st);const ct=new ue.UserDataSyncMachinesServiceChannel(we.get(fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const He=D.ProxyChannel.fromService(we.get(J.ICustomEndpointTelemetryService),Ae);this.server.registerChannel("customEndpointTelemetry",He);const Ye=new ue.UserDataSyncAccountServiceChannel(we.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ye);const lt=new ue.UserDataSyncStoreManagementServiceChannel(we.get(se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",lt);const rt=new Le.UserDataSyncChannel(we.get(se.IUserDataSyncService),we.get(_e.IUserDataProfilesService),we.get(K.ILogService));this.server.registerChannel("userDataSync",rt);const Je=this._register(we.get(j.IInstantiationService).createInstance(_t.UserDataAutoSyncService)),ut=new ue.UserDataAutoSyncChannel(Je);this.server.registerChannel("userDataAutoSync",ut),this.server.registerChannel("IUserDataSyncResourceProviderService",D.ProxyChannel.fromService(we.get(se.IUserDataSyncResourceProviderService),Ae));const Qe=D.ProxyChannel.fromService(we.get(Te.ISharedProcessTunnelService),Ae);this.server.registerChannel(Te.ipcSharedProcessTunnelChannelName,Qe);const et=D.ProxyChannel.fromService(we.get(ht.IRemoteTunnelService),Ae);this.server.registerChannel("remoteTunnel",et)}registerErrorHandler(we){process.on("uncaughtException",Ae=>(0,A.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,A.onUnexpectedError)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Ge=(0,O.toErrorMessage)(Ae,!0);Ge&&we.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}reportProfilesInfo(we,Ae){we.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(we){if(we.data!==it.SharedProcessRawConnection.response)return!1;const Ae=(0,I.firstOrDefault)(we.ports);return Ae?(this.onDidWindowConnectRaw.fire(Ae),!0):!1}}async function St(nt){const we=new Ft(nt);process.parentPort.postMessage(it.SharedProcessLifecycle.ipcReady),await we.init(),process.parentPort.postMessage(it.SharedProcessLifecycle.initDone)}e.main=St,process.parentPort.once("message",nt=>{St(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
