/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var y=["require","exports","vs/base/common/ternarySearchTree","vs/platform/instantiation/common/instantiation","vs/platform/profiling/common/profiling","vs/base/common/path","vs/platform/profiling/common/profilingModel","vs/base/common/arrays","vs/base/common/strings","vs/platform/profiling/electron-sandbox/profileAnalysisWorker","vs/base/common/uri"],E=function(w){for(var a=[],g=0,v=w.length;g<v;g++)a[g]=y[w[g]];return a};define(y[2],E([0,1,7,8]),function(w,a,g,v){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.TernarySearchTree=a.UriIterator=a.PathIterator=a.ConfigKeysIterator=a.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){const s=e.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}a.StringIterator=T;class p{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(e)this._from++;else break;else e=!1;return this}cmp(e){return this._caseSensitive?(0,v.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}a.ConfigKeysIterator=p;class m{constructor(e=!0,s=!0){this._splitOnBackslash=e,this._caseSensitive=s}reset(e){this._from=0,this._to=0,this._value=e,this._valueLen=e.length;for(let s=e.length-1;s>=0;s--,this._valueLen--){const r=this._value.charCodeAt(s);if(!(r===47||this._splitOnBackslash&&r===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let e=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(e)this._from++;else break;else e=!1}return this}cmp(e){return this._caseSensitive?(0,v.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}a.PathIterator=m;var l;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(l||(l={}));class u{constructor(e,s){this._ignorePathCasing=e,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(e)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(this._states[this._stateIdx]===1)return(0,v.compareIgnoreCase)(e,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,v.compareIgnoreCase)(e,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(e);if(this._states[this._stateIdx]===4)return(0,v.compare)(e,this._value.query);if(this._states[this._stateIdx]===5)return(0,v.compare)(e,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}a.UriIterator=u;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(_||(_={}));class h{static forUris(e=()=>!1,s=()=>!1){return new h(new u(e,s))}static forPaths(e=!1){return new h(new m(void 0,!e))}static forStrings(){return new h(new T)}static forConfigKeys(){return new h(new p)}constructor(e){this._iter=e}clear(){this._root=void 0}fill(e,s){if(s){const r=s.slice(0);(0,g.shuffle)(r);for(const i of r)this.set(i,e)}else{const r=e.slice(0);(0,g.shuffle)(r);for(const i of r)this.set(i[0],i[1])}}set(e,s){const r=this._iter.reset(e);let i;this._root||(this._root=new d,this._root.segment=r.value());const t=[];for(i=this._root;;){const o=r.cmp(i.segment);if(o>0)i.left||(i.left=new d,i.left.segment=r.value()),t.push([-1,i]),i=i.left;else if(o<0)i.right||(i.right=new d,i.right.segment=r.value()),t.push([1,i]),i=i.right;else if(r.hasNext())r.next(),i.mid||(i.mid=new d,i.mid.segment=r.value()),t.push([0,i]),i=i.mid;else break}const n=i.value;i.value=s,i.key=e;for(let o=t.length-1;o>=0;o--){const c=t[o][1];c.updateHeight();const b=c.balanceFactor();if(b<-1||b>1){const I=t[o][0],N=t[o+1][0];if(I===1&&N===1)t[o][1]=c.rotateLeft();else if(I===-1&&N===-1)t[o][1]=c.rotateRight();else if(I===1&&N===-1)c.right=t[o+1][1]=t[o+1][1].rotateRight(),t[o][1]=c.rotateLeft();else if(I===-1&&N===1)c.left=t[o+1][1]=t[o+1][1].rotateLeft(),t[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this._root=t[0][1]}}return n}get(e){return this._getNode(e)?.value}_getNode(e){const s=this._iter.reset(e);let r=this._root;for(;r;){const i=s.cmp(r.segment);if(i>0)r=r.left;else if(i<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(e){const s=this._getNode(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,s){const r=this._iter.reset(e),i=[];let t=this._root;for(;t;){const n=r.cmp(t.segment);if(n>0)i.push([-1,t]),t=t.left;else if(n<0)i.push([1,t]),t=t.right;else if(r.hasNext())r.next(),i.push([0,t]),t=t.mid;else break}if(t){if(s?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this._min(t.right);if(n.key){const{key:o,value:c,segment:b}=n;this._delete(n.key,!1),t.key=o,t.value=c,t.segment=b}}else{const n=t.left??t.right;if(i.length>0){const[o,c]=i[i.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this._root=n}for(let n=i.length-1;n>=0;n--){const o=i[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),i[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),i[n][1]=o.rotateRight()),n>0)switch(i[n-1][0]){case-1:i[n-1][1].left=i[n][1];break;case 1:i[n-1][1].right=i[n][1];break;case 0:i[n-1][1].mid=i[n][1];break}else this._root=i[0][1]}}}_min(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this._iter.reset(e);let r=this._root,i;for(;r;){const t=s.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(s.hasNext())s.next(),i=r.value||i,r=r.mid;else break}return r&&r.value||i}findSuperstr(e){return this._findSuperstrOrElement(e,!1)}_findSuperstrOrElement(e,s){const r=this._iter.reset(e);let i=this._root;for(;i;){const t=r.cmp(i.segment);if(t>0)i=i.left;else if(t<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):s?i.value:void 0}}hasElementOrSubtree(e){return this._findSuperstrOrElement(e,!0)!==void 0}forEach(e){for(const[s,r]of this)e(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(e){const s=[];return this._dfsEntries(e,s),s[Symbol.iterator]()}_dfsEntries(e,s){e&&(e.left&&this._dfsEntries(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this._dfsEntries(e.mid,s),e.right&&this._dfsEntries(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const r=s.balanceFactor();return r<-1||r>1?!1:e(s.left)&&e(s.right)};return e(this._root)}}a.TernarySearchTree=h}),define(y[3],E([0,1]),function(w,a){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.refineServiceDecorator=a.createDecorator=a.IInstantiationService=a._util=void 0;var g;(function(m){m.serviceIds=new Map,m.DI_TARGET="$di$target",m.DI_DEPENDENCIES="$di$dependencies";function l(u){return u[m.DI_DEPENDENCIES]||[]}m.getServiceDependencies=l})(g||(a._util=g={})),a.IInstantiationService=T("instantiationService");function v(m,l,u){l[g.DI_TARGET]===l?l[g.DI_DEPENDENCIES].push({id:m,index:u}):(l[g.DI_DEPENDENCIES]=[{id:m,index:u}],l[g.DI_TARGET]=l)}function T(m){if(g.serviceIds.has(m))return g.serviceIds.get(m);const l=function(u,d,_){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");v(l,u,_)};return l.toString=()=>m,g.serviceIds.set(m,l),l}a.createDecorator=T;function p(m){return m}a.refineServiceDecorator=p}),define(y[4],E([0,1,5,3]),function(w,a,g,v){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.Utils=a.IV8InspectProfilingService=void 0,a.IV8InspectProfilingService=(0,v.createDecorator)("IV8InspectProfilingService");var T;(function(p){function m(u){return!!(u.samples&&u.timeDeltas)}p.isValidProfile=m;function l(u,d="noAbsolutePaths"){for(const _ of u.nodes)_.callFrame&&_.callFrame.url&&((0,g.isAbsolute)(_.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(_.callFrame.url))&&(_.callFrame.url=(0,g.join)(d,(0,g.basename)(_.callFrame.url)));return u}p.rewriteAbsolutePaths=l})(T||(a.Utils=T={}))}),define(y[6],E([0,1]),function(w,a){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.processNode=a.BottomUpNode=a.buildModel=void 0;const g=(l,u)=>{const d=u[l];if(d.aggregateTime)return d.aggregateTime;let _=d.selfTime;for(const h of d.children)_+=g(h,u);return d.aggregateTime=_},v=l=>{let u=0;const d=new Map,_=h=>{const f=[h.functionName,h.url,h.scriptId,h.lineNumber,h.columnNumber].join(":"),e=d.get(f);if(e)return e.id;const s=u++;return d.set(f,{id:s,callFrame:h,location:{lineNumber:h.lineNumber+1,columnNumber:h.columnNumber+1}}),s};for(const h of l.nodes)h.locationId=_(h.callFrame),h.positionTicks=h.positionTicks?.map(f=>({...f,startLocationId:_({...h.callFrame,lineNumber:f.line-1,columnNumber:0}),endLocationId:_({...h.callFrame,lineNumber:f.line,columnNumber:0})}));return[...d.values()].sort((h,f)=>h.id-f.id).map(h=>({locations:[h.location],callFrame:h.callFrame}))},T=l=>{if(!l.timeDeltas||!l.samples)return{nodes:[],locations:[],samples:l.samples||[],timeDeltas:l.timeDeltas||[],duration:l.endTime-l.startTime};const{samples:u,timeDeltas:d}=l,h=v(l).map((t,n)=>{const o=t.locations[0];return{id:n,selfTime:0,aggregateTime:0,ticks:0,callFrame:t.callFrame,src:o}}),f=new Map,e=t=>{let n=f.get(t);return n===void 0&&(n=f.size,f.set(t,n)),n},s=new Array(l.nodes.length);for(let t=0;t<l.nodes.length;t++){const n=l.nodes[t],o=e(n.id);s[o]={id:o,selfTime:0,aggregateTime:0,locationId:n.locationId,children:n.children?.map(e)||[]};for(const c of n.positionTicks||[])c.startLocationId&&(h[c.startLocationId].ticks+=c.ticks)}for(const t of s)for(const n of t.children)s[n].parent=t.id;const r=l.endTime-l.startTime;let i=r-d[0];for(let t=0;t<d.length-1;t++){const n=d[t+1];s[e(u[t])].selfTime+=n,i-=n}s.length&&(s[e(u[d.length-1])].selfTime+=i,d.push(i));for(let t=0;t<s.length;t++){const n=s[t],o=h[n.locationId];o.aggregateTime+=g(t,s),o.selfTime+=n.selfTime}return{nodes:s,locations:h,samples:u.map(e),timeDeltas:d,duration:r}};a.buildModel=T;class p{static root(){return new p({id:-1,selfTime:0,aggregateTime:0,ticks:0,callFrame:{functionName:"(root)",lineNumber:-1,columnNumber:-1,scriptId:"0",url:""}})}get id(){return this.location.id}get callFrame(){return this.location.callFrame}get src(){return this.location.src}constructor(u,d){this.location=u,this.parent=d,this.children={},this.aggregateTime=0,this.selfTime=0,this.ticks=0,this.childrenSize=0}addNode(u){this.selfTime+=u.selfTime,this.aggregateTime+=u.aggregateTime}}a.BottomUpNode=p;const m=(l,u,d,_=u)=>{let h=l.children[u.locationId];h||(h=new p(d.locations[u.locationId],l),l.childrenSize++,l.children[u.locationId]=h),h.addNode(_),u.parent&&(0,a.processNode)(h,d.nodes[u.parent],d,_)};a.processNode=m}),define(y[9],E([0,1,5,2,10,4,6]),function(w,a,g,v,T,p,m){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),a.create=void 0;function l(){return new u}a.create=l;class u{analyseBottomUp(r){if(!p.Utils.isValidProfile(r))return{kind:1,samples:[]};const i=(0,m.buildModel)(r),t=e(i,5).filter(n=>!n.isSpecial);return t.length===0||t[0].percentage<10?{kind:1,samples:[]}:{kind:2,samples:t}}analyseByUrlCategory(r,i){const t=v.TernarySearchTree.forUris();t.fill(i);const n=(0,m.buildModel)(r),o=new Map;for(const b of n.nodes){const I=n.locations[b.locationId];let N;try{N=t.findSubstr(T.URI.parse(I.callFrame.url))}catch{}N||(N=_(I.callFrame));const k=(o.get(N)??0)+b.selfTime;o.set(N,k)}const c=[];for(const[b,I]of o)c.push([b,I]);return c}}function d(s){return s.functionName.startsWith("(")&&s.functionName.endsWith(")")}function _(s){let r=s.functionName||"(anonymous)";return s.url&&(r+="#",r+=(0,g.basename)(s.url),s.lineNumber>=0&&(r+=":",r+=s.lineNumber+1),s.columnNumber>=0&&(r+=":",r+=s.columnNumber+1)),r}function h(s){let r=s.functionName||"(anonymous)";return s.url&&(r+=" (",r+=s.url,s.lineNumber>=0&&(r+=":",r+=s.lineNumber+1),s.columnNumber>=0&&(r+=":",r+=s.columnNumber+1),r+=")"),r}function f(s,r){const i={};for(const n of s.nodes)i[n.locationId]=(i[n.locationId]||0)+n.selfTime;const t=Object.entries(i).sort(([,n],[,o])=>o-n).slice(0,r).map(([n])=>Number(n));return new Set(t)}function e(s,r){const i=m.BottomUpNode.root(),t=f(s,r);for(const c of s.nodes)t.has(c.locationId)&&((0,m.processNode)(i,c,s),i.addNode(c));const n=Object.values(i.children).sort((c,b)=>b.selfTime-c.selfTime).slice(0,r),o=[];for(const c of n){const b={selfTime:Math.round(c.selfTime/1e3),totalTime:Math.round(c.aggregateTime/1e3),location:_(c.callFrame),absLocation:h(c.callFrame),url:c.callFrame.url,caller:[],percentage:Math.round(c.selfTime/(s.duration/100)),isSpecial:d(c.callFrame)},I=[c];for(;I.length;){const N=I.pop();let S;for(const k of Object.values(N.children))(!S||S.selfTime<k.selfTime)&&(S=k);if(S){const k=Math.round(S.selfTime/(N.selfTime/100));b.caller.push({percentage:k,location:_(S.callFrame),absLocation:h(S.callFrame)}),I.push(S)}}o.push(b)}return o}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/platform/profiling/electron-sandbox/profileAnalysisWorker.js.map
