/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(pe){for(var e=[],D=0,F=pe.length;D<F;D++)e[D]=Ce[pe[D]];return e};define(Ce[156],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class D{static get(){const d=new Map,R=new Map,A=new Map,p=new Map;function _(y,C){y.has(C.detail)||y.set(C.detail,-C.timestamp)}function b(y,C){const w=y.get(C.detail);w&&(w>=0||y.set(C.detail,w+C.timestamp))}let T=[];typeof pe=="function"&&typeof pe.getStats=="function"&&(T=pe.getStats().slice(0).sort((y,C)=>y.timestamp-C.timestamp));for(const y of T)switch(y.type){case 10:_(d,y);break;case 11:case 12:b(d,y);break;case 21:_(R,y);break;case 22:b(R,y);break;case 33:_(A,y);break;case 34:b(A,y);break;case 31:_(p,y);break;case 32:b(p,y);break}let k=0;A.forEach(y=>k+=y);function v(y){const C=[];return y.forEach((w,s)=>C.push([s,w])),C}return{amdLoad:v(d),amdInvoke:v(R),nodeRequire:v(A),nodeEval:v(p),nodeRequireTotal:k}}static toMarkdownTable(d,R){let A="";const p=[];return d.forEach((_,b)=>{p[b]=_.length}),R.forEach(_=>{_.forEach((b,T)=>{typeof b>"u"&&(b=_[T]="-");const k=b.toString().length;p[T]=Math.max(k,p[T])})}),d.forEach((_,b)=>{A+=`| ${_+" ".repeat(p[b]-_.toString().length)} `}),A+=`|
`,d.forEach((_,b)=>{A+=`| ${"-".repeat(p[b])} `}),A+=`|
`,R.forEach(_=>{_.forEach((b,T)=>{typeof b<"u"&&(A+=`| ${b+" ".repeat(p[T]-b.toString().length)} `)}),A+=`|
`}),A}}e.LoaderStats=D}),define(Ce[118],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function D(w,s,o){const a=F(w,s);if(a!==-1)return w[a]}e.findLast=D;function F(w,s,o=w.length-1){for(let a=o;a>=0;a--){const c=w[a];if(s(c))return a}return-1}e.findLastIdx=F;function d(w,s){const o=R(w,s);return o===-1?void 0:w[o]}e.findLastMonotonous=d;function R(w,s,o=0,a=w.length){let c=o,g=a;for(;c<g;){const u=Math.floor((c+g)/2);s(w[u])?c=u+1:g=u}return c-1}e.findLastIdxMonotonous=R;function A(w,s){const o=p(w,s);return o===w.length?void 0:w[o]}e.findFirstMonotonous=A;function p(w,s,o=0,a=w.length){let c=o,g=a;for(;c<g;){const u=Math.floor((c+g)/2);s(w[u])?g=u:c=u+1}return c}e.findFirstIdxMonotonousOrArrLen=p;function _(w,s,o=0,a=w.length){const c=p(w,s,o,a);return c===w.length?-1:c}e.findFirstIdxMonotonous=_;class b{static{this.assertInvariants=!1}constructor(s){this._array=s,this._findLastMonotonousLastIdx=0}findLastMonotonous(s){if(b.assertInvariants){if(this._prevFindLastPredicate){for(const a of this._array)if(this._prevFindLastPredicate(a)&&!s(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=s}const o=R(this._array,s,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=o+1,o===-1?void 0:this._array[o]}}e.MonotonousArray=b;function T(w,s){if(w.length===0)return;let o=w[0];for(let a=1;a<w.length;a++){const c=w[a];s(c,o)>0&&(o=c)}return o}e.findFirstMaxBy=T;function k(w,s){if(w.length===0)return;let o=w[0];for(let a=1;a<w.length;a++){const c=w[a];s(c,o)>=0&&(o=c)}return o}e.findLastMaxBy=k;function v(w,s){return T(w,(o,a)=>-s(o,a))}e.findFirstMinBy=v;function y(w,s){if(w.length===0)return-1;let o=0;for(let a=1;a<w.length;a++){const c=w[a];s(c,w[o])>0&&(o=a)}return o}e.findMaxIdxBy=y;function C(w,s){for(const o of w){const a=s(o);if(a!==void 0)return a}}e.mapFindFirst=C}),define(Ce[74],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function D(A,p){const _=Object.create(null);for(const b of A){const T=p(b);let k=_[T];k||(k=_[T]=[]),k.push(b)}return _}e.groupBy=D;function F(A,p){const _=[],b=[];for(const T of A)p.has(T)||_.push(T);for(const T of p)A.has(T)||b.push(T);return{removed:_,added:b}}e.diffSets=F;function d(A,p){const _=[],b=[];for(const[T,k]of A)p.has(T)||_.push(k);for(const[T,k]of p)A.has(T)||b.push(k);return{removed:_,added:b}}e.diffMaps=d;function R(A,p){const _=new Set;for(const b of p)A.has(b)&&_.add(b);return _}e.intersection=R}),define(Ce[56],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(A){return(p,_,b)=>{let T=null,k=null;if(typeof b.value=="function"?(T="value",k=b.value):typeof b.get=="function"&&(T="get",k=b.get),!k)throw new Error("not supported");b[T]=A(k,_)}}function F(A,p,_){let b=null,T=null;if(typeof _.value=="function"?(b="value",T=_.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(b="get",T=_.get),!T)throw new Error("not supported");const k=`$memoize$${p}`;_[b]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,v)}),this[k]}}e.memoize=F;function d(A,p,_){return D((b,T)=>{const k=`$debounce$${T}`,v=`$debounce$result$${T}`;return function(...y){this[v]||(this[v]=_?_():void 0),clearTimeout(this[k]),p&&(this[v]=p(this[v],...y),y=[this[v]]),this[k]=setTimeout(()=>{b.apply(this,y),this[v]=_?_():void 0},A)}})}e.debounce=d;function R(A,p,_){return D((b,T)=>{const k=`$throttle$timer$${T}`,v=`$throttle$result$${T}`,y=`$throttle$lastRun$${T}`,C=`$throttle$pending$${T}`;return function(...w){if(this[v]||(this[v]=_?_():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),p&&(this[v]=p(this[v],...w)),this[C])return;const s=this[y]+A;s<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[v]]),this[v]=_?_():void 0):(this[C]=!0,this[k]=setTimeout(()=>{this[C]=!1,this[y]=Date.now(),b.apply(this,[this[v]]),this[v]=_?_():void 0},s-Date.now()))}})}e.throttle=R}),define(Ce[8],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function F(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=F;function d(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=d;function R(u){b(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=R;function A(u){b(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=A;function p(u){if(u instanceof Error){const{name:t,message:n}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:n,stack:r,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=p;const _="Canceled";function b(u){return u instanceof T?!0:u instanceof Error&&u.name===_&&u.message===_}e.isCancellationError=b;class T extends Error{constructor(){super(_),this.name=this.message}}e.CancellationError=T;function k(){const u=new Error(_);return u.name=u.message,u}e.canceled=k;function v(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=v;function y(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=y;class C extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=C;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class s extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=s;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=o;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=a;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const n=new c;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.BugIndicatingError=g}),define(Ce[19],De([1,0,8,118]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function d(Z,ne=0){return Z[Z.length-(1+ne)]}e.tail=d;function R(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=R;function A(Z,ne,re=(ye,oe)=>ye===oe){if(Z===ne)return!0;if(!Z||!ne||Z.length!==ne.length)return!1;for(let ye=0,oe=Z.length;ye<oe;ye++)if(!re(Z[ye],ne[ye]))return!1;return!0}e.equals=A;function p(Z,ne){const re=Z.length-1;ne<re&&(Z[ne]=Z[re]),Z.pop()}e.removeFastWithoutKeepingOrder=p;function _(Z,ne,re){return b(Z.length,ye=>re(Z[ye],ne))}e.binarySearch=_;function b(Z,ne){let re=0,ye=Z-1;for(;re<=ye;){const oe=(re+ye)/2|0,de=ne(oe);if(de<0)re=oe+1;else if(de>0)ye=oe-1;else return oe}return-(re+1)}e.binarySearch2=b;function T(Z,ne,re){if(Z=Z|0,Z>=ne.length)throw new TypeError("invalid index");const ye=ne[Math.floor(ne.length*Math.random())],oe=[],de=[],ee=[];for(const ue of ne){const ve=re(ue,ye);ve<0?oe.push(ue):ve>0?de.push(ue):ee.push(ue)}return Z<oe.length?T(Z,oe,re):Z<oe.length+ee.length?ee[0]:T(Z-(oe.length+ee.length),de,re)}e.quickSelect=T;function k(Z,ne){const re=[];let ye;for(const oe of Z.slice(0).sort(ne))!ye||ne(ye[0],oe)!==0?(ye=[oe],re.push(ye)):ye.push(oe);return re}e.groupBy=k;function*v(Z,ne){let re,ye;for(const oe of Z)ye!==void 0&&ne(ye,oe)?re.push(oe):(re&&(yield re),re=[oe]),ye=oe;re&&(yield re)}e.groupAdjacentBy=v;function y(Z,ne){for(let re=0;re<=Z.length;re++)ne(re===0?void 0:Z[re-1],re===Z.length?void 0:Z[re])}e.forEachAdjacent=y;function C(Z,ne){for(let re=0;re<Z.length;re++)ne(re===0?void 0:Z[re-1],Z[re],re+1===Z.length?void 0:Z[re+1])}e.forEachWithNeighbors=C;function w(Z,ne,re){const ye=[];function oe(ue,ve,ke){if(ve===0&&ke.length===0)return;const $=ye[ye.length-1];$&&$.start+$.deleteCount===ue?($.deleteCount+=ve,$.toInsert.push(...ke)):ye.push({start:ue,deleteCount:ve,toInsert:ke})}let de=0,ee=0;for(;;){if(de===Z.length){oe(de,0,ne.slice(ee));break}if(ee===ne.length){oe(de,Z.length-de,[]);break}const ue=Z[de],ve=ne[ee],ke=re(ue,ve);ke===0?(de+=1,ee+=1):ke<0?(oe(de,1,[]),de+=1):ke>0&&(oe(de,0,[ve]),ee+=1)}return ye}e.sortedDiff=w;function s(Z,ne,re){const ye=w(Z,ne,re),oe=[],de=[];for(const ee of ye)oe.push(...Z.slice(ee.start,ee.start+ee.deleteCount)),de.push(...ee.toInsert);return{removed:oe,added:de}}e.delta=s;function o(Z,ne,re){if(re===0)return[];const ye=Z.slice(0,re).sort(ne);return c(Z,ne,ye,re,Z.length),ye}e.top=o;function a(Z,ne,re,ye,oe){return re===0?Promise.resolve([]):new Promise((de,ee)=>{(async()=>{const ue=Z.length,ve=Z.slice(0,re).sort(ne);for(let ke=re,$=Math.min(re+ye,ue);ke<ue;ke=$,$=Math.min($+ye,ue)){if(ke>re&&await new Promise(K=>setTimeout(K)),oe&&oe.isCancellationRequested)throw new D.CancellationError;c(Z,ne,ve,ke,$)}return ve})().then(de,ee)})}e.topAsync=a;function c(Z,ne,re,ye,oe){for(const de=re.length;ye<oe;ye++){const ee=Z[ye];if(ne(ee,re[de-1])<0){re.pop();const ue=(0,F.findFirstIdxMonotonousOrArrLen)(re,ve=>ne(ee,ve)<0);re.splice(ue,0,ee)}}}function g(Z){return Z.filter(ne=>!!ne)}e.coalesce=g;function u(Z){let ne=0;for(let re=0;re<Z.length;re++)Z[re]&&(Z[ne]=Z[re],ne+=1);Z.length=ne}e.coalesceInPlace=u;function t(Z,ne,re){Z.splice(re,0,Z.splice(ne,1)[0])}e.move=t;function n(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=n;function r(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=r;function i(Z,ne=re=>re){const re=new Set;return Z.filter(ye=>{const oe=ne(ye);return re.has(oe)?!1:(re.add(oe),!0)})}e.distinct=i;function l(Z){const ne=new Set;return re=>{const ye=Z(re);return ne.has(ye)?!1:(ne.add(ye),!0)}}e.uniqueFilter=l;function f(Z,ne){return Z.length>0?Z[0]:ne}e.firstOrDefault=f;function S(Z,ne){return Z.length>0?Z[Z.length-1]:ne}e.lastOrDefault=S;function I(Z,ne,re=(ye,oe)=>ye===oe){let ye=0;for(let oe=0,de=Math.min(Z.length,ne.length);oe<de&&re(Z[oe],ne[oe]);oe++)ye++;return ye}e.commonPrefixLength=I;function E(Z){return[].concat(...Z)}e.flatten=E;function h(Z,ne){let re=typeof ne=="number"?Z:0;typeof ne=="number"?re=Z:(re=0,ne=Z);const ye=[];if(re<=ne)for(let oe=re;oe<ne;oe++)ye.push(oe);else for(let oe=re;oe>ne;oe--)ye.push(oe);return ye}e.range=h;function m(Z,ne,re){return Z.reduce((ye,oe)=>(ye[ne(oe)]=re?re(oe):oe,ye),Object.create(null))}e.index=m;function P(Z,ne){return Z.push(ne),()=>O(Z,ne)}e.insert=P;function O(Z,ne){const re=Z.indexOf(ne);if(re>-1)return Z.splice(re,1),ne}e.remove=O;function N(Z,ne,re){const ye=Z.slice(0,ne),oe=Z.slice(ne);return ye.concat(re,oe)}e.arrayInsert=N;function L(Z,ne){let re;if(typeof ne=="number"){let ye=ne;re=()=>{const oe=Math.sin(ye++)*179426549;return oe-Math.floor(oe)}}else re=Math.random;for(let ye=Z.length-1;ye>0;ye-=1){const oe=Math.floor(re()*(ye+1)),de=Z[ye];Z[ye]=Z[oe],Z[oe]=de}}e.shuffle=L;function U(Z,ne){const re=Z.indexOf(ne);re>-1&&(Z.splice(re,1),Z.unshift(ne))}e.pushToStart=U;function x(Z,ne){const re=Z.indexOf(ne);re>-1&&(Z.splice(re,1),Z.push(ne))}e.pushToEnd=x;function M(Z,ne){for(const re of ne)Z.push(re)}e.pushMany=M;function H(Z,ne){return Array.isArray(Z)?Z.map(ne):ne(Z)}e.mapArrayOrNot=H;function j(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=j;function fe(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=fe;function Y(Z,ne,re){const ye=z(Z,ne),oe=Z.length,de=re.length;Z.length=oe+de;for(let ee=oe-1;ee>=ye;ee--)Z[ee+de]=Z[ee];for(let ee=0;ee<de;ee++)Z[ee+ye]=re[ee]}e.insertInto=Y;function X(Z,ne,re,ye){const oe=z(Z,ne);let de=Z.splice(oe,re);return de===void 0&&(de=[]),Y(Z,oe,ye),de}e.splice=X;function z(Z,ne){return ne<0?Math.max(ne+Z.length,0):Math.min(ne,Z.length)}var J;(function(Z){function ne(de){return de<0}Z.isLessThan=ne;function re(de){return de<=0}Z.isLessThanOrEqual=re;function ye(de){return de>0}Z.isGreaterThan=ye;function oe(de){return de===0}Z.isNeitherLessOrGreaterThan=oe,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function ge(Z,ne){return(re,ye)=>ne(Z(re),Z(ye))}e.compareBy=ge;function le(...Z){return(ne,re)=>{for(const ye of Z){const oe=ye(ne,re);if(!J.isNeitherLessOrGreaterThan(oe))return oe}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const we=(Z,ne)=>Z-ne;e.numberComparator=we;const G=(Z,ne)=>(0,e.numberComparator)(Z?1:0,ne?1:0);e.booleanComparator=G;function B(Z){return(ne,re)=>-Z(ne,re)}e.reverseOrder=B;class V{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let re=this.firstIdx;for(;re<this.items.length&&ne(this.items[re]);)re++;const ye=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ye}takeFromEndWhile(ne){let re=this.lastIdx;for(;re>=0&&ne(this.items[re]);)re--;const ye=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ye}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ne=this.items[this.firstIdx];return this.firstIdx++,ne}removeLast(){const ne=this.items[this.lastIdx];return this.lastIdx--,ne}takeCount(ne){const re=this.items.slice(this.firstIdx,this.firstIdx+ne);return this.firstIdx+=ne,re}}e.ArrayQueue=V;class me{static{this.empty=new me(ne=>{})}constructor(ne){this.iterate=ne}forEach(ne){this.iterate(re=>(ne(re),!0))}toArray(){const ne=[];return this.iterate(re=>(ne.push(re),!0)),ne}filter(ne){return new me(re=>this.iterate(ye=>ne(ye)?re(ye):!0))}map(ne){return new me(re=>this.iterate(ye=>re(ne(ye))))}some(ne){let re=!1;return this.iterate(ye=>(re=ne(ye),!re)),re}findFirst(ne){let re;return this.iterate(ye=>ne(ye)?(re=ye,!1):!0),re}findLast(ne){let re;return this.iterate(ye=>(ne(ye)&&(re=ye),!0)),re}findLastMaxBy(ne){let re,ye=!0;return this.iterate(oe=>((ye||J.isGreaterThan(ne(oe,re)))&&(ye=!1,re=oe),!0)),re}}e.CallbackIterable=me}),define(Ce[57],De([1,0,8]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function F(_,b){if(!_)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=F;function d(_,b="Unreachable"){throw new Error(b)}e.assertNever=d;function R(_){if(!_)throw new D.BugIndicatingError("Assertion Failed")}e.assert=R;function A(_){if(!_()){debugger;_(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function p(_,b){let T=0;for(;T<_.length-1;){const k=_[T],v=_[T+1];if(!b(k,v))return!1;T++}return!0}e.checkAdjacentItems=p}),define(Ce[75],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function D(F){const d=this;let R=!1,A;return function(){return R||(R=!0,A=F.apply(d,arguments)),A}}e.createSingleCallFunction=D}),define(Ce[119],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class D{constructor(d){this._prefix=d,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=D,e.defaultGenerator=new D("id#")}),define(Ce[50],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(F){function d(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}F.is=d;const R=Object.freeze([]);function A(){return R}F.empty=A;function*p(u){yield u}F.single=p;function _(u){return d(u)?u:p(u)}F.wrap=_;function b(u){return u||R}F.from=b;function*T(u){for(let t=u.length-1;t>=0;t--)yield u[t]}F.reverse=T;function k(u){return!u||u[Symbol.iterator]().next().done===!0}F.isEmpty=k;function v(u){return u[Symbol.iterator]().next().value}F.first=v;function y(u,t){for(const n of u)if(t(n))return!0;return!1}F.some=y;function C(u,t){for(const n of u)if(t(n))return n}F.find=C;function*w(u,t){for(const n of u)t(n)&&(yield n)}F.filter=w;function*s(u,t){let n=0;for(const r of u)yield t(r,n++)}F.map=s;function*o(...u){for(const t of u)for(const n of t)yield n}F.concat=o;function a(u,t,n){let r=n;for(const i of u)r=t(r,i);return r}F.reduce=a;function*c(u,t,n=u.length){for(t<0&&(t+=u.length),n<0?n+=u.length:n>u.length&&(n=u.length);t<n;t++)yield u[t]}F.slice=c;function g(u,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,u];const r=u[Symbol.iterator]();for(let i=0;i<t;i++){const l=r.next();if(l.done)return[n,F.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return r}}]}F.consume=g})(D||(e.Iterable=D={}))}),define(Ce[157],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,n=!1){let r=0;const i=t.length;let l="",f=0,S=16,I=0;function E(U){let x=0,M=0;for(;x<U;){const H=t.charCodeAt(r);if(H>=48&&H<=57)M=M*16+H-48;else if(H>=65&&H<=70)M=M*16+H-65+10;else if(H>=97&&H<=102)M=M*16+H-97+10;else break;r++,x++}return x<U&&(M=-1),M}function h(U){r=U,l="",f=0,S=16,I=0}function m(){const U=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&b(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&b(t.charCodeAt(r)))for(r++;r<t.length&&b(t.charCodeAt(r));)r++;else return I=3,t.substring(U,r);let x=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&b(t.charCodeAt(r))){for(r++;r<t.length&&b(t.charCodeAt(r));)r++;x=r}else I=3;return t.substring(U,x)}function P(){let U="",x=r;for(;;){if(r>=i){U+=t.substring(x,r),I=2;break}const M=t.charCodeAt(r);if(M===34){U+=t.substring(x,r),r++;break}if(M===92){if(U+=t.substring(x,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const j=E(4);j>=0?U+=String.fromCharCode(j):I=4;break}default:I=5}x=r;continue}if(M>=0&&M<=31)if(_(M)){U+=t.substring(x,r),I=2;break}else I=6;r++}return U}function O(){if(l="",I=0,f=r,r>=i)return f=i,S=17;let U=t.charCodeAt(r);if(p(U)){do r++,l+=String.fromCharCode(U),U=t.charCodeAt(r);while(p(U));return S=15}if(_(U))return r++,l+=String.fromCharCode(U),U===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),S=14;switch(U){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,l=P(),S=10;case 47:{const x=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!_(t.charCodeAt(r));)r++;return l=t.substring(x,r),S=12}if(t.charCodeAt(r+1)===42){r+=2;const M=i-1;let H=!1;for(;r<M;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,I=1),l=t.substring(x,r),S=13}return l+=String.fromCharCode(U),r++,S=16}case 45:if(l+=String.fromCharCode(U),r++,r===i||!b(t.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=m(),S=11;default:for(;r<i&&N(U);)r++,U=t.charCodeAt(r);if(f!==r){switch(l=t.substring(f,r),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(U),r++,S=16}}function N(U){if(p(U)||_(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:h,getPosition:()=>r,scan:n?L:O,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>I}}e.createScanner=A;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,n){const r=[],i=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function I(E,h,m,P){f.value=E,f.offset=h,f.length=m,f.type=P,f.colonOffset=void 0,l=f}try{c(t,{onObjectBegin:(E,h)=>{if(n<=E)throw i;l=void 0,S=n>E,r.push("")},onObjectProperty:(E,h,m)=>{if(n<h||(I(E,h,m,"property"),r[r.length-1]=E,n<=h+m))throw i},onObjectEnd:(E,h)=>{if(n<=E)throw i;l=void 0,r.pop()},onArrayBegin:(E,h)=>{if(n<=E)throw i;l=void 0,r.push(0)},onArrayEnd:(E,h)=>{if(n<=E)throw i;l=void 0,r.pop()},onLiteralValue:(E,h,m)=>{if(n<h||(I(E,h,m,u(E)),n<=h+m))throw i},onSeparator:(E,h,m)=>{if(n<=h)throw i;if(E===":"&&l&&l.type==="property")l.colonOffset=h,S=!1,l=void 0;else if(E===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(S=!0,r[r.length-1]=""),l=void 0}}})}catch(E){if(E!==i)throw E}return{path:r,previousNode:l,isAtPropertyKey:S,matches:E=>{let h=0;for(let m=0;h<E.length&&m<r.length;m++)if(E[h]===r[m]||E[h]==="*")h++;else if(E[h]!=="**")return!1;return h===E.length}}}e.getLocation=k;function v(t,n=[],r=R.DEFAULT){let i=null,l=[];const f=[];function S(E){Array.isArray(l)?l.push(E):i!==null&&(l[i]=E)}return c(t,{onObjectBegin:()=>{const E={};S(E),f.push(l),l=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const E=[];S(E),f.push(l),l=E,i=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:S,onError:(E,h,m)=>{n.push({error:E,offset:h,length:m})}},r),l[0]}e.parse=v;function y(t,n=[],r=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function f(E){return i.children.push(E),E}c(t,{onObjectBegin:E=>{i=f({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,h,m)=>{i=f({type:"property",offset:h,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:h,length:m,parent:i})},onObjectEnd:(E,h)=>{i.length=E+h-i.offset,i=i.parent,l(E+h)},onArrayBegin:(E,h)=>{i=f({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,h)=>{i.length=E+h-i.offset,i=i.parent,l(E+h)},onLiteralValue:(E,h,m)=>{f({type:u(E),offset:h,length:m,parent:i,value:E}),l(h+m)},onSeparator:(E,h,m)=>{i.type==="property"&&(E===":"?i.colonOffset=h:E===","&&l(h))},onError:(E,h,m)=>{n.push({error:E,offset:h,length:m})}},r);const I=i.children[0];return I&&delete I.parent,I}e.parseTree=y;function C(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===i){r=f.children[1],l=!0;break}if(!l)return}else{const l=i;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=C;function w(t){if(!t.parent||!t.parent.children)return[];const n=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=w;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=s(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function o(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=o;function a(t,n,r=!1){if(o(t,n,r)){const i=t.children;if(Array.isArray(i))for(let l=0;l<i.length&&i[l].offset<=n;l++){const f=a(i[l],n,r);if(f)return f}return t}}e.findNodeAtOffset=a;function c(t,n,r=R.DEFAULT){const i=A(t,!1);function l(ge){return ge?()=>ge(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(ge){return ge?le=>ge(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const S=l(n.onObjectBegin),I=f(n.onObjectProperty),E=l(n.onObjectEnd),h=l(n.onArrayBegin),m=l(n.onArrayEnd),P=f(n.onLiteralValue),O=f(n.onSeparator),N=l(n.onComment),L=f(n.onError),U=r&&r.disallowComments,x=r&&r.allowTrailingComma;function M(){for(;;){const ge=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:U||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ge){case 12:case 13:U?H(10):N();break;case 16:H(1);break;case 15:case 14:break;default:return ge}}}function H(ge,le=[],we=[]){if(L(ge),le.length+we.length>0){let G=i.getToken();for(;G!==17;){if(le.indexOf(G)!==-1){M();break}else if(we.indexOf(G)!==-1)break;G=M()}}}function j(ge){const le=i.getTokenValue();return ge?P(le):I(le),M(),!0}function fe(){switch(i.getToken()){case 11:{let ge=0;try{ge=JSON.parse(i.getTokenValue()),typeof ge!="number"&&(H(2),ge=0)}catch{H(2)}P(ge);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return M(),!0}function Y(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(O(":"),M(),J()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function X(){S(),M();let ge=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ge||H(4,[],[]),O(","),M(),i.getToken()===2&&x)break}else ge&&H(6,[],[]);Y()||H(4,[],[2,5]),ge=!0}return E(),i.getToken()!==2?H(7,[2],[]):M(),!0}function z(){h(),M();let ge=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ge||H(4,[],[]),O(","),M(),i.getToken()===4&&x)break}else ge&&H(6,[],[]);J()||H(4,[],[4,5]),ge=!0}return m(),i.getToken()!==4?H(8,[4],[]):M(),!0}function J(){switch(i.getToken()){case 3:return z();case 1:return X();case 10:return j(!0);default:return fe()}}return M(),i.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):J()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=c;function g(t,n){const r=A(t),i=[];let l,f=0,S;do switch(S=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:f!==S&&i.push(t.substring(f,S)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),f=r.getPosition();break}while(l!==17);return i.join("")}e.stripComments=g;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Ce[58],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(d){this.executor=d,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(d){this._error=d}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=D}),define(Ce[76],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{static{this.Undefined=new D(void 0)}constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}class F{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let R=this._first;for(;R!==D.Undefined;){const A=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,A){const p=new D(R);if(this._first===D.Undefined)this._first=p,this._last=p;else if(A){const b=this._last;this._last=p,p.prev=b,b.next=p}else{const b=this._first;this._first=p,p.next=b,b.prev=p}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(p))}}shift(){if(this._first!==D.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==D.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===D.Undefined&&R.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):R.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):R.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.LinkedList=F}),define(Ce[28],De([1,0]),function(pe,e){"use strict";var D,F,d;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(a,c,g){let u=a.get(c);return u===void 0&&(u=g,a.set(c,u)),u}e.getOrSet=R;function A(a){const c=[];return a.forEach((g,u)=>{c.push(`${u} => ${g}`)}),`Map(${a.size}) {${c.join(", ")}}`}e.mapToString=A;function p(a){const c=[];return a.forEach(g=>{c.push(g)}),`Set(${a.size}) {${c.join(", ")}}`}e.setToString=p;class _{constructor(c,g){this.uri=c,this.value=g}}function b(a){return Array.isArray(a)}class T{static{this.defaultToKey=c=>c.toString()}constructor(c,g){if(this[D]="ResourceMap",c instanceof T)this.map=new Map(c.map),this.toKey=g??T.defaultToKey;else if(b(c)){this.map=new Map,this.toKey=g??T.defaultToKey;for(const[u,t]of c)this.set(u,t)}else this.map=new Map,this.toKey=c??T.defaultToKey}set(c,g){return this.map.set(this.toKey(c),new _(c,g)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,g){typeof g<"u"&&(c=c.bind(g));for(const[u,t]of this.map)c(t.value,t.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=T;class k{constructor(c,g){this[F]="ResourceSet",!c||typeof c=="function"?this._map=new T(c):(this._map=new T(g),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,g){this._map.forEach((u,t)=>c.call(g,t,t,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=k;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class y{constructor(){this[d]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,g=0){const u=this._map.get(c);if(u)return g!==0&&this.touch(u,g),u.value}set(c,g,u=0){let t=this._map.get(c);if(t)t.value=g,u!==0&&this.touch(t,u);else{switch(t={key:c,value:g,next:void 0,previous:void 0},u){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(c,t),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const g=this._map.get(c);if(g)return this._map.delete(c),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,g){const u=this._state;let t=this._head;for(;t;){if(g?c.bind(g)(t.value,t.key,this):c(t.value,t.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,g=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==g)throw new Error("LinkedMap got modified during iteration.");if(u){const n={value:u.key,done:!1};return u=u.next,n}else return{value:void 0,done:!0}}};return t}values(){const c=this,g=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==g)throw new Error("LinkedMap got modified during iteration.");if(u){const n={value:u.value,done:!1};return u=u.next,n}else return{value:void 0,done:!0}}};return t}entries(){const c=this,g=this._state;let u=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==g)throw new Error("LinkedMap got modified during iteration.");if(u){const n={value:[u.key,u.value],done:!1};return u=u.next,n}else return{value:void 0,done:!0}}};return t}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let g=this._head,u=this.size;for(;g&&u>c;)this._map.delete(g.key),g=g.next,u--;this._head=g,this._size=u,g&&(g.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const g=c.next,u=c.previous;if(!g||!u)throw new Error("Invalid list");g.previous=u,u.next=g}c.next=void 0,c.previous=void 0,this._state++}touch(c,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(c===this._head)return;const u=c.next,t=c.previous;c===this._tail?(t.next=void 0,this._tail=t):(u.previous=t,t.next=u),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(g===2){if(c===this._tail)return;const u=c.next,t=c.previous;c===this._head?(u.previous=void 0,this._head=u):(u.previous=t,t.next=u),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((g,u)=>{c.push([u,g])}),c}fromJSON(c){this.clear();for(const[g,u]of c)this.set(g,u)}}e.LinkedMap=y;class C extends y{constructor(c,g=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,g=2){return super.get(c,g)}peek(c){return super.get(c,0)}set(c,g){return super.set(c,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=C;class w{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let g=this.map.get(c)||0;return g===0?!1:(g--,g===0?this.map.delete(c):this.map.set(c,g),!0)}has(c){return this.map.has(c)}}e.CounterSet=w;class s{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[g,u]of c)this.set(g,u)}clear(){this._m1.clear(),this._m2.clear()}set(c,g){this._m1.set(c,g),this._m2.set(g,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const g=this._m1.get(c);return g===void 0?!1:(this._m1.delete(c),this._m2.delete(g),!0)}forEach(c,g){this._m1.forEach((u,t)=>{c.call(g,u,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=s;class o{constructor(){this.map=new Map}add(c,g){let u=this.map.get(c);u||(u=new Set,this.map.set(c,u)),u.add(g)}delete(c,g){const u=this.map.get(c);u&&(u.delete(g),u.size===0&&this.map.delete(c))}forEach(c,g){const u=this.map.get(c);u&&u.forEach(g)}get(c){const g=this.map.get(c);return g||new Set}}e.SetMap=o}),define(Ce[3],De([1,0,19,74,28,75,50]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const p=!1;let _=null;class b{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(m){let P=this.livingDisposables.get(m);return P||(P={parent:null,source:null,isSingleton:!1,value:m,idx:b.idx++},this.livingDisposables.set(m,P)),P}trackDisposable(m){const P=this.getDisposableData(m);P.source||(P.source=new Error().stack)}setParent(m,P){const O=this.getDisposableData(m);O.parent=P}markAsDisposed(m){this.livingDisposables.delete(m)}markAsSingleton(m){this.getDisposableData(m).isSingleton=!0}getRootParent(m,P){const O=P.get(m);if(O)return O;const N=m.parent?this.getRootParent(this.getDisposableData(m.parent),P):m;return P.set(m,N),N}getTrackedDisposables(){const m=new Map;return[...this.livingDisposables.entries()].filter(([,O])=>O.source!==null&&!this.getRootParent(O,m).isSingleton).map(([O])=>O).flat()}computeLeakingDisposables(m=10,P){let O;if(P)O=P;else{const M=new Map,H=[...this.livingDisposables.values()].filter(fe=>fe.source!==null&&!this.getRootParent(fe,M).isSingleton);if(H.length===0)return;const j=new Set(H.map(fe=>fe.value));if(O=H.filter(fe=>!(fe.parent&&j.has(fe.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function N(M){function H(fe,Y){for(;fe.length>0&&Y.some(X=>typeof X=="string"?X===fe[0]:fe[0].match(X));)fe.shift()}const j=M.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return H(j,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),j.reverse()}const L=new d.SetMap;for(const M of O){const H=N(M);for(let j=0;j<=H.length;j++)L.add(H.slice(0,j).join(`
`),M)}O.sort((0,D.compareBy)(M=>M.idx,D.numberComparator));let U="",x=0;for(const M of O.slice(0,m)){x++;const H=N(M),j=[];for(let fe=0;fe<H.length;fe++){let Y=H[fe];Y=`(shared with ${L.get(H.slice(0,fe+1).join(`
`)).size}/${O.length} leaks) at ${Y}`;const z=L.get(H.slice(0,fe).join(`
`)),J=(0,F.groupBy)([...z].map(ge=>N(ge)[fe]),ge=>ge);delete J[H[fe]];for(const[ge,le]of Object.entries(J))j.unshift(`    - stacktraces of ${le.length} other leaks continue with ${ge}`);j.unshift(Y)}U+=`


==================== Leaking disposable ${x}/${O.length}: ${M.value.constructor.name} ====================
${j.join(`
`)}
============================================================

`}return O.length>m&&(U+=`


... and ${O.length-m} more leaking disposables

`),{leaks:O,details:U}}}e.DisposableTracker=b;function T(h){_=h}if(e.setDisposableTracker=T,p){const h="__is_disposable_tracked__";T(new class{trackDisposable(m){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[h]||console.log(P)},3e3)}setParent(m,P){if(m&&m!==t.None)try{m[h]=!0}catch{}}markAsDisposed(m){if(m&&m!==t.None)try{m[h]=!0}catch{}}markAsSingleton(m){}})}function k(h){return _?.trackDisposable(h),h}e.trackDisposable=k;function v(h){_?.markAsDisposed(h)}e.markAsDisposed=v;function y(h,m){_?.setParent(h,m)}function C(h,m){if(_)for(const P of h)_.setParent(P,m)}function w(h){return _?.markAsSingleton(h),h}e.markAsSingleton=w;function s(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=s;function o(h){if(A.Iterable.is(h)){const m=[];for(const P of h)if(P)try{P.dispose()}catch(O){m.push(O)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.dispose=o;function a(h){for(const m of h)s(m)&&m.dispose();return[]}e.disposeIfDisposable=a;function c(...h){const m=g(()=>o(h));return C(h,m),m}e.combinedDisposable=c;function g(h){const m=k({dispose:(0,R.createSingleCallFunction)(()=>{v(m),h()})});return m}e.toDisposable=g;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return y(m,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(m),m.dispose()}}deleteAndLeak(m){m&&this._toDispose.has(m)&&(this._toDispose.delete(m),y(m,null))}}e.DisposableStore=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new u,k(this),y(this._store,this)}dispose(){v(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=t;class n{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&y(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&y(m,null),m}}e.MutableDisposable=n;class r{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(m){let P=m;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,v(this))},this}}e.SafeDisposable=i;class l{constructor(){this.references=new Map}acquire(m,...P){let O=this.references.get(m);O||(O={counter:0,object:this.createReferencedObject(m,...P)},this.references.set(m,O));const{object:N}=O,L=(0,R.createSingleCallFunction)(()=>{--O.counter===0&&(this.destroyReferencedObject(m,O.object),this.references.delete(m))});return O.counter++,{object:N,dispose:L}}}e.ReferenceCollection=l;class f{constructor(m){this.referenceCollection=m}async acquire(m,...P){const O=this.referenceCollection.acquire(m,...P);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(N){throw O.dispose(),N}}}e.AsyncReferenceCollection=f;class S{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=S;function I(h){const m=new u;try{h(m)}finally{m.dispose()}}e.disposeOnReturn=I;class E{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}has(m){return this._store.has(m)}get size(){return this._store.size}get(m){return this._store.get(m)}set(m,P,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(m)?.dispose(),this._store.set(m,P)}deleteAndDispose(m){this._store.get(m)?.dispose(),this._store.delete(m)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=E}),function(pe,e){typeof define=="function"&&define.amd?define(Ce[158],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(ne,re){for(var ye=0;ye<re.length;ye++){var oe=re[ye];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ne,oe.key,oe)}}function D(ne,re,ye){return re&&e(ne.prototype,re),ye&&e(ne,ye),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function F(ne,re){if(ne){if(typeof ne=="string")return d(ne,re);var ye=Object.prototype.toString.call(ne).slice(8,-1);if(ye==="Object"&&ne.constructor&&(ye=ne.constructor.name),ye==="Map"||ye==="Set")return Array.from(ne);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return d(ne,re)}}function d(ne,re){(re==null||re>ne.length)&&(re=ne.length);for(var ye=0,oe=new Array(re);ye<re;ye++)oe[ye]=ne[ye];return oe}function R(ne,re){var ye=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(ye)return(ye=ye.call(ne)).next.bind(ye);if(Array.isArray(ne)||(ye=F(ne))||re&&ne&&typeof ne.length=="number"){ye&&(ne=ye);var oe=0;return function(){return oe>=ne.length?{done:!0}:{done:!1,value:ne[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=A();function p(ne){pe.defaults=ne}var _=/[&<>"']/,b=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return v[re]};function C(ne,re){if(re){if(_.test(ne))return ne.replace(b,y)}else if(T.test(ne))return ne.replace(k,y);return ne}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ne){return ne.replace(w,function(re,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var o=/(^|[^\[])\^/g;function a(ne,re){ne=typeof ne=="string"?ne:ne.source,re=re||"";var ye={replace:function(de,ee){return ee=ee.source||ee,ee=ee.replace(o,"$1"),ne=ne.replace(de,ee),ye},getRegex:function(){return new RegExp(ne,re)}};return ye}var c=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ne,re,ye){if(ne){var oe;try{oe=decodeURIComponent(s(ye)).replace(c,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}re&&!g.test(ye)&&(ye=l(re,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ne,re){t[" "+ne]||(n.test(ne)?t[" "+ne]=ne+"/":t[" "+ne]=E(ne,"/",!0)),ne=t[" "+ne];var ye=ne.indexOf(":")===-1;return re.substring(0,2)==="//"?ye?re:ne.replace(r,"$1")+re:re.charAt(0)==="/"?ye?re:ne.replace(i,"$1")+re:ne+re}var f={exec:function(){}};function S(ne){for(var re=1,ye,oe;re<arguments.length;re++){ye=arguments[re];for(oe in ye)Object.prototype.hasOwnProperty.call(ye,oe)&&(ne[oe]=ye[oe])}return ne}function I(ne,re){var ye=ne.replace(/\|/g,function(ee,ue,ve){for(var ke=!1,$=ue;--$>=0&&ve[$]==="\\";)ke=!ke;return ke?"|":" |"}),oe=ye.split(/ \|/),de=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>re)oe.splice(re);else for(;oe.length<re;)oe.push("");for(;de<oe.length;de++)oe[de]=oe[de].trim().replace(/\\\|/g,"|");return oe}function E(ne,re,ye){var oe=ne.length;if(oe===0)return"";for(var de=0;de<oe;){var ee=ne.charAt(oe-de-1);if(ee===re&&!ye)de++;else if(ee!==re&&ye)de++;else break}return ne.slice(0,oe-de)}function h(ne,re){if(ne.indexOf(re[1])===-1)return-1;for(var ye=ne.length,oe=0,de=0;de<ye;de++)if(ne[de]==="\\")de++;else if(ne[de]===re[0])oe++;else if(ne[de]===re[1]&&(oe--,oe<0))return de;return-1}function m(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ne,re){if(re<1)return"";for(var ye="";re>1;)re&1&&(ye+=ne),re>>=1,ne+=ne;return ye+ne}function O(ne,re,ye,oe){var de=re.href,ee=re.title?C(re.title):null,ue=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){oe.state.inLink=!0;var ve={type:"link",raw:ye,href:de,title:ee,text:ue,tokens:oe.inlineTokens(ue)};return oe.state.inLink=!1,ve}return{type:"image",raw:ye,href:de,title:ee,text:C(ue)}}function N(ne,re){var ye=ne.match(/^(\s+)(?:```)/);if(ye===null)return re;var oe=ye[1];return re.split(`
`).map(function(de){var ee=de.match(/^\s+/);if(ee===null)return de;var ue=ee[0];return ue.length>=oe.length?de.slice(oe.length):de}).join(`
`)}var L=function(){function ne(ye){this.options=ye||pe.defaults}var re=ne.prototype;return re.space=function(oe){var de=this.rules.block.newline.exec(oe);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},re.code=function(oe){var de=this.rules.block.code.exec(oe);if(de){var ee=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:E(ee,`
`)}}},re.fences=function(oe){var de=this.rules.block.fences.exec(oe);if(de){var ee=de[0],ue=N(ee,de[3]||"");return{type:"code",raw:ee,lang:de[2]?de[2].trim():de[2],text:ue}}},re.heading=function(oe){var de=this.rules.block.heading.exec(oe);if(de){var ee=de[2].trim();if(/#$/.test(ee)){var ue=E(ee,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(ee=ue.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ee,tokens:this.lexer.inline(ee)}}},re.hr=function(oe){var de=this.rules.block.hr.exec(oe);if(de)return{type:"hr",raw:de[0]}},re.blockquote=function(oe){var de=this.rules.block.blockquote.exec(oe);if(de){var ee=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},re.list=function(oe){var de=this.rules.block.list.exec(oe);if(de){var ee,ue,ve,ke,$,K,ie,se,Q,he,Se,Ue,We=de[1].trim(),Ze=We.length>1,Qe={type:"list",raw:"",ordered:Ze,start:Ze?+We.slice(0,-1):"",loose:!1,items:[]};We=Ze?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=Ze?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(Ue=!1,!(!(de=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=de[0],oe=oe.substring(ee.length),se=de[2].split(`
`,1)[0],Q=oe.split(`
`,1)[0],this.options.pedantic?(ke=2,Se=se.trimLeft()):(ke=de[2].search(/[^ ]/),ke=ke>4?1:ke,Se=se.slice(ke),ke+=de[1].length),K=!1,!se&&/^ *$/.test(Q)&&(ee+=Q+`
`,oe=oe.substring(Q.length+1),Ue=!0),!Ue)for(var et=new RegExp("^ {0,"+Math.min(3,ke-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Te=new RegExp("^ {0,"+Math.min(3,ke-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,ke-1)+"}(?:```|~~~)"),ze=new RegExp("^ {0,"+Math.min(3,ke-1)+"}#");oe&&(he=oe.split(`
`,1)[0],se=he,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(se)||ze.test(se)||et.test(se)||Te.test(oe)));){if(se.search(/[^ ]/)>=ke||!se.trim())Se+=`
`+se.slice(ke);else if(!K)Se+=`
`+se;else break;!K&&!se.trim()&&(K=!0),ee+=he+`
`,oe=oe.substring(he.length+1)}Qe.loose||(ie?Qe.loose=!0:/\n *\n *$/.test(ee)&&(ie=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(Se),ue&&(ve=ue[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ee,task:!!ue,checked:ve,loose:!1,text:Se}),Qe.raw+=ee}Qe.items[Qe.items.length-1].raw=ee.trimRight(),Qe.items[Qe.items.length-1].text=Se.trimRight(),Qe.raw=Qe.raw.trimRight();var Re=Qe.items.length;for($=0;$<Re;$++){this.lexer.state.top=!1,Qe.items[$].tokens=this.lexer.blockTokens(Qe.items[$].text,[]);var Xe=Qe.items[$].tokens.filter(function(ae){return ae.type==="space"}),ce=Xe.every(function(ae){for(var Ie=ae.raw.split(""),He=0,Be=R(Ie),Ye;!(Ye=Be()).done;){var rt=Ye.value;if(rt===`
`&&(He+=1),He>1)return!0}return!1});!Qe.loose&&Xe.length&&ce&&(Qe.loose=!0,Qe.items[$].loose=!0)}return Qe}},re.html=function(oe){var de=this.rules.block.html.exec(oe);if(de){var ee={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(de[0]):C(de[0]);ee.type="paragraph",ee.text=ue,ee.tokens=this.lexer.inline(ue)}return ee}},re.def=function(oe){var de=this.rules.block.def.exec(oe);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ee=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:de[0],href:de[2],title:de[3]}}},re.table=function(oe){var de=this.rules.block.table.exec(oe);if(de){var ee={type:"table",header:I(de[1]).map(function(ie){return{text:ie}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=de[0];var ue=ee.align.length,ve,ke,$,K;for(ve=0;ve<ue;ve++)/^ *-+: *$/.test(ee.align[ve])?ee.align[ve]="right":/^ *:-+: *$/.test(ee.align[ve])?ee.align[ve]="center":/^ *:-+ *$/.test(ee.align[ve])?ee.align[ve]="left":ee.align[ve]=null;for(ue=ee.rows.length,ve=0;ve<ue;ve++)ee.rows[ve]=I(ee.rows[ve],ee.header.length).map(function(ie){return{text:ie}});for(ue=ee.header.length,ke=0;ke<ue;ke++)ee.header[ke].tokens=this.lexer.inline(ee.header[ke].text);for(ue=ee.rows.length,ke=0;ke<ue;ke++)for(K=ee.rows[ke],$=0;$<K.length;$++)K[$].tokens=this.lexer.inline(K[$].text);return ee}}},re.lheading=function(oe){var de=this.rules.block.lheading.exec(oe);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},re.paragraph=function(oe){var de=this.rules.block.paragraph.exec(oe);if(de){var ee=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ee,tokens:this.lexer.inline(ee)}}},re.text=function(oe){var de=this.rules.block.text.exec(oe);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},re.escape=function(oe){var de=this.rules.inline.escape.exec(oe);if(de)return{type:"escape",raw:de[0],text:C(de[1])}},re.tag=function(oe){var de=this.rules.inline.tag.exec(oe);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):C(de[0]):de[0]}},re.link=function(oe){var de=this.rules.inline.link.exec(oe);if(de){var ee=de[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ue=E(ee.slice(0,-1),"\\");if((ee.length-ue.length)%2===0)return}else{var ve=h(de[2],"()");if(ve>-1){var ke=de[0].indexOf("!")===0?5:4,$=ke+de[1].length+ve;de[2]=de[2].substring(0,ve),de[0]=de[0].substring(0,$).trim(),de[3]=""}}var K=de[2],ie="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);se&&(K=se[1],ie=se[3])}else ie=de[3]?de[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(ee)?K=K.slice(1):K=K.slice(1,-1)),O(de,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:ie&&ie.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},re.reflink=function(oe,de){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var ue=(ee[2]||ee[1]).replace(/\s+/g," ");if(ue=de[ue.toLowerCase()],!ue||!ue.href){var ve=ee[0].charAt(0);return{type:"text",raw:ve,text:ve}}return O(ee,ue,ee[0],this.lexer)}},re.emStrong=function(oe,de,ee){ee===void 0&&(ee="");var ue=this.rules.inline.emStrong.lDelim.exec(oe);if(ue&&!(ue[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ve=ue[1]||ue[2]||"";if(!ve||ve&&(ee===""||this.rules.inline.punctuation.exec(ee))){var ke=ue[0].length-1,$,K,ie=ke,se=0,Q=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Q.lastIndex=0,de=de.slice(-1*oe.length+ke);(ue=Q.exec(de))!=null;)if($=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!$){if(K=$.length,ue[3]||ue[4]){ie+=K;continue}else if((ue[5]||ue[6])&&ke%3&&!((ke+K)%3)){se+=K;continue}if(ie-=K,!(ie>0)){if(K=Math.min(K,K+ie+se),Math.min(ke,K)%2){var he=oe.slice(1,ke+ue.index+K);return{type:"em",raw:oe.slice(0,ke+ue.index+K+1),text:he,tokens:this.lexer.inlineTokens(he)}}var Se=oe.slice(2,ke+ue.index+K-1);return{type:"strong",raw:oe.slice(0,ke+ue.index+K+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},re.codespan=function(oe){var de=this.rules.inline.code.exec(oe);if(de){var ee=de[2].replace(/\n/g," "),ue=/[^ ]/.test(ee),ve=/^ /.test(ee)&&/ $/.test(ee);return ue&&ve&&(ee=ee.substring(1,ee.length-1)),ee=C(ee,!0),{type:"codespan",raw:de[0],text:ee}}},re.br=function(oe){var de=this.rules.inline.br.exec(oe);if(de)return{type:"br",raw:de[0]}},re.del=function(oe){var de=this.rules.inline.del.exec(oe);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},re.autolink=function(oe,de){var ee=this.rules.inline.autolink.exec(oe);if(ee){var ue,ve;return ee[2]==="@"?(ue=C(this.options.mangle?de(ee[1]):ee[1]),ve="mailto:"+ue):(ue=C(ee[1]),ve=ue),{type:"link",raw:ee[0],text:ue,href:ve,tokens:[{type:"text",raw:ue,text:ue}]}}},re.url=function(oe,de){var ee;if(ee=this.rules.inline.url.exec(oe)){var ue,ve;if(ee[2]==="@")ue=C(this.options.mangle?de(ee[0]):ee[0]),ve="mailto:"+ue;else{var ke;do ke=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(ke!==ee[0]);ue=C(ee[0]),ee[1]==="www."?ve="http://"+ue:ve=ue}return{type:"link",raw:ee[0],text:ue,href:ve,tokens:[{type:"text",raw:ue,text:ue}]}}},re.inlineText=function(oe,de){var ee=this.rules.inline.text.exec(oe);if(ee){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):C(ee[0]):ee[0]:ue=C(this.options.smartypants?de(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},ne}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=a(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=a(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=a(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=a(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=a(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=S({},U),U.gfm=S({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=a(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=S({},U.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:a(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var x={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};x._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",x.punctuation=a(x.punctuation).replace(/punctuation/g,x._punctuation).getRegex(),x.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,x.escapedEmSt=/\\\*|\\_/g,x._comment=a(U._comment).replace("(?:-->|$)","-->").getRegex(),x.emStrong.lDelim=a(x.emStrong.lDelim).replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimAst=a(x.emStrong.rDelimAst,"g").replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimUnd=a(x.emStrong.rDelimUnd,"g").replace(/punct/g,x._punctuation).getRegex(),x._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,x._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,x._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,x.autolink=a(x.autolink).replace("scheme",x._scheme).replace("email",x._email).getRegex(),x._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,x.tag=a(x.tag).replace("comment",x._comment).replace("attribute",x._attribute).getRegex(),x._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,x._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,x._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,x.link=a(x.link).replace("label",x._label).replace("href",x._href).replace("title",x._title).getRegex(),x.reflink=a(x.reflink).replace("label",x._label).replace("ref",U._label).getRegex(),x.nolink=a(x.nolink).replace("ref",U._label).getRegex(),x.reflinkSearch=a(x.reflinkSearch,"g").replace("reflink",x.reflink).replace("nolink",x.nolink).getRegex(),x.normal=S({},x),x.pedantic=S({},x.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",x._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",x._label).getRegex()}),x.gfm=S({},x.normal,{escape:a(x.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),x.gfm.url=a(x.gfm.url,"i").replace("email",x.gfm._extended_email).getRegex(),x.breaks=S({},x.gfm,{br:a(x.br).replace("{2,}","*").getRegex(),text:a(x.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(ne){var re="",ye,oe,de=ne.length;for(ye=0;ye<de;ye++)oe=ne.charCodeAt(ye),Math.random()>.5&&(oe="x"+oe.toString(16)),re+="&#"+oe+";";return re}var j=function(){function ne(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||pe.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:U.normal,inline:x.normal};this.options.pedantic?(oe.block=U.pedantic,oe.inline=x.pedantic):this.options.gfm&&(oe.block=U.gfm,this.options.breaks?oe.inline=x.breaks:oe.inline=x.gfm),this.tokenizer.rules=oe}ne.lex=function(oe,de){var ee=new ne(de);return ee.lex(oe)},ne.lexInline=function(oe,de){var ee=new ne(de);return ee.inlineTokens(oe)};var re=ne.prototype;return re.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},re.blockTokens=function(oe,de){var ee=this;de===void 0&&(de=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(ie,se,Q){return se+"    ".repeat(Q.length)});for(var ue,ve,ke,$;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ie){return(ue=ie.call({lexer:ee},oe,de))?(oe=oe.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.space(oe)){oe=oe.substring(ue.raw.length),ue.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ue);continue}if(ue=this.tokenizer.code(oe)){oe=oe.substring(ue.raw.length),ve=de[de.length-1],ve&&(ve.type==="paragraph"||ve.type==="text")?(ve.raw+=`
`+ue.raw,ve.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=ve.text):de.push(ue);continue}if(ue=this.tokenizer.fences(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.heading(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.hr(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.blockquote(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.list(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.html(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.def(oe)){oe=oe.substring(ue.raw.length),ve=de[de.length-1],ve&&(ve.type==="paragraph"||ve.type==="text")?(ve.raw+=`
`+ue.raw,ve.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=ve.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.lheading(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ke=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var ie=1/0,se=oe.slice(1),Q=void 0;ee.options.extensions.startBlock.forEach(function(he){Q=he.call({lexer:this},se),typeof Q=="number"&&Q>=0&&(ie=Math.min(ie,Q))}),ie<1/0&&ie>=0&&(ke=oe.substring(0,ie+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(ke))){ve=de[de.length-1],$&&ve.type==="paragraph"?(ve.raw+=`
`+ue.raw,ve.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ve.text):de.push(ue),$=ke.length!==oe.length,oe=oe.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(oe)){oe=oe.substring(ue.raw.length),ve=de[de.length-1],ve&&ve.type==="text"?(ve.raw+=`
`+ue.raw,ve.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ve.text):de.push(ue);continue}if(oe){var K="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,de},re.inline=function(oe,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:oe,tokens:de}),de},re.inlineTokens=function(oe,de){var ee=this;de===void 0&&(de=[]);var ue,ve,ke,$=oe,K,ie,se;if(this.tokens.links){var Q=Object.keys(this.tokens.links);if(Q.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec($))!=null;)Q.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&($=$.slice(0,K.index)+"["+P("a",K[0].length-2)+"]"+$.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec($))!=null;)$=$.slice(0,K.index)+"["+P("a",K[0].length-2)+"]"+$.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec($))!=null;)$=$.slice(0,K.index)+"++"+$.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(ie||(se=""),ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(ue=Se.call({lexer:ee},oe,de))?(oe=oe.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.tag(oe)){oe=oe.substring(ue.raw.length),ve=de[de.length-1],ve&&ue.type==="text"&&ve.type==="text"?(ve.raw+=ue.raw,ve.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.link(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ue.raw.length),ve=de[de.length-1],ve&&ue.type==="text"&&ve.type==="text"?(ve.raw+=ue.raw,ve.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.emStrong(oe,$,se)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.codespan(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.br(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.del(oe)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.autolink(oe,H)){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(oe,H))){oe=oe.substring(ue.raw.length),de.push(ue);continue}if(ke=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,Ue=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(Ze){We=Ze.call({lexer:this},Ue),typeof We=="number"&&We>=0&&(Se=Math.min(Se,We))}),Se<1/0&&Se>=0&&(ke=oe.substring(0,Se+1))}(),ue=this.tokenizer.inlineText(ke,M)){oe=oe.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(se=ue.raw.slice(-1)),ie=!0,ve=de[de.length-1],ve&&ve.type==="text"?(ve.raw+=ue.raw,ve.text+=ue.text):de.push(ue);continue}if(oe){var he="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return de},D(ne,null,[{key:"rules",get:function(){return{block:U,inline:x}}}]),ne}(),fe=function(){function ne(ye){this.options=ye||pe.defaults}var re=ne.prototype;return re.code=function(oe,de,ee){var ue=(de||"").match(/\S*/)[0];if(this.options.highlight){var ve=this.options.highlight(oe,ue);ve!=null&&ve!==oe&&(ee=!0,oe=ve)}return oe=oe.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+C(ue,!0)+'">'+(ee?oe:C(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:C(oe,!0))+`</code></pre>
`},re.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},re.html=function(oe){return oe},re.heading=function(oe,de,ee,ue){if(this.options.headerIds){var ve=this.options.headerPrefix+ue.slug(ee);return"<h"+de+' id="'+ve+'">'+oe+"</h"+de+`>
`}return"<h"+de+">"+oe+"</h"+de+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(oe,de,ee){var ue=de?"ol":"ul",ve=de&&ee!==1?' start="'+ee+'"':"";return"<"+ue+ve+`>
`+oe+"</"+ue+`>
`},re.listitem=function(oe){return"<li>"+oe+`</li>
`},re.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(oe){return"<p>"+oe+`</p>
`},re.table=function(oe,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+de+`</table>
`},re.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},re.tablecell=function(oe,de){var ee=de.header?"th":"td",ue=de.align?"<"+ee+' align="'+de.align+'">':"<"+ee+">";return ue+oe+("</"+ee+`>
`)},re.strong=function(oe){return"<strong>"+oe+"</strong>"},re.em=function(oe){return"<em>"+oe+"</em>"},re.codespan=function(oe){return"<code>"+oe+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(oe){return"<del>"+oe+"</del>"},re.link=function(oe,de,ee){if(oe=u(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var ue='<a href="'+C(oe)+'"';return de&&(ue+=' title="'+de+'"'),ue+=">"+ee+"</a>",ue},re.image=function(oe,de,ee){if(oe=u(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var ue='<img src="'+oe+'" alt="'+ee+'"';return de&&(ue+=' title="'+de+'"'),ue+=this.options.xhtml?"/>":">",ue},re.text=function(oe){return oe},ne}(),Y=function(){function ne(){}var re=ne.prototype;return re.strong=function(oe){return oe},re.em=function(oe){return oe},re.codespan=function(oe){return oe},re.del=function(oe){return oe},re.html=function(oe){return oe},re.text=function(oe){return oe},re.link=function(oe,de,ee){return""+ee},re.image=function(oe,de,ee){return""+ee},re.br=function(){return""},ne}(),X=function(){function ne(){this.seen={}}var re=ne.prototype;return re.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(oe,de){var ee=oe,ue=0;if(this.seen.hasOwnProperty(ee)){ue=this.seen[oe];do ue++,ee=oe+"-"+ue;while(this.seen.hasOwnProperty(ee))}return de||(this.seen[oe]=ue,this.seen[ee]=0),ee},re.slug=function(oe,de){de===void 0&&(de={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,de.dryrun)},ne}(),z=function(){function ne(ye){this.options=ye||pe.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new X}ne.parse=function(oe,de){var ee=new ne(de);return ee.parse(oe)},ne.parseInline=function(oe,de){var ee=new ne(de);return ee.parseInline(oe)};var re=ne.prototype;return re.parse=function(oe,de){de===void 0&&(de=!0);var ee="",ue,ve,ke,$,K,ie,se,Q,he,Se,Ue,We,Ze,Qe,it,et,Te,Oe,ze,Re=oe.length;for(ue=0;ue<Re;ue++){if(Se=oe[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(ze=this.options.extensions.renderers[Se.type].call({parser:this},Se),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){ee+=ze||"";continue}switch(Se.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,s(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(Q="",se="",$=Se.header.length,ve=0;ve<$;ve++)se+=this.renderer.tablecell(this.parseInline(Se.header[ve].tokens),{header:!0,align:Se.align[ve]});for(Q+=this.renderer.tablerow(se),he="",$=Se.rows.length,ve=0;ve<$;ve++){for(ie=Se.rows[ve],se="",K=ie.length,ke=0;ke<K;ke++)se+=this.renderer.tablecell(this.parseInline(ie[ke].tokens),{header:!1,align:Se.align[ke]});he+=this.renderer.tablerow(se)}ee+=this.renderer.table(Q,he);continue}case"blockquote":{he=this.parse(Se.tokens),ee+=this.renderer.blockquote(he);continue}case"list":{for(Ue=Se.ordered,We=Se.start,Ze=Se.loose,$=Se.items.length,he="",ve=0;ve<$;ve++)it=Se.items[ve],et=it.checked,Te=it.task,Qe="",it.task&&(Oe=this.renderer.checkbox(et),Ze?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Qe+=Oe),Qe+=this.parse(it.tokens,Ze),he+=this.renderer.listitem(Qe,Te,et);ee+=this.renderer.list(he,Ue,We);continue}case"html":{ee+=this.renderer.html(Se.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(he=Se.tokens?this.parseInline(Se.tokens):Se.text;ue+1<Re&&oe[ue+1].type==="text";)Se=oe[++ue],he+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);ee+=de?this.renderer.paragraph(he):he;continue}default:{var Xe='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ee},re.parseInline=function(oe,de){de=de||this.renderer;var ee="",ue,ve,ke,$=oe.length;for(ue=0;ue<$;ue++){if(ve=oe[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(ke=this.options.extensions.renderers[ve.type].call({parser:this},ve),ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ve.type))){ee+=ke||"";continue}switch(ve.type){case"escape":{ee+=de.text(ve.text);break}case"html":{ee+=de.html(ve.text);break}case"link":{ee+=de.link(ve.href,ve.title,this.parseInline(ve.tokens,de));break}case"image":{ee+=de.image(ve.href,ve.title,ve.text);break}case"strong":{ee+=de.strong(this.parseInline(ve.tokens,de));break}case"em":{ee+=de.em(this.parseInline(ve.tokens,de));break}case"codespan":{ee+=de.codespan(ve.text);break}case"br":{ee+=de.br();break}case"del":{ee+=de.del(this.parseInline(ve.tokens,de));break}case"text":{ee+=de.text(ve.text);break}default:{var K='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return ee},ne}();function J(ne,re,ye){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof re=="function"&&(ye=re,re=null),re=S({},J.defaults,re||{}),m(re),ye){var oe=re.highlight,de;try{de=j.lex(ne,re)}catch($){return ye($)}var ee=function(K){var ie;if(!K)try{re.walkTokens&&J.walkTokens(de,re.walkTokens),ie=z.parse(de,re)}catch(se){K=se}return re.highlight=oe,K?ye(K):ye(null,ie)};if(!oe||oe.length<3||(delete re.highlight,!de.length))return ee();var ue=0;J.walkTokens(de,function($){$.type==="code"&&(ue++,setTimeout(function(){oe($.text,$.lang,function(K,ie){if(K)return ee(K);ie!=null&&ie!==$.text&&($.text=ie,$.escaped=!0),ue--,ue===0&&ee()})},0))}),ue===0&&ee();return}function ve($){if($.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+C($.message+"",!0)+"</pre>";throw $}try{var ke=j.lex(ne,re);if(re.walkTokens){if(re.async)return Promise.all(J.walkTokens(ke,re.walkTokens)).then(function(){return z.parse(ke,re)}).catch(ve);J.walkTokens(ke,re.walkTokens)}return z.parse(ke,re)}catch($){ve($)}}J.options=J.setOptions=function(ne){return S(J.defaults,ne),p(J.defaults),J},J.getDefaults=A,J.defaults=pe.defaults,J.use=function(){for(var ne=arguments.length,re=new Array(ne),ye=0;ye<ne;ye++)re[ye]=arguments[ye];var oe=S.apply(void 0,[{}].concat(re)),de=J.defaults.extensions||{renderers:{},childTokens:{}},ee;re.forEach(function(ue){if(ue.extensions&&(ee=!0,ue.extensions.forEach(function(ke){if(!ke.name)throw new Error("extension name required");if(ke.renderer){var $=de.renderers?de.renderers[ke.name]:null;$?de.renderers[ke.name]=function(){for(var K=arguments.length,ie=new Array(K),se=0;se<K;se++)ie[se]=arguments[se];var Q=ke.renderer.apply(this,ie);return Q===!1&&(Q=$.apply(this,ie)),Q}:de.renderers[ke.name]=ke.renderer}if(ke.tokenizer){if(!ke.level||ke.level!=="block"&&ke.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[ke.level]?de[ke.level].unshift(ke.tokenizer):de[ke.level]=[ke.tokenizer],ke.start&&(ke.level==="block"?de.startBlock?de.startBlock.push(ke.start):de.startBlock=[ke.start]:ke.level==="inline"&&(de.startInline?de.startInline.push(ke.start):de.startInline=[ke.start]))}ke.childTokens&&(de.childTokens[ke.name]=ke.childTokens)})),ue.renderer&&function(){var ke=J.defaults.renderer||new fe,$=function(se){var Q=ke[se];ke[se]=function(){for(var he=arguments.length,Se=new Array(he),Ue=0;Ue<he;Ue++)Se[Ue]=arguments[Ue];var We=ue.renderer[se].apply(ke,Se);return We===!1&&(We=Q.apply(ke,Se)),We}};for(var K in ue.renderer)$(K);oe.renderer=ke}(),ue.tokenizer&&function(){var ke=J.defaults.tokenizer||new L,$=function(se){var Q=ke[se];ke[se]=function(){for(var he=arguments.length,Se=new Array(he),Ue=0;Ue<he;Ue++)Se[Ue]=arguments[Ue];var We=ue.tokenizer[se].apply(ke,Se);return We===!1&&(We=Q.apply(ke,Se)),We}};for(var K in ue.tokenizer)$(K);oe.tokenizer=ke}(),ue.walkTokens){var ve=J.defaults.walkTokens;oe.walkTokens=function(ke){var $=[];return $.push(ue.walkTokens.call(this,ke)),ve&&($=$.concat(ve.call(this,ke))),$}}ee&&(oe.extensions=de),J.setOptions(oe)})},J.walkTokens=function(ne,re){for(var ye=[],oe=function(){var ve=ee.value;switch(ye=ye.concat(re.call(J,ve)),ve.type){case"table":{for(var ke=R(ve.header),$;!($=ke()).done;){var K=$.value;ye=ye.concat(J.walkTokens(K.tokens,re))}for(var ie=R(ve.rows),se;!(se=ie()).done;)for(var Q=se.value,he=R(Q),Se;!(Se=he()).done;){var Ue=Se.value;ye=ye.concat(J.walkTokens(Ue.tokens,re))}break}case"list":{ye=ye.concat(J.walkTokens(ve.items,re));break}default:J.defaults.extensions&&J.defaults.extensions.childTokens&&J.defaults.extensions.childTokens[ve.type]?J.defaults.extensions.childTokens[ve.type].forEach(function(We){ye=ye.concat(J.walkTokens(ve[We],re))}):ve.tokens&&(ye=ye.concat(J.walkTokens(ve.tokens,re)))}},de=R(ne),ee;!(ee=de()).done;)oe();return ye},J.parseInline=function(ne,re){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");re=S({},J.defaults,re||{}),m(re);try{var ye=j.lexInline(ne,re);return re.walkTokens&&J.walkTokens(ye,re.walkTokens),z.parseInline(ye,re)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+C(oe.message+"",!0)+"</pre>";throw oe}},J.Parser=z,J.parser=z.parse,J.Renderer=fe,J.TextRenderer=Y,J.Lexer=j,J.lexer=j.lex,J.Tokenizer=L,J.Slugger=X,J.parse=J;var ge=J.options,le=J.setOptions,we=J.use,G=J.walkTokens,B=J.parseInline,V=J,me=z.parse,Z=j.lex;pe.Lexer=j,pe.Parser=z,pe.Renderer=fe,pe.Slugger=X,pe.TextRenderer=Y,pe.Tokenizer=L,pe.getDefaults=A,pe.lexer=Z,pe.marked=J,pe.options=ge,pe.parse=V,pe.parseInline=B,pe.parser=me,pe.setOptions=le,pe.use=we,pe.walkTokens=G,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Ce[77],De([1,0,28]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new D.LRUCache(1e4);function d(b){return _(b,"NFC",F)}e.normalizeNFC=d;const R=new D.LRUCache(1e4);function A(b){return _(b,"NFD",R)}e.normalizeNFD=A;const p=/[^\u0000-\u0080]/;function _(b,T,k){if(!b)return b;const v=k.get(b);if(v)return v;let y;return p.test(b)?y=b.normalize(T):y=b,k.set(b,y),y}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(T){return A(T).replace(b,"")}}()}),define(Ce[120],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function D(p,_,b){return Math.min(Math.max(p,_),b)}e.clamp=D;function F(p,_){return(_+p%_)%_}e.rot=F;class d{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=d;class R{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class A{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const b=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=b,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function pe(d){const R=[];typeof d=="number"&&R.push("code/timeOrigin",d);function A(_){R.push(_,Date.now())}function p(){const _=[];for(let b=0;b<R.length;b+=2)_.push({name:R[b],startTime:R[b+1]});return _}return{mark:A,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(d+A.startTime)});return R}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function D(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=D(F))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var F in D)(typeof exports=="object"?exports:pe)[F]=D[F]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function D(F){if(e[F])return e[F].exports;var d=e[F]={i:F,l:!1,exports:{}};return pe[F].call(d.exports,d,d.exports,D),d.l=!0,d.exports}return D.m=pe,D.c=e,D.d=function(F,d,R){D.o(F,d)||Object.defineProperty(F,d,{enumerable:!0,get:R})},D.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},D.t=function(F,d){if(1&d&&(F=D(F)),8&d||4&d&&typeof F=="object"&&F&&F.__esModule)return F;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:F}),2&d&&typeof F!="string")for(var A in F)D.d(R,A,function(p){return F[p]}.bind(null,A));return R},D.n=function(F){var d=F&&F.__esModule?function(){return F.default}:function(){return F};return D.d(d,"a",d),d},D.o=function(F,d){return Object.prototype.hasOwnProperty.call(F,d)},D.p="",D(D.s=0)}([function(pe,e,D){(function(F){var d;e=pe.exports=we,d=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],_=e.src=[],b=0,T=b++;_[T]="0|[1-9]\\d*";var k=b++;_[k]="[0-9]+";var v=b++;_[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;_[y]="("+_[T]+")\\.("+_[T]+")\\.("+_[T]+")";var C=b++;_[C]="("+_[k]+")\\.("+_[k]+")\\.("+_[k]+")";var w=b++;_[w]="(?:"+_[T]+"|"+_[v]+")";var s=b++;_[s]="(?:"+_[k]+"|"+_[v]+")";var o=b++;_[o]="(?:-("+_[w]+"(?:\\."+_[w]+")*))";var a=b++;_[a]="(?:-?("+_[s]+"(?:\\."+_[s]+")*))";var c=b++;_[c]="[0-9A-Za-z-]+";var g=b++;_[g]="(?:\\+("+_[c]+"(?:\\."+_[c]+")*))";var u=b++,t="v?"+_[y]+_[o]+"?"+_[g]+"?";_[u]="^"+t+"$";var n="[v=\\s]*"+_[C]+_[a]+"?"+_[g]+"?",r=b++;_[r]="^"+n+"$";var i=b++;_[i]="((?:<|>)?=?)";var l=b++;_[l]=_[k]+"|x|X|\\*";var f=b++;_[f]=_[T]+"|x|X|\\*";var S=b++;_[S]="[v=\\s]*("+_[f]+")(?:\\.("+_[f]+")(?:\\.("+_[f]+")(?:"+_[o]+")?"+_[g]+"?)?)?";var I=b++;_[I]="[v=\\s]*("+_[l]+")(?:\\.("+_[l]+")(?:\\.("+_[l]+")(?:"+_[a]+")?"+_[g]+"?)?)?";var E=b++;_[E]="^"+_[i]+"\\s*"+_[S]+"$";var h=b++;_[h]="^"+_[i]+"\\s*"+_[I]+"$";var m=b++;_[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=b++;_[P]="(?:~>?)";var O=b++;_[O]="(\\s*)"+_[P]+"\\s+",p[O]=new RegExp(_[O],"g");var N=b++;_[N]="^"+_[P]+_[S]+"$";var L=b++;_[L]="^"+_[P]+_[I]+"$";var U=b++;_[U]="(?:\\^)";var x=b++;_[x]="(\\s*)"+_[U]+"\\s+",p[x]=new RegExp(_[x],"g");var M=b++;_[M]="^"+_[U]+_[S]+"$";var H=b++;_[H]="^"+_[U]+_[I]+"$";var j=b++;_[j]="^"+_[i]+"\\s*("+n+")$|^$";var fe=b++;_[fe]="^"+_[i]+"\\s*("+t+")$|^$";var Y=b++;_[Y]="(\\s*)"+_[i]+"\\s*("+n+"|"+_[S]+")",p[Y]=new RegExp(_[Y],"g");var X=b++;_[X]="^\\s*("+_[S]+")\\s+-\\s+("+_[S]+")\\s*$";var z=b++;_[z]="^\\s*("+_[I]+")\\s+-\\s+("+_[I]+")\\s*$";var J=b++;_[J]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)d(ge,_[ge]),p[ge]||(p[ge]=new RegExp(_[ge]));function le(Q,he){if(Q instanceof we)return Q;if(typeof Q!="string"||Q.length>R||!(he?p[r]:p[u]).test(Q))return null;try{return new we(Q,he)}catch{return null}}function we(Q,he){if(Q instanceof we){if(Q.loose===he)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof we))return new we(Q,he);d("SemVer",Q,he),this.loose=he;var Se=Q.trim().match(he?p[r]:p[u]);if(!Se)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var We=+Ue;if(We>=0&&We<A)return We}return Ue}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=le,e.valid=function(Q,he){var Se=le(Q,he);return Se?Se.version:null},e.clean=function(Q,he){var Se=le(Q.trim().replace(/^[=v]+/,""),he);return Se?Se.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(Q){return d("SemVer.compare",this.version,this.loose,Q),Q instanceof we||(Q=new we(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},we.prototype.compareMain=function(Q){return Q instanceof we||(Q=new we(Q,this.loose)),B(this.major,Q.major)||B(this.minor,Q.minor)||B(this.patch,Q.patch)},we.prototype.comparePre=function(Q){if(Q instanceof we||(Q=new we(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var he=0;do{var Se=this.prerelease[he],Ue=Q.prerelease[he];if(d("prerelease compare",he,Se,Ue),Se===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Se===void 0)return-1;if(Se!==Ue)return B(Se,Ue)}while(++he)},we.prototype.inc=function(Q,he){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,he,Se,Ue){typeof Se=="string"&&(Ue=Se,Se=void 0);try{return new we(Q,Se).inc(he,Ue).version}catch{return null}},e.diff=function(Q,he){if(ne(Q,he))return null;var Se=le(Q),Ue=le(he);if(Se.prerelease.length||Ue.prerelease.length){for(var We in Se)if((We==="major"||We==="minor"||We==="patch")&&Se[We]!==Ue[We])return"pre"+We;return"prerelease"}for(var We in Se)if((We==="major"||We==="minor"||We==="patch")&&Se[We]!==Ue[We])return We},e.compareIdentifiers=B;var G=/^[0-9]+$/;function B(Q,he){var Se=G.test(Q),Ue=G.test(he);return Se&&Ue&&(Q=+Q,he=+he),Se&&!Ue?-1:Ue&&!Se?1:Q<he?-1:Q>he?1:0}function V(Q,he,Se){return new we(Q,Se).compare(new we(he,Se))}function me(Q,he,Se){return V(Q,he,Se)>0}function Z(Q,he,Se){return V(Q,he,Se)<0}function ne(Q,he,Se){return V(Q,he,Se)===0}function re(Q,he,Se){return V(Q,he,Se)!==0}function ye(Q,he,Se){return V(Q,he,Se)>=0}function oe(Q,he,Se){return V(Q,he,Se)<=0}function de(Q,he,Se,Ue){var We;switch(he){case"===":typeof Q=="object"&&(Q=Q.version),typeof Se=="object"&&(Se=Se.version),We=Q===Se;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof Se=="object"&&(Se=Se.version),We=Q!==Se;break;case"":case"=":case"==":We=ne(Q,Se,Ue);break;case"!=":We=re(Q,Se,Ue);break;case">":We=me(Q,Se,Ue);break;case">=":We=ye(Q,Se,Ue);break;case"<":We=Z(Q,Se,Ue);break;case"<=":We=oe(Q,Se,Ue);break;default:throw new TypeError("Invalid operator: "+he)}return We}function ee(Q,he){if(Q instanceof ee){if(Q.loose===he)return Q;Q=Q.value}if(!(this instanceof ee))return new ee(Q,he);d("comparator",Q,he),this.loose=he,this.parse(Q),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(Q,he){return B(he,Q)},e.major=function(Q,he){return new we(Q,he).major},e.minor=function(Q,he){return new we(Q,he).minor},e.patch=function(Q,he){return new we(Q,he).patch},e.compare=V,e.compareLoose=function(Q,he){return V(Q,he,!0)},e.rcompare=function(Q,he,Se){return V(he,Q,Se)},e.sort=function(Q,he){return Q.sort(function(Se,Ue){return e.compare(Se,Ue,he)})},e.rsort=function(Q,he){return Q.sort(function(Se,Ue){return e.rcompare(Se,Ue,he)})},e.gt=me,e.lt=Z,e.eq=ne,e.neq=re,e.gte=ye,e.lte=oe,e.cmp=de,e.Comparator=ee;var ue={};function ve(Q,he){if(Q instanceof ve)return Q.loose===he?Q:new ve(Q.raw,he);if(Q instanceof ee)return new ve(Q.value,he);if(!(this instanceof ve))return new ve(Q,he);if(this.loose=he,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function ke(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function $(Q,he,Se,Ue,We,Ze,Qe,it,et,Te,Oe,ze,Re){return((he=ke(Se)?"":ke(Ue)?">="+Se+".0.0":ke(We)?">="+Se+"."+Ue+".0":">="+he)+" "+(it=ke(et)?"":ke(Te)?"<"+(+et+1)+".0.0":ke(Oe)?"<"+et+"."+(+Te+1)+".0":ze?"<="+et+"."+Te+"."+Oe+"-"+ze:"<="+it)).trim()}function K(Q,he){for(var Se=0;Se<Q.length;Se++)if(!Q[Se].test(he))return!1;if(he.prerelease.length){for(Se=0;Se<Q.length;Se++)if(d(Q[Se].semver),Q[Se].semver!==ue&&Q[Se].semver.prerelease.length>0){var Ue=Q[Se].semver;if(Ue.major===he.major&&Ue.minor===he.minor&&Ue.patch===he.patch)return!0}return!1}return!0}function ie(Q,he,Se){try{he=new ve(he,Se)}catch{return!1}return he.test(Q)}function se(Q,he,Se,Ue){var We,Ze,Qe,it,et;switch(Q=new we(Q,Ue),he=new ve(he,Ue),Se){case">":We=me,Ze=oe,Qe=Z,it=">",et=">=";break;case"<":We=Z,Ze=ye,Qe=me,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ie(Q,he,Ue))return!1;for(var Te=0;Te<he.set.length;++Te){var Oe=he.set[Te],ze=null,Re=null;if(Oe.forEach(function(Xe){Xe.semver===ue&&(Xe=new ee(">=0.0.0")),ze=ze||Xe,Re=Re||Xe,We(Xe.semver,ze.semver,Ue)?ze=Xe:Qe(Xe.semver,Re.semver,Ue)&&(Re=Xe)}),ze.operator===it||ze.operator===et||(!Re.operator||Re.operator===it)&&Ze(Q,Re.semver)||Re.operator===et&&Qe(Q,Re.semver))return!1}return!0}ee.prototype.parse=function(Q){var he=this.loose?p[j]:p[fe],Se=Q.match(he);if(!Se)throw new TypeError("Invalid comparator: "+Q);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new we(Se[2],this.loose):this.semver=ue},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Q){return d("Comparator.test",Q,this.loose),this.semver===ue||(typeof Q=="string"&&(Q=new we(Q,this.loose)),de(Q,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Q,he){if(!(Q instanceof ee))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new ve(Q.value,he),ie(this.value,Se,he);if(Q.operator==="")return Se=new ve(this.value,he),ie(Q.semver,Se,he);var Ue=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ze=this.semver.version===Q.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),it=de(this.semver,"<",Q.semver,he)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),et=de(this.semver,">",Q.semver,he)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Ue||We||Ze&&Qe||it||et},e.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(Q){var he=this.loose;Q=Q.trim(),d("range",Q,he);var Se=he?p[z]:p[X];Q=Q.replace(Se,$),d("hyphen replace",Q),Q=Q.replace(p[Y],"$1$2$3"),d("comparator trim",Q,p[Y]),Q=(Q=(Q=Q.replace(p[O],"$1~")).replace(p[x],"$1^")).split(/\s+/).join(" ");var Ue=he?p[j]:p[fe],We=Q.split(" ").map(function(Ze){return function(Qe,it){return d("comp",Qe),Qe=function(et,Te){return et.trim().split(/\s+/).map(function(Oe){return function(ze,Re){d("caret",ze,Re);var Xe=Re?p[H]:p[M];return ze.replace(Xe,function(ce,ae,Ie,He,Be){var Ye;return d("caret",ze,ce,ae,Ie,He,Be),ke(ae)?Ye="":ke(Ie)?Ye=">="+ae+".0.0 <"+(+ae+1)+".0.0":ke(He)?Ye=ae==="0"?">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+".0 <"+(+ae+1)+".0.0":Be?(d("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ye=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+He+Be+" <"+ae+"."+Ie+"."+(+He+1):">="+ae+"."+Ie+"."+He+Be+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+He+Be+" <"+(+ae+1)+".0.0"):(d("no pr"),Ye=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+He+" <"+ae+"."+Ie+"."+(+He+1):">="+ae+"."+Ie+"."+He+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+He+" <"+(+ae+1)+".0.0"),d("caret return",Ye),Ye})}(Oe,Te)}).join(" ")}(Qe,it),d("caret",Qe),Qe=function(et,Te){return et.trim().split(/\s+/).map(function(Oe){return function(ze,Re){var Xe=Re?p[L]:p[N];return ze.replace(Xe,function(ce,ae,Ie,He,Be){var Ye;return d("tilde",ze,ce,ae,Ie,He,Be),ke(ae)?Ye="":ke(Ie)?Ye=">="+ae+".0.0 <"+(+ae+1)+".0.0":ke(He)?Ye=">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":Be?(d("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ye=">="+ae+"."+Ie+"."+He+Be+" <"+ae+"."+(+Ie+1)+".0"):Ye=">="+ae+"."+Ie+"."+He+" <"+ae+"."+(+Ie+1)+".0",d("tilde return",Ye),Ye})}(Oe,Te)}).join(" ")}(Qe,it),d("tildes",Qe),Qe=function(et,Te){return d("replaceXRanges",et,Te),et.split(/\s+/).map(function(Oe){return function(ze,Re){ze=ze.trim();var Xe=Re?p[h]:p[E];return ze.replace(Xe,function(ce,ae,Ie,He,Be,Ye){d("xRange",ze,ce,ae,Ie,He,Be,Ye);var rt=ke(Ie),at=rt||ke(He),vt=at||ke(Be);return ae==="="&&vt&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&vt?(at&&(He=0),vt&&(Be=0),ae===">"?(ae=">=",at?(Ie=+Ie+1,He=0,Be=0):vt&&(He=+He+1,Be=0)):ae==="<="&&(ae="<",at?Ie=+Ie+1:He=+He+1),ce=ae+Ie+"."+He+"."+Be):at?ce=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":vt&&(ce=">="+Ie+"."+He+".0 <"+Ie+"."+(+He+1)+".0"),d("xRange return",ce),ce})}(Oe,Te)}).join(" ")}(Qe,it),d("xrange",Qe),Qe=function(et,Te){return d("replaceStars",et,Te),et.trim().replace(p[J],"")}(Qe,it),d("stars",Qe),Qe}(Ze,he)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(Ze){return!!Ze.match(Ue)})),We=We.map(function(Ze){return new ee(Ze,he)})},ve.prototype.intersects=function(Q,he){if(!(Q instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(Ue){return Q.set.some(function(We){return We.every(function(Ze){return Ue.intersects(Ze,he)})})})})},e.toComparators=function(Q,he){return new ve(Q,he).set.map(function(Se){return Se.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new we(Q,this.loose));for(var he=0;he<this.set.length;he++)if(K(this.set[he],Q))return!0;return!1},e.satisfies=ie,e.maxSatisfying=function(Q,he,Se){var Ue=null,We=null;try{var Ze=new ve(he,Se)}catch{return null}return Q.forEach(function(Qe){Ze.test(Qe)&&(Ue&&We.compare(Qe)!==-1||(We=new we(Ue=Qe,Se)))}),Ue},e.minSatisfying=function(Q,he,Se){var Ue=null,We=null;try{var Ze=new ve(he,Se)}catch{return null}return Q.forEach(function(Qe){Ze.test(Qe)&&(Ue&&We.compare(Qe)!==1||(We=new we(Ue=Qe,Se)))}),Ue},e.validRange=function(Q,he){try{return new ve(Q,he).range||"*"}catch{return null}},e.ltr=function(Q,he,Se){return se(Q,he,"<",Se)},e.gtr=function(Q,he,Se){return se(Q,he,">",Se)},e.outside=se,e.prerelease=function(Q,he){var Se=le(Q,he);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(Q,he,Se){return Q=new ve(Q,Se),he=new ve(he,Se),Q.intersects(he)},e.coerce=function(Q){if(Q instanceof we)return Q;if(typeof Q!="string")return null;var he=Q.match(p[m]);return he==null?null:le((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,D(1))},function(pe,e){var D,F,d=pe.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function p(s){if(D===setTimeout)return setTimeout(s,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(s,0);try{return D(s,0)}catch{try{return D.call(null,s,0)}catch{return D.call(this,s,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var _,b=[],T=!1,k=-1;function v(){T&&_&&(T=!1,_.length?b=_.concat(b):k=-1,b.length&&y())}function y(){if(!T){var s=p(v);T=!0;for(var o=b.length;o;){for(_=b,b=[];++k<o;)_&&_[k].run();k=-1,o=b.length}_=null,T=!1,function(a){if(F===clearTimeout)return clearTimeout(a);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(a);try{F(a)}catch{try{return F.call(null,a)}catch{return F.call(this,a)}}}(s)}}function C(s,o){this.fun=s,this.array=o}function w(){}d.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)o[a-1]=arguments[a];b.push(new C(s,o)),b.length!==1||T||p(y)},C.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=w,d.addListener=w,d.once=w,d.off=w,d.removeListener=w,d.removeAllListeners=w,d.emit=w,d.prependListener=w,d.prependOnceListener=w,d.listeners=function(s){return[]},d.binding=function(s){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(s){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(Ce[37],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(R){return new F(R)}constructor(R){this._now=D&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=F}),define(Ce[4],De([1,0,8,75,3,76,37]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const p=!1,_=!1;var b;(function(E){E.None=()=>d.Disposable.None;function h(de){if(_){const{onDidAddListener:ee}=de,ue=C.create();let ve=0;de.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),ee?.()}}}function m(de,ee){return fe(de,()=>{},0,void 0,!0,void 0,ee)}E.defer=m;function P(de){return(ee,ue=null,ve)=>{let ke=!1,$;return $=de(K=>{if(!ke)return $?$.dispose():ke=!0,ee.call(ue,K)},null,ve),ke&&$.dispose(),$}}E.once=P;function O(de,ee,ue){return H((ve,ke=null,$)=>de(K=>ve.call(ke,ee(K)),null,$),ue)}E.map=O;function N(de,ee,ue){return H((ve,ke=null,$)=>de(K=>{ee(K),ve.call(ke,K)},null,$),ue)}E.forEach=N;function L(de,ee,ue){return H((ve,ke=null,$)=>de(K=>ee(K)&&ve.call(ke,K),null,$),ue)}E.filter=L;function U(de){return de}E.signal=U;function x(...de){return(ee,ue=null,ve)=>{const ke=(0,d.combinedDisposable)(...de.map($=>$(K=>ee.call(ue,K))));return j(ke,ve)}}E.any=x;function M(de,ee,ue,ve){let ke=ue;return O(de,$=>(ke=ee(ke,$),ke),ve)}E.reduce=M;function H(de,ee){let ue;const ve={onWillAddFirstListener(){ue=de(ke.fire,ke)},onDidRemoveLastListener(){ue?.dispose()}};ee||h(ve);const ke=new c(ve);return ee?.add(ke),ke.event}function j(de,ee){return ee instanceof Array?ee.push(de):ee&&ee.add(de),de}function fe(de,ee,ue=100,ve=!1,ke=!1,$,K){let ie,se,Q,he=0,Se;const Ue={leakWarningThreshold:$,onWillAddFirstListener(){ie=de(Ze=>{he++,se=ee(se,Ze),ve&&!Q&&(We.fire(se),se=void 0),Se=()=>{const Qe=se;se=void 0,Q=void 0,(!ve||he>1)&&We.fire(Qe),he=0},typeof ue=="number"?(clearTimeout(Q),Q=setTimeout(Se,ue)):Q===void 0&&(Q=0,queueMicrotask(Se))})},onWillRemoveListener(){ke&&he>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ie.dispose()}};K||h(Ue);const We=new c(Ue);return K?.add(We),We.event}E.debounce=fe;function Y(de,ee=0,ue){return E.debounce(de,(ve,ke)=>ve?(ve.push(ke),ve):[ke],ee,void 0,!0,void 0,ue)}E.accumulate=Y;function X(de,ee=(ve,ke)=>ve===ke,ue){let ve=!0,ke;return L(de,$=>{const K=ve||!ee($,ke);return ve=!1,ke=$,K},ue)}E.latch=X;function z(de,ee,ue){return[E.filter(de,ee,ue),E.filter(de,ve=>!ee(ve),ue)]}E.split=z;function J(de,ee=!1,ue=[],ve){let ke=ue.slice(),$=de(se=>{ke?ke.push(se):ie.fire(se)});ve&&ve.add($);const K=()=>{ke?.forEach(se=>ie.fire(se)),ke=null},ie=new c({onWillAddFirstListener(){$||($=de(se=>ie.fire(se)),ve&&ve.add($))},onDidAddFirstListener(){ke&&(ee?setTimeout(K):K())},onDidRemoveLastListener(){$&&$.dispose(),$=null}});return ve&&ve.add(ie),ie.event}E.buffer=J;function ge(de,ee){return(ve,ke,$)=>{const K=ee(new we);return de(function(ie){const se=K.evaluate(ie);se!==le&&ve.call(ke,se)},void 0,$)}}E.chain=ge;const le=Symbol("HaltChainable");class we{constructor(){this.steps=[]}map(ee){return this.steps.push(ee),this}forEach(ee){return this.steps.push(ue=>(ee(ue),ue)),this}filter(ee){return this.steps.push(ue=>ee(ue)?ue:le),this}reduce(ee,ue){let ve=ue;return this.steps.push(ke=>(ve=ee(ve,ke),ve)),this}latch(ee=(ue,ve)=>ue===ve){let ue=!0,ve;return this.steps.push(ke=>{const $=ue||!ee(ke,ve);return ue=!1,ve=ke,$?ke:le}),this}evaluate(ee){for(const ue of this.steps)if(ee=ue(ee),ee===le)break;return ee}}function G(de,ee,ue=ve=>ve){const ve=(...ie)=>K.fire(ue(...ie)),ke=()=>de.on(ee,ve),$=()=>de.removeListener(ee,ve),K=new c({onWillAddFirstListener:ke,onDidRemoveLastListener:$});return K.event}E.fromNodeEventEmitter=G;function B(de,ee,ue=ve=>ve){const ve=(...ie)=>K.fire(ue(...ie)),ke=()=>de.addEventListener(ee,ve),$=()=>de.removeEventListener(ee,ve),K=new c({onWillAddFirstListener:ke,onDidRemoveLastListener:$});return K.event}E.fromDOMEventEmitter=B;function V(de){return new Promise(ee=>P(de)(ee))}E.toPromise=V;function me(de){const ee=new c;return de.then(ue=>{ee.fire(ue)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}E.fromPromise=me;function Z(de,ee){return ee(void 0),de(ue=>ee(ue))}E.runAndSubscribe=Z;function ne(de,ee){let ue=null;function ve($){ue?.dispose(),ue=new d.DisposableStore,ee($,ue)}ve(void 0);const ke=de($=>ve($));return(0,d.toDisposable)(()=>{ke.dispose(),ue?.dispose()})}E.runAndSubscribeWithStore=ne;class re{constructor(ee,ue){this._observable=ee,this._counter=0,this._hasChanged=!1;const ve={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ue||h(ve),this.emitter=new c(ve),ue&&ue.add(this.emitter)}beginUpdate(ee){this._counter++}handlePossibleChange(ee){}handleChange(ee,ue){this._hasChanged=!0}endUpdate(ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(de,ee){return new re(de,ee).emitter.event}E.fromObservable=ye;function oe(de){return ee=>{let ue=0,ve=!1;const ke={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(de.reportChanges(),ve&&(ve=!1,ee()))},handlePossibleChange(){},handleChange(){ve=!0}};return de.addObserver(ke),de.reportChanges(),{dispose(){de.removeObserver(ke)}}}}E.fromObservableLight=oe})(b||(e.Event=b={}));class T{static{this.all=new Set}static{this._idPool=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${T._idPool++}`,T.all.add(this)}start(h){this._stopWatch=new A.StopWatch,this.listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=T;let k=-1;function v(E){const h=k;return k=E,{dispose(){k=h}}}e.setGlobalLeakWarningThreshold=v;class y{constructor(h,m=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=m,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(h,m){const P=this.threshold;if(P<=0||m<P)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let N,L=0;for(const[U,x]of this._stacks)(!N||L<x)&&(N=U,L=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${L}):`),console.warn(N)}return()=>{const N=this._stacks.get(h.value)||0;this._stacks.set(h.value,N-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class s{constructor(h){this.value=h,this.id=w++}}const o=2,a=(E,h)=>{if(E instanceof s)h(E);else for(let m=0;m<E.length;m++){const P=E[m];P&&h(P)}};class c{constructor(h){this._size=0,this._options=h,this._leakageMon=k>0||this._options?.leakWarningThreshold?new y(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(p){const h=this._listeners;queueMicrotask(()=>{a(h,m=>m.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(h,m,P)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.Disposable.None;if(this._disposed)return d.Disposable.None;m&&(h=h.bind(m));const O=new s(h);let N,L;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=C.create(),N=this._leakageMon.check(O.stack,this._size+1)),p&&(O.stack=L??C.create()),this._listeners?this._listeners instanceof s?(this._deliveryQueue??=new u,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const U=(0,d.toDisposable)(()=>{N?.(),this._removeListener(O)});return P instanceof d.DisposableStore?P.add(U):Array.isArray(P)&&P.push(U),U},this._event}_removeListener(h){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const m=this._listeners,P=m.indexOf(h);if(P===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,m[P]=void 0;const O=this._deliveryQueue.current===this;if(this._size*o<=m.length){let N=0;for(let L=0;L<m.length;L++)m[L]?m[N++]=m[L]:O&&(this._deliveryQueue.end--,N<this._deliveryQueue.i&&this._deliveryQueue.i--);m.length=N}}_deliver(h,m){if(!h)return;const P=this._options?.onListenerError||D.onUnexpectedError;if(!P){h.value(m);return}try{h.value(m)}catch(O){P(O)}}_deliverQueue(h){const m=h.current._listeners;for(;h.i<h.end;)this._deliver(m[h.i++],h.value);h.reset()}fire(h){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof s)this._deliver(this._listeners,h);else{const m=this._deliveryQueue;m.enqueue(this,h,this._listeners.length),this._deliverQueue(m)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=c;const g=()=>new u;e.createEventDeliveryQueue=g;class u{constructor(){this.i=-1,this.end=0}enqueue(h,m,P){this.i=0,this.end=P,this.current=h,this.value=m}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(h,m,P){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList),a(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,h]));this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[O,N]=this._asyncDeliveryQueue.shift(),L=[],U={...N,token:m,waitUntil:x=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");P&&(x=P(x,O)),L.push(x)}};try{O(U)}catch(x){(0,D.onUnexpectedError)(x);continue}Object.freeze(L),await Promise.allSettled(L).then(x=>{for(const M of x)M.status==="rejected"&&(0,D.onUnexpectedError)(M.reason)})}}}e.AsyncEmitter=t;class n extends c{get isPaused(){return this._isPaused!==0}constructor(h){super(h),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._size&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=n;class r extends n{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=r;class i extends c{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){this.hasListeners()&&(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const m={event:h,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const P=()=>{this.hasListeners&&this.unhook(m);const O=this.events.indexOf(m);this.events.splice(O,1)};return(0,d.toDisposable)((0,F.createSingleCallFunction)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(m=>this.emitter.fire(m))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class f{constructor(h,m,P,O){this._store=new d.DisposableStore;const N=this._store.add(new l),L=this._store.add(new d.DisposableMap);function U(x){L.set(x,N.add(O(x)))}for(const x of h)U(x);this._store.add(m(x=>{U(x)})),this._store.add(P(x=>{L.deleteAndDispose(x)})),this.event=N.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=f;class S{constructor(){this.buffers=[]}wrapEvent(h){return(m,P,O)=>h(N=>{const L=this.buffers[this.buffers.length-1];L?L.push(()=>m.call(P,N)):m.call(P,N)},void 0,O)}bufferEvents(h){const m=[];this.buffers.push(m);const P=h();return this.buffers.pop(),m.forEach(O=>O()),P}}e.EventBufferer=S;class I{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=d.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(Ce[21],De([1,0,4]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(p,_){const b=setTimeout(p.bind(_),0);return{dispose(){clearTimeout(b)}}});var d;(function(p){function _(b){return b===p.None||b===p.Cancelled||b instanceof R?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}p.isCancellationToken=_,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(d||(e.CancellationToken=d={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=d.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=d.None}}e.CancellationTokenSource=A}),define(Ce[159],De([1,0,21]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class F{constructor(p){this.task=p,this.result=null}get(){if(this.result)return this.result;const p=new D.CancellationTokenSource,_=this.task(p.token);return this.result={promise:_,dispose:()=>{this.result=null,p.cancel(),p.dispose()}},this.result}}e.Cache=F;class d{constructor(p){this.fn=p,this.lastCache=void 0,this.lastArgKey=void 0}get(p){const _=JSON.stringify(p);return this.lastArgKey!==_&&(this.lastArgKey=_,this.lastCache=this.fn(p)),this.lastCache}}e.LRUCachedFunction=d;class R{get cachedValues(){return this._map}constructor(p){this.fn=p,this._map=new Map}get(p){if(this._map.has(p))return this._map.get(p);const _=this.fn(p);return this._map.set(p,_),_}}e.CachedFunction=R}),define(Ce[97],De([1,0,8,3]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function d(g){const u=g;return u?typeof u.read=="function":!1}e.isReadable=d;function R(g){const u=g;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function A(g){const u=g;return u?R(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function p(g,u){return new _(g,u)}e.newWriteableStream=p;class _{constructor(u,t){this.reducer=u,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(t=>t(u))}emitError(u){this.listeners.error.length===0?(0,D.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(t=>t(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,t){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(u,t){if(this.state.destroyed)return;let n;switch(u){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(g,u){const t=[];let n;for(;(n=g.read())!==null;)t.push(n);return u(t)}e.consumeReadable=b;function T(g,u,t){const n=[];let r;for(;(r=g.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return g.read()}}}e.peekReadable=T;function k(g,u){return new Promise((t,n)=>{const r=[];v(g,{onData:i=>{u&&r.push(i)},onError:i=>{u?n(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.consumeStream=k;function v(g,u,t){g.on("error",n=>{t?.isCancellationRequested||u.onError(n)}),g.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),g.on("data",n=>{t?.isCancellationRequested||u.onData(n)})}e.listenStream=v;function y(g,u){return new Promise((t,n)=>{const r=new F.DisposableStore,i=[],l=I=>{if(i.push(I),i.length>u)return r.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},f=I=>(r.dispose(),n(I)),S=()=>(r.dispose(),t({stream:g,buffer:i,ended:!0}));r.add((0,F.toDisposable)(()=>g.removeListener("error",f))),g.on("error",f),r.add((0,F.toDisposable)(()=>g.removeListener("end",S))),g.on("end",S),r.add((0,F.toDisposable)(()=>g.removeListener("data",l))),g.on("data",l)})}e.peekStream=y;function C(g,u){const t=p(u);return t.end(g),t}e.toStream=C;function w(){const g=p(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=w;function s(g){let u=!1;return{read:()=>u?null:(u=!0,g)}}e.toReadable=s;function o(g,u,t){const n=p(t);return v(g,{onData:r=>n.write(u.data(r)),onError:r=>n.error(u.error?u.error(r):r),onEnd:()=>n.end()}),n}e.transform=o;function a(g,u,t){let n=!1;return{read:()=>{const r=u.read();return n?r:(n=!0,r!==null?t([g,r]):g)}}}e.prefixedReadable=a;function c(g,u,t){let n=!1;const r=p(t);return v(u,{onData:i=>n?r.write(i):(n=!0,r.write(t([g,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(g)),r.end()}}),r}e.prefixedStream=c}),define(Ce[22],De([1,0,58,97]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const d=typeof Buffer<"u",R=new D.Lazy(()=>new Uint8Array(256));let A,p;class _{static alloc(m){return d?new _(Buffer.allocUnsafe(m)):new _(new Uint8Array(m))}static wrap(m){return d&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new _(m)}static fromString(m,P){return!(P?.dontUseNodeBuffer||!1)&&d?new _(Buffer.from(m)):(A||(A=new TextEncoder),new _(A.encode(m)))}static fromByteArray(m){const P=_.alloc(m.length);for(let O=0,N=m.length;O<N;O++)P.buffer[O]=m[O];return P}static concat(m,P){if(typeof P>"u"){P=0;for(let L=0,U=m.length;L<U;L++)P+=m[L].byteLength}const O=_.alloc(P);let N=0;for(let L=0,U=m.length;L<U;L++){const x=m[L];O.set(x,N),N+=x.byteLength}return O}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=_.alloc(this.byteLength);return m.set(this),m}toString(){return d?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(m,P){return new _(this.buffer.subarray(m,P))}set(m,P){if(m instanceof _)this.buffer.set(m.buffer,P);else if(m instanceof Uint8Array)this.buffer.set(m,P);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),P);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return v(this.buffer,m)}writeUInt32BE(m,P){y(this.buffer,m,P)}readUInt32LE(m){return C(this.buffer,m)}writeUInt32LE(m,P){w(this.buffer,m,P)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,P){o(this.buffer,m,P)}indexOf(m,P=0){return b(this.buffer,m instanceof _?m.buffer:m,P)}}e.VSBuffer=_;function b(h,m,P=0){const O=m.byteLength,N=h.byteLength;if(O===0)return 0;if(O===1)return h.indexOf(m[0]);if(O>N-P)return-1;const L=R.value;L.fill(m.length);for(let H=0;H<m.length;H++)L[m[H]]=m.length-H-1;let U=P+m.length-1,x=U,M=-1;for(;U<N;)if(h[U]===m[x]){if(x===0){M=U;break}U--,x--}else U+=Math.max(m.length-x,L[h[U]]),x=m.length-1;return M}e.binaryIndexOf=b;function T(h,m){return h[m+0]<<0>>>0|h[m+1]<<8>>>0}e.readUInt16LE=T;function k(h,m,P){h[P+0]=m&255,m=m>>>8,h[P+1]=m&255}e.writeUInt16LE=k;function v(h,m){return h[m]*2**24+h[m+1]*2**16+h[m+2]*2**8+h[m+3]}e.readUInt32BE=v;function y(h,m,P){h[P+3]=m,m=m>>>8,h[P+2]=m,m=m>>>8,h[P+1]=m,m=m>>>8,h[P]=m}e.writeUInt32BE=y;function C(h,m){return h[m+0]<<0>>>0|h[m+1]<<8>>>0|h[m+2]<<16>>>0|h[m+3]<<24>>>0}e.readUInt32LE=C;function w(h,m,P){h[P+0]=m&255,m=m>>>8,h[P+1]=m&255,m=m>>>8,h[P+2]=m&255,m=m>>>8,h[P+3]=m&255}e.writeUInt32LE=w;function s(h,m){return h[m]}e.readUInt8=s;function o(h,m,P){h[P]=m}e.writeUInt8=o;function a(h){return F.consumeReadable(h,m=>_.concat(m))}e.readableToBuffer=a;function c(h){return F.toReadable(h)}e.bufferToReadable=c;function g(h){return F.consumeStream(h,m=>_.concat(m))}e.streamToBuffer=g;async function u(h){return h.ended?_.concat(h.buffer):_.concat([...h.buffer,await g(h.stream)])}e.bufferedStreamToBuffer=u;function t(h){return F.toStream(h,m=>_.concat(m))}e.bufferToStream=t;function n(h){return F.transform(h,{data:m=>typeof m=="string"?_.fromString(m):_.wrap(m)},m=>_.concat(m))}e.streamToBufferReadableStream=n;function r(h){return F.newWriteableStream(m=>_.concat(m),h)}e.newWriteableBufferStream=r;function i(h,m){return F.prefixedReadable(h,m,P=>_.concat(P))}e.prefixedBufferReadable=i;function l(h,m){return F.prefixedStream(h,m,P=>_.concat(P))}e.prefixedBufferStream=l;function f(h){let m=0,P=0,O=0;const N=new Uint8Array(Math.floor(h.length/4*3)),L=x=>{switch(P){case 3:N[O++]=m|x,P=0;break;case 2:N[O++]=m|x>>>2,m=x<<6,P=3;break;case 1:N[O++]=m|x>>>4,m=x<<4,P=2;break;default:m=x<<2,P=1}};for(let x=0;x<h.length;x++){const M=h.charCodeAt(x);if(M>=65&&M<=90)L(M-65);else if(M>=97&&M<=122)L(M-97+26);else if(M>=48&&M<=57)L(M-48+52);else if(M===43||M===45)L(62);else if(M===47||M===95)L(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${h[x]}`)}}const U=O;for(;P>0;)L(0);return _.wrap(N).slice(0,U)}e.decodeBase64=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:h},m=!0,P=!1){const O=P?I:S;let N="";const L=h.byteLength%3;let U=0;for(;U<h.byteLength-L;U+=3){const x=h[U+0],M=h[U+1],H=h[U+2];N+=O[x>>>2],N+=O[(x<<4|M>>>4)&63],N+=O[(M<<2|H>>>6)&63],N+=O[H&63]}if(L===1){const x=h[U+0];N+=O[x>>>2],N+=O[x<<4&63],m&&(N+="==")}else if(L===2){const x=h[U+0],M=h[U+1];N+=O[x>>>2],N+=O[(x<<4|M>>>4)&63],N+=O[M<<2&63],m&&(N+="=")}return N}e.encodeBase64=E}),define(Ce[15],De([1,0,159,58]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function d(Te){return!Te||typeof Te!="string"?!0:Te.trim().length===0}e.isFalsyOrWhitespace=d;const R=/{(\d+)}/g;function A(Te,...Oe){return Oe.length===0?Te:Te.replace(R,function(ze,Re){const Xe=parseInt(Re,10);return isNaN(Xe)||Xe<0||Xe>=Oe.length?ze:Oe[Xe]})}e.format=A;const p=/{([^}]+)}/g;function _(Te,Oe){return Te.replace(p,(ze,Re)=>Oe[Re]??ze)}e.format2=_;function b(Te){return Te.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.escape=b;function T(Te){return Te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function k(Te,Oe){let ze=0;const Re=Oe.charCodeAt(0);for(let Xe=Te.length-1;Xe>=0;Xe--)Te.charCodeAt(Xe)===Re&&ze++;return ze}e.count=k;function v(Te,Oe,ze="\u2026"){return Te.length<=Oe?Te:`${Te.substr(0,Oe)}${ze}`}e.truncate=v;function y(Te,Oe=" "){const ze=C(Te,Oe);return w(ze,Oe)}e.trim=y;function C(Te,Oe){if(!Te||!Oe)return Te;const ze=Oe.length;if(ze===0||Te.length===0)return Te;let Re=0;for(;Te.indexOf(Oe,Re)===Re;)Re=Re+ze;return Te.substring(Re)}e.ltrim=C;function w(Te,Oe){if(!Te||!Oe)return Te;const ze=Oe.length,Re=Te.length;if(ze===0||Re===0)return Te;let Xe=Re,ce=-1;for(;ce=Te.lastIndexOf(Oe,Xe-1),!(ce===-1||ce+ze!==Xe);){if(ce===0)return"";Xe=ce}return Te.substring(0,Xe)}e.rtrim=w;function s(Te){return Te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=s;function o(Te){return Te.replace(/\*/g,"")}e.stripWildcards=o;function a(Te,Oe,ze={}){if(!Te)throw new Error("Cannot create regex from empty string");Oe||(Te=T(Te)),ze.wholeWord&&(/\B/.test(Te.charAt(0))||(Te="\\b"+Te),/\B/.test(Te.charAt(Te.length-1))||(Te=Te+"\\b"));let Re="";return ze.global&&(Re+="g"),ze.matchCase||(Re+="i"),ze.multiline&&(Re+="m"),ze.unicode&&(Re+="u"),new RegExp(Te,Re)}e.createRegExp=a;function c(Te){return Te.source==="^"||Te.source==="^$"||Te.source==="$"||Te.source==="^\\s*$"?!1:!!(Te.exec("")&&Te.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function g(Te){return Te.split(/\r\n|\r|\n/)}e.splitLines=g;function u(Te){for(let Oe=0,ze=Te.length;Oe<ze;Oe++){const Re=Te.charCodeAt(Oe);if(Re!==32&&Re!==9)return Oe}return-1}e.firstNonWhitespaceIndex=u;function t(Te,Oe=0,ze=Te.length){for(let Re=Oe;Re<ze;Re++){const Xe=Te.charCodeAt(Re);if(Xe!==32&&Xe!==9)return Te.substring(Oe,Re)}return Te.substring(Oe,ze)}e.getLeadingWhitespace=t;function n(Te,Oe=Te.length-1){for(let ze=Oe;ze>=0;ze--){const Re=Te.charCodeAt(ze);if(Re!==32&&Re!==9)return ze}return-1}e.lastNonWhitespaceIndex=n;function r(Te,Oe,ze){const Re=[];let Xe=0;for(const ce of Te.matchAll(Oe)){if(Re.push(Te.slice(Xe,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Xe=ce.index+ce[0].length,Re.push(ze(ce[0],...ce.slice(1),ce.index,Te,ce.groups))}return Re.push(Te.slice(Xe)),Promise.all(Re).then(ce=>ce.join(""))}e.replaceAsync=r;function i(Te,Oe){return Te<Oe?-1:Te>Oe?1:0}e.compare=i;function l(Te,Oe,ze=0,Re=Te.length,Xe=0,ce=Oe.length){for(;ze<Re&&Xe<ce;ze++,Xe++){const He=Te.charCodeAt(ze),Be=Oe.charCodeAt(Xe);if(He<Be)return-1;if(He>Be)return 1}const ae=Re-ze,Ie=ce-Xe;return ae<Ie?-1:ae>Ie?1:0}e.compareSubstring=l;function f(Te,Oe){return S(Te,Oe,0,Te.length,0,Oe.length)}e.compareIgnoreCase=f;function S(Te,Oe,ze=0,Re=Te.length,Xe=0,ce=Oe.length){for(;ze<Re&&Xe<ce;ze++,Xe++){let He=Te.charCodeAt(ze),Be=Oe.charCodeAt(Xe);if(He===Be)continue;if(He>=128||Be>=128)return l(Te.toLowerCase(),Oe.toLowerCase(),ze,Re,Xe,ce);E(He)&&(He-=32),E(Be)&&(Be-=32);const Ye=He-Be;if(Ye!==0)return Ye}const ae=Re-ze,Ie=ce-Xe;return ae<Ie?-1:ae>Ie?1:0}e.compareSubstringIgnoreCase=S;function I(Te){return Te>=48&&Te<=57}e.isAsciiDigit=I;function E(Te){return Te>=97&&Te<=122}e.isLowerAsciiLetter=E;function h(Te){return Te>=65&&Te<=90}e.isUpperAsciiLetter=h;function m(Te,Oe){return Te.length===Oe.length&&S(Te,Oe)===0}e.equalsIgnoreCase=m;function P(Te,Oe){const ze=Oe.length;return Oe.length>Te.length?!1:S(Te,Oe,0,ze)===0}e.startsWithIgnoreCase=P;function O(Te,Oe){const ze=Math.min(Te.length,Oe.length);let Re;for(Re=0;Re<ze;Re++)if(Te.charCodeAt(Re)!==Oe.charCodeAt(Re))return Re;return ze}e.commonPrefixLength=O;function N(Te,Oe){const ze=Math.min(Te.length,Oe.length);let Re;const Xe=Te.length-1,ce=Oe.length-1;for(Re=0;Re<ze;Re++)if(Te.charCodeAt(Xe-Re)!==Oe.charCodeAt(ce-Re))return Re;return ze}e.commonSuffixLength=N;function L(Te){return 55296<=Te&&Te<=56319}e.isHighSurrogate=L;function U(Te){return 56320<=Te&&Te<=57343}e.isLowSurrogate=U;function x(Te,Oe){return(Te-55296<<10)+(Oe-56320)+65536}e.computeCodePoint=x;function M(Te,Oe,ze){const Re=Te.charCodeAt(ze);if(L(Re)&&ze+1<Oe){const Xe=Te.charCodeAt(ze+1);if(U(Xe))return x(Re,Xe)}return Re}e.getNextCodePoint=M;function H(Te,Oe){const ze=Te.charCodeAt(Oe-1);if(U(ze)&&Oe>1){const Re=Te.charCodeAt(Oe-2);if(L(Re))return x(Re,ze)}return ze}class j{get offset(){return this._offset}constructor(Oe,ze=0){this._str=Oe,this._len=Oe.length,this._offset=ze}setOffset(Oe){this._offset=Oe}prevCodePoint(){const Oe=H(this._str,this._offset);return this._offset-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=M(this._str,this._len,this._offset);return this._offset+=Oe>=65536?2:1,Oe}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class fe{get offset(){return this._iterator.offset}constructor(Oe,ze=0){this._iterator=new j(Oe,ze)}nextGraphemeLength(){const Oe=he.getInstance(),ze=this._iterator,Re=ze.offset;let Xe=Oe.getGraphemeBreakType(ze.nextCodePoint());for(;!ze.eol();){const ce=ze.offset,ae=Oe.getGraphemeBreakType(ze.nextCodePoint());if(se(Xe,ae)){ze.setOffset(ce);break}Xe=ae}return ze.offset-Re}prevGraphemeLength(){const Oe=he.getInstance(),ze=this._iterator,Re=ze.offset;let Xe=Oe.getGraphemeBreakType(ze.prevCodePoint());for(;ze.offset>0;){const ce=ze.offset,ae=Oe.getGraphemeBreakType(ze.prevCodePoint());if(se(ae,Xe)){ze.setOffset(ce);break}Xe=ae}return Re-ze.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=fe;function Y(Te,Oe){return new fe(Te,Oe).nextGraphemeLength()}e.nextCharLength=Y;function X(Te,Oe){return new fe(Te,Oe).prevGraphemeLength()}e.prevCharLength=X;function z(Te,Oe){Oe>0&&U(Te.charCodeAt(Oe))&&Oe--;const ze=Oe+Y(Te,Oe);return[ze-X(Te,ze),ze]}e.getCharContainingOffset=z;function J(Te){const Oe=new fe(Te);let ze=0;for(;!Oe.eol();)ze++,Oe.nextGraphemeLength();return ze}e.charCount=J;let ge;function le(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Te){return ge||(ge=le()),ge.test(Te)}e.containsRTL=we;const G=/^[\t\n\r\x20-\x7E]*$/;function B(Te){return G.test(Te)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(Te){return e.UNUSUAL_LINE_TERMINATORS.test(Te)}e.containsUnusualLineTerminators=V;function me(Te){return Te>=11904&&Te<=55215||Te>=63744&&Te<=64255||Te>=65281&&Te<=65374}e.isFullWidthCharacter=me;function Z(Te){return Te>=127462&&Te<=127487||Te===8986||Te===8987||Te===9200||Te===9203||Te>=9728&&Te<=10175||Te===11088||Te===11093||Te>=127744&&Te<=128591||Te>=128640&&Te<=128764||Te>=128992&&Te<=129008||Te>=129280&&Te<=129535||Te>=129648&&Te<=129782}e.isEmojiImprecise=Z;function ne(Te,Oe){if(Te.length<Oe)return Te;const ze=/\b/g;let Re=0;for(;ze.test(Te)&&!(Te.length-ze.lastIndex<Oe);)Re=ze.lastIndex,ze.lastIndex+=1;return Te.substring(Re).replace(/^\s/,"")}e.lcut=ne;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ye=/\x1b\].*?\x07/g;function oe(Te){return Te&&(Te=Te.replace(re,"").replace(ye,"")),Te}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(Te){return!!(Te&&Te.length>0&&Te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function ee(Te){return de(Te)?Te.substr(1):Te}e.stripUTF8BOM=ee;function ue(Te,Oe){if(!Te||!Oe||Te.length<Oe.length)return!1;const ze=Oe.length,Re=Te.toLowerCase();let Xe=0,ce=-1;for(;Xe<ze;){const ae=Re.indexOf(Oe[Xe],ce+1);if(ae<0)return!1;ce=ae,Xe++}return!0}e.fuzzyContains=ue;function ve(Te,Oe=!1){return Te?(Oe&&(Te=Te.replace(/\\./g,"")),Te.toLowerCase()!==Te):!1}e.containsUppercaseCharacter=ve;function ke(Te){return Te.charAt(0).toUpperCase()+Te.slice(1)}e.uppercaseFirstLetter=ke;function $(Te,Oe=1){if(Oe===0)return"";let ze=-1;do ze=Te.indexOf(`
`,ze+1),Oe--;while(Oe>0&&ze>=0);return ze===-1?Te:(Te[ze-1]==="\r"&&ze--,Te.substr(0,ze))}e.getNLines=$;function K(Te){return Te=Te%(2*26),Te<26?String.fromCharCode(97+Te):String.fromCharCode(65+Te-26)}e.singleLetterHash=K;function ie(Te){return he.getInstance().getGraphemeBreakType(Te)}e.getGraphemeBreakType=ie;function se(Te,Oe){return Te===0?Oe!==5&&Oe!==7:Te===2&&Oe===3?!1:Te===4||Te===2||Te===3||Oe===4||Oe===2||Oe===3?!0:!(Te===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Te===11||Te===9)&&(Oe===9||Oe===10)||(Te===12||Te===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Te===1||Te===13&&Oe===14||Te===6&&Oe===6)}var Q;(function(Te){Te[Te.Other=0]="Other",Te[Te.Prepend=1]="Prepend",Te[Te.CR=2]="CR",Te[Te.LF=3]="LF",Te[Te.Control=4]="Control",Te[Te.Extend=5]="Extend",Te[Te.Regional_Indicator=6]="Regional_Indicator",Te[Te.SpacingMark=7]="SpacingMark",Te[Te.L=8]="L",Te[Te.V=9]="V",Te[Te.T=10]="T",Te[Te.LV=11]="LV",Te[Te.LVT=12]="LVT",Te[Te.ZWJ=13]="ZWJ",Te[Te.Extended_Pictographic=14]="Extended_Pictographic"})(Q||(e.GraphemeBreakType=Q={}));class he{static{this._INSTANCE=null}static getInstance(){return he._INSTANCE||(he._INSTANCE=new he),he._INSTANCE}constructor(){this._data=Se()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const ze=this._data,Re=ze.length/3;let Xe=1;for(;Xe<=Re;)if(Oe<ze[3*Xe])Xe=2*Xe;else if(Oe>ze[3*Xe+1])Xe=2*Xe+1;else return ze[3*Xe+2];return 0}}function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(Te,Oe){if(Te===0)return 0;const ze=We(Te,Oe);if(ze!==void 0)return ze;const Re=new j(Oe,Te);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=Ue;function We(Te,Oe){const ze=new j(Oe,Te);let Re=ze.prevCodePoint();for(;Ze(Re)||Re===65039||Re===8419;){if(ze.offset===0)return;Re=ze.prevCodePoint()}if(!Z(Re))return;let Xe=ze.offset;return Xe>0&&ze.prevCodePoint()===8205&&(Xe=ze.offset),Xe}function Ze(Te){return 127995<=Te&&Te<=127999}var Qe;(function(Te){Te[Te.zwj=8205]="zwj",Te[Te.emojiVariantSelector=65039]="emojiVariantSelector",Te[Te.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class it{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new D.LRUCachedFunction(Oe=>{function ze(Ye){const rt=new Map;for(let at=0;at<Ye.length;at+=2)rt.set(Ye[at],Ye[at+1]);return rt}function Re(Ye,rt){const at=new Map(Ye);for(const[vt,Ct]of rt)at.set(vt,Ct);return at}function Xe(Ye,rt){if(!Ye)return rt;const at=new Map;for(const[vt,Ct]of Ye)rt.has(vt)&&at.set(vt,Ct);return at}const ce=this.ambiguousCharacterData.value;let ae=Oe.filter(Ye=>!Ye.startsWith("_")&&Ye in ce);ae.length===0&&(ae=["_default"]);let Ie;for(const Ye of ae){const rt=ze(ce[Ye]);Ie=Xe(Ie,rt)}const He=ze(ce._common),Be=Re(He,Ie);return new it(Be)})}static getInstance(Oe){return it.cache.get(Array.from(Oe))}static{this._locales=new F.Lazy(()=>Object.keys(it.ambiguousCharacterData.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it._locales.value}constructor(Oe){this.confusableDictionary=Oe}isAmbiguous(Oe){return this.confusableDictionary.has(Oe)}getPrimaryConfusable(Oe){return this.confusableDictionary.get(Oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=it;class et{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(et.getRawData())),this._data}static isInvisibleCharacter(Oe){return et.getData().has(Oe)}static get codePoints(){return et.getData()}}e.InvisibleCharacters=et}),define(Ce[121],De([1,0,28,15]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function d(...ee){return function(ue,ve){for(let ke=0,$=ee.length;ke<$;ke++){const K=ee[ke](ue,ve);if(K)return K}return null}}e.or=d,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ee,ue,ve){if(!ve||ve.length<ue.length)return null;let ke;return ee?ke=F.startsWithIgnoreCase(ve,ue):ke=ve.indexOf(ue)===0,ke?ue.length>0?[{start:0,end:ue.length}]:[]:null}function A(ee,ue){const ve=ue.toLowerCase().indexOf(ee.toLowerCase());return ve===-1?null:[{start:ve,end:ve+ee.length}]}e.matchesContiguousSubString=A;function p(ee,ue){return _(ee.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=p;function _(ee,ue,ve,ke){if(ve===ee.length)return[];if(ke===ue.length)return null;if(ee[ve]===ue[ke]){let $=null;return($=_(ee,ue,ve+1,ke+1))?o({start:ke,end:ke+1},$):null}return _(ee,ue,ve,ke+1)}function b(ee){return 97<=ee&&ee<=122}function T(ee){return 65<=ee&&ee<=90}e.isUpper=T;function k(ee){return 48<=ee&&ee<=57}function v(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function C(ee){return v(ee)||y.has(ee)}function w(ee,ue){return ee===ue||C(ee)&&C(ue)}function s(ee){return b(ee)||T(ee)||k(ee)}function o(ee,ue){return ue.length===0?ue=[ee]:ee.end===ue[0].start?ue[0].start=ee.start:ue.unshift(ee),ue}function a(ee,ue){for(let ve=ue;ve<ee.length;ve++){const ke=ee.charCodeAt(ve);if(T(ke)||k(ke)||ve>0&&!s(ee.charCodeAt(ve-1)))return ve}return ee.length}function c(ee,ue,ve,ke){if(ve===ee.length)return[];if(ke===ue.length)return null;if(ee[ve]!==ue[ke].toLowerCase())return null;{let $=null,K=ke+1;for($=c(ee,ue,ve+1,ke+1);!$&&(K=a(ue,K))<ue.length;)$=c(ee,ue,ve+1,K),K++;return $===null?null:o({start:ke,end:ke+1},$)}}function g(ee){let ue=0,ve=0,ke=0,$=0,K=0;for(let Se=0;Se<ee.length;Se++)K=ee.charCodeAt(Se),T(K)&&ue++,b(K)&&ve++,s(K)&&ke++,k(K)&&$++;const ie=ue/ee.length,se=ve/ee.length,Q=ke/ee.length,he=$/ee.length;return{upperPercent:ie,lowerPercent:se,alphaPercent:Q,numericPercent:he}}function u(ee){const{upperPercent:ue,lowerPercent:ve}=ee;return ve===0&&ue>.6}function t(ee){const{upperPercent:ue,lowerPercent:ve,alphaPercent:ke,numericPercent:$}=ee;return ve>.2&&ue<.8&&ke>.6&&$<.2}function n(ee){let ue=0,ve=0,ke=0,$=0;for(let K=0;K<ee.length;K++)ke=ee.charCodeAt(K),T(ke)&&ue++,b(ke)&&ve++,v(ke)&&$++;return(ue===0||ve===0)&&$===0?ee.length<=30:ue<=5}function r(ee,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!n(ee)||ue.length>60)return null;const ve=g(ue);if(!t(ve)){if(!u(ve))return null;ue=ue.toLowerCase()}let ke=null,$=0;for(ee=ee.toLowerCase();$<ue.length&&(ke=c(ee,ue,0,$))===null;)$=a(ue,$+1);return ke}e.matchesCamelCase=r;function i(ee,ue,ve=!1){if(!ue||ue.length===0)return null;let ke=null,$=0;for(ee=ee.toLowerCase(),ue=ue.toLowerCase();$<ue.length&&(ke=l(ee,ue,0,$,ve))===null;)$=f(ue,$+1);return ke}e.matchesWords=i;function l(ee,ue,ve,ke,$){if(ve===ee.length)return[];if(ke===ue.length)return null;if(w(ee.charCodeAt(ve),ue.charCodeAt(ke))){let K=null,ie=ke+1;if(K=l(ee,ue,ve+1,ke+1,$),!$)for(;!K&&(ie=f(ue,ie))<ue.length;)K=l(ee,ue,ve+1,ie,$),ie++;return K?ee.charCodeAt(ve)!==ue.charCodeAt(ke)?K:o({start:ke,end:ke+1},K):null}else return null}function f(ee,ue){for(let ve=ue;ve<ee.length;ve++)if(C(ee.charCodeAt(ve))||ve>0&&C(ee.charCodeAt(ve-1)))return ve;return ee.length}const S=d(e.matchesPrefix,r,A),I=d(e.matchesPrefix,r,p),E=new D.LRUCache(1e4);function h(ee,ue,ve=!1){if(typeof ee!="string"||typeof ue!="string")return null;let ke=E.get(ee);ke||(ke=new RegExp(F.convertSimple2RegExpPattern(ee),"i"),E.set(ee,ke));const $=ke.exec(ue);return $?[{start:$.index,end:$.index+$[0].length}]:ve?I(ee,ue):S(ee,ue)}e.matchesFuzzy=h;function m(ee,ue){const ve=me(ee,ee.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ve?O(ve):null}e.matchesFuzzy2=m;function P(ee,ue,ve,ke,$,K){const ie=Math.min(13,ee.length);for(;ve<ie;ve++){const se=me(ee,ue,ve,ke,$,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,K]}e.anyScore=P;function O(ee){if(typeof ee>"u")return[];const ue=[],ve=ee[1];for(let ke=ee.length-1;ke>1;ke--){const $=ee[ke]+ve,K=ue[ue.length-1];K&&K.end===$?K.end=$+1:ue.push({start:$,end:$+1})}return ue}e.createMatches=O;const N=128;function L(){const ee=[],ue=[];for(let ve=0;ve<=N;ve++)ue[ve]=0;for(let ve=0;ve<=N;ve++)ee.push(ue.slice(0));return ee}function U(ee){const ue=[];for(let ve=0;ve<=ee;ve++)ue[ve]=0;return ue}const x=U(2*N),M=U(2*N),H=L(),j=L(),fe=L(),Y=!1;function X(ee,ue,ve,ke,$){function K(se,Q,he=" "){for(;se.length<Q;)se=he+se;return se}let ie=` |   |${ke.split("").map(se=>K(se,3)).join("|")}
`;for(let se=0;se<=ve;se++)se===0?ie+=" |":ie+=`${ue[se-1]}|`,ie+=ee[se].slice(0,$+1).map(Q=>K(Q.toString(),3)).join("|")+`
`;return ie}function z(ee,ue,ve,ke){ee=ee.substr(ue),ve=ve.substr(ke),console.log(X(j,ee,ee.length,ve,ve.length)),console.log(X(fe,ee,ee.length,ve,ve.length)),console.log(X(H,ee,ee.length,ve,ve.length))}function J(ee,ue){if(ue<0||ue>=ee.length)return!1;const ve=ee.codePointAt(ue);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(ve)}}function ge(ee,ue){if(ue<0||ue>=ee.length)return!1;switch(ee.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function le(ee,ue,ve){return ue[ee]!==ve[ee]}function we(ee,ue,ve,ke,$,K,ie=!1){for(;ue<ve&&$<K;)ee[ue]===ke[$]&&(ie&&(x[ue]=$),ue+=1),$+=1;return ue===ve}e.isPatternInWord=we;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var B;(function(ee){ee.Default=[-100,0];function ue(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}ee.isDefault=ue})(B||(e.FuzzyScore=B={}));class V{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ue,ve){this.firstMatchCanBeWeak=ue,this.boostFullMatch=ve}}e.FuzzyScoreOptions=V;function me(ee,ue,ve,ke,$,K,ie=V.default){const se=ee.length>N?N:ee.length,Q=ke.length>N?N:ke.length;if(ve>=se||K>=Q||se-ve>Q-K||!we(ue,ve,se,$,K,Q,!0))return;Z(se,Q,ve,K,ue,$);let he=1,Se=1,Ue=ve,We=K;const Ze=[!1];for(he=1,Ue=ve;Ue<se;he++,Ue++){const Oe=x[Ue],ze=M[Ue],Re=Ue+1<se?M[Ue+1]:Q;for(Se=Oe-K+1,We=Oe;We<Re;Se++,We++){let Xe=Number.MIN_SAFE_INTEGER,ce=!1;We<=ze&&(Xe=ne(ee,ue,Ue,ve,ke,$,We,Q,K,H[he-1][Se-1]===0,Ze));let ae=0;Xe!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Xe+j[he-1][Se-1]);const Ie=We>Oe,He=Ie?j[he][Se-1]+(H[he][Se-1]>0?-5:0):0,Be=We>Oe+1&&H[he][Se-1]>0,Ye=Be?j[he][Se-2]+(H[he][Se-2]>0?-5:0):0;if(Be&&(!Ie||Ye>=He)&&(!ce||Ye>=ae))j[he][Se]=Ye,fe[he][Se]=3,H[he][Se]=0;else if(Ie&&(!ce||He>=ae))j[he][Se]=He,fe[he][Se]=2,H[he][Se]=0;else if(ce)j[he][Se]=ae,fe[he][Se]=1,H[he][Se]=H[he-1][Se-1]+1;else throw new Error("not possible")}}if(Y&&z(ee,ve,ke,K),!Ze[0]&&!ie.firstMatchCanBeWeak)return;he--,Se--;const Qe=[j[he][Se],K];let it=0,et=0;for(;he>=1;){let Oe=Se;do{const ze=fe[he][Oe];if(ze===3)Oe=Oe-2;else if(ze===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&ue[ve+he-1]===$[K+Se-1]&&!le(Oe+K-1,ke,$)&&it+1>H[he][Oe]&&(Oe=Se),Oe===Se?it++:it=1,et||(et=Oe),he--,Se=Oe-1,Qe.push(Se)}Q===se&&ie.boostFullMatch&&(Qe[0]+=2);const Te=et-se;return Qe[0]-=Te,Qe}e.fuzzyScore=me;function Z(ee,ue,ve,ke,$,K){let ie=ee-1,se=ue-1;for(;ie>=ve&&se>=ke;)$[ie]===K[se]&&(M[ie]=se,ie--),se--}function ne(ee,ue,ve,ke,$,K,ie,se,Q,he,Se){if(ue[ve]!==K[ie])return Number.MIN_SAFE_INTEGER;let Ue=1,We=!1;return ie===ve-ke?Ue=ee[ve]===$[ie]?7:5:le(ie,$,K)&&(ie===0||!le(ie-1,$,K))?(Ue=ee[ve]===$[ie]?7:5,We=!0):J(K,ie)&&(ie===0||!J(K,ie-1))?Ue=5:(J(K,ie-1)||ge(K,ie-1))&&(Ue=5,We=!0),Ue>1&&ve===ke&&(Se[0]=!0),We||(We=le(ie,$,K)||J(K,ie-1)||ge(K,ie-1)),ve===ke?ie>Q&&(Ue-=We?3:5):he?Ue+=We?2:0:Ue+=We?0:1,ie+1===se&&(Ue-=We?3:5),Ue}function re(ee,ue,ve,ke,$,K,ie){return oe(ee,ue,ve,ke,$,K,!0,ie)}e.fuzzyScoreGracefulAggressive=re;function ye(ee,ue,ve,ke,$,K,ie){return oe(ee,ue,ve,ke,$,K,!1,ie)}e.fuzzyScoreGraceful=ye;function oe(ee,ue,ve,ke,$,K,ie,se){let Q=me(ee,ue,ve,ke,$,K,se);if(Q&&!ie)return Q;if(ee.length>=3){const he=Math.min(7,ee.length-1);for(let Se=ve+1;Se<he;Se++){const Ue=de(ee,Se);if(Ue){const We=me(Ue,Ue.toLowerCase(),ve,ke,$,K,se);We&&(We[0]-=3,(!Q||We[0]>Q[0])&&(Q=We))}}}return Q}function de(ee,ue){if(ue+1>=ee.length)return;const ve=ee[ue],ke=ee[ue+1];if(ve!==ke)return ee.slice(0,ue)+ke+ve+ee.slice(ue+2)}}),define(Ce[51],De([1,0,15]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(o){return d(o,0)}e.hash=F;function d(o,a){switch(typeof o){case"object":return o===null?R(349,a):Array.isArray(o)?_(o,a):b(o,a);case"string":return p(o,a);case"boolean":return A(o,a);case"number":return R(o,a);case"undefined":return R(937,a);default:return R(617,a)}}e.doHash=d;function R(o,a){return(a<<5)-a+o|0}e.numberHash=R;function A(o,a){return R(o?433:863,a)}function p(o,a){a=R(149417,a);for(let c=0,g=o.length;c<g;c++)a=R(o.charCodeAt(c),a);return a}e.stringHash=p;function _(o,a){return a=R(104579,a),o.reduce((c,g)=>d(g,c),a)}function b(o,a){return a=R(181387,a),Object.keys(o).sort().reduce((c,g)=>(c=p(g,c),d(o[g],c)),a)}class T{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=d(a,this._value),this._value}}e.Hasher=T;var k;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v(o,a,c=32){const g=c-a,u=~((1<<g)-1);return(o<<a|(u&o)>>>g)>>>0}function y(o,a=0,c=o.byteLength,g=0){for(let u=0;u<c;u++)o[a+u]=g}function C(o,a,c="0"){for(;o.length<a;)o=c+o;return o}function w(o,a=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(c=>c.toString(16).padStart(2,"0")).join(""):C((o>>>0).toString(16),a/4)}e.toHexString=w;class s{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const c=a.length;if(c===0)return;const g=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,n,r;for(t!==0?(n=t,r=-1,t=0):(n=a.charCodeAt(0),r=0);;){let i=n;if(D.isHighSurrogate(n))if(r+1<c){const l=a.charCodeAt(r+1);D.isLowSurrogate(l)?(r++,i=D.computeCodePoint(n,l)):i=65533}else{t=n;break}else D.isLowSurrogate(n)&&(i=65533);if(u=this._push(g,u,i),r++,r<c)n=a.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(a,c,g){return g<128?a[c++]=g:g<2048?(a[c++]=192|(g&1984)>>>6,a[c++]=128|(g&63)>>>0):g<65536?(a[c++]=224|(g&61440)>>>12,a[c++]=128|(g&4032)>>>6,a[c++]=128|(g&63)>>>0):(a[c++]=240|(g&1835008)>>>18,a[c++]=128|(g&258048)>>>12,a[c++]=128|(g&4032)>>>6,a[c++]=128|(g&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=s._bigBlock32,c=this._buffDV;for(let S=0;S<64;S+=4)a.setUint32(S,c.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)a.setUint32(S,v(a.getUint32(S-12,!1)^a.getUint32(S-32,!1)^a.getUint32(S-56,!1)^a.getUint32(S-64,!1),1),!1);let g=this._h0,u=this._h1,t=this._h2,n=this._h3,r=this._h4,i,l,f;for(let S=0;S<80;S++)S<20?(i=u&t|~u&n,l=1518500249):S<40?(i=u^t^n,l=1859775393):S<60?(i=u&t|u&n|t&n,l=2400959708):(i=u^t^n,l=3395469782),f=v(g,5)+i+r+l+a.getUint32(S*4,!1)&4294967295,r=n,n=t,t=v(u,30),u=g,g=f;this._h0=this._h0+g&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=s}),define(Ce[38],De([1,0,15]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(F||(F={})),function(d){const R="error",A="warning",p="warn",_="info",b="ignore";function T(v){return v?D.equalsIgnoreCase(R,v)?d.Error:D.equalsIgnoreCase(A,v)||D.equalsIgnoreCase(p,v)?d.Warning:D.equalsIgnoreCase(_,v)?d.Info:d.Ignore:d.Ignore}d.fromValue=T;function k(v){switch(v){case d.Error:return R;case d.Warning:return A;case d.Info:return _;default:return b}}d.toString=k}(F||(F={})),e.default=F}),define(Ce[160],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[78],De([1,0,19,15]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class d{constructor(){this._value="",this._pos=0}reset(y){return this._value=y,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(y){const C=y.charCodeAt(0),w=this._value.charCodeAt(this._pos);return C-w}value(){return this._value[this._pos]}}e.StringIterator=d;class R{constructor(y=!0){this._caseSensitive=y}reset(y){return this._value=y,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let y=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(y)this._from++;else break;else y=!1;return this}cmp(y){return this._caseSensitive?(0,F.compareSubstring)(y,this._value,0,y.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(y,this._value,0,y.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class A{constructor(y=!0,C=!0){this._splitOnBackslash=y,this._caseSensitive=C}reset(y){this._from=0,this._to=0,this._value=y,this._valueLen=y.length;for(let C=y.length-1;C>=0;C--,this._valueLen--){const w=this._value.charCodeAt(C);if(!(w===47||this._splitOnBackslash&&w===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let y=!0;for(;this._to<this._valueLen;this._to++){const C=this._value.charCodeAt(this._to);if(C===47||this._splitOnBackslash&&C===92)if(y)this._from++;else break;else y=!1}return this}cmp(y){return this._caseSensitive?(0,F.compareSubstring)(y,this._value,0,y.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(y,this._value,0,y.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var p;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(p||(p={}));class _{constructor(y,C){this._ignorePathCasing=y,this._ignoreQueryAndFragment=C,this._states=[],this._stateIdx=0}reset(y){return this._value=y,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(y)),this._pathIterator.reset(y.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(y)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(y){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(y,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(y,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(y);if(this._states[this._stateIdx]===4)return(0,F.compare)(y,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(y,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(T||(T={}));class k{static forUris(y=()=>!1,C=()=>!1){return new k(new _(y,C))}static forPaths(y=!1){return new k(new A(void 0,!y))}static forStrings(){return new k(new d)}static forConfigKeys(){return new k(new R)}constructor(y){this._iter=y}clear(){this._root=void 0}fill(y,C){if(C){const w=C.slice(0);(0,D.shuffle)(w);for(const s of w)this.set(s,y)}else{const w=y.slice(0);(0,D.shuffle)(w);for(const s of w)this.set(s[0],s[1])}}set(y,C){const w=this._iter.reset(y);let s;this._root||(this._root=new b,this._root.segment=w.value());const o=[];for(s=this._root;;){const c=w.cmp(s.segment);if(c>0)s.left||(s.left=new b,s.left.segment=w.value()),o.push([-1,s]),s=s.left;else if(c<0)s.right||(s.right=new b,s.right.segment=w.value()),o.push([1,s]),s=s.right;else if(w.hasNext())w.next(),s.mid||(s.mid=new b,s.mid.segment=w.value()),o.push([0,s]),s=s.mid;else break}const a=s.value;s.value=C,s.key=y;for(let c=o.length-1;c>=0;c--){const g=o[c][1];g.updateHeight();const u=g.balanceFactor();if(u<-1||u>1){const t=o[c][0],n=o[c+1][0];if(t===1&&n===1)o[c][1]=g.rotateLeft();else if(t===-1&&n===-1)o[c][1]=g.rotateRight();else if(t===1&&n===-1)g.right=o[c+1][1]=o[c+1][1].rotateRight(),o[c][1]=g.rotateLeft();else if(t===-1&&n===1)g.left=o[c+1][1]=o[c+1][1].rotateLeft(),o[c][1]=g.rotateRight();else throw new Error;if(c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this._root=o[0][1]}}return a}get(y){return this._getNode(y)?.value}_getNode(y){const C=this._iter.reset(y);let w=this._root;for(;w;){const s=C.cmp(w.segment);if(s>0)w=w.left;else if(s<0)w=w.right;else if(C.hasNext())C.next(),w=w.mid;else break}return w}has(y){const C=this._getNode(y);return!(C?.value===void 0&&C?.mid===void 0)}delete(y){return this._delete(y,!1)}deleteSuperstr(y){return this._delete(y,!0)}_delete(y,C){const w=this._iter.reset(y),s=[];let o=this._root;for(;o;){const a=w.cmp(o.segment);if(a>0)s.push([-1,o]),o=o.left;else if(a<0)s.push([1,o]),o=o.right;else if(w.hasNext())w.next(),s.push([0,o]),o=o.mid;else break}if(o){if(C?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const a=this._min(o.right);if(a.key){const{key:c,value:g,segment:u}=a;this._delete(a.key,!1),o.key=c,o.value=g,o.segment=u}}else{const a=o.left??o.right;if(s.length>0){const[c,g]=s[s.length-1];switch(c){case-1:g.left=a;break;case 0:g.mid=a;break;case 1:g.right=a;break}}else this._root=a}for(let a=s.length-1;a>=0;a--){const c=s[a][1];c.updateHeight();const g=c.balanceFactor();if(g>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),s[a][1]=c.rotateLeft()):g<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),s[a][1]=c.rotateRight()),a>0)switch(s[a-1][0]){case-1:s[a-1][1].left=s[a][1];break;case 1:s[a-1][1].right=s[a][1];break;case 0:s[a-1][1].mid=s[a][1];break}else this._root=s[0][1]}}}_min(y){for(;y.left;)y=y.left;return y}findSubstr(y){const C=this._iter.reset(y);let w=this._root,s;for(;w;){const o=C.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(C.hasNext())C.next(),s=w.value||s,w=w.mid;else break}return w&&w.value||s}findSuperstr(y){return this._findSuperstrOrElement(y,!1)}_findSuperstrOrElement(y,C){const w=this._iter.reset(y);let s=this._root;for(;s;){const o=w.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(w.hasNext())w.next(),s=s.mid;else return s.mid?this._entries(s.mid):C?s.value:void 0}}hasElementOrSubtree(y){return this._findSuperstrOrElement(y,!0)!==void 0}forEach(y){for(const[C,w]of this)y(w,C)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(y){const C=[];return this._dfsEntries(y,C),C[Symbol.iterator]()}_dfsEntries(y,C){y&&(y.left&&this._dfsEntries(y.left,C),y.value&&C.push([y.key,y.value]),y.mid&&this._dfsEntries(y.mid,C),y.right&&this._dfsEntries(y.right,C))}_isBalanced(){const y=C=>{if(!C)return!0;const w=C.balanceFactor();return w<-1||w>1?!1:y(C.left)&&y(C.right)};return y(this._root)}}e.TernarySearchTree=k}),define(Ce[18],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(u){return typeof u=="string"}e.isString=D;function F(u){return Array.isArray(u)&&u.every(t=>D(t))}e.isStringArray=F;function d(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=d;function R(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.isTypedArray=R;function A(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=A;function p(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=p;function _(u){return u===!0||u===!1}e.isBoolean=_;function b(u){return typeof u>"u"}e.isUndefined=b;function T(u){return!k(u)}e.isDefined=T;function k(u){return b(u)||u===null}e.isUndefinedOrNull=k;function v(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=v;function y(u){if(k(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=y;function C(...u){const t=[];for(let n=0;n<u.length;n++){const r=u[n];if(k(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(r)}return t}e.assertAllDefined=C;const w=Object.prototype.hasOwnProperty;function s(u){if(!d(u))return!1;for(const t in u)if(w.call(u,t))return!1;return!0}e.isEmptyObject=s;function o(u){return typeof u=="function"}e.isFunction=o;function a(...u){return u.length>0&&u.every(o)}e.areFunctions=a;function c(u,t){const n=Math.min(u.length,t.length);for(let r=0;r<n;r++)g(u[r],t[r])}e.validateConstraints=c;function g(u,t){if(D(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(u instanceof t)return}catch{}if(!k(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g}),define(Ce[79],De([1,0,18]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const F=Object.create(null);function d(p,_){if((0,D.isString)(_)){const b=F[_];if(b===void 0)throw new Error(`${p} references an unknown codicon: ${_}`);_=b}return F[p]=_,{id:p}}function R(){return F}e.getCodiconFontCharacters=R;function A(){return Object.values(e.Codicon)}e.getAllCodicons=A,e.Codicon={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(Ce[23],De([1,0,18]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const a=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([c,g])=>{a[c]=g&&typeof g=="object"?F(g):g}),a}e.deepClone=F;function d(o){if(!o||typeof o!="object")return o;const a=[o];for(;a.length>0;){const c=a.shift();Object.freeze(c);for(const g in c)if(R.call(c,g)){const u=c[g];typeof u=="object"&&!Object.isFrozen(u)&&!(0,D.isTypedArray)(u)&&a.push(u)}}return o}e.deepFreeze=d;const R=Object.prototype.hasOwnProperty;function A(o,a){return p(o,a,new Set)}e.cloneAndChange=A;function p(o,a,c){if((0,D.isUndefinedOrNull)(o))return o;const g=a(o);if(typeof g<"u")return g;if(Array.isArray(o)){const u=[];for(const t of o)u.push(p(t,a,c));return u}if((0,D.isObject)(o)){if(c.has(o))throw new Error("Cannot clone recursive data-structure");c.add(o);const u={};for(const t in o)R.call(o,t)&&(u[t]=p(o[t],a,c));return c.delete(o),u}return o}function _(o,a,c=!0){return(0,D.isObject)(o)?((0,D.isObject)(a)&&Object.keys(a).forEach(g=>{g in o?c&&((0,D.isObject)(o[g])&&(0,D.isObject)(a[g])?_(o[g],a[g],c):o[g]=a[g]):o[g]=a[g]}),o):a}e.mixin=_;function b(o,a){if(o===a)return!0;if(o==null||a===null||a===void 0||typeof o!=typeof a||typeof o!="object"||Array.isArray(o)!==Array.isArray(a))return!1;let c,g;if(Array.isArray(o)){if(o.length!==a.length)return!1;for(c=0;c<o.length;c++)if(!b(o[c],a[c]))return!1}else{const u=[];for(g in o)u.push(g);u.sort();const t=[];for(g in a)t.push(g);if(t.sort(),!b(u,t))return!1;for(c=0;c<u.length;c++)if(!b(o[u[c]],a[u[c]]))return!1}return!0}e.equals=b;function T(o){const a=new Set;return JSON.stringify(o,(c,g)=>{if((0,D.isObject)(g)||Array.isArray(g)){if(a.has(g))return"[Circular]";a.add(g)}return g})}e.safeStringify=T;function k(o,a){const c=Object.create(null);return!o||!a||Object.keys(a).forEach(u=>{const t=o[u],n=a[u];b(t,n)||(c[u]=n)}),c}e.distinct=k;function v(o,a){const c=a.toLowerCase(),g=Object.keys(o).find(u=>u.toLowerCase()===c);return g?o[g]:o[a]}e.getCaseInsensitive=v;function y(o,a){const c=Object.create(null);for(const[g,u]of Object.entries(o))a(g,u)&&(c[g]=u);return c}e.filter=y;function C(o){let a=[];for(;Object.prototype!==o;)a=a.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return a}e.getAllPropertyNames=C;function w(o){const a=[];for(const c of C(o))typeof o[c]=="function"&&a.push(c);return a}e.getAllMethodNames=w;function s(o,a){const c=u=>function(){const t=Array.prototype.slice.call(arguments,0);return a(u,t)},g={};for(const u of o)g[u]=c(u);return g}e.createProxyObject=s}),define(Ce[59],De([1,0,79]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var F;(function(A){function p(_){return _&&typeof _=="object"&&typeof _.id=="string"}A.isThemeColor=p})(F||(e.ThemeColor=F={}));function d(A){return{id:A}}e.themeColorFromId=d;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function _(a){const c=p.exec(a.id);if(!c)return _(D.Codicon.error);const[,g,u]=c,t=["codicon","codicon-"+g];return u&&t.push("codicon-modifier-"+u.substring(1)),t}A.asClassNameArray=_;function b(a){return _(a).join(" ")}A.asClassName=b;function T(a){return"."+_(a).join(".")}A.asCSSSelector=T;function k(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||F.isThemeColor(a.color))}A.isThemeIcon=k;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(a){const c=v.exec(a);if(!c)return;const[,g]=c;return{id:g}}A.fromString=y;function C(a){return{id:a}}A.fromId=C;function w(a,c){let g=a.id;const u=g.lastIndexOf("~");return u!==-1&&(g=g.substring(0,u)),c&&(g=`${g}~${c}`),{id:g}}A.modify=w;function s(a){const c=a.id.lastIndexOf("~");if(c!==-1)return a.id.substring(c+1)}A.getModifier=s;function o(a,c){return a.id===c.id&&a.color?.id===c.color?.id}A.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(Ce[161],De([1,0,121,15,59]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${A.source}`,"g");function _(o){return o.replace(p,(a,c)=>c?a:`\\${a}`)}e.escapeIcons=_;const b=new RegExp(`\\\\${A.source}`,"g");function T(o){return o.replace(b,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=T;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(o){return o.indexOf(R)===-1?o:o.replace(k,(a,c,g,u)=>g?a:c||u||"")}e.stripIcons=v;function y(o){return o?o.replace(/\$\((.*?)\)/g,(a,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=y;const C=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(o){C.lastIndex=0;let a="";const c=[];let g=0;for(;;){const u=C.lastIndex,t=C.exec(o),n=o.substring(u,t?.index);if(n.length>0){a+=n;for(let r=0;r<n.length;r++)c.push(g)}if(!t)break;g+=t[0].length}return{text:a,iconOffsets:c}}e.parseLabelWithIcons=w;function s(o,a,c=!1){const{text:g,iconOffsets:u}=a;if(!u||u.length===0)return(0,D.matchesFuzzy)(o,g,c);const t=(0,F.ltrim)(g," "),n=g.length-t.length,r=(0,D.matchesFuzzy)(o,t,c);if(r)for(const i of r){const l=u[i.start+n]+n;i.start+=l,i.end+=l}return r}e.matchesFuzzyIconAware=s}),define(Ce[122],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var D;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function F(R){return R<0?0:R>255?255:R|0}e.toUint8=F;function d(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=d}),define(Ce[31],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(d){return D.test(d)}e.isUUID=F,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(p){for(let _=0;_<p.length;_++)p[_]=Math.floor(Math.random()*256);return p};const R=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));return function(){d(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let _=0,b="";return b+=A[R[_++]],b+=A[R[_++]],b+=A[R[_++]],b+=A[R[_++]],b+="-",b+=A[R[_++]],b+=A[R[_++]],b+="-",b+=A[R[_++]],b+=A[R[_++]],b+="-",b+=A[R[_++]],b+=A[R[_++]],b+="-",b+=A[R[_++]],b+=A[R[_++]],b+=A[R[_++]],b+=A[R[_++]],b+=A[R[_++]],b+=A[R[_++]],b}}()}),define(Ce[162],De([1,0,19,50,31]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function R(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=R;function A(k,v,y){const C={id:(0,d.generateUuid)(),name:k,uri:v,data:y};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.createFileDataTransferItem=A;class p{constructor(){this._entries=new Map}get size(){let v=0;for(const y of this._entries)v++;return v}has(v){return this._entries.has(this.toKey(v))}matches(v){const y=[...this._entries.keys()];return F.Iterable.some(this,([C,w])=>w.asFile())&&y.push("files"),T(_(v),y)}get(v){return this._entries.get(this.toKey(v))?.[0]}append(v,y){const C=this._entries.get(v);C?C.push(y):this._entries.set(this.toKey(v),[y])}replace(v,y){this._entries.set(this.toKey(v),[y])}delete(v){this._entries.delete(this.toKey(v))}*[Symbol.iterator](){for(const[v,y]of this._entries)for(const C of y)yield[v,C]}toKey(v){return _(v)}}e.VSDataTransfer=p;function _(k){return k.toLowerCase()}function b(k,v){return T(_(k),v.map(_))}e.matchesMimeType=b;function T(k,v){if(k==="*/*")return v.length>0;if(v.includes(k))return!0;const y=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[C,w,s]=y;return s==="*"?v.some(o=>o.startsWith(w+"/")):!1}e.UriList=Object.freeze({create:k=>(0,D.distinct)(k.map(v=>v.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(v=>!v.startsWith("#"))})}),define(Ce[163],De([1,0,60]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function F(p,_,b,T=1){let k=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!k)return k=!0,v(0)},b);d(p,_,T,C=>{if(!k)return k=!0,clearTimeout(y),v(C)})})}e.findFreePort=F;function d(p,_,b,T){if(_===0)return T(0);const k=new D.Socket;k.once("connect",()=>(A(k),d(p+b,_-1,b,T))),k.once("data",()=>{}),k.once("error",v=>(A(k),v.code!=="ECONNREFUSED"?d(p+b,_-1,b,T):T(p))),k.connect(p,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(p,_,b,T="127.0.0.1"){let k=!1,v,y=1;const C=D.createServer({pauseOnConnect:!0});function w(s,o){k||(k=!0,C.removeAllListeners(),C.close(),v&&clearTimeout(v),o(s))}return new Promise(s=>{v=setTimeout(()=>{w(0,s)},b),C.on("listening",()=>{w(p,s)}),C.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<_?(p++,y++,C.listen(p,T)):w(0,s)}),C.on("close",()=>{w(0,s)}),C.listen(p,T)})}e.findFreePortFaster=R;function A(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(_){console.error(_)}}}),define(Ce[123],De([1,0,122]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(p){const _=(0,D.toUint8)(p);this._defaultValue=_,this._asciiMap=F._createAsciiMap(_),this._map=new Map}static _createAsciiMap(p){const _=new Uint8Array(256);return _.fill(p),_}set(p,_){const b=(0,D.toUint8)(_);p>=0&&p<256?this._asciiMap[p]=b:this._map.set(p,b)}get(p){return p>=0&&p<256?this._asciiMap[p]:this._map.get(p)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=F;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class R{constructor(){this._actual=new F(0)}add(p){this._actual.set(p,1)}has(p){return this._actual.get(p)===1}clear(){return this._actual.clear()}}e.CharacterSet=R}),define(Ce[61],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class D{constructor(d,R){this.lineNumber=d,this.column=R}with(d=this.lineNumber,R=this.column){return d===this.lineNumber&&R===this.column?this:new D(d,R)}delta(d=0,R=0){return this.with(this.lineNumber+d,this.column+R)}equals(d){return D.equals(this,d)}static equals(d,R){return!d&&!R?!0:!!d&&!!R&&d.lineNumber===R.lineNumber&&d.column===R.column}isBefore(d){return D.isBefore(this,d)}static isBefore(d,R){return d.lineNumber<R.lineNumber?!0:R.lineNumber<d.lineNumber?!1:d.column<R.column}isBeforeOrEqual(d){return D.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,R){return d.lineNumber<R.lineNumber?!0:R.lineNumber<d.lineNumber?!1:d.column<=R.column}static compare(d,R){const A=d.lineNumber|0,p=R.lineNumber|0;if(A===p){const _=d.column|0,b=R.column|0;return _-b}return A-p}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new D(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.Position=D}),define(Ce[34],De([1,0,61]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(R,A,p,_){R>p||R===p&&A>_?(this.startLineNumber=p,this.startColumn=_,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=p,this.endColumn=_)}isEmpty(){return F.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return F.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return F.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return F.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return F.plusRange(this,R)}static plusRange(R,A){let p,_,b,T;return A.startLineNumber<R.startLineNumber?(p=A.startLineNumber,_=A.startColumn):A.startLineNumber===R.startLineNumber?(p=A.startLineNumber,_=Math.min(A.startColumn,R.startColumn)):(p=R.startLineNumber,_=R.startColumn),A.endLineNumber>R.endLineNumber?(b=A.endLineNumber,T=A.endColumn):A.endLineNumber===R.endLineNumber?(b=A.endLineNumber,T=Math.max(A.endColumn,R.endColumn)):(b=R.endLineNumber,T=R.endColumn),new F(p,_,b,T)}intersectRanges(R){return F.intersectRanges(this,R)}static intersectRanges(R,A){let p=R.startLineNumber,_=R.startColumn,b=R.endLineNumber,T=R.endColumn;const k=A.startLineNumber,v=A.startColumn,y=A.endLineNumber,C=A.endColumn;return p<k?(p=k,_=v):p===k&&(_=Math.max(_,v)),b>y?(b=y,T=C):b===y&&(T=Math.min(T,C)),p>b||p===b&&_>T?null:new F(p,_,b,T)}equalsRange(R){return F.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(R){return new D.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(R){return new D.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new F(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new F(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(R){return new F(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(R){return new F(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new F(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new F(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new F(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const b=R.startLineNumber|0,T=A.startLineNumber|0;if(b===T){const k=R.startColumn|0,v=A.startColumn|0;if(k===v){const y=R.endLineNumber|0,C=A.endLineNumber|0;if(y===C){const w=R.endColumn|0,s=A.endColumn|0;return w-s}return y-C}return k-v}return b-T}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=F}),define(Ce[164],De([1,0,34]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class F{static insert(R,A){return{range:new D.Range(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.EditOperation=F}),define(Ce[165],De([1,0,61,34]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class R extends F.Range{constructor(p,_,b,T){super(p,_,b,T),this.selectionStartLineNumber=p,this.selectionStartColumn=_,this.positionLineNumber=b,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return R.selectionsEqual(this,p)}static selectionsEqual(p,_){return p.selectionStartLineNumber===_.selectionStartLineNumber&&p.selectionStartColumn===_.selectionStartColumn&&p.positionLineNumber===_.positionLineNumber&&p.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,_){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,p,_):new R(p,_,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,_){return this.getDirection()===0?new R(p,_,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,p,_)}static fromPositions(p,_=p){return new R(p.lineNumber,p.column,_.lineNumber,_.column)}static fromRange(p,_){return _===0?new R(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new R(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new R(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,_){if(p&&!_||!p&&_)return!1;if(!p&&!_)return!0;if(p.length!==_.length)return!1;for(let b=0,T=p.length;b<T;b++)if(!this.selectionsEqual(p[b],_[b]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,_,b,T,k){return k===0?new R(p,_,b,T):new R(b,T,p,_)}}e.Selection=R}),define(Ce[166],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[167],De([1,0,123]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class d extends D.CharacterClassifier{constructor(p){super(0);for(let _=0,b=p.length;_<b;_++)this.set(p.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=d;function R(A){const p={};return _=>(p.hasOwnProperty(_)||(p[_]=A(_)),p[_])}e.getMapForWordSeparators=R(A=>new d(A))}),define(Ce[124],De([1,0,50,3,76]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(k=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)k.indexOf(y)>=0||(v+="\\"+y);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function A(k){let v=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)v=k;else{let y="g";k.ignoreCase&&(y+="i"),k.multiline&&(y+="m"),k.unicode&&(y+="u"),v=new RegExp(k.source,y)}return v.lastIndex=0,v}e.ensureValidWordDefinition=A;const p=new d.LinkedList;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function _(k){const v=p.unshift(k);return(0,F.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=_;function b(k,v,y,C,w){if(w||(w=D.Iterable.first(p)),y.length>w.maxLen){let g=k-w.maxLen/2;return g<0?g=0:C+=g,y=y.substring(g,k+w.maxLen/2),b(k,v,y,C,w)}const s=Date.now(),o=k-1-C;let a=-1,c=null;for(let g=1;!(Date.now()-s>=w.timeBudget);g++){const u=o-w.windowSize*g;v.lastIndex=Math.max(0,u);const t=T(v,y,o,a);if(!t&&c||(c=t,u<=0))break;a=u}if(c){const g={word:c[0],startColumn:C+1+c.index,endColumn:C+1+c.index+c[0].length};return v.lastIndex=0,g}return null}e.getWordAtText=b;function T(k,v,y,C){let w;for(;w=k.exec(v);){const s=w.index||0;if(s<=y&&k.lastIndex>=y)return w;if(C>0&&s>C)return null}return null}}),define(Ce[168],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class F{constructor(p){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=p.open,this.close=p.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(p.notIn))for(let _=0,b=p.notIn.length;_<b;_++)switch(p.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(p,_){if(p.getTokenCount()===0)return!0;const b=p.findTokenIndexAtOffset(_-2),T=p.getStandardTokenType(b);return this.isOK(T)}_findNeutralCharacterInRange(p,_){for(let b=p;b<=_;b++){const T=String.fromCharCode(b);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class d{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of p)R(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),R(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),R(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),R(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&R(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=d;function R(A,p,_){A.has(p)?A.get(p).push(_):A.set(p,[_])}}),define(Ce[169],De([1,0,123]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class d{constructor(C,w,s){const o=new Uint8Array(C*w);for(let a=0,c=C*w;a<c;a++)o[a]=s;this._data=o,this.rows=C,this.cols=w}get(C,w){return this._data[C*this.cols+w]}set(C,w,s){this._data[C*this.cols+w]=s}}class R{constructor(C){let w=0,s=0;for(let a=0,c=C.length;a<c;a++){const[g,u,t]=C[a];u>w&&(w=u),g>s&&(s=g),t>s&&(s=t)}w++,s++;const o=new d(s,w,0);for(let a=0,c=C.length;a<c;a++){const[g,u,t]=C[a];o.set(g,u,t)}this._states=o,this._maxCharCode=w}nextState(C,w){return w<0||w>=this._maxCharCode?0:this._states.get(C,w)}}e.StateMachine=R;let A=null;function p(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var _;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let b=null;function T(){if(b===null){b=new D.CharacterClassifier(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<y.length;w++)b.set(y.charCodeAt(w),1);const C=".,;:";for(let w=0;w<C.length;w++)b.set(C.charCodeAt(w),2)}return b}class k{static _createLink(C,w,s,o,a){let c=a-1;do{const g=w.charCodeAt(c);if(C.get(g)!==2)break;c--}while(c>o);if(o>0){const g=w.charCodeAt(o-1),u=w.charCodeAt(c);(g===40&&u===41||g===91&&u===93||g===123&&u===125)&&c--}return{range:{startLineNumber:s,startColumn:o+1,endLineNumber:s,endColumn:c+2},url:w.substring(o,c+1)}}static computeLinks(C,w=p()){const s=T(),o=[];for(let a=1,c=C.getLineCount();a<=c;a++){const g=C.getLineContent(a),u=g.length;let t=0,n=0,r=0,i=1,l=!1,f=!1,S=!1,I=!1;for(;t<u;){let E=!1;const h=g.charCodeAt(t);if(i===13){let m;switch(h){case 40:l=!0,m=0;break;case 41:m=l?0:1;break;case 91:S=!0,f=!0,m=0;break;case 93:S=!1,m=f?0:1;break;case 123:I=!0,m=0;break;case 125:m=I?0:1;break;case 39:case 34:case 96:r===h?m=1:r===39||r===34||r===96?m=0:m=1;break;case 42:m=r===42?1:0;break;case 124:m=r===124?1:0;break;case 32:m=S?0:1;break;default:m=s.get(h)}m===1&&(o.push(k._createLink(s,g,a,n,t)),E=!0)}else if(i===12){let m;h===91?(f=!0,m=0):m=s.get(h),m===1?E=!0:i=13}else i=w.nextState(i,h),i===0&&(E=!0);E&&(i=1,l=!1,f=!1,I=!1,n=t+1,r=h),t++}i===13&&o.push(k._createLink(s,g,a,n,u))}return o}}e.LinkComputer=k;function v(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:k.computeLinks(y)}e.computeLinks=v}),define(Ce[125],De([1,0,23]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var d;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var R;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var p;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var _;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(_||(e.DefaultEndOfLine=_={}));var b;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class T{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,u.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this._indentSizeIsTabSize===u._indentSizeIsTabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class k{constructor(u,t){this._findMatchBrand=void 0,this.range=u,this.matches=t}}e.FindMatch=k;var v;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function y(g){return g&&typeof g.read=="function"}e.isITextSnapshot=y;var C;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var w;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class s{constructor(u,t,n,r,i,l){this.identifier=u,this.range=t,this.text=n,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=i,this._isTracked=l}}e.ValidAnnotatedEditOperation=s;class o{constructor(u,t,n){this.regex=u,this.wordSeparators=t,this.simpleSearch=n}}e.SearchData=o;class a{constructor(u,t,n){this.reverseEdits=u,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=a;function c(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=c}),define(Ce[170],De([1,0,19,122]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class d{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,b){_=(0,F.toUint32)(_);const T=this.values,k=this.prefixSum,v=b.length;return v===0?!1:(this.values=new Uint32Array(T.length+v),this.values.set(T.subarray(0,_),0),this.values.set(T.subarray(_),_+v),this.values.set(b,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,b){return _=(0,F.toUint32)(_),b=(0,F.toUint32)(b),this.values[_]===b?!1:(this.values[_]=b,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,b){_=(0,F.toUint32)(_),b=(0,F.toUint32)(b);const T=this.values,k=this.prefixSum;if(_>=T.length)return!1;const v=T.length-_;return b>=v&&(b=v),b===0?!1:(this.values=new Uint32Array(T.length-b),this.values.set(T.subarray(0,_),0),this.values.set(T.subarray(_+b),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,F.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let b=this.prefixSumValidIndex[0]+1;b===0&&(this.prefixSum[0]=this.values[0],b++),_>=this.values.length&&(_=this.values.length-1);for(let T=b;T<=_;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let b=0,T=this.values.length-1,k=0,v=0,y=0;for(;b<=T;)if(k=b+(T-b)/2|0,v=this.prefixSum[k],y=v-this.values[k],_<y)T=k-1;else if(_>=v)b=k+1;else break;return new A(k,_-y)}}e.PrefixSumComputer=d;class R{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const b=this._indexBySum[_],T=b>0?this._prefixSum[b-1]:0;return new A(b,_-T)}removeValues(_,b){this._values.splice(_,b),this._invalidate(_)}insertValues(_,b){this._values=(0,D.arrayInsert)(this._values,_,b),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,b=this._values.length;_<b;_++){const T=this._values[_],k=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=k+T;for(let v=0;v<T;v++)this._indexBySum[k+v]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,b){this._values[_]!==b&&(this._values[_]=b,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=R;class A{constructor(_,b){this.index=_,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=b}}e.PrefixSumIndexOfResult=A}),define(Ce[171],De([1,0,15,61,170]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(p,_,b,T){this._uri=p,this._lines=_,this._eol=b,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(p){p.eol&&p.eol!==this._eol&&(this._eol=p.eol,this._lineStarts=null);const _=p.changes;for(const b of _)this._acceptDeleteRange(b.range),this._acceptInsertText(new F.Position(b.range.startLineNumber,b.range.startColumn),b.text);this._versionId=p.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const p=this._eol.length,_=this._lines.length,b=new Uint32Array(_);for(let T=0;T<_;T++)b[T]=this._lines[T].length+p;this._lineStarts=new d.PrefixSumComputer(b)}}_setLineText(p,_){this._lines[p]=_,this._lineStarts&&this._lineStarts.setValue(p,this._lines[p].length+this._eol.length)}_acceptDeleteRange(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this._setLineText(p.startLineNumber-1,this._lines[p.startLineNumber-1].substring(0,p.startColumn-1)+this._lines[p.startLineNumber-1].substring(p.endColumn-1));return}this._setLineText(p.startLineNumber-1,this._lines[p.startLineNumber-1].substring(0,p.startColumn-1)+this._lines[p.endLineNumber-1].substring(p.endColumn-1)),this._lines.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}_acceptInsertText(p,_){if(_.length===0)return;const b=(0,D.splitLines)(_);if(b.length===1){this._setLineText(p.lineNumber-1,this._lines[p.lineNumber-1].substring(0,p.column-1)+b[0]+this._lines[p.lineNumber-1].substring(p.column-1));return}b[b.length-1]+=this._lines[p.lineNumber-1].substring(p.column-1),this._setLineText(p.lineNumber-1,this._lines[p.lineNumber-1].substring(0,p.column-1)+b[0]);const T=new Uint32Array(b.length-1);for(let k=1;k<b.length;k++)this._lines.splice(p.lineNumber+k-1,0,b[k]),T[k-1]=b[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(p.lineNumber,T)}}e.MirrorTextModel=R}),define(Ce[172],De([1,0,15,167,61,34,125]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const p=999;class _{constructor(a,c,g,u){this.searchString=a,this.isRegex=c,this.matchCase=g,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=b(this.searchString):a=this.searchString.indexOf(`
`)>=0;let c=null;try{c=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!c)return null;let g=!this.isRegex&&!a;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new A.SearchData(c,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function b(o){if(!o||o.length===0)return!1;for(let a=0,c=o.length;a<c;a++){const g=o.charCodeAt(a);if(g===10)return!0;if(g===92){if(a++,a>=c)break;const u=o.charCodeAt(a);if(u===110||u===114||u===87)return!0}}return!1}e.isMultilineRegexSource=b;function T(o,a,c){if(!c)return new A.FindMatch(o,null);const g=[];for(let u=0,t=a.length;u<t;u++)g[u]=a[u];return new A.FindMatch(o,g)}e.createFindMatch=T;class k{constructor(a){const c=[];let g=0;for(let u=0,t=a.length;u<t;u++)a.charCodeAt(u)===10&&(c[g++]=u);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(a){const c=this._lineFeedsOffsets;let g=0,u=c.length-1;if(u===-1||a<=c[0])return 0;for(;g<u;){const t=g+((u-g)/2>>0);c[t]>=a?u=t-1:c[t+1]>=a?(g=t,u=t):g=t+1}return g+1}}class v{static findMatches(a,c,g,u,t){const n=c.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(a,g,new s(n.wordSeparators,n.regex),u,t):this._doFindMatchesLineByLine(a,g,n,u,t):[]}static _getMultilineMatchRange(a,c,g,u,t,n){let r,i=0;u?(i=u.findLineFeedCountBeforeOffset(t),r=c+t+i):r=c+t;let l;if(u){const E=u.findLineFeedCountBeforeOffset(t+n.length)-i;l=r+n.length+E}else l=r+n.length;const f=a.getPositionAt(r),S=a.getPositionAt(l);return new R.Range(f.lineNumber,f.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(a,c,g,u,t){const n=a.getOffsetAt(c.getStartPosition()),r=a.getValueInRange(c,1),i=a.getEOL()===`\r
`?new k(r):null,l=[];let f=0,S;for(g.reset(0);S=g.next(r);)if(l[f++]=T(this._getMultilineMatchRange(a,n,r,i,S.index,S[0]),S,u),f>=t)return l;return l}static _doFindMatchesLineByLine(a,c,g,u,t){const n=[];let r=0;if(c.startLineNumber===c.endLineNumber){const l=a.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this._findMatchesInLine(g,l,c.startLineNumber,c.startColumn-1,r,n,u,t),n}const i=a.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this._findMatchesInLine(g,i,c.startLineNumber,c.startColumn-1,r,n,u,t);for(let l=c.startLineNumber+1;l<c.endLineNumber&&r<t;l++)r=this._findMatchesInLine(g,a.getLineContent(l),l,0,r,n,u,t);if(r<t){const l=a.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this._findMatchesInLine(g,l,c.endLineNumber,0,r,n,u,t)}return n}static _findMatchesInLine(a,c,g,u,t,n,r,i){const l=a.wordSeparators;if(!r&&a.simpleSearch){const I=a.simpleSearch,E=I.length,h=c.length;let m=-E;for(;(m=c.indexOf(I,m+E))!==-1;)if((!l||w(l,c,h,m,E))&&(n[t++]=new A.FindMatch(new R.Range(g,m+1+u,g,m+1+E+u),null),t>=i))return t;return t}const f=new s(a.wordSeparators,a.regex);let S;f.reset(0);do if(S=f.next(c),S&&(n[t++]=T(new R.Range(g,S.index+1+u,g,S.index+1+S[0].length+u),S,r),t>=i))return t;while(S);return t}static findNextMatch(a,c,g,u){const t=c.parseSearchRequest();if(!t)return null;const n=new s(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(a,g,n,u):this._doFindNextMatchLineByLine(a,g,n,u)}static _doFindNextMatchMultiline(a,c,g,u){const t=new d.Position(c.lineNumber,1),n=a.getOffsetAt(t),r=a.getLineCount(),i=a.getValueInRange(new R.Range(t.lineNumber,t.column,r,a.getLineMaxColumn(r)),1),l=a.getEOL()===`\r
`?new k(i):null;g.reset(c.column-1);const f=g.next(i);return f?T(this._getMultilineMatchRange(a,n,i,l,f.index,f[0]),f,u):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(a,new d.Position(1,1),g,u):null}static _doFindNextMatchLineByLine(a,c,g,u){const t=a.getLineCount(),n=c.lineNumber,r=a.getLineContent(n),i=this._findFirstMatchInLine(g,r,n,c.column,u);if(i)return i;for(let l=1;l<=t;l++){const f=(n+l-1)%t,S=a.getLineContent(f+1),I=this._findFirstMatchInLine(g,S,f+1,1,u);if(I)return I}return null}static _findFirstMatchInLine(a,c,g,u,t){a.reset(u-1);const n=a.next(c);return n?T(new R.Range(g,n.index+1,g,n.index+1+n[0].length),n,t):null}static findPreviousMatch(a,c,g,u){const t=c.parseSearchRequest();if(!t)return null;const n=new s(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(a,g,n,u):this._doFindPreviousMatchLineByLine(a,g,n,u)}static _doFindPreviousMatchMultiline(a,c,g,u){const t=this._doFindMatchesMultiline(a,new R.Range(1,1,c.lineNumber,c.column),g,u,10*p);if(t.length>0)return t[t.length-1];const n=a.getLineCount();return c.lineNumber!==n||c.column!==a.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(a,new d.Position(n,a.getLineMaxColumn(n)),g,u):null}static _doFindPreviousMatchLineByLine(a,c,g,u){const t=a.getLineCount(),n=c.lineNumber,r=a.getLineContent(n).substring(0,c.column-1),i=this._findLastMatchInLine(g,r,n,u);if(i)return i;for(let l=1;l<=t;l++){const f=(t+n-l-1)%t,S=a.getLineContent(f+1),I=this._findLastMatchInLine(g,S,f+1,u);if(I)return I}return null}static _findLastMatchInLine(a,c,g,u){let t=null,n;for(a.reset(0);n=a.next(c);)t=T(new R.Range(g,n.index+1,g,n.index+1+n[0].length),n,u);return t}}e.TextModelSearch=v;function y(o,a,c,g,u){if(g===0)return!0;const t=a.charCodeAt(g-1);if(o.get(t)!==0||t===13||t===10)return!0;if(u>0){const n=a.charCodeAt(g);if(o.get(n)!==0)return!0}return!1}function C(o,a,c,g,u){if(g+u===c)return!0;const t=a.charCodeAt(g+u);if(o.get(t)!==0||t===13||t===10)return!0;if(u>0){const n=a.charCodeAt(g+u-1);if(o.get(n)!==0)return!0}return!1}function w(o,a,c,g,u){return y(o,a,c,g,u)&&C(o,a,c,g,u)}e.isValidMatch=w;class s{constructor(a,c){this._wordSeparators=a,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const c=a.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(g=this._searchRegex.exec(a),!g))return null;const u=g.index,t=g[0].length;if(u===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){D.getNextCodePoint(a,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=t,!this._wordSeparators||w(this._wordSeparators,a,c,u,t))return g}while(g);return null}}e.Searcher=s}),define(Ce[173],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class D{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const A=this._dragOperations.get(R);return this._dragOperations.delete(R),A}}addDragOperationTransfer(R,A){this._dragOperations.set(R,A)}}e.TreeViewsDnDService=D;class F{constructor(R){this.identifier=R}}e.DraggedTreeItemsIdentifier=F}),define(Ce[174],De([1,0,4,3]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class d{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(p){this._onDidChange.fire({changedLanguages:p,changedColorMap:!1})}register(p,_){return this._tokenizationSupports.set(p,_),this.handleChange([p]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(p)===_&&(this._tokenizationSupports.delete(p),this.handleChange([p]))})}get(p){return this._tokenizationSupports.get(p)||null}registerFactory(p,_){this._factories.get(p)?.dispose();const b=new R(this,p,_);return this._factories.set(p,b),(0,F.toDisposable)(()=>{const T=this._factories.get(p);!T||T!==b||(this._factories.delete(p),T.dispose())})}async getOrCreate(p){const _=this.get(p);if(_)return _;const b=this._factories.get(p);return!b||b.isResolved?null:(await b.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const b=this._factories.get(p);return!!(!b||b.isResolved)}setColorMap(p){this._colorMap=p,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=d;class R extends F.Disposable{get isResolved(){return this._isResolved}constructor(p,_,b){super(),this._registry=p,this._languageId=_,this._factory=b,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const p=await this._factory.tokenizationSupport;this._isResolved=!0,p&&!this._isDisposed&&this._register(this._registry.register(this._languageId,p))}}}),define(Ce[175],De([10,11]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Ce[176],De([1,0,4,3,175]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends F.Disposable{constructor(v,y="",C="",w=!0,s){super(),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=v,this._label=y,this._cssClass=C,this._enabled=w,this._actionCallback=s}get id(){return this._id}get label(){return this._label}set label(v){this._setLabel(v)}_setLabel(v){this._label!==v&&(this._label=v,this._onDidChange.fire({label:v}))}get tooltip(){return this._tooltip||""}set tooltip(v){this._setTooltip(v)}_setTooltip(v){this._tooltip!==v&&(this._tooltip=v,this._onDidChange.fire({tooltip:v}))}get class(){return this._cssClass}set class(v){this._setClass(v)}_setClass(v){this._cssClass!==v&&(this._cssClass=v,this._onDidChange.fire({class:v}))}get enabled(){return this._enabled}set enabled(v){this._setEnabled(v)}_setEnabled(v){this._enabled!==v&&(this._enabled=v,this._onDidChange.fire({enabled:v}))}get checked(){return this._checked}set checked(v){this._setChecked(v)}_setChecked(v){this._checked!==v&&(this._checked=v,this._onDidChange.fire({checked:v}))}async run(v,y){this._actionCallback&&await this._actionCallback(v)}}e.Action=R;class A extends F.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new D.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new D.Emitter),this.onDidRun=this._onDidRun.event}async run(v,y){if(!v.enabled)return;this._onWillRun.fire({action:v});let C;try{await this.runAction(v,y)}catch(w){C=w}this._onDidRun.fire({action:v,error:C})}async runAction(v,y){await v.run(y)}}e.ActionRunner=A;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let y=[];for(const C of v)C.length&&(y.length?y=[...y,new p,...C]:y=C);return y}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=p;class _{get actions(){return this._actions}constructor(v,y,C,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=y,this.class=w,this._actions=C}async run(){}}e.SubmenuAction=_;class b extends R{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,d.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=b;function T(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...v)=>k.run(...v),tooltip:k.label}}e.toAction=T}),define(Ce[177],De([10,11]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Ce[178],De([1,0,177]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,d=F*60,R=d*24,A=R*7,p=R*30,_=R*365;function b(k,v,y,C){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,D.localize)(0,null,b(new Date().getTime()+w*1e3,!1));if(!C&&w<30)return(0,D.localize)(1,null);let s;return w<F?(s=w,v?s===1?y?(0,D.localize)(2,null,s):(0,D.localize)(3,null,s):y?(0,D.localize)(4,null,s):(0,D.localize)(5,null,s):s===1?y?(0,D.localize)(6,null,s):(0,D.localize)(7,null,s):y?(0,D.localize)(8,null,s):(0,D.localize)(9,null,s)):w<d?(s=Math.floor(w/F),v?s===1?y?(0,D.localize)(10,null,s):(0,D.localize)(11,null,s):y?(0,D.localize)(12,null,s):(0,D.localize)(13,null,s):s===1?y?(0,D.localize)(14,null,s):(0,D.localize)(15,null,s):y?(0,D.localize)(16,null,s):(0,D.localize)(17,null,s)):w<R?(s=Math.floor(w/d),v?s===1?y?(0,D.localize)(18,null,s):(0,D.localize)(19,null,s):y?(0,D.localize)(20,null,s):(0,D.localize)(21,null,s):s===1?y?(0,D.localize)(22,null,s):(0,D.localize)(23,null,s):y?(0,D.localize)(24,null,s):(0,D.localize)(25,null,s)):w<A?(s=Math.floor(w/R),v?s===1?(0,D.localize)(26,null,s):(0,D.localize)(27,null,s):s===1?(0,D.localize)(28,null,s):(0,D.localize)(29,null,s)):w<p?(s=Math.floor(w/A),v?s===1?y?(0,D.localize)(30,null,s):(0,D.localize)(31,null,s):y?(0,D.localize)(32,null,s):(0,D.localize)(33,null,s):s===1?y?(0,D.localize)(34,null,s):(0,D.localize)(35,null,s):y?(0,D.localize)(36,null,s):(0,D.localize)(37,null,s)):w<_?(s=Math.floor(w/p),v?s===1?y?(0,D.localize)(38,null,s):(0,D.localize)(39,null,s):y?(0,D.localize)(40,null,s):(0,D.localize)(41,null,s):s===1?y?(0,D.localize)(42,null,s):(0,D.localize)(43,null,s):y?(0,D.localize)(44,null,s):(0,D.localize)(45,null,s)):(s=Math.floor(w/_),v?s===1?y?(0,D.localize)(46,null,s):(0,D.localize)(47,null,s):y?(0,D.localize)(48,null,s):(0,D.localize)(49,null,s):s===1?y?(0,D.localize)(50,null,s):(0,D.localize)(51,null,s):y?(0,D.localize)(52,null,s):(0,D.localize)(53,null,s))}e.fromNow=b;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(Ce[179],De([10,11]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Ce[46],De([1,0,19,18,179]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,v){return v&&(k.stack||k.stacktrace)?d.localize(0,null,p(k),A(k.stack)||A(k.stacktrace)):p(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function p(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?d.localize(1,null,k.message):k.message||d.localize(2,null)}function _(k=null,v=!1){if(!k)return d.localize(3,null);if(Array.isArray(k)){const y=D.coalesce(k),C=_(y[0],v);return y.length>1?d.localize(4,null,C,y.length):C}if(F.isString(k))return k;if(k.detail){const y=k.detail;if(y.error)return R(y.error,v);if(y.exception)return R(y.exception,v)}return k.stack?R(k,v):k.message?k.message:d.localize(5,null)}e.toErrorMessage=_;function b(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=b;function T(k,v){let y;return typeof k=="string"?y=new Error(k):y=k,y.actions=v,y}e.createErrorWithActions=T}),define(Ce[180],De([10,11]),function(pe,e){return pe.create("vs/base/common/platform",e)}),define(Ce[12],De([1,0,180]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let F=!1,d=!1,R=!1,A=!1,p=!1,_=!1,b=!1,T=!1,k=!1,v=!1,y,C=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,s,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?a=e.globals.vscode.process:typeof process<"u"&&(a=process);const c=typeof a?.versions?.electron=="string",g=c&&a?.type==="renderer";if(typeof navigator=="object"&&!g)o=navigator.userAgent,F=o.indexOf("Windows")>=0,d=o.indexOf("Macintosh")>=0,T=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,v=o?.indexOf("Mobi")>=0,_=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,C=y,w=navigator.language;else if(typeof a=="object"){F=a.platform==="win32",d=a.platform==="darwin",R=a.platform==="linux",A=R&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,b=c,k=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const I=a.env.VSCODE_NLS_CONFIG;if(I)try{const E=JSON.parse(I),h=E.availableLanguages["*"];y=E.locale,w=E.osLocale,C=h||e.LANGUAGE_DEFAULT,s=E._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var u;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let n=0;d?n=1:F?n=3:R&&(n=2),e.isWindows=F,e.isMacintosh=d,e.isLinux=R,e.isLinuxSnap=A,e.isNative=p,e.isElectron=b,e.isWeb=_,e.isWebWorker=_&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=v,e.isCI=k,e.platform=n,e.userAgent=o,e.language=C;var r;(function(I){function E(){return e.language}I.value=E;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=h;function m(){return e.language==="en"}I.isDefault=m})(r||(e.Language=r={})),e.locale=y,e.platformLocale=w,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let m=0,P=I.length;m<P;m++){const O=I[m];if(O.id===h.data.vscodeScheduleAsyncWork){I.splice(m,1),O.callback();return}}});let E=0;return h=>{const m=++E;I.push({id:m,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:m},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=d||T?2:F?1:3;let l=!0,f=!1;function S(){if(!f){f=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,l=new Uint16Array(I.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=S,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[47],De([1,0,12]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let F;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const d=D.globals.vscode.process;F={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.arch=F.arch}),define(Ce[16],De([1,0,47]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,d=97,R=90,A=122,p=46,_=47,b=92,T=58,k=63;class v extends Error{constructor(n,r,i){let l;typeof r=="string"&&r.indexOf("not ")===0?(l="must not be",r=r.replace(/^not /,"")):l="must be";const f=n.indexOf(".")!==-1?"property":"argument";let S=`The "${n}" ${f} ${l} of type ${r}`;S+=`. Received type ${typeof i}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new v(n,"Object",t)}function C(t,n){if(typeof t!="string")throw new v(n,"string",t)}const w=D.platform==="win32";function s(t){return t===_||t===b}function o(t){return t===_}function a(t){return t>=F&&t<=R||t>=d&&t<=A}function c(t,n,r,i){let l="",f=0,S=-1,I=0,E=0;for(let h=0;h<=t.length;++h){if(h<t.length)E=t.charCodeAt(h);else{if(i(E))break;E=_}if(i(E)){if(!(S===h-1||I===1))if(I===2){if(l.length<2||f!==2||l.charCodeAt(l.length-1)!==p||l.charCodeAt(l.length-2)!==p){if(l.length>2){const m=l.lastIndexOf(r);m===-1?(l="",f=0):(l=l.slice(0,m),f=l.length-1-l.lastIndexOf(r)),S=h,I=0;continue}else if(l.length!==0){l="",f=0,S=h,I=0;continue}}n&&(l+=l.length>0?`${r}..`:"..",f=2)}else l.length>0?l+=`${r}${t.slice(S+1,h)}`:l=t.slice(S+1,h),f=h-S-1;S=h,I=0}else E===p&&I!==-1?++I:I=-1}return l}function g(t,n){y(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let n="",r="",i=!1;for(let l=t.length-1;l>=-1;l--){let f;if(l>=0){if(f=t[l],C(f,"path"),f.length===0)continue}else n.length===0?f=D.cwd():(f=D.env[`=${n}`]||D.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==n.toLowerCase()&&f.charCodeAt(2)===b)&&(f=`${n}\\`));const S=f.length;let I=0,E="",h=!1;const m=f.charCodeAt(0);if(S===1)s(m)&&(I=1,h=!0);else if(s(m))if(h=!0,s(f.charCodeAt(1))){let P=2,O=P;for(;P<S&&!s(f.charCodeAt(P));)P++;if(P<S&&P!==O){const N=f.slice(O,P);for(O=P;P<S&&s(f.charCodeAt(P));)P++;if(P<S&&P!==O){for(O=P;P<S&&!s(f.charCodeAt(P));)P++;(P===S||P!==O)&&(E=`\\\\${N}\\${f.slice(O,P)}`,I=P)}}}else I=1;else a(m)&&f.charCodeAt(1)===T&&(E=f.slice(0,2),I=2,S>2&&s(f.charCodeAt(2))&&(h=!0,I=3));if(E.length>0)if(n.length>0){if(E.toLowerCase()!==n.toLowerCase())continue}else n=E;if(i){if(n.length>0)break}else if(r=`${f.slice(I)}\\${r}`,i=h,h&&n.length>0)break}return r=c(r,!i,"\\",s),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){C(t,"path");const n=t.length;if(n===0)return".";let r=0,i,l=!1;const f=t.charCodeAt(0);if(n===1)return o(f)?"\\":t;if(s(f))if(l=!0,s(t.charCodeAt(1))){let I=2,E=I;for(;I<n&&!s(t.charCodeAt(I));)I++;if(I<n&&I!==E){const h=t.slice(E,I);for(E=I;I<n&&s(t.charCodeAt(I));)I++;if(I<n&&I!==E){for(E=I;I<n&&!s(t.charCodeAt(I));)I++;if(I===n)return`\\\\${h}\\${t.slice(E)}\\`;I!==E&&(i=`\\\\${h}\\${t.slice(E,I)}`,r=I)}}}else r=1;else a(f)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),r=2,n>2&&s(t.charCodeAt(2))&&(l=!0,r=3));let S=r<n?c(t.slice(r),!l,"\\",s):"";return S.length===0&&!l&&(S="."),S.length>0&&s(t.charCodeAt(n-1))&&(S+="\\"),i===void 0?l?`\\${S}`:S:l?`${i}\\${S}`:`${i}${S}`},isAbsolute(t){C(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return s(r)||n>2&&a(r)&&t.charCodeAt(1)===T&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let f=0;f<t.length;++f){const S=t[f];C(S,"path"),S.length>0&&(n===void 0?n=r=S:n+=`\\${S}`)}if(n===void 0)return".";let i=!0,l=0;if(typeof r=="string"&&s(r.charCodeAt(0))){++l;const f=r.length;f>1&&s(r.charCodeAt(1))&&(++l,f>2&&(s(r.charCodeAt(2))?++l:i=!1))}if(i){for(;l<n.length&&s(n.charCodeAt(l));)l++;l>=2&&(n=`\\${n.slice(l)}`)}return e.win32.normalize(n)},relative(t,n){if(C(t,"from"),C(n,"to"),t===n)return"";const r=e.win32.resolve(t),i=e.win32.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===b;)l++;let f=t.length;for(;f-1>l&&t.charCodeAt(f-1)===b;)f--;const S=f-l;let I=0;for(;I<n.length&&n.charCodeAt(I)===b;)I++;let E=n.length;for(;E-1>I&&n.charCodeAt(E-1)===b;)E--;const h=E-I,m=S<h?S:h;let P=-1,O=0;for(;O<m;O++){const L=t.charCodeAt(l+O);if(L!==n.charCodeAt(I+O))break;L===b&&(P=O)}if(O!==m){if(P===-1)return i}else{if(h>m){if(n.charCodeAt(I+O)===b)return i.slice(I+O+1);if(O===2)return i.slice(I+O)}S>m&&(t.charCodeAt(l+O)===b?P=O:O===2&&(P=3)),P===-1&&(P=0)}let N="";for(O=l+P+1;O<=f;++O)(O===f||t.charCodeAt(O)===b)&&(N+=N.length===0?"..":"\\..");return I+=P,N.length>0?`${N}${i.slice(I,E)}`:(i.charCodeAt(I)===b&&++I,i.slice(I,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===b){if(n.charCodeAt(1)===b){const r=n.charCodeAt(2);if(r!==k&&r!==p)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(a(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===b)return`\\\\?\\${n}`;return t},dirname(t){C(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const l=t.charCodeAt(0);if(n===1)return s(l)?t:".";if(s(l)){if(r=i=1,s(t.charCodeAt(1))){let I=2,E=I;for(;I<n&&!s(t.charCodeAt(I));)I++;if(I<n&&I!==E){for(E=I;I<n&&s(t.charCodeAt(I));)I++;if(I<n&&I!==E){for(E=I;I<n&&!s(t.charCodeAt(I));)I++;if(I===n)return t;I!==E&&(r=i=I+1)}}}}else a(l)&&t.charCodeAt(1)===T&&(r=n>2&&s(t.charCodeAt(2))?3:2,i=r);let f=-1,S=!0;for(let I=n-1;I>=i;--I)if(s(t.charCodeAt(I))){if(!S){f=I;break}}else S=!1;if(f===-1){if(r===-1)return".";f=r}return t.slice(0,f)},basename(t,n){n!==void 0&&C(n,"ext"),C(t,"path");let r=0,i=-1,l=!0,f;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let S=n.length-1,I=-1;for(f=t.length-1;f>=r;--f){const E=t.charCodeAt(f);if(s(E)){if(!l){r=f+1;break}}else I===-1&&(l=!1,I=f+1),S>=0&&(E===n.charCodeAt(S)?--S===-1&&(i=f):(S=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(f=t.length-1;f>=r;--f)if(s(t.charCodeAt(f))){if(!l){r=f+1;break}}else i===-1&&(l=!1,i=f+1);return i===-1?"":t.slice(r,i)},extname(t){C(t,"path");let n=0,r=-1,i=0,l=-1,f=!0,S=0;t.length>=2&&t.charCodeAt(1)===T&&a(t.charCodeAt(0))&&(n=i=2);for(let I=t.length-1;I>=n;--I){const E=t.charCodeAt(I);if(s(E)){if(!f){i=I+1;break}continue}l===-1&&(f=!1,l=I+1),E===p?r===-1?r=I:S!==1&&(S=1):r!==-1&&(S=-1)}return r===-1||l===-1||S===0||S===1&&r===l-1&&r===i+1?"":t.slice(r,l)},format:g.bind(null,"\\"),parse(t){C(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,l=t.charCodeAt(0);if(r===1)return s(l)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(s(l)){if(i=1,s(t.charCodeAt(1))){let P=2,O=P;for(;P<r&&!s(t.charCodeAt(P));)P++;if(P<r&&P!==O){for(O=P;P<r&&s(t.charCodeAt(P));)P++;if(P<r&&P!==O){for(O=P;P<r&&!s(t.charCodeAt(P));)P++;P===r?i=P:P!==O&&(i=P+1)}}}}else if(a(l)&&t.charCodeAt(1)===T){if(r<=2)return n.root=n.dir=t,n;if(i=2,s(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let f=-1,S=i,I=-1,E=!0,h=t.length-1,m=0;for(;h>=i;--h){if(l=t.charCodeAt(h),s(l)){if(!E){S=h+1;break}continue}I===-1&&(E=!1,I=h+1),l===p?f===-1?f=h:m!==1&&(m=1):f!==-1&&(m=-1)}return I!==-1&&(f===-1||m===0||m===1&&f===I-1&&f===S+1?n.base=n.name=t.slice(S,I):(n.name=t.slice(S,f),n.base=t.slice(S,I),n.ext=t.slice(f,I))),S>0&&S!==i?n.dir=t.slice(0,S-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const t=/\\/g;return()=>{const n=D.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>D.cwd()})();e.posix={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const l=i>=0?t[i]:u();C(l,"path"),l.length!==0&&(n=`${l}/${n}`,r=l.charCodeAt(0)===_)}return n=c(n,!r,"/",o),r?`/${n}`:n.length>0?n:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===_,r=t.charCodeAt(t.length-1)===_;return t=c(t,!n,"/",o),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===_},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];C(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(C(t,"from"),C(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const r=1,i=t.length,l=i-r,f=1,S=n.length-f,I=l<S?l:S;let E=-1,h=0;for(;h<I;h++){const P=t.charCodeAt(r+h);if(P!==n.charCodeAt(f+h))break;P===_&&(E=h)}if(h===I)if(S>I){if(n.charCodeAt(f+h)===_)return n.slice(f+h+1);if(h===0)return n.slice(f+h)}else l>I&&(t.charCodeAt(r+h)===_?E=h:h===0&&(E=0));let m="";for(h=r+E+1;h<=i;++h)(h===i||t.charCodeAt(h)===_)&&(m+=m.length===0?"..":"/..");return`${m}${n.slice(f+E)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===_;let r=-1,i=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===_){if(!i){r=l;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&C(n,"ext"),C(t,"path");let r=0,i=-1,l=!0,f;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let S=n.length-1,I=-1;for(f=t.length-1;f>=0;--f){const E=t.charCodeAt(f);if(E===_){if(!l){r=f+1;break}}else I===-1&&(l=!1,I=f+1),S>=0&&(E===n.charCodeAt(S)?--S===-1&&(i=f):(S=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(f=t.length-1;f>=0;--f)if(t.charCodeAt(f)===_){if(!l){r=f+1;break}}else i===-1&&(l=!1,i=f+1);return i===-1?"":t.slice(r,i)},extname(t){C(t,"path");let n=-1,r=0,i=-1,l=!0,f=0;for(let S=t.length-1;S>=0;--S){const I=t.charCodeAt(S);if(I===_){if(!l){r=S+1;break}continue}i===-1&&(l=!1,i=S+1),I===p?n===-1?n=S:f!==1&&(f=1):n!==-1&&(f=-1)}return n===-1||i===-1||f===0||f===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:g.bind(null,"/"),parse(t){C(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===_;let i;r?(n.root="/",i=1):i=0;let l=-1,f=0,S=-1,I=!0,E=t.length-1,h=0;for(;E>=i;--E){const m=t.charCodeAt(E);if(m===_){if(!I){f=E+1;break}continue}S===-1&&(I=!1,S=E+1),m===p?l===-1?l=E:h!==1&&(h=1):l!==-1&&(h=-1)}if(S!==-1){const m=f===0&&r?1:f;l===-1||h===0||h===1&&l===S-1&&l===f+1?n.base=n.name=t.slice(m,S):(n.name=t.slice(m,l),n.base=t.slice(m,S),n.ext=t.slice(l,S))}return f>0?n.dir=t.slice(0,f-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(Ce[126],De([1,0,58,16]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const d=new D.Lazy(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),R=new D.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(I,E,h=!1){const m=I||"",P=E||"",O=d.value.collator.compare(m,P);return d.value.collatorIsNumeric&&O===0&&m!==P?m<P?-1:1:O}e.compareFileNames=p;function _(I,E){const h=R.value.collator;return I=I||"",E=E||"",g(h,I,E)}e.compareFileNamesDefault=_;function b(I,E){const h=R.value.collator;return I=I||"",E=E||"",r(I,E)||g(h,I,E)}e.compareFileNamesUpper=b;function T(I,E){const h=R.value.collator;return I=I||"",E=E||"",n(I,E)||g(h,I,E)}e.compareFileNamesLower=T;function k(I,E){return I=I||"",E=E||"",I===E?0:I<E?-1:1}e.compareFileNamesUnicode=k;function v(I,E){const[h,m]=a(I),[P,O]=a(E);let N=d.value.collator.compare(m,O);if(N===0){if(d.value.collatorIsNumeric&&m!==O)return m<O?-1:1;if(N=d.value.collator.compare(h,P),d.value.collatorIsNumeric&&N===0&&h!==P)return h<P?-1:1}return N}e.compareFileExtensions=v;function y(I,E){I=I||"",E=E||"";const h=c(I),m=c(E),P=R.value.collator,O=A.value.collator;return g(O,h,m)||g(P,I,E)}e.compareFileExtensionsDefault=y;function C(I,E){I=I||"",E=E||"";const h=c(I),m=c(E),P=R.value.collator,O=A.value.collator;return g(O,h,m)||r(I,E)||g(P,I,E)}e.compareFileExtensionsUpper=C;function w(I,E){I=I||"",E=E||"";const h=c(I),m=c(E),P=R.value.collator,O=A.value.collator;return g(O,h,m)||n(I,E)||g(P,I,E)}e.compareFileExtensionsLower=w;function s(I,E){I=I||"",E=E||"";const h=c(I).toLowerCase(),m=c(E).toLowerCase();return h!==m?h<m?-1:1:I!==E?I<E?-1:1:0}e.compareFileExtensionsUnicode=s;const o=/^(.*?)(\.([^.]*))?$/;function a(I,E=!1){const h=I?o.exec(I):[];let m=[h&&h[1]||"",h&&h[3]||""];return E&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function c(I){const E=I?o.exec(I):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function g(I,E,h){const m=I.compare(E,h);return m!==0?m:E.length!==h.length?E.length<h.length?-1:1:0}function u(I){const E=I.charAt(0);return E.toLocaleUpperCase()!==E}function t(I){const E=I.charAt(0);return E.toLocaleLowerCase()!==E}function n(I,E){return u(I)&&t(E)?-1:t(I)&&u(E)?1:0}function r(I,E){return t(I)&&u(E)?-1:u(I)&&t(E)?1:0}function i(I,E,h=!1){return h||(I=I&&I.toLowerCase(),E=E&&E.toLowerCase()),I===E?0:I<E?-1:1}function l(I,E,h=!1){const m=I.split(F.sep),P=E.split(F.sep),O=m.length-1,N=P.length-1;let L,U;for(let x=0;;x++){if(L=O===x,U=N===x,L&&U)return p(m[x],P[x],h);if(L)return-1;if(U)return 1;const M=i(m[x],P[x],h);if(M!==0)return M}}e.comparePaths=l;function f(I,E,h){const m=I.toLowerCase(),P=E.toLowerCase(),O=S(I,E,h);if(O)return O;const N=m.endsWith(h),L=P.endsWith(h);if(N!==L)return N?-1:1;const U=p(m,P);return U!==0?U:m.localeCompare(P)}e.compareAnything=f;function S(I,E,h){const m=I.toLowerCase(),P=E.toLowerCase(),O=m.startsWith(h),N=P.startsWith(h);if(O!==N)return O?-1:1;if(O&&N){if(m.length<P.length)return-1;if(m.length>P.length)return 1}return 0}e.compareByPrefix=S}),define(Ce[32],De([1,0,16,12,15,18]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(f){return f===47||f===92}e.isPathSeparator=A;function p(f){return f.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=p;function _(f){return f.indexOf("/")===-1&&(f=p(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=_;function b(f,S=D.posix.sep){if(!f)return"";const I=f.length,E=f.charCodeAt(0);if(A(E)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let m=3;const P=m;for(;m<I&&!A(f.charCodeAt(m));m++);if(P!==m&&!A(f.charCodeAt(m+1))){for(m+=1;m<I;m++)if(A(f.charCodeAt(m)))return f.slice(0,m+1).replace(/[\\/]/g,S)}}return S}else if(o(E)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let h=f.indexOf("://");if(h!==-1){for(h+=3;h<I;h++)if(A(f.charCodeAt(h)))return f.slice(0,h+1)}return""}e.getRoot=b;function T(f){if(!F.isWindows||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let I=2;const E=I;for(;I<f.length&&(S=f.charCodeAt(I),S!==92);I++);return!(E===I||(S=f.charCodeAt(I+1),isNaN(S)||S===92))}e.isUNC=T;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(f,S=F.isWindows){const I=S?k:v;return!(!f||f.length===0||/^\s+$/.test(f)||(I.lastIndex=0,I.test(f))||S&&y.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=C;function w(f,S,I){const E=f===S;return!I||E?E:!f||!S?!1:(0,d.equalsIgnoreCase)(f,S)}e.isEqual=w;function s(f,S,I,E=D.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(I){if(!(0,d.startsWithIgnoreCase)(f,S))return!1;if(S.length===f.length)return!0;let m=S.length;return S.charAt(S.length-1)===E&&m--,f.charAt(m)===E}return S.charAt(S.length-1)!==E&&(S+=E),f.indexOf(S)===0}e.isEqualOrParent=s;function o(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=o;function a(f,S){return F.isWindows&&f.endsWith(":")&&(f+=D.sep),(0,D.isAbsolute)(f)||(f=(0,D.join)(S,f)),f=(0,D.normalize)(f),F.isWindows?(f=(0,d.rtrim)(f,D.sep),f.endsWith(":")&&(f+=D.sep)):(f=(0,d.rtrim)(f,D.sep),f||(f=D.sep)),f}e.sanitizeFilePath=a;function c(f){const S=(0,D.normalize)(f);return F.isWindows?f.length>3?!1:g(S)&&(f.length===2||S.charCodeAt(2)===92):S===D.posix.sep}e.isRootOrDriveLetter=c;function g(f,S=F.isWindows){return S?o(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function u(f,S=F.isWindows){return g(f,S)?f[0]:void 0}e.getDriveLetter=u;function t(f,S,I){return S.length>f.length?-1:f===S?0:(I&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.indexOfPath=t;function n(f){const S=f.split(":");let I,E,h;for(const m of S){const P=Number(m);(0,R.isNumber)(P)?E===void 0?E=P:h===void 0&&(h=P):I=I?[I,m].join(":"):m}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:E!==void 0?E:void 0,column:h!==void 0?h:E!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(f,S,I=8){let E="";for(let m=0;m<I;m++){let P;m===0&&F.isWindows&&!S&&(I===3||I===4)?P=i:P=r,E+=P.charAt(Math.floor(Math.random()*P.length))}let h;return S?h=`${S}-${E}`:h=E,f?(0,D.join)(f,h):h}e.randomPath=l}),define(Ce[127],De([1,0,126,121,51,16,12,15]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,b=[_,[]];function T(H,j,fe,Y){if(!H||!j)return b;const X=H.length,z=j.length;if(X<z)return b;const J=H.toLowerCase();return k(j,fe,z,H,J,X,Y)}e.scoreFuzzy=T;function k(H,j,fe,Y,X,z,J){const ge=[],le=[];for(let V=0;V<fe;V++){const me=V*z,Z=me-z,ne=V>0,re=H[V],ye=j[V];for(let oe=0;oe<z;oe++){const de=oe>0,ee=me+oe,ue=ee-1,ve=Z+oe-1,ke=de?ge[ue]:0,$=ne&&de?ge[ve]:0,K=ne&&de?le[ve]:0;let ie;!$&&ne?ie=0:ie=v(re,ye,Y,X,oe,K),ie&&$+ie>=ke&&(J||ne||X.startsWith(j,oe))?(le[ee]=K+1,ge[ee]=$+ie):(le[ee]=_,ge[ee]=ke)}}const we=[];let G=fe-1,B=z-1;for(;G>=0&&B>=0;){const V=G*z+B;le[V]===_||(we.push(B),G--),B--}return[ge[fe*z-1],we.reverse()]}function v(H,j,fe,Y,X,z){let J=0;if(!y(j,Y[X]))return J;if(J+=1,z>0&&(J+=z*5),H===fe[X]&&(J+=1),X===0)J+=8;else{const ge=C(fe.charCodeAt(X-1));ge?J+=ge:(0,F.isUpper)(fe.charCodeAt(X))&&z===0&&(J+=2)}return J}function y(H,j){return H===j?!0:H==="/"||H==="\\"?j==="/"||j==="\\":!1}function C(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function s(H,j,fe=0,Y=0){const X=j;return X.values&&X.values.length>1?o(H,X.values,fe,Y):a(H,j,fe,Y)}e.scoreFuzzy2=s;function o(H,j,fe,Y){let X=0;const z=[];for(const J of j){const[ge,le]=a(H,J,fe,Y);if(typeof ge!="number")return w;X+=ge,z.push(...le)}return[X,I(z)]}function a(H,j,fe,Y){const X=(0,F.fuzzyScore)(j.original,j.originalLowercase,fe,H,H.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,F.createMatches)(X)]:w}const c=Object.freeze({score:0}),g=1<<18,u=1<<17,t=1<<16;function n(H,j,fe,Y){const X=Y.values?Y.values:[Y];return(0,d.hash)({[Y.normalized]:{values:X.map(J=>({value:J.normalized,expectContiguousMatch:J.expectContiguousMatch})),label:H,description:j,allowNonContiguousMatches:fe}})}function r(H,j,fe,Y,X){if(!H||!j.normalized)return c;const z=Y.getItemLabel(H);if(!z)return c;const J=Y.getItemDescription(H),ge=n(z,J,fe,j),le=X[ge];if(le)return le;const we=i(z,J,Y.getItemPath(H),j,fe);return X[ge]=we,we}e.scoreItemFuzzy=r;function i(H,j,fe,Y,X){const z=!fe||!Y.containsPathSeparator;return fe&&(A.isLinux?Y.pathNormalized===fe:(0,p.equalsIgnoreCase)(Y.pathNormalized,fe))?{score:g,labelMatch:[{start:0,end:H.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:Y.values&&Y.values.length>1?l(H,j,fe,Y.values,z,X):f(H,j,fe,Y,z,X)}function l(H,j,fe,Y,X,z){let J=0;const ge=[],le=[];for(const we of Y){const{score:G,labelMatch:B,descriptionMatch:V}=f(H,j,fe,we,X,z);if(G===_)return c;J+=G,B&&ge.push(...B),V&&le.push(...V)}return{score:J,labelMatch:I(ge),descriptionMatch:I(le)}}function f(H,j,fe,Y,X,z){if(X||!j){const[J,ge]=T(H,Y.normalized,Y.normalizedLowercase,z&&!Y.expectContiguousMatch);if(J){const le=(0,F.matchesPrefix)(Y.normalized,H);let we;if(le){we=u;const G=Math.round(Y.normalized.length/H.length*100);we+=G}else we=t;return{score:we+J,labelMatch:le||S(ge)}}}if(j){let J=j;fe&&(J=`${j}${R.sep}`);const ge=J.length,le=`${J}${H}`,[we,G]=T(le,Y.normalized,Y.normalizedLowercase,z&&!Y.expectContiguousMatch);if(we){const B=S(G),V=[],me=[];return B.forEach(Z=>{Z.start<ge&&Z.end>ge?(V.push({start:0,end:Z.end-ge}),me.push({start:Z.start,end:ge})):Z.start>=ge?V.push({start:Z.start-ge,end:Z.end-ge}):me.push(Z)}),{score:we,labelMatch:V,descriptionMatch:me}}}return c}function S(H){const j=[];if(!H)return j;let fe;for(const Y of H)fe&&fe.end===Y?fe.end+=1:(fe={start:Y,end:Y+1},j.push(fe));return j}function I(H){const j=H.sort((X,z)=>X.start-z.start),fe=[];let Y;for(const X of j)!Y||!E(Y,X)?(Y=X,fe.push(X)):(Y.start=Math.min(Y.start,X.start),Y.end=Math.max(Y.end,X.end));return fe}function E(H,j){return!(H.end<j.start||j.end<H.start)}function h(H,j,fe,Y,X,z){const J=r(H,fe,Y,X,z),ge=r(j,fe,Y,X,z),le=J.score,we=ge.score;if((le===g||we===g)&&le!==we)return le===g?-1:1;if(le>t||we>t){if(le!==we)return le>we?-1:1;if(le<u&&we<u){const re=P(J.labelMatch,ge.labelMatch);if(re!==0)return re}const Z=X.getItemLabel(H)||"",ne=X.getItemLabel(j)||"";if(Z.length!==ne.length)return Z.length-ne.length}if(le!==we)return le>we?-1:1;const G=Array.isArray(J.labelMatch)&&J.labelMatch.length>0,B=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(G&&!B)return-1;if(B&&!G)return 1;const V=m(H,J,X),me=m(j,ge,X);return V&&me&&V!==me?me>V?-1:1:O(H,j,fe,X)}e.compareItemsByFuzzyScore=h;function m(H,j,fe){let Y=-1,X=-1;if(j.descriptionMatch&&j.descriptionMatch.length?Y=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(Y=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(X=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const z=fe.getItemDescription(H);z&&(X+=z.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(X=j.descriptionMatch[j.descriptionMatch.length-1].end);return X-Y}function P(H,j){if(!H&&!j||(!H||!H.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!H||!H.length)return 1;const fe=H[0].start,X=H[H.length-1].end-fe,z=j[0].start,ge=j[j.length-1].end-z;return X===ge?0:ge<X?1:-1}function O(H,j,fe,Y){const X=Y.getItemLabel(H)||"",z=Y.getItemLabel(j)||"",J=Y.getItemDescription(H),ge=Y.getItemDescription(j),le=X.length+(J?J.length:0),we=z.length+(ge?ge.length:0);if(le!==we)return le-we;const G=Y.getItemPath(H),B=Y.getItemPath(j);return G&&B&&G.length!==B.length?G.length-B.length:X!==z?(0,D.compareAnything)(X,z,fe.normalized):J&&ge&&J!==ge?(0,D.compareAnything)(J,ge,fe.normalized):G&&B&&G!==B?(0,D.compareAnything)(G,B,fe.normalized):0}function N(H){return H.startsWith('"')&&H.endsWith('"')}const L=" ";function U(H){typeof H!="string"&&(H="");const j=H.toLowerCase(),{pathNormalized:fe,normalized:Y,normalizedLowercase:X}=x(H),z=fe.indexOf(R.sep)>=0,J=N(H);let ge;const le=H.split(L);if(le.length>1)for(const we of le){const G=N(we),{pathNormalized:B,normalized:V,normalizedLowercase:me}=x(we);V&&(ge||(ge=[]),ge.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:B,normalized:V,normalizedLowercase:me,expectContiguousMatch:G}))}return{original:H,originalLowercase:j,pathNormalized:fe,normalized:Y,normalizedLowercase:X,values:ge,containsPathSeparator:z,expectContiguousMatch:J}}e.prepareQuery=U;function x(H){let j;A.isWindows?j=H.replace(/\//g,R.sep):j=H.replace(/\\/g,R.sep);const fe=(0,p.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function M(H){return Array.isArray(H)?U(H.map(j=>j.original).join(L)):U(H.original)}e.pieceToQuery=M}),define(Ce[98],De([1,0,16]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(T){const k=(0,D.extname)(T),v=F[k.toLowerCase()];return v!==void 0?v:A(T)}e.getMediaOrTextMime=R;function A(T){const k=(0,D.extname)(T);return d[k.toLowerCase()]}e.getMediaMime=A;function p(T){for(const k in d)if(d[k]===T)return k}e.getExtensionForMimeType=p;const _=/^(.+)\/(.+?)(;.+)?$/;function b(T,k){const v=_.exec(T);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:k?void 0:T}e.normalizeMimeType=b}),define(Ce[99],De([1,0,12]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var F;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(F||(e.Source=F={}));var d;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function R(p,..._){const b=_.reduce((v,y)=>(v[y]=!0,v),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(v=>!b[v]).forEach(v=>{for(let y=0;y<T.length;y++)if(v.search(T[y])!==-1){delete p[v];break}})}e.sanitizeProcessEnvironment=R;function A(p){p&&(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(Ce[2],De([1,0,16,12]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function p(i,l){if(!i.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!d.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(i,l){return!i&&!l?"file":i}function b(i,l){switch(i){case"https":case"http":case"file":l?l[0]!==k&&(l=k+l):l=k;break}return l}const T="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(l){return l instanceof y?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,f,S,I,E,h=!1){typeof l=="object"?(this.scheme=l.scheme||T,this.authority=l.authority||T,this.path=l.path||T,this.query=l.query||T,this.fragment=l.fragment||T):(this.scheme=_(l,h),this.authority=f||T,this.path=b(this.scheme,S||T),this.query=I||T,this.fragment=E||T,p(this,h))}get fsPath(){return g(this,!1)}with(l){if(!l)return this;let{scheme:f,authority:S,path:I,query:E,fragment:h}=l;return f===void 0?f=this.scheme:f===null&&(f=T),S===void 0?S=this.authority:S===null&&(S=T),I===void 0?I=this.path:I===null&&(I=T),E===void 0?E=this.query:E===null&&(E=T),h===void 0?h=this.fragment:h===null&&(h=T),f===this.scheme&&S===this.authority&&I===this.path&&E===this.query&&h===this.fragment?this:new s(f,S,I,E,h)}static parse(l,f=!1){const S=v.exec(l);return S?new s(S[2]||T,r(S[4]||T),r(S[5]||T),r(S[7]||T),r(S[9]||T),f):new s(T,T,T,T,T)}static file(l){let f=T;if(F.isWindows&&(l=l.replace(/\\/g,k)),l[0]===k&&l[1]===k){const S=l.indexOf(k,2);S===-1?(f=l.substring(2),l=k):(f=l.substring(2,S),l=l.substring(S)||k)}return new s("file",f,l,T,T)}static from(l,f){return new s(l.scheme,l.authority,l.path,l.query,l.fragment,f)}static joinPath(l,...f){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return F.isWindows&&l.scheme==="file"?S=y.file(D.win32.join(g(l,!0),...f)).path:S=D.posix.join(l.path,...f),l.with({path:S})}toString(l=!1){return u(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof y)return l;{const f=new s(l);return f._formatted=l.external??null,f._fsPath=l._sep===w?l.fsPath??null:null,f}}else return l}}e.URI=y;function C(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=C;const w=F.isWindows?1:void 0;class s extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(l=!1){return l?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,l,f){let S,I=-1;for(let E=0;E<i.length;E++){const h=i.charCodeAt(E);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||l&&h===47||f&&h===91||f&&h===93||f&&h===58)I!==-1&&(S+=encodeURIComponent(i.substring(I,E)),I=-1),S!==void 0&&(S+=i.charAt(E));else{S===void 0&&(S=i.substr(0,E));const m=o[h];m!==void 0?(I!==-1&&(S+=encodeURIComponent(i.substring(I,E)),I=-1),S+=m):I===-1&&(I=E)}}return I!==-1&&(S+=encodeURIComponent(i.substring(I))),S!==void 0?S:i}function c(i){let l;for(let f=0;f<i.length;f++){const S=i.charCodeAt(f);S===35||S===63?(l===void 0&&(l=i.substr(0,f)),l+=o[S]):l!==void 0&&(l+=i[f])}return l!==void 0?l:i}function g(i,l){let f;return i.authority&&i.path.length>1&&i.scheme==="file"?f=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?l?f=i.path.substr(1):f=i.path[1].toLowerCase()+i.path.substr(2):f=i.path,F.isWindows&&(f=f.replace(/\//g,"\\")),f}e.uriToFsPath=g;function u(i,l){const f=l?c:a;let S="",{scheme:I,authority:E,path:h,query:m,fragment:P}=i;if(I&&(S+=I,S+=":"),(E||I==="file")&&(S+=k,S+=k),E){let O=E.indexOf("@");if(O!==-1){const N=E.substr(0,O);E=E.substr(O+1),O=N.lastIndexOf(":"),O===-1?S+=f(N,!1,!1):(S+=f(N.substr(0,O),!1,!1),S+=":",S+=f(N.substr(O+1),!1,!0)),S+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?S+=f(E,!1,!0):(S+=f(E.substr(0,O),!1,!0),S+=E.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}S+=f(h,!0,!1)}return m&&(S+="?",S+=f(m,!1,!1)),P&&(S+="#",S+=l?P:a(P,!1,!1)),S}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,l=>t(l)):i}}),define(Ce[181],De([1,0,2]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function F(b){const T=b;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=F;function d(b){const T=[];let k;try{const v=JSON.parse(b.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),k=y.__$stack),T.push(...v)}catch{T.push("Unable to log remote console arguments",b.arguments)}return{args:T,stack:k}}e.parse=d;function R(b){if(typeof b!="string")return R(d(b).stack);const T=b;if(T){const k=A(T),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=R;function A(b){if(!b)return b;const T=b.indexOf(`
`);return T===-1?b:b.substring(0,T)}function p(b,T){const{args:k,stack:v}=d(b),y=typeof k[0]=="string"&&k.length===1;let C=A(v);C&&(C=`(${C.trim()})`);let w=[];if(typeof k[0]=="string"?C&&y?w=[`%c[${T}] %c${k[0]} %c${C}`,_("blue"),_(""),_("grey")]:w=[`%c[${T}] %c${k[0]}`,_("blue"),_(""),...k.slice(1)]:w=[`%c[${T}]%`,_("blue"),...k],C&&!y&&w.push(C),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,w)}e.log=p;function _(b){return`color: ${b}`}}),define(Ce[62],De([1,0,22,2]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function d(_){return JSON.stringify(_,A)}e.stringify=d;function R(_){let b=JSON.parse(_);return b=p(b),b}e.parse=R;function A(_,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function p(_,b=0){if(!_||b>200)return _;if(typeof _=="object"){switch(_.$mid){case 1:return F.URI.revive(_);case 2:return new RegExp(_.source,_.flags);case 17:return new Date(_.source)}if(_ instanceof D.VSBuffer||_ instanceof Uint8Array)return _;if(Array.isArray(_))for(let T=0;T<_.length;++T)_[T]=p(_[T],b+1);else for(const T in _)Object.hasOwnProperty.call(_,T)&&(_[T]=p(_[T],b+1))}return _}e.revive=p}),define(Ce[17],De([1,0,8,12,2]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(T){this._preferredWebSchema=T}setDelegate(T){this._delegate=T}setServerRootPath(T){this._remoteResourcesPath=`${T}/${R.vscodeRemoteResource}`}set(T,k,v){this._hosts[T]=k,this._ports[T]=v}setConnectionToken(T,k){this._connectionTokens[T]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(T){if(this._delegate)try{return this._delegate(T)}catch(s){return D.onUnexpectedError(s),T}const k=T.authority;let v=this._hosts[k];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const y=this._ports[k],C=this._connectionTokens[k];let w=`path=${encodeURIComponent(T.path)}`;return typeof C=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),d.URI.from({scheme:F.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${v}:${y}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class p{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(T){const k=this.toUri(T,pe);return this.uriToBrowserUri(k)}uriToBrowserUri(T){return T.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===R.file&&(F.isNative||F.isWebWorker&&F.globals.origin===`${R.vscodeFileResource}://${p.FALLBACK_AUTHORITY}`)?T.with({scheme:R.vscodeFileResource,authority:T.authority||p.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(T){const k=this.toUri(T,pe);return this.uriToFileUri(k)}uriToFileUri(T){return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==p.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(T,k){return d.URI.isUri(T)?T:d.URI.parse(k.toUrl(T))}}e.FileAccess=new p;var _;(function(b){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(T.get("3"));const k="vscode-coi";function v(C){let w;typeof C=="string"?w=new URL(C).searchParams:C instanceof URL?w=C.searchParams:d.URI.isUri(C)&&(w=new URL(C.toString(!0)).searchParams);const s=w?.get(k);if(s)return T.get(s)}b.getHeadersFromQuery=v;function y(C,w,s){if(!globalThis.crossOriginIsolated)return;const o=w&&s?"3":s?"2":"1";C instanceof URLSearchParams?C.set(k,o):C[k]=o}b.addSearchParam=y})(_||(e.COI=_={}))}),define(Ce[182],De([1,0,156,17,12,2]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class A{constructor(v,y,C){this.id=v,this.dependencies=y,this.callback=C}}class p{static{this.INSTANCE=new p}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,y,C)=>{typeof v!="string"&&(C=y,y=v,v=null),(typeof y!="object"||!Array.isArray(y))&&(C=y,y=null),this._defineCalls.push(new A(v,y,C))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const y=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!y)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}_rendererLoadScript(v){return new Promise((y,C)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const s=()=>{w.removeEventListener("load",o),w.removeEventListener("error",a)},o=c=>{s(),y(this._defineCalls.pop())},a=c=>{s(),C(c)};w.addEventListener("load",o),w.addEventListener("error",a),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),w.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(w)})}_workerLoadScript(v){return new Promise((y,C)=>{try{this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),importScripts(v),y(this._defineCalls.pop())}catch(w){C(w)}})}async _nodeJSLoadScript(v){try{const y=globalThis._VSCODE_NODE_MODULES.fs,C=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,s=R.URI.parse(v).fsPath,o=y.readFileSync(s).toString(),a=w.wrap(o.replace(/^#!.*/,""));return new C.Script(a).runInThisContext().apply(),this._defineCalls.pop()}catch(y){throw y}}}const _=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function T(k,v,y){if(D.isESM){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[k]&&(k=b[k]);const C=`${k}/${v}`;if(_.has(C))return _.get(C);let w;if(/^\w[\w\d+.-]*:\/\//.test(C))w=C;else{const c=`${y&&!d.isWeb?F.nodeModulesAsarPath:F.nodeModulesPath}/${C}`;w=F.FileAccess.asBrowserUri(c).toString(!0)}const s=p.INSTANCE.load(w);return _.set(C,s),s}else return await new Promise((C,w)=>{pe([k],C,w)})}e.importAMDNodeModule=T}),define(Ce[24],De([1,0,32,17,16,12,15,2]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(y){return(0,p.uriToFsPath)(y,!0)}e.originalFSPath=_;class b{constructor(C){this._ignorePathCasing=C}compare(C,w,s=!1){return C===w?0:(0,A.compare)(this.getComparisonKey(C,s),this.getComparisonKey(w,s))}isEqual(C,w,s=!1){return C===w?!0:!C||!w?!1:this.getComparisonKey(C,s)===this.getComparisonKey(w,s)}getComparisonKey(C,w=!1){return C.with({path:this._ignorePathCasing(C)?C.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(C){return this._ignorePathCasing(C)}isEqualOrParent(C,w,s=!1){if(C.scheme===w.scheme){if(C.scheme===F.Schemas.file)return D.isEqualOrParent(_(C),_(w),this._ignorePathCasing(C))&&C.query===w.query&&(s||C.fragment===w.fragment);if((0,e.isEqualAuthority)(C.authority,w.authority))return D.isEqualOrParent(C.path,w.path,this._ignorePathCasing(C),"/")&&C.query===w.query&&(s||C.fragment===w.fragment)}return!1}joinPath(C,...w){return p.URI.joinPath(C,...w)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return d.posix.basename(C.path)}extname(C){return d.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let w;return C.scheme===F.Schemas.file?w=p.URI.file(d.dirname(_(C))).path:(w=d.posix.dirname(C.path),C.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),w="/")),C.with({path:w})}normalizePath(C){if(!C.path.length)return C;let w;return C.scheme===F.Schemas.file?w=p.URI.file(d.normalize(_(C))).path:w=d.posix.normalize(C.path),C.with({path:w})}relativePath(C,w){if(C.scheme!==w.scheme||!(0,e.isEqualAuthority)(C.authority,w.authority))return;if(C.scheme===F.Schemas.file){const a=d.relative(_(C),_(w));return R.isWindows?D.toSlashes(a):a}let s=C.path||"/";const o=w.path||"/";if(this._ignorePathCasing(C)){let a=0;for(const c=Math.min(s.length,o.length);a<c&&!(s.charCodeAt(a)!==o.charCodeAt(a)&&s.charAt(a).toLowerCase()!==o.charAt(a).toLowerCase());a++);s=o.substr(0,a)+s.substr(a)}return d.posix.relative(s,o)}resolvePath(C,w){if(C.scheme===F.Schemas.file){const s=p.URI.file(d.resolve(_(C),w));return C.with({authority:s.authority,path:s.path})}return w=D.toPosixPath(w),C.with({path:d.posix.resolve(C.path,w)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,w){return C===w||C!==void 0&&w!==void 0&&(0,A.equalsIgnoreCase)(C,w)}hasTrailingPathSeparator(C,w=d.sep){if(C.scheme===F.Schemas.file){const s=_(C);return s.length>D.getRoot(s).length&&s[s.length-1]===w}else{const s=C.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,w=d.sep){return(0,e.hasTrailingPathSeparator)(C,w)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,w=d.sep){let s=!1;if(C.scheme===F.Schemas.file){const o=_(C);s=o!==void 0&&o.length===D.getRoot(o).length&&o[o.length-1]===w}else{w="/";const o=C.path;s=o.length===1&&o.charCodeAt(o.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(C,w)?C.with({path:C.path+"/"}):C}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(y=>y.scheme===F.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new b(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(y,C){const w=[];for(let s=0;s<y.length;s++){const o=C(y[s]);y.some((a,c)=>c===s?!1:(0,e.isEqualOrParent)(o,C(a)))||w.push(y[s])}return w}e.distinctParents=T;var k;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function C(w){const s=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[g,u]=c.split(":");g&&u&&s.set(g,u)});const a=w.path.substring(0,w.path.indexOf(";"));return a&&s.set(y.META_DATA_MIME,a),s}y.parseMetaData=C})(k||(e.DataUri=k={}));function v(y,C,w){if(C){let s=y.path;return s&&s[0]!==d.posix.sep&&(s=d.posix.sep+s),y.with({scheme:w,authority:C,path:s})}return y.with({scheme:w})}e.toLocalResource=v}),define(Ce[9],De([1,0,21,8,4,3,24,12,160]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(B){return!!B&&typeof B.then=="function"}e.isThenable=b;function T(B){const V=new D.CancellationTokenSource,me=B(V.token),Z=new Promise((ne,re)=>{const ye=V.token.onCancellationRequested(()=>{ye.dispose(),V.dispose(),re(new F.CancellationError)});Promise.resolve(me).then(oe=>{ye.dispose(),V.dispose(),ne(oe)},oe=>{ye.dispose(),V.dispose(),re(oe)})});return new class{cancel(){V.cancel()}then(ne,re){return Z.then(ne,re)}catch(ne){return this.then(void 0,ne)}finally(ne){return Z.finally(ne)}}}e.createCancelablePromise=T;function k(B,V,me){return new Promise((Z,ne)=>{const re=V.onCancellationRequested(()=>{re.dispose(),Z(me)});B.then(Z,ne).finally(()=>re.dispose())})}e.raceCancellation=k;function v(B,V){return new Promise((me,Z)=>{const ne=V.onCancellationRequested(()=>{ne.dispose(),Z(new F.CancellationError)});B.then(me,Z).finally(()=>ne.dispose())})}e.raceCancellationError=v;async function y(B){let V=-1;const me=B.map((Z,ne)=>Z.then(re=>(V=ne,re)));try{return await Promise.race(me)}finally{B.forEach((Z,ne)=>{ne!==V&&Z.cancel()})}}e.raceCancellablePromises=y;function C(B,V,me){let Z;const ne=setTimeout(()=>{Z?.(void 0),me?.()},V);return Promise.race([B.finally(()=>clearTimeout(ne)),new Promise(re=>Z=re)])}e.raceTimeout=C;function w(B){return new Promise((V,me)=>{const Z=B();b(Z)?Z.then(V,me):V(Z)})}e.asPromise=w;class s{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const me=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(me,me).then(Z)})}return new Promise((me,Z)=>{this.queuedPromise.then(me,Z)})}return this.activePromise=V(),new Promise((me,Z)=>{this.activePromise.then(ne=>{this.activePromise=null,me(ne)},ne=>{this.activePromise=null,Z(ne)})})}dispose(){this.isDisposed=!0}}e.Throttler=s;class o{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=o;class a{constructor(){this.promiseMap=new Map}queue(V,me){const ne=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(V)===ne&&this.promiseMap.delete(V)});return this.promiseMap.set(V,ne),ne}}e.SequencerByKey=a;const c=(B,V)=>{let me=!0;const Z=setTimeout(()=>{me=!1,V()},B);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Z),me=!1}}},g=B=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,B())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class u{constructor(V){this.defaultDelay=V,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,me=this.defaultDelay){this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ne,re)=>{this.doResolve=ne,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ne=this.task;return this.task=null,ne()}}));const Z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===_.MicrotaskDelay?g(Z):c(me,Z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new F.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class t{constructor(V){this.delayer=new u(V),this.throttler=new s}trigger(V,me){return this.delayer.trigger(()=>this.throttler.queue(V),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this._isOpen=!1,this._promise=new Promise((V,me)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(V){super(),this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(B,V){return V?new Promise((me,Z)=>{const ne=setTimeout(()=>{re.dispose(),me()},B),re=V.onCancellationRequested(()=>{clearTimeout(ne),re.dispose(),Z(new F.CancellationError)})}):T(me=>i(B,me))}e.timeout=i;function l(B,V=0,me){const Z=setTimeout(()=>{B(),me&&ne.dispose()},V),ne=(0,R.toDisposable)(()=>{clearTimeout(Z),me?.deleteAndLeak(ne)});return me?.add(ne),ne}e.disposableTimeout=l;function f(B){const V=[];let me=0;const Z=B.length;function ne(){return me<Z?B[me++]():null}function re(ye){ye!=null&&V.push(ye);const oe=ne();return oe?oe.then(re):Promise.resolve(V)}return Promise.resolve(null).then(re)}e.sequence=f;function S(B,V=Z=>!!Z,me=null){let Z=0;const ne=B.length,re=()=>{if(Z>=ne)return Promise.resolve(me);const ye=B[Z++];return Promise.resolve(ye()).then(de=>V(de)?Promise.resolve(de):re())};return re()}e.first=S;function I(B,V=Z=>!!Z,me=null){if(B.length===0)return Promise.resolve(me);let Z=B.length;const ne=()=>{Z=-1;for(const re of B)re.cancel?.()};return new Promise((re,ye)=>{for(const oe of B)oe.then(de=>{--Z>=0&&V(de)?(ne(),re(de)):Z===0&&re(me)}).catch(de=>{--Z>=0&&(ne(),ye(de))})})}e.firstParallel=I;class E{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new d.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(V){return this._size++,new Promise((me,Z)=>{this.outstandingPromises.push({factory:V,c:me,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const me=V.factory();me.then(V.c,V.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=E;class h extends E{constructor(){super(1)}}e.Queue=h;class m{constructor(){this.sequentializer=new fe,this.tasks=0}queue(V){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,V())):this.sequentializer.run(this.tasks++,V())}}e.LimitedQueue=m;class P{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const V=new z;return this.drainers.add(V),V.p}isDrained(){for(const[,V]of this.queues)if(V.size>0)return!1;return!0}queueFor(V,me=A.extUri){const Z=me.getComparisonKey(V);let ne=this.queues.get(Z);if(!ne){ne=new h;const re=this.drainListenerCount++,ye=d.Event.once(ne.onDrained)(()=>{ne?.dispose(),this.queues.delete(Z),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(re),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new R.DisposableMap),this.drainListeners.set(re,ye),this.queues.set(Z,ne)}return ne}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const V of this.drainers)V.complete();this.drainers.clear()}dispose(){for(const[,V]of this.queues)V.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=P;class O{constructor(V,me){this._token=-1,typeof V=="function"&&typeof me=="number"&&this.setIfNotSet(V,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},me)}setIfNotSet(V,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},me))}}e.TimeoutTimer=O;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,me){this.cancel(),this._token=setInterval(()=>{V()},me)}}e.IntervalTimer=N;class L{constructor(V,me){this.timeoutToken=-1,this.runner=V,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=L;class U{constructor(V,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=U;class x extends L{constructor(V,me){super(V,me),this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner?.(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class M extends R.Disposable{constructor(V,me){super(),this.options=V,this.handler=me,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.options.maxBufferedWork)return!1}else if(this.pending+V.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const me of V)this.pendingWork.push(me);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,p.setTimeout0)(()=>{if(V)return;const me=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(B,V)=>{const me=requestIdleCallback(B,typeof V=="number"?{timeout:V}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(me))}}}}();class H{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function j(B,V,me){let Z;for(let ne=0;ne<me;ne++)try{return await B()}catch(re){Z=re,await i(V)}throw Z}e.retry=j;class fe{isRunning(V){return typeof V=="number"?this._running?.taskId===V:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(V,me,Z){return this._running={taskId:V,cancel:()=>Z?.(),promise:me},me.then(()=>this.doneRunning(V),()=>this.doneRunning(V)),me}doneRunning(V){this._running&&V===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const V=this._queued;this._queued=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this._queued)this._queued.run=V;else{let me,Z;const ne=new Promise((re,ye)=>{me=re,Z=ye});this._queued={run:V,promise:ne,promiseResolve:me,promiseReject:Z}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=fe;class Y{constructor(V,me=()=>Date.now()){this.interval=V,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;var X;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(X||(X={}));class z{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((V,me)=>{this.completeCallback=V,this.errorCallback=me})}complete(V){return new Promise(me=>{this.completeCallback(V),this.outcome={outcome:0,value:V},me()})}error(V){return new Promise(me=>{this.errorCallback(V),this.outcome={outcome:1,value:V},me()})}cancel(){return this.error(new F.CancellationError)}}e.DeferredPromise=z;var J;(function(B){async function V(Z){let ne;const re=await Promise.all(Z.map(ye=>ye.then(oe=>oe,oe=>{ne||(ne=oe)})));if(typeof ne<"u")throw ne;return re}B.settled=V;function me(Z){return new Promise(async(ne,re)=>{try{await Z(ne,re)}catch(ye){re(ye)}})}B.withAsyncBody=me})(J||(e.Promises=J={}));var ge;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(ge||(ge={}));class le{static fromArray(V){return new le(me=>{me.emitMany(V)})}static fromPromise(V){return new le(async me=>{me.emitMany(await V)})}static fromPromises(V){return new le(async me=>{await Promise.all(V.map(async Z=>me.emitOne(await Z)))})}static merge(V){return new le(async me=>{await Promise.all(V.map(async Z=>{for await(const ne of Z)me.emitOne(ne)}))})}static{this.EMPTY=le.fromArray([])}constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new d.Emitter,queueMicrotask(async()=>{const me={emitOne:Z=>this.emitOne(Z),emitMany:Z=>this.emitMany(Z),reject:Z=>this.reject(Z)};try{await Promise.resolve(V(me)),this.resolve()}catch(Z){this.reject(Z)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await d.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,me){return new le(async Z=>{for await(const ne of V)Z.emitOne(me(ne))})}map(V){return le.map(this,V)}static filter(V,me){return new le(async Z=>{for await(const ne of V)me(ne)&&Z.emitOne(ne)})}filter(V){return le.filter(this,V)}static coalesce(V){return le.filter(V,me=>!!me)}coalesce(){return le.coalesce(this)}static async toPromise(V){const me=[];for await(const Z of V)me.push(Z);return me}toPromise(){return le.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=le;class we extends le{constructor(V,me){super(me),this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function G(B){const V=new D.CancellationTokenSource,me=B(V.token);return new we(V,async Z=>{const ne=V.token.onCancellationRequested(()=>{ne.dispose(),V.dispose(),Z.reject(new F.CancellationError)});try{for await(const re of me){if(V.token.isCancellationRequested)return;Z.emitOne(re)}ne.dispose(),V.dispose()}catch(re){ne.dispose(),V.dispose(),Z.reject(re)}})}e.createCancelableAsyncIterable=G}),define(Ce[35],De([1,0,19,9,32,28,16,12,15]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",k="[^/\\\\]",v=/\//g;function y(fe,Y){switch(fe){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${Y?`|${T}${k}+`:""})*?`}}function C(fe,Y){if(!fe)return[];const X=[];let z=!1,J=!1,ge="";for(const le of fe){switch(le){case Y:if(!z&&!J){X.push(ge),ge="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":J=!0;break;case"]":J=!1;break}ge+=le}return ge&&X.push(ge),X}e.splitGlobAware=C;function w(fe){if(!fe)return"";let Y="";const X=C(fe,e.GLOB_SPLIT);if(X.every(z=>z===e.GLOBSTAR))Y=".*";else{let z=!1;X.forEach((J,ge)=>{if(J===e.GLOBSTAR){if(z)return;Y+=y(2,ge===X.length-1)}else{let le=!1,we="",G=!1,B="";for(const V of J){if(V!=="}"&&le){we+=V;continue}if(G&&(V!=="]"||!B)){let me;V==="-"?me=V:(V==="^"||V==="!")&&!B?me="^":V===e.GLOB_SPLIT?me="":me=(0,_.escapeRegExpCharacters)(V),B+=me;continue}switch(V){case"{":le=!0;continue;case"[":G=!0;continue;case"}":{const Z=`(?:${C(we,",").map(ne=>w(ne)).join("|")})`;Y+=Z,le=!1,we="";break}case"]":{Y+="["+B+"]",G=!1,B="";break}case"?":Y+=k;continue;case"*":Y+=y(1);continue;default:Y+=(0,_.escapeRegExpCharacters)(V)}}ge<X.length-1&&(X[ge+1]!==e.GLOBSTAR||ge+2<X.length)&&(Y+=T)}z=J===e.GLOBSTAR})}return Y}const s=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),n=function(){return!1},r=function(){return null};function i(fe,Y){if(!fe)return r;let X;typeof fe!="string"?X=fe.pattern:X=fe,X=X.trim();const z=`${X}_${!!Y.trimForExclusions}`;let J=t.get(z);if(J)return l(J,fe);let ge;return s.test(X)?J=S(X.substr(4),X):(ge=o.exec(f(X,Y)))?J=I(ge[1],X):(Y.trimForExclusions?c:a).test(X)?J=E(X,Y):(ge=g.exec(f(X,Y)))?J=h(ge[1].substr(1),X,!0):(ge=u.exec(f(X,Y)))?J=h(ge[1],X,!1):J=m(X),t.set(z,J),l(J,fe)}function l(fe,Y){if(typeof Y=="string")return fe;const X=function(z,J){return(0,d.isEqualOrParent)(z,Y.base,!p.isLinux)?fe((0,_.ltrim)(z.substr(Y.base.length),A.sep),J):null};return X.allBasenames=fe.allBasenames,X.allPaths=fe.allPaths,X.basenames=fe.basenames,X.patterns=fe.patterns,X}function f(fe,Y){return Y.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function S(fe,Y){return function(X,z){return typeof X=="string"&&X.endsWith(fe)?Y:null}}function I(fe,Y){const X=`/${fe}`,z=`\\${fe}`,J=function(le,we){return typeof le!="string"?null:we?we===fe?Y:null:le===fe||le.endsWith(X)||le.endsWith(z)?Y:null},ge=[fe];return J.basenames=ge,J.patterns=[Y],J.allBasenames=ge,J}function E(fe,Y){const X=H(fe.slice(1,-1).split(",").map(we=>i(we,Y)).filter(we=>we!==r),fe),z=X.length;if(!z)return r;if(z===1)return X[0];const J=function(we,G){for(let B=0,V=X.length;B<V;B++)if(X[B](we,G))return fe;return null},ge=X.find(we=>!!we.allBasenames);ge&&(J.allBasenames=ge.allBasenames);const le=X.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return le.length&&(J.allPaths=le),J}function h(fe,Y,X){const z=A.sep===A.posix.sep,J=z?fe:fe.replace(v,A.sep),ge=A.sep+J,le=A.posix.sep+fe;let we;return X?we=function(G,B){return typeof G=="string"&&(G===J||G.endsWith(ge)||!z&&(G===fe||G.endsWith(le)))?Y:null}:we=function(G,B){return typeof G=="string"&&(G===J||!z&&G===fe)?Y:null},we.allPaths=[(X?"*/":"./")+fe],we}function m(fe){try{const Y=new RegExp(`^${w(fe)}$`);return function(X){return Y.lastIndex=0,typeof X=="string"&&Y.test(X)?fe:null}}catch{return r}}function P(fe,Y,X){return!fe||typeof Y!="string"?!1:O(fe)(Y,void 0,X)}e.match=P;function O(fe,Y={}){if(!fe)return n;if(typeof fe=="string"||N(fe)){const X=i(fe,Y);if(X===r)return n;const z=function(J,ge){return!!X(J,ge)};return X.allBasenames&&(z.allBasenames=X.allBasenames),X.allPaths&&(z.allPaths=X.allPaths),z}return x(fe,Y)}e.parse=O;function N(fe){const Y=fe;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=N;function L(fe){return fe.allBasenames||[]}e.getBasenameTerms=L;function U(fe){return fe.allPaths||[]}e.getPathTerms=U;function x(fe,Y){const X=H(Object.getOwnPropertyNames(fe).map(we=>M(we,fe[we],Y)).filter(we=>we!==r)),z=X.length;if(!z)return r;if(!X.some(we=>!!we.requiresSiblings)){if(z===1)return X[0];const we=function(V,me){let Z;for(let ne=0,re=X.length;ne<re;ne++){const ye=X[ne](V,me);if(typeof ye=="string")return ye;(0,F.isThenable)(ye)&&(Z||(Z=[]),Z.push(ye))}return Z?(async()=>{for(const ne of Z){const re=await ne;if(typeof re=="string")return re}return null})():null},G=X.find(V=>!!V.allBasenames);G&&(we.allBasenames=G.allBasenames);const B=X.reduce((V,me)=>me.allPaths?V.concat(me.allPaths):V,[]);return B.length&&(we.allPaths=B),we}const J=function(we,G,B){let V,me;for(let Z=0,ne=X.length;Z<ne;Z++){const re=X[Z];re.requiresSiblings&&B&&(G||(G=(0,A.basename)(we)),V||(V=G.substr(0,G.length-(0,A.extname)(we).length)));const ye=re(we,G,V,B);if(typeof ye=="string")return ye;(0,F.isThenable)(ye)&&(me||(me=[]),me.push(ye))}return me?(async()=>{for(const Z of me){const ne=await Z;if(typeof ne=="string")return ne}return null})():null},ge=X.find(we=>!!we.allBasenames);ge&&(J.allBasenames=ge.allBasenames);const le=X.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return le.length&&(J.allPaths=le),J}function M(fe,Y,X){if(Y===!1)return r;const z=i(fe,X);if(z===r)return r;if(typeof Y=="boolean")return z;if(Y){const J=Y.when;if(typeof J=="string"){const ge=(le,we,G,B)=>{if(!B||!z(le,we))return null;const V=J.replace("$(basename)",()=>G),me=B(V);return(0,F.isThenable)(me)?me.then(Z=>Z?fe:null):me?fe:null};return ge.requiresSiblings=!0,ge}}return z}function H(fe,Y){const X=fe.filter(we=>!!we.basenames);if(X.length<2)return fe;const z=X.reduce((we,G)=>{const B=G.basenames;return B?we.concat(B):we},[]);let J;if(Y){J=[];for(let we=0,G=z.length;we<G;we++)J.push(Y)}else J=X.reduce((we,G)=>{const B=G.patterns;return B?we.concat(B):we},[]);const ge=function(we,G){if(typeof we!="string")return null;if(!G){let V;for(V=we.length;V>0;V--){const me=we.charCodeAt(V-1);if(me===47||me===92)break}G=we.substr(V)}const B=z.indexOf(G);return B!==-1?J[B]:null};ge.basenames=z,ge.patterns=J,ge.allBasenames=z;const le=fe.filter(we=>!we.basenames);return le.push(ge),le}function j(fe,Y){return(0,D.equals)(fe,Y,(X,z)=>typeof X=="string"&&typeof z=="string"?X===z:typeof X!="string"&&typeof z!="string"?X.base===z.base&&X.pattern===z.pattern:!1)}e.patternsEquals=j}),define(Ce[80],De([1,0,8,161,24,15,2]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class _{constructor(o="",a=!1){if(this.value=o,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(o,a=0){return this.value+=v(this.supportThemeIcons?(0,F.escapeIcons)(o):o).replace(/([ \t]+)/g,(c,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,a){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(o,a,c){return this.value+="[",this.value+=this._escape(a,"]"),this.value+="](",this.value+=this._escape(String(o),")"),c&&(this.value+=` "${this._escape(this._escape(c,'"'),")")}"`),this.value+=")",this}_escape(o,a){const c=new RegExp((0,R.escapeRegExpCharacters)(a),"g");return o.replace(c,(g,u)=>o.charAt(u-1)!=="\\"?`\\${g}`:g)}}e.MarkdownString=_;function b(s){return T(s)?!s.value:Array.isArray(s)?s.every(b):!0}e.isEmptyMarkdownString=b;function T(s){return s instanceof _?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function k(s,o){return s===o?!0:!s||!o?!1:s.value===o.value&&s.isTrusted===o.isTrusted&&s.supportThemeIcons===o.supportThemeIcons&&s.supportHtml===o.supportHtml&&(s.baseUri===o.baseUri||!!s.baseUri&&!!o.baseUri&&(0,d.isEqual)(A.URI.from(s.baseUri),A.URI.from(o.baseUri)))}e.markdownStringEqual=k;function v(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function y(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function C(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function w(s){const o=[],a=s.split("|").map(g=>g.trim());s=a[0];const c=a[1];if(c){const g=/height=(\d+)/.exec(c),u=/width=(\d+)/.exec(c),t=g?g[1]:"",n=u?u[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&o.push(`width="${n}"`),i&&o.push(`height="${t}"`)}return{href:s,dimensions:o}}e.parseHrefAndDimensions=w}),define(Ce[100],De([1,0,19,32,16,12,24,15]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function _(i,l){const{os:f,tildify:S,relative:I}=l;if(I){const m=b(i,I,f);if(typeof m=="string")return m}let E=i.fsPath;if(f===1&&!R.isWindows?E=E.replace(/\//g,"\\"):f!==1&&R.isWindows&&(E=E.replace(/\\/g,"/")),f!==1&&S?.userHome){const m=S.userHome.fsPath;let P;i.scheme!==S.userHome.scheme&&i.path.startsWith(d.posix.sep)?P=S.userHome.with({path:i.path}).fsPath:P=i.fsPath,E=v(P,m,f)}return(f===1?d.win32:d.posix).normalize(T(E,f===1))}e.getPathLabel=_;function b(i,l,f){const S=f===1?d.win32:d.posix,I=f===3?A.extUri:A.extUriIgnorePathCase,E=l.getWorkspace(),h=(0,D.firstOrDefault)(E.folders);if(!h)return;i.scheme!==h.uri.scheme&&i.path.startsWith(d.posix.sep)&&(i=h.uri.with({path:i.path}));const m=l.getWorkspaceFolder(i);if(!m)return;let P;if(I.isEqual(m.uri,i)?P="":P=I.relativePath(m.uri,i)??"",P&&(P=S.normalize(P)),E.folders.length>1&&!l.noPrefix){const O=m.name?m.name:I.basenameOrAuthority(m.uri);P=P?`${O} \u2022 ${P}`:O}return P}function T(i,l=R.isWindows){return(0,F.hasDriveLetter)(i,l)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=T;let k=Object.create(null);function v(i,l,f=R.OS){if(f===1||!i||!l)return i;let S=k.original===l?k.normalized:void 0;S||(S=l,R.isWindows&&(S=(0,F.toSlashes)(S)),S=`${(0,p.rtrim)(S,d.posix.sep)}${d.posix.sep}`,k={original:l,normalized:S});let I=i;return R.isWindows&&(I=(0,F.toSlashes)(I)),(f===3?I.startsWith(S):(0,p.startsWithIgnoreCase)(I,S))?`~/${I.substr(S.length)}`:i}e.tildify=v;function y(i,l){return i.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=y;const C="\u2026",w="\\\\",s="~";function o(i,l=d.sep){const f=new Array(i.length);let S=!1;for(let I=0;I<i.length;I++){const E=i[I];if(E===""){f[I]=`.${l}`;continue}if(!E){f[I]=E;continue}S=!0;let h="",m=E;m.indexOf(w)===0?(h=m.substr(0,m.indexOf(w)+w.length),m=m.substr(m.indexOf(w)+w.length)):m.indexOf(l)===0?(h=m.substr(0,m.indexOf(l)+l.length),m=m.substr(m.indexOf(l)+l.length)):m.indexOf(s)===0&&(h=m.substr(0,m.indexOf(s)+s.length),m=m.substr(m.indexOf(s)+s.length));const P=m.split(l);for(let O=1;S&&O<=P.length;O++)for(let N=P.length-O;S&&N>=0;N--){S=!1;let L=P.slice(N,N+O).join(l);for(let U=0;!S&&U<i.length;U++)if(U!==I&&i[U]&&i[U].indexOf(L)>-1){const x=N+O===P.length,M=N>0&&i[U].indexOf(l)>-1?l+L:L,H=i[U].endsWith(M);S=!x||H}if(!S){let U="";(P[0].endsWith(":")||h!=="")&&(N===1&&(N=0,O++,L=P[0]+l+L),N>0&&(U=P[0]+l),U=h+U),N>0&&(U=U+C+l),U=U+L,N+O<P.length&&(U=U+l+C),f[I]=U}}S&&(f[I]=E)}return f}e.shorten=o;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function c(i,l=Object.create(null)){const f=[];let S=!1,I="";for(const E of i)if(E==="$"||S&&E==="{")I&&f.push({value:I,type:a.TEXT}),I="",S=!0;else if(E==="}"&&S){const h=l[I];if(typeof h=="string")h.length&&f.push({value:h,type:a.VARIABLE});else if(h){const m=f[f.length-1];(!m||m.type!==a.SEPARATOR)&&f.push({value:h.label,type:a.SEPARATOR})}I="",S=!1}else I+=E;return I&&!S&&f.push({value:I,type:a.TEXT}),f.filter((E,h)=>{if(E.type===a.SEPARATOR){const m=f[h-1],P=f[h+1];return[m,P].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=c;function g(i,l){return R.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function u(i,l){return R.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=u;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(i){if(i.endsWith("]")){const l=i.lastIndexOf(" [",i.length-2);if(l!==-1){const f=r(i.substring(0,l));return{name:f.name,parentPath:f.parentPath+i.substring(l)}}}return r(i)}e.splitRecentLabel=n;function r(i){const l=i.indexOf("/")!==-1?d.posix:d.win32,f=l.basename(i),S=l.dirname(i);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}}),define(Ce[128],De([1,0,22,2]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function d(k){return k.toJSON()}class R{constructor(v){this._uriTransformer=v}transformIncoming(v){const y=this._uriTransformer.transformIncoming(v);return y===v?v:d(F.URI.from(y))}transformOutgoing(v){const y=this._uriTransformer.transformOutgoing(v);return y===v?v:d(F.URI.from(y))}transformOutgoingURI(v){const y=this._uriTransformer.transformOutgoing(v);return y===v?v:F.URI.from(y)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,v,y){if(!k||y>200)return null;if(typeof k=="object"){if(k instanceof F.URI)return v.transformOutgoing(k);for(const C in k)if(Object.hasOwnProperty.call(k,C)){const w=A(k[C],v,y+1);w!==null&&(k[C]=w)}}return null}function p(k,v){const y=A(k,v,0);return y===null?k:y}e.transformOutgoingURIs=p;function _(k,v,y,C){if(!k||C>200)return null;if(typeof k=="object"){if(k.$mid===1)return y?F.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof D.VSBuffer)return null;for(const w in k)if(Object.hasOwnProperty.call(k,w)){const s=_(k[w],v,y,C+1);s!==null&&(k[w]=s)}}return null}function b(k,v){const y=_(k,v,!1,0);return y===null?k:y}e.transformIncomingURIs=b;function T(k,v){const y=_(k,v,!0,0);return y===null?k:y}e.transformAndReviveIncomingURIs=T}),define(Ce[29],De([1,0,52,63,371,9,32,77,16,12,24,2]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function y(M,H=v.UNLINK,j){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return H===v.UNLINK?w(M):C(M,j)}async function C(M,H=(0,A.randomPath)((0,F.tmpdir)())){try{try{await D.promises.rename(M,H)}catch(j){return j.code==="ENOENT"?void 0:w(M)}w(H).catch(j=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function w(M){return(0,d.promisify)(D.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function s(M){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function o(M,H){return g(await(H?a(M):(0,d.promisify)(D.readdir)(M)))}async function a(M){try{return await(0,d.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const H=[],j=await o(M);for(const fe of j){let Y=!1,X=!1,z=!1;try{const J=await e.Promises.lstat((0,_.join)(M,fe));Y=J.isFile(),X=J.isDirectory(),z=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}H.push({name:fe,isFile:()=>Y,isDirectory:()=>X,isSymbolicLink:()=>z})}return H}function c(M){return g(D.readdirSync(M))}e.readdirSync=c;function g(M){return M.map(H=>typeof H=="string"?b.isMacintosh?(0,p.normalizeNFC)(H):H:(H.name=b.isMacintosh?(0,p.normalizeNFC)(H.name):H.name,H))}async function u(M){const H=await o(M),j=[];for(const fe of H)await n.existsDirectory((0,_.join)(M,fe))&&j.push(fe);return j}function t(M,H=1e3){return new Promise(j=>{let fe=!1;const Y=setInterval(()=>{fe||(fe=!0,D.access(M,X=>{fe=!1,X&&(clearInterval(Y),j(void 0))}))},H)})}e.whenDeleted=t;var n;(function(M){async function H(Y){let X;try{if(X=await e.Promises.lstat(Y),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(b.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw J}throw z}}M.stat=H;async function j(Y){try{const{stat:X,symbolicLink:z}=await M.stat(Y);return X.isFile()&&z?.dangling!==!0}catch{}return!1}M.existsFile=j;async function fe(Y){try{const{stat:X,symbolicLink:z}=await M.stat(Y);return X.isDirectory()&&z?.dangling!==!0}catch{}return!1}M.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const r=new R.ResourceQueue;function i(M,H,j){return r.queueFor(k.URI.file(M),T.extUriBiasedIgnorePathCase).queue(()=>{const fe=E(j);return new Promise((Y,X)=>S(M,H,fe,z=>z?X(z):Y()))})}let l=!0;function f(M){l=M}e.configureFlushOnWrite=f;function S(M,H,j,fe){if(!l)return D.writeFile(M,H,{mode:j.mode,flag:j.flag},fe);D.open(M,j.flag,j.mode,(Y,X)=>{if(Y)return fe(Y);D.writeFile(X,H,z=>{if(z)return D.close(X,()=>fe(z));D.fdatasync(X,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),f(!1)),D.close(X,ge=>fe(ge))))})})}function I(M,H,j){const fe=E(j);if(!l)return D.writeFileSync(M,H,{mode:fe.mode,flag:fe.flag});const Y=D.openSync(M,fe.flag,fe.mode);try{D.writeFileSync(Y,H);try{D.fdatasyncSync(Y)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),f(!1)}}finally{D.closeSync(Y)}}e.writeFileSync=I;function E(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function h(M,H,j=6e4){if(M!==H)try{b.isWindows&&typeof j=="number"?await m(M,H,Date.now(),j):await(0,d.promisify)(D.rename)(M,H)}catch(fe){if(M.toLowerCase()!==H.toLowerCase()&&fe.code==="EXDEV"||M.endsWith("."))await P(M,H,{preserveSymlinks:!1}),await y(M,v.MOVE);else throw fe}}async function m(M,H,j,fe,Y=0){try{return await(0,d.promisify)(D.rename)(M,H)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-j>=fe)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${X}`),X;if(Y===0){let z=!1;try{const{stat:J}=await n.stat(H);J.isFile()||(z=!0)}catch{}if(z)throw X}return await(0,R.timeout)(Math.min(100,Y*10)),m(M,H,j,fe,Y+1)}}async function P(M,H,j){return N(M,H,{root:{source:M,target:H},options:j,handledSourcePaths:new Set})}const O=511;async function N(M,H,j){if(j.handledSourcePaths.has(M))return;j.handledSourcePaths.add(M);const{stat:fe,symbolicLink:Y}=await n.stat(M);if(Y){if(j.options.preserveSymlinks)try{return await x(M,H,j)}catch(X){console.warn("[node.js fs] copy of symlink failed: ",X)}if(Y.dangling)return}return fe.isDirectory()?L(M,H,fe.mode&O,j):U(M,H,fe.mode&O)}async function L(M,H,j,fe){await e.Promises.mkdir(H,{recursive:!0,mode:j});const Y=await o(M);for(const X of Y)await N((0,_.join)(M,X),(0,_.join)(H,X),fe)}async function U(M,H,j){await e.Promises.copyFile(M,H),await e.Promises.chmod(H,j)}async function x(M,H,j){let fe=await e.Promises.readlink(M);(0,A.isEqualOrParent)(fe,j.root.source,!b.isLinux)&&(fe=(0,_.join)(j.root.target,fe.substr(j.root.source.length+1))),await e.Promises.symlink(fe,H)}e.Promises=new class{get access(){return(0,d.promisify)(D.access)}get stat(){return(0,d.promisify)(D.stat)}get lstat(){return(0,d.promisify)(D.lstat)}get utimes(){return(0,d.promisify)(D.utimes)}get read(){return(M,H,j,fe,Y)=>new Promise((X,z)=>{D.read(M,H,j,fe,Y,(J,ge,le)=>J?z(J):X({bytesRead:ge,buffer:le}))})}get readFile(){return(0,d.promisify)(D.readFile)}get write(){return(M,H,j,fe,Y)=>new Promise((X,z)=>{D.write(M,H,j,fe,Y,(J,ge,le)=>J?z(J):X({bytesWritten:ge,buffer:le}))})}get appendFile(){return(0,d.promisify)(D.appendFile)}get fdatasync(){return(0,d.promisify)(D.fdatasync)}get truncate(){return(0,d.promisify)(D.truncate)}get copyFile(){return(0,d.promisify)(D.copyFile)}get open(){return(0,d.promisify)(D.open)}get close(){return(0,d.promisify)(D.close)}get symlink(){return(0,d.promisify)(D.symlink)}get readlink(){return(0,d.promisify)(D.readlink)}get chmod(){return(0,d.promisify)(D.chmod)}get mkdir(){return(0,d.promisify)(D.mkdir)}get unlink(){return(0,d.promisify)(D.unlink)}get rmdir(){return(0,d.promisify)(D.rmdir)}get realpath(){return(0,d.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return y}get rename(){return h}get copy(){return P}}}),define(Ce[101],De([1,0,52,16,12,15,29]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function p(v){if(d.isLinux)return v;const y=(0,F.dirname)(v);if(v===y)return v;const C=((0,F.basename)(v)||v).toLowerCase();try{const s=(0,A.readdirSync)(y).filter(o=>o.toLowerCase()===C);if(s.length===1){const o=p(y);if(o)return(0,F.join)(o,s[0])}else if(s.length>1){const o=s.indexOf(C);if(o>=0){const a=p(y);if(a)return(0,F.join)(a,s[o])}}}catch{}return null}e.realcaseSync=p;async function _(v){if(d.isLinux)return v;const y=(0,F.dirname)(v);if(v===y)return v;const C=((0,F.basename)(v)||v).toLowerCase();try{const s=(await A.Promises.readdir(y)).filter(o=>o.toLowerCase()===C);if(s.length===1){const o=await _(y);if(o)return(0,F.join)(o,s[0])}else if(s.length>1){const o=s.indexOf(C);if(o>=0){const a=await _(y);if(a)return(0,F.join)(a,s[o])}}}catch{}return null}e.realcase=_;async function b(v){try{return await A.Promises.realpath(v)}catch{const C=k(v);return await A.Promises.access(C,D.constants.R_OK),C}}e.realpath=b;function T(v){try{return D.realpathSync(v)}catch{const C=k(v);return D.accessSync(C,D.constants.R_OK),C}}e.realpathSync=T;function k(v){return(0,R.rtrim)((0,F.normalize)(v),F.sep)}}),define(Ce[102],De([1,0,16,12,47,99,18,29]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function _(k=d.env){return k.comspec||"cmd.exe"}e.getWindowsShell=_;function b(k){let v=[],y=!1;const C=function(w){if(y){v.push(w);return}(!k.send(w,o=>{if(o&&console.error(o),y=!1,v.length>0){const a=v.slice(0);v=[],a.forEach(c=>C(c))}})||F.isWindows)&&(y=!0)};return{send:C}}e.createQueuedSender=b;var T;(function(k){async function v(y,C,w){if(D.isAbsolute(y))return y;if(C===void 0&&(C=d.cwd()),D.dirname(y)!=="."||(w===void 0&&A.isString(d.env.PATH)&&(w=d.env.PATH.split(D.delimiter)),w===void 0||w.length===0))return D.join(C,y);async function o(a){if(await p.Promises.exists(a)){let c;try{c=await p.Promises.stat(a)}catch(g){g.message.startsWith("EACCES")&&(c=await p.Promises.lstat(a))}return c?!c.isDirectory():!1}return!1}for(const a of w){let c;if(D.isAbsolute(a)?c=D.join(a,y):c=D.join(C,a,y),await o(c))return c;let g=c+".com";if(await o(g)||(g=c+".exe",await o(g)))return g}return D.join(C,y)}k.findExecutable=v})(T||(e.win32=T={}))});var je=this&&this.__decorate||function(pe,e,D,F){var d=arguments.length,R=d<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,D):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(pe,e,D,F);else for(var p=pe.length-1;p>=0;p--)(A=pe[p])&&(R=(d<3?A(R):d>3?A(e,D,R):A(e,D))||R);return d>3&&R&&Object.defineProperty(e,D,R),R};define(Ce[81],De([1,0,19,9,22,21,56,8,4,3,62,15,18]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var y;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(y||(y={}));function C(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(w||(w={}));function s(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(o||(o={}));function a(Y){let X=0;for(let z=0;;z+=7){const J=Y.read(1);if(X|=(J.buffer[0]&127)<<z,!(J.buffer[0]&128))return X}}const c=r(0);function g(Y,X){if(X===0){Y.write(c);return}let z=0;for(let ge=X;ge!==0;ge=ge>>>7)z++;const J=d.VSBuffer.alloc(z);for(let ge=0;X!==0;ge++)J.buffer[ge]=X&127,X=X>>>7,X>0&&(J.buffer[ge]|=128);Y.write(J)}class u{constructor(X){this.buffer=X,this.pos=0}read(X){const z=this.buffer.slice(this.pos,this.pos+X);return this.pos+=z.byteLength,z}}e.BufferReader=u;class t{constructor(){this.buffers=[]}get buffer(){return d.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}e.BufferWriter=t;var n;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(n||(n={}));function r(Y){const X=d.VSBuffer.alloc(1);return X.writeUInt8(Y,0),X}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},l=typeof Buffer<"u";function f(Y,X){if(typeof X>"u")Y.write(i.Undefined);else if(typeof X=="string"){const z=d.VSBuffer.fromString(X);Y.write(i.String),g(Y,z.byteLength),Y.write(z)}else if(l&&Buffer.isBuffer(X)){const z=d.VSBuffer.wrap(X);Y.write(i.Buffer),g(Y,z.byteLength),Y.write(z)}else if(X instanceof d.VSBuffer)Y.write(i.VSBuffer),g(Y,X.byteLength),Y.write(X);else if(Array.isArray(X)){Y.write(i.Array),g(Y,X.length);for(const z of X)f(Y,z)}else if(typeof X=="number"&&(X|0)===X)Y.write(i.Uint),g(Y,X);else{const z=d.VSBuffer.fromString(JSON.stringify(X));Y.write(i.Object),g(Y,z.byteLength),Y.write(z)}}e.serialize=f;function S(Y){switch(Y.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return Y.read(a(Y)).toString();case n.Buffer:return Y.read(a(Y)).buffer;case n.VSBuffer:return Y.read(a(Y));case n.Array:{const z=a(Y),J=[];for(let ge=0;ge<z;ge++)J.push(S(Y));return J}case n.Object:return JSON.parse(Y.read(a(Y)).toString());case n.Int:return a(Y)}}e.deserialize=S;class I{constructor(X,z,J=null,ge=1e3){this.protocol=X,this.ctx=z,this.logger=J,this.timeoutDelay=ge,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(X,z){this.channels.set(X,z),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const z=this.send([X.type]);this.logger?.logOutgoing(z,0,1,s(X.type));return}case 201:case 202:case 204:case 203:{const z=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(z,X.id,1,s(X.type),X.data);return}}}send(X,z=void 0){const J=new t;return f(J,X),f(J,z),this.sendBuffer(J.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const z=new u(X),J=S(z),ge=S(z),le=J[0];switch(le){case 100:return this.logger?.logIncoming(X.byteLength,J[1],1,`${C(le)}: ${J[2]}.${J[3]}`,ge),this.onPromise({type:le,id:J[1],channelName:J[2],name:J[3],arg:ge});case 102:return this.logger?.logIncoming(X.byteLength,J[1],1,`${C(le)}: ${J[2]}.${J[3]}`,ge),this.onEventListen({type:le,id:J[1],channelName:J[2],name:J[3],arg:ge});case 101:return this.logger?.logIncoming(X.byteLength,J[1],1,`${C(le)}`),this.disposeActiveRequest({type:le,id:J[1]});case 103:return this.logger?.logIncoming(X.byteLength,J[1],1,`${C(le)}`),this.disposeActiveRequest({type:le,id:J[1]})}}onPromise(X){const z=this.channels.get(X.channelName);if(!z){this.collectPendingRequest(X);return}const J=new R.CancellationTokenSource;let ge;try{ge=z.call(this.ctx,X.name,X.arg,J.token)}catch(G){ge=Promise.reject(G)}const le=X.id;ge.then(G=>{this.sendResponse({id:le,data:G,type:201})},G=>{G instanceof Error?this.sendResponse({id:le,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:le,data:G,type:203})}).finally(()=>{we.dispose(),this.activeRequests.delete(X.id)});const we=(0,b.toDisposable)(()=>J.cancel());this.activeRequests.set(X.id,we)}onEventListen(X){const z=this.channels.get(X.channelName);if(!z){this.collectPendingRequest(X);return}const J=X.id,le=z.listen(this.ctx,X.name,X.arg)(we=>this.sendResponse({id:J,data:we,type:204}));this.activeRequests.set(X.id,le)}disposeActiveRequest(X){const z=this.activeRequests.get(X.id);z&&(z.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let z=this.pendingRequests.get(X.channelName);z||(z=[],this.pendingRequests.set(X.channelName,z));const J=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:X,timeoutTimer:J})}flushPendingRequests(X){const z=this.pendingRequests.get(X);if(z){for(const J of z)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=I;var E;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class h{constructor(X,z=null){this.protocol=X,this.isDisposed=!1,this.state=o.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=z}getChannel(X){const z=this;return{call(J,ge,le){return z.isDisposed?Promise.reject(new p.CancellationError):z.requestPromise(X,J,ge,le)},listen(J,ge){return z.isDisposed?_.Event.None:z.requestEvent(X,J,ge)}}}requestPromise(X,z,J,ge=R.CancellationToken.None){const le=this.lastRequestId++,G={id:le,type:100,channelName:X,name:z,arg:J};if(ge.isCancellationRequested)return Promise.reject(new p.CancellationError);let B;return new Promise((me,Z)=>{if(ge.isCancellationRequested)return Z(new p.CancellationError);const ne=()=>{const de=ee=>{switch(ee.type){case 201:this.handlers.delete(le),me(ee.data);break;case 202:{this.handlers.delete(le);const ue=new Error(ee.data.message);ue.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,ue.name=ee.data.name,Z(ue);break}case 203:this.handlers.delete(le),Z(ee.data);break}};this.handlers.set(le,de),this.sendRequest(G)};let re=null;this.state===o.Idle?ne():(re=(0,F.createCancelablePromise)(de=>this.whenInitialized()),re.then(()=>{re=null,ne()}));const ye=()=>{re?(re.cancel(),re=null):this.sendRequest({id:le,type:101}),Z(new p.CancellationError)},oe=ge.onCancellationRequested(ye);B=(0,b.combinedDisposable)((0,b.toDisposable)(ye),oe),this.activeRequests.add(B)}).finally(()=>{B.dispose(),this.activeRequests.delete(B)})}requestEvent(X,z,J){const ge=this.lastRequestId++,we={id:ge,type:102,channelName:X,name:z,arg:J};let G=null;const B=new _.Emitter({onWillAddFirstListener:()=>{G=(0,F.createCancelablePromise)(me=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(B),this.sendRequest(we)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(B),this.sendRequest({id:ge,type:103}))}}),V=me=>B.fire(me.data);return this.handlers.set(ge,V),B.event}sendRequest(X){switch(X.type){case 100:case 102:{const z=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger?.logOutgoing(z,X.id,0,`${C(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const z=this.send([X.type,X.id]);this.logger?.logOutgoing(z,X.id,0,C(X.type));return}}}send(X,z=void 0){const J=new t;return f(J,X),f(J,z),this.sendBuffer(J.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const z=new u(X),J=S(z),ge=S(z),le=J[0];switch(le){case 200:return this.logger?.logIncoming(X.byteLength,0,0,s(le)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(X.byteLength,J[1],0,s(le),ge),this.onResponse({type:J[0],id:J[1],data:ge})}}onResponse(X){if(X.type===200){this.state=o.Idle,this._onDidInitialize.fire();return}this.handlers.get(X.id)?.(X)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=h,je([A.memoize],h.prototype,"onDidInitializePromise",null);class m{get connections(){const X=[];return this._connections.forEach(z=>X.push(z)),X}constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new b.DisposableStore,this.disposables.add(X(({protocol:z,onDidClientDisconnect:J})=>{const ge=_.Event.once(z.onMessage);this.disposables.add(ge(le=>{const we=new u(le),G=S(we),B=new I(z,G),V=new h(z);this.channels.forEach((Z,ne)=>B.registerChannel(ne,Z));const me={channelServer:B,channelClient:V,ctx:G};this._connections.add(me),this._onDidAddConnection.fire(me),this.disposables.add(J(()=>{B.dispose(),V.dispose(),this._connections.delete(me),this._onDidRemoveConnection.fire(me)}))}))}))}getChannel(X,z){const J=this;return{call(ge,le,we){let G;if((0,v.isFunction)(z)){const V=(0,D.getRandomElement)(J.connections.filter(z));G=V?Promise.resolve(V):_.Event.toPromise(_.Event.filter(J.onDidAddConnection,z))}else G=z.routeCall(J,ge,le);const B=G.then(V=>V.channelClient.getChannel(X));return O(B).call(ge,le,we)},listen(ge,le){if((0,v.isFunction)(z))return J.getMulticastEvent(X,z,ge,le);const we=z.routeEvent(J,ge,le).then(G=>G.channelClient.getChannel(X));return O(we).listen(ge,le)}}}getMulticastEvent(X,z,J,ge){const le=this;let we;const G=new _.Emitter({onWillAddFirstListener:()=>{we=new b.DisposableStore;const B=new _.EventMultiplexer,V=new Map,me=ne=>{const ye=ne.channelClient.getChannel(X).listen(J,ge),oe=B.add(ye);V.set(ne,oe)},Z=ne=>{const re=V.get(ne);re&&(re.dispose(),V.delete(ne))};le.connections.filter(z).forEach(me),_.Event.filter(le.onDidAddConnection,z)(me,void 0,we),le.onDidRemoveConnection(Z,void 0,we),B.event(G.fire,G,we),we.add(B)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return G.event}registerChannel(X,z){this.channels.set(X,z);for(const J of this._connections)J.channelServer.registerChannel(X,z)}dispose(){this.disposables.dispose();for(const X of this._connections)X.channelClient.dispose(),X.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=m;class P{constructor(X,z,J=null){const ge=new t;f(ge,z),X.send(ge.buffer),this.channelClient=new h(X,J),this.channelServer=new I(X,z,J)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,z){this.channelServer.registerChannel(X,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function O(Y){return{call(X,z,J){return Y.then(ge=>ge.call(X,z,J))},listen(X,z){const J=new _.Relay;return Y.then(ge=>J.input=ge.listen(X,z)),J.event}}}e.getDelayedChannel=O;function N(Y){let X=!1;return{call(z,J,ge){return X?Y.call(z,J,ge):(0,F.timeout)(0).then(()=>X=!0).then(()=>Y.call(z,J,ge))},listen(z,J){if(X)return Y.listen(z,J);const ge=new _.Relay;return(0,F.timeout)(0).then(()=>X=!0).then(()=>ge.input=Y.listen(z,J)),ge.event}}}e.getNextTickChannel=N;class L{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const z of X.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await _.Event.toPromise(X.onDidAddConnection),await this.route(X)}}e.StaticRouter=L;var U;(function(Y){function X(le,we,G){const B=le,V=G&&G.disableMarshalling,me=new Map;for(const Z in B)J(Z)&&me.set(Z,_.Event.buffer(B[Z],!0,void 0,we));return new class{listen(Z,ne,re){const ye=me.get(ne);if(ye)return ye;if(ge(ne)){const oe=B[ne];if(typeof oe=="function")return oe.call(B,re)}throw new p.ErrorNoTelemetry(`Event not found: ${ne}`)}call(Z,ne,re){const ye=B[ne];if(typeof ye=="function"){if(!V&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,T.revive)(re[de]);let oe=ye.apply(B,re);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new p.ErrorNoTelemetry(`Method not found: ${ne}`)}}}Y.fromService=X;function z(le,we){const G=we&&we.disableMarshalling;return new Proxy({},{get(B,V){if(typeof V=="string")return we?.properties?.has(V)?we.properties.get(V):ge(V)?function(me){return le.listen(V,me)}:J(V)?le.listen(V):async function(...me){let Z;we&&!(0,v.isUndefinedOrNull)(we.context)?Z=[we.context,...me]:Z=me;const ne=await le.call(V,Z);return G?ne:(0,T.revive)(ne)};throw new p.ErrorNoTelemetry(`Property not found: ${String(V)}`)}})}Y.toService=z;function J(le){return le[0]==="o"&&le[1]==="n"&&k.isUpperAsciiLetter(le.charCodeAt(2))}function ge(le){return/^onDynamic/.test(le)&&k.isUpperAsciiLetter(le.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const X=Y.toString();if(X!=="[object Object]")return X}return Y}function H(Y){return Array.isArray(Y)?Y.map(M):M(Y)}function j(Y,X,z,J,ge,le,we){we=H(we);const G=x[ge],B=G[J%G.length];let V=[`%c[${Y}]%c[${String(X).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(le)?(V=V.concat(we),V.push(")")):V.push(we),console.log.apply(console,V)}class fe{constructor(X,z){this._outgoingPrefix=X,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,z,J,ge,le){this._totalOutgoing+=X,j(this._outgoingPrefix,this._totalOutgoing,X,z,J,ge,le)}logIncoming(X,z,J,ge,le){this._totalIncoming+=X,j(this._incomingPrefix,this._totalIncoming,X,z,J,ge,le)}}e.IPCLogger=fe}),define(Ce[82],De([1,0,22,4,3,81]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var p;(function(i){i.enableDiagnostics=!1,i.records=[];const l=new WeakMap;let f=0;function S(E,h){if(!l.has(E)){const m=String(++f);l.set(E,m)}return l.get(E)}function I(E,h,m,P){if(!i.enableDiagnostics)return;const O=S(E,h);if(P instanceof D.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=D.VSBuffer.alloc(P.byteLength);N.set(P),i.records.push({timestamp:Date.now(),id:O,label:h,type:m,buff:N})}else i.records.push({timestamp:Date.now(),id:O,label:h,type:m,data:P})}i.traceSocketEvent=I})(p||(e.SocketDiagnostics=p={}));var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_||(e.SocketCloseEventType=_={}));let b=null;function T(){return b||(b=D.VSBuffer.alloc(0)),b}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(l){this._chunks.push(l),this._totalLength+=l.byteLength}read(l){return this._read(l,!0)}peek(l){return this._read(l,!1)}_read(l,f){if(l===0)return T();if(l>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===l){const h=this._chunks[0];return f&&(this._chunks.shift(),this._totalLength-=l),h}if(this._chunks[0].byteLength>l){const h=this._chunks[0].slice(0,l);return f&&(this._chunks[0]=this._chunks[0].slice(l),this._totalLength-=l),h}const S=D.VSBuffer.alloc(l);let I=0,E=0;for(;l>0;){const h=this._chunks[E];if(h.byteLength>l){const m=h.slice(0,l);S.set(m,I),I+=l,f&&(this._chunks[E]=h.slice(l),this._totalLength-=l),l-=l}else S.set(h,I),I+=h.byteLength,f?(this._chunks.shift(),this._totalLength-=h.byteLength):E++,l-=h.byteLength}return S}}e.ChunkStream=k;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class w{constructor(l,f,S,I){this.type=l,this.id=f,this.ack=S,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends d.Disposable{constructor(l){super(),this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=l,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(f=>this.acceptChunk(f))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;){const f=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=f.readUInt32BE(9),this._state.messageType=f.readUInt8(0),this._state.id=f.readUInt32BE(1),this._state.ack=f.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const S=this._state.messageType,I=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",f),this._onMessage.fire(new w(S,I,E,f)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class o{constructor(l){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=l,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(l){if(this._isDisposed)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const f=D.VSBuffer.alloc(13);f.writeUInt8(l.type,0),f.writeUInt32BE(l.id,1),f.writeUInt32BE(l.ack,5),f.writeUInt32BE(l.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",l.data),this._writeSoon(f,l.data)}_bufferAdd(l,f){const S=this._totalLength===0;return this._data.push(l,f),this._totalLength+=l.byteLength+f.byteLength,S}_bufferTake(){const l=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,l}_writeSoon(l,f){this._bufferAdd(l,f)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const l=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this._socket.write(l)}}class a extends d.Disposable{constructor(l){super(),this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=l,this._socketWriter=this._register(new o(this._socket)),this._socketReader=this._register(new s(this._socket)),this._register(this._socketReader.onMessage(f=>{f.type===1&&this._onMessage.fire(f.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(l){this._socketWriter.write(new w(1,0,0,l))}}e.Protocol=a;class c extends R.IPCClient{static fromSocket(l,f){return new c(new a(l),f)}get onDidDispose(){return this.protocol.onDidDispose}constructor(l,f,S=null){super(l,f,S),this.protocol=l}dispose(){super.dispose();const l=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),l.end()}}e.Client=c;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(l){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(l):this._emitter.fire(l):this._bufferedMessages.push(l)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class u{constructor(l){this.data=l,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let l=0,f=this._first;for(;f;)f=f.next,l++;return l}peek(){return this._first?this._first.data:null}toArray(){const l=[];let f=0,S=this._first;for(;S;)l[f++]=S.data,S=S.next;return l}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(l){const f=new u(l);if(!this._first){this._first=f,this._last=f;return}this._last.next=f,this._last=f}}class n{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}constructor(){this.lastRuns=[];const l=Date.now();for(let f=0;f<n._HISTORY_LENGTH;f++)this.lastRuns[f]=l-1e3*f;setInterval(()=>{for(let f=n._HISTORY_LENGTH;f>=1;f--)this.lastRuns[f]=this.lastRuns[f-1];this.lastRuns[0]=Date.now()},1e3)}load(){const l=Date.now(),f=(1+n._HISTORY_LENGTH)*1e3;let S=0;for(let I=0;I<n._HISTORY_LENGTH;I++)l-this.lastRuns[I]<=f&&S++;return 1-S/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(l){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l.loadEstimator??n.getInstance(),this._shouldSendKeepAlive=l.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new d.DisposableStore,this._socket=l.socket,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new s(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.add(this._socket.onClose(f=>this._onSocketClose.fire(f))),l.initialChunk&&this._socketReader.acceptChunk(l.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const l=new w(5,0,0,T());this._socketWriter.write(l),this._socketWriter.flush()}sendPause(){const l=new w(7,0,0,T());this._socketWriter.write(l)}sendResume(){const l=new w(8,0,0,T());this._socketWriter.write(l)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(l,f){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new d.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=l,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new s(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.add(this._socket.onClose(S=>this._onSocketClose.fire(S))),this._socketReader.acceptChunk(f)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const l=new w(3,0,this._incomingAckId,T());this._socketWriter.write(l);const f=this._outgoingUnackMsg.toArray();for(let S=0,I=f.length;S<I;S++)this._socketWriter.write(f[S]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(l){if(l.ack>this._outgoingAckId){this._outgoingAckId=l.ack;do{const f=this._outgoingUnackMsg.peek();if(f&&f.id<=l.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this._incomingMsgId)if(l.id!==this._incomingMsgId+1){const f=Date.now();f-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=f,this._socketWriter.write(new w(6,0,0,T())))}else this._incomingMsgId=l.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(l.data);break}case 2:{this._onControlMessage.fire(l.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const f=this._outgoingUnackMsg.toArray();for(let S=0,I=f.length;S<I;S++)this._socketWriter.write(f[S]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(l){const f=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const S=new w(1,f,this._incomingAckId,l);this._outgoingUnackMsg.push(S),this._isReconnecting||(this._socketWriter.write(S),this._recvAckCheck())}sendControl(l){const f=new w(2,0,0,l);this._socketWriter.write(f)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const l=Date.now()-this._incomingMsgLastTime;if(l>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-l+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const l=this._outgoingUnackMsg.peek(),f=Date.now()-l.writtenTime,S=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(f>=2e4&&S>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:f,timeSinceLastReceivedSomeData:S});return}const E=Math.max(2e4-f,2e4-S,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const l=new w(3,0,this._incomingAckId,T());this._socketWriter.write(l)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const l=new w(9,0,this._incomingAckId,T());this._socketWriter.write(l)}}e.PersistentProtocol=r}),define(Ce[183],De([1,0,48,9,22,21,181,8,4,3,23,102,99,81]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class C extends y.ChannelServer{constructor(o){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:_.Event.fromNodeEventEmitter(process,"message",a=>d.VSBuffer.wrap(Buffer.from(a,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.Server=C;class w{constructor(o,a){this.modulePath=o,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new _.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new F.Delayer(c),this.child=null,this._client=null}getChannel(o){const a=this;return{call(c,g,u){return a.requestPromise(o,c,g,u)},listen(c,g){return a.requestEvent(o,c,g)}}}requestPromise(o,a,c,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(o),t=(0,F.createCancelablePromise)(i=>u.call(a,c,i)),n=g.onCancellationRequested(()=>t.cancel()),r=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(o,a,c){if(!this.disposeDelayer)return _.Event.None;this.disposeDelayer.cancel();let g;const u=new _.Emitter({onWillAddFirstListener:()=>{g=this.getCachedChannel(o).listen(a,c)(u.fire,u),this.activeRequests.add(g)},onDidRemoveLastListener:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const o=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(a.env={...a.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(a.env),this.child=(0,D.fork)(this.modulePath,o,a);const c=new _.Emitter;_.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,A.isRemoteConsoleLog)(l)){(0,A.log)(l,`IPC Library: ${this.options.serverName}`);return}c.fire(d.VSBuffer.wrap(Buffer.from(l,"base64")))});const u=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&u.send(l.buffer.toString("base64")),n=c.event,r={send:t,onMessage:n};this._client=new y.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,f)=>{process.removeListener("exit",i),this.activeRequests.forEach(S=>(0,b.dispose)(S)),this.activeRequests.clear(),l!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+f),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:f})})}return this._client}getCachedChannel(o){let a=this.channels.get(o);return a||(a=this.client.getChannel(o),this.channels.set(o,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(Ce[184],De([1,0,9,4,3,62,18]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var p;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function _(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=_;var b;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(b||(e.StorageState=b={}));class T extends d.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(y,C=Object.create(null)){super(),this.database=y,this.options=C,this._onDidChangeStorage=this._register(new F.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=this._register(new D.ThrottledDelayer(T.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){this._onDidChangeStorage.pause();try{y.changed?.forEach((C,w)=>this.acceptExternal(w,C)),y.deleted?.forEach(C=>this.acceptExternal(C,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(y,C){if(this.state===b.Closed)return;let w=!1;(0,A.isUndefinedOrNull)(C)?w=this.cache.delete(y):this.cache.get(y)!==C&&(this.cache.set(y,C),w=!0),w&&this._onDidChangeStorage.fire({key:y,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,C){const w=this.cache.get(y);return(0,A.isUndefinedOrNull)(w)?C:w}getBoolean(y,C){const w=this.get(y);return(0,A.isUndefinedOrNull)(w)?C:w==="true"}getNumber(y,C){const w=this.get(y);return(0,A.isUndefinedOrNull)(w)?C:parseInt(w,10)}getObject(y,C){const w=this.get(y);return(0,A.isUndefinedOrNull)(w)?C:(0,R.parse)(w)}async set(y,C,w=!1){if(this.state===b.Closed)return;if((0,A.isUndefinedOrNull)(C))return this.delete(y,w);const s=(0,A.isObject)(C)||Array.isArray(C)?(0,R.stringify)(C):String(C);if(this.cache.get(y)!==s)return this.cache.set(y,s),this.pendingInserts.set(y,s),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire({key:y,external:w}),this.doFlush()}async delete(y,C=!1){if(!(this.state===b.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire({key:y,external:C}),this.doFlush()}async optimize(){if(this.state!==b.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(this.hasPending)return this.doFlush(y)}async doFlush(y){return this.options.hint===p.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}isInMemory(){return this.options.hint===p.STORAGE_IN_MEMORY}}e.Storage=T;class k{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((C,w)=>this.items.set(w,C)),y.delete?.forEach(C=>this.items.delete(C))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=k}),define(Ce[185],De([1,0,35,16]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function d(R,A,p,_,b,T){if(Array.isArray(R)){let k=0;for(const v of R){const y=d(v,A,p,_,b,T);if(y===10)return y;y>k&&(k=y)}return k}else{if(typeof R=="string")return _?R==="*"?5:R===p?10:0:0;if(R){const{language:k,pattern:v,scheme:y,hasAccessToAllModels:C,notebookType:w}=R;if(!_&&!C)return 0;w&&b&&(A=b);let s=0;if(y)if(y===A.scheme)s=10;else if(y==="*")s=5;else return 0;if(k)if(k===p)s=10;else if(k==="*")s=Math.max(s,5);else return 0;if(w)if(w===T)s=10;else if(w==="*"&&T!==void 0)s=Math.max(s,5);else return 0;if(v){let o;if(typeof v=="string"?o=v:o={...v,base:(0,F.normalize)(v.base)},o===A.fsPath||(0,D.match)(o,A.fsPath))s=10;else return 0}return s}else return 0}}e.score=d}),define(Ce[129],De([1,0,22,12]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var d;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(d||(d={}));function R(k){for(let v=0,y=k.length;v<y;v+=4){const C=k[v+0],w=k[v+1],s=k[v+2],o=k[v+3];k[v+0]=o,k[v+1]=s,k[v+2]=w,k[v+3]=C}}function A(k){const v=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||R(v),D.VSBuffer.wrap(v)}function p(k){const v=k.buffer;if(F.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const y=new Uint8Array(v.byteLength);return y.set(v),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function _(k){const v=new Uint32Array(b(k));let y=0;if(v[y++]=k.id,k.type==="full")v[y++]=1,v[y++]=k.data.length,v.set(k.data,y),y+=k.data.length;else{v[y++]=2,v[y++]=k.deltas.length;for(const C of k.deltas)v[y++]=C.start,v[y++]=C.deleteCount,C.data?(v[y++]=C.data.length,v.set(C.data,y),y+=C.data.length):v[y++]=0}return A(v)}e.encodeSemanticTokensDto=_;function b(k){let v=0;if(v+=1+1,k.type==="full")v+=1+k.data.length;else{v+=1,v+=(1+1+1)*k.deltas.length;for(const y of k.deltas)y.data&&(v+=y.data.length)}return v}function T(k){const v=p(k);let y=0;const C=v[y++];if(v[y++]===1){const a=v[y++],c=v.subarray(y,y+a);return y+=a,{id:C,type:"full",data:c}}const s=v[y++],o=[];for(let a=0;a<s;a++){const c=v[y++],g=v[y++],u=v[y++];let t;u>0&&(t=v.subarray(y,y+u),y+=u),o[a]={start:c,deleteCount:g,data:t}}return{id:C,type:"delta",deltas:o}}e.decodeSemanticTokensDto=T}),define(Ce[186],De([10,11]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[130],De([1,0,19,23,12,166,124,186]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(_||(e.EditorAutoIndentStrategy=_={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(ae){this._values=ae}hasChanged(ae){return this._values[ae]}}e.ConfigurationChangedEvent=b;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(ae,Ie,He,Be){this.id=ae,this.name=Ie,this.defaultValue=He,this.schema=Be}applyUpdate(ae,Ie){return y(ae,Ie)}compute(ae,Ie,He){return He}}class v{constructor(ae,Ie){this.newValue=ae,this.didChange=Ie}}e.ApplyUpdateResult=v;function y(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new v(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const He=Array.isArray(ce)&&Array.isArray(ae)&&D.equals(ce,ae);return new v(ae,!He)}let Ie=!1;for(const He in ae)if(ae.hasOwnProperty(He)){const Be=y(ce[He],ae[He]);Be.didChange&&(ce[He]=Be.newValue,Ie=!0)}return new v(ce,Ie)}class C{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ie){return y(ae,Ie)}validate(ae){return this.defaultValue}}class w{constructor(ae,Ie,He,Be){this.id=ae,this.name=Ie,this.defaultValue=He,this.schema=Be}applyUpdate(ae,Ie){return y(ae,Ie)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ie,He){return He}}function s(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=s;class o extends w{constructor(ae,Ie,He,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=He),super(ae,Ie,He,Be)}validate(ae){return s(ae,this.defaultValue)}}function a(ce,ae,Ie,He){if(typeof ce>"u")return ae;let Be=parseInt(ce,10);return isNaN(Be)?ae:(Be=Math.max(Ie,Be),Be=Math.min(He,Be),Be|0)}e.clampedInt=a;class c extends w{static clampedInt(ae,Ie,He,Be){return a(ae,Ie,He,Be)}constructor(ae,Ie,He,Be,Ye,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=He,rt.minimum=Be,rt.maximum=Ye),super(ae,Ie,He,rt),this.minimum=Be,this.maximum=Ye}validate(ae){return c.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function g(ce,ae,Ie,He){if(typeof ce>"u")return ae;const Be=u.float(ce,ae);return u.clamp(Be,Ie,He)}e.clampedFloat=g;class u extends w{static clamp(ae,Ie,He){return ae<Ie?Ie:ae>He?He:ae}static float(ae,Ie){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ie;const He=parseFloat(ae);return isNaN(He)?Ie:He}constructor(ae,Ie,He,Be,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=He),super(ae,Ie,He,Ye),this.validationFn=Be}validate(ae){return this.validationFn(u.float(ae,this.defaultValue))}}class t extends w{static string(ae,Ie){return typeof ae!="string"?Ie:ae}constructor(ae,Ie,He,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=He),super(ae,Ie,He,Be)}validate(ae){return t.string(ae,this.defaultValue)}}function n(ce,ae,Ie,He){return typeof ce!="string"?ae:He&&ce in He?He[ce]:Ie.indexOf(ce)===-1?ae:ce}e.stringSet=n;class r extends w{constructor(ae,Ie,He,Be,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Be,Ye.default=He),super(ae,Ie,He,Ye),this._allowedValues=Be}validate(ae){return n(ae,this.defaultValue,this._allowedValues)}}class i extends k{constructor(ae,Ie,He,Be,Ye,rt,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Ye,at.default=Be),super(ae,Ie,He,at),this._allowedValues=Ye,this._convert=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this._allowedValues.indexOf(ae)===-1?this.defaultValue:this._convert(ae)}}function l(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ie,He){return He===0?ae.accessibilitySupport:He}}class S extends k{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertSpace:s(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function E(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function m(ce){switch(ce){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function P(ce){switch(ce){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class O extends C{constructor(){super(140)}compute(ae,Ie,He){const Be=["monaco-editor"];return Ie.get(39)&&Be.push(Ie.get(39)),ae.extraEditorClassName&&Be.push(ae.extraEditorClassName),Ie.get(73)==="default"?Be.push("mouse-default"):Ie.get(73)==="copy"&&Be.push("mouse-copy"),Ie.get(110)&&Be.push("showUnused"),Ie.get(138)&&Be.push("showDeprecated"),Be.join(" ")}}class N extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ae,Ie,He){return He&&ae.emptySelectionClipboard}}class L extends k{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:p.localize(16,null),included:d.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:p.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{cursorMoveOnType:s(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(Ie.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?U.OFF:ae==="true"?U.ON:ae:ae?U.ON:U.OFF}}e.EditorFontLigatures=U;class x extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",x.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?x.OFF:ae==="true"?x.TRANSLATE:ae:ae?x.TRANSLATE:x.OFF}compute(ae,Ie,He){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=x;class M extends C{constructor(){super(50)}compute(ae,Ie,He){return ae.fontInfo}}class H extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ae){const Ie=u.float(ae,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(Ie,6,100)}compute(ae,Ie,He){return ae.fontInfo.fontSize}}class j extends k{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(c.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}class fe extends k{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends k{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:p.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:s(Ie.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(Ie.above,this.defaultValue.above)}}}var X;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class z extends C{constructor(){super(143)}compute(ae,Ie,He){return z.computeLayout(Ie,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ie=ae.height/ae.lineHeight,He=Math.floor(ae.paddingTop/ae.lineHeight);let Be=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Be=Math.max(Be,Ie-1));const Ye=(He+ae.viewLineCount+Be)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Ye);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Be,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(ae,Ie){const He=ae.outerWidth,Be=ae.outerHeight,Ye=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const rt=Ie.stableMinimapLayoutInput,at=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,vt=ae.lineHeight,Ct=ae.typicalHalfwidthCharacterWidth,Xt=ae.scrollBeyondLastLine,Vt=ae.minimap.renderCharacters;let Et=Ye>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Bt=ae.minimap.maxColumn,Nt=ae.minimap.size,$t=ae.minimap.side,Tt=ae.verticalScrollbarWidth,At=ae.viewLineCount,Ut=ae.remainingWidth,Wt=ae.isViewportWrapping,jt=Vt?2:3;let zt=Math.floor(Ye*Be);const Ht=zt/Ye;let ot=!1,ft=!1,Rt=jt*Et,Lt=Et/Ye,kt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:te,desiredRatio:Me,minimapLineCount:Ve}=z.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Xt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Be,lineHeight:vt,pixelRatio:Ye});if(At/Ve>1)ot=!0,ft=!0,Et=1,Rt=1,Lt=Et/Ye;else{let qe=!1,nt=Et+1;if(Nt==="fit"){const pt=Math.ceil((Pe+At+te)*Rt);Wt&&at&&Ut<=Ie.stableFitRemainingWidth?(qe=!0,nt=Ie.stableFitMaxMinimapScale):qe=pt>zt}if(Nt==="fill"||qe){ot=!0;const pt=Et;Rt=Math.min(vt*Ye,Math.max(1,Math.floor(1/Me))),Wt&&at&&Ut<=Ie.stableFitRemainingWidth&&(nt=Ie.stableFitMaxMinimapScale),Et=Math.min(nt,Math.max(1,Math.floor(Rt/jt))),Et>pt&&(kt=Math.min(2,Et/pt)),Lt=Et/Ye/kt,zt=Math.ceil(Math.max(Fe,Pe+At+te)*Rt),Wt?(Ie.stableMinimapLayoutInput=ae,Ie.stableFitRemainingWidth=Ut,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const ht=Math.floor(Bt*Lt),_t=Math.min(ht,Math.max(0,Math.floor((Ut-Tt-2)*Lt/(Ct+Lt)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Ye*_t);const Ft=Dt/Ye;Dt=Math.floor(Dt*kt);const Ge=Vt?1:2,Le=$t==="left"?0:He-_t-Tt;return{renderMinimap:Ge,minimapLeft:Le,minimapWidth:_t,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:Et,minimapLineHeight:Rt,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:Ht}}static computeLayout(ae,Ie){const He=Ie.outerWidth|0,Be=Ie.outerHeight|0,Ye=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,at=Ie.typicalHalfwidthCharacterWidth,vt=Ie.maxDigitWidth,Ct=Ie.pixelRatio,Xt=Ie.viewLineCount,Vt=ae.get(135),Et=Vt==="inherit"?ae.get(134):Vt,Bt=Et==="inherit"?ae.get(130):Et,Nt=ae.get(133),$t=Ie.isDominatedByLongLines,Tt=ae.get(57),At=ae.get(67).renderType!==0,Ut=ae.get(68),Wt=ae.get(104),jt=ae.get(83),zt=ae.get(72),Ht=ae.get(102),ot=Ht.verticalScrollbarSize,ft=Ht.verticalHasArrows,Rt=Ht.arrowSize,Lt=Ht.horizontalScrollbarSize,kt=ae.get(43),ht=ae.get(109)!=="never";let _t=ae.get(65);kt&&ht&&(_t+=16);let Dt=0;if(At){const wt=Math.max(rt,Ut);Dt=Math.round(wt*vt)}let Ft=0;Tt&&(Ft=Ye*Ie.glyphMarginDecorationLaneCount);let Ge=0,Le=Ge+Ft,Fe=Le+Dt,Pe=Fe+_t;const te=He-Ft-Dt-_t;let Me=!1,Ve=!1,Je=-1;Et==="inherit"&&$t?(Me=!0,Ve=!0):Bt==="on"||Bt==="bounded"?Ve=!0:Bt==="wordWrapColumn"&&(Je=Nt);const qe=z._computeMinimapLayout({outerWidth:He,outerHeight:Be,lineHeight:Ye,typicalHalfwidthCharacterWidth:at,pixelRatio:Ct,scrollBeyondLastLine:Wt,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:zt,verticalScrollbarWidth:ot,viewLineCount:Xt,remainingWidth:te,isViewportWrapping:Ve},Ie.memory||new T);qe.renderMinimap!==0&&qe.minimapLeft===0&&(Ge+=qe.minimapWidth,Le+=qe.minimapWidth,Fe+=qe.minimapWidth,Pe+=qe.minimapWidth);const nt=te-qe.minimapWidth,pt=Math.max(1,Math.floor((nt-ot-2)/at)),Pt=ft?Rt:0;return Ve&&(Je=Math.max(1,pt),Bt==="bounded"&&(Je=Math.min(Je,Nt))),{width:He,height:Be,glyphMarginLeft:Ge,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Le,lineNumbersWidth:Dt,decorationsLeft:Fe,decorationsWidth:_t,contentLeft:Pe,contentWidth:nt,minimap:qe,viewportColumn:pt,isWordWrapMinified:Me,isViewportWrapping:Ve,wrappingColumn:Je,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Lt,overviewRuler:{top:Pt,width:ot,height:Be-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=z;class J extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ae){return n(ae,"simple",["simple","advanced"])}compute(ae,Ie,He){return Ie.get(2)===2?"advanced":He}}class ge extends k{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:p.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:s(ae.enabled,this.defaultValue.enabled)}}}class le extends k{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:p.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:p.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:p.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:p.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends k{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:p.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(56,null),p.localize(57,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),p.localize(58,null,d.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),p.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:p.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:p.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:p.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:s(Ie.padding,this.defaultValue.padding)}}}class G extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):c.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ie,He){return He<0?c.clampedInt(-He*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class B extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>u.clamp(ae,0,150),{markdownDescription:p.localize(63,null)})}compute(ae,Ie,He){return ae.fontInfo.lineHeight}}class V extends k{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:p.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:p.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(66,null),p.localize(67,null),p.localize(68,null)],default:ae.size,description:p.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:p.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:p.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:p.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:p.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),autohide:s(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ie.scale,1,1,3),maxColumn:c.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(ce){return ce==="ctrlCmd"?d.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{top:c.clampedInt(Ie.top,0,0,1e3),bottom:c.clampedInt(Ie.bottom,0,0,1e3)}}}class ne extends k{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:p.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:p.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),cycle:s(Ie.cycle,this.defaultValue.cycle)}}}class re extends C{constructor(){super(141)}compute(ae,Ie,He){return ae.pixelRatio}}class ye extends k{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(79,null),p.localize(80,null),p.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ae.strings,description:p.localize(82,null)},comments:{anyOf:Ie,default:ae.comments,description:p.localize(83,null)},other:{anyOf:Ie,default:ae.other,description:p.localize(84,null)}},default:ae,markdownDescription:p.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const Ct=ae?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ie,comments:He,strings:Be}=ae,Ye=["on","inline","off"];let rt,at,vt;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,Ye),typeof He=="boolean"?at=He?"on":"off":at=n(He,this.defaultValue.comments,Ye),typeof Be=="boolean"?vt=Be?"on":"off":vt=n(Be,this.defaultValue.strings,Ye),{other:rt,comments:at,strings:vt}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class de extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(86,null),p.localize(87,null),p.localize(88,null),p.localize(89,null)],default:"on",description:p.localize(90,null)})}validate(ae){let Ie=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ie=4,He=ae):ae==="interval"?Ie=3:ae==="relative"?Ie=2:ae==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:He}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class ue extends k{constructor(){const ae=[],Ie={type:"number",description:p.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:p.localize(92,null),format:"color-hex"}}}]},default:ae,description:p.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ie=[];for(const He of ae)if(typeof He=="number")Ie.push({column:c.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Be=He;Ie.push({column:c.clampedInt(Be.column,0,0,1e4),color:Be.color})}return Ie.sort((He,Be)=>He.column-Be.column),Ie}return this.defaultValue}}class ve extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function ke(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends k{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(94,null),p.localize(95,null),p.localize(96,null)],default:"auto",description:p.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(98,null),p.localize(99,null),p.localize(100,null)],default:"auto",description:p.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:p.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:p.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:p.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae,He=c.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=c.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(Ie.vertical,this.defaultValue.vertical),horizontal:ke(Ie.horizontal,this.defaultValue.horizontal),useShadows:s(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:c.clampedInt(Ie.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:c.clampedInt(Ie.verticalSliderSize,Be,0,1e3),scrollByPage:s(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:p.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:p.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:p.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:p.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:p.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:p.localize(111,null)}})}applyUpdate(ae,Ie){let He=!1;Ie.allowedCharacters&&ae&&(F.equals(ae.allowedCharacters,Ie.allowedCharacters)||(ae={...ae,allowedCharacters:Ie.allowedCharacters},He=!0)),Ie.allowedLocales&&ae&&(F.equals(ae.allowedLocales,Ie.allowedLocales)||(ae={...ae,allowedLocales:Ie.allowedLocales},He=!0));const Be=super.applyUpdate(ae,Ie);return He?new v(Be.newValue,!0):Be}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{nonBasicASCII:he(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ae.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ae,Ie){if(typeof ae!="object"||!ae)return Ie;const He={};for(const[Be,Ye]of Object.entries(ae))Ye===!0&&(He[Be]=!0);return He}}class ie extends k{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:p.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[p.localize(113,null),p.localize(114,null)],description:p.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:p.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:s(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends k{constructor(){const ae={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:p.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:p.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends k{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(119,null),p.localize(120,null),p.localize(121,null)],default:ae.bracketPairs,description:p.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(123,null),p.localize(124,null),p.localize(125,null)],default:ae.bracketPairsHorizontal,description:p.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:p.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:p.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(129,null),p.localize(130,null),p.localize(131,null)],default:ae.highlightActiveIndentation,description:p.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{bracketPairs:he(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ce,ae,Ie){const He=Ie.indexOf(ce);return He===-1?ae:Ie[He]}class Se extends k{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(133,null),p.localize(134,null)],default:ae.insertMode,description:p.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:p.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:p.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:p.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null),p.localize(142,null)],default:ae.selectionMode,markdownDescription:p.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:p.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:p.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:p.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:p.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:p.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:s(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:s(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(Ie.showMethods,this.defaultValue.showMethods),showFunctions:s(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:s(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(Ie.showFields,this.defaultValue.showFields),showVariables:s(Ie.showVariables,this.defaultValue.showVariables),showClasses:s(Ie.showClasses,this.defaultValue.showClasses),showStructs:s(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:s(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:s(Ie.showModules,this.defaultValue.showModules),showProperties:s(Ie.showProperties,this.defaultValue.showProperties),showEvents:s(Ie.showEvents,this.defaultValue.showEvents),showOperators:s(Ie.showOperators,this.defaultValue.showOperators),showUnits:s(Ie.showUnits,this.defaultValue.showUnits),showValues:s(Ie.showValues,this.defaultValue.showValues),showConstants:s(Ie.showConstants,this.defaultValue.showConstants),showEnums:s(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:s(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(Ie.showKeywords,this.defaultValue.showKeywords),showWords:s(Ie.showWords,this.defaultValue.showWords),showColors:s(Ie.showColors,this.defaultValue.showColors),showFiles:s(Ie.showFiles,this.defaultValue.showFiles),showReferences:s(Ie.showReferences,this.defaultValue.showReferences),showFolders:s(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:s(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:s(Ie.showUsers,this.defaultValue.showUsers),showIssues:s(Ie.showIssues,this.defaultValue.showIssues)}}}class Ue extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ze extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(183,null),p.localize(184,null),p.localize(185,null),p.localize(186,null)],description:p.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ie,He){return Ie.get(2)===2?0:He}}class Qe extends C{constructor(){super(144)}compute(ae,Ie,He){const Be=Ie.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class it extends k{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:p.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(190,null),p.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends k{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:p.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(194,null),p.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:s(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Te="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.isMacintosh?Oe:d.isLinux?ze:Te,fontWeight:"normal",fontSize:d.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Xe;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(196,null)})),acceptSuggestionOnEnter:Re(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(197,null),""],markdownDescription:p.localize(198,null)})),accessibilitySupport:Re(new f),accessibilityPageSize:Re(new c(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(199,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",p.localize(200,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Re(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(202,null),p.localize(203,null),""],description:p.localize(204,null)})),autoClosingComments:Re(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(205,null),p.localize(206,null),""],description:p.localize(207,null)})),autoClosingDelete:Re(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(208,null),""],description:p.localize(209,null)})),autoClosingOvertype:Re(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(210,null),""],description:p.localize(211,null)})),autoClosingQuotes:Re(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(212,null),p.localize(213,null),""],description:p.localize(214,null)})),autoIndent:Re(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[p.localize(215,null),p.localize(216,null),p.localize(217,null),p.localize(218,null),p.localize(219,null)],description:p.localize(220,null)})),automaticLayout:Re(new o(13,"automaticLayout",!1)),autoSurround:Re(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(221,null),p.localize(222,null),p.localize(223,null),""],description:p.localize(224,null)})),bracketPairColorization:Re(new se),bracketPairGuides:Re(new Q),stickyTabStops:Re(new o(115,"stickyTabStops",!1,{description:p.localize(225,null)})),codeLens:Re(new o(17,"codeLens",!0,{description:p.localize(226,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:p.localize(227,null)})),codeLensFontSize:Re(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(228,null)})),colorDecorators:Re(new o(20,"colorDecorators",!0,{description:p.localize(229,null)})),colorDecoratorActivatedOn:Re(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null)],description:p.localize(233,null)})),colorDecoratorsLimit:Re(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(234,null)})),columnSelection:Re(new o(22,"columnSelection",!1,{description:p.localize(235,null)})),comments:Re(new S),contextmenu:Re(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(236,null)})),cursorBlinking:Re(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:p.localize(237,null)})),cursorSmoothCaretAnimation:Re(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(238,null),p.localize(239,null),p.localize(240,null)],description:p.localize(241,null)})),cursorStyle:Re(new i(28,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(242,null)})),cursorSurroundingLines:Re(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(243,null)})),cursorSurroundingLinesStyle:Re(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(244,null),p.localize(245,null)],markdownDescription:p.localize(246,null)})),cursorWidth:Re(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(247,null)})),disableLayerHinting:Re(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(34,"domReadOnly",!1)),dragAndDrop:Re(new o(35,"dragAndDrop",!0,{description:p.localize(248,null)})),emptySelectionClipboard:Re(new N),dropIntoEditor:Re(new it),stickyScroll:Re(new le),experimentalWhitespaceRendering:Re(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(249,null),p.localize(250,null),p.localize(251,null)],description:p.localize(252,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new u(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:p.localize(253,null)})),find:Re(new L),fixedOverflowWidgets:Re(new o(42,"fixedOverflowWidgets",!1)),folding:Re(new o(43,"folding",!0,{description:p.localize(254,null)})),foldingStrategy:Re(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(255,null),p.localize(256,null)],description:p.localize(257,null)})),foldingHighlight:Re(new o(45,"foldingHighlight",!0,{description:p.localize(258,null)})),foldingImportsByDefault:Re(new o(46,"foldingImportsByDefault",!1,{description:p.localize(259,null)})),foldingMaximumRegions:Re(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(260,null)})),unfoldOnClickAfterEndOfLine:Re(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(261,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(262,null)})),fontInfo:Re(new M),fontLigatures2:Re(new U),fontSize:Re(new H),fontWeight:Re(new j),fontVariations:Re(new x),formatOnPaste:Re(new o(55,"formatOnPaste",!1,{description:p.localize(263,null)})),formatOnType:Re(new o(56,"formatOnType",!1,{description:p.localize(264,null)})),glyphMargin:Re(new o(57,"glyphMargin",!0,{description:p.localize(265,null)})),gotoLocation:Re(new fe),hideCursorInOverviewRuler:Re(new o(59,"hideCursorInOverviewRuler",!1,{description:p.localize(266,null)})),hover:Re(new Y),inDiffEditor:Re(new o(61,"inDiffEditor",!1)),letterSpacing:Re(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>u.clamp(ce,-5,20),{description:p.localize(267,null)})),lightbulb:Re(new ge),lineDecorationsWidth:Re(new G),lineHeight:Re(new B),lineNumbers:Re(new de),lineNumbersMinChars:Re(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(69,"linkedEditing",!1,{description:p.localize(268,null)})),links:Re(new o(70,"links",!0,{description:p.localize(269,null)})),matchBrackets:Re(new r(71,"matchBrackets","always",["always","near","never"],{description:p.localize(270,null)})),minimap:Re(new V),mouseStyle:Re(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new u(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:p.localize(271,null)})),mouseWheelZoom:Re(new o(75,"mouseWheelZoom",!1,{markdownDescription:p.localize(272,null)})),multiCursorMergeOverlapping:Re(new o(76,"multiCursorMergeOverlapping",!0,{description:p.localize(273,null)})),multiCursorModifier:Re(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[p.localize(274,null),p.localize(275,null)],markdownDescription:p.localize(276,null)})),multiCursorPaste:Re(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(277,null),p.localize(278,null)],markdownDescription:p.localize(279,null)})),multiCursorLimit:Re(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(280,null)})),occurrencesHighlight:Re(new o(80,"occurrencesHighlight",!0,{description:p.localize(281,null)})),overviewRulerBorder:Re(new o(81,"overviewRulerBorder",!0,{description:p.localize(282,null)})),overviewRulerLanes:Re(new c(82,"overviewRulerLanes",3,0,3)),padding:Re(new Z),pasteAs:Re(new et),parameterHints:Re(new ne),peekWidgetDefaultFocus:Re(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(283,null),p.localize(284,null)],description:p.localize(285,null)})),definitionLinkOpensInPeek:Re(new o(87,"definitionLinkOpensInPeek",!1,{description:p.localize(286,null)})),quickSuggestions:Re(new ye),quickSuggestionsDelay:Re(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(287,null)})),readOnly:Re(new o(90,"readOnly",!1)),readOnlyMessage:Re(new ve),renameOnType:Re(new o(92,"renameOnType",!1,{description:p.localize(288,null),markdownDeprecationMessage:p.localize(289,null)})),renderControlCharacters:Re(new o(93,"renderControlCharacters",!0,{description:p.localize(290,null),restricted:!0})),renderFinalNewline:Re(new r(94,"renderFinalNewline",d.isLinux?"dimmed":"on",["off","on","dimmed"],{description:p.localize(291,null)})),renderLineHighlight:Re(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(292,null)],description:p.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(294,null)})),renderValidationDecorations:Re(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(295,null),p.localize(296,null),p.localize(297,null),""],description:p.localize(298,null)})),revealHorizontalRightPadding:Re(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(100,"roundedSelection",!0,{description:p.localize(299,null)})),rulers:Re(new ue),scrollbar:Re(new $),scrollBeyondLastColumn:Re(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(300,null)})),scrollBeyondLastLine:Re(new o(104,"scrollBeyondLastLine",!0,{description:p.localize(301,null)})),scrollPredominantAxis:Re(new o(105,"scrollPredominantAxis",!0,{description:p.localize(302,null)})),selectionClipboard:Re(new o(106,"selectionClipboard",!0,{description:p.localize(303,null),included:d.isLinux})),selectionHighlight:Re(new o(107,"selectionHighlight",!0,{description:p.localize(304,null)})),selectOnLineNumbers:Re(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(305,null),p.localize(306,null),p.localize(307,null)],description:p.localize(308,null)})),showUnused:Re(new o(110,"showUnused",!0,{description:p.localize(309,null)})),showDeprecated:Re(new o(138,"showDeprecated",!0,{description:p.localize(310,null)})),inlayHints:Re(new we),snippetSuggestions:Re(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(311,null),p.localize(312,null),p.localize(313,null),p.localize(314,null)],description:p.localize(315,null)})),smartSelect:Re(new Ue),smoothScrolling:Re(new o(113,"smoothScrolling",!1,{description:p.localize(316,null)})),stopRenderingLineAfter:Re(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Se),inlineSuggest:Re(new ie),inlineCompletionsAccessibilityVerbose:Re(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(317,null)})),suggestFontSize:Re(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(120,"suggestOnTriggerCharacters",!0,{description:p.localize(320,null)})),suggestSelection:Re(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(321,null),p.localize(322,null),p.localize(323,null)],description:p.localize(324,null)})),tabCompletion:Re(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(325,null),p.localize(326,null),p.localize(327,null)],description:p.localize(328,null)})),tabIndex:Re(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new K),unusualLineTerminators:Re(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(329,null),p.localize(330,null),p.localize(331,null)],description:p.localize(332,null)})),useShadowDOM:Re(new o(126,"useShadowDOM",!0)),useTabStops:Re(new o(127,"useTabStops",!0,{description:p.localize(333,null)})),wordBreak:Re(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(334,null),p.localize(335,null)],description:p.localize(336,null)})),wordSeparators:Re(new t(129,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:p.localize(337,null)})),wordWrap:Re(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(338,null),p.localize(339,null),p.localize(340,null),p.localize(341,null)],description:p.localize(342,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(343,null)})),wordWrapOverride1:Re(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new O),defaultColorDecorators:Re(new o(145,"defaultColorDecorators",!1,{markdownDescription:p.localize(344,null)})),pixelRatio:Re(new re),tabFocusMode:Re(new o(142,"tabFocusMode",!1,{markdownDescription:p.localize(345,null)})),layoutInfo:Re(new z),wrappingInfo:Re(new Qe),wrappingIndent:Re(new Ze),wrappingStrategy:Re(new J)}}),define(Ce[187],De([10,11]),function(pe,e){return pe.create("vs/editor/common/languages",e)}),define(Ce[83],De([1,0,79,2,164,34,174,187]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(U,x,M){this.offset=U,this.type=x,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class b{constructor(U,x){this.tokens=U,this.endState=x,this._tokenizationResultBrand=void 0}}e.TokenizationResult=b;class T{constructor(U,x){this.tokens=U,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=T;var k;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var v;(function(L){const U=new Map;U.set(0,D.Codicon.symbolMethod),U.set(1,D.Codicon.symbolFunction),U.set(2,D.Codicon.symbolConstructor),U.set(3,D.Codicon.symbolField),U.set(4,D.Codicon.symbolVariable),U.set(5,D.Codicon.symbolClass),U.set(6,D.Codicon.symbolStruct),U.set(7,D.Codicon.symbolInterface),U.set(8,D.Codicon.symbolModule),U.set(9,D.Codicon.symbolProperty),U.set(10,D.Codicon.symbolEvent),U.set(11,D.Codicon.symbolOperator),U.set(12,D.Codicon.symbolUnit),U.set(13,D.Codicon.symbolValue),U.set(15,D.Codicon.symbolEnum),U.set(14,D.Codicon.symbolConstant),U.set(15,D.Codicon.symbolEnum),U.set(16,D.Codicon.symbolEnumMember),U.set(17,D.Codicon.symbolKeyword),U.set(27,D.Codicon.symbolSnippet),U.set(18,D.Codicon.symbolText),U.set(19,D.Codicon.symbolColor),U.set(20,D.Codicon.symbolFile),U.set(21,D.Codicon.symbolReference),U.set(22,D.Codicon.symbolCustomColor),U.set(23,D.Codicon.symbolFolder),U.set(24,D.Codicon.symbolTypeParameter),U.set(25,D.Codicon.account),U.set(26,D.Codicon.issues);function x(j){let fe=U.get(j);return fe||(console.info("No codicon found for CompletionItemKind "+j),fe=D.Codicon.symbolProperty),fe}L.toIcon=x;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function H(j,fe){let Y=M.get(j);return typeof Y>"u"&&!fe&&(Y=9),Y}L.fromString=H})(v||(e.CompletionItemKinds=v={}));var y;(function(L){L[L.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var C;(function(L){L[L.None=0]="None",L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(C||(e.CompletionItemInsertTextRule=C={}));var w;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var s;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(s||(e.InlineCompletionTriggerKind=s={}));class o{constructor(U,x,M,H){this.range=U,this.text=x,this.completionKind=M,this.isSnippetText=H}equals(U){return R.Range.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.SelectedSuggestionInfo=o;var a;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var c;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var g;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(g||(e.DocumentHighlightKind=g={}));function u(L){return L&&F.URI.isUri(L.uri)&&R.Range.isIRange(L.range)&&(R.Range.isIRange(L.originSelectionRange)||R.Range.isIRange(L.targetSelectionRange))}e.isLocationLink=u;var t;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={[17]:(0,p.localize)(0,null),[16]:(0,p.localize)(1,null),[4]:(0,p.localize)(2,null),[13]:(0,p.localize)(3,null),[8]:(0,p.localize)(4,null),[9]:(0,p.localize)(5,null),[21]:(0,p.localize)(6,null),[23]:(0,p.localize)(7,null),[7]:(0,p.localize)(8,null),[0]:(0,p.localize)(9,null),[11]:(0,p.localize)(10,null),[10]:(0,p.localize)(11,null),[19]:(0,p.localize)(12,null),[5]:(0,p.localize)(13,null),[1]:(0,p.localize)(14,null),[2]:(0,p.localize)(15,null),[20]:(0,p.localize)(16,null),[15]:(0,p.localize)(17,null),[18]:(0,p.localize)(18,null),[24]:(0,p.localize)(19,null),[3]:(0,p.localize)(20,null),[6]:(0,p.localize)(21,null),[14]:(0,p.localize)(22,null),[22]:(0,p.localize)(23,null),[25]:(0,p.localize)(24,null),[12]:(0,p.localize)(25,null)};function n(L,U){return(0,p.localize)(26,null,L,e.symbolKindNames[U])}e.getAriaLabelForSymbol=n;var r;(function(L){L[L.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var i;(function(L){const U=new Map;U.set(0,D.Codicon.symbolFile),U.set(1,D.Codicon.symbolModule),U.set(2,D.Codicon.symbolNamespace),U.set(3,D.Codicon.symbolPackage),U.set(4,D.Codicon.symbolClass),U.set(5,D.Codicon.symbolMethod),U.set(6,D.Codicon.symbolProperty),U.set(7,D.Codicon.symbolField),U.set(8,D.Codicon.symbolConstructor),U.set(9,D.Codicon.symbolEnum),U.set(10,D.Codicon.symbolInterface),U.set(11,D.Codicon.symbolFunction),U.set(12,D.Codicon.symbolVariable),U.set(13,D.Codicon.symbolConstant),U.set(14,D.Codicon.symbolString),U.set(15,D.Codicon.symbolNumber),U.set(16,D.Codicon.symbolBoolean),U.set(17,D.Codicon.symbolArray),U.set(18,D.Codicon.symbolObject),U.set(19,D.Codicon.symbolKey),U.set(20,D.Codicon.symbolNull),U.set(21,D.Codicon.symbolEnumMember),U.set(22,D.Codicon.symbolStruct),U.set(23,D.Codicon.symbolEvent),U.set(24,D.Codicon.symbolOperator),U.set(25,D.Codicon.symbolTypeParameter);function x(M){let H=U.get(M);return H||(console.info("No codicon found for SymbolKind "+M),H=D.Codicon.symbolProperty),H}L.toIcon=x})(i||(e.SymbolKinds=i={}));class l{static asEditOperation(U){return d.EditOperation.replace(R.Range.lift(U.range),U.text)}}e.TextEdit=l;class f{static{this.Comment=new f("comment")}static{this.Imports=new f("imports")}static{this.Region=new f("region")}static fromValue(U){switch(U){case"comment":return f.Comment;case"imports":return f.Imports;case"region":return f.Region}return new f(U)}constructor(U){this.value=U}}e.FoldingRangeKind=f;var S;(function(L){function U(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}L.is=U})(S||(e.Command=S={}));var I;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var E;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})(E||(e.CommentThreadState=E={}));var h;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(h||(e.CommentMode=h={}));var m;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(m||(e.CommentState=m={}));var P;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class O{constructor(U){this.createSupport=U,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=O,e.TokenizationRegistry=new A.TokenizationRegistry;var N;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(Ce[188],De([10,11]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[189],De([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[190],De([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[191],De([10,11]),function(pe,e){return pe.create("vs/platform/dialogs/common/dialogs",e)}),define(Ce[192],De([10,11]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[193],De([10,11]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[194],De([10,11]),function(pe,e){return pe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[195],De([10,11]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Ce[196],De([10,11]),function(pe,e){return pe.create("vs/platform/files/common/io",e)}),define(Ce[197],De([10,11]),function(pe,e){return pe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[198],De([10,11]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Ce[199],De([10,11]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[200],De([10,11]),function(pe,e){return pe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[201],De([10,11]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[202],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Ce[203],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[204],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[205],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[206],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[207],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[208],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[209],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[210],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[211],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[212],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[213],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[214],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[215],De([10,11]),function(pe,e){return pe.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[216],De([10,11]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Ce[217],De([10,11]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Ce[218],De([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[219],De([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[220],De([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[221],De([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[222],De([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[223],De([10,11]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[224],De([10,11]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[225],De([10,11]),function(pe,e){return pe.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ce[226],De([10,11]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[227],De([1,0,8,190]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var d;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(d||(e.TokenType=d={}));function R(...b){switch(b.length){case 1:return(0,F.localize)(0,null,b[0]);case 2:return(0,F.localize)(1,null,b[0],b[1]);case 3:return(0,F.localize)(2,null,b[0],b[1],b[2]);default:return}}const A=(0,F.localize)(3,null),p=(0,F.localize)(4,null);class _{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,D.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(T){return this._input=T,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const k=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:k})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const k=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:k})}else this._match(126)?this._addToken(9):this._error(R("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(R("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(T){return this._isAtEnd()||this._input.charCodeAt(this._current)!==T?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(T){this._tokens.push({type:T,offset:this._start})}_error(T){const k=this._start,v=this._input.substring(this._start,this._current),y={type:19,offset:this._start,lexeme:v};this._errors.push({offset:k,lexeme:v,additionalInfo:T}),this._tokens.push(y)}_string(){this.stringRe.lastIndex=this._start;const T=this.stringRe.exec(this._input);if(T){this._current=this._start+T[0].length;const k=this._input.substring(this._start,this._current),v=_._keywords.get(k);v?this._addToken(v):this._tokens.push({type:17,lexeme:k,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let T=this._current,k=!1,v=!1;for(;;){if(T>=this._input.length){this._current=T,this._error(p);return}const C=this._input.charCodeAt(T);if(k)k=!1;else if(C===47&&!v){T++;break}else C===91?v=!0:C===92?k=!0:C===93&&(v=!1);T++}for(;T<this._input.length&&_._regexFlags.has(this._input.charCodeAt(T));)T++;this._current=T;const y=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:y,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=_}),define(Ce[228],De([1,0,24,38,193,372]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function _(o){return o=o.trim(),o==="*"||A.test(o)}e.isValidVersionStr=_;function b(o){if(!_(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=o.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.parseVersion=b;function T(o){if(!o)return null;const a=o.majorBase,c=o.majorMustEqual,g=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let n=o.patchMustEqual;o.hasCaret&&(a===0||(u=!1),n=!1);let r=0;if(o.preRelease){const i=p.exec(o.preRelease);if(i){const[,l,f,S]=i;r=Date.UTC(Number(l),Number(f)-1,Number(S))}}return{majorBase:a,majorMustEqual:c,minorBase:g,minorMustEqual:u,patchBase:t,patchMustEqual:n,isMinimum:o.hasGreaterEquals,notBefore:r}}e.normalizeVersion=T;function k(o,a,c){let g;typeof o=="string"?g=T(b(o)):g=o;let u;a instanceof Date?u=a.getTime():typeof a=="string"&&(u=new Date(a).getTime());let t;if(typeof c=="string"?t=T(b(c)):t=c,!g||!t)return!1;const n=g.majorBase,r=g.minorBase,i=g.patchBase;let l=t.majorBase,f=t.minorBase,S=t.patchBase;const I=t.notBefore;let E=t.majorMustEqual,h=t.minorMustEqual,m=t.patchMustEqual;return t.isMinimum?n>l?!0:n<l?!1:r>f?!0:r<f||u&&u<I?!1:i>=S:(n===1&&l===0&&(!E||!h||!m)&&(l=1,f=0,S=0,E=!0,h=!1,m=!1),n<l?!1:n>l?!E:r<f?!1:r>f?!h:i<S?!1:i>S?!m:!(u&&u<I))}e.isValidVersion=k;function v(o,a,c,g,u){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([F.default.Error,d.localize(0,null)]),t;if(typeof g.name!="string")return t.push([F.default.Error,d.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([F.default.Error,d.localize(2,null,"version")]),t;if(!g.engines)return t.push([F.default.Error,d.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([F.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!s(g.extensionDependencies))return t.push([F.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!s(g.activationEvents))return t.push([F.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([F.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([F.default.Warning,d.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([F.default.Error,d.localize(9,null,"main")]),t;{const i=(0,D.joinPath)(c,g.main);(0,D.isEqualOrParent)(i,c)||t.push([F.default.Warning,d.localize(10,null,i.path,c.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([F.default.Error,d.localize(11,null,"browser")]),t;{const i=(0,D.joinPath)(c,g.browser);(0,D.isEqualOrParent)(i,c)||t.push([F.default.Warning,d.localize(12,null,i.path,c.path)])}}if(!R.valid(g.version))return t.push([F.default.Error,d.localize(13,null)]),t;const n=[];if(!y(o,a,g,u,n))for(const i of n)t.push([F.default.Error,i]);return t}e.validateExtensionManifest=v;function y(o,a,c,g,u){return g||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(o,a,c.engines.vscode,u)}e.isValidExtensionVersion=y;function C(o,a,c){return o==="*"||w(a,c,o)}e.isEngineValid=C;function w(o,a,c,g=[]){const u=T(b(c));if(!u)return g.push(d.localize(14,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return g.push(d.localize(15,null,c)),!1}else if(!u.majorMustEqual)return g.push(d.localize(16,null,c)),!1;return k(o,a,u)?!0:(g.push(d.localize(17,null,o,c)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let a=0,c=o.length;a<c;a++)if(typeof o[a]!="string")return!1;return!0}}),define(Ce[103],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(d,R=[],A=!1){this.ctor=d,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(Ce[104],De([1,0,103]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const F=[];var d;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function R(p,_,b){_ instanceof D.SyncDescriptor||(_=new D.SyncDescriptor(_,[],!!b)),F.push([p,_])}e.registerSingleton=R;function A(){return F}e.getSingletonServiceDescriptors=A}),define(Ce[229],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class F{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const A of this._nodes.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const p=this.lookupOrInsertNode(R),_=this.lookupOrInsertNode(A);p.outgoing.set(_.key,_),_.incoming.set(p.key,p)}removeNode(R){const A=this._hashFn(R);this._nodes.delete(A);for(const p of this._nodes.values())p.outgoing.delete(A),p.incoming.delete(A)}lookupOrInsertNode(R){const A=this._hashFn(R);let p=this._nodes.get(A);return p||(p=new D(A,R),this._nodes.set(A,p)),p}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[A,p]of this._nodes)R.push(`${A}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this._nodes){const p=new Set([R]),_=this._findCycle(A,p);if(_)return _}}_findCycle(R,A){for(const[p,_]of R.outgoing){if(A.has(p))return[...A,p].join(" -> ");A.add(p);const b=this._findCycle(_,A);if(b)return b;A.delete(p)}}}e.Graph=F}),define(Ce[5],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function p(_){return _[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=p})(D||(e._util=D={})),e.IInstantiationService=d("instantiationService");function F(A,p,_){p[D.DI_TARGET]===p?p[D.DI_DEPENDENCIES].push({id:A,index:_}):(p[D.DI_DEPENDENCIES]=[{id:A,index:_}],p[D.DI_TARGET]=p)}function d(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const p=function(_,b,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(p,_,T)};return p.toString=()=>A,D.serviceIds.set(A,p),p}e.createDecorator=d;function R(A){return A}e.refineServiceDecorator=R}),define(Ce[49],De([1,0,18,2,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,d.createDecorator)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.isConfigurationOverrides=R;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=A;var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function _(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=_;function b(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.isConfigured=b;function T(o,a){const c=Object.create(null);for(const g in o)k(c,g,o[g],a);return c}e.toValuesTree=T;function k(o,a,c,g){const u=a.split("."),t=u.pop();let n=o;for(let r=0;r<u.length;r++){const i=u[r];let l=n[i];switch(typeof l){case"undefined":l=n[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${a} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(l)}`);return}n=l}if(typeof n=="object"&&n!==null)try{n[t]=c}catch{g(`Ignoring ${a} as ${u.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${a} as ${u.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=k;function v(o,a){const c=a.split(".");y(o,c)}e.removeFromValueTree=v;function y(o,a){const c=a.shift();if(a.length===0){delete o[c];return}if(Object.keys(o).indexOf(c)!==-1){const g=o[c];typeof g=="object"&&!Array.isArray(g)&&(y(g,a),Object.keys(g).length===0&&delete o[c])}}function C(o,a,c){function g(n,r){let i=n;for(const l of r){if(typeof i!="object"||i===null)return;i=i[l]}return i}const u=a.split("."),t=g(o,u);return typeof t>"u"?c:t}e.getConfigurationValue=C;function w(o,a,c){Object.keys(a).forEach(g=>{g!=="__proto__"&&(g in o?D.isObject(o[g])&&D.isObject(a[g])?w(o[g],a[g],c):c&&(o[g]=a[g]):o[g]=a[g])})}e.merge=w;function s(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=s}),define(Ce[41],De([1,0,12,15,227,5,189,8]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",D.isMacintosh),_.set("isLinux",D.isLinux),_.set("isWindows",D.isWindows),_.set("isWeb",D.isWeb),_.set("isMacNative",D.isMacintosh&&!D.isWeb),_.set("isEdge",D.isEdge),_.set("isFirefox",D.isFirefox),_.set("isChrome",D.isChrome),_.set("isSafari",D.isSafari);function b(G,B){if(_.get(G)!==void 0)throw(0,p.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");_.set(G,B)}e.setConstant=b;const T=Object.prototype.hasOwnProperty;var k;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const v={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),C=(0,A.localize)(1,null),w=(0,A.localize)(2,null),s=(0,A.localize)(3,null),o=(0,A.localize)(4,null),a=(0,A.localize)(5,null),c=(0,A.localize)(6,null),g=(0,A.localize)(7,null);class u{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(B=v){this._config=B,this._scanner=new d.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(B){if(B===""){this._parsingErrors.push({message:y,offset:0,lexeme:"",additionalInfo:C});return}this._tokens=this._scanner.reset(B).scan(),this._current=0,this._parsingErrors=[];try{const V=this._expr();if(!this._isAtEnd()){const me=this._peek(),Z=me.type===17?a:void 0;throw this._parsingErrors.push({message:o,offset:me.offset,lexeme:d.Scanner.getLexeme(me),additionalInfo:Z}),u._parseError}return V}catch(V){if(V!==u._parseError)throw V;return}}_expr(){return this._or()}_or(){const B=[this._and()];for(;this._matchOne(16);){const V=this._and();B.push(V)}return B.length===1?B[0]:t.or(...B)}_and(){const B=[this._term()];for(;this._matchOne(15);){const V=this._term();B.push(V)}return B.length===1?B[0]:t.and(...B)}_term(){if(this._matchOne(2)){const B=this._peek();switch(B.type){case 11:return this._advance(),l.INSTANCE;case 12:return this._advance(),f.INSTANCE;case 0:{this._advance();const V=this._expr();return this._consume(1,s),V?.negate()}case 17:return this._advance(),P.create(B.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",B)}}return this._primary()}_primary(){const B=this._peek();switch(B.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const V=this._expr();return this._consume(1,s),V}case 17:{const V=B.lexeme;if(this._advance(),this._matchOne(9)){const Z=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Z.type!==10)throw this._errExpectedButGot("REGEX",Z);const ne=Z.lexeme,re=ne.lastIndexOf("/"),ye=re===ne.length-1?void 0:this._removeFlagsGY(ne.substring(re+1));let oe;try{oe=new RegExp(ne.substring(1,re),ye)}catch{throw this._errExpectedButGot("REGEX",Z)}return M.create(V,oe)}switch(Z.type){case 10:case 19:{const ne=[Z.lexeme];this._advance();let re=this._peek(),ye=0;for(let ve=0;ve<Z.lexeme.length;ve++)Z.lexeme.charCodeAt(ve)===40?ye++:Z.lexeme.charCodeAt(ve)===41&&ye--;for(;!this._isAtEnd()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let ve=0;ve<re.lexeme.length;ve++)re.lexeme.charCodeAt(ve)===40?ye++:Z.lexeme.charCodeAt(ve)===41&&ye--}if(ye<0)break;ne.push(d.Scanner.getLexeme(re)),this._advance(),re=this._peek()}const oe=ne.join(""),de=oe.lastIndexOf("/"),ee=de===oe.length-1?void 0:this._removeFlagsGY(oe.substring(de+1));let ue;try{ue=new RegExp(oe.substring(1,de),ee)}catch{throw this._errExpectedButGot("REGEX",Z)}return t.regex(V,ue)}case 18:{const ne=Z.lexeme;this._advance();let re=null;if(!(0,F.isFalsyOrWhitespace)(ne)){const ye=ne.indexOf("/"),oe=ne.lastIndexOf("/");if(ye!==oe&&ye>=0){const de=ne.slice(ye+1,oe),ee=ne[oe+1]==="i"?"i":"";try{re=new RegExp(de,ee)}catch{throw this._errExpectedButGot("REGEX",Z)}}}if(re===null)throw this._errExpectedButGot("REGEX",Z);return M.create(V,re)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,w);const Z=this._value();return t.notIn(V,Z)}switch(this._peek().type){case 3:{this._advance();const Z=this._value();if(this._previous().type===18)return t.equals(V,Z);switch(Z){case"true":return t.has(V);case"false":return t.not(V);default:return t.equals(V,Z)}}case 4:{this._advance();const Z=this._value();if(this._previous().type===18)return t.notEquals(V,Z);switch(Z){case"true":return t.not(V);case"false":return t.has(V);default:return t.notEquals(V,Z)}}case 5:return this._advance(),U.create(V,this._value());case 6:return this._advance(),x.create(V,this._value());case 7:return this._advance(),N.create(V,this._value());case 8:return this._advance(),L.create(V,this._value());case 13:return this._advance(),t.in(V,this._value());default:return t.has(V)}}case 20:throw this._parsingErrors.push({message:c,offset:B.offset,lexeme:"",additionalInfo:g}),u._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const B=this._peek();switch(B.type){case 17:case 18:return this._advance(),B.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(B){return B.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(B){return this._check(B)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(B,V){if(this._check(B))return this._advance();throw this._errExpectedButGot(V,this._peek())}_errExpectedButGot(B,V,me){const Z=(0,A.localize)(8,null,B,d.Scanner.getLexeme(V)),ne=V.offset,re=d.Scanner.getLexeme(V);return this._parsingErrors.push({message:Z,offset:ne,lexeme:re,additionalInfo:me}),u._parseError}_check(B){return this._peek().type===B}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=u;class t{static false(){return l.INSTANCE}static true(){return f.INSTANCE}static has(B){return S.create(B)}static equals(B,V){return I.create(B,V)}static notEquals(B,V){return m.create(B,V)}static regex(B,V){return M.create(B,V)}static in(B,V){return E.create(B,V)}static notIn(B,V){return h.create(B,V)}static not(B){return P.create(B)}static and(...B){return fe.create(B,null,!0)}static or(...B){return Y.create(B,null,!0)}static greater(B,V){return N.create(B,V)}static greaterEquals(B,V){return L.create(B,V)}static smaller(B,V){return U.create(B,V)}static smallerEquals(B,V){return x.create(B,V)}static{this._parser=new u({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this._parser.parse(B)}}e.ContextKeyExpr=t;function n(G){const B=new u({regexParsingWithErrorRecovery:!1});return G.map(V=>(B.parse(V),B.lexingErrors.length>0?B.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,A.localize)(9,null,me.additionalInfo):(0,A.localize)(10,null),offset:me.offset,length:me.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=n;function r(G,B){const V=G?G.substituteConstants():void 0,me=B?B.substituteConstants():void 0;return!V&&!me?!0:!V||!me?!1:V.equals(me)}e.expressionsAreEqualWithConstantSubstitution=r;function i(G,B){return G.cmp(B)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=l;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=f;class S{static create(B,V=null){const me=_.get(B);return typeof me=="boolean"?me?f.INSTANCE:l.INSTANCE:new S(B,V)}constructor(B,V){this.key=B,this.negated=V,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:z(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=_.get(this.key);return typeof B=="boolean"?B?f.INSTANCE:l.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class I{static create(B,V,me=null){if(typeof V=="boolean")return V?S.create(B,me):P.create(B,me);const Z=_.get(B);return typeof Z=="boolean"?V===(Z?"true":"false")?f.INSTANCE:l.INSTANCE:new I(B,V,me)}constructor(B,V,me){this.key=B,this.value=V,this.negated=me,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=_.get(this.key);if(typeof B=="boolean"){const V=B?"true":"false";return this.value===V?f.INSTANCE:l.INSTANCE}return this}evaluate(B){return B.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(B){return B.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=I;class E{static create(B,V){return new E(B,V)}constructor(B,V){this.key=B,this.valueKey=V,this.type=10,this.negated=null}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.valueKey,B.key,B.valueKey)}equals(B){return B.type===this.type?this.key===B.key&&this.valueKey===B.valueKey:!1}substituteConstants(){return this}evaluate(B){const V=B.getValue(this.valueKey),me=B.getValue(this.key);return Array.isArray(V)?V.includes(me):typeof me=="string"&&typeof V=="object"&&V!==null?T.call(V,me):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(B){return B.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class h{static create(B,V){return new h(B,V)}constructor(B,V){this.key=B,this.valueKey=V,this.type=11,this._negated=E.create(B,V)}cmp(B){return B.type!==this.type?this.type-B.type:this._negated.cmp(B._negated)}equals(B){return B.type===this.type?this._negated.equals(B._negated):!1}substituteConstants(){return this}evaluate(B){return!this._negated.evaluate(B)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(B){return B.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class m{static create(B,V,me=null){if(typeof V=="boolean")return V?P.create(B,me):S.create(B,me);const Z=_.get(B);return typeof Z=="boolean"?V===(Z?"true":"false")?l.INSTANCE:f.INSTANCE:new m(B,V,me)}constructor(B,V,me){this.key=B,this.value=V,this.negated=me,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=_.get(this.key);if(typeof B=="boolean"){const V=B?"true":"false";return this.value===V?l.INSTANCE:f.INSTANCE}return this}evaluate(B){return B.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(B){return B.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class P{static create(B,V=null){const me=_.get(B);return typeof me=="boolean"?me?l.INSTANCE:f.INSTANCE:new P(B,V)}constructor(B,V){this.key=B,this.negated=V,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:z(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=_.get(this.key);return typeof B=="boolean"?B?l.INSTANCE:f.INSTANCE:this}evaluate(B){return!B.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(B){return B.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function O(G,B){if(typeof G=="string"){const V=parseFloat(G);isNaN(V)||(G=V)}return typeof G=="string"||typeof G=="number"?B(G):l.INSTANCE}class N{static create(B,V,me=null){return O(V,Z=>new N(B,Z,me))}constructor(B,V,me){this.key=B,this.value=V,this.negated=me,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class L{static create(B,V,me=null){return O(V,Z=>new L(B,Z,me))}constructor(B,V,me){this.key=B,this.value=V,this.negated=me,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=L;class U{static create(B,V,me=null){return O(V,Z=>new U(B,Z,me))}constructor(B,V,me){this.key=B,this.value=V,this.negated=me,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class x{static create(B,V,me=null){return O(V,Z=>new x(B,Z,me))}constructor(B,V,me){this.key=B,this.value=V,this.negated=me,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=x;class M{static create(B,V){return new M(B,V)}constructor(B,V){this.key=B,this.regexp=V,this.type=7,this.negated=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.key<B.key)return-1;if(this.key>B.key)return 1;const V=this.regexp?this.regexp.source:"",me=B.regexp?B.regexp.source:"";return V<me?-1:V>me?1:0}equals(B){if(B.type===this.type){const V=this.regexp?this.regexp.source:"",me=B.regexp?B.regexp.source:"";return this.key===B.key&&V===me}return!1}substituteConstants(){return this}evaluate(B){const V=B.getValue(this.key);return this.regexp?this.regexp.test(V):!1}serialize(){const B=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${B}`}keys(){return[this.key]}map(B){return B.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=H.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class H{static create(B){return new H(B)}constructor(B){this._actual=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this._actual.cmp(B._actual)}equals(B){return B.type===this.type?this._actual.equals(B._actual):!1}substituteConstants(){return this}evaluate(B){return!this._actual.evaluate(B)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(B){return new H(this._actual.map(B))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=H;function j(G){let B=null;for(let V=0,me=G.length;V<me;V++){const Z=G[V].substituteConstants();if(G[V]!==Z&&B===null){B=[];for(let ne=0;ne<V;ne++)B[ne]=G[ne]}B!==null&&(B[V]=Z)}return B===null?G:B}class fe{static create(B,V,me){return fe._normalizeArr(B,V,me)}constructor(B,V){this.expr=B,this.negated=V,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let V=0,me=this.expr.length;V<me;V++){const Z=i(this.expr[V],B.expr[V]);if(Z!==0)return Z}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let V=0,me=this.expr.length;V<me;V++)if(!this.expr[V].equals(B.expr[V]))return!1;return!0}return!1}substituteConstants(){const B=j(this.expr);return B===this.expr?this:fe.create(B,this.negated,!1)}evaluate(B){for(let V=0,me=this.expr.length;V<me;V++)if(!this.expr[V].evaluate(B))return!1;return!0}static _normalizeArr(B,V,me){const Z=[];let ne=!1;for(const re of B)if(re){if(re.type===1){ne=!0;continue}if(re.type===0)return l.INSTANCE;if(re.type===6){Z.push(...re.expr);continue}Z.push(re)}if(Z.length===0&&ne)return f.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(i);for(let re=1;re<Z.length;re++)Z[re-1].equals(Z[re])&&(Z.splice(re,1),re--);if(Z.length===1)return Z[0];for(;Z.length>1;){const re=Z[Z.length-1];if(re.type!==9)break;Z.pop();const ye=Z.pop(),oe=Z.length===0,de=Y.create(re.expr.map(ee=>fe.create([ee,ye],null,me)),null,oe);de&&(Z.push(de),Z.sort(i))}if(Z.length===1)return Z[0];if(me){for(let re=0;re<Z.length;re++)for(let ye=re+1;ye<Z.length;ye++)if(Z[re].negate().equals(Z[ye]))return l.INSTANCE;if(Z.length===1)return Z[0]}return new fe(Z,V)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const V of this.expr)B.push(...V.keys());return B}map(B){return new fe(this.expr.map(V=>V.map(B)),null)}negate(){if(!this.negated){const B=[];for(const V of this.expr)B.push(V.negate());this.negated=Y.create(B,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class Y{static create(B,V,me){return Y._normalizeArr(B,V,me)}constructor(B,V){this.expr=B,this.negated=V,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let V=0,me=this.expr.length;V<me;V++){const Z=i(this.expr[V],B.expr[V]);if(Z!==0)return Z}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let V=0,me=this.expr.length;V<me;V++)if(!this.expr[V].equals(B.expr[V]))return!1;return!0}return!1}substituteConstants(){const B=j(this.expr);return B===this.expr?this:Y.create(B,this.negated,!1)}evaluate(B){for(let V=0,me=this.expr.length;V<me;V++)if(this.expr[V].evaluate(B))return!0;return!1}static _normalizeArr(B,V,me){let Z=[],ne=!1;if(B){for(let re=0,ye=B.length;re<ye;re++){const oe=B[re];if(oe){if(oe.type===0){ne=!0;continue}if(oe.type===1)return f.INSTANCE;if(oe.type===9){Z=Z.concat(oe.expr);continue}Z.push(oe)}}if(Z.length===0&&ne)return l.INSTANCE;Z.sort(i)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let re=1;re<Z.length;re++)Z[re-1].equals(Z[re])&&(Z.splice(re,1),re--);if(Z.length===1)return Z[0];if(me){for(let re=0;re<Z.length;re++)for(let ye=re+1;ye<Z.length;ye++)if(Z[re].negate().equals(Z[ye]))return f.INSTANCE;if(Z.length===1)return Z[0]}return new Y(Z,V)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const V of this.expr)B.push(...V.keys());return B}map(B){return new Y(this.expr.map(V=>V.map(B)),null)}negate(){if(!this.negated){const B=[];for(const V of this.expr)B.push(V.negate());for(;B.length>1;){const V=B.shift(),me=B.shift(),Z=[];for(const ne of we(V))for(const re of we(me))Z.push(fe.create([ne,re],null,!1));B.unshift(Y.create(Z,null,!1))}this.negated=Y.create(B,this,!0)}return this.negated}}e.ContextKeyOrExpr=Y;class X extends S{static{this._info=[]}static all(){return X._info.values()}constructor(B,V,me){super(B,null),this._defaultValue=V,typeof me=="object"?X._info.push({...me,key:B}):me!==!0&&X._info.push({key:B,description:me,type:V!=null?typeof V:void 0})}bindTo(B){return B.createKey(this.key,this._defaultValue)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return I.create(this.key,B)}notEqualsTo(B){return m.create(this.key,B)}}e.RawContextKey=X,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function z(G,B){return G<B?-1:G>B?1:0}function J(G,B,V,me){return G<V?-1:G>V?1:B<me?-1:B>me?1:0}function ge(G,B){if(G.type===0||B.type===1)return!0;if(G.type===9)return B.type===9?le(G.expr,B.expr):!1;if(B.type===9){for(const V of B.expr)if(ge(G,V))return!0;return!1}if(G.type===6){if(B.type===6)return le(B.expr,G.expr);for(const V of G.expr)if(ge(V,B))return!0;return!1}return G.equals(B)}e.implies=ge;function le(G,B){let V=0,me=0;for(;V<G.length&&me<B.length;){const Z=G[V].cmp(B[me]);if(Z<0)return!1;Z===0&&V++,me++}return V===G.length}function we(G){return G.type===9?G.expr:[G]}}),define(Ce[230],De([1,0,24,38,191,5,100,12,23]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var b;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(b||(b={}));class T{getConfirmationButtons(s){return this.getButtons(s,b.Confirmation)}getPromptButtons(s){return this.getButtons(s,b.Prompt)}getInputButtons(s){return this.getButtons(s,b.Input)}getButtons(s,o){const a=[];switch(o){case b.Confirmation:{const c=s;c.primaryButton?a.push(c.primaryButton):a.push((0,d.localize)(0,null)),c.cancelButton?a.push(c.cancelButton):a.push((0,d.localize)(1,null));break}case b.Prompt:{const c=s;Array.isArray(c.buttons)&&c.buttons.length>0&&a.push(...c.buttons.map(g=>g.label)),c.cancelButton&&(c.cancelButton===!0?a.push((0,d.localize)(2,null)):typeof c.cancelButton=="string"?a.push(c.cancelButton):c.cancelButton.label?a.push(c.cancelButton.label):a.push((0,d.localize)(3,null))),a.length===0&&a.push((0,d.localize)(4,null));break}case b.Input:{const c=s;c.primaryButton?a.push(c.primaryButton):a.push((0,d.localize)(5,null)),c.cancelButton?a.push(c.cancelButton):a.push((0,d.localize)(6,null));break}}return a}getDialogType(s){if(typeof s=="string")return s;if(typeof s=="number")return s===F.default.Info?"info":s===F.default.Error?"error":s===F.default.Warning?"warning":"none"}async getPromptResult(s,o,a){const c=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&c.push(s.cancelButton),{result:await c[o]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.AbstractDialogHandler=T,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var k;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(k||(e.ConfirmResult=k={}));const v=10;function y(w){const s=[];return s.push(...w.slice(0,v).map(o=>typeof o=="string"?o:(0,D.basename)(o))),w.length>v&&(w.length-v===1?s.push((0,d.localize)(7,null)):s.push((0,d.localize)(8,null,w.length-v))),s.push(""),s.join(`
`)}e.getFileNamesMessage=y;function C(w,s){const o=(0,_.deepClone)(w);let a=(o.buttons??[]).map(t=>(0,A.mnemonicButtonLabel)(t)),c=(w.buttons||[]).map((t,n)=>n),g=0,u=o.cancelId??a.length-1;if(a.length>1){const t=typeof u=="number"?a[u]:void 0;if(p.isLinux||p.isMacintosh){if(typeof t=="string"&&a.length>1&&u!==1){a.splice(u,1),a.splice(1,0,t);const n=c[u];c.splice(u,1),c.splice(1,0,n),u=1}p.isLinux&&a.length>1&&(a=a.reverse(),c=c.reverse(),g=a.length-1,typeof t=="string"&&(u=g-1))}else if(p.isWindows&&typeof t=="string"&&a.length>1&&u!==a.length-1){a.splice(u,1),a.push(t);const n=c[u];c.splice(u,1),c.push(n),u=a.length-1}}return o.buttons=a,o.defaultId=g,o.cancelId=u,o.noLink=!0,o.title=o.title||s.nameLong,{options:o,buttonIndeces:c}}e.massageMessageBoxOptions=C}),define(Ce[131],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[132],De([1,0,192,5]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function d(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=d;function R(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(a,c){switch(a){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function p(a,c){return c==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=p;function _(a,c,g){return p(c,g)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===g?!0:b(g).includes(a)}e.isTargetPlatformCompatible=_;function b(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function T(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=T;var k;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var v;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(a){a.Install="install",a.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var C;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.IExtensionGalleryService=(0,F.createDecorator)("extensionGalleryService");var w;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var s;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(c,g){super(c),this.code=g,this.name=g}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,F.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,F.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,F.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Ce[231],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,D.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(Ce[232],De([1,0,48,17,16,12,99,29,102,194,231]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=b.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends v{static{this.CMD="cmd.exe"}openTerminal(g,u){return this.spawnTerminal(D,g,_.getWindowsShell(),u)}spawnTerminal(g,u,t,n){const r=u.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=d.basename(r,".exe").toLowerCase();if(i==="cmder")return g.spawn(r,n?[n]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),i==="wt"&&l.push("-d ."),new Promise((f,S)=>{const I=s(process),E=g.spawn(t,l,{cwd:n,env:I});E.on("error",S),E.on("exit",()=>f())})}runInTerminal(g,u,t,n,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,f)=>{const S=`"${u} - ${k}"`,I=`""${t.join('" "')}" & pause"`,E=Object.assign({},s(process),n);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const h={cwd:u,env:E,windowsVerbatimArguments:!0};let m,P;d.basename(i,".exe")==="wt"?(m=i,P=["-d",".",y.CMD,"/c",I]):(m=y.CMD,P=["/c","start",S,"/wait",i,"/c",I]),D.spawn(m,P,h).on("error",N=>{f(o(N))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y;class C extends v{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(g,u){return this.spawnTerminal(D,g,u)}runInTerminal(g,u,t,n,r){const i=r.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((l,f)=>{if(i===T.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const S=i===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",g||k,"-w",u];for(const P of t)E.push("-a"),E.push(P);if(n){const P=Object.assign({},s(process),n);for(const O in P){const N=P[O];N===null?(E.push("-u"),E.push(O)):(E.push("-e"),E.push(`${O}=${N}`))}}let h="";const m=D.spawn(C.OSASCRIPT,E);m.on("error",P=>{f(o(P))}),m.stderr.on("data",P=>{h+=P.toString()}),m.on("exit",P=>{if(P===0)l(void 0);else if(h){const O=h.split(`
`,1);f(new Error(O[0]))}else f(new Error(b.localize(1,null,S,P)))})}else f(new Error(b.localize(2,null,i)))})}spawnTerminal(g,u,t){const n=u.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const l=["-a",n];t&&l.push(t);const f=s(process),S=g.spawn("/usr/bin/open",l,{cwd:t,env:f});S.on("error",i),S.on("exit",()=>r())})}}e.MacExternalTerminalService=C;class w extends v{static{this.WAIT_MESSAGE=b.localize(3,null)}openTerminal(g,u){return this.spawnTerminal(D,g,u)}runInTerminal(g,u,t,n,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,f)=>{const S=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const E=`${a(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;S.push(`''${E}''`);const h=Object.assign({},s(process),n);Object.keys(h).filter(N=>h[N]===null).forEach(N=>delete h[N]);const m={cwd:u,env:h};let P="";const O=D.spawn(I,S,m);O.on("error",N=>{f(o(N))}),O.stderr.on("data",N=>{P+=N.toString()}),O.on("exit",N=>{if(N===0)l(void 0);else if(P){const L=P.split(`
`,1);f(new Error(L[0]))}else f(new Error(b.localize(4,null,I,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await p.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{g?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,u,t){const n=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{n.then(l=>{const f=s(process),S=g.spawn(l,[],{cwd:t,env:f});S.on("error",i),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w;function s(c){const g={...c.env};return(0,A.sanitizeProcessEnvironment)(g),g}function o(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(b.localize(5,null,c.path)):c}function a(c){let g="";for(const u of c)u.indexOf(" ")>=0?g+='"'+u+'"':g+=u,g+=" ";return g}}),define(Ce[30],De([1,0,78,16,15,18,2,195,5,12,17]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var v;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var y;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(y||(e.FilePermission=y={}));var C;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function w(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=w;function s(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=s;function o(z){return!!(z.capabilities&131072)}e.hasFileCloneCapability=o;function a(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function c(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=c;function g(z){return w(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;function u(z){return w(z)?!!(z.capabilities&32768):!1}e.hasFileAtomicWriteCapability=u;function t(z){return!!(z.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;function n(z){return!!(z.capabilities&2048)}e.hasReadonlyCapability=n;var r;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(J,ge){const le=new i(J.toString(),ge);return S(le,ge),le}constructor(J,ge){super(J),this.code=ge}}e.FileSystemProviderError=i;function l(z,J){return i.create(z,J)}e.createFileSystemProviderError=l;function f(z){return z||l((0,p.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=f;function S(z,J){return z.name=J?`${J} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=S;function I(z){if(!z)return r.Unknown;if(z instanceof i)return z.code;const J=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!J)return r.Unknown;switch(J[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=I;function E(z){if(z instanceof L)return z.fileOperationResult;switch(I(z)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=E;var h;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class m{constructor(J,ge,le){this.resource=J,this.operation=ge,this.target=le}isOperation(J){return this.operation===J}}e.FileOperationEvent=m;var P;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class O{constructor(J,ge){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const le=new Map;for(const we of J){const G=le.get(we.type);switch(G?G.push([we.resource,we]):le.set(we.type,[[we.resource,we]]),we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}}for(const[we,G]of le)switch(we){case 1:this.added=D.TernarySearchTree.forUris(()=>ge),this.added.fill(G);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>ge),this.updated.fill(G);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>ge),this.deleted.fill(G);break}}contains(J,...ge){return this.doContains(J,{includeChildren:!1},...ge)}affects(J,...ge){return this.doContains(J,{includeChildren:!0},...ge)}doContains(J,ge,...le){if(!J)return!1;const we=le.length>0;return!!((!we||le.includes(1))&&(this.added?.get(J)||ge.includeChildren&&this.added?.findSuperstr(J))||(!we||le.includes(0))&&(this.updated?.get(J)||ge.includeChildren&&this.updated?.findSuperstr(J))||(!we||le.includes(2))&&(this.deleted?.findSubstr(J)||ge.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=O;function N(z,J,ge){return!z||!J||z===J||J.length>z.length?!1:(J.charAt(J.length-1)!==F.sep&&(J+=F.sep),ge?(0,d.startsWithIgnoreCase)(z,J):z.indexOf(J)===0)}e.isParent=N;class L extends Error{constructor(J,ge,le){super(J),this.fileOperationResult=ge,this.options=le}}e.FileOperationError=L;class U extends L{constructor(J,ge,le,we){super(J,ge,we),this.fileOperationResult=ge,this.size=le}}e.TooLargeFileOperationError=U;class x extends L{constructor(J,ge,le){super(J,2,le),this.stat=ge}}e.NotModifiedSinceFileOperationError=x;var M;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(M||(e.FileOperationResult=M={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var H;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.ETAG_DISABLED="";function j(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=j;async function fe(z,J){if(!J.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(ge=>{const le=J.onDidChangeFileSystemProviderRegistrations(we=>{we.scheme===z.scheme&&we.added&&(le.dispose(),ge())})})}e.whenProviderRegistered=fe;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<Y.KB?(0,p.localize)(1,null,J.toFixed(0)):J<Y.MB?(0,p.localize)(2,null,(J/Y.KB).toFixed(2)):J<Y.GB?(0,p.localize)(3,null,(J/Y.MB).toFixed(2)):J<Y.TB?(0,p.localize)(4,null,(J/Y.GB).toFixed(2)):(0,p.localize)(5,null,(J/Y.TB).toFixed(2))}}e.ByteSize=Y;function X(z){const J=typeof z=="string"||z?.scheme===T.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===T.Schemas.file?1024*Y.MB:J?10*Y.MB:b.isWeb?50*Y.MB:1024*Y.MB}e.getLargeFileConfirmationLimit=X}),define(Ce[233],De([1,0,22,8,196,30]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(T,k,v,y,C,w){let s;try{await p(T,k,v,y,C,w)}catch(o){s=o}finally{s&&C.errorTransformer&&(s=C.errorTransformer(s)),typeof s<"u"&&v.error(s),v.end()}}e.readFileIntoStream=A;async function p(T,k,v,y,C,w){_(w);const s=await T.open(k,{create:!1});try{_(w);let o=0,a=0,c=C&&typeof C.length=="number"?C.length:void 0,g=D.VSBuffer.alloc(Math.min(C.bufferSize,typeof c=="number"?c:C.bufferSize)),u=C&&typeof C.position=="number"?C.position:0,t=0;do a=await T.read(s,u,g.buffer,t,g.byteLength-t),u+=a,t+=a,o+=a,typeof c=="number"&&(c-=a),t===g.byteLength&&(await v.write(y(g)),g=D.VSBuffer.alloc(Math.min(C.bufferSize,typeof c=="number"?c:C.bufferSize)),t=0);while(a>0&&(typeof c!="number"||c>0)&&_(w)&&b(o,C));if(t>0){let n=t;typeof c=="number"&&(n=Math.min(t,c)),v.write(y(g.slice(0,n)))}}catch(o){throw(0,R.ensureFileSystemProviderError)(o)}finally{await T.close(s)}}function _(T){if(T.isCancellationRequested)throw(0,F.canceled)();return!0}function b(T,k){if(typeof k?.limits?.size=="number"&&T>k.limits.size)throw(0,R.createFileSystemProviderError)((0,d.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[84],De([1,0,35,3,16,12,2,30]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function _(o){return o.recursive===!0}e.isRecursiveWatchRequest=_;class b extends F.Disposable{static{this.MAX_RESTARTS=5}constructor(a,c,g,u){super(),this.onFileChanges=a,this.onLogMessage=c,this.verboseLogging=g,this.options=u,this.watcherDisposables=this._register(new F.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const a=new F.DisposableStore;this.watcherDisposables.value=a,this.watcher=this.createWatcher(a),this.watcher.setVerboseLogging(this.verboseLogging),a.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),a.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),a.add(this.watcher.onDidError(c=>this.onError(c)))}onError(a){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${a}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${a}`):this.error(a)}restart(a){this.restartCounter++,this.init(),this.watch(a)}async watch(a){this.requests=a,await this.watcher?.watch(a)}async setVerboseLogging(a){this.verboseLogging=a,await this.watcher?.setVerboseLogging(a)}error(a){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${a}`})}trace(a){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${a}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b;class T extends b{constructor(a,c,g){super(a,c,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class k extends b{constructor(a,c,g){super(a,c,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function v(o){return o.map(a=>({type:a.type,resource:A.URI.file(a.path)}))}e.toFileChanges=v;function y(o){const a=new s;for(const c of o)a.processEvent(c);return a.coalesce()}e.coalesceEvents=y;function C(o,a){return typeof a=="string"&&!a.startsWith(D.GLOBSTAR)&&!(0,d.isAbsolute)(a)?{base:o,pattern:a}:a}e.normalizeWatcherPattern=C;function w(o,a){const c=[];for(const g of a)c.push((0,D.parse)(C(o,g)));return c}e.parseWatcherPatterns=w;class s{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(a){return R.isLinux?a.path:a.path.toLowerCase()}processEvent(a){const c=this.mapPathToChange.get(this.toKey(a));let g=!1;if(c){const u=c.type,t=a.type;c.path!==a.path&&(a.type===2||a.type===1)?g=!0:u===1&&t===2?(this.mapPathToChange.delete(this.toKey(a)),this.coalesced.delete(c)):u===2&&t===1?c.type=0:u===1&&t===0||(c.type=t)}else g=!0;g&&(this.coalesced.add(a),this.mapPathToChange.set(this.toKey(a),a))}coalesce(){const a=[],c=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(a.push(g),!1):!0).sort((g,u)=>g.path.length-u.path.length).filter(g=>c.some(u=>(0,p.isParent)(g.path,u,!R.isLinux))?!1:(c.push(g.path),!0)).concat(a)}}}),define(Ce[234],De([1,0,52,9,21,32,3,77,16,12,101,29,84]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(s,o,a,c){super(),this.request=s,this.onDidFilesChange=o,this.onLogMessage=a,this.verboseLogging=c,this.throttledFileChangesEmitter=this._register(new F.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g))),this.fileChangesAggregator=this._register(new F.RunOnceWorker(g=>this.handleFileChanges(g),y.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new d.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const s=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const o=await k.Promises.stat(s);this._register(await this.doWatch(s,o.isDirectory()))}catch(s){s.code!=="ENOENT"?this.error(s):this.trace(s)}}async normalizePath(s){let o=s.path;try{o=await k.Promises.realpath(s.path),s.path===o&&(o=await(0,T.realcase)(s.path)??s.path),s.path!==o&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${o})`)}catch{}return o}async doWatch(s,o){if(b.isMacintosh&&(0,R.isEqualOrParent)(s,"/Volumes/",!0))return this.error(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const a=new d.CancellationTokenSource(this.cts.token),c=new A.DisposableStore;try{const g=(0,_.basename)(s),u=(0,D.watch)(s);c.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${s}'`);const t=new Set;if(o)try{for(const r of await k.Promises.readdir(s))t.add(r)}catch(r){this.error(r)}const n=new Map;c.add((0,A.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),u.on("error",(r,i)=>{this.error(`Failed to watch ${s} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),u.on("change",(r,i)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${i}`);let l="";if(i&&(l=i.toString(),b.isMacintosh&&(l=(0,p.normalizeNFC)(l))),!(!l||r!=="change"&&r!=="rename"))if(o)if(r==="rename"){n.get(l)?.dispose();const f=setTimeout(async()=>{if(n.delete(l),l===g&&!await k.Promises.exists(s)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const S=await this.existsChildStrictCase((0,_.join)(s,l));if(a.token.isCancellationRequested)return;let I;S?t.has(l)?I=0:(I=1,t.add(l)):(t.delete(l),I=2),this.onFileChange({path:(0,_.join)(this.request.path,l),type:I})},y.FILE_DELETE_HANDLER_DELAY);n.set(l,(0,A.toDisposable)(()=>clearTimeout(f)))}else{let f;t.has(l)?f=0:(f=1,t.add(l)),this.onFileChange({path:(0,_.join)(this.request.path,l),type:f})}else if(r==="rename"||l!==g){const f=setTimeout(async()=>{const S=await k.Promises.exists(s);a.token.isCancellationRequested||(S?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(s,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,A.toDisposable)(()=>clearTimeout(f)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await k.Promises.exists(s)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${s} for changes using fs.watch() (${g.toString()})`)}return(0,A.toDisposable)(()=>{a.dispose(!0),c.dispose()})}onFileChange(s,o=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!o&&this.excludes.some(a=>a(s.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${s.path}`):!o&&this.includes&&this.includes.length>0&&!this.includes.some(a=>a(s.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${s.path}`):this.fileChangesAggregator.work(s))}handleFileChanges(s){const o=(0,v.coalesceEvents)(s);if(o.length>0){if(this.verboseLogging)for(const c of o)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesEmitter.work(o)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(s){if(b.isLinux)return k.Promises.exists(s);try{const o=(0,_.basename)(s);return(await k.Promises.readdir((0,_.dirname)(s))).some(c=>c===o)}catch(o){return this.trace(o),!1}}setVerboseLogging(s){this.verboseLogging=s}error(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}warn(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}trace(s){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y;async function C(w,s,o,a,c=512){const g=await k.Promises.open(w,"r"),u=Buffer.allocUnsafe(c),t=new d.CancellationTokenSource(a);let n,r=!1;const i={path:w,excludes:[],recursive:!1},l=new y(i,f=>{(async()=>{for(const{type:S}of f)if(S===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await k.Promises.read(g,u,0,c,null);if(!I||t.token.isCancellationRequested)break;s(u.slice(0,I))}}catch(I){n=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await l.ready,o(),new Promise((f,S)=>{t.token.onCancellationRequested(async()=>{l.dispose();try{await k.Promises.close(g)}catch(I){n=new Error(I)}n?S(n):f()})})}e.watchFileContents=C}),define(Ce[235],De([1,0,4,35,3,12,234]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class p extends d.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const T=this.normalizeRequests(b),k=T.filter(y=>{const C=this.watchers.get(y.path);return C?!(0,F.patternsEquals)(C.request.excludes,y.excludes)||!(0,F.patternsEquals)(C.request.includes,y.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:y})=>!T.find(C=>C.path===y.path&&(0,F.patternsEquals)(C.excludes,y.excludes)&&(0,F.patternsEquals)(C.includes,y.includes))).map(({request:y})=>y.path);k.length&&this.trace(`Request to start watching: ${k.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.stopWatching(y);for(const y of k)this.startWatching(y)}startWatching(b){const T=new A.NodeJSFileWatcherLibrary(b,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),k={request:b,instance:T};this.watchers.set(b.path,k)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const T=this.watchers.get(b);T&&(this.watchers.delete(b),T.instance.dispose())}normalizeRequests(b){const T=new Map;for(const k of b){const v=R.isLinux?k.path:k.path.toLowerCase();T.set(v,k)}return Array.from(T.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,T]of this.watchers)T.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,T){return T?`[File Watcher (node.js)] ${b} (path: ${T.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=p}),define(Ce[236],De([1,0,84,235]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class d extends D.AbstractNonRecursiveWatcherClient{constructor(A,p,_){super(A,p,_),this.init()}createWatcher(A){return A.add(new F.NodeJSWatcher)}}e.NodeJSWatcherClient=d}),define(Ce[237],De([1,0,17,81,183,84]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(_,b,T){super(_,b,T),this.init()}createWatcher(_){const b=_.add(new d.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return _.add(b.onDidProcessExit(({code:T,signal:k})=>this.onError(`terminated by itself with code ${T}, signal: ${k}`))),F.ProxyChannel.toService((0,F.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(Ce[105],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...d){this._entries=new Map;for(const[R,A]of d)this.set(R,A)}set(d,R){const A=this._entries.get(d);return this._entries.set(d,R),A}has(d){return this._entries.has(d)}get(d){return this._entries.get(d)}}e.ServiceCollection=D}),define(Ce[238],De([1,0,9,8,3,103,229,5,105,76]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class k extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class v{constructor(s=new _.ServiceCollection,o=!1,a,c=T){this._services=s,this._strict=o,this._parent=a,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(p.IInstantiationService,this),this._globalGraph=c?a?._globalGraph??new A.Graph(g=>g):void 0}createChild(s){return new v(s,this._strict,this,this._enableTracing)}invokeFunction(s,...o){const a=C.traceInvocation(this._enableTracing,s);let c=!1;try{return s({get:u=>{if(c)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(u,a);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{c=!0,a.stop()}}createInstance(s,...o){let a,c;return s instanceof R.SyncDescriptor?(a=C.traceCreation(this._enableTracing,s.ctor),c=this._createInstance(s.ctor,s.staticArguments.concat(o),a)):(a=C.traceCreation(this._enableTracing,s),c=this._createInstance(s,o,a)),a.stop(),c}_createInstance(s,o=[],a){const c=p._util.getServiceDependencies(s).sort((t,n)=>t.index-n.index),g=[];for(const t of c){const n=this._getOrCreateServiceInstance(t.id,a);n||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(n)}const u=c.length>0?c[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${s.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(s,o.concat(g))}_setServiceInstance(s,o){if(this._services.get(s)instanceof R.SyncDescriptor)this._services.set(s,o);else if(this._parent)this._parent._setServiceInstance(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const o=this._services.get(s);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):o}_getOrCreateServiceInstance(s,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const a=this._getServiceInstanceOrDescriptor(s);return a instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,a,o.branch(s,!0)):(o.branch(s,!1),a)}_safeCreateAndCacheServiceInstance(s,o,a){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,o,a)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,o,a){const c=new A.Graph(t=>t.id.toString());let g=0;const u=[{id:s,desc:o,_trace:a}];for(;u.length;){const t=u.pop();if(c.lookupOrInsertNode(t),g++>1e3)throw new k(c);for(const n of p._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(n.id);if(r||this._throwIfStrict(`[createInstance] ${s} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof R.SyncDescriptor){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};c.insertEdge(t,i),u.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new k(c);break}for(const{data:n}of t){if(this._getServiceInstanceOrDescriptor(n.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,i)}c.removeNode(n)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,o,a=[],c,g){if(this._services.get(s)instanceof R.SyncDescriptor)return this._createServiceInstance(s,o,a,c,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,o,a,c,g);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(s,o,a=[],c,g){if(c){const u=new v(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(s);const t=new Map,n=new D.IdleValue(()=>{const r=u._createInstance(o,a,g);for(const[i,l]of t){const f=r[i];if(typeof f=="function")for(const S of l)f.apply(r,S)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let S=t.get(i);return S||(S=new b.LinkedList,t.set(i,S)),(E,h,m)=>{const P=S.push([E,h,m]);return(0,d.toDisposable)(P)}}if(i in r)return r[i];const l=n.value;let f=l[i];return typeof f!="function"||(f=f.bind(l),r[i]=f),f},set(r,i,l){return n.value[i]=l,!0},getPrototypeOf(r){return o.prototype}})}else return this._createInstance(o,a,g)}_throwIfStrict(s,o){if(o&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=v;var y;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(y||(y={}));class C{static{this.all=new Set}static{this._None=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new C(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C._None}static traceCreation(s,o){return s?new C(1,o.name):C._None}static{this._totals=0}constructor(s,o){this.type=s,this.name=o,this._start=Date.now(),this._dep=[]}branch(s,o){const a=new C(3,s.toString());return this._dep.push([s,o,a]),a}stop(){const s=Date.now()-this._start;C._totals+=s;let o=!1;function a(g,u){const t=[],n=new Array(g+1).join("	");for(const[r,i,l]of u._dep)if(i&&l){o=!0,t.push(`${n}CREATES -> ${r}`);const f=a(g+1,l);f&&t.push(f)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(s>2||o)&&C.all.add(c.join(`
`))}}e.Trace=C}),define(Ce[14],De([1,0,46,4,51,3,28,12,24,18,2,41,5]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function y(){return new Date().toISOString()}function C(E){return(0,b.isNumber)(E)}e.isLogLevel=C;var w;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function s(E,h,m){switch(h){case w.Trace:E.trace(m);break;case w.Debug:E.debug(m);break;case w.Info:E.info(m);break;case w.Warning:E.warn(m);break;case w.Error:E.error(m);break;case w.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=s;function o(E,h=!1){let m="";for(let P=0;P<E.length;P++){let O=E[P];if(O instanceof Error&&(O=(0,D.toErrorMessage)(O,h)),typeof O=="object")try{O=JSON.stringify(O)}catch{}m+=(P>0?" ":"")+O}return m}class a extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(h){this.level!==h&&(this.level=h,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(h){return this.level!==w.Off&&this.level<=h}}e.AbstractLogger=a;class c extends a{constructor(h){super(),this.logAlways=h}checkLogLevel(h){return this.logAlways||super.checkLogLevel(h)}trace(h,...m){this.checkLogLevel(w.Trace)&&this.log(w.Trace,o([h,...m],!0))}debug(h,...m){this.checkLogLevel(w.Debug)&&this.log(w.Debug,o([h,...m]))}info(h,...m){this.checkLogLevel(w.Info)&&this.log(w.Info,o([h,...m]))}warn(h,...m){this.checkLogLevel(w.Warning)&&this.log(w.Warning,o([h,...m]))}error(h,...m){if(this.checkLogLevel(w.Error))if(h instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=h.stack,this.log(w.Error,o(P))}else this.log(w.Error,o([h,...m]))}flush(){}}e.AbstractMessageLogger=c;class g extends a{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.useColors=!p.isWindows}trace(h,...m){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,h,...m):console.log(`[main ${y()}]`,h,...m))}debug(h,...m){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,h,...m):console.log(`[main ${y()}]`,h,...m))}info(h,...m){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,h,...m):console.log(`[main ${y()}]`,h,...m))}warn(h,...m){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,h,...m):console.warn(`[main ${y()}]`,h,...m))}error(h,...m){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,h,...m):console.error(`[main ${y()}]`,h,...m))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class u extends a{constructor(h=e.DEFAULT_LOG_LEVEL,m=!0){super(),this.useColors=m,this.setLevel(h)}trace(h,...m){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",h,...m):console.log(h,...m))}debug(h,...m){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",h,...m):console.log(h,...m))}info(h,...m){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",h,...m):console.log(h,...m))}warn(h,...m){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",h,...m):console.log(h,...m))}error(h,...m){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",h,...m):console.error(h,...m))}dispose(){}flush(){}}e.ConsoleLogger=u;class t extends a{constructor(h,m=e.DEFAULT_LOG_LEVEL){super(),this.adapter=h,this.setLevel(m)}trace(h,...m){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(h),...m])}debug(h,...m){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(h),...m])}info(h,...m){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(h),...m])}warn(h,...m){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(h),...m])}error(h,...m){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(h),...m])}extractMessage(h){return typeof h=="string"?h:(0,D.toErrorMessage)(h,this.checkLogLevel(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends a{constructor(h){super(),this.loggers=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const m of this.loggers)m.setLevel(h);super.setLevel(h)}trace(h,...m){for(const P of this.loggers)P.trace(h,...m)}debug(h,...m){for(const P of this.loggers)P.debug(h,...m)}info(h,...m){for(const P of this.loggers)P.info(h,...m)}warn(h,...m){for(const P of this.loggers)P.warn(h,...m)}error(h,...m){for(const P of this.loggers)P.error(h,...m)}flush(){for(const h of this.loggers)h.flush()}dispose(){for(const h of this.loggers)h.dispose()}}e.MultiplexLogger=n;class r extends R.Disposable{constructor(h,m,P){if(super(),this.logLevel=h,this.logsHome=m,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new F.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,P)for(const O of P)this._loggers.set(O.resource,{logger:void 0,info:O})}getLoggerEntry(h){return(0,b.isString)(h)?[...this._loggers.values()].find(m=>m.info.id===h):this._loggers.get(h)}getLogger(h){return this.getLoggerEntry(h)?.logger}createLogger(h,m){const P=this.toResource(h),O=(0,b.isString)(h)?h:m?.id??(0,d.hash)(P.toString()).toString(16);let N=this._loggers.get(P)?.logger;const L=m?.logLevel==="always"?w.Trace:m?.logLevel;N||(N=this.doCreateLogger(P,L??this.getLogLevel(P)??this.logLevel,{...m,id:O}));const U={logger:N,info:{resource:P,id:O,logLevel:L,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(U.info),this._loggers.set(P,U),N}toResource(h){return(0,b.isString)(h)?(0,_.joinPath)(this.logsHome,`${h}.log`):h}setLogLevel(h,m){if(T.URI.isUri(h)){const P=h,O=m,N=this._loggers.get(P);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.logLevel?void 0:O,N.logger?.setLevel(O),this._loggers.set(N.info.resource,N),this._onDidChangeLogLevel.fire([P,O]))}else{this.logLevel=h;for(const[P,O]of this._loggers.entries())this._loggers.get(P)?.info.logLevel===void 0&&O.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(h,m){const P=this.getLoggerEntry(h);P&&m!==!P.info.hidden&&(P.info.hidden=!m,this._loggers.set(P.info.resource,P),this._onDidChangeVisibility.fire([P.info.resource,m]))}getLogLevel(h){let m;return h&&(m=this._loggers.get(h)?.info.logLevel),m??this.logLevel}registerLogger(h){const m=this._loggers.get(h.resource);m?m.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this._loggers.set(h.resource,{info:h,logger:void 0}),this._onDidChangeLoggers.fire({added:[h],removed:[]}))}deregisterLogger(h){const m=this._loggers.get(h);m&&(m.logger&&m.logger.dispose(),this._loggers.delete(h),this._onDidChangeLoggers.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const h of this._loggers.values())yield h.info}getRegisteredLogger(h){return this._loggers.get(h)?.info}dispose(){this._loggers.forEach(h=>h.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class i{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(h){}getLevel(){return w.Info}trace(h,...m){}debug(h,...m){}info(h,...m){}warn(h,...m){}error(h,...m){}critical(h,...m){}dispose(){}flush(){}}e.NullLogger=i;class l extends i{}e.NullLogService=l;function f(E){if(E.verbose)return w.Trace;if(typeof E.logLevel=="string"){const h=I(E.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function S(E){switch(E){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=S;function I(E){switch(E){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",S(w.Info))}),define(Ce[239],De([1,0,19,9,8,4,3,16,84,14]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends A.Disposable{constructor(v,y){super(),this.logService=v,this.options=y,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new F.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new F.ThrottledDelayer(0))}watch(v,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,y):this.watchNonRecursive(v,y)}watchUniversal(v,y){const C={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive},w=(0,D.insert)(this.universalPathsToWatch,C);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,d.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,_.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.universalPathsToWatch)(0,_.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.universalPathsToWatch)(0,_.isRecursiveWatchRequest)(y)&&v.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,y){const C={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:!1},w=(0,D.insert)(this.nonRecursivePathsToWatch,C);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,d.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,_.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,p.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(Ce[240],De([1,0,52,373,9,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,F.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(n)}`)}})();class t extends a.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new R.ResourceMap(l=>v.extUriBiasedIgnorePathCase.getComparisonKey(l)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:l}=await C.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,l),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:s.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await C.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(i.map(async f=>{try{let S;f.isSymbolicLink()?S=(await this.stat((0,v.joinPath)(r,f.name))).type:S=this.toType(f),l.push([f.name,S])}catch(S){this.logService.trace(S)}})),l}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let l;return i?.dangling?l=s.FileType.Unknown:r.isFile()?l=s.FileType.File:r.isDirectory()?l=s.FileType.Directory:l=s.FileType.Unknown,i&&(l|=s.FileType.SymbolicLink),l}async createResourceLock(r){const i=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let l;for(;l=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await l.wait();const f=new d.Barrier;return this.resourceLocks.set(r,f),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(r)===f&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),f.open()})}async readFile(r,i){let l;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),l=await this.createResourceLock(r));const f=this.toFilePath(r);return await C.Promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}finally{l?.dispose()}}traceLock(r){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,i,l){const f=(0,y.newWriteableStream)(S=>A.VSBuffer.concat(S.map(I=>A.VSBuffer.wrap(I))).buffer);return(0,o.readFileIntoStream)(this,r,f,S=>S.buffer,{...i,bufferSize:256*1024},l),f}async writeFile(r,i,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.canWriteFileAtomic(r)?this.doWriteFileAtomic(r,(0,v.joinPath)((0,v.dirname)(r),`${(0,v.basename)(r)}${l.atomic.postfix}`),i,l):this.doWriteFile(r,i,l)}async canWriteFileAtomic(r){try{const i=this.toFilePath(r),{symbolicLink:l}=await C.SymlinkSupport.stat(i);if(l)return!1}catch{}return!0}async doWriteFileAtomic(r,i,l,f){const S=new b.DisposableStore;try{S.add(await this.createResourceLock(r)),S.add(await this.createResourceLock(i)),await this.doWriteFile(i,l,f,!0);try{await this.rename(i,r,{overwrite:!0})}catch(I){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{S.dispose()}}async doWriteFile(r,i,l,f){let S;try{const I=this.toFilePath(r);if(!l.create||!l.overwrite){if(await C.Promises.exists(I)){if(!l.overwrite)throw(0,s.createFileSystemProviderError)((0,w.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,s.createFileSystemProviderError)((0,w.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(r,{create:!0,unlock:l.unlock},f),await this.write(S,0,i,0,i.byteLength)}catch(I){throw await this.toFileSystemProviderWriteError(r,I)}finally{typeof S=="number"&&await this.close(S)}}static{this.canFlush=!0}static configureFlushOnWrite(r){t.canFlush=r}async open(r,i,l){const f=this.toFilePath(r);let S;(0,s.isFileOpenForWriteOptions)(i)&&!l&&(S=await this.createResourceLock(r));let I;try{if((0,s.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:h}=await C.SymlinkSupport.stat(f);h.mode&128||await C.Promises.chmod(f,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}let E;if((0,s.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await C.Promises.truncate(f,0),E="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}E||(E="w")}else E="r";I=await C.Promises.open(f,E)}catch(E){throw S?.dispose(),(0,s.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,E):this.toFileSystemProviderError(E)}if(this.mapHandleToPos.set(I,0),(0,s.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(I,r),S){const E=this.mapHandleToLock.get(I);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${f})`),this.mapHandleToLock.set(I,S),E&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${f})`),E.dispose())}return I}async close(r){const i=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&t.canFlush)try{await C.Promises.fdatasync(r)}catch(l){t.configureFlushOnWrite(!1),this.logService.error(l)}return await C.Promises.close(r)}catch(l){throw this.toFileSystemProviderError(l)}finally{i&&(this.mapHandleToLock.get(r)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,l,f,S){const I=this.normalizePos(r,i);let E=null;try{E=(await C.Promises.read(r,l,f,S,I)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(r,I,E)}return E}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,l){const f=this.mapHandleToPos.get(r);typeof f=="number"&&(typeof i=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,f+l):this.mapHandleToPos.delete(r)))}async write(r,i,l,f,S){return(0,d.retry)(()=>this.doWrite(r,i,l,f,S),100,3)}async doWrite(r,i,l,f,S){const I=this.normalizePos(r,i);let E=null;try{E=(await C.Promises.write(r,l,f,S,I)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),h)}finally{this.updatePos(r,I,E)}return E}async mkdir(r){try{await C.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const l=this.toFilePath(r);if(i.recursive){let f;i?.atomic!==!1&&i.atomic.postfix&&(f=(0,T.join)((0,T.dirname)(l),`${(0,T.basename)(l)}${i.atomic.postfix}`)),await C.Promises.rm(l,C.RimRafMode.MOVE,f)}else try{await C.Promises.unlink(l)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let S=!1;try{const{stat:I,symbolicLink:E}=await C.SymlinkSupport.stat(l);S=I.isDirectory()&&!E}catch{}if(S)await C.Promises.rmdir(l);else throw f}else throw f}}catch(l){throw this.toFileSystemProviderError(l)}}async rename(r,i,l){const f=this.toFilePath(r),S=this.toFilePath(i);if(f!==S)try{await this.validateMoveCopy(r,i,"move",l.overwrite),await C.Promises.rename(f,S)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,T.basename)(f),(0,T.basename)((0,T.dirname)(S)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(r,i,l){const f=this.toFilePath(r),S=this.toFilePath(i);if(f!==S)try{await this.validateMoveCopy(r,i,"copy",l.overwrite),await C.Promises.copy(f,S,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,T.basename)(f),(0,T.basename)((0,T.dirname)(S)),I.toString()))),this.toFileSystemProviderError(I)}}async validateMoveCopy(r,i,l,f){const S=this.toFilePath(r),I=this.toFilePath(i);let E=!1;if(!!(this.capabilities&1024)||(E=(0,_.isEqual)(S,I,!0)),E){if(l==="copy")throw(0,s.createFileSystemProviderError)((0,w.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const m=await this.statIgnoreError(r);if(!m)throw(0,s.createFileSystemProviderError)((0,w.localize)(5,null),s.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(i);if(P){if(!f)throw(0,s.createFileSystemProviderError)((0,w.localize)(6,null),s.FileSystemProviderErrorCode.FileExists);m.type&s.FileType.File&&P.type&s.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.doCloneFile(r,i,!1)}async doCloneFile(r,i,l){const f=this.toFilePath(r),S=this.toFilePath(i),I=!!(this.capabilities&1024);if((0,_.isEqual)(f,S,!I))return;const E=new b.DisposableStore;try{E.add(await this.createResourceLock(r)),E.add(await this.createResourceLock(i)),l&&await C.Promises.mkdir((0,T.dirname)(S),{recursive:!0}),await C.Promises.copyFile(f,S)}catch(h){if(h.code==="ENOENT"&&!l)return this.doCloneFile(r,i,!0);throw this.toFileSystemProviderError(h)}finally{E.dispose()}}createUniversalWatcher(r,i,l){return new g.UniversalWatcherClient(f=>r(f),f=>i(f),l)}createNonRecursiveWatcher(r,i,l){return new u.NodeJSWatcherClient(f=>r(f),f=>i(f),l)}toFileSystemProviderError(r){if(r instanceof s.FileSystemProviderError)return r;let i=r,l;switch(r.code){case"ENOENT":l=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=s.FileSystemProviderErrorCode.Unknown;break;default:l=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,l)}async toFileSystemProviderWriteError(r,i){let l=this.toFileSystemProviderError(i);if(r&&l.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await C.SymlinkSupport.stat(this.toFilePath(r));f.mode&128||(l=(0,s.createFileSystemProviderError)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return l}}e.DiskFileSystemProvider=t}),define(Ce[241],De([1,0,3,14]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class d extends D.Disposable{constructor(A,p=[]){super(),this.logger=new F.MultiplexLogger([A,...p]),this._register(A.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...p){this.logger.trace(A,...p)}debug(A,...p){this.logger.debug(A,...p)}info(A,...p){this.logger.info(A,...p)}warn(A,...p){this.logger.warn(A,...p)}error(A,...p){this.logger.error(A,...p)}flush(){this.logger.flush()}}e.LogService=d}),define(Ce[242],De([1,0,30,14]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var d;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(d||(d={}));async function R(b,T,k,v,y){try{const C=await new Promise((s,o)=>{pe(["@vscode/spdlog"],s,o)});C.setFlushOn(d.Trace);const w=await C.createAsyncRotatingLogger(b,T,k,v);return y?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(C){console.error(C)}return null}function A(b,T,k){switch(T){case F.LogLevel.Trace:b.trace(k);break;case F.LogLevel.Debug:b.debug(k);break;case F.LogLevel.Info:b.info(k);break;case F.LogLevel.Warning:b.warn(k);break;case F.LogLevel.Error:b.error(k);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function p(b,T){switch(T){case F.LogLevel.Trace:b.setLevel(d.Trace);break;case F.LogLevel.Debug:b.setLevel(d.Debug);break;case F.LogLevel.Info:b.setLevel(d.Info);break;case F.LogLevel.Warning:b.setLevel(d.Warning);break;case F.LogLevel.Error:b.setLevel(d.Error);break;case F.LogLevel.Off:b.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class _ extends F.AbstractMessageLogger{constructor(T,k,v,y,C){super(),this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(T,k,v,y),this._register(this.onDidChangeLogLevel(w=>{this._logger&&p(this._logger,w)}))}async _createSpdLogLogger(T,k,v,y){const C=v?6:1,w=30/C*D.ByteSize.MB,s=await R(T,k,w,C,y);if(s){this._logger=s,p(this._logger,this.getLevel());for(const{level:o,message:a}of this.buffer)A(this._logger,o,a);this.buffer=[]}}log(T,k){this._logger?A(this._logger,T,k):this.getLevel()<=T&&this.buffer.push({level:T,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(Ce[133],De([1,0,38,198,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(_){function b(C,w){return w-C}_.compare=b;const T=Object.create(null);T[_.Error]=(0,F.localize)(0,null),T[_.Warning]=(0,F.localize)(1,null),T[_.Info]=(0,F.localize)(2,null);function k(C){return T[C]||""}_.toString=k;function v(C){switch(C){case D.default.Error:return _.Error;case D.default.Warning:return _.Warning;case D.default.Info:return _.Info;case D.default.Ignore:return _.Hint}}_.fromSeverity=v;function y(C){switch(C){case _.Error:return D.default.Error;case _.Warning:return D.default.Warning;case _.Info:return D.default.Info;case _.Hint:return D.default.Ignore}}_.toSeverity=y}(A||(e.MarkerSeverity=A={}));var p;(function(_){const b="";function T(v){return k(v,!0)}_.makeKey=T;function k(v,y){const C=[b];return v.source?C.push(v.source.replace("\xA6","\\\xA6")):C.push(b),v.code?typeof v.code=="string"?C.push(v.code.replace("\xA6","\\\xA6")):C.push(v.code.value.replace("\xA6","\\\xA6")):C.push(b),v.severity!==void 0&&v.severity!==null?C.push(A.toString(v.severity)):C.push(b),v.message&&y?C.push(v.message.replace("\xA6","\\\xA6")):C.push(b),v.startLineNumber!==void 0&&v.startLineNumber!==null?C.push(v.startLineNumber.toString()):C.push(b),v.startColumn!==void 0&&v.startColumn!==null?C.push(v.startColumn.toString()):C.push(b),v.endLineNumber!==void 0&&v.endLineNumber!==null?C.push(v.endLineNumber.toString()):C.push(b),v.endColumn!==void 0&&v.endColumn!==null?C.push(v.endColumn.toString()):C.push(b),C.push(b),C.join("\xA6")}_.makeKeyOptionalMessage=k})(p||(e.IMarkerData=p={})),e.IMarkerService=(0,d.createDecorator)("markerService")}),define(Ce[243],De([1,0,4,38,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,d.createDecorator)("notificationService");var R;(function(T){T[T.DEFAULT=0]="DEFAULT",T[T.SILENT=1]="SILENT",T[T.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var p;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(p||(e.NotificationsFilter=p={}));class _{constructor(){this.progress=new b,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=_;class b{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=b}),define(Ce[134],De([1,0,15,2,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,d.createDecorator)("openerService");function R(b,T){return F.URI.isUri(b)?(0,D.equalsIgnoreCase)(b.scheme,T):(0,D.startsWithIgnoreCase)(b,T+":")}e.matchesScheme=R;function A(b,...T){return T.some(k=>R(b,k))}e.matchesSomeScheme=A;function p(b,T){return b.with({fragment:`${T.startLineNumber},${T.startColumn}${T.endLineNumber?`-${T.endLineNumber}${T.endColumn?`,${T.endColumn}`:""}`:""}`})}e.withSelection=p;function _(b){let T;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return k&&(T={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},b=b.with({fragment:""})),{selection:T,uri:b}}e.extractSelection=_}),define(Ce[244],De([1,0,12,47]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.context<"u"){const R=D.globals.vscode.context.configuration();if(R)d=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){d=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:R,searchUrl:A,itemUrl:p,controlUrl:_}=d.extensionsGallery||{};Object.assign(d,{extensionsGallery:{serviceUrl:F.env.VSCODE_GALLERY_SERVICE_URL||R,searchUrl:F.env.VSCODE_GALLERY_SEARCH_URL||A,itemUrl:F.env.VSCODE_GALLERY_ITEM_URL||p,controlUrl:F.env.VSCODE_GALLERY_CONTROL_URL||_}});try{const b=(...k)=>k.reduce((v,y)=>(Object.keys(y).forEach(C=>{Array.isArray(v[C])&&Array.isArray(y[C])?v[C]=y[C]:typeof v[C]=="object"&&typeof y[C]=="object"?v[C]=b(v[C],y[C]):v[C]=y[C]}),v),{}),T=globalThis._VSCODE_USER_PRODUCT_JSON||{};d=b(d,T)}catch{}if(F.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const b=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:b.version,release:b.release})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(Ce[135],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(pe,e){return function(D,F){e(D,F,pe)}};define(Ce[64],De([1,0,9,21,3,5]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var A;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(k,v){this.callback=k,this.report=v?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(k){this._value=k,this.callback(this._value)}_reportAsync(k){Promise.resolve(this._lastTask).finally(()=>{this._value=k;const v=this.callback(this._value);this._lastTask=Promise.resolve(v).finally(()=>this._lastTask=void 0)})}}e.Progress=p;let _=class extends d.Disposable{constructor(k,v){super(),this.deferred=new D.DeferredPromise,v.withProgress(k,y=>(this.reporter=y,this.lastStep&&y.report(this.lastStep),this.deferred.p)),this._register((0,d.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};e.UnmanagedProgress=_,e.UnmanagedProgress=_=je([$e(1,e.IProgressService)],_);class b extends d.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new d.DisposableStore)}start(k){this.stop();const v=++this.currentOperationId,y=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{v===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,d.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,d.toDisposable)(()=>y.cancel())),this.currentOperationDisposables.add((0,d.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:v,token:y.token,stop:()=>this.doStop(v),isCurrent:()=>this.currentOperationId===v}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=b,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(Ce[42],De([1,0,57,18]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class d{constructor(){this.data=new Map}add(A,p){D.ok(F.isString(A)),D.ok(F.isObject(p)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,p)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new d}),define(Ce[106],De([1,0,4,42]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function d(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,b){this.schemasById[d(_)]=b,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new R;F.Registry.add(e.Extensions.JSONContribution,A)}),define(Ce[136],De([1,0,19,4,18,188,49,106,42]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=_.Registry.as(p.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.doRegisterConfigurations(t,n,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.doDeregisterConfigurations(t,n),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.doDeregisterConfigurations(n,r),this.doRegisterConfigurations(t,!1,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.doRegisterDefaultConfigurations(t,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,n){const r=[];for(const{overrides:i,source:l}of t)for(const f in i)if(n.add(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const S=this.configurationDefaultsOverrides.get(f),I=S?.valuesSources??new Map;if(l)for(const P of Object.keys(i[f]))I.set(P,l);const E={...S?.value||{},...i[f]};this.configurationDefaultsOverrides.set(f,{source:l,value:E,valuesSources:I});const h=(0,A.getLanguageTagSettingPlainKey)(f),m={type:"object",default:E,description:R.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:d.isString(l)?void 0:l,defaultValueSource:l};r.push(...w(f)),this.configurationProperties[f]=m,this.defaultLanguageConfigurationOverridesNode.properties[f]=m}else{this.configurationDefaultsOverrides.set(f,{value:i[f],source:l});const S=this.configurationProperties[f];S&&(this.updatePropertyDefaultValue(f,S),this.updateSchema(f,S))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const n=new Set;this.doDeregisterDefaultConfigurations(t,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,n){for(const{overrides:r,source:i}of t)for(const l in r){const f=this.configurationDefaultsOverrides.get(l),S=d.isString(i)?i:i?.id,I=d.isString(f?.source)?f?.source:f?.source?.id;if(S===I)if(n.add(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const E=this.configurationProperties[l];E&&(this.updatePropertyDefaultValue(l,E),this.updateSchema(l,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const n of t)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,n,r){t.forEach(i=>{this.validateAndRegisterProperties(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,n){const r=i=>{if(i.properties)for(const l in i.properties){n.add(l);const f=this.configurationProperties[l];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,i.properties[l])}i.allOf?.forEach(l=>r(l))};for(const i of t){r(i);const l=this.configurationContributors.indexOf(i);l!==-1&&this.configurationContributors.splice(l,1)}}validateAndRegisterProperties(t,n=!0,r,i,l=3,f){l=d.isUndefinedOrNull(t.scope)?l:t.scope;const S=t.properties;if(S)for(const E in S){const h=S[E];if(n&&c(E,h)){delete S[E];continue}if(h.source=r,h.defaultDefaultValue=S[E].default,this.updatePropertyDefaultValue(E,h),e.OVERRIDE_PROPERTY_REGEX.test(E)?h.scope=void 0:(h.scope=d.isUndefinedOrNull(h.scope)?l:h.scope,h.restricted=d.isUndefinedOrNull(h.restricted)?!!i?.includes(E):h.restricted),S[E].hasOwnProperty("included")&&!S[E].included){this.excludedConfigurationProperties[E]=S[E],delete S[E];continue}else this.configurationProperties[E]=S[E],S[E].policy?.name&&this.policyConfigurations.set(S[E].policy.name,E);!S[E].deprecationMessage&&S[E].markdownDeprecationMessage&&(S[E].deprecationMessage=S[E].markdownDeprecationMessage),f.add(E)}const I=t.allOf;if(I)for(const E of I)this.validateAndRegisterProperties(E,n,r,i,l,f)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const n=r=>{const i=r.properties;if(i)for(const f in i)this.updateSchema(f,i[f]);r.allOf?.forEach(n)};n(t)}updateSchema(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.resourceLanguageSettingsSchema.properties[t]=n;break}}removeFromSchema(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const n=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,n){const r=this.configurationDefaultsOverrides.get(t);let i=r?.value,l=r?.source;d.isUndefined(i)&&(i=n.defaultDefaultValue,l=void 0),d.isUndefined(i)&&(i=o(n.type)),n.default=i,n.defaultValueSource=l}}const y="\\[([^\\]]+)\\]",C=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(u){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let n=C.exec(u);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=C.exec(u)}}return(0,D.distinct)(t)}e.overrideIdentifiersFromKey=w;function s(u){return u.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=s;function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const a=new v;_.Registry.add(e.Extensions.Configuration,a);function c(u,t){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?R.localize(7,null,u):a.getConfigurationProperties()[u]!==void 0?R.localize(8,null,u):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,u,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=c;function g(){const u=[],t=a.getConfigurationProperties();for(const n of Object.keys(t))u.push([n,t[n].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=g}),define(Ce[245],De([1,0,19,4,157,3,28,23,18,2,49,136,42]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function y(n){return Object.isFrozen(n)?n:p.deepFreeze(n)}class C{constructor(r={},i=[],l=[],f){this._contents=r,this._keys=i,this._overrides=l,this.raw=f,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof C)return i;const l=new w("");return l.parseRaw(i),l.configurationModel});this._rawConfiguration=r.reduce((i,l)=>l===i?l:i.merge(l),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const l=this.rawConfiguration.getValue(r),f=i?this.rawConfiguration.getOverrideValue(r,i):void 0,S=i?this.rawConfiguration.override(i).getValue(r):l;return{value:l,override:f,merged:S}}getOverrideValue(r,i){const l=this.getContentsForOverrideIdentifer(i);return l?r?(0,T.getConfigurationValue)(l,r):l:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const l of this.overrides)l.identifiers.includes(r)&&i.push(...l.keys);return D.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return D.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=p.deepClone(this.contents),l=p.deepClone(this.overrides),f=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of r)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.mergeContents(i,I.contents);for(const E of I.overrides){const[h]=l.filter(m=>D.equals(m.identifiers,E.identifiers));h?(this.mergeContents(h.contents,E.contents),h.keys.push(...E.keys),h.keys=D.distinct(h.keys)):l.push(p.deepClone(E))}for(const E of I.keys)f.indexOf(E)===-1&&f.push(E)}return new C(i,f,l,S.every(I=>I instanceof C)?void 0:S)}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const l={};for(const f of D.distinct([...Object.keys(this.contents),...Object.keys(i)])){let S=this.contents[f];const I=i[f];I&&(typeof S=="object"&&typeof I=="object"?(S=p.deepClone(S),this.mergeContents(S,I)):S=I),l[f]=S}return new C(l,this.keys,this.overrides)}mergeContents(r,i){for(const l of Object.keys(i)){if(l in r&&_.isObject(r[l])&&_.isObject(i[l])){this.mergeContents(r[l],i[l]);continue}r[l]=p.deepClone(i[l])}}getContentsForOverrideIdentifer(r){let i=null,l=null;const f=S=>{S&&(l?this.mergeContents(l,S):l=p.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===r?i=S.contents:S.identifiers.includes(r)&&f(S.contents);return f(i),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.updateValue(r,i,!0)}setValue(r,i){this.updateValue(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(l=>D.equals(l.identifiers,(0,k.overrideIdentifiersFromKey)(r))),1))}updateValue(r,i,l){(0,T.addToValueTree)(this.contents,r,i,f=>console.error(f)),l=l||this.keys.indexOf(r)===-1,l&&this.keys.push(r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],f=>console.error(f))})}}e.ConfigurationModel=C;class w{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!_.isUndefinedOrNull(r)){const l=this.doParseContent(r);this.parseRaw(l,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:l,keys:f,overrides:S,restricted:I,hasExcludedProperties:E}=this.doParseRaw(r,i);this._configurationModel=new C(l,f,S,E?[r]:void 0),this._restrictedConfigurations=I||[]}doParseContent(r){let i={},l=null,f=[];const S=[],I=[];function E(m){Array.isArray(f)?f.push(m):l!==null&&(f[l]=m)}const h={onObjectBegin:()=>{const m={};E(m),S.push(f),f=m,l=null},onObjectProperty:m=>{l=m},onObjectEnd:()=>{f=S.pop()},onArrayBegin:()=>{const m=[];E(m),S.push(f),f=m,l=null},onArrayEnd:()=>{f=S.pop()},onLiteralValue:E,onError:(m,P,O)=>{I.push({error:m,offset:P,length:O})}};if(r)try{d.visit(r,h),i=f[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return i}doParseRaw(r,i){const l=v.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),f=this.filter(r,l,!0,i);r=f.raw;const S=(0,T.toValuesTree)(r,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),I=Object.keys(r),E=this.toOverrides(r,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:S,keys:I,overrides:E,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}filter(r,i,l,f){let S=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:S};const I={},E=[];for(const h in r)if(k.OVERRIDE_PROPERTY_REGEX.test(h)&&l){const m=this.filter(r[h],i,!1,f);I[h]=m.raw,S=S||m.hasExcludedProperties,E.push(...m.restricted)}else{const m=i[h],P=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&E.push(h),!f.exclude?.includes(h)&&(f.include?.includes(h)||(P===void 0||f.scopes===void 0||f.scopes.includes(P))&&!(f.skipRestricted&&m?.restricted))?I[h]=r[h]:S=!0}return{raw:I,restricted:E,hasExcludedProperties:S}}toOverrides(r,i){const l=[];for(const f of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(f)){const S={};for(const I in r[f])S[I]=r[f][I];l.push({identifiers:(0,k.overrideIdentifiersFromKey)(f),keys:Object.keys(S),contents:(0,T.toValuesTree)(S,i)})}return l}}e.ConfigurationModelParser=w;class s extends R.Disposable{constructor(r,i,l,f){super(),this.userSettingsResource=r,this.parseOptions=i,this.fileService=f,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.any(F.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),F.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&l.isEqual(S.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=s;class o{constructor(r,i,l,f,S,I,E,h,m,P,O,N,L){this.key=r,this.overrides=i,this._value=l,this.overrideIdentifiers=f,this.defaultConfiguration=S,this.policyConfiguration=I,this.applicationConfiguration=E,this.userConfiguration=h,this.localUserConfiguration=m,this.remoteUserConfiguration=P,this.workspaceConfiguration=O,this.folderConfigurationModel=N,this.memoryConfigurationModel=L}get value(){return y(this._value)}inspect(r,i,l){const f=r.inspect(i,l);return{get value(){return y(f.value)},get override(){return y(f.override)},get merged(){return y(f.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(r,i,l,f,S=new C,I=new C,E=new A.ResourceMap,h=new C,m=new A.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=l,this._localUserConfiguration=f,this._remoteUserConfiguration=S,this._workspaceConfiguration=I,this._folderConfigurations=E,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,i,l){return this.getConsolidatedConfigurationModel(r,i,l).getValue(r)}updateValue(r,i,l={}){let f;l.resource?(f=this._memoryConfigurationByResource.get(l.resource),f||(f=new C,this._memoryConfigurationByResource.set(l.resource,f))):f=this._memoryConfiguration,i===void 0?f.removeValue(r):f.setValue(r,i),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,l){const f=this.getConsolidatedConfigurationModel(r,i,l),S=this.getFolderConfigurationModelForResource(i.resource,l),I=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const h of f.overrides)for(const m of h.identifiers)f.getOverrideValue(r,m)!==void 0&&E.add(m);return new o(r,i,f.getValue(r),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this._workspaceConfiguration:void 0,S||void 0,I)}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const l=[];if(!i){const{added:f,updated:S,removed:I}=u(this._defaultConfiguration,r);i=[...f,...S,...I]}for(const f of i)for(const S of(0,k.overrideIdentifiersFromKey)(f)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(S),E=r.getKeysForOverrideIdentifier(S),h=[...E.filter(m=>I.indexOf(m)===-1),...I.filter(m=>E.indexOf(m)===-1),...I.filter(m=>!p.equals(this._defaultConfiguration.override(S).getValue(m),r.override(S).getValue(m)))];l.push([S,h])}return this.updateDefaultConfiguration(r),{keys:i,overrides:l}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:l,removed:f}=u(this._policyConfiguration,r),S=[...i,...l,...f];return S.length&&this.updatePolicyConfiguration(r),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:l,removed:f,overrides:S}=u(this.applicationConfiguration,r),I=[...i,...l,...f];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:l,removed:f,overrides:S}=u(this.localUserConfiguration,r),I=[...i,...l,...f];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:l,removed:f,overrides:S}=u(this.remoteUserConfiguration,r),I=[...i,...l,...f];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:l,removed:f,overrides:S}=u(this.workspaceConfiguration,r),I=[...i,...l,...f];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(r,i){const l=this.folderConfigurations.get(r),{added:f,updated:S,removed:I,overrides:E}=u(l,i),h=[...f,...S,...I];return(h.length||!l)&&this.updateFolderConfiguration(r,i),{keys:h,overrides:E}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:l,updated:f,removed:S,overrides:I}=u(i,void 0);return{keys:[...l,...f,...S],overrides:I}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,l){let f=this.getConsolidatedConfigurationModelForResource(i,l);return i.overrideIdentifier&&(f=f.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(f=f.merge(this._policyConfiguration)),f}getConsolidatedConfigurationModelForResource({resource:r},i){let l=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const f=i.getFolder(r);f&&(l=this.getFolderConsolidatedConfiguration(f.uri)||l);const S=this._memoryConfigurationByResource.get(r);S&&(l=l.merge(S))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const l=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(r);f?(i=l.merge(f),this._foldersConsolidatedConfigurations.set(r,i)):i=l}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const l=i.getFolder(r);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:l,overrides:f,keys:S}=this._folderConfigurations.get(i);return r.push([i,{contents:l,overrides:f,keys:S}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this._workspaceConfiguration.keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(l=>r.add(l))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(l=>r.add(l))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(r).forEach(f=>i.add(f))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),l=this.parseConfigurationModel(r.policy),f=this.parseConfigurationModel(r.application),S=this.parseConfigurationModel(r.user),I=this.parseConfigurationModel(r.workspace),E=r.folders.reduce((h,m)=>(h.set(b.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new A.ResourceMap);return new a(i,l,f,S,new C,I,E,new C,new A.ResourceMap)}static parseConfigurationModel(r){return new C(r.contents,r.keys,r.overrides)}}e.Configuration=a;function c(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const f of n)f.keys.forEach(S=>r.add(S)),f.overrides.forEach(([S,I])=>{const E=(0,A.getOrSet)(i,S,new Set);I.forEach(h=>E.add(h))});const l=[];return i.forEach((f,S)=>l.push([S,[...f.values()]])),{keys:[...r.values()],overrides:l}}e.mergeChanges=c;class g{constructor(r,i,l,f){this.change=r,this.previous=i,this.currentConfiguraiton=l,this.currentWorkspace=f,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const S of r.keys)this.affectedKeys.add(S);for(const[,S]of r.overrides)for(const I of S)this.affectedKeys.add(I);this._affectsConfigStr=this._marker;for(const S of this.affectedKeys)this._affectsConfigStr+=S+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){const l=this._marker+r,f=this._affectsConfigStr.indexOf(l);if(f<0)return!1;const S=f+l.length;if(S>=this._affectsConfigStr.length)return!1;const I=this._affectsConfigStr.charCodeAt(S);if(I!==this._markerCode1&&I!==this._markerCode2)return!1;if(i){const E=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!p.equals(E,h)}return!0}}e.ConfigurationChangeEvent=g;function u(n,r){const{added:i,removed:l,updated:f}=t(r?.rawConfiguration,n?.rawConfiguration),S=[],I=n?.getAllOverrideIdentifiers()||[],E=r?.getAllOverrideIdentifiers()||[];if(r){const h=E.filter(m=>!I.includes(m));for(const m of h)S.push([m,r.getKeysForOverrideIdentifier(m)])}if(n){const h=I.filter(m=>!E.includes(m));for(const m of h)S.push([m,n.getKeysForOverrideIdentifier(m)])}if(r&&n){for(const h of I)if(E.includes(h)){const m=t({contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)},{contents:r.getOverrideValue(void 0,h)||{},keys:r.getKeysForOverrideIdentifier(h)});S.push([h,[...m.added,...m.removed,...m.updated]])}}return{added:i,removed:l,updated:f,overrides:S}}function t(n,r){const i=n?r?n.keys.filter(S=>r.keys.indexOf(S)===-1):[...n.keys]:[],l=r?n?r.keys.filter(S=>n.keys.indexOf(S)===-1):[...r.keys]:[],f=[];if(n&&r){for(const S of r.keys)if(n.keys.indexOf(S)!==-1){const I=(0,T.getConfigurationValue)(r.contents,S),E=(0,T.getConfigurationValue)(n.contents,S);p.equals(I,E)||f.push(S)}}return{added:i,removed:l,updated:f}}}),define(Ce[246],De([1,0,22,4,3,82]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const A=(b,T,k)=>{const v=new Uint8Array(16);for(let w=0;w<16;w++)v[w]=Math.round(Math.random()*256);const y=(0,D.encodeBase64)(D.VSBuffer.wrap(v));return[`GET ws://localhost${b}?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=A,e.socketRawEndHeaderSequence=D.VSBuffer.fromString(`\r
\r
`);async function p(b,T,k,v,y){b.write(D.VSBuffer.fromString((0,e.makeRawSocketHeaders)(T,k,v)));const C=new d.DisposableStore;try{return await new Promise((w,s)=>{let o;C.add(b.onData(a=>{o?o=D.VSBuffer.concat([o,a],o.byteLength+a.byteLength):o=a;const c=o.indexOf(e.socketRawEndHeaderSequence);if(c===-1)return;w(b),b.pauseData();const g=o.slice(c+e.socketRawEndHeaderSequence.byteLength);g.byteLength&&y.onData.fire(g)})),C.add(b.onClose(a=>s(a??new Error("socket closed")))),C.add(b.onEnd(()=>s(new Error("socket ended"))))})}catch(w){throw b.dispose(),w}finally{C.dispose()}}e.connectManagedSocket=p;class _ extends d.Disposable{constructor(T,k){super(),this.debugLabel=T,this.pausableDataEmitter=this._register(new F.PauseableEmitter),this.onData=(...v)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...v)),this.didDisposeEmitter=this._register(new F.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(k.onData),this._register(k.onData.event(v=>this.pausableDataEmitter.fire(v))),this.onClose=this._register(k.onClose).event,this.onEnd=this._register(k.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(T,k){R.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,T,k)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=_}),define(Ce[65],De([1,0,8,5]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,F.createDecorator)("remoteAuthorityResolverService");var d;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class R{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=R;class A{constructor(k,v){this.host=k,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class _ extends D.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof _&&k._code===p.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof _&&k._code===p.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof _&&k._code===p.NoResolverFound}static isInvalidAuthority(k){return k instanceof _&&k._code===p.InvalidAuthority}static isHandled(k){return k instanceof _&&k.isHandled}constructor(k,v=p.Unknown,y){super(k),this._message=k,this._code=v,this._detail=y,this.isHandled=v===p.NotAvailable&&y===!0,Object.setPrototypeOf(this,_.prototype)}}e.RemoteAuthorityResolverError=_;function b(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}e.getRemoteAuthorityPrefix=b}),define(Ce[66],De([1,0,17]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function F(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=F;function d(b){if(!b)return;const T=b.indexOf("+");return T<0?b:b.substr(0,T)}e.getRemoteName=d;function R(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(b){const{host:T,port:k}=_(b);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:k}}e.parseAuthorityWithPort=A;function p(b,T){let{host:k,port:v}=_(b);return typeof v>"u"&&(v=T),{host:k,port:v}}e.parseAuthorityWithOptionalPort=p;function _(b){const T=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=b.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:b,port:void 0}}}),define(Ce[25],De([1,0,15,5,66]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A||(e.ExtensionType=A={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.LINUX_PPC64LE="linux-ppc64le",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class _{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const a=typeof s=="string"?s:s.value,c=typeof o=="string"?o:o.value;return D.equalsIgnoreCase(a,c)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=_;class b{get size(){return this._set.size}constructor(s){if(this._set=new Set,s)for(const o of s)this.add(o)}add(s){this._set.add(_.toKey(s))}delete(s){return this._set.delete(_.toKey(s))}has(s){return this._set.has(_.toKey(s))}}e.ExtensionIdentifierSet=b;class T{constructor(){this._map=new Map}clear(){this._map.clear()}delete(s){this._map.delete(_.toKey(s))}get(s){return this._map.get(_.toKey(s))}has(s){return this._map.has(_.toKey(s))}set(s,o){this._map.set(_.toKey(s),o)}values(){return this._map.values()}forEach(s){this._map.forEach(s)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function k(w){return v(w)}e.isApplicationScopedExtension=k;function v(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function y(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function C(w,s){if(s){const o=`onResolveRemoteAuthority:${(0,d.getRemoteName)(s)}`;return!!w.activationEvents?.includes(o)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[137],De([1,0,8,25]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class d{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,p){this._generators.set(A,p)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const p=Object.create(null);for(const _ of A){const b=this.readActivationEvents(_);b.length>0&&(p[F.ExtensionIdentifier.toKey(_.identifier)]=b)}return p}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const p=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return p;for(const _ in A.contributes){const b=this._generators.get(_);if(!b)continue;const T=A.contributes[_],k=Array.isArray(T)?T:[T];try{b(k,p)}catch(v){(0,D.onUnexpectedError)(v)}}return p}}e.ImplicitActivationEventsImpl=d,e.ImplicitActivationEvents=new d}),define(Ce[247],De([1,0,9,22,21,8,4,3,53,37,31,82,65,66]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var w;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function s(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(G){const B=new d.CancellationTokenSource;return setTimeout(()=>B.cancel(),G),B.token}function a(G,B){if(G.isCancellationRequested||B.isCancellationRequested)return d.CancellationToken.Cancelled;const V=new d.CancellationTokenSource;return G.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class c{get didTimeout(){return this._state==="timedout"}constructor(B){this._state="pending",this._disposables=new p.DisposableStore,this.promise=new Promise((V,me)=>{this._resolvePromise=V,this._rejectPromise=me}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function g(G,B){const V=new c(B);return V.registerDisposable(G.onControlMessage(me=>{const Z=JSON.parse(me.toString()),ne=X(Z);ne?V.reject(ne):V.resolve(Z)})),V.promise}function u(G,B,V,me,Z,ne,re,ye){const oe=new c(ye),de=b.StopWatch.create(!1);return G.info(`Creating a socket (${re})...`),_.mark(`code/willCreateSocket/${ne}`),B.connect(V,me,Z,re).then(ee=>{oe.didTimeout?(_.mark(`code/didCreateSocketError/${ne}`),G.info(`Creating a socket (${re}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(_.mark(`code/didCreateSocketOK/${ne}`),G.info(`Creating a socket (${re}) was successful after ${de.elapsed()} ms.`),oe.resolve(ee))},ee=>{_.mark(`code/didCreateSocketError/${ne}`),G.info(`Creating a socket (${re}) returned an error after ${de.elapsed()} ms.`),G.error(ee),oe.reject(ee)}),oe.promise}function t(G,B){const V=new c(B);return G.then(me=>{V.didTimeout||V.resolve(me)},me=>{V.didTimeout||V.reject(me)}),V.promise}async function n(G,B,V,me){const Z=le(G,B);G.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let ne;try{ne=await u(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,y.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,s(B),`renderer-${s(B)}-${G.reconnectionToken}`,me)}catch(ee){throw G.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let re,ye;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ne,null),re=G.reconnectionProtocol,ye=!1):(re=new k.PersistentProtocol({socket:ne}),ye=!0),G.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const oe=await t(G.signService.createNewMessage((0,T.generateUuid)()),me),de={type:"auth",auth:G.connectionToken||"00000000000000000000",data:oe.data};re.sendControl(F.VSBuffer.fromString(JSON.stringify(de)));try{const ee=await g(re,a(me,o(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const $=new Error("Unexpected handshake message");throw $.code="VSCODE_CONNECTION_ERROR",$}if(G.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await t(G.signService.validate(oe,ee.signedData),me)){const $=new Error("Refused to connect to unsupported server");throw $.code="VSCODE_CONNECTION_ERROR",$}const ve=await t(G.signService.sign(ee.data),me),ke={type:"connectionType",commit:G.commit,signedData:ve,desiredConnectionType:B};return V&&(ke.args=V),G.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(F.VSBuffer.fromString(JSON.stringify(ke))),{protocol:re,ownsProtocol:ye}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${Z} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${Z} received error control message when negotiating connection. Error:`),G.logService.error(ee)),ye&&Y(re),ee}}async function r(G,B,V,me){const Z=Date.now(),ne=le(G,B),{protocol:re,ownsProtocol:ye}=await n(G,B,V,me),oe=new c(me);return oe.registerDisposable(re.onControlMessage(de=>{const ee=JSON.parse(de.toString()),ue=X(ee);ue?(G.logService.error(`${ne} received error control message when negotiating connection. Error:`),G.logService.error(ue),ye&&Y(re),oe.reject(ue)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${we(Z)}!`),oe.resolve({protocol:re,firstMessage:ee}))})),oe.promise}async function i(G,B){const{protocol:V}=await r(G,1,void 0,B);return{protocol:V}}async function l(G,B,V){const{protocol:me,firstMessage:Z}=await r(G,2,B,V),ne=Z&&Z.debugPort;return{protocol:me,debugPort:ne}}async function f(G,B,V){const me=Date.now(),Z=le(G,3),{protocol:ne}=await n(G,3,B,V);return G.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${we(me)}!`),ne}async function S(G,B,V){const{connectTo:me,connectionToken:Z}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:me,connectionToken:Z,reconnectionToken:B,reconnectionProtocol:V,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function I(G,B,V){return h(G,async me=>{const{protocol:Z}=await i(me,d.CancellationToken.None);return new j(G,B,V,me.reconnectionToken,Z)})}e.connectRemoteAgentManagement=I;async function E(G,B){return h(G,async V=>{const{protocol:me,debugPort:Z}=await l(V,B,d.CancellationToken.None);return new fe(G,B,V.reconnectionToken,me,Z)})}e.connectRemoteAgentExtensionHost=E;async function h(G,B){for(let me=1;;me++)try{const Z=(0,T.generateUuid)(),ne=await S(G,Z,null);return await B(ne)}catch(Z){if(me<5)G.logService.error(`[remote-connection][attempt ${me}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(Z);else throw G.logService.error(`[remote-connection][attempt ${me}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(Z),H.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(Z)),Z}}async function m(G,B,V){const me=await S(G,(0,T.generateUuid)(),null);return await f(me,{host:B,port:V},d.CancellationToken.None)}e.connectRemoteAgentTunnel=m;function P(G){return(0,D.createCancelablePromise)(B=>new Promise((V,me)=>{const Z=setTimeout(V,G*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var O;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=N;class L{constructor(B,V,me,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=me,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=L;class U{constructor(B,V,me){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=me,this.type=2}}e.ReconnectionRunningEvent=U;class x{constructor(B,V,me){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=me,this.type=4}}e.ConnectionGainEvent=x;class M{constructor(B,V,me,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=me,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class H extends p.Disposable{static triggerPermanentFailure(B,V,me){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=me,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||H._permanentFailure}constructor(B,V,me,Z,ne){super(),this._connectionType=B,this._options=V,this.reconnectionToken=me,this.protocol=Z,this._reconnectionFailureIsFatal=ne,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(re=>{const ye=ge(this._connectionType,this.reconnectionToken,!0);re?re.type===0?(this._options.logService.info(`${ye} received socket close event (hadError: ${re.hadError}).`),re.error&&this._options.logService.error(re.error)):(this._options.logService.info(`${ye} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this._options.logService.error(re.event)):this._options.logService.info(`${ye} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(re=>{const ye=ge(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ye} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),H._instances.push(this),this._register((0,p.toDisposable)(()=>{const re=H._instances.indexOf(this);re>=0&&H._instances.splice(re,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(H._permanentFailureMillisSinceLastIncomingData,H._permanentFailureAttempt,H._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const B=ge(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let me=-1;do{me++;const Z=me<V.length?V[me]:V[V.length-1];try{if(Z>0){const re=P(Z);this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,re)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await re}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1)),this._options.logService.info(`${B} resolving connection...`);const ne=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${ne.connectTo}...`),await this._reconnect(ne,o(C)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1));break}catch(ne){if(ne.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ne),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(me>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ne),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ne)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ne);continue}if((ne.code==="ETIMEDOUT"||ne.code==="ENETUNREACH"||ne.code==="ECONNREFUSED"||ne.code==="ECONNRESET")&&ne.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ne);continue}if((0,R.isCancellationError)(ne)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ne);continue}if(ne instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ne),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,v.RemoteAuthorityResolverError.isHandled(ne));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ne),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(B,V,me){this._reconnectionFailureIsFatal?H.triggerPermanentFailure(B,V,me):this._gotoPermanentFailure(B,V,me)}_gotoPermanentFailure(B,V,me){this._onDidStateChange.fire(new M(this.reconnectionToken,B,V,me)),Y(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=H;class j extends H{constructor(B,V,me,Z,ne){super(1,B,Z,ne,!0),this.client=this._register(new k.Client(ne,{remoteAuthority:V,clientId:me},B.ipcLogger))}async _reconnect(B,V){await i(B,V)}}e.ManagementPersistentConnection=j;class fe extends H{constructor(B,V,me,Z,ne){super(2,B,me,Z,!1),this._startArguments=V,this.debugPort=ne}async _reconnect(B,V){await l(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=fe;function Y(G){try{G.acceptDisconnect();const B=G.getSocket();G.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function X(G){if(G&&G.type==="error"){const B=new Error(`Connection error: ${G.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function z(G,B){for(;G.length<B;)G+=" ";return G}function J(G,B){return`[remote-connection][${z(s(G),13)}][${B.substr(0,5)}\u2026]`}function ge(G,B,V){return`${J(G,B)}[${V?"reconnect":"initial"}]`}function le(G,B){return`${ge(B,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function we(G){return`${Date.now()-G} ms`}}),define(Ce[248],De([1,0,3,5]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,F.createDecorator)("remoteSocketFactoryService");class d{constructor(){this.factories={}}register(A,p){return this.factories[A]??=[],this.factories[A].push(p),(0,D.toDisposable)(()=>{const _=this.factories[A]?.indexOf(p);typeof _=="number"&&_>=0&&this.factories[A]?.splice(_,1)})}getSocketFactory(A){return(this.factories[A.type]||[]).find(_=>_.supports(A))}connect(A,p,_,b){const T=this.getSocketFactory(A);if(!T)throw new Error(`No socket factory found for ${A}`);return T.connect(A,p,_,b)}}e.RemoteSocketFactoryService=d}),define(Ce[249],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class D{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(d){try{const R=await this.getValidator();if(R){const A=String(D._nextId++);return this.validators.set(A,R),{id:A,data:R.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,R){if(!d.id)return!0;const A=this.validators.get(d.id);if(!A)return!1;this.validators.delete(d.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.signValue(d)}catch{}return d}}e.AbstractSignService=D}),define(Ce[107],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(Ce[138],De([1,0,249]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class F extends D.AbstractSignService{getValidator(){return this.vsda().then(R=>new R.validator)}signValue(R){return this.vsda().then(A=>new A.signer().sign(R))}vsda(){return new Promise((R,A)=>pe(["vsda"],R,A))}}e.SignService=F}),define(Ce[250],De([1,0,12,47,31]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(_){if(D.platform===2&&/^penguin(\.|$)/i.test(_))return"chromebook"}function A(_,b,T,k,v,y,C,w){const s=Object.create(null);s["common.machineId"]=y,s.sessionID=(0,d.generateUuid)()+Date.now(),s.commitHash=k,s.version=v,s["common.platformVersion"]=(_||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.PlatformToString)(D.platform),s["common.nodePlatform"]=F.platform,s["common.nodeArch"]=T,s["common.product"]=w||"desktop",C&&(s["common.msftInternal"]=C);let o=0;const a=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),D.isLinuxSnap&&(s["common.snap"]="true");const c=R(b);return c&&(s["common.platformDetail"]=c),s}e.resolveCommonProperties=A;function p(_){const b=F.env.USERDNSDOMAIN;if(!b)return!1;const T=b.toLowerCase();return _.some(k=>T===k)}e.verifyMicrosoftInternalDomain=p}),define(Ce[251],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var F;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var d;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(Ce[85],De([1,0,23,18,4,49,66,250,251]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class b{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=b;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class k{async publicLog(l,f,S){}async publicLogError(l,f,S){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,l){return d.Event.debounce(l.onDidChangeConfiguration,(S,I)=>{const E=S?new Set([...S.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:E}},1e3,!0)(S=>{S.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.configurationTelemetry=v;function y(i,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=y;function C(i,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=C;function w(i){const l=i.getValue(_.TELEMETRY_SETTING_ID),f=i.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function s(i){const l={},f={},S={};c(i,S);for(let I in S){I=I.length>150?I.substr(I.length-149):I;const E=S[I];typeof E=="number"?f[I]=E:typeof E=="boolean"?f[I]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${E.length}`),l[I]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(l[I]=E)}return{properties:l,measurements:f}}e.validateTelemetryData=s;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const l=(0,A.getRemoteName)(i);return o.has(l)?l:"other"}e.cleanRemoteAuthority=a;function c(i,l,f=0,S){if(i)for(const I of Object.getOwnPropertyNames(i)){const E=i[I],h=S?S+I:I;Array.isArray(E)?l[h]=(0,D.safeStringify)(E):E instanceof Date?l[h]=E.toISOString():(0,F.isObject)(E)?f<2?c(E,l,f+1,h+"."):l[h]=(0,D.safeStringify)(E):l[h]=E}}function g(i,l){const f=i.msftInternalDomains||[],S=l.getValue("telemetry.internalTesting");return(0,p.verifyMicrosoftInternalDomain)(f)||S}e.isInternalTelemetry=g;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=u;function t(i,l){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const S=[];for(const m of l)for(;;){const P=m.exec(i);if(!P)break;S.push([P.index,m.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(f="";;){const m=E.exec(i);if(!m)break;const P=S.some(([O,N])=>m.index<N&&O<E.lastIndex);!I.test(m[0])&&!P&&(f+=i.substring(h,m.index)+"<REDACTED: user-file-path>",h=E.lastIndex)}return h<i.length&&(f+=i.substr(h)),f}function n(i){if(!i)return i;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of l)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function r(i,l){return(0,D.cloneAndChange)(i,f=>{if(f instanceof b||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=t(S,l);for(const I of l)S=S.replace(I,"");return S=n(S),S}})}e.cleanData=r}),define(Ce[252],De([1,0,15,132,25,12,2,8,47,85]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,D.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=T;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const l=i.manifest?i.manifest.version:i.version,f=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,l,f)}static parse(i){const l=k.exec(i);return l&&l[1]&&l[2]?new v({id:l[1]},l[2],l[4]||void 0):null}constructor(i,l,f="undefined"){this.version=l,this.targetPlatform=f,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(r){const i=y.exec(r);return i&&i[1]?[s(i[1]),i[2]]:[s(r),void 0]}e.getIdAndVersion=C;function w(r,i){return`${r}.${i}`}e.getExtensionId=w;function s(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=s;function o(r,i){return s(w(r??d.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=o;function a(r,i){const l=[],f=S=>{for(const I of l)if(I.some(E=>T(i(E),i(S))))return I;return null};for(const S of r){const I=f(S);I?I.push(S):l.push([S])}return l}e.groupByExtension=a;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=c;function g(r){return{id:new b.TelemetryTrustedValue(r.identifier.id),name:new b.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new d.ExtensionIdentifier("pprice.better-merge");function u(r,i){const l=[],f=i.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const S=f.shift();if(S&&l.every(I=>!T(I.identifier,{id:S}))){const I=r.filter(E=>T(E.identifier,{id:S}));I.length===1&&(l.push(I[0]),f.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=u;async function t(r,i){if(!R.isLinux)return!1;let l;try{l=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){i.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(S))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const l=await t(r,i),f=(0,F.getTargetPlatform)(l?"alpine":R.platform,_.arch);return i.debug("ComputeTargetPlatform:",f),f}e.computeTargetPlatform=n}),define(Ce[253],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function D(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=D;function F(_){return _?[..._.entries()]:[]}e.serializeEnvironmentDescriptionMap=F;function d(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=d;function R(_){return new Map(_??[])}e.deserializeEnvironmentDescriptionMap=R;function A(_){return Array.from(_.entries()).map(b=>[b[0],D(b[1].map),F(b[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function p(_){return new Map(_.map(b=>[b[0],{map:d(b[1]),descriptionMap:R(b[2])}]))}e.deserializeEnvironmentVariableCollections=p}),define(Ce[254],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class D{constructor(d){this._callback=d,this._terminalBufferMap=new Map}dispose(){for(const d of this._terminalBufferMap.values())d.dispose()}startBuffering(d,R,A=5){const p=R(_=>{const b=typeof _=="string"?_:_.data;let T=this._terminalBufferMap.get(d);if(T){T.data.push(b);return}const k=setTimeout(()=>this.flushBuffer(d),A);T={data:[b],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(d),p.dispose()}},this._terminalBufferMap.set(d,T)});return p}stopBuffering(d){this._terminalBufferMap.get(d)?.dispose()}flushBuffer(d){const R=this._terminalBufferMap.get(d);R&&(this._terminalBufferMap.delete(d),this._callback(d,R.data.join("")))}}e.TerminalDataBufferer=D}),define(Ce[255],De([1,0,9,79,59,4,18,2,199,106,42]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(g){function u(t,n){let r=t.defaults;for(;d.ThemeIcon.isThemeIcon(r);){const i=C.getIcon(r.id);if(!i)return;r=i.defaults}return r}g.getDefinition=u})(k||(e.IconContribution=k={}));var v;(function(g){function u(n){return{weight:n.weight,style:n.style,src:n.src.map(r=>({format:r.format,location:r.location.toString()}))}}g.toJSONObject=u;function t(n){const r=i=>(0,A.isString)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.isString)(i.format)&&(0,A.isString)(i.location)))return{weight:r(n.weight),style:r(n.style),src:n.src.map(i=>({format:i.format,location:p.URI.parse(i.location)}))}}g.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class y{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(u,t,n,r){const i=this.iconsById[u];if(i){if(n&&!i.description){i.description=n,this.iconSchema.properties[u].markdownDescription=`${n} $(${u})`;const S=this.iconReferenceSchema.enum.indexOf(u);S!==-1&&(this.iconReferenceSchema.enumDescriptions[S]=n),this._onDidChange.fire()}return i}const l={id:u,description:n,defaults:t,deprecationMessage:r};this.iconsById[u]=l;const f={$ref:"#/definitions/icons"};return r&&(f.deprecationMessage=r),n&&(f.markdownDescription=`${n}: $(${u})`),this.iconSchema.properties[u]=f,this.iconReferenceSchema.enum.push(u),this.iconReferenceSchema.enumDescriptions.push(n||""),this._onDidChange.fire(),{id:u}}deregisterIcon(u){delete this.iconsById[u],delete this.iconSchema.properties[u];const t=this.iconReferenceSchema.enum.indexOf(u);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(u=>this.iconsById[u])}getIcon(u){return this.iconsById[u]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(u,t){const n=this.iconFontsById[u];return n||(this.iconFontsById[u]=t,this._onDidChange.fire(),t)}deregisterIconFont(u){delete this.iconFontsById[u]}getIconFont(u){return this.iconFontsById[u]}toString(){const u=(i,l)=>i.id.localeCompare(l.id),t=i=>{for(;d.ThemeIcon.isThemeIcon(i.defaults);)i=this.iconsById[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(i=>this.iconsById[i]);for(const i of r.filter(l=>!!l.description).sort(u))n.push(`|<i class="${t(i)}"></i>|${i.id}|${d.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of r.filter(l=>!d.ThemeIcon.isThemeIcon(l.defaults)).sort(u))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const C=new y;T.Registry.add(e.Extensions.IconContribution,C);function w(g,u,t,n){return C.registerIcon(g,u,t,n)}e.registerIcon=w;function s(){return C}e.getIconRegistry=s;function o(){const g=(0,F.getCodiconFontCharacters)();for(const u in g){const t="\\"+g[u].toString(16);C.registerIcon(u,{fontCharacter:t})}}o(),e.iconsSchemaId="vscode://schemas/icons";const a=T.Registry.as(b.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,C.getIconSchema());const c=new D.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.widgetClose=w("widget-close",F.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=w("goto-previous-location",F.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=w("goto-next-location",F.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=d.ThemeIcon.modify(F.Codicon.sync,"spin"),e.spinningLoading=d.ThemeIcon.modify(F.Codicon.loading,"spin")}),define(Ce[86],De([1,0,4,49,5,14]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,d.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,d.createDecorator)("sharedTunnelsService");var A;(function(s){s.Http="http",s.Https="https"})(A||(e.TunnelProtocol=A={}));var p;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(p||(e.TunnelPrivacyId=p={}));function _(s){return!!s.forwardPort}e.isTunnelProvider=_;var b;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=v;function y(s,o,a,c){if(a===1)return!1;if(a===2&&v(o)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(g?.length===4&&parseInt(g[1])>=18)return!1}return s<1024}e.isPortPrivileged=y;class C{constructor(o,a,c){this.remoteAddress=o,this.localAddress=a,this._dispose=c,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=C;let w=class{constructor(o,a){this.logService=o,this.configurationService=a,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],a=Array.from(this._tunnels.values());for(const c of a){const g=Array.from(c.values());for(const u of g){const t=await u.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:a}of o.values())await a.then(c=>typeof c!="string"?c?.dispose():void 0);o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,a,c,g,u){this.addTunnelToMap(o,a,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:a,localAddress:c,privacy:g,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,a){(v(o)||k(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(o,a);if(c)return++c.refcount,c.value}openTunnel(o,a,c,g,u,t=!1,n,r){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${c} on local port ${u}.`);const i=this._tunnelProvider??o;if(!i)return;if(a||(a="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.retainOrCreateTunnel(i,a,c,g,u,t,n,r);return l?l.then(f=>{if(f){if(typeof f=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(a,c),f}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(a,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.makeTunnel(f);return(f.tunnelRemoteHost!==a||f.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&f.privacy!==n&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(S),S}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const a=this._tunnels.get(o.tunnelRemoteHost);if(a){const c=a.get(o.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,c))}}}}async tryDisposeTunnel(o,a,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${a}.`);const g=c.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(a),g}}async closeTunnel(o,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${a} `);const c=this._tunnels.get(o);if(c&&c.has(a)){const g=c.get(a);g.refcount=0,await this.tryDisposeTunnel(o,a,g)}}addTunnelToMap(o,a,c){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(a,{refcount:1,value:c})}async removeEmptyOrErrorTunnelFromMap(o,a){const c=this._tunnels.get(o);if(c){const g=c.get(a),u=g?await g.value:void 0;(!u||typeof u=="string")&&c.delete(a),c.size===0&&this._tunnels.delete(o)}}getTunnelFromMap(o,a){const c=[o];k(o)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):v(o)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const g=c.map(u=>this._tunnels.get(u));for(const u of g){const t=u?.get(a);if(t)return t}}canTunnel(o){return!!T(o)}createWithProvider(o,a,c,g,u,t,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${c} on local port ${g}.`);const r=c;this._factoryInProgress.add(r);const i=g===void 0?c:g,l={elevationRequired:u?this.isPortPrivileged(i):!1},f={remoteAddress:{host:a,port:c},localAddressPort:g,privacy:t,public:t?t!==p.Private:void 0,protocol:n},S=o.forwardPort(f,l);return S?(this.addTunnelToMap(a,c,S),S.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),S}};e.AbstractTunnelService=w,e.AbstractTunnelService=w=je([$e(0,R.ILogService),$e(1,F.IConfigurationService)],w)}),define(Ce[256],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Ce[257],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,D.createDecorator)("editSessionIdentityService");var F;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ce[258],De([1,0,17]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function F(_){return _.scheme!==D.Schemas.file&&_.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=F;function d(_){if(_.folders.length)return _.folders.every(b=>F(b.uri))?_.folders[0].uri:void 0;if(_.configuration&&F(_.configuration))return _.configuration}e.getVirtualWorkspaceLocation=d;function R(_){return d(_)?.scheme}e.getVirtualWorkspaceScheme=R;function A(_){return d(_)?.authority}e.getVirtualWorkspaceAuthority=A;function p(_){return d(_)!==void 0}e.isVirtualWorkspace=p}),define(Ce[43],De([1,0,201,16,78,24,2,5,17]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,p.createDecorator)("contextService");function b(i){const l=i;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=b;function T(i){return typeof i?.id=="string"&&!b(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(i,l){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.basename)(i)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const f=i;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.toWorkspaceIdentifier=k;function v(i){const l=i;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=v;function y(i){const l=i;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const f=i;if(f?.configPath)return{id:f.id,configPath:A.URI.revive(f.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=y;var C;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function w(i){const l=i;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=w;function s(i){const l=i;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=s;class o{constructor(l,f,S,I,E){this._id=l,this._transient=S,this._configuration=I,this._ignorePathCasing=E,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=f}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class a{constructor(l,f){this.raw=f,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function c(i){return new a({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=c,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(i,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,l.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function u(i){let l;return A.URI.isUri(i)?l=i:l=i.configuration,l?.scheme===_.Schemas.tmp}e.isTemporaryWorkspace=u,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,l){return!g(i,l)&&!u(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,F.extname)(i):(0,R.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ce[259],De([1,0,51,4,3,24,2,200,131,30,5,14,43,28,256,9,31,15,18]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function g(i){const l=i;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function u(i,l){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:l}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:l}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=u;function t(i,l,f,S,I,E){return{id:i,name:l,location:f,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:E&&I?.useDefaultFlags?.globalState?E.globalStorageHome:(0,R.joinPath)(f,"globalStorage"),settingsResource:E&&I?.useDefaultFlags?.settings?E.settingsResource:(0,R.joinPath)(f,"settings.json"),keybindingsResource:E&&I?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,R.joinPath)(f,"keybindings.json"),tasksResource:E&&I?.useDefaultFlags?.tasks?E.tasksResource:(0,R.joinPath)(f,"tasks.json"),snippetsHome:E&&I?.useDefaultFlags?.snippets?E.snippetsHome:(0,R.joinPath)(f,"snippets"),extensionsResource:E&&I?.useDefaultFlags?.extensions?E.extensionsResource:(0,R.joinPath)(f,"extensions.json"),cacheHome:(0,R.joinPath)(S,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.toUserDataProfile=t;let n=class extends d.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(l,f,S,I){super(),this.environmentService=l,this.fileService=f,this.uriIdentityService=S,this.logService=I,this.enabled=!0,this._onDidChangeProfiles=this._register(new F.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new F.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new F.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new F.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(l){this.enabled!==l&&(this._profilesObject=void 0,this.enabled=l)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const l=this.createDefaultProfile(),f=[l];if(this.enabled)try{for(const E of this.getStoredProfiles()){if(!E.name||!(0,a.isString)(E.name)||!E.location){this.logService.warn("Skipping the invalid stored profile",E.location||E.name);continue}f.push(t((0,R.basename)(E.location),E.name,E.location,this.profilesCacheHome,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},l))}}catch(E){this.logService.error(E)}const S=new y.ResourceMap,I=new Map;if(f.length)try{const E=this.getStoredProfileAssociations();if(E.workspaces)for(const[h,m]of Object.entries(E.workspaces)){const P=A.URI.parse(h),O=f.find(N=>N.id===m);O&&S.set(P,O)}if(E.emptyWindows)for(const[h,m]of Object.entries(E.emptyWindows)){const P=f.find(O=>O.id===m);P&&I.set(h,P)}}catch(E){this.logService.error(E)}this._profilesObject={profiles:f,workspaces:S,emptyWindows:I}}return this._profilesObject}createDefaultProfile(){const l=t("__default__profile__",(0,p.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const f="Temp",S=new RegExp(`${(0,o.escapeRegExpCharacters)(f)}\\s(\\d+)`);let I=0;for(const h of this.profiles){const m=S.exec(h.name),P=m?parseInt(m[1]):0;I=P>I?P:I}const E=`${f} ${I+1}`;return this.createProfile((0,D.hash)((0,s.generateUuid)()).toString(16),E,{transient:!0},l)}async createNamedProfile(l,f,S){return this.createProfile((0,D.hash)((0,s.generateUuid)()).toString(16),l,f,S)}async createProfile(l,f,S,I){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const E=await this.doCreateProfile(l,f,S);return I&&await this.setProfileForWorkspace(I,E),E}async doCreateProfile(l,f,S){if(!(0,a.isString)(f)||!f)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.profileCreationPromises.get(f);return I||(I=(async()=>{try{const E=this.profiles.find(P=>P.name===f||P.id===l);if(E)return E;const h=t(l,f,(0,R.joinPath)(this.profilesHome,l),this.profilesCacheHome,S,this.defaultProfile);await this.fileService.createFolder(h.location);const m=[];return this._onWillCreateProfile.fire({profile:h,join(P){m.push(P)}}),await w.Promises.settled(m),this.updateProfiles([h],[],[]),h}finally{this.profileCreationPromises.delete(f)}})(),this.profileCreationPromises.set(f,I)),I}async updateProfile(l,f){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(I=>I.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);return S=t(S.id,f.name??S.name,S.location,this.profilesCacheHome,{shortName:f.shortName??S.shortName,icon:f.icon===null?void 0:f.icon??S.icon,transient:f.transient??S.isTransient,useDefaultFlags:f.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[S]),S}async removeProfile(l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const f=this.profiles.find(I=>I.id===l.id);if(!f)throw new Error(`Profile '${l.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:f,join(I){S.push(I)}});try{await Promise.allSettled(S)}catch(I){this.logService.error(I)}for(const I of[...this.profilesObject.emptyWindows.keys()])f.id===this.profilesObject.emptyWindows.get(I)?.id&&this.profilesObject.emptyWindows.delete(I);for(const I of[...this.profilesObject.workspaces.keys()])f.id===this.profilesObject.workspaces.get(I)?.id&&this.profilesObject.workspaces.delete(I);this.updateStoredProfileAssociations(),this.updateProfiles([],[f],[]);try{await this.fileService.del(f.cacheHome,{recursive:!0})}catch(I){(0,b.toFileOperationResult)(I)!==1&&this.logService.error(I)}}async setProfileForWorkspace(l,f){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(I=>I.id===f.id);if(!S)throw new Error(`Profile '${f.name}' does not exist`);this.updateWorkspaceAssociation(l,S)}unsetWorkspace(l,f){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(l,void 0,f)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const l=await this.fileService.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(f=>f.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,f.resource))).map(f=>this.fileService.del(f.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const l=this.transientProfilesObject.profiles.filter(f=>!this.isProfileAssociatedToWorkspace(f));await Promise.allSettled(l.map(f=>this.removeProfile(f)))}getProfileForWorkspace(l){const f=this.getWorkspace(l);return A.URI.isUri(f)?this.transientProfilesObject.workspaces.get(f)??this.profilesObject.workspaces.get(f):this.transientProfilesObject.emptyWindows.get(f)??this.profilesObject.emptyWindows.get(f)}getWorkspace(l){return(0,v.isSingleFolderWorkspaceIdentifier)(l)?l.uri:(0,v.isWorkspaceIdentifier)(l)?l.configPath:l.id}isProfileAssociatedToWorkspace(l){return!!([...this.transientProfilesObject.emptyWindows.values()].some(f=>this.uriIdentityService.extUri.isEqual(f.location,l.location))||[...this.transientProfilesObject.workspaces.values()].some(f=>this.uriIdentityService.extUri.isEqual(f.location,l.location))||[...this.profilesObject.emptyWindows.values()].some(f=>this.uriIdentityService.extUri.isEqual(f.location,l.location))||[...this.profilesObject.workspaces.values()].some(f=>this.uriIdentityService.extUri.isEqual(f.location,l.location)))}updateProfiles(l,f,S){const I=[...this.profiles,...l],E=[];this.transientProfilesObject.profiles=[];for(let h of I)h.isDefault||f.some(m=>h.id===m.id)||(h=S.find(m=>h.id===m.id)??h,h.isTransient?this.transientProfilesObject.profiles.push(h):E.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.saveStoredProfiles(E),this._profilesObject=void 0,this.triggerProfilesChanges(l,f,S)}triggerProfilesChanges(l,f,S){this._onDidChangeProfiles.fire({added:l,removed:f,updated:S,all:this.profiles})}updateWorkspaceAssociation(l,f,S){S=f?.isTransient?!0:S,S||this.updateWorkspaceAssociation(l,void 0,!0);const I=this.getWorkspace(l),E=S?this.transientProfilesObject:this.profilesObject;A.URI.isUri(I)?(E.workspaces.delete(I),f&&E.workspaces.set(I,f)):(E.emptyWindows.delete(I),f&&E.emptyWindows.set(I,f)),S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const l={};for(const[S,I]of this.profilesObject.workspaces.entries())l[S.toString()]=I.id;const f={};for(const[S,I]of this.profilesObject.emptyWindows.entries())f[S.toString()]=I.id;this.saveStoredProfileAssociations({workspaces:l,emptyWindows:f}),this._profilesObject=void 0}migrateStoredProfileAssociations(l){const f={},S=this.createDefaultProfile();if(l.workspaces)for(const[E,h]of Object.entries(l.workspaces)){const m=A.URI.parse(h);f[E]=this.uriIdentityService.extUri.isEqual(m,S.location)?S.id:this.uriIdentityService.extUri.basename(m)}const I={};if(l.emptyWindows)for(const[E,h]of Object.entries(l.emptyWindows)){const m=A.URI.parse(h);I[E]=this.uriIdentityService.extUri.isEqual(m,S.location)?S.id:this.uriIdentityService.extUri.basename(m)}return{workspaces:f,emptyWindows:I}}getStoredProfiles(){return[]}saveStoredProfiles(l){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(l){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=n,e.UserDataProfilesService=n=je([$e(0,_.IEnvironmentService),$e(1,b.IFileService),$e(2,C.IUriIdentityService),$e(3,k.ILogService)],n);class r extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(l){this.storedProfiles=l}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(l){this.storedProfileAssociations=l}}e.InMemoryUserDataProfilesService=r}),define(Ce[260],De([1,0,9,4,3,53,18,184,5,259]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,_.createDecorator)("storageService");var T;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var k;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var v;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function y(a){const c=a.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=y;class C extends d.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(c={flushInterval:C.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new F.PauseableEmitter),this._onDidChangeTarget=this._register(new F.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new F.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new d.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(c,g,u){return F.Event.filter(this._onDidChangeValue.event,t=>t.scope===c&&(g===void 0||t.key===g),u)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,d.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,g){const{key:u,external:t}=g;if(u===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:u,target:this.getKeyTargets(c)[u],external:t})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,g,u){return this.getStorage(g)?.get(c,u)}getBoolean(c,g,u){return this.getStorage(g)?.getBoolean(c,u)}getNumber(c,g,u){return this.getStorage(g)?.getNumber(c,u)}getObject(c,g,u){return this.getStorage(g)?.getObject(c,u)}storeAll(c,g){this.withPausedEmitters(()=>{for(const u of c)this.store(u.key,u.value,u.scope,u.target,g)})}store(c,g,u,t,n=!1){if((0,A.isUndefinedOrNull)(g)){this.remove(c,u,n);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,u,t),this.getStorage(u)?.set(c,g,n)})}remove(c,g,u=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(c,g,void 0),this.getStorage(g)?.delete(c,u)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,g){const u=[],t=this.getKeyTargets(c);for(const n of Object.keys(t))t[n]===g&&u.push(n);return u}updateKeyTarget(c,g,u,t=!1){const n=this.getKeyTargets(g);typeof u=="number"?n[c]!==u&&(n[c]=u,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(n),t)):typeof n[c]=="number"&&(delete n[c],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(n),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const g=this.getStorage(c);return g?y(g):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=T.NONE){this._onWillSaveState.fire({reason:c});const g=this.getStorage(-1),u=this.getStorage(0),t=this.getStorage(1);switch(c){case T.NONE:await D.Promises.settled([g?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await D.Promises.settled([g?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return o(c,g,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(c){return await this.flush(),this.getStorage(c)?.optimize()}async switch(c,g){return this.emitWillSaveState(T.NONE),(0,b.isUserDataProfile)(c)?this.switchToProfile(c,g):this.switchToWorkspace(c,g)}canSwitchProfile(c,g){return!(c.id===g.id||w(g)&&w(c))}switchData(c,g,u){this.withPausedEmitters(()=>{const t=new Set;for(const[n,r]of c)t.add(n),g.get(n)!==r&&this.emitDidChangeValue(u,{key:n,external:!0});for(const[n]of g.items)t.has(n)||this.emitDidChangeValue(u,{key:n,external:!0})})}}e.AbstractStorageService=C;function w(a){return a.isDefault||!!a.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=w;class s extends C{constructor(){super(),this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(c){return!1}}e.InMemoryStorageService=s;async function o(a,c,g,u,t,n){const r=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,l=new Map;a.forEach((P,O)=>{i.set(O,P),l.set(O,r(P))});const f=new Map,S=new Map;c.forEach((P,O)=>{f.set(O,P),S.set(O,r(P))});const I=new Map,E=new Map;g.forEach((P,O)=>{I.set(O,P),E.set(O,r(P))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const h=[];if(i.forEach((P,O)=>{h.push({key:O,value:P})}),console.table(h),console.groupEnd(),console.log(l),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];f.forEach((O,N)=>{P.push({key:N,value:O})}),console.table(P),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const m=[];I.forEach((P,O)=>{m.push({key:O,value:P})}),console.table(m),console.groupEnd(),console.log(E)}e.logStorage=o}),define(Ce[87],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class D{static{this.enableDebugLogging=!1}constructor(d){this.id=d,this._data=new Map,this._idPool=1}add(d){const R=this._idPool++;return this._data.set(R,d),this.logDebugInfo(),R}get(d,R){return this._data.has(d)?this._data.get(d)[R]:void 0}delete(d){this._data.delete(d),this.logDebugInfo()}logDebugInfo(){D.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=D}),define(Ce[54],De([1,0,17,24,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(D.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(p=>{const _=this._providerInfo.get(p.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(p,_){_===null?this._providerInfo.delete(p.scheme):this._providerInfo.set(p.scheme,_)}isFreeScheme(p){return!this._providerInfo.has(p)&&!this._systemSchemes.has(p)}getCapabilities(p){return this._providerInfo.get(p)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,d.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,D.createDecorator)("IExtHostInitDataService")}),define(Ce[261],De([1,0,206,14,241,26]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends d.LogService{constructor(_,b,T){const k=T.remote.isRemote?"remoteexthost":_?"workerexthost":"exthost",v=T.remote.isRemote?(0,D.localize)(0,null):_?(0,D.localize)(1,null):(0,D.localize)(2,null);super(b.createLogger(k,{name:v}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=je([$e(1,F.ILoggerService),$e(2,R.IExtHostInitDataService)],A)}),define(Ce[262],De([1,0,9]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,p,_){this._deferredPromises=new Map,this._id=A,this._shared=p,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(b=>(this._value=b,this)),this._storageListener=this._storage.onDidChangeStorage(b=>{b.shared===this._shared&&b.key===this._id&&(this._value=b.value)}),this._scheduler=new D.RunOnceScheduler(()=>{const b=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of b.values())T.complete()}catch(T){for(const k of b.values())k.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,p){let _=this._value[A];return typeof _>"u"&&(_=p),_}update(A,p){this._value[A]=p;const _=this._deferredPromises.get(A);if(_!==void 0)return _.p;const b=new D.DeferredPromise;return this._deferredPromises.set(A,b),this._scheduler.isScheduled()||this._scheduler.schedule(),b.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class d extends F{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,p){super(A.identifier.value,!0,p),this._extension=A}}e.ExtensionGlobalMemento=d}),define(Ce[263],De([1,0,4,2]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class d{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new D.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new D.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,p,_,b){const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(p.value,_,b);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(A,p){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptDirty(p)}$acceptModelSaved(A){const p=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A));this._onDidSaveNotebookDocument.fire(p.apiNotebook)}}e.ExtHostNotebookDocuments=d}),define(Ce[20],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,D.createDecorator)("IExtHostRpcService");class F{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=F}),define(Ce[264],De([1,0,25,4]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class d{#e;constructor(A,p){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=D.ExtensionIdentifier.toKey(A.identifier),this.#e=p,this.#e.onDidChangePassword(_=>{_.extensionId===this._id&&this._onDidChange.fire({key:_.key})})}get(A){return this.#e.get(this._id,A)}store(A,p){return this.#e.store(this._id,A,p)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=d}),define(Ce[67],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,D.createDecorator)("IURITransformerService");class F{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(Ce[265],De([1,0,22]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(_){let b=this.buffers.indexOf(_);return b<0&&(b=this.buffers.length,this.buffers.push(_)),b}}function d(p,_){if(_.serializeBuffersForPostMessage){const b=new F,k=JSON.stringify(p,(y,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(C)};if(ArrayBuffer.isView(C)){const w=R(C);if(w)return{$$vscode_array_buffer_reference$$:!0,index:b.add(C.buffer),view:{type:w,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),v=b.buffers.map(y=>{const C=new Uint8Array(y);return D.VSBuffer.wrap(C)});return{message:k,buffers:v}}else return{message:JSON.stringify(p),buffers:[]}}e.serializeWebviewMessage=d;function R(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(p,_){const b=_.map(v=>{const y=new ArrayBuffer(v.byteLength);return new Uint8Array(y).set(v.buffer),y}),T=_.length?(v,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const C=y,{index:w}=C,s=b[w];if(C.view)switch(C.view.type){case 1:return new Int8Array(s,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return y}:void 0;return{message:JSON.parse(p,T),arrayBuffers:b}}e.deserializeWebviewMessage=A}),define(Ce[266],De([1,0,267,374,375,60,2,14,376]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const b=!1;function T(c,g,u,t,n,r){const i=r.environment.useHostProxy,l=typeof i=="boolean"?i:!r.remote.isRemote,f={resolveProxy:E=>c.resolveProxy(E),lookupProxyAuthorization:s.bind(void 0,t,n,g,{},r.remote.isRemote),getProxyURL:()=>g.getConfiguration("http").get("proxy"),getProxySupport:()=>g.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>v(g),getSystemCertificatesV2:()=>y(g),log:(E,h,...m)=>{switch(E){case _.LogLevel.Trace:t.trace(h,...m);break;case _.LogLevel.Debug:t.debug(h,...m);break;case _.LogLevel.Info:t.info(h,...m);break;case _.LogLevel.Warning:t.warn(h,...m);break;case _.LogLevel.Error:t.error(h,...m);break;case _.LogLevel.Critical:t.error(h,...m);break;case _.LogLevel.Off:break;default:P(E,h,m);break}function P(O,N,...L){t.error("Unknown log level",O),t.error(N,...L)}},getLogLevel:()=>{const E=t.getLevel();switch(E){case p.LogLevel.Trace:return _.LogLevel.Trace;case p.LogLevel.Debug:return _.LogLevel.Debug;case p.LogLevel.Info:return _.LogLevel.Info;case p.LogLevel.Warning:return _.LogLevel.Warning;case p.LogLevel.Error:return _.LogLevel.Error;case p.LogLevel.Off:return _.LogLevel.Off;default:return h(E)}function h(m){return t.error("Unknown log level",m),_.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,addCertificates:[],env:process.env},S=(0,_.createProxyResolver)(f),I=k(f,S);return w(u,I)}e.connectProxyResolver=T;function k(c,g){return{http:Object.assign(D,(0,_.createHttpPatch)(c,D,g)),https:Object.assign(F,(0,_.createHttpPatch)(c,F,g)),net:Object.assign(R,(0,_.createNetPatch)(c,R)),tls:Object.assign(d,(0,_.createTlsPatch)(c,d))}}function v(c){const g=c.getConfiguration("http");return!g.get("experimental.systemCertificatesV2",b)&&!!g.get("systemCertificates")}function y(c){const g=c.getConfiguration("http");return!!g.get("experimental.systemCertificatesV2",b)&&!!g.get("systemCertificates")}const C=new Map;function w(c,g){return c.getExtensionPathIndex().then(u=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,l,f){if(i==="net")return g.net;if(i==="tls")return g.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const S=u.findSubstr(A.URI.file(l.filename));let I=C.get(S);if(I||C.set(S,I={}),!I[i]){const E=g[i];I[i]={...E}}return I[i]}})}async function s(c,g,u,t,n,r,i,l){const f=t[r];i&&(t[r]=i),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${f}`);const S=i||f,I=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(a(g,I,n),I.some(E=>/^(Negotiate|Kerberos)( |$)/i.test(E))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const E=await new Promise((N,L)=>{pe(["kerberos"],N,L)}),h=new URL(r),m=u.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${h.hostname}`:`HTTP@${h.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${m}`),"Negotiate "+await(await E.initializeClient(m)).step("")}catch(E){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",E)}}let o=!1;function a(c,g,u){o||!g.length||(o=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:g.map(t=>t.split(" ")[0]).join(","),extensionHostType:u?"remote":"local"}))}}),define(Ce[268],De([1,0,128]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function F(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(R){return new D.URITransformer(F(R))}e.createURITransformer=d}),define(Ce[139],De([1,0,216,18,2,3,5,42,30,17,46,176,38]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var C;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function w(le){const we=le;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.isEditorPaneWithSelection=w;function s(le,we,G){for(const B of G.visibleEditorPanes)if(B.group.id===we&&le.matches(B.input))return B.getViewState()}e.findViewStateForEditor=s;function o(le){if(f(le))return!1;const we=le;return d.URI.isUri(we?.resource)}e.isResourceEditorInput=o;function a(le){if(f(le))return!1;const we=le;return we?.original!==void 0&&we.modified!==void 0}e.isResourceDiffEditorInput=a;function c(le){if(f(le)||a(le))return!1;const we=le;return we?.primary!==void 0&&we.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function g(le){if(f(le))return!1;const we=le;return we?we.resource===void 0||we.resource.scheme===b.Schemas.untitled||we.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function u(le){if(f(le))return!1;const we=le;return d.URI.isUri(we?.base?.resource)&&d.URI.isUri(we?.input1?.resource)&&d.URI.isUri(we?.input2?.resource)&&d.URI.isUri(we?.result?.resource)}e.isResourceMergeEditorInput=u;var t;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(we,G){let B=this.mapIdToSaveSource.get(we);return B||(B={source:we,label:G},this.mapIdToSaveSource.set(we,B)),B.source}getSourceLabel(we){return this.mapIdToSaveSource.get(we)?.label??we}}e.SaveSourceRegistry=new r;var i;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class l extends R.Disposable{}e.AbstractEditorInput=l;function f(le){return le instanceof l}e.isEditorInput=f;function S(le){const we=le;return d.URI.isUri(we?.preferredResource)}function I(le){const we=le;return f(we?.primary)&&f(we?.secondary)}e.isSideBySideEditorInput=I;function E(le){const we=le;return f(we?.modified)&&f(we?.original)}e.isDiffEditorInput=E;function h(le,we,G,B,V){return ge(B,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const me={...G,limits:{size:Number.MAX_VALUE}};le.openEditor(we,me)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>V.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=h;function m(le){return f(le?.editor)}e.isEditorInputWithOptions=m;function P(le){const we=le;return m(le)&&we?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function O(le){const we=le;return typeof we?.groupId=="number"&&f(we.editor)}e.isEditorIdentifier=O;var N;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var L;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var U;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class x{getOriginalUri(we,G){if(!we)return;if(u(we))return e.EditorResourceAccessor.getOriginalUri(we.result,G);if(G?.supportSideBySide){const{primary:V,secondary:me}=this.getSideEditors(we);if(V&&me){if(G?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===U.ANY)return this.getOriginalUri(V,{filterByScheme:G.filterByScheme})??this.getOriginalUri(me,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===U.PRIMARY?V:me}}if(a(we)||c(we)||u(we))return;const B=S(we)?we.preferredResource:we.resource;return!B||!G||!G.filterByScheme?B:this.filterUri(B,G.filterByScheme)}getSideEditors(we){return I(we)||c(we)?{primary:we.primary,secondary:we.secondary}:E(we)||a(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,G){if(!we)return;if(u(we))return e.EditorResourceAccessor.getCanonicalUri(we.result,G);if(G?.supportSideBySide){const{primary:V,secondary:me}=this.getSideEditors(we);if(V&&me){if(G?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===U.ANY)return this.getCanonicalUri(V,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===U.PRIMARY?V:me}}if(a(we)||c(we)||u(we))return;const B=we.resource;return!B||!G||!G.filterByScheme?B:this.filterUri(B,G.filterByScheme)}filterUri(we,G){if(Array.isArray(G)){if(G.some(B=>we.scheme===B))return we}else if(G===we.scheme)return we}}var M;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(M||(e.EditorCloseMethod=M={}));function H(le,we,G,B){if(!le.isSticky(we))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return G===M.MOUSE||G===M.KEYBOARD;case"mouse":return G===M.MOUSE;case"keyboard":return G===M.KEYBOARD}return!1}e.preventEditorClose=H,e.EditorResourceAccessor=new x;var j;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(j||(e.CloseDirection=j={}));class fe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(we){const G=this.instantiationService=we.get(A.IInstantiationService);for(const[B,V]of this.editorSerializerConstructors)this.createEditorSerializer(B,V,G);this.editorSerializerConstructors.clear()}createEditorSerializer(we,G,B){const V=B.createInstance(G);this.editorSerializerInstances.set(we,V)}registerFileEditorFactory(we){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=we}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(we,G){if(this.editorSerializerConstructors.has(we)||this.editorSerializerInstances.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.instantiationService?this.createEditorSerializer(we,G,this.instantiationService):this.editorSerializerConstructors.set(we,G),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(we),this.editorSerializerInstances.delete(we)})}getEditorSerializer(we){return this.editorSerializerInstances.get(typeof we=="string"?we:we.typeId)}}p.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function Y(le,we,G){return!le||!le.length?[]:await Promise.all(le.map(async B=>{const V=d.URI.revive(B.fileUri);if(!V){G.info("Cannot resolve the path because it is not valid.",B);return}if(!await we.canHandleResource(V)){G.info("Cannot resolve the path because it cannot be handled",B);return}let Z=B.exists,ne=B.type;if(typeof Z!="boolean"||typeof ne!="number")try{ne=(await we.stat(V)).isDirectory?_.FileType.Directory:_.FileType.Unknown,Z=!0}catch(ye){G.error(ye),Z=!1}if(!Z&&B.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",B);return}if(ne===_.FileType.Directory){G.info("Cannot resolve the path because it is a directory",B);return}const re={...B.options,pinned:!0};return Z?{resource:V,options:re}:{resource:V,options:re,forceUntitled:!0}}))}e.pathsToEditors=Y;var X;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function z(le){const we=le;if(!we)return!1;const G=we;if(G.modified)return z(G.modified);const B=we;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.isTextEditorViewState=z;function J(le){return(0,T.isErrorWithActions)(le)}e.isEditorOpenError=J;function ge(le,we,G){const B=(0,T.createErrorWithActions)(le,we);return B.forceMessage=G?.forceMessage,B.forceSeverity=G?.forceSeverity,B.allowDialog=G?.allowDialog,B}e.createEditorOpenError=ge}),define(Ce[269],De([1,0,4,217,5,3,28,42,19,23,79,255]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,k.registerIcon)("default-view-icon",T.Codicon.window,(0,F.localize)(0,null));var v;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.ViewContainerLocations=[0,1,2];function C(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=C;class w extends R.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new D.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new D.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,_.flatten)([...this.viewContainers.values()])}registerViewContainer(r,i,l){const f=this.get(r.id);if(f)return f;const S=r;return S.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.getOrSet)(this.viewContainers,i,[]).push(S),l?.isDefault&&this.defaultViewContainers.push(S),this._onDidRegister.fire({viewContainer:S,viewContainerLocation:i}),S}deregisterViewContainer(r){for(const i of this.viewContainers.keys()){const l=this.viewContainers.get(i),f=l?.indexOf(r);if(f!==-1){l?.splice(f,1),l.length===0&&this.viewContainers.delete(i),this._onDidDeregister.fire({viewContainer:r,viewContainerLocation:i});return}}}get(r){return this.all.filter(i=>i.id===r)[0]}getViewContainers(r){return[...this.viewContainers.get(r)||[]]}getViewContainerLocation(r){return[...this.viewContainers.keys()].filter(i=>this.getViewContainers(i).filter(l=>l?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.defaultViewContainers.find(i=>this.getViewContainerLocation(i)===r)}}p.Registry.add(v.ViewContainersRegistry,new w);var s;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(s||(e.ViewContentGroups=s={}));function o(n,r){const i=n.group??s.More,l=r.group??s.More;return i!==l?i.localeCompare(l):(n.order??5)-(r.order??5)}class a extends R.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new D.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new D.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new D.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new D.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(r,i){this.registerViews2([{views:r,viewContainer:i}])}registerViews2(r){r.forEach(({views:i,viewContainer:l})=>this.addViews(i,l)),this._onViewsRegistered.fire(r)}deregisterViews(r,i){const l=this.removeViews(r,i);l.length&&this._onViewsDeregistered.fire({views:l,viewContainer:i})}moveViews(r,i){for(const l of this._views.keys())if(l!==i){const f=this.removeViews(r,l);f.length&&(this.addViews(f,i),this._onDidChangeContainer.fire({views:f,from:l,to:i}))}}getViews(r){return this._views.get(r)||[]}getView(r){for(const i of this._viewContainers){const l=(this._views.get(i)||[]).filter(f=>f.id===r)[0];if(l)return l}return null}getViewContainer(r){for(const i of this._viewContainers)if((this._views.get(i)||[]).filter(f=>f.id===r)[0])return i;return null}registerViewWelcomeContent(r,i){return this._viewWelcomeContents.add(r,i),this._onDidChangeViewWelcomeContent.fire(r),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(r,i),this._onDidChangeViewWelcomeContent.fire(r)})}registerViewWelcomeContent2(r,i){const l=new Map;for(const[f,S]of i)this._viewWelcomeContents.add(r,S),l.set(f,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(r,S),this._onDidChangeViewWelcomeContent.fire(r)}));return this._onDidChangeViewWelcomeContent.fire(r),l}getViewWelcomeContent(r){const i=[];return this._viewWelcomeContents.forEach(r,l=>i.push(l)),i.sort(o)}addViews(r,i){let l=this._views.get(i);l||(l=[],this._views.set(i,l),this._viewContainers.push(i));for(const f of r){if(this.getView(f.id)!==null)throw new Error((0,F.localize)(1,null,f.id));l.push(f)}}removeViews(r,i){const l=this._views.get(i);if(!l)return[];const f=[],S=[];for(const I of l)r.includes(I)?f.push(I):S.push(I);return f.length&&(S.length?this._views.set(i,S):(this._views.delete(i),this._viewContainers.splice(this._viewContainers.indexOf(i),1))),f}}p.Registry.add(v.ViewsRegistry,new a),e.IViewsService=(0,d.createDecorator)("viewsService"),e.IViewDescriptorService=(0,d.createDecorator)("viewDescriptorService");var c;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.TreeItemCollapsibleState=g={}));class u{constructor(r,i){this.resolved=!1,this._hasResolve=!1,(0,b.mixin)(this,r),this._hasResolve=!!i,this.resolve=async l=>{if(i&&!this.resolved){const f=await i(l);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}l.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=u;class t extends Error{constructor(r){super((0,F.localize)(2,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Ce[140],De([1,0,4,9,218]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new D.Emitter,this._onExit=new D.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(p){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=p}onEvent(p){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=p}onRequest(p){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=p}sendResponse(p){p.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.internalSend("response",p)}sendRequest(p,_,b,T){const k={command:p};if(_&&Object.keys(_).length>0&&(k.arguments=_),this.internalSend("request",k),typeof T=="number"){const v=setTimeout(()=>{clearTimeout(v);const y=this.pendingRequests.get(k.seq);if(y){this.pendingRequests.delete(k.seq);const C={type:"response",seq:0,request_seq:k.seq,success:!1,command:p,message:(0,d.localize)(0,null,T,p)};y(C)}},T)}return b&&this.pendingRequests.set(k.seq,b),k.seq}acceptMessage(p){this.messageCallback?this.messageCallback(p):(this.queue.push(p),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(p,_){return p.type!=="event"||_.type!=="event"}async processQueue(){let p;for(;this.queue.length;){if((!p||this.needsTaskBoundaryBetween(this.queue[0],p))&&await(0,F.timeout)(0),p=this.queue.shift(),!p)return;switch(p.type){case"event":this.eventCallback?.(p);break;case"request":this.requestCallback?.(p);break;case"response":{const _=p,b=this.pendingRequests.get(_.request_seq);b&&(this.pendingRequests.delete(_.request_seq),b(_));break}}}}internalSend(p,_){_.type=p,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const p=new Map;this.pendingRequests.forEach((_,b)=>p.set(b,_)),await(0,F.timeout)(500),p.forEach((_,b)=>{_({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(b)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(Ce[270],De([1,0,219,41,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new F.RawContextKey("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new F.RawContextKey("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new F.RawContextKey("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new F.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:D.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new F.RawContextKey("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new F.RawContextKey("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new F.RawContextKey("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new F.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new F.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new F.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new F.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new F.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new F.RawContextKey("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new F.RawContextKey("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new F.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new F.RawContextKey("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new F.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new F.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new F.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new F.RawContextKey("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new F.RawContextKey("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new F.RawContextKey("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new F.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new F.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new F.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new F.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new F.RawContextKey("stepBackSupported",!1,{type:"boolean",description:D.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new F.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new F.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new F.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new F.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new F.RawContextKey("breakpointsExist",!1,{type:"boolean",description:D.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new F.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:D.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new F.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new F.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new F.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new F.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new F.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new F.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new F.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new F.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new F.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new F.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new F.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:D.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new F.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new F.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:D.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new F.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:D.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new F.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new F.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new F.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new F.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(50,null)});const R=v=>D.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(52,null)};var A;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(A||(e.State=A={}));function p(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=p;var _;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(_||(e.MemoryRangeType=_={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var b;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var T;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,d.createDecorator)("debugService");var k;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ce[271],De([1,0,15,2,16,23,17,34,21,19]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function k(I,E,h){return I.replace(T,function(m,P){return E&&P.length>0&&P[0]!=="_"?m:h&&h.hasOwnProperty(P)?h[P]:m})}e.formatPII=k;function v(I){const E={};for(const h of Object.keys(I))h.startsWith("!")||(E[h]=I[h]);return E}e.filterExceptionsFromTelemetry=v;function y(I){return I.configuration.request==="attach"&&!C(I)&&(!I.parentSession||y(I.parentSession))}e.isSessionAttach=y;function C(I){let E=I.configuration.type;if(E)return E==="vslsShare"&&(E=I.configuration.adapterProxy.configuration.type),(0,D.equalsIgnoreCase)(E,"extensionhost")||(0,D.equalsIgnoreCase)(E,"pwa-extensionhost")?I:I.parentSession?C(I.parentSession):void 0}e.getExtensionHostDebugSession=C;function w(I){return I.type&&(I.label||I.program||I.runtime)}e.isDebuggerMainContribution=w;function s(I,E,h){let m,P=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=O.exec(I);){const L=N.index+1,U=L+N[0].length;if(L<=E&&U>=h){m=N[0],P=L;break}}if(m){const L=/\w+/g;let U=null;for(;(U=L.exec(m))&&!(U.index+1+P+U[0].length>=h););U&&(m=m.substring(0,L.lastIndex))}return m?{start:P,end:P+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=s;async function o(I,E,h,m){if(I.evaluatableExpressionProvider.has(E)){const P=I.evaluatableExpressionProvider.ordered(E),O=(0,b.coalesce)(await Promise.all(P.map(async N=>{try{return await N.provideEvaluatableExpression(E,h,m??_.CancellationToken.None)}catch{return}})));if(O.length>0){let N=O[0].expression;const L=O[0].range;return N||(N=E.getLineContent(h.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const P=E.getLineContent(h.lineNumber),{start:O,end:N}=s(P,h.column,h.column),L=P.substring(O-1,N);return{matchingExpression:L,range:new p.Range(h.lineNumber,O,h.lineNumber,O+L.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(I){return!!(I&&I.match(a))}e.isUri=c;function g(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(c(I.path))return F.URI.parse(I.path);if((0,d.isAbsolute)(I.path))return F.URI.file(I.path)}return I.path}function u(I){if(typeof I.path=="object"){const E=F.URI.revive(I.path);if(E)return E.scheme===A.Schemas.file?E.fsPath:E.toString()}return I.path}function t(I,E){const h=E?g:u,m=(0,R.deepClone)(I);return r(m,(P,O)=>{P&&O&&(O.path=h(O))}),m}e.convertToDAPaths=t;function n(I,E){const h=E?g:u,m=(0,R.deepClone)(I);return r(m,(P,O)=>{!P&&O&&(O.path=h(O))}),m}e.convertToVSCPaths=n;function r(I,E){switch(I.type){case"event":{const h=I;switch(h.event){case"output":E(!1,h.body.source);break;case"loadedSource":E(!1,h.body.source);break;case"breakpoint":E(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=I;switch(h.command){case"setBreakpoints":E(!0,h.arguments.source);break;case"breakpointLocations":E(!0,h.arguments.source);break;case"source":E(!0,h.arguments.source);break;case"gotoTargets":E(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(m=>E(!1,m));break;default:break}break}case"response":{const h=I;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(m=>E(!1,m.source));break;case"loadedSources":h.body.sources.forEach(m=>E(!1,m));break;case"scopes":h.body.scopes.forEach(m=>E(!1,m.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(m=>E(!1,m.source));break;case"setBreakpoints":h.body.breakpoints.forEach(m=>E(!1,m.source));break;case"disassemble":h.body?.instructions.forEach(P=>E(!1,P.location));break;default:break}break}}}function i(I){return I.filter(E=>!E.presentation?.hidden).sort((E,h)=>E.presentation?h.presentation?E.presentation.group?h.presentation.group?E.presentation.group!==h.presentation.group?E.presentation.group.localeCompare(h.presentation.group):l(E.presentation.order,h.presentation.order):-1:h.presentation.group?1:l(E.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=i;function l(I,E){return typeof I!="number"?typeof E!="number"?0:1:typeof E!="number"?-1:I-E}async function f(I,E){const h=I.getValue("debug.saveBeforeStart",{overrideIdentifier:E.activeTextEditorLanguageId});if(h!=="none"&&(await E.saveAll(),h==="allEditorsInActiveGroup")){const m=E.activeEditorPane;m&&m.input.resource?.scheme===A.Schemas.untitled&&await E.save({editor:m.input,groupId:m.group.id})}await I.reloadConfiguration()}e.saveAllBeforeDebugStart=f;const S=(I,E)=>!I||!E?I===E:I.name===E.name&&I.path===E.path&&I.sourceReference===E.sourceReference;e.sourcesEqual=S}),define(Ce[272],De([1,0,48,60,23,16,12,15,29,220,140]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends T.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(o,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,o.on("data",c=>this.handleData(c))}sendMessage(o){if(this.outputStream){const a=JSON.stringify(o);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${k.TWO_CRLF}${a}`,"utf8")}}handleData(o){for(this.rawData=Buffer.concat([this.rawData,o]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+a))}continue}}else{const a=this.rawData.indexOf(k.TWO_CRLF);if(a!==-1){const g=this.rawData.toString("utf8",0,a).split(k.HEADER_LINESEPARATOR);for(const u of g){const t=u.split(k.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(a+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k;class v extends k{startSession(){return new Promise((o,a)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),o(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",g=>{c?this._onError.fire(g):a(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=v;class y extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return F.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",o)}}e.SocketDebugAdapter=y;class C extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return F.createConnection(this.adapterServer.path,o)}}e.NamedPipeDebugAdapter=C;class w extends k{constructor(o,a){super(),this.adapterExecutable=o,this.debugType=a}async startSession(){const o=this.adapterExecutable.command,a=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(o)if(R.isAbsolute(o)){if(!await _.Promises.exists(o))throw new Error(b.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.debugType));let g=process.env;if(c.env&&Object.keys(c.env).length>0&&(g=d.mixin(d.deepClone(process.env),c.env)),o==="node")if(Array.isArray(a)&&a.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:g,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const n=D.fork(a[0],a.slice(1),t);if(!n.pid)throw new Error(b.localize(2,null,a[0]));this.serverProcess=n}else throw new Error(b.localize(3,null));else{const u={env:g};c.cwd&&(u.cwd=c.cwd),this.serverProcess=D.spawn(o,a,u)}this.serverProcess.on("error",u=>{this._onError.fire(u)}),this.serverProcess.on("exit",(u,t)=>{this._onExit.fire(u)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stdin.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((o,a)=>{const c=D.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,u,t){if(g)return a(g)});c.on("exit",o),c.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(o,a){if(!o)return;const c=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?c.runtime=R.join(a,o.runtime):c.runtime=o.runtime),o.runtimeArgs&&(c.runtimeArgs=o.runtimeArgs),o.program&&(R.isAbsolute(o.program)?c.program=o.program:c.program=R.join(a,o.program)),o.args&&(c.args=o.args);const g=o;return g.win&&(c.win=w.extract(g.win,a)),g.winx86&&(c.winx86=w.extract(g.winx86,a)),g.windows&&(c.windows=w.extract(g.windows,a)),g.osx&&(c.osx=w.extract(g.osx,a)),g.linux&&(c.linux=w.extract(g.linux,a)),c}static platformAdapterExecutable(o,a){let c=Object.create(null);a=a.toLowerCase();for(const i of o)if(i.contributes){const l=i.contributes.debuggers;l&&l.length>0&&l.filter(f=>typeof f.type=="string"&&p.equalsIgnoreCase(f.type,a)).forEach(f=>{const S=w.extract(f,i.extensionLocation.fsPath);c=d.mixin(c,S,i.isBuiltin)})}let g;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=c.winx86||c.win||c.windows:A.isWindows?g=c.win||c.windows:A.isMacintosh?g=c.osx:A.isLinux&&(g=c.linux),g=g||c;const u=g.program||c.program,t=g.args||c.args,n=g.runtime||c.runtime,r=g.runtimeArgs||c.runtimeArgs;if(n)return{type:"executable",command:n,args:(r||[]).concat(typeof u=="string"?[u]:[]).concat(t||[])};if(u)return{type:"executable",command:u,args:t||[]}}}e.ExecutableDebugAdapter=w}),define(Ce[273],De([1,0,48,32,12]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(b,T){return new Promise((k,v)=>{let y="";const C=D.spawn(b,T);C.pid&&C.stdout.on("data",w=>{y+=w.toString()}),C.on("error",w=>{v(w)}),C.on("close",w=>{k(y)})})}async function A(b){if(b)if(d.isWindows){const T=await new Promise((k,v)=>{pe(["@vscode/windows-process-tree"],k,v)});return new Promise(k=>{T.getProcessTree(b,v=>{k(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(b)]).then(T=>{const k=T.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},T=>!0);return Promise.resolve(!0)}e.hasChildProcesses=A;var p;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(p||(p={}));function _(b,T,k,v,y){b=b.trim().toLowerCase();let C;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?C=1:b.indexOf("cmd.exe")>=0?C=0:b.indexOf("bash")>=0?C=2:d.isWindows?C=0:C=2;let w,s=" ";switch(C){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),v){const o=(0,F.getDriveLetter)(v);o&&(s+=`${o}:; `),s+=`cd ${w(v)}; `}if(y)for(const o in y){const a=y[o];a===null?s+=`Remove-Item env:${o}; `:s+=`\${env:${o}}='${a}'; `}if(T.length>0){const o=T.shift(),a=k?o:w(o);s+=a[0]==="'"?`& ${a} `:`${a} `;for(const c of T)s+=c==="<"||c===">"||k?c:w(c),s+=" "}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>o.includes(a))||o.length===0?`"${o}"`:o),v){const o=(0,F.getDriveLetter)(v);o&&(s+=`${o}: && `),s+=`cd ${w(v)} && `}if(y){s+='cmd /C "';for(const o in y){let a=y[o];a===null?s+=`set "${o}=" && `:(a=a.replace(/[&^|<>]/g,c=>`^${c}`),s+=`set "${o}=${a}" && `)}}for(const o of T)s+=o==="<"||o===">"||k?o:w(o),s+=" ";y&&(s+='"');break;case 2:{w=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const o=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(v&&(s+=`cd ${w(v)} ; `),y){s+="/usr/bin/env";for(const a in y){const c=y[a];c===null?s+=` -u ${o(a)}`:s+=` ${o(`${a}=${c}`)}`}s+=" "}for(const a of T)s+=a==="<"||a===">"||k?a:w(a),s+=" ";break}}return s}e.prepareCommand=_}),define(Ce[108],De([1,0,22,35,50,98,17,16,12,41]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var v;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var y;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var C;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var w;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var s;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var o;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var a;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var c;(function(M){M.scheme=A.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${H.join("")}]+`),fe=7;function Y(we,G){const B=G.toString(fe),me=`${B.length<H.length?H[B.length-1]:"z"}${B}s${(0,D.encodeBase64)(D.VSBuffer.fromString(we.scheme),!0,!0)}`;return we.with({scheme:M.scheme,fragment:me})}M.generate=Y;function X(we){if(we.scheme!==M.scheme)return;const G=we.fragment.indexOf("s");if(G<0)return;const B=parseInt(we.fragment.substring(0,G).replace(j,""),fe),V=(0,D.decodeBase64)(we.fragment.substring(G+1)).toString();if(!isNaN(B))return{handle:B,notebook:we.with({scheme:V,fragment:null})}}M.parse=X;function z(we,G){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}M.generateCellOutputUri=z;function J(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!G)return;const B=G[1]&&G[1]!==""?G[1]:void 0,V=G[2];return{outputId:B,notebook:we.with({scheme:V||A.Schemas.file,fragment:null})}}M.parseCellOutputUri=J;function ge(we,G,B){return M.generate(we,G).with({scheme:B})}M.generateCellPropertyUri=ge;function le(we,G){if(we.scheme===G)return M.parse(we.with({scheme:M.scheme}))}M.parseCellPropertyUri=le})(c||(e.CellUri=c={}));const g=M=>_.isWindows?M.replace(/\//g,"\\"):M;class u{constructor(H=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=j,this.order=[...new Set(H)].map(fe=>({pattern:fe,matches:F.parse(g(fe))}))}sort(H){const j=new Map(d.Iterable.map(H,Y=>[Y,g(Y)]));let fe=[];for(const{matches:Y}of this.order)for(const[X,z]of j)if(Y(z)){fe.push(X),j.delete(X);break}return j.size&&(fe=fe.concat([...j.keys()].sort((Y,X)=>this.defaultOrder.indexOf(Y)-this.defaultOrder.indexOf(X)))),fe}prioritize(H,j){const fe=this.findIndex(H);if(fe===-1){this.order.unshift({pattern:H,matches:F.parse(g(H))});return}const Y=new Set(j.map(z=>this.findIndex(z,fe)));Y.delete(-1);const X=Array.from(Y).sort();this.order.splice(fe+1,0,...X.map(z=>this.order[z]));for(let z=X.length-1;z>=0;z--)this.order.splice(X[z],1)}toArray(){return this.order.map(H=>H.pattern)}findIndex(H,j=this.order.length){const fe=g(H);for(let Y=0;Y<j;Y++)if(this.order[Y].matches(fe))return Y;return-1}}e.MimeTypeDisplayOrder=u;function t(M,H,j,fe=(Y,X)=>Y===X){const Y=[];function X(ge,le,we){if(le===0&&we.length===0)return;const G=Y[Y.length-1];G&&G.start+G.deleteCount===ge?(G.deleteCount+=le,G.toInsert.push(...we)):Y.push({start:ge,deleteCount:le,toInsert:we})}let z=0,J=0;for(;;){if(z===M.length){X(z,0,H.slice(J));break}if(J===H.length){X(z,M.length-z,[]);break}const ge=M[z],le=H[J];if(fe(ge,le)){z+=1,J+=1;continue}j(le)?(X(z,1,[]),z+=1):(X(z,0,[le]),J+=1)}return Y}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtLineBoundary","none");var n;(function(M){M.default="default",M.option="option"})(n||(e.NotebookEditorPriority=n={}));function r(M){const H=M;return!!((typeof H.include=="string"||F.isRelativePattern(H.include))&&(typeof H.exclude=="string"||F.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=r;function i(M,H,j){if(Array.isArray(M.viewType)&&M.viewType.indexOf(H)>=0||M.viewType===H)return!0;if(M.filenamePattern){const fe=r(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,Y=r(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(F.match(fe,(0,p.basename)(j.fsPath).toLowerCase()))return!(Y&&F.match(Y,(0,p.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var l;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class f{static{this._prefix="notebook/"}static create(H){return`${f._prefix}${H}`}static parse(H){if(H.startsWith(f._prefix))return H.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f;function S(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.isTextStreamMime=S;const I=new TextDecoder;function E(M){const H=[];let j=!1;for(const z of M)(H.length===0||j)&&(H.push(z),j=!0);let fe=P(H);const Y=D.VSBuffer.concat(H.map(z=>D.VSBuffer.wrap(z))),X=x(Y);return fe=fe||X.byteLength!==Y.byteLength,{data:X,didCompression:fe}}e.compressOutputItemStreams=E,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const h=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(M=>M.charCodeAt(0)),m=10;function P(M){let H=!1;return M.forEach((j,fe)=>{if(fe===0||j.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const Y=M[fe-1],X=j.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(X[0]===h[0]&&X[1]===h[1]&&X[2]===h[2]){const z=Y.lastIndexOf(m);if(z===-1)return;H=!0,M[fe-1]=Y.subarray(0,z),M[fe]=j.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),H}function O(M){let H=M;do M=H,H=M.replace(/[^\n]\x08/gm,"");while(H.length<M.length);return M}function N(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const H=M.match(/^(.*)\r+/m)[1];let j=M.match(/\r+(.*)$/m)[1];j=j+H.slice(j.length,H.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return M}const L="\b".charCodeAt(0),U="\r".charCodeAt(0);function x(M){return!M.buffer.includes(L)&&!M.buffer.includes(U)?M:D.VSBuffer.fromString(N(O(I.decode(M.buffer))))}}),define(Ce[7],De([1,0,19,8,80,28,98,15,18,2,31,25,30,65,108]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C){"use strict";var w,s,o,a,c,g,u,t,n,r,i,l,f,S,I,E,h,m;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(q){return Object.assign(q,{apply:function(...be){if(be.length===0)return Reflect.construct(q,[]);{const Ae=be.length===1?[]:be[1];return Reflect.construct(q,Ae,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(q,[]);{const[Ae,...Ke]=be;return Reflect.construct(q,Ke,Ae.constructor)}}})}var O;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(q){q[q.TerminalCommand=0]="TerminalCommand",q[q.Opener=1]="Opener",q[q.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let L=w=class{static from(...W){let be=W;return new w(function(){if(be){for(const Ae of be)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();be=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=L,e.Disposable=L=w=je([P],L);let U=s=class{static Min(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isBefore(be)&&(be=Ke)}return be}static Max(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isAfter(be)&&(be=Ke)}return be}static isPosition(W){if(!W)return!1;if(W instanceof s)return!0;const{line:be,character:Ae}=W;return typeof be=="number"&&typeof Ae=="number"}static of(W){if(W instanceof s)return W;if(this.isPosition(W))return new s(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,be){if(W<0)throw(0,F.illegalArgument)("line must be non-negative");if(be<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=W,this._character=be}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,be=0){if(W===null||be===null)throw(0,F.illegalArgument)();let Ae;return typeof W>"u"?Ae=0:typeof W=="number"?Ae=W:(Ae=typeof W.lineDelta=="number"?W.lineDelta:0,be=typeof W.characterDelta=="number"?W.characterDelta:0),Ae===0&&be===0?this:new s(this.line+Ae,this.character+be)}with(W,be=this.character){if(W===null||be===null)throw(0,F.illegalArgument)();let Ae;return typeof W>"u"?Ae=this.line:typeof W=="number"?Ae=W:(Ae=typeof W.line=="number"?W.line:this.line,be=typeof W.character=="number"?W.character:this.character),Ae===this.line&&be===this.character?this:new s(Ae,be)}toJSON(){return{line:this.line,character:this.character}}};e.Position=U,e.Position=U=s=je([P],U);let x=o=class{static isRange(W){return W instanceof o?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,be,Ae,Ke){let tt,ct;if(typeof W=="number"&&typeof be=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(tt=new U(W,be),ct=new U(Ae,Ke)):U.isPosition(W)&&U.isPosition(be)&&(tt=U.of(W),ct=U.of(be)),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this._start=tt,this._end=ct):(this._start=ct,this._end=tt)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const be=U.Max(W.start,this._start),Ae=U.Min(W.end,this._end);if(!be.isAfter(Ae))return new o(be,Ae)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const be=U.Min(W.start,this._start),Ae=U.Max(W.end,this.end);return new o(be,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,be=this.end){if(W===null||be===null)throw(0,F.illegalArgument)();let Ae;return W?U.isPosition(W)?Ae=W:(Ae=W.start||this.start,be=W.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&be.isEqual(this.end)?this:new o(Ae,be)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=o=je([P],x);let M=a=class extends x{static isSelection(W){return W instanceof a?!0:W?x.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,be,Ae,Ke){let tt,ct;if(typeof W=="number"&&typeof be=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(tt=new U(W,be),ct=new U(Ae,Ke)):U.isPosition(W)&&U.isPosition(be)&&(tt=U.of(W),ct=U.of(be)),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct),this._anchor=tt,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=M,e.Selection=M=a=je([P],M);const H=q=>{if(typeof q!="string"||q.length===0||!/^[0-9A-Za-z_\-]+$/.test(q))throw(0,F.illegalArgument)("connectionToken")};class j{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be,Ae){if(typeof W!="string"||W.length===0)throw(0,F.illegalArgument)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,F.illegalArgument)("port");typeof Ae<"u"&&H(Ae),this.host=W,this.port=Math.round(be),this.connectionToken=Ae}}e.ResolvedAuthority=j;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be){this.makeConnection=W,this.connectionToken=be,typeof be<"u"&&H(be)}}e.ManagedResolvedAuthority=fe;class Y extends Error{static NotAvailable(W,be){return new Y(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(W){return new Y(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,be=y.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(W),this._message=W,this._code=be,this._detail=Ae,Object.setPrototypeOf(this,Y.prototype)}}e.RemoteAuthorityResolverError=Y;var X;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var z;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(z||(e.EnvironmentVariableMutatorType=z={}));let J=c=class{static isTextEdit(W){return W instanceof c?!0:W?x.isRange(W)&&typeof W.newText=="string":!1}static replace(W,be){return new c(W,be)}static insert(W,be){return c.replace(new x(W,W),be)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const be=new c(new x(new U(0,0),new U(0,0)),"");return be.newEol=W,be}get range(){return this._range}set range(W){if(W&&!x.isRange(W))throw(0,F.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,F.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,F.illegalArgument)("newEol");this._newEol=W}constructor(W,be){this._range=W,this._newText=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=J,e.TextEdit=J=c=je([P],J);let ge=g=class{static isNotebookCellEdit(W){return W instanceof g?!0:W?Zt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,be){return new g(W,be)}static insertCells(W,be){return new g(new Zt(W,W),be)}static deleteCells(W){return new g(W,[])}static updateCellMetadata(W,be){const Ae=new g(new Zt(W,W),[]);return Ae.newCellMetadata=be,Ae}static updateNotebookMetadata(W){const be=new g(new Zt(0,0),[]);return be.newNotebookMetadata=W,be}constructor(W,be){this.range=W,this.newCells=be}};e.NotebookEdit=ge,e.NotebookEdit=ge=g=je([P],ge);class le{static isSnippetTextEdit(W){return W instanceof le?!0:W?x.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,be){return new le(W,be)}static insert(W,be){return le.replace(new x(W,W),be)}constructor(W,be){this.range=W,this.snippet=be}}e.SnippetTextEdit=le;var we;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,be,Ae,Ke){this._edits.push({_type:1,from:W,to:be,options:Ae,metadata:Ke})}createFile(W,be,Ae){this._edits.push({_type:1,from:void 0,to:W,options:be,metadata:Ae})}deleteFile(W,be,Ae){this._edits.push({_type:1,from:W,to:void 0,options:be,metadata:Ae})}replaceNotebookMetadata(W,be,Ae){this._edits.push({_type:3,metadata:Ae,uri:W,edit:{editType:5,metadata:be},notebookMetadata:be})}replaceNotebookCells(W,be,Ae,Ke){const tt=be.start,ct=be.end;(tt!==ct||Ae.length>0)&&this._edits.push({_type:5,uri:W,index:tt,count:ct-tt,cells:Ae,metadata:Ke})}replaceNotebookCellMetadata(W,be,Ae,Ke){this._edits.push({_type:3,metadata:Ke,uri:W,edit:{editType:3,index:be,metadata:Ae}})}replace(W,be,Ae,Ke){this._edits.push({_type:2,uri:W,edit:new J(be,Ae),metadata:Ke})}insert(W,be,Ae,Ke){this.replace(W,new x(be,be),Ae,Ke)}delete(W,be,Ae){this.replace(W,be,"",Ae)}has(W){return this._edits.some(be=>be._type===2&&be.uri.toString()===W.toString())}set(W,be){if(be)for(const Ae of be){if(!Ae)continue;let Ke,tt;Array.isArray(Ae)?(Ke=Ae[0],tt=Ae[1]):Ke=Ae,ge.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(W,Ke.range.start,Ke.newCellMetadata,tt):Ke.newNotebookMetadata?this.replaceNotebookMetadata(W,Ke.newNotebookMetadata,tt):this.replaceNotebookCells(W,Ke.range,Ke.newCells,tt):le.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:tt}):this._edits.push({_type:2,uri:W,edit:Ke,metadata:tt})}else{for(let Ae=0;Ae<this._edits.length;Ae++){const Ke=this._edits[Ae];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this._edits[Ae]=void 0);break}}(0,D.coalesceInPlace)(this._edits)}}get(W){const be=[];for(const Ae of this._edits)Ae._type===2&&Ae.uri.toString()===W.toString()&&be.push(Ae.edit);return be}entries(){const W=new R.ResourceMap;for(const be of this._edits)if(be._type===2){let Ae=W.get(be.uri);Ae||(Ae=[be.uri,[]],W.set(be.uri,Ae)),Ae[1].push(be.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=G,e.WorkspaceEdit=G=je([P],G);let B=u=class{static isSnippetString(W){return W instanceof u?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=u._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,be=this._tabstop++){if(typeof W=="function"){const Ae=new u;Ae._tabstop=this._tabstop,W(Ae),this._tabstop=Ae._tabstop,W=Ae.value}else W=u._escape(W);return this.value+="${",this.value+=be,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,be=this._tabstop++){const Ae=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(W,be){if(typeof be=="function"){const Ae=new u;Ae._tabstop=this._tabstop,be(Ae),this._tabstop=Ae._tabstop,be=Ae.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.SnippetString=B,e.SnippetString=B=u=je([P],B);var V;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var me;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let Z=t=class{static isLocation(W){return W instanceof t?!0:W?x.isRange(W.range)&&b.URI.isUri(W.uri):!1}constructor(W,be){if(this.uri=W,be)if(x.isRange(be))this.range=x.of(be);else if(U.isPosition(be))this.range=new x(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Z,e.Location=Z=t=je([P],Z);let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&x.isRange(W.location.range)&&b.URI.isUri(W.location.uri):!1}constructor(W,be){this.location=W,this.message=be}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.location.range.isEqual(be.location.range)&&W.location.uri.toString()===be.location.uri.toString()}};e.DiagnosticRelatedInformation=ne,e.DiagnosticRelatedInformation=ne=je([P],ne);let re=class{constructor(W,be,Ae=me.Error){if(!x.isRange(W))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=W,this.message=be,this.severity=Ae}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.severity===be.severity&&W.code===be.code&&W.severity===be.severity&&W.source===be.source&&W.range.isEqual(be.range)&&(0,D.equals)(W.tags,be.tags)&&(0,D.equals)(W.relatedInformation,be.relatedInformation,ne.isEqual)}};e.Diagnostic=re,e.Diagnostic=re=je([P],re);let ye=class{constructor(W,be){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=be}};e.Hover=ye,e.Hover=ye=je([P],ye);var oe;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let de=class{constructor(W,be=oe.Text){this.range=W,this.kind=be}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.DocumentHighlight=de,e.DocumentHighlight=de=je([P],de);var ee;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var ue;(function(q){q[q.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let ve=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,be,Ae,Ke,tt){this.name=W,this.kind=be,this.containerName=tt,typeof Ae=="string"&&(this.containerName=Ae),Ke instanceof Z?this.location=Ke:Ae instanceof x&&(this.location=new Z(Ke,Ae)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ve,e.SymbolInformation=ve=n=je([P],ve);let ke=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(r.validate)}constructor(W,be,Ae,Ke,tt){this.name=W,this.detail=be,this.kind=Ae,this.range=Ke,this.selectionRange=tt,this.children=[],r.validate(this)}};e.DocumentSymbol=ke,e.DocumentSymbol=ke=r=je([P],ke);var $;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})($||(e.CodeActionTriggerKind=$={}));let K=class{constructor(W,be){this.title=W,this.kind=be}};e.CodeAction=K,e.CodeAction=K=je([P],K);let ie=class{static{i=this}static{this.sep="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};e.CodeActionKind=ie,e.CodeActionKind=ie=i=je([P],ie),ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorMove=ie.Refactor.append("move"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll"),ie.Notebook=ie.Empty.append("notebook");let se=class{constructor(W,be){if(this.range=W,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=se,e.SelectionRange=se=je([P],se);class Q{constructor(W,be,Ae,Ke,tt,ct){this.kind=W,this.name=be,this.detail=Ae,this.uri=Ke,this.range=tt,this.selectionRange=ct}}e.CallHierarchyItem=Q;class he{constructor(W,be){this.fromRanges=be,this.from=W}}e.CallHierarchyIncomingCall=he;class Se{constructor(W,be){this.fromRanges=be,this.to=W}}e.CallHierarchyOutgoingCall=Se;var Ue;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let We=class{constructor(W,be){this.range=W,this.command=be}get isResolved(){return!!this.command}};e.CodeLens=We,e.CodeLens=We=je([P],We);let Ze=l=class{#e;static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,be=!1){this.#e=new d.MarkdownString(W,{supportThemeIcons:be})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,be){return this.#e.appendCodeblock(be??"",W),this}};e.MarkdownString=Ze,e.MarkdownString=Ze=l=je([P],Ze);let Qe=class{constructor(W,be){this.label=W,this.documentation=be}};e.ParameterInformation=Qe,e.ParameterInformation=Qe=je([P],Qe);let it=class{constructor(W,be){this.label=W,this.documentation=be,this.parameters=[]}};e.SignatureInformation=it,e.SignatureInformation=it=je([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=et,e.SignatureHelp=et=je([P],et);var Te;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(Te||(e.SignatureHelpTriggerKind=Te={}));var Oe;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let ze=class{constructor(W){this.value=W}};e.InlayHintLabelPart=ze,e.InlayHintLabelPart=ze=je([P],ze);let Re=class{constructor(W,be,Ae){this.position=W,this.label=be,this.kind=Ae}};e.InlayHint=Re,e.InlayHint=Re=je([P],Re);var Xe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var ce;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var ae;(function(q){q[q.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let Ie=class{constructor(W,be){this.label=W,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ie,e.CompletionItem=Ie=je([P],Ie);let He=class{constructor(W=[],be=!1){this.items=W,this.isIncomplete=be}};e.CompletionList=He,e.CompletionList=He=je([P],He);let Be=class{constructor(W,be,Ae){this.insertText=W,this.range=be,this.command=Ae}};e.InlineSuggestion=Be,e.InlineSuggestion=Be=je([P],Be);let Ye=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.InlineSuggestionList=Ye,e.InlineSuggestionList=Ye=je([P],Ye);var rt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var at;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(at||(e.StatusBarAlignment=at={}));function vt(q,W){return`${k.ExtensionIdentifier.toKey(q)}.${W}`}e.asStatusBarItemIdentifier=vt;var Ct;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Ct||(e.TextEditorLineNumbersStyle=Ct={}));var Xt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var Vt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var Et;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Bt;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Bt||(e.TextDocumentChangeReason=Bt={}));var Nt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(q){function W(be){switch(be){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(Et||(e.TextEditorSelectionChangeKind=Et={}));var $t;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})($t||(e.SyntaxTokenType=$t={})),function(q){function W(be){switch(be){case q.Other:return"other";case q.Comment:return"comment";case q.String:return"string";case q.RegEx:return"regex"}return"other"}q.toString=W}($t||(e.SyntaxTokenType=$t={}));let Tt=class{constructor(W,be){if(be&&!b.URI.isUri(be))throw(0,F.illegalArgument)("target");if(!x.isRange(W)||W.isEmpty)throw(0,F.illegalArgument)("range");this.range=W,this.target=be}};e.DocumentLink=Tt,e.DocumentLink=Tt=je([P],Tt);let At=class{constructor(W,be,Ae,Ke){this.red=W,this.green=be,this.blue=Ae,this.alpha=Ke}};e.Color=At,e.Color=At=je([P],At);let Ut=class{constructor(W,be){if(be&&!(be instanceof At))throw(0,F.illegalArgument)("color");if(!x.isRange(W)||W.isEmpty)throw(0,F.illegalArgument)("range");this.range=W,this.color=be}};e.ColorInformation=Ut,e.ColorInformation=Ut=je([P],Ut);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.illegalArgument)("label");this.label=W}};e.ColorPresentation=Wt,e.ColorPresentation=Wt=je([P],Wt);var jt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var zt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(zt||(e.SourceControlInputBoxValidationType=zt={}));var Ht;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(Ht||(e.TerminalExitReason=Ht={}));class ot{constructor(W,be,Ae){if(this.startIndex=W,this.length=be,this.tooltip=Ae,typeof W!="number"||W<0)throw(0,F.illegalArgument)("startIndex");if(typeof be!="number"||be<1)throw(0,F.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ot;class ft{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=ft;class Rt{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Rt;var Lt;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Lt||(e.TerminalLocation=Lt={}));class kt{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.illegalArgument)("options")}}e.TerminalProfile=kt;var ht;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ht||(e.TaskRevealKind=ht={}));var _t;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let Dt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(W){switch(W){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(W,be){if(this.label=be,typeof W!="string"||typeof be!="string")throw(0,F.illegalArgument)("name");this._id=W}get id(){return this._id}};e.TaskGroup=Dt,e.TaskGroup=Dt=f=je([P],Dt);function Ft(q){let W="";for(let be=0;be<q.length;be++)W+=q[be].replace(/,/g,",,")+",";return W}let Ge=class{constructor(W,be,Ae){if(typeof W!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=W,be!==void 0&&(Array.isArray(be)?(this._args=be,this._options=Ae):this._options=be)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,F.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const be of this._args)W.push(be);return Ft(W)}};e.ProcessExecution=Ge,e.ProcessExecution=Ge=je([P],Ge);let Le=class{constructor(W,be,Ae){if(this._args=[],Array.isArray(be)){if(!W)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.illegalArgument)("command");this._command=W,this._args=be,this._options=Ae}else{if(typeof W!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=W,this._options=be}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const be of this._args)W.push(typeof be=="string"?be:be.value);return Ft(W)}};e.ShellExecution=Le,e.ShellExecution=Le=je([P],Le);var Fe;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var Pe;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Pe||(e.TaskScope=Pe={}));class te{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=te;let Me=class{static{S=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(W,be,Ae,Ke,tt,ct){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof be=="string"?(this._name=this.name=be,this._source=this.source=Ae,this.execution=Ke,dt=tt,this.__deprecated=!0):be===Pe.Global||be===Pe.Workspace?(this.target=be,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=tt,dt=ct):(this.target=be,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=tt,dt=ct),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof te?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const be=this._definition.type;(S.EmptyType===be||S.ProcessType===be||S.ShellType===be||S.ExtensionCallbackType===be)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};e.Task=Me,e.Task=Me=S=je([P],Me);var Ve;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(Ve||(e.ProgressLocation=Ve={}));var Je;(function(q){function W(be){const Ae=be;return(0,_.isNumber)(Ae.value)?Ae.tooltip&&!(0,_.isString)(Ae.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ae.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ae.value),!1)}q.isViewBadge=W})(Je||(e.ViewBadge=Je={}));let qe=I=class{static isTreeItem(W,be){const Ae=W;if(Ae.checkboxState!==void 0){const Ke=(0,_.isNumber)(Ae.checkboxState)?Ae.checkboxState:(0,_.isObject)(Ae.checkboxState)&&(0,_.isNumber)(Ae.checkboxState.state)?Ae.checkboxState.state:void 0,tt=!(0,_.isNumber)(Ae.checkboxState)&&(0,_.isObject)(Ae.checkboxState)?Ae.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==pt.Checked&&Ke!==pt.Unchecked||tt!==void 0&&!(0,_.isString)(tt))return console.log("INVALID tree item, invalid checkboxState",Ae.checkboxState),!1}if(W instanceof I)return!0;if(Ae.label!==void 0&&!(0,_.isString)(Ae.label)&&!Ae.label?.label)return console.log("INVALID tree item, invalid label",Ae.label),!1;if(Ae.id!==void 0&&!(0,_.isString)(Ae.id))return console.log("INVALID tree item, invalid id",Ae.id),!1;if(Ae.iconPath!==void 0&&!(0,_.isString)(Ae.iconPath)&&!b.URI.isUri(Ae.iconPath)&&(!Ae.iconPath||!(0,_.isString)(Ae.iconPath.id))){const Ke=Ae.iconPath;if(!Ke||!(0,_.isString)(Ke.light)&&!b.URI.isUri(Ke.light)&&!(0,_.isString)(Ke.dark)&&!b.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ae.iconPath),!1}return Ae.description!==void 0&&!(0,_.isString)(Ae.description)&&typeof Ae.description!="boolean"?(console.log("INVALID tree item, invalid description",Ae.description),!1):Ae.resourceUri!==void 0&&!b.URI.isUri(Ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ae.resourceUri),!1):Ae.tooltip!==void 0&&!(0,_.isString)(Ae.tooltip)&&!(Ae.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Ae.tooltip),!1):Ae.command!==void 0&&!Ae.command.command?(console.log("INVALID tree item, invalid command",Ae.command),!1):Ae.collapsibleState!==void 0&&Ae.collapsibleState<nt.None&&Ae.collapsibleState>nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ae.collapsibleState),!1):Ae.contextValue!==void 0&&!(0,_.isString)(Ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ae.contextValue),!1):Ae.accessibilityInformation!==void 0&&!Ae.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ae.accessibilityInformation),!1):!0}constructor(W,be=nt.None){this.collapsibleState=be,b.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.TreeItem=qe,e.TreeItem=qe=I=je([P],qe);var nt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(nt||(e.TreeItemCollapsibleState=nt={}));var pt;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let Pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.DataTransferItem=Pt,e.DataTransferItem=Pt=je([P],Pt);class wt extends Pt{}e.InternalDataTransferItem=wt;class ut extends wt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.InternalFileDataTransferItem=ut;class gt{constructor(W,be,Ae,Ke){this.name=W,this.uri=be,this._itemId=Ae,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=gt;let St=class{#e=new Map;constructor(W){for(const[be,Ae]of W??[]){const Ke=this.#e.get(this.#t(be));Ke?Ke.push(Ae):this.#e.set(this.#t(be),[Ae])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,be){this.#e.set(this.#t(W),[be])}forEach(W,be){for(const[Ae,Ke]of this.#e)for(const tt of Ke)W.call(be,tt,Ae,this)}*[Symbol.iterator](){for(const[W,be]of this.#e)for(const Ae of be)yield[W,Ae]}#t(W){return W.toLowerCase()}};e.DataTransfer=St,e.DataTransfer=St=je([P],St);let mi=class{constructor(W){this.insertText=W}};e.DocumentDropEdit=mi,e.DocumentDropEdit=mi=je([P],mi);let qt=class{constructor(W,be){this.label=be,this.insertText=W}};e.DocumentPasteEdit=qt,e.DocumentPasteEdit=qt=je([P],qt);let Qt=class{constructor(W,be){this.id=W,this.color=be}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.ThemeIcon=Qt,e.ThemeIcon=Qt=je([P],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let si=class{constructor(W){this.id=W}};e.ThemeColor=si,e.ThemeColor=si=je([P],si);var _i;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(_i||(e.ConfigurationTarget=_i={}));let It=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=b.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,be){if(typeof W!="string"&&(!W||!b.URI.isUri(W)&&!b.URI.isUri(W.uri)))throw(0,F.illegalArgument)("base");if(typeof be!="string")throw(0,F.illegalArgument)("pattern");typeof W=="string"?this.baseUri=b.URI.file(W):b.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=It,e.RelativePattern=It=je([P],It);const Qi=new WeakMap;function ln(q,W){Qi.set(q,W)}e.setBreakpointId=ln;let bt=class{constructor(W,be,Ae,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof be=="string"&&(this.condition=be),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=Qi.get(this)??(0,T.generateUuid)()),this._id}};e.Breakpoint=bt,e.Breakpoint=bt=je([P],bt);let gi=class extends bt{constructor(W,be,Ae,Ke,tt){if(super(be,Ae,Ke,tt),W===null)throw(0,F.illegalArgument)("location");this.location=W}};e.SourceBreakpoint=gi,e.SourceBreakpoint=gi=je([P],gi);let pi=class extends bt{constructor(W,be,Ae,Ke,tt){super(be,Ae,Ke,tt),this.functionName=W}};e.FunctionBreakpoint=pi,e.FunctionBreakpoint=pi=je([P],pi);let oi=class extends bt{constructor(W,be,Ae,Ke,tt,ct,dt){if(super(Ke,tt,ct,dt),!be)throw(0,F.illegalArgument)("dataId");this.label=W,this.dataId=be,this.canPersist=Ae}};e.DataBreakpoint=oi,e.DataBreakpoint=oi=je([P],oi);let Ci=class{constructor(W,be,Ae){this.command=W,this.args=be||[],this.options=Ae}};e.DebugAdapterExecutable=Ci,e.DebugAdapterExecutable=Ci=je([P],Ci);let Di=class{constructor(W,be){this.port=W,this.host=be}};e.DebugAdapterServer=Di,e.DebugAdapterServer=Di=je([P],Di);let Ot=class{constructor(W){this.path=W}};e.DebugAdapterNamedPipeServer=Ot,e.DebugAdapterNamedPipeServer=Ot=je([P],Ot);let vi=class{constructor(W){this.implementation=W}};e.DebugAdapterInlineImplementation=vi,e.DebugAdapterInlineImplementation=vi=je([P],vi);let Ii=class{constructor(W,be,Ae){this.session=W,this.threadId=be,this.frameId=Ae}};e.StackFrameFocus=Ii,e.StackFrameFocus=Ii=je([P],Ii);let ai=class{constructor(W,be){this.session=W,this.threadId=be}};e.ThreadFocus=ai,e.ThreadFocus=ai=je([P],ai);let ci=class{constructor(W,be){this.range=W,this.expression=be}};e.EvaluatableExpression=ci,e.EvaluatableExpression=ci=je([P],ci);var lt;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let ki=class{constructor(W,be){this.range=W,this.text=be}};e.InlineValueText=ki,e.InlineValueText=ki=je([P],ki);let Yt=class{constructor(W,be,Ae=!0){this.range=W,this.variableName=be,this.caseSensitiveLookup=Ae}};e.InlineValueVariableLookup=Yt,e.InlineValueVariableLookup=Yt=je([P],Yt);let ii=class{constructor(W,be){this.range=W,this.expression=be}};e.InlineValueEvaluatableExpression=ii,e.InlineValueEvaluatableExpression=ii=je([P],ii);let Ei=class{constructor(W,be){this.frameId=W,this.stoppedLocation=be}};e.InlineValueContext=Ei,e.InlineValueContext=Ei=je([P],Ei);var Yi;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Yi||(e.FileChangeType=Yi={}));let Pi=E=class extends Error{static FileExists(W){return new E(W,v.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(W){return new E(W,v.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(W){return new E(W,v.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(W){return new E(W,v.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(W){return new E(W,v.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(W){return new E(W,v.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}constructor(W,be=v.FileSystemProviderErrorCode.Unknown,Ae){super(b.URI.isUri(W)?W.toString(!0):W),this.code=Ae?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,be),Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}};e.FileSystemError=Pi,e.FileSystemError=Pi=E=je([P],Pi);let Ti=class{constructor(W,be,Ae){this.start=W,this.end=be,this.kind=Ae}};e.FoldingRange=Ti,e.FoldingRange=Ti=je([P],Ti);var Ai;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Ai||(e.FoldingRangeKind=Ai={}));var Ji;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var Ri;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Ri||(e.CommentMode=Ri={}));var li;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(li||(e.CommentState=li={}));var Zi;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(Zi||(e.CommentThreadState=Zi={}));class Li{constructor(W,be=[]){this.tokenTypes=W,this.tokenModifiers=be}}e.SemanticTokensLegend=Li;function Fi(q){return typeof q>"u"||(0,_.isStringArray)(q)}class Oi{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let be=0,Ae=W.tokenTypes.length;be<Ae;be++)this._tokenTypeStrToInt.set(W.tokenTypes[be],be);for(let be=0,Ae=W.tokenModifiers.length;be<Ae;be++)this._tokenModifierStrToInt.set(W.tokenModifiers[be],be)}}push(W,be,Ae,Ke,tt){if(typeof W=="number"&&typeof be=="number"&&typeof Ae=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded(W,be,Ae,Ke,tt);if(x.isRange(W)&&typeof be=="string"&&Fi(Ae))return this._push(W,be,Ae);throw(0,F.illegalArgument)()}_push(W,be,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(be))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,tt=W.start.character,ct=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(be);let xt=0;if(Ae)for(const Kt of Ae){if(!this._tokenModifierStrToInt.has(Kt))throw new Error("`tokenModifier` is not in the provided legend");const Jt=this._tokenModifierStrToInt.get(Kt);xt|=1<<Jt>>>0}this._pushEncoded(Ke,tt,ct,dt,xt)}_pushEncoded(W,be,Ae,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&be<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const xt=this._data.length/5|0;let Kt=0,Jt=0;for(let ti=0;ti<xt;ti++){let ri=this._data[5*ti],Ki=this._data[5*ti+1];ri===0?(ri=Kt,Ki+=Jt):ri+=Kt,this._data[5*ti]=ri,this._data[5*ti+1]=Ki,Kt=ri,Jt=Ki}}let ct=W,dt=be;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=W,this._prevChar=be}static _sortAndDeltaEncode(W){const be=[],Ae=W.length/5|0;for(let dt=0;dt<Ae;dt++)be[dt]=dt;be.sort((dt,xt)=>{const Kt=W[5*dt],Jt=W[5*xt];if(Kt===Jt){const ti=W[5*dt+1],ri=W[5*xt+1];return ti-ri}return Kt-Jt});const Ke=new Uint32Array(W.length);let tt=0,ct=0;for(let dt=0;dt<Ae;dt++){const xt=5*be[dt],Kt=W[xt+0],Jt=W[xt+1],ti=W[xt+2],ri=W[xt+3],Ki=W[xt+4],yn=Kt-tt,Rn=yn===0?Jt-ct:Jt,Xi=5*dt;Ke[Xi+0]=yn,Ke[Xi+1]=Rn,Ke[Xi+2]=ti,Ke[Xi+3]=ri,Ke[Xi+4]=Ki,tt=Kt,ct=Jt}return Ke}build(W){return this._dataIsSortedAndDeltaEncoded?new Mi(new Uint32Array(this._data),W):new Mi(Oi._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Oi;class Mi{constructor(W,be){this.resultId=be,this.data=W}}e.SemanticTokens=Mi;class di{constructor(W,be,Ae){this.start=W,this.deleteCount=be,this.data=Ae}}e.SemanticTokensEdit=di;class un{constructor(W,be){this.resultId=be,this.edits=W}}e.SemanticTokensEdits=un;var en;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Qt("arrow-left")}}constructor(){}};e.QuickInputButtons=Ni,e.QuickInputButtons=Ni=je([P],Ni);var hi;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(hi||(e.QuickPickItemKind=hi={}));var tn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class dn{static validate(W){if(typeof W.badge=="string"){let be=(0,p.nextCharLength)(W.badge,0);if(be<W.badge.length&&(be+=(0,p.nextCharLength)(W.badge,be)),W.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Qt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,be,Ae){this.badge=W,this.tooltip=be,this.color=Ae}}e.FileDecoration=dn;let ni=class{constructor(W){this.kind=W}};e.ColorTheme=ni,e.ColorTheme=ni=je([P],ni);var Ui;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class Zt{static isNotebookRange(W){return W instanceof Zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,be){if(W<0)throw(0,F.illegalArgument)("start must be positive");if(be<0)throw(0,F.illegalArgument)("end must be positive");W<=be?(this._start=W,this._end=be):(this._start=be,this._end=W)}with(W){let be=this._start,Ae=this._end;return W.start!==void 0&&(be=W.start),W.end!==void 0&&(Ae=W.end),be===this._start&&Ae===this._end?this:new Zt(be,Ae)}}e.NotebookRange=Zt;class bi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(be=>bi.isNotebookCellData(be))}static isNotebookCellData(W){return!0}constructor(W,be,Ae,Ke,tt,ct,dt){this.kind=W,this.value=be,this.languageId=Ae,this.mime=Ke,this.outputs=tt??[],this.metadata=ct,this.executionSummary=dt,bi.validate(this)}}e.NotebookCellData=bi;class rn{constructor(W){this.cells=W}}e.NotebookData=rn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const be={name:W.name,message:W.message,stack:W.stack};return Gt.json(be,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,be="application/octet-stream"){return new Gt(W,be)}static#e=new TextEncoder;static text(W,be=A.Mimes.text){const Ae=Gt.#e.encode(String(W));return new Gt(Ae,be)}static json(W,be="text/x-json"){const Ae=JSON.stringify(W,void 0,"	");return Gt.text(Ae,be)}constructor(W,be){this.data=W,this.mime=be;const Ae=(0,A.normalizeMimeType)(be,!0);if(!Ae)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}}e.NotebookCellOutputItem=Gt;class wi{static isNotebookCellOutput(W){return W instanceof wi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,be=!1){const Ae=new Set,Ke=new Set;for(let tt=0;tt<W.length;tt++){const ct=W[tt],dt=(0,A.normalizeMimeType)(ct.mime);if(!Ae.has(dt)||(0,C.isTextStreamMime)(dt)){Ae.add(dt);continue}Ke.add(tt),be&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((tt,ct)=>!Ke.has(ct))}constructor(W,be,Ae){this.items=wi.ensureUniqueMimeTypes(W,!0),typeof be=="string"?(this.id=be,this.metadata=Ae):(this.id=(0,T.generateUuid)(),this.metadata=be??Ae)}}e.NotebookCellOutput=wi;var sn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Si;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Si||(e.NotebookCellExecutionState=Si={}));var xi;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(xi||(e.NotebookCellStatusBarAlignment=xi={}));var xe;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(xe||(e.NotebookEditorRevealType=xe={}));class ei{constructor(W,be){this.text=W,this.alignment=be}}e.NotebookCellStatusBarItem=ei;var Bi;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Bi||(e.NotebookControllerAffinity=Bi={}));var mt;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class hn{constructor(W,be=[]){this.uri=W,this.provides=(0,D.asArray)(be)}}e.NotebookRendererScript=hn;class fn{constructor(W){this.label=W}}e.NotebookKernelSourceAction=fn;let yi=class{constructor(W,be){this.label=W,this.timestamp=be}};e.TimelineItem=yi,e.TimelineItem=yi=je([P],yi);var on;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(W,be){this.ranges=W,this.wordPattern=be}}e.LinkedEditingRanges=mn;class gn{constructor(W){this._autoForwardAction=W}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=gn;var $i;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})($i||(e.TestResultState=$i={}));var cn;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(W=void 0,be=void 0,Ae=void 0,Ke=!1){this.include=W,this.exclude=be,this.profile=Ae,this.continuous=Ke}};e.TestRunRequest=Wi,e.TestRunRequest=Wi=je([P],Wi);let zi=h=class{static diff(W,be,Ae){const Ke=new h(W);return Ke.expectedOutput=be,Ke.actualOutput=Ae,Ke}constructor(W){this.message=W}};e.TestMessage=zi,e.TestMessage=zi=h=je([P],zi);let Hi=class{constructor(W){this.id=W}};e.TestTag=Hi,e.TestTag=Hi=je([P],Hi);let ui=class{constructor(W,be){this.covered=W,this.total=be}};e.CoveredCount=ui,e.CoveredCount=ui=je([P],ui);let Vi=m=class{static fromDetails(W,be){const Ae=new ui(0,0),Ke=new ui(0,0),tt=new ui(0,0);for(const dt of be)if("branches"in dt){Ae.total+=1,Ae.covered+=dt.executionCount>0?1:0;for(const xt of dt.branches)Ke.total+=1,Ke.covered+=xt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const ct=new m(W,Ae,Ke.total>0?Ke:void 0,tt.total>0?tt:void 0);return ct.detailedCoverage=be,ct}constructor(W,be,Ae,Ke){this.uri=W,this.statementCoverage=be,this.branchCoverage=Ae,this.functionCoverage=Ke}};e.FileCoverage=Vi,e.FileCoverage=Vi=m=je([P],Vi);let ji=class{constructor(W,be,Ae=[]){this.executionCount=W,this.location=be,this.branches=Ae}};e.StatementCoverage=ji,e.StatementCoverage=ji=je([P],ji);let qi=class{constructor(W,be){this.executionCount=W,this.location=be}};e.BranchCoverage=qi,e.BranchCoverage=qi=je([P],qi);let Gi=class{constructor(W,be){this.executionCount=W,this.location=be}};e.FunctionCoverage=Gi,e.FunctionCoverage=Gi=je([P],Gi);var Ee;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var _e;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(_e||(e.WorkspaceTrustState=_e={}));var Ne;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ne||(e.PortAutoForwardAction=Ne={}));class st{constructor(W,be,Ae,Ke,tt,ct){this.kind=W,this.name=be,this.detail=Ae,this.uri=Ke,this.range=tt,this.selectionRange=ct}}e.TypeHierarchyItem=st;class yt{constructor(W){this.uri=W}}e.TextTabInput=yt;class Mt{constructor(W,be){this.original=W,this.modified=be}}e.TextDiffTabInput=Mt;class _n{constructor(W,be,Ae,Ke){this.base=W,this.input1=be,this.input2=Ae,this.result=Ke}}e.TextMergeTabInput=_n;class Cn{constructor(W,be){this.uri=W,this.viewType=be}}e.CustomEditorTabInput=Cn;class Dn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Dn;class In{constructor(W,be){this.uri=W,this.notebookType=be}}e.NotebookEditorTabInput=In;class kn{constructor(W,be,Ae){this.original=W,this.modified=be,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=kn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class Tn{constructor(W,be){this.uri=W,this.inputBoxUri=be}}e.InteractiveWindowInput=Tn;var pn;(function(q){q[q.Up=1]="Up",q[q.Down=2]="Down"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(q){q[q.Action=1]="Action",q[q.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var En;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful",q[q.Undone=2]="Undone",q[q.Accepted=3]="Accepted"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var bn;(function(q){q[q.System=0]="System",q[q.User=1]="User",q[q.Assistant=2]="Assistant",q[q.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(q){q[q.Short=1]="Short",q[q.Medium=2]="Medium",q[q.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class An{constructor(W,be){this.role=W,this.content=be}}e.ChatMessage=An;var Sn;(function(q){q[q.SymbolInformation=1]="SymbolInformation",q[q.CommandInformation=2]="CommandInformation",q[q.SearchInformation=3]="SearchInformation",q[q.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}))}),define(Ce[141],De([1,0,57,17,15,171,124,7,19]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const b=new Map;function T(C,w){w?b.set(C,w):b.delete(C)}e.setWordDefinitionFor=T;function k(C){return b.get(C)}class v extends R.MirrorTextModel{constructor(w,s,o,a,c,g,u,t){super(s,o,a,c),this._proxy=w,this._languageId=g,this._isDirty=u,this.notebook=t,this._isDisposed=!1}dispose(){(0,D.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,_.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===F.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},save(){return w._save()},getText(s){return s?w._getTextInRange(s):w.getText()},get eol(){return w._eol===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(s){return w._lineAt(s)},offsetAt(s){return w._offsetAt(s)},positionAt(s){return w._positionAt(s)},validateRange(s){return w._validateRange(s)},validatePosition(s){return w._validatePosition(s)},getWordRangeAtPosition(s,o){return w._getWordRangeAtPosition(s,o)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,D.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,D.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const s=this._validateRange(w);if(s.isEmpty)return"";if(s.isSingleLine)return this._lines[s.start.line].substring(s.start.character,s.end.character);const o=this._eol,a=s.start.line,c=s.end.line,g=[];g.push(this._lines[a].substring(s.start.character));for(let u=a+1;u<c;u++)g.push(this._lines[u]);return g.push(this._lines[c].substring(0,s.end.character)),g.join(o)}_lineAt(w){let s;if(w instanceof p.Position?s=w.line:typeof w=="number"&&(s=w),typeof s!="number"||s<0||s>=this._lines.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new y(s,this._lines[s],s===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const s=this._lineStarts.getIndexOf(w),o=this._lines[s.index].length;return new p.Position(s.index,Math.min(s.remainder,o))}_validateRange(w){if(!(w instanceof p.Range))throw new Error("Invalid argument");const s=this._validatePosition(w.start),o=this._validatePosition(w.end);return s===w.start&&o===w.end?w:new p.Range(s.line,s.character,o.line,o.character)}_validatePosition(w){if(!(w instanceof p.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:s,character:o}=w,a=!1;if(s<0)s=0,o=0,a=!0;else if(s>=this._lines.length)s=this._lines.length-1,o=this._lines[s].length,a=!0;else{const c=this._lines[s].length;o<0?(o=0,a=!0):o>c&&(o=c,a=!0)}return a?new p.Position(s,o):w}_getWordRangeAtPosition(w,s){const o=this._validatePosition(w);if(!s)s=k(this._languageId);else if((0,d.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const a=(0,A.getWordAtText)(o.character+1,(0,A.ensureValidWordDefinition)(s),this._lines[o.line],0);if(a)return new p.Range(o.line,a.startColumn-1,o.line,a.endColumn-1)}}e.ExtHostDocumentData=v;class y{constructor(w,s,o){this._line=w,this._text=s,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new p.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new p.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=y}),define(Ce[274],De([1,0,7,20,4]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(p){this._actual=new D.ColorTheme(D.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new d.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(p){let _;switch(p){case"light":_=D.ColorThemeKind.Light;break;case"hcDark":_=D.ColorThemeKind.HighContrast;break;case"hcLight":_=D.ColorThemeKind.HighContrastLight;break;default:_=D.ColorThemeKind.Dark}this._actual=new D.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=R,e.ExtHostTheming=R=je([$e(0,F.IExtHostRpcService)],R)}),define(Ce[275],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.INotebookExecutionService=(0,D.createDecorator)("INotebookExecutionService")}),define(Ce[68],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(R){R.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var F;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class d{static fromExtHostTestItem(A,p,_=A.parent){if(A._isRoot)return new d([p]);const b=[A.id];for(let T=_;T&&T.id!==p;T=T.parent)b.push(T.id);return b.push(p),new d(b.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const p=A.indexOf("\0");return p===-1?A:A.slice(0,p)}static fromString(A){return new d(A.split("\0"))}static join(A,p){return new d([...A.path,p])}static joinToString(A,p){return A.toString()+"\0"+p}static parentId(A){const p=A.lastIndexOf("\0");return p===-1?void 0:A.slice(0,p)}static localId(A){const p=A.lastIndexOf("\0");return p===-1?A:A.slice(p+1)}static isChild(A,p){return p.startsWith(A)&&p[A.length]==="\0"}static compare(A,p){return A===p?0:d.isChild(A,p)?2:d.isChild(p,A)?3:1}constructor(A,p=A.length){if(this.path=A,this.viewEnd=p,A.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.viewEnd>1?new d(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let p=0;p<A.viewEnd&&p<this.viewEnd;p++)if(A.path[p]!==this.path[p])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=d}),define(Ce[88],De([1,0,2,34,68]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var p;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const _=I=>"runId"in I;e.isStartControllerTests=_;var b;(function(I){I.serialize=E=>({range:E.range.toJSON(),uri:E.uri.toJSON()}),I.deserialize=E=>({range:F.Range.lift(E.range),uri:D.URI.revive(E.uri)})})(b||(e.IRichLocation=b={}));var T;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(T||(e.TestMessageType=T={}));var k;(function(I){I.serialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,contextValue:E.contextValue,location:E.location&&b.serialize(E.location)}),I.deserialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,contextValue:E.contextValue,location:E.location&&b.deserialize(E.location)})})(k||(e.ITestErrorMessage=k={}));const v=(I,E)=>`${E?"s":"e"}${I}`;e.getMarkId=v;var y;(function(I){I.serialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&b.serialize(E.location)}),I.deserialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&b.deserialize(E.location)})})(y||(e.ITestOutputMessage=y={}));var C;(function(I){I.serialize=E=>E.type===0?k.serialize(E):y.serialize(E),I.deserialize=E=>E.type===0?k.deserialize(E):y.deserialize(E)})(C||(e.ITestMessage=C={}));var w;(function(I){I.serializeWithoutMessages=E=>({state:E.state,duration:E.duration,messages:[]}),I.serialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(C.serialize)}),I.deserialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(C.deserialize)})})(w||(e.ITestTaskState=w={}));const s="\0",o=(I,E)=>I+s+E;e.namespaceTestTag=o;const a=I=>{const E=I.indexOf(s);return{ctrlId:I.slice(0,E),tagId:I.slice(E+1)}};e.denamespaceTestTag=a;var c;(function(I){I.serialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?.toJSON(),range:E.range?.toJSON()||null,description:E.description,error:E.error,sortText:E.sortText}),I.deserialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?D.URI.revive(E.uri):void 0,range:E.range?F.Range.lift(E.range):null,description:E.description,error:E.error,sortText:E.sortText})})(c||(e.ITestItem=c={}));var g;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(g||(e.TestItemExpandState=g={}));var u;(function(I){I.serialize=E=>({expand:E.expand,item:c.serialize(E.item)}),I.deserialize=E=>({controllerId:d.TestId.root(E.item.extId),expand:E.expand,item:c.deserialize(E.item)})})(u||(e.InternalTestItem=u={}));var t;(function(I){I.serialize=E=>{let h;return E.item&&(h={},E.item.label!==void 0&&(h.label=E.item.label),E.item.tags!==void 0&&(h.tags=E.item.tags),E.item.busy!==void 0&&(h.busy=E.item.busy),E.item.uri!==void 0&&(h.uri=E.item.uri?.toJSON()),E.item.range!==void 0&&(h.range=E.item.range?.toJSON()),E.item.description!==void 0&&(h.description=E.item.description),E.item.error!==void 0&&(h.error=E.item.error),E.item.sortText!==void 0&&(h.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:h}},I.deserialize=E=>{let h;return E.item&&(h={},E.item.label!==void 0&&(h.label=E.item.label),E.item.tags!==void 0&&(h.tags=E.item.tags),E.item.busy!==void 0&&(h.busy=E.item.busy),E.item.range!==void 0&&(h.range=E.item.range?F.Range.lift(E.item.range):null),E.item.description!==void 0&&(h.description=E.item.description),E.item.error!==void 0&&(h.error=E.item.error),E.item.sortText!==void 0&&(h.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:h}}})(t||(e.ITestItemUpdate=t={}));const n=(I,E)=>{E.expand!==void 0&&(I.expand=E.expand),E.item!==void 0&&(I.item=I.item?Object.assign(I.item,E.item):E.item)};e.applyTestItemUpdate=n;var r;(function(I){I.serializeWithoutMessages=E=>({...u.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(w.serializeWithoutMessages)}),I.serialize=E=>({...u.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(w.serialize)}),I.deserialize=E=>({...u.deserialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(w.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var i;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(i||(e.DetailType=i={}));var l;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(l||(e.TestDiffOpType=l={}));var f;(function(I){I.deserialize=E=>E.op===0?{op:E.op,item:u.deserialize(E.item)}:E.op===1?{op:E.op,item:t.deserialize(E.item)}:E.op===2?{op:E.op,uri:D.URI.revive(E.uri),docv:E.docv}:E,I.serialize=E=>E.op===0?{op:E.op,item:u.serialize(E.item)}:E.op===1?{op:E.op,item:t.serialize(E.item)}:E})(f||(e.TestsDiffOp=f={}));class S{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(E){const h=this.createChangeCollector();for(const m of E)switch(m.op){case 0:this.add(u.deserialize(m.item),h);break;case 1:this.update(t.deserialize(m.item),h);break;case 3:this.remove(m.itemId,h);break;case 5:this.retireTest(m.itemId);break;case 4:this.updatePendingRoots(m.amount);break;case 6:this._tags.set(m.tag.id,m.tag);break;case 7:this._tags.delete(m.id);break}h.complete?.()}add(E,h){const m=d.TestId.parentId(E.item.extId)?.toString();let P;if(!m)P=this.createItem(E),this.roots.add(P),this.items.set(E.item.extId,P);else if(this.items.has(m)){const O=this.items.get(m);O.children.add(E.item.extId),P=this.createItem(E,O),this.items.set(E.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(E)}`);return}return h.add?.(P),E.expand===2&&this.busyControllerCount++,P}update(E,h){const m=this.items.get(E.extId);if(m)return E.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,E.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,E),h.update?.(m),m}remove(E,h){const m=this.items.get(E);if(!m)return;const P=d.TestId.parentId(m.item.extId)?.toString();P?this.items.get(P).children.delete(m.item.extId):this.roots.delete(m);const O=[[E]];for(;O.length;)for(const N of O.pop()){const L=this.items.get(N);L&&(O.push(L.children),this.items.delete(N),h.remove?.(L,L!==m),L.expand===2&&this.busyControllerCount--)}}retireTest(E){}updatePendingRoots(E){this.pendingRootCount+=E}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=S}),define(Ce[109],De([1,0,9,4,3,57,88,68]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var _;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(_||(e.TestItemEventOp=_={}));const b=(a,c)=>a===c,k=Object.entries({range:(a,c)=>a===c?!0:!a||!c?!1:a.equalsRange(c),busy:b,label:b,description:b,error:b,sortText:b,tags:(a,c)=>!(a.length!==c.length||a.some(g=>!c.includes(g)))}),v=(a,c)=>{let g;for(const[u,t]of k)t(a[u],c[u])||(g?g[u]=c[u]:g={[u]:c[u]});return g};class y extends d.Disposable{get root(){return this.options.root}constructor(c){super(),this.options=c,this.debounceSendDiff=this._register(new D.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const g of this.tree.values())this.updateExpandability(g)}get resolveHandler(){return this._resolveHandler}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){switch(c.op){case 2:{for(const g of this.diff)if(g.op===2&&g.uri===c.uri){g.docv=c.docv;return}break}case 1:{const g=this.diff[this.diff.length-1];if(g){if(g.op===1&&g.item.extId===c.item.extId){(0,A.applyTestItemUpdate)(g.item,c.item);return}if(g.op===0&&g.item.item.extId===c.item.extId){(0,A.applyTestItemUpdate)(g.item,c.item);return}}break}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,g){const u=this.tree.get(c);if(u){if((u.expandLevels===void 0||g>u.expandLevels)&&(u.expandLevels=g),u.expand===1){const t=this.resolveChildren(u);return t.isOpen()?this.expandChildren(u,g-1):t.wait().then(()=>this.expandChildren(u,g-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,g-1)):this.expandChildren(u,g-1)}}dispose(){for(const c of this.tree.values())this.options.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,g){switch(g.op){case 3:this.removeItem(p.TestId.joinToString(c.fullId,g.id));break;case 0:this.upsertItem(g.item,c);break;case 5:for(const u of g.ops)this.onTestItemEvent(c,u);break;case 1:this.diffTagRefs(g.new,g.old,c.fullId.toString());break;case 2:this.updateExpandability(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:g.update}});break;case 6:this.documentSynced(c.actual.uri);break;default:(0,R.assertNever)(g)}}documentSynced(c){c&&this.pushDiff({op:2,uri:c,docv:this.options.getDocumentVersion(c)})}upsertItem(c,g){const u=p.TestId.fromExtHostTestItem(c,this.root.id,g?.actual),t=this.options.getApiFor(c);t.parent&&t.parent!==g?.actual&&this.options.getChildren(t.parent).delete(c.id);let n=this.tree.get(u.toString());if(!n){n={fullId:u,actual:c,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(c,g),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(c)}}),this.connectItemAndChildren(c,n,g);return}if(n.actual===c){this.connectItem(c,n,g);return}if(n.actual.uri?.toString()!==c.uri?.toString())return this.removeItem(u.toString()),this.upsertItem(c,g);const r=this.options.getChildren(n.actual),i=n.actual,l=v(this.options.toITestItem(i),this.options.toITestItem(c));this.options.getApiFor(i).listener=void 0,n.actual=c,n.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(c.tags,i.tags,u.toString()),delete l.tags),this.onTestItemEvent(n,{op:4,update:l})),this.connectItemAndChildren(c,n,g);for(const[f,S]of r)this.options.getChildren(c).get(S.id)||this.removeItem(p.TestId.joinToString(u,S.id));this.documentSynced(n.actual.uri)}diffTagRefs(c,g,u){const t=new Set(g.map(n=>n.id));for(const n of c)t.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:u,item:{tags:c.map(n=>(0,A.namespaceTestTag)(this.options.controllerId,n.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const g=this.tags.get(c.id);g?g.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,c.id)}}))}decrementTagRefs(c){const g=this.tags.get(c);g&&!--g.refCount&&(this.tags.delete(c),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,c)}))}setItemParent(c,g){this.options.getApiFor(c).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(c,g,u){this.setItemParent(c,u);const t=this.options.getApiFor(c);t.parent=u?.actual,t.listener=n=>this.onTestItemEvent(g,n),this.updateExpandability(g)}connectItemAndChildren(c,g,u){this.connectItem(c,g,u);for(const[t,n]of this.options.getChildren(c))this.upsertItem(n,g)}updateExpandability(c){let g;this._resolveHandler?c.resolveBarrier?g=c.resolveBarrier.isOpen()?3:2:g=c.actual.canResolveChildren?1:0:g=0,g!==c.expand&&(c.expand=g,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:g}}),g===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,g){if(g<0)return;const u=[];for(const[t,n]of this.options.getChildren(c.actual)){const r=this.expand(p.TestId.joinToString(c.fullId,n.id),g);(0,D.isThenable)(r)&&u.push(r)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const n=new D.Barrier;return n.open(),n}c.expand=2,this.pushExpandStateUpdate(c);const g=c.resolveBarrier=new D.Barrier,u=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let t;try{t=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(n){u(n)}return(0,D.isThenable)(t)?t.catch(u).then(()=>{g.open(),this.updateExpandability(c)}):(g.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}removeItem(c){const g=this.tree.get(c);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const u=[g];for(;u.length;){const t=u.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.options.getChildren(t.actual))u.push(this.tree.get(p.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.TestItemCollection=y;class C extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=C;class w extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class s extends Error{constructor(c,g,u){super(`TestItem with ID "${c}" is from controller "${g}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=s;const o=(a,c,g)=>{let u=new Map;return{get size(){return u.size},forEach(t,n){for(const r of u.values())t.call(n,r,this)},[Symbol.iterator](){return u.entries()},replace(t){const n=new Map,r=new Set(u.keys()),i={op:5,ops:[]};for(const l of t){if(!(l instanceof g))throw new w(l.id);const f=c(l).controllerId;if(f!==a.controllerId)throw new s(l.id,f,a.controllerId);if(n.has(l.id))throw new C(l.id);n.set(l.id,l),r.delete(l.id),i.ops.push({op:0,item:l})}for(const l of r.keys())i.ops.push({op:3,id:l});a.listener?.(i),u=n},add(t){if(!(t instanceof g))throw new w(t.id);u.set(t.id,t),a.listener?.({op:0,item:t})},delete(t){u.delete(t)&&a.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.createTestItemChildren=o}),define(Ce[142],De([1,0,109]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const F=new WeakMap,d=(A,p)=>{const _={controllerId:p};return F.set(A,_),_};e.createPrivateApiFor=d;const R=A=>{const p=F.get(A);if(!p)throw new D.InvalidTestItemError(A?.id||"<unknown>");return p};e.getPrivateApiFor=R}),define(Ce[110],De([1,0,17,2]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function d(p,_){return p.scheme===D.Schemas.http||p.scheme===D.Schemas.https?p:(_&&_.authority&&_.isRemote&&p.scheme===D.Schemas.file&&(p=F.URI.from({scheme:D.Schemas.vscodeRemote,authority:_.authority,path:p.path})),F.URI.from({scheme:D.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.webviewRootResourceAuthority}`,path:p.path,fragment:p.fragment,query:p.query}))}e.asWebviewUri=d;function R(p){return p.replace(/./g,_=>{const b=_.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?_:"-"+b.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,(_,b)=>String.fromCharCode(parseInt(b,16)))}e.decodeAuthority=A}),define(Ce[276],De([1,0,4,3,110]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(p,_,b){this._proxy=p,this._editors=_,this._remoteInfo=b,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const T=_.getVisibleTextEditors();for(const k of this._insets.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(p=>p.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(p,_,b,T,k){let v;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===p){v=c;break}if(!v)throw new Error("not a visible editor");const y=this,C=this._handlePool++,w=new D.Emitter,s=new D.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,d.asWebviewUri)(c,y._remoteInfo)}get cspSource(){return d.webviewGenericCspSource}set options(c){this._options=c,y._proxy.$setOptions(C,c)}get options(){return this._options}set html(c){this._html=c,y._proxy.$setHtml(C,c)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(c){return y._proxy.$postMessage(C,c)}},a=new class{constructor(){this.editor=p,this.line=_,this.height=b,this.webview=o,this.onDidDispose=s.event}dispose(){y._insets.has(C)&&(y._insets.delete(C),y._proxy.$disposeEditorInset(C),s.fire(),s.dispose(),w.dispose())}};return this._proxy.$createEditorInset(C,v.id,v.value.document.uri,_+1,b,T||{},k.identifier,k.extensionLocation),this._insets.set(C,{editor:p,inset:a,onDidReceiveMessage:w}),a}$onDidDispose(p){const _=this._insets.get(p);_&&_.inset.dispose()}$onDidReceiveMessage(p,_){this._insets.get(p)?.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=R}),define(Ce[277],De([1,0,5]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,D.createDecorator)("configurationResolverService");var F;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class d extends Error{constructor(A,p){super(p),this.variable=A}}e.VariableError=d}),define(Ce[278],De([1,0,16,47,18,23,12,100,223,277,15]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,C,w,s){this._contributedVariables=new Map,this._context=y,this._labelService=C,this._userHomePromise=w,s&&(this._envVariablesPromise=s.then(o=>this.prepareEnv(o)))}prepareEnv(y){if(A.isWindows){const C=Object.create(null);return Object.keys(y).forEach(w=>{C[w.toLowerCase()]=y[w]}),C}return y}resolveWithEnvironment(y,C,w){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},C?C.uri:void 0,w)}async resolveAsync(y,C){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,y?y.uri:void 0,C)}async resolveAnyBase(y,C,w,s){const o=R.deepClone(C);A.isWindows&&o.windows?Object.keys(o.windows).forEach(c=>o[c]=o.windows[c]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(c=>o[c]=o.osx[c]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(c=>o[c]=o.linux[c]),delete o.windows,delete o.osx,delete o.linux;const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,y?y.uri:void 0,o,w,s)}async resolveAnyAsync(y,C,w){return this.resolveAnyBase(y,C,w)}async resolveAnyMap(y,C,w){const s=new Map;return{newConfig:await this.resolveAnyBase(y,C,w,s),resolvedVariables:s}}resolveWithInteractionReplace(y,C,w,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,C,w,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,C){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,C)}async recursiveResolve(y,C,w,s,o){if(d.isString(w))return this.resolveString(y,C,w,s,o);if(Array.isArray(w))return Promise.all(w.map(a=>this.recursiveResolve(y,C,a,s,o)));if(d.isObject(w)){const a=Object.create(null),c=await Promise.all(Object.keys(w).map(async g=>[await this.resolveString(y,C,g,s,o),await this.recursiveResolve(y,C,w[g],s,o)]));for(const[g,u]of c)a[g]=u;return a}return w}resolveString(y,C,w,s,o){return(0,T.replaceAsync)(w,k.VARIABLE_REGEXP,async(a,c)=>{if(c.includes(k.VARIABLE_LHS))return a;let g=await this.evaluateSingleVariable(y,a,c,C,s);return o?.set(c,g),g!==a&&d.isString(g)&&g.match(k.VARIABLE_REGEXP)&&(g=await this.resolveString(y,C,g,s,o)),g})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,C,w,s,o){let a;const c=w.split(":");c.length>1&&(w=c[0],a=c[1]);const g=n=>{const r=this._context.getFilePath();if(r)return(0,p.normalizeDriveLetter)(r);throw new b.VariableError(n,(0,_.localize)(0,null,C))},u=n=>{const r=g(n);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return(0,p.normalizeDriveLetter)(i)}throw new b.VariableError(n,(0,_.localize)(1,null,C,D.basename(r)))},t=n=>{if(a){const r=this._context.getFolderUri(a);if(r)return r;throw new b.VariableError(n,(0,_.localize)(2,null,C,a))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new b.VariableError(n,(0,_.localize)(3,null,C)):new b.VariableError(n,(0,_.localize)(4,null,C))};switch(w){case"env":if(a){if(y.env){const n=y.env[A.isWindows?a.toLowerCase():a];if(d.isString(n))return n}return""}throw new b.VariableError(b.VariableKind.Env,(0,_.localize)(5,null,C));case"config":if(a){const n=this._context.getConfigurationValue(s,a);if(d.isUndefinedOrNull(n))throw new b.VariableError(b.VariableKind.Config,(0,_.localize)(6,null,C,a));if(d.isObject(n))throw new b.VariableError(b.VariableKind.Config,(0,_.localize)(7,null,C,a));return n}throw new b.VariableError(b.VariableKind.Config,(0,_.localize)(8,null,C));case"command":return this.resolveFromMap(b.VariableKind.Command,C,a,o,"command");case"input":return this.resolveFromMap(b.VariableKind.Input,C,a,o,"input");case"extensionInstallFolder":if(a){const n=await this._context.getExtension(a);if(!n)throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,_.localize)(9,null,C,a));return this.fsPath(n.extensionLocation)}throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,_.localize)(10,null,C));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,p.normalizeDriveLetter)(this.fsPath(t(b.VariableKind.WorkspaceFolder)));case"cwd":return s||a?(0,p.normalizeDriveLetter)(this.fsPath(t(b.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.normalizeDriveLetter)(D.basename(this.fsPath(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new b.VariableError(b.VariableKind.UserHome,(0,_.localize)(11,null,C))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new b.VariableError(b.VariableKind.LineNumber,(0,_.localize)(12,null,C))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new b.VariableError(b.VariableKind.SelectedText,(0,_.localize)(13,null,C))}case"file":return g(b.VariableKind.File);case"fileWorkspaceFolder":return u(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||a?D.relative(this.fsPath(t(b.VariableKind.RelativeFile)),g(b.VariableKind.RelativeFile)):g(b.VariableKind.RelativeFile);case"relativeFileDirname":{const n=D.dirname(g(b.VariableKind.RelativeFileDirname));if(s||a){const r=D.relative(this.fsPath(t(b.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return D.dirname(g(b.VariableKind.FileDirname));case"fileExtname":return D.extname(g(b.VariableKind.FileExtname));case"fileBasename":return D.basename(g(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=D.basename(g(b.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-D.extname(n).length)}case"fileDirnameBasename":return D.basename(D.dirname(g(b.VariableKind.FileDirnameBasename)));case"execPath":{const n=this._context.getExecPath();return n||C}case"execInstallFolder":{const n=this._context.getAppRoot();return n||C}case"pathSeparator":return D.sep;default:try{const n=a?`${w}:${a}`:w;return this.resolveFromMap(b.VariableKind.Unknown,C,n,o,void 0)}catch{return C}}}}resolveFromMap(y,C,w,s,o){if(w&&s){const a=o===void 0?s[w]:s[o+":"+w];if(typeof a=="string")return a;throw new b.VariableError(y,(0,_.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=k}),define(Ce[143],De([1,0,5,139]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,D.createDecorator)("editorGroupsService");var d;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var R;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var p;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(p||(e.GroupsArrangement=p={}));var _;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(_||(e.MergeGroupMode=_={}));function b(C){const w=C;return(0,F.isEditorInput)(w?.editor)&&(0,F.isEditorInput)(w?.replacement)}e.isEditorReplacement=b;var T;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function v(C){const w=C;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=v;function y(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Ce[279],De([1,0,5,143]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,D.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function d(R){const A=R;return typeof R=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=d}),define(Ce[13],De([1,0,19,22,162,75,80,28,158,62,98,23,18,2,34,83,133,142,139,108,68,88,279,7]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Le){function Fe(te){const{selectionStartLineNumber:Me,selectionStartColumn:Ve,positionLineNumber:Je,positionColumn:qe}=te,nt=new n.Position(Me-1,Ve-1),pt=new n.Position(Je-1,qe-1);return new n.Selection(nt,pt)}Le.to=Fe;function Pe(te){const{anchor:Me,active:Ve}=te;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Le.from=Pe})(r||(e.Selection=r={}));var i;(function(Le){function Fe(te){if(!te)return;const{start:Me,end:Ve}=te;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Le.from=Fe;function Pe(te){if(!te)return;const{startLineNumber:Me,startColumn:Ve,endLineNumber:Je,endColumn:qe}=te;return new n.Range(Me-1,Ve-1,Je-1,qe-1)}Le.to=Pe})(i||(e.Range=i={}));var l;(function(Le){function Fe(Pe){switch(Pe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Le.to=Fe})(l||(e.TokenType=l={}));var f;(function(Le){function Fe(te){return new n.Position(te.lineNumber-1,te.column-1)}Le.to=Fe;function Pe(te){return{lineNumber:te.line+1,column:te.character+1}}Le.from=Pe})(f||(e.Position=f={}));var S;(function(Le){function Fe(Me,Ve,Je){return(0,D.coalesce)((0,D.asArray)(Me).map(qe=>Pe(qe,Ve,Je)))}Le.from=Fe;function Pe(Me,Ve,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:te(Me.scheme,Ve),pattern:Xe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function te(Me,Ve){return Ve&&typeof Me=="string"?Ve.transformOutgoingScheme(Me):Me}})(S||(e.DocumentSelector=S={}));var I;(function(Le){function Fe(te){switch(te){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function Pe(te){switch(te){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Le.to=Pe})(I||(e.DiagnosticTag=I={}));var E;(function(Le){function Fe(te){let Me;return te.code&&((0,v.isString)(te.code)||(0,v.isNumber)(te.code)?Me=String(te.code):Me={value:String(te.code.value),target:te.code.target}),{...i.from(te.range),message:te.message,source:te.source,code:Me,severity:m.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(h.from),tags:Array.isArray(te.tags)?(0,D.coalesce)(te.tags.map(I.from)):void 0}}Le.from=Fe;function Pe(te){const Me=new n.Diagnostic(i.to(te),te.message,m.to(te.severity));return Me.source=te.source,Me.code=(0,v.isString)(te.code)?te.code:te.code?.value,Me.relatedInformation=te.relatedInformation&&te.relatedInformation.map(h.to),Me.tags=te.tags&&(0,D.coalesce)(te.tags.map(I.to)),Me}Le.to=Pe})(E||(e.Diagnostic=E={}));var h;(function(Le){function Fe(te){return{...i.from(te.location.range),message:te.message,resource:te.location.uri}}Le.from=Fe;function Pe(te){return new n.DiagnosticRelatedInformation(new n.Location(te.resource,i.to(te)),te.message)}Le.to=Pe})(h||(e.DiagnosticRelatedInformation=h={}));var m;(function(Le){function Fe(te){switch(te){case n.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Le.from=Fe;function Pe(te){switch(te){case s.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Le.to=Pe})(m||(e.DiagnosticSeverity=m={}));var P;(function(Le){function Fe(te){return typeof te=="number"&&te>=n.ViewColumn.One?te-1:te===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Fe;function Pe(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Pe})(P||(e.ViewColumn=P={}));function O(Le){return typeof Le.range<"u"}function N(Le){return Le.length===0?!0:!!O(Le[0])}e.isDecorationOptionsArr=N;var L;(function(Le){function Fe(qe){return qe.map(Le.from)}Le.fromMany=Fe;function Pe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function te(qe){let nt;if(Pe(qe)){const{language:ut,value:gt}=qe;nt={value:"```"+ut+`
`+gt+"\n```\n"}}else n.MarkdownString.isMarkdownString(qe)?nt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?nt={value:qe}:nt={value:""};const pt=Object.create(null);nt.uris=pt;const Pt=ut=>{try{let gt=y.URI.parse(ut,!0);gt=gt.with({query:Me(gt.query,pt)}),pt[ut]=gt}catch{}return""},wt=new _.marked.Renderer;return wt.link=Pt,wt.image=ut=>typeof ut=="string"?Pt(A.parseHrefAndDimensions(ut).href):"",(0,_.marked)(nt.value,{renderer:wt}),nt}Le.from=te;function Me(qe,nt){if(!qe)return qe;let pt;try{pt=(0,b.parse)(qe)}catch{}if(!pt)return qe;let Pt=!1;return pt=(0,k.cloneAndChange)(pt,wt=>{if(y.URI.isUri(wt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ut]=wt,Pt=!0,ut}else return}),Pt?JSON.stringify(pt):qe}function Ve(qe){const nt=new n.MarkdownString(qe.value,qe.supportThemeIcons);return nt.isTrusted=qe.isTrusted,nt.supportHtml=qe.supportHtml,nt.baseUri=qe.baseUri?y.URI.from(qe.baseUri):void 0,nt}Le.to=Ve;function Je(qe){if(qe)return typeof qe=="string"?qe:Le.from(qe)}Le.fromStrict=Je})(L||(e.MarkdownString=L={}));function U(Le){return N(Le)?Le.map(Fe=>({range:i.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?L.fromMany(Fe.hoverMessage):Fe.hoverMessage?L.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:i.from(Fe)}))}e.fromRangeOrRangeWithMessage=U;function x(Le){return typeof Le>"u"?Le:typeof Le=="string"?y.URI.file(Le):Le}e.pathOrURIToURI=x;var M;(function(Le){function Fe(Pe){return typeof Pe>"u"?Pe:{contentText:Pe.contentText,contentIconPath:Pe.contentIconPath?x(Pe.contentIconPath):void 0,border:Pe.border,borderColor:Pe.borderColor,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,color:Pe.color,backgroundColor:Pe.backgroundColor,margin:Pe.margin,width:Pe.width,height:Pe.height}}Le.from=Fe})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var H;(function(Le){function Fe(Pe){return typeof Pe>"u"?Pe:{backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?x(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?M.from(Pe.before):void 0,after:Pe.after?M.from(Pe.after):void 0}}Le.from=Fe})(H||(e.ThemableDecorationRenderOptions=H={}));var j;(function(Le){function Fe(Pe){if(typeof Pe>"u")return Pe;switch(Pe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(j||(e.DecorationRangeBehavior=j={}));var fe;(function(Le){function Fe(Pe){return{isWholeLine:Pe.isWholeLine,rangeBehavior:Pe.rangeBehavior?j.from(Pe.rangeBehavior):void 0,overviewRulerLane:Pe.overviewRulerLane,light:Pe.light?H.from(Pe.light):void 0,dark:Pe.dark?H.from(Pe.dark):void 0,backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?x(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?M.from(Pe.before):void 0,after:Pe.after?M.from(Pe.after):void 0}}Le.from=Fe})(fe||(e.DecorationRenderOptions=fe={}));var Y;(function(Le){function Fe(te){return{text:te.newText,eol:te.newEol&&et.from(te.newEol),range:i.from(te.range)}}Le.from=Fe;function Pe(te){const Me=new n.TextEdit(i.to(te.range),te.text);return Me.newEol=typeof te.eol>"u"?void 0:et.to(te.eol),Me}Le.to=Pe})(Y||(e.TextEdit=Y={}));var X;(function(Le){function Fe(te,Me){const Ve={edits:[]};if(te instanceof n.WorkspaceEdit){const Je=new p.ResourceSet;for(const qe of te._allEntries())qe._type===1&&y.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of te._allEntries())if(qe._type===1){let nt;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?nt={type:"base64",value:(0,F.encodeBase64)(F.VSBuffer.wrap(qe.options.contents))}:nt={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:nt},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:Y.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:i.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(at.from)}})}return Ve}Le.from=Fe;function Pe(te){const Me=new n.WorkspaceEdit,Ve=new p.ResourceMap;for(const Je of te.edits)if(Je.textEdit){const qe=Je,nt=y.URI.revive(qe.resource),pt=i.to(qe.textEdit.range),Pt=qe.textEdit.text,wt=qe.textEdit.insertAsSnippet;let ut;wt?ut=n.SnippetTextEdit.replace(pt,new n.SnippetString(Pt)):ut=n.TextEdit.replace(pt,Pt);const gt=Ve.get(nt);gt?gt.push(ut):Ve.set(nt,[ut])}else Me.renameFile(y.URI.revive(Je.oldResource),y.URI.revive(Je.newResource),Je.options);for(const[Je,qe]of Ve)Me.set(Je,qe);return Me}Le.to=Pe})(X||(e.WorkspaceEdit=X={}));var z;(function(Le){const Fe=Object.create(null);Fe[n.SymbolKind.File]=0,Fe[n.SymbolKind.Module]=1,Fe[n.SymbolKind.Namespace]=2,Fe[n.SymbolKind.Package]=3,Fe[n.SymbolKind.Class]=4,Fe[n.SymbolKind.Method]=5,Fe[n.SymbolKind.Property]=6,Fe[n.SymbolKind.Field]=7,Fe[n.SymbolKind.Constructor]=8,Fe[n.SymbolKind.Enum]=9,Fe[n.SymbolKind.Interface]=10,Fe[n.SymbolKind.Function]=11,Fe[n.SymbolKind.Variable]=12,Fe[n.SymbolKind.Constant]=13,Fe[n.SymbolKind.String]=14,Fe[n.SymbolKind.Number]=15,Fe[n.SymbolKind.Boolean]=16,Fe[n.SymbolKind.Array]=17,Fe[n.SymbolKind.Object]=18,Fe[n.SymbolKind.Key]=19,Fe[n.SymbolKind.Null]=20,Fe[n.SymbolKind.EnumMember]=21,Fe[n.SymbolKind.Struct]=22,Fe[n.SymbolKind.Event]=23,Fe[n.SymbolKind.Operator]=24,Fe[n.SymbolKind.TypeParameter]=25;function Pe(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Le.from=Pe;function te(Me){for(const Ve in Fe)if(Fe[Ve]===Me)return Number(Ve);return n.SymbolKind.Property}Le.to=te})(z||(e.SymbolKind=z={}));var J;(function(Le){function Fe(te){switch(te){case n.SymbolTag.Deprecated:return 1}}Le.from=Fe;function Pe(te){switch(te){case 1:return n.SymbolTag.Deprecated}}Le.to=Pe})(J||(e.SymbolTag=J={}));var ge;(function(Le){function Fe(te){return{name:te.name,kind:z.from(te.kind),tags:te.tags&&te.tags.map(J.from),containerName:te.containerName,location:V.from(te.location)}}Le.from=Fe;function Pe(te){const Me=new n.SymbolInformation(te.name,z.to(te.kind),te.containerName,V.to(te.location));return Me.tags=te.tags&&te.tags.map(J.to),Me}Le.to=Pe})(ge||(e.WorkspaceSymbol=ge={}));var le;(function(Le){function Fe(te){const Me={name:te.name||"!!MISSING: name!!",detail:te.detail,range:i.from(te.range),selectionRange:i.from(te.selectionRange),kind:z.from(te.kind),tags:te.tags?.map(J.from)??[]};return te.children&&(Me.children=te.children.map(Fe)),Me}Le.from=Fe;function Pe(te){const Me=new n.DocumentSymbol(te.name,te.detail,z.to(te.kind),i.to(te.range),i.to(te.selectionRange));return(0,D.isNonEmptyArray)(te.tags)&&(Me.tags=te.tags.map(J.to)),te.children&&(Me.children=te.children.map(Pe)),Me}Le.to=Pe})(le||(e.DocumentSymbol=le={}));var we;(function(Le){function Fe(te){const Me=new n.CallHierarchyItem(z.to(te.kind),te.name,te.detail||"",y.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Me._sessionId=te._sessionId,Me._itemId=te._itemId,Me}Le.to=Fe;function Pe(te,Me,Ve){if(Me=Me??te._sessionId,Ve=Ve??te._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,name:te.name,detail:te.detail,kind:z.from(te.kind),uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(J.from)}}Le.from=Pe})(we||(e.CallHierarchyItem=we={}));var G;(function(Le){function Fe(Pe){return new n.CallHierarchyIncomingCall(we.to(Pe.from),Pe.fromRanges.map(te=>i.to(te)))}Le.to=Fe})(G||(e.CallHierarchyIncomingCall=G={}));var B;(function(Le){function Fe(Pe){return new n.CallHierarchyOutgoingCall(we.to(Pe.to),Pe.fromRanges.map(te=>i.to(te)))}Le.to=Fe})(B||(e.CallHierarchyOutgoingCall=B={}));var V;(function(Le){function Fe(te){return{range:te.range&&i.from(te.range),uri:te.uri}}Le.from=Fe;function Pe(te){return new n.Location(y.URI.revive(te.uri),i.to(te.range))}Le.to=Pe})(V||(e.location=V={}));var me;(function(Le){function Fe(te){const Me=te,Ve=te;return{originSelectionRange:Me.originSelectionRange?i.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ve.uri,range:i.from(Me.targetRange?Me.targetRange:Ve.range),targetSelectionRange:Me.targetSelectionRange?i.from(Me.targetSelectionRange):void 0}}Le.from=Fe;function Pe(te){return{targetUri:y.URI.revive(te.uri),targetRange:i.to(te.range),targetSelectionRange:te.targetSelectionRange?i.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?i.to(te.originSelectionRange):void 0}}Le.to=Pe})(me||(e.DefinitionLink=me={}));var Z;(function(Le){function Fe(te){return{range:i.from(te.range),contents:L.fromMany(te.contents)}}Le.from=Fe;function Pe(te){return new n.Hover(te.contents.map(L.to),i.to(te.range))}Le.to=Pe})(Z||(e.Hover=Z={}));var ne;(function(Le){function Fe(te){return{range:i.from(te.range),expression:te.expression}}Le.from=Fe;function Pe(te){return new n.EvaluatableExpression(i.to(te.range),te.expression)}Le.to=Pe})(ne||(e.EvaluatableExpression=ne={}));var re;(function(Le){function Fe(te){if(te instanceof n.InlineValueText)return{type:"text",range:i.from(te.range),text:te.text};if(te instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function Pe(te){switch(te.type){case"text":return{range:i.to(te.range),text:te.text};case"variable":return{range:i.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:i.to(te.range),expression:te.expression}}}Le.to=Pe})(re||(e.InlineValue=re={}));var ye;(function(Le){function Fe(te){return{frameId:te.frameId,stoppedLocation:i.from(te.stoppedLocation)}}Le.from=Fe;function Pe(te){return new n.InlineValueContext(te.frameId,i.to(te.stoppedLocation))}Le.to=Pe})(ye||(e.InlineValueContext=ye={}));var oe;(function(Le){function Fe(te){return{range:i.from(te.range),kind:te.kind}}Le.from=Fe;function Pe(te){return new n.DocumentHighlight(i.to(te.range),te.kind)}Le.to=Pe})(oe||(e.DocumentHighlight=oe={}));var de;(function(Le){function Fe(Pe){switch(Pe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Le.to=Fe})(de||(e.CompletionTriggerKind=de={}));var ee;(function(Le){function Fe(Pe){return{triggerKind:de.to(Pe.triggerKind),triggerCharacter:Pe.triggerCharacter}}Le.to=Fe})(ee||(e.CompletionContext=ee={}));var ue;(function(Le){function Fe(te){switch(te){case n.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function Pe(te){switch(te){case 1:return n.CompletionItemTag.Deprecated}}Le.to=Pe})(ue||(e.CompletionItemTag=ue={}));var ve;(function(Le){const Fe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Pe(Ve){return Fe.get(Ve)??9}Le.from=Pe;const te=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Me(Ve){return te.get(Ve)??n.CompletionItemKind.Property}Le.to=Me})(ve||(e.CompletionItemKind=ve={}));var ke;(function(Le){function Fe(Pe,te){const Me=new n.CompletionItem(Pe.label);return Me.insertText=Pe.insertText,Me.kind=ve.to(Pe.kind),Me.tags=Pe.tags?.map(ue.to),Me.detail=Pe.detail,Me.documentation=A.isMarkdownString(Pe.documentation)?L.to(Pe.documentation):Pe.documentation,Me.sortText=Pe.sortText,Me.filterText=Pe.filterText,Me.preselect=Pe.preselect,Me.commitCharacters=Pe.commitCharacters,C.Range.isIRange(Pe.range)?Me.range=i.to(Pe.range):typeof Pe.range=="object"&&(Me.range={inserting:i.to(Pe.range.insert),replacing:i.to(Pe.range.replace)}),Me.keepWhitespace=typeof Pe.insertTextRules>"u"?!1:!!(Pe.insertTextRules&1),typeof Pe.insertTextRules<"u"&&Pe.insertTextRules&4?Me.insertText=new n.SnippetString(Pe.insertText):(Me.insertText=Pe.insertText,Me.textEdit=Me.range instanceof n.Range?new n.TextEdit(Me.range,Me.insertText):void 0),Pe.additionalTextEdits&&Pe.additionalTextEdits.length>0&&(Me.additionalTextEdits=Pe.additionalTextEdits.map(Ve=>Y.to(Ve))),Me.command=te&&Pe.command?te.fromInternal(Pe.command):void 0,Me}Le.to=Fe})(ke||(e.CompletionItem=ke={}));var $;(function(Le){function Fe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:L.fromStrict(te.documentation)}}Le.from=Fe;function Pe(te){return{label:te.label,documentation:A.isMarkdownString(te.documentation)?L.to(te.documentation):te.documentation}}Le.to=Pe})($||(e.ParameterInformation=$={}));var K;(function(Le){function Fe(te){return{label:te.label,documentation:L.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map($.from):[],activeParameter:te.activeParameter}}Le.from=Fe;function Pe(te){return{label:te.label,documentation:A.isMarkdownString(te.documentation)?L.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map($.to):[],activeParameter:te.activeParameter}}Le.to=Pe})(K||(e.SignatureInformation=K={}));var ie;(function(Le){function Fe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(K.from):[]}}Le.from=Fe;function Pe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(K.to):[]}}Le.to=Pe})(ie||(e.SignatureHelp=ie={}));var se;(function(Le){function Fe(Pe,te){const Me=new n.InlayHint(f.to(te.position),typeof te.label=="string"?te.label:te.label.map(Q.to.bind(void 0,Pe)),te.kind&&he.to(te.kind));return Me.textEdits=te.textEdits&&te.textEdits.map(Y.to),Me.tooltip=A.isMarkdownString(te.tooltip)?L.to(te.tooltip):te.tooltip,Me.paddingLeft=te.paddingLeft,Me.paddingRight=te.paddingRight,Me}Le.to=Fe})(se||(e.InlayHint=se={}));var Q;(function(Le){function Fe(Pe,te){const Me=new n.InlayHintLabelPart(te.label);return Me.tooltip=A.isMarkdownString(te.tooltip)?L.to(te.tooltip):te.tooltip,w.Command.is(te.command)&&(Me.command=Pe.fromInternal(te.command)),te.location&&(Me.location=V.to(te.location)),Me}Le.to=Fe})(Q||(e.InlayHintLabelPart=Q={}));var he;(function(Le){function Fe(te){return te}Le.from=Fe;function Pe(te){return te}Le.to=Pe})(he||(e.InlayHintKind=he={}));var Se;(function(Le){function Fe(te){return{range:i.from(te.range),url:te.target,tooltip:te.tooltip}}Le.from=Fe;function Pe(te){let Me;if(te.url)try{Me=typeof te.url=="string"?y.URI.parse(te.url,!0):y.URI.revive(te.url)}catch{}return new n.DocumentLink(i.to(te.range),Me)}Le.to=Pe})(Se||(e.DocumentLink=Se={}));var Ue;(function(Le){function Fe(te){const Me=new n.ColorPresentation(te.label);return te.textEdit&&(Me.textEdit=Y.to(te.textEdit)),te.additionalTextEdits&&(Me.additionalTextEdits=te.additionalTextEdits.map(Ve=>Y.to(Ve))),Me}Le.to=Fe;function Pe(te){return{label:te.label,textEdit:te.textEdit?Y.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Me=>Y.from(Me)):void 0}}Le.from=Pe})(Ue||(e.ColorPresentation=Ue={}));var We;(function(Le){function Fe(te){return new n.Color(te[0],te[1],te[2],te[3])}Le.to=Fe;function Pe(te){return[te.red,te.green,te.blue,te.alpha]}Le.from=Pe})(We||(e.Color=We={}));var Ze;(function(Le){function Fe(te){return{range:i.from(te.range)}}Le.from=Fe;function Pe(te){return new n.SelectionRange(i.to(te.range))}Le.to=Pe})(Ze||(e.SelectionRange=Ze={}));var Qe;(function(Le){function Fe(Pe){switch(Pe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(Qe||(e.TextDocumentSaveReason=Qe={}));var it;(function(Le){function Fe(te){switch(te){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function Pe(te){switch(te){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Le.to=Pe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Le){function Fe(te){if(te===n.EndOfLine.CRLF)return 1;if(te===n.EndOfLine.LF)return 0}Le.from=Fe;function Pe(te){if(te===1)return n.EndOfLine.CRLF;if(te===0)return n.EndOfLine.LF}Le.to=Pe})(et||(e.EndOfLine=et={}));var Te;(function(Le){function Fe(Pe){if(typeof Pe=="object")return Pe.viewId;switch(Pe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(Te||(e.ProgressLocation=Te={}));var Oe;(function(Le){function Fe(te){const Me={start:te.start+1,end:te.end+1};return te.kind&&(Me.kind=ze.from(te.kind)),Me}Le.from=Fe;function Pe(te){const Me={start:te.start-1,end:te.end-1};return te.kind&&(Me.kind=ze.to(te.kind)),Me}Le.to=Pe})(Oe||(e.FoldingRange=Oe={}));var ze;(function(Le){function Fe(te){if(te)switch(te){case n.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Le.from=Fe;function Pe(te){if(te)switch(te.value){case w.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}Le.to=Pe})(ze||(e.FoldingRangeKind=ze={}));var Re;(function(Le){function Fe(Pe){if(Pe)return{pinned:typeof Pe.preview=="boolean"?!Pe.preview:void 0,inactive:Pe.background,preserveFocus:Pe.preserveFocus,selection:typeof Pe.selection=="object"?i.from(Pe.selection):void 0,override:typeof Pe.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Fe})(Re||(e.TextEditorOpenOptions=Re={}));var Xe;(function(Le){function Fe(Ve){return Ve instanceof n.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:Pe(Ve)||te(Ve)?new n.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Le.from=Fe;function Pe(Ve){const Je=Ve;return Je?y.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function te(Ve){const Je=Ve;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(Ve){return typeof Ve=="string"?Ve:new n.RelativePattern(y.URI.revive(Ve.baseUri),Ve.pattern)}Le.to=Me})(Xe||(e.GlobPattern=Xe={}));var ce;(function(Le){function Fe(Pe){if(Pe){if(Array.isArray(Pe))return Pe.map(Fe);if(typeof Pe=="string")return Pe;{const te=Pe;return{language:te.language,scheme:te.scheme,pattern:Xe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Le.from=Fe})(ce||(e.LanguageSelector=ce={}));var ae;(function(Le){function Fe(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Me=>Array.isArray(Me)&&Me.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Je=>Je instanceof n.Range)))}Le.is=Fe;function Pe(te){return{documents:te.documents.map(Me=>Me.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Je=>i.from(Je))})))}}Le.from=Pe})(ae||(e.MappedEditsContext=ae={}));var Ie;(function(Le){function Fe(te){return{start:te.start,end:te.end}}Le.from=Fe;function Pe(te){return new n.NotebookRange(te.start,te.end)}Le.to=Pe})(Ie||(e.NotebookRange=Ie={}));var He;(function(Le){function Fe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Le.to=Fe;function Pe(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Le.from=Pe})(He||(e.NotebookCellExecutionSummary=He={}));var Be;(function(Le){function Fe(Pe){if(Pe===c.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Pe===c.NotebookCellExecutionState.Pending)return;if(Pe===c.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Pe}`)}Le.to=Fe})(Be||(e.NotebookCellExecutionState=Be={}));var Ye;(function(Le){function Fe(te){switch(te){case n.NotebookCellKind.Markup:return c.CellKind.Markup;case n.NotebookCellKind.Code:default:return c.CellKind.Code}}Le.from=Fe;function Pe(te){switch(te){case c.CellKind.Markup:return n.NotebookCellKind.Markup;case c.CellKind.Code:default:return n.NotebookCellKind.Code}}Le.to=Pe})(Ye||(e.NotebookCellKind=Ye={}));var rt;(function(Le){function Fe(te){const Me={metadata:te.metadata??Object.create(null),cells:[]};for(const Ve of te.cells)n.NotebookCellData.validate(Ve),Me.cells.push(at.from(Ve));return Me}Le.from=Fe;function Pe(te){const Me=new n.NotebookData(te.cells.map(at.to));return(0,v.isEmptyObject)(te.metadata)||(Me.metadata=te.metadata),Me}Le.to=Pe})(rt||(e.NotebookData=rt={}));var at;(function(Le){function Fe(te){return{cellKind:Ye.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:He.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Ct.from):[]}}Le.from=Fe;function Pe(te){return new n.NotebookCellData(Ye.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Ct.to):void 0,te.metadata,te.internalMetadata?He.to(te.internalMetadata):void 0)}Le.to=Pe})(at||(e.NotebookCellData=at={}));var vt;(function(Le){function Fe(te){return{mime:te.mime,valueBytes:F.VSBuffer.wrap(te.data)}}Le.from=Fe;function Pe(te){return new n.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Le.to=Pe})(vt||(e.NotebookCellOutputItem=vt={}));var Ct;(function(Le){function Fe(te){return{outputId:te.id,items:te.items.map(vt.from),metadata:te.metadata}}Le.from=Fe;function Pe(te){const Me=te.items.map(vt.to);return new n.NotebookCellOutput(Me,te.outputId,te.metadata)}Le.to=Pe})(Ct||(e.NotebookCellOutput=Ct={}));var Xt;(function(Le){function Fe(Me){return te(Me)?{include:Xe.from(Me.include)??void 0,exclude:Xe.from(Me.exclude)??void 0}:Xe.from(Me)??void 0}Le.from=Fe;function Pe(Me){return te(Me)?{include:Xe.to(Me.include),exclude:Xe.to(Me.exclude)}:Xe.to(Me)}Le.to=Pe;function te(Me){const Ve=Me;return Ve?!(0,v.isUndefinedOrNull)(Ve.include)&&!(0,v.isUndefinedOrNull)(Ve.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Vt;(function(Le){function Fe(Pe,te,Me){const Ve=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{alignment:Pe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Ve,Me),text:Pe.text,tooltip:Pe.tooltip,accessibilityInformation:Pe.accessibilityInformation,priority:Pe.priority}}Le.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var Et;(function(Le){function Fe(Pe,te,Me){const Ve=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{command:te.toInternal(Ve,Me),label:Pe.label,description:Pe.description,detail:Pe.detail,documentation:Pe.documentation}}Le.from=Fe})(Et||(e.NotebookKernelSourceAction=Et={}));var Bt;(function(Le){function Fe(Pe){return{transientOutputs:Pe?.transientOutputs??!1,transientCellMetadata:Pe?.transientCellMetadata??{},transientDocumentMetadata:Pe?.transientDocumentMetadata??{},cellContentMetadata:Pe?.cellContentMetadata??{}}}Le.from=Fe})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var Nt;(function(Le){function Fe(te){return{uri:te.uri,provides:te.provides}}Le.from=Fe;function Pe(te){return new n.NotebookRendererScript(y.URI.revive(te.uri),te.provides)}Le.to=Pe})(Nt||(e.NotebookRendererScript=Nt={}));var $t;(function(Le){function Fe(te){return{message:L.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:i.from(te.location.range),uri:te.location.uri}}}Le.from=Fe;function Pe(te){const Me=new n.TestMessage(typeof te.message=="string"?te.message:L.to(te.message));return Me.actualOutput=te.actual,Me.expectedOutput=te.expected,Me.contextValue=te.contextValue,Me.location=te.location?V.to(te.location):void 0,Me}Le.to=Pe})($t||(e.TestMessage=$t={}));var Tt;(function(Le){Le.namespace=u.namespaceTestTag,Le.denamespace=u.denamespaceTestTag})(Tt||(e.TestTag=Tt={}));var At;(function(Le){function Fe(te){const Me=(0,o.getPrivateApiFor)(te).controllerId;return{extId:g.TestId.fromExtHostTestItem(te,Me).toString(),label:te.label,uri:y.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ve=>Tt.namespace(Me,Ve.id)),range:C.Range.lift(i.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&L.fromStrict(te.error)||null}}Le.from=Fe;function Pe(te){return{parent:void 0,error:void 0,id:g.TestId.fromString(te.extId).localId,label:te.label,uri:y.URI.revive(te.uri),tags:(te.tags||[]).map(Me=>{const{tagId:Ve}=Tt.denamespace(Me);return new n.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Le.toPlain=Pe})(At||(e.TestItem=At={})),function(Le){function Fe(te){return{id:te.id}}Le.from=Fe;function Pe(te){return new n.TestTag(te.id)}Le.to=Pe}(Tt||(e.TestTag=Tt={}));var Ut;(function(Le){const Fe=(te,Me)=>{const Ve=[];for(const[qe,nt]of Me)g.TestId.compare(nt.item.extId,qe)===2&&(Me.delete(qe),Ve.push(nt));const Je={...At.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(nt=>nt.type===0).map($t.to)})),children:Ve.map(qe=>Fe(qe,Me))};for(const qe of Je.children)qe.parent=Je;return Je};function Pe(te){const Me=[],Ve=new Map;for(const Je of te.items){Ve.set(Je.item.extId,Je);const qe=g.TestId.root(Je.item.extId);te.request.targets.some(nt=>nt.controllerId===qe&&nt.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:te.completedAt,results:Me.map(Je=>Fe(Je,Ve))}}Le.to=Pe})(Ut||(e.TestResults=Ut={}));var Wt;(function(Le){function Fe(Ve){return{covered:Ve.covered,total:Ve.covered}}function Pe(Ve){return"line"in Ve?f.from(Ve):i.from(Ve)}function te(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Pe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Pe(Je.location)})):void 0}:{type:0,count:Ve.executionCount,location:Pe(Ve.location)}}Le.fromDetailed=te;function Me(Ve){return{uri:Ve.uri,statement:Fe(Ve.statementCoverage),branch:Ve.branchCoverage&&Fe(Ve.branchCoverage),function:Ve.functionCoverage&&Fe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(te)}}Le.fromFile=Me})(Wt||(e.TestCoverage=Wt={}));var jt;(function(Le){function Fe(Pe){switch(Pe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Le.to=Fe})(jt||(e.CodeActionTriggerKind=jt={}));var zt;(function(Le){function Fe(te){const Me=new n.TypeHierarchyItem(z.to(te.kind),te.name,te.detail||"",y.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Me._sessionId=te._sessionId,Me._itemId=te._itemId,Me}Le.to=Fe;function Pe(te,Me,Ve){if(Me=Me??te._sessionId,Ve=Ve??te._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,kind:z.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(J.from)}}Le.from=Pe})(zt||(e.TypeHierarchyItem=zt={}));var Ht;(function(Le){function Fe(Pe){if(Pe)return{value:Pe.value,tooltip:Pe.tooltip}}Le.from=Fe})(Ht||(e.ViewBadge=Ht={}));var ot;(function(Le){function Fe(Ve,Je,qe){const nt=Je.fileData;return nt?new n.InternalFileDataTransferItem(new n.DataTransferFile(nt.name,y.URI.revive(nt.uri),nt.id,(0,R.createSingleCallFunction)(()=>qe(nt.id)))):Ve===T.Mimes.uriList&&Je.uriListData?new n.InternalDataTransferItem(Me(Je.uriListData)):new n.InternalDataTransferItem(Je.asString)}Le.to=Fe;async function Pe(Ve,Je){const qe=await Je.asString();if(Ve===T.Mimes.uriList)return{asString:qe,fileData:void 0,uriListData:te(qe)};const nt=Je.asFile();return{asString:qe,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Le.from=Pe;function te(Ve){return d.UriList.split(Ve).map(Je=>{if(Je.startsWith("#"))return Je;try{return y.URI.parse(Je)}catch{}return Je})}function Me(Ve){return d.UriList.create(Ve.map(Je=>typeof Je=="string"?Je:y.URI.revive(Je)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Le){function Fe(te,Me){const Ve=te.items.map(([Je,qe])=>[Je,ot.to(Je,qe,Me)]);return new n.DataTransfer(Ve)}Le.toDataTransfer=Fe;async function Pe(te){const Me={items:[]},Ve=[];for(const[Je,qe]of te)Ve.push((async()=>{Me.items.push([Je,await ot.from(Je,qe)])})());return await Promise.all(Ve),Me}Le.from=Pe})(ft||(e.DataTransfer=ft={}));var Rt;(function(Le){function Fe(te){return{message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Le.to=Fe;function Pe(te){return{kind:"reply",message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Le.from=Pe})(Rt||(e.ChatReplyFollowup=Rt={}));var Lt;(function(Le){function Fe(Pe){return typeof Pe=="string"?{title:Pe,message:Pe,kind:"reply"}:"commandId"in Pe?{kind:"command",title:Pe.title??"",commandId:Pe.commandId??"",when:Pe.when??"",args:Pe.args}:Rt.from(Pe)}Le.from=Fe})(Lt||(e.ChatFollowup=Lt={}));var kt;(function(Le){function Fe(te){const Me=new n.ChatMessage(ht.to(te.role),te.content);return Me.name=te.name,Me}Le.to=Fe;function Pe(te){return{role:ht.from(te.role),content:te.content,name:te.name}}Le.from=Pe})(kt||(e.ChatMessage=kt={}));var ht;(function(Le){function Fe(te){switch(te){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Le.to=Fe;function Pe(te){switch(te){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Le.from=Pe})(ht||(e.ChatMessageRole=ht={}));var _t;(function(Le){function Fe(te){return{level:Dt.to(te.level),value:te.value,description:te.description}}Le.to=Fe;function Pe(te){return{level:Dt.from(te.level),value:te.value,description:te.description}}Le.from=Pe})(_t||(e.ChatVariable=_t={}));var Dt;(function(Le){function Fe(te){switch(te){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Le.to=Fe;function Pe(te){switch(te){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Le.from=Pe})(Dt||(e.ChatVariableLevel=Dt={}));var Ft;(function(Le){function Fe(Pe){switch(Pe){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Le.to=Fe})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Ge;(function(Le){function Fe(Pe,te,Me){return"terminalCommand"in Pe?{terminalCommand:Pe.terminalCommand}:"uri"in Pe?{uri:Pe.uri}:te.toInternal(Pe,Me)}Le.from=Fe})(Ge||(e.TerminalQuickFix=Ge={}))}),define(Ce[280],De([1,0,2,8,7,13,76]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class p{constructor(b,T,k,v={timeout:1500,errors:3}){this._logService=b,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=v,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(b){return(T,k,v)=>{const C={dispose:this._callbacks.push([T,k,b])};return Array.isArray(v)&&v.push(C),C}}async $participateInSave(b,T){const k=D.URI.revive(b);let v=!1;const y=setTimeout(()=>v=!0,this._thresholds.timeout),C=[];try{for(const w of[...this._callbacks]){if(v)break;const s=this._documents.getDocument(k),o=await this._deliverEventAsyncAndBlameBadListeners(w,{document:s,reason:R.TextDocumentSaveReason.to(T)});C.push(o)}}finally{clearTimeout(y)}return C}_deliverEventAsyncAndBlameBadListeners([b,T,k],v){const y=this._badListeners.get(b);return typeof y=="number"&&y>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,b,T,v).then(()=>!0,C=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const w=this._badListeners.get(b);this._badListeners.set(b,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(b,T,k,v){const y=[],C=Date.now(),{document:w,reason:s}=v,{version:o}=w,a=Object.freeze({document:w,reason:s,waitUntil(c){if(Object.isFrozen(y))throw(0,F.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(c))}});try{T.apply(k,[a])}catch(c){return Promise.reject(c)}return Object.freeze(y),new Promise((c,g)=>{const u=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(y).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(u),c(t)}).catch(t=>{clearTimeout(u),g(t)})}).then(c=>{const g={edits:[]};for(const u of c)if(Array.isArray(u)&&u.every(t=>t instanceof d.TextEdit))for(const{newText:t,newEol:n,range:r}of u)g.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:t,eol:n&&R.EndOfLine.from(n)}});if(g.edits.length!==0)return o===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=p}),define(Ce[281],De([1,0,17,2,13,7,108]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class p{constructor(k,v,y,C){this.start=k,this.deletedCount=v,this.deletedItems=y,this.items=C}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class _{static asModelAddData(k,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,v,y){this.notebook=k,this._extHostDocument=v,this._cellData=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this._outputs=y.outputs.map(d.NotebookCellOutput.to),this._internalMetadata=y.internalMetadata??{},this._metadata=Object.freeze(y.metadata??{}),this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:d.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return k._mime},set mime(C){k._mime=C},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(y)}return this._apiCell}setOutputs(k){this._outputs=k.map(d.NotebookCellOutput.to)}setOutputItems(k,v,y){const C=y.map(d.NotebookCellOutputItem.to),w=this._outputs.find(s=>s.id===k);if(w&&(v||(w.items.length=0),w.items.push(...C),w.items.length>1&&w.items.every(s=>A.isTextStreamMime(s.mime)))){const s=new Map,o=[];w.items.forEach(a=>{let c;s.has(a.mime)?c=s.get(a.mime):(c=[],s.set(a.mime,c),o.push(a.mime)),c.push(a.data)}),w.items.length=0,o.forEach(a=>{const c=A.compressOutputItemStreams(s.get(a));w.items.push({mime:a,data:c.data.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(d.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=_;class b{static{this._handlePool=0}constructor(k,v,y,C,w){this._proxy=k,this._textDocumentsAndEditors=v,this._textDocuments=y,this.uri=C,this.handle=b._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0,void 0),this._versionId=w.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const k=this,v={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===D.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(y){return y=k._validateIndex(y),k._cells[y].apiCell},getCells(y){return(y?k._getCells(y):k._cells).map(w=>w.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(v)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,v,y){this._versionId=k.versionId,this._isDirty=v,this.acceptDocumentPropertiesChanged({metadata:y});const C={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},w=[];for(const o of k.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,C.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,C.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),w.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),w.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),w.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),w.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),w.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<w.length;o++){const a=w[o],c=s.get(a.cell);if(c===void 0){const g=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});s.set(a.cell,g-1)}else C.cellChanges[c]={...C.cellChanges[c],...a}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let v=k.start|0,y=k.end|0;return v<0&&(v=0),y>this._cells.length&&(y=this._cells.length),k.with({start:v,end:y})}_getCells(k){k=this._validateRange(k);const v=[];for(let y=k.start;y<k.end;y++)v.push(this._cells[y]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,v,y){if(this._disposed)return;const C=[],w=[],s=[];if(k.reverse().forEach(o=>{const c=o[2].map(t=>{const n=new _(this,this._textDocumentsAndEditors,t);return v||w.push(_.asModelAddData(this.apiNotebook,t)),n}),g=new p(o[0],o[1],[],c),u=this._cells.splice(o[0],o[1],...c);for(const t of u)s.push(t.uri),g.deletedItems.push(t.apiCell);C.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:s}),y)for(const o of C)y.push(o.asApiEvent())}_moveCells(k,v,y,C){const w=this._cells.splice(k,v);this._cells.splice(y,0,...w);const s=[new p(k,v,w.map(o=>o.apiCell),[]),new p(y,0,[],w)];for(const o of s)C.push(o.asApiEvent())}_setCellOutputs(k,v){this._cells[k].setOutputs(v)}_setCellOutputItems(k,v,y,C){this._cells[k].setOutputItems(v,y,C)}_changeCellLanguage(k,v){const y=this._cells[k];y.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelLanguageChanged(y.uri,v)}_changeCellMime(k,v){const y=this._cells[k];y.apiCell.mime=v}_changeCellMetadata(k,v){this._cells[k].setMetadata(v)}_changeCellInternalMetadata(k,v){this._cells[k].setInternalMetadata(v)}getCellFromApiCell(k){return this._cells.find(v=>v.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(v=>v.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=b}),define(Ce[282],De([1,0,4,2,13,7]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(_,b,T,k={timeout:1500,errors:3}){this._logService=_,this._notebooksAndEditors=b,this._mainThreadBulkEdits=T,this._thresholds=k,this._onWillSaveNotebookDocumentEvent=new D.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(_){return(b,T,k)=>{const v=function(C){b.call(T,C)};return v.extension=_,this._onWillSaveNotebookDocumentEvent.event(v,void 0,k)}}async $participateInSave(_,b,T){const k=F.URI.revive(_),v=this._notebooksAndEditors.getNotebookDocument(k);if(!v)throw new Error("Unable to resolve notebook document");const y=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:v.apiNotebook,reason:d.TextDocumentSaveReason.to(b)},T,async(w,s)=>{const o=Date.now(),a=await await Promise.resolve(w);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!T.isCancellationRequested&&a&&(a instanceof R.WorkspaceEdit?y.push(a):this._logService.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),T.isCancellationRequested)return!1;if(y.length===0)return!0;const C={edits:[]};for(const w of y){const{edits:s}=d.WorkspaceEdit.from(w);C.edits=C.edits.concat(s)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(Ce[144],De([1,0,8,13,7]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,_,b,T,k,v){this.id=p,this._proxy=_,this.notebookData=b,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=T,this._viewColumn=v}get apiEditor(){if(!this._editor){const p=this;this._editor={get notebook(){return p.notebookData.apiNotebook},get selection(){return p._selections[0]},set selection(_){this.selections=[_]},get selections(){return p._selections},set selections(_){if(!Array.isArray(_)||!_.every(d.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");p._selections=_,p._trySetSelections(_)},get visibleRanges(){return p._visibleRanges},revealRange(_,b){p._proxy.$tryRevealRange(p.id,F.NotebookRange.from(_),b??d.NotebookEditorRevealType.Default)},get viewColumn(){return p._viewColumn}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(p){this._visible=p}_acceptVisibleRanges(p){this._visibleRanges=p}_acceptSelections(p){this._selections=p}_trySetSelections(p){this._proxy.$trySetSelections(this.id,p.map(F.NotebookRange.from))}_acceptViewColumn(p){this._viewColumn=p}}e.ExtHostNotebookEditor=R}),define(Ce[283],De([1,0,8,4,14,13]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(_,b){this._logService=_,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new F.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new F.Emitter({onListenerError:D.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(_,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,b);const T=this._notebooksAndEditors.getEditorById(_);b.visibleRanges&&T._acceptVisibleRanges(b.visibleRanges.ranges.map(R.NotebookRange.to)),b.selections&&T._acceptSelections(b.selections.selections.map(R.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const b in _)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(R.ViewColumn.to(_[b]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=je([$e(0,d.ILogService)],A)}),define(Ce[284],De([1,0,13,64,208,21,56,8]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(v){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=v}async withProgress(v,y,C){const w=this._handles++,{title:s,location:o,cancellable:a}=y,c={label:(0,d.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this._proxy.$startProgress(w,{location:D.ProgressLocation.from(o),title:s,source:c,cancellable:a},v.isUnderDevelopment?void 0:v.identifier.value).catch(p.onUnexpectedExternalError),this._withProgress(w,C,!!a)}_withProgress(v,y,C){let w;C&&(w=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(v,w));const s=a=>{this._proxy.$progressEnd(a),this._mapHandleToCancellationSource.delete(a),w?.dispose()};let o;try{o=y(new T(this._proxy,v),C&&w?w.token:R.CancellationToken.None)}catch(a){throw s(v),a}return o.then(a=>s(v),a=>s(v)),o}$acceptProgressCanceled(v){const y=this._mapHandleToCancellationSource.get(v);y&&(y.cancel(),this._mapHandleToCancellationSource.delete(v))}}e.ExtHostProgress=_;function b(k,v){return k.message=v.message,typeof v.increment=="number"&&(typeof k.increment=="number"?k.increment+=v.increment:k.increment=v.increment),k}class T extends F.Progress{constructor(v,y){super(C=>this.throttledReport(C)),this._proxy=v,this._handle=y}throttledReport(v){this._proxy.$progressReport(this._handle,v)}}je([(0,A.throttle)(100,(k,v)=>b(k,v),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(Ce[145],De([1,0,34,142,68,109,88,13,2]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const b=(c,g,u,t)=>{let n=g;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!u(n,r)){const i=n;n=r,c.listener?.(t(r,i))}}}},T=(c,g)=>c===g,k={range:(c,g)=>c===g?!0:!c||!g?!1:c.isEqual(g),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(c,g)=>!(c.length!==g.length||c.some(u=>!g.find(t=>u.id===t.id)))},v=c=>g=>({op:4,update:c(g)}),y=(c,g)=>({range:(()=>{let u;const t=v(n=>({range:D.Range.lift(p.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return u},set(n){c.listener?.({op:6}),k.range(u,n)||(u=n,c.listener?.(t(n)))}}})(),label:b(c,g,k.label,v(u=>({label:u}))),description:b(c,void 0,k.description,v(u=>({description:u}))),sortText:b(c,void 0,k.sortText,v(u=>({sortText:u}))),canResolveChildren:b(c,!1,k.canResolveChildren,u=>({op:2,state:u})),busy:b(c,!1,k.busy,v(u=>({busy:u}))),error:b(c,void 0,k.error,v(u=>({error:p.MarkdownString.fromStrict(u)||null}))),tags:b(c,[],k.tags,(u,t)=>({op:1,new:u.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),C=c=>{const g=d.TestId.fromString(c.extId),u=new s(g.controllerId,g.localId,c.label,_.URI.revive(c.uri)||void 0);return u.range=p.Range.to(c.range||void 0),u.description=c.description||void 0,u.sortText=c.sortText||void 0,u.tags=c.tags.map(t=>p.TestTag.to({id:(0,A.denamespaceTestTag)(t).tagId})),u},w=c=>{let g;for(const u of c.tests){const t=C(u.item);(0,F.getPrivateApiFor)(t).parent=g,g=t}return g};e.toItemFromContext=w;class s{constructor(g,u,t,n){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const r=(0,F.createPrivateApiFor)(this,g);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,F.getPrivateApiFor,s),enumerable:!0,writable:!1},...y(r,t)})}}e.TestItemImpl=s;class o extends s{constructor(g,u){super(g,g,u,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class a extends R.TestItemCollection{constructor(g,u,t){super({controllerId:g,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:F.getPrivateApiFor,getChildren:n=>n.children,root:new o(g,u),toITestItem:p.TestItem.from})}}e.ExtHostTestItemCollection=a}),define(Ce[146],De([1,0,57,8,119,13,7]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class p{static{this._Keys=new d.IdGenerator("TextEditorDecorationType")}constructor(v,y,C){const w=p._Keys.nextId();v.$registerTextEditorDecorationType(y.identifier,w,R.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:w,dispose(){v.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=p;class _{constructor(v,y){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=y.undoStopBefore,this._undoStopAfter=y.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,y){this._throwIfFinalized();let C=null;if(v instanceof A.Position)C=new A.Range(v,v);else if(v instanceof A.Range)C=v;else throw new Error("Unrecognized location");this._pushEdit(C,y,!1)}insert(v,y){this._throwIfFinalized(),this._pushEdit(new A.Range(v,v),y,!0)}delete(v){this._throwIfFinalized();let y=null;if(v instanceof A.Range)y=v;else throw new Error("Unrecognized location");this._pushEdit(y,null,!0)}_pushEdit(v,y,C){const w=this._document.validateRange(v);this._collectedEdits.push({range:w,text:y,forceMoveMarkers:C})}setEndOfLine(v){if(this._throwIfFinalized(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=v}}class b{constructor(v,y,C,w){this._proxy=v,this._id=y,this._accept(C),this._logService=w;const s=this;this.value={get tabSize(){return s._tabSize},set tabSize(o){s._setTabSize(o)},get indentSize(){return s._indentSize},set indentSize(o){s._setIndentSize(o)},get insertSpaces(){return s._insertSpaces},set insertSpaces(o){s._setInsertSpaces(o)},get cursorStyle(){return s._cursorStyle},set cursorStyle(o){s._setCursorStyle(o)},get lineNumbers(){return s._lineNumbers},set lineNumbers(o){s._setLineNumbers(o)}}}_accept(v){this._tabSize=v.tabSize,this._indentSize=v.indentSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}_setTabSize(v){const y=this._validateTabSize(v);if(y!==null){if(typeof y=="number"){if(this._tabSize===y)return;this._tabSize=y}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:y}))}}_validateIndentSize(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}_setIndentSize(v){const y=this._validateIndentSize(v);if(y!==null){if(typeof y=="number"){if(this._indentSize===y)return;this._indentSize=y}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:y}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:!!v}_setInsertSpaces(v){const y=this._validateInsertSpaces(v);if(typeof y=="boolean"){if(this._insertSpaces===y)return;this._insertSpaces=y}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:y}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const y={};let C=!1;if(typeof v.tabSize<"u"){const w=this._validateTabSize(v.tabSize);w==="auto"?(C=!0,y.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,C=!0,y.tabSize=w)}if(typeof v.indentSize<"u"){const w=this._validateIndentSize(v.indentSize);w==="tabSize"?(C=!0,y.indentSize=w):typeof w=="number"&&this._indentSize!==w&&(this._indentSize=w,C=!0,y.indentSize=w)}if(typeof v.insertSpaces<"u"){const w=this._validateInsertSpaces(v.insertSpaces);w==="auto"?(C=!0,y.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,C=!0,y.insertSpaces=w)}typeof v.cursorStyle<"u"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,C=!0,y.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,C=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),C&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,y))}_warnOnError(v,y){y.catch(C=>{this._logService.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this._logService.warn(C)})}}e.ExtHostTextEditorOptions=b;class T{constructor(v,y,C,w,s,o,a,c){this.id=v,this._proxy=y,this._logService=C,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=s,this._options=new b(this._proxy,this.id,o,C),this._visibleRanges=a,this._viewColumn=c;const g=this;this.value=Object.freeze({get document(){return w.value},set document(u){throw new F.ReadonlyError("document")},get selection(){return g._selections&&g._selections[0]},set selection(u){if(!(u instanceof A.Selection))throw(0,F.illegalArgument)("selection");g._selections=[u],g._trySetSelection()},get selections(){return g._selections},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");g._selections=u,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(u){throw new F.ReadonlyError("visibleRanges")},get options(){return g._options.value},set options(u){g._disposed||g._options.assign(u)},get viewColumn(){return g._viewColumn},set viewColumn(u){throw new F.ReadonlyError("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new _(w.value,t);return u(n),g._applyEdit(n)},insertSnippet(u,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=g._selections.map(i=>R.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:l}=R.Position.from(t);r=[{startLineNumber:i,startColumn:l,endLineNumber:i,endColumn:l}]}else if(t instanceof A.Range)r=[R.Range.from(t)];else{r=[];for(const i of t)if(i instanceof A.Range)r.push(R.Range.from(i));else{const{lineNumber:l,column:f}=R.Position.from(i);r.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return y.$tryInsertSnippet(v,w.value.version,u.value,r,n)},setDecorations(u,t){const n=t.length===0;n&&!g._hasDecorationsForKey.has(u.key)||(n?g._hasDecorationsForKey.delete(u.key):g._hasDecorationsForKey.add(u.key),g._runOnProxy(()=>{if(R.isDecorationOptionsArr(t))return y.$trySetDecorations(v,u.key,R.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,l=t.length;i<l;i++){const f=t[i];r[4*i]=f.start.line+1,r[4*i+1]=f.start.character+1,r[4*i+2]=f.end.line+1,r[4*i+3]=f.end.character+1}return y.$trySetDecorationsFast(v,u.key,r)}}))},revealRange(u,t){g._runOnProxy(()=>y.$tryRevealRange(v,R.Range.from(u),t||A.TextEditorRevealType.Default))},show(u){y.$tryShowEditor(v,R.ViewColumn.from(u))},hide(){y.$tryHideEditor(v)}})}dispose(){(0,D.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,D.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,D.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,D.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,D.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const y=v.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const C=y.edits.map(s=>s.range);C.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=C.length-1;s<o;s++){const a=C[s].end;if(C[s+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=y.edits.map(s=>({range:R.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,w,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this._logService.warn(y),null))}}e.ExtHostTextEditor=T}),define(Ce[147],De([1,0,5,131]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,D.refineServiceDecorator)(F.IEnvironmentService)}),define(Ce[148],De([1,0,25,4,16,3]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(o,a){this.versionId=o,this.removedDueToLooping=a}}e.DeltaExtensionsResult=A;class p{static isHostExtension(o,a,c){if(a.getExtensionDescription(o))return!1;const g=c.getExtensionDescription(o);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(o,a){this._activationEventsReader=o,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=a,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new D.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const o of this._extensionDescriptions){if(this._extensionsMap.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this._extensionsMap.set(o.identifier,o),this._extensionsArr.push(o);const a=this._activationEventsReader.readActivationEvents(o);if(Array.isArray(a))for(let c of a)c==="onUri"&&(c=`onUri:${D.ExtensionIdentifier.toKey(o.identifier)}`),this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(o)}}set(o){return this._extensionDescriptions=o,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(o,a){this._extensionDescriptions=w(this._extensionDescriptions,a),this._extensionDescriptions=this._extensionDescriptions.concat(o);const c=p._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=w(this._extensionDescriptions,c.map(g=>g.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new A(this._versionId,c)}static _findLoopingExtensions(o){const a=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(n){this._nodesSet.has(n)||(this._nodesSet.add(n),this._nodesArr.push(n))}addArc(n,r){this.addNode(n),this.addNode(r),this._arcs.has(n)?this._arcs.get(n).push(r):this._arcs.set(n,[r])}getArcs(n){return this._arcs.has(n)?this._arcs.get(n):[]}hasOnlyGoodArcs(n,r){const i=a.getArcs(n);for(let l=0;l<i.length;l++)if(!r.has(i[l]))return!1;return!0}getNodes(){return this._nodesArr}},c=new D.ExtensionIdentifierMap;for(const n of o)if(c.set(n.identifier,n),n.extensionDependencies)for(const r of n.extensionDependencies)a.addArc(D.ExtensionIdentifier.toKey(n.identifier),D.ExtensionIdentifier.toKey(r));const g=new Set;a.getNodes().filter(n=>a.getArcs(n).length===0).forEach(n=>g.add(n));const u=a.getNodes().filter(n=>!g.has(n));let t;do{t=!1;for(let n=0;n<u.length;n++){const r=u[n];a.hasOnlyGoodArcs(r,g)&&(u.splice(n,1),n--,g.add(r),t=!0)}}while(t);return u.map(n=>c.get(n))}containsActivationEvent(o){return this._activationMap.has(o)}containsExtension(o){return this._extensionsMap.has(o)}getExtensionDescriptionsForActivationEvent(o){const a=this._activationMap.get(o);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new _(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(o){const a=this._extensionsMap.get(o);return a||void 0}getExtensionDescriptionByUUID(o){for(const a of this._extensionsArr)if(a.uuid===o)return a}getExtensionDescriptionByIdOrUUID(o,a){return this.getExtensionDescription(o)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=p;class _{constructor(o,a){this.versionId=o,this.extensions=a}}e.ExtensionDescriptionRegistrySnapshot=_,e.basicActivationEventsReader={readActivationEvents:s=>s.activationEvents};class b{constructor(o){this._lock=new v,this._actual=new p(o,[])}async acquireLock(o){const a=await this._lock.acquire(o);return new T(this,a)}deltaExtensions(o,a,c){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(a,c)}containsActivationEvent(o){return this._actual.containsActivationEvent(o)}containsExtension(o){return this._actual.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this._actual.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(o){return this._actual.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this._actual.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,a){return this._actual.getExtensionDescriptionByIdOrUUID(o,a)}}e.LockableExtensionDescriptionRegistry=b;class T extends R.Disposable{constructor(o,a){super(),this._registry=o,this._isDisposed=!1,this._register(a)}isAcquiredFor(o){return!this._isDisposed&&this._registry===o}}e.ExtensionDescriptionRegistryLock=T;class k{constructor(o){this.name=o,this.promise=new Promise((a,c)=>{this._resolve=a})}resolve(o){this._resolve(o)}}class v{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(o){const a=new k(o);return this._pendingCustomers.push(a),this._advance(),a.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const o=this._pendingCustomers.shift();this._isLocked=!0;let a=!0;const c=setTimeout(()=>{a&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{a&&(clearTimeout(c),a=!1,this._isLocked=!1,this._advance())};o.resolve((0,R.toDisposable)(g))}}var y;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(y||(y={}));function C(s,o){const a=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(a!==c)return a-c;const g=d.posix.basename(s.extensionLocation.path),u=d.posix.basename(o.extensionLocation.path);return g<u?-1:g>u?1:0}function w(s,o){const a=new D.ExtensionIdentifierSet(o);return s.filter(c=>!a.has(c.identifier))}}),define(Ce[285],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var D;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(k){this.pipeName=k,this.type=1}serialize(k){k[F.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=F;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(k){k[d.ENV_KEY]="1"}}e.SocketExtHostConnection=d;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(k){k[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R;function A(T){delete T[F.ENV_KEY],delete T[d.ENV_KEY],delete T[R.ENV_KEY]}function p(T,k){A(k),T.serialize(k)}e.writeExtHostConnection=p;function _(T){if(T[F.ENV_KEY])return b(T,new F(T[F.ENV_KEY]));if(T[d.ENV_KEY])return b(T,new d);if(T[R.ENV_KEY])return b(T,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=_;function b(T,k){return A(T),k}}),define(Ce[111],De([1,0,22]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(F||(e.UIKind=F={}));var d;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var R;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A(b){const T=D.VSBuffer.alloc(1);switch(b){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=A;function p(b,T){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=p;var _;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(_||(e.NativeLogMarkers=_={}))}),define(Ce[89],De([1,0,5,4,14,26,111,66,85,23,2,3,210]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let y=class extends k.Disposable{constructor(o,a){super(),this.initData=o,this.loggerService=a,this._onDidChangeTelemetryEnabled=this._register(new F.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new F.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=T.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=a.createLogger(this.extHostTelemetryLogFile,{id:_.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(a.onDidChangeLogLevel(c=>{(0,d.isLogLevel)(c)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,a,c){const g=this.getTelemetryDetails(),u=new C(a,c,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}),t=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,a,c){this._level=o,this._telemetryIsSupported=a,this._productConfig=c??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const a=Object.create(null);switch(a["common.extname"]=`${o.publisher}.${o.name}`,a["common.extversion"]=o.version,a["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,a["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,a["common.vscodeversion"]=this.initData.version,a["common.isnewappinstall"]=w(this.initData.telemetryInfo.firstSessionDate),a["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,p.getRemoteName)((0,_.cleanRemoteAuthority)(this.initData.remote.authority)),a}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const a=this.getTelemetryDetails();this._telemetryLoggers.forEach((c,g)=>{const u=c.filter(t=>!t.isDisposed);u.length===0?this._telemetryLoggers.delete(g):this._telemetryLoggers.set(g,u)}),this._telemetryLoggers.forEach(c=>{for(const g of c)g.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,a){const g=this._telemetryLoggers.get(o.value)?.filter(t=>!t.isDisposed);if(!g)return this._telemetryLoggers.delete(o.value),!1;let u=!1;for(const t of g)t.ignoreUnhandledExtHostErrors||(t.logError(a),u=!0);return u}};e.ExtHostTelemetry=y,e.ExtHostTelemetry=y=je([$e(0,R.IExtHostInitDataService),$e(1,d.ILoggerService)],y);class C{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,a,c,g,u,t,n){this._extension=c,this._logger=g,this._inLoggingOnlyMode=u,this._commonProperties=t,this._onDidChangeEnableStates=new F.Emitter,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=a?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=a?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(o,a){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:a},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let a="properties"in o?o.properties??{}:o;return a=(0,_.cleanData)(a,[]),this._additionalCommonProperties&&(a=(0,b.mixin)(a,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(a=(0,b.mixin)(a,this._commonProperties)),"properties"in o?o.properties=a:o=a,o}logEvent(o,a){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,a=this.mixInCommonPropsAndCleanData(a||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,a),this._logger.trace(o,a))}logUsage(o,a){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,a)}logError(o,a){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof o=="string")this.logEvent(o,a);else{const c={name:o.name,message:o.message,stack:o.stack,cause:o.cause},g=(0,_.cleanData)(c,[]),u=new Error(g.message,{cause:g.cause});u.stack=g.stack,u.name=g.name,a=this.mixInCommonPropsAndCleanData(a||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(u,a),this._logger.trace("exception",a)}}get apiTelemetryLogger(){if(!this._apiObject){const o=this,a={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(a)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=C;function w(s){const o=Date.now()-new Date(s).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=w,e.IExtHostTelemetry=(0,D.createDecorator)("IExtHostTelemetry")}),define(Ce[27],De([1,0,4,2,252,137,25,5]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,p.createDecorator)("extensionService");class _{constructor(u){this.dependency=u}}e.MissingExtensionDependency=_;var b;(function(g){g[g.EagerAutoStart=1]="EagerAutoStart",g[g.EagerManualStart=2]="EagerManualStart",g[g.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class T{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(u,t,n){this._versionId=u,this._allExtensions=t.slice(0),this._myExtensions=n.slice(0)}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(u,t,n){if(this._versionId>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this._versionId})`);const r=[],i=[],l=[],f=[],S=k(this._allExtensions),I=k(t),E=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this._allExtensions){const L=I.get(N.identifier);if(!L){r.push(N.identifier),S.delete(N.identifier);continue}if(!E(N,L)){r.push(N.identifier),S.delete(N.identifier);continue}}for(const N of t){const L=S.get(N.identifier);if(!L){i.push(N);continue}if(!E(L,N)){r.push(L.identifier),S.delete(L.identifier);continue}}const h=new A.ExtensionIdentifierSet(this._myExtensions),m=new A.ExtensionIdentifierSet(n);for(const N of this._myExtensions)m.has(N)||l.push(N);for(const N of n)h.has(N)||f.push(N);const P=R.ImplicitActivationEvents.createActivationEventsMap(i),O={versionId:u,toRemove:r,toAdd:i,addActivationEvents:P,myToRemove:l,myToAdd:f};return this.delta(O),O}delta(u){if(this._versionId>=u.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=u,l=new A.ExtensionIdentifierSet(t),f=new A.ExtensionIdentifierSet(r);for(let S=0;S<this._allExtensions.length;S++)l.has(this._allExtensions[S].identifier)&&(this._allExtensions.splice(S,1),S--);for(let S=0;S<this._myExtensions.length;S++)f.has(this._myExtensions[S])&&(this._myExtensions.splice(S,1),S--);for(const S of n)this._allExtensions.push(S);for(const S of i)this._myExtensions.push(S);return u}containsExtension(u){for(const t of this._myExtensions)if(A.ExtensionIdentifier.equals(t,u))return!0;return!1}}e.ExtensionHostExtensions=T;function k(g){const u=new A.ExtensionIdentifierMap;for(const t of g)u.set(t.identifier,t);return u}function v(g,u){return g.enabledApiProposals?g.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function y(g,u){if(!v(g,u))throw new Error(`Extension '${g.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${g.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.checkProposedApiEnabled=y;class C{constructor(u,t,n,r){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.ActivationTimes=C;class w{constructor(u,t){this.description=u,this.value=t}}e.ExtensionPointContribution=w;var s;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,d.getGalleryExtensionId)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation,targetPlatform:g.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function a(g,u){return{identifier:new A.ExtensionIdentifier((0,d.getExtensionId)(g.manifest.publisher,g.manifest.name)),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!!u,extensionLocation:g.location,...g.manifest,uuid:g.identifier.uuid,targetPlatform:g.targetPlatform}}e.toExtensionDescription=a;class c{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(Ce[286],De([1,0,8,148,25,27,14,9]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class _{static{this.NONE=new _(!1,-1,-1,-1)}constructor(o,a,c,g){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=c,this.activateResolvedTime=g}}e.ExtensionActivationTimes=_;class b{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,a){return o===-1||a===-1?-1:a-o}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class T{constructor(o,a,c,g,u,t){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=c,this.module=g,this.exports=u,this.subscriptions=t}}e.ActivatedExtension=T;class k extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class v extends T{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class y extends T{constructor(o){super(!0,o,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(o,a,c,g){this._logService=g,this._registry=o,this._globalRegistry=a,this._host=c,this._operations=new d.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,a]of this._operations)a.dispose()}async waitForActivatingExtensions(){const o=[];for(const[a,c]of this._operations)o.push(c.wait());await Promise.all(o)}isActivated(o){const a=this._operations.get(o);return!!(a&&a.value)}getActivatedExtension(o){const a=this._operations.get(o);if(!a||!a.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return a.value}async activateByEvent(o,a){if(this._alreadyActivatedEvents[o])return;const c=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(c.map(g=>({id:g.identifier,reason:{startup:a,extensionId:g.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,a){const c=this._registry.getExtensionDescription(o);if(!c)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:c.identifier,reason:a}])}async _activateExtensions(o){const a=o.filter(c=>!this.isActivated(c.id)).map(c=>this._handleActivationRequest(c));await Promise.all(a.map(c=>c.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const a=this._registry.getExtensionDescription(o.id);if(!a){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this._createAndSaveOperation(o,null,[],new y(u));return this._host.onExtensionActivationError(o.id,u,new R.MissingExtensionDependency(o.id.value)),t}const c=[],g=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const u of g){if(this._isResolvedExtension(u))continue;const t=this._operations.get(u);if(t){c.push(t);continue}if(this._isHostExtension(u)){c.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(u).identifier,reason:o.reason}));continue}const n=this._registry.getExtensionDescription(u);if(n){if(!n.main&&!n.browser)continue;c.push(this._handleActivationRequest({id:n.identifier,reason:o.reason}));continue}const r=a.displayName||a.identifier.value,i=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${u}'`),l=this._createAndSaveOperation(o,a.displayName,[],new y(i));return this._host.onExtensionActivationError(a.identifier,i,new R.MissingExtensionDependency(u)),l}return this._createAndSaveOperation(o,a.displayName,c,null)}_createAndSaveOperation(o,a,c,g){const u=new w(o.id,a,o.reason,c,g,this._host,this._logService);return this._operations.set(o.id,u),u}_isHostExtension(o){return F.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const a=this._globalRegistry.getExtensionDescription(o);return a?!a.main&&!a.browser:!1}};e.ExtensionsActivator=C,e.ExtensionsActivator=C=je([$e(3,A.ILogService)],C);let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,a,c,g,u,t,n){this._id=o,this._displayName=a,this._reason=c,this._deps=g,this._value=u,this._host=t,this._logService=n,this._barrier=new p.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const a=this._deps[o];if(a.value&&!a.value.activationFailed){this._deps.splice(o,1),o--;continue}if(a.value&&a.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);c.detail=a.value.activationFailedError,this._value=new y(c),this._host.onExtensionActivationError(this._id,c,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const a=new Error;if(o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this._value=new y(a),this._isDisposed&&D.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};w=je([$e(6,A.ILogService)],w)}),define(Ce[287],De([1,0,212,24,2,4,3,269,9,7,18,19,13,80,21,173,27]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(g,u){if((0,T.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let t;return Array.isArray(g.highlights)&&(t=g.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:g.label,highlights:t}}}class a extends A.Disposable{constructor(u,t,n){super(),this._proxy=u,this.commands=t,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeViewsDnDService;function r(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>r(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(l=>r(l)?this.convertArgument(l):l):i})}registerTreeDataProvider(u,t,n){const r=this.createTreeView(u,{treeDataProvider:t},n);return{dispose:()=>r.dispose()}}createTreeView(u,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,f=!!t.dragAndDropController?.handleDrop,S=this.createExtHostTreeView(u,t,n),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:i,hasHandleDrag:l,hasHandleDrop:f,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},E=this._proxy.$registerTreeViewDataProvider(u,I),h={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,s.checkProposedApiEnabled)(n,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,s.checkProposedApiEnabled)(n,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(m){(0,y.isMarkdownString)(m)&&(0,s.checkProposedApiEnabled)(n,"treeViewMarkdownMessage"),S.message=m},get title(){return S.title},set title(m){S.title=m},get description(){return S.description},set description(m){S.description=m},get badge(){return S.badge},set badge(m){m!==void 0&&b.ViewBadge.isViewBadge(m)?S.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(S.badge=void 0)},reveal:(m,P)=>S.reveal(m,P),dispose:async()=>{await E,this.treeViews.delete(u),S.dispose()}};return this._register(h),h}$getChildren(u,t){const n=this.treeViews.get(u);return n?n.getChildren(t):Promise.reject(new p.NoTreeViewError(u))}async $handleDrop(u,t,n,r,i,l,f,S){const I=this.treeViews.get(u);if(!I)return Promise.reject(new p.NoTreeViewError(u));const E=v.DataTransfer.toDataTransfer(n,async h=>(await this._proxy.$resolveDropFileData(u,t,h)).buffer);return f===u&&S&&await this.addAdditionalTransferItems(E,I,S,i,l),I.onDrop(E,r,i)}async addAdditionalTransferItems(u,t,n,r,i){const l=this.treeDragAndDropService.removeDragOperationTransfer(i);if(l)(await l)?.forEach((f,S)=>{f&&u.set(S,f)});else if(i&&t.handleDrag){const f=t.handleDrag(n,u,r);this.treeDragAndDropService.addDragOperationTransfer(i,f),await f}return u}async $handleDrag(u,t,n,r){const i=this.treeViews.get(u);if(!i)return Promise.reject(new p.NoTreeViewError(u));const l=await this.addAdditionalTransferItems(new b.DataTransfer,i,t,r,n);if(!(!l||r.isCancellationRequested))return v.DataTransfer.from(l)}async $hasResolve(u){const t=this.treeViews.get(u);if(!t)throw new p.NoTreeViewError(u);return t.hasResolve}$resolve(u,t,n){const r=this.treeViews.get(u);if(!r)throw new p.NoTreeViewError(u);return r.resolveTreeItem(t,n)}$setExpanded(u,t,n){const r=this.treeViews.get(u);if(!r)throw new p.NoTreeViewError(u);r.setExpanded(t,n)}$setSelectionAndFocus(u,t,n){const r=this.treeViews.get(u);if(!r)throw new p.NoTreeViewError(u);r.setSelectionAndFocus(t,n)}$setVisible(u,t){const n=this.treeViews.get(u);if(!n){if(!t)return;throw new p.NoTreeViewError(u)}n.setVisible(t)}$changeCheckboxState(u,t){const n=this.treeViews.get(u);if(!n)throw new p.NoTreeViewError(u);n.setCheckboxState(t)}createExtHostTreeView(u,t,n){const r=this._register(new c(u,t,this._proxy,this.commands.converter,this.logService,n));return this.treeViews.set(u,r),r}convertArgument(u){const t=this.treeViews.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=a;class c extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,T.isUndefinedOrNull)(u))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(u,t,n,r,i,l){if(super(),this.viewId=u,this.proxy=n,this.commands=r,this.logService=i,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new R.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new C.CancellationTokenSource,l.contributes&&l.contributes.views)for(const E in l.contributes.views)for(const h of l.contributes.views[E])h.id===u&&(this._title=h.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(E=>this._onDidChangeData.fire({message:!1,element:E})));let f,S;const I=R.Event.debounce(this._onDidChangeData.event,(E,h)=>(E||(E={message:!1,elements:[]}),h.element!==!1&&(f||(f=new Promise(m=>S=m),this.refreshPromise=this.refreshPromise.then(()=>f)),Array.isArray(h.element)?E.elements.push(...h.element):E.elements.push(h.element)),h.message&&(E.message=!0),E),200,!0);this._register(I(({message:E,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=S;return f=null,this.refresh(h).then(()=>m())})),E&&this.proxy.$setMessage(this.viewId,v.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(u);return n||(n=await this.fetchChildrenNodes(t)),n?n.map(r=>r.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const n=(0,T.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,T.isUndefinedOrNull)(t.focus)?!1:t.focus,i=(0,T.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(l=>this.resolveTreeNode(u,l[l.length-1]).then(f=>this.proxy.$reveal(this.viewId,{item:f.item,parentChain:l.map(S=>S.item)},{select:n,focus:r,expand:i})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:r,expand:i})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}get badge(){return this._badge}set badge(u){this._badge?.value===u?.value&&this._badge?.tooltip===u?.tooltip||(this._badge=v.ViewBadge.from(u),this.proxy.$setBadge(this.viewId,u))}setExpanded(u,t){const n=this.getExtensionElement(u);n&&(t?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelectionAndFocus(u,t){const n=!(0,k.equals)(this._selectedHandles,u);this._selectedHandles=u;const r=this._focusedHandle!==t;this._focusedHandle=t,n&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),r&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async n=>{const r=this.getExtensionElement(n.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:n.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(u,t,n){const r=[];for(const i of u){const l=this.getExtensionElement(i);l&&r.push(l)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,n),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,t,n){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,_.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,u,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,t){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(u);if(n){const r=this.nodes.get(n);if(r){const i=await this.dataProvider.resolveTreeItem(r.extensionItem,n,t)??r.extensionItem;return this.validateTreeItem(i),r.item.tooltip=this.getTooltip(i.tooltip),r.item.command=this.getCommand(r.disposableStore,i.command),r.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(t=>t?this.resolveUnknownParentChain(t).then(n=>this.resolveTreeNode(t,n[n.length-1]).then(r=>(n.push(r),n))):Promise.resolve([]))}resolveParent(u){const t=this.nodes.get(u);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,t){const n=this.nodes.get(u);return n?Promise.resolve(n):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(r=>this.createHandle(u,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(r);if(i){const l=this.nodes.get(i);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(u){if(u){let t;if(typeof u=="string"){const n=this.getExtensionElement(u);t=n?this.nodes.get(n):void 0}else t=u;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const t=new C.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=u?this.nodes.get(u):void 0,r=await this.dataProvider.getChildren(u);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,k.coalesce)(r||[]).map(async l=>{const f=await this.dataProvider.getTreeItem(l);return f&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(l,f,n):null}));return t.token.isCancellationRequested?void 0:(0,k.coalesce)(i)}finally{t.dispose()}}refresh(u){if(u.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new C.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(u);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const t=new Set,n=u.map(i=>this.nodes.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let l=i;for(;l&&l.parent&&n.findIndex(f=>l&&l.parent&&f&&f.item.handle===l.parent.item.handle)===-1;){const f=this.elements.get(l.parent.item.handle);l=f?this.nodes.get(f):void 0}l&&!l.parent&&t.add(i.item.handle)}const r=[];return t.forEach(i=>{const l=this.elements.get(i);if(l){const f=this.nodes.get(l);f&&(!f.parent||!t.has(f.parent.item.handle))&&r.push(i)}}),r}refreshHandles(u){const t={};return Promise.all(u.map(n=>this.refreshNode(n).then(r=>{r&&(t[n]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(u){const t=this.getExtensionElement(u);if(t){const n=this.nodes.get(t);if(n)return this.clearChildren(t),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const i=this.createTreeNode(t,r,n.parent);return this.updateNodeCache(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,t,n){const r=this.createTreeNode(u,t,n);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.addNodeToCache(u,r),this.addNodeToParentCache(r,n),r}getTooltip(u){return b.MarkdownString.isMarkdownString(u)?v.MarkdownString.from(u):u}getCommand(u,t){return t?{...this.commands.toInternal(t,u),originalId:t.command}:void 0}getCheckbox(u){if(u.checkboxState===void 0)return;let t,n,r;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,n=u.checkboxState.tooltip,r=u.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:r}}validateTreeItem(u){if(!b.TreeItem.isTreeItem(u,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(u,t,n){this.validateTreeItem(t);const r=this._register(new A.DisposableStore),i=this.createHandle(u,t,n),l=this.getLightIconPath(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:o(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:l,iconDark:this.getDarkIconPath(t)||l,themeIcon:this.getThemeIcon(t),collapsibleState:(0,T.isUndefinedOrNull)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:n,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(u){return u.iconPath instanceof b.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:t,label:n,resourceUri:r},i,l){if(t)return`${c.ID_HANDLE_PREFIX}/${t}`;const f=o(n,this.extension),S=i?i.item.handle:c.LABEL_HANDLE_PREFIX;let I=f?f.label:r?(0,F.basename)(r):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const E=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,h=this.getChildrenNodes(i)||[];let m,P=0;do{if(m=`${S}/${P}:${I}`,l||!this.elements.has(m)||E===m)break;P++}while(P<=h.length);return m}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof b.ThemeIcon))return typeof u.iconPath=="string"||d.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof b.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return d.URI.isUri(u)?u:d.URI.file(u)}addNodeToCache(u,t){this.elements.set(t.item.handle,u),this.nodes.set(u,t)}updateNodeCache(u,t,n,r){this.elements.delete(t.item.handle),this.nodes.delete(u),t.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(u,t);const i=this.getChildrenNodes(r)||[],l=i.filter(f=>f.item.handle===n.item.handle)[0];l&&i.splice(i.indexOf(l),1,t)}addNodeToParentCache(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const t=this.nodes.get(u);if(t){if(t.children)for(const n of t.children){const r=this.elements.get(n.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(u){const t=this.nodes.get(u);if(t){if(t.children)for(const n of t.children){const r=this.elements.get(n.item.handle);r&&this.clear(r)}this.nodes.delete(u),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Ce[288],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[289],De([1,0,224,8,38,132,106,42,25,288,135,137]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=p.Registry.as(A.Extensions.JSONContribution);class y{constructor(u,t,n){this._messageHandler=u,this._extension=t,this._extensionPointId=n}_msg(u,t){this._messageHandler({type:u,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(u){this._msg(d.default.Error,u)}warn(u){this._msg(d.default.Warning,u)}info(u){this._msg(d.default.Info,u)}}e.ExtensionMessageCollector=y;class C{static _toSet(u){const t=new _.ExtensionIdentifierSet;for(let n=0,r=u.length;n<r;n++)t.add(u[n].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new C(t,[]);if(!t||!t.length)return new C([],u);const n=this._toSet(u),r=this._toSet(t),i=t.filter(f=>!n.has(f.description.identifier)),l=u.filter(f=>!r.has(f.description.identifier));return new C(i,l)}constructor(u,t){this.added=u,this.removed=t}}e.ExtensionPointUserDelta=C;class w{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(u){if(this._handler!==null)throw new Error("Handler already set!");this._handler=u,this._handle()}acceptUsers(u){this._delta=C.compute(this._users,u),this._users=u,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(u){(0,F.onUnexpectedError)(u)}}}e.ExtensionPoint=w;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:_.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"*",description:D.localize(42,null),body:"*"}]}},badges:{type:"array",description:D.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(44,null)},href:{type:"string",description:D.localize(45,null)},description:{type:"string",description:D.localize(46,null)}}}},markdown:{type:"string",description:D.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:D.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(52,null)},{body:["workspace"],description:D.localize(53,null)},{body:["ui","workspace"],description:D.localize(54,null)},{body:["workspace","ui"],description:D.localize(55,null)},{body:[],description:D.localize(56,null)}]},capabilities:{description:D.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(60,null),D.localize(61,null),D.localize(62,null)]},description:{type:"string",markdownDescription:D.localize(63,null)}}},untrustedWorkspaces:{description:D.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(66,null),D.localize(67,null),D.localize(68,null)]},restrictedConfigurations:{description:D.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(70,null)}}}}},sponsor:{description:D.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(73,null),type:"string"},"vscode:uninstall":{description:D.localize(74,null),type:"string"}}},icon:{type:"string",description:D.localize(75,null)},l10n:{type:"string",description:D.localize(76,null)},pricing:{type:"string",markdownDescription:D.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(u){if(this._extensionPoints.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new w(u.extensionPoint,u.defaultExtensionKind);return this._extensionPoints.set(u.extensionPoint,t),u.activationEventsGenerator&&k.ImplicitActivationEvents.register(u.extensionPoint,u.activationEventsGenerator),e.schema.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,v.registerSchema(o,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const c={ExtensionsRegistry:"ExtensionsRegistry"};p.Registry.add(c.ExtensionsRegistry,new a),e.ExtensionsRegistry=p.Registry.as(c.ExtensionsRegistry),v.registerSchema(o,e.schema),v.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:D.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Ce[290],De([1,0,221,18,23,289,41,4]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const _={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var b;(function(v){function y(C,w,s){if(!C)return;const o=F.isString(C.type)?C.type:void 0;if(!o||o.length===0){s.error(D.localize(3,null));return}const a=[];if(Array.isArray(C.required))for(const c of C.required)F.isString(c)&&a.push(c);return{extensionId:w.value,taskType:o,required:a,properties:C.properties?d.deepClone(C.properties):{},when:C.when?A.ContextKeyExpr.deserialize(C.when):void 0}}v.from=y})(b||(b={}));const T=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,y)=>{for(const C of v)C.type&&y.push(`onTaskType:${C.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:_}});class k{constructor(){this._onDefinitionsChanged=new p.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((y,C)=>{T.setHandler((w,s)=>{this._schema=void 0;try{for(const o of s.removed){const a=o.value;for(const c of a)this.taskTypes&&c.type&&this.taskTypes[c.type]&&delete this.taskTypes[c.type]}for(const o of s.added){const a=o.value;for(const c of a){const g=b.from(c,o.description.identifier,o.collector);g&&(this.taskTypes[g.taskType]=g)}}(s.removed.length>0||s.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}y(void 0)})})}onReady(){return this.readyPromise}get(y){return this.taskTypes[y]}all(){return Object.keys(this.taskTypes).map(y=>this.taskTypes[y])}getJsonSchema(){if(this._schema===void 0){const y=[];for(const C of this.all()){const w={type:"object",additionalProperties:!1};C.required.length>0&&(w.required=C.required.slice(0)),C.properties!==void 0?w.properties=d.deepClone(C.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[C.taskType]},y.push(w)}this._schema={oneOf:y}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(Ce[291],De([1,0,222,18,24,23,41,290]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,D.localize(0,null)),e.TASKS_CATEGORY={value:D.localize(1,null),original:"Tasks"};var _;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(_||(e.ShellQuoting=_={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(x){function M(H){if(!H)return x.Strong;switch(H.toLowerCase()){case"escape":return x.Escape;case"strong":return x.Strong;case"weak":return x.Weak;default:return x.Strong}}x.from=M}(_||(e.ShellQuoting=_={}));var b;(function(x){x.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var T;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(T||(e.RevealKind=T={})),function(x){function M(H){switch(H.toLowerCase()){case"always":return x.Always;case"silent":return x.Silent;case"never":return x.Never;default:return x.Always}}x.fromString=M}(T||(e.RevealKind=T={}));var k;(function(x){x[x.Never=1]="Never",x[x.OnProblem=2]="OnProblem",x[x.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(x){function M(H){switch(H.toLowerCase()){case"always":return x.Always;case"never":return x.Never;case"onproblem":return x.OnProblem;default:return x.OnProblem}}x.fromString=M}(k||(e.RevealProblemKind=k={}));var v;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(v||(e.PanelKind=v={})),function(x){function M(H){switch(H.toLowerCase()){case"shared":return x.Shared;case"dedicated":return x.Dedicated;case"new":return x.New;default:return x.Shared}}x.fromString=M}(v||(e.PanelKind=v={}));var y;(function(x){x.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var C;(function(x){x[x.Shell=1]="Shell",x[x.Process=2]="Process",x[x.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(x){function M(j){switch(j.toLowerCase()){case"shell":return x.Shell;case"process":return x.Process;case"customExecution":return x.CustomExecution;default:return x.Process}}x.fromString=M;function H(j){switch(j){case x.Shell:return"shell";case x.Process:return"process";case x.CustomExecution:return"customExecution";default:return"process"}}x.toString=H}(C||(e.RuntimeType=C={}));var w;(function(x){function M(H){return F.isString(H)?H:H.value}x.value=M})(w||(e.CommandString=w={}));var s;(function(x){x.Clean={_id:"clean",isDefault:!1},x.Build={_id:"build",isDefault:!1},x.Rebuild={_id:"rebuild",isDefault:!1},x.Test={_id:"test",isDefault:!1};function M(j){return j===x.Clean._id||j===x.Build._id||j===x.Rebuild._id||j===x.Test._id}x.is=M;function H(j){if(j!==void 0)return F.isString(j)?M(j)?{_id:j,isDefault:!1}:void 0:j}x.from=H})(s||(e.TaskGroup=s={}));var o;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var a;(function(x){x.Workspace="workspace",x.Extension="extension",x.InMemory="inMemory",x.WorkspaceFile="workspaceFile",x.User="user";function M(H){switch(H){case x.User:return 2;case x.WorkspaceFile:return 5;default:return 6}}x.toConfigurationTarget=M})(a||(e.TaskSourceKind=a={}));var c;(function(x){x.parallel="parallel",x.sequence="sequence"})(c||(e.DependsOrder=c={}));var g;(function(x){x[x.default=1]="default",x[x.folderOpen=2]="folderOpen"})(g||(e.RunOnOptions=g={}));var u;(function(x){x.defaults={reevaluateOnRerun:!0,runOn:g.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(M,H,j,fe,Y,X){this._label="",this._id=M,H&&(this._label=H),j&&(this.type=j),this.runOptions=fe,this.configurationProperties=Y,this._source=X}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,H=!1){if(M===void 0)return!1;if(F.isString(M))return M===this._label||M===this.configurationProperties.identifier||H&&M===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class n extends t{constructor(M,H,j,fe,Y,X,z,J){super(M,j,void 0,z,J,H),this.command={},this._source=H,this.hasDefinedMatchers=X,Y&&(this.command=Y)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case C.Shell:H="shell";break;case C.Process:H="process";break;case C.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(M){return M instanceof n}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.getFolderId();if(!M)return;let H=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:H};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new n(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=n;class r extends t{constructor(M,H,j,fe,Y,X,z){super(M,j,fe,X,z,H),this._source=H,this.configures=Y}static is(M){return M instanceof r}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===a.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.getFolderId();if(!M)return;let H=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:H};return JSON.stringify(j)}}e.ConfiguringTask=r;class i extends t{constructor(M,H,j,fe,Y,X,z,J,ge){super(M,j,fe,J,ge,H),this.defines=Y,this.hasDefinedMatchers=z,this.command=X,this.icon=ge.icon,this.hide=ge.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof i}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new i(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=i;class l extends t{constructor(M,H,j,fe,Y,X){super(M,j,fe,Y,X,H),this._source=H}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new l(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=l;var f;(function(x){x[x.Process=1]="Process",x[x.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(x){x._default=x.Terminal}(f||(e.ExecutionEngine=f={}));var S;(function(x){x[x.V0_1_0=1]="V0_1_0",x[x.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(M){this._order=new Map;for(let H=0;H<M.length;H++)this._order.set(M[H].uri.toString(),H)}compare(M,H){const j=M.getWorkspaceFolder(),fe=H.getWorkspaceFolder();if(j&&fe){let Y=this._order.get(j.uri.toString());Y=Y===void 0?0:Y+1;let X=this._order.get(fe.uri.toString());return X=X===void 0?0:X+1,Y===X?M._label.localeCompare(H._label):Y-X}else return!j&&fe?-1:j&&!fe?1:0}}e.TaskSorter=I;var E;(function(x){x.DependsOnStarted="dependsOnStarted",x.AcquiredInput="acquiredInput",x.Start="start",x.ProcessStarted="processStarted",x.Active="active",x.Inactive="inactive",x.Changed="changed",x.Terminated="terminated",x.ProcessEnded="processEnded",x.End="end"})(E||(e.TaskEventKind=E={}));var h;(function(x){x.SingleRun="singleRun",x.Background="background"})(h||(e.TaskRunType=h={}));var m;(function(x){x[x.System=0]="System",x[x.User=1]="User",x[x.FolderOpen=2]="FolderOpen",x[x.ConfigurationChange=3]="ConfigurationChange",x[x.Reconnect=4]="Reconnect"})(m||(e.TaskRunSource=m={}));var P;(function(x){function M(J){return{taskId:J._id,taskName:J.configurationProperties.name,runType:J.configurationProperties.isBackground?"background":"singleRun",group:J.configurationProperties.group,__task:J}}function H(J,ge,le){return{...M(J),kind:"start",terminalId:ge,resolvedVariables:le}}x.start=H;function j(J,ge,le){return{...M(J),kind:"processStarted",terminalId:ge,processId:le}}x.processStarted=j;function fe(J,ge,le){return{...M(J),kind:"processEnded",terminalId:ge,exitCode:le}}x.processEnded=fe;function Y(J,ge,le){return{...M(J),kind:"terminated",exitReason:le,terminalId:ge}}x.terminated=Y;function X(J,ge,le){return{...M(ge),kind:J,terminalId:le}}x.general=X;function z(){return{kind:"changed"}}x.changed=z})(P||(e.TaskEvent=P={}));var O;(function(x){function M(j){const fe=Object.keys(j).sort();let Y="";for(const X of fe){let z=j[X];z instanceof Object?z=M(z):typeof z=="string"&&(z=z.replace(/,/g,",,")),Y+=X+","+z+","}return Y}function H(j){const Y={_key:M(j),type:j.taskType};return Object.assign(Y,j),Y}x.create=H})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(x){x.AutoDetect="task.autoDetect",x.SaveBeforeRun="task.saveBeforeRun",x.ShowDecorations="task.showDecorations",x.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",x.SlowProviderWarning="task.slowProviderWarning",x.QuickOpenHistory="task.quickOpen.history",x.QuickOpenDetail="task.quickOpen.detail",x.QuickOpenSkip="task.quickOpen.skip",x.QuickOpenShowAll="task.quickOpen.showAll",x.AllowAutomaticTasks="task.allowAutomaticTasks",x.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var L;(function(x){x.Tasks="tasks",x.SuppressTaskName="tasks.suppressTaskName",x.Windows="tasks.windows",x.Osx="tasks.osx",x.Linux="tasks.linux",x.ShowOutput="tasks.showOutput",x.IsShellCommand="tasks.isShellCommand",x.ServiceTestSetting="tasks.service.testSetting"})(L||(e.TasksSchemaProperties=L={}));var U;(function(x){function M(H,j){const fe=p.TaskDefinitionRegistry.get(H.type);if(fe===void 0){const J=R.deepClone(H);return delete J._key,O.create(J)}const Y=Object.create(null);Y.type=fe.taskType;const X=new Set;fe.required.forEach(J=>X.add(J));const z=fe.properties;for(const J of Object.keys(z)){const ge=H[J];if(ge!=null)Y[J]=ge;else if(X.has(J)){const le=z[J];if(le.default!==void 0)Y[J]=R.deepClone(le.default);else switch(le.type){case"boolean":Y[J]=!1;break;case"number":case"integer":Y[J]=0;break;case"string":Y[J]="";break;default:j.error(D.localize(2,null,JSON.stringify(H,void 0,0),J));return}}}return O.create(Y)}x.createTaskIdentifier=M})(U||(e.TaskDefinition=U={}))}),define(Ce[292],De([1,0,8]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,p)=>{this._actualOk=A,this._actualErr=p,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,D.onUnexpectedError)(A))}then(A,p){return this._ensureActual().then(A,p)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F;class d extends F{constructor(){super(),this._hasErr=!0,this._err=new D.CancellationError}}e.CanceledLazyPromise=d}),define(Ce[69],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class D{static{this.count=0}constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++D.count}}e.ProxyIdentifier=D;const F=[];function d(p){const _=new D(p);return F[_.nid]=_,_}e.createProxyIdentifier=d;function R(p){return F[p].sid}e.getStringIdentifierForProxy=R;class A{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=A}),define(Ce[6],De([1,0,69]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var d;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var R;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var p;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var _;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(_||(e.CellOutputKind=_={}));var b;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var T;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class k{static{this._n=0}static mixin(s){return s._id=k._n++,s}}e.IdObject=k;var v;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var C;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.MainContext={MainThreadAuthentication:(0,D.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,D.createProxyIdentifier)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,D.createProxyIdentifier)("MainThreadChatAgents"),MainThreadChatVariables:(0,D.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,D.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,D.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,D.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,D.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,D.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,D.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,D.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,D.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,D.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,D.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,D.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,D.createProxyIdentifier)("ExtHostChat"),ExtHostChatSlashCommands:(0,D.createProxyIdentifier)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,D.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.createProxyIdentifier)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,D.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ce[293],De([1,0,6,7]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class d{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(D.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,p,_){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const b=this._relatedInformationProviders.get(A);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation(p,_)??[]}getRelatedInformation(A,p,_){return this._proxy.$getAiRelatedInformation(p,_)}registerRelatedInformationProvider(A,p,_){const b=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(b,_),this._proxy.$registerAiRelatedInformationProvider(b,p),new F.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(b),this._relatedInformationProviders.delete(b)})}}e.ExtHostRelatedInformation=d}),define(Ce[90],De([1,0,5,14,6,20]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,D.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(_,b){this._extHostLogService=b,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(d.MainContext.MainThreadTelemetry)}report(_,b,T){const k=this.getUsageKey(_,b);this._reportedUsages.has(k)||(this._reportedUsages.add(k),b.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:_}))}getUsageKey(_,b){return`${_}-${b.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=je([$e(0,R.IExtHostRpcService),$e(1,F.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(p,_,b){}})}),define(Ce[294],De([1,0,4,6,7,25]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new D.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new p,this._getSessionsTaskSingler=new p,this._proxy=b.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,T,k,v={}){const y=R.ExtensionIdentifier.toKey(b.identifier),C=[...k].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${y} ${T} ${C}`,async()=>{await this._proxy.$ensureProvider(T);const w=b.displayName||b.name;return this._proxy.$getSession(T,k,y,w,v)})}async getSessions(b,T,k){const v=R.ExtensionIdentifier.toKey(b.identifier),y=[...k].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${v} ${y}`,async()=>{await this._proxy.$ensureProvider(T);const C=b.displayName||b.name;return this._proxy.$getSessions(T,k,v,C)})}async removeSession(b,T){const k=this._authenticationProviders.get(b);return k?k.provider.removeSession(T):this._proxy.$removeSession(b,T)}registerAuthenticationProvider(b,T,k,v){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:T,provider:k,options:v??{supportsMultipleAccounts:!1}}),this._providers.find(C=>C.id===b)||this._providers.push({id:b,label:T});const y=k.onDidChangeSessions(C=>{this._proxy.$sendDidChangeSessions(b,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,T,v?.supportsMultipleAccounts??!1),new d.Disposable(()=>{y.dispose(),this._authenticationProviders.delete(b);const C=this._providers.findIndex(w=>w.id===b);C>-1&&this._providers.splice(C),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,T,k){const v=this._authenticationProviders.get(b);if(v)return Promise.resolve(v.provider.createSession(T,k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,T){const k=this._authenticationProviders.get(b);if(k)return Promise.resolve(k.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,T){const k=this._authenticationProviders.get(b);if(k)return Promise.resolve(k.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,T){return this._onDidChangeSessions.fire({provider:{id:b,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=A;class p{constructor(){this._inFlightPromises=new Map}getOrCreate(b,T){const k=this._inFlightPromises.get(b);if(k)return k;const v=T().finally(()=>this._inFlightPromises.delete(b));return this._inFlightPromises.set(b,v),v}}}),define(Ce[295],De([1,0,6,20,13]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(p,_){this._proxy=p.getProxy(D.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:b=>_.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,_,b){const T=d.WorkspaceEdit.from(p,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(T,void 0,b?.isRefactoring??!1)}};e.ExtHostBulkEdits=R,e.ExtHostBulkEdits=R=je([$e(0,F.IExtHostRpcService)],R)}),define(Ce[296],De([1,0,9,4,50,3,37,202,6,13]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class T{static{this._pool=0}constructor(y,C){this.extension=y,this.provider=C,this.handle=T._pool++}}class k{static{this._nextId=0}constructor(y,C){this.logService=C,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new F.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=y.getProxy(_.MainContext.MainThreadChat)}registerChatProvider(y,C,w){const s=new T(y,w);return this._chatProvider.set(s.handle,s),this._proxy.$registerChatProvider(s.handle,C),(0,R.toDisposable)(()=>{this._proxy.$unregisterChatProvider(s.handle),this._chatProvider.delete(s.handle)})}transferChatSession(y,C){const w=d.Iterable.find(this._chatSessions.keys(),s=>this._chatSessions.get(s)===y)??0;typeof w=="number"&&this._proxy.$transferChatSession(w,C)}addChatRequest(y){this._proxy.$addRequest(y)}sendInteractiveRequestToProvider(y,C){this._proxy.$sendRequestToProvider(y,C)}async $prepareChat(y,C,w){const s=this._chatProvider.get(y);if(!s)return;const o=await s.provider.prepareSession(C,w);if(!o)return;const a=k._nextId++;return this._chatSessions.set(a,o),{id:a,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $resolveRequest(y,C,w,s){const o=this._chatProvider.get(y);if(!o)return;const a=this._chatSessions.get(C);if(!a||!o.provider.resolveRequest)return;const c=await o.provider.resolveRequest(a,w,s);if(c)return{message:typeof c.message=="string"?c.message:b.ChatReplyFollowup.from(c.message)}}async $provideWelcomeMessage(y,C){const w=this._chatProvider.get(y);if(!w||!w.provider.provideWelcomeMessage)return;const s=await w.provider.provideWelcomeMessage(C);if(s)return s.map(o=>typeof o=="string"?o:o.map(a=>b.ChatReplyFollowup.from(a)))}async $provideFollowups(y,C,w){const s=this._chatProvider.get(y);if(!s)return;const o=this._chatSessions.get(C);return!o||!s.provider.provideFollowups?void 0:(await s.provider.provideFollowups(o,w))?.map(c=>b.ChatFollowup.from(c))}$removeRequest(y,C,w){const s=this._chatProvider.get(y);if(!s)return;const o=this._chatSessions.get(C);o&&s.provider.removeRequest&&s.provider.removeRequest(o,w)}async $provideReply(y,C,w,s){const o=this._chatProvider.get(y);if(!o)return;const a=this._chatSessions.get(C);if(!a)return;const c={session:a,message:typeof w.message=="string"?w.message:b.ChatReplyFollowup.to(w.message),variables:{}};if(w.variables)for(const i of Object.keys(w.variables))c.variables[i]=w.variables[i].map(b.ChatVariable.to);const g=A.StopWatch.create(!1);let u;const t={report:i=>{if(!s.isCancellationRequested)if(typeof u>"u"&&(u=g.elapsed()),"responseId"in i)this._proxy.$acceptResponseProgress(y,C,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const l=Promise.all([this._proxy.$acceptResponseProgress(y,C,{placeholder:i.placeholder}),i.resolvedContent]);(0,D.raceCancellation)(l,s).then(f=>{if(!f)return;const[S,I]=f;this._proxy.$acceptResponseProgress(y,C,I,S??void 0)})}else"content"in i?this._proxy.$acceptResponseProgress(y,C,{content:typeof i.content=="string"?i.content:b.MarkdownString.from(i.content)}):"documents"in i?this._proxy.$acceptResponseProgress(y,C,{documents:i.documents.map(l=>({uri:l.uri,version:l.version,ranges:l.ranges.map(f=>b.Range.from(f))}))}):this._proxy.$acceptResponseProgress(y,C,i)}};let n;try{n=await o.provider.provideResponseWithProgress(c,t,s),n||(n={errorDetails:{message:(0,p.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,p.localize)(1,null,i.message),responseIsIncomplete:!0}},this.logService.error(i)}try{if(a.saveState&&this._chatSessions.has(C)){const i=a.saveState();this._proxy.$acceptChatState(C,i)}}catch(i){this.logService.warn(i)}const r={firstProgress:u??0,totalElapsed:g.elapsed()};return{errorDetails:n.errorDetails,timings:r}}async $provideSlashCommands(y,C,w){const s=this._chatProvider.get(y);if(!s)return;const o=this._chatSessions.get(C);return!o||!s.provider.provideSlashCommands?void 0:(await s.provider.provideSlashCommands(o,w))?.map(c=>({...c,kind:b.CompletionItemKind.from(c.kind)}))}$releaseSession(y){this._chatSessions.delete(y)}async $onDidPerformUserAction(y){this._onDidPerformUserAction.fire(y)}}e.ExtHostChat=k}),define(Ce[297],De([1,0,9,3,64,6,13,7]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents=void 0;class _{static{this._idPool=0}constructor(k,v,y){this._extHostChatProvider=v,this._logService=y,this._agents=new Map,this._proxy=k.getProxy(R.MainContext.MainThreadChatAgents)}registerAgent(k,v,y,C){const w=_._idPool++;return this._agents.set(w,{extension:k,agent:y}),this._proxy.$registerAgent(w,v,C),(0,F.toDisposable)(()=>{this._proxy.$unregisterAgent(w),this._agents.delete(w)})}async $invokeAgent(k,v,y,C,w){const s=this._agents.get(k);if(!s){this._logService.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let o=!1;function a(){if(o)throw new Error("Only valid while executing the command")}const c=new D.DeferredPromise;w.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),3*1e3),this._extHostChatProvider.allowListExtensionWhile(s.extension,c.p);const g=s.agent({role:p.ChatMessageRole.User,content:y},{history:C.history.map(A.ChatMessage.to)},new d.Progress(u=>{a(),this._proxy.$handleProgressChunk(v,{content:b(u.message)?u.message:u.message.value})}),w);try{return await(0,D.raceCancellation)(Promise.resolve(g).then(u=>{if(u&&"followUp"in u)return{followUp:u?.followUp?.map(n=>A.ChatFollowup.from(n))}}),w)}finally{o=!0,c.complete()}}}e.ExtHostChatAgents=_;function b(T){return!!T&&typeof T=="object"&&"treeData"in T}}),define(Ce[298],De([1,0,3,6,13,64,25]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class p{static{this._idPool=1}constructor(b,T){this._logService=T,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new A.ExtensionIdentifierMap,this._proxy=b.getProxy(F.MainContext.MainThreadChatProvider)}registerProvider(b,T,k,v){const y=p._idPool++;return this._providers.set(y,{extension:b,provider:k}),this._proxy.$registerProvider(y,T,{extension:b,displayName:v.name??b.value}),(0,D.toDisposable)(()=>{this._proxy.$unregisterProvider(y),this._providers.delete(y)})}async $provideChatResponse(b,T,k,v,y){const C=this._providers.get(b);if(!C)return;const w=new R.Progress(async s=>{if(y.isCancellationRequested){this._logService.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this._proxy.$handleProgressChunk(T,{index:s.index,part:s.part})},{async:!0});return C.provider.provideChatResponse(k.map(d.ChatMessage.to),v,w,y)}allowListExtensionWhile(b,T){this._chatAccessAllowList.set(b,T),T.finally(()=>this._chatAccessAllowList.delete(b))}async requestChatResponseProvider(b,T){if(!this._chatAccessAllowList.has(b))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k._chatAccessAllowList.has(b)},async makeRequest(v,y,C,w){if(!k._chatAccessAllowList.has(b))throw new Error("Access to chat has been revoked");const s=Math.random()*1e6|0;k._pendingRequest.set(s,C);try{await k._proxy.$fetchResponse(b,T,s,v.map(d.ChatMessage.from),y,w)}finally{k._pendingRequest.delete(s)}}}}async $handleResponseFragment(b,T){this._pendingRequest.get(b)?.report(T)}}e.ExtHostChatProvider=p}),define(Ce[299],De([1,0,3,6,7,13,64,9]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatSlashCommands=void 0;class _{static{this._idPool=0}constructor(k,v,y){this._extHostChatProvider=v,this._logService=y,this._commands=new Map,this._proxy=k.getProxy(F.MainContext.MainThreadChatSlashCommands)}registerCommand(k,v,y,C){const w=_._idPool++;return this._commands.set(w,{extension:k,command:y}),this._proxy.$registerCommand(w,v,C.description),(0,D.toDisposable)(()=>{this._proxy.$unregisterCommand(w),this._commands.delete(w)})}async $executeCommand(k,v,y,C,w){const s=this._commands.get(k);if(!s){this._logService.warn(`[CHAT](${k}) CANNOT execute command because the command is not registered`);return}let o=!1;function a(){if(o)throw new Error("Only valid while executing the command")}const c=new p.DeferredPromise;w.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(s.extension,c.p);const g=s.command({role:d.ChatMessageRole.User,content:y},{history:C.history.map(R.ChatMessage.to)},new A.Progress(u=>{a(),this._proxy.$handleProgressChunk(v,{content:b(u.message)?u.message:u.message.value})}),w);try{return await(0,p.raceCancellation)(Promise.resolve(g).then(u=>{if(u&&"followUp"in u)return{followUp:u?.followUp?.map(n=>R.ChatFollowup.from(n))}}),w)}finally{o=!0,c.complete()}}}e.ExtHostChatSlashCommands=_;function b(T){return!!T&&typeof T=="object"&&"treeData"in T}}),define(Ce[300],De([1,0,3,6,8,13]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class A{static{this._idPool=0}constructor(_){this._resolver=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadChatVariables)}async $resolveVariable(_,b,T){const k=this._resolver.get(_);if(k)try{const v=await k.resolver.resolve(k.data.name,{message:b},T);if(v)return v.map(R.ChatVariable.from)}catch(v){(0,d.onUnexpectedExternalError)(v)}}registerVariableResolver(_,b,T,k){const v=A._idPool++;return this._resolver.set(v,{extension:_.identifier,data:{name:b,description:T},resolver:k}),this._proxy.$registerVariable(v,{name:b,description:T}),(0,D.toDisposable)(()=>{this._resolver.delete(v),this._proxy.$unregisterVariable(v)})}}e.ExtHostChatVariables=A}),define(Ce[301],De([1,0,6]),function(pe,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(R){const A=R.getProxy(D.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(p){return A.$writeText(p)}})}}e.ExtHostClipboard=F}),define(Ce[33],De([1,0,18,7,13,23,6,19,14,62,34,61,2,3,5,20,145,22,69,46,37,85,89]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{#e;#t;#i;constructor(I,E,h){this._commands=new Map,this._apiCommands=new Map,this.#e=I.getProxy(A.MainContext.MainThreadCommands),this._logService=E,this.#i=h,this.#t=I.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new r(this,m=>{const P=this._apiCommands.get(m);return P?.result===l.Void?P:void 0},E),this._argumentProcessors=[{processArgument(m){return(0,b.revive)(m)}},{processArgument(m){return(0,R.cloneAndChange)(m,function(P){if(T.Range.isIRange(P))return d.Range.to(P);if(k.Position.isIPosition(P))return d.Position.to(P);if(T.Range.isIRange(P.range)&&v.URI.isUri(P.uri))return d.location.to(P);if(P instanceof o.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(I){this._argumentProcessors.push(I)}registerApiCommand(I){const E=this.registerCommand(!1,I.id,async(...h)=>{const m=I.args.map((O,N)=>{if(!O.validate(h[N]))throw new Error(`Invalid argument '${O.name}' when running '${I.id}', received: ${typeof h[N]=="object"?JSON.stringify(h[N],null,"	"):h[N]} `);return O.convert(h[N])}),P=await this.executeCommand(I.internalId,...m);return I.result.convert(P,h,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this._apiCommands.set(I.id,I),new F.Disposable(()=>{E.dispose(),this._apiCommands.delete(I.id)})}registerCommand(I,E,h,m,P,O){if(this._logService.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this._commands.has(E))throw new Error(`command '${E}' already exists`);return this._commands.set(E,{callback:h,thisArg:m,description:P,extension:O}),I&&this.#e.$registerCommand(E),new F.Disposable(()=>{this._commands.delete(E)&&I&&this.#e.$unregisterCommand(E)})}executeCommand(I,...E){return this._logService.trace("ExtHostCommands#executeCommand",I),this._doExecuteCommand(I,E,!0)}async _doExecuteCommand(I,E,h){if(this._commands.has(I))return this.#e.$fireCommandActivationEvent(I),this._executeContributedCommand(I,E,!1);{let m=!1;const P=(0,R.cloneAndChange)(E,function(O){if(O instanceof F.Position)return d.Position.from(O);if(O instanceof F.Range)return d.Range.from(O);if(O instanceof F.Location)return d.location.from(O);if(F.NotebookRange.isNotebookRange(O))return d.NotebookRange.from(O);if(O instanceof ArrayBuffer)return m=!0,o.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return m=!0,o.VSBuffer.wrap(O);if(O instanceof o.VSBuffer)return m=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(I,m?new a.SerializableObjectWithBuffers(P):P,h);return(0,b.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(I,E,!1);throw O}}}async _executeContributedCommand(I,E,h){const m=this._commands.get(I);if(!m)throw new Error("Unknown command");const{callback:P,thisArg:O,description:N}=m;if(N)for(let U=0;U<N.args.length;U++)try{(0,D.validateConstraint)(E[U],N.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed.Illegal argument '${N.args[U].name}' - ${N.args[U].description} `)}const L=g.StopWatch.create();try{return await P.apply(O,E)}catch(U){if(I===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...E);x&&(I=x.command)}if(this._logService.error(U,I,m.extension?.identifier),!h)throw U;if(m.extension?.identifier){const x=this.#i.onExtensionError(m.extension.identifier,U);this._logService.trace("forwarded error to extension?",x,m.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.toErrorMessage)(U)),this.id=I,this.source=m.extension?.displayName??m.extension?.name}}}finally{this._reportTelemetry(m,I,L.elapsed())}}_reportTelemetry(I,E,h){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new u.TelemetryTrustedValue(E),duration:h})}$executeContributedCommand(I,...E){this._logService.trace("ExtHostCommands#$executeContributedCommand",I);const h=this._commands.get(I);return h?(E=E.map(m=>this._argumentProcessors.reduce((P,O)=>O.processArgument(P,h.extension?.identifier),m)),this._executeContributedCommand(I,E,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this._logService.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(E=>(I&&(E=E.filter(h=>h[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[E,h]of this._commands){const{description:m}=h;m&&(I[E]=m)}return Promise.resolve(I)}};e.ExtHostCommands=n,e.ExtHostCommands=n=je([$e(0,w.IExtHostRpcService),$e(1,_.ILogService),$e(2,t.IExtHostTelemetry)],n),e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class r{constructor(I,E,h){this._commands=I,this._lookupApiCommand=E,this._logService=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(I,E){if(!I)return;const h={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return h;const m=this._lookupApiCommand(I.command);if(m)h.id=m.internalId,h.arguments=m.args.map((P,O)=>P.convert(I.arguments&&I.arguments[O]));else if((0,p.isNonEmptyArray)(I.arguments)){const P=`${I.command} /${++this._cachIdPool}`;this._cache.set(P,I),E.add((0,y.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),h.$ident=P,h.id=this.delegatingCommandId,h.arguments=[P],this._logService.trace("CommandsConverter#CREATE",I.command,P)}return h}fromInternal(I){return typeof I.$ident=="string"?this._cache.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this._cache.get(I[0])}_executeConvertedCommand(...I){const E=this.getActualCommand(...I);return this._logService.trace("CommandsConverter#EXECUTE",I[0],E?E.command:"MISSING"),E?this._commands.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.CommandsConverter=r;class i{static{this.Uri=new i("uri","Uri of a text document",I=>v.URI.isUri(I),I=>I)}static{this.Position=new i("position","A position in a text document",I=>F.Position.isPosition(I),d.Position.from)}static{this.Range=new i("range","A range in a text document",I=>F.Range.isRange(I),d.Range.from)}static{this.Selection=new i("selection","A selection in a text document",I=>F.Selection.isSelection(I),d.Selection.from)}static{this.Number=new i("number","",I=>typeof I=="number",I=>I)}static{this.String=new i("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=i.Arr(i.String)}static Arr(I){return new i(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,E=>Array.isArray(E)&&E.every(h=>I.validate(h)),E=>E.map(h=>I.convert(h)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",I=>I instanceof F.CallHierarchyItem,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",I=>I instanceof F.TypeHierarchyItem,d.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VSCodium TestItem",I=>I instanceof s.TestItemImpl,d.TestItem.from)}constructor(I,E,h,m){this.name=I,this.description=E,this.validate=h,this.convert=m}optional(){return new i(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,E){return new i(I??this.name,E??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i;class l{static{this.Void=new l("no result",I=>I)}constructor(I,E){this.description=I,this.convert=E}}e.ApiCommandResult=l;class f{constructor(I,E,h,m,P){this.id=I,this.internalId=E,this.description=h,this.args=m,this.result=P}}e.ApiCommand=f}),define(Ce[302],De([1,0,19,17,2,83,129,41,134,33,13,7]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new b.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(T.DocumentHighlight.to))),new b.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,D.isFalsyOrEmpty)(s))return;class a extends k.SymbolInformation{static to(g){const u=new a(g.name,T.SymbolKind.to(g.kind),g.containerName||"",new k.Location(o[0],T.Range.to(g.range)));return u.detail=g.detail,u.range=u.location.range,u.selectionRange=T.Range.to(g.selectionRange),u.children=g.children?g.children.map(a.to):[],u}}return s.map(a.to)})),new b.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.ApiCommandArgument.Uri,new b.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new b.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(T.TextEdit.to))),new b.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range,new b.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new b.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(T.TextEdit.to))),new b.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,new b.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new b.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new b.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(T.TextEdit.to))),new b.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(T.location.to))),new b.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(T.Hover.to))),new b.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.ApiCommandArgument.Uri,new b.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>k.Position.isPosition(o)),s=>s.map(T.Position.from))],new b.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(o=>{let a;for(const c of o.reverse())a=new k.SelectionRange(T.Range.to(c),a);return a}))),new b.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.ApiCommandArgument.String.with("query","Search string")],new b.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(T.WorkspaceSymbol.to))),new b.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(T.CallHierarchyItem.to))),new b.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.ApiCommandArgument.CallHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(T.CallHierarchyIncomingCall.to))),new b.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.ApiCommandArgument.CallHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(T.CallHierarchyOutgoingCall.to))),new b.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:T.Range.to(s.range),placeholder:s.text}})),new b.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,b.ApiCommandArgument.String.with("newName","The new symbol name")],new b.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return T.WorkspaceEdit.to(s)}})),new b.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(T.DocumentLink.to))),new b.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new k.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new b.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,A.decodeSemanticTokensDto)(s);if(o.type==="full")return new k.SemanticTokens(o.data,void 0)})),new b.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range.optional()],new b.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new k.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new b.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range],new b.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,A.decodeSemanticTokensDto)(s);if(o.type==="full")return new k.SemanticTokens(o.data,void 0)})),new b.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,b.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,o,a)=>{if(!s)return new k.CompletionList([]);const c=s.suggestions.map(g=>T.CompletionItem.to(g,a));return new k.CompletionList(c,s.incomplete)})),new b.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,b.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return T.SignatureHelp.to(s)})),new b.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,o,a)=>C(c=>new k.CodeLens(T.Range.to(c.range),c.command&&a.fromInternal(c.command)))(s))),new b.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.ApiCommandArgument.Uri,new b.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>k.Range.isRange(s),s=>k.Selection.isSelection(s)?T.Selection.from(s):T.Range.from(s)),b.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),b.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,o,a)=>C(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(c.command)}else{const g=new k.CodeAction(c.title,c.kind?new k.CodeActionKind(c.kind):void 0);return c.edit&&(g.edit=T.WorkspaceEdit.to(c.edit)),c.command&&(g.command=a.fromInternal(c.command)),g.isPreferred=c.isPreferred,g}})(s))),new b.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new k.ColorInformation(T.Range.to(o.range),T.Color.to(o.color))):[])),new b.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.ApiCommandArgument("color","The color to show and insert",s=>s instanceof k.Color,T.Color.from),new b.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:T.Range.from(s.range)}))],new b.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(T.ColorPresentation.to):[])),new b.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range],new b.ApiCommandResult("A promise that resolves to an array of Inlay objects",(s,o,a)=>s.map(T.InlayHint.to.bind(void 0,a)))),new b.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(T.FoldingRange.to)})),new b.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>T.NotebookExclusiveDocumentPattern.to(o))})))),new b.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range,new b.ApiCommandArgument("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof k.Range,s=>T.InlineValueContext.from(s))],new b.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(T.InlineValue.to))),new b.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",s=>d.URI.isUri(s)||typeof s=="string"&&(0,_.matchesSomeScheme)(s,F.Schemas.http,F.Schemas.https),s=>s),new b.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[T.ViewColumn.from(s),void 0]:[T.ViewColumn.from(s.viewColumn),T.TextEditorOpenOptions.from(s)])).optional(),b.ApiCommandArgument.String.with("label","").optional()],b.ApiCommandResult.Void),new b.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.ApiCommandArgument.Uri.with("resource","Resource to open"),b.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new b.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[T.ViewColumn.from(s),void 0]:[T.ViewColumn.from(s.viewColumn),T.TextEditorOpenOptions.from(s)])).optional()],b.ApiCommandResult.Void),new b.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),b.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),b.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new b.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[T.ViewColumn.from(s.viewColumn),T.TextEditorOpenOptions.from(s)]).optional()],b.ApiCommandResult.Void),new b.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(T.TypeHierarchyItem.to))),new b.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.ApiCommandArgument.TypeHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(T.TypeHierarchyItem.to))),new b.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.ApiCommandArgument.TypeHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(T.TypeHierarchyItem.to))),new b.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.ApiCommandArgument.TestItem],b.ApiCommandResult.Void),new b.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.ApiCommandResult.Void),new b.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.ApiCommandArgument.String.with("name","The context key name"),new b.ApiCommandArgument("value","The context key value",()=>!0,s=>s)],b.ApiCommandResult.Void),new b.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.StringArray,new b.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",s=>T.MappedEditsContext.is(s),s=>T.MappedEditsContext.from(s))],new b.ApiCommandResult("A promise that resolves to a workspace edit or null",s=>s?T.WorkspaceEdit.to(s):null))];class y{static register(o){v.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",p.validateWhenClauses)}}e.ExtHostApiCommands=y;function C(s){return o=>{if(Array.isArray(o))return o.map(s)}}function w(s){if(!Array.isArray(s))return;const o=[];for(const a of s)R.isLocationLink(a)?o.push(T.DefinitionLink.to(a)):o.push(T.location.to(a));return o}}),define(Ce[303],De([1,0,9,56,4,3,2,83,25,13,7,6,27]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(C,w,s){const o=C.getProxy(k.MainContext.MainThreadComments);class a{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new _.ExtensionIdentifierMap,w.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this._commentControllers.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=this._commentControllers.get(f.commentControlHandle);if(!S)return f;const I=S.getCommentThread(f.commentThreadHandle);return I?I.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const S=this._commentControllers.get(f.thread.commentControlHandle);if(!S)return f;const I=S.getCommentThread(f.thread.commentThreadHandle);return I?f.$mid===8?I.value:{thread:I.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this._commentControllers.get(f.thread.commentControlHandle);if(!S)return f;const I=S.getCommentThread(f.thread.commentThreadHandle);if(!I)return f;const E=f.commentUniqueId,h=I.getCommentByUniqueId(E);return h||f}else if(f&&f.$mid===11){const S=this._commentControllers.get(f.thread.commentControlHandle);if(!S)return f;const I=S.getCommentThread(f.thread.commentThreadHandle);if(!I)return f;const E=f.text,h=f.commentUniqueId,m=I.getCommentByUniqueId(h);return m?(typeof m.body=="string"?m.body=E:m.body=new T.MarkdownString(E),m):f}return f}})}createCommentController(f,S,I){const E=a.handlePool++,h=new g(f,E,S,I);this._commentControllers.set(h.handle,h);const m=this._commentControllersByExtension.get(f.identifier)||[];return m.push(h),this._commentControllersByExtension.set(f.identifier,m),h.value}$createCommentThreadTemplate(f,S,I){const E=this._commentControllers.get(f);E&&E.$createCommentThreadTemplate(S,I)}async $updateCommentThreadTemplate(f,S,I){const E=this._commentControllers.get(f);E&&E.$updateCommentThreadTemplate(S,I)}$deleteCommentThread(f,S){this._commentControllers.get(f)?.$deleteCommentThread(S)}$provideCommentingRanges(f,S,I){const E=this._commentControllers.get(f);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const h=s.getDocument(A.URI.revive(S));return(0,D.asPromise)(async()=>{const m=await E.commentingRangeProvider.provideCommentingRanges(h,I);let P;return Array.isArray(m)?P={ranges:m,fileComments:!1}:m?P={ranges:m.ranges||[],fileComments:m.fileComments||!1}:P=m??void 0,P}).then(m=>{let P;return m&&(P={ranges:m.ranges.map(O=>b.Range.from(O)),fileComments:m.fileComments}),P})}$toggleReaction(f,S,I,E,h){const m=this._commentControllers.get(f);return!m||!m.reactionHandler?Promise.resolve(void 0):(0,D.asPromise)(()=>{const P=m.getCommentThread(S);if(P){const O=P.getCommentByUniqueId(E.uniqueIdInThread);if(m!==void 0&&O&&m.reactionHandler)return m.reactionHandler(O,n(h))}return Promise.resolve(void 0)})}}class c{static{this._handlePool=0}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){(f===void 0!=(this._range===void 0)||!f||!this._range||!f.isEqual(this._range))&&(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(f){this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,S,I,E,h,m,P,O){this._commentControllerHandle=S,this._id=I,this._uri=E,this._range=h,this._comments=m,this.extensionDescription=P,this._isTemplate=O,this.handle=c._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new d.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),o.$createCommentThread(S,this.handle,this._id,this._uri,b.Range.from(this._range),P.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=m,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(S,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(L){N.range=L},get comments(){return N.comments},set comments(L){N.comments=L},get collapsibleState(){return N.collapsibleState},set collapsibleState(L){N.collapsibleState=L},get canReply(){return N.canReply},set canReply(L){N.canReply=L},get contextValue(){return N.contextValue},set contextValue(L){N.contextValue=L},get label(){return N.label},set label(L){N.label=L},get state(){return N.state},set state(L){N.state=L},dispose:()=>{N.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const f=I=>Object.prototype.hasOwnProperty.call(this.modifications,I),S={};f("range")&&(S.range=b.Range.from(this._range)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this._comments.map(I=>u(this,I,this._commentsMap,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=r(this._collapseState)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=i(this._state)),f("isTemplate")&&(S.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,S)}getCommentByUniqueId(f){for(const S of this._commentsMap){const I=S[0],E=S[1];if(f===E)return I}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}je([(0,F.debounce)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,S,I,E){this._extension=f,this._handle=S,this._id=I,this._label=E,this._threads=new Map,o.$registerCommentController(this.handle,I,E,this._extension.identifier.value);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(m){h.options=m},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(m){h.commentingRangeProvider=m},get reactionHandler(){return h.reactionHandler},set reactionHandler(m){h.reactionHandler=m},createCommentThread(m,P,O){return h.createCommentThread(m,P,O).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,I){S===void 0&&(0,v.checkProposedApiEnabled)(this._extension,"fileComments");const E=new c(this.id,this.handle,void 0,f,S,I,this._extension,!1);return this._threads.set(E.handle,E),E}$createCommentThreadTemplate(f,S){const I=new c(this.id,this.handle,void 0,A.URI.revive(f),b.Range.to(S),[],this._extension,!0);return I.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this._threads.set(I.handle,I),I}$updateCommentThreadTemplate(f,S){const I=this._threads.get(f);I&&(I.range=b.Range.to(S))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function u(l,f,S,I){let E=S.get(f);return E||(E=++l.commentHandle,S.set(f,E)),f.state!==void 0&&(0,v.checkProposedApiEnabled)(I,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:E,body:typeof f.body=="string"?f.body:b.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(h=>t(h)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?b.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function n(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?A.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function r(l){if(l!==void 0)switch(l){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function i(l){if(l!==void 0)switch(l){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new a}e.createExtHostComments=y}),define(Ce[304],De([1,0,23,6,26,20]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(T,k){this._mainThreadConsole=T.getProxy(F.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(T,k){const v=this,y=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){v._handleConsoleCall(T,k,y,arguments)}})}_handleConsoleCall(T,k,v,y){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:_(y,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(T,v,y)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=je([$e(0,R.IExtHostRpcService),$e(1,d.IExtHostInitDataService)],A);const p=1e5;function _(b,T){const k=[];if(b.length)for(let v=0;v<b.length;v++){let y=b[v];if(typeof y>"u")y="undefined";else if(y instanceof Error){const C=y;C.stack?y=C.stack:y=C.toString()}k.push(y)}if(T){const v=new Error().stack;v&&k.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,D.safeStringify)(k);return v.length>p?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(Ce[149],De([1,0,2,6,7,5,20,14,19,15,16,27]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class{static{v=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(w,s){this._logService=s,this._provider=new Map,this._proxy=w.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,s){const o=v._handlePool++;this._provider.set(o,{provider:w,extensionDescription:s}),this._proxy.$registerDecorationProvider(o,s.identifier.value);const a=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(o,null);return}const g=(0,_.asArray)(c);if(g.length<=v._maxEventSize){this._proxy.$onDidChange(o,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,g.length);const u=g.map(r=>({uri:r,rank:(0,b.count)(r.path,"/")})),t=(0,_.groupBy)(u,(r,i)=>r.rank-i.rank||(0,b.compare)(r.uri.path,i.uri.path)),n=[];e:for(const r of t){let i;for(const l of r){const f=(0,T.dirname)(l.uri.path);if(i!==f&&(i=f,n.push(l.uri)>=v._maxEventSize))break e}}this._proxy.$onDidChange(o,n)});return new d.Disposable(()=>{a?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(w,s,o){if(!this._provider.has(w))return Object.create(null);const a=Object.create(null),{provider:c,extensionDescription:g}=this._provider.get(w);return await Promise.all(s.map(async u=>{try{const{uri:t,id:n}=u,r=await Promise.resolve(c.provideFileDecoration(D.URI.revive(t),o));if(!r)return;try{d.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,k.checkProposedApiEnabled)(g,"codiconDecoration"),a[n]=[r.propagate,r.tooltip,r.badge,r.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${g.identifier.value}': ${i}`)}}catch(t){this._logService.error(t)}})),a}};e.ExtHostDecorations=y,e.ExtHostDecorations=y=v=je([$e(0,A.IExtHostRpcService),$e(1,p.ILogService)],y),e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")}),define(Ce[305],De([1,0,203,133,2,6,7,13,4,14,28,54]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class y{#e;#t;#i;constructor(s,o,a,c,g,u,t,n){this._name=s,this._owner=o,this._maxDiagnosticsTotal=a,this._maxDiagnosticsPerFile=c,this._modelVersionIdProvider=g,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(c,a),this.#i=new T.ResourceMap(r=>u.getComparisonKey(r)),this.#e=t,this.#t=n}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,o){if(!s){this.clear();return}this._checkDisposed();let a=[];if(d.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),a=[s]}else if(Array.isArray(s)){a=[];let u;s=[...s].sort(y._compareIndexedTuplesByUri);for(const t of s){const[n,r]=t;if((!u||n.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=n,a.push(n),this.#i.set(n,[])),r)this.#i.get(n)?.push(...r);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(a),!this.#e)return;const c=[];let g=0;for(const u of a){let t=[];const n=this.#i.get(u);if(n)if(n.length>this._maxDiagnosticsPerFile){t=[];const r=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const l of n)if(l.severity===r[i]&&t.push({...p.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(u)})===this._maxDiagnosticsPerFile)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,D.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(r=>({...p.Diagnostic.from(r),modelVersionId:this._modelVersionIdProvider(u)}));if(c.push([u,t]),g+=t.length,g>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,c)}delete(s){this._checkDisposed(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(s,o){this._checkDisposed();for(const[a,c]of this)s.call(o,a,c,this)}*[Symbol.iterator](){this._checkDisposed();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this._checkDisposed();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this.#i.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=y;let C=class{static{v=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*v._maxDiagnosticsPerFile}static _mapper(s){const o=new T.ResourceMap;for(const a of s)o.set(a,a);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,a,c){this._logService=o,this._fileSystemInfoService=a,this._extHostDocumentsAndEditors=c,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,v._mapper),this._proxy=s.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{_collections:a,_proxy:c,_onDidChangeDiagnostics:g,_logService:u,_fileSystemInfoService:t,_extHostDocumentsAndEditors:n}=this,r=new class{$changeMany(f,S){c.$changeMany(f,S),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,f,S.length===0?"CLEARING":S)}$clear(f){c.$clear(f),u.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,f)}dispose(){c.dispose()}};let i;if(!o)o="_generated_diagnostic_collection_name_#"+v._idPool++,i=o;else if(!a.has(o))i=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do i=o+v._idPool++;while(a.has(i))}return new class extends y{constructor(){super(o,i,v._maxDiagnosticsTotal,v._maxDiagnosticsPerFile,f=>n.getDocument(f)?.version,t.extUri,r,g),a.set(i,this)}dispose(){super.dispose(),a.delete(i)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const o=new Map,a=[];for(const c of this._collections.values())c.forEach((g,u)=>{let t=o.get(g.toString());typeof t>"u"&&(t=a.length,o.set(g.toString(),t),a.push([g,[]])),a[t][1]=a[t][1].concat(...u)});return a}}_getDiagnostics(s){let o=[];for(const a of this._collections.values())a.has(s)&&(o=o.concat(a.get(s)));return o}$acceptMarkersChange(s){if(!this._mirrorCollection){const o="_generated_mirror",a=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,a),this._mirrorCollection=a}for(const[o,a]of s)this._mirrorCollection.set(d.URI.revive(o),a.map(p.Diagnostic.to))}};e.ExtHostDiagnostics=C,e.ExtHostDiagnostics=C=v=je([$e(1,b.ILogService),$e(2,k.IExtHostFileSystemInfo)],C)}),define(Ce[306],De([1,0,2,6,27]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(p){this._proxy=p.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(p,_){return _?.allowUIResources&&(0,d.checkProposedApiEnabled)(p,"showLocal"),this._proxy.$showOpenDialog(_).then(b=>b?b.map(T=>D.URI.revive(T)):void 0)}showSaveDialog(p){return this._proxy.$showSaveDialog(p).then(_=>_?D.URI.revive(_):void 0)}}e.ExtHostDialogs=R}),define(Ce[307],De([1,0,8,2,7,6,17,21,15]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class b{static{this._handlePool=0}constructor(k,v,y){this._documentsAndEditors=v,this._logService=y,this._documentContentProviders=new Map,this._proxy=k.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,v){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const y=b._handlePool++;this._documentContentProviders.set(y,v),this._proxy.$registerTextContentProvider(y,k);let C;return typeof v.onDidChange=="function"&&(C=v.onDidChange(w=>{if(w.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(y,w).then(s=>{if(!s&&typeof s!="string")return;const o=this._documentsAndEditors.getDocument(w);if(!o)return;const a=(0,_.splitLines)(s);if(!o.equalLines(a))return this._proxy.$onVirtualDocumentChange(w,s)},D.onUnexpectedError)})),new d.Disposable(()=>{this._documentContentProviders.delete(y)&&this._proxy.$unregisterTextContentProvider(y),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(k,v){const y=this._documentContentProviders.get(k);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(v),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=b}),define(Ce[308],De([1,0,4,3,2,6,141,13,18,23,7,8]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class v{constructor(C,w){this._onDidAddDocument=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidRemoveDocument=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidChangeDocument=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this._onDidSaveDocument=new D.Emitter({onListenerError:k.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const o of s)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const o of s)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const w=this._documentsAndEditors.getDocument(C);if(w)return w}getDocument(C){const w=this.getDocumentData(C);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return w.document}ensureDocumentData(C){const w=this._documentsAndEditors.getDocument(C);if(w)return Promise.resolve(w);let s=this._documentLoader.get(C.toString());return s||(s=this._proxy.$tryOpenDocument(C).then(o=>{this._documentLoader.delete(C.toString());const a=d.URI.revive(o);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(a))},o=>(this._documentLoader.delete(C.toString()),Promise.reject(o))),this._documentLoader.set(C.toString(),s)),s}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(w=>d.URI.revive(w))}$acceptModelLanguageChanged(C,w){const s=d.URI.revive(C),o=this._documentsAndEditors.getDocument(s);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(w),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(C){const w=d.URI.revive(C),s=this._documentsAndEditors.getDocument(w);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(C,w){const s=d.URI.revive(C),o=this._documentsAndEditors.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,w,s){const o=d.URI.revive(C),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(s),a.onEvents(w);let c;w.isUndoing?c=T.TextDocumentChangeReason.Undo:w.isRedoing&&(c=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,b.deepFreeze)({document:a.document,contentChanges:w.changes.map(g=>({range:p.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:c}))}setWordDefinitionFor(C,w){(0,A.setWordDefinitionFor)(C,w)}}e.ExtHostDocuments=v}),define(Ce[70],De([1,0,57,4,3,2,5,6,141,20,146,13,14,28,17,50,58]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let a=class{constructor(g,u){this._extHostRpc=g,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new y.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const u=[],t=[],n=[];if(g.removedDocuments)for(const r of g.removedDocuments){const i=R.URI.revive(r),l=this._documents.get(i);l?.unref()&&(this._documents.delete(i),u.push(l.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const i=R.URI.revive(r.uri);let l=this._documents.get(i);if(l&&i.scheme!==C.Schemas.vscodeNotebookCell&&i.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);l||(l=new o(new _.ExtHostDocumentData(this._extHostRpc.getProxy(p.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,l),t.push(l.value)),l.ref()}if(g.removedEditors)for(const r of g.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&n.push(i)}if(g.addedEditors)for(const r of g.addedEditors){const i=R.URI.revive(r.documentUri);D.ok(this._documents.has(i),`document '${i}' does not exist`),D.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(i).value,f=new T.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(p.MainContext.MainThreadTextEditors),this._logService,new s.Lazy(()=>l.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(S=>k.Range.to(S)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}g.newActiveEditor!==void 0&&(D.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,d.dispose)(u),(0,d.dispose)(n),g.removedDocuments&&this._onDidRemoveDocuments.fire(u),g.addedDocuments&&this._onDidAddDocuments.fire(t),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return g?u:u?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=a,e.ExtHostDocumentsAndEditors=a=je([$e(0,b.IExtHostRpcService),$e(1,v.ILogService)],a),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[71],De([1,0,13,6,2,4,5,7,20,18,74]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class k{constructor(s,o,a){this._activeTabIdGetter=a,this._parentGroup=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this._apiObject){const s=this,o={get isActive(){return s._dto.id===s._activeTabIdGetter()},get label(){return s._dto.label},get input(){return s._input},get isDirty(){return s._dto.isDirty},get isPinned(){return s._dto.isPinned},get isPreview(){return s._dto.isPreview},get group(){return s._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(s){this._dto=s,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new p.TextTabInput(d.URI.revive(this._dto.input.uri));case 2:return new p.TextDiffTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified));case 3:return new p.TextMergeTabInput(d.URI.revive(this._dto.input.base),d.URI.revive(this._dto.input.input1),d.URI.revive(this._dto.input.input2),d.URI.revive(this._dto.input.result));case 6:return new p.CustomEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new p.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new p.NotebookEditorTabInput(d.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new p.NotebookDiffEditorTabInput(d.URI.revive(this._dto.input.original),d.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new p.TerminalEditorTabInput;case 9:return new p.InteractiveWindowInput(d.URI.revive(this._dto.input.uri),d.URI.revive(this._dto.input.inputBoxUri));default:return}}}class v{constructor(s,o){this._tabs=[],this._activeTabId="",this._dto=s,this._activeGroupIdGetter=o;for(const a of s.tabs)a.isActive&&(this._activeTabId=a.id),this._tabs.push(new k(a,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const s=this,o={get isActive(){return s._dto.groupId===s._activeGroupIdGetter()},get viewColumn(){return D.ViewColumn.to(s._dto.viewColumn)},get activeTab(){return s._tabs.find(a=>a.tabId===s._activeTabId)?.apiObject},get tabs(){return Object.freeze(s._tabs.map(a=>a.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(s){this._dto=s}acceptTabOperation(s){if(s.kind===0){const a=new k(s.tabDto,this,()=>this.activeTabId());return this._tabs.splice(s.index,0,a),s.tabDto.isActive&&(this._activeTabId=a.tabId),a}else if(s.kind===1){const a=this._tabs.splice(s.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return a.tabId===this._activeTabId&&(this._activeTabId=""),a}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this._tabs.splice(s.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this._tabs.splice(s.index,0,a),a}const o=this._tabs.find(a=>a.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this._activeTabId=s.tabDto.id:this._activeTabId===s.tabDto.id&&!s.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this._activeTabId}}let y=class{constructor(s){this._onDidChangeTabs=new R.Emitter,this._onDidChangeTabGroups=new R.Emitter,this._extHostTabGroups=[],this._proxy=s.getProxy(F.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const s=this,o={onDidChangeTabGroups:s._onDidChangeTabGroups.event,onDidChangeTabs:s._onDidChangeTabs.event,get all(){return Object.freeze(s._extHostTabGroups.map(a=>a.apiObject))},get activeTabGroup(){const a=s._activeGroupId;return(0,b.assertIsDefined)(s._extHostTabGroups.find(g=>g.groupId===a)?.apiObject)},close:async(a,c)=>{const g=Array.isArray(a)?a:[a];return g.length?C(g[0])?this._closeGroups(g,c):this._closeTabs(g,c):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(s){const o=new Set(this._extHostTabGroups.map(r=>r.groupId)),a=new Set(s.map(r=>r.groupId)),c=(0,T.diffSets)(o,a),g=this._extHostTabGroups.filter(r=>c.removed.includes(r.groupId)).map(r=>r.apiObject),u=[],t=[];this._extHostTabGroups=s.map(r=>{const i=new v(r,()=>this._activeGroupId);return c.added.includes(i.groupId)?u.push(i.apiObject):t.push(i.apiObject),i});const n=(0,b.assertIsDefined)(s.find(r=>r.isActive===!0)?.groupId);n!==void 0&&this._activeGroupId!==n&&(this._activeGroupId=n),this._onDidChangeTabGroups.fire(Object.freeze({opened:u,closed:g,changed:t}))}$acceptTabGroupUpdate(s){const o=this._extHostTabGroups.find(a=>a.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this._activeGroupId=s.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this._extHostTabGroups.find(c=>c.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const a=o.acceptTabOperation(s);switch(s.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}_findExtHostTabFromApi(s){for(const o of this._extHostTabGroups)for(const a of o.tabs)if(a.apiObject===s)return a}_findExtHostTabGroupFromApi(s){return this._extHostTabGroups.find(o=>o.apiObject===s)}async _closeTabs(s,o){const a=[];for(const c of s){const g=this._findExtHostTabFromApi(c);if(!g)throw new Error("Tab close: Invalid tab not found!");a.push(g.tabId)}return this._proxy.$closeTab(a,o)}async _closeGroups(s,o){const a=[];for(const c of s){const g=this._findExtHostTabGroupFromApi(c);if(!g)throw new Error("Group close: Invalid group not found!");a.push(g.groupId)}return this._proxy.$closeGroup(a,o)}};e.ExtHostEditorTabs=y,e.ExtHostEditorTabs=y=je([$e(0,_.IExtHostRpcService)],y);function C(w){return w.tabs!==void 0}}),define(Ce[309],De([1,0,6,7]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class d{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(D.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,p,_){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const b=this._AiEmbeddingVectorProviders.get(A);if(!b)throw new Error("Embedding vector provider not found");const T=await b.provideEmbeddingVector(p,_);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(A,p,_){const b=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(b,_),this._proxy.$registerAiEmbeddingVectorProvider(p,b),new F.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(b),this._AiEmbeddingVectorProviders.delete(b)})}}e.ExtHostAiEmbeddingVector=d}),define(Ce[310],De([1,0,2,6,3,7,13,169,15,22,27,80]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const s=this._schemes.indexOf(w);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),s=[];let o,a,c=14,g=14;for(const u of w){let t=o?(0,_.commonPrefixLength)(o,u):0;for(t===0?a=1:a=g;t<u.length;t++)t+1===u.length?(c=g,g=9):g+=1,s.push([a,u.toUpperCase().charCodeAt(t),g]),s.push([a,u.toLowerCase().charCodeAt(t),g]),a=g;o=u,g=c}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new p.StateMachine(s)}}provideDocumentLinks(w){this._initStateMachine();const s=[],o=p.LinkComputer.computeLinks({getLineContent(a){return w.lineAt(a-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const a of o){const c=A.DocumentLink.to(a);c.target&&s.push(c)}return s}}class y{constructor(w,s){this._extHostLanguageFeatures=s,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,s,o,a={}){if(y._validateFileSystemProvider(o),this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const c=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(c,o);let g=2;a.isCaseSensitive&&(g+=1024),a.isReadonly&&(g+=2048),typeof o.copy=="function"&&(g+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,T.checkProposedApiEnabled)(w,"fsChunks"),g+=4);let u;a.isReadonly&&(0,k.isMarkdownString)(a.isReadonly)&&((0,T.checkProposedApiEnabled)(w,"readonlyMessage"),u={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this._proxy.$registerFileSystemProvider(c,s,g,u).catch(n=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${s}`),console.error(n)});const t=o.onDidChangeFile(n=>{const r=[];for(const i of n){const{uri:l,type:f}=i;if(l.scheme!==s)continue;let S;switch(f){case R.FileChangeType.Changed:S=0;break;case R.FileChangeType.Created:S=1;break;case R.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:l,type:S})}this._proxy.$onFileSystemChange(c,r)});return(0,d.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(c),this._proxy.$unregisterProvider(c)})}static _validateFileSystemProvider(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(w){const{type:s,ctime:o,mtime:a,size:c,permissions:g}=w;return{type:s,ctime:o,mtime:a,size:c,permissions:g}}$stat(w,s){return Promise.resolve(this._getFsProvider(w).stat(D.URI.revive(s))).then(o=>y._asIStat(o))}$readdir(w,s){return Promise.resolve(this._getFsProvider(w).readDirectory(D.URI.revive(s)))}$readFile(w,s){return Promise.resolve(this._getFsProvider(w).readFile(D.URI.revive(s))).then(o=>b.VSBuffer.wrap(o))}$writeFile(w,s,o,a){return Promise.resolve(this._getFsProvider(w).writeFile(D.URI.revive(s),o.buffer,a))}$delete(w,s,o){return Promise.resolve(this._getFsProvider(w).delete(D.URI.revive(s),o))}$rename(w,s,o,a){return Promise.resolve(this._getFsProvider(w).rename(D.URI.revive(s),D.URI.revive(o),a))}$copy(w,s,o,a){const c=this._getFsProvider(w);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(D.URI.revive(s),D.URI.revive(o),a))}$mkdir(w,s){return Promise.resolve(this._getFsProvider(w).createDirectory(D.URI.revive(s)))}$watch(w,s,o,a){const c=this._getFsProvider(w).watch(D.URI.revive(o),a);this._watches.set(s,c)}$unwatch(w,s){const o=this._watches.get(s);o&&(o.dispose(),this._watches.delete(s))}$open(w,s,o){const a=this._getFsProvider(w);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(D.URI.revive(s),o))}$close(w,s){const o=this._getFsProvider(w);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(w,s,o,a){const c=this._getFsProvider(w);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const g=b.VSBuffer.alloc(a);return Promise.resolve(c.read(s,o,g.buffer,0,a)).then(u=>g.slice(0,u))}$write(w,s,o,a){const c=this._getFsProvider(w);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(s,o,a.buffer,0,a.byteLength))}_getFsProvider(w){const s=this._fsProvider.get(w);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.ExtHostFileSystem=y}),define(Ce[72],De([1,0,6,30,7,22,5,20,54,3,9,24,17]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=y=class{constructor(s,o){this._fileSystemProvider=new Map,this._writeQueue=new T.ResourceQueue,this._proxy=s.getProxy(D.MainContext.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(c){try{let g;const u=a._fileSystemProvider.get(c.scheme);return u?(await a._proxy.$ensureActivation(c.scheme),g=await u.impl.stat(c)):g=await a._proxy.$stat(c),{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===F.FilePermission.Readonly?1:void 0}}catch(g){y._handleError(g)}},async readDirectory(c){try{const g=a._fileSystemProvider.get(c.scheme);return g?(await a._proxy.$ensureActivation(c.scheme),(await g.impl.readDirectory(c)).slice()):await a._proxy.$readdir(c)}catch(g){return y._handleError(g)}},async createDirectory(c){try{const g=a._fileSystemProvider.get(c.scheme);return g&&!g.isReadonly?(await a._proxy.$ensureActivation(c.scheme),await a.mkdirp(g.impl,g.extUri,c)):await a._proxy.$mkdir(c)}catch(g){return y._handleError(g)}},async readFile(c){try{const g=a._fileSystemProvider.get(c.scheme);return g?(await a._proxy.$ensureActivation(c.scheme),(await g.impl.readFile(c)).slice()):(await a._proxy.$readFile(c)).buffer}catch(g){return y._handleError(g)}},async writeFile(c,g){try{const u=a._fileSystemProvider.get(c.scheme);return u&&!u.isReadonly?(await a._proxy.$ensureActivation(c.scheme),await a.mkdirp(u.impl,u.extUri,u.extUri.dirname(c)),await a._writeQueue.queueFor(c).queue(()=>Promise.resolve(u.impl.writeFile(c,g,{create:!0,overwrite:!0})))):await a._proxy.$writeFile(c,R.VSBuffer.wrap(g))}catch(u){return y._handleError(u)}},async delete(c,g){try{const u=a._fileSystemProvider.get(c.scheme);return u&&!u.isReadonly?(await a._proxy.$ensureActivation(c.scheme),await u.impl.delete(c,{recursive:!1,...g})):await a._proxy.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...g})}catch(u){return y._handleError(u)}},async rename(c,g,u){try{return await a._proxy.$rename(c,g,{overwrite:!1,...u})}catch(t){return y._handleError(t)}},async copy(c,g,u){try{return await a._proxy.$copy(c,g,{overwrite:!1,...u})}catch(t){return y._handleError(t)}},isWritableFileSystem(c){const g=o.getCapabilities(c);if(typeof g=="number")return!(g&2048)}})}async mkdirp(s,o,a){const c=[];for(;!o.isEqual(a,o.dirname(a));)try{if(!((await s.stat(a)).type&F.FileType.Directory))throw d.FileSystemError.FileExists(`Unable to create folder '${a.scheme===v.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(g){if(F.toFileSystemProviderErrorCode(g)!==F.FileSystemProviderErrorCode.FileNotFound)throw g;c.push(o.basename(a)),a=o.dirname(a)}for(let g=c.length-1;g>=0;g--){a=o.joinPath(a,c[g]);try{await s.createDirectory(a)}catch(u){if(F.toFileSystemProviderErrorCode(u)!==F.FileSystemProviderErrorCode.FileExists)throw u}}}static _handleError(s){if(s instanceof d.FileSystemError)throw s;if(s instanceof F.FileSystemProviderError)switch(s.code){case F.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(s.message);case F.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(s.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(s.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(s.message);case F.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(s.message);case F.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(s.message);default:throw new d.FileSystemError(s.message,s.name)}if(!(s instanceof Error))throw new d.FileSystemError(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw d.FileSystemError.Unavailable(s.message);switch(s.name){case F.FileSystemProviderErrorCode.FileExists:throw d.FileSystemError.FileExists(s.message);case F.FileSystemProviderErrorCode.FileNotFound:throw d.FileSystemError.FileNotFound(s.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw d.FileSystemError.FileNotADirectory(s.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw d.FileSystemError.FileIsADirectory(s.message);case F.FileSystemProviderErrorCode.NoPermissions:throw d.FileSystemError.NoPermissions(s.message);case F.FileSystemProviderErrorCode.Unavailable:throw d.FileSystemError.Unavailable(s.message);default:throw new d.FileSystemError(s.message,s.name)}}addFileSystemProvider(s,o,a){return this._fileSystemProvider.set(s,{impl:o,extUri:a?.isCaseSensitive?k.extUri:k.extUriIgnorePathCase,isReadonly:!!a?.isReadonly}),(0,b.toDisposable)(()=>this._fileSystemProvider.delete(s))}getFileSystemProviderExtUri(s){return this._fileSystemProvider.get(s)?.extUri??k.extUri}};e.ExtHostConsumerFileSystem=C,e.ExtHostConsumerFileSystem=C=y=je([$e(0,p.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],C),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[311],De([1,0,4,35,2,6,13,7]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(k,v,y,C,w,s,o,a){this._onDidCreate=new D.Emitter,this._onDidChange=new D.Emitter,this._onDidDelete=new D.Emitter;const c=this.ensureWatching(k,y,w);this._config=0,s&&(this._config+=1),o&&(this._config+=2),a&&(this._config+=4);const g=(0,F.parse)(w),u=typeof w=="string",t=C(n=>{if(!s)for(const r of n.created){const i=d.URI.revive(r);g(i.fsPath)&&(!u||v.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!o)for(const r of n.changed){const i=d.URI.revive(r);g(i.fsPath)&&(!u||v.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!a)for(const r of n.deleted){const i=d.URI.revive(r);g(i.fsPath)&&(!u||v.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=p.Disposable.from(c,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(k,v,y){const C=p.Disposable.from();if(typeof y=="string")return C;const w=k.getProxy(R.MainContext.MainThreadFileSystem);let s=!1;(y.pattern.includes(F.GLOBSTAR)||y.pattern.includes(F.GLOB_SPLIT))&&(s=!0);const o=Math.random();return w.$watch(v.identifier.value,o,y.baseUri,{recursive:s,excludes:[]}),p.Disposable.from({dispose:()=>w.$unwatch(o)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class b{constructor(k,v,y){this._mainContext=k,this._logService=v,this._extHostDocumentsAndEditors=y,this._onFileSystemEvent=new D.Emitter,this._onDidRenameFile=new D.Emitter,this._onDidCreateFile=new D.Emitter,this._onDidDeleteFile=new D.Emitter,this._onWillRenameFile=new D.AsyncEmitter,this._onWillCreateFile=new D.AsyncEmitter,this._onWillDeleteFile=new D.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,v,y,C,w,s){return new _(this._mainContext,k,v,this._onFileSystemEvent.event,A.GlobPattern.from(y),C,w,s)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,v){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:v.map(y=>({oldUri:d.URI.revive(y.source),newUri:d.URI.revive(y.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:v.map(y=>d.URI.revive(y.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:v.map(y=>d.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,v){return(y,C,w)=>{const s=function(a){y.call(C,a)};return s.extension=k,v.event(s,void 0,w)}}async $onWillRunFileOperation(k,v,y,C){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:v.map(w=>({oldUri:d.URI.revive(w.source),newUri:d.URI.revive(w.target)}))},y,C);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:v.map(w=>d.URI.revive(w.target))},y,C);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:v.map(w=>d.URI.revive(w.target))},y,C)}}async _fireWillEvent(k,v,y,C){const w=new Set,s=[];if(await k.fireAsync(v,C,async(a,c)=>{const g=Date.now(),u=await Promise.resolve(a);u instanceof p.WorkspaceEdit&&(s.push([c.extension,u]),w.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-g>y&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),C.isCancellationRequested||s.length===0)return;const o={edits:[]};for(const[,a]of s){const{edits:c}=A.WorkspaceEdit.from(a,{getTextDocumentVersion:g=>this._extHostDocumentsAndEditors.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(c)}return{edit:o,extensionNames:Array.from(w)}}}e.ExtHostFileSystemEventService=b}),define(Ce[312],De([1,0,3,2,6,13,7,33]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class _{static{this._pool=0}constructor(v,y){this.extension=v,this.provider=y,this.handle=_._pool++}}class b{constructor(v){this.session=v,this.responses=[]}}class T{static{this._nextId=0}constructor(v,y,C,w){this._documents=C,this._logService=w,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=v.getProxy(d.MainContext.MainThreadInlineChat),y.registerApiCommand(new p.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.ApiCommandArgument("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?R.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?R.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?R.Position.from(s.position):void 0}})],p.ApiCommandResult.Void))}registerProvider(v,y,C){const w=new _(v,y);return this._inputProvider.set(w.handle,w),this._proxy.$registerInteractiveEditorProvider(w.handle,C.label,v.identifier.value,typeof y.handleInteractiveEditorResponseFeedback=="function"),(0,D.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(w.handle),this._inputProvider.delete(w.handle)})}async $prepareSession(v,y,C,w){const s=this._inputProvider.get(v);if(!s){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const o=this._documents.getDocument(F.URI.revive(y)),a=R.Selection.to(C),c=await s.provider.prepareInteractiveEditorSession({document:o,selection:a},w);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const g=T._nextId++;return this._inputSessions.set(g,new b(c)),{id:g,placeholder:c.placeholder,slashCommands:c.slashCommands?.map(u=>({command:u.command,detail:u.detail,refer:u.refer,executeImmediately:u.executeImmediately})),wholeRange:R.Range.from(c.wholeRange),message:c.message}}async $provideResponse(v,y,C,w){const s=this._inputProvider.get(v);if(!s)return;const o=this._inputSessions.get(y.id);if(!o)return;const a={prompt:C.prompt,selection:R.Selection.to(C.selection),wholeRange:R.Range.to(C.wholeRange),attempt:C.attempt,live:C.live};let c=!1;const g={report:n=>{if(!C.live)throw new Error("Progress reporting is only supported for live sessions");c||w.isCancellationRequested||!n.message&&!n.edits||this._proxy.$handleProgressChunk(C.requestId,{message:n.message,edits:n.edits?.map(R.TextEdit.from)})}},u=s.provider.provideInteractiveEditorResponse(o.session,a,g,w);Promise.resolve(u).finally(()=>c=!0);const t=await u;if(t){const n=o.responses.push(t)-1,r={wholeRange:R.Range.from(t.wholeRange),placeholder:t.placeholder};if(T._isMessageResponse(t))return{...r,id:n,type:"message",message:R.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof A.WorkspaceEdit)return{...r,id:n,type:"bulkEdit",edits:R.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...r,id:n,type:"editorEdit",edits:i.map(R.TextEdit.from)}}}$handleFeedback(v,y,C,w){const s=this._inputProvider.get(v),o=this._inputSessions.get(y),a=o?.responses[C];if(s&&a){const c=R.InteractiveEditorResponseFeedbackKind.to(w);s.provider.handleInteractiveEditorResponseFeedback?.(o.session,a,c)}}$releaseSession(v,y){}static _isMessageResponse(v){return typeof v=="object"&&typeof v.contents=="object"}}e.ExtHostInteractiveEditor=T}),define(Ce[313],De([1,0,2,33]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class d{constructor(A,p,_,b,T){this._extHostNotebooks=p,this._textDocumentsAndEditors=_,this._commands=b;const k=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new F.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new F.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new F.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new F.ApiCommandResult("Notebook and input URI",v=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const y=this._extHostNotebooks.getEditorById(v.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:D.URI.revive(v.notebookUri),inputUri:D.URI.revive(v.inputUri),notebookEditor:y.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:D.URI.revive(v.notebookUri),inputUri:D.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(A,p,_,b){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:_,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(D.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,p){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=d}),define(Ce[314],De([1,0,6,7]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class d{constructor(A){this._IssueUriRequestHandlers=new Map,this._proxy=A.getProxy(D.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,p){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const _=this._IssueUriRequestHandlers.get(A);if(!_)throw new Error("Issue request handler not found");const b=await _.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}registerIssueUriRequestHandler(A,p){const _=A.identifier.value;return this._IssueUriRequestHandlers.set(_,p),this._proxy.$registerIssueUriRequestHandler(_),new F.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(_),this._IssueUriRequestHandlers.delete(_)})}}e.ExtHostIssueReporter=d}),define(Ce[315],De([1,0,3,6]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class d{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const p=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(p,A),(0,D.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(p)})}}e.ExtHostLabelService=d}),define(Ce[316],De([1,0,2,23,13,7,83,6,15,34,19,18,165,21,25,3,129,119,87,37,8,9,27,205]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const ie=this._documents.getDocument($),se=await this._provider.provideDocumentSymbols(ie,K);if(!(0,T.isFalsyOrEmpty)(se))return se[0]instanceof R.DocumentSymbol?se.map(d.DocumentSymbol.from):r._asDocumentSymbolTree(se)}static _asDocumentSymbolTree($){$=$.slice(0).sort((se,Q)=>{let he=se.location.range.start.compareTo(Q.location.range.start);return he===0&&(he=Q.location.range.end.compareTo(se.location.range.end)),he});const K=[],ie=[];for(const se of $){const Q={name:se.name||"!!MISSING: name!!",kind:d.SymbolKind.from(se.kind),tags:se.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:d.Range.from(se.location.range),selectionRange:d.Range.from(se.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Q),K.push(Q);break}const he=ie[ie.length-1];if(b.Range.containsRange(he.range,Q.range)&&!b.Range.equalsRange(he.range,Q.range)){he.children?.push(Q),ie.push(Q);break}ie.pop()}}return K}}class i{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor($,K,ie){this._documents=$,this._commands=K,this._provider=ie,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const ie=this._documents.getDocument($),se=await this._provider.provideCodeLenses(ie,K);if(!se||K.isCancellationRequested)return;const Q=this._cache.add(se),he=new w.DisposableStore;this._disposables.set(Q,he);const Se={cacheId:Q,lenses:[]};for(let Ue=0;Ue<se.length;Ue++)Se.lenses.push({cacheId:[Q,Ue],range:d.Range.from(se[Ue].range),command:this._commands.toInternal(se[Ue].command,he)});return Se}async resolveCodeLens($,K){const ie=$.cacheId&&this._cache.get(...$.cacheId);if(!ie)return;let se;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?se=ie:se=await this._provider.resolveCodeLens(ie,K),se||(se=ie),K.isCancellationRequested)return;const Q=$.cacheId&&this._disposables.get($.cacheId[0]);if(Q)return $.command=this._commands.toInternal(se.command??i._badCmd,Q),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}function l(ke){return Array.isArray(ke)?ke.map(d.DefinitionLink.from):ke?[d.DefinitionLink.from(ke)]:[]}class f{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideDefinition(se,Q,ie);return l(he)}}class S{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideDeclaration(se,Q,ie);return l(he)}}class I{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideImplementation(se,Q,ie);return l(he)}}class E{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideTypeDefinition(se,Q,ie);return l(he)}}class h{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideHover(se,Q,ie);if(!(!he||(0,T.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=se.getWordRangeAtPosition(Q)),he.range||(he.range=new R.Range(Q,Q)),d.Hover.from(he)}}class m{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideEvaluatableExpression(se,Q,ie);if(he)return d.EvaluatableExpression.from(he)}}class P{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,ie,se){const Q=this._documents.getDocument($),he=await this._provider.provideInlineValues(Q,d.Range.to(K),d.InlineValueContext.to(ie),se);if(Array.isArray(he))return he.map(Se=>d.InlineValue.from(Se))}}class O{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideDocumentHighlights(se,Q,ie);if(Array.isArray(he))return he.map(d.DocumentHighlight.from)}}class N{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.provideLinkedEditingRanges(se,Q,ie);if(he&&Array.isArray(he.ranges))return{ranges:(0,T.coalesce)(he.ranges.map(d.Range.from)),wordPattern:he.wordPattern}}}class L{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,ie,se){const Q=this._documents.getDocument($),he=d.Position.to(K),Se=await this._provider.provideReferences(Q,he,ie,se);if(Array.isArray(Se))return Se.map(d.location.from)}}class U{static{this._maxCodeActionsPerFile=1e3}constructor($,K,ie,se,Q,he,Se){this._documents=$,this._commands=K,this._diagnostics=ie,this._provider=se,this._logService=Q,this._extension=he,this._apiDeprecation=Se,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,ie,se){const Q=this._documents.getDocument($),he=v.Selection.isISelection(K)?d.Selection.to(K):d.Range.to(K),Se=[];for(const et of this._diagnostics.getDiagnostics($))if(he.intersection(et.range)&&Se.push(et)>U._maxCodeActionsPerFile)break;const Ue={diagnostics:Se,only:ie.only?new R.CodeActionKind(ie.only):void 0,triggerKind:d.CodeActionTriggerKind.to(ie.trigger)},We=await this._provider.provideCodeActions(Q,he,Ue,se);if(!(0,T.isNonEmptyArray)(We)||se.isCancellationRequested)return;const Ze=this._cache.add(We),Qe=new w.DisposableStore;this._disposables.set(Ze,Qe);const it=[];for(let et=0;et<We.length;et++){const Te=We[et];Te&&(U._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,Qe)})):(Ue.only&&(Te.kind?Ue.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ze,et],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,Qe),diagnostics:Te.diagnostics&&Te.diagnostics.map(d.Diagnostic.from),edit:Te.edit&&d.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Ze,actions:it}}async resolveCodeAction($,K){const[ie,se]=$,Q=this._cache.get(ie,se);if(!Q||U._isCommand(Q))return{};if(!this._provider.resolveCodeAction)return{};const he=await this._provider.resolveCodeAction(Q,K)??Q;let Se;he.edit&&(Se=d.WorkspaceEdit.from(he.edit,void 0));let Ue;if(he.command){const We=this._disposables.get(ie);We&&(Ue=this._commands.toInternal(he.command,We))}return{edit:Se,command:Ue}}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}class x{static toInternalProviderId($,K){return $+"."+K}constructor($,K,ie,se,Q){this._proxy=$,this._documents=K,this._provider=ie,this._handle=se,this._extension=Q}async prepareDocumentPaste($,K,ie,se){if(!this._provider.prepareDocumentPaste)return;const Q=this._documents.getDocument($),he=K.map(We=>d.Range.to(We)),Se=d.DataTransfer.toDataTransfer(ie,()=>{throw new g.NotImplementedError});if(await this._provider.prepareDocumentPaste(Q,he,Se,se),se.isCancellationRequested)return;const Ue=Array.from(Se).filter(([,We])=>!(We instanceof R.InternalDataTransferItem));return d.DataTransfer.from(Ue)}async providePasteEdits($,K,ie,se,Q){if(!this._provider.provideDocumentPasteEdits)return;const he=this._documents.getDocument(K),Se=ie.map(Ze=>d.Range.to(Ze)),Ue=d.DataTransfer.toDataTransfer(se,async Ze=>(await this._proxy.$resolvePasteFileData(this._handle,$,Ze)).buffer),We=await this._provider.provideDocumentPasteEdits(he,Se,Ue,Q);if(We)return{label:We.label??(0,n.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:x.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class M{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,ie){const se=this._documents.getDocument($),Q=await this._provider.provideDocumentFormattingEdits(se,K,ie);if(Array.isArray(Q))return Q.map(d.TextEdit.from)}}class H{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,ie,se){const Q=this._documents.getDocument($),he=d.Range.to(K),Se=await this._provider.provideDocumentRangeFormattingEdits(Q,he,ie,se);if(Array.isArray(Se))return Se.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits($,K,ie,se){(0,k.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this._documents.getDocument($),he=K.map(d.Range.to),Se=await this._provider.provideDocumentRangesFormattingEdits(Q,he,ie,se);if(Array.isArray(Se))return Se.map(d.TextEdit.from)}}class j{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,ie,se,Q){const he=this._documents.getDocument($),Se=d.Position.to(K),Ue=await this._provider.provideOnTypeFormattingEdits(he,Se,ie,se,Q);if(Array.isArray(Ue))return Ue.map(d.TextEdit.from)}}class fe{constructor($,K){this._provider=$,this._logService=K,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols($,K){const ie=await this._provider.provideWorkspaceSymbols($,K);if(!(0,T.isNonEmptyArray)(ie))return{symbols:[]};const se=this._cache.add(ie),Q={cacheId:se,symbols:[]};for(let he=0;he<ie.length;he++){const Se=ie[he];if(!Se||!Se.name){this._logService.warn("INVALID SymbolInformation",Se);continue}Q.symbols.push({...d.WorkspaceSymbol.from(Se),cacheId:[se,he]})}return Q}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!$.cacheId)return $;const ie=this._cache.get(...$.cacheId);if(ie){const se=await this._provider.resolveWorkspaceSymbol(ie,K);return se&&(0,F.mixin)($,d.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols($){this._cache.delete($)}}class Y{static supportsResolving($){return typeof $.prepareRename=="function"}constructor($,K,ie){this._documents=$,this._provider=K,this._logService=ie}async provideRenameEdits($,K,ie,se){const Q=this._documents.getDocument($),he=d.Position.to(K);try{const Se=await this._provider.provideRenameEdits(Q,he,ie,se);return Se?d.WorkspaceEdit.from(Se):void 0}catch(Se){const Ue=Y._asMessage(Se);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation($,K,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument($),Q=d.Position.to(K);try{const he=await this._provider.prepareRename(se,Q,ie);let Se,Ue;if(R.Range.isRange(he)?(Se=he,Ue=se.getText(he)):(0,k.isObject)(he)&&(Se=he.range,Ue=he.placeholder),!Se||!Ue)return;if(Se.start.line>Q.line||Se.end.line<Q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(Se),text:Ue}}catch(he){const Se=Y._asMessage(he);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(he)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class X{constructor($,K){this.resultId=$,this.tokens=K}}class z{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,ie){const se=this._documents.getDocument($),Q=K!==0?this._previousResults.get(K):null;let he=typeof Q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,Q.resultId,ie):await this._provider.provideDocumentSemanticTokens(se,ie);return Q&&this._previousResults.delete(K),he?(he=z._fixProvidedSemanticTokens(he),this._send(z._convertToEdits(Q,he),he)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new R.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new R.SemanticTokensEdits($.edits.map(K=>new R.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!z._isSemanticTokens(K)||!$||!$.tokens)return K;const ie=$.tokens,se=ie.length,Q=K.data,he=Q.length;let Se=0;const Ue=Math.min(se,he);for(;Se<Ue&&ie[Se]===Q[Se];)Se++;if(Se===se&&Se===he)return new R.SemanticTokensEdits([],K.resultId);let We=0;const Ze=Ue-Se;for(;We<Ze&&ie[se-We-1]===Q[he-We-1];)We++;return new R.SemanticTokensEdits([{start:Se,deleteCount:se-Se-We,data:Q.subarray(Se,he-We)}],K.resultId)}_send($,K){if(z._isSemanticTokens($)){const ie=this._nextResultId++;return this._previousResults.set(ie,new X($.resultId,$.data)),(0,s.encodeSemanticTokensDto)({id:ie,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const ie=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(ie,new X(K.resultId,K.data)):this._previousResults.set(ie,new X($.resultId)),(0,s.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:($.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class J{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,ie){const se=this._documents.getDocument($),Q=await this._provider.provideDocumentRangeSemanticTokens(se,d.Range.to(K),ie);return Q?this._send(Q):null}_send($){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}class ge{static supportsResolving($){return typeof $.resolveCompletionItem=="function"}constructor($,K,ie,se,Q){this._documents=$,this._commands=K,this._provider=ie,this._apiDeprecation=se,this._extension=Q,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems($,K,ie,se){const Q=this._documents.getDocument($),he=d.Position.to(K),Se=Q.getWordRangeAtPosition(he)||new R.Range(he,he),Ue=Se.with({end:he}),We=new c.StopWatch,Ze=await this._provider.provideCompletionItems(Q,he,se,d.CompletionContext.to(ie));if(!Ze||se.isCancellationRequested)return;const Qe=Array.isArray(Ze)?new R.CompletionList(Ze):Ze,it=ge.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),et=new w.DisposableStore;this._disposables.set(it,et);const Te=[],Oe={x:it,b:Te,a:{replace:d.Range.from(Se),insert:d.Range.from(Ue)},c:Qe.isIncomplete||void 0,d:We.elapsed()};for(let ze=0;ze<Qe.items.length;ze++){const Re=Qe.items[ze],Xe=this._convertCompletionItem(Re,[it,ze],Ue,Se);Te.push(Xe)}return Oe}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...$);if(!ie)return;const se=this._convertCompletionItem(ie,$),Q=await this._provider.resolveCompletionItem(ie,K);if(!Q)return;const he=this._convertCompletionItem(Q,$);return(se.h!==he.h||se.i!==he.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==he.n||se.o!==he.o||!(0,F.equals)(se.p,he.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,ie,se){const Q=this._disposables.get(K[0]);if(!Q)throw Error("DisposableStore is missing...");const he=this._commands.toInternal($.command,Q),Se={x:K,a:$.label,b:$.kind!==void 0?d.CompletionItemKind.from($.kind):void 0,m:$.tags&&$.tags.map(d.CompletionItemTag.from),c:$.detail,d:typeof $.documentation>"u"?void 0:d.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters?.join(""),l:$.additionalTextEdits&&$.additionalTextEdits.map(d.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=$.textEdit.newText):typeof $.insertText=="string"?Se.h=$.insertText:$.insertText instanceof R.SnippetString&&(Se.h=$.insertText.value,Se.i|=4);let Ue;return $.textEdit?Ue=$.textEdit.range:$.range&&(Ue=$.range),R.Range.isRange(Ue)?Se.j=d.Range.from(Ue):Ue&&(!ie?.isEqual(Ue.inserting)||!se?.isEqual(Ue.replacing))&&(Se.j={insert:d.Range.from(Ue.inserting),replace:d.Range.from(Ue.replacing)}),Se}}class le{async provideInlineCompletions($,K,ie,se){}disposeCompletions($){}handleDidShowCompletionItem($,K,ie){}handlePartialAccept($,K,ie){}}class we extends le{constructor($,K,ie,se){super(),this._extension=$,this._documents=K,this._provider=ie,this._commands=se,this._references=new G,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions($,K,ie,se){const Q=this._documents.getDocument($),he=d.Position.to(K),Se=await this._provider.provideInlineCompletionItems(Q,he,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:d.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[ie.triggerKind]},se);if(!Se||se.isCancellationRequested)return;const Ue=Array.isArray(Se)?Se:Se.items,We=this._isAdditionsProposedApiEnabled?Array.isArray(Se)?[]:Se.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(Se)?Se.enableForwardStability:void 0;let Qe;return{pid:this._references.createReferenceId({dispose(){Qe?.dispose()},items:Ue}),items:Ue.map((et,Te)=>{let Oe;et.command&&(Qe||(Qe=new w.DisposableStore),Oe=this._commands.toInternal(et.command,Qe));const ze=et.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:et.filterText,range:et.range?d.Range.from(et.range):void 0,command:Oe,idx:Te,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:We.map(et=>(Qe||(Qe=new w.DisposableStore),this._commands.toInternal(et,Qe))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions($){this._references.disposeReferenceId($)?.dispose()}handleDidShowCompletionItem($,K,ie){const se=this._references.get($)?.items[K];se&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(se,ie)}handlePartialAccept($,K,ie){const se=this._references.get($)?.items[K];se&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(se,ie)}}class G{constructor(){this._references=new Map,this._idPool=1}createReferenceId($){const K=this._idPool++;return this._references.set(K,$),K}disposeReferenceId($){const K=this._references.get($);return this._references.delete($),K}get($){return this._references.get($)}}class B{constructor($,K){this._documents=$,this._provider=K,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp($,K,ie,se){const Q=this._documents.getDocument($),he=d.Position.to(K),Se=this.reviveContext(ie),Ue=await this._provider.provideSignatureHelp(Q,he,se,Se);if(Ue){const We=this._cache.add([Ue]);return{...d.SignatureHelp.from(Ue),id:We}}}reviveContext($){let K;if($.activeSignatureHelp){const ie=d.SignatureHelp.to($.activeSignatureHelp),se=this._cache.get($.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=ie.activeSignature,K.activeParameter=ie.activeParameter):K=ie}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class V{constructor($,K,ie,se,Q){this._documents=$,this._commands=K,this._provider=ie,this._logService=se,this._extension=Q,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints($,K,ie){const se=this._documents.getDocument($),Q=d.Range.to(K),he=await this._provider.provideInlayHints(se,Q,ie);if(!Array.isArray(he)||he.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${K}`);return}if(ie.isCancellationRequested)return;const Se=this._cache.add(he);this._disposables.set(Se,new w.DisposableStore);const Ue={hints:[],cacheId:Se};for(let We=0;We<he.length;We++)this._isValidInlayHint(he[We],Q)&&Ue.hints.push(this._convertInlayHint(he[We],[Se,We]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${K}`),Ue}async resolveInlayHint($,K){if(typeof this._provider.resolveInlayHint!="function")return;const ie=this._cache.get(...$);if(!ie)return;const se=await this._provider.resolveInlayHint(ie,K);if(se&&this._isValidInlayHint(se))return this._convertInlayHint(se,$)}releaseHints($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_isValidInlayHint($,K){return $.label.length===0||Array.isArray($.label)&&$.label.every(ie=>ie.value.length===0)?(console.log("INVALID inlay hint, empty label",$),!1):!(K&&!K.contains($.position))}_convertInlayHint($,K){const ie=this._disposables.get(K[0]);if(!ie)throw Error("DisposableStore is missing...");const se={label:"",cacheId:K,tooltip:d.MarkdownString.fromStrict($.tooltip),position:d.Position.from($.position),textEdits:$.textEdits&&$.textEdits.map(d.TextEdit.from),kind:$.kind&&d.InlayHintKind.from($.kind),paddingLeft:$.paddingLeft,paddingRight:$.paddingRight};return typeof $.label=="string"?se.label=$.label:se.label=$.label.map(Q=>{const he={label:Q.value};return he.tooltip=d.MarkdownString.fromStrict(Q.tooltip),R.Location.isLocation(Q.location)&&(he.location=d.location.from(Q.location)),Q.command&&(he.command=this._commands.toInternal(Q.command,ie)),he}),se}}class me{constructor($,K){this._documents=$,this._provider=K,this._cache=new a.Cache("DocumentLink")}async provideLinks($,K){const ie=this._documents.getDocument($),se=await this._provider.provideDocumentLinks(ie,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(me._validateLink).map(d.DocumentLink.from)};{const Q=this._cache.add(se),he={links:[],cacheId:Q};for(let Se=0;Se<se.length;Se++){if(!me._validateLink(se[Se]))continue;const Ue=d.DocumentLink.from(se[Se]);Ue.cacheId=[Q,Se],he.links.push(Ue)}return he}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...$);if(!ie)return;const se=await this._provider.resolveDocumentLink(ie,K);if(!(!se||!me._validateLink(se)))return d.DocumentLink.from(se)}releaseLinks($){this._cache.delete($)}}class Z{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const ie=this._documents.getDocument($),se=await this._provider.provideDocumentColors(ie,K);return Array.isArray(se)?se.map(he=>({color:d.Color.from(he.color),range:d.Range.from(he.range)})):[]}async provideColorPresentations($,K,ie){const se=this._documents.getDocument($),Q=d.Range.to(K.range),he=d.Color.to(K.color),Se=await this._provider.provideColorPresentations(he,{document:se,range:Q},ie);if(Array.isArray(Se))return Se.map(d.ColorPresentation.from)}}class ne{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,ie){const se=this._documents.getDocument($),Q=await this._provider.provideFoldingRanges(se,K,ie);if(Array.isArray(Q))return Q.map(d.FoldingRange.from)}}class re{constructor($,K,ie){this._documents=$,this._provider=K,this._logService=ie}async provideSelectionRanges($,K,ie){const se=this._documents.getDocument($),Q=K.map(d.Position.to),he=await this._provider.provideSelectionRanges(se,Q,ie);if(!(0,T.isNonEmptyArray)(he))return[];if(he.length!==Q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Ue=0;Ue<Q.length;Ue++){const We=[];Se.push(We);let Ze=Q[Ue],Qe=he[Ue];for(;;){if(!Qe.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Qe)),!Qe.parent)break;Ze=Qe.range,Qe=Qe.parent}}return Se}}class ye{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.prepareCallHierarchy(se,Q,ie);if(!he)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(he)?he.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,he)]}async provideCallsTo($,K,ie){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyIncomingCalls(se,ie);if(Q)return Q.map(he=>({from:this._cacheAndConvertItem($,he.from),fromRanges:he.fromRanges.map(Se=>d.Range.from(Se))}))}async provideCallsFrom($,K,ie){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyOutgoingCalls(se,ie);if(Q)return Q.map(he=>({to:this._cacheAndConvertItem($,he.to),fromRanges:he.fromRanges.map(Se=>d.Range.from(Se))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const ie=this._cache.get($),se=d.CallHierarchyItem.from(K,$,ie.size.toString(36));return ie.set(se._itemId,K),se}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class oe{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ie){const se=this._documents.getDocument($),Q=d.Position.to(K),he=await this._provider.prepareTypeHierarchy(se,Q,ie);if(!he)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(he)?he.map(Ue=>this._cacheAndConvertItem(Se,Ue)):[this._cacheAndConvertItem(Se,he)]}async provideSupertypes($,K,ie){const se=this._itemFromCache($,K);if(!se)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySupertypes(se,ie);if(Q)return Q.map(he=>this._cacheAndConvertItem($,he))}async provideSubtypes($,K,ie){const se=this._itemFromCache($,K);if(!se)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySubtypes(se,ie);if(Q)return Q.map(he=>this._cacheAndConvertItem($,he))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const ie=this._cache.get($),se=d.TypeHierarchyItem.from(K,$,ie.size.toString(36));return ie.set(se._itemId,K),se}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class de{static toInternalProviderId($,K){return $+"."+K}constructor($,K,ie,se,Q){this._proxy=$,this._documents=K,this._provider=ie,this._handle=se,this._extension=Q}async provideDocumentOnDropEdits($,K,ie,se,Q){const he=this._documents.getDocument(K),Se=d.Position.to(ie),Ue=d.DataTransfer.toDataTransfer(se,async Ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,$,Ze)).buffer),We=await this._provider.provideDocumentDropEdits(he,Se,Ue,Q);if(We)return{label:We.label??(0,n.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor($,K){this._documents=$,this._provider=K}async provideMappedEdits($,K,ie,se){const Q=D.URI.revive($),he=this._documents.getDocument(Q),Se=ie.documents.map(Ze=>Ze.map(Qe=>({uri:D.URI.revive(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(it=>d.Range.to(it))}))),Ue={documents:Se,selections:Se[0]?.[0]?.ranges??[]},We=await this._provider.provideMappedEdits(he,K,Ue,se);return We?d.WorkspaceEdit.from(We):null}}class ue{constructor($,K){this.adapter=$,this.extension=K}}class ve{static{this._handlePool=0}constructor($,K,ie,se,Q,he,Se,Ue){this._uriTransformer=K,this._documents=ie,this._commands=se,this._diagnostics=Q,this._logService=he,this._apiDeprecation=Se,this._extensionTelemetry=Ue,this._adapter=new Map,this._proxy=$.getProxy(p.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector($,K){return d.DocumentSelector.from($,this._uriTransformer,K)}_createDisposable($){return new R.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return ve._handlePool++}async _withAdapter($,K,ie,se,Q,he=!1){const Se=this._adapter.get($);if(!Se||!(Se.adapter instanceof K))return se;const Ue=Date.now();he||this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${ie.toString().replace(/[\r\n]/g,"")}'`);const We=ie(Se.adapter,Se.extension);return Promise.resolve(We).catch(Ze=>{(0,g.isCancellationError)(Ze)||(this._logService.error(`[${Se.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(Se.extension.identifier,Ze))}).finally(()=>{he||this._logService.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),y.CancellationToken.isCancellationToken(Q)?(0,u.raceCancellationError)(We,Q):We}_addNewAdapter($,K){const ie=this._nextHandle();return this._adapter.set(ie,new ue($,K)),ie}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,ie,se){const Q=this._addNewAdapter(new r(this._documents,ie),$),he=se&&se.label||ve._extLabel($);return this._proxy.$registerDocumentSymbolProvider(Q,this._transformDocumentSelector(K,$),he),this._createDisposable(Q)}$provideDocumentSymbols($,K,ie){return this._withAdapter($,r,se=>se.provideDocumentSymbols(D.URI.revive(K),ie),void 0,ie)}registerCodeLensProvider($,K,ie){const se=this._nextHandle(),Q=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new ue(new i(this._documents,this._commands.converter,ie),$)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K,$),Q);let he=this._createDisposable(se);if(Q!==void 0){const Se=ie.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(Q));he=R.Disposable.from(he,Se)}return he}$provideCodeLenses($,K,ie){return this._withAdapter($,i,se=>se.provideCodeLenses(D.URI.revive(K),ie),void 0,ie)}$resolveCodeLens($,K,ie){return this._withAdapter($,i,se=>se.resolveCodeLens(K,ie),void 0,void 0)}$releaseCodeLenses($,K){this._withAdapter($,i,ie=>Promise.resolve(ie.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider($,K,ie){const se=this._addNewAdapter(new f(this._documents,ie),$);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDefinition($,K,ie,se){return this._withAdapter($,f,Q=>Q.provideDefinition(D.URI.revive(K),ie,se),[],se)}registerDeclarationProvider($,K,ie){const se=this._addNewAdapter(new S(this._documents,ie),$);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDeclaration($,K,ie,se){return this._withAdapter($,S,Q=>Q.provideDeclaration(D.URI.revive(K),ie,se),[],se)}registerImplementationProvider($,K,ie){const se=this._addNewAdapter(new I(this._documents,ie),$);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideImplementation($,K,ie,se){return this._withAdapter($,I,Q=>Q.provideImplementation(D.URI.revive(K),ie,se),[],se)}registerTypeDefinitionProvider($,K,ie){const se=this._addNewAdapter(new E(this._documents,ie),$);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideTypeDefinition($,K,ie,se){return this._withAdapter($,E,Q=>Q.provideTypeDefinition(D.URI.revive(K),ie,se),[],se)}registerHoverProvider($,K,ie,se){const Q=this._addNewAdapter(new h(this._documents,ie),$);return this._proxy.$registerHoverProvider(Q,this._transformDocumentSelector(K,$)),this._createDisposable(Q)}$provideHover($,K,ie,se){return this._withAdapter($,h,Q=>Q.provideHover(D.URI.revive(K),ie,se),void 0,se)}registerEvaluatableExpressionProvider($,K,ie,se){const Q=this._addNewAdapter(new m(this._documents,ie),$);return this._proxy.$registerEvaluatableExpressionProvider(Q,this._transformDocumentSelector(K,$)),this._createDisposable(Q)}$provideEvaluatableExpression($,K,ie,se){return this._withAdapter($,m,Q=>Q.provideEvaluatableExpression(D.URI.revive(K),ie,se),void 0,se)}registerInlineValuesProvider($,K,ie,se){const Q=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new P(this._documents,ie),$);this._proxy.$registerInlineValuesProvider(he,this._transformDocumentSelector(K,$),Q);let Se=this._createDisposable(he);if(Q!==void 0){const Ue=ie.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(Q));Se=R.Disposable.from(Se,Ue)}return Se}$provideInlineValues($,K,ie,se,Q){return this._withAdapter($,P,he=>he.provideInlineValues(D.URI.revive(K),ie,se,Q),void 0,Q)}registerDocumentHighlightProvider($,K,ie){const se=this._addNewAdapter(new O(this._documents,ie),$);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDocumentHighlights($,K,ie,se){return this._withAdapter($,O,Q=>Q.provideDocumentHighlights(D.URI.revive(K),ie,se),void 0,se)}registerLinkedEditingRangeProvider($,K,ie){const se=this._addNewAdapter(new N(this._documents,ie),$);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideLinkedEditingRanges($,K,ie,se){return this._withAdapter($,N,async Q=>{const he=await Q.provideLinkedEditingRanges(D.URI.revive(K),ie,se);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ve._serializeRegExp(he.wordPattern):void 0}},void 0,se)}registerReferenceProvider($,K,ie){const se=this._addNewAdapter(new L(this._documents,ie),$);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideReferences($,K,ie,se,Q){return this._withAdapter($,L,he=>he.provideReferences(D.URI.revive(K),ie,se,Q),void 0,Q)}registerCodeActionProvider($,K,ie,se){const Q=new w.DisposableStore,he=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(he,this._transformDocumentSelector(K,$),{providedKinds:se?.providedCodeActionKinds?.map(Se=>Se.value),documentation:se?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,Q)}))},ve._extLabel($),!!ie.resolveCodeAction),Q.add(this._createDisposable(he)),Q}$provideCodeActions($,K,ie,se,Q){return this._withAdapter($,U,he=>he.provideCodeActions(D.URI.revive(K),ie,se,Q),void 0,Q)}$resolveCodeAction($,K,ie){return this._withAdapter($,U,se=>se.resolveCodeAction(K,ie),{},void 0)}$releaseCodeActions($,K){this._withAdapter($,U,ie=>Promise.resolve(ie.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider($,K,ie){const se=this._addNewAdapter(new M(this._documents,ie),$);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K,$),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentFormattingEdits($,K,ie,se){return this._withAdapter($,M,Q=>Q.provideDocumentFormattingEdits(D.URI.revive(K),ie,se),void 0,se)}registerDocumentRangeFormattingEditProvider($,K,ie){const se=typeof ie.provideDocumentRangesFormattingEdits=="function",Q=this._addNewAdapter(new H(this._documents,ie),$);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(K,$),$.identifier,$.displayName||$.name,se),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits($,K,ie,se,Q){return this._withAdapter($,H,he=>he.provideDocumentRangeFormattingEdits(D.URI.revive(K),ie,se,Q),void 0,Q)}$provideDocumentRangesFormattingEdits($,K,ie,se,Q){return this._withAdapter($,H,he=>he.provideDocumentRangesFormattingEdits(D.URI.revive(K),ie,se,Q),void 0,Q)}registerOnTypeFormattingEditProvider($,K,ie,se){const Q=this._addNewAdapter(new j(this._documents,ie),$);return this._proxy.$registerOnTypeFormattingSupport(Q,this._transformDocumentSelector(K,$),se,$.identifier),this._createDisposable(Q)}$provideOnTypeFormattingEdits($,K,ie,se,Q,he){return this._withAdapter($,j,Se=>Se.provideOnTypeFormattingEdits(D.URI.revive(K),ie,se,Q,he),void 0,he)}registerWorkspaceSymbolProvider($,K){const ie=this._addNewAdapter(new fe(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ie,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(ie)}$provideWorkspaceSymbols($,K,ie){return this._withAdapter($,fe,se=>se.provideWorkspaceSymbols(K,ie),{symbols:[]},ie)}$resolveWorkspaceSymbol($,K,ie){return this._withAdapter($,fe,se=>se.resolveWorkspaceSymbol(K,ie),void 0,void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,fe,ie=>ie.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider($,K,ie){const se=this._addNewAdapter(new Y(this._documents,ie,this._logService),$);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K,$),Y.supportsResolving(ie)),this._createDisposable(se)}$provideRenameEdits($,K,ie,se,Q){return this._withAdapter($,Y,he=>he.provideRenameEdits(D.URI.revive(K),ie,se,Q),void 0,Q)}$resolveRenameLocation($,K,ie,se){return this._withAdapter($,Y,Q=>Q.resolveRenameLocation(D.URI.revive(K),ie,se),void 0,se)}registerDocumentSemanticTokensProvider($,K,ie,se){const Q=this._addNewAdapter(new z(this._documents,ie),$),he=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Q,this._transformDocumentSelector(K,$),se,he);let Se=this._createDisposable(Q);if(he){const Ue=ie.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(he));Se=R.Disposable.from(Se,Ue)}return Se}$provideDocumentSemanticTokens($,K,ie,se){return this._withAdapter($,z,Q=>Q.provideDocumentSemanticTokens(D.URI.revive(K),ie,se),null,se)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,z,ie=>ie.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider($,K,ie,se){const Q=this._addNewAdapter(new J(this._documents,ie),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Q,this._transformDocumentSelector(K,$),se),this._createDisposable(Q)}$provideDocumentRangeSemanticTokens($,K,ie,se){return this._withAdapter($,J,Q=>Q.provideDocumentRangeSemanticTokens(D.URI.revive(K),ie,se),null,se)}registerCompletionItemProvider($,K,ie,se){const Q=this._addNewAdapter(new ge(this._documents,this._commands.converter,ie,this._apiDeprecation,$),$);return this._proxy.$registerCompletionsProvider(Q,this._transformDocumentSelector(K,$),se,ge.supportsResolving(ie),$.identifier),this._createDisposable(Q)}$provideCompletionItems($,K,ie,se,Q){return this._withAdapter($,ge,he=>he.provideCompletionItems(D.URI.revive(K),ie,se,Q),void 0,Q)}$resolveCompletionItem($,K,ie){return this._withAdapter($,ge,se=>se.resolveCompletionItem(K,ie),void 0,ie)}$releaseCompletionItems($,K){this._withAdapter($,ge,ie=>ie.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider($,K,ie,se){const Q=new we($,this._documents,ie,this._commands.converter),he=this._addNewAdapter(Q,$);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(K,$),Q.supportsHandleEvents,C.ExtensionIdentifier.toKey($.identifier.value),se?.yieldTo?.map(Se=>C.ExtensionIdentifier.toKey(Se))||[]),this._createDisposable(he)}$provideInlineCompletions($,K,ie,se,Q){return this._withAdapter($,le,he=>he.provideInlineCompletions(D.URI.revive(K),ie,se,Q),void 0,Q)}$handleInlineCompletionDidShow($,K,ie,se){this._withAdapter($,le,async Q=>{Q.handleDidShowCompletionItem(K,ie,se)},void 0,void 0)}$handleInlineCompletionPartialAccept($,K,ie,se){this._withAdapter($,le,async Q=>{Q.handlePartialAccept(K,ie,se)},void 0,void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,le,async ie=>{ie.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider($,K,ie,se){const Q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,he=this._addNewAdapter(new B(this._documents,ie),$);return this._proxy.$registerSignatureHelpProvider(he,this._transformDocumentSelector(K,$),Q),this._createDisposable(he)}$provideSignatureHelp($,K,ie,se,Q){return this._withAdapter($,B,he=>he.provideSignatureHelp(D.URI.revive(K),ie,se,Q),void 0,Q)}$releaseSignatureHelp($,K){this._withAdapter($,B,ie=>ie.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider($,K,ie){const se=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new V(this._documents,this._commands.converter,ie,this._logService,$),$);this._proxy.$registerInlayHintsProvider(Q,this._transformDocumentSelector(K,$),typeof ie.resolveInlayHint=="function",se,ve._extLabel($));let he=this._createDisposable(Q);if(se!==void 0){const Se=ie.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(se));he=R.Disposable.from(he,Se)}return he}$provideInlayHints($,K,ie,se){return this._withAdapter($,V,Q=>Q.provideInlayHints(D.URI.revive(K),ie,se),void 0,se)}$resolveInlayHint($,K,ie){return this._withAdapter($,V,se=>se.resolveInlayHint(K,ie),void 0,ie)}$releaseInlayHints($,K){this._withAdapter($,V,ie=>ie.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider($,K,ie){const se=this._addNewAdapter(new me(this._documents,ie),$);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K,$),typeof ie.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks($,K,ie){return this._withAdapter($,me,se=>se.provideLinks(D.URI.revive(K),ie),void 0,ie,K.scheme==="output")}$resolveDocumentLink($,K,ie){return this._withAdapter($,me,se=>se.resolveLink(K,ie),void 0,void 0,!0)}$releaseDocumentLinks($,K){this._withAdapter($,me,ie=>ie.releaseLinks(K),void 0,void 0,!0)}registerColorProvider($,K,ie){const se=this._addNewAdapter(new Z(this._documents,ie),$);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideDocumentColors($,K,ie){return this._withAdapter($,Z,se=>se.provideColors(D.URI.revive(K),ie),[],ie)}$provideColorPresentations($,K,ie,se){return this._withAdapter($,Z,Q=>Q.provideColorPresentations(D.URI.revive(K),ie,se),void 0,se)}registerFoldingRangeProvider($,K,ie){const se=this._nextHandle(),Q=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new ue(new ne(this._documents,ie),$)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K,$),$.identifier,Q);let he=this._createDisposable(se);if(Q!==void 0){const Se=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Q));he=R.Disposable.from(he,Se)}return he}$provideFoldingRanges($,K,ie,se){return this._withAdapter($,ne,Q=>Q.provideFoldingRanges(D.URI.revive(K),ie,se),void 0,se)}registerSelectionRangeProvider($,K,ie){const se=this._addNewAdapter(new re(this._documents,ie,this._logService),$);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideSelectionRanges($,K,ie,se){return this._withAdapter($,re,Q=>Q.provideSelectionRanges(D.URI.revive(K),ie,se),[],se)}registerCallHierarchyProvider($,K,ie){const se=this._addNewAdapter(new ye(this._documents,ie),$);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$prepareCallHierarchy($,K,ie,se){return this._withAdapter($,ye,Q=>Promise.resolve(Q.prepareSession(D.URI.revive(K),ie,se)),void 0,se)}$provideCallHierarchyIncomingCalls($,K,ie,se){return this._withAdapter($,ye,Q=>Q.provideCallsTo(K,ie,se),void 0,se)}$provideCallHierarchyOutgoingCalls($,K,ie,se){return this._withAdapter($,ye,Q=>Q.provideCallsFrom(K,ie,se),void 0,se)}$releaseCallHierarchy($,K){this._withAdapter($,ye,ie=>Promise.resolve(ie.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider($,K,ie){const se=this._addNewAdapter(new oe(this._documents,ie),$);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$prepareTypeHierarchy($,K,ie,se){return this._withAdapter($,oe,Q=>Promise.resolve(Q.prepareSession(D.URI.revive(K),ie,se)),void 0,se)}$provideTypeHierarchySupertypes($,K,ie,se){return this._withAdapter($,oe,Q=>Q.provideSupertypes(K,ie,se),void 0,se)}$provideTypeHierarchySubtypes($,K,ie,se){return this._withAdapter($,oe,Q=>Q.provideSubtypes(K,ie,se),void 0,se)}$releaseTypeHierarchy($,K){this._withAdapter($,oe,ie=>Promise.resolve(ie.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider($,K,ie,se){const Q=this._nextHandle();this._adapter.set(Q,new ue(new de(this._proxy,this._documents,ie,Q,$),$));const he=(0,t.isProposedApiEnabled)($,"dropMetadata")&&se?de.toInternalProviderId($.identifier.value,se.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(Q,this._transformDocumentSelector(K,$),he,(0,t.isProposedApiEnabled)($,"dropMetadata")?se:void 0),this._createDisposable(Q)}$provideDocumentOnDropEdits($,K,ie,se,Q,he){return this._withAdapter($,de,Se=>Promise.resolve(Se.provideDocumentOnDropEdits(K,D.URI.revive(ie),se,Q,he)),void 0,void 0)}registerMappedEditsProvider($,K,ie){const se=this._addNewAdapter(new ee(this._documents,ie),$);return this._proxy.$registerMappedEditsProvider(se,this._transformDocumentSelector(K,$)),this._createDisposable(se)}$provideMappedEdits($,K,ie,se,Q){return this._withAdapter($,ee,he=>Promise.resolve(he.provideMappedEdits(K,ie,se,Q)),null,Q)}registerDocumentPasteEditProvider($,K,ie,se){const Q=this._nextHandle();this._adapter.set(Q,new ue(new x(this._proxy,this._documents,ie,Q,$),$));const he=x.toInternalProviderId($.identifier.value,se.id);return this._proxy.$registerPasteEditProvider(Q,this._transformDocumentSelector(K,$),he,{supportsCopy:!!ie.prepareDocumentPaste,supportsPaste:!!ie.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this._createDisposable(Q)}$prepareDocumentPaste($,K,ie,se,Q){return this._withAdapter($,x,he=>he.prepareDocumentPaste(D.URI.revive(K),ie,se,Q),void 0,Q)}$providePasteEdits($,K,ie,se,Q,he){return this._withAdapter($,x,Se=>Se.providePasteEdits(K,D.URI.revive(ie),se,Q,he),void 0,he)}static _serializeRegExp($){return{pattern:$.source,flags:$.flags}}static _serializeIndentationRule($){return{decreaseIndentPattern:ve._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:ve._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?ve._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?ve._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:ve._serializeRegExp($.beforeText),afterText:$.afterText?ve._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?ve._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(ve._serializeOnEnterRule)}static _serializeAutoClosingPair($){return{open:$.open,close:$.close,notIn:$.notIn?$.notIn.map(K=>R.SyntaxTokenType.toString(K)):void 0}}static _serializeAutoClosingPairs($){return $.map(ve._serializeAutoClosingPair)}setLanguageConfiguration($,K,ie){const{wordPattern:se}=ie;if(se&&(0,_.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const Q=this._nextHandle(),he={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?ve._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?ve._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?ve._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport,autoClosingPairs:ie.autoClosingPairs?ve._serializeAutoClosingPairs(ie.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(Q,K,he),this._createDisposable(Q)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=ve}),define(Ce[317],De([1,0,6,13,7,38,9,3]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(T,k,v,y){this._documents=k,this._commands=v,this._uriTransformer=y,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=T.getProxy(D.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this._languageIds=T}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(T,k){await this._proxy.$changeLanguage(T,k);const v=this._documents.getDocumentData(T);if(!v)throw new Error(`document '${T.toString()}' NOT found`);return v.document}async tokenAtPosition(T,k){const v=T.version,y=F.Position.from(k),C=await this._proxy.$tokensAtPosition(T.uri,y),w={type:d.StandardTokenType.Other,range:T.getWordRangeAtPosition(k)??new d.Range(k.line,k.character,k.line,k.character)};if(!C)return w;const s={range:F.Range.to(C.range),type:F.TokenType.to(C.type)};return!s.range.contains(k)||v!==T.version?w:s}createLanguageStatusItem(T,k,v){const y=this._handlePool++,C=this._proxy,w=this._ids,s=`${T.identifier.value}/${k}`;if(w.has(s))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);w.add(s);const o={selector:v,id:k,name:T.displayName??T.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new p.DisposableStore,g=()=>{if(a?.dispose(),!w.has(s)){console.warn(`LanguageStatusItem (${k}) from ${T.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,A.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(y,{id:s,name:o.name??T.displayName??T.name,source:T.displayName??T.name,selector:F.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===d.LanguageStatusSeverity.Error?R.default.Error:o.severity===d.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:o.command&&this._commands.toInternal(o.command,c),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},u={dispose(){c.dispose(),a?.dispose(),C.$removeLanguageStatus(y),w.delete(s)},get id(){return o.id},get name(){return o.name},set name(t){o.name=t,g()},get selector(){return o.selector},set selector(t){o.selector=t,g()},get text(){return o.text},set text(t){o.text=t,g()},get detail(){return o.detail},set detail(t){o.detail=t,g()},get severity(){return o.severity},set severity(t){o.severity=t,g()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(t){o.accessibilityInformation=t,g()},get command(){return o.command},set command(t){o.command=t,g()},get busy(){return o.busy},set busy(t){o.busy=t,g()}};return g(),u}}e.ExtHostLanguages=_}),define(Ce[112],De([1,0,12,15,2,5,14,6,26,20]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let T=class{constructor(v,y,C){this.logService=C,this.bundleCache=new Map,this._proxy=y.getProxy(p.MainContext.MainThreadLocalization),this.currentLanguage=v.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===D.LANGUAGE_DEFAULT}getMessage(v,y){const{message:C,args:w,comment:s}=y;if(this.isDefaultLanguage)return(0,F.format2)(C,w??{});let o=C;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const a=this.bundleCache.get(v)?.contents[o];return a||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.format2)(a??C,w??{})}getBundle(v){return this.bundleCache.get(v)?.contents}getBundleUri(v){return this.bundleCache.get(v)?.uri}async initializeLocalizedMessages(v){if(this.isDefaultLanguage||!v.l10n&&!v.isBuiltin||this.bundleCache.has(v.identifier.value))return;let y;const C=await this.getBundleLocation(v);if(!C){this.logService.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const w=await this._proxy.$fetchBundleContents(C),s=JSON.parse(w);y=v.isBuiltin?s.contents?.bundle:s}catch(w){this.logService.error(`Failed to load translations for ${v.identifier.value} from ${C}: ${w.message}`);return}y&&this.bundleCache.set(v.identifier.value,{contents:y,uri:C})}async getBundleLocation(v){if(v.isBuiltin){const y=await this._proxy.$fetchBuiltInBundleUri(v.identifier.value,this.currentLanguage);return d.URI.revive(y)}return v.l10n?d.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=T,e.ExtHostLocalizationService=T=je([$e(0,_.IExtHostInitDataService),$e(1,b.IExtHostRpcService),$e(2,A.ILogService)],T),e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(Ce[150],De([1,0,14,6,26,20,2,62]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let _=class extends D.AbstractLoggerService{constructor(k,v){super(v.logLevel,v.logsLocation,v.loggers.map(y=>(0,p.revive)(y))),this._proxy=k.getProxy(F.MainContext.MainThreadLogger)}$setLogLevel(k,v){v?this.setLogLevel(A.URI.revive(v),k):this.setLogLevel(k)}setVisibility(k,v){super.setVisibility(k,v),this._proxy.$setVisibility(k,v)}doCreateLogger(k,v,y){return new b(this._proxy,k,v,y)}};e.ExtHostLoggerService=_,e.ExtHostLoggerService=_=je([$e(0,R.IExtHostRpcService),$e(1,d.IExtHostInitDataService)],_);class b extends D.AbstractMessageLogger{constructor(k,v,y,C){super(C?.logLevel==="always"),this.proxy=k,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(y),this.proxy.$createLogger(v,C).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,v){const y=[[k,v]];this.isLoggerCreated?this.doLog(y):this.buffer.push(...y)}doLog(k){this.proxy.$log(this.file,k)}flush(){this.proxy.$flush(this.file)}}}),define(Ce[113],De([1,0,6,5,3,20,22]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,F.createDecorator)("IExtHostManagedSockets");let p=class{constructor(k){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=k.getProxy(D.MainContext.MainThreadManagedSockets)}setFactory(k,v){for(const y of this._managedRemoteSockets.values())y.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new _(k,v),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(k){if(!this._factory||this._factory.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const v=++this._remoteSocketIdCounter,y=await this._factory.makeConnection(),C=new d.DisposableStore;return this._managedRemoteSockets.set(v,new b(v,y,C)),C.add((0,d.toDisposable)(()=>this._managedRemoteSockets.delete(v))),C.add(y.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(v),C.dispose()})),C.add(y.onDidClose(w=>{this._proxy.$onDidManagedSocketClose(v,w?.stack??w?.message),C.dispose()})),C.add(y.onDidReceiveMessage(w=>this._proxy.$onDidManagedSocketHaveData(v,A.VSBuffer.wrap(w)))),v}$remoteSocketWrite(k,v){this._managedRemoteSockets.get(k)?.actual.send(v.buffer)}$remoteSocketEnd(k){const v=this._managedRemoteSockets.get(k);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(k){await this._managedRemoteSockets.get(k)?.actual.drain?.()}};e.ExtHostManagedSockets=p,e.ExtHostManagedSockets=p=je([$e(0,R.IExtHostRpcService)],p);class _{constructor(k,v){this.socketFactoryId=k,this.makeConnection=v}}class b extends d.Disposable{constructor(k,v,y){super(),this.socketId=k,this.actual=v,this._register(y)}}}),define(Ce[318],De([1,0,6,14,27]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(p){return p&&p.title}let A=class{constructor(_,b){this._logService=b,this._proxy=_.getProxy(D.MainContext.MainThreadMessageService)}showMessage(_,b,T,k,v){const y={source:{identifier:_.identifier,label:_.displayName||_.name}};let C;typeof k=="string"||R(k)?C=[k,...v]:(y.modal=k?.modal,y.useCustom=k?.useCustom,y.detail=k?.detail,C=v),y.useCustom&&(0,d.checkProposedApiEnabled)(_,"resolvers");const w=[];for(let s=0;s<C.length;s++){const o=C[s];if(typeof o=="string")w.push({title:o,handle:s,isCloseAffordance:!1});else if(typeof o=="object"){const{title:a,isCloseAffordance:c}=o;w.push({title:a,isCloseAffordance:!!c,handle:s})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(b,T,y,w).then(s=>{if(typeof s=="number")return C[s]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=je([$e(1,F.ILogService)],A)}),define(Ce[319],De([1,0,207,22,4,3,28,15,18,2,30,87,6,33,13,7,69,281,144,8,23,17]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class t{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(r=>r.apiEditor)}constructor(r,i,l,f,S){this._textDocumentsAndEditors=l,this._textDocuments=f,this._extHostFileSystem=S,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new d.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new d.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new d.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new d.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=r.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=r.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=r.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=i.converter,i.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const E=I.notebookEditor?.notebookUri,h=I.cell.handle,P=this._documents.get(E)?.getCell(h);if(P)return P.apiCell}if(I&&I.$mid===14){const E=I.uri,h=this._documents.get(E);if(h)return h.apiNotebook}return I}}),t._registerApiCommands(i)}getEditorById(r){const i=this._editors.get(r);if(!i)throw new Error(`unknown text editor: ${r}. known editors: ${[...this._editors.keys()]} `);return i}getIdByEditor(r){for(const[i,l]of this._editors)if(l.apiEditor===r)return i}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(r,i){const l=this._documents.get(r);if(!l&&!i)throw new Error(`NO notebook document for '${r}'`);return l}static _convertNotebookRegistrationData(r,i){if(!i)return;const l=i.filenamePattern.map(f=>C.NotebookExclusiveDocumentPattern.from(f)).filter(f=>f!==void 0);if(i.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:i.displayName,filenamePattern:l,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,i,l){const f=t._notebookStatusBarItemProviderHandlePool++,S=typeof l.onDidChangeCellStatusBarItems=="function"?t._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(f,l),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(f,S,i);let I;return S!==void 0&&(I=l.onDidChangeCellStatusBarItems(E=>this._notebookProxy.$emitCellStatusBarEvent(S))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(f),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(f,S),I?.dispose()})}async createNotebookDocument(r){const i=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:r.viewType,content:r.content&&C.NotebookData.from(r.content)});return b.URI.revive(i)}async openNotebookDocument(r){const i=this._documents.get(r);if(i)return i.apiNotebook;const l=await this._notebookDocumentsProxy.$tryOpenNotebook(r),f=this._documents.get(b.URI.revive(l));return(0,_.assertIsDefined)(f?.apiNotebook)}async showNotebookDocument(r,i){b.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let l;typeof i=="object"?l={position:C.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(C.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:l={preserveFocus:!1};const f=await this._notebookEditorsProxy.$tryShowNotebookDocument(r.uri,r.notebookType,l),S=f&&this._editors.get(f)?.apiEditor;if(S)return S;throw f?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,i,l,f){const S=this._notebookStatusBarItemProviders.get(r),I=b.URI.revive(i),E=this._documents.get(I);if(!E||!S)return;const h=E.getCellFromIndex(l);if(!h)return;const m=await S.provideCellStatusBarItems(h.apiCell,f);if(!m)return;const P=new R.DisposableStore,O=this._statusBarCache.add([P]),L=(Array.isArray(m)?m:[m]).map(U=>C.NotebookStatusBarItem.from(U,this._commandsConverter,P));return{cacheId:O,items:L}}$releaseNotebookCellStatusBarItems(r){this._statusBarCache.delete(r)}registerNotebookSerializer(r,i,l,f,S){if((0,p.isFalsyOrWhitespace)(i))throw new Error("viewType cannot be empty or just whitespace");const I=this._handlePool++;return this._notebookSerializer.set(I,{viewType:i,serializer:l,options:f}),this._notebookProxy.$registerNotebookSerializer(I,{id:r.identifier,location:r.extensionLocation},i,C.NotebookDocumentContentOptions.from(f),t._convertNotebookRegistrationData(r,S)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(I)})}async $dataToNotebook(r,i,l){const f=this._notebookSerializer.get(r);if(!f)throw new Error("NO serializer found");const S=await f.serializer.deserializeNotebook(i.buffer,l);return new s.SerializableObjectWithBuffers(C.NotebookData.from(S))}async $notebookToData(r,i,l){const f=this._notebookSerializer.get(r);if(!f)throw new Error("NO serializer found");const S=await f.serializer.serializeNotebook(C.NotebookData.to(i.value),l);return F.VSBuffer.wrap(S)}async $saveNotebook(r,i,l,f,S){const I=b.URI.revive(i),E=this._notebookSerializer.get(r);if(!E)throw new Error("NO serializer found");const h=this._documents.get(I);if(!h)throw new Error("Document NOT found");if(h.versionId!==l)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(I.scheme))throw new T.FileOperationError((0,D.localize)(0,null,this._resourceForError(I)),6);await this._validateWriteFile(I,f);const m={metadata:(0,g.filter)(h.apiNotebook.metadata,U=>!(E.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of h.apiNotebook.getCells()){const x=new w.NotebookCellData(U.kind,U.document.getText(),U.document.languageId,U.mime,E.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);x.metadata=(0,g.filter)(U.metadata,M=>!(E.options?.transientCellMetadata??{})[M]),m.cells.push(x)}const P=await E.serializer.serializeNotebook(m,S);await this._extHostFileSystem.value.writeFile(I,P);const O=this._extHostFileSystem.getFileSystemProviderExtUri(I.scheme),N=await this._extHostFileSystem.value.stat(I);return{name:O.basename(I),isFile:(N.type&T.FileType.File)!==0,isDirectory:(N.type&T.FileType.Directory)!==0,isSymbolicLink:(N.type&T.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&T.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(I.scheme),locked:!!((N.permissions??0)&T.FilePermission.Locked),etag:T.etag({mtime:N.mtime,size:N.size}),children:void 0}}async _validateWriteFile(r,i){const l=await this._extHostFileSystem.value.stat(r);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==T.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==T.etag({mtime:i.mtime,size:l.size}))throw new T.FileOperationError((0,D.localize)(1,null),3,i)}_resourceForError(r){return r.scheme===u.Schemas.file?r.fsPath:r.toString()}_createExtHostEditor(r,i,l){if(this._editors.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const f=new a.ExtHostNotebookEditor(i,this._notebookEditorsProxy,r,l.visibleRanges.map(C.NotebookRange.to),l.selections.map(C.NotebookRange.to),typeof l.viewColumn=="number"?C.ViewColumn.to(l.viewColumn):void 0);this._editors.set(i,f)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const l of r.value.removedDocuments){const f=b.URI.revive(l),S=this._documents.get(f);S&&(S.dispose(),this._documents.delete(f),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===f.toString()&&this._editors.delete(I.id)}if(r.value.addedDocuments){const l=[];for(const f of r.value.addedDocuments){const S=b.URI.revive(f.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const I=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,S,f);l.push(...f.cells.map(E=>o.ExtHostCell.asModelAddData(I.apiNotebook,E))),this._documents.get(S)?.dispose(),this._documents.set(S,I),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this._onDidOpenNotebookDocument.fire(I.apiNotebook)}}if(r.value.addedEditors)for(const l of r.value.addedEditors){if(this._editors.has(l.id))return;const f=b.URI.revive(l.documentUri),S=this._documents.get(f);S&&this._createExtHostEditor(S,l.id,l)}const i=[];if(r.value.removedEditors)for(const l of r.value.removedEditors){const f=this._editors.get(l);f&&(this._editors.delete(l),this._activeNotebookEditor?.id===f.id&&(this._activeNotebookEditor=void 0),i.push(f))}if(r.value.visibleEditors){this._visibleNotebookEditors=r.value.visibleEditors.map(f=>this._editors.get(f)).filter(f=>!!f);const l=new Set;this._visibleNotebookEditors.forEach(f=>l.add(f.id));for(const f of this._editors.values()){const S=l.has(f.id);f._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(f=>f).filter(f=>f.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this._activeNotebookEditor=void 0:r.value.newActiveEditor&&(this._editors.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(r){const i=y.ApiCommandArgument.String.with("notebookType","A notebook type"),l=new y.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new y.ApiCommandArgument("data","Bytes to convert to data",S=>S instanceof Uint8Array,S=>F.VSBuffer.wrap(S))],new y.ApiCommandResult("Notebook Data",S=>C.NotebookData.to(S.value))),f=new y.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new y.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",S=>!0,S=>new s.SerializableObjectWithBuffers(C.NotebookData.from(S)))],new y.ApiCommandResult("Bytes",S=>S.buffer));r.registerApiCommand(l),r.registerApiCommand(f)}}e.ExtHostNotebookController=t}),define(Ce[320],De([1,0,19,9,21,4,3,28,2,25,14,87,6,33,13,7,110,275,27,69]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let g=class{constructor(S,I,E,h,m){this._initData=I,this._extHostNotebook=E,this._commands=h,this._logService=m,this._activeExecutions=new p.ResourceMap,this._activeNotebookExecutions=new p.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new k.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=S.getProxy(v.MainContext.MainThreadNotebookKernels);const P=new y.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const N=this._extHostNotebook.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:N}}else if(O&&"notebookEditor"in O){const N=this._extHostNotebook.getIdByEditor(O.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return O})],y.ApiCommandResult.Void);this._commands.registerApiCommand(P)}createNotebookController(S,I,E,h,m,P){for(const ge of this._kernelData.values())if(ge.controller.id===I&&b.ExtensionIdentifier.equals(S.identifier,ge.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const O=this._handlePool++,N=this;this._logService.trace(`NotebookController[${O}], CREATED by ${S.identifier.value}, ${I}`);const L=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${S.identifier}'`);let U=!1;const x=new R.Emitter,M=new R.Emitter,H={id:l(S.identifier,I),notebookType:E,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:h||S.identifier.value,preloads:P?P.map(C.NotebookRendererScript.from):[]};let j=m??L,fe;this._proxy.$addKernel(O,H).catch(ge=>{console.log(ge),U=!0});let Y=0;const X=()=>{if(U)return;const ge=++Y;Promise.resolve().then(()=>{ge===Y&&this._proxy.$updateKernel(O,H)})},z=new p.ResourceMap,J={get id(){return I},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return H.label},set label(ge){H.label=ge??S.displayName??S.name,X()},get detail(){return H.detail??""},set detail(ge){H.detail=ge,X()},get description(){return H.description??""},set description(ge){H.description=ge,X()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ge){H.supportedLanguages=ge,X()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){H.supportsExecutionOrder=ge,X()},get rendererScripts(){return H.preloads?H.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(ge){j=ge??L},get interruptHandler(){return fe},set interruptHandler(ge){fe=ge,H.supportsInterrupt=!!ge,X()},createNotebookCellExecution(ge){if(U)throw new Error("notebook controller is DISPOSED");if(!z.has(ge.notebook.uri))throw N._logService.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return N._createNotebookCellExecution(ge,l(S.identifier,this.id))},createNotebookExecution(ge){if((0,a.checkProposedApiEnabled)(S,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!z.has(ge.uri))throw N._logService.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return N._createNotebookExecution(ge,l(S.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${O}], DISPOSED`),U=!0,this._kernelData.delete(O),x.dispose(),M.dispose(),this._proxy.$removeKernel(O))},updateNotebookAffinity(ge,le){le===w.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(S,"notebookControllerAffinityHidden"),N._proxy.$updateNotebookPriority(O,ge.uri,le)},onDidReceiveMessage:M.event,postMessage(ge,le){return(0,a.checkProposedApiEnabled)(S,"notebookMessaging"),N._proxy.$postMessage(O,le&&N._extHostNotebook.getIdByEditor(le),ge)},asWebviewUri(ge){return(0,a.checkProposedApiEnabled)(S,"notebookMessaging"),(0,s.asWebviewUri)(ge,N._initData.remote)}};return this._kernelData.set(O,{extensionId:S.identifier,controller:J,onDidReceiveMessage:M,onDidChangeSelection:x,associatedNotebooks:z}),J}getIdByController(S){for(const[I,E]of this._kernelData)if(E.controller===S)return l(E.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,I){const E=this._kernelDetectionTaskHandlePool++,h=this;this._logService.trace(`NotebookControllerDetectionTask[${E}], CREATED by ${S.identifier.value}`),this._proxy.$addKernelDetectionTask(E,I);const m={dispose:()=>{this._kernelDetectionTask.delete(E),h._proxy.$removeKernelDetectionTask(E)}};return this._kernelDetectionTask.set(E,m),m}registerKernelSourceActionProvider(S,I,E){const h=this._kernelSourceActionProviderHandlePool++,m=typeof E.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,P=this;this._kernelSourceActionProviders.set(h,E),this._logService.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${S.identifier.value}`),this._proxy.$addKernelSourceActionProvider(h,h,I);let O;return m!==void 0&&(O=E.onDidChangeNotebookKernelSourceActions(N=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this._kernelSourceActionProviders.delete(h),P._proxy.$removeKernelSourceActionProvider(h,h),O?.dispose()}}}async $provideKernelSourceActions(S,I){const E=this._kernelSourceActionProviders.get(S);if(E){const h=new A.DisposableStore;return this._kernelSourceActionProviderCache.add([h]),(await E.provideNotebookKernelSourceActions(I)??[]).map(P=>C.NotebookKernelSourceAction.from(P,this._commands.converter,h))}return[]}$acceptNotebookAssociation(S,I,E){const h=this._kernelData.get(S);if(h){const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(I));E?h.associatedNotebooks.set(m.uri,!0):h.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${S}] ASSOCIATE notebook`,m.uri.toString(),E),h.onDidChangeSelection.fire({selected:E,notebook:m.apiNotebook})}}async $executeCells(S,I,E){const h=this._kernelData.get(S);if(!h)return;const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(I)),P=[];for(const O of E){const N=m.getCell(O);N&&P.push(N.apiCell)}try{this._logService.trace(`NotebookController[${S}] EXECUTE cells`,m.uri.toString(),P.length),await h.controller.executeHandler.call(h.controller,P,m.apiNotebook,h.controller)}catch(O){this._logService.error(`NotebookController[${S}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(S,I,E){const h=this._kernelData.get(S);if(!h)return;const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(I));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,m.apiNotebook);else for(const P of E){const O=m.getCell(P);O&&this._activeExecutions.get(O.uri)?.cancel()}if(h.controller.interruptHandler){const P=this._activeNotebookExecutions.get(m.uri);E.length&&Array.isArray(P)&&P.length&&P.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(S,I,E){const h=this._kernelData.get(S);if(!h)return;const m=this._extHostNotebook.getEditorById(I);h.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:E}))}$cellExecutionChanged(S,I,E){const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(S)).getCell(I);if(m){const P=E?C.NotebookCellExecutionState.to(E):w.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:P})}}_createNotebookCellExecution(S,I){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this._extHostNotebook.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!h)throw new Error("invalid cell");if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const m=new t(I,h,this._proxy);this._activeExecutions.set(h.uri,m);const P=m.onDidChangeState(()=>{m.state===u.Resolved&&(m.dispose(),P.dispose(),this._activeExecutions.delete(h.uri))});return m.asApiObject()}_createNotebookExecution(S,I){const E=this._extHostNotebook.getNotebookDocument(S.uri),h=S.getCells().find(O=>{const N=E.getCellFromApiCell(O);return N&&this._activeExecutions.has(N.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this._activeNotebookExecutions.has(E.uri))throw new Error(`duplicate notebook execution for ${E.uri}`);const m=new r(I,E,this._proxy),P=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),P.dispose(),this._activeNotebookExecutions.delete(E.uri))});return this._activeNotebookExecutions.set(E.uri,[m,P]),m.asApiObject()}};e.ExtHostNotebookKernels=g,e.ExtHostNotebookKernels=g=je([$e(4,T.ILogService)],g);var u;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(u||(u={}));class t extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(S,I,E){super(),this._cell=I,this._proxy=E,this._handle=t.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=I.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,S,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(S){await this._collector.addItem(S)}async update(S){const I=Array.isArray(S)?S:[S];return this._proxy.$updateExecution(this._handle,new c.SerializableObjectWithBuffers(I))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(S){let I=this._cell;if(S&&(I=this._cell.notebook.getCellFromApiCell(S)),!I)throw new Error("INVALID cell");return I.handle}validateAndConvertOutputs(S){return S.map(I=>{const E=w.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return E===I.items?C.NotebookCellOutput.from(I):C.NotebookCellOutput.from({items:E,id:I.id,metadata:I.metadata})})}async updateOutputs(S,I,E){const h=this.cellIndexToHandle(I),m=this.validateAndConvertOutputs((0,D.asArray)(S));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:h,append:E,outputs:m})}async updateOutputItems(S,I,E){return S=w.NotebookCellOutput.ensureUniqueMimeTypes((0,D.asArray)(S),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:S.map(C.NotebookCellOutputItem.from),outputId:I.id,append:E})}asApiObject(){const S=this;return Object.freeze({get token(){return S._tokenSource.token},get cell(){return S._cell.apiCell},get executionOrder(){return S._executionOrder},set executionOrder(E){S._executionOrder=E,S.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:S._executionOrder}])},start(E){if(S._state===u.Resolved||S._state===u.Started)throw new Error("Cannot call start again");S._state=u.Started,S._onDidChangeState.fire(),S.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:E})},end(E,h){if(S._state===u.Resolved)throw new Error("Cannot call resolve twice");S._state=u.Resolved,S._onDidChangeState.fire(),S._collector.flush(),S._proxy.$completeExecution(S._handle,new c.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:E}))},clearOutput(E){return S.verifyStateForOutput(),S.updateOutputs([],E,!1)},appendOutput(E,h){return S.verifyStateForOutput(),S.updateOutputs(E,h,!0)},replaceOutput(E,h){return S.verifyStateForOutput(),S.updateOutputs(E,h,!1)},appendOutputItems(E,h){return S.verifyStateForOutput(),S.updateOutputItems(E,h,!0)},replaceOutputItems(E,h){return S.verifyStateForOutput(),S.updateOutputItems(E,h,!1)}})}}var n;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(n||(n={}));class r extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(S,I,E){super(),this._notebook=I,this._proxy=E,this._handle=r.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=n.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,S,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===n.Resolved||this._state===n.Started)throw new Error("Cannot call start again");this._state=n.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===n.Resolved)throw new Error("Cannot call resolve twice");this._state=n.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class i{constructor(S,I){this.delay=S,this.callback=I,this.batch=[],this.startedTimer=Date.now()}addItem(S){return this.batch.push(S),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const S=this.currentDeferred;this.currentDeferred=void 0;const I=this.batch;return this.batch=[],this.callback(I).finally(()=>S.complete())}}function l(f,S){return`${f.value}/${S}`}e.createKernelId=l}),define(Ce[321],De([1,0,4,6,144]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(p,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=p.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(p,_,b){const T=this._extHostNotebook.getEditorById(p);this._rendererMessageEmitters.get(_)?.fire({editor:T.apiEditor,message:b})}createRendererMessaging(p,_){if(!p.contributes?.notebookRenderer?.some(T=>T.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);return{onDidReceiveMessage:(T,k,v)=>this.getOrCreateEmitterFor(_).event(T,k,v),postMessage:(T,k)=>{d.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const v=k&&d.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(v?.id,_,T)}}}getOrCreateEmitterFor(p){let _=this._rendererMessageEmitters.get(p);return _||(_=new D.Emitter({onDidRemoveLastListener:()=>{_?.dispose(),this._rendererMessageEmitters.delete(p)}}),this._rendererMessageEmitters.set(p,_),_)}}e.ExtHostNotebookRenderers=R}),define(Ce[322],De([1,0,3,18,2,27,6]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class p{constructor(b){this.handlers=new Map,this.proxy=b.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,T,k){if((0,R.checkProposedApiEnabled)(b,"profileContentHandlers"),this.handlers.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.handlers.set(T,k),this.proxy.$registerProfileContentHandler(T,k.name,k.description,b.identifier.value),(0,D.toDisposable)(()=>{this.handlers.delete(T),this.proxy.$unregisterProfileContentHandler(T)})}async $saveProfile(b,T,k,v){const y=this.handlers.get(b);if(!y)throw new Error(`Unknown handler with id: ${b}`);return y.saveProfile(T,k,v)}async $readProfile(b,T,k){const v=this.handlers.get(b);if(!v)throw new Error(`Unknown handler with id: ${b}`);return v.readProfile((0,F.isString)(T)?T:d.URI.revive(T),k)}}e.ExtHostProfileContentHandlers=p}),define(Ce[323],De([1,0,2,6,9,13]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(_,b){this.uriTransformer=b,this.providers=new Map,this.proxy=_.getProxy(F.MainContext.MainThreadQuickDiff)}$provideOriginalResource(_,b,T){const k=D.URI.revive(b),v=this.providers.get(_);return v?(0,d.asPromise)(()=>v.provideOriginalResource(k,T)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(_,b,T,k){const v=A.handlePool++;return this.providers.set(v,b),this.proxy.$registerQuickDiffProvider(v,R.DocumentSelector.from(_,this.uriTransformer),T,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(v),this.providers.delete(v)}}}}e.ExtHostQuickDiff=A}),define(Ce[324],De([1,0,21,4,3,6,2,7,8,19,38,59,27,13]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(w,s,o){const a=w.getProxy(R.MainContext.MainThreadQuickOpen);class c{constructor(S,I){this._sessions=new Map,this._instances=0,this._workspace=S,this._commands=I}showQuickPick(S,I,E,h=D.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(I),P=++this._instances,O=a.$show(P,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},h),N={},L=O.then(()=>N);return Promise.race([L,m]).then(U=>{if(U===N)return;const x=(0,v.isProposedApiEnabled)(S,"quickPickItemTooltip");return m.then(M=>{const H=[];for(let j=0;j<M.length;j++){const fe=M[j];if(typeof fe=="string")H.push({label:fe,handle:j});else if(fe.kind===p.QuickPickItemKind.Separator)H.push({type:"separator",label:fe.label});else{fe.tooltip&&!x&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const Y=fe.iconPath?r(fe.iconPath):void 0;H.push({label:fe.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:x?y.MarkdownString.fromStrict(fe.tooltip):void 0,handle:j})}}return E&&typeof E.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{E.onDidSelectItem(M[j])}),a.$setItems(P,H),O.then(j=>{if(typeof j=="number")return M[j];if(Array.isArray(j))return j.map(fe=>M[fe])})})}).then(void 0,U=>{if(!(0,_.isCancellationError)(U))return a.$setError(P,U),Promise.reject(U)})}$onItemSelected(S){this._onDidSelectItem?.(S)}showInput(S,I=D.CancellationToken.None){return this._validateInput=S?.validateInput,a.$input(S,typeof this._validateInput=="function",I).then(void 0,E=>{if(!(0,_.isCancellationError)(E))return Promise.reject(E)})}async $validateInput(S){if(!this._validateInput)return;const I=await this._validateInput(S);if(!I||typeof I=="string")return I;let E;switch(I.severity){case p.InputBoxValidationSeverity.Info:E=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:E=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:E=T.default.Error;break;default:E=I.message?T.default.Error:T.default.Ignore;break}return{content:I.message,severity:E}}async showWorkspaceFolderPick(S,I=D.CancellationToken.None){const E=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!E)return;const h=await this._workspace.getWorkspaceFolders2();if(h)return h.find(m=>m.uri.toString()===E.uri.toString())}createQuickPick(S){const I=new i(S,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}createInputBox(S){const I=new l(S,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}$onDidChangeValue(S,I){this._sessions.get(S)?._fireDidChangeValue(I)}$onDidAccept(S){this._sessions.get(S)?._fireDidAccept()}$onDidChangeActive(S,I){const E=this._sessions.get(S);E instanceof i&&E._fireDidChangeActive(I)}$onDidChangeSelection(S,I){const E=this._sessions.get(S);E instanceof i&&E._fireDidChangeSelection(I)}$onDidTriggerButton(S,I){this._sessions.get(S)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(S,I,E){const h=this._sessions.get(S);h instanceof i&&h._fireDidTriggerItemButton(I,E)}$onDidHide(S){this._sessions.get(S)?._fireDidHide()}}class g{static{this._nextId=1}constructor(S,I){this._extensionId=S,this._onDidDispose=I,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new F.Emitter,this._onDidChangeValueEmitter=new F.Emitter,this._onDidTriggerButtonEmitter=new F.Emitter,this._onDidHideEmitter=new F.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(S){this._title=S,this.update({title:S})}get step(){return this._steps}set step(S){this._steps=S,this.update({step:S})}get totalSteps(){return this._totalSteps}set totalSteps(S){this._totalSteps=S,this.update({totalSteps:S})}get enabled(){return this._enabled}set enabled(S){this._enabled=S,this.update({enabled:S})}get busy(){return this._busy}set busy(S){this._busy=S,this.update({busy:S})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(S){this._ignoreFocusOut=S,this.update({ignoreFocusOut:S})}get value(){return this._value}set value(S){this._value=S,this.update({value:S})}get placeholder(){return this._placeholder}set placeholder(S){this._placeholder=S,this.update({placeholder:S})}get buttons(){return this._buttons}set buttons(S){this._buttons=S.slice(),this._handlesToButtons.clear(),S.forEach((I,E)=>{const h=I===p.QuickInputButtons.Back?-1:E;this._handlesToButtons.set(h,I)}),this.update({buttons:S.map((I,E)=>({...r(I.iconPath),tooltip:I.tooltip,handle:I===p.QuickInputButtons.Back?-1:E}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(S){this._value=S,this._onDidChangeValueEmitter.fire(S)}_fireDidTriggerButton(S){const I=this._handlesToButtons.get(S);I&&this._onDidTriggerButtonEmitter.fire(I)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,d.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),a.$dispose(this._id))}update(S){if(!this._disposed){for(const I of Object.keys(S)){const E=S[I];this._pendingUpdate[I]=E===void 0?null:E}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){a.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function u(f){if(f instanceof p.ThemeIcon)return{id:f.id};const S=n(f),I=t(f);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof I=="string"?A.URI.file(I):I}}function t(f){return typeof f=="object"&&"light"in f?f.light:f}function n(f){return typeof f=="object"&&"dark"in f?f.dark:f}function r(f){const S=u(f);let I,E;return"id"in S?E=k.ThemeIcon.asClassName(S):I=S,{iconPath:I,iconClass:E}}class i extends g{constructor(S,I){super(S.identifier,I),this.extension=S,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new F.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new F.Emitter,this._onDidTriggerItemButtonEmitter=new F.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(S){this._items=S.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),S.forEach((h,m)=>{this._handlesToItems.set(m,h),this._itemsToHandles.set(h,m)});const I=(0,v.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),E=[];for(let h=0;h<S.length;h++){const m=S[h];if(m.kind===p.QuickPickItemKind.Separator)E.push({type:"separator",label:m.label});else{m.tooltip&&!I&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=m.iconPath?r(m.iconPath):void 0;E.push({handle:h,label:m.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:I?y.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((O,N)=>({...r(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.update({items:E})}get canSelectMany(){return this._canSelectMany}set canSelectMany(S){this._canSelectMany=S,this.update({canSelectMany:S})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(S){this._matchOnDescription=S,this.update({matchOnDescription:S})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(S){this._matchOnDetail=S,this.update({matchOnDetail:S})}get sortByLabel(){return this._sortByLabel}set sortByLabel(S){this._sortByLabel=S,this.update({sortByLabel:S})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(S){this._keepScrollPosition=S,this.update({keepScrollPosition:S})}get activeItems(){return this._activeItems}set activeItems(S){this._activeItems=S.filter(I=>this._itemsToHandles.has(I)),this.update({activeItems:this._activeItems.map(I=>this._itemsToHandles.get(I))})}get selectedItems(){return this._selectedItems}set selectedItems(S){this._selectedItems=S.filter(I=>this._itemsToHandles.has(I)),this.update({selectedItems:this._selectedItems.map(I=>this._itemsToHandles.get(I))})}_fireDidChangeActive(S){const I=(0,b.coalesce)(S.map(E=>this._handlesToItems.get(E)));this._activeItems=I,this._onDidChangeActiveEmitter.fire(I)}_fireDidChangeSelection(S){const I=(0,b.coalesce)(S.map(E=>this._handlesToItems.get(E)));this._selectedItems=I,this._onDidChangeSelectionEmitter.fire(I)}_fireDidTriggerItemButton(S,I){const E=this._handlesToItems.get(S);if(!E||!E.buttons||!E.buttons.length)return;const h=E.buttons[I];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:E})}}class l extends g{constructor(S,I){super(S.identifier,I),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(S){this._password=S,this.update({password:S})}get prompt(){return this._prompt}set prompt(S){this._prompt=S,this.update({prompt:S})}get valueSelection(){return this._valueSelection}set valueSelection(S){this._valueSelection=S,this.update({valueSelection:S})}get validationMessage(){return this._validationMessage}set validationMessage(S){this._validationMessage=S,S?typeof S=="string"?this.update({validationMessage:S,severity:T.default.Error}):this.update({validationMessage:S.message,severity:S.severity??T.default.Error}):this.update({validationMessage:void 0,severity:T.default.Ignore})}}return new c(s,o)}e.createExtHostQuickOpen=C}),define(Ce[325],De([1,0,2,4,56,3,9,6,19,126,14,25,59,13,27,17]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(h){if(h)return typeof h.iconPath=="string"?D.URI.file(h.iconPath):D.URI.isUri(h.iconPath)||v.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function a(h){if(h.icon){if(D.URI.isUri(h.icon))return h.icon;if(v.ThemeIcon.isThemeIcon(h.icon))return h.icon;{const m=h.icon;return{light:m.light,dark:m.dark}}}else return}function c(h,m){if(!h.iconPath&&!m.iconPath)return 0;if(h.iconPath){if(!m.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:D.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,O=typeof m.iconPath=="string"?m.iconPath:D.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,b.comparePaths)(P,O)}function g(h,m){let P=0;if(h.strikeThrough!==m.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==m.faded)return h.faded?1:-1;if(h.tooltip!==m.tooltip)return(h.tooltip||"").localeCompare(m.tooltip||"");if(P=c(h,m),P!==0)return P;if(h.light&&m.light)P=c(h.light,m.light);else{if(h.light)return 1;if(m.light)return-1}if(P!==0)return P;if(h.dark&&m.dark)P=c(h.dark,m.dark);else{if(h.dark)return 1;if(m.dark)return-1}return P}function u(h,m){if(h.command!==m.command)return h.command<m.command?-1:1;if(h.title!==m.title)return h.title<m.title?-1:1;if(h.tooltip!==m.tooltip){if(h.tooltip!==void 0&&m.tooltip!==void 0)return h.tooltip<m.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(h.arguments===m.arguments)return 0;if(h.arguments)if(m.arguments){if(h.arguments.length!==m.arguments.length)return h.arguments.length-m.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const O=h.arguments[P],N=m.arguments[P];if(O!==N)return O<N?-1:1}return 0}function t(h,m){let P=(0,b.comparePaths)(h.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&m.command)P=u(h.command,m.command);else{if(h.command)return 1;if(m.command)return-1}if(P!==0)return P;if(h.decorations&&m.decorations)P=g(h.decorations,m.decorations);else{if(h.decorations)return 1;if(m.decorations)return-1}return P}function n(h,m){for(let P=0;P<h.length;P++)if(h[P]!==m[P])return!1;return!0}function r(h,m){return h.command===m.command&&h.title===m.title&&h.tooltip===m.tooltip&&(h.arguments&&m.arguments?n(h.arguments,m.arguments):h.arguments===m.arguments)}function i(h,m){return(0,_.equals)(h,m,r)}function l(h,m){return h===m?!0:!h||!m?!1:h.id===m.id&&h.label===m.label&&h.upstream?.id===m.upstream?.id&&h.upstream?.label===m.upstream?.label}class f{#e;#t;get value(){return this._value}set value(m){m=m??"",this.#e.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get enabled(){return this._enabled}set enabled(m){m=!!m,this._enabled!==m&&(this._enabled=m,this.#e.$setInputBoxEnablement(this._sourceControlHandle,m))}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this.#e.$setInputBoxVisibility(this._sourceControlHandle,m))}get document(){return(0,C.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(m,P,O,N,L){this._extension=m,this._sourceControlHandle=N,this._documentUri=L,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=P,this.#e=O}showValidationMessage(m,P){(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,m,P)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=f;class S{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}constructor(m,P,O,N,L){this._proxy=m,this._commands=P,this._sourceControlHandle=O,this._id=N,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=S._handlePool++}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,P){const O=this._resourceStatesCommandsMap.get(m);return O?(0,A.asPromise)(()=>this._commands.executeCommand(O.command,...O.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(t),O=(0,_.sortedDiff)(this._resourceSnapshot,m,t).map(U=>{const x=U.toInsert.map(M=>{const H=this._resourceHandlePool++;this._resourceStatesMap.set(H,M);const j=M.resourceUri;let fe;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const V=new R.DisposableStore;fe=this._commands.converter.toInternal(M.command,V),this._resourceStatesDisposablesMap.set(H,V)}else this._resourceStatesCommandsMap.set(H,M.command);const Y=o(M.decorations),X=M.decorations&&o(M.decorations.light)||Y,z=M.decorations&&o(M.decorations.dark)||Y,J=[X,z],ge=M.decorations&&M.decorations.tooltip||"",le=M.decorations&&!!M.decorations.strikeThrough,we=M.decorations&&!!M.decorations.faded,G=M.contextValue||"";return{rawResource:[H,j,J,ge,le,we,G,fe],handle:H}});return{start:U.start,deleteCount:U.deleteCount,toInsert:x}}),N=O.map(({start:U,deleteCount:x,toInsert:M})=>[U,x,M.map(H=>H.rawResource)]),L=O.reverse();for(const{start:U,deleteCount:x,toInsert:M}of L){const H=M.map(fe=>fe.handle),j=this._handlesSnapshot.splice(U,x,...H);for(const fe of j)this._resourceStatesMap.delete(fe),this._resourceStatesCommandsMap.delete(fe),this._resourceStatesDisposablesMap.get(fe)?.dispose(),this._resourceStatesDisposablesMap.delete(fe)}return this._resourceSnapshot=m,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class I{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this.#e.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m;let P;(0,C.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(P=m?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m,quickDiffLabel:P})}get historyProvider(){return(0,C.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(m){(0,C.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=m,this._historyProviderDisposable.value=new R.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!m}),m&&(this._historyProviderDisposable.value.add(m.onDidChangeCurrentHistoryItemGroup(()=>{l(this._historyProviderCurrentHistoryItemGroup,m?.currentHistoryItemGroup)||(this._historyProviderCurrentHistoryItemGroup=m?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))})),this._historyProviderDisposable.value.add(m.onDidChangeActionButton(()=>{(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new R.DisposableStore;const P=m.actionButton!==void 0?{command:this._commands.converter.toInternal(m.actionButton.command,this._historyProviderActionButtonDisposable.value),description:m.actionButton.description,enabled:m.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,P??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this.#e.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=m;const P=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=m;const P=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),secondaryCommands:m.secondaryCommands?.map(O=>O.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:m.description,enabled:m.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=m;const P=(m||[]).map(O=>this._commands.converter.toInternal(O,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}constructor(m,P,O,N,L,U,x){this._extension=m,this._commands=N,this._id=L,this._label=U,this._rootUri=x,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new R.MutableDisposable,this._historyProviderActionButtonDisposable=new R.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new R.MutableDisposable,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=I._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=O;const M=D.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${L}/scm${this.handle}/input`,query:x?`rootUri=${encodeURIComponent(x.toString())}`:void 0});this._inputBox=new f(m,P,this.#e,this.handle,M),this.#e.$registerSourceControl(this.handle,L,U,x,M)}createResourceGroup(m,P){const O=new S(this.#e,this._commands,this.handle,m,P),N=F.Event.once(O.onDidDispose)(()=>this.createdResourceGroups.delete(O));return this.createdResourceGroups.set(O,N),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const m=[],P=[];for(const[O,N]of this.createdResourceGroups){N.dispose();const L=O.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(O),this.eventuallyUpdateResourceStates()});F.Event.once(O.onDidDispose)(()=>{this.updatedResourceGroups.delete(O),L.dispose(),this._groups.delete(O.handle),this.#e.$unregisterGroup(this.handle,O.handle)}),m.push([O.handle,O.id,O.label,O.features]);const U=O._takeResourceStateSnapshot();U.length>0&&P.push([O.handle,U]),this._groups.set(O.handle,O)}this.#e.$registerGroups(this.handle,m,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(P=>{const O=P._takeResourceStateSnapshot();O.length!==0&&m.push([P.handle,O])}),m.length>0&&this.#e.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this.#e.$unregisterSourceControl(this.handle)}}je([(0,d.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),je([(0,d.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{s=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(m,P,O,N){this._commands=P,this._extHostDocuments=O,this.logService=N,this._sourceControls=new Map,this._sourceControlsByExtension=new k.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=m.getProxy(p.MainContext.MainThreadSCM),this._telemetry=m.getProxy(p.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const U=this._sourceControls.get(L.sourceControlHandle);if(!U)return L;const x=U.getResourceGroup(L.groupHandle);return x?x.getResourceState(L.handle):L}else if(L&&L.$mid===4){const U=this._sourceControls.get(L.sourceControlHandle);return U?U.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const U=this._sourceControls.get(L.handle);return U||L}return L}})}createSourceControl(m,P,O,N){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,P,O,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const L=s._handlePool++,U=new I(m,this._extHostDocuments,this._proxy,this._commands,P,O,N);this._sourceControls.set(L,U);const x=this._sourceControlsByExtension.get(m.identifier)||[];return x.push(U),this._sourceControlsByExtension.set(m.identifier,x),U}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const P=this._sourceControlsByExtension.get(m.identifier),O=P&&P[P.length-1];return O&&O.inputBox}$provideOriginalResource(m,P,O){const N=D.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,N.toString());const L=this._sourceControls.get(m);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(N,O)).then(U=>U||null)}$onInputBoxValueChange(m,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const O=this._sourceControls.get(m);return O&&O.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(m,P,O,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,P,O);const L=this._sourceControls.get(m);if(!L)return Promise.resolve(void 0);const U=L.getResourceGroup(P);return U?U.$executeResourceCommand(O,N):Promise.resolve(void 0)}$validateInput(m,P,O){this.logService.trace("ExtHostSCM#$validateInput",m);const N=this._sourceControls.get(m);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>N.inputBox.validateInput(P,O)).then(L=>{if(!L)return Promise.resolve(void 0);const U=y.MarkdownString.fromStrict(L.message);return U?Promise.resolve([U,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(m,P,O){return await this._sourceControls.get(m)?.historyProvider?.resolveHistoryItemGroupBase(P,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(m,P,O,N){return await this._sourceControls.get(m)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,O,N)??void 0}async $provideHistoryItems(m,P,O,N){return(await this._sourceControls.get(m)?.historyProvider?.provideHistoryItems(P,O,N))?.map(x=>({id:x.id,parentIds:x.parentIds,label:x.label,description:x.description,icon:a(x),timestamp:x.timestamp}))??void 0}async $provideHistoryItemChanges(m,P,O){return await this._sourceControls.get(m)?.historyProvider?.provideHistoryItemChanges(P,O)??void 0}};e.ExtHostSCM=E,e.ExtHostSCM=E=s=je([$e(3,T.ILogService)],E)}),define(Ce[114],De([1,0,6,4,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(p){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=p.getProxy(D.MainContext.MainThreadSecretState)}async $onDidChangePassword(p){this._onDidChangePassword.fire(p)}get(p,_){return this._proxy.$getPassword(p,_)}store(p,_,b){return this._proxy.$setPassword(p,_,b)}delete(p,_){return this._proxy.$deletePassword(p,_)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,d.createDecorator)("IExtHostSecretState")}),define(Ce[326],De([1,0,6,13,2]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class R{static{this.handlePool=0}constructor(p,_){this.uriTransformer=_,this.providers=new Map,this.proxy=p.getProxy(D.MainContext.MainThreadShare)}async $provideShare(p,_,b){return await this.providers.get(p)?.provideShare({selection:F.Range.to(_.selection),resourceUri:d.URI.revive(_.resourceUri)},b)??void 0}registerShareProvider(p,_){const b=R.handlePool++;return this.providers.set(b,_),this.proxy.$registerShareProvider(b,F.DocumentSelector.from(p,this.uriTransformer),_.id,_.label,_.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(b),this.providers.delete(b)}}}}e.ExtHostShare=R}),define(Ce[327],De([1,0,7,6,209,3,13,18]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class _{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new D.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(v,y,C,w,s,o=D.StatusBarAlignment.Left,a){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new R.DisposableStore,this.#e=v,this.#t=y,s&&w){this._entryId=(0,D.asStatusBarItemIdentifier)(w.identifier,s);const c=C.get(this._entryId);c&&(o=c.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,a=c.priority,this._visible=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this._entryId=String(_.ID_GEN++);this._extension=w,this._id=s,this._alignment=o,this._priority=this.validatePriority(a)}validatePriority(v){if((0,p.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!_.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new R.DisposableStore,typeof v=="string"?this._command={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this._latestCommandRegistration)}:v?this._command={fromApi:v,internal:this.#t.toInternal(v,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let y;this._name?y=this._name:y=(0,d.localize)(0,null,this._extension.displayName||this._extension.name);let C=this._color;this._backgroundColor&&(C=_.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,v,this._extension?.identifier.value,y,this._text,w,this._command?.internal,C,this._backgroundColor,this._alignment===D.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=_;class b{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,d.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const y={message:v};return this._messages.unshift(y),this._update(),new D.Disposable(()=>{const C=this._messages.indexOf(y);C>=0&&(this._messages.splice(C,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(v,y){this._existingItems=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadStatusBar),this._commands=y,this._statusMessage=new b(this)}$acceptStaticEntries(v){for(const y of v)this._existingItems.set(y.entryId,y)}createStatusBarEntry(v,y,C,w){return new _(this._proxy,this._commands,this._existingItems,v,y,C,w)}setStatusBarMessage(v,y){const C=this._statusMessage.setMessage(v);let w;return typeof y=="number"?w=setTimeout(()=>C.dispose(),y):typeof y<"u"&&y.then(()=>C.dispose(),()=>C.dispose()),new D.Disposable(()=>{C.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=T}),define(Ce[115],De([1,0,6,4,5]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(p,_){this._logService=_,this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=p.getProxy(D.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(p,_){this._proxy.$registerExtensionStorageKeysToSync(p,_)}async initializeExtensionStorage(p,_,b){const T=await this._proxy.$initializeExtensionStorage(p,_);let k;return T&&(k=this.safeParseValue(p,_,T)),k||b}setValue(p,_,b){return this._proxy.$setValue(p,_,b)}$acceptValue(p,_,b){const T=this.safeParseValue(p,_,b);T&&this._onDidChangeStorage.fire({shared:p,key:_,value:T})}safeParseValue(p,_,b){try{return JSON.parse(b)}catch(T){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${_}, global: ${p}): ${T}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,d.createDecorator)("IExtHostStorage")}),define(Ce[91],De([1,0,5,26,14,72,2]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,D.createDecorator)("IExtensionStoragePaths");let p=class{constructor(b,T,k){this._logService=T,this._extHostFileSystem=k,this._workspace=b.workspace??void 0,this._environment=b.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(v=>this._value=v)}async _getWorkspaceStorageURI(b){return A.URI.joinPath(this._environment.workspaceStorageHome,b)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const b=this._workspace.id,T=await this._getWorkspaceStorageURI(b);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(b){if(this._value)return A.URI.joinPath(this._value,b.identifier.value)}globalValue(b){return A.URI.joinPath(this._environment.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=p,e.ExtensionStoragePaths=p=je([$e(0,F.IExtHostInitDataService),$e(1,d.ILogService),$e(2,R.IExtHostConsumerFileSystem)],p)}),define(Ce[44],De([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,13,33]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,d.createDecorator)("IExtHostTerminalService");class c{constructor(E,h,m,P){this._proxy=E,this._id=h,this._creationOptions=m,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(N=>this._pidPromiseComplete=N);const O=this;this.value={get name(){return O._name||""},get processId(){return O._pidPromise},get creationOptions(){return O._creationOptions},get exitStatus(){return O._exitStatus},get state(){return O._state},get selection(){return O._selection},sendText(N,L=!0){O._checkDisposed(),O._proxy.$sendText(O._id,N,L)},show(N){O._checkDisposed(),O._proxy.$show(O._id,N)},hide(){O._checkDisposed(),O._proxy.$hide(O._id)},dispose(){O._disposed||(O._disposed=!0,O._proxy.$dispose(O._id))},get dimensions(){if(!(O._cols===void 0||O._rows===void 0))return{columns:O._cols,rows:O._rows}}}}async create(E,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:E.name,shellPath:E.shellPath??void 0,shellArgs:E.shellArgs??void 0,cwd:E.cwd??void 0,env:E.env??void 0,icon:l(E.iconPath)??void 0,color:w.ThemeColor.isThemeColor(E.color)?E.color.id:void 0,initialText:E.message??void 0,strictEnv:E.strictEnv??void 0,hideFromUser:E.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this._serializeParentTerminal(E.location,h?.resolvedExtHostIdentifier),isTransient:E.isTransient??void 0})}async createExtensionTerminal(E,h,m,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(E,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(E,h){return typeof E=="object"?"parentTerminal"in E&&E.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in E?{viewColumn:o.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus}:void 0:E}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(E){this._name=E}setExitStatus(E,h){this._exitStatus=Object.freeze({code:E,reason:h})}setDimensions(E,h){return E===this._cols&&h===this._rows||E===0||h===0?!1:(this._cols=E,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(E){this._selection=E}_setProcessId(E){this._pidPromiseComplete?(this._pidPromiseComplete(E),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==E&&(this._pidPromise=Promise.resolve(E))})}}e.ExtHostTerminal=c;class g{get onProcessReady(){return this._onProcessReady.event}constructor(E){this._pty=E,this.id=0,this.shouldPersist=!1,this._onProcessData=new D.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new D.Emitter,this._onDidChangeProperty=new D.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new D.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(E){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${E}`)}updateProperty(E,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${E}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(E){this._pty.handleInput?.(E)}resize(E,h){this._pty.setDimensions?.({columns:E,rows:h})}clearBuffer(){}async processBinary(E){}acknowledgeDataEvent(E){}async setUnicodeVersion(E){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(E){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(E||void 0),E&&this._pty.setDimensions?.(E),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends p.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(E=>E.value)}constructor(E,h,m){super(),this._extHostCommands=h,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new p.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new D.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new D.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new D.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new D.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new D.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new D.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new D.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new D.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=m.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new C.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(E),this._extHostCommands.registerArgumentProcessor({processArgument:P=>{const O=N=>{const L=N;return this._getTerminalById(L.instanceId)?.value};switch(P?.$mid){case 15:return O(P);default:{if(Array.isArray(P))for(let N=0;N<P.length&&P[N].$mid===15;N++)P[N]=O(P[N]);return P}}}}),this._register({dispose:()=>{for(const[P,O]of this._terminalProcesses)O.shutdown(!0)}})}getDefaultShell(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(E,h){const m=new c(this._proxy,(0,y.generateUuid)(),E,E.name),P=new g(E.pty);return m.createExtensionTerminal(E.location,this._serializeParentTerminal(E,h).resolvedExtHostIdentifier,l(E.iconPath),f(E.color)).then(O=>{const N=this._setupExtHostProcessListeners(O,P);this._terminalProcessDisposables[O]=N}),this._terminals.push(m),m.value}_serializeParentTerminal(E,h){if(h=h||{},E.location&&typeof E.location=="object"&&"parentTerminal"in E.location){const m=E.location.parentTerminal;if(m){const P=this._terminals.find(O=>O.value===m);P&&(h.resolvedExtHostIdentifier=P._id)}}else E.location&&typeof E.location!="object"?h.location=E.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(E,h){if(!this._getTerminalById(E))throw new Error(`Cannot resolve terminal with id ${E} for virtual process`);const P=new g(h),O=this._setupExtHostProcessListeners(E,P);this._terminalProcessDisposables[E]=O}async $acceptActiveTerminalChanged(E){const h=this._activeTerminal;if(E===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(E);m&&(this._activeTerminal=m,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(E,h){const m=this._getTerminalById(E);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:h})}async $acceptTerminalDimensions(E,h,m){const P=this._getTerminalById(E);P&&P.setDimensions(h,m)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(E,h){const m=this._getTerminalById(E);m&&this._onDidExecuteCommand.fire({terminal:m.value,...h})}async $acceptTerminalMaximumDimensions(E,h,m){this._terminalProcesses.get(E)?.resize(h,m)}async $acceptTerminalTitleChange(E,h){const m=this._getTerminalById(E);m&&(m.name=h)}async $acceptTerminalClosed(E,h,m){const P=this._getTerminalObjectIndexById(this._terminals,E);if(P!==null){const O=this._terminals.splice(P,1)[0];O.setExitStatus(h,m),this._onDidCloseTerminal.fire(O.value)}}$acceptTerminalOpened(E,h,m,P){if(h){const L=this._getTerminalObjectIndexById(this._terminals,h);if(L!==null){this._terminals[L]._id=E,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const O={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},N=new c(this._proxy,E,O,m);this._terminals.push(N),this._onDidOpenTerminal.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(E,h){this._getTerminalById(E)?._setProcessId(h)}async $startExtensionTerminal(E,h){const m=this._getTerminalById(E);if(!m)return{message:(0,b.localize)(0,null,E)};m.isOpen||await new Promise(O=>{const N=this.onDidOpenTerminal(async L=>{L===m.value&&(N.dispose(),O())})});const P=this._terminalProcesses.get(E);P?P.startSendingEvents(h):this._extensionTerminalAwaitingStart[E]={initialDimensions:h}}_setupExtHostProcessListeners(E,h){const m=new p.DisposableStore;m.add(h.onProcessReady(O=>this._proxy.$sendProcessReady(E,O.pid,O.cwd,O.windowsPty))),m.add(h.onDidChangeProperty(O=>this._proxy.$sendProcessProperty(E,O))),this._bufferer.startBuffering(E,h.onProcessData),m.add(h.onProcessExit(O=>this._onProcessExit(E,O))),this._terminalProcesses.set(E,h);const P=this._extensionTerminalAwaitingStart[E];return P&&h instanceof g&&(h.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[E]),m}$acceptProcessAckDataEvent(E,h){this._terminalProcesses.get(E)?.acknowledgeDataEvent(h)}$acceptProcessInput(E,h){this._terminalProcesses.get(E)?.input(h)}$acceptTerminalInteraction(E){const h=this._getTerminalById(E);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptTerminalSelection(E,h){this._getTerminalById(E)?.setSelection(h)}$acceptProcessResize(E,h,m){try{this._terminalProcesses.get(E)?.resize(h,m)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(E,h){this._terminalProcesses.get(E)?.shutdown(h)}$acceptProcessRequestInitialCwd(E){this._terminalProcesses.get(E)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(E,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(E){this._terminalProcesses.get(E)?.getCwd().then(h=>this._proxy.$sendProcessProperty(E,{type:"cwd",value:h}))}$acceptProcessRequestLatency(E){return Promise.resolve(E)}registerLinkProvider(E){return this._linkProviders.add(E),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(E),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(E,h,m){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,m),this._proxy.$registerProfileProvider(h,E.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(E,h,m){if(this._quickFixProviders.has(E))throw new Error(`Terminal quick fix provider "${E}" is already registered`);return this._quickFixProviders.set(E,m),this._proxy.$registerQuickFixProvider(E,h),new _.Disposable(()=>{this._quickFixProviders.delete(E),this._proxy.$unregisterQuickFixProvider(E)})}async $provideTerminalQuickFixes(E,h){const m=new v.CancellationTokenSource().token;if(m.isCancellationRequested)return;const P=this._quickFixProviders.get(E);if(!P)return;const O=await P.provideTerminalQuickFixes(h,m);if(O===null||Array.isArray(O)&&O.length===0)return;const N=new p.DisposableStore;if(this._lastQuickFixCommands.value=N,!Array.isArray(O))return O?o.TerminalQuickFix.from(O,this._extHostCommands.converter,N):void 0;const L=[];for(const U of O){const x=o.TerminalQuickFix.from(U,this._extHostCommands.converter,N);x&&L.push(x)}return L}async $createContributedProfileTerminal(E,h){const m=new v.CancellationTokenSource().token;let P=await this._profileProviders.get(E)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${E}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(E,h){const m=this._getTerminalById(E);if(!m)return[];this._terminalLinkCache.delete(E),this._terminalLinkCancellationSource.get(E)?.dispose(!0);const O=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(E,O);const N=[],L={terminal:m.value,line:h},U=[];for(const H of this._linkProviders)U.push(s.Promises.withAsyncBody(async j=>{O.token.onCancellationRequested(()=>j({provider:H,links:[]}));const fe=await H.provideTerminalLinks(L,O.token)||[];O.token.isCancellationRequested||j({provider:H,links:fe})}));const x=await Promise.all(U);if(O.token.isCancellationRequested)return[];const M=new Map;for(const H of x)H&&H.links.length>0&&N.push(...H.links.map(j=>{const fe={id:u++,startIndex:j.startIndex,length:j.length,label:j.tooltip};return M.set(fe.id,{provider:H.provider,link:j}),fe}));return this._terminalLinkCache.set(E,M),N}$activateLink(E,h){const m=this._terminalLinkCache.get(E)?.get(h);m&&m.provider.handleTerminalLink(m.link)}_onProcessExit(E,h){this._bufferer.stopBuffering(E),this._terminalProcesses.delete(E),delete this._extensionTerminalAwaitingStart[E];const m=this._terminalProcessDisposables[E];m&&(m.dispose(),delete this._terminalProcessDisposables[E]),this._proxy.$sendProcessExit(E,h)}_getTerminalById(E){return this._getTerminalObjectById(this._terminals,E)}_getTerminalObjectById(E,h){const m=this._getTerminalObjectIndexById(E,h);return m!==null?E[m]:null}_getTerminalObjectIndexById(E,h){const m=E.findIndex(P=>P._id===h);return m===-1?null:m}getEnvironmentVariableCollection(E){let h=this._environmentVariableCollections.get(E.identifier.value);return h||(h=new n,this._setEnvironmentVariableCollection(E.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(E,h){const m=(0,k.serializeEnvironmentVariableCollection)(h.map),P=(0,k.serializeEnvironmentDescriptionMap)(h.descriptionMap);this._proxy.$setEnvironmentVariableCollection(E,h.persistent,m.length===0?void 0:m,P)}$initEnvironmentVariableCollections(E){E.forEach(h=>{const m=h[0],P=new n(h[1]);this._setEnvironmentVariableCollection(m,P)})}$acceptDefaultProfile(E,h){const m=this._defaultProfile;this._defaultProfile=E,this._defaultAutomationProfile=h,m?.path!==E.path&&this._onDidChangeShell.fire(E.path)}_setEnvironmentVariableCollection(E,h){this._environmentVariableCollections.set(E,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(E,h)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=je([$e(1,a.IExtHostCommands),$e(2,A.IExtHostRpcService)],t);class n{get persistent(){return this._persistent}set persistent(E){this._persistent=E,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new D.Emitter,this.map=new Map(E)}getScopedEnvironmentVariableCollection(E){const h=this.getScopeKey(E);let m=this.scopedCollections.get(h);return m||(m=new r(this,E),this.scopedCollections.set(h,m),m.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),m}replace(E,h,m,P){this._setIfDiffers(E,{value:h,type:_.EnvironmentVariableMutatorType.Replace,options:m??{applyAtProcessCreation:!0},scope:P})}append(E,h,m,P){this._setIfDiffers(E,{value:h,type:_.EnvironmentVariableMutatorType.Append,options:m??{applyAtProcessCreation:!0},scope:P})}prepend(E,h,m,P){this._setIfDiffers(E,{value:h,type:_.EnvironmentVariableMutatorType.Prepend,options:m??{applyAtProcessCreation:!0},scope:P})}_setIfDiffers(E,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const m=this.getKey(E,h.scope),P=this.map.get(m),O=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==h.value||P.type!==h.type||P.options?.applyAtProcessCreation!==O.applyAtProcessCreation||P.options?.applyAtShellIntegration!==O.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const N=this.getKey(E,h.scope),L={variable:E,...h,options:O};this.map.set(N,L),this._onDidChangeCollection.fire()}}get(E,h){const m=this.getKey(E,h),P=this.map.get(m);return P?S(P):void 0}getKey(E,h){const m=this.getScopeKey(h);return m.length?`${E}:::${m}`:E}getScopeKey(E){return this.getWorkspaceKey(E?.workspaceFolder)??""}getWorkspaceKey(E){return E?E.uri.toString():void 0}getVariableMap(E){const h=new Map;for(const[m,P]of this.map)this.getScopeKey(P.scope)===this.getScopeKey(E)&&h.set(P.variable,S(P));return h}delete(E,h){const m=this.getKey(E,h);this.map.delete(m),this._onDidChangeCollection.fire()}clear(E){if(E?.workspaceFolder){for(const[h,m]of this.map)m.scope?.workspaceFolder?.index===E.workspaceFolder.index&&this.map.delete(h);this.clearDescription(E)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(E,h){const m=this.getScopeKey(h),P=this.descriptionMap.get(m);if(!P||P.description!==E){let O;typeof E=="string"?O=E:O=E?.value.split(`

`)[0];const N={description:O,scope:h};this.descriptionMap.set(m,N),this._onDidChangeCollection.fire()}}getDescription(E){const h=this.getScopeKey(E);return this.descriptionMap.get(h)?.description}clearDescription(E){const h=this.getScopeKey(E);this.descriptionMap.delete(h)}}class r{get persistent(){return this.collection.persistent}set persistent(E){this.collection.persistent=E}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E,h){this.collection=E,this.scope=h,this._onDidChangeCollection=new D.Emitter}getScoped(E){return this.collection.getScopedEnvironmentVariableCollection(E)}replace(E,h,m){this.collection.replace(E,h,m,this.scope)}append(E,h,m){this.collection.append(E,h,m,this.scope)}prepend(E,h,m){this.collection.prepend(E,h,m,this.scope)}get(E){return this.collection.get(E,this.scope)}forEach(E,h){this.collection.getVariableMap(this.scope).forEach((m,P)=>E.call(h,P,m,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(E){this.collection.delete(E,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(E){this.collection.setDescription(E,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let i=class extends t{constructor(E,h){super(!1,E,h)}createTerminal(E,h,m){throw new T.NotSupportedError}createTerminalFromOptions(E,h){throw new T.NotSupportedError}};e.WorkerExtHostTerminalService=i,e.WorkerExtHostTerminalService=i=je([$e(0,a.IExtHostCommands),$e(1,A.IExtHostRpcService)],i);function l(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function f(I){return w.ThemeColor.isThemeColor(I)?I:void 0}function S(I){const E={...I};return delete E.scope,E.options=E.options??void 0,delete E.variable,E}}),define(Ce[328],De([1,0,118,9,22,21,4,75,51,3,23,18,31,6,20,145,13,7,68,109,88,27]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(L,U,x){this.editors=x,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(y.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new l(this.proxy),U.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 16:{const H=M,j=H.tests[H.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(j))?.collection.tree.get(j)?.actual??(0,w.toItemFromContext)(M)}case 18:{const{extId:H,message:j}=M;return{test:this.controllers.get(a.TestId.root(H))?.collection.tree.get(H)?.actual,message:s.TestMessage.to(j)}}default:return M}}}),U.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await U.executeCommand("_testing.getExplorerSelection"),H=j=>{const fe=this.controllers.get(a.TestId.root(j));if(fe)return a.TestId.isRoot(j)?fe.controller:fe.collection.tree.get(j)?.actual};return{include:M?.include.map(H).filter(k.isDefined)||[],exclude:M?.exclude.map(H).filter(k.isDefined)||[]}})}createTestController(L,U,x,M){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const H=new b.DisposableStore,j=H.add(new w.ExtHostTestItemCollection(U,x,this.editors));j.root.label=x;const fe=new Map,Y=this.proxy,X={items:j.root.children,get label(){return x},set label(J){x=J,j.root.label=J,Y.$updateController(U,{label:x})},get refreshHandler(){return M},set refreshHandler(J){M=J,Y.$updateController(U,{canRefresh:!!J})},get id(){return U},createRunProfile:(J,ge,le,we,G,B)=>{let V=(0,_.hash)(J);for(;fe.has(V);)V++;return new P(this.proxy,fe,U,V,J,ge,le,we,G,B)},createTestItem(J,ge,le){return new w.TestItemImpl(U,J,ge,le)},createTestRun:(J,ge,le=!0)=>this.runTracker.createTestRun(L,U,j,J,ge,le),invalidateTestResults:J=>{if(J===void 0)this.proxy.$markTestRetired(void 0);else{const ge=J instanceof Array?J:[J];this.proxy.$markTestRetired(ge.map(le=>a.TestId.fromExtHostTestItem(le,U).toString()))}},set resolveHandler(J){j.resolveHandler=J},get resolveHandler(){return j.resolveHandler},dispose:()=>{H.dispose()}};Y.$registerTestController(U,x,!!M),H.add((0,b.toDisposable)(()=>Y.$unregisterTestController(U)));const z={controller:X,collection:j,profiles:fe,extension:L};return this.controllers.set(U,z),H.add((0,b.toDisposable)(()=>this.controllers.delete(U))),H.add(j.onDidGenerateDiff(J=>Y.$publishDiff(U,J.map(g.TestsDiffOp.serialize)))),X}createTestObserver(){return this.observer.checkout()}async runTests(L,U=R.CancellationToken.None){const x=f(L);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(x.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(H=>a.TestId.fromExtHostTestItem(H,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:O[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:L.exclude?.map(H=>H.id)},U)}$syncTests(){for(const{collection:L}of this.controllers.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,U,x){return(0,D.mapFindFirst)(this.runTracker.trackers,H=>H.id===L?H.getCoverage(U):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(L,U,x,M){return(0,D.mapFindFirst)(this.runTracker.trackers,j=>j.id===L?j.getCoverage(U):void 0)?.resolveFileCoverage(x,M)??Promise.resolve([])}$configureRunProfile(L,U){this.controllers.get(L)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(L,U){await this.controllers.get(L)?.controller.refreshHandler?.(U)}$publishTestResults(L){this.results=Object.freeze(L.map(U=>(0,T.deepFreeze)(s.TestResults.to(U))).concat(this.results).sort((U,x)=>x.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,U){const x=this.controllers.get(a.TestId.fromString(L).controllerId)?.collection;x&&(await x.expand(L,U<0?1/0:U),x.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(g.TestsDiffOp.deserialize))}async $runControllerTests(L,U){return Promise.all(L.map(x=>this.runControllerTestRequest(x,!1,U)))}async $startContinuousRun(L,U){const x=new R.CancellationTokenSource(U),M=await Promise.all(L.map(H=>this.runControllerTestRequest(H,!0,x.token)));return!U.isCancellationRequested&&!M.some(H=>H.error)&&await new Promise(H=>U.onCancellationRequested(H)),x.dispose(!0),M}async runControllerTestRequest(L,U,x){const M=this.controllers.get(L.controllerId);if(!M)return{};const{collection:H,profiles:j,extension:fe}=M,Y=j.get(L.profileId);if(!Y)return{};const X=L.testIds.map(le=>H.tree.get(le)).filter(k.isDefined),z=L.excludeExtIds.map(le=>M.collection.tree.get(le)).filter(k.isDefined).filter(le=>X.some(we=>we.fullId.compare(le.fullId)===2));if(!X.length)return{};const J=new o.TestRunRequest(X.some(le=>le.actual instanceof w.TestItemRootImpl)?void 0:X.map(le=>le.actual),z.map(le=>le.actual),Y,U),ge=(0,g.isStartControllerTests)(L)&&this.runTracker.prepareForMainThreadTestRun(J,S.fromInternal(L,M.collection),fe,x);try{return await Y.runHandler(J,x),{}}catch(le){return{error:String(le)}}finally{ge&&(ge.hasRunningTasks&&!x.isCancellationRequested&&await A.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};e.ExtHostTesting=t,e.ExtHostTesting=t=je([$e(0,C.IExtHostRpcService)],t);const n=1e4;var r;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(r||(r={}));class i extends b.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(L,U,x,M){super(),this.dto=L,this.proxy=U,this.extension=x,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(M));const H=this._register(new F.RunOnceScheduler(()=>this.forciblyEndTasks(),n));this._register(this.cts.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const U=this.dto.id,x=this.dto.controllerId,M=(0,v.generateUuid)(),H=new I(this.proxy,U,M),j=z=>(J,...ge)=>{if(Y){console.warn(`Setting the state of test "${J.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(J)&&(this.ensureTestIsKnown(J),z(J,...ge))},fe=(z,J)=>{const ge=J instanceof Array?J.map(s.TestMessage.from):[s.TestMessage.from(J)];if(ge.some(le=>le.contextValue!==void 0)&&(0,u.checkProposedApiEnabled)(this.extension,"testMessageContextValue"),z.uri&&z.range){const le={range:s.Range.from(z.range),uri:z.uri};for(const we of ge)we.location=we.location||le}this.proxy.$appendTestMessagesInRun(U,M,a.TestId.fromExtHostTestItem(z,x).toString(),ge)};let Y=!1;const X={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return H.coverageProvider},set coverageProvider(z){H.coverageProvider=z},enqueued:j(z=>{this.proxy.$updateTestStateInRun(U,M,a.TestId.fromExtHostTestItem(z,x).toString(),1)}),skipped:j(z=>{this.proxy.$updateTestStateInRun(U,M,a.TestId.fromExtHostTestItem(z,x).toString(),5)}),started:j(z=>{this.proxy.$updateTestStateInRun(U,M,a.TestId.fromExtHostTestItem(z,x).toString(),2)}),errored:j((z,J,ge)=>{fe(z,J),this.proxy.$updateTestStateInRun(U,M,a.TestId.fromExtHostTestItem(z,x).toString(),6,ge)}),failed:j((z,J,ge)=>{fe(z,J),this.proxy.$updateTestStateInRun(U,M,a.TestId.fromExtHostTestItem(z,x).toString(),4,ge)}),passed:j((z,J)=>{this.proxy.$updateTestStateInRun(U,M,a.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,J)}),appendOutput:(z,J,ge)=>{Y||(ge&&(this.dto.isIncluded(ge)?this.ensureTestIsKnown(ge):ge=void 0),this.proxy.$appendOutputToRun(U,M,d.VSBuffer.fromString(z),J&&s.location.from(J),ge&&a.TestId.fromExtHostTestItem(ge,x).toString()))},end:()=>{Y||(Y=!0,this.proxy.$finishedTestRunTask(U,M),this.tasks.delete(M),this.tasks.size||this.markEnded())}};return this.tasks.set(M,{run:X,coverage:H}),this.proxy.$startedTestRunTask(U,{id:M,name:L,running:!0}),X}forciblyEndTasks(){for(const{run:L}of this.tasks.values())L.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(L){if(!(L instanceof w.TestItemImpl))throw new c.InvalidTestItemError(L.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const U=[],x=this.dto.colllection.root;for(;;){const M=s.TestItem.from(L);if(U.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),L===x))break;L=L.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}dispose(){this.markEnded(),super.dispose()}}class l{get trackers(){return this.tracked.values()}constructor(L){this.proxy=L,this.tracked=new Map}prepareForMainThreadTestRun(L,U,x,M){return this.getTracker(L,U,x,M)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.cancel();return}}cancelAllRuns(){for(const L of this.tracked.values())L.cancel()}createTestRun(L,U,x,M,H,j){const fe=this.tracked.get(M);if(fe)return fe.createRun(H);const Y=S.fromPublic(U,x,M,j),X=f(M);this.proxy.$startedExtensionTestRun({controllerId:U,continuous:!!M.continuous,profile:X&&{group:O[X.kind],id:X.profileId},exclude:M.exclude?.map(J=>a.TestId.fromExtHostTestItem(J,x.root.id).toString())??[],id:Y.id,include:M.include?.map(J=>a.TestId.fromExtHostTestItem(J,x.root.id).toString())??[x.root.id],persist:j});const z=this.getTracker(M,Y,L);return A.Event.once(z.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(Y.id),z.dispose()}),z.createRun(H)}getTracker(L,U,x,M){const H=new i(U,this.proxy,x,M);return this.tracked.set(L,H),A.Event.once(H.onEnd)(()=>this.tracked.delete(L)),H}}e.TestRunCoordinator=l;const f=N=>{if(N.profile){if(!(N.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class S{static fromPublic(L,U,x,M){return new S(L,(0,v.generateUuid)(),x.include?.map(H=>a.TestId.fromExtHostTestItem(H,L).toString())??[L],x.exclude?.map(H=>a.TestId.fromExtHostTestItem(H,L).toString())??[],M,U)}static fromInternal(L,U){return new S(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,U)}constructor(L,U,x,M,H,j){this.controllerId=L,this.id=U,this.isPersisted=H,this.colllection=j,this.includePrefix=x.map(fe=>fe+"\0"),this.excludePrefix=M.map(fe=>fe+"\0")}isIncluded(L){const U=a.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(U===x||U.startsWith(x))return!1;for(const x of this.includePrefix)if(U===x||U.startsWith(x))return!0;return!1}}e.TestRunDto=S;class I{set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");L&&(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(L,U,x){this.proxy=L,this.runId=U,this.taskId=x}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(s.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(L,U){const x=await this.fileCoverage;let M=x?.[L];return!this._coverageProvider||!x||!M?[]:(M.detailedCoverage||(M=x[L]=await this._coverageProvider.resolveFileCoverage?.(M,U)??M),M.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(L){this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(L){this.added.add(L)}update(L){Object.assign(L.revived,s.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}this.updated.delete(L);const U=a.TestId.parentId(L.item.extId);if(U&&this.alreadyRemoved.has(U.toString())){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:x}=this;return{get added(){return[...L].map(M=>M.revived)},get updated(){return[...U].map(M=>M.revived)},get removed(){return[...x].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return{...L,revived:s.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new E(this.changeEmitter)}}class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(U=>U.revived)},dispose:(0,p.createSingleCallFunction)(()=>{--L.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class P{#e;#t;get label(){return this._label}set label(L){L!==this._label&&(this._label=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(L){L!==this._supportsContinuousRun&&(this._supportsContinuousRun=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?s.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,U,x,M,H,j,fe,Y=!1,X=void 0,z=!1){this.controllerId=x,this.profileId=M,this._label=H,this.kind=j,this.runHandler=fe,this._isDefault=Y,this._tag=X,this._supportsContinuousRun=z,this.#e=L,this.#t=U,U.set(M,this);const J=O[j];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${j}`);this.#e.$publishTestRunProfile({profileId:M,controllerId:x,tag:X?s.TestTag.namespace(this.controllerId,X.id):null,label:H,group:J,isDefault:Y,hasConfigurationHandler:!1,supportsContinuousRun:z})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=P;const O={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[329],De([1,0,19,8,4,6,146,13,7]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(k,v){this._extHostDocumentsAndEditors=v,this._onDidChangeTextEditorSelection=new d.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new d.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new d.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new d.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new d.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new d.Emitter({onListenerError:F.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=k.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(y=>this._onDidChangeVisibleTextEditors.fire(y)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(y=>this._onDidChangeActiveTextEditor.fire(y))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(k){const v=this._extHostDocumentsAndEditors.allEditors();return k?v:v.map(y=>y.value)}async showTextDocument(k,v,y){let C;typeof v=="number"?C={position:p.ViewColumn.from(v),preserveFocus:y}:typeof v=="object"?C={position:p.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?p.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:C={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(k.uri,C),s=w&&this._extHostDocumentsAndEditors.getEditor(w);if(s)return s.value;throw w?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,v){return new A.TextEditorDecorationType(this._proxy,k,v).value}$acceptEditorPropertiesChanged(k,v){const y=this._extHostDocumentsAndEditors.getEditor(k);if(!y)throw new Error("unknown text editor");if(v.options&&y._acceptOptions(v.options),v.selections){const C=v.selections.selections.map(p.Selection.to);y._acceptSelections(C)}if(v.visibleRanges){const C=D.coalesce(v.visibleRanges.map(p.Range.to));y._acceptVisibleRanges(C)}if(v.options&&this._onDidChangeTextEditorOptions.fire({textEditor:y.value,options:{...v.options,lineNumbers:p.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const C=_.TextEditorSelectionChangeKind.fromValue(v.selections.source),w=v.selections.selections.map(p.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:y.value,selections:w,kind:C})}if(v.visibleRanges){const C=D.coalesce(v.visibleRanges.map(p.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:y.value,visibleRanges:C})}}$acceptEditorPositionData(k){for(const v in k){const y=this._extHostDocumentsAndEditors.getEditor(v);if(!y)throw new Error("Unknown text editor");const C=p.ViewColumn.to(k[v]);y.value.viewColumn!==C&&(y._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:y.value,viewColumn:C}))}}getDiffInformation(k){return Promise.resolve(this._proxy.$getDiffInformation(k))}}e.ExtHostEditors=b}),define(Ce[330],De([1,0,2,5,6,3,7,13,25,18]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class T{constructor(y,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=y.getProxy(d.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(w,s)=>{if(w&&w.$mid===12)if(this._providers.get(w.source)&&_.ExtensionIdentifier.equals(s,this._providers.get(w.source)?.extension)){const o=w.uri===void 0?void 0:D.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(k(o))?.get(w.handle)}else return;return w}})}async $getTimeline(y,C,w,s){return this._providers.get(y)?.provider.provideTimeline(D.URI.revive(C),w,s)}registerTimelineProvider(y,C,w,s){const o=new R.DisposableStore,a=this.convertTimelineItem(C.id,s,o).bind(this);let c;C.onDidChange&&(c=C.onDidChange(u=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:C.id}),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:y,onDidChange:void 0,async provideTimeline(u,t,n){t?.resetCache&&(o.clear(),g.get(C.id)?.clear());const r=await C.provideTimeline(u,t,n);if(r==null)return;const i=a(u,t);return{...r,source:C.id,items:r.items.map(i)}},dispose(){for(const u of g.values())u.get(C.id)?.clear();c?.dispose(),o.dispose()}},w)}convertTimelineItem(y,C,w){return(s,o)=>{let a;if(o?.cacheResults){let c=this._itemsBySourceAndUriMap.get(y);c===void 0&&(c=new Map,this._itemsBySourceAndUriMap.set(y,c));const g=k(s);a=c.get(g),a===void 0&&(a=new Map,c.set(g,a))}return c=>{const{iconPath:g,...u}=c,t=`${y}|${c.id??c.timestamp}`;a?.set(t,c);let n,r,i;c.iconPath&&(g instanceof A.ThemeIcon?i={id:g.id,color:g.color}:D.URI.isUri(g)?(n=g,r=g):{light:n,dark:r}=g);let l;return A.MarkdownString.isMarkdownString(u.tooltip)?l=p.MarkdownString.from(u.tooltip):(0,b.isString)(u.tooltip)?l=u.tooltip:A.MarkdownString.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.MarkdownString.from(u.detail)):(0,b.isString)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=u.detail),{...u,id:u.id??void 0,handle:t,source:y,command:c.command?C.toInternal(c.command,w):void 0,icon:n,iconDark:r,themeIcon:i,tooltip:l,accessibilityInformation:c.accessibilityInformation}}}}registerTimelineProviderCore(y,C){if(this._providers.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this._proxy.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this._providers.set(y.id,{provider:y,extension:C}),(0,R.toDisposable)(()=>{for(const s of this._itemsBySourceAndUriMap.values())s.get(y.id)?.clear();this._providers.delete(y.id),this._proxy.$unregisterTimelineProvider(y.id),y.dispose()})}}e.ExtHostTimeline=T;function k(v){return v?.toString()}}),define(Ce[73],De([1,0,21,4,3,213,5,14,86,6,26,20,7]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class y extends _.DisposableTunnel{}var C;(function(s){function o(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?_.TunnelPrivacyId.Public:_.TunnelPrivacyId.Private),protocol:c.protocol}}s.fromApiTunnel=o;function a(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==_.TunnelPrivacyId.ConstantPrivate&&c.privacy!==_.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}s.fromServiceTunnel=a})(C||(e.TunnelDtoConverter=C={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let w=class extends d.Disposable{constructor(o,a,c){super(),this.logService=c,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new F.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(b.MainContext.MainThreadTunnelService)}async openTunnel(o,a){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const c=await this._proxy.$openTunnel(a,o.displayName);if(c){const g=new y(c.remoteAddress,c.localAddress,()=>this._proxy.$closeTunnel(c.remoteAddress));return this._register(g),g}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,a){const c=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(c,{selector:o,provider:a}),this._proxy.$registerPortsAttributesProvider(o,c),new v.Disposable(()=>{this._portAttributesProviders.delete(c),this._proxy.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(o,a,c,g,u){const t=[];for(const r of o){const i=this._portAttributesProviders.get(r);if(!i)return[];t.push(...await Promise.all(a.map(async l=>{let f;try{f=await i.provider.providePortAttributes({port:l,pid:c,commandLine:g},u)}catch{f=await i.provider.providePortAttributes(l,c,g,u)}return{providedAttributes:f,port:l}})))}const n=t.filter(r=>!!r.providedAttributes);return n.length>0?n.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,a){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(g,u)=>await o.provideTunnel(g,u,new D.CancellationTokenSource().token)??void 0;const c=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(c),Promise.resolve((0,d.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,a){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const c=o.tunnelFactory??(a?this.makeManagedTunnelFactory(a):void 0);if(c){this._forwardPortProvider=c;let g=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&g.length===0&&(g=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:g}:void 0;this._proxy.$setTunnelProvider(u)}}else this._forwardPortProvider=void 0;return(0,d.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,a){if(this._extensionTunnels.has(o.host)){const c=this._extensionTunnels.get(o.host);c.has(o.port)&&(a&&c.get(o.port).disposeListener.dispose(),await c.get(o.port).tunnel.dispose(),c.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,a){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this._forwardPortProvider(o,a);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const g=await c;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),g===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const u=this._register(g.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(g.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:g,disposeListener:u}),C.fromApiTunnel(g)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(o){const a=await Promise.all(o.map(g=>this._showCandidatePort(g.host,g.port,g.detail??""))),c=o.filter((g,u)=>a[u]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(g=>g.port).join(", ")} to ${c.map(g=>g.port).join(", ")}`),c}};e.ExtHostTunnelService=w,e.ExtHostTunnelService=w=je([$e(0,k.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,p.ILogService)],w)}),define(Ce[331],De([1,0,3,17,2,6]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}constructor(_){this._openers=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,b,T,k){if(this._openers.has(b))throw new Error(`Opener with id '${b}' already registered`);const v=k.schemes.find(y=>!A.supportedSchemes.has(y));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(b,T),this._proxy.$registerUriOpener(b,k.schemes,_,k.label),(0,D.toDisposable)(()=>{this._openers.delete(b),this._proxy.$unregisterUriOpener(b)})}async $canOpenUri(_,b,T){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener with id: ${_}`);const v=d.URI.revive(b);return k.canOpenExternalUri(v,T)}async $openUri(_,b,T){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener id: '${_}'`);return k.openExternalUri(d.URI.revive(b.resolvedUri),{sourceUri:d.URI.revive(b.sourceUri)},T)}}e.ExtHostUriOpeners=A}),define(Ce[332],De([1,0,6,2,3,8,25]),function(pe,e,D,F,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class p{static{this.HandlePool=0}constructor(b){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=b.getProxy(D.MainContext.MainThreadUrls)}registerUriHandler(b,T){const k=b.identifier;if(this.handles.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const v=p.HandlePool++;return this.handles.add(k),this.handlers.set(v,T),this._proxy.$registerUriHandler(v,k,b.displayName||b.name),(0,d.toDisposable)(()=>{this.handles.delete(k),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(b,T){const k=this.handlers.get(b);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(T))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(b){return F.URI.revive(await this._proxy.$createAppUri(b))}}e.ExtHostUrls=p}),define(Ce[92],De([1,0,4,3,17,23,2,228,265,110,6]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class k{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(g,u,t,n,r,i,l){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new D.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new D.Emitter,this._onDidDispose=this.#d.event,this.#e=g,this.#t=u,this.#r=t,this.#u=n,this.#l=r,this.#n=i,this.#c=v(i),this.#h=y(i),this.#i=l}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return this.#a=!0,(0,b.asWebviewUri)(g,this.#u)}get cspSource(){const g=this.#n.extensionLocation;if(g.scheme===d.Schemas.https||g.scheme===d.Schemas.http){let u=g.toString();return u.endsWith("/")||(u+="/"),u+" "+b.webviewGenericCspSource}return b.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(g){this.assertNotDisposed(),this.#s!==g&&(this.#s=g,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(g)))}get options(){return this.assertNotDisposed(),this.#r}set options(g){this.assertNotDisposed(),R.equals(this.#r,g)||this.#t.$setOptions(this.#e,s(this.#n,this.#l,g)),this.#r=g}async postMessage(g){if(this.#o)return!1;const u=(0,_.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(g){if(!this.#h)return g;const u=this.#n.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return g.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,r,i,l,f,S)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(f)}),E=(0,b.asWebviewUri)(I,{isRemote:u,authority:t}).toString();return`${r}${E}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,r,i,l,f,S)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(f)}),E=(0,b.asWebviewUri)(I,{isRemote:u,authority:t}).toString();return`${r}${E}${S}`})}}e.ExtHostWebview=k;function v(c){try{const g=(0,p.normalizeVersion)((0,p.parseVersion)(c.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;function y(c){try{const g=(0,p.normalizeVersion)((0,p.parseVersion)(c.engines.vscode));return g?g.majorBase<1||g.majorBase===1&&g.minorBase<60:!1}catch{return!1}}class C extends F.Disposable{constructor(g,u,t,n,r){super(),this.remoteInfo=u,this.workspace=t,this._logService=n,this._deprecationService=r,this._webviews=new Map,this._webviewProxy=g.getProxy(T.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const g of this._webviews.values())g.dispose();this._webviews.clear()}$onMessage(g,u,t){const n=this.getWebview(g);if(n){const{message:r}=(0,_.deserializeWebviewMessage)(u,t.value);n._onMessageEmitter.fire(r)}}$onMissingCsp(g,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,u,t){const n=new k(g,this._webviewProxy,o(u),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(g,n);const r=n._onDidDispose(()=>{r.dispose(),this.deleteWebview(g)});return n}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=C;function w(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=w;function s(c,g,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||a(c,g)}}e.serializeWebviewOptions=s;function o(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(g=>A.URI.from(g))}}function a(c,g){return[...(g?.getWorkspaceFolders()||[]).map(u=>u.uri),c.extensionLocation]}}),define(Ce[333],De([1,0,21,51,3,17,24,2,13,92,87,6,7]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(n,r){this.document=n,this._storagePath=r,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,r){await this.getEdit(n).undo(),r||this.disposeBackup()}async redo(n,r){await this.getEdit(n).redo(),r||this.disposeBackup()}disposeEdits(n){for(const r of n)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=u(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const r=this._edits.get(n,0);if(!r)throw new Error("No edit found");return r}}class C{constructor(){this._documents=new Map}get(n,r){return this._documents.get(this.key(n,r))}add(n,r,i){const l=this.key(n,r.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${n} resource:${r.uri}`);const f=new y(r,i);return this._documents.set(l,f),f}delete(n,r){const i=this.key(n,r.uri);this._documents.delete(i)}key(n,r){return`${n}@@@${r}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class s{constructor(){this._providers=new Map}addTextProvider(n,r,i){return this.add(0,n,r,i)}addCustomProvider(n,r,i){return this.add(1,n,r,i)}get(n){return this._providers.get(n)}add(n,r,i,l){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:n,extension:i,provider:l}),new v.Disposable(()=>this._providers.delete(r))}}class o{constructor(n,r,i,l,f){this._extHostDocuments=r,this._extensionStoragePaths=i,this._extHostWebview=l,this._extHostWebviewPanels=f,this._editorProviders=new s,this._documents=new C,this._proxy=n.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,r,i,l){const f=new d.DisposableStore;return c(i)?(f.add(this._editorProviders.addTextProvider(r,n,i)),this._proxy.$registerTextEditorProvider((0,b.toExtensionData)(n),r,l.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,b.shouldSerializeBuffersForPostMessage)(n))):(f.add(this._editorProviders.addCustomProvider(r,n,i)),a(i)&&f.add(i.onDidChangeCustomDocument(S=>{const I=this.getCustomDocumentEntry(r,S.document.uri);if(g(S)){const E=I.addEdit(S);this._proxy.$onDidEdit(S.document.uri,r,E,S.label)}else this._proxy.$onContentChange(S.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,b.toExtensionData)(n),r,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,b.shouldSerializeBuffersForPostMessage)(n))),v.Disposable.from(f,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(n,r,i,l,f){const S=this._editorProviders.get(r);if(!S)throw new Error(`No provider found for '${r}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${r}'`);const I=p.URI.revive(n),E=await S.provider.openCustomDocument(I,{backupId:i,untitledDocumentData:l?.buffer},f);let h;return a(S.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension)),this._documents.add(r,E,h),{editable:a(S.provider)}}async $disposeCustomDocument(n,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${r}'`);const l=p.URI.revive(n),{document:f}=this.getCustomDocumentEntry(r,l);this._documents.delete(r,f),f.dispose()}async $resolveCustomEditor(n,r,i,l,f,S){const I=this._editorProviders.get(i);if(!I)throw new Error(`No provider found for '${i}'`);const E=_.ViewColumn.to(f),h=this._extHostWebview.createNewWebview(r,l.contentOptions,I.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(r,i,l.title,E,l.options,h,l.active),P=p.URI.revive(n);switch(I.type){case 1:{const{document:O}=this.getCustomDocumentEntry(i,P);return I.provider.resolveCustomEditor(O,m,S)}case 0:{const O=this._extHostDocuments.getDocument(P);return I.provider.resolveCustomTextEditor(O,m,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,r,i){this.getCustomDocumentEntry(r,n).disposeEdits(i)}async $onMoveCustomEditor(n,r,i){const l=this._editorProviders.get(i);if(!l)throw new Error(`No provider found for '${i}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const f=this._extHostWebviewPanels.getWebviewPanel(n);if(!f)throw new Error("No webview found");const S=p.URI.revive(r),I=this._extHostDocuments.getDocument(S);await l.provider.moveCustomTextEditor(I,f,D.CancellationToken.None)}async $undo(n,r,i,l){return this.getCustomDocumentEntry(r,n).undo(i,l)}async $redo(n,r,i,l){return this.getCustomDocumentEntry(r,n).redo(i,l)}async $revert(n,r,i){const l=this.getCustomDocumentEntry(r,n);await this.getCustomEditorProvider(r).revertCustomDocument(l.document,i),l.disposeBackup()}async $onSave(n,r,i){const l=this.getCustomDocumentEntry(r,n);await this.getCustomEditorProvider(r).saveCustomDocument(l.document,i),l.disposeBackup()}async $onSaveAs(n,r,i,l){const f=this.getCustomDocumentEntry(r,n);return this.getCustomEditorProvider(r).saveCustomDocumentAs(f.document,p.URI.revive(i),l)}async $backup(n,r,i){const l=this.getCustomDocumentEntry(r,n),S=await this.getCustomEditorProvider(r).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},i);return l.updateBackup(S),S.id}getCustomDocumentEntry(n,r){const i=this._documents.get(n,p.URI.revive(r));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(n){const i=this._editorProviders.get(n)?.provider;if(!i||!a(i))throw new Error("Custom document is not editable");return i}}e.ExtHostCustomEditors=o;function a(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function g(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const n=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,F.hash)(n)+""}}),define(Ce[334],De([1,0,4,3,2,31,13,92,6,7]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends F.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(C,w,s,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new D.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new D.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=C,this.#t=w,this.#u=s,this.#i=o.viewType,this.#l=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(C){this.assertNotDisposed(),this.#n!==C&&(this.#n=C,this.#t.$setTitle(this.#e,C))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(C){this.assertNotDisposed(),this.#s!==C&&(this.#s=C,this.#t.$setIconPath(this.#e,d.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(C){this.#c||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(this.#a=C.active,this.#o=C.visible,this.#r=C.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(C,w){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof C>"u"?void 0:A.ViewColumn.from(C),preserveFocus:!!w})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class k extends F.Disposable{static newHandle(){return(0,R.generateUuid)()}constructor(C,w,s){super(),this.webviews=w,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(C=>C.dispose()),this._webviewPanels.clear()}createWebviewPanel(C,w,s,o,a={}){const c=typeof o=="object"?o.viewColumn:o,g={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,p.shouldSerializeBuffersForPostMessage)(C),t=k.newHandle();this._proxy.$createWebviewPanel((0,p.toExtensionData)(C),t,w,{title:s,panelOptions:v(a),webviewOptions:(0,p.serializeWebviewOptions)(C,this.workspace,a),serializeBuffersForPostMessage:u},g);const n=this.webviews.createNewWebview(t,a,C);return this.createNewWebviewPanel(t,w,s,c,a,n,!0)}$onDidChangeWebviewPanelViewStates(C){const w=Object.keys(C);w.sort((s,o)=>{const a=C[s],c=C[o];return a.active?1:c.active?-1:+a.visible-+c.visible});for(const s of w){const o=this.getWebviewPanel(s);if(!o)continue;const a=C[s];o._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this._webviewPanels.delete(C),this.webviews.deleteWebview(C)}registerWebviewPanelSerializer(C,w,s){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:s,extension:C}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,p.shouldSerializeBuffersForPostMessage)(C)}),new b.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(C,w,s,o){const a=this._serializers.get(w);if(!a)throw new Error(`No serializer found for '${w}'`);const{serializer:c,extension:g}=a,u=this.webviews.createNewWebview(C,s.webviewOptions,g),t=this.createNewWebviewPanel(C,w,s.title,o,s.panelOptions,u,s.active);await c.deserializeWebviewPanel(t,s.state)}createNewWebviewPanel(C,w,s,o,a,c,g){const u=new T(C,this._proxy,c,{viewType:w,title:s,viewColumn:o,panelOptions:a,active:g});return this._webviewPanels.set(C,u),u}getWebviewPanel(C){return this._webviewPanels.get(C)}}e.ExtHostWebviewPanels=k;function v(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Ce[335],De([1,0,4,3,92,13,6,7]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends F.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(k,v,y,C,w,s){super(),this.#l=!1,this.#a=this._register(new D.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new D.Emitter),this.onDidDispose=this.#c.event,this.#i=y,this.#s=C,this.#e=k,this.#t=v,this.#u=w,this.#n=s}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(k){this.assertNotDisposed(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.assertNotDisposed(),this.#r}set description(k){this.assertNotDisposed(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#l||(this.#n=k,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(k){this.assertNotDisposed(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.assertNotDisposed(),this.#t.$show(this.#e,!!k)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class b{constructor(k,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(k,v,y,C){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:y,extension:k}),this._proxy.$registerWebviewViewProvider((0,d.toExtensionData)(k),v,{retainContextWhenHidden:C?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.shouldSerializeBuffersForPostMessage)(k)}),new p.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(k,v,y,C,w){const s=this._viewProviders.get(v);if(!s)throw new Error(`No view provider found for '${v}'`);const{provider:o,extension:a}=s,c=this._extHostWebview.createNewWebview(k,{},a),g=new _(k,this._proxy,v,y,c,!0);this._webviewViews.set(k,g),await o.resolveWebviewView(g,{state:C},w)}async $onDidChangeWebviewViewVisibility(k,v){this.getWebviewView(k)._setVisible(v)}async $disposeWebviewView(k){const v=this.getWebviewView(k);this._webviewViews.delete(k),v.dispose(),this._extHostWebview.deleteWebview(k)}getWebviewView(k){const v=this._webviewViews.get(k);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(Ce[151],De([1,0,4,6,2,17,15,5,20,27]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class{static{T=this}static{this.InitialState={focused:!0,active:!0}}getState(y){const C=this._state;return{get focused(){return C.focused},get active(){return(0,b.checkProposedApiEnabled)(y,"windowActivity"),C.active}}}constructor(y){this._onDidChangeWindowState=new D.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=T.InitialState,this._proxy=y.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:w})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,C){C!==this._state[y]&&(this._state={...this._state,[y]:C},this._onDidChangeWindowState.fire(this._state))}openUri(y,C){let w;if(typeof y=="string"){w=y;try{y=d.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,w,C)}async asExternalUri(y,C){if((0,A.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(y,C);return d.URI.from(w)}};e.ExtHostWindow=k,e.ExtHostWindow=k=T=je([$e(0,_.IExtHostRpcService)],k),e.IExtHostWindow=(0,p.createDecorator)("IExtHostWindow")}),define(Ce[336],De([1,0,304,26,20]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let A=class extends D.AbstractExtHostConsoleForwarder{constructor(_,b){super(_,b),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(_,b,T){const k=_==="error"||_==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),b.apply(console,T),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(_,b){const T=process[_],k=T.write;let v="";Object.defineProperty(T,"write",{set:()=>{},get:()=>(y,C,w)=>{if(!this._isMakingConsoleCall){v+=y.toString(C);const s=v.length>R?v.length:v.lastIndexOf(`
`);s!==-1&&(console[b](v.slice(0,s)),v=v.slice(s+1))}k.call(T,y,C,w)}})}};e.ExtHostConsoleForwarder=A,e.ExtHostConsoleForwarder=A=je([$e(0,d.IExtHostRpcService),$e(1,F.IExtHostInitDataService)],A)}),define(Ce[337],De([1,0,72,17,14,240,30,12]),function(pe,e,D,F,d,R,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let _=class{constructor(k,v){k.addFileSystemProvider(F.Schemas.file,new b(v),{isCaseSensitive:p.isLinux})}};e.ExtHostDiskFileSystemProvider=_,e.ExtHostDiskFileSystemProvider=_=je([$e(0,D.IExtHostConsumerFileSystem),$e(1,d.ILogService)],_);class b{constructor(k){this.logService=k,this.impl=new R.DiskFileSystemProvider(this.logService)}async stat(k){const v=await this.impl.stat(k);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(k){return this.impl.readdir(k)}createDirectory(k){return this.impl.mkdir(k)}readFile(k){return this.impl.readFile(k)}writeFile(k,v,y){return this.impl.writeFile(k,v,{...y,unlock:!1,atomic:!1})}delete(k,v){return this.impl.delete(k,{...v,useTrash:!1,atomic:!1})}rename(k,v,y){return this.impl.rename(k,v,y)}copy(k,v,y){return this.impl.copy(k,v,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(k,v){throw new Error("Method not implemented.")}}}),define(Ce[338],De([1,0,16,63,31,33,3,6,2,20]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends A.Disposable{constructor(v,y){super();const C=v.getProxy(p.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async w=>{const s=_.URI.file((0,D.join)((0,F.tmpdir)(),(0,d.generateUuid)()));return await C.$download(w,s),s})}};e.ExtHostDownloadService=T,e.ExtHostDownloadService=T=je([$e(0,b.IExtHostRpcService),$e(1,R.IExtHostCommands)],T)}),define(Ce[339],De([1,0,150,17,242,31]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends D.ExtHostLoggerService{doCreateLogger(_,b,T){return _.scheme===F.Schemas.file?new d.SpdLogLogger(T?.name||(0,R.generateUuid)(),_.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,b):super.doCreateLogger(_,b,T)}registerLogger(_){super.registerLogger(_),this._proxy.$registerLogger(_)}deregisterLogger(_){super.deregisterLogger(_),this._proxy.$deregisterLogger(_)}}e.ExtHostLoggerService=A}),define(Ce[340],De([1,0,52,16,2,91,3,17,9,29]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends R.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const n=await super._getWorkspaceStorageURI(t);if(n.scheme!==p.Schemas.file)return n;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const r=n.fsPath;let i=0;do{let l;i===0?l=r:l=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${i}`:`${r}-${i}`,await k(l);const f=F.join(l,"vscode.lock"),S=await w(this._logService,f,!1);if(S)return this._workspaceStorageLock=S,process.on("exit",()=>{S.dispose()}),d.URI.file(l);i++}while(i<10);return n}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function k(u){try{await b.Promises.stat(u);return}catch{}try{await b.Promises.mkdir(u,{recursive:!0})}catch{}}const v=1e3,y=10*60*1e3;class C extends A.Disposable{constructor(t,n){super(),this.logService=t,this.filename=n,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await s(t,n);(!r||r.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this._timer.cancel());try{await b.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{D.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await b.Promises.writeFile(this.filename,JSON.stringify(n),{flag:"w"})}catch(n){this.logService.error(n)}}}async function w(u,t,n){try{const i={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){u.error(i)}const r=await s(u,t);return!r||r.pid!==process.pid?n?(u.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(u,t)):(u.info(`Lock '${t}': Lock acquired.`),new C(u,t))}async function s(u,t){let n;try{n=await b.Promises.readFile(t)}catch(r){return u.error(r),null}try{return JSON.parse(String(n))}catch(r){return u.error(r),null}}async function o(u,t){let n;try{n=await b.Promises.stat(t)}catch(r){return u.error(r),0}return n.mtime.getTime()}function a(u){try{return process.kill(u,0),!0}catch{return!1}}async function c(u,t){const n=await s(u,t);if(!n)return u.info(`Lock '${t}': Could not read pid of lock holder.`),g(u,t);if(n.willReleaseAt){let S=n.willReleaseAt-Date.now();if(S<5e3){for(S>0?u.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):u.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,_.timeout)(Math.min(100,S)),await o(u,t)===0)return g(u,t);S=n.willReleaseAt-Date.now()}return g(u,t)}}if(!a(n.pid))return u.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),g(u,t);const r=await o(u,t),i=Date.now()-r;if(i<=y)return u.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;u.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const l=await o(u,t),f=Date.now()-l;return f<=y?(u.info(`Lock '${t}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null):(u.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),g(u,t))}async function g(u,t){u.info(`Lock '${t}': Deleting a stale lock.`);try{await b.Promises.unlink(t)}catch{}return w(u,t,!0)}}),define(Ce[341],De([1,0,31,20,44,33]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends d.BaseExtHostTerminalService{constructor(_,b){super(!0,_,b)}createTerminal(_,b,T){return this.createTerminalFromOptions({name:_,shellPath:b,shellArgs:T})}createTerminalFromOptions(_,b){const T=new d.ExtHostTerminal(this._proxy,(0,D.generateUuid)(),_,_.name);return this._terminals.push(T),T.create(_,this._serializeParentTerminal(_,b)),T.value}};e.ExtHostTerminalService=A,e.ExtHostTerminalService=A=je([$e(0,R.IExtHostCommands),$e(1,F.IExtHostRpcService)],A)}),define(Ce[342],De([1,0,9,22,21,8,4,3,128,292,69]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(m,P){try{return JSON.stringify(m,P)}catch{return"null"}}const y="$$ref$$",C={[y]:-1};class w{constructor(P,O){this.jsonString=P,this.referencedBuffers=O}}function s(m,P=null,O=!1){const N=[];return{jsonString:(O?v:JSON.stringify)(m,(U,x)=>{if(typeof x>"u")return C;if(typeof x=="object"){if(x instanceof F.VSBuffer){const M=N.push(x)-1;return{[y]:M}}if(P)return P(U,x)}return x}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=s;function o(m,P,O){return JSON.parse(m,(N,L)=>{if(L){const U=L[y];if(typeof U=="number")return P[U];if(O&&L.$mid===1)return O.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=o;function a(m,P){return JSON.stringify(m,P)}function c(m){return m?(P,O)=>O&&O.$mid===1?m.transformOutgoing(O):O:null}var g;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},n=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends p.Disposable{static{k=n}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(P,O=null,N=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=O,this._uriTransformer=N,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,U=T.ProxyIdentifier.count;L<U;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new D.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{const O=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],O.resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,_.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:O,sid:N}=P;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,N)),this._proxies[O]}_createProxy(P,O){const N={get:(L,U)=>(typeof U=="string"&&!L[U]&&U.charCodeAt(0)===36&&(L[U]=(...x)=>this._remoteCall(P,U,x)),U===r?O:L[U])};return new Proxy(Object.create(null),N)}set(P,O){return this._locals[P.nid]=O,O}assertRegistered(P){for(let O=0,N=P.length;O<N;O++){const L=P[O];if(!this._locals[L.nid])throw new Error(`Missing proxy instance ${L.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const O=P.byteLength,N=f.read(P,0),L=N.readUInt8(),U=N.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:M,args:H}=I.deserializeRequestJSONArgs(N);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(O,U,x,M,H,L===2);break}case 3:case 4:{let{rpcId:x,method:M,args:H}=I.deserializeRequestMixedArgs(N);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(O,U,x,M,H,L===4);break}case 5:{this._logger?.logIncoming(O,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(O,U);break}case 7:{this._receiveReply(O,U,void 0);break}case 9:{let x=I.deserializeReplyOKJSON(N);this._uriTransformer&&(x=(0,_.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(O,U,x);break}case 10:{const x=I.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(O,U,x);break}case 8:{const x=I.deserializeReplyOKVSBuffer(N);this._receiveReply(O,U,x);break}case 11:{let x=I.deserializeReplyErrError(N);this._uriTransformer&&(x=(0,_.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(O,U,x);break}case 12:{this._receiveReplyErr(O,U,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,O,N,L,U,x){this._logger?.logIncoming(P,O,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(N)}.${L}(`,U);const M=String(O);let H,j;if(x){const Y=new d.CancellationTokenSource;U.push(Y.token),H=this._invokeHandler(N,L,U),j=()=>Y.cancel()}else H=this._invokeHandler(N,L,U),j=t;this._cancelInvokedHandlers[M]=j;const fe=I.serializeAcknowledged(O);this._logger?.logOutgoing(fe.byteLength,O,1,"ack"),this._protocol.send(fe),H.then(Y=>{delete this._cancelInvokedHandlers[M];const X=I.serializeReplyOK(O,Y,this._uriReplacer);this._logger?.logOutgoing(X.byteLength,O,1,"reply:",Y),this._protocol.send(X)},Y=>{delete this._cancelInvokedHandlers[M];const X=I.serializeReplyErr(O,Y);this._logger?.logOutgoing(X.byteLength,O,1,"replyErr:",Y),this._protocol.send(X)})}_receiveCancel(P,O){this._logger?.logIncoming(P,O,1,"receiveCancel");const N=String(O);this._cancelInvokedHandlers[N]?.()}_receiveReply(P,O,N){this._logger?.logIncoming(P,O,0,"receiveReply:",N);const L=String(O);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const U=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],U.resolveOk(N)}_receiveReplyErr(P,O,N){this._logger?.logIncoming(P,O,0,"receiveReplyErr:",N);const L=String(O);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const U=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;N&&(N.$isError?(x=new Error,x.name=N.name,x.message=N.message,x.stack=N.stack):x=N),U.resolveErr(x)}_invokeHandler(P,O,N){try{return Promise.resolve(this._doInvokeHandler(P,O,N))}catch(L){return Promise.reject(L)}}_doInvokeHandler(P,O,N){const L=this._locals[P];if(!L)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(P));const U=L[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,T.getStringIdentifierForProxy)(P));return U.apply(L,N)}_remoteCall(P,O,N){if(this._isDisposed)return new b.CanceledLazyPromise;let L=null;if(N.length>0&&d.CancellationToken.isCancellationToken(N[N.length-1])&&(L=N.pop()),L&&L.isCancellationRequested)return Promise.reject(R.canceled());const U=I.serializeRequestArguments(N,this._uriReplacer),x=++this._lastMessageId,M=String(x),H=new b.LazyPromise,j=new p.DisposableStore;L&&j.add(L.onCancellationRequested(()=>{const Y=I.serializeCancel(x);this._logger?.logOutgoing(Y.byteLength,x,0,"cancel"),this._protocol.send(I.serializeCancel(x))})),this._pendingRPCReplies[M]=new l(H,j),this._onWillSendRequest(x);const fe=I.serializeRequest(x,P,O,U,!!L);return this._logger?.logOutgoing(fe.byteLength,x,0,`request: ${(0,T.getStringIdentifierForProxy)(P)}.${O}(`,N),this._protocol.send(fe),H}}e.RPCProtocol=i;class l{constructor(P,O){this._promise=P,this._disposable=O}resolveOk(P){this._promise.resolveOk(P),this._disposable.dispose()}resolveErr(P){this._promise.resolveErr(P),this._disposable.dispose()}}class f{static alloc(P,O,N){const L=new f(F.VSBuffer.alloc(N+1+4),0);return L.writeUInt8(P),L.writeUInt32(O),L}static read(P,O){return new f(P,O)}get buffer(){return this._buff}constructor(P,O){this._buff=P,this._offset=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,N}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,N}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,O}static sizeMixedArray(P){let O=0;O+=1;for(let N=0,L=P.length;N<L;N++){const U=P[N];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let x=0;x<U.buffers.length;++x)O+=this.sizeVSBuffer(U.buffers[x]);break;case 4:break}}return O}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let O=0,N=P.length;O<N;O++){const L=P[O];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let U=0;U<L.buffers.length;++U)this.writeBuffer(L.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(P);for(let N=0;N<P;N++)switch(this.readUInt8()){case 1:O[N]=this.readLongString();break;case 2:O[N]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),x=this.readLongString(),M=[];for(let H=0;H<U;++H)M.push(this.readVSBuffer());O[N]=new T.SerializableObjectWithBuffers(o(x,M,null));break}case 4:O[N]=void 0;break}return O}}var S;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(S||(S={}));class I{static _useMixedArgSerialization(P){for(let O=0,N=P.length;O<N;O++)if(P[O]instanceof F.VSBuffer||P[O]instanceof T.SerializableObjectWithBuffers||typeof P[O]>"u")return!0;return!1}static serializeRequestArguments(P,O){if(this._useMixedArgSerialization(P)){const N=[];for(let L=0,U=P.length;L<U;L++){const x=P[L];if(x instanceof F.VSBuffer)N[L]={type:2,value:x};else if(typeof x>"u")N[L]={type:4};else if(x instanceof T.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:H}=s(x.value,O);N[L]={type:3,value:F.VSBuffer.fromString(M),buffers:H}}else N[L]={type:1,value:F.VSBuffer.fromString(a(x,O))}}return{type:1,args:N}}return{type:0,args:a(P,O)}}static serializeRequest(P,O,N,L,U){switch(L.type){case 0:return this._requestJSONArgs(P,O,N,L.args,U);case 1:return this._requestMixedArgs(P,O,N,L.args,U)}}static _requestJSONArgs(P,O,N,L,U){const x=F.VSBuffer.fromString(N),M=F.VSBuffer.fromString(L);let H=0;H+=f.sizeUInt8(),H+=f.sizeShortString(x),H+=f.sizeLongString(M);const j=f.alloc(U?2:1,P,H);return j.writeUInt8(O),j.writeShortString(x),j.writeLongString(M),j.buffer}static deserializeRequestJSONArgs(P){const O=P.readUInt8(),N=P.readShortString(),L=P.readLongString();return{rpcId:O,method:N,args:JSON.parse(L)}}static _requestMixedArgs(P,O,N,L,U){const x=F.VSBuffer.fromString(N);let M=0;M+=f.sizeUInt8(),M+=f.sizeShortString(x),M+=f.sizeMixedArray(L);const H=f.alloc(U?4:3,P,M);return H.writeUInt8(O),H.writeShortString(x),H.writeMixedArray(L),H.buffer}static deserializeRequestMixedArgs(P){const O=P.readUInt8(),N=P.readShortString(),L=P.readMixedArray(),U=new Array(L.length);for(let x=0,M=L.length;x<M;x++){const H=L[x];typeof H=="string"?U[x]=JSON.parse(H):U[x]=H}return{rpcId:O,method:N,args:U}}static serializeAcknowledged(P){return f.alloc(5,P,0).buffer}static serializeCancel(P){return f.alloc(6,P,0).buffer}static serializeReplyOK(P,O,N){if(typeof O>"u")return this._serializeReplyOKEmpty(P);if(O instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(P,O);if(O instanceof T.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:U}=s(O.value,N,!0);return this._serializeReplyOKJSONWithBuffers(P,L,U)}else return this._serializeReplyOKJSON(P,v(O,N))}static _serializeReplyOKEmpty(P){return f.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,O){let N=0;N+=f.sizeVSBuffer(O);const L=f.alloc(8,P,N);return L.writeVSBuffer(O),L.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,O){const N=F.VSBuffer.fromString(O);let L=0;L+=f.sizeLongString(N);const U=f.alloc(9,P,L);return U.writeLongString(N),U.buffer}static _serializeReplyOKJSONWithBuffers(P,O,N){const L=F.VSBuffer.fromString(O);let U=0;U+=f.sizeUInt32,U+=f.sizeLongString(L);for(const M of N)U+=f.sizeVSBuffer(M);const x=f.alloc(10,P,U);x.writeUInt32(N.length),x.writeLongString(L);for(const M of N)x.writeBuffer(M);return x.buffer}static deserializeReplyOKJSON(P){const O=P.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(P,O){const N=P.readUInt32(),L=P.readLongString(),U=[];for(let x=0;x<N;++x)U.push(P.readVSBuffer());return new T.SerializableObjectWithBuffers(o(L,U,O))}static serializeReplyErr(P,O){const N=O?v(R.transformErrorForSerialization(O),null):void 0;if(typeof N!="string")return this._serializeReplyErrEmpty(P);const L=F.VSBuffer.fromString(N);let U=0;U+=f.sizeLongString(L);const x=f.alloc(11,P,U);return x.writeLongString(L),x.buffer}static deserializeReplyErrError(P){const O=P.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(P){return f.alloc(12,P,0).buffer}}var E;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var h;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(h||(h={}))}),define(Ce[343],De([1,0,4,42,41,5]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new d.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new d.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new d.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var A;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.channels=new Map,this._onDidRegisterChannel=new D.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new D.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(b){this.channels.has(b.id)||(this.channels.set(b.id,b),this._onDidRegisterChannel.fire(b.id))}getChannels(){const b=[];return this.channels.forEach(T=>b.push(T)),b}getChannel(b){return this.channels.get(b)}removeChannel(b){this.channels.delete(b),this._onDidRemoveChannel.fire(b)}}F.Registry.add(e.Extensions.OutputChannels,new p),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new d.RawContextKey("activeOutputChannel","")}),define(Ce[152],De([1,0,6,5,20,25,14,343,72,26,54,178,22,18,30,4,3]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(u,t,n,r,i){super(),this.id=u,this.name=t,this.logger=n,this.proxy=r,this.extension=i,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(n.getLevel()),this._register(n.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,p.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.offset;this.info(u),this.proxy.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(u,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.proxy.$close(this.id)}log(u,t){this.offset+=v.VSBuffer.fromString(t).byteLength,(0,A.log)(this.logger,u,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class a extends o{appendLine(u){this.append(u)}}let c=class{constructor(u,t,n,r,i,l){this.initData=t,this.extHostFileSystem=n,this.extHostFileSystemInfo=r,this.loggerService=i,this.logService=l,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(D.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[t,n]of this.channels)n.visible=t===this.visibleChannelId}createOutputChannel(u,t,n){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,i=(0,y.isString)(t)?t:void 0;if((0,y.isString)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const f=this.initData.environment.extensionLogLevel?.find(([I])=>R.ExtensionIdentifier.equals(n.identifier,I))?.[1];f&&(l=(0,A.parseLogLevel)(f));const S=r?this.doCreateLogOutputChannel(u,l,n):this.doCreateOutputChannel(u,i,n);return S.then(I=>{this.channels.set(I.id,I),I.visible=I.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(u,l??this.logService.getLevel(),S):this.createExtHostOutputChannel(u,S)}async doCreateOutputChannel(u,t,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,i=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.proxy.$register(u,i,t,n.identifier.value);return new o(f,u,l,this.proxy,n)}async doCreateLogOutputChannel(u,t,n){const r=await this.createExtensionLogDirectory(n),i=u.replace(/[\\/:\*\?"<>\|]/g,""),l=this.extHostFileSystemInfo.extUri.joinPath(r,`${i}.log`),f=`${n.identifier.value}.${i}`,S=this.loggerService.createLogger(l,{id:f,name:u,logLevel:t,extensionId:n.identifier.value});return new a(f,u,S,this.proxy,n)}createExtensionLogDirectory(u){let t=this.extensionLogDirectoryPromise.get(u.identifier.value);if(!t){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,u.identifier.value);this.extensionLogDirectoryPromise.set(u.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileExists)throw r}return n})())}return t}createExtHostOutputChannel(u,t){let n=!1;const r=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return u},append(i){r(),t.then(l=>l.append(i))},appendLine(i){r(),t.then(l=>l.appendLine(i))},clear(){r(),t.then(i=>i.clear())},replace(i){r(),t.then(l=>l.replace(i))},show(i,l){r(),t.then(f=>f.show(i,l))},hide(){r(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}createExtHostLogOutputChannel(u,t,n){const r=new s.DisposableStore,i=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},l=r.add(new w.Emitter);function f(S){t=S,l.fire(S)}return n.then(S=>{r.add(S),S.logLevel!==t&&f(S.logLevel),r.add(S.onDidChangeLogLevel(I=>f(I)))}),{...this.createExtHostOutputChannel(u,n),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(S,...I){i(),n.then(E=>E.trace(S,...I))},debug(S,...I){i(),n.then(E=>E.debug(S,...I))},info(S,...I){i(),n.then(E=>E.info(S,...I))},warn(S,...I){i(),n.then(E=>E.warn(S,...I))},error(S,...I){i(),n.then(E=>E.error(S,...I))},dispose(){r.dispose()}}}};e.ExtHostOutputService=c,e.ExtHostOutputService=c=je([$e(0,d.IExtHostRpcService),$e(1,b.IExtHostInitDataService),$e(2,_.IExtHostConsumerFileSystem),$e(3,T.IExtHostFileSystemInfo),$e(4,A.ILoggerService),$e(5,A.ILogService)],c),e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(Ce[344],De([1,0,5,9]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,D.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let R=1/0;for(let p=0;p<this.maxSampleCount;p++){const _=await d.getRoundTripTime();if(_===void 0)return;R=Math.min(R,_/2),await(0,F.timeout)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((p,_)=>p+_,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((p,_)=>p+_,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ce[345],De([1,0,32,17,16,12,24,2,5,258,43,147,344]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let C=y=class{constructor(s,o,a,c){this.localUserHome=s,this.remoteAgentService=o,this.environmentService=a,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||R.OS)(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=g?.userHome??s})()}hasValidBasename(s,o,a){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(c=>this.doHasValidBasename(s,c,o)):this.doHasValidBasename(s,o,a)}doHasValidBasename(s,o,a){return s.scheme===F.Schemas.file||s.scheme===F.Schemas.vscodeRemote?(0,D.isValidBasename)(a??(0,A.basename)(s),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return F.Schemas.vscodeRemote;const a=(0,b.getVirtualWorkspaceScheme)(o.getWorkspace());if(a)return a;const c=o.getWorkspace().folders[0];if(c)return c.uri.scheme;const g=o.getWorkspace().configuration;return g?g.scheme:F.Schemas.file}userHome(s){return s?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?d.win32:d.posix)}async fileURI(s){let o="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const c=s.indexOf("/",2);c===-1?(o=s.substring(2),s="/"):(o=s.substring(2,c),s=s.substring(c)||"/")}return p.URI.from({scheme:F.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.AbstractPathService=C,e.AbstractPathService=C=y=je([$e(1,v.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,T.IWorkspaceContextService)],C)}),define(Ce[346],De([1,0,225,19,56,4,51,3,2,49,230,14,65,260,86,43,147,27,21,18,23,41]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.isCandidatePort=e.OnPortForward=e.makeAddress=e.mapHasAddressLocalhostOrAllInterfaces=e.mapHasAddress=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.parseAddress=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new u.RawContextKey("forwardedPortsViewEnabled",!1,D.localize(0,null));function r(O){const N=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.parseAddress=r;var i;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var l;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.UserTunnelSource={source:l.User,description:D.localize(1,null)},e.AutoTunnelSource={source:l.Auto,description:D.localize(2,null)};function f(O,N,L){const U=O.get(I(N,L));if(U)return U;if((0,C.isLocalhost)(N))for(const x of C.LOCALHOST_ADDRESSES){const M=I(x,L);if(O.has(M))return O.get(M)}else if((0,C.isAllInterfaces)(N))for(const x of C.ALL_INTERFACES_ADDRESSES){const M=I(x,L);if(O.has(M))return O.get(M)}}e.mapHasAddress=f;function S(O,N,L){const U=f(O,N,L);if(U)return U;const x=(0,C.isAllInterfaces)(N)?"localhost":(0,C.isLocalhost)(N)?"0.0.0.0":void 0;if(x)return f(O,x,L)}e.mapHasAddressLocalhostOrAllInterfaces=S;function I(O,N){return O+":"+N}e.makeAddress=I;var E;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(E||(e.OnPortForward=E={}));function h(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.isCandidatePort=h;class m extends p.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.configurationService=N,this.portsAttributes=[],this._onDidChangeAttributes=new R.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(N.onDidChangeConfiguration(L=>{(L.affectsConfiguration(m.SETTING)||L.affectsConfiguration(m.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(N,L,U){let x=this.findNextIndex(N,L,U,this.portsAttributes,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;x>=0;){const H=this.portsAttributes[x];H.key===N?(M.onAutoForward=H.onAutoForward??M.onAutoForward,M.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:M.elevateIfNeeded,M.label=H.label??M.label,M.requireLocalPort=H.requireLocalPort,M.protocol=H.protocol):(M.onAutoForward=M.onAutoForward??H.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:H.elevateIfNeeded,M.label=M.label??H.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??H.protocol),x=this.findNextIndex(N,L,U,this.portsAttributes,x+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.getOtherAttributes()}hasStartEnd(N){return N.start!==void 0&&N.end!==void 0}hasHostAndPort(N){return N.host!==void 0&&N.port!==void 0&&(0,c.isString)(N.host)&&(0,c.isNumber)(N.port)}findNextIndex(N,L,U,x,M){if(M>=x.length)return-1;const H=!(0,C.isLocalhost)(L)&&!(0,C.isAllInterfaces)(L),fe=x.slice(M).findIndex(Y=>(0,c.isNumber)(Y.key)?H?!1:Y.key===N:this.hasStartEnd(Y.key)?H?!1:N>=Y.key.start&&N<=Y.key.end:this.hasHostAndPort(Y.key)?N===Y.key.port&&L===Y.key.host:U?Y.key.test(U):!1);return fe>=0?fe+M:-1}readSetting(){const N=this.configurationService.getValue(m.SETTING);if(!N||!(0,c.isObject)(N))return[];const L=[];for(const x in N){if(x===void 0)continue;const M=N[x];let H;if(Number(x))H=Number(x);else if((0,c.isString)(x))if(m.RANGE.test(x)){const j=x.match(m.RANGE);H={start:Number(j[1]),end:Number(j[2])}}else if(m.HOST_AND_PORT.test(x)){const j=x.match(m.HOST_AND_PORT);H={host:j[1],port:Number(j[2])}}else{let j;try{j=RegExp(x)}catch{}j&&(H=j)}H&&L.push({key:H,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const U=this.configurationService.getValue(m.DEFAULTS);return U&&(this.defaultPortAttributes={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.sortAttributes(L)}sortAttributes(N){function L(U,x){return(0,c.isNumber)(U.key)?U.key:x.hasStartEnd(U.key)?U.key.start:x.hasHostAndPort(U.key)?U.key.port:Number.MAX_VALUE}return N.sort((U,x)=>L(U,this)-L(x,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(N){switch(N){case C.ProvidedOnAutoForward.Notify:return E.Notify;case C.ProvidedOnAutoForward.OpenBrowser:return E.OpenBrowser;case C.ProvidedOnAutoForward.OpenBrowserOnce:return E.OpenBrowserOnce;case C.ProvidedOnAutoForward.OpenPreview:return E.OpenPreview;case C.ProvidedOnAutoForward.Silent:return E.Silent;case C.ProvidedOnAutoForward.Ignore:return E.Ignore;default:return}}async addAttributes(N,L,U){const M=this.configurationService.inspect(m.SETTING).userRemoteValue;let H;!M||!(0,c.isObject)(M)?H={}:H=(0,g.deepClone)(M),H[`${N}`]||(H[`${N}`]={});for(const j in L)H[`${N}`][j]=L[j];return this.configurationService.updateValue(m.SETTING,H,U)}}e.PortsAttributes=m;let P=class extends p.Disposable{constructor(N,L,U,x,M,H,j,fe,Y,X){super(),this.tunnelService=N,this.storageService=L,this.configurationService=U,this.environmentService=x,this.remoteAuthorityResolverService=M,this.workspaceContextService=H,this.logService=j,this.dialogService=fe,this.extensionService=Y,this.contextKeyService=X,this.inProgress=new Map,this._onForwardPort=new R.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new R.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new R.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new R.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new R.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new R.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new m(U),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async z=>{const J=await this.getAttributes(z.map(ge=>({port:ge.tunnelRemotePort,host:ge.tunnelRemoteHost})));for(const ge of z)if(ge.localAddress){const le=I(ge.tunnelRemoteHost,ge.tunnelRemotePort),we=S(this._candidates??new Map,ge.tunnelRemoteHost,ge.tunnelRemotePort);this.forwarded.set(le,{remotePort:ge.tunnelRemotePort,remoteHost:ge.tunnelRemoteHost,localAddress:ge.localAddress,protocol:J?.get(ge.tunnelRemotePort)?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(ge.localAddress,J?.get(ge.tunnelRemotePort)),localPort:ge.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:ge.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(le,ge)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async z=>{const J=I(z.tunnelRemoteHost,z.tunnelRemotePort);if(!S(this.forwarded,z.tunnelRemoteHost,z.tunnelRemotePort)&&!S(this.detected,z.tunnelRemoteHost,z.tunnelRemotePort)&&!S(this.inProgress,z.tunnelRemoteHost,z.tunnelRemotePort)&&z.localAddress){const ge=S(this._candidates??new Map,z.tunnelRemoteHost,z.tunnelRemotePort),le=(await this.getAttributes([{port:z.tunnelRemotePort,host:z.tunnelRemoteHost}]))?.get(z.tunnelRemotePort);this.forwarded.set(J,{remoteHost:z.tunnelRemoteHost,remotePort:z.tunnelRemotePort,localAddress:z.localAddress,protocol:le?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(z.localAddress,le),localPort:z.tunnelLocalPort,closeable:!0,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:z.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(J,z),this._onForwardPort.fire(this.forwarded.get(J))})),this._register(this.tunnelService.onTunnelClosed(z=>this.onTunnelClosed(z,i.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(N=>N.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const N=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&N.dispose()}))}async onTunnelClosed(N,L){const U=I(N.host,N.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.storeForwarded(),this._onClosePort.fire(N))}makeLocalUri(N,L){if(N.startsWith("http"))return _.URI.parse(N);const U=L?.protocol??"http";return _.URI.parse(`${U}://${N}`)}async getStorageKey(){const N=this.workspaceContextService.getWorkspace(),L=N.configuration?(0,A.hash)(N.configuration.path):N.folders.length>0?(0,A.hash)(N.folders[0].uri.path):void 0;if(L===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.environmentService.remoteAuthority}.${L}`}async getTunnelRestoreValue(){const N=this.storageService.get(n,1);if(N)return this.storageService.remove(n,1),await this.storeForwarded(),N;const L=await this.getStorageKey();if(L)return this.storageService.get(L,0)}async restoreForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const N=await this.tunnelRestoreValue;if(N&&N!==this.knownPortsRestoreValue){const L=JSON.parse(N)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${L.map(U=>U.remotePort).join(", ")}`);for(const U of L){const x=S(this.detected,U.remoteHost,U.remotePort);U.source.source!==l.Extension&&!x||U.source.source===l.Extension&&x?await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===l.Extension&&!x&&this.unrestoredExtensionTunnels.set(I(U.remoteHost,U.remotePort),U)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const N=await this.getStorageKey();this.restoreListener=this._register(new p.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async L=>{L.key===N&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(N,0)),await this.restoreForwarded())}))}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.knownPortsRestoreValue){this.knownPortsRestoreValue=N;const L=await this.getStorageKey();L&&this.storageService.store(L,this.knownPortsRestoreValue,0,0)}}}async showPortMismatchModalIfNeeded(N,L,U){if(!N.tunnelLocalPort||!U?.requireLocalPort||N.tunnelLocalPort===L)return;const x=new Date;if(this.mismatchCooldown.getTime()+t>x.getTime())return;this.mismatchCooldown=x;const M=D.localize(3,null,L,N.tunnelRemotePort,N.tunnelLocalPort);return this.dialogService.info(M)}async forward(N,L){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await R.Event.toPromise(this.onRestoreComplete.event),this.doForward(N,L)}async doForward(N,L){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const U=S(this.forwarded,N.remote.host,N.remote.port);L=L??(L!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const x=N.local!==void 0?N.local:N.remote.port;let M;if(U)return this.mergeAttributesIntoExistingTunnel(U,N,L);{const H=this.environmentService.remoteAuthority,j=H?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(H)).authority}:void 0,fe=I(N.remote.host,N.remote.port);this.inProgress.set(fe,!0),N=this.mergeCachedAndUnrestoredProperties(fe,N);const Y=await this.tunnelService.openTunnel(j,N.remote.host,N.remote.port,void 0,x,N.elevateIfNeeded?N.elevateIfNeeded:L?.elevateIfNeeded,N.privacy,L?.protocol);if(typeof Y=="string")M=Y;else if(Y&&Y.localAddress){const X=S(this._candidates??new Map,N.remote.host,N.remote.port),z=Y.protocol?Y.protocol===C.TunnelProtocol.Https?C.TunnelProtocol.Https:C.TunnelProtocol.Http:L?.protocol??C.TunnelProtocol.Http,J={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:L?.label??N.name,closeable:!0,localAddress:Y.localAddress,protocol:z,localUri:await this.makeLocalUri(Y.localAddress,L),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:N.source??e.UserTunnelSource,privacy:Y.privacy};return this.forwarded.set(fe,J),this.remoteTunnels.set(fe,Y),this.inProgress.delete(fe),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(Y,x,L),this._onForwardPort.fire(J),Y}this.inProgress.delete(fe)}return M}mergeCachedAndUnrestoredProperties(N,L){const U=this.unrestoredExtensionTunnels.has(N)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(N)?this.sessionCachedProperties:void 0;if(U){const x=U.get(N);U.delete(N),x&&(L.name=x.name??L.name,L.local=("local"in x?x.local:"localPort"in x?x.localPort:void 0)??L.local,L.privacy=x.privacy??L.privacy)}return L}async mergeAttributesIntoExistingTunnel(N,L,U){const x=U?.label??L.name;let M;(function(j){j[j.None=0]="None",j[j.Fire=1]="Fire",j[j.Reopen=2]="Reopen"})(M||(M={}));let H=M.None;switch(x!==N.name&&(N.name=x,H=M.Fire),(U?.protocol||N.protocol!==C.TunnelProtocol.Http)&&U?.protocol!==N.protocol&&(L.source=N.source,H=M.Reopen),L.privacy&&N.privacy!==L.privacy&&(H=M.Reopen),H){case M.Fire:{this._onForwardPort.fire();break}case M.Reopen:await this.close(N.remoteHost,N.remotePort,i.User),await this.doForward(L,U)}return S(this.remoteTunnels,L.remote.host,L.remote.port)}async name(N,L,U){const x=S(this.forwarded,N,L),M=I(N,L);if(x){x.name=U,await this.storeForwarded(),this._onPortName.fire({host:N,port:L});return}else this.detected.has(M)&&(this.detected.get(M).name=U,this._onPortName.fire({host:N,port:L}))}async close(N,L,U){const x=I(N,L),M=this.forwarded.get(x);return U===i.AutoForwardEnd&&M&&M.source.source===l.Auto&&this.sessionCachedProperties.set(x,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.tunnelService.closeTunnel(N,L),this.onTunnelClosed({host:N,port:L},U)}address(N,L){const U=I(N,L);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(N){if(N)for(const L of N){const U=S(this._candidates??new Map,L.remoteAddress.host,L.remoteAddress.port),x=typeof L.localAddress=="string"?L.localAddress:I(L.localAddress.host,L.localAddress.port);this.detected.set(I(L.remoteAddress.host,L.remoteAddress.port),{remoteHost:L.remoteAddress.host,remotePort:L.remoteAddress.port,localAddress:x,protocol:C.TunnelProtocol.Http,localUri:this.makeLocalUri(x),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:C.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:D.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(L.remoteAddress.host,L.remoteAddress.port,x,C.TunnelPrivacyId.ConstantPrivate,C.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(N){this._candidateFilter=N}async setCandidates(N){let L=N;this._candidateFilter&&(L=await this._candidateFilter(N));const U=this.updateInResponseToCandidates(L);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(x=>x.port).join(", ")}`),this._onCandidatesChanged.fire(U)}updateInResponseToCandidates(N){const L=this._candidates??new Map,U=new Map;return this._candidates=U,N.forEach(x=>{const M=I(x.host,x.port);U.set(M,{host:x.host,port:x.port,detail:x.detail,pid:x.pid}),L.has(M)&&L.delete(M);const H=S(this.forwarded,x.host,x.port);H&&(H.runningProcess=x.detail,H.hasRunningProcess=!0,H.pid=x.pid)}),L.forEach((x,M)=>{const H=r(M);if(!H)return;const j=S(this.forwarded,H.host,H.port);j&&(j.runningProcess=void 0,j.hasRunningProcess=!1,j.pid=void 0);const fe=S(this.detected,H.host,H.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),L}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const N=Array.from(this.forwarded.values()),L=await this.getAttributes(N.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(L)for(const U of N){const x=L.get(U.remotePort);(x?.protocol||U.protocol!==C.TunnelProtocol.Http)&&x?.protocol!==U.protocol&&await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},x),x&&x.label&&x.label!==U.name&&await this.name(U.remoteHost,U.remotePort,x.label)}}async getAttributes(N,L=!0){const U=new Map,x=new Map;N.forEach(Y=>{const X=S(this._candidates??new Map,C.LOCALHOST_ADDRESSES[0],Y.port)??Y;if(X){U.set(Y.port,X);const z=h(X)?X.pid:void 0;x.has(z)||x.set(z,[]),x.get(z)?.push(Y.port)}});const M=new Map;if(N.forEach(Y=>{const X=this.configPortsAttributes.getAttributes(Y.port,Y.host,U.get(Y.port)?.detail);X&&M.set(Y.port,X)}),this.portAttributesProviders.length===0||!L)return M.size>0?M:void 0;const H=await Promise.all((0,F.flatten)(this.portAttributesProviders.map(Y=>Array.from(x.entries()).map(X=>{const z=X[1],J=U.get(z[0]);return Y.providePortAttributes(z,J?.pid,J?.detail,new a.CancellationTokenSource().token)})))),j=new Map;if(H.forEach(Y=>Y.forEach(X=>{X&&j.set(X.port,X)})),!M&&!j)return;const fe=new Map;return N.forEach(Y=>{const X=M.get(Y.port),z=j.get(Y.port);fe.set(Y.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??m.providedActionToAction(z?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),fe}addAttributesProvider(N){this.portAttributesProviders.push(N)}};e.TunnelModel=P,je([(0,d.debounce)(1e3)],P.prototype,"storeForwarded",null),e.TunnelModel=P=je([$e(0,C.ITunnelService),$e(1,y.IStorageService),$e(2,b.IConfigurationService),$e(3,s.IWorkbenchEnvironmentService),$e(4,v.IRemoteAuthorityResolverService),$e(5,w.IWorkspaceContextService),$e(6,k.ILogService),$e(7,T.IDialogService),$e(8,o.IExtensionService),$e(9,u.IContextKeyService)],P)}),define(Ce[93],De([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class D{constructor(A,p){this.line=A,this.character=p}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,p){return new D(0,0)}with(A){return new D(0,0)}}e.Position=D;class F{constructor(A,p,_,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,p),this.end=new D(_,b)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var d;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(Ce[36],De([1,0,19,35,23,32,15,5,16,8,93,9]),function(pe,e,D,F,d,R,A,p,_,b,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",y=" characters skipped \u27EB",C=(v.length+y.length+5)*2;e.ISearchService=(0,p.createDecorator)("searchService");var w;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(w||(e.SearchProviderType=w={}));var s;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(s||(e.QueryType=s={}));function o(z){return!!z.preview}e.resultIsMatch=o;function a(z){return!!z.resource}e.isFileMatch=a;function c(z){return!!z.message}e.isProgressMessage=c;var g;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(g||(e.SearchCompletionExitCode=g={}));class u{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=u;class t{constructor(J,ge,le,we){this.ranges=ge,this.webviewIndex=we;const G=Array.isArray(ge)?ge:[ge];if(le&&le.matchLines===1&&n(G)){J=(0,A.getNLines)(J,le.matchLines);let B="",V=0,me=0;const Z=Math.floor(le.charsPerLine/5),ne=[];for(const re of G){const ye=Math.max(re.startColumn-Z,0),oe=re.startColumn+le.charsPerLine;if(ye>me+Z+C){const de=v+(ye-me)+y;B+=de+J.slice(ye,oe),V+=ye-(me+de.length)}else B+=J.slice(me,oe);ne.push(new i(0,re.startColumn-V,re.endColumn-V)),me=oe}this.preview={text:B,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const B=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:J,matches:(0,D.mapArrayOrNot)(ge,V=>new r(V.startLineNumber-B,V.startColumn,V.endLineNumber-B,V.endColumn))}}}}e.TextSearchMatch=t;function n(z){const J=z[0].startLineNumber;for(const ge of z)if(ge.startLineNumber!==J||ge.endLineNumber!==J)return!1;return!0}class r{constructor(J,ge,le,we){this.startLineNumber=J,this.startColumn=ge,this.endLineNumber=le,this.endColumn=we}}e.SearchRange=r;class i extends r{constructor(J,ge,le){super(J,ge,J,le)}}e.OneLineRange=i;var l;(function(z){z.List="list",z.Tree="tree"})(l||(e.ViewMode=l={}));var f;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function S(z,J=!0){const ge=z&&z.files&&z.files.exclude,le=J&&z&&z.search&&z.search.exclude;if(!ge&&!le)return;if(!ge||!le)return ge||le;let we=Object.create(null);return we=d.mixin(we,d.deepClone(ge)),we=d.mixin(we,d.deepClone(le),!0),we}e.getExcludes=S;function I(z,J){return z.excludePattern&&F.match(z.excludePattern,J)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&F.match(z.includePattern,J)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(ge=>{const le=ge.folder.fsPath;if(R.isEqualOrParent(J,le)){const we=_.relative(le,J);return!ge.includePattern||!!F.match(ge.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=I;var E;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class h extends Error{constructor(J,ge){super(J),this.code=ge}}e.SearchError=h;function m(z){const J=z.message;if((0,b.isCancellationError)(z))return new h(J,E.canceled);try{const ge=JSON.parse(J);return new h(ge.message,ge.code)}catch{return new h(J,E.other)}}e.deserializeSearchError=m;function P(z){const J={message:z.message,code:z.code};return new Error(JSON.stringify(J))}e.serializeSearchError=P;function O(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=O;function N(z){return z.type==="success"}e.isSerializedSearchSuccess=N;function L(z){return!!z.path}e.isSerializedFileMatch=L;function U(z,J){const ge=z.searchPath?z.searchPath:z.relativePath;return(0,A.fuzzyContains)(ge,J)}e.isFilePatternMatch=U;class x{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function M(z,J){const ge={...z||{},...J||{}};return Object.keys(ge).filter(le=>{const we=ge[le];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=M;class H{constructor(J,ge){this._parsedIncludeExpression=null,this._excludeExpression={...J.excludePattern||{},...ge.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let le=J.includePattern;ge.includePattern&&(le?le={...le,...ge.includePattern}:le=ge.includePattern),le&&(this._parsedIncludeExpression=F.parse(le))}matchesExcludesSync(J,ge,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,ge,le))}includedInQuerySync(J,ge,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,ge,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(J,ge,le))}includedInQuery(J,ge,le){const we=this._parsedExcludeExpression(J,ge,le),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(J,ge,le):!0;return(0,k.isThenable)(we)?we.then(B=>B?!1:G()):G()}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=H;function j(z){for(const J in z)if(typeof z[J]!="boolean")return!0;return!1}function fe(z){if(!z)return;let J;return ge=>(J||(J=(z()||Promise.resolve([])).then(le=>le?X(le):{})),J.then(le=>!!le[ge]))}e.hasSiblingPromiseFn=fe;function Y(z){if(!z)return;let J;return ge=>{if(!J){const le=z();J=le?X(le):{}}return!!J[ge]}}e.hasSiblingFn=Y;function X(z){const J={};for(const ge of z)J[ge]=!0;return J}}),define(Ce[39],De([1,0,19,9,21,4,3,78,17,120,24,15,2,214,5,14,243,43,54,26,20,13,7,67,36,6]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(O,N,L){return new T.ExtUri(U=>E(U,L)).isEqual(O,N)}function f(O,N,L){return l(O.uri,N.uri,L)?0:(0,k.compare)(O.uri.toString(),N.uri.toString())}function S(O,N,L){return O.index!==N.index?O.index<N.index?-1:1:l(O.uri,N.uri,L)?(0,k.compare)(O.name,N.name):(0,k.compare)(O.uri.toString(),N.uri.toString())}function I(O,N,L,U){const x=O.slice(0).sort((H,j)=>L(H,j,U)),M=N.slice(0).sort((H,j)=>L(H,j,U));return(0,D.delta)(x,M,(H,j)=>L(H,j,U))}function E(O,N){const L=N.getCapabilities(O.scheme);return!(L&&L&1024)}class h extends o.Workspace{static toExtHostWorkspace(N,L,U,x){if(!N)return{workspace:null,added:[],removed:[]};const{id:M,name:H,folders:j,configuration:fe,transient:Y,isUntitled:X}=N,z=[],J=L;L?j.forEach((G,B)=>{const V=v.URI.revive(G.uri),me=h._findFolder(U||L,V,x);me?(me.name=G.name,me.index=G.index,z.push(me)):z.push({uri:V,name:G.name,index:B})}):z.push(...j.map(({uri:G,name:B,index:V})=>({uri:v.URI.revive(G),name:B,index:V}))),z.sort((G,B)=>G.index<B.index?-1:1);const ge=new h(M,H,z,!!Y,fe?v.URI.revive(fe):null,!!X,G=>E(G,x)),{added:le,removed:we}=I(J?J.workspaceFolders:[],ge.workspaceFolders,f,x);return{workspace:ge,added:le,removed:we}}static _findFolder(N,L,U){for(let x=0;x<N.folders.length;x++){const M=N.workspaceFolders[x];if(l(M.uri,L,U))return M}}constructor(N,L,U,x,M,H,j){super(N,U.map(fe=>new o.WorkspaceFolder(fe)),x,M,j),this._name=L,this._isUntitled=H,this._workspaceFolders=[],this._structure=p.TernarySearchTree.forUris(j),U.forEach(fe=>{this._workspaceFolders.push(fe),this._structure.set(fe.uri,fe)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,L){return L&&this._structure.get(N)&&(N=(0,T.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let m=class{constructor(N,L,U,x,M){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new R.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=x,this._extHostFileSystemInfo=U,this._uriTransformerService=M,this._requestIdProvider=new b.Counter,this._barrier=new F.Barrier,this._proxy=N.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(i.MainContext.MainThreadMessageService);const H=L.workspace;this._confirmedWorkspace=H?new h(H.id,H.name,[],!!H.transient,H.configuration?v.URI.revive(H.configuration):null,!!H.isUntitled,j=>E(j,U)):void 0}$initializeWorkspace(N,L){this._trusted=L,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:_.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,L,U,...x){const M=[];if(Array.isArray(x)&&x.forEach(X=>{v.URI.isUri(X.uri)&&!M.some(z=>l(z.uri,X.uri,this._extHostFileSystemInfo))&&M.push({uri:X.uri,name:X.name||(0,T.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[L,U].some(X=>typeof X!="number"||X<0)||U===0&&M.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+U>H.length)return!1;const j=H.slice(0);j.splice(L,U,...M.map(X=>({uri:X.uri,name:X.name||(0,T.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<j.length;X++){const z=j[X];if(j.some((J,ge)=>ge!==X&&l(z.uri,J.uri,this._extHostFileSystemInfo)))return!1}j.forEach((X,z)=>X.index=z);const{added:fe,removed:Y}=I(H,j,S,this._extHostFileSystemInfo);if(fe.length===0&&Y.length===0)return!1;if(this._proxy){const X=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(X,L,U,M).then(void 0,z=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(s.Severity.Error,(0,y.localize)(0,null,X,z.toString()),J,[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(N,L){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,L)}async getWorkspaceFolder2(N,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,L)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,L){let U,x="";if(typeof N=="string"?(U=v.URI.file(N),x=N):typeof N<"u"&&(U=N,x=N.fsPath),!U)return x;const M=this.getWorkspaceFolder(U,!0);if(!M)return x;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let H=(0,T.relativePath)(M.uri,U);return L&&M.name&&(H=`${M.name}/${H}`),H}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:L,added:U,removed:x}=h.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:x}))}findFiles(N,L,U,x,M=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let H;if(L===null?H=!1:L&&(typeof L=="string"?H=L:H=L.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:fe}=P(u.GlobPattern.from(N));return this._proxy.$startFileSearch(j??null,fe??null,H??null,U??null,M).then(Y=>Array.isArray(Y)?Y.map(X=>v.URI.revive(X)):[])}async findTextInFiles(N,L,U,x,M=d.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),j=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:fe,folder:Y}=P(u.GlobPattern.from(L.include)),X=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,z={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:j,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:fe,excludePattern:X},J=!1;if(this._activeSearchCallbacks[H]=ge=>{if(J)return;const le=v.URI.revive(ge.resource);ge.results.forEach(we=>{(0,r.resultIsMatch)(we)?U({uri:le,preview:{text:we.preview.text,matches:(0,D.mapArrayOrNot)(we.preview.matches,G=>new t.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,D.mapArrayOrNot)(we.ranges,G=>new t.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):U({uri:le,text:we.text,lineNumber:we.lineNumber})})},M.isCancellationRequested)return{};try{const ge=await this._proxy.$startTextSearch(N,Y??null,z,H,M);return delete this._activeSearchCallbacks[H],ge||{}}catch(ge){throw delete this._activeSearchCallbacks[H],ge}}$handleTextSearchResult(N,L){this._activeSearchCallbacks[L]?.(N)}async save(N){const L=await this._proxy.$save(N,{saveAs:!1});return v.URI.revive(L)}async saveAs(N){const L=await this._proxy.$save(N,{saveAs:!0});return v.URI.revive(L)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(N,L){if(this._editSessionIdentityProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._editSessionIdentityProviders.set(N,L);const U=this._uriTransformerService.transformOutgoingScheme(N),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,U),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(N),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(N,L){this._logService.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(v.URI.revive(N));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const x=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!x),!x)return;const M=await x.provideEditSessionIdentity(U,L);if(this._logService.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(N,L,U,x){this._logService.info("Getting edit session identifier for workspaceFolder",N);const M=await this.resolveWorkspaceFolder(v.URI.revive(N));if(!M){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const H=this._editSessionIdentityProviders.get(M.uri.scheme);if(this._logService.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!H),!H)return;const j=await H.provideEditSessionIdentityMatch?.(L,U,x);if(this._logService.info("Provider returned edit session identifier match result: ",j),!!j)return j}getOnWillCreateEditSessionIdentityEvent(N){return(L,U,x)=>{const M=function(j){L.call(U,j)};return M.extension=N,this._onWillCreateEditSessionIdentityEvent.event(M,void 0,x)}}async $onWillCreateEditSessionIdentity(N,L,U){const x=await this.resolveWorkspaceFolder(v.URI.revive(N));if(x===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:x},L,async(M,H)=>{const j=Date.now();await Promise.resolve(M),Date.now()-j>U&&this._logService.warn("SLOW edit session create-participant",H.extension.identifier)}),L.isCancellationRequested}registerCanonicalUriProvider(N,L){if(this._canonicalUriProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._canonicalUriProviders.set(N,L);const U=this._uriTransformerService.transformOutgoingScheme(N),x=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(x,U),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(N),this._proxy.$unregisterCanonicalUriProvider(x)})}async provideCanonicalUri(N,L,U){const x=this._canonicalUriProviders.get(N.scheme);if(!x)return;const M=await x.provideCanonicalUri?.(v.URI.revive(N),L,U);if(M)return M}async $provideCanonicalUri(N,L,U){return this.provideCanonicalUri(v.URI.revive(N),{targetScheme:L},U)}};e.ExtHostWorkspace=m,e.ExtHostWorkspace=m=je([$e(0,g.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,a.IExtHostFileSystemInfo),$e(3,w.ILogService),$e(4,n.IURITransformerService)],m),e.IExtHostWorkspace=(0,C.createDecorator)("IExtHostWorkspace");function P(O){let N,L;return O&&(typeof O=="string"?N=O:(N=O.pattern,L=v.URI.revive(O.baseUri))),{includePattern:N,folder:L}}}),define(Ce[40],De([1,0,23,4,39,6,7,245,136,18,9,5,20,14,2]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(n,r){if(r){const i=r.split(".");let l=n;for(let f=0;l&&f<i.length;f++)l=l[i[f]];return l}}function s(n){return n instanceof C.URI}function o(n){return n&&n.uri instanceof C.URI&&n.languageId&&typeof n.languageId=="string"}function a(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function c(n){return n&&n.uri instanceof C.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function g(n){if(s(n))return{resource:n};if(o(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(a(n))return{overrideIdentifier:n.languageId};if(c(n))return{resource:n.uri};if(n===null)return{resource:null}}let u=class{constructor(r,i,l){this._proxy=r.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=l,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,i))}};e.ExtHostConfiguration=u,e.ExtHostConfiguration=u=je([$e(0,v.IExtHostRpcService),$e(1,d.IExtHostWorkspace),$e(2,y.ILogService)],u);class t{constructor(r,i,l,f){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=i,this._configuration=p.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=p.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,l))}getConfiguration(r,i,l){const f=g(i)||{},S=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,l?.identifier);function I(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const E={has(h){return typeof w(S,h)<"u"},get:(h,m)=>{this._validateConfigurationAccess(r?`${r}.${h}`:h,f,l?.identifier);let P=w(S,h);if(typeof P>"u")P=m;else{let O;const N=(L,U)=>{if((0,b.isObject)(L)){let x;const M=()=>{O=O||(0,D.deepClone)(S),x=x||w(O,U)};return new Proxy(L,{get:(H,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return M(),()=>x;if(O)return x=x||w(O,U),x[j];const fe=H[j];return typeof j=="string"?N(fe,`${U}.${j}`):fe},set:(H,j,fe)=>(M(),x&&(x[j]=fe),!0),deleteProperty:(H,j)=>(M(),x&&delete x[j],!0),defineProperty:(H,j,fe)=>(M(),x&&Object.defineProperty(x,j,fe),!0)})}return Array.isArray(L)?(0,D.deepClone)(L):L};P=N(P,h)}return P},update:(h,m,P,O)=>{h=r?`${r}.${h}`:h;const N=I(P);return m!==void 0?this._proxy.$updateConfigurationOption(N,h,m,f,O):this._proxy.$removeConfigurationOption(N,h,f,O)},inspect:h=>{h=r?`${r}.${h}`:h;const m=this._configuration.inspect(h,f,this._extHostWorkspace.workspace);if(m)return{key:h,defaultValue:(0,D.deepClone)(m.policy?.value??m.default?.value),globalValue:(0,D.deepClone)(m.user?.value??m.application?.value),workspaceValue:(0,D.deepClone)(m.workspace?.value),workspaceFolderValue:(0,D.deepClone)(m.workspaceFolder?.value),defaultLanguageValue:(0,D.deepClone)(m.default?.override),globalLanguageValue:(0,D.deepClone)(m.user?.override??m.application?.override),workspaceLanguageValue:(0,D.deepClone)(m.workspace?.override),workspaceFolderLanguageValue:(0,D.deepClone)(m.workspaceFolder?.override),languageIds:(0,D.deepClone)(m.overrideIdentifiers)}}};return typeof S=="object"&&(0,D.mixin)(E,S,!1),Object.freeze(E)}_toReadonlyValue(r){const i=l=>(0,b.isObject)(l)?new Proxy(l,{get:(f,S)=>i(f[S]),set:(f,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(f,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(f,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return i(r)}_validateConfigurationAccess(r,i,l){const f=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),S=l?`[${l.value}] `:"";if(f===4){typeof i?.resource>"u"&&this._logService.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this._logService.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const l=new p.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,S)=>l.affectsConfiguration(f,g(S))})}_toMap(r){return r.reduce((i,l)=>(i.set(l[0],l[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")}),define(Ce[94],De([1,0,2,9,4,6,7,39,70,40,21,44,20,26,5,17,12,14,90,291,8]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(u||(u={}));var t;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(t||(t={}));var n;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(n||(n={}));var r;(function(N){function L(M){if(M){const H=M;return H&&!!H.process}else return!1}N.is=L;function U(M){if(M==null)return;const H={process:M.process,args:M.args};return M.options&&(H.options=n.from(M.options)),H}N.from=U;function x(M){if(M!=null)return new A.ProcessExecution(M.process,M.args,M.options)}N.to=x})(r||(r={}));var i;(function(N){function L(x){if(x!=null)return x}N.from=L;function U(x){if(x!=null)return x}N.to=U})(i||(i={}));var l;(function(N){function L(M){if(M){const H=M;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=L;function U(M){if(M==null)return;const H={};return M.commandLine!==void 0?H.commandLine=M.commandLine:(H.command=M.command,H.args=M.args),M.options&&(H.options=i.from(M.options)),H}N.from=U;function x(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.ShellExecution(M.commandLine,M.options):new A.ShellExecution(M.command,M.args?M.args:[],M.options)}N.to=x})(l||(l={}));var f;(function(N){function L(M){if(M){const H=M;return H&&H.customExecution==="customExecution"}else return!1}N.is=L;function U(M){return{customExecution:"customExecution"}}N.from=U;function x(M,H){return H.get(M)}N.to=x})(f||(e.CustomExecutionDTO=f={}));var S;(function(N){function L(U,x){let M;return U.scope!==void 0&&typeof U.scope!="number"?M=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===A.TaskScope.Workspace&&x&&x.workspaceFile?M=x.workspaceFile:M=c.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:M}}N.from=L})(S||(e.TaskHandleDTO=S={}));var I;(function(N){function L(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}N.from=L})(I||(I={}));var E;(function(N){function L(M,H){if(M==null)return[];const j=[];for(const fe of M){const Y=U(fe,H);Y&&j.push(Y)}return j}N.fromMany=L;function U(M,H){if(M==null)return;let j;M.execution instanceof A.ProcessExecution?j=r.from(M.execution):M.execution instanceof A.ShellExecution?j=l.from(M.execution):M.execution&&M.execution instanceof A.CustomExecution&&(j=f.from(M.execution));const fe=u.from(M.definition);let Y;return M.scope?typeof M.scope=="number"?Y=M.scope:Y=M.scope.uri:Y=A.TaskScope.Workspace,!fe||!Y?void 0:{_id:M._id,definition:fe,name:M.name,source:{extensionId:H.identifier.value,label:M.source,scope:Y},execution:j,isBackground:M.isBackground,group:I.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=U;async function x(M,H,j){if(M==null)return;let fe;r.is(M.execution)?fe=r.to(M.execution):l.is(M.execution)?fe=l.to(M.execution):f.is(M.execution)&&(fe=f.to(M._id,j));const Y=u.to(M.definition);let X;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?X=M.source.scope:X=await H.resolveWorkspaceFolder(D.URI.revive(M.source.scope)):X=A.TaskScope.Workspace),!Y||!X)return;const z=new A.Task(Y,X,M.name,M.source.label,fe,M.problemMatchers);return M.isBackground!==void 0&&(z.isBackground=M.isBackground),M.group!==void 0&&(z.group=A.TaskGroup.from(M.group._id),z.group&&M.group.isDefault&&(z.group=new A.TaskGroup(z.group.id,z.group.label),M.group.isDefault===!0&&(z.group.isDefault=M.group.isDefault))),M.presentationOptions&&(z.presentationOptions=t.to(M.presentationOptions)),M._id&&(z._id=M._id),M.detail&&(z.detail=M.detail),z}N.to=x})(E||(e.TaskDTO=E={}));var h;(function(N){function L(x){return x}N.from=L;function U(x){if(x)return Object.assign(Object.create(null),x)}N.to=U})(h||(h={}));class m{#e;constructor(L,U,x){this._id=U,this._task=x,this.#e=L}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let P=class{constructor(L,U,x,M,H,j,fe,Y){this._onDidExecuteTask=new d.Emitter,this._onDidTerminateTask=new d.Emitter,this._onDidTaskProcessStarted=new d.Emitter,this._onDidTaskProcessEnded=new d.Emitter,this._proxy=L.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=M,this._configurationService=H,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=fe,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(L,U,x){if(!x)return new A.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:U,provider:x,extension:L}),this._proxy.$registerTaskProvider(M,U),new A.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(L,U){this._proxy.$registerTaskSystem(L,U)}fetchTasks(L){return this._proxy.$fetchTasks(h.from(L)).then(async U=>{const x=[];for(const M of U){const H=await E.to(M,this._workspaceProvider,this._providedCustomExecutions2);H&&x.push(H)}return x})}get taskExecutions(){const L=[];return this._taskExecutions.forEach(U=>L.push(U)),L}terminateTask(L){if(!(L instanceof m))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(L._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(L,U,x){const M=this._providedCustomExecutions2.get(L.id);M&&(this._activeCustomExecutions2.set(L.id,M),this._terminalService.attachPtyToTerminal(U,await M.callback(x))),this._lastStartedTask=L.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(L)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(L){const U=await this.getTaskExecution(L);this._taskExecutionPromises.delete(L.id),this._taskExecutions.delete(L.id),this.customExecutionComplete(L),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(L){const U=await this.getTaskExecution(L.id);this._onDidTaskProcessStarted.fire({execution:U,processId:L.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(L){const U=await this.getTaskExecution(L.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:L.exitCode})}$provideTasks(L,U){const x=this._handlers.get(L);if(!x)return Promise.reject(new Error("no handler found"));const M=[],H=(0,F.asPromise)(()=>x.provider.provideTasks(T.CancellationToken.None)).then(j=>this.provideTasksInternal(U,M,x,j));return new Promise(j=>{H.then(fe=>{Promise.all(M).then(()=>{j(fe)})})})}async $resolveTask(L,U){const x=this._handlers.get(L);if(!x)return Promise.reject(new Error("no handler found"));if(U.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${x.type}].`);const M=await E.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const H=await x.provider.resolveTask(M,T.CancellationToken.None);if(!H)return;this.checkDeprecation(H,x);const j=E.from(H,x.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(j.execution)&&await this.addCustomExecution(j,H,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(L,U,x){const M=await this._proxy.$createTaskId(L);!x&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,U.execution)),this._providedCustomExecutions2.set(M,U.execution)}async getTaskExecution(L,U){if(typeof L=="string"){const H=this._taskExecutionPromises.get(L);if(!H)throw new g.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const x=this._taskExecutionPromises.get(L.id);if(x)return x;const M=new Promise((H,j)=>{function fe(Y,X,z){z?H(new m(Y,X.id,z)):j("Unexpected: Task does not exist.")}U?fe(this,L,U):E.to(L.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>fe(this,L,Y))});return this._taskExecutionPromises.set(L.id,M),M.then(H=>(this._taskExecutions.set(L.id,H),H),H=>Promise.reject(H))}checkDeprecation(L,U){L._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(L){this._activeCustomExecutions2.get(L.id)&&this._activeCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.has(L.id)&&this._lastStartedTask!==L.id&&(this._providedCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.delete(L.id));const x=this._notProvidedCustomExecutions.values();let M=x.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=x.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=je([$e(0,v.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,p.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,b.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,o.ILogService),$e(7,a.IExtHostApiDeprecationService)],P);let O=class extends P{constructor(L,U,x,M,H,j,fe,Y){super(L,U,x,M,H,j,fe,Y),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(0)})}async executeTask(L,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const x=E.from(U,L);if(x===void 0)throw new Error("Task is not valid");if(f.is(x.execution))await this.addCustomExecution(x,U,!1);else throw new g.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),U);return this._proxy.$executeTask(x).catch(H=>{throw new Error(H)}),M}provideTasksInternal(L,U,x,M){const H=[];if(M)for(const j of M){this.checkDeprecation(j,x),(!j.definition||!L[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=E.from(j,x.extension);fe&&f.is(fe.execution)?(H.push(fe),U.push(this.addCustomExecution(fe,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:x.extension}}async resolveTaskInternal(L){if(f.is(L.execution))return L;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(L,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,U,x){}};e.WorkerExtHostTask=O,e.WorkerExtHostTask=O=je([$e(0,v.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,p.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,b.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,o.ILogService),$e(7,a.IExtHostApiDeprecationService)],O),e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(Ce[347],De([1,0,16,21,46,35,24,37,36]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class b{constructor(v,y,C){this.config=v,this.provider=y,this.sessionToken=C,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&R.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const y=this.config.folderQueries||[];return new Promise((C,w)=>{const s=o=>{this.resultCount++,v(o)};if(this.isCanceled)return C({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const a=o.toString(),c=D.basename(a);this.globalExcludePattern&&this.globalExcludePattern(a,c)||this.matchFile(s,{base:o,basename:c})}),Promise.all(y.map(o=>this.searchInFolder(o,s))).then(o=>{C({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{w(new Error((0,d.toErrorMessage)(o)))})})}async searchInFolder(v,y){const C=new F.CancellationTokenSource,w=this.getSearchOptionsForFolder(v),s=this.initDirectoryTree(),o=new _.QueryGlobTester(this.config,v),a=!o.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(C),c=p.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,C.token),u=c.elapsed(),t=p.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(n=>{const r=D.posix.relative(v.folder.path,n.path);if(a){const i=D.basename(n.path);this.matchFile(y,{base:v.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(s,v.folder,r,y)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(s,o,y),{providerTime:u,postProcessTime:t.elapsed()})}finally{C.dispose(),this.activeCancellationTokens.delete(C)}}getSearchOptionsForFolder(v){const y=(0,_.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),C=(0,_.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:C,includes:y,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},y,C,w){if(C===this.filePattern){const o=D.basename(this.filePattern);this.matchFile(w,{base:y,relativePath:this.filePattern,basename:o})}function s(o){const a=D.basename(o),c=D.dirname(o);let g=v[c];g||(g=v[c]=[],s(c)),g.push({base:y,relativePath:o,basename:a})}s(C)}matchDirectoryTree({rootEntries:v,pathToEntries:y},C,w){const s=this,o=this.filePattern;function a(c){const g=(0,_.hasSiblingFn)(()=>c.map(u=>u.basename));for(let u=0,t=c.length;u<t;u++){const n=c[u],{relativePath:r,basename:i}=n;if(C.matchesExcludesSync(r,i,o!==i?g:void 0))continue;const l=y[r];if(l)a(l);else{if(r===o)continue;s.matchFile(w,n)}if(s.isLimitHit)break}}a(v)}matchFile(v,y){(!this.includePattern||y.relativePath&&this.includePattern(y.relativePath,y.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(y))}}class T{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(v,y,C,w){const s=this.getSessionTokenSource(v.cacheKey),o=new b(v,y,s&&s.token);let a=0;const c=g=>{a+=g.length,C(g.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(o,T.BATCH_SIZE,c,w).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:g.stats}}))}clearCache(v){this.getSessionTokenSource(v)?.cancel()}getSessionTokenSource(v){if(v)return this.sessions.has(v)||this.sessions.set(v,new F.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:A.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,y,C,w){const s=w.onCancellationRequested(()=>{v.cancel()}),o=c=>{c&&(a.push(c),y>0&&a.length>=y&&(C(a),a=[]))};let a=[];return v.search(o).then(c=>(a.length&&C(a),s.dispose(),c),c=>(a.length&&C(a),s.dispose(),Promise.reject(c)))}}e.FileSearchManager=T}),define(Ce[348],De([1,0,19,74,35,100,28,17,16,24,15,18,2,172,226,49,14,43,143,345,36]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(h,m,P,O,N){this.configurationService=h,this.workspaceContextService=m,this.editorGroupsService=P,this.logService=O,this.pathService=N}text(h,m,P={}){h=this.getContentPattern(h,P);const O=this.configurationService.getValue(),N=m&&m.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(m?.map(o.toWorkspaceFolder),P),type:2,contentPattern:h,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(h,m){const P=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const O={...h,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(h,m)&&(O.isCaseSensitive=!0),this.isMultiline(h)&&(O.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),O}file(h,m={}){return{...this.commonQuery(h,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}handleIncludeExclude(h,m){return h?(h=Array.isArray(h)?h.map(l):l(h),m?this.parseSearchPaths(h):{pattern:n(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],m={}){const P=this.handleIncludeExclude(m.includePattern,m.expandPatterns),O=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),N=h.length>1,L=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,m,O)):h.map(M=>this.getFolderQueryForRoot(M,m,O,N))).filter(M=>!!M),U={_reason:m._reason,folderQueries:L,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:O.pattern,includePattern:P.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const M=D.coalesce(D.flatten(this.editorGroupsService.groups.map(fe=>fe.editors.map(Y=>Y.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const H=M.filter(fe=>(0,g.pathIncludedInQuery)(U,fe.fsPath)),j=this.commonQueryFromFileList(H);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...U,...j}}const x=m.extraFileResources&&m.extraFileResources.filter(M=>(0,g.pathIncludedInQuery)(U,M.fsPath));return U.extraFileResources=x&&x.length?x:void 0,U}commonQueryFromFileList(h){const m=[],P=new A.ResourceMap,O={};let N=!1;return h.forEach(L=>{if(L.scheme===p.Schemas.walkThrough)return;if((0,b.isAbsolutePath)(L)){const x=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:_.dirname(L.fsPath)});let M=P.get(x);M||(N=!0,M={folder:x,includePattern:{}},m.push(M),P.set(x,M));const H=_.relative(x.fsPath,L.fsPath);(0,k.assertIsDefined)(M.includePattern)[H.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,O[L.fsPath]=!0)}),{folderQueries:m,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(h,m){if(m.isSmartCase){if(h.isRegExp){if(T.containsUppercaseCharacter(h.pattern,!0))return!0}else if(T.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,y.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const m=j=>_.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),O=(Array.isArray(h)?h:r(h)).map(j=>{const fe=this.pathService.resolvedUserHome;return fe?(0,R.untildify)(j,fe.scheme===p.Schemas.file?fe.fsPath:fe.path):j}),N=F.groupBy(O,j=>m(j)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(j=>T.rtrim(j,"/")).map(j=>T.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),i(j))),U={},x=this.expandSearchPathPatterns(N.searchPaths||[]);x&&x.length&&(U.searchPaths=x);const M=D.flatten(L),H=n(...M);return H&&(U.pattern=H),U}getExcludesForFolder(h,m){return m.disregardExcludeSettings?void 0:(0,g.getExcludes)(h,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const m=h.flatMap(O=>{let{pathPortion:N,globPortion:L}=t(O);return L&&(L=f(L)),this.expandOneSearchPath(N).flatMap(x=>this.resolveOneSearchPathPattern(x,L))}),P=new Map;return m.forEach(O=>{const N=O.searchPath.toString(),L=P.get(N);L?O.pattern&&(L.pattern=L.pattern||{},L.pattern[O.pattern]=!0):P.set(N,{searchPath:O.searchPath,pattern:O.pattern?n(O.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(h){if(_.isAbsolute(h)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==p.Schemas.file?[{searchPath:m[0].uri.with({path:h})}]:[{searchPath:v.URI.file(_.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=l(h),h.startsWith("../")||h===".."){const O=_.posix.resolve(m.path,h);return[{searchPath:m.with({path:O})}]}const P=f(h);return[{searchPath:m,pattern:P}]}else{if(h==="./"||h===".\\")return[];{const m=h.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(N=>{const L=m.match(new RegExp(`^${T.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(k.isDefined);if(O.length)return O.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&f(L)}});{const N=h.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:h,U=C.localize(0,null,L);throw new Error(U)}}}}resolveOneSearchPathPattern(h,m){const P=h.pattern&&m?`${h.pattern}/${m}`:h.pattern||m,O=[{searchPath:h.searchPath,pattern:P}];return P&&!P.endsWith("**")&&O.push({searchPath:h.searchPath,pattern:P+"/**"}),O}getFolderQueryForSearchPath(h,m,P){const O=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(h.searchPath),m,P,!1);return O?{...O,includePattern:h.pattern}:null}getFolderQueryForRoot(h,m,P,O){let N;const L=v.URI.isUri(h)?h:h.uri;if(P.searchPaths){const j=P.searchPaths.filter(fe=>(0,b.isEqual)(fe.searchPath,L))[0];if(j&&!j.pattern)return null;j&&(N=j.pattern)}const U=this.configurationService.getValue({resource:L}),M={...this.getExcludesForFolder(U,m)||{},...N||{}},H=v.URI.isUri(h)?(0,b.basename)(h):h.name;return{folder:L,folderName:O?H:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!U.search.followSymlinks}}};e.QueryBuilder=u,e.QueryBuilder=u=je([$e(0,w.IConfigurationService),$e(1,o.IWorkspaceContextService),$e(2,a.IEditorGroupsService),$e(3,s.ILogService),$e(4,c.IPathService)],u);function t(E){const h=E.match(/[\*\{\}\(\)\[\]\?]/);if(h){const m=h.index,P=E.substr(0,m).match(/[/|\\][^/\\]*$/);if(P){let O=E.substr(0,P.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:E.substr((P.index||0)+1)}}}return{pathPortion:E}}function n(...E){return E.length?E.reduce((h,m)=>(h[m]=!0,h),Object.create(null)):void 0}function r(E){return d.splitGlobAware(E,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(E){return[`**/${E}/**`,`**/${E}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function l(E){return E.replace(/\\/g,"/")}function f(E){return l(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(E){return E.replace(/([?*[\]])/g,"[$1]")}function I(E,h){E=D.distinct(E,O=>O.toString());const m=[],P=h.getWorkspace();return E&&E.forEach(O=>{let N;if(h.getWorkbenchState()===2)N=(0,b.relativePath)(P.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const L=h.getWorkspaceFolder(O);if(L){const U=L.name;if(P.folders.filter(M=>M.name===U).length===1){const M=(0,b.relativePath)(L.uri,O);M===""?N=`./${L.name}`:N=`./${L.name}/${M}`}else N=O.fsPath}}N&&m.push(S(N))}),m}e.resolveResourcesForSearchIncludes=I}),define(Ce[349],De([1,0,24,2,21,8,5,348,36,43]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(w,s){const o=s.activationEvents;if(!o)return Promise.resolve(void 0);const a=[],c=[];for(const i of o)if(/^workspaceContains:/.test(i)){const l=i.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?c.push(l):a.push(l)}if(a.length===0&&c.length===0)return Promise.resolve(void 0);let g;const u=new Promise((i,l)=>{g=i}),t=i=>g({activationEvent:i}),n=Promise.all(a.map(i=>v(w,i,t))).then(()=>{}),r=y(w,s.identifier,c,t);return Promise.all([n,r]).then(()=>{g(void 0)}),u}e.checkActivateWorkspaceContainsExtension=k;async function v(w,s,o){for(const a of w.folders)if(await w.exists(D.joinPath(F.URI.revive(a),s))){o(`workspaceContains:${s}`);return}}async function y(w,s,o,a){if(o.length===0)return Promise.resolve(void 0);const c=new d.CancellationTokenSource,g=w.checkExists(w.folders,o,c.token),u=setTimeout(async()=>{c.cancel(),w.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},T);let t=!1;try{t=await g}catch(n){R.isCancellationError(n)||R.onUnexpectedError(n)}c.dispose(),clearTimeout(u),t&&a(`workspaceContains:${o.join(",")}`)}function C(w,s,o,a){const c=w.get(A.IInstantiationService),g=w.get(_.ISearchService),t=c.createInstance(p.QueryBuilder).file(s.map(n=>(0,b.toWorkspaceFolder)(F.URI.revive(n))),{_reason:"checkExists",includePattern:o,exists:!0});return g.fileSearch(t,a).then(n=>!!n.limitHit,n=>R.isCancellationError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=C}),define(Ce[45],De([1,0,204,16,53,24,9,3,78,2,14,6,40,286,115,39,27,148,8,25,22,262,7,65,5,26,91,20,105,73,44,4,349,114,264,17,112,37,12,113]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n,r,i,l,f,S,I,E,h,m,P,O,N,L,U,x,M){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let j=H=class extends p.Disposable{constructor(G,B,V,me,Z,ne,re,ye,oe,de,ee,ue){super(),this._extHostManagedSockets=ue,this._onDidChangeRemoteConnectionData=this._register(new h.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=B,this._extHostContext=V,this._initData=re,this._extHostWorkspace=me,this._extHostConfiguration=Z,this._logService=ne,this._extHostTunnelService=oe,this._extHostTerminalService=de,this._extHostLocalizationService=ee,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new le(this._initData.extensions.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const ve=new c.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,J(this._globalRegistry,ve)),x.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${X(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${X(this._myRegistry)}`)),this._storage=new C.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=G.createChild(new S.ServiceCollection([C.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState])),this._activator=this._register(new y.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ke,$,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ke,a.transformErrorForSerialization($),K)},actualActivateExtension:async(ke,$)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(ke,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ke,$),new y.HostExtension;const K=this._myRegistry.getExtensionDescription(ke);return this._activateExtension(K,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),d.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){a.onUnexpectedError(G)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._myRegistry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(G)}terminate(G,B=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${G}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),a.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const V=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),V]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${B}`):this._logService.info(`Extension host exiting with code ${B}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(B)})}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}async getExtension(G){const B=await this._mainThreadExtensionsProxy.$getExtension(G);return B&&{...B,identifier:new c.ExtensionIdentifier(B.identifier.value),extensionLocation:b.URI.revive(B.extensionLocation)}}_activateByEvent(G,B){return this._activator.activateByEvent(G,B)}_activateById(G,B){return this._activator.activateById(G,B)}activateByIdWithErrors(G,B){return this._activateById(G,B).then(()=>{const V=this._activator.getActivatedExtension(G);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._myRegistry)}getExtensionExports(G){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(G).exports;try{return this._activator.getActivatedExtension(G).exports}catch{return null}}async _realPathExtensionUri(G){if(G.scheme===N.Schemas.file&&this._hostUtils.fsRealpath){const B=await this._hostUtils.fsRealpath(G.fsPath);return b.URI.file(B)}return G}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(G=>new ge(G))),this._extensionPathIndex}async _createExtensionPathIndex(G){const B=_.TernarySearchTree.forUris(V=>R.extUriBiasedIgnorePathCase.ignorePathCasing(V));return await Promise.all(G.map(async V=>{if(this._getEntryPoint(V)){const me=await this._realPathExtensionUri(V.extensionLocation);B.set(me,V)}})),B}_deactivate(G){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return B;const V=this._activator.getActivatedExtension(G);if(!V)return B;try{typeof V.module.deactivate=="function"&&(B=Promise.resolve(V.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(me)}try{(0,p.dispose)(V.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(me)}return B}async _activateExtension(G,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,B).then(V=>{const me=V.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,B),this._logExtensionActivationTimes(G,B,"success",me),V},V=>{throw this._logExtensionActivationTimes(G,B,"failure"),V})}_logExtensionActivationTimes(G,B,V,me){const Z=Y(G,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...me||{},outcome:V})}_doActivateExtension(G,B){const V=Y(G,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",V);const me=this._getEntryPoint(G);if(!me)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${G.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this._logService.flush();const Z=new y.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(G,(0,R.joinPath)(G.extensionLocation,me),Z),this._loadExtensionContext(G)]).then(ne=>(d.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),H._callActivate(this._logService,G.identifier,ne[0],ne[1],Z))).then(ne=>(d.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ne))}_loadExtensionContext(G){const B=new u.ExtensionGlobalMemento(G,this._storage),V=new u.ExtensionMemento(G.identifier.value,!1,this._storage),me=new O.ExtensionSecrets(G,this._secretState),Z=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ne=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([B.whenReady,V.whenReady,this._storagePath.whenReady]).then(()=>{const re=this;let ye,oe;const de=(0,s.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(c.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:V,secrets:me,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return F.join(G.extensionLocation.fsPath,ee)},get storagePath(){return re._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return re._storagePath.globalValue(G).fsPath},get logPath(){return F.join(re._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return b.URI.joinPath(re._initData.logsLocation,G.identifier.value)},get storageUri(){return re._storagePath.workspaceValue(G)},get globalStorageUri(){return re._storagePath.globalValue(G)},get extensionMode(){return Z},get extension(){return ye===void 0&&(ye=new z(re,G.identifier,G,ne,!1)),ye},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(G,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!oe){if(!de)return;const ee=h.Event.buffer(h.Event.fromDOMEventEmitter(de,"message",ue=>ue.data));de.start(),oe={onDidReceiveMessage:ee,postMessage:de.postMessage.bind(de)}}return oe}})})}static _callActivate(G,B,V,me,Z){return V=V||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,B,V,me,Z).then(ne=>new y.ActivatedExtension(!1,null,Z.build(),V,ne,me.subscriptions))}static _callActivateOptional(G,B,V,me,Z){if(typeof V.activate=="function")try{Z.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ne=typeof global=="object"?global:self,re=V.activate.apply(ne,[me]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(re).then(ye=>(Z.activateResolveStop(),ye))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(V)}_activateOneStartupFinished(G,B){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:B}).then(void 0,V=>{this._logService.error(V)})}_activateAllStartupFinishedDeferred(G,B=0){const me=Date.now();(0,x.setTimeout0)(()=>{for(let Z=B;Z<G.length;Z+=1){const ne=G[Z];for(const re of ne.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-me>50){this._activateAllStartupFinishedDeferred(G,Z);break}else this._activateOneStartupFinished(ne,re)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(d.getMarks()),this._extHostConfiguration.getConfigProvider().then(G=>{const B=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),V=this._myRegistry.getAllExtensionDescriptions();if(B)this._activateAllStartupFinishedDeferred(V);else for(const me of V)if(me.activationEvents)for(const Z of me.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(me,Z)})}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],V=this._handleWorkspaceContainsEagerExtensions(B),me=this._handleRemoteResolverEagerExtensions(),Z=Promise.all([me,G,V]).then(()=>{});return Promise.race([Z,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(G,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,B){if(this.isActivated(B.identifier))return;const V=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:G.map(ne=>ne.uri),forceUsingSearch:V||!this._hostUtils.fsExists,exists:ne=>this._hostUtils.fsExists(ne.fsPath),checkExists:(ne,re,ye)=>this._mainThreadWorkspaceProxy.$checkExists(ne,re,ye)},Z=await(0,m.checkActivateWorkspaceContainsExtension)(me,B);if(Z)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Z.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:B}=this._initData.environment;if(!G||!B)throw new Error(D.localize(0,null));const V=await this._loadCommonJSModule(null,B,new y.ExtensionActivationTimesBuilder(!1));if(!V||typeof V.run!="function")throw new Error(D.localize(1,null,B.toString()));return new Promise((me,Z)=>{const ne=(oe,de)=>{oe?(x.isCI&&this._logService.error("Test runner called back with error",oe),Z(oe)):(x.isCI&&(de?this._logService.info(`Test runner called back with ${de} failures.`):this._logService.info("Test runner called back with successful outcome.")),me(typeof de=="number"&&de>0?1:0))},re=(0,R.originalFSPath)(B),ye=V.run(re,ne);ye&&ye.then&&ye.then(()=>{x.isCI&&this._logService.info("Test runner finished successfully."),me(0)}).catch(oe=>{x.isCI&&this._logService.error("Test runner finished with error",oe),Z(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,B){return this._resolvers[G]=B,(0,p.toDisposable)(()=>{delete this._resolvers[G]})}async getRemoteExecServer(G){const{resolver:B}=await this._activateAndGetResolver(G);return B?.resolveExecServer?.(G,{resolveAttempt:0})}async _activateAndGetResolver(G){const B=G.indexOf("+");if(B===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const V=G.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${V}`,!1),{authorityPrefix:V,resolver:this._resolvers[V]}}async $resolveAuthority(G,B){const V=U.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,n.getRemoteAuthorityPrefix)(G)},${B})][${V.elapsed()}ms] `,Z=se=>this._logService.info(`${me()}${se}`),ne=se=>this._logService.warn(`${me()}${se}`),re=(se,Q=void 0)=>this._logService.error(`${me()}${se}`,Q),ye=se=>{if(se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},oe=async se=>{Z(`activating resolver for ${se}...`);const{resolver:Q,authorityPrefix:he}=await this._activateAndGetResolver(se);if(!Q)throw re(`no resolver for ${he}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${he}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:he,remoteAuthority:se}},de=G.split(/@|%40/g).reverse();Z(`activating remote resolvers ${de.join(" -> ")}`);let ee;try{ee=await Promise.all(de.map(oe)).catch(async se=>{if(!(se instanceof t.RemoteAuthorityResolverError)||se._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ne(`resolving nested authorities failed: ${se.message}`),[await oe(G)]})}catch(se){return ye(se)}const ue=new A.IntervalTimer;ue.cancelAndSet(()=>Z("waiting..."),1e3);let ve,ke;for(const[se,{authorityPrefix:Q,resolver:he,remoteAuthority:Se}]of ee.entries())try{if(se===ee.length-1)Z("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${Q}`),ve=await he.resolve(Se,{resolveAttempt:B,execServer:ke}),d.mark(`code/extHost/didResolveAuthorityOK/${Q}`),Z("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(he,t.ManagedResolvedAuthority.isManagedResolvedAuthority(ve)?ve:void 0));else{if(Z(`invoking resolveExecServer() for ${Se}`),d.mark(`code/extHost/willResolveExecServer/${Q}`),ke=await he.resolveExecServer?.(Se,{resolveAttempt:B,execServer:ke}),!ke)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${Se}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(Ue){return d.mark(`code/extHost/didResolveAuthorityError/${Q}`),re("returned an error",Ue),ue.dispose(),ye(Ue)}ue.dispose();const $={environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures},K={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};Z(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(ve)?"managed authority":`${ve.host}:${ve.port}`}`);let ie;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(ve)){const se=B;this._extHostManagedSockets.setFactory(se,ve.makeConnection),ie={authority:G,connectTo:new n.ManagedRemoteConnection(se),connectionToken:ve.connectionToken}}else ie={authority:G,connectTo:new n.WebSocketRemoteConnection(ve.host,ve.port),connectionToken:ve.connectionToken};return{type:"ok",value:{authority:ie,options:K,tunnelInformation:$}}}async $getCanonicalURI(G,B){this._logService.info(`$getCanonicalURI invoked for authority (${(0,n.getRemoteAuthorityPrefix)(G)})`);const{resolver:V}=await this._activateAndGetResolver(G);if(!V)return null;const me=b.URI.revive(B);if(typeof V.getCanonicalURI>"u")return me;const Z=await(0,A.asPromise)(()=>V.getCanonicalURI(me));return Z||me}$startExtensionHost(G){G.toAdd.forEach(me=>me.extensionLocation=b.URI.revive(me.extensionLocation));const{globalRegistry:B,myExtensions:V}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,G);return this._globalRegistry.set(B.getAllExtensionDescriptions()),this._myRegistry.set(V),x.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${X(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(G,B){return B===1?this._almostReadyToRunExtensions.wait().then(V=>this._activateByEvent(G,!1)):this._readyToRunExtensions.wait().then(V=>this._activateByEvent(G,!1))}async $activate(G,B){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(G)?(await this._activateById(G,B),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ne=>ne.extensionLocation=b.URI.revive(ne.extensionLocation));const{globalRegistry:B,myExtensions:V}=fe(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),me=await this._createExtensionPathIndex(V);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(B.getAllExtensionDescriptions()),this._myRegistry.set(V),x.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${X(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const B=g.VSBuffer.alloc(G),V=Math.random()%256;for(let me=0;me<G;me++)B.writeUInt8(V,me);return B}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=j,e.AbstractExtHostExtensionService=j=H=je([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,v.IExtHostConfiguration),$e(5,T.ILogService),$e(6,i.IExtHostInitDataService),$e(7,l.IExtensionStoragePaths),$e(8,I.IExtHostTunnelService),$e(9,E.IExtHostTerminalService),$e(10,L.IExtHostLocalizationService),$e(11,M.IExtHostManagedSockets)],j);function fe(we,G,B,V){we.addActivationEvents(V.addActivationEvents);const me=new o.ExtensionDescriptionRegistry(we,G.getAllExtensionDescriptions());me.deltaExtensions(V.toAdd,V.toRemove);const Z=new c.ExtensionIdentifierSet(B.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of V.myToRemove)Z.delete(re);for(const re of V.myToAdd)Z.add(re);const ne=J(me,Z);return{globalRegistry:me,myExtensions:ne}}function Y(we,G){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function X(we){return we.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class z{#e;#t;#i;constructor(G,B,V,me,Z){this.#e=G,this.#t=B,this.#i=V.identifier,this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=F.normalize((0,R.originalFSPath)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=me,this.isFromDifferentExtensionHost=Z}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=z;function J(we,G){return we.getAllExtensionDescriptions().filter(B=>G.has(B.identifier))}class ge{constructor(G){this._searchTree=G}setSearchTree(G){this._searchTree=G}findSubstr(G){return this._searchTree.findSubstr(G)}forEach(G){return this._searchTree.forEach(G)}}e.ExtensionPaths=ge;class le{constructor(G){this._map=new c.ExtensionIdentifierMap,this.addActivationEvents(G)}readActivationEvents(G){return this._map.get(G.identifier)}addActivationEvents(G){for(const B of Object.keys(G))this._map.set(B,G[B])}}}),define(Ce[350],De([1,0,53,2,6,40,27,25,20,26,5,45,14,15]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(g,u,t,n,r,i,l){this._apiFactory=g,this._extensionRegistry=u,this._instaService=t,this._extHostConfiguration=n,this._extHostExtensionService=r,this._initData=i,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),D.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,u,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,u,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const u of g.nodeModuleName)this._factories.set(u,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(u=>g.alternativeModuleName(u))}};e.RequireInterceptor=w,e.RequireInterceptor=w=je([$e(2,T.IInstantiationService),$e(3,R.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,b.IExtHostInitDataService),$e(6,v.ILogService)],w);let s=class{static{C=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(g){if(g.environment.appRoot&&C.aliased.size){const u=(0,y.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${u}/${r}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const u=this.re.exec(this.forceForwardSlashes(g));if(!u)return;const[,t,n,r]=u,i=C.aliased.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+r}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};s=C=je([$e(0,b.IExtHostInitDataService)],s);class o{constructor(g,u,t,n,r){this._apiFactory=g,this._extensionPaths=u,this._extensionRegistry=t,this._configProvider=n,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new p.ExtensionIdentifierMap}load(g,u){const t=this._extensionPaths.findSubstr(u);if(t){let n=this._extApiImpl.get(t.identifier);return n||(n=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((r,i)=>n+=`	${i} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let a=class{constructor(g,u,t){this._extensionPaths=g,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(d.MainContext.MainThreadTelemetry);const n=t.getProxy(d.MainContext.MainThreadWindow);this._impl=(r,i)=>{const l=F.URI.parse(r);return i?this.callOriginal(r,i):l.scheme==="http"||l.scheme==="https"?n.$openUri(l,r,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?n.$openUri(l,r,{}):this.callOriginal(r,i)}}load(g,u,t){const n=this._extensionPaths.findSubstr(u);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=t(g),this._impl}callOriginal(g,u){return this.sendNoForwardTelemetry(),this._original(g,u)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=je([$e(2,_.IExtHostRpcService)],a)}),define(Ce[55],De([1,0,58,3,16,47,5,70,71,45,7,39,278,40]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class C extends v.AbstractVariableResolverService{constructor(o,a,c,g,u,t,n){function r(){if(c){const i=c.activeEditor();if(i)return i.document.uri;const l=g.tabGroups.all.find(f=>f.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof T.TextDiffTabInput||l.input instanceof T.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof T.TextTabInput||l.input instanceof T.NotebookEditorTabInput||l.input instanceof T.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:i=>{const l=t.folders.filter(f=>f.name===i);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,l)=>u.getConfiguration(void 0,i).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=r();if(i)return d.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const i=r();if(i){const l=a.getWorkspaceFolder(i);if(l)return d.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(c){const i=c.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(c){const i=c.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let w=class extends F.Disposable{constructor(o,a,c,g,u){super(),this.extensionService=o,this.workspaceService=a,this.editorService=c,this.configurationService=g,this.editorTabs=u,this._resolver=new D.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new C(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=w,e.ExtHostVariableResolverProviderService=w=je([$e(0,b.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,p.IExtHostDocumentsAndEditors),$e(3,y.IExtHostConfiguration),$e(4,_.IExtHostEditorTabs)],w)}),define(Ce[95],De([1,0,9,4,2,5,6,71,45,20,7,39,140,271,40,55]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,r,i,l,f,S){this._workspaceService=r,this._extensionService=i,this._configurationService=l,this._editorTabs=f,this._variableResolver=S,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new F.Emitter,this._onDidTerminateDebugSession=new F.Emitter,this._onDidChangeActiveDebugSession=new F.Emitter,this._onDidReceiveDebugSessionCustomEvent=new F.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new F.Emitter,this._onDidChangeStackFrameFocus=new F.Emitter,this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(E=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}asDebugSourceUri(n,r){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let l=`debug:${encodeURIComponent(i.path||"")}`,f="?";return r&&(l+=`${f}session=${encodeURIComponent(r.id)}`,f="&"),l+=`${f}ref=${i.sourceReference}`,d.URI.parse(l)}else{if(i.path)return d.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const r=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const l=i.contributes.debuggers;if(l&&l.length>0)for(const f of l)(0,y.isDebuggerMainContribution)(f)&&r.push(f.type)}this._debugServiceProxy.$registerDebugTypes(r)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const n=[];return this._breakpoints.forEach(r=>n.push(r)),n}addBreakpoints(n){const r=n.filter(f=>{const S=f.id;return this._breakpoints.has(S)?!1:(this._breakpoints.set(S,f),!0)});this.fireBreakpointChanges(r,[],[]);const i=[],l=new Map;for(const f of r)if(f instanceof T.SourceBreakpoint){let S=l.get(f.location.uri.toString());S||(S={type:"sourceMulti",uri:f.location.uri,lines:[]},l.set(f.location.uri.toString(),S),i.push(S)),S.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof T.FunctionBreakpoint&&i.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(n){const r=n.filter(S=>this._breakpoints.delete(S.id));this.fireBreakpointChanges([],r,[]);const i=r.filter(S=>S instanceof T.SourceBreakpoint).map(S=>S.id),l=r.filter(S=>S instanceof T.FunctionBreakpoint).map(S=>S.id),f=r.filter(S=>S instanceof T.DataBreakpoint).map(S=>S.id);return this._debugServiceProxy.$unregisterBreakpoints(i,l,f)}startDebugging(n,r,i){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,r,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,r,i){if(!r)return new T.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:l,provider:r}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,i,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,l),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(f=>f.provider!==r),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(n,r,i){if(!i)return new T.Disposable(()=>{});if(!this.definesDebugType(n,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.getAdapterDescriptorFactoryByType(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:r,handle:l,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(r,l),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(f=>f.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(n,r){if(!r)return new T.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:i,factory:r}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==r)})}async $runInTerminal(n,r){return Promise.resolve(void 0)}async $substituteVariables(n,r){let i;const l=await this.getFolder(n);return l&&(i={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,r)}createDebugAdapter(n,r){if(n.type==="implementation")return new g(n.implementation)}createSignService(){}async $startDASession(n,r){const i=this,l=await this.getSession(r);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const S=this.convertToDto(f),I=this.createDebugAdapter(S,l);if(!I)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const E=I;return this._debugAdapters.set(n,E),this.getDebugAdapterTrackers(l).then(h=>(h&&this._debugAdaptersTrackers.set(n,h),E.onMessage(async m=>{if(m.type==="request"&&m.command==="handshake"){const P=m,O={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(P.arguments.value);O.body={signature:N},E.sendResponse(O)}else throw new Error("no signer")}catch(N){O.success=!1,O.message=N.message,E.sendResponse(O)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(m),m=(0,y.convertToVSCPaths)(m,!0),i._debugServiceProxy.$acceptDAMessage(n,m)}),E.onError(m=>{h&&h.onError&&h.onError(m),this._debugServiceProxy.$acceptDAError(n,m.name,m.message,m.stack)}),E.onExit(m=>{h&&h.onExit&&h.onExit(m??void 0,void 0),this._debugServiceProxy.$acceptDAExit(n,m??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),E.startSession()))})}$sendDAMessage(n,r){r=(0,y.convertToDAPaths)(r,!1);const i=this._debugAdaptersTrackers.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(r),this._debugAdapters.get(n)?.sendMessage(r)}$stopDASession(n){const r=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),r&&r.onWillStopSession&&r.onWillStopSession();const i=this._debugAdapters.get(n);return this._debugAdapters.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const r=[],i=[],l=[];if(n.added)for(const f of n.added){const S=f.id;if(S&&!this._breakpoints.has(S)){let I;if(f.type==="function")I=new T.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")I=new T.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const E=d.URI.revive(f.uri);I=new T.SourceBreakpoint(new T.Location(E,new T.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,T.setBreakpointId)(I,S),this._breakpoints.set(S,I),r.push(I)}}if(n.removed)for(const f of n.removed){const S=this._breakpoints.get(f);S&&(this._breakpoints.delete(f),i.push(S))}if(n.changed){for(const f of n.changed)if(f.id){const S=this._breakpoints.get(f.id);if(S){if(S instanceof T.FunctionBreakpoint&&f.type==="function"){const I=S;I.enabled=f.enabled,I.condition=f.condition,I.hitCondition=f.hitCondition,I.logMessage=f.logMessage,I.functionName=f.functionName}else if(S instanceof T.SourceBreakpoint&&f.type==="source"){const I=S;I.enabled=f.enabled,I.condition=f.condition,I.hitCondition=f.hitCondition,I.logMessage=f.logMessage,I.location=new T.Location(d.URI.revive(f.uri),new T.Position(f.line,f.character))}l.push(S)}}}this.fireBreakpointChanges(r,i,l)}async $acceptStackFrameFocus(n){let r;const i=n.sessionId?await this.getSession(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?r=new T.ThreadFocus(i,n.threadId):r=new T.StackFrameFocus(i,n.threadId,n.frameId),this._stackFrameFocus=r,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(n,r,i){return(0,D.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.getFolder(r);return l.provideDebugConfigurations(f,i)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(n,r,i,l){return(0,D.asPromise)(async()=>{const f=this.getConfigProviderByHandle(n);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.getFolder(r);return f.resolveDebugConfiguration(S,i,l)})}$resolveDebugConfigurationWithSubstitutedVariables(n,r,i,l){return(0,D.asPromise)(async()=>{const f=this.getConfigProviderByHandle(n);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.getFolder(r);return f.resolveDebugConfigurationWithSubstitutedVariables(S,i,l)})}async $provideDebugAdapter(n,r){const i=this.getAdapterDescriptorFactoryByHandle(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(r);return this.getAdapterDescriptor(i,l).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(f)})}async $acceptDebugSessionStarted(n){const r=await this.getSession(n);this._onDidStartDebugSession.fire(r)}async $acceptDebugSessionTerminated(n){const r=await this.getSession(n);r&&(this._onDidTerminateDebugSession.fire(r),this._debugSessions.delete(r.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,r){(await this.getSession(n))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(n,r){const l={session:await this.getSession(n),event:r.event,body:r.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(n){if(n instanceof T.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof T.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const r=this._adapterFactories.filter(i=>i.type===n);if(r.length>0)return r[0].factory}getAdapterDescriptorFactoryByHandle(n){const r=this._adapterFactories.filter(i=>i.handle===n);if(r.length>0)return r[0].factory}getConfigProviderByHandle(n){const r=this._configProviders.filter(i=>i.handle===n);if(r.length>0)return r[0].provider}definesDebugType(n,r){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const l of i)if(l.label&&l.type&&l.type===r)return!0}}return!1}getDebugAdapterTrackers(n){const i=n.configuration.type,l=this._trackerFactories.filter(f=>f.type===i||f.type==="*").map(f=>(0,D.asPromise)(()=>f.factory.createDebugAdapterTracker(n)).then(S=>S,S=>null));return Promise.race([Promise.all(l).then(f=>{const S=f.filter(I=>!!I);if(S.length>0)return new c(S)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async getAdapterDescriptor(n,r){const i=r.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new T.DebugAdapterServer(i));if(n){const f=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>n.createDebugAdapterDescriptor(r,this.daExecutableFromPackage(r,f))).then(S=>{if(S)return S})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(r,l))}daExecutableFromPackage(n,r){}fireBreakpointChanges(n,r,i){(n.length>0||r.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:r,changed:i}))}async getSession(n){if(n)if(typeof n=="string"){const r=this._debugSessions.get(n);if(r)return r}else{let r=this._debugSessions.get(n.id);if(!r){const i=await this.getFolder(n.folderUri),l=n.parent?this._debugSessions.get(n.parent):void 0;r=new o(this._debugServiceProxy,n.id,n.type,n.name,i,n.configuration,l),this._debugSessions.set(r.id,r),this._debugServiceProxy.$sessionCached(r.id)}return r}throw new Error("cannot find session")}getFolder(n){if(n){const r=d.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=s,e.ExtHostDebugServiceBase=s=je([$e(0,b.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,_.IExtHostExtensionService),$e(3,C.IExtHostConfiguration),$e(4,p.IExtHostEditorTabs),$e(5,w.IExtHostVariableResolverProvider)],s);class o{constructor(n,r,i,l,f,S,I){this._debugServiceProxy=n,this._id=r,this._type=i,this._name=l,this._workspaceFolder=f,this._configuration=S,this._parentSession=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,r){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,r)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=o;class a{constructor(n){this.value=Object.freeze({append(r){n.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.ExtHostDebugConsole=a;class c{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(r=>r.onError?r.onError(n):void 0)}onExit(n,r){this.trackers.forEach(i=>i.onExit?i.onExit(n,r):void 0)}}class g extends v.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends s{constructor(n,r,i,l,f,S){super(n,r,i,l,f,S)}};e.WorkerExtHostDebugService=u,e.WorkerExtHostDebugService=u=je([$e(0,b.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,_.IExtHostExtensionService),$e(3,C.IExtHostConfiguration),$e(4,p.IExtHostEditorTabs),$e(5,w.IExtHostVariableResolverProvider)],u)}),define(Ce[351],De([1,0,8,53,2,6,342,14,104,105,26,238,20,67,45,89]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class s{static async installEarlyHandler(c){Error.stackTraceLimit=100;const g=c.get(p.ILogService),t=c.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);D.setUnexpectedErrorHandler(n=>{g.error(n);const r=D.transformErrorForSerialization(n);t.$onUnexpectedError(r)})}static async installFullHandler(c){const g=c.get(p.ILogService),u=c.get(v.IExtHostRpcService),t=c.get(C.IExtHostExtensionService),n=c.get(w.IExtHostTelemetry),r=u.getProxy(R.MainContext.MainThreadExtensionService),i=u.getProxy(R.MainContext.MainThreadErrors),l=await t.getExtensionPathIndex(),f=new WeakMap;function S(h,m){if(f.has(h))return f.get(h).stack;let P="",O,N;for(const U of m)P+=`
	at ${U.toString()}`,N=U.getFileName(),!O&&N&&(O=l.findSubstr(d.URI.file(N)));const L=`${h.name||"Error"}: ${h.message||""}${P}`;return f.set(h,{extensionIdentifier:O?.identifier,stack:L}),L}const I=Symbol("prepareStackTrace wrapped");let E=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return E},set(h){if(h===S||!h||h[I]){E=h||S;return}E=function(m,P){return S(m,P),h.call(Error,m,P)},Object.assign(E,{[I]:!0})}}),D.setUnexpectedErrorHandler(h=>{g.error(h);const m=D.transformErrorForSerialization(h),P=f.get(h);if(!P?.extensionIdentifier){i.$onUnexpectedError(m);return}r.$onExtensionRuntimeError(P.extensionIdentifier,m);const O=n.onExtensionError(P.extensionIdentifier,h);g.trace("forwarded error to extension?",O,P)})}}e.ErrorHandler=s;class o{constructor(c,g,u,t,n){this._hostUtils=u,this._rpcProtocol=new A.RPCProtocol(c,null,t),g=o._transform(g,this._rpcProtocol);const r=new b.ServiceCollection(...(0,_.getSingletonServiceDescriptors)());r.set(T.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:n}),r.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),r.set(y.IURITransformerService,new y.URITransformerService(t)),r.set(C.IHostUtils,u);const i=new k.InstantiationService(r,!0);i.invokeFunction(s.installEarlyHandler),this._logService=i.invokeFunction(l=>l.get(p.ILogService)),F.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=i.invokeFunction(l=>l.get(C.IExtHostExtensionService)),this._extensionService.initialize(),i.invokeFunction(s.installFullHandler)}async asBrowserUri(c){const g=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService);return d.URI.revive(await g.$asBrowserUri(c))}terminate(c){this._extensionService.terminate(c)}static _transform(c,g){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(g.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=d.URI.revive(g.transformIncomingURIs(c.environment.appRoot));const u=c.environment.extensionDevelopmentLocationURI;return u&&(c.environment.extensionDevelopmentLocationURI=u.map(t=>d.URI.revive(g.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=d.URI.revive(g.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=d.URI.revive(g.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=d.URI.revive(g.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=d.URI.revive(g.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=d.URI.revive(g.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=d.URI.revive(g.transformIncomingURIs(c.logsLocation)),c.workspace=g.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=o}),define(Ce[352],De([1,0,9,12,215,232,138,95,71,45,20,44,7,55,39,272,273,40]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let a=class extends p.ExtHostDebugServiceBase{constructor(n,r,i,l,f,S,I){super(n,r,i,l,S,I),this._terminalService=f,this._integratedTerminalInstances=new u}createDebugAdapter(n,r){switch(n.type){case"server":return new w.SocketDebugAdapter(n);case"pipeServer":return new w.NamedPipeDebugAdapter(n);case"executable":return new w.ExecutableDebugAdapter(n,r.type)}return super.createDebugAdapter(n,r)}daExecutableFromPackage(n,r){const i=w.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),n.type);if(i)return new v.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new A.SignService}async $runInTerminal(n,r){if(n.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const i=await this._configurationService.getConfigProvider(),l=this._terminalService.getDefaultShell(!0),f=this._terminalService.getDefaultShellArgs(!0),S=n.title||d.localize(0,null),I=JSON.stringify({shell:l,shellArgs:f});let E=await this._integratedTerminalInstances.checkout(I,S),h,m=!1;if(E)h=n.cwd;else{const L={shellPath:l,shellArgs:f,cwd:n.cwd,name:S,iconPath:new v.ThemeIcon("debug")};m=!0,E=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(E,I)}E.show(!0);const P=await E.processId;m?await new Promise(L=>setTimeout(L,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?E.sendText("cls"):l.indexOf("bash")>=0?E.sendText("clear"):F.isWindows?E.sendText("cls"):E.sendText("clear"));const O=(0,s.prepareCommand)(l,n.args,!!n.argsCanBeInterpretedByShell,h,n.env);E.sendText(O);const N=this.onDidTerminateDebugSession(L=>{L.id===r&&(this._integratedTerminalInstances.free(E),N.dispose())});return P}else if(n.kind==="external")return g(n,await this._configurationService.getConfigProvider());return super.$runInTerminal(n,r)}};e.ExtHostDebugService=a,e.ExtHostDebugService=a=je([$e(0,T.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,b.IExtHostExtensionService),$e(3,o.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,_.IExtHostEditorTabs),$e(6,y.IExtHostVariableResolverProvider)],a);let c;function g(t,n){if(!c)if(F.isWindows)c=new R.WindowsExternalTerminalService;else if(F.isMacintosh)c=new R.MacExternalTerminalService;else if(F.isLinux)c=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=n.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class u{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(n,r){const l=[...this._terminalInstances.entries()].map(([f,S])=>(0,D.createCancelablePromise)(async I=>{if(f.name!==r||S.lastUsedAt!==-1&&await(0,s.hasChildProcesses)(await f.processId))return null;const E=Date.now();return S.lastUsedAt+u.minUseDelay>E||I.isCancellationRequested||S.config!==n?null:(S.lastUsedAt=E,f)}));return await(0,D.firstParallel)(l,f=>!!f)}insert(n,r){this._terminalInstances.set(n,{lastUsedAt:Date.now(),config:r})}free(n){const r=this._terminalInstances.get(n);r&&(r.lastUsedAt=-1)}onTerminalClosed(n){this._terminalInstances.delete(n)}}}),define(Ce[353],De([1,0,16,2,102,39,70,40,43,44,20,26,94,17,14,90,24,63,55]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends v.ExtHostTaskBase{constructor(u,t,n,r,i,l,f,S,I){super(u,t,n,r,i,l,f,S),this.workspaceService=n,this.variableResolver=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const r=v.TaskHandleDTO.from(n,this.workspaceService),i=await this._proxy.$getTaskExecution(r);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(i,t);return this._proxy.$executeTask(r).catch(()=>{}),l}else{const r=v.TaskDTO.from(t,u);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,t,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),t);return this._proxy.$executeTask(r).catch(()=>{}),i}}provideTasksInternal(u,t,n,r){const i=[];if(r)for(const l of r){this.checkDeprecation(l,n),(!l.definition||!u[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const f=v.TaskDTO.from(l,n.extension);f&&(i.push(f),v.CustomExecutionDTO.is(f.execution)&&t.push(this.addCustomExecution(f,l,!0)))}return{tasks:i,extension:n.extension}}async resolveTaskInternal(u){return u}async getAFolder(u){let t=u&&u.length>0?u[0]:void 0;if(!t){const n=F.URI.file((0,o.homedir)());t=new _.WorkspaceFolder({uri:n,name:s.basename(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(u,t){const n=F.URI.revive(u),r={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(n),l=await this._workspaceProvider.getWorkspaceFolders2()??[],f=await this.variableResolver.getResolver(),S=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(const I of t.variables)r.variables[I]=await f.resolveAsync(S,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(D.delimiter);for(let E=0;E<I.length;E++)I[E]=await f.resolveAsync(S,I[E])}r.process=await d.win32.findExecutable(await f.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await f.resolveAsync(S,t.process.cwd):void 0,I)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(u,t,n){return d.win32.findExecutable(u,t,n)}};e.ExtHostTask=c,e.ExtHostTask=c=je([$e(0,T.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,A.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,C.ILogService),$e(7,w.IExtHostApiDeprecationService),$e(8,a.IExtHostVariableResolverProvider)],c)}),define(Ce[354],De([1,0,63,55]),function(pe,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class d extends F.ExtHostVariableResolverProviderService{homeDir(){return(0,D.homedir)()}}e.NodeExtHostVariableResolverProviderService=d}),define(Ce[153],De([1,0,19,9,21,46,17,16,24,2,36]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(a,c,g,u){this.query=a,this.provider=c,this.fileUtils=g,this.processType=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,c){const g=this.query.folderQueries||[],u=new d.CancellationTokenSource(c);return new Promise((t,n)=>{this.collector=new y(a);let r=!1;const i=(l,f)=>{if(!r&&!this.isLimitHit){const S=this.resultSize(l);w(l)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,r=!0,u.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const I=this.resultSize(l);this.resultCount+=I,(I>0||!w(l))&&this.collector.add(l,f)}};Promise.all(g.map((l,f)=>this.searchInFolder(l,S=>i(S,f),u.token))).then(l=>{u.dispose(),this.collector.flush();const f=l.some(S=>!!S&&!!S.limitHit);t({limitHit:this.isLimitHit||f,messages:(0,D.flatten)(l.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.processType}})},l=>{u.dispose();const f=(0,R.toErrorMessage)(l);n(new Error(f))})})}resultSize(a){return w(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,c){const g=Array.isArray(a.ranges)?a.ranges:[a.ranges],u=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:g.slice(0,c),preview:{matches:u.slice(0,c),text:a.preview.text},uri:a.uri}}async searchInFolder(a,c,g){const u=new T.QueryGlobTester(this.query,a),t=[],n={report:l=>{if(!this.validateProviderResult(l))return;const f=a.folder.scheme===A.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(_.dirname(l.uri))):void 0,S=_.relativePath(a.folder,l.uri);if(S){const I=u.includedInQuery(S,p.basename(S),f);(0,F.isThenable)(I)?t.push(I.then(E=>{E&&c(l)})):I&&c(l)}}},r=this.getSearchOptionsForFolder(a),i=await this.provider.provideTextSearchResults(v(this.query.contentPattern),r,n,g);return t.length&&await Promise.all(t),i}validateProviderResult(a){if(w(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const c=(0,T.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),g=(0,T.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),u={folder:b.URI.from(a.folder),excludes:g,includes:c,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return u.usePCRE2=this.query.usePCRE2,u}}e.TextSearchManager=k;function v(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new s(512,c=>this.sendItems(c))}add(a,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!_.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(C(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=y;function C(o){return w(o)?{preview:{matches:(0,D.mapArrayOrNot)(o.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:o.preview.text},ranges:(0,D.mapArrayOrNot)(o.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function w(o){return!!o.preview}e.extensionResultIsMatch=w;class s{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(a,c){this.maxBatchSize=a,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,c){a&&this.addItemToBatch(a,c)}addItems(a,c){a&&this.addItemsToBatch(a,c)}addItemToBatch(a,c){this.batch.push(a),this.batchSize+=c,this.onUpdate()}addItemsToBatch(a,c){this.batch=this.batch.concat(a),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<s.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},s.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=s}),define(Ce[96],De([1,0,3,6,5,347,20,67,14,2,153]),function(pe,e,D,F,d,R,A,p,_,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,d.createDecorator)("IExtHostSearch");let k=class{constructor(w,s,o){this.extHostRpc=w,this._uriTransformer=s,this._logService=o,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,s){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const o=this._handlePool++;return this._textSearchProvider.set(o,s),this._proxy.$registerTextSearchProvider(o,this._transformScheme(w)),(0,D.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(w,s){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const o=this._handlePool++;return this._fileSearchProvider.set(o,s),this._proxy.$registerFileSearchProvider(o,this._transformScheme(w)),(0,D.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(w,s,o,a){const c=v(o),g=this._fileSearchProvider.get(w);if(g)return this._fileSearchManager.fileSearch(c,g,u=>{this._proxy.$handleFileMatch(w,s,u.map(t=>t.resource))},a);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,s,o,a){const c=this._textSearchProvider.get(w);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const g=v(o);return this.createTextSearchManager(g,c).search(t=>this._proxy.$handleTextMatch(w,s,t),a)}$enableExtensionHostSearch(){}createTextSearchManager(w,s){return new T.TextSearchManager(w,s,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=k,e.ExtHostSearch=k=je([$e(0,A.IExtHostRpcService),$e(1,p.IURITransformerService),$e(2,_.ILogService)],k);function v(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(y),extraFileResources:C.extraFileResources&&C.extraFileResources.map(w=>b.URI.revive(w))}}e.reviveQuery=v;function y(C){return{...C,folder:b.URI.revive(C.folder)}}}),define(Ce[355],De([1,0,21,8,4,38,2,130,125,168,185,30,6,111,302,301,33,303,40,305,306,307,280,308,70,45,310,311,316,317,318,152,284,324,325,327,115,44,329,287,13,7,85,332,92,151,39,25,276,315,66,149,94,95,96,14,67,20,26,319,274,73,90,294,330,91,72,335,333,334,295,54,328,331,114,71,89,320,93,321,17,134,283,263,313,3,27,270,112,257,322,323,296,312,282,314,113,326,298,299,300,293,309,297]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n,r,i,l,f,S,I,E,h,m,P,O,N,L,U,x,M,H,j,fe,Y,X,z,J,ge,le,we,G,B,V,me,Z,ne,re,ye,oe,de,ee,ue,ve,ke,$,K,ie,se,Q,he,Se,Ue,We,Ze,Qe,it,et,Te,Oe,ze,Re,Xe,ce,ae,Ie,He,Be,Ye,rt,at,vt,Ct,Xt,Vt,Et,Bt,Nt,$t,Tt,At,Ut,Wt,jt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ht(ot){const ft=ot.get(oe.IExtHostInitDataService),Rt=ot.get(Ue.IExtHostFileSystemInfo),Lt=ot.get(ie.IExtHostConsumerFileSystem),kt=ot.get(i.IExtHostExtensionService),ht=ot.get(J.IExtHostWorkspace),_t=ot.get(et.IExtHostTelemetry),Dt=ot.get(a.IExtHostConfiguration),Ft=ot.get(re.IURITransformerService),Ge=ot.get(ye.IExtHostRpcService),Le=ot.get(L.IExtHostStorage),Fe=ot.get(K.IExtensionStoragePaths),Pe=ot.get(ne.ILoggerService),te=ot.get(ne.ILogService),Me=ot.get(ue.IExtHostTunnelService),Ve=ot.get(ve.IExtHostApiDeprecationService),Je=ot.get(z.IExtHostWindow),qe=ot.get(Qe.IExtHostSecretState),nt=ot.get(it.IExtHostEditorTabs),pt=ot.get(Nt.IExtHostManagedSockets);Ge.set(v.ExtHostContext.ExtHostFileSystemInfo,Rt),Ge.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Pe),Ge.set(v.ExtHostContext.ExtHostWorkspace,ht),Ge.set(v.ExtHostContext.ExtHostConfiguration,Dt),Ge.set(v.ExtHostContext.ExtHostExtensionService,kt),Ge.set(v.ExtHostContext.ExtHostStorage,Le),Ge.set(v.ExtHostContext.ExtHostTunnelService,Me),Ge.set(v.ExtHostContext.ExtHostWindow,Je),Ge.set(v.ExtHostContext.ExtHostSecretState,qe),Ge.set(v.ExtHostContext.ExtHostTelemetry,_t),Ge.set(v.ExtHostContext.ExtHostEditorTabs,nt),Ge.set(v.ExtHostContext.ExtHostManagedSockets,pt);const Pt=Ge.set(v.ExtHostContext.ExtHostDecorations,ot.get(B.IExtHostDecorations)),wt=Ge.set(v.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(r.IExtHostDocumentsAndEditors)),ut=Ge.set(v.ExtHostContext.ExtHostCommands,ot.get(s.IExtHostCommands)),gt=Ge.set(v.ExtHostContext.ExtHostTerminalService,ot.get(U.IExtHostTerminalService)),St=Ge.set(v.ExtHostContext.ExtHostDebugService,ot.get(me.IExtHostDebugService)),mi=Ge.set(v.ExtHostContext.ExtHostSearch,ot.get(Z.IExtHostSearch)),qt=Ge.set(v.ExtHostContext.ExtHostTask,ot.get(V.IExtHostTask)),Qt=Ge.set(v.ExtHostContext.ExtHostOutputService,ot.get(h.IExtHostOutputService)),si=Ge.set(v.ExtHostContext.ExtHostLocalization,ot.get(rt.IExtHostLocalizationService)),_i=Ge.set(v.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Ge)),It=Ge.set(v.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(Ge,wt)),Qi=Ge.set(v.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Ge,wt,te)),ln=Ge.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(te,It,Ge.getProxy(v.MainContext.MainThreadBulkEdits))),bt=Ge.set(v.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(Ge,ut,wt,It,Lt)),gi=Ge.set(v.ExtHostContext.ExtHostNotebookDocuments,new ae.ExtHostNotebookDocuments(bt)),pi=Ge.set(v.ExtHostContext.ExtHostNotebookEditors,new ce.ExtHostNotebookEditors(te,bt)),oi=Ge.set(v.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(Ge,ft,bt,ut,te)),Ci=Ge.set(v.ExtHostContext.ExtHostNotebookRenderers,new ze.ExtHostNotebookRenderers(Ge,bt)),Di=Ge.set(v.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Et.ExtHostNotebookDocumentSaveParticipant(te,bt,Ge.getProxy(v.MainContext.MainThreadBulkEdits))),Ot=Ge.set(v.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Ge,wt)),vi=Ge.set(v.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(Ge.getProxy(v.MainContext.MainThreadTreeViews),ut,te)),Ii=Ge.set(v.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ge.getProxy(v.MainContext.MainThreadEditorInsets),Ot,ft.remote)),ai=Ge.set(v.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(Ge,te,Rt,wt)),ci=Ge.set(v.ExtHostContext.ExtHostLanguages,new I.ExtHostLanguages(Ge,It,ut.converter,Ft)),lt=Ge.set(v.ExtHostContext.ExtHostLanguageFeatures,new S.ExtHostLanguageFeatures(Ge,Ft,It,ut,ai,te,Ve,_t)),ki=Ge.set(v.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ge,lt)),Yt=Ge.set(v.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ge,te,wt)),ii=Ge.set(v.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(Ge,ht,ut)),Ei=Ge.set(v.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Ge,ut,It,te)),Yi=Ge.set(v.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ge,Ft)),Pi=Ge.set(v.ExtHostContext.ExtHostShare,new $t.ExtHostShare(Ge,Ft)),Ti=Ge.set(v.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ge,ut,It)),Ai=Ge.set(v.ExtHostContext.ExtHostProgress,new m.ExtHostProgress(Ge.getProxy(v.MainContext.MainThreadProgress))),Ji=Ge.set(v.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(Ge)),Ri=Ge.set(v.ExtHostContext.ExtHostTheming,new ee.ExtHostTheming(Ge)),li=Ge.set(v.ExtHostContext.ExtHostAuthentication,new ke.ExtHostAuthentication(Ge)),Zi=Ge.set(v.ExtHostContext.ExtHostTimeline,new $.ExtHostTimeline(Ge,ut)),Li=Ge.set(v.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(Ge,ft.remote,ht,te,Ve)),Fi=Ge.set(v.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(Ge,Li,ht)),Oi=Ge.set(v.ExtHostContext.ExtHostCustomEditors,new Q.ExtHostCustomEditors(Ge,It,Fe,Li,Fi)),Mi=Ge.set(v.ExtHostContext.ExtHostWebviewViews,new se.ExtHostWebviewViews(Ge,Li)),di=Ge.set(v.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,ut,wt)),un=Ge.set(v.ExtHostContext.ExtHostUriOpeners,new Ze.ExtHostUriOpeners(Ge)),en=Ge.set(v.ExtHostContext.ExtHostProfileContentHandlers,new vt.ExtHostProfileContentHandlers(Ge));Ge.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Ge,bt,wt,ut,te));const Ni=Ge.set(v.ExtHostContext.ExtHostInlineChat,new Vt.ExtHostInteractiveEditor(Ge,ut,It,te)),hi=Ge.set(v.ExtHostContext.ExtHostChatProvider,new Tt.ExtHostChatProvider(Ge,te)),tn=Ge.set(v.ExtHostContext.ExtHostChatSlashCommands,new At.ExtHostChatSlashCommands(Ge,hi,te)),nn=Ge.set(v.ExtHostContext.ExtHostChatAgents,new zt.ExtHostChatAgents(Ge,hi,te)),dn=Ge.set(v.ExtHostContext.ExtHostChatVariables,new Ut.ExtHostChatVariables(Ge)),ni=Ge.set(v.ExtHostContext.ExtHostChat,new Xt.ExtHostChat(Ge,te)),Ui=Ge.set(v.ExtHostContext.ExtHostAiRelatedInformation,new Wt.ExtHostRelatedInformation(Ge)),Zt=Ge.set(v.ExtHostContext.ExtHostAiEmbeddingVector,new jt.ExtHostAiEmbeddingVector(Ge)),bi=Ge.set(v.ExtHostContext.ExtHostIssueReporter,new Bt.ExtHostIssueReporter(Ge)),rn=Ge.set(v.ExtHostContext.ExtHostStatusBar,new N.ExtHostStatusBar(Ge,ut.converter)),Gt=Object.values(v.ExtHostContext);Ge.assertRegistered(Gt);const wi=new Se.ExtHostBulkEdits(Ge,wt),sn=new w.ExtHostClipboard(Ge),Si=new E.ExtHostMessageService(Ge,te),xi=new g.ExtHostDialogs(Ge);return C.ExtHostApiCommands.register(ut),function(xe,ei,Bi){const mt=function(){let Ee=!xe.isUnderDevelopment;function _e(){Ee||(te.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Ee=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")_e();else{const yt=st;typeof yt.scheme>"u"&&_e(),typeof yt.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return st}}(),hn={getSession(Ee,_e,Ne){return li.getSession(xe,Ee,_e,Ne)},getSessions(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"authGetSessions"),li.getSessions(xe,Ee,_e)},async hasSession(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"authSession"),!!await li.getSession(xe,Ee,_e,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(Ee,_e,Ne,st){return li.registerAuthenticationProvider(Ee,_e,Ne,st)}},fn={registerCommand(Ee,_e,Ne){return ut.registerCommand(!0,Ee,_e,Ne,void 0,xe)},registerTextEditorCommand(Ee,_e,Ne){return ut.registerCommand(!0,Ee,(...st)=>{const yt=Ot.getActiveTextEditor();if(!yt){te.warn("Cannot execute "+Ee+" because there is no active text editor.");return}return yt.edit(Mt=>{_e.apply(Ne,[yt,Mt,...st])}).then(Mt=>{Mt||te.warn("Edits from command "+Ee+" were not applied.")},Mt=>{te.warn("An error occurred while running command "+Ee,Mt)})},void 0,void 0,xe)},registerDiffInformationCommand:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(xe,"diffCommand"),ut.registerCommand(!0,Ee,async(...st)=>{const yt=wt.activeEditor(!0);if(!yt){te.warn("Cannot execute "+Ee+" because there is no active text editor.");return}const Mt=await Ot.getDiffInformation(yt.id);_e.apply(Ne,[Mt,...st])},void 0,void 0,xe)),executeCommand(Ee,..._e){return ut.executeCommand(Ee,..._e)},getCommands(Ee=!1){return ut.getCommands(Ee)}},yi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return _t.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return _t.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(xe,"telemetry"),_t.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(xe,"telemetry"),_t.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(Ee,_e){return et.ExtHostTelemetryLogger.validateSender(Ee),_t.instantiateLogger(xe,Ee,_e)},openExternal(Ee,_e){return Je.openUri(Ee,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(Ee){if(Ee.scheme===ft.environment.appUriScheme)return _i.createAppUri(Ee);try{return await Je.asExternalUri(Ee,{allowTunneling:!!ft.remote.authority})}catch(_e){if((0,Xe.matchesScheme)(Ee,Re.Schemas.http)||(0,Xe.matchesScheme)(Ee,Re.Schemas.https))return Ee;throw _e}},get remoteName(){return(0,G.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(xe,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return te.getLevel()},get onDidChangeLogLevel(){return te.onDidChangeLogLevel},registerIssueUriRequestHandler(Ee){return(0,Be.checkProposedApiEnabled)(xe,"handleIssueUri"),bi.registerIssueUriRequestHandler(xe,Ee)},get appQuality(){return(0,Be.checkProposedApiEnabled)(xe,"resolvers"),ft.quality},get appCommit(){return(0,Be.checkProposedApiEnabled)(xe,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(yi);const on={createTestController(Ee,_e,Ne){return di.createTestController(xe,Ee,_e,Ne)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(xe,"testObserver"),di.createTestObserver()},runTests(Ee){return(0,Be.checkProposedApiEnabled)(xe,"testObserver"),di.runTests(Ee)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(xe,"testObserver"),di.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(xe,"testObserver"),di.results}},fi=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,an={getExtension(Ee,_e){(0,Be.isProposedApiEnabled)(xe,"extensionsAny")||(_e=!1);const Ne=ei.mine.getExtensionDescription(Ee);if(Ne)return new i.Extension(kt,xe.identifier,Ne,fi,!1);if(_e){const st=ei.all.getExtensionDescription(Ee);if(st)return new i.Extension(kt,xe.identifier,st,fi,!0)}},get all(){const Ee=[];for(const _e of ei.mine.getAllExtensionDescriptions())Ee.push(new i.Extension(kt,xe.identifier,_e,fi,!1));return Ee},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(xe,"extensionsAny");const Ee=new ge.ExtensionIdentifierSet(ei.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),_e=[];for(const Ne of ei.all.getAllExtensionDescriptions()){const st=!Ee.has(Ne.identifier);_e.push(new i.Extension(kt,xe.identifier,Ne,fi,st))}return _e},get onDidChange(){return(0,Be.isProposedApiEnabled)(xe,"extensionsAny")?d.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},mn={createDiagnosticCollection(Ee){return ai.createDiagnosticCollection(xe.identifier,Ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:Ee=>ai.getDiagnostics(Ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(Ee,_e){return ci.changeLanguage(Ee.uri,_e)},match(Ee,_e){const Ne=It.getDocumentData(_e.uri)?.notebook;return(0,T.score)(H.LanguageSelector.from(Ee),_e.uri,_e.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(Ee,_e,Ne){return lt.registerCodeActionProvider(xe,mt(Ee),_e,Ne)},registerDocumentPasteEditProvider(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"documentPaste"),lt.registerDocumentPasteEditProvider(xe,mt(Ee),_e,Ne)},registerCodeLensProvider(Ee,_e){return lt.registerCodeLensProvider(xe,mt(Ee),_e)},registerDefinitionProvider(Ee,_e){return lt.registerDefinitionProvider(xe,mt(Ee),_e)},registerDeclarationProvider(Ee,_e){return lt.registerDeclarationProvider(xe,mt(Ee),_e)},registerImplementationProvider(Ee,_e){return lt.registerImplementationProvider(xe,mt(Ee),_e)},registerTypeDefinitionProvider(Ee,_e){return lt.registerTypeDefinitionProvider(xe,mt(Ee),_e)},registerHoverProvider(Ee,_e){return lt.registerHoverProvider(xe,mt(Ee),_e,xe.identifier)},registerEvaluatableExpressionProvider(Ee,_e){return lt.registerEvaluatableExpressionProvider(xe,mt(Ee),_e,xe.identifier)},registerInlineValuesProvider(Ee,_e){return lt.registerInlineValuesProvider(xe,mt(Ee),_e,xe.identifier)},registerDocumentHighlightProvider(Ee,_e){return lt.registerDocumentHighlightProvider(xe,mt(Ee),_e)},registerLinkedEditingRangeProvider(Ee,_e){return lt.registerLinkedEditingRangeProvider(xe,mt(Ee),_e)},registerReferenceProvider(Ee,_e){return lt.registerReferenceProvider(xe,mt(Ee),_e)},registerRenameProvider(Ee,_e){return lt.registerRenameProvider(xe,mt(Ee),_e)},registerDocumentSymbolProvider(Ee,_e,Ne){return lt.registerDocumentSymbolProvider(xe,mt(Ee),_e,Ne)},registerWorkspaceSymbolProvider(Ee){return lt.registerWorkspaceSymbolProvider(xe,Ee)},registerDocumentFormattingEditProvider(Ee,_e){return lt.registerDocumentFormattingEditProvider(xe,mt(Ee),_e)},registerDocumentRangeFormattingEditProvider(Ee,_e){return lt.registerDocumentRangeFormattingEditProvider(xe,mt(Ee),_e)},registerOnTypeFormattingEditProvider(Ee,_e,Ne,...st){return lt.registerOnTypeFormattingEditProvider(xe,mt(Ee),_e,[Ne].concat(st))},registerDocumentSemanticTokensProvider(Ee,_e,Ne){return lt.registerDocumentSemanticTokensProvider(xe,mt(Ee),_e,Ne)},registerDocumentRangeSemanticTokensProvider(Ee,_e,Ne){return lt.registerDocumentRangeSemanticTokensProvider(xe,mt(Ee),_e,Ne)},registerSignatureHelpProvider(Ee,_e,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(xe,mt(Ee),_e,Ne):lt.registerSignatureHelpProvider(xe,mt(Ee),_e,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(Ee,_e,...Ne){return lt.registerCompletionItemProvider(xe,mt(Ee),_e,Ne)},registerInlineCompletionItemProvider(Ee,_e,Ne){return _e.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,Be.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Ne&&(0,Be.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(xe,mt(Ee),_e,Ne)},registerDocumentLinkProvider(Ee,_e){return lt.registerDocumentLinkProvider(xe,mt(Ee),_e)},registerColorProvider(Ee,_e){return lt.registerColorProvider(xe,mt(Ee),_e)},registerFoldingRangeProvider(Ee,_e){return lt.registerFoldingRangeProvider(xe,mt(Ee),_e)},registerSelectionRangeProvider(Ee,_e){return lt.registerSelectionRangeProvider(xe,Ee,_e)},registerCallHierarchyProvider(Ee,_e){return lt.registerCallHierarchyProvider(xe,Ee,_e)},registerTypeHierarchyProvider(Ee,_e){return lt.registerTypeHierarchyProvider(xe,Ee,_e)},setLanguageConfiguration:(Ee,_e)=>lt.setLanguageConfiguration(xe,Ee,_e),getTokenInformationAtPosition(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"tokenInformation"),ci.tokenAtPosition(Ee,_e)},registerInlayHintsProvider(Ee,_e){return lt.registerInlayHintsProvider(xe,Ee,_e)},createLanguageStatusItem(Ee,_e){return ci.createLanguageStatusItem(xe,Ee,_e)},registerDocumentDropEditProvider(Ee,_e,Ne){return lt.registerDocumentOnDropEditProvider(xe,Ee,_e,(0,Be.isProposedApiEnabled)(xe,"dropMetadata")?Ne:void 0)}},gn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Ee,_e,Ne){const st=await(A.URI.isUri(Ee)?Promise.resolve($i.openTextDocument(Ee)):Promise.resolve(Ee));return Ot.showTextDocument(st,_e,Ne)},createTextEditorDecorationType(Ee){return Ot.createTextEditorDecorationType(xe,Ee)},onDidChangeActiveTextEditor(Ee,_e,Ne){return Ot.onDidChangeActiveTextEditor(Ee,_e,Ne)},onDidChangeVisibleTextEditors(Ee,_e,Ne){return Ot.onDidChangeVisibleTextEditors(Ee,_e,Ne)},onDidChangeTextEditorSelection(Ee,_e,Ne){return Ot.onDidChangeTextEditorSelection(Ee,_e,Ne)},onDidChangeTextEditorOptions(Ee,_e,Ne){return Ot.onDidChangeTextEditorOptions(Ee,_e,Ne)},onDidChangeTextEditorVisibleRanges(Ee,_e,Ne){return Ot.onDidChangeTextEditorVisibleRanges(Ee,_e,Ne)},onDidChangeTextEditorViewColumn(Ee,_e,Ne){return Ot.onDidChangeTextEditorViewColumn(Ee,_e,Ne)},onDidCloseTerminal(Ee,_e,Ne){return gt.onDidCloseTerminal(Ee,_e,Ne)},onDidOpenTerminal(Ee,_e,Ne){return gt.onDidOpenTerminal(Ee,_e,Ne)},onDidChangeActiveTerminal(Ee,_e,Ne){return gt.onDidChangeActiveTerminal(Ee,_e,Ne)},onDidChangeTerminalDimensions(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"terminalDimensions"),gt.onDidChangeTerminalDimensions(Ee,_e,Ne)},onDidChangeTerminalState(Ee,_e,Ne){return gt.onDidChangeTerminalState(Ee,_e,Ne)},onDidWriteTerminalData(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(Ee,_e,Ne)},onDidExecuteTerminalCommand(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(Ee,_e,Ne)},get state(){return Je.getState(xe)},onDidChangeWindowState(Ee,_e,Ne){return Je.onDidChangeWindowState(Ee,_e,Ne)},showInformationMessage(Ee,..._e){return Si.showMessage(xe,R.default.Info,Ee,_e[0],_e.slice(1))},showWarningMessage(Ee,..._e){return Si.showMessage(xe,R.default.Warning,Ee,_e[0],_e.slice(1))},showErrorMessage(Ee,..._e){return Si.showMessage(xe,R.default.Error,Ee,_e[0],_e.slice(1))},showQuickPick(Ee,_e,Ne){return ii.showQuickPick(xe,Ee,_e,Ne)},showWorkspaceFolderPick(Ee){return ii.showWorkspaceFolderPick(Ee)},showInputBox(Ee,_e){return ii.showInput(Ee,_e)},showOpenDialog(Ee){return xi.showOpenDialog(xe,Ee)},showSaveDialog(Ee){return xi.showSaveDialog(Ee)},createStatusBarItem(Ee,_e,Ne){let st,yt,Mt;return typeof Ee=="string"?(st=Ee,yt=_e,Mt=Ne):(yt=Ee,Mt=_e),rn.createStatusBarEntry(xe,st,yt,Mt)},setStatusBarMessage(Ee,_e){return rn.setStatusBarMessage(Ee,_e)},withScmProgress(Ee){return Ve.report("window.withScmProgress",xe,"Use 'withProgress' instead."),Ai.withProgress(xe,{location:j.ProgressLocation.SourceControl},(_e,Ne)=>Ee({report(st){}}))},withProgress(Ee,_e){return Ai.withProgress(xe,Ee,_e)},createOutputChannel(Ee,_e){return Qt.createOutputChannel(Ee,_e,xe)},createWebviewPanel(Ee,_e,Ne,st){return Fi.createWebviewPanel(xe,Ee,_e,Ne,st)},createWebviewTextEditorInset(Ee,_e,Ne,st){return(0,Be.checkProposedApiEnabled)(xe,"editorInsets"),Ii.createWebviewEditorInset(Ee,_e,Ne,st,xe)},createTerminal(Ee,_e,Ne){return typeof Ee=="object"?"pty"in Ee?gt.createExtensionTerminal(Ee):gt.createTerminalFromOptions(Ee):gt.createTerminal(Ee,_e,Ne)},registerTerminalLinkProvider(Ee){return gt.registerLinkProvider(Ee)},registerTerminalProfileProvider(Ee,_e){return gt.registerProfileProvider(xe,Ee,_e)},registerTerminalQuickFixProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(Ee,xe.identifier.value,_e)},registerTreeDataProvider(Ee,_e){return vi.registerTreeDataProvider(Ee,_e,xe)},createTreeView(Ee,_e){return vi.createTreeView(Ee,_e,xe)},registerWebviewPanelSerializer:(Ee,_e)=>Fi.registerWebviewPanelSerializer(xe,Ee,_e),registerCustomEditorProvider:(Ee,_e,Ne={})=>Oi.registerCustomEditorProvider(xe,Ee,_e,Ne),registerFileDecorationProvider(Ee){return Pt.registerFileDecorationProvider(Ee,xe)},registerUriHandler(Ee){return _i.registerUriHandler(xe,Ee)},createQuickPick(){return ii.createQuickPick(xe)},createInputBox(){return ii.createInputBox(xe)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(Ee,_e,Ne){return Ri.onDidChangeActiveColorTheme(Ee,_e,Ne)},registerWebviewViewProvider(Ee,_e,Ne){return Mi.registerWebviewViewProvider(xe,Ee,_e,Ne?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Ee,_e,Ne){return bt.onDidChangeActiveNotebookEditor(Ee,_e,Ne)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Ee,_e,Ne){return pi.onDidChangeNotebookEditorSelection(Ee,_e,Ne)},onDidChangeNotebookEditorVisibleRanges(Ee,_e,Ne){return pi.onDidChangeNotebookEditorVisibleRanges(Ee,_e,Ne)},showNotebookDocument(Ee,_e){return bt.showNotebookDocument(Ee,_e)},registerExternalUriOpener(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"externalUriOpener"),un.registerExternalUriOpener(xe.identifier,Ee,_e,Ne)},registerProfileContentHandler(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"profileContentHandlers"),en.registrProfileContentHandler(xe,Ee,_e)},registerQuickDiffProvider(Ee,_e,Ne,st){return(0,Be.checkProposedApiEnabled)(xe,"quickDiffProvider"),Yi.registerQuickDiffProvider(mt(Ee),_e,Ne,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"shareProvider"),Pi.registerShareProvider(mt(Ee),_e)}},$i={get rootPath(){return Ve.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(Ee){throw new F.ReadonlyError("rootPath")},getWorkspaceFolder(Ee){return ht.getWorkspaceFolder(Ee)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(Ee){throw new F.ReadonlyError("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(Ee){throw new F.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(Ee,_e,...Ne)=>ht.updateWorkspaceFolders(xe,Ee,_e||0,...Ne),onDidChangeWorkspaceFolders:function(Ee,_e,Ne){return ht.onDidChangeWorkspace(Ee,_e,Ne)},asRelativePath:(Ee,_e)=>ht.getRelativePath(Ee,_e),findFiles:(Ee,_e,Ne,st)=>ht.findFiles(Ee,_e,Ne,xe.identifier,st),findTextInFiles:(Ee,_e,Ne,st)=>{(0,Be.checkProposedApiEnabled)(xe,"findTextInFiles");let yt,Mt;return typeof _e=="object"?(yt=_e,Mt=Ne):(yt={},Mt=_e,st=Ne),ht.findTextInFiles(Ee,yt||{},Mt,xe.identifier,st)},save:Ee=>((0,Be.checkProposedApiEnabled)(xe,"saveEditor"),ht.save(Ee)),saveAs:Ee=>((0,Be.checkProposedApiEnabled)(xe,"saveEditor"),ht.saveAs(Ee)),saveAll:Ee=>ht.saveAll(Ee),applyEdit(Ee,_e){return wi.applyWorkspaceEdit(Ee,xe,_e)},createFileSystemWatcher:(Ee,_e,Ne,st)=>Yt.createFileSystemWatcher(ht,xe,Ee,_e,Ne,st),get textDocuments(){return It.getAllDocumentData().map(Ee=>Ee.document)},set textDocuments(Ee){throw new F.ReadonlyError("textDocuments")},openTextDocument(Ee){let _e;const Ne=Ee;if(typeof Ee=="string")_e=Promise.resolve(A.URI.file(Ee));else if(A.URI.isUri(Ee))_e=Promise.resolve(Ee);else if(!Ne||typeof Ne=="object")_e=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(st=>It.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(Ee,_e,Ne)=>It.onDidAddDocument(Ee,_e,Ne),onDidCloseTextDocument:(Ee,_e,Ne)=>It.onDidRemoveDocument(Ee,_e,Ne),onDidChangeTextDocument:(Ee,_e,Ne)=>It.onDidChangeDocument(Ee,_e,Ne),onDidSaveTextDocument:(Ee,_e,Ne)=>It.onDidSaveDocument(Ee,_e,Ne),onWillSaveTextDocument:(Ee,_e,Ne)=>ln.getOnWillSaveTextDocumentEvent(xe)(Ee,_e,Ne),get notebookDocuments(){return bt.notebookDocuments.map(Ee=>Ee.apiNotebook)},async openNotebookDocument(Ee,_e){let Ne;if(A.URI.isUri(Ee))Ne=Ee,await bt.openNotebookDocument(Ee);else if(typeof Ee=="string")Ne=A.URI.revive(await bt.createNotebookDocument({viewType:Ee,content:_e}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(Ee,_e,Ne){return gi.onDidSaveNotebookDocument(Ee,_e,Ne)},onDidChangeNotebookDocument(Ee,_e,Ne){return gi.onDidChangeNotebookDocument(Ee,_e,Ne)},onWillSaveNotebookDocument(Ee,_e,Ne){return Di.getOnWillSaveNotebookDocumentEvent(xe)(Ee,_e,Ne)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(Ee,_e,Ne,st){return bt.registerNotebookSerializer(xe,Ee,_e,Ne,(0,Be.isProposedApiEnabled)(xe,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(Ee,_e,Ne)=>Bi.onDidChangeConfiguration(Ee,_e,Ne),getConfiguration(Ee,_e){return _e=arguments.length===1?void 0:_e,Bi.getConfiguration(Ee,_e,xe)},registerTextDocumentContentProvider(Ee,_e){return Qi.registerTextDocumentContentProvider(Ee,_e)},registerTaskProvider:(Ee,_e)=>(Ve.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(xe,Ee,_e)),registerFileSystemProvider(Ee,_e,Ne){return(0,He.combinedDisposable)(ki.registerFileSystemProvider(xe,Ee,_e,Ne),Lt.addFileSystemProvider(Ee,_e,Ne))},get fs(){return Lt.value},registerFileSearchProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"fileSearchProvider"),mi.registerFileSearchProvider(Ee,_e)),registerTextSearchProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"textSearchProvider"),mi.registerTextSearchProvider(Ee,_e)),registerRemoteAuthorityResolver:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"resolvers"),kt.registerRemoteAuthorityResolver(Ee,_e)),registerResourceLabelFormatter:Ee=>((0,Be.checkProposedApiEnabled)(xe,"resolvers"),Ji.$registerResourceLabelFormatter(Ee)),getRemoteExecServer:Ee=>((0,Be.checkProposedApiEnabled)(xe,"resolvers"),kt.getRemoteExecServer(Ee)),onDidCreateFiles:(Ee,_e,Ne)=>Yt.onDidCreateFile(Ee,_e,Ne),onDidDeleteFiles:(Ee,_e,Ne)=>Yt.onDidDeleteFile(Ee,_e,Ne),onDidRenameFiles:(Ee,_e,Ne)=>Yt.onDidRenameFile(Ee,_e,Ne),onWillCreateFiles:(Ee,_e,Ne)=>Yt.getOnWillCreateFileEvent(xe)(Ee,_e,Ne),onWillDeleteFiles:(Ee,_e,Ne)=>Yt.getOnWillDeleteFileEvent(xe)(Ee,_e,Ne),onWillRenameFiles:(Ee,_e,Ne)=>Yt.getOnWillRenameFileEvent(xe)(Ee,_e,Ne),openTunnel:Ee=>((0,Be.checkProposedApiEnabled)(xe,"tunnels"),Me.openTunnel(xe,Ee).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,Be.checkProposedApiEnabled)(xe,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(xe,"tunnels"),Me.onDidChangeTunnels(Ee,_e,Ne)),registerPortAttributesProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"portsAttributes"),Me.registerPortsAttributesProvider(Ee,_e)),registerTunnelProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"tunnelFactory"),Me.registerTunnelProvider(Ee,_e)),registerTimelineProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"timeline"),Zi.registerTimelineProvider(Ee,_e,xe.identifier,ut.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:Ee=>((0,Be.checkProposedApiEnabled)(xe,"workspaceTrust"),ht.requestWorkspaceTrust(Ee)),onDidGrantWorkspaceTrust:(Ee,_e,Ne)=>ht.onDidGrantWorkspaceTrust(Ee,_e,Ne),registerEditSessionIdentityProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(Ee,_e)),onWillCreateEditSessionIdentity:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(xe)(Ee,_e,Ne)),registerCanonicalUriProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ht.registerCanonicalUriProvider(Ee,_e)),getCanonicalUri:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ht.provideCanonicalUri(Ee,_e,Ne))},cn={get inputBox(){return Ve.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(xe)},createSourceControl(Ee,_e,Ne){return Ei.createSourceControl(xe,Ee,_e,Ne)}},Wi={createCommentController(Ee,_e){return Ti.createCommentController(xe,Ee,_e)}},zi={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},onDidStartDebugSession(Ee,_e,Ne){return St.onDidStartDebugSession(Ee,_e,Ne)},onDidTerminateDebugSession(Ee,_e,Ne){return St.onDidTerminateDebugSession(Ee,_e,Ne)},onDidChangeActiveDebugSession(Ee,_e,Ne){return St.onDidChangeActiveDebugSession(Ee,_e,Ne)},onDidReceiveDebugSessionCustomEvent(Ee,_e,Ne){return St.onDidReceiveDebugSessionCustomEvent(Ee,_e,Ne)},onDidChangeBreakpoints(Ee,_e,Ne){return St.onDidChangeBreakpoints(Ee,_e,Ne)},onDidChangeStackFrameFocus(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"debugFocus"),St.onDidChangeStackFrameFocus(Ee,_e,Ne)},registerDebugConfigurationProvider(Ee,_e,Ne){return St.registerDebugConfigurationProvider(Ee,_e,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Ee,_e){return St.registerDebugAdapterDescriptorFactory(xe,Ee,_e)},registerDebugAdapterTrackerFactory(Ee,_e){return St.registerDebugAdapterTrackerFactory(Ee,_e)},startDebugging(Ee,_e,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?St.startDebugging(Ee,_e,{parentSession:Ne}):St.startDebugging(Ee,_e,Ne||{})},stopDebugging(Ee){return St.stopDebugging(Ee)},addBreakpoints(Ee){return St.addBreakpoints(Ee)},removeBreakpoints(Ee){return St.removeBreakpoints(Ee)},asDebugSourceUri(Ee,_e){return St.asDebugSourceUri(Ee,_e)}},Hi={registerTaskProvider:(Ee,_e)=>qt.registerTaskProvider(xe,Ee,_e),fetchTasks:Ee=>qt.fetchTasks(Ee),executeTask:Ee=>qt.executeTask(xe,Ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(Ee,_e,Ne)=>qt.onDidStartTask(Ee,_e,Ne),onDidEndTask:(Ee,_e,Ne)=>qt.onDidEndTask(Ee,_e,Ne),onDidStartTaskProcess:(Ee,_e,Ne)=>qt.onDidStartTaskProcess(Ee,_e,Ne),onDidEndTaskProcess:(Ee,_e,Ne)=>qt.onDidEndTaskProcess(Ee,_e,Ne)},ui={createNotebookController(Ee,_e,Ne,st,yt){return oi.createNotebookController(xe,Ee,_e,Ne,st,(0,Be.isProposedApiEnabled)(xe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(Ee,_e)=>bt.registerNotebookCellStatusBarItemProvider(xe,Ee,_e),createRendererMessaging(Ee){return Ci.createRendererMessaging(xe,Ee)},createNotebookControllerDetectionTask(Ee){return(0,Be.checkProposedApiEnabled)(xe,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(xe,Ee)},registerKernelSourceActionProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"notebookKernelSource"),oi.registerKernelSourceActionProvider(xe,Ee,_e)},onDidChangeNotebookCellExecutionState(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(Ee,_e,Ne)}},Vi={t(...Ee){if(typeof Ee[0]=="string"){const _e=Ee.shift(),Ne=!Ee||typeof Ee[0]!="object"?Ee:Ee[0];return si.getMessage(xe.identifier.value,{message:_e,args:Ne})}return si.getMessage(xe.identifier.value,Ee[0])},get bundle(){return si.getBundle(xe.identifier.value)},get uri(){return si.getBundleUri(xe.identifier.value)}},ji={_version:1,registerInteractiveEditorSessionProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"interactive"),Ni.registerProvider(xe,Ee,_e={label:_e?.label??xe.displayName??xe.name})},registerInteractiveSessionProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"interactive"),ni.registerChatProvider(xe,Ee,_e)},addInteractiveRequest(Ee){return(0,Be.checkProposedApiEnabled)(xe,"interactive"),ni.addChatRequest(Ee)},sendInteractiveRequestToProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"interactive"),ni.sendInteractiveRequestToProvider(Ee,_e)},get onDidPerformUserAction(){return(0,Be.checkProposedApiEnabled)(xe,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"interactive"),ni.transferChatSession(Ee,_e)}},qi={getRelatedInformation(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Ui.getRelatedInformation(xe,Ee,_e)},registerRelatedInformationProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Ui.registerRelatedInformationProvider(xe,Ee,_e)},registerEmbeddingVectorProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Zt.registerEmbeddingVectorProvider(xe,Ee,_e)}},Gi={registerChatResponseProvider(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"chatProvider"),hi.registerProvider(xe.identifier,Ee,_e,Ne)},registerSlashCommand(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"chatSlashCommands"),tn.registerCommand(xe.identifier,Ee,_e,Ne??{description:""})},requestChatAccess(Ee){return(0,Be.checkProposedApiEnabled)(xe,"chatRequestAccess"),hi.requestChatResponseProvider(xe.identifier,Ee)},registerVariable(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"chatVariables"),dn.registerVariableResolver(xe,Ee,_e,Ne)},registerMappedEditsProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(xe,"mappedEditsProvider"),lt.registerMappedEditsProvider(xe,Ee,_e)},registerAgent(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(xe,"chatAgents"),nn.registerAgent(xe.identifier,Ee,_e,Ne)}};return{version:ft.version,ai:qi,authentication:hn,commands:fn,comments:Wi,chat:Gi,debug:zi,env:yi,extensions:an,interactive:ji,l10n:Vi,languages:mn,notebooks:ui,scm:cn,tasks:Hi,tests:on,window:gn,workspace:$i,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,ChatMessage:j.ChatMessage,ChatMessageRole:j.ChatMessageRole,ChatVariableLevel:j.ChatVariableLevel,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:D.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentState:j.CommentState,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:d.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:b.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixExecuteTerminalCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:p.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,SyntaxTokenType:j.SyntaxTokenType,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:y.UIKind,Uri:A.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,ManagedResolvedAuthority:j.ManagedResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestMessage:j.TestMessage,TestMessage2:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:ne.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch,InteractiveSessionVoteDirection:j.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:j.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:j.InteractiveEditorResponseFeedbackKind,StackFrameFocus:j.StackFrameFocus,ThreadFocus:j.ThreadFocus,RelatedInformationType:j.RelatedInformationType}}}e.createApiFactoryAndRegisterActors=Ht}),define(Ce[356],De([1,0,104,152,39,149,40,33,70,44,94,95,96,115,73,90,151,72,54,114,89,71,150,14,55,112,113]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n,r,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,D.registerSingleton)(n.ILoggerService,t.ExtHostLoggerService,1),(0,D.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService,1),(0,D.registerSingleton)(p.IExtHostCommands,p.ExtHostCommands,0),(0,D.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,D.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,D.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,D.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,D.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors,0),(0,D.registerSingleton)(l.IExtHostManagedSockets,l.ExtHostManagedSockets,0),(0,D.registerSingleton)(a.IExtHostFileSystemInfo,a.ExtHostFileSystemInfo,0),(0,D.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService,1),(0,D.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,D.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,0),(0,D.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask,0),(0,D.registerSingleton)(b.IExtHostTerminalService,b.WorkerExtHostTerminalService,0),(0,D.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,D.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,0),(0,D.registerSingleton)(d.IExtHostWorkspace,d.ExtHostWorkspace,0),(0,D.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState,0),(0,D.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry,0),(0,D.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs,0),(0,D.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ce[116],De([1,0,19,14,36,93]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function p(k,v,y,C){const w=(0,D.mapArrayOrNot)(y,_),s=new d.TextSearchMatch(v,w,C),o=s.preview.matches;return{ranges:(0,D.mapArrayOrNot)(w,b),uri:k,preview:{text:s.preview.text,matches:(0,D.mapArrayOrNot)(o,b)}}}e.createTextSearchResult=p;function _(k){return new d.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function b(k){return new R.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(v,y){this.prefix=v,this.logService=y}appendLine(v){this.logService.debug(`${this.prefix}#search`,v)}};e.OutputChannel=T,e.OutputChannel=T=je([$e(1,F.ILogService)],T)}),define(Ce[357],De([1,0,48,16,77,32,12,15,116,358]),function(pe,e,D,F,d,R,A,p,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const T=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(c,g,u,t){const n=v(c,g,u,t),r=g.folder.fsPath;return{cmd:D.spawn(T,n.args,{cwd:r}),rgDiskPath:T,siblingClauses:n.siblingClauses,rgArgs:n,cwd:r}}e.spawnRipgrepCmd=k;function v(c,g,u,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];C([g],u,!1).forEach(i=>{const l=(0,_.anchorGlob)(i);if(n.push("-g",l),A.isMacintosh){const f=(0,d.normalizeNFD)(l);f!==l&&n.push("-g",f)}});const r=y([g],t,void 0,!1);return r.globArgs.forEach(i=>{const l=`!${(0,_.anchorGlob)(i)}`;if(n.push("-g",l),A.isMacintosh){const f=(0,d.normalizeNFD)(l);f!==l&&n.push("-g",f)}}),g.disregardIgnoreFiles!==!1?n.push("--no-ignore"):g.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),g.ignoreSymlinks||n.push("--follow"),c.exists&&n.push("--quiet"),n.push("--no-config"),g.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:r.siblingClauses}}function y(c,g,u,t=!0){const n=[];let r={};return c.forEach(i=>{const l=Object.assign({},i.excludePattern||{},g||{}),f=w(l,t?i.folder.fsPath:void 0,u);n.push(...f.globArgs),f.siblingClauses&&(r=Object.assign(r,f.siblingClauses))}),{globArgs:n,siblingClauses:r}}function C(c,g,u=!0){const t=[];return c.forEach(n=>{const r=Object.assign({},g||{},n.includePattern||{}),i=w(r,u?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function w(c,g,u){const t=[],n={};return Object.keys(c).forEach(r=>{if(u&&u.has(r)||!r)return;const i=c[r];r=o(g?s(g,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(a(r))):i&&i.when&&(n[r]=i)}),{globArgs:t,siblingClauses:n}}function s(c,g){return F.isAbsolute(g)?g:F.join(c,g)}e.getAbsoluteGlob=s;function o(c){return c=p.rtrim(c,"\\"),p.rtrim(c,"/")}function a(c){return R.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=a}),define(Ce[359],De([1,0,48,52,16,360,19,46,35,77,32,12,37,15,18,29,36,357,127]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(r=>r())});class g{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&_.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,a.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&_.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(l=>{const f=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),S=l.folder.fsPath;i.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==S).forEach(I=>{(0,T.isEqualOrParent)(I,S)&&(f[d.relative(S,I)]=!0)}),this.folderExcludePatterns.set(S,new t(f,S))})}cancel(){this.isCanceled=!0,c.forEach(i=>i())}walk(i,l,f,S,I){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return I(null,this.isLimitHit);l.forEach(E=>{const h=d.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,h)||this.matchFile(f,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(i,(E,h)=>{this.call(this.cmdTraversal,this,E,f,S,m=>{if(m){const P=(0,p.toErrorMessage)(m);console.error(P),this.errors.push(P),h(m,void 0)}else h(null,void 0)})},(E,h)=>{this.fileWalkSW.stop();const m=E?A.coalesce(E)[0]:null;I(m,this.isLimitHit)})}parallel(i,l,f){const S=new Array(i.length),I=new Array(i.length);let E=!1,h=0;if(i.length===0)return f(null,[]);i.forEach((m,P)=>{l(m,(O,N)=>{if(O?(E=!0,S[P]=null,I[P]=O):(S[P]=N,I[P]=null),++h===i.length)return f(E?I:null,S)})})}call(i,l,...f){try{i.apply(l,f)}catch(S){f[f.length-1](S)}}cmdTraversal(i,l,f,S){const I=i.folder.fsPath,E=k.isMacintosh,h=()=>L&&L.kill();c.add(h);let m=H=>{c.delete(h),m=()=>{},S(H)},P="";const O=this.initDirectoryTree(),N=(0,o.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),L=N.cmd,U=!Object.keys(N.siblingClauses).length,x=N.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let M=`${N.rgDiskPath} ${x}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),f({message:M}),this.cmdResultCount=0,this.collectStdout(L,"utf8",f,(H,j,fe)=>{if(H){m(H);return}if(this.isLimitHit){m();return}const X=(P+(E?b.normalizeNFC(j||""):j)).split(`
`);if(fe){const z=X.length;X[z-1]=X[z-1].trim(),X[z-1]||X.pop()}else P=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){m(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=X.length,U){for(const z of X)if(this.matchFile(l,{base:I,relativePath:z,searchPath:this.getSearchPath(i,z)}),this.isLimitHit){h();break}(fe||this.isLimitHit)&&m();return}this.addDirectoryEntries(i,O,I,X,l),fe&&(this.matchDirectoryTree(O,I,l),m())})}spawnFindCmd(i){const l=this.folderExcludePatterns.get(i.folder.fsPath),f=l.getBasenameTerms(),S=l.getPathTerms(),I=["-L","."];if(f.length||S.length){I.push("-not","(","(");for(const E of f)I.push("-name",E),I.push("-o");for(const E of S)I.push("-path",E),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),D.spawn("find",I,{cwd:i.folder.fsPath})}readStdout(i,l,f){let S="";this.collectStdout(i,l,()=>{},(I,E,h)=>{if(I){f(I);return}S+=E,h&&f(null,S)})}collectStdout(i,l,f,S){let I=(m,P,O)=>{(m||O)&&(I=()=>{},this.cmdSW?.stop()),S(m,P,O)},E=!1;i.stdout?(this.forwardData(i.stdout,l,I),i.stdout.once("data",()=>E=!0)):f({message:"stdout is null"});let h;i.stderr?h=this.collectData(i.stderr):f({message:"stderr is null"}),i.on("error",m=>{I(m)}),i.on("close",m=>{let P;!E&&(P=this.decodeData(h,l))&&n(P)?I(new Error(`command failed with error code ${m}: ${this.decodeData(h,l)}`)):(this.exists&&m===0&&(this.isLimitHit=!0),I(null,"",!0))})}forwardData(i,l,f){const S=new R.StringDecoder(l);return i.on("data",I=>{f(null,S.write(I))}),S}collectData(i){const l=[];return i.on("data",f=>{l.push(f)}),l}decodeData(i,l){const f=new R.StringDecoder(l);return i.map(S=>f.write(S)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:l},f,S,I){S.indexOf(this.filePattern)!==-1&&this.matchFile(I,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const E=h=>{const m=d.basename(h),P=d.dirname(h);let O=l[P];O||(O=l[P]=[],E(P)),O.push({base:f,relativePath:h,basename:m,searchPath:this.getSearchPath(i,h)})};S.forEach(E)}matchDirectoryTree({rootEntries:i,pathToEntries:l},f,S){const I=this,E=this.folderExcludePatterns.get(f),h=this.filePattern;function m(P){I.directoriesWalked++;const O=(0,s.hasSiblingFn)(()=>P.map(N=>N.basename));for(let N=0,L=P.length;N<L;N++){const U=P[N],{relativePath:x,basename:M}=U;if(E.test(x,M,h!==M?O:void 0))continue;const H=l[x];if(H)m(H);else{if(I.filesWalked++,x===h)continue;I.matchFile(S,U)}if(I.isLimitHit)break}}m(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,l,f,S,I){const E=i.folder,h=(0,s.hasSiblingFn)(()=>f);this.parallel(f,(m,P)=>{if(this.isCanceled||this.isLimitHit)return P(null);const O=l?[l,m].join(d.sep):m;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,m,this.config.filePattern!==m?h:void 0))return P(null);const N=[E.fsPath,O].join(d.sep);F.lstat(N,(L,U)=>{if(L||this.isCanceled||this.isLimitHit)return P(null);this.statLinkIfNeeded(N,U,(x,M)=>x||this.isCanceled||this.isLimitHit?P(null):M.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,U,(H,j)=>H||this.isCanceled||this.isLimitHit||(j=j||"",this.walkedPaths[j])?P(null):(this.walkedPaths[j]=!0,w.Promises.readdir(N).then(fe=>{if(this.isCanceled||this.isLimitHit)return P(null);this.doWalk(i,O,fe,S,Y=>P(Y||null))},fe=>{P(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&C.isNumber(M.size)&&M.size>this.maxFilesize||this.matchFile(S,{base:E.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),P(null,void 0)))})},m=>{const P=m&&A.coalesce(m);return I(P&&P.length>0?P[0]:void 0)})}matchFile(i,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,d.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(l))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,s.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,l,f){return l.isSymbolicLink()?F.stat(i,f):f(null,l)}realPathIfNeeded(i,l,f){return l.isSymbolicLink()?F.realpath(i,(S,I)=>S?f(S):f(null,I)):f(null,i)}getSearchPath(i,l){return i.folderName?d.join(i.folderName,l):l}}e.FileWalker=g;class u{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new g(i)}search(i,l,f){this.walker.walk(this.folderQueries,this.extraFiles,i,l,(S,I)=>{f(S,{limitHit:I,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class t{constructor(i,l){this.expression=i,this.root=l,this.init(i)}init(i){let l,f;Object.keys(i).filter(S=>i[S]).forEach(S=>{d.isAbsolute(S)?(l=l||_.getEmptyExpression(),l[S]=i[S]):(f=f||_.getEmptyExpression(),f[S]=i[S])}),this.absoluteParsedExpr=l&&_.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=f&&_.parse(f,{trimForExclusions:!0})}test(i,l,f){return this.relativeParsedExpr&&this.relativeParsedExpr(i,l,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(d.join(this.root,i),l,f)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getPathTerms(this.relativeParsedExpr)),i}}function n(r){const i=r.trim().split(`
`),l=i[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return y.uppercaseFirstLetter(i[i.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(Ce[361],De([1,0,97,22,182,21]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(f=>f===l)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const p=512,_=512,b=512*8,T=512*128;var k;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k||(e.DecodeStreamErrorKind=k={}));class v extends Error{constructor(f,S){super(f),this.decodeStreamErrorKind=S}}e.DecodeStreamError=v;class y{static async create(f){let S;if(f!==e.UTF8)S=(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(f));else{const I=new TextDecoder;S={write(E){return I.decode(E,{stream:!0})},end(){return I.decode()}}}return new y(S)}constructor(f){this.iconvLiteDecoder=f}write(f){return this.iconvLiteDecoder.write(f)}end(){return this.iconvLiteDecoder.end()}}function C(l,f){const S=f.minBytesRequiredForDetection??f.guessEncoding?b:_;return new Promise((I,E)=>{const h=(0,D.newWriteableStream)(U=>U.join("")),m=[];let P=0,O;const N=new R.CancellationTokenSource,L=async()=>{try{const U=await i({buffer:F.VSBuffer.concat(m),bytesRead:P},f.guessEncoding);if(U.seemsBinary&&f.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);U.encoding=await f.overwriteEncoding(U.encoding),O=await y.create(U.encoding);const x=O.write(F.VSBuffer.concat(m).buffer);h.write(x),m.length=0,P=0,I({stream:h,detected:U})}catch(U){N.cancel(),h.destroy(),E(U)}};(0,D.listenStream)(l,{onData:async U=>{O?h.write(O.write(U.buffer)):(m.push(U),P+=U.byteLength,P>=S&&(l.pause(),await L(),setTimeout(()=>l.resume())))},onError:U=>h.error(U),onEnd:async()=>{O||await L(),h.end(O?.end())}},N.token)})}e.toDecodeStream=C;async function w(l,f,S){const E=(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(f),S);let h=!1,m=!1;return{read(){if(m)return null;const P=l.read();if(typeof P!="string"){if(m=!0,!h&&S?.addBOM)switch(f){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const O=E.end();return O&&O.length>0?(h=!0,F.VSBuffer.wrap(O)):null}return h=!0,F.VSBuffer.wrap(E.write(P))}}}e.toEncodeReadable=w;async function s(l){return(await(0,d.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(l))}e.encodingExists=s;function o(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=o;function a(l,f){if(!l||f<e.UTF16be_BOM.length)return null;const S=l.readUInt8(0),I=l.readUInt8(1);if(S===e.UTF16be_BOM[0]&&I===e.UTF16be_BOM[1])return e.UTF16be;if(S===e.UTF16le_BOM[0]&&I===e.UTF16le_BOM[1])return e.UTF16le;if(f<e.UTF8_BOM.length)return null;const E=l.readUInt8(2);return S===e.UTF8_BOM[0]&&I===e.UTF8_BOM[1]&&E===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const c=["ascii","utf-16","utf-32"];async function g(l){const f=await(0,d.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),S=l.slice(0,T),I=n(S.buffer),E=f.detect(I);if(!E||!E.encoding)return null;const h=E.encoding.toLowerCase();return 0<=c.indexOf(h)?null:t(E.encoding)}const u={ibm866:"cp866",big5:"cp950"};function t(l){const f=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return u[f]||f}function n(l){let f="";for(let S=0;S<l.length;S++)f+=String.fromCharCode(l[S]);return f}function r(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const f=l.match(/windows(\d+)/);return f?"windows-"+f[1]:l}}}e.toCanonicalName=r;function i({buffer:l,bytesRead:f},S){let I=a(l,f),E=!1;if(I!==e.UTF16be&&I!==e.UTF16le&&l){let h=!0,m=!0,P=!1;for(let O=0;O<f&&O<p;O++){const N=O%2===1,L=l.readUInt8(O)===0;if(L&&(P=!0),h&&(N&&!L||!N&&L)&&(h=!1),m&&(N&&L||!N&&!L)&&(m=!1),L&&!h&&!m)break}P&&(h?I=e.UTF16le:m?I=e.UTF16be:E=!0)}return S&&!E&&!I&&l?g(l.slice(0,f)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:E,encoding:I}}e.detectEncodingFromBuffer=i,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[154],De([1,0,361,29,153]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends d.TextSearchManager{constructor(p,_,b=F,T="searchProcess"){super(p,_,{readdir:k=>b.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,D.toCanonicalName)(k)},T)}}e.NativeTextSearchManager=R}),define(Ce[155],De([1,0,48,377,360,19,74,35,16,15,2,36,93,378,358,116]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const s=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(m){this.outputChannel=m}provideTextSearchResults(m,P,O,N){return this.outputChannel.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((L,U)=>{N.onCancellationRequested(()=>z());const x=n(m,P),M=P.folder.fsPath,H=x.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.outputChannel.appendLine(`${s} ${H}
 - cwd: ${M}`);let j=D.spawn(s,x,{cwd:M});j.on("error",G=>{console.error(G),this.outputChannel.appendLine("Error: "+(G&&G.message)),U((0,k.serializeSearchError)(new k.SearchError(G&&G.message,k.SearchErrorCode.rgProcessError)))});let fe=!1;const Y=new g(P.maxResults,M,P.previewOptions);Y.on("result",G=>{fe=!0,ge="",O.report(G)});let X=!1;const z=()=>{X=!0,j?.kill(),Y?.cancel()};let J=!1;Y.on("hitLimit",()=>{J=!0,z()});let ge="";j.stdout.on("data",G=>{Y.handleData(G),fe||(ge+=G)});let le=!1;j.stdout.once("data",()=>le=!0);let we="";j.stderr.on("data",G=>{const B=G.toString();this.outputChannel.appendLine(B),we.length+B.length<1e6&&(we+=B)}),j.on("close",()=>{if(this.outputChannel.appendLine(le?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(fe?"Got result from parser":"No result from parser"),ge&&this.outputChannel.appendLine(`Got data without result: ${ge}`),this.outputChannel.appendLine(""),X)L({limitHit:J});else{Y.flush(),j=null;let G;we&&!le&&(G=a(we))?U((0,k.serializeSearchError)(new k.SearchError(G.message,G.code))):L({limitHit:J})}})})}}e.RipgrepTextSearchEngine=o;function a(h){const m=h.split(`
`),P=m[0].trim();if(m.some(N=>N.startsWith("regex parse error")))return new k.SearchError(c(m),k.SearchErrorCode.regexParseError);const O=P.match(/grep config error: unknown encoding: (.*)/);if(O)return new k.SearchError(`Unknown encoding: ${O[1]}`,k.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new k.SearchError(P.charAt(0).toUpperCase()+P.substr(1),k.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(P,k.SearchErrorCode.regexParseError)}function c(h){const m=["Regex parse error"],P=h.filter(O=>O.startsWith("PCRE2:"));if(P.length>=1){const O=P[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];m.push(":"+N)}}return m.join("")}class g extends F.EventEmitter{constructor(m,P,O){super(),this.maxResults=m,this.rootFolder=P,this.previewOptions=O,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new d.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(m,P){return super.on(m,P),this}handleData(m){if(this.isDone)return;const P=typeof m=="string"?m:this.stringDecoder.write(m);this.handleDecodedData(P)}handleDecodedData(m){let P=m.indexOf(`
`);const O=this.remainder+m;if(P>=0)P+=this.remainder.length;else{this.remainder=O;return}let N=0;for(;P>=0;)this.handleLine(O.substring(N,P).trim()),N=P+1,P=O.indexOf(`
`,N);this.remainder=O.substring(N)}handleLine(m){if(this.isDone||!m)return;let P;try{P=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(P.type==="match"){const O=u(P.data.path),N=T.URI.file(_.join(this.rootFolder,O)),L=this.createTextSearchMatch(P.data,N);this.onResult(L),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const O=u(P.data.path),N=T.URI.file(_.join(this.rootFolder,O));this.createTextSearchContext(P.data,N).forEach(U=>this.onResult(U))}}createTextSearchMatch(m,P){const O=m.line_number-1,N=u(m.lines),L=Buffer.from(N);let U=0,x=0,M=O;m.submatches.length===0&&m.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const H=(0,R.coalesce)(m.submatches.map((j,fe)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const Y=u(j.match),X=L.slice(U,j.start).toString(),z=t(X),J=z.numLines>0?z.lastLineLength:z.lastLineLength+x,ge=t(Y),le=z.numLines+M,we=ge.numLines+le,G=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+J;return U=j.end,x=G,M=we,new v.Range(le,J,we,G)}));return(0,w.createTextSearchResult)(P,N,H,this.previewOptions)}createTextSearchContext(m,P){const O=u(m.lines),N=m.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((L,U)=>({text:L,uri:P,lineNumber:N+U}))}onResult(m){this.emit("result",m)}}e.RipgrepParser=g;function u(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function t(h){const m=/\n/g;let P=0,O=-1,N;for(;N=m.exec(h);)P++,O=N.index;const L=O>=0?h.length-O-1:h.length;return{numLines:P,lastLineLength:L}}function n(h,m){const P=["--hidden","--no-require-git"];P.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,A.groupBy)(m.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const U=new Set;N.forEach(x=>{U.add(x)}),P.push("-g","!*"),U.forEach(x=>{r(x).map(w.anchorGlob).forEach(M=>{P.push("-g",M)})})}O&&O.length&&O.forEach(U=>{P.push("-g",U)}),m.excludes.map(w.anchorGlob).forEach(U=>P.push("-g",`!${U}`)),m.maxFileSize&&P.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),m.followSymlinks&&P.push("--follow"),m.encoding&&m.encoding!=="utf8"&&P.push("--encoding",m.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,b.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),m.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),P.push("--engine","auto"));let L;if(h.isWordMatch){const x=(0,b.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",x)}else if(h.isRegExp){let U=f(h.pattern);U=S(U),P.push("--regexp",U)}else L=h.pattern,P.push("--fixed-strings");return P.push("--no-config"),m.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),h.isMultiline&&P.push("--multiline"),m.beforeContext&&P.push("--before-context",m.beforeContext+""),m.afterContext&&P.push("--after-context",m.afterContext+""),P.push("--"),L&&P.push(L),P.push("."),P}e.getRgArgs=n;function r(h){return E(h).flatMap(P=>{const O=(0,p.splitGlobAware)(P,"/");return O.map((N,L)=>O.slice(0,L+1).join("/"))})}function i(h){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(m);)h=h.replace(m,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(P);)h=h.replace(P,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=i;const l=h=>h.type==="Assertion"&&h.kind==="lookbehind";function f(h){let m;try{m=new y.RegExpParser().parsePattern(h)}catch{return h}let P="",O=0;const N=(x,M,H)=>{P+=h.slice(O,x)+H,O=M},L=[];return new y.RegExpVisitor({onCharacterEnter(x){if(x.raw!=="\\n")return;const M=L[0];if(!M)N(x.start,x.end,"\\r?\\n");else if(!L.some(l))if(M.type==="CharacterClass")if(M.negate){const H=h.slice(M.start+2,x.start)+h.slice(x.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,H?`[^${H}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=h.slice(M.start+1,x.start)+h.slice(x.end,M.end-1);N(M.start,M.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(x.start,x.end,"(?:\\r?\\n)")},onQuantifierEnter(x){L.unshift(x)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(x){L.unshift(x)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(x){L.unshift(x)},onCharacterClassLeave(){L.shift()},onAssertionEnter(x){l(x)&&L.push(x)},onAssertionLeave(x){L[0]===x&&L.shift()}}).visit(m),P+=h.slice(O),P}e.fixRegexNewline=f;function S(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=S;function I(h){let m=!1,P=!1,O="",N="";for(let L=0;L<h.length;L++){const U=h[L];switch(U){case"\\":P?(m?N+="\\"+U:O+="\\"+U,P=!1):P=!0;break;case"{":if(P)m?N+=U:O+=U,P=!1;else{if(m)return{strInBraces:O+"{"+N+"{"+h.substring(L+1)};m=!0}break;case"}":if(P)m?N+=U:O+=U,P=!1;else{if(m)return{fixedStart:O,strInBraces:N,fixedEnd:h.substring(L+1)};O+=U}break;default:m?N+=(P?"\\":"")+U:O+=(P?"\\":"")+U,P=!1;break}}return{strInBraces:O+(m?"{"+N:"")}}function E(h){const{fixedStart:m,strInBraces:P,fixedEnd:O}=I(h);if(m===void 0||O===void 0)return[P];let N=(0,p.splitGlobAware)(P,",");N.length||(N=[""]);const L=E(O);return N.flatMap(U=>{const x=m+U;return L.map(M=>x+M)})}e.performBraceExpansionForRipgrep=E}),define(Ce[362],De([1,0,21,155,64,17]),function(pe,e,D,F,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(b){this.outputChannel=b,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(b,T,k,v){const y=new F.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===R.Schemas.vscodeUserData){const C={...T,folder:T.folder.with({scheme:R.Schemas.file})},w=new d.Progress(s=>k.report({...s,uri:s.uri.with({scheme:T.folder.scheme})}));return this.withToken(v,s=>y.provideTextSearchResults(b,C,w,s))}else return this.withToken(v,C=>y.provideTextSearchResults(b,T,k,C))}async withToken(b,T){const k=p(b);this.inProgress.add(k);const v=await T(k.token);return this.inProgress.delete(k),v}dispose(){this.inProgress.forEach(b=>b.cancel())}}e.RipgrepSearchProvider=A;function p(_){const b=new D.CancellationTokenSource;return _.onCancellationRequested(()=>b.cancel()),b}}),define(Ce[363],De([1,0,29,155,154]),function(pe,e,D,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(_){this.query=_}search(_,b,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(y){T({message:y})}},v=new d.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(k),D);return new Promise((y,C)=>v.search(w=>{b(w.map(A))},_).then(w=>y({limitHit:w.limitHit,type:"success",stats:w.stats}),C))}}e.TextSearchEngineAdapter=R;function A(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((_,b)=>{if(b.ranges){const T=b;return _+(Array.isArray(T.ranges)?T.ranges.length:1)}else return _+1},0)}}}),define(Ce[364],De([1,0,19,9,8,4,127,16,37,2,30,36,359,363]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{static{this.BATCH_SIZE=512}constructor(g="searchProcess"){this.processType=g,this.caches=Object.create(null)}fileSearch(g){let u;const t=o(g),n=new R.Emitter({onDidAddFirstListener:()=>{u=(0,F.createCancelablePromise)(r=>this.doFileSearchWithEngine(v.Engine,t,i=>n.fire(i),r)),u.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{u.cancel()}});return n.event}textSearch(g){let u;const t=o(g),n=new R.Emitter({onDidAddFirstListener:()=>{u=(0,F.createCancelablePromise)(r=>this.ripgrepTextSearch(t,i=>n.fire(i),r)),u.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{u.cancel()}});return n.event}ripgrepTextSearch(g,u,t){return g.maxFileSize=this.getPlatformFileLimits().maxFileSize,new y.TextSearchEngineAdapter(g).search(t,u,u)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*T.ByteSize.MB:16*T.ByteSize.GB}}doFileSearch(g,u,t){return this.doFileSearchWithEngine(v.Engine,g,u,t)}doFileSearchWithEngine(g,u,t,n,r=C.BATCH_SIZE){let i=0;const l=S=>{Array.isArray(S)?(i+=S.length,t(S.map(I=>this.rawMatchToSearchItem(I)))):S.relativePath?(i++,t(this.rawMatchToSearchItem(S))):t(S)};if(u.sortByScore){let S=this.trySortedSearchFromCache(u,l,n);if(!S){const I=u.maxResults?Object.assign({},u,{maxResults:null}):u,E=new g(I);S=this.doSortedSearch(E,u,t,l,n)}return new Promise((I,E)=>{S.then(([h,m])=>{const P=m.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(P,t,r),I(h)},E)})}const f=new g(u);return this.doSearch(f,l,r,n).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(g){return{path:g.base?(0,p.join)(g.base,g.relativePath):g.relativePath}}doSortedSearch(g,u,t,n,r){const i=new R.Emitter;let l=(0,F.createCancelablePromise)(S=>{let I=[];const E=h=>{Array.isArray(h)?I=h:(n(h),i.fire(h))};return this.doSearch(g,E,-1,S).then(h=>[h,I])}),f;if(u.cacheKey){f=this.getOrCreateCache(u.cacheKey);const S={promise:l,event:i.event,resolved:!1};f.resultsToSearchCache[u.filePattern||""]=S,l.then(()=>{S.resolved=!0},I=>{delete f.resultsToSearchCache[u.filePattern||""]}),l=this.preventCancellation(l)}return l.then(([S,I])=>{const E=f?f.scorerCache:Object.create(null),h=(typeof u.maxResults!="number"||u.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(u,I,E,r).then(m=>{const P=h?h.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:P,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:m.length},messages:S.messages,limitHit:S.limitHit||typeof u.maxResults=="number"&&I.length>u.maxResults},m]})})}getOrCreateCache(g){const u=this.caches[g];return u||(this.caches[g]=new w)}trySortedSearchFromCache(g,u,t){const n=g.cacheKey&&this.caches[g.cacheKey];if(!n)return;const r=this.getResultsFromCache(n,g.filePattern||"",u,t);if(r)return r.then(([i,l,f])=>{const S=_.StopWatch.create(!1);return this.sortResults(g,l,n.scorerCache,t).then(I=>{const E=S.elapsed(),h={fromCache:!0,detailStats:f,type:this.processType,resultCount:l.length,sortingTime:E};return[{type:"success",limitHit:i.limitHit||typeof g.maxResults=="number"&&l.length>g.maxResults,stats:h},I]})})}sortResults(g,u,t,n){const r=(0,A.prepareQuery)(g.filePattern||""),i=(f,S)=>(0,A.compareItemsByFuzzyScore)(f,S,r,!0,s,t),l=typeof g.maxResults=="number"?g.maxResults:Number.MAX_VALUE;return D.topAsync(u,i,l,1e4,n)}sendProgress(g,u,t){if(t&&t>0)for(let n=0;n<g.length;n+=t)u(g.slice(n,n+t));else u(g)}getResultsFromCache(g,u,t,n){const r=_.StopWatch.create(!1),i=u.indexOf(p.sep)>=0;let l;for(const E in g.resultsToSearchCache)if(u.startsWith(E)){if(i&&E.indexOf(p.sep)<0&&E!=="")continue;const h=g.resultsToSearchCache[E];l={promise:this.preventCancellation(h.promise),event:h.event,resolved:h.resolved};break}if(!l)return null;const f=r.elapsed(),S=_.StopWatch.create(!1),I=l.event(t);return n&&n.onCancellationRequested(()=>{I.dispose()}),l.promise.then(([E,h])=>{if(n&&n.isCancellationRequested)throw(0,d.canceled)();const m=[],P=(0,A.prepareQuery)(u).normalizedLowercase;for(const O of h)(0,k.isFilePatternMatch)(O,P)&&m.push(O);return[E,m,{cacheWasResolved:l.resolved,cacheLookupTime:f,cacheFilterTime:S.elapsed(),cacheEntryCount:h.length}]})}doSearch(g,u,t,n){return new Promise((r,i)=>{let l=[];n?.onCancellationRequested(()=>g.cancel()),g.search(f=>{f&&(t?(l.push(f),t>0&&l.length>=t&&(u(l),l=[])):u(f))},f=>{u(f)},(f,S)=>{l.length&&u(l),f?i(f):r(S)})})}clearCache(g){return delete this.caches[g],Promise.resolve(void 0)}preventCancellation(g){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,t){return g.then(u,t)}catch(u){return this.then(void 0,u)}finally(u){return g.finally(u)}}}}e.SearchService=C;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const s=new class{getItemLabel(c){return(0,p.basename)(c.relativePath)}getItemDescription(c){return(0,p.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function o(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(a),extraFileResources:c.extraFileResources&&c.extraFileResources.map(g=>b.URI.revive(g))}}function a(c){return{...c,folder:b.URI.revive(c.folder)}}}),define(Ce[365],De([1,0,3,17,2,29,14,26,20,96,67,36,364,362,116,154]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let s=class extends b.ExtHostSearch{constructor(a,c,g,u){super(a,g,u),this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new D.DisposableStore;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.RipgrepSearchProvider(t))),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const a=new C.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.file,new y.RipgrepSearchProvider(a))),this._disposables.add(this.registerInternalFileSearchProvider(F.Schemas.file,new v.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(a,c){const g=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=g,this._proxy.$registerFileSearchProvider(g,this._transformScheme(a)),(0,D.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(a,c,g,u){const t=(0,b.reviveQuery)(g);return a===this._internalFileSearchHandle?this.doInternalFileSearch(a,c,t,u):super.$provideFileSearchResults(a,c,g,u)}doInternalFileSearch(a,c,g,u){const t=n=>{if((0,k.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(a,c,n.map(r=>d.URI.file(r.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(g,t,u)}$clearCache(a){return this._internalFileSearchProvider?.clearCache(a),super.$clearCache(a)}createTextSearchManager(a,c){return new w.NativeTextSearchManager(a,c,void 0,"textSearchProvider")}};e.NativeExtHostSearch=s,e.NativeExtHostSearch=s=je([$e(0,_.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,T.IURITransformerService),$e(3,A.ILogService)],s)}),define(Ce[117],De([1,0,379,60,63,380,22,8,4,3,16,12,31,81,82]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(h,m){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,m)}constructor(h,m=""){this._canWrite=!0,this.debugLabel=m,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,p.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(h){const m=P=>{this.traceSocketEvent("read",P),h(A.VSBuffer.wrap(P))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(h){const m=P=>{h({type:0,hadError:P,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(h){const m=()=>{h()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(h){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,p.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,p.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=w;var s;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var o;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(o||(o={}));class a extends b.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(h,m){this.socket.traceSocketEvent(h,m)}constructor(h,m,P,O){super(),this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:P?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new c(this,m,P,O,this._onData,(N,L)=>this._write(N,L))),this._register(this._flowManager.onError(N=>{console.error(N),(0,p.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await _.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let m=0;for(;m<h.byteLength;)this._flowManager.writeMessage(h.slice(m,Math.min(m+262144,h.byteLength))),m+=262144}_write(h,m){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let P=2;h.byteLength<126?P+=0:h.byteLength<2**16?P+=2:P+=8;const O=A.VSBuffer.alloc(P);if(m?O.writeUInt8(194,0):O.writeUInt8(130,0),h.byteLength<126)O.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(h.byteLength>>>8&255,++N),O.writeUInt8(h.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(h.byteLength>>>24&255,++N),O.writeUInt8(h.byteLength>>>16&255,++N),O.writeUInt8(h.byteLength>>>8&255,++N),O.writeUInt8(h.byteLength>>>0&255,++N)}this.socket.write(A.VSBuffer.concat([O,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),P=m.readUInt8(0),O=(P&128)>>>7,N=(P&64)>>>6,L=m.readUInt8(1),U=(L&128)>>>7,x=L&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!O,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),P=m.readUInt8(1),O=(P&128)>>>7;let N=P&127,L=1;N===126?N=m.readUInt8(++L)*2**8+m.readUInt8(++L):N===127&&(N=m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*2**24+m.readUInt8(++L)*2**16+m.readUInt8(++L)*2**8+m.readUInt8(++L));let U=0;O&&(U=m.readUInt8(++L)*2**24+m.readUInt8(++L)*2**16+m.readUInt8(++L)*2**8+m.readUInt8(++L)),this._state.state=3,this._state.readLen=N,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),t(m,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(m,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await _.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=a;class c extends b.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(h,m,P,O,N,L){super(),this._tracer=h,this._onData=N,this._writeFn=L,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new _.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new _.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,m?(this._zlibInflateStream=this._register(new g(this._tracer,O,P,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(h){this._writeQueue.push(h),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const h=this._writeQueue.shift();if(this._zlibDeflateStream){const m=await this._deflateMessage(this._zlibDeflateStream,h);this._writeFn(m,!0)}else this._writeFn(h,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(h,m){return new Promise((P,O)=>{h.write(m),h.flush(N=>P(N))})}acceptFrame(h,m,P){this._readQueue.push({data:h,isCompressed:m,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const h=this._readQueue.shift();if(this._zlibInflateStream&&h.isCompressed){const m=await this._inflateFrame(this._zlibInflateStream,h.data,h.isLastFrameOfMessage);this._onData.fire(m)}else this._onData.fire(h.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(h,m,P){return new Promise((O,N)=>{h.write(m),P&&h.write(A.VSBuffer.fromByteArray([0,0,255,255])),h.flush(L=>O(L))})}}class g extends b.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(h,m,P,O){super(),this._tracer=h,this._recordInflateBytes=m,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,R.createInflateRaw)(O),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(A.VSBuffer.wrap(N))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(h){this._recordInflateBytes&&this._recordedInflateBytes.push(h.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",h),this._zlibInflate.write(h.buffer)}flush(h){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const m=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,h(m)})}}class u extends b.Disposable{constructor(h,m){super(),this._tracer=h,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,R.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(A.VSBuffer.wrap(P))})}write(h){this._tracer.traceSocketEvent("zlibDeflateWrite",h.buffer),this._zlibDeflate.write(h.buffer)}flush(h){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let m=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.byteLength-4),h(m)})}}function t(E,h){if(h===0)return;const m=E.byteLength>>>2;for(let x=0;x<m;x++){const M=E.readUInt32BE(x*4);E.writeUInt32BE(M^h,x*4)}const P=m*4,O=E.byteLength-P,N=h>>>24&255,L=h>>>16&255,U=h>>>8&255;O>=1&&E.writeUInt8(E.readUInt8(P)^N,P),O>=2&&E.writeUInt8(E.readUInt8(P+1)^L,P+1),O>=3&&E.writeUInt8(E.readUInt8(P+2)^U,P+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function r(){const E=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const h=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,d.tmpdir)(),m=(0,T.join)(h,`vscode-ipc-${E}.sock`);return l(m),m}e.createRandomIPCHandle=r;function i(E,h,m){const P=(0,D.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${m}-${h}-sock`;const O=m.substr(0,4),N=h.substr(0,6),L=P.substr(0,8);let U;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${L}-${O}-${N}.sock`):U=(0,T.join)(E,`${O}-${N}.sock`),l(U),U}e.createStaticIPCHandle=i;function l(E){const h=n[k.platform];typeof h=="number"&&E.length>=h&&console.warn(`WARNING: IPC handle "${E}" is longer than ${h} chars, try a shorter --user-data-dir`)}class f extends y.IPCServer{static toClientConnectionEvent(h){const m=_.Event.fromNodeEventEmitter(h,"connection");return _.Event.map(m,P=>({protocol:new C.Protocol(new w(P,"ipc-server-connection")),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(P,"close"))}))}constructor(h){super(f.toClientConnectionEvent(h)),this.server=h}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=f;function S(E){return new Promise((h,m)=>{const P=(0,F.createServer)();P.on("error",m),P.listen(E,()=>{P.removeListener("error",m),h(new f(P))})})}e.serve=S;function I(E,h){return new Promise((m,P)=>{const O=(0,F.createConnection)(E,()=>{O.removeListener("error",P),m(C.Client.fromSocket(new w(O,`ipc-client${h}`),h))});O.once("error",P)})}e.connect=I}),define(Ce[366],De([1,0,60,63,163,117,9,3,12,49,14,135,247,248,107,86,22]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function o(t,n,r,i,l){let f;for(let S=3;S&&(f?.dispose(),f=await new a(t,n,r,i,l).waitForReady(),!(l&&d.BROWSER_RESTRICTED_PORTS[l]||!d.BROWSER_RESTRICTED_PORTS[f.tunnelLocalPort]));S--);return f}class a extends p.Disposable{constructor(n,r,i,l,f){super(),this.defaultTunnelHost=r,this.suggestedLocalPort=f,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=n,this._server=D.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=S=>this._onConnection(S),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(r=>{r()})}async waitForReady(){const n=this.suggestedLocalPort??this.tunnelRemotePort,r=(0,w.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,d.findFreePortFaster)(n,2,1e3,r),l=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(n){n.pause();const r=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.connectRemoteAgentTunnel)(this._options,r,this.tunnelRemotePort),l=i.getSocket(),f=i.readEntireBuffer();i.dispose(),f.byteLength>0&&n.write(f.buffer),n.on("end",()=>{n.localAddress&&this._socketsDispose.delete(n.localAddress),l.end()}),n.on("close",()=>l.end()),n.on("error",()=>{n.localAddress&&this._socketsDispose.delete(n.localAddress),l instanceof R.NodeSocket?l.socket.destroy():l.end()}),l instanceof R.NodeSocket?this._mirrorNodeSocket(n,l):this._mirrorGenericSocket(n,l),n.localAddress&&this._socketsDispose.set(n.localAddress,()=>{n.end(),l.end()})}_mirrorGenericSocket(n,r){r.onClose(()=>n.destroy()),r.onEnd(()=>n.end()),r.onData(i=>n.write(i.buffer)),n.on("data",i=>r.write(s.VSBuffer.wrap(i))),n.resume()}_mirrorNodeSocket(n,r){const i=r.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.NodeRemoteTunnel=a;let c=class extends w.AbstractTunnelService{constructor(n,r,i,l,f){super(r,f),this.remoteSocketFactoryService=n,this.signService=i,this.productService=l}isPortPrivileged(n){return(0,w.isPortPrivileged)(n,this.defaultTunnelHost,_.OS,F.release())}retainOrCreateTunnel(n,r,i,l,f,S,I,E){const h=this.getTunnelFromMap(r,i);if(h)return++h.refcount,h.value;if((0,w.isTunnelProvider)(n))return this.createWithProvider(n,r,i,f,S,I,E);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${f}.`);const m={commit:this.productService.commit,quality:this.productService.quality,addressProvider:n,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},P=o(m,l,r,i,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(r,i,P),P}}};e.BaseTunnelService=c,e.BaseTunnelService=c=je([$e(0,y.IRemoteSocketFactoryService),$e(1,T.ILogService),$e(2,C.ISignService),$e(3,k.IProductService),$e(4,b.IConfigurationService)],c);let g=class extends c{constructor(n,r,i,l,f){super(n,r,i,l,f)}};e.TunnelService=g,e.TunnelService=g=je([$e(0,y.IRemoteSocketFactoryService),$e(1,T.ILogService),$e(2,C.ISignService),$e(3,k.IProductService),$e(4,b.IConfigurationService)],g);let u=class extends p.Disposable{constructor(n,r,i,l,f){super(),this.remoteSocketFactoryService=n,this.logService=r,this.productService=i,this.signService=l,this.configurationService=f,this._tunnelServices=new Map}async openTunnel(n,r,i,l,f,S,I,E,h){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${l} on local port ${S}.`),!this._tunnelServices.has(n)){const m=new g(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(m),this._tunnelServices.set(n,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this._tunnelServices.delete(n))})}return this._tunnelServices.get(n).openTunnel(r,i,l,f,S,I,E,h)}};e.SharedTunnelsService=u,e.SharedTunnelsService=u=je([$e(0,y.IRemoteSocketFactoryService),$e(1,T.ILogService),$e(2,k.IProductService),$e(3,C.ISignService),$e(4,b.IConfigurationService)],u)}),define(Ce[367],De([1,0,117,267,52,33,2,14,43]),function(pe,e,D,F,d,R,A,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class b{constructor(v,y,C){this._commands=v,this.logService=y,this._ipcHandlePath=C,this._server=F.createServer((w,s)=>this.onRequest(w,s)),this.setup().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",v=>this.logService.error(v))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(v,y){const C=(s,o)=>{y.writeHead(s,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),a=>a&&this.logService.error(a))},w=[];v.setEncoding("utf8"),v.on("data",s=>w.push(s)),v.on("end",async()=>{try{const s=JSON.parse(w.join(""));let o;switch(s.type){case"open":o=await this.open(s);break;case"openExternal":o=await this.openExternal(s);break;case"status":o=await this.getStatus(s);break;case"extensionManagement":o=await this.manageExtensions(s);break;default:C(404,`Unknown message type: ${s.type}`);break}C(200,o)}catch(s){const o=s instanceof Error?s.message:JSON.stringify(s);C(500,o),this.logService.error("Error while processing pipe request",s)}})}async open(v){const{fileURIs:y,folderURIs:C,forceNewWindow:w,diffMode:s,mergeMode:o,addMode:a,forceReuseWindow:c,gotoLineMode:g,waitMarkerFilePath:u,remoteAuthority:t}=v,n=[];if(Array.isArray(C))for(const f of C)try{n.push({folderUri:A.URI.parse(f)})}catch{}if(Array.isArray(y))for(const f of y)try{(0,_.hasWorkspaceFileExtension)(f)?n.push({workspaceUri:A.URI.parse(f)}):n.push({fileUri:A.URI.parse(f)})}catch{}const r=u?A.URI.file(u):void 0,l={forceNewWindow:w,diffMode:s,mergeMode:o,addMode:a,gotoLineMode:g,forceReuseWindow:c,preferNewWindow:!c&&!r&&!a,waitMarkerFileURI:r,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",n,l)}async openExternal(v){for(const y of v.uris){const C=A.URI.parse(y),w=C.scheme==="file"?C:y;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(v){const y=w=>w?.map(s=>/\.vsix$/i.test(s)?A.URI.parse(s):s),C={list:v.list,install:y(v.install),uninstall:y(v.uninstall),force:v.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",C)}async getStatus(v){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&d.existsSync(this._ipcHandlePath)&&d.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=b;let T=class extends b{constructor(v,y){super(v,y,(0,D.createRandomIPCHandle)())}};e.CLIServer=T,e.CLIServer=T=je([$e(0,R.IExtHostCommands),$e(1,p.ILogService)],T)}),define(Ce[368],De([1,0,53,355,350,266,45,338,2,17,7,367,101,336,337]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends d.RequireInterceptor{_installInterceptor(){const a=this,c=globalThis._VSCODE_NODE_MODULES.module,g=c._load;c._load=function(r,i,l){return r=t(r),a._factories.has(r)?a._factories.get(r).load(r,_.URI.file((0,v.realpathSync)(i.filename)),f=>g.apply(this,[f,i,l])):g.apply(this,arguments)};const u=c._resolveLookupPaths;c._resolveLookupPaths=(n,r)=>u.call(this,t(n),r);const t=n=>{for(const r of a._alternatives){const i=r(n);if(i){n=i;break}}return n}}}class s extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const a=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(p.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const u=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=u.ipcHandlePath}this._instaService.createInstance(C.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(w,a,{mine:this._myRegistry,all:this._globalRegistry}).install(),D.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),D.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(a){return a.main}async _loadCommonJSModule(a,c,g){if(c.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${c}', must be of file-scheme`);let u=null;g.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${c.toString(!0)}`),this._logService.flush();const t=a?.identifier.value;a&&await this._extHostLocalizationService.initializeLocalizedMessages(a);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),u=pe.__$__nodeRequire(c.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}return u}async $setRemoteEnvironment(a){if(this._initData.remote.isRemote)for(const c in a){const g=a[c];g===null?delete process.env[c]:process.env[c]=g}}}e.ExtHostExtensionService=s}),define(Ce[369],De([1,0,48,22,4,3,120,12,24,2,29,14,246,65,107,86,366,26,20,73,346]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function u(h){const m=h.trim().split(`
`),P=[];return m.forEach(N=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);L&&L.length>=3&&P.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),P.reduce((N,L)=>(N[L.socket]=L,N),{})}e.getSockets=u;function t(...h){const m=[].concat(...h.map(r));return[...new Map(m.filter(P=>P.st==="0A").map(P=>{const O=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(O[0]),port:parseInt(O[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.loadListeningPorts=t;function n(h){let m="";if(h.length===8)for(let P=h.length-2;P>=0;P-=2)m+=parseInt(h.substr(P,2),16),P!==0&&(m+=".");else for(let P=0;P<h.length;P+=8){const O=h.substring(P,P+8);let N="";for(let L=8;L>=2;L-=2)N+=O.substring(L-2,L),(L===6||L===2)&&(N=parseInt(N,16).toString(16),m+=`${N}`,N="",P+L!==h.length-6&&(m+=":"))}return m}e.parseIpAddress=n;function r(h){const m=h.trim().split(`
`),P=m.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return m.map(N=>N.trim().split(/\s+/).reduce((L,U,x)=>(L[P[x]||x]=U,L),{}))}e.loadConnectionTable=r;function i(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/server-main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function l(h){const m=h.trim().split(`
`),P=[];return m.forEach(O=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);N&&N.length>=4&&P.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),P}e.getRootProcesses=l;async function f(h,m,P){const O=P.reduce((L,U)=>(L[U.pid]=U,L),{}),N=[];return h.forEach(({socket:L,ip:U,port:x})=>{const M=m[L]?m[L].pid:void 0,H=M?O[M]?.cmd:void 0;M&&H&&!i(H)&&N.push({host:U,port:x,detail:H,pid:M})}),N}e.findPorts=f;function S(h,m,P){const O=new Map,N=l(m);for(const L of h){const U=P.get(L.port);if(U){O.set(L.port,U);continue}const x=N.find(M=>M.cmd.includes(`${L.port}`));if(x){let M=x,H;do H=N.find(j=>j.ppid===M.pid),H&&(M=H);while(H);O.set(L.port,{host:L.ip,port:L.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else O.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return O}e.tryFindRootPorts=S;let I=class extends c.ExtHostTunnelService{constructor(m,P,O,N){super(m,P,O),this.initData=P,this.signService=N,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,p.isLinux&&P.remote.isRemote&&P.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let P;this._initialCandidates&&(P=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const O=new A.MovingAverage;let N=0;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),U=(await this.findCandidatePorts()).filter(H=>(0,w.isLocalhost)(H.host)||(0,w.isAllInterfaces)(H.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(H=>H.port).join(", ")}`);const x=new Date().getTime()-L;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${x} ms.`),N++>3&&O.update(x),(!P||JSON.stringify(P)!==JSON.stringify(U))&&(P=U,await this._proxy.$onFoundNewCandidates(P));const M=this.calculateDelay(O.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(H=>setTimeout(()=>H(),M))}}calculateDelay(m){return Math.max(m*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(m=>m.port).join(", ")}`)}async findCandidatePorts(){let m="",P="";try{m=await T.Promises.readFile("/proc/net/tcp","utf8"),P=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(m,P),N=await new Promise(Y=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,z,J)=>{Y(z)})}),L=u(N),U=await T.Promises.readdir("/proc"),x=[];for(const Y of U)try{const X=Number(Y),z=_.joinPath(b.URI.file("/proc"),Y);if((await T.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(X)){const ge=await T.Promises.readlink(_.joinPath(z,"cwd").fsPath),le=await T.Promises.readFile(_.joinPath(z,"cmdline").fsPath,"utf8");x.push({pid:X,cwd:ge,cmd:le})}}catch{}const M=[],H=O.filter(Y=>{const X=L[Y.socket];return X||M.push(Y),X}),j=f(H,L,x);let fe;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const Y=await new Promise(X=>{(0,D.exec)("ps -F -A -l | grep root",(z,J,ge)=>{X(J)})});this._foundRootPorts=S(M,Y,this._foundRootPorts),fe=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(X=>X.port).join(", ")}`)}return j.then(Y=>fe?Y.concat(fe):Y)}makeManagedTunnelFactory(m){return async P=>{const O=new s.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(L,U,x,M){const H=await m.makeConnection();return E.connect(H,U,x,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.ManagedRemoteConnection(0),connectionToken:m.connectionToken})}},signService:this.signService},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await O.waitForReady();const N=new d.Emitter;return{localAddress:(0,g.parseAddress)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{O.dispose(),N.fire(),N.dispose()}}}}};e.NodeExtHostTunnelService=I,e.NodeExtHostTunnelService=I=je([$e(0,a.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,k.ILogService),$e(3,C.ISignService)],I);class E extends v.ManagedSocket{static connect(m,P,O,N){const L=new R.DisposableStore,U={onClose:L.add(new d.Emitter),onData:L.add(new d.Emitter),onEnd:L.add(new d.Emitter)};L.add(m.onDidReceiveMessage(M=>U.onData.fire(F.VSBuffer.wrap(M)))),L.add(m.onDidEnd(()=>U.onEnd.fire())),L.add(m.onDidClose(M=>U.onClose.fire({type:0,error:M,hadError:!!M})));const x=new E(m,N,U);return x._register(L),(0,v.connectManagedSocket)(x,P,O,N,U)}constructor(m,P,O){super(P,O),this.passing=m}write(m){this.passing.send(m.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(Ce[370],De([1,0,104,341,353,352,365,368,369,95,45,96,94,44,73,91,340,339,14,354,55,261,103,107,138]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o,a,c,g,u,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.registerSingleton)(T.IExtHostExtensionService,p.ExtHostExtensionService,0),(0,D.registerSingleton)(a.ILoggerService,o.ExtHostLoggerService,1),(0,D.registerSingleton)(a.ILogService,new t.SyncDescriptor(u.ExtHostLogService,[!1],!0)),(0,D.registerSingleton)(n.ISignService,r.SignService,1),(0,D.registerSingleton)(w.IExtensionStoragePaths,s.ExtensionStoragePaths,0),(0,D.registerSingleton)(b.IExtHostDebugService,R.ExtHostDebugService,0),(0,D.registerSingleton)(k.IExtHostSearch,A.NativeExtHostSearch,0),(0,D.registerSingleton)(v.IExtHostTask,d.ExtHostTask,0),(0,D.registerSingleton)(y.IExtHostTerminalService,F.ExtHostTerminalService,0),(0,D.registerSingleton)(C.IExtHostTunnelService,_.NodeExtHostTunnelService,0),(0,D.registerSingleton)(g.IExtHostVariableResolverProvider,c.NodeExtHostVariableResolverProviderService,0)}),define(Ce[381],De([1,0,60,382,53,8,82,117,244,111,351,22,29,101,9,130,268,285,356,370]),function(pe,e,D,F,d,R,A,p,_,b,T,k,v,y,C,w,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const a=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,f=l._load;l._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const c=process.exit.bind(process);function g(l){process.exit=function(f){if(l)c(f);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let u=function(l){c()};function t(){const l=(0,o.readExtHostConnection)(process.env);if(l.type===3)return new Promise((f,S)=>{const I=E=>{const h=E[0],m=new A.BufferedEmitter;h.on("message",P=>m.fire(k.VSBuffer.wrap(P.data))),h.on("close",()=>{u("renderer closed the MessagePort")}),h.start(),f({onMessage:m.event,send:P=>h.postMessage(P.buffer)})};process.parentPort.on("message",E=>I(E.ports))});if(l.type===2)return new Promise((f,S)=>{let I=null;const E=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),h=108e5,m=3e5,P=new C.ProcessTimeRunOnceScheduler(()=>u("renderer disconnected for too long (1)"),h),O=new C.ProcessTimeRunOnceScheduler(()=>u("renderer disconnected for too long (2)"),m);process.on("message",(L,U)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const x=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let M;if(L.skipWebSocketFrames)M=new p.NodeSocket(U,"extHost-socket");else{const H=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));M=new p.WebSocketNodeSocket(new p.NodeSocket(U,"extHost-socket"),L.permessageDeflate,H,!1)}I?(P.cancel(),O.cancel(),I.beginAcceptReconnection(M,x),I.endAcceptReconnection(),I.sendResume()):(clearTimeout(E),I=new A.PersistentProtocol({socket:M,initialChunk:x}),I.sendResume(),I.onDidDispose(()=>u("renderer disconnected")),f(I),I.onSocketClose(()=>{P.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;P.isScheduled()&&O.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const f=l.pipeName;return new Promise((S,I)=>{const E=D.createConnection(f,()=>{E.removeListener("error",I);const h=new A.PersistentProtocol({socket:new p.NodeSocket(E,"extHost-renderer")});h.sendResume(),S(h)});E.once("error",I),E.on("close",()=>{u("renderer closed the socket")})})}}async function n(){const l=await t();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,l.onMessage(f=>{(0,b.isMessageOfType)(f,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(f)})}send(f){this._terminating||l.send(f)}async drain(){if(l.drain)return l.drain()}}}function r(l){return new Promise(f=>{const S=l.onMessage(I=>{S.dispose();const E=JSON.parse(I.toString()),h=E.commit,m=_.default.commit;if(h&&m&&h!==m&&c(55),E.parentPid){let P=0;setInterval(function(){try{process.kill(E.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&u(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):u(`parent process ${E.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(E.parentPid)}catch(N){(0,R.onUnexpectedError)(N)}}l.send((0,b.createMessageOfType)(0)),f({protocol:l,initData:E})});l.send((0,b.createMessageOfType)(1))})}async function i(){const l=[];process.on("unhandledRejection",(P,O)=>{l.push(O),setTimeout(()=>{const N=l.indexOf(O);N>=0&&O.catch(L=>{l.splice(N,1),(0,R.isCancellationError)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),P&&(0,R.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const O=l.indexOf(P);O>=0&&l.splice(O,1)}),process.on("uncaughtException",function(P){(0,R.isSigPipeError)(P)||(0,R.onUnexpectedError)(P)}),d.mark("code/extHost/willConnectToRenderer");const f=await n();d.mark("code/extHost/didConnectToRenderer");const S=await r(f);d.mark("code/extHost/didWaitForInitData");const{initData:I}=S;g(!!I.environment.extensionTestsLocationURI),I.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,I.environment.skipWorkspaceStorageLock=(0,w.boolean)(a.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(O){c(O)}fsExists(O){return v.Promises.exists(O)}fsRealpath(O){return(0,y.realpath)(O)}};let h=null;I.remote.authority&&a.transformURIs&&(h=(0,s.createURITransformer)(I.remote.authority));const m=new T.ExtensionHostMain(S.protocol,I,E,h);u=P=>m.terminate(P)}i().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/workbench/api/node/extensionHostProcess.js.map
