/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(be){for(var e=[],w=0,R=be.length;w<R;w++)e[w]=Te[be[w]];return e};define(Te[65],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(T){return(d,y,m)=>{let P=null,_=null;if(typeof m.value=="function"?(P="value",_=m.value):typeof m.get=="function"&&(P="get",_=m.get),!_)throw new Error("not supported");m[P]=T(_,y)}}function R(T,d,y){let m=null,P=null;if(typeof y.value=="function"?(m="value",P=y.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(m="get",P=y.get),!P)throw new Error("not supported");const _=`$memoize$${d}`;y[m]=function(...a){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,a)}),this[_]}}e.memoize=R;function k(T,d,y){return w((m,P)=>{const _=`$debounce$${P}`,a=`$debounce$result$${P}`;return function(...v){this[a]||(this[a]=y?y():void 0),clearTimeout(this[_]),d&&(this[a]=d(this[a],...v),v=[this[a]]),this[_]=setTimeout(()=>{m.apply(this,v),this[a]=y?y():void 0},T)}})}e.debounce=k;function F(T,d,y){return w((m,P)=>{const _=`$throttle$timer$${P}`,a=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...f){if(this[a]||(this[a]=y?y():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),d&&(this[a]=d(this[a],...f)),this[g])return;const t=this[v]+T;t<=Date.now()?(this[v]=Date.now(),m.apply(this,[this[a]]),this[a]=y?y():void 0):(this[g]=!0,this[_]=setTimeout(()=>{this[g]=!1,this[v]=Date.now(),m.apply(this,[this[a]]),this[a]=y?y():void 0},t-Date.now()))}})}e.throttle=F}),define(Te[88],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(Te[115],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var R;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var F;(function(r){r.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function T(r,s=!1){let i=0;const o=r.length;let S="",b=0,C=16,I=0;function c(z){let M=0,N=0;for(;M<z;){const ee=r.charCodeAt(i);if(ee>=48&&ee<=57)N=N*16+ee-48;else if(ee>=65&&ee<=70)N=N*16+ee-65+10;else if(ee>=97&&ee<=102)N=N*16+ee-97+10;else break;i++,M++}return M<z&&(N=-1),N}function h(z){i=z,S="",b=0,C=16,I=0}function u(){const z=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&m(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&m(r.charCodeAt(i)))for(i++;i<r.length&&m(r.charCodeAt(i));)i++;else return I=3,r.substring(z,i);let M=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&m(r.charCodeAt(i))){for(i++;i<r.length&&m(r.charCodeAt(i));)i++;M=i}else I=3;return r.substring(z,M)}function A(){let z="",M=i;for(;;){if(i>=o){z+=r.substring(M,i),I=2;break}const N=r.charCodeAt(i);if(N===34){z+=r.substring(M,i),i++;break}if(N===92){if(z+=r.substring(M,i),i++,i>=o){I=2;break}switch(r.charCodeAt(i++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Q=c(4);Q>=0?z+=String.fromCharCode(Q):I=4;break}default:I=5}M=i;continue}if(N>=0&&N<=31)if(y(N)){z+=r.substring(M,i),I=2;break}else I=6;i++}return z}function B(){if(S="",I=0,b=i,i>=o)return b=o,C=17;let z=r.charCodeAt(i);if(d(z)){do i++,S+=String.fromCharCode(z),z=r.charCodeAt(i);while(d(z));return C=15}if(y(z))return i++,S+=String.fromCharCode(z),z===13&&r.charCodeAt(i)===10&&(i++,S+=`
`),C=14;switch(z){case 123:return i++,C=1;case 125:return i++,C=2;case 91:return i++,C=3;case 93:return i++,C=4;case 58:return i++,C=6;case 44:return i++,C=5;case 34:return i++,S=A(),C=10;case 47:{const M=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!y(r.charCodeAt(i));)i++;return S=r.substring(M,i),C=12}if(r.charCodeAt(i+1)===42){i+=2;const N=o-1;let ee=!1;for(;i<N;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,ee=!0;break}i++}return ee||(i++,I=1),S=r.substring(M,i),C=13}return S+=String.fromCharCode(z),i++,C=16}case 45:if(S+=String.fromCharCode(z),i++,i===o||!m(r.charCodeAt(i)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return S+=u(),C=11;default:for(;i<o&&H(z);)i++,z=r.charCodeAt(i);if(b!==i){switch(S=r.substring(b,i),S){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return S+=String.fromCharCode(z),i++,C=16}}function H(z){if(d(z)||y(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=B();while(z>=12&&z<=15);return z}return{setPosition:h,getPosition:()=>i,scan:s?U:B,getToken:()=>C,getTokenValue:()=>S,getTokenOffset:()=>b,getTokenLength:()=>i-b,getTokenError:()=>I}}e.createScanner=T;function d(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function m(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function _(r,s){const i=[],o=new Object;let S;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function I(c,h,u,A){b.value=c,b.offset=h,b.length=u,b.type=A,b.colonOffset=void 0,S=b}try{E(r,{onObjectBegin:(c,h)=>{if(s<=c)throw o;S=void 0,C=s>c,i.push("")},onObjectProperty:(c,h,u)=>{if(s<h||(I(c,h,u,"property"),i[i.length-1]=c,s<=h+u))throw o},onObjectEnd:(c,h)=>{if(s<=c)throw o;S=void 0,i.pop()},onArrayBegin:(c,h)=>{if(s<=c)throw o;S=void 0,i.push(0)},onArrayEnd:(c,h)=>{if(s<=c)throw o;S=void 0,i.pop()},onLiteralValue:(c,h,u)=>{if(s<h||(I(c,h,u,p(c)),s<=h+u))throw o},onSeparator:(c,h,u)=>{if(s<=h)throw o;if(c===":"&&S&&S.type==="property")S.colonOffset=h,C=!1,S=void 0;else if(c===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(C=!0,i[i.length-1]=""),S=void 0}}})}catch(c){if(c!==o)throw c}return{path:i,previousNode:S,isAtPropertyKey:C,matches:c=>{let h=0;for(let u=0;h<c.length&&u<i.length;u++)if(c[h]===i[u]||c[h]==="*")h++;else if(c[h]!=="**")return!1;return h===c.length}}}e.getLocation=_;function a(r,s=[],i=F.DEFAULT){let o=null,S=[];const b=[];function C(c){Array.isArray(S)?S.push(c):o!==null&&(S[o]=c)}return E(r,{onObjectBegin:()=>{const c={};C(c),b.push(S),S=c,o=null},onObjectProperty:c=>{o=c},onObjectEnd:()=>{S=b.pop()},onArrayBegin:()=>{const c=[];C(c),b.push(S),S=c,o=null},onArrayEnd:()=>{S=b.pop()},onLiteralValue:C,onError:(c,h,u)=>{s.push({error:c,offset:h,length:u})}},i),S[0]}e.parse=a;function v(r,s=[],i=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function S(c){o.type==="property"&&(o.length=c-o.offset,o=o.parent)}function b(c){return o.children.push(c),c}E(r,{onObjectBegin:c=>{o=b({type:"object",offset:c,length:-1,parent:o,children:[]})},onObjectProperty:(c,h,u)=>{o=b({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:c,offset:h,length:u,parent:o})},onObjectEnd:(c,h)=>{o.length=c+h-o.offset,o=o.parent,S(c+h)},onArrayBegin:(c,h)=>{o=b({type:"array",offset:c,length:-1,parent:o,children:[]})},onArrayEnd:(c,h)=>{o.length=c+h-o.offset,o=o.parent,S(c+h)},onLiteralValue:(c,h,u)=>{b({type:p(c),offset:h,length:u,parent:o,value:c}),S(h+u)},onSeparator:(c,h,u)=>{o.type==="property"&&(c===":"?o.colonOffset=h:c===","&&S(h))},onError:(c,h,u)=>{s.push({error:c,offset:h,length:u})}},i);const I=o.children[0];return I&&delete I.parent,I}e.parseTree=v;function g(r,s){if(!r)return;let i=r;for(const o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let S=!1;for(const b of i.children)if(Array.isArray(b.children)&&b.children[0].value===o){i=b.children[1],S=!0;break}if(!S)return}else{const S=o;if(i.type!=="array"||S<0||!Array.isArray(i.children)||S>=i.children.length)return;i=i.children[S]}return i}e.findNodeAtLocation=g;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;s.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&s.push(i)}return s}e.getNodePath=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const i of r.children){const o=i.children[1];o&&(s[i.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=t;function n(r,s,i=!1){return s>=r.offset&&s<r.offset+r.length||i&&s===r.offset+r.length}e.contains=n;function l(r,s,i=!1){if(n(r,s,i)){const o=r.children;if(Array.isArray(o))for(let S=0;S<o.length&&o[S].offset<=s;S++){const b=l(o[S],s,i);if(b)return b}return r}}e.findNodeAtOffset=l;function E(r,s,i=F.DEFAULT){const o=T(r,!1);function S(_e){return _e?()=>_e(o.getTokenOffset(),o.getTokenLength()):()=>!0}function b(_e){return _e?ce=>_e(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const C=S(s.onObjectBegin),I=b(s.onObjectProperty),c=S(s.onObjectEnd),h=S(s.onArrayBegin),u=S(s.onArrayEnd),A=b(s.onLiteralValue),B=b(s.onSeparator),H=S(s.onComment),U=b(s.onError),z=i&&i.disallowComments,M=i&&i.allowTrailingComma;function N(){for(;;){const _e=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:z||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(_e){case 12:case 13:z?ee(10):H();break;case 16:ee(1);break;case 15:case 14:break;default:return _e}}}function ee(_e,ce=[],pe=[]){if(U(_e),ce.length+pe.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){N();break}else if(pe.indexOf(ie)!==-1)break;ie=N()}}}function Q(_e){const ce=o.getTokenValue();return _e?A(ce):I(ce),N(),!0}function Se(){switch(o.getToken()){case 11:{let _e=0;try{_e=JSON.parse(o.getTokenValue()),typeof _e!="number"&&(ee(2),_e=0)}catch{ee(2)}A(_e);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return N(),!0}function ye(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(Q(!1),o.getToken()===6?(B(":"),N(),ue()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){C(),N();let _e=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(_e||ee(4,[],[]),B(","),N(),o.getToken()===2&&M)break}else _e&&ee(6,[],[]);ye()||ee(4,[],[2,5]),_e=!0}return c(),o.getToken()!==2?ee(7,[2],[]):N(),!0}function Y(){h(),N();let _e=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(_e||ee(4,[],[]),B(","),N(),o.getToken()===4&&M)break}else _e&&ee(6,[],[]);ue()||ee(4,[],[4,5]),_e=!0}return u(),o.getToken()!==4?ee(8,[4],[]):N(),!0}function ue(){switch(o.getToken()){case 3:return Y();case 1:return Pe();case 10:return Q(!0);default:return Se()}}return N(),o.getToken()===17?i.allowEmptyContent?!0:(ee(4,[],[]),!1):ue()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.visit=E;function D(r,s){const i=T(r),o=[];let S,b=0,C;do switch(C=i.getPosition(),S=i.scan(),S){case 12:case 13:case 17:b!==C&&o.push(r.substring(b,C)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),b=i.getPosition();break}while(S!==17);return o.join("")}e.stripComments=D;function p(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),function(be,e){typeof define=="function"&&define.amd?define(Te[116],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(Ee,me){for(var De=0;De<me.length;De++){var re=me[De];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Ee,re.key,re)}}function w(Ee,me,De){return me&&e(Ee.prototype,me),De&&e(Ee,De),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function R(Ee,me){if(Ee){if(typeof Ee=="string")return k(Ee,me);var De=Object.prototype.toString.call(Ee).slice(8,-1);if(De==="Object"&&Ee.constructor&&(De=Ee.constructor.name),De==="Map"||De==="Set")return Array.from(Ee);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return k(Ee,me)}}function k(Ee,me){(me==null||me>Ee.length)&&(me=Ee.length);for(var De=0,re=new Array(me);De<me;De++)re[De]=Ee[De];return re}function F(Ee,me){var De=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(De)return(De=De.call(Ee)).next.bind(De);if(Array.isArray(Ee)||(De=R(Ee))||me&&Ee&&typeof Ee.length=="number"){De&&(Ee=De);var re=0;return function(){return re>=Ee.length?{done:!0}:{done:!1,value:Ee[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=T();function d(Ee){be.defaults=Ee}var y=/[&<>"']/,m=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(me){return a[me]};function g(Ee,me){if(me){if(y.test(Ee))return Ee.replace(m,v)}else if(P.test(Ee))return Ee.replace(_,v);return Ee}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Ee){return Ee.replace(f,function(me,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var n=/(^|[^\[])\^/g;function l(Ee,me){Ee=typeof Ee=="string"?Ee:Ee.source,me=me||"";var De={replace:function(de,se){return se=se.source||se,se=se.replace(n,"$1"),Ee=Ee.replace(de,se),De},getRegex:function(){return new RegExp(Ee,me)}};return De}var E=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Ee,me,De){if(Ee){var re;try{re=decodeURIComponent(t(De)).replace(E,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}me&&!D.test(De)&&(De=S(me,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var r={},s=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function S(Ee,me){r[" "+Ee]||(s.test(Ee)?r[" "+Ee]=Ee+"/":r[" "+Ee]=c(Ee,"/",!0)),Ee=r[" "+Ee];var De=Ee.indexOf(":")===-1;return me.substring(0,2)==="//"?De?me:Ee.replace(i,"$1")+me:me.charAt(0)==="/"?De?me:Ee.replace(o,"$1")+me:Ee+me}var b={exec:function(){}};function C(Ee){for(var me=1,De,re;me<arguments.length;me++){De=arguments[me];for(re in De)Object.prototype.hasOwnProperty.call(De,re)&&(Ee[re]=De[re])}return Ee}function I(Ee,me){var De=Ee.replace(/\|/g,function(se,oe,fe){for(var Ie=!1,O=oe;--O>=0&&fe[O]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=De.split(/ \|/),de=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>me)re.splice(me);else for(;re.length<me;)re.push("");for(;de<re.length;de++)re[de]=re[de].trim().replace(/\\\|/g,"|");return re}function c(Ee,me,De){var re=Ee.length;if(re===0)return"";for(var de=0;de<re;){var se=Ee.charAt(re-de-1);if(se===me&&!De)de++;else if(se!==me&&De)de++;else break}return Ee.slice(0,re-de)}function h(Ee,me){if(Ee.indexOf(me[1])===-1)return-1;for(var De=Ee.length,re=0,de=0;de<De;de++)if(Ee[de]==="\\")de++;else if(Ee[de]===me[0])re++;else if(Ee[de]===me[1]&&(re--,re<0))return de;return-1}function u(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ee,me){if(me<1)return"";for(var De="";me>1;)me&1&&(De+=Ee),me>>=1,Ee+=Ee;return De+Ee}function B(Ee,me,De,re){var de=me.href,se=me.title?g(me.title):null,oe=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:De,href:de,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,fe}return{type:"image",raw:De,href:de,title:se,text:g(oe)}}function H(Ee,me){var De=Ee.match(/^(\s+)(?:```)/);if(De===null)return me;var re=De[1];return me.split(`
`).map(function(de){var se=de.match(/^\s+/);if(se===null)return de;var oe=se[0];return oe.length>=re.length?de.slice(re.length):de}).join(`
`)}var U=function(){function Ee(De){this.options=De||be.defaults}var me=Ee.prototype;return me.space=function(re){var de=this.rules.block.newline.exec(re);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},me.code=function(re){var de=this.rules.block.code.exec(re);if(de){var se=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?se:c(se,`
`)}}},me.fences=function(re){var de=this.rules.block.fences.exec(re);if(de){var se=de[0],oe=H(se,de[3]||"");return{type:"code",raw:se,lang:de[2]?de[2].trim():de[2],text:oe}}},me.heading=function(re){var de=this.rules.block.heading.exec(re);if(de){var se=de[2].trim();if(/#$/.test(se)){var oe=c(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(re){var de=this.rules.block.hr.exec(re);if(de)return{type:"hr",raw:de[0]}},me.blockquote=function(re){var de=this.rules.block.blockquote.exec(re);if(de){var se=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(re){var de=this.rules.block.list.exec(re);if(de){var se,oe,fe,Ie,O,V,K,G,q,Z,ae,Me,Ue=de[1].trim(),Ge=Ue.length>1,je={type:"list",raw:"",ordered:Ge,start:Ge?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ge?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ge?Ue:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Me=!1,!(!(de=Je.exec(re))||this.rules.block.hr.test(re)));){if(se=de[0],re=re.substring(se.length),G=de[2].split(`
`,1)[0],q=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=G.trimLeft()):(Ie=de[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=G.slice(Ie),Ie+=de[1].length),V=!1,!G&&/^ *$/.test(q)&&(se+=q+`
`,re=re.substring(q.length+1),Me=!0),!Me)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(Z=re.split(`
`,1)[0],G=Z,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(G)||tt.test(G)||Ye.test(G)||et.test(re)));){if(G.search(/[^ ]/)>=Ie||!G.trim())ae+=`
`+G.slice(Ie);else if(!V)ae+=`
`+G;else break;!V&&!G.trim()&&(V=!0),se+=Z+`
`,re=re.substring(Z.length+1)}je.loose||(K?je.loose=!0:/\n *\n *$/.test(se)&&(K=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:se,task:!!oe,checked:fe,loose:!1,text:ae}),je.raw+=se}je.items[je.items.length-1].raw=se.trimRight(),je.items[je.items.length-1].text=ae.trimRight(),je.raw=je.raw.trimRight();var xe=je.items.length;for(O=0;O<xe;O++){this.lexer.state.top=!1,je.items[O].tokens=this.lexer.blockTokens(je.items[O].text,[]);var st=je.items[O].tokens.filter(function(X){return X.type==="space"}),J=st.every(function(X){for(var ve=X.raw.split(""),Be=0,Ne=F(ve),Xe;!(Xe=Ne()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!je.loose&&st.length&&J&&(je.loose=!0,je.items[O].loose=!0)}return je}},me.html=function(re){var de=this.rules.block.html.exec(re);if(de){var se={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(de[0]):g(de[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(re){var de=this.rules.block.def.exec(re);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var se=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:de[0],href:de[2],title:de[3]}}},me.table=function(re){var de=this.rules.block.table.exec(re);if(de){var se={type:"table",header:I(de[1]).map(function(K){return{text:K}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=de[0];var oe=se.align.length,fe,Ie,O,V;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(se.align[fe])?se.align[fe]="right":/^ *:-+: *$/.test(se.align[fe])?se.align[fe]="center":/^ *:-+ *$/.test(se.align[fe])?se.align[fe]="left":se.align[fe]=null;for(oe=se.rows.length,fe=0;fe<oe;fe++)se.rows[fe]=I(se.rows[fe],se.header.length).map(function(K){return{text:K}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(V=se.rows[Ie],O=0;O<V.length;O++)V[O].tokens=this.lexer.inline(V[O].text);return se}}},me.lheading=function(re){var de=this.rules.block.lheading.exec(re);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},me.paragraph=function(re){var de=this.rules.block.paragraph.exec(re);if(de){var se=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(re){var de=this.rules.block.text.exec(re);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},me.escape=function(re){var de=this.rules.inline.escape.exec(re);if(de)return{type:"escape",raw:de[0],text:g(de[1])}},me.tag=function(re){var de=this.rules.inline.tag.exec(re);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):g(de[0]):de[0]}},me.link=function(re){var de=this.rules.inline.link.exec(re);if(de){var se=de[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=c(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var fe=h(de[2],"()");if(fe>-1){var Ie=de[0].indexOf("!")===0?5:4,O=Ie+de[1].length+fe;de[2]=de[2].substring(0,fe),de[0]=de[0].substring(0,O).trim(),de[3]=""}}var V=de[2],K="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);G&&(V=G[1],K=G[3])}else K=de[3]?de[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(se)?V=V.slice(1):V=V.slice(1,-1)),B(de,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},me.reflink=function(re,de){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=de[oe.toLowerCase()],!oe||!oe.href){var fe=se[0].charAt(0);return{type:"text",raw:fe,text:fe}}return B(se,oe,se[0],this.lexer)}},me.emStrong=function(re,de,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,O,V,K=Ie,G=0,q=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*re.length+Ie);(oe=q.exec(de))!=null;)if(O=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!O){if(V=O.length,oe[3]||oe[4]){K+=V;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+V)%3)){G+=V;continue}if(K-=V,!(K>0)){if(V=Math.min(V,V+K+G),Math.min(Ie,V)%2){var Z=re.slice(1,Ie+oe.index+V);return{type:"em",raw:re.slice(0,Ie+oe.index+V+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var ae=re.slice(2,Ie+oe.index+V-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+V+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},me.codespan=function(re){var de=this.rules.inline.code.exec(re);if(de){var se=de[2].replace(/\n/g," "),oe=/[^ ]/.test(se),fe=/^ /.test(se)&&/ $/.test(se);return oe&&fe&&(se=se.substring(1,se.length-1)),se=g(se,!0),{type:"codespan",raw:de[0],text:se}}},me.br=function(re){var de=this.rules.inline.br.exec(re);if(de)return{type:"br",raw:de[0]}},me.del=function(re){var de=this.rules.inline.del.exec(re);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},me.autolink=function(re,de){var se=this.rules.inline.autolink.exec(re);if(se){var oe,fe;return se[2]==="@"?(oe=g(this.options.mangle?de(se[1]):se[1]),fe="mailto:"+oe):(oe=g(se[1]),fe=oe),{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(re,de){var se;if(se=this.rules.inline.url.exec(re)){var oe,fe;if(se[2]==="@")oe=g(this.options.mangle?de(se[0]):se[0]),fe="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=g(se[0]),se[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(re,de){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):g(se[0]):se[0]:oe=g(this.options.smartypants?de(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},Ee}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=l(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=l(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=l(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=l(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=l(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=l(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=C({},z),z.gfm=C({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=l(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=l(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=C({},z.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:l(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=l(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=l(z._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=l(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=l(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=l(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=l(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=l(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=l(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=l(M.reflink).replace("label",M._label).replace("ref",z._label).getRegex(),M.nolink=l(M.nolink).replace("ref",z._label).getRegex(),M.reflinkSearch=l(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=C({},M),M.pedantic=C({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=C({},M.normal,{escape:l(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=l(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=C({},M.gfm,{br:l(M.br).replace("{2,}","*").getRegex(),text:l(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(Ee){var me="",De,re,de=Ee.length;for(De=0;De<de;De++)re=Ee.charCodeAt(De),Math.random()>.5&&(re="x"+re.toString(16)),me+="&#"+re+";";return me}var Q=function(){function Ee(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:z.normal,inline:M.normal};this.options.pedantic?(re.block=z.pedantic,re.inline=M.pedantic):this.options.gfm&&(re.block=z.gfm,this.options.breaks?re.inline=M.breaks:re.inline=M.gfm),this.tokenizer.rules=re}Ee.lex=function(re,de){var se=new Ee(de);return se.lex(re)},Ee.lexInline=function(re,de){var se=new Ee(de);return se.inlineTokens(re)};var me=Ee.prototype;return me.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},me.blockTokens=function(re,de){var se=this;de===void 0&&(de=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(K,G,q){return G+"    ".repeat(q.length)});for(var oe,fe,Ie,O;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(oe=K.call({lexer:se},re,de))?(re=re.substring(oe.raw.length),de.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),fe=de[de.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):de.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),fe=de[de.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,G=re.slice(1),q=void 0;se.options.extensions.startBlock.forEach(function(Z){q=Z.call({lexer:this},G),typeof q=="number"&&q>=0&&(K=Math.min(K,q))}),K<1/0&&K>=0&&(Ie=re.substring(0,K+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=de[de.length-1],O&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):de.push(oe),O=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),fe=de[de.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):de.push(oe);continue}if(re){var V="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,de},me.inline=function(re,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:re,tokens:de}),de},me.inlineTokens=function(re,de){var se=this;de===void 0&&(de=[]);var oe,fe,Ie,O=re,V,K,G;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,V.index)+"["+A("a",V[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,V.index)+"["+A("a",V[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,V.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(K||(G=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},re,de))?(re=re.substring(oe.raw.length),de.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),fe=de[de.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):de.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),fe=de[de.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):de.push(oe);continue}if(oe=this.tokenizer.emStrong(re,O,G)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),de.push(oe);continue}if(oe=this.tokenizer.autolink(re,ee)){re=re.substring(oe.raw.length),de.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ee))){re=re.substring(oe.raw.length),de.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Me=re.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Ge){Ue=Ge.call({lexer:this},Me),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=re.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(G=oe.raw.slice(-1)),K=!0,fe=de[de.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):de.push(oe);continue}if(re){var Z="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return de},w(Ee,null,[{key:"rules",get:function(){return{block:z,inline:M}}}]),Ee}(),Se=function(){function Ee(De){this.options=De||be.defaults}var me=Ee.prototype;return me.code=function(re,de,se){var oe=(de||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,oe);fe!=null&&fe!==re&&(se=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+g(oe,!0)+'">'+(se?re:g(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:g(re,!0))+`</code></pre>
`},me.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},me.html=function(re){return re},me.heading=function(re,de,se,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(se);return"<h"+de+' id="'+fe+'">'+re+"</h"+de+`>
`}return"<h"+de+">"+re+"</h"+de+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(re,de,se){var oe=de?"ol":"ul",fe=de&&se!==1?' start="'+se+'"':"";return"<"+oe+fe+`>
`+re+"</"+oe+`>
`},me.listitem=function(re){return"<li>"+re+`</li>
`},me.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(re){return"<p>"+re+`</p>
`},me.table=function(re,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+de+`</table>
`},me.tablerow=function(re){return`<tr>
`+re+`</tr>
`},me.tablecell=function(re,de){var se=de.header?"th":"td",oe=de.align?"<"+se+' align="'+de.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},me.strong=function(re){return"<strong>"+re+"</strong>"},me.em=function(re){return"<em>"+re+"</em>"},me.codespan=function(re){return"<code>"+re+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(re){return"<del>"+re+"</del>"},me.link=function(re,de,se){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+g(re)+'"';return de&&(oe+=' title="'+de+'"'),oe+=">"+se+"</a>",oe},me.image=function(re,de,se){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return de&&(oe+=' title="'+de+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(re){return re},Ee}(),ye=function(){function Ee(){}var me=Ee.prototype;return me.strong=function(re){return re},me.em=function(re){return re},me.codespan=function(re){return re},me.del=function(re){return re},me.html=function(re){return re},me.text=function(re){return re},me.link=function(re,de,se){return""+se},me.image=function(re,de,se){return""+se},me.br=function(){return""},Ee}(),Pe=function(){function Ee(){this.seen={}}var me=Ee.prototype;return me.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(re,de){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return de||(this.seen[re]=oe,this.seen[se]=0),se},me.slug=function(re,de){de===void 0&&(de={});var se=this.serialize(re);return this.getNextSafeSlug(se,de.dryrun)},Ee}(),Y=function(){function Ee(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Pe}Ee.parse=function(re,de){var se=new Ee(de);return se.parse(re)},Ee.parseInline=function(re,de){var se=new Ee(de);return se.parseInline(re)};var me=Ee.prototype;return me.parse=function(re,de){de===void 0&&(de=!0);var se="",oe,fe,Ie,O,V,K,G,q,Z,ae,Me,Ue,Ge,je,Je,Ye,et,it,tt,xe=re.length;for(oe=0;oe<xe;oe++){if(ae=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(q="",G="",O=ae.header.length,fe=0;fe<O;fe++)G+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(q+=this.renderer.tablerow(G),Z="",O=ae.rows.length,fe=0;fe<O;fe++){for(K=ae.rows[fe],G="",V=K.length,Ie=0;Ie<V;Ie++)G+=this.renderer.tablecell(this.parseInline(K[Ie].tokens),{header:!1,align:ae.align[Ie]});Z+=this.renderer.tablerow(G)}se+=this.renderer.table(q,Z);continue}case"blockquote":{Z=this.parse(ae.tokens),se+=this.renderer.blockquote(Z);continue}case"list":{for(Me=ae.ordered,Ue=ae.start,Ge=ae.loose,O=ae.items.length,Z="",fe=0;fe<O;fe++)Je=ae.items[fe],Ye=Je.checked,et=Je.task,je="",Je.task&&(it=this.renderer.checkbox(Ye),Ge?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=it+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=it+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:it}):je+=it),je+=this.parse(Je.tokens,Ge),Z+=this.renderer.listitem(je,et,Ye);se+=this.renderer.list(Z,Me,Ue);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(Z=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<xe&&re[oe+1].type==="text";)ae=re[++oe],Z+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=de?this.renderer.paragraph(Z):Z;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(re,de){de=de||this.renderer;var se="",oe,fe,Ie,O=re.length;for(oe=0;oe<O;oe++){if(fe=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){se+=Ie||"";continue}switch(fe.type){case"escape":{se+=de.text(fe.text);break}case"html":{se+=de.html(fe.text);break}case"link":{se+=de.link(fe.href,fe.title,this.parseInline(fe.tokens,de));break}case"image":{se+=de.image(fe.href,fe.title,fe.text);break}case"strong":{se+=de.strong(this.parseInline(fe.tokens,de));break}case"em":{se+=de.em(this.parseInline(fe.tokens,de));break}case"codespan":{se+=de.codespan(fe.text);break}case"br":{se+=de.br();break}case"del":{se+=de.del(this.parseInline(fe.tokens,de));break}case"text":{se+=de.text(fe.text);break}default:{var V='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return se},Ee}();function ue(Ee,me,De){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof me=="function"&&(De=me,me=null),me=C({},ue.defaults,me||{}),u(me),De){var re=me.highlight,de;try{de=Q.lex(Ee,me)}catch(O){return De(O)}var se=function(V){var K;if(!V)try{me.walkTokens&&ue.walkTokens(de,me.walkTokens),K=Y.parse(de,me)}catch(G){V=G}return me.highlight=re,V?De(V):De(null,K)};if(!re||re.length<3||(delete me.highlight,!de.length))return se();var oe=0;ue.walkTokens(de,function(O){O.type==="code"&&(oe++,setTimeout(function(){re(O.text,O.lang,function(V,K){if(V)return se(V);K!=null&&K!==O.text&&(O.text=K,O.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function fe(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+g(O.message+"",!0)+"</pre>";throw O}try{var Ie=Q.lex(Ee,me);if(me.walkTokens){if(me.async)return Promise.all(ue.walkTokens(Ie,me.walkTokens)).then(function(){return Y.parse(Ie,me)}).catch(fe);ue.walkTokens(Ie,me.walkTokens)}return Y.parse(Ie,me)}catch(O){fe(O)}}ue.options=ue.setOptions=function(Ee){return C(ue.defaults,Ee),d(ue.defaults),ue},ue.getDefaults=T,ue.defaults=be.defaults,ue.use=function(){for(var Ee=arguments.length,me=new Array(Ee),De=0;De<Ee;De++)me[De]=arguments[De];var re=C.apply(void 0,[{}].concat(me)),de=ue.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var O=de.renderers?de.renderers[Ie.name]:null;O?de.renderers[Ie.name]=function(){for(var V=arguments.length,K=new Array(V),G=0;G<V;G++)K[G]=arguments[G];var q=Ie.renderer.apply(this,K);return q===!1&&(q=O.apply(this,K)),q}:de.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ie.level]?de[Ie.level].unshift(Ie.tokenizer):de[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?de.startBlock?de.startBlock.push(Ie.start):de.startBlock=[Ie.start]:Ie.level==="inline"&&(de.startInline?de.startInline.push(Ie.start):de.startInline=[Ie.start]))}Ie.childTokens&&(de.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ue.defaults.renderer||new Se,O=function(G){var q=Ie[G];Ie[G]=function(){for(var Z=arguments.length,ae=new Array(Z),Me=0;Me<Z;Me++)ae[Me]=arguments[Me];var Ue=oe.renderer[G].apply(Ie,ae);return Ue===!1&&(Ue=q.apply(Ie,ae)),Ue}};for(var V in oe.renderer)O(V);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ue.defaults.tokenizer||new U,O=function(G){var q=Ie[G];Ie[G]=function(){for(var Z=arguments.length,ae=new Array(Z),Me=0;Me<Z;Me++)ae[Me]=arguments[Me];var Ue=oe.tokenizer[G].apply(Ie,ae);return Ue===!1&&(Ue=q.apply(Ie,ae)),Ue}};for(var V in oe.tokenizer)O(V);re.tokenizer=Ie}(),oe.walkTokens){var fe=ue.defaults.walkTokens;re.walkTokens=function(Ie){var O=[];return O.push(oe.walkTokens.call(this,Ie)),fe&&(O=O.concat(fe.call(this,Ie))),O}}se&&(re.extensions=de),ue.setOptions(re)})},ue.walkTokens=function(Ee,me){for(var De=[],re=function(){var fe=se.value;switch(De=De.concat(me.call(ue,fe)),fe.type){case"table":{for(var Ie=F(fe.header),O;!(O=Ie()).done;){var V=O.value;De=De.concat(ue.walkTokens(V.tokens,me))}for(var K=F(fe.rows),G;!(G=K()).done;)for(var q=G.value,Z=F(q),ae;!(ae=Z()).done;){var Me=ae.value;De=De.concat(ue.walkTokens(Me.tokens,me))}break}case"list":{De=De.concat(ue.walkTokens(fe.items,me));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[fe.type]?ue.defaults.extensions.childTokens[fe.type].forEach(function(Ue){De=De.concat(ue.walkTokens(fe[Ue],me))}):fe.tokens&&(De=De.concat(ue.walkTokens(fe.tokens,me)))}},de=F(Ee),se;!(se=de()).done;)re();return De},ue.parseInline=function(Ee,me){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");me=C({},ue.defaults,me||{}),u(me);try{var De=Q.lexInline(Ee,me);return me.walkTokens&&ue.walkTokens(De,me.walkTokens),Y.parseInline(De,me)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+g(re.message+"",!0)+"</pre>";throw re}},ue.Parser=Y,ue.parser=Y.parse,ue.Renderer=Se,ue.TextRenderer=ye,ue.Lexer=Q,ue.lexer=Q.lex,ue.Tokenizer=U,ue.Slugger=Pe,ue.parse=ue;var _e=ue.options,ce=ue.setOptions,pe=ue.use,ie=ue.walkTokens,x=ue.parseInline,W=ue,le=Y.parse,we=Q.lex;be.Lexer=Q,be.Parser=Y,be.Renderer=Se,be.Slugger=Pe,be.TextRenderer=ye,be.Tokenizer=U,be.getDefaults=T,be.lexer=we,be.marked=ue,be.options=_e,be.parse=W,be.parseInline=x,be.parser=le,be.setOptions=ce,be.use=pe,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Te[117],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(d,y,m){return Math.min(Math.max(d,y),m)}e.clamp=w;function R(d,y){return(y+d%y)%y}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class F{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=F;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const m=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function be(k){const F=[];typeof k=="number"&&F.push("code/timeOrigin",k);function T(y){F.push(y,Date.now())}function d(){const y=[];for(let m=0;m<F.length;m+=2)y.push({name:F[m],startTime:F[m+1]});return y}return{mark:T,getMarks:d}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))F.push({name:T.name,startTime:Math.round(k+T.startTime)});return F}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var R in w)(typeof exports=="object"?exports:be)[R]=w[R]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(R){if(e[R])return e[R].exports;var k=e[R]={i:R,l:!1,exports:{}};return be[R].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=be,w.c=e,w.d=function(R,k,F){w.o(R,k)||Object.defineProperty(R,k,{enumerable:!0,get:F})},w.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},w.t=function(R,k){if(1&k&&(R=w(R)),8&k||4&k&&typeof R=="object"&&R&&R.__esModule)return R;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:R}),2&k&&typeof R!="string")for(var T in R)w.d(F,T,function(d){return R[d]}.bind(null,T));return F},w.n=function(R){var k=R&&R.__esModule?function(){return R.default}:function(){return R};return w.d(k,"a",k),k},w.o=function(R,k){return Object.prototype.hasOwnProperty.call(R,k)},w.p="",w(w.s=0)}([function(be,e,w){(function(R){var k;e=be.exports=pe,k=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,d=e.re=[],y=e.src=[],m=0,P=m++;y[P]="0|[1-9]\\d*";var _=m++;y[_]="[0-9]+";var a=m++;y[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=m++;y[v]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var g=m++;y[g]="("+y[_]+")\\.("+y[_]+")\\.("+y[_]+")";var f=m++;y[f]="(?:"+y[P]+"|"+y[a]+")";var t=m++;y[t]="(?:"+y[_]+"|"+y[a]+")";var n=m++;y[n]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var l=m++;y[l]="(?:-?("+y[t]+"(?:\\."+y[t]+")*))";var E=m++;y[E]="[0-9A-Za-z-]+";var D=m++;y[D]="(?:\\+("+y[E]+"(?:\\."+y[E]+")*))";var p=m++,r="v?"+y[v]+y[n]+"?"+y[D]+"?";y[p]="^"+r+"$";var s="[v=\\s]*"+y[g]+y[l]+"?"+y[D]+"?",i=m++;y[i]="^"+s+"$";var o=m++;y[o]="((?:<|>)?=?)";var S=m++;y[S]=y[_]+"|x|X|\\*";var b=m++;y[b]=y[P]+"|x|X|\\*";var C=m++;y[C]="[v=\\s]*("+y[b]+")(?:\\.("+y[b]+")(?:\\.("+y[b]+")(?:"+y[n]+")?"+y[D]+"?)?)?";var I=m++;y[I]="[v=\\s]*("+y[S]+")(?:\\.("+y[S]+")(?:\\.("+y[S]+")(?:"+y[l]+")?"+y[D]+"?)?)?";var c=m++;y[c]="^"+y[o]+"\\s*"+y[C]+"$";var h=m++;y[h]="^"+y[o]+"\\s*"+y[I]+"$";var u=m++;y[u]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=m++;y[A]="(?:~>?)";var B=m++;y[B]="(\\s*)"+y[A]+"\\s+",d[B]=new RegExp(y[B],"g");var H=m++;y[H]="^"+y[A]+y[C]+"$";var U=m++;y[U]="^"+y[A]+y[I]+"$";var z=m++;y[z]="(?:\\^)";var M=m++;y[M]="(\\s*)"+y[z]+"\\s+",d[M]=new RegExp(y[M],"g");var N=m++;y[N]="^"+y[z]+y[C]+"$";var ee=m++;y[ee]="^"+y[z]+y[I]+"$";var Q=m++;y[Q]="^"+y[o]+"\\s*("+s+")$|^$";var Se=m++;y[Se]="^"+y[o]+"\\s*("+r+")$|^$";var ye=m++;y[ye]="(\\s*)"+y[o]+"\\s*("+s+"|"+y[C]+")",d[ye]=new RegExp(y[ye],"g");var Pe=m++;y[Pe]="^\\s*("+y[C]+")\\s+-\\s+("+y[C]+")\\s*$";var Y=m++;y[Y]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var ue=m++;y[ue]="(<|>)?=?\\s*\\*";for(var _e=0;_e<35;_e++)k(_e,y[_e]),d[_e]||(d[_e]=new RegExp(y[_e]));function ce(q,Z){if(q instanceof pe)return q;if(typeof q!="string"||q.length>F||!(Z?d[i]:d[p]).test(q))return null;try{return new pe(q,Z)}catch{return null}}function pe(q,Z){if(q instanceof pe){if(q.loose===Z)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof pe))return new pe(q,Z);k("SemVer",q,Z),this.loose=Z;var ae=q.trim().match(Z?d[i]:d[p]);if(!ae)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Ue=+Me;if(Ue>=0&&Ue<T)return Ue}return Me}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(q,Z){var ae=ce(q,Z);return ae?ae.version:null},e.clean=function(q,Z){var ae=ce(q.trim().replace(/^[=v]+/,""),Z);return ae?ae.version:null},e.SemVer=pe,pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},pe.prototype.toString=function(){return this.version},pe.prototype.compare=function(q){return k("SemVer.compare",this.version,this.loose,q),q instanceof pe||(q=new pe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},pe.prototype.compareMain=function(q){return q instanceof pe||(q=new pe(q,this.loose)),x(this.major,q.major)||x(this.minor,q.minor)||x(this.patch,q.patch)},pe.prototype.comparePre=function(q){if(q instanceof pe||(q=new pe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Z=0;do{var ae=this.prerelease[Z],Me=q.prerelease[Z];if(k("prerelease compare",Z,ae,Me),ae===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ae===void 0)return-1;if(ae!==Me)return x(ae,Me)}while(++Z)},pe.prototype.inc=function(q,Z){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Z,ae,Me){typeof ae=="string"&&(Me=ae,ae=void 0);try{return new pe(q,ae).inc(Z,Me).version}catch{return null}},e.diff=function(q,Z){if(Ee(q,Z))return null;var ae=ce(q),Me=ce(Z);if(ae.prerelease.length||Me.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Me[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Me[Ue])return Ue},e.compareIdentifiers=x;var ie=/^[0-9]+$/;function x(q,Z){var ae=ie.test(q),Me=ie.test(Z);return ae&&Me&&(q=+q,Z=+Z),ae&&!Me?-1:Me&&!ae?1:q<Z?-1:q>Z?1:0}function W(q,Z,ae){return new pe(q,ae).compare(new pe(Z,ae))}function le(q,Z,ae){return W(q,Z,ae)>0}function we(q,Z,ae){return W(q,Z,ae)<0}function Ee(q,Z,ae){return W(q,Z,ae)===0}function me(q,Z,ae){return W(q,Z,ae)!==0}function De(q,Z,ae){return W(q,Z,ae)>=0}function re(q,Z,ae){return W(q,Z,ae)<=0}function de(q,Z,ae,Me){var Ue;switch(Z){case"===":typeof q=="object"&&(q=q.version),typeof ae=="object"&&(ae=ae.version),Ue=q===ae;break;case"!==":typeof q=="object"&&(q=q.version),typeof ae=="object"&&(ae=ae.version),Ue=q!==ae;break;case"":case"=":case"==":Ue=Ee(q,ae,Me);break;case"!=":Ue=me(q,ae,Me);break;case">":Ue=le(q,ae,Me);break;case">=":Ue=De(q,ae,Me);break;case"<":Ue=we(q,ae,Me);break;case"<=":Ue=re(q,ae,Me);break;default:throw new TypeError("Invalid operator: "+Z)}return Ue}function se(q,Z){if(q instanceof se){if(q.loose===Z)return q;q=q.value}if(!(this instanceof se))return new se(q,Z);k("comparator",q,Z),this.loose=Z,this.parse(q),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(q,Z){return x(Z,q)},e.major=function(q,Z){return new pe(q,Z).major},e.minor=function(q,Z){return new pe(q,Z).minor},e.patch=function(q,Z){return new pe(q,Z).patch},e.compare=W,e.compareLoose=function(q,Z){return W(q,Z,!0)},e.rcompare=function(q,Z,ae){return W(Z,q,ae)},e.sort=function(q,Z){return q.sort(function(ae,Me){return e.compare(ae,Me,Z)})},e.rsort=function(q,Z){return q.sort(function(ae,Me){return e.rcompare(ae,Me,Z)})},e.gt=le,e.lt=we,e.eq=Ee,e.neq=me,e.gte=De,e.lte=re,e.cmp=de,e.Comparator=se;var oe={};function fe(q,Z){if(q instanceof fe)return q.loose===Z?q:new fe(q.raw,Z);if(q instanceof se)return new fe(q.value,Z);if(!(this instanceof fe))return new fe(q,Z);if(this.loose=Z,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function O(q,Z,ae,Me,Ue,Ge,je,Je,Ye,et,it,tt,xe){return((Z=Ie(ae)?"":Ie(Me)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Me+".0":">="+Z)+" "+(Je=Ie(Ye)?"":Ie(et)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+et+1)+".0":tt?"<="+Ye+"."+et+"."+it+"-"+tt:"<="+Je)).trim()}function V(q,Z){for(var ae=0;ae<q.length;ae++)if(!q[ae].test(Z))return!1;if(Z.prerelease.length){for(ae=0;ae<q.length;ae++)if(k(q[ae].semver),q[ae].semver!==oe&&q[ae].semver.prerelease.length>0){var Me=q[ae].semver;if(Me.major===Z.major&&Me.minor===Z.minor&&Me.patch===Z.patch)return!0}return!1}return!0}function K(q,Z,ae){try{Z=new fe(Z,ae)}catch{return!1}return Z.test(q)}function G(q,Z,ae,Me){var Ue,Ge,je,Je,Ye;switch(q=new pe(q,Me),Z=new fe(Z,Me),ae){case">":Ue=le,Ge=re,je=we,Je=">",Ye=">=";break;case"<":Ue=we,Ge=De,je=le,Je="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(q,Z,Me))return!1;for(var et=0;et<Z.set.length;++et){var it=Z.set[et],tt=null,xe=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,xe=xe||st,Ue(st.semver,tt.semver,Me)?tt=st:je(st.semver,xe.semver,Me)&&(xe=st)}),tt.operator===Je||tt.operator===Ye||(!xe.operator||xe.operator===Je)&&Ge(q,xe.semver)||xe.operator===Ye&&je(q,xe.semver))return!1}return!0}se.prototype.parse=function(q){var Z=this.loose?d[Q]:d[Se],ae=q.match(Z);if(!ae)throw new TypeError("Invalid comparator: "+q);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new pe(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(q){return k("Comparator.test",q,this.loose),this.semver===oe||(typeof q=="string"&&(q=new pe(q,this.loose)),de(q,this.operator,this.semver,this.loose))},se.prototype.intersects=function(q,Z){if(!(q instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(q.value,Z),K(this.value,ae,Z);if(q.operator==="")return ae=new fe(this.value,Z),K(q.semver,ae,Z);var Me=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ge=this.semver.version===q.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Je=de(this.semver,"<",q.semver,Z)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=de(this.semver,">",q.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Me||Ue||Ge&&je||Je||Ye},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(q){var Z=this.loose;q=q.trim(),k("range",q,Z);var ae=Z?d[Y]:d[Pe];q=q.replace(ae,O),k("hyphen replace",q),q=q.replace(d[ye],"$1$2$3"),k("comparator trim",q,d[ye]),q=(q=(q=q.replace(d[B],"$1~")).replace(d[M],"$1^")).split(/\s+/).join(" ");var Me=Z?d[Q]:d[Se],Ue=q.split(" ").map(function(Ge){return function(je,Je){return k("comp",je),je=function(Ye,et){return Ye.trim().split(/\s+/).map(function(it){return function(tt,xe){k("caret",tt,xe);var st=xe?d[ee]:d[N];return tt.replace(st,function(J,X,ve,Be,Ne){var Xe;return k("caret",tt,J,X,ve,Be,Ne),Ie(X)?Xe="":Ie(ve)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=X==="0"?">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+".0 <"+(+X+1)+".0.0":Ne?(k("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=X==="0"?ve==="0"?">="+X+"."+ve+"."+Be+Ne+" <"+X+"."+ve+"."+(+Be+1):">="+X+"."+ve+"."+Be+Ne+" <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+"."+Be+Ne+" <"+(+X+1)+".0.0"):(k("no pr"),Xe=X==="0"?ve==="0"?">="+X+"."+ve+"."+Be+" <"+X+"."+ve+"."+(+Be+1):">="+X+"."+ve+"."+Be+" <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+"."+Be+" <"+(+X+1)+".0.0"),k("caret return",Xe),Xe})}(it,et)}).join(" ")}(je,Je),k("caret",je),je=function(Ye,et){return Ye.trim().split(/\s+/).map(function(it){return function(tt,xe){var st=xe?d[U]:d[H];return tt.replace(st,function(J,X,ve,Be,Ne){var Xe;return k("tilde",tt,J,X,ve,Be,Ne),Ie(X)?Xe="":Ie(ve)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0":Ne?(k("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+X+"."+ve+"."+Be+Ne+" <"+X+"."+(+ve+1)+".0"):Xe=">="+X+"."+ve+"."+Be+" <"+X+"."+(+ve+1)+".0",k("tilde return",Xe),Xe})}(it,et)}).join(" ")}(je,Je),k("tildes",je),je=function(Ye,et){return k("replaceXRanges",Ye,et),Ye.split(/\s+/).map(function(it){return function(tt,xe){tt=tt.trim();var st=xe?d[h]:d[c];return tt.replace(st,function(J,X,ve,Be,Ne,Xe){k("xRange",tt,J,X,ve,Be,Ne,Xe);var nt=Ie(ve),ht=nt||Ie(Be),wt=ht||Ie(Ne);return X==="="&&wt&&(X=""),nt?J=X===">"||X==="<"?"<0.0.0":"*":X&&wt?(ht&&(Be=0),wt&&(Ne=0),X===">"?(X=">=",ht?(ve=+ve+1,Be=0,Ne=0):wt&&(Be=+Be+1,Ne=0)):X==="<="&&(X="<",ht?ve=+ve+1:Be=+Be+1),J=X+ve+"."+Be+"."+Ne):ht?J=">="+ve+".0.0 <"+(+ve+1)+".0.0":wt&&(J=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),k("xRange return",J),J})}(it,et)}).join(" ")}(je,Je),k("xrange",je),je=function(Ye,et){return k("replaceStars",Ye,et),Ye.trim().replace(d[ue],"")}(je,Je),k("stars",je),je}(Ge,Z)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ge){return!!Ge.match(Me)})),Ue=Ue.map(function(Ge){return new se(Ge,Z)})},fe.prototype.intersects=function(q,Z){if(!(q instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Me){return q.set.some(function(Ue){return Ue.every(function(Ge){return Me.intersects(Ge,Z)})})})})},e.toComparators=function(q,Z){return new fe(q,Z).set.map(function(ae){return ae.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new pe(q,this.loose));for(var Z=0;Z<this.set.length;Z++)if(V(this.set[Z],q))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(q,Z,ae){var Me=null,Ue=null;try{var Ge=new fe(Z,ae)}catch{return null}return q.forEach(function(je){Ge.test(je)&&(Me&&Ue.compare(je)!==-1||(Ue=new pe(Me=je,ae)))}),Me},e.minSatisfying=function(q,Z,ae){var Me=null,Ue=null;try{var Ge=new fe(Z,ae)}catch{return null}return q.forEach(function(je){Ge.test(je)&&(Me&&Ue.compare(je)!==1||(Ue=new pe(Me=je,ae)))}),Me},e.validRange=function(q,Z){try{return new fe(q,Z).range||"*"}catch{return null}},e.ltr=function(q,Z,ae){return G(q,Z,"<",ae)},e.gtr=function(q,Z,ae){return G(q,Z,">",ae)},e.outside=G,e.prerelease=function(q,Z){var ae=ce(q,Z);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(q,Z,ae){return q=new fe(q,ae),Z=new fe(Z,ae),q.intersects(Z)},e.coerce=function(q){if(q instanceof pe)return q;if(typeof q!="string")return null;var Z=q.match(d[u]);return Z==null?null:ce((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,w(1))},function(be,e){var w,R,k=be.exports={};function F(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function d(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{R=typeof clearTimeout=="function"?clearTimeout:T}catch{R=T}})();var y,m=[],P=!1,_=-1;function a(){P&&y&&(P=!1,y.length?m=y.concat(m):_=-1,m.length&&v())}function v(){if(!P){var t=d(a);P=!0;for(var n=m.length;n;){for(y=m,m=[];++_<n;)y&&y[_].run();_=-1,n=m.length}y=null,P=!1,function(l){if(R===clearTimeout)return clearTimeout(l);if((R===T||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(l);try{R(l)}catch{try{return R.call(null,l)}catch{return R.call(this,l)}}}(t)}}function g(t,n){this.fun=t,this.array=n}function f(){}k.nextTick=function(t){var n=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)n[l-1]=arguments[l];m.push(new g(t,n)),m.length!==1||P||d(v)},g.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=f,k.addListener=f,k.once=f,k.off=f,k.removeListener=f,k.removeAllListeners=f,k.emit=f,k.prependListener=f,k.prependOnceListener=f,k.listeners=function(t){return[]},k.binding=function(t){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(t){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Te[118],Ae([1,0,9,6]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(D){const p=D;return p?typeof p.read=="function":!1}e.isReadable=k;function F(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=F;function T(D){const p=D;return p?F(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function d(D,p){return new y(D,p)}e.newWriteableStream=d;class y{constructor(p,r){this.reducer=p,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(r=>r(p))}emitError(p){this.listeners.error.length===0?(0,w.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(r=>r(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,r){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(p,r){if(this.state.destroyed)return;let s;switch(p){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(r);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(D,p){const r=[];let s;for(;(s=D.read())!==null;)r.push(s);return p(r)}e.consumeReadable=m;function P(D,p,r){const s=[];let i;for(;(i=D.read())!==null&&s.length<r;)s.push(i);return i===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return D.read()}}}e.peekReadable=P;function _(D,p){return new Promise((r,s)=>{const i=[];a(D,{onData:o=>{p&&i.push(o)},onError:o=>{p?s(o):r(void 0)},onEnd:()=>{r(p?p(i):void 0)}})})}e.consumeStream=_;function a(D,p,r){D.on("error",s=>{r?.isCancellationRequested||p.onError(s)}),D.on("end",()=>{r?.isCancellationRequested||p.onEnd()}),D.on("data",s=>{r?.isCancellationRequested||p.onData(s)})}e.listenStream=a;function v(D,p){return new Promise((r,s)=>{const i=new R.DisposableStore,o=[],S=I=>{if(o.push(I),o.length>p)return i.dispose(),D.pause(),r({stream:D,buffer:o,ended:!1})},b=I=>(i.dispose(),s(I)),C=()=>(i.dispose(),r({stream:D,buffer:o,ended:!0}));i.add((0,R.toDisposable)(()=>D.removeListener("error",b))),D.on("error",b),i.add((0,R.toDisposable)(()=>D.removeListener("end",C))),D.on("end",C),i.add((0,R.toDisposable)(()=>D.removeListener("data",S))),D.on("data",S)})}e.peekStream=v;function g(D,p){const r=d(p);return r.end(D),r}e.toStream=g;function f(){const D=d(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=f;function t(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.toReadable=t;function n(D,p,r){const s=d(r);return a(D,{onData:i=>s.write(p.data(i)),onError:i=>s.error(p.error?p.error(i):i),onEnd:()=>s.end()}),s}e.transform=n;function l(D,p,r){let s=!1;return{read:()=>{const i=p.read();return s?i:(s=!0,i!==null?r([D,i]):D)}}}e.prefixedReadable=l;function E(D,p,r){let s=!1;const i=d(r);return a(p,{onData:o=>s?i.write(o):(s=!0,i.write(r([D,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(D)),i.end()}}),i}e.prefixedStream=E}),define(Te[25],Ae([1,0,66,118]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",F=new w.Lazy(()=>new Uint8Array(256));let T,d;class y{static alloc(u){return k?new y(Buffer.allocUnsafe(u)):new y(new Uint8Array(u))}static wrap(u){return k&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new y(u)}static fromString(u,A){return!(A?.dontUseNodeBuffer||!1)&&k?new y(Buffer.from(u)):(T||(T=new TextEncoder),new y(T.encode(u)))}static fromByteArray(u){const A=y.alloc(u.length);for(let B=0,H=u.length;B<H;B++)A.buffer[B]=u[B];return A}static concat(u,A){if(typeof A>"u"){A=0;for(let U=0,z=u.length;U<z;U++)A+=u[U].byteLength}const B=y.alloc(A);let H=0;for(let U=0,z=u.length;U<z;U++){const M=u[U];B.set(M,H),H+=M.byteLength}return B}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=y.alloc(this.byteLength);return u.set(this),u}toString(){return k?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(u,A){return new y(this.buffer.subarray(u,A))}set(u,A){if(u instanceof y)this.buffer.set(u.buffer,A);else if(u instanceof Uint8Array)this.buffer.set(u,A);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),A);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return a(this.buffer,u)}writeUInt32BE(u,A){v(this.buffer,u,A)}readUInt32LE(u){return g(this.buffer,u)}writeUInt32LE(u,A){f(this.buffer,u,A)}readUInt8(u){return t(this.buffer,u)}writeUInt8(u,A){n(this.buffer,u,A)}indexOf(u,A=0){return m(this.buffer,u instanceof y?u.buffer:u,A)}}e.VSBuffer=y;function m(h,u,A=0){const B=u.byteLength,H=h.byteLength;if(B===0)return 0;if(B===1)return h.indexOf(u[0]);if(B>H-A)return-1;const U=F.value;U.fill(u.length);for(let ee=0;ee<u.length;ee++)U[u[ee]]=u.length-ee-1;let z=A+u.length-1,M=z,N=-1;for(;z<H;)if(h[z]===u[M]){if(M===0){N=z;break}z--,M--}else z+=Math.max(u.length-M,U[h[z]]),M=u.length-1;return N}e.binaryIndexOf=m;function P(h,u){return h[u+0]<<0>>>0|h[u+1]<<8>>>0}e.readUInt16LE=P;function _(h,u,A){h[A+0]=u&255,u=u>>>8,h[A+1]=u&255}e.writeUInt16LE=_;function a(h,u){return h[u]*2**24+h[u+1]*2**16+h[u+2]*2**8+h[u+3]}e.readUInt32BE=a;function v(h,u,A){h[A+3]=u,u=u>>>8,h[A+2]=u,u=u>>>8,h[A+1]=u,u=u>>>8,h[A]=u}e.writeUInt32BE=v;function g(h,u){return h[u+0]<<0>>>0|h[u+1]<<8>>>0|h[u+2]<<16>>>0|h[u+3]<<24>>>0}e.readUInt32LE=g;function f(h,u,A){h[A+0]=u&255,u=u>>>8,h[A+1]=u&255,u=u>>>8,h[A+2]=u&255,u=u>>>8,h[A+3]=u&255}e.writeUInt32LE=f;function t(h,u){return h[u]}e.readUInt8=t;function n(h,u,A){h[A]=u}e.writeUInt8=n;function l(h){return R.consumeReadable(h,u=>y.concat(u))}e.readableToBuffer=l;function E(h){return R.toReadable(h)}e.bufferToReadable=E;function D(h){return R.consumeStream(h,u=>y.concat(u))}e.streamToBuffer=D;async function p(h){return h.ended?y.concat(h.buffer):y.concat([...h.buffer,await D(h.stream)])}e.bufferedStreamToBuffer=p;function r(h){return R.toStream(h,u=>y.concat(u))}e.bufferToStream=r;function s(h){return R.transform(h,{data:u=>typeof u=="string"?y.fromString(u):y.wrap(u)},u=>y.concat(u))}e.streamToBufferReadableStream=s;function i(h){return R.newWriteableStream(u=>y.concat(u),h)}e.newWriteableBufferStream=i;function o(h,u){return R.prefixedReadable(h,u,A=>y.concat(A))}e.prefixedBufferReadable=o;function S(h,u){return R.prefixedStream(h,u,A=>y.concat(A))}e.prefixedBufferStream=S;function b(h){let u=0,A=0,B=0;const H=new Uint8Array(Math.floor(h.length/4*3)),U=M=>{switch(A){case 3:H[B++]=u|M,A=0;break;case 2:H[B++]=u|M>>>2,u=M<<6,A=3;break;case 1:H[B++]=u|M>>>4,u=M<<4,A=2;break;default:u=M<<2,A=1}};for(let M=0;M<h.length;M++){const N=h.charCodeAt(M);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${h[M]}`)}}const z=B;for(;A>0;)U(0);return y.wrap(H).slice(0,z)}e.decodeBase64=b;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:h},u=!0,A=!1){const B=A?I:C;let H="";const U=h.byteLength%3;let z=0;for(;z<h.byteLength-U;z+=3){const M=h[z+0],N=h[z+1],ee=h[z+2];H+=B[M>>>2],H+=B[(M<<4|N>>>4)&63],H+=B[(N<<2|ee>>>6)&63],H+=B[ee&63]}if(U===1){const M=h[z+0];H+=B[M>>>2],H+=B[M<<4&63],u&&(H+="==")}else if(U===2){const M=h[z+0],N=h[z+1];H+=B[M>>>2],H+=B[(M<<4|N>>>4)&63],H+=B[N<<2&63],u&&(H+="=")}return H}e.encodeBase64=c}),define(Te[119],Ae([1,0,28,15]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...se){return function(oe,fe){for(let Ie=0,O=se.length;Ie<O;Ie++){const V=se[Ie](oe,fe);if(V)return V}return null}}e.or=k,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(se,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return se?Ie=R.startsWithIgnoreCase(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function T(se,oe){const fe=oe.toLowerCase().indexOf(se.toLowerCase());return fe===-1?null:[{start:fe,end:fe+se.length}]}e.matchesContiguousSubString=T;function d(se,oe){return y(se.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=d;function y(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]===oe[Ie]){let O=null;return(O=y(se,oe,fe+1,Ie+1))?n({start:Ie,end:Ie+1},O):null}return y(se,oe,fe,Ie+1)}function m(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.isUpper=P;function _(se){return 48<=se&&se<=57}function a(se){return se===32||se===9||se===10||se===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>v.add(se.charCodeAt(0)));function g(se){return a(se)||v.has(se)}function f(se,oe){return se===oe||g(se)&&g(oe)}function t(se){return m(se)||P(se)||_(se)}function n(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function l(se,oe){for(let fe=oe;fe<se.length;fe++){const Ie=se.charCodeAt(fe);if(P(Ie)||_(Ie)||fe>0&&!t(se.charCodeAt(fe-1)))return fe}return se.length}function E(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]!==oe[Ie].toLowerCase())return null;{let O=null,V=Ie+1;for(O=E(se,oe,fe+1,Ie+1);!O&&(V=l(oe,V))<oe.length;)O=E(se,oe,fe+1,V),V++;return O===null?null:n({start:Ie,end:Ie+1},O)}}function D(se){let oe=0,fe=0,Ie=0,O=0,V=0;for(let ae=0;ae<se.length;ae++)V=se.charCodeAt(ae),P(V)&&oe++,m(V)&&fe++,t(V)&&Ie++,_(V)&&O++;const K=oe/se.length,G=fe/se.length,q=Ie/se.length,Z=O/se.length;return{upperPercent:K,lowerPercent:G,alphaPercent:q,numericPercent:Z}}function p(se){const{upperPercent:oe,lowerPercent:fe}=se;return fe===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:O}=se;return fe>.2&&oe<.8&&Ie>.6&&O<.2}function s(se){let oe=0,fe=0,Ie=0,O=0;for(let V=0;V<se.length;V++)Ie=se.charCodeAt(V),P(Ie)&&oe++,m(Ie)&&fe++,a(Ie)&&O++;return(oe===0||fe===0)&&O===0?se.length<=30:oe<=5}function i(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const fe=D(oe);if(!r(fe)){if(!p(fe))return null;oe=oe.toLowerCase()}let Ie=null,O=0;for(se=se.toLowerCase();O<oe.length&&(Ie=E(se,oe,0,O))===null;)O=l(oe,O+1);return Ie}e.matchesCamelCase=i;function o(se,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,O=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();O<oe.length&&(Ie=S(se,oe,0,O,fe))===null;)O=b(oe,O+1);return Ie}e.matchesWords=o;function S(se,oe,fe,Ie,O){if(fe===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(fe),oe.charCodeAt(Ie))){let V=null,K=Ie+1;if(V=S(se,oe,fe+1,Ie+1,O),!O)for(;!V&&(K=b(oe,K))<oe.length;)V=S(se,oe,fe+1,K,O),K++;return V?se.charCodeAt(fe)!==oe.charCodeAt(Ie)?V:n({start:Ie,end:Ie+1},V):null}else return null}function b(se,oe){for(let fe=oe;fe<se.length;fe++)if(g(se.charCodeAt(fe))||fe>0&&g(se.charCodeAt(fe-1)))return fe;return se.length}const C=k(e.matchesPrefix,i,T),I=k(e.matchesPrefix,i,d),c=new w.LRUCache(1e4);function h(se,oe,fe=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=c.get(se);Ie||(Ie=new RegExp(R.convertSimple2RegExpPattern(se),"i"),c.set(se,Ie));const O=Ie.exec(oe);return O?[{start:O.index,end:O.index+O[0].length}]:fe?I(se,oe):C(se,oe)}e.matchesFuzzy=h;function u(se,oe){const fe=le(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?B(fe):null}e.matchesFuzzy2=u;function A(se,oe,fe,Ie,O,V){const K=Math.min(13,se.length);for(;fe<K;fe++){const G=le(se,oe,fe,Ie,O,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,V]}e.anyScore=A;function B(se){if(typeof se>"u")return[];const oe=[],fe=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const O=se[Ie]+fe,V=oe[oe.length-1];V&&V.end===O?V.end=O+1:oe.push({start:O,end:O+1})}return oe}e.createMatches=B;const H=128;function U(){const se=[],oe=[];for(let fe=0;fe<=H;fe++)oe[fe]=0;for(let fe=0;fe<=H;fe++)se.push(oe.slice(0));return se}function z(se){const oe=[];for(let fe=0;fe<=se;fe++)oe[fe]=0;return oe}const M=z(2*H),N=z(2*H),ee=U(),Q=U(),Se=U(),ye=!1;function Pe(se,oe,fe,Ie,O){function V(G,q,Z=" "){for(;G.length<q;)G=Z+G;return G}let K=` |   |${Ie.split("").map(G=>V(G,3)).join("|")}
`;for(let G=0;G<=fe;G++)G===0?K+=" |":K+=`${oe[G-1]}|`,K+=se[G].slice(0,O+1).map(q=>V(q.toString(),3)).join("|")+`
`;return K}function Y(se,oe,fe,Ie){se=se.substr(oe),fe=fe.substr(Ie),console.log(Pe(Q,se,se.length,fe,fe.length)),console.log(Pe(Se,se,se.length,fe,fe.length)),console.log(Pe(ee,se,se.length,fe,fe.length))}function ue(se,oe){if(oe<0||oe>=se.length)return!1;const fe=se.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(fe)}}function _e(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,fe){return oe[se]!==fe[se]}function pe(se,oe,fe,Ie,O,V,K=!1){for(;oe<fe&&O<V;)se[oe]===Ie[O]&&(K&&(M[oe]=O),oe+=1),O+=1;return oe===fe}e.isPatternInWord=pe;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var x;(function(se){se.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}se.isDefault=oe})(x||(e.FuzzyScore=x={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.FuzzyScoreOptions=W;function le(se,oe,fe,Ie,O,V,K=W.default){const G=se.length>H?H:se.length,q=Ie.length>H?H:Ie.length;if(fe>=G||V>=q||G-fe>q-V||!pe(oe,fe,G,O,V,q,!0))return;we(G,q,fe,V,oe,O);let Z=1,ae=1,Me=fe,Ue=V;const Ge=[!1];for(Z=1,Me=fe;Me<G;Z++,Me++){const it=M[Me],tt=N[Me],xe=Me+1<G?N[Me+1]:q;for(ae=it-V+1,Ue=it;Ue<xe;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,J=!1;Ue<=tt&&(st=Ee(se,oe,Me,fe,Ie,O,Ue,q,V,ee[Z-1][ae-1]===0,Ge));let X=0;st!==Number.MAX_SAFE_INTEGER&&(J=!0,X=st+Q[Z-1][ae-1]);const ve=Ue>it,Be=ve?Q[Z][ae-1]+(ee[Z][ae-1]>0?-5:0):0,Ne=Ue>it+1&&ee[Z][ae-1]>0,Xe=Ne?Q[Z][ae-2]+(ee[Z][ae-2]>0?-5:0):0;if(Ne&&(!ve||Xe>=Be)&&(!J||Xe>=X))Q[Z][ae]=Xe,Se[Z][ae]=3,ee[Z][ae]=0;else if(ve&&(!J||Be>=X))Q[Z][ae]=Be,Se[Z][ae]=2,ee[Z][ae]=0;else if(J)Q[Z][ae]=X,Se[Z][ae]=1,ee[Z][ae]=ee[Z-1][ae-1]+1;else throw new Error("not possible")}}if(ye&&Y(se,fe,Ie,V),!Ge[0]&&!K.firstMatchCanBeWeak)return;Z--,ae--;const je=[Q[Z][ae],V];let Je=0,Ye=0;for(;Z>=1;){let it=ae;do{const tt=Se[Z][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);Je>1&&oe[fe+Z-1]===O[V+ae-1]&&!ce(it+V-1,Ie,O)&&Je+1>ee[Z][it]&&(it=ae),it===ae?Je++:Je=1,Ye||(Ye=it),Z--,ae=it-1,je.push(ae)}q===G&&K.boostFullMatch&&(je[0]+=2);const et=Ye-G;return je[0]-=et,je}e.fuzzyScore=le;function we(se,oe,fe,Ie,O,V){let K=se-1,G=oe-1;for(;K>=fe&&G>=Ie;)O[K]===V[G]&&(N[K]=G,K--),G--}function Ee(se,oe,fe,Ie,O,V,K,G,q,Z,ae){if(oe[fe]!==V[K])return Number.MIN_SAFE_INTEGER;let Me=1,Ue=!1;return K===fe-Ie?Me=se[fe]===O[K]?7:5:ce(K,O,V)&&(K===0||!ce(K-1,O,V))?(Me=se[fe]===O[K]?7:5,Ue=!0):ue(V,K)&&(K===0||!ue(V,K-1))?Me=5:(ue(V,K-1)||_e(V,K-1))&&(Me=5,Ue=!0),Me>1&&fe===Ie&&(ae[0]=!0),Ue||(Ue=ce(K,O,V)||ue(V,K-1)||_e(V,K-1)),fe===Ie?K>q&&(Me-=Ue?3:5):Z?Me+=Ue?2:0:Me+=Ue?0:1,K+1===G&&(Me-=Ue?3:5),Me}function me(se,oe,fe,Ie,O,V,K){return re(se,oe,fe,Ie,O,V,!0,K)}e.fuzzyScoreGracefulAggressive=me;function De(se,oe,fe,Ie,O,V,K){return re(se,oe,fe,Ie,O,V,!1,K)}e.fuzzyScoreGraceful=De;function re(se,oe,fe,Ie,O,V,K,G){let q=le(se,oe,fe,Ie,O,V,G);if(q&&!K)return q;if(se.length>=3){const Z=Math.min(7,se.length-1);for(let ae=fe+1;ae<Z;ae++){const Me=de(se,ae);if(Me){const Ue=le(Me,Me.toLowerCase(),fe,Ie,O,V,G);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function de(se,oe){if(oe+1>=se.length)return;const fe=se[oe],Ie=se[oe+1];if(fe!==Ie)return se.slice(0,oe)+Ie+fe+se.slice(oe+2)}}),define(Te[29],Ae([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const F="error",T="warning",d="warn",y="info",m="ignore";function P(a){return a?w.equalsIgnoreCase(F,a)?k.Error:w.equalsIgnoreCase(T,a)||w.equalsIgnoreCase(d,a)?k.Warning:w.equalsIgnoreCase(y,a)?k.Info:k.Ignore:k.Ignore}k.fromValue=P;function _(a){switch(a){case k.Error:return F;case k.Warning:return T;case k.Info:return y;default:return m}}k.toString=_}(R||(R={})),e.default=R}),define(Te[120],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Te[48],Ae([1,0,18,15]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(v){return this._value=v,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(v){const g=v.charCodeAt(0),f=this._value.charCodeAt(this._pos);return g-f}value(){return this._value[this._pos]}}e.StringIterator=k;class F{constructor(v=!0){this._caseSensitive=v}reset(v){return this._value=v,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let v=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(v)this._from++;else break;else v=!1;return this}cmp(v){return this._caseSensitive?(0,R.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=F;class T{constructor(v=!0,g=!0){this._splitOnBackslash=v,this._caseSensitive=g}reset(v){this._from=0,this._to=0,this._value=v,this._valueLen=v.length;for(let g=v.length-1;g>=0;g--,this._valueLen--){const f=this._value.charCodeAt(g);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let v=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(v)this._from++;else break;else v=!1}return this}cmp(v){return this._caseSensitive?(0,R.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class y{constructor(v,g){this._ignorePathCasing=v,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(v){return this._value=v,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(v)),this._pathIterator.reset(v.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(v)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(v){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(v,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(v,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(v);if(this._states[this._stateIdx]===4)return(0,R.compare)(v,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(v,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class _{static forUris(v=()=>!1,g=()=>!1){return new _(new y(v,g))}static forPaths(v=!1){return new _(new T(void 0,!v))}static forStrings(){return new _(new k)}static forConfigKeys(){return new _(new F)}constructor(v){this._iter=v}clear(){this._root=void 0}fill(v,g){if(g){const f=g.slice(0);(0,w.shuffle)(f);for(const t of f)this.set(t,v)}else{const f=v.slice(0);(0,w.shuffle)(f);for(const t of f)this.set(t[0],t[1])}}set(v,g){const f=this._iter.reset(v);let t;this._root||(this._root=new m,this._root.segment=f.value());const n=[];for(t=this._root;;){const E=f.cmp(t.segment);if(E>0)t.left||(t.left=new m,t.left.segment=f.value()),n.push([-1,t]),t=t.left;else if(E<0)t.right||(t.right=new m,t.right.segment=f.value()),n.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new m,t.mid.segment=f.value()),n.push([0,t]),t=t.mid;else break}const l=t.value;t.value=g,t.key=v;for(let E=n.length-1;E>=0;E--){const D=n[E][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const r=n[E][0],s=n[E+1][0];if(r===1&&s===1)n[E][1]=D.rotateLeft();else if(r===-1&&s===-1)n[E][1]=D.rotateRight();else if(r===1&&s===-1)D.right=n[E+1][1]=n[E+1][1].rotateRight(),n[E][1]=D.rotateLeft();else if(r===-1&&s===1)D.left=n[E+1][1]=n[E+1][1].rotateLeft(),n[E][1]=D.rotateRight();else throw new Error;if(E>0)switch(n[E-1][0]){case-1:n[E-1][1].left=n[E][1];break;case 1:n[E-1][1].right=n[E][1];break;case 0:n[E-1][1].mid=n[E][1];break}else this._root=n[0][1]}}return l}get(v){return this._getNode(v)?.value}_getNode(v){const g=this._iter.reset(v);let f=this._root;for(;f;){const t=g.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else break}return f}has(v){const g=this._getNode(v);return!(g?.value===void 0&&g?.mid===void 0)}delete(v){return this._delete(v,!1)}deleteSuperstr(v){return this._delete(v,!0)}_delete(v,g){const f=this._iter.reset(v),t=[];let n=this._root;for(;n;){const l=f.cmp(n.segment);if(l>0)t.push([-1,n]),n=n.left;else if(l<0)t.push([1,n]),n=n.right;else if(f.hasNext())f.next(),t.push([0,n]),n=n.mid;else break}if(n){if(g?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const l=this._min(n.right);if(l.key){const{key:E,value:D,segment:p}=l;this._delete(l.key,!1),n.key=E,n.value=D,n.segment=p}}else{const l=n.left??n.right;if(t.length>0){const[E,D]=t[t.length-1];switch(E){case-1:D.left=l;break;case 0:D.mid=l;break;case 1:D.right=l;break}}else this._root=l}for(let l=t.length-1;l>=0;l--){const E=t[l][1];E.updateHeight();const D=E.balanceFactor();if(D>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),t[l][1]=E.rotateLeft()):D<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),t[l][1]=E.rotateRight()),l>0)switch(t[l-1][0]){case-1:t[l-1][1].left=t[l][1];break;case 1:t[l-1][1].right=t[l][1];break;case 0:t[l-1][1].mid=t[l][1];break}else this._root=t[0][1]}}}_min(v){for(;v.left;)v=v.left;return v}findSubstr(v){const g=this._iter.reset(v);let f=this._root,t;for(;f;){const n=g.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(g.hasNext())g.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(v){return this._findSuperstrOrElement(v,!1)}_findSuperstrOrElement(v,g){const f=this._iter.reset(v);let t=this._root;for(;t;){const n=f.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this._entries(t.mid):g?t.value:void 0}}hasElementOrSubtree(v){return this._findSuperstrOrElement(v,!0)!==void 0}forEach(v){for(const[g,f]of this)v(f,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(v){const g=[];return this._dfsEntries(v,g),g[Symbol.iterator]()}_dfsEntries(v,g){v&&(v.left&&this._dfsEntries(v.left,g),v.value&&g.push([v.key,v.value]),v.mid&&this._dfsEntries(v.mid,g),v.right&&this._dfsEntries(v.right,g))}_isBalanced(){const v=g=>{if(!g)return!0;const f=g.balanceFactor();return f<-1||f>1?!1:v(g.left)&&v(g.right)};return v(this._root)}}e.TernarySearchTree=_}),define(Te[40],Ae([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(T){function d(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=d})(R||(e.ThemeColor=R={}));function k(T){return{id:T}}e.themeColorFromId=k;var F;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(l){const E=d.exec(l.id);if(!E)return y(w.Codicon.error);const[,D,p]=E,r=["codicon","codicon-"+D];return p&&r.push("codicon-modifier-"+p.substring(1)),r}T.asClassNameArray=y;function m(l){return y(l).join(" ")}T.asClassName=m;function P(l){return"."+y(l).join(".")}T.asCSSSelector=P;function _(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||R.isThemeColor(l.color))}T.isThemeIcon=_;const a=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function v(l){const E=a.exec(l);if(!E)return;const[,D]=E;return{id:D}}T.fromString=v;function g(l){return{id:l}}T.fromId=g;function f(l,E){let D=l.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),E&&(D=`${D}~${E}`),{id:D}}T.modify=f;function t(l){const E=l.id.lastIndexOf("~");if(E!==-1)return l.id.substring(E+1)}T.getModifier=t;function n(l,E){return l.id===E.id&&l.color?.id===E.color?.id}T.isEqual=n})(F||(e.ThemeIcon=F={}))}),define(Te[121],Ae([1,0,119,15,40]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const F="$(",T=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),d=new RegExp(`(\\\\)?${T.source}`,"g");function y(n){return n.replace(d,(l,E)=>E?l:`\\${l}`)}e.escapeIcons=y;const m=new RegExp(`\\\\${T.source}`,"g");function P(n){return n.replace(m,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=P;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function a(n){return n.indexOf(F)===-1?n:n.replace(_,(l,E,D,p)=>D?l:E||p||"")}e.stripIcons=a;function v(n){return n?n.replace(/\$\((.*?)\)/g,(l,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=v;const g=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(n){g.lastIndex=0;let l="";const E=[];let D=0;for(;;){const p=g.lastIndex,r=g.exec(n),s=n.substring(p,r?.index);if(s.length>0){l+=s;for(let i=0;i<s.length;i++)E.push(D)}if(!r)break;D+=r[0].length}return{text:l,iconOffsets:E}}e.parseLabelWithIcons=f;function t(n,l,E=!1){const{text:D,iconOffsets:p}=l;if(!p||p.length===0)return(0,w.matchesFuzzy)(n,D,E);const r=(0,R.ltrim)(D," "),s=D.length-r.length,i=(0,w.matchesFuzzy)(n,r,E);if(i)for(const o of i){const S=p[o.start+s]+s;o.start+=S,o.end+=S}return i}e.matchesFuzzyIconAware=t}),define(Te[36],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(k){return w.test(k)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(d){for(let y=0;y<d.length;y++)d[y]=Math.floor(Math.random()*256);return d};const F=new Uint8Array(16),T=[];for(let d=0;d<256;d++)T.push(d.toString(16).padStart(2,"0"));return function(){k(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let y=0,m="";return m+=T[F[y++]],m+=T[F[y++]],m+=T[F[y++]],m+=T[F[y++]],m+="-",m+=T[F[y++]],m+=T[F[y++]],m+="-",m+=T[F[y++]],m+=T[F[y++]],m+="-",m+=T[F[y++]],m+=T[F[y++]],m+="-",m+=T[F[y++]],m+=T[F[y++]],m+=T[F[y++]],m+=T[F[y++]],m+=T[F[y++]],m+=T[F[y++]],m}}()}),define(Te[122],Ae([1,0,18,67,36]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function F(_){return{asString:async()=>_,asFile:()=>{},value:typeof _=="string"?_:void 0}}e.createStringDataTransferItem=F;function T(_,a,v){const g={id:(0,k.generateUuid)(),name:_,uri:a,data:v};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.createFileDataTransferItem=T;class d{constructor(){this._entries=new Map}get size(){let a=0;for(const v of this._entries)a++;return a}has(a){return this._entries.has(this.toKey(a))}matches(a){const v=[...this._entries.keys()];return R.Iterable.some(this,([g,f])=>f.asFile())&&v.push("files"),P(y(a),v)}get(a){return this._entries.get(this.toKey(a))?.[0]}append(a,v){const g=this._entries.get(a);g?g.push(v):this._entries.set(this.toKey(a),[v])}replace(a,v){this._entries.set(this.toKey(a),[v])}delete(a){this._entries.delete(this.toKey(a))}*[Symbol.iterator](){for(const[a,v]of this._entries)for(const g of v)yield[a,g]}toKey(a){return y(a)}}e.VSDataTransfer=d;function y(_){return _.toLowerCase()}function m(_,a){return P(y(_),a.map(y))}e.matchesMimeType=m;function P(_,a){if(_==="*/*")return a.length>0;if(a.includes(_))return!0;const v=_.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[g,f,t]=v;return t==="*"?a.some(n=>n.startsWith(f+"/")):!1}e.UriList=Object.freeze({create:_=>(0,w.distinct)(_.map(a=>a.toString())).join(`\r
`),split:_=>_.split(`\r
`),parse:_=>e.UriList.split(_).filter(a=>!a.startsWith("#"))})}),define(Te[123],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[124],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class R{constructor(d){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=d.open,this.close=d.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(d.notIn))for(let y=0,m=d.notIn.length;y<m;y++)switch(d.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(d){switch(d){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(d,y){if(d.getTokenCount()===0)return!0;const m=d.findTokenIndexAtOffset(y-2),P=d.getStandardTokenType(m);return this.isOK(P)}_findNeutralCharacterInRange(d,y){for(let m=d;m<=y;m++){const P=String.fromCharCode(m);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=R;class k{constructor(d){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of d)F(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),F(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),F(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),F(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&F(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function F(T,d,y){T.has(d)?T.get(d).push(y):T.set(d,[y])}}),define(Te[125],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class w{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(F){if(F&&this._dragOperations.has(F)){const T=this._dragOperations.get(F);return this._dragOperations.delete(F),T}}addDragOperationTransfer(F,T){this._dragOperations.set(F,T)}}e.TreeViewsDnDService=w;class R{constructor(F){this.identifier=F}}e.DraggedTreeItemsIdentifier=R}),define(Te[126],Ae([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Te[127],Ae([1,0,5,6,126]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class F extends R.Disposable{constructor(a,v="",g="",f=!0,t){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=a,this._label=v,this._cssClass=g,this._enabled=f,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(a){this._setLabel(a)}_setLabel(a){this._label!==a&&(this._label=a,this._onDidChange.fire({label:a}))}get tooltip(){return this._tooltip||""}set tooltip(a){this._setTooltip(a)}_setTooltip(a){this._tooltip!==a&&(this._tooltip=a,this._onDidChange.fire({tooltip:a}))}get class(){return this._cssClass}set class(a){this._setClass(a)}_setClass(a){this._cssClass!==a&&(this._cssClass=a,this._onDidChange.fire({class:a}))}get enabled(){return this._enabled}set enabled(a){this._setEnabled(a)}_setEnabled(a){this._enabled!==a&&(this._enabled=a,this._onDidChange.fire({enabled:a}))}get checked(){return this._checked}set checked(a){this._setChecked(a)}_setChecked(a){this._checked!==a&&(this._checked=a,this._onDidChange.fire({checked:a}))}async run(a,v){this._actionCallback&&await this._actionCallback(a)}}e.Action=F;class T extends R.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event}async run(a,v){if(!a.enabled)return;this._onWillRun.fire({action:a});let g;try{await this.runAction(a,v)}catch(f){g=f}this._onDidRun.fire({action:a,error:g})}async runAction(a,v){await a.run(v)}}e.ActionRunner=T;class d{constructor(){this.id=d.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let v=[];for(const g of a)g.length&&(v.length?v=[...v,new d,...g]:v=g);return v}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=d;class y{get actions(){return this._actions}constructor(a,v,g,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=v,this.class=f,this._actions=g}async run(){}}e.SubmenuAction=y;class m extends F{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,k.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m;function P(_){return{id:_.id,label:_.label,class:void 0,enabled:_.enabled??!0,checked:_.checked??!1,run:async(...a)=>_.run(...a),tooltip:_.label}}e.toAction=P}),define(Te[128],Ae([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Te[129],Ae([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,F=k*24,T=F*7,d=F*30,y=F*365;function m(_,a,v,g){typeof _!="number"&&(_=_.getTime());const f=Math.round((new Date().getTime()-_)/1e3);if(f<-30)return(0,w.localize)(0,null,m(new Date().getTime()+f*1e3,!1));if(!g&&f<30)return(0,w.localize)(1,null);let t;return f<R?(t=f,a?t===1?v?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):v?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?v?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):v?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):f<k?(t=Math.floor(f/R),a?t===1?v?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):v?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?v?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):v?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):f<F?(t=Math.floor(f/k),a?t===1?v?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):v?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?v?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):v?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):f<T?(t=Math.floor(f/F),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):f<d?(t=Math.floor(f/T),a?t===1?v?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):v?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?v?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):v?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):f<y?(t=Math.floor(f/d),a?t===1?v?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):v?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?v?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):v?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(f/y),a?t===1?v?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):v?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?v?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):v?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.fromNow=m;function P(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Te[130],Ae([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Te[41],Ae([1,0,18,16,130]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(_,a){return a&&(_.stack||_.stacktrace)?k.localize(0,null,d(_),T(_.stack)||T(_.stacktrace)):d(_)}function T(_){return Array.isArray(_)?_.join(`
`):_}function d(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?k.localize(1,null,_.message):_.message||k.localize(2,null)}function y(_=null,a=!1){if(!_)return k.localize(3,null);if(Array.isArray(_)){const v=w.coalesce(_),g=y(v[0],a);return v.length>1?k.localize(4,null,g,v.length):g}if(R.isString(_))return _;if(_.detail){const v=_.detail;if(v.error)return F(v.error,a);if(v.exception)return F(v.exception,a)}return _.stack?F(_,a):_.message?_.message:k.localize(5,null)}e.toErrorMessage=y;function m(_){const a=_;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=m;function P(_,a){let v;return typeof _=="string"?v=new Error(_):v=_,v.actions=a,v}e.createErrorWithActions=P}),define(Te[131],Ae([1,0,66,19]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new w.Lazy(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function d(I,c,h=!1){const u=I||"",A=c||"",B=k.value.collator.compare(u,A);return k.value.collatorIsNumeric&&B===0&&u!==A?u<A?-1:1:B}e.compareFileNames=d;function y(I,c){const h=F.value.collator;return I=I||"",c=c||"",D(h,I,c)}e.compareFileNamesDefault=y;function m(I,c){const h=F.value.collator;return I=I||"",c=c||"",i(I,c)||D(h,I,c)}e.compareFileNamesUpper=m;function P(I,c){const h=F.value.collator;return I=I||"",c=c||"",s(I,c)||D(h,I,c)}e.compareFileNamesLower=P;function _(I,c){return I=I||"",c=c||"",I===c?0:I<c?-1:1}e.compareFileNamesUnicode=_;function a(I,c){const[h,u]=l(I),[A,B]=l(c);let H=k.value.collator.compare(u,B);if(H===0){if(k.value.collatorIsNumeric&&u!==B)return u<B?-1:1;if(H=k.value.collator.compare(h,A),k.value.collatorIsNumeric&&H===0&&h!==A)return h<A?-1:1}return H}e.compareFileExtensions=a;function v(I,c){I=I||"",c=c||"";const h=E(I),u=E(c),A=F.value.collator,B=T.value.collator;return D(B,h,u)||D(A,I,c)}e.compareFileExtensionsDefault=v;function g(I,c){I=I||"",c=c||"";const h=E(I),u=E(c),A=F.value.collator,B=T.value.collator;return D(B,h,u)||i(I,c)||D(A,I,c)}e.compareFileExtensionsUpper=g;function f(I,c){I=I||"",c=c||"";const h=E(I),u=E(c),A=F.value.collator,B=T.value.collator;return D(B,h,u)||s(I,c)||D(A,I,c)}e.compareFileExtensionsLower=f;function t(I,c){I=I||"",c=c||"";const h=E(I).toLowerCase(),u=E(c).toLowerCase();return h!==u?h<u?-1:1:I!==c?I<c?-1:1:0}e.compareFileExtensionsUnicode=t;const n=/^(.*?)(\.([^.]*))?$/;function l(I,c=!1){const h=I?n.exec(I):[];let u=[h&&h[1]||"",h&&h[3]||""];return c&&(!u[0]&&u[1]||u[0]&&u[0].charAt(0)===".")&&(u=[u[0]+"."+u[1],""]),u}function E(I){const c=I?n.exec(I):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function D(I,c,h){const u=I.compare(c,h);return u!==0?u:c.length!==h.length?c.length<h.length?-1:1:0}function p(I){const c=I.charAt(0);return c.toLocaleUpperCase()!==c}function r(I){const c=I.charAt(0);return c.toLocaleLowerCase()!==c}function s(I,c){return p(I)&&r(c)?-1:r(I)&&p(c)?1:0}function i(I,c){return r(I)&&p(c)?-1:p(I)&&r(c)?1:0}function o(I,c,h=!1){return h||(I=I&&I.toLowerCase(),c=c&&c.toLowerCase()),I===c?0:I<c?-1:1}function S(I,c,h=!1){const u=I.split(R.sep),A=c.split(R.sep),B=u.length-1,H=A.length-1;let U,z;for(let M=0;;M++){if(U=B===M,z=H===M,U&&z)return d(u[M],A[M],h);if(U)return-1;if(z)return 1;const N=o(u[M],A[M],h);if(N!==0)return N}}e.comparePaths=S;function b(I,c,h){const u=I.toLowerCase(),A=c.toLowerCase(),B=C(I,c,h);if(B)return B;const H=u.endsWith(h),U=A.endsWith(h);if(H!==U)return H?-1:1;const z=d(u,A);return z!==0?z:u.localeCompare(A)}e.compareAnything=b;function C(I,c,h){const u=I.toLowerCase(),A=c.toLowerCase(),B=u.startsWith(h),H=A.startsWith(h);if(B!==H)return B?-1:1;if(B&&H){if(u.length<A.length)return-1;if(u.length>A.length)return 1}return 0}e.compareByPrefix=C}),define(Te[42],Ae([1,0,19,22,15,16]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(b){return b===47||b===92}e.isPathSeparator=T;function d(b){return b.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=d;function y(b){return b.indexOf("/")===-1&&(b=d(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.toPosixPath=y;function m(b,C=w.posix.sep){if(!b)return"";const I=b.length,c=b.charCodeAt(0);if(T(c)){if(T(b.charCodeAt(1))&&!T(b.charCodeAt(2))){let u=3;const A=u;for(;u<I&&!T(b.charCodeAt(u));u++);if(A!==u&&!T(b.charCodeAt(u+1))){for(u+=1;u<I;u++)if(T(b.charCodeAt(u)))return b.slice(0,u+1).replace(/[\\/]/g,C)}}return C}else if(n(c)&&b.charCodeAt(1)===58)return T(b.charCodeAt(2))?b.slice(0,2)+C:b.slice(0,2);let h=b.indexOf("://");if(h!==-1){for(h+=3;h<I;h++)if(T(b.charCodeAt(h)))return b.slice(0,h+1)}return""}e.getRoot=m;function P(b){if(!R.isWindows||!b||b.length<5)return!1;let C=b.charCodeAt(0);if(C!==92||(C=b.charCodeAt(1),C!==92))return!1;let I=2;const c=I;for(;I<b.length&&(C=b.charCodeAt(I),C!==92);I++);return!(c===I||(C=b.charCodeAt(I+1),isNaN(C)||C===92))}e.isUNC=P;const _=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(b,C=R.isWindows){const I=C?_:a;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||C&&v.test(b)||b==="."||b===".."||C&&b[b.length-1]==="."||C&&b.length!==b.trim().length||b.length>255)}e.isValidBasename=g;function f(b,C,I){const c=b===C;return!I||c?c:!b||!C?!1:(0,k.equalsIgnoreCase)(b,C)}e.isEqual=f;function t(b,C,I,c=w.sep){if(b===C)return!0;if(!b||!C||C.length>b.length)return!1;if(I){if(!(0,k.startsWithIgnoreCase)(b,C))return!1;if(C.length===b.length)return!0;let u=C.length;return C.charAt(C.length-1)===c&&u--,b.charAt(u)===c}return C.charAt(C.length-1)!==c&&(C+=c),b.indexOf(C)===0}e.isEqualOrParent=t;function n(b){return b>=65&&b<=90||b>=97&&b<=122}e.isWindowsDriveLetter=n;function l(b,C){return R.isWindows&&b.endsWith(":")&&(b+=w.sep),(0,w.isAbsolute)(b)||(b=(0,w.join)(C,b)),b=(0,w.normalize)(b),R.isWindows?(b=(0,k.rtrim)(b,w.sep),b.endsWith(":")&&(b+=w.sep)):(b=(0,k.rtrim)(b,w.sep),b||(b=w.sep)),b}e.sanitizeFilePath=l;function E(b){const C=(0,w.normalize)(b);return R.isWindows?b.length>3?!1:D(C)&&(b.length===2||C.charCodeAt(2)===92):C===w.posix.sep}e.isRootOrDriveLetter=E;function D(b,C=R.isWindows){return C?n(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function p(b,C=R.isWindows){return D(b,C)?b[0]:void 0}e.getDriveLetter=p;function r(b,C,I){return C.length>b.length?-1:b===C?0:(I&&(b=b.toLowerCase(),C=C.toLowerCase()),b.indexOf(C))}e.indexOfPath=r;function s(b){const C=b.split(":");let I,c,h;for(const u of C){const A=Number(u);(0,F.isNumber)(A)?c===void 0?c=A:h===void 0&&(h=A):I=I?[I,u].join(":"):u}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:c!==void 0?c:void 0,column:h!==void 0?h:c!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(b,C,I=8){let c="";for(let u=0;u<I;u++){let A;u===0&&R.isWindows&&!C&&(I===3||I===4)?A=o:A=i,c+=A.charAt(Math.floor(Math.random()*A.length))}let h;return C?h=`${C}-${c}`:h=c,b?(0,w.join)(b,h):h}e.randomPath=S}),define(Te[68],Ae([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(P){const _=(0,w.extname)(P),a=R[_.toLowerCase()];return a!==void 0?a:T(P)}e.getMediaOrTextMime=F;function T(P){const _=(0,w.extname)(P);return k[_.toLowerCase()]}e.getMediaMime=T;function d(P){for(const _ in k)if(k[_]===P)return _}e.getExtensionForMimeType=d;const y=/^(.+)\/(.+?)(;.+)?$/;function m(P,_){const a=y.exec(P);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:_?void 0:P}e.normalizeMimeType=m}),define(Te[69],Ae([1,0,25,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(y){return JSON.stringify(y,T)}e.stringify=k;function F(y){let m=JSON.parse(y);return m=d(m),m}e.parse=F;function T(y,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function d(y,m=0){if(!y||m>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return R.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof w.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let P=0;P<y.length;++P)y[P]=d(y[P],m+1);else for(const P in y)Object.hasOwnProperty.call(y,P)&&(y[P]=d(y[P],m+1))}return y}e.revive=d}),define(Te[13],Ae([1,0,9,22,2]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var F;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${F.vscodeRemoteResource}`}set(P,_,a){this._hosts[P]=_,this._ports[P]=a}setConnectionToken(P,_){this._connectionTokens[P]=_}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(t){return w.onUnexpectedError(t),P}const _=P.authority;let a=this._hosts[_];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const v=this._ports[_],g=this._connectionTokens[_];let f=`path=${encodeURIComponent(P.path)}`;return typeof g=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),k.URI.from({scheme:R.isWeb?this._preferredWebSchema:F.vscodeRemoteResource,authority:`${a}:${v}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class d{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(P){const _=this.toUri(P,be);return this.uriToBrowserUri(_)}uriToBrowserUri(P){return P.scheme===F.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===F.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${F.vscodeFileResource}://${d.FALLBACK_AUTHORITY}`)?P.with({scheme:F.vscodeFileResource,authority:P.authority||d.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const _=this.toUri(P,be);return this.uriToFileUri(_)}uriToFileUri(P){return P.scheme===F.vscodeFileResource?P.with({scheme:F.file,authority:P.authority!==d.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,_){return k.URI.isUri(P)?P:k.URI.parse(_.toUrl(P))}}e.FileAccess=new d;var y;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const _="vscode-coi";function a(g){let f;typeof g=="string"?f=new URL(g).searchParams:g instanceof URL?f=g.searchParams:k.URI.isUri(g)&&(f=new URL(g.toString(!0)).searchParams);const t=f?.get(_);if(t)return P.get(t)}m.getHeadersFromQuery=a;function v(g,f,t){if(!globalThis.crossOriginIsolated)return;const n=f&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(_,n):g[_]=n}m.addSearchParam=v})(y||(e.COI=y={}))}),define(Te[23],Ae([1,0,42,13,19,22,15,2]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(v){return(0,d.uriToFsPath)(v,!0)}e.originalFSPath=y;class m{constructor(g){this._ignorePathCasing=g}compare(g,f,t=!1){return g===f?0:(0,T.compare)(this.getComparisonKey(g,t),this.getComparisonKey(f,t))}isEqual(g,f,t=!1){return g===f?!0:!g||!f?!1:this.getComparisonKey(g,t)===this.getComparisonKey(f,t)}getComparisonKey(g,f=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,f,t=!1){if(g.scheme===f.scheme){if(g.scheme===R.Schemas.file)return w.isEqualOrParent(y(g),y(f),this._ignorePathCasing(g))&&g.query===f.query&&(t||g.fragment===f.fragment);if((0,e.isEqualAuthority)(g.authority,f.authority))return w.isEqualOrParent(g.path,f.path,this._ignorePathCasing(g),"/")&&g.query===f.query&&(t||g.fragment===f.fragment)}return!1}joinPath(g,...f){return d.URI.joinPath(g,...f)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return k.posix.basename(g.path)}extname(g){return k.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let f;return g.scheme===R.Schemas.file?f=d.URI.file(k.dirname(y(g))).path:(f=k.posix.dirname(g.path),g.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),f="/")),g.with({path:f})}normalizePath(g){if(!g.path.length)return g;let f;return g.scheme===R.Schemas.file?f=d.URI.file(k.normalize(y(g))).path:f=k.posix.normalize(g.path),g.with({path:f})}relativePath(g,f){if(g.scheme!==f.scheme||!(0,e.isEqualAuthority)(g.authority,f.authority))return;if(g.scheme===R.Schemas.file){const l=k.relative(y(g),y(f));return F.isWindows?w.toSlashes(l):l}let t=g.path||"/";const n=f.path||"/";if(this._ignorePathCasing(g)){let l=0;for(const E=Math.min(t.length,n.length);l<E&&!(t.charCodeAt(l)!==n.charCodeAt(l)&&t.charAt(l).toLowerCase()!==n.charAt(l).toLowerCase());l++);t=n.substr(0,l)+t.substr(l)}return k.posix.relative(t,n)}resolvePath(g,f){if(g.scheme===R.Schemas.file){const t=d.URI.file(k.resolve(y(g),f));return g.with({authority:t.authority,path:t.path})}return f=w.toPosixPath(f),g.with({path:k.posix.resolve(g.path,f)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,f){return g===f||g!==void 0&&f!==void 0&&(0,T.equalsIgnoreCase)(g,f)}hasTrailingPathSeparator(g,f=k.sep){if(g.scheme===R.Schemas.file){const t=y(g);return t.length>w.getRoot(t).length&&t[t.length-1]===f}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,f=k.sep){return(0,e.hasTrailingPathSeparator)(g,f)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,f=k.sep){let t=!1;if(g.scheme===R.Schemas.file){const n=y(g);t=n!==void 0&&n.length===w.getRoot(n).length&&n[n.length-1]===f}else{f="/";const n=g.path;t=n.length===1&&n.charCodeAt(n.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,f)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(v=>v.scheme===R.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new m(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(v,g){const f=[];for(let t=0;t<v.length;t++){const n=g(v[t]);v.some((l,E)=>E===t?!1:(0,e.isEqualOrParent)(n,g(l)))||f.push(v[t])}return f}e.distinctParents=P;var _;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function g(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(E=>{const[D,p]=E.split(":");D&&p&&t.set(D,p)});const l=f.path.substring(0,f.path.indexOf(";"));return l&&t.set(v.META_DATA_MIME,l),t}v.parseMetaData=g})(_||(e.DataUri=_={}));function a(v,g,f){if(g){let t=v.path;return t&&t[0]!==k.posix.sep&&(t=k.posix.sep+t),v.with({scheme:f,authority:g,path:t})}return v.with({scheme:f})}e.toLocalResource=a}),define(Te[12],Ae([1,0,21,9,5,6,23,22,120]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(x){return!!x&&typeof x.then=="function"}e.isThenable=m;function P(x){const W=new w.CancellationTokenSource,le=x(W.token),we=new Promise((Ee,me)=>{const De=W.token.onCancellationRequested(()=>{De.dispose(),W.dispose(),me(new R.CancellationError)});Promise.resolve(le).then(re=>{De.dispose(),W.dispose(),Ee(re)},re=>{De.dispose(),W.dispose(),me(re)})});return new class{cancel(){W.cancel()}then(Ee,me){return we.then(Ee,me)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return we.finally(Ee)}}}e.createCancelablePromise=P;function _(x,W,le){return new Promise((we,Ee)=>{const me=W.onCancellationRequested(()=>{me.dispose(),we(le)});x.then(we,Ee).finally(()=>me.dispose())})}e.raceCancellation=_;function a(x,W){return new Promise((le,we)=>{const Ee=W.onCancellationRequested(()=>{Ee.dispose(),we(new R.CancellationError)});x.then(le,we).finally(()=>Ee.dispose())})}e.raceCancellationError=a;async function v(x){let W=-1;const le=x.map((we,Ee)=>we.then(me=>(W=Ee,me)));try{return await Promise.race(le)}finally{x.forEach((we,Ee)=>{Ee!==W&&we.cancel()})}}e.raceCancellablePromises=v;function g(x,W,le){let we;const Ee=setTimeout(()=>{we?.(void 0),le?.()},W);return Promise.race([x.finally(()=>clearTimeout(Ee)),new Promise(me=>we=me)])}e.raceTimeout=g;function f(x){return new Promise((W,le)=>{const we=x();m(we)?we.then(W,le):W(we)})}e.asPromise=f;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const le=()=>{if(this.queuedPromise=null,this.isDisposed)return;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(le,le).then(we)})}return new Promise((le,we)=>{this.queuedPromise.then(le,we)})}return this.activePromise=W(),new Promise((le,we)=>{this.activePromise.then(Ee=>{this.activePromise=null,le(Ee)},Ee=>{this.activePromise=null,we(Ee)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class n{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=n;class l{constructor(){this.promiseMap=new Map}queue(W,le){const Ee=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.promiseMap.get(W)===Ee&&this.promiseMap.delete(W)});return this.promiseMap.set(W,Ee),Ee}}e.SequencerByKey=l;const E=(x,W)=>{let le=!0;const we=setTimeout(()=>{le=!1,W()},x);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},D=x=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,x())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};class p{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,le=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ee,me)=>{this.doResolve=Ee,this.doReject=me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ee=this.task;return this.task=null,Ee()}}));const we=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=le===y.MicrotaskDelay?D(we):E(le,we),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new R.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class r{constructor(W){this.delayer=new p(W),this.throttler=new t}trigger(W,le){return this.delayer.trigger(()=>this.throttler.queue(W),le)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=r;class s{constructor(){this._isOpen=!1,this._promise=new Promise((W,le)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class i extends s{constructor(W){super(),this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function o(x,W){return W?new Promise((le,we)=>{const Ee=setTimeout(()=>{me.dispose(),le()},x),me=W.onCancellationRequested(()=>{clearTimeout(Ee),me.dispose(),we(new R.CancellationError)})}):P(le=>o(x,le))}e.timeout=o;function S(x,W=0,le){const we=setTimeout(()=>{x(),le&&Ee.dispose()},W),Ee=(0,F.toDisposable)(()=>{clearTimeout(we),le?.deleteAndLeak(Ee)});return le?.add(Ee),Ee}e.disposableTimeout=S;function b(x){const W=[];let le=0;const we=x.length;function Ee(){return le<we?x[le++]():null}function me(De){De!=null&&W.push(De);const re=Ee();return re?re.then(me):Promise.resolve(W)}return Promise.resolve(null).then(me)}e.sequence=b;function C(x,W=we=>!!we,le=null){let we=0;const Ee=x.length,me=()=>{if(we>=Ee)return Promise.resolve(le);const De=x[we++];return Promise.resolve(De()).then(de=>W(de)?Promise.resolve(de):me())};return me()}e.first=C;function I(x,W=we=>!!we,le=null){if(x.length===0)return Promise.resolve(le);let we=x.length;const Ee=()=>{we=-1;for(const me of x)me.cancel?.()};return new Promise((me,De)=>{for(const re of x)re.then(de=>{--we>=0&&W(de)?(Ee(),me(de)):we===0&&me(le)}).catch(de=>{--we>=0&&(Ee(),De(de))})})}e.firstParallel=I;class c{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((le,we)=>{this.outstandingPromises.push({factory:W,c:le,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const le=W.factory();le.then(W.c,W.e),le.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class u{constructor(){this.sequentializer=new Se,this.tasks=0}queue(W){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,W())):this.sequentializer.run(this.tasks++,W())}}e.LimitedQueue=u;class A{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const W=new Y;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,le=T.extUri){const we=le.getComparisonKey(W);let Ee=this.queues.get(we);if(!Ee){Ee=new h;const me=this.drainListenerCount++,De=k.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.queues.delete(we),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(me),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new F.DisposableMap),this.drainListeners.set(me,De),this.queues.set(we,Ee)}return Ee}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=A;class B{constructor(W,le){this._token=-1,typeof W=="function"&&typeof le=="number"&&this.setIfNotSet(W,le)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,le){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},le)}setIfNotSet(W,le){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},le))}}e.TimeoutTimer=B;class H{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,le){this.cancel(),this._token=setInterval(()=>{W()},le)}}e.IntervalTimer=H;class U{constructor(W,le){this.timeoutToken=-1,this.runner=W,this.timeout=le,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class z{constructor(W,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=le,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=z;class M extends U{constructor(W,le){super(W,le),this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner?.(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class N extends F.Disposable{constructor(W,le){super(),this.options=W,this.handler=le,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const le of W)this.pendingWork.push(le);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,d.setTimeout0)(()=>{if(W)return;const le=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(x,W)=>{const le=requestIdleCallback(x,typeof W=="number"?{timeout:W}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class ee{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(le){this._error=le}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ee;async function Q(x,W,le){let we;for(let Ee=0;Ee<le;Ee++)try{return await x()}catch(me){we=me,await o(W)}throw we}e.retry=Q;class Se{isRunning(W){return typeof W=="number"?this._running?.taskId===W:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(W,le,we){return this._running={taskId:W,cancel:()=>we?.(),promise:le},le.then(()=>this.doneRunning(W),()=>this.doneRunning(W)),le}doneRunning(W){this._running&&W===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const W=this._queued;this._queued=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}queue(W){if(this._queued)this._queued.run=W;else{let le,we;const Ee=new Promise((me,De)=>{le=me,we=De});this._queued={run:W,promise:Ee,promiseResolve:le,promiseReject:we}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Se;class ye{constructor(W,le=()=>Date.now()){this.interval=W,this.nowFn=le,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=ye;var Pe;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(Pe||(Pe={}));class Y{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((W,le)=>{this.completeCallback=W,this.errorCallback=le})}complete(W){return new Promise(le=>{this.completeCallback(W),this.outcome={outcome:0,value:W},le()})}error(W){return new Promise(le=>{this.errorCallback(W),this.outcome={outcome:1,value:W},le()})}cancel(){return this.error(new R.CancellationError)}}e.DeferredPromise=Y;var ue;(function(x){async function W(we){let Ee;const me=await Promise.all(we.map(De=>De.then(re=>re,re=>{Ee||(Ee=re)})));if(typeof Ee<"u")throw Ee;return me}x.settled=W;function le(we){return new Promise(async(Ee,me)=>{try{await we(Ee,me)}catch(De){me(De)}})}x.withAsyncBody=le})(ue||(e.Promises=ue={}));var _e;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(_e||(_e={}));class ce{static fromArray(W){return new ce(le=>{le.emitMany(W)})}static fromPromise(W){return new ce(async le=>{le.emitMany(await W)})}static fromPromises(W){return new ce(async le=>{await Promise.all(W.map(async we=>le.emitOne(await we)))})}static merge(W){return new ce(async le=>{await Promise.all(W.map(async we=>{for await(const Ee of we)le.emitOne(Ee)}))})}static{this.EMPTY=ce.fromArray([])}constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const le={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(W(le)),this.resolve()}catch(we){this.reject(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,le){return new ce(async we=>{for await(const Ee of W)we.emitOne(le(Ee))})}map(W){return ce.map(this,W)}static filter(W,le){return new ce(async we=>{for await(const Ee of W)le(Ee)&&we.emitOne(Ee)})}filter(W){return ce.filter(this,W)}static coalesce(W){return ce.filter(W,le=>!!le)}coalesce(){return ce.coalesce(this)}static async toPromise(W){const le=[];for await(const we of W)le.push(we);return le}toPromise(){return ce.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}e.AsyncIterableObject=ce;class pe extends ce{constructor(W,le){super(le),this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function ie(x){const W=new w.CancellationTokenSource,le=x(W.token);return new pe(W,async we=>{const Ee=W.token.onCancellationRequested(()=>{Ee.dispose(),W.dispose(),we.reject(new R.CancellationError)});try{for await(const me of le){if(W.token.isCancellationRequested)return;we.emitOne(me)}Ee.dispose(),W.dispose()}catch(me){Ee.dispose(),W.dispose(),we.reject(me)}})}e.createCancelableAsyncIterable=ie}),define(Te[37],Ae([1,0,18,12,42,28,19,22,15]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",_="[^/\\\\]",a=/\//g;function v(Se,ye){switch(Se){case 0:return"";case 1:return`${_}*?`;default:return`(?:${P}|${_}+${P}${ye?`|${P}${_}+`:""})*?`}}function g(Se,ye){if(!Se)return[];const Pe=[];let Y=!1,ue=!1,_e="";for(const ce of Se){switch(ce){case ye:if(!Y&&!ue){Pe.push(_e),_e="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}_e+=ce}return _e&&Pe.push(_e),Pe}e.splitGlobAware=g;function f(Se){if(!Se)return"";let ye="";const Pe=g(Se,e.GLOB_SPLIT);if(Pe.every(Y=>Y===e.GLOBSTAR))ye=".*";else{let Y=!1;Pe.forEach((ue,_e)=>{if(ue===e.GLOBSTAR){if(Y)return;ye+=v(2,_e===Pe.length-1)}else{let ce=!1,pe="",ie=!1,x="";for(const W of ue){if(W!=="}"&&ce){pe+=W;continue}if(ie&&(W!=="]"||!x)){let le;W==="-"?le=W:(W==="^"||W==="!")&&!x?le="^":W===e.GLOB_SPLIT?le="":le=(0,y.escapeRegExpCharacters)(W),x+=le;continue}switch(W){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${g(pe,",").map(Ee=>f(Ee)).join("|")})`;ye+=we,ce=!1,pe="";break}case"]":{ye+="["+x+"]",ie=!1,x="";break}case"?":ye+=_;continue;case"*":ye+=v(1);continue;default:ye+=(0,y.escapeRegExpCharacters)(W)}}_e<Pe.length-1&&(Pe[_e+1]!==e.GLOBSTAR||_e+2<Pe.length)&&(ye+=P)}Y=ue===e.GLOBSTAR})}return ye}const t=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new F.LRUCache(1e4),s=function(){return!1},i=function(){return null};function o(Se,ye){if(!Se)return i;let Pe;typeof Se!="string"?Pe=Se.pattern:Pe=Se,Pe=Pe.trim();const Y=`${Pe}_${!!ye.trimForExclusions}`;let ue=r.get(Y);if(ue)return S(ue,Se);let _e;return t.test(Pe)?ue=C(Pe.substr(4),Pe):(_e=n.exec(b(Pe,ye)))?ue=I(_e[1],Pe):(ye.trimForExclusions?E:l).test(Pe)?ue=c(Pe,ye):(_e=D.exec(b(Pe,ye)))?ue=h(_e[1].substr(1),Pe,!0):(_e=p.exec(b(Pe,ye)))?ue=h(_e[1],Pe,!1):ue=u(Pe),r.set(Y,ue),S(ue,Se)}function S(Se,ye){if(typeof ye=="string")return Se;const Pe=function(Y,ue){return(0,k.isEqualOrParent)(Y,ye.base,!d.isLinux)?Se((0,y.ltrim)(Y.substr(ye.base.length),T.sep),ue):null};return Pe.allBasenames=Se.allBasenames,Pe.allPaths=Se.allPaths,Pe.basenames=Se.basenames,Pe.patterns=Se.patterns,Pe}function b(Se,ye){return ye.trimForExclusions&&Se.endsWith("/**")?Se.substr(0,Se.length-2):Se}function C(Se,ye){return function(Pe,Y){return typeof Pe=="string"&&Pe.endsWith(Se)?ye:null}}function I(Se,ye){const Pe=`/${Se}`,Y=`\\${Se}`,ue=function(ce,pe){return typeof ce!="string"?null:pe?pe===Se?ye:null:ce===Se||ce.endsWith(Pe)||ce.endsWith(Y)?ye:null},_e=[Se];return ue.basenames=_e,ue.patterns=[ye],ue.allBasenames=_e,ue}function c(Se,ye){const Pe=ee(Se.slice(1,-1).split(",").map(pe=>o(pe,ye)).filter(pe=>pe!==i),Se),Y=Pe.length;if(!Y)return i;if(Y===1)return Pe[0];const ue=function(pe,ie){for(let x=0,W=Pe.length;x<W;x++)if(Pe[x](pe,ie))return Se;return null},_e=Pe.find(pe=>!!pe.allBasenames);_e&&(ue.allBasenames=_e.allBasenames);const ce=Pe.reduce((pe,ie)=>ie.allPaths?pe.concat(ie.allPaths):pe,[]);return ce.length&&(ue.allPaths=ce),ue}function h(Se,ye,Pe){const Y=T.sep===T.posix.sep,ue=Y?Se:Se.replace(a,T.sep),_e=T.sep+ue,ce=T.posix.sep+Se;let pe;return Pe?pe=function(ie,x){return typeof ie=="string"&&(ie===ue||ie.endsWith(_e)||!Y&&(ie===Se||ie.endsWith(ce)))?ye:null}:pe=function(ie,x){return typeof ie=="string"&&(ie===ue||!Y&&ie===Se)?ye:null},pe.allPaths=[(Pe?"*/":"./")+Se],pe}function u(Se){try{const ye=new RegExp(`^${f(Se)}$`);return function(Pe){return ye.lastIndex=0,typeof Pe=="string"&&ye.test(Pe)?Se:null}}catch{return i}}function A(Se,ye,Pe){return!Se||typeof ye!="string"?!1:B(Se)(ye,void 0,Pe)}e.match=A;function B(Se,ye={}){if(!Se)return s;if(typeof Se=="string"||H(Se)){const Pe=o(Se,ye);if(Pe===i)return s;const Y=function(ue,_e){return!!Pe(ue,_e)};return Pe.allBasenames&&(Y.allBasenames=Pe.allBasenames),Pe.allPaths&&(Y.allPaths=Pe.allPaths),Y}return M(Se,ye)}e.parse=B;function H(Se){const ye=Se;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.isRelativePattern=H;function U(Se){return Se.allBasenames||[]}e.getBasenameTerms=U;function z(Se){return Se.allPaths||[]}e.getPathTerms=z;function M(Se,ye){const Pe=ee(Object.getOwnPropertyNames(Se).map(pe=>N(pe,Se[pe],ye)).filter(pe=>pe!==i)),Y=Pe.length;if(!Y)return i;if(!Pe.some(pe=>!!pe.requiresSiblings)){if(Y===1)return Pe[0];const pe=function(W,le){let we;for(let Ee=0,me=Pe.length;Ee<me;Ee++){const De=Pe[Ee](W,le);if(typeof De=="string")return De;(0,R.isThenable)(De)&&(we||(we=[]),we.push(De))}return we?(async()=>{for(const Ee of we){const me=await Ee;if(typeof me=="string")return me}return null})():null},ie=Pe.find(W=>!!W.allBasenames);ie&&(pe.allBasenames=ie.allBasenames);const x=Pe.reduce((W,le)=>le.allPaths?W.concat(le.allPaths):W,[]);return x.length&&(pe.allPaths=x),pe}const ue=function(pe,ie,x){let W,le;for(let we=0,Ee=Pe.length;we<Ee;we++){const me=Pe[we];me.requiresSiblings&&x&&(ie||(ie=(0,T.basename)(pe)),W||(W=ie.substr(0,ie.length-(0,T.extname)(pe).length)));const De=me(pe,ie,W,x);if(typeof De=="string")return De;(0,R.isThenable)(De)&&(le||(le=[]),le.push(De))}return le?(async()=>{for(const we of le){const Ee=await we;if(typeof Ee=="string")return Ee}return null})():null},_e=Pe.find(pe=>!!pe.allBasenames);_e&&(ue.allBasenames=_e.allBasenames);const ce=Pe.reduce((pe,ie)=>ie.allPaths?pe.concat(ie.allPaths):pe,[]);return ce.length&&(ue.allPaths=ce),ue}function N(Se,ye,Pe){if(ye===!1)return i;const Y=o(Se,Pe);if(Y===i)return i;if(typeof ye=="boolean")return Y;if(ye){const ue=ye.when;if(typeof ue=="string"){const _e=(ce,pe,ie,x)=>{if(!x||!Y(ce,pe))return null;const W=ue.replace("$(basename)",()=>ie),le=x(W);return(0,R.isThenable)(le)?le.then(we=>we?Se:null):le?Se:null};return _e.requiresSiblings=!0,_e}}return Y}function ee(Se,ye){const Pe=Se.filter(pe=>!!pe.basenames);if(Pe.length<2)return Se;const Y=Pe.reduce((pe,ie)=>{const x=ie.basenames;return x?pe.concat(x):pe},[]);let ue;if(ye){ue=[];for(let pe=0,ie=Y.length;pe<ie;pe++)ue.push(ye)}else ue=Pe.reduce((pe,ie)=>{const x=ie.patterns;return x?pe.concat(x):pe},[]);const _e=function(pe,ie){if(typeof pe!="string")return null;if(!ie){let W;for(W=pe.length;W>0;W--){const le=pe.charCodeAt(W-1);if(le===47||le===92)break}ie=pe.substr(W)}const x=Y.indexOf(ie);return x!==-1?ue[x]:null};_e.basenames=Y,_e.patterns=ue,_e.allBasenames=Y;const ce=Se.filter(pe=>!pe.basenames);return ce.push(_e),ce}function Q(Se,ye){return(0,w.equals)(Se,ye,(Pe,Y)=>typeof Pe=="string"&&typeof Y=="string"?Pe===Y:typeof Pe!="string"&&typeof Y!="string"?Pe.base===Y.base&&Pe.pattern===Y.pattern:!1)}e.patternsEquals=Q}),define(Te[49],Ae([1,0,9,121,23,15,2]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var d;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(d||(e.MarkdownStringTextNewlineStyle=d={}));class y{constructor(n="",l=!1){if(this.value=n,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(n,l=0){return this.value+=a(this.supportThemeIcons?(0,R.escapeIcons)(n):n).replace(/([ \t]+)/g,(E,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,l){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}appendLink(n,l,E){return this.value+="[",this.value+=this._escape(l,"]"),this.value+="](",this.value+=this._escape(String(n),")"),E&&(this.value+=` "${this._escape(this._escape(E,'"'),")")}"`),this.value+=")",this}_escape(n,l){const E=new RegExp((0,F.escapeRegExpCharacters)(l),"g");return n.replace(E,(D,p)=>n.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=y;function m(t){return P(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function P(t){return t instanceof y?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function _(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,k.isEqual)(T.URI.from(t.baseUri),T.URI.from(n.baseUri)))}e.markdownStringEqual=_;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=a;function v(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function f(t){const n=[],l=t.split("|").map(D=>D.trim());t=l[0];const E=l[1];if(E){const D=/height=(\d+)/.exec(E),p=/width=(\d+)/.exec(E),r=D?D[1]:"",s=p?p[1]:"",i=isFinite(parseInt(s)),o=isFinite(parseInt(r));i&&n.push(`width="${s}"`),o&&n.push(`height="${r}"`)}return{href:t,dimensions:n}}e.parseHrefAndDimensions=f}),define(Te[90],Ae([1,0,18,42,19,22,23,15]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,S){const{os:b,tildify:C,relative:I}=S;if(I){const u=m(o,I,b);if(typeof u=="string")return u}let c=o.fsPath;if(b===1&&!F.isWindows?c=c.replace(/\//g,"\\"):b!==1&&F.isWindows&&(c=c.replace(/\\/g,"/")),b!==1&&C?.userHome){const u=C.userHome.fsPath;let A;o.scheme!==C.userHome.scheme&&o.path.startsWith(k.posix.sep)?A=C.userHome.with({path:o.path}).fsPath:A=o.fsPath,c=a(A,u,b)}return(b===1?k.win32:k.posix).normalize(P(c,b===1))}e.getPathLabel=y;function m(o,S,b){const C=b===1?k.win32:k.posix,I=b===3?T.extUri:T.extUriIgnorePathCase,c=S.getWorkspace(),h=(0,w.firstOrDefault)(c.folders);if(!h)return;o.scheme!==h.uri.scheme&&o.path.startsWith(k.posix.sep)&&(o=h.uri.with({path:o.path}));const u=S.getWorkspaceFolder(o);if(!u)return;let A;if(I.isEqual(u.uri,o)?A="":A=I.relativePath(u.uri,o)??"",A&&(A=C.normalize(A)),c.folders.length>1&&!S.noPrefix){const B=u.name?u.name:I.basenameOrAuthority(u.uri);A=A?`${B} \u2022 ${A}`:B}return A}function P(o,S=F.isWindows){return(0,R.hasDriveLetter)(o,S)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let _=Object.create(null);function a(o,S,b=F.OS){if(b===1||!o||!S)return o;let C=_.original===S?_.normalized:void 0;C||(C=S,F.isWindows&&(C=(0,R.toSlashes)(C)),C=`${(0,d.rtrim)(C,k.posix.sep)}${k.posix.sep}`,_={original:S,normalized:C});let I=o;return F.isWindows&&(I=(0,R.toSlashes)(I)),(b===3?I.startsWith(C):(0,d.startsWithIgnoreCase)(I,C))?`~/${I.substr(C.length)}`:o}e.tildify=a;function v(o,S){return o.replace(/^~($|\/|\\)/,`${S}$1`)}e.untildify=v;const g="\u2026",f="\\\\",t="~";function n(o,S=k.sep){const b=new Array(o.length);let C=!1;for(let I=0;I<o.length;I++){const c=o[I];if(c===""){b[I]=`.${S}`;continue}if(!c){b[I]=c;continue}C=!0;let h="",u=c;u.indexOf(f)===0?(h=u.substr(0,u.indexOf(f)+f.length),u=u.substr(u.indexOf(f)+f.length)):u.indexOf(S)===0?(h=u.substr(0,u.indexOf(S)+S.length),u=u.substr(u.indexOf(S)+S.length)):u.indexOf(t)===0&&(h=u.substr(0,u.indexOf(t)+t.length),u=u.substr(u.indexOf(t)+t.length));const A=u.split(S);for(let B=1;C&&B<=A.length;B++)for(let H=A.length-B;C&&H>=0;H--){C=!1;let U=A.slice(H,H+B).join(S);for(let z=0;!C&&z<o.length;z++)if(z!==I&&o[z]&&o[z].indexOf(U)>-1){const M=H+B===A.length,N=H>0&&o[z].indexOf(S)>-1?S+U:U,ee=o[z].endsWith(N);C=!M||ee}if(!C){let z="";(A[0].endsWith(":")||h!=="")&&(H===1&&(H=0,B++,U=A[0]+S+U),H>0&&(z=A[0]+S),z=h+z),H>0&&(z=z+g+S),z=z+U,H+B<A.length&&(z=z+S+g),b[I]=z}}C&&(b[I]=c)}return b}e.shorten=n;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function E(o,S=Object.create(null)){const b=[];let C=!1,I="";for(const c of o)if(c==="$"||C&&c==="{")I&&b.push({value:I,type:l.TEXT}),I="",C=!0;else if(c==="}"&&C){const h=S[I];if(typeof h=="string")h.length&&b.push({value:h,type:l.VARIABLE});else if(h){const u=b[b.length-1];(!u||u.type!==l.SEPARATOR)&&b.push({value:h.label,type:l.SEPARATOR})}I="",C=!1}else I+=c;return I&&!C&&b.push({value:I,type:l.TEXT}),b.filter((c,h)=>{if(c.type===l.SEPARATOR){const u=b[h-1],A=b[h+1];return[u,A].every(B=>B&&(B.type===l.VARIABLE||B.type===l.TEXT)&&B.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=E;function D(o,S){return F.isMacintosh||S?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):o.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function p(o,S){return F.isMacintosh||S?o.replace(/\(&&\w\)|&&/g,""):F.isWindows?o.replace(/&&|&/g,b=>b==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(o){if(o.endsWith("]")){const S=o.lastIndexOf(" [",o.length-2);if(S!==-1){const b=i(o.substring(0,S));return{name:b.name,parentPath:b.parentPath+o.substring(S)}}}return i(o)}e.splitRecentLabel=s;function i(o){const S=o.indexOf("/")!==-1?k.posix:k.win32,b=S.basename(o),C=S.dirname(o);return b.length?{name:b,parentPath:C}:{name:C,parentPath:""}}}),define(Te[132],Ae([1,0,25,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(_){return _.toJSON()}class F{constructor(a){this._uriTransformer=a}transformIncoming(a){const v=this._uriTransformer.transformIncoming(a);return v===a?a:k(R.URI.from(v))}transformOutgoing(a){const v=this._uriTransformer.transformOutgoing(a);return v===a?a:k(R.URI.from(v))}transformOutgoingURI(a){const v=this._uriTransformer.transformOutgoing(a);return v===a?a:R.URI.from(v)}transformOutgoingScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}}e.URITransformer=F,e.DefaultURITransformer=new class{transformIncoming(_){return _}transformOutgoing(_){return _}transformOutgoingURI(_){return _}transformOutgoingScheme(_){return _}};function T(_,a,v){if(!_||v>200)return null;if(typeof _=="object"){if(_ instanceof R.URI)return a.transformOutgoing(_);for(const g in _)if(Object.hasOwnProperty.call(_,g)){const f=T(_[g],a,v+1);f!==null&&(_[g]=f)}}return null}function d(_,a){const v=T(_,a,0);return v===null?_:v}e.transformOutgoingURIs=d;function y(_,a,v,g){if(!_||g>200)return null;if(typeof _=="object"){if(_.$mid===1)return v?R.URI.revive(a.transformIncoming(_)):a.transformIncoming(_);if(_ instanceof w.VSBuffer)return null;for(const f in _)if(Object.hasOwnProperty.call(_,f)){const t=y(_[f],a,v,g+1);t!==null&&(_[f]=t)}}return null}function m(_,a){const v=y(_,a,!1,0);return v===null?_:v}e.transformIncomingURIs=m;function P(_,a){const v=y(_,a,!0,0);return v===null?_:v}e.transformAndReviveIncomingURIs=P}),define(Te[133],Ae([1,0,37,19]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(F,T,d,y,m,P){if(Array.isArray(F)){let _=0;for(const a of F){const v=k(a,T,d,y,m,P);if(v===10)return v;v>_&&(_=v)}return _}else{if(typeof F=="string")return y?F==="*"?5:F===d?10:0:0;if(F){const{language:_,pattern:a,scheme:v,hasAccessToAllModels:g,notebookType:f}=F;if(!y&&!g)return 0;f&&m&&(T=m);let t=0;if(v)if(v===T.scheme)t=10;else if(v==="*")t=5;else return 0;if(_)if(_===d)t=10;else if(_==="*")t=Math.max(t,5);else return 0;if(f)if(f===P)t=10;else if(f==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(a){let n;if(typeof a=="string"?n=a:n={...a,base:(0,R.normalize)(a.base)},n===T.fsPath||(0,w.match)(n,T.fsPath))t=10;else return 0}return t}else return 0}}e.score=k}),define(Te[91],Ae([1,0,25,22]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(k||(k={}));function F(_){for(let a=0,v=_.length;a<v;a+=4){const g=_[a+0],f=_[a+1],t=_[a+2],n=_[a+3];_[a+0]=n,_[a+1]=t,_[a+2]=f,_[a+3]=g}}function T(_){const a=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return R.isLittleEndian()||F(a),w.VSBuffer.wrap(a)}function d(_){const a=_.buffer;if(R.isLittleEndian()||F(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const v=new Uint8Array(a.byteLength);return v.set(a),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function y(_){const a=new Uint32Array(m(_));let v=0;if(a[v++]=_.id,_.type==="full")a[v++]=1,a[v++]=_.data.length,a.set(_.data,v),v+=_.data.length;else{a[v++]=2,a[v++]=_.deltas.length;for(const g of _.deltas)a[v++]=g.start,a[v++]=g.deleteCount,g.data?(a[v++]=g.data.length,a.set(g.data,v),v+=g.data.length):a[v++]=0}return T(a)}e.encodeSemanticTokensDto=y;function m(_){let a=0;if(a+=1+1,_.type==="full")a+=1+_.data.length;else{a+=1,a+=(1+1+1)*_.deltas.length;for(const v of _.deltas)v.data&&(a+=v.data.length)}return a}function P(_){const a=d(_);let v=0;const g=a[v++];if(a[v++]===1){const l=a[v++],E=a.subarray(v,v+l);return v+=l,{id:g,type:"full",data:E}}const t=a[v++],n=[];for(let l=0;l<t;l++){const E=a[v++],D=a[v++],p=a[v++];let r;p>0&&(r=a.subarray(v,v+p),v+=p),n[l]={start:E,deleteCount:D,data:r}}return{id:g,type:"delta",deltas:n}}e.decodeSemanticTokensDto=P}),define(Te[134],Ae([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Te[135],Ae([1,0,18,24,22,123,136,134]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=m;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class _{constructor(X,ve,Be,Ne){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,ve){return v(X,ve)}compute(X,ve,Be){return Be}}class a{constructor(X,ve){this.newValue=X,this.didChange=ve}}e.ApplyUpdateResult=a;function v(J,X){if(typeof J!="object"||typeof X!="object"||!J||!X)return new a(X,J!==X);if(Array.isArray(J)||Array.isArray(X)){const Be=Array.isArray(J)&&Array.isArray(X)&&w.equals(J,X);return new a(X,!Be)}let ve=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Ne=v(J[Be],X[Be]);Ne.didChange&&(J[Be]=Ne.newValue,ve=!0)}return new a(J,ve)}class g{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ve){return v(X,ve)}validate(X){return this.defaultValue}}class f{constructor(X,ve,Be,Ne){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,ve){return v(X,ve)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ve,Be){return Be}}function t(J,X){return typeof J>"u"?X:J==="false"?!1:!!J}e.boolean=t;class n extends f{constructor(X,ve,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(X,ve,Be,Ne)}validate(X){return t(X,this.defaultValue)}}function l(J,X,ve,Be){if(typeof J>"u")return X;let Ne=parseInt(J,10);return isNaN(Ne)?X:(Ne=Math.max(ve,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=l;class E extends f{static clampedInt(X,ve,Be,Ne){return l(X,ve,Be,Ne)}constructor(X,ve,Be,Ne,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Ne,nt.maximum=Xe),super(X,ve,Be,nt),this.minimum=Ne,this.maximum=Xe}validate(X){return E.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function D(J,X,ve,Be){if(typeof J>"u")return X;const Ne=p.float(J,X);return p.clamp(Ne,ve,Be)}e.clampedFloat=D;class p extends f{static clamp(X,ve,Be){return X<ve?ve:X>Be?Be:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X>"u")return ve;const Be=parseFloat(X);return isNaN(Be)?ve:Be}constructor(X,ve,Be,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(X,ve,Be,Xe),this.validationFn=Ne}validate(X){return this.validationFn(p.float(X,this.defaultValue))}}class r extends f{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(X,ve,Be,Ne)}validate(X){return r.string(X,this.defaultValue)}}function s(J,X,ve,Be){return typeof J!="string"?X:Be&&J in Be?Be[J]:ve.indexOf(J)===-1?X:J}e.stringSet=s;class i extends f{constructor(X,ve,Be,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=Be),super(X,ve,Be,Xe),this._allowedValues=Ne}validate(X){return s(X,this.defaultValue,this._allowedValues)}}class o extends _{constructor(X,ve,Be,Ne,Xe,nt,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=Xe,ht.default=Ne),super(X,ve,Be,ht),this._allowedValues=Xe,this._convert=nt}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function S(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",tags:["accessibility"],description:d.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Be){return Be===0?X.accessibilitySupport:Be}}class C extends _{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:d.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:t(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function c(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function u(J){switch(J){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function A(J){switch(J){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class B extends g{constructor(){super(140)}compute(X,ve,Be){const Ne=["monaco-editor"];return ve.get(39)&&Ne.push(ve.get(39)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),ve.get(73)==="default"?Ne.push("mouse-default"):ve.get(73)==="copy"&&Ne.push("mouse-copy"),ve.get(110)&&Ne.push("showUnused"),ve.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(X,ve,Be){return Be&&X.emptySelectionClipboard}}class U extends _{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:d.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:d.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:t(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ve.loop,this.defaultValue.loop)}}}class z extends _{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.ON:X:X?z.ON:z.OFF}}e.EditorFontLigatures=z;class M extends _{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:d.localize(22,null)},{type:"string",description:d.localize(23,null)}],description:d.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?M.OFF:X==="true"?M.TRANSLATE:X:X?M.TRANSLATE:M.OFF}compute(X,ve,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class N extends g{constructor(){super(50)}compute(X,ve,Be){return X.fontInfo}}class ee extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(25,null)})}validate(X){const ve=p.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ve,6,100)}compute(X,ve,Be){return X.fontInfo.fontSize}}class Q extends _{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.MINIMUM_VALUE,maximum:Q.MAXIMUM_VALUE,errorMessage:d.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(E.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.MINIMUM_VALUE,Q.MAXIMUM_VALUE))}}class Se extends _{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[d.localize(28,null),d.localize(29,null),d.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:d.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:d.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:d.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:d.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:d.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:d.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:d.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:d.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{multiple:s(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??s(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??s(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??s(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??s(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??s(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends _{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:d.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:d.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:d.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:d.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:d.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),delay:E.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:t(ve.sticky,this.defaultValue.sticky),hidingDelay:E.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ve.above,this.defaultValue.above)}}}var Pe;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Y extends g{constructor(){super(143)}compute(X,ve,Be){return Y.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,ve-1));const Xe=(Be+X.viewLineCount+Ne)/(X.pixelRatio*X.height),nt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:nt}}static _computeMinimapLayout(X,ve){const Be=X.outerWidth,Ne=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=ve.stableMinimapLayoutInput,ht=nt&&X.outerHeight===nt.outerHeight&&X.lineHeight===nt.lineHeight&&X.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&X.pixelRatio===nt.pixelRatio&&X.scrollBeyondLastLine===nt.scrollBeyondLastLine&&X.paddingTop===nt.paddingTop&&X.paddingBottom===nt.paddingBottom&&X.minimap.enabled===nt.minimap.enabled&&X.minimap.side===nt.minimap.side&&X.minimap.size===nt.minimap.size&&X.minimap.showSlider===nt.minimap.showSlider&&X.minimap.renderCharacters===nt.minimap.renderCharacters&&X.minimap.maxColumn===nt.minimap.maxColumn&&X.minimap.scale===nt.minimap.scale&&X.verticalScrollbarWidth===nt.verticalScrollbarWidth&&X.isViewportWrapping===nt.isViewportWrapping,wt=X.lineHeight,Pt=X.typicalHalfwidthCharacterWidth,Xt=X.scrollBeyondLastLine,Vt=X.minimap.renderCharacters;let vt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const $t=X.minimap.maxColumn,Nt=X.minimap.size,Bt=X.minimap.side,Tt=X.verticalScrollbarWidth,At=X.viewLineCount,xt=X.remainingWidth,zt=X.isViewportWrapping,qt=Vt?2:3;let Ht=Math.floor(Xe*Ne);const Wt=Ht/Xe;let ot=!1,ft=!1,Rt=qt*vt,Ot=vt/Xe,It=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Re,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:j,desiredRatio:Oe,minimapLineCount:$e}=Y.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Xt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Xe});if(At/$e>1)ot=!0,ft=!0,vt=1,Rt=1,Ot=vt/Xe;else{let ze=!1,Ze=vt+1;if(Nt==="fit"){const pt=Math.ceil((ge+At+j)*Rt);zt&&ht&&xt<=ve.stableFitRemainingWidth?(ze=!0,Ze=ve.stableFitMaxMinimapScale):ze=pt>Ht}if(Nt==="fill"||ze){ot=!0;const pt=vt;Rt=Math.min(wt*Xe,Math.max(1,Math.floor(1/Oe))),zt&&ht&&xt<=ve.stableFitRemainingWidth&&(Ze=ve.stableFitMaxMinimapScale),vt=Math.min(Ze,Math.max(1,Math.floor(Rt/qt))),vt>pt&&(It=Math.min(2,vt/pt)),Ot=vt/Xe/It,Ht=Math.ceil(Math.max(Re,ge+At+j)*Rt),zt?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=xt,ve.stableFitMaxMinimapScale=vt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const dt=Math.floor($t*Ot),yt=Math.min(dt,Math.max(0,Math.floor((xt-Tt-2)*Ot/(Pt+Ot)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Xe*yt);const Ft=Dt/Xe;Dt=Math.floor(Dt*It);const He=Vt?1:2,ke=Bt==="left"?0:Be-yt-Tt;return{renderMinimap:He,minimapLeft:ke,minimapWidth:yt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:vt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:Ht,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:Wt}}static computeLayout(X,ve){const Be=ve.outerWidth|0,Ne=ve.outerHeight|0,Xe=ve.lineHeight|0,nt=ve.lineNumbersDigitCount|0,ht=ve.typicalHalfwidthCharacterWidth,wt=ve.maxDigitWidth,Pt=ve.pixelRatio,Xt=ve.viewLineCount,Vt=X.get(135),vt=Vt==="inherit"?X.get(134):Vt,$t=vt==="inherit"?X.get(130):vt,Nt=X.get(133),Bt=ve.isDominatedByLongLines,Tt=X.get(57),At=X.get(67).renderType!==0,xt=X.get(68),zt=X.get(104),qt=X.get(83),Ht=X.get(72),Wt=X.get(102),ot=Wt.verticalScrollbarSize,ft=Wt.verticalHasArrows,Rt=Wt.arrowSize,Ot=Wt.horizontalScrollbarSize,It=X.get(43),dt=X.get(109)!=="never";let yt=X.get(65);It&&dt&&(yt+=16);let Dt=0;if(At){const bt=Math.max(nt,xt);Dt=Math.round(bt*wt)}let Ft=0;Tt&&(Ft=Xe*ve.glyphMarginDecorationLaneCount);let He=0,ke=He+Ft,Re=ke+Dt,ge=Re+yt;const j=Be-Ft-Dt-yt;let Oe=!1,$e=!1,Ke=-1;vt==="inherit"&&Bt?(Oe=!0,$e=!0):$t==="on"||$t==="bounded"?$e=!0:$t==="wordWrapColumn"&&(Ke=Nt);const ze=Y._computeMinimapLayout({outerWidth:Be,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:ht,pixelRatio:Pt,scrollBeyondLastLine:zt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Ht,verticalScrollbarWidth:ot,viewLineCount:Xt,remainingWidth:j,isViewportWrapping:$e},ve.memory||new P);ze.renderMinimap!==0&&ze.minimapLeft===0&&(He+=ze.minimapWidth,ke+=ze.minimapWidth,Re+=ze.minimapWidth,ge+=ze.minimapWidth);const Ze=j-ze.minimapWidth,pt=Math.max(1,Math.floor((Ze-ot-2)/ht)),kt=ft?Rt:0;return $e&&(Ke=Math.max(1,pt),$t==="bounded"&&(Ke=Math.min(Ke,Nt))),{width:Be,height:Ne,glyphMarginLeft:He,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:ke,lineNumbersWidth:Dt,decorationsLeft:Re,decorationsWidth:yt,contentLeft:ge,contentWidth:Ze,minimap:ze,viewportColumn:pt,isWordWrapMinified:Oe,isViewportWrapping:$e,wrappingColumn:Ke,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Ot,overviewRuler:{top:kt,width:ot,height:Ne-2*kt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ue extends _{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[d.localize(47,null),d.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:d.localize(49,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,ve,Be){return ve.get(2)===2?"advanced":Be}}class _e extends _{constructor(){const X={enabled:!0};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:d.localize(50,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class ce extends _{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:d.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:d.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:d.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:d.localize(54,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends _{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:d.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(56,null),d.localize(57,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),d.localize(58,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),d.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:d.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:d.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:d.localize(62,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:s(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(ve.fontFamily,this.defaultValue.fontFamily),padding:t(ve.padding,this.defaultValue.padding)}}}class ie extends _{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):E.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ve,Be){return Be<0?E.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class x extends p{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>p.clamp(X,0,150),{markdownDescription:d.localize(63,null)})}compute(X,ve,Be){return X.fontInfo.lineHeight}}class W extends _{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:d.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:d.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:X.size,description:d.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:d.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:d.localize(71,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:d.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:d.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),autohide:t(ve.autohide,this.defaultValue.autohide),size:s(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ve.side,this.defaultValue.side,["right","left"]),showSlider:s(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ve.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(ve.scale,1,1,3),maxColumn:E.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(J){return J==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class we extends _{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:E.clampedInt(ve.top,0,0,1e3),bottom:E.clampedInt(ve.bottom,0,0,1e3)}}}class Ee extends _{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:d.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:d.localize(78,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),cycle:t(ve.cycle,this.defaultValue.cycle)}}}class me extends g{constructor(){super(141)}compute(X,ve,Be){return X.pixelRatio}}class De extends _{constructor(){const X={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(79,null),d.localize(80,null),d.localize(81,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:X.strings,description:d.localize(82,null)},comments:{anyOf:ve,default:X.comments,description:d.localize(83,null)},other:{anyOf:ve,default:X.other,description:d.localize(84,null)}},default:X,markdownDescription:d.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Pt=X?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Ne}=X,Xe=["on","inline","off"];let nt,ht,wt;return typeof ve=="boolean"?nt=ve?"on":"off":nt=s(ve,this.defaultValue.other,Xe),typeof Be=="boolean"?ht=Be?"on":"off":ht=s(Be,this.defaultValue.comments,Xe),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=s(Ne,this.defaultValue.strings,Xe),{other:nt,comments:ht,strings:wt}}}var re;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class de extends _{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(86,null),d.localize(87,null),d.localize(88,null),d.localize(89,null)],default:"on",description:d.localize(90,null)})}validate(X){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ve=4,Be=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function se(J){const X=J.get(97);return X==="editable"?J.get(90):X!=="on"}e.filterValidationDecorations=se;class oe extends _{constructor(){const X=[],ve={type:"number",description:d.localize(91,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:d.localize(92,null),format:"color-hex"}}}]},default:X,description:d.localize(93,null)})}validate(X){if(Array.isArray(X)){const ve=[];for(const Be of X)if(typeof Be=="number")ve.push({column:E.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;ve.push({column:E.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Be,Ne)=>Be.column-Ne.column),ve}return this.defaultValue}}class fe extends _{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(J,X){if(typeof J!="string")return X;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends _{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(94,null),d.localize(95,null),d.localize(96,null)],default:"auto",description:d.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(98,null),d.localize(99,null),d.localize(100,null)],default:"auto",description:d.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:d.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:d.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:d.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Be=E.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=E.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ve.vertical,this.defaultValue.vertical),horizontal:Ie(ve.horizontal,this.defaultValue.horizontal),useShadows:t(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:E.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:E.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:t(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends _{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:d.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:d.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:d.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:d.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:d.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:d.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:d.localize(111,null)}})}applyUpdate(X,ve){let Be=!1;ve.allowedCharacters&&X&&(R.equals(X.allowedCharacters,ve.allowedCharacters)||(X={...X,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&X&&(R.equals(X.allowedLocales,ve.allowedLocales)||(X={...X,allowedLocales:ve.allowedLocales},Be=!0));const Ne=super.applyUpdate(X,ve);return Be?new a(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{nonBasicASCII:Z(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,ve){if(typeof X!="object"||!X)return ve;const Be={};for(const[Ne,Xe]of Object.entries(X))Xe===!0&&(Be[Ne]=!0);return Be}}class K extends _{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:d.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[d.localize(113,null),d.localize(114,null)],description:d.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:d.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),mode:s(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class G extends _{constructor(){const X={enabled:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:d.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:d.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends _{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(119,null),d.localize(120,null),d.localize(121,null)],default:X.bracketPairs,description:d.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(123,null),d.localize(124,null),d.localize(125,null)],default:X.bracketPairsHorizontal,description:d.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:d.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:d.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(129,null),d.localize(130,null),d.localize(131,null)],default:X.highlightActiveIndentation,description:d.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{bracketPairs:Z(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(J,X,ve){const Be=ve.indexOf(J);return Be===-1?X:ve[Be]}class ae extends _{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(133,null),d.localize(134,null)],default:X.insertMode,description:d.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:d.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:d.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:d.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[d.localize(139,null),d.localize(140,null),d.localize(141,null),d.localize(142,null)],default:X.selectionMode,markdownDescription:d.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:d.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:d.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:d.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:d.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:d.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:d.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(180,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:s(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ve.showIcons,this.defaultValue.showIcons),showStatusBar:t(ve.showStatusBar,this.defaultValue.showStatusBar),preview:t(ve.preview,this.defaultValue.preview),previewMode:s(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ve.showMethods,this.defaultValue.showMethods),showFunctions:t(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ve.showFields,this.defaultValue.showFields),showVariables:t(ve.showVariables,this.defaultValue.showVariables),showClasses:t(ve.showClasses,this.defaultValue.showClasses),showStructs:t(ve.showStructs,this.defaultValue.showStructs),showInterfaces:t(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ve.showModules,this.defaultValue.showModules),showProperties:t(ve.showProperties,this.defaultValue.showProperties),showEvents:t(ve.showEvents,this.defaultValue.showEvents),showOperators:t(ve.showOperators,this.defaultValue.showOperators),showUnits:t(ve.showUnits,this.defaultValue.showUnits),showValues:t(ve.showValues,this.defaultValue.showValues),showConstants:t(ve.showConstants,this.defaultValue.showConstants),showEnums:t(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ve.showKeywords,this.defaultValue.showKeywords),showWords:t(ve.showWords,this.defaultValue.showWords),showColors:t(ve.showColors,this.defaultValue.showColors),showFiles:t(ve.showFiles,this.defaultValue.showFiles),showReferences:t(ve.showReferences,this.defaultValue.showReferences),showFolders:t(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ve.showSnippets,this.defaultValue.showSnippets),showUsers:t(ve.showUsers,this.defaultValue.showUsers),showIssues:t(ve.showIssues,this.defaultValue.showIssues)}}}class Me extends _{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:d.localize(182,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ge extends _{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[d.localize(183,null),d.localize(184,null),d.localize(185,null),d.localize(186,null)],description:d.localize(187,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ve,Be){return ve.get(2)===2?0:Be}}class je extends g{constructor(){super(144)}compute(X,ve,Be){const Ne=ve.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class Je extends _{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:d.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:d.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[d.localize(190,null),d.localize(191,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),showDropSelector:s(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends _{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:d.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:d.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[d.localize(194,null),d.localize(195,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),showPasteSelector:s(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?it:k.isLinux?tt:et,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function xe(J){return e.editorOptionsRegistry[J.id]=J,J}var st;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.ariaRequired=5]="ariaRequired",J[J.autoClosingBrackets=6]="autoClosingBrackets",J[J.autoClosingComments=7]="autoClosingComments",J[J.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",J[J.autoClosingDelete=9]="autoClosingDelete",J[J.autoClosingOvertype=10]="autoClosingOvertype",J[J.autoClosingQuotes=11]="autoClosingQuotes",J[J.autoIndent=12]="autoIndent",J[J.automaticLayout=13]="automaticLayout",J[J.autoSurround=14]="autoSurround",J[J.bracketPairColorization=15]="bracketPairColorization",J[J.guides=16]="guides",J[J.codeLens=17]="codeLens",J[J.codeLensFontFamily=18]="codeLensFontFamily",J[J.codeLensFontSize=19]="codeLensFontSize",J[J.colorDecorators=20]="colorDecorators",J[J.colorDecoratorsLimit=21]="colorDecoratorsLimit",J[J.columnSelection=22]="columnSelection",J[J.comments=23]="comments",J[J.contextmenu=24]="contextmenu",J[J.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",J[J.cursorBlinking=26]="cursorBlinking",J[J.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",J[J.cursorStyle=28]="cursorStyle",J[J.cursorSurroundingLines=29]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",J[J.cursorWidth=31]="cursorWidth",J[J.disableLayerHinting=32]="disableLayerHinting",J[J.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",J[J.domReadOnly=34]="domReadOnly",J[J.dragAndDrop=35]="dragAndDrop",J[J.dropIntoEditor=36]="dropIntoEditor",J[J.emptySelectionClipboard=37]="emptySelectionClipboard",J[J.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",J[J.extraEditorClassName=39]="extraEditorClassName",J[J.fastScrollSensitivity=40]="fastScrollSensitivity",J[J.find=41]="find",J[J.fixedOverflowWidgets=42]="fixedOverflowWidgets",J[J.folding=43]="folding",J[J.foldingStrategy=44]="foldingStrategy",J[J.foldingHighlight=45]="foldingHighlight",J[J.foldingImportsByDefault=46]="foldingImportsByDefault",J[J.foldingMaximumRegions=47]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=49]="fontFamily",J[J.fontInfo=50]="fontInfo",J[J.fontLigatures=51]="fontLigatures",J[J.fontSize=52]="fontSize",J[J.fontWeight=53]="fontWeight",J[J.fontVariations=54]="fontVariations",J[J.formatOnPaste=55]="formatOnPaste",J[J.formatOnType=56]="formatOnType",J[J.glyphMargin=57]="glyphMargin",J[J.gotoLocation=58]="gotoLocation",J[J.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",J[J.hover=60]="hover",J[J.inDiffEditor=61]="inDiffEditor",J[J.inlineSuggest=62]="inlineSuggest",J[J.letterSpacing=63]="letterSpacing",J[J.lightbulb=64]="lightbulb",J[J.lineDecorationsWidth=65]="lineDecorationsWidth",J[J.lineHeight=66]="lineHeight",J[J.lineNumbers=67]="lineNumbers",J[J.lineNumbersMinChars=68]="lineNumbersMinChars",J[J.linkedEditing=69]="linkedEditing",J[J.links=70]="links",J[J.matchBrackets=71]="matchBrackets",J[J.minimap=72]="minimap",J[J.mouseStyle=73]="mouseStyle",J[J.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=75]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",J[J.multiCursorModifier=77]="multiCursorModifier",J[J.multiCursorPaste=78]="multiCursorPaste",J[J.multiCursorLimit=79]="multiCursorLimit",J[J.occurrencesHighlight=80]="occurrencesHighlight",J[J.overviewRulerBorder=81]="overviewRulerBorder",J[J.overviewRulerLanes=82]="overviewRulerLanes",J[J.padding=83]="padding",J[J.pasteAs=84]="pasteAs",J[J.parameterHints=85]="parameterHints",J[J.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",J[J.quickSuggestions=88]="quickSuggestions",J[J.quickSuggestionsDelay=89]="quickSuggestionsDelay",J[J.readOnly=90]="readOnly",J[J.readOnlyMessage=91]="readOnlyMessage",J[J.renameOnType=92]="renameOnType",J[J.renderControlCharacters=93]="renderControlCharacters",J[J.renderFinalNewline=94]="renderFinalNewline",J[J.renderLineHighlight=95]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=97]="renderValidationDecorations",J[J.renderWhitespace=98]="renderWhitespace",J[J.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",J[J.roundedSelection=100]="roundedSelection",J[J.rulers=101]="rulers",J[J.scrollbar=102]="scrollbar",J[J.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=104]="scrollBeyondLastLine",J[J.scrollPredominantAxis=105]="scrollPredominantAxis",J[J.selectionClipboard=106]="selectionClipboard",J[J.selectionHighlight=107]="selectionHighlight",J[J.selectOnLineNumbers=108]="selectOnLineNumbers",J[J.showFoldingControls=109]="showFoldingControls",J[J.showUnused=110]="showUnused",J[J.snippetSuggestions=111]="snippetSuggestions",J[J.smartSelect=112]="smartSelect",J[J.smoothScrolling=113]="smoothScrolling",J[J.stickyScroll=114]="stickyScroll",J[J.stickyTabStops=115]="stickyTabStops",J[J.stopRenderingLineAfter=116]="stopRenderingLineAfter",J[J.suggest=117]="suggest",J[J.suggestFontSize=118]="suggestFontSize",J[J.suggestLineHeight=119]="suggestLineHeight",J[J.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",J[J.suggestSelection=121]="suggestSelection",J[J.tabCompletion=122]="tabCompletion",J[J.tabIndex=123]="tabIndex",J[J.unicodeHighlighting=124]="unicodeHighlighting",J[J.unusualLineTerminators=125]="unusualLineTerminators",J[J.useShadowDOM=126]="useShadowDOM",J[J.useTabStops=127]="useTabStops",J[J.wordBreak=128]="wordBreak",J[J.wordSeparators=129]="wordSeparators",J[J.wordWrap=130]="wordWrap",J[J.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=133]="wordWrapColumn",J[J.wordWrapOverride1=134]="wordWrapOverride1",J[J.wordWrapOverride2=135]="wordWrapOverride2",J[J.wrappingIndent=136]="wrappingIndent",J[J.wrappingStrategy=137]="wrappingStrategy",J[J.showDeprecated=138]="showDeprecated",J[J.inlayHints=139]="inlayHints",J[J.editorClassName=140]="editorClassName",J[J.pixelRatio=141]="pixelRatio",J[J.tabFocusMode=142]="tabFocusMode",J[J.layoutInfo=143]="layoutInfo",J[J.wrappingInfo=144]="wrappingInfo",J[J.defaultColorDecorators=145]="defaultColorDecorators",J[J.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",J[J.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:xe(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(196,null)})),acceptSuggestionOnEnter:xe(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(197,null),""],markdownDescription:d.localize(198,null)})),accessibilitySupport:xe(new b),accessibilityPageSize:xe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(199,null),tags:["accessibility"]})),ariaLabel:xe(new r(4,"ariaLabel",d.localize(200,null))),ariaRequired:xe(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:xe(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:d.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:xe(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(202,null),d.localize(203,null),""],description:d.localize(204,null)})),autoClosingComments:xe(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(205,null),d.localize(206,null),""],description:d.localize(207,null)})),autoClosingDelete:xe(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(208,null),""],description:d.localize(209,null)})),autoClosingOvertype:xe(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(210,null),""],description:d.localize(211,null)})),autoClosingQuotes:xe(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(212,null),d.localize(213,null),""],description:d.localize(214,null)})),autoIndent:xe(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[d.localize(215,null),d.localize(216,null),d.localize(217,null),d.localize(218,null),d.localize(219,null)],description:d.localize(220,null)})),automaticLayout:xe(new n(13,"automaticLayout",!1)),autoSurround:xe(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(221,null),d.localize(222,null),d.localize(223,null),""],description:d.localize(224,null)})),bracketPairColorization:xe(new G),bracketPairGuides:xe(new q),stickyTabStops:xe(new n(115,"stickyTabStops",!1,{description:d.localize(225,null)})),codeLens:xe(new n(17,"codeLens",!0,{description:d.localize(226,null)})),codeLensFontFamily:xe(new r(18,"codeLensFontFamily","",{description:d.localize(227,null)})),codeLensFontSize:xe(new E(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(228,null)})),colorDecorators:xe(new n(20,"colorDecorators",!0,{description:d.localize(229,null)})),colorDecoratorActivatedOn:xe(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[d.localize(230,null),d.localize(231,null),d.localize(232,null)],description:d.localize(233,null)})),colorDecoratorsLimit:xe(new E(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:d.localize(234,null)})),columnSelection:xe(new n(22,"columnSelection",!1,{description:d.localize(235,null)})),comments:xe(new C),contextmenu:xe(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:xe(new n(25,"copyWithSyntaxHighlighting",!0,{description:d.localize(236,null)})),cursorBlinking:xe(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:d.localize(237,null)})),cursorSmoothCaretAnimation:xe(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[d.localize(238,null),d.localize(239,null),d.localize(240,null)],description:d.localize(241,null)})),cursorStyle:xe(new o(28,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:d.localize(242,null)})),cursorSurroundingLines:xe(new E(29,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(243,null)})),cursorSurroundingLinesStyle:xe(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(244,null),d.localize(245,null)],markdownDescription:d.localize(246,null)})),cursorWidth:xe(new E(31,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(247,null)})),disableLayerHinting:xe(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:xe(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:xe(new n(34,"domReadOnly",!1)),dragAndDrop:xe(new n(35,"dragAndDrop",!0,{description:d.localize(248,null)})),emptySelectionClipboard:xe(new H),dropIntoEditor:xe(new Je),stickyScroll:xe(new ce),experimentalWhitespaceRendering:xe(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[d.localize(249,null),d.localize(250,null),d.localize(251,null)],description:d.localize(252,null)})),extraEditorClassName:xe(new r(39,"extraEditorClassName","")),fastScrollSensitivity:xe(new p(40,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:d.localize(253,null)})),find:xe(new U),fixedOverflowWidgets:xe(new n(42,"fixedOverflowWidgets",!1)),folding:xe(new n(43,"folding",!0,{description:d.localize(254,null)})),foldingStrategy:xe(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),foldingHighlight:xe(new n(45,"foldingHighlight",!0,{description:d.localize(258,null)})),foldingImportsByDefault:xe(new n(46,"foldingImportsByDefault",!1,{description:d.localize(259,null)})),foldingMaximumRegions:xe(new E(47,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(260,null)})),unfoldOnClickAfterEndOfLine:xe(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(261,null)})),fontFamily:xe(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(262,null)})),fontInfo:xe(new N),fontLigatures2:xe(new z),fontSize:xe(new ee),fontWeight:xe(new Q),fontVariations:xe(new M),formatOnPaste:xe(new n(55,"formatOnPaste",!1,{description:d.localize(263,null)})),formatOnType:xe(new n(56,"formatOnType",!1,{description:d.localize(264,null)})),glyphMargin:xe(new n(57,"glyphMargin",!0,{description:d.localize(265,null)})),gotoLocation:xe(new Se),hideCursorInOverviewRuler:xe(new n(59,"hideCursorInOverviewRuler",!1,{description:d.localize(266,null)})),hover:xe(new ye),inDiffEditor:xe(new n(61,"inDiffEditor",!1)),letterSpacing:xe(new p(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>p.clamp(J,-5,20),{description:d.localize(267,null)})),lightbulb:xe(new _e),lineDecorationsWidth:xe(new ie),lineHeight:xe(new x),lineNumbers:xe(new de),lineNumbersMinChars:xe(new E(68,"lineNumbersMinChars",5,1,300)),linkedEditing:xe(new n(69,"linkedEditing",!1,{description:d.localize(268,null)})),links:xe(new n(70,"links",!0,{description:d.localize(269,null)})),matchBrackets:xe(new i(71,"matchBrackets","always",["always","near","never"],{description:d.localize(270,null)})),minimap:xe(new W),mouseStyle:xe(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:xe(new p(74,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:d.localize(271,null)})),mouseWheelZoom:xe(new n(75,"mouseWheelZoom",!1,{markdownDescription:d.localize(272,null)})),multiCursorMergeOverlapping:xe(new n(76,"multiCursorMergeOverlapping",!0,{description:d.localize(273,null)})),multiCursorModifier:xe(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[d.localize(274,null),d.localize(275,null)],markdownDescription:d.localize(276,null)})),multiCursorPaste:xe(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(277,null),d.localize(278,null)],markdownDescription:d.localize(279,null)})),multiCursorLimit:xe(new E(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:d.localize(280,null)})),occurrencesHighlight:xe(new n(80,"occurrencesHighlight",!0,{description:d.localize(281,null)})),overviewRulerBorder:xe(new n(81,"overviewRulerBorder",!0,{description:d.localize(282,null)})),overviewRulerLanes:xe(new E(82,"overviewRulerLanes",3,0,3)),padding:xe(new we),pasteAs:xe(new Ye),parameterHints:xe(new Ee),peekWidgetDefaultFocus:xe(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(283,null),d.localize(284,null)],description:d.localize(285,null)})),definitionLinkOpensInPeek:xe(new n(87,"definitionLinkOpensInPeek",!1,{description:d.localize(286,null)})),quickSuggestions:xe(new De),quickSuggestionsDelay:xe(new E(89,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(287,null)})),readOnly:xe(new n(90,"readOnly",!1)),readOnlyMessage:xe(new fe),renameOnType:xe(new n(92,"renameOnType",!1,{description:d.localize(288,null),markdownDeprecationMessage:d.localize(289,null)})),renderControlCharacters:xe(new n(93,"renderControlCharacters",!0,{description:d.localize(290,null),restricted:!0})),renderFinalNewline:xe(new i(94,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:d.localize(291,null)})),renderLineHighlight:xe(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(292,null)],description:d.localize(293,null)})),renderLineHighlightOnlyWhenFocus:xe(new n(96,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(294,null)})),renderValidationDecorations:xe(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:xe(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(295,null),d.localize(296,null),d.localize(297,null),""],description:d.localize(298,null)})),revealHorizontalRightPadding:xe(new E(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:xe(new n(100,"roundedSelection",!0,{description:d.localize(299,null)})),rulers:xe(new oe),scrollbar:xe(new O),scrollBeyondLastColumn:xe(new E(103,"scrollBeyondLastColumn",4,0,1073741824,{description:d.localize(300,null)})),scrollBeyondLastLine:xe(new n(104,"scrollBeyondLastLine",!0,{description:d.localize(301,null)})),scrollPredominantAxis:xe(new n(105,"scrollPredominantAxis",!0,{description:d.localize(302,null)})),selectionClipboard:xe(new n(106,"selectionClipboard",!0,{description:d.localize(303,null),included:k.isLinux})),selectionHighlight:xe(new n(107,"selectionHighlight",!0,{description:d.localize(304,null)})),selectOnLineNumbers:xe(new n(108,"selectOnLineNumbers",!0)),showFoldingControls:xe(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[d.localize(305,null),d.localize(306,null),d.localize(307,null)],description:d.localize(308,null)})),showUnused:xe(new n(110,"showUnused",!0,{description:d.localize(309,null)})),showDeprecated:xe(new n(138,"showDeprecated",!0,{description:d.localize(310,null)})),inlayHints:xe(new pe),snippetSuggestions:xe(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(311,null),d.localize(312,null),d.localize(313,null),d.localize(314,null)],description:d.localize(315,null)})),smartSelect:xe(new Me),smoothScrolling:xe(new n(113,"smoothScrolling",!1,{description:d.localize(316,null)})),stopRenderingLineAfter:xe(new E(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:xe(new ae),inlineSuggest:xe(new K),inlineCompletionsAccessibilityVerbose:xe(new n(147,"inlineCompletionsAccessibilityVerbose",!1,{description:d.localize(317,null)})),suggestFontSize:xe(new E(118,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:xe(new E(119,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:xe(new n(120,"suggestOnTriggerCharacters",!0,{description:d.localize(320,null)})),suggestSelection:xe(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(321,null),d.localize(322,null),d.localize(323,null)],description:d.localize(324,null)})),tabCompletion:xe(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(325,null),d.localize(326,null),d.localize(327,null)],description:d.localize(328,null)})),tabIndex:xe(new E(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:xe(new V),unusualLineTerminators:xe(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(329,null),d.localize(330,null),d.localize(331,null)],description:d.localize(332,null)})),useShadowDOM:xe(new n(126,"useShadowDOM",!0)),useTabStops:xe(new n(127,"useTabStops",!0,{description:d.localize(333,null)})),wordBreak:xe(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[d.localize(334,null),d.localize(335,null)],description:d.localize(336,null)})),wordSeparators:xe(new r(129,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:d.localize(337,null)})),wordWrap:xe(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(338,null),d.localize(339,null),d.localize(340,null),d.localize(341,null)],description:d.localize(342,null)})),wordWrapBreakAfterCharacters:xe(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:xe(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:xe(new E(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(343,null)})),wordWrapOverride1:xe(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:xe(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:xe(new B),defaultColorDecorators:xe(new n(145,"defaultColorDecorators",!1,{markdownDescription:d.localize(344,null)})),pixelRatio:xe(new me),tabFocusMode:xe(new n(142,"tabFocusMode",!1,{markdownDescription:d.localize(345,null)})),layoutInfo:xe(new Y),wrappingInfo:xe(new je),wrappingIndent:xe(new Ge),wrappingStrategy:xe(new ue)}}),define(Te[137],Ae([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Te[138],Ae([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Te[139],Ae([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Te[140],Ae([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Te[141],Ae([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Te[142],Ae([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Te[143],Ae([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Te[144],Ae([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Te[145],Ae([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Te[146],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Te[147],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Te[148],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Te[149],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Te[150],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Te[151],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Te[152],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Te[153],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Te[154],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Te[155],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Te[156],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Te[157],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Te[158],Ae([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Te[159],Ae([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Te[160],Ae([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Te[161],Ae([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Te[162],Ae([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Te[163],Ae([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Te[164],Ae([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Te[165],Ae([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Te[166],Ae([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Te[167],Ae([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Te[168],Ae([1,0,9,139]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(k||(e.TokenType=k={}));function F(...m){switch(m.length){case 1:return(0,R.localize)(0,null,m[0]);case 2:return(0,R.localize)(1,null,m[0],m[1]);case 3:return(0,R.localize)(2,null,m[0],m[1],m[2]);default:return}}const T=(0,R.localize)(3,null),d=(0,R.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const _=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:_})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const _=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:_})}else this._match(126)?this._addToken(9):this._error(F("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(F("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const _=this._start,a=this._input.substring(this._start,this._current),v={type:19,offset:this._start,lexeme:a};this._errors.push({offset:_,lexeme:a,additionalInfo:P}),this._tokens.push(v)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const _=this._input.substring(this._start,this._current),a=y._keywords.get(_);a?this._addToken(a):this._tokens.push({type:17,lexeme:_,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,_=!1,a=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(d);return}const g=this._input.charCodeAt(P);if(_)_=!1;else if(g===47&&!a){P++;break}else g===91?a=!0:g===92?_=!0:g===93&&(a=!1);P++}for(;P<this._input.length&&y._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const v=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:v,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(Te[169],Ae([1,0,23,29,141,277]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,d=/^-(\d{4})(\d{2})(\d{2})$/;function y(n){return n=n.trim(),n==="*"||T.test(n)}e.isValidVersionStr=y;function m(n){if(!y(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=n.match(T);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.parseVersion=m;function P(n){if(!n)return null;const l=n.majorBase,E=n.majorMustEqual,D=n.minorBase;let p=n.minorMustEqual;const r=n.patchBase;let s=n.patchMustEqual;n.hasCaret&&(l===0||(p=!1),s=!1);let i=0;if(n.preRelease){const o=d.exec(n.preRelease);if(o){const[,S,b,C]=o;i=Date.UTC(Number(S),Number(b)-1,Number(C))}}return{majorBase:l,majorMustEqual:E,minorBase:D,minorMustEqual:p,patchBase:r,patchMustEqual:s,isMinimum:n.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function _(n,l,E){let D;typeof n=="string"?D=P(m(n)):D=n;let p;l instanceof Date?p=l.getTime():typeof l=="string"&&(p=new Date(l).getTime());let r;if(typeof E=="string"?r=P(m(E)):r=E,!D||!r)return!1;const s=D.majorBase,i=D.minorBase,o=D.patchBase;let S=r.majorBase,b=r.minorBase,C=r.patchBase;const I=r.notBefore;let c=r.majorMustEqual,h=r.minorMustEqual,u=r.patchMustEqual;return r.isMinimum?s>S?!0:s<S?!1:i>b?!0:i<b||p&&p<I?!1:o>=C:(s===1&&S===0&&(!c||!h||!u)&&(S=1,b=0,C=0,c=!0,h=!1,u=!1),s<S?!1:s>S?!c:i<b?!1:i>b?!h:o<C?!1:o>C?!u:!(p&&p<I))}e.isValidVersion=_;function a(n,l,E,D,p){const r=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return r.push([R.default.Error,k.localize(0,null)]),r;if(typeof D.name!="string")return r.push([R.default.Error,k.localize(1,null,"name")]),r;if(typeof D.version!="string")return r.push([R.default.Error,k.localize(2,null,"version")]),r;if(!D.engines)return r.push([R.default.Error,k.localize(3,null,"engines")]),r;if(typeof D.engines.vscode!="string")return r.push([R.default.Error,k.localize(4,null,"engines.vscode")]),r;if(typeof D.extensionDependencies<"u"&&!t(D.extensionDependencies))return r.push([R.default.Error,k.localize(5,null,"extensionDependencies")]),r;if(typeof D.activationEvents<"u"){if(!t(D.activationEvents))return r.push([R.default.Error,k.localize(6,null,"activationEvents")]),r;if(typeof D.main>"u"&&typeof D.browser>"u")return r.push([R.default.Error,k.localize(7,null,"activationEvents","main","browser")]),r}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&r.push([R.default.Warning,k.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return r.push([R.default.Error,k.localize(9,null,"main")]),r;{const o=(0,w.joinPath)(E,D.main);(0,w.isEqualOrParent)(o,E)||r.push([R.default.Warning,k.localize(10,null,o.path,E.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return r.push([R.default.Error,k.localize(11,null,"browser")]),r;{const o=(0,w.joinPath)(E,D.browser);(0,w.isEqualOrParent)(o,E)||r.push([R.default.Warning,k.localize(12,null,o.path,E.path)])}}if(!F.valid(D.version))return r.push([R.default.Error,k.localize(13,null)]),r;const s=[];if(!v(n,l,D,p,s))for(const o of s)r.push([R.default.Error,o]);return r}e.validateExtensionManifest=a;function v(n,l,E,D,p){return D||typeof E.main>"u"&&typeof E.browser>"u"?!0:f(n,l,E.engines.vscode,p)}e.isValidExtensionVersion=v;function g(n,l,E){return n==="*"||f(l,E,n)}e.isEngineValid=g;function f(n,l,E,D=[]){const p=P(m(E));if(!p)return D.push(k.localize(14,null,E)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(k.localize(15,null,E)),!1}else if(!p.majorMustEqual)return D.push(k.localize(16,null,E)),!1;return _(n,l,p)?!0:(D.push(k.localize(17,null,n,E)),!1)}function t(n){if(!Array.isArray(n))return!1;for(let l=0,E=n.length;l<E;l++)if(typeof n[l]!="string")return!1;return!0}}),define(Te[70],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,F=[],T=!1){this.ctor=k,this.staticArguments=F,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=w}),define(Te[71],Ae([1,0,70]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var k;(function(d){d[d.Eager=0]="Eager",d[d.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function F(d,y,m){y instanceof w.SyncDescriptor||(y=new w.SyncDescriptor(y,[],!!m)),R.push([d,y])}e.registerSingleton=F;function T(){return R}e.getSingletonServiceDescriptors=T}),define(Te[170],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(F,T){this.key=F,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class R{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(const T of this._nodes.values())T.outgoing.size===0&&F.push(T);return F}insertEdge(F,T){const d=this.lookupOrInsertNode(F),y=this.lookupOrInsertNode(T);d.outgoing.set(y.key,y),y.incoming.set(d.key,d)}removeNode(F){const T=this._hashFn(F);this._nodes.delete(T);for(const d of this._nodes.values())d.outgoing.delete(T),d.incoming.delete(T)}lookupOrInsertNode(F){const T=this._hashFn(F);let d=this._nodes.get(T);return d||(d=new w(T,F),this._nodes.set(T,d)),d}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){const F=[];for(const[T,d]of this._nodes)F.push(`${T}
	(-> incoming)[${[...d.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...d.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,T]of this._nodes){const d=new Set([F]),y=this._findCycle(T,d);if(y)return y}}_findCycle(F,T){for(const[d,y]of F.outgoing){if(T.has(d))return[...T,d].join(" -> ");T.add(d);const m=this._findCycle(y,T);if(m)return m;T.delete(d)}}}e.Graph=R}),define(Te[4],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function d(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=d})(w||(e._util=w={})),e.IInstantiationService=k("instantiationService");function R(T,d,y){d[w.DI_TARGET]===d?d[w.DI_DEPENDENCIES].push({id:T,index:y}):(d[w.DI_DEPENDENCIES]=[{id:T,index:y}],d[w.DI_TARGET]=d)}function k(T){if(w.serviceIds.has(T))return w.serviceIds.get(T);const d=function(y,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(d,y,P)};return d.toString=()=>T,w.serviceIds.set(T,d),d}e.createDecorator=k;function F(T){return T}e.refineServiceDecorator=F}),define(Te[43],Ae([1,0,16,2,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function F(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof R.URI)}e.isConfigurationOverrides=F;function T(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=T;var d;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(d||(e.ConfigurationTarget=d={}));function y(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function m(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}e.isConfigured=m;function P(n,l){const E=Object.create(null);for(const D in n)_(E,D,n[D],l);return E}e.toValuesTree=P;function _(n,l,E,D){const p=l.split("."),r=p.pop();let s=n;for(let i=0;i<p.length;i++){const o=p[i];let S=s[o];switch(typeof S){case"undefined":S=s[o]=Object.create(null);break;case"object":break;default:D(`Ignoring ${l} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(S)}`);return}s=S}if(typeof s=="object"&&s!==null)try{s[r]=E}catch{D(`Ignoring ${l} as ${p.join(".")} is ${JSON.stringify(s)}`)}else D(`Ignoring ${l} as ${p.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=_;function a(n,l){const E=l.split(".");v(n,E)}e.removeFromValueTree=a;function v(n,l){const E=l.shift();if(l.length===0){delete n[E];return}if(Object.keys(n).indexOf(E)!==-1){const D=n[E];typeof D=="object"&&!Array.isArray(D)&&(v(D,l),Object.keys(D).length===0&&delete n[E])}}function g(n,l,E){function D(s,i){let o=s;for(const S of i){if(typeof o!="object"||o===null)return;o=o[S]}return o}const p=l.split("."),r=D(n,p);return typeof r>"u"?E:r}e.getConfigurationValue=g;function f(n,l,E){Object.keys(l).forEach(D=>{D!=="__proto__"&&(D in n?w.isObject(n[D])&&w.isObject(l[D])?f(n[D],l[D],E):E&&(n[D]=l[D]):n[D]=l[D])})}e.merge=f;function t(n){return n.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=t}),define(Te[32],Ae([1,0,22,15,168,4,138,9]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",w.isMacintosh),y.set("isLinux",w.isLinux),y.set("isWindows",w.isWindows),y.set("isWeb",w.isWeb),y.set("isMacNative",w.isMacintosh&&!w.isWeb),y.set("isEdge",w.isEdge),y.set("isFirefox",w.isFirefox),y.set("isChrome",w.isChrome),y.set("isSafari",w.isSafari);function m(ie,x){if(y.get(ie)!==void 0)throw(0,d.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(ie,x)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var _;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(_||(e.ContextKeyExprType=_={}));const a={regexParsingWithErrorRecovery:!0},v=(0,T.localize)(0,null),g=(0,T.localize)(1,null),f=(0,T.localize)(2,null),t=(0,T.localize)(3,null),n=(0,T.localize)(4,null),l=(0,T.localize)(5,null),E=(0,T.localize)(6,null),D=(0,T.localize)(7,null);class p{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(x=a){this._config=x,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(x){if(x===""){this._parsingErrors.push({message:v,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(x).scan(),this._current=0,this._parsingErrors=[];try{const W=this._expr();if(!this._isAtEnd()){const le=this._peek(),we=le.type===17?l:void 0;throw this._parsingErrors.push({message:n,offset:le.offset,lexeme:k.Scanner.getLexeme(le),additionalInfo:we}),p._parseError}return W}catch(W){if(W!==p._parseError)throw W;return}}_expr(){return this._or()}_or(){const x=[this._and()];for(;this._matchOne(16);){const W=this._and();x.push(W)}return x.length===1?x[0]:r.or(...x)}_and(){const x=[this._term()];for(;this._matchOne(15);){const W=this._term();x.push(W)}return x.length===1?x[0]:r.and(...x)}_term(){if(this._matchOne(2)){const x=this._peek();switch(x.type){case 11:return this._advance(),S.INSTANCE;case 12:return this._advance(),b.INSTANCE;case 0:{this._advance();const W=this._expr();return this._consume(1,t),W?.negate()}case 17:return this._advance(),A.create(x.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",x)}}return this._primary()}_primary(){const x=this._peek();switch(x.type){case 11:return this._advance(),r.true();case 12:return this._advance(),r.false();case 0:{this._advance();const W=this._expr();return this._consume(1,t),W}case 17:{const W=x.lexeme;if(this._advance(),this._matchOne(9)){const we=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),we.type!==10)throw this._errExpectedButGot("REGEX",we);const Ee=we.lexeme,me=Ee.lastIndexOf("/"),De=me===Ee.length-1?void 0:this._removeFlagsGY(Ee.substring(me+1));let re;try{re=new RegExp(Ee.substring(1,me),De)}catch{throw this._errExpectedButGot("REGEX",we)}return N.create(W,re)}switch(we.type){case 10:case 19:{const Ee=[we.lexeme];this._advance();let me=this._peek(),De=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--;for(;!this._isAtEnd()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let fe=0;fe<me.lexeme.length;fe++)me.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--}if(De<0)break;Ee.push(k.Scanner.getLexeme(me)),this._advance(),me=this._peek()}const re=Ee.join(""),de=re.lastIndexOf("/"),se=de===re.length-1?void 0:this._removeFlagsGY(re.substring(de+1));let oe;try{oe=new RegExp(re.substring(1,de),se)}catch{throw this._errExpectedButGot("REGEX",we)}return r.regex(W,oe)}case 18:{const Ee=we.lexeme;this._advance();let me=null;if(!(0,R.isFalsyOrWhitespace)(Ee)){const De=Ee.indexOf("/"),re=Ee.lastIndexOf("/");if(De!==re&&De>=0){const de=Ee.slice(De+1,re),se=Ee[re+1]==="i"?"i":"";try{me=new RegExp(de,se)}catch{throw this._errExpectedButGot("REGEX",we)}}}if(me===null)throw this._errExpectedButGot("REGEX",we);return N.create(W,me)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,f);const we=this._value();return r.notIn(W,we)}switch(this._peek().type){case 3:{this._advance();const we=this._value();if(this._previous().type===18)return r.equals(W,we);switch(we){case"true":return r.has(W);case"false":return r.not(W);default:return r.equals(W,we)}}case 4:{this._advance();const we=this._value();if(this._previous().type===18)return r.notEquals(W,we);switch(we){case"true":return r.not(W);case"false":return r.has(W);default:return r.notEquals(W,we)}}case 5:return this._advance(),z.create(W,this._value());case 6:return this._advance(),M.create(W,this._value());case 7:return this._advance(),H.create(W,this._value());case 8:return this._advance(),U.create(W,this._value());case 13:return this._advance(),r.in(W,this._value());default:return r.has(W)}}case 20:throw this._parsingErrors.push({message:E,offset:x.offset,lexeme:"",additionalInfo:D}),p._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const x=this._peek();switch(x.type){case 17:case 18:return this._advance(),x.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(x){return x.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(x){return this._check(x)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(x,W){if(this._check(x))return this._advance();throw this._errExpectedButGot(W,this._peek())}_errExpectedButGot(x,W,le){const we=(0,T.localize)(8,null,x,k.Scanner.getLexeme(W)),Ee=W.offset,me=k.Scanner.getLexeme(W);return this._parsingErrors.push({message:we,offset:Ee,lexeme:me,additionalInfo:le}),p._parseError}_check(x){return this._peek().type===x}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=p;class r{static false(){return S.INSTANCE}static true(){return b.INSTANCE}static has(x){return C.create(x)}static equals(x,W){return I.create(x,W)}static notEquals(x,W){return u.create(x,W)}static regex(x,W){return N.create(x,W)}static in(x,W){return c.create(x,W)}static notIn(x,W){return h.create(x,W)}static not(x){return A.create(x)}static and(...x){return Se.create(x,null,!0)}static or(...x){return ye.create(x,null,!0)}static greater(x,W){return H.create(x,W)}static greaterEquals(x,W){return U.create(x,W)}static smaller(x,W){return z.create(x,W)}static smallerEquals(x,W){return M.create(x,W)}static{this._parser=new p({regexParsingWithErrorRecovery:!1})}static deserialize(x){return x==null?void 0:this._parser.parse(x)}}e.ContextKeyExpr=r;function s(ie){const x=new p({regexParsingWithErrorRecovery:!1});return ie.map(W=>(x.parse(W),x.lexingErrors.length>0?x.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,T.localize)(9,null,le.additionalInfo):(0,T.localize)(10,null),offset:le.offset,length:le.lexeme.length})):x.parsingErrors.length>0?x.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.validateWhenClauses=s;function i(ie,x){const W=ie?ie.substituteConstants():void 0,le=x?x.substituteConstants():void 0;return!W&&!le?!0:!W||!le?!1:W.equals(le)}e.expressionsAreEqualWithConstantSubstitution=i;function o(ie,x){return ie.cmp(x)}class S{static{this.INSTANCE=new S}constructor(){this.type=0}cmp(x){return this.type-x.type}equals(x){return x.type===this.type}substituteConstants(){return this}evaluate(x){return!1}serialize(){return"false"}keys(){return[]}map(x){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=S;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(x){return this.type-x.type}equals(x){return x.type===this.type}substituteConstants(){return this}evaluate(x){return!0}serialize(){return"true"}keys(){return[]}map(x){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=b;class C{static create(x,W=null){const le=y.get(x);return typeof le=="boolean"?le?b.INSTANCE:S.INSTANCE:new C(x,W)}constructor(x,W){this.key=x,this.negated=W,this.type=2}cmp(x){return x.type!==this.type?this.type-x.type:Y(this.key,x.key)}equals(x){return x.type===this.type?this.key===x.key:!1}substituteConstants(){const x=y.get(this.key);return typeof x=="boolean"?x?b.INSTANCE:S.INSTANCE:this}evaluate(x){return!!x.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(x){return x.mapDefined(this.key)}negate(){return this.negated||(this.negated=A.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class I{static create(x,W,le=null){if(typeof W=="boolean")return W?C.create(x,le):A.create(x,le);const we=y.get(x);return typeof we=="boolean"?W===(we?"true":"false")?b.INSTANCE:S.INSTANCE:new I(x,W,le)}constructor(x,W,le){this.key=x,this.value=W,this.negated=le,this.type=4}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){const x=y.get(this.key);if(typeof x=="boolean"){const W=x?"true":"false";return this.value===W?b.INSTANCE:S.INSTANCE}return this}evaluate(x){return x.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(x){return x.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=I;class c{static create(x,W){return new c(x,W)}constructor(x,W){this.key=x,this.valueKey=W,this.type=10,this.negated=null}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.valueKey,x.key,x.valueKey)}equals(x){return x.type===this.type?this.key===x.key&&this.valueKey===x.valueKey:!1}substituteConstants(){return this}evaluate(x){const W=x.getValue(this.valueKey),le=x.getValue(this.key);return Array.isArray(W)?W.includes(le):typeof le=="string"&&typeof W=="object"&&W!==null?P.call(W,le):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(x){return x.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=c;class h{static create(x,W){return new h(x,W)}constructor(x,W){this.key=x,this.valueKey=W,this.type=11,this._negated=c.create(x,W)}cmp(x){return x.type!==this.type?this.type-x.type:this._negated.cmp(x._negated)}equals(x){return x.type===this.type?this._negated.equals(x._negated):!1}substituteConstants(){return this}evaluate(x){return!this._negated.evaluate(x)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(x){return x.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class u{static create(x,W,le=null){if(typeof W=="boolean")return W?A.create(x,le):C.create(x,le);const we=y.get(x);return typeof we=="boolean"?W===(we?"true":"false")?S.INSTANCE:b.INSTANCE:new u(x,W,le)}constructor(x,W,le){this.key=x,this.value=W,this.negated=le,this.type=5}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){const x=y.get(this.key);if(typeof x=="boolean"){const W=x?"true":"false";return this.value===W?S.INSTANCE:b.INSTANCE}return this}evaluate(x){return x.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(x){return x.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class A{static create(x,W=null){const le=y.get(x);return typeof le=="boolean"?le?S.INSTANCE:b.INSTANCE:new A(x,W)}constructor(x,W){this.key=x,this.negated=W,this.type=3}cmp(x){return x.type!==this.type?this.type-x.type:Y(this.key,x.key)}equals(x){return x.type===this.type?this.key===x.key:!1}substituteConstants(){const x=y.get(this.key);return typeof x=="boolean"?x?S.INSTANCE:b.INSTANCE:this}evaluate(x){return!x.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(x){return x.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=A;function B(ie,x){if(typeof ie=="string"){const W=parseFloat(ie);isNaN(W)||(ie=W)}return typeof ie=="string"||typeof ie=="number"?x(ie):S.INSTANCE}class H{static create(x,W,le=null){return B(W,we=>new H(x,we,le))}constructor(x,W,le){this.key=x,this.value=W,this.negated=le,this.type=12}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(x){return x.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class U{static create(x,W,le=null){return B(W,we=>new U(x,we,le))}constructor(x,W,le){this.key=x,this.value=W,this.negated=le,this.type=13}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(x){return x.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=U;class z{static create(x,W,le=null){return B(W,we=>new z(x,we,le))}constructor(x,W,le){this.key=x,this.value=W,this.negated=le,this.type=14}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(x){return x.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class M{static create(x,W,le=null){return B(W,we=>new M(x,we,le))}constructor(x,W,le){this.key=x,this.value=W,this.negated=le,this.type=15}cmp(x){return x.type!==this.type?this.type-x.type:ue(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(x){return x.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=M;class N{static create(x,W){return new N(x,W)}constructor(x,W){this.key=x,this.regexp=W,this.type=7,this.negated=null}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.key<x.key)return-1;if(this.key>x.key)return 1;const W=this.regexp?this.regexp.source:"",le=x.regexp?x.regexp.source:"";return W<le?-1:W>le?1:0}equals(x){if(x.type===this.type){const W=this.regexp?this.regexp.source:"",le=x.regexp?x.regexp.source:"";return this.key===x.key&&W===le}return!1}substituteConstants(){return this}evaluate(x){const W=x.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const x=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${x}`}keys(){return[this.key]}map(x){return x.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ee.create(this)),this.negated}}e.ContextKeyRegexExpr=N;class ee{static create(x){return new ee(x)}constructor(x){this._actual=x,this.type=8}cmp(x){return x.type!==this.type?this.type-x.type:this._actual.cmp(x._actual)}equals(x){return x.type===this.type?this._actual.equals(x._actual):!1}substituteConstants(){return this}evaluate(x){return!this._actual.evaluate(x)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(x){return new ee(this._actual.map(x))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ee;function Q(ie){let x=null;for(let W=0,le=ie.length;W<le;W++){const we=ie[W].substituteConstants();if(ie[W]!==we&&x===null){x=[];for(let Ee=0;Ee<W;Ee++)x[Ee]=ie[Ee]}x!==null&&(x[W]=we)}return x===null?ie:x}class Se{static create(x,W,le){return Se._normalizeArr(x,W,le)}constructor(x,W){this.expr=x,this.negated=W,this.type=6}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.expr.length<x.expr.length)return-1;if(this.expr.length>x.expr.length)return 1;for(let W=0,le=this.expr.length;W<le;W++){const we=o(this.expr[W],x.expr[W]);if(we!==0)return we}return 0}equals(x){if(x.type===this.type){if(this.expr.length!==x.expr.length)return!1;for(let W=0,le=this.expr.length;W<le;W++)if(!this.expr[W].equals(x.expr[W]))return!1;return!0}return!1}substituteConstants(){const x=Q(this.expr);return x===this.expr?this:Se.create(x,this.negated,!1)}evaluate(x){for(let W=0,le=this.expr.length;W<le;W++)if(!this.expr[W].evaluate(x))return!1;return!0}static _normalizeArr(x,W,le){const we=[];let Ee=!1;for(const me of x)if(me){if(me.type===1){Ee=!0;continue}if(me.type===0)return S.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&Ee)return b.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const De=we.pop(),re=we.length===0,de=ye.create(me.expr.map(se=>Se.create([se,De],null,le)),null,re);de&&(we.push(de),we.sort(o))}if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return S.INSTANCE;if(we.length===1)return we[0]}return new Se(we,W)}}serialize(){return this.expr.map(x=>x.serialize()).join(" && ")}keys(){const x=[];for(const W of this.expr)x.push(...W.keys());return x}map(x){return new Se(this.expr.map(W=>W.map(x)),null)}negate(){if(!this.negated){const x=[];for(const W of this.expr)x.push(W.negate());this.negated=ye.create(x,this,!0)}return this.negated}}e.ContextKeyAndExpr=Se;class ye{static create(x,W,le){return ye._normalizeArr(x,W,le)}constructor(x,W){this.expr=x,this.negated=W,this.type=9}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.expr.length<x.expr.length)return-1;if(this.expr.length>x.expr.length)return 1;for(let W=0,le=this.expr.length;W<le;W++){const we=o(this.expr[W],x.expr[W]);if(we!==0)return we}return 0}equals(x){if(x.type===this.type){if(this.expr.length!==x.expr.length)return!1;for(let W=0,le=this.expr.length;W<le;W++)if(!this.expr[W].equals(x.expr[W]))return!1;return!0}return!1}substituteConstants(){const x=Q(this.expr);return x===this.expr?this:ye.create(x,this.negated,!1)}evaluate(x){for(let W=0,le=this.expr.length;W<le;W++)if(this.expr[W].evaluate(x))return!0;return!1}static _normalizeArr(x,W,le){let we=[],Ee=!1;if(x){for(let me=0,De=x.length;me<De;me++){const re=x[me];if(re){if(re.type===0){Ee=!0;continue}if(re.type===1)return b.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&Ee)return S.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return b.INSTANCE;if(we.length===1)return we[0]}return new ye(we,W)}}serialize(){return this.expr.map(x=>x.serialize()).join(" || ")}keys(){const x=[];for(const W of this.expr)x.push(...W.keys());return x}map(x){return new ye(this.expr.map(W=>W.map(x)),null)}negate(){if(!this.negated){const x=[];for(const W of this.expr)x.push(W.negate());for(;x.length>1;){const W=x.shift(),le=x.shift(),we=[];for(const Ee of pe(W))for(const me of pe(le))we.push(Se.create([Ee,me],null,!1));x.unshift(ye.create(we,null,!1))}this.negated=ye.create(x,this,!0)}return this.negated}}e.ContextKeyOrExpr=ye;class Pe extends C{static{this._info=[]}static all(){return Pe._info.values()}constructor(x,W,le){super(x,null),this._defaultValue=W,typeof le=="object"?Pe._info.push({...le,key:x}):le!==!0&&Pe._info.push({key:x,description:le,type:W!=null?typeof W:void 0})}bindTo(x){return x.createKey(this.key,this._defaultValue)}getValue(x){return x.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(x){return I.create(this.key,x)}notEqualsTo(x){return u.create(this.key,x)}}e.RawContextKey=Pe,e.IContextKeyService=(0,F.createDecorator)("contextKeyService");function Y(ie,x){return ie<x?-1:ie>x?1:0}function ue(ie,x,W,le){return ie<W?-1:ie>W?1:x<le?-1:x>le?1:0}function _e(ie,x){if(ie.type===0||x.type===1)return!0;if(ie.type===9)return x.type===9?ce(ie.expr,x.expr):!1;if(x.type===9){for(const W of x.expr)if(_e(ie,W))return!0;return!1}if(ie.type===6){if(x.type===6)return ce(x.expr,ie.expr);for(const W of ie.expr)if(_e(W,x))return!0;return!1}return ie.equals(x)}e.implies=_e;function ce(ie,x){let W=0,le=0;for(;W<ie.length&&le<x.length;){const we=ie[W].cmp(x[le]);if(we<0)return!1;we===0&&W++,le++}return W===ie.length}function pe(ie){return ie.type===9?ie.expr:[ie]}}),define(Te[171],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Te[92],Ae([1,0,140,4]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function F(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function T(l,E){switch(l){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":E==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function d(l,E){return E==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=d;function y(l,E,D){return d(E,D)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===D?!0:m(D).includes(l)}e.isTargetPlatformCompatible=y;function m(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=P;var _;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(_||(e.SortBy=_={}));var a;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var f;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class n extends Error{constructor(E,D){super(E),this.code=D,this.name=D}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Te[38],Ae([1,0,48,19,15,16,2,142,4,22,13]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function _(Y){return Y.create===!0}e.isFileOpenForWriteOptions=_;var a;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var v;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var g;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function f(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=f;function t(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=t;function n(Y){return!!(Y.capabilities&131072)}e.hasFileCloneCapability=n;function l(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function E(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=E;function D(Y){return f(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;function p(Y){return f(Y)?!!(Y.capabilities&32768):!1}e.hasFileAtomicWriteCapability=p;function r(Y){return!!(Y.capabilities&65536)}e.hasFileAtomicDeleteCapability=r;function s(Y){return!!(Y.capabilities&2048)}e.hasReadonlyCapability=s;var i;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class o extends Error{static create(ue,_e){const ce=new o(ue.toString(),_e);return C(ce,_e),ce}constructor(ue,_e){super(ue),this.code=_e}}e.FileSystemProviderError=o;function S(Y,ue){return o.create(Y,ue)}e.createFileSystemProviderError=S;function b(Y){return Y||S((0,d.localize)(0,null),i.Unknown)}e.ensureFileSystemProviderError=b;function C(Y,ue){return Y.name=ue?`${ue} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=C;function I(Y){if(!Y)return i.Unknown;if(Y instanceof o)return Y.code;const ue=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!ue)return i.Unknown;switch(ue[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.toFileSystemProviderErrorCode=I;function c(Y){if(Y instanceof U)return Y.fileOperationResult;switch(I(Y)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=c;var h;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class u{constructor(ue,_e,ce){this.resource=ue,this.operation=_e,this.target=ce}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=u;var A;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class B{constructor(ue,_e){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const pe of ue){const ie=ce.get(pe.type);switch(ie?ie.push([pe.resource,pe]):ce.set(pe.type,[[pe.resource,pe]]),pe.type){case 1:this.rawAdded.push(pe.resource);break;case 0:this.rawUpdated.push(pe.resource);break;case 2:this.rawDeleted.push(pe.resource);break}}for(const[pe,ie]of ce)switch(pe){case 1:this.added=w.TernarySearchTree.forUris(()=>_e),this.added.fill(ie);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>_e),this.updated.fill(ie);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>_e),this.deleted.fill(ie);break}}contains(ue,..._e){return this.doContains(ue,{includeChildren:!1},..._e)}affects(ue,..._e){return this.doContains(ue,{includeChildren:!0},..._e)}doContains(ue,_e,...ce){if(!ue)return!1;const pe=ce.length>0;return!!((!pe||ce.includes(1))&&(this.added?.get(ue)||_e.includeChildren&&this.added?.findSuperstr(ue))||(!pe||ce.includes(0))&&(this.updated?.get(ue)||_e.includeChildren&&this.updated?.findSuperstr(ue))||(!pe||ce.includes(2))&&(this.deleted?.findSubstr(ue)||_e.includeChildren&&this.deleted?.findSuperstr(ue)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=B;function H(Y,ue,_e){return!Y||!ue||Y===ue||ue.length>Y.length?!1:(ue.charAt(ue.length-1)!==R.sep&&(ue+=R.sep),_e?(0,k.startsWithIgnoreCase)(Y,ue):Y.indexOf(ue)===0)}e.isParent=H;class U extends Error{constructor(ue,_e,ce){super(ue),this.fileOperationResult=_e,this.options=ce}}e.FileOperationError=U;class z extends U{constructor(ue,_e,ce,pe){super(ue,_e,pe),this.fileOperationResult=_e,this.size=ce}}e.TooLargeFileOperationError=z;class M extends U{constructor(ue,_e,ce){super(ue,2,ce),this.stat=_e}}e.NotModifiedSinceFileOperationError=M;var N;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ee;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.ETAG_DISABLED="";function Q(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=Q;async function Se(Y,ue){if(!ue.hasProvider(T.URI.from({scheme:Y.scheme})))return new Promise(_e=>{const ce=ue.onDidChangeFileSystemProviderRegistrations(pe=>{pe.scheme===Y.scheme&&pe.added&&(ce.dispose(),_e())})})}e.whenProviderRegistered=Se;class ye{static{this.KB=1024}static{this.MB=ye.KB*ye.KB}static{this.GB=ye.MB*ye.KB}static{this.TB=ye.GB*ye.KB}static formatSize(ue){return(0,F.isNumber)(ue)||(ue=0),ue<ye.KB?(0,d.localize)(1,null,ue.toFixed(0)):ue<ye.MB?(0,d.localize)(2,null,(ue/ye.KB).toFixed(2)):ue<ye.GB?(0,d.localize)(3,null,(ue/ye.MB).toFixed(2)):ue<ye.TB?(0,d.localize)(4,null,(ue/ye.GB).toFixed(2)):(0,d.localize)(5,null,(ue/ye.TB).toFixed(2))}}e.ByteSize=ye;function Pe(Y){const ue=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*ye.MB:ue?10*ye.MB:m.isWeb?50*ye.MB:1024*ye.MB}e.getLargeFileConfirmationLimit=Pe}),define(Te[72],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[F,T]of k)this.set(F,T)}set(k,F){const T=this._entries.get(k);return this._entries.set(k,F),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(Te[172],Ae([1,0,12,9,6,70,170,4,72,173]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class _ extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new y.ServiceCollection,n=!1,l,E=P){this._services=t,this._strict=n,this._parent=l,this._enableTracing=E,this._activeInstantiations=new Set,this._services.set(d.IInstantiationService,this),this._globalGraph=E?l?._globalGraph??new T.Graph(D=>D):void 0}createChild(t){return new a(t,this._strict,this,this._enableTracing)}invokeFunction(t,...n){const l=g.traceInvocation(this._enableTracing,t);let E=!1;try{return t({get:p=>{if(E)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(p,l);if(!r)throw new Error(`[invokeFunction] unknown service '${p}'`);return r}},...n)}finally{E=!0,l.stop()}}createInstance(t,...n){let l,E;return t instanceof F.SyncDescriptor?(l=g.traceCreation(this._enableTracing,t.ctor),E=this._createInstance(t.ctor,t.staticArguments.concat(n),l)):(l=g.traceCreation(this._enableTracing,t),E=this._createInstance(t,n,l)),l.stop(),E}_createInstance(t,n=[],l){const E=d._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),D=[];for(const r of E){const s=this._getOrCreateServiceInstance(r.id,l);s||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),D.push(s)}const p=E.length>0?E[0].index:n.length;if(n.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${n.length} static arguments`);const r=p-n.length;r>0?n=n.concat(new Array(r)):n=n.slice(0,p)}return Reflect.construct(t,n.concat(D))}_setServiceInstance(t,n){if(this._services.get(t)instanceof F.SyncDescriptor)this._services.set(t,n);else if(this._parent)this._parent._setServiceInstance(t,n);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const n=this._services.get(t);return!n&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):n}_getOrCreateServiceInstance(t,n){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const l=this._getServiceInstanceOrDescriptor(t);return l instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,l,n.branch(t,!0)):(n.branch(t,!1),l)}_safeCreateAndCacheServiceInstance(t,n,l){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,n,l)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,n,l){const E=new T.Graph(r=>r.id.toString());let D=0;const p=[{id:t,desc:n,_trace:l}];for(;p.length;){const r=p.pop();if(E.lookupOrInsertNode(r),D++>1e3)throw new _(E);for(const s of d._util.getServiceDependencies(r.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),i instanceof F.SyncDescriptor){const o={id:s.id,desc:i,_trace:r._trace.branch(s.id,!0)};E.insertEdge(r,o),p.push(o)}}}for(;;){const r=E.roots();if(r.length===0){if(!E.isEmpty())throw new _(E);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof F.SyncDescriptor){const o=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,o)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,n,l=[],E,D){if(this._services.get(t)instanceof F.SyncDescriptor)return this._createServiceInstance(t,n,l,E,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,n,l,E,D);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}_createServiceInstance(t,n,l=[],E,D){if(E){const p=new a(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(t);const r=new Map,s=new w.IdleValue(()=>{const i=p._createInstance(n,l,D);for(const[o,S]of r){const b=i[o];if(typeof b=="function")for(const C of S)b.apply(i,C)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let C=r.get(o);return C||(C=new m.LinkedList,r.set(o,C)),(c,h,u)=>{const A=C.push([c,h,u]);return(0,k.toDisposable)(A)}}if(o in i)return i[o];const S=s.value;let b=S[o];return typeof b!="function"||(b=b.bind(S),i[o]=b),b},set(i,o,S){return s.value[o]=S,!0},getPrototypeOf(i){return n.prototype}})}else return this._createInstance(n,l,D)}_throwIfStrict(t,n){if(n&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=a;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,n){return t?new g(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(t,n){return t?new g(1,n.name):g._None}static{this._totals=0}constructor(t,n){this.type=t,this.name=n,this._start=Date.now(),this._dep=[]}branch(t,n){const l=new g(3,t.toString());return this._dep.push([t,n,l]),l}stop(){const t=Date.now()-this._start;g._totals+=t;let n=!1;function l(D,p){const r=[],s=new Array(D+1).join("	");for(const[i,o,S]of p._dep)if(o&&S){n=!0,r.push(`${s}CREATES -> ${i}`);const b=l(D+1,S);b&&r.push(b)}else r.push(`${s}uses -> ${i}`);return r.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(t>2||n)&&g.all.add(E.join(`
`))}}e.Trace=g}),define(Te[14],Ae([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,a.createDecorator)("logService"),e.ILoggerService=(0,a.createDecorator)("loggerService");function v(){return new Date().toISOString()}function g(c){return(0,m.isNumber)(c)}e.isLogLevel=g;var f;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(f||(e.LogLevel=f={})),e.DEFAULT_LOG_LEVEL=f.Info;function t(c,h,u){switch(h){case f.Trace:c.trace(u);break;case f.Debug:c.debug(u);break;case f.Info:c.info(u);break;case f.Warning:c.warn(u);break;case f.Error:c.error(u);break;case f.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=t;function n(c,h=!1){let u="";for(let A=0;A<c.length;A++){let B=c[A];if(B instanceof Error&&(B=(0,w.toErrorMessage)(B,h)),typeof B=="object")try{B=JSON.stringify(B)}catch{}u+=(A>0?" ":"")+B}return u}class l extends F.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(h){this.level!==h&&(this.level=h,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(h){return this.level!==f.Off&&this.level<=h}}e.AbstractLogger=l;class E extends l{constructor(h){super(),this.logAlways=h}checkLogLevel(h){return this.logAlways||super.checkLogLevel(h)}trace(h,...u){this.checkLogLevel(f.Trace)&&this.log(f.Trace,n([h,...u],!0))}debug(h,...u){this.checkLogLevel(f.Debug)&&this.log(f.Debug,n([h,...u]))}info(h,...u){this.checkLogLevel(f.Info)&&this.log(f.Info,n([h,...u]))}warn(h,...u){this.checkLogLevel(f.Warning)&&this.log(f.Warning,n([h,...u]))}error(h,...u){if(this.checkLogLevel(f.Error))if(h instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=h.stack,this.log(f.Error,n(A))}else this.log(f.Error,n([h,...u]))}flush(){}}e.AbstractMessageLogger=E;class D extends l{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.useColors=!d.isWindows}trace(h,...u){this.checkLogLevel(f.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,h,...u):console.log(`[main ${v()}]`,h,...u))}debug(h,...u){this.checkLogLevel(f.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,h,...u):console.log(`[main ${v()}]`,h,...u))}info(h,...u){this.checkLogLevel(f.Info)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,h,...u):console.log(`[main ${v()}]`,h,...u))}warn(h,...u){this.checkLogLevel(f.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,h,...u):console.warn(`[main ${v()}]`,h,...u))}error(h,...u){this.checkLogLevel(f.Error)&&(this.useColors?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,h,...u):console.error(`[main ${v()}]`,h,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=D;class p extends l{constructor(h=e.DEFAULT_LOG_LEVEL,u=!0){super(),this.useColors=u,this.setLevel(h)}trace(h,...u){this.checkLogLevel(f.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",h,...u):console.log(h,...u))}debug(h,...u){this.checkLogLevel(f.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",h,...u):console.log(h,...u))}info(h,...u){this.checkLogLevel(f.Info)&&(this.useColors?console.log("%c INFO","color: #33f",h,...u):console.log(h,...u))}warn(h,...u){this.checkLogLevel(f.Warning)&&(this.useColors?console.log("%c WARN","color: #993",h,...u):console.log(h,...u))}error(h,...u){this.checkLogLevel(f.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",h,...u):console.error(h,...u))}dispose(){}flush(){}}e.ConsoleLogger=p;class r extends l{constructor(h,u=e.DEFAULT_LOG_LEVEL){super(),this.adapter=h,this.setLevel(u)}trace(h,...u){this.checkLogLevel(f.Trace)&&this.adapter.log(f.Trace,[this.extractMessage(h),...u])}debug(h,...u){this.checkLogLevel(f.Debug)&&this.adapter.log(f.Debug,[this.extractMessage(h),...u])}info(h,...u){this.checkLogLevel(f.Info)&&this.adapter.log(f.Info,[this.extractMessage(h),...u])}warn(h,...u){this.checkLogLevel(f.Warning)&&this.adapter.log(f.Warning,[this.extractMessage(h),...u])}error(h,...u){this.checkLogLevel(f.Error)&&this.adapter.log(f.Error,[this.extractMessage(h),...u])}extractMessage(h){return typeof h=="string"?h:(0,w.toErrorMessage)(h,this.checkLogLevel(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=r;class s extends l{constructor(h){super(),this.loggers=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const u of this.loggers)u.setLevel(h);super.setLevel(h)}trace(h,...u){for(const A of this.loggers)A.trace(h,...u)}debug(h,...u){for(const A of this.loggers)A.debug(h,...u)}info(h,...u){for(const A of this.loggers)A.info(h,...u)}warn(h,...u){for(const A of this.loggers)A.warn(h,...u)}error(h,...u){for(const A of this.loggers)A.error(h,...u)}flush(){for(const h of this.loggers)h.flush()}dispose(){for(const h of this.loggers)h.dispose()}}e.MultiplexLogger=s;class i extends F.Disposable{constructor(h,u,A){if(super(),this.logLevel=h,this.logsHome=u,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new R.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,A)for(const B of A)this._loggers.set(B.resource,{logger:void 0,info:B})}getLoggerEntry(h){return(0,m.isString)(h)?[...this._loggers.values()].find(u=>u.info.id===h):this._loggers.get(h)}getLogger(h){return this.getLoggerEntry(h)?.logger}createLogger(h,u){const A=this.toResource(h),B=(0,m.isString)(h)?h:u?.id??(0,k.hash)(A.toString()).toString(16);let H=this._loggers.get(A)?.logger;const U=u?.logLevel==="always"?f.Trace:u?.logLevel;H||(H=this.doCreateLogger(A,U??this.getLogLevel(A)??this.logLevel,{...u,id:B}));const z={logger:H,info:{resource:A,id:B,logLevel:U,name:u?.name,hidden:u?.hidden,extensionId:u?.extensionId,when:u?.when}};return this.registerLogger(z.info),this._loggers.set(A,z),H}toResource(h){return(0,m.isString)(h)?(0,y.joinPath)(this.logsHome,`${h}.log`):h}setLogLevel(h,u){if(P.URI.isUri(h)){const A=h,B=u,H=this._loggers.get(A);H&&B!==H.info.logLevel&&(H.info.logLevel=B===this.logLevel?void 0:B,H.logger?.setLevel(B),this._loggers.set(H.info.resource,H),this._onDidChangeLogLevel.fire([A,B]))}else{this.logLevel=h;for(const[A,B]of this._loggers.entries())this._loggers.get(A)?.info.logLevel===void 0&&B.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(h,u){const A=this.getLoggerEntry(h);A&&u!==!A.info.hidden&&(A.info.hidden=!u,this._loggers.set(A.info.resource,A),this._onDidChangeVisibility.fire([A.info.resource,u]))}getLogLevel(h){let u;return h&&(u=this._loggers.get(h)?.info.logLevel),u??this.logLevel}registerLogger(h){const u=this._loggers.get(h.resource);u?u.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this._loggers.set(h.resource,{info:h,logger:void 0}),this._onDidChangeLoggers.fire({added:[h],removed:[]}))}deregisterLogger(h){const u=this._loggers.get(h);u&&(u.logger&&u.logger.dispose(),this._loggers.delete(h),this._onDidChangeLoggers.fire({added:[],removed:[u.info]}))}*getRegisteredLoggers(){for(const h of this._loggers.values())yield h.info}getRegisteredLogger(h){return this._loggers.get(h)?.info}dispose(){this._loggers.forEach(h=>h.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class o{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(h){}getLevel(){return f.Info}trace(h,...u){}debug(h,...u){}info(h,...u){}warn(h,...u){}error(h,...u){}critical(h,...u){}dispose(){}flush(){}}e.NullLogger=o;class S extends o{}e.NullLogService=S;function b(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const h=I(c.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function C(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=C;function I(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new _.RawContextKey("logLevel",C(f.Info))}),define(Te[174],Ae([1,0,6,14]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends w.Disposable{constructor(T,d=[]){super(),this.logger=new R.MultiplexLogger([T,...d]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...d){this.logger.trace(T,...d)}debug(T,...d){this.logger.debug(T,...d)}info(T,...d){this.logger.info(T,...d)}warn(T,...d){this.logger.warn(T,...d)}error(T,...d){this.logger.error(T,...d)}flush(){this.logger.flush()}}e.LogService=k}),define(Te[94],Ae([1,0,29,143,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function m(g,f){return f-g}y.compare=m;const P=Object.create(null);P[y.Error]=(0,R.localize)(0,null),P[y.Warning]=(0,R.localize)(1,null),P[y.Info]=(0,R.localize)(2,null);function _(g){return P[g]||""}y.toString=_;function a(g){switch(g){case w.default.Error:return y.Error;case w.default.Warning:return y.Warning;case w.default.Info:return y.Info;case w.default.Ignore:return y.Hint}}y.fromSeverity=a;function v(g){switch(g){case y.Error:return w.default.Error;case y.Warning:return w.default.Warning;case y.Info:return w.default.Info;case y.Hint:return w.default.Ignore}}y.toSeverity=v}(T||(e.MarkerSeverity=T={}));var d;(function(y){const m="";function P(a){return _(a,!0)}y.makeKey=P;function _(a,v){const g=[m];return a.source?g.push(a.source.replace("\xA6","\\\xA6")):g.push(m),a.code?typeof a.code=="string"?g.push(a.code.replace("\xA6","\\\xA6")):g.push(a.code.value.replace("\xA6","\\\xA6")):g.push(m),a.severity!==void 0&&a.severity!==null?g.push(T.toString(a.severity)):g.push(m),a.message&&v?g.push(a.message.replace("\xA6","\\\xA6")):g.push(m),a.startLineNumber!==void 0&&a.startLineNumber!==null?g.push(a.startLineNumber.toString()):g.push(m),a.startColumn!==void 0&&a.startColumn!==null?g.push(a.startColumn.toString()):g.push(m),a.endLineNumber!==void 0&&a.endLineNumber!==null?g.push(a.endLineNumber.toString()):g.push(m),a.endColumn!==void 0&&a.endColumn!==null?g.push(a.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}y.makeKeyOptionalMessage=_})(d||(e.IMarkerData=d={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(Te[175],Ae([1,0,5,29,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,k.createDecorator)("notificationService");var F;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var d;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(d||(e.NotificationsFilter=d={}));class y{constructor(){this.progress=new m,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(_){}updateMessage(_){}updateActions(_){}close(){}}e.NoOpNotification=y;class m{infinite(){}done(){}total(_){}worked(_){}}e.NoOpProgress=m}),define(Te[95],Ae([1,0,15,2,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function F(m,P){return R.URI.isUri(m)?(0,w.equalsIgnoreCase)(m.scheme,P):(0,w.startsWithIgnoreCase)(m,P+":")}e.matchesScheme=F;function T(m,...P){return P.some(_=>F(m,_))}e.matchesSomeScheme=T;function d(m,P){return m.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.withSelection=d;function y(m){let P;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return _&&(P={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},m=m.with({fragment:""})),{selection:P,uri:m}}e.extractSelection=y}),define(Te[176],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(be,e,w,R){var k=arguments.length,F=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(be,e,w,R);else for(var d=be.length-1;d>=0;d--)(T=be[d])&&(F=(k<3?T(F):k>3?T(e,w,F):T(e,w))||F);return k>3&&F&&Object.defineProperty(e,w,F),F},We=this&&this.__param||function(be,e){return function(w,R){e(w,R,be)}};define(Te[50],Ae([1,0,12,21,6,4]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var T;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class d{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(_,a){this.callback=_,this.report=a?.async?this._reportAsync.bind(this):this._reportSync.bind(this)}_reportSync(_){this._value=_,this.callback(this._value)}_reportAsync(_){Promise.resolve(this._lastTask).finally(()=>{this._value=_;const a=this.callback(this._value);this._lastTask=Promise.resolve(a).finally(()=>this._lastTask=void 0)})}}e.Progress=d;let y=class extends k.Disposable{constructor(_,a){super(),this.deferred=new w.DeferredPromise,a.withProgress(_,v=>(this.reporter=v,this.lastStep&&v.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ve([We(1,e.IProgressService)],y);class m extends k.Disposable{constructor(_){super(),this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(_){this.stop();const a=++this.currentOperationId,v=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>v.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:v.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(Te[30],Ae([1,0,51,16]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,d){w.ok(R.isString(T)),w.ok(R.isObject(d)),w.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,d)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(Te[73],Ae([1,0,5,30]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(d){return d.length>0&&d.charAt(d.length-1)==="#"?d.substring(0,d.length-1):d}class F{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,m){this.schemasById[k(y)]=m,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new F;R.Registry.add(e.Extensions.JSONContribution,T)}),define(Te[96],Ae([1,0,18,5,16,137,43,73,30]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const _=y.Registry.as(d.Extensions.JSONContribution);class a{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const i=new Set;this.doRegisterConfigurations(r,s,i),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const s=new Set;this.doDeregisterConfigurations(r,s),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:r,remove:s}){const i=new Set;this.doDeregisterConfigurations(s,i),this.doRegisterConfigurations(r,!1,i),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(r){const s=new Set;this.doRegisterDefaultConfigurations(r,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(r,s){const i=[];for(const{overrides:o,source:S}of r)for(const b in o)if(s.add(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const C=this.configurationDefaultsOverrides.get(b),I=C?.valuesSources??new Map;if(S)for(const A of Object.keys(o[b]))I.set(A,S);const c={...C?.value||{},...o[b]};this.configurationDefaultsOverrides.set(b,{source:S,value:c,valuesSources:I});const h=(0,T.getLanguageTagSettingPlainKey)(b),u={type:"object",default:c,description:F.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:k.isString(S)?void 0:S,defaultValueSource:S};i.push(...f(b)),this.configurationProperties[b]=u,this.defaultLanguageConfigurationOverridesNode.properties[b]=u}else{this.configurationDefaultsOverrides.set(b,{value:o[b],source:S});const C=this.configurationProperties[b];C&&(this.updatePropertyDefaultValue(b,C),this.updateSchema(b,C))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(r){const s=new Set;this.doDeregisterDefaultConfigurations(r,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(r,s){for(const{overrides:i,source:o}of r)for(const S in i){const b=this.configurationDefaultsOverrides.get(S),C=k.isString(o)?o:o?.id,I=k.isString(b?.source)?b?.source:b?.source?.id;if(C===I)if(s.add(S),this.configurationDefaultsOverrides.delete(S),e.OVERRIDE_PROPERTY_REGEX.test(S))delete this.configurationProperties[S],delete this.defaultLanguageConfigurationOverridesNode.properties[S];else{const c=this.configurationProperties[S];c&&(this.updatePropertyDefaultValue(S,c),this.updateSchema(S,c))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(r){let s=!1;const i=new Set;r.removedDefaults&&(this.doDeregisterDefaultConfigurations(r.removedDefaults,i),s=!0),r.addedDefaults&&(this.doRegisterDefaultConfigurations(r.addedDefaults,i),s=!0),r.removedConfigurations&&this.doDeregisterConfigurations(r.removedConfigurations,i),r.addedConfigurations&&this.doRegisterConfigurations(r.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){this.doRegisterOverrideIdentifiers(r),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(r){for(const s of r)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,s,i){r.forEach(o=>{this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties,void 0,i),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(r,s){const i=o=>{if(o.properties)for(const S in o.properties){s.add(S);const b=this.configurationProperties[S];b?.policy?.name&&this.policyConfigurations.delete(b.policy.name),delete this.configurationProperties[S],this.removeFromSchema(S,o.properties[S])}o.allOf?.forEach(S=>i(S))};for(const o of r){i(o);const S=this.configurationContributors.indexOf(o);S!==-1&&this.configurationContributors.splice(S,1)}}validateAndRegisterProperties(r,s=!0,i,o,S=3,b){S=k.isUndefinedOrNull(r.scope)?S:r.scope;const C=r.properties;if(C)for(const c in C){const h=C[c];if(s&&E(c,h)){delete C[c];continue}if(h.source=i,h.defaultDefaultValue=C[c].default,this.updatePropertyDefaultValue(c,h),e.OVERRIDE_PROPERTY_REGEX.test(c)?h.scope=void 0:(h.scope=k.isUndefinedOrNull(h.scope)?S:h.scope,h.restricted=k.isUndefinedOrNull(h.restricted)?!!o?.includes(c):h.restricted),C[c].hasOwnProperty("included")&&!C[c].included){this.excludedConfigurationProperties[c]=C[c],delete C[c];continue}else this.configurationProperties[c]=C[c],C[c].policy?.name&&this.policyConfigurations.set(C[c].policy.name,c);!C[c].deprecationMessage&&C[c].markdownDeprecationMessage&&(C[c].deprecationMessage=C[c].markdownDeprecationMessage),b.add(c)}const I=r.allOf;if(I)for(const c of I)this.validateAndRegisterProperties(c,s,i,o,S,b)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const s=i=>{const o=i.properties;if(o)for(const b in o)this.updateSchema(b,o[b]);i.allOf?.forEach(s)};s(r)}updateSchema(r,s){switch(e.allSettings.properties[r]=s,s.scope){case 1:e.applicationSettings.properties[r]=s;break;case 2:e.machineSettings.properties[r]=s;break;case 6:e.machineOverridableSettings.properties[r]=s;break;case 3:e.windowSettings.properties[r]=s;break;case 4:e.resourceSettings.properties[r]=s;break;case 5:e.resourceSettings.properties[r]=s,this.resourceLanguageSettingsSchema.properties[r]=s;break}}removeFromSchema(r,s){switch(delete e.allSettings.properties[r],s.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const s=`[${r}]`,i={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}registerOverridePropertyPatternKey(){const r={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,s){const i=this.configurationDefaultsOverrides.get(r);let o=i?.value,S=i?.source;k.isUndefined(o)&&(o=s.defaultDefaultValue,S=void 0),k.isUndefined(o)&&(o=n(s.type)),s.default=o,s.defaultValueSource=S}}const v="\\[([^\\]]+)\\]",g=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(p){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=g.exec(p);for(;s?.length;){const i=s[1].trim();i&&r.push(i),s=g.exec(p)}}return(0,w.distinct)(r)}e.overrideIdentifiersFromKey=f;function t(p){return p.reduce((r,s)=>`${r}[${s}]`,"")}e.keyFromOverrideIdentifiers=t;function n(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=n;const l=new a;y.Registry.add(e.Extensions.Configuration,l);function E(p,r){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?F.localize(7,null,p):l.getConfigurationProperties()[p]!==void 0?F.localize(8,null,p):r.policy?.name&&l.getPolicyConfigurations().get(r.policy?.name)!==void 0?F.localize(9,null,p,r.policy?.name,l.getPolicyConfigurations().get(r.policy?.name)):null:F.localize(6,null)}e.validateProperty=E;function D(){const p=[],r=l.getConfigurationProperties();for(const s of Object.keys(r))p.push([s,r[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=D}),define(Te[177],Ae([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(s){return Object.isFrozen(s)?s:d.deepFreeze(s)}class g{constructor(i={},o=[],S=[],b){this._contents=i,this._keys=o,this._overrides=S,this.raw=b,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof g)return o;const S=new f("");return S.parseRaw(o),S.configurationModel});this._rawConfiguration=i.reduce((o,S)=>S===o?S:o.merge(S),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,o){const S=this.rawConfiguration.getValue(i),b=o?this.rawConfiguration.getOverrideValue(i,o):void 0,C=o?this.rawConfiguration.override(o).getValue(i):S;return{value:S,override:b,merged:C}}getOverrideValue(i,o){const S=this.getContentsForOverrideIdentifer(o);return S?i?(0,P.getConfigurationValue)(S,i):S:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const S of this.overrides)S.identifiers.includes(i)&&o.push(...S.keys);return w.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=d.deepClone(this.contents),S=d.deepClone(this.overrides),b=[...this.keys],C=this.raw?.length?[...this.raw]:[this];for(const I of i)if(C.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.mergeContents(o,I.contents);for(const c of I.overrides){const[h]=S.filter(u=>w.equals(u.identifiers,c.identifiers));h?(this.mergeContents(h.contents,c.contents),h.keys.push(...c.keys),h.keys=w.distinct(h.keys)):S.push(d.deepClone(c))}for(const c of I.keys)b.indexOf(c)===-1&&b.push(c)}return new g(o,b,S,C.every(I=>I instanceof g)?void 0:C)}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const S={};for(const b of w.distinct([...Object.keys(this.contents),...Object.keys(o)])){let C=this.contents[b];const I=o[b];I&&(typeof C=="object"&&typeof I=="object"?(C=d.deepClone(C),this.mergeContents(C,I)):C=I),S[b]=C}return new g(S,this.keys,this.overrides)}mergeContents(i,o){for(const S of Object.keys(o)){if(S in i&&y.isObject(i[S])&&y.isObject(o[S])){this.mergeContents(i[S],o[S]);continue}i[S]=d.deepClone(o[S])}}getContentsForOverrideIdentifer(i){let o=null,S=null;const b=C=>{C&&(S?this.mergeContents(S,C):S=d.deepClone(C))};for(const C of this.overrides)C.identifiers.length===1&&C.identifiers[0]===i?o=C.contents:C.identifiers.includes(i)&&b(C.contents);return b(o),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.updateValue(i,o,!0)}setValue(i,o){this.updateValue(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,P.removeFromValueTree)(this.contents,i),_.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(S=>w.equals(S.identifiers,(0,_.overrideIdentifiersFromKey)(i))),1))}updateValue(i,o,S){(0,P.addToValueTree)(this.contents,i,o,b=>console.error(b)),S=S||this.keys.indexOf(i)===-1,S&&this.keys.push(i),_.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,_.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],b=>console.error(b))})}}e.ConfigurationModel=g;class f{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!y.isUndefinedOrNull(i)){const S=this.doParseContent(i);this.parseRaw(S,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:S,keys:b,overrides:C,restricted:I,hasExcludedProperties:c}=this.doParseRaw(i,o);this._configurationModel=new g(S,b,C,c?[i]:void 0),this._restrictedConfigurations=I||[]}doParseContent(i){let o={},S=null,b=[];const C=[],I=[];function c(u){Array.isArray(b)?b.push(u):S!==null&&(b[S]=u)}const h={onObjectBegin:()=>{const u={};c(u),C.push(b),b=u,S=null},onObjectProperty:u=>{S=u},onObjectEnd:()=>{b=C.pop()},onArrayBegin:()=>{const u=[];c(u),C.push(b),b=u,S=null},onArrayEnd:()=>{b=C.pop()},onLiteralValue:c,onError:(u,A,B)=>{I.push({error:u,offset:A,length:B})}};if(i)try{k.visit(i,h),o=b[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return o}doParseRaw(i,o){const S=a.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),b=this.filter(i,S,!0,o);i=b.raw;const C=(0,P.toValuesTree)(i,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),I=Object.keys(i),c=this.toOverrides(i,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:C,keys:I,overrides:c,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}filter(i,o,S,b){let C=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:C};const I={},c=[];for(const h in i)if(_.OVERRIDE_PROPERTY_REGEX.test(h)&&S){const u=this.filter(i[h],o,!1,b);I[h]=u.raw,C=C||u.hasExcludedProperties,c.push(...u.restricted)}else{const u=o[h],A=u?typeof u.scope<"u"?u.scope:3:void 0;u?.restricted&&c.push(h),!b.exclude?.includes(h)&&(b.include?.includes(h)||(A===void 0||b.scopes===void 0||b.scopes.includes(A))&&!(b.skipRestricted&&u?.restricted))?I[h]=i[h]:C=!0}return{raw:I,restricted:c,hasExcludedProperties:C}}toOverrides(i,o){const S=[];for(const b of Object.keys(i))if(_.OVERRIDE_PROPERTY_REGEX.test(b)){const C={};for(const I in i[b])C[I]=i[b][I];S.push({identifiers:(0,_.overrideIdentifiersFromKey)(b),keys:Object.keys(C),contents:(0,P.toValuesTree)(C,o)})}return S}}e.ConfigurationModelParser=f;class t extends F.Disposable{constructor(i,o,S,b){super(),this.userSettingsResource=i,this.parseOptions=o,this.fileService=b,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this._register(this.fileService.watch(S.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,C=>C.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,C=>(C.isOperation(0)||C.isOperation(3)||C.isOperation(1)||C.isOperation(4))&&S.isEqual(C.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(i){return i&&(this.parseOptions=i),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class n{constructor(i,o,S,b,C,I,c,h,u,A,B,H,U){this.key=i,this.overrides=o,this._value=S,this.overrideIdentifiers=b,this.defaultConfiguration=C,this.policyConfiguration=I,this.applicationConfiguration=c,this.userConfiguration=h,this.localUserConfiguration=u,this.remoteUserConfiguration=A,this.workspaceConfiguration=B,this.folderConfigurationModel=H,this.memoryConfigurationModel=U}get value(){return v(this._value)}inspect(i,o,S){const b=i.inspect(o,S);return{get value(){return v(b.value)},get override(){return v(b.override)},get merged(){return v(b.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(i,o,S,b,C=new g,I=new g,c=new T.ResourceMap,h=new g,u=new T.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=S,this._localUserConfiguration=b,this._remoteUserConfiguration=C,this._workspaceConfiguration=I,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,o,S){return this.getConsolidatedConfigurationModel(i,o,S).getValue(i)}updateValue(i,o,S={}){let b;S.resource?(b=this._memoryConfigurationByResource.get(S.resource),b||(b=new g,this._memoryConfigurationByResource.set(S.resource,b))):b=this._memoryConfiguration,o===void 0?b.removeValue(i):b.setValue(i,o),S.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,S){const b=this.getConsolidatedConfigurationModel(i,o,S),C=this.getFolderConfigurationModelForResource(o.resource,S),I=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,c=new Set;for(const h of b.overrides)for(const u of h.identifiers)b.getOverrideValue(i,u)!==void 0&&c.add(u);return new n(i,o,b.getValue(i),c.size?[...c]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this._workspaceConfiguration:void 0,C||void 0,I)}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const S=[];if(!o){const{added:b,updated:C,removed:I}=p(this._defaultConfiguration,i);o=[...b,...C,...I]}for(const b of o)for(const C of(0,_.overrideIdentifiersFromKey)(b)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(C),c=i.getKeysForOverrideIdentifier(C),h=[...c.filter(u=>I.indexOf(u)===-1),...I.filter(u=>c.indexOf(u)===-1),...I.filter(u=>!d.equals(this._defaultConfiguration.override(C).getValue(u),i.override(C).getValue(u)))];S.push([C,h])}return this.updateDefaultConfiguration(i),{keys:o,overrides:S}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:S,removed:b}=p(this._policyConfiguration,i),C=[...o,...S,...b];return C.length&&this.updatePolicyConfiguration(i),{keys:C,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:S,removed:b,overrides:C}=p(this.applicationConfiguration,i),I=[...o,...S,...b];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:C}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:S,removed:b,overrides:C}=p(this.localUserConfiguration,i),I=[...o,...S,...b];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:C}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:S,removed:b,overrides:C}=p(this.remoteUserConfiguration,i),I=[...o,...S,...b];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:C}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:S,removed:b,overrides:C}=p(this.workspaceConfiguration,i),I=[...o,...S,...b];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:C}}compareAndUpdateFolderConfiguration(i,o){const S=this.folderConfigurations.get(i),{added:b,updated:C,removed:I,overrides:c}=p(S,o),h=[...b,...C,...I];return(h.length||!S)&&this.updateFolderConfiguration(i,o),{keys:h,overrides:c}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:S,updated:b,removed:C,overrides:I}=p(o,void 0);return{keys:[...S,...b,...C],overrides:I}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,S){let b=this.getConsolidatedConfigurationModelForResource(o,S);return o.overrideIdentifier&&(b=b.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(b=b.merge(this._policyConfiguration)),b}getConsolidatedConfigurationModelForResource({resource:i},o){let S=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const b=o.getFolder(i);b&&(S=this.getFolderConsolidatedConfiguration(b.uri)||S);const C=this._memoryConfigurationByResource.get(i);C&&(S=S.merge(C))}return S}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const S=this.getWorkspaceConsolidatedConfiguration(),b=this._folderConfigurations.get(i);b?(o=S.merge(b),this._foldersConsolidatedConfigurations.set(i,o)):o=S}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const S=o.getFolder(i);if(S)return this._folderConfigurations.get(S.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:S,overrides:b,keys:C}=this._folderConfigurations.get(o);return i.push([o,{contents:S,overrides:b,keys:C}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this._workspaceConfiguration.keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.keys.forEach(S=>i.add(S))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getAllOverrideIdentifiers().forEach(S=>i.add(S))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(S=>o.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(S=>o.add(S)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(S=>o.add(S)),this._folderConfigurations.forEach(S=>S.getKeysForOverrideIdentifier(i).forEach(b=>o.add(b))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),S=this.parseConfigurationModel(i.policy),b=this.parseConfigurationModel(i.application),C=this.parseConfigurationModel(i.user),I=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((h,u)=>(h.set(m.URI.revive(u[0]),this.parseConfigurationModel(u[1])),h),new T.ResourceMap);return new l(o,S,b,C,new g,I,c,new g,new T.ResourceMap)}static parseConfigurationModel(i){return new g(i.contents,i.keys,i.overrides)}}e.Configuration=l;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,o=new Map;for(const b of s)b.keys.forEach(C=>i.add(C)),b.overrides.forEach(([C,I])=>{const c=(0,T.getOrSet)(o,C,new Set);I.forEach(h=>c.add(h))});const S=[];return o.forEach((b,C)=>S.push([C,[...b.values()]])),{keys:[...i.values()],overrides:S}}e.mergeChanges=E;class D{constructor(i,o,S,b){this.change=i,this.previous=o,this.currentConfiguraiton=S,this.currentWorkspace=b,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const C of i.keys)this.affectedKeys.add(C);for(const[,C]of i.overrides)for(const I of C)this.affectedKeys.add(I);this._affectsConfigStr=this._marker;for(const C of this.affectedKeys)this._affectsConfigStr+=C+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){const S=this._marker+i,b=this._affectsConfigStr.indexOf(S);if(b<0)return!1;const C=b+S.length;if(C>=this._affectsConfigStr.length)return!1;const I=this._affectsConfigStr.charCodeAt(C);if(I!==this._markerCode1&&I!==this._markerCode2)return!1;if(o){const c=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!d.equals(c,h)}return!0}}e.ConfigurationChangeEvent=D;function p(s,i){const{added:o,removed:S,updated:b}=r(i?.rawConfiguration,s?.rawConfiguration),C=[],I=s?.getAllOverrideIdentifiers()||[],c=i?.getAllOverrideIdentifiers()||[];if(i){const h=c.filter(u=>!I.includes(u));for(const u of h)C.push([u,i.getKeysForOverrideIdentifier(u)])}if(s){const h=I.filter(u=>!c.includes(u));for(const u of h)C.push([u,s.getKeysForOverrideIdentifier(u)])}if(i&&s){for(const h of I)if(c.includes(h)){const u=r({contents:s.getOverrideValue(void 0,h)||{},keys:s.getKeysForOverrideIdentifier(h)},{contents:i.getOverrideValue(void 0,h)||{},keys:i.getKeysForOverrideIdentifier(h)});C.push([h,[...u.added,...u.removed,...u.updated]])}}return{added:o,removed:S,updated:b,overrides:C}}function r(s,i){const o=s?i?s.keys.filter(C=>i.keys.indexOf(C)===-1):[...s.keys]:[],S=i?s?i.keys.filter(C=>s.keys.indexOf(C)===-1):[...i.keys]:[],b=[];if(s&&i){for(const C of i.keys)if(s.keys.indexOf(C)!==-1){const I=(0,P.getConfigurationValue)(i.contents,C),c=(0,P.getConfigurationValue)(s.contents,C);d.equals(I,c)||b.push(C)}}return{added:o,removed:S,updated:b}}}),define(Te[97],Ae([1,0,9,4]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var k;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class F{constructor(_){this.id=_,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=F;class T{constructor(_,a){this.host=_,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var d;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(d||(e.RemoteAuthorityResolverErrorCode=d={}));class y extends w.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof y&&_._code===d.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof y&&_._code===d.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof y&&_._code===d.NoResolverFound}static isInvalidAuthority(_){return _ instanceof y&&_._code===d.InvalidAuthority}static isHandled(_){return _ instanceof y&&_.isHandled}constructor(_,a=d.Unknown,v){super(_),this._message=_,this._code=a,this._detail=v,this.isHandled=a===d.NotAvailable&&v===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function m(P){const _=P.indexOf("+");return _===-1?P:P.substring(0,_)}e.getRemoteAuthorityPrefix=m}),define(Te[52],Ae([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=R;function k(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=k;function F(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=F;function T(m){const{host:P,port:_}=y(m);if(typeof _>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:_}}e.parseAuthorityWithPort=T;function d(m,P){let{host:_,port:a}=y(m);return typeof a>"u"&&(a=P),{host:_,port:a}}e.parseAuthorityWithOptionalPort=d;function y(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const _=m.match(/^(\[[0-9a-z:]+\])$/);if(_)return{host:_[1],port:void 0};const a=m.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:m,port:void 0}}}),define(Te[20],Ae([1,0,15,4,52]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(T||(e.ExtensionType=T={}));var d;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.LINUX_PPC64LE="linux-ppc64le",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(d||(e.TargetPlatform=d={}));class y{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,n){if(typeof t>"u"||t===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof t=="string"||typeof n=="string"){const l=typeof t=="string"?t:t.value,E=typeof n=="string"?n:n.value;return w.equalsIgnoreCase(l,E)}return t._lower===n._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=y;class m{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const n of t)this.add(n)}add(t){this._set.add(y.toKey(t))}delete(t){return this._set.delete(y.toKey(t))}has(t){return this._set.has(y.toKey(t))}}e.ExtensionIdentifierSet=m;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(y.toKey(t))}get(t){return this._map.get(y.toKey(t))}has(t){return this._map.has(y.toKey(t))}set(t,n){this._map.set(y.toKey(t),n)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function _(f){return a(f)}e.isApplicationScopedExtension=_;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=a;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function g(f,t){if(t){const n=`onResolveRemoteAuthority:${(0,k.getRemoteName)(t)}`;return!!f.activationEvents?.includes(n)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Te[98],Ae([1,0,9,20]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,d){this._generators.set(T,d)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const d=Object.create(null);for(const y of T){const m=this.readActivationEvents(y);m.length>0&&(d[R.ExtensionIdentifier.toKey(y.identifier)]=m)}return d}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const d=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return d;for(const y in T.contributes){const m=this._generators.get(y);if(!m)continue;const P=T.contributes[y],_=Array.isArray(P)?P:[P];try{m(_,d)}catch(a){(0,w.onUnexpectedError)(a)}}return d}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Te[178],Ae([1,0,22,74,36]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function F(y){if(w.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,m,P,_,a,v,g,f){const t=Object.create(null);t["common.machineId"]=v,t.sessionID=(0,k.generateUuid)()+Date.now(),t.commitHash=_,t.version=a,t["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.PlatformToString)(w.platform),t["common.nodePlatform"]=R.platform,t["common.nodeArch"]=P,t["common.product"]=f||"desktop",g&&(t["common.msftInternal"]=g);let n=0;const l=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.isLinuxSnap&&(t["common.snap"]="true");const E=F(m);return E&&(t["common.platformDetail"]=E),t}e.resolveCommonProperties=T;function d(y){const m=R.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return y.some(_=>P===_)}e.verifyMicrosoftInternalDomain=d}),define(Te[179],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var k;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(Te[53],Ae([1,0,24,16,5,43,52,178,179]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(S){this.value=S,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class _{async publicLog(S,b,C){}async publicLogError(S,b,C){}}e.NullEndpointTelemetryService=_,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,S){return k.Event.debounce(S.onDidChangeConfiguration,(C,I)=>{const c=C?new Set([...C.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:c}},1e3,!0)(C=>{C.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(C.source),configurationKeys:Array.from(C.affectedKeys)})})}e.configurationTelemetry=a;function v(o,S){return!S.isBuilt&&!S.disableTelemetry?!0:!(S.disableTelemetry||!o.enableTelemetry)}e.supportsTelemetry=v;function g(o,S){return S.extensionTestsLocationURI?!0:!(S.isBuilt||S.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=g;function f(o){const S=o.getValue(y.TELEMETRY_SETTING_ID),b=o.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||b===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function t(o){const S={},b={},C={};E(o,C);for(let I in C){I=I.length>150?I.substr(I.length-149):I;const c=C[I];typeof c=="number"?b[I]=c:typeof c=="boolean"?b[I]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${c.length}`),S[I]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(S[I]=c)}return{properties:S,measurements:b}}e.validateTelemetryData=t;const n=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(o){if(!o)return"none";const S=(0,T.getRemoteName)(o);return n.has(S)?S:"other"}e.cleanRemoteAuthority=l;function E(o,S,b=0,C){if(o)for(const I of Object.getOwnPropertyNames(o)){const c=o[I],h=C?C+I:I;Array.isArray(c)?S[h]=(0,w.safeStringify)(c):c instanceof Date?S[h]=c.toISOString():(0,R.isObject)(c)?b<2?E(c,S,b+1,h+"."):S[h]=(0,w.safeStringify)(c):S[h]=c}}function D(o,S){const b=o.msftInternalDomains||[],C=S.getValue("telemetry.internalTesting");return(0,d.verifyMicrosoftInternalDomain)(b)||C}e.isInternalTelemetry=D;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=p;function r(o,S){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let b=o;const C=[];for(const u of S)for(;;){const A=u.exec(o);if(!A)break;C.push([A.index,u.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(b="";;){const u=c.exec(o);if(!u)break;const A=C.some(([B,H])=>u.index<H&&B<c.lastIndex);!I.test(u[0])&&!A&&(b+=o.substring(h,u.index)+"<REDACTED: user-file-path>",h=c.lastIndex)}return h<o.length&&(b+=o.substr(h)),b}function s(o){if(!o)return o;const S=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of S)if(b.regex.test(o))return`<REDACTED: ${b.label}>`;return o}function i(o,S){return(0,w.cloneAndChange)(o,b=>{if(b instanceof m||Object.hasOwnProperty.call(b,"isTrustedTelemetryValue"))return b.value;if(typeof b=="string"){let C=b.replaceAll("%20"," ");C=r(C,S);for(const I of S)C=C.replace(I,"");return C=s(C),C}})}e.cleanData=i}),define(Te[180],Ae([1,0,15,92,20,22,2,9,74,53]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,w.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=P;const _=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const S=o.manifest?o.manifest.version:o.version,b=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,S,b)}static parse(o){const S=_.exec(o);return S&&S[1]&&S[2]?new a({id:S[1]},S[2],S[4]||void 0):null}constructor(o,S,b="undefined"){this.version=S,this.targetPlatform=b,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=a;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(i){const o=v.exec(i);return o&&o[1]?[t(o[1]),o[2]]:[t(i),void 0]}e.getIdAndVersion=g;function f(i,o){return`${i}.${o}`}e.getExtensionId=f;function t(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=t;function n(i,o){return t(f(i??k.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=n;function l(i,o){const S=[],b=C=>{for(const I of S)if(I.some(c=>P(o(c),o(C))))return I;return null};for(const C of i){const I=b(C);I?I.push(C):S.push([C])}return S}e.groupByExtension=l;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function D(i){return{id:new m.TelemetryTrustedValue(i.identifier.id),name:new m.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function p(i,o){const S=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const C=b.shift();if(C&&S.every(I=>!P(I.identifier,{id:C}))){const I=i.filter(c=>P(c.identifier,{id:C}));I.length===1&&(S.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=p;async function r(i,o){if(!F.isLinux)return!1;let S;try{S=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{S=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(C){o.debug("Error while getting the os-release file.",(0,d.getErrorMessage)(C))}}return!!S&&(S.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,o){const S=await r(i,o),b=(0,R.getTargetPlatform)(S?"alpine":F.platform,y.arch);return o.debug("ComputeTargetPlatform:",b),b}e.computeTargetPlatform=s}),define(Te[181],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=w;function R(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=R;function k(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=k;function F(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=F;function T(y){return Array.from(y.entries()).map(m=>[m[0],w(m[1].map),R(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function d(y){return new Map(y.map(m=>[m[0],{map:k(m[1]),descriptionMap:F(m[2])}]))}e.deserializeEnvironmentVariableCollections=d}),define(Te[182],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,F,T=5){const d=F(y=>{const m=typeof y=="string"?y:y.data;let P=this._terminalBufferMap.get(k);if(P){P.data.push(m);return}const _=setTimeout(()=>this.flushBuffer(k),T);P={data:[m],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(k),d.dispose()}},this._terminalBufferMap.set(k,P)});return d}stopBuffering(k){this._terminalBufferMap.get(k)?.dispose()}flushBuffer(k){const F=this._terminalBufferMap.get(k);F&&(this._terminalBufferMap.delete(k),this._callback(k,F.data.join("")))}}e.TerminalDataBufferer=w}),define(Te[183],Ae([1,0,12,89,40,5,16,2,144,73,30]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var _;(function(D){function p(r,s){let i=r.defaults;for(;k.ThemeIcon.isThemeIcon(i);){const o=g.getIcon(i.id);if(!o)return;i=o.defaults}return i}D.getDefinition=p})(_||(e.IconContribution=_={}));var a;(function(D){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(i=>({format:i.format,location:i.location.toString()}))}}D.toJSONObject=p;function r(s){const i=o=>(0,T.isString)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,T.isString)(o.format)&&(0,T.isString)(o.location)))return{weight:i(s.weight),style:i(s.style),src:s.src.map(o=>({format:o.format,location:d.URI.parse(o.location)}))}}D.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class v{constructor(){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${k.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,r,s,i){const o=this.iconsById[p];if(o){if(s&&!o.description){o.description=s,this.iconSchema.properties[p].markdownDescription=`${s} $(${p})`;const C=this.iconReferenceSchema.enum.indexOf(p);C!==-1&&(this.iconReferenceSchema.enumDescriptions[C]=s),this._onDidChange.fire()}return o}const S={id:p,description:s,defaults:r,deprecationMessage:i};this.iconsById[p]=S;const b={$ref:"#/definitions/icons"};return i&&(b.deprecationMessage=i),s&&(b.markdownDescription=`${s}: $(${p})`),this.iconSchema.properties[p]=b,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const r=this.iconReferenceSchema.enum.indexOf(p);r!==-1&&(this.iconReferenceSchema.enum.splice(r,1),this.iconReferenceSchema.enumDescriptions.splice(r,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,r){const s=this.iconFontsById[p];return s||(this.iconFontsById[p]=r,this._onDidChange.fire(),r)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(o,S)=>o.id.localeCompare(S.id),r=o=>{for(;k.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of i.filter(S=>!!S.description).sort(p))s.push(`|<i class="${r(o)}"></i>|${o.id}|${k.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of i.filter(S=>!k.ThemeIcon.isThemeIcon(S.defaults)).sort(p))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const g=new v;P.Registry.add(e.Extensions.IconContribution,g);function f(D,p,r,s){return g.registerIcon(D,p,r,s)}e.registerIcon=f;function t(){return g}e.getIconRegistry=t;function n(){const D=(0,R.getCodiconFontCharacters)();for(const p in D){const r="\\"+D[p].toString(16);g.registerIcon(p,{fontCharacter:r})}}n(),e.iconsSchemaId="vscode://schemas/icons";const l=P.Registry.as(m.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,g.getIconSchema());const E=new w.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=f("widget-close",R.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",R.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",R.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=k.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=k.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(Te[184],Ae([1,0,5,43,4,14]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(t){t.Http="http",t.Https="https"})(T||(e.TunnelProtocol=T={}));var d;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(d||(e.TunnelPrivacyId=d={}));function y(t){return!!t.forwardPort}e.isTunnelProvider=y;var m;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function _(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=_,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=a;function v(t,n,l,E){if(l===1)return!1;if(l===2&&a(n)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(E);if(D?.length===4&&parseInt(D[1])>=18)return!1}return t<1024}e.isPortPrivileged=v;class g{constructor(n,l,E){this.remoteAddress=n,this.localAddress=l,this._dispose=E,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let f=class{constructor(n,l){this.logService=n,this.configurationService=l,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const n=this.configurationService.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],l=Array.from(this._tunnels.values());for(const E of l){const D=Array.from(E.values());for(const p of D){const r=await p.value;r&&typeof r!="string"&&n.push(r)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:l}of n.values())await l.then(E=>typeof E!="string"?E?.dispose():void 0);n.clear()}this._tunnels.clear()}setEnvironmentTunnel(n,l,E,D,p){this.addTunnelToMap(n,l,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:l,localAddress:E,privacy:D,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,l){(a(n)||_(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const E=this.getTunnelFromMap(n,l);if(E)return++E.refcount,E.value}openTunnel(n,l,E,D,p,r=!1,s,i){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${E} on local port ${p}.`);const o=this._tunnelProvider??n;if(!o)return;if(l||(l="localhost"),D||(D=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(E)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.retainOrCreateTunnel(o,l,E,D,p,r,s,i);return S?S.then(b=>{if(b){if(typeof b=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(l,E),b}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(l,E);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.makeTunnel(b);return(b.tunnelRemoteHost!==l||b.tunnelRemotePort!==E)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&b.privacy!==s&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(C),C}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const l=this._tunnels.get(n.tunnelRemoteHost);if(l){const E=l.get(n.tunnelRemotePort);E&&(E.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,E))}}}}async tryDisposeTunnel(n,l,E){if(E.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${l}.`);const D=E.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(l),D}}async closeTunnel(n,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${l} `);const E=this._tunnels.get(n);if(E&&E.has(l)){const D=E.get(l);D.refcount=0,await this.tryDisposeTunnel(n,l,D)}}addTunnelToMap(n,l,E){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(l,{refcount:1,value:E})}async removeEmptyOrErrorTunnelFromMap(n,l){const E=this._tunnels.get(n);if(E){const D=E.get(l),p=D?await D.value:void 0;(!p||typeof p=="string")&&E.delete(l),E.size===0&&this._tunnels.delete(n)}}getTunnelFromMap(n,l){const E=[n];_(n)?(E.push(...e.LOCALHOST_ADDRESSES),E.push(...e.ALL_INTERFACES_ADDRESSES)):a(n)&&E.push(...e.ALL_INTERFACES_ADDRESSES);const D=E.map(p=>this._tunnels.get(p));for(const p of D){const r=p?.get(l);if(r)return r}}canTunnel(n){return!!P(n)}createWithProvider(n,l,E,D,p,r,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${E} on local port ${D}.`);const i=E;this._factoryInProgress.add(i);const o=D===void 0?E:D,S={elevationRequired:p?this.isPortPrivileged(o):!1},b={remoteAddress:{host:l,port:E},localAddressPort:D,privacy:r,public:r?r!==d.Private:void 0,protocol:s},C=n.forwardPort(b,S);return C?(this.addTunnelToMap(l,E,C),C.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(i)})):this._factoryInProgress.delete(i),C}};e.AbstractTunnelService=f,e.AbstractTunnelService=f=Ve([We(0,F.ILogService),We(1,R.IConfigurationService)],f)}),define(Te[185],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,w.createDecorator)("editSessionIdentityService");var R;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Te[186],Ae([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(y){return y.scheme!==w.Schemas.file&&y.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=R;function k(y){if(y.folders.length)return y.folders.every(m=>R(m.uri))?y.folders[0].uri:void 0;if(y.configuration&&R(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=k;function F(y){return k(y)?.scheme}e.getVirtualWorkspaceScheme=F;function T(y){return k(y)?.authority}e.getVirtualWorkspaceAuthority=T;function d(y){return k(y)!==void 0}e.isVirtualWorkspace=d}),define(Te[54],Ae([1,0,145,19,48,23,2,4,13]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,d.createDecorator)("contextService");function m(o){const S=o;return typeof S?.id=="string"&&T.URI.isUri(S.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(o){return typeof o?.id=="string"&&!m(o)&&!a(o)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function _(o,S){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,R.basename)(o)}:S?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const b=o;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.toWorkspaceIdentifier=_;function a(o){const S=o;return typeof S?.id=="string"&&T.URI.isUri(S.configPath)}e.isWorkspaceIdentifier=a;function v(o){const S=o;if(S?.uri)return{id:S.id,uri:T.URI.revive(S.uri)};const b=o;if(b?.configPath)return{id:b.id,configPath:T.URI.revive(b.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=v;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function f(o){const S=o;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=f;function t(o){const S=o;return!!(S&&typeof S=="object"&&T.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=t;class n{constructor(S,b,C,I,c){this._id=S,this._transient=C,this._configuration=I,this._ignorePathCasing=c,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=b}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=n;class l{constructor(S,b){this.raw=b,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,F.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function E(o){return new l({uri:o,index:0,name:(0,F.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(o,S){return F.extUriBiasedIgnorePathCase.isEqualOrParent(o,S.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function p(o){let S;return T.URI.isUri(o)?S=o:S=o.configuration,S?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=r;function s(o,S){return!D(o,S)&&!p(o)}e.isSavedWorkspace=s;function i(o){return(typeof o=="string"?(0,R.extname)(o):(0,F.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Te[55],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{static{this.enableDebugLogging=!1}constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const F=this._idPool++;return this._data.set(F,k),this.logDebugInfo(),F}get(k,F){return this._data.has(k)?this._data.get(k)[F]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){w.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=w}),define(Te[39],Ae([1,0,13,23,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map,this.extUri=new R.ExtUri(d=>{const y=this._providerInfo.get(d.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(d,y){y===null?this._providerInfo.delete(d.scheme):this._providerInfo.set(d.scheme,y)}isFreeScheme(d){return!this._providerInfo.has(d)&&!this._systemSchemes.has(d)}getCapabilities(d){return this._providerInfo.get(d)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Te[27],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(Te[187],Ae([1,0,150,14,174,27]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends k.LogService{constructor(y,m,P){const _=P.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",a=P.remote.isRemote?(0,w.localize)(0,null):y?(0,w.localize)(1,null):(0,w.localize)(2,null);super(m.createLogger(_,{name:a}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=Ve([We(1,R.ILoggerService),We(2,F.IExtHostInitDataService)],T)}),define(Te[188],Ae([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(T,d,y){this._deferredPromises=new Map,this._id=T,this._shared=d,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(m=>(this._value=m,this)),this._storageListener=this._storage.onDidChangeStorage(m=>{m.shared===this._shared&&m.key===this._id&&(this._value=m.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const m=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of m.values())P.complete()}catch(P){for(const _ of m.values())_.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,d){let y=this._value[T];return typeof y>"u"&&(y=d),y}update(T,d){this._value[T]=d;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const m=new w.DeferredPromise;return this._deferredPromises.set(T,m),this._scheduler.isScheduled()||this._scheduler.schedule(),m.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,d){super(T.identifier.value,!0,d),this._extension=T}}e.ExtensionGlobalMemento=k}),define(Te[189],Ae([1,0,5,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new w.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new w.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,d,y,m){const _=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(T)).acceptModelChanged(d.value,y,m);this._onDidChangeNotebookDocument.fire(_)}$acceptDirtyStateChanged(T,d){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(T)).acceptDirty(d)}$acceptModelSaved(T){const d=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(T));this._onDidSaveNotebookDocument.fire(d.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(Te[17],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class R{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=R}),define(Te[190],Ae([1,0,20,5]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{#e;constructor(T,d){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(T.identifier),this.#e=d,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(T){return this.#e.get(this._id,T)}store(T,d){return this.#e.store(this._id,T,d)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=k}),define(Te[56],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class R{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=R}),define(Te[191],Ae([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let m=this.buffers.indexOf(y);return m<0&&(m=this.buffers.length,this.buffers.push(y)),m}}function k(d,y){if(y.serializeBuffersForPostMessage){const m=new R,_=JSON.stringify(d,(v,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(g)};if(ArrayBuffer.isView(g)){const f=F(g);if(f)return{$$vscode_array_buffer_reference$$:!0,index:m.add(g.buffer),view:{type:f,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),a=m.buffers.map(v=>{const g=new Uint8Array(v);return w.VSBuffer.wrap(g)});return{message:_,buffers:a}}else return{message:JSON.stringify(d),buffers:[]}}e.serializeWebviewMessage=k;function F(d){switch(d.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(d,y){const m=y.map(a=>{const v=new ArrayBuffer(a.byteLength);return new Uint8Array(v).set(a.buffer),v}),P=y.length?(a,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const g=v,{index:f}=g,t=m[f];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse(d,P),arrayBuffers:m}}e.deserializeWebviewMessage=T}),define(Te[99],Ae([1,0,159,16,2,6,4,30,38,13,41,127,29]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var g;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function f(ce){const pe=ce;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.isEditorPaneWithSelection=f;function t(ce,pe,ie){for(const x of ie.visibleEditorPanes)if(x.group.id===pe&&ce.matches(x.input))return x.getViewState()}e.findViewStateForEditor=t;function n(ce){if(b(ce))return!1;const pe=ce;return k.URI.isUri(pe?.resource)}e.isResourceEditorInput=n;function l(ce){if(b(ce))return!1;const pe=ce;return pe?.original!==void 0&&pe.modified!==void 0}e.isResourceDiffEditorInput=l;function E(ce){if(b(ce)||l(ce))return!1;const pe=ce;return pe?.primary!==void 0&&pe.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function D(ce){if(b(ce))return!1;const pe=ce;return pe?pe.resource===void 0||pe.resource.scheme===m.Schemas.untitled||pe.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;function p(ce){if(b(ce))return!1;const pe=ce;return k.URI.isUri(pe?.base?.resource)&&k.URI.isUri(pe?.input1?.resource)&&k.URI.isUri(pe?.input2?.resource)&&k.URI.isUri(pe?.result?.resource)}e.isResourceMergeEditorInput=p;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class i{constructor(){this.mapIdToSaveSource=new Map}registerSource(pe,ie){let x=this.mapIdToSaveSource.get(pe);return x||(x={source:pe,label:ie},this.mapIdToSaveSource.set(pe,x)),x.source}getSourceLabel(pe){return this.mapIdToSaveSource.get(pe)?.label??pe}}e.SaveSourceRegistry=new i;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class S extends F.Disposable{}e.AbstractEditorInput=S;function b(ce){return ce instanceof S}e.isEditorInput=b;function C(ce){const pe=ce;return k.URI.isUri(pe?.preferredResource)}function I(ce){const pe=ce;return b(pe?.primary)&&b(pe?.secondary)}e.isSideBySideEditorInput=I;function c(ce){const pe=ce;return b(pe?.modified)&&b(pe?.original)}e.isDiffEditorInput=c;function h(ce,pe,ie,x,W){return _e(x,[(0,_.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor(pe,le)}}),(0,_.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>W.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.createTooLargeFileError=h;function u(ce){return b(ce?.editor)}e.isEditorInputWithOptions=u;function A(ce){const pe=ce;return u(ce)&&pe?.group!==void 0}e.isEditorInputWithOptionsAndGroup=A;function B(ce){const pe=ce;return typeof pe?.groupId=="number"&&b(pe.editor)}e.isEditorIdentifier=B;var H;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var z;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class M{getOriginalUri(pe,ie){if(!pe)return;if(p(pe))return e.EditorResourceAccessor.getOriginalUri(pe.result,ie);if(ie?.supportSideBySide){const{primary:W,secondary:le}=this.getSideEditors(pe);if(W&&le){if(ie?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===z.ANY)return this.getOriginalUri(W,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});pe=ie.supportSideBySide===z.PRIMARY?W:le}}if(l(pe)||E(pe)||p(pe))return;const x=C(pe)?pe.preferredResource:pe.resource;return!x||!ie||!ie.filterByScheme?x:this.filterUri(x,ie.filterByScheme)}getSideEditors(pe){return I(pe)||E(pe)?{primary:pe.primary,secondary:pe.secondary}:c(pe)||l(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,ie){if(!pe)return;if(p(pe))return e.EditorResourceAccessor.getCanonicalUri(pe.result,ie);if(ie?.supportSideBySide){const{primary:W,secondary:le}=this.getSideEditors(pe);if(W&&le){if(ie?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===z.ANY)return this.getCanonicalUri(W,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});pe=ie.supportSideBySide===z.PRIMARY?W:le}}if(l(pe)||E(pe)||p(pe))return;const x=pe.resource;return!x||!ie||!ie.filterByScheme?x:this.filterUri(x,ie.filterByScheme)}filterUri(pe,ie){if(Array.isArray(ie)){if(ie.some(x=>pe.scheme===x))return pe}else if(ie===pe.scheme)return pe}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ee(ce,pe,ie,x){if(!ce.isSticky(pe))return!1;switch(x.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.preventEditorClose=ee,e.EditorResourceAccessor=new M;var Q;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class Se{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(pe){const ie=this.instantiationService=pe.get(T.IInstantiationService);for(const[x,W]of this.editorSerializerConstructors)this.createEditorSerializer(x,W,ie);this.editorSerializerConstructors.clear()}createEditorSerializer(pe,ie,x){const W=x.createInstance(ie);this.editorSerializerInstances.set(pe,W)}registerFileEditorFactory(pe){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=pe}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(pe,ie){if(this.editorSerializerConstructors.has(pe)||this.editorSerializerInstances.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.instantiationService?this.createEditorSerializer(pe,ie,this.instantiationService):this.editorSerializerConstructors.set(pe,ie),(0,F.toDisposable)(()=>{this.editorSerializerConstructors.delete(pe),this.editorSerializerInstances.delete(pe)})}getEditorSerializer(pe){return this.editorSerializerInstances.get(typeof pe=="string"?pe:pe.typeId)}}d.Registry.add(e.EditorExtensions.EditorFactory,new Se);async function ye(ce,pe,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async x=>{const W=k.URI.revive(x.fileUri);if(!W){ie.info("Cannot resolve the path because it is not valid.",x);return}if(!await pe.canHandleResource(W)){ie.info("Cannot resolve the path because it cannot be handled",x);return}let we=x.exists,Ee=x.type;if(typeof we!="boolean"||typeof Ee!="number")try{Ee=(await pe.stat(W)).isDirectory?y.FileType.Directory:y.FileType.Unknown,we=!0}catch(De){ie.error(De),we=!1}if(!we&&x.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",x);return}if(Ee===y.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",x);return}const me={...x.options,pinned:!0};return we?{resource:W,options:me}:{resource:W,options:me,forceUntitled:!0}}))}e.pathsToEditors=ye;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Y(ce){const pe=ce;if(!pe)return!1;const ie=pe;if(ie.modified)return Y(ie.modified);const x=pe;return!!(x.contributionsState&&x.viewState&&Array.isArray(x.cursorState))}e.isTextEditorViewState=Y;function ue(ce){return(0,P.isErrorWithActions)(ce)}e.isEditorOpenError=ue;function _e(ce,pe,ie){const x=(0,P.createErrorWithActions)(ce,pe);return x.forceMessage=ie?.forceMessage,x.forceSeverity=ie?.forceSeverity,x.allowDialog=ie?.allowDialog,x}e.createEditorOpenError=_e}),define(Te[192],Ae([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,_.registerIcon)("default-view-icon",P.Codicon.window,(0,R.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.ViewContainerLocations=[0,1,2];function g(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=g;class f extends F.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(i,o,S){const b=this.get(i.id);if(b)return b;const C=i;return C.openCommandActionDescriptor=S?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,T.getOrSet)(this.viewContainers,o,[]).push(C),S?.isDefault&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:o}),C}deregisterViewContainer(i){for(const o of this.viewContainers.keys()){const S=this.viewContainers.get(o),b=S?.indexOf(i);if(b!==-1){S?.splice(b,1),S.length===0&&this.viewContainers.delete(o),this._onDidDeregister.fire({viewContainer:i,viewContainerLocation:o});return}}}get(i){return this.all.filter(o=>o.id===i)[0]}getViewContainers(i){return[...this.viewContainers.get(i)||[]]}getViewContainerLocation(i){return[...this.viewContainers.keys()].filter(o=>this.getViewContainers(o).filter(S=>S?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.defaultViewContainers.find(o=>this.getViewContainerLocation(o)===i)}}d.Registry.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function n(s,i){const o=s.group??t.More,S=i.group??t.More;return o!==S?o.localeCompare(S):(s.order??5)-(i.order??5)}class l extends F.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(i,o){this.registerViews2([{views:i,viewContainer:o}])}registerViews2(i){i.forEach(({views:o,viewContainer:S})=>this.addViews(o,S)),this._onViewsRegistered.fire(i)}deregisterViews(i,o){const S=this.removeViews(i,o);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:o})}moveViews(i,o){for(const S of this._views.keys())if(S!==o){const b=this.removeViews(i,S);b.length&&(this.addViews(b,o),this._onDidChangeContainer.fire({views:b,from:S,to:o}))}}getViews(i){return this._views.get(i)||[]}getView(i){for(const o of this._viewContainers){const S=(this._views.get(o)||[]).filter(b=>b.id===i)[0];if(S)return S}return null}getViewContainer(i){for(const o of this._viewContainers)if((this._views.get(o)||[]).filter(b=>b.id===i)[0])return o;return null}registerViewWelcomeContent(i,o){return this._viewWelcomeContents.add(i,o),this._onDidChangeViewWelcomeContent.fire(i),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(i,o),this._onDidChangeViewWelcomeContent.fire(i)})}registerViewWelcomeContent2(i,o){const S=new Map;for(const[b,C]of o)this._viewWelcomeContents.add(i,C),S.set(b,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(i,C),this._onDidChangeViewWelcomeContent.fire(i)}));return this._onDidChangeViewWelcomeContent.fire(i),S}getViewWelcomeContent(i){const o=[];return this._viewWelcomeContents.forEach(i,S=>o.push(S)),o.sort(n)}addViews(i,o){let S=this._views.get(o);S||(S=[],this._views.set(o,S),this._viewContainers.push(o));for(const b of i){if(this.getView(b.id)!==null)throw new Error((0,R.localize)(1,null,b.id));S.push(b)}}removeViews(i,o){const S=this._views.get(o);if(!S)return[];const b=[],C=[];for(const I of S)i.includes(I)?b.push(I):C.push(I);return b.length&&(C.length?this._views.set(o,C):(this._views.delete(o),this._viewContainers.splice(this._viewContainers.indexOf(o),1))),b}}d.Registry.add(a.ViewsRegistry,new l),e.IViewsService=(0,k.createDecorator)("viewsService"),e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var E;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(E||(e.ViewVisibilityState=E={}));var D;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(D||(e.TreeItemCollapsibleState=D={}));class p{constructor(i,o){this.resolved=!1,this._hasResolve=!1,(0,m.mixin)(this,i),this._hasResolve=!!o,this.resolve=async S=>{if(o&&!this.resolved){const b=await o(S);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=p;class r extends Error{constructor(i){super((0,R.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.NoTreeViewError=r}),define(Te[193],Ae([1,0,5,12,161]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(d){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=d}onEvent(d){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=d}onRequest(d){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=d}sendResponse(d){d.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${d.command}`)):this.internalSend("response",d)}sendRequest(d,y,m,P){const _={command:d};if(y&&Object.keys(y).length>0&&(_.arguments=y),this.internalSend("request",_),typeof P=="number"){const a=setTimeout(()=>{clearTimeout(a);const v=this.pendingRequests.get(_.seq);if(v){this.pendingRequests.delete(_.seq);const g={type:"response",seq:0,request_seq:_.seq,success:!1,command:d,message:(0,k.localize)(0,null,P,d)};v(g)}},P)}return m&&this.pendingRequests.set(_.seq,m),_.seq}acceptMessage(d){this.messageCallback?this.messageCallback(d):(this.queue.push(d),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(d,y){return d.type!=="event"||y.type!=="event"}async processQueue(){let d;for(;this.queue.length;){if((!d||this.needsTaskBoundaryBetween(this.queue[0],d))&&await(0,R.timeout)(0),d=this.queue.shift(),!d)return;switch(d.type){case"event":this.eventCallback?.(d);break;case"request":this.requestCallback?.(d);break;case"response":{const y=d,m=this.pendingRequests.get(y.request_seq);m&&(this.pendingRequests.delete(y.request_seq),m(y));break}}}}internalSend(d,y){y.type=d,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const d=new Map;this.pendingRequests.forEach((y,m)=>d.set(m,y)),await(0,R.timeout)(500),d.forEach((y,m)=>{y({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(m)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=F}),define(Te[194],Ae([1,0,162,32,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:w.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=a=>w.localize(51,null,a);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var T;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(T||(e.State=T={}));function d(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=d;var y;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var P;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.IDebugService=(0,k.createDecorator)("debugService");var _;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(_||(e.BreakpointWidgetContext=_={}))}),define(Te[195],Ae([1,0,15,2,19,24,13,44,21,18]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function _(I,c,h){return I.replace(P,function(u,A){return c&&A.length>0&&A[0]!=="_"?u:h&&h.hasOwnProperty(A)?h[A]:u})}e.formatPII=_;function a(I){const c={};for(const h of Object.keys(I))h.startsWith("!")||(c[h]=I[h]);return c}e.filterExceptionsFromTelemetry=a;function v(I){return I.configuration.request==="attach"&&!g(I)&&(!I.parentSession||v(I.parentSession))}e.isSessionAttach=v;function g(I){let c=I.configuration.type;if(c)return c==="vslsShare"&&(c=I.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(c,"extensionhost")||(0,w.equalsIgnoreCase)(c,"pwa-extensionhost")?I:I.parentSession?g(I.parentSession):void 0}e.getExtensionHostDebugSession=g;function f(I){return I.type&&(I.label||I.program||I.runtime)}e.isDebuggerMainContribution=f;function t(I,c,h){let u,A=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=B.exec(I);){const U=H.index+1,z=U+H[0].length;if(U<=c&&z>=h){u=H[0],A=U;break}}if(u){const U=/\w+/g;let z=null;for(;(z=U.exec(u))&&!(z.index+1+A+z[0].length>=h););z&&(u=u.substring(0,U.lastIndex))}return u?{start:A,end:A+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function n(I,c,h,u){if(I.evaluatableExpressionProvider.has(c)){const A=I.evaluatableExpressionProvider.ordered(c),B=(0,m.coalesce)(await Promise.all(A.map(async H=>{try{return await H.provideEvaluatableExpression(c,h,u??y.CancellationToken.None)}catch{return}})));if(B.length>0){let H=B[0].expression;const U=B[0].range;return H||(H=c.getLineContent(h.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:H}}}else{const A=c.getLineContent(h.lineNumber),{start:B,end:H}=t(A,h.column,h.column),U=A.substring(B-1,H);return{matchingExpression:U,range:new d.Range(h.lineNumber,B,h.lineNumber,B+U.length)}}return null}e.getEvaluatableExpressionAtPosition=n;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function E(I){return!!(I&&I.match(l))}e.isUri=E;function D(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(E(I.path))return R.URI.parse(I.path);if((0,k.isAbsolute)(I.path))return R.URI.file(I.path)}return I.path}function p(I){if(typeof I.path=="object"){const c=R.URI.revive(I.path);if(c)return c.scheme===T.Schemas.file?c.fsPath:c.toString()}return I.path}function r(I,c){const h=c?D:p,u=(0,F.deepClone)(I);return i(u,(A,B)=>{A&&B&&(B.path=h(B))}),u}e.convertToDAPaths=r;function s(I,c){const h=c?D:p,u=(0,F.deepClone)(I);return i(u,(A,B)=>{!A&&B&&(B.path=h(B))}),u}e.convertToVSCPaths=s;function i(I,c){switch(I.type){case"event":{const h=I;switch(h.event){case"output":c(!1,h.body.source);break;case"loadedSource":c(!1,h.body.source);break;case"breakpoint":c(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=I;switch(h.command){case"setBreakpoints":c(!0,h.arguments.source);break;case"breakpointLocations":c(!0,h.arguments.source);break;case"source":c(!0,h.arguments.source);break;case"gotoTargets":c(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(u=>c(!1,u));break;default:break}break}case"response":{const h=I;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(u=>c(!1,u.source));break;case"loadedSources":h.body.sources.forEach(u=>c(!1,u));break;case"scopes":h.body.scopes.forEach(u=>c(!1,u.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(u=>c(!1,u.source));break;case"setBreakpoints":h.body.breakpoints.forEach(u=>c(!1,u.source));break;case"disassemble":h.body?.instructions.forEach(A=>c(!1,A.location));break;default:break}break}}}function o(I){return I.filter(c=>!c.presentation?.hidden).sort((c,h)=>c.presentation?h.presentation?c.presentation.group?h.presentation.group?c.presentation.group!==h.presentation.group?c.presentation.group.localeCompare(h.presentation.group):S(c.presentation.order,h.presentation.order):-1:h.presentation.group?1:S(c.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=o;function S(I,c){return typeof I!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:I-c}async function b(I,c){const h=I.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(h!=="none"&&(await c.saveAll(),h==="allEditorsInActiveGroup")){const u=c.activeEditorPane;u&&u.input.resource?.scheme===T.Schemas.untitled&&await c.save({editor:u.input,groupId:u.group.id})}await I.reloadConfiguration()}e.saveAllBeforeDebugStart=b;const C=(I,c)=>!I||!c?I===c:I.name===c.name&&I.path===c.path&&I.sourceReference===c.sourceReference;e.sourcesEqual=C}),define(Te[75],Ae([1,0,25,37,67,68,13,19,22,32]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var _;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(_||(e.NotebookRunState=_={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var v;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var g;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var l;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(l||(e.CellEditType=l={}));var E;(function(N){N.scheme=T.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${ee.join("")}]+`),Se=7;function ye(pe,ie){const x=ie.toString(Se),le=`${x.length<ee.length?ee[x.length-1]:"z"}${x}s${(0,w.encodeBase64)(w.VSBuffer.fromString(pe.scheme),!0,!0)}`;return pe.with({scheme:N.scheme,fragment:le})}N.generate=ye;function Pe(pe){if(pe.scheme!==N.scheme)return;const ie=pe.fragment.indexOf("s");if(ie<0)return;const x=parseInt(pe.fragment.substring(0,ie).replace(Q,""),Se),W=(0,w.decodeBase64)(pe.fragment.substring(ie+1)).toString();if(!isNaN(x))return{handle:x,notebook:pe.with({scheme:W,fragment:null})}}N.parse=Pe;function Y(pe,ie){return pe.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${pe.scheme!==T.Schemas.file?pe.scheme:""}`})}N.generateCellOutputUri=Y;function ue(pe){if(pe.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!ie)return;const x=ie[1]&&ie[1]!==""?ie[1]:void 0,W=ie[2];return{outputId:x,notebook:pe.with({scheme:W||T.Schemas.file,fragment:null})}}N.parseCellOutputUri=ue;function _e(pe,ie,x){return N.generate(pe,ie).with({scheme:x})}N.generateCellPropertyUri=_e;function ce(pe,ie){if(pe.scheme===ie)return N.parse(pe.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(E||(e.CellUri=E={}));const D=N=>y.isWindows?N.replace(/\//g,"\\"):N;class p{constructor(ee=[],Q=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Q,this.order=[...new Set(ee)].map(Se=>({pattern:Se,matches:R.parse(D(Se))}))}sort(ee){const Q=new Map(k.Iterable.map(ee,ye=>[ye,D(ye)]));let Se=[];for(const{matches:ye}of this.order)for(const[Pe,Y]of Q)if(ye(Y)){Se.push(Pe),Q.delete(Pe);break}return Q.size&&(Se=Se.concat([...Q.keys()].sort((ye,Pe)=>this.defaultOrder.indexOf(ye)-this.defaultOrder.indexOf(Pe)))),Se}prioritize(ee,Q){const Se=this.findIndex(ee);if(Se===-1){this.order.unshift({pattern:ee,matches:R.parse(D(ee))});return}const ye=new Set(Q.map(Y=>this.findIndex(Y,Se)));ye.delete(-1);const Pe=Array.from(ye).sort();this.order.splice(Se+1,0,...Pe.map(Y=>this.order[Y]));for(let Y=Pe.length-1;Y>=0;Y--)this.order.splice(Pe[Y],1)}toArray(){return this.order.map(ee=>ee.pattern)}findIndex(ee,Q=this.order.length){const Se=D(ee);for(let ye=0;ye<Q;ye++)if(this.order[ye].matches(Se))return ye;return-1}}e.MimeTypeDisplayOrder=p;function r(N,ee,Q,Se=(ye,Pe)=>ye===Pe){const ye=[];function Pe(_e,ce,pe){if(ce===0&&pe.length===0)return;const ie=ye[ye.length-1];ie&&ie.start+ie.deleteCount===_e?(ie.deleteCount+=ce,ie.toInsert.push(...pe)):ye.push({start:_e,deleteCount:ce,toInsert:pe})}let Y=0,ue=0;for(;;){if(Y===N.length){Pe(Y,0,ee.slice(ue));break}if(ue===ee.length){Pe(Y,N.length-Y,[]);break}const _e=N[Y],ce=ee[ue];if(Se(_e,ce)){Y+=1,ue+=1;continue}Q(ce)?(Pe(Y,1,[]),Y+=1):(Pe(Y,0,[ce]),ue+=1)}return ye}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function i(N){const ee=N;return!!((typeof ee.include=="string"||R.isRelativePattern(ee.include))&&(typeof ee.exclude=="string"||R.isRelativePattern(ee.exclude)))}e.isDocumentExcludePattern=i;function o(N,ee,Q){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ee)>=0||N.viewType===ee)return!0;if(N.filenamePattern){const Se=i(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,ye=i(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(R.match(Se,(0,d.basename)(Q.fsPath).toLowerCase()))return!(ye&&R.match(ye,(0,d.basename)(Q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var S;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class b{static{this._prefix="notebook/"}static create(ee){return`${b._prefix}${ee}`}static parse(ee){if(ee.startsWith(b._prefix))return ee.substring(b._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=b;function C(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.isTextStreamMime=C;const I=new TextDecoder;function c(N){const ee=[];let Q=!1;for(const Y of N)(ee.length===0||Q)&&(ee.push(Y),Q=!0);let Se=A(ee);const ye=w.VSBuffer.concat(ee.map(Y=>w.VSBuffer.wrap(Y))),Pe=M(ye);return Se=Se||Pe.byteLength!==ye.byteLength,{data:Pe,didCompression:Se}}e.compressOutputItemStreams=c,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const h=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(N=>N.charCodeAt(0)),u=10;function A(N){let ee=!1;return N.forEach((Q,Se)=>{if(Se===0||Q.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ye=N[Se-1],Pe=Q.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Pe[0]===h[0]&&Pe[1]===h[1]&&Pe[2]===h[2]){const Y=ye.lastIndexOf(u);if(Y===-1)return;ee=!0,N[Se-1]=ye.subarray(0,Y),N[Se]=Q.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ee}function B(N){let ee=N;do N=ee,ee=N.replace(/[^\n]\x08/gm,"");while(ee.length<N.length);return N}function H(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ee=N.match(/^(.*)\r+/m)[1];let Q=N.match(/\r+(.*)$/m)[1];Q=Q+ee.slice(Q.length,ee.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return N}const U="\b".charCodeAt(0),z="\r".charCodeAt(0);function M(N){return!N.buffer.includes(U)&&!N.buffer.includes(z)?N:w.VSBuffer.fromString(H(B(I.decode(N.buffer))))}}),define(Te[7],Ae([1,0,18,9,49,28,68,15,16,2,36,20,38,97,75]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g){"use strict";var f,t,n,l,E,D,p,r,s,i,o,S,b,C,I,c,h,u;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A($){return Object.assign($,{apply:function(...ne){if(ne.length===0)return Reflect.construct($,[]);{const Ce=ne.length===1?[]:ne[1];return Reflect.construct($,Ce,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct($,[]);{const[Ce,...qe]=ne;return Reflect.construct($,qe,Ce.constructor)}}})}var B;(function($){$[$.Top=0]="Top",$[$.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var H;(function($){$[$.TerminalCommand=0]="TerminalCommand",$[$.Opener=1]="Opener",$[$.Command=3]="Command"})(H||(e.TerminalQuickFixType=H={}));let U=f=class{static from(...L){let ne=L;return new f(function(){if(ne){for(const Ce of ne)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ne=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=U,e.Disposable=U=f=Ve([A],U);let z=t=class{static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Ce=1;Ce<L.length;Ce++){const qe=L[Ce];qe.isBefore(ne)&&(ne=qe)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Ce=1;Ce<L.length;Ce++){const qe=L[Ce];qe.isAfter(ne)&&(ne=qe)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:ne,character:Ce}=L;return typeof ne=="number"&&typeof Ce=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,ne){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(ne<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=ne}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,R.illegalArgument)();let Ce;return typeof L>"u"?Ce=0:typeof L=="number"?Ce=L:(Ce=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Ce===0&&ne===0?this:new t(this.line+Ce,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,R.illegalArgument)();let Ce;return typeof L>"u"?Ce=this.line:typeof L=="number"?Ce=L:(Ce=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Ce===this.line&&ne===this.character?this:new t(Ce,ne)}toJSON(){return{line:this.line,character:this.character}}};e.Position=z,e.Position=z=t=Ve([A],z);let M=n=class{static isRange(L){return L instanceof n?!0:L?z.isPosition(L.start)&&z.isPosition(L.end):!1}static of(L){if(L instanceof n)return L;if(this.isRange(L))return new n(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,ne,Ce,qe){let Qe,at;if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof qe=="number"?(Qe=new z(L,ne),at=new z(Ce,qe)):z.isPosition(L)&&z.isPosition(ne)&&(Qe=z.of(L),at=z.of(ne)),!Qe||!at)throw new Error("Invalid arguments");Qe.isBefore(at)?(this._start=Qe,this._end=at):(this._start=at,this._end=Qe)}contains(L){return n.isRange(L)?this.contains(L.start)&&this.contains(L.end):z.isPosition(L)?!(z.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=z.Max(L.start,this._start),Ce=z.Min(L.end,this._end);if(!ne.isAfter(Ce))return new n(ne,Ce)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=z.Min(L.start,this._start),Ce=z.Max(L.end,this.end);return new n(ne,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,R.illegalArgument)();let Ce;return L?z.isPosition(L)?Ce=L:(Ce=L.start||this.start,ne=L.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ne.isEqual(this.end)?this:new n(Ce,ne)}toJSON(){return[this.start,this.end]}};e.Range=M,e.Range=M=n=Ve([A],M);let N=l=class extends M{static isSelection(L){return L instanceof l?!0:L?M.isRange(L)&&z.isPosition(L.anchor)&&z.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,ne,Ce,qe){let Qe,at;if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof qe=="number"?(Qe=new z(L,ne),at=new z(Ce,qe)):z.isPosition(L)&&z.isPosition(ne)&&(Qe=z.of(L),at=z.of(ne)),!Qe||!at)throw new Error("Invalid arguments");super(Qe,at),this._anchor=Qe,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=N,e.Selection=N=l=Ve([A],N);const ee=$=>{if(typeof $!="string"||$.length===0||!/^[0-9A-Za-z_\-]+$/.test($))throw(0,R.illegalArgument)("connectionToken")};class Q{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne,Ce){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,R.illegalArgument)("port");typeof Ce<"u"&&ee(Ce),this.host=L,this.port=Math.round(ne),this.connectionToken=Ce}}e.ResolvedAuthority=Q;class Se{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne){this.makeConnection=L,this.connectionToken=ne,typeof ne<"u"&&ee(ne)}}e.ManagedResolvedAuthority=Se;class ye extends Error{static NotAvailable(L,ne){return new ye(L,v.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new ye(L,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ne=v.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(L),this._message=L,this._code=ne,this._detail=Ce,Object.setPrototypeOf(this,ye.prototype)}}e.RemoteAuthorityResolverError=ye;var Pe;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Y;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let ue=E=class{static isTextEdit(L){return L instanceof E?!0:L?M.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new E(L,ne)}static insert(L,ne){return E.replace(new M(L,L),ne)}static delete(L){return E.replace(L,"")}static setEndOfLine(L){const ne=new E(new M(new z(0,0),new z(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!M.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}constructor(L,ne){this._range=L,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=ue,e.TextEdit=ue=E=Ve([A],ue);let _e=D=class{static isNotebookCellEdit(L){return L instanceof D?!0:L?Zt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new D(L,ne)}static insertCells(L,ne){return new D(new Zt(L,L),ne)}static deleteCells(L){return new D(L,[])}static updateCellMetadata(L,ne){const Ce=new D(new Zt(L,L),[]);return Ce.newCellMetadata=ne,Ce}static updateNotebookMetadata(L){const ne=new D(new Zt(0,0),[]);return ne.newNotebookMetadata=L,ne}constructor(L,ne){this.range=L,this.newCells=ne}};e.NotebookEdit=_e,e.NotebookEdit=_e=D=Ve([A],_e);class ce{static isSnippetTextEdit(L){return L instanceof ce?!0:L?M.isRange(L.range)&&x.isSnippetString(L.snippet):!1}static replace(L,ne){return new ce(L,ne)}static insert(L,ne){return ce.replace(new M(L,L),ne)}constructor(L,ne){this.range=L,this.snippet=ne}}e.SnippetTextEdit=ce;var pe;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,Ce,qe){this._edits.push({_type:1,from:L,to:ne,options:Ce,metadata:qe})}createFile(L,ne,Ce){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:Ce})}deleteFile(L,ne,Ce){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:Ce})}replaceNotebookMetadata(L,ne,Ce){this._edits.push({_type:3,metadata:Ce,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,Ce,qe){const Qe=ne.start,at=ne.end;(Qe!==at||Ce.length>0)&&this._edits.push({_type:5,uri:L,index:Qe,count:at-Qe,cells:Ce,metadata:qe})}replaceNotebookCellMetadata(L,ne,Ce,qe){this._edits.push({_type:3,metadata:qe,uri:L,edit:{editType:3,index:ne,metadata:Ce}})}replace(L,ne,Ce,qe){this._edits.push({_type:2,uri:L,edit:new ue(ne,Ce),metadata:qe})}insert(L,ne,Ce,qe){this.replace(L,new M(ne,ne),Ce,qe)}delete(L,ne,Ce){this.replace(L,ne,"",Ce)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Ce of ne){if(!Ce)continue;let qe,Qe;Array.isArray(Ce)?(qe=Ce[0],Qe=Ce[1]):qe=Ce,_e.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(L,qe.range.start,qe.newCellMetadata,Qe):qe.newNotebookMetadata?this.replaceNotebookMetadata(L,qe.newNotebookMetadata,Qe):this.replaceNotebookCells(L,qe.range,qe.newCells,Qe):ce.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:L,range:qe.range,edit:qe.snippet,metadata:Qe}):this._edits.push({_type:2,uri:L,edit:qe,metadata:Qe})}else{for(let Ce=0;Ce<this._edits.length;Ce++){const qe=this._edits[Ce];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===L.toString()&&(this._edits[Ce]=void 0);break}}(0,w.coalesceInPlace)(this._edits)}}get(L){const ne=[];for(const Ce of this._edits)Ce._type===2&&Ce.uri.toString()===L.toString()&&ne.push(Ce.edit);return ne}entries(){const L=new F.ResourceMap;for(const ne of this._edits)if(ne._type===2){let Ce=L.get(ne.uri);Ce||(Ce=[ne.uri,[]],L.set(ne.uri,Ce)),Ce[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ie,e.WorkspaceEdit=ie=Ve([A],ie);let x=p=class{static isSnippetString(L){return L instanceof p?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=p._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const Ce=new p;Ce._tabstop=this._tabstop,L(Ce),this._tabstop=Ce._tabstop,L=Ce.value}else L=p._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const Ce=L.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Ce=new p;Ce._tabstop=this._tabstop,ne(Ce),this._tabstop=Ce._tabstop,ne=Ce.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.SnippetString=x,e.SnippetString=x=p=Ve([A],x);var W;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var le;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=r=class{static isLocation(L){return L instanceof r?!0:L?M.isRange(L.range)&&m.URI.isUri(L.uri):!1}constructor(L,ne){if(this.uri=L,ne)if(M.isRange(ne))this.range=M.of(ne);else if(z.isPosition(ne))this.range=new M(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=we,e.Location=we=r=Ve([A],we);let Ee=class{static is(L){return L?typeof L.message=="string"&&L.location&&M.isRange(L.location.range)&&m.URI.isUri(L.location.uri):!1}constructor(L,ne){this.location=L,this.message=ne}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};e.DiagnosticRelatedInformation=Ee,e.DiagnosticRelatedInformation=Ee=Ve([A],Ee);let me=class{constructor(L,ne,Ce=le.Error){if(!M.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Ce}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,w.equals)(L.tags,ne.tags)&&(0,w.equals)(L.relatedInformation,ne.relatedInformation,Ee.isEqual)}};e.Diagnostic=me,e.Diagnostic=me=Ve([A],me);let De=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};e.Hover=De,e.Hover=De=Ve([A],De);var re;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let de=class{constructor(L,ne=re.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.DocumentHighlight=de,e.DocumentHighlight=de=Ve([A],de);var se;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function($){$[$.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ne,Ce,qe,Qe){this.name=L,this.kind=ne,this.containerName=Qe,typeof Ce=="string"&&(this.containerName=Ce),qe instanceof we?this.location=qe:Ce instanceof M&&(this.location=new we(qe,Ce)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=fe,e.SymbolInformation=fe=s=Ve([A],fe);let Ie=i=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(i.validate)}constructor(L,ne,Ce,qe,Qe){this.name=L,this.detail=ne,this.kind=Ce,this.range=qe,this.selectionRange=Qe,this.children=[],i.validate(this)}};e.DocumentSymbol=Ie,e.DocumentSymbol=Ie=i=Ve([A],Ie);var O;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(O||(e.CodeActionTriggerKind=O={}));let V=class{constructor(L,ne){this.title=L,this.kind=ne}};e.CodeAction=V,e.CodeAction=V=Ve([A],V);let K=class{static{o=this}static{this.sep="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.sep)}};e.CodeActionKind=K,e.CodeActionKind=K=o=Ve([A],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let G=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=G,e.SelectionRange=G=Ve([A],G);class q{constructor(L,ne,Ce,qe,Qe,at){this.kind=L,this.name=ne,this.detail=Ce,this.uri=qe,this.range=Qe,this.selectionRange=at}}e.CallHierarchyItem=q;class Z{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=Z;class ae{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=ae;var Me;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let Ue=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};e.CodeLens=Ue,e.CodeLens=Ue=Ve([A],Ue);let Ge=S=class{#e;static isMarkdownString(L){return L instanceof S?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ne=!1){this.#e=new k.MarkdownString(L,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ne){return this.#e.appendCodeblock(ne??"",L),this}};e.MarkdownString=Ge,e.MarkdownString=Ge=S=Ve([A],Ge);let je=class{constructor(L,ne){this.label=L,this.documentation=ne}};e.ParameterInformation=je,e.ParameterInformation=je=Ve([A],je);let Je=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};e.SignatureInformation=Je,e.SignatureInformation=Je=Ve([A],Je);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ye,e.SignatureHelp=Ye=Ve([A],Ye);var et;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var it;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.InlayHintLabelPart=tt,e.InlayHintLabelPart=tt=Ve([A],tt);let xe=class{constructor(L,ne,Ce){this.position=L,this.label=ne,this.kind=Ce}};e.InlayHint=xe,e.InlayHint=xe=Ve([A],xe);var st;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var J;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(J||(e.CompletionItemKind=J={}));var X;(function($){$[$.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let ve=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&J[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ve,e.CompletionItem=ve=Ve([A],ve);let Be=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};e.CompletionList=Be,e.CompletionList=Be=Ve([A],Be);let Ne=class{constructor(L,ne,Ce){this.insertText=L,this.range=ne,this.command=Ce}};e.InlineSuggestion=Ne,e.InlineSuggestion=Ne=Ve([A],Ne);let Xe=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.InlineSuggestionList=Xe,e.InlineSuggestionList=Xe=Ve([A],Xe);var nt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ht;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function wt($,L){return`${_.ExtensionIdentifier.toKey($)}.${L}`}e.asStatusBarItemIdentifier=wt;var Pt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Xt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var Vt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var vt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var $t;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})($t||(e.TextDocumentChangeReason=$t={}));var Nt;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function($){function L(ne){switch(ne){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=L}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Bt;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function($){function L(ne){switch(ne){case $.Other:return"other";case $.Comment:return"comment";case $.String:return"string";case $.RegEx:return"regex"}return"other"}$.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let Tt=class{constructor(L,ne){if(ne&&!m.URI.isUri(ne))throw(0,R.illegalArgument)("target");if(!M.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=ne}};e.DocumentLink=Tt,e.DocumentLink=Tt=Ve([A],Tt);let At=class{constructor(L,ne,Ce,qe){this.red=L,this.green=ne,this.blue=Ce,this.alpha=qe}};e.Color=At,e.Color=At=Ve([A],At);let xt=class{constructor(L,ne){if(ne&&!(ne instanceof At))throw(0,R.illegalArgument)("color");if(!M.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=ne}};e.ColorInformation=xt,e.ColorInformation=xt=Ve([A],xt);let zt=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};e.ColorPresentation=zt,e.ColorPresentation=zt=Ve([A],zt);var qt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Ht;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var Wt;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(Wt||(e.TerminalExitReason=Wt={}));class ot{constructor(L,ne,Ce){if(this.startIndex=L,this.length=ne,this.tooltip=Ce,typeof L!="number"||L<0)throw(0,R.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,R.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=ot;class ft{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=ft;class Rt{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=Rt;var Ot;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Ot||(e.TerminalLocation=Ot={}));class It{constructor(L){if(this.options=L,typeof L!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=It;var dt;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(dt||(e.TaskRevealKind=dt={}));var yt;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(yt||(e.TaskPanelKind=yt={}));let Dt=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,R.illegalArgument)("name");this._id=L}get id(){return this._id}};e.TaskGroup=Dt,e.TaskGroup=Dt=b=Ve([A],Dt);function Ft($){let L="";for(let ne=0;ne<$.length;ne++)L+=$[ne].replace(/,/g,",,")+",";return L}let He=class{constructor(L,ne,Ce){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ce):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)L.push(ne);return Ft(L)}};e.ProcessExecution=He,e.ProcessExecution=He=Ve([A],He);let ke=class{constructor(L,ne,Ce){if(this._args=[],Array.isArray(ne)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=ne,this._options=Ce}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return Ft(L)}};e.ShellExecution=ke,e.ShellExecution=ke=Ve([A],ke);var Re;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Re||(e.ShellQuoting=Re={}));var ge;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class j{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=j;let Oe=class{static{C=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(L,ne,Ce,qe,Qe,at){this.__deprecated=!1,this._definition=this.definition=L;let ut;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ce,this.execution=qe,ut=Qe,this.__deprecated=!0):ne===ge.Global||ne===ge.Workspace?(this.target=ne,this._name=this.name=Ce,this._source=this.source=qe,this.execution=Qe,ut=at):(this.target=ne,this._name=this.name=Ce,this._source=this.source=qe,this.execution=Qe,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof He?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof ke?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof j?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(C.EmptyType===ne||C.ProcessType===ne||C.ShellType===ne||C.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};e.Task=Oe,e.Task=Oe=C=Ve([A],Oe);var $e;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})($e||(e.ProgressLocation=$e={}));var Ke;(function($){function L(ne){const Ce=ne;return(0,y.isNumber)(Ce.value)?Ce.tooltip&&!(0,y.isString)(Ce.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ce.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ce.value),!1)}$.isViewBadge=L})(Ke||(e.ViewBadge=Ke={}));let ze=I=class{static isTreeItem(L,ne){const Ce=L;if(Ce.checkboxState!==void 0){const qe=(0,y.isNumber)(Ce.checkboxState)?Ce.checkboxState:(0,y.isObject)(Ce.checkboxState)&&(0,y.isNumber)(Ce.checkboxState.state)?Ce.checkboxState.state:void 0,Qe=!(0,y.isNumber)(Ce.checkboxState)&&(0,y.isObject)(Ce.checkboxState)?Ce.checkboxState.tooltip:void 0;if(qe===void 0||qe!==pt.Checked&&qe!==pt.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",Ce.checkboxState),!1}if(L instanceof I)return!0;if(Ce.label!==void 0&&!(0,y.isString)(Ce.label)&&!Ce.label?.label)return console.log("INVALID tree item, invalid label",Ce.label),!1;if(Ce.id!==void 0&&!(0,y.isString)(Ce.id))return console.log("INVALID tree item, invalid id",Ce.id),!1;if(Ce.iconPath!==void 0&&!(0,y.isString)(Ce.iconPath)&&!m.URI.isUri(Ce.iconPath)&&(!Ce.iconPath||!(0,y.isString)(Ce.iconPath.id))){const qe=Ce.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!m.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!m.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Ce.iconPath),!1}return Ce.description!==void 0&&!(0,y.isString)(Ce.description)&&typeof Ce.description!="boolean"?(console.log("INVALID tree item, invalid description",Ce.description),!1):Ce.resourceUri!==void 0&&!m.URI.isUri(Ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ce.resourceUri),!1):Ce.tooltip!==void 0&&!(0,y.isString)(Ce.tooltip)&&!(Ce.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Ce.tooltip),!1):Ce.command!==void 0&&!Ce.command.command?(console.log("INVALID tree item, invalid command",Ce.command),!1):Ce.collapsibleState!==void 0&&Ce.collapsibleState<Ze.None&&Ce.collapsibleState>Ze.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ce.collapsibleState),!1):Ce.contextValue!==void 0&&!(0,y.isString)(Ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ce.contextValue),!1):Ce.accessibilityInformation!==void 0&&!Ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ce.accessibilityInformation),!1):!0}constructor(L,ne=Ze.None){this.collapsibleState=ne,m.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.TreeItem=ze,e.TreeItem=ze=I=Ve([A],ze);var Ze;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(Ze||(e.TreeItemCollapsibleState=Ze={}));var pt;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.DataTransferItem=kt,e.DataTransferItem=kt=Ve([A],kt);class bt extends kt{}e.InternalDataTransferItem=bt;class lt extends bt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.InternalFileDataTransferItem=lt;class gt{constructor(L,ne,Ce,qe){this.name=L,this.uri=ne,this._itemId=Ce,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=gt;let St=class{#e=new Map;constructor(L){for(const[ne,Ce]of L??[]){const qe=this.#e.get(this.#t(ne));qe?qe.push(Ce):this.#e.set(this.#t(ne),[Ce])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ne){this.#e.set(this.#t(L),[ne])}forEach(L,ne){for(const[Ce,qe]of this.#e)for(const Qe of qe)L.call(ne,Qe,Ce,this)}*[Symbol.iterator](){for(const[L,ne]of this.#e)for(const Ce of ne)yield[L,Ce]}#t(L){return L.toLowerCase()}};e.DataTransfer=St,e.DataTransfer=St=Ve([A],St);let mi=class{constructor(L){this.insertText=L}};e.DocumentDropEdit=mi,e.DocumentDropEdit=mi=Ve([A],mi);let jt=class{constructor(L,ne){this.label=ne,this.insertText=L}};e.DocumentPasteEdit=jt,e.DocumentPasteEdit=jt=Ve([A],jt);let Qt=class{constructor(L,ne){this.id=L,this.color=ne}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.ThemeIcon=Qt,e.ThemeIcon=Qt=Ve([A],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let si=class{constructor(L){this.id=L}};e.ThemeColor=si,e.ThemeColor=si=Ve([A],si);var yi;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(yi||(e.ConfigurationTarget=yi={}));let Ct=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=m.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,ne){if(typeof L!="string"&&(!L||!m.URI.isUri(L)&&!m.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof ne!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?this.baseUri=m.URI.file(L):m.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ct,e.RelativePattern=Ct=Ve([A],Ct);const Qi=new WeakMap;function ln($,L){Qi.set($,L)}e.setBreakpointId=ln;let Et=class{constructor(L,ne,Ce,qe){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Ce=="string"&&(this.hitCondition=Ce),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=Qi.get(this)??(0,P.generateUuid)()),this._id}};e.Breakpoint=Et,e.Breakpoint=Et=Ve([A],Et);let gi=class extends Et{constructor(L,ne,Ce,qe,Qe){if(super(ne,Ce,qe,Qe),L===null)throw(0,R.illegalArgument)("location");this.location=L}};e.SourceBreakpoint=gi,e.SourceBreakpoint=gi=Ve([A],gi);let pi=class extends Et{constructor(L,ne,Ce,qe,Qe){super(ne,Ce,qe,Qe),this.functionName=L}};e.FunctionBreakpoint=pi,e.FunctionBreakpoint=pi=Ve([A],pi);let oi=class extends Et{constructor(L,ne,Ce,qe,Qe,at,ut){if(super(qe,Qe,at,ut),!ne)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=Ce}};e.DataBreakpoint=oi,e.DataBreakpoint=oi=Ve([A],oi);let Di=class{constructor(L,ne,Ce){this.command=L,this.args=ne||[],this.options=Ce}};e.DebugAdapterExecutable=Di,e.DebugAdapterExecutable=Di=Ve([A],Di);let Ci=class{constructor(L,ne){this.port=L,this.host=ne}};e.DebugAdapterServer=Ci,e.DebugAdapterServer=Ci=Ve([A],Ci);let Lt=class{constructor(L){this.path=L}};e.DebugAdapterNamedPipeServer=Lt,e.DebugAdapterNamedPipeServer=Lt=Ve([A],Lt);let vi=class{constructor(L){this.implementation=L}};e.DebugAdapterInlineImplementation=vi,e.DebugAdapterInlineImplementation=vi=Ve([A],vi);let Ii=class{constructor(L,ne,Ce){this.session=L,this.threadId=ne,this.frameId=Ce}};e.StackFrameFocus=Ii,e.StackFrameFocus=Ii=Ve([A],Ii);let ai=class{constructor(L,ne){this.session=L,this.threadId=ne}};e.ThreadFocus=ai,e.ThreadFocus=ai=Ve([A],ai);let ci=class{constructor(L,ne){this.range=L,this.expression=ne}};e.EvaluatableExpression=ci,e.EvaluatableExpression=ci=Ve([A],ci);var ct;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(ct||(e.InlineCompletionTriggerKind=ct={}));let ki=class{constructor(L,ne){this.range=L,this.text=ne}};e.InlineValueText=ki,e.InlineValueText=ki=Ve([A],ki);let Yt=class{constructor(L,ne,Ce=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Ce}};e.InlineValueVariableLookup=Yt,e.InlineValueVariableLookup=Yt=Ve([A],Yt);let ii=class{constructor(L,ne){this.range=L,this.expression=ne}};e.InlineValueEvaluatableExpression=ii,e.InlineValueEvaluatableExpression=ii=Ve([A],ii);let Ei=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};e.InlineValueContext=Ei,e.InlineValueContext=Ei=Ve([A],Ei);var Yi;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Yi||(e.FileChangeType=Yi={}));let Pi=c=class extends Error{static FileExists(L){return new c(L,a.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(L){return new c(L,a.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(L){return new c(L,a.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(L){return new c(L,a.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(L){return new c(L,a.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(L){return new c(L,a.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}constructor(L,ne=a.FileSystemProviderErrorCode.Unknown,Ce){super(m.URI.isUri(L)?L.toString(!0):L),this.code=Ce?.name??"Unknown",(0,a.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}};e.FileSystemError=Pi,e.FileSystemError=Pi=c=Ve([A],Pi);let Ti=class{constructor(L,ne,Ce){this.start=L,this.end=ne,this.kind=Ce}};e.FoldingRange=Ti,e.FoldingRange=Ti=Ve([A],Ti);var Ai;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Ai||(e.FoldingRangeKind=Ai={}));var Ji;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var Ri;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Ri||(e.CommentMode=Ri={}));var li;(function($){$[$.Published=0]="Published",$[$.Draft=1]="Draft"})(li||(e.CommentState=li={}));var Zi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Zi||(e.CommentThreadState=Zi={}));class Oi{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=Oi;function Fi($){return typeof $>"u"||(0,y.isStringArray)($)}class Li{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,Ce=L.tokenTypes.length;ne<Ce;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,Ce=L.tokenModifiers.length;ne<Ce;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,Ce,qe,Qe){if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof qe=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(L,ne,Ce,qe,Qe);if(M.isRange(L)&&typeof ne=="string"&&Fi(Ce))return this._push(L,ne,Ce);throw(0,R.illegalArgument)()}_push(L,ne,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const qe=L.start.line,Qe=L.start.character,at=L.end.character-L.start.character,ut=this._tokenTypeStrToInt.get(ne);let Ut=0;if(Ce)for(const Gt of Ce){if(!this._tokenModifierStrToInt.has(Gt))throw new Error("`tokenModifier` is not in the provided legend");const Jt=this._tokenModifierStrToInt.get(Gt);Ut|=1<<Jt>>>0}this._pushEncoded(qe,Qe,at,ut,Ut)}_pushEncoded(L,ne,Ce,qe,Qe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ut=this._data.length/5|0;let Gt=0,Jt=0;for(let ti=0;ti<Ut;ti++){let ri=this._data[5*ti],Gi=this._data[5*ti+1];ri===0?(ri=Gt,Gi+=Jt):ri+=Gt,this._data[5*ti]=ri,this._data[5*ti+1]=Gi,Gt=ri,Jt=Gi}}let at=L,ut=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Qe,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){const ne=[],Ce=L.length/5|0;for(let ut=0;ut<Ce;ut++)ne[ut]=ut;ne.sort((ut,Ut)=>{const Gt=L[5*ut],Jt=L[5*Ut];if(Gt===Jt){const ti=L[5*ut+1],ri=L[5*Ut+1];return ti-ri}return Gt-Jt});const qe=new Uint32Array(L.length);let Qe=0,at=0;for(let ut=0;ut<Ce;ut++){const Ut=5*ne[ut],Gt=L[Ut+0],Jt=L[Ut+1],ti=L[Ut+2],ri=L[Ut+3],Gi=L[Ut+4],_n=Gt-Qe,Rn=_n===0?Jt-at:Jt,Xi=5*ut;qe[Xi+0]=_n,qe[Xi+1]=Rn,qe[Xi+2]=ti,qe[Xi+3]=ri,qe[Xi+4]=Gi,Qe=Gt,at=Jt}return qe}build(L){return this._dataIsSortedAndDeltaEncoded?new Mi(new Uint32Array(this._data),L):new Mi(Li._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Li;class Mi{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=Mi;class di{constructor(L,ne,Ce){this.start=L,this.deleteCount=ne,this.data=Ce}}e.SemanticTokensEdit=di;class un{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=un;var en;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Qt("arrow-left")}}constructor(){}};e.QuickInputButtons=Ni,e.QuickInputButtons=Ni=Ve([A],Ni);var hi;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(hi||(e.QuickPickItemKind=hi={}));var tn;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class dn{static validate(L){if(typeof L.badge=="string"){let ne=(0,d.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,d.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Qt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ne,Ce){this.badge=L,this.tooltip=ne,this.color=Ce}}e.FileDecoration=dn;let ni=class{constructor(L){this.kind=L}};e.ColorTheme=ni,e.ColorTheme=ni=Ve([A],ni);var xi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(xi||(e.ColorThemeKind=xi={}));class Zt{static isNotebookRange(L){return L instanceof Zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,ne){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(ne<0)throw(0,R.illegalArgument)("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}with(L){let ne=this._start,Ce=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Ce=L.end),ne===this._start&&Ce===this._end?this:new Zt(ne,Ce)}}e.NotebookRange=Zt;class bi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>bi.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}constructor(L,ne,Ce,qe,Qe,at,ut){this.kind=L,this.value=ne,this.languageId=Ce,this.mime=qe,this.outputs=Qe??[],this.metadata=at,this.executionSummary=ut,bi.validate(this)}}e.NotebookCellData=bi;class rn{constructor(L){this.cells=L}}e.NotebookData=rn;class Kt{static isNotebookCellOutputItem(L){return L instanceof Kt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Kt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Kt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Kt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Kt(L,ne)}static#e=new TextEncoder;static text(L,ne=T.Mimes.text){const Ce=Kt.#e.encode(String(L));return new Kt(Ce,ne)}static json(L,ne="text/x-json"){const Ce=JSON.stringify(L,void 0,"	");return Kt.text(Ce,ne)}constructor(L,ne){this.data=L,this.mime=ne;const Ce=(0,T.normalizeMimeType)(ne,!0);if(!Ce)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}}e.NotebookCellOutputItem=Kt;class wi{static isNotebookCellOutput(L){return L instanceof wi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Ce=new Set,qe=new Set;for(let Qe=0;Qe<L.length;Qe++){const at=L[Qe],ut=(0,T.normalizeMimeType)(at.mime);if(!Ce.has(ut)||(0,g.isTextStreamMime)(ut)){Ce.add(ut);continue}qe.add(Qe),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?L:L.filter((Qe,at)=>!qe.has(at))}constructor(L,ne,Ce){this.items=wi.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Ce):(this.id=(0,P.generateUuid)(),this.metadata=ne??Ce)}}e.NotebookCellOutput=wi;var sn;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Si;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Si||(e.NotebookCellExecutionState=Si={}));var Ui;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Le;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Le||(e.NotebookEditorRevealType=Le={}));class ei{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=ei;var $i;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})($i||(e.NotebookControllerAffinity=$i={}));var mt;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred",$[$.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class hn{constructor(L,ne=[]){this.uri=L,this.provides=(0,w.asArray)(ne)}}e.NotebookRendererScript=hn;class fn{constructor(L){this.label=L}}e.NotebookKernelSourceAction=fn;let _i=class{constructor(L,ne){this.label=L,this.timestamp=ne}};e.TimelineItem=_i,e.TimelineItem=_i=Ve([A],_i);var on;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=mn;class gn{constructor(L){this._autoForwardAction=L}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=gn;var Bi;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let zi=class{constructor(L=void 0,ne=void 0,Ce=void 0,qe=!1){this.include=L,this.exclude=ne,this.profile=Ce,this.continuous=qe}};e.TestRunRequest=zi,e.TestRunRequest=zi=Ve([A],zi);let Hi=h=class{static diff(L,ne,Ce){const qe=new h(L);return qe.expectedOutput=ne,qe.actualOutput=Ce,qe}constructor(L){this.message=L}};e.TestMessage=Hi,e.TestMessage=Hi=h=Ve([A],Hi);let Wi=class{constructor(L){this.id=L}};e.TestTag=Wi,e.TestTag=Wi=Ve([A],Wi);let ui=class{constructor(L,ne){this.covered=L,this.total=ne}};e.CoveredCount=ui,e.CoveredCount=ui=Ve([A],ui);let Vi=u=class{static fromDetails(L,ne){const Ce=new ui(0,0),qe=new ui(0,0),Qe=new ui(0,0);for(const ut of ne)if("branches"in ut){Ce.total+=1,Ce.covered+=ut.executionCount>0?1:0;for(const Ut of ut.branches)qe.total+=1,qe.covered+=Ut.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ut.executionCount>0?1:0;const at=new u(L,Ce,qe.total>0?qe:void 0,Qe.total>0?Qe:void 0);return at.detailedCoverage=ne,at}constructor(L,ne,Ce,qe){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Ce,this.functionCoverage=qe}};e.FileCoverage=Vi,e.FileCoverage=Vi=u=Ve([A],Vi);let qi=class{constructor(L,ne,Ce=[]){this.executionCount=L,this.location=ne,this.branches=Ce}};e.StatementCoverage=qi,e.StatementCoverage=qi=Ve([A],qi);let ji=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.BranchCoverage=ji,e.BranchCoverage=ji=Ve([A],ji);let Ki=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.FunctionCoverage=Ki,e.FunctionCoverage=Ki=Ve([A],Ki);var te;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}));var he;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(he||(e.WorkspaceTrustState=he={}));var Fe;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(Fe||(e.PortAutoForwardAction=Fe={}));class rt{constructor(L,ne,Ce,qe,Qe,at){this.kind=L,this.name=ne,this.detail=Ce,this.uri=qe,this.range=Qe,this.selectionRange=at}}e.TypeHierarchyItem=rt;class _t{constructor(L){this.uri=L}}e.TextTabInput=_t;class Mt{constructor(L,ne){this.original=L,this.modified=ne}}e.TextDiffTabInput=Mt;class yn{constructor(L,ne,Ce,qe){this.base=L,this.input1=ne,this.input2=Ce,this.result=qe}}e.TextMergeTabInput=yn;class Dn{constructor(L,ne){this.uri=L,this.viewType=ne}}e.CustomEditorTabInput=Dn;class Cn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=Cn;class In{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.NotebookEditorTabInput=In;class kn{constructor(L,ne,Ce){this.original=L,this.modified=ne,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=kn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class Tn{constructor(L,ne){this.uri=L,this.inputBoxUri=ne}}e.InteractiveWindowInput=Tn;var pn;(function($){$[$.Up=1]="Up",$[$.Down=2]="Down"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function($){$[$.Action=1]="Action",$[$.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var En;(function($){$[$.Unhelpful=0]="Unhelpful",$[$.Helpful=1]="Helpful",$[$.Undone=2]="Undone",$[$.Accepted=3]="Accepted"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var bn;(function($){$[$.System=0]="System",$[$.User=1]="User",$[$.Assistant=2]="Assistant",$[$.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function($){$[$.Short=1]="Short",$[$.Medium=2]="Medium",$[$.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class An{constructor(L,ne){this.role=L,this.content=ne}}e.ChatMessage=An;var Sn;(function($){$[$.SymbolInformation=1]="SymbolInformation",$[$.CommandInformation=2]="CommandInformation",$[$.SearchInformation=3]="SearchInformation",$[$.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}))}),define(Te[100],Ae([1,0,51,13,15,278,136,7,18]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function P(g,f){f?m.set(g,f):m.delete(g)}e.setWordDefinitionFor=P;function _(g){return m.get(g)}class a extends F.MirrorTextModel{constructor(f,t,n,l,E,D,p,r){super(t,n,l,E),this._proxy=f,this._languageId=D,this._isDirty=p,this.notebook=r,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,y.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},save(){return f._save()},getText(t){return t?f._getTextInRange(t):f.getText()},get eol(){return f._eol===`
`?d.EndOfLine.LF:d.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(t){return f._lineAt(t)},offsetAt(t){return f._offsetAt(t)},positionAt(t){return f._positionAt(t)},validateRange(t){return f._validateRange(t)},validatePosition(t){return f._validatePosition(t)},getWordRangeAtPosition(t,n){return f._getWordRangeAtPosition(t,n)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,w.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,w.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const t=this._validateRange(f);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const n=this._eol,l=t.start.line,E=t.end.line,D=[];D.push(this._lines[l].substring(t.start.character));for(let p=l+1;p<E;p++)D.push(this._lines[p]);return D.push(this._lines[E].substring(0,t.end.character)),D.join(n)}_lineAt(f){let t;if(f instanceof d.Position?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this._lines[t],t===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(f),n=this._lines[t.index].length;return new d.Position(t.index,Math.min(t.remainder,n))}_validateRange(f){if(!(f instanceof d.Range))throw new Error("Invalid argument");const t=this._validatePosition(f.start),n=this._validatePosition(f.end);return t===f.start&&n===f.end?f:new d.Range(t.line,t.character,n.line,n.character)}_validatePosition(f){if(!(f instanceof d.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:t,character:n}=f,l=!1;if(t<0)t=0,n=0,l=!0;else if(t>=this._lines.length)t=this._lines.length-1,n=this._lines[t].length,l=!0;else{const E=this._lines[t].length;n<0?(n=0,l=!0):n>E&&(n=E,l=!0)}return l?new d.Position(t,n):f}_getWordRangeAtPosition(f,t){const n=this._validatePosition(f);if(!t)t=_(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const l=(0,T.getWordAtText)(n.character+1,(0,T.ensureValidWordDefinition)(t),this._lines[n.line],0);if(l)return new d.Range(n.line,l.startColumn-1,n.line,l.endColumn-1)}}e.ExtHostDocumentData=a;class v{constructor(f,t,n){this._line=f,this._text=t,this._isLastLine=n}get lineNumber(){return this._line}get text(){return this._text}get range(){return new d.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new d.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=v}),define(Te[196],Ae([1,0,7,17,5]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(d){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(d){let y;switch(d){case"light":y=w.ColorThemeKind.Light;break;case"hcDark":y=w.ColorThemeKind.HighContrast;break;case"hcLight":y=w.ColorThemeKind.HighContrastLight;break;default:y=w.ColorThemeKind.Dark}this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=F,e.ExtHostTheming=F=Ve([We(0,R.IExtHostRpcService)],F)}),define(Te[197],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.INotebookExecutionService=(0,w.createDecorator)("INotebookExecutionService")}),define(Te[45],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var R;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class k{static fromExtHostTestItem(T,d,y=T.parent){if(T._isRoot)return new k([d]);const m=[T.id];for(let P=y;P&&P.id!==d;P=P.parent)m.push(P.id);return m.push(d),new k(m.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const d=T.indexOf("\0");return d===-1?T:T.slice(0,d)}static fromString(T){return new k(T.split("\0"))}static join(T,d){return new k([...T.path,d])}static joinToString(T,d){return T.toString()+"\0"+d}static parentId(T){const d=T.lastIndexOf("\0");return d===-1?void 0:T.slice(0,d)}static localId(T){const d=T.lastIndexOf("\0");return d===-1?T:T.slice(d+1)}static isChild(T,d){return d.startsWith(T)&&d[T.length]==="\0"}static compare(T,d){return T===d?0:k.isChild(T,d)?2:k.isChild(d,T)?3:1}constructor(T,d=T.length){if(this.path=T,this.viewEnd=d,T.length===0||d<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let d=0;d<T.viewEnd&&d<this.viewEnd;d++)if(T.path[d]!==this.path[d])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(Te[57],Ae([1,0,2,44,45]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var T;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var d;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=I=>"runId"in I;e.isStartControllerTests=y;var m;(function(I){I.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),I.deserialize=c=>({range:R.Range.lift(c.range),uri:w.URI.revive(c.uri)})})(m||(e.IRichLocation=m={}));var P;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(P||(e.TestMessageType=P={}));var _;(function(I){I.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&m.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&m.deserialize(c.location)})})(_||(e.ITestErrorMessage=_={}));const a=(I,c)=>`${c?"s":"e"}${I}`;e.getMarkId=a;var v;(function(I){I.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&m.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&m.deserialize(c.location)})})(v||(e.ITestOutputMessage=v={}));var g;(function(I){I.serialize=c=>c.type===0?_.serialize(c):v.serialize(c),I.deserialize=c=>c.type===0?_.deserialize(c):v.deserialize(c)})(g||(e.ITestMessage=g={}));var f;(function(I){I.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),I.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(g.serialize)}),I.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(g.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",n=(I,c)=>I+t+c;e.namespaceTestTag=n;const l=I=>{const c=I.indexOf(t);return{ctrlId:I.slice(0,c),tagId:I.slice(c+1)}};e.denamespaceTestTag=l;var E;(function(I){I.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),I.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?w.URI.revive(c.uri):void 0,range:c.range?R.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(E||(e.ITestItem=E={}));var D;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var p;(function(I){I.serialize=c=>({expand:c.expand,item:E.serialize(c.item)}),I.deserialize=c=>({controllerId:k.TestId.root(c.item.extId),expand:c.expand,item:E.deserialize(c.item)})})(p||(e.InternalTestItem=p={}));var r;(function(I){I.serialize=c=>{let h;return c.item&&(h={},c.item.label!==void 0&&(h.label=c.item.label),c.item.tags!==void 0&&(h.tags=c.item.tags),c.item.busy!==void 0&&(h.busy=c.item.busy),c.item.uri!==void 0&&(h.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(h.range=c.item.range?.toJSON()),c.item.description!==void 0&&(h.description=c.item.description),c.item.error!==void 0&&(h.error=c.item.error),c.item.sortText!==void 0&&(h.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:h}},I.deserialize=c=>{let h;return c.item&&(h={},c.item.label!==void 0&&(h.label=c.item.label),c.item.tags!==void 0&&(h.tags=c.item.tags),c.item.busy!==void 0&&(h.busy=c.item.busy),c.item.range!==void 0&&(h.range=c.item.range?R.Range.lift(c.item.range):null),c.item.description!==void 0&&(h.description=c.item.description),c.item.error!==void 0&&(h.error=c.item.error),c.item.sortText!==void 0&&(h.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:h}}})(r||(e.ITestItemUpdate=r={}));const s=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=s;var i;(function(I){I.serializeWithoutMessages=c=>({...p.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serializeWithoutMessages)}),I.serialize=c=>({...p.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serialize)}),I.deserialize=c=>({...p.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.deserialize),retired:!0})})(i||(e.TestResultItem=i={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var S;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(S||(e.TestDiffOpType=S={}));var b;(function(I){I.deserialize=c=>c.op===0?{op:c.op,item:p.deserialize(c.item)}:c.op===1?{op:c.op,item:r.deserialize(c.item)}:c.op===2?{op:c.op,uri:w.URI.revive(c.uri),docv:c.docv}:c,I.serialize=c=>c.op===0?{op:c.op,item:p.serialize(c.item)}:c.op===1?{op:c.op,item:r.serialize(c.item)}:c})(b||(e.TestsDiffOp=b={}));class C{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const h=this.createChangeCollector();for(const u of c)switch(u.op){case 0:this.add(p.deserialize(u.item),h);break;case 1:this.update(r.deserialize(u.item),h);break;case 3:this.remove(u.itemId,h);break;case 5:this.retireTest(u.itemId);break;case 4:this.updatePendingRoots(u.amount);break;case 6:this._tags.set(u.tag.id,u.tag);break;case 7:this._tags.delete(u.id);break}h.complete?.()}add(c,h){const u=k.TestId.parentId(c.item.extId)?.toString();let A;if(!u)A=this.createItem(c),this.roots.add(A),this.items.set(c.item.extId,A);else if(this.items.has(u)){const B=this.items.get(u);B.children.add(c.item.extId),A=this.createItem(c,B),this.items.set(c.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return h.add?.(A),c.expand===2&&this.busyControllerCount++,A}update(c,h){const u=this.items.get(c.extId);if(u)return c.expand!==void 0&&(u.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(u,c),h.update?.(u),u}remove(c,h){const u=this.items.get(c);if(!u)return;const A=k.TestId.parentId(u.item.extId)?.toString();A?this.items.get(A).children.delete(u.item.extId):this.roots.delete(u);const B=[[c]];for(;B.length;)for(const H of B.pop()){const U=this.items.get(H);U&&(B.push(U.children),this.items.delete(H),h.remove?.(U,U!==u),U.expand===2&&this.busyControllerCount--)}}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=C}),define(Te[76],Ae([1,0,12,5,6,51,57,45]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const m=(l,E)=>l===E,_=Object.entries({range:(l,E)=>l===E?!0:!l||!E?!1:l.equalsRange(E),busy:m,label:m,description:m,error:m,sortText:m,tags:(l,E)=>!(l.length!==E.length||l.some(D=>!E.includes(D)))}),a=(l,E)=>{let D;for(const[p,r]of _)r(l[p],E[p])||(D?D[p]=E[p]:D={[p]:E[p]});return D};class v extends k.Disposable{get root(){return this.options.root}constructor(E){super(),this.options=E,this.debounceSendDiff=this._register(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(E){this._resolveHandler=E;for(const D of this.tree.values())this.updateExpandability(D)}get resolveHandler(){return this._resolveHandler}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){switch(E.op){case 2:{for(const D of this.diff)if(D.op===2&&D.uri===E.uri){D.docv=E.docv;return}break}case 1:{const D=this.diff[this.diff.length-1];if(D){if(D.op===1&&D.item.extId===E.item.extId){(0,T.applyTestItemUpdate)(D.item,E.item);return}if(D.op===0&&D.item.item.extId===E.item.extId){(0,T.applyTestItemUpdate)(D.item,E.item);return}}break}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,D){const p=this.tree.get(E);if(p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const r=this.resolveChildren(p);return r.isOpen()?this.expandChildren(p,D-1):r.wait().then(()=>this.expandChildren(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,D-1)):this.expandChildren(p,D-1)}}dispose(){for(const E of this.tree.values())this.options.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(E,D){switch(D.op){case 3:this.removeItem(d.TestId.joinToString(E.fullId,D.id));break;case 0:this.upsertItem(D.item,E);break;case 5:for(const p of D.ops)this.onTestItemEvent(E,p);break;case 1:this.diffTagRefs(D.new,D.old,E.fullId.toString());break;case 2:this.updateExpandability(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:D.update}});break;case 6:this.documentSynced(E.actual.uri);break;default:(0,F.assertNever)(D)}}documentSynced(E){E&&this.pushDiff({op:2,uri:E,docv:this.options.getDocumentVersion(E)})}upsertItem(E,D){const p=d.TestId.fromExtHostTestItem(E,this.root.id,D?.actual),r=this.options.getApiFor(E);r.parent&&r.parent!==D?.actual&&this.options.getChildren(r.parent).delete(E.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:E,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},E.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(E,D),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(E)}}),this.connectItemAndChildren(E,s,D);return}if(s.actual===E){this.connectItem(E,s,D);return}if(s.actual.uri?.toString()!==E.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(E,D);const i=this.options.getChildren(s.actual),o=s.actual,S=a(this.options.toITestItem(o),this.options.toITestItem(E));this.options.getApiFor(o).listener=void 0,s.actual=E,s.expand=0,S&&(S.hasOwnProperty("tags")&&(this.diffTagRefs(E.tags,o.tags,p.toString()),delete S.tags),this.onTestItemEvent(s,{op:4,update:S})),this.connectItemAndChildren(E,s,D);for(const[b,C]of i)this.options.getChildren(E).get(C.id)||this.removeItem(d.TestId.joinToString(p,C.id));this.documentSynced(s.actual.uri)}diffTagRefs(E,D,p){const r=new Set(D.map(s=>s.id));for(const s of E)r.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:p,item:{tags:E.map(s=>(0,T.namespaceTestTag)(this.options.controllerId,s.id))}}}),r.forEach(this.decrementTagRefs,this)}incrementTagRefs(E){const D=this.tags.get(E.id);D?D.refCount++:(this.tags.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,E.id)}}))}decrementTagRefs(E){const D=this.tags.get(E);D&&!--D.refCount&&(this.tags.delete(E),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,E)}))}setItemParent(E,D){this.options.getApiFor(E).parent=D&&D.actual!==this.root?D.actual:void 0}connectItem(E,D,p){this.setItemParent(E,p);const r=this.options.getApiFor(E);r.parent=p?.actual,r.listener=s=>this.onTestItemEvent(D,s),this.updateExpandability(D)}connectItemAndChildren(E,D,p){this.connectItem(E,D,p);for(const[r,s]of this.options.getChildren(E))this.upsertItem(s,D)}updateExpandability(E){let D;this._resolveHandler?E.resolveBarrier?D=E.resolveBarrier.isOpen()?3:2:D=E.actual.canResolveChildren?1:0:D=0,D!==E.expand&&(E.expand=D,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:D}}),D===1&&E.expandLevels!==void 0&&this.resolveChildren(E))}expandChildren(E,D){if(D<0)return;const p=[];for(const[r,s]of this.options.getChildren(E.actual)){const i=this.expand(d.TestId.joinToString(E.fullId,s.id),D);(0,w.isThenable)(i)&&p.push(i)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this._resolveHandler){const s=new w.Barrier;return s.open(),s}E.expand=2,this.pushExpandStateUpdate(E);const D=E.resolveBarrier=new w.Barrier,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let r;try{r=this._resolveHandler(E.actual===this.root?void 0:E.actual)}catch(s){p(s)}return(0,w.isThenable)(r)?r.catch(p).then(()=>{D.open(),this.updateExpandability(E)}):(D.open(),this.updateExpandability(E)),E.resolveBarrier}pushExpandStateUpdate(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}removeItem(E){const D=this.tree.get(E);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const p=[D];for(;p.length;){const r=p.pop();if(r){this.options.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(r.fullId.toString());for(const[s,i]of this.options.getChildren(r.actual))p.push(this.tree.get(d.TestId.joinToString(r.fullId,i.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.diffOpEmitter.fire(E)}}e.TestItemCollection=v;class g extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=g;class f extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class t extends Error{constructor(E,D,p){super(`TestItem with ID "${E}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=t;const n=(l,E,D)=>{let p=new Map;return{get size(){return p.size},forEach(r,s){for(const i of p.values())r.call(s,i,this)},[Symbol.iterator](){return p.entries()},replace(r){const s=new Map,i=new Set(p.keys()),o={op:5,ops:[]};for(const S of r){if(!(S instanceof D))throw new f(S.id);const b=E(S).controllerId;if(b!==l.controllerId)throw new t(S.id,b,l.controllerId);if(s.has(S.id))throw new g(S.id);s.set(S.id,S),i.delete(S.id),o.ops.push({op:0,item:S})}for(const S of i.keys())o.ops.push({op:3,id:S});l.listener?.(o),p=s},add(r){if(!(r instanceof D))throw new f(r.id);p.set(r.id,r),l.listener?.({op:0,item:r})},delete(r){p.delete(r)&&l.listener?.({op:3,id:r})},get(r){return p.get(r)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=n}),define(Te[101],Ae([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,k=(T,d)=>{const y={controllerId:d};return R.set(T,y),y};e.createPrivateApiFor=k;const F=T=>{const d=R.get(T);if(!d)throw new w.InvalidTestItemError(T?.id||"<unknown>");return d};e.getPrivateApiFor=F}),define(Te[77],Ae([1,0,13,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(d,y){return d.scheme===w.Schemas.http||d.scheme===w.Schemas.https?d:(y&&y.authority&&y.isRemote&&d.scheme===w.Schemas.file&&(d=R.URI.from({scheme:w.Schemas.vscodeRemote,authority:y.authority,path:d.path})),R.URI.from({scheme:w.Schemas.https,authority:`${d.scheme}+${F(d.authority)}.${e.webviewRootResourceAuthority}`,path:d.path,fragment:d.fragment,query:d.query}))}e.asWebviewUri=k;function F(d){return d.replace(/./g,y=>{const m=y.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?y:"-"+m.toString(16).padStart(4,"0")})}function T(d){return d.replace(/-([0-9a-f]{4})/g,(y,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=T}),define(Te[198],Ae([1,0,5,6,77]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(d,y,m){this._proxy=d,this._editors=y,this._remoteInfo=m,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const P=y.getVisibleTextEditors();for(const _ of this._insets.values())P.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(d=>d.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(d,y,m,P,_){let a;for(const E of this._editors.getVisibleTextEditors(!0))if(E.value===d){a=E;break}if(!a)throw new Error("not a visible editor");const v=this,g=this._handlePool++,f=new w.Emitter,t=new w.Emitter,n=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(E){return(0,k.asWebviewUri)(E,v._remoteInfo)}get cspSource(){return k.webviewGenericCspSource}set options(E){this._options=E,v._proxy.$setOptions(g,E)}get options(){return this._options}set html(E){this._html=E,v._proxy.$setHtml(g,E)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(E){return v._proxy.$postMessage(g,E)}},l=new class{constructor(){this.editor=d,this.line=y,this.height=m,this.webview=n,this.onDidDispose=t.event}dispose(){v._insets.has(g)&&(v._insets.delete(g),v._proxy.$disposeEditorInset(g),t.fire(),t.dispose(),f.dispose())}};return this._proxy.$createEditorInset(g,a.id,a.value.document.uri,y+1,m,P||{},_.identifier,_.extensionLocation),this._insets.set(g,{editor:d,inset:l,onDidReceiveMessage:f}),l}$onDidDispose(d){const y=this._insets.get(d);y&&y.inset.dispose()}$onDidReceiveMessage(d,y){this._insets.get(d)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=F}),define(Te[199],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var R;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class k extends Error{constructor(T,d){super(d),this.variable=T}}e.VariableError=k}),define(Te[200],Ae([1,0,19,74,16,24,22,90,165,199,15]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class _{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,g,f,t){this._contributedVariables=new Map,this._context=v,this._labelService=g,this._userHomePromise=f,t&&(this._envVariablesPromise=t.then(n=>this.prepareEnv(n)))}prepareEnv(v){if(T.isWindows){const g=Object.create(null);return Object.keys(v).forEach(f=>{g[f.toLowerCase()]=v[f]}),g}return v}resolveWithEnvironment(v,g,f){return this.recursiveResolve({env:this.prepareEnv(v),userHome:void 0},g?g.uri:void 0,f)}async resolveAsync(v,g){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,v?v.uri:void 0,g)}async resolveAnyBase(v,g,f,t){const n=F.deepClone(g);T.isWindows&&n.windows?Object.keys(n.windows).forEach(E=>n[E]=n.windows[E]):T.isMacintosh&&n.osx?Object.keys(n.osx).forEach(E=>n[E]=n.osx[E]):T.isLinux&&n.linux&&Object.keys(n.linux).forEach(E=>n[E]=n.linux[E]),delete n.windows,delete n.osx,delete n.linux;const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,v?v.uri:void 0,n,f,t)}async resolveAnyAsync(v,g,f){return this.resolveAnyBase(v,g,f)}async resolveAnyMap(v,g,f){const t=new Map;return{newConfig:await this.resolveAnyBase(v,g,f,t),resolvedVariables:t}}resolveWithInteractionReplace(v,g,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,g,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,g){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,g)}async recursiveResolve(v,g,f,t,n){if(k.isString(f))return this.resolveString(v,g,f,t,n);if(Array.isArray(f))return Promise.all(f.map(l=>this.recursiveResolve(v,g,l,t,n)));if(k.isObject(f)){const l=Object.create(null),E=await Promise.all(Object.keys(f).map(async D=>[await this.resolveString(v,g,D,t,n),await this.recursiveResolve(v,g,f[D],t,n)]));for(const[D,p]of E)l[D]=p;return l}return f}resolveString(v,g,f,t,n){return(0,P.replaceAsync)(f,_.VARIABLE_REGEXP,async(l,E)=>{if(E.includes(_.VARIABLE_LHS))return l;let D=await this.evaluateSingleVariable(v,l,E,g,t);return n?.set(E,D),D!==l&&k.isString(D)&&D.match(_.VARIABLE_REGEXP)&&(D=await this.resolveString(v,g,D,t,n)),D})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}async evaluateSingleVariable(v,g,f,t,n){let l;const E=f.split(":");E.length>1&&(f=E[0],l=E[1]);const D=s=>{const i=this._context.getFilePath();if(i)return(0,d.normalizeDriveLetter)(i);throw new m.VariableError(s,(0,y.localize)(0,null,g))},p=s=>{const i=D(s);if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return(0,d.normalizeDriveLetter)(o)}throw new m.VariableError(s,(0,y.localize)(1,null,g,w.basename(i)))},r=s=>{if(l){const i=this._context.getFolderUri(l);if(i)return i;throw new m.VariableError(s,(0,y.localize)(2,null,g,l))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new m.VariableError(s,(0,y.localize)(3,null,g)):new m.VariableError(s,(0,y.localize)(4,null,g))};switch(f){case"env":if(l){if(v.env){const s=v.env[T.isWindows?l.toLowerCase():l];if(k.isString(s))return s}return""}throw new m.VariableError(m.VariableKind.Env,(0,y.localize)(5,null,g));case"config":if(l){const s=this._context.getConfigurationValue(t,l);if(k.isUndefinedOrNull(s))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(6,null,g,l));if(k.isObject(s))throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(7,null,g,l));return s}throw new m.VariableError(m.VariableKind.Config,(0,y.localize)(8,null,g));case"command":return this.resolveFromMap(m.VariableKind.Command,g,l,n,"command");case"input":return this.resolveFromMap(m.VariableKind.Input,g,l,n,"input");case"extensionInstallFolder":if(l){const s=await this._context.getExtension(l);if(!s)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,g,l));return this.fsPath(s.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,g));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,d.normalizeDriveLetter)(this.fsPath(r(m.VariableKind.WorkspaceFolder)));case"cwd":return t||l?(0,d.normalizeDriveLetter)(this.fsPath(r(m.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,d.normalizeDriveLetter)(w.basename(this.fsPath(r(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,y.localize)(11,null,g))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new m.VariableError(m.VariableKind.LineNumber,(0,y.localize)(12,null,g))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new m.VariableError(m.VariableKind.SelectedText,(0,y.localize)(13,null,g))}case"file":return D(m.VariableKind.File);case"fileWorkspaceFolder":return p(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||l?w.relative(this.fsPath(r(m.VariableKind.RelativeFile)),D(m.VariableKind.RelativeFile)):D(m.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.dirname(D(m.VariableKind.RelativeFileDirname));if(t||l){const i=w.relative(this.fsPath(r(m.VariableKind.RelativeFileDirname)),s);return i.length===0?".":i}return s}case"fileDirname":return w.dirname(D(m.VariableKind.FileDirname));case"fileExtname":return w.extname(D(m.VariableKind.FileExtname));case"fileBasename":return w.basename(D(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.basename(D(m.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.extname(s).length)}case"fileDirnameBasename":return w.basename(w.dirname(D(m.VariableKind.FileDirnameBasename)));case"execPath":{const s=this._context.getExecPath();return s||g}case"execInstallFolder":{const s=this._context.getAppRoot();return s||g}case"pathSeparator":return w.sep;default:try{const s=l?`${f}:${l}`:f;return this.resolveFromMap(m.VariableKind.Unknown,g,s,n,void 0)}catch{return g}}}}resolveFromMap(v,g,f,t,n){if(f&&t){const l=n===void 0?t[f]:t[n+":"+f];if(typeof l=="string")return l;throw new m.VariableError(v,(0,y.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=_}),define(Te[102],Ae([1,0,4,99]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var k;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var F;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var T;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var d;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(d||(e.GroupsArrangement=d={}));var y;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function m(g){const f=g;return(0,R.isEditorInput)(f?.editor)&&(0,R.isEditorInput)(f?.replacement)}e.isEditorReplacement=m;var P;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var _;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(_||(e.OpenEditorContext=_={}));function a(g){const f=g;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=a;function v(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(Te[201],Ae([1,0,4,102]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(F){const T=F;return typeof F=="number"||(0,R.isEditorGroup)(T)}e.isPreferredGroup=k}),define(Te[8],Ae([1,0,18,25,122,202,49,28,116,69,68,24,16,2,44,78,94,101,99,75,45,57,201,7]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(ke){function Re(j){const{selectionStartLineNumber:Oe,selectionStartColumn:$e,positionLineNumber:Ke,positionColumn:ze}=j,Ze=new s.Position(Oe-1,$e-1),pt=new s.Position(Ke-1,ze-1);return new s.Selection(Ze,pt)}ke.to=Re;function ge(j){const{anchor:Oe,active:$e}=j;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}ke.from=ge})(i||(e.Selection=i={}));var o;(function(ke){function Re(j){if(!j)return;const{start:Oe,end:$e}=j;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}ke.from=Re;function ge(j){if(!j)return;const{startLineNumber:Oe,startColumn:$e,endLineNumber:Ke,endColumn:ze}=j;return new s.Range(Oe-1,$e-1,Ke-1,ze-1)}ke.to=ge})(o||(e.Range=o={}));var S;(function(ke){function Re(ge){switch(ge){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ke.to=Re})(S||(e.TokenType=S={}));var b;(function(ke){function Re(j){return new s.Position(j.lineNumber-1,j.column-1)}ke.to=Re;function ge(j){return{lineNumber:j.line+1,column:j.character+1}}ke.from=ge})(b||(e.Position=b={}));var C;(function(ke){function Re(Oe,$e,Ke){return(0,w.coalesce)((0,w.asArray)(Oe).map(ze=>ge(ze,$e,Ke)))}ke.from=Re;function ge(Oe,$e,Ke){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ke?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:j(Oe.scheme,$e),pattern:st.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ke?.isBuiltin}}function j(Oe,$e){return $e&&typeof Oe=="string"?$e.transformOutgoingScheme(Oe):Oe}})(C||(e.DocumentSelector=C={}));var I;(function(ke){function Re(j){switch(j){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ke.from=Re;function ge(j){switch(j){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ke.to=ge})(I||(e.DiagnosticTag=I={}));var c;(function(ke){function Re(j){let Oe;return j.code&&((0,a.isString)(j.code)||(0,a.isNumber)(j.code)?Oe=String(j.code):Oe={value:String(j.code.value),target:j.code.target}),{...o.from(j.range),message:j.message,source:j.source,code:Oe,severity:u.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(h.from),tags:Array.isArray(j.tags)?(0,w.coalesce)(j.tags.map(I.from)):void 0}}ke.from=Re;function ge(j){const Oe=new s.Diagnostic(o.to(j),j.message,u.to(j.severity));return Oe.source=j.source,Oe.code=(0,a.isString)(j.code)?j.code:j.code?.value,Oe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(h.to),Oe.tags=j.tags&&(0,w.coalesce)(j.tags.map(I.to)),Oe}ke.to=ge})(c||(e.Diagnostic=c={}));var h;(function(ke){function Re(j){return{...o.from(j.location.range),message:j.message,resource:j.location.uri}}ke.from=Re;function ge(j){return new s.DiagnosticRelatedInformation(new s.Location(j.resource,o.to(j)),j.message)}ke.to=ge})(h||(e.DiagnosticRelatedInformation=h={}));var u;(function(ke){function Re(j){switch(j){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ke.from=Re;function ge(j){switch(j){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ke.to=ge})(u||(e.DiagnosticSeverity=u={}));var A;(function(ke){function Re(j){return typeof j=="number"&&j>=s.ViewColumn.One?j-1:j===s.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ke.from=Re;function ge(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}ke.to=ge})(A||(e.ViewColumn=A={}));function B(ke){return typeof ke.range<"u"}function H(ke){return ke.length===0?!0:!!B(ke[0])}e.isDecorationOptionsArr=H;var U;(function(ke){function Re(ze){return ze.map(ke.from)}ke.fromMany=Re;function ge(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function j(ze){let Ze;if(ge(ze)){const{language:lt,value:gt}=ze;Ze={value:"```"+lt+`
`+gt+"\n```\n"}}else s.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const pt=Object.create(null);Ze.uris=pt;const kt=lt=>{try{let gt=v.URI.parse(lt,!0);gt=gt.with({query:Oe(gt.query,pt)}),pt[lt]=gt}catch{}return""},bt=new y.marked.Renderer;return bt.link=kt,bt.image=lt=>typeof lt=="string"?kt(T.parseHrefAndDimensions(lt).href):"",(0,y.marked)(Ze.value,{renderer:bt}),Ze}ke.from=j;function Oe(ze,Ze){if(!ze)return ze;let pt;try{pt=(0,m.parse)(ze)}catch{}if(!pt)return ze;let kt=!1;return pt=(0,_.cloneAndChange)(pt,bt=>{if(v.URI.isUri(bt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[lt]=bt,kt=!0,lt}else return}),kt?JSON.stringify(pt):ze}function $e(ze){const Ze=new s.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?v.URI.from(ze.baseUri):void 0,Ze}ke.to=$e;function Ke(ze){if(ze)return typeof ze=="string"?ze:ke.from(ze)}ke.fromStrict=Ke})(U||(e.MarkdownString=U={}));function z(ke){return H(ke)?ke.map(Re=>({range:o.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?U.fromMany(Re.hoverMessage):Re.hoverMessage?U.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ke.map(Re=>({range:o.from(Re)}))}e.fromRangeOrRangeWithMessage=z;function M(ke){return typeof ke>"u"?ke:typeof ke=="string"?v.URI.file(ke):ke}e.pathOrURIToURI=M;var N;(function(ke){function Re(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?M(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}ke.from=Re})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ee;(function(ke){function Re(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?M(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}ke.from=Re})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Q;(function(ke){function Re(ge){if(typeof ge>"u")return ge;switch(ge){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ke.from=Re})(Q||(e.DecorationRangeBehavior=Q={}));var Se;(function(ke){function Re(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Q.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ee.from(ge.light):void 0,dark:ge.dark?ee.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?M(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}ke.from=Re})(Se||(e.DecorationRenderOptions=Se={}));var ye;(function(ke){function Re(j){return{text:j.newText,eol:j.newEol&&Ye.from(j.newEol),range:o.from(j.range)}}ke.from=Re;function ge(j){const Oe=new s.TextEdit(o.to(j.range),j.text);return Oe.newEol=typeof j.eol>"u"?void 0:Ye.to(j.eol),Oe}ke.to=ge})(ye||(e.TextEdit=ye={}));var Pe;(function(ke){function Re(j,Oe){const $e={edits:[]};if(j instanceof s.WorkspaceEdit){const Ke=new d.ResourceSet;for(const ze of j._allEntries())ze._type===1&&v.URI.isUri(ze.to)&&ze.from===void 0&&Ke.add(ze.to);for(const ze of j._allEntries())if(ze._type===1){let Ze;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?Ze={type:"base64",value:(0,R.encodeBase64)(R.VSBuffer.wrap(ze.options.contents))}:Ze={type:"dataTransferItem",id:ze.options.contents._itemId}),$e.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:Ze},metadata:ze.metadata})}else ze._type===2?$e.edits.push({resource:ze.uri,textEdit:ye.from(ze.edit),versionId:Ke.has(ze.uri)?void 0:Oe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?$e.edits.push({resource:ze.uri,textEdit:{range:o.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ke.has(ze.uri)?void 0:Oe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?$e.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&$e.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(ht.from)}})}return $e}ke.from=Re;function ge(j){const Oe=new s.WorkspaceEdit,$e=new d.ResourceMap;for(const Ke of j.edits)if(Ke.textEdit){const ze=Ke,Ze=v.URI.revive(ze.resource),pt=o.to(ze.textEdit.range),kt=ze.textEdit.text,bt=ze.textEdit.insertAsSnippet;let lt;bt?lt=s.SnippetTextEdit.replace(pt,new s.SnippetString(kt)):lt=s.TextEdit.replace(pt,kt);const gt=$e.get(Ze);gt?gt.push(lt):$e.set(Ze,[lt])}else Oe.renameFile(v.URI.revive(Ke.oldResource),v.URI.revive(Ke.newResource),Ke.options);for(const[Ke,ze]of $e)Oe.set(Ke,ze);return Oe}ke.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var Y;(function(ke){const Re=Object.create(null);Re[s.SymbolKind.File]=0,Re[s.SymbolKind.Module]=1,Re[s.SymbolKind.Namespace]=2,Re[s.SymbolKind.Package]=3,Re[s.SymbolKind.Class]=4,Re[s.SymbolKind.Method]=5,Re[s.SymbolKind.Property]=6,Re[s.SymbolKind.Field]=7,Re[s.SymbolKind.Constructor]=8,Re[s.SymbolKind.Enum]=9,Re[s.SymbolKind.Interface]=10,Re[s.SymbolKind.Function]=11,Re[s.SymbolKind.Variable]=12,Re[s.SymbolKind.Constant]=13,Re[s.SymbolKind.String]=14,Re[s.SymbolKind.Number]=15,Re[s.SymbolKind.Boolean]=16,Re[s.SymbolKind.Array]=17,Re[s.SymbolKind.Object]=18,Re[s.SymbolKind.Key]=19,Re[s.SymbolKind.Null]=20,Re[s.SymbolKind.EnumMember]=21,Re[s.SymbolKind.Struct]=22,Re[s.SymbolKind.Event]=23,Re[s.SymbolKind.Operator]=24,Re[s.SymbolKind.TypeParameter]=25;function ge(Oe){return typeof Re[Oe]=="number"?Re[Oe]:6}ke.from=ge;function j(Oe){for(const $e in Re)if(Re[$e]===Oe)return Number($e);return s.SymbolKind.Property}ke.to=j})(Y||(e.SymbolKind=Y={}));var ue;(function(ke){function Re(j){switch(j){case s.SymbolTag.Deprecated:return 1}}ke.from=Re;function ge(j){switch(j){case 1:return s.SymbolTag.Deprecated}}ke.to=ge})(ue||(e.SymbolTag=ue={}));var _e;(function(ke){function Re(j){return{name:j.name,kind:Y.from(j.kind),tags:j.tags&&j.tags.map(ue.from),containerName:j.containerName,location:W.from(j.location)}}ke.from=Re;function ge(j){const Oe=new s.SymbolInformation(j.name,Y.to(j.kind),j.containerName,W.to(j.location));return Oe.tags=j.tags&&j.tags.map(ue.to),Oe}ke.to=ge})(_e||(e.WorkspaceSymbol=_e={}));var ce;(function(ke){function Re(j){const Oe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:o.from(j.range),selectionRange:o.from(j.selectionRange),kind:Y.from(j.kind),tags:j.tags?.map(ue.from)??[]};return j.children&&(Oe.children=j.children.map(Re)),Oe}ke.from=Re;function ge(j){const Oe=new s.DocumentSymbol(j.name,j.detail,Y.to(j.kind),o.to(j.range),o.to(j.selectionRange));return(0,w.isNonEmptyArray)(j.tags)&&(Oe.tags=j.tags.map(ue.to)),j.children&&(Oe.children=j.children.map(ge)),Oe}ke.to=ge})(ce||(e.DocumentSymbol=ce={}));var pe;(function(ke){function Re(j){const Oe=new s.CallHierarchyItem(Y.to(j.kind),j.name,j.detail||"",v.URI.revive(j.uri),o.to(j.range),o.to(j.selectionRange));return Oe._sessionId=j._sessionId,Oe._itemId=j._itemId,Oe}ke.to=Re;function ge(j,Oe,$e){if(Oe=Oe??j._sessionId,$e=$e??j._itemId,Oe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:$e,name:j.name,detail:j.detail,kind:Y.from(j.kind),uri:j.uri,range:o.from(j.range),selectionRange:o.from(j.selectionRange),tags:j.tags?.map(ue.from)}}ke.from=ge})(pe||(e.CallHierarchyItem=pe={}));var ie;(function(ke){function Re(ge){return new s.CallHierarchyIncomingCall(pe.to(ge.from),ge.fromRanges.map(j=>o.to(j)))}ke.to=Re})(ie||(e.CallHierarchyIncomingCall=ie={}));var x;(function(ke){function Re(ge){return new s.CallHierarchyOutgoingCall(pe.to(ge.to),ge.fromRanges.map(j=>o.to(j)))}ke.to=Re})(x||(e.CallHierarchyOutgoingCall=x={}));var W;(function(ke){function Re(j){return{range:j.range&&o.from(j.range),uri:j.uri}}ke.from=Re;function ge(j){return new s.Location(v.URI.revive(j.uri),o.to(j.range))}ke.to=ge})(W||(e.location=W={}));var le;(function(ke){function Re(j){const Oe=j,$e=j;return{originSelectionRange:Oe.originSelectionRange?o.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:$e.uri,range:o.from(Oe.targetRange?Oe.targetRange:$e.range),targetSelectionRange:Oe.targetSelectionRange?o.from(Oe.targetSelectionRange):void 0}}ke.from=Re;function ge(j){return{targetUri:v.URI.revive(j.uri),targetRange:o.to(j.range),targetSelectionRange:j.targetSelectionRange?o.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?o.to(j.originSelectionRange):void 0}}ke.to=ge})(le||(e.DefinitionLink=le={}));var we;(function(ke){function Re(j){return{range:o.from(j.range),contents:U.fromMany(j.contents)}}ke.from=Re;function ge(j){return new s.Hover(j.contents.map(U.to),o.to(j.range))}ke.to=ge})(we||(e.Hover=we={}));var Ee;(function(ke){function Re(j){return{range:o.from(j.range),expression:j.expression}}ke.from=Re;function ge(j){return new s.EvaluatableExpression(o.to(j.range),j.expression)}ke.to=ge})(Ee||(e.EvaluatableExpression=Ee={}));var me;(function(ke){function Re(j){if(j instanceof s.InlineValueText)return{type:"text",range:o.from(j.range),text:j.text};if(j instanceof s.InlineValueVariableLookup)return{type:"variable",range:o.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}ke.from=Re;function ge(j){switch(j.type){case"text":return{range:o.to(j.range),text:j.text};case"variable":return{range:o.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:o.to(j.range),expression:j.expression}}}ke.to=ge})(me||(e.InlineValue=me={}));var De;(function(ke){function Re(j){return{frameId:j.frameId,stoppedLocation:o.from(j.stoppedLocation)}}ke.from=Re;function ge(j){return new s.InlineValueContext(j.frameId,o.to(j.stoppedLocation))}ke.to=ge})(De||(e.InlineValueContext=De={}));var re;(function(ke){function Re(j){return{range:o.from(j.range),kind:j.kind}}ke.from=Re;function ge(j){return new s.DocumentHighlight(o.to(j.range),j.kind)}ke.to=ge})(re||(e.DocumentHighlight=re={}));var de;(function(ke){function Re(ge){switch(ge){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ke.to=Re})(de||(e.CompletionTriggerKind=de={}));var se;(function(ke){function Re(ge){return{triggerKind:de.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}ke.to=Re})(se||(e.CompletionContext=se={}));var oe;(function(ke){function Re(j){switch(j){case s.CompletionItemTag.Deprecated:return 1}}ke.from=Re;function ge(j){switch(j){case 1:return s.CompletionItemTag.Deprecated}}ke.to=ge})(oe||(e.CompletionItemTag=oe={}));var fe;(function(ke){const Re=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ge($e){return Re.get($e)??9}ke.from=ge;const j=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Oe($e){return j.get($e)??s.CompletionItemKind.Property}ke.to=Oe})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(ke){function Re(ge,j){const Oe=new s.CompletionItem(ge.label);return Oe.insertText=ge.insertText,Oe.kind=fe.to(ge.kind),Oe.tags=ge.tags?.map(oe.to),Oe.detail=ge.detail,Oe.documentation=T.isMarkdownString(ge.documentation)?U.to(ge.documentation):ge.documentation,Oe.sortText=ge.sortText,Oe.filterText=ge.filterText,Oe.preselect=ge.preselect,Oe.commitCharacters=ge.commitCharacters,g.Range.isIRange(ge.range)?Oe.range=o.to(ge.range):typeof ge.range=="object"&&(Oe.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Oe.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Oe.insertText=new s.SnippetString(ge.insertText):(Oe.insertText=ge.insertText,Oe.textEdit=Oe.range instanceof s.Range?new s.TextEdit(Oe.range,Oe.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ge.additionalTextEdits.map($e=>ye.to($e))),Oe.command=j&&ge.command?j.fromInternal(ge.command):void 0,Oe}ke.to=Re})(Ie||(e.CompletionItem=Ie={}));var O;(function(ke){function Re(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:U.fromStrict(j.documentation)}}ke.from=Re;function ge(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?U.to(j.documentation):j.documentation}}ke.to=ge})(O||(e.ParameterInformation=O={}));var V;(function(ke){function Re(j){return{label:j.label,documentation:U.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(O.from):[],activeParameter:j.activeParameter}}ke.from=Re;function ge(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?U.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(O.to):[],activeParameter:j.activeParameter}}ke.to=ge})(V||(e.SignatureInformation=V={}));var K;(function(ke){function Re(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(V.from):[]}}ke.from=Re;function ge(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(V.to):[]}}ke.to=ge})(K||(e.SignatureHelp=K={}));var G;(function(ke){function Re(ge,j){const Oe=new s.InlayHint(b.to(j.position),typeof j.label=="string"?j.label:j.label.map(q.to.bind(void 0,ge)),j.kind&&Z.to(j.kind));return Oe.textEdits=j.textEdits&&j.textEdits.map(ye.to),Oe.tooltip=T.isMarkdownString(j.tooltip)?U.to(j.tooltip):j.tooltip,Oe.paddingLeft=j.paddingLeft,Oe.paddingRight=j.paddingRight,Oe}ke.to=Re})(G||(e.InlayHint=G={}));var q;(function(ke){function Re(ge,j){const Oe=new s.InlayHintLabelPart(j.label);return Oe.tooltip=T.isMarkdownString(j.tooltip)?U.to(j.tooltip):j.tooltip,f.Command.is(j.command)&&(Oe.command=ge.fromInternal(j.command)),j.location&&(Oe.location=W.to(j.location)),Oe}ke.to=Re})(q||(e.InlayHintLabelPart=q={}));var Z;(function(ke){function Re(j){return j}ke.from=Re;function ge(j){return j}ke.to=ge})(Z||(e.InlayHintKind=Z={}));var ae;(function(ke){function Re(j){return{range:o.from(j.range),url:j.target,tooltip:j.tooltip}}ke.from=Re;function ge(j){let Oe;if(j.url)try{Oe=typeof j.url=="string"?v.URI.parse(j.url,!0):v.URI.revive(j.url)}catch{}return new s.DocumentLink(o.to(j.range),Oe)}ke.to=ge})(ae||(e.DocumentLink=ae={}));var Me;(function(ke){function Re(j){const Oe=new s.ColorPresentation(j.label);return j.textEdit&&(Oe.textEdit=ye.to(j.textEdit)),j.additionalTextEdits&&(Oe.additionalTextEdits=j.additionalTextEdits.map($e=>ye.to($e))),Oe}ke.to=Re;function ge(j){return{label:j.label,textEdit:j.textEdit?ye.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Oe=>ye.from(Oe)):void 0}}ke.from=ge})(Me||(e.ColorPresentation=Me={}));var Ue;(function(ke){function Re(j){return new s.Color(j[0],j[1],j[2],j[3])}ke.to=Re;function ge(j){return[j.red,j.green,j.blue,j.alpha]}ke.from=ge})(Ue||(e.Color=Ue={}));var Ge;(function(ke){function Re(j){return{range:o.from(j.range)}}ke.from=Re;function ge(j){return new s.SelectionRange(o.to(j.range))}ke.to=ge})(Ge||(e.SelectionRange=Ge={}));var je;(function(ke){function Re(ge){switch(ge){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ke.to=Re})(je||(e.TextDocumentSaveReason=je={}));var Je;(function(ke){function Re(j){switch(j){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ke.from=Re;function ge(j){switch(j){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ke.to=ge})(Je||(e.TextEditorLineNumbersStyle=Je={}));var Ye;(function(ke){function Re(j){if(j===s.EndOfLine.CRLF)return 1;if(j===s.EndOfLine.LF)return 0}ke.from=Re;function ge(j){if(j===1)return s.EndOfLine.CRLF;if(j===0)return s.EndOfLine.LF}ke.to=ge})(Ye||(e.EndOfLine=Ye={}));var et;(function(ke){function Re(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ke.from=Re})(et||(e.ProgressLocation=et={}));var it;(function(ke){function Re(j){const Oe={start:j.start+1,end:j.end+1};return j.kind&&(Oe.kind=tt.from(j.kind)),Oe}ke.from=Re;function ge(j){const Oe={start:j.start-1,end:j.end-1};return j.kind&&(Oe.kind=tt.to(j.kind)),Oe}ke.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(ke){function Re(j){if(j)switch(j){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}ke.from=Re;function ge(j){if(j)switch(j.value){case f.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}ke.to=ge})(tt||(e.FoldingRangeKind=tt={}));var xe;(function(ke){function Re(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?l.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ke.from=Re})(xe||(e.TextEditorOpenOptions=xe={}));var st;(function(ke){function Re($e){return $e instanceof s.RelativePattern?$e.toJSON():typeof $e=="string"?$e:ge($e)||j($e)?new s.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}ke.from=Re;function ge($e){const Ke=$e;return Ke?v.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function j($e){const Ke=$e;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Oe($e){return typeof $e=="string"?$e:new s.RelativePattern(v.URI.revive($e.baseUri),$e.pattern)}ke.to=Oe})(st||(e.GlobPattern=st={}));var J;(function(ke){function Re(ge){if(ge){if(Array.isArray(ge))return ge.map(Re);if(typeof ge=="string")return ge;{const j=ge;return{language:j.language,scheme:j.scheme,pattern:st.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}ke.from=Re})(J||(e.LanguageSelector=J={}));var X;(function(ke){function Re(j){return!!j&&typeof j=="object"&&"documents"in j&&Array.isArray(j.documents)&&j.documents.every(Oe=>Array.isArray(Oe)&&Oe.every($e=>$e&&typeof $e=="object"&&"uri"in $e&&v.URI.isUri($e.uri)&&"version"in $e&&typeof $e.version=="number"&&"ranges"in $e&&Array.isArray($e.ranges)&&$e.ranges.every(Ke=>Ke instanceof s.Range)))}ke.is=Re;function ge(j){return{documents:j.documents.map(Oe=>Oe.map($e=>({uri:v.URI.from($e.uri),version:$e.version,ranges:$e.ranges.map(Ke=>o.from(Ke))})))}}ke.from=ge})(X||(e.MappedEditsContext=X={}));var ve;(function(ke){function Re(j){return{start:j.start,end:j.end}}ke.from=Re;function ge(j){return new s.NotebookRange(j.start,j.end)}ke.to=ge})(ve||(e.NotebookRange=ve={}));var Be;(function(ke){function Re(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}ke.to=Re;function ge(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}ke.from=ge})(Be||(e.NotebookCellExecutionSummary=Be={}));var Ne;(function(ke){function Re(ge){if(ge===E.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ge===E.NotebookCellExecutionState.Pending)return;if(ge===E.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}ke.to=Re})(Ne||(e.NotebookCellExecutionState=Ne={}));var Xe;(function(ke){function Re(j){switch(j){case s.NotebookCellKind.Markup:return E.CellKind.Markup;case s.NotebookCellKind.Code:default:return E.CellKind.Code}}ke.from=Re;function ge(j){switch(j){case E.CellKind.Markup:return s.NotebookCellKind.Markup;case E.CellKind.Code:default:return s.NotebookCellKind.Code}}ke.to=ge})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(ke){function Re(j){const Oe={metadata:j.metadata??Object.create(null),cells:[]};for(const $e of j.cells)s.NotebookCellData.validate($e),Oe.cells.push(ht.from($e));return Oe}ke.from=Re;function ge(j){const Oe=new s.NotebookData(j.cells.map(ht.to));return(0,a.isEmptyObject)(j.metadata)||(Oe.metadata=j.metadata),Oe}ke.to=ge})(nt||(e.NotebookData=nt={}));var ht;(function(ke){function Re(j){return{cellKind:Xe.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Be.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(Pt.from):[]}}ke.from=Re;function ge(j){return new s.NotebookCellData(Xe.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(Pt.to):void 0,j.metadata,j.internalMetadata?Be.to(j.internalMetadata):void 0)}ke.to=ge})(ht||(e.NotebookCellData=ht={}));var wt;(function(ke){function Re(j){return{mime:j.mime,valueBytes:R.VSBuffer.wrap(j.data)}}ke.from=Re;function ge(j){return new s.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}ke.to=ge})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(ke){function Re(j){return{outputId:j.id,items:j.items.map(wt.from),metadata:j.metadata}}ke.from=Re;function ge(j){const Oe=j.items.map(wt.to);return new s.NotebookCellOutput(Oe,j.outputId,j.metadata)}ke.to=ge})(Pt||(e.NotebookCellOutput=Pt={}));var Xt;(function(ke){function Re(Oe){return j(Oe)?{include:st.from(Oe.include)??void 0,exclude:st.from(Oe.exclude)??void 0}:st.from(Oe)??void 0}ke.from=Re;function ge(Oe){return j(Oe)?{include:st.to(Oe.include),exclude:st.to(Oe.exclude)}:st.to(Oe)}ke.to=ge;function j(Oe){const $e=Oe;return $e?!(0,a.isUndefinedOrNull)($e.include)&&!(0,a.isUndefinedOrNull)($e.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Vt;(function(ke){function Re(ge,j,Oe){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal($e,Oe),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}ke.from=Re})(Vt||(e.NotebookStatusBarItem=Vt={}));var vt;(function(ke){function Re(ge,j,Oe){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:j.toInternal($e,Oe),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}ke.from=Re})(vt||(e.NotebookKernelSourceAction=vt={}));var $t;(function(ke){function Re(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}ke.from=Re})($t||(e.NotebookDocumentContentOptions=$t={}));var Nt;(function(ke){function Re(j){return{uri:j.uri,provides:j.provides}}ke.from=Re;function ge(j){return new s.NotebookRendererScript(v.URI.revive(j.uri),j.provides)}ke.to=ge})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(ke){function Re(j){return{message:U.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,contextValue:j.contextValue,location:j.location&&{range:o.from(j.location.range),uri:j.location.uri}}}ke.from=Re;function ge(j){const Oe=new s.TestMessage(typeof j.message=="string"?j.message:U.to(j.message));return Oe.actualOutput=j.actual,Oe.expectedOutput=j.expected,Oe.contextValue=j.contextValue,Oe.location=j.location?W.to(j.location):void 0,Oe}ke.to=ge})(Bt||(e.TestMessage=Bt={}));var Tt;(function(ke){ke.namespace=p.namespaceTestTag,ke.denamespace=p.denamespaceTestTag})(Tt||(e.TestTag=Tt={}));var At;(function(ke){function Re(j){const Oe=(0,n.getPrivateApiFor)(j).controllerId;return{extId:D.TestId.fromExtHostTestItem(j,Oe).toString(),label:j.label,uri:v.URI.revive(j.uri),busy:j.busy,tags:j.tags.map($e=>Tt.namespace(Oe,$e.id)),range:g.Range.lift(o.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&U.fromStrict(j.error)||null}}ke.from=Re;function ge(j){return{parent:void 0,error:void 0,id:D.TestId.fromString(j.extId).localId,label:j.label,uri:v.URI.revive(j.uri),tags:(j.tags||[]).map(Oe=>{const{tagId:$e}=Tt.denamespace(Oe);return new s.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}ke.toPlain=ge})(At||(e.TestItem=At={})),function(ke){function Re(j){return{id:j.id}}ke.from=Re;function ge(j){return new s.TestTag(j.id)}ke.to=ge}(Tt||(e.TestTag=Tt={}));var xt;(function(ke){const Re=(j,Oe)=>{const $e=[];for(const[ze,Ze]of Oe)D.TestId.compare(Ze.item.extId,ze)===2&&(Oe.delete(ze),$e.push(Ze));const Ke={...At.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(Bt.to)})),children:$e.map(ze=>Re(ze,Oe))};for(const ze of Ke.children)ze.parent=Ke;return Ke};function ge(j){const Oe=[],$e=new Map;for(const Ke of j.items){$e.set(Ke.item.extId,Ke);const ze=D.TestId.root(Ke.item.extId);j.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Ke.item.extId))&&Oe.push(Ke)}return{completedAt:j.completedAt,results:Oe.map(Ke=>Re(Ke,$e))}}ke.to=ge})(xt||(e.TestResults=xt={}));var zt;(function(ke){function Re($e){return{covered:$e.covered,total:$e.covered}}function ge($e){return"line"in $e?b.from($e):o.from($e)}function j($e){return"branches"in $e?{count:$e.executionCount,location:ge($e.location),type:1,branches:$e.branches.length?$e.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&ge(Ke.location)})):void 0}:{type:0,count:$e.executionCount,location:ge($e.location)}}ke.fromDetailed=j;function Oe($e){return{uri:$e.uri,statement:Re($e.statementCoverage),branch:$e.branchCoverage&&Re($e.branchCoverage),function:$e.functionCoverage&&Re($e.functionCoverage),details:$e.detailedCoverage?.map(j)}}ke.fromFile=Oe})(zt||(e.TestCoverage=zt={}));var qt;(function(ke){function Re(ge){switch(ge){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ke.to=Re})(qt||(e.CodeActionTriggerKind=qt={}));var Ht;(function(ke){function Re(j){const Oe=new s.TypeHierarchyItem(Y.to(j.kind),j.name,j.detail||"",v.URI.revive(j.uri),o.to(j.range),o.to(j.selectionRange));return Oe._sessionId=j._sessionId,Oe._itemId=j._itemId,Oe}ke.to=Re;function ge(j,Oe,$e){if(Oe=Oe??j._sessionId,$e=$e??j._itemId,Oe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:$e,kind:Y.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:o.from(j.range),selectionRange:o.from(j.selectionRange),tags:j.tags?.map(ue.from)}}ke.from=ge})(Ht||(e.TypeHierarchyItem=Ht={}));var Wt;(function(ke){function Re(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}ke.from=Re})(Wt||(e.ViewBadge=Wt={}));var ot;(function(ke){function Re($e,Ke,ze){const Ze=Ke.fileData;return Ze?new s.InternalFileDataTransferItem(new s.DataTransferFile(Ze.name,v.URI.revive(Ze.uri),Ze.id,(0,F.createSingleCallFunction)(()=>ze(Ze.id)))):$e===P.Mimes.uriList&&Ke.uriListData?new s.InternalDataTransferItem(Oe(Ke.uriListData)):new s.InternalDataTransferItem(Ke.asString)}ke.to=Re;async function ge($e,Ke){const ze=await Ke.asString();if($e===P.Mimes.uriList)return{asString:ze,fileData:void 0,uriListData:j(ze)};const Ze=Ke.asFile();return{asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri,id:Ze._itemId??Ze.id}:void 0}}ke.from=ge;function j($e){return k.UriList.split($e).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return v.URI.parse(Ke)}catch{}return Ke})}function Oe($e){return k.UriList.create($e.map(Ke=>typeof Ke=="string"?Ke:v.URI.revive(Ke)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(ke){function Re(j,Oe){const $e=j.items.map(([Ke,ze])=>[Ke,ot.to(Ke,ze,Oe)]);return new s.DataTransfer($e)}ke.toDataTransfer=Re;async function ge(j){const Oe={items:[]},$e=[];for(const[Ke,ze]of j)$e.push((async()=>{Oe.items.push([Ke,await ot.from(Ke,ze)])})());return await Promise.all($e),Oe}ke.from=ge})(ft||(e.DataTransfer=ft={}));var Rt;(function(ke){function Re(j){return{message:j.message,metadata:j.metadata,title:j.title,tooltip:j.tooltip}}ke.to=Re;function ge(j){return{kind:"reply",message:j.message,metadata:j.metadata,title:j.title,tooltip:j.tooltip}}ke.from=ge})(Rt||(e.ChatReplyFollowup=Rt={}));var Ot;(function(ke){function Re(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Rt.from(ge)}ke.from=Re})(Ot||(e.ChatFollowup=Ot={}));var It;(function(ke){function Re(j){const Oe=new s.ChatMessage(dt.to(j.role),j.content);return Oe.name=j.name,Oe}ke.to=Re;function ge(j){return{role:dt.from(j.role),content:j.content,name:j.name}}ke.from=ge})(It||(e.ChatMessage=It={}));var dt;(function(ke){function Re(j){switch(j){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}ke.to=Re;function ge(j){switch(j){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}ke.from=ge})(dt||(e.ChatMessageRole=dt={}));var yt;(function(ke){function Re(j){return{level:Dt.to(j.level),value:j.value,description:j.description}}ke.to=Re;function ge(j){return{level:Dt.from(j.level),value:j.value,description:j.description}}ke.from=ge})(yt||(e.ChatVariable=yt={}));var Dt;(function(ke){function Re(j){switch(j){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}ke.to=Re;function ge(j){switch(j){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}ke.from=ge})(Dt||(e.ChatVariableLevel=Dt={}));var Ft;(function(ke){function Re(ge){switch(ge){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}ke.to=Re})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var He;(function(ke){function Re(ge,j,Oe){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:j.toInternal(ge,Oe)}ke.from=Re})(He||(e.TerminalQuickFix=He={}))}),define(Te[203],Ae([1,0,2,9,7,8,173]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class d{constructor(m,P,_,a={timeout:1500,errors:3}){this._logService=m,this._documents=P,this._mainThreadBulkEdits=_,this._thresholds=a,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(m){return(P,_,a)=>{const g={dispose:this._callbacks.push([P,_,m])};return Array.isArray(a)&&a.push(g),g}}async $participateInSave(m,P){const _=w.URI.revive(m);let a=!1;const v=setTimeout(()=>a=!0,this._thresholds.timeout),g=[];try{for(const f of[...this._callbacks]){if(a)break;const t=this._documents.getDocument(_),n=await this._deliverEventAsyncAndBlameBadListeners(f,{document:t,reason:F.TextDocumentSaveReason.to(P)});g.push(n)}}finally{clearTimeout(v)}return g}_deliverEventAsyncAndBlameBadListeners([m,P,_],a){const v=this._badListeners.get(m);return typeof v=="number"&&v>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,m,P,a).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const f=this._badListeners.get(m);this._badListeners.set(m,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(m,P,_,a){const v=[],g=Date.now(),{document:f,reason:t}=a,{version:n}=f,l=Object.freeze({document:f,reason:t,waitUntil(E){if(Object.isFrozen(v))throw(0,R.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(E))}});try{P.apply(_,[l])}catch(E){return Promise.reject(E)}return Object.freeze(v),new Promise((E,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this._thresholds.timeout);return Promise.all(v).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(p),E(r)}).catch(r=>{clearTimeout(p),D(r)})}).then(E=>{const D={edits:[]};for(const p of E)if(Array.isArray(p)&&p.every(r=>r instanceof k.TextEdit))for(const{newText:r,newEol:s,range:i}of p)D.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:i&&F.Range.from(i),text:r,eol:s&&F.EndOfLine.from(s)}});if(D.edits.length!==0)return n===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=d}),define(Te[204],Ae([1,0,13,2,8,7,75]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class d{constructor(_,a,v,g){this.start=_,this.deletedCount=a,this.deletedItems=v,this.items=g}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(_=>_.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(_,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:_}}constructor(_,a,v){this.notebook=_,this._extHostDocument=a,this._cellData=v,this.handle=v.handle,this.uri=R.URI.revive(v.uri),this.cellKind=v.cellKind,this._outputs=v.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=v.internalMetadata??{},this._metadata=Object.freeze(v.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const _=this,a=this._extHostDocument.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return _.notebook.getCellIndex(_)},notebook:_.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:a.document,get mime(){return _._mime},set mime(g){_._mime=g},get outputs(){return _._outputs.slice(0)},get metadata(){return _._metadata},get executionSummary(){return _._previousResult}};this._apiCell=Object.freeze(v)}return this._apiCell}setOutputs(_){this._outputs=_.map(k.NotebookCellOutput.to)}setOutputItems(_,a,v){const g=v.map(k.NotebookCellOutputItem.to),f=this._outputs.find(t=>t.id===_);if(f&&(a||(f.items.length=0),f.items.push(...g),f.items.length>1&&f.items.every(t=>T.isTextStreamMime(t.mime)))){const t=new Map,n=[];f.items.forEach(l=>{let E;t.has(l.mime)?E=t.get(l.mime):(E=[],t.set(l.mime,E),n.push(l.mime)),E.push(l.data)}),f.items.length=0,n.forEach(l=>{const E=T.compressOutputItemStreams(t.get(l));f.items.push({mime:l,data:E.data.buffer})})}}setMetadata(_){this._metadata=Object.freeze(_)}setInternalMetadata(_){this._internalMetadata=_,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(_))}setMime(_){}}e.ExtHostCell=y;class m{static{this._handlePool=0}constructor(_,a,v,g,f){this._proxy=_,this._textDocumentsAndEditors=a,this._textDocuments=v,this.uri=g,this.handle=m._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=f.viewType,this._metadata=Object.freeze(f.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,f.cells]],!0,void 0),this._versionId=f.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const _=this,a={get uri(){return _.uri},get version(){return _._versionId},get notebookType(){return _._notebookType},get isDirty(){return _._isDirty},get isUntitled(){return _.uri.scheme===w.Schemas.untitled},get isClosed(){return _._disposed},get metadata(){return _._metadata},get cellCount(){return _._cells.length},cellAt(v){return v=_._validateIndex(v),_._cells[v].apiCell},getCells(v){return(v?_._getCells(v):_._cells).map(f=>f.apiCell)},save(){return _._save()}};this._notebook=Object.freeze(a)}return this._notebook}acceptDocumentPropertiesChanged(_){_.metadata&&(this._metadata=Object.freeze({...this._metadata,..._.metadata}))}acceptDirty(_){this._isDirty=_}acceptModelChanged(_,a,v){this._versionId=_.versionId,this._isDirty=a,this.acceptDocumentPropertiesChanged({metadata:v});const g={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const n of _.rawEvents)n.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(n.changes,!1,g.contentChanges):n.kind===T.NotebookCellsChangeType.Move?this._moveCells(n.index,n.length,n.newIdx,g.contentChanges):n.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(n.index,n.outputs),f.push({cell:this._cells[n.index].apiCell,outputs:this._cells[n.index].apiCell.outputs})):n.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(n.index,n.outputId,n.append,n.outputItems),f.push({cell:this._cells[n.index].apiCell,outputs:this._cells[n.index].apiCell.outputs})):n.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(n.index,n.language),f.push({cell:this._cells[n.index].apiCell,document:this._cells[n.index].apiCell.document})):n.kind===T.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this._cells[n.index].apiCell,document:this._cells[n.index].apiCell.document}):n.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(n.index,n.mime):n.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(n.index,n.metadata),f.push({cell:this._cells[n.index].apiCell,metadata:this._cells[n.index].apiCell.metadata})):n.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(n.index,n.internalMetadata),f.push({cell:this._cells[n.index].apiCell,executionSummary:this._cells[n.index].apiCell.executionSummary}));const t=new Map;for(let n=0;n<f.length;n++){const l=f[n],E=t.get(l.cell);if(E===void 0){const D=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});t.set(l.cell,D-1)}else g.cellChanges[E]={...g.cellChanges[E],...l}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(_){return _=_|0,_<0?0:_>=this._cells.length?this._cells.length-1:_}_validateRange(_){let a=_.start|0,v=_.end|0;return a<0&&(a=0),v>this._cells.length&&(v=this._cells.length),_.with({start:a,end:v})}_getCells(_){_=this._validateRange(_);const a=[];for(let v=_.start;v<_.end;v++)a.push(this._cells[v]);return a}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(_,a,v){if(this._disposed)return;const g=[],f=[],t=[];if(_.reverse().forEach(n=>{const E=n[2].map(r=>{const s=new y(this,this._textDocumentsAndEditors,r);return a||f.push(y.asModelAddData(this.apiNotebook,r)),s}),D=new d(n[0],n[1],[],E),p=this._cells.splice(n[0],n[1],...E);for(const r of p)t.push(r.uri),D.deletedItems.push(r.apiCell);g.push(D)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),v)for(const n of g)v.push(n.asApiEvent())}_moveCells(_,a,v,g){const f=this._cells.splice(_,a);this._cells.splice(v,0,...f);const t=[new d(_,a,f.map(n=>n.apiCell),[]),new d(v,0,[],f)];for(const n of t)g.push(n.asApiEvent())}_setCellOutputs(_,a){this._cells[_].setOutputs(a)}_setCellOutputItems(_,a,v,g){this._cells[_].setOutputItems(a,v,g)}_changeCellLanguage(_,a){const v=this._cells[_];v.apiCell.document.languageId!==a&&this._textDocuments.$acceptModelLanguageChanged(v.uri,a)}_changeCellMime(_,a){const v=this._cells[_];v.apiCell.mime=a}_changeCellMetadata(_,a){this._cells[_].setMetadata(a)}_changeCellInternalMetadata(_,a){this._cells[_].setInternalMetadata(a)}getCellFromApiCell(_){return this._cells.find(a=>a.apiCell===_)}getCellFromIndex(_){return this._cells[_]}getCell(_){return this._cells.find(a=>a.handle===_)}getCellIndex(_){return this._cells.indexOf(_)}}e.ExtHostNotebookDocument=m}),define(Te[205],Ae([1,0,5,2,8,7]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,m,P,_={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=m,this._mainThreadBulkEdits=P,this._thresholds=_,this._onWillSaveNotebookDocumentEvent=new w.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(m,P,_)=>{const a=function(g){m.call(P,g)};return a.extension=y,this._onWillSaveNotebookDocumentEvent.event(a,void 0,_)}}async $participateInSave(y,m,P){const _=R.URI.revive(y),a=this._notebooksAndEditors.getNotebookDocument(_);if(!a)throw new Error("Unable to resolve notebook document");const v=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:a.apiNotebook,reason:k.TextDocumentSaveReason.to(m)},P,async(f,t)=>{const n=Date.now(),l=await await Promise.resolve(f);Date.now()-n>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&l&&(l instanceof F.WorkspaceEdit?v.push(l):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const g={edits:[]};for(const f of v){const{edits:t}=k.WorkspaceEdit.from(f);g.edits=g.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Te[103],Ae([1,0,9,8,7]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(d,y,m,P,_,a){this.id=d,this._proxy=y,this.notebookData=m,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=P,this._viewColumn=a}get apiEditor(){if(!this._editor){const d=this;this._editor={get notebook(){return d.notebookData.apiNotebook},get selection(){return d._selections[0]},set selection(y){this.selections=[y]},get selections(){return d._selections},set selections(y){if(!Array.isArray(y)||!y.every(k.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");d._selections=y,d._trySetSelections(y)},get visibleRanges(){return d._visibleRanges},revealRange(y,m){d._proxy.$tryRevealRange(d.id,R.NotebookRange.from(y),m??k.NotebookEditorRevealType.Default)},get viewColumn(){return d._viewColumn}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(d){this._visible=d}_acceptVisibleRanges(d){this._visibleRanges=d}_acceptSelections(d){this._selections=d}_trySetSelections(d){this._proxy.$trySetSelections(this.id,d.map(R.NotebookRange.from))}_acceptViewColumn(d){this._viewColumn=d}}e.ExtHostNotebookEditor=F}),define(Te[206],Ae([1,0,9,5,14,8]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,m){this._logService=y,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new R.Emitter({onListenerError:w.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter({onListenerError:w.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,m);const P=this._notebooksAndEditors.getEditorById(y);m.visibleRanges&&P._acceptVisibleRanges(m.visibleRanges.ranges.map(F.NotebookRange.to)),m.selections&&P._acceptSelections(m.selections.selections.map(F.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const m in y)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(F.ViewColumn.to(y[m]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=Ve([We(0,k.ILogService)],T)}),define(Te[207],Ae([1,0,8,50,152,21,65,9]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,v,g){const f=this._handles++,{title:t,location:n,cancellable:l}=v,E={label:(0,k.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(f,{location:w.ProgressLocation.from(n),title:t,source:E,cancellable:l},a.isUnderDevelopment?void 0:a.identifier.value).catch(d.onUnexpectedExternalError),this._withProgress(f,g,!!l)}_withProgress(a,v,g){let f;g&&(f=new F.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,f));const t=l=>{this._proxy.$progressEnd(l),this._mapHandleToCancellationSource.delete(l),f?.dispose()};let n;try{n=v(new P(this._proxy,a),g&&f?f.token:F.CancellationToken.None)}catch(l){throw t(a),l}return n.then(l=>t(a),l=>t(a)),n}$acceptProgressCanceled(a){const v=this._mapHandleToCancellationSource.get(a);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=y;function m(_,a){return _.message=a.message,typeof a.increment=="number"&&(typeof _.increment=="number"?_.increment+=a.increment:_.increment=a.increment),_}class P extends R.Progress{constructor(a,v){super(g=>this.throttledReport(g)),this._proxy=a,this._handle=v}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,T.throttle)(100,(_,a)=>m(_,a),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Te[104],Ae([1,0,44,101,45,76,57,8,2]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(E,D,p,r)=>{let s=D;return{enumerable:!0,configurable:!1,get(){return s},set(i){if(!p(s,i)){const o=s;s=i,E.listener?.(r(i,o))}}}},P=(E,D)=>E===D,_={range:(E,D)=>E===D?!0:!E||!D?!1:E.isEqual(D),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(E,D)=>!(E.length!==D.length||E.some(p=>!D.find(r=>p.id===r.id)))},a=E=>D=>({op:4,update:E(D)}),v=(E,D)=>({range:(()=>{let p;const r=a(s=>({range:w.Range.lift(d.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){E.listener?.({op:6}),_.range(p,s)||(p=s,E.listener?.(r(s)))}}})(),label:m(E,D,_.label,a(p=>({label:p}))),description:m(E,void 0,_.description,a(p=>({description:p}))),sortText:m(E,void 0,_.sortText,a(p=>({sortText:p}))),canResolveChildren:m(E,!1,_.canResolveChildren,p=>({op:2,state:p})),busy:m(E,!1,_.busy,a(p=>({busy:p}))),error:m(E,void 0,_.error,a(p=>({error:d.MarkdownString.fromStrict(p)||null}))),tags:m(E,[],_.tags,(p,r)=>({op:1,new:p.map(d.TestTag.from),old:r.map(d.TestTag.from)}))}),g=E=>{const D=k.TestId.fromString(E.extId),p=new t(D.controllerId,D.localId,E.label,y.URI.revive(E.uri)||void 0);return p.range=d.Range.to(E.range||void 0),p.description=E.description||void 0,p.sortText=E.sortText||void 0,p.tags=E.tags.map(r=>d.TestTag.to({id:(0,T.denamespaceTestTag)(r).tagId})),p},f=E=>{let D;for(const p of E.tests){const r=g(p.item);(0,R.getPrivateApiFor)(r).parent=D,D=r}return D};e.toItemFromContext=f;class t{constructor(D,p,r,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const i=(0,R.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof n?void 0:i.parent}},children:{value:(0,F.createTestItemChildren)(i,R.getPrivateApiFor,t),enumerable:!0,writable:!1},...v(i,r)})}}e.TestItemImpl=t;class n extends t{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=n;class l extends F.TestItemCollection{constructor(D,p,r){super({controllerId:D,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:R.getPrivateApiFor,getChildren:s=>s.children,root:new n(D,p),toITestItem:d.TestItem.from})}}e.ExtHostTestItemCollection=l}),define(Te[105],Ae([1,0,51,9,88,8,7]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class d{static{this._Keys=new k.IdGenerator("TextEditorDecorationType")}constructor(a,v,g){const f=d._Keys.nextId();a.$registerTextEditorDecorationType(v.identifier,f,F.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=d;class y{constructor(a,v){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=v.undoStopBefore,this._undoStopAfter=v.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,v){this._throwIfFinalized();let g=null;if(a instanceof T.Position)g=new T.Range(a,a);else if(a instanceof T.Range)g=a;else throw new Error("Unrecognized location");this._pushEdit(g,v,!1)}insert(a,v){this._throwIfFinalized(),this._pushEdit(new T.Range(a,a),v,!0)}delete(a){this._throwIfFinalized();let v=null;if(a instanceof T.Range)v=a;else throw new Error("Unrecognized location");this._pushEdit(v,null,!0)}_pushEdit(a,v,g){const f=this._document.validateRange(a);this._collectedEdits.push({range:f,text:v,forceMoveMarkers:g})}setEndOfLine(a){if(this._throwIfFinalized(),a!==T.EndOfLine.LF&&a!==T.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=a}}class m{constructor(a,v,g,f){this._proxy=a,this._id=v,this._accept(g),this._logService=f;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(n){t._setTabSize(n)},get indentSize(){return t._indentSize},set indentSize(n){t._setIndentSize(n)},get insertSpaces(){return t._insertSpaces},set insertSpaces(n){t._setInsertSpaces(n)},get cursorStyle(){return t._cursorStyle},set cursorStyle(n){t._setCursorStyle(n)},get lineNumbers(){return t._lineNumbers},set lineNumbers(n){t._setLineNumbers(n)}}}_accept(a){this._tabSize=a.tabSize,this._indentSize=a.indentSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=F.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}_setTabSize(a){const v=this._validateTabSize(a);if(v!==null){if(typeof v=="number"){if(this._tabSize===v)return;this._tabSize=v}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:v}))}}_validateIndentSize(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}_setIndentSize(a){const v=this._validateIndentSize(a);if(v!==null){if(typeof v=="number"){if(this._indentSize===v)return;this._indentSize=v}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:v}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:!!a}_setInsertSpaces(a){const v=this._validateInsertSpaces(a);if(typeof v=="boolean"){if(this._insertSpaces===v)return;this._insertSpaces=v}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:v}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:F.TextEditorLineNumbersStyle.from(a)})))}assign(a){const v={};let g=!1;if(typeof a.tabSize<"u"){const f=this._validateTabSize(a.tabSize);f==="auto"?(g=!0,v.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,g=!0,v.tabSize=f)}if(typeof a.indentSize<"u"){const f=this._validateIndentSize(a.indentSize);f==="tabSize"?(g=!0,v.indentSize=f):typeof f=="number"&&this._indentSize!==f&&(this._indentSize=f,g=!0,v.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this._validateInsertSpaces(a.insertSpaces);f==="auto"?(g=!0,v.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,g=!0,v.insertSpaces=f)}typeof a.cursorStyle<"u"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,g=!0,v.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,g=!0,v.lineNumbers=F.TextEditorLineNumbersStyle.from(a.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,v))}_warnOnError(a,v){v.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=m;class P{constructor(a,v,g,f,t,n,l,E){this.id=a,this._proxy=v,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new m(this._proxy,this.id,n,g),this._visibleRanges=l,this._viewColumn=E;const D=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw new R.ReadonlyError("document")},get selection(){return D._selections&&D._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,R.illegalArgument)("selection");D._selections=[p],D._trySetSelection()},get selections(){return D._selections},set selections(p){if(!Array.isArray(p)||p.some(r=>!(r instanceof T.Selection)))throw(0,R.illegalArgument)("selections");D._selections=p,D._trySetSelection()},get visibleRanges(){return D._visibleRanges},set visibleRanges(p){throw new R.ReadonlyError("visibleRanges")},get options(){return D._options.value},set options(p){D._disposed||D._options.assign(p)},get viewColumn(){return D._viewColumn},set viewColumn(p){throw new R.ReadonlyError("viewColumn")},edit(p,r={undoStopBefore:!0,undoStopAfter:!0}){if(D._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(f.value,r);return p(s),D._applyEdit(s)},insertSnippet(p,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(D._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=D._selections.map(o=>F.Range.from(o));else if(r instanceof T.Position){const{lineNumber:o,column:S}=F.Position.from(r);i=[{startLineNumber:o,startColumn:S,endLineNumber:o,endColumn:S}]}else if(r instanceof T.Range)i=[F.Range.from(r)];else{i=[];for(const o of r)if(o instanceof T.Range)i.push(F.Range.from(o));else{const{lineNumber:S,column:b}=F.Position.from(o);i.push({startLineNumber:S,startColumn:b,endLineNumber:S,endColumn:b})}}return v.$tryInsertSnippet(a,f.value.version,p.value,i,s)},setDecorations(p,r){const s=r.length===0;s&&!D._hasDecorationsForKey.has(p.key)||(s?D._hasDecorationsForKey.delete(p.key):D._hasDecorationsForKey.add(p.key),D._runOnProxy(()=>{if(F.isDecorationOptionsArr(r))return v.$trySetDecorations(a,p.key,F.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let o=0,S=r.length;o<S;o++){const b=r[o];i[4*o]=b.start.line+1,i[4*o+1]=b.start.character+1,i[4*o+2]=b.end.line+1,i[4*o+3]=b.end.character+1}return v.$trySetDecorationsFast(a,p.key,i)}}))},revealRange(p,r){D._runOnProxy(()=>v.$tryRevealRange(a,F.Range.from(p),r||T.TextEditorRevealType.Default))},show(p){v.$tryShowEditor(a,F.ViewColumn.from(p))},hide(){v.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,w.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,w.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,w.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(F.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const v=a.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const g=v.edits.map(t=>t.range);g.sort((t,n)=>t.end.line===n.end.line?t.end.character===n.end.character?t.start.line===n.start.line?t.start.character-n.start.character:t.start.line-n.start.line:t.end.character-n.end.character:t.end.line-n.end.line);for(let t=0,n=g.length-1;t<n;t++){const l=g[t].end;if(g[t+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?F.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this._logService.warn(v),null))}}e.ExtHostTextEditor=P}),define(Te[208],Ae([1,0,4,171]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,w.refineServiceDecorator)(R.IEnvironmentService)}),define(Te[106],Ae([1,0,20,5,19,6]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(n,l){this.versionId=n,this.removedDueToLooping=l}}e.DeltaExtensionsResult=T;class d{static isHostExtension(n,l,E){if(l.getExtensionDescription(n))return!1;const D=E.getExtensionDescription(n);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(n,l){this._activationEventsReader=n,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=l,this._initialize()}_initialize(){this._extensionDescriptions.sort(g),this._extensionsMap=new w.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const l=this._activationEventsReader.readActivationEvents(n);if(Array.isArray(l))for(let E of l)E==="onUri"&&(E=`onUri:${w.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(n)}}set(n){return this._extensionDescriptions=n,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(n,l){this._extensionDescriptions=f(this._extensionDescriptions,l),this._extensionDescriptions=this._extensionDescriptions.concat(n);const E=d._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=f(this._extensionDescriptions,E.map(D=>D.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new T(this._versionId,E)}static _findLoopingExtensions(n){const l=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(s){this._nodesSet.has(s)||(this._nodesSet.add(s),this._nodesArr.push(s))}addArc(s,i){this.addNode(s),this.addNode(i),this._arcs.has(s)?this._arcs.get(s).push(i):this._arcs.set(s,[i])}getArcs(s){return this._arcs.has(s)?this._arcs.get(s):[]}hasOnlyGoodArcs(s,i){const o=l.getArcs(s);for(let S=0;S<o.length;S++)if(!i.has(o[S]))return!1;return!0}getNodes(){return this._nodesArr}},E=new w.ExtensionIdentifierMap;for(const s of n)if(E.set(s.identifier,s),s.extensionDependencies)for(const i of s.extensionDependencies)l.addArc(w.ExtensionIdentifier.toKey(s.identifier),w.ExtensionIdentifier.toKey(i));const D=new Set;l.getNodes().filter(s=>l.getArcs(s).length===0).forEach(s=>D.add(s));const p=l.getNodes().filter(s=>!D.has(s));let r;do{r=!1;for(let s=0;s<p.length;s++){const i=p[s];l.hasOnlyGoodArcs(i,D)&&(p.splice(s,1),s--,D.add(i),r=!0)}}while(r);return p.map(s=>E.get(s))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const l=this._activationMap.get(n);return l?l.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(n){const l=this._extensionsMap.get(n);return l||void 0}getExtensionDescriptionByUUID(n){for(const l of this._extensionsArr)if(l.uuid===n)return l}getExtensionDescriptionByIdOrUUID(n,l){return this.getExtensionDescription(n)??(l?this.getExtensionDescriptionByUUID(l):void 0)}}e.ExtensionDescriptionRegistry=d;class y{constructor(n,l){this.versionId=n,this.extensions=l}}e.ExtensionDescriptionRegistrySnapshot=y,e.basicActivationEventsReader={readActivationEvents:t=>t.activationEvents};class m{constructor(n){this._lock=new a,this._actual=new d(n,[])}async acquireLock(n){const l=await this._lock.acquire(n);return new P(this,l)}deltaExtensions(n,l,E){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(l,E)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,l){return this._actual.getExtensionDescriptionByIdOrUUID(n,l)}}e.LockableExtensionDescriptionRegistry=m;class P extends F.Disposable{constructor(n,l){super(),this._registry=n,this._isDisposed=!1,this._register(l)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=P;class _{constructor(n){this.name=n,this.promise=new Promise((l,E)=>{this._resolve=l})}resolve(n){this._resolve(n)}}class a{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const l=new _(n);return this._pendingCustomers.push(l),this._advance(),l.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let l=!0;const E=setTimeout(()=>{l&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),D=()=>{l&&(clearTimeout(E),l=!1,this._isLocked=!1,this._advance())};n.resolve((0,F.toDisposable)(D))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function g(t,n){const l=t.isBuiltin?0:t.isUnderDevelopment?2:1,E=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(l!==E)return l-E;const D=k.posix.basename(t.extensionLocation.path),p=k.posix.basename(n.extensionLocation.path);return D<p?-1:D>p?1:0}function f(t,n){const l=new w.ExtensionIdentifierSet(n);return t.filter(E=>!l.has(E.identifier))}}),define(Te[79],Ae([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(R||(e.UIKind=R={}));var k;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var F;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function T(m){const P=w.VSBuffer.alloc(1);switch(m){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=T;function d(m,P){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=d;var y;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Te[58],Ae([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let v=class extends _.Disposable{constructor(n,l){super(),this.initData=n,this.loggerService=l,this._onDidChangeTelemetryEnabled=this._register(new R.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new R.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=P.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=l.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,a.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(l.onDidChangeLogLevel(E=>{(0,k.isLogLevel)(E)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(n,l,E){const D=this.getTelemetryDetails(),p=new g(l,E,n,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(n),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),r=this._telemetryLoggers.get(n.identifier.value)??[];return this._telemetryLoggers.set(n.identifier.value,[...r,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(n,l,E){this._level=n,this._telemetryIsSupported=l,this._productConfig=E??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(n){const l=Object.create(null);switch(l["common.extname"]=`${n.publisher}.${n.name}`,l["common.extversion"]=n.version,l["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,l["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,l["common.vscodeversion"]=this.initData.version,l["common.isnewappinstall"]=f(this.initData.telemetryInfo.firstSessionDate),l["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:l["common.uikind"]="web";break;case T.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,d.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),l}$onDidChangeTelemetryLevel(n){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=n;const l=this.getTelemetryDetails();this._telemetryLoggers.forEach((E,D)=>{const p=E.filter(r=>!r.isDisposed);p.length===0?this._telemetryLoggers.delete(D):this._telemetryLoggers.set(D,p)}),this._telemetryLoggers.forEach(E=>{for(const D of E)D.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(n,l){const D=this._telemetryLoggers.get(n.value)?.filter(r=>!r.isDisposed);if(!D)return this._telemetryLoggers.delete(n.value),!1;let p=!1;for(const r of D)r.ignoreUnhandledExtHostErrors||(r.logError(l),p=!0);return p}};e.ExtHostTelemetry=v,e.ExtHostTelemetry=v=Ve([We(0,F.IExtHostInitDataService),We(1,k.ILoggerService)],v);class g{static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,l,E,D,p,r,s){this._extension=E,this._logger=D,this._inLoggingOnlyMode=p,this._commonProperties=r,this._onDidChangeEnableStates=new R.Emitter,this.ignoreUnhandledExtHostErrors=l?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=l?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=l?.additionalCommonProperties,this._sender=n,this._telemetryEnablements={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(n,l){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:n,isErrorsEnabled:l},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(n){let l="properties"in n?n.properties??{}:n;return l=(0,y.cleanData)(l,[]),this._additionalCommonProperties&&(l=(0,m.mixin)(l,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(l=(0,m.mixin)(l,this._commonProperties)),"properties"in n?n.properties=l:n=l,n}logEvent(n,l){this._sender&&(this._extension.publisher==="vscode"?n=this._extension.name+"/"+n:n=this._extension.identifier.value+"/"+n,l=this.mixInCommonPropsAndCleanData(l||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(n,l),this._logger.trace(n,l))}logUsage(n,l){this._telemetryEnablements.isUsageEnabled&&this.logEvent(n,l)}logError(n,l){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof n=="string")this.logEvent(n,l);else{const E={name:n.name,message:n.message,stack:n.stack,cause:n.cause},D=(0,y.cleanData)(E,[]),p=new Error(D.message,{cause:D.cause});p.stack=D.stack,p.name=D.name,l=this.mixInCommonPropsAndCleanData(l||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(p,l),this._logger.trace("exception",l)}}get apiTelemetryLogger(){if(!this._apiObject){const n=this,l={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return n._telemetryEnablements.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n._onDidChangeEnableStates.event.bind(n)};this._apiObject=Object.freeze(l)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let n=this._sender;this._sender=void 0,Promise.resolve(n.flush()).then(n=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=g;function f(t){const n=Date.now()-new Date(t).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(Te[26],Ae([1,0,5,2,180,98,20,4]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,d.createDecorator)("extensionService");class y{constructor(p){this.dependency=p}}e.MissingExtensionDependency=y;var m;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class P{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(p,r,s){this._versionId=p,this._allExtensions=r.slice(0),this._myExtensions=s.slice(0)}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:F.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(p,r,s){if(this._versionId>p)throw new Error(`ExtensionHostExtensions: invalid versionId ${p} (current: ${this._versionId})`);const i=[],o=[],S=[],b=[],C=_(this._allExtensions),I=_(r),c=(H,U)=>H.extensionLocation.toString()===U.extensionLocation.toString()||H.isBuiltin===U.isBuiltin||H.isUserBuiltin===U.isUserBuiltin||H.isUnderDevelopment===U.isUnderDevelopment;for(const H of this._allExtensions){const U=I.get(H.identifier);if(!U){i.push(H.identifier),C.delete(H.identifier);continue}if(!c(H,U)){i.push(H.identifier),C.delete(H.identifier);continue}}for(const H of r){const U=C.get(H.identifier);if(!U){o.push(H);continue}if(!c(U,H)){i.push(U.identifier),C.delete(U.identifier);continue}}const h=new T.ExtensionIdentifierSet(this._myExtensions),u=new T.ExtensionIdentifierSet(s);for(const H of this._myExtensions)u.has(H)||S.push(H);for(const H of s)h.has(H)||b.push(H);const A=F.ImplicitActivationEvents.createActivationEventsMap(o),B={versionId:p,toRemove:i,toAdd:o,addActivationEvents:A,myToRemove:S,myToAdd:b};return this.delta(B),B}delta(p){if(this._versionId>=p.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:i,myToAdd:o}=p,S=new T.ExtensionIdentifierSet(r),b=new T.ExtensionIdentifierSet(i);for(let C=0;C<this._allExtensions.length;C++)S.has(this._allExtensions[C].identifier)&&(this._allExtensions.splice(C,1),C--);for(let C=0;C<this._myExtensions.length;C++)b.has(this._myExtensions[C])&&(this._myExtensions.splice(C,1),C--);for(const C of s)this._allExtensions.push(C);for(const C of o)this._myExtensions.push(C);return p}containsExtension(p){for(const r of this._myExtensions)if(T.ExtensionIdentifier.equals(r,p))return!0;return!1}}e.ExtensionHostExtensions=P;function _(D){const p=new T.ExtensionIdentifierMap;for(const r of D)p.set(r.identifier,r);return p}function a(D,p){return D.enabledApiProposals?D.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=a;function v(D,p){if(!a(D,p))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.checkProposedApiEnabled=v;class g{constructor(p,r,s,i){this.codeLoadingTime=p,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=i}}e.ActivationTimes=g;class f{constructor(p,r){this.description=p,this.value=r}}e.ExtensionPointContribution=f;var t;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function n(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.toExtension=n;function l(D,p){return{identifier:new T.ExtensionIdentifier((0,k.getExtensionId)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!p,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform}}e.toExtensionDescription=l;class E{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=E}),define(Te[209],Ae([1,0,9,106,20,26,14,12]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(n,l,E,D){this.startup=n,this.codeLoadingTime=l,this.activateCallTime=E,this.activateResolvedTime=D}}e.ExtensionActivationTimes=y;class m{constructor(n){this._startup=n,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(n,l){return n===-1||l===-1?-1:l-n}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=m;class P{constructor(n,l,E,D,p,r){this.activationFailed=n,this.activationFailedError=l,this.activationTimes=E,this.module=D,this.exports=p,this.subscriptions=r}}e.ActivatedExtension=P;class _ extends P{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=_;class a extends P{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=a;class v extends P{constructor(n){super(!0,n,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(n,l,E,D){this._logService=D,this._registry=n,this._globalRegistry=l,this._host=E,this._operations=new k.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[n,l]of this._operations)l.dispose()}async waitForActivatingExtensions(){const n=[];for(const[l,E]of this._operations)n.push(E.wait());await Promise.all(n)}isActivated(n){const l=this._operations.get(n);return!!(l&&l.value)}getActivatedExtension(n){const l=this._operations.get(n);if(!l||!l.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return l.value}async activateByEvent(n,l){if(this._alreadyActivatedEvents[n])return;const E=this._registry.getExtensionDescriptionsForActivationEvent(n);await this._activateExtensions(E.map(D=>({id:D.identifier,reason:{startup:l,extensionId:D.identifier,activationEvent:n}}))),this._alreadyActivatedEvents[n]=!0}activateById(n,l){const E=this._registry.getExtensionDescription(n);if(!E)throw new Error(`Extension '${n}' is not known`);return this._activateExtensions([{id:E.identifier,reason:l}])}async _activateExtensions(n){const l=n.filter(E=>!this.isActivated(E.id)).map(E=>this._handleActivationRequest(E));await Promise.all(l.map(E=>E.wait()))}_handleActivationRequest(n){if(this._operations.has(n.id))return this._operations.get(n.id);if(this._isHostExtension(n.id))return this._createAndSaveOperation(n,null,[],null);const l=this._registry.getExtensionDescription(n.id);if(!l){const p=new Error(`Cannot activate unknown extension '${n.id.value}'`),r=this._createAndSaveOperation(n,null,[],new v(p));return this._host.onExtensionActivationError(n.id,p,new F.MissingExtensionDependency(n.id.value)),r}const E=[],D=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const p of D){if(this._isResolvedExtension(p))continue;const r=this._operations.get(p);if(r){E.push(r);continue}if(this._isHostExtension(p)){E.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:n.reason}));continue}const s=this._registry.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;E.push(this._handleActivationRequest({id:s.identifier,reason:n.reason}));continue}const i=l.displayName||l.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${p}'`),S=this._createAndSaveOperation(n,l.displayName,[],new v(o));return this._host.onExtensionActivationError(l.identifier,o,new F.MissingExtensionDependency(p)),S}return this._createAndSaveOperation(n,l.displayName,E,null)}_createAndSaveOperation(n,l,E,D){const p=new f(n.id,l,n.reason,E,D,this._host,this._logService);return this._operations.set(n.id,p),p}_isHostExtension(n){return R.ExtensionDescriptionRegistry.isHostExtension(n,this._registry,this._globalRegistry)}_isResolvedExtension(n){const l=this._globalRegistry.getExtensionDescription(n);return l?!l.main&&!l.browser:!1}};e.ExtensionsActivator=g,e.ExtensionsActivator=g=Ve([We(3,T.ILogService)],g);let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(n,l,E,D,p,r,s){this._id=n,this._displayName=l,this._reason=E,this._deps=D,this._value=p,this._host=r,this._logService=s,this._barrier=new d.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let n=0;n<this._deps.length;n++){const l=this._deps[n];if(l.value&&!l.value.activationFailed){this._deps.splice(n,1),n--;continue}if(l.value&&l.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);E.detail=l.value.activationFailedError,this._value=new v(E),this._host.onExtensionActivationError(this._id,E,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(n=>n.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(n){const l=new Error;if(n&&n.name&&(l.name=n.name),n&&n.message?l.message=`Activating extension '${this._id.value}' failed: ${n.message}.`:l.message=`Activating extension '${this._id.value}' failed: ${n}.`,n&&n.stack&&(l.stack=n.stack),this._value=new v(l),this._isDisposed&&w.isCancellationError(n))return;this._host.onExtensionActivationError(this._id,l,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(n)}}};f=Ve([We(6,T.ILogService)],f)}),define(Te[210],Ae([1,0,156,23,2,5,6,192,12,7,16,18,8,49,21,125,26]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function n(D,p){if((0,P.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let r;return Array.isArray(D.highlights)&&(r=D.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:D.label,highlights:r}}}class l extends T.Disposable{constructor(p,r,s){super(),this._proxy=p,this.commands=r,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeViewsDnDService;function i(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>i(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(S=>i(S)?this.convertArgument(S):S):o})}registerTreeDataProvider(p,r,s){const i=this.createTreeView(p,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView(p,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],S=!!r.dragAndDropController?.handleDrag,b=!!r.dragAndDropController?.handleDrop,C=this.createExtHostTreeView(p,r,s),I={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:o,hasHandleDrag:S,hasHandleDrop:b,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},c=this._proxy.$registerTreeViewDataProvider(p,I),h={get onDidCollapseElement(){return C.onDidCollapseElement},get onDidExpandElement(){return C.onDidExpandElement},get selection(){return C.selectedElements},get onDidChangeSelection(){return C.onDidChangeSelection},get activeItem(){return(0,t.checkProposedApiEnabled)(s,"treeViewActiveItem"),C.focusedElement},get onDidChangeActiveItem(){return(0,t.checkProposedApiEnabled)(s,"treeViewActiveItem"),C.onDidChangeActiveItem},get visible(){return C.visible},get onDidChangeVisibility(){return C.onDidChangeVisibility},get onDidChangeCheckboxState(){return C.onDidChangeCheckboxState},get message(){return C.message},set message(u){(0,v.isMarkdownString)(u)&&(0,t.checkProposedApiEnabled)(s,"treeViewMarkdownMessage"),C.message=u},get title(){return C.title},set title(u){C.title=u},get description(){return C.description},set description(u){C.description=u},get badge(){return C.badge},set badge(u){u!==void 0&&m.ViewBadge.isViewBadge(u)?C.badge={value:Math.floor(Math.abs(u.value)),tooltip:u.tooltip}:u===void 0&&(C.badge=void 0)},reveal:(u,A)=>C.reveal(u,A),dispose:async()=>{await c,this.treeViews.delete(p),C.dispose()}};return this._register(h),h}$getChildren(p,r){const s=this.treeViews.get(p);return s?s.getChildren(r):Promise.reject(new d.NoTreeViewError(p))}async $handleDrop(p,r,s,i,o,S,b,C){const I=this.treeViews.get(p);if(!I)return Promise.reject(new d.NoTreeViewError(p));const c=a.DataTransfer.toDataTransfer(s,async h=>(await this._proxy.$resolveDropFileData(p,r,h)).buffer);return b===p&&C&&await this.addAdditionalTransferItems(c,I,C,o,S),I.onDrop(c,i,o)}async addAdditionalTransferItems(p,r,s,i,o){const S=this.treeDragAndDropService.removeDragOperationTransfer(o);if(S)(await S)?.forEach((b,C)=>{b&&p.set(C,b)});else if(o&&r.handleDrag){const b=r.handleDrag(s,p,i);this.treeDragAndDropService.addDragOperationTransfer(o,b),await b}return p}async $handleDrag(p,r,s,i){const o=this.treeViews.get(p);if(!o)return Promise.reject(new d.NoTreeViewError(p));const S=await this.addAdditionalTransferItems(new m.DataTransfer,o,r,i,s);if(!(!S||i.isCancellationRequested))return a.DataTransfer.from(S)}async $hasResolve(p){const r=this.treeViews.get(p);if(!r)throw new d.NoTreeViewError(p);return r.hasResolve}$resolve(p,r,s){const i=this.treeViews.get(p);if(!i)throw new d.NoTreeViewError(p);return i.resolveTreeItem(r,s)}$setExpanded(p,r,s){const i=this.treeViews.get(p);if(!i)throw new d.NoTreeViewError(p);i.setExpanded(r,s)}$setSelectionAndFocus(p,r,s){const i=this.treeViews.get(p);if(!i)throw new d.NoTreeViewError(p);i.setSelectionAndFocus(r,s)}$setVisible(p,r){const s=this.treeViews.get(p);if(!s){if(!r)return;throw new d.NoTreeViewError(p)}s.setVisible(r)}$changeCheckboxState(p,r){const s=this.treeViews.get(p);if(!s)throw new d.NoTreeViewError(p);s.setCheckboxState(r)}createExtHostTreeView(p,r,s){const i=this._register(new E(p,r,this._proxy,this.commands.converter,this.logService,s));return this.treeViews.set(p,i),i}convertArgument(p){const r=this.treeViews.get(p.$treeViewId);return r&&"$treeItemHandle"in p?r.getExtensionElement(p.$treeItemHandle):r&&"$focusedTreeItem"in p&&p.$focusedTreeItem?r.focusedElement:null}}e.ExtHostTreeViews=l;class E extends T.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,P.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,r,s,i,o,S){if(super(),this.viewId=p,this.proxy=s,this.commands=i,this.logService=o,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new F.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new F.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new F.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new F.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new F.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new F.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,S.contributes&&S.contributes.views)for(const c in S.contributes.views)for(const h of S.contributes.views[c])h.id===p&&(this._title=h.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let b,C;const I=F.Event.debounce(this._onDidChangeData.event,(c,h)=>(c||(c={message:!1,elements:[]}),h.element!==!1&&(b||(b=new Promise(u=>C=u),this.refreshPromise=this.refreshPromise.then(()=>b)),Array.isArray(h.element)?c.elements.push(...h.element):c.elements.push(h.element)),h.message&&(c.message=!0),c),200,!0);this._register(I(({message:c,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const u=C;return b=null,this.refresh(h).then(()=>u())})),c&&this.proxy.$setMessage(this.viewId,a.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(p){const r=p?this.getExtensionElement(p):void 0;if(p&&!r)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(p);return s||(s=await this.fetchChildrenNodes(r)),s?s.map(i=>i.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,r){r=r||{select:!0,focus:!1};const s=(0,P.isUndefinedOrNull)(r.select)?!0:r.select,i=(0,P.isUndefinedOrNull)(r.focus)?!1:r.focus,o=(0,P.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(S=>this.resolveTreeNode(p,S[S.length-1]).then(b=>this.proxy.$reveal(this.viewId,{item:b.item,parentChain:S.map(C=>C.item)},{select:s,focus:i,expand:o})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:i,expand:o})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=a.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,r){const s=this.getExtensionElement(p);s&&(r?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelectionAndFocus(p,r){const s=!(0,_.equals)(this._selectedHandles,p);this._selectedHandles=p;const i=this._focusedHandle!==r;this._focusedHandle=r,s&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),i&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const r=(await Promise.all(p.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.dataProvider.getTreeItem(i),newState:s.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,r,s){const i=[];for(const o of p){const S=this.getExtensionElement(o);S&&i.push(S)}if(!(!this.dndController?.handleDrag||i.length===0))return await this.dndController.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(i,p,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,r){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(p);if(s){const i=this.nodes.get(s);if(i){const o=await this.dataProvider.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.validateTreeItem(o),i.item.tooltip=this.getTooltip(o.tooltip),i.item.command=this.getCommand(i.disposableStore,o.command),i.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(r=>r?this.resolveUnknownParentChain(r).then(s=>this.resolveTreeNode(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}resolveParent(p){const r=this.nodes.get(p);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,r){const s=this.nodes.get(p);return s?Promise.resolve(s):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(i=>this.createHandle(p,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const S=this.nodes.get(o);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(p){if(p){let r;if(typeof p=="string"){const s=this.getExtensionElement(p);r=s?this.nodes.get(s):void 0}else r=p;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const r=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=p?this.nodes.get(p):void 0,i=await this.dataProvider.getChildren(p);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,_.coalesce)(i||[]).map(async S=>{const b=await this.dataProvider.getTreeItem(S);return b&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(S,b,s):null}));return r.token.isCancellationRequested?void 0:(0,_.coalesce)(o)}finally{r.dispose()}}refresh(p){if(p.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(p);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const r=new Set,s=p.map(o=>this.nodes.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let S=o;for(;S&&S.parent&&s.findIndex(b=>S&&S.parent&&b&&b.item.handle===S.parent.item.handle)===-1;){const b=this.elements.get(S.parent.item.handle);S=b?this.nodes.get(b):void 0}S&&!S.parent&&r.add(o.item.handle)}const i=[];return r.forEach(o=>{const S=this.elements.get(o);if(S){const b=this.nodes.get(S);b&&(!b.parent||!r.has(b.parent.item.handle))&&i.push(o)}}),i}refreshHandles(p){const r={};return Promise.all(p.map(s=>this.refreshNode(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(p){const r=this.getExtensionElement(p);if(r){const s=this.nodes.get(r);if(s)return this.clearChildren(r),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(i=>{if(i){const o=this.createTreeNode(r,i,s.parent);return this.updateNodeCache(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,r,s){const i=this.createTreeNode(p,r,s);if(r.id&&this.elements.has(i.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.addNodeToCache(p,i),this.addNodeToParentCache(i,s),i}getTooltip(p){return m.MarkdownString.isMarkdownString(p)?a.MarkdownString.from(p):p}getCommand(p,r){return r?{...this.commands.toInternal(r,p),originalId:r.command}:void 0}getCheckbox(p){if(p.checkboxState===void 0)return;let r,s,i;return typeof p.checkboxState=="number"?r=p.checkboxState:(r=p.checkboxState.state,s=p.checkboxState.tooltip,i=p.checkboxState.accessibilityInformation),{isChecked:r===m.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}validateTreeItem(p){if(!m.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,r,s){this.validateTreeItem(r);const i=this._register(new T.DisposableStore),o=this.createHandle(p,r,s),S=this.getLightIconPath(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:n(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(i,r.command),contextValue:r.contextValue,icon:S,iconDark:this.getDarkIconPath(r)||S,themeIcon:this.getThemeIcon(r),collapsibleState:(0,P.isUndefinedOrNull)(r.collapsibleState)?m.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.getCheckbox(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(p){return p.iconPath instanceof m.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:r,label:s,resourceUri:i},o,S){if(r)return`${E.ID_HANDLE_PREFIX}/${r}`;const b=n(s,this.extension),C=o?o.item.handle:E.LABEL_HANDLE_PREFIX;let I=b?b.label:i?(0,R.basename)(i):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const c=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,h=this.getChildrenNodes(o)||[];let u,A=0;do{if(u=`${C}/${A}:${I}`,S||!this.elements.has(u)||c===u)break;A++}while(A<=h.length);return u}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof m.ThemeIcon))return typeof p.iconPath=="string"||k.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof m.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return k.URI.isUri(p)?p:k.URI.file(p)}addNodeToCache(p,r){this.elements.set(r.item.handle,p),this.nodes.set(p,r)}updateNodeCache(p,r,s,i){this.elements.delete(r.item.handle),this.nodes.delete(p),r.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(p,r);const o=this.getChildrenNodes(i)||[],S=o.filter(b=>b.item.handle===s.item.handle)[0];S&&o.splice(o.indexOf(S),1,r)}addNodeToParentCache(p,r){r?(r.children||(r.children=[]),r.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const r=this.nodes.get(p);if(r){if(r.children)for(const s of r.children){const i=this.elements.get(s.item.handle);i&&this.clear(i)}r.children=void 0}}else this.clearAll()}clear(p){const r=this.nodes.get(p);if(r){if(r.children)for(const s of r.children){const i=this.elements.get(s.item.handle);i&&this.clear(i)}this.nodes.delete(p),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Te[211],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Te[212],Ae([1,0,166,9,29,92,73,30,20,211,176,98]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const a=d.Registry.as(T.Extensions.JSONContribution);class v{constructor(p,r,s){this._messageHandler=p,this._extension=r,this._extensionPointId=s}_msg(p,r){this._messageHandler({type:p,message:r,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(k.default.Error,p)}warn(p){this._msg(k.default.Warning,p)}info(p){this._msg(k.default.Info,p)}}e.ExtensionMessageCollector=v;class g{static _toSet(p){const r=new y.ExtensionIdentifierSet;for(let s=0,i=p.length;s<i;s++)r.add(p[s].description.identifier);return r}static compute(p,r){if(!p||!p.length)return new g(r,[]);if(!r||!r.length)return new g([],p);const s=this._toSet(p),i=this._toSet(r),o=r.filter(b=>!s.has(b.description.identifier)),S=p.filter(b=>!i.has(b.description.identifier));return new g(o,S)}constructor(p,r){this.added=p,this.removed=r}}e.ExtensionPointUserDelta=g;class f{constructor(p,r){this.name=p,this.defaultExtensionKind=r,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=g.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,R.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const r=new f(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,r),p.activationEventsGenerator&&_.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,a.registerSchema(n,e.schema),r}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=l;const E={ExtensionsRegistry:"ExtensionsRegistry"};d.Registry.add(E.ExtensionsRegistry,new l),e.ExtensionsRegistry=d.Registry.as(E.ExtensionsRegistry),a.registerSchema(n,e.schema),a.registerSchema(P.productSchemaId,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Te[213],Ae([1,0,163,16,24,212,32,5]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var m;(function(a){function v(g,f,t){if(!g)return;const n=R.isString(g.type)?g.type:void 0;if(!n||n.length===0){t.error(w.localize(3,null));return}const l=[];if(Array.isArray(g.required))for(const E of g.required)R.isString(E)&&l.push(E);return{extensionId:f.value,taskType:n,required:l,properties:g.properties?k.deepClone(g.properties):{},when:g.when?T.ContextKeyExpr.deserialize(g.when):void 0}}a.from=v})(m||(m={}));const P=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,v)=>{for(const g of a)g.type&&v.push(`onTaskType:${g.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:y}});class _{constructor(){this._onDefinitionsChanged=new d.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((v,g)=>{P.setHandler((f,t)=>{this._schema=void 0;try{for(const n of t.removed){const l=n.value;for(const E of l)this.taskTypes&&E.type&&this.taskTypes[E.type]&&delete this.taskTypes[E.type]}for(const n of t.added){const l=n.value;for(const E of l){const D=m.from(E,n.description.identifier,n.collector);D&&(this.taskTypes[D.taskType]=D)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}v(void 0)})})}onReady(){return this.readyPromise}get(v){return this.taskTypes[v]}all(){return Object.keys(this.taskTypes).map(v=>this.taskTypes[v])}getJsonSchema(){if(this._schema===void 0){const v=[];for(const g of this.all()){const f={type:"object",additionalProperties:!1};g.required.length>0&&(f.required=g.required.slice(0)),g.properties!==void 0?f.properties=k.deepClone(g.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[g.taskType]},v.push(f)}this._schema={oneOf:v}}return this._schema}}e.TaskDefinitionRegistry=new _}),define(Te[214],Ae([1,0,164,16,23,24,32,213]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,w.localize(0,null)),e.TASKS_CATEGORY={value:w.localize(1,null),original:"Tasks"};var y;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(M){function N(ee){if(!ee)return M.Strong;switch(ee.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=N}(y||(e.ShellQuoting=y={}));var m;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var P;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(P||(e.RevealKind=P={})),function(M){function N(ee){switch(ee.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=N}(P||(e.RevealKind=P={}));var _;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(_||(e.RevealProblemKind=_={})),function(M){function N(ee){switch(ee.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=N}(_||(e.RevealProblemKind=_={}));var a;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(a||(e.PanelKind=a={})),function(M){function N(ee){switch(ee.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=N}(a||(e.PanelKind=a={}));var v;(function(M){M.defaults={echo:!0,reveal:P.Always,revealProblems:_.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var g;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(M){function N(Q){switch(Q.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=N;function ee(Q){switch(Q){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=ee}(g||(e.RuntimeType=g={}));var f;(function(M){function N(ee){return R.isString(ee)?ee:ee.value}M.value=N})(f||(e.CommandString=f={}));var t;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function N(Q){return Q===M.Clean._id||Q===M.Build._id||Q===M.Rebuild._id||Q===M.Test._id}M.is=N;function ee(Q){if(Q!==void 0)return R.isString(Q)?N(Q)?{_id:Q,isDefault:!1}:void 0:Q}M.from=ee})(t||(e.TaskGroup=t={}));var n;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var l;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function N(ee){switch(ee){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=N})(l||(e.TaskSourceKind=l={}));var E;(function(M){M.parallel="parallel",M.sequence="sequence"})(E||(e.DependsOrder=E={}));var D;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(D||(e.RunOnOptions=D={}));var p;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class r{constructor(N,ee,Q,Se,ye,Pe){this._label="",this._id=N,ee&&(this._label=ee),Q&&(this.type=Q),this.runOptions=Se,this.configurationProperties=ye,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.getFolderId(),id:this._id};return JSON.stringify(N)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ee=!1){if(N===void 0)return!1;if(R.isString(N))return N===this._label||N===this.configurationProperties.identifier||ee&&N===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),N&&(this._taskLoadMessages=this._taskLoadMessages.concat(N))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class s extends r{constructor(N,ee,Q,Se,ye,Pe,Y,ue){super(N,Q,void 0,Y,ue,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,ye&&(this.command=ye)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case g.Shell:ee="shell";break;case g.Process:ee="process";break;case g.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===l.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(ee+=this._source.kind);const Q={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:ee};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.CustomTask=s;class i extends r{constructor(N,ee,Q,Se,ye,Pe,Y){super(N,Q,Se,Pe,Y,ee),this._source=ee,this.configures=ye}static is(N){return N instanceof i}fromObject(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===l.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(ee+=this._source.kind);const Q={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:ee};return JSON.stringify(Q)}}e.ConfiguringTask=i;class o extends r{constructor(N,ee,Q,Se,ye,Pe,Y,ue,_e){super(N,Q,Se,ue,_e,ee),this.defines=ye,this.hasDefinedMatchers=Y,this.command=Pe,this.icon=_e.icon,this.hide=_e.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.getFolderId(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.ContributedTask=o;class S extends r{constructor(N,ee,Q,Se,ye,Pe){super(N,Q,Se,ye,Pe,ee),this._source=ee}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(N){return new S(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.InMemoryTask=S;var b;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(M){M._default=M.Terminal}(b||(e.ExecutionEngine=b={}));var C;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(C||(e.JsonSchemaVersion=C={}));class I{constructor(N){this._order=new Map;for(let ee=0;ee<N.length;ee++)this._order.set(N[ee].uri.toString(),ee)}compare(N,ee){const Q=N.getWorkspaceFolder(),Se=ee.getWorkspaceFolder();if(Q&&Se){let ye=this._order.get(Q.uri.toString());ye=ye===void 0?0:ye+1;let Pe=this._order.get(Se.uri.toString());return Pe=Pe===void 0?0:Pe+1,ye===Pe?N._label.localeCompare(ee._label):ye-Pe}else return!Q&&Se?-1:Q&&!Se?1:0}}e.TaskSorter=I;var c;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(c||(e.TaskEventKind=c={}));var h;(function(M){M.SingleRun="singleRun",M.Background="background"})(h||(e.TaskRunType=h={}));var u;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(u||(e.TaskRunSource=u={}));var A;(function(M){function N(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function ee(ue,_e,ce){return{...N(ue),kind:"start",terminalId:_e,resolvedVariables:ce}}M.start=ee;function Q(ue,_e,ce){return{...N(ue),kind:"processStarted",terminalId:_e,processId:ce}}M.processStarted=Q;function Se(ue,_e,ce){return{...N(ue),kind:"processEnded",terminalId:_e,exitCode:ce}}M.processEnded=Se;function ye(ue,_e,ce){return{...N(ue),kind:"terminated",exitReason:ce,terminalId:_e}}M.terminated=ye;function Pe(ue,_e,ce){return{...N(_e),kind:ue,terminalId:ce}}M.general=Pe;function Y(){return{kind:"changed"}}M.changed=Y})(A||(e.TaskEvent=A={}));var B;(function(M){function N(Q){const Se=Object.keys(Q).sort();let ye="";for(const Pe of Se){let Y=Q[Pe];Y instanceof Object?Y=N(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),ye+=Pe+","+Y+","}return ye}function ee(Q){const ye={_key:N(Q),type:Q.taskType};return Object.assign(ye,Q),ye}M.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var H;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection"})(H||(e.TaskSettingId=H={}));var U;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var z;(function(M){function N(ee,Q){const Se=d.TaskDefinitionRegistry.get(ee.type);if(Se===void 0){const ue=F.deepClone(ee);return delete ue._key,B.create(ue)}const ye=Object.create(null);ye.type=Se.taskType;const Pe=new Set;Se.required.forEach(ue=>Pe.add(ue));const Y=Se.properties;for(const ue of Object.keys(Y)){const _e=ee[ue];if(_e!=null)ye[ue]=_e;else if(Pe.has(ue)){const ce=Y[ue];if(ce.default!==void 0)ye[ue]=F.deepClone(ce.default);else switch(ce.type){case"boolean":ye[ue]=!1;break;case"number":case"integer":ye[ue]=0;break;case"string":ye[ue]="";break;default:Q.error(w.localize(2,null,JSON.stringify(ee,void 0,0),ue));return}}}return B.create(ye)}M.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(Te[215],Ae([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,d)=>{this._actualOk=T,this._actualErr=d,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,d){return this._ensureActual().then(T,d)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R;class k extends R{constructor(){super(),this._hasErr=!0,this._err=new w.CancellationError}}e.CanceledLazyPromise=k}),define(Te[46],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++w.count}}e.ProxyIdentifier=w;const R=[];function k(d){const y=new w(d);return R[y.nid]=y,y}e.createProxyIdentifier=k;function F(d){return R[d].sid}e.getStringIdentifierForProxy=F;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(Te[3],Ae([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var k;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(k||(e.TabInputKind=k={}));var F;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var T;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var d;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(d||(e.WebviewMessageArrayBufferViewType=d={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var m;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class _{static{this._n=0}static mixin(t){return t._id=_._n++,t}}e.IdObject=_;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var g;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,w.createProxyIdentifier)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,w.createProxyIdentifier)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,w.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,w.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,w.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,w.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,w.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,w.createProxyIdentifier)("ExtHostChat"),ExtHostChatSlashCommands:(0,w.createProxyIdentifier)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,w.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.createProxyIdentifier)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Te[216],Ae([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class k{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(w.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,d,y){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const m=this._relatedInformationProviders.get(T);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(d,y)??[]}getRelatedInformation(T,d,y){return this._proxy.$getAiRelatedInformation(d,y)}registerRelatedInformationProvider(T,d,y){const m=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(m,y),this._proxy.$registerAiRelatedInformationProvider(m,d),new R.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(m),this._relatedInformationProviders.delete(m)})}}e.ExtHostRelatedInformation=k}),define(Te[80],Ae([1,0,4,14,3,17]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,m){this._extHostLogService=m,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,m,P){const _=this.getUsageKey(y,m);this._reportedUsages.has(_)||(this._reportedUsages.add(_),m.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:y}))}getUsageKey(y,m){return`${y}-${m.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=Ve([We(0,F.IExtHostRpcService),We(1,R.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(d,y,m){}})}),define(Te[217],Ae([1,0,5,3,7,20]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(m){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new d,this._getSessionsTaskSingler=new d,this._proxy=m.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(m){return this._providers=m,Promise.resolve()}async getSession(m,P,_,a={}){const v=F.ExtensionIdentifier.toKey(m.identifier),g=[..._].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${v} ${P} ${g}`,async()=>{await this._proxy.$ensureProvider(P);const f=m.displayName||m.name;return this._proxy.$getSession(P,_,v,f,a)})}async getSessions(m,P,_){const a=F.ExtensionIdentifier.toKey(m.identifier),v=[..._].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${a} ${v}`,async()=>{await this._proxy.$ensureProvider(P);const g=m.displayName||m.name;return this._proxy.$getSessions(P,_,a,g)})}async removeSession(m,P){const _=this._authenticationProviders.get(m);return _?_.provider.removeSession(P):this._proxy.$removeSession(m,P)}registerAuthenticationProvider(m,P,_,a){if(this._authenticationProviders.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this._authenticationProviders.set(m,{label:P,provider:_,options:a??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===m)||this._providers.push({id:m,label:P});const v=_.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(m,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(m,P,a?.supportsMultipleAccounts??!1),new k.Disposable(()=>{v.dispose(),this._authenticationProviders.delete(m);const g=this._providers.findIndex(f=>f.id===m);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(m)})}$createSession(m,P,_){const a=this._authenticationProviders.get(m);if(a)return Promise.resolve(a.provider.createSession(P,_));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,P){const _=this._authenticationProviders.get(m);if(_)return Promise.resolve(_.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,P){const _=this._authenticationProviders.get(m);if(_)return Promise.resolve(_.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,P){return this._onDidChangeSessions.fire({provider:{id:m,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T;class d{constructor(){this._inFlightPromises=new Map}getOrCreate(m,P){const _=this._inFlightPromises.get(m);if(_)return _;const a=P().finally(()=>this._inFlightPromises.delete(m));return this._inFlightPromises.set(m,a),a}}}),define(Te[218],Ae([1,0,3,17,8]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(d,y){this._proxy=d.getProxy(w.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:m=>y.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(d,y,m){const P=k.WorkspaceEdit.from(d,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(P,void 0,m?.isRefactoring??!1)}};e.ExtHostBulkEdits=F,e.ExtHostBulkEdits=F=Ve([We(0,R.IExtHostRpcService)],F)}),define(Te[219],Ae([1,0,12,5,67,6,59,146,3,8]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class P{static{this._pool=0}constructor(v,g){this.extension=v,this.provider=g,this.handle=P._pool++}}class _{static{this._nextId=0}constructor(v,g){this.logService=g,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new R.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=v.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(v,g,f){const t=new P(v,f);return this._chatProvider.set(t.handle,t),this._proxy.$registerChatProvider(t.handle,g),(0,F.toDisposable)(()=>{this._proxy.$unregisterChatProvider(t.handle),this._chatProvider.delete(t.handle)})}transferChatSession(v,g){const f=k.Iterable.find(this._chatSessions.keys(),t=>this._chatSessions.get(t)===v)??0;typeof f=="number"&&this._proxy.$transferChatSession(f,g)}addChatRequest(v){this._proxy.$addRequest(v)}sendInteractiveRequestToProvider(v,g){this._proxy.$sendRequestToProvider(v,g)}async $prepareChat(v,g,f){const t=this._chatProvider.get(v);if(!t)return;const n=await t.provider.prepareSession(g,f);if(!n)return;const l=_._nextId++;return this._chatSessions.set(l,n),{id:l,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveRequest(v,g,f,t){const n=this._chatProvider.get(v);if(!n)return;const l=this._chatSessions.get(g);if(!l||!n.provider.resolveRequest)return;const E=await n.provider.resolveRequest(l,f,t);if(E)return{message:typeof E.message=="string"?E.message:m.ChatReplyFollowup.from(E.message)}}async $provideWelcomeMessage(v,g){const f=this._chatProvider.get(v);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(g);if(t)return t.map(n=>typeof n=="string"?n:n.map(l=>m.ChatReplyFollowup.from(l)))}async $provideFollowups(v,g,f){const t=this._chatProvider.get(v);if(!t)return;const n=this._chatSessions.get(g);return!n||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(n,f))?.map(E=>m.ChatFollowup.from(E))}$removeRequest(v,g,f){const t=this._chatProvider.get(v);if(!t)return;const n=this._chatSessions.get(g);n&&t.provider.removeRequest&&t.provider.removeRequest(n,f)}async $provideReply(v,g,f,t){const n=this._chatProvider.get(v);if(!n)return;const l=this._chatSessions.get(g);if(!l)return;const E={session:l,message:typeof f.message=="string"?f.message:m.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))E.variables[o]=f.variables[o].map(m.ChatVariable.to);const D=T.StopWatch.create(!1);let p;const r={report:o=>{if(!t.isCancellationRequested)if(typeof p>"u"&&(p=D.elapsed()),"responseId"in o)this._proxy.$acceptResponseProgress(v,g,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const S=Promise.all([this._proxy.$acceptResponseProgress(v,g,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.raceCancellation)(S,t).then(b=>{if(!b)return;const[C,I]=b;this._proxy.$acceptResponseProgress(v,g,I,C??void 0)})}else"content"in o?this._proxy.$acceptResponseProgress(v,g,{content:typeof o.content=="string"?o.content:m.MarkdownString.from(o.content)}):"documents"in o?this._proxy.$acceptResponseProgress(v,g,{documents:o.documents.map(S=>({uri:S.uri,version:S.version,ranges:S.ranges.map(b=>m.Range.from(b))}))}):this._proxy.$acceptResponseProgress(v,g,o)}};let s;try{s=await n.provider.provideResponseWithProgress(E,r,t),s||(s={errorDetails:{message:(0,d.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,d.localize)(1,null,o.message),responseIsIncomplete:!0}},this.logService.error(o)}try{if(l.saveState&&this._chatSessions.has(g)){const o=l.saveState();this._proxy.$acceptChatState(g,o)}}catch(o){this.logService.warn(o)}const i={firstProgress:p??0,totalElapsed:D.elapsed()};return{errorDetails:s.errorDetails,timings:i}}async $provideSlashCommands(v,g,f){const t=this._chatProvider.get(v);if(!t)return;const n=this._chatSessions.get(g);return!n||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(n,f))?.map(E=>({...E,kind:m.CompletionItemKind.from(E.kind)}))}$releaseSession(v){this._chatSessions.delete(v)}async $onDidPerformUserAction(v){this._onDidPerformUserAction.fire(v)}}e.ExtHostChat=_}),define(Te[220],Ae([1,0,12,6,50,3,8,7]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents=void 0;class y{static{this._idPool=0}constructor(_,a,v){this._extHostChatProvider=a,this._logService=v,this._agents=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadChatAgents)}registerAgent(_,a,v,g){const f=y._idPool++;return this._agents.set(f,{extension:_,agent:v}),this._proxy.$registerAgent(f,a,g),(0,R.toDisposable)(()=>{this._proxy.$unregisterAgent(f),this._agents.delete(f)})}async $invokeAgent(_,a,v,g,f){const t=this._agents.get(_);if(!t){this._logService.warn(`[CHAT](${_}) CANNOT invoke agent because the agent is not registered`);return}let n=!1;function l(){if(n)throw new Error("Only valid while executing the command")}const E=new w.DeferredPromise;f.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),3*1e3),this._extHostChatProvider.allowListExtensionWhile(t.extension,E.p);const D=t.agent({role:d.ChatMessageRole.User,content:v},{history:g.history.map(T.ChatMessage.to)},new k.Progress(p=>{l(),this._proxy.$handleProgressChunk(a,{content:m(p.message)?p.message:p.message.value})}),f);try{return await(0,w.raceCancellation)(Promise.resolve(D).then(p=>{if(p&&"followUp"in p)return{followUp:p?.followUp?.map(s=>T.ChatFollowup.from(s))}}),f)}finally{n=!0,E.complete()}}}e.ExtHostChatAgents=y;function m(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Te[221],Ae([1,0,6,3,8,50,20]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class d{static{this._idPool=1}constructor(m,P){this._logService=P,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new T.ExtensionIdentifierMap,this._proxy=m.getProxy(R.MainContext.MainThreadChatProvider)}registerProvider(m,P,_,a){const v=d._idPool++;return this._providers.set(v,{extension:m,provider:_}),this._proxy.$registerProvider(v,P,{extension:m,displayName:a.name??m.value}),(0,w.toDisposable)(()=>{this._proxy.$unregisterProvider(v),this._providers.delete(v)})}async $provideChatResponse(m,P,_,a,v){const g=this._providers.get(m);if(!g)return;const f=new F.Progress(async t=>{if(v.isCancellationRequested){this._logService.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this._proxy.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return g.provider.provideChatResponse(_.map(k.ChatMessage.to),a,f,v)}allowListExtensionWhile(m,P){this._chatAccessAllowList.set(m,P),P.finally(()=>this._chatAccessAllowList.delete(m))}async requestChatResponseProvider(m,P){if(!this._chatAccessAllowList.has(m))throw new Error("Extension is NOT allowed to make chat requests");const _=this;return{get isRevoked(){return!_._chatAccessAllowList.has(m)},async makeRequest(a,v,g,f){if(!_._chatAccessAllowList.has(m))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;_._pendingRequest.set(t,g);try{await _._proxy.$fetchResponse(m,P,t,a.map(k.ChatMessage.from),v,f)}finally{_._pendingRequest.delete(t)}}}}async $handleResponseFragment(m,P){this._pendingRequest.get(m)?.report(P)}}e.ExtHostChatProvider=d}),define(Te[222],Ae([1,0,6,3,7,8,50,12]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatSlashCommands=void 0;class y{static{this._idPool=0}constructor(_,a,v){this._extHostChatProvider=a,this._logService=v,this._commands=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadChatSlashCommands)}registerCommand(_,a,v,g){const f=y._idPool++;return this._commands.set(f,{extension:_,command:v}),this._proxy.$registerCommand(f,a,g.description),(0,w.toDisposable)(()=>{this._proxy.$unregisterCommand(f),this._commands.delete(f)})}async $executeCommand(_,a,v,g,f){const t=this._commands.get(_);if(!t){this._logService.warn(`[CHAT](${_}) CANNOT execute command because the command is not registered`);return}let n=!1;function l(){if(n)throw new Error("Only valid while executing the command")}const E=new d.DeferredPromise;f.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(t.extension,E.p);const D=t.command({role:k.ChatMessageRole.User,content:v},{history:g.history.map(F.ChatMessage.to)},new T.Progress(p=>{l(),this._proxy.$handleProgressChunk(a,{content:m(p.message)?p.message:p.message.value})}),f);try{return await(0,d.raceCancellation)(Promise.resolve(D).then(p=>{if(p&&"followUp"in p)return{followUp:p?.followUp?.map(s=>F.ChatFollowup.from(s))}}),f)}finally{n=!0,E.complete()}}}e.ExtHostChatSlashCommands=y;function m(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Te[223],Ae([1,0,6,3,9,8]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadChatVariables)}async $resolveVariable(y,m,P){const _=this._resolver.get(y);if(_)try{const a=await _.resolver.resolve(_.data.name,{message:m},P);if(a)return a.map(F.ChatVariable.from)}catch(a){(0,k.onUnexpectedExternalError)(a)}}registerVariableResolver(y,m,P,_){const a=T._idPool++;return this._resolver.set(a,{extension:y.identifier,data:{name:m,description:P},resolver:_}),this._proxy.$registerVariable(a,{name:m,description:P}),(0,w.toDisposable)(()=>{this._resolver.delete(a),this._proxy.$unregisterVariable(a)})}}e.ExtHostChatVariables=T}),define(Te[224],Ae([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(F){const T=F.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(d){return T.$writeText(d)}})}}e.ExtHostClipboard=R}),define(Te[31],Ae([1,0,16,7,8,24,3,18,14,69,44,279,2,6,4,17,104,25,46,41,59,53,58]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{#e;#t;#i;constructor(I,c,h){this._commands=new Map,this._apiCommands=new Map,this.#e=I.getProxy(T.MainContext.MainThreadCommands),this._logService=c,this.#i=h,this.#t=I.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new i(this,u=>{const A=this._apiCommands.get(u);return A?.result===S.Void?A:void 0},c),this._argumentProcessors=[{processArgument(u){return(0,m.revive)(u)}},{processArgument(u){return(0,F.cloneAndChange)(u,function(A){if(P.Range.isIRange(A))return k.Range.to(A);if(_.Position.isIPosition(A))return k.Position.to(A);if(P.Range.isIRange(A.range)&&a.URI.isUri(A.uri))return k.location.to(A);if(A instanceof n.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(I){this._argumentProcessors.push(I)}registerApiCommand(I){const c=this.registerCommand(!1,I.id,async(...h)=>{const u=I.args.map((B,H)=>{if(!B.validate(h[H]))throw new Error(`Invalid argument '${B.name}' when running '${I.id}', received: ${typeof h[H]=="object"?JSON.stringify(h[H],null,"	"):h[H]} `);return B.convert(h[H])}),A=await this.executeCommand(I.internalId,...u);return I.result.convert(A,h,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this._apiCommands.set(I.id,I),new R.Disposable(()=>{c.dispose(),this._apiCommands.delete(I.id)})}registerCommand(I,c,h,u,A,B){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:h,thisArg:u,description:A,extension:B}),I&&this.#e.$registerCommand(c),new R.Disposable(()=>{this._commands.delete(c)&&I&&this.#e.$unregisterCommand(c)})}executeCommand(I,...c){return this._logService.trace("ExtHostCommands#executeCommand",I),this._doExecuteCommand(I,c,!0)}async _doExecuteCommand(I,c,h){if(this._commands.has(I))return this.#e.$fireCommandActivationEvent(I),this._executeContributedCommand(I,c,!1);{let u=!1;const A=(0,F.cloneAndChange)(c,function(B){if(B instanceof R.Position)return k.Position.from(B);if(B instanceof R.Range)return k.Range.from(B);if(B instanceof R.Location)return k.location.from(B);if(R.NotebookRange.isNotebookRange(B))return k.NotebookRange.from(B);if(B instanceof ArrayBuffer)return u=!0,n.VSBuffer.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return u=!0,n.VSBuffer.wrap(B);if(B instanceof n.VSBuffer)return u=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(I,u?new l.SerializableObjectWithBuffers(A):A,h);return(0,m.revive)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this._doExecuteCommand(I,c,!1);throw B}}}async _executeContributedCommand(I,c,h){const u=this._commands.get(I);if(!u)throw new Error("Unknown command");const{callback:A,thisArg:B,description:H}=u;if(H)for(let z=0;z<H.args.length;z++)try{(0,w.validateConstraint)(c[z],H.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed.Illegal argument '${H.args[z].name}' - ${H.args[z].description} `)}const U=D.StopWatch.create();try{return await A.apply(B,c)}catch(z){if(I===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...c);M&&(I=M.command)}if(this._logService.error(z,I,u.extension?.identifier),!h)throw z;if(u.extension?.identifier){const M=this.#i.onExtensionError(u.extension.identifier,z);this._logService.trace("forwarded error to extension?",M,u.extension?.identifier)}throw new class extends Error{constructor(){super((0,E.toErrorMessage)(z)),this.id=I,this.source=u.extension?.displayName??u.extension?.name}}}finally{this._reportTelemetry(u,I,U.elapsed())}}_reportTelemetry(I,c,h){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new p.TelemetryTrustedValue(c),duration:h})}$executeContributedCommand(I,...c){this._logService.trace("ExtHostCommands#$executeContributedCommand",I);const h=this._commands.get(I);return h?(c=c.map(u=>this._argumentProcessors.reduce((A,B)=>B.processArgument(A,h.extension?.identifier),u)),this._executeContributedCommand(I,c,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this._logService.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(c=>(I&&(c=c.filter(h=>h[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[c,h]of this._commands){const{description:u}=h;u&&(I[c]=u)}return Promise.resolve(I)}};e.ExtHostCommands=s,e.ExtHostCommands=s=Ve([We(0,f.IExtHostRpcService),We(1,y.ILogService),We(2,r.IExtHostTelemetry)],s),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class i{constructor(I,c,h){this._commands=I,this._lookupApiCommand=c,this._logService=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(I,c){if(!I)return;const h={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return h;const u=this._lookupApiCommand(I.command);if(u)h.id=u.internalId,h.arguments=u.args.map((A,B)=>A.convert(I.arguments&&I.arguments[B]));else if((0,d.isNonEmptyArray)(I.arguments)){const A=`${I.command} /${++this._cachIdPool}`;this._cache.set(A,I),c.add((0,v.toDisposable)(()=>{this._cache.delete(A),this._logService.trace("CommandsConverter#DISPOSE",A)})),h.$ident=A,h.id=this.delegatingCommandId,h.arguments=[A],this._logService.trace("CommandsConverter#CREATE",I.command,A)}return h}fromInternal(I){return typeof I.$ident=="string"?this._cache.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this._cache.get(I[0])}_executeConvertedCommand(...I){const c=this.getActualCommand(...I);return this._logService.trace("CommandsConverter#EXECUTE",I[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.CommandsConverter=i;class o{static{this.Uri=new o("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new o("position","A position in a text document",I=>R.Position.isPosition(I),k.Position.from)}static{this.Range=new o("range","A range in a text document",I=>R.Range.isRange(I),k.Range.from)}static{this.Selection=new o("selection","A selection in a text document",I=>R.Selection.isSelection(I),k.Selection.from)}static{this.Number=new o("number","",I=>typeof I=="number",I=>I)}static{this.String=new o("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=o.Arr(o.String)}static Arr(I){return new o(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,c=>Array.isArray(c)&&c.every(h=>I.validate(h)),c=>c.map(h=>I.convert(h)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",I=>I instanceof R.CallHierarchyItem,k.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",I=>I instanceof R.TypeHierarchyItem,k.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VSCodium TestItem",I=>I instanceof t.TestItemImpl,k.TestItem.from)}constructor(I,c,h,u){this.name=I,this.description=c,this.validate=h,this.convert=u}optional(){return new o(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,c){return new o(I??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o;class S{static{this.Void=new S("no result",I=>I)}constructor(I,c){this.description=I,this.convert=c}}e.ApiCommandResult=S;class b{constructor(I,c,h,u,A){this.id=I,this.internalId=c,this.description=h,this.args=u,this.result=A}}e.ApiCommand=b}),define(Te[225],Ae([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const a=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(P.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,n)=>{if((0,w.isFalsyOrEmpty)(t))return;class l extends _.SymbolInformation{static to(D){const p=new l(D.name,P.SymbolKind.to(D.kind),D.containerName||"",new _.Location(n[0],P.Range.to(D.range)));return p.detail=D.detail,p.range=p.location.range,p.selectionRange=P.Range.to(D.selectionRange),p.children=D.children?D.children.map(l.to):[],p}}return t.map(l.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(P.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(P.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(P.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(P.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(P.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(n=>_.Position.isPosition(n)),t=>t.map(P.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(n=>{let l;for(const E of n.reverse())l=new _.SelectionRange(P.Range.to(E),l);return l}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new _.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,T.decodeSemanticTokensDto)(t);if(n.type==="full")return new _.SemanticTokens(n.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new _.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,T.decodeSemanticTokensDto)(t);if(n.type==="full")return new _.SemanticTokens(n.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,n,l)=>{if(!t)return new _.CompletionList([]);const E=t.suggestions.map(D=>P.CompletionItem.to(D,l));return new _.CompletionList(E,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,n,l)=>g(E=>new _.CodeLens(P.Range.to(E.range),E.command&&l.fromInternal(E.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>_.Range.isRange(t),t=>_.Selection.isSelection(t)?P.Selection.from(t):P.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,n,l)=>g(E=>{if(E._isSynthetic){if(!E.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(E.command)}else{const D=new _.CodeAction(E.title,E.kind?new _.CodeActionKind(E.kind):void 0);return E.edit&&(D.edit=P.WorkspaceEdit.to(E.edit)),E.command&&(D.command=l.fromInternal(E.command)),D.isPreferred=E.isPreferred,D}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(n=>new _.ColorInformation(P.Range.to(n.range),P.Color.to(n.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof _.Color,P.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,n,l)=>t.map(P.InlayHint.to.bind(void 0,l)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,n)=>{if(t)return t.map(P.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(n=>P.NotebookExclusiveDocumentPattern.to(n))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof _.Range,t=>P.InlineValueContext.from(t))],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>k.URI.isUri(t)||typeof t=="string"&&(0,y.matchesSomeScheme)(t,R.Schemas.http,R.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.StringArray,new m.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new m.ApiCommandResult("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class v{static register(n){a.forEach(n.registerApiCommand,n),this._registerValidateWhenClausesCommand(n)}static _registerValidateWhenClausesCommand(n){n.registerCommand(!1,"_validateWhenClauses",d.validateWhenClauses)}}e.ExtHostApiCommands=v;function g(t){return n=>{if(Array.isArray(n))return n.map(t)}}function f(t){if(!Array.isArray(t))return;const n=[];for(const l of t)F.isLocationLink(l)?n.push(P.DefinitionLink.to(l)):n.push(P.location.to(l));return n}}),define(Te[226],Ae([1,0,12,65,5,6,2,78,20,8,7,3,26]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(g,f,t){const n=g.getProxy(_.MainContext.MainThreadComments);class l{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,f.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const C=this._commentControllers.get(b.handle);return C?C.value:b}else if(b&&b.$mid===7){const C=this._commentControllers.get(b.commentControlHandle);if(!C)return b;const I=C.getCommentThread(b.commentThreadHandle);return I?I.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const C=this._commentControllers.get(b.thread.commentControlHandle);if(!C)return b;const I=C.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const C=this._commentControllers.get(b.thread.commentControlHandle);if(!C)return b;const I=C.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const c=b.commentUniqueId,h=I.getCommentByUniqueId(c);return h||b}else if(b&&b.$mid===11){const C=this._commentControllers.get(b.thread.commentControlHandle);if(!C)return b;const I=C.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const c=b.text,h=b.commentUniqueId,u=I.getCommentByUniqueId(h);return u?(typeof u.body=="string"?u.body=c:u.body=new P.MarkdownString(c),u):b}return b}})}createCommentController(b,C,I){const c=l.handlePool++,h=new D(b,c,C,I);this._commentControllers.set(h.handle,h);const u=this._commentControllersByExtension.get(b.identifier)||[];return u.push(h),this._commentControllersByExtension.set(b.identifier,u),h.value}$createCommentThreadTemplate(b,C,I){const c=this._commentControllers.get(b);c&&c.$createCommentThreadTemplate(C,I)}async $updateCommentThreadTemplate(b,C,I){const c=this._commentControllers.get(b);c&&c.$updateCommentThreadTemplate(C,I)}$deleteCommentThread(b,C){this._commentControllers.get(b)?.$deleteCommentThread(C)}$provideCommentingRanges(b,C,I){const c=this._commentControllers.get(b);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const h=t.getDocument(T.URI.revive(C));return(0,w.asPromise)(async()=>{const u=await c.commentingRangeProvider.provideCommentingRanges(h,I);let A;return Array.isArray(u)?A={ranges:u,fileComments:!1}:u?A={ranges:u.ranges||[],fileComments:u.fileComments||!1}:A=u??void 0,A}).then(u=>{let A;return u&&(A={ranges:u.ranges.map(B=>m.Range.from(B)),fileComments:u.fileComments}),A})}$toggleReaction(b,C,I,c,h){const u=this._commentControllers.get(b);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const A=u.getCommentThread(C);if(A){const B=A.getCommentByUniqueId(c.uniqueIdInThread);if(u!==void 0&&B&&u.reactionHandler)return u.reactionHandler(B,s(h))}return Promise.resolve(void 0)})}}class E{static{this._handlePool=0}set threadId(b){this._id=b}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(b){(b===void 0!=(this._range===void 0)||!b||!this._range||!b.isEqual(this._range))&&(this._range=b,this.modifications.range=b,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(b){this._canReply!==b&&(this._canReply=b,this.modifications.canReply=b,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(b){this._label=b,this.modifications.label=b,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(b){this._contextValue=b,this.modifications.contextValue=b,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(b){this._comments=b,this.modifications.comments=b,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(b){this._collapseState=b,this.modifications.collapsibleState=b,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(b){this._state=b,this.modifications.state=b,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(b,C,I,c,h,u,A,B){this._commentControllerHandle=C,this._id=I,this._uri=c,this._range=h,this._comments=u,this.extensionDescription=A,this._isTemplate=B,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputDisposables.value=new F.DisposableStore,this._id===void 0&&(this._id=`${b}.${this.handle}`),n.$createCommentThread(C,this.handle,this._id,this._uri,m.Range.from(this._range),A.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{n.$deleteCommentThread(C,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(U){H.range=U},get comments(){return H.comments},set comments(U){H.comments=U},get collapsibleState(){return H.collapsibleState},set collapsibleState(U){H.collapsibleState=U},get canReply(){return H.canReply},set canReply(U){H.canReply=U},get contextValue(){return H.contextValue},set contextValue(U){H.contextValue=U},get label(){return H.label},set label(U){H.label=U},get state(){return H.state},set state(U){H.state=U},dispose:()=>{H.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new F.DisposableStore);const b=I=>Object.prototype.hasOwnProperty.call(this.modifications,I),C={};b("range")&&(C.range=m.Range.from(this._range)),b("label")&&(C.label=this.label),b("contextValue")&&(C.contextValue=this.contextValue??null),b("comments")&&(C.comments=this._comments.map(I=>p(this,I,this._commentsMap,this.extensionDescription))),b("collapsibleState")&&(C.collapseState=i(this._collapseState)),b("canReply")&&(C.canReply=this.canReply),b("state")&&(C.state=o(this._state)),b("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},n.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(b){for(const C of this._commentsMap){const I=C[0],c=C[1];if(b===c)return I}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(b=>b.dispose())}}Ve([(0,R.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class D{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(b){this._commentingRangeProvider=b,n.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(b){this._reactionHandler=b,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this._options}set options(b){this._options=b,n.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(b,C,I,c){this._extension=b,this._handle=C,this._id=I,this._label=c,this._threads=new Map,n.$registerCommentController(this.handle,I,c,this._extension.identifier.value);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(u){h.options=u},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(u){h.commentingRangeProvider=u},get reactionHandler(){return h.reactionHandler},set reactionHandler(u){h.reactionHandler=u},createCommentThread(u,A,B){return h.createCommentThread(u,A,B).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread(b,C,I){C===void 0&&(0,a.checkProposedApiEnabled)(this._extension,"fileComments");const c=new E(this.id,this.handle,void 0,b,C,I,this._extension,!1);return this._threads.set(c.handle,c),c}$createCommentThreadTemplate(b,C){const I=new E(this.id,this.handle,void 0,T.URI.revive(b),m.Range.to(C),[],this._extension,!0);return I.collapsibleState=d.CommentThreadCollapsibleState.Expanded,this._threads.set(I.handle,I),I}$updateCommentThreadTemplate(b,C){const I=this._threads.get(b);I&&(I.range=m.Range.to(C))}$deleteCommentThread(b){this._threads.get(b)?.dispose(),this._threads.delete(b)}getCommentThread(b){return this._threads.get(b)}dispose(){this._threads.forEach(b=>{b.dispose()}),this._localDisposables.forEach(b=>b.dispose())}}function p(S,b,C,I){let c=C.get(b);return c||(c=++S.commentHandle,C.set(b,c)),b.state!==void 0&&(0,a.checkProposedApiEnabled)(I,"commentsDraftState"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:c,body:typeof b.body=="string"?b.body:m.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(h=>r(h)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function r(S){return{label:S.label,iconPath:S.iconPath?m.pathOrURIToURI(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted}}function s(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?T.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1}}function i(S){if(S!==void 0)switch(S){case P.CommentThreadCollapsibleState.Expanded:return d.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return d.CommentThreadCollapsibleState.Collapsed}return d.CommentThreadCollapsibleState.Collapsed}function o(S){if(S!==void 0)switch(S){case P.CommentThreadState.Unresolved:return d.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return d.CommentThreadState.Resolved}return d.CommentThreadState.Unresolved}return new l}e.createExtHostComments=v}),define(Te[227],Ae([1,0,24,3,27,17]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(P,_){this._mainThreadConsole=P.getProxy(R.MainContext.MainThreadConsole),this._includeStack=_.consoleForward.includeStack,this._logNative=_.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(P,_){const a=this,v=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){a._handleConsoleCall(P,_,v,arguments)}})}_handleConsoleCall(P,_,a,v){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:_,arguments:y(v,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(P,a,v)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=Ve([We(0,F.IExtHostRpcService),We(1,k.IExtHostInitDataService)],T);const d=1e5;function y(m,P){const _=[];if(m.length)for(let a=0;a<m.length;a++){let v=m[a];if(typeof v>"u")v="undefined";else if(v instanceof Error){const g=v;g.stack?v=g.stack:v=g.toString()}_.push(v)}if(P){const a=new Error().stack;a&&_.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.safeStringify)(_);return a.length>d?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Te[107],Ae([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class{static{a=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(f,t){this._logService=t,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const n=a._handlePool++;this._provider.set(n,{provider:f,extensionDescription:t}),this._proxy.$registerDecorationProvider(n,t.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(E=>{if(!E){this._proxy.$onDidChange(n,null);return}const D=(0,y.asArray)(E);if(D.length<=a._maxEventSize){this._proxy.$onDidChange(n,D);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,D.length);const p=D.map(i=>({uri:i,rank:(0,m.count)(i.path,"/")})),r=(0,y.groupBy)(p,(i,o)=>i.rank-o.rank||(0,m.compare)(i.uri.path,o.uri.path)),s=[];e:for(const i of r){let o;for(const S of i){const b=(0,P.dirname)(S.uri.path);if(o!==b&&(o=b,s.push(S.uri)>=a._maxEventSize))break e}}this._proxy.$onDidChange(n,s)});return new k.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(f,t,n){if(!this._provider.has(f))return Object.create(null);const l=Object.create(null),{provider:E,extensionDescription:D}=this._provider.get(f);return await Promise.all(t.map(async p=>{try{const{uri:r,id:s}=p,i=await Promise.resolve(E.provideFileDecoration(w.URI.revive(r),n));if(!i)return;try{k.FileDecoration.validate(i),i.badge&&typeof i.badge!="string"&&(0,_.checkProposedApiEnabled)(D,"codiconDecoration"),l[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${D.identifier.value}': ${o}`)}}catch(r){this._logService.error(r)}})),l}};e.ExtHostDecorations=v,e.ExtHostDecorations=v=a=Ve([We(0,T.IExtHostRpcService),We(1,d.ILogService)],v),e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")}),define(Te[228],Ae([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{#e;#t;#i;constructor(t,n,l,E,D,p,r,s){this._name=t,this._owner=n,this._maxDiagnosticsTotal=l,this._maxDiagnosticsPerFile=E,this._modelVersionIdProvider=D,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(E,l),this.#i=new P.ResourceMap(i=>p.getComparisonKey(i)),this.#e=r,this.#t=s}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(t,n){if(!t){this.clear();return}this._checkDisposed();let l=[];if(k.URI.isUri(t)){if(!n){this.delete(t);return}this.#i.set(t,n.slice()),l=[t]}else if(Array.isArray(t)){l=[];let p;t=[...t].sort(v._compareIndexedTuplesByUri);for(const r of t){const[s,i]=r;if((!p||s.toString()!==p.toString())&&(p&&this.#i.get(p).length===0&&this.#i.delete(p),p=s,l.push(s),this.#i.set(s,[])),i)this.#i.get(s)?.push(...i);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(l),!this.#e)return;const E=[];let D=0;for(const p of l){let r=[];const s=this.#i.get(p);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const i=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const S of s)if(S.severity===i[o]&&r.push({...d.Diagnostic.from(S),modelVersionId:this._modelVersionIdProvider(p)})===this._maxDiagnosticsPerFile)break e;r.push({severity:R.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(i=>({...d.Diagnostic.from(i),modelVersionId:this._modelVersionIdProvider(p)}));if(E.push([p,r]),D+=r.length,D>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,E)}delete(t){this._checkDisposed(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this._owner,[[t,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(t,n){this._checkDisposed();for(const[l,E]of this)t.call(n,l,E,this)}*[Symbol.iterator](){this._checkDisposed();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this._checkDisposed();const n=this.#i.get(t);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(t){return this._checkDisposed(),Array.isArray(this.#i.get(t))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(t,n){return t[0].toString()<n[0].toString()?-1:t[0].toString()>n[0].toString()?1:0}}e.DiagnosticCollection=v;let g=class{static{a=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*a._maxDiagnosticsPerFile}static _mapper(t){const n=new P.ResourceMap;for(const l of t)n.set(l,l);return{uris:Object.freeze(Array.from(n.values()))}}constructor(t,n,l,E){this._logService=n,this._fileSystemInfoService=l,this._extHostDocumentsAndEditors=E,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,a._mapper),this._proxy=t.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(t,n){const{_collections:l,_proxy:E,_onDidChangeDiagnostics:D,_logService:p,_fileSystemInfoService:r,_extHostDocumentsAndEditors:s}=this,i=new class{$changeMany(b,C){E.$changeMany(b,C),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,b,C.length===0?"CLEARING":C)}$clear(b){E.$clear(b),p.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,b)}dispose(){E.dispose()}};let o;if(!n)n="_generated_diagnostic_collection_name_#"+a._idPool++,o=n;else if(!l.has(n))o=n;else{this._logService.warn(`DiagnosticCollection with name '${n}' does already exist.`);do o=n+a._idPool++;while(l.has(o))}return new class extends v{constructor(){super(n,o,a._maxDiagnosticsTotal,a._maxDiagnosticsPerFile,b=>s.getDocument(b)?.version,r.extUri,i,D),l.set(o,this)}dispose(){super.dispose(),l.delete(o)}}}getDiagnostics(t){if(t)return this._getDiagnostics(t);{const n=new Map,l=[];for(const E of this._collections.values())E.forEach((D,p)=>{let r=n.get(D.toString());typeof r>"u"&&(r=l.length,n.set(D.toString(),r),l.push([D,[]])),l[r][1]=l[r][1].concat(...p)});return l}}_getDiagnostics(t){let n=[];for(const l of this._collections.values())l.has(t)&&(n=n.concat(l.get(t)));return n}$acceptMarkersChange(t){if(!this._mirrorCollection){const n="_generated_mirror",l=new v(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,E=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(n,l),this._mirrorCollection=l}for(const[n,l]of t)this._mirrorCollection.set(k.URI.revive(n),l.map(d.Diagnostic.to))}};e.ExtHostDiagnostics=g,e.ExtHostDiagnostics=g=a=Ve([We(1,m.ILogService),We(2,_.IExtHostFileSystemInfo)],g)}),define(Te[229],Ae([1,0,2,3,26]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class F{constructor(d){this._proxy=d.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(d,y){return y?.allowUIResources&&(0,k.checkProposedApiEnabled)(d,"showLocal"),this._proxy.$showOpenDialog(y).then(m=>m?m.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(d){return this._proxy.$showSaveDialog(d).then(y=>y?w.URI.revive(y):void 0)}}e.ExtHostDialogs=F}),define(Te[230],Ae([1,0,9,2,7,3,13,21,15]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{static{this._handlePool=0}constructor(_,a,v){this._documentsAndEditors=a,this._logService=v,this._documentContentProviders=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,a){if(Object.keys(T.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const v=m._handlePool++;this._documentContentProviders.set(v,a),this._proxy.$registerTextContentProvider(v,_);let g;return typeof a.onDidChange=="function"&&(g=a.onDidChange(f=>{if(f.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(t=>{if(!t&&typeof t!="string")return;const n=this._documentsAndEditors.getDocument(f);if(!n)return;const l=(0,y.splitLines)(t);if(!n.equalLines(l))return this._proxy.$onVirtualDocumentChange(f,t)},w.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(v)&&this._proxy.$unregisterTextContentProvider(v),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(_,a){const v=this._documentContentProviders.get(_);return v?Promise.resolve(v.provideTextDocumentContent(R.URI.revive(a),d.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=m}),define(Te[231],Ae([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class a{constructor(g,f){this._onDidAddDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidRemoveDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidChangeDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this._onDidSaveDocument=new w.Emitter({onListenerError:_.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(F.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const n of t)this._onDidRemoveDocument.fire(n.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const n of t)this._onDidAddDocument.fire(n.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const f=this._documentsAndEditors.getDocument(g);if(f)return f}getDocument(g){const f=this.getDocumentData(g);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return f.document}ensureDocumentData(g){const f=this._documentsAndEditors.getDocument(g);if(f)return Promise.resolve(f);let t=this._documentLoader.get(g.toString());return t||(t=this._proxy.$tryOpenDocument(g).then(n=>{this._documentLoader.delete(g.toString());const l=k.URI.revive(n);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(l))},n=>(this._documentLoader.delete(g.toString()),Promise.reject(n))),this._documentLoader.set(g.toString(),t)),t}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(f=>k.URI.revive(f))}$acceptModelLanguageChanged(g,f){const t=k.URI.revive(g),n=this._documentsAndEditors.getDocument(t);if(!n)throw new Error("unknown document");this._onDidRemoveDocument.fire(n.document),n._acceptLanguageId(f),this._onDidAddDocument.fire(n.document)}$acceptModelSaved(g){const f=k.URI.revive(g),t=this._documentsAndEditors.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(g,f){const t=k.URI.revive(g),n=this._documentsAndEditors.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(f),this._onDidChangeDocument.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,f,t){const n=k.URI.revive(g),l=this._documentsAndEditors.getDocument(n);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(f);let E;f.isUndoing?E=P.TextDocumentChangeReason.Undo:f.isRedoing&&(E=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,m.deepFreeze)({document:l.document,contentChanges:f.changes.map(D=>({range:d.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:E}))}setWordDefinitionFor(g,f){(0,T.setWordDefinitionFor)(g,f)}}e.ExtHostDocuments=a}),define(Te[60],Ae([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,67,66]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class n{constructor(D){this.value=D,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let l=class{constructor(D,p){this._extHostRpc=D,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new v.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],r=[],s=[];if(D.removedDocuments)for(const i of D.removedDocuments){const o=F.URI.revive(i),S=this._documents.get(o);S?.unref()&&(this._documents.delete(o),p.push(S.value))}if(D.addedDocuments)for(const i of D.addedDocuments){const o=F.URI.revive(i.uri);let S=this._documents.get(o);if(S&&o.scheme!==g.Schemas.vscodeNotebookCell&&o.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);S||(S=new n(new y.ExtHostDocumentData(this._extHostRpc.getProxy(d.MainContext.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(o,S),r.push(S.value)),S.ref()}if(D.removedEditors)for(const i of D.removedEditors){const o=this._editors.get(i);this._editors.delete(i),o&&s.push(o)}if(D.addedEditors)for(const i of D.addedEditors){const o=F.URI.revive(i.documentUri);w.ok(this._documents.has(o),`document '${o}' does not exist`),w.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const S=this._documents.get(o).value,b=new P.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(d.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>S.document),i.selections.map(_.Selection.to),i.options,i.visibleRanges.map(C=>_.Range.to(C)),typeof i.editorPosition=="number"?_.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,b)}D.newActiveEditor!==void 0&&(w.ok(D.newActiveEditor===null||this._editors.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this._activeEditorId=D.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(s),D.removedDocuments&&this._onDidRemoveDocuments.fire(p),D.addedDocuments&&this._onDidAddDocuments.fire(r),(D.removedEditors||D.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),D.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(D){return this._documents.get(D)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),D=>D.value)}getEditor(D){return this._editors.get(D)}activeEditor(D){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return D?p:p?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=l,e.ExtHostDocumentsAndEditors=l=Ve([We(0,m.IExtHostRpcService),We(1,a.ILogService)],l),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Te[61],Ae([1,0,8,3,2,5,4,7,17,16,232]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class _{constructor(t,n,l){this._activeTabIdGetter=l,this._parentGroup=n,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,n={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(n)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new d.TextTabInput(k.URI.revive(this._dto.input.uri));case 2:return new d.TextDiffTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified));case 3:return new d.TextMergeTabInput(k.URI.revive(this._dto.input.base),k.URI.revive(this._dto.input.input1),k.URI.revive(this._dto.input.input2),k.URI.revive(this._dto.input.result));case 6:return new d.CustomEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new d.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new d.NotebookEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new d.NotebookDiffEditorTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new d.TerminalEditorTabInput;case 9:return new d.InteractiveWindowInput(k.URI.revive(this._dto.input.uri),k.URI.revive(this._dto.input.inputBoxUri));default:return}}}class a{constructor(t,n){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=n;for(const l of t.tabs)l.isActive&&(this._activeTabId=l.id),this._tabs.push(new _(l,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,n={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return w.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(l=>l.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(l=>l.apiObject))}};this._apiObject=Object.freeze(n)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const l=new _(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,l),t.tabDto.isActive&&(this._activeTabId=l.tabId),l}else if(t.kind===1){const l=this._tabs.splice(t.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return l.tabId===this._activeTabId&&(this._activeTabId=""),l}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this._tabs.splice(t.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,l),l}const n=this._tabs.find(l=>l.tabId===t.tabDto.id);if(!n)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),n.acceptDtoUpdate(t.tabDto),n}activeTabId(){return this._activeTabId}}let v=class{constructor(t){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,n={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(l=>l.apiObject))},get activeTabGroup(){const l=t._activeGroupId;return(0,m.assertIsDefined)(t._extHostTabGroups.find(D=>D.groupId===l)?.apiObject)},close:async(l,E)=>{const D=Array.isArray(l)?l:[l];return D.length?g(D[0])?this._closeGroups(D,E):this._closeTabs(D,E):!0}};this._apiObject=Object.freeze(n)}return this._apiObject}$acceptEditorTabModel(t){const n=new Set(this._extHostTabGroups.map(i=>i.groupId)),l=new Set(t.map(i=>i.groupId)),E=(0,P.diffSets)(n,l),D=this._extHostTabGroups.filter(i=>E.removed.includes(i.groupId)).map(i=>i.apiObject),p=[],r=[];this._extHostTabGroups=t.map(i=>{const o=new a(i,()=>this._activeGroupId);return E.added.includes(o.groupId)?p.push(o.apiObject):r.push(o.apiObject),o});const s=(0,m.assertIsDefined)(t.find(i=>i.isActive===!0)?.groupId);s!==void 0&&this._activeGroupId!==s&&(this._activeGroupId=s),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:D,changed:r}))}$acceptTabGroupUpdate(t){const n=this._extHostTabGroups.find(l=>l.groupId===t.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const n=this._extHostTabGroups.find(E=>E.groupId===t.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const l=n.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}_findExtHostTabFromApi(t){for(const n of this._extHostTabGroups)for(const l of n.tabs)if(l.apiObject===t)return l}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(n=>n.apiObject===t)}async _closeTabs(t,n){const l=[];for(const E of t){const D=this._findExtHostTabFromApi(E);if(!D)throw new Error("Tab close: Invalid tab not found!");l.push(D.tabId)}return this._proxy.$closeTab(l,n)}async _closeGroups(t,n){const l=[];for(const E of t){const D=this._findExtHostTabGroupFromApi(E);if(!D)throw new Error("Group close: Invalid group not found!");l.push(D.groupId)}return this._proxy.$closeGroup(l,n)}};e.ExtHostEditorTabs=v,e.ExtHostEditorTabs=v=Ve([We(0,y.IExtHostRpcService)],v);function g(f){return f.tabs!==void 0}}),define(Te[233],Ae([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class k{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(w.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,d,y){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const m=this._AiEmbeddingVectorProviders.get(T);if(!m)throw new Error("Embedding vector provider not found");const P=await m.provideEmbeddingVector(d,y);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(T,d,y){const m=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(m,y),this._proxy.$registerAiEmbeddingVectorProvider(d,m),new R.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(m),this._AiEmbeddingVectorProviders.delete(m)})}}e.ExtHostAiEmbeddingVector=k}),define(Te[234],Ae([1,0,2,3,6,7,8,280,15,25,26,49]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class a{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const t=this._schemes.indexOf(f);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),t=[];let n,l,E=14,D=14;for(const p of f){let r=n?(0,y.commonPrefixLength)(n,p):0;for(r===0?l=1:l=D;r<p.length;r++)r+1===p.length?(E=D,D=9):D+=1,t.push([l,p.toUpperCase().charCodeAt(r),D]),t.push([l,p.toLowerCase().charCodeAt(r),D]),l=D;n=p,D=E}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new d.StateMachine(t)}}provideDocumentLinks(f){this._initStateMachine();const t=[],n=d.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const l of n){const E=T.DocumentLink.to(l);E.target&&t.push(E)}return t}}class v{constructor(f,t){this._extHostLanguageFeatures=t,this._linkProvider=new a,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,t,n,l={}){if(v._validateFileSystemProvider(n),this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const E=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(E,n);let D=2;l.isCaseSensitive&&(D+=1024),l.isReadonly&&(D+=2048),typeof n.copy=="function"&&(D+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,P.checkProposedApiEnabled)(f,"fsChunks"),D+=4);let p;l.isReadonly&&(0,_.isMarkdownString)(l.isReadonly)&&((0,P.checkProposedApiEnabled)(f,"readonlyMessage"),p={value:l.isReadonly.value,isTrusted:l.isReadonly.isTrusted,supportThemeIcons:l.isReadonly.supportThemeIcons,supportHtml:l.isReadonly.supportHtml,baseUri:l.isReadonly.baseUri,uris:l.isReadonly.uris}),this._proxy.$registerFileSystemProvider(E,t,D,p).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=n.onDidChangeFile(s=>{const i=[];for(const o of s){const{uri:S,type:b}=o;if(S.scheme!==t)continue;let C;switch(b){case F.FileChangeType.Changed:C=0;break;case F.FileChangeType.Created:C=1;break;case F.FileChangeType.Deleted:C=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:S,type:C})}this._proxy.$onFileSystemChange(E,i)});return(0,k.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(E),this._proxy.$unregisterProvider(E)})}static _validateFileSystemProvider(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(f){const{type:t,ctime:n,mtime:l,size:E,permissions:D}=f;return{type:t,ctime:n,mtime:l,size:E,permissions:D}}$stat(f,t){return Promise.resolve(this._getFsProvider(f).stat(w.URI.revive(t))).then(n=>v._asIStat(n))}$readdir(f,t){return Promise.resolve(this._getFsProvider(f).readDirectory(w.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this._getFsProvider(f).readFile(w.URI.revive(t))).then(n=>m.VSBuffer.wrap(n))}$writeFile(f,t,n,l){return Promise.resolve(this._getFsProvider(f).writeFile(w.URI.revive(t),n.buffer,l))}$delete(f,t,n){return Promise.resolve(this._getFsProvider(f).delete(w.URI.revive(t),n))}$rename(f,t,n,l){return Promise.resolve(this._getFsProvider(f).rename(w.URI.revive(t),w.URI.revive(n),l))}$copy(f,t,n,l){const E=this._getFsProvider(f);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(w.URI.revive(t),w.URI.revive(n),l))}$mkdir(f,t){return Promise.resolve(this._getFsProvider(f).createDirectory(w.URI.revive(t)))}$watch(f,t,n,l){const E=this._getFsProvider(f).watch(w.URI.revive(n),l);this._watches.set(t,E)}$unwatch(f,t){const n=this._watches.get(t);n&&(n.dispose(),this._watches.delete(t))}$open(f,t,n){const l=this._getFsProvider(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(w.URI.revive(t),n))}$close(f,t){const n=this._getFsProvider(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(t))}$read(f,t,n,l){const E=this._getFsProvider(f);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const D=m.VSBuffer.alloc(l);return Promise.resolve(E.read(t,n,D.buffer,0,l)).then(p=>D.slice(0,p))}$write(f,t,n,l){const E=this._getFsProvider(f);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(t,n,l.buffer,0,l.byteLength))}_getFsProvider(f){const t=this._fsProvider.get(f);if(!t){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return t}}e.ExtHostFileSystem=v}),define(Te[62],Ae([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let g=v=class{constructor(t,n){this._fileSystemProvider=new Map,this._writeQueue=new P.ResourceQueue,this._proxy=t.getProxy(w.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(E){try{let D;const p=l._fileSystemProvider.get(E.scheme);return p?(await l._proxy.$ensureActivation(E.scheme),D=await p.impl.stat(E)):D=await l._proxy.$stat(E),{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions===R.FilePermission.Readonly?1:void 0}}catch(D){v._handleError(D)}},async readDirectory(E){try{const D=l._fileSystemProvider.get(E.scheme);return D?(await l._proxy.$ensureActivation(E.scheme),(await D.impl.readDirectory(E)).slice()):await l._proxy.$readdir(E)}catch(D){return v._handleError(D)}},async createDirectory(E){try{const D=l._fileSystemProvider.get(E.scheme);return D&&!D.isReadonly?(await l._proxy.$ensureActivation(E.scheme),await l.mkdirp(D.impl,D.extUri,E)):await l._proxy.$mkdir(E)}catch(D){return v._handleError(D)}},async readFile(E){try{const D=l._fileSystemProvider.get(E.scheme);return D?(await l._proxy.$ensureActivation(E.scheme),(await D.impl.readFile(E)).slice()):(await l._proxy.$readFile(E)).buffer}catch(D){return v._handleError(D)}},async writeFile(E,D){try{const p=l._fileSystemProvider.get(E.scheme);return p&&!p.isReadonly?(await l._proxy.$ensureActivation(E.scheme),await l.mkdirp(p.impl,p.extUri,p.extUri.dirname(E)),await l._writeQueue.queueFor(E).queue(()=>Promise.resolve(p.impl.writeFile(E,D,{create:!0,overwrite:!0})))):await l._proxy.$writeFile(E,F.VSBuffer.wrap(D))}catch(p){return v._handleError(p)}},async delete(E,D){try{const p=l._fileSystemProvider.get(E.scheme);return p&&!p.isReadonly?(await l._proxy.$ensureActivation(E.scheme),await p.impl.delete(E,{recursive:!1,...D})):await l._proxy.$delete(E,{recursive:!1,useTrash:!1,atomic:!1,...D})}catch(p){return v._handleError(p)}},async rename(E,D,p){try{return await l._proxy.$rename(E,D,{overwrite:!1,...p})}catch(r){return v._handleError(r)}},async copy(E,D,p){try{return await l._proxy.$copy(E,D,{overwrite:!1,...p})}catch(r){return v._handleError(r)}},isWritableFileSystem(E){const D=n.getCapabilities(E);if(typeof D=="number")return!(D&2048)}})}async mkdirp(t,n,l){const E=[];for(;!n.isEqual(l,n.dirname(l));)try{if(!((await t.stat(l)).type&R.FileType.Directory))throw k.FileSystemError.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(D){if(R.toFileSystemProviderErrorCode(D)!==R.FileSystemProviderErrorCode.FileNotFound)throw D;E.push(n.basename(l)),l=n.dirname(l)}for(let D=E.length-1;D>=0;D--){l=n.joinPath(l,E[D]);try{await t.createDirectory(l)}catch(p){if(R.toFileSystemProviderErrorCode(p)!==R.FileSystemProviderErrorCode.FileExists)throw p}}}static _handleError(t){if(t instanceof k.FileSystemError)throw t;if(t instanceof R.FileSystemProviderError)switch(t.code){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(t.message);default:throw new k.FileSystemError(t.message,t.name)}if(!(t instanceof Error))throw new k.FileSystemError(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw k.FileSystemError.Unavailable(t.message);switch(t.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(t.message);default:throw new k.FileSystemError(t.message,t.name)}}addFileSystemProvider(t,n,l){return this._fileSystemProvider.set(t,{impl:n,extUri:l?.isCaseSensitive?_.extUri:_.extUriIgnorePathCase,isReadonly:!!l?.isReadonly}),(0,m.toDisposable)(()=>this._fileSystemProvider.delete(t))}getFileSystemProviderExtUri(t){return this._fileSystemProvider.get(t)?.extUri??_.extUri}};e.ExtHostConsumerFileSystem=g,e.ExtHostConsumerFileSystem=g=v=Ve([We(0,d.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],g),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Te[235],Ae([1,0,5,37,2,3,8,7]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(_,a,v,g,f,t,n,l){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter;const E=this.ensureWatching(_,v,f);this._config=0,t&&(this._config+=1),n&&(this._config+=2),l&&(this._config+=4);const D=(0,R.parse)(f),p=typeof f=="string",r=g(s=>{if(!t)for(const i of s.created){const o=k.URI.revive(i);D(o.fsPath)&&(!p||a.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!n)for(const i of s.changed){const o=k.URI.revive(i);D(o.fsPath)&&(!p||a.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!l)for(const i of s.deleted){const o=k.URI.revive(i);D(o.fsPath)&&(!p||a.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}});this._disposable=d.Disposable.from(E,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(_,a,v){const g=d.Disposable.from();if(typeof v=="string")return g;const f=_.getProxy(F.MainContext.MainThreadFileSystem);let t=!1;(v.pattern.includes(R.GLOBSTAR)||v.pattern.includes(R.GLOB_SPLIT))&&(t=!0);const n=Math.random();return f.$watch(a.identifier.value,n,v.baseUri,{recursive:t,excludes:[]}),d.Disposable.from({dispose:()=>f.$unwatch(n)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class m{constructor(_,a,v){this._mainContext=_,this._logService=a,this._extHostDocumentsAndEditors=v,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new w.AsyncEmitter,this._onWillCreateFile=new w.AsyncEmitter,this._onWillDeleteFile=new w.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(_,a,v,g,f,t){return new y(this._mainContext,_,a,this._onFileSystemEvent.event,T.GlobPattern.from(v),g,f,t)}$onFileEvent(_){this._onFileSystemEvent.fire(_)}$onDidRunFileOperation(_,a){switch(_){case 2:this._onDidRenameFile.fire(Object.freeze({files:a.map(v=>({oldUri:k.URI.revive(v.source),newUri:k.URI.revive(v.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:a.map(v=>k.URI.revive(v.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:a.map(v=>k.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(_){return this._createWillExecuteEvent(_,this._onWillRenameFile)}getOnWillCreateFileEvent(_){return this._createWillExecuteEvent(_,this._onWillCreateFile)}getOnWillDeleteFileEvent(_){return this._createWillExecuteEvent(_,this._onWillDeleteFile)}_createWillExecuteEvent(_,a){return(v,g,f)=>{const t=function(l){v.call(g,l)};return t.extension=_,a.event(t,void 0,f)}}async $onWillRunFileOperation(_,a,v,g){switch(_){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:a.map(f=>({oldUri:k.URI.revive(f.source),newUri:k.URI.revive(f.target)}))},v,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:a.map(f=>k.URI.revive(f.target))},v,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:a.map(f=>k.URI.revive(f.target))},v,g)}}async _fireWillEvent(_,a,v,g){const f=new Set,t=[];if(await _.fireAsync(a,g,async(l,E)=>{const D=Date.now(),p=await Promise.resolve(l);p instanceof d.WorkspaceEdit&&(t.push([E.extension,p]),f.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-D>v&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const n={edits:[]};for(const[,l]of t){const{edits:E}=T.WorkspaceEdit.from(l,{getTextDocumentVersion:D=>this._extHostDocumentsAndEditors.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(E)}return{edit:n,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=m}),define(Te[236],Ae([1,0,6,2,3,8,7,31]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(a,v){this.extension=a,this.provider=v,this.handle=y._pool++}}class m{constructor(a){this.session=a,this.responses=[]}}class P{static{this._nextId=0}constructor(a,v,g,f){this._documents=g,this._logService=f,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=a.getProxy(k.MainContext.MainThreadInlineChat),v.registerApiCommand(new d.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new d.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?F.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?F.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?F.Position.from(t.position):void 0}})],d.ApiCommandResult.Void))}registerProvider(a,v,g){const f=new y(a,v);return this._inputProvider.set(f.handle,f),this._proxy.$registerInteractiveEditorProvider(f.handle,g.label,a.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function"),(0,w.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(f.handle),this._inputProvider.delete(f.handle)})}async $prepareSession(a,v,g,f){const t=this._inputProvider.get(a);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this._documents.getDocument(R.URI.revive(v)),l=F.Selection.to(g),E=await t.provider.prepareInteractiveEditorSession({document:n,selection:l},f);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(l))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const D=P._nextId++;return this._inputSessions.set(D,new m(E)),{id:D,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(p=>({command:p.command,detail:p.detail,refer:p.refer,executeImmediately:p.executeImmediately})),wholeRange:F.Range.from(E.wholeRange),message:E.message}}async $provideResponse(a,v,g,f){const t=this._inputProvider.get(a);if(!t)return;const n=this._inputSessions.get(v.id);if(!n)return;const l={prompt:g.prompt,selection:F.Selection.to(g.selection),wholeRange:F.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let E=!1;const D={report:s=>{if(!g.live)throw new Error("Progress reporting is only supported for live sessions");E||f.isCancellationRequested||!s.message&&!s.edits||this._proxy.$handleProgressChunk(g.requestId,{message:s.message,edits:s.edits?.map(F.TextEdit.from)})}},p=t.provider.provideInteractiveEditorResponse(n.session,l,D,f);Promise.resolve(p).finally(()=>E=!0);const r=await p;if(r){const s=n.responses.push(r)-1,i={wholeRange:F.Range.from(r.wholeRange),placeholder:r.placeholder};if(P._isMessageResponse(r))return{...i,id:s,type:"message",message:F.MarkdownString.from(r.contents)};const{edits:o}=r;if(o instanceof T.WorkspaceEdit)return{...i,id:s,type:"bulkEdit",edits:F.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...i,id:s,type:"editorEdit",edits:o.map(F.TextEdit.from)}}}$handleFeedback(a,v,g,f){const t=this._inputProvider.get(a),n=this._inputSessions.get(v),l=n?.responses[g];if(t&&l){const E=F.InteractiveEditorResponseFeedbackKind.to(f);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,l,E)}}$releaseSession(a,v){}static _isMessageResponse(a){return typeof a=="object"&&typeof a.contents=="object"}}e.ExtHostInteractiveEditor=P}),define(Te[237],Ae([1,0,2,31]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,d,y,m,P){this._extHostNotebooks=d,this._textDocumentsAndEditors=y,this._commands=m;const _=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",a=>!0,a=>a),new R.ApiCommandArgument("resource","Interactive resource Uri",a=>!0,a=>a),new R.ApiCommandArgument("controllerId","Notebook controller Id",a=>!0,a=>a),new R.ApiCommandArgument("title","Interactive editor title",a=>!0,a=>a)],new R.ApiCommandResult("Notebook and input URI",a=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const v=this._extHostNotebooks.getEditorById(a.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:v.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this._commands.registerApiCommand(_)}$willAddInteractiveDocument(T,d,y,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:d,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(w.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,d){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(Te[238],Ae([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class k{constructor(T){this._IssueUriRequestHandlers=new Map,this._proxy=T.getProxy(w.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,d){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const m=await y.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(T,d){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,d),this._proxy.$registerIssueUriRequestHandler(y),new R.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=k}),define(Te[239],Ae([1,0,6,3]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const d=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(d,T),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(d)})}}e.ExtHostLabelService=k}),define(Te[240],Ae([1,0,2,24,8,7,78,3,15,44,18,16,281,21,20,6,91,88,55,59,9,12,26,149]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentSymbols(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideDocumentSymbols(K,V);if(!(0,P.isFalsyOrEmpty)(G))return G[0]instanceof F.DocumentSymbol?G.map(k.DocumentSymbol.from):i._asDocumentSymbolTree(G)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((G,q)=>{let Z=G.location.range.start.compareTo(q.location.range.start);return Z===0&&(Z=q.location.range.end.compareTo(G.location.range.end)),Z});const V=[],K=[];for(const G of O){const q={name:G.name||"!!MISSING: name!!",kind:k.SymbolKind.from(G.kind),tags:G.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:k.Range.from(G.location.range),selectionRange:k.Range.from(G.location.range),children:[]};for(;;){if(K.length===0){K.push(q),V.push(q);break}const Z=K[K.length-1];if(m.Range.containsRange(Z.range,q.range)&&!m.Range.equalsRange(Z.range,q.range)){Z.children?.push(q),K.push(q);break}K.pop()}}return V}}class o{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(O,V,K){this._documents=O,this._commands=V,this._provider=K,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideCodeLenses(K,V);if(!G||V.isCancellationRequested)return;const q=this._cache.add(G),Z=new f.DisposableStore;this._disposables.set(q,Z);const ae={cacheId:q,lenses:[]};for(let Me=0;Me<G.length;Me++)ae.lenses.push({cacheId:[q,Me],range:k.Range.from(G[Me].range),command:this._commands.toInternal(G[Me].command,Z)});return ae}async resolveCodeLens(O,V){const K=O.cacheId&&this._cache.get(...O.cacheId);if(!K)return;let G;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?G=K:G=await this._provider.resolveCodeLens(K,V),G||(G=K),V.isCancellationRequested)return;const q=O.cacheId&&this._disposables.get(O.cacheId[0]);if(q)return O.command=this._commands.toInternal(G.command??o._badCmd,q),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}function S(Ie){return Array.isArray(Ie)?Ie.map(k.DefinitionLink.from):Ie?[k.DefinitionLink.from(Ie)]:[]}class b{constructor(O,V){this._documents=O,this._provider=V}async provideDefinition(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideDefinition(G,q,K);return S(Z)}}class C{constructor(O,V){this._documents=O,this._provider=V}async provideDeclaration(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideDeclaration(G,q,K);return S(Z)}}class I{constructor(O,V){this._documents=O,this._provider=V}async provideImplementation(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideImplementation(G,q,K);return S(Z)}}class c{constructor(O,V){this._documents=O,this._provider=V}async provideTypeDefinition(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideTypeDefinition(G,q,K);return S(Z)}}class h{constructor(O,V){this._documents=O,this._provider=V}async provideHover(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideHover(G,q,K);if(!(!Z||(0,P.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=G.getWordRangeAtPosition(q)),Z.range||(Z.range=new F.Range(q,q)),k.Hover.from(Z)}}class u{constructor(O,V){this._documents=O,this._provider=V}async provideEvaluatableExpression(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideEvaluatableExpression(G,q,K);if(Z)return k.EvaluatableExpression.from(Z)}}class A{constructor(O,V){this._documents=O,this._provider=V}async provideInlineValues(O,V,K,G){const q=this._documents.getDocument(O),Z=await this._provider.provideInlineValues(q,k.Range.to(V),k.InlineValueContext.to(K),G);if(Array.isArray(Z))return Z.map(ae=>k.InlineValue.from(ae))}}class B{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentHighlights(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideDocumentHighlights(G,q,K);if(Array.isArray(Z))return Z.map(k.DocumentHighlight.from)}}class H{constructor(O,V){this._documents=O,this._provider=V}async provideLinkedEditingRanges(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.provideLinkedEditingRanges(G,q,K);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,P.coalesce)(Z.ranges.map(k.Range.from)),wordPattern:Z.wordPattern}}}class U{constructor(O,V){this._documents=O,this._provider=V}async provideReferences(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ae=await this._provider.provideReferences(q,Z,K,G);if(Array.isArray(ae))return ae.map(k.location.from)}}class z{static{this._maxCodeActionsPerFile=1e3}constructor(O,V,K,G,q,Z,ae){this._documents=O,this._commands=V,this._diagnostics=K,this._provider=G,this._logService=q,this._extension=Z,this._apiDeprecation=ae,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,V,K,G){const q=this._documents.getDocument(O),Z=a.Selection.isISelection(V)?k.Selection.to(V):k.Range.to(V),ae=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(Z.intersection(Ye.range)&&ae.push(Ye)>z._maxCodeActionsPerFile)break;const Me={diagnostics:ae,only:K.only?new F.CodeActionKind(K.only):void 0,triggerKind:k.CodeActionTriggerKind.to(K.trigger)},Ue=await this._provider.provideCodeActions(q,Z,Me,G);if(!(0,P.isNonEmptyArray)(Ue)||G.isCancellationRequested)return;const Ge=this._cache.add(Ue),je=new f.DisposableStore;this._disposables.set(Ge,je);const Je=[];for(let Ye=0;Ye<Ue.length;Ye++){const et=Ue[Ye];et&&(z._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,je)})):(Me.only&&(et.kind?Me.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ge,Ye],title:et.title,command:et.command&&this._commands.toInternal(et.command,je),diagnostics:et.diagnostics&&et.diagnostics.map(k.Diagnostic.from),edit:et.edit&&k.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ge,actions:Je}}async resolveCodeAction(O,V){const[K,G]=O,q=this._cache.get(K,G);if(!q||z._isCommand(q))return{};if(!this._provider.resolveCodeAction)return{};const Z=await this._provider.resolveCodeAction(q,V)??q;let ae;Z.edit&&(ae=k.WorkspaceEdit.from(Z.edit,void 0));let Me;if(Z.command){const Ue=this._disposables.get(K);Ue&&(Me=this._commands.toInternal(Z.command,Ue))}return{edit:ae,command:Me}}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}class M{static toInternalProviderId(O,V){return O+"."+V}constructor(O,V,K,G,q){this._proxy=O,this._documents=V,this._provider=K,this._handle=G,this._extension=q}async prepareDocumentPaste(O,V,K,G){if(!this._provider.prepareDocumentPaste)return;const q=this._documents.getDocument(O),Z=V.map(Ue=>k.Range.to(Ue)),ae=k.DataTransfer.toDataTransfer(K,()=>{throw new D.NotImplementedError});if(await this._provider.prepareDocumentPaste(q,Z,ae,G),G.isCancellationRequested)return;const Me=Array.from(ae).filter(([,Ue])=>!(Ue instanceof F.InternalDataTransferItem));return k.DataTransfer.from(Me)}async providePasteEdits(O,V,K,G,q){if(!this._provider.provideDocumentPasteEdits)return;const Z=this._documents.getDocument(V),ae=K.map(Ge=>k.Range.to(Ge)),Me=k.DataTransfer.toDataTransfer(G,async Ge=>(await this._proxy.$resolvePasteFileData(this._handle,O,Ge)).buffer),Ue=await this._provider.provideDocumentPasteEdits(Z,ae,Me,q);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:Ue.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:M.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?k.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentFormattingEdits(O,V,K){const G=this._documents.getDocument(O),q=await this._provider.provideDocumentFormattingEdits(G,V,K);if(Array.isArray(q))return q.map(k.TextEdit.from)}}class ee{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeFormattingEdits(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Range.to(V),ae=await this._provider.provideDocumentRangeFormattingEdits(q,Z,K,G);if(Array.isArray(ae))return ae.map(k.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,V,K,G){(0,_.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this._documents.getDocument(O),Z=V.map(k.Range.to),ae=await this._provider.provideDocumentRangesFormattingEdits(q,Z,K,G);if(Array.isArray(ae))return ae.map(k.TextEdit.from)}}class Q{constructor(O,V){this._documents=O,this._provider=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,V,K,G,q){const Z=this._documents.getDocument(O),ae=k.Position.to(V),Me=await this._provider.provideOnTypeFormattingEdits(Z,ae,K,G,q);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class Se{constructor(O,V){this._provider=O,this._logService=V,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,V){const K=await this._provider.provideWorkspaceSymbols(O,V);if(!(0,P.isNonEmptyArray)(K))return{symbols:[]};const G=this._cache.add(K),q={cacheId:G,symbols:[]};for(let Z=0;Z<K.length;Z++){const ae=K[Z];if(!ae||!ae.name){this._logService.warn("INVALID SymbolInformation",ae);continue}q.symbols.push({...k.WorkspaceSymbol.from(ae),cacheId:[G,Z]})}return q}async resolveWorkspaceSymbol(O,V){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const K=this._cache.get(...O.cacheId);if(K){const G=await this._provider.resolveWorkspaceSymbol(K,V);return G&&(0,R.mixin)(O,k.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class ye{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,V,K){this._documents=O,this._provider=V,this._logService=K}async provideRenameEdits(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V);try{const ae=await this._provider.provideRenameEdits(q,Z,K,G);return ae?k.WorkspaceEdit.from(ae):void 0}catch(ae){const Me=ye._asMessage(ae);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(O,V,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const G=this._documents.getDocument(O),q=k.Position.to(V);try{const Z=await this._provider.prepareRename(G,q,K);let ae,Me;if(F.Range.isRange(Z)?(ae=Z,Me=G.getText(Z)):(0,_.isObject)(Z)&&(ae=Z.range,Me=Z.placeholder),!ae||!Me)return;if(ae.start.line>q.line||ae.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ae),text:Me}}catch(Z){const ae=ye._asMessage(Z);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class Pe{constructor(O,V){this.resultId=O,this.tokens=V}}class Y{constructor(O,V){this._documents=O,this._provider=V,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,V,K){const G=this._documents.getDocument(O),q=V!==0?this._previousResults.get(V):null;let Z=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(G,q.resultId,K):await this._provider.provideDocumentSemanticTokens(G,K);return q&&this._previousResults.delete(V),Z?(Z=Y._fixProvidedSemanticTokens(Z),this._send(Y._convertToEdits(q,Z),Z)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return Y._isSemanticTokens(O)?Y._isCorrectSemanticTokens(O)?O:new F.SemanticTokens(new Uint32Array(O.data),O.resultId):Y._isSemanticTokensEdits(O)?Y._isCorrectSemanticTokensEdits(O)?O:new F.SemanticTokensEdits(O.edits.map(V=>new F.SemanticTokensEdit(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const V of O.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,V){if(!Y._isSemanticTokens(V)||!O||!O.tokens)return V;const K=O.tokens,G=K.length,q=V.data,Z=q.length;let ae=0;const Me=Math.min(G,Z);for(;ae<Me&&K[ae]===q[ae];)ae++;if(ae===G&&ae===Z)return new F.SemanticTokensEdits([],V.resultId);let Ue=0;const Ge=Me-ae;for(;Ue<Ge&&K[G-Ue-1]===q[Z-Ue-1];)Ue++;return new F.SemanticTokensEdits([{start:ae,deleteCount:G-ae-Ue,data:q.subarray(ae,Z-Ue)}],V.resultId)}_send(O,V){if(Y._isSemanticTokens(O)){const K=this._nextResultId++;return this._previousResults.set(K,new Pe(O.resultId,O.data)),(0,t.encodeSemanticTokensDto)({id:K,type:"full",data:O.data})}if(Y._isSemanticTokensEdits(O)){const K=this._nextResultId++;return Y._isSemanticTokens(V)?this._previousResults.set(K,new Pe(V.resultId,V.data)):this._previousResults.set(K,new Pe(O.resultId)),(0,t.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(O.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ue{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeSemanticTokens(O,V,K){const G=this._documents.getDocument(O),q=await this._provider.provideDocumentRangeSemanticTokens(G,k.Range.to(V),K);return q?this._send(q):null}_send(O){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class _e{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,V,K,G,q){this._documents=O,this._commands=V,this._provider=K,this._apiDeprecation=G,this._extension=q,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ae=q.getWordRangeAtPosition(Z)||new F.Range(Z,Z),Me=ae.with({end:Z}),Ue=new E.StopWatch,Ge=await this._provider.provideCompletionItems(q,Z,G,k.CompletionContext.to(K));if(!Ge||G.isCancellationRequested)return;const je=Array.isArray(Ge)?new F.CompletionList(Ge):Ge,Je=_e.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Ye=new f.DisposableStore;this._disposables.set(Je,Ye);const et=[],it={x:Je,b:et,a:{replace:k.Range.from(ae),insert:k.Range.from(Me)},c:je.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<je.items.length;tt++){const xe=je.items[tt],st=this._convertCompletionItem(xe,[Je,tt],Me,ae);et.push(st)}return it}async resolveCompletionItem(O,V){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...O);if(!K)return;const G=this._convertCompletionItem(K,O),q=await this._provider.resolveCompletionItem(K,V);if(!q)return;const Z=this._convertCompletionItem(q,O);return(G.h!==Z.h||G.i!==Z.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==Z.n||G.o!==Z.o||!(0,R.equals)(G.p,Z.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:Z.d,c:Z.c,l:Z.l,h:Z.h,i:Z.i,n:Z.n,o:Z.o,p:Z.p}}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,V,K,G){const q=this._disposables.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const Z=this._commands.toInternal(O.command,q),ae={x:V,a:O.label,b:O.kind!==void 0?k.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(k.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:k.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(k.TextEdit.from),n:Z?.$ident,o:Z?.id,p:Z?.$ident?void 0:Z?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=O.textEdit.newText):typeof O.insertText=="string"?ae.h=O.insertText:O.insertText instanceof F.SnippetString&&(ae.h=O.insertText.value,ae.i|=4);let Me;return O.textEdit?Me=O.textEdit.range:O.range&&(Me=O.range),F.Range.isRange(Me)?ae.j=k.Range.from(Me):Me&&(!K?.isEqual(Me.inserting)||!G?.isEqual(Me.replacing))&&(ae.j={insert:k.Range.from(Me.inserting),replace:k.Range.from(Me.replacing)}),ae}}class ce{async provideInlineCompletions(O,V,K,G){}disposeCompletions(O){}handleDidShowCompletionItem(O,V,K){}handlePartialAccept(O,V,K){}}class pe extends ce{constructor(O,V,K,G){super(),this._extension=O,this._documents=V,this._provider=K,this._commands=G,this._references=new ie,this._isAdditionsProposedApiEnabled=(0,r.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ae=await this._provider.provideInlineCompletionItems(q,Z,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:k.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},G);if(!ae||G.isCancellationRequested)return;const Me=Array.isArray(ae)?ae:ae.items,Ue=this._isAdditionsProposedApiEnabled?Array.isArray(ae)?[]:ae.commands||[]:[],Ge=this._isAdditionsProposedApiEnabled&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let je;return{pid:this._references.createReferenceId({dispose(){je?.dispose()},items:Me}),items:Me.map((Ye,et)=>{let it;Ye.command&&(je||(je=new f.DisposableStore),it=this._commands.toInternal(Ye.command,je));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?k.Range.from(Ye.range):void 0,command:it,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(je||(je=new f.DisposableStore),this._commands.toInternal(Ye,je))),suppressSuggestions:!1,enableForwardStability:Ge}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,V,K){const G=this._references.get(O)?.items[V];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G,K)}handlePartialAccept(O,V,K){const G=this._references.get(O)?.items[V];G&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(G,K)}}class ie{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const V=this._idPool++;return this._references.set(V,O),V}disposeReferenceId(O){const V=this._references.get(O);return this._references.delete(O),V}get(O){return this._references.get(O)}}class x{constructor(O,V){this._documents=O,this._provider=V,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(O,V,K,G){const q=this._documents.getDocument(O),Z=k.Position.to(V),ae=this.reviveContext(K),Me=await this._provider.provideSignatureHelp(q,Z,G,ae);if(Me){const Ue=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:Ue}}}reviveContext(O){let V;if(O.activeSignatureHelp){const K=k.SignatureHelp.to(O.activeSignatureHelp),G=this._cache.get(O.activeSignatureHelp.id,0);G?(V=G,V.activeSignature=K.activeSignature,V.activeParameter=K.activeParameter):V=K}return{...O,activeSignatureHelp:V}}releaseSignatureHelp(O){this._cache.delete(O)}}class W{constructor(O,V,K,G,q){this._documents=O,this._commands=V,this._provider=K,this._logService=G,this._extension=q,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,V,K){const G=this._documents.getDocument(O),q=k.Range.to(V),Z=await this._provider.provideInlayHints(G,q,K);if(!Array.isArray(Z)||Z.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${V}`);return}if(K.isCancellationRequested)return;const ae=this._cache.add(Z);this._disposables.set(ae,new f.DisposableStore);const Me={hints:[],cacheId:ae};for(let Ue=0;Ue<Z.length;Ue++)this._isValidInlayHint(Z[Ue],q)&&Me.hints.push(this._convertInlayHint(Z[Ue],[ae,Ue]));return this._logService.trace(`[InlayHints] ${Me.hints.length} inlay hints from '${this._extension.identifier.value}' for ${V}`),Me}async resolveInlayHint(O,V){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...O);if(!K)return;const G=await this._provider.resolveInlayHint(K,V);if(G&&this._isValidInlayHint(G))return this._convertInlayHint(G,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,V){return O.label.length===0||Array.isArray(O.label)&&O.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(V&&!V.contains(O.position))}_convertInlayHint(O,V){const K=this._disposables.get(V[0]);if(!K)throw Error("DisposableStore is missing...");const G={label:"",cacheId:V,tooltip:k.MarkdownString.fromStrict(O.tooltip),position:k.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(k.TextEdit.from),kind:O.kind&&k.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?G.label=O.label:G.label=O.label.map(q=>{const Z={label:q.value};return Z.tooltip=k.MarkdownString.fromStrict(q.tooltip),F.Location.isLocation(q.location)&&(Z.location=k.location.from(q.location)),q.command&&(Z.command=this._commands.toInternal(q.command,K)),Z}),G}}class le{constructor(O,V){this._documents=O,this._provider=V,this._cache=new l.Cache("DocumentLink")}async provideLinks(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideDocumentLinks(K,V);if(!(!Array.isArray(G)||G.length===0)&&!V.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:G.filter(le._validateLink).map(k.DocumentLink.from)};{const q=this._cache.add(G),Z={links:[],cacheId:q};for(let ae=0;ae<G.length;ae++){if(!le._validateLink(G[ae]))continue;const Me=k.DocumentLink.from(G[ae]);Me.cacheId=[q,ae],Z.links.push(Me)}return Z}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,V){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...O);if(!K)return;const G=await this._provider.resolveDocumentLink(K,V);if(!(!G||!le._validateLink(G)))return k.DocumentLink.from(G)}releaseLinks(O){this._cache.delete(O)}}class we{constructor(O,V){this._documents=O,this._provider=V}async provideColors(O,V){const K=this._documents.getDocument(O),G=await this._provider.provideDocumentColors(K,V);return Array.isArray(G)?G.map(Z=>({color:k.Color.from(Z.color),range:k.Range.from(Z.range)})):[]}async provideColorPresentations(O,V,K){const G=this._documents.getDocument(O),q=k.Range.to(V.range),Z=k.Color.to(V.color),ae=await this._provider.provideColorPresentations(Z,{document:G,range:q},K);if(Array.isArray(ae))return ae.map(k.ColorPresentation.from)}}class Ee{constructor(O,V){this._documents=O,this._provider=V}async provideFoldingRanges(O,V,K){const G=this._documents.getDocument(O),q=await this._provider.provideFoldingRanges(G,V,K);if(Array.isArray(q))return q.map(k.FoldingRange.from)}}class me{constructor(O,V,K){this._documents=O,this._provider=V,this._logService=K}async provideSelectionRanges(O,V,K){const G=this._documents.getDocument(O),q=V.map(k.Position.to),Z=await this._provider.provideSelectionRanges(G,q,K);if(!(0,P.isNonEmptyArray)(Z))return[];if(Z.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Me=0;Me<q.length;Me++){const Ue=[];ae.push(Ue);let Ge=q[Me],je=Z[Me];for(;;){if(!je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(k.SelectionRange.from(je)),!je.parent)break;Ge=je.range,je=je.parent}}return ae}}class De{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.prepareCallHierarchy(G,q,K);if(!Z)return;const ae=this._idPool.nextId();return this._cache.set(ae,new Map),Array.isArray(Z)?Z.map(Me=>this._cacheAndConvertItem(ae,Me)):[this._cacheAndConvertItem(ae,Z)]}async provideCallsTo(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(G,K);if(q)return q.map(Z=>({from:this._cacheAndConvertItem(O,Z.from),fromRanges:Z.fromRanges.map(ae=>k.Range.from(ae))}))}async provideCallsFrom(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(G,K);if(q)return q.map(Z=>({to:this._cacheAndConvertItem(O,Z.to),fromRanges:Z.fromRanges.map(ae=>k.Range.from(ae))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const K=this._cache.get(O),G=k.CallHierarchyItem.from(V,O,K.size.toString(36));return K.set(G._itemId,V),G}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class re{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,K){const G=this._documents.getDocument(O),q=k.Position.to(V),Z=await this._provider.prepareTypeHierarchy(G,q,K);if(!Z)return;const ae=this._idPool.nextId();return this._cache.set(ae,new Map),Array.isArray(Z)?Z.map(Me=>this._cacheAndConvertItem(ae,Me)):[this._cacheAndConvertItem(ae,Z)]}async provideSupertypes(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(G,K);if(q)return q.map(Z=>this._cacheAndConvertItem(O,Z))}async provideSubtypes(O,V,K){const G=this._itemFromCache(O,V);if(!G)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(G,K);if(q)return q.map(Z=>this._cacheAndConvertItem(O,Z))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const K=this._cache.get(O),G=k.TypeHierarchyItem.from(V,O,K.size.toString(36));return K.set(G._itemId,V),G}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class de{static toInternalProviderId(O,V){return O+"."+V}constructor(O,V,K,G,q){this._proxy=O,this._documents=V,this._provider=K,this._handle=G,this._extension=q}async provideDocumentOnDropEdits(O,V,K,G,q){const Z=this._documents.getDocument(V),ae=k.Position.to(K),Me=k.DataTransfer.toDataTransfer(G,async Ge=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,Ge)).buffer),Ue=await this._provider.provideDocumentDropEdits(Z,ae,Me,q);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:Ue.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:de.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?k.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(O,V){this._documents=O,this._provider=V}async provideMappedEdits(O,V,K,G){const q=w.URI.revive(O),Z=this._documents.getDocument(q),ae=K.documents.map(Ge=>Ge.map(je=>({uri:w.URI.revive(je.uri),version:je.version,ranges:je.ranges.map(Je=>k.Range.to(Je))}))),Me={documents:ae,selections:ae[0]?.[0]?.ranges??[]},Ue=await this._provider.provideMappedEdits(Z,V,Me,G);return Ue?k.WorkspaceEdit.from(Ue):null}}class oe{constructor(O,V){this.adapter=O,this.extension=V}}class fe{static{this._handlePool=0}constructor(O,V,K,G,q,Z,ae,Me){this._uriTransformer=V,this._documents=K,this._commands=G,this._diagnostics=q,this._logService=Z,this._apiDeprecation=ae,this._extensionTelemetry=Me,this._adapter=new Map,this._proxy=O.getProxy(d.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O,V){return k.DocumentSelector.from(O,this._uriTransformer,V)}_createDisposable(O){return new F.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return fe._handlePool++}async _withAdapter(O,V,K,G,q,Z=!1){const ae=this._adapter.get(O);if(!ae||!(ae.adapter instanceof V))return G;const Me=Date.now();Z||this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ue=K(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Ge=>{(0,D.isCancellationError)(Ge)||(this._logService.error(`[${ae.extension.identifier.value}] provider FAILED`),this._logService.error(Ge),this._extensionTelemetry.onExtensionError(ae.extension.identifier,Ge))}).finally(()=>{Z||this._logService.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Me}ms`)}),v.CancellationToken.isCancellationToken(q)?(0,p.raceCancellationError)(Ue,q):Ue}_addNewAdapter(O,V){const K=this._nextHandle();return this._adapter.set(K,new oe(O,V)),K}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,V,K,G){const q=this._addNewAdapter(new i(this._documents,K),O),Z=G&&G.label||fe._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(V,O),Z),this._createDisposable(q)}$provideDocumentSymbols(O,V,K){return this._withAdapter(O,i,G=>G.provideDocumentSymbols(w.URI.revive(V),K),void 0,K)}registerCodeLensProvider(O,V,K){const G=this._nextHandle(),q=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(G,new oe(new o(this._documents,this._commands.converter,K),O)),this._proxy.$registerCodeLensSupport(G,this._transformDocumentSelector(V,O),q);let Z=this._createDisposable(G);if(q!==void 0){const ae=K.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(q));Z=F.Disposable.from(Z,ae)}return Z}$provideCodeLenses(O,V,K){return this._withAdapter(O,o,G=>G.provideCodeLenses(w.URI.revive(V),K),void 0,K)}$resolveCodeLens(O,V,K){return this._withAdapter(O,o,G=>G.resolveCodeLens(V,K),void 0,void 0)}$releaseCodeLenses(O,V){this._withAdapter(O,o,K=>Promise.resolve(K.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(O,V,K){const G=this._addNewAdapter(new b(this._documents,K),O);return this._proxy.$registerDefinitionSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDefinition(O,V,K,G){return this._withAdapter(O,b,q=>q.provideDefinition(w.URI.revive(V),K,G),[],G)}registerDeclarationProvider(O,V,K){const G=this._addNewAdapter(new C(this._documents,K),O);return this._proxy.$registerDeclarationSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDeclaration(O,V,K,G){return this._withAdapter(O,C,q=>q.provideDeclaration(w.URI.revive(V),K,G),[],G)}registerImplementationProvider(O,V,K){const G=this._addNewAdapter(new I(this._documents,K),O);return this._proxy.$registerImplementationSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideImplementation(O,V,K,G){return this._withAdapter(O,I,q=>q.provideImplementation(w.URI.revive(V),K,G),[],G)}registerTypeDefinitionProvider(O,V,K){const G=this._addNewAdapter(new c(this._documents,K),O);return this._proxy.$registerTypeDefinitionSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideTypeDefinition(O,V,K,G){return this._withAdapter(O,c,q=>q.provideTypeDefinition(w.URI.revive(V),K,G),[],G)}registerHoverProvider(O,V,K,G){const q=this._addNewAdapter(new h(this._documents,K),O);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(V,O)),this._createDisposable(q)}$provideHover(O,V,K,G){return this._withAdapter(O,h,q=>q.provideHover(w.URI.revive(V),K,G),void 0,G)}registerEvaluatableExpressionProvider(O,V,K,G){const q=this._addNewAdapter(new u(this._documents,K),O);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(V,O)),this._createDisposable(q)}$provideEvaluatableExpression(O,V,K,G){return this._withAdapter(O,u,q=>q.provideEvaluatableExpression(w.URI.revive(V),K,G),void 0,G)}registerInlineValuesProvider(O,V,K,G){const q=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new A(this._documents,K),O);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(V,O),q);let ae=this._createDisposable(Z);if(q!==void 0){const Me=K.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(q));ae=F.Disposable.from(ae,Me)}return ae}$provideInlineValues(O,V,K,G,q){return this._withAdapter(O,A,Z=>Z.provideInlineValues(w.URI.revive(V),K,G,q),void 0,q)}registerDocumentHighlightProvider(O,V,K){const G=this._addNewAdapter(new B(this._documents,K),O);return this._proxy.$registerDocumentHighlightProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDocumentHighlights(O,V,K,G){return this._withAdapter(O,B,q=>q.provideDocumentHighlights(w.URI.revive(V),K,G),void 0,G)}registerLinkedEditingRangeProvider(O,V,K){const G=this._addNewAdapter(new H(this._documents,K),O);return this._proxy.$registerLinkedEditingRangeProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideLinkedEditingRanges(O,V,K,G){return this._withAdapter(O,H,async q=>{const Z=await q.provideLinkedEditingRanges(w.URI.revive(V),K,G);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?fe._serializeRegExp(Z.wordPattern):void 0}},void 0,G)}registerReferenceProvider(O,V,K){const G=this._addNewAdapter(new U(this._documents,K),O);return this._proxy.$registerReferenceSupport(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideReferences(O,V,K,G,q){return this._withAdapter(O,U,Z=>Z.provideReferences(w.URI.revive(V),K,G,q),void 0,q)}registerCodeActionProvider(O,V,K,G){const q=new f.DisposableStore,Z=this._addNewAdapter(new z(this._documents,this._commands.converter,this._diagnostics,K,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(V,O),{providedKinds:G?.providedCodeActionKinds?.map(ae=>ae.value),documentation:G?.documentation?.map(ae=>({kind:ae.kind.value,command:this._commands.converter.toInternal(ae.command,q)}))},fe._extLabel(O),!!K.resolveCodeAction),q.add(this._createDisposable(Z)),q}$provideCodeActions(O,V,K,G,q){return this._withAdapter(O,z,Z=>Z.provideCodeActions(w.URI.revive(V),K,G,q),void 0,q)}$resolveCodeAction(O,V,K){return this._withAdapter(O,z,G=>G.resolveCodeAction(V,K),{},void 0)}$releaseCodeActions(O,V){this._withAdapter(O,z,K=>Promise.resolve(K.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(O,V,K){const G=this._addNewAdapter(new N(this._documents,K),O);return this._proxy.$registerDocumentFormattingSupport(G,this._transformDocumentSelector(V,O),O.identifier,O.displayName||O.name),this._createDisposable(G)}$provideDocumentFormattingEdits(O,V,K,G){return this._withAdapter(O,N,q=>q.provideDocumentFormattingEdits(w.URI.revive(V),K,G),void 0,G)}registerDocumentRangeFormattingEditProvider(O,V,K){const G=typeof K.provideDocumentRangesFormattingEdits=="function",q=this._addNewAdapter(new ee(this._documents,K),O);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(V,O),O.identifier,O.displayName||O.name,G),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(O,V,K,G,q){return this._withAdapter(O,ee,Z=>Z.provideDocumentRangeFormattingEdits(w.URI.revive(V),K,G,q),void 0,q)}$provideDocumentRangesFormattingEdits(O,V,K,G,q){return this._withAdapter(O,ee,Z=>Z.provideDocumentRangesFormattingEdits(w.URI.revive(V),K,G,q),void 0,q)}registerOnTypeFormattingEditProvider(O,V,K,G){const q=this._addNewAdapter(new Q(this._documents,K),O);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(V,O),G,O.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(O,V,K,G,q,Z){return this._withAdapter(O,Q,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(V),K,G,q,Z),void 0,Z)}registerWorkspaceSymbolProvider(O,V){const K=this._addNewAdapter(new Se(V,this._logService),O);return this._proxy.$registerNavigateTypeSupport(K,typeof V.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(O,V,K){return this._withAdapter(O,Se,G=>G.provideWorkspaceSymbols(V,K),{symbols:[]},K)}$resolveWorkspaceSymbol(O,V,K){return this._withAdapter(O,Se,G=>G.resolveWorkspaceSymbol(V,K),void 0,void 0)}$releaseWorkspaceSymbols(O,V){this._withAdapter(O,Se,K=>K.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(O,V,K){const G=this._addNewAdapter(new ye(this._documents,K,this._logService),O);return this._proxy.$registerRenameSupport(G,this._transformDocumentSelector(V,O),ye.supportsResolving(K)),this._createDisposable(G)}$provideRenameEdits(O,V,K,G,q){return this._withAdapter(O,ye,Z=>Z.provideRenameEdits(w.URI.revive(V),K,G,q),void 0,q)}$resolveRenameLocation(O,V,K,G){return this._withAdapter(O,ye,q=>q.resolveRenameLocation(w.URI.revive(V),K,G),void 0,G)}registerDocumentSemanticTokensProvider(O,V,K,G){const q=this._addNewAdapter(new Y(this._documents,K),O),Z=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(V,O),G,Z);let ae=this._createDisposable(q);if(Z){const Me=K.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(Z));ae=F.Disposable.from(ae,Me)}return ae}$provideDocumentSemanticTokens(O,V,K,G){return this._withAdapter(O,Y,q=>q.provideDocumentSemanticTokens(w.URI.revive(V),K,G),null,G)}$releaseDocumentSemanticTokens(O,V){this._withAdapter(O,Y,K=>K.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,V,K,G){const q=this._addNewAdapter(new ue(this._documents,K),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(V,O),G),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(O,V,K,G){return this._withAdapter(O,ue,q=>q.provideDocumentRangeSemanticTokens(w.URI.revive(V),K,G),null,G)}registerCompletionItemProvider(O,V,K,G){const q=this._addNewAdapter(new _e(this._documents,this._commands.converter,K,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(q,this._transformDocumentSelector(V,O),G,_e.supportsResolving(K),O.identifier),this._createDisposable(q)}$provideCompletionItems(O,V,K,G,q){return this._withAdapter(O,_e,Z=>Z.provideCompletionItems(w.URI.revive(V),K,G,q),void 0,q)}$resolveCompletionItem(O,V,K){return this._withAdapter(O,_e,G=>G.resolveCompletionItem(V,K),void 0,K)}$releaseCompletionItems(O,V){this._withAdapter(O,_e,K=>K.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(O,V,K,G){const q=new pe(O,this._documents,K,this._commands.converter),Z=this._addNewAdapter(q,O);return this._proxy.$registerInlineCompletionsSupport(Z,this._transformDocumentSelector(V,O),q.supportsHandleEvents,g.ExtensionIdentifier.toKey(O.identifier.value),G?.yieldTo?.map(ae=>g.ExtensionIdentifier.toKey(ae))||[]),this._createDisposable(Z)}$provideInlineCompletions(O,V,K,G,q){return this._withAdapter(O,ce,Z=>Z.provideInlineCompletions(w.URI.revive(V),K,G,q),void 0,q)}$handleInlineCompletionDidShow(O,V,K,G){this._withAdapter(O,ce,async q=>{q.handleDidShowCompletionItem(V,K,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,V,K,G){this._withAdapter(O,ce,async q=>{q.handlePartialAccept(V,K,G)},void 0,void 0)}$freeInlineCompletionsList(O,V){this._withAdapter(O,ce,async K=>{K.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(O,V,K,G){const q=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,Z=this._addNewAdapter(new x(this._documents,K),O);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(V,O),q),this._createDisposable(Z)}$provideSignatureHelp(O,V,K,G,q){return this._withAdapter(O,x,Z=>Z.provideSignatureHelp(w.URI.revive(V),K,G,q),void 0,q)}$releaseSignatureHelp(O,V){this._withAdapter(O,x,K=>K.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(O,V,K){const G=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new W(this._documents,this._commands.converter,K,this._logService,O),O);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(V,O),typeof K.resolveInlayHint=="function",G,fe._extLabel(O));let Z=this._createDisposable(q);if(G!==void 0){const ae=K.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(G));Z=F.Disposable.from(Z,ae)}return Z}$provideInlayHints(O,V,K,G){return this._withAdapter(O,W,q=>q.provideInlayHints(w.URI.revive(V),K,G),void 0,G)}$resolveInlayHint(O,V,K){return this._withAdapter(O,W,G=>G.resolveInlayHint(V,K),void 0,K)}$releaseInlayHints(O,V){this._withAdapter(O,W,K=>K.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(O,V,K){const G=this._addNewAdapter(new le(this._documents,K),O);return this._proxy.$registerDocumentLinkProvider(G,this._transformDocumentSelector(V,O),typeof K.resolveDocumentLink=="function"),this._createDisposable(G)}$provideDocumentLinks(O,V,K){return this._withAdapter(O,le,G=>G.provideLinks(w.URI.revive(V),K),void 0,K,V.scheme==="output")}$resolveDocumentLink(O,V,K){return this._withAdapter(O,le,G=>G.resolveLink(V,K),void 0,void 0,!0)}$releaseDocumentLinks(O,V){this._withAdapter(O,le,K=>K.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(O,V,K){const G=this._addNewAdapter(new we(this._documents,K),O);return this._proxy.$registerDocumentColorProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideDocumentColors(O,V,K){return this._withAdapter(O,we,G=>G.provideColors(w.URI.revive(V),K),[],K)}$provideColorPresentations(O,V,K,G){return this._withAdapter(O,we,q=>q.provideColorPresentations(w.URI.revive(V),K,G),void 0,G)}registerFoldingRangeProvider(O,V,K){const G=this._nextHandle(),q=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(G,new oe(new Ee(this._documents,K),O)),this._proxy.$registerFoldingRangeProvider(G,this._transformDocumentSelector(V,O),O.identifier,q);let Z=this._createDisposable(G);if(q!==void 0){const ae=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));Z=F.Disposable.from(Z,ae)}return Z}$provideFoldingRanges(O,V,K,G){return this._withAdapter(O,Ee,q=>q.provideFoldingRanges(w.URI.revive(V),K,G),void 0,G)}registerSelectionRangeProvider(O,V,K){const G=this._addNewAdapter(new me(this._documents,K,this._logService),O);return this._proxy.$registerSelectionRangeProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideSelectionRanges(O,V,K,G){return this._withAdapter(O,me,q=>q.provideSelectionRanges(w.URI.revive(V),K,G),[],G)}registerCallHierarchyProvider(O,V,K){const G=this._addNewAdapter(new De(this._documents,K),O);return this._proxy.$registerCallHierarchyProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$prepareCallHierarchy(O,V,K,G){return this._withAdapter(O,De,q=>Promise.resolve(q.prepareSession(w.URI.revive(V),K,G)),void 0,G)}$provideCallHierarchyIncomingCalls(O,V,K,G){return this._withAdapter(O,De,q=>q.provideCallsTo(V,K,G),void 0,G)}$provideCallHierarchyOutgoingCalls(O,V,K,G){return this._withAdapter(O,De,q=>q.provideCallsFrom(V,K,G),void 0,G)}$releaseCallHierarchy(O,V){this._withAdapter(O,De,K=>Promise.resolve(K.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(O,V,K){const G=this._addNewAdapter(new re(this._documents,K),O);return this._proxy.$registerTypeHierarchyProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$prepareTypeHierarchy(O,V,K,G){return this._withAdapter(O,re,q=>Promise.resolve(q.prepareSession(w.URI.revive(V),K,G)),void 0,G)}$provideTypeHierarchySupertypes(O,V,K,G){return this._withAdapter(O,re,q=>q.provideSupertypes(V,K,G),void 0,G)}$provideTypeHierarchySubtypes(O,V,K,G){return this._withAdapter(O,re,q=>q.provideSubtypes(V,K,G),void 0,G)}$releaseTypeHierarchy(O,V){this._withAdapter(O,re,K=>Promise.resolve(K.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(O,V,K,G){const q=this._nextHandle();this._adapter.set(q,new oe(new de(this._proxy,this._documents,K,q,O),O));const Z=(0,r.isProposedApiEnabled)(O,"dropMetadata")&&G?de.toInternalProviderId(O.identifier.value,G.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(V,O),Z,(0,r.isProposedApiEnabled)(O,"dropMetadata")?G:void 0),this._createDisposable(q)}$provideDocumentOnDropEdits(O,V,K,G,q,Z){return this._withAdapter(O,de,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(V,w.URI.revive(K),G,q,Z)),void 0,void 0)}registerMappedEditsProvider(O,V,K){const G=this._addNewAdapter(new se(this._documents,K),O);return this._proxy.$registerMappedEditsProvider(G,this._transformDocumentSelector(V,O)),this._createDisposable(G)}$provideMappedEdits(O,V,K,G,q){return this._withAdapter(O,se,Z=>Promise.resolve(Z.provideMappedEdits(V,K,G,q)),null,q)}registerDocumentPasteEditProvider(O,V,K,G){const q=this._nextHandle();this._adapter.set(q,new oe(new M(this._proxy,this._documents,K,q,O),O));const Z=M.toInternalProviderId(O.identifier.value,G.id);return this._proxy.$registerPasteEditProvider(q,this._transformDocumentSelector(V,O),Z,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this._createDisposable(q)}$prepareDocumentPaste(O,V,K,G,q){return this._withAdapter(O,M,Z=>Z.prepareDocumentPaste(w.URI.revive(V),K,G,q),void 0,q)}$providePasteEdits(O,V,K,G,q,Z){return this._withAdapter(O,M,ae=>ae.providePasteEdits(V,w.URI.revive(K),G,q,Z),void 0,Z)}static _serializeRegExp(O){return{pattern:O.source,flags:O.flags}}static _serializeIndentationRule(O){return{decreaseIndentPattern:fe._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:fe._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?fe._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?fe._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:fe._serializeRegExp(O.beforeText),afterText:O.afterText?fe._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?fe._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(fe._serializeOnEnterRule)}static _serializeAutoClosingPair(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(V=>F.SyntaxTokenType.toString(V)):void 0}}static _serializeAutoClosingPairs(O){return O.map(fe._serializeAutoClosingPair)}setLanguageConfiguration(O,V,K){const{wordPattern:G}=K;if(G&&(0,y.regExpLeadsToEndlessLoop)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this._documents.setWordDefinitionFor(V,G):this._documents.setWordDefinitionFor(V,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this._nextHandle(),Z={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?fe._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?fe._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?fe._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?fe._serializeAutoClosingPairs(K.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(q,V,Z),this._createDisposable(q)}$setWordDefinitions(O){for(const V of O)this._documents.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.ExtHostLanguageFeatures=fe}),define(Te[241],Ae([1,0,3,8,7,29,12,6]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(P,_,a,v){this._documents=_,this._commands=a,this._uriTransformer=v,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(w.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,_){await this._proxy.$changeLanguage(P,_);const a=this._documents.getDocumentData(P);if(!a)throw new Error(`document '${P.toString()}' NOT found`);return a.document}async tokenAtPosition(P,_){const a=P.version,v=R.Position.from(_),g=await this._proxy.$tokensAtPosition(P.uri,v),f={type:k.StandardTokenType.Other,range:P.getWordRangeAtPosition(_)??new k.Range(_.line,_.character,_.line,_.character)};if(!g)return f;const t={range:R.Range.to(g.range),type:R.TokenType.to(g.type)};return!t.range.contains(_)||a!==P.version?f:t}createLanguageStatusItem(P,_,a){const v=this._handlePool++,g=this._proxy,f=this._ids,t=`${P.identifier.value}/${_}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);f.add(t);const n={selector:a,id:_,name:P.displayName??P.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let l;const E=new d.DisposableStore,D=()=>{if(l?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${_}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}l=(0,T.disposableTimeout)(()=>{E.clear(),this._proxy.$setLanguageStatus(v,{id:t,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(n.selector,this._uriTransformer),label:n.text,detail:n.detail??"",severity:n.severity===k.LanguageStatusSeverity.Error?F.default.Error:n.severity===k.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this._commands.toInternal(n.command,E),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},p={dispose(){E.dispose(),l?.dispose(),g.$removeLanguageStatus(v),f.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,D()},get selector(){return n.selector},set selector(r){n.selector=r,D()},get text(){return n.text},set text(r){n.text=r,D()},get detail(){return n.detail},set detail(r){n.detail=r,D()},get severity(){return n.severity},set severity(r){n.severity=r,D()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,D()},get command(){return n.command},set command(r){n.command=r,D()},get busy(){return n.busy},set busy(r){n.busy=r,D()}};return D(),p}}e.ExtHostLanguages=y}),define(Te[81],Ae([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let P=class{constructor(a,v,g){this.logService=g,this.bundleCache=new Map,this._proxy=v.getProxy(d.MainContext.MainThreadLocalization),this.currentLanguage=a.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===w.LANGUAGE_DEFAULT}getMessage(a,v){const{message:g,args:f,comment:t}=v;if(this.isDefaultLanguage)return(0,R.format2)(g,f??{});let n=g;t&&t.length>0&&(n+=`/${Array.isArray(t)?t.join(""):t}`);const l=this.bundleCache.get(a)?.contents[n];return l||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,R.format2)(l??g,f??{})}getBundle(a){return this.bundleCache.get(a)?.contents}getBundleUri(a){return this.bundleCache.get(a)?.uri}async initializeLocalizedMessages(a){if(this.isDefaultLanguage||!a.l10n&&!a.isBuiltin||this.bundleCache.has(a.identifier.value))return;let v;const g=await this.getBundleLocation(a);if(!g){this.logService.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this._proxy.$fetchBundleContents(g),t=JSON.parse(f);v=a.isBuiltin?t.contents?.bundle:t}catch(f){this.logService.error(`Failed to load translations for ${a.identifier.value} from ${g}: ${f.message}`);return}v&&this.bundleCache.set(a.identifier.value,{contents:v,uri:g})}async getBundleLocation(a){if(a.isBuiltin){const v=await this._proxy.$fetchBuiltInBundleUri(a.identifier.value,this.currentLanguage);return k.URI.revive(v)}return a.l10n?k.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=P,e.ExtHostLocalizationService=P=Ve([We(0,y.IExtHostInitDataService),We(1,m.IExtHostRpcService),We(2,T.ILogService)],P),e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(Te[242],Ae([1,0,14,3,27,17,2,69]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends w.AbstractLoggerService{constructor(_,a){super(a.logLevel,a.logsLocation,a.loggers.map(v=>(0,d.revive)(v))),this._proxy=_.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(_,a){a?this.setLogLevel(T.URI.revive(a),_):this.setLogLevel(_)}setVisibility(_,a){super.setVisibility(_,a),this._proxy.$setVisibility(_,a)}doCreateLogger(_,a,v){return new m(this._proxy,_,a,v)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=Ve([We(0,F.IExtHostRpcService),We(1,k.IExtHostInitDataService)],y);class m extends w.AbstractMessageLogger{constructor(_,a,v,g){super(g?.logLevel==="always"),this.proxy=_,this.file=a,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.proxy.$createLogger(a,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(_,a){const v=[[_,a]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(_){this.proxy.$log(this.file,_)}flush(){this.proxy.$flush(this.file)}}}),define(Te[82],Ae([1,0,3,4,6,17,25]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,R.createDecorator)("IExtHostManagedSockets");let d=class{constructor(_){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=_.getProxy(w.MainContext.MainThreadManagedSockets)}setFactory(_,a){for(const v of this._managedRemoteSockets.values())v.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(_,a),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(_){if(!this._factory||this._factory.socketFactoryId!==_)throw new Error(`No socket factory with id ${_}`);const a=++this._remoteSocketIdCounter,v=await this._factory.makeConnection(),g=new k.DisposableStore;return this._managedRemoteSockets.set(a,new m(a,v,g)),g.add((0,k.toDisposable)(()=>this._managedRemoteSockets.delete(a))),g.add(v.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(a),g.dispose()})),g.add(v.onDidClose(f=>{this._proxy.$onDidManagedSocketClose(a,f?.stack??f?.message),g.dispose()})),g.add(v.onDidReceiveMessage(f=>this._proxy.$onDidManagedSocketHaveData(a,T.VSBuffer.wrap(f)))),a}$remoteSocketWrite(_,a){this._managedRemoteSockets.get(_)?.actual.send(a.buffer)}$remoteSocketEnd(_){const a=this._managedRemoteSockets.get(_);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(_){await this._managedRemoteSockets.get(_)?.actual.drain?.()}};e.ExtHostManagedSockets=d,e.ExtHostManagedSockets=d=Ve([We(0,F.IExtHostRpcService)],d);class y{constructor(_,a){this.socketFactoryId=_,this.makeConnection=a}}class m extends k.Disposable{constructor(_,a,v){super(),this.socketId=_,this.actual=a,this._register(v)}}}),define(Te[243],Ae([1,0,3,14,26]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(d){return d&&d.title}let T=class{constructor(y,m){this._logService=m,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,m,P,_,a){const v={source:{identifier:y.identifier,label:y.displayName||y.name}};let g;typeof _=="string"||F(_)?g=[_,...a]:(v.modal=_?.modal,v.useCustom=_?.useCustom,v.detail=_?.detail,g=a),v.useCustom&&(0,k.checkProposedApiEnabled)(y,"resolvers");const f=[];for(let t=0;t<g.length;t++){const n=g[t];if(typeof n=="string")f.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:l,isCloseAffordance:E}=n;f.push({title:l,isCloseAffordance:!!E,handle:t})}else this._logService.warn("Invalid message item:",n)}return this._proxy.$showMessage(m,P,v,f).then(t=>{if(typeof t=="number")return g[t]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=Ve([We(1,R.ILogService)],T)}),define(Te[244],Ae([1,0,151,25,5,6,28,15,16,2,38,55,3,31,8,7,46,204,103,9,24,13]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class r{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(i=>i.apiEditor)}constructor(i,o,S,b,C){this._textDocumentsAndEditors=S,this._textDocuments=b,this._extHostFileSystem=C,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new k.Emitter({onListenerError:E.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter({onListenerError:E.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter({onListenerError:E.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter({onListenerError:E.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new _.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=i.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=i.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=i.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const c=I.notebookEditor?.notebookUri,h=I.cell.handle,A=this._documents.get(c)?.getCell(h);if(A)return A.apiCell}if(I&&I.$mid===14){const c=I.uri,h=this._documents.get(c);if(h)return h.apiNotebook}return I}}),r._registerApiCommands(o)}getEditorById(i){const o=this._editors.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(i){for(const[o,S]of this._editors)if(S.apiEditor===i)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(i,o){const S=this._documents.get(i);if(!S&&!o)throw new Error(`NO notebook document for '${i}'`);return S}static _convertNotebookRegistrationData(i,o){if(!o)return;const S=o.filenamePattern.map(b=>g.NotebookExclusiveDocumentPattern.from(b)).filter(b=>b!==void 0);if(o.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:i.identifier,providerDisplayName:i.displayName||i.name,displayName:o.displayName,filenamePattern:S,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(i,o,S){const b=r._notebookStatusBarItemProviderHandlePool++,C=typeof S.onDidChangeCellStatusBarItems=="function"?r._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(b,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(b,C,o);let I;return C!==void 0&&(I=S.onDidChangeCellStatusBarItems(c=>this._notebookProxy.$emitCellStatusBarEvent(C))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(b),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(b,C),I?.dispose()})}async createNotebookDocument(i){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:i.viewType,content:i.content&&g.NotebookData.from(i.content)});return m.URI.revive(o)}async openNotebookDocument(i){const o=this._documents.get(i);if(o)return o.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(i),b=this._documents.get(m.URI.revive(S));return(0,y.assertIsDefined)(b?.apiNotebook)}async showNotebookDocument(i,o){m.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let S;typeof o=="object"?S={position:g.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(g.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:S={preserveFocus:!1};const b=await this._notebookEditorsProxy.$tryShowNotebookDocument(i.uri,i.notebookType,S),C=b&&this._editors.get(b)?.apiEditor;if(C)return C;throw b?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(i,o,S,b){const C=this._notebookStatusBarItemProviders.get(i),I=m.URI.revive(o),c=this._documents.get(I);if(!c||!C)return;const h=c.getCellFromIndex(S);if(!h)return;const u=await C.provideCellStatusBarItems(h.apiCell,b);if(!u)return;const A=new F.DisposableStore,B=this._statusBarCache.add([A]),U=(Array.isArray(u)?u:[u]).map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,A));return{cacheId:B,items:U}}$releaseNotebookCellStatusBarItems(i){this._statusBarCache.delete(i)}registerNotebookSerializer(i,o,S,b,C){if((0,d.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const I=this._handlePool++;return this._notebookSerializer.set(I,{viewType:o,serializer:S,options:b}),this._notebookProxy.$registerNotebookSerializer(I,{id:i.identifier,location:i.extensionLocation},o,g.NotebookDocumentContentOptions.from(b),r._convertNotebookRegistrationData(i,C)),(0,F.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(I)})}async $dataToNotebook(i,o,S){const b=this._notebookSerializer.get(i);if(!b)throw new Error("NO serializer found");const C=await b.serializer.deserializeNotebook(o.buffer,S);return new t.SerializableObjectWithBuffers(g.NotebookData.from(C))}async $notebookToData(i,o,S){const b=this._notebookSerializer.get(i);if(!b)throw new Error("NO serializer found");const C=await b.serializer.serializeNotebook(g.NotebookData.to(o.value),S);return R.VSBuffer.wrap(C)}async $saveNotebook(i,o,S,b,C){const I=m.URI.revive(o),c=this._notebookSerializer.get(i);if(!c)throw new Error("NO serializer found");const h=this._documents.get(I);if(!h)throw new Error("Document NOT found");if(h.versionId!==S)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(I.scheme))throw new P.FileOperationError((0,w.localize)(0,null,this._resourceForError(I)),6);await this._validateWriteFile(I,b);const u={metadata:(0,D.filter)(h.apiNotebook.metadata,z=>!(c.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of h.apiNotebook.getCells()){const M=new f.NotebookCellData(z.kind,z.document.getText(),z.document.languageId,z.mime,c.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);M.metadata=(0,D.filter)(z.metadata,N=>!(c.options?.transientCellMetadata??{})[N]),u.cells.push(M)}const A=await c.serializer.serializeNotebook(u,C);await this._extHostFileSystem.value.writeFile(I,A);const B=this._extHostFileSystem.getFileSystemProviderExtUri(I.scheme),H=await this._extHostFileSystem.value.stat(I);return{name:B.basename(I),isFile:(H.type&P.FileType.File)!==0,isDirectory:(H.type&P.FileType.Directory)!==0,isSymbolicLink:(H.type&P.FileType.SymbolicLink)!==0,mtime:H.mtime,ctime:H.ctime,size:H.size,readonly:!!((H.permissions??0)&P.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(I.scheme),locked:!!((H.permissions??0)&P.FilePermission.Locked),etag:P.etag({mtime:H.mtime,size:H.size}),children:void 0}}async _validateWriteFile(i,o){const S=await this._extHostFileSystem.value.stat(i);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&o.mtime<S.mtime&&o.etag!==P.etag({mtime:o.mtime,size:S.size}))throw new P.FileOperationError((0,w.localize)(1,null),3,o)}_resourceForError(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString()}_createExtHostEditor(i,o,S){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const b=new l.ExtHostNotebookEditor(o,this._notebookEditorsProxy,i,S.visibleRanges.map(g.NotebookRange.to),S.selections.map(g.NotebookRange.to),typeof S.viewColumn=="number"?g.ViewColumn.to(S.viewColumn):void 0);this._editors.set(o,b)}$acceptDocumentAndEditorsDelta(i){if(i.value.removedDocuments)for(const S of i.value.removedDocuments){const b=m.URI.revive(S),C=this._documents.get(b);C&&(C.dispose(),this._documents.delete(b),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:C.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(C.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===b.toString()&&this._editors.delete(I.id)}if(i.value.addedDocuments){const S=[];for(const b of i.value.addedDocuments){const C=m.URI.revive(b.uri);if(this._documents.has(C))throw new Error(`adding EXISTING notebook ${C} `);const I=new n.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,C,b);S.push(...b.cells.map(c=>n.ExtHostCell.asModelAddData(I.apiNotebook,c))),this._documents.get(C)?.dispose(),this._documents.set(C,I),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(I.apiNotebook)}}if(i.value.addedEditors)for(const S of i.value.addedEditors){if(this._editors.has(S.id))return;const b=m.URI.revive(S.documentUri),C=this._documents.get(b);C&&this._createExtHostEditor(C,S.id,S)}const o=[];if(i.value.removedEditors)for(const S of i.value.removedEditors){const b=this._editors.get(S);b&&(this._editors.delete(S),this._activeNotebookEditor?.id===b.id&&(this._activeNotebookEditor=void 0),o.push(b))}if(i.value.visibleEditors){this._visibleNotebookEditors=i.value.visibleEditors.map(b=>this._editors.get(b)).filter(b=>!!b);const S=new Set;this._visibleNotebookEditors.forEach(b=>S.add(b.id));for(const b of this._editors.values()){const C=S.has(b.id);b._acceptVisibility(C)}this._visibleNotebookEditors=[...this._editors.values()].map(b=>b).filter(b=>b.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}i.value.newActiveEditor===null?this._activeNotebookEditor=void 0:i.value.newActiveEditor&&(this._editors.get(i.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${i.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(i.value.newActiveEditor)),i.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(i){const o=v.ApiCommandArgument.String.with("notebookType","A notebook type"),S=new v.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new v.ApiCommandArgument("data","Bytes to convert to data",C=>C instanceof Uint8Array,C=>R.VSBuffer.wrap(C))],new v.ApiCommandResult("Notebook Data",C=>g.NotebookData.to(C.value))),b=new v.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new v.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",C=>!0,C=>new t.SerializableObjectWithBuffers(g.NotebookData.from(C)))],new v.ApiCommandResult("Bytes",C=>C.buffer));i.registerApiCommand(S),i.registerApiCommand(b)}}e.ExtHostNotebookController=r}),define(Te[245],Ae([1,0,18,12,21,5,6,28,2,20,14,55,3,31,8,7,77,197,26,46]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(C,I,c,h,u){this._initData=I,this._extHostNotebook=c,this._commands=h,this._logService=u,this._activeExecutions=new d.ResourceMap,this._activeNotebookExecutions=new d.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new _.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=C.getProxy(a.MainContext.MainThreadNotebookKernels);const A=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const H=this._extHostNotebook.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:H}}else if(B&&"notebookEditor"in B){const H=this._extHostNotebook.getIdByEditor(B.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return B})],v.ApiCommandResult.Void);this._commands.registerApiCommand(A)}createNotebookController(C,I,c,h,u,A){for(const _e of this._kernelData.values())if(_e.controller.id===I&&m.ExtensionIdentifier.equals(C.identifier,_e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const B=this._handlePool++,H=this;this._logService.trace(`NotebookController[${B}], CREATED by ${C.identifier.value}, ${I}`);const U=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${C.identifier}'`);let z=!1;const M=new F.Emitter,N=new F.Emitter,ee={id:S(C.identifier,I),notebookType:c,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:h||C.identifier.value,preloads:A?A.map(g.NotebookRendererScript.from):[]};let Q=u??U,Se;this._proxy.$addKernel(B,ee).catch(_e=>{console.log(_e),z=!0});let ye=0;const Pe=()=>{if(z)return;const _e=++ye;Promise.resolve().then(()=>{_e===ye&&this._proxy.$updateKernel(B,ee)})},Y=new d.ResourceMap,ue={get id(){return I},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return ee.label},set label(_e){ee.label=_e??C.displayName??C.name,Pe()},get detail(){return ee.detail??""},set detail(_e){ee.detail=_e,Pe()},get description(){return ee.description??""},set description(_e){ee.description=_e,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(_e){ee.supportedLanguages=_e,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(_e){ee.supportsExecutionOrder=_e,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(_e){Q=_e??U},get interruptHandler(){return Se},set interruptHandler(_e){Se=_e,ee.supportsInterrupt=!!_e,Pe()},createNotebookCellExecution(_e){if(z)throw new Error("notebook controller is DISPOSED");if(!Y.has(_e.notebook.uri))throw H._logService.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${_e.notebook.uri.toString()}`);return H._createNotebookCellExecution(_e,S(C.identifier,this.id))},createNotebookExecution(_e){if((0,l.checkProposedApiEnabled)(C,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!Y.has(_e.uri))throw H._logService.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${_e.uri.toString()}`);return H._createNotebookExecution(_e,S(C.identifier,this.id))},dispose:()=>{z||(this._logService.trace(`NotebookController[${B}], DISPOSED`),z=!0,this._kernelData.delete(B),M.dispose(),N.dispose(),this._proxy.$removeKernel(B))},updateNotebookAffinity(_e,ce){ce===f.NotebookControllerAffinity2.Hidden&&(0,l.checkProposedApiEnabled)(C,"notebookControllerAffinityHidden"),H._proxy.$updateNotebookPriority(B,_e.uri,ce)},onDidReceiveMessage:N.event,postMessage(_e,ce){return(0,l.checkProposedApiEnabled)(C,"notebookMessaging"),H._proxy.$postMessage(B,ce&&H._extHostNotebook.getIdByEditor(ce),_e)},asWebviewUri(_e){return(0,l.checkProposedApiEnabled)(C,"notebookMessaging"),(0,t.asWebviewUri)(_e,H._initData.remote)}};return this._kernelData.set(B,{extensionId:C.identifier,controller:ue,onDidReceiveMessage:N,onDidChangeSelection:M,associatedNotebooks:Y}),ue}getIdByController(C){for(const[I,c]of this._kernelData)if(c.controller===C)return S(c.extensionId,C.id);return null}createNotebookControllerDetectionTask(C,I){const c=this._kernelDetectionTaskHandlePool++,h=this;this._logService.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${C.identifier.value}`),this._proxy.$addKernelDetectionTask(c,I);const u={dispose:()=>{this._kernelDetectionTask.delete(c),h._proxy.$removeKernelDetectionTask(c)}};return this._kernelDetectionTask.set(c,u),u}registerKernelSourceActionProvider(C,I,c){const h=this._kernelSourceActionProviderHandlePool++,u=typeof c.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,A=this;this._kernelSourceActionProviders.set(h,c),this._logService.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${C.identifier.value}`),this._proxy.$addKernelSourceActionProvider(h,h,I);let B;return u!==void 0&&(B=c.onDidChangeNotebookKernelSourceActions(H=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(u))),{dispose:()=>{this._kernelSourceActionProviders.delete(h),A._proxy.$removeKernelSourceActionProvider(h,h),B?.dispose()}}}async $provideKernelSourceActions(C,I){const c=this._kernelSourceActionProviders.get(C);if(c){const h=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([h]),(await c.provideNotebookKernelSourceActions(I)??[]).map(A=>g.NotebookKernelSourceAction.from(A,this._commands.converter,h))}return[]}$acceptNotebookAssociation(C,I,c){const h=this._kernelData.get(C);if(h){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(I));c?h.associatedNotebooks.set(u.uri,!0):h.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${C}] ASSOCIATE notebook`,u.uri.toString(),c),h.onDidChangeSelection.fire({selected:c,notebook:u.apiNotebook})}}async $executeCells(C,I,c){const h=this._kernelData.get(C);if(!h)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(I)),A=[];for(const B of c){const H=u.getCell(B);H&&A.push(H.apiCell)}try{this._logService.trace(`NotebookController[${C}] EXECUTE cells`,u.uri.toString(),A.length),await h.controller.executeHandler.call(h.controller,A,u.apiNotebook,h.controller)}catch(B){this._logService.error(`NotebookController[${C}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(C,I,c){const h=this._kernelData.get(C);if(!h)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(I));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,u.apiNotebook);else for(const A of c){const B=u.getCell(A);B&&this._activeExecutions.get(B.uri)?.cancel()}if(h.controller.interruptHandler){const A=this._activeNotebookExecutions.get(u.uri);c.length&&Array.isArray(A)&&A.length&&A.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(C,I,c){const h=this._kernelData.get(C);if(!h)return;const u=this._extHostNotebook.getEditorById(I);h.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:c}))}$cellExecutionChanged(C,I,c){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(C)).getCell(I);if(u){const A=c?g.NotebookCellExecutionState.to(c):f.NotebookCellExecutionState.Idle;A!==void 0&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:A})}}_createNotebookCellExecution(C,I){if(C.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this._extHostNotebook.getNotebookDocument(C.notebook.uri).getCellFromApiCell(C);if(!h)throw new Error("invalid cell");if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const u=new r(I,h,this._proxy);this._activeExecutions.set(h.uri,u);const A=u.onDidChangeState(()=>{u.state===p.Resolved&&(u.dispose(),A.dispose(),this._activeExecutions.delete(h.uri))});return u.asApiObject()}_createNotebookExecution(C,I){const c=this._extHostNotebook.getNotebookDocument(C.uri),h=C.getCells().find(B=>{const H=c.getCellFromApiCell(B);return H&&this._activeExecutions.has(H.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this._activeNotebookExecutions.has(c.uri))throw new Error(`duplicate notebook execution for ${c.uri}`);const u=new i(I,c,this._proxy),A=u.onDidChangeState(()=>{u.state===s.Resolved&&(u.dispose(),A.dispose(),this._activeNotebookExecutions.delete(c.uri))});return this._activeNotebookExecutions.set(c.uri,[u,A]),u.asApiObject()}};e.ExtHostNotebookKernels=D,e.ExtHostNotebookKernels=D=Ve([We(4,P.ILogService)],D);var p;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(p||(p={}));class r extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(C,I,c){super(),this._cell=I,this._proxy=c,this._handle=r.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new o(10,h=>this.update(h)),this._executionOrder=I.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,C,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(C){await this._collector.addItem(C)}async update(C){const I=Array.isArray(C)?C:[C];return this._proxy.$updateExecution(this._handle,new E.SerializableObjectWithBuffers(I))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(C){let I=this._cell;if(C&&(I=this._cell.notebook.getCellFromApiCell(C)),!I)throw new Error("INVALID cell");return I.handle}validateAndConvertOutputs(C){return C.map(I=>{const c=f.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return c===I.items?g.NotebookCellOutput.from(I):g.NotebookCellOutput.from({items:c,id:I.id,metadata:I.metadata})})}async updateOutputs(C,I,c){const h=this.cellIndexToHandle(I),u=this.validateAndConvertOutputs((0,w.asArray)(C));return this.updateSoon({editType:n.CellExecutionUpdateType.Output,cellHandle:h,append:c,outputs:u})}async updateOutputItems(C,I,c){return C=f.NotebookCellOutput.ensureUniqueMimeTypes((0,w.asArray)(C),!0),this.updateSoon({editType:n.CellExecutionUpdateType.OutputItems,items:C.map(g.NotebookCellOutputItem.from),outputId:I.id,append:c})}asApiObject(){const C=this;return Object.freeze({get token(){return C._tokenSource.token},get cell(){return C._cell.apiCell},get executionOrder(){return C._executionOrder},set executionOrder(c){C._executionOrder=c,C.update([{editType:n.CellExecutionUpdateType.ExecutionState,executionOrder:C._executionOrder}])},start(c){if(C._state===p.Resolved||C._state===p.Started)throw new Error("Cannot call start again");C._state=p.Started,C._onDidChangeState.fire(),C.update({editType:n.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,h){if(C._state===p.Resolved)throw new Error("Cannot call resolve twice");C._state=p.Resolved,C._onDidChangeState.fire(),C._collector.flush(),C._proxy.$completeExecution(C._handle,new E.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:c}))},clearOutput(c){return C.verifyStateForOutput(),C.updateOutputs([],c,!1)},appendOutput(c,h){return C.verifyStateForOutput(),C.updateOutputs(c,h,!0)},replaceOutput(c,h){return C.verifyStateForOutput(),C.updateOutputs(c,h,!1)},appendOutputItems(c,h){return C.verifyStateForOutput(),C.updateOutputItems(c,h,!0)},replaceOutputItems(c,h){return C.verifyStateForOutput(),C.updateOutputItems(c,h,!1)}})}}var s;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(s||(s={}));class i extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(C,I,c){super(),this._notebook=I,this._proxy=c,this._handle=i.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,C,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===s.Resolved||this._state===s.Started)throw new Error("Cannot call start again");this._state=s.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===s.Resolved)throw new Error("Cannot call resolve twice");this._state=s.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class o{constructor(C,I){this.delay=C,this.callback=I,this.batch=[],this.startedTimer=Date.now()}addItem(C){return this.batch.push(C),this.currentDeferred||(this.currentDeferred=new R.DeferredPromise,this.startedTimer=Date.now(),(0,R.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const C=this.currentDeferred;this.currentDeferred=void 0;const I=this.batch;return this.batch=[],this.callback(I).finally(()=>C.complete())}}function S(b,C){return`${b.value}/${C}`}e.createKernelId=S}),define(Te[246],Ae([1,0,5,3,103]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(d,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=d.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(d,y,m){const P=this._extHostNotebook.getEditorById(d);this._rendererMessageEmitters.get(y)?.fire({editor:P.apiEditor,message:m})}createRendererMessaging(d,y){if(!d.contributes?.notebookRenderer?.some(P=>P.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(P,_,a)=>this.getOrCreateEmitterFor(y).event(P,_,a),postMessage:(P,_)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(P)&&([P,_]=[_,P]);const a=_&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(_);return this.proxy.$postMessage(a?.id,y,P)}}}getOrCreateEmitterFor(d){let y=this._rendererMessageEmitters.get(d);return y||(y=new w.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(d)}}),this._rendererMessageEmitters.set(d,y),y)}}e.ExtHostNotebookRenderers=F}),define(Te[247],Ae([1,0,6,16,2,26,3]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class d{constructor(m){this.handlers=new Map,this.proxy=m.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,P,_){if((0,F.checkProposedApiEnabled)(m,"profileContentHandlers"),this.handlers.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.handlers.set(P,_),this.proxy.$registerProfileContentHandler(P,_.name,_.description,m.identifier.value),(0,w.toDisposable)(()=>{this.handlers.delete(P),this.proxy.$unregisterProfileContentHandler(P)})}async $saveProfile(m,P,_,a){const v=this.handlers.get(m);if(!v)throw new Error(`Unknown handler with id: ${m}`);return v.saveProfile(P,_,a)}async $readProfile(m,P,_){const a=this.handlers.get(m);if(!a)throw new Error(`Unknown handler with id: ${m}`);return a.readProfile((0,R.isString)(P)?P:k.URI.revive(P),_)}}e.ExtHostProfileContentHandlers=d}),define(Te[248],Ae([1,0,2,3,12,8]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(y,m){this.uriTransformer=m,this.providers=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,m,P){const _=w.URI.revive(m),a=this.providers.get(y);return a?(0,k.asPromise)(()=>a.provideOriginalResource(_,P)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(y,m,P,_){const a=T.handlePool++;return this.providers.set(a,m),this.proxy.$registerQuickDiffProvider(a,F.DocumentSelector.from(y,this.uriTransformer),P,_),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(a),this.providers.delete(a)}}}}e.ExtHostQuickDiff=T}),define(Te[249],Ae([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(f,t,n){const l=f.getProxy(F.MainContext.MainThreadQuickOpen);class E{constructor(C,I){this._sessions=new Map,this._instances=0,this._workspace=C,this._commands=I}showQuickPick(C,I,c,h=w.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(I),A=++this._instances,B=l.$show(A,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},h),H={},U=B.then(()=>H);return Promise.race([U,u]).then(z=>{if(z===H)return;const M=(0,a.isProposedApiEnabled)(C,"quickPickItemTooltip");return u.then(N=>{const ee=[];for(let Q=0;Q<N.length;Q++){const Se=N[Q];if(typeof Se=="string")ee.push({label:Se,handle:Q});else if(Se.kind===d.QuickPickItemKind.Separator)ee.push({type:"separator",label:Se.label});else{Se.tooltip&&!M&&console.warn(`Extension '${C.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${C.identifier.value}`);const ye=Se.iconPath?i(Se.iconPath):void 0;ee.push({label:Se.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:Se.description,detail:Se.detail,picked:Se.picked,alwaysShow:Se.alwaysShow,tooltip:M?v.MarkdownString.fromStrict(Se.tooltip):void 0,handle:Q})}}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{c.onDidSelectItem(N[Q])}),l.$setItems(A,ee),B.then(Q=>{if(typeof Q=="number")return N[Q];if(Array.isArray(Q))return Q.map(Se=>N[Se])})})}).then(void 0,z=>{if(!(0,y.isCancellationError)(z))return l.$setError(A,z),Promise.reject(z)})}$onItemSelected(C){this._onDidSelectItem?.(C)}showInput(C,I=w.CancellationToken.None){return this._validateInput=C?.validateInput,l.$input(C,typeof this._validateInput=="function",I).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(C){if(!this._validateInput)return;const I=await this._validateInput(C);if(!I||typeof I=="string")return I;let c;switch(I.severity){case d.InputBoxValidationSeverity.Info:c=P.default.Info;break;case d.InputBoxValidationSeverity.Warning:c=P.default.Warning;break;case d.InputBoxValidationSeverity.Error:c=P.default.Error;break;default:c=I.message?P.default.Error:P.default.Ignore;break}return{content:I.message,severity:c}}async showWorkspaceFolderPick(C,I=w.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[C]);if(!c)return;const h=await this._workspace.getWorkspaceFolders2();if(h)return h.find(u=>u.uri.toString()===c.uri.toString())}createQuickPick(C){const I=new o(C,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}createInputBox(C){const I=new S(C,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}$onDidChangeValue(C,I){this._sessions.get(C)?._fireDidChangeValue(I)}$onDidAccept(C){this._sessions.get(C)?._fireDidAccept()}$onDidChangeActive(C,I){const c=this._sessions.get(C);c instanceof o&&c._fireDidChangeActive(I)}$onDidChangeSelection(C,I){const c=this._sessions.get(C);c instanceof o&&c._fireDidChangeSelection(I)}$onDidTriggerButton(C,I){this._sessions.get(C)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(C,I,c){const h=this._sessions.get(C);h instanceof o&&h._fireDidTriggerItemButton(I,c)}$onDidHide(C){this._sessions.get(C)?._fireDidHide()}}class D{static{this._nextId=1}constructor(C,I){this._extensionId=C,this._onDidDispose=I,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(C){this._title=C,this.update({title:C})}get step(){return this._steps}set step(C){this._steps=C,this.update({step:C})}get totalSteps(){return this._totalSteps}set totalSteps(C){this._totalSteps=C,this.update({totalSteps:C})}get enabled(){return this._enabled}set enabled(C){this._enabled=C,this.update({enabled:C})}get busy(){return this._busy}set busy(C){this._busy=C,this.update({busy:C})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(C){this._ignoreFocusOut=C,this.update({ignoreFocusOut:C})}get value(){return this._value}set value(C){this._value=C,this.update({value:C})}get placeholder(){return this._placeholder}set placeholder(C){this._placeholder=C,this.update({placeholder:C})}get buttons(){return this._buttons}set buttons(C){this._buttons=C.slice(),this._handlesToButtons.clear(),C.forEach((I,c)=>{const h=I===d.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(h,I)}),this.update({buttons:C.map((I,c)=>({...i(I.iconPath),tooltip:I.tooltip,handle:I===d.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(C){this._value=C,this._onDidChangeValueEmitter.fire(C)}_fireDidTriggerButton(C){const I=this._handlesToButtons.get(C);I&&this._onDidTriggerButtonEmitter.fire(I)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),l.$dispose(this._id))}update(C){if(!this._disposed){for(const I of Object.keys(C)){const c=C[I];this._pendingUpdate[I]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){l.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function p(b){if(b instanceof d.ThemeIcon)return{id:b.id};const C=s(b),I=r(b);return{dark:typeof C=="string"?T.URI.file(C):C,light:typeof I=="string"?T.URI.file(I):I}}function r(b){return typeof b=="object"&&"light"in b?b.light:b}function s(b){return typeof b=="object"&&"dark"in b?b.dark:b}function i(b){const C=p(b);let I,c;return"id"in C?c=_.ThemeIcon.asClassName(C):I=C,{iconPath:I,iconClass:c}}class o extends D{constructor(C,I){super(C.identifier,I),this.extension=C,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this._onDidTriggerItemButtonEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(C){this._items=C.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),C.forEach((h,u)=>{this._handlesToItems.set(u,h),this._itemsToHandles.set(h,u)});const I=(0,a.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),c=[];for(let h=0;h<C.length;h++){const u=C[h];if(u.kind===d.QuickPickItemKind.Separator)c.push({type:"separator",label:u.label});else{u.tooltip&&!I&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const A=u.iconPath?i(u.iconPath):void 0;c.push({handle:h,label:u.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(u.tooltip):void 0,buttons:u.buttons?.map((B,H)=>({...i(B.iconPath),tooltip:B.tooltip,handle:H}))})}}this.update({items:c})}get canSelectMany(){return this._canSelectMany}set canSelectMany(C){this._canSelectMany=C,this.update({canSelectMany:C})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(C){this._matchOnDescription=C,this.update({matchOnDescription:C})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(C){this._matchOnDetail=C,this.update({matchOnDetail:C})}get sortByLabel(){return this._sortByLabel}set sortByLabel(C){this._sortByLabel=C,this.update({sortByLabel:C})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(C){this._keepScrollPosition=C,this.update({keepScrollPosition:C})}get activeItems(){return this._activeItems}set activeItems(C){this._activeItems=C.filter(I=>this._itemsToHandles.has(I)),this.update({activeItems:this._activeItems.map(I=>this._itemsToHandles.get(I))})}get selectedItems(){return this._selectedItems}set selectedItems(C){this._selectedItems=C.filter(I=>this._itemsToHandles.has(I)),this.update({selectedItems:this._selectedItems.map(I=>this._itemsToHandles.get(I))})}_fireDidChangeActive(C){const I=(0,m.coalesce)(C.map(c=>this._handlesToItems.get(c)));this._activeItems=I,this._onDidChangeActiveEmitter.fire(I)}_fireDidChangeSelection(C){const I=(0,m.coalesce)(C.map(c=>this._handlesToItems.get(c)));this._selectedItems=I,this._onDidChangeSelectionEmitter.fire(I)}_fireDidTriggerItemButton(C,I){const c=this._handlesToItems.get(C);if(!c||!c.buttons||!c.buttons.length)return;const h=c.buttons[I];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:c})}}class S extends D{constructor(C,I){super(C.identifier,I),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(C){this._password=C,this.update({password:C})}get prompt(){return this._prompt}set prompt(C){this._prompt=C,this.update({prompt:C})}get valueSelection(){return this._valueSelection}set valueSelection(C){this._valueSelection=C,this.update({valueSelection:C})}get validationMessage(){return this._validationMessage}set validationMessage(C){this._validationMessage=C,C?typeof C=="string"?this.update({validationMessage:C,severity:P.default.Error}):this.update({validationMessage:C.message,severity:C.severity??P.default.Error}):this.update({validationMessage:void 0,severity:P.default.Ignore})}}return new E(t,n)}e.createExtHostQuickOpen=g}),define(Te[250],Ae([1,0,2,5,65,6,12,3,18,131,14,20,40,8,26,13]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(h){if(h)return typeof h.iconPath=="string"?w.URI.file(h.iconPath):w.URI.isUri(h.iconPath)||a.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function l(h){if(h.icon){if(w.URI.isUri(h.icon))return h.icon;if(a.ThemeIcon.isThemeIcon(h.icon))return h.icon;{const u=h.icon;return{light:u.light,dark:u.dark}}}else return}function E(h,u){if(!h.iconPath&&!u.iconPath)return 0;if(h.iconPath){if(!u.iconPath)return 1}else return-1;const A=typeof h.iconPath=="string"?h.iconPath:w.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,B=typeof u.iconPath=="string"?u.iconPath:w.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,m.comparePaths)(A,B)}function D(h,u){let A=0;if(h.strikeThrough!==u.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==u.faded)return h.faded?1:-1;if(h.tooltip!==u.tooltip)return(h.tooltip||"").localeCompare(u.tooltip||"");if(A=E(h,u),A!==0)return A;if(h.light&&u.light)A=E(h.light,u.light);else{if(h.light)return 1;if(u.light)return-1}if(A!==0)return A;if(h.dark&&u.dark)A=E(h.dark,u.dark);else{if(h.dark)return 1;if(u.dark)return-1}return A}function p(h,u){if(h.command!==u.command)return h.command<u.command?-1:1;if(h.title!==u.title)return h.title<u.title?-1:1;if(h.tooltip!==u.tooltip){if(h.tooltip!==void 0&&u.tooltip!==void 0)return h.tooltip<u.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(h.arguments===u.arguments)return 0;if(h.arguments)if(u.arguments){if(h.arguments.length!==u.arguments.length)return h.arguments.length-u.arguments.length}else return 1;else return-1;for(let A=0;A<h.arguments.length;A++){const B=h.arguments[A],H=u.arguments[A];if(B!==H)return B<H?-1:1}return 0}function r(h,u){let A=(0,m.comparePaths)(h.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(A!==0)return A;if(h.command&&u.command)A=p(h.command,u.command);else{if(h.command)return 1;if(u.command)return-1}if(A!==0)return A;if(h.decorations&&u.decorations)A=D(h.decorations,u.decorations);else{if(h.decorations)return 1;if(u.decorations)return-1}return A}function s(h,u){for(let A=0;A<h.length;A++)if(h[A]!==u[A])return!1;return!0}function i(h,u){return h.command===u.command&&h.title===u.title&&h.tooltip===u.tooltip&&(h.arguments&&u.arguments?s(h.arguments,u.arguments):h.arguments===u.arguments)}function o(h,u){return(0,y.equals)(h,u,i)}function S(h,u){return h===u?!0:!h||!u?!1:h.id===u.id&&h.label===u.label&&h.upstream?.id===u.upstream?.id&&h.upstream?.label===u.upstream?.label}class b{#e;#t;get value(){return this._value}set value(u){u=u??"",this.#e.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get enabled(){return this._enabled}set enabled(u){u=!!u,this._enabled!==u&&(this._enabled=u,this.#e.$setInputBoxEnablement(this._sourceControlHandle,u))}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this.#e.$setInputBoxVisibility(this._sourceControlHandle,u))}get document(){return(0,g.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(u,A,B,H,U){this._extension=u,this._sourceControlHandle=H,this._documentUri=U,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=A,this.#e=B}showValidationMessage(u,A){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,u,A)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=b;class C{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}constructor(u,A,B,H,U){this._proxy=u,this._commands=A,this._sourceControlHandle=B,this._id=H,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=C._handlePool++}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,A){const B=this._resourceStatesCommandsMap.get(u);return B?(0,T.asPromise)(()=>this._commands.executeCommand(B.command,...B.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(r),B=(0,y.sortedDiff)(this._resourceSnapshot,u,r).map(z=>{const M=z.toInsert.map(N=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,N);const Q=N.resourceUri;let Se;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const W=new F.DisposableStore;Se=this._commands.converter.toInternal(N.command,W),this._resourceStatesDisposablesMap.set(ee,W)}else this._resourceStatesCommandsMap.set(ee,N.command);const ye=n(N.decorations),Pe=N.decorations&&n(N.decorations.light)||ye,Y=N.decorations&&n(N.decorations.dark)||ye,ue=[Pe,Y],_e=N.decorations&&N.decorations.tooltip||"",ce=N.decorations&&!!N.decorations.strikeThrough,pe=N.decorations&&!!N.decorations.faded,ie=N.contextValue||"";return{rawResource:[ee,Q,ue,_e,ce,pe,ie,Se],handle:ee}});return{start:z.start,deleteCount:z.deleteCount,toInsert:M}}),H=B.map(({start:z,deleteCount:M,toInsert:N})=>[z,M,N.map(ee=>ee.rawResource)]),U=B.reverse();for(const{start:z,deleteCount:M,toInsert:N}of U){const ee=N.map(Se=>Se.handle),Q=this._handlesSnapshot.splice(z,M,...ee);for(const Se of Q)this._resourceStatesMap.delete(Se),this._resourceStatesCommandsMap.delete(Se),this._resourceStatesDisposablesMap.get(Se)?.dispose(),this._resourceStatesDisposablesMap.delete(Se)}return this._resourceSnapshot=u,H}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class I{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this.#e.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u;let A;(0,g.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(A=u?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u,quickDiffLabel:A})}get historyProvider(){return(0,g.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(u){(0,g.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=u,this._historyProviderDisposable.value=new F.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!u}),u&&(this._historyProviderDisposable.value.add(u.onDidChangeCurrentHistoryItemGroup(()=>{S(this._historyProviderCurrentHistoryItemGroup,u?.currentHistoryItemGroup)||(this._historyProviderCurrentHistoryItemGroup=u?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))})),this._historyProviderDisposable.value.add(u.onDidChangeActionButton(()=>{(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new F.DisposableStore;const A=u.actionButton!==void 0?{command:this._commands.converter.toInternal(u.actionButton.command,this._historyProviderActionButtonDisposable.value),description:u.actionButton.description,enabled:u.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,A??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this.#e.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new F.DisposableStore,this._acceptInputCommand=u;const A=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:A})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=u;const A=u!==void 0?{command:this._commands.converter.toInternal(u.command,this._actionButtonDisposables.value),secondaryCommands:u.secondaryCommands?.map(B=>B.map(H=>this._commands.converter.toInternal(H,this._actionButtonDisposables.value))),description:u.description,enabled:u.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:A??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&o(this._statusBarCommands,u))return;this._statusBarDisposables.value=new F.DisposableStore,this._statusBarCommands=u;const A=(u||[]).map(B=>this._commands.converter.toInternal(B,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:A})}get selected(){return this._selected}constructor(u,A,B,H,U,z,M){this._extension=u,this._commands=H,this._id=U,this._label=z,this._rootUri=M,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new F.MutableDisposable,this._historyProviderActionButtonDisposable=new F.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new F.MutableDisposable,this._statusBarDisposables=new F.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=I._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=B;const N=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${U}/scm${this.handle}/input`,query:M?`rootUri=${encodeURIComponent(M.toString())}`:void 0});this._inputBox=new b(u,A,this.#e,this.handle,N),this.#e.$registerSourceControl(this.handle,U,z,M,N)}createResourceGroup(u,A){const B=new C(this.#e,this._commands,this.handle,u,A),H=R.Event.once(B.onDidDispose)(()=>this.createdResourceGroups.delete(B));return this.createdResourceGroups.set(B,H),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const u=[],A=[];for(const[B,H]of this.createdResourceGroups){H.dispose();const U=B.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(B),this.eventuallyUpdateResourceStates()});R.Event.once(B.onDidDispose)(()=>{this.updatedResourceGroups.delete(B),U.dispose(),this._groups.delete(B.handle),this.#e.$unregisterGroup(this.handle,B.handle)}),u.push([B.handle,B.id,B.label,B.features]);const z=B._takeResourceStateSnapshot();z.length>0&&A.push([B.handle,z]),this._groups.set(B.handle,B)}this.#e.$registerGroups(this.handle,u,A),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(A=>{const B=A._takeResourceStateSnapshot();B.length!==0&&u.push([A.handle,B])}),u.length>0&&this.#e.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ve([(0,k.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let c=class{static{t=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(u,A,B,H){this._commands=A,this._extHostDocuments=B,this.logService=H,this._sourceControls=new Map,this._sourceControlsByExtension=new _.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=u.getProxy(d.MainContext.MainThreadSCM),this._telemetry=u.getProxy(d.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const z=this._sourceControls.get(U.sourceControlHandle);if(!z)return U;const M=z.getResourceGroup(U.groupHandle);return M?M.getResourceState(U.handle):U}else if(U&&U.$mid===4){const z=this._sourceControls.get(U.sourceControlHandle);return z?z.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const z=this._sourceControls.get(U.handle);return z||U}return U}})}createSourceControl(u,A,B,H){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,A,B,H),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const U=t._handlePool++,z=new I(u,this._extHostDocuments,this._proxy,this._commands,A,B,H);this._sourceControls.set(U,z);const M=this._sourceControlsByExtension.get(u.identifier)||[];return M.push(z),this._sourceControlsByExtension.set(u.identifier,M),z}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const A=this._sourceControlsByExtension.get(u.identifier),B=A&&A[A.length-1];return B&&B.inputBox}$provideOriginalResource(u,A,B){const H=w.URI.revive(A);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,H.toString());const U=this._sourceControls.get(u);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(H,B)).then(z=>z||null)}$onInputBoxValueChange(u,A){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const B=this._sourceControls.get(u);return B&&B.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(u,A,B,H){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,A,B);const U=this._sourceControls.get(u);if(!U)return Promise.resolve(void 0);const z=U.getResourceGroup(A);return z?z.$executeResourceCommand(B,H):Promise.resolve(void 0)}$validateInput(u,A,B){this.logService.trace("ExtHostSCM#$validateInput",u);const H=this._sourceControls.get(u);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>H.inputBox.validateInput(A,B)).then(U=>{if(!U)return Promise.resolve(void 0);const z=v.MarkdownString.fromStrict(U.message);return z?Promise.resolve([z,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(u,A,B){return await this._sourceControls.get(u)?.historyProvider?.resolveHistoryItemGroupBase(A,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(u,A,B,H){return await this._sourceControls.get(u)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(A,B,H)??void 0}async $provideHistoryItems(u,A,B,H){return(await this._sourceControls.get(u)?.historyProvider?.provideHistoryItems(A,B,H))?.map(M=>({id:M.id,parentIds:M.parentIds,label:M.label,description:M.description,icon:l(M),timestamp:M.timestamp}))??void 0}async $provideHistoryItemChanges(u,A,B){return await this._sourceControls.get(u)?.historyProvider?.provideHistoryItemChanges(A,B)??void 0}};e.ExtHostSCM=c,e.ExtHostSCM=c=t=Ve([We(3,P.ILogService)],c)}),define(Te[83],Ae([1,0,3,5,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(d){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=d.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(d){this._onDidChangePassword.fire(d)}get(d,y){return this._proxy.$getPassword(d,y)}store(d,y,m){return this._proxy.$setPassword(d,y,m)}delete(d,y){return this._proxy.$deletePassword(d,y)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(Te[251],Ae([1,0,3,8,2]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class F{static{this.handlePool=0}constructor(d,y){this.uriTransformer=y,this.providers=new Map,this.proxy=d.getProxy(w.MainContext.MainThreadShare)}async $provideShare(d,y,m){return await this.providers.get(d)?.provideShare({selection:R.Range.to(y.selection),resourceUri:k.URI.revive(y.resourceUri)},m)??void 0}registerShareProvider(d,y){const m=F.handlePool++;return this.providers.set(m,y),this.proxy.$registerShareProvider(m,R.DocumentSelector.from(d,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(m),this.providers.delete(m)}}}}e.ExtHostShare=F}),define(Te[252],Ae([1,0,7,3,153,6,8,16]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(a,v,g,f,t,n=w.StatusBarAlignment.Left,l){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new F.DisposableStore,this.#e=a,this.#t=v,t&&f){this._entryId=(0,w.asStatusBarItemIdentifier)(f.identifier,t);const E=g.get(this._entryId);E&&(n=E.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,l=E.priority,this._visible=!0,this.name=E.name,this.text=E.text,this.tooltip=E.tooltip,this.command=E.command,this.accessibilityInformation=E.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=f,this._id=t,this._alignment=n,this._priority=this.validatePriority(l)}validatePriority(a){if((0,d.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!y.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new F.DisposableStore,typeof a=="string"?this._command={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this._latestCommandRegistration)}:a?this._command={fromApi:a,internal:this.#t.toInternal(a,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let v;this._name?v=this._name:v=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,a,this._extension?.identifier.value,v,this._text,f,this._command?.internal,g,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class m{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const v={message:a};return this._messages.unshift(v),this._update(),new w.Disposable(()=>{const g=this._messages.indexOf(v);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(a,v){this._existingItems=new Map,this._proxy=a.getProxy(R.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new m(this)}$acceptStaticEntries(a){for(const v of a)this._existingItems.set(v.entryId,v)}createStatusBarEntry(a,v,g,f){return new y(this._proxy,this._commands,this._existingItems,a,v,g,f)}setStatusBarMessage(a,v){const g=this._statusMessage.setMessage(a);let f;return typeof v=="number"?f=setTimeout(()=>g.dispose(),v):typeof v<"u"&&v.then(()=>g.dispose(),()=>g.dispose()),new w.Disposable(()=>{g.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=P}),define(Te[84],Ae([1,0,3,5,4]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(d,y){this._logService=y,this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=d.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(d,y){this._proxy.$registerExtensionStorageKeysToSync(d,y)}async initializeExtensionStorage(d,y,m){const P=await this._proxy.$initializeExtensionStorage(d,y);let _;return P&&(_=this.safeParseValue(d,y,P)),_||m}setValue(d,y,m){return this._proxy.$setValue(d,y,m)}$acceptValue(d,y,m){const P=this.safeParseValue(d,y,m);P&&this._onDidChangeStorage.fire({shared:d,key:y,value:P})}safeParseValue(d,y,m){try{return JSON.parse(m)}catch(P){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${d}): ${P}`)}}}e.ExtHostStorage=F,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(Te[85],Ae([1,0,4,27,14,62,2]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let d=class{constructor(m,P,_){this._logService=P,this._extHostFileSystem=_,this._workspace=m.workspace??void 0,this._environment=m.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(m){return T.URI.joinPath(this._environment.workspaceStorageHome,m)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const m=this._workspace.id,P=await this._getWorkspaceStorageURI(m);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(m){if(this._value)return T.URI.joinPath(this._value,m.identifier.value)}globalValue(m){return T.URI.joinPath(this._environment.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=d,e.ExtensionStoragePaths=d=Ve([We(0,R.IExtHostInitDataService),We(1,k.ILogService),We(2,F.IExtHostConsumerFileSystem)],d)}),define(Te[63],Ae([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,12,8,31]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class E{constructor(c,h,u,A){this._proxy=c,this._id=h,this._creationOptions=u,this._name=A,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(H=>this._pidPromiseComplete=H);const B=this;this.value={get name(){return B._name||""},get processId(){return B._pidPromise},get creationOptions(){return B._creationOptions},get exitStatus(){return B._exitStatus},get state(){return B._state},get selection(){return B._selection},sendText(H,U=!0){B._checkDisposed(),B._proxy.$sendText(B._id,H,U)},show(H){B._checkDisposed(),B._proxy.$show(B._id,H)},hide(){B._checkDisposed(),B._proxy.$hide(B._id)},dispose(){B._disposed||(B._disposed=!0,B._proxy.$dispose(B._id))},get dimensions(){if(!(B._cols===void 0||B._rows===void 0))return{columns:B._cols,rows:B._rows}}}}async create(c,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:c.shellPath??void 0,shellArgs:c.shellArgs??void 0,cwd:c.cwd??void 0,env:c.env??void 0,icon:S(c.iconPath)??void 0,color:f.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:c.message??void 0,strictEnv:c.strictEnv??void 0,hideFromUser:c.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this._serializeParentTerminal(c.location,h?.resolvedExtHostIdentifier),isTransient:c.isTransient??void 0})}async createExtensionTerminal(c,h,u,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:f.ThemeColor.isThemeColor(A)?A.id:void 0,location:this._serializeParentTerminal(c,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,h){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in c?{viewColumn:n.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitStatus(c,h){this._exitStatus=Object.freeze({code:c,reason:h})}setDimensions(c,h){return c===this._cols&&h===this._rows||c===0||h===0?!1:(this._cols=c,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(c){this._selection=c}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=E;class D{get onProcessReady(){return this._onProcessReady.event}constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new w.Emitter,this._onDidChangeProperty=new w.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,h){this._pty.setDimensions?.({columns:c,rows:h})}clearBuffer(){}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(c){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let p=1,r=class extends d.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}constructor(c,h,u){super(),this._extHostCommands=h,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new d.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new w.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new w.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new w.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new w.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new w.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=u.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(c),this._extHostCommands.registerArgumentProcessor({processArgument:A=>{const B=H=>{const U=H;return this._getTerminalById(U.instanceId)?.value};switch(A?.$mid){case 15:return B(A);default:{if(Array.isArray(A))for(let H=0;H<A.length&&A[H].$mid===15;H++)A[H]=B(A[H]);return A}}}}),this._register({dispose:()=>{for(const[A,B]of this._terminalProcesses)B.shutdown(!0)}})}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,h){const u=new E(this._proxy,(0,v.generateUuid)(),c,c.name),A=new D(c.pty);return u.createExtensionTerminal(c.location,this._serializeParentTerminal(c,h).resolvedExtHostIdentifier,S(c.iconPath),b(c.color)).then(B=>{const H=this._setupExtHostProcessListeners(B,A);this._terminalProcessDisposables[B]=H}),this._terminals.push(u),u.value}_serializeParentTerminal(c,h){if(h=h||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const u=c.location.parentTerminal;if(u){const A=this._terminals.find(B=>B.value===u);A&&(h.resolvedExtHostIdentifier=A._id)}}else c.location&&typeof c.location!="object"?h.location=c.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(c,h){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const A=new D(h),B=this._setupExtHostProcessListeners(c,A);this._terminalProcessDisposables[c]=B}async $acceptActiveTerminalChanged(c){const h=this._activeTerminal;if(c===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(c);u&&(this._activeTerminal=u,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,h){const u=this._getTerminalById(c);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:h})}async $acceptTerminalDimensions(c,h,u){const A=this._getTerminalById(c);A&&A.setDimensions(h,u)&&this._onDidChangeTerminalDimensions.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(c,h){const u=this._getTerminalById(c);u&&this._onDidExecuteCommand.fire({terminal:u.value,...h})}async $acceptTerminalMaximumDimensions(c,h,u){this._terminalProcesses.get(c)?.resize(h,u)}async $acceptTerminalTitleChange(c,h){const u=this._getTerminalById(c);u&&(u.name=h)}async $acceptTerminalClosed(c,h,u){const A=this._getTerminalObjectIndexById(this._terminals,c);if(A!==null){const B=this._terminals.splice(A,1)[0];B.setExitStatus(h,u),this._onDidCloseTerminal.fire(B.value)}}$acceptTerminalOpened(c,h,u,A){if(h){const U=this._getTerminalObjectIndexById(this._terminals,h);if(U!==null){this._terminals[U]._id=c,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const B={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:F.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},H=new E(this._proxy,c,B,u);this._terminals.push(H),this._onDidOpenTerminal.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(c,h){this._getTerminalById(c)?._setProcessId(h)}async $startExtensionTerminal(c,h){const u=this._getTerminalById(c);if(!u)return{message:(0,m.localize)(0,null,c)};u.isOpen||await new Promise(B=>{const H=this.onDidOpenTerminal(async U=>{U===u.value&&(H.dispose(),B())})});const A=this._terminalProcesses.get(c);A?A.startSendingEvents(h):this._extensionTerminalAwaitingStart[c]={initialDimensions:h}}_setupExtHostProcessListeners(c,h){const u=new d.DisposableStore;u.add(h.onProcessReady(B=>this._proxy.$sendProcessReady(c,B.pid,B.cwd,B.windowsPty))),u.add(h.onDidChangeProperty(B=>this._proxy.$sendProcessProperty(c,B))),this._bufferer.startBuffering(c,h.onProcessData),u.add(h.onProcessExit(B=>this._onProcessExit(c,B))),this._terminalProcesses.set(c,h);const A=this._extensionTerminalAwaitingStart[c];return A&&h instanceof D&&(h.startSendingEvents(A.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),u}$acceptProcessAckDataEvent(c,h){this._terminalProcesses.get(c)?.acknowledgeDataEvent(h)}$acceptProcessInput(c,h){this._terminalProcesses.get(c)?.input(h)}$acceptTerminalInteraction(c){const h=this._getTerminalById(c);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptTerminalSelection(c,h){this._getTerminalById(c)?.setSelection(h)}$acceptProcessResize(c,h,u){try{this._terminalProcesses.get(c)?.resize(h,u)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(c,h){this._terminalProcesses.get(c)?.shutdown(h)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(h=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:h}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,h,u){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,u),this._proxy.$registerProfileProvider(h,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(c,h,u){if(this._quickFixProviders.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this._quickFixProviders.set(c,u),this._proxy.$registerQuickFixProvider(c,h),new y.Disposable(()=>{this._quickFixProviders.delete(c),this._proxy.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,h){const u=new a.CancellationTokenSource().token;if(u.isCancellationRequested)return;const A=this._quickFixProviders.get(c);if(!A)return;const B=await A.provideTerminalQuickFixes(h,u);if(B===null||Array.isArray(B)&&B.length===0)return;const H=new d.DisposableStore;if(this._lastQuickFixCommands.value=H,!Array.isArray(B))return B?n.TerminalQuickFix.from(B,this._extHostCommands.converter,H):void 0;const U=[];for(const z of B){const M=n.TerminalQuickFix.from(z,this._extHostCommands.converter,H);M&&U.push(M)}return U}async $createContributedProfileTerminal(c,h){const u=new a.CancellationTokenSource().token;let A=await this._profileProviders.get(c)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,h);return}this.createTerminalFromOptions(A.options,h)}}async $provideLinks(c,h){const u=this._getTerminalById(c);if(!u)return[];this._terminalLinkCache.delete(c),this._terminalLinkCancellationSource.get(c)?.dispose(!0);const B=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,B);const H=[],U={terminal:u.value,line:h},z=[];for(const ee of this._linkProviders)z.push(t.Promises.withAsyncBody(async Q=>{B.token.onCancellationRequested(()=>Q({provider:ee,links:[]}));const Se=await ee.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||Q({provider:ee,links:Se})}));const M=await Promise.all(z);if(B.token.isCancellationRequested)return[];const N=new Map;for(const ee of M)ee&&ee.links.length>0&&H.push(...ee.links.map(Q=>{const Se={id:p++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return N.set(Se.id,{provider:ee.provider,link:Q}),Se}));return this._terminalLinkCache.set(c,N),H}$activateLink(c,h){const u=this._terminalLinkCache.get(c)?.get(h);u&&u.provider.handleTerminalLink(u.link)}_onProcessExit(c,h){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const u=this._terminalProcessDisposables[c];u&&(u.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,h)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,h){const u=this._getTerminalObjectIndexById(c,h);return u!==null?c[u]:null}_getTerminalObjectIndexById(c,h){const u=c.findIndex(A=>A._id===h);return u===-1?null:u}getEnvironmentVariableCollection(c){let h=this._environmentVariableCollections.get(c.identifier.value);return h||(h=new s,this._setEnvironmentVariableCollection(c.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(c,h){const u=(0,_.serializeEnvironmentVariableCollection)(h.map),A=(0,_.serializeEnvironmentDescriptionMap)(h.descriptionMap);this._proxy.$setEnvironmentVariableCollection(c,h.persistent,u.length===0?void 0:u,A)}$initEnvironmentVariableCollections(c){c.forEach(h=>{const u=h[0],A=new s(h[1]);this._setEnvironmentVariableCollection(u,A)})}$acceptDefaultProfile(c,h){const u=this._defaultProfile;this._defaultProfile=c,this._defaultAutomationProfile=h,u?.path!==c.path&&this._onDidChangeShell.fire(c.path)}_setEnvironmentVariableCollection(c,h){this._environmentVariableCollections.set(c,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,h)})}};e.BaseExtHostTerminalService=r,e.BaseExtHostTerminalService=r=Ve([We(1,l.IExtHostCommands),We(2,T.IExtHostRpcService)],r);class s{get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(c)}getScopedEnvironmentVariableCollection(c){const h=this.getScopeKey(c);let u=this.scopedCollections.get(h);return u||(u=new i(this,c),this.scopedCollections.set(h,u),u.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),u}replace(c,h,u,A){this._setIfDiffers(c,{value:h,type:y.EnvironmentVariableMutatorType.Replace,options:u??{applyAtProcessCreation:!0},scope:A})}append(c,h,u,A){this._setIfDiffers(c,{value:h,type:y.EnvironmentVariableMutatorType.Append,options:u??{applyAtProcessCreation:!0},scope:A})}prepend(c,h,u,A){this._setIfDiffers(c,{value:h,type:y.EnvironmentVariableMutatorType.Prepend,options:u??{applyAtProcessCreation:!0},scope:A})}_setIfDiffers(c,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const u=this.getKey(c,h.scope),A=this.map.get(u),B=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==h.value||A.type!==h.type||A.options?.applyAtProcessCreation!==B.applyAtProcessCreation||A.options?.applyAtShellIntegration!==B.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const H=this.getKey(c,h.scope),U={variable:c,...h,options:B};this.map.set(H,U),this._onDidChangeCollection.fire()}}get(c,h){const u=this.getKey(c,h),A=this.map.get(u);return A?C(A):void 0}getKey(c,h){const u=this.getScopeKey(h);return u.length?`${c}:::${u}`:c}getScopeKey(c){return this.getWorkspaceKey(c?.workspaceFolder)??""}getWorkspaceKey(c){return c?c.uri.toString():void 0}getVariableMap(c){const h=new Map;for(const[u,A]of this.map)this.getScopeKey(A.scope)===this.getScopeKey(c)&&h.set(A.variable,C(A));return h}delete(c,h){const u=this.getKey(c,h);this.map.delete(u),this._onDidChangeCollection.fire()}clear(c){if(c?.workspaceFolder){for(const[h,u]of this.map)u.scope?.workspaceFolder?.index===c.workspaceFolder.index&&this.map.delete(h);this.clearDescription(c)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(c,h){const u=this.getScopeKey(h),A=this.descriptionMap.get(u);if(!A||A.description!==c){let B;typeof c=="string"?B=c:B=c?.value.split(`

`)[0];const H={description:B,scope:h};this.descriptionMap.set(u,H),this._onDidChangeCollection.fire()}}getDescription(c){const h=this.getScopeKey(c);return this.descriptionMap.get(h)?.description}clearDescription(c){const h=this.getScopeKey(c);this.descriptionMap.delete(h)}}class i{get persistent(){return this.collection.persistent}set persistent(c){this.collection.persistent=c}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c,h){this.collection=c,this.scope=h,this._onDidChangeCollection=new w.Emitter}getScoped(c){return this.collection.getScopedEnvironmentVariableCollection(c)}replace(c,h,u){this.collection.replace(c,h,u,this.scope)}append(c,h,u){this.collection.append(c,h,u,this.scope)}prepend(c,h,u){this.collection.prepend(c,h,u,this.scope)}get(c){return this.collection.get(c,this.scope)}forEach(c,h){this.collection.getVariableMap(this.scope).forEach((u,A)=>c.call(h,A,u,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(c){this.collection.delete(c,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(c){this.collection.setDescription(c,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let o=class extends r{constructor(c,h){super(!1,c,h)}createTerminal(c,h,u){throw new P.NotSupportedError}createTerminalFromOptions(c,h){throw new P.NotSupportedError}};e.WorkerExtHostTerminalService=o,e.WorkerExtHostTerminalService=o=Ve([We(0,l.IExtHostCommands),We(1,T.IExtHostRpcService)],o);function S(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return f.ThemeColor.isThemeColor(I)?I:void 0}function C(I){const c={...I};return delete c.scope,c.options=c.options??void 0,delete c.variable,c}}),define(Te[253],Ae([1,0,282,12,25,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,57,26]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(U,z,M){this.editors=M,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(v.MainContext.MainThreadTesting),this.observer=new u(this.proxy),this.runTracker=new S(this.proxy),z.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ee=N,Q=ee.tests[ee.tests.length-1].item.extId;return this.controllers.get(l.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,f.toItemFromContext)(N)}case 18:{const{extId:ee,message:Q}=N;return{test:this.controllers.get(l.TestId.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(Q)}}default:return N}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await z.executeCommand("_testing.getExplorerSelection"),ee=Q=>{const Se=this.controllers.get(l.TestId.root(Q));if(Se)return l.TestId.isRoot(Q)?Se.controller:Se.collection.tree.get(Q)?.actual};return{include:N?.include.map(ee).filter(_.isDefined)||[],exclude:N?.exclude.map(ee).filter(_.isDefined)||[]}})}createTestController(U,z,M,N){if(this.controllers.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const ee=new m.DisposableStore,Q=ee.add(new f.ExtHostTestItemCollection(z,M,this.editors));Q.root.label=M;const Se=new Map,ye=this.proxy,Pe={items:Q.root.children,get label(){return M},set label(ue){M=ue,Q.root.label=ue,ye.$updateController(z,{label:M})},get refreshHandler(){return N},set refreshHandler(ue){N=ue,ye.$updateController(z,{canRefresh:!!ue})},get id(){return z},createRunProfile:(ue,_e,ce,pe,ie,x)=>{let W=(0,y.hash)(ue);for(;Se.has(W);)W++;return new A(this.proxy,Se,z,W,ue,_e,ce,pe,ie,x)},createTestItem(ue,_e,ce){return new f.TestItemImpl(z,ue,_e,ce)},createTestRun:(ue,_e,ce=!0)=>this.runTracker.createTestRun(U,z,Q,ue,_e,ce),invalidateTestResults:ue=>{if(ue===void 0)this.proxy.$markTestRetired(void 0);else{const _e=ue instanceof Array?ue:[ue];this.proxy.$markTestRetired(_e.map(ce=>l.TestId.fromExtHostTestItem(ce,z).toString()))}},set resolveHandler(ue){Q.resolveHandler=ue},get resolveHandler(){return Q.resolveHandler},dispose:()=>{ee.dispose()}};ye.$registerTestController(z,M,!!N),ee.add((0,m.toDisposable)(()=>ye.$unregisterTestController(z)));const Y={controller:Pe,collection:Q,profiles:Se,extension:U};return this.controllers.set(z,Y),ee.add((0,m.toDisposable)(()=>this.controllers.delete(z))),ee.add(Q.onDidGenerateDiff(ue=>ye.$publishDiff(z,ue.map(D.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.observer.checkout()}async runTests(U,z=F.CancellationToken.None){const M=b(U);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.controllers.get(M.controllerId);if(!N)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>l.TestId.fromExtHostTestItem(ee,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},z)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,z,M){return(0,w.mapFindFirst)(this.runTracker.trackers,ee=>ee.id===U?ee.getCoverage(z):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(U,z,M,N){return(0,w.mapFindFirst)(this.runTracker.trackers,Q=>Q.id===U?Q.getCoverage(z):void 0)?.resolveFileCoverage(M,N)??Promise.resolve([])}$configureRunProfile(U,z){this.controllers.get(U)?.profiles.get(z)?.configureHandler?.()}async $refreshTests(U,z){await this.controllers.get(U)?.controller.refreshHandler?.(z)}$publishTestResults(U){this.results=Object.freeze(U.map(z=>(0,P.deepFreeze)(t.TestResults.to(z))).concat(this.results).sort((z,M)=>M.completedAt-z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,z){const M=this.controllers.get(l.TestId.fromString(U).controllerId)?.collection;M&&(await M.expand(U,z<0?1/0:z),M.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(D.TestsDiffOp.deserialize))}async $runControllerTests(U,z){return Promise.all(U.map(M=>this.runControllerTestRequest(M,!1,z)))}async $startContinuousRun(U,z){const M=new F.CancellationTokenSource(z),N=await Promise.all(U.map(ee=>this.runControllerTestRequest(ee,!0,M.token)));return!z.isCancellationRequested&&!N.some(ee=>ee.error)&&await new Promise(ee=>z.onCancellationRequested(ee)),M.dispose(!0),N}async runControllerTestRequest(U,z,M){const N=this.controllers.get(U.controllerId);if(!N)return{};const{collection:ee,profiles:Q,extension:Se}=N,ye=Q.get(U.profileId);if(!ye)return{};const Pe=U.testIds.map(ce=>ee.tree.get(ce)).filter(_.isDefined),Y=U.excludeExtIds.map(ce=>N.collection.tree.get(ce)).filter(_.isDefined).filter(ce=>Pe.some(pe=>pe.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const ue=new n.TestRunRequest(Pe.some(ce=>ce.actual instanceof f.TestItemRootImpl)?void 0:Pe.map(ce=>ce.actual),Y.map(ce=>ce.actual),ye,z),_e=(0,D.isStartControllerTests)(U)&&this.runTracker.prepareForMainThreadTestRun(ue,C.fromInternal(U,N.collection),Se,M);try{return await ye.runHandler(ue,M),{}}catch(ce){return{error:String(ce)}}finally{_e&&(_e.hasRunningTasks&&!M.isCancellationRequested&&await T.Event.toPromise(_e.onEnd),_e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};e.ExtHostTesting=r,e.ExtHostTesting=r=Ve([We(0,g.IExtHostRpcService)],r);const s=1e4;var i;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(i||(i={}));class o extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,z,M,N){super(),this.dto=U,this.proxy=z,this.extension=M,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(N));const ee=this._register(new R.RunOnceScheduler(()=>this.forciblyEndTasks(),s));this._register(this.cts.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const z=this.dto.id,M=this.dto.controllerId,N=(0,a.generateUuid)(),ee=new I(this.proxy,z,N),Q=Y=>(ue,..._e)=>{if(ye){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(ue)&&(this.ensureTestIsKnown(ue),Y(ue,..._e))},Se=(Y,ue)=>{const _e=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(_e.some(ce=>ce.contextValue!==void 0)&&(0,p.checkProposedApiEnabled)(this.extension,"testMessageContextValue"),Y.uri&&Y.range){const ce={range:t.Range.from(Y.range),uri:Y.uri};for(const pe of _e)pe.location=pe.location||ce}this.proxy.$appendTestMessagesInRun(z,N,l.TestId.fromExtHostTestItem(Y,M).toString(),_e)};let ye=!1;const Pe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(Y){ee.coverageProvider=Y},enqueued:Q(Y=>{this.proxy.$updateTestStateInRun(z,N,l.TestId.fromExtHostTestItem(Y,M).toString(),1)}),skipped:Q(Y=>{this.proxy.$updateTestStateInRun(z,N,l.TestId.fromExtHostTestItem(Y,M).toString(),5)}),started:Q(Y=>{this.proxy.$updateTestStateInRun(z,N,l.TestId.fromExtHostTestItem(Y,M).toString(),2)}),errored:Q((Y,ue,_e)=>{Se(Y,ue),this.proxy.$updateTestStateInRun(z,N,l.TestId.fromExtHostTestItem(Y,M).toString(),6,_e)}),failed:Q((Y,ue,_e)=>{Se(Y,ue),this.proxy.$updateTestStateInRun(z,N,l.TestId.fromExtHostTestItem(Y,M).toString(),4,_e)}),passed:Q((Y,ue)=>{this.proxy.$updateTestStateInRun(z,N,l.TestId.fromExtHostTestItem(Y,this.dto.controllerId).toString(),3,ue)}),appendOutput:(Y,ue,_e)=>{ye||(_e&&(this.dto.isIncluded(_e)?this.ensureTestIsKnown(_e):_e=void 0),this.proxy.$appendOutputToRun(z,N,k.VSBuffer.fromString(Y),ue&&t.location.from(ue),_e&&l.TestId.fromExtHostTestItem(_e,M).toString()))},end:()=>{ye||(ye=!0,this.proxy.$finishedTestRunTask(z,N),this.tasks.delete(N),this.tasks.size||this.markEnded())}};return this.tasks.set(N,{run:Pe,coverage:ee}),this.proxy.$startedTestRunTask(z,{id:N,name:U,running:!0}),Pe}forciblyEndTasks(){for(const{run:U}of this.tasks.values())U.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(U){if(!(U instanceof f.TestItemImpl))throw new E.InvalidTestItemError(U.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const z=[],M=this.dto.colllection.root;for(;;){const N=t.TestItem.from(U);if(z.unshift(N),this.sharedTestIds.has(N.extId)||(this.sharedTestIds.add(N.extId),U===M))break;U=U.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,z)}dispose(){this.markEnded(),super.dispose()}}class S{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,z,M,N){return this.getTracker(U,z,M,N)}cancelRunById(U){for(const z of this.tracked.values())if(z.id===U){z.cancel();return}}cancelAllRuns(){for(const U of this.tracked.values())U.cancel()}createTestRun(U,z,M,N,ee,Q){const Se=this.tracked.get(N);if(Se)return Se.createRun(ee);const ye=C.fromPublic(z,M,N,Q),Pe=b(N);this.proxy.$startedExtensionTestRun({controllerId:z,continuous:!!N.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(ue=>l.TestId.fromExtHostTestItem(ue,M.root.id).toString())??[],id:ye.id,include:N.include?.map(ue=>l.TestId.fromExtHostTestItem(ue,M.root.id).toString())??[M.root.id],persist:Q});const Y=this.getTracker(N,ye,U);return T.Event.once(Y.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ye.id),Y.dispose()}),Y.createRun(ee)}getTracker(U,z,M,N){const ee=new o(z,this.proxy,M,N);return this.tracked.set(U,ee),T.Event.once(ee.onEnd)(()=>this.tracked.delete(U)),ee}}e.TestRunCoordinator=S;const b=H=>{if(H.profile){if(!(H.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class C{static fromPublic(U,z,M,N){return new C(U,(0,a.generateUuid)(),M.include?.map(ee=>l.TestId.fromExtHostTestItem(ee,U).toString())??[U],M.exclude?.map(ee=>l.TestId.fromExtHostTestItem(ee,U).toString())??[],N,z)}static fromInternal(U,z){return new C(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,z)}constructor(U,z,M,N,ee,Q){this.controllerId=U,this.id=z,this.isPersisted=ee,this.colllection=Q,this.includePrefix=M.map(Se=>Se+"\0"),this.excludePrefix=N.map(Se=>Se+"\0")}isIncluded(U){const z=l.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(z===M||z.startsWith(M))return!1;for(const M of this.includePrefix)if(z===M||z.startsWith(M))return!0;return!1}}e.TestRunDto=C;class I{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,z,M){this.proxy=U,this.runId=z,this.taskId=M}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(z){throw this.fileCoverage=void 0,z}}async resolveFileCoverage(U,z){const M=await this.fileCoverage;let N=M?.[U];return!this._coverageProvider||!M||!N?[]:(N.detailedCoverage||(N=M[U]=await this._coverageProvider.resolveFileCoverage?.(N,z)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class c{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const z=l.TestId.parentId(U.item.extId);if(z&&this.alreadyRemoved.has(z.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:z,removed:M}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...z].map(N=>N.revived)},get removed(){return[...M].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,z){return{...U,revived:t.TestItem.toPlain(U.item),depth:z?z.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}class u{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(z=>z.revived)},dispose:(0,d.createSingleCallFunction)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class A{#e;#t;get label(){return this._label}set label(U){U!==this._label&&(this._label=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(U){U!==this._supportsContinuousRun&&(this._supportsContinuousRun=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,z,M,N,ee,Q,Se,ye=!1,Pe=void 0,Y=!1){this.controllerId=M,this.profileId=N,this._label=ee,this.kind=Q,this.runHandler=Se,this._isDefault=ye,this._tag=Pe,this._supportsContinuousRun=Y,this.#e=U,this.#t=z,z.set(N,this);const ue=B[Q];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:M,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:ue,isDefault:ye,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=A;const B={[n.TestRunProfileKind.Coverage]:8,[n.TestRunProfileKind.Debug]:4,[n.TestRunProfileKind.Run]:2}}),define(Te[254],Ae([1,0,18,9,5,3,105,8,7]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(_,a){this._extHostDocumentsAndEditors=a,this._onDidChangeTextEditorSelection=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new k.Emitter({onListenerError:R.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=_.getProxy(F.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(_){const a=this._extHostDocumentsAndEditors.allEditors();return _?a:a.map(v=>v.value)}async showTextDocument(_,a,v){let g;typeof a=="number"?g={position:d.ViewColumn.from(a),preserveFocus:v}:typeof a=="object"?g={position:d.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?d.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:g={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(_.uri,g),t=f&&this._extHostDocumentsAndEditors.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}createTextEditorDecorationType(_,a){return new T.TextEditorDecorationType(this._proxy,_,a).value}$acceptEditorPropertiesChanged(_,a){const v=this._extHostDocumentsAndEditors.getEditor(_);if(!v)throw new Error("unknown text editor");if(a.options&&v._acceptOptions(a.options),a.selections){const g=a.selections.selections.map(d.Selection.to);v._acceptSelections(g)}if(a.visibleRanges){const g=w.coalesce(a.visibleRanges.map(d.Range.to));v._acceptVisibleRanges(g)}if(a.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...a.options,lineNumbers:d.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const g=y.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(d.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:f,kind:g})}if(a.visibleRanges){const g=w.coalesce(a.visibleRanges.map(d.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:g})}}$acceptEditorPositionData(_){for(const a in _){const v=this._extHostDocumentsAndEditors.getEditor(a);if(!v)throw new Error("Unknown text editor");const g=d.ViewColumn.to(_[a]);v.value.viewColumn!==g&&(v._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:g}))}}getDiffInformation(_){return Promise.resolve(this._proxy.$getDiffInformation(_))}}e.ExtHostEditors=m}),define(Te[255],Ae([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class P{constructor(v,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=v.getProxy(k.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this._providers.get(f.source)&&y.ExtensionIdentifier.equals(t,this._providers.get(f.source)?.extension)){const n=f.uri===void 0?void 0:w.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(_(n))?.get(f.handle)}else return;return f}})}async $getTimeline(v,g,f,t){return this._providers.get(v)?.provider.provideTimeline(w.URI.revive(g),f,t)}registerTimelineProvider(v,g,f,t){const n=new F.DisposableStore,l=this.convertTimelineItem(g.id,t,n).bind(this);let E;g.onDidChange&&(E=g.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:g.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:v,onDidChange:void 0,async provideTimeline(p,r,s){r?.resetCache&&(n.clear(),D.get(g.id)?.clear());const i=await g.provideTimeline(p,r,s);if(i==null)return;const o=l(p,r);return{...i,source:g.id,items:i.items.map(o)}},dispose(){for(const p of D.values())p.get(g.id)?.clear();E?.dispose(),n.dispose()}},f)}convertTimelineItem(v,g,f){return(t,n)=>{let l;if(n?.cacheResults){let E=this._itemsBySourceAndUriMap.get(v);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(v,E));const D=_(t);l=E.get(D),l===void 0&&(l=new Map,E.set(D,l))}return E=>{const{iconPath:D,...p}=E,r=`${v}|${E.id??E.timestamp}`;l?.set(r,E);let s,i,o;E.iconPath&&(D instanceof T.ThemeIcon?o={id:D.id,color:D.color}:w.URI.isUri(D)?(s=D,i=D):{light:s,dark:i}=D);let S;return T.MarkdownString.isMarkdownString(p.tooltip)?S=d.MarkdownString.from(p.tooltip):(0,m.isString)(p.tooltip)?S=p.tooltip:T.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=d.MarkdownString.from(p.detail)):(0,m.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=p.detail),{...p,id:p.id??void 0,handle:r,source:v,command:E.command?g.toInternal(E.command,f):void 0,icon:s,iconDark:i,themeIcon:o,tooltip:S,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(v,g){if(this._providers.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this._proxy.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this._providers.set(v.id,{provider:v,extension:g}),(0,F.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(v.id)?.clear();this._providers.delete(v.id),this._proxy.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=P;function _(a){return a?.toString()}}),define(Te[86],Ae([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class v extends y.DisposableTunnel{}var g;(function(t){function n(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:E.protocol}}t.fromApiTunnel=n;function l(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==y.TunnelPrivacyId.ConstantPrivate&&E.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}t.fromServiceTunnel=l})(g||(e.TunnelDtoConverter=g={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let f=class extends k.Disposable{constructor(n,l,E){super(),this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new R.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=n.getProxy(m.MainContext.MainThreadTunnelService)}async openTunnel(n,l){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(l,n.displayName);if(E){const D=new v(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(D),D}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(n,l){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:n,provider:l}),this._proxy.$registerPortsAttributesProvider(n,E),new a.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(n,l,E,D,p){const r=[];for(const i of n){const o=this._portAttributesProviders.get(i);if(!o)return[];r.push(...await Promise.all(l.map(async S=>{let b;try{b=await o.provider.providePortAttributes({port:S,pid:E,commandLine:D},p)}catch{b=await o.provider.providePortAttributes(S,E,D,p)}return{providedAttributes:b,port:S}})))}const s=r.filter(i=>!!i.providedAttributes);return s.length>0?s.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,l){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(D,p)=>await n.provideTunnel(D,p,new w.CancellationTokenSource().token)??void 0;const E=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(E),Promise.resolve((0,k.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,l){if(n){n.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this._showCandidatePort=n.showCandidatePort,this._proxy.$setCandidateFilter());const E=n.tunnelFactory??(l?this.makeManagedTunnelFactory(l):void 0);if(E){this._forwardPortProvider=E;let D=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&D.length===0&&(D=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const p=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:D}:void 0;this._proxy.$setTunnelProvider(p)}}else this._forwardPortProvider=void 0;return(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(n){}async $closeTunnel(n,l){if(this._extensionTunnels.has(n.host)){const E=this._extensionTunnels.get(n.host);E.has(n.port)&&(l&&E.get(n.port).disposeListener.dispose(),await E.get(n.port).tunnel.dispose(),E.delete(n.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(n,l){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(n,l);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const D=await E;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),D===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(n.remoteAddress.host)||this._extensionTunnels.set(n.remoteAddress.host,new Map);const p=this._register(D.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(D.remoteAddress))));return this._extensionTunnels.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:D,disposeListener:p}),g.fromApiTunnel(D)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),E instanceof Error)return E.message}}async $applyCandidateFilter(n){const l=await Promise.all(n.map(D=>this._showCandidatePort(D.host,D.port,D.detail??""))),E=n.filter((D,p)=>l[p]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(D=>D.port).join(", ")} to ${E.map(D=>D.port).join(", ")}`),E}};e.ExtHostTunnelService=f,e.ExtHostTunnelService=f=Ve([We(0,_.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,d.ILogService)],f)}),define(Te[256],Ae([1,0,6,13,2,3]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,m,P,_){if(this._openers.has(m))throw new Error(`Opener with id '${m}' already registered`);const a=_.schemes.find(v=>!T.supportedSchemes.has(v));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(m,P),this._proxy.$registerUriOpener(m,_.schemes,y,_.label),(0,w.toDisposable)(()=>{this._openers.delete(m),this._proxy.$unregisterUriOpener(m)})}async $canOpenUri(y,m,P){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener with id: ${y}`);const a=k.URI.revive(m);return _.canOpenExternalUri(a,P)}async $openUri(y,m,P){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener id: '${y}'`);return _.openExternalUri(k.URI.revive(m.resolvedUri),{sourceUri:k.URI.revive(m.sourceUri)},P)}}e.ExtHostUriOpeners=T}),define(Te[257],Ae([1,0,3,2,6,9,20]),function(be,e,w,R,k,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class d{static{this.HandlePool=0}constructor(m){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=m.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(m,P){const _=m.identifier;if(this.handles.has(_))throw new Error(`Protocol handler already registered for extension ${_}`);const a=d.HandlePool++;return this.handles.add(_),this.handlers.set(a,P),this._proxy.$registerUriHandler(a,_,m.displayName||m.name),(0,k.toDisposable)(()=>{this.handles.delete(_),this.handlers.delete(a),this._proxy.$unregisterUriHandler(a)})}$handleExternalUri(m,P){const _=this.handlers.get(m);if(!_)return Promise.resolve(void 0);try{_.handleUri(R.URI.revive(P))}catch(a){(0,F.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(m){return R.URI.revive(await this._proxy.$createAppUri(m))}}e.ExtHostUrls=d}),define(Te[64],Ae([1,0,5,6,13,24,2,169,191,77,3]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(D,p,r,s,i,o,S){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new w.Emitter,this._onDidDispose=this.#d.event,this.#e=D,this.#t=p,this.#r=r,this.#u=s,this.#l=i,this.#n=o,this.#c=a(o),this.#h=v(o),this.#i=S}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return this.#a=!0,(0,m.asWebviewUri)(D,this.#u)}get cspSource(){const D=this.#n.extensionLocation;if(D.scheme===k.Schemas.https||D.scheme===k.Schemas.http){let p=D.toString();return p.endsWith("/")||(p+="/"),p+" "+m.webviewGenericCspSource}return m.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(D){this.assertNotDisposed(),this.#s!==D&&(this.#s=D,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(D)))}get options(){return this.assertNotDisposed(),this.#r}set options(D){this.assertNotDisposed(),F.equals(this.#r,D)||this.#t.$setOptions(this.#e,t(this.#n,this.#l,D)),this.#r=D}async postMessage(D){if(this.#o)return!1;const p=(0,y.serializeWebviewMessage)(D,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,p.message,...p.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(D){if(!this.#h)return D;const p=this.#n.extensionLocation?.scheme===k.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===k.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,S,b,C)=>{const I=T.URI.from({scheme:S||"file",path:decodeURIComponent(b)}),c=(0,m.asWebviewUri)(I,{isRemote:p,authority:r}).toString();return`${i}${c}${C}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,S,b,C)=>{const I=T.URI.from({scheme:S||"file",path:decodeURIComponent(b)}),c=(0,m.asWebviewUri)(I,{isRemote:p,authority:r}).toString();return`${i}${c}${C}`})}}e.ExtHostWebview=_;function a(E){try{const D=(0,d.normalizeVersion)((0,d.parseVersion)(E.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function v(E){try{const D=(0,d.normalizeVersion)((0,d.parseVersion)(E.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class g extends R.Disposable{constructor(D,p,r,s,i){super(),this.remoteInfo=p,this.workspace=r,this._logService=s,this._deprecationService=i,this._webviews=new Map,this._webviewProxy=D.getProxy(P.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const D of this._webviews.values())D.dispose();this._webviews.clear()}$onMessage(D,p,r){const s=this.getWebview(D);if(s){const{message:i}=(0,y.deserializeWebviewMessage)(p,r.value);s._onMessageEmitter.fire(i)}}$onMissingCsp(D,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,p,r){const s=new _(D,this._webviewProxy,n(p),this.remoteInfo,this.workspace,r,this._deprecationService);this._webviews.set(D,s);const i=s._onDidDispose(()=>{i.dispose(),this.deleteWebview(D)});return s}deleteWebview(D){this._webviews.delete(D)}getWebview(D){return this._webviews.get(D)}}e.ExtHostWebviews=g;function f(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=f;function t(E,D,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||l(E,D)}}e.serializeWebviewOptions=t;function n(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(D=>T.URI.from(D))}}function l(E,D){return[...(D?.getWorkspaceFolders()||[]).map(p=>p.uri),E.extensionLocation]}}),define(Te[258],Ae([1,0,21,93,6,13,23,2,8,64,55,3,7]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(s,i){this.document=s,this._storagePath=i,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,i){await this.getEdit(s).undo(),i||this.disposeBackup()}async redo(s,i){await this.getEdit(s).redo(),i||this.disposeBackup()}disposeEdits(s){for(const i of s)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const i=this._edits.get(s,0);if(!i)throw new Error("No edit found");return i}}class g{constructor(){this._documents=new Map}get(s,i){return this._documents.get(this.key(s,i))}add(s,i,o){const S=this.key(s,i.uri);if(this._documents.has(S))throw new Error(`Document already exists for viewType:${s} resource:${i.uri}`);const b=new v(i,o);return this._documents.set(S,b),b}delete(s,i){const o=this.key(s,i.uri);this._documents.delete(o)}key(s,i){return`${s}@@@${i}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this._providers=new Map}addTextProvider(s,i,o){return this.add(0,s,i,o)}addCustomProvider(s,i,o){return this.add(1,s,i,o)}get(s){return this._providers.get(s)}add(s,i,o,S){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:s,extension:o,provider:S}),new a.Disposable(()=>this._providers.delete(i))}}class n{constructor(s,i,o,S,b){this._extHostDocuments=i,this._extensionStoragePaths=o,this._extHostWebview=S,this._extHostWebviewPanels=b,this._editorProviders=new t,this._documents=new g,this._proxy=s.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,i,o,S){const b=new k.DisposableStore;return E(o)?(b.add(this._editorProviders.addTextProvider(i,s,o)),this._proxy.$registerTextEditorProvider((0,m.toExtensionData)(s),i,S.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(s))):(b.add(this._editorProviders.addCustomProvider(i,s,o)),l(o)&&b.add(o.onDidChangeCustomDocument(C=>{const I=this.getCustomDocumentEntry(i,C.document.uri);if(D(C)){const c=I.addEdit(C);this._proxy.$onDidEdit(C.document.uri,i,c,C.label)}else this._proxy.$onContentChange(C.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,m.toExtensionData)(s),i,S.webviewOptions||{},!!S.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(s))),a.Disposable.from(b,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(s,i,o,S,b){const C=this._editorProviders.get(i);if(!C)throw new Error(`No provider found for '${i}'`);if(C.type!==1)throw new Error(`Invalid provide type for '${i}'`);const I=d.URI.revive(s),c=await C.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:S?.buffer},b);let h;return l(C.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(C.extension)??this._extensionStoragePaths.globalValue(C.extension)),this._documents.add(i,c,h),{editable:l(C.provider)}}async $disposeCustomDocument(s,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const S=d.URI.revive(s),{document:b}=this.getCustomDocumentEntry(i,S);this._documents.delete(i,b),b.dispose()}async $resolveCustomEditor(s,i,o,S,b,C){const I=this._editorProviders.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const c=y.ViewColumn.to(b),h=this._extHostWebview.createNewWebview(i,S.contentOptions,I.extension),u=this._extHostWebviewPanels.createNewWebviewPanel(i,o,S.title,c,S.options,h,S.active),A=d.URI.revive(s);switch(I.type){case 1:{const{document:B}=this.getCustomDocumentEntry(o,A);return I.provider.resolveCustomEditor(B,u,C)}case 0:{const B=this._extHostDocuments.getDocument(A);return I.provider.resolveCustomTextEditor(B,u,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,i,o){this.getCustomDocumentEntry(i,s).disposeEdits(o)}async $onMoveCustomEditor(s,i,o){const S=this._editorProviders.get(o);if(!S)throw new Error(`No provider found for '${o}'`);if(!S.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const b=this._extHostWebviewPanels.getWebviewPanel(s);if(!b)throw new Error("No webview found");const C=d.URI.revive(i),I=this._extHostDocuments.getDocument(C);await S.provider.moveCustomTextEditor(I,b,w.CancellationToken.None)}async $undo(s,i,o,S){return this.getCustomDocumentEntry(i,s).undo(o,S)}async $redo(s,i,o,S){return this.getCustomDocumentEntry(i,s).redo(o,S)}async $revert(s,i,o){const S=this.getCustomDocumentEntry(i,s);await this.getCustomEditorProvider(i).revertCustomDocument(S.document,o),S.disposeBackup()}async $onSave(s,i,o){const S=this.getCustomDocumentEntry(i,s);await this.getCustomEditorProvider(i).saveCustomDocument(S.document,o),S.disposeBackup()}async $onSaveAs(s,i,o,S){const b=this.getCustomDocumentEntry(i,s);return this.getCustomEditorProvider(i).saveCustomDocumentAs(b.document,d.URI.revive(o),S)}async $backup(s,i,o){const S=this.getCustomDocumentEntry(i,s),C=await this.getCustomEditorProvider(i).backupCustomDocument(S.document,{destination:S.getNewBackupUri()},o);return S.updateBackup(C),C.id}getCustomDocumentEntry(s,i){const o=this._documents.get(s,d.URI.revive(i));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(s){const o=this._editorProviders.get(s)?.provider;if(!o||!l(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=n;function l(r){return!!r.onDidChangeCustomDocument}function E(r){return typeof r.resolveCustomTextEditor=="function"}function D(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function p(r){const s=r.scheme===F.Schemas.file||r.scheme===F.Schemas.untitled?r.fsPath:r.toString();return(0,R.hash)(s)+""}}),define(Te[259],Ae([1,0,5,6,2,36,8,64,3,7]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends R.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(g,f,t,n){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new w.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new w.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=g,this.#t=f,this.#u=t,this.#i=n.viewType,this.#l=n.panelOptions,this.#r=n.viewColumn,this.#n=n.title,this.#a=n.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(g){this.assertNotDisposed(),this.#n!==g&&(this.#n=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(g){this.assertNotDisposed(),this.#s!==g&&(this.#s=g,this.#t.$setIconPath(this.#e,k.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(g){this.#c||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#a=g.active,this.#o=g.visible,this.#r=g.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(g,f){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:T.ViewColumn.from(g),preserveFocus:!!f})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class _ extends R.Disposable{static newHandle(){return(0,F.generateUuid)()}constructor(g,f,t){super(),this.webviews=f,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(y.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(g=>g.dispose()),this._webviewPanels.clear()}createWebviewPanel(g,f,t,n,l={}){const E=typeof n=="object"?n.viewColumn:n,D={viewColumn:T.ViewColumn.from(E),preserveFocus:typeof n=="object"&&!!n.preserveFocus},p=(0,d.shouldSerializeBuffersForPostMessage)(g),r=_.newHandle();this._proxy.$createWebviewPanel((0,d.toExtensionData)(g),r,f,{title:t,panelOptions:a(l),webviewOptions:(0,d.serializeWebviewOptions)(g,this.workspace,l),serializeBuffersForPostMessage:p},D);const s=this.webviews.createNewWebview(r,l,g);return this.createNewWebviewPanel(r,f,t,E,l,s,!0)}$onDidChangeWebviewPanelViewStates(g){const f=Object.keys(g);f.sort((t,n)=>{const l=g[t],E=g[n];return l.active?1:E.active?-1:+l.visible-+E.visible});for(const t of f){const n=this.getWebviewPanel(t);if(!n)continue;const l=g[t];n._updateViewState({active:l.active,visible:l.visible,viewColumn:T.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,f,t){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:t,extension:g}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,d.shouldSerializeBuffersForPostMessage)(g)}),new m.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(g,f,t,n){const l=this._serializers.get(f);if(!l)throw new Error(`No serializer found for '${f}'`);const{serializer:E,extension:D}=l,p=this.webviews.createNewWebview(g,t.webviewOptions,D),r=this.createNewWebviewPanel(g,f,t.title,n,t.panelOptions,p,t.active);await E.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(g,f,t,n,l,E,D){const p=new P(g,this._proxy,E,{viewType:f,title:t,viewColumn:n,panelOptions:l,active:D});return this._webviewPanels.set(g,p),p}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=_;function a(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Te[260],Ae([1,0,5,6,64,8,3,7]),function(be,e,w,R,k,F,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends R.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(_,a,v,g,f,t){super(),this.#l=!1,this.#a=this._register(new w.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new w.Emitter),this.onDidDispose=this.#c.event,this.#i=v,this.#s=g,this.#e=_,this.#t=a,this.#u=f,this.#n=t}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(_){this.assertNotDisposed(),this.#s!==_&&(this.#s=_,this.#t.$setWebviewViewTitle(this.#e,_))}get description(){return this.assertNotDisposed(),this.#r}set description(_){this.assertNotDisposed(),this.#r!==_&&(this.#r=_,this.#t.$setWebviewViewDescription(this.#e,_))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(_){_===this.#n||this.#l||(this.#n=_,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(_){this.assertNotDisposed(),!(_?.value===this.#o?.value&&_?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(_),this.#t.$setWebviewViewBadge(this.#e,_))}show(_){this.assertNotDisposed(),this.#t.$show(this.#e,!!_)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class m{constructor(_,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(_,a,v,g){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:v,extension:_}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(_),a,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(_)}),new d.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(_,a,v,g,f){const t=this._viewProviders.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:n,extension:l}=t,E=this._extHostWebview.createNewWebview(_,{},l),D=new y(_,this._proxy,a,v,E,!0);this._webviewViews.set(_,D),await n.resolveWebviewView(D,{state:g},f)}async $onDidChangeWebviewViewVisibility(_,a){this.getWebviewView(_)._setVisible(a)}async $disposeWebviewView(_){const a=this.getWebviewView(_);this._webviewViews.delete(_),a.dispose(),this._extHostWebview.deleteWebview(_)}getWebviewView(_){const a=this._webviewViews.get(_);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=m}),define(Te[108],Ae([1,0,5,3,2,13,15,4,17,26]),function(be,e,w,R,k,F,T,d,y,m){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let _=class{static{P=this}static{this.InitialState={focused:!0,active:!0}}getState(v){const g=this._state;return{get focused(){return g.focused},get active(){return(0,m.checkProposedApiEnabled)(v,"windowActivity"),g.active}}}constructor(v){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=P.InitialState,this._proxy=v.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:g,isActive:f})=>{this.onDidChangeWindowProperty("focused",g),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,g){g!==this._state[v]&&(this._state={...this._state,[v]:g},this._onDidChangeWindowState.fire(this._state))}openUri(v,g){let f;if(typeof v=="string"){f=v;try{v=k.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,T.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,f,g)}async asExternalUri(v,g){if((0,T.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(v,g);return k.URI.from(f)}};e.ExtHostWindow=_,e.ExtHostWindow=_=P=Ve([We(0,y.IExtHostRpcService)],_),e.IExtHostWindow=(0,d.createDecorator)("IExtHostWindow")}),define(Te[261],Ae([1,0,227,27,17]),function(be,e,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends w.AbstractExtHostConsoleForwarder{constructor(d,y){super(d,y)}_nativeConsoleLogMessage(d,y,m){y.apply(console,m)}};e.ExtHostConsoleForwarder=F,e.ExtHostConsoleForwarder=F=Ve([We(0,k.IExtHostRpcService),We(1,R.IExtHostInitDataService)],F)}),define(Te[262],Ae([1,0,12,25,21,9,5,6,132,215,46]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(u,A){try{return JSON.stringify(u,A)}catch{return"null"}}const v="$$ref$$",g={[v]:-1};class f{constructor(A,B){this.jsonString=A,this.referencedBuffers=B}}function t(u,A=null,B=!1){const H=[];return{jsonString:(B?a:JSON.stringify)(u,(z,M)=>{if(typeof M>"u")return g;if(typeof M=="object"){if(M instanceof R.VSBuffer){const N=H.push(M)-1;return{[v]:N}}if(A)return A(z,M)}return M}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=t;function n(u,A,B){return JSON.parse(u,(H,U)=>{if(U){const z=U[v];if(typeof z=="number")return A[z];if(B&&U.$mid===1)return B.transformIncoming(U)}return U})}e.parseJsonAndRestoreBufferRefs=n;function l(u,A){return JSON.stringify(u,A)}function E(u){return u?(A,B)=>B&&B.$mid===1?u.transformOutgoing(B):B:null}var D;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));var p;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const r=()=>{},s=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends d.Disposable{static{_=s}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(A,B=null,H=null){super(),this[_]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=B,this._uriTransformer=H,this._uriReplacer=E(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,z=P.ProxyIdentifier.count;U<z;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(U=>this._receiveOneMessage(U))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],B.resolveErr(F.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,y.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:B,sid:H}=A;return this._proxies[B]||(this._proxies[B]=this._createProxy(B,H)),this._proxies[B]}_createProxy(A,B){const H={get:(U,z)=>(typeof z=="string"&&!U[z]&&z.charCodeAt(0)===36&&(U[z]=(...M)=>this._remoteCall(A,z,M)),z===i?B:U[z])};return new Proxy(Object.create(null),H)}set(A,B){return this._locals[A.nid]=B,B}assertRegistered(A){for(let B=0,H=A.length;B<H;B++){const U=A[B];if(!this._locals[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}_receiveOneMessage(A){if(this._isDisposed)return;const B=A.byteLength,H=b.read(A,0),U=H.readUInt8(),z=H.readUInt32();switch(U){case 1:case 2:{let{rpcId:M,method:N,args:ee}=I.deserializeRequestJSONArgs(H);this._uriTransformer&&(ee=(0,y.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(B,z,M,N,ee,U===2);break}case 3:case 4:{let{rpcId:M,method:N,args:ee}=I.deserializeRequestMixedArgs(H);this._uriTransformer&&(ee=(0,y.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(B,z,M,N,ee,U===4);break}case 5:{this._logger?.logIncoming(B,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(B,z);break}case 7:{this._receiveReply(B,z,void 0);break}case 9:{let M=I.deserializeReplyOKJSON(H);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(B,z,M);break}case 10:{const M=I.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(B,z,M);break}case 8:{const M=I.deserializeReplyOKVSBuffer(H);this._receiveReply(B,z,M);break}case 11:{let M=I.deserializeReplyErrError(H);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(B,z,M);break}case 12:{this._receiveReplyErr(B,z,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,B,H,U,z,M){this._logger?.logIncoming(A,B,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(H)}.${U}(`,z);const N=String(B);let ee,Q;if(M){const ye=new k.CancellationTokenSource;z.push(ye.token),ee=this._invokeHandler(H,U,z),Q=()=>ye.cancel()}else ee=this._invokeHandler(H,U,z),Q=r;this._cancelInvokedHandlers[N]=Q;const Se=I.serializeAcknowledged(B);this._logger?.logOutgoing(Se.byteLength,B,1,"ack"),this._protocol.send(Se),ee.then(ye=>{delete this._cancelInvokedHandlers[N];const Pe=I.serializeReplyOK(B,ye,this._uriReplacer);this._logger?.logOutgoing(Pe.byteLength,B,1,"reply:",ye),this._protocol.send(Pe)},ye=>{delete this._cancelInvokedHandlers[N];const Pe=I.serializeReplyErr(B,ye);this._logger?.logOutgoing(Pe.byteLength,B,1,"replyErr:",ye),this._protocol.send(Pe)})}_receiveCancel(A,B){this._logger?.logIncoming(A,B,1,"receiveCancel");const H=String(B);this._cancelInvokedHandlers[H]?.()}_receiveReply(A,B,H){this._logger?.logIncoming(A,B,0,"receiveReply:",H);const U=String(B);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const z=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],z.resolveOk(H)}_receiveReplyErr(A,B,H){this._logger?.logIncoming(A,B,0,"receiveReplyErr:",H);const U=String(B);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const z=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let M;H&&(H.$isError?(M=new Error,M.name=H.name,M.message=H.message,M.stack=H.stack):M=H),z.resolveErr(M)}_invokeHandler(A,B,H){try{return Promise.resolve(this._doInvokeHandler(A,B,H))}catch(U){return Promise.reject(U)}}_doInvokeHandler(A,B,H){const U=this._locals[A];if(!U)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(A));const z=U[B];if(typeof z!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.getStringIdentifierForProxy)(A));return z.apply(U,H)}_remoteCall(A,B,H){if(this._isDisposed)return new m.CanceledLazyPromise;let U=null;if(H.length>0&&k.CancellationToken.isCancellationToken(H[H.length-1])&&(U=H.pop()),U&&U.isCancellationRequested)return Promise.reject(F.canceled());const z=I.serializeRequestArguments(H,this._uriReplacer),M=++this._lastMessageId,N=String(M),ee=new m.LazyPromise,Q=new d.DisposableStore;U&&Q.add(U.onCancellationRequested(()=>{const ye=I.serializeCancel(M);this._logger?.logOutgoing(ye.byteLength,M,0,"cancel"),this._protocol.send(I.serializeCancel(M))})),this._pendingRPCReplies[N]=new S(ee,Q),this._onWillSendRequest(M);const Se=I.serializeRequest(M,A,B,z,!!U);return this._logger?.logOutgoing(Se.byteLength,M,0,`request: ${(0,P.getStringIdentifierForProxy)(A)}.${B}(`,H),this._protocol.send(Se),ee}}e.RPCProtocol=o;class S{constructor(A,B){this._promise=A,this._disposable=B}resolveOk(A){this._promise.resolveOk(A),this._disposable.dispose()}resolveErr(A){this._promise.resolveErr(A),this._disposable.dispose()}}class b{static alloc(A,B,H){const U=new b(R.VSBuffer.alloc(H+1+4),0);return U.writeUInt8(A),U.writeUInt32(B),U}static read(A,B){return new b(A,B)}get buffer(){return this._buff}constructor(A,B){this._buff=A,this._offset=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,H}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,H}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,B}static sizeMixedArray(A){let B=0;B+=1;for(let H=0,U=A.length;H<U;H++){const z=A[H];switch(B+=1,z.type){case 1:B+=this.sizeLongString(z.value);break;case 2:B+=this.sizeVSBuffer(z.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(z.value);for(let M=0;M<z.buffers.length;++M)B+=this.sizeVSBuffer(z.buffers[M]);break;case 4:break}}return B}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let B=0,H=A.length;B<H;B++){const U=A[B];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let z=0;z<U.buffers.length;++z)this.writeBuffer(U.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const B=new Array(A);for(let H=0;H<A;H++)switch(this.readUInt8()){case 1:B[H]=this.readLongString();break;case 2:B[H]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),M=this.readLongString(),N=[];for(let ee=0;ee<z;++ee)N.push(this.readVSBuffer());B[H]=new P.SerializableObjectWithBuffers(n(M,N,null));break}case 4:B[H]=void 0;break}return B}}var C;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(C||(C={}));class I{static _useMixedArgSerialization(A){for(let B=0,H=A.length;B<H;B++)if(A[B]instanceof R.VSBuffer||A[B]instanceof P.SerializableObjectWithBuffers||typeof A[B]>"u")return!0;return!1}static serializeRequestArguments(A,B){if(this._useMixedArgSerialization(A)){const H=[];for(let U=0,z=A.length;U<z;U++){const M=A[U];if(M instanceof R.VSBuffer)H[U]={type:2,value:M};else if(typeof M>"u")H[U]={type:4};else if(M instanceof P.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:ee}=t(M.value,B);H[U]={type:3,value:R.VSBuffer.fromString(N),buffers:ee}}else H[U]={type:1,value:R.VSBuffer.fromString(l(M,B))}}return{type:1,args:H}}return{type:0,args:l(A,B)}}static serializeRequest(A,B,H,U,z){switch(U.type){case 0:return this._requestJSONArgs(A,B,H,U.args,z);case 1:return this._requestMixedArgs(A,B,H,U.args,z)}}static _requestJSONArgs(A,B,H,U,z){const M=R.VSBuffer.fromString(H),N=R.VSBuffer.fromString(U);let ee=0;ee+=b.sizeUInt8(),ee+=b.sizeShortString(M),ee+=b.sizeLongString(N);const Q=b.alloc(z?2:1,A,ee);return Q.writeUInt8(B),Q.writeShortString(M),Q.writeLongString(N),Q.buffer}static deserializeRequestJSONArgs(A){const B=A.readUInt8(),H=A.readShortString(),U=A.readLongString();return{rpcId:B,method:H,args:JSON.parse(U)}}static _requestMixedArgs(A,B,H,U,z){const M=R.VSBuffer.fromString(H);let N=0;N+=b.sizeUInt8(),N+=b.sizeShortString(M),N+=b.sizeMixedArray(U);const ee=b.alloc(z?4:3,A,N);return ee.writeUInt8(B),ee.writeShortString(M),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(A){const B=A.readUInt8(),H=A.readShortString(),U=A.readMixedArray(),z=new Array(U.length);for(let M=0,N=U.length;M<N;M++){const ee=U[M];typeof ee=="string"?z[M]=JSON.parse(ee):z[M]=ee}return{rpcId:B,method:H,args:z}}static serializeAcknowledged(A){return b.alloc(5,A,0).buffer}static serializeCancel(A){return b.alloc(6,A,0).buffer}static serializeReplyOK(A,B,H){if(typeof B>"u")return this._serializeReplyOKEmpty(A);if(B instanceof R.VSBuffer)return this._serializeReplyOKVSBuffer(A,B);if(B instanceof P.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:z}=t(B.value,H,!0);return this._serializeReplyOKJSONWithBuffers(A,U,z)}else return this._serializeReplyOKJSON(A,a(B,H))}static _serializeReplyOKEmpty(A){return b.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,B){let H=0;H+=b.sizeVSBuffer(B);const U=b.alloc(8,A,H);return U.writeVSBuffer(B),U.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,B){const H=R.VSBuffer.fromString(B);let U=0;U+=b.sizeLongString(H);const z=b.alloc(9,A,U);return z.writeLongString(H),z.buffer}static _serializeReplyOKJSONWithBuffers(A,B,H){const U=R.VSBuffer.fromString(B);let z=0;z+=b.sizeUInt32,z+=b.sizeLongString(U);for(const N of H)z+=b.sizeVSBuffer(N);const M=b.alloc(10,A,z);M.writeUInt32(H.length),M.writeLongString(U);for(const N of H)M.writeBuffer(N);return M.buffer}static deserializeReplyOKJSON(A){const B=A.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(A,B){const H=A.readUInt32(),U=A.readLongString(),z=[];for(let M=0;M<H;++M)z.push(A.readVSBuffer());return new P.SerializableObjectWithBuffers(n(U,z,B))}static serializeReplyErr(A,B){const H=B?a(F.transformErrorForSerialization(B),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(A);const U=R.VSBuffer.fromString(H);let z=0;z+=b.sizeLongString(U);const M=b.alloc(11,A,z);return M.writeLongString(U),M.buffer}static deserializeReplyErrError(A){const B=A.readLongString();return JSON.parse(B)}static _serializeReplyErrEmpty(A){return b.alloc(12,A,0).buffer}}var c;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var h;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(h||(h={}))}),define(Te[263],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(F){const T=d=>{globalThis.removeEventListener("message",T);const y=d.data;Object.defineProperties(globalThis,{postMessage:{value(m,P){y.postMessage(m,P)}},onmessage:{get(){return y.onmessage},set(m){y.onmessage=m}}}),y.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",T)}.toString();class R extends EventTarget{constructor(F,T,d){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${T}'))`,m=new Blob([y],{type:"application/javascript"}),P=URL.createObjectURL(m),_=new MessageChannel,a=P,v={type:"_newWorker",id:a,port:_.port2,url:P,options:d};F(v,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{F({type:"_terminateWorker",id:a}),URL.revokeObjectURL(P),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(g){_.port1.onmessage=g}},onmessageerror:{get(){return _.port1.onmessageerror},set(g){_.port1.onmessageerror=g}}}),_.port1.addEventListener("messageerror",g=>{const f=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(f)}),_.port1.addEventListener("message",g=>{const f=new MessageEvent("message",{data:g.data});this.dispatchEvent(f)}),_.port1.start()}}e.NestedWorker=R}),define(Te[264],Ae([1,0,5,30,32,4]),function(be,e,w,R,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class d{constructor(){this.channels=new Map,this._onDidRegisterChannel=new w.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new w.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(P=>m.push(P)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}R.Registry.add(e.Extensions.OutputChannels,new d),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(Te[109],Ae([1,0,3,4,17,20,14,264,62,27,39,129,25,16,38,5,6]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class n extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,r,s,i,o){super(),this.id=p,this.name=r,this.logger=s,this.proxy=i,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(s.getLevel()),this._register(s.onDidChangeLogLevel(S=>this.setLevel(S)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,d.OutputChannelUpdateMode.Clear,p)}replace(p){const r=this.offset;this.info(p),this.proxy.$update(this.id,d.OutputChannelUpdateMode.Replace,r),this.visible&&this.logger.flush()}show(p,r){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:r))}hide(){this.proxy.$close(this.id)}log(p,r){this.offset+=a.VSBuffer.fromString(r).byteLength,(0,T.log)(this.logger,p,r),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,d.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class l extends n{appendLine(p){this.append(p)}}let E=class{constructor(p,r,s,i,o,S){this.initData=r,this.extHostFileSystem=s,this.extHostFileSystemInfo=i,this.loggerService=o,this.logService=S,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(w.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(r.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[r,s]of this.channels)s.visible=r===this.visibleChannelId}createOutputChannel(p,r,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,o=(0,v.isString)(r)?r:void 0;if((0,v.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let S;const b=this.initData.environment.extensionLogLevel?.find(([I])=>F.ExtensionIdentifier.equals(s.identifier,I))?.[1];b&&(S=(0,T.parseLogLevel)(b));const C=i?this.doCreateLogOutputChannel(p,S,s):this.doCreateOutputChannel(p,o,s);return C.then(I=>{this.channels.set(I.id,I),I.visible=I.id===this.visibleChannelId}),i?this.createExtHostLogOutputChannel(p,S??this.logService.getLevel(),C):this.createExtHostOutputChannel(p,C)}async doCreateOutputChannel(p,r,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const i=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(i,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),S=this.loggerService.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.proxy.$register(p,o,r,s.identifier.value);return new n(b,p,S,this.proxy,s)}async doCreateLogOutputChannel(p,r,s){const i=await this.createExtensionLogDirectory(s),o=p.replace(/[\\/:\*\?"<>\|]/g,""),S=this.extHostFileSystemInfo.extUri.joinPath(i,`${o}.log`),b=`${s.identifier.value}.${o}`,C=this.loggerService.createLogger(S,{id:b,name:p,logLevel:r,extensionId:s.identifier.value});return new l(b,p,C,this.proxy,s)}createExtensionLogDirectory(p){let r=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!r){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,r=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}return s})())}return r}createExtHostOutputChannel(p,r){let s=!1;const i=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(o){i(),r.then(S=>S.append(o))},appendLine(o){i(),r.then(S=>S.appendLine(o))},clear(){i(),r.then(o=>o.clear())},replace(o){i(),r.then(S=>S.replace(o))},show(o,S){i(),r.then(b=>b.show(o,S))},hide(){i(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}createExtHostLogOutputChannel(p,r,s){const i=new t.DisposableStore,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},S=i.add(new f.Emitter);function b(C){r=C,S.fire(C)}return s.then(C=>{i.add(C),C.logLevel!==r&&b(C.logLevel),i.add(C.onDidChangeLogLevel(I=>b(I)))}),{...this.createExtHostOutputChannel(p,s),get logLevel(){return r},onDidChangeLogLevel:S.event,trace(C,...I){o(),s.then(c=>c.trace(C,...I))},debug(C,...I){o(),s.then(c=>c.debug(C,...I))},info(C,...I){o(),s.then(c=>c.info(C,...I))},warn(C,...I){o(),s.then(c=>c.warn(C,...I))},error(C,...I){o(),s.then(c=>c.error(C,...I))},dispose(){i.dispose()}}}};e.ExtHostOutputService=E,e.ExtHostOutputService=E=Ve([We(0,k.IExtHostRpcService),We(1,m.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,P.IExtHostFileSystemInfo),We(4,T.ILoggerService),We(5,T.ILogService)],E),e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(Te[265],Ae([1,0,4,12]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let F=1/0;for(let d=0;d<this.maxSampleCount;d++){const y=await k.getRoundTripTime();if(y===void 0)return;F=Math.min(F,y/2),await(0,R.timeout)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(F):T=this.initial.reduce((d,y)=>d+y,0)/this.initial.length,this.lastMeasurement={initial:T,current:F,average:this.average.reduce((d,y)=>d+y,0)/this.average.length,high:(()=>typeof T>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Te[266],Ae([1,0,42,13,19,22,23,2,4,186,54,208,265]),function(be,e,w,R,k,F,T,d,y,m,P,_,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let g=v=class{constructor(t,n,l,E){this.localUserHome=t,this.remoteAgentService=n,this.environmentService=l,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||F.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome??t})()}hasValidBasename(t,n,l){return typeof n=="string"||typeof n>"u"?this.resolveOS.then(E=>this.doHasValidBasename(t,E,n)):this.doHasValidBasename(t,n,l)}doHasValidBasename(t,n,l){return t.scheme===R.Schemas.file||t.scheme===R.Schemas.vscodeRemote?(0,w.isValidBasename)(l??(0,T.basename)(t),n===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,n){if(t.remoteAuthority)return R.Schemas.vscodeRemote;const l=(0,m.getVirtualWorkspaceScheme)(n.getWorkspace());if(l)return l;const E=n.getWorkspace().folders[0];if(E)return E.uri.scheme;const D=n.getWorkspace().configuration;return D?D.scheme:R.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?k.win32:k.posix)}async fileURI(t){let n="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const E=t.indexOf("/",2);E===-1?(n=t.substring(2),t="/"):(n=t.substring(2,E),t=t.substring(E)||"/")}return d.URI.from({scheme:R.Schemas.file,authority:n,path:t,query:"",fragment:""})}};e.AbstractPathService=g,e.AbstractPathService=g=v=Ve([We(1,a.IRemoteAgentService),We(2,_.IWorkbenchEnvironmentService),We(3,P.IWorkspaceContextService)],g)}),define(Te[110],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(T,d){this.line=T,this.character=d}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,d){return new w(0,0)}with(T){return new w(0,0)}}e.Position=w;class R{constructor(T,d,y,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(T,d),this.end=new w(y,m)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new R(0,0,0,0)}with(T){return new R(0,0,0,0)}}e.Range=R;var k;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(Te[47],Ae([1,0,18,37,24,42,15,4,19,9,110,12]),function(be,e,w,R,k,F,T,d,y,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",v=" characters skipped \u27EB",g=(a.length+v.length+5)*2;e.ISearchService=(0,d.createDecorator)("searchService");var f;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function n(Y){return!!Y.preview}e.resultIsMatch=n;function l(Y){return!!Y.resource}e.isFileMatch=l;function E(Y){return!!Y.message}e.isProgressMessage=E;var D;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(D||(e.SearchCompletionExitCode=D={}));class p{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=p;class r{constructor(ue,_e,ce,pe){this.ranges=_e,this.webviewIndex=pe;const ie=Array.isArray(_e)?_e:[_e];if(ce&&ce.matchLines===1&&s(ie)){ue=(0,T.getNLines)(ue,ce.matchLines);let x="",W=0,le=0;const we=Math.floor(ce.charsPerLine/5),Ee=[];for(const me of ie){const De=Math.max(me.startColumn-we,0),re=me.startColumn+ce.charsPerLine;if(De>le+we+g){const de=a+(De-le)+v;x+=de+ue.slice(De,re),W+=De-(le+de.length)}else x+=ue.slice(le,re);Ee.push(new o(0,me.startColumn-W,me.endColumn-W)),le=re}this.preview={text:x,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const x=Array.isArray(_e)?_e[0].startLineNumber:_e.startLineNumber;this.preview={text:ue,matches:(0,w.mapArrayOrNot)(_e,W=>new i(W.startLineNumber-x,W.startColumn,W.endLineNumber-x,W.endColumn))}}}}e.TextSearchMatch=r;function s(Y){const ue=Y[0].startLineNumber;for(const _e of Y)if(_e.startLineNumber!==ue||_e.endLineNumber!==ue)return!1;return!0}class i{constructor(ue,_e,ce,pe){this.startLineNumber=ue,this.startColumn=_e,this.endLineNumber=ce,this.endColumn=pe}}e.SearchRange=i;class o extends i{constructor(ue,_e,ce){super(ue,_e,ue,ce)}}e.OneLineRange=o;var S;(function(Y){Y.List="list",Y.Tree="tree"})(S||(e.ViewMode=S={}));var b;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function C(Y,ue=!0){const _e=Y&&Y.files&&Y.files.exclude,ce=ue&&Y&&Y.search&&Y.search.exclude;if(!_e&&!ce)return;if(!_e||!ce)return _e||ce;let pe=Object.create(null);return pe=k.mixin(pe,k.deepClone(_e)),pe=k.mixin(pe,k.deepClone(ce),!0),pe}e.getExcludes=C;function I(Y,ue){return Y.excludePattern&&R.match(Y.excludePattern,ue)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&R.match(Y.includePattern,ue)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(_e=>{const ce=_e.folder.fsPath;if(F.isEqualOrParent(ue,ce)){const pe=y.relative(ce,ue);return!_e.includePattern||!!R.match(_e.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=I;var c;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(c||(e.SearchErrorCode=c={}));class h extends Error{constructor(ue,_e){super(ue),this.code=_e}}e.SearchError=h;function u(Y){const ue=Y.message;if((0,m.isCancellationError)(Y))return new h(ue,c.canceled);try{const _e=JSON.parse(ue);return new h(_e.message,_e.code)}catch{return new h(ue,c.other)}}e.deserializeSearchError=u;function A(Y){const ue={message:Y.message,code:Y.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=A;function B(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=B;function H(Y){return Y.type==="success"}e.isSerializedSearchSuccess=H;function U(Y){return!!Y.path}e.isSerializedFileMatch=U;function z(Y,ue){const _e=Y.searchPath?Y.searchPath:Y.relativePath;return(0,T.fuzzyContains)(_e,ue)}e.isFilePatternMatch=z;class M{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function N(Y,ue){const _e={...Y||{},...ue||{}};return Object.keys(_e).filter(ce=>{const pe=_e[ce];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=N;class ee{constructor(ue,_e){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},..._e.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let ce=ue.includePattern;_e.includePattern&&(ce?ce={...ce,..._e.includePattern}:ce=_e.includePattern),ce&&(this._parsedIncludeExpression=R.parse(ce))}matchesExcludesSync(ue,_e,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,_e,ce))}includedInQuerySync(ue,_e,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,_e,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,_e,ce))}includedInQuery(ue,_e,ce){const pe=this._parsedExcludeExpression(ue,_e,ce),ie=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,_e,ce):!0;return(0,_.isThenable)(pe)?pe.then(x=>x?!1:ie()):ie()}hasSiblingExcludeClauses(){return Q(this._excludeExpression)}}e.QueryGlobTester=ee;function Q(Y){for(const ue in Y)if(typeof Y[ue]!="boolean")return!0;return!1}function Se(Y){if(!Y)return;let ue;return _e=>(ue||(ue=(Y()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),ue.then(ce=>!!ce[_e]))}e.hasSiblingPromiseFn=Se;function ye(Y){if(!Y)return;let ue;return _e=>{if(!ue){const ce=Y();ue=ce?Pe(ce):{}}return!!ue[_e]}}e.hasSiblingFn=ye;function Pe(Y){const ue={};for(const _e of Y)ue[_e]=!0;return ue}}),define(Te[33],Ae([1,0,18,12,21,5,6,48,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,56,47,3]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function S(B,H,U){return new P.ExtUri(z=>c(z,U)).isEqual(B,H)}function b(B,H,U){return S(B.uri,H.uri,U)?0:(0,_.compare)(B.uri.toString(),H.uri.toString())}function C(B,H,U){return B.index!==H.index?B.index<H.index?-1:1:S(B.uri,H.uri,U)?(0,_.compare)(B.name,H.name):(0,_.compare)(B.uri.toString(),H.uri.toString())}function I(B,H,U,z){const M=B.slice(0).sort((ee,Q)=>U(ee,Q,z)),N=H.slice(0).sort((ee,Q)=>U(ee,Q,z));return(0,w.delta)(M,N,(ee,Q)=>U(ee,Q,z))}function c(B,H){const U=H.getCapabilities(B.scheme);return!(U&&U&1024)}class h extends n.Workspace{static toExtHostWorkspace(H,U,z,M){if(!H)return{workspace:null,added:[],removed:[]};const{id:N,name:ee,folders:Q,configuration:Se,transient:ye,isUntitled:Pe}=H,Y=[],ue=U;U?Q.forEach((ie,x)=>{const W=a.URI.revive(ie.uri),le=h._findFolder(z||U,W,M);le?(le.name=ie.name,le.index=ie.index,Y.push(le)):Y.push({uri:W,name:ie.name,index:x})}):Y.push(...Q.map(({uri:ie,name:x,index:W})=>({uri:a.URI.revive(ie),name:x,index:W}))),Y.sort((ie,x)=>ie.index<x.index?-1:1);const _e=new h(N,ee,Y,!!ye,Se?a.URI.revive(Se):null,!!Pe,ie=>c(ie,M)),{added:ce,removed:pe}=I(ue?ue.workspaceFolders:[],_e.workspaceFolders,b,M);return{workspace:_e,added:ce,removed:pe}}static _findFolder(H,U,z){for(let M=0;M<H.folders.length;M++){const N=H.workspaceFolders[M];if(S(N.uri,U,z))return N}}constructor(H,U,z,M,N,ee,Q){super(H,z.map(Se=>new n.WorkspaceFolder(Se)),M,N,Q),this._name=U,this._isUntitled=ee,this._workspaceFolders=[],this._structure=d.TernarySearchTree.forUris(Q),z.forEach(Se=>{this._workspaceFolders.push(Se),this._structure.set(Se.uri,Se)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(H,U){return U&&this._structure.get(H)&&(H=(0,P.dirname)(H)),this._structure.findSubstr(H)}resolveWorkspaceFolder(H){return this._structure.get(H)}}let u=class{constructor(H,U,z,M,N){this._onDidChangeWorkspace=new F.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new F.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new F.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=M,this._extHostFileSystemInfo=z,this._uriTransformerService=N,this._requestIdProvider=new m.Counter,this._barrier=new R.Barrier,this._proxy=H.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=H.getProxy(o.MainContext.MainThreadMessageService);const ee=U.workspace;this._confirmedWorkspace=ee?new h(ee.id,ee.name,[],!!ee.transient,ee.configuration?a.URI.revive(ee.configuration):null,!!ee.isUntitled,Q=>c(Q,z)):void 0}$initializeWorkspace(H,U){this._trusted=U,this.$acceptWorkspaceData(H),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:y.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(H,U,z,...M){const N=[];if(Array.isArray(M)&&M.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!N.some(Y=>S(Y.uri,Pe.uri,this._extHostFileSystemInfo))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.basenameOrAuthority)(Pe.uri)})}),this._unconfirmedWorkspace||[U,z].some(Pe=>typeof Pe!="number"||Pe<0)||z===0&&N.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+z>ee.length)return!1;const Q=ee.slice(0);Q.splice(U,z,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.basenameOrAuthority)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Q.length;Pe++){const Y=Q[Pe];if(Q.some((ue,_e)=>_e!==Pe&&S(Y.uri,ue.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((Pe,Y)=>Pe.index=Y);const{added:Se,removed:ye}=I(ee,Q,C,this._extHostFileSystemInfo);if(Se.length===0&&ye.length===0)return!1;if(this._proxy){const Pe=H.displayName||H.name;this._proxy.$updateWorkspaceFolders(Pe,U,z,N).then(void 0,Y=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:H.identifier,label:H.displayName||H.name}};this._messageService.$showMessage(t.Severity.Error,(0,v.localize)(0,null,Pe,Y.toString()),ue,[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(H,U){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,U)}async getWorkspaceFolder2(H,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,U)}async resolveWorkspaceFolder(H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(H)}getPath(){if(!this._actualWorkspace)return;const{folders:H}=this._actualWorkspace;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,U){let z,M="";if(typeof H=="string"?(z=a.URI.file(H),M=H):typeof H<"u"&&(z=H,M=H.fsPath),!z)return M;const N=this.getWorkspaceFolder(z,!0);if(!N)return M;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let ee=(0,P.relativePath)(N.uri,z);return U&&N.name&&(ee=`${N.name}/${ee}`),ee}trySetWorkspaceFolders(H){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:H,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:U,added:z,removed:M}=h.toExtHostWorkspace(H,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:M}))}findFiles(H,U,z,M,N=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let ee;if(U===null?ee=!1:U&&(typeof U=="string"?ee=U:ee=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:Se}=A(p.GlobPattern.from(H));return this._proxy.$startFileSearch(Q??null,Se??null,ee??null,z??null,N).then(ye=>Array.isArray(ye)?ye.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(H,U,z,M,N=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),Q=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Se,folder:ye}=A(p.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Y={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Q,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Se,excludePattern:Pe},ue=!1;if(this._activeSearchCallbacks[ee]=_e=>{if(ue)return;const ce=a.URI.revive(_e.resource);_e.results.forEach(pe=>{(0,i.resultIsMatch)(pe)?z({uri:ce,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,ie=>new r.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,ie=>new r.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):z({uri:ce,text:pe.text,lineNumber:pe.lineNumber})})},N.isCancellationRequested)return{};try{const _e=await this._proxy.$startTextSearch(H,ye??null,Y,ee,N);return delete this._activeSearchCallbacks[ee],_e||{}}catch(_e){throw delete this._activeSearchCallbacks[ee],_e}}$handleTextSearchResult(H,U){this._activeSearchCallbacks[U]?.(H)}async save(H){const U=await this._proxy.$save(H,{saveAs:!1});return a.URI.revive(U)}async saveAs(H){const U=await this._proxy.$save(H,{saveAs:!0});return a.URI.revive(U)}saveAll(H){return this._proxy.$saveAll(H)}resolveProxy(H){return this._proxy.$resolveProxy(H)}get trusted(){return this._trusted}requestWorkspaceTrust(H){return this._proxy.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(H,U){if(this._editSessionIdentityProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._editSessionIdentityProviders.set(H,U);const z=this._uriTransformerService.transformOutgoingScheme(H),M=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(M,z),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(H),this._proxy.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(H,U){this._logService.info("Getting edit session identifier for workspaceFolder",H);const z=await this.resolveWorkspaceFolder(a.URI.revive(H));if(!z){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const M=this._editSessionIdentityProviders.get(z.uri.scheme);if(this._logService.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!M),!M)return;const N=await M.provideEditSessionIdentity(z,U);if(this._logService.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(H,U,z,M){this._logService.info("Getting edit session identifier for workspaceFolder",H);const N=await this.resolveWorkspaceFolder(a.URI.revive(H));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ee=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ee),!ee)return;const Q=await ee.provideEditSessionIdentityMatch?.(U,z,M);if(this._logService.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(H){return(U,z,M)=>{const N=function(Q){U.call(z,Q)};return N.extension=H,this._onWillCreateEditSessionIdentityEvent.event(N,void 0,M)}}async $onWillCreateEditSessionIdentity(H,U,z){const M=await this.resolveWorkspaceFolder(a.URI.revive(H));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:M},U,async(N,ee)=>{const Q=Date.now();await Promise.resolve(N),Date.now()-Q>z&&this._logService.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(H,U){if(this._canonicalUriProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._canonicalUriProviders.set(H,U);const z=this._uriTransformerService.transformOutgoingScheme(H),M=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(M,z),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(H),this._proxy.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(H,U,z){const M=this._canonicalUriProviders.get(H.scheme);if(!M)return;const N=await M.provideCanonicalUri?.(a.URI.revive(H),U,z);if(N)return N}async $provideCanonicalUri(H,U,z){return this.provideCanonicalUri(a.URI.revive(H),{targetScheme:U},z)}};e.ExtHostWorkspace=u,e.ExtHostWorkspace=u=Ve([We(0,D.IExtHostRpcService),We(1,E.IExtHostInitDataService),We(2,l.IExtHostFileSystemInfo),We(3,f.ILogService),We(4,s.IURITransformerService)],u),e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function A(B){let H,U;return B&&(typeof B=="string"?H=B:(H=B.pattern,U=a.URI.revive(B.baseUri))),{includePattern:H,folder:U}}}),define(Te[34],Ae([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,i){if(i){const o=i.split(".");let S=s;for(let b=0;S&&b<o.length;b++)S=S[o[b]];return S}}function t(s){return s instanceof g.URI}function n(s){return s&&s.uri instanceof g.URI&&s.languageId&&typeof s.languageId=="string"}function l(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function E(s){return s&&s.uri instanceof g.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function D(s){if(t(s))return{resource:s};if(n(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(l(s))return{overrideIdentifier:s.languageId};if(E(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(i,o,S){this._proxy=i.getProxy(F.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=S,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new r(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(i,o))}};e.ExtHostConfiguration=p,e.ExtHostConfiguration=p=Ve([We(0,a.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,v.ILogService)],p);class r{constructor(i,o,S,b){this._onDidChangeConfiguration=new R.Emitter,this._proxy=i,this._logService=b,this._extHostWorkspace=o,this._configuration=d.Configuration.parse(S),this._configurationScopes=this._toMap(S.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,o){const S={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=d.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,S))}getConfiguration(i,o,S){const b=D(o)||{},C=this._toReadonlyValue(i?f(this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,b,S?.identifier);function I(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const c={has(h){return typeof f(C,h)<"u"},get:(h,u)=>{this._validateConfigurationAccess(i?`${i}.${h}`:h,b,S?.identifier);let A=f(C,h);if(typeof A>"u")A=u;else{let B;const H=(U,z)=>{if((0,m.isObject)(U)){let M;const N=()=>{B=B||(0,w.deepClone)(C),M=M||f(B,z)};return new Proxy(U,{get:(ee,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return N(),()=>M;if(B)return M=M||f(B,z),M[Q];const Se=ee[Q];return typeof Q=="string"?H(Se,`${z}.${Q}`):Se},set:(ee,Q,Se)=>(N(),M&&(M[Q]=Se),!0),deleteProperty:(ee,Q)=>(N(),M&&delete M[Q],!0),defineProperty:(ee,Q,Se)=>(N(),M&&Object.defineProperty(M,Q,Se),!0)})}return Array.isArray(U)?(0,w.deepClone)(U):U};A=H(A,h)}return A},update:(h,u,A,B)=>{h=i?`${i}.${h}`:h;const H=I(A);return u!==void 0?this._proxy.$updateConfigurationOption(H,h,u,b,B):this._proxy.$removeConfigurationOption(H,h,b,B)},inspect:h=>{h=i?`${i}.${h}`:h;const u=this._configuration.inspect(h,b,this._extHostWorkspace.workspace);if(u)return{key:h,defaultValue:(0,w.deepClone)(u.policy?.value??u.default?.value),globalValue:(0,w.deepClone)(u.user?.value??u.application?.value),workspaceValue:(0,w.deepClone)(u.workspace?.value),workspaceFolderValue:(0,w.deepClone)(u.workspaceFolder?.value),defaultLanguageValue:(0,w.deepClone)(u.default?.override),globalLanguageValue:(0,w.deepClone)(u.user?.override??u.application?.override),workspaceLanguageValue:(0,w.deepClone)(u.workspace?.override),workspaceFolderLanguageValue:(0,w.deepClone)(u.workspaceFolder?.override),languageIds:(0,w.deepClone)(u.overrideIdentifiers)}}};return typeof C=="object"&&(0,w.mixin)(c,C,!1),Object.freeze(c)}_toReadonlyValue(i){const o=S=>(0,m.isObject)(S)?new Proxy(S,{get:(b,C)=>o(b[C]),set:(b,C,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(b,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(b,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return o(i)}_validateConfigurationAccess(i,o,S){const b=y.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),C=S?`[${S.value}] `:"";if(b===4){typeof o?.resource>"u"&&this._logService.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){o?.resource&&this._logService.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,o){const S=new d.ConfigurationChangeEvent(i,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(b,C)=>S.affectsConfiguration(b,D(C))})}_toMap(i){return i.reduce((o,S)=>(o.set(S[0],S[1]),o),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")}),define(Te[111],Ae([1,0,2,12,5,3,7,33,60,34,21,63,17,27,4,13,22,14,80,214,9]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var p;(function(H){function U(M){if(M!=null)return M}H.from=U;function z(M){if(M!=null)return M}H.to=z})(p||(p={}));var r;(function(H){function U(M){if(M!=null)return M}H.from=U;function z(M){if(M!=null)return M}H.to=z})(r||(r={}));var s;(function(H){function U(M){if(M!=null)return M}H.from=U;function z(M){if(M!=null)return M}H.to=z})(s||(s={}));var i;(function(H){function U(N){if(N){const ee=N;return ee&&!!ee.process}else return!1}H.is=U;function z(N){if(N==null)return;const ee={process:N.process,args:N.args};return N.options&&(ee.options=s.from(N.options)),ee}H.from=z;function M(N){if(N!=null)return new T.ProcessExecution(N.process,N.args,N.options)}H.to=M})(i||(i={}));var o;(function(H){function U(M){if(M!=null)return M}H.from=U;function z(M){if(M!=null)return M}H.to=z})(o||(o={}));var S;(function(H){function U(N){if(N){const ee=N;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}H.is=U;function z(N){if(N==null)return;const ee={};return N.commandLine!==void 0?ee.commandLine=N.commandLine:(ee.command=N.command,ee.args=N.args),N.options&&(ee.options=o.from(N.options)),ee}H.from=z;function M(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new T.ShellExecution(N.commandLine,N.options):new T.ShellExecution(N.command,N.args?N.args:[],N.options)}H.to=M})(S||(S={}));var b;(function(H){function U(N){if(N){const ee=N;return ee&&ee.customExecution==="customExecution"}else return!1}H.is=U;function z(N){return{customExecution:"customExecution"}}H.from=z;function M(N,ee){return ee.get(N)}H.to=M})(b||(e.CustomExecutionDTO=b={}));var C;(function(H){function U(z,M){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===T.TaskScope.Workspace&&M&&M.workspaceFile?N=M.workspaceFile:N=E.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:N}}H.from=U})(C||(e.TaskHandleDTO=C={}));var I;(function(H){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}H.from=U})(I||(I={}));var c;(function(H){function U(N,ee){if(N==null)return[];const Q=[];for(const Se of N){const ye=z(Se,ee);ye&&Q.push(ye)}return Q}H.fromMany=U;function z(N,ee){if(N==null)return;let Q;N.execution instanceof T.ProcessExecution?Q=i.from(N.execution):N.execution instanceof T.ShellExecution?Q=S.from(N.execution):N.execution&&N.execution instanceof T.CustomExecution&&(Q=b.from(N.execution));const Se=p.from(N.definition);let ye;return N.scope?typeof N.scope=="number"?ye=N.scope:ye=N.scope.uri:ye=T.TaskScope.Workspace,!Se||!ye?void 0:{_id:N._id,definition:Se,name:N.name,source:{extensionId:ee.identifier.value,label:N.source,scope:ye},execution:Q,isBackground:N.isBackground,group:I.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}H.from=z;async function M(N,ee,Q){if(N==null)return;let Se;i.is(N.execution)?Se=i.to(N.execution):S.is(N.execution)?Se=S.to(N.execution):b.is(N.execution)&&(Se=b.to(N._id,Q));const ye=p.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=T.TaskScope.Workspace),!ye||!Pe)return;const Y=new T.Task(ye,Pe,N.name,N.source.label,Se,N.problemMatchers);return N.isBackground!==void 0&&(Y.isBackground=N.isBackground),N.group!==void 0&&(Y.group=T.TaskGroup.from(N.group._id),Y.group&&N.group.isDefault&&(Y.group=new T.TaskGroup(Y.group.id,Y.group.label),N.group.isDefault===!0&&(Y.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Y.presentationOptions=r.to(N.presentationOptions)),N._id&&(Y._id=N._id),N.detail&&(Y.detail=N.detail),Y}H.to=M})(c||(e.TaskDTO=c={}));var h;(function(H){function U(M){return M}H.from=U;function z(M){if(M)return Object.assign(Object.create(null),M)}H.to=z})(h||(h={}));class u{#e;constructor(U,z,M){this._id=z,this._task=M,this.#e=U}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let A=class{constructor(U,z,M,N,ee,Q,Se,ye){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=U.getProxy(F.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=N,this._configurationService=ee,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Se,this._deprecationService=ye,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,M){if(!M)return new T.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:z,provider:M,extension:U}),this._proxy.$registerTaskProvider(N,z),new T.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(U,z){this._proxy.$registerTaskSystem(U,z)}fetchTasks(U){return this._proxy.$fetchTasks(h.from(U)).then(async z=>{const M=[];for(const N of z){const ee=await c.to(N,this._workspaceProvider,this._providedCustomExecutions2);ee&&M.push(ee)}return M})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof u))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,z,M){const N=this._providedCustomExecutions2.get(U.id);N&&(this._activeCustomExecutions2.set(U.id,N),this._terminalService.attachPtyToTerminal(z,await N.callback(M))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const z=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const M=this._handlers.get(U);if(!M)return Promise.reject(new Error("no handler found"));const N=[],ee=(0,R.asPromise)(()=>M.provider.provideTasks(P.CancellationToken.None)).then(Q=>this.provideTasksInternal(z,N,M,Q));return new Promise(Q=>{ee.then(Se=>{Promise.all(N).then(()=>{Q(Se)})})})}async $resolveTask(U,z){const M=this._handlers.get(U);if(!M)return Promise.reject(new Error("no handler found"));if(z.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${M.type}].`);const N=await c.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ee=await M.provider.resolveTask(N,P.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,M);const Q=c.from(ee,M.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(Q.execution)&&await this.addCustomExecution(Q,ee,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,z,M){const N=await this._proxy.$createTaskId(U);!M&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,z.execution)),this._providedCustomExecutions2.set(N,z.execution)}async getTaskExecution(U,z){if(typeof U=="string"){const ee=this._taskExecutionPromises.get(U);if(!ee)throw new D.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return ee}const M=this._taskExecutionPromises.get(U.id);if(M)return M;const N=new Promise((ee,Q)=>{function Se(ye,Pe,Y){Y?ee(new u(ye,Pe.id,Y)):Q("Unexpected: Task does not exist.")}z?Se(this,U,z):c.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then(ye=>Se(this,U,ye))});return this._taskExecutionPromises.set(U.id,N),N.then(ee=>(this._taskExecutions.set(U.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(U,z){U._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const M=this._notProvidedCustomExecutions.values();let N=M.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=M.next()}};e.ExtHostTaskBase=A,e.ExtHostTaskBase=A=Ve([We(0,a.IExtHostRpcService),We(1,v.IExtHostInitDataService),We(2,d.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,_.IExtHostTerminalService),We(6,n.ILogService),We(7,l.IExtHostApiDeprecationService)],A);let B=class extends A{constructor(U,z,M,N,ee,Q,Se,ye){super(U,z,M,N,ee,Q,Se,ye),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const M=c.from(z,U);if(M===void 0)throw new Error("Task is not valid");if(b.is(M.execution))await this.addCustomExecution(M,z,!1);else throw new D.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),z);return this._proxy.$executeTask(M).catch(ee=>{throw new Error(ee)}),N}provideTasksInternal(U,z,M,N){const ee=[];if(N)for(const Q of N){this.checkDeprecation(Q,M),(!Q.definition||!U[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const Se=c.from(Q,M.extension);Se&&b.is(Se.execution)?(ee.push(Se),z.push(this.addCustomExecution(Se,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:M.extension}}async resolveTaskInternal(U){if(b.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,M){}};e.WorkerExtHostTask=B,e.WorkerExtHostTask=B=Ve([We(0,a.IExtHostRpcService),We(1,v.IExtHostInitDataService),We(2,d.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,_.IExtHostTerminalService),We(6,n.ILogService),We(7,l.IExtHostApiDeprecationService)],B),e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Te[267],Ae([1,0,19,21,41,37,23,59,47]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(a,v,g){this.config=a,this.provider=v,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&F.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&F.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const v=this.config.folderQueries||[];return new Promise((g,f)=>{const t=n=>{this.resultCount++,a(n)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(n=>{const l=n.toString(),E=w.basename(l);this.globalExcludePattern&&this.globalExcludePattern(l,E)||this.matchFile(t,{base:n,basename:E})}),Promise.all(v.map(n=>this.searchInFolder(n,t))).then(n=>{g({limitHit:this.isLimitHit,stats:n[0]||void 0})},n=>{f(new Error((0,k.toErrorMessage)(n)))})})}async searchInFolder(a,v){const g=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(a),t=this.initDirectoryTree(),n=new y.QueryGlobTester(this.config,a),l=!n.hasSiblingExcludeClauses();let E;try{this.activeCancellationTokens.add(g),E=d.StopWatch.create();const D=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,g.token),p=E.elapsed(),r=d.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(D&&D.forEach(s=>{const i=w.posix.relative(a.folder.path,s.path);if(l){const o=w.basename(s.path);this.matchFile(v,{base:a.folder,relativePath:i,basename:o});return}this.addDirectoryEntries(t,a.folder,i,v)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,n,v),{providerTime:p,postProcessTime:r.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(a){const v=(0,y.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),g=(0,y.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:g,includes:v,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},v,g,f){if(g===this.filePattern){const n=w.basename(this.filePattern);this.matchFile(f,{base:v,relativePath:this.filePattern,basename:n})}function t(n){const l=w.basename(n),E=w.dirname(n);let D=a[E];D||(D=a[E]=[],t(E)),D.push({base:v,relativePath:n,basename:l})}t(g)}matchDirectoryTree({rootEntries:a,pathToEntries:v},g,f){const t=this,n=this.filePattern;function l(E){const D=(0,y.hasSiblingFn)(()=>E.map(p=>p.basename));for(let p=0,r=E.length;p<r;p++){const s=E[p],{relativePath:i,basename:o}=s;if(g.matchesExcludesSync(i,o,n!==o?D:void 0))continue;const S=v[i];if(S)l(S);else{if(i===n)continue;t.matchFile(f,s)}if(t.isLimitHit)break}}l(a)}matchFile(a,v){(!this.includePattern||v.relativePath&&this.includePattern(v.relativePath,v.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(v))}}class P{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(a,v,g,f){const t=this.getSessionTokenSource(a.cacheKey),n=new m(a,v,t&&t.token);let l=0;const E=D=>{l+=D.length,g(D.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(n,P.BATCH_SIZE,E,f).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:D.stats}}))}clearCache(a){this.getSessionTokenSource(a)?.cancel()}getSessionTokenSource(a){if(a)return this.sessions.has(a)||this.sessions.set(a,new R.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:T.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,v,g,f){const t=f.onCancellationRequested(()=>{a.cancel()}),n=E=>{E&&(l.push(E),v>0&&l.length>=v&&(g(l),l=[]))};let l=[];return a.search(n).then(E=>(l.length&&g(l),t.dispose(),E),E=>(l.length&&g(l),t.dispose(),Promise.reject(E)))}}e.FileSearchManager=P}),define(Te[268],Ae([1,0,18,232,37,90,28,13,19,23,15,16,2,283,167,43,14,54,102,266,47]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(h,u,A,B,H){this.configurationService=h,this.workspaceContextService=u,this.editorGroupsService=A,this.logService=B,this.pathService=H}text(h,u,A={}){h=this.getContentPattern(h,A);const B=this.configurationService.getValue(),H=u&&u.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(u?.map(n.toWorkspaceFolder),A),type:2,contentPattern:h,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:B.search.usePCRE2||H||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}getContentPattern(h,u){const A=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const B={...h,wordSeparators:A.editor.wordSeparators};return this.isCaseSensitive(h,u)&&(B.isCaseSensitive=!0),this.isMultiline(h)&&(B.isMultiline=!0),u.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=u.notebookSearchConfig.includeMarkupInput),u.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=u.notebookSearchConfig.includeMarkupPreview),u.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=u.notebookSearchConfig.includeCodeInput),u.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=u.notebookSearchConfig.includeOutput),B}file(h,u={}){return{...this.commonQuery(h,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(h,u){return h?(h=Array.isArray(h)?h.map(S):S(h),u?this.parseSearchPaths(h):{pattern:s(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],u={}){const A=this.handleIncludeExclude(u.includePattern,u.expandPatterns),B=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),H=h.length>1,U=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,u,B)):h.map(N=>this.getFolderQueryForRoot(N,u,B,H))).filter(N=>!!N),z={_reason:u._reason,folderQueries:U,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:B.pattern,includePattern:A.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const N=w.coalesce(w.flatten(this.editorGroupsService.groups.map(Se=>Se.editors.map(ye=>ye.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ee=N.filter(Se=>(0,D.pathIncludedInQuery)(z,Se.fsPath)),Q=this.commonQueryFromFileList(ee);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...z,...Q}}const M=u.extraFileResources&&u.extraFileResources.filter(N=>(0,D.pathIncludedInQuery)(z,N.fsPath));return z.extraFileResources=M&&M.length?M:void 0,z}commonQueryFromFileList(h){const u=[],A=new T.ResourceMap,B={};let H=!1;return h.forEach(U=>{if(U.scheme===d.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(U)){const M=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:y.dirname(U.fsPath)});let N=A.get(M);N||(H=!0,N={folder:M,includePattern:{}},u.push(N),A.set(M,N));const ee=y.relative(M.fsPath,U.fsPath);(0,_.assertIsDefined)(N.includePattern)[ee.replace(/\\/g,"/")]=!0}else U.fsPath&&(H=!0,B[U.fsPath]=!0)}),{folderQueries:u,includePattern:B,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(h,u){if(u.isSmartCase){if(h.isRegExp){if(P.containsUppercaseCharacter(h.pattern,!0))return!0}else if(P.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,v.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const u=Q=>y.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),B=(Array.isArray(h)?h:i(h)).map(Q=>{const Se=this.pathService.resolvedUserHome;return Se?(0,F.untildify)(Q,Se.scheme===d.Schemas.file?Se.fsPath:Se.path):Q}),H=R.groupBy(B,Q=>u(Q)?"searchPaths":"exprSegments"),U=(H.exprSegments||[]).map(Q=>P.rtrim(Q,"/")).map(Q=>P.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),o(Q))),z={},M=this.expandSearchPathPatterns(H.searchPaths||[]);M&&M.length&&(z.searchPaths=M);const N=w.flatten(U),ee=s(...N);return ee&&(z.pattern=ee),z}getExcludesForFolder(h,u){return u.disregardExcludeSettings?void 0:(0,D.getExcludes)(h,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const u=h.flatMap(B=>{let{pathPortion:H,globPortion:U}=r(B);return U&&(U=b(U)),this.expandOneSearchPath(H).flatMap(M=>this.resolveOneSearchPathPattern(M,U))}),A=new Map;return u.forEach(B=>{const H=B.searchPath.toString(),U=A.get(H);U?B.pattern&&(U.pattern=U.pattern||{},U.pattern[B.pattern]=!0):A.set(H,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(A.values())}expandOneSearchPath(h){if(y.isAbsolute(h)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==d.Schemas.file?[{searchPath:u[0].uri.with({path:h})}]:[{searchPath:a.URI.file(y.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=S(h),h.startsWith("../")||h===".."){const B=y.posix.resolve(u.path,h);return[{searchPath:u.with({path:B})}]}const A=b(h);return[{searchPath:u,pattern:A}]}else{if(h==="./"||h===".\\")return[];{const u=h.replace(/^\.[\/\\]/,""),B=this.workspaceContextService.getWorkspace().folders.map(H=>{const U=u.match(new RegExp(`^${P.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return U?{match:U,folder:H}:null}).filter(_.isDefined);if(B.length)return B.map(H=>{const U=H.match[1];return{searchPath:H.folder.uri,pattern:U&&b(U)}});{const H=h.match(/\.[\/\\](.+)[\/\\]?/),U=H?H[1]:h,z=g.localize(0,null,U);throw new Error(z)}}}}resolveOneSearchPathPattern(h,u){const A=h.pattern&&u?`${h.pattern}/${u}`:h.pattern||u,B=[{searchPath:h.searchPath,pattern:A}];return A&&!A.endsWith("**")&&B.push({searchPath:h.searchPath,pattern:A+"/**"}),B}getFolderQueryForSearchPath(h,u,A){const B=this.getFolderQueryForRoot((0,n.toWorkspaceFolder)(h.searchPath),u,A,!1);return B?{...B,includePattern:h.pattern}:null}getFolderQueryForRoot(h,u,A,B){let H;const U=a.URI.isUri(h)?h:h.uri;if(A.searchPaths){const Q=A.searchPaths.filter(Se=>(0,m.isEqual)(Se.searchPath,U))[0];if(Q&&!Q.pattern)return null;Q&&(H=Q.pattern)}const z=this.configurationService.getValue({resource:U}),N={...this.getExcludesForFolder(z,u)||{},...H||{}},ee=a.URI.isUri(h)?(0,m.basename)(h):h.name;return{folder:U,folderName:B?ee:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof u.disregardParentIgnoreFiles=="boolean"?u.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!z.search.followSymlinks}}};e.QueryBuilder=p,e.QueryBuilder=p=Ve([We(0,f.IConfigurationService),We(1,n.IWorkspaceContextService),We(2,l.IEditorGroupsService),We(3,t.ILogService),We(4,E.IPathService)],p);function r(c){const h=c.match(/[\*\{\}\(\)\[\]\?]/);if(h){const u=h.index,A=c.substr(0,u).match(/[/|\\][^/\\]*$/);if(A){let B=c.substr(0,A.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:c.substr((A.index||0)+1)}}}return{pathPortion:c}}function s(...c){return c.length?c.reduce((h,u)=>(h[u]=!0,h),Object.create(null)):void 0}function i(c){return k.splitGlobAware(c,",").map(h=>h.trim()).filter(h=>!!h.length)}function o(c){return[`**/${c}/**`,`**/${c}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function S(c){return c.replace(/\\/g,"/")}function b(c){return S(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(c){return c.replace(/([?*[\]])/g,"[$1]")}function I(c,h){c=w.distinct(c,B=>B.toString());const u=[],A=h.getWorkspace();return c&&c.forEach(B=>{let H;if(h.getWorkbenchState()===2)H=(0,m.relativePath)(A.folders[0].uri,B),H&&H!=="."&&(H="./"+H);else{const U=h.getWorkspaceFolder(B);if(U){const z=U.name;if(A.folders.filter(N=>N.name===z).length===1){const N=(0,m.relativePath)(U.uri,B);N===""?H=`./${U.name}`:H=`./${U.name}/${N}`}else H=B.fsPath}}H&&u.push(C(H))}),u}e.resolveResourcesForSearchIncludes=I}),define(Te[269],Ae([1,0,23,2,21,9,4,268,47,54]),function(be,e,w,R,k,F,T,d,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function _(f,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const l=[],E=[];for(const o of n)if(/^workspaceContains:/.test(o)){const S=o.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||f.forceUsingSearch?E.push(S):l.push(S)}if(l.length===0&&E.length===0)return Promise.resolve(void 0);let D;const p=new Promise((o,S)=>{D=o}),r=o=>D({activationEvent:o}),s=Promise.all(l.map(o=>a(f,o,r))).then(()=>{}),i=v(f,t.identifier,E,r);return Promise.all([s,i]).then(()=>{D(void 0)}),p}e.checkActivateWorkspaceContainsExtension=_;async function a(f,t,n){for(const l of f.folders)if(await f.exists(w.joinPath(R.URI.revive(l),t))){n(`workspaceContains:${t}`);return}}async function v(f,t,n,l){if(n.length===0)return Promise.resolve(void 0);const E=new k.CancellationTokenSource,D=f.checkExists(f.folders,n,E.token),p=setTimeout(async()=>{E.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let r=!1;try{r=await D}catch(s){F.isCancellationError(s)||F.onUnexpectedError(s)}E.dispose(),clearTimeout(p),r&&l(`workspaceContains:${n.join(",")}`)}function g(f,t,n,l){const E=f.get(T.IInstantiationService),D=f.get(y.ISearchService),r=E.createInstance(d.QueryBuilder).file(t.map(s=>(0,m.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:n,exists:!0});return D.fileSearch(r,l).then(s=>!!s.limitHit,s=>F.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=g}),define(Te[35],Ae([1,0,148,19,87,23,12,6,48,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,72,86,63,5,269,83,190,13,81,59,22,82]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r,s,i,o,S,b,C,I,c,h,u,A,B,H,U,z,M,N){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let Q=ee=class extends d.Disposable{constructor(ie,x,W,le,we,Ee,me,De,re,de,se,oe){super(),this._extHostManagedSockets=oe,this._onDidChangeRemoteConnectionData=this._register(new h.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=x,this._extHostContext=W,this._initData=me,this._extHostWorkspace=le,this._extHostConfiguration=we,this._logService=Ee,this._extHostTunnelService=re,this._extHostTerminalService=de,this._extHostLocalizationService=se,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new ce(this._initData.extensions.activationEvents),this._globalRegistry=new n.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const fe=new E.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new n.ExtensionDescriptionRegistry(this._activationEventsReader,ue(this._globalRegistry,fe)),M.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Pe(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Pe(this._myRegistry)}`)),this._storage=new g.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=De,this._instaService=ie.createChild(new C.ServiceCollection([g.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState])),this._activator=this._register(new v.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ie,O,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ie,l.transformErrorForSerialization(O),V)},actualActivateExtension:async(Ie,O)=>{if(n.ExtensionDescriptionRegistry.isHostExtension(Ie,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ie,O),new v.HostExtension;const V=this._myRegistry.getExtensionDescription(Ie);return this._activateExtension(V,O)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){l.onUnexpectedError(ie)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._myRegistry.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this._deactivate(we))}catch{}await Promise.all(ie)}terminate(ie,x=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ie}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),l.setUnexpectedErrorHandler(le=>{this._logService.error(le)}),this._extHostContext.dispose();const W=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),W]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${x}`):this._logService.info(`Extension host exiting with code ${x}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(x)})}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}async getExtension(ie){const x=await this._mainThreadExtensionsProxy.$getExtension(ie);return x&&{...x,identifier:new E.ExtensionIdentifier(x.identifier.value),extensionLocation:m.URI.revive(x.extensionLocation)}}_activateByEvent(ie,x){return this._activator.activateByEvent(ie,x)}_activateById(ie,x){return this._activator.activateById(ie,x)}activateByIdWithErrors(ie,x){return this._activateById(ie,x).then(()=>{const W=this._activator.getActivatedExtension(ie);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._myRegistry)}getExtensionExports(ie){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(ie).exports;try{return this._activator.getActivatedExtension(ie).exports}catch{return null}}async _realPathExtensionUri(ie){if(ie.scheme===H.Schemas.file&&this._hostUtils.fsRealpath){const x=await this._hostUtils.fsRealpath(ie.fsPath);return m.URI.file(x)}return ie}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ie=>new _e(ie))),this._extensionPathIndex}async _createExtensionPathIndex(ie){const x=y.TernarySearchTree.forUris(W=>F.extUriBiasedIgnorePathCase.ignorePathCasing(W));return await Promise.all(ie.map(async W=>{if(this._getEntryPoint(W)){const le=await this._realPathExtensionUri(W.extensionLocation);x.set(le,W)}})),x}_deactivate(ie){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return x;const W=this._activator.getActivatedExtension(ie);if(!W)return x;try{typeof W.module.deactivate=="function"&&(x=Promise.resolve(W.module.deactivate()).then(void 0,le=>(this._logService.error(le),Promise.resolve(void 0))))}catch(le){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(le)}try{(0,d.dispose)(W.subscriptions)}catch(le){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(le)}return x}async _activateExtension(ie,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,x).then(W=>{const le=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,x),this._logExtensionActivationTimes(ie,x,"success",le),W},W=>{throw this._logExtensionActivationTimes(ie,x,"failure"),W})}_logExtensionActivationTimes(ie,x,W,le){const we=ye(ie,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:W})}_doActivateExtension(ie,x){const W=ye(ie,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const le=this._getEntryPoint(ie);if(!le)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${ie.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this._logService.flush();const we=new v.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(ie,(0,F.joinPath)(ie.extensionLocation,le),we),this._loadExtensionContext(ie)]).then(Ee=>(k.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee._callActivate(this._logService,ie.identifier,Ee[0],Ee[1],we))).then(Ee=>(k.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Ee))}_loadExtensionContext(ie){const x=new p.ExtensionGlobalMemento(ie,this._storage),W=new p.ExtensionMemento(ie.identifier.value,!1,this._storage),le=new B.ExtensionSecrets(ie,this._secretState),we=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ee=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([x.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let De,re;const de=(0,t.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(E.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:x,workspaceState:W,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return R.join(ie.extensionLocation.fsPath,se)},get storagePath(){return me._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(ie).fsPath},get logPath(){return R.join(me._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return m.URI.joinPath(me._initData.logsLocation,ie.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(ie)},get globalStorageUri(){return me._storagePath.globalValue(ie)},get extensionMode(){return we},get extension(){return De===void 0&&(De=new Y(me,ie.identifier,ie,Ee,!1)),De},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!de)return;const se=h.Event.buffer(h.Event.fromDOMEventEmitter(de,"message",oe=>oe.data));de.start(),re={onDidReceiveMessage:se,postMessage:de.postMessage.bind(de)}}return re}})})}static _callActivate(ie,x,W,le,we){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,x,W,le,we).then(Ee=>new v.ActivatedExtension(!1,null,we.build(),W,Ee,le.subscriptions))}static _callActivateOptional(ie,x,W,le,we){if(typeof W.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${x.value}`);const Ee=typeof global=="object"?global:self,me=W.activate.apply(Ee,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(De=>(we.activateResolveStop(),De))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(W)}_activateOneStartupFinished(ie,x){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:x}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinishedDeferred(ie,x=0){const le=Date.now();(0,M.setTimeout0)(()=>{for(let we=x;we<ie.length;we+=1){const Ee=ie[we];for(const me of Ee.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this._activateAllStartupFinishedDeferred(ie,we);break}else this._activateOneStartupFinished(Ee,me)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks()),this._extHostConfiguration.getConfigProvider().then(ie=>{const x=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),W=this._myRegistry.getAllExtensionDescriptions();if(x)this._activateAllStartupFinishedDeferred(W);else for(const le of W)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this._activateOneStartupFinished(le,we)})}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(x),le=this._handleRemoteResolverEagerExtensions(),we=Promise.all([le,ie,W]).then(()=>{});return Promise.race([we,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),we}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(ie,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,x){if(this.isActivated(x.identifier))return;const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,le={logService:this._logService,folders:ie.map(Ee=>Ee.uri),forceUsingSearch:W||!this._hostUtils.fsExists,exists:Ee=>this._hostUtils.fsExists(Ee.fsPath),checkExists:(Ee,me,De)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,me,De)},we=await(0,u.checkActivateWorkspaceContainsExtension)(le,x);if(we)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:we.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:x}=this._initData.environment;if(!ie||!x)throw new Error(w.localize(0,null));const W=await this._loadCommonJSModule(null,x,new v.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(w.localize(1,null,x.toString()));return new Promise((le,we)=>{const Ee=(re,de)=>{re?(M.isCI&&this._logService.error("Test runner called back with error",re),we(re)):(M.isCI&&(de?this._logService.info(`Test runner called back with ${de} failures.`):this._logService.info("Test runner called back with successful outcome.")),le(typeof de=="number"&&de>0?1:0))},me=(0,F.originalFSPath)(x),De=W.run(me,Ee);De&&De.then&&De.then(()=>{M.isCI&&this._logService.info("Test runner finished successfully."),le(0)}).catch(re=>{M.isCI&&this._logService.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,x){return this._resolvers[ie]=x,(0,d.toDisposable)(()=>{delete this._resolvers[ie]})}async getRemoteExecServer(ie){const{resolver:x}=await this._activateAndGetResolver(ie);return x?.resolveExecServer?.(ie,{resolveAttempt:0})}async _activateAndGetResolver(ie){const x=ie.indexOf("+");if(x===-1)throw new r.RemoteAuthorityResolverError("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const W=ie.substr(0,x);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${W}`,!1),{authorityPrefix:W,resolver:this._resolvers[W]}}async $resolveAuthority(ie,x){const W=z.StopWatch.create(!1),le=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(ie)},${x})][${W.elapsed()}ms] `,we=G=>this._logService.info(`${le()}${G}`),Ee=G=>this._logService.warn(`${le()}${G}`),me=(G,q=void 0)=>this._logService.error(`${le()}${G}`,q),De=G=>{if(G instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},re=async G=>{we(`activating resolver for ${G}...`);const{resolver:q,authorityPrefix:Z}=await this._activateAndGetResolver(G);if(!q)throw me(`no resolver for ${Z}`),new r.RemoteAuthorityResolverError(`No remote extension installed to resolve ${Z}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:Z,remoteAuthority:G}},de=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${de.join(" -> ")}`);let se;try{se=await Promise.all(de.map(re)).catch(async G=>{if(!(G instanceof r.RemoteAuthorityResolverError)||G._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return Ee(`resolving nested authorities failed: ${G.message}`),[await re(ie)]})}catch(G){return De(G)}const oe=new T.IntervalTimer;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[G,{authorityPrefix:q,resolver:Z,remoteAuthority:ae}]of se.entries())try{if(G===se.length-1)we("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${q}`),fe=await Z.resolve(ae,{resolveAttempt:x,execServer:Ie}),k.mark(`code/extHost/didResolveAuthorityOK/${q}`),we("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Z,r.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),k.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await Z.resolveExecServer?.(ae,{resolveAttempt:x,execServer:Ie}),!Ie)throw new r.RemoteAuthorityResolverError(`Exec server was not available for ${ae}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Me){return k.mark(`code/extHost/didResolveAuthorityError/${q}`),me("returned an error",Me),oe.dispose(),De(Me)}oe.dispose();const O={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},V={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let K;if(r.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)){const G=x;this._extHostManagedSockets.setFactory(G,fe.makeConnection),K={authority:ie,connectTo:new s.ManagedRemoteConnection(G),connectionToken:fe.connectionToken}}else K={authority:ie,connectTo:new s.WebSocketRemoteConnection(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:K,options:V,tunnelInformation:O}}}async $getCanonicalURI(ie,x){this._logService.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(ie)})`);const{resolver:W}=await this._activateAndGetResolver(ie);if(!W)return null;const le=m.URI.revive(x);if(typeof W.getCanonicalURI>"u")return le;const we=await(0,T.asPromise)(()=>W.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=m.URI.revive(le.extensionLocation));const{globalRegistry:x,myExtensions:W}=Se(this._activationEventsReader,this._globalRegistry,this._myRegistry,ie);return this._globalRegistry.set(x.getAllExtensionDescriptions()),this._myRegistry.set(W),M.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Pe(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Pe(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(ie,x){return x===1?this._almostReadyToRunExtensions.wait().then(W=>this._activateByEvent(ie,!1)):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(ie,!1))}async $activate(ie,x){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ie)?(await this._activateById(ie,x),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Ee=>Ee.extensionLocation=m.URI.revive(Ee.extensionLocation));const{globalRegistry:x,myExtensions:W}=Se(this._activationEventsReader,this._globalRegistry,this._myRegistry,ie),le=await this._createExtensionPathIndex(W);return(await this.getExtensionPathIndex()).setSearchTree(le),this._globalRegistry.set(x.getAllExtensionDescriptions()),this._myRegistry.set(W),M.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Pe(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Pe(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const x=D.VSBuffer.alloc(ie),W=Math.random()%256;for(let le=0;le<ie;le++)x.writeUInt8(W,le);return x}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Q,e.AbstractExtHostExtensionService=Q=ee=Ve([We(0,i.IInstantiationService),We(1,e.IHostUtils),We(2,b.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,a.IExtHostConfiguration),We(5,P.ILogService),We(6,o.IExtHostInitDataService),We(7,S.IExtensionStoragePaths),We(8,I.IExtHostTunnelService),We(9,c.IExtHostTerminalService),We(10,U.IExtHostLocalizationService),We(11,N.IExtHostManagedSockets)],Q);function Se(pe,ie,x,W){pe.addActivationEvents(W.addActivationEvents);const le=new n.ExtensionDescriptionRegistry(pe,ie.getAllExtensionDescriptions());le.deltaExtensions(W.toAdd,W.toRemove);const we=new E.ExtensionIdentifierSet(x.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of W.myToRemove)we.delete(me);for(const me of W.myToAdd)we.add(me);const Ee=ue(le,we);return{globalRegistry:le,myExtensions:Ee}}function ye(pe,ie){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe(pe){return pe.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(ie,x,W,le,we){this.#e=ie,this.#t=x,this.#i=W.identifier,this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=R.normalize((0,F.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Y;function ue(pe,ie){return pe.getAllExtensionDescriptions().filter(x=>ie.has(x.identifier))}class _e{constructor(ie){this._searchTree=ie}setSearchTree(ie){this._searchTree=ie}findSubstr(ie){return this._searchTree.findSubstr(ie)}forEach(ie){return this._searchTree.forEach(ie)}}e.ExtensionPaths=_e;class ce{constructor(ie){this._map=new E.ExtensionIdentifierMap,this.addActivationEvents(ie)}readActivationEvents(ie){return this._map.get(ie.identifier)}addActivationEvents(ie){for(const x of Object.keys(ie))this._map.set(x,ie[x])}}}),define(Te[270],Ae([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(D,p,r,s,i,o,S){this._apiFactory=D,this._extensionRegistry=p,this._instaService=r,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=o,this._logService=S,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const D=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new n(this._apiFactory,p,this._extensionRegistry,D,this._logService)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(l,p,this._initData.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const p of D.nodeModuleName)this._factories.set(p,D);else this._factories.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this._alternatives.push(p=>D.alternativeModuleName(p))}};e.RequireInterceptor=f,e.RequireInterceptor=f=Ve([We(2,P.IInstantiationService),We(3,F.IExtHostConfiguration),We(4,_.IExtHostExtensionService),We(5,m.IExtHostInitDataService),We(6,a.ILogService)],f);let t=class{static{g=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(D){if(D.environment.appRoot&&g.aliased.size){const p=(0,v.escapeRegExpCharacters)(this.forceForwardSlashes(D.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${p}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(D){if(!this.re)return;const p=this.re.exec(this.forceForwardSlashes(D));if(!p)return;const[,r,s,i]=p,o=g.aliased.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+i}forceForwardSlashes(D){return D.replace(/\\/g,"/")}};t=g=Ve([We(0,m.IExtHostInitDataService)],t);class n{constructor(D,p,r,s,i){this._apiFactory=D,this._extensionPaths=p,this._extensionRegistry=r,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new d.ExtensionIdentifierMap}load(D,p){const r=this._extensionPaths.findSubstr(p);if(r){let s=this._extApiImpl.get(r.identifier);return s||(s=this._apiFactory(r,this._extensionRegistry,this._configProvider),this._extApiImpl.set(r.identifier,s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,o)=>s+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let l=class{constructor(D,p,r){this._extensionPaths=D,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=r.getProxy(k.MainContext.MainThreadTelemetry);const s=r.getProxy(k.MainContext.MainThreadWindow);this._impl=(i,o)=>{const S=R.URI.parse(i);return o?this.callOriginal(i,o):S.scheme==="http"||S.scheme==="https"?s.$openUri(S,i,{allowTunneling:!0}):S.scheme==="mailto"||S.scheme===this._appUriScheme?s.$openUri(S,i,{}):this.callOriginal(i,o)}}load(D,p,r){const s=this._extensionPaths.findSubstr(p);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=r(D),this._impl}callOriginal(D,p){return this.sendNoForwardTelemetry(),this._original(D,p)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};l=Ve([We(2,y.IExtHostRpcService)],l)}),define(Te[112],Ae([1,0,66,6,19,74,4,60,61,35,7,33,200,34]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class g extends a.AbstractVariableResolverService{constructor(n,l,E,D,p,r,s){function i(){if(E){const o=E.activeEditor();if(o)return o.document.uri;const S=D.tabGroups.all.find(b=>b.isActive)?.activeTab;if(S!==void 0){if(S.input instanceof P.TextDiffTabInput||S.input instanceof P.NotebookDiffEditorTabInput)return S.input.modified;if(S.input instanceof P.TextTabInput||S.input instanceof P.NotebookEditorTabInput||S.input instanceof P.CustomEditorTabInput)return S.input.uri}}}super({getFolderUri:o=>{const S=r.folders.filter(b=>b.name===o);if(S&&S.length>0)return S[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,S)=>p.getConfiguration(void 0,o).get(S),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return k.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const o=i();if(o){const S=l.getWorkspaceFolder(o);if(S)return k.normalize(S.uri.fsPath)}}},getSelectedText:()=>{if(E){const o=E.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(E){const o=E.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>n.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(F.env))}}let f=class extends R.Disposable{constructor(n,l,E,D,p){super(),this.extensionService=n,this.workspaceService=l,this.editorService=E,this.configurationService=D,this.editorTabs=p,this._resolver=new w.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,i,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=f,e.ExtHostVariableResolverProviderService=f=Ve([We(0,m.IExtHostExtensionService),We(1,_.IExtHostWorkspace),We(2,d.IExtHostDocumentsAndEditors),We(3,v.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],f)}),define(Te[113],Ae([1,0,12,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,F.createDecorator)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,i,o,S,b,C){this._workspaceService=i,this._extensionService=o,this._configurationService=S,this._editorTabs=b,this._variableResolver=C,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=s.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter,this._onDidChangeStackFrameFocus=new R.Emitter,this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(c=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}asDebugSourceUri(s,i){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let S=`debug:${encodeURIComponent(o.path||"")}`,b="?";return i&&(S+=`${b}session=${encodeURIComponent(i.id)}`,b="&"),S+=`${b}ref=${o.sourceReference}`,k.URI.parse(S)}else{if(o.path)return k.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const i=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const S=o.contributes.debuggers;if(S&&S.length>0)for(const b of S)(0,v.isDebuggerMainContribution)(b)&&i.push(b.type)}this._debugServiceProxy.$registerDebugTypes(i)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const s=[];return this._breakpoints.forEach(i=>s.push(i)),s}addBreakpoints(s){const i=s.filter(b=>{const C=b.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,b),!0)});this.fireBreakpointChanges(i,[],[]);const o=[],S=new Map;for(const b of i)if(b instanceof P.SourceBreakpoint){let C=S.get(b.location.uri.toString());C||(C={type:"sourceMulti",uri:b.location.uri,lines:[]},S.set(b.location.uri.toString(),C),o.push(C)),C.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof P.FunctionBreakpoint&&o.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(s){const i=s.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],i,[]);const o=i.filter(C=>C instanceof P.SourceBreakpoint).map(C=>C.id),S=i.filter(C=>C instanceof P.FunctionBreakpoint).map(C=>C.id),b=i.filter(C=>C instanceof P.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(o,S,b)}startDebugging(s,i,o){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,o){if(!i)return new P.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:S,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,S),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(s,i,o){if(!o)return new P.Disposable(()=>{});if(!this.definesDebugType(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:S,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,S),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new P.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:o,factory:i}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let o;const S=await this.getFolder(s);return S&&(o={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,i)}createDebugAdapter(s,i){if(s.type==="implementation")return new D(s.implementation)}createSignService(){}async $startDASession(s,i){const o=this,S=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.convertToDto(b),I=this.createDebugAdapter(C,S);if(!I)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const c=I;return this._debugAdapters.set(s,c),this.getDebugAdapterTrackers(S).then(h=>(h&&this._debugAdaptersTrackers.set(s,h),c.onMessage(async u=>{if(u.type==="request"&&u.command==="handshake"){const A=u,B={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(A.arguments.value);B.body={signature:H},c.sendResponse(B)}else throw new Error("no signer")}catch(H){B.success=!1,B.message=H.message,c.sendResponse(B)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(u),u=(0,v.convertToVSCPaths)(u,!0),o._debugServiceProxy.$acceptDAMessage(s,u)}),c.onError(u=>{h&&h.onError&&h.onError(u),this._debugServiceProxy.$acceptDAError(s,u.name,u.message,u.stack)}),c.onExit(u=>{h&&h.onExit&&h.onExit(u??void 0,void 0),this._debugServiceProxy.$acceptDAExit(s,u??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),c.startSession()))})}$sendDAMessage(s,i){i=(0,v.convertToDAPaths)(i,!1);const o=this._debugAdaptersTrackers.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this._debugAdapters.get(s)?.sendMessage(i)}$stopDASession(s){const i=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const o=this._debugAdapters.get(s);return this._debugAdapters.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],o=[],S=[];if(s.added)for(const b of s.added){const C=b.id;if(C&&!this._breakpoints.has(C)){let I;if(b.type==="function")I=new P.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")I=new P.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const c=k.URI.revive(b.uri);I=new P.SourceBreakpoint(new P.Location(c,new P.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}(0,P.setBreakpointId)(I,C),this._breakpoints.set(C,I),i.push(I)}}if(s.removed)for(const b of s.removed){const C=this._breakpoints.get(b);C&&(this._breakpoints.delete(b),o.push(C))}if(s.changed){for(const b of s.changed)if(b.id){const C=this._breakpoints.get(b.id);if(C){if(C instanceof P.FunctionBreakpoint&&b.type==="function"){const I=C;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.functionName=b.functionName}else if(C instanceof P.SourceBreakpoint&&b.type==="source"){const I=C;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.location=new P.Location(k.URI.revive(b.uri),new P.Position(b.line,b.character))}S.push(C)}}}this.fireBreakpointChanges(i,o,S)}async $acceptStackFrameFocus(s){let i;const o=s.sessionId?await this.getSession(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?i=new P.ThreadFocus(o,s.threadId):i=new P.StackFrameFocus(o,s.threadId,s.frameId),this._stackFrameFocus=i,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(s,i,o){return(0,w.asPromise)(async()=>{const S=this.getConfigProviderByHandle(s);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(i);return S.provideDebugConfigurations(b,o)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(s,i,o,S){return(0,w.asPromise)(async()=>{const b=this.getConfigProviderByHandle(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(i);return b.resolveDebugConfiguration(C,o,S)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,o,S){return(0,w.asPromise)(async()=>{const b=this.getConfigProviderByHandle(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(i);return b.resolveDebugConfigurationWithSubstitutedVariables(C,o,S)})}async $provideDebugAdapter(s,i){const o=this.getAdapterDescriptorFactoryByHandle(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(i);return this.getAdapterDescriptor(o,S).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(s){const i=await this.getSession(s);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.getSession(s);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,i){(await this.getSession(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const S={session:await this.getSession(s),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(s){if(s instanceof P.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const i=this._adapterFactories.filter(o=>o.type===s);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(s){const i=this._adapterFactories.filter(o=>o.handle===s);if(i.length>0)return i[0].factory}getConfigProviderByHandle(s){const i=this._configProviders.filter(o=>o.handle===s);if(i.length>0)return i[0].provider}definesDebugType(s,i){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const S of o)if(S.label&&S.type&&S.type===i)return!0}}return!1}getDebugAdapterTrackers(s){const o=s.configuration.type,S=this._trackerFactories.filter(b=>b.type===o||b.type==="*").map(b=>(0,w.asPromise)(()=>b.factory.createDebugAdapterTracker(s)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(b=>{const C=b.filter(I=>!!I);if(C.length>0)return new E(C)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async getAdapterDescriptor(s,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.DebugAdapterServer(o));if(s){const b=await this._extensionService.getExtensionRegistry();return(0,w.asPromise)(()=>s.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,b))).then(C=>{if(C)return C})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,S))}daExecutableFromPackage(s,i){}fireBreakpointChanges(s,i,o){(s.length>0||i.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:i,changed:o}))}async getSession(s){if(s)if(typeof s=="string"){const i=this._debugSessions.get(s);if(i)return i}else{let i=this._debugSessions.get(s.id);if(!i){const o=await this.getFolder(s.folderUri),S=s.parent?this._debugSessions.get(s.parent):void 0;i=new n(this._debugServiceProxy,s.id,s.type,s.name,o,s.configuration,S),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(s){if(s){const i=k.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=t,e.ExtHostDebugServiceBase=t=Ve([We(0,m.IExtHostRpcService),We(1,_.IExtHostWorkspace),We(2,y.IExtHostExtensionService),We(3,g.IExtHostConfiguration),We(4,d.IExtHostEditorTabs),We(5,f.IExtHostVariableResolverProvider)],t);class n{constructor(s,i,o,S,b,C,I){this._debugServiceProxy=s,this._id=i,this._type=o,this._name=S,this._workspaceFolder=b,this._configuration=C,this._parentSession=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,i)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=n;class l{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=l;class E{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.trackers.forEach(o=>o.onExit?o.onExit(s,i):void 0)}}class D extends a.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(s,i,o,S,b,C){super(s,i,o,S,b,C)}};e.WorkerExtHostDebugService=p,e.WorkerExtHostDebugService=p=Ve([We(0,m.IExtHostRpcService),We(1,_.IExtHostWorkspace),We(2,y.IExtHostExtensionService),We(3,g.IExtHostConfiguration),We(4,d.IExtHostEditorTabs),We(5,f.IExtHostVariableResolverProvider)],p)}),define(Te[271],Ae([1,0,9,87,2,3,262,14,71,72,27,172,17,56,35,58]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class t{static async installEarlyHandler(E){Error.stackTraceLimit=100;const D=E.get(d.ILogService),r=E.get(a.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{D.error(s);const i=w.transformErrorForSerialization(s);r.$onUnexpectedError(i)})}static async installFullHandler(E){const D=E.get(d.ILogService),p=E.get(a.IExtHostRpcService),r=E.get(g.IExtHostExtensionService),s=E.get(f.IExtHostTelemetry),i=p.getProxy(F.MainContext.MainThreadExtensionService),o=p.getProxy(F.MainContext.MainThreadErrors),S=await r.getExtensionPathIndex(),b=new WeakMap;function C(h,u){if(b.has(h))return b.get(h).stack;let A="",B,H;for(const z of u)A+=`
	at ${z.toString()}`,H=z.getFileName(),!B&&H&&(B=S.findSubstr(k.URI.file(H)));const U=`${h.name||"Error"}: ${h.message||""}${A}`;return b.set(h,{extensionIdentifier:B?.identifier,stack:U}),U}const I=Symbol("prepareStackTrace wrapped");let c=C;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return c},set(h){if(h===C||!h||h[I]){c=h||C;return}c=function(u,A){return C(u,A),h.call(Error,u,A)},Object.assign(c,{[I]:!0})}}),w.setUnexpectedErrorHandler(h=>{D.error(h);const u=w.transformErrorForSerialization(h),A=b.get(h);if(!A?.extensionIdentifier){o.$onUnexpectedError(u);return}i.$onExtensionRuntimeError(A.extensionIdentifier,u);const B=s.onExtensionError(A.extensionIdentifier,h);D.trace("forwarded error to extension?",B,A)})}}e.ErrorHandler=t;class n{constructor(E,D,p,r,s){this._hostUtils=p,this._rpcProtocol=new T.RPCProtocol(E,null,r),D=n._transform(D,this._rpcProtocol);const i=new m.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());i.set(P.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:s}),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),i.set(v.IURITransformerService,new v.URITransformerService(r)),i.set(g.IHostUtils,p);const o=new _.InstantiationService(i,!0);o.invokeFunction(t.installEarlyHandler),this._logService=o.invokeFunction(S=>S.get(d.ILogService)),R.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=o.invokeFunction(S=>S.get(g.IExtHostExtensionService)),this._extensionService.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(E){const D=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService);return k.URI.revive(await D.$asBrowserUri(E))}terminate(E){this._extensionService.terminate(E)}static _transform(E,D){E.extensions.allExtensions.forEach(r=>{r.extensionLocation=k.URI.revive(D.transformIncomingURIs(r.extensionLocation))}),E.environment.appRoot=k.URI.revive(D.transformIncomingURIs(E.environment.appRoot));const p=E.environment.extensionDevelopmentLocationURI;return p&&(E.environment.extensionDevelopmentLocationURI=p.map(r=>k.URI.revive(D.transformIncomingURIs(r)))),E.environment.extensionTestsLocationURI=k.URI.revive(D.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=k.URI.revive(D.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=k.URI.revive(D.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=k.URI.revive(D.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=k.URI.revive(D.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=k.URI.revive(D.transformIncomingURIs(E.logsLocation)),E.workspace=D.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=n}),define(Te[272],Ae([1,0,18,12,21,41,13,19,23,2,47]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(l,E,D,p){this.query=l,this.provider=E,this.fileUtils=D,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,E){const D=this.query.folderQueries||[],p=new k.CancellationTokenSource(E);return new Promise((r,s)=>{this.collector=new v(l);let i=!1;const o=(S,b)=>{if(!i&&!this.isLimitHit){const C=this.resultSize(S);f(S)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,i=!0,p.cancel(),S=this.trimResultToSize(S,this.query.maxResults-this.resultCount));const I=this.resultSize(S);this.resultCount+=I,(I>0||!f(S))&&this.collector.add(S,b)}};Promise.all(D.map((S,b)=>this.searchInFolder(S,C=>o(C,b),p.token))).then(S=>{p.dispose(),this.collector.flush();const b=S.some(C=>!!C&&!!C.limitHit);r({limitHit:this.isLimitHit||b,messages:(0,w.flatten)(S.map(C=>C?.message?Array.isArray(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},S=>{p.dispose();const b=(0,F.toErrorMessage)(S);s(new Error(b))})})}resultSize(l){return f(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,E){const D=Array.isArray(l.ranges)?l.ranges:[l.ranges],p=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:D.slice(0,E),preview:{matches:p.slice(0,E),text:l.preview.text},uri:l.uri}}async searchInFolder(l,E,D){const p=new P.QueryGlobTester(this.query,l),r=[],s={report:S=>{if(!this.validateProviderResult(S))return;const b=l.folder.scheme===T.Schemas.file?(0,P.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(S.uri))):void 0,C=y.relativePath(l.folder,S.uri);if(C){const I=p.includedInQuery(C,d.basename(C),b);(0,R.isThenable)(I)?r.push(I.then(c=>{c&&E(S)})):I&&E(S)}}},i=this.getSearchOptionsForFolder(l),o=await this.provider.provideTextSearchResults(a(this.query.contentPattern),i,s,D);return r.length&&await Promise.all(r),o}validateProviderResult(l){if(f(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const E=(0,P.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),D=(0,P.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),p={folder:m.URI.from(l.folder),excludes:D,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=_;function a(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class v{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,E=>this.sendItems(E))}add(l,E){this._currentFileMatch&&(this._currentFolderIdx!==E||!y.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=E,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(g(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=v;function g(n){return f(n)?{preview:{matches:(0,w.mapArrayOrNot)(n.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:n.preview.text},ranges:(0,w.mapArrayOrNot)(n.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function f(n){return!!n.preview}e.extensionResultIsMatch=f;class t{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(l,E){this.maxBatchSize=l,this.cb=E,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,E){l&&this.addItemToBatch(l,E)}addItems(l,E){l&&this.addItemsToBatch(l,E)}addItemToBatch(l,E){this.batch.push(l),this.batchSize+=E,this.onUpdate()}addItemsToBatch(l,E){this.batch=this.batch.concat(l),this.batchSize+=E,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t}),define(Te[114],Ae([1,0,6,3,4,267,17,56,14,2,272]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let _=class{constructor(f,t,n){this.extHostRpc=f,this._uriTransformer=t,this._logService=n,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new F.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const n=this._handlePool++;return this._textSearchProvider.set(n,t),this._proxy.$registerTextSearchProvider(n,this._transformScheme(f)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(n),this._proxy.$unregisterProvider(n)})}registerFileSearchProvider(f,t){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const n=this._handlePool++;return this._fileSearchProvider.set(n,t),this._proxy.$registerFileSearchProvider(n,this._transformScheme(f)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(n),this._proxy.$unregisterProvider(n)})}$provideFileSearchResults(f,t,n,l){const E=a(n),D=this._fileSearchProvider.get(f);if(D)return this._fileSearchManager.fileSearch(E,D,p=>{this._proxy.$handleFileMatch(f,t,p.map(r=>r.resource))},l);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,n,l){const E=this._textSearchProvider.get(f);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const D=a(n);return this.createTextSearchManager(D,E).search(r=>this._proxy.$handleTextMatch(f,t,r),l)}$enableExtensionHostSearch(){}createTextSearchManager(f,t){return new P.TextSearchManager(f,t,{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}};e.ExtHostSearch=_,e.ExtHostSearch=_=Ve([We(0,T.IExtHostRpcService),We(1,d.IURITransformerService),We(2,y.ILogService)],_);function a(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(v),extraFileResources:g.extraFileResources&&g.extraFileResources.map(f=>m.URI.revive(f))}}e.reviveQuery=a;function v(g){return{...g,folder:m.URI.revive(g.folder)}}}),define(Te[273],Ae([1,0,21,9,5,29,2,135,284,124,133,38,3,79,225,224,31,226,34,228,229,230,203,231,60,35,234,235,240,241,243,109,207,249,250,252,84,63,254,210,8,7,53,257,64,108,33,20,198,239,52,107,111,113,114,14,56,17,27,244,196,86,80,217,255,85,62,260,258,259,218,39,253,256,83,61,58,245,110,246,13,95,206,189,237,6,26,194,81,185,247,248,219,236,205,238,82,251,221,222,223,216,233,220]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r,s,i,o,S,b,C,I,c,h,u,A,B,H,U,z,M,N,ee,Q,Se,ye,Pe,Y,ue,_e,ce,pe,ie,x,W,le,we,Ee,me,De,re,de,se,oe,fe,Ie,O,V,K,G,q,Z,ae,Me,Ue,Ge,je,Je,Ye,et,it,tt,xe,st,J,X,ve,Be,Ne,Xe,nt,ht,wt,Pt,Xt,Vt,vt,$t,Nt,Bt,Tt,At,xt,zt,qt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Wt(ot){const ft=ot.get(re.IExtHostInitDataService),Rt=ot.get(Me.IExtHostFileSystemInfo),Ot=ot.get(K.IExtHostConsumerFileSystem),It=ot.get(o.IExtHostExtensionService),dt=ot.get(ue.IExtHostWorkspace),yt=ot.get(Ye.IExtHostTelemetry),Dt=ot.get(l.IExtHostConfiguration),Ft=ot.get(me.IURITransformerService),He=ot.get(De.IExtHostRpcService),ke=ot.get(U.IExtHostStorage),Re=ot.get(V.IExtensionStoragePaths),ge=ot.get(Ee.ILoggerService),j=ot.get(Ee.ILogService),Oe=ot.get(oe.IExtHostTunnelService),$e=ot.get(fe.IExtHostApiDeprecationService),Ke=ot.get(Y.IExtHostWindow),ze=ot.get(je.IExtHostSecretState),Ze=ot.get(Je.IExtHostEditorTabs),pt=ot.get(Nt.IExtHostManagedSockets);He.set(a.ExtHostContext.ExtHostFileSystemInfo,Rt),He.set(a.ExtHostContext.ExtHostLogLevelServiceShape,ge),He.set(a.ExtHostContext.ExtHostWorkspace,dt),He.set(a.ExtHostContext.ExtHostConfiguration,Dt),He.set(a.ExtHostContext.ExtHostExtensionService,It),He.set(a.ExtHostContext.ExtHostStorage,ke),He.set(a.ExtHostContext.ExtHostTunnelService,Oe),He.set(a.ExtHostContext.ExtHostWindow,Ke),He.set(a.ExtHostContext.ExtHostSecretState,ze),He.set(a.ExtHostContext.ExtHostTelemetry,yt),He.set(a.ExtHostContext.ExtHostEditorTabs,Ze),He.set(a.ExtHostContext.ExtHostManagedSockets,pt);const kt=He.set(a.ExtHostContext.ExtHostDecorations,ot.get(x.IExtHostDecorations)),bt=He.set(a.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(i.IExtHostDocumentsAndEditors)),lt=He.set(a.ExtHostContext.ExtHostCommands,ot.get(t.IExtHostCommands)),gt=He.set(a.ExtHostContext.ExtHostTerminalService,ot.get(z.IExtHostTerminalService)),St=He.set(a.ExtHostContext.ExtHostDebugService,ot.get(le.IExtHostDebugService)),mi=He.set(a.ExtHostContext.ExtHostSearch,ot.get(we.IExtHostSearch)),jt=He.set(a.ExtHostContext.ExtHostTask,ot.get(W.IExtHostTask)),Qt=He.set(a.ExtHostContext.ExtHostOutputService,ot.get(h.IExtHostOutputService)),si=He.set(a.ExtHostContext.ExtHostLocalization,ot.get(nt.IExtHostLocalizationService)),yi=He.set(a.ExtHostContext.ExtHostUrls,new ye.ExtHostUrls(He)),Ct=He.set(a.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(He,bt)),Qi=He.set(a.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(He,bt,j)),ln=He.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(j,Ct,He.getProxy(a.MainContext.MainThreadBulkEdits))),Et=He.set(a.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(He,lt,bt,Ct,Ot)),gi=He.set(a.ExtHostContext.ExtHostNotebookDocuments,new X.ExtHostNotebookDocuments(Et)),pi=He.set(a.ExtHostContext.ExtHostNotebookEditors,new J.ExtHostNotebookEditors(j,Et)),oi=He.set(a.ExtHostContext.ExtHostNotebookKernels,new et.ExtHostNotebookKernels(He,ft,Et,lt,j)),Di=He.set(a.ExtHostContext.ExtHostNotebookRenderers,new tt.ExtHostNotebookRenderers(He,Et)),Ci=He.set(a.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new vt.ExtHostNotebookDocumentSaveParticipant(j,Et,He.getProxy(a.MainContext.MainThreadBulkEdits))),Lt=He.set(a.ExtHostContext.ExtHostEditors,new M.ExtHostEditors(He,bt)),vi=He.set(a.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(He.getProxy(a.MainContext.MainThreadTreeViews),lt,j)),Ii=He.set(a.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(He.getProxy(a.MainContext.MainThreadEditorInsets),Lt,ft.remote)),ai=He.set(a.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(He,j,Rt,bt)),ci=He.set(a.ExtHostContext.ExtHostLanguages,new I.ExtHostLanguages(He,Ct,lt.converter,Ft)),ct=He.set(a.ExtHostContext.ExtHostLanguageFeatures,new C.ExtHostLanguageFeatures(He,Ft,Ct,lt,ai,j,$e,yt)),ki=He.set(a.ExtHostContext.ExtHostFileSystem,new S.ExtHostFileSystem(He,ct)),Yt=He.set(a.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(He,j,bt)),ii=He.set(a.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(He,dt,lt)),Ei=He.set(a.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(He,lt,Ct,j)),Yi=He.set(a.ExtHostContext.ExtHostQuickDiff,new Pt.ExtHostQuickDiff(He,Ft)),Pi=He.set(a.ExtHostContext.ExtHostShare,new Bt.ExtHostShare(He,Ft)),Ti=He.set(a.ExtHostContext.ExtHostComments,(0,n.createExtHostComments)(He,lt,Ct)),Ai=He.set(a.ExtHostContext.ExtHostProgress,new u.ExtHostProgress(He.getProxy(a.MainContext.MainThreadProgress))),Ji=He.set(a.ExtHostContext.ExtHosLabelService,new pe.ExtHostLabelService(He)),Ri=He.set(a.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(He)),li=He.set(a.ExtHostContext.ExtHostAuthentication,new Ie.ExtHostAuthentication(He)),Zi=He.set(a.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(He,lt)),Oi=He.set(a.ExtHostContext.ExtHostWebviews,new Pe.ExtHostWebviews(He,ft.remote,dt,j,$e)),Fi=He.set(a.ExtHostContext.ExtHostWebviewPanels,new Z.ExtHostWebviewPanels(He,Oi,dt)),Li=He.set(a.ExtHostContext.ExtHostCustomEditors,new q.ExtHostCustomEditors(He,Ct,Re,Oi,Fi)),Mi=He.set(a.ExtHostContext.ExtHostWebviewViews,new G.ExtHostWebviewViews(He,Oi)),di=He.set(a.ExtHostContext.ExtHostTesting,new Ue.ExtHostTesting(He,lt,bt)),un=He.set(a.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(He)),en=He.set(a.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(He));He.set(a.ExtHostContext.ExtHostInteractive,new ve.ExtHostInteractive(He,Et,bt,lt,j));const Ni=He.set(a.ExtHostContext.ExtHostInlineChat,new Vt.ExtHostInteractiveEditor(He,lt,Ct,j)),hi=He.set(a.ExtHostContext.ExtHostChatProvider,new Tt.ExtHostChatProvider(He,j)),tn=He.set(a.ExtHostContext.ExtHostChatSlashCommands,new At.ExtHostChatSlashCommands(He,hi,j)),nn=He.set(a.ExtHostContext.ExtHostChatAgents,new Ht.ExtHostChatAgents(He,hi,j)),dn=He.set(a.ExtHostContext.ExtHostChatVariables,new xt.ExtHostChatVariables(He)),ni=He.set(a.ExtHostContext.ExtHostChat,new Xt.ExtHostChat(He,j)),xi=He.set(a.ExtHostContext.ExtHostAiRelatedInformation,new zt.ExtHostRelatedInformation(He)),Zt=He.set(a.ExtHostContext.ExtHostAiEmbeddingVector,new qt.ExtHostAiEmbeddingVector(He)),bi=He.set(a.ExtHostContext.ExtHostIssueReporter,new $t.ExtHostIssueReporter(He)),rn=He.set(a.ExtHostContext.ExtHostStatusBar,new H.ExtHostStatusBar(He,lt.converter)),Kt=Object.values(a.ExtHostContext);He.assertRegistered(Kt);const wi=new ae.ExtHostBulkEdits(He,bt),sn=new f.ExtHostClipboard(He),Si=new c.ExtHostMessageService(He,j),Ui=new D.ExtHostDialogs(He);return g.ExtHostApiCommands.register(lt),function(Le,ei,$i){const mt=function(){let te=!Le.isUnderDevelopment;function he(){te||(j.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")he();else{const _t=rt;typeof _t.scheme>"u"&&he(),typeof _t.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return rt}}(),hn={getSession(te,he,Fe){return li.getSession(Le,te,he,Fe)},getSessions(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"authGetSessions"),li.getSessions(Le,te,he)},async hasSession(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"authSession"),!!await li.getSession(Le,te,he,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(te,he,Fe,rt){return li.registerAuthenticationProvider(te,he,Fe,rt)}},fn={registerCommand(te,he,Fe){return lt.registerCommand(!0,te,he,Fe,void 0,Le)},registerTextEditorCommand(te,he,Fe){return lt.registerCommand(!0,te,(...rt)=>{const _t=Lt.getActiveTextEditor();if(!_t){j.warn("Cannot execute "+te+" because there is no active text editor.");return}return _t.edit(Mt=>{he.apply(Fe,[_t,Mt,...rt])}).then(Mt=>{Mt||j.warn("Edits from command "+te+" were not applied.")},Mt=>{j.warn("An error occurred while running command "+te,Mt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"diffCommand"),lt.registerCommand(!0,te,async(...rt)=>{const _t=bt.activeEditor(!0);if(!_t){j.warn("Cannot execute "+te+" because there is no active text editor.");return}const Mt=await Lt.getDiffInformation(_t.id);he.apply(Fe,[Mt,...rt])},void 0,void 0,Le)),executeCommand(te,...he){return lt.executeCommand(te,...he)},getCommands(te=!1){return lt.getCommands(te)}},_i={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Le,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Le,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,he){return Ye.ExtHostTelemetryLogger.validateSender(te),yt.instantiateLogger(Le,te,he)},openExternal(te,he){return Ke.openUri(te,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ft.environment.appUriScheme)return yi.createAppUri(te);try{return await Ke.asExternalUri(te,{allowTunneling:!!ft.remote.authority})}catch(he){if((0,st.matchesScheme)(te,xe.Schemas.http)||(0,st.matchesScheme)(te,xe.Schemas.https))return te;throw he}},get remoteName(){return(0,ie.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return j.getLevel()},get onDidChangeLogLevel(){return j.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.checkProposedApiEnabled)(Le,"handleIssueUri"),bi.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ft.quality},get appCommit(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(_i);const on={createTestController(te,he,Fe){return di.createTestController(Le,te,he,Fe)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),di.createTestObserver()},runTests(te){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),di.runTests(te)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),di.results}},fi=ft.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,an={getExtension(te,he){(0,Ne.isProposedApiEnabled)(Le,"extensionsAny")||(he=!1);const Fe=ei.mine.getExtensionDescription(te);if(Fe)return new o.Extension(It,Le.identifier,Fe,fi,!1);if(he){const rt=ei.all.getExtensionDescription(te);if(rt)return new o.Extension(It,Le.identifier,rt,fi,!0)}},get all(){const te=[];for(const he of ei.mine.getAllExtensionDescriptions())te.push(new o.Extension(It,Le.identifier,he,fi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(Le,"extensionsAny");const te=new _e.ExtensionIdentifierSet(ei.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),he=[];for(const Fe of ei.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);he.push(new o.Extension(It,Le.identifier,Fe,fi,rt))}return he},get onDidChange(){return(0,Ne.isProposedApiEnabled)(Le,"extensionsAny")?k.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},mn={createDiagnosticCollection(te){return ai.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:te=>ai.getDiagnostics(te),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(te,he){return ci.changeLanguage(te.uri,he)},match(te,he){const Fe=Ct.getDocumentData(he.uri)?.notebook;return(0,P.score)(ee.LanguageSelector.from(te),he.uri,he.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,he,Fe){return ct.registerCodeActionProvider(Le,mt(te),he,Fe)},registerDocumentPasteEditProvider(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,mt(te),he,Fe)},registerCodeLensProvider(te,he){return ct.registerCodeLensProvider(Le,mt(te),he)},registerDefinitionProvider(te,he){return ct.registerDefinitionProvider(Le,mt(te),he)},registerDeclarationProvider(te,he){return ct.registerDeclarationProvider(Le,mt(te),he)},registerImplementationProvider(te,he){return ct.registerImplementationProvider(Le,mt(te),he)},registerTypeDefinitionProvider(te,he){return ct.registerTypeDefinitionProvider(Le,mt(te),he)},registerHoverProvider(te,he){return ct.registerHoverProvider(Le,mt(te),he,Le.identifier)},registerEvaluatableExpressionProvider(te,he){return ct.registerEvaluatableExpressionProvider(Le,mt(te),he,Le.identifier)},registerInlineValuesProvider(te,he){return ct.registerInlineValuesProvider(Le,mt(te),he,Le.identifier)},registerDocumentHighlightProvider(te,he){return ct.registerDocumentHighlightProvider(Le,mt(te),he)},registerLinkedEditingRangeProvider(te,he){return ct.registerLinkedEditingRangeProvider(Le,mt(te),he)},registerReferenceProvider(te,he){return ct.registerReferenceProvider(Le,mt(te),he)},registerRenameProvider(te,he){return ct.registerRenameProvider(Le,mt(te),he)},registerDocumentSymbolProvider(te,he,Fe){return ct.registerDocumentSymbolProvider(Le,mt(te),he,Fe)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,he){return ct.registerDocumentFormattingEditProvider(Le,mt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return ct.registerDocumentRangeFormattingEditProvider(Le,mt(te),he)},registerOnTypeFormattingEditProvider(te,he,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Le,mt(te),he,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,he,Fe){return ct.registerDocumentSemanticTokensProvider(Le,mt(te),he,Fe)},registerDocumentRangeSemanticTokensProvider(te,he,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Le,mt(te),he,Fe)},registerSignatureHelpProvider(te,he,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Le,mt(te),he,Fe):ct.registerSignatureHelpProvider(Le,mt(te),he,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,he,...Fe){return ct.registerCompletionItemProvider(Le,mt(te),he,Fe)},registerInlineCompletionItemProvider(te,he,Fe){return he.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,mt(te),he,Fe)},registerDocumentLinkProvider(te,he){return ct.registerDocumentLinkProvider(Le,mt(te),he)},registerColorProvider(te,he){return ct.registerColorProvider(Le,mt(te),he)},registerFoldingRangeProvider(te,he){return ct.registerFoldingRangeProvider(Le,mt(te),he)},registerSelectionRangeProvider(te,he){return ct.registerSelectionRangeProvider(Le,te,he)},registerCallHierarchyProvider(te,he){return ct.registerCallHierarchyProvider(Le,te,he)},registerTypeHierarchyProvider(te,he){return ct.registerTypeHierarchyProvider(Le,te,he)},setLanguageConfiguration:(te,he)=>ct.setLanguageConfiguration(Le,te,he),getTokenInformationAtPosition(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"tokenInformation"),ci.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return ct.registerInlayHintsProvider(Le,te,he)},createLanguageStatusItem(te,he){return ci.createLanguageStatusItem(Le,te,he)},registerDocumentDropEditProvider(te,he,Fe){return ct.registerDocumentOnDropEditProvider(Le,te,he,(0,Ne.isProposedApiEnabled)(Le,"dropMetadata")?Fe:void 0)}},gn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,he,Fe){const rt=await(T.URI.isUri(te)?Promise.resolve(Bi.openTextDocument(te)):Promise.resolve(te));return Lt.showTextDocument(rt,he,Fe)},createTextEditorDecorationType(te){return Lt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,he,Fe){return Lt.onDidChangeActiveTextEditor(te,he,Fe)},onDidChangeVisibleTextEditors(te,he,Fe){return Lt.onDidChangeVisibleTextEditors(te,he,Fe)},onDidChangeTextEditorSelection(te,he,Fe){return Lt.onDidChangeTextEditorSelection(te,he,Fe)},onDidChangeTextEditorOptions(te,he,Fe){return Lt.onDidChangeTextEditorOptions(te,he,Fe)},onDidChangeTextEditorVisibleRanges(te,he,Fe){return Lt.onDidChangeTextEditorVisibleRanges(te,he,Fe)},onDidChangeTextEditorViewColumn(te,he,Fe){return Lt.onDidChangeTextEditorViewColumn(te,he,Fe)},onDidCloseTerminal(te,he,Fe){return gt.onDidCloseTerminal(te,he,Fe)},onDidOpenTerminal(te,he,Fe){return gt.onDidOpenTerminal(te,he,Fe)},onDidChangeActiveTerminal(te,he,Fe){return gt.onDidChangeActiveTerminal(te,he,Fe)},onDidChangeTerminalDimensions(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalDimensions"),gt.onDidChangeTerminalDimensions(te,he,Fe)},onDidChangeTerminalState(te,he,Fe){return gt.onDidChangeTerminalState(te,he,Fe)},onDidWriteTerminalData(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(te,he,Fe)},onDidExecuteTerminalCommand(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(te,he,Fe)},get state(){return Ke.getState(Le)},onDidChangeWindowState(te,he,Fe){return Ke.onDidChangeWindowState(te,he,Fe)},showInformationMessage(te,...he){return Si.showMessage(Le,F.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Si.showMessage(Le,F.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Si.showMessage(Le,F.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Fe){return ii.showQuickPick(Le,te,he,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,he){return ii.showInput(te,he)},showOpenDialog(te){return Ui.showOpenDialog(Le,te)},showSaveDialog(te){return Ui.showSaveDialog(te)},createStatusBarItem(te,he,Fe){let rt,_t,Mt;return typeof te=="string"?(rt=te,_t=he,Mt=Fe):(_t=te,Mt=he),rn.createStatusBarEntry(Le,rt,_t,Mt)},setStatusBarMessage(te,he){return rn.setStatusBarMessage(te,he)},withScmProgress(te){return $e.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ai.withProgress(Le,{location:Q.ProgressLocation.SourceControl},(he,Fe)=>te({report(rt){}}))},withProgress(te,he){return Ai.withProgress(Le,te,he)},createOutputChannel(te,he){return Qt.createOutputChannel(te,he,Le)},createWebviewPanel(te,he,Fe,rt){return Fi.createWebviewPanel(Le,te,he,Fe,rt)},createWebviewTextEditorInset(te,he,Fe,rt){return(0,Ne.checkProposedApiEnabled)(Le,"editorInsets"),Ii.createWebviewEditorInset(te,he,Fe,rt,Le)},createTerminal(te,he,Fe){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):gt.createTerminalFromOptions(te):gt.createTerminal(te,he,Fe)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return gt.registerProfileProvider(Le,te,he)},registerTerminalQuickFixProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(te,Le.identifier.value,he)},registerTreeDataProvider(te,he){return vi.registerTreeDataProvider(te,he,Le)},createTreeView(te,he){return vi.createTreeView(te,he,Le)},registerWebviewPanelSerializer:(te,he)=>Fi.registerWebviewPanelSerializer(Le,te,he),registerCustomEditorProvider:(te,he,Fe={})=>Li.registerCustomEditorProvider(Le,te,he,Fe),registerFileDecorationProvider(te){return kt.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return yi.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(te,he,Fe){return Ri.onDidChangeActiveColorTheme(te,he,Fe)},registerWebviewViewProvider(te,he,Fe){return Mi.registerWebviewViewProvider(Le,te,he,Fe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Fe){return Et.onDidChangeActiveNotebookEditor(te,he,Fe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Fe){return pi.onDidChangeNotebookEditorSelection(te,he,Fe)},onDidChangeNotebookEditorVisibleRanges(te,he,Fe){return pi.onDidChangeNotebookEditorVisibleRanges(te,he,Fe)},showNotebookDocument(te,he){return Et.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"externalUriOpener"),un.registerExternalUriOpener(Le.identifier,te,he,Fe)},registerProfileContentHandler(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"profileContentHandlers"),en.registrProfileContentHandler(Le,te,he)},registerQuickDiffProvider(te,he,Fe,rt){return(0,Ne.checkProposedApiEnabled)(Le,"quickDiffProvider"),Yi.registerQuickDiffProvider(mt(te),he,Fe,rt)},get tabGroups(){return Ze.tabGroups},registerShareProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"shareProvider"),Pi.registerShareProvider(mt(te),he)}},Bi={get rootPath(){return $e.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(te){throw new R.ReadonlyError("rootPath")},getWorkspaceFolder(te){return dt.getWorkspaceFolder(te)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(te){throw new R.ReadonlyError("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(te){throw new R.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(te,he,...Fe)=>dt.updateWorkspaceFolders(Le,te,he||0,...Fe),onDidChangeWorkspaceFolders:function(te,he,Fe){return dt.onDidChangeWorkspace(te,he,Fe)},asRelativePath:(te,he)=>dt.getRelativePath(te,he),findFiles:(te,he,Fe,rt)=>dt.findFiles(te,he,Fe,Le.identifier,rt),findTextInFiles:(te,he,Fe,rt)=>{(0,Ne.checkProposedApiEnabled)(Le,"findTextInFiles");let _t,Mt;return typeof he=="object"?(_t=he,Mt=Fe):(_t={},Mt=he,rt=Fe),dt.findTextInFiles(te,_t||{},Mt,Le.identifier,rt)},save:te=>((0,Ne.checkProposedApiEnabled)(Le,"saveEditor"),dt.save(te)),saveAs:te=>((0,Ne.checkProposedApiEnabled)(Le,"saveEditor"),dt.saveAs(te)),saveAll:te=>dt.saveAll(te),applyEdit(te,he){return wi.applyWorkspaceEdit(te,Le,he)},createFileSystemWatcher:(te,he,Fe,rt)=>Yt.createFileSystemWatcher(dt,Le,te,he,Fe,rt),get textDocuments(){return Ct.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new R.ReadonlyError("textDocuments")},openTextDocument(te){let he;const Fe=te;if(typeof te=="string")he=Promise.resolve(T.URI.file(te));else if(T.URI.isUri(te))he=Promise.resolve(te);else if(!Fe||typeof Fe=="object")he=Ct.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>Ct.ensureDocumentData(rt).then(_t=>_t.document))},onDidOpenTextDocument:(te,he,Fe)=>Ct.onDidAddDocument(te,he,Fe),onDidCloseTextDocument:(te,he,Fe)=>Ct.onDidRemoveDocument(te,he,Fe),onDidChangeTextDocument:(te,he,Fe)=>Ct.onDidChangeDocument(te,he,Fe),onDidSaveTextDocument:(te,he,Fe)=>Ct.onDidSaveDocument(te,he,Fe),onWillSaveTextDocument:(te,he,Fe)=>ln.getOnWillSaveTextDocumentEvent(Le)(te,he,Fe),get notebookDocuments(){return Et.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Fe;if(T.URI.isUri(te))Fe=te,await Et.openNotebookDocument(te);else if(typeof te=="string")Fe=T.URI.revive(await Et.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,he,Fe){return gi.onDidSaveNotebookDocument(te,he,Fe)},onDidChangeNotebookDocument(te,he,Fe){return gi.onDidChangeNotebookDocument(te,he,Fe)},onWillSaveNotebookDocument(te,he,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Le)(te,he,Fe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Fe,rt){return Et.registerNotebookSerializer(Le,te,he,Fe,(0,Ne.isProposedApiEnabled)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,he,Fe)=>$i.onDidChangeConfiguration(te,he,Fe),getConfiguration(te,he){return he=arguments.length===1?void 0:he,$i.getConfiguration(te,he,Le)},registerTextDocumentContentProvider(te,he){return Qi.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>($e.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),jt.registerTaskProvider(Le,te,he)),registerFileSystemProvider(te,he,Fe){return(0,Be.combinedDisposable)(ki.registerFileSystemProvider(Le,te,he,Fe),Ot.addFileSystemProvider(te,he,Fe))},get fs(){return Ot.value},registerFileSearchProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"fileSearchProvider"),mi.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"textSearchProvider"),mi.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),It.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),It.getRemoteExecServer(te)),onDidCreateFiles:(te,he,Fe)=>Yt.onDidCreateFile(te,he,Fe),onDidDeleteFiles:(te,he,Fe)=>Yt.onDidDeleteFile(te,he,Fe),onDidRenameFiles:(te,he,Fe)=>Yt.onDidRenameFile(te,he,Fe),onWillCreateFiles:(te,he,Fe)=>Yt.getOnWillCreateFileEvent(Le)(te,he,Fe),onWillDeleteFiles:(te,he,Fe)=>Yt.getOnWillDeleteFileEvent(Le)(te,he,Fe),onWillRenameFiles:(te,he,Fe)=>Yt.getOnWillRenameFileEvent(Le)(te,he,Fe),openTunnel:te=>((0,Ne.checkProposedApiEnabled)(Le,"tunnels"),Oe.openTunnel(Le,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(Le,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"tunnels"),Oe.onDidChangeTunnels(te,he,Fe)),registerPortAttributesProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"portsAttributes"),Oe.registerPortsAttributesProvider(te,he)),registerTunnelProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"tunnelFactory"),Oe.registerTunnelProvider(te,he)),registerTimelineProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"timeline"),Zi.registerTimelineProvider(te,he,Le.identifier,lt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:te=>((0,Ne.checkProposedApiEnabled)(Le,"workspaceTrust"),dt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Fe)=>dt.onDidGrantWorkspaceTrust(te,he,Fe),registerEditSessionIdentityProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(te,he)),onWillCreateEditSessionIdentity:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Le)(te,he,Fe)),registerCanonicalUriProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"canonicalUriProvider"),dt.registerCanonicalUriProvider(te,he)),getCanonicalUri:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"canonicalUriProvider"),dt.provideCanonicalUri(te,he,Fe))},cn={get inputBox(){return $e.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Le)},createSourceControl(te,he,Fe){return Ei.createSourceControl(Le,te,he,Fe)}},zi={createCommentController(te,he){return Ti.createCommentController(Le,te,he)}},Hi={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},onDidStartDebugSession(te,he,Fe){return St.onDidStartDebugSession(te,he,Fe)},onDidTerminateDebugSession(te,he,Fe){return St.onDidTerminateDebugSession(te,he,Fe)},onDidChangeActiveDebugSession(te,he,Fe){return St.onDidChangeActiveDebugSession(te,he,Fe)},onDidReceiveDebugSessionCustomEvent(te,he,Fe){return St.onDidReceiveDebugSessionCustomEvent(te,he,Fe)},onDidChangeBreakpoints(te,he,Fe){return St.onDidChangeBreakpoints(te,he,Fe)},onDidChangeStackFrameFocus(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"debugFocus"),St.onDidChangeStackFrameFocus(te,he,Fe)},registerDebugConfigurationProvider(te,he,Fe){return St.registerDebugConfigurationProvider(te,he,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return St.registerDebugAdapterDescriptorFactory(Le,te,he)},registerDebugAdapterTrackerFactory(te,he){return St.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?St.startDebugging(te,he,{parentSession:Fe}):St.startDebugging(te,he,Fe||{})},stopDebugging(te){return St.stopDebugging(te)},addBreakpoints(te){return St.addBreakpoints(te)},removeBreakpoints(te){return St.removeBreakpoints(te)},asDebugSourceUri(te,he){return St.asDebugSourceUri(te,he)}},Wi={registerTaskProvider:(te,he)=>jt.registerTaskProvider(Le,te,he),fetchTasks:te=>jt.fetchTasks(te),executeTask:te=>jt.executeTask(Le,te),get taskExecutions(){return jt.taskExecutions},onDidStartTask:(te,he,Fe)=>jt.onDidStartTask(te,he,Fe),onDidEndTask:(te,he,Fe)=>jt.onDidEndTask(te,he,Fe),onDidStartTaskProcess:(te,he,Fe)=>jt.onDidStartTaskProcess(te,he,Fe),onDidEndTaskProcess:(te,he,Fe)=>jt.onDidEndTaskProcess(te,he,Fe)},ui={createNotebookController(te,he,Fe,rt,_t){return oi.createNotebookController(Le,te,he,Fe,rt,(0,Ne.isProposedApiEnabled)(Le,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>Et.registerNotebookCellStatusBarItemProvider(Le,te,he),createRendererMessaging(te){return Di.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ne.checkProposedApiEnabled)(Le,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Le,te,he)},onDidChangeNotebookCellExecutionState(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(te,he,Fe)}},Vi={t(...te){if(typeof te[0]=="string"){const he=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return si.getMessage(Le.identifier.value,{message:he,args:Fe})}return si.getMessage(Le.identifier.value,te[0])},get bundle(){return si.getBundle(Le.identifier.value)},get uri(){return si.getBundleUri(Le.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),Ni.registerProvider(Le,te,he={label:he?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),ni.registerChatProvider(Le,te,he)},addInteractiveRequest(te){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),ni.addChatRequest(te)},sendInteractiveRequestToProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),ni.sendInteractiveRequestToProvider(te,he)},get onDidPerformUserAction(){return(0,Ne.checkProposedApiEnabled)(Le,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),ni.transferChatSession(te,he)}},ji={getRelatedInformation(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),xi.getRelatedInformation(Le,te,he)},registerRelatedInformationProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),xi.registerRelatedInformationProvider(Le,te,he)},registerEmbeddingVectorProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Zt.registerEmbeddingVectorProvider(Le,te,he)}},Ki={registerChatResponseProvider(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatProvider"),hi.registerProvider(Le.identifier,te,he,Fe)},registerSlashCommand(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatSlashCommands"),tn.registerCommand(Le.identifier,te,he,Fe??{description:""})},requestChatAccess(te){return(0,Ne.checkProposedApiEnabled)(Le,"chatRequestAccess"),hi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatVariables"),dn.registerVariableResolver(Le,te,he,Fe)},registerMappedEditsProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,he)},registerAgent(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatAgents"),nn.registerAgent(Le.identifier,te,he,Fe)}};return{version:ft.version,ai:ji,authentication:hn,commands:fn,comments:zi,chat:Ki,debug:Hi,env:_i,extensions:an,interactive:qi,l10n:Vi,languages:mn,notebooks:ui,scm:cn,tasks:Wi,tests:on,window:gn,workspace:Bi,Breakpoint:Q.Breakpoint,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatMessage:Q.ChatMessage,ChatMessageRole:Q.ChatMessageRole,ChatVariableLevel:Q.ChatVariableLevel,CallHierarchyIncomingCall:Q.CallHierarchyIncomingCall,CallHierarchyItem:Q.CallHierarchyItem,CallHierarchyOutgoingCall:Q.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:w.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:Q.CodeAction,CodeActionKind:Q.CodeActionKind,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.CodeLens,Color:Q.Color,ColorInformation:Q.ColorInformation,ColorPresentation:Q.ColorPresentation,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CompletionItem:Q.CompletionItem,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.CompletionList,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.CustomExecution,DebugAdapterExecutable:Q.DebugAdapterExecutable,DebugAdapterInlineImplementation:Q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Q.DebugAdapterNamedPipeServer,DebugAdapterServer:Q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.Diagnostic,DiagnosticRelatedInformation:Q.DiagnosticRelatedInformation,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.Disposable,DocumentHighlight:Q.DocumentHighlight,DocumentHighlightKind:Q.DocumentHighlightKind,DocumentLink:Q.DocumentLink,DocumentSymbol:Q.DocumentSymbol,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.EvaluatableExpression,InlineValueText:Q.InlineValueText,InlineValueVariableLookup:Q.InlineValueVariableLookup,InlineValueEvaluatableExpression:Q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.FileDecoration,FileDecoration2:Q.FileDecoration,FileSystemError:Q.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:Q.FoldingRange,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.FunctionBreakpoint,InlineCompletionItem:Q.InlineSuggestion,InlineCompletionList:Q.InlineSuggestionList,Hover:Q.Hover,IndentAction:m.IndentAction,Location:Q.Location,MarkdownString:Q.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:Q.ParameterInformation,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.Position,ProcessExecution:Q.ProcessExecution,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.QuickInputButtons,Range:Q.Range,RelativePattern:Q.RelativePattern,Selection:Q.Selection,SelectionRange:Q.SelectionRange,SemanticTokens:Q.SemanticTokens,SemanticTokensBuilder:Q.SemanticTokensBuilder,SemanticTokensEdit:Q.SemanticTokensEdit,SemanticTokensEdits:Q.SemanticTokensEdits,SemanticTokensLegend:Q.SemanticTokensLegend,ShellExecution:Q.ShellExecution,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.SignatureHelp,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.SignatureInformation,SnippetString:Q.SnippetString,SourceBreakpoint:Q.SourceBreakpoint,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.SymbolInformation,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.Task,TaskGroup:Q.TaskGroup,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.TerminalLink,TerminalQuickFixExecuteTerminalCommand:Q.TerminalQuickFixCommand,TerminalQuickFixOpener:Q.TerminalQuickFixOpener,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.TerminalProfile,TerminalExitReason:Q.TerminalExitReason,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.TextEdit,SnippetTextEdit:Q.SnippetTextEdit,TextEditorCursorStyle:d.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.ThemeColor,ThemeIcon:Q.ThemeIcon,TreeItem:Q.TreeItem,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.TypeHierarchyItem,UIKind:v.UIKind,Uri:T.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.WorkspaceEdit,DocumentDropEdit:Q.DocumentDropEdit,DocumentPasteEdit:Q.DocumentPasteEdit,InlayHint:Q.InlayHint,InlayHintLabelPart:Q.InlayHintLabelPart,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.RemoteAuthorityResolverError,ResolvedAuthority:Q.ResolvedAuthority,ManagedResolvedAuthority:Q.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.TimelineItem,NotebookRange:Q.NotebookRange,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.NotebookCellData,NotebookData:Q.NotebookData,NotebookRendererScript:Q.NotebookRendererScript,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.NotebookCellOutput,NotebookCellOutputItem:Q.NotebookCellOutputItem,NotebookCellStatusBarItem:Q.NotebookCellStatusBarItem,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.NotebookEdit,NotebookKernelSourceAction:Q.NotebookKernelSourceAction,PortAttributes:Q.PortAttributes,LinkedEditingRanges:Q.LinkedEditingRanges,TestResultState:Q.TestResultState,TestRunRequest:Q.TestRunRequest,TestMessage:Q.TestMessage,TestMessage2:Q.TestMessage,TestTag:Q.TestTag,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Q.DataTransfer,DataTransferItem:Q.DataTransferItem,CoveredCount:Q.CoveredCount,FileCoverage:Q.FileCoverage,StatementCoverage:Q.StatementCoverage,BranchCoverage:Q.BranchCoverage,FunctionCoverage:Q.FunctionCoverage,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.TextTabInput,TabInputTextDiff:Q.TextDiffTabInput,TabInputTextMerge:Q.TextMergeTabInput,TabInputCustom:Q.CustomEditorTabInput,TabInputNotebook:Q.NotebookEditorTabInput,TabInputNotebookDiff:Q.NotebookDiffEditorTabInput,TabInputWebview:Q.WebviewEditorTabInput,TabInputTerminal:Q.TerminalEditorTabInput,TabInputInteractiveWindow:Q.InteractiveWindowInput,TelemetryTrustedValue:Se.TelemetryTrustedValue,LogLevel:Ee.LogLevel,EditSessionIdentityMatch:ht.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Q.StackFrameFocus,ThreadFocus:Q.ThreadFocus,RelatedInformationType:Q.RelatedInformationType}}}e.createApiFactoryAndRegisterActors=Wt}),define(Te[274],Ae([1,0,71,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,39,83,58,61,242,14,112,81,82]),function(be,e,w,R,k,F,T,d,y,m,P,_,a,v,g,f,t,n,l,E,D,p,r,s,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,w.registerSingleton)(s.ILoggerService,r.ExtHostLoggerService,1),(0,w.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,w.registerSingleton)(d.IExtHostCommands,d.ExtHostCommands,0),(0,w.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,w.registerSingleton)(n.IExtHostConsumerFileSystem,n.ExtHostConsumerFileSystem,0),(0,w.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService,0),(0,w.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,0),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,w.registerSingleton)(S.IExtHostManagedSockets,S.ExtHostManagedSockets,0),(0,w.registerSingleton)(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo,0),(0,w.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,w.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch,0),(0,w.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,w.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask,0),(0,w.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,w.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,w.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,w.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,w.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,w.registerSingleton)(D.IExtHostTelemetry,D.ExtHostTelemetry,0),(0,w.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,w.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,0)}),define(Te[275],Ae([1,0,273,35,2,270,7,12,261]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends F.RequireInterceptor{_installInterceptor(){}getModule(v,g){for(const f of this._alternatives){const t=f(v);if(t){v=t;break}}if(this._factories.has(v))return this._factories.get(v).load(v,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const v=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(m,v,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(v){return v.browser}async _loadCommonJSModule(v,g,f){g=g.with({path:_(g.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const n=k.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),l=await fetch(n.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),l.status!==200)throw new Error(l.statusText);const E=await l.text(),D=`${g.toString(!0)}#vscode-extension`,p=`${E}
//# sourceURL=${D}`;let r;try{r=new Function("module","exports","require",p)}catch(S){throw console.error(t?`Loading code for extension ${t} failed: ${S.message}`:`Loading code failed: ${S.message}`),console.error(`${g.toString(!0)}${typeof S.line=="number"?` line ${S.line}`:""}${typeof S.column=="number"?` column ${S.column}`:""}`),console.error(S),S}v&&await this._extHostLocalizationService.initializeLocalizedMessages(v);const s={},i={exports:s},o=S=>{const b=this._fakeModules.getModule(S,g);if(b===void 0)throw new Error(`Cannot load module '${S}'`);return b};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(i,s,o),i.exports!==s?i.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(v){}async _waitForDebuggerAttachment(v=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+v;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,d.timeout)(10)}}e.ExtHostExtensionService=P;function _(a,v){return a.endsWith(v)?a:a+v}}),define(Te[276],Ae([1,0,70,71,14,35,187,85,275]),function(be,e,w,R,k,F,T,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.registerSingleton)(k.ILogService,new w.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,R.registerSingleton)(F.IExtHostExtensionService,y.ExtHostExtensionService,0),(0,R.registerSingleton)(d.IExtensionStoragePaths,d.ExtensionStoragePaths,0)}),define(Te[285],Ae([1,0,25,5,79,271,263,19,87,13,2,274,276]),function(be,e,w,R,k,F,T,d,y,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const g=fetch.bind(self);function f(r){self.fetch=async function(s,i){return s instanceof Request||v(String(s))&&(s=(await r(P.URI.parse(String(s)))).toString(!0)),g(s,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,i,o,S,b){(async()=>(v(i.toString())&&(i=(await r(P.URI.parse(i.toString()))).toString(!0)),super.open(s,i,o??!0,S,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,i){if(/^file:/i.test(s.toString()))s=m.FileAccess.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const S=`(${function(c){function h(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const u=fetch.bind(self);self.fetch=function(B,H){return B instanceof Request?u(B,H):u(h(B),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,H,U,z,M){return super.open(B,h(H),U??!0,z,M)}};const A=importScripts.bind(self);self.importScripts=(...B)=>{A(...B.map(h))},A(c)}.toString()}('${s}'))`;i=i||{},i.name=i.name||d.basename(s.toString());const b=new Blob([S],{type:"application/javascript"}),C=URL.createObjectURL(b);return new r(C,i)}}else self.Worker=class extends T.NestedWorker{constructor(r,s){super(a,r,{name:d.basename(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){_()}};class n{constructor(){const s=new MessageChannel,i=new R.Emitter;let o=!1;a(s.port2,[s.port2]),s.port1.onmessage=S=>{const{data:b}=S;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const C=w.VSBuffer.wrap(new Uint8Array(b,0,b.byteLength));if((0,k.isMessageOfType)(C,2)){o=!0,E("received terminate message from renderer");return}i.fire(C)},this.protocol={onMessage:i.event,send:S=>{if(!o){const b=S.buffer.buffer.slice(S.buffer.byteOffset,S.buffer.byteOffset+S.buffer.byteLength);s.port1.postMessage(b,[b])}}}}}function l(r){return new Promise(s=>{const i=r.onMessage(o=>{i.dispose();const S=JSON.parse(o.toString());r.send((0,k.createMessageOfType)(0)),s({protocol:r,initData:S})});r.send((0,k.createMessageOfType)(1))})}let E=r=>_();function D(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function p(){y.mark("code/extHost/willConnectToRenderer");const r=new n;return{onmessage(s){D(s)&&l(r.protocol).then(i=>{y.mark("code/extHost/didWaitForInitData");const o=new F.ExtensionHostMain(i.protocol,i.initData,t,null,s.data);f(S=>o.asBrowserUri(S)),E=S=>o.terminate(S)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/workbench/api/worker/extensionHostWorker.js.map
