/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],j=function(F){for(var e=[],C=0,y=F.length;C<y;C++)e[C]=W[F[C]];return e};define(W[21],j([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class C{static get(){const k=new Map,w=new Map,s=new Map,h=new Map;function t(l,n){l.has(n.detail)||l.set(n.detail,-n.timestamp)}function a(l,n){const i=l.get(n.detail);i&&(i>=0||l.set(n.detail,i+n.timestamp))}let u=[];typeof F=="function"&&typeof F.getStats=="function"&&(u=F.getStats().slice(0).sort((l,n)=>l.timestamp-n.timestamp));for(const l of u)switch(l.type){case 10:t(k,l);break;case 11:case 12:a(k,l);break;case 21:t(w,l);break;case 22:a(w,l);break;case 33:t(s,l);break;case 34:a(s,l);break;case 31:t(h,l);break;case 32:a(h,l);break}let o=0;s.forEach(l=>o+=l);function g(l){const n=[];return l.forEach((i,r)=>n.push([r,i])),n}return{amdLoad:g(k),amdInvoke:g(w),nodeRequire:g(s),nodeEval:g(h),nodeRequireTotal:o}}static toMarkdownTable(k,w){let s="";const h=[];return k.forEach((t,a)=>{h[a]=t.length}),w.forEach(t=>{t.forEach((a,u)=>{typeof a>"u"&&(a=t[u]="-");const o=a.toString().length;h[u]=Math.max(o,h[u])})}),k.forEach((t,a)=>{s+=`| ${t+" ".repeat(h[a]-t.toString().length)} `}),s+=`|
`,k.forEach((t,a)=>{s+=`| ${"-".repeat(h[a])} `}),s+=`|
`,w.forEach(t=>{t.forEach((a,u)=>{typeof a<"u"&&(s+=`| ${a+" ".repeat(h[u]-a.toString().length)} `)}),s+=`|
`}),s}}e.LoaderStats=C}),define(W[4],j([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let C;function y(i){C=i}e.setLogger=y;function k(){return C}e.getLogger=k;class w{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return s([h(l("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[h(" "),a(u(r.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),a(u(r.newValue,60),{color:"green"})]:[h(" (unchanged)")]:[h(" "),a(u(r.newValue,60),{color:"green"}),h(" (initial)")]}handleObservableChanged(r,c){console.log(...this.textToConsoleArgs([t("observable value changed"),a(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c)]))}formatChanges(r){if(r.size!==0)return a(" (changed deps: "+[...r].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const c=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(_,R)=>(this.changedObservablesSets.get(r).add(_),c.apply(r,[_,R]))}handleDerivedRecomputed(r,c){const _=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([t("derived recomputed"),a(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c),this.formatChanges(_),{data:[{fn:r._computeFn}]}])),_.clear()}handleFromEventObservableTriggered(r,c){console.log(...this.textToConsoleArgs([t("observable from event triggered"),a(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const c=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(_,R)=>(this.changedObservablesSets.get(r).add(_),c.apply(r,[_,R]))}handleAutorunTriggered(r){const c=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([t("autorun"),a(r.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:r._runFn}]}])),c.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let c=r.getDebugName();c===void 0&&(c=""),console.log(...this.textToConsoleArgs([t("transaction"),a(c,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=w;function s(i){const r=new Array,c=[];let _="";function R(E){if("length"in E)for(const f of E)f&&R(f);else"text"in E?(_+=`%c${E.text}`,r.push(E.style),E.data&&c.push(...E.data)):"data"in E&&c.push(...E.data)}R(i);const I=[_,...r];return I.push(...c),I}function h(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,r={color:"black"}){function c(R){return Object.entries(R).reduce((I,[E,f])=>`${I}${E}:${f};`,"")}const _={color:r.color};return r.strikeThrough&&(_["text-decoration"]="line-through"),r.bold&&(_["font-weight"]="bold"),{text:i,style:c(_)}}function u(i,r){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=r?`"${i}"`:`"${i.substr(0,r-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?o(i,r):g(i,r);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function o(i,r){let c="[ ",_=!0;for(const R of i){if(_||(c+=", "),c.length-5>r){c+="...";break}_=!1,c+=`${u(R,r-c.length)}`}return c+=" ]",c}function g(i,r){let c="{ ",_=!0;for(const[R,I]of Object.entries(i)){if(_||(c+=", "),c.length-5>r){c+="...";break}_=!1,c+=`${R}: ${u(I,r-c.length)}`}return c+=" }",c}function l(i,r){let c="";for(let _=1;_<=r;_++)c+=i;return c}function n(i,r){for(;i.length<r;)i+=" ";return i}}),define(W[5],j([0,1,4]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.getDebugName=e.TransactionImpl=e.subtransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerivedOpts=void 0;let y;function k(r){y=r}e._setDerivedOpts=k;class w{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,_){const R=_===void 0?void 0:c,I=_===void 0?c:_;return y({owner:R,debugName:()=>{const E=o(I);if(E!==void 0)return E;const T=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(I.toString());if(T)return`${this.debugName}.${T[2]}`;if(!R)return`${this.debugName} (mapped)`}},E=>I(this.read(E),E))}}e.ConvenientObservable=w;class s extends w{constructor(){super(...arguments),this.observers=new Set}addObserver(c){const _=this.observers.size;this.observers.add(c),_===0&&this.onFirstObserverAdded()}removeObserver(c){this.observers.delete(c)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=s;function h(r,c){const _=new a(r,c);try{r(_)}finally{_.finish()}}e.transaction=h;function t(r,c,_){r?c(r):h(c,_)}e.subtransaction=t;class a{constructor(c,_){this._fn=c,this._getDebugName=_,this.updatingObservers=[],(0,C.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():o(this._fn)}updateObserver(c,_){this.updatingObservers.push({observer:c,observable:_}),c.beginUpdate(_)}finish(){const c=this.updatingObservers;this.updatingObservers=null;for(const{observer:_,observable:R}of c)_.endUpdate(R);(0,C.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=a;function u(r,c,_,R){let I;if(r!==void 0)if(typeof r=="function"){if(I=r(),I!==void 0)return I}else return r;if(c!==void 0&&(I=o(c),I!==void 0))return I;if(_!==void 0){for(const E in _)if(_[E]===R)return E}}e.getDebugName=u;function o(r){const c=r.toString(),R=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(c);return(R?R[1]:void 0)?.trim()}e.getFunctionName=o;function g(r,c){return typeof r=="string"?new l(void 0,r,c):new l(r,void 0,c)}e.observableValue=g;class l extends s{get debugName(){return u(this._debugName,void 0,this._owner,this)??"ObservableValue"}constructor(c,_,R){super(),this._owner=c,this._debugName=_,this._value=R}get(){return this._value}set(c,_,R){if(this._value===c)return;let I;_||(_=I=new a(()=>{},()=>`Setting ${this.debugName}`));try{const E=this._value;this._setValue(c),(0,C.getLogger)()?.handleObservableChanged(this,{oldValue:E,newValue:c,change:R,didChange:!0,hadValue:!0});for(const f of this.observers)_.updateObserver(f,this),f.handleChange(this,R)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(c){this._value=c}}e.ObservableValue=l;function n(r,c){return typeof r=="string"?new i(void 0,r,c):new i(r,void 0,c)}e.disposableObservableValue=n;class i extends l{_setValue(c){this._value!==c&&(this._value&&this._value.dispose(),this._value=c)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=i}),define(W[9],j([0,1,42,2,5,4]),function(F,e,C,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorun=e.autorunOpts=void 0;function s(n,i){return new g(n.debugName,i,void 0,void 0)}e.autorunOpts=s;function h(n){return new g(void 0,n,void 0,void 0)}e.autorun=h;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.autorunHandleChanges=t;function a(n,i){const r=new y.DisposableStore,c=t({debugName:n.debugName??(()=>(0,k.getFunctionName)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(_,R)=>{r.clear(),i(_,R,r)});return(0,y.toDisposable)(()=>{c.dispose(),r.dispose()})}e.autorunWithStoreHandleChanges=a;function u(n){const i=new y.DisposableStore,r=s({debugName:()=>(0,k.getFunctionName)(n)||"(anonymous)"},c=>{i.clear(),n(c,i)});return(0,y.toDisposable)(()=>{r.dispose(),i.dispose()})}e.autorunWithStore=u;var o;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(o||(o={}));class g{get debugName(){if(typeof this._debugName=="string")return this._debugName;if(typeof this._debugName=="function"){const r=this._debugName();if(r!==void 0)return r}const i=(0,k.getFunctionName)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,r,c,_){this._debugName=i,this._runFn=r,this.createChangeSummary=c,this._handleChange=_,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,w.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,y.trackDisposable)(this)}dispose(){this.disposed=!0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear(),(0,y.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i,this.state=3;try{if(!this.disposed){(0,w.getLogger)()?.handleAutorunTriggered(this);const r=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,r)}}finally{(0,w.getLogger)()?.handleAutorunFinished(this);for(const r of this.dependenciesToBeRemoved)r.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,C.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(i){this.state===3&&this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(this.state=1)}handleChange(i,r){this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(!this._handleChange||this._handleChange({changedObservable:i,change:r,didChange:_=>_===i},this.changeSummary))&&(this.state=2)}readObservable(i){if(this.disposed)return i.get();i.addObserver(this);const r=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),r}}e.AutorunObserver=g,function(n){n.Observer=g}(h||(e.autorun=h={}));function l(n,i){let r;return s({debugName:()=>(0,k.getFunctionName)(i)},c=>{const _=n.read(c),R=r;r=_,i({lastValue:R,newValue:_})})}e.autorunDelta=l}),define(W[10],j([0,1,6,2,5,4]),function(F,e,C,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=void 0;const s=(l,n)=>l===n;function h(l,n){return n!==void 0?new g(l,void 0,n,void 0,void 0,void 0,s):new g(void 0,void 0,l,void 0,void 0,void 0,s)}e.derived=h;function t(l,n){return new g(l.owner,l.debugName,n,void 0,void 0,void 0,l.equalityComparer??s)}e.derivedOpts=t;function a(l,n){return new g(l.owner,l.debugName,n,l.createEmptyChangeSummary,l.handleChange,void 0,l.equalityComparer??s)}e.derivedHandleChanges=a;function u(l,n){let i,r;n===void 0?(i=l,r=void 0):(r=l,i=n);const c=new y.DisposableStore;return new g(r,()=>(0,k.getFunctionName)(i)??"(anonymous)",_=>(c.clear(),i(_,c)),void 0,void 0,()=>c.dispose(),s)}e.derivedWithStore=u,(0,k._setDerivedOpts)(h);var o;(function(l){l[l.initial=0]="initial",l[l.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",l[l.stale=2]="stale",l[l.upToDate=3]="upToDate"})(o||(o={}));class g extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this._debugName,this._computeFn,this._owner,this)??"(anonymous)"}constructor(n,i,r,c,_,R=void 0,I){super(),this._owner=n,this._debugName=i,this._computeFn=r,this.createChangeSummary=c,this._handleChange=_,this._handleLastObserverRemoved=R,this._equalityComparator=I,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,w.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const n=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const i=this.state!==0,r=this.value;this.state=3;const c=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,c)}finally{for(const R of this.dependenciesToBeRemoved)R.removeObserver(this);this.dependenciesToBeRemoved.clear()}const _=i&&!this._equalityComparator(r,this.value);if((0,w.getLogger)()?.handleDerivedRecomputed(this,{oldValue:r,newValue:this.value,change:void 0,didChange:_,hadValue:i}),_)for(const R of this.observers)R.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const i=this.updateCount===1;if(this.state===3&&(this.state=1,!i))for(const r of this.observers)r.handlePossibleChange(this);if(i)for(const r of this.observers)r.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const i=[...this.observers];for(const r of i)r.endUpdate(this)}if(this.updateCount<0)throw new C.BugIndicatingError}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const i of this.observers)i.handlePossibleChange(this)}}handleChange(n,i){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const r=this._handleChange?this._handleChange({changedObservable:n,change:i,didChange:_=>_===n},this.changeSummary):!0,c=this.state===3;if(r&&(this.state===1||c)&&(this.state=2,c))for(const _ of this.observers)_.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),i}addObserver(n){const i=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.Derived=g}),define(W[22],j([0,1,2,9,5,10,4]),function(F,e,C,y,k,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.recomputeInitiallyAndOnChange=e.keepObserved=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(v){return new t(v)}e.constObservable=h;class t extends k.ConvenientObservable{constructor(O){super(),this.value=O}get debugName(){return this.toString()}get(){return this.value}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.value}`}}function a(v){const O=(0,k.observableValue)("promiseValue",{});return v.then(z=>{O.set({value:z},void 0)}),O}e.observableFromPromise=a;function u(v,O){return new Promise(z=>{let m=!1,L=!1;const M=(0,y.autorun)(B=>{const p=v.read(B);O(p)&&(m?M.dispose():L=!0,z(p))});m=!0,L&&M.dispose()})}e.waitForState=u;function o(v,O){return new g(v,O)}e.observableFromEvent=o;class g extends k.BaseObservable{constructor(O,z){super(),this.event=O,this._getValue=z,this.hasValue=!1,this.handleEvent=m=>{const L=this._getValue(m),M=!this.hasValue||this.value!==L;(0,s.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:L,change:void 0,didChange:M,hadValue:this.hasValue}),M&&(this.value=L,this.hasValue&&(0,k.transaction)(B=>{for(const p of this.observers)B.updateObserver(p,this),p.handleChange(this,void 0)},()=>{const B=this.getDebugName();return"Event fired"+(B?`: ${B}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,k.getFunctionName)(this._getValue)}get debugName(){const O=this.getDebugName();return"From Event"+(O?`: ${O}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=g,function(v){v.Observer=g}(o||(e.observableFromEvent=o={}));function l(v,O){return new n(v,O)}e.observableSignalFromEvent=l;class n extends k.BaseObservable{constructor(O,z){super(),this.debugName=O,this.event=z,this.handleEvent=()=>{(0,k.transaction)(m=>{for(const L of this.observers)m.updateObserver(L,this),L.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function i(v){return typeof v=="string"?new r(v):new r(void 0,v)}e.observableSignal=i;class r extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this._debugName,void 0,this._owner,this)??"Observable Signal"}constructor(O,z){super(),this._debugName=O,this._owner=z}trigger(O,z){if(!O){(0,k.transaction)(m=>{this.trigger(m,z)},()=>`Trigger signal ${this.debugName}`);return}for(const m of this.observers)O.updateObserver(m,this),m.handleChange(this,z)}get(){}}function c(v,O,z){const m=(0,k.observableValue)("debounced",void 0);let L;return z.add((0,y.autorun)(M=>{const B=v.read(M);L&&clearTimeout(L),L=setTimeout(()=>{(0,k.transaction)(p=>{m.set(B,p)})},O)})),m}e.debouncedObservable=c;function _(v,O,z){const m=(0,k.observableValue)("triggeredRecently",!1);let L;return z.add(v(()=>{m.set(!0,void 0),L&&clearTimeout(L),L=setTimeout(()=>{m.set(!1,void 0)},O)})),m}e.wasEventTriggeredRecently=_;function R(v){const O=new E(!1);return v.addObserver(O),(0,C.toDisposable)(()=>{v.removeObserver(O)})}e.keepObserved=R;function I(v){const O=new E(!0);return v.addObserver(O),v.reportChanges(),(0,C.toDisposable)(()=>{v.removeObserver(O)})}e.recomputeInitiallyAndOnChange=I;class E{constructor(O){this.forceRecompute=O,this.counter=0}beginUpdate(O){this.counter++}endUpdate(O){this.counter--,this.counter===0&&this.forceRecompute&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,z){}}function f(v){let O;return(0,w.derived)(m=>(O=v(m,O),O))}e.derivedObservableWithCache=f;function T(v,O){let z;const m=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),L=(0,w.derived)(v,M=>(m.read(M),z=O(M,z),z));return Object.assign(L,{clearCache:M=>{z=void 0,m.set(m.get()+1,M)}})}e.derivedObservableWithWritableCache=T}),define(W[11],j([0,1,5,10,9,22,4]),function(F,e,C,y,k,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return C.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return C.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return C.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return C.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return y.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return y.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return y.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return y.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return w.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return w.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return w.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return w.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return w.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return w.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return w.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return w.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return w.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return w.observableSignalFromEvent}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return w.waitForState}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return w.wasEventTriggeredRecently}}),!1&&(0,s.setLogger)(new s.ConsoleObservableLogger)}),define(W[23],j([0,1,6,2]),function(F,e,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(I){const E=I;return E?typeof E.read=="function":!1}e.isReadable=k;function w(I){const E=I;return E?[E.on,E.pause,E.resume,E.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=w;function s(I){const E=I;return E?w(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=s;function h(I,E){return new t(I,E)}e.newWriteableStream=h;class t{constructor(E,f){this.reducer=E,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E<"u"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(f=>f(E))}emitError(E){this.listeners.error.length===0?(0,C.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(f=>f(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,f){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(E,f){if(this.state.destroyed)return;let T;switch(E){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const v=T.indexOf(f);v>=0&&T.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(I,E){const f=[];let T;for(;(T=I.read())!==null;)f.push(T);return E(f)}e.consumeReadable=a;function u(I,E,f){const T=[];let v;for(;(v=I.read())!==null&&T.length<f;)T.push(v);return v===null&&T.length>0?E(T):{read:()=>{if(T.length>0)return T.shift();if(typeof v<"u"){const O=v;return v=void 0,O}return I.read()}}}e.peekReadable=u;function o(I,E){return new Promise((f,T)=>{const v=[];g(I,{onData:O=>{E&&v.push(O)},onError:O=>{E?T(O):f(void 0)},onEnd:()=>{f(E?E(v):void 0)}})})}e.consumeStream=o;function g(I,E,f){I.on("error",T=>{f?.isCancellationRequested||E.onError(T)}),I.on("end",()=>{f?.isCancellationRequested||E.onEnd()}),I.on("data",T=>{f?.isCancellationRequested||E.onData(T)})}e.listenStream=g;function l(I,E){return new Promise((f,T)=>{const v=new y.DisposableStore,O=[],z=M=>{if(O.push(M),O.length>E)return v.dispose(),I.pause(),f({stream:I,buffer:O,ended:!1})},m=M=>(v.dispose(),T(M)),L=()=>(v.dispose(),f({stream:I,buffer:O,ended:!0}));v.add((0,y.toDisposable)(()=>I.removeListener("error",m))),I.on("error",m),v.add((0,y.toDisposable)(()=>I.removeListener("end",L))),I.on("end",L),v.add((0,y.toDisposable)(()=>I.removeListener("data",z))),I.on("data",z)})}e.peekStream=l;function n(I,E){const f=h(E);return f.end(I),f}e.toStream=n;function i(){const I=h(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=i;function r(I){let E=!1;return{read:()=>E?null:(E=!0,I)}}e.toReadable=r;function c(I,E,f){const T=h(f);return g(I,{onData:v=>T.write(E.data(v)),onError:v=>T.error(E.error?E.error(v):v),onEnd:()=>T.end()}),T}e.transform=c;function _(I,E,f){let T=!1;return{read:()=>{const v=E.read();return T?v:(T=!0,v!==null?f([I,v]):I)}}}e.prefixedReadable=_;function R(I,E,f){let T=!1;const v=h(f);return g(E,{onData:O=>T?v.write(O):(T=!0,v.write(f([I,O]))),onError:O=>v.error(O),onEnd:()=>{T||(T=!0,v.write(I)),v.end()}}),v}e.prefixedStream=R}),define(W[12],j([0,1,43,23]),function(F,e,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",w=new C.Lazy(()=>new Uint8Array(256));let s,h;class t{static alloc(b){return k?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return k&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,D){return!(D?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(b)):(s||(s=new TextEncoder),new t(s.encode(b)))}static fromByteArray(b){const D=t.alloc(b.length);for(let V=0,K=b.length;V<K;V++)D.buffer[V]=b[V];return D}static concat(b,D){if(typeof D>"u"){D=0;for(let $=0,G=b.length;$<G;$++)D+=b[$].byteLength}const V=t.alloc(D);let K=0;for(let $=0,G=b.length;$<G;$++){const q=b[$];V.set(q,K),K+=q.byteLength}return V}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return k?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(b,D){return new t(this.buffer.subarray(b,D))}set(b,D){if(b instanceof t)this.buffer.set(b.buffer,D);else if(b instanceof Uint8Array)this.buffer.set(b,D);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),D);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,D){l(this.buffer,b,D)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,D){i(this.buffer,b,D)}readUInt8(b){return r(this.buffer,b)}writeUInt8(b,D){c(this.buffer,b,D)}indexOf(b,D=0){return a(this.buffer,b instanceof t?b.buffer:b,D)}}e.VSBuffer=t;function a(p,b,D=0){const V=b.byteLength,K=p.byteLength;if(V===0)return 0;if(V===1)return p.indexOf(b[0]);if(V>K-D)return-1;const $=w.value;$.fill(b.length);for(let J=0;J<b.length;J++)$[b[J]]=b.length-J-1;let G=D+b.length-1,q=G,H=-1;for(;G<K;)if(p[G]===b[q]){if(q===0){H=G;break}G--,q--}else G+=Math.max(b.length-q,$[p[G]]),q=b.length-1;return H}e.binaryIndexOf=a;function u(p,b){return p[b+0]<<0>>>0|p[b+1]<<8>>>0}e.readUInt16LE=u;function o(p,b,D){p[D+0]=b&255,b=b>>>8,p[D+1]=b&255}e.writeUInt16LE=o;function g(p,b){return p[b]*2**24+p[b+1]*2**16+p[b+2]*2**8+p[b+3]}e.readUInt32BE=g;function l(p,b,D){p[D+3]=b,b=b>>>8,p[D+2]=b,b=b>>>8,p[D+1]=b,b=b>>>8,p[D]=b}e.writeUInt32BE=l;function n(p,b){return p[b+0]<<0>>>0|p[b+1]<<8>>>0|p[b+2]<<16>>>0|p[b+3]<<24>>>0}e.readUInt32LE=n;function i(p,b,D){p[D+0]=b&255,b=b>>>8,p[D+1]=b&255,b=b>>>8,p[D+2]=b&255,b=b>>>8,p[D+3]=b&255}e.writeUInt32LE=i;function r(p,b){return p[b]}e.readUInt8=r;function c(p,b,D){p[D]=b}e.writeUInt8=c;function _(p){return y.consumeReadable(p,b=>t.concat(b))}e.readableToBuffer=_;function R(p){return y.toReadable(p)}e.bufferToReadable=R;function I(p){return y.consumeStream(p,b=>t.concat(b))}e.streamToBuffer=I;async function E(p){return p.ended?t.concat(p.buffer):t.concat([...p.buffer,await I(p.stream)])}e.bufferedStreamToBuffer=E;function f(p){return y.toStream(p,b=>t.concat(b))}e.bufferToStream=f;function T(p){return y.transform(p,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.streamToBufferReadableStream=T;function v(p){return y.newWriteableStream(b=>t.concat(b),p)}e.newWriteableBufferStream=v;function O(p,b){return y.prefixedReadable(p,b,D=>t.concat(D))}e.prefixedBufferReadable=O;function z(p,b){return y.prefixedStream(p,b,D=>t.concat(D))}e.prefixedBufferStream=z;function m(p){let b=0,D=0,V=0;const K=new Uint8Array(Math.floor(p.length/4*3)),$=q=>{switch(D){case 3:K[V++]=b|q,D=0;break;case 2:K[V++]=b|q>>>2,b=q<<6,D=3;break;case 1:K[V++]=b|q>>>4,b=q<<4,D=2;break;default:b=q<<2,D=1}};for(let q=0;q<p.length;q++){const H=p.charCodeAt(q);if(H>=65&&H<=90)$(H-65);else if(H>=97&&H<=122)$(H-97+26);else if(H>=48&&H<=57)$(H-48+52);else if(H===43||H===45)$(62);else if(H===47||H===95)$(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${p[q]}`)}}const G=V;for(;D>0;)$(0);return t.wrap(K).slice(0,G)}e.decodeBase64=m;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:p},b=!0,D=!1){const V=D?M:L;let K="";const $=p.byteLength%3;let G=0;for(;G<p.byteLength-$;G+=3){const q=p[G+0],H=p[G+1],J=p[G+2];K+=V[q>>>2],K+=V[(q<<4|H>>>4)&63],K+=V[(H<<2|J>>>6)&63],K+=V[J&63]}if($===1){const q=p[G+0];K+=V[q>>>2],K+=V[q<<4&63],b&&(K+="==")}else if($===2){const q=p[G+0],H=p[G+1];K+=V[q>>>2],K+=V[(q<<4|H>>>4)&63],K+=V[H<<2&63],b&&(K+="=")}return K}e.encodeBase64=B}),define(W[24],j([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[13],j([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var C;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function y(k){let w=0,s=0,h=0,t=0;for(let a=0,u=k.length;a<u;a++){const o=k.charCodeAt(a);o===13?(w===0&&(s=a),w++,a+1<u&&k.charCodeAt(a+1)===10?(t|=2,a++):t|=3,h=a+1):o===10&&(t|=1,w===0&&(s=a),w++,h=a+1)}return w===0&&(s=k.length),[w,s,k.length-h,t]}e.countEOL=y}),define(W[14],j([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(C||(e.LanguageId=C={}));var y;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(y||(e.FontStyle=y={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var w;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(w||(e.StandardTokenType=w={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class h{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let o="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&1&&(o+=" mtki"),g&2&&(o+=" mtkb"),g&4&&(o+=" mtku"),g&8&&(o+=" mtks"),o}static getInlineStyleFromMetadata(a,u){const o=this.getForeground(a),g=this.getFontStyle(a);let l=`color: ${u[o]};`;g&1&&(l+="font-style: italic;"),g&2&&(l+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(l+=`text-decoration:${n};`),l}static getPresentationFromMetadata(a){const u=this.getForeground(a),o=this.getFontStyle(a);return{foreground:u,italic:!!(o&1),bold:!!(o&2),underline:!!(o&4),strikethrough:!!(o&8)}}}e.TokenMetadata=h}),define(W[25],j([0,1,26]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class y{constructor(s){this._default=s,this._store=[]}get(s){return s<this._store.length?this._store[s]:this._default}set(s,h){for(;s>=this._store.length;)this._store[this._store.length]=this._default;this._store[s]=h}replace(s,h,t){if(s>=this._store.length)return;if(h===0){this.insert(s,t);return}else if(t===0){this.delete(s,h);return}const a=this._store.slice(0,s),u=this._store.slice(s+h),o=k(t,this._default);this._store=a.concat(o,u)}delete(s,h){h===0||s>=this._store.length||this._store.splice(s,h)}insert(s,h){if(h===0||s>=this._store.length)return;const t=[];for(let a=0;a<h;a++)t[a]=this._default;this._store=(0,C.arrayInsert)(this._store,s,t)}}e.FixedArray=y;function k(w,s){const h=[];for(let t=0;t<w;t++)h[t]=s;return h}}),define(W[7],j([0,1,14]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class y{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,h){const t=y.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=s.length,a[1]=t,new y(a,s,h)}constructor(s,h,t){this._lineTokensBrand=void 0,this._tokens=s,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=t}equals(s){return s instanceof y?this.slicedEquals(s,0,this._tokensCount):!1}slicedEquals(s,h,t){if(this._text!==s._text||this._tokensCount!==s._tokensCount)return!1;const a=h<<1,u=a+(t<<1);for(let o=a;o<u;o++)if(this._tokens[o]!==s._tokens[o])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(s){return s>0?this._tokens[s-1<<1]:0}getMetadata(s){return this._tokens[(s<<1)+1]}getLanguageId(s){const h=this._tokens[(s<<1)+1],t=C.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(s){const h=this._tokens[(s<<1)+1];return C.TokenMetadata.getTokenType(h)}getForeground(s){const h=this._tokens[(s<<1)+1];return C.TokenMetadata.getForeground(h)}getClassName(s){const h=this._tokens[(s<<1)+1];return C.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(s,h){const t=this._tokens[(s<<1)+1];return C.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(s){const h=this._tokens[(s<<1)+1];return C.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(s){return this._tokens[s<<1]}findTokenIndexAtOffset(s){return y.findIndexInTokensArray(this._tokens,s)}inflate(){return this}sliceAndInflate(s,h,t){return new k(this,s,h,t)}static convertToEndOffset(s,h){const a=(s.length>>>1)-1;for(let u=0;u<a;u++)s[u<<1]=s[u+1<<1];s[a<<1]=h}static findIndexInTokensArray(s,h){if(s.length<=2)return 0;let t=0,a=(s.length>>>1)-1;for(;t<a;){const u=t+Math.floor((a-t)/2),o=s[u<<1];if(o===h)return u+1;o<h?t=u+1:o>h&&(a=u)}return t}withInserted(s){if(s.length===0)return this;let h=0,t=0,a="";const u=new Array;let o=0;for(;;){const g=h<this._tokensCount?this._tokens[h<<1]:-1,l=t<s.length?s[t]:null;if(g!==-1&&(l===null||g<=l.offset)){a+=this._text.substring(o,g);const n=this._tokens[(h<<1)+1];u.push(a.length,n),h++,o=g}else if(l){if(l.offset>o){a+=this._text.substring(o,l.offset);const n=this._tokens[(h<<1)+1];u.push(a.length,n),o=l.offset}a+=l.text,u.push(a.length,l.tokenMetadata),t++}else break}return new y(new Uint32Array(u),a,this._languageIdCodec)}}e.LineTokens=y;class k{constructor(s,h,t,a){this._source=s,this._startOffset=h,this._endOffset=t,this._deltaOffset=a,this._firstTokenIndex=s.findTokenIndexAtOffset(h),this._tokensCount=0;for(let u=this._firstTokenIndex,o=s.getCount();u<o&&!(s.getStartOffset(u)>=t);u++)this._tokensCount++}getMetadata(s){return this._source.getMetadata(this._firstTokenIndex+s)}getLanguageId(s){return this._source.getLanguageId(this._firstTokenIndex+s)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(s){return s instanceof k?this._startOffset===s._startOffset&&this._endOffset===s._endOffset&&this._deltaOffset===s._deltaOffset&&this._source.slicedEquals(s._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(s){return this._source.getForeground(this._firstTokenIndex+s)}getEndOffset(s){const h=this._source.getEndOffset(this._firstTokenIndex+s);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(s){return this._source.getClassName(this._firstTokenIndex+s)}getInlineStyle(s,h){return this._source.getInlineStyle(this._firstTokenIndex+s,h)}getPresentation(s){return this._source.getPresentation(this._firstTokenIndex+s)}findTokenIndexAtOffset(s){return this._source.findTokenIndexAtOffset(s+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[27],j([0,1,7]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class y{static deleteBeginning(s,h){return s===null||s===e.EMPTY_LINE_TOKENS?s:y.delete(s,0,h)}static deleteEnding(s,h){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const t=k(s),a=t[t.length-2];return y.delete(s,h,a)}static delete(s,h,t){if(s===null||s===e.EMPTY_LINE_TOKENS||h===t)return s;const a=k(s),u=a.length>>>1;if(h===0&&a[a.length-2]===t)return e.EMPTY_LINE_TOKENS;const o=C.LineTokens.findIndexInTokensArray(a,h),g=o>0?a[o-1<<1]:0,l=a[o<<1];if(t<l){const _=t-h;for(let R=o;R<u;R++)a[R<<1]-=_;return s}let n,i;g!==h?(a[o<<1]=h,n=o+1<<1,i=h):(n=o<<1,i=g);const r=t-h;for(let _=o+1;_<u;_++){const R=a[_<<1]-r;R>i&&(a[n++]=R,a[n++]=a[(_<<1)+1],i=R)}if(n===a.length)return s;const c=new Uint32Array(n);return c.set(a.subarray(0,n),0),c.buffer}static append(s,h){if(h===e.EMPTY_LINE_TOKENS)return s;if(s===e.EMPTY_LINE_TOKENS)return h;if(s===null)return s;if(h===null)return null;const t=k(s),a=k(h),u=a.length>>>1,o=new Uint32Array(t.length+a.length);o.set(t,0);let g=t.length;const l=t[t.length-2];for(let n=0;n<u;n++)o[g++]=a[n<<1]+l,o[g++]=a[(n<<1)+1];return o.buffer}static insert(s,h,t){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const a=k(s),u=a.length>>>1;let o=C.LineTokens.findIndexInTokensArray(a,h);o>0&&a[o-1<<1]===h&&o--;for(let g=o;g<u;g++)a[g<<1]+=t;return s}}e.ContiguousTokensEditing=y;function k(w){return w instanceof Uint32Array?w:new Uint32Array(w)}e.toUint32Array=k}),define(W[28],j([0,1,26,12,44,13,27,15]),function(F,e,C,y,k,w,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(u,o,g){const l=new Uint32Array(u.buffer),n=(0,y.readUInt32BE)(u,o);o+=4;const i=(0,y.readUInt32BE)(u,o);o+=4;const r=[];for(let c=0;c<i;c++){const _=(0,y.readUInt32BE)(u,o);o+=4,r.push(l.subarray(o/4,o/4+_/4)),o+=_}return g.push(new t(n,r)),o}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(u,o){this._startLineNumber=u,this._tokens=o}getLineRange(){return new h.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(u){return this._tokens[u-this._startLineNumber]}appendLineTokens(u){this._tokens.push(u)}serializeSize(){let u=0;u+=4,u+=4;for(let o=0;o<this._tokens.length;o++){const g=this._tokens[o];if(!(g instanceof Uint32Array))throw new Error("Not supported!");u+=4,u+=g.byteLength}return u}serialize(u,o){(0,y.writeUInt32BE)(u,this._startLineNumber,o),o+=4,(0,y.writeUInt32BE)(u,this._tokens.length,o),o+=4;for(let g=0;g<this._tokens.length;g++){const l=this._tokens[g];if(!(l instanceof Uint32Array))throw new Error("Not supported!");(0,y.writeUInt32BE)(u,l.byteLength,o),o+=4,u.set(new Uint8Array(l.buffer),o),o+=l.byteLength}return o}applyEdit(u,o){const[g,l]=(0,w.countEOL)(o);this._acceptDeleteRange(u),this._acceptInsertText(new k.Position(u.startLineNumber,u.startColumn),g,l)}_acceptDeleteRange(u){if(u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn)return;const o=u.startLineNumber-this._startLineNumber,g=u.endLineNumber-this._startLineNumber;if(g<0){const l=g-o;this._startLineNumber-=l;return}if(!(o>=this._tokens.length)){if(o<0&&g>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(o===g){this._tokens[o]=s.ContiguousTokensEditing.delete(this._tokens[o],u.startColumn-1,u.endColumn-1);return}if(o>=0)if(this._tokens[o]=s.ContiguousTokensEditing.deleteEnding(this._tokens[o],u.startColumn-1),g<this._tokens.length){const l=s.ContiguousTokensEditing.deleteBeginning(this._tokens[g],u.endColumn-1);this._tokens[o]=s.ContiguousTokensEditing.append(this._tokens[o],l),this._tokens.splice(o+1,g-o)}else this._tokens[o]=s.ContiguousTokensEditing.append(this._tokens[o],null),this._tokens=this._tokens.slice(0,o+1);else{const l=-o;this._startLineNumber-=l,this._tokens[g]=s.ContiguousTokensEditing.deleteBeginning(this._tokens[g],u.endColumn-1),this._tokens=this._tokens.slice(g)}}}_acceptInsertText(u,o,g){if(o===0&&g===0)return;const l=u.lineNumber-this._startLineNumber;if(l<0){this._startLineNumber+=o;return}if(!(l>=this._tokens.length)){if(o===0){this._tokens[l]=s.ContiguousTokensEditing.insert(this._tokens[l],u.column-1,g);return}this._tokens[l]=s.ContiguousTokensEditing.deleteEnding(this._tokens[l],u.column-1),this._tokens[l]=s.ContiguousTokensEditing.insert(this._tokens[l],u.column-1,g),this._insertLines(u.lineNumber,o)}}_insertLines(u,o){if(o===0)return;const g=[];for(let l=0;l<o;l++)g[l]=null;this._tokens=C.arrayInsert(this._tokens,u,g)}}e.ContiguousMultilineTokens=t}),define(W[16],j([0,1,12,28]),function(F,e,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(s){let h=0;const t=(0,C.readUInt32BE)(s,h);h+=4;const a=[];for(let u=0;u<t;u++)h=y.ContiguousMultilineTokens.deserialize(s,h,a);return a}constructor(){this._tokens=[]}add(s,h){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(h);return}}this._tokens.push(new y.ContiguousMultilineTokens(s,[h]))}finalize(){return this._tokens}serialize(){const s=this._serializeSize(),h=new Uint8Array(s);return this._serialize(h),h}_serializeSize(){let s=0;s+=4;for(let h=0;h<this._tokens.length;h++)s+=this._tokens[h].serializeSize();return s}_serialize(s){let h=0;(0,C.writeUInt32BE)(s,this._tokens.length,h),h+=4;for(let t=0;t<this._tokens.length;t++)h=this._tokens[t].serialize(s,h)}}e.ContiguousMultilineTokensBuilder=k}),define(W[29],j([0,1,30,3,31,45]),function(F,e,C,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function s(m){return m===47||m===92}e.isPathSeparator=s;function h(m){return m.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=h;function t(m){return m.indexOf("/")===-1&&(m=h(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.toPosixPath=t;function a(m,L=C.posix.sep){if(!m)return"";const M=m.length,B=m.charCodeAt(0);if(s(B)){if(s(m.charCodeAt(1))&&!s(m.charCodeAt(2))){let b=3;const D=b;for(;b<M&&!s(m.charCodeAt(b));b++);if(D!==b&&!s(m.charCodeAt(b+1))){for(b+=1;b<M;b++)if(s(m.charCodeAt(b)))return m.slice(0,b+1).replace(/[\\/]/g,L)}}return L}else if(c(B)&&m.charCodeAt(1)===58)return s(m.charCodeAt(2))?m.slice(0,2)+L:m.slice(0,2);let p=m.indexOf("://");if(p!==-1){for(p+=3;p<M;p++)if(s(m.charCodeAt(p)))return m.slice(0,p+1)}return""}e.getRoot=a;function u(m){if(!y.isWindows||!m||m.length<5)return!1;let L=m.charCodeAt(0);if(L!==92||(L=m.charCodeAt(1),L!==92))return!1;let M=2;const B=M;for(;M<m.length&&(L=m.charCodeAt(M),L!==92);M++);return!(B===M||(L=m.charCodeAt(M+1),isNaN(L)||L===92))}e.isUNC=u;const o=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(m,L=y.isWindows){const M=L?o:g;return!(!m||m.length===0||/^\s+$/.test(m)||(M.lastIndex=0,M.test(m))||L&&l.test(m)||m==="."||m===".."||L&&m[m.length-1]==="."||L&&m.length!==m.trim().length||m.length>255)}e.isValidBasename=n;function i(m,L,M){const B=m===L;return!M||B?B:!m||!L?!1:(0,k.equalsIgnoreCase)(m,L)}e.isEqual=i;function r(m,L,M,B=C.sep){if(m===L)return!0;if(!m||!L||L.length>m.length)return!1;if(M){if(!(0,k.startsWithIgnoreCase)(m,L))return!1;if(L.length===m.length)return!0;let b=L.length;return L.charAt(L.length-1)===B&&b--,m.charAt(b)===B}return L.charAt(L.length-1)!==B&&(L+=B),m.indexOf(L)===0}e.isEqualOrParent=r;function c(m){return m>=65&&m<=90||m>=97&&m<=122}e.isWindowsDriveLetter=c;function _(m,L){return y.isWindows&&m.endsWith(":")&&(m+=C.sep),(0,C.isAbsolute)(m)||(m=(0,C.join)(L,m)),m=(0,C.normalize)(m),y.isWindows?(m=(0,k.rtrim)(m,C.sep),m.endsWith(":")&&(m+=C.sep)):(m=(0,k.rtrim)(m,C.sep),m||(m=C.sep)),m}e.sanitizeFilePath=_;function R(m){const L=(0,C.normalize)(m);return y.isWindows?m.length>3?!1:I(L)&&(m.length===2||L.charCodeAt(2)===92):L===C.posix.sep}e.isRootOrDriveLetter=R;function I(m,L=y.isWindows){return L?c(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function E(m,L=y.isWindows){return I(m,L)?m[0]:void 0}e.getDriveLetter=E;function f(m,L,M){return L.length>m.length?-1:m===L?0:(M&&(m=m.toLowerCase(),L=L.toLowerCase()),m.indexOf(L))}e.indexOfPath=f;function T(m){const L=m.split(":");let M,B,p;for(const b of L){const D=Number(b);(0,w.isNumber)(D)?B===void 0?B=D:p===void 0&&(p=D):M=M?[M,b].join(":"):b}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:B!==void 0?B:void 0,column:p!==void 0?p:B!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(m,L,M=8){let B="";for(let b=0;b<M;b++){let D;b===0&&y.isWindows&&!L&&(M===3||M===4)?D=O:D=v,B+=D.charAt(Math.floor(Math.random()*D.length))}let p;return L?p=`${L}-${B}`:p=B,m?(0,C.join)(m,p):p}e.randomPath=z}),define(W[17],j([0,1,6,3,8]),function(F,e,C,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(w||(e.Schemas=w={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class s{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u){this._remoteResourcesPath=`${u}/${w.vscodeRemoteResource}`}set(u,o,g){this._hosts[u]=o,this._ports[u]=g}setConnectionToken(u,o){this._connectionTokens[u]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)try{return this._delegate(u)}catch(r){return C.onUnexpectedError(r),u}const o=u.authority;let g=this._hosts[o];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const l=this._ports[o],n=this._connectionTokens[o];let i=`path=${encodeURIComponent(u.path)}`;return typeof n=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),k.URI.from({scheme:y.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${g}:${l}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new s,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{static{this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(u){const o=this.toUri(u,F);return this.uriToBrowserUri(o)}uriToBrowserUri(u){return u.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(u):u.scheme===w.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${w.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?u.with({scheme:w.vscodeFileResource,authority:u.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):u}asFileUri(u){const o=this.toUri(u,F);return this.uriToFileUri(o)}uriToFileUri(u){return u.scheme===w.vscodeFileResource?u.with({scheme:w.file,authority:u.authority!==h.FALLBACK_AUTHORITY?u.authority:null,query:null,fragment:null}):u}toUri(u,o){return k.URI.isUri(u)?u:k.URI.parse(o.toUrl(u))}}e.FileAccess=new h;var t;(function(a){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(u.get("3"));const o="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:k.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const r=i?.get(o);if(r)return u.get(r)}a.getHeadersFromQuery=g;function l(n,i,r){if(!globalThis.crossOriginIsolated)return;const c=i&&r?"3":r?"2":"1";n instanceof URLSearchParams?n.set(o,c):n[o]=c}a.addSearchParam=l})(t||(e.COI=t={}))}),define(W[32],j([0,1,21,17,3,8]),function(F,e,C,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class s{constructor(g,l,n){this.id=g,this.dependencies=l,this.callback=n}}class h{static{this.INSTANCE=new h}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,l,n)=>{typeof g!="string"&&(n=l,l=g,g=null),(typeof l!="object"||!Array.isArray(l))&&(n=l,l=null),this._defineCalls.push(new s(g,l,n))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const l=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!l)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}_rendererLoadScript(g){return new Promise((l,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const r=()=>{i.removeEventListener("load",c),i.removeEventListener("error",_)},c=R=>{r(),l(this._defineCalls.pop())},_=R=>{r(),n(R)};i.addEventListener("load",c),i.addEventListener("error",_),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}_workerLoadScript(g){return new Promise((l,n)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),l(this._defineCalls.pop())}catch(i){n(i)}})}async _nodeJSLoadScript(g){try{const l=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,r=w.URI.parse(g).fsPath,c=l.readFileSync(r).toString(),_=i.wrap(c.replace(/^#!.*/,""));return new n.Script(_).runInThisContext().apply(),this._defineCalls.pop()}catch(l){throw l}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function u(o,g,l){if(C.isESM){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[o]&&(o=a[o]);const n=`${o}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const R=`${l&&!k.isWeb?y.nodeModulesAsarPath:y.nodeModulesPath}/${n}`;i=y.FileAccess.asBrowserUri(R).toString(!0)}const r=h.INSTANCE.load(i);return t.set(n,r),r}else return await new Promise((n,i)=>{F([o],n,i)})}e.importAMDNodeModule=u}),define(W[18],j([0,1,29,17,30,3,31,8]),function(F,e,C,y,k,w,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(l){return(0,h.uriToFsPath)(l,!0)}e.originalFSPath=t;class a{constructor(n){this._ignorePathCasing=n}compare(n,i,r=!1){return n===i?0:(0,s.compare)(this.getComparisonKey(n,r),this.getComparisonKey(i,r))}isEqual(n,i,r=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,r)===this.getComparisonKey(i,r)}getComparisonKey(n,i=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,i,r=!1){if(n.scheme===i.scheme){if(n.scheme===y.Schemas.file)return C.isEqualOrParent(t(n),t(i),this._ignorePathCasing(n))&&n.query===i.query&&(r||n.fragment===i.fragment);if((0,e.isEqualAuthority)(n.authority,i.authority))return C.isEqualOrParent(n.path,i.path,this._ignorePathCasing(n),"/")&&n.query===i.query&&(r||n.fragment===i.fragment)}return!1}joinPath(n,...i){return h.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return k.posix.basename(n.path)}extname(n){return k.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===y.Schemas.file?i=h.URI.file(k.dirname(t(n))).path:(i=k.posix.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===y.Schemas.file?i=h.URI.file(k.normalize(t(n))).path:i=k.posix.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.isEqualAuthority)(n.authority,i.authority))return;if(n.scheme===y.Schemas.file){const _=k.relative(t(n),t(i));return w.isWindows?C.toSlashes(_):_}let r=n.path||"/";const c=i.path||"/";if(this._ignorePathCasing(n)){let _=0;for(const R=Math.min(r.length,c.length);_<R&&!(r.charCodeAt(_)!==c.charCodeAt(_)&&r.charAt(_).toLowerCase()!==c.charAt(_).toLowerCase());_++);r=c.substr(0,_)+r.substr(_)}return k.posix.relative(r,c)}resolvePath(n,i){if(n.scheme===y.Schemas.file){const r=h.URI.file(k.resolve(t(n),i));return n.with({authority:r.authority,path:r.path})}return i=C.toPosixPath(i),n.with({path:k.posix.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.equalsIgnoreCase)(n,i)}hasTrailingPathSeparator(n,i=k.sep){if(n.scheme===y.Schemas.file){const r=t(n);return r.length>C.getRoot(r).length&&r[r.length-1]===i}else{const r=n.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=k.sep){return(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=k.sep){let r=!1;if(n.scheme===y.Schemas.file){const c=t(n);r=c!==void 0&&c.length===C.getRoot(c).length&&c[c.length-1]===i}else{i="/";const c=n.path;r=c.length===1&&c.charCodeAt(c.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path+"/"}):n}}e.ExtUri=a,e.extUri=new a(()=>!1),e.extUriBiasedIgnorePathCase=new a(l=>l.scheme===y.Schemas.file?!w.isLinux:!0),e.extUriIgnorePathCase=new a(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function u(l,n){const i=[];for(let r=0;r<l.length;r++){const c=n(l[r]);l.some((_,R)=>R===r?!1:(0,e.isEqualOrParent)(c,n(_)))||i.push(l[r])}return i}e.distinctParents=u;var o;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function n(i){const r=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(R=>{const[I,E]=R.split(":");I&&E&&r.set(I,E)});const _=i.path.substring(0,i.path.indexOf(";"));return _&&r.set(l.META_DATA_MIME,_),r}l.parseMetaData=n})(o||(e.DataUri=o={}));function g(l,n,i){if(n){let r=l.path;return r&&r[0]!==k.posix.sep&&(r=k.posix.sep+r),l.with({scheme:i,authority:n,path:r})}return l.with({scheme:i})}e.toLocalResource=g}),define(W[19],j([0,1,46,6,33,2,18,3,24]),function(F,e,C,y,k,w,s,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function a(N){return!!N&&typeof N.then=="function"}e.isThenable=a;function u(N){const d=new C.CancellationTokenSource,S=N(d.token),P=new Promise((A,U)=>{const Q=d.token.onCancellationRequested(()=>{Q.dispose(),d.dispose(),U(new y.CancellationError)});Promise.resolve(S).then(Z=>{Q.dispose(),d.dispose(),A(Z)},Z=>{Q.dispose(),d.dispose(),U(Z)})});return new class{cancel(){d.cancel()}then(A,U){return P.then(A,U)}catch(A){return this.then(void 0,A)}finally(A){return P.finally(A)}}}e.createCancelablePromise=u;function o(N,d,S){return new Promise((P,A)=>{const U=d.onCancellationRequested(()=>{U.dispose(),P(S)});N.then(P,A).finally(()=>U.dispose())})}e.raceCancellation=o;function g(N,d){return new Promise((S,P)=>{const A=d.onCancellationRequested(()=>{A.dispose(),P(new y.CancellationError)});N.then(S,P).finally(()=>A.dispose())})}e.raceCancellationError=g;async function l(N){let d=-1;const S=N.map((P,A)=>P.then(U=>(d=A,U)));try{return await Promise.race(S)}finally{N.forEach((P,A)=>{A!==d&&P.cancel()})}}e.raceCancellablePromises=l;function n(N,d,S){let P;const A=setTimeout(()=>{P?.(void 0),S?.()},d);return Promise.race([N.finally(()=>clearTimeout(A)),new Promise(U=>P=U)])}e.raceTimeout=n;function i(N){return new Promise((d,S)=>{const P=N();a(P)?P.then(d,S):d(P)})}e.asPromise=i;class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(d){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=d,!this.queuedPromise){const S=()=>{if(this.queuedPromise=null,this.isDisposed)return;const P=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,P};this.queuedPromise=new Promise(P=>{this.activePromise.then(S,S).then(P)})}return new Promise((S,P)=>{this.queuedPromise.then(S,P)})}return this.activePromise=d(),new Promise((S,P)=>{this.activePromise.then(A=>{this.activePromise=null,S(A)},A=>{this.activePromise=null,P(A)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class c{constructor(){this.current=Promise.resolve(null)}queue(d){return this.current=this.current.then(()=>d(),()=>d())}}e.Sequencer=c;class _{constructor(){this.promiseMap=new Map}queue(d,S){const A=(this.promiseMap.get(d)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.promiseMap.get(d)===A&&this.promiseMap.delete(d)});return this.promiseMap.set(d,A),A}}e.SequencerByKey=_;const R=(N,d)=>{let S=!0;const P=setTimeout(()=>{S=!1,d()},N);return{isTriggered:()=>S,dispose:()=>{clearTimeout(P),S=!1}}},I=N=>{let d=!0;return queueMicrotask(()=>{d&&(d=!1,N())}),{isTriggered:()=>d,dispose:()=>{d=!1}}};class E{constructor(d){this.defaultDelay=d,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(d,S=this.defaultDelay){this.task=d,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,U)=>{this.doResolve=A,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}}));const P=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=S===t.MicrotaskDelay?I(P):R(S,P),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class f{constructor(d){this.delayer=new E(d),this.throttler=new r}trigger(d,S){return this.delayer.trigger(()=>this.throttler.queue(d),S)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=f;class T{constructor(){this._isOpen=!1,this._promise=new Promise((d,S)=>{this._completePromise=d})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=T;class v extends T{constructor(d){super(),this._timeout=setTimeout(()=>this.open(),d)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function O(N,d){return d?new Promise((S,P)=>{const A=setTimeout(()=>{U.dispose(),S()},N),U=d.onCancellationRequested(()=>{clearTimeout(A),U.dispose(),P(new y.CancellationError)})}):u(S=>O(N,S))}e.timeout=O;function z(N,d=0,S){const P=setTimeout(()=>{N(),S&&A.dispose()},d),A=(0,w.toDisposable)(()=>{clearTimeout(P),S?.deleteAndLeak(A)});return S?.add(A),A}e.disposableTimeout=z;function m(N){const d=[];let S=0;const P=N.length;function A(){return S<P?N[S++]():null}function U(Q){Q!=null&&d.push(Q);const Z=A();return Z?Z.then(U):Promise.resolve(d)}return Promise.resolve(null).then(U)}e.sequence=m;function L(N,d=P=>!!P,S=null){let P=0;const A=N.length,U=()=>{if(P>=A)return Promise.resolve(S);const Q=N[P++];return Promise.resolve(Q()).then(X=>d(X)?Promise.resolve(X):U())};return U()}e.first=L;function M(N,d=P=>!!P,S=null){if(N.length===0)return Promise.resolve(S);let P=N.length;const A=()=>{P=-1;for(const U of N)U.cancel?.()};return new Promise((U,Q)=>{for(const Z of N)Z.then(X=>{--P>=0&&d(X)?(A(),U(X)):P===0&&U(S)}).catch(X=>{--P>=0&&(A(),Q(X))})})}e.firstParallel=M;class B{constructor(d){this._size=0,this.maxDegreeOfParalellism=d,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(d){return this._size++,new Promise((S,P)=>{this.outstandingPromises.push({factory:d,c:S,e:P}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const d=this.outstandingPromises.shift();this.runningPromises++;const S=d.factory();S.then(d.c,d.e),S.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=B;class p extends B{constructor(){super(1)}}e.Queue=p;class b{constructor(){this.sequentializer=new x,this.tasks=0}queue(d){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,d())):this.sequentializer.run(this.tasks++,d())}}e.LimitedQueue=b;class D{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const d=new te;return this.drainers.add(d),d.p}isDrained(){for(const[,d]of this.queues)if(d.size>0)return!1;return!0}queueFor(d,S=s.extUri){const P=S.getComparisonKey(d);let A=this.queues.get(P);if(!A){A=new p;const U=this.drainListenerCount++,Q=k.Event.once(A.onDrained)(()=>{A?.dispose(),this.queues.delete(P),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(U),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new w.DisposableMap),this.drainListeners.set(U,Q),this.queues.set(P,A)}return A}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const d of this.drainers)d.complete();this.drainers.clear()}dispose(){for(const[,d]of this.queues)d.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=D;class V{constructor(d,S){this._token=-1,typeof d=="function"&&typeof S=="number"&&this.setIfNotSet(d,S)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(d,S){this.cancel(),this._token=setTimeout(()=>{this._token=-1,d()},S)}setIfNotSet(d,S){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,d()},S))}}e.TimeoutTimer=V;class K{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(d,S){this.cancel(),this._token=setInterval(()=>{d()},S)}}e.IntervalTimer=K;class ${constructor(d,S){this.timeoutToken=-1,this.runner=d,this.timeout=S,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(d=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,d)}get delay(){return this.timeout}set delay(d){this.timeout=d}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class G{constructor(d,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.runner=d,this.timeout=S,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(d=this.timeout){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(d/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class q extends ${constructor(d,S){super(d,S),this.units=[]}work(d){this.units.push(d),this.isScheduled()||this.schedule()}doRun(){const d=this.units;this.units=[],this.runner?.(d)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class H extends w.Disposable{constructor(d,S){super(),this.options=d,this.handler=S,this.pendingWork=[],this.throttler=this._register(new w.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(d){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+d.length>this.options.maxBufferedWork)return!1}else if(this.pending+d.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const S of d)this.pendingWork.push(S);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,h.setTimeout0)(()=>{if(d)return;const S=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let d=!1;return{dispose(){d||(d=!0)}}}:e.runWhenIdle=(N,d)=>{const S=requestIdleCallback(N,typeof d=="number"?{timeout:d}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(S))}}}}();class J{constructor(d){this._didRun=!1,this._executor=()=>{try{this._value=d()}catch(S){this._error=S}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=J;async function se(N,d,S){let P;for(let A=0;A<S;A++)try{return await N()}catch(U){P=U,await O(d)}throw P}e.retry=se;class x{isRunning(d){return typeof d=="number"?this._running?.taskId===d:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(d,S,P){return this._running={taskId:d,cancel:()=>P?.(),promise:S},S.then(()=>this.doneRunning(d),()=>this.doneRunning(d)),S}doneRunning(d){this._running&&d===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const d=this._queued;this._queued=void 0,d.run().then(d.promiseResolve,d.promiseReject)}}queue(d){if(this._queued)this._queued.run=d;else{let S,P;const A=new Promise((U,Q)=>{S=U,P=Q});this._queued={run:d,promise:A,promiseResolve:S,promiseReject:P}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=x;class ae{constructor(d,S=()=>Date.now()){this.interval=d,this.nowFn=S,this.lastIncrementTime=0,this.value=0}increment(){const d=this.nowFn();return d-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=d,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var ee;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((d,S)=>{this.completeCallback=d,this.errorCallback=S})}complete(d){return new Promise(S=>{this.completeCallback(d),this.outcome={outcome:0,value:d},S()})}error(d){return new Promise(S=>{this.errorCallback(d),this.outcome={outcome:1,value:d},S()})}cancel(){return this.error(new y.CancellationError)}}e.DeferredPromise=te;var ne;(function(N){async function d(P){let A;const U=await Promise.all(P.map(Q=>Q.then(Z=>Z,Z=>{A||(A=Z)})));if(typeof A<"u")throw A;return U}N.settled=d;function S(P){return new Promise(async(A,U)=>{try{await P(A,U)}catch(Q){U(Q)}})}N.withAsyncBody=S})(ne||(e.Promises=ne={}));var ie;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(d){return new Y(S=>{S.emitMany(d)})}static fromPromise(d){return new Y(async S=>{S.emitMany(await d)})}static fromPromises(d){return new Y(async S=>{await Promise.all(d.map(async P=>S.emitOne(await P)))})}static merge(d){return new Y(async S=>{await Promise.all(d.map(async P=>{for await(const A of P)S.emitOne(A)}))})}static{this.EMPTY=Y.fromArray([])}constructor(d){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const S={emitOne:P=>this.emitOne(P),emitMany:P=>this.emitMany(P),reject:P=>this.reject(P)};try{await Promise.resolve(d(S)),this.resolve()}catch(P){this.reject(P)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let d=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(d<this._results.length)return{done:!1,value:this._results[d++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(d,S){return new Y(async P=>{for await(const A of d)P.emitOne(S(A))})}map(d){return Y.map(this,d)}static filter(d,S){return new Y(async P=>{for await(const A of d)S(A)&&P.emitOne(A)})}filter(d){return Y.filter(this,d)}static coalesce(d){return Y.filter(d,S=>!!S)}coalesce(){return Y.coalesce(this)}static async toPromise(d){const S=[];for await(const P of d)S.push(P);return S}toPromise(){return Y.toPromise(this)}emitOne(d){this._state===0&&(this._results.push(d),this._onStateChanged.fire())}emitMany(d){this._state===0&&(this._results=this._results.concat(d),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(d){this._state===0&&(this._state=2,this._error=d,this._onStateChanged.fire())}}e.AsyncIterableObject=Y;class re extends Y{constructor(d,S){super(S),this._source=d}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function oe(N){const d=new C.CancellationTokenSource,S=N(d.token);return new re(d,async P=>{const A=d.token.onCancellationRequested(()=>{A.dispose(),d.dispose(),P.reject(new y.CancellationError)});try{for await(const U of S){if(d.token.isCancellationRequested)return;P.emitOne(U)}A.dispose(),d.dispose()}catch(U){A.dispose(),d.dispose(),P.reject(U)}})}e.createCancelableAsyncIterable=oe}),define(W[20],j([0,1,34]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(w){return this===w}};function y(w,s){return new C.TokenizationResult([new C.Token(0,"",w)],s)}e.nullTokenize=y;function k(w,s){const h=new Uint32Array(2);return h[0]=0,h[1]=(w<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new C.EncodedTokenizationResult(h,s===null?e.NullState:s)}e.nullTokenizeEncoded=k}),define(W[35],j([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(F,e,C,y,k,w,s,h,t,a,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var l;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(l||(l={}));class n{constructor(f,T){this.tokenizationSupport=T,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new r(f)}getStartState(f){return this.store.getStartState(f,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=n;class i extends n{constructor(f,T,v,O){super(f,T),this._textModel=v,this._languageIdCodec=O}updateTokensUntilLine(f,T){const v=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>T)break;const z=this._textModel.getLineContent(O.lineNumber),m=R(this._languageIdCodec,v,this.tokenizationSupport,z,!0,O.startState);f.add(O.lineNumber,m.tokens),this.store.setEndState(O.lineNumber,m.endState)}}getTokenTypeIfInsertingCharacter(f,T){const v=this.getStartState(f.lineNumber);if(!v)return 0;const O=this._textModel.getLanguageId(),z=this._textModel.getLineContent(f.lineNumber),m=z.substring(0,f.column-1)+T+z.substring(f.column-1),L=R(this._languageIdCodec,O,this.tokenizationSupport,m,!0,v),M=new g.LineTokens(L.tokens,m,this._languageIdCodec);if(M.getCount()===0)return 0;const B=M.findTokenIndexAtOffset(f.column-1);return M.getStandardTokenType(B)}tokenizeLineWithEdit(f,T,v){const O=f.lineNumber,z=f.column,m=this.getStartState(O);if(!m)return null;const L=this._textModel.getLineContent(O),M=L.substring(0,z-1)+v+L.substring(z-1+T),B=this._textModel.getLanguageIdAtPosition(O,0),p=R(this._languageIdCodec,B,this.tokenizationSupport,M,!0,m);return new g.LineTokens(p.tokens,M,this._languageIdCodec)}isCheapToTokenize(f){const T=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<T||f===T&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,T,v){if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(T<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,v),{heuristicTokens:!1};let O=this.guessStartState(T);const z=this._textModel.getLanguageId();for(let m=T;m<=v;m++){const L=this._textModel.getLineContent(m),M=R(this._languageIdCodec,z,this.tokenizationSupport,L,!0,O);f.add(m,M.tokens),O=M.endState}return{heuristicTokens:!0}}guessStartState(f){let T=this._textModel.getLineFirstNonWhitespaceColumn(f);const v=[];let O=null;for(let L=f-1;T>1&&L>=1;L--){const M=this._textModel.getLineFirstNonWhitespaceColumn(L);if(M!==0&&M<T&&(v.push(this._textModel.getLineContent(L)),T=M,O=this.getStartState(L),O))break}O||(O=this.tokenizationSupport.getInitialState()),v.reverse();const z=this._textModel.getLanguageId();let m=O;for(const L of v)m=R(this._languageIdCodec,z,this.tokenizationSupport,L,!1,m).endState;return m}}e.TokenizerWithStateStoreAndTextModel=i;class r{constructor(f){this.lineCount=f,this._tokenizationStateStore=new c,this._invalidEndStatesLineNumbers=new _,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this._tokenizationStateStore.getEndState(f)}setEndState(f,T){if(!T)throw new y.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(f);const v=this._tokenizationStateStore.setEndState(f,T);return v&&f<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f+1,f+2)),v}acceptChange(f,T){this.lineCount+=T-f.length,this._tokenizationStateStore.acceptChange(f,T),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),T)}acceptChanges(f){for(const T of f){const[v]=(0,s.countEOL)(T.text);this.acceptChange(new h.LineRange(T.range.startLineNumber,T.range.endLineNumber+1),v+1)}}invalidateEndStateRange(f){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(f,T){return f===1?T:this.getEndState(f-1)}getFirstInvalidLine(f){const T=this.getFirstInvalidEndStateLineNumber();if(T===null)return null;const v=this.getStartState(T,f);if(!v)throw new y.BugIndicatingError("Start state must be defined");return{lineNumber:T,startState:v}}}e.TrackingTokenizationStateStore=r;class c{constructor(){this._lineEndStates=new u.FixedArray(null)}getEndState(f){return this._lineEndStates.get(f)}setEndState(f,T){const v=this._lineEndStates.get(f);return v&&v.equals(T)?!1:(this._lineEndStates.set(f,T),!0)}acceptChange(f,T){let v=f.length;T>0&&v>0&&(v--,T--),this._lineEndStates.replace(f.startLineNumber,v,T)}acceptChanges(f){for(const T of f){const[v]=(0,s.countEOL)(T.text);this.acceptChange(new h.LineRange(T.range.startLineNumber,T.range.endLineNumber+1),v+1)}}}e.TokenizationStateStore=c;class _{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const f=this._ranges[0];return f.start+1===f.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}delete(f){const T=this._ranges.findIndex(v=>v.contains(f));if(T!==-1){const v=this._ranges[T];v.start===f?v.endExclusive===f+1?this._ranges.splice(T,1):this._ranges[T]=new t.OffsetRange(f+1,v.endExclusive):v.endExclusive===f+1?this._ranges[T]=new t.OffsetRange(v.start,f):this._ranges.splice(T,1,new t.OffsetRange(v.start,f),new t.OffsetRange(f+1,v.endExclusive))}}addRange(f){t.OffsetRange.addRange(f,this._ranges)}addRangeAndResize(f,T){let v=0;for(;!(v>=this._ranges.length||f.start<=this._ranges[v].endExclusive);)v++;let O=v;for(;!(O>=this._ranges.length||f.endExclusive<this._ranges[O].start);)O++;const z=T-f.length;for(let m=O;m<this._ranges.length;m++)this._ranges[m]=this._ranges[m].delta(z);if(v===O){const m=new t.OffsetRange(f.start,f.start+T);m.isEmpty||this._ranges.splice(v,0,m)}else{const m=Math.min(f.start,this._ranges[v].start),L=Math.max(f.endExclusive,this._ranges[O-1].endExclusive),M=new t.OffsetRange(m,L+z);M.isEmpty?this._ranges.splice(v,O-v):this._ranges.splice(v,O-v,M)}}toString(){return this._ranges.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=_;function R(E,f,T,v,O,z){let m=null;if(T)try{m=T.tokenizeEncoded(v,O,z.clone())}catch(L){(0,y.onUnexpectedError)(L)}return m||(m=(0,a.nullTokenizeEncoded)(E.encodeLanguageId(f),z)),g.LineTokens.convertToEndOffset(m.tokens,v.length),m}class I{constructor(f,T){this._tokenizerWithStateStore=f,this._backgroundTokenStore=T,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,C.runWhenIdle)(f=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(f)}))}_backgroundTokenizeWithDeadline(f){const T=Date.now()+f.timeRemaining(),v=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<T?(0,k.setTimeout0)(v):this._beginBackgroundTokenization())};v()}_backgroundTokenizeForAtLeast1ms(){const f=this._tokenizerWithStateStore._textModel.getLineCount(),T=new o.ContiguousMultilineTokensBuilder,v=w.StopWatch.create(!1);do if(v.elapsed()>1||this._tokenizeOneInvalidLine(T)>=f)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(T.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(f){const T=this._tokenizerWithStateStore?.getFirstInvalidLine();return T?(this._tokenizerWithStateStore.updateTokensUntilLine(f,T.lineNumber),T.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(f,T){this._tokenizerWithStateStore.store.invalidateEndStateRange(new h.LineRange(f,T))}}e.DefaultBackgroundTokenizer=I}),define(W[37],j([0,1,33,2,36,14,34]),function(F,e,C,y,k,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class h extends y.Disposable{constructor(a,u,o,g,l,n,i){super(),this._grammar=a,this._initialState=u,this._containsEmbeddedLanguages=o,this._createBackgroundTokenizer=g,this._backgroundTokenizerShouldOnlyVerifyTokens=l,this._reportTokenizationTime=n,this._reportSlowTokenization=i,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new C.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(a,u,o){throw new Error("Not supported!")}createBackgroundTokenizer(a,u){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(a,u)}tokenizeEncoded(a,u,o){const g=Math.random()*1e4<1,l=this._reportSlowTokenization||g,n=l?new k.StopWatch(!0):void 0,i=this._grammar.tokenizeLine2(a,o,500);if(l){const c=n.elapsed();(g||c>32)&&this._reportTokenizationTime(c,a.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new s.EncodedTokenizationResult(i.tokens,o);if(this._containsEmbeddedLanguages){const c=this._seenLanguages,_=i.tokens;for(let R=0,I=_.length>>>1;R<I;R++){const E=_[(R<<1)+1],f=w.TokenMetadata.getLanguageId(E);c[f]||(c[f]=!0,this._onDidEncounterLanguage.fire(f))}}let r;return o.equals(i.ruleStack)?r=o:r=i.ruleStack,new s.EncodedTokenizationResult(i.tokens,r)}}e.TextMateTokenizationSupport=h}),define(W[38],j([0,1,20,2,11]),function(F,e,C,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class w extends y.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,t,a){super(),this._encodedLanguageId=h,this._actual=t,this._maxTokenizationLineLength=a,this._register((0,k.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(h,t,a){throw new Error("Not supported!")}tokenizeEncoded(h,t,a){return h.length>=this._maxTokenizationLineLength.get()?(0,C.nullTokenizeEncoded)(this._encodedLanguageId,a):this._actual.tokenizeEncoded(h,t,a)}createBackgroundTokenizer(h,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=w}),define(W[39],j([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(F,e,C,y,k,w,s,h,t,a,u,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class l extends h.MirrorTextModel{constructor(r,c,_,R,I,E,f,T){super(r,c,_,R),this._host=I,this._languageId=E,this._encodedLanguageId=f,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,k.observableValue)(this,-1),this._tokenizeDebouncer=new y.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(T,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(r,c){this._languageId=r,this._encodedLanguageId=c,this._resetTokenization()}onEvents(r){super.onEvents(r),this._tokenizerWithStateStore?.store.acceptChanges(r.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(r){this._maxTokenizationLineLength.set(r,void 0)}retokenize(r,c){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new s.LineRange(r,c)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const r=this._languageId,c=this._encodedLanguageId,_=await this._host.getOrCreateGrammar(r,c);if(!(this._isDisposed||r!==this._languageId||c!==this._encodedLanguageId||!_)){if(_.grammar){const R=new g.TokenizationSupportWithLineLimit(this._encodedLanguageId,new o.TextMateTokenizationSupport(_.grammar,_.initialState,!1,void 0,()=>!1,(I,E,f)=>{this._host.reportTokenizationTime(I,r,_.sourceExtensionId,E,f)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,R)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:c}=await(0,C.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=c}const r=new Date().getTime();for(;;){let c=0;const _=new a.ContiguousMultilineTokensBuilder,R=new n;for(;;){const f=this._tokenizerWithStateStore.getFirstInvalidLine();if(f===null||c>200)break;c++;const T=this._lines[f.lineNumber-1],v=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(T,!0,f.startState);if(this._tokenizerWithStateStore.store.setEndState(f.lineNumber,v.endState)){const z=this._diffStateStacksRefEqFn(f.startState,v.endState);R.setState(f.lineNumber,z)}else R.setState(f.lineNumber,null);if(u.LineTokens.convertToEndOffset(v.tokens,T.length),_.add(f.lineNumber,v.tokens),new Date().getTime()-r>20)break}if(c===0)break;const I=R.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,_.serialize(),I),new Date().getTime()-r>20){(0,w.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=l;class n{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(r,c){r===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(c):this._stateDeltas.push({startLineNumber:r,stateDeltas:[c]}),this._lastStartLineNumber=r}getStateDeltas(){return this._stateDeltas}}}),define(W[40],j([0,1,18]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class y{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(w){if(this._scopeNameToLanguageRegistration[w.scopeName]){const s=this._scopeNameToLanguageRegistration[w.scopeName];C.isEqual(s.location,w.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${w.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${w.location.toString()}`)}this._scopeNameToLanguageRegistration[w.scopeName]=w}getGrammarDefinition(w){return this._scopeNameToLanguageRegistration[w]||null}}e.TMScopeRegistry=y}),define(W[41],j([0,1,2,40]),function(F,e,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends C.Disposable{constructor(s,h,t,a){super(),this._host=s,this._initialState=t.INITIAL,this._scopeRegistry=new y.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:a,loadGrammar:async u=>{const o=this._scopeRegistry.getGrammarDefinition(u);if(!o)return this._host.logTrace(`No grammar found for scope ${u}`),null;const g=o.location;try{const l=await this._host.readFile(g);return t.parseRawGrammar(l,g.path)}catch(l){return this._host.logError(`Unable to load and parse grammar for scope ${u} from ${g}`,l),null}},getInjections:u=>{const o=u.split(".");let g=[];for(let l=1;l<=o.length;l++){const n=o.slice(0,l).join(".");g=[...g,...this._injections[n]||[]]}return g}}));for(const u of h){if(this._scopeRegistry.register(u),u.injectTo){for(const o of u.injectTo){let g=this._injections[o];g||(this._injections[o]=g=[]),g.push(u.scopeName)}if(u.embeddedLanguages)for(const o of u.injectTo){let g=this._injectedEmbeddedLanguages[o];g||(this._injectedEmbeddedLanguages[o]=g=[]),g.push(u.embeddedLanguages)}}u.language&&this._languageToScope.set(u.language,u.scopeName)}}has(s){return this._languageToScope.has(s)}setTheme(s,h){this._grammarRegistry.setTheme(s,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(s,h){const t=this._languageToScope.get(s);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const a=this._scopeRegistry.getGrammarDefinition(t);if(!a)throw new Error(e.missingTMGrammarErrorMessage);const u=a.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const l=this._injectedEmbeddedLanguages[t];for(const n of l)for(const i of Object.keys(n))u[i]=n[i]}const o=Object.keys(u).length>0;let g;try{g=await this._grammarRegistry.loadGrammarWithConfiguration(t,h,{embeddedLanguages:u,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(l){throw l.message&&l.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):l}return{languageId:s,grammar:g,initialState:this._initialState,containsEmbeddedLanguages:o,sourceExtensionId:a.sourceExtensionId}}}e.TMGrammarFactory=k}),define(W[49],j([0,1,8,41,39]),function(F,e,C,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function w(h,t){return new s(h,t)}e.create=w;class s{constructor(t,a){this._createData=a,this._models=new Map,this._grammarCache=[],this._host=t.host;const u=a.grammarDefinitions.map(o=>({location:C.URI.revive(o.location),language:o.language,scopeName:o.scopeName,embeddedLanguages:o.embeddedLanguages,tokenTypes:o.tokenTypes,injectTo:o.injectTo,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors,sourceExtensionId:o.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(u)}async _loadTMGrammarFactory(t){const a=this._createData.textmateMainUri,u=await new Promise((i,r)=>{F([a],i,r)}),o=await new Promise((i,r)=>{F([this._createData.onigurumaMainUri],i,r)}),l=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await o.loadWASM(l);const n=Promise.resolve({createOnigScanner:i=>o.createOnigScanner(i),createOnigString:i=>o.createOnigString(i)});return new y.TMGrammarFactory({logTrace:i=>{},logError:(i,r)=>console.error(i,r),readFile:i=>this._host.readFile(i)},t,u,n)}acceptNewModel(t){const a=C.URI.revive(t.uri),u=this;this._models.set(t.controllerId,new k.TextMateWorkerTokenizer(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(o,g){const l=await u._grammarFactory;return l?(u._grammarCache[g]||(u._grammarCache[g]=l.createGrammar(o,g)),u._grammarCache[g]):Promise.resolve(null)},setTokensAndStates(o,g,l){u._host.setTokensAndStates(t.controllerId,o,g,l)},reportTokenizationTime(o,g,l,n,i){u._host.reportTokenizationTime(o,g,l,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this._models.get(t).onEvents(a)}retokenize(t,a,u){this._models.get(t).retokenize(a,u)}acceptModelLanguageChanged(t,a,u){this._models.get(t).onLanguageId(a,u)}acceptRemovedModel(t){const a=this._models.get(t);a&&(a.dispose(),this._models.delete(t))}async acceptTheme(t,a){(await this._grammarFactory)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this._models.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/36d13de33ac0d6c684f10f99cff352e2f58228b3/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
